/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/objects","vs/editor/common/core/lineRange","vs/base/common/platform","vs/base/common/uri","vs/base/common/arrays","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ne=function(H){for(var t=[],P=0,k=H.length;P<k;P++)t[P]=K[H[P]];return t};const Ve=this,je=typeof global=="object"?global:{};var $e;(function(H){H.global=Ve;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof H.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}H.Environment=t})($e||($e={}));var $e;(function(H){class t{constructor(a,$,o){this.type=a,this.detail=$,this.timestamp=o}}H.LoaderEvent=t;class P{constructor(a){this._events=[new t(1,"",a)]}record(a,$){this._events.push(new t(a,$,H.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}H.LoaderEventRecorder=P;class k{record(a,$){}getEvents(){return[]}}k.INSTANCE=new k,H.NullLoaderEventRecorder=k})($e||($e={}));var $e;(function(H){class t{static fileUriToFilePath(k,i){if(i=decodeURI(i).replace(/%23/g,"#"),k){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(k,i){return k.length>=i.length&&k.substr(0,i.length)===i}static endsWith(k,i){return k.length>=i.length&&k.substr(k.length-i.length)===i}static containsQueryString(k){return/^[^\#]*\?/gi.test(k)}static isAbsolutePath(k){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(k)}static forEachProperty(k,i){if(k){let a;for(a in k)k.hasOwnProperty(a)&&i(a,k[a])}}static isEmpty(k){let i=!0;return t.forEachProperty(k,()=>{i=!1}),i}static recursiveClone(k){if(!k||typeof k!="object"||k instanceof RegExp||!Array.isArray(k)&&Object.getPrototypeOf(k)!==Object.prototype)return k;let i=Array.isArray(k)?[]:{};return t.forEachProperty(k,(a,$)=>{$&&typeof $=="object"?i[a]=t.recursiveClone($):i[a]=$}),i}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(k){return t.startsWith(k,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=H.global.performance&&typeof H.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?H.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,H.Utilities=t})($e||($e={}));var $e;(function(H){function t(i){if(i instanceof Error)return i;const a=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(a.stack=i.stack),a}H.ensureError=t;class P{static validateConfigurationOptions(a){function $(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory function of "'+o.moduleId+'" has thrown an exception'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}}if(a=a||{},typeof a.baseUrl!="string"&&(a.baseUrl=""),typeof a.isBuild!="boolean"&&(a.isBuild=!1),typeof a.paths!="object"&&(a.paths={}),typeof a.config!="object"&&(a.config={}),typeof a.catchError>"u"&&(a.catchError=!1),typeof a.recordStats>"u"&&(a.recordStats=!1),typeof a.urlArgs!="string"&&(a.urlArgs=""),typeof a.onError!="function"&&(a.onError=$),Array.isArray(a.ignoreDuplicateModules)||(a.ignoreDuplicateModules=[]),a.baseUrl.length>0&&(H.Utilities.endsWith(a.baseUrl,"/")||(a.baseUrl+="/")),typeof a.cspNonce!="string"&&(a.cspNonce=""),typeof a.preferScriptTags>"u"&&(a.preferScriptTags=!1),a.nodeCachedData&&typeof a.nodeCachedData=="object"&&(typeof a.nodeCachedData.seed!="string"&&(a.nodeCachedData.seed="seed"),(typeof a.nodeCachedData.writeDelay!="number"||a.nodeCachedData.writeDelay<0)&&(a.nodeCachedData.writeDelay=1e3*7),!a.nodeCachedData.path||typeof a.nodeCachedData.path!="string")){const o=t(new Error("INVALID cached data configuration, 'path' MUST be set"));o.phase="configuration",a.onError(o),a.nodeCachedData=void 0}return a}static mergeConfigurationOptions(a=null,$=null){let o=H.Utilities.recursiveClone($||{});return H.Utilities.forEachProperty(a,(s,u)=>{s==="ignoreDuplicateModules"&&typeof o.ignoreDuplicateModules<"u"?o.ignoreDuplicateModules=o.ignoreDuplicateModules.concat(u):s==="paths"&&typeof o.paths<"u"?H.Utilities.forEachProperty(u,(g,E)=>o.paths[g]=E):s==="config"&&typeof o.config<"u"?H.Utilities.forEachProperty(u,(g,E)=>o.config[g]=E):o[s]=H.Utilities.recursiveClone(u)}),P.validateConfigurationOptions(o)}}H.ConfigurationOptionsUtil=P;class k{constructor(a,$){if(this._env=a,this.options=P.mergeConfigurationOptions($),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let o=this.options.nodeRequire.main.filename,s=Math.max(o.lastIndexOf("/"),o.lastIndexOf("\\"));this.options.baseUrl=o.substring(0,s+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let a=0;a<this.options.ignoreDuplicateModules.length;a++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[a]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],H.Utilities.forEachProperty(this.options.paths,(a,$)=>{Array.isArray($)?this.sortedPathsRules.push({from:a,to:$}):this.sortedPathsRules.push({from:a,to:[$]})}),this.sortedPathsRules.sort((a,$)=>$.from.length-a.from.length)}cloneAndMerge(a){return new k(this._env,P.mergeConfigurationOptions(a,this.options))}getOptionsLiteral(){return this.options}_applyPaths(a){let $;for(let o=0,s=this.sortedPathsRules.length;o<s;o++)if($=this.sortedPathsRules[o],H.Utilities.startsWith(a,$.from)){let u=[];for(let g=0,E=$.to.length;g<E;g++)u.push($.to[g]+a.substr($.from.length));return u}return[a]}_addUrlArgsToUrl(a){return H.Utilities.containsQueryString(a)?a+"&"+this.options.urlArgs:a+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(a){return this.options.urlArgs?this._addUrlArgsToUrl(a):a}_addUrlArgsIfNecessaryToUrls(a){if(this.options.urlArgs)for(let $=0,o=a.length;$<o;$++)a[$]=this._addUrlArgsToUrl(a[$]);return a}moduleIdToPaths(a){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(a))return this.isBuild()?["empty:"]:["node|"+a];let $=a,o;if(!H.Utilities.endsWith($,".js")&&!H.Utilities.isAbsolutePath($)){o=this._applyPaths($);for(let s=0,u=o.length;s<u;s++)this.isBuild()&&o[s]==="empty:"||(H.Utilities.isAbsolutePath(o[s])||(o[s]=this.options.baseUrl+o[s]),!H.Utilities.endsWith(o[s],".js")&&!H.Utilities.containsQueryString(o[s])&&(o[s]=o[s]+".js"))}else!H.Utilities.endsWith($,".js")&&!H.Utilities.containsQueryString($)&&($=$+".js"),o=[$];return this._addUrlArgsIfNecessaryToUrls(o)}requireToUrl(a){let $=a;return H.Utilities.isAbsolutePath($)||($=this._applyPaths($)[0],H.Utilities.isAbsolutePath($)||($=this.options.baseUrl+$)),this._addUrlArgsIfNecessaryToUrl($)}isBuild(){return this.options.isBuild}shouldInvokeFactory(a){return!!(!this.options.isBuild||H.Utilities.isAnonymousModule(a)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[a])}isDuplicateMessageIgnoredFor(a){return this.ignoreDuplicateModulesMap.hasOwnProperty(a)}getConfigForModule(a){if(this.options.config)return this.options.config[a]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(a){this.options.onError(a)}}H.Configuration=k})($e||($e={}));var $e;(function(H){class t{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,g,E,h){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new P:this._scriptLoader=new a(this._env)}else this._env.isNode?this._scriptLoader=new a(this._env):this._scriptLoader=new P;let c={callback:E,errorback:h};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push(c);return}this._callbackMap[g]=[c],this._scriptLoader.load(u,g,()=>this.triggerCallback(g),e=>this.triggerErrorback(g,e))}triggerCallback(u){let g=this._callbackMap[u];delete this._callbackMap[u];for(let E=0;E<g.length;E++)g[E].callback()}triggerErrorback(u,g){let E=this._callbackMap[u];delete this._callbackMap[u];for(let h=0;h<E.length;h++)E[h].errorback(g)}}class P{attachListeners(u,g,E){let h=()=>{u.removeEventListener("load",c),u.removeEventListener("error",e)},c=A=>{h(),g()},e=A=>{h(),E(A)};u.addEventListener("load",c),u.addEventListener("error",e)}load(u,g,E,h){if(/^node\|/.test(g)){let c=u.getConfig().getOptionsLiteral(),e=$(u.getRecorder(),c.nodeRequire||H.global.nodeRequire),A=g.split("|"),y=null;try{y=e(A[1])}catch(R){h(R);return}u.enqueueDefineAnonymousModule([],()=>y),E()}else{let c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript"),this.attachListeners(c,E,h);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(g=e.createScriptURL(g)),c.setAttribute("src",g);const{cspNonce:A}=u.getConfig().getOptionsLiteral();A&&c.setAttribute("nonce",A),document.getElementsByTagName("head")[0].appendChild(c)}}}function k(s){const{trustedTypesPolicy:u}=s.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=k(u)),this._cachedCanUseEval}load(u,g,E,h){if(/^node\|/.test(g)){const c=u.getConfig().getOptionsLiteral(),e=$(u.getRecorder(),c.nodeRequire||H.global.nodeRequire),A=g.split("|");let y=null;try{y=e(A[1])}catch(R){h(R);return}u.enqueueDefineAnonymousModule([],function(){return y}),E()}else{const{trustedTypesPolicy:c}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(g).then(A=>{if(A.status!==200)throw new Error(A.statusText);return A.text()}).then(A=>{A=`${A}
//# sourceURL=${g}`,(c?self.eval(c.createScript("",A)):new Function(A)).call(self),E()}).then(void 0,h);return}try{c&&(g=c.createScriptURL(g)),importScripts(g),E()}catch(A){h(A)}}}}class a{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,g){const{nodeCachedData:E}=g.getConfig().getOptionsLiteral();if(!E||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const h=this,c=u("module");function e(A){const y=A.constructor;let R=function(M){try{return A.require(M)}finally{}};return R.resolve=function(M,d){return y._resolveFilename(M,A,!1,d)},R.resolve.paths=function(M){return y._resolveLookupPaths(M,A)},R.main=process.mainModule,R.extensions=y._extensions,R.cache=y._cache,R}c.prototype._compile=function(A,y){const R=c.wrap(A.replace(/^#!.*/,"")),m=g.getRecorder(),M=h._getCachedDataPath(E,y),d={filename:y};let b;try{const L=h._fs.readFileSync(M);b=L.slice(0,16),d.cachedData=L.slice(16),m.record(60,M)}catch{m.record(61,M)}const r=new h._vm.Script(R,d),l=r.runInThisContext(d),N=h._path.dirname(y),f=e(this),w=[this.exports,f,this,y,N,process,je,Buffer],v=l.apply(this.exports,w);return h._handleCachedData(r,R,M,!d.cachedData,g),h._verifyCachedData(r,R,M,b,g),v}}load(u,g,E,h){const c=u.getConfig().getOptionsLiteral(),e=$(u.getRecorder(),c.nodeRequire||H.global.nodeRequire),A=c.nodeInstrumenter||function(R){return R};this._init(e),this._initNodeRequire(e,u);let y=u.getRecorder();if(/^node\|/.test(g)){let R=g.split("|"),m=null;try{m=e(R[1])}catch(M){h(M);return}u.enqueueDefineAnonymousModule([],()=>m),E()}else{g=H.Utilities.fileUriToFilePath(this._env.isWindows,g);const R=this._path.normalize(g),m=this._getElectronRendererScriptPathOrUri(R),M=!!c.nodeCachedData,d=M?this._getCachedDataPath(c.nodeCachedData,g):void 0;this._readSourceAndCachedData(R,d,y,(b,r,l,N)=>{if(b){h(b);return}let f;r.charCodeAt(0)===a._BOM?f=a._PREFIX+r.substring(1)+a._SUFFIX:f=a._PREFIX+r+a._SUFFIX,f=A(f,R);const w={filename:m,cachedData:l},v=this._createAndEvalScript(u,f,w,E,h);this._handleCachedData(v,f,d,M&&!l,u),this._verifyCachedData(v,f,d,N,u)})}}_createAndEvalScript(u,g,E,h,c){const e=u.getRecorder();e.record(31,E.filename);const A=new this._vm.Script(g,E),y=A.runInThisContext(E),R=u.getGlobalAMDDefineFunc();let m=!1;const M=function(){return m=!0,R.apply(null,arguments)};return M.amd=R.amd,y.call(H.global,u.getGlobalAMDRequireFunc(),M,E.filename,this._path.dirname(E.filename)),e.record(32,E.filename),m?h():c(new Error(`Didn't receive define call in ${E.filename}!`)),A}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let g=u.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,g){const E=this._crypto.createHash("md5").update(g,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),h=this._path.basename(g).replace(/\.js$/,"");return this._path.join(u.path,`${h}-${E}.code`)}_handleCachedData(u,g,E,h,c){u.cachedDataRejected?this._fs.unlink(E,e=>{c.getRecorder().record(62,E),this._createAndWriteCachedData(u,g,E,c),e&&c.getConfig().onError(e)}):h&&this._createAndWriteCachedData(u,g,E,c)}_createAndWriteCachedData(u,g,E,h){let c=Math.ceil(h.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,A=0,y;const R=()=>{setTimeout(()=>{y||(y=this._crypto.createHash("md5").update(g,"utf8").digest());const m=u.createCachedData();if(!(m.length===0||m.length===e||A>=5)){if(m.length<e){R();return}e=m.length,this._fs.writeFile(E,Buffer.concat([y,m]),M=>{M&&h.getConfig().onError(M),h.getRecorder().record(63,E),R()})}},c*Math.pow(4,A++))};R()}_readSourceAndCachedData(u,g,E,h){if(!g)this._fs.readFile(u,{encoding:"utf8"},h);else{let c,e,A,y=2;const R=m=>{m?h(m):--y===0&&h(void 0,c,e,A)};this._fs.readFile(u,{encoding:"utf8"},(m,M)=>{c=M,R(m)}),this._fs.readFile(g,(m,M)=>{!m&&M&&M.length>0?(A=M.slice(0,16),e=M.slice(16),E.record(60,g)):E.record(61,g),R()})}}_verifyCachedData(u,g,E,h,c){h&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(g,"utf8").digest();h.equals(e)||(c.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${E}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(E,A=>{A&&c.getConfig().onError(A)}))},Math.ceil(5e3*(1+Math.random()))))}}a._BOM=65279,a._PREFIX="(function (require, define, __filename, __dirname) { ",a._SUFFIX=`
});`;function $(s,u){if(u.__$__isRecorded)return u;const g=function(h){s.record(33,h);try{return u(h)}finally{s.record(34,h)}};return g.__$__isRecorded=!0,g}H.ensureRecordedNodeRequire=$;function o(s){return new t(s)}H.createScriptLoader=o})($e||($e={}));var $e;(function(H){class t{constructor(s){let u=s.lastIndexOf("/");u!==-1?this.fromModulePath=s.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(s){let u=s,g;for(g=/\/\.\//;g.test(u);)u=u.replace(g,"/");for(u=u.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(u);)u=u.replace(g,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(s){let u=s;return H.Utilities.isAbsolutePath(u)||(H.Utilities.startsWith(u,"./")||H.Utilities.startsWith(u,"../"))&&(u=t._normalizeModuleId(this.fromModulePath+u)),u}}t.ROOT=new t(""),H.ModuleIdResolver=t;class P{constructor(s,u,g,E,h,c){this.id=s,this.strId=u,this.dependencies=g,this._callback=E,this._errorback=h,this.moduleIdResolver=c,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(s,u){try{return{returnedValue:s.apply(H.global,u),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(s,u,g,E){return s.shouldInvokeFactory(u)?s.shouldCatchError()?this._safeInvokeFunction(g,E):{returnedValue:g.apply(H.global,E),producedError:null}:{returnedValue:null,producedError:null}}complete(s,u,g,E){this._isComplete=!0;let h=null;if(this._callback)if(typeof this._callback=="function"){s.record(21,this.strId);let c=P._invokeFactory(u,this.strId,this._callback,g);h=c.producedError,s.record(22,this.strId),!h&&typeof c.returnedValue<"u"&&(!this.exportsPassedIn||H.Utilities.isEmpty(this.exports))&&(this.exports=c.returnedValue)}else this.exports=this._callback;if(h){let c=H.ensureError(h);c.phase="factory",c.moduleId=this.strId,c.neededBy=E(this.id),this.error=c,u.onError(c)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(s){return this._isComplete=!0,this.error=s,this._errorback?(this._errorback(s),!0):!1}isComplete(){return this._isComplete}}H.Module=P;class k{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(s){let u=this._strModuleIdToIntModuleId.get(s);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(s,u),this._intModuleIdToStrModuleId[u]=s),u}getStrModuleId(s){return this._intModuleIdToStrModuleId[s]}}class i{constructor(s){this.id=s}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),H.RegularDependency=i;class a{constructor(s,u,g){this.id=s,this.pluginId=u,this.pluginParam=g}}H.PluginDependency=a;class ${constructor(s,u,g,E,h=0){this._env=s,this._scriptLoader=u,this._loaderAvailableTimestamp=h,this._defineFunc=g,this._requireFunc=E,this._moduleIdProvider=new k,this._config=new H.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new $(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(s,u){let g=c=>c.replace(/\\/g,"/"),E=g(s),h=u.split(/\n/);for(let c=0;c<h.length;c++){let e=h[c].match(/(.*):(\d+):(\d+)\)?$/);if(e){let A=e[1],y=e[2],R=e[3],m=Math.max(A.lastIndexOf(" ")+1,A.lastIndexOf("(")+1);if(A=A.substr(m),A=g(A),A===E){let M={line:parseInt(y,10),col:parseInt(R,10)};return M.line===1&&(M.col-=53),M}}}throw new Error("Could not correlate define call site for needle "+s)}getBuildInfo(){if(!this._config.isBuild())return null;let s=[],u=0;for(let g=0,E=this._modules2.length;g<E;g++){let h=this._modules2[g];if(!h)continue;let c=this._buildInfoPath[h.id]||null,e=this._buildInfoDefineStack[h.id]||null,A=this._buildInfoDependencies[h.id];s[u++]={id:h.strId,path:c,defineLocation:c&&e?$._findRelevantLocationInStack(c,e):null,dependencies:A,shim:null,exports:h.exports}}return s}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new H.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=H.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(s,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:s,callback:u}}defineModule(s,u,g,E,h,c=new t(s)){let e=this._moduleIdProvider.getModuleId(s);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(s)||console.warn("Duplicate definition of module '"+s+"'");return}let A=new P(e,s,this._normalizeDependencies(u,c),g,E,c);this._modules2[e]=A,this._config.isBuild()&&(this._buildInfoDefineStack[e]=h,this._buildInfoDependencies[e]=(A.dependencies||[]).map(y=>this._moduleIdProvider.getStrModuleId(y.id))),this._resolve(A)}_normalizeDependency(s,u){if(s==="exports")return i.EXPORTS;if(s==="module")return i.MODULE;if(s==="require")return i.REQUIRE;let g=s.indexOf("!");if(g>=0){let E=u.resolveModule(s.substr(0,g)),h=u.resolveModule(s.substr(g+1)),c=this._moduleIdProvider.getModuleId(E+"!"+h),e=this._moduleIdProvider.getModuleId(E);return new a(c,e,h)}return new i(this._moduleIdProvider.getModuleId(u.resolveModule(s)))}_normalizeDependencies(s,u){let g=[],E=0;for(let h=0,c=s.length;h<c;h++)g[E++]=this._normalizeDependency(s[h],u);return g}_relativeRequire(s,u,g,E){if(typeof u=="string")return this.synchronousRequire(u,s);this.defineModule(H.Utilities.generateAnonymousModule(),u,g,E,null,s)}synchronousRequire(s,u=new t(s)){let g=this._normalizeDependency(s,u),E=this._modules2[g.id];if(!E)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This is the first mention of this module!");if(!E.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This module has not been resolved completely yet.");if(E.error)throw E.error;return E.exports}configure(s,u){let g=this._config.shouldRecordStats();u?this._config=new H.Configuration(this._env,s):this._config=this._config.cloneAndMerge(s),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(s){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(s),u.dependencies,u.callback,null,u.stack)}}_createLoadError(s,u){let g=this._moduleIdProvider.getStrModuleId(s),E=(this._inverseDependencies2[s]||[]).map(c=>this._moduleIdProvider.getStrModuleId(c));const h=H.ensureError(u);return h.phase="loading",h.moduleId=g,h.neededBy=E,h}_onLoadError(s,u){const g=this._createLoadError(s,u);this._modules2[s]||(this._modules2[s]=new P(s,this._moduleIdProvider.getStrModuleId(s),[],()=>{},null,null));let E=[];for(let e=0,A=this._moduleIdProvider.getMaxModuleId();e<A;e++)E[e]=!1;let h=!1,c=[];for(c.push(s),E[s]=!0;c.length>0;){let e=c.shift(),A=this._modules2[e];A&&(h=A.onDependencyError(g)||h);let y=this._inverseDependencies2[e];if(y)for(let R=0,m=y.length;R<m;R++){let M=y[R];E[M]||(c.push(M),E[M]=!0)}}h||this._config.onError(g)}_hasDependencyPath(s,u){let g=this._modules2[s];if(!g)return!1;let E=[];for(let c=0,e=this._moduleIdProvider.getMaxModuleId();c<e;c++)E[c]=!1;let h=[];for(h.push(g),E[s]=!0;h.length>0;){let e=h.shift().dependencies;if(e)for(let A=0,y=e.length;A<y;A++){let R=e[A];if(R.id===u)return!0;let m=this._modules2[R.id];m&&!E[R.id]&&(E[R.id]=!0,h.push(m))}}return!1}_findCyclePath(s,u,g){if(s===u||g===50)return[s];let E=this._modules2[s];if(!E)return null;let h=E.dependencies;if(h)for(let c=0,e=h.length;c<e;c++){let A=this._findCyclePath(h[c].id,u,g+1);if(A!==null)return A.push(s),A}return null}_createRequire(s){let u=(g,E,h)=>this._relativeRequire(s,g,E,h);return u.toUrl=g=>this._config.requireToUrl(s.resolveModule(g)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(g,E=!1)=>{this.configure(g,E)},u.__$__nodeRequire=H.global.nodeRequire,u}_loadModule(s){if(this._modules2[s]||this._knownModules2[s])return;this._knownModules2[s]=!0;let u=this._moduleIdProvider.getStrModuleId(s),g=this._config.moduleIdToPaths(u),E=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||E.test(u))&&g.push("node|"+u);let h=-1,c=e=>{if(h++,h>=g.length)this._onLoadError(s,e);else{let A=g[h],y=this.getRecorder();if(this._config.isBuild()&&A==="empty:"){this._buildInfoPath[s]=A,this.defineModule(this._moduleIdProvider.getStrModuleId(s),[],null,null,null),this._onLoad(s);return}y.record(10,A),this._scriptLoader.load(this,A,()=>{this._config.isBuild()&&(this._buildInfoPath[s]=A),y.record(11,A),this._onLoad(s)},R=>{y.record(12,A),c(R)})}};c(null)}_loadPluginDependency(s,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let g=E=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],E,null,null)};g.error=E=>{this._config.onError(this._createLoadError(u.id,E))},s.load(u.pluginParam,this._createRequire(t.ROOT),g,this._config.getOptionsLiteral())}_resolve(s){let u=s.dependencies;if(u)for(let g=0,E=u.length;g<E;g++){let h=u[g];if(h===i.EXPORTS){s.exportsPassedIn=!0,s.unresolvedDependenciesCount--;continue}if(h===i.MODULE){s.unresolvedDependenciesCount--;continue}if(h===i.REQUIRE){s.unresolvedDependenciesCount--;continue}let c=this._modules2[h.id];if(c&&c.isComplete()){if(c.error){s.onDependencyError(c.error);return}s.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(h.id,s.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(h.id)+"' and '"+this._moduleIdProvider.getStrModuleId(s.id)+"'. The cyclic path follows:");let e=this._findCyclePath(h.id,s.id,0)||[];e.reverse(),e.push(h.id),console.warn(e.map(A=>this._moduleIdProvider.getStrModuleId(A)).join(` => 
`)),s.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[h.id]=this._inverseDependencies2[h.id]||[],this._inverseDependencies2[h.id].push(s.id),h instanceof a){let e=this._modules2[h.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,h);continue}let A=this._inversePluginDependencies2.get(h.pluginId);A||(A=[],this._inversePluginDependencies2.set(h.pluginId,A)),A.push(h),this._loadModule(h.pluginId);continue}this._loadModule(h.id)}s.unresolvedDependenciesCount===0&&this._onModuleComplete(s)}_onModuleComplete(s){let u=this.getRecorder();if(s.isComplete())return;let g=s.dependencies,E=[];if(g)for(let A=0,y=g.length;A<y;A++){let R=g[A];if(R===i.EXPORTS){E[A]=s.exports;continue}if(R===i.MODULE){E[A]={id:s.strId,config:()=>this._config.getConfigForModule(s.strId)};continue}if(R===i.REQUIRE){E[A]=this._createRequire(s.moduleIdResolver);continue}let m=this._modules2[R.id];if(m){E[A]=m.exports;continue}E[A]=null}const h=A=>(this._inverseDependencies2[A]||[]).map(y=>this._moduleIdProvider.getStrModuleId(y));s.complete(u,this._config,E,h);let c=this._inverseDependencies2[s.id];if(this._inverseDependencies2[s.id]=null,c)for(let A=0,y=c.length;A<y;A++){let R=c[A],m=this._modules2[R];m.unresolvedDependenciesCount--,m.unresolvedDependenciesCount===0&&this._onModuleComplete(m)}let e=this._inversePluginDependencies2.get(s.id);if(e){this._inversePluginDependencies2.delete(s.id);for(let A=0,y=e.length;A<y;A++)this._loadPluginDependency(s.exports,e[A])}}}H.ModuleManager=$})($e||($e={}));var Z,$e;(function(H){const t=new H.Environment;let P=null;const k=function(o,s,u){typeof o!="string"&&(u=s,s=o,o=null),(typeof s!="object"||!Array.isArray(s))&&(u=s,s=null),s||(s=["require","exports","module"]),o?P.defineModule(o,s,u,null,null):P.enqueueDefineAnonymousModule(s,u)};k.amd={jQuery:!0};const i=function(o,s=!1){P.configure(o,s)},a=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return P.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){P.defineModule(H.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};a.config=i,a.getConfig=function(){return P.getConfig().getOptionsLiteral()},a.reset=function(){P=P.reset()},a.getBuildInfo=function(){return P.getBuildInfo()},a.getStats=function(){return P.getLoaderEvents()},a.define=k;function $(){if(typeof H.global.require<"u"||typeof require<"u"){const o=H.global.require||require;if(typeof o=="function"&&typeof o.resolve=="function"){const s=H.ensureRecordedNodeRequire(P.getRecorder(),o);H.global.nodeRequire=s,a.nodeRequire=s,a.__$__nodeRequire=s}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=a:(t.isElectronRenderer||(H.global.define=k),H.global.require=a)}H.init=$,(typeof H.global.define!="function"||!H.global.define.amd)&&(P=new H.ModuleManager(t,H.createScriptLoader(t),k,a,H.Utilities.getHighPerformanceTimestamp()),typeof H.global.require<"u"&&typeof H.global.require!="function"&&a.config(H.global.require),Z=function(){return k.apply(null,arguments)},Z.amd=k.amd,typeof doNotInitLoader>"u"&&$())})($e||($e={})),Z(K[63],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function P(o,s,u,g){if(g=g||{},(g["vs/css"]||{}).disabled){u({});return}const h=s.toUrl(o+".css");k(o,h,()=>{u({})},c=>{typeof u.error=="function"&&u.error("Could not find "+h+".")})}t.load=P;function k(o,s,u,g){if(i(o,s)){u();return}a(o,s,u,g)}function i(o,s){const u=document.getElementsByTagName("link");for(let g=0,E=u.length;g<E;g++){const h=u[g].getAttribute("data-name"),c=u[g].getAttribute("href");if(h===o||c===s)return!0}return!1}function a(o,s,u,g){const E=document.createElement("link");E.setAttribute("rel","stylesheet"),E.setAttribute("type","text/css"),E.setAttribute("data-name",o),$(o,E,u,g),E.setAttribute("href",s),(document.head||document.getElementsByTagName("head")[0]).appendChild(E)}function $(o,s,u,g){const E=()=>{s.removeEventListener("load",h),s.removeEventListener("error",c)},h=e=>{E(),u()},c=e=>{E(),g(e)};s.addEventListener("load",h),s.addEventListener("error",c)}}),Z("vs/nls",["require","exports"],function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let P=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const k="i-default";function i(e,A){let y;return A.length===0?y=e:y=e.replace(/\{(\d+)\}/g,(R,m)=>{const M=m[0],d=A[M];let b=R;return typeof d=="string"?b=d:(typeof d=="number"||typeof d=="boolean"||d===void 0||d===null)&&(b=String(d)),b}),P&&(y="\uFF3B"+y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),y}function a(e,A){let y=e[A];return y||(y=e["*"],y)?y:null}function $(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function o(e,A,y){const R=$(e)+$(A)+"vscode/"+$(y),m=await fetch(R);if(m.ok)return await m.json();throw new Error(`${m.status} - ${m.statusText}`)}function s(e){return function(A,y){const R=Array.prototype.slice.call(arguments,2);return i(e[A],R)}}function u(e,A,...y){return i(A,y)}t.localize=u;function g(e){}t.getConfiguredDefaultLocale=g;function E(e){P=e}t.setPseudoTranslation=E;function h(e,A){return{localize:s(A[e]),getConfiguredDefaultLocale:A.getConfiguredDefaultLocale??(y=>{})}}t.create=h;function c(e,A,y,R){const m=R["vs/nls"]??{};if(!e||e.length===0)return y({localize:u,getConfiguredDefaultLocale:()=>m.availableLanguages?.["*"]});const M=m.availableLanguages?a(m.availableLanguages,e):null,d=M===null||M===k;let b=".nls";d||(b=b+"."+M);const r=l=>{Array.isArray(l)?l.localize=s(l):l.localize=s(l[e]),l.getConfiguredDefaultLocale=()=>m.availableLanguages?.["*"],y(l)};typeof m.loadBundle=="function"?m.loadBundle(e,M,(l,N)=>{l?A([e+".nls"],r):r(N)}):m.translationServiceUrl&&!d?(async()=>{try{const l=await o(m.translationServiceUrl,M,e);return r(l)}catch(l){if(!M.includes("-"))return console.error(l),A([e+".nls"],r);try{const N=M.split("-")[0],f=await o(m.translationServiceUrl,N,e);return m.availableLanguages??={},m.availableLanguages["*"]=N,r(f)}catch(N){return console.error(N),A([e+".nls"],r)}}})():A([e+b],r,l=>{if(b===".nls"){console.error("Failed trying to load default language strings",l);return}console.error(`Failed to load message bundle for language ${M}. Falling back to the default language:`,l),A([e+".nls"],r)})}t.load=c}),function(){const H=globalThis.MonacoEnvironment,t=H&&H.baseUrl?H.baseUrl:"../../../";function P(g,E){if(H?.createTrustedTypesPolicy)try{return H.createTrustedTypesPolicy(g,E)}catch(h){console.warn(h);return}try{return self.trustedTypes?.createPolicy(g,E)}catch(h){console.warn(h);return}}const k=P("amdLoader",{createScriptURL:g=>g,createScript:(g,...E)=>{const h=E.slice(0,-1).join(","),c=E.pop().toString();return`(function anonymous(${h}) { ${c}
})`}});function i(){try{return(k?globalThis.eval(k.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function a(){return new Promise((g,E)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return g();const h=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(h).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${h}`,(k?globalThis.eval(k.createScript("",e)):new Function(e)).call(globalThis),g()}).then(void 0,E);return}k?importScripts(k.createScriptURL(h)):importScripts(h),g()})}function $(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:k,amdModulesPattern:/^vs\//})}function o(g){a().then(()=>{$(),require([g],function(E){setTimeout(function(){const h=E.create((c,e)=>{globalThis.postMessage(c,e)},null);for(globalThis.onmessage=c=>h.onmessage(c.data,c.ports);u.length>0;){const c=u.shift();h.onmessage(c.data,c.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&$();let s=!0;const u=[];globalThis.onmessage=g=>{if(!s){u.push(g);return}s=!1,o(g.data)}}(),Z(K[28],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L=t.$K=t.$J=t.$I=void 0;function P($,o){const s=Object.create(null);for(const u of $){const g=o(u);let E=s[g];E||(E=s[g]=[]),E.push(u)}return s}t.$I=P;function k($,o){const s=[],u=[];for(const g of $)o.has(g)||s.push(g);for(const g of o)$.has(g)||u.push(g);return{removed:s,added:u}}t.$J=k;function i($,o){const s=[],u=[];for(const[g,E]of $)o.has(g)||s.push(E);for(const[g,E]of o)$.has(g)||u.push(E);return{removed:s,added:u}}t.$K=i;class a{constructor(){this.a=new Map}add(o,s){let u=this.a.get(o);u||(u=new Set,this.a.set(o,u)),u.add(s)}delete(o,s){const u=this.a.get(o);u&&(u.delete(s),u.size===0&&this.a.delete(o))}forEach(o,s){const u=this.a.get(o);u&&u.forEach(s)}get(o){const s=this.a.get(o);return s||new Set}}t.$L=a}),Z(K[29],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0r=t.$9r=t.$8r=t.$7r=void 0;function P(o,s){const u=Math.pow(10,s);return Math.round(o*u)/u}class k{constructor(s,u,g,E=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,s))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=P(Math.max(Math.min(1,E),0),3)}static equals(s,u){return s.r===u.r&&s.g===u.g&&s.b===u.b&&s.a===u.a}}t.$7r=k;class i{constructor(s,u,g,E){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=P(Math.max(Math.min(1,u),0),3),this.l=P(Math.max(Math.min(1,g),0),3),this.a=P(Math.max(Math.min(1,E),0),3)}static equals(s,u){return s.h===u.h&&s.s===u.s&&s.l===u.l&&s.a===u.a}static fromRGBA(s){const u=s.r/255,g=s.g/255,E=s.b/255,h=s.a,c=Math.max(u,g,E),e=Math.min(u,g,E);let A=0,y=0;const R=(e+c)/2,m=c-e;if(m>0){switch(y=Math.min(R<=.5?m/(2*R):m/(2-2*R),1),c){case u:A=(g-E)/m+(g<E?6:0);break;case g:A=(E-u)/m+2;break;case E:A=(u-g)/m+4;break}A*=60,A=Math.round(A)}return new i(A,y,R,h)}static i(s,u,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?s+(u-s)*6*g:g<1/2?u:g<2/3?s+(u-s)*(2/3-g)*6:s}static toRGBA(s){const u=s.h/360,{s:g,l:E,a:h}=s;let c,e,A;if(g===0)c=e=A=E;else{const y=E<.5?E*(1+g):E+g-E*g,R=2*E-y;c=i.i(R,y,u+1/3),e=i.i(R,y,u),A=i.i(R,y,u-1/3)}return new k(Math.round(c*255),Math.round(e*255),Math.round(A*255),h)}}t.$8r=i;class a{constructor(s,u,g,E){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=P(Math.max(Math.min(1,u),0),3),this.v=P(Math.max(Math.min(1,g),0),3),this.a=P(Math.max(Math.min(1,E),0),3)}static equals(s,u){return s.h===u.h&&s.s===u.s&&s.v===u.v&&s.a===u.a}static fromRGBA(s){const u=s.r/255,g=s.g/255,E=s.b/255,h=Math.max(u,g,E),c=Math.min(u,g,E),e=h-c,A=h===0?0:e/h;let y;return e===0?y=0:h===u?y=((g-E)/e%6+6)%6:h===g?y=(E-u)/e+2:y=(u-g)/e+4,new a(Math.round(y*60),A,h,s.a)}static toRGBA(s){const{h:u,s:g,v:E,a:h}=s,c=E*g,e=c*(1-Math.abs(u/60%2-1)),A=E-c;let[y,R,m]=[0,0,0];return u<60?(y=c,R=e):u<120?(y=e,R=c):u<180?(R=c,m=e):u<240?(R=e,m=c):u<300?(y=e,m=c):u<=360&&(y=c,m=e),y=Math.round((y+A)*255),R=Math.round((R+A)*255),m=Math.round((m+A)*255),new k(y,R,m,h)}}t.$9r=a;class ${static fromHex(s){return $.Format.CSS.parseHex(s)||$.red}static equals(s,u){return!s&&!u?!0:!s||!u?!1:s.equals(u)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:a.fromRGBA(this.rgba)}constructor(s){if(s)if(s instanceof k)this.rgba=s;else if(s instanceof i)this.i=s,this.rgba=i.toRGBA(s);else if(s instanceof a)this.j=s,this.rgba=a.toRGBA(s);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(s){return!!s&&k.equals(this.rgba,s.rgba)&&i.equals(this.hsla,s.hsla)&&a.equals(this.hsva,s.hsva)}getRelativeLuminance(){const s=$.k(this.rgba.r),u=$.k(this.rgba.g),g=$.k(this.rgba.b),E=.2126*s+.7152*u+.0722*g;return P(E,4)}static k(s){const u=s/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(s){const u=this.getRelativeLuminance(),g=s.getRelativeLuminance();return u>g?(u+.05)/(g+.05):(g+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(s){const u=this.getRelativeLuminance(),g=s.getRelativeLuminance();return u>g}isDarkerThan(s){const u=this.getRelativeLuminance(),g=s.getRelativeLuminance();return u<g}lighten(s){return new $(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*s,this.hsla.a))}darken(s){return new $(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*s,this.hsla.a))}transparent(s){const{r:u,g,b:E,a:h}=this.rgba;return new $(new k(u,g,E,h*s))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new $(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(s){const u=s.rgba,g=this.rgba.a,E=u.a,h=g+E*(1-g);if(h<1e-6)return $.transparent;const c=this.rgba.r*g/h+u.r*E*(1-g)/h,e=this.rgba.g*g/h+u.g*E*(1-g)/h,A=this.rgba.b*g/h+u.b*E*(1-g)/h;return new $(new k(c,e,A,h))}makeOpaque(s){if(this.isOpaque()||s.rgba.a!==1)return this;const{r:u,g,b:E,a:h}=this.rgba;return new $(new k(s.rgba.r-h*(s.rgba.r-u),s.rgba.g-h*(s.rgba.g-g),s.rgba.b-h*(s.rgba.b-E),1))}flatten(...s){const u=s.reduceRight((g,E)=>$.o(E,g));return $.o(this,u)}static o(s,u){const g=1-s.rgba.a;return new $(new k(g*u.rgba.r+s.rgba.a*s.rgba.r,g*u.rgba.g+s.rgba.a*s.rgba.g,g*u.rgba.b+s.rgba.a*s.rgba.b))}toString(){return this.u||(this.u=$.Format.CSS.format(this)),this.u}static getLighterColor(s,u,g){if(s.isLighterThan(u))return s;g=g||.5;const E=s.getRelativeLuminance(),h=u.getRelativeLuminance();return g=g*(h-E)/h,s.lighten(g)}static getDarkerColor(s,u,g){if(s.isDarkerThan(u))return s;g=g||.5;const E=s.getRelativeLuminance(),h=u.getRelativeLuminance();return g=g*(E-h)/E,s.darken(g)}static{this.white=new $(new k(255,255,255,1))}static{this.black=new $(new k(0,0,0,1))}static{this.red=new $(new k(255,0,0,1))}static{this.blue=new $(new k(0,0,255,1))}static{this.green=new $(new k(0,255,0,1))}static{this.cyan=new $(new k(0,255,255,1))}static{this.lightgrey=new $(new k(211,211,211,1))}static{this.transparent=new $(new k(0,0,0,0))}}t.$0r=$,function(o){let s;(function(u){let g;(function(E){function h(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:o.Format.CSS.formatRGBA(r)}E.formatRGB=h;function c(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}E.formatRGBA=c;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:o.Format.CSS.formatHSLA(r)}E.formatHSL=e;function A(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}E.formatHSLA=A;function y(r){const l=r.toString(16);return l.length!==2?"0"+l:l}function R(r){return`#${y(r.rgba.r)}${y(r.rgba.g)}${y(r.rgba.b)}`}E.formatHex=R;function m(r,l=!1){return l&&r.rgba.a===1?o.Format.CSS.formatHex(r):`#${y(r.rgba.r)}${y(r.rgba.g)}${y(r.rgba.b)}${y(Math.round(r.rgba.a*255))}`}E.formatHexA=m;function M(r){return r.isOpaque()?o.Format.CSS.formatHex(r):o.Format.CSS.formatRGBA(r)}E.format=M;function d(r){const l=r.length;if(l===0||r.charCodeAt(0)!==35)return null;if(l===7){const N=16*b(r.charCodeAt(1))+b(r.charCodeAt(2)),f=16*b(r.charCodeAt(3))+b(r.charCodeAt(4)),w=16*b(r.charCodeAt(5))+b(r.charCodeAt(6));return new o(new k(N,f,w,1))}if(l===9){const N=16*b(r.charCodeAt(1))+b(r.charCodeAt(2)),f=16*b(r.charCodeAt(3))+b(r.charCodeAt(4)),w=16*b(r.charCodeAt(5))+b(r.charCodeAt(6)),v=16*b(r.charCodeAt(7))+b(r.charCodeAt(8));return new o(new k(N,f,w,v/255))}if(l===4){const N=b(r.charCodeAt(1)),f=b(r.charCodeAt(2)),w=b(r.charCodeAt(3));return new o(new k(16*N+N,16*f+f,16*w+w))}if(l===5){const N=b(r.charCodeAt(1)),f=b(r.charCodeAt(2)),w=b(r.charCodeAt(3)),v=b(r.charCodeAt(4));return new o(new k(16*N+N,16*f+f,16*w+w,(16*v+v)/255))}return null}E.parseHex=d;function b(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=u.CSS||(u.CSS={}))})(s=o.Format||(o.Format={}))}($||(t.$0r=$={}))}),Z(K[30],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lu=void 0;class P{constructor(i,a,$,o){this.originalStart=i,this.originalLength=a,this.modifiedStart=$,this.modifiedLength=o}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$lu=P}),Z(K[3],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.$X=t.setUnexpectedErrorHandler=t.$V=t.$U=void 0;class P{constructor(){this.b=[],this.a=function(l){setTimeout(()=>{throw l.stack?d.isErrorNoTelemetry(l)?new d(l.message+`

`+l.stack):new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.b.push(l),()=>{this.d(l)}}c(l){this.b.forEach(N=>{N(l)})}d(l){this.b.splice(this.b.indexOf(l),1)}setUnexpectedErrorHandler(l){this.a=l}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(l){this.a(l),this.c(l)}onUnexpectedExternalError(l){this.a(l)}}t.$U=P,t.$V=new P;function k(r){t.$V.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=k;function i(r){if(!r||typeof r!="object")return!1;const l=r;return l.code==="EPIPE"&&l.syscall?.toUpperCase()==="WRITE"}t.$X=i;function a(r){u(r)||t.$V.onUnexpectedError(r)}t.$Y=a;function $(r){u(r)||t.$V.onUnexpectedExternalError(r)}t.$Z=$;function o(r){if(r instanceof Error){const{name:l,message:N}=r,f=r.stacktrace||r.stack;return{$isError:!0,name:l,message:N,stack:f,noTelemetry:d.isErrorNoTelemetry(r)}}return r}t.$1=o;const s="Canceled";function u(r){return r instanceof g?!0:r instanceof Error&&r.name===s&&r.message===s}t.$2=u;class g extends Error{constructor(){super(s),this.name=this.message}}t.$3=g;function E(){const r=new Error(s);return r.name=r.message,r}t.$4=E;function h(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.$5=h;function c(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.$6=c;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.$7=e;function A(r){const l=new Error(`${r} has been disposed`);return l.name="DISPOSED",l}t.$8=A;function y(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.$9=y;class R extends Error{constructor(l){super("NotImplemented"),l&&(this.message=l)}}t.$0=R;class m extends Error{constructor(l){super("NotSupported"),l&&(this.message=l)}}t.$$=m;class M extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=M;class d extends Error{constructor(l){super(l),this.name="CodeExpectedError"}static fromError(l){if(l instanceof d)return l;const N=new d;return N.message=l.message,N.stack=l.stack,N}static isErrorNoTelemetry(l){return l.name==="CodeExpectedError"}}t.$ab=d;class b extends Error{constructor(l){super(l||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}t.$bb=b}),Z(K[15],ne([0,1,3]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.CompareResult=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.top=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=void 0;function k(D,U=0){return D[D.length-(1+U)]}t.$_e=k;function i(D){if(D.length===0)throw new Error("Invalid tail call");return[D.slice(0,D.length-1),D[D.length-1]]}t.$af=i;function a(D,U,S=(j,x)=>j===x){if(D===U)return!0;if(!D||!U||D.length!==U.length)return!1;for(let j=0,x=D.length;j<x;j++)if(!S(D[j],U[j]))return!1;return!0}t.$bf=a;function $(D,U){const S=D.length-1;U<S&&(D[U]=D[S]),D.pop()}t.$cf=$;function o(D,U,S){return s(D.length,j=>S(D[j],U))}t.$df=o;function s(D,U){let S=0,j=D-1;for(;S<=j;){const x=(S+j)/2|0,te=U(x);if(te<0)S=x+1;else if(te>0)j=x-1;else return x}return-(S+1)}t.$ef=s;function u(D,U){let S=0,j=D.length;if(j===0)return 0;for(;S<j;){const x=Math.floor((S+j)/2);U(D[x])?j=x:S=x+1}return S}t.$ff=u;function g(D,U,S){if(D=D|0,D>=U.length)throw new TypeError("invalid index");const j=U[Math.floor(U.length*Math.random())],x=[],te=[],re=[];for(const de of U){const ge=S(de,j);ge<0?x.push(de):ge>0?te.push(de):re.push(de)}return D<x.length?g(D,x,S):D<x.length+re.length?re[0]:g(D-(x.length+re.length),te,S)}t.$gf=g;function E(D,U){const S=[];let j;for(const x of D.slice(0).sort(U))!j||U(j[0],x)!==0?(j=[x],S.push(j)):j.push(x);return S}t.$hf=E;function h(D,U,S){const j=[];function x(de,ge,we){if(ge===0&&we.length===0)return;const Le=j[j.length-1];Le&&Le.start+Le.deleteCount===de?(Le.deleteCount+=ge,Le.toInsert.push(...we)):j.push({start:de,deleteCount:ge,toInsert:we})}let te=0,re=0;for(;;){if(te===D.length){x(te,0,U.slice(re));break}if(re===U.length){x(te,D.length-te,[]);break}const de=D[te],ge=U[re],we=S(de,ge);we===0?(te+=1,re+=1):we<0?(x(te,1,[]),te+=1):we>0&&(x(te,0,[ge]),re+=1)}return j}t.$if=h;function c(D,U,S){const j=h(D,U,S),x=[],te=[];for(const re of j)x.push(...D.slice(re.start,re.start+re.deleteCount)),te.push(...re.toInsert);return{removed:x,added:te}}t.$jf=c;function e(D,U,S){if(S===0)return[];const j=D.slice(0,S).sort(U);return y(D,U,j,S,D.length),j}t.top=e;function A(D,U,S,j,x){return S===0?Promise.resolve([]):new Promise((te,re)=>{(async()=>{const de=D.length,ge=D.slice(0,S).sort(U);for(let we=S,Le=Math.min(S+j,de);we<de;we=Le,Le=Math.min(Le+j,de)){if(we>S&&await new Promise(ke=>setTimeout(ke)),x&&x.isCancellationRequested)throw new P.$3;y(D,U,ge,we,Le)}return ge})().then(te,re)})}t.$lf=A;function y(D,U,S,j,x){for(const te=S.length;j<x;j++){const re=D[j];if(U(re,S[te-1])<0){S.pop();const de=u(S,ge=>U(re,ge)<0);S.splice(de,0,re)}}}function R(D){return D.filter(U=>!!U)}t.$mf=R;function m(D){let U=0;for(let S=0;S<D.length;S++)D[S]&&(D[U]=D[S],U+=1);D.length=U}t.$nf=m;function M(D,U,S){D.splice(S,0,D.splice(U,1)[0])}t.$of=M;function d(D){return!Array.isArray(D)||D.length===0}t.$pf=d;function b(D){return Array.isArray(D)&&D.length>0}t.$qf=b;function r(D,U=S=>S){const S=new Set;return D.filter(j=>{const x=U(j);return S.has(x)?!1:(S.add(x),!0)})}t.$rf=r;function l(D){const U=new Set;return S=>{const j=D(S);return U.has(j)?!1:(U.add(j),!0)}}t.$sf=l;function N(D,U){const S=f(D,U);if(S!==-1)return D[S]}t.$tf=N;function f(D,U){for(let S=D.length-1;S>=0;S--){const j=D[S];if(U(j))return S}return-1}t.$uf=f;function w(D,U){return D.length>0?D[0]:U}t.$vf=w;function v(D,U){return D.length>0?D[D.length-1]:U}t.$wf=v;function L(D,U,S=(j,x)=>j===x){let j=0;for(let x=0,te=Math.min(D.length,U.length);x<te&&S(D[x],U[x]);x++)j++;return j}t.$xf=L;function F(D){return[].concat(...D)}t.$yf=F;function _(D,U){let S=typeof U=="number"?D:0;typeof U=="number"?S=D:(S=0,U=D);const j=[];if(S<=U)for(let x=S;x<U;x++)j.push(x);else for(let x=S;x>U;x--)j.push(x);return j}t.$zf=_;function I(D,U,S){return D.reduce((j,x)=>(j[U(x)]=S?S(x):x,j),Object.create(null))}t.$Af=I;function V(D,U){return D.push(U),()=>z(D,U)}t.$Bf=V;function z(D,U){const S=D.indexOf(U);if(S>-1)return D.splice(S,1),U}t.$Cf=z;function C(D,U,S){const j=D.slice(0,U),x=D.slice(U);return j.concat(S,x)}t.$Df=C;function O(D,U){let S;if(typeof U=="number"){let j=U;S=()=>{const x=Math.sin(j++)*179426549;return x-Math.floor(x)}}else S=Math.random;for(let j=D.length-1;j>0;j-=1){const x=Math.floor(S()*(j+1)),te=D[j];D[j]=D[x],D[x]=te}}t.$Ef=O;function p(D,U){const S=D.indexOf(U);S>-1&&(D.splice(S,1),D.unshift(U))}t.$Ff=p;function q(D,U){const S=D.indexOf(U);S>-1&&(D.splice(S,1),D.push(U))}t.$Gf=q;function X(D,U){for(const S of U)D.push(S)}t.$Hf=X;function B(D,U){return Array.isArray(D)?D.map(U):U(D)}t.$If=B;function J(D){return Array.isArray(D)?D:[D]}t.$Jf=J;function n(D){return D[Math.floor(Math.random()*D.length)]}t.$Kf=n;function ee(D,U){for(const S of D){const j=U(S);if(j!==void 0)return j}}t.$Lf=ee;function ue(D,U,S){const j=ae(D,U),x=D.length,te=S.length;D.length=x+te;for(let re=x-1;re>=j;re--)D[re+te]=D[re];for(let re=0;re<te;re++)D[re+j]=S[re]}t.$Mf=ue;function oe(D,U,S,j){const x=ae(D,U),te=D.splice(x,S);return ue(D,x,j),te}t.$Nf=oe;function ae(D,U){return U<0?Math.max(U+D.length,0):Math.min(U,D.length)}var he;(function(D){function U(x){return x<0}D.isLessThan=U;function S(x){return x>0}D.isGreaterThan=S;function j(x){return x===0}D.isNeitherLessOrGreaterThan=j,D.greaterThan=1,D.lessThan=-1,D.neitherLessOrGreaterThan=0})(he||(t.CompareResult=he={}));function Ae(D,U){return(S,j)=>U(D(S),D(j))}t.$Of=Ae;function me(...D){return(U,S)=>{for(const j of D){const x=j(U,S);if(!he.isNeitherLessOrGreaterThan(x))return x}return he.neitherLessOrGreaterThan}}t.$Pf=me;const be=(D,U)=>D-U;t.$Qf=be;function Ee(D){return(U,S)=>-D(U,S)}t.$Rf=Ee;function se(D,U){if(D.length===0)return;let S=D[0];for(let j=1;j<D.length;j++){const x=D[j];U(x,S)>0&&(S=x)}return S}t.$Sf=se;function ce(D,U){if(D.length===0)return;let S=D[0];for(let j=1;j<D.length;j++){const x=D[j];U(x,S)>=0&&(S=x)}return S}t.$Tf=ce;function fe(D,U){return se(D,(S,j)=>-U(S,j))}t.$Uf=fe;class ve{constructor(U){this.f=U,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(U){let S=this.c;for(;S<this.f.length&&U(this.f[S]);)S++;const j=S===this.c?null:this.f.slice(this.c,S);return this.c=S,j}takeFromEndWhile(U){let S=this.d;for(;S>=0&&U(this.f[S]);)S--;const j=S===this.d?null:this.f.slice(S+1,this.d+1);return this.d=S,j}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const U=this.f[this.c];return this.c++,U}removeLast(){const U=this.f[this.d];return this.d--,U}takeCount(U){const S=this.f.slice(this.c,this.c+U);return this.c+=U,S}}t.$Vf=ve;class Y{static{this.empty=new Y(U=>{})}constructor(U){this.iterate=U}forEach(U){this.iterate(S=>(U(S),!0))}toArray(){const U=[];return this.iterate(S=>(U.push(S),!0)),U}filter(U){return new Y(S=>this.iterate(j=>U(j)?S(j):!0))}map(U){return new Y(S=>this.iterate(j=>S(U(j))))}some(U){let S=!1;return this.iterate(j=>(S=U(j),!S)),S}findFirst(U){let S;return this.iterate(j=>U(j)?(S=j,!1):!0),S}findLast(U){let S;return this.iterate(j=>(U(j)&&(S=j),!0)),S}findLastMaxBy(U){let S,j=!0;return this.iterate(x=>((j||he.isGreaterThan(U(x,S)))&&(j=!1,S=x),!0)),S}}t.$Wf=Y}),Z(K[10],ne([0,1,3]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qc=t.$pc=t.$oc=t.$nc=t.ok=void 0;function k(s,u){if(!s)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}t.ok=k;function i(s,u="Unreachable"){throw new Error(u)}t.$nc=i;function a(s){if(!s)throw new P.$bb("Assertion Failed")}t.$oc=a;function $(s){if(!s()){debugger;s(),(0,P.$Y)(new P.$bb("Assertion Failed"))}}t.$pc=$;function o(s,u){let g=0;for(;g<s.length-1;){const E=s[g],h=s[g+1];if(!u(E,h))return!1;g++}return!0}t.$qc=o}),Z(K[16],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function P(k){const i=this;let a=!1,$;return function(){return a||(a=!0,$=k.apply(i,arguments)),$}}t.$cb=P}),Z(K[17],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var P;(function(k){function i(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}k.is=i;const a=Object.freeze([]);function $(){return a}k.empty=$;function*o(d){yield d}k.single=o;function s(d){return i(d)?d:o(d)}k.wrap=s;function u(d){return d||a}k.from=u;function g(d){return!d||d[Symbol.iterator]().next().done===!0}k.isEmpty=g;function E(d){return d[Symbol.iterator]().next().value}k.first=E;function h(d,b){for(const r of d)if(b(r))return!0;return!1}k.some=h;function c(d,b){for(const r of d)if(b(r))return r}k.find=c;function*e(d,b){for(const r of d)b(r)&&(yield r)}k.filter=e;function*A(d,b){let r=0;for(const l of d)yield b(l,r++)}k.map=A;function*y(...d){for(const b of d)for(const r of b)yield r}k.concat=y;function R(d,b,r){let l=r;for(const N of d)l=b(l,N);return l}k.reduce=R;function*m(d,b,r=d.length){for(b<0&&(b+=d.length),r<0?r+=d.length:r>d.length&&(r=d.length);b<r;b++)yield d[b]}k.slice=m;function M(d,b=Number.POSITIVE_INFINITY){const r=[];if(b===0)return[r,d];const l=d[Symbol.iterator]();for(let N=0;N<b;N++){const f=l.next();if(f.done)return[r,k.empty()];r.push(f.value)}return[r,{[Symbol.iterator](){return l}}]}k.consume=M})(P||(t.Iterable=P={}))}),Z(K[31],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kq=t.KeyMod=t.KeyCodeUtils=t.$jq=t.$iq=t.$hq=t.$gq=t.$fq=t.ScanCode=t.KeyCode=void 0;var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(P||(t.KeyCode=P={}));var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(k||(t.ScanCode=k={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(A,y){this._keyCodeToStr[A]=y,this._strToKeyCode[y.toLowerCase()]=A}keyCodeToStr(A){return this._keyCodeToStr[A]}strToKeyCode(A){return this._strToKeyCode[A.toLowerCase()]||0}}const a=new i,$=new i,o=new i;t.$fq=new Array(230),t.$gq={};const s=[],u=Object.create(null),g=Object.create(null);t.$hq={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>u[e]||0,toString:e=>s[e]||"None"},t.$iq=[],t.$jq=[];for(let e=0;e<=193;e++)t.$iq[e]=-1;for(let e=0;e<=132;e++)t.$jq[e]=-1;(function(){const e="",A=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],y=[],R=[];for(const m of A){const[M,d,b,r,l,N,f,w,v]=m;if(R[d]||(R[d]=!0,s[d]=b,u[b]=d,g[b.toLowerCase()]=d,M&&(t.$iq[d]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.$jq[r]=d))),!y[r]){if(y[r]=!0,!l)throw new Error(`String representation missing for key code ${r} around scan code ${b}`);a.define(r,l),$.define(r,w||l),o.define(r,v||w||l)}N&&(t.$fq[N]=r),f&&(t.$gq[f]=r)}t.$jq[3]=46})();var E;(function(e){function A(b){return a.keyCodeToStr(b)}e.toString=A;function y(b){return a.strToKeyCode(b)}e.fromString=y;function R(b){return $.keyCodeToStr(b)}e.toUserSettingsUS=R;function m(b){return o.keyCodeToStr(b)}e.toUserSettingsGeneral=m;function M(b){return $.strToKeyCode(b)||o.strToKeyCode(b)}e.fromUserSettings=M;function d(b){if(b>=98&&b<=113)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return a.keyCodeToStr(b)}e.toElectronAccelerator=d})(E||(t.KeyCodeUtils=E={}));var h;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(h||(t.KeyMod=h={}));function c(e,A){const y=(A&65535)<<16>>>0;return(e|y)>>>0}t.$kq=c}),Z(K[32],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=void 0;class P{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$T=P}),Z(K[7],ne([0,1,16,17]),function(H,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tb=t.$sb=t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=t.$db=void 0;const i=!1;let a=null;function $(v){a=v}if(t.$db=$,i){const v="__is_disposable_tracked__";$(new class{trackDisposable(L){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[v]||console.log(F)},3e3)}setParent(L,F){if(L&&L!==m.None)try{L[v]=!0}catch{}}markAsDisposed(L){if(L&&L!==m.None)try{L[v]=!0}catch{}}markAsSingleton(L){}})}function o(v){return a?.trackDisposable(v),v}function s(v){a?.markAsDisposed(v)}function u(v,L){a?.setParent(v,L)}function g(v,L){if(a)for(const F of v)a.setParent(F,L)}function E(v){return a?.markAsSingleton(v),v}t.$eb=E;function h(v){return typeof v.dispose=="function"&&v.dispose.length===0}t.$fb=h;function c(v){if(k.Iterable.is(v)){const L=[];for(const F of v)if(F)try{F.dispose()}catch(_){L.push(_)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}t.$gb=c;function e(v){for(const L of v)h(L)&&L.dispose();return[]}t.$hb=e;function A(...v){const L=y(()=>c(v));return g(v,L),L}t.$ib=A;function y(v){const L=o({dispose:(0,P.$cb)(()=>{s(L),v()})});return L}t.$jb=y;class R{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,o(this)}dispose(){this.g||(s(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return u(L,this),this.g?R.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}}t.$kb=R;class m{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new R,o(this),u(this.q,this)}dispose(){s(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}t.$lb=m;class M{constructor(){this.b=!1,o(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&u(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,s(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&u(L,null),L}}t.$mb=M;class d{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$nb=d;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,o(this)}set(L){let F=L;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,s(this))},this}}t.$ob=b;class r{constructor(){this.a=new Map}acquire(L,...F){let _=this.a.get(L);_||(_={counter:0,object:this.b(L,...F)},this.a.set(L,_));const{object:I}=_,V=(0,P.$cb)(()=>{--_.counter===0&&(this.c(L,_.object),this.a.delete(L))});return _.counter++,{object:I,dispose:V}}}t.$pb=r;class l{constructor(L){this.a=L}async acquire(L,...F){const _=this.a.acquire(L,...F);try{return{object:await _.object,dispose:()=>_.dispose()}}catch(I){throw _.dispose(),I}}}t.$qb=l;class N{constructor(L){this.object=L}dispose(){}}t.$rb=N;function f(v){const L=new R;try{v(L)}finally{L.dispose()}}t.$sb=f;class w{constructor(){this.a=new Map,this.b=!1,o(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get(L){return this.a.get(L)}set(L,F,_=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),_||this.a.get(L)?.dispose(),this.a.set(L,F)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$tb=w}),Z(K[18],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lc=void 0;class P{static{this.Undefined=new P(void 0)}constructor(a){this.element=a,this.next=P.Undefined,this.prev=P.Undefined}}class k{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let a=this.a;for(;a!==P.Undefined;){const $=a.next;a.prev=P.Undefined,a.next=P.Undefined,a=$}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(a){return this.d(a,!1)}push(a){return this.d(a,!0)}d(a,$){const o=new P(a);if(this.a===P.Undefined)this.a=o,this.b=o;else if($){const u=this.b;this.b=o,o.prev=u,u.next=o}else{const u=this.a;this.a=o,o.next=u,u.prev=o}this.c+=1;let s=!1;return()=>{s||(s=!0,this.e(o))}}shift(){if(this.a!==P.Undefined){const a=this.a.element;return this.e(this.a),a}}pop(){if(this.b!==P.Undefined){const a=this.b.element;return this.e(this.b),a}}e(a){if(a.prev!==P.Undefined&&a.next!==P.Undefined){const $=a.prev;$.next=a.next,a.next.prev=$}else a.prev===P.Undefined&&a.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):a.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):a.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let a=this.a;for(;a!==P.Undefined;)yield a.element,a=a.next}}t.$lc=k}),Z(K[19],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class k{static create(a){return new k(a)}constructor(a){this.c=P&&a===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$4c=k}),Z(K[8],ne([0,1,3,16,7,18,19]),function(H,t,P,k,i,a,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dd=t.$cd=t.$bd=t.$ad=t.$_c=t.$$c=t.$0c=t.$9c=t.$8c=t.$7c=t.$6c=t.Event=void 0;const o=!1,s=!1;var u;(function(F){F.None=()=>i.$lb.None;function _(Y){if(s){const{onDidAddListener:D}=Y,U=e.create();let S=0;Y.onDidAddListener=()=>{++S===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),D?.()}}}function I(Y,D){return J(Y,()=>{},0,void 0,!0,void 0,D)}F.defer=I;function V(Y){return(D,U=null,S)=>{let j=!1,x;return x=Y(te=>{if(!j)return x?x.dispose():j=!0,D.call(U,te)},null,S),j&&x.dispose(),x}}F.once=V;function z(Y,D,U){return B((S,j=null,x)=>Y(te=>S.call(j,D(te)),null,x),U)}F.map=z;function C(Y,D,U){return B((S,j=null,x)=>Y(te=>{D(te),S.call(j,te)},null,x),U)}F.forEach=C;function O(Y,D,U){return B((S,j=null,x)=>Y(te=>D(te)&&S.call(j,te),null,x),U)}F.filter=O;function p(Y){return Y}F.signal=p;function q(...Y){return(D,U=null,S)=>(0,i.$ib)(...Y.map(j=>j(x=>D.call(U,x),null,S)))}F.any=q;function X(Y,D,U,S){let j=U;return z(Y,x=>(j=D(j,x),j),S)}F.reduce=X;function B(Y,D){let U;const S={onWillAddFirstListener(){U=Y(j.fire,j)},onDidRemoveLastListener(){U?.dispose()}};D||_(S);const j=new M(S);return D?.add(j),j.event}function J(Y,D,U=100,S=!1,j=!1,x,te){let re,de,ge,we=0,Le;const ke={leakWarningThreshold:x,onWillAddFirstListener(){re=Y(qe=>{we++,de=D(de,qe),S&&!ge&&(De.fire(de),de=void 0),Le=()=>{const Se=de;de=void 0,ge=void 0,(!S||we>1)&&De.fire(Se),we=0},typeof U=="number"?(clearTimeout(ge),ge=setTimeout(Le,U)):ge===void 0&&(ge=0,queueMicrotask(Le))})},onWillRemoveListener(){j&&we>0&&Le?.()},onDidRemoveLastListener(){Le=void 0,re.dispose()}};te||_(ke);const De=new M(ke);return te?.add(De),De.event}F.debounce=J;function n(Y,D=0,U){return F.debounce(Y,(S,j)=>S?(S.push(j),S):[j],D,void 0,!0,void 0,U)}F.accumulate=n;function ee(Y,D=(S,j)=>S===j,U){let S=!0,j;return O(Y,x=>{const te=S||!D(x,j);return S=!1,j=x,te},U)}F.latch=ee;function ue(Y,D,U){return[F.filter(Y,D,U),F.filter(Y,S=>!D(S),U)]}F.split=ue;function oe(Y,D=!1,U=[]){let S=U.slice(),j=Y(re=>{S?S.push(re):te.fire(re)});const x=()=>{S?.forEach(re=>te.fire(re)),S=null},te=new M({onWillAddFirstListener(){j||(j=Y(re=>te.fire(re)))},onDidAddFirstListener(){S&&(D?setTimeout(x):x())},onDidRemoveLastListener(){j&&j.dispose(),j=null}});return te.event}F.buffer=oe;class ae{constructor(D){this.event=D,this.d=new i.$kb}map(D){return new ae(z(this.event,D,this.d))}forEach(D){return new ae(C(this.event,D,this.d))}filter(D){return new ae(O(this.event,D,this.d))}reduce(D,U){return new ae(X(this.event,D,U,this.d))}latch(){return new ae(ee(this.event,void 0,this.d))}debounce(D,U=100,S=!1,j=!1,x){return new ae(J(this.event,D,U,S,j,x,this.d))}on(D,U,S){return this.event(D,U,S)}once(D,U,S){return V(this.event)(D,U,S)}dispose(){this.d.dispose()}}function he(Y){return new ae(Y)}F.chain=he;function Ae(Y,D,U=S=>S){const S=(...re)=>te.fire(U(...re)),j=()=>Y.on(D,S),x=()=>Y.removeListener(D,S),te=new M({onWillAddFirstListener:j,onDidRemoveLastListener:x});return te.event}F.fromNodeEventEmitter=Ae;function me(Y,D,U=S=>S){const S=(...re)=>te.fire(U(...re)),j=()=>Y.addEventListener(D,S),x=()=>Y.removeEventListener(D,S),te=new M({onWillAddFirstListener:j,onDidRemoveLastListener:x});return te.event}F.fromDOMEventEmitter=me;function be(Y){return new Promise(D=>V(Y)(D))}F.toPromise=be;function Ee(Y,D){return D(void 0),Y(U=>D(U))}F.runAndSubscribe=Ee;function se(Y,D){let U=null;function S(x){U?.dispose(),U=new i.$kb,D(x,U)}S(void 0);const j=Y(x=>S(x));return(0,i.$jb)(()=>{j.dispose(),U?.dispose()})}F.runAndSubscribeWithStore=se;class ce{constructor(D,U){this._observable=D,this.d=0,this.f=!1;const S={onWillAddFirstListener:()=>{D.addObserver(this)},onDidRemoveLastListener:()=>{D.removeObserver(this)}};U||_(S),this.emitter=new M(S),U&&U.add(this.emitter)}beginUpdate(D){this.d++}handlePossibleChange(D){}handleChange(D,U){this.f=!0}endUpdate(D){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function fe(Y,D){return new ce(Y,D).emitter.event}F.fromObservable=fe;function ve(Y){return D=>{let U=0,S=!1;const j={beginUpdate(){U++},endUpdate(){U--,U===0&&(Y.reportChanges(),S&&(S=!1,D()))},handlePossibleChange(){},handleChange(){S=!0}};return Y.addObserver(j),Y.reportChanges(),{dispose(){Y.removeObserver(j)}}}}F.fromObservableLight=ve})(u||(t.Event=u={}));class g{static{this.all=new Set}static{this.d=0}constructor(_){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${_}_${g.d++}`,g.all.add(this)}start(_){this.f=new $.$4c,this.listenerCount=_}stop(){if(this.f){const _=this.f.elapsed();this.durations.push(_),this.elapsedOverall+=_,this.invocationCount+=1,this.f=void 0}}}t.$6c=g;let E=-1;function h(F){const _=E;return E=F,{dispose(){E=_}}}t.$7c=h;class c{constructor(_,I=Math.random().toString(18).slice(2,5)){this.threshold=_,this.name=I,this.f=0}dispose(){this.d?.clear()}check(_,I){const V=this.threshold;if(V<=0||I<V)return;this.d||(this.d=new Map);const z=this.d.get(_.value)||0;if(this.d.set(_.value,z+1),this.f-=1,this.f<=0){this.f=V*.5;let C,O=0;for(const[p,q]of this.d)(!C||O<q)&&(C=p,O=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${O}):`),console.warn(C)}return()=>{const C=this.d.get(_.value)||0;this.d.set(_.value,C-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(_){this.value=_}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let A=0;class y{constructor(_){this.value=_,this.id=A++}}const R=2,m=(F,_)=>{if(F instanceof y)_(F);else for(let I=0;I<F.length;I++){const V=F[I];V&&_(V)}};class M{constructor(_){this.u=0,this.d=_,this.f=E>0||this.d?.leakWarningThreshold?new c(this.d?.leakWarningThreshold??E):void 0,this.g=this.d?._profName?new g(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(o){const _=this.q;queueMicrotask(()=>{m(_,I=>I.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(_,I,V)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$lb.None;if(this.j)return i.$lb.None;I&&(_=_.bind(I));const z=new y(_);let C,O;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(z.stack=e.create(),C=this.f.check(z.stack,this.u+1)),o&&(z.stack=O??e.create()),this.q?this.q instanceof y?(this.t??=new b,this.q=[this.q,z]):this.q.push(z):(this.d?.onWillAddFirstListener?.(this),this.q=z,this.d?.onDidAddFirstListener?.(this)),this.u++;const p=(0,i.$jb)(()=>{C?.(),this.v(z)});return V instanceof i.$kb?V.add(p):Array.isArray(V)&&V.push(p),p},this.m}v(_){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const I=this.q,V=I.indexOf(_);if(V===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,I[V]=void 0;const z=this.t.current===this;if(this.u*R<=I.length){let C=0;for(let O=0;O<I.length;O++)I[O]?I[C++]=I[O]:z&&(this.t.end--,C<this.t.i&&this.t.i--);I.length=C}}w(_,I){if(!_)return;const V=this.d?.onListenerError||P.$Y;if(!V){_.value(I);return}try{_.value(I)}catch(z){V(z)}}x(_){const I=_.current.q;for(;_.i<_.end;)this.w(I[_.i++],_.value);_.reset()}fire(_){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof y)this.w(this.q,_);else{const I=this.t;I.enqueue(this,_,this.q.length),this.x(I)}this.g?.stop()}hasListeners(){return this.u>0}}t.$8c=M;const d=()=>new b;t.$9c=d;class b{constructor(){this.i=-1,this.end=0}enqueue(_,I,V){this.i=0,this.end=V,this.current=_,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends M{async fireAsync(_,I,V){if(this.q)for(this.h||(this.h=new a.$lc),m(this.q,z=>this.h.push([z.value,_]));this.h.size>0&&!I.isCancellationRequested;){const[z,C]=this.h.shift(),O=[],p={...C,token:I,waitUntil:q=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");V&&(q=V(q,z)),O.push(q)}};try{z(p)}catch(q){(0,P.$Y)(q);continue}Object.freeze(O),await Promise.allSettled(O).then(q=>{for(const X of q)X.status==="rejected"&&(0,P.$Y)(X.reason)})}}}t.$0c=r;class l extends M{get isPaused(){return this.h!==0}constructor(_){super(_),this.h=0,this.s=new a.$lc,this.y=_?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const _=Array.from(this.s);this.s.clear(),super.fire(this.y(_))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(_){this.u&&(this.h!==0?this.s.push(_):super.fire(_))}}t.$$c=l;class N extends l{constructor(_){super(_),this.k=_.delay??100}fire(_){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(_)}}t.$_c=N;class f extends M{constructor(_){super(_),this.h=[],this.k=_?.merge}fire(_){this.hasListeners()&&(this.h.push(_),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}t.$ad=f;class w{constructor(){this.f=!1,this.g=[],this.d=new M({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(_){const I={event:_,listener:null};this.g.push(I),this.f&&this.k(I);const V=()=>{this.f&&this.m(I);const z=this.g.indexOf(I);this.g.splice(z,1)};return(0,i.$jb)((0,k.$cb)(V))}h(){this.f=!0,this.g.forEach(_=>this.k(_))}j(){this.f=!1,this.g.forEach(_=>this.m(_))}k(_){_.listener=_.event(I=>this.d.fire(I))}m(_){_.listener&&_.listener.dispose(),_.listener=null}dispose(){this.d.dispose()}}t.$bd=w;class v{constructor(){this.d=[]}wrapEvent(_){return(I,V,z)=>_(C=>{const O=this.d[this.d.length-1];O?O.push(()=>I.call(V,C)):I.call(V,C)},void 0,z)}bufferEvents(_){const I=[];this.d.push(I);const V=_();return this.d.pop(),I.forEach(z=>z()),V}}t.$cd=v;class L{constructor(){this.d=!1,this.f=u.None,this.g=i.$lb.None,this.h=new M({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(_){this.f=_,this.d&&(this.g.dispose(),this.g=_(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}t.$dd=L}),Z(K[20],ne([0,1,8]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ed=t.CancellationToken=void 0;const k=Object.freeze(function(o,s){const u=setTimeout(o.bind(s),0);return{dispose(){clearTimeout(u)}}});var i;(function(o){function s(u){return u===o.None||u===o.Cancelled||u instanceof a?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}o.isCancellationToken=s,o.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),o.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(i||(t.CancellationToken=i={}));class a{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?k:(this.b||(this.b=new P.$8c),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class ${constructor(s){this.a=void 0,this.b=void 0,this.b=s&&s.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new a),this.a}cancel(){this.a?this.a instanceof a&&this.a.cancel():this.a=i.Cancelled}dispose(s=!1){s&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof a&&this.a.dispose():this.a=i.None}}t.$ed=$}),Z(K[33],ne([0,1,20]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hd=t.$gd=t.$fd=void 0;class k{constructor(o){this.b=o,this.a=null}get(){if(this.a)return this.a;const o=new P.$ed,s=this.b(o.token);return this.a={promise:s,dispose:()=>{this.a=null,o.cancel(),o.dispose()}},this.a}}t.$fd=k;class i{constructor(o){this.c=o,this.a=void 0,this.b=void 0}get(o){const s=JSON.stringify(o);return this.b!==s&&(this.b=s,this.a=this.c(o)),this.a}}t.$gd=i;class a{get cachedValues(){return this.a}constructor(o){this.b=o,this.a=new Map}get(o){if(this.a.has(o))return this.a.get(o);const s=this.b(o);return this.a.set(o,s),s}}t.$hd=a}),Z(K[5],ne([0,1,33,32]),function(H,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ie=t.$he=t.$ge=t.$fe=t.GraphemeBreakType=t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.$Kd=t.$Jd=t.$Id=t.$Hd=t.$Gd=t.$Fd=t.$Ed=t.$Dd=t.$Cd=t.$Bd=t.$Ad=t.$zd=t.$yd=t.$xd=t.$wd=t.$vd=t.$ud=t.$td=t.$sd=t.$rd=t.$qd=t.$pd=t.$od=t.$nd=t.$md=t.$ld=t.$kd=void 0;function i(T){return!T||typeof T!="string"?!0:T.trim().length===0}t.$kd=i;const a=/{(\d+)}/g;function $(T,...W){return W.length===0?T:T.replace(a,function(G,Q){const ie=parseInt(Q,10);return isNaN(ie)||ie<0||ie>=W.length?G:W[ie]})}t.$ld=$;const o=/{([^}]+)}/g;function s(T,W){return T.replace(o,(G,Q)=>W[Q]??G)}t.$md=s;function u(T){return T.replace(/[<>&]/g,function(W){switch(W){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return W}})}t.$nd=u;function g(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$od=g;function E(T,W){let G=0;const Q=W.charCodeAt(0);for(let ie=T.length-1;ie>=0;ie--)T.charCodeAt(ie)===Q&&G++;return G}t.$pd=E;function h(T,W,G="\u2026"){return T.length<=W?T:`${T.substr(0,W)}${G}`}t.$qd=h;function c(T,W=" "){const G=e(T,W);return A(G,W)}t.$rd=c;function e(T,W){if(!T||!W)return T;const G=W.length;if(G===0||T.length===0)return T;let Q=0;for(;T.indexOf(W,Q)===Q;)Q=Q+G;return T.substring(Q)}t.$sd=e;function A(T,W){if(!T||!W)return T;const G=W.length,Q=T.length;if(G===0||Q===0)return T;let ie=Q,le=-1;for(;le=T.lastIndexOf(W,ie-1),!(le===-1||le+G!==ie);){if(le===0)return"";ie=le}return T.substring(0,ie)}t.$td=A;function y(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$ud=y;function R(T){return T.replace(/\*/g,"")}t.$vd=R;function m(T,W,G={}){if(!T)throw new Error("Cannot create regex from empty string");W||(T=g(T)),G.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let Q="";return G.global&&(Q+="g"),G.matchCase||(Q+="i"),G.multiline&&(Q+="m"),G.unicode&&(Q+="u"),new RegExp(T,Q)}t.$wd=m;function M(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}t.$xd=M;function d(T){return!!T.match(/([^\\]|^)(\\\\)*\\\d+/)}t.$yd=d;function b(T){return(T.global?"g":"")+(T.ignoreCase?"i":"")+(T.multiline?"m":"")+(T.unicode?"u":"")}t.$zd=b;function r(T){return T.split(/\r\n|\r|\n/)}t.$Ad=r;function l(T){for(let W=0,G=T.length;W<G;W++){const Q=T.charCodeAt(W);if(Q!==32&&Q!==9)return W}return-1}t.$Bd=l;function N(T,W=0,G=T.length){for(let Q=W;Q<G;Q++){const ie=T.charCodeAt(Q);if(ie!==32&&ie!==9)return T.substring(W,Q)}return T.substring(W,G)}t.$Cd=N;function f(T,W=T.length-1){for(let G=W;G>=0;G--){const Q=T.charCodeAt(G);if(Q!==32&&Q!==9)return G}return-1}t.$Dd=f;function w(T,W,G){const Q=[];let ie=0;for(const le of T.matchAll(W)){if(Q.push(T.slice(ie,le.index)),le.index===void 0)throw new Error("match.index should be defined");ie=le.index+le[0].length,Q.push(G(le[0],...le.slice(1),le.index,T,le.groups))}return Q.push(T.slice(ie)),Promise.all(Q).then(le=>le.join(""))}t.$Ed=w;function v(T,W){return T<W?-1:T>W?1:0}t.$Fd=v;function L(T,W,G=0,Q=T.length,ie=0,le=W.length){for(;G<Q&&ie<le;G++,ie++){const Me=T.charCodeAt(G),pe=W.charCodeAt(ie);if(Me<pe)return-1;if(Me>pe)return 1}const Ne=Q-G,ye=le-ie;return Ne<ye?-1:Ne>ye?1:0}t.$Gd=L;function F(T,W){return _(T,W,0,T.length,0,W.length)}t.$Hd=F;function _(T,W,G=0,Q=T.length,ie=0,le=W.length){for(;G<Q&&ie<le;G++,ie++){let Me=T.charCodeAt(G),pe=W.charCodeAt(ie);if(Me===pe)continue;if(Me>=128||pe>=128)return L(T.toLowerCase(),W.toLowerCase(),G,Q,ie,le);V(Me)&&(Me-=32),V(pe)&&(pe-=32);const Re=Me-pe;if(Re!==0)return Re}const Ne=Q-G,ye=le-ie;return Ne<ye?-1:Ne>ye?1:0}t.$Id=_;function I(T){return T>=48&&T<=57}t.$Jd=I;function V(T){return T>=97&&T<=122}t.$Kd=V;function z(T){return T>=65&&T<=90}t.$Ld=z;function C(T,W){return T.length===W.length&&_(T,W)===0}t.$Md=C;function O(T,W){const G=W.length;return W.length>T.length?!1:_(T,W,0,G)===0}t.$Nd=O;function p(T,W){const G=Math.min(T.length,W.length);let Q;for(Q=0;Q<G;Q++)if(T.charCodeAt(Q)!==W.charCodeAt(Q))return Q;return G}t.$Od=p;function q(T,W){const G=Math.min(T.length,W.length);let Q;const ie=T.length-1,le=W.length-1;for(Q=0;Q<G;Q++)if(T.charCodeAt(ie-Q)!==W.charCodeAt(le-Q))return Q;return G}t.$Pd=q;function X(T){return 55296<=T&&T<=56319}t.$Qd=X;function B(T){return 56320<=T&&T<=57343}t.$Rd=B;function J(T,W){return(T-55296<<10)+(W-56320)+65536}t.$Sd=J;function n(T,W,G){const Q=T.charCodeAt(G);if(X(Q)&&G+1<W){const ie=T.charCodeAt(G+1);if(B(ie))return J(Q,ie)}return Q}t.$Td=n;function ee(T,W){const G=T.charCodeAt(W-1);if(B(G)&&W>1){const Q=T.charCodeAt(W-2);if(X(Q))return J(Q,G)}return G}class ue{get offset(){return this.e}constructor(W,G=0){this.c=W,this.d=W.length,this.e=G}setOffset(W){this.e=W}prevCodePoint(){const W=ee(this.c,this.e);return this.e-=W>=65536?2:1,W}nextCodePoint(){const W=n(this.c,this.d,this.e);return this.e+=W>=65536?2:1,W}eol(){return this.e>=this.d}}t.$Ud=ue;class oe{get offset(){return this.c.offset}constructor(W,G=0){this.c=new ue(W,G)}nextGraphemeLength(){const W=_e.getInstance(),G=this.c,Q=G.offset;let ie=W.getGraphemeBreakType(G.nextCodePoint());for(;!G.eol();){const le=G.offset,Ne=W.getGraphemeBreakType(G.nextCodePoint());if(qe(ie,Ne)){G.setOffset(le);break}ie=Ne}return G.offset-Q}prevGraphemeLength(){const W=_e.getInstance(),G=this.c,Q=G.offset;let ie=W.getGraphemeBreakType(G.prevCodePoint());for(;G.offset>0;){const le=G.offset,Ne=W.getGraphemeBreakType(G.prevCodePoint());if(qe(Ne,ie)){G.setOffset(le);break}ie=Ne}return Q-G.offset}eol(){return this.c.eol()}}t.$Vd=oe;function ae(T,W){return new oe(T,W).nextGraphemeLength()}t.$Wd=ae;function he(T,W){return new oe(T,W).prevGraphemeLength()}t.$Xd=he;function Ae(T,W){W>0&&B(T.charCodeAt(W))&&W--;const G=W+ae(T,W);return[G-he(T,G),G]}t.$Yd=Ae;function me(T){const W=new oe(T);let G=0;for(;!W.eol();)G++,W.nextGraphemeLength();return G}t.$Zd=me;let be;function Ee(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function se(T){return be||(be=Ee()),be.test(T)}t.$1d=se;const ce=/^[\t\n\r\x20-\x7E]*$/;function fe(T){return ce.test(T)}t.$2d=fe,t.$3d=/[\u2028\u2029]/;function ve(T){return t.$3d.test(T)}t.$4d=ve;function Y(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}t.$5d=Y;function D(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}t.$6d=D;function U(T,W){if(T.length<W)return T;const G=/\b/g;let Q=0;for(;G.test(T)&&!(T.length-G.lastIndex<W);)Q=G.lastIndex,G.lastIndex+=1;return T.substring(Q).replace(/^\s/,"")}t.$7d=U;const S=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,j=/\x1b\].*?\x07/g;function x(T){return T&&(T=T.replace(S,"").replace(j,"")),T}t.$8d=x,t.$9d=String.fromCharCode(65279);function te(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}t.$0d=te;function re(T){return te(T)?T.substr(1):T}t.$$d=re;function de(T,W){if(!T||!W||T.length<W.length)return!1;const G=W.length,Q=T.toLowerCase();let ie=0,le=-1;for(;ie<G;){const Ne=Q.indexOf(W[ie],le+1);if(Ne<0)return!1;le=Ne,ie++}return!0}t.$_d=de;function ge(T,W=!1){return T?(W&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}t.$ae=ge;function we(T){return T.charAt(0).toUpperCase()+T.slice(1)}t.$be=we;function Le(T,W=1){if(W===0)return"";let G=-1;do G=T.indexOf(`
`,G+1),W--;while(W>0&&G>=0);return G===-1?T:(T[G-1]==="\r"&&G--,T.substr(0,G))}t.$ce=Le;function ke(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}t.$de=ke;function De(T){return _e.getInstance().getGraphemeBreakType(T)}t.$ee=De;function qe(T,W){return T===0?W!==5&&W!==7:T===2&&W===3?!1:T===4||T===2||T===3||W===4||W===2||W===3?!0:!(T===8&&(W===8||W===9||W===11||W===12)||(T===11||T===9)&&(W===9||W===10)||(T===12||T===10)&&W===10||W===5||W===13||W===7||T===1||T===13&&W===14||T===6&&W===6)}var Se;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(Se||(t.GraphemeBreakType=Se={}));class _e{static{this.c=null}static getInstance(){return _e.c||(_e.c=new _e),_e.c}constructor(){this.d=We()}getGraphemeBreakType(W){if(W<32)return W===10?3:W===13?2:4;if(W<127)return 0;const G=this.d,Q=G.length/3;let ie=1;for(;ie<=Q;)if(W<G[3*ie])ie=2*ie;else if(W>G[3*ie+1])ie=2*ie+1;else return G[3*ie+2];return 0}}function We(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ce(T,W){if(T===0)return 0;const G=He(T,W);if(G!==void 0)return G;const Q=new ue(W,T);return Q.prevCodePoint(),Q.offset}t.$fe=Ce;function He(T,W){const G=new ue(W,T);let Q=G.prevCodePoint();for(;ze(Q)||Q===65039||Q===8419;){if(G.offset===0)return;Q=G.prevCodePoint()}if(!D(Q))return;let ie=G.offset;return ie>0&&G.prevCodePoint()===8205&&(ie=G.offset),ie}function ze(T){return 127995<=T&&T<=127999}var Oe;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),t.$ge="\xA0";class Te{static{this.c=new k.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$gd(W=>{function G(Re){const Pe=new Map;for(let Fe=0;Fe<Re.length;Fe+=2)Pe.set(Re[Fe],Re[Fe+1]);return Pe}function Q(Re,Pe){const Fe=new Map(Re);for(const[Ue,Be]of Pe)Fe.set(Ue,Be);return Fe}function ie(Re,Pe){if(!Re)return Pe;const Fe=new Map;for(const[Ue,Be]of Re)Pe.has(Ue)&&Fe.set(Ue,Be);return Fe}const le=this.c.value;let Ne=W.filter(Re=>!Re.startsWith("_")&&Re in le);Ne.length===0&&(Ne=["_default"]);let ye;for(const Re of Ne){const Pe=G(le[Re]);ye=ie(ye,Pe)}const Me=G(le._common),pe=Q(Me,ye);return new Te(pe)})}static getInstance(W){return Te.d.get(Array.from(W))}static{this.e=new k.$T(()=>Object.keys(Te.c.value).filter(W=>!W.startsWith("_")))}static getLocales(){return Te.e.value}constructor(W){this.f=W}isAmbiguous(W){return this.f.has(W)}getPrimaryConfusable(W){return this.f.get(W)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$he=Te;class Ie{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ie.c())),this.d}static isInvisibleCharacter(W){return Ie.e().has(W)}static get codePoints(){return Ie.e()}}t.$ie=Ie}),Z(K[34],ne([0,1,5]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ji=t.$ii=t.$hi=t.$gi=t.$fi=t.$ei=t.$di=void 0;function k(R){return i(R,0)}t.$di=k;function i(R,m){switch(typeof R){case"object":return R===null?a(349,m):Array.isArray(R)?s(R,m):u(R,m);case"string":return o(R,m);case"boolean":return $(R,m);case"number":return a(R,m);case"undefined":return a(937,m);default:return a(617,m)}}t.$ei=i;function a(R,m){return(m<<5)-m+R|0}t.$fi=a;function $(R,m){return a(R?433:863,m)}function o(R,m){m=a(149417,m);for(let M=0,d=R.length;M<d;M++)m=a(R.charCodeAt(M),m);return m}t.$gi=o;function s(R,m){return m=a(104579,m),R.reduce((M,d)=>i(d,M),m)}function u(R,m){return m=a(181387,m),Object.keys(R).sort().reduce((M,d)=>(M=o(d,M),i(R[d],M)),m)}class g{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=i(m,this.g),this.g}}t.$hi=g;var E;(function(R){R[R.BLOCK_SIZE=64]="BLOCK_SIZE",R[R.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function h(R,m,M=32){const d=M-m,b=~((1<<d)-1);return(R<<m|(b&R)>>>d)>>>0}function c(R,m=0,M=R.byteLength,d=0){for(let b=0;b<M;b++)R[m+b]=d}function e(R,m,M="0"){for(;R.length<m;)R=M+R;return R}function A(R,m=32){return R instanceof ArrayBuffer?Array.from(new Uint8Array(R)).map(M=>M.toString(16).padStart(2,"0")).join(""):e((R>>>0).toString(16),m/4)}t.$ii=A;class y{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const M=m.length;if(M===0)return;const d=this.p;let b=this.r,r=this.u,l,N;for(r!==0?(l=r,N=-1,r=0):(l=m.charCodeAt(0),N=0);;){let f=l;if(P.$Qd(l))if(N+1<M){const w=m.charCodeAt(N+1);P.$Rd(w)?(N++,f=P.$Sd(l,w)):f=65533}else{r=l;break}else P.$Rd(l)&&(f=65533);if(b=this.w(d,b,f),N++,N<M)l=m.charCodeAt(N);else break}this.r=b,this.u=r}w(m,M,d){return d<128?m[M++]=d:d<2048?(m[M++]=192|(d&1984)>>>6,m[M++]=128|(d&63)>>>0):d<65536?(m[M++]=224|(d&61440)>>>12,m[M++]=128|(d&4032)>>>6,m[M++]=128|(d&63)>>>0):(m[M++]=240|(d&1835008)>>>18,m[M++]=128|(d&258048)>>>12,m[M++]=128|(d&4032)>>>6,m[M++]=128|(d&63)>>>0),M>=64&&(this.y(),M-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),M}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),A(this.h)+A(this.l)+A(this.m)+A(this.n)+A(this.o)}x(){this.p[this.r++]=128,c(this.p,this.r),this.r>56&&(this.y(),c(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=y.g,M=this.q;for(let L=0;L<64;L+=4)m.setUint32(L,M.getUint32(L,!1),!1);for(let L=64;L<320;L+=4)m.setUint32(L,h(m.getUint32(L-12,!1)^m.getUint32(L-32,!1)^m.getUint32(L-56,!1)^m.getUint32(L-64,!1),1),!1);let d=this.h,b=this.l,r=this.m,l=this.n,N=this.o,f,w,v;for(let L=0;L<80;L++)L<20?(f=b&r|~b&l,w=1518500249):L<40?(f=b^r^l,w=1859775393):L<60?(f=b&r|b&l|r&l,w=2400959708):(f=b^r^l,w=3395469782),v=h(d,5)+f+N+w+m.getUint32(L*4,!1)&4294967295,N=l,l=r,r=h(b,30),b=d,d=v;this.h=this.h+d&4294967295,this.l=this.l+b&4294967295,this.m=this.m+r&4294967295,this.n=this.n+l&4294967295,this.o=this.o+N&4294967295}}t.$ji=y}),Z(K[21],ne([0,1,30,34]),function(H,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ou=t.$nu=t.$mu=void 0;class i{constructor(h){this.a=h}getElements(){const h=this.a,c=new Int32Array(h.length);for(let e=0,A=h.length;e<A;e++)c[e]=h.charCodeAt(e);return c}}t.$mu=i;function a(E,h,c){return new g(new i(E),new i(h)).ComputeDiff(c).changes}t.$nu=a;class ${static Assert(h,c){if(!h)throw new Error(c)}}class o{static Copy(h,c,e,A,y){for(let R=0;R<y;R++)e[A+R]=h[c+R]}static Copy2(h,c,e,A,y){for(let R=0;R<y;R++)e[A+R]=h[c+R]}}var s;(function(E){E[E.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(s||(s={}));class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new P.$lu(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(h,c){this.b=Math.min(this.b,h),this.c=Math.min(this.c,c),this.d++}AddModifiedElement(h,c){this.b=Math.min(this.b,h),this.c=Math.min(this.c,c),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class g{constructor(h,c,e=null){this.a=e,this.b=h,this.c=c;const[A,y,R]=g.o(h),[m,M,d]=g.o(c);this.d=R&&d,this.e=A,this.f=y,this.g=m,this.h=M,this.k=[],this.m=[]}static n(h){return h.length>0&&typeof h[0]=="string"}static o(h){const c=h.getElements();if(g.n(c)){const e=new Int32Array(c.length);for(let A=0,y=c.length;A<y;A++)e[A]=(0,k.$gi)(c[A],0);return[c,e,!0]}return c instanceof Int32Array?[[],c,!1]:[[],new Int32Array(c),!1]}p(h,c){return this.f[h]!==this.h[c]?!1:this.d?this.e[h]===this.g[c]:!0}q(h,c){if(!this.p(h,c))return!1;const e=g.r(this.b,h),A=g.r(this.c,c);return e===A}static r(h,c){return typeof h.getStrictElement=="function"?h.getStrictElement(c):null}s(h,c){return this.f[h]!==this.f[c]?!1:this.d?this.e[h]===this.e[c]:!0}u(h,c){return this.h[h]!==this.h[c]?!1:this.d?this.g[h]===this.g[c]:!0}ComputeDiff(h){return this.v(0,this.f.length-1,0,this.h.length-1,h)}v(h,c,e,A,y){const R=[!1];let m=this.w(h,c,e,A,R);return y&&(m=this.z(m)),{quitEarly:R[0],changes:m}}w(h,c,e,A,y){for(y[0]=!1;h<=c&&e<=A&&this.p(h,e);)h++,e++;for(;c>=h&&A>=e&&this.p(c,A);)c--,A--;if(h>c||e>A){let r;return e<=A?($.Assert(h===c+1,"originalStart should only be one more than originalEnd"),r=[new P.$lu(h,0,e,A-e+1)]):h<=c?($.Assert(e===A+1,"modifiedStart should only be one more than modifiedEnd"),r=[new P.$lu(h,c-h+1,e,0)]):($.Assert(h===c+1,"originalStart should only be one more than originalEnd"),$.Assert(e===A+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const R=[0],m=[0],M=this.y(h,c,e,A,R,m,y),d=R[0],b=m[0];if(M!==null)return M;if(!y[0]){const r=this.w(h,d,e,b,y);let l=[];return y[0]?l=[new P.$lu(d+1,c-(d+1)+1,b+1,A-(b+1)+1)]:l=this.w(d+1,c,b+1,A,y),this.H(r,l)}return[new P.$lu(h,c-h+1,e,A-e+1)]}x(h,c,e,A,y,R,m,M,d,b,r,l,N,f,w,v,L,F){let _=null,I=null,V=new u,z=c,C=e,O=N[0]-v[0]-A,p=-1073741824,q=this.k.length-1;do{const X=O+h;X===z||X<C&&d[X-1]<d[X+1]?(r=d[X+1],f=r-O-A,r<p&&V.MarkNextChange(),p=r,V.AddModifiedElement(r+1,f),O=X+1-h):(r=d[X-1]+1,f=r-O-A,r<p&&V.MarkNextChange(),p=r-1,V.AddOriginalElement(r,f+1),O=X-1-h),q>=0&&(d=this.k[q],h=d[0],z=1,C=d.length-1)}while(--q>=-1);if(_=V.getReverseChanges(),F[0]){let X=N[0]+1,B=v[0]+1;if(_!==null&&_.length>0){const J=_[_.length-1];X=Math.max(X,J.getOriginalEnd()),B=Math.max(B,J.getModifiedEnd())}I=[new P.$lu(X,l-X+1,B,w-B+1)]}else{V=new u,z=R,C=m,O=N[0]-v[0]-M,p=1073741824,q=L?this.m.length-1:this.m.length-2;do{const X=O+y;X===z||X<C&&b[X-1]>=b[X+1]?(r=b[X+1]-1,f=r-O-M,r>p&&V.MarkNextChange(),p=r+1,V.AddOriginalElement(r+1,f+1),O=X+1-y):(r=b[X-1],f=r-O-M,r>p&&V.MarkNextChange(),p=r,V.AddModifiedElement(r+1,f+1),O=X-1-y),q>=0&&(b=this.m[q],y=b[0],z=1,C=b.length-1)}while(--q>=-1);I=V.getChanges()}return this.H(_,I)}y(h,c,e,A,y,R,m){let M=0,d=0,b=0,r=0,l=0,N=0;h--,e--,y[0]=0,R[0]=0,this.k=[],this.m=[];const f=c-h+(A-e),w=f+1,v=new Int32Array(w),L=new Int32Array(w),F=A-e,_=c-h,I=h-e,V=c-A,C=(_-F)%2===0;v[F]=h,L[_]=c,m[0]=!1;for(let O=1;O<=f/2+1;O++){let p=0,q=0;b=this.J(F-O,O,F,w),r=this.J(F+O,O,F,w);for(let B=b;B<=r;B+=2){B===b||B<r&&v[B-1]<v[B+1]?M=v[B+1]:M=v[B-1]+1,d=M-(B-F)-I;const J=M;for(;M<c&&d<A&&this.p(M+1,d+1);)M++,d++;if(v[B]=M,M+d>p+q&&(p=M,q=d),!C&&Math.abs(B-_)<=O-1&&M>=L[B])return y[0]=M,R[0]=d,J<=L[B]&&1447>0&&O<=1447+1?this.x(F,b,r,I,_,l,N,V,v,L,M,c,y,d,A,R,C,m):null}const X=(p-h+(q-e)-O)/2;if(this.a!==null&&!this.a(p,X))return m[0]=!0,y[0]=p,R[0]=q,X>0&&1447>0&&O<=1447+1?this.x(F,b,r,I,_,l,N,V,v,L,M,c,y,d,A,R,C,m):(h++,e++,[new P.$lu(h,c-h+1,e,A-e+1)]);l=this.J(_-O,O,_,w),N=this.J(_+O,O,_,w);for(let B=l;B<=N;B+=2){B===l||B<N&&L[B-1]>=L[B+1]?M=L[B+1]-1:M=L[B-1],d=M-(B-_)-V;const J=M;for(;M>h&&d>e&&this.p(M,d);)M--,d--;if(L[B]=M,C&&Math.abs(B-F)<=O&&M<=v[B])return y[0]=M,R[0]=d,J>=v[B]&&1447>0&&O<=1447+1?this.x(F,b,r,I,_,l,N,V,v,L,M,c,y,d,A,R,C,m):null}if(O<=1447){let B=new Int32Array(r-b+2);B[0]=F-b+1,o.Copy2(v,b,B,1,r-b+1),this.k.push(B),B=new Int32Array(N-l+2),B[0]=_-l+1,o.Copy2(L,l,B,1,N-l+1),this.m.push(B)}}return this.x(F,b,r,I,_,l,N,V,v,L,M,c,y,d,A,R,C,m)}z(h){for(let c=0;c<h.length;c++){const e=h[c],A=c<h.length-1?h[c+1].originalStart:this.f.length,y=c<h.length-1?h[c+1].modifiedStart:this.h.length,R=e.originalLength>0,m=e.modifiedLength>0;for(;e.originalStart+e.originalLength<A&&e.modifiedStart+e.modifiedLength<y&&(!R||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!m||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const d=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!d)break;e.originalStart++,e.modifiedStart++}const M=[null];if(c<h.length-1&&this.I(h[c],h[c+1],M)){h[c]=M[0],h.splice(c+1,1),c--;continue}}for(let c=h.length-1;c>=0;c--){const e=h[c];let A=0,y=0;if(c>0){const r=h[c-1];A=r.originalStart+r.originalLength,y=r.modifiedStart+r.modifiedLength}const R=e.originalLength>0,m=e.modifiedLength>0;let M=0,d=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const l=e.originalStart-r,N=e.modifiedStart-r;if(l<A||N<y||R&&!this.s(l,l+e.originalLength)||m&&!this.u(N,N+e.modifiedLength))break;const w=(l===A&&N===y?5:0)+this.G(l,e.originalLength,N,e.modifiedLength);w>d&&(d=w,M=r)}e.originalStart-=M,e.modifiedStart-=M;const b=[null];if(c>0&&this.I(h[c-1],h[c],b)){h[c-1]=b[0],h.splice(c,1),c++;continue}}if(this.d)for(let c=1,e=h.length;c<e;c++){const A=h[c-1],y=h[c],R=y.originalStart-A.originalStart-A.originalLength,m=A.originalStart,M=y.originalStart+y.originalLength,d=M-m,b=A.modifiedStart,r=y.modifiedStart+y.modifiedLength,l=r-b;if(R<5&&d<20&&l<20){const N=this.A(m,d,b,l,R);if(N){const[f,w]=N;(f!==A.originalStart+A.originalLength||w!==A.modifiedStart+A.modifiedLength)&&(A.originalLength=f-A.originalStart,A.modifiedLength=w-A.modifiedStart,y.originalStart=f+R,y.modifiedStart=w+R,y.originalLength=M-y.originalStart,y.modifiedLength=r-y.modifiedStart)}}}return h}A(h,c,e,A,y){if(c<y||A<y)return null;const R=h+c-y+1,m=e+A-y+1;let M=0,d=0,b=0;for(let r=h;r<R;r++)for(let l=e;l<m;l++){const N=this.B(r,l,y);N>0&&N>M&&(M=N,d=r,b=l)}return M>0?[d,b]:null}B(h,c,e){let A=0;for(let y=0;y<e;y++){if(!this.p(h+y,c+y))return 0;A+=this.e[h+y].length}return A}C(h){return h<=0||h>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[h])}D(h,c){if(this.C(h)||this.C(h-1))return!0;if(c>0){const e=h+c;if(this.C(e-1)||this.C(e))return!0}return!1}E(h){return h<=0||h>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[h])}F(h,c){if(this.E(h)||this.E(h-1))return!0;if(c>0){const e=h+c;if(this.E(e-1)||this.E(e))return!0}return!1}G(h,c,e,A){const y=this.D(h,c)?1:0,R=this.F(e,A)?1:0;return y+R}H(h,c){const e=[];if(h.length===0||c.length===0)return c.length>0?c:h;if(this.I(h[h.length-1],c[0],e)){const A=new Array(h.length+c.length-1);return o.Copy(h,0,A,0,h.length-1),A[h.length-1]=e[0],o.Copy(c,1,A,h.length,c.length-1),A}else{const A=new Array(h.length+c.length);return o.Copy(h,0,A,0,h.length),o.Copy(c,0,A,h.length,c.length),A}}I(h,c,e){if($.Assert(h.originalStart<=c.originalStart,"Left change is not less than or equal to right change"),$.Assert(h.modifiedStart<=c.modifiedStart,"Left change is not less than or equal to right change"),h.originalStart+h.originalLength>=c.originalStart||h.modifiedStart+h.modifiedLength>=c.modifiedStart){const A=h.originalStart;let y=h.originalLength;const R=h.modifiedStart;let m=h.modifiedLength;return h.originalStart+h.originalLength>=c.originalStart&&(y=c.originalStart+c.originalLength-h.originalStart),h.modifiedStart+h.modifiedLength>=c.modifiedStart&&(m=c.modifiedStart+c.modifiedLength-h.modifiedStart),e[0]=new P.$lu(A,y,R,m),!0}else return e[0]=null,!1}J(h,c,e,A){if(h>=0&&h<A)return h;const y=e,R=A-e-1,m=c%2===0;if(h<0){const M=y%2===0;return m===M?0:1}else{const M=R%2===0;return m===M?A-1:A-2}}}t.$ou=g}),Z(K[22],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ce=t.$Be=t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=void 0;function P(l){return typeof l=="string"}t.$je=P;function k(l){return Array.isArray(l)&&l.every(N=>P(N))}t.$ke=k;function i(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}t.$le=i;function a(l){const N=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof N}t.$me=a;function $(l){return typeof l=="number"&&!isNaN(l)}t.$ne=$;function o(l){return!!l&&typeof l[Symbol.iterator]=="function"}t.$oe=o;function s(l){return l===!0||l===!1}t.$pe=s;function u(l){return typeof l>"u"}t.$qe=u;function g(l){return!E(l)}t.$re=g;function E(l){return u(l)||l===null}t.$se=E;function h(l,N){if(!l)throw new Error(N?`Unexpected type, expected '${N}'`:"Unexpected type")}t.$te=h;function c(l){if(E(l))throw new Error("Assertion Failed: argument is undefined or null");return l}t.$ue=c;function e(...l){const N=[];for(let f=0;f<l.length;f++){const w=l[f];if(E(w))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);N.push(w)}return N}t.$ve=e;const A=Object.prototype.hasOwnProperty;function y(l){if(!i(l))return!1;for(const N in l)if(A.call(l,N))return!1;return!0}t.$we=y;function R(l){return typeof l=="function"}t.$xe=R;function m(...l){return l.length>0&&l.every(R)}t.$ye=m;function M(l,N){const f=Math.min(l.length,N.length);for(let w=0;w<f;w++)d(l[w],N[w])}t.$ze=M;function d(l,N){if(P(N)){if(typeof l!==N)throw new Error(`argument does not match constraint: typeof ${N}`)}else if(R(N)){try{if(l instanceof N)return}catch{}if(!E(l)&&l.constructor===N||N.length===1&&N.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Ae=d;function b(l){return l===null?void 0:l}t.$Be=b;function r(l){return typeof l>"u"?null:l}t.$Ce=r}),Z(K[35],ne([0,1,22]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cj=t.$Bj=t.$Aj=void 0;const k=Object.create(null);function i(o,s){if((0,P.$je)(s)){const u=k[s];if(u===void 0)throw new Error(`${o} references an unknown codicon: ${s}`);s=u}return k[o]=s,{id:o}}function a(){return k}t.$Aj=a;function $(){return Object.values(t.$Cj)}t.$Bj=$,t.$Cj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),Z(K[11],ne([0,1,22]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sm=t.$Rm=t.$Qm=t.$Pm=t.$Om=t.$Nm=t.$Mm=t.$Lm=t.$Km=t.$Jm=t.$Im=t.$Hm=void 0;function k(R){if(!R||typeof R!="object"||R instanceof RegExp)return R;const m=Array.isArray(R)?[]:{};return Object.entries(R).forEach(([M,d])=>{m[M]=d&&typeof d=="object"?k(d):d}),m}t.$Hm=k;function i(R){if(!R||typeof R!="object")return R;const m=[R];for(;m.length>0;){const M=m.shift();Object.freeze(M);for(const d in M)if(a.call(M,d)){const b=M[d];typeof b=="object"&&!Object.isFrozen(b)&&!(0,P.$me)(b)&&m.push(b)}}return R}t.$Im=i;const a=Object.prototype.hasOwnProperty;function $(R,m){return o(R,m,new Set)}t.$Jm=$;function o(R,m,M){if((0,P.$se)(R))return R;const d=m(R);if(typeof d<"u")return d;if(Array.isArray(R)){const b=[];for(const r of R)b.push(o(r,m,M));return b}if((0,P.$le)(R)){if(M.has(R))throw new Error("Cannot clone recursive data-structure");M.add(R);const b={};for(const r in R)a.call(R,r)&&(b[r]=o(R[r],m,M));return M.delete(R),b}return R}function s(R,m,M=!0){return(0,P.$le)(R)?((0,P.$le)(m)&&Object.keys(m).forEach(d=>{d in R?M&&((0,P.$le)(R[d])&&(0,P.$le)(m[d])?s(R[d],m[d],M):R[d]=m[d]):R[d]=m[d]}),R):m}t.$Km=s;function u(R,m){if(R===m)return!0;if(R==null||m===null||m===void 0||typeof R!=typeof m||typeof R!="object"||Array.isArray(R)!==Array.isArray(m))return!1;let M,d;if(Array.isArray(R)){if(R.length!==m.length)return!1;for(M=0;M<R.length;M++)if(!u(R[M],m[M]))return!1}else{const b=[];for(d in R)b.push(d);b.sort();const r=[];for(d in m)r.push(d);if(r.sort(),!u(b,r))return!1;for(M=0;M<b.length;M++)if(!u(R[b[M]],m[b[M]]))return!1}return!0}t.$Lm=u;function g(R){const m=new Set;return JSON.stringify(R,(M,d)=>{if((0,P.$le)(d)||Array.isArray(d)){if(m.has(d))return"[Circular]";m.add(d)}return d})}t.$Mm=g;function E(R,m){const M=Object.create(null);return!R||!m||Object.keys(m).forEach(b=>{const r=R[b],l=m[b];u(r,l)||(M[b]=l)}),M}t.$Nm=E;function h(R,m){const M=m.toLowerCase(),d=Object.keys(R).find(b=>b.toLowerCase()===M);return d?R[d]:R[m]}t.$Om=h;function c(R,m){const M=Object.create(null);for(const[d,b]of Object.entries(R))m(d,b)&&(M[d]=b);return M}t.$Pm=c;function e(R){let m=[];for(;Object.prototype!==R;)m=m.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return m}t.$Qm=e;function A(R){const m=[];for(const M of e(R))typeof R[M]=="function"&&m.push(M);return m}t.$Rm=A;function y(R,m){const M=b=>function(){const r=Array.prototype.slice.call(arguments,0);return m(b,r)},d={};for(const b of R)d[b]=M(b);return d}t.$Sm=y}),Z(K[23],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jd=t.$id=t.Constants=void 0;var P;(function(a){a[a.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",a[a.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",a[a.MAX_UINT_8=255]="MAX_UINT_8",a[a.MAX_UINT_16=65535]="MAX_UINT_16",a[a.MAX_UINT_32=4294967295]="MAX_UINT_32",a[a.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P||(t.Constants=P={}));function k(a){return a<0?0:a>255?255:a|0}t.$id=k;function i(a){return a<0?0:a>4294967295?4294967295:a|0}t.$jd=i}),Z(K[24],ne([0,1,23]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4r=t.$3r=void 0;class k{constructor(o){const s=(0,P.$id)(o);this.c=s,this.a=k.d(s),this.b=new Map}static d(o){const s=new Uint8Array(256);return s.fill(o),s}set(o,s){const u=(0,P.$id)(s);o>=0&&o<256?this.a[o]=u:this.b.set(o,u)}get(o){return o>=0&&o<256?this.a[o]:this.b.get(o)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$3r=k;var i;(function($){$[$.False=0]="False",$[$.True=1]="True"})(i||(i={}));class a{constructor(){this.a=new k(0)}add(o){this.a.set(o,1)}has(o){return this.a.get(o)===1}clear(){return this.a.clear()}}t.$4r=a}),Z(K[6],ne([0,1,3]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dC=void 0;class k{static addRange(a,$){let o=0;for(;o<$.length&&$[o].endExclusive<a.start;)o++;let s=o;for(;s<$.length&&$[s].start<=a.endExclusive;)s++;if(o===s)$.splice(o,0,a);else{const u=Math.min(a.start,$[o].start),g=Math.max(a.endExclusive,$[s-1].endExclusive);$.splice(o,s-o,new k(u,g))}}static tryCreate(a,$){if(!(a>$))return new k(a,$)}constructor(a,$){if(this.start=a,this.endExclusive=$,a>$)throw new P.$bb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(a){return new k(this.start+a,this.endExclusive+a)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(a){return this.start===a.start&&this.endExclusive===a.endExclusive}containsRange(a){return this.start<=a.start&&a.endExclusive<=this.endExclusive}contains(a){return this.start<=a&&a<this.endExclusive}join(a){return new k(Math.min(this.start,a.start),Math.max(this.endExclusive,a.endExclusive))}intersect(a){const $=Math.max(this.start,a.start),o=Math.min(this.endExclusive,a.endExclusive);if($<=o)return new k($,o)}}t.$dC=k}),Z(K[4],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nr=void 0;class P{constructor(i,a){this.lineNumber=i,this.column=a}with(i=this.lineNumber,a=this.column){return i===this.lineNumber&&a===this.column?this:new P(i,a)}delta(i=0,a=0){return this.with(this.lineNumber+i,this.column+a)}equals(i){return P.equals(this,i)}static equals(i,a){return!i&&!a?!0:!!i&&!!a&&i.lineNumber===a.lineNumber&&i.column===a.column}isBefore(i){return P.isBefore(this,i)}static isBefore(i,a){return i.lineNumber<a.lineNumber?!0:a.lineNumber<i.lineNumber?!1:i.column<a.column}isBeforeOrEqual(i){return P.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,a){return i.lineNumber<a.lineNumber?!0:a.lineNumber<i.lineNumber?!1:i.column<=a.column}static compare(i,a){const $=i.lineNumber|0,o=a.lineNumber|0;if($===o){const s=i.column|0,u=a.column|0;return s-u}return $-o}clone(){return new P(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new P(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.$Nr=P}),Z(K[2],ne([0,1,4]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Or=void 0;class k{constructor(a,$,o,s){a>o||a===o&&$>s?(this.startLineNumber=o,this.startColumn=s,this.endLineNumber=a,this.endColumn=$):(this.startLineNumber=a,this.startColumn=$,this.endLineNumber=o,this.endColumn=s)}isEmpty(){return k.isEmpty(this)}static isEmpty(a){return a.startLineNumber===a.endLineNumber&&a.startColumn===a.endColumn}containsPosition(a){return k.containsPosition(this,a)}static containsPosition(a,$){return!($.lineNumber<a.startLineNumber||$.lineNumber>a.endLineNumber||$.lineNumber===a.startLineNumber&&$.column<a.startColumn||$.lineNumber===a.endLineNumber&&$.column>a.endColumn)}static strictContainsPosition(a,$){return!($.lineNumber<a.startLineNumber||$.lineNumber>a.endLineNumber||$.lineNumber===a.startLineNumber&&$.column<=a.startColumn||$.lineNumber===a.endLineNumber&&$.column>=a.endColumn)}containsRange(a){return k.containsRange(this,a)}static containsRange(a,$){return!($.startLineNumber<a.startLineNumber||$.endLineNumber<a.startLineNumber||$.startLineNumber>a.endLineNumber||$.endLineNumber>a.endLineNumber||$.startLineNumber===a.startLineNumber&&$.startColumn<a.startColumn||$.endLineNumber===a.endLineNumber&&$.endColumn>a.endColumn)}strictContainsRange(a){return k.strictContainsRange(this,a)}static strictContainsRange(a,$){return!($.startLineNumber<a.startLineNumber||$.endLineNumber<a.startLineNumber||$.startLineNumber>a.endLineNumber||$.endLineNumber>a.endLineNumber||$.startLineNumber===a.startLineNumber&&$.startColumn<=a.startColumn||$.endLineNumber===a.endLineNumber&&$.endColumn>=a.endColumn)}plusRange(a){return k.plusRange(this,a)}static plusRange(a,$){let o,s,u,g;return $.startLineNumber<a.startLineNumber?(o=$.startLineNumber,s=$.startColumn):$.startLineNumber===a.startLineNumber?(o=$.startLineNumber,s=Math.min($.startColumn,a.startColumn)):(o=a.startLineNumber,s=a.startColumn),$.endLineNumber>a.endLineNumber?(u=$.endLineNumber,g=$.endColumn):$.endLineNumber===a.endLineNumber?(u=$.endLineNumber,g=Math.max($.endColumn,a.endColumn)):(u=a.endLineNumber,g=a.endColumn),new k(o,s,u,g)}intersectRanges(a){return k.intersectRanges(this,a)}static intersectRanges(a,$){let o=a.startLineNumber,s=a.startColumn,u=a.endLineNumber,g=a.endColumn;const E=$.startLineNumber,h=$.startColumn,c=$.endLineNumber,e=$.endColumn;return o<E?(o=E,s=h):o===E&&(s=Math.max(s,h)),u>c?(u=c,g=e):u===c&&(g=Math.min(g,e)),o>u||o===u&&s>g?null:new k(o,s,u,g)}equalsRange(a){return k.equalsRange(this,a)}static equalsRange(a,$){return!a&&!$?!0:!!a&&!!$&&a.startLineNumber===$.startLineNumber&&a.startColumn===$.startColumn&&a.endLineNumber===$.endLineNumber&&a.endColumn===$.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(a){return new P.$Nr(a.endLineNumber,a.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(a){return new P.$Nr(a.startLineNumber,a.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(a,$){return new k(this.startLineNumber,this.startColumn,a,$)}setStartPosition(a,$){return new k(a,$,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(a){return new k(a.startLineNumber,a.startColumn,a.startLineNumber,a.startColumn)}collapseToEnd(){return k.collapseToEnd(this)}static collapseToEnd(a){return new k(a.endLineNumber,a.endColumn,a.endLineNumber,a.endColumn)}delta(a){return new k(this.startLineNumber+a,this.startColumn,this.endLineNumber+a,this.endColumn)}static fromPositions(a,$=a){return new k(a.lineNumber,a.column,$.lineNumber,$.column)}static lift(a){return a?new k(a.startLineNumber,a.startColumn,a.endLineNumber,a.endColumn):null}static isIRange(a){return a&&typeof a.startLineNumber=="number"&&typeof a.startColumn=="number"&&typeof a.endLineNumber=="number"&&typeof a.endColumn=="number"}static areIntersectingOrTouching(a,$){return!(a.endLineNumber<$.startLineNumber||a.endLineNumber===$.startLineNumber&&a.endColumn<$.startColumn||$.endLineNumber<a.startLineNumber||$.endLineNumber===a.startLineNumber&&$.endColumn<a.startColumn)}static areIntersecting(a,$){return!(a.endLineNumber<$.startLineNumber||a.endLineNumber===$.startLineNumber&&a.endColumn<=$.startColumn||$.endLineNumber<a.startLineNumber||$.endLineNumber===a.startLineNumber&&$.endColumn<=a.startColumn)}static compareRangesUsingStarts(a,$){if(a&&$){const u=a.startLineNumber|0,g=$.startLineNumber|0;if(u===g){const E=a.startColumn|0,h=$.startColumn|0;if(E===h){const c=a.endLineNumber|0,e=$.endLineNumber|0;if(c===e){const A=a.endColumn|0,y=$.endColumn|0;return A-y}return c-e}return E-h}return u-g}return(a?1:0)-($?1:0)}static compareRangesUsingEnds(a,$){return a.endLineNumber===$.endLineNumber?a.endColumn===$.endColumn?a.startLineNumber===$.startLineNumber?a.startColumn-$.startColumn:a.startLineNumber-$.startLineNumber:a.endColumn-$.endColumn:a.endLineNumber-$.endLineNumber}static spansMultipleLines(a){return a.endLineNumber>a.startLineNumber}toJSON(){return this}}t.$Or=k}),Z(K[36],ne([0,1,2]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vr=void 0;class k{static insert(a,$){return{range:new P.$Or(a.lineNumber,a.column,a.lineNumber,a.column),text:$,forceMoveMarkers:!0}}static delete(a){return{range:a,text:null}}static replace(a,$){return{range:a,text:$}}static replaceMove(a,$){return{range:a,text:$,forceMoveMarkers:!0}}}t.$Vr=k}),Z(K[12],ne([0,1,3,2]),function(H,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pr=void 0;class i{static fromRange($){return new i($.startLineNumber,$.endLineNumber)}static subtract($,o){return o?$.startLineNumber<o.startLineNumber&&o.endLineNumberExclusive<$.endLineNumberExclusive?[new i($.startLineNumber,o.startLineNumber),new i(o.endLineNumberExclusive,$.endLineNumberExclusive)]:o.startLineNumber<=$.startLineNumber&&$.endLineNumberExclusive<=o.endLineNumberExclusive?[]:o.endLineNumberExclusive<$.endLineNumberExclusive?[new i(Math.max(o.endLineNumberExclusive,$.startLineNumber),$.endLineNumberExclusive)]:[new i($.startLineNumber,Math.min(o.startLineNumber,$.endLineNumberExclusive))]:[$]}static joinMany($){if($.length===0)return[];let o=$[0];for(let s=1;s<$.length;s++)o=this.join(o,$[s]);return o}static join($,o){if($.length===0)return o;if(o.length===0)return $;const s=[];let u=0,g=0,E=null;for(;u<$.length||g<o.length;){let h=null;if(u<$.length&&g<o.length){const c=$[u],e=o[g];c.startLineNumber<e.startLineNumber?(h=c,u++):(h=e,g++)}else u<$.length?(h=$[u],u++):(h=o[g],g++);E===null?E=h:E.endLineNumberExclusive>=h.startLineNumber?E=new i(E.startLineNumber,Math.max(E.endLineNumberExclusive,h.endLineNumberExclusive)):(s.push(E),E=h)}return E!==null&&s.push(E),s}static ofLength($,o){return new i($,$+o)}static deserialize($){return new i($[0],$[1])}constructor($,o){if($>o)throw new P.$bb(`startLineNumber ${$} cannot be after endLineNumberExclusive ${o}`);this.startLineNumber=$,this.endLineNumberExclusive=o}contains($){return this.startLineNumber<=$&&$<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta($){return new i(this.startLineNumber+$,this.endLineNumberExclusive+$)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join($){return new i(Math.min(this.startLineNumber,$.startLineNumber),Math.max(this.endLineNumberExclusive,$.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect($){const o=Math.max(this.startLineNumber,$.startLineNumber),s=Math.min(this.endLineNumberExclusive,$.endLineNumberExclusive);if(o<=s)return new i(o,s)}intersectsStrict($){return this.startLineNumber<$.endLineNumberExclusive&&$.startLineNumber<this.endLineNumberExclusive}overlapOrTouch($){return this.startLineNumber<=$.endLineNumberExclusive&&$.startLineNumber<=this.endLineNumberExclusive}equals($){return this.startLineNumber===$.startLineNumber&&this.endLineNumberExclusive===$.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new k.$Or(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new k.$Or(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray($){const o=[];for(let s=this.startLineNumber;s<this.endLineNumberExclusive;s++)o.push($(s));return o}forEach($){for(let o=this.startLineNumber;o<this.endLineNumberExclusive;o++)$(o)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes($){return this.startLineNumber<=$&&$<this.endLineNumberExclusive}}t.$Pr=i}),Z(K[37],ne([0,1,4,2]),function(H,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wr=t.SelectionDirection=void 0;var i;(function($){$[$.LTR=0]="LTR",$[$.RTL=1]="RTL"})(i||(t.SelectionDirection=i={}));class a extends k.$Or{constructor(o,s,u,g){super(o,s,u,g),this.selectionStartLineNumber=o,this.selectionStartColumn=s,this.positionLineNumber=u,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(o){return a.selectionsEqual(this,o)}static selectionsEqual(o,s){return o.selectionStartLineNumber===s.selectionStartLineNumber&&o.selectionStartColumn===s.selectionStartColumn&&o.positionLineNumber===s.positionLineNumber&&o.positionColumn===s.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(o,s){return this.getDirection()===0?new a(this.startLineNumber,this.startColumn,o,s):new a(o,s,this.startLineNumber,this.startColumn)}getPosition(){return new P.$Nr(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new P.$Nr(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(o,s){return this.getDirection()===0?new a(o,s,this.endLineNumber,this.endColumn):new a(this.endLineNumber,this.endColumn,o,s)}static fromPositions(o,s=o){return new a(o.lineNumber,o.column,s.lineNumber,s.column)}static fromRange(o,s){return s===0?new a(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):new a(o.endLineNumber,o.endColumn,o.startLineNumber,o.startColumn)}static liftSelection(o){return new a(o.selectionStartLineNumber,o.selectionStartColumn,o.positionLineNumber,o.positionColumn)}static selectionsArrEqual(o,s){if(o&&!s||!o&&s)return!1;if(!o&&!s)return!0;if(o.length!==s.length)return!1;for(let u=0,g=o.length;u<g;u++)if(!this.selectionsEqual(o[u],s[u]))return!1;return!0}static isISelection(o){return o&&typeof o.selectionStartLineNumber=="number"&&typeof o.selectionStartColumn=="number"&&typeof o.positionLineNumber=="number"&&typeof o.positionColumn=="number"}static createWithDirection(o,s,u,g,E){return E===0?new a(o,s,u,g):new a(u,g,o,s)}}t.$Wr=a}),Z(K[38],ne([0,1,24]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6r=t.$5r=t.WordCharacterClass=void 0;var k;(function($){$[$.Regular=0]="Regular",$[$.Whitespace=1]="Whitespace",$[$.WordSeparator=2]="WordSeparator"})(k||(t.WordCharacterClass=k={}));class i extends P.$3r{constructor(o){super(0);for(let s=0,u=o.length;s<u;s++)this.set(o.charCodeAt(s),2);this.set(32,1),this.set(9,1)}}t.$5r=i;function a($){const o={};return s=>(o.hasOwnProperty(s)||(o[s]=$(s)),o[s])}t.$6r=a($=>new i($))}),Z(K[25],ne([0,1,17,7,18]),function(H,t,P,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mr=t.$Lr=t.$Kr=t.$Jr=t.$Ir=void 0,t.$Ir="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function a(E=""){let h="(-?\\d*\\.\\d\\w*)|([^";for(const c of t.$Ir)E.indexOf(c)>=0||(h+="\\"+c);return h+="\\s]+)",new RegExp(h,"g")}t.$Jr=a();function $(E){let h=t.$Jr;if(E&&E instanceof RegExp)if(E.global)h=E;else{let c="g";E.ignoreCase&&(c+="i"),E.multiline&&(c+="m"),E.unicode&&(c+="u"),h=new RegExp(E.source,c)}return h.lastIndex=0,h}t.$Kr=$;const o=new i.$lc;o.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function s(E){const h=o.unshift(E);return(0,k.$jb)(h)}t.$Lr=s;function u(E,h,c,e,A){if(A||(A=P.Iterable.first(o)),c.length>A.maxLen){let d=E-A.maxLen/2;return d<0?d=0:e+=d,c=c.substring(d,E+A.maxLen/2),u(E,h,c,e,A)}const y=Date.now(),R=E-1-e;let m=-1,M=null;for(let d=1;!(Date.now()-y>=A.timeBudget);d++){const b=R-A.windowSize*d;h.lastIndex=Math.max(0,b);const r=g(h,c,R,m);if(!r&&M||(M=r,b<=0))break;m=b}if(M){const d={word:M[0],startColumn:e+1+M.index,endColumn:e+1+M.index+M[0].length};return h.lastIndex=0,d}return null}t.$Mr=u;function g(E,h,c,e){let A;for(;A=E.exec(h);){const y=A.index||0;if(y<=c&&E.lastIndex>=c)return A;if(e>0&&y>e)return null}return null}}),Z(K[9],ne([0,1,3,6]),function(H,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hX=t.$gX=t.$fX=t.$eX=void 0;class i{static trivial(u,g){return new i([new a(new k.$dC(0,u.length),new k.$dC(0,g.length))],!1)}static trivialTimedOut(u,g){return new i([new a(new k.$dC(0,u.length),new k.$dC(0,g.length))],!0)}constructor(u,g){this.diffs=u,this.hitTimeout=g}}t.$eX=i;class a{constructor(u,g){this.seq1Range=u,this.seq2Range=g}reverse(){return new a(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(u){return new a(this.seq1Range.join(u.seq1Range),this.seq2Range.join(u.seq2Range))}delta(u){return u===0?this:new a(this.seq1Range.delta(u),this.seq2Range.delta(u))}}t.$fX=a;class ${static{this.instance=new $}isValid(){return!0}}t.$gX=$;class o{constructor(u){if(this.c=u,this.a=Date.now(),this.b=!0,u<=0)throw new P.$bb("timeout must be positive")}isValid(){if(!(Date.now()-this.a<this.c)&&this.b){this.b=!1;debugger}return this.b}disable(){this.c=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.b=!0}}t.$hX=o}),Z(K[39],ne([0,1,6,9]),function(H,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pX=t.$oX=t.$nX=t.$mX=t.$lX=t.$kX=void 0;function i(E,h,c){let e=c;return e=s(E,h,e),e=u(E,h,e),e}t.$kX=i;function a(E,h,c){const e=[];for(const A of c){const y=e[e.length-1];if(!y){e.push(A);continue}A.seq1Range.start-y.seq1Range.endExclusive<=2||A.seq2Range.start-y.seq2Range.endExclusive<=2?e[e.length-1]=new k.$fX(y.seq1Range.join(A.seq1Range),y.seq2Range.join(A.seq2Range)):e.push(A)}return e}t.$lX=a;function $(E,h,c){let e=c;if(e.length===0)return e;let A=0,y;do{y=!1;const R=[e[0]];for(let m=1;m<e.length;m++){let b=function(l,N){const f=new P.$dC(d.seq1Range.endExclusive,M.seq1Range.start);return E.getText(f).replace(/\s/g,"").length<=4&&(l.seq1Range.length+l.seq2Range.length>5||N.seq1Range.length+N.seq2Range.length>5)};const M=e[m],d=R[R.length-1];b(d,M)?(y=!0,R[R.length-1]=R[R.length-1].join(M)):R.push(M)}e=R}while(A++<10&&y);return e}t.$mX=$;function o(E,h,c){let e=c;if(e.length===0)return e;let A=0,y;do{y=!1;const R=[e[0]];for(let m=1;m<e.length;m++){let b=function(l,N){const f=new P.$dC(d.seq1Range.endExclusive,M.seq1Range.start);if(E.countLinesIn(f)>5||f.length>500)return!1;const v=E.getText(f).trim();if(v.length>20||v.split(/\r\n|\r|\n/).length>1)return!1;const L=E.countLinesIn(l.seq1Range),F=l.seq1Range.length,_=h.countLinesIn(l.seq2Range),I=l.seq2Range.length,V=E.countLinesIn(N.seq1Range),z=N.seq1Range.length,C=h.countLinesIn(N.seq2Range),O=N.seq2Range.length,p=2*40+50;function q(X){return Math.min(X,p)}return Math.pow(Math.pow(q(L*40+F),1.5)+Math.pow(q(_*40+I),1.5),1.5)+Math.pow(Math.pow(q(V*40+z),1.5)+Math.pow(q(C*40+O),1.5),1.5)>(p**1.5)**1.5*1.3};const M=e[m],d=R[R.length-1];b(d,M)?(y=!0,R[R.length-1]=R[R.length-1].join(M)):R.push(M)}e=R}while(A++<10&&y);return e}t.$nX=o;function s(E,h,c){if(c.length===0)return c;const e=[];e.push(c[0]);for(let y=1;y<c.length;y++){const R=e[e.length-1];let m=c[y];if(m.seq1Range.isEmpty||m.seq2Range.isEmpty){const M=m.seq1Range.start-R.seq1Range.endExclusive;let d;for(d=1;d<=M&&!(E.getElement(m.seq1Range.start-d)!==E.getElement(m.seq1Range.endExclusive-d)||h.getElement(m.seq2Range.start-d)!==h.getElement(m.seq2Range.endExclusive-d));d++);if(d--,d===M){e[e.length-1]=new k.$fX(new P.$dC(R.seq1Range.start,m.seq1Range.endExclusive-M),new P.$dC(R.seq2Range.start,m.seq2Range.endExclusive-M));continue}m=m.delta(-d)}e.push(m)}const A=[];for(let y=0;y<e.length-1;y++){const R=e[y+1];let m=e[y];if(m.seq1Range.isEmpty||m.seq2Range.isEmpty){const M=R.seq1Range.start-m.seq1Range.endExclusive;let d;for(d=0;d<M&&!(E.getElement(m.seq1Range.start+d)!==E.getElement(m.seq1Range.endExclusive+d)||h.getElement(m.seq2Range.start+d)!==h.getElement(m.seq2Range.endExclusive+d));d++);if(d===M){e[y+1]=new k.$fX(new P.$dC(m.seq1Range.start+M,R.seq1Range.endExclusive),new P.$dC(m.seq2Range.start+M,R.seq2Range.endExclusive));continue}d>0&&(m=m.delta(d))}A.push(m)}return e.length>0&&A.push(e[e.length-1]),A}t.$oX=s;function u(E,h,c){if(!E.getBoundaryScore||!h.getBoundaryScore)return c;for(let e=0;e<c.length;e++){const A=e>0?c[e-1]:void 0,y=c[e],R=e+1<c.length?c[e+1]:void 0,m=new P.$dC(A?A.seq1Range.start+1:0,R?R.seq1Range.endExclusive-1:E.length),M=new P.$dC(A?A.seq2Range.start+1:0,R?R.seq2Range.endExclusive-1:h.length);y.seq1Range.isEmpty?c[e]=g(y,E,h,m,M):y.seq2Range.isEmpty&&(c[e]=g(y.reverse(),h,E,M,m).reverse())}return c}t.$pX=u;function g(E,h,c,e,A){let R=1;for(;E.seq1Range.start-R>=e.start&&E.seq2Range.start-R>=A.start&&c.isStronglyEqual(E.seq2Range.start-R,E.seq2Range.endExclusive-R)&&R<100;)R++;R--;let m=0;for(;E.seq1Range.start+m<e.endExclusive&&E.seq2Range.endExclusive+m<A.endExclusive&&c.isStronglyEqual(E.seq2Range.start+m,E.seq2Range.endExclusive+m)&&m<100;)m++;if(R===0&&m===0)return E;let M=0,d=-1;for(let b=-R;b<=m;b++){const r=E.seq2Range.start+b,l=E.seq2Range.endExclusive+b,N=E.seq1Range.start+b,f=h.getBoundaryScore(N)+c.getBoundaryScore(r)+c.getBoundaryScore(l);f>d&&(d=f,M=b)}return E.delta(M)}}),Z(K[40],ne([0,1,6,9]),function(H,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qX=void 0;class i{compute(u,g,E=k.$gX.instance){if(u.length===0||g.length===0)return k.$eX.trivial(u,g);function h(b,r){for(;b<u.length&&r<g.length&&u.getElement(b)===g.getElement(r);)b++,r++;return b}let c=0;const e=new $;e.set(0,h(0,0));const A=new o;A.set(0,e.get(0)===0?null:new a(null,0,0,e.get(0)));let y=0;e:for(;;){if(c++,!E.isValid())return k.$eX.trivialTimedOut(u,g);const b=-Math.min(c,g.length+c%2),r=Math.min(c,u.length+c%2);for(y=b;y<=r;y+=2){const l=y===r?-1:e.get(y+1),N=y===b?-1:e.get(y-1)+1,f=Math.min(Math.max(l,N),u.length),w=f-y;if(f>u.length||w>g.length)continue;const v=h(f,w);e.set(y,v);const L=f===l?A.get(y+1):A.get(y-1);if(A.set(y,v!==f?new a(L,f,w,v-f):L),e.get(y)===u.length&&e.get(y)-y===g.length)break e}}let R=A.get(y);const m=[];let M=u.length,d=g.length;for(;;){const b=R?R.x+R.length:0,r=R?R.y+R.length:0;if((b!==M||r!==d)&&m.push(new k.$fX(new P.$dC(b,M),new P.$dC(r,d))),!R)break;M=R.x,d=R.y,R=R.prev}return m.reverse(),new k.$eX(m,!1)}}t.$qX=i;class a{constructor(u,g,E,h){this.prev=u,this.x=g,this.y=E,this.length=h}}class ${constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,g){if(u<0){if(u=-u-1,u>=this.b.length){const E=this.b;this.b=new Int32Array(E.length*2),this.b.set(E)}this.b[u]=g}else{if(u>=this.a.length){const E=this.a;this.a=new Int32Array(E.length*2),this.a.set(E)}this.a[u]=g}}}class o{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,g){u<0?(u=-u-1,this.b[u]=g):this.a[u]=g}}}),Z(K[41],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iX=void 0;class P{constructor(i,a){this.width=i,this.height=a,this.a=[],this.a=new Array(i*a)}get(i,a){return this.a[i+a*this.width]}set(i,a,$){this.a[i+a*this.width]=$}}t.$iX=P}),Z(K[42],ne([0,1,6,9,41]),function(H,t,P,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jX=void 0;class a{compute(o,s,u=k.$gX.instance,g){if(o.length===0||s.length===0)return k.$eX.trivial(o,s);const E=new i.$iX(o.length,s.length),h=new i.$iX(o.length,s.length),c=new i.$iX(o.length,s.length);for(let d=0;d<o.length;d++)for(let b=0;b<s.length;b++){if(!u.isValid())return k.$eX.trivialTimedOut(o,s);const r=d===0?0:E.get(d-1,b),l=b===0?0:E.get(d,b-1);let N;o.getElement(d)===s.getElement(b)?(d===0||b===0?N=0:N=E.get(d-1,b-1),d>0&&b>0&&h.get(d-1,b-1)===3&&(N+=c.get(d-1,b-1)),N+=g?g(d,b):1):N=-1;const f=Math.max(r,l,N);if(f===N){const w=d>0&&b>0?c.get(d-1,b-1):0;c.set(d,b,w+1),h.set(d,b,3)}else f===r?(c.set(d,b,0),h.set(d,b,1)):f===l&&(c.set(d,b,0),h.set(d,b,2));E.set(d,b,f)}const e=[];let A=o.length,y=s.length;function R(d,b){(d+1!==A||b+1!==y)&&e.push(new k.$fX(new P.$dC(d+1,A),new P.$dC(b+1,y))),A=d,y=b}let m=o.length-1,M=s.length-1;for(;m>=0&&M>=0;)h.get(m,M)===3?(R(m,M),m--,M--):h.get(m,M)===1?m--:M--;return R(-1,-1),e.reverse(),new k.$eX(e,!1)}}t.$jX=a}),Z(K[26],ne([0,1,12]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ur=t.$Tr=t.$Sr=t.$Rr=t.$Qr=void 0;class k{constructor(u,g,E){this.changes=u,this.moves=g,this.hitTimeout=E}}t.$Qr=k;class i{static inverse(u,g,E){const h=[];let c=1,e=1;for(const y of u){const R=new i(new P.$Pr(c,y.originalRange.startLineNumber),new P.$Pr(e,y.modifiedRange.startLineNumber),void 0);R.modifiedRange.isEmpty||h.push(R),c=y.originalRange.endLineNumberExclusive,e=y.modifiedRange.endLineNumberExclusive}const A=new i(new P.$Pr(c,g+1),new P.$Pr(e,E+1),void 0);return A.modifiedRange.isEmpty||h.push(A),h}constructor(u,g,E){this.originalRange=u,this.modifiedRange=g,this.innerChanges=E}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}flip(){return new i(this.modifiedRange,this.originalRange,this.innerChanges?.map(u=>u.flip()))}}t.$Rr=i;class a{constructor(u,g){this.originalRange=u,this.modifiedRange=g}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new a(this.modifiedRange,this.originalRange)}}t.$Sr=a;class ${constructor(u,g){this.original=u,this.modified=g}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new $(this.modified,this.original)}}t.$Tr=$;class o{constructor(u,g){this.lineRangeMapping=u,this.changes=g}flip(){return new o(this.lineRangeMapping.flip(),this.changes.map(u=>u.flip()))}}t.$Ur=o}),Z(K[27],ne([0,1,21,26,5,2,10,12]),function(H,t,P,k,i,a,$,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qu=t.$pu=void 0;const s=3;class u{computeDiff(b,r,l){const f=new y(b,r,{maxComputationTime:l.maxComputationTimeMs,shouldIgnoreTrimWhitespace:l.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),w=[];let v=null;for(const L of f.changes){let F;L.originalEndLineNumber===0?F=new o.$Pr(L.originalStartLineNumber+1,L.originalStartLineNumber+1):F=new o.$Pr(L.originalStartLineNumber,L.originalEndLineNumber+1);let _;L.modifiedEndLineNumber===0?_=new o.$Pr(L.modifiedStartLineNumber+1,L.modifiedStartLineNumber+1):_=new o.$Pr(L.modifiedStartLineNumber,L.modifiedEndLineNumber+1);let I=new k.$Rr(F,_,L.charChanges?.map(V=>new k.$Sr(new a.$Or(V.originalStartLineNumber,V.originalStartColumn,V.originalEndLineNumber,V.originalEndColumn),new a.$Or(V.modifiedStartLineNumber,V.modifiedStartColumn,V.modifiedEndLineNumber,V.modifiedEndColumn))));v&&(v.modifiedRange.endLineNumberExclusive===I.modifiedRange.startLineNumber||v.originalRange.endLineNumberExclusive===I.originalRange.startLineNumber)&&(I=new k.$Rr(v.originalRange.join(I.originalRange),v.modifiedRange.join(I.modifiedRange),v.innerChanges&&I.innerChanges?v.innerChanges.concat(I.innerChanges):void 0),w.pop()),w.push(I),v=I}return(0,$.$pc)(()=>(0,$.$qc)(w,(L,F)=>F.originalRange.startLineNumber-L.originalRange.endLineNumberExclusive===F.modifiedRange.startLineNumber-L.modifiedRange.endLineNumberExclusive&&L.originalRange.endLineNumberExclusive<F.originalRange.startLineNumber&&L.modifiedRange.endLineNumberExclusive<F.modifiedRange.startLineNumber)),new k.$Qr(w,[],f.quitEarly)}}t.$pu=u;function g(d,b,r,l){return new P.$ou(d,b,r).ComputeDiff(l)}class E{constructor(b){const r=[],l=[];for(let N=0,f=b.length;N<f;N++)r[N]=R(b[N],1),l[N]=m(b[N],1);this.lines=b,this.a=r,this.b=l}getElements(){const b=[];for(let r=0,l=this.lines.length;r<l;r++)b[r]=this.lines[r].substring(this.a[r]-1,this.b[r]-1);return b}getStrictElement(b){return this.lines[b]}getStartLineNumber(b){return b+1}getEndLineNumber(b){return b+1}createCharSequence(b,r,l){const N=[],f=[],w=[];let v=0;for(let L=r;L<=l;L++){const F=this.lines[L],_=b?this.a[L]:1,I=b?this.b[L]:F.length+1;for(let V=_;V<I;V++)N[v]=F.charCodeAt(V-1),f[v]=L+1,w[v]=V,v++;!b&&L<l&&(N[v]=10,f[v]=L+1,w[v]=F.length+1,v++)}return new h(N,f,w)}}class h{constructor(b,r,l){this.a=b,this.b=r,this.d=l}toString(){return"["+this.a.map((b,r)=>(b===10?"\\n":String.fromCharCode(b))+`-(${this.b[r]},${this.d[r]})`).join(", ")+"]"}e(b,r){if(b<0||b>=r.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(b){return b>0&&b===this.b.length?this.getEndLineNumber(b-1):(this.e(b,this.b),this.b[b])}getEndLineNumber(b){return b===-1?this.getStartLineNumber(b+1):(this.e(b,this.b),this.a[b]===10?this.b[b]+1:this.b[b])}getStartColumn(b){return b>0&&b===this.d.length?this.getEndColumn(b-1):(this.e(b,this.d),this.d[b])}getEndColumn(b){return b===-1?this.getStartColumn(b+1):(this.e(b,this.d),this.a[b]===10?1:this.d[b]+1)}}class c{constructor(b,r,l,N,f,w,v,L){this.originalStartLineNumber=b,this.originalStartColumn=r,this.originalEndLineNumber=l,this.originalEndColumn=N,this.modifiedStartLineNumber=f,this.modifiedStartColumn=w,this.modifiedEndLineNumber=v,this.modifiedEndColumn=L}static createFromDiffChange(b,r,l){const N=r.getStartLineNumber(b.originalStart),f=r.getStartColumn(b.originalStart),w=r.getEndLineNumber(b.originalStart+b.originalLength-1),v=r.getEndColumn(b.originalStart+b.originalLength-1),L=l.getStartLineNumber(b.modifiedStart),F=l.getStartColumn(b.modifiedStart),_=l.getEndLineNumber(b.modifiedStart+b.modifiedLength-1),I=l.getEndColumn(b.modifiedStart+b.modifiedLength-1);return new c(N,f,w,v,L,F,_,I)}}function e(d){if(d.length<=1)return d;const b=[d[0]];let r=b[0];for(let l=1,N=d.length;l<N;l++){const f=d[l],w=f.originalStart-(r.originalStart+r.originalLength),v=f.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(w,v)<s?(r.originalLength=f.originalStart+f.originalLength-r.originalStart,r.modifiedLength=f.modifiedStart+f.modifiedLength-r.modifiedStart):(b.push(f),r=f)}return b}class A{constructor(b,r,l,N,f){this.originalStartLineNumber=b,this.originalEndLineNumber=r,this.modifiedStartLineNumber=l,this.modifiedEndLineNumber=N,this.charChanges=f}static createFromDiffResult(b,r,l,N,f,w,v){let L,F,_,I,V;if(r.originalLength===0?(L=l.getStartLineNumber(r.originalStart)-1,F=0):(L=l.getStartLineNumber(r.originalStart),F=l.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(_=N.getStartLineNumber(r.modifiedStart)-1,I=0):(_=N.getStartLineNumber(r.modifiedStart),I=N.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),w&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&f()){const z=l.createCharSequence(b,r.originalStart,r.originalStart+r.originalLength-1),C=N.createCharSequence(b,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(z.getElements().length>0&&C.getElements().length>0){let O=g(z,C,f,!0).changes;v&&(O=e(O)),V=[];for(let p=0,q=O.length;p<q;p++)V.push(c.createFromDiffChange(O[p],z,C))}}return new A(L,F,_,I,V)}}class y{constructor(b,r,l){this.a=l.shouldComputeCharChanges,this.b=l.shouldPostProcessCharChanges,this.d=l.shouldIgnoreTrimWhitespace,this.e=l.shouldMakePrettyDiff,this.f=b,this.g=r,this.h=new E(b),this.j=new E(r),this.k=M(l.maxComputationTime),this.l=M(l.maxComputationTime===0?0:Math.min(l.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const b=g(this.h,this.j,this.k,this.e),r=b.changes,l=b.quitEarly;if(this.d){const v=[];for(let L=0,F=r.length;L<F;L++)v.push(A.createFromDiffResult(this.d,r[L],this.h,this.j,this.l,this.a,this.b));return{quitEarly:l,changes:v}}const N=[];let f=0,w=0;for(let v=-1,L=r.length;v<L;v++){const F=v+1<L?r[v+1]:null,_=F?F.originalStart:this.f.length,I=F?F.modifiedStart:this.g.length;for(;f<_&&w<I;){const V=this.f[f],z=this.g[w];if(V!==z){{let C=R(V,1),O=R(z,1);for(;C>1&&O>1;){const p=V.charCodeAt(C-2),q=z.charCodeAt(O-2);if(p!==q)break;C--,O--}(C>1||O>1)&&this.m(N,f+1,1,C,w+1,1,O)}{let C=m(V,1),O=m(z,1);const p=V.length+1,q=z.length+1;for(;C<p&&O<q;){const X=V.charCodeAt(C-1),B=V.charCodeAt(O-1);if(X!==B)break;C++,O++}(C<p||O<q)&&this.m(N,f+1,C,p,w+1,O,q)}}f++,w++}F&&(N.push(A.createFromDiffResult(this.d,F,this.h,this.j,this.l,this.a,this.b)),f+=F.originalLength,w+=F.modifiedLength)}return{quitEarly:l,changes:N}}m(b,r,l,N,f,w,v){if(this.n(b,r,l,N,f,w,v))return;let L;this.a&&(L=[new c(r,l,r,N,f,w,f,v)]),b.push(new A(r,r,f,f,L))}n(b,r,l,N,f,w,v){const L=b.length;if(L===0)return!1;const F=b[L-1];return F.originalEndLineNumber===0||F.modifiedEndLineNumber===0?!1:F.originalEndLineNumber===r&&F.modifiedEndLineNumber===f?(this.a&&F.charChanges&&F.charChanges.push(new c(r,l,r,N,f,w,f,v)),!0):F.originalEndLineNumber+1===r&&F.modifiedEndLineNumber+1===f?(F.originalEndLineNumber=r,F.modifiedEndLineNumber=f,this.a&&F.charChanges&&F.charChanges.push(new c(r,l,r,N,f,w,f,v)),!0):!1}}t.$qu=y;function R(d,b){const r=i.$Bd(d);return r===-1?b:r+1}function m(d,b){const r=i.$Dd(d);return r===-1?b:r+2}function M(d){if(d===0)return()=>!0;const b=Date.now();return()=>Date.now()-b<d}}),Z(K[43],ne([0,1,15,10,28,12,6,4,2,9,42,39,40,26]),function(H,t,P,k,i,a,$,o,s,u,g,E,h,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vX=t.$uX=t.$tX=t.$sX=t.$rX=void 0;class e{constructor(){this.b=new g.$jX,this.f=new h.$qX}computeDiff(p,q,X){if(p.length===1&&p[0].length===0||q.length===1&&q[0].length===0)return{changes:[new c.$Rr(new a.$Pr(1,p.length+1),new a.$Pr(1,q.length+1),[new c.$Sr(new s.$Or(1,1,p.length,p[0].length+1),new s.$Or(1,1,q.length,q[0].length+1))])],hitTimeout:!1,moves:[]};const B=X.maxComputationTimeMs===0?u.$gX.instance:new u.$hX(X.maxComputationTimeMs),J=!X.ignoreTrimWhitespace,n=new Map;function ee(D){let U=n.get(D);return U===void 0&&(U=n.size,n.set(D,U)),U}const ue=p.map(D=>ee(D.trim())),oe=q.map(D=>ee(D.trim())),ae=new l(ue,p),he=new l(oe,q),Ae=(()=>ae.length+he.length<1700?this.b.compute(ae,he,B,(D,U)=>p[D]===q[U]?q[U].length===0?.1:1+Math.log(1+q[U].length):.99):this.f.compute(ae,he))();let me=Ae.diffs,be=Ae.hitTimeout;me=(0,E.$kX)(ae,he,me),me=(0,E.$mX)(ae,he,me);const Ee=[],se=D=>{if(J)for(let U=0;U<D;U++){const S=ce+U,j=fe+U;if(p[S]!==q[j]){const x=this.n(p,q,new u.$fX(new $.$dC(S,S+1),new $.$dC(j,j+1)),B,J);for(const te of x.mappings)Ee.push(te);x.hitTimeout&&(be=!0)}}};let ce=0,fe=0;for(const D of me){(0,k.$pc)(()=>D.seq1Range.start-ce===D.seq2Range.start-fe);const U=D.seq1Range.start-ce;se(U),ce=D.seq1Range.endExclusive,fe=D.seq2Range.endExclusive;const S=this.n(p,q,D,B,J);S.hitTimeout&&(be=!0);for(const j of S.mappings)Ee.push(j)}se(p.length-ce);const ve=d(Ee,p,q);let Y=[];return X.computeMoves&&(Y=this.h(ve,p,q,ue,oe,B,J)),(0,k.$pc)(()=>{function D(S,j){if(S.lineNumber<1||S.lineNumber>j.length)return!1;const x=j[S.lineNumber-1];return!(S.column<1||S.column>x.length+1)}function U(S,j){return!(S.startLineNumber<1||S.startLineNumber>j.length+1||S.endLineNumberExclusive<1||S.endLineNumberExclusive>j.length+1)}for(const S of ve){if(!S.innerChanges)return!1;for(const j of S.innerChanges)if(!(D(j.modifiedRange.getStartPosition(),q)&&D(j.modifiedRange.getEndPosition(),q)&&D(j.originalRange.getStartPosition(),p)&&D(j.originalRange.getEndPosition(),p)))return!1;if(!U(S.modifiedRange,q)||!U(S.originalRange,p))return!1}return!0}),new c.$Qr(ve,Y,be)}h(p,q,X,B,J,n,ee){const ue=[],oe=p.filter(se=>se.modifiedRange.isEmpty&&se.originalRange.length>=3).map(se=>new C(se.originalRange,q,se)),ae=new Set(p.filter(se=>se.originalRange.isEmpty&&se.modifiedRange.length>=3).map(se=>new C(se.modifiedRange,X,se))),he=new Set;for(const se of oe){let ce=-1,fe;for(const ve of ae){const Y=se.computeSimilarity(ve);Y>ce&&(ce=Y,fe=ve)}if(ce>.9&&fe){const ve=this.n(q,X,new u.$fX(new $.$dC(se.range.startLineNumber-1,se.range.endLineNumberExclusive-1),new $.$dC(fe.range.startLineNumber-1,fe.range.endLineNumberExclusive-1)),n,ee),Y=d(ve.mappings,q,X,!0);ae.delete(fe),ue.push(new c.$Ur(new c.$Tr(se.range,fe.range),Y)),he.add(se.source),he.add(fe.source)}}const Ae=new i.$L;for(const se of p)if(!he.has(se))for(let ce=se.originalRange.startLineNumber;ce<se.originalRange.endLineNumberExclusive-2;ce++){const fe=`${B[ce-1]}:${B[ce+1-1]}:${B[ce+2-1]}`;Ae.add(fe,{range:new a.$Pr(ce,ce+3)})}const me=[];p.sort((0,P.$Of)(se=>se.modifiedRange.startLineNumber,P.$Qf));for(const se of p){if(he.has(se))continue;let ce=[];for(let fe=se.modifiedRange.startLineNumber;fe<se.modifiedRange.endLineNumberExclusive-2;fe++){const ve=`${J[fe-1]}:${J[fe+1-1]}:${J[fe+2-1]}`,Y=new a.$Pr(fe,fe+3),D=[];Ae.forEach(ve,({range:U})=>{for(const j of ce)if(j.originalLineRange.endLineNumberExclusive+1===U.endLineNumberExclusive&&j.modifiedLineRange.endLineNumberExclusive+1===Y.endLineNumberExclusive){j.originalLineRange=new a.$Pr(j.originalLineRange.startLineNumber,U.endLineNumberExclusive),j.modifiedLineRange=new a.$Pr(j.modifiedLineRange.startLineNumber,Y.endLineNumberExclusive),D.push(j);return}const S={modifiedLineRange:Y,originalLineRange:U};me.push(S),D.push(S)}),ce=D}}me.sort((0,P.$Rf)((0,P.$Of)(se=>se.modifiedLineRange.length,P.$Qf)));const be=new y,Ee=new y;for(const se of me){const ce=se.modifiedLineRange.startLineNumber-se.originalLineRange.startLineNumber,fe=be.subtractFrom(se.modifiedLineRange),ve=Ee.subtractFrom(se.originalLineRange).map(D=>D.delta(ce)),Y=A(fe,ve);for(const D of Y){if(D.length<3)continue;const U=D,S=D.delta(-ce),j=this.n(q,X,new u.$fX(new $.$dC(S.startLineNumber-1,S.endLineNumberExclusive-1),new $.$dC(U.startLineNumber-1,U.endLineNumberExclusive-1)),n,ee),x=d(j.mappings,q,X,!0);ue.push(new c.$Ur(new c.$Tr(S,U),x)),be.addRange(U),Ee.addRange(S)}}return ue}n(p,q,X,B,J){const n=new f(p,X.seq1Range,J),ee=new f(q,X.seq2Range,J),ue=n.length+ee.length<500?this.b.compute(n,ee,B):this.f.compute(n,ee,B);let oe=ue.diffs;return oe=(0,E.$kX)(n,ee,oe),oe=m(n,ee,oe),oe=(0,E.$lX)(n,ee,oe),oe=(0,E.$nX)(n,ee,oe),{mappings:oe.map(he=>new c.$Sr(n.translateRange(he.seq1Range),ee.translateRange(he.seq2Range))),hitTimeout:ue.hitTimeout}}}t.$rX=e;function A(O,p){const q=[];let X=0,B=0;for(;X<O.length&&B<p.length;){const J=O[X],n=p[B],ee=J.intersect(n);ee&&!ee.isEmpty&&q.push(ee),J.endLineNumberExclusive<n.endLineNumberExclusive?X++:B++}return q}class y{constructor(){this.b=[]}addRange(p){const q=R(this.b.findIndex(B=>B.endLineNumberExclusive>=p.startLineNumber),this.b.length),X=(0,P.$uf)(this.b,B=>B.startLineNumber<=p.endLineNumberExclusive)+1;if(q===X)this.b.splice(q,0,p);else if(q===X-1){const B=this.b[q];this.b[q]=B.join(p)}else{const B=this.b[q].join(this.b[X-1]).join(p);this.b.splice(q,X-q,B)}}intersects(p){for(const q of this.b)if(q.intersectsStrict(p))return!0;return!1}subtractFrom(p){const q=R(this.b.findIndex(n=>n.endLineNumberExclusive>=p.startLineNumber),this.b.length),X=(0,P.$uf)(this.b,n=>n.startLineNumber<=p.endLineNumberExclusive)+1;if(q===X)return[p];const B=[];let J=p.startLineNumber;for(let n=q;n<X;n++){const ee=this.b[n];ee.startLineNumber>J&&B.push(new a.$Pr(J,ee.startLineNumber)),J=ee.endLineNumberExclusive}return J<p.endLineNumberExclusive&&B.push(new a.$Pr(J,p.endLineNumberExclusive)),B}}function R(O,p){return O===-1?p:O}function m(O,p,q){const X=[];let B;function J(){if(!B)return;const ee=B.s1Range.length-B.deleted,ue=B.s2Range.length-B.added;Math.max(B.deleted,B.added)+(B.count-1)>ee&&X.push(new u.$fX(B.s1Range,B.s2Range)),B=void 0}for(const ee of q){let ue=function(me,be){if(!B||!B.s1Range.containsRange(me)||!B.s2Range.containsRange(be))if(B&&!(B.s1Range.endExclusive<me.start&&B.s2Range.endExclusive<be.start)){const ce=$.$dC.tryCreate(B.s1Range.endExclusive,me.start),fe=$.$dC.tryCreate(B.s2Range.endExclusive,be.start);B.deleted+=ce?.length??0,B.added+=fe?.length??0,B.s1Range=B.s1Range.join(me),B.s2Range=B.s2Range.join(be)}else J(),B={added:0,deleted:0,count:0,s1Range:me,s2Range:be};const Ee=me.intersect(ee.seq1Range),se=be.intersect(ee.seq2Range);B.count++,B.deleted+=Ee?.length??0,B.added+=se?.length??0};const oe=O.findWordContaining(ee.seq1Range.start-1),ae=p.findWordContaining(ee.seq2Range.start-1),he=O.findWordContaining(ee.seq1Range.endExclusive),Ae=p.findWordContaining(ee.seq2Range.endExclusive);oe&&he&&ae&&Ae&&oe.equals(he)&&ae.equals(Ae)?ue(oe,ae):(oe&&ae&&ue(oe,ae),he&&Ae&&ue(he,Ae))}return J(),M(q,X)}function M(O,p){const q=[];for(;O.length>0||p.length>0;){const X=O[0],B=p[0];let J;X&&(!B||X.seq1Range.start<B.seq1Range.start)?J=O.shift():J=p.shift(),q.length>0&&q[q.length-1].seq1Range.endExclusive>=J.seq1Range.start?q[q.length-1]=q[q.length-1].join(J):q.push(J)}return q}function d(O,p,q,X=!1){const B=[];for(const J of r(O.map(n=>b(n,p,q)),(n,ee)=>n.originalRange.overlapOrTouch(ee.originalRange)||n.modifiedRange.overlapOrTouch(ee.modifiedRange))){const n=J[0],ee=J[J.length-1];B.push(new c.$Rr(n.originalRange.join(ee.originalRange),n.modifiedRange.join(ee.modifiedRange),J.map(ue=>ue.innerChanges[0])))}return(0,k.$pc)(()=>!X&&B.length>0&&B[0].originalRange.startLineNumber!==B[0].modifiedRange.startLineNumber?!1:(0,k.$qc)(B,(J,n)=>n.originalRange.startLineNumber-J.originalRange.endLineNumberExclusive===n.modifiedRange.startLineNumber-J.modifiedRange.endLineNumberExclusive&&J.originalRange.endLineNumberExclusive<n.originalRange.startLineNumber&&J.modifiedRange.endLineNumberExclusive<n.modifiedRange.startLineNumber)),B}t.$sX=d;function b(O,p,q){let X=0,B=0;O.modifiedRange.endColumn===1&&O.originalRange.endColumn===1&&O.originalRange.startLineNumber+X<=O.originalRange.endLineNumber&&O.modifiedRange.startLineNumber+X<=O.modifiedRange.endLineNumber&&(B=-1),O.modifiedRange.startColumn-1>=q[O.modifiedRange.startLineNumber-1].length&&O.originalRange.startColumn-1>=p[O.originalRange.startLineNumber-1].length&&O.originalRange.startLineNumber<=O.originalRange.endLineNumber+B&&O.modifiedRange.startLineNumber<=O.modifiedRange.endLineNumber+B&&(X=1);const J=new a.$Pr(O.originalRange.startLineNumber+X,O.originalRange.endLineNumber+1+B),n=new a.$Pr(O.modifiedRange.startLineNumber+X,O.modifiedRange.endLineNumber+1+B);return new c.$Rr(J,n,[O])}t.$tX=b;function*r(O,p){let q,X;for(const B of O)X!==void 0&&p(X,B)?q.push(B):(q&&(yield q),q=[B]),X=B;q&&(yield q)}class l{constructor(p,q){this.b=p,this.f=q}getElement(p){return this.b[p]}get length(){return this.b.length}getBoundaryScore(p){const q=p===0?0:N(this.f[p-1]),X=p===this.f.length?0:N(this.f[p]);return 1e3-(q+X)}getText(p){return this.f.slice(p.start,p.endExclusive).join(`
`)}isStronglyEqual(p,q){return this.f[p]===this.f[q]}}t.$uX=l;function N(O){let p=0;for(;p<O.length&&(O.charCodeAt(p)===32||O.charCodeAt(p)===9);)p++;return p}class f{constructor(p,q,X){this.lines=p,this.considerWhitespaceChanges=X,this.b=[],this.f=[],this.h=[];let B=!1;q.start>0&&q.endExclusive>=p.length&&(q=new $.$dC(q.start-1,q.endExclusive),B=!0),this.lineRange=q;for(let J=this.lineRange.start;J<this.lineRange.endExclusive;J++){let n=p[J],ee=0;if(B)ee=n.length,n="",B=!1;else if(!X){const ue=n.trimStart();ee=n.length-ue.length,n=ue.trimEnd()}this.h.push(ee);for(let ue=0;ue<n.length;ue++)this.b.push(n.charCodeAt(ue));J<p.length-1&&(this.b.push(`
`.charCodeAt(0)),this.f[J-this.lineRange.start]=this.b.length)}this.h.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new $.$dC(0,this.length))}getText(p){return this.b.slice(p.start,p.endExclusive).map(q=>String.fromCharCode(q)).join("")}getElement(p){return this.b[p]}get length(){return this.b.length}getBoundaryScore(p){const q=_(p>0?this.b[p-1]:-1),X=_(p<this.b.length?this.b[p]:-1);if(q===6&&X===7)return 0;let B=0;return q!==X&&(B+=10,X===1&&(B+=1)),B+=F(q),B+=F(X),B}translateOffset(p){if(this.lineRange.isEmpty)return new o.$Nr(this.lineRange.start+1,1);let q=0,X=this.f.length;for(;q<X;){const J=Math.floor((q+X)/2);this.f[J]>p?X=J:q=J+1}const B=q===0?0:this.f[q-1];return new o.$Nr(this.lineRange.start+q+1,p-B+1+this.h[q])}translateRange(p){return s.$Or.fromPositions(this.translateOffset(p.start),this.translateOffset(p.endExclusive))}findWordContaining(p){if(p<0||p>=this.b.length||!w(this.b[p]))return;let q=p;for(;q>0&&w(this.b[q-1]);)q--;let X=p;for(;X<this.b.length&&w(this.b[X]);)X++;return new $.$dC(q,X)}countLinesIn(p){return this.translateOffset(p.endExclusive).lineNumber-this.translateOffset(p.start).lineNumber}isStronglyEqual(p,q){return this.b[p]===this.b[q]}}t.$vX=f;function w(O){return O>=97&&O<=122||O>=65&&O<=90||O>=48&&O<=57}var v;(function(O){O[O.WordLower=0]="WordLower",O[O.WordUpper=1]="WordUpper",O[O.WordNumber=2]="WordNumber",O[O.End=3]="End",O[O.Other=4]="Other",O[O.Space=5]="Space",O[O.LineBreakCR=6]="LineBreakCR",O[O.LineBreakLF=7]="LineBreakLF"})(v||(v={}));const L={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function F(O){return L[O]}function _(O){return O===10?7:O===13?6:I(O)?5:O>=97&&O<=122?0:O>=65&&O<=90?1:O>=48&&O<=57?2:O===-1?3:4}function I(O){return O===32||O===9}const V=new Map;function z(O){let p=V.get(O);return p===void 0&&(p=V.size,V.set(O,p)),p}class C{constructor(p,q,X){this.range=p,this.lines=q,this.source=X,this.f=[];let B=0;for(let J=p.startLineNumber-1;J<p.endLineNumberExclusive-1;J++){const n=q[J];for(let ue=0;ue<n.length;ue++){B++;const oe=n[ue],ae=z(oe);this.f[ae]=(this.f[ae]||0)+1}B++;const ee=z(`
`);this.f[ee]=(this.f[ee]||0)+1}this.b=B}computeSimilarity(p){let q=0;const X=Math.max(this.f.length,p.f.length);for(let B=0;B<X;B++)q+=Math.abs((this.f[B]??0)-(p.f[B]??0));return 1-q/(this.b+p.b)}}}),Z(K[44],ne([0,1,27,43]),function(H,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wX=void 0,t.$wX={getLegacy:()=>new P.$pu,getAdvanced:()=>new k.$rX}}),Z(K[45],ne([0,1,29]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xX=void 0;function k(h){const c=[];for(const e of h){const A=Number(e);(A||A===0&&e.replace(/\s/g,"")!=="")&&c.push(A)}return c}function i(h,c,e,A){return{red:h/255,blue:e/255,green:c/255,alpha:A}}function a(h,c){const e=c.index,A=c[0].length;if(!e)return;const y=h.positionAt(e);return{startLineNumber:y.lineNumber,startColumn:y.column,endLineNumber:y.lineNumber,endColumn:y.column+A}}function $(h,c){if(!h)return;const e=P.$0r.Format.CSS.parseHex(c);if(e)return{range:h,color:i(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function o(h,c,e){if(!h||c.length!==1)return;const y=c[0].values(),R=k(y);return{range:h,color:i(R[0],R[1],R[2],e?R[3]:1)}}function s(h,c,e){if(!h||c.length!==1)return;const y=c[0].values(),R=k(y),m=new P.$0r(new P.$8r(R[0],R[1]/100,R[2]/100,e?R[3]:1));return{range:h,color:i(m.rgba.r,m.rgba.g,m.rgba.b,m.rgba.a)}}function u(h,c){return typeof h=="string"?[...h.matchAll(c)]:h.findMatches(c)}function g(h){const c=[],A=u(h,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(A.length>0)for(const y of A){const R=y.filter(b=>b!==void 0),m=R[1],M=R[2];if(!M)continue;let d;if(m==="rgb"){const b=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;d=o(a(h,y),u(M,b),!1)}else if(m==="rgba"){const b=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;d=o(a(h,y),u(M,b),!0)}else if(m==="hsl"){const b=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;d=s(a(h,y),u(M,b),!1)}else if(m==="hsla"){const b=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;d=s(a(h,y),u(M,b),!0)}else m==="#"&&(d=$(a(h,y),m+M));d&&c.push(d)}return c}function E(h){return!h||typeof h.getValue!="function"||typeof h.positionAt!="function"?[]:g(h)}t.$xX=E}),Z(K[46],ne([0,1,24]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aX=t.$_W=t.$$W=t.State=void 0;var k;(function(c){c[c.Invalid=0]="Invalid",c[c.Start=1]="Start",c[c.H=2]="H",c[c.HT=3]="HT",c[c.HTT=4]="HTT",c[c.HTTP=5]="HTTP",c[c.F=6]="F",c[c.FI=7]="FI",c[c.FIL=8]="FIL",c[c.BeforeColon=9]="BeforeColon",c[c.AfterColon=10]="AfterColon",c[c.AlmostThere=11]="AlmostThere",c[c.End=12]="End",c[c.Accept=13]="Accept",c[c.LastKnownState=14]="LastKnownState"})(k||(t.State=k={}));class i{constructor(e,A,y){const R=new Uint8Array(e*A);for(let m=0,M=e*A;m<M;m++)R[m]=y;this.a=R,this.rows=e,this.cols=A}get(e,A){return this.a[e*this.cols+A]}set(e,A,y){this.a[e*this.cols+A]=y}}class a{constructor(e){let A=0,y=0;for(let m=0,M=e.length;m<M;m++){const[d,b,r]=e[m];b>A&&(A=b),d>y&&(y=d),r>y&&(y=r)}A++,y++;const R=new i(y,A,0);for(let m=0,M=e.length;m<M;m++){const[d,b,r]=e[m];R.set(d,b,r)}this.a=R,this.b=A}nextState(e,A){return A<0||A>=this.b?0:this.a.get(e,A)}}t.$$W=a;let $=null;function o(){return $===null&&($=new a([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),$}var s;(function(c){c[c.None=0]="None",c[c.ForceTermination=1]="ForceTermination",c[c.CannotEndIn=2]="CannotEndIn"})(s||(s={}));let u=null;function g(){if(u===null){u=new P.$3r(0);const c=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let A=0;A<c.length;A++)u.set(c.charCodeAt(A),1);const e=".,;:";for(let A=0;A<e.length;A++)u.set(e.charCodeAt(A),2)}return u}class E{static a(e,A,y,R,m){let M=m-1;do{const d=A.charCodeAt(M);if(e.get(d)!==2)break;M--}while(M>R);if(R>0){const d=A.charCodeAt(R-1),b=A.charCodeAt(M);(d===40&&b===41||d===91&&b===93||d===123&&b===125)&&M--}return{range:{startLineNumber:y,startColumn:R+1,endLineNumber:y,endColumn:M+2},url:A.substring(R,M+1)}}static computeLinks(e,A=o()){const y=g(),R=[];for(let m=1,M=e.getLineCount();m<=M;m++){const d=e.getLineContent(m),b=d.length;let r=0,l=0,N=0,f=1,w=!1,v=!1,L=!1,F=!1;for(;r<b;){let _=!1;const I=d.charCodeAt(r);if(f===13){let V;switch(I){case 40:w=!0,V=0;break;case 41:V=w?0:1;break;case 91:L=!0,v=!0,V=0;break;case 93:L=!1,V=v?0:1;break;case 123:F=!0,V=0;break;case 125:V=F?0:1;break;case 39:case 34:case 96:N===I?V=1:N===39||N===34||N===96?V=0:V=1;break;case 42:V=N===42?1:0;break;case 124:V=N===124?1:0;break;case 32:V=L?0:1;break;default:V=y.get(I)}V===1&&(R.push(E.a(y,d,m,l,r)),_=!0)}else if(f===12){let V;I===91?(v=!0,V=0):V=y.get(I),V===1?_=!0:f=13}else f=A.nextState(f,I),f===0&&(_=!0);_&&(f=1,w=!1,v=!1,F=!1,l=r+1,N=I),r++}f===13&&R.push(E.a(y,d,m,l,b))}return R}}t.$_W=E;function h(c){return!c||typeof c.getLineCount!="function"||typeof c.getLineContent!="function"?[]:E.computeLinks(c)}t.$aX=h}),Z(K[47],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bX=void 0;class P{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new P}navigateValueSet(i,a,$,o,s){if(i&&a){const u=this.a(a,s);if(u)return{range:i,value:u}}if($&&o){const u=this.a(o,s);if(u)return{range:$,value:u}}return null}a(i,a){const $=this.b(i,a);return $!==null?$:this.d(i,a)}b(i,a){const $=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let o=Number(i);const s=parseFloat(i);return!isNaN(o)&&!isNaN(s)&&o===s?o===0&&!a?null:(o=Math.floor(o*$),o+=a?$:-$,String(o/$)):null}d(i,a){return this.e(this.c,i,a)}e(i,a,$){let o=null;for(let s=0,u=i.length;o===null&&s<u;s++)o=this.f(i[s],a,$);return o}f(i,a,$){let o=i.indexOf(a);return o>=0?(o+=$?1:-1,o<0?o=i.length-1:o%=i.length,i[o]):null}}t.$bX=P}),Z(K[48],ne([0,1,11]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2t=t.$1t=t.$Zt=t.$Yt=t.ModelConstants=t.PositionAffinity=t.$Xt=t.TrackedRangeStickiness=t.$Wt=t.$Vt=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var k;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(k||(t.OverviewRulerLane=k={}));var i;(function(d){d[d.Left=1]="Left",d[d.Right=2]="Right"})(i||(t.GlyphMarginLane=i={}));var a;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(a||(t.MinimapPosition=a={}));var $;(function(d){d[d.Both=0]="Both",d[d.Right=1]="Right",d[d.Left=2]="Left",d[d.None=3]="None"})($||(t.InjectedTextCursorStops=$={}));var o;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(o||(t.EndOfLinePreference=o={}));var s;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(s||(t.DefaultEndOfLine=s={}));var u;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(u||(t.EndOfLineSequence=u={}));class g{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(b){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,b.tabSize|0),b.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,b.indentSize|0),this.a=!1),this.insertSpaces=!!b.insertSpaces,this.defaultEOL=b.defaultEOL|0,this.trimAutoWhitespace=!!b.trimAutoWhitespace,this.bracketPairColorizationOptions=b.bracketPairColorizationOptions}equals(b){return this.tabSize===b.tabSize&&this.a===b.a&&this.indentSize===b.indentSize&&this.insertSpaces===b.insertSpaces&&this.defaultEOL===b.defaultEOL&&this.trimAutoWhitespace===b.trimAutoWhitespace&&(0,P.$Lm)(this.bracketPairColorizationOptions,b.bracketPairColorizationOptions)}createChangeEvent(b){return{tabSize:this.tabSize!==b.tabSize,indentSize:this.indentSize!==b.indentSize,insertSpaces:this.insertSpaces!==b.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==b.trimAutoWhitespace}}}t.$Vt=g;class E{constructor(b,r){this._findMatchBrand=void 0,this.range=b,this.matches=r}}t.$Wt=E;var h;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(h||(t.TrackedRangeStickiness=h={}));function c(d){return d&&typeof d.read=="function"}t.$Xt=c;var e;(function(d){d[d.Left=0]="Left",d[d.Right=1]="Right",d[d.None=2]="None",d[d.LeftOfInjectedText=3]="LeftOfInjectedText",d[d.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var A;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(A||(t.ModelConstants=A={}));class y{constructor(b,r,l,N,f,w){this.identifier=b,this.range=r,this.text=l,this.forceMoveMarkers=N,this.isAutoWhitespaceEdit=f,this._isTracked=w}}t.$Yt=y;class R{constructor(b,r,l){this.regex=b,this.wordSeparators=r,this.simpleSearch=l}}t.$Zt=R;class m{constructor(b,r,l){this.reverseEdits=b,this.changes=r,this.trimAutoWhitespaceLineNumbers=l}}t.$1t=m;function M(d){return!d.isTooLargeForSyncing()&&!d.isForSimpleWidget}t.$2t=M}),Z(K[49],ne([0,1,15,23]),function(H,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vu=t.$uu=t.$tu=void 0;class i{constructor(s){this.a=s,this.b=new Uint32Array(s.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(s,u){s=(0,k.$jd)(s);const g=this.a,E=this.b,h=u.length;return h===0?!1:(this.a=new Uint32Array(g.length+h),this.a.set(g.subarray(0,s),0),this.a.set(g.subarray(s),s+h),this.a.set(u,s),s-1<this.c[0]&&(this.c[0]=s-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue(s,u){return s=(0,k.$jd)(s),u=(0,k.$jd)(u),this.a[s]===u?!1:(this.a[s]=u,s-1<this.c[0]&&(this.c[0]=s-1),!0)}removeValues(s,u){s=(0,k.$jd)(s),u=(0,k.$jd)(u);const g=this.a,E=this.b;if(s>=g.length)return!1;const h=g.length-s;return u>=h&&(u=h),u===0?!1:(this.a=new Uint32Array(g.length-u),this.a.set(g.subarray(0,s),0),this.a.set(g.subarray(s+u),s),this.b=new Uint32Array(this.a.length),s-1<this.c[0]&&(this.c[0]=s-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(s){return s<0?0:(s=(0,k.$jd)(s),this.d(s))}d(s){if(s<=this.c[0])return this.b[s];let u=this.c[0]+1;u===0&&(this.b[0]=this.a[0],u++),s>=this.a.length&&(s=this.a.length-1);for(let g=u;g<=s;g++)this.b[g]=this.b[g-1]+this.a[g];return this.c[0]=Math.max(this.c[0],s),this.b[s]}getIndexOf(s){s=Math.floor(s),this.getTotalSum();let u=0,g=this.a.length-1,E=0,h=0,c=0;for(;u<=g;)if(E=u+(g-u)/2|0,h=this.b[E],c=h-this.a[E],s<c)g=E-1;else if(s>=h)u=E+1;else break;return new $(E,s-c)}}t.$tu=i;class a{constructor(s){this.a=s,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(s){return this.g(),s===0?0:this.d[s-1]}getIndexOf(s){this.g();const u=this.e[s],g=u>0?this.d[u-1]:0;return new $(u,s-g)}removeValues(s,u){this.a.splice(s,u),this.f(s)}insertValues(s,u){this.a=(0,P.$Df)(this.a,s,u),this.f(s)}f(s){this.b=!1,this.c=Math.min(this.c,s-1)}g(){if(!this.b){for(let s=this.c+1,u=this.a.length;s<u;s++){const g=this.a[s],E=s>0?this.d[s-1]:0;this.d[s]=E+g;for(let h=0;h<g;h++)this.e[E+h]=s}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(s,u){this.a[s]!==u&&(this.a[s]=u,this.f(s))}}t.$uu=a;class ${constructor(s,u){this.index=s,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=s,this.remainder=u}}t.$vu=$}),Z(K[50],ne([0,1,5,4,49]),function(H,t,P,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wu=void 0;class a{constructor(o,s,u,g){this.d=o,this.f=s,this.g=u,this.h=g,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(o){o.eol&&o.eol!==this.g&&(this.g=o.eol,this.j=null);const s=o.changes;for(const u of s)this.o(u.range),this.p(new k.$Nr(u.range.startLineNumber,u.range.startColumn),u.text);this.h=o.versionId,this.k=null}l(){if(!this.j){const o=this.g.length,s=this.f.length,u=new Uint32Array(s);for(let g=0;g<s;g++)u[g]=this.f[g].length+o;this.j=new i.$tu(u)}}n(o,s){this.f[o]=s,this.j&&this.j.setValue(o,this.f[o].length+this.g.length)}o(o){if(o.startLineNumber===o.endLineNumber){if(o.startColumn===o.endColumn)return;this.n(o.startLineNumber-1,this.f[o.startLineNumber-1].substring(0,o.startColumn-1)+this.f[o.startLineNumber-1].substring(o.endColumn-1));return}this.n(o.startLineNumber-1,this.f[o.startLineNumber-1].substring(0,o.startColumn-1)+this.f[o.endLineNumber-1].substring(o.endColumn-1)),this.f.splice(o.startLineNumber,o.endLineNumber-o.startLineNumber),this.j&&this.j.removeValues(o.startLineNumber,o.endLineNumber-o.startLineNumber)}p(o,s){if(s.length===0)return;const u=(0,P.$Ad)(s);if(u.length===1){this.n(o.lineNumber-1,this.f[o.lineNumber-1].substring(0,o.column-1)+u[0]+this.f[o.lineNumber-1].substring(o.column-1));return}u[u.length-1]+=this.f[o.lineNumber-1].substring(o.column-1),this.n(o.lineNumber-1,this.f[o.lineNumber-1].substring(0,o.column-1)+u[0]);const g=new Uint32Array(u.length-1);for(let E=1;E<u.length;E++)this.f.splice(o.lineNumber+E-1,0,u[E]),g[E-1]=u[E].length+this.g.length;this.j&&this.j.insertValues(o.lineNumber,g)}}t.$wu=a}),Z(K[51],ne([0,1,5,38,4,2,48]),function(H,t,P,k,i,a,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8B=t.$7B=t.$6B=t.$5B=t.$4B=t.$3B=void 0;const o=999;class s{constructor(m,M,d,b){this.searchString=m,this.isRegex=M,this.matchCase=d,this.wordSeparators=b}parseSearchRequest(){if(this.searchString==="")return null;let m;this.isRegex?m=u(this.searchString):m=this.searchString.indexOf(`
`)>=0;let M=null;try{M=P.$wd(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:m,global:!0,unicode:!0})}catch{return null}if(!M)return null;let d=!this.isRegex&&!m;return d&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(d=this.matchCase),new $.$Zt(M,this.wordSeparators?(0,k.$6r)(this.wordSeparators):null,d?this.searchString:null)}}t.$3B=s;function u(R){if(!R||R.length===0)return!1;for(let m=0,M=R.length;m<M;m++){const d=R.charCodeAt(m);if(d===10)return!0;if(d===92){if(m++,m>=M)break;const b=R.charCodeAt(m);if(b===110||b===114||b===87)return!0}}return!1}t.$4B=u;function g(R,m,M){if(!M)return new $.$Wt(R,null);const d=[];for(let b=0,r=m.length;b<r;b++)d[b]=m[b];return new $.$Wt(R,d)}t.$5B=g;class E{constructor(m){const M=[];let d=0;for(let b=0,r=m.length;b<r;b++)m.charCodeAt(b)===10&&(M[d++]=b);this.a=M}findLineFeedCountBeforeOffset(m){const M=this.a;let d=0,b=M.length-1;if(b===-1||m<=M[0])return 0;for(;d<b;){const r=d+((b-d)/2>>0);M[r]>=m?b=r-1:M[r+1]>=m?(d=r,b=r):d=r+1}return d+1}}class h{static findMatches(m,M,d,b,r){const l=M.parseSearchRequest();return l?l.regex.multiline?this.b(m,d,new y(l.wordSeparators,l.regex),b,r):this.c(m,d,l,b,r):[]}static a(m,M,d,b,r,l){let N,f=0;b?(f=b.findLineFeedCountBeforeOffset(r),N=M+r+f):N=M+r;let w;if(b){const _=b.findLineFeedCountBeforeOffset(r+l.length)-f;w=N+l.length+_}else w=N+l.length;const v=m.getPositionAt(N),L=m.getPositionAt(w);return new a.$Or(v.lineNumber,v.column,L.lineNumber,L.column)}static b(m,M,d,b,r){const l=m.getOffsetAt(M.getStartPosition()),N=m.getValueInRange(M,1),f=m.getEOL()===`\r
`?new E(N):null,w=[];let v=0,L;for(d.reset(0);L=d.next(N);)if(w[v++]=g(this.a(m,l,N,f,L.index,L[0]),L,b),v>=r)return w;return w}static c(m,M,d,b,r){const l=[];let N=0;if(M.startLineNumber===M.endLineNumber){const w=m.getLineContent(M.startLineNumber).substring(M.startColumn-1,M.endColumn-1);return N=this.d(d,w,M.startLineNumber,M.startColumn-1,N,l,b,r),l}const f=m.getLineContent(M.startLineNumber).substring(M.startColumn-1);N=this.d(d,f,M.startLineNumber,M.startColumn-1,N,l,b,r);for(let w=M.startLineNumber+1;w<M.endLineNumber&&N<r;w++)N=this.d(d,m.getLineContent(w),w,0,N,l,b,r);if(N<r){const w=m.getLineContent(M.endLineNumber).substring(0,M.endColumn-1);N=this.d(d,w,M.endLineNumber,0,N,l,b,r)}return l}static d(m,M,d,b,r,l,N,f){const w=m.wordSeparators;if(!N&&m.simpleSearch){const F=m.simpleSearch,_=F.length,I=M.length;let V=-_;for(;(V=M.indexOf(F,V+_))!==-1;)if((!w||A(w,M,I,V,_))&&(l[r++]=new $.$Wt(new a.$Or(d,V+1+b,d,V+1+_+b),null),r>=f))return r;return r}const v=new y(m.wordSeparators,m.regex);let L;v.reset(0);do if(L=v.next(M),L&&(l[r++]=g(new a.$Or(d,L.index+1+b,d,L.index+1+L[0].length+b),L,N),r>=f))return r;while(L);return r}static findNextMatch(m,M,d,b){const r=M.parseSearchRequest();if(!r)return null;const l=new y(r.wordSeparators,r.regex);return r.regex.multiline?this.e(m,d,l,b):this.f(m,d,l,b)}static e(m,M,d,b){const r=new i.$Nr(M.lineNumber,1),l=m.getOffsetAt(r),N=m.getLineCount(),f=m.getValueInRange(new a.$Or(r.lineNumber,r.column,N,m.getLineMaxColumn(N)),1),w=m.getEOL()===`\r
`?new E(f):null;d.reset(M.column-1);const v=d.next(f);return v?g(this.a(m,l,f,w,v.index,v[0]),v,b):M.lineNumber!==1||M.column!==1?this.e(m,new i.$Nr(1,1),d,b):null}static f(m,M,d,b){const r=m.getLineCount(),l=M.lineNumber,N=m.getLineContent(l),f=this.g(d,N,l,M.column,b);if(f)return f;for(let w=1;w<=r;w++){const v=(l+w-1)%r,L=m.getLineContent(v+1),F=this.g(d,L,v+1,1,b);if(F)return F}return null}static g(m,M,d,b,r){m.reset(b-1);const l=m.next(M);return l?g(new a.$Or(d,l.index+1,d,l.index+1+l[0].length),l,r):null}static findPreviousMatch(m,M,d,b){const r=M.parseSearchRequest();if(!r)return null;const l=new y(r.wordSeparators,r.regex);return r.regex.multiline?this.h(m,d,l,b):this.j(m,d,l,b)}static h(m,M,d,b){const r=this.b(m,new a.$Or(1,1,M.lineNumber,M.column),d,b,10*o);if(r.length>0)return r[r.length-1];const l=m.getLineCount();return M.lineNumber!==l||M.column!==m.getLineMaxColumn(l)?this.h(m,new i.$Nr(l,m.getLineMaxColumn(l)),d,b):null}static j(m,M,d,b){const r=m.getLineCount(),l=M.lineNumber,N=m.getLineContent(l).substring(0,M.column-1),f=this.k(d,N,l,b);if(f)return f;for(let w=1;w<=r;w++){const v=(r+l-w-1)%r,L=m.getLineContent(v+1),F=this.k(d,L,v+1,b);if(F)return F}return null}static k(m,M,d,b){let r=null,l;for(m.reset(0);l=m.next(M);)r=g(new a.$Or(d,l.index+1,d,l.index+1+l[0].length),l,b);return r}}t.$6B=h;function c(R,m,M,d,b){if(d===0)return!0;const r=m.charCodeAt(d-1);if(R.get(r)!==0||r===13||r===10)return!0;if(b>0){const l=m.charCodeAt(d);if(R.get(l)!==0)return!0}return!1}function e(R,m,M,d,b){if(d+b===M)return!0;const r=m.charCodeAt(d+b);if(R.get(r)!==0||r===13||r===10)return!0;if(b>0){const l=m.charCodeAt(d+b-1);if(R.get(l)!==0)return!0}return!1}function A(R,m,M,d,b){return c(R,m,M,d,b)&&e(R,m,M,d,b)}t.$7B=A;class y{constructor(m,M){this._wordSeparators=m,this.a=M,this.b=-1,this.c=0}reset(m){this.a.lastIndex=m,this.b=-1,this.c=0}next(m){const M=m.length;let d;do{if(this.b+this.c===M||(d=this.a.exec(m),!d))return null;const b=d.index,r=d[0].length;if(b===this.b&&r===this.c){if(r===0){P.$Td(m,M,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=b,this.c=r,!this._wordSeparators||A(this._wordSeparators,m,M,b,r))return d}while(d);return null}}t.$8B=y}),Z(K[52],ne([0,1,2,51,5,10,25]),function(H,t,P,k,i,a,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$0W=void 0;class o{static computeUnicodeHighlights(e,A,y){const R=y?y.startLineNumber:1,m=y?y.endLineNumber:e.getLineCount(),M=new g(A),d=M.getCandidateCodePoints();let b;d==="allNonBasicAscii"?b=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):b=new RegExp(`${s(Array.from(d))}`,"g");const r=new k.$8B(null,b),l=[];let N=!1,f,w=0,v=0,L=0;e:for(let F=R,_=m;F<=_;F++){const I=e.getLineContent(F),V=I.length;r.reset(0);do if(f=r.next(I),f){let z=f.index,C=f.index+f[0].length;if(z>0){const X=I.charCodeAt(z-1);i.$Qd(X)&&z--}if(C+1<V){const X=I.charCodeAt(C-1);i.$Qd(X)&&C++}const O=I.substring(z,C);let p=(0,$.$Mr)(z+1,$.$Jr,I,0);p&&p.endColumn<=z+1&&(p=null);const q=M.shouldHighlightNonBasicASCII(O,p?p.word:null);if(q!==0){q===3?w++:q===2?v++:q===1?L++:(0,a.$nc)(q);const X=1e3;if(l.length>=X){N=!0;break e}l.push(new P.$Or(F,z+1,F,C+1))}}while(f)}return{ranges:l,hasMore:N,ambiguousCharacterCount:w,invisibleCharacterCount:v,nonBasicAsciiCharacterCount:L}}static computeUnicodeHighlightReason(e,A){const y=new g(A);switch(y.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const m=e.codePointAt(0),M=y.ambiguousCharacters.getPrimaryConfusable(m),d=i.$he.getLocales().filter(b=>!i.$he.getInstance(new Set([...A.allowedLocales,b])).isAmbiguous(m));return{kind:0,confusableWith:String.fromCodePoint(M),notAmbiguousInLocales:d}}case 1:return{kind:2}}}}t.$0W=o;function s(c,e){return`[${i.$od(c.map(y=>String.fromCodePoint(y)).join(""))}]`}var u;(function(c){c[c.Ambiguous=0]="Ambiguous",c[c.Invisible=1]="Invisible",c[c.NonBasicAscii=2]="NonBasicAscii"})(u||(t.UnicodeHighlighterReasonKind=u={}));class g{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.$he.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const A of i.$ie.codePoints)E(String.fromCodePoint(A))||e.add(A);if(this.b.ambiguousCharacters)for(const A of this.ambiguousCharacters.getConfusableCodePoints())e.add(A);for(const A of this.a)e.delete(A);return e}shouldHighlightNonBasicASCII(e,A){const y=e.codePointAt(0);if(this.a.has(y))return 0;if(this.b.nonBasicASCII)return 1;let R=!1,m=!1;if(A)for(const M of A){const d=M.codePointAt(0),b=i.$2d(M);R=R||b,!b&&!this.ambiguousCharacters.isAmbiguous(d)&&!i.$ie.isInvisibleCharacter(d)&&(m=!0)}return!R&&m?0:this.b.invisibleCharacters&&!E(e)&&i.$ie.isInvisibleCharacter(y)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(y)?3:0}}function E(c){return c===" "||c===`
`||c==="	"}var h;(function(c){c[c.None=0]="None",c[c.NonBasicASCII=1]="NonBasicASCII",c[c.Invisible=2]="Invisible",c[c.Ambiguous=3]="Ambiguous"})(h||(h={}))}),Z(K[53],ne([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var P;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(P||(t.AccessibilitySupport=P={}));var k;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(k||(t.CodeActionTriggerType=k={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i||(t.CompletionItemInsertTextRule=i={}));var a;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(a||(t.CompletionItemKind=a={}));var $;(function(n){n[n.Deprecated=1]="Deprecated"})($||(t.CompletionItemTag=$={}));var o;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(o||(t.CompletionTriggerKind=o={}));var s;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(s||(t.ContentWidgetPositionPreference=s={}));var u;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(u||(t.CursorChangeReason=u={}));var g;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(g||(t.DefaultEndOfLine=g={}));var E;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(E||(t.DocumentHighlightKind=E={}));var h;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(h||(t.EditorAutoIndentStrategy=h={}));var c;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=8]="autoClosingDelete",n[n.autoClosingOvertype=9]="autoClosingOvertype",n[n.autoClosingQuotes=10]="autoClosingQuotes",n[n.autoIndent=11]="autoIndent",n[n.automaticLayout=12]="automaticLayout",n[n.autoSurround=13]="autoSurround",n[n.bracketPairColorization=14]="bracketPairColorization",n[n.guides=15]="guides",n[n.codeLens=16]="codeLens",n[n.codeLensFontFamily=17]="codeLensFontFamily",n[n.codeLensFontSize=18]="codeLensFontSize",n[n.colorDecorators=19]="colorDecorators",n[n.colorDecoratorsLimit=20]="colorDecoratorsLimit",n[n.columnSelection=21]="columnSelection",n[n.comments=22]="comments",n[n.contextmenu=23]="contextmenu",n[n.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",n[n.cursorBlinking=25]="cursorBlinking",n[n.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",n[n.cursorStyle=27]="cursorStyle",n[n.cursorSurroundingLines=28]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",n[n.cursorWidth=30]="cursorWidth",n[n.disableLayerHinting=31]="disableLayerHinting",n[n.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",n[n.domReadOnly=33]="domReadOnly",n[n.dragAndDrop=34]="dragAndDrop",n[n.dropIntoEditor=35]="dropIntoEditor",n[n.emptySelectionClipboard=36]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",n[n.extraEditorClassName=38]="extraEditorClassName",n[n.fastScrollSensitivity=39]="fastScrollSensitivity",n[n.find=40]="find",n[n.fixedOverflowWidgets=41]="fixedOverflowWidgets",n[n.folding=42]="folding",n[n.foldingStrategy=43]="foldingStrategy",n[n.foldingHighlight=44]="foldingHighlight",n[n.foldingImportsByDefault=45]="foldingImportsByDefault",n[n.foldingMaximumRegions=46]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=48]="fontFamily",n[n.fontInfo=49]="fontInfo",n[n.fontLigatures=50]="fontLigatures",n[n.fontSize=51]="fontSize",n[n.fontWeight=52]="fontWeight",n[n.fontVariations=53]="fontVariations",n[n.formatOnPaste=54]="formatOnPaste",n[n.formatOnType=55]="formatOnType",n[n.glyphMargin=56]="glyphMargin",n[n.gotoLocation=57]="gotoLocation",n[n.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",n[n.hover=59]="hover",n[n.inDiffEditor=60]="inDiffEditor",n[n.inlineSuggest=61]="inlineSuggest",n[n.letterSpacing=62]="letterSpacing",n[n.lightbulb=63]="lightbulb",n[n.lineDecorationsWidth=64]="lineDecorationsWidth",n[n.lineHeight=65]="lineHeight",n[n.lineNumbers=66]="lineNumbers",n[n.lineNumbersMinChars=67]="lineNumbersMinChars",n[n.linkedEditing=68]="linkedEditing",n[n.links=69]="links",n[n.matchBrackets=70]="matchBrackets",n[n.minimap=71]="minimap",n[n.mouseStyle=72]="mouseStyle",n[n.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=74]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",n[n.multiCursorModifier=76]="multiCursorModifier",n[n.multiCursorPaste=77]="multiCursorPaste",n[n.multiCursorLimit=78]="multiCursorLimit",n[n.occurrencesHighlight=79]="occurrencesHighlight",n[n.overviewRulerBorder=80]="overviewRulerBorder",n[n.overviewRulerLanes=81]="overviewRulerLanes",n[n.padding=82]="padding",n[n.pasteAs=83]="pasteAs",n[n.parameterHints=84]="parameterHints",n[n.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",n[n.quickSuggestions=87]="quickSuggestions",n[n.quickSuggestionsDelay=88]="quickSuggestionsDelay",n[n.readOnly=89]="readOnly",n[n.readOnlyMessage=90]="readOnlyMessage",n[n.renameOnType=91]="renameOnType",n[n.renderControlCharacters=92]="renderControlCharacters",n[n.renderFinalNewline=93]="renderFinalNewline",n[n.renderLineHighlight=94]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=96]="renderValidationDecorations",n[n.renderWhitespace=97]="renderWhitespace",n[n.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",n[n.roundedSelection=99]="roundedSelection",n[n.rulers=100]="rulers",n[n.scrollbar=101]="scrollbar",n[n.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=103]="scrollBeyondLastLine",n[n.scrollPredominantAxis=104]="scrollPredominantAxis",n[n.selectionClipboard=105]="selectionClipboard",n[n.selectionHighlight=106]="selectionHighlight",n[n.selectOnLineNumbers=107]="selectOnLineNumbers",n[n.showFoldingControls=108]="showFoldingControls",n[n.showUnused=109]="showUnused",n[n.snippetSuggestions=110]="snippetSuggestions",n[n.smartSelect=111]="smartSelect",n[n.smoothScrolling=112]="smoothScrolling",n[n.stickyScroll=113]="stickyScroll",n[n.stickyTabStops=114]="stickyTabStops",n[n.stopRenderingLineAfter=115]="stopRenderingLineAfter",n[n.suggest=116]="suggest",n[n.suggestFontSize=117]="suggestFontSize",n[n.suggestLineHeight=118]="suggestLineHeight",n[n.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",n[n.suggestSelection=120]="suggestSelection",n[n.tabCompletion=121]="tabCompletion",n[n.tabIndex=122]="tabIndex",n[n.unicodeHighlighting=123]="unicodeHighlighting",n[n.unusualLineTerminators=124]="unusualLineTerminators",n[n.useShadowDOM=125]="useShadowDOM",n[n.useTabStops=126]="useTabStops",n[n.wordBreak=127]="wordBreak",n[n.wordSeparators=128]="wordSeparators",n[n.wordWrap=129]="wordWrap",n[n.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=132]="wordWrapColumn",n[n.wordWrapOverride1=133]="wordWrapOverride1",n[n.wordWrapOverride2=134]="wordWrapOverride2",n[n.wrappingIndent=135]="wrappingIndent",n[n.wrappingStrategy=136]="wrappingStrategy",n[n.showDeprecated=137]="showDeprecated",n[n.inlayHints=138]="inlayHints",n[n.editorClassName=139]="editorClassName",n[n.pixelRatio=140]="pixelRatio",n[n.tabFocusMode=141]="tabFocusMode",n[n.layoutInfo=142]="layoutInfo",n[n.wrappingInfo=143]="wrappingInfo",n[n.defaultColorDecorators=144]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn"})(c||(t.EditorOption=c={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var A;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(A||(t.EndOfLineSequence=A={}));var y;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(y||(t.GlyphMarginLane=y={}));var R;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(R||(t.IndentAction=R={}));var m;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(m||(t.InjectedTextCursorStops=m={}));var M;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(M||(t.InlayHintKind=M={}));var d;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(d||(t.InlineCompletionTriggerKind=d={}));var b;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(b||(t.KeyCode=b={}));var r;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(r||(t.MarkerSeverity=r={}));var l;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(l||(t.MarkerTag=l={}));var N;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(N||(t.MinimapPosition=N={}));var f;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(f||(t.MouseTargetType=f={}));var w;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(w||(t.OverlayWidgetPositionPreference=w={}));var v;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(v||(t.OverviewRulerLane=v={}));var L;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(L||(t.PositionAffinity=L={}));var F;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(F||(t.RenderLineNumbersType=F={}));var _;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(_||(t.RenderMinimap=_={}));var I;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(I||(t.ScrollType=I={}));var V;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(V||(t.ScrollbarVisibility=V={}));var z;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(z||(t.SelectionDirection=z={}));var C;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(C||(t.SignatureHelpTriggerKind=C={}));var O;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(O||(t.SymbolKind=O={}));var p;(function(n){n[n.Deprecated=1]="Deprecated"})(p||(t.SymbolTag=p={}));var q;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(q||(t.TextEditorCursorBlinkingStyle=q={}));var X;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(X||(t.TextEditorCursorStyle=X={}));var B;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(B||(t.TrackedRangeStickiness=B={}));var J;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(J||(t.WrappingIndent=J={}))}),Z(K[54],ne([0,1,8,7]),function(H,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$es=void 0;class i{constructor(){this.a=new Map,this.b=new Map,this.c=new P.$8c,this.onDidChange=this.c.event,this.d=null}handleChange(o){this.c.fire({changedLanguages:o,changedColorMap:!1})}register(o,s){return this.a.set(o,s),this.handleChange([o]),(0,k.$jb)(()=>{this.a.get(o)===s&&(this.a.delete(o),this.handleChange([o]))})}get(o){return this.a.get(o)||null}registerFactory(o,s){this.b.get(o)?.dispose();const u=new a(this,o,s);return this.b.set(o,u),(0,k.$jb)(()=>{const g=this.b.get(o);!g||g!==u||(this.b.delete(o),g.dispose())})}async getOrCreate(o){const s=this.get(o);if(s)return s;const u=this.b.get(o);return!u||u.isResolved?null:(await u.resolve(),this.get(o))}isResolved(o){if(this.get(o))return!0;const u=this.b.get(o);return!!(!u||u.isResolved)}setColorMap(o){this.d=o,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$es=i;class a extends k.$lb{get isResolved(){return this.c}constructor(o,s,u){super(),this.f=o,this.g=s,this.h=u,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const o=await this.h.tokenizationSupport;this.c=!0,o&&!this.a&&this.B(this.f.register(this.g,o))}}}),Z(K[55],ne([56,57]),function(H,t){return H.create("vs/base/common/platform",t)}),Z(K[13],ne([0,1,55]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H=t.$G=t.$F=t.$E=t.$D=t.$C=t.OS=t.OperatingSystem=t.$A=t.$z=t.$y=t.$x=t.$w=t.Language=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=t.$f=void 0,t.$f="en";let k=!1,i=!1,a=!1,$=!1,o=!1,s=!1,u=!1,g=!1,E=!1,h=!1,c,e=t.$f,A=t.$f,y,R;t.$g=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof t.$g.vscode<"u"&&typeof t.$g.vscode.process<"u"?m=t.$g.vscode.process:typeof process<"u"&&(m=process);const M=typeof m?.versions?.electron=="string",d=M&&m?.type==="renderer";if(typeof navigator=="object"&&!d)R=navigator.userAgent,k=R.indexOf("Windows")>=0,i=R.indexOf("Macintosh")>=0,g=(R.indexOf("Macintosh")>=0||R.indexOf("iPad")>=0||R.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,a=R.indexOf("Linux")>=0,h=R?.indexOf("Mobi")>=0,s=!0,c=P.getConfiguredDefaultLocale(P.localize(0,null))||t.$f,e=c,A=navigator.language;else if(typeof m=="object"){k=m.platform==="win32",i=m.platform==="darwin",a=m.platform==="linux",$=a&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,u=M,E=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=t.$f,e=t.$f;const F=m.env.VSCODE_NLS_CONFIG;if(F)try{const _=JSON.parse(F),I=_.availableLanguages["*"];c=_.locale,A=_.osLocale,e=I||t.$f,y=_._translationsConfigFile}catch{}o=!0}else console.error("Unable to resolve platform.");var b;(function(F){F[F.Web=0]="Web",F[F.Mac=1]="Mac",F[F.Linux=2]="Linux",F[F.Windows=3]="Windows"})(b||(t.Platform=b={}));function r(F){switch(F){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=r;let l=0;i?l=1:k?l=3:a&&(l=2),t.$i=k,t.$j=i,t.$k=a,t.$l=$,t.$m=o,t.$n=u,t.$o=s,t.$p=s&&typeof t.$g.importScripts=="function",t.$q=g,t.$r=h,t.$s=E,t.$t=l,t.$u=R,t.$v=e;var N;(function(F){function _(){return t.$v}F.value=_;function I(){return t.$v.length===2?t.$v==="en":t.$v.length>=3?t.$v[0]==="e"&&t.$v[1]==="n"&&t.$v[2]==="-":!1}F.isDefaultVariant=I;function V(){return t.$v==="en"}F.isDefault=V})(N||(t.Language=N={})),t.$w=c,t.$x=A,t.$y=y,t.$z=typeof t.$g.postMessage=="function"&&!t.$g.importScripts,t.$A=(()=>{if(t.$z){const F=[];t.$g.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let V=0,z=F.length;V<z;V++){const C=F[V];if(C.id===I.data.vscodeScheduleAsyncWork){F.splice(V,1),C.callback();return}}});let _=0;return I=>{const V=++_;F.push({id:V,callback:I}),t.$g.postMessage({vscodeScheduleAsyncWork:V},"*")}}return F=>setTimeout(F)})();var f;(function(F){F[F.Windows=1]="Windows",F[F.Macintosh=2]="Macintosh",F[F.Linux=3]="Linux"})(f||(t.OperatingSystem=f={})),t.OS=i||g?2:k?1:3;let w=!0,v=!1;function L(){if(!v){v=!0;const F=new Uint8Array(2);F[0]=1,F[1]=2,w=new Uint16Array(F.buffer)[0]===(2<<8)+1}return w}t.$C=L,t.$D=!!(t.$u&&t.$u.indexOf("Chrome")>=0),t.$E=!!(t.$u&&t.$u.indexOf("Firefox")>=0),t.$F=!!(!t.$D&&t.$u&&t.$u.indexOf("Safari")>=0),t.$G=!!(t.$u&&t.$u.indexOf("Edg/")>=0),t.$H=!!(t.$u&&t.$u.indexOf("Android")>=0)}),Z(K[58],ne([0,1,13]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8b=t.$7b=t.env=t.cwd=void 0;let k;if(typeof P.$g.vscode<"u"&&typeof P.$g.vscode.process<"u"){const i=P.$g.vscode.process;k={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:k={get platform(){return P.$i?"win32":P.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=k.cwd,t.env=k.env,t.$7b=k.platform,t.$8b=k.arch}),Z(K[59],ne([0,1,58]),function(H,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kc=t.sep=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=t.$dc=t.$cc=t.$bc=t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=void 0;const k=65,i=97,a=90,$=122,o=46,s=47,u=92,g=58,E=63;class h extends Error{constructor(l,N,f){let w;typeof N=="string"&&N.indexOf("not ")===0?(w="must not be",N=N.replace(/^not /,"")):w="must be";const v=l.indexOf(".")!==-1?"property":"argument";let L=`The "${l}" ${v} ${w} of type ${N}`;L+=`. Received type ${typeof f}`,super(L),this.code="ERR_INVALID_ARG_TYPE"}}function c(r,l){if(r===null||typeof r!="object")throw new h(l,"Object",r)}function e(r,l){if(typeof r!="string")throw new h(l,"string",r)}const A=P.$7b==="win32";function y(r){return r===s||r===u}function R(r){return r===s}function m(r){return r>=k&&r<=a||r>=i&&r<=$}function M(r,l,N,f){let w="",v=0,L=-1,F=0,_=0;for(let I=0;I<=r.length;++I){if(I<r.length)_=r.charCodeAt(I);else{if(f(_))break;_=s}if(f(_)){if(!(L===I-1||F===1))if(F===2){if(w.length<2||v!==2||w.charCodeAt(w.length-1)!==o||w.charCodeAt(w.length-2)!==o){if(w.length>2){const V=w.lastIndexOf(N);V===-1?(w="",v=0):(w=w.slice(0,V),v=w.length-1-w.lastIndexOf(N)),L=I,F=0;continue}else if(w.length!==0){w="",v=0,L=I,F=0;continue}}l&&(w+=w.length>0?`${N}..`:"..",v=2)}else w.length>0?w+=`${N}${r.slice(L+1,I)}`:w=r.slice(L+1,I),v=I-L-1;L=I,F=0}else _===o&&F!==-1?++F:F=-1}return w}function d(r,l){c(l,"pathObject");const N=l.dir||l.root,f=l.base||`${l.name||""}${l.ext||""}`;return N?N===l.root?`${N}${f}`:`${N}${r}${f}`:f}t.$9b={resolve(...r){let l="",N="",f=!1;for(let w=r.length-1;w>=-1;w--){let v;if(w>=0){if(v=r[w],e(v,"path"),v.length===0)continue}else l.length===0?v=P.cwd():(v=P.env[`=${l}`]||P.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==l.toLowerCase()&&v.charCodeAt(2)===u)&&(v=`${l}\\`));const L=v.length;let F=0,_="",I=!1;const V=v.charCodeAt(0);if(L===1)y(V)&&(F=1,I=!0);else if(y(V))if(I=!0,y(v.charCodeAt(1))){let z=2,C=z;for(;z<L&&!y(v.charCodeAt(z));)z++;if(z<L&&z!==C){const O=v.slice(C,z);for(C=z;z<L&&y(v.charCodeAt(z));)z++;if(z<L&&z!==C){for(C=z;z<L&&!y(v.charCodeAt(z));)z++;(z===L||z!==C)&&(_=`\\\\${O}\\${v.slice(C,z)}`,F=z)}}}else F=1;else m(V)&&v.charCodeAt(1)===g&&(_=v.slice(0,2),F=2,L>2&&y(v.charCodeAt(2))&&(I=!0,F=3));if(_.length>0)if(l.length>0){if(_.toLowerCase()!==l.toLowerCase())continue}else l=_;if(f){if(l.length>0)break}else if(N=`${v.slice(F)}\\${N}`,f=I,I&&l.length>0)break}return N=M(N,!f,"\\",y),f?`${l}\\${N}`:`${l}${N}`||"."},normalize(r){e(r,"path");const l=r.length;if(l===0)return".";let N=0,f,w=!1;const v=r.charCodeAt(0);if(l===1)return R(v)?"\\":r;if(y(v))if(w=!0,y(r.charCodeAt(1))){let F=2,_=F;for(;F<l&&!y(r.charCodeAt(F));)F++;if(F<l&&F!==_){const I=r.slice(_,F);for(_=F;F<l&&y(r.charCodeAt(F));)F++;if(F<l&&F!==_){for(_=F;F<l&&!y(r.charCodeAt(F));)F++;if(F===l)return`\\\\${I}\\${r.slice(_)}\\`;F!==_&&(f=`\\\\${I}\\${r.slice(_,F)}`,N=F)}}}else N=1;else m(v)&&r.charCodeAt(1)===g&&(f=r.slice(0,2),N=2,l>2&&y(r.charCodeAt(2))&&(w=!0,N=3));let L=N<l?M(r.slice(N),!w,"\\",y):"";return L.length===0&&!w&&(L="."),L.length>0&&y(r.charCodeAt(l-1))&&(L+="\\"),f===void 0?w?`\\${L}`:L:w?`${f}\\${L}`:`${f}${L}`},isAbsolute(r){e(r,"path");const l=r.length;if(l===0)return!1;const N=r.charCodeAt(0);return y(N)||l>2&&m(N)&&r.charCodeAt(1)===g&&y(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let l,N;for(let v=0;v<r.length;++v){const L=r[v];e(L,"path"),L.length>0&&(l===void 0?l=N=L:l+=`\\${L}`)}if(l===void 0)return".";let f=!0,w=0;if(typeof N=="string"&&y(N.charCodeAt(0))){++w;const v=N.length;v>1&&y(N.charCodeAt(1))&&(++w,v>2&&(y(N.charCodeAt(2))?++w:f=!1))}if(f){for(;w<l.length&&y(l.charCodeAt(w));)w++;w>=2&&(l=`\\${l.slice(w)}`)}return t.$9b.normalize(l)},relative(r,l){if(e(r,"from"),e(l,"to"),r===l)return"";const N=t.$9b.resolve(r),f=t.$9b.resolve(l);if(N===f||(r=N.toLowerCase(),l=f.toLowerCase(),r===l))return"";let w=0;for(;w<r.length&&r.charCodeAt(w)===u;)w++;let v=r.length;for(;v-1>w&&r.charCodeAt(v-1)===u;)v--;const L=v-w;let F=0;for(;F<l.length&&l.charCodeAt(F)===u;)F++;let _=l.length;for(;_-1>F&&l.charCodeAt(_-1)===u;)_--;const I=_-F,V=L<I?L:I;let z=-1,C=0;for(;C<V;C++){const p=r.charCodeAt(w+C);if(p!==l.charCodeAt(F+C))break;p===u&&(z=C)}if(C!==V){if(z===-1)return f}else{if(I>V){if(l.charCodeAt(F+C)===u)return f.slice(F+C+1);if(C===2)return f.slice(F+C)}L>V&&(r.charCodeAt(w+C)===u?z=C:C===2&&(z=3)),z===-1&&(z=0)}let O="";for(C=w+z+1;C<=v;++C)(C===v||r.charCodeAt(C)===u)&&(O+=O.length===0?"..":"\\..");return F+=z,O.length>0?`${O}${f.slice(F,_)}`:(f.charCodeAt(F)===u&&++F,f.slice(F,_))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const l=t.$9b.resolve(r);if(l.length<=2)return r;if(l.charCodeAt(0)===u){if(l.charCodeAt(1)===u){const N=l.charCodeAt(2);if(N!==E&&N!==o)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(m(l.charCodeAt(0))&&l.charCodeAt(1)===g&&l.charCodeAt(2)===u)return`\\\\?\\${l}`;return r},dirname(r){e(r,"path");const l=r.length;if(l===0)return".";let N=-1,f=0;const w=r.charCodeAt(0);if(l===1)return y(w)?r:".";if(y(w)){if(N=f=1,y(r.charCodeAt(1))){let F=2,_=F;for(;F<l&&!y(r.charCodeAt(F));)F++;if(F<l&&F!==_){for(_=F;F<l&&y(r.charCodeAt(F));)F++;if(F<l&&F!==_){for(_=F;F<l&&!y(r.charCodeAt(F));)F++;if(F===l)return r;F!==_&&(N=f=F+1)}}}}else m(w)&&r.charCodeAt(1)===g&&(N=l>2&&y(r.charCodeAt(2))?3:2,f=N);let v=-1,L=!0;for(let F=l-1;F>=f;--F)if(y(r.charCodeAt(F))){if(!L){v=F;break}}else L=!1;if(v===-1){if(N===-1)return".";v=N}return r.slice(0,v)},basename(r,l){l!==void 0&&e(l,"ext"),e(r,"path");let N=0,f=-1,w=!0,v;if(r.length>=2&&m(r.charCodeAt(0))&&r.charCodeAt(1)===g&&(N=2),l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let L=l.length-1,F=-1;for(v=r.length-1;v>=N;--v){const _=r.charCodeAt(v);if(y(_)){if(!w){N=v+1;break}}else F===-1&&(w=!1,F=v+1),L>=0&&(_===l.charCodeAt(L)?--L===-1&&(f=v):(L=-1,f=F))}return N===f?f=F:f===-1&&(f=r.length),r.slice(N,f)}for(v=r.length-1;v>=N;--v)if(y(r.charCodeAt(v))){if(!w){N=v+1;break}}else f===-1&&(w=!1,f=v+1);return f===-1?"":r.slice(N,f)},extname(r){e(r,"path");let l=0,N=-1,f=0,w=-1,v=!0,L=0;r.length>=2&&r.charCodeAt(1)===g&&m(r.charCodeAt(0))&&(l=f=2);for(let F=r.length-1;F>=l;--F){const _=r.charCodeAt(F);if(y(_)){if(!v){f=F+1;break}continue}w===-1&&(v=!1,w=F+1),_===o?N===-1?N=F:L!==1&&(L=1):N!==-1&&(L=-1)}return N===-1||w===-1||L===0||L===1&&N===w-1&&N===f+1?"":r.slice(N,w)},format:d.bind(null,"\\"),parse(r){e(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const N=r.length;let f=0,w=r.charCodeAt(0);if(N===1)return y(w)?(l.root=l.dir=r,l):(l.base=l.name=r,l);if(y(w)){if(f=1,y(r.charCodeAt(1))){let z=2,C=z;for(;z<N&&!y(r.charCodeAt(z));)z++;if(z<N&&z!==C){for(C=z;z<N&&y(r.charCodeAt(z));)z++;if(z<N&&z!==C){for(C=z;z<N&&!y(r.charCodeAt(z));)z++;z===N?f=z:z!==C&&(f=z+1)}}}}else if(m(w)&&r.charCodeAt(1)===g){if(N<=2)return l.root=l.dir=r,l;if(f=2,y(r.charCodeAt(2))){if(N===3)return l.root=l.dir=r,l;f=3}}f>0&&(l.root=r.slice(0,f));let v=-1,L=f,F=-1,_=!0,I=r.length-1,V=0;for(;I>=f;--I){if(w=r.charCodeAt(I),y(w)){if(!_){L=I+1;break}continue}F===-1&&(_=!1,F=I+1),w===o?v===-1?v=I:V!==1&&(V=1):v!==-1&&(V=-1)}return F!==-1&&(v===-1||V===0||V===1&&v===F-1&&v===L+1?l.base=l.name=r.slice(L,F):(l.name=r.slice(L,v),l.base=r.slice(L,F),l.ext=r.slice(v,F))),L>0&&L!==f?l.dir=r.slice(0,L-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const b=(()=>{if(A){const r=/\\/g;return()=>{const l=P.cwd().replace(r,"/");return l.slice(l.indexOf("/"))}}return()=>P.cwd()})();t.$0b={resolve(...r){let l="",N=!1;for(let f=r.length-1;f>=-1&&!N;f--){const w=f>=0?r[f]:b();e(w,"path"),w.length!==0&&(l=`${w}/${l}`,N=w.charCodeAt(0)===s)}return l=M(l,!N,"/",R),N?`/${l}`:l.length>0?l:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===s,N=r.charCodeAt(r.length-1)===s;return r=M(r,!l,"/",R),r.length===0?l?"/":N?"./":".":(N&&(r+="/"),l?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===s},join(...r){if(r.length===0)return".";let l;for(let N=0;N<r.length;++N){const f=r[N];e(f,"path"),f.length>0&&(l===void 0?l=f:l+=`/${f}`)}return l===void 0?".":t.$0b.normalize(l)},relative(r,l){if(e(r,"from"),e(l,"to"),r===l||(r=t.$0b.resolve(r),l=t.$0b.resolve(l),r===l))return"";const N=1,f=r.length,w=f-N,v=1,L=l.length-v,F=w<L?w:L;let _=-1,I=0;for(;I<F;I++){const z=r.charCodeAt(N+I);if(z!==l.charCodeAt(v+I))break;z===s&&(_=I)}if(I===F)if(L>F){if(l.charCodeAt(v+I)===s)return l.slice(v+I+1);if(I===0)return l.slice(v+I)}else w>F&&(r.charCodeAt(N+I)===s?_=I:I===0&&(_=0));let V="";for(I=N+_+1;I<=f;++I)(I===f||r.charCodeAt(I)===s)&&(V+=V.length===0?"..":"/..");return`${V}${l.slice(v+_)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===s;let N=-1,f=!0;for(let w=r.length-1;w>=1;--w)if(r.charCodeAt(w)===s){if(!f){N=w;break}}else f=!1;return N===-1?l?"/":".":l&&N===1?"//":r.slice(0,N)},basename(r,l){l!==void 0&&e(l,"ext"),e(r,"path");let N=0,f=-1,w=!0,v;if(l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let L=l.length-1,F=-1;for(v=r.length-1;v>=0;--v){const _=r.charCodeAt(v);if(_===s){if(!w){N=v+1;break}}else F===-1&&(w=!1,F=v+1),L>=0&&(_===l.charCodeAt(L)?--L===-1&&(f=v):(L=-1,f=F))}return N===f?f=F:f===-1&&(f=r.length),r.slice(N,f)}for(v=r.length-1;v>=0;--v)if(r.charCodeAt(v)===s){if(!w){N=v+1;break}}else f===-1&&(w=!1,f=v+1);return f===-1?"":r.slice(N,f)},extname(r){e(r,"path");let l=-1,N=0,f=-1,w=!0,v=0;for(let L=r.length-1;L>=0;--L){const F=r.charCodeAt(L);if(F===s){if(!w){N=L+1;break}continue}f===-1&&(w=!1,f=L+1),F===o?l===-1?l=L:v!==1&&(v=1):l!==-1&&(v=-1)}return l===-1||f===-1||v===0||v===1&&l===f-1&&l===N+1?"":r.slice(l,f)},format:d.bind(null,"/"),parse(r){e(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const N=r.charCodeAt(0)===s;let f;N?(l.root="/",f=1):f=0;let w=-1,v=0,L=-1,F=!0,_=r.length-1,I=0;for(;_>=f;--_){const V=r.charCodeAt(_);if(V===s){if(!F){v=_+1;break}continue}L===-1&&(F=!1,L=_+1),V===o?w===-1?w=_:I!==1&&(I=1):w!==-1&&(I=-1)}if(L!==-1){const V=v===0&&N?1:v;w===-1||I===0||I===1&&w===L-1&&w===v+1?l.base=l.name=r.slice(V,L):(l.name=r.slice(V,w),l.base=r.slice(V,L),l.ext=r.slice(w,L))}return v>0?l.dir=r.slice(0,v-1):N&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},t.$0b.win32=t.$9b.win32=t.$9b,t.$0b.posix=t.$9b.posix=t.$0b,t.$$b=A?t.$9b.normalize:t.$0b.normalize,t.$_b=A?t.$9b.isAbsolute:t.$0b.isAbsolute,t.$ac=A?t.$9b.join:t.$0b.join,t.$bc=A?t.$9b.resolve:t.$0b.resolve,t.$cc=A?t.$9b.relative:t.$0b.relative,t.$dc=A?t.$9b.dirname:t.$0b.dirname,t.$ec=A?t.$9b.basename:t.$0b.basename,t.$fc=A?t.$9b.extname:t.$0b.extname,t.$gc=A?t.$9b.format:t.$0b.format,t.$hc=A?t.$9b.parse:t.$0b.parse,t.$ic=A?t.$9b.toNamespacedPath:t.$0b.toNamespacedPath,t.sep=A?t.$9b.sep:t.$0b.sep,t.$kc=A?t.$9b.delimiter:t.$0b.delimiter}),Z(K[14],ne([0,1,59,13]),function(H,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ve=t.$Ue=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,a=/^\//,$=/^\/\//;function o(f,w){if(!f.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${f.authority}", path: "${f.path}", query: "${f.query}", fragment: "${f.fragment}"}`);if(f.scheme&&!i.test(f.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(f.path){if(f.authority){if(!a.test(f.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if($.test(f.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function s(f,w){return!f&&!w?"file":f}function u(f,w){switch(f){case"https":case"http":case"file":w?w[0]!==E&&(w=E+w):w=E;break}return w}const g="",E="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(w){return w instanceof c?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,v,L,F,_,I=!1){typeof w=="object"?(this.scheme=w.scheme||g,this.authority=w.authority||g,this.path=w.path||g,this.query=w.query||g,this.fragment=w.fragment||g):(this.scheme=s(w,I),this.authority=v||g,this.path=u(this.scheme,L||g),this.query=F||g,this.fragment=_||g,o(this,I))}get fsPath(){return d(this,!1)}with(w){if(!w)return this;let{scheme:v,authority:L,path:F,query:_,fragment:I}=w;return v===void 0?v=this.scheme:v===null&&(v=g),L===void 0?L=this.authority:L===null&&(L=g),F===void 0?F=this.path:F===null&&(F=g),_===void 0?_=this.query:_===null&&(_=g),I===void 0?I=this.fragment:I===null&&(I=g),v===this.scheme&&L===this.authority&&F===this.path&&_===this.query&&I===this.fragment?this:new y(v,L,F,_,I)}static parse(w,v=!1){const L=h.exec(w);return L?new y(L[2]||g,N(L[4]||g),N(L[5]||g),N(L[7]||g),N(L[9]||g),v):new y(g,g,g,g,g)}static file(w){let v=g;if(k.$i&&(w=w.replace(/\\/g,E)),w[0]===E&&w[1]===E){const L=w.indexOf(E,2);L===-1?(v=w.substring(2),w=E):(v=w.substring(2,L),w=w.substring(L)||E)}return new y("file",v,w,g,g)}static from(w,v){return new y(w.scheme,w.authority,w.path,w.query,w.fragment,v)}static joinPath(w,...v){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let L;return k.$i&&w.scheme==="file"?L=c.file(P.$9b.join(d(w,!0),...v)).path:L=P.$0b.join(w.path,...v),w.with({path:L})}toString(w=!1){return b(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof c)return w;{const v=new y(w);return v._formatted=w.external??null,v._fsPath=w._sep===A?w.fsPath??null:null,v}}else return w}}t.URI=c;function e(f){return!f||typeof f!="object"?!1:typeof f.scheme=="string"&&(typeof f.authority=="string"||typeof f.authority>"u")&&(typeof f.path=="string"||typeof f.path>"u")&&(typeof f.query=="string"||typeof f.query>"u")&&(typeof f.fragment=="string"||typeof f.fragment>"u")}t.$Ue=e;const A=k.$i?1:void 0;class y extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(w=!1){return w?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=A),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const R={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(f,w,v){let L,F=-1;for(let _=0;_<f.length;_++){const I=f.charCodeAt(_);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||w&&I===47||v&&I===91||v&&I===93||v&&I===58)F!==-1&&(L+=encodeURIComponent(f.substring(F,_)),F=-1),L!==void 0&&(L+=f.charAt(_));else{L===void 0&&(L=f.substr(0,_));const V=R[I];V!==void 0?(F!==-1&&(L+=encodeURIComponent(f.substring(F,_)),F=-1),L+=V):F===-1&&(F=_)}}return F!==-1&&(L+=encodeURIComponent(f.substring(F))),L!==void 0?L:f}function M(f){let w;for(let v=0;v<f.length;v++){const L=f.charCodeAt(v);L===35||L===63?(w===void 0&&(w=f.substr(0,v)),w+=R[L]):w!==void 0&&(w+=f[v])}return w!==void 0?w:f}function d(f,w){let v;return f.authority&&f.path.length>1&&f.scheme==="file"?v=`//${f.authority}${f.path}`:f.path.charCodeAt(0)===47&&(f.path.charCodeAt(1)>=65&&f.path.charCodeAt(1)<=90||f.path.charCodeAt(1)>=97&&f.path.charCodeAt(1)<=122)&&f.path.charCodeAt(2)===58?w?v=f.path.substr(1):v=f.path[1].toLowerCase()+f.path.substr(2):v=f.path,k.$i&&(v=v.replace(/\//g,"\\")),v}t.$Ve=d;function b(f,w){const v=w?M:m;let L="",{scheme:F,authority:_,path:I,query:V,fragment:z}=f;if(F&&(L+=F,L+=":"),(_||F==="file")&&(L+=E,L+=E),_){let C=_.indexOf("@");if(C!==-1){const O=_.substr(0,C);_=_.substr(C+1),C=O.lastIndexOf(":"),C===-1?L+=v(O,!1,!1):(L+=v(O.substr(0,C),!1,!1),L+=":",L+=v(O.substr(C+1),!1,!0)),L+="@"}_=_.toLowerCase(),C=_.lastIndexOf(":"),C===-1?L+=v(_,!1,!0):(L+=v(_.substr(0,C),!1,!0),L+=_.substr(C))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const C=I.charCodeAt(1);C>=65&&C<=90&&(I=`/${String.fromCharCode(C+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const C=I.charCodeAt(0);C>=65&&C<=90&&(I=`${String.fromCharCode(C+32)}:${I.substr(2)}`)}L+=v(I,!0,!1)}return V&&(L+="?",L+=v(V,!1,!1)),z&&(L+="#",L+=w?z:m(z,!1,!1)),L}function r(f){try{return decodeURIComponent(f)}catch{return f.length>3?f.substr(0,3)+r(f.substr(3)):f}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(f){return f.match(l)?f.replace(l,w=>r(w)):f}}),Z(K[64],ne([0,1,3,8,7,11,13,5]),function(H,t,P,k,i,a,$,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const s="$initialize";let u=!1;function g(N){$.$o&&(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(N.message))}t.logOnceWebWorkerWarning=g;var E;(function(N){N[N.Request=0]="Request",N[N.Reply=1]="Reply",N[N.SubscribeEvent=2]="SubscribeEvent",N[N.Event=3]="Event",N[N.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class h{constructor(f,w,v,L){this.vsWorker=f,this.req=w,this.method=v,this.args=L,this.type=0}}class c{constructor(f,w,v,L){this.vsWorker=f,this.seq=w,this.res=v,this.err=L,this.type=1}}class e{constructor(f,w,v,L){this.vsWorker=f,this.req=w,this.eventName=v,this.arg=L,this.type=2}}class A{constructor(f,w,v){this.vsWorker=f,this.req=w,this.event=v,this.type=3}}class y{constructor(f,w){this.vsWorker=f,this.req=w,this.type=4}}class R{constructor(f){this.a=-1,this.g=f,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(f){this.a=f}sendMessage(f,w){const v=String(++this.b);return new Promise((L,F)=>{this.c[v]={resolve:L,reject:F},this.o(new h(this.a,v,f,w))})}listen(f,w){let v=null;const L=new k.$8c({onWillAddFirstListener:()=>{v=String(++this.b),this.d.set(v,L),this.o(new e(this.a,v,f,w))},onDidRemoveLastListener:()=>{this.d.delete(v),this.o(new y(this.a,v)),v=null}});return L.event}handleMessage(f){!f||!f.vsWorker||this.a!==-1&&f.vsWorker!==this.a||this.h(f)}h(f){switch(f.type){case 1:return this.j(f);case 0:return this.k(f);case 2:return this.l(f);case 3:return this.m(f);case 4:return this.n(f)}}j(f){if(!this.c[f.seq]){console.warn("Got reply to unknown seq");return}const w=this.c[f.seq];if(delete this.c[f.seq],f.err){let v=f.err;f.err.$isError&&(v=new Error,v.name=f.err.name,v.message=f.err.message,v.stack=f.err.stack),w.reject(v);return}w.resolve(f.res)}k(f){const w=f.req;this.g.handleMessage(f.method,f.args).then(L=>{this.o(new c(this.a,w,L,void 0))},L=>{L.detail instanceof Error&&(L.detail=(0,P.$1)(L.detail)),this.o(new c(this.a,w,void 0,(0,P.$1)(L)))})}l(f){const w=f.req,v=this.g.handleEvent(f.eventName,f.arg)(L=>{this.o(new A(this.a,w,L))});this.f.set(w,v)}m(f){if(!this.d.has(f.req)){console.warn("Got event for unknown req");return}this.d.get(f.req).fire(f.event)}n(f){if(!this.f.has(f.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(f.req).dispose(),this.f.delete(f.req)}o(f){const w=[];if(f.type===0)for(let v=0;v<f.args.length;v++)f.args[v]instanceof ArrayBuffer&&w.push(f.args[v]);else f.type===1&&f.res instanceof ArrayBuffer&&w.push(f.res);this.g.sendMessage(f,w)}}class m extends i.$lb{constructor(f,w,v){super();let L=null;this.a=this.B(f.create("vs/base/common/worker/simpleWorker",C=>{this.c.handleMessage(C)},C=>{L?.(C)})),this.c=new R({sendMessage:(C,O)=>{this.a.postMessage(C,O)},handleMessage:(C,O)=>{if(typeof v[C]!="function")return Promise.reject(new Error("Missing method "+C+" on main thread host."));try{return Promise.resolve(v[C].apply(v,O))}catch(p){return Promise.reject(p)}},handleEvent:(C,O)=>{if(d(C)){const p=v[C].call(v,O);if(typeof p!="function")throw new Error(`Missing dynamic event ${C} on main thread host.`);return p}if(M(C)){const p=v[C];if(typeof p!="function")throw new Error(`Missing event ${C} on main thread host.`);return p}throw new Error(`Malformed event name ${C}`)}}),this.c.setWorkerId(this.a.getId());let F=null;const _=globalThis.require;typeof _<"u"&&typeof _.getConfig=="function"?F=_.getConfig():typeof globalThis.requirejs<"u"&&(F=globalThis.requirejs.s.contexts._.config);const I=(0,a.$Rm)(v);this.b=this.c.sendMessage(s,[this.a.getId(),JSON.parse(JSON.stringify(F)),w,I]);const V=(C,O)=>this.g(C,O),z=(C,O)=>this.c.listen(C,O);this.f=new Promise((C,O)=>{L=O,this.b.then(p=>{C(b(p,V,z))},p=>{O(p),this.h("Worker failed to load "+w,p)})})}getProxyObject(){return this.f}g(f,w){return new Promise((v,L)=>{this.b.then(()=>{this.c.sendMessage(f,w).then(v,L)},L)})}h(f,w){console.error(f),console.info(w)}}t.SimpleWorkerClient=m;function M(N){return N[0]==="o"&&N[1]==="n"&&o.$Ld(N.charCodeAt(2))}function d(N){return/^onDynamic/.test(N)&&o.$Ld(N.charCodeAt(9))}function b(N,f,w){const v=_=>function(){const I=Array.prototype.slice.call(arguments,0);return f(_,I)},L=_=>function(I){return w(_,I)},F={};for(const _ of N){if(d(_)){F[_]=L(_);continue}if(M(_)){F[_]=w(_,void 0);continue}F[_]=v(_)}return F}class r{constructor(f,w){this.a=w,this.b=null,this.c=new R({sendMessage:(v,L)=>{f(v,L)},handleMessage:(v,L)=>this.d(v,L),handleEvent:(v,L)=>this.f(v,L)})}onmessage(f){this.c.handleMessage(f)}d(f,w){if(f===s)return this.g(w[0],w[1],w[2],w[3]);if(!this.b||typeof this.b[f]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+f));try{return Promise.resolve(this.b[f].apply(this.b,w))}catch(v){return Promise.reject(v)}}f(f,w){if(!this.b)throw new Error("Missing requestHandler");if(d(f)){const v=this.b[f].call(this.b,w);if(typeof v!="function")throw new Error(`Missing dynamic event ${f} on request handler.`);return v}if(M(f)){const v=this.b[f];if(typeof v!="function")throw new Error(`Missing event ${f} on request handler.`);return v}throw new Error(`Malformed event name ${f}`)}g(f,w,v,L){this.c.setWorkerId(f);const I=b(L,(V,z)=>this.c.sendMessage(V,z),(V,z)=>this.c.listen(V,z));return this.a?(this.b=this.a(I),Promise.resolve((0,a.$Rm)(this.b))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy!==void 0&&delete w.trustedTypesPolicy,w.catchError=!0,globalThis.require.config(w)),new Promise((V,z)=>{(globalThis.require||H)([v],O=>{if(this.b=O.create(I),!this.b){z(new Error("No RequestHandler!"));return}V((0,a.$Rm)(this.b))},z)}))}}t.SimpleWorkerServer=r;function l(N){return new r(N,null)}t.create=l}),Z(K[60],ne([56,57]),function(H,t){return H.create("vs/editor/common/languages",t)}),Z(K[61],ne([0,1,35,14,36,2,54,60]),function(H,t,P,k,i,a,$,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$ws=t.$vs=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$us=t.$ts=t.SymbolKinds=t.SymbolTag=t.$ss=t.$rs=t.SymbolKind=t.$qs=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$ps=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$os=t.$ns=t.$ms=void 0;class s{constructor(q,X,B){this.offset=q,this.type=X,this.language=B,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$ms=s;class u{constructor(q,X){this.tokens=q,this.endState=X,this._tokenizationResultBrand=void 0}}t.$ns=u;class g{constructor(q,X){this.tokens=q,this.endState=X,this._encodedTokenizationResultBrand=void 0}}t.$os=g;var E;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(E||(t.CompletionItemKind=E={}));var h;(function(p){const q=new Map;q.set(0,P.$Cj.symbolMethod),q.set(1,P.$Cj.symbolFunction),q.set(2,P.$Cj.symbolConstructor),q.set(3,P.$Cj.symbolField),q.set(4,P.$Cj.symbolVariable),q.set(5,P.$Cj.symbolClass),q.set(6,P.$Cj.symbolStruct),q.set(7,P.$Cj.symbolInterface),q.set(8,P.$Cj.symbolModule),q.set(9,P.$Cj.symbolProperty),q.set(10,P.$Cj.symbolEvent),q.set(11,P.$Cj.symbolOperator),q.set(12,P.$Cj.symbolUnit),q.set(13,P.$Cj.symbolValue),q.set(15,P.$Cj.symbolEnum),q.set(14,P.$Cj.symbolConstant),q.set(15,P.$Cj.symbolEnum),q.set(16,P.$Cj.symbolEnumMember),q.set(17,P.$Cj.symbolKeyword),q.set(27,P.$Cj.symbolSnippet),q.set(18,P.$Cj.symbolText),q.set(19,P.$Cj.symbolColor),q.set(20,P.$Cj.symbolFile),q.set(21,P.$Cj.symbolReference),q.set(22,P.$Cj.symbolCustomColor),q.set(23,P.$Cj.symbolFolder),q.set(24,P.$Cj.symbolTypeParameter),q.set(25,P.$Cj.account),q.set(26,P.$Cj.issues);function X(n){let ee=q.get(n);return ee||(console.info("No codicon found for CompletionItemKind "+n),ee=P.$Cj.symbolProperty),ee}p.toIcon=X;const B=new Map;B.set("method",0),B.set("function",1),B.set("constructor",2),B.set("field",3),B.set("variable",4),B.set("class",5),B.set("struct",6),B.set("interface",7),B.set("module",8),B.set("property",9),B.set("event",10),B.set("operator",11),B.set("unit",12),B.set("value",13),B.set("constant",14),B.set("enum",15),B.set("enum-member",16),B.set("enumMember",16),B.set("keyword",17),B.set("snippet",27),B.set("text",18),B.set("color",19),B.set("file",20),B.set("reference",21),B.set("customcolor",22),B.set("folder",23),B.set("type-parameter",24),B.set("typeParameter",24),B.set("account",25),B.set("issue",26);function J(n,ee){let ue=B.get(n);return typeof ue>"u"&&!ee&&(ue=9),ue}p.fromString=J})(h||(t.CompletionItemKinds=h={}));var c;(function(p){p[p.Deprecated=1]="Deprecated"})(c||(t.CompletionItemTag=c={}));var e;(function(p){p[p.None=0]="None",p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var A;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(A||(t.CompletionTriggerKind=A={}));var y;(function(p){p[p.Automatic=0]="Automatic",p[p.Explicit=1]="Explicit"})(y||(t.InlineCompletionTriggerKind=y={}));class R{constructor(q,X,B,J){this.range=q,this.text=X,this.completionKind=B,this.isSnippetText=J}equals(q){return a.$Or.lift(this.range).equalsRange(q.range)&&this.text===q.text&&this.completionKind===q.completionKind&&this.isSnippetText===q.isSnippetText}}t.$ps=R;var m;(function(p){p[p.Invoke=1]="Invoke",p[p.Auto=2]="Auto"})(m||(t.CodeActionTriggerType=m={}));var M;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(M||(t.SignatureHelpTriggerKind=M={}));var d;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(d||(t.DocumentHighlightKind=d={}));function b(p){return p&&k.URI.isUri(p.uri)&&a.$Or.isIRange(p.range)&&(a.$Or.isIRange(p.originSelectionRange)||a.$Or.isIRange(p.targetSelectionRange))}t.$qs=b;var r;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(r||(t.SymbolKind=r={})),t.$rs={[17]:(0,o.localize)(0,null),[16]:(0,o.localize)(1,null),[4]:(0,o.localize)(2,null),[13]:(0,o.localize)(3,null),[8]:(0,o.localize)(4,null),[9]:(0,o.localize)(5,null),[21]:(0,o.localize)(6,null),[23]:(0,o.localize)(7,null),[7]:(0,o.localize)(8,null),[0]:(0,o.localize)(9,null),[11]:(0,o.localize)(10,null),[10]:(0,o.localize)(11,null),[19]:(0,o.localize)(12,null),[5]:(0,o.localize)(13,null),[1]:(0,o.localize)(14,null),[2]:(0,o.localize)(15,null),[20]:(0,o.localize)(16,null),[15]:(0,o.localize)(17,null),[18]:(0,o.localize)(18,null),[24]:(0,o.localize)(19,null),[3]:(0,o.localize)(20,null),[6]:(0,o.localize)(21,null),[14]:(0,o.localize)(22,null),[22]:(0,o.localize)(23,null),[25]:(0,o.localize)(24,null),[12]:(0,o.localize)(25,null)};function l(p,q){return(0,o.localize)(26,null,p,t.$rs[q])}t.$ss=l;var N;(function(p){p[p.Deprecated=1]="Deprecated"})(N||(t.SymbolTag=N={}));var f;(function(p){const q=new Map;q.set(0,P.$Cj.symbolFile),q.set(1,P.$Cj.symbolModule),q.set(2,P.$Cj.symbolNamespace),q.set(3,P.$Cj.symbolPackage),q.set(4,P.$Cj.symbolClass),q.set(5,P.$Cj.symbolMethod),q.set(6,P.$Cj.symbolProperty),q.set(7,P.$Cj.symbolField),q.set(8,P.$Cj.symbolConstructor),q.set(9,P.$Cj.symbolEnum),q.set(10,P.$Cj.symbolInterface),q.set(11,P.$Cj.symbolFunction),q.set(12,P.$Cj.symbolVariable),q.set(13,P.$Cj.symbolConstant),q.set(14,P.$Cj.symbolString),q.set(15,P.$Cj.symbolNumber),q.set(16,P.$Cj.symbolBoolean),q.set(17,P.$Cj.symbolArray),q.set(18,P.$Cj.symbolObject),q.set(19,P.$Cj.symbolKey),q.set(20,P.$Cj.symbolNull),q.set(21,P.$Cj.symbolEnumMember),q.set(22,P.$Cj.symbolStruct),q.set(23,P.$Cj.symbolEvent),q.set(24,P.$Cj.symbolOperator),q.set(25,P.$Cj.symbolTypeParameter);function X(B){let J=q.get(B);return J||(console.info("No codicon found for SymbolKind "+B),J=P.$Cj.symbolProperty),J}p.toIcon=X})(f||(t.SymbolKinds=f={}));class w{static asEditOperation(q){return i.$Vr.replace(a.$Or.lift(q.range),q.text)}}t.$ts=w;class v{static{this.Comment=new v("comment")}static{this.Imports=new v("imports")}static{this.Region=new v("region")}static fromValue(q){switch(q){case"comment":return v.Comment;case"imports":return v.Imports;case"region":return v.Region}return new v(q)}constructor(q){this.value=q}}t.$us=v;var L;(function(p){function q(X){return!X||typeof X!="object"?!1:typeof X.id=="string"&&typeof X.title=="string"}p.is=q})(L||(t.Command=L={}));var F;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(F||(t.CommentThreadCollapsibleState=F={}));var _;(function(p){p[p.Unresolved=0]="Unresolved",p[p.Resolved=1]="Resolved"})(_||(t.CommentThreadState=_={}));var I;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(I||(t.CommentMode=I={}));var V;(function(p){p[p.Published=0]="Published",p[p.Draft=1]="Draft"})(V||(t.CommentState=V={}));var z;(function(p){p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(z||(t.InlayHintKind=z={}));class C{constructor(q){this.b=q,this.a=null}dispose(){this.a&&this.a.then(q=>{q&&q.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$vs=C,t.$ws=new $.$es;var O;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(O||(t.ExternalUriOpenerPriority=O={}))}),Z(K[62],ne([0,1,20,8,31,14,4,2,37,61,53]),function(H,t,P,k,i,a,$,o,s,u,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dX=t.$cX=void 0;class E{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,A){return(0,i.$kq)(e,A)}}t.$cX=E;function h(){return{editor:void 0,languages:void 0,CancellationTokenSource:P.$ed,Emitter:k.$8c,KeyCode:g.KeyCode,KeyMod:E,Position:$.$Nr,Range:o.$Or,Selection:s.$Wr,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:a.URI,Token:u.$ms}}t.$dX=h}),Z(K[65],ne([0,1,21,14,4,2,50,25,46,47,62,19,52,27,44,11,3,45]),function(H,t,P,k,i,a,$,o,s,u,g,E,h,c,e,A,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class m extends $.$wu{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(r){const l=[];for(let N=0;N<this.f.length;N++){const f=this.f[N],w=this.offsetAt(new i.$Nr(N+1,1)),v=f.matchAll(r);for(const L of v)(L.index||L.index===0)&&(L.index=L.index+w),l.push(L)}return l}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(r){return this.f[r-1]}getWordAtPosition(r,l){const N=(0,o.$Mr)(r.column,(0,o.$Kr)(l),this.f[r.lineNumber-1],0);return N?new a.$Or(r.lineNumber,N.startColumn,r.lineNumber,N.endColumn):null}getWordUntilPosition(r,l){const N=this.getWordAtPosition(r,l);return N?{word:this.f[r.lineNumber-1].substring(N.startColumn-1,r.column-1),startColumn:N.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const l=this.f,N=this.q.bind(this);let f=0,w="",v=0,L=[];return{*[Symbol.iterator](){for(;;)if(v<L.length){const F=w.substring(L[v].start,L[v].end);v+=1,yield F}else if(f<l.length)w=l[f],L=N(w,r),v=0,f+=1;else break}}}getLineWords(r,l){const N=this.f[r-1],f=this.q(N,l),w=[];for(const v of f)w.push({word:N.substring(v.start,v.end),startColumn:v.start+1,endColumn:v.end+1});return w}q(r,l){const N=[];let f;for(l.lastIndex=0;(f=l.exec(r))&&f[0].length!==0;)N.push({start:f.index,end:f.index+f[0].length});return N}getValueInRange(r){if(r=this.r(r),r.startLineNumber===r.endLineNumber)return this.f[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const l=this.g,N=r.startLineNumber-1,f=r.endLineNumber-1,w=[];w.push(this.f[N].substring(r.startColumn-1));for(let v=N+1;v<f;v++)w.push(this.f[v]);return w.push(this.f[f].substring(0,r.endColumn-1)),w.join(l)}offsetAt(r){return r=this.s(r),this.l(),this.j.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this.l();const l=this.j.getIndexOf(r),N=this.f[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,N)}}r(r){const l=this.s({lineNumber:r.startLineNumber,column:r.startColumn}),N=this.s({lineNumber:r.endLineNumber,column:r.endColumn});return l.lineNumber!==r.startLineNumber||l.column!==r.startColumn||N.lineNumber!==r.endLineNumber||N.column!==r.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:N.lineNumber,endColumn:N.column}:r}s(r){if(!i.$Nr.isIPosition(r))throw new Error("bad position");let{lineNumber:l,column:N}=r,f=!1;if(l<1)l=1,N=1,f=!0;else if(l>this.f.length)l=this.f.length,N=this.f[l-1].length+1,f=!0;else{const w=this.f[l-1].length+1;N<1?(N=1,f=!0):N>w&&(N=w,f=!0)}return f?{lineNumber:l,column:N}:r}}class M{constructor(r,l){this.d=r,this.f=Object.create(null),this.g=l,this.h=null}dispose(){this.f=Object.create(null)}j(r){return this.f[r]}k(){const r=[];return Object.keys(this.f).forEach(l=>r.push(this.f[l])),r}acceptNewModel(r){this.f[r.url]=new m(k.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,l){if(!this.f[r])return;this.f[r].onEvents(l)}acceptRemovedModel(r){this.f[r]&&delete this.f[r]}async computeUnicodeHighlights(r,l,N){const f=this.j(r);return f?h.$0W.computeUnicodeHighlights(f,l,N):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(r,l,N,f){const w=this.j(r),v=this.j(l);return!w||!v?null:M.l(w,v,N,f)}static l(r,l,N,f){const w=f==="advanced"?e.$wX.getAdvanced():e.$wX.getLegacy(),v=r.getLinesContent(),L=l.getLinesContent(),F=w.computeDiff(v,L,N),_=F.changes.length>0?!1:this.n(r,l);function I(V){return V.map(z=>[z.originalRange.startLineNumber,z.originalRange.endLineNumberExclusive,z.modifiedRange.startLineNumber,z.modifiedRange.endLineNumberExclusive,z.innerChanges?.map(C=>[C.originalRange.startLineNumber,C.originalRange.startColumn,C.originalRange.endLineNumber,C.originalRange.endColumn,C.modifiedRange.startLineNumber,C.modifiedRange.startColumn,C.modifiedRange.endLineNumber,C.modifiedRange.endColumn])])}return{identical:_,quitEarly:F.hitTimeout,changes:I(F.changes),moves:F.moves.map(V=>[V.lineRangeMapping.original.startLineNumber,V.lineRangeMapping.original.endLineNumberExclusive,V.lineRangeMapping.modified.startLineNumber,V.lineRangeMapping.modified.endLineNumberExclusive,I(V.changes)])}}static n(r,l){const N=r.getLineCount(),f=l.getLineCount();if(N!==f)return!1;for(let w=1;w<=N;w++){const v=r.getLineContent(w),L=l.getLineContent(w);if(v!==L)return!1}return!0}async computeDirtyDiff(r,l,N){const f=this.j(r),w=this.j(l);if(!f||!w)return null;const v=f.getLinesContent(),L=w.getLinesContent();return new c.$qu(v,L,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:N,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(r,l,N){const f=this.j(r);if(!f)return l;const w=[];let v;l=l.slice(0).sort((L,F)=>{if(L.range&&F.range)return a.$Or.compareRangesUsingStarts(L.range,F.range);const _=L.range?0:1,I=F.range?0:1;return _-I});for(let{range:L,text:F,eol:_}of l){if(typeof _=="number"&&(v=_),a.$Or.isEmpty(L)&&!F)continue;const I=f.getValueInRange(L);if(F=F.replace(/\r\n|\n|\r/g,f.eol),I===F)continue;if(Math.max(F.length,I.length)>M.o){w.push({range:L,text:F});continue}const V=(0,P.$nu)(I,F,N),z=f.offsetAt(a.$Or.lift(L).getStartPosition());for(const C of V){const O=f.positionAt(z+C.originalStart),p=f.positionAt(z+C.originalStart+C.originalLength),q={text:F.substr(C.modifiedStart,C.modifiedLength),range:{startLineNumber:O.lineNumber,startColumn:O.column,endLineNumber:p.lineNumber,endColumn:p.column}};f.getValueInRange(q.range)!==q.text&&w.push(q)}}return typeof v=="number"&&w.push({eol:v,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeHumanReadableDiff(r,l,N){const f=this.j(r);if(!f)return l;const w=[];let v;l=l.slice(0).sort((L,F)=>{if(L.range&&F.range)return a.$Or.compareRangesUsingStarts(L.range,F.range);const _=L.range?0:1,I=F.range?0:1;return _-I});for(let{range:L,text:F,eol:_}of l){let p=function(X,B){return new i.$Nr(X.lineNumber+B.lineNumber-1,B.lineNumber===1?X.column+B.column-1:B.column)},q=function(X,B){const J=[];for(let n=B.startLineNumber;n<=B.endLineNumber;n++){const ee=X[n-1];n===B.startLineNumber&&n===B.endLineNumber?J.push(ee.substring(B.startColumn-1,B.endColumn-1)):n===B.startLineNumber?J.push(ee.substring(B.startColumn-1)):n===B.endLineNumber?J.push(ee.substring(0,B.endColumn-1)):J.push(ee)}return J};if(typeof _=="number"&&(v=_),a.$Or.isEmpty(L)&&!F)continue;const I=f.getValueInRange(L);if(F=F.replace(/\r\n|\n|\r/g,f.eol),I===F)continue;if(Math.max(F.length,I.length)>M.o){w.push({range:L,text:F});continue}const V=I.split(/\r\n|\n|\r/),z=F.split(/\r\n|\n|\r/),C=e.$wX.getAdvanced().computeDiff(V,z,N),O=a.$Or.lift(L).getStartPosition();for(const X of C.changes)if(X.innerChanges)for(const B of X.innerChanges)w.push({range:a.$Or.fromPositions(p(O,B.originalRange.getStartPosition()),p(O,B.originalRange.getEndPosition())),text:q(z,B.modifiedRange).join(f.eol)});else throw new y.$bb("The experimental diff algorithm always produces inner changes")}return typeof v=="number"&&w.push({eol:v,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeLinks(r){const l=this.j(r);return l?(0,s.$aX)(l):null}async computeDefaultDocumentColors(r){const l=this.j(r);return l?(0,R.$xX)(l):null}static{this.p=1e4}async textualSuggest(r,l,N,f){const w=new E.$4c,v=new RegExp(N,f),L=new Set;e:for(const F of r){const _=this.j(F);if(_){for(const I of _.words(v))if(!(I===l||!isNaN(Number(I)))&&(L.add(I),L.size>M.p))break e}}return{words:Array.from(L),duration:w.elapsed()}}async computeWordRanges(r,l,N,f){const w=this.j(r);if(!w)return Object.create(null);const v=new RegExp(N,f),L=Object.create(null);for(let F=l.startLineNumber;F<l.endLineNumber;F++){const _=w.getLineWords(F,v);for(const I of _){if(!isNaN(Number(I.word)))continue;let V=L[I.word];V||(V=[],L[I.word]=V),V.push({startLineNumber:F,startColumn:I.startColumn,endLineNumber:F,endColumn:I.endColumn})}}return L}async navigateValueSet(r,l,N,f,w){const v=this.j(r);if(!v)return null;const L=new RegExp(f,w);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const F=v.getValueInRange(l),_=v.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},L);if(!_)return null;const I=v.getValueInRange(_);return u.$bX.INSTANCE.navigateValueSet(l,F,_,I,N)}loadForeignModule(r,l,N){const f=(L,F)=>this.d.fhr(L,F),v={host:(0,A.$Sm)(N,f),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(v,l),Promise.resolve((0,A.$Rm)(this.h))):new Promise((L,F)=>{H([r],_=>{this.h=_.create(v,l),L((0,A.$Rm)(this.h))},F)})}fmr(r,l){if(!this.h||typeof this.h[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.h[r].apply(this.h,l))}catch(N){return Promise.reject(N)}}}t.EditorSimpleWorker=M;function d(b){return new M(b,null)}t.create=d,typeof importScripts=="function"&&(globalThis.monaco=(0,g.$dX)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/93d3731736cc6fefbd63810d5fb2d57bedc84ca0/core/vs/base/worker/workerMain.js.map
