/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/types","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/arrays","vs/base/common/strings","vs/platform/telemetry/common/telemetry","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/node/state","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/stream","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/lazy","vs/base/common/normalization","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/parts/ipc/node/ipc.net","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/code/electron-main/auth","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ie=function(V){for(var e=[],E=0,C=V.length;E<C;E++)e[E]=te[V[E]];return e};define(te[134],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=e.$9r=e.$8r=e.$7r=void 0;function E(S,f){const u=Math.pow(10,f);return Math.round(S*u)/u}class C{constructor(f,u,$,d=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=E(Math.max(Math.min(1,d),0),3)}static equals(f,u){return f.r===u.r&&f.g===u.g&&f.b===u.b&&f.a===u.a}}e.$7r=C;class r{constructor(f,u,$,d){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=E(Math.max(Math.min(1,u),0),3),this.l=E(Math.max(Math.min(1,$),0),3),this.a=E(Math.max(Math.min(1,d),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.l===u.l&&f.a===u.a}static fromRGBA(f){const u=f.r/255,$=f.g/255,d=f.b/255,p=f.a,h=Math.max(u,$,d),v=Math.min(u,$,d);let y=0,o=0;const g=(v+h)/2,c=h-v;if(c>0){switch(o=Math.min(g<=.5?c/(2*g):c/(2-2*g),1),h){case u:y=($-d)/c+($<d?6:0);break;case $:y=(d-u)/c+2;break;case d:y=(u-$)/c+4;break}y*=60,y=Math.round(y)}return new r(y,o,g,p)}static i(f,u,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?f+(u-f)*6*$:$<1/2?u:$<2/3?f+(u-f)*(2/3-$)*6:f}static toRGBA(f){const u=f.h/360,{s:$,l:d,a:p}=f;let h,v,y;if($===0)h=v=y=d;else{const o=d<.5?d*(1+$):d+$-d*$,g=2*d-o;h=r.i(g,o,u+1/3),v=r.i(g,o,u),y=r.i(g,o,u-1/3)}return new C(Math.round(h*255),Math.round(v*255),Math.round(y*255),p)}}e.$8r=r;class O{constructor(f,u,$,d){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=E(Math.max(Math.min(1,u),0),3),this.v=E(Math.max(Math.min(1,$),0),3),this.a=E(Math.max(Math.min(1,d),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.v===u.v&&f.a===u.a}static fromRGBA(f){const u=f.r/255,$=f.g/255,d=f.b/255,p=Math.max(u,$,d),h=Math.min(u,$,d),v=p-h,y=p===0?0:v/p;let o;return v===0?o=0:p===u?o=(($-d)/v%6+6)%6:p===$?o=(d-u)/v+2:o=(u-$)/v+4,new O(Math.round(o*60),y,p,f.a)}static toRGBA(f){const{h:u,s:$,v:d,a:p}=f,h=d*$,v=h*(1-Math.abs(u/60%2-1)),y=d-h;let[o,g,c]=[0,0,0];return u<60?(o=h,g=v):u<120?(o=v,g=h):u<180?(g=h,c=v):u<240?(g=v,c=h):u<300?(o=v,c=h):u<=360&&(o=h,c=v),o=Math.round((o+y)*255),g=Math.round((g+y)*255),c=Math.round((c+y)*255),new C(o,g,c,p)}}e.$9r=O;class R{static fromHex(f){return R.Format.CSS.parseHex(f)||R.red}static equals(f,u){return!f&&!u?!0:!f||!u?!1:f.equals(u)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:O.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof C)this.rgba=f;else if(f instanceof r)this.i=f,this.rgba=r.toRGBA(f);else if(f instanceof O)this.j=f,this.rgba=O.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&C.equals(this.rgba,f.rgba)&&r.equals(this.hsla,f.hsla)&&O.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=R.k(this.rgba.r),u=R.k(this.rgba.g),$=R.k(this.rgba.b),d=.2126*f+.7152*u+.0722*$;return E(d,4)}static k(f){const u=f/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(f){const u=this.getRelativeLuminance(),$=f.getRelativeLuminance();return u>$?(u+.05)/($+.05):($+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const u=this.getRelativeLuminance(),$=f.getRelativeLuminance();return u>$}isDarkerThan(f){const u=this.getRelativeLuminance(),$=f.getRelativeLuminance();return u<$}lighten(f){return new R(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new R(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:u,g:$,b:d,a:p}=this.rgba;return new R(new C(u,$,d,p*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new R(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const u=f.rgba,$=this.rgba.a,d=u.a,p=$+d*(1-$);if(p<1e-6)return R.transparent;const h=this.rgba.r*$/p+u.r*d*(1-$)/p,v=this.rgba.g*$/p+u.g*d*(1-$)/p,y=this.rgba.b*$/p+u.b*d*(1-$)/p;return new R(new C(h,v,y,p))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:u,g:$,b:d,a:p}=this.rgba;return new R(new C(f.rgba.r-p*(f.rgba.r-u),f.rgba.g-p*(f.rgba.g-$),f.rgba.b-p*(f.rgba.b-d),1))}flatten(...f){const u=f.reduceRight(($,d)=>R.o(d,$));return R.o(this,u)}static o(f,u){const $=1-f.rgba.a;return new R(new C($*u.rgba.r+f.rgba.a*f.rgba.r,$*u.rgba.g+f.rgba.a*f.rgba.g,$*u.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=R.Format.CSS.format(this)),this.u}static getLighterColor(f,u,$){if(f.isLighterThan(u))return f;$=$||.5;const d=f.getRelativeLuminance(),p=u.getRelativeLuminance();return $=$*(p-d)/p,f.lighten($)}static getDarkerColor(f,u,$){if(f.isDarkerThan(u))return f;$=$||.5;const d=f.getRelativeLuminance(),p=u.getRelativeLuminance();return $=$*(d-p)/d,f.darken($)}static{this.white=new R(new C(255,255,255,1))}static{this.black=new R(new C(0,0,0,1))}static{this.red=new R(new C(255,0,0,1))}static{this.blue=new R(new C(0,0,255,1))}static{this.green=new R(new C(0,255,0,1))}static{this.cyan=new R(new C(0,255,255,1))}static{this.lightgrey=new R(new C(211,211,211,1))}static{this.transparent=new R(new C(0,0,0,0))}}e.$0r=R,function(S){let f;(function(u){let $;(function(d){function p(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:S.Format.CSS.formatRGBA(t)}d.formatRGB=p;function h(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}d.formatRGBA=h;function v(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(t)}d.formatHSL=v;function y(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}d.formatHSLA=y;function o(t){const l=t.toString(16);return l.length!==2?"0"+l:l}function g(t){return`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}`}d.formatHex=g;function c(t,l=!1){return l&&t.rgba.a===1?S.Format.CSS.formatHex(t):`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}${o(Math.round(t.rgba.a*255))}`}d.formatHexA=c;function b(t){return t.isOpaque()?S.Format.CSS.formatHex(t):S.Format.CSS.formatRGBA(t)}d.format=b;function k(t){const l=t.length;if(l===0||t.charCodeAt(0)!==35)return null;if(l===7){const s=16*w(t.charCodeAt(1))+w(t.charCodeAt(2)),n=16*w(t.charCodeAt(3))+w(t.charCodeAt(4)),i=16*w(t.charCodeAt(5))+w(t.charCodeAt(6));return new S(new C(s,n,i,1))}if(l===9){const s=16*w(t.charCodeAt(1))+w(t.charCodeAt(2)),n=16*w(t.charCodeAt(3))+w(t.charCodeAt(4)),i=16*w(t.charCodeAt(5))+w(t.charCodeAt(6)),a=16*w(t.charCodeAt(7))+w(t.charCodeAt(8));return new S(new C(s,n,i,a/255))}if(l===4){const s=w(t.charCodeAt(1)),n=w(t.charCodeAt(2)),i=w(t.charCodeAt(3));return new S(new C(16*s+s,16*n+n,16*i+i))}if(l===5){const s=w(t.charCodeAt(1)),n=w(t.charCodeAt(2)),i=w(t.charCodeAt(3)),a=w(t.charCodeAt(4));return new S(new C(16*s+s,16*n+n,16*i+i,(16*a+a)/255))}return null}d.parseHex=k;function w(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})($=u.CSS||(u.CSS={}))})(f=S.Format||(S.Format={}))}(R||(e.$0r=R={}))}),define(te[55],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.$Ug=e.$Tg=void 0;function E(R){return(S,f,u)=>{let $=null,d=null;if(typeof u.value=="function"?($="value",d=u.value):typeof u.get=="function"&&($="get",d=u.get),!d)throw new Error("not supported");u[$]=R(d,f)}}function C(R,S,f){let u=null,$=null;if(typeof f.value=="function"?(u="value",$=f.value,$.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(u="get",$=f.get),!$)throw new Error("not supported");const d=`$memoize$${S}`;f[u]=function(...p){return this.hasOwnProperty(d)||Object.defineProperty(this,d,{configurable:!1,enumerable:!1,writable:!1,value:$.apply(this,p)}),this[d]}}e.$Tg=C;function r(R,S,f){return E((u,$)=>{const d=`$debounce$${$}`,p=`$debounce$result$${$}`;return function(...h){this[p]||(this[p]=f?f():void 0),clearTimeout(this[d]),S&&(this[p]=S(this[p],...h),h=[this[p]]),this[d]=setTimeout(()=>{u.apply(this,h),this[p]=f?f():void 0},R)}})}e.$Ug=r;function O(R,S,f){return E((u,$)=>{const d=`$throttle$timer$${$}`,p=`$throttle$result$${$}`,h=`$throttle$lastRun$${$}`,v=`$throttle$pending$${$}`;return function(...y){if(this[p]||(this[p]=f?f():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),S&&(this[p]=S(this[p],...y)),this[v])return;const o=this[h]+R;o<=Date.now()?(this[h]=Date.now(),u.apply(this,[this[p]]),this[p]=f?f():void 0):(this[v]=!0,this[d]=setTimeout(()=>{this[v]=!1,this[h]=Date.now(),u.apply(this,[this[p]]),this[p]=f?f():void 0},o-Date.now()))}})}e.$Vg=O}),define(te[13],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class E{constructor(){this.b=[],this.a=function(l){setTimeout(()=>{throw l.stack?k.isErrorNoTelemetry(l)?new k(l.message+`

`+l.stack):new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.b.push(l),()=>{this.d(l)}}c(l){this.b.forEach(s=>{s(l)})}d(l){this.b.splice(this.b.indexOf(l),1)}setUnexpectedErrorHandler(l){this.a=l}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(l){this.a(l),this.c(l)}onUnexpectedExternalError(l){this.a(l)}}e.$U=E,e.$V=new E;function C(t){e.$V.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=C;function r(t){if(!t||typeof t!="object")return!1;const l=t;return l.code==="EPIPE"&&l.syscall?.toUpperCase()==="WRITE"}e.$X=r;function O(t){u(t)||e.$V.onUnexpectedError(t)}e.$Y=O;function R(t){u(t)||e.$V.onUnexpectedExternalError(t)}e.$Z=R;function S(t){if(t instanceof Error){const{name:l,message:s}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:l,message:s,stack:n,noTelemetry:k.isErrorNoTelemetry(t)}}return t}e.$1=S;const f="Canceled";function u(t){return t instanceof $?!0:t instanceof Error&&t.name===f&&t.message===f}e.$2=u;class $ extends Error{constructor(){super(f),this.name=this.message}}e.$3=$;function d(){const t=new Error(f);return t.name=t.message,t}e.$4=d;function p(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.$5=p;function h(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.$6=h;function v(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.$7=v;function y(t){const l=new Error(`${t} has been disposed`);return l.name="DISPOSED",l}e.$8=y;function o(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.$9=o;class g extends Error{constructor(l){super("NotImplemented"),l&&(this.message=l)}}e.$0=g;class c extends Error{constructor(l){super("NotSupported"),l&&(this.message=l)}}e.$$=c;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=b;class k extends Error{constructor(l){super(l),this.name="CodeExpectedError"}static fromError(l){if(l instanceof k)return l;const s=new k;return s.message=l.message,s.stack=l.stack,s}static isErrorNoTelemetry(l){return l.name==="CodeExpectedError"}}e.$ab=k;class w extends Error{constructor(l){super(l||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype)}}e.$bb=w}),define(te[24],ie([0,1,13]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.CompareResult=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.top=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=void 0;function C(z,Y=0){return z[z.length-(1+Y)]}e.$_e=C;function r(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.$af=r;function O(z,Y,x=(ae,he)=>ae===he){if(z===Y)return!0;if(!z||!Y||z.length!==Y.length)return!1;for(let ae=0,he=z.length;ae<he;ae++)if(!x(z[ae],Y[ae]))return!1;return!0}e.$bf=O;function R(z,Y){const x=z.length-1;Y<x&&(z[Y]=z[x]),z.pop()}e.$cf=R;function S(z,Y,x){return f(z.length,ae=>x(z[ae],Y))}e.$df=S;function f(z,Y){let x=0,ae=z-1;for(;x<=ae;){const he=(x+ae)/2|0,Ie=Y(he);if(Ie<0)x=he+1;else if(Ie>0)ae=he-1;else return he}return-(x+1)}e.$ef=f;function u(z,Y){let x=0,ae=z.length;if(ae===0)return 0;for(;x<ae;){const he=Math.floor((x+ae)/2);Y(z[he])?ae=he:x=he+1}return x}e.$ff=u;function $(z,Y,x){if(z=z|0,z>=Y.length)throw new TypeError("invalid index");const ae=Y[Math.floor(Y.length*Math.random())],he=[],Ie=[],Ee=[];for(const Ae of Y){const Me=x(Ae,ae);Me<0?he.push(Ae):Me>0?Ie.push(Ae):Ee.push(Ae)}return z<he.length?$(z,he,x):z<he.length+Ee.length?Ee[0]:$(z-(he.length+Ee.length),Ie,x)}e.$gf=$;function d(z,Y){const x=[];let ae;for(const he of z.slice(0).sort(Y))!ae||Y(ae[0],he)!==0?(ae=[he],x.push(ae)):ae.push(he);return x}e.$hf=d;function p(z,Y,x){const ae=[];function he(Ae,Me,We){if(Me===0&&We.length===0)return;const $e=ae[ae.length-1];$e&&$e.start+$e.deleteCount===Ae?($e.deleteCount+=Me,$e.toInsert.push(...We)):ae.push({start:Ae,deleteCount:Me,toInsert:We})}let Ie=0,Ee=0;for(;;){if(Ie===z.length){he(Ie,0,Y.slice(Ee));break}if(Ee===Y.length){he(Ie,z.length-Ie,[]);break}const Ae=z[Ie],Me=Y[Ee],We=x(Ae,Me);We===0?(Ie+=1,Ee+=1):We<0?(he(Ie,1,[]),Ie+=1):We>0&&(he(Ie,0,[Me]),Ee+=1)}return ae}e.$if=p;function h(z,Y,x){const ae=p(z,Y,x),he=[],Ie=[];for(const Ee of ae)he.push(...z.slice(Ee.start,Ee.start+Ee.deleteCount)),Ie.push(...Ee.toInsert);return{removed:he,added:Ie}}e.$jf=h;function v(z,Y,x){if(x===0)return[];const ae=z.slice(0,x).sort(Y);return o(z,Y,ae,x,z.length),ae}e.top=v;function y(z,Y,x,ae,he){return x===0?Promise.resolve([]):new Promise((Ie,Ee)=>{(async()=>{const Ae=z.length,Me=z.slice(0,x).sort(Y);for(let We=x,$e=Math.min(x+ae,Ae);We<Ae;We=$e,$e=Math.min($e+ae,Ae)){if(We>x&&await new Promise(be=>setTimeout(be)),he&&he.isCancellationRequested)throw new E.$3;o(z,Y,Me,We,$e)}return Me})().then(Ie,Ee)})}e.$lf=y;function o(z,Y,x,ae,he){for(const Ie=x.length;ae<he;ae++){const Ee=z[ae];if(Y(Ee,x[Ie-1])<0){x.pop();const Ae=u(x,Me=>Y(Ee,Me)<0);x.splice(Ae,0,Ee)}}}function g(z){return z.filter(Y=>!!Y)}e.$mf=g;function c(z){let Y=0;for(let x=0;x<z.length;x++)z[x]&&(z[Y]=z[x],Y+=1);z.length=Y}e.$nf=c;function b(z,Y,x){z.splice(x,0,z.splice(Y,1)[0])}e.$of=b;function k(z){return!Array.isArray(z)||z.length===0}e.$pf=k;function w(z){return Array.isArray(z)&&z.length>0}e.$qf=w;function t(z,Y=x=>x){const x=new Set;return z.filter(ae=>{const he=Y(ae);return x.has(he)?!1:(x.add(he),!0)})}e.$rf=t;function l(z){const Y=new Set;return x=>{const ae=z(x);return Y.has(ae)?!1:(Y.add(ae),!0)}}e.$sf=l;function s(z,Y){const x=n(z,Y);if(x!==-1)return z[x]}e.$tf=s;function n(z,Y){for(let x=z.length-1;x>=0;x--){const ae=z[x];if(Y(ae))return x}return-1}e.$uf=n;function i(z,Y){return z.length>0?z[0]:Y}e.$vf=i;function a(z,Y){return z.length>0?z[z.length-1]:Y}e.$wf=a;function m(z,Y,x=(ae,he)=>ae===he){let ae=0;for(let he=0,Ie=Math.min(z.length,Y.length);he<Ie&&x(z[he],Y[he]);he++)ae++;return ae}e.$xf=m;function P(z){return[].concat(...z)}e.$yf=P;function I(z,Y){let x=typeof Y=="number"?z:0;typeof Y=="number"?x=z:(x=0,Y=z);const ae=[];if(x<=Y)for(let he=x;he<Y;he++)ae.push(he);else for(let he=x;he>Y;he--)ae.push(he);return ae}e.$zf=I;function D(z,Y,x){return z.reduce((ae,he)=>(ae[Y(he)]=x?x(he):he,ae),Object.create(null))}e.$Af=D;function M(z,Y){return z.push(Y),()=>L(z,Y)}e.$Bf=M;function L(z,Y){const x=z.indexOf(Y);if(x>-1)return z.splice(x,1),Y}e.$Cf=L;function N(z,Y,x){const ae=z.slice(0,Y),he=z.slice(Y);return ae.concat(x,he)}e.$Df=N;function B(z,Y){let x;if(typeof Y=="number"){let ae=Y;x=()=>{const he=Math.sin(ae++)*179426549;return he-Math.floor(he)}}else x=Math.random;for(let ae=z.length-1;ae>0;ae-=1){const he=Math.floor(x()*(ae+1)),Ie=z[ae];z[ae]=z[he],z[he]=Ie}}e.$Ef=B;function re(z,Y){const x=z.indexOf(Y);x>-1&&(z.splice(x,1),z.unshift(Y))}e.$Ff=re;function ne(z,Y){const x=z.indexOf(Y);x>-1&&(z.splice(x,1),z.push(Y))}e.$Gf=ne;function ue(z,Y){for(const x of Y)z.push(x)}e.$Hf=ue;function se(z,Y){return Array.isArray(z)?z.map(Y):Y(z)}e.$If=se;function le(z){return Array.isArray(z)?z:[z]}e.$Jf=le;function J(z){return z[Math.floor(Math.random()*z.length)]}e.$Kf=J;function K(z,Y){for(const x of z){const ae=Y(x);if(ae!==void 0)return ae}}e.$Lf=K;function U(z,Y,x){const ae=W(z,Y),he=z.length,Ie=x.length;z.length=he+Ie;for(let Ee=he-1;Ee>=ae;Ee--)z[Ee+Ie]=z[Ee];for(let Ee=0;Ee<Ie;Ee++)z[Ee+ae]=x[Ee]}e.$Mf=U;function T(z,Y,x,ae){const he=W(z,Y),Ie=z.splice(he,x);return U(z,he,ae),Ie}e.$Nf=T;function W(z,Y){return Y<0?Math.max(Y+z.length,0):Math.min(Y,z.length)}var H;(function(z){function Y(he){return he<0}z.isLessThan=Y;function x(he){return he>0}z.isGreaterThan=x;function ae(he){return he===0}z.isNeitherLessOrGreaterThan=ae,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(H||(e.CompareResult=H={}));function Q(z,Y){return(x,ae)=>Y(z(x),z(ae))}e.$Of=Q;function ce(...z){return(Y,x)=>{for(const ae of z){const he=ae(Y,x);if(!H.isNeitherLessOrGreaterThan(he))return he}return H.neitherLessOrGreaterThan}}e.$Pf=ce;const oe=(z,Y)=>z-Y;e.$Qf=oe;function j(z){return(Y,x)=>-z(Y,x)}e.$Rf=j;function A(z,Y){if(z.length===0)return;let x=z[0];for(let ae=1;ae<z.length;ae++){const he=z[ae];Y(he,x)>0&&(x=he)}return x}e.$Sf=A;function F(z,Y){if(z.length===0)return;let x=z[0];for(let ae=1;ae<z.length;ae++){const he=z[ae];Y(he,x)>=0&&(x=he)}return x}e.$Tf=F;function q(z,Y){return A(z,(x,ae)=>-Y(x,ae))}e.$Uf=q;class G{constructor(Y){this.f=Y,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let x=this.c;for(;x<this.f.length&&Y(this.f[x]);)x++;const ae=x===this.c?null:this.f.slice(this.c,x);return this.c=x,ae}takeFromEndWhile(Y){let x=this.d;for(;x>=0&&Y(this.f[x]);)x--;const ae=x===this.d?null:this.f.slice(x+1,this.d+1);return this.d=x,ae}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Y=this.f[this.c];return this.c++,Y}removeLast(){const Y=this.f[this.d];return this.d--,Y}takeCount(Y){const x=this.f.slice(this.c,this.c+Y);return this.c+=Y,x}}e.$Vf=G;class Z{static{this.empty=new Z(Y=>{})}constructor(Y){this.iterate=Y}forEach(Y){this.iterate(x=>(Y(x),!0))}toArray(){const Y=[];return this.iterate(x=>(Y.push(x),!0)),Y}filter(Y){return new Z(x=>this.iterate(ae=>Y(ae)?x(ae):!0))}map(Y){return new Z(x=>this.iterate(ae=>x(Y(ae))))}some(Y){let x=!1;return this.iterate(ae=>(x=Y(ae),!x)),x}findFirst(Y){let x;return this.iterate(ae=>Y(ae)?(x=ae,!1):!0),x}findLast(Y){let x;return this.iterate(ae=>(Y(ae)&&(x=ae),!0)),x}findLastMaxBy(Y){let x,ae=!0;return this.iterate(he=>((ae||H.isGreaterThan(Y(he,x)))&&(ae=!1,x=he),!0)),x}}e.$Wf=Z}),define(te[135],ie([0,1,13]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qc=e.$pc=e.$oc=e.$nc=e.ok=void 0;function C(f,u){if(!f)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=C;function r(f,u="Unreachable"){throw new Error(u)}e.$nc=r;function O(f){if(!f)throw new E.$bb("Assertion Failed")}e.$oc=O;function R(f){if(!f()){debugger;f(),(0,E.$Y)(new E.$bb("Assertion Failed"))}}e.$pc=R;function S(f,u){let $=0;for(;$<f.length-1;){const d=f[$],p=f[$+1];if(!u(d,p))return!1;$++}return!0}e.$qc=S}),define(te[49],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function E(C){const r=this;let O=!1,R;return function(){return O||(O=!0,R=C.apply(r,arguments)),R}}e.$cb=E}),define(te[68],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(C){function r(k){return k&&typeof k=="object"&&typeof k[Symbol.iterator]=="function"}C.is=r;const O=Object.freeze([]);function R(){return O}C.empty=R;function*S(k){yield k}C.single=S;function f(k){return r(k)?k:S(k)}C.wrap=f;function u(k){return k||O}C.from=u;function $(k){return!k||k[Symbol.iterator]().next().done===!0}C.isEmpty=$;function d(k){return k[Symbol.iterator]().next().value}C.first=d;function p(k,w){for(const t of k)if(w(t))return!0;return!1}C.some=p;function h(k,w){for(const t of k)if(w(t))return t}C.find=h;function*v(k,w){for(const t of k)w(t)&&(yield t)}C.filter=v;function*y(k,w){let t=0;for(const l of k)yield w(l,t++)}C.map=y;function*o(...k){for(const w of k)for(const t of w)yield t}C.concat=o;function g(k,w,t){let l=t;for(const s of k)l=w(l,s);return l}C.reduce=g;function*c(k,w,t=k.length){for(w<0&&(w+=k.length),t<0?t+=k.length:t>k.length&&(t=k.length);w<t;w++)yield k[w]}C.slice=c;function b(k,w=Number.POSITIVE_INFINITY){const t=[];if(w===0)return[t,k];const l=k[Symbol.iterator]();for(let s=0;s<w;s++){const n=l.next();if(n.done)return[t,C.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return l}}]}C.consume=b})(E||(e.Iterable=E={}))}),define(te[44],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function R(t,l=!1){let s=0;const n=t.length;let i="",a=0,m=16,P=0;function I(ne){let ue=0,se=0;for(;ue<ne;){const le=t.charCodeAt(s);if(le>=48&&le<=57)se=se*16+le-48;else if(le>=65&&le<=70)se=se*16+le-65+10;else if(le>=97&&le<=102)se=se*16+le-97+10;else break;s++,ue++}return ue<ne&&(se=-1),se}function D(ne){s=ne,i="",a=0,m=16,P=0}function M(){const ne=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&u(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&u(t.charCodeAt(s)))for(s++;s<t.length&&u(t.charCodeAt(s));)s++;else return P=3,t.substring(ne,s);let ue=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&u(t.charCodeAt(s))){for(s++;s<t.length&&u(t.charCodeAt(s));)s++;ue=s}else P=3;return t.substring(ne,ue)}function L(){let ne="",ue=s;for(;;){if(s>=n){ne+=t.substring(ue,s),P=2;break}const se=t.charCodeAt(s);if(se===34){ne+=t.substring(ue,s),s++;break}if(se===92){if(ne+=t.substring(ue,s),s++,s>=n){P=2;break}switch(t.charCodeAt(s++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const J=I(4);J>=0?ne+=String.fromCharCode(J):P=4;break}default:P=5}ue=s;continue}if(se>=0&&se<=31)if(f(se)){ne+=t.substring(ue,s),P=2;break}else P=6;s++}return ne}function N(){if(i="",P=0,a=s,s>=n)return a=n,m=17;let ne=t.charCodeAt(s);if(S(ne)){do s++,i+=String.fromCharCode(ne),ne=t.charCodeAt(s);while(S(ne));return m=15}if(f(ne))return s++,i+=String.fromCharCode(ne),ne===13&&t.charCodeAt(s)===10&&(s++,i+=`
`),m=14;switch(ne){case 123:return s++,m=1;case 125:return s++,m=2;case 91:return s++,m=3;case 93:return s++,m=4;case 58:return s++,m=6;case 44:return s++,m=5;case 34:return s++,i=L(),m=10;case 47:{const ue=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!f(t.charCodeAt(s));)s++;return i=t.substring(ue,s),m=12}if(t.charCodeAt(s+1)===42){s+=2;const se=n-1;let le=!1;for(;s<se;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,le=!0;break}s++}return le||(s++,P=1),i=t.substring(ue,s),m=13}return i+=String.fromCharCode(ne),s++,m=16}case 45:if(i+=String.fromCharCode(ne),s++,s===n||!u(t.charCodeAt(s)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=M(),m=11;default:for(;s<n&&B(ne);)s++,ne=t.charCodeAt(s);if(a!==s){switch(i=t.substring(a,s),i){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return i+=String.fromCharCode(ne),s++,m=16}}function B(ne){if(S(ne)||f(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let ne;do ne=N();while(ne>=12&&ne<=15);return ne}return{setPosition:D,getPosition:()=>s,scan:l?re:N,getToken:()=>m,getTokenValue:()=>i,getTokenOffset:()=>a,getTokenLength:()=>s-a,getTokenError:()=>P}}e.$vm=R;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var $;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})($||($={}));function d(t,l){const s=[],n=new Object;let i;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function P(I,D,M,L){a.value=I,a.offset=D,a.length=M,a.type=L,a.colonOffset=void 0,i=a}try{b(t,{onObjectBegin:(I,D)=>{if(l<=I)throw n;i=void 0,m=l>I,s.push("")},onObjectProperty:(I,D,M)=>{if(l<D||(P(I,D,M,"property"),s[s.length-1]=I,l<=D+M))throw n},onObjectEnd:(I,D)=>{if(l<=I)throw n;i=void 0,s.pop()},onArrayBegin:(I,D)=>{if(l<=I)throw n;i=void 0,s.push(0)},onArrayEnd:(I,D)=>{if(l<=I)throw n;i=void 0,s.pop()},onLiteralValue:(I,D,M)=>{if(l<D||(P(I,D,M,w(I)),l<=D+M))throw n},onSeparator:(I,D,M)=>{if(l<=D)throw n;if(I===":"&&i&&i.type==="property")i.colonOffset=D,m=!1,i=void 0;else if(I===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(m=!0,s[s.length-1]=""),i=void 0}}})}catch(I){if(I!==n)throw I}return{path:s,previousNode:i,isAtPropertyKey:m,matches:I=>{let D=0;for(let M=0;D<I.length&&M<s.length;M++)if(I[D]===s[M]||I[D]==="*")D++;else if(I[D]!=="**")return!1;return D===I.length}}}e.$wm=d;function p(t,l=[],s=O.DEFAULT){let n=null,i=[];const a=[];function m(I){Array.isArray(i)?i.push(I):n!==null&&(i[n]=I)}return b(t,{onObjectBegin:()=>{const I={};m(I),a.push(i),i=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{i=a.pop()},onArrayBegin:()=>{const I=[];m(I),a.push(i),i=I,n=null},onArrayEnd:()=>{i=a.pop()},onLiteralValue:m,onError:(I,D,M)=>{l.push({error:I,offset:D,length:M})}},s),i[0]}e.$xm=p;function h(t,l=[],s=O.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(I){n.type==="property"&&(n.length=I-n.offset,n=n.parent)}function a(I){return n.children.push(I),I}b(t,{onObjectBegin:I=>{n=a({type:"object",offset:I,length:-1,parent:n,children:[]})},onObjectProperty:(I,D,M)=>{n=a({type:"property",offset:D,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:I,offset:D,length:M,parent:n})},onObjectEnd:(I,D)=>{n.length=I+D-n.offset,n=n.parent,i(I+D)},onArrayBegin:(I,D)=>{n=a({type:"array",offset:I,length:-1,parent:n,children:[]})},onArrayEnd:(I,D)=>{n.length=I+D-n.offset,n=n.parent,i(I+D)},onLiteralValue:(I,D,M)=>{a({type:w(I),offset:D,length:M,parent:n,value:I}),i(D+M)},onSeparator:(I,D,M)=>{n.type==="property"&&(I===":"?n.colonOffset=D:I===","&&i(D))},onError:(I,D,M)=>{l.push({error:I,offset:D,length:M})}},s);const P=n.children[0];return P&&delete P.parent,P}e.$ym=h;function v(t,l){if(!t)return;let s=t;for(const n of l)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let i=!1;for(const a of s.children)if(Array.isArray(a.children)&&a.children[0].value===n){s=a.children[1],i=!0;break}if(!i)return}else{const i=n;if(s.type!=="array"||i<0||!Array.isArray(s.children)||i>=s.children.length)return;s=s.children[i]}return s}e.$zm=v;function y(t){if(!t.parent||!t.parent.children)return[];const l=y(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;l.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&l.push(s)}return l}e.$Am=y;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const l=Object.create(null);for(const s of t.children){const n=s.children[1];n&&(l[s.children[0].value]=o(n))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Bm=o;function g(t,l,s=!1){return l>=t.offset&&l<t.offset+t.length||s&&l===t.offset+t.length}e.$Cm=g;function c(t,l,s=!1){if(g(t,l,s)){const n=t.children;if(Array.isArray(n))for(let i=0;i<n.length&&n[i].offset<=l;i++){const a=c(n[i],l,s);if(a)return a}return t}}e.$Dm=c;function b(t,l,s=O.DEFAULT){const n=R(t,!1);function i(Q){return Q?()=>Q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(Q){return Q?ce=>Q(ce,n.getTokenOffset(),n.getTokenLength()):()=>!0}const m=i(l.onObjectBegin),P=a(l.onObjectProperty),I=i(l.onObjectEnd),D=i(l.onArrayBegin),M=i(l.onArrayEnd),L=a(l.onLiteralValue),N=a(l.onSeparator),B=i(l.onComment),re=a(l.onError),ne=s&&s.disallowComments,ue=s&&s.allowTrailingComma;function se(){for(;;){const Q=n.scan();switch(n.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:ne||le(11);break;case 2:le(12);break;case 6:le(16);break}switch(Q){case 12:case 13:ne?le(10):B();break;case 16:le(1);break;case 15:case 14:break;default:return Q}}}function le(Q,ce=[],oe=[]){if(re(Q),ce.length+oe.length>0){let j=n.getToken();for(;j!==17;){if(ce.indexOf(j)!==-1){se();break}else if(oe.indexOf(j)!==-1)break;j=se()}}}function J(Q){const ce=n.getTokenValue();return Q?L(ce):P(ce),se(),!0}function K(){switch(n.getToken()){case 11:{let Q=0;try{Q=JSON.parse(n.getTokenValue()),typeof Q!="number"&&(le(2),Q=0)}catch{le(2)}L(Q);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return se(),!0}function U(){return n.getToken()!==10?(le(3,[],[2,5]),!1):(J(!1),n.getToken()===6?(N(":"),se(),H()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function T(){m(),se();let Q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Q||le(4,[],[]),N(","),se(),n.getToken()===2&&ue)break}else Q&&le(6,[],[]);U()||le(4,[],[2,5]),Q=!0}return I(),n.getToken()!==2?le(7,[2],[]):se(),!0}function W(){D(),se();let Q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Q||le(4,[],[]),N(","),se(),n.getToken()===4&&ue)break}else Q&&le(6,[],[]);H()||le(4,[],[4,5]),Q=!0}return M(),n.getToken()!==4?le(8,[4],[]):se(),!0}function H(){switch(n.getToken()){case 3:return W();case 1:return T();case 10:return J(!0);default:return K()}}return se(),n.getToken()===17?s.allowEmptyContent?!0:(le(4,[],[]),!1):H()?(n.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}e.$Em=b;function k(t,l){const s=R(t),n=[];let i,a=0,m;do switch(m=s.getPosition(),i=s.scan(),i){case 12:case 13:case 17:a!==m&&n.push(t.substring(a,m)),l!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,l)),a=s.getPosition();break}while(i!==17);return n.join("")}e.$Fm=k;function w(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Gm=w}),define(te[136],ie([0,1,44]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9R=e.$8R=e.$7R=e.$6R=void 0;function C(u,$,d){let p,h,v,y,o;if($){for(y=$.offset,o=y+$.length,v=y;v>0&&!f(u,v-1);)v--;let m=o;for(;m<u.length&&!f(u,m);)m++;h=u.substring(v,m),p=R(h,d)}else h=u,p=0,v=0,y=0,o=u.length;const g=S(d,u);let c=!1,b=0,k;d.insertSpaces?k=O(" ",d.tabSize||4):k="	";const w=(0,E.$vm)(h,!1);let t=!1;function l(){return g+O(k,p+b)}function s(){let m=w.scan();for(c=!1;m===15||m===14;)c=c||m===14,m=w.scan();return t=m===16||w.getTokenError()!==0,m}const n=[];function i(m,P,I){!t&&P<o&&I>y&&u.substring(P,I)!==m&&n.push({offset:P,length:I-P,content:m})}let a=s();if(a!==17){const m=w.getTokenOffset()+v,P=O(k,p);i(P,v,m)}for(;a!==17;){let m=w.getTokenOffset()+w.getTokenLength()+v,P=s(),I="";for(;!c&&(P===12||P===13);){const M=w.getTokenOffset()+v;i(" ",m,M),m=w.getTokenOffset()+w.getTokenLength()+v,I=P===12?l():"",P=s()}if(P===2)a!==1&&(b--,I=l());else if(P===4)a!==3&&(b--,I=l());else{switch(a){case 3:case 1:b++,I=l();break;case 5:case 12:I=l();break;case 13:c?I=l():I=" ";break;case 6:I=" ";break;case 10:if(P===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?I=" ":P!==5&&P!==17&&(t=!0);break;case 16:t=!0;break}c&&(P===12||P===13)&&(I=l())}const D=w.getTokenOffset()+v;i(I,m,D),a=P}return n}e.$6R=C;function r(u,$){const d=JSON.stringify(u,void 0,$.insertSpaces?$.tabSize||4:"	");return $.eol!==void 0?d.replace(/\r\n|\r|\n/g,$.eol):d}e.$7R=r;function O(u,$){let d="";for(let p=0;p<$;p++)d+=u;return d}function R(u,$){let d=0,p=0;const h=$.tabSize||4;for(;d<u.length;){const v=u.charAt(d);if(v===" ")p++;else if(v==="	")p+=h;else break;d++}return Math.floor(p/h)}function S(u,$){for(let d=0;d<$.length;d++){const p=$.charAt(d);if(p==="\r")return d+1<$.length&&$.charAt(d+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return u&&u.eol||`
`}e.$8R=S;function f(u,$){return`\r
`.indexOf(u.charAt($))!==-1}e.$9R=f}),define(te[137],ie([0,1,44,136]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bS=e.$aS=e.$_R=e.$$R=e.$0R=void 0;function r(u,$,d){return O(u,$,void 0,d)}e.$0R=r;function O(u,$,d,p,h){const v=$.slice(),y=[],o=(0,E.$ym)(u,y);let g,c;for(;v.length>0&&(c=v.pop(),g=(0,E.$zm)(o,v),g===void 0&&d!==void 0);)typeof c=="string"?d={[c]:d}:d=[d];if(g)if(g.type==="object"&&typeof c=="string"&&Array.isArray(g.children)){const b=(0,E.$zm)(g,[c]);if(b!==void 0)if(d===void 0){if(!b.parent)throw new Error("Malformed AST");const k=g.children.indexOf(b.parent);let w,t=b.parent.offset+b.parent.length;if(k>0){const l=g.children[k-1];w=l.offset+l.length}else w=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return R(u,{offset:w,length:t-w,content:""},p)}else return R(u,{offset:b.offset,length:b.length,content:JSON.stringify(d)},p);else{if(d===void 0)return[];const k=`${JSON.stringify(c)}: ${JSON.stringify(d)}`,w=h?h(g.children.map(l=>l.children[0].value)):g.children.length;let t;if(w>0){const l=g.children[w-1];t={offset:l.offset+l.length,length:0,content:","+k}}else g.children.length===0?t={offset:g.offset+1,length:0,content:k}:t={offset:g.offset+1,length:0,content:k+","};return R(u,t,p)}}else if(g.type==="array"&&typeof c=="number"&&Array.isArray(g.children))if(d!==void 0){const b=`${JSON.stringify(d)}`;let k;if(g.children.length===0||c===0)k={offset:g.offset+1,length:0,content:g.children.length===0?b:b+","};else{const w=c===-1||c>g.children.length?g.children.length:c,t=g.children[w-1];k={offset:t.offset+t.length,length:0,content:","+b}}return R(u,k,p)}else{const b=c,k=g.children[b];let w;if(g.children.length===1)w={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===b){const t=g.children[b-1],l=t.offset+t.length,s=g.offset+g.length;w={offset:l,length:s-2-l,content:""}}else w={offset:k.offset,length:g.children[b+1].offset-k.offset,content:""};return R(u,w,p)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${g.type}`);else{if(d===void 0)throw new Error("Can not delete in empty document");return R(u,{offset:o?o.offset:0,length:o?o.length:0,content:JSON.stringify(d)},p)}}e.$$R=O;function R(u,$,d){let p=S(u,$),h=$.offset,v=$.offset+$.content.length;if($.length===0||$.content.length===0){for(;h>0&&!(0,C.$9R)(p,h-1);)h--;for(;v<p.length&&!(0,C.$9R)(p,v);)v++}const y=(0,C.$6R)(p,{offset:h,length:v-h},d);for(let g=y.length-1;g>=0;g--){const c=y[g];p=S(p,c),h=Math.min(h,c.offset),v=Math.max(v,c.offset+c.length),v+=c.content.length-c.length}const o=u.length-(p.length-v)-h;return[{offset:h,length:o,content:p.substring(h,v)}]}e.$_R=R;function S(u,$){return u.substring(0,$.offset)+$.content+u.substring($.offset+$.length)}e.$aS=S;function f(u,$){const d=$.slice(0).sort((h,v)=>{const y=h.offset-v.offset;return y===0?h.length-v.length:y});let p=u.length;for(let h=d.length-1;h>=0;h--){const v=d[h];if(v.offset+v.length<=p)u=S(u,v);else throw new Error("Overlapping edit");p=v.offset}return u}e.$bS=f}),define(te[85],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class E{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=E}),define(te[2],ie([0,1,49,68]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tb=e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;const r=!1;let O=null;function R(a){O=a}if(e.$db=R,r){const a="__is_disposable_tracked__";R(new class{trackDisposable(m){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[a]||console.log(P)},3e3)}setParent(m,P){if(m&&m!==c.None)try{m[a]=!0}catch{}}markAsDisposed(m){if(m&&m!==c.None)try{m[a]=!0}catch{}}markAsSingleton(m){}})}function S(a){return O?.trackDisposable(a),a}function f(a){O?.markAsDisposed(a)}function u(a,m){O?.setParent(a,m)}function $(a,m){if(O)for(const P of a)O.setParent(P,m)}function d(a){return O?.markAsSingleton(a),a}e.$eb=d;function p(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.$fb=p;function h(a){if(C.Iterable.is(a)){const m=[];for(const P of a)if(P)try{P.dispose()}catch(I){m.push(I)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.$gb=h;function v(a){for(const m of a)p(m)&&m.dispose();return[]}e.$hb=v;function y(...a){const m=o(()=>h(a));return $(a,m),m}e.$ib=y;function o(a){const m=S({dispose:(0,E.$cb)(()=>{f(m),a()})});return m}e.$jb=o;class g{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return u(m,this),this.g?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(m),m}}e.$kb=g;class c{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new g,S(this),u(this.q,this)}dispose(){f(this),this.q.dispose()}B(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(m)}}e.$lb=c;class b{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(m){this.b||m===this.a||(this.a?.dispose(),m&&u(m,this),this.a=m)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const m=this.a;return this.a=void 0,m&&u(m,null),m}}e.$mb=b;class k{constructor(m){this.b=m,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$nb=k;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(m){let P=m;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,f(this))},this}}e.$ob=w;class t{constructor(){this.a=new Map}acquire(m,...P){let I=this.a.get(m);I||(I={counter:0,object:this.b(m,...P)},this.a.set(m,I));const{object:D}=I,M=(0,E.$cb)(()=>{--I.counter===0&&(this.c(m,I.object),this.a.delete(m))});return I.counter++,{object:D,dispose:M}}}e.$pb=t;class l{constructor(m){this.a=m}async acquire(m,...P){const I=this.a.acquire(m,...P);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(D){throw I.dispose(),D}}}e.$qb=l;class s{constructor(m){this.object=m}dispose(){}}e.$rb=s;function n(a){const m=new g;try{a(m)}finally{m.dispose()}}e.$sb=n;class i{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(m){return this.a.has(m)}get(m){return this.a.get(m)}set(m,P,I=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this.a.get(m)?.dispose(),this.a.set(m,P)}deleteAndDispose(m){this.a.get(m)?.dispose(),this.a.delete(m)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$tb=i}),define(te[101],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lc=void 0;class E{static{this.Undefined=new E(void 0)}constructor(O){this.element=O,this.next=E.Undefined,this.prev=E.Undefined}}class C{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let O=this.a;for(;O!==E.Undefined;){const R=O.next;O.prev=E.Undefined,O.next=E.Undefined,O=R}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,R){const S=new E(O);if(this.a===E.Undefined)this.a=S,this.b=S;else if(R){const u=this.b;this.b=S,S.prev=u,u.next=S}else{const u=this.a;this.a=S,S.next=u,u.prev=S}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(S))}}shift(){if(this.a!==E.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==E.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==E.Undefined&&O.next!==E.Undefined){const R=O.prev;R.next=O.next,O.next.prev=R}else O.prev===E.Undefined&&O.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):O.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):O.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==E.Undefined;)yield O.element,O=O.next}}e.$lc=C}),define(te[35],ie([0,1]),function(V,e){"use strict";var E,C,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.Touch=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;function O(y,o,g){let c=y.get(o);return c===void 0&&(c=g,y.set(o,c)),c}e.$ki=O;function R(y){const o=[];return y.forEach((g,c)=>{o.push(`${c} => ${g}`)}),`Map(${y.size}) {${o.join(", ")}}`}e.$li=R;function S(y){const o=[];return y.forEach(g=>{o.push(g)}),`Set(${y.size}) {${o.join(", ")}}`}e.$mi=S;class f{constructor(o,g){this.uri=o,this.value=g}}class u{static{this.a=o=>o.toString()}constructor(o,g){this[E]="ResourceMap",o instanceof u?(this.b=new Map(o.b),this.c=g??u.a):(this.b=new Map,this.c=o??u.a)}set(o,g){return this.b.set(this.c(o),new f(o,g)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,g){typeof g<"u"&&(o=o.bind(g));for(const[c,b]of this.b)o(b.value,b.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$ni=u;class ${constructor(o,g){this[C]="ResourceSet",!o||typeof o=="function"?this.a=new u(o):(this.a=new u(g),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,g){this.a.forEach((c,b)=>o.call(g,b,b,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$oi=$;var d;(function(y){y[y.None=0]="None",y[y.AsOld=1]="AsOld",y[y.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class p{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,g=0){const c=this.a.get(o);if(c)return g!==0&&this.j(c,g),c.value}set(o,g,c=0){let b=this.a.get(o);if(b)b.value=g,c!==0&&this.j(b,c);else{switch(b={key:o,value:g,next:void 0,previous:void 0},c){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(o,b),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const g=this.a.get(o);if(g)return this.a.delete(o),this.i(g),this.d--,g.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,g){const c=this.e;let b=this.b;for(;b;){if(g?o.bind(g)(b.value,b.key,this):o(b.value,b.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const o=this,g=this.e;let c=this.b;const b={[Symbol.iterator](){return b},next(){if(o.e!==g)throw new Error("LinkedMap got modified during iteration.");if(c){const k={value:c.key,done:!1};return c=c.next,k}else return{value:void 0,done:!0}}};return b}values(){const o=this,g=this.e;let c=this.b;const b={[Symbol.iterator](){return b},next(){if(o.e!==g)throw new Error("LinkedMap got modified during iteration.");if(c){const k={value:c.value,done:!1};return c=c.next,k}else return{value:void 0,done:!0}}};return b}entries(){const o=this,g=this.e;let c=this.b;const b={[Symbol.iterator](){return b},next(){if(o.e!==g)throw new Error("LinkedMap got modified during iteration.");if(c){const k={value:[c.key,c.value],done:!1};return c=c.next,k}else return{value:void 0,done:!0}}};return b}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let g=this.b,c=this.size;for(;g&&c>o;)this.a.delete(g.key),g=g.next,c--;this.b=g,this.d=c,g&&(g.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const g=o.next,c=o.previous;if(!g||!c)throw new Error("Invalid list");g.previous=c,c.next=g}o.next=void 0,o.previous=void 0,this.e++}j(o,g){if(!this.b||!this.c)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(o===this.b)return;const c=o.next,b=o.previous;o===this.c?(b.next=void 0,this.c=b):(c.previous=b,b.next=c),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(g===2){if(o===this.c)return;const c=o.next,b=o.previous;o===this.b?(c.previous=void 0,this.b=c):(c.previous=b,b.next=c),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((g,c)=>{o.push([c,g])}),o}fromJSON(o){this.clear();for(const[g,c]of o)this.set(g,c)}}e.$pi=p;class h extends p{constructor(o,g=1){super(),this.k=o,this.l=Math.min(Math.max(0,g),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,g=2){return super.get(o,g)}peek(o){return super.get(o,0)}set(o,g){return super.set(o,g,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$qi=h;class v{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let g=this.a.get(o)||0;return g===0?!1:(g--,g===0?this.a.delete(o):this.a.set(o,g),!0)}has(o){return this.a.has(o)}}e.$ri=v}),define(te[86],ie([0,1,35]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=void 0;const C=new E.$qi(1e4);function r(u){return f(u,"NFC",C)}e.$7k=r;const O=new E.$qi(1e4);function R(u){return f(u,"NFD",O)}e.$8k=R;const S=/[^\u0000-\u0080]/;function f(u,$,d){if(!u)return u;const p=d.get(u);if(p)return p;let h;return S.test(u)?h=u.normalize($):h=u,d.set(u,h),h}e.$9k=function(){const u=/[\u0300-\u036f]/g;return function($){return R($).replace(u,"")}}()}),define(te[138],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=e.$vl=e.rot=e.$tl=void 0;function E(S,f,u){return Math.min(Math.max(S,f),u)}e.$tl=E;function C(S,f){return(f+S%f)%f}e.rot=C;class r{constructor(){this.a=0}getNext(){return this.a++}}e.$vl=r;class O{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$wl=O;class R{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const u=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$xl=R}),function(){function V(r){const O=[];typeof r=="number"&&O.push("code/timeOrigin",r);function R(f){O.push(f,Date.now())}function S(){const f=[];for(let u=0;u<O.length;u+=2)f.push({name:O[u],startTime:O[u+1]});return f}return{mark:R,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const R of performance.getEntriesByType("mark"))O.push({name:R.name,startTime:Math.round(r+R.startTime)});return O}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function E(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=E(C))}(),function(V,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var C in E)(typeof exports=="object"?exports:V)[C]=E[C]}}(typeof self<"u"?self:this,function(){return function(V){var e={};function E(C){if(e[C])return e[C].exports;var r=e[C]={i:C,l:!1,exports:{}};return V[C].call(r.exports,r,r.exports,E),r.l=!0,r.exports}return E.m=V,E.c=e,E.d=function(C,r,O){E.o(C,r)||Object.defineProperty(C,r,{enumerable:!0,get:O})},E.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},E.t=function(C,r){if(1&r&&(C=E(C)),8&r||4&r&&typeof C=="object"&&C&&C.__esModule)return C;var O=Object.create(null);if(E.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:C}),2&r&&typeof C!="string")for(var R in C)E.d(O,R,function(S){return C[S]}.bind(null,R));return O},E.n=function(C){var r=C&&C.__esModule?function(){return C.default}:function(){return C};return E.d(r,"a",r),r},E.o=function(C,r){return Object.prototype.hasOwnProperty.call(C,r)},E.p="",E(E.s=0)}([function(V,e,E){(function(C){var r;e=V.exports=oe,r=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],f=e.src=[],u=0,$=u++;f[$]="0|[1-9]\\d*";var d=u++;f[d]="[0-9]+";var p=u++;f[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=u++;f[h]="("+f[$]+")\\.("+f[$]+")\\.("+f[$]+")";var v=u++;f[v]="("+f[d]+")\\.("+f[d]+")\\.("+f[d]+")";var y=u++;f[y]="(?:"+f[$]+"|"+f[p]+")";var o=u++;f[o]="(?:"+f[d]+"|"+f[p]+")";var g=u++;f[g]="(?:-("+f[y]+"(?:\\."+f[y]+")*))";var c=u++;f[c]="(?:-?("+f[o]+"(?:\\."+f[o]+")*))";var b=u++;f[b]="[0-9A-Za-z-]+";var k=u++;f[k]="(?:\\+("+f[b]+"(?:\\."+f[b]+")*))";var w=u++,t="v?"+f[h]+f[g]+"?"+f[k]+"?";f[w]="^"+t+"$";var l="[v=\\s]*"+f[v]+f[c]+"?"+f[k]+"?",s=u++;f[s]="^"+l+"$";var n=u++;f[n]="((?:<|>)?=?)";var i=u++;f[i]=f[d]+"|x|X|\\*";var a=u++;f[a]=f[$]+"|x|X|\\*";var m=u++;f[m]="[v=\\s]*("+f[a]+")(?:\\.("+f[a]+")(?:\\.("+f[a]+")(?:"+f[g]+")?"+f[k]+"?)?)?";var P=u++;f[P]="[v=\\s]*("+f[i]+")(?:\\.("+f[i]+")(?:\\.("+f[i]+")(?:"+f[c]+")?"+f[k]+"?)?)?";var I=u++;f[I]="^"+f[n]+"\\s*"+f[m]+"$";var D=u++;f[D]="^"+f[n]+"\\s*"+f[P]+"$";var M=u++;f[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=u++;f[L]="(?:~>?)";var N=u++;f[N]="(\\s*)"+f[L]+"\\s+",S[N]=new RegExp(f[N],"g");var B=u++;f[B]="^"+f[L]+f[m]+"$";var re=u++;f[re]="^"+f[L]+f[P]+"$";var ne=u++;f[ne]="(?:\\^)";var ue=u++;f[ue]="(\\s*)"+f[ne]+"\\s+",S[ue]=new RegExp(f[ue],"g");var se=u++;f[se]="^"+f[ne]+f[m]+"$";var le=u++;f[le]="^"+f[ne]+f[P]+"$";var J=u++;f[J]="^"+f[n]+"\\s*("+l+")$|^$";var K=u++;f[K]="^"+f[n]+"\\s*("+t+")$|^$";var U=u++;f[U]="(\\s*)"+f[n]+"\\s*("+l+"|"+f[m]+")",S[U]=new RegExp(f[U],"g");var T=u++;f[T]="^\\s*("+f[m]+")\\s+-\\s+("+f[m]+")\\s*$";var W=u++;f[W]="^\\s*("+f[P]+")\\s+-\\s+("+f[P]+")\\s*$";var H=u++;f[H]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)r(Q,f[Q]),S[Q]||(S[Q]=new RegExp(f[Q]));function ce(ee,fe){if(ee instanceof oe)return ee;if(typeof ee!="string"||ee.length>O||!(fe?S[s]:S[w]).test(ee))return null;try{return new oe(ee,fe)}catch{return null}}function oe(ee,fe){if(ee instanceof oe){if(ee.loose===fe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof oe))return new oe(ee,fe);r("SemVer",ee,fe),this.loose=fe;var ge=ee.trim().match(fe?S[s]:S[w]);if(!ge)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Ce=+Se;if(Ce>=0&&Ce<R)return Ce}return Se}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=ce,e.valid=function(ee,fe){var ge=ce(ee,fe);return ge?ge.version:null},e.clean=function(ee,fe){var ge=ce(ee.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(ee){return r("SemVer.compare",this.version,this.loose,ee),ee instanceof oe||(ee=new oe(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},oe.prototype.compareMain=function(ee){return ee instanceof oe||(ee=new oe(ee,this.loose)),A(this.major,ee.major)||A(this.minor,ee.minor)||A(this.patch,ee.patch)},oe.prototype.comparePre=function(ee){if(ee instanceof oe||(ee=new oe(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Se=ee.prerelease[fe];if(r("prerelease compare",fe,ge,Se),ge===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(ge===void 0)return-1;if(ge!==Se)return A(ge,Se)}while(++fe)},oe.prototype.inc=function(ee,fe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,fe,ge,Se){typeof ge=="string"&&(Se=ge,ge=void 0);try{return new oe(ee,ge).inc(fe,Se).version}catch{return null}},e.diff=function(ee,fe){if(Z(ee,fe))return null;var ge=ce(ee),Se=ce(fe);if(ge.prerelease.length||Se.prerelease.length){for(var Ce in ge)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ge[Ce]!==Se[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in ge)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ge[Ce]!==Se[Ce])return Ce},e.compareIdentifiers=A;var j=/^[0-9]+$/;function A(ee,fe){var ge=j.test(ee),Se=j.test(fe);return ge&&Se&&(ee=+ee,fe=+fe),ge&&!Se?-1:Se&&!ge?1:ee<fe?-1:ee>fe?1:0}function F(ee,fe,ge){return new oe(ee,ge).compare(new oe(fe,ge))}function q(ee,fe,ge){return F(ee,fe,ge)>0}function G(ee,fe,ge){return F(ee,fe,ge)<0}function Z(ee,fe,ge){return F(ee,fe,ge)===0}function z(ee,fe,ge){return F(ee,fe,ge)!==0}function Y(ee,fe,ge){return F(ee,fe,ge)>=0}function x(ee,fe,ge){return F(ee,fe,ge)<=0}function ae(ee,fe,ge,Se){var Ce;switch(fe){case"===":typeof ee=="object"&&(ee=ee.version),typeof ge=="object"&&(ge=ge.version),Ce=ee===ge;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ge=="object"&&(ge=ge.version),Ce=ee!==ge;break;case"":case"=":case"==":Ce=Z(ee,ge,Se);break;case"!=":Ce=z(ee,ge,Se);break;case">":Ce=q(ee,ge,Se);break;case">=":Ce=Y(ee,ge,Se);break;case"<":Ce=G(ee,ge,Se);break;case"<=":Ce=x(ee,ge,Se);break;default:throw new TypeError("Invalid operator: "+fe)}return Ce}function he(ee,fe){if(ee instanceof he){if(ee.loose===fe)return ee;ee=ee.value}if(!(this instanceof he))return new he(ee,fe);r("comparator",ee,fe),this.loose=fe,this.parse(ee),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(ee,fe){return A(fe,ee)},e.major=function(ee,fe){return new oe(ee,fe).major},e.minor=function(ee,fe){return new oe(ee,fe).minor},e.patch=function(ee,fe){return new oe(ee,fe).patch},e.compare=F,e.compareLoose=function(ee,fe){return F(ee,fe,!0)},e.rcompare=function(ee,fe,ge){return F(fe,ee,ge)},e.sort=function(ee,fe){return ee.sort(function(ge,Se){return e.compare(ge,Se,fe)})},e.rsort=function(ee,fe){return ee.sort(function(ge,Se){return e.rcompare(ge,Se,fe)})},e.gt=q,e.lt=G,e.eq=Z,e.neq=z,e.gte=Y,e.lte=x,e.cmp=ae,e.Comparator=he;var Ie={};function Ee(ee,fe){if(ee instanceof Ee)return ee.loose===fe?ee:new Ee(ee.raw,fe);if(ee instanceof he)return new Ee(ee.value,fe);if(!(this instanceof Ee))return new Ee(ee,fe);if(this.loose=fe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Ae(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Me(ee,fe,ge,Se,Ce,je,Oe,ze,Te,He,Be,X,de){return((fe=Ae(ge)?"":Ae(Se)?">="+ge+".0.0":Ae(Ce)?">="+ge+"."+Se+".0":">="+fe)+" "+(ze=Ae(Te)?"":Ae(He)?"<"+(+Te+1)+".0.0":Ae(Be)?"<"+Te+"."+(+He+1)+".0":X?"<="+Te+"."+He+"."+Be+"-"+X:"<="+ze)).trim()}function We(ee,fe){for(var ge=0;ge<ee.length;ge++)if(!ee[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ee.length;ge++)if(r(ee[ge].semver),ee[ge].semver!==Ie&&ee[ge].semver.prerelease.length>0){var Se=ee[ge].semver;if(Se.major===fe.major&&Se.minor===fe.minor&&Se.patch===fe.patch)return!0}return!1}return!0}function $e(ee,fe,ge){try{fe=new Ee(fe,ge)}catch{return!1}return fe.test(ee)}function be(ee,fe,ge,Se){var Ce,je,Oe,ze,Te;switch(ee=new oe(ee,Se),fe=new Ee(fe,Se),ge){case">":Ce=q,je=x,Oe=G,ze=">",Te=">=";break;case"<":Ce=G,je=Y,Oe=q,ze="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(ee,fe,Se))return!1;for(var He=0;He<fe.set.length;++He){var Be=fe.set[He],X=null,de=null;if(Be.forEach(function(me){me.semver===Ie&&(me=new he(">=0.0.0")),X=X||me,de=de||me,Ce(me.semver,X.semver,Se)?X=me:Oe(me.semver,de.semver,Se)&&(de=me)}),X.operator===ze||X.operator===Te||(!de.operator||de.operator===ze)&&je(ee,de.semver)||de.operator===Te&&Oe(ee,de.semver))return!1}return!0}he.prototype.parse=function(ee){var fe=this.loose?S[J]:S[K],ge=ee.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ee);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new oe(ge[2],this.loose):this.semver=Ie},he.prototype.toString=function(){return this.value},he.prototype.test=function(ee){return r("Comparator.test",ee,this.loose),this.semver===Ie||(typeof ee=="string"&&(ee=new oe(ee,this.loose)),ae(ee,this.operator,this.semver,this.loose))},he.prototype.intersects=function(ee,fe){if(!(ee instanceof he))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Ee(ee.value,fe),$e(this.value,ge,fe);if(ee.operator==="")return ge=new Ee(this.value,fe),$e(ee.semver,ge,fe);var Se=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),je=this.semver.version===ee.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),ze=ae(this.semver,"<",ee.semver,fe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Te=ae(this.semver,">",ee.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return Se||Ce||je&&Oe||ze||Te},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ee){var fe=this.loose;ee=ee.trim(),r("range",ee,fe);var ge=fe?S[W]:S[T];ee=ee.replace(ge,Me),r("hyphen replace",ee),ee=ee.replace(S[U],"$1$2$3"),r("comparator trim",ee,S[U]),ee=(ee=(ee=ee.replace(S[N],"$1~")).replace(S[ue],"$1^")).split(/\s+/).join(" ");var Se=fe?S[J]:S[K],Ce=ee.split(" ").map(function(je){return function(Oe,ze){return r("comp",Oe),Oe=function(Te,He){return Te.trim().split(/\s+/).map(function(Be){return function(X,de){r("caret",X,de);var me=de?S[le]:S[se];return X.replace(me,function(ve,ye,Re,Fe,qe){var Ge;return r("caret",X,ve,ye,Re,Fe,qe),Ae(ye)?Ge="":Ae(Re)?Ge=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ae(Fe)?Ge=ye==="0"?">="+ye+"."+Re+".0 <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+".0 <"+(+ye+1)+".0.0":qe?(r("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ge=ye==="0"?Re==="0"?">="+ye+"."+Re+"."+Fe+qe+" <"+ye+"."+Re+"."+(+Fe+1):">="+ye+"."+Re+"."+Fe+qe+" <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+"."+Fe+qe+" <"+(+ye+1)+".0.0"):(r("no pr"),Ge=ye==="0"?Re==="0"?">="+ye+"."+Re+"."+Fe+" <"+ye+"."+Re+"."+(+Fe+1):">="+ye+"."+Re+"."+Fe+" <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+"."+Fe+" <"+(+ye+1)+".0.0"),r("caret return",Ge),Ge})}(Be,He)}).join(" ")}(Oe,ze),r("caret",Oe),Oe=function(Te,He){return Te.trim().split(/\s+/).map(function(Be){return function(X,de){var me=de?S[re]:S[B];return X.replace(me,function(ve,ye,Re,Fe,qe){var Ge;return r("tilde",X,ve,ye,Re,Fe,qe),Ae(ye)?Ge="":Ae(Re)?Ge=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ae(Fe)?Ge=">="+ye+"."+Re+".0 <"+ye+"."+(+Re+1)+".0":qe?(r("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ge=">="+ye+"."+Re+"."+Fe+qe+" <"+ye+"."+(+Re+1)+".0"):Ge=">="+ye+"."+Re+"."+Fe+" <"+ye+"."+(+Re+1)+".0",r("tilde return",Ge),Ge})}(Be,He)}).join(" ")}(Oe,ze),r("tildes",Oe),Oe=function(Te,He){return r("replaceXRanges",Te,He),Te.split(/\s+/).map(function(Be){return function(X,de){X=X.trim();var me=de?S[D]:S[I];return X.replace(me,function(ve,ye,Re,Fe,qe,Ge){r("xRange",X,ve,ye,Re,Fe,qe,Ge);var xe=Ae(Re),Ye=xe||Ae(Fe),Qe=Ye||Ae(qe);return ye==="="&&Qe&&(ye=""),xe?ve=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Qe?(Ye&&(Fe=0),Qe&&(qe=0),ye===">"?(ye=">=",Ye?(Re=+Re+1,Fe=0,qe=0):Qe&&(Fe=+Fe+1,qe=0)):ye==="<="&&(ye="<",Ye?Re=+Re+1:Fe=+Fe+1),ve=ye+Re+"."+Fe+"."+qe):Ye?ve=">="+Re+".0.0 <"+(+Re+1)+".0.0":Qe&&(ve=">="+Re+"."+Fe+".0 <"+Re+"."+(+Fe+1)+".0"),r("xRange return",ve),ve})}(Be,He)}).join(" ")}(Oe,ze),r("xrange",Oe),Oe=function(Te,He){return r("replaceStars",Te,He),Te.trim().replace(S[H],"")}(Oe,ze),r("stars",Oe),Oe}(je,fe)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(je){return!!je.match(Se)})),Ce=Ce.map(function(je){return new he(je,fe)})},Ee.prototype.intersects=function(ee,fe){if(!(ee instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Se){return ee.set.some(function(Ce){return Ce.every(function(je){return Se.intersects(je,fe)})})})})},e.toComparators=function(ee,fe){return new Ee(ee,fe).set.map(function(ge){return ge.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new oe(ee,this.loose));for(var fe=0;fe<this.set.length;fe++)if(We(this.set[fe],ee))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(ee,fe,ge){var Se=null,Ce=null;try{var je=new Ee(fe,ge)}catch{return null}return ee.forEach(function(Oe){je.test(Oe)&&(Se&&Ce.compare(Oe)!==-1||(Ce=new oe(Se=Oe,ge)))}),Se},e.minSatisfying=function(ee,fe,ge){var Se=null,Ce=null;try{var je=new Ee(fe,ge)}catch{return null}return ee.forEach(function(Oe){je.test(Oe)&&(Se&&Ce.compare(Oe)!==1||(Ce=new oe(Se=Oe,ge)))}),Se},e.validRange=function(ee,fe){try{return new Ee(ee,fe).range||"*"}catch{return null}},e.ltr=function(ee,fe,ge){return be(ee,fe,"<",ge)},e.gtr=function(ee,fe,ge){return be(ee,fe,">",ge)},e.outside=be,e.prerelease=function(ee,fe){var ge=ce(ee,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ee,fe,ge){return ee=new Ee(ee,ge),fe=new Ee(fe,ge),ee.intersects(fe)},e.coerce=function(ee){if(ee instanceof oe)return ee;if(typeof ee!="string")return null;var fe=ee.match(S[M]);return fe==null?null:ce((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,E(1))},function(V,e){var E,C,r=V.exports={};function O(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function S(o){if(E===setTimeout)return setTimeout(o,0);if((E===O||!E)&&setTimeout)return E=setTimeout,setTimeout(o,0);try{return E(o,0)}catch{try{return E.call(null,o,0)}catch{return E.call(this,o,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:O}catch{E=O}try{C=typeof clearTimeout=="function"?clearTimeout:R}catch{C=R}})();var f,u=[],$=!1,d=-1;function p(){$&&f&&($=!1,f.length?u=f.concat(u):d=-1,u.length&&h())}function h(){if(!$){var o=S(p);$=!0;for(var g=u.length;g;){for(f=u,u=[];++d<g;)f&&f[d].run();d=-1,g=u.length}f=null,$=!1,function(c){if(C===clearTimeout)return clearTimeout(c);if((C===R||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(c);try{C(c)}catch{try{return C.call(null,c)}catch{return C.call(this,c)}}}(o)}}function v(o,g){this.fun=o,this.array=g}function y(){}r.nextTick=function(o){var g=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)g[c-1]=arguments[c];u.push(new v(o,g)),u.length!==1||$||S(h)},v.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=y,r.addListener=y,r.once=y,r.off=y,r.removeListener=y,r.removeAllListeners=y,r.emit=y,r.prependListener=y,r.prependOnceListener=y,r.listeners=function(o){return[]},r.binding=function(o){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(o){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(te[139],ie([0,1]),function(V,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class C{constructor(S,f,u){this.level=S,this.key=f,this.value=u,this.forward=[]}}const r=void 0;class O{constructor(S,f=2**16){this.comparator=S,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new C(this.c,r,r)}get size(){return this.f}clear(){this.e=new C(this.c,r,r)}has(S){return!!O.g(this,S,this.comparator)}get(S){return O.g(this,S,this.comparator)?.value}set(S,f){return O.h(this,S,f,this.comparator)&&(this.f+=1),this}delete(S){const f=O.k(this,S,this.comparator);return f&&(this.f-=1),f}forEach(S,f){let u=this.e.forward[0];for(;u;)S.call(f,u.value,u.key,this),u=u.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",f=this.e.forward[0];for(;f;)S+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return S}static g(S,f,u){let $=S.e;for(let d=S.d-1;d>=0;d--)for(;$.forward[d]&&u($.forward[d].key,f)<0;)$=$.forward[d];if($=$.forward[0],$&&u($.key,f)===0)return $}static h(S,f,u,$){const d=[];let p=S.e;for(let h=S.d-1;h>=0;h--){for(;p.forward[h]&&$(p.forward[h].key,f)<0;)p=p.forward[h];d[h]=p}if(p=p.forward[0],p&&$(p.key,f)===0)return p.value=u,!1;{const h=O.j(S);if(h>S.d){for(let v=S.d;v<h;v++)d[v]=S.e;S.d=h}p=new C(h,f,u);for(let v=0;v<h;v++)p.forward[v]=d[v].forward[v],d[v].forward[v]=p;return!0}}static j(S,f=.5){let u=1;for(;Math.random()<f&&u<S.c;)u+=1;return u}static k(S,f,u){const $=[];let d=S.e;for(let p=S.d-1;p>=0;p--){for(;d.forward[p]&&u(d.forward[p].key,f)<0;)d=d.forward[p];$[p]=d}if(d=d.forward[0],!d||u(d.key,f)!==0)return!1;for(let p=0;p<S.d&&$[p].forward[p]===d;p++)$[p].forward[p]=d.forward[p];for(;S.d>0&&S.e.forward[S.d-1]===r;)S.d-=1;return!0}}e.$br=O}),define(te[69],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(O){return new C(O)}constructor(O){this.c=E&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$4c=C}),define(te[3],ie([0,1,13,49,2,101,69]),function(V,e,E,C,r,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.Event=void 0;const S=!1,f=!1;var u;(function(P){P.None=()=>r.$lb.None;function I(Z){if(f){const{onDidAddListener:z}=Z,Y=v.create();let x=0;Z.onDidAddListener=()=>{++x===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),z?.()}}}function D(Z,z){return le(Z,()=>{},0,void 0,!0,void 0,z)}P.defer=D;function M(Z){return(z,Y=null,x)=>{let ae=!1,he;return he=Z(Ie=>{if(!ae)return he?he.dispose():ae=!0,z.call(Y,Ie)},null,x),ae&&he.dispose(),he}}P.once=M;function L(Z,z,Y){return se((x,ae=null,he)=>Z(Ie=>x.call(ae,z(Ie)),null,he),Y)}P.map=L;function N(Z,z,Y){return se((x,ae=null,he)=>Z(Ie=>{z(Ie),x.call(ae,Ie)},null,he),Y)}P.forEach=N;function B(Z,z,Y){return se((x,ae=null,he)=>Z(Ie=>z(Ie)&&x.call(ae,Ie),null,he),Y)}P.filter=B;function re(Z){return Z}P.signal=re;function ne(...Z){return(z,Y=null,x)=>(0,r.$ib)(...Z.map(ae=>ae(he=>z.call(Y,he),null,x)))}P.any=ne;function ue(Z,z,Y,x){let ae=Y;return L(Z,he=>(ae=z(ae,he),ae),x)}P.reduce=ue;function se(Z,z){let Y;const x={onWillAddFirstListener(){Y=Z(ae.fire,ae)},onDidRemoveLastListener(){Y?.dispose()}};z||I(x);const ae=new b(x);return z?.add(ae),ae.event}function le(Z,z,Y=100,x=!1,ae=!1,he,Ie){let Ee,Ae,Me,We=0,$e;const be={leakWarningThreshold:he,onWillAddFirstListener(){Ee=Z(fe=>{We++,Ae=z(Ae,fe),x&&!Me&&(ee.fire(Ae),Ae=void 0),$e=()=>{const ge=Ae;Ae=void 0,Me=void 0,(!x||We>1)&&ee.fire(ge),We=0},typeof Y=="number"?(clearTimeout(Me),Me=setTimeout($e,Y)):Me===void 0&&(Me=0,queueMicrotask($e))})},onWillRemoveListener(){ae&&We>0&&$e?.()},onDidRemoveLastListener(){$e=void 0,Ee.dispose()}};Ie||I(be);const ee=new b(be);return Ie?.add(ee),ee.event}P.debounce=le;function J(Z,z=0,Y){return P.debounce(Z,(x,ae)=>x?(x.push(ae),x):[ae],z,void 0,!0,void 0,Y)}P.accumulate=J;function K(Z,z=(x,ae)=>x===ae,Y){let x=!0,ae;return B(Z,he=>{const Ie=x||!z(he,ae);return x=!1,ae=he,Ie},Y)}P.latch=K;function U(Z,z,Y){return[P.filter(Z,z,Y),P.filter(Z,x=>!z(x),Y)]}P.split=U;function T(Z,z=!1,Y=[]){let x=Y.slice(),ae=Z(Ee=>{x?x.push(Ee):Ie.fire(Ee)});const he=()=>{x?.forEach(Ee=>Ie.fire(Ee)),x=null},Ie=new b({onWillAddFirstListener(){ae||(ae=Z(Ee=>Ie.fire(Ee)))},onDidAddFirstListener(){x&&(z?setTimeout(he):he())},onDidRemoveLastListener(){ae&&ae.dispose(),ae=null}});return Ie.event}P.buffer=T;class W{constructor(z){this.event=z,this.d=new r.$kb}map(z){return new W(L(this.event,z,this.d))}forEach(z){return new W(N(this.event,z,this.d))}filter(z){return new W(B(this.event,z,this.d))}reduce(z,Y){return new W(ue(this.event,z,Y,this.d))}latch(){return new W(K(this.event,void 0,this.d))}debounce(z,Y=100,x=!1,ae=!1,he){return new W(le(this.event,z,Y,x,ae,he,this.d))}on(z,Y,x){return this.event(z,Y,x)}once(z,Y,x){return M(this.event)(z,Y,x)}dispose(){this.d.dispose()}}function H(Z){return new W(Z)}P.chain=H;function Q(Z,z,Y=x=>x){const x=(...Ee)=>Ie.fire(Y(...Ee)),ae=()=>Z.on(z,x),he=()=>Z.removeListener(z,x),Ie=new b({onWillAddFirstListener:ae,onDidRemoveLastListener:he});return Ie.event}P.fromNodeEventEmitter=Q;function ce(Z,z,Y=x=>x){const x=(...Ee)=>Ie.fire(Y(...Ee)),ae=()=>Z.addEventListener(z,x),he=()=>Z.removeEventListener(z,x),Ie=new b({onWillAddFirstListener:ae,onDidRemoveLastListener:he});return Ie.event}P.fromDOMEventEmitter=ce;function oe(Z){return new Promise(z=>M(Z)(z))}P.toPromise=oe;function j(Z,z){return z(void 0),Z(Y=>z(Y))}P.runAndSubscribe=j;function A(Z,z){let Y=null;function x(he){Y?.dispose(),Y=new r.$kb,z(he,Y)}x(void 0);const ae=Z(he=>x(he));return(0,r.$jb)(()=>{ae.dispose(),Y?.dispose()})}P.runAndSubscribeWithStore=A;class F{constructor(z,Y){this._observable=z,this.d=0,this.f=!1;const x={onWillAddFirstListener:()=>{z.addObserver(this)},onDidRemoveLastListener:()=>{z.removeObserver(this)}};Y||I(x),this.emitter=new b(x),Y&&Y.add(this.emitter)}beginUpdate(z){this.d++}handlePossibleChange(z){}handleChange(z,Y){this.f=!0}endUpdate(z){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function q(Z,z){return new F(Z,z).emitter.event}P.fromObservable=q;function G(Z){return z=>{let Y=0,x=!1;const ae={beginUpdate(){Y++},endUpdate(){Y--,Y===0&&(Z.reportChanges(),x&&(x=!1,z()))},handlePossibleChange(){},handleChange(){x=!0}};return Z.addObserver(ae),Z.reportChanges(),{dispose(){Z.removeObserver(ae)}}}}P.fromObservableLight=G})(u||(e.Event=u={}));class ${static{this.all=new Set}static{this.d=0}constructor(I){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${I}_${$.d++}`,$.all.add(this)}start(I){this.f=new R.$4c,this.listenerCount=I}stop(){if(this.f){const I=this.f.elapsed();this.durations.push(I),this.elapsedOverall+=I,this.invocationCount+=1,this.f=void 0}}}e.$6c=$;let d=-1;function p(P){const I=d;return d=P,{dispose(){d=I}}}e.$7c=p;class h{constructor(I,D=Math.random().toString(18).slice(2,5)){this.threshold=I,this.name=D,this.f=0}dispose(){this.d?.clear()}check(I,D){const M=this.threshold;if(M<=0||D<M)return;this.d||(this.d=new Map);const L=this.d.get(I.value)||0;if(this.d.set(I.value,L+1),this.f-=1,this.f<=0){this.f=M*.5;let N,B=0;for(const[re,ne]of this.d)(!N||B<ne)&&(N=re,B=ne);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${B}):`),console.warn(N)}return()=>{const N=this.d.get(I.value)||0;this.d.set(I.value,N-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(I){this.value=I}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class o{constructor(I){this.value=I,this.id=y++}}const g=2,c=(P,I)=>{if(P instanceof o)I(P);else for(let D=0;D<P.length;D++){const M=P[D];M&&I(M)}};class b{constructor(I){this.u=0,this.d=I,this.f=d>0||this.d?.leakWarningThreshold?new h(this.d?.leakWarningThreshold??d):void 0,this.g=this.d?._profName?new $(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(S){const I=this.q;queueMicrotask(()=>{c(I,D=>D.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(I,D,M)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$lb.None;if(this.j)return r.$lb.None;D&&(I=I.bind(D));const L=new o(I);let N,B;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(L.stack=v.create(),N=this.f.check(L.stack,this.u+1)),S&&(L.stack=B??v.create()),this.q?this.q instanceof o?(this.t??=new w,this.q=[this.q,L]):this.q.push(L):(this.d?.onWillAddFirstListener?.(this),this.q=L,this.d?.onDidAddFirstListener?.(this)),this.u++;const re=(0,r.$jb)(()=>{N?.(),this.v(L)});return M instanceof r.$kb?M.add(re):Array.isArray(M)&&M.push(re),re},this.m}v(I){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const D=this.q,M=D.indexOf(I);if(M===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,D[M]=void 0;const L=this.t.current===this;if(this.u*g<=D.length){let N=0;for(let B=0;B<D.length;B++)D[B]?D[N++]=D[B]:L&&(this.t.end--,N<this.t.i&&this.t.i--);D.length=N}}w(I,D){if(!I)return;const M=this.d?.onListenerError||E.$Y;if(!M){I.value(D);return}try{I.value(D)}catch(L){M(L)}}x(I){const D=I.current.q;for(;I.i<I.end;)this.w(D[I.i++],I.value);I.reset()}fire(I){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof o)this.w(this.q,I);else{const D=this.t;D.enqueue(this,I,this.q.length),this.x(D)}this.g?.stop()}hasListeners(){return this.u>0}}e.$8c=b;const k=()=>new w;e.$9c=k;class w{constructor(){this.i=-1,this.end=0}enqueue(I,D,M){this.i=0,this.end=M,this.current=I,this.value=D}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends b{async fireAsync(I,D,M){if(this.q)for(this.h||(this.h=new O.$lc),c(this.q,L=>this.h.push([L.value,I]));this.h.size>0&&!D.isCancellationRequested;){const[L,N]=this.h.shift(),B=[],re={...N,token:D,waitUntil:ne=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");M&&(ne=M(ne,L)),B.push(ne)}};try{L(re)}catch(ne){(0,E.$Y)(ne);continue}Object.freeze(B),await Promise.allSettled(B).then(ne=>{for(const ue of ne)ue.status==="rejected"&&(0,E.$Y)(ue.reason)})}}}e.$0c=t;class l extends b{get isPaused(){return this.h!==0}constructor(I){super(I),this.h=0,this.s=new O.$lc,this.y=I?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const I=Array.from(this.s);this.s.clear(),super.fire(this.y(I))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(I){this.u&&(this.h!==0?this.s.push(I):super.fire(I))}}e.$$c=l;class s extends l{constructor(I){super(I),this.k=I.delay??100}fire(I){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(I)}}e.$_c=s;class n extends b{constructor(I){super(I),this.h=[],this.k=I?.merge}fire(I){this.hasListeners()&&(this.h.push(I),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(D=>super.fire(D)),this.h=[]}))}}e.$ad=n;class i{constructor(){this.f=!1,this.g=[],this.d=new b({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(I){const D={event:I,listener:null};this.g.push(D),this.f&&this.k(D);const M=()=>{this.f&&this.m(D);const L=this.g.indexOf(D);this.g.splice(L,1)};return(0,r.$jb)((0,C.$cb)(M))}h(){this.f=!0,this.g.forEach(I=>this.k(I))}j(){this.f=!1,this.g.forEach(I=>this.m(I))}k(I){I.listener=I.event(D=>this.d.fire(D))}m(I){I.listener&&I.listener.dispose(),I.listener=null}dispose(){this.d.dispose()}}e.$bd=i;class a{constructor(){this.d=[]}wrapEvent(I){return(D,M,L)=>I(N=>{const B=this.d[this.d.length-1];B?B.push(()=>D.call(M,N)):D.call(M,N)},void 0,L)}bufferEvents(I){const D=[];this.d.push(D);const M=I();return this.d.pop(),D.forEach(L=>L()),M}}e.$cd=a;class m{constructor(){this.d=!1,this.f=u.None,this.g=r.$lb.None,this.h=new b({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(I){this.f=I,this.d&&(this.g.dispose(),this.g=I(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}e.$dd=m}),define(te[22],ie([0,1,3]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ed=e.CancellationToken=void 0;const C=Object.freeze(function(S,f){const u=setTimeout(S.bind(f),0);return{dispose(){clearTimeout(u)}}});var r;(function(S){function f(u){return u===S.None||u===S.Cancelled||u instanceof O?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}S.isCancellationToken=f,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(r||(e.CancellationToken=r={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new E.$8c),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(f){this.a=void 0,this.b=void 0,this.b=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new O),this.a}cancel(){this.a?this.a instanceof O&&this.a.cancel():this.a=r.Cancelled}dispose(f=!1){f&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof O&&this.a.dispose():this.a=r.None}}e.$ed=R}),define(te[140],ie([0,1,22]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hd=e.$gd=e.$fd=void 0;class C{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new E.$ed,f=this.b(S.token);return this.a={promise:f,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$fd=C;class r{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const f=JSON.stringify(S);return this.b!==f&&(this.b=f,this.a=this.c(S)),this.a}}e.$gd=r;class O{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const f=this.b(S);return this.a.set(S,f),f}}e.$hd=O}),define(te[56],ie([0,1,13,2]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=void 0;function r(k){const w=k;return w?typeof w.read=="function":!1}e.$ub=r;function O(k){const w=k;return w?[w.on,w.pause,w.resume,w.destroy].every(t=>typeof t=="function"):!1}e.$vb=O;function R(k){const w=k;return w?O(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.$wb=R;function S(k,w){return new f(k,w)}e.$xb=S;class f{constructor(w,t){this.e=w,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(t=>t(w))}h(w){this.c.error.length===0?(0,E.$Y)(w):this.c.error.slice(0).forEach(t=>t(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,t){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(w,t){if(this.a.destroyed)return;let l;switch(w){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const s=l.indexOf(t);s>=0&&l.splice(s,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(k,w){const t=[];let l;for(;(l=k.read())!==null;)t.push(l);return w(t)}e.$yb=u;function $(k,w,t){const l=[];let s;for(;(s=k.read())!==null&&l.length<t;)l.push(s);return s===null&&l.length>0?w(l):{read:()=>{if(l.length>0)return l.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return k.read()}}}e.$zb=$;function d(k,w){return new Promise((t,l)=>{const s=[];p(k,{onData:n=>{w&&s.push(n)},onError:n=>{w?l(n):t(void 0)},onEnd:()=>{t(w?w(s):void 0)}})})}e.$Ab=d;function p(k,w){let t=!1;return k.on("error",l=>{t||w.onError(l)}),k.on("end",()=>{t||w.onEnd()}),k.on("data",l=>{t||w.onData(l)}),(0,C.$jb)(()=>t=!0)}e.$Bb=p;function h(k,w){return new Promise((t,l)=>{const s=new C.$kb,n=[],i=P=>{if(n.push(P),n.length>w)return s.dispose(),k.pause(),t({stream:k,buffer:n,ended:!1})},a=P=>l(P),m=()=>t({stream:k,buffer:n,ended:!0});s.add((0,C.$jb)(()=>k.removeListener("error",a))),k.on("error",a),s.add((0,C.$jb)(()=>k.removeListener("end",m))),k.on("end",m),s.add((0,C.$jb)(()=>k.removeListener("data",i))),k.on("data",i)})}e.$Cb=h;function v(k,w){const t=S(w);return t.end(k),t}e.$Db=v;function y(){const k=S(()=>{throw new Error("not supported")});return k.end(),k}e.$Eb=y;function o(k){let w=!1;return{read:()=>w?null:(w=!0,k)}}e.$Fb=o;function g(k,w,t){const l=S(t);return p(k,{onData:s=>l.write(w.data(s)),onError:s=>l.error(w.error?w.error(s):s),onEnd:()=>l.end()}),l}e.$Gb=g;function c(k,w,t){let l=!1;return{read:()=>{const s=w.read();return l?s:(l=!0,s!==null?t([k,s]):k)}}}e.$Hb=c;function b(k,w,t){let l=!1;const s=S(t);return p(w,{onData:n=>l?s.write(n):(l=!0,s.write(t([k,n]))),onError:n=>s.error(n),onEnd:()=>{l||(l=!0,s.write(k)),s.end()}}),s}e.$Ib=b}),define(te[17],ie([0,1,85,56]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=void 0;const r=typeof Buffer<"u",O=new E.$T(()=>new Uint8Array(256));let R,S;class f{static alloc(M){return r?new f(Buffer.allocUnsafe(M)):new f(new Uint8Array(M))}static wrap(M){return r&&!Buffer.isBuffer(M)&&(M=Buffer.from(M.buffer,M.byteOffset,M.byteLength)),new f(M)}static fromString(M,L){return!(L?.dontUseNodeBuffer||!1)&&r?new f(Buffer.from(M)):(R||(R=new TextEncoder),new f(R.encode(M)))}static fromByteArray(M){const L=f.alloc(M.length);for(let N=0,B=M.length;N<B;N++)L.buffer[N]=M[N];return L}static concat(M,L){if(typeof L>"u"){L=0;for(let re=0,ne=M.length;re<ne;re++)L+=M[re].byteLength}const N=f.alloc(L);let B=0;for(let re=0,ne=M.length;re<ne;re++){const ue=M[re];N.set(ue,B),B+=ue.byteLength}return N}constructor(M){this.buffer=M,this.byteLength=this.buffer.byteLength}clone(){const M=f.alloc(this.byteLength);return M.set(this),M}toString(){return r?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(M,L){return new f(this.buffer.subarray(M,L))}set(M,L){if(M instanceof f)this.buffer.set(M.buffer,L);else if(M instanceof Uint8Array)this.buffer.set(M,L);else if(M instanceof ArrayBuffer)this.buffer.set(new Uint8Array(M),L);else if(ArrayBuffer.isView(M))this.buffer.set(new Uint8Array(M.buffer,M.byteOffset,M.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(M){return p(this.buffer,M)}writeUInt32BE(M,L){h(this.buffer,M,L)}readUInt32LE(M){return v(this.buffer,M)}writeUInt32LE(M,L){y(this.buffer,M,L)}readUInt8(M){return o(this.buffer,M)}writeUInt8(M,L){g(this.buffer,M,L)}indexOf(M,L=0){return u(this.buffer,M instanceof f?M.buffer:M,L)}}e.$Jb=f;function u(D,M,L=0){const N=M.byteLength,B=D.byteLength;if(N===0)return 0;if(N===1)return D.indexOf(M[0]);if(N>B-L)return-1;const re=O.value;re.fill(M.length);for(let le=0;le<M.length;le++)re[M[le]]=M.length-le-1;let ne=L+M.length-1,ue=ne,se=-1;for(;ne<B;)if(D[ne]===M[ue]){if(ue===0){se=ne;break}ne--,ue--}else ne+=Math.max(M.length-ue,re[D[ne]]),ue=M.length-1;return se}e.$Kb=u;function $(D,M){return D[M+0]<<0>>>0|D[M+1]<<8>>>0}e.$Lb=$;function d(D,M,L){D[L+0]=M&255,M=M>>>8,D[L+1]=M&255}e.$Mb=d;function p(D,M){return D[M]*2**24+D[M+1]*2**16+D[M+2]*2**8+D[M+3]}e.$Nb=p;function h(D,M,L){D[L+3]=M,M=M>>>8,D[L+2]=M,M=M>>>8,D[L+1]=M,M=M>>>8,D[L]=M}e.$Ob=h;function v(D,M){return D[M+0]<<0>>>0|D[M+1]<<8>>>0|D[M+2]<<16>>>0|D[M+3]<<24>>>0}e.$Pb=v;function y(D,M,L){D[L+0]=M&255,M=M>>>8,D[L+1]=M&255,M=M>>>8,D[L+2]=M&255,M=M>>>8,D[L+3]=M&255}e.$Qb=y;function o(D,M){return D[M]}e.$Rb=o;function g(D,M,L){D[L]=M}e.$Sb=g;function c(D){return C.$yb(D,M=>f.concat(M))}e.$Tb=c;function b(D){return C.$Fb(D)}e.$Ub=b;function k(D){return C.$Ab(D,M=>f.concat(M))}e.$Vb=k;async function w(D){return D.ended?f.concat(D.buffer):f.concat([...D.buffer,await k(D.stream)])}e.$Wb=w;function t(D){return C.$Db(D,M=>f.concat(M))}e.$Xb=t;function l(D){return C.$Gb(D,{data:M=>typeof M=="string"?f.fromString(M):f.wrap(M)},M=>f.concat(M))}e.$Yb=l;function s(D){return C.$xb(M=>f.concat(M),D)}e.$Zb=s;function n(D,M){return C.$Hb(D,M,L=>f.concat(L))}e.$1b=n;function i(D,M){return C.$Ib(D,M,L=>f.concat(L))}e.$2b=i;function a(D){let M=0,L=0,N=0;const B=new Uint8Array(Math.floor(D.length/4*3)),re=ue=>{switch(L){case 3:B[N++]=M|ue,L=0;break;case 2:B[N++]=M|ue>>>2,M=ue<<6,L=3;break;case 1:B[N++]=M|ue>>>4,M=ue<<4,L=2;break;default:M=ue<<2,L=1}};for(let ue=0;ue<D.length;ue++){const se=D.charCodeAt(ue);if(se>=65&&se<=90)re(se-65);else if(se>=97&&se<=122)re(se-97+26);else if(se>=48&&se<=57)re(se-48+52);else if(se===43||se===45)re(62);else if(se===47||se===95)re(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${D[ue]}`)}}const ne=N;for(;L>0;)re(0);return f.wrap(B).slice(0,ne)}e.$3b=a;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:D},M=!0,L=!1){const N=L?P:m;let B="";const re=D.byteLength%3;let ne=0;for(;ne<D.byteLength-re;ne+=3){const ue=D[ne+0],se=D[ne+1],le=D[ne+2];B+=N[ue>>>2],B+=N[(ue<<4|se>>>4)&63],B+=N[(se<<2|le>>>6)&63],B+=N[le&63]}if(re===1){const ue=D[ne+0];B+=N[ue>>>2],B+=N[ue<<4&63],M&&(B+="==")}else if(re===2){const ue=D[ne+0],se=D[ne+1];B+=N[ue>>>2],B+=N[(ue<<4|se>>>4)&63],B+=N[se<<2&63],M&&(B+="=")}return B}e.$4b=I}),define(te[25],ie([0,1,140,85]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.GraphemeBreakType=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=void 0;function r(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.$kd=r;const O=/{(\d+)}/g;function R(X,...de){return de.length===0?X:X.replace(O,function(me,ve){const ye=parseInt(ve,10);return isNaN(ye)||ye<0||ye>=de.length?me:de[ye]})}e.$ld=R;const S=/{([^}]+)}/g;function f(X,de){return X.replace(S,(me,ve)=>de[ve]??me)}e.$md=f;function u(X){return X.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.$nd=u;function $(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$od=$;function d(X,de){let me=0;const ve=de.charCodeAt(0);for(let ye=X.length-1;ye>=0;ye--)X.charCodeAt(ye)===ve&&me++;return me}e.$pd=d;function p(X,de,me="\u2026"){return X.length<=de?X:`${X.substr(0,de)}${me}`}e.$qd=p;function h(X,de=" "){const me=v(X,de);return y(me,de)}e.$rd=h;function v(X,de){if(!X||!de)return X;const me=de.length;if(me===0||X.length===0)return X;let ve=0;for(;X.indexOf(de,ve)===ve;)ve=ve+me;return X.substring(ve)}e.$sd=v;function y(X,de){if(!X||!de)return X;const me=de.length,ve=X.length;if(me===0||ve===0)return X;let ye=ve,Re=-1;for(;Re=X.lastIndexOf(de,ye-1),!(Re===-1||Re+me!==ye);){if(Re===0)return"";ye=Re}return X.substring(0,ye)}e.$td=y;function o(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$ud=o;function g(X){return X.replace(/\*/g,"")}e.$vd=g;function c(X,de,me={}){if(!X)throw new Error("Cannot create regex from empty string");de||(X=$(X)),me.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let ve="";return me.global&&(ve+="g"),me.matchCase||(ve+="i"),me.multiline&&(ve+="m"),me.unicode&&(ve+="u"),new RegExp(X,ve)}e.$wd=c;function b(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.$xd=b;function k(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.$yd=k;function w(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.$zd=w;function t(X){return X.split(/\r\n|\r|\n/)}e.$Ad=t;function l(X){for(let de=0,me=X.length;de<me;de++){const ve=X.charCodeAt(de);if(ve!==32&&ve!==9)return de}return-1}e.$Bd=l;function s(X,de=0,me=X.length){for(let ve=de;ve<me;ve++){const ye=X.charCodeAt(ve);if(ye!==32&&ye!==9)return X.substring(de,ve)}return X.substring(de,me)}e.$Cd=s;function n(X,de=X.length-1){for(let me=de;me>=0;me--){const ve=X.charCodeAt(me);if(ve!==32&&ve!==9)return me}return-1}e.$Dd=n;function i(X,de,me){const ve=[];let ye=0;for(const Re of X.matchAll(de)){if(ve.push(X.slice(ye,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ye=Re.index+Re[0].length,ve.push(me(Re[0],...Re.slice(1),Re.index,X,Re.groups))}return ve.push(X.slice(ye)),Promise.all(ve).then(Re=>Re.join(""))}e.$Ed=i;function a(X,de){return X<de?-1:X>de?1:0}e.$Fd=a;function m(X,de,me=0,ve=X.length,ye=0,Re=de.length){for(;me<ve&&ye<Re;me++,ye++){const Ge=X.charCodeAt(me),xe=de.charCodeAt(ye);if(Ge<xe)return-1;if(Ge>xe)return 1}const Fe=ve-me,qe=Re-ye;return Fe<qe?-1:Fe>qe?1:0}e.$Gd=m;function P(X,de){return I(X,de,0,X.length,0,de.length)}e.$Hd=P;function I(X,de,me=0,ve=X.length,ye=0,Re=de.length){for(;me<ve&&ye<Re;me++,ye++){let Ge=X.charCodeAt(me),xe=de.charCodeAt(ye);if(Ge===xe)continue;if(Ge>=128||xe>=128)return m(X.toLowerCase(),de.toLowerCase(),me,ve,ye,Re);M(Ge)&&(Ge-=32),M(xe)&&(xe-=32);const Ye=Ge-xe;if(Ye!==0)return Ye}const Fe=ve-me,qe=Re-ye;return Fe<qe?-1:Fe>qe?1:0}e.$Id=I;function D(X){return X>=48&&X<=57}e.$Jd=D;function M(X){return X>=97&&X<=122}e.$Kd=M;function L(X){return X>=65&&X<=90}e.$Ld=L;function N(X,de){return X.length===de.length&&I(X,de)===0}e.$Md=N;function B(X,de){const me=de.length;return de.length>X.length?!1:I(X,de,0,me)===0}e.$Nd=B;function re(X,de){const me=Math.min(X.length,de.length);let ve;for(ve=0;ve<me;ve++)if(X.charCodeAt(ve)!==de.charCodeAt(ve))return ve;return me}e.$Od=re;function ne(X,de){const me=Math.min(X.length,de.length);let ve;const ye=X.length-1,Re=de.length-1;for(ve=0;ve<me;ve++)if(X.charCodeAt(ye-ve)!==de.charCodeAt(Re-ve))return ve;return me}e.$Pd=ne;function ue(X){return 55296<=X&&X<=56319}e.$Qd=ue;function se(X){return 56320<=X&&X<=57343}e.$Rd=se;function le(X,de){return(X-55296<<10)+(de-56320)+65536}e.$Sd=le;function J(X,de,me){const ve=X.charCodeAt(me);if(ue(ve)&&me+1<de){const ye=X.charCodeAt(me+1);if(se(ye))return le(ve,ye)}return ve}e.$Td=J;function K(X,de){const me=X.charCodeAt(de-1);if(se(me)&&de>1){const ve=X.charCodeAt(de-2);if(ue(ve))return le(ve,me)}return me}class U{get offset(){return this.e}constructor(de,me=0){this.c=de,this.d=de.length,this.e=me}setOffset(de){this.e=de}prevCodePoint(){const de=K(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=J(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$Ud=U;class T{get offset(){return this.c.offset}constructor(de,me=0){this.c=new U(de,me)}nextGraphemeLength(){const de=Se.getInstance(),me=this.c,ve=me.offset;let ye=de.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Fe=de.getGraphemeBreakType(me.nextCodePoint());if(fe(ye,Fe)){me.setOffset(Re);break}ye=Fe}return me.offset-ve}prevGraphemeLength(){const de=Se.getInstance(),me=this.c,ve=me.offset;let ye=de.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Fe=de.getGraphemeBreakType(me.prevCodePoint());if(fe(Fe,ye)){me.setOffset(Re);break}ye=Fe}return ve-me.offset}eol(){return this.c.eol()}}e.$Vd=T;function W(X,de){return new T(X,de).nextGraphemeLength()}e.$Wd=W;function H(X,de){return new T(X,de).prevGraphemeLength()}e.$Xd=H;function Q(X,de){de>0&&se(X.charCodeAt(de))&&de--;const me=de+W(X,de);return[me-H(X,me),me]}e.$Yd=Q;function ce(X){const de=new T(X);let me=0;for(;!de.eol();)me++,de.nextGraphemeLength();return me}e.$Zd=ce;let oe;function j(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function A(X){return oe||(oe=j()),oe.test(X)}e.$1d=A;const F=/^[\t\n\r\x20-\x7E]*$/;function q(X){return F.test(X)}e.$2d=q,e.$3d=/[\u2028\u2029]/;function G(X){return e.$3d.test(X)}e.$4d=G;function Z(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.$5d=Z;function z(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.$6d=z;function Y(X,de){if(X.length<de)return X;const me=/\b/g;let ve=0;for(;me.test(X)&&!(X.length-me.lastIndex<de);)ve=me.lastIndex,me.lastIndex+=1;return X.substring(ve).replace(/^\s/,"")}e.$7d=Y;const x=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ae=/\x1b\].*?\x07/g;function he(X){return X&&(X=X.replace(x,"").replace(ae,"")),X}e.$8d=he,e.$9d=String.fromCharCode(65279);function Ie(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.$0d=Ie;function Ee(X){return Ie(X)?X.substr(1):X}e.$$d=Ee;function Ae(X,de){if(!X||!de||X.length<de.length)return!1;const me=de.length,ve=X.toLowerCase();let ye=0,Re=-1;for(;ye<me;){const Fe=ve.indexOf(de[ye],Re+1);if(Fe<0)return!1;Re=Fe,ye++}return!0}e.$_d=Ae;function Me(X,de=!1){return X?(de&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.$ae=Me;function We(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.$be=We;function $e(X,de=1){if(de===0)return"";let me=-1;do me=X.indexOf(`
`,me+1),de--;while(de>0&&me>=0);return me===-1?X:(X[me-1]==="\r"&&me--,X.substr(0,me))}e.$ce=$e;function be(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}e.$de=be;function ee(X){return Se.getInstance().getGraphemeBreakType(X)}e.$ee=ee;function fe(X,de){return X===0?de!==5&&de!==7:X===2&&de===3?!1:X===4||X===2||X===3||de===4||de===2||de===3?!0:!(X===8&&(de===8||de===9||de===11||de===12)||(X===11||X===9)&&(de===9||de===10)||(X===12||X===10)&&de===10||de===5||de===13||de===7||X===1||X===13&&de===14||X===6&&de===6)}var ge;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(e.GraphemeBreakType=ge={}));class Se{static{this.c=null}static getInstance(){return Se.c||(Se.c=new Se),Se.c}constructor(){this.d=Ce()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const me=this.d,ve=me.length/3;let ye=1;for(;ye<=ve;)if(de<me[3*ye])ye=2*ye;else if(de>me[3*ye+1])ye=2*ye+1;else return me[3*ye+2];return 0}}function Ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(X,de){if(X===0)return 0;const me=Oe(X,de);if(me!==void 0)return me;const ve=new U(de,X);return ve.prevCodePoint(),ve.offset}e.$fe=je;function Oe(X,de){const me=new U(de,X);let ve=me.prevCodePoint();for(;ze(ve)||ve===65039||ve===8419;){if(me.offset===0)return;ve=me.prevCodePoint()}if(!z(ve))return;let ye=me.offset;return ye>0&&me.prevCodePoint()===8205&&(ye=me.offset),ye}function ze(X){return 127995<=X&&X<=127999}var Te;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.$ge="\xA0";class He{static{this.c=new C.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new E.$gd(de=>{function me(Ye){const Qe=new Map;for(let tt=0;tt<Ye.length;tt+=2)Qe.set(Ye[tt],Ye[tt+1]);return Qe}function ve(Ye,Qe){const tt=new Map(Ye);for(const[ot,ct]of Qe)tt.set(ot,ct);return tt}function ye(Ye,Qe){if(!Ye)return Qe;const tt=new Map;for(const[ot,ct]of Ye)Qe.has(ot)&&tt.set(ot,ct);return tt}const Re=this.c.value;let Fe=de.filter(Ye=>!Ye.startsWith("_")&&Ye in Re);Fe.length===0&&(Fe=["_default"]);let qe;for(const Ye of Fe){const Qe=me(Re[Ye]);qe=ye(qe,Qe)}const Ge=me(Re._common),xe=ve(Ge,qe);return new He(xe)})}static getInstance(de){return He.d.get(Array.from(de))}static{this.e=new C.$T(()=>Object.keys(He.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return He.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$he=He;class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(de){return Be.e().has(de)}static get codePoints(){return Be.e()}}e.$ie=Be}),define(te[57],ie([0,1,25]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=void 0;function C(g){return r(g,0)}e.$di=C;function r(g,c){switch(typeof g){case"object":return g===null?O(349,c):Array.isArray(g)?f(g,c):u(g,c);case"string":return S(g,c);case"boolean":return R(g,c);case"number":return O(g,c);case"undefined":return O(937,c);default:return O(617,c)}}e.$ei=r;function O(g,c){return(c<<5)-c+g|0}e.$fi=O;function R(g,c){return O(g?433:863,c)}function S(g,c){c=O(149417,c);for(let b=0,k=g.length;b<k;b++)c=O(g.charCodeAt(b),c);return c}e.$gi=S;function f(g,c){return c=O(104579,c),g.reduce((b,k)=>r(k,b),c)}function u(g,c){return c=O(181387,c),Object.keys(g).sort().reduce((b,k)=>(b=S(k,b),r(g[k],b)),c)}class ${constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=r(c,this.g),this.g}}e.$hi=$;var d;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(d||(d={}));function p(g,c,b=32){const k=b-c,w=~((1<<k)-1);return(g<<c|(w&g)>>>k)>>>0}function h(g,c=0,b=g.byteLength,k=0){for(let w=0;w<b;w++)g[c+w]=k}function v(g,c,b="0"){for(;g.length<c;)g=b+g;return g}function y(g,c=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(b=>b.toString(16).padStart(2,"0")).join(""):v((g>>>0).toString(16),c/4)}e.$ii=y;class o{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const b=c.length;if(b===0)return;const k=this.p;let w=this.r,t=this.u,l,s;for(t!==0?(l=t,s=-1,t=0):(l=c.charCodeAt(0),s=0);;){let n=l;if(E.$Qd(l))if(s+1<b){const i=c.charCodeAt(s+1);E.$Rd(i)?(s++,n=E.$Sd(l,i)):n=65533}else{t=l;break}else E.$Rd(l)&&(n=65533);if(w=this.w(k,w,n),s++,s<b)l=c.charCodeAt(s);else break}this.r=w,this.u=t}w(c,b,k){return k<128?c[b++]=k:k<2048?(c[b++]=192|(k&1984)>>>6,c[b++]=128|(k&63)>>>0):k<65536?(c[b++]=224|(k&61440)>>>12,c[b++]=128|(k&4032)>>>6,c[b++]=128|(k&63)>>>0):(c[b++]=240|(k&1835008)>>>18,c[b++]=128|(k&258048)>>>12,c[b++]=128|(k&4032)>>>6,c[b++]=128|(k&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=o.g,b=this.q;for(let m=0;m<64;m+=4)c.setUint32(m,b.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)c.setUint32(m,p(c.getUint32(m-12,!1)^c.getUint32(m-32,!1)^c.getUint32(m-56,!1)^c.getUint32(m-64,!1),1),!1);let k=this.h,w=this.l,t=this.m,l=this.n,s=this.o,n,i,a;for(let m=0;m<80;m++)m<20?(n=w&t|~w&l,i=1518500249):m<40?(n=w^t^l,i=1859775393):m<60?(n=w&t|w&l|t&l,i=2400959708):(n=w^t^l,i=3395469782),a=p(k,5)+n+s+i+c.getUint32(m*4,!1)&4294967295,s=l,l=t,t=p(w,30),w=k,k=a;this.h=this.h+k&4294967295,this.l=this.l+w&4294967295,this.m=this.m+t&4294967295,this.n=this.n+l&4294967295,this.o=this.o+s&4294967295}}e.$ji=o}),define(te[70],ie([0,1,25]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(C||(C={})),function(r){const O="error",R="warning",S="warn",f="info",u="ignore";function $(p){return p?E.$Md(O,p)?r.Error:E.$Md(R,p)||E.$Md(S,p)?r.Warning:E.$Md(f,p)?r.Info:r.Ignore:r.Ignore}r.fromValue=$;function d(p){switch(p){case r.Error:return O;case r.Warning:return R;case r.Info:return f;default:return u}}r.toString=d}(C||(C={})),e.default=C}),define(te[141],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0,e.$5c=Symbol("MicrotaskDelay")}),define(te[58],ie([0,1,24,25]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=void 0;class r{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const v=h.charCodeAt(0),y=this.b.charCodeAt(this.c);return v-y}value(){return this.b[this.c]}}e.$rh=r;class O{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,C.$Gd)(h,this.b,0,h.length,this.c,this.d):(0,C.$Id)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$sh=O;class R{constructor(h=!0,v=!0){this.f=h,this.g=v}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let v=h.length-1;v>=0;v--,this.c--){const y=this.b.charCodeAt(v);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,C.$Gd)(h,this.b,0,h.length,this.d,this.e):(0,C.$Id)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$th=R;var S;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(S||(S={}));class f{constructor(h,v){this.f=h,this.g=v,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,C.$Hd)(h,this.c.scheme);if(this.d[this.e]===2)return(0,C.$Hd)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,C.$Fd)(h,this.c.query);if(this.d[this.e]===5)return(0,C.$Fd)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$uh=f;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var $;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})($||($={}));class d{static forUris(h=()=>!1,v=()=>!1){return new d(new f(h,v))}static forPaths(h=!1){return new d(new R(void 0,!h))}static forStrings(){return new d(new r)}static forConfigKeys(){return new d(new O)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,v){if(v){const y=v.slice(0);(0,E.$Ef)(y);for(const o of y)this.set(o,h)}else{const y=h.slice(0);(0,E.$Ef)(y);for(const o of y)this.set(o[0],o[1])}}set(h,v){const y=this.b.reset(h);let o;this.c||(this.c=new u,this.c.segment=y.value());const g=[];for(o=this.c;;){const b=y.cmp(o.segment);if(b>0)o.left||(o.left=new u,o.left.segment=y.value()),g.push([-1,o]),o=o.left;else if(b<0)o.right||(o.right=new u,o.right.segment=y.value()),g.push([1,o]),o=o.right;else if(y.hasNext())y.next(),o.mid||(o.mid=new u,o.mid.segment=y.value()),g.push([0,o]),o=o.mid;else break}const c=o.value;o.value=v,o.key=h;for(let b=g.length-1;b>=0;b--){const k=g[b][1];k.updateHeight();const w=k.balanceFactor();if(w<-1||w>1){const t=g[b][0],l=g[b+1][0];if(t===1&&l===1)g[b][1]=k.rotateLeft();else if(t===-1&&l===-1)g[b][1]=k.rotateRight();else if(t===1&&l===-1)k.right=g[b+1][1]=g[b+1][1].rotateRight(),g[b][1]=k.rotateLeft();else if(t===-1&&l===1)k.left=g[b+1][1]=g[b+1][1].rotateLeft(),g[b][1]=k.rotateRight();else throw new Error;if(b>0)switch(g[b-1][0]){case-1:g[b-1][1].left=g[b][1];break;case 1:g[b-1][1].right=g[b][1];break;case 0:g[b-1][1].mid=g[b][1];break}else this.c=g[0][1]}}return c}get(h){return this.d(h)?.value}d(h){const v=this.b.reset(h);let y=this.c;for(;y;){const o=v.cmp(y.segment);if(o>0)y=y.left;else if(o<0)y=y.right;else if(v.hasNext())v.next(),y=y.mid;else break}return y}has(h){const v=this.d(h);return!(v?.value===void 0&&v?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,v){const y=this.b.reset(h),o=[];let g=this.c;for(;g;){const c=y.cmp(g.segment);if(c>0)o.push([-1,g]),g=g.left;else if(c<0)o.push([1,g]),g=g.right;else if(y.hasNext())y.next(),o.push([0,g]),g=g.mid;else break}if(g){if(v?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const c=this.f(g.right);if(c.key){const{key:b,value:k,segment:w}=c;this.e(c.key,!1),g.key=b,g.value=k,g.segment=w}}else{const c=g.left??g.right;if(o.length>0){const[b,k]=o[o.length-1];switch(b){case-1:k.left=c;break;case 0:k.mid=c;break;case 1:k.right=c;break}}else this.c=c}for(let c=o.length-1;c>=0;c--){const b=o[c][1];b.updateHeight();const k=b.balanceFactor();if(k>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),o[c][1]=b.rotateLeft()):k<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),o[c][1]=b.rotateRight()),c>0)switch(o[c-1][0]){case-1:o[c-1][1].left=o[c][1];break;case 1:o[c-1][1].right=o[c][1];break;case 0:o[c-1][1].mid=o[c][1];break}else this.c=o[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const v=this.b.reset(h);let y=this.c,o;for(;y;){const g=v.cmp(y.segment);if(g>0)y=y.left;else if(g<0)y=y.right;else if(v.hasNext())v.next(),o=y.value||o,y=y.mid;else break}return y&&y.value||o}findSuperstr(h){return this.g(h,!1)}g(h,v){const y=this.b.reset(h);let o=this.c;for(;o;){const g=y.cmp(o.segment);if(g>0)o=o.left;else if(g<0)o=o.right;else if(y.hasNext())y.next(),o=o.mid;else return o.mid?this.h(o.mid):v?o.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[v,y]of this)h(y,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const v=[];return this.j(h,v),v[Symbol.iterator]()}j(h,v){h&&(h.left&&this.j(h.left,v),h.value&&v.push([h.key,h.value]),h.mid&&this.j(h.mid,v),h.right&&this.j(h.right,v))}_isBalanced(){const h=v=>{if(!v)return!0;const y=v.balanceFactor();return y<-1||y>1?!1:h(v.left)&&h(v.right)};return h(this.c)}}e.$vh=d}),define(te[10],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;function E(l){return typeof l=="string"}e.$je=E;function C(l){return Array.isArray(l)&&l.every(s=>E(s))}e.$ke=C;function r(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.$le=r;function O(l){const s=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof s}e.$me=O;function R(l){return typeof l=="number"&&!isNaN(l)}e.$ne=R;function S(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.$oe=S;function f(l){return l===!0||l===!1}e.$pe=f;function u(l){return typeof l>"u"}e.$qe=u;function $(l){return!d(l)}e.$re=$;function d(l){return u(l)||l===null}e.$se=d;function p(l,s){if(!l)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$te=p;function h(l){if(d(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.$ue=h;function v(...l){const s=[];for(let n=0;n<l.length;n++){const i=l[n];if(d(i))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);s.push(i)}return s}e.$ve=v;const y=Object.prototype.hasOwnProperty;function o(l){if(!r(l))return!1;for(const s in l)if(y.call(l,s))return!1;return!0}e.$we=o;function g(l){return typeof l=="function"}e.$xe=g;function c(...l){return l.length>0&&l.every(g)}e.$ye=c;function b(l,s){const n=Math.min(l.length,s.length);for(let i=0;i<n;i++)k(l[i],s[i])}e.$ze=b;function k(l,s){if(E(s)){if(typeof l!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(g(s)){try{if(l instanceof s)return}catch{}if(!d(l)&&l.constructor===s||s.length===1&&s.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Ae=k;function w(l){return l===null?void 0:l}e.$Be=w;function t(l){return typeof l>"u"?null:l}e.$Ce=t}),define(te[71],ie([0,1,10]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=e.$Aj=void 0;const C=Object.create(null);function r(S,f){if((0,E.$je)(f)){const u=C[f];if(u===void 0)throw new Error(`${S} references an unknown codicon: ${f}`);f=u}return C[S]=f,{id:S}}function O(){return C}e.$Aj=O;function R(){return Object.values(e.$Cj)}e.$Bj=R,e.$Cj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package_:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(te[37],ie([0,1,10]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=void 0;function C(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const c=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([b,k])=>{c[b]=k&&typeof k=="object"?C(k):k}),c}e.$Hm=C;function r(g){if(!g||typeof g!="object")return g;const c=[g];for(;c.length>0;){const b=c.shift();Object.freeze(b);for(const k in b)if(O.call(b,k)){const w=b[k];typeof w=="object"&&!Object.isFrozen(w)&&!(0,E.$me)(w)&&c.push(w)}}return g}e.$Im=r;const O=Object.prototype.hasOwnProperty;function R(g,c){return S(g,c,new Set)}e.$Jm=R;function S(g,c,b){if((0,E.$se)(g))return g;const k=c(g);if(typeof k<"u")return k;if(Array.isArray(g)){const w=[];for(const t of g)w.push(S(t,c,b));return w}if((0,E.$le)(g)){if(b.has(g))throw new Error("Cannot clone recursive data-structure");b.add(g);const w={};for(const t in g)O.call(g,t)&&(w[t]=S(g[t],c,b));return b.delete(g),w}return g}function f(g,c,b=!0){return(0,E.$le)(g)?((0,E.$le)(c)&&Object.keys(c).forEach(k=>{k in g?b&&((0,E.$le)(g[k])&&(0,E.$le)(c[k])?f(g[k],c[k],b):g[k]=c[k]):g[k]=c[k]}),g):c}e.$Km=f;function u(g,c){if(g===c)return!0;if(g==null||c===null||c===void 0||typeof g!=typeof c||typeof g!="object"||Array.isArray(g)!==Array.isArray(c))return!1;let b,k;if(Array.isArray(g)){if(g.length!==c.length)return!1;for(b=0;b<g.length;b++)if(!u(g[b],c[b]))return!1}else{const w=[];for(k in g)w.push(k);w.sort();const t=[];for(k in c)t.push(k);if(t.sort(),!u(w,t))return!1;for(b=0;b<w.length;b++)if(!u(g[w[b]],c[w[b]]))return!1}return!0}e.$Lm=u;function $(g){const c=new Set;return JSON.stringify(g,(b,k)=>{if((0,E.$le)(k)||Array.isArray(k)){if(c.has(k))return"[Circular]";c.add(k)}return k})}e.$Mm=$;function d(g,c){const b=Object.create(null);return!g||!c||Object.keys(c).forEach(w=>{const t=g[w],l=c[w];u(t,l)||(b[w]=l)}),b}e.$Nm=d;function p(g,c){const b=c.toLowerCase(),k=Object.keys(g).find(w=>w.toLowerCase()===b);return k?g[k]:g[c]}e.$Om=p;function h(g,c){const b=Object.create(null);for(const[k,w]of Object.entries(g))c(k,w)&&(b[k]=w);return b}e.$Pm=h;function v(g){let c=[];for(;Object.prototype!==g;)c=c.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return c}e.$Qm=v;function y(g){const c=[];for(const b of v(g))typeof g[b]=="function"&&c.push(b);return c}e.$Rm=y;function o(g,c){const b=w=>function(){const t=Array.prototype.slice.call(arguments,0);return c(w,t)},k={};for(const w of g)k[w]=b(w);return k}e.$Sm=o}),define(te[102],ie([0,1,71]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Dj=e.ThemeColor=void 0;var C;(function(R){function S(f){return f&&typeof f=="object"&&typeof f.id=="string"}R.isThemeColor=S})(C||(e.ThemeColor=C={}));function r(R){return{id:R}}e.$Dj=r;var O;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function f(c){const b=S.exec(c.id);if(!b)return f(E.$Cj.error);const[,k,w]=b,t=["codicon","codicon-"+k];return w&&t.push("codicon-modifier-"+w.substring(1)),t}R.asClassNameArray=f;function u(c){return f(c).join(" ")}R.asClassName=u;function $(c){return"."+f(c).join(".")}R.asCSSSelector=$;function d(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||C.isThemeColor(c.color))}R.isThemeIcon=d;const p=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function h(c){const b=p.exec(c);if(!b)return;const[,k]=b;return{id:k}}R.fromString=h;function v(c){return{id:c}}R.fromId=v;function y(c,b){let k=c.id;const w=k.lastIndexOf("~");return w!==-1&&(k=k.substring(0,w)),b&&(k=`${k}~${b}`),{id:k}}R.modify=y;function o(c){const b=c.id.lastIndexOf("~");if(b!==-1)return c.id.substring(b+1)}R.getModifier=o;function g(c,b){return c.id===b.id&&c.color?.id===b.color?.id}R.isEqual=g})(O||(e.ThemeIcon=O={}))}),define(te[31],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(r){return E.test(r)}e.$5e=C,e.$6e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(S){for(let f=0;f<S.length;f++)S[f]=Math.floor(Math.random()*256);return S};const O=new Uint8Array(16),R=[];for(let S=0;S<256;S++)R.push(S.toString(16).padStart(2,"0"));return function(){r(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let f=0,u="";return u+=R[O[f++]],u+=R[O[f++]],u+=R[O[f++]],u+=R[O[f++]],u+="-",u+=R[O[f++]],u+=R[O[f++]],u+="-",u+=R[O[f++]],u+=R[O[f++]],u+="-",u+=R[O[f++]],u+=R[O[f++]],u+="-",u+=R[O[f++]],u+=R[O[f++]],u+=R[O[f++]],u+=R[O[f++]],u+=R[O[f++]],u+=R[O[f++]],u}}()}),define(te[142],ie([0,1,72,45,49]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jS=void 0;async function O(R,S){if(await new Promise(($,d)=>{const p=C.createReadStream(R),h=E.createHash("sha1");p.pipe(h);const v=(0,r.$cb)((y,o)=>{p.removeAllListeners(),h.removeAllListeners(),y?d(y):$(o)});p.once("error",v),p.once("end",v),h.once("error",v),h.once("data",y=>v(void 0,y.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$jS=O}),define(te[143],ie([0,1,27]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=void 0;const C=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(R){const S=R.replace(/\-/g,":").toLowerCase();return!C.has(S)}function O(){const R=(0,E.networkInterfaces)();for(const S in R){const f=R[S];if(f){for(const{mac:u}of f)if(r(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$sm=O}),define(te[87],ie([0,1,27,58,31,143]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0,e.$tm=new class{c(u){return this.a||(this.a=C.$vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(u)}value(){if(this.b===void 0){let u=0,$=0;const d=(0,E.networkInterfaces)();for(const p in d){const h=d[p];if(h)for(const{mac:v,internal:y}of h)y||($+=1,this.c(v.toUpperCase())&&(u+=1))}this.b=$>0?u/$:0}return this.b}};let R;async function S(u){return R||(R=(async()=>await f(u)||r.$6e())()),R}e.$um=S;async function f(u){try{const $=await new Promise((p,h)=>{V(["crypto"],p,h)}),d=(0,O.$sm)();return $.createHash("sha256").update(d,"utf8").digest("hex")}catch($){u($);return}}}),define(te[103],ie([0,1,88]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$8e=void 0;function C(S,f,u,$=1){let d=!1;return new Promise(p=>{const h=setTimeout(()=>{if(!d)return d=!0,p(0)},u);r(S,f,$,v=>{if(!d)return d=!0,clearTimeout(h),p(v)})})}e.$8e=C;function r(S,f,u,$){if(f===0)return $(0);const d=new E.Socket;d.once("connect",()=>(R(d),r(S+u,f-1,u,$))),d.once("data",()=>{}),d.once("error",p=>(R(d),p.code!=="ECONNREFUSED"?r(S+u,f-1,u,$):$(S))),d.connect(S,"127.0.0.1")}e.$9e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(S,f,u,$="127.0.0.1"){let d=!1,p,h=1;const v=E.createServer({pauseOnConnect:!0});function y(o,g){d||(d=!0,v.removeAllListeners(),v.close(),p&&clearTimeout(p),g(o))}return new Promise(o=>{p=setTimeout(()=>{y(0,o)},u),v.on("listening",()=>{y(S,o)}),v.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&h<f?(S++,h++,v.listen(S,$)):y(0,o)}),v.on("close",()=>{y(0,o)}),v.listen(S,$)})}e.$0e=O;function R(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(f){console.error(f)}}}),function(){function V(){function e(){return process.uncHostAllowlist}function E(f){const u=new Set;if(Array.isArray(f))for(const $ of f)typeof $=="string"&&u.add($);return Array.from(u)}function C(){const f=e();return f?Array.from(f):[]}function r(f){if(process.platform!=="win32")return;const u=e();if(u)if(typeof f=="string")u.add(f.toLowerCase());else for(const $ of E(f))r($)}function O(f){if(typeof f!="string")return;const u=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let $;for(const d of u){if(f.indexOf(d)!==0)continue;const h=f.indexOf("\\",d.length);if(h===-1)continue;const v=f.substring(d.length,h);if(v){$=v;break}}return $}function R(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:C,addUNCHostToAllowlist:r,getUNCHost:O,disableUNCAccessRestrictions:R,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return V()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=V():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(te[144],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nS=e.$mS=void 0,e.$mS="vscode:contextmenu",e.$nS="vscode:onCloseContextMenu"}),define(te[145],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uS=void 0;class E{constructor(r,O){this.a=r,this.onMessage=O}send(r){try{this.a.send("vscode:message",r.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$uS=E}),define(te[38],ie([0,1,14,13]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oS=void 0;class r{constructor(){this.a=new WeakMap}on(R,S){const f=(u,...$)=>{this.b(R,u)&&S(u,...$)};return this.a.set(S,f),E.ipcMain.on(R,f),this}once(R,S){return E.ipcMain.once(R,(f,...u)=>{this.b(R,f)&&S(f,...u)}),this}handle(R,S){return E.ipcMain.handle(R,(f,...u)=>this.b(R,f)?S(f,...u):Promise.reject(`Invalid channel '${R}' or sender for ipcMain.handle() usage.`)),this}removeHandler(R){return E.ipcMain.removeHandler(R),this}removeListener(R,S){const f=this.a.get(S);return f&&(E.ipcMain.removeListener(R,f),this.a.delete(S)),this}b(R,S){if(!R||!R.startsWith("vscode:"))return(0,C.$Y)(`Refused to handle ipcMain event for channel '${R}' because the channel is unknown.`),!1;const f=S.senderFrame,u=f.url;if(!u)return!0;let $="unknown";try{$=new URL(u).host}catch{return(0,C.$Y)(`Refused to handle ipcMain event for channel '${R}' because of a malformed URL '${u}'.`),!1}return $!=="vscode-app"?((0,C.$Y)(`Refused to handle ipcMain event for channel '${R}' because of a bad origin of '${$}'.`),!1):f.parent!==null?((0,C.$Y)(`Refused to handle ipcMain event for channel '${R}' because sender of origin '${$}' is not a main frame.`),!1):!0}}e.$oS=new r}),define(te[146],ie([0,1,14,38,10,144]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pS=void 0;function R(){C.$oS.on(O.$mS,(f,u,$,d,p)=>{const h=S(f,d,$);h.popup({window:(0,r.$Be)(E.BrowserWindow.fromWebContents(f.sender)),x:p?p.x:void 0,y:p?p.y:void 0,positioningItem:p?p.positioningItem:void 0,callback:()=>{h&&f.sender.send(O.$nS,u)}})})}e.$pS=R;function S(f,u,$){const d=new E.Menu;return $.forEach(p=>{let h;p.type==="separator"?h=new E.MenuItem({type:p.type}):Array.isArray(p.submenu)?h=new E.MenuItem({submenu:S(f,u,p.submenu),label:p.label}):h=new E.MenuItem({label:p.label,type:p.type,accelerator:p.accelerator,checked:p.checked,enabled:p.enabled,visible:p.visible,click:(v,y,o)=>f.sender.send(u,p.id,o)}),d.append(h)}),d}}),define(te[147],ie([12,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(te[148],ie([0,1,147]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=void 0;const C=60,r=C*60,O=r*24,R=O*7,S=O*30,f=O*365;function u(d,p,h,v){typeof d!="number"&&(d=d.getTime());const y=Math.round((new Date().getTime()-d)/1e3);if(y<-30)return(0,E.localize)(0,null,u(new Date().getTime()+y*1e3,!1));if(!v&&y<30)return(0,E.localize)(1,null);let o;return y<C?(o=y,p?o===1?h?(0,E.localize)(2,null,o):(0,E.localize)(3,null,o):h?(0,E.localize)(4,null,o):(0,E.localize)(5,null,o):o===1?h?(0,E.localize)(6,null,o):(0,E.localize)(7,null,o):h?(0,E.localize)(8,null,o):(0,E.localize)(9,null,o)):y<r?(o=Math.floor(y/C),p?o===1?h?(0,E.localize)(10,null,o):(0,E.localize)(11,null,o):h?(0,E.localize)(12,null,o):(0,E.localize)(13,null,o):o===1?h?(0,E.localize)(14,null,o):(0,E.localize)(15,null,o):h?(0,E.localize)(16,null,o):(0,E.localize)(17,null,o)):y<O?(o=Math.floor(y/r),p?o===1?h?(0,E.localize)(18,null,o):(0,E.localize)(19,null,o):h?(0,E.localize)(20,null,o):(0,E.localize)(21,null,o):o===1?h?(0,E.localize)(22,null,o):(0,E.localize)(23,null,o):h?(0,E.localize)(24,null,o):(0,E.localize)(25,null,o)):y<R?(o=Math.floor(y/O),p?o===1?(0,E.localize)(26,null,o):(0,E.localize)(27,null,o):o===1?(0,E.localize)(28,null,o):(0,E.localize)(29,null,o)):y<S?(o=Math.floor(y/R),p?o===1?h?(0,E.localize)(30,null,o):(0,E.localize)(31,null,o):h?(0,E.localize)(32,null,o):(0,E.localize)(33,null,o):o===1?h?(0,E.localize)(34,null,o):(0,E.localize)(35,null,o):h?(0,E.localize)(36,null,o):(0,E.localize)(37,null,o)):y<f?(o=Math.floor(y/S),p?o===1?h?(0,E.localize)(38,null,o):(0,E.localize)(39,null,o):h?(0,E.localize)(40,null,o):(0,E.localize)(41,null,o):o===1?h?(0,E.localize)(42,null,o):(0,E.localize)(43,null,o):h?(0,E.localize)(44,null,o):(0,E.localize)(45,null,o)):(o=Math.floor(y/f),p?o===1?h?(0,E.localize)(46,null,o):(0,E.localize)(47,null,o):h?(0,E.localize)(48,null,o):(0,E.localize)(49,null,o):o===1?h?(0,E.localize)(50,null,o):(0,E.localize)(51,null,o):h?(0,E.localize)(52,null,o):(0,E.localize)(53,null,o))}e.$Rl=u;function $(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Sl=$}),define(te[149],ie([12,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(te[50],ie([0,1,24,10,149]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=void 0;function O(d,p){return p&&(d.stack||d.stacktrace)?r.localize(0,null,S(d),R(d.stack)||R(d.stacktrace)):S(d)}function R(d){return Array.isArray(d)?d.join(`
`):d}function S(d){return d.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?r.localize(1,null,d.message):d.message||r.localize(2,null)}function f(d=null,p=!1){if(!d)return r.localize(3,null);if(Array.isArray(d)){const h=E.$mf(d),v=f(h[0],p);return h.length>1?r.localize(4,null,v,h.length):v}if(C.$je(d))return d;if(d.detail){const h=d.detail;if(h.error)return O(h.error,p);if(h.exception)return O(h.exception,p)}return d.stack?O(d,p):d.message?d.message:r.localize(5,null)}e.$ai=f;function u(d){const p=d;return p instanceof Error&&Array.isArray(p.actions)}e.$bi=u;function $(d,p){let h;return typeof d=="string"?h=new Error(d):h=d,h.actions=p,h}e.$ci=$}),define(te[150],ie([12,11]),function(V,e){return V.create("vs/base/common/jsonErrorMessages",e)}),define(te[151],ie([0,1,150]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=void 0;function C(r){switch(r){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.$bp=C}),define(te[152],ie([12,11]),function(V,e){return V.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,152]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let C=!1,r=!1,O=!1,R=!1,S=!1,f=!1,u=!1,$=!1,d=!1,p=!1,h,v=e.$f,y=e.$f,o,g;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?c=e.$g.vscode.process:typeof process<"u"&&(c=process);const b=typeof c?.versions?.electron=="string",k=b&&c?.type==="renderer";if(typeof navigator=="object"&&!k)g=navigator.userAgent,C=g.indexOf("Windows")>=0,r=g.indexOf("Macintosh")>=0,$=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=g.indexOf("Linux")>=0,p=g?.indexOf("Mobi")>=0,f=!0,h=E.getConfiguredDefaultLocale(E.localize(0,null))||e.$f,v=h,y=navigator.language;else if(typeof c=="object"){C=c.platform==="win32",r=c.platform==="darwin",O=c.platform==="linux",R=O&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,u=b,d=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$f,v=e.$f;const P=c.env.VSCODE_NLS_CONFIG;if(P)try{const I=JSON.parse(P),D=I.availableLanguages["*"];h=I.locale,y=I.osLocale,v=D||e.$f,o=I._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var w;(function(P){P[P.Web=0]="Web",P[P.Mac=1]="Mac",P[P.Linux=2]="Linux",P[P.Windows=3]="Windows"})(w||(e.Platform=w={}));function t(P){switch(P){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let l=0;r?l=1:C?l=3:O&&(l=2),e.$i=C,e.$j=r,e.$k=O,e.$l=R,e.$m=S,e.$n=u,e.$o=f,e.$p=f&&typeof e.$g.importScripts=="function",e.$q=$,e.$r=p,e.$s=d,e.$t=l,e.$u=g,e.$v=v;var s;(function(P){function I(){return e.$v}P.value=I;function D(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}P.isDefaultVariant=D;function M(){return e.$v==="en"}P.isDefault=M})(s||(e.Language=s={})),e.$w=h,e.$x=y,e.$y=o,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const P=[];e.$g.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let M=0,L=P.length;M<L;M++){const N=P[M];if(N.id===D.data.vscodeScheduleAsyncWork){P.splice(M,1),N.callback();return}}});let I=0;return D=>{const M=++I;P.push({id:M,callback:D}),e.$g.postMessage({vscodeScheduleAsyncWork:M},"*")}}return P=>setTimeout(P)})();var n;(function(P){P[P.Windows=1]="Windows",P[P.Macintosh=2]="Macintosh",P[P.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=r||$?2:C?1:3;let i=!0,a=!1;function m(){if(!a){a=!0;const P=new Uint8Array(2);P[0]=1,P[1]=2,i=new Uint16Array(P.buffer)[0]===(2<<8)+1}return i}e.$C=m,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(te[36],ie([0,1,4]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8b=e.$7b=e.env=e.cwd=void 0;let C;if(typeof E.$g.vscode<"u"&&typeof E.$g.vscode.process<"u"){const r=E.$g.vscode.process;C={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return E.$i?"win32":E.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.$7b=C.platform,e.$8b=C.arch}),define(te[9],ie([0,1,36]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kc=e.sep=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=void 0;const C=65,r=97,O=90,R=122,S=46,f=47,u=92,$=58,d=63;class p extends Error{constructor(l,s,n){let i;typeof s=="string"&&s.indexOf("not ")===0?(i="must not be",s=s.replace(/^not /,"")):i="must be";const a=l.indexOf(".")!==-1?"property":"argument";let m=`The "${l}" ${a} ${i} of type ${s}`;m+=`. Received type ${typeof n}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,l){if(t===null||typeof t!="object")throw new p(l,"Object",t)}function v(t,l){if(typeof t!="string")throw new p(l,"string",t)}const y=E.$7b==="win32";function o(t){return t===f||t===u}function g(t){return t===f}function c(t){return t>=C&&t<=O||t>=r&&t<=R}function b(t,l,s,n){let i="",a=0,m=-1,P=0,I=0;for(let D=0;D<=t.length;++D){if(D<t.length)I=t.charCodeAt(D);else{if(n(I))break;I=f}if(n(I)){if(!(m===D-1||P===1))if(P===2){if(i.length<2||a!==2||i.charCodeAt(i.length-1)!==S||i.charCodeAt(i.length-2)!==S){if(i.length>2){const M=i.lastIndexOf(s);M===-1?(i="",a=0):(i=i.slice(0,M),a=i.length-1-i.lastIndexOf(s)),m=D,P=0;continue}else if(i.length!==0){i="",a=0,m=D,P=0;continue}}l&&(i+=i.length>0?`${s}..`:"..",a=2)}else i.length>0?i+=`${s}${t.slice(m+1,D)}`:i=t.slice(m+1,D),a=D-m-1;m=D,P=0}else I===S&&P!==-1?++P:P=-1}return i}function k(t,l){h(l,"pathObject");const s=l.dir||l.root,n=l.base||`${l.name||""}${l.ext||""}`;return s?s===l.root?`${s}${n}`:`${s}${t}${n}`:n}e.$9b={resolve(...t){let l="",s="",n=!1;for(let i=t.length-1;i>=-1;i--){let a;if(i>=0){if(a=t[i],v(a,"path"),a.length===0)continue}else l.length===0?a=E.cwd():(a=E.env[`=${l}`]||E.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==l.toLowerCase()&&a.charCodeAt(2)===u)&&(a=`${l}\\`));const m=a.length;let P=0,I="",D=!1;const M=a.charCodeAt(0);if(m===1)o(M)&&(P=1,D=!0);else if(o(M))if(D=!0,o(a.charCodeAt(1))){let L=2,N=L;for(;L<m&&!o(a.charCodeAt(L));)L++;if(L<m&&L!==N){const B=a.slice(N,L);for(N=L;L<m&&o(a.charCodeAt(L));)L++;if(L<m&&L!==N){for(N=L;L<m&&!o(a.charCodeAt(L));)L++;(L===m||L!==N)&&(I=`\\\\${B}\\${a.slice(N,L)}`,P=L)}}}else P=1;else c(M)&&a.charCodeAt(1)===$&&(I=a.slice(0,2),P=2,m>2&&o(a.charCodeAt(2))&&(D=!0,P=3));if(I.length>0)if(l.length>0){if(I.toLowerCase()!==l.toLowerCase())continue}else l=I;if(n){if(l.length>0)break}else if(s=`${a.slice(P)}\\${s}`,n=D,D&&l.length>0)break}return s=b(s,!n,"\\",o),n?`${l}\\${s}`:`${l}${s}`||"."},normalize(t){v(t,"path");const l=t.length;if(l===0)return".";let s=0,n,i=!1;const a=t.charCodeAt(0);if(l===1)return g(a)?"\\":t;if(o(a))if(i=!0,o(t.charCodeAt(1))){let P=2,I=P;for(;P<l&&!o(t.charCodeAt(P));)P++;if(P<l&&P!==I){const D=t.slice(I,P);for(I=P;P<l&&o(t.charCodeAt(P));)P++;if(P<l&&P!==I){for(I=P;P<l&&!o(t.charCodeAt(P));)P++;if(P===l)return`\\\\${D}\\${t.slice(I)}\\`;P!==I&&(n=`\\\\${D}\\${t.slice(I,P)}`,s=P)}}}else s=1;else c(a)&&t.charCodeAt(1)===$&&(n=t.slice(0,2),s=2,l>2&&o(t.charCodeAt(2))&&(i=!0,s=3));let m=s<l?b(t.slice(s),!i,"\\",o):"";return m.length===0&&!i&&(m="."),m.length>0&&o(t.charCodeAt(l-1))&&(m+="\\"),n===void 0?i?`\\${m}`:m:i?`${n}\\${m}`:`${n}${m}`},isAbsolute(t){v(t,"path");const l=t.length;if(l===0)return!1;const s=t.charCodeAt(0);return o(s)||l>2&&c(s)&&t.charCodeAt(1)===$&&o(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,s;for(let a=0;a<t.length;++a){const m=t[a];v(m,"path"),m.length>0&&(l===void 0?l=s=m:l+=`\\${m}`)}if(l===void 0)return".";let n=!0,i=0;if(typeof s=="string"&&o(s.charCodeAt(0))){++i;const a=s.length;a>1&&o(s.charCodeAt(1))&&(++i,a>2&&(o(s.charCodeAt(2))?++i:n=!1))}if(n){for(;i<l.length&&o(l.charCodeAt(i));)i++;i>=2&&(l=`\\${l.slice(i)}`)}return e.$9b.normalize(l)},relative(t,l){if(v(t,"from"),v(l,"to"),t===l)return"";const s=e.$9b.resolve(t),n=e.$9b.resolve(l);if(s===n||(t=s.toLowerCase(),l=n.toLowerCase(),t===l))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===u;)i++;let a=t.length;for(;a-1>i&&t.charCodeAt(a-1)===u;)a--;const m=a-i;let P=0;for(;P<l.length&&l.charCodeAt(P)===u;)P++;let I=l.length;for(;I-1>P&&l.charCodeAt(I-1)===u;)I--;const D=I-P,M=m<D?m:D;let L=-1,N=0;for(;N<M;N++){const re=t.charCodeAt(i+N);if(re!==l.charCodeAt(P+N))break;re===u&&(L=N)}if(N!==M){if(L===-1)return n}else{if(D>M){if(l.charCodeAt(P+N)===u)return n.slice(P+N+1);if(N===2)return n.slice(P+N)}m>M&&(t.charCodeAt(i+N)===u?L=N:N===2&&(L=3)),L===-1&&(L=0)}let B="";for(N=i+L+1;N<=a;++N)(N===a||t.charCodeAt(N)===u)&&(B+=B.length===0?"..":"\\..");return P+=L,B.length>0?`${B}${n.slice(P,I)}`:(n.charCodeAt(P)===u&&++P,n.slice(P,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.$9b.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===u){if(l.charCodeAt(1)===u){const s=l.charCodeAt(2);if(s!==d&&s!==S)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(c(l.charCodeAt(0))&&l.charCodeAt(1)===$&&l.charCodeAt(2)===u)return`\\\\?\\${l}`;return t},dirname(t){v(t,"path");const l=t.length;if(l===0)return".";let s=-1,n=0;const i=t.charCodeAt(0);if(l===1)return o(i)?t:".";if(o(i)){if(s=n=1,o(t.charCodeAt(1))){let P=2,I=P;for(;P<l&&!o(t.charCodeAt(P));)P++;if(P<l&&P!==I){for(I=P;P<l&&o(t.charCodeAt(P));)P++;if(P<l&&P!==I){for(I=P;P<l&&!o(t.charCodeAt(P));)P++;if(P===l)return t;P!==I&&(s=n=P+1)}}}}else c(i)&&t.charCodeAt(1)===$&&(s=l>2&&o(t.charCodeAt(2))?3:2,n=s);let a=-1,m=!0;for(let P=l-1;P>=n;--P)if(o(t.charCodeAt(P))){if(!m){a=P;break}}else m=!1;if(a===-1){if(s===-1)return".";a=s}return t.slice(0,a)},basename(t,l){l!==void 0&&v(l,"ext"),v(t,"path");let s=0,n=-1,i=!0,a;if(t.length>=2&&c(t.charCodeAt(0))&&t.charCodeAt(1)===$&&(s=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let m=l.length-1,P=-1;for(a=t.length-1;a>=s;--a){const I=t.charCodeAt(a);if(o(I)){if(!i){s=a+1;break}}else P===-1&&(i=!1,P=a+1),m>=0&&(I===l.charCodeAt(m)?--m===-1&&(n=a):(m=-1,n=P))}return s===n?n=P:n===-1&&(n=t.length),t.slice(s,n)}for(a=t.length-1;a>=s;--a)if(o(t.charCodeAt(a))){if(!i){s=a+1;break}}else n===-1&&(i=!1,n=a+1);return n===-1?"":t.slice(s,n)},extname(t){v(t,"path");let l=0,s=-1,n=0,i=-1,a=!0,m=0;t.length>=2&&t.charCodeAt(1)===$&&c(t.charCodeAt(0))&&(l=n=2);for(let P=t.length-1;P>=l;--P){const I=t.charCodeAt(P);if(o(I)){if(!a){n=P+1;break}continue}i===-1&&(a=!1,i=P+1),I===S?s===-1?s=P:m!==1&&(m=1):s!==-1&&(m=-1)}return s===-1||i===-1||m===0||m===1&&s===i-1&&s===n+1?"":t.slice(s,i)},format:k.bind(null,"\\"),parse(t){v(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const s=t.length;let n=0,i=t.charCodeAt(0);if(s===1)return o(i)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(o(i)){if(n=1,o(t.charCodeAt(1))){let L=2,N=L;for(;L<s&&!o(t.charCodeAt(L));)L++;if(L<s&&L!==N){for(N=L;L<s&&o(t.charCodeAt(L));)L++;if(L<s&&L!==N){for(N=L;L<s&&!o(t.charCodeAt(L));)L++;L===s?n=L:L!==N&&(n=L+1)}}}}else if(c(i)&&t.charCodeAt(1)===$){if(s<=2)return l.root=l.dir=t,l;if(n=2,o(t.charCodeAt(2))){if(s===3)return l.root=l.dir=t,l;n=3}}n>0&&(l.root=t.slice(0,n));let a=-1,m=n,P=-1,I=!0,D=t.length-1,M=0;for(;D>=n;--D){if(i=t.charCodeAt(D),o(i)){if(!I){m=D+1;break}continue}P===-1&&(I=!1,P=D+1),i===S?a===-1?a=D:M!==1&&(M=1):a!==-1&&(M=-1)}return P!==-1&&(a===-1||M===0||M===1&&a===P-1&&a===m+1?l.base=l.name=t.slice(m,P):(l.name=t.slice(m,a),l.base=t.slice(m,P),l.ext=t.slice(a,P))),m>0&&m!==n?l.dir=t.slice(0,m-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const w=(()=>{if(y){const t=/\\/g;return()=>{const l=E.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>E.cwd()})();e.$0b={resolve(...t){let l="",s=!1;for(let n=t.length-1;n>=-1&&!s;n--){const i=n>=0?t[n]:w();v(i,"path"),i.length!==0&&(l=`${i}/${l}`,s=i.charCodeAt(0)===f)}return l=b(l,!s,"/",g),s?`/${l}`:l.length>0?l:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f,s=t.charCodeAt(t.length-1)===f;return t=b(t,!l,"/",g),t.length===0?l?"/":s?"./":".":(s&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let l;for(let s=0;s<t.length;++s){const n=t[s];v(n,"path"),n.length>0&&(l===void 0?l=n:l+=`/${n}`)}return l===void 0?".":e.$0b.normalize(l)},relative(t,l){if(v(t,"from"),v(l,"to"),t===l||(t=e.$0b.resolve(t),l=e.$0b.resolve(l),t===l))return"";const s=1,n=t.length,i=n-s,a=1,m=l.length-a,P=i<m?i:m;let I=-1,D=0;for(;D<P;D++){const L=t.charCodeAt(s+D);if(L!==l.charCodeAt(a+D))break;L===f&&(I=D)}if(D===P)if(m>P){if(l.charCodeAt(a+D)===f)return l.slice(a+D+1);if(D===0)return l.slice(a+D)}else i>P&&(t.charCodeAt(s+D)===f?I=D:D===0&&(I=0));let M="";for(D=s+I+1;D<=n;++D)(D===n||t.charCodeAt(D)===f)&&(M+=M.length===0?"..":"/..");return`${M}${l.slice(a+I)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f;let s=-1,n=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===f){if(!n){s=i;break}}else n=!1;return s===-1?l?"/":".":l&&s===1?"//":t.slice(0,s)},basename(t,l){l!==void 0&&v(l,"ext"),v(t,"path");let s=0,n=-1,i=!0,a;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let m=l.length-1,P=-1;for(a=t.length-1;a>=0;--a){const I=t.charCodeAt(a);if(I===f){if(!i){s=a+1;break}}else P===-1&&(i=!1,P=a+1),m>=0&&(I===l.charCodeAt(m)?--m===-1&&(n=a):(m=-1,n=P))}return s===n?n=P:n===-1&&(n=t.length),t.slice(s,n)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===f){if(!i){s=a+1;break}}else n===-1&&(i=!1,n=a+1);return n===-1?"":t.slice(s,n)},extname(t){v(t,"path");let l=-1,s=0,n=-1,i=!0,a=0;for(let m=t.length-1;m>=0;--m){const P=t.charCodeAt(m);if(P===f){if(!i){s=m+1;break}continue}n===-1&&(i=!1,n=m+1),P===S?l===-1?l=m:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||n===-1||a===0||a===1&&l===n-1&&l===s+1?"":t.slice(l,n)},format:k.bind(null,"/"),parse(t){v(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const s=t.charCodeAt(0)===f;let n;s?(l.root="/",n=1):n=0;let i=-1,a=0,m=-1,P=!0,I=t.length-1,D=0;for(;I>=n;--I){const M=t.charCodeAt(I);if(M===f){if(!P){a=I+1;break}continue}m===-1&&(P=!1,m=I+1),M===S?i===-1?i=I:D!==1&&(D=1):i!==-1&&(D=-1)}if(m!==-1){const M=a===0&&s?1:a;i===-1||D===0||D===1&&i===m-1&&i===a+1?l.base=l.name=t.slice(M,m):(l.name=t.slice(M,i),l.base=t.slice(M,m),l.ext=t.slice(i,m))}return a>0?l.dir=t.slice(0,a-1):s&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.$0b.win32=e.$9b.win32=e.$9b,e.$0b.posix=e.$9b.posix=e.$0b,e.$$b=y?e.$9b.normalize:e.$0b.normalize,e.$_b=y?e.$9b.isAbsolute:e.$0b.isAbsolute,e.$ac=y?e.$9b.join:e.$0b.join,e.$bc=y?e.$9b.resolve:e.$0b.resolve,e.$cc=y?e.$9b.relative:e.$0b.relative,e.$dc=y?e.$9b.dirname:e.$0b.dirname,e.$ec=y?e.$9b.basename:e.$0b.basename,e.$fc=y?e.$9b.extname:e.$0b.extname,e.$gc=y?e.$9b.format:e.$0b.format,e.$hc=y?e.$9b.parse:e.$0b.parse,e.$ic=y?e.$9b.toNamespacedPath:e.$0b.toNamespacedPath,e.sep=y?e.$9b.sep:e.$0b.sep,e.$kc=y?e.$9b.delimiter:e.$0b.delimiter}),define(te[32],ie([0,1,9,4,25,10]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=void 0;function R(a){return a===47||a===92}e.$De=R;function S(a){return a.replace(/[\\/]/g,E.$0b.sep)}e.$Ee=S;function f(a){return a.indexOf("/")===-1&&(a=S(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$Fe=f;function u(a,m=E.$0b.sep){if(!a)return"";const P=a.length,I=a.charCodeAt(0);if(R(I)){if(R(a.charCodeAt(1))&&!R(a.charCodeAt(2))){let M=3;const L=M;for(;M<P&&!R(a.charCodeAt(M));M++);if(L!==M&&!R(a.charCodeAt(M+1))){for(M+=1;M<P;M++)if(R(a.charCodeAt(M)))return a.slice(0,M+1).replace(/[\\/]/g,m)}}return m}else if(g(I)&&a.charCodeAt(1)===58)return R(a.charCodeAt(2))?a.slice(0,2)+m:a.slice(0,2);let D=a.indexOf("://");if(D!==-1){for(D+=3;D<P;D++)if(R(a.charCodeAt(D)))return a.slice(0,D+1)}return""}e.$Ge=u;function $(a){if(!C.$i||!a||a.length<5)return!1;let m=a.charCodeAt(0);if(m!==92||(m=a.charCodeAt(1),m!==92))return!1;let P=2;const I=P;for(;P<a.length&&(m=a.charCodeAt(P),m!==92);P++);return!(I===P||(m=a.charCodeAt(P+1),isNaN(m)||m===92))}e.$He=$;const d=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(a,m=C.$i){const P=m?d:p;return!(!a||a.length===0||/^\s+$/.test(a)||(P.lastIndex=0,P.test(a))||m&&h.test(a)||a==="."||a===".."||m&&a[a.length-1]==="."||m&&a.length!==a.trim().length||a.length>255)}e.$Ie=v;function y(a,m,P){const I=a===m;return!P||I?I:!a||!m?!1:(0,r.$Md)(a,m)}e.$Je=y;function o(a,m,P,I=E.sep){if(a===m)return!0;if(!a||!m||m.length>a.length)return!1;if(P){if(!(0,r.$Nd)(a,m))return!1;if(m.length===a.length)return!0;let M=m.length;return m.charAt(m.length-1)===I&&M--,a.charAt(M)===I}return m.charAt(m.length-1)!==I&&(m+=I),a.indexOf(m)===0}e.$Ke=o;function g(a){return a>=65&&a<=90||a>=97&&a<=122}e.$Le=g;function c(a,m){return C.$i&&a.endsWith(":")&&(a+=E.sep),(0,E.$_b)(a)||(a=(0,E.$ac)(m,a)),a=(0,E.$$b)(a),C.$i?(a=(0,r.$td)(a,E.sep),a.endsWith(":")&&(a+=E.sep)):(a=(0,r.$td)(a,E.sep),a||(a=E.sep)),a}e.$Me=c;function b(a){const m=(0,E.$$b)(a);return C.$i?a.length>3?!1:k(m)&&(a.length===2||m.charCodeAt(2)===92):m===E.$0b.sep}e.$Ne=b;function k(a,m=C.$i){return m?g(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$Oe=k;function w(a,m=C.$i){return k(a,m)?a[0]:void 0}e.$Pe=w;function t(a,m,P){return m.length>a.length?-1:a===m?0:(P&&(a=a.toLowerCase(),m=m.toLowerCase()),a.indexOf(m))}e.$Qe=t;function l(a){const m=a.split(":");let P,I,D;for(const M of m){const L=Number(M);(0,O.$ne)(L)?I===void 0?I=L:D===void 0&&(D=L):P=P?[P,M].join(":"):M}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:I!==void 0?I:void 0,column:D!==void 0?D:I!==void 0?1:void 0}}e.$Re=l;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(a,m,P=8){let I="";for(let M=0;M<P;M++){let L;M===0&&C.$i&&!m&&(P===3||P===4)?L=n:L=s,I+=L.charAt(Math.floor(Math.random()*L.length))}let D;return m?D=`${m}-${I}`:D=I,a?(0,E.$ac)(a,D):D}e.$Se=i}),define(te[73],ie([0,1,4]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.TerminateResponseCode=e.Source=void 0;var C;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(C||(e.Source=C={}));var r;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function O(S,...f){const u=f.reduce((p,h)=>(p[h]=!0,p),{}),$=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(p=>!u[p]).forEach(p=>{for(let h=0;h<$.length;h++)if(p.search($[h])!==-1){delete S[p];break}})}e.$fl=O;function R(S){S&&(delete S.DEBUG,E.$j&&delete S.DYLD_LIBRARY_PATH,E.$k&&delete S.LD_PRELOAD)}e.$gl=R}),define(te[7],ie([0,1,9,4]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ve=e.$Ue=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,O=/^\//,R=/^\/\//;function S(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!r.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!O.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(n,i){return!n&&!i?"file":n}function u(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==d&&(i=d+i):i=d;break}return i}const $="",d="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,a,m,P,I,D=!1){typeof i=="object"?(this.scheme=i.scheme||$,this.authority=i.authority||$,this.path=i.path||$,this.query=i.query||$,this.fragment=i.fragment||$):(this.scheme=f(i,D),this.authority=a||$,this.path=u(this.scheme,m||$),this.query=P||$,this.fragment=I||$,S(this,D))}get fsPath(){return k(this,!1)}with(i){if(!i)return this;let{scheme:a,authority:m,path:P,query:I,fragment:D}=i;return a===void 0?a=this.scheme:a===null&&(a=$),m===void 0?m=this.authority:m===null&&(m=$),P===void 0?P=this.path:P===null&&(P=$),I===void 0?I=this.query:I===null&&(I=$),D===void 0?D=this.fragment:D===null&&(D=$),a===this.scheme&&m===this.authority&&P===this.path&&I===this.query&&D===this.fragment?this:new o(a,m,P,I,D)}static parse(i,a=!1){const m=p.exec(i);return m?new o(m[2]||$,s(m[4]||$),s(m[5]||$),s(m[7]||$),s(m[9]||$),a):new o($,$,$,$,$)}static file(i){let a=$;if(C.$i&&(i=i.replace(/\\/g,d)),i[0]===d&&i[1]===d){const m=i.indexOf(d,2);m===-1?(a=i.substring(2),i=d):(a=i.substring(2,m),i=i.substring(m)||d)}return new o("file",a,i,$,$)}static from(i,a){return new o(i.scheme,i.authority,i.path,i.query,i.fragment,a)}static joinPath(i,...a){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return C.$i&&i.scheme==="file"?m=h.file(E.$9b.join(k(i,!0),...a)).path:m=E.$0b.join(i.path,...a),i.with({path:m})}toString(i=!1){return w(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const a=new o(i);return a._formatted=i.external??null,a._fsPath=i._sep===y?i.fsPath??null:null,a}}else return i}}e.URI=h;function v(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$Ue=v;const y=C.$i?1:void 0;class o extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(i=!1){return i?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=y),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function c(n,i,a){let m,P=-1;for(let I=0;I<n.length;I++){const D=n.charCodeAt(I);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||i&&D===47||a&&D===91||a&&D===93||a&&D===58)P!==-1&&(m+=encodeURIComponent(n.substring(P,I)),P=-1),m!==void 0&&(m+=n.charAt(I));else{m===void 0&&(m=n.substr(0,I));const M=g[D];M!==void 0?(P!==-1&&(m+=encodeURIComponent(n.substring(P,I)),P=-1),m+=M):P===-1&&(P=I)}}return P!==-1&&(m+=encodeURIComponent(n.substring(P))),m!==void 0?m:n}function b(n){let i;for(let a=0;a<n.length;a++){const m=n.charCodeAt(a);m===35||m===63?(i===void 0&&(i=n.substr(0,a)),i+=g[m]):i!==void 0&&(i+=n[a])}return i!==void 0?i:n}function k(n,i){let a;return n.authority&&n.path.length>1&&n.scheme==="file"?a=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?a=n.path.substr(1):a=n.path[1].toLowerCase()+n.path.substr(2):a=n.path,C.$i&&(a=a.replace(/\//g,"\\")),a}e.$Ve=k;function w(n,i){const a=i?b:c;let m="",{scheme:P,authority:I,path:D,query:M,fragment:L}=n;if(P&&(m+=P,m+=":"),(I||P==="file")&&(m+=d,m+=d),I){let N=I.indexOf("@");if(N!==-1){const B=I.substr(0,N);I=I.substr(N+1),N=B.lastIndexOf(":"),N===-1?m+=a(B,!1,!1):(m+=a(B.substr(0,N),!1,!1),m+=":",m+=a(B.substr(N+1),!1,!0)),m+="@"}I=I.toLowerCase(),N=I.lastIndexOf(":"),N===-1?m+=a(I,!1,!0):(m+=a(I.substr(0,N),!1,!0),m+=I.substr(N))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const N=D.charCodeAt(1);N>=65&&N<=90&&(D=`/${String.fromCharCode(N+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const N=D.charCodeAt(0);N>=65&&N<=90&&(D=`${String.fromCharCode(N+32)}:${D.substr(2)}`)}m+=a(D,!0,!1)}return M&&(m+="?",m+=a(M,!1,!1)),L&&(m+="#",m+=i?L:c(L,!1,!1)),m}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(l)?n.replace(l,i=>t(i)):n}}),define(te[153],ie([0,1,7]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Ep=e.$Dp=e.$Cp=void 0;function C(u){const $=u;return $&&typeof $.type=="string"&&typeof $.severity=="string"}e.$Cp=C;function r(u){const $=[];let d;try{const p=JSON.parse(u.arguments),h=p[p.length-1];h&&h.__$stack&&(p.pop(),d=h.__$stack),$.push(...p)}catch{$.push("Unable to log remote console arguments",u.arguments)}return{args:$,stack:d}}e.$Dp=r;function O(u){if(typeof u!="string")return O(r(u).stack);const $=u;if($){const d=R($),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(p&&p.length===4)return{uri:E.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Ep=O;function R(u){if(!u)return u;const $=u.indexOf(`
`);return $===-1?u:u.substring(0,$)}function S(u,$){const{args:d,stack:p}=r(u),h=typeof d[0]=="string"&&d.length===1;let v=R(p);v&&(v=`(${v.trim()})`);let y=[];if(typeof d[0]=="string"?v&&h?y=[`%c[${$}] %c${d[0]} %c${v}`,f("blue"),f(""),f("grey")]:y=[`%c[${$}] %c${d[0]}`,f("blue"),f(""),...d.slice(1)]:y=[`%c[${$}]%`,f("blue"),...d],v&&!h&&y.push(v),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,y)}e.log=S;function f(u){return`color: ${u}`}}),define(te[74],ie([0,1,17,25,7]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=e.$Xg=e.$Wg=void 0;function O(u){return JSON.stringify(u,S)}e.$Wg=O;function R(u){let $=JSON.parse(u);return $=f($),$}e.$Xg=R;function S(u,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:(0,C.$zd)($)}:$}function f(u,$=0){if(!u||$>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return r.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof E.$Jb||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let d=0;d<u.length;++d)u[d]=f(u[d],$+1);else for(const d in u)Object.hasOwnProperty.call(u,d)&&(u[d]=f(u[d],$+1))}return u}e.$Yg=f}),define(te[15],ie([0,1,13,4,7]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.Schemas=void 0;var O;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.$We="vscode-tkn",e.$Xe="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($){this.f=`${$}/${O.vscodeRemoteResource}`}set($,d,p){this.a[$]=d,this.b[$]=p}setConnectionToken($,d){this.c[$]=d}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(o){return E.$Y(o),$}const d=$.authority;let p=this.a[d];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const h=this.b[d],v=this.c[d];let y=`path=${encodeURIComponent($.path)}`;return typeof v=="string"&&(y+=`&${e.$Xe}=${encodeURIComponent(v)}`),r.URI.from({scheme:C.$o?this.d:O.vscodeRemoteResource,authority:`${p}:${h}`,path:this.f,query:y})}}e.$Ye=new R,e.$Ze="vs/../../extensions",e.$1e="vs/../../node_modules",e.$2e="vs/../../node_modules.asar",e.$3e="vs/../../node_modules.asar.unpacked";class S{static{this.a="vscode-app"}asBrowserUri($){const d=this.b($,V);return this.uriToBrowserUri(d)}uriToBrowserUri($){return $.scheme===O.vscodeRemote?e.$Ye.rewrite($):$.scheme===O.file&&(C.$m||C.$p&&C.$g.origin===`${O.vscodeFileResource}://${S.a}`)?$.with({scheme:O.vscodeFileResource,authority:$.authority||S.a,query:null,fragment:null}):$}asFileUri($){const d=this.b($,V);return this.uriToFileUri(d)}uriToFileUri($){return $.scheme===O.vscodeFileResource?$.with({scheme:O.file,authority:$.authority!==S.a?$.authority:null,query:null,fragment:null}):$}b($,d){return r.URI.isUri($)?$:r.URI.parse(d.toUrl($))}}e.$4e=new S;var f;(function(u){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze($.get("3"));const d="vscode-coi";function p(v){let y;typeof v=="string"?y=new URL(v).searchParams:v instanceof URL?y=v.searchParams:r.URI.isUri(v)&&(y=new URL(v.toString(!0)).searchParams);const o=y?.get(d);if(o)return $.get(o)}u.getHeadersFromQuery=p;function h(v,y,o){if(!globalThis.crossOriginIsolated)return;const g=y&&o?"3":o?"2":"1";v instanceof URLSearchParams?v.set(d,g):v[d]=g}u.addSearchParam=h})(f||(e.COI=f={}))}),define(te[19],ie([0,1,32,15,9,4,25,7]),function(V,e,E,C,r,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.DataUri=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=void 0;function f(h){return(0,S.$Ve)(h,!0)}e.$Xf=f;class u{constructor(v){this.a=v}compare(v,y,o=!1){return v===y?0:(0,R.$Fd)(this.getComparisonKey(v,o),this.getComparisonKey(y,o))}isEqual(v,y,o=!1){return v===y?!0:!v||!y?!1:this.getComparisonKey(v,o)===this.getComparisonKey(y,o)}getComparisonKey(v,y=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,y,o=!1){if(v.scheme===y.scheme){if(v.scheme===C.Schemas.file)return E.$Ke(f(v),f(y),this.a(v))&&v.query===y.query&&(o||v.fragment===y.fragment);if((0,e.$cg)(v.authority,y.authority))return E.$Ke(v.path,y.path,this.a(v),"/")&&v.query===y.query&&(o||v.fragment===y.fragment)}return!1}joinPath(v,...y){return S.URI.joinPath(v,...y)}basenameOrAuthority(v){return(0,e.$7f)(v)||v.authority}basename(v){return r.$0b.basename(v.path)}extname(v){return r.$0b.extname(v.path)}dirname(v){if(v.path.length===0)return v;let y;return v.scheme===C.Schemas.file?y=S.URI.file(r.$dc(f(v))).path:(y=r.$0b.dirname(v.path),v.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),y="/")),v.with({path:y})}normalizePath(v){if(!v.path.length)return v;let y;return v.scheme===C.Schemas.file?y=S.URI.file(r.$$b(f(v))).path:y=r.$0b.normalize(v.path),v.with({path:y})}relativePath(v,y){if(v.scheme!==y.scheme||!(0,e.$cg)(v.authority,y.authority))return;if(v.scheme===C.Schemas.file){const c=r.$cc(f(v),f(y));return O.$i?E.$Ee(c):c}let o=v.path||"/";const g=y.path||"/";if(this.a(v)){let c=0;for(const b=Math.min(o.length,g.length);c<b&&!(o.charCodeAt(c)!==g.charCodeAt(c)&&o.charAt(c).toLowerCase()!==g.charAt(c).toLowerCase());c++);o=g.substr(0,c)+o.substr(c)}return r.$0b.relative(o,g)}resolvePath(v,y){if(v.scheme===C.Schemas.file){const o=S.URI.file(r.$bc(f(v),y));return v.with({authority:o.authority,path:o.path})}return y=E.$Fe(y),v.with({path:r.$0b.resolve(v.path,y)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,y){return v===y||v!==void 0&&y!==void 0&&(0,R.$Md)(v,y)}hasTrailingPathSeparator(v,y=r.sep){if(v.scheme===C.Schemas.file){const o=f(v);return o.length>E.$Ge(o).length&&o[o.length-1]===y}else{const o=v.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,y=r.sep){return(0,e.$dg)(v,y)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,y=r.sep){let o=!1;if(v.scheme===C.Schemas.file){const g=f(v);o=g!==void 0&&g.length===E.$Ge(g).length&&g[g.length-1]===y}else{y="/";const g=v.path;o=g.length===1&&g.charCodeAt(g.length-1)===47}return!o&&!(0,e.$dg)(v,y)?v.with({path:v.path+"/"}):v}}e.$Yf=u,e.$Zf=new u(()=>!1),e.$1f=new u(h=>h.scheme===C.Schemas.file?!O.$k:!0),e.$2f=new u(h=>!0),e.$3f=e.$Zf.isEqual.bind(e.$Zf),e.$4f=e.$Zf.isEqualOrParent.bind(e.$Zf),e.$5f=e.$Zf.getComparisonKey.bind(e.$Zf),e.$6f=e.$Zf.basenameOrAuthority.bind(e.$Zf),e.$7f=e.$Zf.basename.bind(e.$Zf),e.$8f=e.$Zf.extname.bind(e.$Zf),e.$9f=e.$Zf.dirname.bind(e.$Zf),e.$0f=e.$Zf.joinPath.bind(e.$Zf),e.$$f=e.$Zf.normalizePath.bind(e.$Zf),e.$_f=e.$Zf.relativePath.bind(e.$Zf),e.$ag=e.$Zf.resolvePath.bind(e.$Zf),e.$bg=e.$Zf.isAbsolutePath.bind(e.$Zf),e.$cg=e.$Zf.isEqualAuthority.bind(e.$Zf),e.$dg=e.$Zf.hasTrailingPathSeparator.bind(e.$Zf),e.$eg=e.$Zf.removeTrailingPathSeparator.bind(e.$Zf),e.$fg=e.$Zf.addTrailingPathSeparator.bind(e.$Zf);function $(h,v){const y=[];for(let o=0;o<h.length;o++){const g=v(h[o]);h.some((c,b)=>b===o?!1:(0,e.$4f)(g,v(c)))||y.push(h[o])}return y}e.$gg=$;var d;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function v(y){const o=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(b=>{const[k,w]=b.split(":");k&&w&&o.set(k,w)});const c=y.path.substring(0,y.path.indexOf(";"));return c&&o.set(h.META_DATA_MIME,c),o}h.parseMetaData=v})(d||(e.DataUri=d={}));function p(h,v,y){if(v){let o=h.path;return o&&o[0]!==r.$0b.sep&&(o=r.$0b.sep+o),h.with({scheme:y,authority:v,path:o})}return h.with({scheme:y})}e.$hg=p}),define(te[8],ie([0,1,22,13,3,2,19,4,141]),function(V,e,E,C,r,O,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.$Rg=e.$Qg=e.Promises=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function u(j){return!!j&&typeof j.then=="function"}e.$ig=u;function $(j){const A=new E.$ed,F=j(A.token),q=new Promise((G,Z)=>{const z=A.token.onCancellationRequested(()=>{z.dispose(),A.dispose(),Z(new C.$3)});Promise.resolve(F).then(Y=>{z.dispose(),A.dispose(),G(Y)},Y=>{z.dispose(),A.dispose(),Z(Y)})});return new class{cancel(){A.cancel()}then(G,Z){return q.then(G,Z)}catch(G){return this.then(void 0,G)}finally(G){return q.finally(G)}}}e.$jg=$;function d(j,A,F){return new Promise((q,G)=>{const Z=A.onCancellationRequested(()=>{Z.dispose(),q(F)});j.then(q,G).finally(()=>Z.dispose())})}e.$kg=d;function p(j,A){return new Promise((F,q)=>{const G=A.onCancellationRequested(()=>{G.dispose(),q(new C.$3)});j.then(F,q).finally(()=>G.dispose())})}e.$lg=p;async function h(j){let A=-1;const F=j.map((q,G)=>q.then(Z=>(A=G,Z)));try{return await Promise.race(F)}finally{j.forEach((q,G)=>{G!==A&&q.cancel()})}}e.$mg=h;function v(j,A,F){let q;const G=setTimeout(()=>{q?.(void 0),F?.()},A);return Promise.race([j.finally(()=>clearTimeout(G)),new Promise(Z=>q=Z)])}e.$ng=v;function y(j){return new Promise((A,F)=>{const q=j();u(q)?q.then(A,F):A(q)})}e.$og=y;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(A){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=A,!this.b){const F=()=>{if(this.b=null,this.f)return;const q=this.queue(this.d);return this.d=null,q};this.b=new Promise(q=>{this.a.then(F,F).then(q)})}return new Promise((F,q)=>{this.b.then(F,q)})}return this.a=A(),new Promise((F,q)=>{this.a.then(G=>{this.a=null,F(G)},G=>{this.a=null,q(G)})})}dispose(){this.f=!0}}e.$pg=o;class g{constructor(){this.a=Promise.resolve(null)}queue(A){return this.a=this.a.then(()=>A(),()=>A())}}e.$qg=g;class c{constructor(){this.a=new Map}queue(A,F){const G=(this.a.get(A)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(A)===G&&this.a.delete(A)});return this.a.set(A,G),G}}e.$rg=c;const b=(j,A)=>{let F=!0;const q=setTimeout(()=>{F=!1,A()},j);return{isTriggered:()=>F,dispose:()=>{clearTimeout(q),F=!1}}},k=j=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,j())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};class w{constructor(A){this.defaultDelay=A,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(A,F=this.defaultDelay){this.g=A,this.h(),this.b||(this.b=new Promise((G,Z)=>{this.d=G,this.f=Z}).then(()=>{if(this.b=null,this.d=null,this.g){const G=this.g;return this.g=null,G()}}));const q=()=>{this.a=null,this.d?.(null)};return this.a=F===f.$5c?k(q):b(F,q),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$sg=w;class t{constructor(A){this.a=new w(A),this.b=new o}trigger(A,F){return this.a.trigger(()=>this.b.queue(A),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$tg=t;class l{constructor(){this.a=!1,this.b=new Promise((A,F)=>{this.d=A})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ug=l;class s extends l{constructor(A){super(),this.f=setTimeout(()=>this.open(),A)}open(){clearTimeout(this.f),super.open()}}e.$vg=s;function n(j,A){return A?new Promise((F,q)=>{const G=setTimeout(()=>{Z.dispose(),F()},j),Z=A.onCancellationRequested(()=>{clearTimeout(G),Z.dispose(),q(new C.$3)})}):$(F=>n(j,F))}e.$wg=n;function i(j,A=0){const F=setTimeout(j,A);return(0,O.$jb)(()=>clearTimeout(F))}e.$xg=i;function a(j){const A=[];let F=0;const q=j.length;function G(){return F<q?j[F++]():null}function Z(z){z!=null&&A.push(z);const Y=G();return Y?Y.then(Z):Promise.resolve(A)}return Promise.resolve(null).then(Z)}e.$yg=a;function m(j,A=q=>!!q,F=null){let q=0;const G=j.length,Z=()=>{if(q>=G)return Promise.resolve(F);const z=j[q++];return Promise.resolve(z()).then(x=>A(x)?Promise.resolve(x):Z())};return Z()}e.$zg=m;function P(j,A=q=>!!q,F=null){if(j.length===0)return Promise.resolve(F);let q=j.length;const G=()=>{q=-1;for(const Z of j)Z.cancel?.()};return new Promise((Z,z)=>{for(const Y of j)Y.then(x=>{--q>=0&&A(x)?(G(),Z(x)):q===0&&Z(F)}).catch(x=>{--q>=0&&(G(),z(x))})})}e.$Ag=P;class I{constructor(A){this.a=0,this.d=A,this.f=[],this.b=0,this.g=new r.$8c}get onDrained(){return this.g.event}get size(){return this.a}queue(A){return this.a++,new Promise((F,q)=>{this.f.push({factory:A,c:F,e:q}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const A=this.f.shift();this.b++;const F=A.factory();F.then(A.c,A.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Bg=I;class D extends I{constructor(){super(1)}}e.$Cg=D;class M{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const A=new T;return this.b.add(A),A.p}d(){for(const[,A]of this.a)if(A.size>0)return!1;return!0}queueFor(A,F=R.$Zf){const q=F.getComparisonKey(A);let G=this.a.get(q);return G||(G=new D,r.Event.once(G.onDrained)(()=>{G?.dispose(),this.a.delete(q),this.f()}),this.a.set(q,G)),G}f(){this.d()&&this.g()}g(){for(const A of this.b)A.complete();this.b.clear()}dispose(){for(const[,A]of this.a)A.dispose();this.a.clear(),this.g()}}e.$Dg=M;class L{constructor(A,F){this.a=-1,typeof A=="function"&&typeof F=="number"&&this.setIfNotSet(A,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(A,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,A()},F)}setIfNotSet(A,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,A()},F))}}e.$Eg=L;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(A,F){this.cancel(),this.a=setInterval(()=>{A()},F)}}e.$Fg=N;class B{constructor(A,F){this.b=-1,this.a=A,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(A=this.d){this.cancel(),this.b=setTimeout(this.f,A)}get delay(){return this.d}set delay(A){this.d=A}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Gg=B;class re{constructor(A,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=A,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(A=this.b){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(A/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Hg=re;class ne extends B{constructor(A,F){super(A,F),this.j=[]}work(A){this.j.push(A),this.isScheduled()||this.schedule()}h(){const A=this.j;this.j=[],this.a?.(A)}dispose(){this.j=[],super.dispose()}}e.$Ig=ne;class ue extends O.$lb{constructor(A,F){super(),this.g=A,this.h=F,this.a=[],this.b=this.B(new O.$mb),this.f=!1}get pending(){return this.a.length}work(A){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+A.length>this.g.maxBufferedWork)return!1}else if(this.pending+A.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of A)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new B(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Jg=ue,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Kg=j=>{(0,S.$A)(()=>{if(A)return;const F=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.$Kg=(j,A)=>{const F=requestIdleCallback(j,typeof A=="number"?{timeout:A}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(F))}}}}();class se{constructor(A){this.d=!1,this.a=()=>{try{this.f=A()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.$Kg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Lg=se;async function le(j,A,F){let q;for(let G=0;G<F;G++)try{return await j()}catch(Z){q=Z,await n(A)}throw q}e.$Mg=le;class J{hasPending(A){return this.a?typeof A=="number"?this.a.taskId===A:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(A,F,q){return this.a={taskId:A,cancel:()=>q?.(),promise:F},F.then(()=>this.d(A),()=>this.d(A)),F}d(A){this.a&&A===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const A=this.b;this.b=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this.b)this.b.run=A;else{let F,q;const G=new Promise((Z,z)=>{F=Z,q=z});this.b={run:A,promise:G,promiseResolve:F,promiseReject:q}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ng=J;class K{constructor(A,F=()=>Date.now()){this.d=A,this.f=F,this.a=0,this.b=0}increment(){const A=this.f();return A-this.a>this.d&&(this.a=A,this.b=0),this.b++,this.b}}e.$Og=K;var U;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(U||(U={}));class T{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((A,F)=>{this.a=A,this.b=F})}complete(A){return new Promise(F=>{this.a(A),this.d={outcome:0,value:A},F()})}error(A){return new Promise(F=>{this.b(A),this.d={outcome:1,value:A},F()})}cancel(){return this.error(new C.$3)}}e.$Pg=T;var W;(function(j){async function A(q){let G;const Z=await Promise.all(q.map(z=>z.then(Y=>Y,Y=>{G||(G=Y)})));if(typeof G<"u")throw G;return Z}j.settled=A;function F(q){return new Promise(async(G,Z)=>{try{await q(G,Z)}catch(z){Z(z)}})}j.withAsyncBody=F})(W||(e.Promises=W={}));var H;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(H||(H={}));class Q{static fromArray(A){return new Q(F=>{F.emitMany(A)})}static fromPromise(A){return new Q(async F=>{F.emitMany(await A)})}static fromPromises(A){return new Q(async F=>{await Promise.all(A.map(async q=>F.emitOne(await q)))})}static merge(A){return new Q(async F=>{await Promise.all(A.map(async q=>{for await(const G of q)F.emitOne(G)}))})}static{this.EMPTY=Q.fromArray([])}constructor(A){this.a=0,this.b=[],this.d=null,this.f=new r.$8c,queueMicrotask(async()=>{const F={emitOne:q=>this.g(q),emitMany:q=>this.h(q),reject:q=>this.k(q)};try{await Promise.resolve(A(F)),this.j()}catch(q){this.k(q)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(A<this.b.length)return{done:!1,value:this.b[A++]};if(this.a===1)return{done:!0,value:void 0};await r.Event.toPromise(this.f.event)}while(!0)}}}static map(A,F){return new Q(async q=>{for await(const G of A)q.emitOne(F(G))})}map(A){return Q.map(this,A)}static filter(A,F){return new Q(async q=>{for await(const G of A)F(G)&&q.emitOne(G)})}filter(A){return Q.filter(this,A)}static coalesce(A){return Q.filter(A,F=>!!F)}coalesce(){return Q.coalesce(this)}static async toPromise(A){const F=[];for await(const q of A)F.push(q);return F}toPromise(){return Q.toPromise(this)}g(A){this.a===0&&(this.b.push(A),this.f.fire())}h(A){this.a===0&&(this.b=this.b.concat(A),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(A){this.a===0&&(this.a=2,this.d=A,this.f.fire())}}e.$Qg=Q;class ce extends Q{constructor(A,F){super(F),this.l=A}cancel(){this.l.cancel()}}e.$Rg=ce;function oe(j){const A=new E.$ed,F=j(A.token);return new ce(A,async q=>{const G=A.token.onCancellationRequested(()=>{G.dispose(),A.dispose(),q.reject(new C.$3)});try{for await(const Z of F){if(A.token.isCancellationRequested)return;q.emitOne(Z)}G.dispose(),A.dispose()}catch(Z){G.dispose(),A.dispose(),q.reject(Z)}})}e.$Sg=oe}),define(te[104],ie([0,1,24,8,32,35,9,4,25]),function(V,e,E,C,r,O,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=void 0;function u(){return Object.create(null)}e.$_i=u,e.$aj="**",e.$bj="/";const $="[/\\\\]",d="[^/\\\\]",p=/\//g;function h(K,U){switch(K){case 0:return"";case 1:return`${d}*?`;default:return`(?:${$}|${d}+${$}${U?`|${$}${d}+`:""})*?`}}function v(K,U){if(!K)return[];const T=[];let W=!1,H=!1,Q="";for(const ce of K){switch(ce){case U:if(!W&&!H){T.push(Q),Q="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":H=!0;break;case"]":H=!1;break}Q+=ce}return Q&&T.push(Q),T}e.$cj=v;function y(K){if(!K)return"";let U="";const T=v(K,e.$bj);if(T.every(W=>W===e.$aj))U=".*";else{let W=!1;T.forEach((H,Q)=>{if(H===e.$aj){if(W)return;U+=h(2,Q===T.length-1)}else{let ce=!1,oe="",j=!1,A="";for(const F of H){if(F!=="}"&&ce){oe+=F;continue}if(j&&(F!=="]"||!A)){let q;F==="-"?q=F:(F==="^"||F==="!")&&!A?q="^":F===e.$bj?q="":q=(0,f.$od)(F),A+=q;continue}switch(F){case"{":ce=!0;continue;case"[":j=!0;continue;case"}":{const G=`(?:${v(oe,",").map(Z=>y(Z)).join("|")})`;U+=G,ce=!1,oe="";break}case"]":{U+="["+A+"]",j=!1,A="";break}case"?":U+=d;continue;case"*":U+=h(1);continue;default:U+=(0,f.$od)(F)}}Q<T.length-1&&(T[Q+1]!==e.$aj||Q+2<T.length)&&(U+=$)}W=H===e.$aj})}return U}const o=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,k=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.$qi(1e4),l=function(){return!1},s=function(){return null};function n(K,U){if(!K)return s;let T;typeof K!="string"?T=K.pattern:T=K,T=T.trim();const W=`${T}_${!!U.trimForExclusions}`;let H=t.get(W);if(H)return i(H,K);let Q;return o.test(T)?H=m(T.substr(4),T):(Q=g.exec(a(T,U)))?H=P(Q[1],T):(U.trimForExclusions?b:c).test(T)?H=I(T,U):(Q=k.exec(a(T,U)))?H=D(Q[1].substr(1),T,!0):(Q=w.exec(a(T,U)))?H=D(Q[1],T,!1):H=M(T),t.set(W,H),i(H,K)}function i(K,U){if(typeof U=="string")return K;const T=function(W,H){return(0,r.$Ke)(W,U.base,!S.$k)?K((0,f.$sd)(W.substr(U.base.length),R.sep),H):null};return T.allBasenames=K.allBasenames,T.allPaths=K.allPaths,T.basenames=K.basenames,T.patterns=K.patterns,T}function a(K,U){return U.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function m(K,U){return function(T,W){return typeof T=="string"&&T.endsWith(K)?U:null}}function P(K,U){const T=`/${K}`,W=`\\${K}`,H=function(ce,oe){return typeof ce!="string"?null:oe?oe===K?U:null:ce===K||ce.endsWith(T)||ce.endsWith(W)?U:null},Q=[K];return H.basenames=Q,H.patterns=[U],H.allBasenames=Q,H}function I(K,U){const T=le(K.slice(1,-1).split(",").map(oe=>n(oe,U)).filter(oe=>oe!==s),K),W=T.length;if(!W)return s;if(W===1)return T[0];const H=function(oe,j){for(let A=0,F=T.length;A<F;A++)if(T[A](oe,j))return K;return null},Q=T.find(oe=>!!oe.allBasenames);Q&&(H.allBasenames=Q.allBasenames);const ce=T.reduce((oe,j)=>j.allPaths?oe.concat(j.allPaths):oe,[]);return ce.length&&(H.allPaths=ce),H}function D(K,U,T){const W=R.sep===R.$0b.sep,H=W?K:K.replace(p,R.sep),Q=R.sep+H,ce=R.$0b.sep+K;let oe;return T?oe=function(j,A){return typeof j=="string"&&(j===H||j.endsWith(Q)||!W&&(j===K||j.endsWith(ce)))?U:null}:oe=function(j,A){return typeof j=="string"&&(j===H||!W&&j===K)?U:null},oe.allPaths=[(T?"*/":"./")+K],oe}function M(K){try{const U=new RegExp(`^${y(K)}$`);return function(T){return U.lastIndex=0,typeof T=="string"&&U.test(T)?K:null}}catch{return s}}function L(K,U,T){return!K||typeof U!="string"?!1:N(K)(U,void 0,T)}e.$dj=L;function N(K,U={}){if(!K)return l;if(typeof K=="string"||B(K)){const T=n(K,U);if(T===s)return l;const W=function(H,Q){return!!T(H,Q)};return T.allBasenames&&(W.allBasenames=T.allBasenames),T.allPaths&&(W.allPaths=T.allPaths),W}return ue(K,U)}e.$ej=N;function B(K){const U=K;return U?typeof U.base=="string"&&typeof U.pattern=="string":!1}e.$fj=B;function re(K){return K.allBasenames||[]}e.$gj=re;function ne(K){return K.allPaths||[]}e.$hj=ne;function ue(K,U){const T=le(Object.getOwnPropertyNames(K).map(oe=>se(oe,K[oe],U)).filter(oe=>oe!==s)),W=T.length;if(!W)return s;if(!T.some(oe=>!!oe.requiresSiblings)){if(W===1)return T[0];const oe=function(F,q){let G;for(let Z=0,z=T.length;Z<z;Z++){const Y=T[Z](F,q);if(typeof Y=="string")return Y;(0,C.$ig)(Y)&&(G||(G=[]),G.push(Y))}return G?(async()=>{for(const Z of G){const z=await Z;if(typeof z=="string")return z}return null})():null},j=T.find(F=>!!F.allBasenames);j&&(oe.allBasenames=j.allBasenames);const A=T.reduce((F,q)=>q.allPaths?F.concat(q.allPaths):F,[]);return A.length&&(oe.allPaths=A),oe}const H=function(oe,j,A){let F,q;for(let G=0,Z=T.length;G<Z;G++){const z=T[G];z.requiresSiblings&&A&&(j||(j=(0,R.$ec)(oe)),F||(F=j.substr(0,j.length-(0,R.$fc)(oe).length)));const Y=z(oe,j,F,A);if(typeof Y=="string")return Y;(0,C.$ig)(Y)&&(q||(q=[]),q.push(Y))}return q?(async()=>{for(const G of q){const Z=await G;if(typeof Z=="string")return Z}return null})():null},Q=T.find(oe=>!!oe.allBasenames);Q&&(H.allBasenames=Q.allBasenames);const ce=T.reduce((oe,j)=>j.allPaths?oe.concat(j.allPaths):oe,[]);return ce.length&&(H.allPaths=ce),H}function se(K,U,T){if(U===!1)return s;const W=n(K,T);if(W===s)return s;if(typeof U=="boolean")return W;if(U){const H=U.when;if(typeof H=="string"){const Q=(ce,oe,j,A)=>{if(!A||!W(ce,oe))return null;const F=H.replace("$(basename)",()=>j),q=A(F);return(0,C.$ig)(q)?q.then(G=>G?K:null):q?K:null};return Q.requiresSiblings=!0,Q}}return W}function le(K,U){const T=K.filter(oe=>!!oe.basenames);if(T.length<2)return K;const W=T.reduce((oe,j)=>{const A=j.basenames;return A?oe.concat(A):oe},[]);let H;if(U){H=[];for(let oe=0,j=W.length;oe<j;oe++)H.push(U)}else H=T.reduce((oe,j)=>{const A=j.patterns;return A?oe.concat(A):oe},[]);const Q=function(oe,j){if(typeof oe!="string")return null;if(!j){let F;for(F=oe.length;F>0;F--){const q=oe.charCodeAt(F-1);if(q===47||q===92)break}j=oe.substr(F)}const A=W.indexOf(j);return A!==-1?H[A]:null};Q.basenames=W,Q.patterns=H,Q.allBasenames=W;const ce=K.filter(oe=>!oe.basenames);return ce.push(Q),ce}function J(K,U){return(0,E.$bf)(K,U,(T,W)=>typeof T=="string"&&typeof W=="string"?T===W:typeof T!="string"&&typeof W!="string"?T.base===W.base&&T.pattern===W.pattern:!1)}e.$ij=J}),define(te[46],ie([0,1,24,32,9,4,19,25]),function(V,e,E,C,r,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9z=e.$8z=e.$7z=e.$6z=e.$5z=e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=void 0;function f(n,i){const{os:a,tildify:m,relative:P}=i;if(P){const M=u(n,P,a);if(typeof M=="string")return M}let I=n.fsPath;if(a===1&&!O.$i?I=I.replace(/\//g,"\\"):a!==1&&O.$i&&(I=I.replace(/\\/g,"/")),a!==1&&m?.userHome){const M=m.userHome.fsPath;let L;n.scheme!==m.userHome.scheme&&n.path.startsWith(r.$0b.sep)?L=m.userHome.with({path:n.path}).fsPath:L=n.fsPath,I=p(L,M,a)}return(a===1?r.$9b:r.$0b).normalize($(I,a===1))}e.$Zz=f;function u(n,i,a){const m=a===1?r.$9b:r.$0b,P=a===3?R.$Zf:R.$2f,I=i.getWorkspace(),D=(0,E.$vf)(I.folders);if(!D)return;n.scheme!==D.uri.scheme&&n.path.startsWith(r.$0b.sep)&&(n=D.uri.with({path:n.path}));const M=i.getWorkspaceFolder(n);if(!M)return;let L;if(P.isEqual(M.uri,n)?L="":L=P.relativePath(M.uri,n)??"",L&&(L=m.normalize(L)),I.folders.length>1&&!i.noPrefix){const N=M.name?M.name:P.basenameOrAuthority(M.uri);L=L?`${N} \u2022 ${L}`:N}return L}function $(n,i=O.$i){return(0,C.$Oe)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.$1z=$;let d=Object.create(null);function p(n,i,a=O.OS){if(a===1||!n||!i)return n;let m=d.original===i?d.normalized:void 0;m||(m=i,O.$i&&(m=(0,C.$Ee)(m)),m=`${(0,S.$td)(m,r.$0b.sep)}${r.$0b.sep}`,d={original:i,normalized:m});let P=n;return O.$i&&(P=(0,C.$Ee)(P)),(a===3?P.startsWith(m):(0,S.$Nd)(P,m))?`~/${P.substr(m.length)}`:n}e.$2z=p;function h(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.$3z=h;const v="\u2026",y="\\\\",o="~";function g(n,i=r.sep){const a=new Array(n.length);let m=!1;for(let P=0;P<n.length;P++){const I=n[P];if(I===""){a[P]=`.${i}`;continue}if(!I){a[P]=I;continue}m=!0;let D="",M=I;M.indexOf(y)===0?(D=M.substr(0,M.indexOf(y)+y.length),M=M.substr(M.indexOf(y)+y.length)):M.indexOf(i)===0?(D=M.substr(0,M.indexOf(i)+i.length),M=M.substr(M.indexOf(i)+i.length)):M.indexOf(o)===0&&(D=M.substr(0,M.indexOf(o)+o.length),M=M.substr(M.indexOf(o)+o.length));const L=M.split(i);for(let N=1;m&&N<=L.length;N++)for(let B=L.length-N;m&&B>=0;B--){m=!1;let re=L.slice(B,B+N).join(i);for(let ne=0;!m&&ne<n.length;ne++)if(ne!==P&&n[ne]&&n[ne].indexOf(re)>-1){const ue=B+N===L.length,se=B>0&&n[ne].indexOf(i)>-1?i+re:re,le=n[ne].endsWith(se);m=!ue||le}if(!m){let ne="";(L[0].endsWith(":")||D!=="")&&(B===1&&(B=0,N++,re=L[0]+i+re),B>0&&(ne=L[0]+i),ne=D+ne),B>0&&(ne=ne+v+i),ne=ne+re,B+N<L.length&&(ne=ne+i+v),a[P]=ne}}m&&(a[P]=I)}return a}e.$4z=g;var c;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function b(n,i=Object.create(null)){const a=[];let m=!1,P="";for(const I of n)if(I==="$"||m&&I==="{")P&&a.push({value:P,type:c.TEXT}),P="",m=!0;else if(I==="}"&&m){const D=i[P];if(typeof D=="string")D.length&&a.push({value:D,type:c.VARIABLE});else if(D){const M=a[a.length-1];(!M||M.type!==c.SEPARATOR)&&a.push({value:D.label,type:c.SEPARATOR})}P="",m=!1}else P+=I;return P&&!m&&a.push({value:P,type:c.TEXT}),a.filter((I,D)=>{if(I.type===c.SEPARATOR){const M=a[D-1],L=a[D+1];return[M,L].every(N=>N&&(N.type===c.VARIABLE||N.type===c.TEXT)&&N.value.length>0)}return!0}).map(I=>I.value).join("")}e.$5z=b;function k(n,i){return O.$j||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):n.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$6z=k;function w(n,i){return O.$j||i?n.replace(/\(&&\w\)|&&/g,""):O.$i?n.replace(/&&|&/g,a=>a==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.$7z=w;function t(n){return n.replace(/&/g,"&&")}e.$8z=t;function l(n){if(n.endsWith("]")){const i=n.lastIndexOf(" [",n.length-2);if(i!==-1){const a=s(n.substring(0,i));return{name:a.name,parentPath:a.parentPath+n.substring(i)}}}return s(n)}e.$9z=l;function s(n){const i=n.indexOf("/")!==-1?r.$0b:r.$9b,a=i.basename(n),m=i.dirname(n);return a.length?{name:a,parentPath:m}:{name:m,parentPath:""}}}),define(te[154],ie([0,1,17,7]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=e.$om=e.$nm=void 0;function r(d){return d.toJSON()}class O{constructor(p){this.a=p}transformIncoming(p){const h=this.a.transformIncoming(p);return h===p?p:r(C.URI.from(h))}transformOutgoing(p){const h=this.a.transformOutgoing(p);return h===p?p:r(C.URI.from(h))}transformOutgoingURI(p){const h=this.a.transformOutgoing(p);return h===p?p:C.URI.from(h)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$nm=O,e.$om=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function R(d,p,h){if(!d||h>200)return null;if(typeof d=="object"){if(d instanceof C.URI)return p.transformOutgoing(d);for(const v in d)if(Object.hasOwnProperty.call(d,v)){const y=R(d[v],p,h+1);y!==null&&(d[v]=y)}}return null}function S(d,p){const h=R(d,p,0);return h===null?d:h}e.$pm=S;function f(d,p,h,v){if(!d||v>200)return null;if(typeof d=="object"){if(d.$mid===1)return h?C.URI.revive(p.transformIncoming(d)):p.transformIncoming(d);if(d instanceof E.$Jb)return null;for(const y in d)if(Object.hasOwnProperty.call(d,y)){const o=f(d[y],p,h,v+1);o!==null&&(d[y]=o)}}return null}function u(d,p){const h=f(d,p,!1,0);return h===null?d:h}e.$qm=u;function $(d,p){const h=f(d,p,!0,0);return h===null?d:h}e.$rm=$}),define(te[21],ie([0,1,45,27,155,8,32,86,9,4,19,7]),function(V,e,E,C,r,O,R,S,f,u,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function h(se,le=p.UNLINK,J){if((0,R.$Ne)(se))throw new Error("rimraf - will refuse to recursively delete root");return le===p.UNLINK?y(se):v(se,J)}async function v(se,le=(0,R.$Se)((0,C.tmpdir)())){try{try{await E.promises.rename(se,le)}catch(J){return J.code==="ENOENT"?void 0:y(se)}y(le).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function y(se){return(0,r.promisify)(E.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function o(se){if((0,R.$Ne)(se))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=o;async function g(se,le){return k(await(le?c(se):(0,r.promisify)(E.readdir)(se)))}async function c(se){try{return await(0,r.promisify)(E.readdir)(se,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const le=[],J=await g(se);for(const K of J){let U=!1,T=!1,W=!1;try{const H=await e.Promises.lstat((0,f.$ac)(se,K));U=H.isFile(),T=H.isDirectory(),W=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}le.push({name:K,isFile:()=>U,isDirectory:()=>T,isSymbolicLink:()=>W})}return le}function b(se){return k(E.readdirSync(se))}e.readdirSync=b;function k(se){return se.map(le=>typeof le=="string"?u.$j?(0,S.$7k)(le):le:(le.name=u.$j?(0,S.$7k)(le.name):le.name,le))}async function w(se){const le=await g(se),J=[];for(const K of le)await l.existsDirectory((0,f.$ac)(se,K))&&J.push(K);return J}function t(se,le=1e3){return new Promise(J=>{let K=!1;const U=setInterval(()=>{K||(K=!0,E.access(se,T=>{K=!1,T&&(clearInterval(U),J(void 0))}))},le)})}e.whenDeleted=t;var l;(function(se){async function le(U){let T;try{if(T=await e.Promises.lstat(U),!T.isSymbolicLink())return{stat:T}}catch{}try{return{stat:await e.Promises.stat(U),symbolicLink:T?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(u.$i&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw H}throw W}}se.stat=le;async function J(U){try{const{stat:T,symbolicLink:W}=await se.stat(U);return T.isFile()&&W?.dangling!==!0}catch{}return!1}se.existsFile=J;async function K(U){try{const{stat:T,symbolicLink:W}=await se.stat(U);return T.isDirectory()&&W?.dangling!==!0}catch{}return!1}se.existsDirectory=K})(l||(e.SymlinkSupport=l={}));const s=new O.$Dg;function n(se,le,J){return s.queueFor(d.URI.file(se),$.$1f).queue(()=>{const K=I(J);return new Promise((U,T)=>m(se,le,K,W=>W?T(W):U()))})}let i=!0;function a(se){i=se}e.configureFlushOnWrite=a;function m(se,le,J,K){if(!i)return E.writeFile(se,le,{mode:J.mode,flag:J.flag},K);E.open(se,J.flag,J.mode,(U,T)=>{if(U)return K(U);E.writeFile(T,le,W=>{if(W)return E.close(T,()=>K(W));E.fdatasync(T,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),a(!1)),E.close(T,Q=>K(Q))))})})}function P(se,le,J){const K=I(J);if(!i)return E.writeFileSync(se,le,{mode:K.mode,flag:K.flag});const U=E.openSync(se,K.flag,K.mode);try{E.writeFileSync(U,le);try{E.fdatasyncSync(U)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),a(!1)}}finally{E.closeSync(U)}}e.writeFileSync=P;function I(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function D(se,le,J=6e4){if(se!==le)try{u.$i&&typeof J=="number"?await M(se,le,Date.now(),J):await(0,r.promisify)(E.rename)(se,le)}catch(K){if(se.toLowerCase()!==le.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await L(se,le,{preserveSymlinks:!1}),await h(se,p.MOVE);else throw K}}async function M(se,le,J,K,U=0){try{return await(0,r.promisify)(E.rename)(se,le)}catch(T){if(T.code!=="EACCES"&&T.code!=="EPERM"&&T.code!=="EBUSY")throw T;if(Date.now()-J>=K)throw console.error(`[node.js fs] rename failed after ${U} retries with error: ${T}`),T;if(U===0){let W=!1;try{const{stat:H}=await l.stat(le);H.isFile()||(W=!0)}catch{}if(W)throw T}return await(0,O.$wg)(Math.min(100,U*10)),M(se,le,J,K,U+1)}}async function L(se,le,J){return B(se,le,{root:{source:se,target:le},options:J,handledSourcePaths:new Set})}const N=511;async function B(se,le,J){if(J.handledSourcePaths.has(se))return;J.handledSourcePaths.add(se);const{stat:K,symbolicLink:U}=await l.stat(se);if(U){if(J.options.preserveSymlinks)try{return await ue(se,le,J)}catch(T){console.warn("[node.js fs] copy of symlink failed: ",T)}if(U.dangling)return}return K.isDirectory()?re(se,le,K.mode&N,J):ne(se,le,K.mode&N)}async function re(se,le,J,K){await e.Promises.mkdir(le,{recursive:!0,mode:J});const U=await g(se);for(const T of U)await B((0,f.$ac)(se,T),(0,f.$ac)(le,T),K)}async function ne(se,le,J){await e.Promises.copyFile(se,le),await e.Promises.chmod(le,J)}async function ue(se,le,J){let K=await e.Promises.readlink(se);(0,R.$Ke)(K,J.root.source,!u.$k)&&(K=(0,f.$ac)(J.root.target,K.substr(J.root.source.length+1))),await e.Promises.symlink(K,le)}e.Promises=new class{get access(){return(0,r.promisify)(E.access)}get stat(){return(0,r.promisify)(E.stat)}get lstat(){return(0,r.promisify)(E.lstat)}get utimes(){return(0,r.promisify)(E.utimes)}get read(){return(se,le,J,K,U)=>new Promise((T,W)=>{E.read(se,le,J,K,U,(H,Q,ce)=>H?W(H):T({bytesRead:Q,buffer:ce}))})}get readFile(){return(0,r.promisify)(E.readFile)}get write(){return(se,le,J,K,U)=>new Promise((T,W)=>{E.write(se,le,J,K,U,(H,Q,ce)=>H?W(H):T({bytesWritten:Q,buffer:ce}))})}get appendFile(){return(0,r.promisify)(E.appendFile)}get fdatasync(){return(0,r.promisify)(E.fdatasync)}get truncate(){return(0,r.promisify)(E.truncate)}get copyFile(){return(0,r.promisify)(E.copyFile)}get open(){return(0,r.promisify)(E.open)}get close(){return(0,r.promisify)(E.close)}get symlink(){return(0,r.promisify)(E.symlink)}get readlink(){return(0,r.promisify)(E.readlink)}get chmod(){return(0,r.promisify)(E.chmod)}get mkdir(){return(0,r.promisify)(E.mkdir)}get unlink(){return(0,r.promisify)(E.unlink)}get rmdir(){return(0,r.promisify)(E.rmdir)}get realpath(){return(0,r.promisify)(E.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return w}get writeFile(){return n}get rm(){return h}get rename(){return D}get copy(){return L}}}),define(te[105],ie([0,1,45,9,4,25,21]),function(V,e,E,C,r,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=e.$Kp=e.$Jp=void 0;function S(p){if(r.$k)return p;const h=(0,C.$dc)(p);if(p===h)return p;const v=((0,C.$ec)(p)||p).toLowerCase();try{const o=(0,R.readdirSync)(h).filter(g=>g.toLowerCase()===v);if(o.length===1){const g=S(h);if(g)return(0,C.$ac)(g,o[0])}else if(o.length>1){const g=o.indexOf(v);if(g>=0){const c=S(h);if(c)return(0,C.$ac)(c,o[g])}}}catch{}return null}e.$Jp=S;async function f(p){if(r.$k)return p;const h=(0,C.$dc)(p);if(p===h)return p;const v=((0,C.$ec)(p)||p).toLowerCase();try{const o=(await R.Promises.readdir(h)).filter(g=>g.toLowerCase()===v);if(o.length===1){const g=await f(h);if(g)return(0,C.$ac)(g,o[0])}else if(o.length>1){const g=o.indexOf(v);if(g>=0){const c=await f(h);if(c)return(0,C.$ac)(c,o[g])}}}catch{}return null}e.$Kp=f;async function u(p){try{return await R.Promises.realpath(p)}catch{const v=d(p);return await R.Promises.access(v,E.constants.R_OK),v}}e.$Lp=u;function $(p){try{return E.realpathSync(p)}catch{const v=d(p);return E.accessSync(v,E.constants.R_OK),v}}e.$Mp=$;function d(p){return(0,O.$td)((0,C.$$b)(p),C.sep)}}),define(te[106],ie([0,1,27,9,21]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=void 0;const O=/^\d+$/,R=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var f;(function(k){k[k.x64=0]="x64",k[k.x86=1]="x86",k[k.ARM=2]="ARM"})(f||(f={}));let u;switch(process.arch){case"ia32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let $;process.env.PROCESSOR_ARCHITEW6432?$=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?$=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?$=1:$=0;class d{constructor(w,t,l){this.exePath=w,this.displayName=t,this.a=l}async exists(){return this.a===void 0&&(this.a=await r.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:k=!1}={}){return k?u===0?process.env["ProgramFiles(x86)"]||null:$===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:k=!1,findPreview:w=!1}={}){const t=p({useAlternateBitness:k});if(!t)return null;const l=C.$ac(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(l))return null;let s=-1,n=null;for(const m of await r.Promises.readdir(l)){let P=-1;if(w){const D=m.indexOf("-");if(D<0)continue;const M=m.substring(0,D);if(!O.test(M)||m.substring(D+1)!=="preview")continue;P=parseInt(M,10)}else{if(!O.test(m))continue;P=parseInt(m,10)}if(P<=s)continue;const I=C.$ac(l,m,"pwsh.exe");await r.SymlinkSupport.existsFile(I)&&(n=I,s=P)}if(!n)return null;const i=t.includes("x86")?" (x86)":"",a=w?" Preview":"";return new d(n,`PowerShell${a}${i}`,!0)}async function v({findPreview:k}={}){if(!process.env.LOCALAPPDATA)return null;const w=C.$ac(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(w))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=k?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const s of await r.Promises.readdir(w))if(t.test(s)){const n=C.$ac(w,s,"pwsh.exe");return new d(n,l)}return null}function y(){const k=C.$ac(E.homedir(),".dotnet","tools","pwsh.exe");return new d(k,".NET Core PowerShell Global Tool")}function o(){const k=C.$ac(process.env.windir,u===1&&$!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new d(k,"Windows PowerShell",!0)}async function*g(){let k=await h();k&&(yield k),k=await h({useAlternateBitness:!0}),k&&(yield k),k=await v(),k&&(yield k),k=y(),k&&(yield k),k=await h({findPreview:!0}),k&&(yield k),k=await v({findPreview:!0}),k&&(yield k),k=await h({useAlternateBitness:!0,findPreview:!0}),k&&(yield k),k=o(),k&&(yield k)}async function*c(){for await(const k of g())await k.exists()&&(yield k)}e.$dl=c;async function b(){for await(const k of c())return k;return null}e.$el=b}),define(te[89],ie([0,1,9,4,36,73,10,21]),function(V,e,E,C,r,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$il=e.$hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function f(d=r.env){return d.comspec||"cmd.exe"}e.$hl=f;function u(d){let p=[],h=!1;const v=function(y){if(h){p.push(y);return}(!d.send(y,g=>{if(g&&console.error(g),h=!1,p.length>0){const c=p.slice(0);p=[],c.forEach(b=>v(b))}})||C.$i)&&(h=!0)};return{send:v}}e.$il=u;var $;(function(d){async function p(h,v,y){if(E.$_b(h))return h;if(v===void 0&&(v=r.cwd()),E.$dc(h)!=="."||(y===void 0&&R.$je(r.env.PATH)&&(y=r.env.PATH.split(E.$kc)),y===void 0||y.length===0))return E.$ac(v,h);async function g(c){if(await S.Promises.exists(c)){let b;try{b=await S.Promises.stat(c)}catch(k){k.message.startsWith("EACCES")&&(b=await S.Promises.lstat(c))}return b?!b.isDirectory():!1}return!1}for(const c of y){let b;if(E.$_b(c)?b=E.$ac(c,h):b=E.$ac(v,c,h),await g(b))return b;let k=b+".com";if(await g(k)||(k=b+".exe",await g(k)))return k}return E.$ac(v,h)}d.findExecutable=p})($||(e.win32=$={}))}),define(te[107],ie([0,1,47,15]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;function r(R){return new Promise((S,f)=>{let u;const $=new Map;function d(h,v,y,o,g){const c=$.get(v);if(h===R||c){const b={name:p(y),cmd:y,pid:h,ppid:v,load:o,mem:g};$.set(h,b),h===R&&(u=b),c&&(c.children||(c.children=[]),c.children.push(b),c.children.length>1&&(c.children=c.children.sort((k,w)=>k.pid-w.pid)))}}function p(h){const v=/--utility-sub-type=network/i,y=/--ms-enable-electron-run-as-node/i,o=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,c=/conhost\.exe.+--headless/i,b=/--type=([a-zA-Z-]+)/;if(o.exec(h))return"electron-crash-reporter";if(g.exec(h))return"winpty-agent";if(c.exec(h))return"conpty-agent";let k=b.exec(h);if(k&&k.length===2)return k[1]==="renderer"?"window":k[1]==="utility"?v.exec(h)?"utility-network-service":"utility-process":k[1]==="extensionHost"?"extension-host":k[1];const w=/[a-zA-Z-]+\.js/g;let t="";do k=w.exec(h),k&&(t+=k+" ");while(k);return t&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${t})`:y.exec(h)?`electron-nodejs (${h})`:h}if(process.platform==="win32"){const h=v=>v.indexOf("\\\\?\\")===0||v.indexOf("\\??\\")===0?v.substring(4):v.indexOf('"\\\\?\\')===0||v.indexOf('"\\??\\')===0?'"'+v.substring(5):v;new Promise((v,y)=>{V(["@vscode/windows-process-tree"],v,y)}).then(v=>{v.getProcessList(R,y=>{if(!y){f(new Error(`Root process ${R} not found`));return}v.getProcessCpuUsage(y,o=>{const g=new Map;o.forEach(c=>{const b=h(c.commandLine||"");g.set(c.pid,{name:p(b),cmd:b,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),u=g.get(R),u?(g.forEach(c=>{const b=g.get(c.ppid);b&&(b.children||(b.children=[]),b.children.push(c))}),g.forEach(c=>{c.children&&(c.children=c.children.sort((b,k)=>b.pid-k.pid))}),S(u)):f(new Error(`Root process ${R} not found`))})},v.ProcessDataFlag.CommandLine|v.ProcessDataFlag.Memory)})}else{let h=function(){let v=[u];const y=[];for(;v.length;){const g=v.shift();g&&(y.push(g.pid),g.children&&(v=v.concat(g.children)))}let o=JSON.stringify(C.$4e.asFileUri("vs/base/node/cpuUsage.sh").fsPath);o+=" "+y.join(" "),(0,E.exec)(o,{},(g,c,b)=>{if(g||b)f(g||new Error(b.toString()));else{const k=c.toString().split(`
`);for(let w=0;w<y.length;w++){const t=$.get(y[w]);t.load=parseFloat(k[w])}if(!u){f(new Error(`Root process ${R} not found`));return}S(u)}})};(0,E.exec)("which ps",{},(v,y,o)=>{if(v||o)if(process.platform!=="linux")f(v||new Error(o.toString()));else{const g=JSON.stringify(C.$4e.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(g,{},(c,b,k)=>{c||k?f(c||new Error(k.toString())):(O(b,d),h())})}else{const g=y.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${g} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(b,k,w)=>{b||w&&!w.includes("screen size is bogus")?f(b||new Error(w.toString())):(O(k,d),process.platform==="linux"?h():u?S(u):f(new Error(`Root process ${R} not found`)))})}})}})}e.$fr=r;function O(R,S){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,u=R.toString().split(`
`);for(const $ of u){const d=f.exec($.trim());d&&d.length===6&&S(parseInt(d[1]),parseInt(d[2]),d[5],parseFloat(d[3]),parseFloat(d[4]))}}}),define(te[108],ie([0,1,27,4,106,89]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=void 0;async function R(d,p){return d===1?C.$i?$():O.$hl(p):f(d,p)}e.$jl=R;let S=null;function f(d,p){if(C.$k&&d===2||C.$j&&d===3)return"/bin/bash";if(!S){let h;if(C.$i)h="/bin/bash";else{if(h=p.SHELL,!h)try{h=(0,E.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}S=h}return S}let u=null;async function $(){return u||(u=(await(0,r.$el)()).exePath),u}});var pe=this&&this.__decorate||function(V,e,E,C){var r=arguments.length,O=r<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,E):C,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(V,e,E,C);else for(var S=V.length-1;S>=0;S--)(R=V[S])&&(O=(r<3?R(O):r>3?R(e,E,O):R(e,E))||O);return r>3&&O&&Object.defineProperty(e,E,O),O};define(te[42],ie([0,1,24,8,17,22,55,13,3,2,74,25,10]),function(V,e,E,C,r,O,R,S,f,u,$,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.ProxyChannel=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.RequestInitiator=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=void 0;var h;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(h||(h={}));function v(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(y||(y={}));function o(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(g||(g={}));function c(U){let T=0;for(let W=0;;W+=7){const H=U.read(1);if(T|=(H.buffer[0]&127)<<W,!(H.buffer[0]&128))return T}}const b=s(0);function k(U,T){if(T===0){U.write(b);return}let W=0;for(let Q=T;Q!==0;Q=Q>>>7)W++;const H=r.$Jb.alloc(W);for(let Q=0;T!==0;Q++)H.buffer[Q]=T&127,T=T>>>7,T>0&&(H.buffer[Q]|=128);U.write(H)}class w{constructor(T){this.b=T,this.a=0}read(T){const W=this.b.slice(this.a,this.a+T);return this.a+=W.byteLength,W}}e.$Zg=w;class t{constructor(){this.a=[]}get buffer(){return r.$Jb.concat(this.a)}write(T){this.a.push(T)}}e.$1g=t;var l;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(l||(l={}));function s(U){const T=r.$Jb.alloc(1);return T.writeUInt8(U,0),T}const n={Undefined:s(l.Undefined),String:s(l.String),Buffer:s(l.Buffer),VSBuffer:s(l.VSBuffer),Array:s(l.Array),Object:s(l.Object),Uint:s(l.Int)},i=typeof Buffer<"u";function a(U,T){if(typeof T>"u")U.write(n.Undefined);else if(typeof T=="string"){const W=r.$Jb.fromString(T);U.write(n.String),k(U,W.byteLength),U.write(W)}else if(i&&Buffer.isBuffer(T)){const W=r.$Jb.wrap(T);U.write(n.Buffer),k(U,W.byteLength),U.write(W)}else if(T instanceof r.$Jb)U.write(n.VSBuffer),k(U,T.byteLength),U.write(T);else if(Array.isArray(T)){U.write(n.Array),k(U,T.length);for(const W of T)a(U,W)}else if(typeof T=="number"&&(T|0)===T)U.write(n.Uint),k(U,T);else{const W=r.$Jb.fromString(JSON.stringify(T));U.write(n.Object),k(U,W.byteLength),U.write(W)}}e.$2g=a;function m(U){switch(U.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return U.read(c(U)).toString();case l.Buffer:return U.read(c(U)).buffer;case l.VSBuffer:return U.read(c(U));case l.Array:{const W=c(U),H=[];for(let Q=0;Q<W;Q++)H.push(m(U));return H}case l.Object:return JSON.parse(U.read(c(U)).toString());case l.Int:return c(U)}}e.$3g=m;class P{constructor(T,W,H=null,Q=1e3){this.h=T,this.j=W,this.k=H,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(T,W){this.b.set(T,W),setTimeout(()=>this.w(T),0)}m(T){switch(T.type){case 200:{const W=this.o([T.type]);this.k?.logOutgoing(W,0,1,o(T.type));return}case 201:case 202:case 204:case 203:{const W=this.o([T.type,T.id],T.data);this.k?.logOutgoing(W,T.id,1,o(T.type),T.data);return}}}o(T,W=void 0){const H=new t;return a(H,T),a(H,W),this.p(H.buffer)}p(T){try{return this.h.send(T),T.byteLength}catch{return 0}}q(T){const W=new w(T),H=m(W),Q=m(W),ce=H[0];switch(ce){case 100:return this.k?.logIncoming(T.byteLength,H[1],1,`${v(ce)}: ${H[2]}.${H[3]}`,Q),this.s({type:ce,id:H[1],channelName:H[2],name:H[3],arg:Q});case 102:return this.k?.logIncoming(T.byteLength,H[1],1,`${v(ce)}: ${H[2]}.${H[3]}`,Q),this.t({type:ce,id:H[1],channelName:H[2],name:H[3],arg:Q});case 101:return this.k?.logIncoming(T.byteLength,H[1],1,`${v(ce)}`),this.u({type:ce,id:H[1]});case 103:return this.k?.logIncoming(T.byteLength,H[1],1,`${v(ce)}`),this.u({type:ce,id:H[1]})}}s(T){const W=this.b.get(T.channelName);if(!W){this.v(T);return}const H=new O.$ed;let Q;try{Q=W.call(this.j,T.name,T.arg,H.token)}catch(j){Q=Promise.reject(j)}const ce=T.id;Q.then(j=>{this.m({id:ce,data:j,type:201}),this.d.delete(T.id)},j=>{j instanceof Error?this.m({id:ce,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.m({id:ce,data:j,type:203}),this.d.delete(T.id)});const oe=(0,u.$jb)(()=>H.cancel());this.d.set(T.id,oe)}t(T){const W=this.b.get(T.channelName);if(!W){this.v(T);return}const H=T.id,ce=W.listen(this.j,T.name,T.arg)(oe=>this.m({id:H,data:oe,type:204}));this.d.set(T.id,ce)}u(T){const W=this.d.get(T.id);W&&(W.dispose(),this.d.delete(T.id))}v(T){let W=this.g.get(T.channelName);W||(W=[],this.g.set(T.channelName,W));const H=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.m({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:T,timeoutTimer:H})}w(T){const W=this.g.get(T);if(W){for(const H of W)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(T)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.$gb)(this.d.values()),this.d.clear()}}e.$4g=P;var I;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class D{constructor(T,W=null){this.l=T,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$8c,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=W}getChannel(T){const W=this;return{call(H,Q,ce){return W.a?Promise.reject(new S.$3):W.m(T,H,Q,ce)},listen(H,Q){return W.a?f.Event.None:W.o(T,H,Q)}}}m(T,W,H,Q=O.CancellationToken.None){const ce=this.g++,j={id:ce,type:100,channelName:T,name:W,arg:H};if(Q.isCancellationRequested)return Promise.reject(new S.$3);let A;return new Promise((q,G)=>{if(Q.isCancellationRequested)return G(new S.$3);const Z=()=>{const ae=he=>{switch(he.type){case 201:this.f.delete(ce),q(he.data);break;case 202:{this.f.delete(ce);const Ie=new Error(he.data.message);Ie.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,Ie.name=he.data.name,G(Ie);break}case 203:this.f.delete(ce),G(he.data);break}};this.f.set(ce,ae),this.p(j)};let z=null;this.b===g.Idle?Z():(z=(0,C.$jg)(ae=>this.u()),z.then(()=>{z=null,Z()}));const Y=()=>{z?(z.cancel(),z=null):this.p({id:ce,type:101}),G(new S.$3)},x=Q.onCancellationRequested(Y);A=(0,u.$ib)((0,u.$jb)(Y),x),this.d.add(A)}).finally(()=>{this.d.delete(A)})}o(T,W,H){const Q=this.g++,oe={id:Q,type:102,channelName:T,name:W,arg:H};let j=null;const A=new f.$8c({onWillAddFirstListener:()=>{j=(0,C.$jg)(q=>this.u()),j.then(()=>{j=null,this.d.add(A),this.p(oe)})},onDidRemoveLastListener:()=>{j?(j.cancel(),j=null):(this.d.delete(A),this.p({id:Q,type:103}))}}),F=q=>A.fire(q.data);return this.f.set(Q,F),A.event}p(T){switch(T.type){case 100:case 102:{const W=this.q([T.type,T.id,T.channelName,T.name],T.arg);this.j?.logOutgoing(W,T.id,0,`${v(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const W=this.q([T.type,T.id]);this.j?.logOutgoing(W,T.id,0,v(T.type));return}}}q(T,W=void 0){const H=new t;return a(H,T),a(H,W),this.r(H.buffer)}r(T){try{return this.l.send(T),T.byteLength}catch{return 0}}s(T){const W=new w(T),H=m(W),Q=m(W),ce=H[0];switch(ce){case 200:return this.j?.logIncoming(T.byteLength,0,0,o(ce)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(T.byteLength,H[1],0,o(ce),Q),this.t({type:H[0],id:H[1],data:Q})}}t(T){if(T.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(T.id)?.(T)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.$gb)(this.d.values()),this.d.clear()}}e.$5g=D,pe([R.$Tg],D.prototype,"onDidInitializePromise",null);class M{get connections(){const T=[];return this.f.forEach(W=>T.push(W)),T}constructor(T){this.a=new Map,this.f=new Set,this.g=new f.$8c,this.onDidAddConnection=this.g.event,this.h=new f.$8c,this.onDidRemoveConnection=this.h.event,T(({protocol:W,onDidClientDisconnect:H})=>{f.Event.once(W.onMessage)(ce=>{const oe=new w(ce),j=m(oe),A=new P(W,j),F=new D(W);this.a.forEach((G,Z)=>A.registerChannel(Z,G));const q={channelServer:A,channelClient:F,ctx:j};this.f.add(q),this.g.fire(q),H(()=>{A.dispose(),F.dispose(),this.f.delete(q),this.h.fire(q)})})})}getChannel(T,W){const H=this;return{call(Q,ce,oe){let j;if((0,p.$xe)(W)){const F=(0,E.$Kf)(H.connections.filter(W));j=F?Promise.resolve(F):f.Event.toPromise(f.Event.filter(H.onDidAddConnection,W))}else j=W.routeCall(H,Q,ce);const A=j.then(F=>F.channelClient.getChannel(T));return N(A).call(Q,ce,oe)},listen(Q,ce){if((0,p.$xe)(W))return H.j(T,W,Q,ce);const oe=W.routeEvent(H,Q,ce).then(j=>j.channelClient.getChannel(T));return N(oe).listen(Q,ce)}}}j(T,W,H,Q){const ce=this;let oe=new u.$kb;const j=new f.$8c({onWillAddFirstListener:()=>{oe=new u.$kb;const A=new f.$bd,F=new Map,q=Z=>{const Y=Z.channelClient.getChannel(T).listen(H,Q),x=A.add(Y);F.set(Z,x)},G=Z=>{const z=F.get(Z);z&&(z.dispose(),F.delete(Z))};ce.connections.filter(W).forEach(q),f.Event.filter(ce.onDidAddConnection,W)(q,void 0,oe),ce.onDidRemoveConnection(G,void 0,oe),A.event(j.fire,j,oe),oe.add(A)},onDidRemoveLastListener:()=>{oe.dispose()}});return j.event}registerChannel(T,W){this.a.set(T,W),this.f.forEach(H=>{H.channelServer.registerChannel(T,W)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$6g=M;class L{constructor(T,W,H=null){const Q=new t;a(Q,W),T.send(Q.buffer),this.a=new D(T,H),this.d=new P(T,W,H)}getChannel(T){return this.a.getChannel(T)}registerChannel(T,W){this.d.registerChannel(T,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$7g=L;function N(U){return{call(T,W,H){return U.then(Q=>Q.call(T,W,H))},listen(T,W){const H=new f.$dd;return U.then(Q=>H.input=Q.listen(T,W)),H.event}}}e.$8g=N;function B(U){let T=!1;return{call(W,H,Q){return T?U.call(W,H,Q):(0,C.$wg)(0).then(()=>T=!0).then(()=>U.call(W,H,Q))},listen(W,H){if(T)return U.listen(W,H);const Q=new f.$dd;return(0,C.$wg)(0).then(()=>T=!0).then(()=>Q.input=U.listen(W,H)),Q.event}}}e.$9g=B;class re{constructor(T){this.a=T}routeCall(T){return this.b(T)}routeEvent(T){return this.b(T)}async b(T){for(const W of T.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await f.Event.toPromise(T.onDidAddConnection),await this.b(T)}}e.$0g=re;var ne;(function(U){function T(ce,oe){const j=ce,A=oe&&oe.disableMarshalling,F=new Map;for(const q in j)H(q)&&F.set(q,f.Event.buffer(j[q],!0));return new class{listen(q,G,Z){const z=F.get(G);if(z)return z;if(Q(G)){const Y=j[G];if(typeof Y=="function")return Y.call(j,Z)}throw new S.$ab(`Event not found: ${G}`)}call(q,G,Z){const z=j[G];if(typeof z=="function"){if(!A&&Array.isArray(Z))for(let Y=0;Y<Z.length;Y++)Z[Y]=(0,$.$Yg)(Z[Y]);return z.apply(j,Z)}throw new S.$ab(`Method not found: ${G}`)}}}U.fromService=T;function W(ce,oe){const j=oe&&oe.disableMarshalling;return new Proxy({},{get(A,F){if(typeof F=="string")return oe?.properties?.has(F)?oe.properties.get(F):Q(F)?function(q){return ce.listen(F,q)}:H(F)?ce.listen(F):async function(...q){let G;oe&&!(0,p.$se)(oe.context)?G=[oe.context,...q]:G=q;const Z=await ce.call(F,G);return j?Z:(0,$.$Yg)(Z)};throw new S.$ab(`Property not found: ${String(F)}`)}})}U.toService=W;function H(ce){return ce[0]==="o"&&ce[1]==="n"&&d.$Ld(ce.charCodeAt(2))}function Q(ce){return/^onDynamic/.test(ce)&&d.$Ld(ce.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const T=U.toString();if(T!=="[object Object]")return T}return U}function le(U){return Array.isArray(U)?U.map(se):se(U)}function J(U,T,W,H,Q,ce,oe){oe=le(oe);const j=ue[Q],A=j[H%j.length];let F=[`%c[${U}]%c[${String(T).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(ce)?(F=F.concat(oe),F.push(")")):F.push(oe),console.log.apply(console,F)}class K{constructor(T,W){this.d=T,this.f=W,this.a=0,this.b=0}logOutgoing(T,W,H,Q,ce){this.b+=T,J(this.d,this.b,T,W,H,Q,ce)}logIncoming(T,W,H,Q,ce){this.a+=T,J(this.f,this.a,T,W,H,Q,ce)}}e.$$g=K}),define(te[156],ie([0,1,17,3,42]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sS=e.$rS=void 0;class O{constructor(f){this.a=f,this.onMessage=C.Event.fromDOMEventEmitter(this.a,"message",u=>E.$Jb.wrap(u.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$rS=O;class R extends r.$7g{constructor(f,u){const $=new O(f);super($,u),this.b=$}dispose(){this.b.disconnect()}}e.$sS=R}),define(te[109],ie([0,1,17,3,2,42]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dh=e.$ch=e.$bh=e.$ah=e.ProtocolConstants=e.$_g=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var S;(function(n){n.enableDiagnostics=!1,n.records=[];const i=new WeakMap;let a=0;function m(I,D){if(!i.has(I)){const M=String(++a);i.set(I,M)}return i.get(I)}function P(I,D,M,L){if(!n.enableDiagnostics)return;const N=m(I,D);if(L instanceof E.$Jb||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const B=E.$Jb.alloc(L.byteLength);B.set(L),n.records.push({timestamp:Date.now(),id:N,label:D,type:M,buff:B})}else n.records.push({timestamp:Date.now(),id:N,label:D,type:M,data:L})}n.traceSocketEvent=P})(S||(e.SocketDiagnostics=S={}));var f;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let u=null;function $(){return u||(u=E.$Jb.alloc(0)),u}class d{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,a){if(i===0)return $();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const D=this.a[0];return a&&(this.a.shift(),this.b-=i),D}if(this.a[0].byteLength>i){const D=this.a[0].slice(0,i);return a&&(this.a[0]=this.a[0].slice(i),this.b-=i),D}const m=E.$Jb.alloc(i);let P=0,I=0;for(;i>0;){const D=this.a[I];if(D.byteLength>i){const M=D.slice(0,i);m.set(M,P),P+=i,a&&(this.a[I]=D.slice(i),this.b-=i),i-=i}else m.set(D,P),P+=D.byteLength,a?(this.a.shift(),this.b-=D.byteLength):I++,i-=D.byteLength}return m}}e.$_g=d;var p;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(p||(p={}));function h(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class y{constructor(i,a,m,P){this.type=i,this.id=a,this.ack=m,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class o extends r.$lb{constructor(i){super(),this.f=this.B(new C.$8c),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new d,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const m=this.g.messageType,P=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new y(m,P,I,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=E.$Jb.alloc(13);a.writeUInt8(i.type,0),a.writeUInt32BE(i.id,1),a.writeUInt32BE(i.ack,5),a.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(a,i.data)}g(i,a){const m=this.f===0;return this.d.push(i,a),this.f+=i.byteLength+a.byteLength,m}h(){const i=E.$Jb.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,a){this.g(i,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class c extends r.$lb{constructor(i){super(),this.f=new C.$8c,this.onMessage=this.f.event,this.g=new C.$8c,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new g(this.a)),this.c=this.B(new o(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new y(1,0,0,i))}}e.$ah=c;class b extends O.$7g{static fromSocket(i,a){return new b(new c(i),a)}get onDidDispose(){return this.b.onDidDispose}constructor(i,a,m=null){super(i,a,m),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$bh=b;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new C.$8c({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$ch=k;class w{constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,a=this.a;for(;a;)a=a.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let a=0,m=this.a;for(;m;)i[a++]=m.data,m=m.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const a=new w(i);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class l{static{this.a=10}static{this.b=null}static getInstance(){return l.b||(l.b=new l),l.b}constructor(){this.c=[];const i=Date.now();for(let a=0;a<l.a;a++)this.c[a]=i-1e3*a;setInterval(()=>{for(let a=l.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),a=(1+l.a)*1e3;let m=0;for(let P=0;P<l.a;P++)i-this.c[P]<=a&&m++;return 1-m/l.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new k,this.onControlMessage=this.u.event,this.v=new k,this.onMessage=this.v.event,this.w=new k,this.onDidDispose=this.w.event,this.x=new k,this.onSocketClose=this.x.event,this.y=new k,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??l.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new r.$kb,this.o=i.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new o(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new y(5,0,0,$());this.p.write(i),this.p.flush()}sendPause(){const i=new y(7,0,0,$());this.p.write(i)}sendResume(){const i=new y(8,0,0,$());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,a){this.a=!0,this.r.dispose(),this.r=new r.$kb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new o(this.o)),this.r.add(this.q.onMessage(m=>this.z(m))),this.r.add(this.o.onClose(m=>this.x.fire(m))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new y(3,0,this.h,$());this.p.write(i);const a=this.b.toArray();for(let m=0,P=a.length;m<P;m++)this.p.write(a[m]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const a=this.b.peek();if(a&&a.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new y(6,0,0,$())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let m=0,P=a.length;m<P;m++)this.p.write(a[m]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const a=++this.c;this.h=this.g;const m=new y(1,a,this.h,i);this.b.push(m),this.a||(this.p.write(m),this.B())}sendControl(i){const a=new y(2,0,0,i);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),a=Date.now()-i.writtenTime,m=Date.now()-this.q.lastReadTime,P=Date.now()-this.n;if(a>=2e4&&m>=2e4&&P>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:m});return}const I=Math.max(2e4-a,2e4-m,2e4-P,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new y(3,0,this.h,$());this.p.write(i)}D(){this.h=this.g;const i=new y(9,0,this.h,$());this.p.write(i)}}e.$dh=s}),define(te[157],ie([0,1,38,17,3,2,42,145]),function(V,e,E,C,r,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vS=void 0;function f($,d){const p=r.Event.fromNodeEventEmitter(E.$oS,d,(v,y)=>({event:v,message:y})),h=r.Event.filter(p,({event:v})=>v.sender.id===$);return r.Event.map(h,({message:v})=>v&&C.$Jb.wrap(v))}class u extends R.$6g{static{this.b=new Map}static d(){const d=r.Event.fromNodeEventEmitter(E.$oS,"vscode:hello",({sender:p})=>p);return r.Event.map(d,p=>{const h=p.id;u.b.get(h)?.dispose();const y=new r.$8c;u.b.set(h,(0,O.$jb)(()=>y.fire()));const o=f(h,"vscode:message"),g=r.Event.any(r.Event.signal(f(h,"vscode:disconnect")),y.event);return{protocol:new S.$uS(p,o),onDidClientDisconnect:g}})}constructor(){super(u.d())}}e.$vS=u}),define(te[110],ie([0,1,38,3,31,156]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xS=e.$wS=void 0;class R extends O.$sS{constructor(u,$){super({addEventListener:(d,p)=>u.addListener(d,p),removeEventListener:(d,p)=>u.removeListener(d,p),postMessage:d=>u.postMessage(d),start:()=>u.start(),close:()=>u.close()},$)}}e.$wS=R;async function S(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const u=(0,r.$6e)();f.webContents.send("vscode:createMessageChannel",u);const $=C.Event.fromNodeEventEmitter(E.$oS,"vscode:createMessageChannelResult",(p,h)=>({nonce:h,port:p.ports[0]})),{port:d}=await C.Event.toPromise(C.Event.once(C.Event.filter($,p=>p.nonce===u)));return d}e.$xS=S}),define(te[158],ie([0,1,47,8,17,22,153,13,3,2,37,89,73,42]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=void 0;class v extends h.$4g{constructor(g){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",c=>r.$Jb.wrap(Buffer.from(c,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$Gp=v;class y{constructor(g,c){this.i=g,this.j=c,this.c=new Set,this.g=new Map,this.h=new f.$8c,this.onDidProcessExit=this.h.event;const b=c&&c.timeout?c.timeout:6e4;this.b=new C.$sg(b),this.d=null,this.f=null}getChannel(g){const c=this;return{call(b,k,w){return c.k(g,b,k,w)},listen(b,k){return c.l(g,b,k)}}}k(g,c,b,k=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(k.isCancellationRequested)return Promise.reject(S.$4());this.b.cancel();const w=this.n(g),t=(0,C.$jg)(n=>w.call(c,b,n)),l=k.onCancellationRequested(()=>t.cancel()),s=(0,u.$jb)(()=>t.cancel());return this.c.add(s),t.finally(()=>{l.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,c,b){if(!this.b)return f.Event.None;this.b.cancel();let k;const w=new f.$8c({onWillAddFirstListener:()=>{k=this.n(g).listen(c,b)(w.fire,w),this.c.add(k)},onDidRemoveLastListener:()=>{this.c.delete(k),k.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return w.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],c=Object.create(null);c.env={...(0,$.$Hm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(c.env={...c.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(c.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,p.$gl)(c.env),this.d=(0,E.fork)(this.i,g,c);const b=new f.$8c;f.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,R.$Cp)(i)){(0,R.log)(i,`IPC Library: ${this.j.serverName}`);return}b.fire(r.$Jb.wrap(Buffer.from(i,"base64")))});const w=this.j.useQueue?(0,d.$il)(this.d):this.d,t=i=>this.d&&this.d.connected&&w.send(i.buffer.toString("base64")),l=b.event,s={send:t,onMessage:l};this.f=new h.$5g(s);const n=()=>this.o();process.once("exit",n),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,a)=>{process.removeListener("exit",n),this.c.forEach(m=>(0,u.$gb)(m)),this.c.clear(),i!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:a})})}return this.f}n(g){let c=this.g.get(g);return c||(c=this.m.getChannel(g),this.g.set(g,c)),c}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Hp=y}),define(te[111],ie([0,1,8,3,2,74,10]),function(V,e,E,C,r,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.StorageState=e.$Fo=e.StorageHint=void 0;var S;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function f(p){const h=p;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$Fo=f;var u;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(u||(e.StorageState=u={}));class $ extends r.$lb{static{this.a=100}constructor(h,v=Object.create(null)){super(),this.m=h,this.n=v,this.b=this.B(new C.$$c),this.onDidChangeStorage=this.b.event,this.c=u.None,this.f=new Map,this.g=new E.$tg($.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(h=>this.r(h)))}r(h){this.b.pause();try{h.changed?.forEach((v,y)=>this.s(y,v)),h.deleted?.forEach(v=>this.s(v,void 0))}finally{this.b.resume()}}s(h,v){if(this.c===u.Closed)return;let y=!1;(0,R.$se)(v)?y=this.f.delete(h):this.f.get(h)!==v&&(this.f.set(h,v),y=!0),y&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===u.None&&(this.c=u.Initialized,this.n.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(h,v){const y=this.f.get(h);return(0,R.$se)(y)?v:y}getBoolean(h,v){const y=this.get(h);return(0,R.$se)(y)?v:y==="true"}getNumber(h,v){const y=this.get(h);return(0,R.$se)(y)?v:parseInt(y,10)}getObject(h,v){const y=this.get(h);return(0,R.$se)(y)?v:(0,O.$Xg)(y)}async set(h,v,y=!1){if(this.c===u.Closed)return;if((0,R.$se)(v))return this.delete(h,y);const o=(0,R.$le)(v)||Array.isArray(v)?(0,O.$Wg)(v):String(v);if(this.f.get(h)!==o)return this.f.set(h,o),this.j.set(h,o),this.h.delete(h),this.b.fire({key:h,external:y}),this.w()}async delete(h,v=!1){if(!(this.c===u.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:v}),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=u.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(h).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(h){if(this.u)return this.w(h)}async w(h){return this.g.trigger(()=>this.v(),h)}async whenFlushed(){if(this.u)return new Promise(h=>this.l.push(h))}isInMemory(){return this.n.hint===S.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Go=$;class d{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((v,y)=>this.a.set(y,v)),h.delete?.forEach(v=>this.a.delete(v))}async close(){}}e.$Ho=d}),define(te[159],ie([0,1,8,3,35,9,21]),function(V,e,E,C,r,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$US=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return C.Event.None}static{this.a=2e3}static{this.b=256}constructor($,d=Object.create(null)){this.g=$,this.h=d,this.c=(0,O.$ec)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const $=await this.f,d=new Map;return(await this.s($,"SELECT * FROM ItemTable")).forEach(h=>d.set(h.key,h.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${d.size} rows`),d}async updateItems($){const d=await this.f;return this.j(d,$)}j($,d){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${d.insert?(0,r.$li)(d.insert):"0"}), delete(${d.delete?(0,r.$mi)(d.delete):"0"})`),this.t($,()=>{const p=d.insert,h=d.delete;if(p&&p.size>0){const v=[];v.push([]);let y=0;p.forEach((o,g)=>{let c=v[y];c.length>S.b&&(y++,c=[],v.push(c)),c.push(g,o)}),v.forEach(o=>{this.u($,`INSERT INTO ItemTable VALUES ${new Array(o.length/2).fill("(?,?)").join(",")}`,g=>g.run(o),()=>{const g=[];let c=0;return p.forEach((b,k)=>{g.push(k),c+=b.length}),`Keys: ${g.join(", ")} Length: ${c}`})})}if(h&&h.size){const v=[];v.push([]);let y=0;h.forEach(o=>{let g=v[y];g.length>S.b&&(y++,g=[],v.push(g)),g.push(o)}),v.forEach(o=>{this.u($,`DELETE FROM ItemTable WHERE key IN (${new Array(o.length).fill("?").join(",")})`,g=>g.run(o),()=>{const g=[];return h.forEach(c=>{g.push(c)}),`Keys: ${g.join(", ")}`})})}})}async close($){this.d.trace(`[storage ${this.c}] close()`);const d=await this.f;return this.k(d,$)}k($,d){return new Promise((p,h)=>{$.db.close(v=>(v&&this.o($,`[storage ${this.c}] close(): ${v}`),this.g===S.IN_MEMORY_PATH?p():!$.isErroneous&&!$.isInMemory?this.l().then(p,y=>(this.d.error(`[storage ${this.c}] backup(): ${y}`),p())):typeof d=="function"?R.Promises.unlink(this.g).then(()=>this.p(this.g).then(y=>{const o=()=>this.k(y,void 0);return this.j(y,{insert:d()}).then(()=>o(),g=>(o(),Promise.reject(g)))})).then(p,h):h(v||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const $=this.m(this.g);return R.Promises.copy(this.g,$,{preserveSymlinks:!1})}m($){return`${$}.backup`}async checkIntegrity($){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${$})`);const d=await this.f,p=await this.r(d,$?"PRAGMA integrity_check":"PRAGMA quick_check"),h=$?p.integrity_check:p.quick_check;return d.isErroneous?`${h} (last error: ${d.lastError})`:d.isInMemory?`${h} (in-memory!)`:h}async n($,d=!0){this.d.trace(`[storage ${this.c}] open(${$}, retryOnBusy: ${d})`);try{return await this.p($)}catch(p){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&d)return await(0,E.$wg)(S.a),this.n($,!1);try{await R.Promises.unlink($);try{await R.Promises.rename(this.m($),$,!1)}catch{}return await this.p($)}catch(h){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${h}`),this.p(S.IN_MEMORY_PATH)}}}o($,d){$.isErroneous=!0,$.lastError=d,this.d.error(d)}p($){return new Promise((d,p)=>{new Promise((h,v)=>{V(["@vscode/sqlite3"],h,v)}).then(h=>{const v={db:new(this.d.isTracing?h.verbose().Database:h.Database)($,y=>y?v.db&&y.code!=="SQLITE_CANTOPEN"?v.db.close(()=>p(y)):p(y):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>d(v),o=>v.db.close(()=>p(o)))),isInMemory:$===S.IN_MEMORY_PATH};v.db.on("error",y=>this.o(v,`[storage ${this.c}] Error (event): ${y}`)),this.d.isTracing&&v.db.on("trace",y=>this.d.trace(`[storage ${this.c}] Trace (event): ${y}`))},p)})}q($,d){return new Promise((p,h)=>{$.db.exec(d,v=>v?(this.o($,`[storage ${this.c}] exec(): ${v}`),h(v)):p())})}r($,d){return new Promise((p,h)=>{$.db.get(d,(v,y)=>v?(this.o($,`[storage ${this.c}] get(): ${v}`),h(v)):p(y))})}s($,d){return new Promise((p,h)=>{$.db.all(d,(v,y)=>v?(this.o($,`[storage ${this.c}] all(): ${v}`),h(v)):p(y))})}t($,d){return new Promise((p,h)=>{$.db.serialize(()=>{$.db.run("BEGIN TRANSACTION"),d(),$.db.run("END TRANSACTION",v=>v?(this.o($,`[storage ${this.c}] transaction(): ${v}`),h(v)):p())})})}u($,d,p,h){const v=$.db.prepare(d),y=o=>{this.o($,`[storage ${this.c}] prepare(): ${o} (${d}). Details: ${h()}`)};v.on("error",y),p(v),v.finalize(o=>{o&&y(o),v.removeListener("error",y)})}}e.$US=S;class f{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor($){$&&typeof $.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.a=$.logTrace),$&&typeof $.logError=="function"&&(this.b=$.logError)}get isTracing(){return!!this.a}trace($){this.a?.($)}error($){this.b?.($)}}}),define(te[160],ie([12,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(te[161],ie([12,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[162],ie([12,11]),function(V,e){return V.create("vs/platform/contextkey/common/contextkey",e)}),define(te[163],ie([12,11]),function(V,e){return V.create("vs/platform/contextkey/common/scanner",e)}),define(te[164],ie([12,11]),function(V,e){return V.create("vs/platform/dialogs/common/dialogs",e)}),define(te[165],ie([12,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[166],ie([12,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(te[167],ie([12,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(te[168],ie([12,11]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[169],ie([12,11]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[170],ie([12,11]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[171],ie([12,11]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[172],ie([12,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[173],ie([12,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(te[174],ie([12,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(te[175],ie([12,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(te[176],ie([12,11]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[177],ie([12,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[178],ie([12,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[179],ie([12,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[180],ie([12,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[181],ie([12,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(te[182],ie([12,11]),function(V,e){return V.create("vs/platform/shell/node/shellEnv",e)}),define(te[183],ie([12,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[184],ie([12,11]),function(V,e){return V.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[185],ie([12,11]),function(V,e){return V.create("vs/platform/terminal/common/terminalProfiles",e)}),define(te[186],ie([12,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(te[187],ie([12,11]),function(V,e){return V.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[188],ie([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[189],ie([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[190],ie([12,11]),function(V,e){return V.create("vs/platform/workspace/common/workspace",e)}),define(te[191],ie([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[192],ie([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[193],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gab=e.$Fab=void 0;function E(r){return r&&r.hasOwnProperty("folderUri")}e.$Fab=E;function C(r){return r&&r.hasOwnProperty("workspace")}e.$Gab=C}),define(te[194],ie([0,1,7]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x3b=e.$w3b=e.$v3b=void 0;function C(R){return typeof R?.backupFolder=="string"}e.$v3b=C;function r(R){let S=[];try{Array.isArray(R.workspaces)&&(S=R.workspaces.map(f=>({workspace:{id:f.id,configPath:E.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$w3b=r;function O(R){let S=[];try{Array.isArray(R.folders)&&(S=R.folders.map(f=>({folderUri:E.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$x3b=O}),define(te[195],ie([0,1,13,163]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.TokenType=void 0;var r;(function(u){u[u.LParen=0]="LParen",u[u.RParen=1]="RParen",u[u.Neg=2]="Neg",u[u.Eq=3]="Eq",u[u.NotEq=4]="NotEq",u[u.Lt=5]="Lt",u[u.LtEq=6]="LtEq",u[u.Gt=7]="Gt",u[u.GtEq=8]="GtEq",u[u.RegexOp=9]="RegexOp",u[u.RegexStr=10]="RegexStr",u[u.True=11]="True",u[u.False=12]="False",u[u.In=13]="In",u[u.Not=14]="Not",u[u.And=15]="And",u[u.Or=16]="Or",u[u.Str=17]="Str",u[u.QuotedStr=18]="QuotedStr",u[u.Error=19]="Error",u[u.EOF=20]="EOF"})(r||(e.TokenType=r={}));function O(...u){switch(u.length){case 1:return(0,C.localize)(0,null,u[0]);case 2:return(0,C.localize)(1,null,u[0],u[1]);case 3:return(0,C.localize)(2,null,u[0],u[1],u[2]);default:return}}const R=(0,C.localize)(3,null),S=(0,C.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme($){switch($.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return $.isTripleEq?"===":"==";case 4:return $.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return $.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return $.lexeme;case 18:return $.lexeme;case 19:return $.lexeme;case 20:return"EOF";default:throw(0,E.$6)(`unhandled token type: ${JSON.stringify($)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset($){return this.c=$,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const d=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:d})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const d=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:d})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h($){return this.r()||this.c.charCodeAt(this.e)!==$?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k($){this.f.push({type:$,offset:this.d})}l($){const d=this.d,p=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:p};this.g.push({offset:d,lexeme:p,additionalInfo:$}),this.f.push(h)}n(){this.m.lastIndex=this.d;const $=this.m.exec(this.c);if($){this.e=this.d+$[0].length;const d=this.c.substring(this.d,this.e),p=f.b.get(d);p?this.k(p):this.f.push({type:17,lexeme:d,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let $=this.e,d=!1,p=!1;for(;;){if($>=this.c.length){this.e=$,this.l(S);return}const v=this.c.charCodeAt($);if(d)d=!1;else if(v===47&&!p){$++;break}else v===91?p=!0:v===92?d=!0:v===93&&(p=!1);$++}for(;$<this.c.length&&f.a.has(this.c.charCodeAt($));)$++;this.e=$;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$si=f}),define(te[196],ie([0,1,3,2]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=void 0;class r{constructor(){this.a=new E.$8c,this.b=new E.$8c,this.c=new E.$8c,this.d=new E.$8c}static{this.ChannelName="extensionhostdebugservice"}call(S,f,u){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:u[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:u[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:u[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:u[0],port:u[1],subId:u[2]}))}throw new Error("Method not implemented.")}listen(S,f,u){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$sn=r;class O extends C.$lb{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,f,u){this.b.call("attach",[S,f,u])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,f){this.b.call("terminate",[S,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,f){return this.b.call("openExtensionDevelopmentHostWindow",[S,f])}}e.$tn=O}),define(te[197],ie([0,1,148,55,15,9,36,19,7]),function(V,e,E,C,r,O,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=e.$Ul=e.$Tl=void 0,e.$Tl=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,O.$dc)(r.$4e.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,O.$ac)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,S.$0f)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$0f)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,E.$Sl)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.$ac)(this.userDataPath,"logs",h)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$0f)(f.URI.file((0,O.$ac)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$0f)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$0f)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$0f)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=R.env.VSCODE_PORTABLE;return h?f.URI.file((0,O.$ac)(h,"argv.json")):(0,S.$0f)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,O.$ac)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,O.$bc)(h):(0,O.$$b)((0,O.$ac)(r.$4e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?f.URI.file((0,O.$bc)(h)):f.URI.file((0,O.$ac)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,O.$bc)(h);const v=R.env.VSCODE_EXTENSIONS;if(v)return v;const y=R.env.VSCODE_PORTABLE;return y?(0,O.$ac)(y,"extensions"):(0,S.$0f)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(v=>/^[^:/?#]+?:\/\//.test(v)?f.URI.parse(v):f.URI.file((0,O.$$b)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?f.URI.parse(h):f.URI.file((0,O.$$b)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return $(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$Tl.test(h))}get extensionLogLevel(){const h=[];for(const v of this.args.log||[]){const y=e.$Tl.exec(v);y&&y[1]&&y[2]&&h.push([y[1],y[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,S.$0f)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get disableKeytar(){return!!this.args["disable-keytar"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=R.env.VSCODE_PORTABLE;return h?f.URI.file((0,O.$ac)(h,"policy.json")):(0,S.$0f)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,v,y){this.a=h,this.b=v,this.c=y,this.editSessionId=this.args.editSessionId}}e.$Ul=u,pe([C.$Tg],u.prototype,"appRoot",null),pe([C.$Tg],u.prototype,"userHome",null),pe([C.$Tg],u.prototype,"userDataPath",null),pe([C.$Tg],u.prototype,"appSettingsHome",null),pe([C.$Tg],u.prototype,"tmpDir",null),pe([C.$Tg],u.prototype,"cacheHome",null),pe([C.$Tg],u.prototype,"stateResource",null),pe([C.$Tg],u.prototype,"userRoamingDataHome",null),pe([C.$Tg],u.prototype,"userDataSyncHome",null),pe([C.$Tg],u.prototype,"sync",null),pe([C.$Tg],u.prototype,"machineSettingsResource",null),pe([C.$Tg],u.prototype,"workspaceStorageHome",null),pe([C.$Tg],u.prototype,"localHistoryHome",null),pe([C.$Tg],u.prototype,"keyboardLayoutResource",null),pe([C.$Tg],u.prototype,"argvResource",null),pe([C.$Tg],u.prototype,"isExtensionDevelopment",null),pe([C.$Tg],u.prototype,"untitledWorkspacesHome",null),pe([C.$Tg],u.prototype,"builtinExtensionsPath",null),pe([C.$Tg],u.prototype,"extensionsPath",null),pe([C.$Tg],u.prototype,"extensionDevelopmentLocationURI",null),pe([C.$Tg],u.prototype,"extensionDevelopmentKind",null),pe([C.$Tg],u.prototype,"extensionTestsLocationURI",null),pe([C.$Tg],u.prototype,"debugExtensionHost",null),pe([C.$Tg],u.prototype,"logLevel",null),pe([C.$Tg],u.prototype,"extensionLogLevel",null),pe([C.$Tg],u.prototype,"serviceMachineIdResource",null),pe([C.$Tg],u.prototype,"disableTelemetry",null),pe([C.$Tg],u.prototype,"disableWorkspaceTrust",null),pe([C.$Tg],u.prototype,"disableKeytar",null),pe([C.$Tg],u.prototype,"policyFile",null);function $(p,h){return d(p["inspect-extensions"],p["inspect-brk-extensions"],5870,h,p.debugId,p.extensionEnvironment)}e.$Vl=$;function d(p,h,v,y,o,g){const b=Number(h||p)||(y?null:v),k=b?!!h:!1;let w;if(g)try{w=JSON.parse(g)}catch{}return{port:b,break:k,debugId:o,env:w}}e.$Wl=d}),define(te[112],ie([0,1,307,4,166]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=void 0;const O={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.$kl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(33,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(y,o,g=R){const c=y.find(a=>a.length>0&&a[0]!=="-"),b={},k=["_"],w=[],t={};let l;for(const a in o){const m=o[a];m.type==="subcommand"?a===c&&(l=m):(m.alias&&(b[a]=m.alias),m.type==="string"||m.type==="string[]"?(k.push(a),m.deprecates&&k.push(...m.deprecates)):m.type==="boolean"&&(w.push(a),m.deprecates&&w.push(...m.deprecates)),m.global&&(t[a]=m))}if(l&&c){const a=t;for(const D in l.options)a[D]=l.options[D];const m=y.filter(D=>D!==c),P=g.getSubcommandReporter?g.getSubcommandReporter(c):void 0,I=S(m,a,P);return{[c]:I,_:[]}}const s=E(y,{string:k,boolean:w,alias:b}),n={},i=s;n._=s._.map(a=>String(a)).filter(a=>a.length>0),delete i._;for(const a in o){const m=o[a];if(m.type==="subcommand")continue;m.alias&&delete i[m.alias];let P=i[a];if(m.deprecates)for(const I of m.deprecates)i.hasOwnProperty(I)&&(P||(P=i[I],P&&g.onDeprecatedOption(I,m.deprecationMessage||(0,r.localize)(36,null,a))),delete i[I]);if(typeof P<"u"){if(m.type==="string[]"){if(Array.isArray(P)||(P=[P]),!m.allowEmptyValue){const I=P.filter(D=>D.length>0);I.length!==P.length&&(g.onEmptyValue(a),P=I.length>0?I:void 0)}}else m.type==="string"&&(Array.isArray(P)?(P=P.pop(),g.onMultipleValues(a,P)):!P&&!m.allowEmptyValue&&(g.onEmptyValue(a),P=void 0));n[a]=P,m.deprecationMessage&&g.onDeprecatedOption(a,m.deprecationMessage)}delete i[a]}for(const a in i)g.onUnknownOption(a);return n}e.$ll=S;function f(y,o){let g="";return o.args&&(Array.isArray(o.args)?g=` <${o.args.join("> <")}>`:g=` <${o.args}>`),o.alias?`-${o.alias} --${y}${g}`:`--${y}${g}`}function u(y,o){const g=[];for(const c in y){const b=y[c],k=f(c,b);g.push([k,b.description])}return $(g,o)}e.$ml=u;function $(y,o){const c=y.reduce((w,t)=>Math.max(w,t[0].length),12)+2+1;if(o-c<25)return y.reduce((w,t)=>w.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const b=o-c-1,k=[];for(const w of y){const t=w[0],l=p(w[1],b),s=d(c-t.length-2);k.push("  "+t+s+l[0]);for(let n=1;n<l.length;n++)k.push(d(c)+l[n])}return k}function d(y){return" ".repeat(y)}function p(y,o){const g=[];for(;y.length;){const c=y.length<o?y.length:y.lastIndexOf(" ",o),b=y.slice(0,c).trim();y=y.slice(c),g.push(b)}return g}function h(y,o,g,c,b){const k=process.stdout.isTTY&&process.stdout.columns||80,w=b?.noInputFiles!==!0?`[${(0,r.localize)(37,null)}...]`:"",t=[`${y} ${g}`];t.push(""),t.push(`${(0,r.localize)(38,null)}: ${o} [${(0,r.localize)(39,null)}]${w}`),t.push(""),b?.noPipe!==!0&&(C.$i?t.push((0,r.localize)(40,null,o)):t.push((0,r.localize)(41,null,o)),t.push(""));const l={},s=[];for(const n in c){const i=c[n];if(i.type==="subcommand")i.description&&s.push({command:n,description:i.description});else if(i.description&&i.cat){let a=l[i.cat];a||(l[i.cat]=a={}),a[n]=i}}for(const n in l){const i=n,a=l[i];a&&(t.push(O[i]),t.push(...u(a,k)),t.push(""))}return s.length&&(t.push((0,r.localize)(42,null)),t.push(...$(s.map(n=>[n.command,n.description]),k)),t.push("")),t.join(`
`)}e.$nl=h;function v(y,o){return`${y||(0,r.localize)(43,null)}
${o||(0,r.localize)(44,null)}
${process.arch}`}e.$ol=v}),define(te[198],ie([0,1,88,196,112]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E3b=void 0;class O extends C.$sn{constructor(S){super(),this.f=S}call(S,f,u){return f==="openExtensionDevelopmentHostWindow"?this.g(u[0],u[1]):super.call(S,f,u)}async g(S,f){const u=(0,r.$ll)(S,r.$kl);u.debugRenderer=f;const $=u.extensionDevelopmentPath;if(!$)return{success:!1};const[d]=await this.f.openExtensionDevelopmentHostWindow($,{context:5,cli:u,forceProfile:u.profile,forceTempProfile:u["profile-temp"]});if(!f)return{success:!0};const p=d.win;if(!p)return{success:!0};const h=p.webContents.debugger;let v=h.isAttached()?1/0:0;const y=(0,E.createServer)(o=>{v++===0&&h.attach();let g=!1;const c=w=>{g||o.write(JSON.stringify(w)+"\0")},b=(w,t,l,s)=>c({method:t,params:l,sessionId:s});p.on("close",()=>{h.removeListener("message",b),o.end(),g=!0}),h.addListener("message",b);let k=Buffer.alloc(0);o.on("data",w=>{k=Buffer.concat([k,w]);for(let t=k.indexOf(0);t!==-1;t=k.indexOf(0)){let l;try{const s=k.slice(0,t).toString("utf8");k=k.slice(t+1),l=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}h.sendCommand(l.method,l.params,l.sessionId).then(s=>c({id:l.id,sessionId:l.sessionId,result:s})).catch(s=>c({id:l.id,sessionId:l.sessionId,error:{code:0,message:s.message}}))}}),o.on("error",w=>{console.error("error on cdp pipe:",w)}),o.on("close",()=>{g=!0,--v===0&&h.detach()})});return await new Promise(o=>y.listen(0,o)),p.on("close",()=>y.close()),{rendererDebugPort:y.address().port,success:!0}}}e.$E3b=O}),define(te[63],ie([0,1,308,167,112]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ql=e.$pl=void 0;function O(d,p){const h=(b,k)=>{console.warn((0,C.localize)(0,null,b,k))},v=b=>{console.warn((0,C.localize)(1,null,b))},y=(b,k)=>{console.warn((0,C.localize)(2,null,b,k))},o=b=>({onUnknownOption:k=>{b!=="tunnel"&&console.warn((0,C.localize)(3,null,k,b))},onMultipleValues:h,onEmptyValue:v,onDeprecatedOption:y,getSubcommandReporter:b!=="tunnel"?o:void 0}),g={onUnknownOption:b=>{console.warn((0,C.localize)(4,null,b))},onMultipleValues:h,onEmptyValue:v,onDeprecatedOption:y,getSubcommandReporter:o},c=(0,r.$ll)(d,r.$kl,p?g:void 0);return c.goto&&c._.forEach(b=>E(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(b),(0,C.localize)(5,null))),c}function R(d){const p=d.findIndex(h=>!/^-/.test(h));if(p>-1)return[...d.slice(0,p),...d.slice(p+1)]}function S(d){let[,...p]=d;process.env.VSCODE_DEV&&(p=R(p)||[]);const h=!$(process.env);return O(p,h)}e.$pl=S;function f(d){let[,,...p]=d;return process.env.VSCODE_DEV&&(p=R(p)||[]),O(p,!0)}e.$ql=f;function u(d,...p){const h=d.indexOf("--");return h===-1?d.push(...p):d.splice(h,0,...p),d}e.$rl=u;function $(d){return d.VSCODE_CLI==="1"}e.$sl=$}),function(){"use strict";function V(e,E,C){function r(R,S){const f=O(R,S),u=[f];return e.isAbsolute(f)||u.unshift(C),e.resolve(...u)}function O(R,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,S);const $=R["user-data-dir"];if($)return $;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const d=process.env.USERPROFILE;if(typeof d!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(d,"AppData","Roaming")}break;case"darwin":u=e.join(E.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,S)}return{getUserDataPath:r}}if(typeof define=="function")define(te[199],ie([113,27,36]),function(e,E,C){return V(e,E,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=V(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[90],ie([0,1,27,197,199]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=e.$Xl=void 0;class O extends C.$Ul{constructor(u,$){super(u,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,r.getUserDataPath)(u,$.nameShort)},$)}}e.$Xl=O;function R(f,u){return(0,C.$Wl)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,u,f.extensionEnvironment)}e.$Yl=R;function S(f,u){return(0,C.$Wl)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,u,f.extensionEnvironment)}e.$Zl=S}),define(te[200],ie([0,1,45,27,32]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$54b=void 0;function O(R){const S=(0,r.$Se)((0,C.tmpdir)());try{return(0,E.writeFileSync)(S,""),R&&console.log(`Marker file for --wait created: ${S}`),S}catch(f){R&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$54b=O}),define(te[201],ie([0,1,10,169]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=void 0;function r(R,S,f){try{O(R,S,f)}catch(u){console.error(u?.message??u)}return R}e.$cp=r;function O(R,S,f){const u=($,d,p)=>{const h=$[d];if((0,E.$je)(h)){const v=h,y=v.length;if(y>1&&v[0]==="%"&&v[y-1]==="%"){const o=v.substr(1,y-2);let g=S[o];g===void 0&&f&&(g=f[o]);const c=typeof g=="string"?g:g?.message,b=f?.[o],k=typeof b=="string"?b:b?.message;if(!c){k||console.warn(`[${R.name}]: ${(0,C.localize)(0,null,o)}`);return}if(p&&(d==="title"||d==="category")&&k&&k!==c){const w={value:c,original:k};$[d]=w}else $[d]=c}}else if((0,E.$le)(h))for(const v in h)h.hasOwnProperty(v)&&(v==="commands"?u(h,v,!0):u(h,v,p));else if(Array.isArray(h))for(let v=0;v<h.length;v++)u(h,v,p)};for(const $ in R)R.hasOwnProperty($)&&u(R,$)}}),define(te[202],ie([0,1,19,70,171,203]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function f(g){return g=g.trim(),g==="*"||R.test(g)}e.$ro=f;function u(g){if(!f(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=g.match(R);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$so=u;function $(g){if(!g)return null;const c=g.majorBase,b=g.majorMustEqual,k=g.minorBase;let w=g.minorMustEqual;const t=g.patchBase;let l=g.patchMustEqual;g.hasCaret&&(c===0||(w=!1),l=!1);let s=0;if(g.preRelease){const n=S.exec(g.preRelease);if(n){const[,i,a,m]=n;s=Date.UTC(Number(i),Number(a)-1,Number(m))}}return{majorBase:c,majorMustEqual:b,minorBase:k,minorMustEqual:w,patchBase:t,patchMustEqual:l,isMinimum:g.hasGreaterEquals,notBefore:s}}e.$to=$;function d(g,c,b){let k;typeof g=="string"?k=$(u(g)):k=g;let w;c instanceof Date?w=c.getTime():typeof c=="string"&&(w=new Date(c).getTime());let t;if(typeof b=="string"?t=$(u(b)):t=b,!k||!t)return!1;const l=k.majorBase,s=k.minorBase,n=k.patchBase;let i=t.majorBase,a=t.minorBase,m=t.patchBase;const P=t.notBefore;let I=t.majorMustEqual,D=t.minorMustEqual,M=t.patchMustEqual;return t.isMinimum?l>i?!0:l<i?!1:s>a?!0:s<a||w&&w<P?!1:n>=m:(l===1&&i===0&&(!I||!D||!M)&&(i=1,a=0,m=0,I=!0,D=!1,M=!1),l<i?!1:l>i?!I:s<a?!1:s>a?!D:n<m?!1:n>m?!M:!(w&&w<P))}e.$uo=d;function p(g,c,b,k,w){const t=[];if(typeof k.publisher<"u"&&typeof k.publisher!="string")return t.push([C.default.Error,r.localize(0,null)]),t;if(typeof k.name!="string")return t.push([C.default.Error,r.localize(1,null,"name")]),t;if(typeof k.version!="string")return t.push([C.default.Error,r.localize(2,null,"version")]),t;if(!k.engines)return t.push([C.default.Error,r.localize(3,null,"engines")]),t;if(typeof k.engines.vscode!="string")return t.push([C.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof k.extensionDependencies<"u"&&!o(k.extensionDependencies))return t.push([C.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof k.activationEvents<"u"){if(!o(k.activationEvents))return t.push([C.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof k.main>"u"&&typeof k.browser>"u")return t.push([C.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof k.extensionKind<"u"&&typeof k.main>"u"&&t.push([C.default.Warning,r.localize(8,null,"extensionKind")]),typeof k.main<"u"){if(typeof k.main!="string")return t.push([C.default.Error,r.localize(9,null,"main")]),t;{const n=(0,E.$0f)(b,k.main);(0,E.$4f)(n,b)||t.push([C.default.Warning,r.localize(10,null,n.path,b.path)])}}if(typeof k.browser<"u"){if(typeof k.browser!="string")return t.push([C.default.Error,r.localize(11,null,"browser")]),t;{const n=(0,E.$0f)(b,k.browser);(0,E.$4f)(n,b)||t.push([C.default.Warning,r.localize(12,null,n.path,b.path)])}}if(!O.valid(k.version))return t.push([C.default.Error,r.localize(13,null)]),t;const l=[];if(!h(g,c,k,w,l))for(const n of l)t.push([C.default.Error,n]);return t}e.$vo=p;function h(g,c,b,k,w){return k||typeof b.main>"u"&&typeof b.browser>"u"?!0:y(g,c,b.engines.vscode,w)}e.$wo=h;function v(g,c,b){return g==="*"||y(c,b,g)}e.$xo=v;function y(g,c,b,k=[]){const w=$(u(b));if(!w)return k.push(r.localize(14,null,b)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return k.push(r.localize(15,null,b)),!1}else if(!w.majorMustEqual)return k.push(r.localize(16,null,b)),!1;return d(g,c,w)?!0:(k.push(r.localize(17,null,g,b)),!1)}function o(g){if(!Array.isArray(g))return!1;for(let c=0,b=g.length;c<b;c++)if(typeof g[c]!="string")return!1;return!0}}),define(te[204],ie([0,1,17,31]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=void 0;async function r(O,R,S){let f=S&&S.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const $=(await R.readFile(O.serviceMachineIdResource)).value.toString();f=(0,C.$5e)($)?$:null}catch{f=null}if(!f){f=(0,C.$6e)();try{await R.writeFile(O.serviceMachineIdResource,E.$Jb.fromString(f))}catch{}}return S?.store("storage.serviceMachineId",f,-1,1),f}e.$Qo=r}),define(te[75],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=void 0;class E{constructor(r,O=[],R=!1){this.ctor=r,this.staticArguments=O,this.supportsDelayedInstantiation=R}}e.$mh=E}),define(te[205],ie([0,1,75]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=e.InstantiationType=void 0;const C=[];var r;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function O(S,f,u){f instanceof E.$mh||(f=new E.$mh(f,[],!!u)),C.push([S,f])}e.$_q=O;function R(){return C}e.$ar=R}),define(te[206],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=void 0;class E{constructor(O,R){this.key=O,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Sp=E;class C{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const R of this.a.values())R.outgoing.size===0&&O.push(R);return O}insertEdge(O,R){const S=this.lookupOrInsertNode(O),f=this.lookupOrInsertNode(R);S.outgoing.set(f.key,f),f.incoming.set(S.key,S)}removeNode(O){const R=this.b(O);this.a.delete(R);for(const S of this.a.values())S.outgoing.delete(R),S.incoming.delete(R)}lookupOrInsertNode(O){const R=this.b(O);let S=this.a.get(R);return S||(S=new E(R,O),this.a.set(R,S)),S}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[R,S]of this.a)O.push(`${R}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,R]of this.a){const S=new Set([O]),f=this.c(R,S);if(f)return f}}c(O,R){for(const[S,f]of O.outgoing){if(R.has(S))return[...R,S].join(" -> ");R.add(S);const u=this.c(f,R);if(u)return u;R.delete(S)}}}e.$Tp=C}),define(te[6],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function S(f){return f[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=S})(E||(e._util=E={})),e.$oh=r("instantiationService");function C(R,S,f){S[E.DI_TARGET]===S?S[E.DI_DEPENDENCIES].push({id:R,index:f}):(S[E.DI_DEPENDENCIES]=[{id:R,index:f}],S[E.DI_TARGET]=S)}function r(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const S=function(f,u,$){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(S,f,$)};return S.toString=()=>R,E.serviceIds.set(R,S),S}e.$ph=r;function O(R){return R}e.$qh=O}),define(te[64],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y3b=void 0,e.$y3b=(0,E.$ph)("backupMainService")}),define(te[18],ie([0,1,10,7,6]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.ConfigurationTarget=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,r.$ph)("configurationService");function O(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof C.URI)}e.$Wh=O;function R(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof C.URI)}e.$Xh=R;var S;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function f(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Yh=f;function u(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.$Zh=u;function $(g,c){const b=Object.create(null);for(const k in g)d(b,k,g[k],c);return b}e.$1h=$;function d(g,c,b,k){const w=c.split("."),t=w.pop();let l=g;for(let s=0;s<w.length;s++){const n=w[s];let i=l[n];switch(typeof i){case"undefined":i=l[n]=Object.create(null);break;case"object":break;default:k(`Ignoring ${c} as ${w.slice(0,s+1).join(".")} is ${JSON.stringify(i)}`);return}l=i}if(typeof l=="object"&&l!==null)try{l[t]=b}catch{k(`Ignoring ${c} as ${w.join(".")} is ${JSON.stringify(l)}`)}else k(`Ignoring ${c} as ${w.join(".")} is ${JSON.stringify(l)}`)}e.$2h=d;function p(g,c){const b=c.split(".");h(g,b)}e.$3h=p;function h(g,c){const b=c.shift();if(c.length===0){delete g[b];return}if(Object.keys(g).indexOf(b)!==-1){const k=g[b];typeof k=="object"&&!Array.isArray(k)&&(h(k,c),Object.keys(k).length===0&&delete g[b])}}function v(g,c,b){function k(l,s){let n=l;for(const i of s){if(typeof n!="object"||n===null)return;n=n[i]}return n}const w=c.split("."),t=k(g,w);return typeof t>"u"?b:t}e.$4h=v;function y(g,c,b){Object.keys(c).forEach(k=>{k!=="__proto__"&&(k in g?E.$le(g[k])&&E.$le(c[k])?y(g[k],c[k],b):b&&(g[k]=c[k]):g[k]=c[k])})}e.$5h=y;function o(g){return g.replace(/[\[\]]/g,"")}e.$6h=o}),define(te[114],ie([0,1,4,25,195,6,162,13]),function(V,e,E,C,r,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ContextKeyExprType=e.$ti=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",E.$j),f.set("isLinux",E.$k),f.set("isWindows",E.$i),f.set("isWeb",E.$o),f.set("isMacNative",E.$j&&!E.$o),f.set("isEdge",E.$G),f.set("isFirefox",E.$E),f.set("isChrome",E.$D),f.set("isSafari",E.$F);function u(j,A){if(f.get(j)!==void 0)throw(0,S.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(j,A)}e.$ti=u;const $=Object.prototype.hasOwnProperty;var d;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const p={regexParsingWithErrorRecovery:!0},h=(0,R.localize)(0,null),v=(0,R.localize)(1,null),y=(0,R.localize)(2,null),o=(0,R.localize)(3,null),g=(0,R.localize)(4,null),c=(0,R.localize)(5,null),b=(0,R.localize)(6,null),k=(0,R.localize)(7,null);class w{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(A=p){this.k=A,this.d=new r.$si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(A){if(A===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(A).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const q=this.D(),G=q.type===17?c:void 0;throw this.h.push({message:g,offset:q.offset,lexeme:r.$si.getLexeme(q),additionalInfo:G}),w.c}return F}catch(F){if(F!==w.c)throw F;return}}l(){return this.m()}m(){const A=[this.o()];for(;this.y(16);){const F=this.o();A.push(F)}return A.length===1?A[0]:t.or(...A)}o(){const A=[this.s()];for(;this.y(15);){const F=this.s();A.push(F)}return A.length===1?A[0]:t.and(...A)}s(){if(this.y(2)){const A=this.D();switch(A.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,o),F?.negate()}case 17:return this.z(),L.create(A.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",A)}}return this.t()}t(){const A=this.D();switch(A.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,o),F}case 17:{const F=A.lexeme;if(this.z(),this.y(9)){const G=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),G.type!==10)throw this.B("REGEX",G);const Z=G.lexeme,z=Z.lastIndexOf("/"),Y=z===Z.length-1?void 0:this.w(Z.substring(z+1));let x;try{x=new RegExp(Z.substring(1,z),Y)}catch{throw this.B("REGEX",G)}return se.create(F,x)}switch(G.type){case 10:case 19:{const Z=[G.lexeme];this.z();let z=this.D(),Y=0;for(let Ee=0;Ee<G.lexeme.length;Ee++)G.lexeme.charCodeAt(Ee)===40?Y++:G.lexeme.charCodeAt(Ee)===41&&Y--;for(;!this.E()&&z.type!==15&&z.type!==16;){switch(z.type){case 0:Y++;break;case 1:Y--;break;case 10:case 18:for(let Ee=0;Ee<z.lexeme.length;Ee++)z.lexeme.charCodeAt(Ee)===40?Y++:G.lexeme.charCodeAt(Ee)===41&&Y--}if(Y<0)break;Z.push(r.$si.getLexeme(z)),this.z(),z=this.D()}const x=Z.join(""),ae=x.lastIndexOf("/"),he=ae===x.length-1?void 0:this.w(x.substring(ae+1));let Ie;try{Ie=new RegExp(x.substring(1,ae),he)}catch{throw this.B("REGEX",G)}return t.regex(F,Ie)}case 18:{const Z=G.lexeme;this.z();let z=null;if(!(0,C.$kd)(Z)){const Y=Z.indexOf("/"),x=Z.lastIndexOf("/");if(Y!==x&&Y>=0){const ae=Z.slice(Y+1,x),he=Z[x+1]==="i"?"i":"";try{z=new RegExp(ae,he)}catch{throw this.B("REGEX",G)}}}if(z===null)throw this.B("REGEX",G);return se.create(F,z)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const G=this.u();return t.notIn(F,G)}switch(this.D().type){case 3:{this.z();const G=this.u();if(this.x().type===18)return t.equals(F,G);switch(G){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,G)}}case 4:{this.z();const G=this.u();if(this.x().type===18)return t.notEquals(F,G);switch(G){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,G)}}case 5:return this.z(),ne.create(F,this.u());case 6:return this.z(),ue.create(F,this.u());case 7:return this.z(),B.create(F,this.u());case 8:return this.z(),re.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:b,offset:A.offset,lexeme:"",additionalInfo:k}),w.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const A=this.D();switch(A.type){case 17:case 18:return this.z(),A.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(A){return A.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(A){return this.C(A)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(A,F){if(this.C(A))return this.z();throw this.B(F,this.D())}B(A,F,q){const G=(0,R.localize)(8,null,A,r.$si.getLexeme(F)),Z=F.offset,z=r.$si.getLexeme(F);return this.h.push({message:G,offset:Z,lexeme:z,additionalInfo:q}),w.c}C(A){return this.D().type===A}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ui=w;class t{static false(){return i.INSTANCE}static true(){return a.INSTANCE}static has(A){return m.create(A)}static equals(A,F){return P.create(A,F)}static notEquals(A,F){return M.create(A,F)}static regex(A,F){return se.create(A,F)}static in(A,F){return I.create(A,F)}static notIn(A,F){return D.create(A,F)}static not(A){return L.create(A)}static and(...A){return K.create(A,null,!0)}static or(...A){return U.create(A,null,!0)}static greater(A,F){return B.create(A,F)}static greaterEquals(A,F){return re.create(A,F)}static smaller(A,F){return ne.create(A,F)}static smallerEquals(A,F){return ue.create(A,F)}static{this.c=new w({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this.c.parse(A)}}e.$vi=t;function l(j){const A=new w({regexParsingWithErrorRecovery:!1});return j.map(F=>(A.parse(F),A.lexingErrors.length>0?A.lexingErrors.map(q=>({errorMessage:q.additionalInfo?(0,R.localize)(9,null,q.additionalInfo):(0,R.localize)(10,null),offset:q.offset,length:q.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(q=>({errorMessage:q.additionalInfo?`${q.message}. ${q.additionalInfo}`:q.message,offset:q.offset,length:q.lexeme.length})):[]))}e.$wi=l;function s(j,A){const F=j?j.substituteConstants():void 0,q=A?A.substituteConstants():void 0;return!F&&!q?!0:!F||!q?!1:F.equals(q)}e.$xi=s;function n(j,A){return j.cmp(A)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return a.INSTANCE}}e.$yi=i;class a{static{this.INSTANCE=new a}constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return i.INSTANCE}}e.$zi=a;class m{static create(A,F=null){const q=f.get(A);return typeof q=="boolean"?q?a.INSTANCE:i.INSTANCE:new m(A,F)}constructor(A,F){this.key=A,this.c=F,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:W(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=f.get(this.key);return typeof A=="boolean"?A?a.INSTANCE:i.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Ai=m;class P{static create(A,F,q=null){if(typeof F=="boolean")return F?m.create(A,q):L.create(A,q);const G=f.get(A);return typeof G=="boolean"?F===(G?"true":"false")?a.INSTANCE:i.INSTANCE:new P(A,F,q)}constructor(A,F,q){this.c=A,this.d=F,this.f=q,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=f.get(this.c);if(typeof A=="boolean"){const F=A?"true":"false";return this.d===F?a.INSTANCE:i.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Bi=P;class I{static create(A,F){return new I(A,F)}constructor(A,F){this.d=A,this.f=F,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:H(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const F=A.getValue(this.f),q=A.getValue(this.d);return Array.isArray(F)?F.includes(q):typeof q=="string"&&typeof F=="object"&&F!==null?$.call(F,q):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$Ci=I;class D{static create(A,F){return new D(A,F)}constructor(A,F){this.d=A,this.f=F,this.type=11,this.c=I.create(A,F)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Di=D;class M{static create(A,F,q=null){if(typeof F=="boolean")return F?L.create(A,q):m.create(A,q);const G=f.get(A);return typeof G=="boolean"?F===(G?"true":"false")?i.INSTANCE:a.INSTANCE:new M(A,F,q)}constructor(A,F,q){this.c=A,this.d=F,this.f=q,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=f.get(this.c);if(typeof A=="boolean"){const F=A?"true":"false";return this.d===F?i.INSTANCE:a.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Ei=M;class L{static create(A,F=null){const q=f.get(A);return typeof q=="boolean"?q?i.INSTANCE:a.INSTANCE:new L(A,F)}constructor(A,F){this.c=A,this.d=F,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:W(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=f.get(this.c);return typeof A=="boolean"?A?i.INSTANCE:a.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.$Fi=L;function N(j,A){if(typeof j=="string"){const F=parseFloat(j);isNaN(F)||(j=F)}return typeof j=="string"||typeof j=="number"?A(j):i.INSTANCE}class B{static create(A,F,q=null){return N(F,G=>new B(A,G,q))}constructor(A,F,q){this.c=A,this.d=F,this.f=q,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Gi=B;class re{static create(A,F,q=null){return N(F,G=>new re(A,G,q))}constructor(A,F,q){this.c=A,this.d=F,this.f=q,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Hi=re;class ne{static create(A,F,q=null){return N(F,G=>new ne(A,G,q))}constructor(A,F,q){this.c=A,this.d=F,this.f=q,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Ii=ne;class ue{static create(A,F,q=null){return N(F,G=>new ue(A,G,q))}constructor(A,F,q){this.c=A,this.d=F,this.f=q,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Ji=ue;class se{static create(A,F){return new se(A,F)}constructor(A,F){this.d=A,this.f=F,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const F=this.f?this.f.source:"",q=A.f?A.f.source:"";return F<q?-1:F>q?1:0}equals(A){if(A.type===this.type){const F=this.f?this.f.source:"",q=A.f?A.f.source:"";return this.d===A.d&&F===q}return!1}substituteConstants(){return this}evaluate(A){const F=A.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=le.create(this)),this.c}}e.$Ki=se;class le{static create(A){return new le(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(A){return new le(this.c.map(A))}negate(){return this.c}}e.$Li=le;function J(j){let A=null;for(let F=0,q=j.length;F<q;F++){const G=j[F].substituteConstants();if(j[F]!==G&&A===null){A=[];for(let Z=0;Z<F;Z++)A[Z]=j[Z]}A!==null&&(A[F]=G)}return A===null?j:A}class K{static create(A,F,q){return K.d(A,F,q)}constructor(A,F){this.expr=A,this.c=F,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let F=0,q=this.expr.length;F<q;F++){const G=n(this.expr[F],A.expr[F]);if(G!==0)return G}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let F=0,q=this.expr.length;F<q;F++)if(!this.expr[F].equals(A.expr[F]))return!1;return!0}return!1}substituteConstants(){const A=J(this.expr);return A===this.expr?this:K.create(A,this.c,!1)}evaluate(A){for(let F=0,q=this.expr.length;F<q;F++)if(!this.expr[F].evaluate(A))return!1;return!0}static d(A,F,q){const G=[];let Z=!1;for(const z of A)if(z){if(z.type===1){Z=!0;continue}if(z.type===0)return i.INSTANCE;if(z.type===6){G.push(...z.expr);continue}G.push(z)}if(G.length===0&&Z)return a.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(n);for(let z=1;z<G.length;z++)G[z-1].equals(G[z])&&(G.splice(z,1),z--);if(G.length===1)return G[0];for(;G.length>1;){const z=G[G.length-1];if(z.type!==9)break;G.pop();const Y=G.pop(),x=G.length===0,ae=U.create(z.expr.map(he=>K.create([he,Y],null,q)),null,x);ae&&(G.push(ae),G.sort(n))}if(G.length===1)return G[0];if(q){for(let z=0;z<G.length;z++)for(let Y=z+1;Y<G.length;Y++)if(G[z].negate().equals(G[Y]))return i.INSTANCE;if(G.length===1)return G[0]}return new K(G,F)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const F of this.expr)A.push(...F.keys());return A}map(A){return new K(this.expr.map(F=>F.map(A)),null)}negate(){if(!this.c){const A=[];for(const F of this.expr)A.push(F.negate());this.c=U.create(A,this,!0)}return this.c}}e.$Mi=K;class U{static create(A,F,q){return U.d(A,F,q)}constructor(A,F){this.expr=A,this.c=F,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let F=0,q=this.expr.length;F<q;F++){const G=n(this.expr[F],A.expr[F]);if(G!==0)return G}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let F=0,q=this.expr.length;F<q;F++)if(!this.expr[F].equals(A.expr[F]))return!1;return!0}return!1}substituteConstants(){const A=J(this.expr);return A===this.expr?this:U.create(A,this.c,!1)}evaluate(A){for(let F=0,q=this.expr.length;F<q;F++)if(this.expr[F].evaluate(A))return!0;return!1}static d(A,F,q){let G=[],Z=!1;if(A){for(let z=0,Y=A.length;z<Y;z++){const x=A[z];if(x){if(x.type===0){Z=!0;continue}if(x.type===1)return a.INSTANCE;if(x.type===9){G=G.concat(x.expr);continue}G.push(x)}}if(G.length===0&&Z)return i.INSTANCE;G.sort(n)}if(G.length!==0){if(G.length===1)return G[0];for(let z=1;z<G.length;z++)G[z-1].equals(G[z])&&(G.splice(z,1),z--);if(G.length===1)return G[0];if(q){for(let z=0;z<G.length;z++)for(let Y=z+1;Y<G.length;Y++)if(G[z].negate().equals(G[Y]))return a.INSTANCE;if(G.length===1)return G[0]}return new U(G,F)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const F of this.expr)A.push(...F.keys());return A}map(A){return new U(this.expr.map(F=>F.map(A)),null)}negate(){if(!this.c){const A=[];for(const F of this.expr)A.push(F.negate());for(;A.length>1;){const F=A.shift(),q=A.shift(),G=[];for(const Z of oe(F))for(const z of oe(q))G.push(K.create([Z,z],null,!1));A.unshift(U.create(G,null,!1))}this.c=U.create(A,this,!0)}return this.c}}e.$Ni=U;class T extends m{static{this.d=[]}static all(){return T.d.values()}constructor(A,F,q){super(A,null),this.f=F,typeof q=="object"?T.d.push({...q,key:A}):q!==!0&&T.d.push({key:A,description:q,type:F!=null?typeof F:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return P.create(this.key,A)}notEqualsTo(A){return M.create(this.key,A)}}e.$Oi=T,e.$Pi=(0,O.$ph)("contextKeyService");function W(j,A){return j<A?-1:j>A?1:0}function H(j,A,F,q){return j<F?-1:j>F?1:A<q?-1:A>q?1:0}function Q(j,A){if(j.type===0||A.type===1)return!0;if(j.type===9)return A.type===9?ce(j.expr,A.expr):!1;if(A.type===9){for(const F of A.expr)if(Q(j,F))return!0;return!1}if(j.type===6){if(A.type===6)return ce(A.expr,j.expr);for(const F of j.expr)if(Q(F,A))return!0;return!1}return j.equals(A)}e.$Qi=Q;function ce(j,A){let F=0,q=0;for(;F<j.length&&q<A.length;){const G=j[F].cmp(A[q]);if(G<0)return!1;G===0&&F++,q++}return F===j.length}function oe(j){return j.type===9?j.expr:[j]}}),define(te[76],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=void 0,e.$mn=(0,E.$ph)("credentialsService"),e.$nn=(0,E.$ph)("credentialsMainService");class C{constructor(){this.a={}}async getPassword(O,R){return this.a[O]?.[R]??null}async setPassword(O,R,S){this.a[O]=this.a[O]??{},this.a[O][R]=S}async deletePassword(O,R){return this.a[O]?.[R]?(delete this.a[O][R],Object.keys(this.a[O]).length===0&&delete this.a[O],!0):!1}async findPassword(O){return JSON.stringify(this.a[O])??null}async findCredentials(O){const R=[];for(const S of Object.keys(this.a[O]||{}))R.push({account:S,password:this.a[O][S]});return R}async clear(){this.a={}}}e.$on=C}),define(te[91],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=e.$5l=e.ID=void 0,e.ID="diagnosticsService",e.$5l=(0,E.$ph)(e.ID);function C(O){return!!O.hostName&&!!O.errorMessage}e.$6l=C;class r{async getPerformanceInfo(R,S){return{}}async getSystemInfo(R,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,S){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.$7l=r}),define(te[92],ie([0,1,19,70,164,6,46,4,37]),function(V,e,E,C,r,O,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bA=e.$aA=e.ConfirmResult=e.$_z=e.$$z=e.$0z=void 0,e.$0z=(0,O.$ph)("dialogService");var u;(function(y){y[y.Confirmation=1]="Confirmation",y[y.Prompt=2]="Prompt",y[y.Input=3]="Input"})(u||(u={}));class ${a(o){return this.d(o,u.Confirmation)}b(o){return this.d(o,u.Prompt)}c(o){return this.d(o,u.Input)}d(o,g){const c=[];switch(g){case u.Confirmation:{const b=o;b.primaryButton?c.push(b.primaryButton):c.push((0,r.localize)(0,null)),b.cancelButton?c.push(b.cancelButton):c.push((0,r.localize)(1,null));break}case u.Prompt:{const b=o;Array.isArray(b.buttons)&&b.buttons.length>0&&c.push(...b.buttons.map(k=>k.label)),b.cancelButton&&(b.cancelButton===!0?c.push((0,r.localize)(2,null)):typeof b.cancelButton=="string"?c.push(b.cancelButton):b.cancelButton.label?c.push(b.cancelButton.label):c.push((0,r.localize)(3,null))),c.length===0&&c.push((0,r.localize)(4,null));break}case u.Input:{const b=o;b.primaryButton?c.push(b.primaryButton):c.push((0,r.localize)(5,null)),b.cancelButton?c.push(b.cancelButton):c.push((0,r.localize)(6,null));break}}return c}e(o){if(typeof o=="string")return o;if(typeof o=="number")return o===C.default.Info?"info":o===C.default.Error?"error":o===C.default.Warning?"warning":"none"}async f(o,g,c){const b=[...o.buttons??[]];return o.cancelButton&&typeof o.cancelButton!="string"&&typeof o.cancelButton!="boolean"&&b.push(o.cancelButton),{result:await b[g]?.run({checkboxChecked:c}),checkboxChecked:c}}}e.$$z=$,e.$_z=(0,O.$ph)("fileDialogService");var d;(function(y){y[y.SAVE=0]="SAVE",y[y.DONT_SAVE=1]="DONT_SAVE",y[y.CANCEL=2]="CANCEL"})(d||(e.ConfirmResult=d={}));const p=10;function h(y){const o=[];return o.push(...y.slice(0,p).map(g=>typeof g=="string"?g:(0,E.$7f)(g))),y.length>p&&(y.length-p===1?o.push((0,r.localize)(7,null)):o.push((0,r.localize)(8,null,y.length-p))),o.push(""),o.join(`
`)}e.$aA=h;function v(y,o){const g=(0,f.$Hm)(y);let c=(g.buttons??[]).map(t=>(0,R.$7z)(t)),b=(y.buttons||[]).map((t,l)=>l),k=0,w=g.cancelId??c.length-1;if(c.length>1){const t=typeof w=="number"?c[w]:void 0;if(S.$k||S.$j){if(typeof t=="string"&&c.length>1&&w!==1){c.splice(w,1),c.splice(1,0,t);const l=b[w];b.splice(w,1),b.splice(1,0,l),w=1}S.$k&&c.length>1&&(c=c.reverse(),b=b.reverse(),k=c.length-1,typeof t=="string"&&(w=k-1))}else if(S.$i&&typeof t=="string"&&c.length>1&&w!==c.length-1){c.splice(w,1),c.push(t);const l=b[w];b.splice(w,1),b.push(l),w=c.length-1}}return g.buttons=c,g.defaultId=k,g.cancelId=w,g.noLink=!0,g.title=g.title||o.nameLong,{options:g,buttonIndeces:b}}e.$bA=v}),define(te[115],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mqb=e.$lqb=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$kqb=e.$jqb=void 0,e.$jqb=(0,E.$ph)("encryptionService"),e.$kqb=(0,E.$ph)("encryptionMainService");var C;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnome="gnome",S.gnomeKeyring="gnome-keyring",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(C||(e.PasswordStoreCLIOption=C={}));var r;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(r||(e.KnownStorageProvider=r={}));function O(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$lqb=O;function R(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$mqb=R}),define(te[33],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=void 0,e.$wh=(0,E.$ph)("environmentService"),e.$xh=(0,E.$qh)(e.$wh)}),define(te[116],ie([0,1,168,6]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Pn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=void 0,e.$Dn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$En=new RegExp(e.$Dn),e.$Fn="__web_extension",e.$Gn="skipWalkthrough",e.$Hn="extensionsSync";function r(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$In=r;function O(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Jn=O;function R(c,b){switch(c){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Kn=R;function S(c,b){return b==="web"&&!c.includes("web")}e.$Ln=S;function f(c,b,k){return S(b,k)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===k?!0:u(k).includes(c)}e.$Mn=f;function u(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Nn=u;function $(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$On=$;var d;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(d||(e.SortBy=d={}));var p;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var h;(function(c){c.Install="install",c.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var v;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$Pn=(0,C.$ph)("extensionGalleryService");var y;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var o;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(o||(e.ExtensionSignaturetErrorCode=o={}));class g extends Error{constructor(b,k){super(b),this.code=k,this.name=k}}e.$Qn=g,e.$Rn=(0,C.$ph)("extensionManagementService"),e.$Sn="extensionsIdentifiers/disabled",e.$Tn="extensionsIdentifiers/enabled",e.$Un=(0,C.$ph)("IGlobalExtensionEnablementService"),e.$Vn=(0,C.$ph)("IExtensionTipsService"),e.$Wn=(0,E.localize)(0,null),e.$Xn={value:e.$Wn,original:"Extensions"},e.$Yn={value:(0,E.localize)(1,null),original:"Preferences"}}),define(te[207],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjb=void 0,e.$sjb=(0,E.$ph)("extensionUrlTrustService")}),define(te[208],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U3b=e.$T3b=void 0,e.$T3b=(0,E.$ph)("extensionHostStarter"),e.$U3b="extensionHostStarter"}),define(te[117],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qVb=e.$pVb=e.$oVb=void 0,e.$oVb=(0,E.$ph)("externalTerminal"),e.$pVb="Terminal.app",e.$qVb=(0,E.$ph)("externalTerminal")}),define(te[209],ie([0,1,47,15,9,4,73,21,89,172,117]),function(V,e,E,C,r,O,R,S,f,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y3b=e.$X3b=e.$W3b=void 0;const d=u.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await y.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends p{static{this.b="cmd.exe"}openTerminal(k,w){return this.spawnTerminal(E,k,f.$hl(),w)}spawnTerminal(k,w,t,l){const s=w.windowsExec||h.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const n=r.$ec(s,".exe").toLowerCase();if(n==="cmder")return k.spawn(s,l?[l]:void 0),Promise.resolve(void 0);const i=["/c","start","/wait"];return s.indexOf(" ")>=0&&i.push('""'),i.push(s),n==="wt"&&i.push("-d ."),new Promise((a,m)=>{const P=o(process),I=k.spawn(t,i,{cwd:l,env:P});I.on("error",m),I.on("exit",()=>a())})}runInTerminal(k,w,t,l,s){const n="windowsExec"in s&&s.windowsExec?s.windowsExec:h.getDefaultTerminalWindows();return new Promise((i,a)=>{const m=`"${w} - ${d}"`,P=`""${t.join('" "')}" & pause"`,I=Object.assign({},o(process),l);Object.keys(I).filter(B=>I[B]===null).forEach(B=>delete I[B]);const D={cwd:w,env:I,windowsVerbatimArguments:!0};let M,L;r.$ec(n,".exe")==="wt"?(M=n,L=["-d",".",h.b,"/c",P]):(M=h.b,L=["/c","start",m,"/wait",n,"/c",P]),E.spawn(M,L,D).on("error",B=>{a(g(B))}),i(void 0)})}static getDefaultTerminalWindows(){if(!h.d){const k=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${k?"Sysnative":"System32"}\\cmd.exe`}return h.d}}e.$W3b=h;class v extends p{static{this.b="/usr/bin/osascript"}openTerminal(k,w){return this.spawnTerminal(E,k,w)}runInTerminal(k,w,t,l,s){const n=s.osxExec||$.$pVb;return new Promise((i,a)=>{if(n===$.$pVb||n==="iTerm.app"){const m=n===$.$pVb?"TerminalHelper":"iTermHelper",I=[C.$4e.asFileUri(`vs/workbench/contrib/externalTerminal/node/${m}.scpt`).fsPath,"-t",k||d,"-w",w];for(const L of t)I.push("-a"),I.push(L);if(l){const L=Object.assign({},o(process),l);for(const N in L){const B=L[N];B===null?(I.push("-u"),I.push(N)):(I.push("-e"),I.push(`${N}=${B}`))}}let D="";const M=E.spawn(v.b,I);M.on("error",L=>{a(g(L))}),M.stderr.on("data",L=>{D+=L.toString()}),M.on("exit",L=>{if(L===0)i(void 0);else if(D){const N=D.split(`
`,1);a(new Error(N[0]))}else a(new Error(u.localize(1,null,m,L)))})}else a(new Error(u.localize(2,null,n)))})}spawnTerminal(k,w,t){const l=w.osxExec||$.$pVb;return new Promise((s,n)=>{const i=["-a",l];t&&i.push(t);const a=o(process),m=k.spawn("/usr/bin/open",i,{cwd:t,env:a});m.on("error",n),m.on("exit",()=>s())})}}e.$X3b=v;class y extends p{static{this.b=u.localize(3,null)}openTerminal(k,w){return this.spawnTerminal(E,k,w)}runInTerminal(k,w,t,l,s){const n=s.linuxExec?Promise.resolve(s.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((i,a)=>{const m=[];n.then(P=>{P.indexOf("gnome-terminal")>=0?m.push("-x"):m.push("-e"),m.push("bash"),m.push("-c");const I=`${c(t)}; echo; read -p "${y.b}" -n1;`;m.push(`''${I}''`);const D=Object.assign({},o(process),l);Object.keys(D).filter(B=>D[B]===null).forEach(B=>delete D[B]);const M={cwd:w,env:D};let L="";const N=E.spawn(P,m,M);N.on("error",B=>{a(g(B))}),N.stderr.on("data",B=>{L+=B.toString()}),N.on("exit",B=>{if(B===0)i(void 0);else if(L){const re=L.split(`
`,1);a(new Error(re[0]))}else a(new Error(u.localize(4,null,P,B)))})})})}static async getDefaultTerminalLinuxReady(){if(!y.d)if(!O.$k)y.d=Promise.resolve("xterm");else{const k=await S.Promises.exists("/etc/debian_version");y.d=new Promise(w=>{k?w("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?w("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?w("konsole"):process.env.COLORTERM?w(process.env.COLORTERM):process.env.TERM?w(process.env.TERM):w("xterm")})}return y.d}spawnTerminal(k,w,t){const l=w.linuxExec?Promise.resolve(w.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{l.then(i=>{const a=o(process),m=k.spawn(i,[],{cwd:t,env:a});m.on("error",n),m.on("exit",()=>s())})})}}e.$Y3b=y;function o(b){const k={...b.env};return(0,R.$fl)(k),k}function g(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(u.localize(5,null,b.path)):b}function c(b){let k="";for(const w of b)w.indexOf(" ")>=0?k+='"'+w+'"':k+=w,k+=" ";return k}}),define(te[16],ie([0,1,58,9,25,10,7,174,6,4,15]),function(V,e,E,C,r,O,R,S,f,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileKind=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileOperationResult=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileChangeType=e.$0j=e.FileOperation=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.FileSystemProviderErrorCode=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tj=e.$Sj=void 0,e.$Sj=(0,f.$ph)("fileService");function d(W){return W.create===!0}e.$Tj=d;var p;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var h;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var v;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(v||(e.FileSystemProviderCapabilities=v={}));function y(W){return!!(W.capabilities&2)}e.$Uj=y;function o(W){return!!(W.capabilities&8)}e.$Vj=o;function g(W){return!!(W.capabilities&131072)}e.$Wj=g;function c(W){return!!(W.capabilities&4)}e.$Xj=c;function b(W){return!!(W.capabilities&16)}e.$Yj=b;function k(W){return y(W)?!!(W.capabilities&16384):!1}e.$Zj=k;function w(W){return y(W)?!!(W.capabilities&32768):!1}e.$1j=w;function t(W){return!!(W.capabilities&65536)}e.$2j=t;function l(W){return!!(W.capabilities&2048)}e.$3j=l;var s;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class n extends Error{static create(H,Q){const ce=new n(H.toString(),Q);return m(ce,Q),ce}constructor(H,Q){super(H),this.code=Q}}e.$4j=n;function i(W,H){return n.create(W,H)}e.$5j=i;function a(W){return W||i((0,S.localize)(0,null),s.Unknown)}e.$6j=a;function m(W,H){return W.name=H?`${H} (FileSystemError)`:"FileSystemError",W}e.$7j=m;function P(W){if(!W)return s.Unknown;if(W instanceof n)return W.code;const H=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!H)return s.Unknown;switch(H[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$8j=P;function I(W){if(W instanceof re)return W.fileOperationResult;switch(P(W)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$9j=I;var D;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class M{constructor(H,Q,ce){this.resource=H,this.operation=Q,this.target=ce}isOperation(H){return this.operation===H}}e.$0j=M;var L;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class N{constructor(H,Q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const oe of H){const j=ce.get(oe.type);switch(j?j.push([oe.resource,oe]):ce.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,j]of ce)switch(oe){case 1:this.a=E.$vh.forUris(()=>Q),this.a.fill(j);break;case 0:this.b=E.$vh.forUris(()=>Q),this.b.fill(j);break;case 2:this.c=E.$vh.forUris(()=>Q),this.c.fill(j);break}}contains(H,...Q){return this.d(H,{includeChildren:!1},...Q)}affects(H,...Q){return this.d(H,{includeChildren:!0},...Q)}d(H,Q,...ce){if(!H)return!1;const oe=ce.length>0;return!!((!oe||ce.includes(1))&&(this.a?.get(H)||Q.includeChildren&&this.a?.findSuperstr(H))||(!oe||ce.includes(0))&&(this.b?.get(H)||Q.includeChildren&&this.b?.findSuperstr(H))||(!oe||ce.includes(2))&&(this.c?.findSubstr(H)||Q.includeChildren&&this.c?.findSuperstr(H)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$$j=N;function B(W,H,Q){return!W||!H||W===H||H.length>W.length?!1:(H.charAt(H.length-1)!==C.sep&&(H+=C.sep),Q?(0,r.$Nd)(W,H):W.indexOf(H)===0)}e.$_j=B;class re extends Error{constructor(H,Q,ce){super(H),this.fileOperationResult=Q,this.options=ce}}e.$ak=re;class ne extends re{constructor(H,Q,ce,oe){super(H,Q,oe),this.fileOperationResult=Q,this.size=ce}}e.$bk=ne;class ue extends re{constructor(H,Q,ce){super(H,2,ce),this.stat=Q}}e.$ck=ue;var se;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(se||(e.FileOperationResult=se={})),e.$dk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ek={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$fk="files.associations",e.$gk="files.exclude",e.$hk="files.readonlyInclude",e.$ik="files.readonlyExclude",e.$jk="files.readonlyFromPermissions";var le;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(e.FileKind=le={})),e.$kk="";function J(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.$lk=J;async function K(W,H){if(!H.hasProvider(R.URI.from({scheme:W.scheme})))return new Promise(Q=>{const ce=H.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===W.scheme&&oe.added&&(ce.dispose(),Q())})})}e.$mk=K;class U{static{this.KB=1024}static{this.MB=U.KB*U.KB}static{this.GB=U.MB*U.KB}static{this.TB=U.GB*U.KB}static formatSize(H){return(0,O.$ne)(H)||(H=0),H<U.KB?(0,S.localize)(1,null,H.toFixed(0)):H<U.MB?(0,S.localize)(2,null,(H/U.KB).toFixed(2)):H<U.GB?(0,S.localize)(3,null,(H/U.MB).toFixed(2)):H<U.TB?(0,S.localize)(4,null,(H/U.GB).toFixed(2)):(0,S.localize)(5,null,(H/U.TB).toFixed(2))}}e.$nk=U;function T(W){const H=typeof W=="string"||W?.scheme===$.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===$.Schemas.file?1024*U.MB:H?10*U.MB:u.$o?50*U.MB:1024*U.MB}e.$ok=T}),define(te[210],ie([0,1,17,50,13,3,2,56,7,31,16]),function(V,e,E,C,r,O,R,S,f,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JM=e.$IM=void 0,e.$IM="localFilesystem";class d extends R.$lb{constructor(h,v){super(),this.a=h,this.b=v,this.onDidChangeCapabilities=O.Event.None,this.f=this.B(new O.$8c),this.onDidChangeFile=this.f.event,this.g=this.B(new O.$8c),this.onDidWatchError=this.g.event,this.h=(0,u.$6e)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,v){const{buffer:y}=await this.a.call("readFile",[h,v]);return y}readFileStream(h,v,y){const o=(0,S.$xb)(c=>E.$Jb.concat(c.map(b=>E.$Jb.wrap(b))).buffer),g=this.a.listen("readFileStream",[h,v])(c=>{if(c instanceof E.$Jb)o.write(c.buffer);else{if(c==="end")o.end();else{let b;if(c instanceof Error)b=c;else{const k=c;b=(0,$.$5j)(k.message??(0,C.$ai)(k),k.code??$.FileSystemProviderErrorCode.Unknown)}o.error(b),o.end()}g.dispose()}});return y.onCancellationRequested(()=>{o.error((0,r.$4)()),o.end(),g.dispose()}),o}writeFile(h,v,y){return this.a.call("writeFile",[h,E.$Jb.wrap(v),y])}open(h,v){return this.a.call("open",[h,v])}close(h){return this.a.call("close",[h])}async read(h,v,y,o,g){const[c,b]=await this.a.call("read",[h,v,g]);return y.set(c.buffer.slice(0,b),o),b}write(h,v,y,o,g){return this.a.call("write",[h,v,E.$Jb.wrap(y),o,g])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,v){return this.a.call("delete",[h,v])}rename(h,v,y){return this.a.call("rename",[h,v,y])}copy(h,v,y){return this.a.call("copy",[h,v,y])}cloneFile(h,v){return this.a.call("cloneFile",[h,v])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const v=h;this.f.fire(v.map(y=>({resource:f.URI.revive(y.resource),type:y.type})))}else{const v=h;this.g.fire(v)}}))}watch(h,v){const y=(0,u.$6e)();return this.a.call("watch",[this.h,y,h,v]),(0,R.$jb)(()=>this.a.call("unwatch",[this.h,y]))}}e.$JM=d}),define(te[118],ie([0,1,17,13,175,16]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=void 0;async function R($,d,p,h,v,y){let o;try{await S($,d,p,h,v,y)}catch(g){o=g}finally{o&&v.errorTransformer&&(o=v.errorTransformer(o)),typeof o<"u"&&p.error(o),p.end()}}e.$rp=R;async function S($,d,p,h,v,y){f(y);const o=await $.open(d,{create:!1});try{f(y);let g=0,c=0,b=v&&typeof v.length=="number"?v.length:void 0,k=E.$Jb.alloc(Math.min(v.bufferSize,typeof b=="number"?b:v.bufferSize)),w=v&&typeof v.position=="number"?v.position:0,t=0;do c=await $.read(o,w,k.buffer,t,k.byteLength-t),w+=c,t+=c,g+=c,typeof b=="number"&&(b-=c),t===k.byteLength&&(await p.write(h(k)),k=E.$Jb.alloc(Math.min(v.bufferSize,typeof b=="number"?b:v.bufferSize)),t=0);while(c>0&&(typeof b!="number"||b>0)&&f(y)&&u(g,v));if(t>0){let l=t;typeof b=="number"&&(l=Math.min(t,b)),p.write(h(k.slice(0,l)))}}catch(g){throw(0,O.$6j)(g)}finally{await $.close(o)}}function f($){if($.isCancellationRequested)throw(0,C.$4)();return!0}function u($,d){if(typeof d?.limits?.size=="number"&&$>d.limits.size)throw(0,O.$5j)((0,r.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[77],ie([0,1,104,2,9,4,7,16]),function(V,e,E,C,r,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=void 0;function f(g){return g.recursive===!0}e.$tp=f;class u extends C.$lb{static{this.a=5}constructor(c,b,k,w){super(),this.h=c,this.i=b,this.j=k,this.k=w,this.c=this.B(new C.$mb),this.f=void 0,this.g=0}m(){const c=new C.$kb;this.c.value=c,this.b=this.l(c),this.b.setVerboseLogging(this.j),c.add(this.b.onDidChangeFile(b=>this.h(b))),c.add(this.b.onDidLogMessage(b=>this.i(b))),c.add(this.b.onDidError(b=>this.n(b)))}n(c){this.k.restartOnError?this.g<u.a&&this.f?(this.r(`restarting watcher after error: ${c}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${c}`):this.r(c)}p(c){this.g++,this.m(),this.watch(c)}async watch(c){this.f=c,await this.b?.watch(c)}async setVerboseLogging(c){this.j=c,await this.b?.setVerboseLogging(c)}r(c){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${c}`})}s(c){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${c}`})}dispose(){return this.b=void 0,super.dispose()}}e.$up=u;class $ extends u{constructor(c,b,k){super(c,b,k,{type:"node.js",restartOnError:!1})}}e.$vp=$;class d extends u{constructor(c,b,k){super(c,b,k,{type:"universal",restartOnError:!0})}}e.$wp=d;function p(g){return g.map(c=>({type:c.type,resource:R.URI.file(c.path)}))}e.$xp=p;function h(g){const c=new o;for(const b of g)c.processEvent(b);return c.coalesce()}e.$yp=h;function v(g,c){return typeof c=="string"&&!c.startsWith(E.$aj)&&!(0,r.$_b)(c)?{base:g,pattern:c}:c}e.$zp=v;function y(g,c){const b=[];for(const k of c)b.push((0,E.$ej)(v(g,k)));return b}e.$Ap=y;class o{constructor(){this.a=new Set,this.b=new Map}c(c){return O.$k?c.path:c.path.toLowerCase()}processEvent(c){const b=this.b.get(this.c(c));let k=!1;if(b){const w=b.type,t=c.type;b.path!==c.path&&(c.type===2||c.type===1)?k=!0:w===1&&t===2?(this.b.delete(this.c(c)),this.a.delete(b)):w===2&&t===1?b.type=0:w===1&&t===0||(b.type=t)}else k=!0;k&&(this.a.add(c),this.b.set(this.c(c),c))}coalesce(){const c=[],b=[];return Array.from(this.a).filter(k=>k.type!==2?(c.push(k),!1):!0).sort((k,w)=>k.path.length-w.path.length).filter(k=>b.some(w=>(0,S.$_j)(k.path,w,!O.$k))?!1:(b.push(k.path),!0)).concat(c)}}}),define(te[211],ie([0,1,45,8,22,32,2,86,9,4,105,21,77]),function(V,e,E,C,r,O,R,S,f,u,$,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0;class h extends R.$lb{static{this.a=100}static{this.b=75}constructor(o,g,c,b){super(),this.j=o,this.k=g,this.l=c,this.m=b,this.c=this.B(new C.$Jg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},k=>this.k(k))),this.f=this.B(new C.$Ig(k=>this.u(k),h.b)),this.g=(0,p.$Ap)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,p.$Ap)(this.j.path,this.j.includes):void 0,this.i=new r.$ed,this.ready=this.n()}async n(){try{const o=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const g=await d.Promises.stat(o);this.B(await this.s(o,g.isDirectory()))}catch(o){o.code!=="ENOENT"?this.w(o):this.z(o)}}async r(o){let g=o.path;try{g=await d.Promises.realpath(o.path),o.path===g&&(g=await(0,$.$Kp)(o.path)??o.path),o.path!==g&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${g})`)}catch{}return g}async s(o,g){if(u.$j&&(0,O.$Ke)(o,"/Volumes/",!0))return this.w(`Refusing to watch ${o} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$lb.None;const c=new r.$ed(this.i.token),b=new R.$kb;try{const k=(0,f.$ec)(o),w=(0,E.watch)(o);b.add((0,R.$jb)(()=>{w.removeAllListeners(),w.close()})),this.z(`Started watching: '${o}'`);const t=new Set;if(g)try{for(const s of await d.Promises.readdir(o))t.add(s)}catch(s){this.w(s)}const l=new Map;b.add((0,R.$jb)(()=>{for(const[,s]of l)s.dispose();l.clear()})),w.on("error",(s,n)=>{this.w(`Failed to watch ${o} for changes using fs.watch() (${s}, ${n})`),this.dispose()}),w.on("change",(s,n)=>{if(c.token.isCancellationRequested)return;this.z(`[raw] ["${s}"] ${n}`);let i="";if(n&&(i=n.toString(),u.$j&&(i=(0,S.$7k)(i))),!(!i||s!=="change"&&s!=="rename"))if(g)if(s==="rename"){l.get(i)?.dispose();const a=setTimeout(async()=>{if(l.delete(i),i===k&&!await d.Promises.exists(o)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const m=await this.v((0,f.$ac)(o,i));if(c.token.isCancellationRequested)return;let P;m?t.has(i)?P=0:(P=1,t.add(i)):(t.delete(i),P=2),this.t({path:(0,f.$ac)(this.j.path,i),type:P})},h.a);l.set(i,(0,R.$jb)(()=>clearTimeout(a)))}else{let a;t.has(i)?a=0:(a=1,t.add(i)),this.t({path:(0,f.$ac)(this.j.path,i),type:a})}else if(s==="rename"||i!==k){const a=setTimeout(async()=>{const m=await d.Promises.exists(o);c.token.isCancellationRequested||(m?(this.t({path:this.j.path,type:0},!0),b.add(await this.s(o,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},h.a);b.clear(),b.add((0,R.$jb)(()=>clearTimeout(a)))}else this.t({path:this.j.path,type:0},!0)})}catch(k){await d.Promises.exists(o)&&!c.token.isCancellationRequested&&this.w(`Failed to watch ${o} for changes using fs.watch() (${k.toString()})`)}return(0,R.$jb)(()=>{c.dispose(!0),b.dispose()})}t(o,g=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`),!g&&this.g.some(c=>c(o.path))?this.m&&this.z(` >> ignored (excluded) ${o.path}`):!g&&this.h&&this.h.length>0&&!this.h.some(c=>c(o.path))?this.m&&this.z(` >> ignored (not included) ${o.path}`):this.f.work(o))}u(o){const g=(0,p.$yp)(o);if(g.length>0){if(this.m)for(const b of g)this.z(`>> normalized ${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`);this.c.work(g)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(o){if(u.$k)return d.Promises.exists(o);try{const g=(0,f.$ec)(o);return(await d.Promises.readdir((0,f.$dc)(o))).some(b=>b===g)}catch(g){return this.z(g),!1}}setVerboseLogging(o){this.m=o}w(o){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${o}`})}y(o){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${o}`})}z(o){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${o}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Np=h;async function v(y,o,g,c,b=512){const k=await d.Promises.open(y,"r"),w=Buffer.allocUnsafe(b),t=new r.$ed(c);let l,s=!1;const n={path:y,excludes:[],recursive:!1},i=new h(n,a=>{(async()=>{for(const{type:m}of a)if(m===0){if(s)return;s=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:P}=await d.Promises.read(k,w,0,b,null);if(!P||t.token.isCancellationRequested)break;o(w.slice(0,P))}}catch(P){l=new Error(P),t.dispose(!0)}finally{s=!1}}})()});return await i.ready,g(),new Promise((a,m)=>{t.token.onCancellationRequested(async()=>{i.dispose();try{await d.Promises.close(k)}catch(P){l=new Error(P)}l?m(l):a()})})}e.$Op=v}),define(te[212],ie([0,1,3,104,2,4,211]),function(V,e,E,C,r,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;class S extends r.$lb{constructor(){super(...arguments),this.a=this.B(new E.$8c),this.onDidChangeFile=this.a.event,this.b=this.B(new E.$8c),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(u){const $=this.i(u),d=$.filter(h=>{const v=this.c.get(h.path);return v?!(0,C.$ij)(v.request.excludes,h.excludes)||!(0,C.$ij)(v.request.includes,h.includes):!0}),p=Array.from(this.c.values()).filter(({request:h})=>!$.find(v=>v.path===h.path&&(0,C.$ij)(v.excludes,h.excludes)&&(0,C.$ij)(v.includes,h.includes))).map(({request:h})=>h.path);d.length&&this.j(`Request to start watching: ${d.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const h of p)this.h(h);for(const h of d)this.g(h)}g(u){const $=new R.$Np(u,p=>this.a.fire(p),p=>this.b.fire(p),this.f),d={request:u,instance:$};this.c.set(u.path,d)}async stop(){for(const[u]of this.c)this.h(u);this.c.clear()}h(u){const $=this.c.get(u);$&&(this.c.delete(u),$.instance.dispose())}i(u){const $=new Map;for(const d of u){const p=O.$k?d.path:d.path.toLowerCase();$.set(p,d)}return Array.from($.values())}async setVerboseLogging(u){this.f=u;for(const[,$]of this.c)$.instance.setVerboseLogging(u)}j(u){this.f&&this.b.fire({type:"trace",message:this.k(u)})}k(u,$){return $?`[File Watcher (node.js)] ${u} (path: ${$.request.path})`:`[File Watcher (node.js)] ${u}`}}e.$Pp=S}),define(te[213],ie([0,1,77,212]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;class r extends E.$vp{constructor(R,S,f){super(R,S,f),this.m()}l(){return new C.$Pp}}e.$Qp=r}),define(te[214],ie([0,1,15,42,158,77]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;class R extends O.$wp{constructor(f,u,$){super(f,u,$),this.m()}l(f){const u=f.add(new r.$Hp(E.$4e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(u.onDidProcessExit(({code:$,signal:d})=>this.n(`terminated by itself with code ${$}, signal: ${d}`))),C.ProxyChannel.toService((0,C.$9g)(u.getChannel("watcher")))}}e.$Ip=R}),define(te[93],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=void 0;class E{constructor(...r){this.a=new Map;for(const[O,R]of r)this.set(O,R)}set(r,O){const R=this.a.get(r);return this.a.set(r,O),R}has(r){return this.a.has(r)}get(r){return this.a.get(r)}}e.$nh=E}),define(te[215],ie([0,1,8,13,2,75,206,6,93,101]),function(V,e,E,C,r,O,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0;const $=!1;class d extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class p{constructor(o=new f.$nh,g=!1,c,b=$){this.f=o,this.g=g,this.h=c,this.i=b,this.o=new Set,this.f.set(S.$oh,this),this._globalGraph=b?c?._globalGraph??new R.$Tp(k=>k):void 0}createChild(o){return new p(o,this.g,this,this.i)}invokeFunction(o,...g){const c=v.traceInvocation(this.i,o);let b=!1;try{return o({get:w=>{if(b)throw(0,C.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(w,c);if(!t)throw new Error(`[invokeFunction] unknown service '${w}'`);return t}},...g)}finally{b=!0,c.stop()}}createInstance(o,...g){let c,b;return o instanceof O.$mh?(c=v.traceCreation(this.i,o.ctor),b=this.j(o.ctor,o.staticArguments.concat(g),c)):(c=v.traceCreation(this.i,o),b=this.j(o,g,c)),c.stop(),b}j(o,g=[],c){const b=S._util.getServiceDependencies(o).sort((t,l)=>t.index-l.index),k=[];for(const t of b){const l=this.m(t.id,c);l||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),k.push(l)}const w=b.length>0?b[0].index:g.length;if(g.length!==w){console.trace(`[createInstance] First service dependency of ${o.name} at position ${w+1} conflicts with ${g.length} static arguments`);const t=w-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,w)}return Reflect.construct(o,g.concat(k))}k(o,g){if(this.f.get(o)instanceof O.$mh)this.f.set(o,g);else if(this.h)this.h.k(o,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const g=this.f.get(o);return!g&&this.h?this.h.l(o):g}m(o,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const c=this.l(o);return c instanceof O.$mh?this.q(o,c,g.branch(o,!0)):(g.branch(o,!1),c)}q(o,g,c){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,g,c)}finally{this.o.delete(o)}}r(o,g,c){const b=new R.$Tp(t=>t.id.toString());let k=0;const w=[{id:o,desc:g,_trace:c}];for(;w.length;){const t=w.pop();if(b.lookupOrInsertNode(t),k++>1e3)throw new d(b);for(const l of S._util.getServiceDependencies(t.desc.ctor)){const s=this.l(l.id);if(s||this.u(`[createInstance] ${o} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),s instanceof O.$mh){const n={id:l.id,desc:s,_trace:t._trace.branch(l.id,!0)};b.insertEdge(t,n),w.push(n)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new d(b);break}for(const{data:l}of t){if(this.l(l.id)instanceof O.$mh){const n=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,n)}b.removeNode(l)}}return this.l(o)}s(o,g,c=[],b,k){if(this.f.get(o)instanceof O.$mh)return this.t(o,g,c,b,k);if(this.h)return this.h.s(o,g,c,b,k);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t(o,g,c=[],b,k){if(b){const w=new p(void 0,this.g,this,this.i);w.c=String(o);const t=new Map,l=new E.$Lg(()=>{const s=w.j(g,c,k);for(const[n,i]of t){const a=s[n];if(typeof a=="function")for(const m of i)a.apply(s,m)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,n){if(!l.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let m=t.get(n);return m||(m=new u.$lc,t.set(n,m)),(I,D,M)=>{const L=m.push([I,D,M]);return(0,r.$jb)(L)}}if(n in s)return s[n];const i=l.value;let a=i[n];return typeof a!="function"||(a=a.bind(i),s[n]=a),a},set(s,n,i){return l.value[n]=i,!0},getPrototypeOf(s){return g.prototype}})}else return this.j(g,c,k)}u(o,g){if(g&&console.warn(o),this.g)throw new Error(o)}}e.$Up=p;var h;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(h||(h={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,g){return o?new v(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(o,g){return o?new v(1,g.name):v.c}static{this.f=0}constructor(o,g){this.type=o,this.name=g,this.g=Date.now(),this.h=[]}branch(o,g){const c=new v(3,o.toString());return this.h.push([o,g,c]),c}stop(){const o=Date.now()-this.g;v.f+=o;let g=!1;function c(k,w){const t=[],l=new Array(k+1).join("	");for(const[s,n,i]of w.h)if(n&&i){g=!0,t.push(`${l}CREATES -> ${s}`);const a=c(k+1,i);a&&t.push(a)}else t.push(`${l}uses -> ${s}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(o>2||g)&&v.all.add(b.join(`
`))}}e.$Vp=v}),define(te[216],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vrb=e.IssueType=void 0;var C;(function(r){r[r.Bug=0]="Bug",r[r.PerformanceIssue=1]="PerformanceIssue",r[r.FeatureRequest=2]="FeatureRequest"})(C||(e.IssueType=C={})),e.$vrb=(0,E.$ph)("issueService")}),define(te[5],ie([0,1,50,3,57,2,35,4,19,10,7,114,6]),function(V,e,E,C,r,O,R,S,f,u,$,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.log=e.$Ui=e.LogLevel=e.$Ti=e.$Si=e.$Ri=void 0,e.$Ri=(0,p.$ph)("logService"),e.$Si=(0,p.$ph)("loggerService");function h(){return new Date().toISOString()}function v(I){return(0,u.$ne)(I)}e.$Ti=v;var y;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$Ui=y.Info;function o(I,D,M){switch(D){case y.Trace:I.trace(M);break;case y.Debug:I.debug(M);break;case y.Info:I.info(M);break;case y.Warning:I.warn(M);break;case y.Error:I.error(M);break;case y.Off:break;default:throw new Error(`Invalid log level ${D}`)}}e.log=o;function g(I,D=!1){let M="";for(let L=0;L<I.length;L++){let N=I[L];if(N instanceof Error&&(N=(0,E.$ai)(N,D)),typeof N=="object")try{N=JSON.stringify(N)}catch{}M+=(L>0?" ":"")+N}return M}class c extends O.$lb{constructor(){super(...arguments),this.b=e.$Ui,this.c=this.B(new C.$8c),this.onDidChangeLogLevel=this.c.event}setLevel(D){this.b!==D&&(this.b=D,this.c.fire(this.b))}getLevel(){return this.b}f(D){return this.b!==y.Off&&this.b<=D}}e.$Wi=c;class b extends c{constructor(D){super(),this.h=D}f(D){return this.h||super.f(D)}trace(D,...M){this.f(y.Trace)&&this.g(y.Trace,g([D,...M],!0))}debug(D,...M){this.f(y.Debug)&&this.g(y.Debug,g([D,...M]))}info(D,...M){this.f(y.Info)&&this.g(y.Info,g([D,...M]))}warn(D,...M){this.f(y.Warning)&&this.g(y.Warning,g([D,...M]))}error(D,...M){if(this.f(y.Error))if(D instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=D.stack,this.g(y.Error,g(L))}else this.g(y.Error,g([D,...M]))}flush(){}}e.$Xi=b;class k extends c{constructor(D=e.$Ui){super(),this.setLevel(D),this.g=!S.$i}trace(D,...M){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,D,...M):console.log(`[main ${h()}]`,D,...M))}debug(D,...M){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,D,...M):console.log(`[main ${h()}]`,D,...M))}info(D,...M){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,D,...M):console.log(`[main ${h()}]`,D,...M))}warn(D,...M){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,D,...M):console.warn(`[main ${h()}]`,D,...M))}error(D,...M){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,D,...M):console.error(`[main ${h()}]`,D,...M))}dispose(){}flush(){}}e.$Yi=k;class w extends c{constructor(D=e.$Ui,M=!0){super(),this.g=M,this.setLevel(D)}trace(D,...M){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",D,...M):console.log(D,...M))}debug(D,...M){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",D,...M):console.log(D,...M))}info(D,...M){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",D,...M):console.log(D,...M))}warn(D,...M){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",D,...M):console.log(D,...M))}error(D,...M){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",D,...M):console.error(D,...M))}dispose(){}flush(){}}e.$Zi=w;class t extends c{constructor(D,M=e.$Ui){super(),this.g=D,this.setLevel(M)}trace(D,...M){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(D),...M])}debug(D,...M){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(D),...M])}info(D,...M){this.f(y.Info)&&this.g.log(y.Info,[this.h(D),...M])}warn(D,...M){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(D),...M])}error(D,...M){this.f(y.Error)&&this.g.log(y.Error,[this.h(D),...M])}h(D){return typeof D=="string"?D:(0,E.$ai)(D,this.f(y.Trace))}dispose(){}flush(){}}e.$1i=t;class l extends c{constructor(D){super(),this.g=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const M of this.g)M.setLevel(D);super.setLevel(D)}trace(D,...M){for(const L of this.g)L.trace(D,...M)}debug(D,...M){for(const L of this.g)L.debug(D,...M)}info(D,...M){for(const L of this.g)L.info(D,...M)}warn(D,...M){for(const L of this.g)L.warn(D,...M)}error(D,...M){for(const L of this.g)L.error(D,...M)}flush(){for(const D of this.g)D.flush()}dispose(){for(const D of this.g)D.dispose()}}e.$2i=l;class s extends O.$lb{constructor(D,M,L){if(super(),this.h=D,this.j=M,this.b=new R.$ni,this.c=this.B(new C.$8c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$8c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$8c),this.onDidChangeVisibility=this.g.event,L)for(const N of L)this.b.set(N.resource,{logger:void 0,info:N})}k(D){return(0,u.$je)(D)?[...this.b.values()].find(M=>M.info.id===D):this.b.get(D)}getLogger(D){return this.k(D)?.logger}createLogger(D,M){const L=this.l(D),N=(0,u.$je)(D)?D:M?.id??(0,r.$di)(L.toString()).toString(16);let B=this.b.get(L)?.logger;const re=M?.logLevel==="always"?y.Trace:M?.logLevel;B||(B=this.m(L,re??this.getLogLevel(L)??this.h,{...M,id:N}));const ne={logger:B,info:{resource:L,id:N,logLevel:re,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(ne.info),this.b.set(L,ne),B}l(D){return(0,u.$je)(D)?(0,f.$0f)(this.j,`${D}.log`):D}setLogLevel(D,M){if($.URI.isUri(D)){const L=D,N=M,B=this.b.get(L);B&&N!==B.info.logLevel&&(B.info.logLevel=N===this.h?void 0:N,B.logger?.setLevel(N),this.b.set(B.info.resource,B),this.f.fire([L,N]))}else{this.h=D;for(const[L,N]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(D,M){const L=this.k(D);L&&M!==!L.info.hidden&&(L.info.hidden=!M,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,M]))}getLogLevel(D){let M;return D&&(M=this.b.get(D)?.info.logLevel),M??this.h}registerLogger(D){const M=this.b.get(D.resource);M?M.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this.b.set(D.resource,{info:D,logger:void 0}),this.c.fire({added:[D],removed:[]}))}deregisterLogger(D){const M=this.b.get(D);M&&(M.logger&&M.logger.dispose(),this.b.delete(D),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const D of this.b.values())yield D.info}getRegisteredLogger(D){return this.b.get(D)?.info}dispose(){this.b.forEach(D=>D.logger?.dispose()),this.b.clear(),super.dispose()}}e.$3i=s;class n{constructor(){this.onDidChangeLogLevel=new C.$8c().event}setLevel(D){}getLevel(){return y.Info}trace(D,...M){}debug(D,...M){}info(D,...M){}warn(D,...M){}error(D,...M){}critical(D,...M){}dispose(){}flush(){}}e.$4i=n;class i extends n{}e.$5i=i;function a(I){if(I.verbose)return y.Trace;if(typeof I.logLevel=="string"){const D=P(I.logLevel.toLowerCase());if(D!==void 0)return D}return e.$Ui}e.$6i=a;function m(I){switch(I){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$7i=m;function P(I){switch(I){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$8i=P,e.$9i=new d.$Oi("logLevel",m(y.Info))});var _=this&&this.__param||function(V,e){return function(E,C){e(E,C,V)}};define(te[217],ie([0,1,76,3,2,5,4,8]),function(V,e,E,C,r,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=void 0;let f=class ut extends r.$lb{static{this.a=2500}static{this.b=ut.a-100}constructor($){super(),this.h=$,this.c=this.B(new C.$8c),this.onDidChangePassword=this.c.event,this.g=new S.$rg}async getPassword($,d){this.h.trace("Going to get password from keytar:",$,d);let p;try{p=await this.i()}catch{return null}return await this.g.queue($+d,()=>this.k(p,$,d))}async k($,d,p){this.h.trace("Doing get password from keytar:",d,p);const h=await(0,S.$Mg)(()=>$.getPassword(d,p),50,3);if(!h)return this.h.trace("Did not get a password from keytar for account:",p),h;let v,y;try{const o=JSON.parse(h);v=o.content,y=o.hasNextChunk}catch{}if(!v||!y)return this.h.trace("Got password from keytar for account:",p),h;try{let o=1;for(;y;){const g=await(0,S.$Mg)(()=>$.getPassword(d,`${p}-${o}`),50,3),c=JSON.parse(g);v+=c.content,y=c.hasNextChunk,o++}return this.h.trace(`Got ${o}-chunked password from keytar for account:`,p),v}catch(o){return this.h.error(o),h}}async setPassword($,d,p){this.h.trace("Going to set password using keytar:",$,d);let h;try{h=await this.i()}catch(v){throw this.j?.(v),v}await this.g.queue($+d,()=>this.l(h,$,d,p)),this.c.fire({service:$,account:d})}async l($,d,p,h){if(this.h.trace("Doing set password from keytar:",d,p),!R.$i){await(0,S.$Mg)(()=>$.setPassword(d,p,h),50,3),this.h.trace("Set password from keytar for account:",p);return}if(await this.m($,d,p),h.length<=ut.b){await(0,S.$Mg)(()=>$.setPassword(d,p,h),50,3),this.h.trace("Set password from keytar for account:",p);return}let v=0,y=0,o=!0;for(;o;){const g=h.substring(v,v+ut.b);v+=ut.b,o=h.length-v>0;const c={content:g,hasNextChunk:o};await(0,S.$Mg)(()=>$.setPassword(d,y?`${p}-${y}`:p,JSON.stringify(c)),50,3),y++}this.h.trace(`Set${y?` ${y}-chunked`:""} password from keytar for account:`,p)}async deletePassword($,d){this.h.trace("Going to delete password using keytar:",$,d);let p;try{p=await this.i()}catch(v){throw this.j?.(v),v}const h=await this.g.queue($+d,()=>this.m(p,$,d));return h&&this.c.fire({service:$,account:d}),h}async m($,d,p){this.h.trace("Doing delete password from keytar:",d,p);const h=await $.getPassword(d,p);if(!h)return this.h.trace("Did not get a password to delete from keytar for account:",p),!1;let v,y;try{const g=JSON.parse(h);v=g.content,y=g.hasNextChunk}catch{}let o=0;if(v&&y)try{for(o++;y;){const g=`${p}-${o}`,c=await $.getPassword(d,g);await $.deletePassword(d,g),y=JSON.parse(c).hasNextChunk,o++}}catch(g){this.h.error(g)}return await $.deletePassword(d,p)?(this.h.trace(`Deleted${o?` ${o}-chunked`:""} password from keytar for account:`,p),!0):(this.h.trace(`Keytar failed to delete${o?` ${o}-chunked`:""} password for account:`,p),!1)}async findPassword($){let d;try{d=await this.i()}catch{return null}return await d.findPassword($)}async findCredentials($){let d;try{d=await this.i()}catch{return[]}return await d.findCredentials($)}clear(){return this.f instanceof E.$on?this.f.clear():Promise.resolve()}};e.$pn=f,e.$pn=f=pe([_(0,O.$Ri)],f)}),define(te[218],ie([0,1,14,4,5]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R3b=void 0;const O=E.safeStorage;let R=class{constructor(f){this.a=f,E.app.commandLine.getSwitchValue("password-store")==="basic"&&O.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.a.trace("[EncryptionMainService] Encrypting value.");try{const u=JSON.stringify(O.encryptString(f));return this.a.trace("[EncryptionMainService] Encrypted value."),u}catch(u){throw this.a.error(u),u}}async decrypt(f){let u;try{if(u=JSON.parse(f),!u.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const $=Buffer.from(u.data);this.a.trace("[EncryptionMainService] Decrypting value.");const d=O.decryptString($);return this.a.trace("[EncryptionMainService] Decrypted value."),d}catch($){throw this.a.error($),$}}isEncryptionAvailable(){return Promise.resolve(O.isEncryptionAvailable())}getKeyStorageProvider(){if(C.$i)return Promise.resolve("dpapi");if(C.$j)return Promise.resolve("keychain_access");if(O.getSelectedStorageBackend)try{const f=O.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.a.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(C.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(C.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");O.setUsePlainTextEncryption(!0)}};e.$R3b=R,e.$R3b=R=pe([_(0,r.$Ri)],R)}),define(te[219],ie([0,1,24,8,13,3,2,9,77,5]),function(V,e,E,C,r,O,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;class $ extends R.$lb{constructor(p,h){super(),this.a=p,this.b=h,this.c=this.B(new O.$8c),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$8c),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new C.$tg(0)),this.s=[],this.t=this.B(new C.$tg(0))}watch(p,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(p,h):this.u(p,h)}l(p,h){const v={path:this.C(p),excludes:h.excludes,includes:h.includes,recursive:h.recursive},y=(0,E.$Bf)(this.j,v);return this.m(),(0,R.$jb)(()=>{y(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,r.$Y)(p))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,f.$xp)(h)),h=>this.z(h),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const h of this.j)(0,f.$tp)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const h of this.j)(0,f.$tp)(h)&&p.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(p,h){const v={path:this.C(p),excludes:h.excludes,includes:h.includes,recursive:!1},y=(0,E.$Bf)(this.s,v);return this.v(),(0,R.$jb)(()=>{y(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(p=>(0,r.$Y)(p))}w(){return this.r||(this.r=this.B(this.y(p=>this.c.fire((0,f.$xp)(p)),p=>this.z(p),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.r.watch(this.s)}z(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}C(p){return(0,S.$$b)(p.fsPath)}}e.$Bp=$}),define(te[220],ie([0,1,24,8,17,22,3,57,68,2,58,15,65,19,56,173,16,118,5,13]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=void 0;let k=class extends u.$lb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new R.$8c),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new R.$8c),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new R.$8c),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new R.$8c),this.onDidRunOperation=this.m.event,this.R=this.B(new R.$8c),this.onDidFilesChange=this.R.event,this.S=this.B(new R.$8c),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new C.$Dg)}registerProvider(t,l){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${t}`);const s=new u.$kb;return this.h.set(t,l),this.c.fire({added:!0,scheme:t,provider:l}),s.add(l.onDidChangeFile(n=>this.R.fire(new o.$$j(n,!this.O(l))))),typeof l.onDidWatchError=="function"&&s.add(l.onDidWatchError(n=>this.S.fire(new Error(n)))),s.add(l.onDidChangeCapabilities(()=>this.g.fire({provider:l,scheme:t}))),(0,u.$jb)(()=>{this.c.fire({added:!1,scheme:t,provider:l}),this.h.delete(t),(0,u.$gb)(s)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const l=[];this.f.fire({scheme:t,join(s){l.push(s)}}),!this.h.has(t)&&await C.Promises.settled(l)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,l){const s=this.h.get(t.scheme);return!!(s&&s.capabilities&l)}listCapabilities(){return f.Iterable.map(this.h,([t,l])=>({scheme:t,capabilities:l.capabilities}))}async j(t){if(!(0,h.$bg)(t))throw new o.$ak((0,y.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const l=this.h.get(t.scheme);if(!l){const s=new b.$ab;throw s.message=(0,y.localize)(1,null,t.toString()),s}return l}async k(t){const l=await this.j(t);if((0,o.$Xj)(l)||(0,o.$Uj)(l)||(0,o.$Yj)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const l=await this.j(t);if((0,o.$Xj)(l)||(0,o.$Uj)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,l){try{return await this.n(t,l)}catch(s){throw(0,o.$8j)(s)===o.FileSystemProviderErrorCode.FileNotFound?new o.$ak((0,y.localize)(2,null,this.nb(t)),1):(0,o.$6j)(s)}}async n(t,l){const s=await this.j(t),n=this.O(s),i=l?.resolveTo,a=l?.resolveSingleChildDescendants,m=l?.resolveMetadata,P=await s.stat(t);let I;return this.p(s,t,P,void 0,!!m,(D,M)=>(I||(I=$.$vh.forUris(()=>!n),I.set(t,!0),i&&I.fill(!0,i)),I.get(D.resource)||I.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&a?M===1:!1))}async p(t,l,s,n,i,a){const{providerExtUri:m}=this.N(t),P={resource:l,name:m.basename(l),isFile:(s.type&o.FileType.File)!==0,isDirectory:(s.type&o.FileType.Directory)!==0,isSymbolicLink:(s.type&o.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&o.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((s.permissions??0)&o.FilePermission.Locked),etag:(0,o.$lk)({mtime:s.mtime,size:s.size}),children:void 0};if(P.isDirectory&&a(P,n)){try{const I=await t.readdir(l),D=await C.Promises.settled(I.map(async([M,L])=>{try{const N=m.joinPath(l,M),B=i?await t.stat(N):{type:L};return await this.p(t,N,B,I.length,i,a)}catch(N){return this.b.trace(N),null}}));P.children=(0,E.$mf)(D)}catch(I){this.b.trace(I),P.children=[]}return P}return P}async resolveAll(t){return C.Promises.settled(t.map(async l=>{try{return{stat:await this.n(l.resource,l.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const l=await this.j(t),s=await l.stat(t);return this.p(l,t,s,void 0,!0,()=>!1)}async exists(t){const l=await this.j(t);try{return!!await l.stat(t)}catch{return!1}}async canCreateFile(t,l){try{await this.r(t,l)}catch(s){return s}return!0}async r(t,l){if(!l?.overwrite&&await this.exists(t))throw new o.$ak((0,y.localize)(3,null,this.nb(t)),3,l)}async createFile(t,l=r.$Jb.fromString(""),s){await this.r(t,s);const n=await this.writeFile(t,l);return this.m.fire(new o.$0j(t,0,n)),n}async writeFile(t,l,s){const n=this.lb(await this.l(t),t),{providerExtUri:i}=this.N(n);try{await this.s(n,t,s)||await this.P(n,i.dirname(t));let m;if((0,o.$Uj)(n)&&!(l instanceof r.$Jb))if((0,v.$vb)(l)){const P=await(0,v.$Cb)(l,3);P.ended?m=r.$Jb.concat(P.buffer):m=P}else m=(0,v.$zb)(l,P=>r.$Jb.concat(P),3);else m=l;if(!(0,o.$Xj)(n)||(0,o.$Uj)(n)&&m instanceof r.$Jb)await this.cb(n,t,s,m);else{const P=m instanceof r.$Jb?(0,r.$Ub)(m):m;s?.atomic!==!1&&s?.atomic?.postfix?await this.Y(n,t,(0,h.$0f)((0,h.$9f)(t),`${(0,h.$7f)(t)}${s.atomic.postfix}`),s,P):await this.Z(n,t,s,P)}this.m.fire(new o.$0j(t,4))}catch(a){throw new o.$ak((0,y.localize)(4,null,this.nb(t),(0,o.$6j)(a).toString()),(0,o.$9j)(a),s)}return this.resolve(t,{resolveMetadata:!0})}async s(t,l,s){const n=!!s?.unlock;if(n&&!(t.capabilities&8192))throw new Error((0,y.localize)(5,null,this.nb(l)));if(!!s?.atomic){if(!(t.capabilities&32768))throw new Error((0,y.localize)(6,null,this.nb(l)));if(n)throw new Error((0,y.localize)(7,null,this.nb(l)))}let a;try{a=await t.stat(l)}catch{return}if(a.type&o.FileType.Directory)throw new o.$ak((0,y.localize)(8,null,this.nb(l)),0,s);if(this.mb(l,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==o.$kk&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,o.$lk)({mtime:s.mtime,size:a.size}))throw new o.$ak((0,y.localize)(9,null),3,s);return a}async readFile(t,l,s){const n=await this.k(t);return l?.atomic?this.t(n,t,l,s):this.u(n,t,l,s)}async t(t,l,s,n){return new Promise((i,a)=>{this.X.queueFor(l,this.N(t).providerExtUri).queue(async()=>{try{const m=await this.u(t,l,s,n);i(m)}catch(m){a(m)}})})}async u(t,l,s,n){const i=await this.v(t,l,{...s,preferUnbuffered:!0},n);return{...i,value:await(0,r.$Vb)(i.value)}}async readFileStream(t,l,s){const n=await this.k(t);return this.v(n,t,l,s)}async v(t,l,s,n){const i=new O.$ed(n),a=this.F(l,s).then(P=>P,P=>{throw i.cancel(),P});let m;try{return typeof s?.etag=="string"&&s.etag!==o.$kk&&await a,s?.atomic&&(0,o.$Zj)(t)||!((0,o.$Xj)(t)||(0,o.$Yj)(t))||(0,o.$Uj)(t)&&s?.preferUnbuffered?m=this.D(t,l,s):(0,o.$Yj)(t)?m=this.z(t,l,i.token,s):m=this.C(t,l,i.token,s),{...await a,value:m}}catch(P){throw m&&await(0,v.$Ab)(m),this.w(P,l,s)}}w(t,l,s){const n=(0,y.localize)(10,null,this.nb(l),(0,o.$6j)(t).toString());return t instanceof o.$ck?new o.$ck(n,t.stat,s):t instanceof o.$bk?new o.$bk(n,t.fileOperationResult,t.size,t.options):new o.$ak(n,(0,o.$9j)(t),s)}z(t,l,s,n=Object.create(null)){const i=t.readFileStream(l,n,s);return(0,v.$Gb)(i,{data:a=>a instanceof r.$Jb?a:r.$Jb.wrap(a),error:a=>this.w(a,l,n)},a=>r.$Jb.concat(a))}C(t,l,s,n=Object.create(null)){const i=(0,r.$Zb)();return(0,g.$rp)(t,l,i,a=>a,{...n,bufferSize:this.a,errorTransformer:a=>this.w(a,l,n)},s),i}D(t,l,s){const n=(0,v.$xb)(i=>r.$Jb.concat(i));return(async()=>{try{let i;s?.atomic&&(0,o.$Zj)(t)?i=await t.readFile(l,{atomic:!0}):i=await t.readFile(l),typeof s?.position=="number"&&(i=i.slice(s.position)),typeof s?.length=="number"&&(i=i.slice(0,s.length)),this.G(l,i.byteLength,s),n.end(r.$Jb.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async F(t,l){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new o.$ak((0,y.localize)(11,null,this.nb(t)),0,l);if(typeof l?.etag=="string"&&l.etag!==o.$kk&&l.etag===s.etag)throw new o.$ck((0,y.localize)(12,null),s,l);return this.G(t,s.size,l),s}G(t,l,s){if(typeof s?.limits?.size=="number"&&l>s.limits.size)throw new o.$bk((0,y.localize)(13,null,this.nb(t)),7,l,s)}async canMove(t,l,s){return this.H(t,l,"move",s)}async canCopy(t,l,s){return this.H(t,l,"copy",s)}async H(t,l,s,n){if(t.toString()!==l.toString())try{const i=s==="move"?this.lb(await this.l(t),t):await this.k(t),a=this.lb(await this.l(l),l);await this.M(i,t,a,l,s,n)}catch(i){return i}return!0}async move(t,l,s){const n=this.lb(await this.l(t),t),i=this.lb(await this.l(l),l),a=await this.I(n,t,i,l,"move",!!s),m=await this.resolve(l,{resolveMetadata:!0});return this.m.fire(new o.$0j(t,a==="move"?2:3,m)),m}async copy(t,l,s){const n=await this.k(t),i=this.lb(await this.l(l),l),a=await this.I(n,t,i,l,"copy",!!s),m=await this.resolve(l,{resolveMetadata:!0});return this.m.fire(new o.$0j(t,a==="copy"?3:2,m)),m}async I(t,l,s,n,i,a){if(l.toString()===n.toString())return i;const{exists:m,isSameResourceWithDifferentPathCase:P}=await this.M(t,l,s,n,i,a);if(m&&!P&&a&&await this.del(n,{recursive:!0}),await this.P(s,this.N(s).providerExtUri.dirname(n)),i==="copy"){if(t===s&&(0,o.$Vj)(t))await t.copy(l,n,{overwrite:a});else{const I=await this.resolve(l);I.isDirectory?await this.L(t,I,s,n):await this.J(t,l,s,n)}return i}else return t===s?(await t.rename(l,n,{overwrite:a}),i):(await this.I(t,l,s,n,"copy",a),await this.del(l,{recursive:!0}),"copy")}async J(t,l,s,n){if((0,o.$Xj)(t)&&(0,o.$Xj)(s))return this.eb(t,l,s,n);if((0,o.$Xj)(t)&&(0,o.$Uj)(s))return this.kb(t,l,s,n);if((0,o.$Uj)(t)&&(0,o.$Xj)(s))return this.ib(t,l,s,n);if((0,o.$Uj)(t)&&(0,o.$Uj)(s))return this.gb(t,l,s,n)}async L(t,l,s,n){await s.mkdir(n),Array.isArray(l.children)&&await C.Promises.settled(l.children.map(async i=>{const a=this.N(s).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.L(t,await this.resolve(i.resource),s,a):this.J(t,i.resource,s,a)}))}async M(t,l,s,n,i,a){let m=!1;if(t===s){const{providerExtUri:I,isPathCaseSensitive:D}=this.N(t);if(D||(m=I.isEqual(l,n)),m&&i==="copy")throw new Error((0,y.localize)(14,null,this.nb(l),this.nb(n)));if(!m&&I.isEqualOrParent(n,l))throw new Error((0,y.localize)(15,null,this.nb(l),this.nb(n)))}const P=await this.exists(n);if(P&&!m){if(!a)throw new o.$ak((0,y.localize)(16,null,this.nb(l),this.nb(n)),4);if(t===s){const{providerExtUri:I}=this.N(t);if(I.isEqualOrParent(l,n))throw new Error((0,y.localize)(17,null,this.nb(l),this.nb(n)))}}return{exists:P,isSameResourceWithDifferentPathCase:m}}N(t){const l=this.O(t);return{providerExtUri:l?h.$Zf:h.$2f,isPathCaseSensitive:l}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const l=this.lb(await this.j(t),t);await this.P(l,t);const s=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new o.$0j(t,0,s)),s}async P(t,l){const s=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(l,n.dirname(l));)try{if(!((await t.stat(l)).type&o.FileType.Directory))throw new Error((0,y.localize)(18,null,this.nb(l)));break}catch(i){if((0,o.$8j)(i)!==o.FileSystemProviderErrorCode.FileNotFound)throw i;s.push(n.basename(l)),l=n.dirname(l)}for(let i=s.length-1;i>=0;i--){l=n.joinPath(l,s[i]);try{await t.mkdir(l)}catch(a){if((0,o.$8j)(a)!==o.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,l){try{await this.Q(t,l)}catch(s){return s}return!0}async Q(t,l){const s=this.lb(await this.j(t),t),n=!!l?.useTrash;if(n&&!(s.capabilities&4096))throw new Error((0,y.localize)(19,null,this.nb(t)));const i=l?.atomic;if(i&&!(s.capabilities&65536))throw new Error((0,y.localize)(20,null,this.nb(t)));if(n&&i)throw new Error((0,y.localize)(21,null,this.nb(t)));let a;try{a=await s.stat(t)}catch{}if(a)this.mb(t,a);else throw new o.$ak((0,y.localize)(22,null,this.nb(t)),1);if(!!!l?.recursive){const P=await this.resolve(t);if(P.isDirectory&&Array.isArray(P.children)&&P.children.length>0)throw new Error((0,y.localize)(23,null,this.nb(t)))}return s}async del(t,l){const s=await this.Q(t,l),n=!!l?.useTrash,i=!!l?.recursive,a=l?.atomic??!1;await s.delete(t,{recursive:i,useTrash:n,atomic:a}),this.m.fire(new o.$0j(t,1))}async cloneFile(t,l){const s=await this.j(t),n=this.lb(await this.l(l),l);if(s===n&&this.N(s).providerExtUri.isEqual(t,l))return;if(s===n&&(0,o.$Wj)(s))return s.cloneFile(t,l);await this.P(n,this.N(n).providerExtUri.dirname(l));const i=this.X.queueFor(t,this.N(s).providerExtUri);return s===n&&(0,o.$Vj)(s)?i.queue(()=>s.copy(t,l,{overwrite:!0})):i.queue(()=>this.J(s,t,n,l))}watch(t,l={recursive:!1,excludes:[]}){const s=new u.$kb;let n=!1,i=()=>{n=!0};return s.add((0,u.$jb)(()=>i())),(async()=>{try{const a=await this.W(t,l);n?(0,u.$gb)(a):i=()=>(0,u.$gb)(a)}catch(a){this.b.error(a)}})(),s}async W(t,l){const s=await this.j(t),n=(0,S.$di)([this.N(s).providerExtUri.getComparisonKey(t),l]);let i=this.U.get(n);return i||(i={count:0,disposable:s.watch(t,l)},this.U.set(n,i)),i.count+=1,(0,u.$jb)(()=>{i&&(i.count--,i.count===0&&((0,u.$gb)(i.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,u.$gb)(t.disposable);this.U.clear()}async Y(t,l,s,n,i){await this.Z(t,s,n,i);try{await t.rename(s,l,{overwrite:!0})}catch(a){try{await t.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async Z(t,l,s,n){return this.X.queueFor(l,this.N(t).providerExtUri).queue(async()=>{const i=await t.open(l,{create:!0,unlock:s?.unlock??!1});try{(0,v.$vb)(n)||(0,v.$wb)(n)?await this.$(t,i,n):await this.ab(t,i,n)}catch(a){throw(0,o.$6j)(a)}finally{await t.close(i)}})}async $(t,l,s){let n=0,i;if((0,v.$wb)(s)){if(s.buffer.length>0){const a=r.$Jb.concat(s.buffer);await this.bb(t,l,a,a.byteLength,n,0),n+=a.byteLength}if(s.ended)return;i=s.stream}else i=s;return new Promise((a,m)=>{(0,v.$Bb)(i,{onData:async P=>{i.pause();try{await this.bb(t,l,P,P.byteLength,n,0)}catch(I){return m(I)}n+=P.byteLength,setTimeout(()=>i.resume())},onError:P=>m(P),onEnd:()=>a()})})}async ab(t,l,s){let n=0,i;for(;(i=s.read())!==null;)await this.bb(t,l,i,i.byteLength,n,0),n+=i.byteLength}async bb(t,l,s,n,i,a){let m=0;for(;m<n;){const P=await t.write(l,i+m,s.buffer,a+m,n-m);m+=P}}async cb(t,l,s,n){return this.X.queueFor(l,this.N(t).providerExtUri).queue(()=>this.db(t,l,s,n))}async db(t,l,s,n){let i;n instanceof r.$Jb?i=n:(0,v.$vb)(n)?i=await(0,r.$Vb)(n):(0,v.$wb)(n)?i=await(0,r.$Wb)(n):i=(0,r.$Tb)(n),await t.writeFile(l,i.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async eb(t,l,s,n){return this.X.queueFor(n,this.N(s).providerExtUri).queue(()=>this.fb(t,l,s,n))}async fb(t,l,s,n){let i,a;try{i=await t.open(l,{create:!1}),a=await s.open(n,{create:!0,unlock:!1});const m=r.$Jb.alloc(this.a);let P=0,I=0,D=0;do D=await t.read(i,P,m.buffer,I,m.byteLength-I),await this.bb(s,a,m,D,P,I),P+=D,I+=D,I===m.byteLength&&(I=0);while(D>0)}catch(m){throw(0,o.$6j)(m)}finally{await C.Promises.settled([typeof i=="number"?t.close(i):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async gb(t,l,s,n){return this.X.queueFor(n,this.N(s).providerExtUri).queue(()=>this.hb(t,l,s,n))}async hb(t,l,s,n){return s.writeFile(n,await t.readFile(l),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,l,s,n){return this.X.queueFor(n,this.N(s).providerExtUri).queue(()=>this.jb(t,l,s,n))}async jb(t,l,s,n){const i=await s.open(n,{create:!0,unlock:!1});try{const a=await t.readFile(l);await this.bb(s,i,r.$Jb.wrap(a),a.byteLength,0,0)}catch(a){throw(0,o.$6j)(a)}finally{await s.close(i)}}async kb(t,l,s,n){const i=await(0,r.$Vb)(this.C(t,l,O.CancellationToken.None));await this.cb(s,n,void 0,i)}lb(t,l){if(t.capabilities&2048)throw new o.$ak((0,y.localize)(24,null,this.nb(l)),6);return t}mb(t,l){if((l.permissions??0)&o.FilePermission.Readonly)throw new o.$ak((0,y.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===d.Schemas.file?t.fsPath:t.toString(!0)}};e.$sp=k,e.$sp=k=pe([_(0,c.$Ri)],k)}),define(te[94],ie([0,1,45,309,8,35,17,3,32,2,9,4,19,56,21,177,16,118,219,50,214,213]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0,(()=>{try{(0,C.gracefulify)(E)}catch(l){console.error(`Error enabling graceful-fs: ${(0,b.$ai)(l)}`)}})();class t extends c.$Bp{static{this.D=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=S.Event.None,this.I=new O.$ni(i=>p.$1f.getComparisonKey(i)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,d.$k&&(this.F|=1024)),this.F}async stat(s){try{const{stat:n,symbolicLink:i}=await v.SymlinkSupport.stat(this.C(s));return{type:this.H(n,i),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:o.FilePermission.Locked}}catch(n){throw this.ab(n)}}async G(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await v.Promises.readdir(this.C(s),{withFileTypes:!0}),i=[];return await Promise.all(n.map(async a=>{try{let m;a.isSymbolicLink()?m=(await this.stat((0,p.$0f)(s,a.name))).type:m=this.H(a),i.push([a.name,m])}catch(m){this.a.trace(m)}})),i}catch(n){throw this.ab(n)}}H(s,n){let i;return n?.dangling?i=o.FileType.Unknown:s.isFile()?i=o.FileType.File:s.isDirectory()?i=o.FileType.Directory:i=o.FileType.Unknown,n&&(i|=o.FileType.SymbolicLink),i}async J(s){const n=this.C(s);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let i;for(;i=this.I.get(s);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await i.wait();const a=new r.$ug;return this.I.set(s,a),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,u.$jb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.I.get(s)===a&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.I.delete(s)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(s,n){let i;try{n?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(s)})`),i=await this.J(s));const a=this.C(s);return await v.Promises.readFile(a)}catch(a){throw this.ab(a)}finally{i?.dispose()}}L(s){t.D&&this.a.trace(s)}readFileStream(s,n,i){const a=(0,h.$xb)(m=>R.$Jb.concat(m.map(P=>R.$Jb.wrap(P))).buffer);return(0,g.$rp)(this,s,a,m=>m.buffer,{...n,bufferSize:256*1024},i),a}async writeFile(s,n,i){return i?.atomic!==!1&&i?.atomic?.postfix?this.M(s,(0,p.$0f)((0,p.$9f)(s),`${(0,p.$7f)(s)}${i.atomic.postfix}`),n,i):this.N(s,n,i)}async M(s,n,i,a){await this.N(n,i,a);try{await this.rename(n,s,{overwrite:!0})}catch(m){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw m}}async N(s,n,i){let a;try{const m=this.C(s);if(!i.create||!i.overwrite){if(await v.Promises.exists(m)){if(!i.overwrite)throw(0,o.$5j)((0,y.localize)(0,null),o.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,o.$5j)((0,y.localize)(1,null),o.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(s,{create:!0,unlock:i.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(m){throw await this.bb(s,m)}finally{typeof a=="number"&&await this.close(a)}}static{this.R=!0}static configureFlushOnWrite(s){t.R=s}async open(s,n){const i=this.C(s);let a;(0,o.$Tj)(n)&&(a=await this.J(s));let m;try{if((0,o.$Tj)(n)&&n.unlock)try{const{stat:I}=await v.SymlinkSupport.stat(i);I.mode&128||await v.Promises.chmod(i,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let P;if((0,o.$Tj)(n)){if(d.$i)try{await v.Promises.truncate(i,0),P="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}P||(P="w")}else P="r";m=await v.Promises.open(i,P)}catch(P){throw a?.dispose(),(0,o.$Tj)(n)?await this.bb(s,P):this.ab(P)}if(this.O.set(m,0),(0,o.$Tj)(n)&&this.Q.set(m,s),a){const P=this.P.get(m);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${m} (${i})`),this.P.set(m,a),P&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${m} (${i})`),P.dispose())}return m}async close(s){const n=this.P.get(s);try{if(this.O.delete(s),this.Q.delete(s)&&t.R)try{await v.Promises.fdatasync(s)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await v.Promises.close(s)}catch(i){throw this.ab(i)}finally{n&&(this.P.get(s)===n&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.P.delete(s)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,i,a,m){const P=this.S(s,n);let I=null;try{I=(await v.Promises.read(s,i,a,m,P)).bytesRead}catch(D){throw this.ab(D)}finally{this.U(s,P,I)}return I}S(s,n){return n===this.O.get(s)?null:n}U(s,n,i){const a=this.O.get(s);typeof a=="number"&&(typeof n=="number"||(typeof i=="number"?this.O.set(s,a+i):this.O.delete(s)))}async write(s,n,i,a,m){return(0,r.$Mg)(()=>this.W(s,n,i,a,m),100,3)}async W(s,n,i,a,m){const P=this.S(s,n);let I=null;try{I=(await v.Promises.write(s,i,a,m,P)).bytesWritten}catch(D){throw await this.bb(this.Q.get(s),D)}finally{this.U(s,P,I)}return I}async mkdir(s){try{await v.Promises.mkdir(this.C(s))}catch(n){throw this.ab(n)}}async delete(s,n){try{const i=this.C(s);if(n.recursive){let a;n?.atomic!==!1&&n.atomic.postfix&&(a=(0,$.$ac)((0,$.$dc)(i),`${(0,$.$ec)(i)}${n.atomic.postfix}`)),await v.Promises.rm(i,v.RimRafMode.MOVE,a)}else try{await v.Promises.unlink(i)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let m=!1;try{const{stat:P,symbolicLink:I}=await v.SymlinkSupport.stat(i);m=P.isDirectory()&&!I}catch{}if(m)await v.Promises.rmdir(i);else throw a}else throw a}}catch(i){throw this.ab(i)}}async rename(s,n,i){const a=this.C(s),m=this.C(n);if(a!==m)try{await this.X(s,n,"move",i.overwrite),await v.Promises.rename(a,m)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(2,null,(0,$.$ec)(a),(0,$.$ec)((0,$.$dc)(m)),P.toString()))),this.ab(P)}}async copy(s,n,i){const a=this.C(s),m=this.C(n);if(a!==m)try{await this.X(s,n,"copy",i.overwrite),await v.Promises.copy(a,m,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(3,null,(0,$.$ec)(a),(0,$.$ec)((0,$.$dc)(m)),P.toString()))),this.ab(P)}}async X(s,n,i,a){const m=this.C(s),P=this.C(n);let I=!1;if(!!(this.capabilities&1024)||(I=(0,f.$Je)(m,P,!0)),I){if(i==="copy")throw(0,o.$5j)((0,y.localize)(4,null),o.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const M=await this.G(s);if(!M)throw(0,o.$5j)((0,y.localize)(5,null),o.FileSystemProviderErrorCode.FileNotFound);const L=await this.G(n);if(L){if(!a)throw(0,o.$5j)((0,y.localize)(6,null),o.FileSystemProviderErrorCode.FileExists);M.type&o.FileType.File&&L.type&o.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.Y(s,n,!1)}async Y(s,n,i){const a=this.C(s),m=this.C(n),P=!!(this.capabilities&1024);if((0,f.$Je)(a,m,!P))return;const I=new u.$kb;try{const[D,M]=await Promise.all([this.J(s),this.J(n)]);I.add(D),I.add(M),i&&await v.Promises.mkdir((0,$.$dc)(m),{recursive:!0}),await v.Promises.copyFile(a,m)}catch(D){if(D.code==="ENOENT"&&!i)return this.Y(s,n,!0);throw this.ab(D)}finally{I.dispose()}}p(s,n,i){return new k.$Ip(a=>s(a),a=>n(a),i)}y(s,n,i){return new w.$Qp(a=>s(a),a=>n(a),i)}ab(s){if(s instanceof o.$4j)return s;let n=s,i;switch(s.code){case"ENOENT":i=o.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=o.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=o.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=o.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=o.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=o.FileSystemProviderErrorCode.Unknown;break;default:i=o.FileSystemProviderErrorCode.Unknown}return(0,o.$5j)(n,i)}async bb(s,n){let i=this.ab(n);if(s&&i.code===o.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await v.SymlinkSupport.stat(this.C(s));a.mode&128||(i=(0,o.$5j)(n,o.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return i}}e.$Rp=t}),define(te[221],ie([0,1,3,94,2,17,56,22]),function(V,e,E,C,r,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=void 0;class f extends r.$lb{constructor(d,p){super(),this.a=d,this.b=p,this.w=new Map,this.y=new Map}call(d,p,h){const v=this.c(d);switch(p){case"stat":return this.g(v,h[0]);case"readdir":return this.h(v,h[0]);case"open":return this.l(v,h[0],h[1]);case"close":return this.m(h[0]);case"read":return this.n(h[0],h[1],h[2]);case"readFile":return this.i(v,h[0],h[1]);case"write":return this.p(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.k(v,h[0],h[1],h[2]);case"rename":return this.t(v,h[0],h[1],h[2]);case"copy":return this.u(v,h[0],h[1],h[2]);case"cloneFile":return this.v(v,h[0],h[1]);case"mkdir":return this.r(v,h[0]);case"delete":return this.s(v,h[0],h[1]);case"watch":return this.C(v,h[0],h[1],h[2],h[3]);case"unwatch":return this.D(h[0],h[1])}throw new Error(`IPC Command ${p} not found`)}listen(d,p,h){const v=this.c(d);switch(p){case"fileChange":return this.z(v,h[0]);case"readFileStream":return this.j(v,h[0],h[1])}throw new Error(`Unknown event ${p}`)}g(d,p){const h=this.f(d,p,!0);return this.a.stat(h)}h(d,p){const h=this.f(d,p);return this.a.readdir(h)}async i(d,p,h){const v=this.f(d,p,!0),y=await this.a.readFile(v,h);return O.$Jb.wrap(y)}j(d,p,h){const v=this.f(d,p,!0),y=new S.$ed,o=new E.$8c({onDidRemoveLastListener:()=>{y.cancel()}}),g=this.a.readFileStream(v,h,y.token);return(0,R.$Bb)(g,{onData:c=>o.fire(O.$Jb.wrap(c)),onError:c=>o.fire(c),onEnd:()=>{o.fire("end"),o.dispose(),y.dispose()}}),o.event}k(d,p,h,v){const y=this.f(d,p);return this.a.writeFile(y,h.buffer,v)}l(d,p,h){const v=this.f(d,p,!0);return this.a.open(v,h)}m(d){return this.a.close(d)}async n(d,p,h){const v=O.$Jb.alloc(h),y=0,o=await this.a.read(d,p,v.buffer,y,h);return[v,o]}p(d,p,h,v,y){return this.a.write(d,p,h.buffer,v,y)}r(d,p){const h=this.f(d,p);return this.a.mkdir(h)}s(d,p,h){const v=this.f(d,p);return this.a.delete(v,h)}t(d,p,h,v){const y=this.f(d,p),o=this.f(d,h);return this.a.rename(y,o,v)}u(d,p,h,v){const y=this.f(d,p),o=this.f(d,h);return this.a.copy(y,o,v)}v(d,p,h){const v=this.f(d,p),y=this.f(d,h);return this.a.cloneFile(v,y)}z(d,p){const h=new E.$8c({onWillAddFirstListener:()=>{this.w.set(p,this.F(d,h))},onDidRemoveLastListener:()=>{(0,r.$gb)(this.w.get(p)),this.w.delete(p)}});return h.event}async C(d,p,h,v,y){const o=this.w.get(p);if(o){const g=this.f(d,v),c=o.watch(h,g,y);this.y.set(p+h,c)}}async D(d,p){const h=d+p,v=this.y.get(h);v&&((0,r.$gb)(v),this.y.delete(h))}dispose(){super.dispose();for(const[,d]of this.y)d.dispose();this.y.clear();for(const[,d]of this.w)d.dispose();this.w.clear()}}e.$lr=f;class u extends r.$lb{constructor(d,p,h,v){super(),this.c=d,this.f=h,this.g=v,this.a=new Map,this.b=this.B(new C.$Rp(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(p)}h(d){const p=this.B(new E.$8c);this.B(p.event(h=>{d.fire(h.map(v=>({resource:this.c.transformOutgoingURI(v.resource),type:v.type})))})),this.B(this.b.onDidChangeFile(h=>p.fire(h))),this.B(this.b.onDidWatchError(h=>d.fire(h)))}i(d){}j(d){}watch(d,p,h){const v=this.j(this.g);return Array.isArray(v)&&(h.excludes=[...h.excludes,...v]),this.a.set(d,this.b.watch(p,h)),(0,r.$jb)(()=>{(0,r.$gb)(this.a.get(d)),this.a.delete(d)})}dispose(){super.dispose();for(const[,d]of this.a)d.dispose();this.a.clear()}}e.$mr=u}),define(te[222],ie([0,1,14,176,4,7,16,9,221,154]),function(V,e,E,C,r,O,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z3b=void 0;class $ extends f.$lr{constructor(h,v,y){super(h,v),this.G=y}c(h){return u.$om}f(h,v){return O.URI.revive(v)}async s(h,v,y){if(!y.useTrash)return super.s(h,v,y);const o=this.f(h,v),g=(0,S.$$b)(o.fsPath);try{await E.shell.trashItem(g)}catch{throw(0,R.$5j)(r.$i?(0,C.localize)(0,null,(0,S.$ec)(g)):(0,C.localize)(1,null,(0,S.$ec)(g)),R.FileSystemProviderErrorCode.Unknown)}}F(h,v){return new d(h,v,this.b,this.G)}}e.$Z3b=$;class d extends f.$mr{watch(h,v,y){if(y.recursive)throw(0,R.$5j)("Recursive file watching is not supported from main process for performance reasons.",R.FileSystemProviderErrorCode.Unavailable);return super.watch(h,v,y)}}}),define(te[223],ie([0,1,5]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Zb=void 0;class C extends E.$Xi{constructor(O=E.$Ui){super(),this.k=[],this.l=void 0,this.setLevel(O),this.B(this.onDidChangeLogLevel(R=>{this.l?.setLevel(R)}))}set logger(O){this.l=O;for(const{level:R,message:S}of this.k)(0,E.log)(O,R,S);this.k=[]}g(O,R){this.l?(0,E.log)(this.l,O,R):this.getLevel()<=O&&this.k.push({level:O,message:R})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.$2Zb=C}),define(te[224],ie([0,1,7,3,5,2]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=e.$Nq=void 0;class R extends r.$3i{constructor(d,p,h,v,y){super(p,h,v),this.n=d,this.p=y,this.B(y.listen("onDidChangeLogLevel",d)(o=>{(0,r.$Ti)(o)?super.setLogLevel(o):super.setLogLevel(E.URI.revive(o[0]),o[1])})),this.B(y.listen("onDidChangeVisibility",d)(([o,g])=>super.setVisibility(E.URI.revive(o),g))),this.B(y.listen("onDidChangeLoggers",d)(({added:o,removed:g})=>{for(const c of o)super.registerLogger({...c,resource:E.URI.revive(c.resource)});for(const c of g)super.deregisterLogger(c.resource)}))}createConsoleMainLogger(){return new r.$1i({log:(d,p)=>{this.p.call("consoleLog",[d,p])}})}registerLogger(d){super.registerLogger(d),this.p.call("registerLogger",[d,this.n])}deregisterLogger(d){super.deregisterLogger(d),this.p.call("deregisterLogger",[d,this.n])}setLogLevel(d,p){super.setLogLevel(d,p),this.p.call("setLogLevel",[d,p])}setVisibility(d,p){super.setVisibility(d,p),this.p.call("setVisibility",[this.l(d),p])}m(d,p,h){return new S(this.p,d,p,h,this.n)}static setLogLevel(d,p,h){return d.call("setLogLevel",[p,h])}}e.$Nq=R;class S extends r.$Xi{constructor(d,p,h,v,y){super(v?.logLevel==="always"),this.m=d,this.n=p,this.k=!1,this.l=[],this.setLevel(h),this.m.call("createLogger",[p,v,y]).then(()=>{this.r(this.l),this.k=!0})}g(d,p){const h=[[d,p]];this.k?this.r(h):this.l.push(...h)}r(d){this.m.call("log",[this.n,d])}}class f{constructor(d,p){this.a=d,this.b=p}listen(d,p){const h=this.b(d);switch(p){case"onDidChangeLoggers":return C.Event.map(this.a.onDidChangeLoggers,v=>({added:[...v.added].map(y=>this.c(y,h)),removed:[...v.removed].map(y=>this.c(y,h))}));case"onDidChangeVisibility":return C.Event.map(this.a.onDidChangeVisibility,v=>[h.transformOutgoingURI(v[0]),v[1]]);case"onDidChangeLogLevel":return C.Event.map(this.a.onDidChangeLogLevel,v=>(0,r.$Ti)(v)?v:[h.transformOutgoingURI(v[0]),v[1]])}throw new Error(`Event not found: ${p}`)}async call(d,p,h){const v=this.b(d);switch(p){case"setLogLevel":return(0,r.$Ti)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(E.URI.revive(v.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,v)))}throw new Error(`Call not found: ${p}`)}c(d,p){return{...d,resource:p.transformOutgoingURI(d.resource)}}}e.$Oq=f;class u extends O.$lb{constructor(d,p){super(),p.call("setLogLevel",[d.getLogLevel()]),this.B(d.onDidChangeLogLevel(h=>p.call("setLogLevel",[h]))),p.call("getRegisteredLoggers").then(h=>{for(const v of h)d.registerLogger({...v,resource:E.URI.revive(v.resource)})}),this.B(p.listen("onDidChangeVisibility")(([h,v])=>d.setVisibility(E.URI.revive(h),v))),this.B(p.listen("onDidChangeLoggers")(({added:h,removed:v})=>{for(const y of h)d.registerLogger({...y,resource:E.URI.revive(y.resource)});for(const y of v)d.deregisterLogger(y.resource)}))}}e.$Pq=u}),define(te[225],ie([0,1,2,5]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=void 0;class r extends E.$lb{constructor(R,S=[]){super(),this.a=new C.$2i([R,...S]),this.B(R.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...S){this.a.trace(R,...S)}debug(R,...S){this.a.debug(R,...S)}info(R,...S){this.a.info(R,...S)}warn(R,...S){this.a.warn(R,...S)}error(R,...S){this.a.error(R,...S)}flush(){this.a.flush()}}e.$1M=r}),define(te[226],ie([0,1,35,7,5]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V4b=void 0;class O{constructor(S){this.b=S,this.a=new E.$ni}listen(S,f,u){switch(f){case"onDidChangeLoggers":return u?this.b.getOnDidChangeLoggersEvent(u):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return u?this.b.getOnDidChangeLogLevelEvent(u):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return u?this.b.getOnDidChangeVisibilityEvent(u):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(S,f,u){switch(f){case"createLogger":this.c(C.URI.revive(u[0]),u[1],u[2]);return;case"log":return this.e(C.URI.revive(u[0]),u[1]);case"consoleLog":return this.d(u[0],u[1]);case"setLogLevel":return(0,r.$Ti)(u[0])?this.b.setLogLevel(u[0]):this.b.setLogLevel(C.URI.revive(u[0]),u[1]);case"setVisibility":return this.b.setVisibility(C.URI.revive(u[0]),u[1]);case"registerLogger":return this.b.registerLogger({...u[0],resource:C.URI.revive(u[0].resource)},u[1]);case"deregisterLogger":return this.b.deregisterLogger(C.URI.revive(u[0]))}throw new Error(`Call not found: ${f}`)}c(S,f,u){this.a.set(S,this.b.createLogger(S,f,u))}d(S,f){let u=console.log;switch(S){case r.LogLevel.Error:u=console.error;break;case r.LogLevel.Warning:u=console.warn;break;case r.LogLevel.Info:u=console.info;break}u.call(console,...f)}e(S,f){const u=this.a.get(S);if(!u)throw new Error("Create the logger before logging");for(const[$,d]of f)(0,r.log)(u,$,d)}}e.$V4b=O}),define(te[227],ie([0,1,16,5]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=void 0;var r;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(r||(r={}));async function O(u,$,d,p,h){try{const v=await new Promise((o,g)=>{V(["@vscode/spdlog"],o,g)});v.setFlushOn(r.Trace);const y=await v.createAsyncRotatingLogger(u,$,d,p);return h?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(v){console.error(v)}return null}function R(u,$,d){switch($){case C.LogLevel.Trace:u.trace(d);break;case C.LogLevel.Debug:u.debug(d);break;case C.LogLevel.Info:u.info(d);break;case C.LogLevel.Warning:u.warn(d);break;case C.LogLevel.Error:u.error(d);break;case C.LogLevel.Off:break;default:throw new Error(`Invalid log level ${$}`)}}function S(u,$){switch($){case C.LogLevel.Trace:u.setLevel(r.Trace);break;case C.LogLevel.Debug:u.setLevel(r.Debug);break;case C.LogLevel.Info:u.setLevel(r.Info);break;case C.LogLevel.Warning:u.setLevel(r.Warning);break;case C.LogLevel.Error:u.setLevel(r.Error);break;case C.LogLevel.Off:u.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${$}`)}}class f extends C.$Xi{constructor($,d,p,h,v){super(),this.k=[],this.setLevel(v),this.l=this.n($,d,p,h),this.B(this.onDidChangeLogLevel(y=>{this.m&&S(this.m,y)}))}async n($,d,p,h){const v=p?6:1,y=30/v*E.$nk.MB,o=await O($,d,y,v,h);if(o){this.m=o,S(this.m,this.getLevel());for(const{level:g,message:c}of this.k)R(this.m,g,c);this.k=[]}}g($,d){this.m?R(this.m,$,d):this.getLevel()<=$&&this.k.push({level:$,message:d})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$PM=f}),define(te[228],ie([0,1,31,5,227]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=void 0;class O extends C.$3i{m(S,f,u){return new r.$PM((0,E.$6e)(),S.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,f)}}e.$QM=O}),define(te[66],ie([0,1,35,3,6,5,228]),function(V,e,E,C,r,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m4b=e.$l4b=void 0,e.$l4b=(0,r.$qh)(O.$Si);class S extends R.$QM{constructor(){super(...arguments),this.p=new E.$ni}createLogger(u,$,d){d!==void 0&&this.p.set(this.l(u),d);try{return super.createLogger(u,$)}catch(p){throw this.p.delete(this.l(u)),p}}registerLogger(u,$){$!==void 0&&this.p.set(u.resource,$),super.registerLogger(u)}deregisterLogger(u){this.p.delete(u),super.deregisterLogger(u)}getRegisteredLoggers(u){const $=[];for(const d of super.getRegisteredLoggers())u===this.p.get(d.resource)&&$.push(d);return $}getOnDidChangeLogLevelEvent(u){return C.Event.filter(this.onDidChangeLogLevel,$=>(0,O.$Ti)($)||this.s($[0],u))}getOnDidChangeVisibilityEvent(u){return C.Event.filter(this.onDidChangeVisibility,([$])=>this.s($,u))}getOnDidChangeLoggersEvent(u){return C.Event.filter(C.Event.map(this.onDidChangeLoggers,$=>({added:[...$.added].filter(p=>this.s(p.resource,u)),removed:[...$.removed].filter(p=>this.s(p.resource,u))})),$=>$.added.length>0||$.removed.length>0)}deregisterLoggers(u){for(const[$,d]of this.p)d===u&&this.deregisterLogger($)}s(u,$){const d=this.p.get(u);return d===void 0||d===$}dispose(){super.dispose(),this.p.clear()}}e.$m4b=S}),define(te[229],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f4b=e.$e4b=e.$d4b=e.$c4b=void 0;function E(R){return R.submenu!==void 0}e.$c4b=E;function C(R){return R.id==="vscode.menubar.separator"}e.$d4b=C;function r(R){return R.uri!==void 0}e.$e4b=r;function O(R){return!E(R)&&!C(R)&&!r(R)}e.$f4b=O}),define(te[39],ie([0,1,3,68,2,6]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=e.$Vm=void 0,e.$Vm=(0,O.$ph)("policy");class R extends r.$lb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.$8c),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const $=Object.keys(this.f).length;return this.f={...u,...this.f},$!==Object.keys(this.f).length&&await this.i(u),C.Iterable.reduce(this.g.entries(),(d,[p,h])=>({...d,[p]:h}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return C.Iterable.reduce(Object.entries(this.f),(u,[$,d])=>({...u,[$]:{definition:d,value:this.g.get($)}}),{})}}e.$Wm=R;class S{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Xm=S}),define(te[230],ie([0,1,8,3,68,10,16,5,39]),function(V,e,E,C,r,O,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a5b=void 0;function u(d,p){const h=[];for(const v of new Set(r.Iterable.concat(d.keys(),p.keys())))d.get(v)!==p.get(v)&&h.push(v);return h}let $=class extends f.$Wm{constructor(p,h,v){super(),this.j=p,this.k=h,this.l=v,this.c=this.B(new E.$tg(500));const y=C.Event.filter(h.onDidFilesChange,o=>o.affects(p));this.B(h.watch(p)),this.B(y(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const p=new Map;try{const h=await this.k.readFile(this.j),v=JSON.parse(h.value.toString());if(!(0,O.$le)(v))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(v))this.f[y]&&p.set(y,v[y])}catch(h){h.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",h)}return p}async p(){const p=await this.n(),h=u(this.g,p);this.g=p,h.length>0&&this.h.fire(h)}};e.$a5b=$,e.$a5b=$=pe([_(1,R.$Sj),_(2,S.$Ri)],$)}),define(te[231],ie([0,1,3,2,39]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P4b=e.$O4b=void 0;class O{constructor(f){this.b=f,this.a=new C.$kb}listen(f,u){switch(u){case"onDidChange":return E.Event.map(this.b.onDidChange,$=>$.reduce((d,p)=>({...d,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${u}`)}call(f,u,$){switch(u){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions($)}throw new Error(`Call not found: ${u}`)}dispose(){this.a.dispose()}}e.$O4b=O;class R extends r.$Wm{constructor(f,u){super(),this.a=u;for(const $ in f){const{definition:d,value:p}=f[$];this.f[$]=d,p!==void 0&&this.g.set($,p)}this.a.listen("onDidChange")($=>{for(const d in $){const p=$[d];p===null?this.g.delete(d):this.g.set(d,p)}this.h.fire(Object.keys($))})}async i(f){const u=await this.a.call("updatePolicyDefinitions",f);for(const $ in u)this.g.set($,u[$])}}e.$P4b=R}),define(te[232],ie([0,1,39,8,310,2,5]),function(V,e,E,C,r,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_4b=void 0;let S=class extends E.$Wm{constructor(u,$){super(),this.j=u,this.k=$,this.a=new C.$pg,this.b=this.B(new O.$mb)}async i(u){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`),await this.a.queue(()=>new Promise(($,d)=>{try{this.b.value=(0,r.createWatcher)(this.k,u,p=>{this.m(p),$()})}catch(p){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),d(p)}}))}m(u){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const $ in u){const d=u[$];d===void 0?this.g.delete($):this.g.set($,d)}this.h.fire(Object.keys(u))}};e.$_4b=S,e.$_4b=S=pe([_(0,R.$Ri)],S)}),define(te[78],ie([0,1,4,36]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof E.$g.vscode<"u"&&typeof E.$g.vscode.context<"u"){const O=E.$g.vscode.context.configuration();if(O)r=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,C.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:O.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(te[23],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=void 0,e.$0i=(0,E.$ph)("productService"),e.$$i="vscode://schemas/vscode-product"}),define(te[233],ie([0,1,72,5,23]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S3b=void 0;let O=class{constructor(S,f){this.b=S,this.c=f,this.a=new Map}async isExtensionUrlTrusted(S,f){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const u=/^(.*)#([^#]+)$/.exec(f);if(!u)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,$,d]=u;let p=this.a.get(S);if(!p){if(p=this.b.trustedExtensionUrlPublicKeys[S],!p||p.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",S),!1;this.a.set(S,[...p])}const h=Buffer.from(decodeURIComponent(d),"base64");if(h.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const v=h.slice(0,6),y=h.readUIntBE(0,6),o=Date.now()-y;if(o<0||o>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const g=h.slice(6),c=E.createVerify("SHA256");c.write(v),c.write(Buffer.from($)),c.end();for(let b=0;b<p.length;b++){let k=p[b];if(k!==null){if(typeof k=="string")try{k=E.createPublicKey({key:Buffer.from(k,"base64"),format:"der",type:"spki"}),p[b]=k}catch(w){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${b+1} for ${S}:`,w),p[b]=null;continue}if(c.verify(k,g))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};e.$S3b=O,e.$S3b=O=pe([_(0,r.$0i),_(1,C.$Ri)],O)}),define(te[234],ie([0,1,8,5]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$53b=void 0;let r=class{constructor(R,S,f){this.a=R,this.b=S,this.c=f}async inspect(R){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.$wg)(R);const f=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const R=this.a.webContents.debugger;R.attach(),await R.sendCommand("Profiler.enable")}async e(){const R=this.a.webContents.debugger;await R.sendCommand("Profiler.disable"),R.detach()}};e.$53b=r,e.$53b=r=pe([_(2,C.$Ri)],r)}),define(te[79],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$83b=void 0,e.$83b=(0,E.$ph)("protocolMainService")}),define(te[43],ie([0,1,135,10]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=void 0;class r{constructor(){this.a=new Map}add(R,S){E.ok(C.$je(R)),E.ok(C.$le(S)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,S)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Tm=new r}),define(te[235],ie([0,1,3,43]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0,e.$Um={JSONContribution:"base.contributions.json"};function r(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class O{constructor(){this.b=new E.$8c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,u){this.a[r(f)]=u,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const R=new O;C.$Tm.add(e.$Um.JSONContribution,R)}),define(te[59],ie([0,1,24,3,10,161,18,235,43]),function(V,e,E,C,r,O,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.ConfigurationScope=e.$Ym=e.EditPresentationTypes=void 0;var u;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(u||(e.EditPresentationTypes=u={})),e.$Ym={Configuration:"base.contributions.configuration"};var $;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})($||(e.ConfigurationScope=$={})),e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m={properties:{},patternProperties:{}},e.$5m={properties:{},patternProperties:{}},e.$6m="vscode://schemas/settings/resourceLanguage",e.$7m="vscode://schemas/settings/configurationDefaults";const d=f.$Tm.as(S.$Um.JSONContribution);class p{constructor(){this.h=new Set,this.i=new C.$8c,this.onDidSchemaChange=this.i.event,this.j=new C.$8c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},d.registerSchema(e.$6m,this.g),this.v()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const s=new Set;this.n(t,l,s),d.registerSchema(e.$6m,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const l=new Set;this.o(t,l),d.registerSchema(e.$6m,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:t,remove:l}){const s=new Set;this.o(l,s),this.n(t,!1,s),d.registerSchema(e.$6m,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const l=new Set;this.k(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(t,l){const s=[];for(const{overrides:n,source:i}of t)for(const a in n)if(l.add(a),e.$9m.test(a)){const m=this.a.get(a),P=m?.valuesSources??new Map;if(i)for(const L of Object.keys(n[a]))P.set(L,i);const I={...m?.value||{},...n[a]};this.a.set(a,{source:i,value:I,valuesSources:P});const D=(0,R.$6h)(a),M={type:"object",default:I,description:O.localize(1,null,D),$ref:e.$6m,defaultDefaultValue:I,source:r.$je(i)?void 0:i,defaultValueSource:i};s.push(...y(a)),this.d[a]=M,this.b.properties[a]=M}else{this.a.set(a,{value:n[a],source:i});const m=this.d[a];m&&(this.w(a,m),this.r(a,m))}this.m(s)}deregisterDefaultConfigurations(t){const l=new Set;this.l(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(t,l){for(const{overrides:s,source:n}of t)for(const i in s){const a=this.a.get(i),m=r.$je(n)?n:n?.id,P=r.$je(a?.source)?a?.source:a?.source?.id;if(m===P)if(l.add(i),this.a.delete(i),e.$9m.test(i))delete this.d[i],delete this.b.properties[i];else{const I=this.d[i];I&&(this.w(i,I),this.r(i,I))}}this.u()}deltaConfiguration(t){let l=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),l=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),l=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const l of t)this.h.add(l);this.u()}n(t,l,s){t.forEach(n=>{this.p(n,l,n.extensionInfo,n.restrictedProperties,void 0,s),this.c.push(n),this.q(n)})}o(t,l){const s=n=>{if(n.properties)for(const i in n.properties){l.add(i);const a=this.d[i];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[i],this.s(i,n.properties[i])}n.allOf?.forEach(i=>s(i))};for(const n of t){s(n);const i=this.c.indexOf(n);i!==-1&&this.c.splice(i,1)}}p(t,l=!0,s,n,i=3,a){i=r.$se(t.scope)?i:t.scope;const m=t.properties;if(m)for(const I in m){const D=m[I];if(l&&b(I,D)){delete m[I];continue}if(D.source=s,D.defaultDefaultValue=m[I].default,this.w(I,D),e.$9m.test(I)?D.scope=void 0:(D.scope=r.$se(D.scope)?i:D.scope,D.restricted=r.$se(D.restricted)?!!n?.includes(I):D.restricted),m[I].hasOwnProperty("included")&&!m[I].included){this.f[I]=m[I],delete m[I];continue}else this.d[I]=m[I],m[I].policy?.name&&this.e.set(m[I].policy.name,I);!m[I].deprecationMessage&&m[I].markdownDeprecationMessage&&(m[I].deprecationMessage=m[I].markdownDeprecationMessage),a.add(I)}const P=t.allOf;if(P)for(const I of P)this.p(I,l,s,n,i,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const l=s=>{const n=s.properties;if(n)for(const a in n)this.r(a,n[a]);s.allOf?.forEach(l)};l(t)}r(t,l){switch(e.$Zm.properties[t]=l,l.scope){case 1:e.$1m.properties[t]=l;break;case 2:e.$2m.properties[t]=l;break;case 6:e.$3m.properties[t]=l;break;case 3:e.$4m.properties[t]=l;break;case 4:e.$5m.properties[t]=l;break;case 5:e.$5m.properties[t]=l,this.g.properties[t]=l;break}}s(t,l){switch(delete e.$Zm.properties[t],l.scope){case 1:delete e.$1m.properties[t];break;case 2:delete e.$2m.properties[t];break;case 6:delete e.$3m.properties[t];break;case 3:delete e.$4m.properties[t];break;case 4:case 5:delete e.$5m.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const l=`[${t}]`,s={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$6m};this.w(l,s),e.$Zm.properties[l]=s,e.$1m.properties[l]=s,e.$2m.properties[l]=s,e.$3m.properties[l]=s,e.$4m.properties[l]=s,e.$5m.properties[l]=s}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$6m};e.$Zm.patternProperties[e.$8m]=t,e.$1m.patternProperties[e.$8m]=t,e.$2m.patternProperties[e.$8m]=t,e.$3m.patternProperties[e.$8m]=t,e.$4m.patternProperties[e.$8m]=t,e.$5m.patternProperties[e.$8m]=t,this.i.fire()}w(t,l){const s=this.a.get(t);let n=s?.value,i=s?.source;r.$qe(n)&&(n=l.defaultDefaultValue,i=void 0),r.$qe(n)&&(n=g(l.type)),l.default=n,l.defaultValueSource=i}}const h="\\[([^\\]]+)\\]",v=new RegExp(h,"g");e.$8m=`^(${h})+$`,e.$9m=new RegExp(e.$8m);function y(w){const t=[];if(e.$9m.test(w)){let l=v.exec(w);for(;l?.length;){const s=l[1].trim();s&&t.push(s),l=v.exec(w)}}return(0,E.$rf)(t)}e.$0m=y;function o(w){return w.reduce((t,l)=>`${t}[${l}]`,"")}e.$$m=o;function g(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$_m=g;const c=new p;f.$Tm.add(e.$Ym.Configuration,c);function b(w,t){return w.trim()?e.$9m.test(w)?O.localize(7,null,w):c.getConfigurationProperties()[w]!==void 0?O.localize(8,null,w):t.policy?.name&&c.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,w,t.policy?.name,c.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}e.$an=b;function k(){const w=[],t=c.getConfigurationProperties();for(const l of Object.keys(t))w.push([l,t[l].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.$bn=k}),define(te[119],ie([0,1,24,3,44,2,35,37,10,7,18,59,43]),function(V,e,E,C,r,O,R,S,f,u,$,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=void 0;function h(l){return Object.isFrozen(l)?l:S.$Im(l)}class v{constructor(s={},n=[],i=[],a){this.b=s,this.c=n,this.d=i,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof v)return n;const i=new y("");return i.parseRaw(n),i.configurationModel});this.f=s.reduce((n,i)=>i===n?i:n.merge(i),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,$.$4h)(this.contents,s):this.contents}inspect(s,n){const i=this.rawConfiguration.getValue(s),a=n?this.rawConfiguration.getOverrideValue(s,n):void 0,m=n?this.rawConfiguration.override(n).getValue(s):i;return{value:i,override:a,merged:m}}getOverrideValue(s,n){const i=this.i(n);return i?s?(0,$.$4h)(i,s):i:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const i of this.overrides)i.identifiers.includes(s)&&n.push(...i.keys);return E.$rf(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return E.$rf(s)}override(s){let n=this.a.get(s);return n||(n=this.g(s),this.a.set(s,n)),n}merge(...s){const n=S.$Hm(this.contents),i=S.$Hm(this.overrides),a=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const P of s)if(m.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(n,P.contents);for(const I of P.overrides){const[D]=i.filter(M=>E.$bf(M.identifiers,I.identifiers));D?(this.h(D.contents,I.contents),D.keys.push(...I.keys),D.keys=E.$rf(D.keys)):i.push(S.$Hm(I))}for(const I of P.keys)a.indexOf(I)===-1&&a.push(I)}return new v(n,a,i,m.every(P=>P instanceof v)?void 0:m)}g(s){const n=this.i(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const a of E.$rf([...Object.keys(this.contents),...Object.keys(n)])){let m=this.contents[a];const P=n[a];P&&(typeof m=="object"&&typeof P=="object"?(m=S.$Hm(m),this.h(m,P)):m=P),i[a]=m}return new v(i,this.keys,this.overrides)}h(s,n){for(const i of Object.keys(n)){if(i in s&&f.$le(s[i])&&f.$le(n[i])){this.h(s[i],n[i]);continue}s[i]=S.$Hm(n[i])}}i(s){let n=null,i=null;const a=m=>{m&&(i?this.h(i,m):i=S.$Hm(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===s?n=m.contents:m.identifiers.includes(s)&&a(m.contents);return a(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.j(s,n,!0)}setValue(s,n){this.j(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,$.$3h)(this.contents,s),d.$9m.test(s)&&this.overrides.splice(this.overrides.findIndex(i=>E.$bf(i.identifiers,(0,d.$0m)(s))),1))}j(s,n,i){(0,$.$2h)(this.contents,s,n,a=>console.error(a)),i=i||this.keys.indexOf(s)===-1,i&&this.keys.push(s),d.$9m.test(s)&&this.overrides.push({identifiers:(0,d.$0m)(s),keys:Object.keys(this.contents[s]),contents:(0,$.$1h)(this.contents[s],a=>console.error(a))})}}e.$cn=v;class y{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!f.$se(s)){const i=this.g(s);this.parseRaw(i,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:i,keys:a,overrides:m,restricted:P,hasExcludedProperties:I}=this.h(s,n);this.b=new v(i,a,m,I?[s]:void 0),this.c=P||[]}g(s){let n={},i=null,a=[];const m=[],P=[];function I(M){Array.isArray(a)?a.push(M):i!==null&&(a[i]=M)}const D={onObjectBegin:()=>{const M={};I(M),m.push(a),a=M,i=null},onObjectProperty:M=>{i=M},onObjectEnd:()=>{a=m.pop()},onArrayBegin:()=>{const M=[];I(M),m.push(a),a=M,i=null},onArrayEnd:()=>{a=m.pop()},onLiteralValue:I,onError:(M,L,N)=>{P.push({error:M,offset:L,length:N})}};if(s)try{r.$Em(s,D),n=a[0]||{}}catch(M){console.error(`Error while parsing settings file ${this.f}: ${M}`),this.d=[M]}return n}h(s,n){const i=p.$Tm.as(d.$Ym.Configuration).getConfigurationProperties(),a=this.i(s,i,!0,n);s=a.raw;const m=(0,$.$1h)(s,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),P=Object.keys(s),I=this.j(s,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:m,keys:P,overrides:I,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(s,n,i,a){let m=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:m};const P={},I=[];for(const D in s)if(d.$9m.test(D)&&i){const M=this.i(s[D],n,!1,a);P[D]=M.raw,m=m||M.hasExcludedProperties,I.push(...M.restricted)}else{const M=n[D],L=M?typeof M.scope<"u"?M.scope:3:void 0;M?.restricted&&I.push(D),!a.exclude?.includes(D)&&(a.include?.includes(D)||(L===void 0||a.scopes===void 0||a.scopes.includes(L))&&!(a.skipRestricted&&M?.restricted))?P[D]=s[D]:m=!0}return{raw:P,restricted:I,hasExcludedProperties:m}}j(s,n){const i=[];for(const a of Object.keys(s))if(d.$9m.test(a)){const m={};for(const P in s[a])m[P]=s[a][P];i.push({identifiers:(0,d.$0m)(a),keys:Object.keys(m),contents:(0,$.$1h)(m,n)})}return i}}e.$dn=y;class o extends O.$lb{constructor(s,n,i,a){super(),this.c=s,this.f=n,this.g=a,this.b=this.B(new C.$8c),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,m=>m.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,m=>(m.isOperation(0)||m.isOperation(3)||m.isOperation(1)||m.isOperation(4))&&i.isEqual(m.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$en=o;class g{constructor(s,n,i,a,m,P,I,D,M,L,N,B,re){this.a=s,this.b=n,this.c=i,this.overrideIdentifiers=a,this.d=m,this.f=P,this.g=I,this.h=D,this.i=M,this.j=L,this.k=N,this.l=B,this.m=re}get value(){return h(this.c)}n(s,n,i){const a=s.inspect(n,i);return{get value(){return h(a.value)},get override(){return h(a.override)},get merged(){return h(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(s,n,i,a,m=new v,P=new v,I=new R.$ni,D=new v,M=new R.$ni){this.c=s,this.d=n,this.f=i,this.g=a,this.h=m,this.i=P,this.j=I,this.l=D,this.m=M,this.a=null,this.b=new R.$ni,this.n=null}getValue(s,n,i){return this.q(s,n,i).getValue(s)}updateValue(s,n,i={}){let a;i.resource?(a=this.m.get(i.resource),a||(a=new v,this.m.set(i.resource,a))):a=this.l,n===void 0?a.removeValue(s):a.setValue(s,n),i.resource||(this.a=null)}inspect(s,n,i){const a=this.q(s,n,i),m=this.u(n.resource,i),P=n.resource?this.m.get(n.resource)||this.l:this.l,I=new Set;for(const D of a.overrides)for(const M of D.identifiers)a.getOverrideValue(s,M)!==void 0&&I.add(M);return new g(s,n,a.getValue(s),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,m||void 0,P)}keys(s){const n=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,n){this.j.set(s,n),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const i=[];if(!n){const{added:a,updated:m,removed:P}=w(this.c,s);n=[...a,...m,...P]}for(const a of n)for(const m of(0,d.$0m)(a)){const P=this.c.getKeysForOverrideIdentifier(m),I=s.getKeysForOverrideIdentifier(m),D=[...I.filter(M=>P.indexOf(M)===-1),...P.filter(M=>I.indexOf(M)===-1),...P.filter(M=>!S.$Lm(this.c.override(m).getValue(M),s.override(m).getValue(M)))];i.push([m,D])}return this.updateDefaultConfiguration(s),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:i,removed:a}=w(this.d,s),m=[...n,...i,...a];return m.length&&this.updatePolicyConfiguration(s),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:i,removed:a,overrides:m}=w(this.applicationConfiguration,s),P=[...n,...i,...a];return P.length&&this.updateApplicationConfiguration(s),{keys:P,overrides:m}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:i,removed:a,overrides:m}=w(this.localUserConfiguration,s),P=[...n,...i,...a];return P.length&&this.updateLocalUserConfiguration(s),{keys:P,overrides:m}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:i,removed:a,overrides:m}=w(this.remoteUserConfiguration,s),P=[...n,...i,...a];return P.length&&this.updateRemoteUserConfiguration(s),{keys:P,overrides:m}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:i,removed:a,overrides:m}=w(this.workspaceConfiguration,s),P=[...n,...i,...a];return P.length&&this.updateWorkspaceConfiguration(s),{keys:P,overrides:m}}compareAndUpdateFolderConfiguration(s,n){const i=this.p.get(s),{added:a,updated:m,removed:P,overrides:I}=w(i,n),D=[...a,...m,...P];return(D.length||!i)&&this.updateFolderConfiguration(s,n),{keys:D,overrides:I}}compareAndDeleteFolderConfiguration(s){const n=this.p.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:i,updated:a,removed:m,overrides:P}=w(n,void 0);return{keys:[...i,...a,...m],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,n,i){let a=this.r(n,i);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(a=a.merge(this.d)),a}r({resource:s},n){let i=this.s();if(n&&s){const a=n.getFolder(s);a&&(i=this.t(a.uri)||i);const m=this.m.get(s);m&&(i=i.merge(m))}return i}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let n=this.b.get(s);if(!n){const i=this.s(),a=this.j.get(s);a?(n=i.merge(a),this.b.set(s,n)):n=i}return n}u(s,n){if(n&&s){const i=n.getFolder(s);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,n)=>{const{contents:i,overrides:a,keys:m}=this.j.get(n);return s.push([n,{contents:i,overrides:a,keys:m}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this.i.keys.forEach(n=>s.add(n)),this.j.forEach(n=>n.keys.forEach(i=>s.add(i))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(i=>s.add(i))),[...s.values()]}w(s){const n=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.i.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(s).forEach(a=>n.add(a))),[...n.values()]}static parse(s){const n=this.x(s.defaults),i=this.x(s.policy),a=this.x(s.application),m=this.x(s.user),P=this.x(s.workspace),I=s.folders.reduce((D,M)=>(D.set(u.URI.revive(M[0]),this.x(M[1])),D),new R.$ni);return new c(n,i,a,m,new v,P,I,new v,new R.$ni)}static x(s){return new v(s.contents,s.keys,s.overrides)}}e.$fn=c;function b(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const s=new Set,n=new Map;for(const a of l)a.keys.forEach(m=>s.add(m)),a.overrides.forEach(([m,P])=>{const I=(0,R.$ki)(n,m,new Set);P.forEach(D=>I.add(D))});const i=[];return n.forEach((a,m)=>i.push([m,[...a.values()]])),{keys:[...s.values()],overrides:i}}e.$gn=b;class k{constructor(s,n,i,a){this.change=s,this.f=n,this.g=i,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const m of s.keys)this.affectedKeys.add(m);for(const[,m]of s.overrides)for(const P of m)this.affectedKeys.add(P);this.d=this.a;for(const m of this.affectedKeys)this.d+=m+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(s,n){const i=this.a+s,a=this.d.indexOf(i);if(a<0)return!1;const m=a+i.length;if(m>=this.d.length)return!1;const P=this.d.charCodeAt(m);if(P!==this.b&&P!==this.c)return!1;if(n){const I=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.f?.workspace):void 0,D=this.g.getValue(s,n,this.h);return!S.$Lm(I,D)}return!0}}e.$hn=k;function w(l,s){const{added:n,removed:i,updated:a}=t(s?.rawConfiguration,l?.rawConfiguration),m=[],P=l?.getAllOverrideIdentifiers()||[],I=s?.getAllOverrideIdentifiers()||[];if(s){const D=I.filter(M=>!P.includes(M));for(const M of D)m.push([M,s.getKeysForOverrideIdentifier(M)])}if(l){const D=P.filter(M=>!I.includes(M));for(const M of D)m.push([M,l.getKeysForOverrideIdentifier(M)])}if(s&&l){for(const D of P)if(I.includes(D)){const M=t({contents:l.getOverrideValue(void 0,D)||{},keys:l.getKeysForOverrideIdentifier(D)},{contents:s.getOverrideValue(void 0,D)||{},keys:s.getKeysForOverrideIdentifier(D)});m.push([D,[...M.added,...M.removed,...M.updated]])}}return{added:n,removed:i,updated:a,overrides:m}}function t(l,s){const n=l?s?l.keys.filter(m=>s.keys.indexOf(m)===-1):[...l.keys]:[],i=s?l?s.keys.filter(m=>l.keys.indexOf(m)===-1):[...s.keys]:[],a=[];if(l&&s){for(const m of s.keys)if(l.keys.indexOf(m)!==-1){const P=(0,$.$4h)(s.contents,m),I=(0,$.$4h)(l.contents,m);S.$Lm(P,I)||a.push(m)}}return{added:n,removed:i,updated:a}}}),define(te[236],ie([0,1,24,3,2,37,10,119,59,5,39,43]),function(V,e,E,C,r,O,R,S,f,u,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=void 0;class p extends r.$lb{constructor(){super(...arguments),this.a=this.B(new C.$8c),this.onDidChangeConfiguration=this.a.event,this.b=new S.$cn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(d.$Tm.as(f.$Ym.Configuration).onDidUpdateConfiguration(({properties:o,defaultsOverrides:g})=>this.c(Array.from(o),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(o,g){this.h(o,d.$Tm.as(f.$Ym.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:o})}f(){return{}}g(){this.b=new S.$cn;const o=d.$Tm.as(f.$Ym.Configuration).getConfigurationProperties();this.h(Object.keys(o),o)}h(o,g){const c=this.f();for(const b of o){const k=c[b],w=g[b];k!==void 0?this.b.addValue(b,k):w?this.b.addValue(b,w.default):this.b.removeValue(b)}}}e.$in=p;class h{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=new S.$cn}async initialize(){return this.configurationModel}}e.$jn=h;let v=class extends r.$lb{get configurationModel(){return this.b}constructor(o,g,c){super(),this.c=o,this.f=g,this.g=c,this.a=this.B(new C.$8c),this.onDidChangeConfiguration=this.a.event,this.b=new S.$cn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(o=>this.i(o))),this.B(this.c.onDidChangeConfiguration(async({properties:o})=>this.j(await this.h(o),!0))),this.b}async h(o){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",o);const g={},c=[],b=d.$Tm.as(f.$Ym.Configuration).getConfigurationProperties();for(const k of o){const w=b[k];if(!w){c.push(k);continue}if(w.policy){if(w.type!=="string"&&w.type!=="number"){this.g.warn(`Policy ${w.policy.name} has unsupported type ${w.type}`);continue}c.push(k),g[w.policy.name]={type:w.type}}}return(0,R.$we)(g)||await this.f.updatePolicyDefinitions(g),c}i(o){this.g.trace("PolicyConfiguration#onDidChangePolicies",o);const g=d.$Tm.as(f.$Ym.Configuration).getPolicyConfigurations(),c=(0,E.$mf)(o.map(b=>g.get(b)));this.j(c,!0)}j(o,g){this.g.trace("PolicyConfiguration#update",o);const c=d.$Tm.as(f.$Ym.Configuration).getConfigurationProperties(),b=[],k=this.b.isEmpty();for(const w of o){const t=c[w]?.policy?.name;if(t){const l=this.f.getPolicyValue(t);(k?l!==void 0:!(0,O.$Lm)(this.b.getValue(w),l))&&b.push([w,l])}else this.b.getValue(w)!==void 0&&b.push([w,void 0])}if(b.length){this.g.trace("PolicyConfiguration#changed",b);const w=this.b;this.b=new S.$cn;for(const t of w.keys)this.b.setValue(t,w.getValue(t));for(const[t,l]of b)l===void 0?this.b.removeValue(t):this.b.setValue(t,l);g&&this.a.fire(this.b)}}};e.$kn=v,e.$kn=v=pe([_(1,$.$Vm),_(2,u.$Ri)],v)}),define(te[237],ie([0,1,8,3,2,19,18,119,236,39]),function(V,e,E,C,r,O,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0;class $ extends r.$lb{constructor(p,h,v,y){super(),this.i=p,this.h=this.B(new C.$8c),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$in),this.c=v instanceof u.$Xm?new f.$jn:this.B(new f.$kn(this.b,v,y)),this.f=this.B(new S.$en(this.i,{},O.$1f,h)),this.a=new S.$fn(this.b.configurationModel,this.c.configurationModel,new S.$cn,new S.$cn),this.g=this.B(new E.$Gg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:o,properties:g})=>this.k(o,g))),this.B(this.c.onDidChangeConfiguration(o=>this.l(o))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,h,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.$fn(p,h,new S.$cn,v)}getConfigurationData(){return this.a.toData()}getValue(p,h){const v=typeof p=="string"?p:void 0,y=(0,R.$Wh)(p)?p:(0,R.$Wh)(h)?h:{};return this.a.getValue(v,y,void 0)}updateValue(p,h,v,y){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.j(p)}j(p){const h=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(p);this.m(v,h,2)}k(p,h){const v=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(p,h);this.m(y,v,7)}l(p){const h=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(p);this.m(v,h,7)}m(p,h,v){const y=new S.$hn(p,{data:h},this.a);y.source=v,y.sourceConfig=this.n(v),this.h.fire(y)}n(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$ln=$}),define(te[238],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$34b=e.$24b=e.$14b=void 0,e.$14b="request",e.$24b="remoteResourceHandler";class E{async routeCall(r,O,R){if(O!==e.$14b)throw new Error(`Call not found: ${O}`);const S=R[0];if(S?.authority){const f=r.connections.find(u=>u.ctx===S.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(r,O){throw new Error(`Event not found: ${O}`)}}e.$34b=E}),define(te[239],ie([0,1,13,6]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.RemoteAuthorityResolverErrorCode=e.$yk=e.$xk=e.RemoteConnectionType=e.$wk=void 0,e.$wk=(0,C.$ph)("remoteAuthorityResolverService");var r;(function($){$[$.WebSocket=0]="WebSocket",$[$.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class O{constructor(d){this.id=d,this.type=1}toString(){return`Managed(${this.id})`}}e.$xk=O;class R{constructor(d,p){this.host=d,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$yk=R;var S;(function($){$.Unknown="Unknown",$.NotAvailable="NotAvailable",$.TemporarilyNotAvailable="TemporarilyNotAvailable",$.NoResolverFound="NoResolverFound",$.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class f extends E.$ab{static isNotAvailable(d){return d instanceof f&&d._code===S.NotAvailable}static isTemporarilyNotAvailable(d){return d instanceof f&&d._code===S.TemporarilyNotAvailable}static isNoResolverFound(d){return d instanceof f&&d._code===S.NoResolverFound}static isInvalidAuthority(d){return d instanceof f&&d._code===S.InvalidAuthority}static isHandled(d){return d instanceof f&&d.isHandled}constructor(d,p=S.Unknown,h){super(d),this._message=d,this._code=p,this._detail=h,this.isHandled=p===S.NotAvailable&&h===!0,Object.setPrototypeOf(this,f.prototype)}}e.$zk=f;function u($){const d=$.indexOf("+");return d===-1?$:$.substring(0,d)}e.$Ak=u}),define(te[60],ie([0,1,15]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=void 0;function C(u){return u.scheme===E.Schemas.vscodeRemote?u.authority:void 0}e.$Bk=C;function r(u){if(!u)return;const $=u.indexOf("+");return $<0?u:u.substr(0,$)}e.$Ck=r;function O(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.$Dk=O;function R(u){const{host:$,port:d}=f(u);if(typeof d>"u")throw new Error("Remote authority doesn't contain a port!");return{host:$,port:d}}e.$Ek=R;function S(u,$){let{host:d,port:p}=f(u);return typeof p>"u"&&(p=$),{host:d,port:p}}e.$Fk=S;function f(u){const $=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if($)return{host:$[1],port:parseInt($[2],10)};const d=u.match(/^(\[[0-9a-z:]+\])$/);if(d)return{host:d[1],port:void 0};const p=u.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:u,port:void 0}}}),define(te[120],ie([0,1,25,6,60]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.TargetPlatform=e.ExtensionType=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=void 0,e.$Bl="extensions.user.cache",e.$Cl="extensions.builtin.cache",e.$Dl="undefined_publisher",e.$El=["ui","workspace","web"];function O(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$Fl=O,e.$Gl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(R||(e.ExtensionType=R={}));var S;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class f{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,g){if(typeof o>"u"||o===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof o=="string"||typeof g=="string"){const c=typeof o=="string"?o:o.value,b=typeof g=="string"?g:g.value;return E.$Md(c,b)}return o._lower===g._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Hl=f;class u{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const g of o)this.add(g)}add(o){this.c.add(f.toKey(o))}delete(o){return this.c.delete(f.toKey(o))}has(o){return this.c.has(f.toKey(o))}}e.$Il=u;class ${constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(f.toKey(o))}get(o){return this.c.get(f.toKey(o))}has(o){return this.c.has(f.toKey(o))}set(o,g){this.c.set(f.toKey(o),g)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Jl=$;function d(y){return p(y)}e.$Kl=d;function p(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$Ll=p;function h(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$Ml=h;function v(y,o){if(o){const g=`onResolveRemoteAuthority:${(0,r.$Ck)(o)}`;return!!y.activationEvents?.includes(g)}return!1}e.$Nl=v,e.$Ol=(0,C.$ph)("IBuiltinExtensionsScannerService")}),define(te[240],ie([0,1,8,17,22,13,3,2,65,69,31,109,239,60]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.PersistentConnectionEventType=e.$Mk=e.$Lk=e.$Kk=e.ConnectionType=void 0;const v=30*1e3;var y;(function(j){j[j.Management=1]="Management",j[j.ExtensionHost=2]="ExtensionHost",j[j.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function o(j){switch(j){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(j){const A=new r.$ed;return setTimeout(()=>A.cancel(),j),A.token}function c(j,A){if(j.isCancellationRequested||A.isCancellationRequested)return r.CancellationToken.Cancelled;const F=new r.$ed;return j.onCancellationRequested(()=>F.cancel()),A.onCancellationRequested(()=>F.cancel()),F.token}class b{get didTimeout(){return this.c==="timedout"}constructor(A){this.c="pending",this.d=new S.$kb,this.promise=new Promise((F,q)=>{this.f=F,this.g=q}),A.isCancellationRequested?this.h():this.d.add(A.onCancellationRequested(()=>this.h()))}registerDisposable(A){this.c==="pending"?this.d.add(A):A.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(A))}reject(A){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(A))}}function k(j,A){const F=new b(A);return F.registerDisposable(j.onControlMessage(q=>{const G=JSON.parse(q.toString()),Z=T(G);Z?F.reject(Z):F.resolve(G)})),F.promise}function w(j,A,F,q,G,Z,z,Y){const x=new b(Y),ae=u.$4c.create(!1);return j.info(`Creating a socket (${z})...`),f.mark(`code/willCreateSocket/${Z}`),A.connect(F,q,G,z).then(he=>{x.didTimeout?(f.mark(`code/didCreateSocketError/${Z}`),j.info(`Creating a socket (${z}) finished after ${ae.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(f.mark(`code/didCreateSocketOK/${Z}`),j.info(`Creating a socket (${z}) was successful after ${ae.elapsed()} ms.`),x.resolve(he))},he=>{f.mark(`code/didCreateSocketError/${Z}`),j.info(`Creating a socket (${z}) returned an error after ${ae.elapsed()} ms.`),j.error(he),x.reject(he)}),x.promise}function t(j,A){const F=new b(A);return j.then(q=>{F.didTimeout||F.resolve(q)},q=>{F.didTimeout||F.reject(q)}),F.promise}async function l(j,A,F,q){const G=ce(j,A);j.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await w(j.logService,j.remoteSocketFactoryService,j.connectTo,(0,h.$Dk)(j),`reconnectionToken=${j.reconnectionToken}&reconnection=${j.reconnectionProtocol?"true":"false"}`,o(A),`renderer-${o(A)}-${j.reconnectionToken}`,q)}catch(he){throw j.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),j.logService.error(he),he}j.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let z,Y;j.reconnectionProtocol?(j.reconnectionProtocol.beginAcceptReconnection(Z,null),z=j.reconnectionProtocol,Y=!1):(z=new d.$dh({socket:Z}),Y=!0),j.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const x=await t(j.signService.createNewMessage((0,$.$6e)()),q),ae={type:"auth",auth:j.connectionToken||"00000000000000000000",data:x.data};z.sendControl(C.$Jb.fromString(JSON.stringify(ae)));try{const he=await k(z,c(q,g(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Me=new Error("Unexpected handshake message");throw Me.code="VSCODE_CONNECTION_ERROR",Me}if(j.logService.trace(`${G} 4/6. received SignRequest control message.`),!await t(j.signService.validate(x,he.signedData),q)){const Me=new Error("Refused to connect to unsupported server");throw Me.code="VSCODE_CONNECTION_ERROR",Me}const Ee=await t(j.signService.sign(he.data),q),Ae={type:"connectionType",commit:j.commit,signedData:Ee,desiredConnectionType:A};return F&&(Ae.args=F),j.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(C.$Jb.fromString(JSON.stringify(Ae))),{protocol:z,ownsProtocol:Y}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(j.logService.error(`${G} the handshake timed out. Error:`),j.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(j.logService.error(`${G} received error control message when negotiating connection. Error:`),j.logService.error(he)),Y&&U(z),he}}async function s(j,A,F,q){const G=Date.now(),Z=ce(j,A),{protocol:z,ownsProtocol:Y}=await l(j,A,F,q),x=new b(q);return x.registerDisposable(z.onControlMessage(ae=>{const he=JSON.parse(ae.toString()),Ie=T(he);Ie?(j.logService.error(`${Z} received error control message when negotiating connection. Error:`),j.logService.error(Ie),Y&&U(z),x.reject(Ie)):(j.reconnectionProtocol?.endAcceptReconnection(),j.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${oe(G)}!`),x.resolve({protocol:z,firstMessage:he}))})),x.promise}async function n(j,A){const{protocol:F}=await s(j,1,void 0,A);return{protocol:F}}async function i(j,A,F){const{protocol:q,firstMessage:G}=await s(j,2,A,F),Z=G&&G.debugPort;return{protocol:q,debugPort:Z}}async function a(j,A,F){const q=Date.now(),G=ce(j,3),{protocol:Z}=await l(j,3,A,F);return j.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${oe(q)}!`),Z}async function m(j,A,F){const{connectTo:q,connectionToken:G}=await j.addressProvider.getAddress();return{commit:j.commit,quality:j.quality,connectTo:q,connectionToken:G,reconnectionToken:A,reconnectionProtocol:F,remoteSocketFactoryService:j.remoteSocketFactoryService,signService:j.signService,logService:j.logService}}async function P(j,A,F){return D(j,async q=>{const{protocol:G}=await n(q,r.CancellationToken.None);return new J(j,A,F,q.reconnectionToken,G)})}e.$Kk=P;async function I(j,A){return D(j,async F=>{const{protocol:q,debugPort:G}=await i(F,A,r.CancellationToken.None);return new K(j,A,F.reconnectionToken,q,G)})}e.$Lk=I;async function D(j,A){for(let q=1;;q++)try{const G=(0,$.$6e)(),Z=await m(j,G,null);return await A(Z)}catch(G){if(q<5)j.logService.error(`[remote-connection][attempt ${q}] An error occurred in initial connection! Will retry... Error:`),j.logService.error(G);else throw j.logService.error(`[remote-connection][attempt ${q}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),j.logService.error(G),le.triggerPermanentFailure(0,0,p.$zk.isHandled(G)),G}}async function M(j,A,F){const q=await m(j,(0,$.$6e)(),null);return await a(q,{host:A,port:F},r.CancellationToken.None)}e.$Mk=M;function L(j){return(0,E.$jg)(A=>new Promise((F,q)=>{const G=setTimeout(F,j*1e3);A.onCancellationRequested(()=>{clearTimeout(G),F()})}))}var N;(function(j){j[j.ConnectionLost=0]="ConnectionLost",j[j.ReconnectionWait=1]="ReconnectionWait",j[j.ReconnectionRunning=2]="ReconnectionRunning",j[j.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",j[j.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class B{constructor(A,F){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.type=0}}e.$Nk=B;class re{constructor(A,F,q,G){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.durationSeconds=q,this.c=G,this.type=1}skipWait(){this.c.cancel()}}e.$Ok=re;class ne{constructor(A,F,q){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=q,this.type=2}}e.$Pk=ne;class ue{constructor(A,F,q){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=q,this.type=4}}e.$Qk=ue;class se{constructor(A,F,q,G){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=q,this.handled=G,this.type=3}}e.$Rk=se;class le extends S.$lb{static triggerPermanentFailure(A,F,q){this._permanentFailure=!0,this.f=A,this.g=F,this.h=q,this.i.forEach(G=>G.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(A=>A.s())}static debugPauseSocketWriting(){this.i.forEach(A=>A.w())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.i=[]}get k(){return this.c||le._permanentFailure}constructor(A,F,q,G,Z){super(),this.n=A,this.p=F,this.reconnectionToken=q,this.protocol=G,this.r=Z,this.j=this.B(new R.$8c),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new ue(this.reconnectionToken,0,0)),this.B(G.onSocketClose(z=>{const Y=Q(this.n,this.reconnectionToken,!0);z?z.type===0?(this.p.logService.info(`${Y} received socket close event (hadError: ${z.hadError}).`),z.error&&this.p.logService.error(z.error)):(this.p.logService.info(`${Y} received socket close event (wasClean: ${z.wasClean}, code: ${z.code}, reason: ${z.reason}).`),z.event&&this.p.logService.error(z.event)):this.p.logService.info(`${Y} received socket close event.`),this.s()})),this.B(G.onSocketTimeout(z=>{const Y=Q(this.n,this.reconnectionToken,!0);this.p.logService.info(`${Y} received socket timeout event (unacknowledgedMsgCount: ${z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${z.timeSinceLastReceivedSomeData}).`),this.s()})),le.i.push(this),this.B((0,S.$jb)(()=>{const z=le.i.indexOf(this);z>=0&&le.i.splice(z,1)})),this.k&&this.v(le.f,le.g,le.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const A=Q(this.n,this.reconnectionToken,!0);this.p.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const G=q<F.length?F[q]:F[F.length-1];try{if(G>0){const z=L(G);this.j.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G,z)),this.p.logService.info(`${A} waiting for ${G} seconds before reconnecting...`);try{await z}catch{}}if(this.k){this.p.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this.p.logService.info(`${A} resolving connection...`);const Z=await m(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${A} connecting to ${Z.connectTo}...`),await this.y(Z,g(v)),this.p.logService.info(`${A} reconnected!`),this.j.fire(new ue(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this.p.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(p.$zk.isTemporarilyNotAvailable(Z)){this.p.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.p.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Z);continue}if((0,O.$2)(Z)){this.p.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Z);continue}if(Z instanceof p.$zk){this.p.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),q+1,p.$zk.isHandled(Z));break}this.p.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!this.k&&!this.m)}u(A,F,q){this.r?le.triggerPermanentFailure(A,F,q):this.v(A,F,q)}v(A,F,q){this.j.fire(new se(this.reconnectionToken,A,F,q)),U(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.$Sk=le;class J extends le{constructor(A,F,q,G,Z){super(1,A,G,Z,!0),this.client=this.B(new d.$bh(Z,{remoteAuthority:F,clientId:q},A.ipcLogger))}async y(A,F){await n(A,F)}}e.$Tk=J;class K extends le{constructor(A,F,q,G,Z){super(2,A,q,G,!1),this.z=F,this.debugPort=Z}async y(A,F){await i(A,this.z,F)}}e.$Uk=K;function U(j){try{j.acceptDisconnect();const A=j.getSocket();j.dispose(),A.dispose()}catch(A){(0,O.$Y)(A)}}function T(j){if(j&&j.type==="error"){const A=new Error(`Connection error: ${j.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function W(j,A){for(;j.length<A;)j+=" ";return j}function H(j,A){return`[remote-connection][${W(o(j),13)}][${A.substr(0,5)}\u2026]`}function Q(j,A,F){return`${H(j,A)}[${F?"reconnect":"initial"}]`}function ce(j,A){return`${Q(A,j.reconnectionToken,!!j.reconnectionProtocol)}[${j.connectTo}]`}function oe(j){return`${Date.now()-j} ms`}}),define(te[241],ie([0,1,2,6]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=void 0,e.$Gk=(0,C.$ph)("remoteSocketFactoryService");class r{constructor(){this.a={}}register(R,S){return this.a[R]??=[],this.a[R].push(S),(0,E.$jb)(()=>{const f=this.a[R]?.indexOf(S);typeof f=="number"&&f>=0&&this.a[R]?.splice(f,1)})}b(R){return(this.a[R.type]||[]).find(f=>f.supports(R))}connect(R,S,f,u){const $=this.b(R);if(!$)throw new Error(`No socket factory found for ${R}`);return $.connect(R,S,f,u)}}e.$Hk=r}),define(te[242],ie([0,1,27,47,21,113]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$43b=void 0;let R;async function S(h=!1){return(R===void 0||h)&&(R=f()),R}e.$43b=S;async function f(){const h=u();if(h===void 0)return!1;if(h>=22e3){const v=d();if(v)return new Promise(y=>{C.execFile(v,["--status"],o=>y(!o))})}else{const v=p();if(v)try{if((await r.Promises.stat(v)).isFile())return!0}catch{}}return!1}function u(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(h)return parseInt(h[3])}function $(h){const v=process.env.SystemRoot;if(v){const y=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return O.join(v,y?"Sysnative":"System32",h)}}function d(){return $("wsl.exe")}function p(){return $("lxss\\LxssManager.dll")}}),define(te[51],ie([0,1,17,13,2,181,59,6,5,43]),function(V,e,E,C,r,O,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=void 0,e.$yo=(0,S.$ph)("requestService");class ${constructor(w){this.b=w}toJSON(){if(!this.a){const w=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?w[t]="*****":w[t]=this.b[t];this.a=w}return this.a}}class d extends r.$lb{constructor(w){super(),this.b=0,this.a=w.createLogger("network",{name:(0,O.localize)(0,null),when:f.$9i.isEqualTo((0,f.$7i)(f.LogLevel.Trace)).serialize()})}async c(w,t,l){const s=`${w} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new $(t.headers??{}));try{const n=await l();return this.a.trace(`${s} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${s} - error`,t.type,(0,C.$9)(n)),n}}}e.$zo=d;function p(k){return k.res.statusCode&&k.res.statusCode>=200&&k.res.statusCode<300||k.res.statusCode===1223}e.$Ao=p;function h(k){return k.res.statusCode===204}async function v(k){return h(k)?null:(await(0,E.$Vb)(k.stream)).toString()}e.$Bo=v;async function y(k){if(!p(k))throw new Error("Server returned "+k.res.statusCode);return v(k)}e.$Co=y;async function o(k){if(!p(k))throw new Error("Server returned "+k.res.statusCode);if(h(k))return null;const t=(await(0,E.$Vb)(k.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}e.$Do=o;function g(k){b(k)}e.$Eo=g;let c;function b(k){const w=u.$Tm.as(R.$Ym.Configuration),t=c;c={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:k,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0}}},w.updateConfigurations({add:[c],remove:t?[t]:[]})}b(1)}),define(te[243],ie([0,1,17,22]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$Aq=void 0;class r{constructor(S){this.a=S}listen(S,f){throw new Error("Invalid listen")}call(S,f,u,$=C.CancellationToken.None){switch(f){case"request":return this.a.request(u[0],$).then(async({res:d,stream:p})=>{const h=await(0,E.$Vb)(p);return[{statusCode:d.statusCode,headers:d.headers},h]});case"resolveProxy":return this.a.resolveProxy(u[0])}throw new Error("Invalid call")}}e.$Aq=r;class O{constructor(S){this.a=S}async request(S,f){const[u,$]=await this.a.call("request",[S],f);return{res:u,stream:(0,E.$Xb)($)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}}e.$Bq=O}),define(te[244],ie([0,1,245,10]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;function r(R,S){return R.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:R.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function O(R,S,f={}){const u=(0,E.parse)(R),$=f.proxyUrl||r(u,S);if(!$)return null;const d=(0,E.parse)($);if(!/^https?:$/.test(d.protocol||""))return null;const p={host:d.hostname||"",port:d.port||(d.protocol==="https"?"443":"80"),auth:d.auth,rejectUnauthorized:(0,C.$pe)(f.strictSSL)?f.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((h,v)=>{V(["http-proxy-agent"],h,v)}))(p):new(await new Promise((h,v)=>{V(["https-proxy-agent"],h,v)}))(p)}e.$Cq=O}),define(te[95],ie([0,1,47,9,182,22,50,13,4,31,108,63,8,138]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=void 0;let v;async function y(g,c,b,k){return b["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$i?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,d.$sl)(k)&&!b["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,d.$sl)(k)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=p.Promises.withAsyncBody(async(w,t)=>{const l=new O.$ed;let s=1e4;const n=g.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(s=(0,h.$tl)(n,1,120)*1e3);const i=setTimeout(()=>{l.dispose(!0),t(new Error((0,r.localize)(0,null)))},s);try{w(await o(c,l.token))}catch(a){!(0,S.$2)(a)&&!l.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,R.$ai)(a)))):w({})}finally{clearTimeout(i),l.dispose()}})),v)}e.$yl=y;async function o(g,c){const b=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",b);const k=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",k);const w=(0,u.$6e)().replace(/-/g,"").substr(0,12),t=new RegExp(w+"({.*})"+w),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",l);const s=await(0,$.$jl)(f.OS,l);return g.trace("getUnixShellEnvironment#shell",s),new Promise((n,i)=>{if(c.isCancellationRequested)return i(new S.$3);const a=(0,C.$ec)(s);let m,P;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(m=`& '${process.execPath}' ${I} -p '''${w}'' + JSON.stringify(process.env) + ''${w}'''`,P=["-Login","-Command"]):a==="nu"?(m=`^'${process.execPath}' ${I} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,P=["-i","-l","-c"]):(m=`'${process.execPath}' ${I} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,a==="tcsh"||a==="csh"?P=["-ic"]:P=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),m);const D=(0,E.spawn)(s,[...P,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});c.onCancellationRequested(()=>(D.kill(),i(new S.$3))),D.on("error",N=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,R.$ai)(N)),i(N)});const M=[];D.stdout.on("data",N=>M.push(N));const L=[];D.stderr.on("data",N=>L.push(N)),D.on("close",(N,B)=>{const re=Buffer.concat(M).toString("utf8");g.trace("getUnixShellEnvironment#raw",re);const ne=Buffer.concat(L).toString("utf8");if(ne.trim()&&g.trace("getUnixShellEnvironment#stderr",ne),N||B)return i(new Error((0,r.localize)(2,null,N,B)));const ue=t.exec(re),se=ue?ue[1]:"{}";try{const le=JSON.parse(se);b?le.ELECTRON_RUN_AS_NODE=b:delete le.ELECTRON_RUN_AS_NODE,k?le.ELECTRON_NO_ATTACH_CONSOLE=k:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",le),n(le)}catch(le){g.error("getUnixShellEnvironment#errorCaught",(0,R.$ai)(le)),i(le)}})})}}),define(te[246],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pZb=void 0;class E{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(r){try{const O=await this.c();if(O){const R=String(E.a++);return this.b.set(R,O),{id:R,data:O.createNewMessage(r)}}}catch{}return{id:"",data:r}}async validate(r,O){if(!r.id)return!0;const R=this.b.get(r.id);if(!R)return!1;this.b.delete(r.id);try{return R.validate(O)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(r){try{return await this.d(r)}catch{}return r}}e.$pZb=E}),define(te[96],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.$Ik=void 0,e.$Ik="signService",e.$Jk=(0,E.$ph)(e.$Ik)}),define(te[247],ie([0,1,246]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$4b=void 0;class C extends E.$pZb{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(R=>new R.signer().sign(O))}h(){return new Promise((O,R)=>V(["vsda"],O,R))}}e.$$4b=C}),define(te[34],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=void 0,e.$RM=(0,E.$ph)("stateReadService"),e.$SM=(0,E.$ph)("stateService")}),define(te[121],ie([0,1,8,17,10,33,16,5]),function(V,e,E,C,r,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.$UM=e.$TM=e.SaveStrategy=void 0;var f;(function(p){p[p.IMMEDIATE=0]="IMMEDIATE",p[p.DELAYED=1]="DELAYED"})(f||(e.SaveStrategy=f={}));class u{constructor(h,v,y,o){this.f=h,this.g=y,this.h=o,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=v===0?void 0:new E.$tg(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(h){h.fileOperationResult!==1&&this.g.error(h)}}getItem(h,v){const y=this.a[h];return(0,r.$se)(y)?v:y}setItem(h,v){this.setItems([{key:h,data:v}])}setItems(h){let v=!1;for(const{key:y,data:o}of h)this.a[y]!==o&&((0,r.$se)(o)?(0,r.$qe)(this.a[y])||(this.a[y]=void 0,v=!0):(this.a[y]=o,v=!0));v&&this.j()}removeItem(h){(0,r.$qe)(this.a[h])||(this.a[h]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const h=JSON.stringify(this.a,null,4);if(h!==this.b)try{await this.h.writeFile(this.f,C.$Jb.fromString(h),{atomic:{postfix:".vsctmp"}}),this.b=h}catch(v){this.g.error(v)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.$TM=u;let $=class{constructor(h,v,y,o){this.a=new u(v.stateResource,h,y,o)}async init(){await this.a.init()}getItem(h,v){return this.a.getItem(h,v)}};e.$UM=$,e.$UM=$=pe([_(1,O.$wh),_(2,S.$Ri),_(3,R.$Sj)],$);class d extends ${setItem(h,v){this.a.setItem(h,v)}setItems(h){this.a.setItems(h)}removeItem(h){this.a.removeItem(h)}close(){return this.a.close()}}e.$VM=d}),define(te[122],ie([0,1,4,36,31]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=void 0;function O(f){if(E.$t===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function R(f,u,$,d,p,h,v,y){const o=Object.create(null);o["common.machineId"]=h,o.sessionID=(0,r.$6e)()+Date.now(),o.commitHash=d,o.version=p,o["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,E.$h)(E.$t),o["common.nodePlatform"]=C.$7b,o["common.nodeArch"]=$,o["common.product"]=y||"desktop",v&&(o["common.msftInternal"]=v);let g=0;const c=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),E.$l&&(o["common.snap"]="true");const b=O(u);return b&&(o["common.platformDetail"]=b),o}e.$Zn=R;function S(f){const u=C.env.USERDNSDOMAIN;if(!u)return!1;const $=u.toLowerCase();return f.some(d=>$===d)}e.$1n=S}),define(te[26],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0,e.$Vk=(0,E.$ph)("telemetryService"),e.$Wk=(0,E.$ph)("customEndpointTelemetryService"),e.$Xk="telemetry.currentSessionDate",e.$Yk="telemetry.firstSessionDate",e.$Zk="telemetry.lastSessionDate",e.$1k="telemetry.machineId",e.$2k="telemetry",e.$3k="telemetry.telemetryLevel",e.$4k="telemetry.enableCrashReporter",e.$5k="telemetry.enableTelemetry";var C;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var r;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(te[248],ie([0,1,27,8,44,15,9,4,7,87,21,107,91,16,23,26]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=e.$hr=e.$gr=void 0;const o=new Map;async function g(t,l){const s=`${t}::${l.join(":")}`,n=o.get(s);if(n)return n;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,m=new Map,P=2e4;function I(M,L,N,B){const re=L.substring(M.length+1);return C.Promises.withAsyncBody(async ne=>{let ue;try{ue=await $.Promises.readdir(L,{withFileTypes:!0})}catch{ne();return}if(B.count>=P){B.count+=ue.length,B.maxReached=!0,ne();return}let se=ue.length;if(se===0){ne();return}let le=ue;B.count+ue.length>P&&(B.maxReached=!0,se=P-B.count,le=ue.slice(0,se)),B.count+=ue.length;for(const J of le)if(J.isDirectory()){if(N.includes(J.name)||await I(M,(0,R.$ac)(L,J.name),N,B),--se===0){ne();return}}else{const K=J.name.lastIndexOf(".");if(K>=0){const U=J.name.substring(K+1);U&&a.set(U,(a.get(U)??0)+1)}for(const U of i)U.relativePathPattern?.test(re)!==!1&&U.filePattern.test(J.name)&&m.set(U.tag,(m.get(U.tag)??0)+1);if(--se===0){ne();return}}})}const D=C.Promises.withAsyncBody(async M=>{const L={count:0,maxReached:!1};await I(t,t,l,L);const N=await k(t);M({configFiles:c(m),fileTypes:c(a),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:N})});return o.set(s,D),D}e.$gr=g;function c(t){return Array.from(t.entries(),([l,s])=>({name:l,count:s})).sort((l,s)=>s.count-l.count)}function b(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/h.$nk.GB).toFixed(2)}GB (${(E.freemem()/h.$nk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.$tm.value()*100)}%`},l=E.cpus();return l&&l.length>0&&(t.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),t}e.$hr=b;async function k(t){try{const l=new Map,s=(0,R.$ac)(t,".vscode","launch.json"),n=await $.Promises.readFile(s),i=[],a=(0,r.$xm)(n.toString(),i);if(i.length)return console.log(`Unable to parse ${s}`),[];if((0,r.$Gm)(a)==="object"&&a.configurations)for(const m of a.configurations){const P=m.type;P&&(l.has(P)?l.set(P,l.get(P)+1):l.set(P,1))}return c(l)}catch{return[]}}e.$ir=k;let w=class{constructor(l,s){this.c=l,this.d=s}f(l){const s=[];return s.push(`OS Version:       ${l.os}`),s.push(`CPUs:             ${l.cpus}`),s.push(`Memory (System):  ${l.memory}`),s.push(`VM:               ${l.vmHint}`),s.join(`
`)}g(l){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const n=E.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(E.totalmem()/h.$nk.GB).toFixed(2)}GB (${(E.freemem()/h.$nk.GB).toFixed(2)}GB free)`),S.$i||s.push(`Load (avg):       ${E.loadavg().map(i=>Math.round(i)).join(", ")}`),s.push(`VM:               ${Math.round(u.$tm.value()*100)}%`),s.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${l.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(l.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(l,s){return Promise.all([(0,d.$fr)(l.mainPID),this.k(l)]).then(async n=>{let[i,a]=n,m=this.m(l,i);return s.forEach(P=>{if((0,p.$6l)(P))m+=`
${P.errorMessage}`,a+=`
${P.errorMessage}`;else if(m+=`

Remote: ${P.hostName}`,P.processes&&(m+=`
${this.m(l,P.processes)}`),P.workspaceMetadata){a+=`
|  Remote: ${P.hostName}`;for(const I of Object.keys(P.workspaceMetadata)){const D=P.workspaceMetadata[I];let M=`${D.fileCount} files`;D.maxFilesReached&&(M=`more than ${M}`),a+=`|    Folder (${I}): ${M}`,a+=this.h(D)}}}),{processInfo:m,workspaceInfo:a}})}async getSystemInfo(l,s){const{memory:n,vmHint:i,os:a,cpus:m}=b(),P={os:a,memory:n,cpus:m,vmHint:i,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:s};return S.$i||(P.load=`${E.loadavg().map(I=>Math.round(I)).join(", ")}`),S.$k&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(l,s){const n=[];return(0,d.$fr)(l.mainPID).then(async i=>(n.push(""),n.push(this.g(l)),n.push(""),n.push(this.m(l,i)),l.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(l))),s.forEach(a=>{if((0,p.$6l)(a))n.push(`
${a.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${a.hostName}`),n.push(this.f(a.machineInfo)),a.processes&&n.push(this.m(l,a.processes)),a.workspaceMetadata)for(const m of Object.keys(a.workspaceMetadata)){const P=a.workspaceMetadata[m];let I=`${P.fileCount} files`;P.maxFilesReached&&(I=`more than ${I}`),n.push(`Folder (${m}): ${I}`),n.push(this.h(P))}}),n.push(""),n.push(""),n.join(`
`)))}h(l){const s=[];let i=0;const a=(D,M)=>{const L=` ${D}(${M})`;i+L.length>60?(s.push(m),m="|                 ",i=m.length):i+=L.length,m+=L};let m="|      File types:";const P=10,I=l.fileTypes.length>P?P:l.fileTypes.length;for(let D=0;D<I;D++){const M=l.fileTypes[D];a(M.name,M.count)}if(s.push(m),l.configFiles.length>=0&&(m="|      Conf files:",i=0,l.configFiles.forEach(D=>{a(D.name,D.count)}),s.push(m)),l.launchConfigFiles.length>0){let D="|      Launch Configs:";l.launchConfigFiles.forEach(M=>{const L=M.count>1?` ${M.name}(${M.count})`:` ${M.name}`;D+=L}),s.push(D)}return s.join(`
`)}j(l){const s=Math.max(...Object.keys(l).map(n=>n.length));return Object.keys(l).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${l[n]}`).join(`
                  `)}k(l){const s=[],n=[];return l.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(s.push(`|  Window (${i.title})`),i.folderURIs.forEach(a=>{const m=f.URI.revive(a);if(m.scheme===O.Schemas.file){const P=m.fsPath;n.push(g(P,["node_modules",".git"]).then(I=>{let D=`${I.fileCount} files`;I.maxFilesReached&&(D=`more than ${D}`),s.push(`|    Folder (${(0,R.$ec)(P)}): ${D}`),s.push(this.h(I))}).catch(I=>{s.push(`|      Error: Unable to collect workspace stats for folder ${P} (${I.toString()})`)}))}else s.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(i=>s.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(l,s){const n=new Map;l.windows.forEach(a=>n.set(a.pid,`window [${a.id}] (${a.title})`)),l.pidToNames.forEach(({pid:a,name:m})=>n.set(a,m));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),s&&this.n(l.mainPID,n,i,s,0),i.join(`
`)}n(l,s,n,i,a){const m=a===0;let P;m?P=i.pid===l?`${this.d.applicationName} main`:"remote agent":s.has(i.pid)?P=s.get(i.pid):P=`${"  ".repeat(a)} ${i.name}`;const I=process.platform==="win32"?i.mem:E.totalmem()*(i.mem/100);n.push(`${i.load.toFixed(0).padStart(5," ")}	${(I/h.$nk.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(i.children)&&i.children.forEach(D=>this.n(l,s,n,D,a+1))}async getWorkspaceFileExtensions(l){const s=new Set;for(const{uri:n}of l.folders){const i=f.URI.revive(n);if(i.scheme!==O.Schemas.file)continue;const a=i.fsPath;try{(await g(a,["node_modules",".git"])).fileTypes.forEach(P=>s.add(P.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(l){for(const{uri:s}of l.folders){const n=f.URI.revive(s);if(n.scheme!==O.Schemas.file)continue;const i=n.fsPath;try{const a=await g(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),a.fileTypes.forEach(m=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:m.name,count:m.count})}),a.launchConfigFiles.forEach(m=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:m.name,count:m.count})}),a.configFiles.forEach(m=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};e.$jr=w,e.$jr=w=pe([_(0,y.$Vk),_(1,v.$0i)],w)}),define(te[249],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q4b=e.$p4b=void 0;class E{constructor(O){this.b=O}listen(O,R){throw new Error(`Event not found: ${R}`)}call(O,R,{eventName:S,data:f}){return this.b.forEach(u=>u.log(S,f)),Promise.resolve(null)}}e.$p4b=E;class C{constructor(O){this.b=O}log(O,R){return this.b.call("log",{eventName:O,data:R}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$q4b=C}),define(te[52],ie([0,1,37,10,3,18,60,122,26]),function(V,e,E,C,r,O,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0;class u{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$2n=u;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$3n=$,e.$4n=new $;class d{async publicLog(i,a,m){}async publicLogError(i,a,m){}}e.$5n=d,e.$6n="telemetry",e.$7n="extensionTelemetryLog",e.$8n={log:()=>null,flush:()=>Promise.resolve(null)};function p(n,i){return r.Event.debounce(i.onDidChangeConfiguration,(m,P)=>{const I=m?new Set([...m.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:I}},1e3,!0)(m=>{m.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,O.$Yh)(m.source),configurationKeys:Array.from(m.affectedKeys)})})}e.$9n=p;function h(n,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!n.enableTelemetry||i.extensionTestsLocationURI)}e.$0n=h;function v(n,i){return!(i.isBuilt||i.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$$n=v;function y(n){const i=n.getValue(f.$3k),a=n.getValue(f.$4k);if(n.getValue(f.$5k)===!1||a===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$_n=y;function o(n){const i={},a={},m={};b(n,m);for(let P in m){P=P.length>150?P.substr(P.length-149):P;const I=m[P];typeof I=="number"?a[P]=I:typeof I=="boolean"?a[P]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${I.length}`),i[P]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(i[P]=I)}return{properties:i,measurements:a}}e.$ao=o;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(n){if(!n)return"none";const i=(0,R.$Ck)(n);return g.has(i)?i:"other"}e.$bo=c;function b(n,i,a=0,m){if(n)for(const P of Object.getOwnPropertyNames(n)){const I=n[P],D=m?m+P:P;Array.isArray(I)?i[D]=(0,E.$Mm)(I):I instanceof Date?i[D]=I.toISOString():(0,C.$le)(I)?a<2?b(I,i,a+1,D+"."):i[D]=(0,E.$Mm)(I):i[D]=I}}function k(n,i){const a=n.msftInternalDomains||[],m=i.getValue("telemetry.internalTesting");return(0,S.$1n)(a)||m}e.$co=k;function w(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$do=w;function t(n,i){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let a=n;const m=[];for(const M of i)for(;;){const L=M.exec(n);if(!L)break;m.push([L.index,M.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(a="";;){const M=I.exec(n);if(!M)break;const L=m.some(([N,B])=>M.index<B&&N<I.lastIndex);!P.test(M[0])&&!L&&(a+=n.substring(D,M.index)+"<REDACTED: user-file-path>",D=I.lastIndex)}return D<n.length&&(a+=n.substr(D)),a}function l(n){if(!n)return n;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of i)if(a.regex.test(n))return`<REDACTED: ${a.label}>`;return n}function s(n,i){return(0,E.$Jm)(n,a=>{if(a instanceof u||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let m=a.replaceAll("%20"," ");m=t(m,i);for(const P of i)m=m.replace(P,"");return m=l(m),m}})}e.$eo=s}),define(te[123],ie([0,1,25,116,120,4,7,13,36,52]),function(V,e,E,C,r,O,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=void 0;function $(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,E.$Hd)(s.id,n.id)===0}e.$fo=$;const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(n){const i=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new p(n.identifier,i,a)}static parse(n){const i=d.exec(n);return i&&i[1]&&i[2]?new p({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,a="undefined"){this.version=i,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof p?$(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$go=p;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(s){const n=h.exec(s);return n&&n[1]?[o(n[1]),n[2]]:[o(s),void 0]}e.$ho=v;function y(s,n){return`${s}.${n}`}e.$io=y;function o(s){return s.toLowerCase()}e.$jo=o;function g(s,n){return o(y(s??r.$Dl,n))}e.$ko=g;function c(s,n){const i=[],a=m=>{for(const P of i)if(P.some(I=>$(n(I),n(m))))return P;return null};for(const m of s){const P=a(m);P?P.push(m):i.push([m])}return i}e.$lo=c;function b(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$mo=b;function k(s){return{id:new u.$2n(s.identifier.id),name:new u.$2n(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$no=k,e.$oo=new r.$Hl("pprice.better-merge");function w(s,n){const i=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const m=a.shift();if(m&&i.every(P=>!$(P.identifier,{id:m}))){const P=s.filter(I=>$(I.identifier,{id:m}));P.length===1&&(i.push(P[0]),a.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.$po=w;async function t(s,n){if(!O.$k)return!1;let i;try{i=(await s.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await s.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){n.debug("Error while getting the os-release file.",(0,S.$9)(m))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(s,n){const i=await t(s,n),a=(0,C.$Kn)(i?"alpine":O.$t,f.$8b);return n.debug("ComputeTargetPlatform:",a),a}e.$qo=l}),define(te[250],ie([0,1,204,52]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=void 0;async function r(O,R,S,f,u,$,d){const p={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${R.nameShort})`};if((0,C.$0n)(R,S)&&(0,C.$_n)(f)===3){const h=await(0,E.$Qo)(S,u,$);p["X-Market-User-Id"]=h,p["VSCode-SessionId"]=d.machineId||h}return p}e.$Ro=r}),define(te[251],ie([0,1,2,37,4,25,183,18,59,78,23,43,26,52]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=void 0;let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,c,b){this.k=c,this.l=b,this.d={},this.i=new E.$kb,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const k of this.f)this.j.push(new RegExp((0,O.$od)(k),"gi")),k.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.$od)(k.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(k=>{(k.affectsConfiguration(p.$3k)||k.affectsConfiguration(p.$5k)||k.affectsConfiguration(p.$4k))&&this.m()}))}setExperimentProperty(g,c){this.d[g]=c}m(){let g=(0,h.$_n)(this.k);const c=this.l.enabledTelemetryLevels;if(c){this.h=this.sendErrorTelemetry?c.error:!1;const b=c.usage?3:c.error?2:0;g=Math.min(g,b)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,c,b){this.g<c||(b=(0,C.$Km)(b,this.d),b=(0,h.$eo)(b,this.j),b=(0,C.$Km)(b,this.c),this.b.forEach(k=>k.log(g,b)))}publicLog(g,c){this.n(g,3,c)}publicLog2(g,c){this.publicLog(g,c)}publicLogError(g,c){this.h&&this.n(g,2,c)}publicLogError2(g,c){this.publicLogError(g,c)}};e.$Fq=v,e.$Fq=v=pe([_(1,S.$Vh),_(2,$.$0i)],v);function y(){const o=(0,R.localize)(0,null,u.default.nameLong),g=u.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=r.$o?"":(0,R.localize)(3,null),b=(0,R.localize)(4,null),k=(0,R.localize)(5,null),w=(0,R.localize)(6,null),t=(0,R.localize)(7,null),l=`
|       | ${b} | ${k} | ${w} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,R.localize)(8,null);return`
${o} ${g} ${c}

&nbsp;

${t}
${l}

&nbsp;

${s}
`}d.$Tm.as(f.$Ym.Configuration).registerConfiguration({id:p.$2k,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[p.$3k]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),d.$Tm.as(f.$Ym.Configuration).registerConfiguration({id:p.$2k,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[p.$5k]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,R.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,R.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${p.$3k}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[252],ie([0,1,4,87,26]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T4b=void 0;async function O(R,S){let f=R.getItem(r.$1k);return(typeof f!="string"||E.$j&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,C.$um)(S.error.bind(S))),f}e.$T4b=O}),define(te[253],ie([0,1,26,252]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U4b=void 0;async function r(O,R){const S=await(0,C.$T4b)(O,R);return O.setItem(E.$1k,S),S}e.$U4b=r}),define(te[124],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var E;(function(C){C[C.Replace=1]="Replace",C[C.Append=2]="Append",C[C.Prepend=3]="Prepend"})(E||(e.EnvironmentVariableMutatorType=E={}))}),define(te[254],ie([0,1,4,124]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;const r=new Map([[C.EnvironmentVariableMutatorType.Append,"APPEND"],[C.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[C.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class O{constructor($){this.collections=$,this.a=new Map,this.b=new Map,$.forEach((d,p)=>{this.d(d,p);const h=d.map.entries();let v=h.next();for(;!v.done;){const y=v.value[1],o=v.value[0];let g=this.a.get(o);if(g||(g=[],this.a.set(o,g)),g.length>0&&g[0].type===C.EnvironmentVariableMutatorType.Replace){v=h.next();continue}const c={extensionIdentifier:p,value:y.value,type:y.type,scope:y.scope,variable:y.variable,options:y.options};c.scope||delete c.scope,g.unshift(c),v=h.next()}})}async applyToProcessEnvironment($,d,p){let h;E.$i&&(h={},Object.keys($).forEach(v=>h[v.toLowerCase()]=v));for(const[v,y]of this.getVariableMap(d)){const o=E.$i&&h[v.toLowerCase()]||v;for(const g of y){const c=p?await p(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case C.EnvironmentVariableMutatorType.Append:$[o]=($[o]||"")+c;break;case C.EnvironmentVariableMutatorType.Prepend:$[o]=c+($[o]||"");break;case C.EnvironmentVariableMutatorType.Replace:$[o]=c;break}if(g.options?.applyAtShellIntegration??!1){const b=`VSCODE_ENV_${r.get(g.type)}`;$[b]=($[b]?$[b]+":":"")+v+"="+this.c(c)}}}}c($){return $.replaceAll(":","\\x3a")}diff($,d){const p=new Map,h=new Map,v=new Map;if($.getVariableMap(d).forEach((y,o)=>{const g=this.getVariableMap(d).get(o),c=S(y,g);c&&p.set(o,c)}),this.getVariableMap(d).forEach((y,o)=>{const g=$.getVariableMap(d).get(o),c=S(y,g);c&&v.set(o,c)}),this.getVariableMap(d).forEach((y,o)=>{const g=$.getVariableMap(d).get(o),c=f(y,g);c&&h.set(o,c)}),!(p.size===0&&h.size===0&&v.size===0))return{added:p,changed:h,removed:v}}getVariableMap($){const d=new Map;for(const p of this.a.values()){const h=p.filter(v=>R(v,$));h.length>0&&d.set(h[0].variable,h)}return d}getDescriptionMap($){const d=new Map;for(const p of this.b.values()){const h=p.filter(v=>R(v,$,!0));for(const v of h)d.set(v.extensionIdentifier,v.description)}return d}d($,d){if(!$.descriptionMap)return;const p=$.descriptionMap.entries();let h=p.next();for(;!h.done;){const v=h.value[1],y=h.value[0];let o=this.b.get(y);o||(o=[],this.b.set(y,o));const g={extensionIdentifier:d,scope:v.scope,description:v.description};g.scope||delete g.scope,o.push(g),h=p.next()}}}e.$6q=O;function R(u,$,d=!1){return u.scope?!!(u.scope.workspaceFolder&&$?.workspaceFolder&&u.scope.workspaceFolder.index===$.workspaceFolder.index):d?$===u.scope:!0}function S(u,$){if(!$)return u;const d=new Set;$.forEach(h=>d.add(h.extensionIdentifier));const p=[];return u.forEach(h=>{d.has(h.extensionIdentifier)||p.push(h)}),p.length===0?void 0:p}function f(u,$){if(!$)return;const d=new Map;$.forEach(h=>d.set(h.extensionIdentifier,h));const p=[];return u.forEach(h=>{const v=d.get(h.extensionIdentifier);v&&(h.type!==v.type||h.value!==v.value||h.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index)&&p.push(v)}),p.length===0?void 0:p}}),define(te[255],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=e.$2q=e.$1q=e.$Zq=void 0;function E(f){return[...f.entries()]}e.$Zq=E;function C(f){return f?[...f.entries()]:[]}e.$1q=C;function r(f){return new Map(f)}e.$2q=r;function O(f){return new Map(f??[])}e.$3q=O;function R(f){return Array.from(f.entries()).map(u=>[u[0],E(u[1].map),C(u[1].descriptionMap)])}e.$4q=R;function S(f){return new Map(f.map(u=>[u[0],{map:r(u[1]),descriptionMap:O(u[2])}]))}e.$5q=S}),define(te[256],ie([0,1,8,22,3,2,5]),function(V,e,E,C,r,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;let S=class extends O.$lb{constructor(u,$){super(),this.h=$,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new r.$8c),this.onCreateRequest=this.g.event,this.b=u===void 0?15e3:u}createRequest(u){return new Promise(($,d)=>{const p=++this.a;this.c.set(p,$),this.g.fire({requestId:p,...u});const h=new C.$ed;(0,E.$wg)(this.b,h.token).then(()=>d(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,O.$jb)(()=>h.cancel())])})}acceptReply(u,$){const d=this.c.get(u);d?(this.c.delete(u),(0,O.$gb)(this.f.get(u)||[]),this.f.delete(u),d($)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${u}`)}};e.$Qq=S,e.$Qq=S=pe([_(1,R.$Ri)],S)}),define(te[125],ie([0,1,6,114,43]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=e.$Kq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Jq=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Iq=void 0,e.$Iq=new C.$Oi("terminalTabFocusMode",!1,!0);var O;(function(w){w.DefaultProfile="terminal.integrated.defaultProfile.",w.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var R;(function(w){w.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",w.AutomationProfileLinux="terminal.integrated.automationProfile.linux",w.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",w.AutomationProfileWindows="terminal.integrated.automationProfile.windows",w.ProfilesWindows="terminal.integrated.profiles.windows",w.ProfilesMacOs="terminal.integrated.profiles.osx",w.ProfilesLinux="terminal.integrated.profiles.linux",w.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",w.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",w.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",w.UseWslProfiles="terminal.integrated.useWslProfiles",w.TabsDefaultColor="terminal.integrated.tabs.defaultColor",w.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",w.TabsEnabled="terminal.integrated.tabs.enabled",w.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",w.TabsHideCondition="terminal.integrated.tabs.hideCondition",w.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",w.TabsShowActions="terminal.integrated.tabs.showActions",w.TabsLocation="terminal.integrated.tabs.location",w.TabsFocusMode="terminal.integrated.tabs.focusMode",w.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",w.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",w.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",w.CopyOnSelection="terminal.integrated.copyOnSelection",w.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",w.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",w.FontFamily="terminal.integrated.fontFamily",w.FontSize="terminal.integrated.fontSize",w.LetterSpacing="terminal.integrated.letterSpacing",w.LineHeight="terminal.integrated.lineHeight",w.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",w.TabStopWidth="terminal.integrated.tabStopWidth",w.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",w.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",w.BellDuration="terminal.integrated.bellDuration",w.FontWeight="terminal.integrated.fontWeight",w.FontWeightBold="terminal.integrated.fontWeightBold",w.CursorBlinking="terminal.integrated.cursorBlinking",w.CursorStyle="terminal.integrated.cursorStyle",w.CursorWidth="terminal.integrated.cursorWidth",w.Scrollback="terminal.integrated.scrollback",w.DetectLocale="terminal.integrated.detectLocale",w.DefaultLocation="terminal.integrated.defaultLocation",w.GpuAcceleration="terminal.integrated.gpuAcceleration",w.TerminalTitleSeparator="terminal.integrated.tabs.separator",w.TerminalTitle="terminal.integrated.tabs.title",w.TerminalDescription="terminal.integrated.tabs.description",w.RightClickBehavior="terminal.integrated.rightClickBehavior",w.Cwd="terminal.integrated.cwd",w.ConfirmOnExit="terminal.integrated.confirmOnExit",w.ConfirmOnKill="terminal.integrated.confirmOnKill",w.EnableBell="terminal.integrated.enableBell",w.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",w.AllowChords="terminal.integrated.allowChords",w.AllowMnemonics="terminal.integrated.allowMnemonics",w.TabFocusMode="terminal.integrated.tabFocusMode",w.EnvMacOs="terminal.integrated.env.osx",w.EnvLinux="terminal.integrated.env.linux",w.EnvWindows="terminal.integrated.env.windows",w.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",w.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",w.ShowExitAlert="terminal.integrated.showExitAlert",w.SplitCwd="terminal.integrated.splitCwd",w.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",w.WordSeparators="terminal.integrated.wordSeparators",w.EnableFileLinks="terminal.integrated.enableFileLinks",w.UnicodeVersion="terminal.integrated.unicodeVersion",w.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",w.LocalEchoEnabled="terminal.integrated.localEchoEnabled",w.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",w.LocalEchoStyle="terminal.integrated.localEchoStyle",w.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",w.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",w.HideOnStartup="terminal.integrated.hideOnStartup",w.CustomGlyphs="terminal.integrated.customGlyphs",w.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",w.InheritEnv="terminal.integrated.inheritEnv",w.ShowLinkHover="terminal.integrated.showLinkHover",w.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",w.AutoReplies="terminal.integrated.autoReplies",w.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",w.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",w.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",w.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",w.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",w.EnableImages="terminal.integrated.enableImages",w.SmoothScrolling="terminal.integrated.smoothScrolling",w.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",w.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",w.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay"})(R||(e.TerminalSettingId=R={}));var S;(function(w){w.PowerShell="pwsh",w.Bash="bash",w.Fish="fish",w.Sh="sh",w.Csh="csh",w.Ksh="ksh",w.Zsh="zsh"})(S||(e.PosixShellType=S={}));var f;(function(w){w.CommandPrompt="cmd",w.PowerShell="pwsh",w.Wsl="wsl",w.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var u;(function(w){w[w.Api=0]="Api",w[w.Process=1]="Process",w[w.Sequence=2]="Sequence",w[w.Config=3]="Config"})(u||(e.TitleEventSource=u={}));var $;(function(w){w.LocalPty="localPty",w.PtyHost="ptyHost",w.PtyHostWindow="ptyHostWindow",w.Logger="logger",w.Heartbeat="heartbeat"})($||(e.TerminalIpcChannels=$={}));var d;(function(w){w.Cwd="cwd",w.InitialCwd="initialCwd",w.FixedDimensions="fixedDimensions",w.Title="title",w.ShellType="shellType",w.HasChildProcesses="hasChildProcesses",w.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",w.OverrideDimensions="overrideDimensions",w.FailedShellIntegrationActivation="failedShellIntegrationActivation",w.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(d||(e.ProcessPropertyType=d={})),e.$Jq=(0,E.$ph)("ptyService");var p;(function(w){w[w.BeatInterval=5e3]="BeatInterval",w[w.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",w[w.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",w[w.SecondWaitMultiplier=1]="SecondWaitMultiplier",w[w.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var h;(function(w){w[w.Panel=1]="Panel",w[w.Editor=2]="Editor"})(h||(e.TerminalLocation=h={}));var v;(function(w){w.TerminalView="view",w.Editor="editor"})(v||(e.TerminalLocationString=v={}));var y;(function(w){w[w.GraceTime=6e4]="GraceTime",w[w.ShortGraceTime=6e3]="ShortGraceTime"})(y||(e.LocalReconnectConstants=y={}));var o;(function(w){w[w.HighWatermarkChars=1e5]="HighWatermarkChars",w[w.LowWatermarkChars=5e3]="LowWatermarkChars",w[w.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var g;(function(w){w.GitBash="Git Bash",w.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var c;(function(w){w[w.Off=0]="Off",w[w.FinalTerm=1]="FinalTerm",w[w.VSCode=2]="VSCode"})(c||(e.ShellIntegrationStatus=c={}));var b;(function(w){w[w.Unknown=0]="Unknown",w[w.Shutdown=1]="Shutdown",w[w.Process=2]="Process",w[w.User=3]="User",w[w.Extension=4]="Extension"})(b||(e.TerminalExitReason=b={})),e.$Kq={Backend:"workbench.contributions.terminal.processBackend"};class k{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const l=this.b(t.remoteAuthority);if(this.a.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this.a.set(l,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}r.$Tm.add(e.$Kq.Backend,new k),e.$Lq=(0,E.$ph)("localPtyService"),e.$Mq=(0,E.$ph)("terminalLogService")}),define(te[257],ie([0,1,71,7,185,102]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=e.$Rq=void 0;function R(p,h){const v=[{name:null,description:(0,r.localize)(0,null)}];return v.push(...p.map(y=>({name:y.profileName,description:S(y)}))),h&&v.push(...h.map(y=>({name:y.title,description:f(y)}))),{values:v.map(y=>y.name),markdownDescriptions:v.map(y=>y.description)}}e.$Rq=R;function S(p){let h=`$(${O.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:E.$Cj.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?h+=`
- args: "${p.args}"`:h+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(h+=`
- overrideName: ${p.overrideName}`),p.color&&(h+=`
- color: ${p.color}`),p.env&&(h+=`
- env: ${JSON.stringify(p.env)}`),h}function f(p){return`$(${O.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:E.$Cj.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function u(p,h){if(!p&&!h)return!0;if(typeof p=="string"&&typeof h=="string")return p===h;if(Array.isArray(p)&&Array.isArray(h)){if(p.length!==h.length)return!1;for(let v=0;v<p.length;v++)if(p[v]!==h[v])return!1;return!0}return!1}e.$Sq=u;function $(p,h){if(!p&&!h)return!0;if(!p||!h)return!1;if(O.ThemeIcon.isThemeIcon(p)&&O.ThemeIcon.isThemeIcon(h))return p.id===h.id&&p.color===h.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof h=="object"&&"light"in h&&"dark"in h){const v=p,y=h;if((C.URI.isUri(v.light)||d(v.light))&&(C.URI.isUri(v.dark)||d(v.dark))&&(C.URI.isUri(y.light)||d(y.light))&&(C.URI.isUri(y.dark)||d(y.dark)))return v.light.path===y.light.path&&v.dark.path===y.dark.path}if(C.URI.isUri(p)&&C.URI.isUri(h)||d(p)||d(h)){const v=p,y=h;return v.path===y.path&&v.scheme===y.scheme}return!1}e.$Tq=$;function d(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.$Uq=d}),define(te[258],ie([0,1,71,4,184,59,43,257]),function(V,e,E,C,r,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=e.$Wq=e.$Vq=void 0,e.$Vq={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Wq={type:"string",enum:Array.from((0,E.$Bj)(),o=>o.id),markdownEnumDescriptions:Array.from((0,E.$Bj)(),o=>`$(${o.id})`)};const f={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.$Wq},color:{description:(0,r.localize)(3,null),...e.$Vq},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},u={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},$={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function d(o){const g=o===2?"linux":o===1?"osx":"windows";return(0,r.localize)(7,null,(0,C.$h)(o),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:d(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...f}},{type:"null"},u]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:d(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...f}},{type:"null"},u]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:d(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...f}},{type:"null"},u]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,r.localize)(26,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){R.$Tm.as(O.$Ym.Configuration).registerConfiguration(p),y()}e.$Xq=h;let v;function y(o,g){const c=R.$Tm.as(O.$Ym.Configuration);let b;o&&(b=(0,S.$Rq)(o?.profiles,g));const k=v;v={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:o?.os===3?b?.values:void 0,markdownEnumDescriptions:o?.os===3?b?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:o?.os===2?b?.values:void 0,markdownEnumDescriptions:o?.os===2?b?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:o?.os===1?b?.values:void 0,markdownEnumDescriptions:o?.os===1?b?.markdownDescriptions:void 0}}},c.updateConfigurations({add:[v],remove:k?[k]:[]})}e.$Yq=y}),define(te[259],ie([0,1,27,15,37,9,4,36,25,10,21,124,255,254]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=void 0;function v(){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let i=0;return n&&n.length===4&&(i=parseInt(n[3])),i}e.$7q=v;async function y(n,i,a,m=S.env,P=$.Promises.exists){if(O.$_b(n))return await P(n)?n:void 0;if(i===void 0&&(i=S.cwd()),O.$dc(n)!=="."){const L=O.$ac(i,n);return await P(L)?L:void 0}const D=(0,r.$Om)(m,"PATH");if(a===void 0&&(0,u.$je)(D)&&(a=D.split(O.$kc)),a===void 0||a.length===0){const L=O.$ac(i,n);return await P(L)?L:void 0}for(const L of a){let N;if(O.$_b(L)?N=O.$ac(L,n):N=O.$ac(i,L,n),await P(N))return N;if(R.$i){let B=N+".com";if(await P(B)||(B=N+".exe",await P(B)))return B}}const M=O.$ac(i,n);return await P(M)?M:void 0}e.$8q=y;function o(n,i,a,m,P){const I=R.$i&&(!i.windowsEnableConpty||v()<18309);if(!i.shellIntegration.enabled||!n.executable||n.isFeatureTerminal||n.hideFromUser||n.ignoreShellIntegration||I)return;const D=n.args,M=S.$7b==="win32"?O.$ec(n.executable).toLowerCase():O.$ec(n.executable),L=O.$dc(C.$4e.asFileUri("").fsPath);let N;const B={VSCODE_INJECTION:"1"};if(i.shellIntegration.nonce&&(B.VSCODE_NONCE=i.shellIntegration.nonce),R.$i){if(M==="pwsh.exe"||M==="powershell.exe")return!D||l(D)?N=b.get(c.WindowsPwsh):t(D)&&(N=b.get(c.WindowsPwshLogin)),N?(N=[...N],N[N.length-1]=(0,f.$ld)(N[N.length-1],L,""),{newArgs:N,envMixin:B}):void 0;m.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args);return}switch(M){case"bash":return!D||D.length===0?N=b.get(c.Bash):s(D)&&(B.VSCODE_SHELL_LOGIN="1",g(i,B),N=b.get(c.Bash)),N?(N=[...N],N[N.length-1]=(0,f.$ld)(N[N.length-1],L),{newArgs:N,envMixin:B}):void 0;case"fish":{const re=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ne=O.$ac(L,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return B.XDG_DATA_DIRS=`${re}:${ne}`,g(i,B),{newArgs:void 0,envMixin:B}}case"pwsh":return!D||l(D)?N=b.get(c.Pwsh):t(D)&&(N=b.get(c.PwshLogin)),N?(N=[...N],N[N.length-1]=(0,f.$ld)(N[N.length-1],L,""),{newArgs:N,envMixin:B}):void 0;case"zsh":{if(!D||D.length===0?N=b.get(c.Zsh):s(D)?(N=b.get(c.ZshLogin),g(i,B)):(D===b.get(c.Zsh)||D===b.get(c.ZshLogin))&&(N=D),!N)return;N=[...N],N[N.length-1]=(0,f.$ld)(N[N.length-1],L);let re;try{re=E.userInfo().username}catch{re="unknown"}const ne=O.$ac(E.tmpdir(),`${re}-${P.applicationName}-zsh`);B.ZDOTDIR=ne;const ue=a?.ZDOTDIR??E.homedir()??"~";B.USER_ZDOTDIR=ue;const se=[];return se.push({source:O.$ac(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:O.$ac(ne,".zshrc")}),se.push({source:O.$ac(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:O.$ac(ne,".zprofile")}),se.push({source:O.$ac(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:O.$ac(ne,".zshenv")}),se.push({source:O.$ac(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:O.$ac(ne,".zlogin")}),{newArgs:N,envMixin:B,filesToCopy:se}}}m.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args)}e.$9q=o;function g(n,i){if(R.$j&&n.environmentVariableCollections){const a=(0,p.$5q)(n.environmentVariableCollections),P=new h.$6q(a).getVariableMap({workspaceFolder:n.workspaceFolder}).get("PATH"),I=[];if(P)for(const D of P)D.type===d.EnvironmentVariableMutatorType.Prepend&&I.push(D.value);I.length>0&&(i.VSCODE_PATH_PREFIX=I.join(""))}}var c;(function(n){n.WindowsPwsh="windows-pwsh",n.WindowsPwshLogin="windows-pwsh-login",n.Pwsh="pwsh",n.PwshLogin="pwsh-login",n.Zsh="zsh",n.ZshLogin="zsh-login",n.Bash="bash"})(c||(c={}));const b=new Map;b.set(c.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),b.set(c.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),b.set(c.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),b.set(c.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),b.set(c.Zsh,["-i"]),b.set(c.ZshLogin,["-il"]),b.set(c.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const k=["-login","-l"],w=["-nol","-nologo"];function t(n){return typeof n=="string"?k.includes(n.toLowerCase()):n.length===1&&k.includes(n[0].toLowerCase())||n.length===2&&(k.includes(n[0].toLowerCase())||k.includes(n[1].toLowerCase()))&&(w.includes(n[0].toLowerCase())||w.includes(n[1].toLowerCase()))}function l(n){return typeof n=="string"?w.includes(n.toLowerCase()):n.length===0||n?.length===1&&w.includes(n[0].toLowerCase())}function s(n){return n==="string"&&k.includes(n.toLowerCase())||typeof n!="string"&&n.length===1&&k.includes(n[0].toLowerCase())}}),define(te[260],ie([0,1,47,71,9,4,10,21,106,259,113]),function(V,e,E,C,r,O,R,S,f,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;let d,p=!0;function h(i,a,m,P,I=process.env,D,M,L,N){return D=D||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},O.$i?v(m,D,I,M,P.getValue("terminal.integrated.useWslProfiles")!==!1,i&&typeof i=="object"?{...i}:P.getValue("terminal.integrated.profiles.windows"),typeof a=="string"?a:P.getValue("terminal.integrated.defaultProfile.windows"),N,L):l(D,M,m,i&&typeof i=="object"?{...i}:P.getValue(O.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof a=="string"?a:P.getValue(O.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),N,L,I)}e.$0q=h;async function v(i,a,m,P,I,D,M,L,N){const B=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),re=`${process.env.windir}\\${B?"Sysnative":"System32"}`;let ne=!1;(0,u.$7q)()>=16299&&(ne=!0),await c(L);const ue=new Map;if(i){ue.set("PowerShell",{source:"PowerShell",icon:C.$Cj.terminalPowershell,isAutoDetected:!0}),ue.set("Windows PowerShell",{path:`${re}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:C.$Cj.terminalPowershell,isAutoDetected:!0}),ue.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ue.set("Command Prompt",{path:`${re}\\cmd.exe`,icon:C.$Cj.terminalCmd,isAutoDetected:!0}),ue.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ue.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:C.$Cj.terminalBash,isAutoDetected:!0});const le=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ue.set("Cmder",{path:`${re}\\cmd.exe`,args:["/K",le],requiresPath:process.env.CMDER_ROOT?le:{path:le,isUnsafe:!0},isAutoDetected:!0})}s(D,ue);const se=await y(ue.entries(),M,a,m,P,N);if(i&&I)try{const le=await w(`${re}\\${ne?"wsl":"bash"}.exe`,M);for(const J of le)(!D||!(J.profileName in D))&&se.push(J)}catch{p&&(P?.info("WSL is not installed, so could not detect WSL profiles"),p=!1)}return se}async function y(i,a,m,P=process.env,I,D){const M=[];for(const[L,N]of i)M.push(o(L,N,a,m,P,I,D));return(await Promise.all(M)).filter(L=>!!L)}async function o(i,a,m,P,I=process.env,D,M){if(a===null)return;let L,N,B;if("source"in a&&!("path"in a)){const se=d?.get(a.source);if(!se)return;L=se.paths,N=a.args||se.args,a.icon?B=g(a.icon):se.icon&&(B=se.icon)}else L=Array.isArray(a.path)?a.path:[a.path],N=O.$i||Array.isArray(a.args)?a.args:void 0,B=g(a.icon);let re;if(M){const se=L.map(J=>typeof J=="string"?J:J.path),le=await M(se);re=new Array(L.length);for(let J=0;J<L.length;J++)typeof L[J]=="string"?re[J]=le[J]:re[J]={path:le[J],isUnsafe:!0}}else re=L.slice();let ne;if(a.requiresPath){let se;if((0,R.$je)(a.requiresPath)?se=a.requiresPath:(se=a.requiresPath.path,a.requiresPath.isUnsafe&&(ne=se)),!await P.existsFile(se))return}const ue=await n(i,m,re,P,I,N,a.env,a.overrideName,a.isAutoDetected,ne);if(!ue){D?.debug("Terminal profile not validated",i,L);return}return ue.isAutoDetected=a.isAutoDetected,ue.icon=B,ue.color=a.color,ue}function g(i){return typeof i=="string"?{id:i}:i}async function c(i){if(d&&!i)return;const[a,m]=await Promise.all([b(),i||k()]);d=new Map,d.set("Git Bash",{profileName:"Git Bash",paths:a,args:["--login","-i"]}),d.set("PowerShell",{profileName:"PowerShell",paths:m,icon:C.$Cj.terminalPowershell})}async function b(){const i=new Set,a=await(0,u.$8q)("git.exe");if(a){const I=(0,$.dirname)(a);i.add((0,$.resolve)(I,"../.."))}function m(I,D){D&&I.add(D)}m(i,process.env.ProgramW6432),m(i,process.env.ProgramFiles),m(i,process.env["ProgramFiles(X86)"]),m(i,`${process.env.LocalAppData}\\Program`);const P=[];for(const I of i)P.push(`${I}\\Git\\bin\\bash.exe`,`${I}\\Git\\usr\\bin\\bash.exe`,`${I}\\usr\\bin\\bash.exe`);return P.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),P}async function k(){const i=[];for await(const a of(0,f.$dl)())i.push(a.exePath);return i}async function w(i,a){const m=[],P=await new Promise((M,L)=>{E.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(N,B)=>{if(N)return L("Problem occurred when getting wsl distros");M(B)})});if(!P)return[];const I=new RegExp(/[\r?\n]/),D=P.split(I).filter(M=>M.trim().length>0&&M!=="");for(const M of D){if(M===""||M.startsWith("docker-desktop"))continue;const L=`${M} (WSL)`,N={profileName:L,path:i,args:["-d",`${M}`],isDefault:L===a,icon:t(M),isAutoDetected:!1};m.push(N)}return m}function t(i){return i.includes("Ubuntu")?C.$Cj.terminalUbuntu:i.includes("Debian")?C.$Cj.terminalDebian:C.$Cj.terminalLinux}async function l(i,a,m,P,I,D,M,L){const N=new Map;if(m){const B=(await i.readFile("/etc/shells")).toString(),re=(D||B.split(`
`)).map(ue=>{const se=ue.indexOf("#");return se===-1?ue:ue.substring(0,se)}).filter(ue=>ue.trim().length>0),ne=new Map;for(const ue of re){let se=(0,r.$ec)(ue),le=ne.get(se)||0;le++,le>1&&(se=`${se} (${le})`),ne.set(se,le),N.set(se,{path:ue,isAutoDetected:!0})}}return s(P,N),await y(N.entries(),I,i,L,a,M)}function s(i,a){if(i)for(const[m,P]of Object.entries(i))P===null||typeof P!="object"||!("path"in P)&&!("source"in P)?a.delete(m):(P.icon=P.icon||a.get(m)?.icon,a.set(m,P))}async function n(i,a,m,P,I,D,M,L,N,B){if(m.length===0)return Promise.resolve(void 0);const re=m.shift();if(re==="")return n(i,a,m,P,I,D,M,L,N);const ne=typeof re!="string"&&re.isUnsafe,ue=typeof re=="string"?re:re.path,se={profileName:i,path:ue,args:D,env:M,overrideName:L,isAutoDetected:N,isDefault:i===a,isUnsafePath:ne,requiresUnsafePath:B};if((0,r.$ec)(ue)===ue){const J=I.PATH?I.PATH.split(r.$kc):void 0,K=await(0,u.$8q)(ue,void 0,J,void 0,P.existsFile);return K?(se.path=K,se.isFromPath=!0,se):n(i,a,m,P,I,D)}return await P.existsFile((0,r.$$b)(ue))?se:n(i,a,m,P,I,D,M,L,N)}}),define(te[261],ie([0,1,3,2,4,42,18,5,224,95,256,125,258,260,108,69]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;var o;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(o||(o={}));let g=class extends C.$lb{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.P()}constructor(b,k,w,t){super(),this.H=b,this.I=k,this.J=w,this.L=t,this.j=!1,this.k=0,this.l=!0,this.m=!1,this.r=this.B(new E.$8c),this.onPtyHostExit=this.r.event,this.s=this.B(new E.$8c),this.onPtyHostStart=this.s.event,this.t=this.B(new E.$8c),this.onPtyHostUnresponsive=this.t.event,this.u=this.B(new E.$8c),this.onPtyHostResponsive=this.u.event,this.v=this.B(new E.$8c),this.onPtyHostRequestResolveVariables=this.v.event,this.w=this.B(new E.$8c),this.onProcessData=this.w.event,this.y=this.B(new E.$8c),this.onProcessReady=this.y.event,this.z=this.B(new E.$8c),this.onProcessReplay=this.z.event,this.C=this.B(new E.$8c),this.onProcessOrphanQuestion=this.C.event,this.D=this.B(new E.$8c),this.onDidRequestDetach=this.D.event,this.F=this.B(new E.$8c),this.onDidChangeProperty=this.F.event,this.G=this.B(new E.$8c),this.onProcessExit=this.G.event,(0,p.$Xq)(),this.B(this.H),this.B((0,C.$jb)(()=>this.Q())),this.i=this.B(new $.$Qq(void 0,this.J)),this.i.onCreateRequest(this.v.fire,this.v),this.H.onRequestConnection&&E.Event.once(this.H.onRequestConnection)(()=>this.h()),this.H.onWillShutdown?.(()=>this.j=!0)}get M(){return this.I.getValue("terminal.integrated.ignoreProcessNames")}async N(){return this.g?.refreshIgnoreProcessNames?.(this.M)}async O(){if(r.$i)return process.env;try{return await(0,u.$yl)(this.I,this.J,{_:[]},process.env)}catch(b){return this.J.error("ptyHost was unable to resolve shell environment",b),{}}}P(){const b=this.H.start(),k=b.client;this.J.getLevel()===S.LogLevel.Trace&&this.J.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),O.ProxyChannel.toService(k.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.R()),this.R(!0),this.B(b.onDidProcessExit(l=>{this.r.fire(l.code),!this.j&&!this.m&&(this.k<=o.MaxRestarts?(this.J.error(`ptyHost terminated unexpectedly with code ${l.code}`),this.k++,this.restartPtyHost()):this.J.error(`ptyHost terminated unexpectedly with code ${l.code}, giving up`))}));const t=O.ProxyChannel.toService(k.getChannel(d.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(l=>this.w.fire(l))),this.B(t.onProcessReady(l=>this.y.fire(l))),this.B(t.onProcessExit(l=>this.G.fire(l))),this.B(t.onDidChangeProperty(l=>this.F.fire(l))),this.B(t.onProcessReplay(l=>this.z.fire(l))),this.B(t.onProcessOrphanQuestion(l=>this.C.fire(l))),this.B(t.onDidRequestDetach(l=>this.D.fire(l))),this.B(new f.$Pq(this.L,k.getChannel(d.TerminalIpcChannels.Logger))),this.a=b,this.b=t,this.s.fire(),this.B(this.I.onDidChangeConfiguration(async l=>{l.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.N()})),this.N(),[b,t]}dispose(){this.m=!0,super.dispose()}async createProcess(b,k,w,t,l,s,n,i,a,m,P){const I=setTimeout(()=>this.W(),d.HeartbeatConstants.CreateProcessTimeout),D=await this.f.createProcess(b,k,w,t,l,s,n,i,a,m,P);return clearTimeout(I),D}updateTitle(b,k,w){return this.f.updateTitle(b,k,w)}updateIcon(b,k,w,t){return this.f.updateIcon(b,k,w,t)}attachToProcess(b){return this.f.attachToProcess(b)}detachFromProcess(b,k){return this.f.detachFromProcess(b,k)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(b){return this.f.start(b)}shutdown(b,k){return this.f.shutdown(b,k)}input(b,k){return this.f.input(b,k)}processBinary(b,k){return this.f.processBinary(b,k)}resize(b,k,w){return this.f.resize(b,k,w)}clearBuffer(b){return this.f.clearBuffer(b)}acknowledgeDataEvent(b,k){return this.f.acknowledgeDataEvent(b,k)}setUnicodeVersion(b,k){return this.f.setUnicodeVersion(b,k)}getInitialCwd(b){return this.f.getInitialCwd(b)}getCwd(b){return this.f.getCwd(b)}async getLatency(){const b=new y.$4c,k=await this.f.getLatency();return b.stop(),[{label:"ptyhostservice<->ptyhost",latency:b.elapsed()},...k]}orphanQuestionReply(b){return this.f.orphanQuestionReply(b)}installAutoReply(b,k){return this.f.installAutoReply(b,k)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(b){return this.f.uninstallAutoReply(b)}getDefaultSystemShell(b){return this.g?.getDefaultSystemShell(b)??(0,v.$jl)(b??r.OS,process.env)}async getProfiles(b,k,w,t=!1){const l=await this.O();return(0,h.$0q)(k,w,t,this.I,l,void 0,this.J,this.Y.bind(this,b))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(b,k){return this.f.getWslPath(b,k)}getRevivedPtyNewId(b,k){return this.f.getRevivedPtyNewId(b,k)}setTerminalLayoutInfo(b){return this.f.setTerminalLayoutInfo(b)}async getTerminalLayoutInfo(b){return this.g?.getTerminalLayoutInfo(b)}async requestDetachInstance(b,k){return this.f.requestDetachInstance(b,k)}async acceptDetachInstanceReply(b,k){return this.f.acceptDetachInstanceReply(b,k)}async freePortKillProcess(b){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(b)}async serializeTerminalState(b){return this.f.serializeTerminalState(b)}async reviveTerminalProcesses(b,k,w){return this.f.reviveTerminalProcesses(b,k,w)}async refreshProperty(b,k){return this.f.refreshProperty(b,k)}async updateProperty(b,k,w){return this.f.updateProperty(b,k,w)}async restartPtyHost(){this.Q(),this.l=!0,this.P()}Q(){this.f.shutdownAll(),this.c.store.dispose()}R(b){this.X(),this.n=setTimeout(()=>this.S(),b?d.HeartbeatConstants.ConnectingBeatInterval:d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this.l||(this.l=!0,this.u.fire())}S(){this.J.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.n=void 0,this.p=setTimeout(()=>this.U(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}U(){this.J.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.p=void 0,this.l&&(this.l=!1,this.t.fire())}W(){this.X(),this.J.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.l&&(this.l=!1,this.t.fire())}X(){this.n&&(clearTimeout(this.n),this.n=void 0),this.p&&(clearTimeout(this.p),this.p=void 0)}Y(b,k){return this.i.createRequest({workspaceId:b,originalText:k})}async acceptPtyHostResolvedVariables(b,k){this.i.acceptReply(b,k)}};e.$$q=g,e.$$q=g=pe([_(1,R.$Vh),_(2,S.$Ri),_(3,S.$Si)],g)}),define(te[80],ie([0,1,14,3,2,4,18,6,34]),function(V,e,E,C,r,O,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$33b=e.$23b=void 0;const u="#FFFFFF",$="#1E1E1E",d="#000000",p="#FFFFFF",h="theme",v="themeBackground",y="windowSplash";e.$23b=(0,S.$ph)("themeMainService");let o=class extends r.$lb{constructor(c,b){super(),this.b=c,this.c=b,this.a=this.B(new C.$8c),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(O.$i){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(O.$j){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(O.$k&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const c=this.getColorScheme();if(c.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return c.dark?d:p;let b=this.b.getItem(v,null);if(!b)switch(this.b.getItem(h,"vs-dark").split(" ")[0]){case"vs":b=u;break;case"hc-black":b=d;break;case"hc-light":b=p;break;default:b=$}return O.$j&&b.toUpperCase()===$&&(b="#171717"),b}saveWindowSplash(c,b){this.b.setItems([{key:h,data:b.baseTheme},{key:v,data:b.colorInfo.background},{key:y,data:b}]),typeof c=="number"&&this.f(c,b)}f(c,b){for(const k of E.BrowserWindow.getAllWindows())if(k.id===c){k.setBackgroundColor(b.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(y)}};e.$33b=o,e.$33b=o=pe([_(0,f.$SM),_(1,R.$Vh)],o)}),define(te[126],ie([0,1,3,18,6,5]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pz=e.$Oz=e.$Nz=e.$Mz=e.$Lz=e.$Kz=e.$Jz=e.$Iz=e.ProvidedOnAutoForward=e.$Hz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Gz=e.$Fz=void 0,e.$Fz=(0,r.$ph)("tunnelService"),e.$Gz=(0,r.$ph)("sharedTunnelsService");var R;(function(o){o.Http="http",o.Https="https"})(R||(e.TunnelProtocol=R={}));var S;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(S||(e.TunnelPrivacyId=S={}));function f(o){return!!o.forwardPort}e.$Hz=f;var u;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function $(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(g)return{address:g[1],port:+g[2]}}e.$Iz=$,e.$Jz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function d(o){return e.$Jz.indexOf(o)>=0}e.$Kz=d,e.$Lz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(o){return e.$Lz.indexOf(o)>=0}e.$Mz=p;function h(o,g,c,b){if(c===1)return!1;if(c===2&&p(g)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(k?.length===4&&parseInt(k[1])>=18)return!1}return o<1024}e.$Nz=h;class v{constructor(g,c,b){this.remoteAddress=g,this.localAddress=c,this.b=b,this.a=new E.$8c,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Oz=v;let y=class{constructor(g,c){this.i=g,this.j=c,this.a=new E.$8c,this.onTunnelOpened=this.a.event,this.b=new E.$8c,this.onTunnelClosed=this.b.event,this.c=new E.$8c,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const g=this.j.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this.e=g,g?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this.f=g.elevation,this.g=g.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const g=[],c=Array.from(this.d.values());for(const b of c){const k=Array.from(b.values());for(const w of k){const t=await w.value;t&&g.push(t)}}return g}async dispose(){for(const g of this.d.values()){for(const{value:c}of g.values())await c.then(b=>b?.dispose());g.clear()}this.d.clear()}setEnvironmentTunnel(g,c,b,k,w){this.o(g,c,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:c,localAddress:b,privacy:k,protocol:w,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,c){(p(g)||d(g))&&(g=e.$Jz[0]);const b=this.q(g,c);if(b)return++b.refcount,b.value}openTunnel(g,c,b,k,w,t=!1,l,s){this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${b} on local port ${w}.`);const n=this.e??g;if(!n)return;if(c||(c="localhost"),k||(k=this.k),this.e&&this.h.has(b)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(n,c,b,k,w,t,l,s);return i?i.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(c,b);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.m(a);return(a.tunnelRemoteHost!==c||a.tunnelRemotePort!==b)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&a.privacy!==l&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const c=this.d.get(g.tunnelRemoteHost);if(c){const b=c.get(g.tunnelRemotePort);b&&(b.refcount--,await this.n(g.tunnelRemoteHost,g.tunnelRemotePort,b))}}}}async n(g,c,b){if(b.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${c}.`);const k=b.value.then(async w=>{w&&(await w.dispose(!0),this.b.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this.d.has(g)&&this.d.get(g).delete(c),k}}async closeTunnel(g,c){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${c} `);const b=this.d.get(g);if(b&&b.has(c)){const k=b.get(c);k.refcount=0,await this.n(g,c,k)}}o(g,c,b){this.d.has(g)||this.d.set(g,new Map),this.d.get(g).set(c,{refcount:1,value:b})}async p(g,c){const b=this.d.get(g);if(b){const k=b.get(c);(k?await k.value:void 0)||b.delete(c),b.size===0&&this.d.delete(g)}}q(g,c){const b=[g];d(g)?(b.push(...e.$Jz),b.push(...e.$Lz)):p(g)&&b.push(...e.$Lz);const k=b.map(w=>this.d.get(w));for(const w of k){const t=w?.get(c);if(t)return t}}canTunnel(g){return!!$(g)}s(g,c,b,k,w,t,l){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${b} on local port ${k}.`);const s=b;this.h.add(s);const n=k===void 0?b:k,i={elevationRequired:w?this.isPortPrivileged(n):!1},a={remoteAddress:{host:c,port:b},localAddressPort:k,privacy:t,public:t?t!==S.Private:void 0,protocol:l},m=g.forwardPort(a,i);return m?(this.o(c,b,m),m.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),m}};e.$Pz=y,e.$Pz=y=pe([_(0,O.$Ri),_(1,C.$Vh)],y)}),define(te[262],ie([0,1,88,27,103,8,2,18,5,23,240,126,96,4,241]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$94b=e.$84b=e.$74b=void 0;async function y(k,w,t,l,s){let n;for(let i=3;i&&(n?.dispose(),n=await new o(k,w,t,l,s).waitForReady(),!(s&&r.$9e[s]||!r.$9e[n.tunnelLocalPort]));i--);return n}class o extends R.$lb{constructor(w,t,l,s,n){super(),this.j=t,this.k=n,this.privacy=d.TunnelPrivacyId.Private,this.i=new Map,this.a=w,this.b=E.createServer(),this.c=new O.$ug,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=i=>this.l(i),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const w=this.k??this.tunnelRemotePort,t=(0,d.$Mz)(this.j)?"0.0.0.0":"127.0.0.1";let l=await(0,r.$0e)(w,2,1e3,t),s=null;return this.b.listen(l,this.j),await this.c.wait(),s=this.b.address(),s||(l=0,this.b.listen(l,this.j),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async l(w){w.pause();const t=(0,d.$Kz)(this.tunnelRemoteHost)||(0,d.$Mz)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,$.$Mk)(this.a,t,this.tunnelRemotePort),s=l.getSocket().socket,n=l.readEntireBuffer();l.dispose(),n.byteLength>0&&w.write(n.buffer),w.on("end",()=>{w.localAddress&&this.i.delete(w.localAddress),s.end()}),w.on("close",()=>s.end()),w.on("error",()=>{w.localAddress&&this.i.delete(w.localAddress),s.destroy()}),s.on("end",()=>w.end()),s.on("close",()=>w.end()),s.on("error",()=>{w.destroy()}),w.pipe(s),s.pipe(w),w.localAddress&&this.i.set(w.localAddress,()=>{w.end(),s.end()})}}let g=class extends d.$Pz{constructor(w,t,l,s,n){super(t,n),this.t=w,this.u=l,this.v=s}isPortPrivileged(w){return(0,d.$Nz)(w,this.k,h.OS,C.release())}r(w,t,l,s,n,i,a,m){const P=this.q(t,l);if(P)return++P.refcount,P.value;if((0,d.$Hz)(w))return this.s(w,t,l,n,i,a,m);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${l} on local port ${n}.`);const I={commit:this.v.commit,quality:this.v.quality,addressProvider:w,remoteSocketFactoryService:this.t,signService:this.u,logService:this.i,ipcLogger:null},D=y(I,s,t,l,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,l,D),D}}};e.$74b=g,e.$74b=g=pe([_(0,v.$Gk),_(1,f.$Ri),_(2,p.$Jk),_(3,u.$0i),_(4,S.$Vh)],g);let c=class extends g{constructor(w,t,l,s,n){super(w,t,l,s,n)}};e.$84b=c,e.$84b=c=pe([_(0,v.$Gk),_(1,f.$Ri),_(2,p.$Jk),_(3,u.$0i),_(4,S.$Vh)],c);let b=class extends R.$lb{constructor(w,t,l,s,n){super(),this.b=w,this.c=t,this.f=l,this.g=s,this.h=n,this.a=new Map}async openTunnel(w,t,l,s,n,i,a,m,P){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${s} on local port ${i}.`),!this.a.has(w)){const I=new c(this.b,this.c,this.g,this.f,this.h);this.B(I),this.a.set(w,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(w))})}return this.a.get(w).openTunnel(t,l,s,n,i,a,m,P)}};e.$94b=b,e.$94b=b=pe([_(0,v.$Gk),_(1,f.$Ri),_(2,u.$0i),_(3,p.$Jk),_(4,S.$Vh)],b)}),define(te[48],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gib=e.$Fib=e.DisablementReason=e.UpdateType=e.StateType=void 0;var C;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.Disabled="disabled",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(C||(e.StateType=C={}));var r;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(r||(e.UpdateType=r={}));var O;(function(R){R[R.NotBuilt=0]="NotBuilt",R[R.DisabledByEnvironment=1]="DisabledByEnvironment",R[R.ManuallyDisabled=2]="ManuallyDisabled",R[R.MissingConfiguration=3]="MissingConfiguration",R[R.InvalidConfiguration=4]="InvalidConfiguration",R[R.RunningAsAdmin=5]="RunningAsAdmin"})(O||(e.DisablementReason=O={})),e.$Fib={Uninitialized:{type:"uninitialized"},Disabled:R=>({type:"disabled",reason:R}),Idle:(R,S)=>({type:"idle",updateType:R,error:S}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.$Gib=(0,E.$ph)("updateService")}),define(te[263],ie([0,1,4,186,59,43]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),O.$Tm.as(r.$Ym.Configuration).registerConfiguration({id:"update",order:15,title:(0,C.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,C.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,C.localize)(2,null),(0,C.localize)(3,null),(0,C.localize)(4,null),(0,C.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,C.localize)(6,null),deprecationMessage:(0,C.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,C.localize)(8,null),description:(0,C.localize)(9,null),included:E.$i&&!E.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,C.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[264],ie([0,1,3,48]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s4b=e.$r4b=void 0;class r{constructor(S){this.a=S}listen(S,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(S,f,u){switch(f){case"checkForUpdates":return this.a.checkForUpdates(u);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(u)}throw new Error(`Call not found: ${f}`)}}e.$r4b=r;class O{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new E.$8c,this.onStateChange=this.a.event,this.b=C.$Fib.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$s4b=O}),define(te[40],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=void 0,e.$pk=(0,E.$ph)("IUriIdentityService")}),define(te[265],ie([0,1,40,205,16,19,139,3,2]),function(V,e,E,C,r,O,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class u{static{this._clock=0}constructor(p){this.uri=p,this.time=u._clock++}touch(){return this.time=u._clock++,this}}let $=class{constructor(p){this.g=p,this.c=new f.$kb,this.f=2**16;const h=new Map,v=y=>{let o=h.get(y.scheme);return o===void 0&&(o=p.hasProvider(y)&&!this.g.hasCapability(y,1024),h.set(y.scheme,o)),o};this.c.add(S.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(y=>{h.delete(y.scheme)})),this.extUri=new O.$Yf(v),this.d=new R.$br((y,o)=>this.extUri.compare(y,o,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,O.$$f)(p));const h=this.d.get(p);return h?h.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new u(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((v,y)=>v[1].time<y[1].time?1:v[1].time>y[1].time?-1:0);u._clock=0,this.d.clear();const h=this.f*.5;for(let v=0;v<h;v++)this.d.set(p[v][0],p[v][1].touch())}};e.$cr=$,e.$cr=$=pe([_(0,r.$Sj)],$),(0,C.$_q)(E.$pk,$,1)}),define(te[127],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjb=void 0,e.$rjb=(0,E.$ph)("urlService")}),define(te[266],ie([0,1,7]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B4b=e.$A4b=e.$z4b=void 0;class C{constructor(S){this.a=S}listen(S,f){throw new Error(`Event not found: ${f}`)}call(S,f,u){switch(f){case"handleURL":return this.a.handleURL(E.URI.revive(u[0]),u[1])}throw new Error(`Call not found: ${f}`)}}e.$z4b=C;class r{constructor(S){this.a=S}handleURL(S,f){return this.a.call("handleURL",[S.toJSON(),f])}}e.$A4b=r;class O{constructor(S,f){this.a=S,this.b=f}async routeCall(S,f,u,$){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(u)&&u.length>0){const d=E.URI.revive(u[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",d.toString(!0)),d.query){const p=/\bwindowId=(\d+)/.exec(d.query);if(p){const h=p[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${h}"`,d.toString(!0));const v=new RegExp(`window:${h}`),y=S.connections.find(o=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",o.ctx),v.test(o.ctx)));if(y)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",d.toString(!0)),y;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",d.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",d.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,f,u,$)}routeEvent(S,f){throw new Error(`Event not found: ${f}`)}}e.$B4b=O}),define(te[267],ie([0,1,8,2,7,23]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rqb=e.$qqb=void 0;class R extends C.$lb{constructor(){super(...arguments),this.a=new Set}open(u,$){const d=[...this.a.values()];return(0,E.$zg)(d.map(p=>()=>p.handleURL(u,$)),void 0,!1).then(p=>p||!1)}registerHandler(u){return this.a.add(u),(0,C.$jb)(()=>this.a.delete(u))}}e.$qqb=R;let S=class extends R{constructor(u){super(),this.b=u}create(u){let{authority:$,path:d,query:p,fragment:h}=u||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return $&&d&&d.indexOf("/")!==0&&(d=`/${d}`),r.URI.from({scheme:this.b.urlProtocol,authority:$,path:d,query:p,fragment:h})}};e.$rqb=S,e.$rqb=S=pe([_(0,O.$0i)],S)}),define(te[268],ie([0,1,14,8,3,2,4,7]),function(V,e,E,C,r,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C4b=void 0;class f{constructor($,d,p,h,v,y){if(this.f=d,this.g=y,this.a=[],this.b=0,this.c=O.$lb.None,this.d=new O.$kb,$&&(y.trace("ElectronURLListener initialUrisToHandle:",$.map(c=>c.originalUrl)),this.a=$),R.$i){const c=h.isBuilt?[]:[`"${h.appRoot}"`];c.push("--open-url","--"),E.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,c)}const o=r.Event.map(r.Event.fromNodeEventEmitter(E.app,"open-url",(c,b)=>({event:c,url:b})),({event:c,url:b})=>(c.preventDefault(),b));this.d.add(o(c=>{const b=this.h(c);b&&this.f.open(b,{originalUrl:c})})),p.getWindows().filter(c=>c.isReady).length>0?(y.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(y.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),r.Event.once(p.onDidSignalReadyWindow)(this.i,this,this.d))}h($){try{return S.URI.parse($)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const $=[];for(const d of this.a)await this.f.open(d.uri,{originalUrl:d.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",d.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",d.originalUrl),$.push(d));$.length!==0&&(this.a=$,this.c=(0,C.$xg)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.$C4b=f}),define(te[269],ie([0,1,3,2,16,56,58,17]),function(V,e,E,C,r,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b5b=void 0;class f extends C.$lb{get capabilities(){return this.f.capabilities&-5}constructor($,d,p,h){super(),this.c=$,this.f=d,this.g=p,this.h=h,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new E.$8c),this.onDidChangeFile=this.a.event,this.b=R.$vh.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(v=>this.i(v)))}watch($,d){this.b.set($,$);const p=this.f.watch(this.j($),d);return(0,C.$jb)(()=>{this.b.delete($),p.dispose()})}stat($){return this.f.stat(this.j($))}mkdir($){return this.f.mkdir(this.j($))}rename($,d,p){return this.f.rename(this.j($),this.j(d),p)}readFile($){return this.f.readFile(this.j($),{atomic:!0})}readFileStream($,d,p){const h=(0,O.$xb)(v=>S.$Jb.concat(v.map(y=>S.$Jb.wrap(y))).buffer);return(async()=>{try{const v=await this.readFile($);h.end(v)}catch(v){h.error(v),h.end()}})(),h}readdir($){return this.f.readdir(this.j($))}writeFile($,d,p){return this.f.writeFile(this.j($),d,p)}delete($,d){return this.f.delete(this.j($),d)}copy($,d,p){if((0,r.$Vj)(this.f))return this.f.copy(this.j($),this.j(d),p);throw new Error("copy not supported")}i($){const d=[];for(const p of $){if(p.resource.scheme!==this.c)continue;const h=this.k(p.resource);this.b.findSubstr(h)&&d.push({resource:h,type:p.type})}d.length&&(this.h.debug("User data changed"),this.a.fire(d))}j($){return $.with({scheme:this.c})}k($){return $.with({scheme:this.g})}}e.$b5b=f}),define(te[270],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W4b=void 0,e.$W4b="utilityProcessWorker"}),define(te[271],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D4b=void 0,e.$D4b=(0,E.$ph)("webviewManagerService")}),define(te[272],ie([0,1,14,2,15,7]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E4b=void 0;class R extends C.$lb{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.b.bind(this);E.protocol.registerFileProtocol(r.Schemas.vscodeWebview,f)}b(f,u){try{const $=O.URI.parse(f.url),d=R.a.get($.path);if(typeof d=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${d}`,h=r.$4e.asFileUri(p);return u({path:h.fsPath,headers:{...r.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return u({error:-10})}catch{}return u({error:-2})}}e.$E4b=R}),define(te[81],ie([0,1,4]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GD=e.$FD=e.$ED=e.$DD=e.$CD=e.$BD=e.$AD=e.$zD=void 0,e.$zD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C($){return!!$.workspaceUri}e.$AD=C;function r($){return!!$.folderUri}e.$BD=r;function O($){return!!$.fileUri}e.$CD=O;function R($){const d=S($),p=$.getValue("window.menuBarVisibility");return p==="default"||d==="native"&&p==="compact"||E.$j&&E.$m?"classic":p}e.$DD=R;function S($){if(E.$o)return"custom";const d=$.getValue("window");if(d){if(E.$j&&d.nativeTabs===!0||E.$j&&d.nativeFullScreen===!1)return"native";const v=d.titleBarStyle;if(v==="native"||v==="custom")return v}return E.$k?"native":"custom"}e.$ED=S;function f($){return!(!E.$i||E.$o||S($)==="native")}e.$FD=f;function u($=0){return Math.pow(1.2,$)}e.$GD=u}),define(te[128],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$e3b=e.UnloadReason=e.LoadReason=void 0;var E;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(E||(e.LoadReason=E={}));var C;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(C||(e.UnloadReason=C={}));const r=function(S=1){return{width:1024,height:768,mode:S}};e.$e3b=r;var O;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(O||(e.WindowMode=O={}));var R;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.PROCESS_GONE=2]="PROCESS_GONE",S[S.LOAD=3]="LOAD"})(R||(e.WindowError=R={}))}),define(te[29],ie([0,1,6]),function(V,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.$t3b=void 0,e.$t3b=(0,E.$ph)("windowsMainService");var C;(function(r){r[r.CLI=0]="CLI",r[r.DOCK=1]="DOCK",r[r.MENU=2]="MENU",r[r.DIALOG=3]="DIALOG",r[r.DESKTOP=4]="DESKTOP",r[r.API=5]="API"})(C||(e.OpenContext=C={}))}),define(te[273],ie([0,1,76,5,33,23,29,217]),function(V,e,E,C,r,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N4b=void 0;let f=class extends S.$pn{constructor($,d,p,h){super($),this.n=d,this.p=p,this.r=h,this.j=v=>{this.r.sendToFocused("vscode:showCredentialsError",v.message??v)}}async getSecretStoragePrefix(){return Promise.resolve(this.p.urlProtocol)}async i(){if(this.f)return this.f;if(this.n.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.$on,this.f;const $=await new Promise((d,p)=>{V(["keytar"],d,p)});return await $.findCredentials("test-keytar-loads"),this.f=$,this.f}};e.$N4b=f,e.$N4b=f=pe([_(0,C.$Ri),_(1,r.$xh),_(2,O.$0i),_(3,R.$t3b)],f)}),define(te[274],ie([0,1,14,24,4,7,21,18,63,6,5,127,29]),function(V,e,E,C,r,O,R,S,f,u,$,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b4b=e.$a4b=e.ID=void 0,e.ID="launchMainService",e.$a4b=(0,u.$ph)(e.ID);let h=class{constructor(y,o,g,c){this.a=y,this.b=o,this.c=g,this.d=c}async start(y,o){this.a.trace("Received data from other instance: ",y,o),r.$j&&E.app.focus({steal:!0});const g=this.e(y);if(g.length){let c=Promise.resolve();if(this.b.getWindowCount()===0){const b=(0,C.$vf)(await this.b.openEmptyWindow({context:4}));b&&(c=b.ready())}c.then(()=>{for(const{uri:b,originalUrl:k}of g)this.c.open(b,{originalUrl:k})})}else return this.f(y,o)}e(y){return y["open-url"]&&y._urls&&y._urls.length>0?(0,C.$mf)(y._urls.map(o=>{try{return{uri:O.URI.parse(o),originalUrl:o}}catch{return null}})):[]}async f(y,o){const g=(0,f.$sl)(o)?0:4;let c=[];const b=y.wait&&y.waitMarkerFilePath?O.URI.file(y.waitMarkerFilePath):void 0,k=y.remote||void 0,w={context:g,cli:y,userEnv:o,waitMarkerFileURI:b,remoteAuthority:k,forceProfile:y.profile,forceTempProfile:y["profile-temp"]};if(y.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(y.extensionDevelopmentPath,w);else if(!y._.length&&!y["folder-uri"]&&!y["file-uri"]){let t=!1;if(y["new-window"]||y["unity-launch"]||w.forceProfile||w.forceTempProfile)t=!0;else if(y["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!r.$j}if(t)c=await this.b.open({...w,forceNewWindow:!0,forceEmpty:!0});else{const l=this.b.getLastActiveWindow();l?(this.b.openExistingWindow(l,w),c=[l]):c=await this.b.open({...w,forceEmpty:!0})}}else c=await this.b.open({...w,forceNewWindow:y["new-window"],preferNewWindow:!y["reuse-window"]&&!y.wait,forceReuseWindow:y["reuse-window"],diffMode:y.diff,mergeMode:y.merge,addMode:y.add,noRecentEntry:!!y["skip-add-to-recently-opened"],gotoLineMode:y.goto});if(b&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,R.whenDeleted)(b.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$b4b=h,e.$b4b=h=pe([_(0,$.$Ri),_(1,p.$t3b),_(2,d.$rjb),_(3,S.$Vh)],h)}),define(te[275],ie([0,1,14,3,2,272,29]),function(V,e,E,C,r,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F4b=void 0;let S=class extends r.$lb{constructor(u){super(),this.b=u,this.a=this.B(new C.$8c),this.onFoundInFrame=this.a.event,this.B(new O.$E4b)}async setIgnoreMenuShortcuts(u,$){let d;if(typeof u.windowId=="number"){const{windowId:p}=u,h=this.b.getWindowById(p);if(!h?.win)throw new Error(`Invalid windowId: ${p}`);d=h.win.webContents}else{const{webContentsId:p}=u;if(d=E.webContents.fromId(p),!d)throw new Error(`Invalid webContentsId: ${p}`)}d.isDestroyed()||d.setIgnoreMenuShortcuts($)}async findInFrame(u,$,d,p){const v=this.c(u,$);if(typeof v.findInFrame=="function"){v.findInFrame(d,{findNext:p.findNext,forward:p.forward});const y=(o,g)=>{g.finalUpdate&&(this.a.fire(g),v.removeListener("found-in-frame",y))};v.on("found-in-frame",y)}}async stopFindInFrame(u,$,d){const h=this.c(u,$);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(d.keepSelection?"keepSelection":"clearSelection")}c(u,$){const d=this.b.getWindowById(u.windowId);if(!d?.win)throw new Error(`Invalid windowId: ${u}`);const p=d.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===$);if(!p)throw new Error(`Unknown frame: ${$}`);return p}};e.$F4b=S,e.$F4b=S=pe([_(0,R.$t3b)],S)}),define(te[276],ie([0,1,8,3,2]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L4b=void 0;class O extends r.$lb{constructor({onDidOpenWindow:S,onDidFocusWindow:f,getActiveWindowId:u}){super(),this.a=this.B(new r.$kb),C.Event.latch(C.Event.any(S,f))(this.f,this,this.a),this.b=(0,E.$jg)(()=>u()),(async()=>{try{const d=await this.b;this.c=typeof this.c=="number"?this.c:d}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$L4b=O}),define(te[30],ie([0,1,190,9,58,19,7,6,15]),function(V,e,E,C,r,O,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.WorkbenchState=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$yh=(0,S.$ph)("contextService");function u(n){const i=n;return typeof i?.id=="string"&&R.URI.isUri(i.uri)}e.$zh=u;function $(n){return typeof n?.id=="string"&&!u(n)&&!p(n)}e.$Ah=$,e.$Bh={id:"ext-dev"},e.$Ch={id:"empty-window"};function d(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,C.$ec)(n)}:i?e.$Bh:e.$Ch;const a=n;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$Dh=d;function p(n){const i=n;return typeof i?.id=="string"&&R.URI.isUri(i.configPath)}e.$Eh=p;function h(n){const i=n;if(i?.uri)return{id:i.id,uri:R.URI.revive(i.uri)};const a=n;if(a?.configPath)return{id:a.id,configPath:R.URI.revive(a.configPath)};if(n?.id)return{id:n.id}}e.$Fh=h;var v;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function y(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.$Gh=y;function o(n){const i=n;return!!(i&&typeof i=="object"&&R.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.$Hh=o;class g{constructor(i,a,m,P,I){this.h=i,this.j=m,this.k=P,this.l=I,this.c=r.$vh.forUris(this.l,()=>!0),this.folders=a}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=r.$vh.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ih=g;class c{constructor(i,a){this.raw=a,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,O.$0f)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Jh=c;function b(n){return new c({uri:n,index:0,name:(0,O.$6f)(n)},{uri:n.toString()})}e.$Kh=b,e.$Lh="code-workspace",e.$Mh=`.${e.$Lh}`,e.$Nh=[{name:(0,E.localize)(0,null),extensions:[e.$Lh]}],e.$Oh="workspace.json";function k(n,i){return O.$1f.isEqualOrParent(n,i.untitledWorkspacesHome)}e.$Ph=k;function w(n){let i;return R.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===f.Schemas.tmp}e.$Qh=w,e.$Rh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$Rh}e.$Sh=t;function l(n,i){return!k(n,i)&&!w(n)}e.$Th=l;function s(n){return(typeof n=="string"?(0,C.$fc)(n):(0,O.$8f)(n))===e.$Mh}e.$Uh=s}),define(te[61],ie([0,1,14,8,57,46,2,86,4,10,21,165,92,6,5,23,30]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G3b=e.$F3b=void 0,e.$F3b=(0,h.$ph)("dialogMainService");let g=class{constructor(b,k){this.d=b,this.e=k,this.a=new Map,this.b=new Map,this.c=new C.$Cg}pickFileFolder(b,k){return this.f({...b,pickFolders:!0,pickFiles:!0,title:(0,d.localize)(0,null)},k)}pickFolder(b,k){return this.f({...b,pickFolders:!0,title:(0,d.localize)(1,null)},k)}pickFile(b,k){return this.f({...b,pickFiles:!0,title:(0,d.localize)(2,null)},k)}pickWorkspace(b,k){const w=(0,d.localize)(3,null),t=(0,O.$7z)((0,d.localize)(4,null)),l=o.$Nh;return this.f({...b,pickFiles:!0,title:w,filters:l,buttonLabel:t},k)}async f(b,k){const w={title:b.title,buttonLabel:b.buttonLabel,filters:b.filters,defaultPath:b.defaultPath};(typeof b.pickFiles=="boolean"||typeof b.pickFolders=="boolean")&&(w.properties=void 0,b.pickFiles&&b.pickFolders&&(w.properties=["multiSelections","openDirectory","openFile","createDirectory"])),w.properties||(w.properties=["multiSelections",b.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$j&&w.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(w,(0,u.$Be)(k||E.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(b){if(b){let k=this.b.get(b.id);return k||(k=new C.$Cg,this.b.set(b.id,k)),k}else return this.c}showMessageBox(b,k){return this.g(k).queue(async()=>{const{options:w,buttonIndeces:t}=(0,p.$bA)(b,this.e);let l;return k?l=await E.dialog.showMessageBox(k,w):l=await E.dialog.showMessageBox(w),{response:t[l.response],checkboxChecked:l.checkboxChecked}})}async showSaveDialog(b,k){const w=this.j(b,k);if(!w)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(k).queue(async()=>{let t;return k?t=await E.dialog.showSaveDialog(k,b):t=await E.dialog.showSaveDialog(b),t.filePath=this.h(t.filePath),t})}finally{(0,R.$gb)(w)}}h(b){return b&&f.$j&&(b=(0,S.$7k)(b)),b}i(b){return b.map(k=>this.h(k))}async showOpenDialog(b,k){b.defaultPath&&(await $.Promises.exists(b.defaultPath)||(b.defaultPath=void 0));const w=this.j(b,k);if(!w)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(k).queue(async()=>{let t;return k?t=await E.dialog.showOpenDialog(k,b):t=await E.dialog.showOpenDialog(b),t.filePaths=this.i(t.filePaths),t})}finally{(0,R.$gb)(w)}}j(b,k){if(!k)return R.$lb.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",b);let w=this.a.get(k.id);w||(w=new Set,this.a.set(k.id,w));const t=(0,r.$di)(b);if(!w.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",b),w.add(t),(0,R.$jb)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",b),w?.delete(t),w?.size===0&&this.a.delete(k.id)})}};e.$G3b=g,e.$G3b=g=pe([_(0,v.$Ri),_(1,y.$0i)],g)}),define(te[277],ie([0,1,3,2,74,30]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o4b=void 0;class R extends C.$lb{static{this.a=100}constructor(f,u){super(),this.f=f,this.g=u,this.b=this.B(new E.$8c),this.c=new Map,this.h(u.applicationStorage,this.b)}h(f,u){this.B(E.Event.debounce(f.onDidChangeStorage,($,d)=>($?$.push(d):$=[d],$),R.a)($=>{$.length&&u.fire(this.i($,f))}))}i(f,u){const $=new Map,d=new Set;return f.forEach(p=>{const h=u.get(p.key);typeof h=="string"?$.set(p.key,h):d.add(p.key)}),{changed:Array.from($.entries()),deleted:Array.from(d.values())}}listen(f,u,$){switch(u){case"onDidChangeStorage":{const d=$.profile?(0,r.$Yg)($.profile):void 0;if(!d)return this.b.event;let p=this.c.get(d.id);return p||(p=this.B(new E.$8c),this.h(this.g.profileStorage(d),p),this.c.set(d.id,p)),p.event}}throw new Error(`Event not found: ${u}`)}async call(f,u,$){const d=$.profile?(0,r.$Yg)($.profile):void 0,p=(0,O.$Fh)($.workspace),h=await this.j(d,p);switch(u){case"getItems":return Array.from(h.items.entries());case"updateItems":{const v=$;if(v.insert)for(const[y,o]of v.insert)h.set(y,o);v.delete?.forEach(y=>h.delete(y));break}case"isUsed":{const v=$.payload;if(typeof v=="string")return this.g.isUsed(v)}default:throw new Error(`Call not found: ${u}`)}}async j(f,u){let $;u?$=this.g.workspaceStorage(u):f?$=this.g.profileStorage(f):$=this.g.applicationStorage;try{await $.init()}catch(d){this.f.error(`StorageIPC#init: Unable to init ${u?"workspace":f?"profile":"application"} storage due to ${d}`)}return $}}e.$o4b=R}),define(te[41],ie([0,1,57,3,2,19,7,187,33,16,6,5,30,35,40,8,31,25,10]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.ProfileResourceType=void 0;var b;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(b||(e.ProfileResourceType=b={}));function k(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&R.URI.isUri(i.location)&&R.URI.isUri(i.globalStorageHome)&&R.URI.isUri(i.settingsResource)&&R.URI.isUri(i.keybindingsResource)&&R.URI.isUri(i.tasksResource)&&R.URI.isUri(i.snippetsHome)&&R.URI.isUri(i.extensionsResource))}e.$qk=k,e.$rk=(0,$.$ph)("IUserDataProfilesService");function w(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:R.URI.revive(n.location).with({scheme:i}),globalStorageHome:R.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:R.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:R.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:R.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:R.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:R.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:R.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$sk=w;function t(n,i,a,m,P,I){return{id:n,name:i,location:a,isDefault:!1,shortName:P?.shortName,globalStorageHome:I&&P?.useDefaultFlags?.globalState?I.globalStorageHome:(0,O.$0f)(a,"globalStorage"),settingsResource:I&&P?.useDefaultFlags?.settings?I.settingsResource:(0,O.$0f)(a,"settings.json"),keybindingsResource:I&&P?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,O.$0f)(a,"keybindings.json"),tasksResource:I&&P?.useDefaultFlags?.tasks?I.tasksResource:(0,O.$0f)(a,"tasks.json"),snippetsHome:I&&P?.useDefaultFlags?.snippets?I.snippetsHome:(0,O.$0f)(a,"snippets"),extensionsResource:I&&P?.useDefaultFlags?.extensions?I.extensionsResource:(0,O.$0f)(a,"extensions.json"),cacheHome:(0,O.$0f)(m,n),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}e.$tk=t;let l=class extends r.$lb{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,a,m,P){super(),this.n=i,this.r=a,this.s=m,this.t=P,this.f=!0,this.h=this.B(new C.$8c),this.onDidChangeProfiles=this.h.event,this.i=this.B(new C.$8c),this.onWillCreateProfile=this.i.event,this.j=this.B(new C.$8c),this.onWillRemoveProfile=this.j.event,this.k=this.B(new C.$8c),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new h.$ni,emptyWindows:new Map},this.profilesHome=(0,O.$0f)(this.n.userRoamingDataHome,"profiles"),this.g=(0,O.$0f)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=this.w(),a=[i];if(this.f)try{for(const I of this.J()){if(!I.name||!(0,c.$je)(I.name)||!I.location){this.t.warn("Skipping the invalid stored profile",I.location||I.name);continue}a.push(t((0,O.$7f)(I.location),I.name,I.location,this.g,{shortName:I.shortName,useDefaultFlags:I.useDefaultFlags},i))}}catch(I){this.t.error(I)}const m=new h.$ni,P=new Map;if(a.length)try{const I=this.M();if(I.workspaces)for(const[D,M]of Object.entries(I.workspaces)){const L=R.URI.parse(D),N=a.find(B=>B.id===M);N&&m.set(L,N)}if(I.emptyWindows)for(const[D,M]of Object.entries(I.emptyWindows)){const L=a.find(N=>N.id===M);L&&P.set(D,L)}}catch(I){this.t.error(I)}this.u={profiles:a,workspaces:m,emptyWindows:P}}return this.u}w(){const i=t("__default__profile__",(0,S.localize)(0,null),this.n.userRoamingDataHome,this.g);return{...i,extensionsResource:this.O()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const a="Temp",m=new RegExp(`${(0,g.$od)(a)}\\s(\\d+)`);let P=0;for(const D of this.profiles){const M=m.exec(D.name),L=M?parseInt(M[1]):0;P=L>P?L:P}const I=`${a} ${P+1}`;return this.createProfile((0,E.$di)((0,o.$6e)()).toString(16),I,{transient:!0},i)}async createNamedProfile(i,a,m){return this.createProfile((0,E.$di)((0,o.$6e)()).toString(16),i,a,m)}async createProfile(i,a,m,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.y(i,a,m);return P&&await this.setProfileForWorkspace(P,I),I}async y(i,a,m){if(!(0,c.$je)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.l.get(a);return P||(P=(async()=>{try{const I=this.profiles.find(L=>L.name===a||L.id===i);if(I)return I;const D=t(i,a,(0,O.$0f)(this.profilesHome,i),this.g,m,this.defaultProfile);await this.r.createFolder(D.location);const M=[];return this.i.fire({profile:D,join(L){M.push(L)}}),await y.Promises.settled(M),this.D([D],[],[]),D}finally{this.l.delete(a)}})(),this.l.set(a,P)),P}async updateProfile(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let m=this.profiles.find(P=>P.id===i.id);if(!m)throw new Error(`Profile '${i.name}' does not exist`);return m=t(m.id,a.name??m.name,m.location,this.g,{shortName:a.shortName??m.shortName,transient:a.transient??m.isTransient,useDefaultFlags:a.useDefaultFlags??m.useDefaultFlags},this.defaultProfile),this.D([],[],[m]),m}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(P=>P.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);const m=[];this.j.fire({profile:a,join(P){m.push(P)}});try{await Promise.allSettled(m)}catch(P){this.t.error(P)}for(const P of[...this.v.emptyWindows.keys()])a.id===this.v.emptyWindows.get(P)?.id&&this.v.emptyWindows.delete(P);for(const P of[...this.v.workspaces.keys()])a.id===this.v.workspaces.get(P)?.id&&this.v.workspaces.delete(P);this.H(),this.D([],[a],[]);try{await this.r.del(a.cacheHome,{recursive:!0})}catch(P){(0,u.$9j)(P)!==1&&this.t.error(P)}}async setProfileForWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=this.profiles.find(P=>P.id===a.id);if(!m)throw new Error(`Profile '${a.name}' does not exist`);this.G(i,m)}unsetWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,a)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(a=>a.isDirectory&&this.profiles.every(m=>!this.s.extUri.isEqual(m.location,a.resource))).map(a=>this.r.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(a=>!this.C(a));await Promise.allSettled(i.map(a=>this.removeProfile(a)))}getProfileForWorkspace(i){const a=this.z(i);return R.URI.isUri(a)?this.m.workspaces.get(a)??this.v.workspaces.get(a):this.m.emptyWindows.get(a)??this.v.emptyWindows.get(a)}z(i){return(0,p.$zh)(i)?i.uri:(0,p.$Eh)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.m.workspaces.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.v.emptyWindows.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.v.workspaces.values()].some(a=>this.s.extUri.isEqual(a.location,i.location)))}D(i,a,m){const P=[...this.profiles,...i],I=[];this.m.profiles=[];for(let D of P)D.isDefault||a.some(M=>D.id===M.id)||(D=m.find(M=>D.id===M.id)??D,D.isTransient?this.m.profiles.push(D):I.push({location:D.location,name:D.name,shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}));this.L(I),this.u=void 0,this.F(i,a,m)}F(i,a,m){this.h.fire({added:i,removed:a,updated:m,all:this.profiles})}G(i,a,m){m=a?.isTransient?!0:m,m||this.G(i,void 0,!0);const P=this.z(i),I=m?this.m:this.v;R.URI.isUri(P)?(I.workspaces.delete(P),a&&I.workspaces.set(P,a)):(I.emptyWindows.delete(P),a&&I.emptyWindows.set(P,a)),m||this.H()}H(){const i={};for(const[m,P]of this.v.workspaces.entries())i[m.toString()]=P.id;const a={};for(const[m,P]of this.v.emptyWindows.entries())a[m.toString()]=P.id;this.N({workspaces:i,emptyWindows:a}),this.u=void 0}I(i){const a={},m=this.w();if(i.workspaces)for(const[I,D]of Object.entries(i.workspaces)){const M=R.URI.parse(D);a[I]=this.s.extUri.isEqual(M,m.location)?m.id:this.s.extUri.basename(M)}const P={};if(i.emptyWindows)for(const[I,D]of Object.entries(i.emptyWindows)){const M=R.URI.parse(D);P[I]=this.s.extUri.isEqual(M,m.location)?m.id:this.s.extUri.basename(M)}return{workspaces:a,emptyWindows:P}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};e.$uk=l,e.$uk=l=pe([_(0,f.$wh),_(1,u.$Sj),_(2,v.$pk),_(3,d.$Ri)],l);class s extends l{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.$vk=s}),define(te[82],ie([0,1,8,17,2,3,35,7,116,123,16,6,5,41,40,10,13,26]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=e.$_o=e.$$o=e.ExtensionsProfileScanningErrorCode=void 0;var c;(function(l){l.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",l.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(c||(e.ExtensionsProfileScanningErrorCode=c={}));class b extends Error{constructor(s,n){super(s),this.code=n}}e.$$o=b,e.$_o=(0,d.$ph)("IExtensionsProfileScannerService");let k=class extends r.$lb{constructor(s,n,i,a,m,P){super(),this.i=s,this.j=n,this.k=i,this.l=a,this.m=m,this.n=P,this.b=this.B(new O.$8c),this.onAddExtensions=this.b.event,this.c=this.B(new O.$8c),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.$8c),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.$8c),this.onDidRemoveExtensions=this.g.event,this.h=new R.$ni}scanProfileExtensions(s,n){return this.p(s,void 0,n)}async addExtensionsToProfile(s,n){const i=[],a=[];try{return await this.p(n,m=>{const P=[];for(const I of m)s.some(([D])=>(0,u.$fo)(D.identifier,I.identifier))?i.push(I):P.push(I);for(const[I,D]of s)if(!P.some(M=>(0,u.$fo)(M.identifier,I.identifier)&&M.version===I.manifest.version)){const M={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:D};a.push(M),P.push(M)}return a.length&&this.b.fire({extensions:a,profileLocation:n}),i.length&&this.f.fire({extensions:i,profileLocation:n}),P}),a.length&&this.c.fire({extensions:a,profileLocation:n}),i.length&&this.g.fire({extensions:i,profileLocation:n}),a}catch(m){throw a.length&&this.c.fire({extensions:a,error:m,profileLocation:n}),i.length&&this.g.fire({extensions:i,error:m,profileLocation:n}),m}}async updateMetadata(s,n){const i=[];return await this.p(n,a=>{const m=[];for(const P of a){const I=s.find(([D])=>(0,u.$fo)(D.identifier,P.identifier)&&D.manifest.version===P.version);I&&(P.metadata={...P.metadata,...I[1]},i.push(P)),m.push(P)}return m}),i}async removeExtensionFromProfile(s,n){const i=[];this.f.fire({extensions:i,profileLocation:n});try{await this.p(n,a=>{const m=[];for(const P of a)(0,u.$fo)(P.identifier,s.identifier)?i.push(P):m.push(P);return i.length&&this.f.fire({extensions:i,profileLocation:n}),m}),i.length&&this.g.fire({extensions:i,profileLocation:n})}catch(a){throw i.length&&this.g.fire({extensions:i,error:a,profileLocation:n}),a}}async p(s,n,i){return this.w(s).queue(async()=>{let a=[],m;try{const P=await this.j.readFile(s);m=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,$.$9j)(P)!==1)throw P;if(this.l.extUri.isEqual(s,this.k.defaultProfile.extensionsResource)&&(m=await this.v()),!m&&i?.bailOutWhenFileNotFound)throw new b((0,o.$9)(P),"ERROR_PROFILE_NOT_FOUND")}if(m){Array.isArray(m)||this.r(s);let P=!1;for(const I of m){w(I)||this.r(s);let D;if((0,y.$je)(I.relativeLocation)&&I.relativeLocation)D=this.t(I.relativeLocation);else if((0,y.$je)(I.location))D=this.t(I.location),P=!0,I.relativeLocation=I.location,I.location=D.toJSON();else{D=S.URI.revive(I.location);const M=this.s(D);M&&(P=!0,I.relativeLocation=M)}a.push({identifier:I.identifier,location:D,version:I.version,metadata:I.metadata})}P&&await this.j.writeFile(s,C.$Jb.fromString(JSON.stringify(m)))}if(n){a=n(a);const P=a.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.s(I.location),metadata:I.metadata}));await this.j.writeFile(s,C.$Jb.fromString(JSON.stringify(P)))}return a})}r(s){const n=new b(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(s){return this.l.extUri.isEqual(this.l.extUri.dirname(s),this.i)?this.l.extUri.basename(s):void 0}t(s){return this.l.extUri.joinPath(this.i,s)}async v(){return this.u||(this.u=(async()=>{const s=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let i;try{i=(await this.j.readFile(s)).value.toString()}catch(m){if((0,$.$9j)(m)===1)return;throw m}this.n.info("Migrating extensions from old default profile location",s.toString());let a;try{const m=JSON.parse(i);Array.isArray(m)&&m.every(P=>w(P))?a=m:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",m)}catch(m){this.n.error(m)}if(a)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,C.$Jb.fromString(JSON.stringify(a)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",s.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(m){if((0,$.$9j)(m)===3)this.n.info("Migration from old default profile location to new location is done by another window",s.toString(),this.k.defaultProfile.extensionsResource.toString());else throw m}try{await this.j.del(s)}catch(m){(0,$.$9j)(m)!==1&&this.n.error(m)}try{await this.j.del(n)}catch(m){(0,$.$9j)(m)!==1&&this.n.error(m)}return a})()),this.u}w(s){let n=this.h.get(s);return n||(n=new E.$Cg,this.h.set(s,n)),n}};e.$ap=k,e.$ap=k=pe([_(1,$.$Sj),_(2,h.$rk),_(3,v.$pk),_(4,g.$Vk),_(5,p.$Ri)],k);function w(l){return(0,y.$le)(l)&&(0,f.$On)(l.identifier)&&(t(l.location)||(0,y.$je)(l.location)&&l.location)&&((0,y.$qe)(l.relativeLocation)||(0,y.$je)(l.relativeLocation))&&l.version&&(0,y.$je)(l.version)}function t(l){return l?(0,y.$je)(l.path)&&(0,y.$je)(l.scheme):!1}}),define(te[129],ie([0,1,24,8,37,17,13,44,151,2,15,9,4,19,203,70,10,7,170,33,123,120,202,16,6,5,23,3,74,82,41,40,201]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t,l,s,n,i,a,m,P,I,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.Translations=void 0;var L;(function(le){function J(K,U){if(K===U)return!0;const T=Object.keys(K),W=new Set;for(const H of Object.keys(U))W.add(H);if(T.length!==W.size)return!1;for(const H of T){if(K[H]!==U[H])return!1;W.delete(H)}return W.size===0}le.equals=J})(L||(e.Translations=L={})),e.$dp=(0,s.$ph)("IExtensionsScannerService");let N=class extends u.$lb{constructor(J,K,U,T,W,H,Q,ce,oe,j,A,F){super(),this.systemExtensionsLocation=J,this.userExtensionsLocation=K,this.l=U,this.m=T,this.n=W,this.r=H,this.s=Q,this.t=ce,this.u=oe,this.v=j,this.w=A,this.y=F,this.g=this.B(new a.$8c),this.onDidChangeCache=this.g.event,this.h=(0,h.$0f)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(ne,this.m,this.h)),this.j=this.B(this.y.createInstance(ne,this.m,this.h)),this.k=this.B(this.y.createInstance(re,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,k.$qo)(this.s,this.t)),this.z}async scanAllExtensions(J,K,U){const[T,W]=await Promise.all([this.scanSystemExtensions(J),this.scanUserExtensions(K)]),H=U?await this.scanExtensionsUnderDevelopment(J,[...T,...W]):[];return this.G(T,W,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(J){const K=[];K.push(this.H(!!J.useCache,J.language)),K.push(this.I(J.language,!!J.checkControlFile));const[U,T]=await Promise.all(K);return this.F([...U,...T],0,J,!1)}async scanUserExtensions(J){const K=J.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",K);const U=this.w.extUri.isEqual(J.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,T=await this.L(K,!!J.profileLocation,1,!J.includeUninstalled,J.language,!0,U),W=J.useCache&&!T.devMode&&T.excludeObsolete?this.j:this.k;let H;try{H=await W.scanExtensions(T)}catch(Q){if(Q instanceof P.$$o&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),H=await W.scanExtensions(T);else throw Q}return H=await this.F(H,1,J,!0),this.t.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(J,K){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const U=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(T=>T.scheme===$.Schemas.file).map(async T=>{const W=await this.L(T,!1,1,!0,J.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(W)).map(Q=>(Q.type=K.find(ce=>(0,k.$fo)(ce.identifier,Q.identifier))?.type??Q.type,this.k.validate(Q,W)))}))).flat();return this.F(U,"development",J,!0)}return[]}async scanExistingExtension(J,K,U){const T=await this.L(J,!1,K,!0,U.language,!0,void 0),W=await this.k.scanExtension(T);return!W||!U.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(J,K,U){const T=await this.L(J,!1,K,!0,U.language,!0,void 0),W=await this.k.scanOneOrMultipleExtensions(T);return this.F(W,K,U,!0)}async scanMetadata(J){const K=(0,h.$0f)(J,"package.json"),U=(await this.s.readFile(K)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(J,K){const U=(0,h.$0f)(J,"package.json"),T=(await this.s.readFile(U)).value.toString(),W=JSON.parse(T);K.isMachineScoped=K.isMachineScoped||void 0,K.isBuiltin=K.isBuiltin||void 0,W.__metadata={...W.__metadata,...K},await this.s.writeFile((0,h.$0f)(J,"package.json"),O.$Jb.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(J){if(J instanceof P.$$o&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw J}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const J=await this.scanUserExtensions({includeInvalid:!0});if(J.length)await this.r.addExtensionsToProfile(J.map(K=>[K,K.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,O.$Jb.fromString(JSON.stringify([])))}catch(K){(0,l.$9j)(K)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.$9)(K))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(J){this.t.error(J)}finally{this.C=void 0}})()),this.C}async F(J,K,U,T){return U.includeAllVersions||(J=this.G(K===0?J:void 0,K===1?J:void 0,K==="development"?J:void 0,await this.getTargetPlatform(),T)),U.includeInvalid||(J=J.filter(W=>W.isValid)),J.sort((W,H)=>{const Q=d.$ec(W.location.fsPath),ce=d.$ec(H.location.fsPath);return Q<ce?-1:Q>ce?1:0})}G(J,K,U,T,W){const H=(ce,oe,j)=>{if(ce.isValid&&!oe.isValid)return!1;if(ce.isValid===oe.isValid){if(W&&v.gt(ce.manifest.version,oe.manifest.version))return this.t.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${ce.location.path} with version ${ce.manifest.version}`),!1;if(v.eq(ce.manifest.version,oe.manifest.version)){if(ce.type===0)return this.t.debug(`Skipping extension ${oe.location.path} in favour of system extension ${ce.location.path} with same version`),!1;if(ce.targetPlatform===T)return this.t.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return j?this.t.warn(`Overwriting user extension ${ce.location.path} with ${oe.location.path}.`):this.t.debug(`Overwriting user extension ${ce.location.path} with ${oe.location.path}.`),!0},Q=new w.$Jl;return J?.forEach(ce=>{const oe=Q.get(ce.identifier.id);(!oe||H(oe,ce,!1))&&Q.set(ce.identifier.id,ce)}),K?.forEach(ce=>{const oe=Q.get(ce.identifier.id);if(!oe&&J&&ce.type===0){this.t.debug(`Skipping obsolete system extension ${ce.location.path}.`);return}(!oe||H(oe,ce,!1))&&Q.set(ce.identifier.id,ce)}),U?.forEach(ce=>{const oe=Q.get(ce.identifier.id);(!oe||H(oe,ce,!0))&&Q.set(ce.identifier.id,ce),Q.set(ce.identifier.id,ce)}),[...Q.values()]}async H(J,K){this.t.trace("Started scanning system extensions");const U=await this.L(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),W=await(J&&!U.devMode?this.i:this.k).scanExtensions(U);return this.t.trace("Scanned system extensions:",W.length),W}async I(J,K){const U=this.u.isBuilt?[]:this.v.builtInExtensions;if(!U?.length)return[];this.t.trace("Started scanning dev system extensions");const T=K?await this.J():{},W=[],H=g.URI.file(d.$$b(d.$ac($.$4e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ce of U){const oe=T[ce.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":W.push((0,h.$0f)(H,ce.name));break;default:W.push(g.URI.file(oe));break}}const Q=await Promise.all(W.map(async ce=>this.k.scanExtension(await this.L(ce,!1,0,!0,J,!0,void 0))));return this.t.trace("Scanned dev system extensions:",Q.length),(0,E.$mf)(Q)}async J(){try{const J=await this.s.readFile(this.l);return JSON.parse(J.value.toString())}catch{return{}}}async L(J,K,U,T,W,H,Q){const ce=await this.f(W??p.$v),oe=await this.M(J),j=K&&!this.w.extUri.isEqual(J,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,A=j?await this.M(j):void 0;return new B(J,oe,j,A,K,Q,U,T,H,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,W,ce)}async M(J){try{const K=await this.s.stat(J);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.$ep=N,e.$ep=N=pe([_(4,I.$rk),_(5,P.$_o),_(6,l.$Sj),_(7,n.$Ri),_(8,b.$wh),_(9,i.$0i),_(10,D.$pk),_(11,s.$oh)],N);class B{constructor(J,K,U,T,W,H,Q,ce,oe,j,A,F,q,G,Z){this.location=J,this.mtime=K,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=T,this.profile=W,this.profileScanOptions=H,this.type=Q,this.excludeObsolete=ce,this.validate=oe,this.productVersion=j,this.productDate=A,this.productCommit=F,this.devMode=q,this.language=G,this.translations=Z}static createNlsConfiguration(J){return{language:J.language,pseudo:J.language==="pseudo",devMode:J.devMode,translations:J.translations}}static equals(J,K){return(0,h.$3f)(J.location,K.location)&&J.mtime===K.mtime&&(0,h.$3f)(J.applicationExtensionslocation,K.applicationExtensionslocation)&&J.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&J.profile===K.profile&&r.$Lm(J.profileScanOptions,K.profileScanOptions)&&J.type===K.type&&J.excludeObsolete===K.excludeObsolete&&J.validate===K.validate&&J.productVersion===K.productVersion&&J.productDate===K.productDate&&J.productCommit===K.productCommit&&J.devMode===K.devMode&&J.language===K.language&&L.equals(J.translations,K.translations)}}e.$fp=B;let re=class extends u.$lb{constructor(J,K,U,T,W){super(),this.f=J,this.g=K,this.h=U,this.i=T,this.j=W}async scanExtensions(J){const K=J.profile?await this.l(J):await this.k(J);let U={};if(J.excludeObsolete&&J.type===1)try{const T=(await this.i.readFile(this.f)).value.toString();U=JSON.parse(T)}catch{}return(0,o.$we)(U)?K:K.filter(T=>!U[k.$go.create(T).toString()])}async k(J){const K=await this.i.resolve(J.location);if(!K.children?.length)return[];const U=await Promise.all(K.children.map(async T=>{if(!T.isDirectory||J.type===1&&(0,h.$7f)(T.resource).indexOf(".")===0)return null;const W=new B(T.resource,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(W)}));return(0,E.$mf)(U).sort((T,W)=>T.location.path<W.location.path?-1:1)}async l(J){let K=await this.m(J.location,()=>!0,J);if(J.applicationExtensionslocation&&!this.h.extUri.isEqual(J.location,J.applicationExtensionslocation)){K=K.filter(T=>!T.metadata?.isApplicationScoped);const U=await this.m(J.applicationExtensionslocation,T=>!!T.metadata?.isBuiltin||!!T.metadata?.isApplicationScoped,J);K.push(...U)}return K}async m(J,K,U){const T=await this.g.scanProfileExtensions(J,U.profileScanOptions);if(!T.length)return[];const W=await Promise.all(T.map(async H=>{if(K(H)){const Q=new B(H.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(Q,H.metadata)}return null}));return(0,E.$mf)(W)}async scanOneOrMultipleExtensions(J){try{if(await this.i.exists((0,h.$0f)(J.location,"package.json"))){const K=await this.scanExtension(J);return K?[K]:[]}else return await this.scanExtensions(J)}catch(K){return this.j.error(`Error scanning extensions at ${J.location.path}:`,(0,R.$9)(K)),[]}}async scanExtension(J,K){try{let U=await this.scanExtensionManifest(J.location);if(U){U.publisher||(U.publisher=w.$Dl),K=K??U.__metadata,delete U.__metadata;const T=(0,k.$ko)(U.publisher,U.name),W=K?.id?{id:T,uuid:K.id}:{id:T},H=K?.isSystem?0:J.type,Q=H===0||!!K?.isBuiltin;U=await this.n(J.location,U,B.createNlsConfiguration(J));const ce={type:H,identifier:W,manifest:U,location:J.location,isBuiltin:Q,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return J.validate?this.validate(ce,J):ce}}catch(U){J.type!==0&&this.j.error(U)}return null}validate(J,K){let U=!0;const T=(0,t.$vo)(K.productVersion,K.productDate,K.location,J.manifest,J.isBuiltin);for(const[W,H]of T)W===y.default.Error&&(U=!1,this.j.error(this.u(K.location,H)));return J.isValid=U,J.validations=T,J}async scanExtensionManifest(J){const K=(0,h.$0f)(J,"package.json");let U;try{U=(await this.i.readFile(K)).value.toString()}catch(W){return(0,l.$9j)(W)!==1&&this.j.error(this.u(J,(0,c.localize)(0,null,K.path,W.message))),null}let T;try{T=JSON.parse(U)}catch{const H=[];(0,S.$xm)(U,H);for(const Q of H)this.j.error(this.u(J,(0,c.localize)(1,null,K.path,Q.offset,Q.length,(0,f.$bp)(Q.error))));return null}return(0,S.$Gm)(T)!=="object"?(this.j.error(this.u(J,(0,c.localize)(2,null,K.path))),null):T}async n(J,K,U){const T=await this.r(J,K,U);if(T)try{const W=[],H=await this.s(T.default,W);if(W.length>0)return W.forEach(ce=>{this.j.error(this.u(J,(0,c.localize)(3,null,T.default?.path,(0,f.$bp)(ce.error))))}),K;if((0,S.$Gm)(T)!=="object")return this.j.error(this.u(J,(0,c.localize)(4,null,T.default?.path))),K;const Q=T.values||Object.create(null);return(0,M.$cp)(K,Q,H)}catch{}return K}async r(J,K,U){const T=(0,h.$0f)(J,"package.nls.json"),W=(oe,j)=>{j.forEach(A=>{this.j.error(this.u(J,(0,c.localize)(5,null,oe?.path,(0,f.$bp)(A.error))))})},H=oe=>{this.j.error(this.u(J,(0,c.localize)(6,null,oe?.path)))},Q=`${K.publisher}.${K.name}`,ce=U.translations[Q];if(ce)try{const oe=g.URI.file(ce),j=(await this.i.readFile(oe)).value.toString(),A=[],F=(0,S.$xm)(j,A);return A.length>0?(W(oe,A),{values:void 0,default:T}):(0,S.$Gm)(F)!=="object"?(H(oe),{values:void 0,default:T}):{values:F.contents?F.contents.package:void 0,default:T}}catch{return{values:void 0,default:T}}else{if(!await this.i.exists(T))return;let j;try{j=await this.t(J,U)}catch{return}if(!j.localized)return{values:void 0,default:j.original};try{const A=(await this.i.readFile(j.localized)).value.toString(),F=[],q=(0,S.$xm)(A,F);return F.length>0?(W(j.localized,F),{values:void 0,default:j.original}):(0,S.$Gm)(q)!=="object"?(H(j.localized),{values:void 0,default:j.original}):{values:q,default:j.original}}catch{return{values:void 0,default:j.original}}}}async s(J,K){if(J)try{const U=(await this.i.readFile(J)).value.toString();return(0,S.$xm)(U,K)}catch{}}t(J,K){return new Promise((U,T)=>{const W=H=>{const Q=(0,h.$0f)(J,`package.nls.${H}.json`);this.i.exists(Q).then(ce=>{ce&&U({localized:Q,original:(0,h.$0f)(J,"package.nls.json")});const oe=H.lastIndexOf("-");oe===-1?U({localized:(0,h.$0f)(J,"package.nls.json"),original:null}):(H=H.substring(0,oe),W(H))})};if(K.devMode||K.pseudo||!K.language)return U({localized:(0,h.$0f)(J,"package.nls.json"),original:null});W(K.language)})}u(J,K){return`[${J.path}]: ${K}`}};re=pe([_(1,P.$_o),_(2,D.$pk),_(3,l.$Sj),_(4,n.$Ri)],re);let ne=class extends re{constructor(J,K,U,T,W,H,Q){super(K,T,W,H,Q),this.z=J,this.C=U,this.w=this.B(new C.$tg(3e3)),this.y=this.B(new a.$8c),this.onDidChangeCache=this.y.event}async scanExtensions(J){const K=this.H(J),U=await this.D(K);if(this.v=J,U&&U.input&&B.equals(U.input,this.v))return this.j.debug("Using cached extensions scan result",J.location.toString()),this.w.trigger(()=>this.G()),U.result.map(W=>(W.location=g.URI.revive(W.location),W));const T=await super.scanExtensions(J);return await this.F(K,{input:J,result:T}),T}async D(J){try{const K=await this.i.readFile(J),U=JSON.parse(K.value.toString());return{result:U.result,input:(0,m.$Yg)(U.input)}}catch(K){this.j.debug("Error while reading the extension cache file:",J.path,(0,R.$9)(K))}return null}async F(J,K){try{await this.i.writeFile(J,O.$Jb.fromString(JSON.stringify(K)))}catch(U){this.j.debug("Error while writing the extension cache file:",J.path,(0,R.$9)(U))}}async G(){if(!this.v)return;const J=this.H(this.v),K=await this.D(J);if(!K)return;const U=K.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!r.$Lm(T,U))try{this.j.info("Invalidating Cache",U,T),await this.i.del(J),this.y.fire()}catch(W){this.j.error(W)}}H(J){const K=this.I(J);return this.h.extUri.joinPath(K.cacheHome,J.type===0?w.$Cl:w.$Bl)}I(J){return J.type===0?this.C.defaultProfile:J.profile?this.h.extUri.isEqual(J.location,this.z.extensionsResource)?this.z:this.C.profiles.find(K=>this.h.extUri.isEqual(J.location,K.extensionsResource))??this.z:this.C.defaultProfile}};ne=pe([_(2,I.$rk),_(3,P.$_o),_(4,D.$pk),_(5,l.$Sj),_(6,n.$Ri)],ne);function ue(le,J){const K=(0,k.$io)(le.manifest.publisher,le.manifest.name);return{id:K,identifier:new w.$Hl(K),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:J,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,...le.manifest}}e.$gp=ue;class se extends N{constructor(J,K,U,T,W,H,Q,ce,oe,j,A,F){super(J,K,(0,h.$0f)(U,".vscode-oss-dev","extensions","control.json"),T,W,H,Q,ce,oe,j,A,F),this.N=(async()=>{if(p.$y)try{const q=await this.s.readFile(g.URI.file(p.$y));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}f(J){return this.N}}e.$hp=se}),define(te[278],ie([0,1,5,41,40,26,82,16,33,7]),function(V,e,E,C,r,O,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=void 0;let $=class extends R.$ap{constructor(p,h,v,y,o,g){super(u.URI.file(p.extensionsPath),h,v,y,o,g)}};e.$ZM=$,e.$ZM=$=pe([_(0,f.$xh),_(1,S.$Sj),_(2,C.$rk),_(3,r.$pk),_(4,O.$Vk),_(5,E.$Ri)],$)}),define(te[279],ie([0,1,7,33,82,129,16,6,5,23,40,41]),function(V,e,E,C,r,O,R,S,f,u,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q4b=void 0;let p=class extends O.$hp{constructor(v,y,o,g,c,b,k,w){super(E.URI.file(c.builtinExtensionsPath),E.URI.file(c.extensionsPath),c.userHome,v.defaultProfile,v,y,o,g,c,b,k,w)}};e.$Q4b=p,e.$Q4b=p=pe([_(0,d.$rk),_(1,r.$_o),_(2,R.$Sj),_(3,f.$Ri),_(4,C.$xh),_(5,u.$0i),_(6,$.$pk),_(7,S.$oh)],p)}),define(te[280],ie([0,1,14,2,15,9,4,58,7,31,38,33,5,41]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$64b=void 0;let v=class extends C.$lb{constructor(o,g,c){super(),this.c=o,this.f=c,this.a=S.$vh.forPaths(!R.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(o.appRoot),this.addValidFileRoot(o.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(o.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:o}=E.session;o.protocol.registerFileProtocol(r.Schemas.vscodeFileResource,(g,c)=>this.i(g,c)),o.protocol.interceptFileProtocol(r.Schemas.file,(g,c)=>this.h(g,c)),this.B((0,C.$jb)(()=>{o.protocol.unregisterProtocol(r.Schemas.vscodeFileResource),o.protocol.uninterceptProtocol(r.Schemas.file)}))}addValidFileRoot(o){const g=(0,O.$$b)(o);return this.a.get(g)?C.$lb.None:(this.a.set(g,!0),(0,C.$jb)(()=>this.a.delete(g)))}h(o,g){const c=f.URI.parse(o.url);return this.f.error(`Refused to load resource ${c.fsPath} from ${r.Schemas.file}: protocol (original URL: ${o.url})`),g({error:-3})}i(o,g){const c=this.j(o);let b;return this.c.crossOriginIsolated&&((0,O.$ec)(c)==="workbench.html"||(0,O.$ec)(c)==="workbench-dev.html"?b=r.COI.CoopAndCoep:b=r.COI.getHeadersFromQuery(o.url)),this.a.findSubstr(c)?g({path:c,headers:b}):this.b.has((0,O.$fc)(c).toLowerCase())?g({path:c}):(this.f.error(`${r.Schemas.vscodeFileResource}: Refused to load resource ${c} from ${r.Schemas.vscodeFileResource}: protocol (original URL: ${o.url})`),g({error:-3}))}j(o){const g=f.URI.parse(o.url),c=r.$4e.uriToFileUri(g);return(0,O.$$b)(c.fsPath)}createIPCObjectUrl(){let o;const g=f.URI.from({scheme:"vscode",path:(0,u.$6e)()}),c=g.toString(),b=async()=>o;return $.$oS.handle(c,b),this.f.trace(`IPC Object URL: Registered new channel ${c}.`),{resource:g,update:k=>o=k,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${c}.`),$.$oS.removeHandler(c)}}}};e.$64b=v,e.$64b=v=pe([_(0,d.$xh),_(1,h.$rk),_(2,p.$Ri)],v)}),define(te[97],ie([0,1,8,3,2,65,10,111,6,41]),function(V,e,E,C,r,O,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Ko=e.$Jo=e.$Io=void 0,e.$Io="__$__isNewStorageMarker",e.$Jo="__$__targetStorageMarker",e.$Ko=(0,f.$ph)("storageService");var $;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})($||(e.WillSaveStateReason=$={}));var d;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(d||(e.StorageScope=d={}));var p;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function h(c){const b=c.get(e.$Jo);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}e.$Lo=h;class v extends r.$lb{static{this.a=60*1e3}constructor(b={flushInterval:v.a}){super(),this.j=b,this.b=this.B(new C.$$c),this.c=this.B(new C.$$c),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$8c),this.onWillSaveState=this.f.event,this.h=this.B(new E.$Gg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new r.$mb),this.v=void 0,this.y=void 0,this.C=void 0}onDidChangeValue(b,k,w){return C.Event.filter(this.b.event,t=>t.scope===b&&(k===void 0||t.key===k),w)}k(){this.i.value=(0,E.$Kg)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,r.$gb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.J()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(b,k){const{key:w,external:t}=k;if(w===e.$Jo){switch(b){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:b})}else this.b.fire({scope:b,key:w,target:this.F(b)[w],external:t})}r(b){this.f.fire({reason:b})}get(b,k,w){return this.L(k)?.get(b,w)}getBoolean(b,k,w){return this.L(k)?.getBoolean(b,w)}getNumber(b,k,w){return this.L(k)?.getNumber(b,w)}getObject(b,k,w){return this.L(k)?.getObject(b,w)}storeAll(b,k){this.t(()=>{for(const w of b)this.store(w.key,w.value,w.scope,w.target,k)})}store(b,k,w,t,l=!1){if((0,R.$se)(k)){this.remove(b,w,l);return}this.t(()=>{this.u(b,w,t),this.L(w)?.set(b,k,l)})}remove(b,k,w=!1){this.t(()=>{this.u(b,k,void 0),this.L(k)?.delete(b,w)})}t(b){this.b.pause(),this.c.pause();try{b()}finally{this.b.resume(),this.c.resume()}}keys(b,k){const w=[],t=this.F(b);for(const l of Object.keys(t))t[l]===k&&w.push(l);return w}u(b,k,w,t=!1){const l=this.F(k);typeof w=="number"?l[b]!==w&&(l[b]=w,this.L(k)?.set(e.$Jo,JSON.stringify(l),t)):typeof l[b]=="number"&&(delete l[b],this.L(k)?.set(e.$Jo,JSON.stringify(l),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(b){switch(b){case-1:return this.D;case 0:return this.z;default:return this.w}}G(b){const k=this.L(b);return k?h(k):Object.create(null)}isNew(b){return this.getBoolean(e.$Io,b)===!0}async flush(b=$.NONE){this.f.fire({reason:b});const k=this.L(-1),w=this.L(0),t=this.L(1);switch(b){case $.NONE:await E.Promises.settled([k?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case $.SHUTDOWN:await E.Promises.settled([k?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.L(-1)?.items??new Map,k=this.L(0)?.items??new Map,w=this.L(1)?.items??new Map;return g(b,k,w,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(b,k){return this.r($.NONE),(0,u.$qk)(b)?this.N(b,k):this.O(b,k)}H(b,k){return!(b.id===k.id||y(k)&&y(b))}I(b,k,w){this.t(()=>{const t=new Set;for(const[l,s]of b)t.add(l),k.get(l)!==s&&this.n(w,{key:l,external:!0});for(const[l]of k.items)t.has(l)||this.n(w,{key:l,external:!0})})}}e.$Mo=v;function y(c){return c.isDefault||!!c.useDefaultFlags?.globalState}e.$No=y;class o extends v{constructor(){super(),this.p=this.B(new S.$Go(new S.$Ho,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new S.$Go(new S.$Ho,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new S.$Go(new S.$Ho,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(b=>this.n(1,b))),this.B(this.P.onDidChangeStorage(b=>this.n(0,b))),this.B(this.p.onDidChangeStorage(b=>this.n(-1,b)))}L(b){switch(b){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(b){return!1}}e.$Oo=o;async function g(c,b,k,w,t,l){const s=L=>{try{return JSON.parse(L)}catch{return L}},n=new Map,i=new Map;c.forEach((L,N)=>{n.set(N,L),i.set(N,s(L))});const a=new Map,m=new Map;b.forEach((L,N)=>{a.set(N,L),m.set(N,s(L))});const P=new Map,I=new Map;k.forEach((L,N)=>{P.set(N,L),I.set(N,s(L))}),console.group(w!==t?`Storage: Application (path: ${w})`:`Storage: Application & Profile (path: ${w}, default profile)`);const D=[];if(n.forEach((L,N)=>{D.push({key:N,value:L})}),console.table(D),console.groupEnd(),console.log(i),w!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];a.forEach((N,B)=>{L.push({key:B,value:N})}),console.table(L),console.groupEnd(),console.log(m)}console.group(`Storage: Workspace (path: ${l})`);const M=[];P.forEach((L,N)=>{M.push({key:N,value:L})}),console.table(M),console.groupEnd(),console.log(I)}e.$Po=g}),define(te[281],ie([0,1,24,8,3,2,9,69,7,21,111,159,5,97,26,30]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m3b=e.$l3b=e.$k3b=e.$j3b=void 0;class o extends O.$lb{static{this.a=2e3}get storage(){return this.f}constructor(l,s){super(),this.j=l,this.k=s,this.b=this.B(new r.$8c),this.onDidChangeStorage=this.b.event,this.c=this.B(new r.$8c),this.onDidCloseStorage=this.c.event,this.f=new $.$Go(new $.$Ho,{hint:$.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new C.$Pg,this.whenInit=this.h.p,this.i=$.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===$.StorageState.None)try{const l=await this.n();this.f.dispose(),this.f=l,this.B(l.onDidChangeStorage(n=>this.b.fire(n))),await this.m(l);const s=l.getBoolean(h.$Io);s===void 0?l.set(h.$Io,!0):s&&l.set(h.$Io,!1)}catch(l){this.j.error(`[storage main] initialize(): Unable to init storage due to ${l}`)}finally{this.i=$.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===p.LogLevel.Trace?l=>this.j.trace(l):void 0,logError:l=>this.j.error(l)}}m(l){return l.init()}get items(){return this.f.items}get(l,s){return this.f.get(l,s)}set(l,s){return this.f.set(l,s)}delete(l){return this.f.delete(l)}async close(){const l=new S.$4c(!1);await this.s(),l.stop(),l.elapsed()>o.a&&await this.r(l),this.c.fire()}async r(l){if(this.path)try{const s=(0,E.top)(Array.from(this.f.items.entries()).map(([i,a])=>({key:i,length:a.length})),(i,a)=>a.length-i.length,5).map(i=>`${i.key}:${i.length}`).join(", "),n=(await this.k.stat(f.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${l.elapsed()}ms, DB size: ${n}b, Large Keys: ${s}`)}catch(s){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",s)}}async s(){this.g&&await this.g,this.i=$.StorageState.Closed,await this.f.close()}}class g extends o{static{this.t="state.vscdb"}get path(){if(!this.v.useInMemoryStorage)return(0,R.$ac)(this.u.globalStorageHome.fsPath,g.t)}constructor(l,s,n,i){super(n,i),this.u=l,this.v=s}async n(){return new $.$Go(new d.$US(this.path??d.$US.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:$.StorageHint.STORAGE_IN_MEMORY})}}class c extends g{constructor(l,s,n,i){super(l,s,n,i)}}e.$j3b=c;class b extends g{constructor(l,s,n,i){super(s.defaultProfile,l,n,i)}async m(l){await super.m(l),this.z(l)}z(l){l.get(v.$Yk,void 0)===void 0&&l.set(v.$Yk,new Date().toUTCString());const n=l.get(v.$Xk,void 0),i=new Date().toUTCString();l.set(v.$Zk,typeof n>"u"?null:n),l.set(v.$Xk,i)}}e.$k3b=b;class k extends o{static{this.t="state.vscdb"}static{this.u="workspace.json"}get path(){if(!this.w.useInMemoryStorage)return(0,R.$ac)(this.y.workspaceStorageHome.fsPath,this.v.id,k.t)}constructor(l,s,n,i,a){super(n,a),this.v=l,this.w=s,this.y=i}async n(){const{storageFilePath:l,wasCreated:s}=await this.C();return new $.$Go(new d.$US(l,{logging:this.l()}),{hint:this.w.useInMemoryStorage?$.StorageHint.STORAGE_IN_MEMORY:s?$.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:d.$US.IN_MEMORY_PATH,wasCreated:!0};const l=(0,R.$ac)(this.y.workspaceStorageHome.fsPath,this.v.id),s=(0,R.$ac)(l,k.t);return await u.Promises.exists(l)?{storageFilePath:s,wasCreated:!1}:(await u.Promises.mkdir(l,{recursive:!0}),this.D(l),{storageFilePath:s,wasCreated:!0})}async D(l){let s;if((0,y.$zh)(this.v)?s={folder:this.v.uri.toString()}:(0,y.$Eh)(this.v)&&(s={workspace:this.v.configPath.toString()}),s)try{const n=(0,R.$ac)(l,k.u);await u.Promises.exists(n)||await u.Promises.writeFile(n,JSON.stringify(s,void 0,2))}catch(n){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$l3b=k;class w extends o{get path(){}async n(){return new $.$Go(new $.$Ho,{hint:$.StorageHint.STORAGE_IN_MEMORY})}}e.$m3b=w}),define(te[282],ie([0,1,3,2,97]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S4b=void 0;class O extends C.$lb{constructor(S,f,u){super(),this.b=S,this.c=f,this.f=u;const $=this.B(new C.$mb);this.a=this.B(new E.$8c({onWillAddFirstListener:()=>$.value=this.g(),onDidRemoveLastListener:()=>$.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new C.$kb;return S.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,u)=>(f?f.push(u.key):f=[u.key],f),100)(f=>this.h(f))),S.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(f,u)=>{f||(f=new Map);let $=f.get(u.profile.id);return $||f.set(u.profile.id,$={profile:u.profile,keys:[],storage:u.storage}),$.keys.push(u.key),f},100)(f=>this.i(f))),S}h(S){const f=S.includes(r.$Jo)?[this.c.defaultProfile]:[],u=[];if(S=S.filter($=>$!==r.$Jo),S.length){const $=(0,r.$Lo)(this.b.applicationStorage.storage);u.push({profile:this.c.defaultProfile,changes:S.map(d=>({key:d,scope:0,target:$[d]}))})}this.j(f,u)}i(S){const f=[],u=new Map;for(const[$,d]of S.entries()){d.keys.includes(r.$Jo)&&f.push(d.profile);const p=d.keys.filter(h=>h!==r.$Jo);if(p.length){const h=(0,r.$Lo)(d.storage.storage);u.set($,{profile:d.profile,changes:p.map(v=>({key:v,scope:0,target:h[v]}))})}}this.j(f,[...u.values()])}j(S,f){(S.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:S})}listen(S,f,u){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(S,f){throw new Error(`Call not found: ${f}`)}}e.$S4b=O}),define(te[283],ie([0,1,7,33,16,5,34,40,41,10,121]),function(V,e,E,C,r,O,R,S,f,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=e.$XM=e.$WM=void 0;let d=class ft extends f.$uk{static{this.a="profileAssociationsMigration"}constructor(y,o,g,c,b){super(g,c,o,b),this.P=y,this.Q=g}J(){return this.P.getItem(ft.b,[]).map(o=>({...o,location:(0,u.$je)(o.location)?this.s.extUri.joinPath(this.profilesHome,o.location):E.URI.revive(o.location)}))}M(){const y=this.P.getItem(ft.c,{});return this.P.getItem(ft.a,!1)?y:this.I(y)}O(){return this.s.extUri.joinPath(E.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$WM=d,e.$WM=d=pe([_(0,R.$RM),_(1,S.$pk),_(2,C.$xh),_(3,r.$Sj),_(4,O.$Ri)],d);let p=class rt extends d{constructor(y,o,g,c,b){super(y,o,g,c,b),this.W=y}L(y){y.length?this.W.setItem(rt.b,y.map(o=>({...o,location:this.s.extUri.basename(o.location)}))):this.W.removeItem(rt.b)}J(){const y=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(y),this.W.setItem("userDataProfilesMigration",!0)),y}N(y){y.emptyWindows||y.workspaces?this.W.setItem(rt.c,y):this.W.removeItem(rt.c)}M(){const y="workspaceAndProfileInfo",o=this.W.getItem(y,void 0);if(o){this.W.removeItem(y);const c=o.reduce((b,{workspace:k,profile:w})=>(b[E.URI.revive(k).toString()]=E.URI.revive(w).toString(),b),{});this.W.setItem(rt.c,{workspaces:c})}const g=super.M();return this.W.getItem(rt.a,!1)||(this.N(g),this.W.setItem(rt.a,!0)),g}};e.$XM=p,e.$XM=p=pe([_(0,R.$SM),_(1,S.$pk),_(2,C.$xh),_(3,r.$Sj),_(4,O.$Ri)],p);let h=class extends p{constructor(y,o,g,c){super(new $.$VM(0,o,c,g),y,o,g,c)}async init(){return await this.W.init(),super.init()}};e.$YM=h,e.$YM=h=pe([_(0,S.$pk),_(1,C.$xh),_(2,r.$Sj),_(3,O.$Ri)],h)}),define(te[53],ie([0,1,33,16,6,5,40,41,283,34]),function(V,e,E,C,r,O,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o3b=e.$n3b=void 0,e.$n3b=(0,r.$qh)(S.$rk);let $=class extends f.$XM{constructor(p,h,v,y,o){super(p,h,v,y,o)}getAssociatedEmptyWindows(){const p=[];for(const h of this.v.emptyWindows.keys())p.push({id:h});return p}};e.$o3b=$,e.$o3b=$=pe([_(0,u.$SM),_(1,R.$pk),_(2,E.$xh),_(3,C.$Sj),_(4,O.$Ri)],$)}),define(te[130],ie([0,1,19,7,30]),function(V,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J3b=e.$I3b=e.$H3b=void 0;async function O(f,u,$){for(const p of f){const h=p.openedWorkspace;if((0,r.$Eh)(h)){const v=await $(h);if(v){if(v.folders.some(y=>E.$1f.isEqualOrParent(u,y.uri)))return p}else if(E.$1f.isEqualOrParent(u,h.configPath))return p}}const d=f.filter(p=>(0,r.$zh)(p.openedWorkspace)&&E.$1f.isEqualOrParent(u,p.openedWorkspace.uri));if(d.length)return d.sort((p,h)=>-(p.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.$H3b=O;function R(f,u){for(const $ of f)if((0,r.$Eh)($.openedWorkspace)&&E.$1f.isEqual($.openedWorkspace.configPath,u)||(0,r.$zh)($.openedWorkspace)&&E.$1f.isEqual($.openedWorkspace.uri,u))return $}e.$I3b=R;function S(f,u){const $=d=>u.some(p=>E.$1f.isEqual(C.URI.file(p),C.URI.file(d)));for(const d of f)if(d.config?.extensionDevelopmentPath?.some(p=>$(p)))return d}e.$J3b=S}),define(te[98],ie([0,1,32,44,137,46,15,9,4,19,7,6,60,30]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qab=e.$Pab=e.$Oab=e.$Nab=e.$Mab=e.$Lab=e.$Kab=e.$Jab=e.$Iab=e.$Hab=void 0,e.$Hab=(0,d.$ph)("workspacesService");function v(I){return I.hasOwnProperty("workspace")}e.$Iab=v;function y(I){return I.hasOwnProperty("folderUri")}e.$Jab=y;function o(I){return I.hasOwnProperty("fileUri")}e.$Kab=o;function g(I){return c(I)||b(I)}e.$Lab=g;function c(I){const D=I;return typeof D?.path=="string"&&(!D.name||typeof D.name=="string")}function b(I){const D=I;return typeof D?.uri=="string"&&(!D.name||typeof D.name=="string")}function k(I,D,M,L,N){if(I.scheme!==L.scheme)return{name:M,uri:I.toString(!0)};let B=D?void 0:N.relativePath(L,I);if(B!==void 0)B.length===0?B=".":f.$i&&(B=w(B));else if(I.scheme===R.Schemas.file)B=I.fsPath,f.$i&&(B=w(B));else if(N.isEqualAuthority(I.authority,L.authority))B=I.path;else return{name:M,uri:I.toString(!0)};return{name:M,path:B}}e.$Mab=k;function w(I){return I=(0,O.$1z)(I),(0,E.$He)(I)||(I=(0,E.$Ee)(I)),I}function t(I,D,M){const L=[],N=new Set,B=M.dirname(D);for(const re of I){let ne;if(c(re))re.path&&(ne=M.resolvePath(B,re.path));else if(b(re))try{ne=$.URI.parse(re.uri),ne.path[0]!==S.$0b.sep&&(ne=ne.with({path:S.$0b.sep+ne.path}))}catch(ue){console.warn(ue)}if(ne){const ue=M.getComparisonKey(ne);if(!N.has(ue)){N.add(ue);const se=re.name||M.basenameOrAuthority(ne);L.push(new h.$Jh({uri:ne,name:se,index:L.length},re))}}}return L}e.$Nab=t;function l(I,D,M,L,N){const B=s(D,I),re=N.dirname(D),ne=N.dirname(L),ue=[];for(const K of B.folders){const U=c(K)?N.resolvePath(re,K.path):$.URI.parse(K.uri);let T;M?T=!1:T=!c(K)||(0,S.$_b)(K.path),ue.push(k(U,T,K.name,ne,N))}const se={insertSpaces:!1,tabSize:4,eol:f.$k||f.$j?`
`:`\r
`},le=r.$$R(I,["folders"],ue,se);let J=r.$bS(I,le);return(0,u.$cg)(B.remoteAuthority,(0,p.$Bk)(L))&&(J=r.$bS(J,r.$0R(J,["remoteAuthority"],se))),J}e.$Oab=l;function s(I,D){const M=C.$xm(D);if(M&&Array.isArray(M.folders))M.folders=M.folders.filter(L=>g(L));else throw new Error(`${I} looks like an invalid workspace file.`);return M}function n(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function i(I){return typeof I.folderUri=="string"}function a(I){return typeof I.fileUri=="string"}function m(I,D){const M={workspaces:[],files:[]};if(I){const L=function(B,re){for(let ne=0;ne<B.length;ne++)try{re(B[ne],ne)}catch(ue){D.warn(`Error restoring recent entry ${JSON.stringify(B[ne])}: ${ue.toString()}. Skip entry.`)}},N=I;Array.isArray(N.entries)&&L(N.entries,B=>{const re=B.label,ne=B.remoteAuthority;n(B)?M.workspaces.push({label:re,remoteAuthority:ne,workspace:{id:B.workspace.id,configPath:$.URI.parse(B.workspace.configPath)}}):i(B)?M.workspaces.push({label:re,remoteAuthority:ne,folderUri:$.URI.parse(B.folderUri)}):a(B)&&M.files.push({label:re,remoteAuthority:ne,fileUri:$.URI.parse(B.fileUri)})})}return M}e.$Pab=m;function P(I){const D={entries:[]};for(const M of I.workspaces)y(M)?D.entries.push({folderUri:M.folderUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority}):D.entries.push({workspace:{id:M.workspace.id,configPath:M.workspace.configPath.toString()},label:M.label,remoteAuthority:M.remoteAuthority});for(const M of I.files)D.entries.push({fileUri:M.fileUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority});return D}e.$Qab=P}),define(te[99],ie([0,1,72,15,4,19]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C3b=e.$B3b=e.$A3b=e.$z3b=void 0,e.$z3b=128/4;function R(u){function $(){let d=u.scheme===C.Schemas.file?(0,O.$Xf)(u):u.toString();return r.$k||(d=d.toLowerCase()),(0,E.createHash)("md5").update(d).digest("hex")}return{id:$(),configPath:u}}e.$A3b=R;function S(u,$){function d(){if(u.scheme!==C.Schemas.file)return(0,E.createHash)("md5").update(u.toString()).digest("hex");if(!$)return;let h;return r.$k?h=$.ino:r.$j?h=$.birthtime.getTime():r.$i&&(typeof $.birthtimeMs=="number"?h=Math.floor($.birthtimeMs):h=$.birthtime.getTime()),(0,E.createHash)("md5").update(u.fsPath).update(h?String(h):"").digest("hex")}const p=d();if(typeof p=="string")return{id:p,uri:u}}e.$B3b=S;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$C3b=f}),define(te[131],ie([0,1,72,88,27,284,17,13,3,2,9,4,31,42,109]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=void 0;class y{traceSocketEvent(D,M){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,D,M)}constructor(D,M=""){this.f=!0,this.debugLabel=M,this.socket=D,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,S.$Y)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(D){const M=L=>{this.traceSocketEvent("read",L),D(R.$Jb.wrap(L))};return this.socket.on("data",M),{dispose:()=>this.socket.off("data",M)}}onClose(D){const M=L=>{D({type:0,hadError:L,error:void 0})};return this.socket.on("close",M),{dispose:()=>this.socket.off("close",M)}}onEnd(D){const M=()=>{D()};return this.socket.on("end",M),{dispose:()=>this.socket.off("end",M)}}write(D){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",D),this.socket.write(D.buffer,M=>{if(M){if(M.code==="EPIPE")return;(0,S.$Y)(M)}})}catch(M){if(M.code==="EPIPE")return;(0,S.$Y)(M)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((D,M)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),D();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),D()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$eh=y;var o;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(o||(o={}));var g;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(g||(g={}));class c extends u.$lb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(D,M){this.socket.traceSocketEvent(D,M)}constructor(D,M,L,N){super(),this.f=this.B(new f.$8c),this.g=this.B(new f.$8c),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=D,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:M,inflateBytesLength:L?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new b(this,M,L,N,this.f,(B,re)=>this.k(B,re))),this.B(this.a.onError(B=>{console.error(B),(0,S.$Y)(B),this.g.fire({type:0,hadError:!0,error:B})})),this.b=new v.$_g,this.B(this.socket.onData(B=>this.l(B))),this.B(this.socket.onClose(async B=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(B)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(D){return this.f.event(D)}onClose(D){return this.g.event(D)}onEnd(D){return this.socket.onEnd(D)}write(D){let M=0;for(;M<D.byteLength;)this.a.writeMessage(D.slice(M,Math.min(M+262144,D.byteLength))),M+=262144}k(D,M){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",D);let L=2;D.byteLength<126?L+=0:D.byteLength<2**16?L+=2:L+=8;const N=R.$Jb.alloc(L);if(M?N.writeUInt8(194,0):N.writeUInt8(130,0),D.byteLength<126)N.writeUInt8(D.byteLength,1);else if(D.byteLength<2**16){N.writeUInt8(126,1);let B=1;N.writeUInt8(D.byteLength>>>8&255,++B),N.writeUInt8(D.byteLength>>>0&255,++B)}else{N.writeUInt8(127,1);let B=1;N.writeUInt8(0,++B),N.writeUInt8(0,++B),N.writeUInt8(0,++B),N.writeUInt8(0,++B),N.writeUInt8(D.byteLength>>>24&255,++B),N.writeUInt8(D.byteLength>>>16&255,++B),N.writeUInt8(D.byteLength>>>8&255,++B),N.writeUInt8(D.byteLength>>>0&255,++B)}this.socket.write(R.$Jb.concat([N,D]))}end(){this.h=!0,this.socket.end()}l(D){if(D.byteLength!==0){for(this.b.acceptChunk(D);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const M=this.b.peek(this.j.readLen),L=M.readUInt8(0),N=(L&128)>>>7,B=(L&64)>>>6,re=M.readUInt8(1),ne=(re&128)>>>7,ue=re&127;this.j.state=2,this.j.readLen=2+(ne?4:0)+(ue===126?2:0)+(ue===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!B),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const M=this.b.read(this.j.readLen),L=M.readUInt8(1),N=(L&128)>>>7;let B=L&127,re=1;B===126?B=M.readUInt8(++re)*2**8+M.readUInt8(++re):B===127&&(B=M.readUInt8(++re)*0+M.readUInt8(++re)*0+M.readUInt8(++re)*0+M.readUInt8(++re)*0+M.readUInt8(++re)*2**24+M.readUInt8(++re)*2**16+M.readUInt8(++re)*2**8+M.readUInt8(++re));let ne=0;N&&(ne=M.readUInt8(++re)*2**24+M.readUInt8(++re)*2**16+M.readUInt8(++re)*2**8+M.readUInt8(++re)),this.j.state=3,this.j.readLen=B,this.j.mask=ne,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const M=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",M),t(M,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",M),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(M,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$fh=c;class b extends u.$lb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$Jb.alloc(0)}constructor(D,M,L,N,B,re){super(),this.l=D,this.m=B,this.n=re,this.a=this.B(new f.$8c),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$8c),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new f.$8c),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,M?(this.b=this.B(new k(this.l,N,L,{windowBits:15})),this.f=this.B(new w(this.l,{windowBits:15})),this.B(this.b.onError(ne=>this.a.fire(ne))),this.B(this.f.onError(ne=>this.a.fire(ne)))):(this.b=null,this.f=null)}writeMessage(D){this.g.push(D),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const D=this.g.shift();if(this.f){const M=await this.s(this.f,D);this.n(M,!0)}else this.n(D,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(D,M){return new Promise((L,N)=>{D.write(M),D.flush(B=>L(B))})}acceptFrame(D,M,L){this.h.push({data:D,isCompressed:M,isLastFrameOfMessage:L}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const D=this.h.shift();if(this.b&&D.isCompressed){const M=await this.w(this.b,D.data,D.isLastFrameOfMessage);this.m.fire(M)}else this.m.fire(D.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(D,M,L){return new Promise((N,B)=>{D.write(M),L&&D.write(R.$Jb.fromByteArray([0,0,255,255])),D.flush(re=>N(re))})}}class k extends u.$lb{get recordedInflateBytes(){return this.j?R.$Jb.concat(this.f):R.$Jb.alloc(0)}constructor(D,M,L,N){super(),this.h=D,this.j=M,this.a=this.B(new f.$8c),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(N),this.b.on("error",B=>{this.h.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this.a.fire(B)}),this.b.on("data",B=>{this.h.traceSocketEvent("zlibInflateData",B),this.g.push(R.$Jb.wrap(B))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(D){this.j&&this.f.push(D.clone()),this.h.traceSocketEvent("zlibInflateWrite",D),this.b.write(D.buffer)}flush(D){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const M=R.$Jb.concat(this.g);this.g.length=0,D(M)})}}class w extends u.$lb{constructor(D,M){super(),this.g=D,this.a=this.B(new f.$8c),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(R.$Jb.wrap(L))})}write(D){this.g.traceSocketEvent("zlibDeflateWrite",D.buffer),this.b.write(D.buffer)}flush(D){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let M=R.$Jb.concat(this.f);this.f.length=0,M=M.slice(0,M.byteLength-4),D(M)})}}function t(I,D){if(D===0)return;const M=I.byteLength>>>2;for(let ue=0;ue<M;ue++){const se=I.readUInt32BE(ue*4);I.writeUInt32BE(se^D,ue*4)}const L=M*4,N=I.byteLength-L,B=D>>>24&255,re=D>>>16&255,ne=D>>>8&255;N>=1&&I.writeUInt8(I.readUInt8(L)^B,L),N>=2&&I.writeUInt8(I.readUInt8(L+1)^re,L+1),N>=3&&I.writeUInt8(I.readUInt8(L+2)^ne,L+2)}e.$gh=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function s(){const I=(0,p.$6e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const D=process.platform!=="darwin"&&e.$gh?e.$gh:(0,r.tmpdir)(),M=(0,$.$ac)(D,`vscode-ipc-${I}.sock`);return i(M),M}e.$hh=s;function n(I,D,M){const L=(0,E.createHash)("md5").update(I).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${M}-${D}-sock`;const N=M.substr(0,4),B=D.substr(0,6),re=L.substr(0,8);let ne;return process.platform!=="darwin"&&e.$gh&&!process.env.VSCODE_PORTABLE?ne=(0,$.$ac)(e.$gh,`vscode-${re}-${N}-${B}.sock`):ne=(0,$.$ac)(I,`${N}-${B}.sock`),i(ne),ne}e.$ih=n;function i(I){const D=l[d.$t];typeof D=="number"&&I.length>=D&&console.warn(`WARNING: IPC handle "${I}" is longer than ${D} chars, try a shorter --user-data-dir`)}class a extends h.$6g{static b(D){const M=f.Event.fromNodeEventEmitter(D,"connection");return f.Event.map(M,L=>({protocol:new v.$ah(new y(L,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(L,"close"))}))}constructor(D){super(a.b(D)),this.d=D}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$jh=a;function m(I){return new Promise((D,M)=>{const L=(0,C.createServer)();L.on("error",M),L.listen(I,()=>{L.removeListener("error",M),D(new a(L))})})}e.$kh=m;function P(I,D){return new Promise((M,L)=>{const N=(0,C.createConnection)(I,()=>{N.removeListener("error",L),M(v.$bh.fromSocket(new y(N,`ipc-client${D}`),D))});N.once("error",L)})}e.$lh=P}),define(te[28],ie([0,1,55,9,4,131,33,90,6]),function(V,e,E,C,r,O,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g3b=e.$f3b=void 0,e.$f3b=(0,f.$qh)(R.$wh);class u extends S.$Xl{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,C.$ac)(this.userDataPath,"clp")}get backupHome(){return(0,C.$ac)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,O.$ih)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,C.$ac)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(r.$k){for(const d in process.env)if(d.endsWith("_VSCODE_SNAP_ORIG")){const p=d.slice(0,-17);if(this.d[p])continue;process.env[p]&&(this.d[p]=process.env[p]),process.env[d]?process.env[p]=process.env[d]:delete process.env[p]}}}restoreSnapExportedVariables(){if(r.$k)for(const d in this.d)process.env[d]=this.d[d],delete this.d[d]}}e.$g3b=u,pe([E.$Tg],u.prototype,"cachedLanguagesPath",null),pe([E.$Tg],u.prototype,"backupHome",null),pe([E.$Tg],u.prototype,"mainIPCHandle",null),pe([E.$Tg],u.prototype,"mainLockfile",null),pe([E.$Tg],u.prototype,"disableUpdates",null),pe([E.$Tg],u.prototype,"crossOriginIsolated",null),pe([E.$Tg],u.prototype,"codeCachePath",null),pe([E.$Tg],u.prototype,"useCodeCache",null)}),define(te[285],ie([0,1,72,32,15,9,4,19,21,194,18,28,34,16,5,193,30,99]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D3b=void 0;let c=class yt{static{this.a="backupWorkspaces"}constructor(k,w,t,l){this.j=k,this.k=w,this.l=t,this.m=l,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$1f,this.i={isEqual:(s,n)=>(0,C.$Je)(s,n,!R.$k)}}async initialize(){const k=this.m.getItem(yt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(k.emptyWindows),this.d=await this.u((0,u.$w3b)(k)),this.e=await this.v((0,u.$x3b)(k)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==h.$ek.OFF}q(){return this.s()===h.$ek.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||h.$ek.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(k,w){this.d.some(l=>k.workspace.id===l.workspace.id)||(this.d.push(k),this.C());const t=(0,O.$ac)(this.c,k.workspace.id);return w?this.t(t,w).then(()=>t):t}async t(k,w){if(await f.Promises.exists(k)&&await this.z(k),await f.Promises.exists(w))try{await f.Promises.rename(w,k,!1)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(k){return this.e.some(w=>this.h.isEqual(k.folderUri,w.folderUri))||(this.e.push(k),this.C()),(0,O.$ac)(this.c,this.D(k))}registerEmptyWindowBackup(k){return this.g.some(w=>!!w.backupFolder&&this.i.isEqual(w.backupFolder,k.backupFolder))||(this.g.push(k),this.C()),(0,O.$ac)(this.c,k.backupFolder)}async u(k){if(!Array.isArray(k))return[];const w=new Set,t=[];for(const l of k){const s=l.workspace;if(!(0,o.$Eh)(s))return[];if(!w.has(s.id)){w.add(s.id);const n=(0,O.$ac)(this.c,s.id);await this.B(n)?s.configPath.scheme!==r.Schemas.file||await f.Promises.exists(s.configPath.fsPath)?t.push(l):await this.z(n):await this.x(n)}}return t}async v(k){if(!Array.isArray(k))return[];const w=[],t=new Set;for(const l of k){const s=l.folderUri,n=this.h.getComparisonKey(s);if(!t.has(n)){t.add(n);const i=(0,O.$ac)(this.c,this.D(l));await this.B(i)?s.scheme!==r.Schemas.file||await f.Promises.exists(s.fsPath)?w.push(l):await this.z(i):await this.x(i)}}return w}async w(k){if(!Array.isArray(k))return[];const w=[],t=new Set;for(const l of k){const s=l.backupFolder;if(typeof s!="string")return[];if(!t.has(s)){t.add(s);const n=(0,O.$ac)(this.c,s);await this.B(n)?w.push(l):await this.x(n)}}return w}async x(k){try{await f.Promises.rm(k,f.RimRafMode.MOVE)}catch(w){this.l.error(`Backup: Could not delete stale backup: ${w.toString()}`)}}y(){let k=(0,g.$C3b)();for(;this.g.some(w=>!!w.backupFolder&&this.i.isEqual(w.backupFolder,k.id));)k=(0,g.$C3b)();return{backupFolder:k.id}}async z(k){const w=this.y(),t=(0,O.$ac)(this.c,w.backupFolder);try{await f.Promises.rename(k,t,!1)}catch(l){return this.l.error(`Backup: Could not rename backup folder: ${l.toString()}`),!1}return this.g.push(w),!0}async getDirtyWorkspaces(){const k=[];for(const w of this.d)await this.A(w)&&k.push(w);for(const w of this.e)await this.A(w)&&k.push(w);return k}A(k){let w;return(0,u.$v3b)(k)?w=(0,O.$ac)(this.c,k.backupFolder):(0,y.$Fab)(k)?w=(0,O.$ac)(this.c,this.D(k)):w=(0,O.$ac)(this.c,k.workspace.id),this.B(w)}async B(k){try{const w=await f.Promises.readdir(k);for(const t of w)try{if((await f.Promises.readdir((0,O.$ac)(k,t))).length>0)return!0}catch{}}catch{}return!1}C(){const k={workspaces:this.d.map(({workspace:w,remoteAuthority:t})=>{const l={id:w.id,configURIPath:w.configPath.toString()};return t&&(l.remoteAuthority=t),l}),folders:this.e.map(({folderUri:w,remoteAuthority:t})=>{const l={folderUri:w.toString()};return t&&(l.remoteAuthority=t),l}),emptyWindows:this.g.map(({backupFolder:w,remoteAuthority:t})=>{const l={backupFolder:w};return t&&(l.remoteAuthority=t),l})};this.m.setItem(yt.a,k)}D(k){const w=k.folderUri;let t;return w.scheme===r.Schemas.file?t=R.$k?w.fsPath:w.fsPath.toLowerCase():t=w.toString().toLowerCase(),(0,E.createHash)("md5").update(t).digest("hex")}};e.$D3b=c,e.$D3b=c=pe([_(0,d.$f3b),_(1,$.$Vh),_(2,v.$Ri),_(3,p.$SM)],c)}),define(te[20],ie([0,1,14,38,8,3,2,4,36,10,6,5,34,28]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i3b=e.LifecycleMainPhase=e.ShutdownReason=e.$h3b=void 0,e.$h3b=(0,$.$ph)("lifecycleMainService");var v;(function(g){g[g.QUIT=1]="QUIT",g[g.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var y;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen",g[g.Eventually=4]="Eventually"})(y||(e.LifecycleMainPhase=y={}));let o=class dt extends R.$lb{static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(c,b,k){super(),this.w=c,this.y=b,this.z=k,this.c=this.B(new O.$8c),this.onBeforeShutdown=this.c.event,this.f=this.B(new O.$8c),this.onWillShutdown=this.f.event,this.g=this.B(new O.$8c),this.onWillLoadWindow=this.g.event,this.h=this.B(new O.$8c),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.v=void 0,this.C(),this.when(2).then(()=>this.D())}C(){this.j=!!this.y.getItem(dt.b),this.j&&this.y.removeItem(dt.b)}D(){const c=()=>{this.i||(this.N("Lifecycle#app.on(before-quit)"),this.i=!0,this.N("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$j&&this.n===0&&this.F(1))};E.app.addListener("before-quit",c);const b=()=>{this.N("Lifecycle#app.on(window-all-closed)"),(this.i||!S.$j)&&E.app.quit()};E.app.addListener("window-all-closed",b),E.app.once("will-quit",k=>{this.N("Lifecycle#app.on(will-quit) - begin"),k.preventDefault(),this.F(1).finally(()=>{this.N("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.I(!1),E.app.removeListener("before-quit",c),E.app.removeListener("window-all-closed",b),this.N("Lifecycle#app.on(will-quit) - calling app.quit()"),E.app.quit()})})}F(c){if(this.s)return this.s;const b=this.w;this.N("Lifecycle#onWillShutdown.fire()");const k=[];return this.f.fire({reason:c,join(w,t){b.trace(`Lifecycle#onWillShutdown - begin '${w}'`),k.push(t.finally(()=>{b.trace(`Lifecycle#onWillShutdown - end '${w}'`)}))}}),this.s=(async()=>{try{await r.Promises.settled(k)}catch(w){this.w.error(w)}try{await this.y.close()}catch(w){this.w.error(w)}})(),this.s}set phase(c){if(c<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===c)return;this.N(`lifecycle (main): phase changed (value: ${c})`),this.k=c;const b=this.u.get(this.k);b&&(b.open(),this.u.delete(this.k))}async when(c){if(c<=this.k)return;let b=this.u.get(c);b||(b=new r.$ug,this.u.set(c,b)),await b.wait()}registerWindow(c){const b=new R.$kb;this.n++,b.add(c.onWillLoad(w=>this.g.fire({window:c,workspace:w.workspace,reason:w.reason})));const k=(0,u.$ue)(c.win);k.on("close",w=>{const t=c.id;if(this.l.has(t)){this.l.delete(t);return}this.N(`Lifecycle#window.on('close') - window ID ${c.id}`),w.preventDefault(),this.unload(c,1).then(l=>{if(l){this.l.delete(t);return}this.l.add(t),this.N(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(c),c.close()})}),k.on("closed",()=>{this.N(`Lifecycle#window.on('closed') - window ID ${c.id}`),this.n--,b.dispose(),this.n===0&&(!S.$j||this.i)&&this.F(1)})}async reload(c,b){await this.unload(c,3)||c.reload(b)}unload(c,b){const k=this.t.get(c.id);if(k)return k;const w=this.G(c,b).finally(()=>{this.t.delete(c.id)});return this.t.set(c.id,w),w}async G(c,b){if(!c.isReady)return!1;this.N(`Lifecycle#unload() - window ID ${c.id}`);const k=this.i?2:b,w=await this.J(c,k);return w?(this.N(`Lifecycle#unload() - veto in renderer (window ID ${c.id})`),this.H(w)):(await this.L(c,k),!1)}H(c){return c?(this.I(!0),this.i=!1,!0):!1}I(c){this.r&&(this.r(c),this.r=void 0,this.p=void 0)}J(c,b){return new Promise(k=>{const w=this.m++,t=`vscode:ok${w}`,l=`vscode:cancel${w}`;C.$oS.once(t,()=>{k(!1)}),C.$oS.once(l,()=>{k(!0)}),c.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:l,reason:b})})}L(c,b){return new Promise(k=>{const t=`vscode:reply${this.m++}`;C.$oS.once(t,()=>k()),c.send("vscode:onWillUnload",{replyChannel:t,reason:b})})}quit(c){return this.M(c).then(b=>{if(!b&&c)try{if(S.$i){const k=(0,f.cwd)();k!==process.cwd()&&process.chdir(k)}}catch(k){this.w.error(k)}return b})}M(c){return this.N(`Lifecycle#quit() - begin (willRestart: ${c})`),this.p?(this.N("Lifecycle#quit() - returning pending quit promise"),this.p):(c&&this.y.setItem(dt.b,!0),this.p=new Promise(b=>{this.r=b,this.N("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}N(c){this.z.args["enable-smoke-test-driver"]?this.w.info(c):this.w.trace(c)}setRelaunchHandler(c){this.v=c}async relaunch(c){this.N("Lifecycle#relaunch()");const b=process.argv.slice(1);if(c?.addArgs&&b.push(...c.addArgs),c?.removeArgs)for(const t of c.removeArgs){const l=b.indexOf(t);l>=0&&b.splice(l,1)}const k=()=>{this.v?.handleRelaunch(c)||(this.N("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:b}))};E.app.once("quit",k),await this.quit(!0)&&E.app.removeListener("quit",k)}async kill(c){this.N("Lifecycle#kill()"),await this.F(2),await Promise.race([(0,r.$wg)(1e3),(async()=>{for(const b of E.BrowserWindow.getAllWindows())if(b&&!b.isDestroyed()){let k;b.webContents&&!b.webContents.isDestroyed()?k=new Promise(w=>b.once("closed",w)):k=Promise.resolve(),b.destroy(),await k}})()]),E.app.exit(c)}};e.$i3b=o,e.$i3b=o=pe([_(0,d.$Ri),_(1,p.$SM),_(2,h.$f3b)],o)}),define(te[286],ie([0,1,4,3,2,6,20]),function(V,e,E,C,r,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$3b=e.$03b=void 0,e.$03b=(0,O.$ph)("keyboardLayoutMainService");let S=class extends r.$lb{constructor($){super(),this.a=this.B(new C.$8c),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,$.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const $=await new Promise((d,p)=>{V(["native-keymap"],d,p)});this.c=f($),E.$s||$.onDidChangeKeyboardLayout(()=>{this.c=f($),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$$3b=S,e.$$3b=S=pe([_(0,R.$h3b)],S);function f(u){const $=u.getKeyMap(),d=u.getCurrentKeyboardLayout();return{keyboardMapping:$,keyboardLayoutInfo:d}}}),define(te[287],ie([0,1,245,8,17,13,10,18,33,95,5,51,244,284]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=void 0;let v=class extends d.$zo{constructor(c,b,k,w){super(w),this.j=c,this.k=b,this.l=k,this.m(),this.B(c.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const c=this.j.getValue("http");this.f=c?.proxy,this.g=!!c?.proxyStrictSSL,this.h=c?.proxyAuthorization}async request(c,b){const{f:k,g:w}=this;let t;try{t=await(0,u.$yl)(this.j,this.l,this.k.args,process.env)}catch(n){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,O.$9)(n)))}const l={...process.env,...t},s=c.agent?c.agent:await(0,p.$Cq)(c.url||"",l,{proxyUrl:k,strictSSL:w});return c.agent=s,c.strictSSL=w,this.h&&(c.headers={...c.headers||{},"Proxy-Authorization":this.h}),this.c(c.isChromiumNetwork?"electron":"node",c,()=>o(c,b))}async resolveProxy(c){}};e.$Dq=v,e.$Dq=v=pe([_(0,S.$Vh),_(1,f.$xh),_(2,$.$Ri),_(3,$.$Si)],v);async function y(g){return((0,E.parse)(g.url).protocol==="https:"?await new Promise((k,w)=>{V(["https"],k,w)}):await new Promise((k,w)=>{V(["http"],k,w)})).request}async function o(g,c){return C.Promises.withAsyncBody(async(b,k)=>{const w=(0,E.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await y(g),l={hostname:w.hostname,port:w.port?parseInt(w.port):w.protocol==="https:"?443:80,protocol:w.protocol,path:w.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,R.$pe)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(l.auth=g.user+":"+g.password);const s=t(l,n=>{const i=(0,R.$ne)(g.followRedirects)?g.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)o({...g,url:n.headers.location,followRedirects:i-1},c).then(b,k);else{let a=n;!g.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(a=n.pipe((0,h.createGunzip)())),b({res:n,stream:(0,r.$Yb)(a)})}});s.on("error",k),g.timeout&&s.setTimeout(g.timeout),g.isChromiumNetwork&&s.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&s.write(g.data),s.end(),c.onCancellationRequested(()=>{s.abort(),k(new O.$3)})})}e.$Eq=o}),define(te[288],ie([0,1,14,287]),function(V,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$04b=void 0;function r(R){return E.net.request}class O extends C.$Dq{request(S,f){return super.request({...S||{},getRawRequest:r,isChromiumNetwork:!0},f)}}e.$04b=O}),define(te[83],ie([0,1,7,49,3,2,33,16,6,20,5,97,281,41,53,40]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s3b=e.$r3b=e.$q3b=e.$p3b=void 0,e.$p3b=(0,f.$ph)("storageMainService");let o=class extends O.$lb{constructor(b,k,w,t,l,s){super(),this.c=b,this.f=k,this.g=w,this.h=t,this.i=l,this.j=s,this.a=void 0,this.b=this.B(new r.$8c),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(b=>{b.window.profile&&this.profileStorage(b.window.profile).init(),b.workspace&&this.workspaceStorage(b.workspace).init()})),this.B(this.h.onWillShutdown(b=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=b.reason,b.join("applicationStorage",this.applicationStorage.close());for(const[,k]of this.n)b.join("profileStorage",k.close());for(const[,k]of this.r)b.join("workspaceStorage",k.close())})),this.B(this.g.onWillCreateProfile(b=>{b.join((async()=>{await this.i.exists(b.profile.globalStorageHome)||await this.i.createFolder(b.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(b=>{const k=this.n.get(b.profile.id);k&&b.join(k.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const b=new p.$k3b(this.k(),this.g,this.c,this.i);return(0,C.$cb)(b.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),b}profileStorage(b){if((0,d.$No)(b))return this.applicationStorage;let k=this.n.get(b.id);if(!k){this.c.trace(`StorageMainService: creating profile storage (${b.name})`),k=this.p(b),this.n.set(b.id,k);const w=this.B(k.onDidChangeStorage(t=>this.b.fire({...t,storage:k,profile:b})));(0,C.$cb)(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${b.name})`),this.n.delete(b.id),w.dispose()})}return k}p(b){return this.a===2?new p.$m3b(this.c,this.i):new p.$j3b(b,this.k(),this.c,this.i)}workspaceStorage(b){let k=this.r.get(b.id);return k||(this.c.trace(`StorageMainService: creating workspace storage (${b.id})`),k=this.s(b),this.r.set(b.id,k),(0,C.$cb)(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${b.id})`),this.r.delete(b.id)})),k}s(b){return this.a===2?new p.$m3b(this.c,this.i):new p.$l3b(b,this.k(),this.c,this.f,this.i)}isUsed(b){const k=E.URI.file(b);for(const w of[this.applicationStorage,...this.n.values(),...this.r.values()])if(w.path&&this.j.extUri.isEqualOrParent(E.URI.file(w.path),k))return!0;return!1}};e.$q3b=o,e.$q3b=o=pe([_(0,$.$Ri),_(1,R.$wh),_(2,v.$n3b),_(3,u.$h3b),_(4,S.$Sj),_(5,y.$pk)],o),e.$r3b=(0,f.$ph)("applicationStorageMainService");let g=class extends d.$Mo{constructor(b,k){super(),this.p=b,this.s=k,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(b){if(b===-1)return this.s.applicationStorage.storage}M(b){if(b===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$s3b=g,e.$s3b=g=pe([_(0,h.$rk),_(1,e.$p3b)],g)}),define(te[289],ie([0,1,14,22,3,57,2,10,31,76,115,5,23,83,29]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u3b=void 0;var y;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let o=class extends R.$lb{constructor(c,b,k,w,t,l){super(),this.h=c,this.i=b,this.j=k,this.k=w,this.l=t,this.m=l,this.a=`${this.m.urlProtocol}.proxy-credentials`,this.b="proxy-credentials://",this.c=void 0,this.f=y.Initial,this.g=void 0,this.n()}n(){const c=r.Event.fromNodeEventEmitter(E.app,"login",(b,k,w,t,l)=>({event:b,webContents:k,req:w,authInfo:t,callback:l}));this.B(c(this.p,this))}async p({event:c,authInfo:b,req:k,callback:w}){if(!b.isProxy)return;if(!this.c&&this.f===y.LoginDialogShown&&k.firstAuthAttempt){this.h.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}c.preventDefault();let t;if(this.c)this.h.trace("auth#onLogin (proxy) - pending proxy handling found"),t=await this.c;else{this.h.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.c=this.r(b);try{t=await this.c}finally{this.c=void 0}}w(t?.username,t?.password)}async r(c){this.h.trace("auth#resolveProxyCredentials (proxy) - enter");try{const b=await this.t(c);if(b)return this.h.trace("auth#resolveProxyCredentials (proxy) - got credentials"),b;this.h.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.h.trace("auth#resolveProxyCredentials (proxy) - exit")}}async s(c){try{let b=this.l.get(this.b+c,-1),k;if(b||(b=(0,S.$Be)(await this.j.getPassword(this.a,c)),b&&(k=await this.k.decrypt(b),b=await this.k.encrypt(k),this.l.store(this.b+c,b,-1,1),await this.j.deletePassword(this.a,c))),b){const w=JSON.parse(k??await this.k.decrypt(b));return{storedUsername:w.username,storedPassword:w.password}}}catch(b){this.h.error(b)}return{storedUsername:void 0,storedPassword:void 0}}async t(c){this.h.trace("auth#doResolveProxyCredentials - enter",c);const b=String((0,O.$di)({scheme:c.scheme,host:c.host,port:c.port})),{storedUsername:k,storedPassword:w}=await this.s(b);if(this.f!==y.StoredCredentialsUsed&&typeof k=="string"&&typeof w=="string")return this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.f=y.StoredCredentialsUsed,{username:k,password:w};const t=this.i.getFocusedWindow()||this.i.getLastActiveWindow();if(!t){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.h.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${t.id} to handle proxy login`);const l={authInfo:c,username:this.g?.username??k,password:this.g?.password??w,replyChannel:`vscode:proxyAuthResponse:${(0,f.$6e)()}`};t.sendWhenReady("vscode:openProxyAuthenticationDialog",C.CancellationToken.None,l),this.f=y.LoginDialogShown;const s=await new Promise(n=>{const i=async(a,m,P)=>{if(m===l.replyChannel)if(this.h.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${t.id}`),t.win?.webContents.off("ipc-message",i),P){const I={username:P.username,password:P.password};try{if(P.remember){const D=await this.k.encrypt(JSON.stringify(I));this.l.store(this.b+b,D,-1,1)}else this.l.remove(this.b+b,-1)}catch(D){this.h.error(D)}n({username:I.username,password:I.password})}else n(void 0)};t.win?.webContents.on("ipc-message",i)});return this.g=s,s}};e.$u3b=o,e.$u3b=o=pe([_(0,d.$Ri),_(1,v.$t3b),_(2,u.$nn),_(3,$.$kqb),_(4,h.$r3b),_(5,p.$0i)],o)}),define(te[100],ie([0,1,8,22,3,18,28,20,5,23,51,48]),function(V,e,E,C,r,O,R,S,f,u,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u4b=e.$t4b=void 0;function p(v,y,o){return`${o.updateUrl}/api/update/${v}/${y}/${o.commit}`}e.$t4b=p;let h=class{get state(){return this.b}d(y){this.j.info("update#setState",y.type),this.b=y,this.c.fire(y)}constructor(y,o,g,c,b,k){this.f=y,this.g=o,this.h=g,this.i=c,this.j=b,this.k=k,this.b=d.$Fib.Uninitialized,this.c=new r.$8c,this.onStateChange=this.c.event,y.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(d.$Fib.Disabled(0));return}if(this.h.disableUpdates){this.d(d.$Fib.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(d.$Fib.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const y=this.g.getValue("update.mode"),o=this.m(y);if(!o){this.d(d.$Fib.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(o),!this.a){this.d(d.$Fib.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(d.$Fib.Idle(this.q())),y==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}y==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(y){return y==="none"?void 0:this.k.quality}n(y=60*60*1e3){return(0,E.$wg)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(y){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(y)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(y){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(y=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},C.CancellationToken.None)).res.statusCode===204}catch(o){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(o);return}}async _applySpecificUpdate(y){}q(){return 1}r(){}};e.$u4b=h,e.$u4b=h=pe([_(0,S.$h3b),_(1,O.$Vh),_(2,R.$f3b),_(3,$.$yo),_(4,f.$Ri),_(5,u.$0i)],h)}),define(te[290],ie([0,1,14,55,3,2,18,28,20,5,23,51,26,48,100]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v4b=void 0;let y=class extends v.$u4b{get v(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"error",(g,c)=>c)}get w(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get x(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(g,c,b)=>({url:c,version:b,productVersion:b}))}get y(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(g,c,b,k)=>({releaseNotes:c,version:b,productVersion:b,date:k}))}constructor(g,c,b,k,w,t,l){super(g,c,k,w,t,l),this.z=b,this.u=new O.$kb,g.setRelaunchHandler(this)}handleRelaunch(g){return g?.addArgs||g?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(g){this.j.error("UpdateService error:",g);const c=this.state.type==="checking for updates"&&this.state.explicit?g:void 0;this.d(h.$Fib.Idle(1,c))}s(g){let c;this.k.darwinUniversalAssetId?c=this.k.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const b=(0,v.$t4b)(c,g,this.k);try{E.autoUpdater.setFeedURL({url:b})}catch(k){this.j.error("Failed to set update feed URL",k);return}return b}t(g){this.d(h.$Fib.CheckingForUpdates(g)),E.autoUpdater.checkForUpdates()}E(g){this.state.type==="checking for updates"&&this.d(h.$Fib.Downloading(g))}F(g){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:g.version}),this.d(h.$Fib.Ready(g)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(h.$Fib.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$v4b=y,pe([C.$Tg],y.prototype,"v",null),pe([C.$Tg],y.prototype,"w",null),pe([C.$Tg],y.prototype,"x",null),pe([C.$Tg],y.prototype,"y",null),e.$v4b=y=pe([_(0,f.$h3b),_(1,R.$Vh),_(2,p.$Vk),_(3,S.$f3b),_(4,d.$yo),_(5,u.$Ri),_(6,$.$0i)],y)}),define(te[291],ie([0,1,47,45,8,3,9,28,20,5,26,48]),function(V,e,E,C,r,O,R,S,f,u,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x4b=void 0;let p=class{get state(){return this.a}d(y){this.g.info("update#setState",y.type),this.a=y,this.b.fire(y)}constructor(y,o,g){if(this.f=y,this.g=g,this.a=d.$Fib.Uninitialized,this.b=new O.$8c,this.onStateChange=this.b.event,o.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(d.$Fib.Idle(this.k())),this.h(30*1e3).then(void 0,c=>this.g.error(c))}h(y=60*60*1e3){return(0,r.$wg)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(y){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(y)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(y){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(y=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(y){}};p=pe([_(0,f.$h3b),_(1,S.$f3b),_(2,u.$Ri)],p);let h=class extends p{constructor(y,o,g,c,b,k){super(g,c,b),this.o=y,this.p=o,this.q=k;const w=(0,C.watch)(R.$dc(this.o)),t=O.Event.fromNodeEventEmitter(w,"change",(i,a)=>a),l=O.Event.filter(t,i=>i==="current"),n=O.Event.debounce(l,(i,a)=>a,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{n.dispose(),w.close()})}m(){this.d(d.$Fib.CheckingForUpdates(!1)),this.u().then(y=>{y?this.d(d.$Fib.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(d.$Fib.Idle(2)))},y=>{this.g.error(y),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(d.$Fib.Idle(2,y.message||y))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+R.$ec(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const y=await new Promise((g,c)=>(0,C.realpath)(`${R.$dc(this.o)}/current`,(b,k)=>b?c(b):g(k))),o=R.$ec(y);return this.p!==o}isLatestVersion(){return this.u().then(void 0,y=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$x4b=h,e.$x4b=h=pe([_(2,f.$h3b),_(3,S.$f3b),_(4,u.$Ri),_(5,$.$Vk)],h)}),define(te[292],ie([0,1,2,20,53,30,8,29]),function(V,e,E,C,r,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R4b=void 0;let f=class extends E.$lb{constructor($,d,p){super(),this.a=d,this.b=p,this.B($.onWillLoadWindow(h=>{h.reason===2&&this.c(h.window)})),this.B($.onBeforeCloseWindow(h=>this.c(h))),this.B(new R.$Gg(()=>this.g(),30*1e3)).schedule()}async c($){const d=this.f($),p=this.a.getProfileForWorkspace(d);p?.isTransient&&(this.a.unsetWorkspace(d,p.isTransient),p.isTransient&&await this.a.cleanUpTransientProfiles())}f($){return $.openedWorkspace??(0,O.$Dh)($.backupPath,$.isExtensionDevelopmentHost)}g(){const $=this.a.getAssociatedEmptyWindows();if($.length===0)return;const d=this.b.getWindows().map(p=>this.f(p));for(const p of $)d.some(h=>h.id===p.id)||this.a.unsetWorkspace(p,!1)}};e.$R4b=f,e.$R4b=f=pe([_(0,C.$h3b),_(1,r.$n3b),_(2,S.$t3b)],f)}),define(te[62],ie([0,1,14,2,3,5,311,8,15,29,70,26,20,73,37,4,132]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N3b=e.$M3b=void 0;function g(k){return typeof k.responseWindowId=="number"}let c=class ht extends C.$lb{static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(ht.b.values())}constructor(w,t,l){super(),this.n=w,this.p=t,this.r=l,this.c=String(++ht.a),this.f=this.B(new r.$8c),this.onStdout=this.f.event,this.g=this.B(new r.$8c),this.onStderr=this.g.event,this.h=this.B(new r.$8c),this.onMessage=this.h.event,this.i=this.B(new r.$8c),this.onExit=this.i.event,this.j=this.B(new r.$8c),this.onCrash=this.j.event,this.k=void 0,this.l=void 0,this.m=void 0}s(w,t){let l;switch(this.m?.correlationId?l=`[UtilityProcess id: ${this.m?.correlationId}, type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${w}`:l=`[UtilityProcess type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${w}`,t){case $.default.Error:this.n.error(l);break;case $.default.Warning:this.n.warn(l);break;case $.default.Info:this.n.trace(l);break}}t(){return this.k?(this.s("Cannot start utility process because it is already running...",$.default.Error),!1):!0}start(w){const t=this.u(w);return t&&w.payload&&this.postMessage(w.payload),t}u(w){if(!this.t())return!1;this.m=w;const t=`${this.m.type}-${this.c}`,l=f.$4e.asFileUri("bootstrap-fork.js").fsPath,s=this.m.args??[],n=this.m.execArgv??[],i=this.m.allowLoadingUnsignedLibraries,a=this.m.forceAllocationsToV8Sandbox,m="pipe",P=this.v(w);return this.s("creating new...",$.default.Info),this.k=E.utilityProcess.fork(l,s,{serviceName:t,env:P,execArgv:n,allowLoadingUnsignedLibraries:i,forceAllocationsToV8Sandbox:a,stdio:m}),this.w(this.k,this.m,t),!0}v(w){const t=w.env?{...w.env}:{...(0,v.$Hm)(process.env)};t.VSCODE_AMD_ENTRYPOINT=w.entryPoint,typeof w.parentLifecycleBound=="number"&&(t.VSCODE_PARENT_PID=String(w.parentLifecycleBound)),t.VSCODE_CRASH_REPORTER_PROCESS_TYPE=w.type,y.$i&&((0,o.isUNCAccessRestrictionsDisabled)()?t.NODE_DISABLE_UNC_ACCESS_CHECKS="1":t.NODE_UNC_HOST_ALLOWLIST=(0,o.getUNCHostAllowlist)().join("\\")),(0,h.$gl)(t);for(const l of Object.keys(t))t[l]=String(t[l]);return t}w(w,t,l){if(w.stdout){const s=new R.StringDecoder("utf-8");this.B(r.Event.fromNodeEventEmitter(w.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:s.write(n))))}if(w.stderr){const s=new R.StringDecoder("utf-8");this.B(r.Event.fromNodeEventEmitter(w.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:s.write(n))))}this.B(r.Event.fromNodeEventEmitter(w,"message")(s=>this.h.fire(s))),this.B(r.Event.fromNodeEventEmitter(w,"spawn")(()=>{this.l=w.pid,typeof w.pid=="number"&&ht.b.set(w.pid,{pid:w.pid,name:g(t)?`${t.type} [${t.responseWindowId}]`:t.type}),this.s("successfully created",$.default.Info)})),this.B(r.Event.fromNodeEventEmitter(w,"exit")(s=>{this.s(`received exit event with code ${s}`,$.default.Info),this.i.fire({pid:this.l,code:s,signal:"unknown"}),this.y()})),this.B(r.Event.fromNodeEventEmitter(E.app,"child-process-gone",(s,n)=>({event:s,details:n}))(({details:s})=>{s.type==="Utility"&&s.name===l&&(this.s(`crashed with code ${s.exitCode} and reason '${s.reason}'`,$.default.Error),this.p.publicLog2("utilityprocesscrash",{type:t.type,reason:s.reason,code:s.exitCode}),this.j.fire({pid:this.l,code:s.exitCode,reason:s.reason}),this.y())}))}once(w,t){const l=this.B(this.h.event(s=>{s===w&&(l.dispose(),t())}))}postMessage(w,t){this.k&&this.k.postMessage(w,t)}connect(w){const{port1:t,port2:l}=new E.MessageChannelMain;return this.postMessage(w,[l]),t}enableInspectPort(){if(!this.k||typeof this.l!="number")return!1;this.s("enabling inspect port",$.default.Info);const w=process;return typeof w._debugProcess=="function"?(w._debugProcess(this.l),!0):!1}kill(){if(!this.k)return;this.s("attempting to kill the process...",$.default.Info),this.k.kill()?(this.s("successfully killed the process",$.default.Info),this.y()):this.s("unable to kill the process",$.default.Warning)}y(){typeof this.l=="number"&&ht.b.delete(this.l),this.k=void 0}async waitForExit(w){this.k&&(this.s("waiting to exit...",$.default.Info),await Promise.race([r.Event.toPromise(this.onExit),(0,S.$wg)(w)]),this.k&&(this.s(`did not exit within ${w}ms, will kill it now...`,$.default.Info),this.kill()))}};e.$M3b=c,e.$M3b=c=pe([_(0,O.$Ri),_(1,d.$Vk),_(2,p.$h3b)],c);let b=class extends c{constructor(w,t,l,s){super(w,l,s),this.z=t}start(w){const t=this.z.getWindowById(w.responseWindowId);if(!t?.win||t.win.isDestroyed()||t.win.webContents.isDestroyed())return this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",$.default.Error),!0;if(!super.u(w))return!1;this.C(t.win,w);const s=this.connect(w.payload);return t.win.webContents.postMessage(w.responseChannel,w.responseNonce,[s]),!0}C(w,t){t.windowLifecycleBound&&(this.B(r.Event.filter(this.r.onWillLoadWindow,l=>l.window.win===w)(()=>this.kill())),this.B(r.Event.fromNodeEventEmitter(w,"closed")(()=>this.kill())))}};e.$N3b=b,e.$N3b=b=pe([_(0,O.$Ri),_(1,u.$t3b),_(2,d.$Vk),_(3,p.$h3b)],b)}),define(te[293],ie([0,1,13,5,20,8,62,29,26]),function(V,e,E,C,r,O,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V3b=void 0;let u=class Rt{static{this.a=0}constructor(d,p,h,v){this.d=d,this.f=p,this.g=h,this.h=v,this.b=new Map,this.c=!1,this.f.onWillShutdown(y=>{this.c=!0,y.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(d){const p=this.b.get(d);if(!p)throw new Error("Unknown extension host!");return p}onDynamicStdout(d){return this.i(d).onStdout}onDynamicStderr(d){return this.i(d).onStderr}onDynamicMessage(d){return this.i(d).onMessage}onDynamicExit(d){return this.i(d).onExit}async createExtensionHost(){if(this.c)throw(0,E.$4)();const d=String(++Rt.a),p=new R.$N3b(this.d,this.g,this.h,this.f);return this.b.set(d,p),p.onExit(({pid:h,code:v,signal:y})=>{this.d.info(`Extension host with pid ${h} exited with code: ${v}, signal: ${y}.`),setTimeout(()=>{p.dispose(),this.b.delete(d)})}),{id:d}}async start(d,p){if(this.c)throw(0,E.$4)();this.i(d).start({...p,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:p.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:d})}async enableInspectPort(d){if(this.c)throw(0,E.$4)();const p=this.b.get(d);return p?p.enableInspectPort():!1}async kill(d){if(this.c)throw(0,E.$4)();const p=this.b.get(d);p&&p.kill()}async _killAllNow(){for(const[,d]of this.b)d.kill()}async _waitForAllExit(d){const p=[];for(const[,h]of this.b)p.push(h.waitForExit(d));return O.Promises.settled(p).then(()=>{})}};e.$V3b=u,e.$V3b=u=pe([_(0,C.$Ri),_(1,r.$h3b),_(2,S.$t3b),_(3,f.$Vk)],u)}),define(te[294],ie([0,1,38,8,2,28,20,5,41,39,66,62,52,90,10]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n4b=void 0;let y=class extends r.$lb{constructor(g,c,b,k,w,t,l){super(),this.c=g,this.f=c,this.g=b,this.h=k,this.i=w,this.j=t,this.k=l,this.a=new C.$ug,this.b=void 0,this.r=void 0,this.s=void 0,this.l()}l(){E.$oS.on("vscode:createSharedProcessMessageChannel",(g,c)=>this.m(g,c)),this.B(this.h.onWillShutdown(()=>this.n()))}async m(g,c){this.i.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const b=await this.connect();if(g.sender.isDestroyed())return b.close();g.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[b])}n(){this.i.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage("vscode:electron-main->shared-process=exit"),this.b=void 0}whenReady(){return this.r||(this.r=(async()=>{await this.t;const g=new C.$Pg;this.b?this.b.once("vscode:shared-process->electron-main=init-done",()=>g.complete()):E.$oS.once("vscode:shared-process->electron-main=init-done",()=>g.complete()),await g.p,this.i.trace("[SharedProcess] Overall ready")})()),this.r}get t(){return this.s||(this.s=(async()=>{await this.a.wait(),this.u();const g=new C.$Pg;this.b?this.b.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()):E.$oS.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()),await g.p,this.i.trace("[SharedProcess] IPC ready")})()),this.s}u(){this.b=this.B(new d.$M3b(this.i,p.$4n,this.h));const g=(0,h.$Zl)(this.f.args,this.f.isBuilt);let c;g.port&&(c=["--nolazy"],g.break?c.push(`--inspect-brk=${g.port}`):c.push(`--inspect=${g.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.v(),execArgv:c})}v(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.j.getLogLevel(),loggers:this.j.getRegisteredLoggers(),policiesData:this.k.serialize()}}async connect(){return await this.t,(0,v.$ue)(this.b).connect()}};e.$n4b=y,e.$n4b=y=pe([_(1,O.$f3b),_(2,f.$rk),_(3,R.$h3b),_(4,S.$Ri),_(5,$.$l4b),_(6,u.$Vm)],y)}),define(te[295],ie([0,1,28,90,20,5,52,62,110,38,2,3,37,18]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z4b=void 0;let v=class extends $.$lb{constructor(o,g,c,b,k){super(),this.f=o,this.g=g,this.h=c,this.i=b,this.j=k,this.a=void 0,this.b=new d.$8c,this.onRequestConnection=this.b.event,this.c=new d.$8c,this.onWillShutdown=this.c.event,this.i.onWillShutdown(()=>this.c.fire()),u.$oS.on("vscode:createPtyHostMessageChannel",(w,t)=>this.l(w,t)),this.B((0,$.$jb)(()=>{u.$oS.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$M3b(this.j,R.$4n,this.i);const o=(0,C.$Yl)(this.h.args,this.h.isBuilt),g=o.port?["--nolazy",`--inspect${o.break?"-brk":""}=${o.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:g,args:["--logsPath",this.h.logsHome.fsPath],env:this.k()});const c=this.a.connect(),b=new f.$wS(c,"ptyHost"),k=new $.$kb;return k.add(b),k.add((0,$.$jb)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:b,store:k,onDidProcessExit:this.a.onExit}}k(){this.h.unsetSnapExportedVariables();const o={...(0,p.$Hm)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},g=this.g.getValue("terminal.integrated.developer.ptyHost.latency");g&&typeof g=="number"&&(o.VSCODE_LATENCY=String(g));const c=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return c&&typeof c=="number"&&(o.VSCODE_STARTUP_DELAY=String(c)),this.h.restoreSnapExportedVariables(),o}l(o,g){this.b.fire();const c=this.a.connect();if(o.sender.isDestroyed()){c.close();return}o.sender.postMessage("vscode:createPtyHostMessageChannelResult",g,[c])}};e.$Z4b=v,e.$Z4b=v=pe([_(1,h.$Vh),_(2,E.$f3b),_(3,r.$h3b),_(4,O.$Ri)],v)}),define(te[296],ie([0,1,2,6,5,29,62,26,57,3,8,20]),function(V,e,E,C,r,O,R,S,f,u,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y4b=e.$X4b=void 0,e.$X4b=(0,C.$ph)("utilityProcessWorker");let p=class extends E.$lb{constructor(y,o,g,c){super(),this.b=y,this.c=o,this.f=g,this.g=c,this.a=new Map}async createWorker(y){const o=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${o})`);const g=this.h(y);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${o})`),this.disposeWorker(y));const c=new h(this.b,this.c,this.f,this.g,y);if(!c.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,c);const b=new $.$Pg;return u.Event.once(c.onDidTerminate)(k=>{k.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${k.code}, signal: ${k.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${k.code}, signal: ${k.signal}`),this.a.delete(g),b.complete({reason:k})}),b.p}h(y){return(0,f.$di)({moduleId:y.process.moduleId,windowId:y.reply.windowId})}async disposeWorker(y){const o=this.h(y),g=this.a.get(o);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),g.kill(),this.a.delete(o))}};e.$Y4b=p,e.$Y4b=p=pe([_(0,r.$Ri),_(1,O.$t3b),_(2,S.$Vk),_(3,d.$h3b)],p);let h=class extends E.$lb{constructor(y,o,g,c,b){super(),this.c=y,this.f=o,this.g=g,this.h=c,this.i=b,this.a=this.B(new u.$8c),this.onDidTerminate=this.a.event,this.b=new R.$N3b(this.c,this.f,this.g,this.h),this.j()}j(){this.B(this.b.onExit(y=>this.a.fire({code:y.code,signal:y.signal}))),this.B(this.b.onCrash(y=>this.a.fire({code:y.code,signal:"ECRASH"})))}spawn(){const o=this.f.getWindowById(this.i.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.i.process.type,entryPoint:this.i.process.moduleId,parentLifecycleBound:o,windowLifecycleBound:!0,correlationId:`${this.i.reply.windowId}`,responseWindowId:this.i.reply.windowId,responseChannel:this.i.reply.channel,responseNonce:this.i.reply.nonce})}kill(){this.b.kill()}};h=pe([_(0,r.$Ri),_(1,O.$t3b),_(2,S.$Vk),_(3,d.$h3b)],h)}),define(te[297],ie([0,1,14,2,4,19,7,18,20,5,34,29,128,30]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J4b=e.$I4b=e.$H4b=void 0;let v=class vt extends C.$lb{static{this.a="windowsState"}get state(){return this.b}constructor(k,w,t,l,s){super(),this.g=k,this.h=w,this.i=t,this.j=l,this.k=s,this.b=y(this.h.getItem(vt.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(k=>this.p(k)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(k=>{k.newCount-k.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(k=>this.p(k))}m(){this.f=!0,this.n()}n(){const k=new Set,w={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!w.lastActiveWindow){let s=this.g.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),s&&(w.lastActiveWindow=this.r(s),w.lastActiveWindow.uiState.mode===3&&k.add(w.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);t&&(w.lastPluginDevelopmentHostWindow=this.r(t),w.lastPluginDevelopmentHostWindow.uiState.mode===3&&(k.has(w.lastPluginDevelopmentHostWindow.uiState.display)?r.$j&&!t.win?.isSimpleFullScreen()&&(w.lastPluginDevelopmentHostWindow.uiState.mode=1):k.add(w.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(w.openedWindows=this.g.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>{const n=this.r(s);return n.uiState.mode===3&&(k.has(n.uiState.display)?r.$j&&n.windowId!==w.lastActiveWindow?.windowId&&!s.win?.isSimpleFullScreen()&&(n.uiState.mode=1):k.add(n.uiState.display)),n}));const l=g(w);this.h.setItem(vt.a,l),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",l)}p(k){if(this.i.quitRequested)return;const w=this.r(k);k.isExtensionDevelopmentHost&&!k.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=w:!k.isExtensionDevelopmentHost&&k.openedWorkspace&&this.b.openedWindows.forEach(t=>{const l=(0,h.$Eh)(k.openedWorkspace)&&t.workspace?.id===k.openedWorkspace.id,s=(0,h.$zh)(k.openedWorkspace)&&t.folderUri&&O.$1f.isEqual(t.folderUri,k.openedWorkspace.uri);(l||s)&&(t.uiState=w.uiState)}),this.g.getWindowCount()===1&&(this.c=w)}r(k){return{windowId:k.id,workspace:(0,h.$Eh)(k.openedWorkspace)?k.openedWorkspace:void 0,folderUri:(0,h.$zh)(k.openedWorkspace)?k.openedWorkspace.uri:void 0,backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.serializeWindowState()}}getNewWindowState(k){const w=this.s(k),t=this.k.getValue("window");if(w.mode===3){let l;w.hasDefaultState?l=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):l=!!(this.i.wasRestarted||t?.restoreFullscreen),l||(w.mode=1)}return w}s(k){const w=this.g.getLastActiveWindow();if(!k.extensionTestsPath){if(k.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=k.workspace;if((0,h.$Eh)(a)){const P=this.state.openedWindows.filter(I=>I.workspace&&I.workspace.id===a.id).map(I=>I.uiState);if(P.length)return P[0]}if((0,h.$zh)(a)){const P=this.state.openedWindows.filter(I=>I.folderUri&&O.$1f.isEqual(I.folderUri,a.uri)).map(I=>I.uiState);if(P.length)return P[0]}else if(k.backupPath){const P=this.state.openedWindows.filter(I=>I.backupPath===k.backupPath).map(I=>I.uiState);if(P.length)return P[0]}const m=this.c||this.state.lastActiveWindow;if(!w&&m)return m.uiState}let t;const l=E.screen.getAllDisplays();if(l.length===1)t=l[0];else{if(r.$j){const a=E.screen.getCursorScreenPoint();t=E.screen.getDisplayNearestPoint(a)}!t&&w&&(t=E.screen.getDisplayMatching(w.getBounds())),t||(t=E.screen.getPrimaryDisplay()||l[0])}let s=(0,p.$e3b)();s.x=Math.round(t.bounds.x+t.bounds.width/2-s.width/2),s.y=Math.round(t.bounds.y+t.bounds.height/2-s.height/2);const n=this.k.getValue("window");let i=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")s.mode=0,i=!1;else if(n.newWindowDimensions==="fullscreen")s.mode=3,i=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&w){const a=w.serializeWindowState();a.mode===3?s.mode=3:s=a,i=s.mode!==3&&n.newWindowDimensions==="offset"}}return i&&(s=this.t(s)),s.hasDefaultState=!0,s}t(k){if(this.g.getWindows().length===0)return k;k.x=typeof k.x=="number"?k.x:0,k.y=typeof k.y=="number"?k.y:0;const w=this.g.getWindows().map(t=>t.getBounds());for(;w.some(t=>t.x===k.x||t.y===k.y);)k.x+=30,k.y+=30;return k}};e.$H4b=v,e.$H4b=v=pe([_(0,d.$t3b),_(1,$.$SM),_(2,f.$h3b),_(3,u.$Ri),_(4,S.$Vh)],v);function y(b){const k={openedWindows:[]},w=b||{openedWindows:[]};return w.lastActiveWindow&&(k.lastActiveWindow=o(w.lastActiveWindow)),w.lastPluginDevelopmentHostWindow&&(k.lastPluginDevelopmentHostWindow=o(w.lastPluginDevelopmentHostWindow)),Array.isArray(w.openedWindows)&&(k.openedWindows=w.openedWindows.map(t=>o(t))),k}e.$I4b=y;function o(b){const k={uiState:b.uiState};return b.backupPath&&(k.backupPath=b.backupPath),b.remoteAuthority&&(k.remoteAuthority=b.remoteAuthority),b.folder&&(k.folderUri=R.URI.parse(b.folder)),b.workspaceIdentifier&&(k.workspace={id:b.workspaceIdentifier.id,configPath:R.URI.parse(b.workspaceIdentifier.configURIPath)}),k}function g(b){return{lastActiveWindow:b.lastActiveWindow&&c(b.lastActiveWindow),lastPluginDevelopmentHostWindow:b.lastPluginDevelopmentHostWindow&&c(b.lastPluginDevelopmentHostWindow),openedWindows:b.openedWindows.map(k=>c(k))}}e.$J4b=g;function c(b){return{workspaceIdentifier:b.workspace&&{id:b.workspace.id,configURIPath:b.workspace.configPath.toString()},folder:b.folderUri&&b.folderUri.toString(),backupPath:b.backupPath,remoteAuthority:b.remoteAuthority,uiState:b.uiState}}}),define(te[54],ie([0,1,14,3,44,2,15,9,19,10,21,192,64,61,28,6,5,53,130,30,98,99]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L3b=e.$K3b=void 0,e.$K3b=(0,y.$ph)("workspacesManagementMainService");let t=class extends O.$lb{constructor(s,n,i,a,m){super(),this.g=s,this.h=n,this.i=i,this.j=a,this.k=m,this.a=this.B(new C.$8c),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new C.$8c),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const s=(await $.Promises.readdir(this.c.fsPath)).map(n=>(0,f.$0f)(this.c,n,b.$Oh));for(const n of s){const i=(0,w.$A3b)(n),a=await this.resolveLocalWorkspace(n);a?this.f.push({workspace:i,remoteAuthority:a.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(s){s.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${s}).`)}}resolveLocalWorkspace(s){return this.l(s,n=>$.Promises.readFile(n,"utf8"))}l(s,n){if(this.m(s)&&s.scheme===R.Schemas.file)try{const i=n(s.fsPath);return i instanceof Promise?i.then(a=>this.n(s,a),a=>{}):this.n(s,i)}catch{return}}m(s){return(0,b.$Ph)(s,this.g)||(0,b.$Uh)(s)}n(s,n){try{const i=this.p(s,n),a=(0,w.$A3b)(s);return{id:a.id,configPath:a.configPath,folders:(0,k.$Nab)(i.folders,a.configPath,f.$1f),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}p(s,n){const i=(0,r.$xm)(n);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(a=>(0,k.$Lab)(a));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(s,n){const{workspace:i,storedWorkspace:a}=this.r(s,n),m=i.configPath.fsPath;return await $.Promises.mkdir((0,S.$dc)(m),{recursive:!0}),await $.Promises.writeFile(m,JSON.stringify(a,null,"	")),this.f.push({workspace:i,remoteAuthority:n}),i}r(s=[],n){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),a=(0,f.$0f)(this.c,i),m=(0,f.$0f)(a,b.$Oh),P=[];for(const I of s)P.push((0,k.$Mab)(I.uri,!0,I.name,a,f.$1f));return{workspace:(0,w.$A3b)(m),storedWorkspace:{folders:P,remoteAuthority:n}}}async getWorkspaceIdentifier(s){return(0,w.$A3b)(s)}isUntitledWorkspace(s){return(0,b.$Ph)(s.configPath,this.g)}async deleteUntitledWorkspace(s){this.isUntitledWorkspace(s)&&(await this.s(s),this.i.isEnabled()&&this.i.unsetWorkspace(s),this.a.fire(s))}async s(s){const n=(0,f.$Xf)(s.configPath);try{await $.Promises.rm((0,S.$dc)(n));const i=(0,S.$ac)(this.g.workspaceStorageHome.fsPath,s.id);await $.Promises.exists(i)&&await $.Promises.writeFile((0,S.$ac)(i,"obsolete"),""),this.f=this.f.filter(a=>a.workspace.id!==s.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${n} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(s,n,i){if(!s||!s.win||!s.isReady||!await this.t(s,n,i))return;const m=await this.u(s,(0,w.$A3b)(i));if(m)return this.b.fire({window:s,workspace:m.workspace}),m}async t(s,n,i){return i?(0,b.$Eh)(s.openedWorkspace)&&f.$1f.isEqual(s.openedWorkspace.configPath,i)?!1:(0,c.$I3b)(n,i)?(await this.k.showMessageBox({type:"info",buttons:[(0,d.localize)(0,null)],message:(0,d.localize)(1,null,(0,f.$7f)(i)),detail:(0,d.localize)(2,null)},(0,u.$Be)(E.BrowserWindow.getFocusedWindow())),!1):!0:!0}async u(s,n){if(!s.config)return;s.focus();let i;return s.config.extensionDevelopmentPath||(s.config.backupPath?i=await this.j.registerWorkspaceBackup({workspace:n,remoteAuthority:s.remoteAuthority},s.config.backupPath):i=this.j.registerWorkspaceBackup({workspace:n,remoteAuthority:s.remoteAuthority})),(0,b.$Eh)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=n,s.config.backupPath=i,{workspace:n,backupPath:i}}};e.$L3b=t,e.$L3b=t=pe([_(0,v.$f3b),_(1,o.$Ri),_(2,g.$n3b),_(3,p.$y3b),_(4,h.$F3b)],t)}),define(te[133],ie([0,1,14,38,22,6,29,30,54,10,5,62]),function(V,e,E,C,r,O,R,S,f,u,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q3b=e.$P3b=e.ID=void 0,e.ID="diagnosticsMainService",e.$P3b=(0,O.$ph)(e.ID);let p=class{constructor(v,y,o){this.a=v,this.b=y,this.c=o}async getRemoteDiagnostics(v){const y=this.a.getWindows();return(await Promise.all(y.map(async g=>{const c=g.remoteAuthority;if(!c)return;const b=`vscode:getDiagnosticInfoResponse${g.id}`,k={includeProcesses:v.includeProcesses,folders:v.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(w=>{g.sendWhenReady("vscode:getDiagnosticInfo",r.CancellationToken.None,{replyChannel:b,args:k}),C.$oS.once(b,(t,l)=>{l||w({hostName:c,errorMessage:`Unable to resolve connection to '${c}'.`}),w(l)}),setTimeout(()=>{w({hostName:c,errorMessage:`Connection to '${c}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const v=[];for(const o of E.BrowserWindow.getAllWindows()){const g=this.a.getWindowById(o.id);g?v.push(await this.d(g)):v.push(this.e(o))}const y=[];for(const{pid:o,name:g}of d.$M3b.getAll())y.push({pid:o,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:v,pidToNames:y,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(v){const y=await this.f(v),o=(0,u.$ue)(v.win);return this.e(o,y,v.remoteAuthority)}e(v,y=[],o){return{id:v.id,pid:v.webContents.getOSProcessId(),title:v.getTitle(),folderURIs:y,remoteAuthority:o}}async f(v){const y=[],o=v.openedWorkspace;if((0,S.$zh)(o))y.push(o.uri);else if((0,S.$Eh)(o)){const g=await this.b.resolveLocalWorkspace(o.configPath);g&&g.folders.forEach(b=>{y.push(b.uri)})}return y}};e.$Q3b=p,e.$Q3b=p=pe([_(0,R.$t3b),_(1,f.$K3b),_(2,$.$Ri)],p)}),define(te[67],ie([0,1,47,14,27,155,55,3,2,15,9,4,7,105,87,21,103,180,61,28,6,20,5,23,80,29,30,54,17,242,234]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t,l,s,n,i,a,m,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$73b=e.$63b=void 0,e.$63b=(0,k.$ph)("nativeHostMainService");let D=class extends f.$lb{constructor(L,N,B,re,ne,ue,se,le){super(),this.a=L,this.b=N,this.c=B,this.f=re,this.g=ne,this.h=ue,this.i=se,this.j=le,this.onDidOpenWindow=S.Event.map(this.a.onDidOpenWindow,J=>J.id),this.onDidTriggerSystemContextMenu=S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:J,x:K,y:U})=>({windowId:J.id,x:K,y:U})),({windowId:J})=>!!this.a.getWindowById(J)),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(C.app,"browser-window-maximize",(J,K)=>K.id),J=>!!this.a.getWindowById(J)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(C.app,"browser-window-unmaximize",(J,K)=>K.id),J=>!!this.a.getWindowById(J)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(C.app,"browser-window-blur",(J,K)=>K.id),J=>!!this.a.getWindowById(J)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),J=>!!J),J=>J.id),S.Event.filter(S.Event.fromNodeEventEmitter(C.app,"browser-window-focus",(J,K)=>K.id),J=>!!this.a.getWindowById(J))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(C.powerMonitor,"resume"),this.onDidChangeColorScheme=this.i.onDidChangeColorScheme,this.k=this.B(new S.$8c),this.onDidChangePassword=this.k.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(C.screen,"display-metrics-changed",(J,K,U)=>U),J=>!(Array.isArray(J)&&J.length===1&&J[0]==="workArea")),S.Event.fromNodeEventEmitter(C.screen,"display-added"),S.Event.fromNodeEventEmitter(C.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(N=>({id:N.id,workspace:N.openedWorkspace??(0,i.$Dh)(N.backupPath,N.isExtensionDevelopmentHost),title:N.win?.getTitle()??"",filename:N.getRepresentedFilename(),dirty:N.isDocumentEdited()}))}async getWindowCount(L){return this.a.getWindowCount()}async getActiveWindowId(L){const N=C.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(N)return N.id}openWindow(L,N,B){return Array.isArray(N)?this.l(L,N,B):this.m(L,N)}async l(L,N,B=Object.create(null)){N.length>0&&await this.a.open({context:5,contextWindowId:L,urisToOpen:N,cli:this.f.args,forceNewWindow:B.forceNewWindow,forceReuseWindow:B.forceReuseWindow,preferNewWindow:B.preferNewWindow,diffMode:B.diffMode,mergeMode:B.mergeMode,addMode:B.addMode,gotoLineMode:B.gotoLineMode,noRecentEntry:B.noRecentEntry,waitMarkerFileURI:B.waitMarkerFileURI,remoteAuthority:B.remoteAuthority||void 0,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}async m(L,N){await this.a.openEmptyWindow({context:5,contextWindowId:L},N)}async toggleFullScreen(L){this.t(L)?.toggleFullScreen()}async handleTitleDoubleClick(L){this.t(L)?.handleTitleDoubleClick()}async isMaximized(L){const N=this.t(L);return N?.win?N.win.isMaximized():!1}async maximizeWindow(L){const N=this.t(L);N?.win&&N.win.maximize()}async unmaximizeWindow(L){const N=this.t(L);N?.win&&N.win.unmaximize()}async minimizeWindow(L){const N=this.t(L);N?.win&&N.win.minimize()}async updateWindowControls(L,N){const B=this.t(L);B&&B.updateWindowControls(N)}async focusWindow(L,N){N&&typeof N.windowId=="number"&&(L=N.windowId),this.t(L)?.focus({force:N?.force??!1})}async setMinimumSize(L,N,B){const re=this.t(L);if(re?.win){const[ne,ue]=re.win.getSize(),[se,le]=re.win.getMinimumSize(),[J,K]=[N??se,B??le],[U,T]=[Math.max(ne,J),Math.max(ue,K)];(se!==J||le!==K)&&re.win.setMinimumSize(J,K),(ne!==U||ue!==T)&&re.win.setSize(U,T)}}async saveWindowSplash(L,N){this.i.saveWindowSplash(L,N)}async installShellCommand(L){const{source:N,target:B}=await this.n();try{const{symbolicLink:re}=await y.SymlinkSupport.stat(N);if(re&&!re.dangling){const ne=await(0,h.$Lp)(N);if(B===ne)return}await y.Promises.unlink(N)}catch(re){if(re.code!=="ENOENT")throw re}try{await y.Promises.symlink(B,N)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:ne}=await this.showMessageBox(L,{type:"info",message:(0,g.localize)(0,null,this.h.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(ne===0)try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${B}' '${N}'\\" with administrator privileges"`;await(0,O.promisify)(E.exec)(ue)}catch{throw new Error((0,g.localize)(3,null,N))}}}async uninstallShellCommand(L){const{source:N}=await this.n();try{await y.Promises.unlink(N)}catch(B){switch(B.code){case"EACCES":{const{response:re}=await this.showMessageBox(L,{type:"info",message:(0,g.localize)(4,null,this.h.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(re===0)try{const ne=`osascript -e "do shell script \\"rm '${N}'\\" with administrator privileges"`;await(0,O.promisify)(E.exec)(ne)}catch{throw new Error((0,g.localize)(7,null,N))}break}case"ENOENT":break;default:throw B}}}async n(){const L=(0,$.$bc)(this.f.appRoot,"bin","code"),N=`/usr/local/bin/${this.h.applicationName}`;if(!await y.Promises.exists(L))throw new Error((0,g.localize)(8,null,L));return{source:N,target:L}}async showMessageBox(L,N){return this.b.showMessageBox(N,this.p(L))}async showSaveDialog(L,N){return this.b.showSaveDialog(N,this.p(L))}async showOpenDialog(L,N){return this.b.showOpenDialog(N,this.p(L))}p(L){const N=this.t(L);if(N?.win)return N.win}async pickFileFolderAndOpen(L,N){const B=await this.b.pickFileFolder(N);B&&await this.r(await Promise.all(B.map(async re=>await y.SymlinkSupport.existsDirectory(re)?{folderUri:p.URI.file(re)}:{fileUri:p.URI.file(re)})),N,L)}async pickFolderAndOpen(L,N){const B=await this.b.pickFolder(N);B&&await this.r(B.map(re=>({folderUri:p.URI.file(re)})),N,L)}async pickFileAndOpen(L,N){const B=await this.b.pickFile(N);B&&await this.r(B.map(re=>({fileUri:p.URI.file(re)})),N,L)}async pickWorkspaceAndOpen(L,N){const B=await this.b.pickWorkspace(N);B&&await this.r(B.map(re=>({workspaceUri:p.URI.file(re)})),N,L)}async r(L,N,B){await this.a.open({context:3,contextWindowId:B,cli:this.f.args,urisToOpen:L,forceNewWindow:N.forceNewWindow})}async showItemInFolder(L,N){C.shell.showItemInFolder(N)}async setRepresentedFilename(L,N){this.t(L)?.setRepresentedFilename(N)}async setDocumentEdited(L,N){this.t(L)?.setDocumentEdited(N)}async openExternal(L,N){return this.f.unsetSnapExportedVariables(),C.shell.openExternal(N),this.f.restoreSnapExportedVariables(),!0}moveItemToTrash(L,N){return C.shell.trashItem(N)}async isAdmin(){let L;return d.$i?L=(await new Promise((N,B)=>{V(["native-is-elevated"],N,B)}))():L=process.getuid?.()===0,L}async writeElevated(L,N,B,re){const ne=await new Promise((ue,se)=>{V(["@vscode/sudo-prompt"],ue,se)});return new Promise((ue,se)=>{const le=[`"${this.s}"`];re?.unlock&&le.push("--file-chmod"),le.push("--file-write",`"${N.fsPath}"`,`"${B.fsPath}"`);const J={name:this.h.nameLong.replace("-",""),icns:d.$j&&this.f.isBuilt?(0,$.$ac)((0,$.$dc)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};ne.exec(le.join(" "),J,(K,U,T)=>{U&&this.g.trace(`[sudo-prompt] received stdout: ${U}`),T&&this.g.trace(`[sudo-prompt] received stderr: ${T}`),K?se(K):ue(void 0)})})}async isRunningUnderARM64Translation(){return d.$k||d.$i?!1:C.app.runningUnderARM64Translation}get s(){return d.$i?this.f.isBuilt?(0,$.$ac)((0,$.$dc)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,$.$ac)(this.f.appRoot,"scripts","code-cli.bat"):d.$k?this.f.isBuilt?(0,$.$ac)((0,$.$dc)(process.execPath),"bin",`${this.h.applicationName}`):(0,$.$ac)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,$.$ac)(this.f.appRoot,"bin","code"):(0,$.$ac)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,r.totalmem)(),freemem:(0,r.freemem)(),loadavg:(0,r.loadavg)()}}async getOSProperties(){return{arch:(0,r.arch)(),platform:(0,r.platform)(),release:(0,r.release)(),type:(0,r.type)(),cpus:(0,r.cpus)()}}async getOSVirtualMachineHint(){return v.$tm.value()}async getOSColorScheme(){return this.i.getColorScheme()}async hasWSLFeatureInstalled(){return d.$i&&(0,P.$43b)()}async killProcess(L,N,B){process.kill(N,B)}async readClipboardText(L,N){return C.clipboard.readText(N)}async writeClipboardText(L,N,B){return C.clipboard.writeText(N,B)}async readClipboardFindText(L){return C.clipboard.readFindText()}async writeClipboardFindText(L,N){return C.clipboard.writeFindText(N)}async writeClipboardBuffer(L,N,B,re){return C.clipboard.writeBuffer(N,Buffer.from(B.buffer),re)}async readClipboardBuffer(L,N){return m.$Jb.wrap(C.clipboard.readBuffer(N))}async hasClipboard(L,N,B){return C.clipboard.has(N,B)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){C.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){C.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){C.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){C.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){C.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,N){this.t(L)?.updateTouchBar(N)}async notifyReady(L){this.t(L)?.setReady()}async relaunch(L,N){return this.c.relaunch(N)}async reload(L,N){const B=this.t(L);if(B){if((0,i.$Eh)(B.openedWorkspace)){const re=B.openedWorkspace.configPath;if(re.scheme===u.Schemas.file&&(await this.j.resolveLocalWorkspace(re))?.transient)return this.openWindow(B.id,{forceReuseWindow:!0})}return this.c.reload(B,N?.disableExtensions!==void 0?{_:[],"disable-extensions":N.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,N){const B=this.t(N);if(B?.win)return B.win.close()}async quit(L){const N=this.a.getLastActiveWindow();N?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&N.win?N.win.close():this.c.quit()}async exit(L,N){await this.c.kill(N)}async resolveProxy(L,N){return this.t(L)?.win?.webContents?.session?.resolveProxy(N)}findFreePort(L,N,B,re,ne=1){return(0,o.$8e)(N,B,re,ne)}async openDevTools(L,N){const B=this.t(L);B?.win&&B.win.webContents.openDevTools(N)}async toggleDevTools(L){const N=this.t(L);N?.win&&N.win.webContents.toggleDevTools()}async sendInputEvent(L,N){const B=this.t(L);B?.win&&(N.type==="mouseDown"||N.type==="mouseUp")&&B.win.webContents.sendInputEvent(N)}async profileRenderer(L,N,B){const re=this.t(L);if(!re||!re.win)throw new Error;return await new I.$53b(re.win,N,this.g).inspect(B)}async windowsGetStringRegKey(L,N,B,re){if(!d.$i)return;const ne=await new Promise((ue,se)=>{V(["@vscode/windows-registry"],ue,se)});try{return ne.GetStringRegKey(N,B,re)}catch{return}}t(L){if(typeof L=="number")return this.a.getWindowById(L)}};e.$73b=D,pe([R.$Tg],D.prototype,"s",null),e.$73b=D=pe([_(0,n.$t3b),_(1,c.$F3b),_(2,w.$h3b),_(3,b.$f3b),_(4,t.$Ri),_(5,l.$0i),_(6,s.$23b),_(7,a.$K3b)],D)}),define(te[298],ie([0,1,14,38,27,2,15,4,107,178,91,133,61,28,5,67,78,23,79,81,32,10,34,62,22,7,29,8]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t,l,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$93b=void 0;const m="issue.processExplorerWindowState";let P=class At{static{this.a="#1E1E1E"}constructor(M,L,N,B,re,ne,ue,se,le,J,K){this.g=M,this.h=L,this.i=N,this.j=B,this.k=re,this.l=ne,this.m=ue,this.n=se,this.o=le,this.p=J,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){C.$oS.on("vscode:listProcesses",async M=>{const L=[];try{L.push({name:(0,u.localize)(0,null),rootProcess:await(0,f.$fr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(B=>{(0,$.$6l)(B)?L.push({name:B.hostName,rootProcess:B}):B.processes&&L.push({name:B.hostName,rootProcess:B.processes})})}catch(N){this.i.error(`Listing processes failed: ${N}`)}this.t(M,"vscode:listProcessesResponse",L)}),C.$oS.on("vscode:workbenchCommand",(M,L)=>{const{id:N,from:B,args:re}=L;let ne;switch(B){case"processExplorer":ne=this.f;break;default:throw new Error(`Unexpected command source: ${B}`)}ne?.webContents.send("vscode:runAction",{id:N,from:B,args:re})}),C.$oS.on("vscode:closeProcessExplorer",M=>{this.d?.close()}),C.$oS.on("vscode:pidToNameRequest",async M=>{const L=await this.k.getMainDiagnostics(),N=[];for(const B of L.windows)N.push([B.pid,`window [${B.id}] (${B.title})`]);for(const{pid:B,name:re}of l.$M3b.getAll())N.push([B,re]);this.t(M,"vscode:pidToNameResponse",N)})}async openReporter(M){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const L=new O.$kb,N=L.add(this.n.createIPCObjectUrl()),B=this.v(this.c,700,800);this.b=this.u(B,N,{backgroundColor:M.styles.backgroundColor,title:(0,u.localize)(1,null),zoomLevel:M.zoomLevel,alwaysOnTop:!1},"issue-reporter"),N.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:M,disableExtensions:!!this.h.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:o.default}),this.b.loadURL(R.$4e.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,L.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,L.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(M){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const L=new O.$kb,N=L.add(this.n.createIPCObjectUrl()),B=this.p.getItem(m,void 0),re=I(B)?B:this.v(this.f,800,500);this.d=this.u(re,N,{backgroundColor:M.styles.backgroundColor,title:(0,u.localize)(2,null),zoomLevel:M.zoomLevel,alwaysOnTop:!0},"process-explorer"),N.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:M,product:o.default}),this.d.loadURL(R.$4e.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,L.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,L.dispose())});const ne=()=>{if(!this.d)return;const ue=this.d.getSize(),se=this.d.getPosition();if(!ue||!se)return;const le={width:ue[0],height:ue[1],x:se[0],y:se[1]};this.p.setItem(m,le)};this.d.on("moved",ne),this.d.on("resized",ne)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const M=await E.contentTracing.stopRecording(`${(0,k.$Se)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null,M),buttons:[(0,u.localize)(5,null)]},(0,w.$Be)(E.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,M)}async getSystemStatus(){const[M,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(M,L)}async $getSystemInfo(){const[M,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(M,L)}async $getPerformanceInfo(){try{const[M,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(M,L)}catch(M){throw this.i.warn("issueService#getPerformanceInfo ",M.message),M}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(M){this.i.error(M)}}async $showConfirmCloseDialog(){if(this.b){const{response:M}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(6,null),buttons:[(0,u.localize)(7,null),(0,u.localize)(8,null)]},this.b);M===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:M}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(9,null),buttons:[(0,u.localize)(10,null),(0,u.localize)(11,null)]},this.b);return M===0}return!1}async $getIssueReporterUri(M){if(!this.c)throw new Error("Issue reporter window not available");const L=this.q.getWindowById(this.c.id);if(!L)throw new Error("Window not found");const N=`vscode:triggerIssueUriRequestHandlerResponse${L.id}`;return a.Promises.withAsyncBody(async(B,re)=>{const ne=new s.$ed;L.sendWhenReady("vscode:triggerIssueUriRequestHandler",ne.token,{replyChannel:N,extensionId:M}),C.$oS.once(N,(ue,se)=>{B(n.URI.parse(se))});try{await(0,a.$wg)(5e3),ne.cancel(),re(new Error("Timed out waiting for issue reporter URI"))}finally{C.$oS.removeHandler(N)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(M){M.isMinimized()&&M.restore(),M.focus()}t(M,L,...N){M.sender.isDestroyed()||M.sender.send(L,...N)}u(M,L,N,B){const re=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:M.width,height:M.height,minWidth:300,minHeight:200,x:M.x,y:M.y,title:N.title,backgroundColor:N.backgroundColor||At.a,webPreferences:{preload:R.$4e.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${L.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,b.$GD)(N.zoomLevel),sandbox:!0},alwaysOnTop:N.alwaysOnTop,experimentalDarkMode:!0});return re.setMenuBarVisibility(!1),re}v(M,L,N){let B;const re=E.screen.getAllDisplays();if(re.length===1)B=re[0];else{if(S.$j){const se=E.screen.getCursorScreenPoint();B=E.screen.getDisplayNearestPoint(se)}!B&&M&&(B=E.screen.getDisplayMatching(M.getBounds())),B||(B=E.screen.getPrimaryDisplay()||re[0])}const ne=B.bounds,ue={width:L,height:N,x:ne.x+ne.width/2-L/2,y:ne.y+ne.height/2-N/2};return ne.width>0&&ne.height>0&&(ue.x<ne.x&&(ue.x=ne.x),ue.y<ne.y&&(ue.y=ne.y),ue.x>ne.x+ne.width&&(ue.x=ne.x),ue.y>ne.y+ne.height&&(ue.y=ne.y),ue.width>ne.width&&(ue.width=ne.width),ue.height>ne.height&&(ue.height=ne.height)),ue}};e.$93b=P,e.$93b=P=pe([_(1,h.$f3b),_(2,v.$Ri),_(3,$.$5l),_(4,d.$P3b),_(5,p.$F3b),_(6,y.$63b),_(7,c.$83b),_(8,g.$0i),_(9,t.$SM),_(10,i.$t3b)],P);function I(D){return typeof D!="object"||D===null?!1:"x"in D&&"y"in D&&"width"in D&&"height"in D}}),define(te[299],ie([0,1,22,18,28,20,5,67,23,51,26,48,100]),function(V,e,E,C,r,O,R,S,f,u,$,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w4b=void 0;let h=class extends p.$u4b{constructor(y,o,g,c,b,k,w,t){super(y,o,c,b,k,t),this.e=g,this.u=w}s(y){return(0,p.$t4b)(`linux-${process.arch}`,y,this.k)}t(y){this.a&&(this.d(d.$Fib.CheckingForUpdates(y)),this.i.request({url:this.a},E.CancellationToken.None).then(u.$Do).then(o=>{!o||!o.url||!o.version||!o.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!y}),this.d(d.$Fib.Idle(1))):this.d(d.$Fib.AvailableForDownload(o))}).then(void 0,o=>{this.j.error(o),this.e.publicLog2("update:notAvailable",{explicit:!!y});const g=y?o.message||o:void 0;this.d(d.$Fib.Idle(1,g))}))}async o(y){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):y.update.url&&this.u.openExternal(void 0,y.update.url),this.d(d.$Fib.Idle(1))}};e.$w4b=h,e.$w4b=h=pe([_(0,O.$h3b),_(1,C.$Vh),_(2,$.$Vk),_(3,r.$f3b),_(4,u.$yo),_(5,R.$Ri),_(6,S.$63b),_(7,f.$0i)],h)}),define(te[300],ie([0,1,47,45,27,8,22,55,9,7,142,21,18,28,16,20,5,67,23,51,26,48,100]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y4b=void 0;async function l(a,m=1e3){for(;!a();)await(0,O.$wg)(m)}let s;function n(){return typeof s>"u"&&(s=C.existsSync(f.$ac(f.$dc(process.execPath),"unins000.exe"))?0:1),s}let i=class extends t.$u4b{get cachePath(){const m=f.$ac((0,r.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return d.Promises.mkdir(m,{recursive:!0}).then(()=>m)}constructor(m,P,I,D,M,L,N,B,re){super(m,P,D,M,L,re),this.u=I,this.v=N,this.w=B,m.setRelaunchHandler(this)}handleRelaunch(m){return m?.addArgs||m?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(w.$Fib.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(m){let P="win32";return process.arch!=="ia32"&&(P+=`-${process.arch}`),n()===1?P+="-archive":this.k.target==="user"&&(P+="-user"),(0,t.$t4b)(P,m,this.k)}t(m){this.a&&(this.d(w.$Fib.CheckingForUpdates(m)),this.i.request({url:this.a},R.CancellationToken.None).then(b.$Do).then(P=>{const I=n();return!P||!P.url||!P.version||!P.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!m}),this.d(w.$Fib.Idle(I)),Promise.resolve(null)):I===1?(this.d(w.$Fib.AvailableForDownload(P)),Promise.resolve(null)):(this.d(w.$Fib.Downloading(P)),this.C(P.version).then(()=>this.B(P.version).then(D=>d.Promises.exists(D).then(M=>{if(M)return Promise.resolve(D);const L=P.url,N=P.hash,B=`${D}.tmp`;return this.i.request({url:L},R.CancellationToken.None).then(re=>this.v.writeFile(u.URI.file(B),re.stream)).then(N?()=>(0,$.$jS)(B,P.hash):()=>{}).then(()=>d.Promises.rename(B,D,!1)).then(()=>D)})).then(D=>{const M=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:D},M?this.k.target==="user"?this.p():this.d(w.$Fib.Downloaded(P)):this.d(w.$Fib.Ready(P))})))}).then(void 0,P=>{this.j.error(P),this.u.publicLog2("update:notAvailable",{explicit:!!m});const I=m?P.message||P:void 0;this.d(w.$Fib.Idle(n(),I))}))}async o(m){m.update.url&&this.w.openExternal(void 0,m.update.url),this.d(w.$Fib.Idle(n()))}async B(m){const P=await this.cachePath;return f.$ac(P,`CodeSetup-${this.k.quality}-${m}.exe`)}async C(m=null){const P=m?L=>!new RegExp(`${this.k.quality}-${m}\\.exe$`).test(L):()=>!0,I=await this.cachePath,M=(await d.Promises.readdir(I)).filter(P).map(async L=>{try{await d.Promises.unlink(f.$ac(I,L))}catch{}});await Promise.all(M)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const m=this.state.update;this.d(w.$Fib.Updating(m));const P=await this.cachePath;this.e.updateFilePath=f.$ac(P,`CodeSetup-${this.k.quality}-${m.version}.flag`),await d.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(w.$Fib.Idle(n()))});const D=`${this.k.win32MutexName}-ready`,M=await new Promise((L,N)=>{V(["@vscode/windows-mutex"],L,N)});l(()=>M.isActive(D)).then(()=>this.d(w.$Fib.Ready(m)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?C.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return n()}async _applySpecificUpdate(m){if(this.state.type!=="idle")return;const P=this.g.getValue("update.enableWindowsBackgroundUpdates"),I={version:"unknown",productVersion:"unknown"};this.d(w.$Fib.Downloading(I)),this.e={packagePath:m},P?this.k.target==="user"?this.p():this.d(w.$Fib.Downloaded(I)):this.d(w.$Fib.Ready(I))}};e.$y4b=i,pe([S.$Tg],i.prototype,"cachePath",null),e.$y4b=i=pe([_(0,y.$h3b),_(1,p.$Vh),_(2,k.$Vk),_(3,h.$f3b),_(4,b.$yo),_(5,o.$Ri),_(6,v.$Sj),_(7,g.$63b),_(8,c.$0i)],i)}),define(te[301],ie([0,1,14,8,22,50,3,2,15,9,65,4,7,188,64,18,61,28,63,16,20,5,23,79,250,83,26,102,80,81,29,30,54,128,134,39,34,53,66,24]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t,l,s,n,i,a,m,P,I,D,M,L,N,B,re,ne,ue,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G4b=void 0;var le;(function(K){K[K.NONE=0]="NONE",K[K.NAVIGATING=1]="NAVIGATING",K[K.READY=2]="READY"})(le||(le={}));let J=class kt extends S.$lb{static{this.a="windowControlHeight"}get id(){return this.j}get win(){return this.k}get lastFocusTime(){return this.l}get backupPath(){return this.m?.backupPath}get openedWorkspace(){return this.m?.workspace}get profile(){if(!this.config)return;const U=this.O.profiles.find(T=>T.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&U?U:this.O.getProfileForWorkspace(this.config.workspace??(0,D.$Dh)(this.backupPath,this.isExtensionDevelopmentHost))??this.O.defaultProfile}get remoteAuthority(){return this.m?.remoteAuthority}get config(){return this.m}get isExtensionDevelopmentHost(){return!!this.m?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.m?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.m?.debugId}constructor(U,T,W,H,Q,ce,oe,j,A,F,q,G,Z,z,Y,x,ae,he,Ie,Ee){super(),this.J=T,this.L=W,this.M=H,this.N=Q,this.O=ce,this.P=oe,this.Q=j,this.R=A,this.S=F,this.U=q,this.W=G,this.X=Z,this.Y=z,this.Z=Y,this.$=x,this.ab=ae,this.bb=he,this.db=Ie,this.eb=Ee,this.b=this.B(new R.$8c),this.onWillLoad=this.b.event,this.c=this.B(new R.$8c),this.onDidSignalReady=this.c.event,this.f=this.B(new R.$8c),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new R.$8c),this.onDidClose=this.g.event,this.h=this.B(new R.$8c),this.onDidDestroy=this.h.event,this.l=-1,this.s=void 0,this.t=void 0,this.w=!1,this.z=[],this.C=[],this.D=void 0,this.F=void 0,this.G=this.B(this.bb.createIPCObjectUrl()),this.I=!1,this.fb=0;{const[Ae,Me]=this.pb(U.state);this.n=Ae,this.J.trace("window#ctor: using window state",Ae);const We=this.n.mode===0||this.n.mode===3,$e=this.S.getValue("window"),be={width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y,backgroundColor:this.U.getBackgroundColor(),minWidth:P.$zD.WIDTH,minHeight:P.$zD.HEIGHT,show:!We,title:this.ab.nameLong,webPreferences:{preload:f.$4e.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.G.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,P.$GD)($e?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};d.$k?be.icon=(0,u.$ac)(this.M.appRoot,"resources/linux/code.png"):d.$i&&!this.M.isBuilt&&(be.icon=(0,u.$ac)(this.M.appRoot,"resources/win32/code_150x150.png")),d.$j&&!this.wb()&&(be.fullscreenable=!1),d.$j&&(be.acceptFirstMouse=!0,$e?.clickThroughInactive===!1&&(be.acceptFirstMouse=!1));const ee=d.$j&&$e?.nativeTabs===!0;ee&&(be.tabbingIdentifier=this.ab.nameShort);const fe=(0,P.$ED)(this.S)==="custom";if(fe&&(be.titleBarStyle="hidden",d.$j||(be.frame=!1),(0,P.$FD)(this.S))){const ge=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),Se=N.$0r.fromHex(ge).isDarker()?"#FFFFFF":"#000000";be.titleBarOverlay={height:29,color:ge,symbolColor:Se},this.w=!0}if((0,$.mark)("code/willCreateCodeBrowserWindow"),this.k=new E.BrowserWindow(be),(0,$.mark)("code/didCreateCodeBrowserWindow"),this.j=this.k.id,d.$j&&fe&&this.k.setSheetOffset(22),fe&&(d.$i&&(0,P.$FD)(this.S)||d.$j)){const ge=this.eb.getItem(kt.a);ge&&this.updateWindowControls({height:ge})}d.$i&&fe&&this.k.hookWindowMessage(278,()=>{const[Se,Ce]=this.k.getPosition(),je=E.screen.getCursorScreenPoint(),Oe=je.x-Se,ze=je.y-Ce;return(()=>!(Oe>30&&ze>=0&&ze<=Math.max(this.k.getBounds().height*.15,35)))()||(this.k.setEnabled(!1),this.k.setEnabled(!0),this.f.fire({x:Oe,y:ze})),0}),(d.$j||d.$i)&&Me&&(!ee||E.BrowserWindow.getAllWindows().length===1)&&[this.n.width,this.n.height,this.n.x,this.n.y].every(ge=>typeof ge=="number")&&this.k.setBounds({width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y}),We&&((0,$.mark)("code/willMaximizeCodeWindow"),this.k.maximize(),this.n.mode===3&&this.sb(!0),this.k.show(),(0,$.mark)("code/didMaximizeCodeWindow")),this.l=Date.now()}this.M.args["open-devtools"]===!0&&this.k.webContents.openDevTools(),this.mb(),this.Ab(),this.gb()}setRepresentedFilename(U){d.$j?this.k.setRepresentedFilename(U):this.u=U}getRepresentedFilename(){return d.$j?this.k.getRepresentedFilename():this.u}setDocumentEdited(U){d.$j&&this.k.setDocumentEdited(U),this.v=U}isDocumentEdited(){return d.$j?this.k.isDocumentEdited():!!this.v}focus(U){d.$j&&U?.force&&E.app.focus({steal:!0}),this.k&&(this.k.isMinimized()&&this.k.restore(),this.k.focus())}setReady(){for(this.J.trace(`window#load: window reported ready (id: ${this.j})`),this.fb=2;this.z.length;)this.z.pop()(this);this.c.fire()}ready(){return new Promise(U=>{if(this.isReady)return U(this);this.z.push(U)})}get isReady(){return this.fb===2}get whenClosedOrLoaded(){return new Promise(U=>{function T(){W.dispose(),H.dispose(),U()}const W=this.onDidClose(()=>T()),H=this.onWillLoad(()=>T())})}gb(){this.k.on("unresponsive",()=>this.jb(1)),this.k.webContents.on("render-process-gone",(T,W)=>this.jb(2,{...W})),this.k.webContents.on("did-fail-load",(T,W,H)=>this.jb(3,{reason:H,exitCode:W})),this.k.webContents.on("will-prevent-unload",T=>{T.preventDefault()}),this.k.on("closed",()=>{this.g.fire(),this.dispose()}),this.k.webContents.on("did-finish-load",()=>{this.H&&(this.m=this.H,this.H=void 0)}),this.k.on("focus",()=>{this.l=Date.now()}),this.k.on("maximize",T=>{this.m&&(this.m.maximized=!0),E.app.emit("browser-window-maximize",T,this.k)}),this.k.on("unmaximize",T=>{this.m&&(this.m.maximized=!1),E.app.emit("browser-window-unmaximize",T,this.k)}),this.k.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",r.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.k.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",r.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.B(this.S.onDidChangeConfiguration(T=>this.mb(T))),this.B(this.W.onDidDeleteUntitledWorkspace(T=>this.lb(T)));const U=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.k.webContents.session.webRequest.onBeforeSendHeaders({urls:U},async(T,W)=>{const H=await this.ib();W({cancel:!1,requestHeaders:Object.assign(T.requestHeaders,H)})})}ib(){return this.hb||(this.hb=(0,s.$Ro)(this.ab.version,this.ab,this.M,this.S,this.P,this.Q,this.Y)),this.hb}async jb(U,T){switch(U){case 2:this.J.error(`CodeWindow: renderer process gone (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.J.error("CodeWindow: detected unresponsive");break;case 3:this.J.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:U,reason:T?.reason,code:T?.exitCode}),U){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.$.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.kb(!1,!1),this.$.quit();return}if(U===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.k&&this.k.webContents&&this.k.webContents.isDevToolsOpened())return;const{response:W,checkboxChecked:H}=await this.Z.showMessageBox({type:"warning",buttons:[(0,h.localize)(0,null),(0,h.localize)(1,null),(0,h.localize)(2,null)],message:(0,h.localize)(3,null),detail:(0,h.localize)(4,null),checkboxLabel:this.m?.workspace?(0,h.localize)(5,null):void 0},this.k);if(W!==2){const Q=W===0;await this.kb(Q,H)}}else if(U===2){let W;T?W=(0,h.localize)(7,null,T.reason,T.exitCode??"<unknown>"):W=(0,h.localize)(6,null);const{response:H,checkboxChecked:Q}=await this.Z.showMessageBox({type:"warning",buttons:[this.m?.workspace?(0,h.localize)(8,null):(0,h.localize)(9,null),(0,h.localize)(10,null)],message:W,detail:this.m?.workspace?(0,h.localize)(11,null):(0,h.localize)(12,null),checkboxLabel:this.m?.workspace?(0,h.localize)(13,null):void 0},this.k),ce=H===0;await this.kb(ce,Q)}break}}async kb(U,T){const W=this.m?.workspace;if(T&&W)try{const H=this.R.workspaceStorage(W);await H.init(),H.delete("memento/workbench.parts.editor"),await H.close()}catch(H){this.J.error(H)}if(this.h.fire(),this.k?.destroy(),U&&this.m){let H,Q;(0,D.$zh)(W)?H={folderUri:W.uri}:(0,D.$Eh)(W)?H={workspaceUri:W.configPath}:Q=!0,(0,se.$vf)(await this.db.open({context:5,userEnv:this.m.userEnv,cli:{...this.M.args,_:[]},urisToOpen:H?[H]:void 0,forceEmpty:Q,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}lb(U){this.m?.workspace?.id===U.id&&(this.m.workspace=void 0)}mb(U){if(!U||U.affectsConfiguration("window.menuBarVisibility")){const T=this.xb();T!==this.r&&(this.r=T,this.yb(T))}if(!U||U.affectsConfiguration("http.proxy")){let T=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;T?.endsWith("/")&&(T=T.substr(0,T.length-1));const W=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((T||"").indexOf("@")===-1&&(T!==this.D||W!==this.F)){this.D=T,this.F=W;const H=T||"",Q=W?`${W},<local>`:"<local>";this.J.trace(`Setting proxy to '${H}', bypassing '${Q}'`),this.k.webContents.session.setProxy({proxyRules:H,proxyBypassRules:Q,pacScript:""})}}}addTabbedWindow(U){d.$j&&U.win&&this.k.addTabbedWindow(U.win)}load(U,T=Object.create(null)){this.J.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!T.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.k.setTitle(this.ab.nameLong)),this.nb(U,T),this.fb===0?this.m=U:this.H=U,this.fb=1,this.k.loadURL(f.$4e.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const W=this.I;this.I=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new C.$Gg(()=>{this.k&&!this.k.isVisible()&&!this.k.isMinimized()&&(this.k.show(),this.focus({force:!0}),this.k.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:U.workspace,reason:T.isReload?3:W?2:1})}nb(U,T){const W=(this.m??this.H)?.userEnv;if(W){const H=(0,c.$sl)(W)&&!(0,c.$sl)(U.userEnv),Q=this.isExtensionDevelopmentHost;(H||Q)&&(U.userEnv={...W,...U.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(U.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(U["disable-extensions"]=T.disableExtensions),U.fullscreen=this.isFullScreen,U.maximized=this.k.isMaximized(),U.partsSplash=this.U.getWindowSplash(),(0,$.mark)("code/willOpenNewWindow"),U.perfMarks=(0,$.getMarks)(),this.G.update(U)}async reload(U){const T=Object.assign({},this.m);T.workspace=await this.ob(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToMerge,delete T.filesToWait,this.isExtensionDevelopmentHost&&U&&(T.verbose=U.verbose,T.debugId=U.debugId,T.extensionEnvironment=U.extensionEnvironment,T["inspect-extensions"]=U["inspect-extensions"],T["inspect-brk-extensions"]=U["inspect-brk-extensions"],T["extensions-dir"]=U["extensions-dir"]),T.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),T.isInitialStartup=!1,T.policiesData=this.N.serialize(),T.continueOn=this.M.continueOn,T.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile,home:this.O.profilesHome},T.logLevel=this.L.getLogLevel(),T.loggers={window:this.L.getRegisteredLoggers(this.id),global:this.L.getRegisteredLoggers()},this.load(T,{isReload:!0,disableExtensions:U?.["disable-extensions"]})}async ob(U){if((0,D.$Eh)(U.workspace)){const T=U.workspace.configPath;if(T.scheme===f.Schemas.file&&!await this.P.exists(T))return}else if((0,D.$zh)(U.workspace)){const T=U.workspace.uri;if(T.scheme===f.Schemas.file&&!await this.P.exists(T))return}return U.workspace}serializeWindowState(){if(!this.k)return(0,L.$e3b)();if(this.isFullScreen){let W;try{W=E.screen.getDisplayMatching(this.getBounds())}catch{}const H=(0,L.$e3b)();return{mode:3,display:W?W.id:void 0,width:this.n.width||H.width,height:this.n.height||H.height,x:this.n.x||0,y:this.n.y||0}}const U=Object.create(null);let T;if(!d.$j&&this.k.isMaximized()?T=0:T=1,T===0?U.mode=0:U.mode=1,T===1||T===0){let W;T===1?W=this.getBounds():W=this.k.getNormalBounds(),U.x=W.x,U.y=W.y,U.width=W.width,U.height=W.height}return U}updateWindowControls(U){if(U.height&&this.eb.setItem(kt.a,U.height),d.$i&&this.w)this.k.setTitleBarOverlay({color:U.backgroundColor?.trim()===""?void 0:U.backgroundColor,symbolColor:U.foregroundColor?.trim()===""?void 0:U.foregroundColor,height:U.height?U.height-1:void 0});else if(d.$j&&U.height!==void 0){const T=(U.height-15)/2;this.k.setTrafficLightPosition({x:T,y:T})}}pb(U){(0,$.mark)("code/willRestoreCodeWindowState");let T=!1;if(U)try{const W=E.screen.getAllDisplays();T=W.length>1,U=this.qb(U,W)}catch(W){this.J.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return(0,$.mark)("code/didRestoreCodeWindowState"),[U||(0,L.$e3b)(),T]}qb(U,T){if(this.J.trace(`window#validateWindowState: validating window state on ${T.length} display(s)`,U),typeof U.x!="number"||typeof U.y!="number"||typeof U.width!="number"||typeof U.height!="number"){this.J.trace("window#validateWindowState: unexpected type of state values");return}if(U.width<=0||U.height<=0){this.J.trace("window#validateWindowState: unexpected negative values");return}if(T.length===1){const Q=this.rb(T[0]);if(Q){let ce=function(){!U||typeof U.x!="number"||typeof U.y!="number"||!Q||(U.x<Q.x&&(U.x=Q.x),U.y<Q.y&&(U.y=Q.y))};this.J.trace("window#validateWindowState: 1 monitor working area",Q),ce(),U.width>Q.width&&(U.width=Q.width),U.height>Q.height&&(U.height=Q.height),U.x>Q.x+Q.width-128&&(U.x=Q.x+Q.width-U.width),U.y>Q.y+Q.height-128&&(U.y=Q.y+Q.height-U.height),ce()}return U}if(U.display&&U.mode===3){const Q=T.find(ce=>ce.id===U.display);if(Q&&typeof Q.bounds?.x=="number"&&typeof Q.bounds?.y=="number"){this.J.trace("window#validateWindowState: restoring fullscreen to previous display");const ce=(0,L.$e3b)(3);return ce.x=Q.bounds.x,ce.y=Q.bounds.y,ce}}let W,H;try{W=E.screen.getDisplayMatching({x:U.x,y:U.y,width:U.width,height:U.height}),H=this.rb(W)}catch{}if(W&&H&&U.x+U.width>H.x&&U.y+U.height>H.y&&U.x<H.x+H.width&&U.y<H.y+H.height)return this.J.trace("window#validateWindowState: multi-monitor working area",H),U}rb(U){if(U.workArea.width>0&&U.workArea.height>0)return U.workArea;if(U.bounds.width>0&&U.bounds.height>0)return U.bounds}getBounds(){const[U,T]=this.k.getPosition(),[W,H]=this.k.getSize();return{x:U,y:T,width:W,height:H}}toggleFullScreen(){this.sb(!this.isFullScreen)}sb(U){this.wb()?this.tb(U):this.vb(U),this.sendWhenReady(U?"vscode:enterFullScreen":"vscode:leaveFullScreen",r.CancellationToken.None),this.r&&this.yb(this.r,!1)}get isFullScreen(){return d.$j&&typeof this.s=="boolean"?this.s:this.k.isFullScreen()||this.k.isSimpleFullScreen()}tb(U){this.k.isSimpleFullScreen()&&this.k.setSimpleFullScreen(!1),this.ub(U)}ub(U){d.$j&&(this.s=U,this.t=new C.$Pg,Promise.race([this.t.p,(0,C.$wg)(1e3)]).finally(()=>this.s=void 0)),this.k.setFullScreen(U)}vb(U){this.k.isFullScreen()&&this.ub(!1),this.k.setSimpleFullScreen(U),this.k.webContents.focus()}wb(){const U=this.S.getValue("window");return!U||typeof U.nativeFullScreen!="boolean"||U.nativeTabs?!0:U.nativeFullScreen!==!1}isMinimized(){return this.k.isMinimized()}xb(){let U=(0,P.$DD)(this.S);return["visible","toggle","hidden"].indexOf(U)<0&&(U="classic"),U}yb(U,T=!0){d.$j||(U==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,h.localize)(14,null)),U==="hidden"?setTimeout(()=>{this.zb(U)}):this.zb(U))}zb(U){const T=this.isFullScreen;switch(U){case"classic":this.k.setMenuBarVisibility(!T),this.k.autoHideMenuBar=T;break;case"visible":this.k.setMenuBarVisibility(!0),this.k.autoHideMenuBar=!1;break;case"toggle":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!0;break;case"hidden":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(d.$j)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.k.minimize();break;case"None":break;case"Maximize":default:this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}else this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}close(){this.k?.close()}sendWhenReady(U,T,...W){this.isReady?this.send(U,...W):this.ready().then(()=>{T.isCancellationRequested||this.send(U,...W)})}send(U,...T){if(this.k){if(this.k.isDestroyed()||this.k.webContents.isDestroyed()){this.J.warn(`Sending IPC message to channel '${U}' for window that is destroyed`);return}try{this.k.webContents.send(U,...T)}catch(W){this.J.warn(`Error sending IPC message to channel '${U}' of window ${this.j}: ${(0,O.$ai)(W)}`)}}}updateTouchBar(U){d.$j&&this.C.forEach((T,W)=>{const H=U[W];T.segments=this.Cb(H)})}Ab(){if(d.$j){for(let U=0;U<10;U++){const T=this.Bb();this.C.push(T)}this.k.setTouchBar(new E.TouchBar({items:this.C}))}}Bb(U=[]){const T=this.Cb(U),W=new E.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:H=>{this.sendWhenReady("vscode:runAction",r.CancellationToken.None,{id:W.segments[H].id,from:"touchbar"})}});return W}Cb(U=[]){return U.map(W=>{let H;W.icon&&!a.ThemeIcon.isThemeIcon(W.icon)&&W.icon?.dark?.scheme===f.Schemas.file&&(H=E.nativeImage.createFromPath(p.URI.revive(W.icon.dark).fsPath),H.isEmpty()&&(H=void 0));let Q;return typeof W.title=="string"?Q=W.title:Q=W.title.value,{id:W.id,label:H?void 0:Q,icon:H}})}dispose(){super.dispose(),this.L.deregisterLoggers(this.id),this.k=null}};e.$G4b=J,e.$G4b=J=pe([_(1,w.$Ri),_(2,ue.$l4b),_(3,g.$f3b),_(4,B.$Vm),_(5,ne.$n3b),_(6,b.$Sj),_(7,n.$r3b),_(8,n.$p3b),_(9,y.$Vh),_(10,m.$23b),_(11,M.$K3b),_(12,v.$y3b),_(13,i.$Vk),_(14,o.$F3b),_(15,k.$h3b),_(16,t.$0i),_(17,l.$83b),_(18,I.$t3b),_(19,re.$SM)],J)}),define(te[84],ie([0,1,14,24,8,3,46,2,15,4,19,7,21,191,6,20,5,83,98,30,54,35]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h4b=e.$g4b=void 0,e.$g4b=(0,v.$ph)("workspacesHistoryMainService");let t=class nt extends S.$lb{static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(s,n,i,a){super(),this.f=s,this.g=n,this.h=i,this.j=a,this.c=this.B(new O.$8c),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new r.$tg(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}async addRecentlyOpened(s){let n=[],i=[];for(const m of s)if((0,c.$Iab)(m))!this.g.isUntitledWorkspace(m.workspace)&&!this.r(n,m.workspace)&&n.push(m);else if((0,c.$Jab)(m))this.s(n,m.folderUri)||n.push(m);else{const P=this.t(i,m.fileUri),I=m.fileUri.scheme===f.Schemas.file&&nt.y.indexOf((0,$.$7f)(m.fileUri))>=0;!P&&!I&&(i.push(m),u.$i&&m.fileUri.scheme===f.Schemas.file&&E.app.addRecentDocument(m.fileUri.fsPath))}const a=await this.l({workspaces:n,files:i});n=a.workspaces,i=a.files,n.length>nt.a&&(n.length=nt.a),i.length>nt.a&&(i.length=nt.a),await this.n({workspaces:n,files:i}),this.c.fire(),u.$j&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(s){const n=P=>{const I=this.p(P);for(const D of s)if($.$1f.isEqual(D,I))return!1;return!0},i=await this.getRecentlyOpened(),a=i.workspaces.filter(n),m=i.files.filter(n);(a.length!==i.workspaces.length||m.length!==i.files.length)&&(await this.n({files:m,workspaces:a}),this.c.fire(),u.$j&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(s){const n=new w.$ni(m=>$.$1f.getComparisonKey(m));if(s?.workspaces)for(const m of s.workspaces)n.set(this.p(m),m);const i=new w.$ni(m=>$.$1f.getComparisonKey(m));if(s?.files)for(const m of s.files)i.set(this.p(m),m);const a=await this.m();for(const m of a.workspaces){const P=n.get(this.p(m));P?P.label=P.label??m.label:n.set(this.p(m),m)}for(const m of a.files){const P=i.get(this.p(m));P?P.label=P.label??m.label:i.set(this.p(m),m)}return{workspaces:[...n.values()],files:[...i.values()]}}async m(){await this.j.whenReady;let s;const n=this.j.get(nt.b,-1);if(typeof n=="string")try{s=JSON.parse(n)}catch(i){this.f.error("Unexpected error parsing opened paths list",i)}return(0,c.$Pab)(s,this.f)}async n(s){await this.j.whenReady,this.j.store(nt.b,JSON.stringify((0,c.$Qab)(s)),-1,1)}p(s){return(0,c.$Jab)(s)?s.folderUri:(0,c.$Kab)(s)?s.fileUri:s.workspace.configPath}r(s,n){return!!s.find(i=>(0,c.$Iab)(i)&&i.workspace.id===n.id)}s(s,n){return!!s.find(i=>(0,c.$Jab)(i)&&$.$1f.isEqual(i.folderUri,n))}t(s,n){return!!s.find(i=>$.$1f.isEqual(i.fileUri,n))}static{this.u=7}static{this.v=10}static{this.w=7}static{this.y=["COMMIT_EDITMSG","MERGE_MSG"]}async C(){u.$i&&(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!u.$i)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(0,null),description:(0,h.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const m of E.app.getJumpListSettings().removedItems){const P=m.args;if(P){const I=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(P);I&&n.push(d.URI.parse(I[2]))}}await this.removeRecentlyOpened(n);let i=!1;const a=(0,C.$mf)((await this.getRecentlyOpened()).workspaces.slice(0,nt.w).map(m=>{const P=(0,c.$Iab)(m)?m.workspace:m.folderUri,{title:I,description:D}=this.F(P,m.label);let M;return d.URI.isUri(P)?M=`--folder-uri "${P.toString()}"`:(i=!0,M=`--file-uri "${P.configPath.toString()}"`),{type:"task",title:I.substr(0,255),description:D.substr(0,255),program:process.execPath,args:M,iconPath:"explorer.exe",iconIndex:0}}));a.length>0&&s.push({type:"custom",name:i?(0,h.localize)(2,null):(0,h.localize)(3,null),items:a})}s.push({type:"recent"});try{const n=E.app.setJumpList(s);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}F(s,n){if(n)return{title:(0,R.$9z)(n).name,description:n};if(d.URI.isUri(s))return{title:(0,$.$7f)(s),description:this.G(s)};if(this.g.isUntitledWorkspace(s))return{title:(0,h.localize)(4,null),description:""};let i=(0,$.$7f)(s.configPath);return i.endsWith(b.$Lh)&&(i=i.substr(0,i.length-b.$Lh.length-1)),{title:(0,h.localize)(5,null,i),description:this.G(s.configPath)}}G(s){return s.scheme==="file"?(0,R.$1z)(s.fsPath):s.toString()}async H(){if(!u.$j)return;E.app.clearRecentDocuments();const s=await this.getRecentlyOpened(),n=[];let i=0;for(let m=0;m<s.workspaces.length&&i<nt.u;m++){const P=this.p(s.workspaces[m]);if(P.scheme===f.Schemas.file){const I=(0,$.$Xf)(P);await p.Promises.exists(I)&&(n.push(I),i++)}}const a=[];for(let m=0;m<s.files.length&&i<nt.v;m++){const P=this.p(s.files[m]);if(P.scheme===f.Schemas.file){const I=(0,$.$Xf)(P);if(nt.y.includes((0,$.$7f)(P))||n.includes(I))continue;await p.Promises.exists(I)&&(a.push(I),i++)}}a.reverse().forEach(m=>E.app.addRecentDocument(m)),n.reverse().forEach(m=>E.app.addRecentDocument(m))}};e.$h4b=t,e.$h4b=t=pe([_(0,o.$Ri),_(1,k.$K3b),_(2,y.$h3b),_(3,g.$r3b)],t)}),define(te[302],ie([0,1,14,8,22,46,4,7,179,18,28,20,5,229,67,23,34,26,48,81,29,84]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i4b=void 0;const t="menu";let l=class Et{static{this.a="lastKnownMenubarData"}constructor(i,a,m,P,I,D,M,L,N,B,re){this.n=i,this.o=a,this.p=m,this.q=P,this.r=I,this.s=D,this.t=M,this.u=L,this.v=N,this.w=B,this.x=re,this.m=Object.create(null),this.g=new C.$Gg(()=>this.E(),0),this.h=new C.$Gg(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(R.$j||(0,b.$ED)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const i=this.t.getItem(Et.a);i&&(i.menus&&(this.k=i.menus),i.keybindings&&(this.l=i.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(D,M,L)=>this.p.openEmptyWindow({context:2,contextWindowId:M?.id}),this.m["workbench.action.newWindow"]=(D,M,L)=>this.p.openEmptyWindow({context:2,contextWindowId:M?.id}),this.m["workbench.action.files.openFileFolder"]=(D,M,L)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(L),telemetryExtraData:{from:t}}),this.m["workbench.action.files.openFolder"]=(D,M,L)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(L),telemetryExtraData:{from:t}}),this.m["workbench.action.openWorkspace"]=(D,M,L)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(L),telemetryExtraData:{from:t}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const i=this.x.youTubeUrl;i&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(i,"openYouTubeUrl"));const a=this.x.requestFeatureUrl;a&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(a,"openUserVoiceUrl"));const m=this.x.reportIssueUrl;m&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(m,"openReportIssues"));const P=this.x.licenseUrl;P&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(R.$v){const D=P.indexOf("?")>0?"&":"?";this.Z(`${P}${D}lang=${R.$v}`,"openLicenseUrl")}else this.Z(P,"openLicenseUrl")});const I=this.x.privacyStatementUrl;I&&P&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(I,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(i=>this.F(i)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const i=this.o.getValue("window.enableMenuBarMnemonics");return typeof i!="boolean"?!0:i}get C(){if(!R.$j)return!1;const i=this.o.getValue("window.nativeTabs");return typeof i!="boolean"?!1:i}updateMenu(i,a){this.k=i.menus,this.l=i.keybindings,this.t.setItem(Et.a,i),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(i){R.$j&&(i.oldCount===0&&i.newCount>0||i.oldCount>0&&i.newCount===0)&&(this.d=i.newCount===0,this.D())}G(){R.$j&&(this.f=!E.BrowserWindow.getFocusedWindow(),this.D())}H(){const i=E.Menu.getApplicationMenu();if(i&&this.j.push(i),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(R.$j?new E.Menu:null);return}const a=new E.Menu;let m;if(R.$j){const I=new E.Menu;m=new E.MenuItem({label:this.x.nameShort,submenu:I}),this.I(I),a.append(m)}if(R.$j&&!this.c){this.c=!0;const I=new E.Menu;I.append(new E.MenuItem({label:this.ab(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(I)}if(this.K("File")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(1,null)),submenu:I});this.M(I,"File"),a.append(D)}if(this.K("Edit")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(2,null)),submenu:I});this.M(I,"Edit"),a.append(D)}if(this.K("Selection")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(3,null)),submenu:I});this.M(I,"Selection"),a.append(D)}if(this.K("View")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(4,null)),submenu:I});this.M(I,"View"),a.append(D)}if(this.K("Go")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(5,null)),submenu:I});this.M(I,"Go"),a.append(D)}if(this.K("Run")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(6,null)),submenu:I});this.M(I,"Run"),a.append(D)}if(this.K("Terminal")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(7,null)),submenu:I});this.M(I,"Terminal"),a.append(D)}let P;if(this.K("Window")){const I=new E.Menu;P=new E.MenuItem({label:this.ab(f.localize(8,null)),submenu:I,role:"window"}),this.S(I)}if(P&&a.append(P),this.K("Help")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(9,null)),submenu:I,role:"help"});this.M(I,"Help"),a.append(D)}a.items&&a.items.length>0?E.Menu.setApplicationMenu(a):E.Menu.setApplicationMenu(null),this.h.schedule()}I(i){const a=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),m=this.T();let P;if(this.K("Preferences")){const ne=new E.Menu;this.M(ne,"Preferences"),P=new E.MenuItem({label:this.ab(f.localize(11,null)),submenu:ne})}const I=new E.Menu,D=new E.MenuItem({label:f.localize(12,null),role:"services",submenu:I}),M=new E.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),L=new E.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),N=new E.MenuItem({label:f.localize(15,null),role:"unhide"}),B=new E.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(ne,ue,se)=>{const le=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||E.BrowserWindow.getFocusedWindow()||le?.isMinimized())&&await this.J(se)&&this.w.quit(void 0)}})),re=[a];re.push(...m),P&&re.push(s(),P),re.push(s(),D,s(),M,L,N,s(),B),re.forEach(ne=>i.append(ne))}async J(i){if(this.p.getWindowCount()===0)return!0;const a=this.o.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.Q(i)){const{response:m}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return m===0}return!0}K(i){if(!R.$j&&(0,b.$ED)(this.o)==="custom")return!1;switch(i){case"File":case"Help":if(R.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[i];case"Window":if(R.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[i]}}L(i,a){a.forEach(m=>{if((0,h.$d4b)(m))i.append(s());else if((0,h.$c4b)(m)){const P=new E.Menu,I=new E.MenuItem({label:this.ab(m.label),submenu:P});this.L(P,m.submenu.items),i.append(I)}else(0,h.$e4b)(m)?i.append(this.O(m)):(0,h.$f4b)(m)&&(m.id==="workbench.action.showAboutDialog"&&this.N(i),R.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[m.id]?i.append(new E.MenuItem(this.Y(m.id,{label:this.ab(m.label),click:this.m[m.id]}))):i.append(this.U(m.label,m.id,!1,m.checked)):i.append(this.U(m.label,m.id,m.enabled!==!1,!!m.checked)):i.append(this.U(m.label,m.id,m.enabled!==!1,!!m.checked)))})}M(i,a){this.k&&this.k[a]&&this.L(i,this.k[a].items)}N(i){const a=this.T();a.length&&(a.forEach(m=>i.append(m)),i.append(s()))}O(i){const a=S.URI.revive(i.uri),m=i.id,P=m==="openRecentFile"?{fileUri:a}:m==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new E.MenuItem(this.Y(m,{label:i.label,click:async(I,D,M)=>{const L=this.P(M);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[P],forceNewWindow:L,gotoLineMode:!1,remoteAuthority:i.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([a])}},!1))}P(i){return!!(i&&(!R.$j&&(i.ctrlKey||i.shiftKey)||R.$j&&(i.metaKey||i.altKey)))}Q(i){return!!(i.triggeredByAccelerator||i.altKey||i.ctrlKey||i.metaKey||i.shiftKey)}R(i,a,m){const P={label:this.ab(i),role:m,enabled:!0};return new E.MenuItem(this.X(a,P))}S(i){const a=new E.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),m=new E.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),P=new E.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),I=this.U(f.localize(23,null),"workbench.action.switchWindow"),D=[];this.C&&(D.push(s()),D.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),D.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),D.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),D.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),D.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,m,s(),I,...D,s(),P].forEach(M=>i.append(M))}T(){switch(this.n.state.type){case"idle":return[new E.MenuItem({label:this.ab(f.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.ab(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.ab(f.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.ab(f.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(i,a,m,P){const I=this.ab(i),D=typeof a=="function"?a:(re,ne,ue)=>{const se=re?re.userSettingsLabel:null;let le=a;Array.isArray(a)&&(le=this.P(ue)?a[1]:a[0]),se&&ue.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:se}):this.W({type:"commandId",commandId:le})},M=typeof m=="boolean"?m:this.p.getWindowCount()>0,L=typeof P=="boolean"?P:!1,N={label:I,click:D,enabled:M};L&&(N.type="checkbox",N.checked=L);let B;return typeof a=="string"?B=a:Array.isArray(a)&&(B=a[0]),R.$j&&(B==="editor.action.clipboardCutAction"?N.role="cut":B==="editor.action.clipboardCopyAction"?N.role="copy":B==="editor.action.clipboardPasteAction"&&(N.role="paste"),B==="undo"?N.click=this.V(D,{inDevTools:re=>re.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):B==="redo"?N.click=this.V(D,{inDevTools:re=>re.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):B==="editor.action.selectAll"&&(N.click=this.V(D,{inDevTools:re=>re.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.X(B,N))}V(i,a){return(m,P,I)=>{const D=E.BrowserWindow.getFocusedWindow();if(!D)return a.inNoWindow();if(D.webContents.isDevToolsFocused()&&D.webContents.devToolsWebContents)return a.inDevTools(D.webContents.devToolsWebContents);i(m,P||D,I)}}W(i){let a=E.BrowserWindow.getFocusedWindow();if(!a){const P=this.p.getLastActiveWindow();P?.isMinimized()&&(a=P.win)}const m=a?this.p.getWindowById(a.id):void 0;if(m){if(this.v.trace("menubar#runActionInRenderer",i),R.$j&&!this.q.isBuilt&&!m.isReady&&(i.type==="commandId"&&i.commandId==="workbench.action.toggleDevTools"||i.type!=="commandId"&&i.userSettingsLabel==="alt+cmd+i"))return;if(i.type==="commandId"){const P={id:i.commandId,from:"menu"};m.sendWhenReady("vscode:runAction",r.CancellationToken.None,P)}else{const P={userSettingsLabel:i.userSettingsLabel};m.sendWhenReady("vscode:runKeybinding",r.CancellationToken.None,P)}}else this.v.trace("menubar#runActionInRenderer: no active window found",i)}X(i,a){const m=typeof i=="string"?this.l[i]:void 0;if(m?.label){if(m.isNative!==!1)a.accelerator=m.label,a.userSettingsLabel=m.userSettingsLabel;else if(typeof a.label=="string"){const P=a.label.indexOf("[");P>=0?a.label=`${a.label.substr(0,P)} [${m.label}]`:a.label=`${a.label} [${m.label}]`}}else a.accelerator=void 0;return a}Y(i,a,m=!a.accelerator){m&&(a=this.X(i,a));const P=a.click;return a.click=(I,D,M)=>{this.$(i),P?.(I,D,M)},a}Z(i,a){this.w.openExternal(void 0,i),this.$(a)}$(i){this.r.publicLog2("workbenchActionExecuted",{id:i,from:t})}ab(i){return(0,O.$6z)(i,!this.B)}};e.$i4b=l,e.$i4b=l=pe([_(0,c.$Gib),_(1,u.$Vh),_(2,k.$t3b),_(3,$.$f3b),_(4,g.$Vk),_(5,w.$g4b),_(6,o.$SM),_(7,d.$h3b),_(8,p.$Ri),_(9,v.$63b),_(10,y.$0i)],l);function s(){return new E.MenuItem({type:"separator"})}}),define(te[303],ie([0,1,6,20,5,302]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k4b=e.$j4b=void 0,e.$j4b=(0,E.$ph)("menubarMainService");let R=class{constructor(f,u,$){this.b=f,this.c=u,this.d=$,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(O.$i4b)}async updateMenubar(f,u){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(u,f)}};e.$k4b=R,e.$k4b=R=pe([_(0,E.$oh),_(1,C.$h3b),_(2,r.$Ri)],R)}),define(te[304],ie([0,1,14,21,132,27,24,22,3,32,49,46,2,15,9,65,4,36,19,10,7,189,64,18,61,28,16,6,20,5,78,79,60,34,81,301,130,297,30,99,84,54,80,39,53,66]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t,l,s,n,i,a,m,P,I,D,M,L,N,B,re,ne,ue,se,le,J,K,U,T,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K4b=void 0;function H(oe){return(0,ue.$Eh)(oe?.workspace)}function Q(oe){return(0,ue.$zh)(oe?.workspace)}let ce=class at extends p.$lb{static{this.a=[]}constructor(j,A,F,q,G,Z,z,Y,x,ae,he,Ie,Ee,Ae,Me,We,$e,be){super(),this.k=j,this.l=A,this.m=F,this.n=q,this.r=G,this.s=Z,this.t=z,this.u=Y,this.v=x,this.w=ae,this.z=he,this.C=Ie,this.D=Ee,this.F=Ae,this.G=Me,this.H=We,this.I=$e,this.J=be,this.b=this.B(new f.$8c),this.onDidOpenWindow=this.b.event,this.c=this.B(new f.$8c),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new f.$8c),this.onDidDestroyWindow=this.f.event,this.g=this.B(new f.$8c),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new f.$8c),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ne.$H4b(this,this.r,this.v,this.m,this.z)),this.L()}L(){this.B(this.D.onDidEnterWorkspace(j=>this.c.fire(j.window))),this.B(this.onDidSignalReadyWindow(j=>{if(j.config?.extensionDevelopmentPath||j.config?.extensionTestsPath){const A=new p.$kb;if(A.add(f.Event.any(j.onDidClose,j.onDidDestroy)(()=>A.dispose())),j.config.extensionDevelopmentPath)for(const F of j.config.extensionDevelopmentPath)A.add(this.I.addValidFileRoot(F));j.config.extensionTestsPath&&A.add(this.I.addValidFileRoot(j.config.extensionTestsPath))}}))}openEmptyWindow(j,A){const F=this.t.args,q=A?.remoteAuthority||void 0,G=!0,Z=A?.forceReuseWindow,z=!Z;return this.open({...j,cli:F,forceEmpty:G,forceNewWindow:z,forceReuseWindow:Z,remoteAuthority:q})}openExistingWindow(j,A){j.focus(),this.M(A,[j])}async open(j){this.m.trace("windowsManager#open"),j.addMode&&(j.initialStartup||!this.getLastActiveWindow())&&(j.addMode=!1);const A=[],F=[],q=[],G=[],Z=[];let z,Y=0;const x=await this.S(j);this.m.trace("windowsManager#open pathsToOpen",x);for(const Ae of x)Q(Ae)?j.addMode?A.push(Ae):F.push(Ae):H(Ae)?q.push(Ae):Ae.fileUri?(z||(z={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ae.remoteAuthority}),z.filesToOpenOrCreate.push(Ae)):Ae.backupPath?Z.push({backupFolder:(0,v.$ec)(Ae.backupPath),remoteAuthority:Ae.remoteAuthority}):Y++;j.diffMode&&z&&z.filesToOpenOrCreate.length>=2&&(z.filesToDiff=z.filesToOpenOrCreate.slice(0,2),z.filesToOpenOrCreate=[]),j.mergeMode&&z&&z.filesToOpenOrCreate.length===4&&(z.filesToMerge=z.filesToOpenOrCreate.slice(0,4),z.filesToOpenOrCreate=[],z.filesToDiff=[]),z&&j.waitMarkerFileURI&&(z.filesToWait={paths:(0,R.$mf)([...z.filesToDiff,z.filesToMerge[3],...z.filesToOpenOrCreate]),waitMarkerFileUri:j.waitMarkerFileURI}),j.initialStartup?(G.push(...this.D.getUntitledWorkspaces()),q.push(...G),Z.push(...this.w.getEmptyWindowBackups())):Z.length=0;const{windows:ae,filesOpenedInWindow:he}=await this.N(j,q,F,Z,Y,z,A);if(this.m.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${q.length}, foldersToOpen: ${F.length}, emptyToRestore: ${Z.length}, emptyToOpen: ${Y})`),ae.length>1)if(he)he.focus();else{const Ae=this.j.state.lastActiveWindow&&!j.forceEmpty&&!j.cli._.length&&!j.cli["file-uri"]&&!j.cli["folder-uri"]&&!(j.urisToOpen&&j.urisToOpen.length);let Me=!0,We=!0;if(Ae){const $e=ae.filter(be=>this.j.state.lastActiveWindow&&be.backupPath===this.j.state.lastActiveWindow.backupPath);$e.length&&($e[0].focus(),Me=!1,We=!1)}if(Me)for(let $e=ae.length-1;$e>=0;$e--){const be=ae[$e];if(!(be.openedWorkspace&&G.some(ee=>be.openedWorkspace&&ee.workspace.id===be.openedWorkspace.id)||be.backupPath&&Z.some(ee=>be.backupPath&&ee.backupFolder===(0,v.$ec)(be.backupPath)))){be.focus(),We=!1;break}}We&&ae[ae.length-1].focus()}const Ie=z&&z.filesToDiff.length>0,Ee=z&&z.filesToMerge.length>0;if(!ae.some(Ae=>Ae.isExtensionDevelopmentHost)&&!Ie&&!Ee&&!j.noRecentEntry){const Ae=[];for(const Me of x)H(Me)&&!Me.transient?Ae.push({label:Me.label,workspace:Me.workspace,remoteAuthority:Me.remoteAuthority}):Q(Me)?Ae.push({label:Me.label,folderUri:Me.workspace.uri,remoteAuthority:Me.remoteAuthority}):Me.fileUri&&Ae.push({label:Me.label,fileUri:Me.fileUri,remoteAuthority:Me.remoteAuthority});this.C.addRecentlyOpened(Ae)}return this.M(j,ae),ae}M(j,A){const F=j.waitMarkerFileURI;j.context===0&&F&&A.length===1&&A[0]&&(async()=>{await A[0].whenClosedOrLoaded;try{await this.H.del(F)}catch{}})()}async N(j,A,F,q,G,Z,z){const Y=[];let x;function ae($e,be){Y.push($e),be&&(x=$e,Z=void 0)}let{openFolderInNewWindow:he,openFilesInNewWindow:Ie}=this.fb(j);if(!j.initialStartup&&z.length>0){const $e=z[0].remoteAuthority,be=this.kb($e);be&&ae(this.P(be,z.map(ee=>ee.workspace.uri)))}const Ee=F.length+A.length+q.length;if(Z&&Ee===0){const $e=Z.filesToOpenOrCreate[0]||Z.filesToDiff[0]||Z.filesToMerge[3],be=this.getWindows().filter(fe=>Z&&(0,c.$cg)(fe.remoteAuthority,Z.remoteAuthority));let ee;$e?.fileUri&&!Ie&&((j.context===4||j.context===0||j.context===1)&&(ee=await(0,re.$H3b)(be,$e.fileUri,async fe=>fe.configPath.scheme===h.Schemas.file?this.D.resolveLocalWorkspace(fe.configPath):void 0)),ee||(ee=this.lb(be))),ee?(0,ue.$Eh)(ee.openedWorkspace)?A.push({workspace:ee.openedWorkspace,remoteAuthority:ee.remoteAuthority}):(0,ue.$zh)(ee.openedWorkspace)?F.push({workspace:ee.openedWorkspace,remoteAuthority:ee.remoteAuthority}):ae(this.O(j,ee,Z),!0):ae(await this.gb({userEnv:j.userEnv,cli:j.cli,initialStartup:j.initialStartup,filesToOpen:Z,forceNewWindow:!0,remoteAuthority:Z.remoteAuthority,forceNewTabbedWindow:j.forceNewTabbedWindow,forceProfile:j.forceProfile,forceTempProfile:j.forceTempProfile}),!0)}const Ae=(0,R.$rf)(A,$e=>$e.workspace.id);if(Ae.length>0){const $e=(0,R.$mf)(Ae.map(be=>(0,re.$I3b)(this.getWindows(),be.workspace.configPath)));if($e.length>0){const be=$e[0],ee=(0,c.$cg)(Z?.remoteAuthority,be.remoteAuthority)?Z:void 0;ae(this.O(j,be,ee),!!ee),he=!0}for(const be of Ae){if($e.some(ge=>ge.openedWorkspace&&ge.openedWorkspace.id===be.workspace.id))continue;const ee=be.remoteAuthority,fe=(0,c.$cg)(Z?.remoteAuthority,ee)?Z:void 0;ae(await this.R(j,be,he,fe),!!fe),he=!0}}const Me=(0,R.$rf)(F,$e=>c.$1f.getComparisonKey($e.workspace.uri));if(Me.length>0){const $e=(0,R.$mf)(Me.map(be=>(0,re.$I3b)(this.getWindows(),be.workspace.uri)));if($e.length>0){const be=$e[0],ee=(0,c.$cg)(Z?.remoteAuthority,be.remoteAuthority)?Z:void 0;ae(this.O(j,be,ee),!!ee),he=!0}for(const be of Me){if($e.some(ge=>(0,ue.$zh)(ge.openedWorkspace)&&c.$1f.isEqual(ge.openedWorkspace.uri,be.workspace.uri)))continue;const ee=be.remoteAuthority,fe=(0,c.$cg)(Z?.remoteAuthority,ee)?Z:void 0;ae(await this.R(j,be,he,fe),!!fe),he=!0}}const We=(0,R.$rf)(q,$e=>$e.backupFolder);if(We.length>0)for(const $e of We){const be=$e.remoteAuthority,ee=(0,c.$cg)(Z?.remoteAuthority,be)?Z:void 0;ae(await this.Q(j,!0,be,ee,$e),!!ee),he=!0}if(Y.length===0||Z){Z&&!G&&G++;const $e=Z?Z.remoteAuthority:j.remoteAuthority;for(let be=0;be<G;be++)ae(await this.Q(j,he,$e,Z),!!Z),he=!0}return{windows:(0,R.$rf)(Y),filesOpenedInWindow:x}}O(j,A,F){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:F}),A.focus();const q={filesToOpenOrCreate:F?.filesToOpenOrCreate,filesToDiff:F?.filesToDiff,filesToMerge:F?.filesToMerge,filesToWait:F?.filesToWait,termProgram:j?.userEnv?.TERM_PROGRAM};return A.sendWhenReady("vscode:openFiles",S.CancellationToken.None,q),A}P(j,A){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:A}),j.focus();const F={foldersToAdd:A};return j.sendWhenReady("vscode:addFolders",S.CancellationToken.None,F),j}Q(j,A,F,q,G){this.m.trace("windowsManager#doOpenEmpty",{restore:!!G,remoteAuthority:F,filesToOpen:q,forceNewWindow:A});let Z;return!A&&typeof j.contextWindowId=="number"&&(Z=this.getWindowById(j.contextWindowId)),this.gb({userEnv:j.userEnv,cli:j.cli,initialStartup:j.initialStartup,remoteAuthority:F,forceNewWindow:A,forceNewTabbedWindow:j.forceNewTabbedWindow,filesToOpen:q,windowToUse:Z,emptyWindowBackupInfo:G,forceProfile:j.forceProfile,forceTempProfile:j.forceTempProfile})}R(j,A,F,q,G){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:A,filesToOpen:q}),!F&&!G&&typeof j.contextWindowId=="number"&&(G=this.getWindowById(j.contextWindowId)),this.gb({workspace:A.workspace,userEnv:j.userEnv,cli:j.cli,initialStartup:j.initialStartup,remoteAuthority:A.remoteAuthority,forceNewWindow:F,forceNewTabbedWindow:j.forceNewTabbedWindow,filesToOpen:q,windowToUse:G,forceProfile:j.forceProfile,forceTempProfile:j.forceTempProfile})}async S(j){let A,F=!1,q=!1;if(j.urisToOpen&&j.urisToOpen.length>0?(A=await this.U(j),F=!0):j.forceEmpty?A=[Object.create(null)]:j.cli._.length||j.cli["folder-uri"]||j.cli["file-uri"]?(A=await this.W(j.cli),A.length===0&&A.push(Object.create(null)),F=!0):(A=await this.Y(),A.length===0&&A.push(Object.create(null)),q=!0),!j.addMode&&F){const G=A.filter(Z=>Q(Z));if(G.length>1){const Z=G[0].remoteAuthority;if(G.every(z=>(0,c.$cg)(z.remoteAuthority,Z))){const z=await this.D.createUntitledWorkspace(G.map(Y=>({uri:Y.workspace.uri})));A.push({workspace:z,remoteAuthority:Z}),A=A.filter(Y=>!Q(Y))}}}if(j.initialStartup&&!q&&this.z.getValue("window")?.restoreWindows==="preserve"){const G=await this.Y();A.unshift(...G.filter(Z=>H(Z)||Q(Z)||Z.backupPath))}return A}async U(j){const A={gotoLineMode:j.gotoLineMode,remoteAuthority:j.remoteAuthority},F=await Promise.all((0,R.$mf)(j.urisToOpen||[]).map(async q=>{const G=await this.$(q,A);if(G)return G.label=q.label,G;const Z=this.bb(q);this.G.showMessageBox({type:"info",buttons:[(0,w.localize)(0,null)],message:Z.scheme===h.Schemas.file?(0,w.localize)(1,null):(0,w.localize)(2,null),detail:Z.scheme===h.Schemas.file?(0,w.localize)(3,null,(0,d.$Zz)(Z,{os:o.OS,tildify:this.t})):(0,w.localize)(4,null,Z.toString(!0))},(0,b.$Be)(E.BrowserWindow.getFocusedWindow()))}));return(0,R.$mf)(F)}async W(j){const A=[],F={ignoreFileNotFound:!0,gotoLineMode:j.goto,remoteAuthority:j.remote||void 0,forceOpenWorkspaceAsFile:j.diff&&j._.length===2||j.merge&&j._.length===4},q=j["folder-uri"];if(q){const z=await Promise.all(q.map(Y=>{const x=this.X(Y);if(x)return this.$({folderUri:x},F)}));A.push(...(0,R.$mf)(z))}const G=j["file-uri"];if(G){const z=await Promise.all(G.map(Y=>{const x=this.X(Y);if(x)return this.$((0,ue.$Uh)(Y)?{workspaceUri:x}:{fileUri:x},F)}));A.push(...(0,R.$mf)(z))}const Z=await Promise.all(j._.map(z=>F.remoteAuthority?this.eb(z,F):this.cb(z,F)));return A.push(...(0,R.$mf)(Z)),A}X(j){try{const A=k.URI.parse(j);if(!A.scheme){this.m.error(`Invalid URI input string, scheme missing: ${j}`);return}return A.path?A:A.with({path:"/"})}catch(A){this.m.error(`Invalid URI input string: ${j}, ${A.message}`)}}async Y(){const j=this.Z();switch(j){case"none":return[];case"one":case"all":case"preserve":case"folders":{const A=[];j!=="one"&&A.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&A.push(this.j.state.lastActiveWindow);const F=await Promise.all(A.map(async q=>{if(q.workspace){const G=await this.$({workspaceUri:q.workspace.configPath},{remoteAuthority:q.remoteAuthority,rejectTransientWorkspaces:!0});if(H(G))return G}else if(q.folderUri){const G=await this.$({folderUri:q.folderUri},{remoteAuthority:q.remoteAuthority});if(Q(G))return G}else if(j!=="folders"&&q.backupPath)return{backupPath:q.backupPath,remoteAuthority:q.remoteAuthority}}));return(0,R.$mf)(F)}}}Z(){let j;return this.v.wasRestarted?j="all":(j=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(j)||(j="all")),j}async $(j,A=Object.create(null)){const F=this.bb(j);return F.scheme===h.Schemas.file?((0,N.$CD)(j)&&(A={...A,forceOpenWorkspaceAsFile:!0}),this.cb(F.fsPath,A)):this.ab(j,A)}ab(j,A){let F=this.bb(j);const q=(0,M.$Bk)(F)||A.remoteAuthority;if(F=(0,c.$eg)((0,c.$$f)(F)),(0,N.$CD)(j)){if(A.gotoLineMode){const{path:G,line:Z,column:z}=(0,u.$Re)(F.path);return{fileUri:F.with({path:G}),options:{selection:Z?{startLineNumber:Z,startColumn:z||1}:void 0},remoteAuthority:q}}return{fileUri:F,remoteAuthority:q}}else if((0,N.$AD)(j))return{workspace:(0,se.$A3b)(F),remoteAuthority:q};return{workspace:(0,se.$B3b)(F),remoteAuthority:q}}bb(j){return(0,N.$AD)(j)?j.workspaceUri:(0,N.$BD)(j)?j.folderUri:j.fileUri}async cb(j,A,F){let q,G;A.gotoLineMode&&({path:j,line:q,column:G}=(0,u.$Re)(j)),j=(0,u.$Me)((0,v.$$b)(j),(0,g.cwd)());try{const Z=await C.Promises.stat(j);if(Z.isFile()){if(!A.forceOpenWorkspaceAsFile){const z=await this.D.resolveLocalWorkspace(k.URI.file(j));if(z)return z.transient&&A.rejectTransientWorkspaces?void 0:{workspace:{id:z.id,configPath:z.configPath},type:i.FileType.File,exists:!0,remoteAuthority:z.remoteAuthority,transient:z.transient}}return{fileUri:k.URI.file(j),type:i.FileType.File,exists:!0,options:{selection:q?{startLineNumber:q,startColumn:G||1}:void 0}}}else{if(Z.isDirectory())return{workspace:(0,se.$B3b)(k.URI.file(j),Z),type:i.FileType.Directory,exists:!0};if(!o.$i&&j==="/dev/null")return{fileUri:k.URI.file(j),type:i.FileType.File,exists:!0}}}catch(Z){if(Z.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!F)return this.db(j,A);const z=k.URI.file(j);if(this.C.removeRecentlyOpened([z]),A.ignoreFileNotFound)return{fileUri:z,type:i.FileType.File,exists:!1}}}async db(j,A){const F=k.URI.file(j),{response:q,checkboxChecked:G}=await this.G.showMessageBox({type:"warning",buttons:[(0,w.localize)(5,null),(0,w.localize)(6,null),(0,w.localize)(7,null)],message:(0,w.localize)(8,null,F.authority),detail:(0,w.localize)(9,null,(0,d.$Zz)(F,{os:o.OS,tildify:this.t})),checkboxLabel:(0,w.localize)(10,null,F.authority),cancelId:1});if(q===0)return(0,r.addUNCHostToAllowlist)(F.authority),G&&this.B(f.Event.once(this.onDidOpenWindow)(Z=>{Z.sendWhenReady("vscode:configureAllowedUNCHost",S.CancellationToken.None,F.authority)})),this.cb(j,A,!0);if(q===2)return E.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.db(j,A)}eb(j,A){const F=j.charCodeAt(0),q=A.remoteAuthority;let G,Z;A.gotoLineMode&&({path:j,line:G,column:Z}=(0,u.$Re)(j)),F!==47&&((0,u.$Le)(F)&&j.charCodeAt(j.charCodeAt(1))===58&&(j=(0,u.$Ee)(j)),j=`/${j}`);const z=k.URI.from({scheme:h.Schemas.vscodeRemote,authority:q,path:j});if(j.charCodeAt(j.length-1)!==47){if((0,ue.$Uh)(j))return A.forceOpenWorkspaceAsFile?{fileUri:z,options:{selection:G?{startLineNumber:G,startColumn:Z||1}:void 0},remoteAuthority:A.remoteAuthority}:{workspace:(0,se.$A3b)(z),remoteAuthority:q};if(A.gotoLineMode||v.$0b.basename(j).indexOf(".")!==-1)return{fileUri:z,options:{selection:G?{startLineNumber:G,startColumn:Z||1}:void 0},remoteAuthority:q}}return{workspace:(0,se.$B3b)(z),remoteAuthority:q}}fb(j){const A=this.z.getValue("window"),F=A?.openFoldersInNewWindow||"default",q=A?.openFilesInNewWindow||"off";let G=(j.preferNewWindow||j.forceNewWindow)&&!j.forceReuseWindow;!j.forceNewWindow&&!j.forceReuseWindow&&(F==="on"||F==="off")&&(G=F==="on");let Z=!1;return j.forceNewWindow||j.forceReuseWindow?Z=!!j.forceNewWindow&&!j.forceReuseWindow:(o.$j?j.context===1&&(Z=!0):j.context!==3&&j.context!==2&&!(j.userEnv&&j.userEnv.TERM_PROGRAM==="vscode")&&(Z=!0),!j.cli.extensionDevelopmentPath&&(q==="on"||q==="off")&&(Z=q==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:Z}}async openExtensionDevelopmentHostWindow(j,A){const F=(0,re.$J3b)(this.getWindows(),j);if(F)return this.v.reload(F,A.cli),F.focus(),[F];let q=A.cli["folder-uri"]||[],G=A.cli["file-uri"]||[],Z=A.cli._;if(!Z.length&&!q.length&&!G.length&&!A.cli.extensionTestsPath){const x=this.j.state.lastPluginDevelopmentHostWindow,ae=x?.workspace??x?.folderUri;ae&&(k.URI.isUri(ae)?ae.scheme===h.Schemas.file?Z=[ae.fsPath]:q=[ae.toString()]:ae.configPath.scheme===h.Schemas.file?Z=[(0,c.$Xf)(ae.configPath)]:G=[ae.configPath.toString()])}let z=A.remoteAuthority;for(const x of j)if(x.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ae=k.URI.parse(x),he=(0,M.$Bk)(ae);he&&(z?(0,c.$cg)(he,z)||this.m.error("more than one extension development path authority"):z=he)}Z=Z.filter(x=>{const ae=k.URI.file(x);return(0,re.$I3b)(this.getWindows(),ae)?!1:(0,c.$cg)((0,M.$Bk)(ae),z)}),q=q.filter(x=>{const ae=this.X(x);return ae&&(0,re.$I3b)(this.getWindows(),ae)?!1:ae?(0,c.$cg)((0,M.$Bk)(ae),z):!1}),G=G.filter(x=>{const ae=this.X(x);return ae&&(0,re.$I3b)(this.getWindows(),ae)?!1:ae?(0,c.$cg)((0,M.$Bk)(ae),z):!1}),A.cli._=Z,A.cli["folder-uri"]=q,A.cli["file-uri"]=G;const Y={context:A.context,cli:A.cli,forceNewWindow:!0,forceEmpty:!Z.length&&!q.length&&!G.length,userEnv:A.userEnv,noRecentEntry:!0,waitMarkerFileURI:A.waitMarkerFileURI,remoteAuthority:z,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile};return this.open(Y)}async gb(j){const A=this.z.getValue("window"),F=this.getLastActiveWindow(),q=F?.profile??this.u.defaultProfile;let G;!j.forceNewWindow&&!j.forceNewTabbedWindow&&(G=j.windowToUse||F,G&&G.focus());const Z={...this.t.args,...j.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:j.emptyWindowBackupInfo?(0,v.$ac)(this.t.backupHome,j.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.u.profilesHome,all:this.u.profiles,profile:q},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:j.remoteAuthority,workspace:j.workspace,userEnv:{...this.l,...j.userEnv},filesToOpenOrCreate:j.filesToOpen?.filesToOpenOrCreate,filesToDiff:j.filesToOpen?.filesToDiff,filesToMerge:j.filesToOpen?.filesToMerge,filesToWait:j.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsHome.fsPath,product:I.default,isInitialStartup:j.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,O.release)(),hostname:(0,O.hostname)(),arch:(0,O.arch)()},zoomLevel:typeof A?.zoomLevel=="number"?A.zoomLevel:void 0,autoDetectHighContrast:A?.autoDetectHighContrast??!0,autoDetectColorScheme:A?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn};if(G){const z=G.config;!Z.extensionDevelopmentPath&&z?.extensionDevelopmentPath&&(Z.extensionDevelopmentPath=z.extensionDevelopmentPath,Z.extensionDevelopmentKind=z.extensionDevelopmentKind,Z["enable-proposed-api"]=z["enable-proposed-api"],Z.verbose=z.verbose,Z["inspect-extensions"]=z["inspect-extensions"],Z["inspect-brk-extensions"]=z["inspect-brk-extensions"],Z.debugId=z.debugId,Z.extensionEnvironment=z.extensionEnvironment,Z["extensions-dir"]=z["extensions-dir"],Z["disable-extensions"]=z["disable-extensions"]),Z.loggers={global:Z.loggers.global,window:z?.loggers.window??Z.loggers.window}}else{const z=this.j.getNewWindowState(Z);(0,y.mark)("code/willCreateCodeWindow");const Y=G=this.F.createInstance(B.$G4b,{state:z,extensionDevelopmentPath:Z.extensionDevelopmentPath,isExtensionTestHost:!!Z.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),j.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(Y),at.a.push(Y),this.b.fire(Y),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,$.$cb)(Y.onDidSignalReady)(()=>this.c.fire(Y)),(0,$.$cb)(Y.onDidClose)(()=>this.jb(Y)),(0,$.$cb)(Y.onDidDestroy)(()=>this.f.fire(Y)),Y.onDidTriggerSystemContextMenu(({x:ae,y:he})=>this.h.fire({window:Y,x:ae,y:he}));const x=(0,b.$ue)(Y.win?.webContents);x.removeAllListeners("devtools-reload-page"),x.on("devtools-reload-page",()=>this.v.reload(Y)),this.v.registerWindow(Y)}return Z.windowId=G.id,G.isReady?this.v.unload(G,4).then(async z=>{z||await this.hb(G,Z,j,q)}):await this.hb(G,Z,j,q),G}async hb(j,A,F,q){if(A.extensionDevelopmentPath||((0,ue.$Eh)(A.workspace)?A.backupPath=this.w.registerWorkspaceBackup({workspace:A.workspace,remoteAuthority:A.remoteAuthority}):(0,ue.$zh)(A.workspace)?A.backupPath=this.w.registerFolderBackup({folderUri:A.workspace.uri,remoteAuthority:A.remoteAuthority}):A.backupPath=this.w.registerEmptyWindowBackup({backupFolder:F.emptyWindowBackupInfo?.backupFolder??(0,se.$C3b)().id,remoteAuthority:A.remoteAuthority})),this.u.isEnabled()){const G=A.workspace??(0,ue.$Dh)(A.backupPath,!1),Z=this.ib(F,G,q),z=Z instanceof Promise?await Z:Z;A.profiles.profile=z,A.extensionDevelopmentPath||await this.u.setProfileForWorkspace(G,z)}j.load(A)}ib(j,A,F){return j.forceProfile?this.u.profiles.find(q=>q.name===j.forceProfile)??this.u.createNamedProfile(j.forceProfile):j.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(A)??F}jb(j){const A=at.a.indexOf(j);at.a.splice(A,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const j=E.BrowserWindow.getFocusedWindow();if(j)return this.getWindowById(j.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(j){return this.lb(this.getWindows().filter(A=>(0,c.$cg)(A.remoteAuthority,j)))}lb(j){const A=Math.max.apply(Math,j.map(F=>F.lastFocusTime));return j.find(F=>F.lastFocusTime===A)}sendToFocused(j,...A){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(j,S.CancellationToken.None,...A)}sendToAll(j,A,F){for(const q of this.getWindows())F&&F.indexOf(q.id)>=0||q.sendWhenReady(j,S.CancellationToken.None,A)}getWindows(){return at.a}getWindowCount(){return at.a.length}getWindowById(j){const A=this.getWindows().filter(F=>F.id===j);return(0,R.$vf)(A)}getWindowByWebContents(j){const A=E.BrowserWindow.fromWebContents(j);if(A)return this.getWindowById(A.id)}};e.$K4b=ce,e.$K4b=ce=pe([_(2,P.$Ri),_(3,W.$l4b),_(4,L.$SM),_(5,U.$Vm),_(6,n.$f3b),_(7,T.$n3b),_(8,m.$h3b),_(9,t.$y3b),_(10,l.$Vh),_(11,le.$g4b),_(12,J.$K3b),_(13,a.$oh),_(14,s.$F3b),_(15,i.$Sj),_(16,D.$83b),_(17,K.$23b)],ce)}),define(te[305],ie([0,1,64,29,84,54]),function(V,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M4b=void 0;let R=class{constructor(f,u,$,d){this.a=f,this.b=u,this.c=$,this.d=d,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,u){const $=this.b.getWindowById(f);if($)return this.a.enterWorkspace($,this.b.getWindows(),u)}createUntitledWorkspace(f,u,$){return this.a.createUntitledWorkspace(u,$)}deleteUntitledWorkspace(f,u){return this.a.deleteUntitledWorkspace(u)}getWorkspaceIdentifier(f,u){return this.a.getWorkspaceIdentifier(u)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,u){return this.c.addRecentlyOpened(u)}removeRecentlyOpened(f,u){return this.c.removeRecentlyOpened(u)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$M4b=R,e.$M4b=R=pe([_(0,O.$K3b),_(1,C.$t3b),_(2,r.$g4b),_(3,E.$y3b)],R)}),define(te[306],ie([0,1,14,132,38,27,17,50,13,32,49,44,46,2,15,9,4,10,7,31,146,42,157,110,289,160,64,285,18,76,198,91,133,61,115,218,28,63,95,207,233,208,293,117,209,210,16,222,94,75,6,93,216,298,286,274,20,5,303,67,23,60,294,96,34,277,83,122,26,249,251,52,48,264,290,299,291,300,127,266,267,268,271,275,29,304,276,30,98,84,305,54,273,39,231,53,243,51,82,129,279,292,282,8,253,278,226,66,92,296,270,24,125,295,261,238,85]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t,l,s,n,i,a,m,P,I,D,M,L,N,B,re,ne,ue,se,le,J,K,U,T,W,H,Q,ce,oe,j,A,F,q,G,Z,z,Y,x,ae,he,Ie,Ee,Ae,Me,We,$e,be,ee,fe,ge,Se,Ce,je,Oe,ze,Te,He,Be,X,de,me,ve,ye,Re,Fe,qe,Ge,xe,Ye,Qe,tt,ot,ct,Ct,gt,Ot,Mt,Lt,jt,Ft,Ut,Nt,$t,Tt,Wt,zt,Bt,qt,mt,Ht,St,bt,Vt,Gt,wt,Jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$44b=void 0;let pt=class extends h.$lb{constructor(Pe,ke,we,Le,De,Ne,Ke,Xe,Ue,Ve,Je,Ze){super(),this.c=Pe,this.f=ke,this.g=we,this.h=Le,this.i=De,this.j=Ne,this.k=Ke,this.l=Xe,this.m=Ue,this.n=Ve,this.p=Je,this.s=Ze,this.t(),this.u()}t(){const Pe=Ue=>Ue?.startsWith(`${v.Schemas.vscodeWebview}://`),ke=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Ue,Ve,Je,Ze)=>Pe(Ze.requestingUrl)?Je(ke.has(Ve)):Je(!1)),E.session.defaultSession.setPermissionCheckHandler((Ue,Ve,Je,Ze)=>Pe(Ze.requestingUrl)?ke.has(Ve):!1);const we=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,v.Schemas.vscodeManagedRemoteResource,"devtools"]),Le=Ue=>{for(let Ve=Ue;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1},De=Ue=>Ue.resourceType==="xhr"||Le(Ue.frame),Ne=Ue=>{const Ve=Ue.frame;if(!Ve||!this.a)return!1;const Je=E.BrowserWindow.getAllWindows();for(const Ze of Je)if(Ve.processId===Ze.webContents.mainFrame.processId)return!0;return!1},Ke=(Ue,Ve)=>{if(Ue.path!=="/index.html")return!0;const Je=Ve.frame;if(!Je||!this.a)return!1;for(const Ze of this.a.getWindows())if(Ze.win&&Je.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Ue,Ve)=>{const Je=c.URI.parse(Ue.url);return Je.scheme===v.Schemas.vscodeWebview&&!Ke(Je,Ue)?(this.h.error("Blocked vscode-webview request",Ue.url),Ve({cancel:!0})):Je.scheme===v.Schemas.vscodeFileResource&&!Ne(Ue)?(this.h.error("Blocked vscode-file request",Ue.url),Ve({cancel:!0})):Je.path.endsWith(".svg")&&!we.has(Je.scheme)?Ve({cancel:!De(Ue)}):Ve({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Ue,Ve)=>{const Je=Ue.responseHeaders,Ze=Je["content-type"]||Je["Content-Type"];if(Ze&&Array.isArray(Ze)){const _e=c.URI.parse(Ue.url);if(_e.path.endsWith(".svg")&&we.has(_e.scheme))return Je["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Je});if(!_e.path.endsWith(v.Schemas.vscodeRemoteResource)&&Ze.some(st=>st.toLowerCase().includes("image/svg")))return Ve({cancel:!De(Ue)})}return Ve({cancel:!1})});const Xe=E.session.defaultSession;typeof Xe.setCodeCachePath=="function"&&this.j.codeCachePath&&Xe.setCodeCachePath((0,y.$ac)(this.j.codeCachePath,"chrome")),o.$i&&(this.l.getValue("security.restrictUNCAccess")===!1?(0,C.disableUNCAccessRestrictions)():(0,C.addUNCHostToAllowlist)(this.l.getValue("security.allowedUNCHosts")))}u(){(0,f.setUnexpectedErrorHandler)(we=>this.w(we)),process.on("uncaughtException",we=>{(0,f.$X)(we)||(0,f.$Y)(we)}),process.on("unhandledRejection",we=>(0,f.$Y)(we)),this.k.onWillShutdown(()=>this.dispose()),(0,k.$pS)(),E.app.on("accessibility-support-changed",(we,Le)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Le)}),E.app.on("activate",async(we,Le)=>{this.h.trace("app#activate"),Le||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(we,Le)=>{Le.on("will-navigate",De=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),Le.setWindowOpenHandler(({url:De})=>(this.b?.openExternal(void 0,De),{action:"deny"}))});let Pe=[],ke;E.app.on("open-file",(we,Le)=>{this.h.trace("app#open-file: ",Le),we.preventDefault(),Pe.push((0,Ge.$Uh)(Le)?{workspaceUri:c.URI.file(Le)}:{fileUri:c.URI.file(Le)}),ke!==void 0&&(clearTimeout(ke),ke=void 0),ke=setTimeout(async()=>{await this.a?.open({context:1,cli:this.j.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],ke=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),r.$oS.handle("vscode:fetchShellEnv",we=>{const Le=this.a?.getWindowByWebContents(we.sender);let De,Ne;return Le?.config?(De=Le.config,Ne={...process.env,...Le.config.userEnv}):(De=this.j.args,Ne=process.env),this.O(De,Ne,!1)}),r.$oS.handle("vscode:writeNlsFile",(we,Le,De)=>{const Ne=this.v([Le]);if(!Ne||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.n.writeFile(Ne,R.$Jb.fromString(De))}),r.$oS.handle("vscode:readNlsFile",async(we,...Le)=>{const De=this.v(Le);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.n.readFile(De)).value.toString()}),r.$oS.on("vscode:toggleDevTools",we=>we.sender.toggleDevTools()),r.$oS.on("vscode:openDevTools",we=>we.sender.openDevTools()),r.$oS.on("vscode:reloadWindow",we=>we.sender.reload())}v(Pe){let ke;for(const we of Pe)typeof we=="string"&&(typeof ke!="string"?ke=we:ke=(0,y.$ac)(ke,we));if(!(typeof ke!="string"||!(0,y.$_b)(ke)||!(0,u.$Ke)(ke,this.j.cachedLanguagesPath,!o.$k)))return c.URI.file(ke)}w(Pe){if(Pe){const ke={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(ke))}this.h.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.h.error(Pe.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.j.appRoot}`),this.h.debug("args:",this.j.args);const Pe=this.p.win32AppUserModelId;o.$i&&Pe&&E.app.setAppUserModelId(Pe);try{o.$j&&this.l.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ue){this.h.error(Ue)}const ke=new t.$vS;this.k.onWillShutdown(Ue=>{Ue.reason===2&&ke.dispose()}),this.h.trace("Resolving machine identifier...");const we=await(0,Tt.$U4b)(this.m,this.h);this.h.trace(`Resolved machine identifier: ${we}`);const{sharedProcessReady:Le,sharedProcessClient:De}=this.H(we),Ne=await this.I(we,Le);this.B(Ne.createInstance(s.$u3b)),this.B(Ne.createInstance(Ut.$R4b)),Ne.invokeFunction(Ue=>this.J(Ue,ke,De));const Ke=Ne.invokeFunction(Ue=>this.y(Ue,ke));this.z(ke),this.k.phase=2,await Ne.invokeFunction(Ue=>this.L(Ue,Ke)),this.k.phase=3,this.M(),this.B(new $t.$Gg(()=>{this.B((0,$t.$Kg)(()=>this.k.phase=4,2500))},2500)).schedule()}y(Pe,ke){const we=this.a=Pe.get(Re.$t3b),Le=Pe.get(Be.$rjb),De=this.b=Pe.get(ae.$63b),Ne=this;Le.registerHandler({async handleURL(Ze,_e){return Ne.G(we,Le,Ze,_e)}});const Ke=this.B(new qe.$L4b({onDidOpenWindow:De.onDidOpenWindow,onDidFocusWindow:De.onDidFocusWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Xe=new w.$0g(Ze=>Ke.getActiveClientId().then(_e=>Ze===_e)),Ue=new X.$B4b(Xe,this.h),Ve=ke.getChannel("urlHandler",Ue);Le.registerHandler(new X.$A4b(Ve));const Je=this.C();return this.B(new me.$C4b(Je?.urls,Le,we,this.j,this.p,this.h)),Je}z(Pe){const ke=()=>({statusCode:404,data:"Not found"}),we=new Jt.$T(()=>Pe.getChannel(wt.$24b,new wt.$34b));E.protocol.registerBufferProtocol(v.Schemas.vscodeManagedRemoteResource,(Le,De)=>{const Ne=c.URI.parse(Le.url);if(!Ne.authority.startsWith("window:"))return De(ke());we.value.call(wt.$14b,[Ne]).then(Ke=>De({...Ke,data:Buffer.from(Ke.body,"base64")}),Ke=>{this.h.warn("error dispatching remote resource call",Ke),De({statusCode:500,data:String(Ke)})})})}C(){const Pe=this.j.args["open-url"]?this.j.args._urls||[]:[];Pe.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Pe);const ke=global.getOpenUrls()||[];if(ke.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",ke),Pe.length+ke.length===0)return;const we=[];return{urls:[...Pe,...ke].map(De=>{try{return{uri:c.URI.parse(De),originalUrl:De}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",De);return}}).filter(De=>{if(!De)return!1;if(this.D(De.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",De.uri.toString(!0)),!1;const Ne=this.F(De.uri);return Ne?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",De.uri.toString(!0),Ne),we.push(Ne),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",De.uri.toString(!0)),!0)}),openables:we}}D(Pe){if(Pe.authority===v.Schemas.file&&o.$i){const{options:ke,buttonIndeces:we}=(0,qt.$bA)({type:"warning",buttons:[(0,n.localize)(0,null),(0,n.localize)(1,null)],message:(0,n.localize)(2,null,(0,p.$Zz)(Pe,{os:o.OS,tildify:this.j}),this.p.nameShort),detail:(0,n.localize)(3,null)},this.p);if(we[E.dialog.showMessageBoxSync(ke)]===1)return!0}return!1}F(Pe){if(Pe.path){if(Pe.authority===v.Schemas.file){const ke=c.URI.file(Pe.fsPath);return(0,Ge.$Uh)(ke)?{workspaceUri:ke}:{fileUri:ke}}else if(Pe.authority===v.Schemas.vscodeRemote){const ke=Pe.path.indexOf(y.$0b.sep,1);if(ke!==-1){const we=Pe.path.substring(1,ke),Le=Pe.path.substring(ke),De=c.URI.from({scheme:v.Schemas.vscodeRemote,authority:we,path:Le,query:Pe.query,fragment:Pe.fragment});return(0,Ge.$Uh)(Le)?{workspaceUri:De}:/:[\d]+$/.test(Le)?{fileUri:De}:{folderUri:De}}}}}async G(Pe,ke,we,Le){if(this.h.trace("app#handleProtocolUrl():",we.toString(!0),Le),we.scheme===this.p.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:c.URI.parse(we.query).path,query:""})),this.D(we))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0;let De=!1;const Ne=new URLSearchParams(we.query);Ne.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),Ne.delete("windowId"),we=we.with({query:Ne.toString()}),De=!0):o.$j&&Pe.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),De=!0);const Ke=Ne.get("continueOn");Ke!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),Ne.delete("continueOn"),we=we.with({query:Ne.toString()}),this.j.continueOn=Ke??void 0);const Xe=this.F(we);return Xe?(this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Xe,we.toString(!0)),(0,St.$vf)(await Pe.open({context:5,cli:{...this.j.args},urisToOpen:[Xe],forceNewWindow:De,gotoLineMode:!0}))?.focus(),!0):De?(this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,St.$vf)(await Pe.open({context:5,cli:{...this.j.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ie.$Bk)(we)}))?.ready(),ke.open(we,Le)):(this.h.trace("app#handleProtocolUrl(): not handled",we.toString(!0),Le),!1)}H(Pe){const ke=this.B(this.g.createInstance(Ee.$n4b,Pe)),we=(async()=>{this.h.trace("Main->SharedProcess#connect");const De=await ke.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new l.$wS(De,"main")})();return{sharedProcessReady:(async()=>(await ke.whenReady(),we))(),sharedProcessClient:we}}async I(Pe,ke){const we=new A.$nh;switch(process.platform){case"win32":we.set(Ce.$Gib,new oe.$mh(He.$y4b));break;case"linux":o.$l?we.set(Ce.$Gib,new oe.$mh(Te.$x4b,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(Ce.$Gib,new oe.$mh(ze.$w4b));break;case"darwin":we.set(Ce.$Gib,new oe.$mh(Oe.$v4b));break}we.set(Re.$t3b,new oe.$mh(Fe.$K4b,[Pe,this.f],!1));const Le=new L.$G3b(this.h,this.p);we.set(L.$F3b,Le),we.set(Z.$a4b,new oe.$mh(Z.$b4b,void 0,!1)),we.set(M.$P3b,new oe.$mh(M.$Q3b,void 0,!1)),we.set(D.$5l,w.ProxyChannel.toService((0,w.$8g)(ke.then(Ue=>Ue.getChannel("diagnostics"))))),we.set(F.$vrb,new oe.$mh(q.$93b,[this.f])),we.set(N.$kqb,new oe.$mh(B.$R3b)),we.set(G.$03b,new oe.$mh(G.$$3b)),we.set(ae.$63b,new oe.$mh(ae.$73b,void 0,!1)),we.set(P.$nn,new oe.$mh(ot.$N4b)),we.set(ve.$D4b,new oe.$mh(ye.$F4b)),we.set(x.$j4b,new oe.$mh(x.$k4b)),we.set(se.$sjb,new oe.$mh(le.$S3b)),we.set(J.$T3b,new oe.$mh(K.$V3b)),we.set($e.$p3b,new oe.$mh($e.$q3b)),we.set($e.$r3b,new oe.$mh($e.$s3b));const De=new Vt.$Z4b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.l.getValue("terminal.integrated.persistentSessionScrollback")??100},this.l,this.j,this.k,this.h),Ne=new Gt.$$q(De,this.l,this.h,this.i);we.set(bt.$Lq,Ne),o.$i?we.set(U.$qVb,new oe.$mh(T.$W3b)):o.$j?we.set(U.$qVb,new oe.$mh(T.$X3b)):o.$k&&we.set(U.$qVb,new oe.$mh(T.$Y3b));const Ke=new a.$D3b(this.j,this.l,this.h,this.m);we.set(i.$y3b,Ke);const Xe=new tt.$L3b(this.j,this.h,this.s,Ke,Le);if(we.set(tt.$K3b,Xe),we.set(xe.$Hab,new oe.$mh(Qe.$M4b,void 0,!1)),we.set(Ye.$g4b,new oe.$mh(Ye.$h4b,void 0,!1)),we.set(Be.$rjb,new oe.$mh(de.$rqb,void 0,!1)),(0,Se.$0n)(this.p,this.j)){const Ue=(0,Se.$co)(this.p,this.l),Ve=(0,w.$8g)(ke.then(it=>it.getChannel("telemetryAppender"))),Je=new fe.$q4b(Ve),Ze=(0,be.$Zn)((0,O.release)(),(0,O.hostname)(),process.arch,this.p.commit,this.p.version,Pe,Ue),_e=(0,Se.$do)(this.j),st={appenders:[Je],commonProperties:Ze,piiPaths:_e,sendErrorTelemetry:!0};we.set(ee.$Vk,new oe.$mh(ge.$Fq,[st],!1))}else we.set(ee.$Vk,Se.$4n);return we.set(Lt.$_o,new oe.$mh(Wt.$ZM,void 0,!0)),we.set(jt.$dp,new oe.$mh(Ft.$Q4b,void 0,!0)),we.set(mt.$X4b,new oe.$mh(mt.$Y4b,void 0,!0)),await $t.Promises.settled([Ke.initialize(),Xe.initialize()]),this.g.createChild(we)}J(Pe,ke,we){const Le=w.ProxyChannel.fromService(Pe.get(Z.$a4b),{disableMarshalling:!0});this.c.registerChannel("launch",Le);const De=w.ProxyChannel.fromService(Pe.get(M.$P3b),{disableMarshalling:!0});this.c.registerChannel("diagnostics",De);const Ne=new Ct.$O4b(Pe.get(ct.$Vm));ke.registerChannel("policy",Ne),we.then(et=>et.registerChannel("policy",Ne));const Ke=this.n.getProvider(v.Schemas.file);(0,g.$te)(Ke instanceof ce.$Rp);const Xe=new Q.$Z3b(Ke,this.h,this.j);ke.registerChannel(W.$IM,Xe),we.then(et=>et.registerChannel(W.$IM,Xe));const Ue=w.ProxyChannel.fromService(Pe.get(gt.$n3b));ke.registerChannel("userDataProfiles",Ue),we.then(et=>et.registerChannel("userDataProfiles",Ue));const Ve=new Ot.$Aq(Pe.get(Mt.$yo));we.then(et=>et.registerChannel("request",Ve));const Je=new je.$r4b(Pe.get(Ce.$Gib));ke.registerChannel("update",Je);const Ze=w.ProxyChannel.fromService(Pe.get(F.$vrb));ke.registerChannel("issue",Ze);const _e=w.ProxyChannel.fromService(Pe.get(N.$kqb));ke.registerChannel("encryption",_e);const st=w.ProxyChannel.fromService(Pe.get(P.$nn));ke.registerChannel("credentials",st);const it=w.ProxyChannel.fromService(Pe.get(Ae.$Jk));ke.registerChannel("sign",it);const lt=w.ProxyChannel.fromService(Pe.get(G.$03b));ke.registerChannel("keyboardLayout",lt),this.b=Pe.get(ae.$63b);const Pt=w.ProxyChannel.fromService(this.b);ke.registerChannel("nativeHost",Pt),we.then(et=>et.registerChannel("nativeHost",Pt));const Kt=w.ProxyChannel.fromService(Pe.get(xe.$Hab));ke.registerChannel("workspaces",Kt);const Zt=w.ProxyChannel.fromService(Pe.get(x.$j4b));ke.registerChannel("menubar",Zt);const Yt=w.ProxyChannel.fromService(Pe.get(Be.$rjb));ke.registerChannel("url",Yt);const Xt=w.ProxyChannel.fromService(Pe.get(se.$sjb));ke.registerChannel("extensionUrlTrust",Xt);const Qt=w.ProxyChannel.fromService(Pe.get(ve.$D4b));ke.registerChannel("webview",Qt);const It=this.B(new We.$o4b(this.h,Pe.get($e.$p3b)));ke.registerChannel("storage",It),we.then(et=>et.registerChannel("storage",It));const xt=this.B(new Nt.$S4b(Pe.get($e.$p3b),Pe.get(gt.$n3b),this.h));we.then(et=>et.registerChannel("profileStorageListener",xt));const _t=w.ProxyChannel.fromService(Pe.get(bt.$Lq));ke.registerChannel(bt.TerminalIpcChannels.LocalPty,_t);const ei=w.ProxyChannel.fromService(Pe.get(U.$qVb));ke.registerChannel("externalTerminal",ei);const Dt=new zt.$V4b(Pe.get(Bt.$l4b));ke.registerChannel("logger",Dt),we.then(et=>et.registerChannel("logger",Dt));const ti=new I.$E3b(Pe.get(Re.$t3b));ke.registerChannel("extensionhostdebugservice",ti);const ii=w.ProxyChannel.fromService(Pe.get(J.$T3b));ke.registerChannel(J.$U3b,ii);const ni=w.ProxyChannel.fromService(Pe.get(mt.$X4b));ke.registerChannel(Ht.$W4b,ni)}async L(Pe,ke){const we=this.a=Pe.get(Re.$t3b),Le=(0,ne.$sl)(process.env)?0:4,De=this.j.args;if(ke){if(ke.openables.length>0)return we.open({context:Le,cli:De,urisToOpen:ke.openables,gotoLineMode:!0,initialStartup:!0});if(ke.urls.length>0)for(const it of ke.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),we.open({context:Le,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ne=global.macOpenFiles,Ke=De._.length,Xe=!!De["folder-uri"],Ue=!!De["file-uri"],Ve=De["skip-add-to-recently-opened"]===!0,Je=De.wait&&De.waitMarkerFilePath?c.URI.file(De.waitMarkerFilePath):void 0,Ze=De.remote||void 0,_e=De.profile,st=De["profile-temp"];if(!Ke&&!Xe&&!Ue){if(De["new-window"]||_e||st)return we.open({context:Le,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:Je,initialStartup:!0,remoteAuthority:Ze,forceProfile:_e,forceTempProfile:st});if(Ne.length)return we.open({context:1,cli:De,urisToOpen:Ne.map(it=>(0,Ge.$Uh)(it)?{workspaceUri:c.URI.file(it)}:{fileUri:c.URI.file(it)}),noRecentEntry:Ve,waitMarkerFileURI:Je,initialStartup:!0})}return we.open({context:Le,cli:De,forceNewWindow:De["new-window"]||!Ke&&De["unity-launch"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:Ve,waitMarkerFileURI:Je,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Ze,forceProfile:_e,forceTempProfile:st})}M(){this.N(),E.protocol.registerHttpProtocol(v.Schemas.vscodeRemoteResource,(Pe,ke)=>{ke({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})}),this.O(this.j.args,process.env,!0),this.P(),o.$j&&E.app.runningUnderARM64Translation&&this.a?.sendToFocused("vscode:showTranslatedBuildWarning")}async N(){const Pe=this.p.win32MutexName;if(o.$i&&Pe)try{const ke=await new Promise((Le,De)=>{V(["@vscode/windows-mutex"],Le,De)}),we=new ke.Mutex(Pe);(0,$.$cb)(this.k.onWillShutdown)(()=>we.release())}catch(ke){this.h.error(ke)}}async O(Pe,ke,we){try{return await(0,ue.$yl)(this.l,this.h,Pe,ke)}catch(Le){const De=(0,S.$ai)(Le);we?this.a?.sendToFocused("vscode:showResolveShellEnvError",De):this.h.error(De)}return{}}async P(){try{const ke=(await this.n.readFile(this.j.argvResource)).value.toString(),we=JSON.parse((0,d.$Fm)(ke)),De=(0,Se.$_n)(this.l)>=1;if(we["enable-crash-reporter"]===void 0){const Ne=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,b.$6e)()}"`,"}"],Ke=ke.substring(0,ke.length-2).concat(`,
`,Ne.join(`
`));await this.n.writeFile(this.j.argvResource,R.$Jb.fromString(Ke))}else{const Ne=ke.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);Ne!==ke&&await this.n.writeFile(this.j.argvResource,R.$Jb.fromString(Ne))}}catch(Pe){this.h.error(Pe)}}};e.$44b=pt,e.$44b=pt=pe([_(2,j.$oh),_(3,Y.$Ri),_(4,Y.$Si),_(5,re.$f3b),_(6,z.$h3b),_(7,m.$Vh),_(8,Me.$SM),_(9,H.$Sj),_(10,he.$0i),_(11,gt.$n3b)],pt)}),define(te[312],ie([0,1,14,45,7,24,8,50,13,32,49,46,15,9,65,4,36,25,21,42,131,306,11,18,237,248,28,63,200,16,220,94,75,215,93,20,223,5,78,23,79,280,126,262,51,288,96,247,34,52,80,53,39,232,230,2,40,265,66,225,92,121,269,263]),function(V,e,E,C,r,O,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t,l,s,n,i,a,m,P,I,D,M,L,N,B,re,ne,ue,se,le,J,K,U,T,W,H,Q,ce,oe,j,A,F,q,G,Z,z,Y,x,ae,he,Ie,Ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ae{main(){try{this.a()}catch($e){console.error($e.message),E.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[$e,be,ee,fe,ge,Se,Ce,je]=this.b();try{try{await this.d(ee,je,fe,ge,Ce)}catch(Oe){throw this.f(ee,Ce,Oe),Oe}await $e.invokeFunction(async Oe=>{const ze=Oe.get(ne.$Ri),Te=Oe.get(B.$h3b),He=Oe.get(P.$Sj),Be=Oe.get(ne.$Si),X=await this.e(ze,ee,Te,$e,Ce,!0);return c.Promises.writeFile(ee.mainLockfile,String(process.pid)).catch(de=>{ze.warn(`app#startup(): Error writing main lockfile: ${de.stack}`)}),Se.logger=Be.createLogger("main",{name:(0,t.localize)(0,null)}),(0,$.$cb)(Te.onWillShutdown)(de=>{He.dispose(),fe.dispose(),de.join("instanceLockfile",c.Promises.unlink(ee.mainLockfile).catch(()=>{}))}),$e.createInstance(w.$44b,X,be).startup()})}catch(Oe){$e.invokeFunction(this.i,Oe)}}b(){const $e=new N.$nh,be=new Z.$kb;process.once("exit",()=>be.dispose());const ee={_serviceBrand:void 0,...ue.default};$e.set(se.$0i,ee);const fe=new i.$g3b(this.j(),ee),ge=this.c(fe);$e.set(i.$f3b,fe);const Se=new x.$m4b((0,ne.$6i)(fe),fe.logsHome);$e.set(x.$l4b,Se);const Ce=new re.$2Zb(Se.getLogLevel()),je=be.add(new ae.$1M(Ce,[new ne.$Yi(Se.getLogLevel())]));$e.set(ne.$Ri,je);const Oe=new I.$sp(je);$e.set(P.$Sj,Oe);const ze=new D.$Rp(je);Oe.registerProvider(p.Schemas.file,ze),Oe.registerProvider(p.Schemas.vscodeUserData,new Ee.$b5b(p.Schemas.file,ze,p.Schemas.vscodeUserData,je));const Te=new Y.$cr(Oe);$e.set(z.$pk,Te);const He=new Ie.$VM(1,fe,je,Oe);$e.set(ce.$RM,He),$e.set(ce.$SM,He);const Be=new A.$o3b(He,Te,fe,Oe,je);$e.set(A.$n3b,Be);const X=y.$i&&ee.win32RegValueName?be.add(new q.$_4b(je,ee.win32RegValueName)):fe.policyFile?be.add(new G.$a5b(fe.policyFile,Oe,je)):new F.$Xm;$e.set(F.$Vm,X);const de=new s.$ln(Be.defaultProfile.settingsResource,Oe,X,je);return $e.set(l.$Vh,de),$e.set(B.$h3b,new M.$mh(B.$i3b,void 0,!1)),$e.set(T.$yo,new M.$mh(W.$04b,void 0,!0)),$e.set(j.$23b,new M.$mh(j.$33b)),$e.set(H.$Jk,new M.$mh(Q.$$4b,void 0,!1)),$e.set(K.$Fz,new M.$mh(U.$84b)),$e.set(le.$83b,new J.$64b(fe,Be,je)),[new L.$Up($e,!0),ge,fe,de,He,Ce,ee,Be]}c($e){const be={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ee=>{const fe=process.env[ee];typeof fe=="string"&&(be[ee]=fe)}),Object.assign(process.env,be),be}async d($e,be,ee,fe,ge){await R.Promises.settled([Promise.all([$e.extensionsPath,$e.codeCachePath,$e.logsHome.fsPath,be.defaultProfile.globalStorageHome.fsPath,$e.workspaceStorageHome.fsPath,$e.localHistoryHome.fsPath,$e.backupHome].map(Se=>Se?c.Promises.mkdir(Se,{recursive:!0}):void 0)),fe.init(),ee.initialize()]),be.init()}async e($e,be,ee,fe,ge,Se){let Ce;try{(0,v.mark)("code/willStartMainServer"),Ce=await(0,k.$kh)(be.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),(0,$.$cb)(ee.onWillShutdown)(()=>Ce.dispose())}catch(je){if(je.code!=="EADDRINUSE")throw this.f(be,ge,je),je;let Oe;try{Oe=await(0,k.$lh)(be.mainIPCHandle,"main")}catch(Be){if(!Se||y.$i||Be.code!=="ECONNREFUSED")throw Be.code==="EPERM"&&this.g((0,t.localize)(1,null,ge.nameShort),(0,t.localize)(2,null),ge),Be;try{(0,C.unlinkSync)(be.mainIPCHandle)}catch(X){throw $e.warn("Could not delete obsolete instance handle",X),X}return this.e($e,be,ee,fe,ge,!1)}if(be.extensionTestsLocationURI&&!be.debugExtensionHost.break){const Be=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw $e.error(Be),Oe.dispose(),new Error(Be)}let ze;!be.args.wait&&!be.args.status&&(ze=setTimeout(()=>{this.g((0,t.localize)(3,null,ge.nameShort),(0,t.localize)(4,null),ge)},1e4));const Te=b.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),He=b.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(be.args.status)return fe.invokeFunction(async()=>{const Be=new n.$jr(oe.$4n,ge),X=await He.getMainDiagnostics(),de=await He.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),me=await Be.getDiagnostics(X,de);throw console.log(me),new f.$_});throw y.$i&&await this.h(Te,$e),$e.trace("Sending env to running instance..."),await Te.start(be.args,process.env),Oe.dispose(),ze&&clearTimeout(ze),new f.$_("Sent env to running instance. Terminating...")}if(be.args.status)throw console.log((0,t.localize)(5,null,ge.nameShort)),new f.$_("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ce}f($e,be,ee){if(ee.code==="EACCES"||ee.code==="EPERM"){const fe=(0,O.$mf)([$e.userDataPath,$e.extensionsPath,k.$gh]).map(ge=>(0,d.$Zz)(r.URI.file(ge),{os:y.OS,tildify:$e}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,S.$ai)(ee),fe.join(`
`)),be)}}g($e,be,ee){E.dialog.showMessageBoxSync((0,he.$bA)({type:"warning",buttons:[(0,t.localize)(8,null)],message:$e,detail:be},ee).options)}async h($e,be){if(y.$i){const ee=await $e.getMainProcessId();be.trace("Sending some foreground love to the running instance:",ee);try{(await new Promise((fe,ge)=>{V(["windows-foreground-love"],fe,ge)})).allowSetForegroundWindow(ee)}catch(fe){be.error(fe)}}}i($e,be){const ee=$e.get(ne.$Ri),fe=$e.get(B.$h3b);let ge=0;be&&(be.isExpected?be.message&&ee.trace(be.message):(ge=1,be.stack?ee.error(be.stack):ee.error(`Startup error: ${be.toString()}`))),fe.kill(ge)}j(){const $e=this.k((0,a.$pl)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const be=(0,m.$54b)($e.verbose);be&&((0,a.$rl)(process.argv,"--waitMarkerFilePath",be),$e.waitMarkerFilePath=be)}return $e}k($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const be=this.l($e._,$e.goto);$e._=be}return $e}l($e,be){const ee=(0,o.cwd)(),fe=$e.map(Ce=>{let je=String(Ce),Oe;be&&(Oe=(0,u.$Re)(je),je=Oe.path),je&&(je=this.m(ee,je));const ze=(0,u.$Me)(je,ee),Te=(0,h.$ec)(ze);return Te&&!(0,u.$Ie)(Te)?null:be&&Oe?(Oe.path=ze,this.n(Oe)):ze}),ge=y.$i||y.$j,Se=(0,O.$rf)(fe,Ce=>Ce&&ge?Ce.toLowerCase():Ce||"");return(0,O.$mf)(Se)}m($e,be){return y.$i&&(be=(0,g.$td)(be,'"')),be=(0,g.$rd)((0,g.$rd)(be," "),"	"),y.$i&&(be=(0,h.$bc)($e,be),be=(0,g.$td)(be,".")),be}n($e){const be=[$e.path];return typeof $e.line=="number"&&be.push(String($e.line)),typeof $e.column=="number"&&be.push(String($e.column)),be.join(":")}}new Ae().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/93d3731736cc6fefbd63810d5fb2d57bedc84ca0/core/vs/code/electron-main/main.js.map
