/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/strings","vs/base/common/uuid","vs/base/common/objects","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(G){for(var e=[],M=0,N=G.length;M<N;M++)e[M]=ne[G[M]];return e};define(ne[70],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class M{static get(){const D=new Map,A=new Map,L=new Map,b=new Map;function u(h,S){h.has(S.detail)||h.set(S.detail,-S.timestamp)}function c(h,S){const y=h.get(S.detail);y&&(y>=0||h.set(S.detail,y+S.timestamp))}let w=[];typeof G=="function"&&typeof G.getStats=="function"&&(w=G.getStats().slice(0).sort((h,S)=>h.timestamp-S.timestamp));for(const h of w)switch(h.type){case 10:u(D,h);break;case 11:case 12:c(D,h);break;case 21:u(A,h);break;case 22:c(A,h);break;case 33:u(L,h);break;case 34:c(L,h);break;case 31:u(b,h);break;case 32:c(b,h);break}let O=0;L.forEach(h=>O+=h);function m(h){const S=[];return h.forEach((y,g)=>S.push([g,y])),S}return{amdLoad:m(D),amdInvoke:m(A),nodeRequire:m(L),nodeEval:m(b),nodeRequireTotal:O}}static toMarkdownTable(D,A){let L="";const b=[];return D.forEach((u,c)=>{b[c]=u.length}),A.forEach(u=>{u.forEach((c,w)=>{typeof c>"u"&&(c=u[w]="-");const O=c.toString().length;b[w]=Math.max(O,b[w])})}),D.forEach((u,c)=>{L+=`| ${u+" ".repeat(b[c]-u.toString().length)} `}),L+=`|
`,D.forEach((u,c)=>{L+=`| ${"-".repeat(b[c])} `}),L+=`|
`,A.forEach(u=>{u.forEach((c,w)=>{typeof c<"u"&&(L+=`| ${c+" ".repeat(b[w]-c.toString().length)} `)}),L+=`|
`}),L}}e.$S=M}),define(ne[52],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.$Ug=e.$Tg=void 0;function M(L){return(b,u,c)=>{let w=null,O=null;if(typeof c.value=="function"?(w="value",O=c.value):typeof c.get=="function"&&(w="get",O=c.get),!O)throw new Error("not supported");c[w]=L(O,u)}}function N(L,b,u){let c=null,w=null;if(typeof u.value=="function"?(c="value",w=u.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",w=u.get),!w)throw new Error("not supported");const O=`$memoize$${b}`;u[c]=function(...m){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,m)}),this[O]}}e.$Tg=N;function D(L,b,u){return M((c,w)=>{const O=`$debounce$${w}`,m=`$debounce$result$${w}`;return function(...h){this[m]||(this[m]=u?u():void 0),clearTimeout(this[O]),b&&(this[m]=b(this[m],...h),h=[this[m]]),this[O]=setTimeout(()=>{c.apply(this,h),this[m]=u?u():void 0},L)}})}e.$Ug=D;function A(L,b,u){return M((c,w)=>{const O=`$throttle$timer$${w}`,m=`$throttle$result$${w}`,h=`$throttle$lastRun$${w}`,S=`$throttle$pending$${w}`;return function(...y){if(this[m]||(this[m]=u?u():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...y)),this[S])return;const g=this[h]+L;g<=Date.now()?(this[h]=Date.now(),c.apply(this,[this[m]]),this[m]=u?u():void 0):(this[S]=!0,this[O]=setTimeout(()=>{this[S]=!1,this[h]=Date.now(),c.apply(this,[this[m]]),this[m]=u?u():void 0},g-Date.now()))}})}e.$Vg=A}),define(ne[71],re([0,1,9]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qc=e.$pc=e.$oc=e.$nc=e.ok=void 0;function N(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=N;function D(u,c="Unreachable"){throw new Error(c)}e.$nc=D;function A(u){if(!u)throw new M.$bb("Assertion Failed")}e.$oc=A;function L(u){if(!u()){debugger;u(),(0,M.$Y)(new M.$bb("Assertion Failed"))}}e.$pc=L;function b(u,c){let w=0;for(;w<u.length-1;){const O=u[w],m=u[w+1];if(!c(O,m))return!1;w++}return!0}e.$qc=b}),define(ne[53],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var M;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(M||(e.ScanError=M={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function L(t,a=!1){let i=0;const n=t.length;let s="",o=0,l=16,I=0;function E(te){let ae=0,ce=0;for(;ae<te;){const ie=t.charCodeAt(i);if(ie>=48&&ie<=57)ce=ce*16+ie-48;else if(ie>=65&&ie<=70)ce=ce*16+ie-65+10;else if(ie>=97&&ie<=102)ce=ce*16+ie-97+10;else break;i++,ae++}return ae<te&&(ce=-1),ce}function k(te){i=te,s="",o=0,l=16,I=0}function j(){const te=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return I=3,t.substring(te,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;ae=i}else I=3;return t.substring(te,ae)}function W(){let te="",ae=i;for(;;){if(i>=n){te+=t.substring(ae,i),I=2;break}const ce=t.charCodeAt(i);if(ce===34){te+=t.substring(ae,i),i++;break}if(ce===92){if(te+=t.substring(ae,i),i++,i>=n){I=2;break}switch(t.charCodeAt(i++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const V=E(4);V>=0?te+=String.fromCharCode(V):I=4;break}default:I=5}ae=i;continue}if(ce>=0&&ce<=31)if(u(ce)){te+=t.substring(ae,i),I=2;break}else I=6;i++}return te}function ee(){if(s="",I=0,o=i,i>=n)return o=n,l=17;let te=t.charCodeAt(i);if(b(te)){do i++,s+=String.fromCharCode(te),te=t.charCodeAt(i);while(b(te));return l=15}if(u(te))return i++,s+=String.fromCharCode(te),te===13&&t.charCodeAt(i)===10&&(i++,s+=`
`),l=14;switch(te){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,s=W(),l=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!u(t.charCodeAt(i));)i++;return s=t.substring(ae,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const ce=n-1;let ie=!1;for(;i<ce;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ie=!0;break}i++}return ie||(i++,I=1),s=t.substring(ae,i),l=13}return s+=String.fromCharCode(te),i++,l=16}case 45:if(s+=String.fromCharCode(te),i++,i===n||!c(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=j(),l=11;default:for(;i<n&&x(te);)i++,te=t.charCodeAt(i);if(o!==i){switch(s=t.substring(o,i),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(te),i++,l=16}}function x(te){if(b(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let te;do te=ee();while(te>=12&&te<=15);return te}return{setPosition:k,getPosition:()=>i,scan:a?le:ee,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>I}}e.$vm=L;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var w;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(w||(w={}));function O(t,a){const i=[],n=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function I(E,k,j,W){o.value=E,o.offset=k,o.length=j,o.type=W,o.colonOffset=void 0,s=o}try{P(t,{onObjectBegin:(E,k)=>{if(a<=E)throw n;s=void 0,l=a>E,i.push("")},onObjectProperty:(E,k,j)=>{if(a<k||(I(E,k,j,"property"),i[i.length-1]=E,a<=k+j))throw n},onObjectEnd:(E,k)=>{if(a<=E)throw n;s=void 0,i.pop()},onArrayBegin:(E,k)=>{if(a<=E)throw n;s=void 0,i.push(0)},onArrayEnd:(E,k)=>{if(a<=E)throw n;s=void 0,i.pop()},onLiteralValue:(E,k,j)=>{if(a<k||(I(E,k,j,p(E)),a<=k+j))throw n},onSeparator:(E,k,j)=>{if(a<=k)throw n;if(E===":"&&s&&s.type==="property")s.colonOffset=k,l=!1,s=void 0;else if(E===","){const W=i[i.length-1];typeof W=="number"?i[i.length-1]=W+1:(l=!0,i[i.length-1]=""),s=void 0}}})}catch(E){if(E!==n)throw E}return{path:i,previousNode:s,isAtPropertyKey:l,matches:E=>{let k=0;for(let j=0;k<E.length&&j<i.length;j++)if(E[k]===i[j]||E[k]==="*")k++;else if(E[k]!=="**")return!1;return k===E.length}}}e.$wm=O;function m(t,a=[],i=A.DEFAULT){let n=null,s=[];const o=[];function l(E){Array.isArray(s)?s.push(E):n!==null&&(s[n]=E)}return P(t,{onObjectBegin:()=>{const E={};l(E),o.push(s),s=E,n=null},onObjectProperty:E=>{n=E},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const E=[];l(E),o.push(s),s=E,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:l,onError:(E,k,j)=>{a.push({error:E,offset:k,length:j})}},i),s[0]}e.$xm=m;function h(t,a=[],i=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(E){n.type==="property"&&(n.length=E-n.offset,n=n.parent)}function o(E){return n.children.push(E),E}P(t,{onObjectBegin:E=>{n=o({type:"object",offset:E,length:-1,parent:n,children:[]})},onObjectProperty:(E,k,j)=>{n=o({type:"property",offset:k,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:E,offset:k,length:j,parent:n})},onObjectEnd:(E,k)=>{n.length=E+k-n.offset,n=n.parent,s(E+k)},onArrayBegin:(E,k)=>{n=o({type:"array",offset:E,length:-1,parent:n,children:[]})},onArrayEnd:(E,k)=>{n.length=E+k-n.offset,n=n.parent,s(E+k)},onLiteralValue:(E,k,j)=>{o({type:p(E),offset:k,length:j,parent:n,value:E}),s(k+j)},onSeparator:(E,k,j)=>{n.type==="property"&&(E===":"?n.colonOffset=k:E===","&&s(k))},onError:(E,k,j)=>{a.push({error:E,offset:k,length:j})}},i);const I=n.children[0];return I&&delete I.parent,I}e.$ym=h;function S(t,a){if(!t)return;let i=t;for(const n of a)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===n){i=o.children[1],s=!0;break}if(!s)return}else{const s=n;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.$zm=S;function y(t){if(!t.parent||!t.parent.children)return[];const a=y(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.$Am=y;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const a=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(a[i.children[0].value]=g(n))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Bm=g;function d(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.$Cm=d;function f(t,a,i=!1){if(d(t,a,i)){const n=t.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=a;s++){const o=f(n[s],a,i);if(o)return o}return t}}e.$Dm=f;function P(t,a,i=A.DEFAULT){const n=L(t,!1);function s(Y){return Y?()=>Y(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(Y){return Y?K=>Y(K,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(a.onObjectBegin),I=o(a.onObjectProperty),E=s(a.onObjectEnd),k=s(a.onArrayBegin),j=s(a.onArrayEnd),W=o(a.onLiteralValue),ee=o(a.onSeparator),x=s(a.onComment),le=o(a.onError),te=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function ce(){for(;;){const Y=n.scan();switch(n.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:te||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(Y){case 12:case 13:te?ie(10):x();break;case 16:ie(1);break;case 15:case 14:break;default:return Y}}}function ie(Y,K=[],T=[]){if(le(Y),K.length+T.length>0){let R=n.getToken();for(;R!==17;){if(K.indexOf(R)!==-1){ce();break}else if(T.indexOf(R)!==-1)break;R=ce()}}}function V(Y){const K=n.getTokenValue();return Y?W(K):I(K),ce(),!0}function H(){switch(n.getToken()){case 11:{let Y=0;try{Y=JSON.parse(n.getTokenValue()),typeof Y!="number"&&(ie(2),Y=0)}catch{ie(2)}W(Y);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return ce(),!0}function C(){return n.getToken()!==10?(ie(3,[],[2,5]),!1):(V(!1),n.getToken()===6?(ee(":"),ce(),X()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function U(){l(),ce();let Y=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ie(4,[],[]),ee(","),ce(),n.getToken()===2&&ae)break}else Y&&ie(6,[],[]);C()||ie(4,[],[2,5]),Y=!0}return E(),n.getToken()!==2?ie(7,[2],[]):ce(),!0}function q(){k(),ce();let Y=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ie(4,[],[]),ee(","),ce(),n.getToken()===4&&ae)break}else Y&&ie(6,[],[]);X()||ie(4,[],[4,5]),Y=!0}return j(),n.getToken()!==4?ie(8,[4],[]):ce(),!0}function X(){switch(n.getToken()){case 3:return q();case 1:return U();case 10:return V(!0);default:return H()}}return ce(),n.getToken()===17?i.allowEmptyContent?!0:(ie(4,[],[]),!1):X()?(n.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$Em=P;function $(t,a){const i=L(t),n=[];let s,o=0,l;do switch(l=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:o!==l&&n.push(t.substring(o,l)),a!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,a)),o=i.getPosition();break}while(s!==17);return n.join("")}e.$Fm=$;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Gm=p}),define(ne[72],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=e.$vl=e.rot=e.$tl=void 0;function M(b,u,c){return Math.min(Math.max(b,u),c)}e.$tl=M;function N(b,u){return(u+b%u)%u}e.rot=N;class D{constructor(){this.a=0}getNext(){return this.a++}}e.$vl=D;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$wl=A;class L{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$xl=L}),function(){function G(D){const A=[];typeof D=="number"&&A.push("code/timeOrigin",D);function L(u){A.push(u,Date.now())}function b(){const u=[];for(let c=0;c<A.length;c+=2)u.push({name:A[c],startTime:A[c+1]});return u}return{mark:L,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const L of performance.getEntriesByType("mark"))A.push({name:L.name,startTime:Math.round(D+L.startTime)});return A}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function M(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return M(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=M(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=M(N))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var M=e();for(var N in M)(typeof exports=="object"?exports:G)[N]=M[N]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function M(N){if(e[N])return e[N].exports;var D=e[N]={i:N,l:!1,exports:{}};return G[N].call(D.exports,D,D.exports,M),D.l=!0,D.exports}return M.m=G,M.c=e,M.d=function(N,D,A){M.o(N,D)||Object.defineProperty(N,D,{enumerable:!0,get:A})},M.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},M.t=function(N,D){if(1&D&&(N=M(N)),8&D||4&D&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(M.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&D&&typeof N!="string")for(var L in N)M.d(A,L,function(b){return N[b]}.bind(null,L));return A},M.n=function(N){var D=N&&N.__esModule?function(){return N.default}:function(){return N};return M.d(D,"a",D),D},M.o=function(N,D){return Object.prototype.hasOwnProperty.call(N,D)},M.p="",M(M.s=0)}([function(G,e,M){(function(N){var D;e=G.exports=T,D=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],u=e.src=[],c=0,w=c++;u[w]="0|[1-9]\\d*";var O=c++;u[O]="[0-9]+";var m=c++;u[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=c++;u[h]="("+u[w]+")\\.("+u[w]+")\\.("+u[w]+")";var S=c++;u[S]="("+u[O]+")\\.("+u[O]+")\\.("+u[O]+")";var y=c++;u[y]="(?:"+u[w]+"|"+u[m]+")";var g=c++;u[g]="(?:"+u[O]+"|"+u[m]+")";var d=c++;u[d]="(?:-("+u[y]+"(?:\\."+u[y]+")*))";var f=c++;u[f]="(?:-?("+u[g]+"(?:\\."+u[g]+")*))";var P=c++;u[P]="[0-9A-Za-z-]+";var $=c++;u[$]="(?:\\+("+u[P]+"(?:\\."+u[P]+")*))";var p=c++,t="v?"+u[h]+u[d]+"?"+u[$]+"?";u[p]="^"+t+"$";var a="[v=\\s]*"+u[S]+u[f]+"?"+u[$]+"?",i=c++;u[i]="^"+a+"$";var n=c++;u[n]="((?:<|>)?=?)";var s=c++;u[s]=u[O]+"|x|X|\\*";var o=c++;u[o]=u[w]+"|x|X|\\*";var l=c++;u[l]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[d]+")?"+u[$]+"?)?)?";var I=c++;u[I]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[f]+")?"+u[$]+"?)?)?";var E=c++;u[E]="^"+u[n]+"\\s*"+u[l]+"$";var k=c++;u[k]="^"+u[n]+"\\s*"+u[I]+"$";var j=c++;u[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=c++;u[W]="(?:~>?)";var ee=c++;u[ee]="(\\s*)"+u[W]+"\\s+",b[ee]=new RegExp(u[ee],"g");var x=c++;u[x]="^"+u[W]+u[l]+"$";var le=c++;u[le]="^"+u[W]+u[I]+"$";var te=c++;u[te]="(?:\\^)";var ae=c++;u[ae]="(\\s*)"+u[te]+"\\s+",b[ae]=new RegExp(u[ae],"g");var ce=c++;u[ce]="^"+u[te]+u[l]+"$";var ie=c++;u[ie]="^"+u[te]+u[I]+"$";var V=c++;u[V]="^"+u[n]+"\\s*("+a+")$|^$";var H=c++;u[H]="^"+u[n]+"\\s*("+t+")$|^$";var C=c++;u[C]="(\\s*)"+u[n]+"\\s*("+a+"|"+u[l]+")",b[C]=new RegExp(u[C],"g");var U=c++;u[U]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var q=c++;u[q]="^\\s*("+u[I]+")\\s+-\\s+("+u[I]+")\\s*$";var X=c++;u[X]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)D(Y,u[Y]),b[Y]||(b[Y]=new RegExp(u[Y]));function K(B,Q){if(B instanceof T)return B;if(typeof B!="string"||B.length>A||!(Q?b[i]:b[p]).test(B))return null;try{return new T(B,Q)}catch{return null}}function T(B,Q){if(B instanceof T){if(B.loose===Q)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof T))return new T(B,Q);D("SemVer",B,Q),this.loose=Q;var _=B.trim().match(Q?b[i]:b[p]);if(!_)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var we=+$e;if(we>=0&&we<L)return we}return $e}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=K,e.valid=function(B,Q){var _=K(B,Q);return _?_.version:null},e.clean=function(B,Q){var _=K(B.trim().replace(/^[=v]+/,""),Q);return _?_.version:null},e.SemVer=T,T.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},T.prototype.toString=function(){return this.version},T.prototype.compare=function(B){return D("SemVer.compare",this.version,this.loose,B),B instanceof T||(B=new T(B,this.loose)),this.compareMain(B)||this.comparePre(B)},T.prototype.compareMain=function(B){return B instanceof T||(B=new T(B,this.loose)),r(this.major,B.major)||r(this.minor,B.minor)||r(this.patch,B.patch)},T.prototype.comparePre=function(B){if(B instanceof T||(B=new T(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var Q=0;do{var _=this.prerelease[Q],$e=B.prerelease[Q];if(D("prerelease compare",Q,_,$e),_===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(_===void 0)return-1;if(_!==$e)return r(_,$e)}while(++Q)},T.prototype.inc=function(B,Q){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,Q,_,$e){typeof _=="string"&&($e=_,_=void 0);try{return new T(B,_).inc(Q,$e).version}catch{return null}},e.diff=function(B,Q){if(J(B,Q))return null;var _=K(B),$e=K(Q);if(_.prerelease.length||$e.prerelease.length){for(var we in _)if((we==="major"||we==="minor"||we==="patch")&&_[we]!==$e[we])return"pre"+we;return"prerelease"}for(var we in _)if((we==="major"||we==="minor"||we==="patch")&&_[we]!==$e[we])return we},e.compareIdentifiers=r;var R=/^[0-9]+$/;function r(B,Q){var _=R.test(B),$e=R.test(Q);return _&&$e&&(B=+B,Q=+Q),_&&!$e?-1:$e&&!_?1:B<Q?-1:B>Q?1:0}function v(B,Q,_){return new T(B,_).compare(new T(Q,_))}function z(B,Q,_){return v(B,Q,_)>0}function F(B,Q,_){return v(B,Q,_)<0}function J(B,Q,_){return v(B,Q,_)===0}function Z(B,Q,_){return v(B,Q,_)!==0}function oe(B,Q,_){return v(B,Q,_)>=0}function fe(B,Q,_){return v(B,Q,_)<=0}function de(B,Q,_,$e){var we;switch(Q){case"===":typeof B=="object"&&(B=B.version),typeof _=="object"&&(_=_.version),we=B===_;break;case"!==":typeof B=="object"&&(B=B.version),typeof _=="object"&&(_=_.version),we=B!==_;break;case"":case"=":case"==":we=J(B,_,$e);break;case"!=":we=Z(B,_,$e);break;case">":we=z(B,_,$e);break;case">=":we=oe(B,_,$e);break;case"<":we=F(B,_,$e);break;case"<=":we=fe(B,_,$e);break;default:throw new TypeError("Invalid operator: "+Q)}return we}function ue(B,Q){if(B instanceof ue){if(B.loose===Q)return B;B=B.value}if(!(this instanceof ue))return new ue(B,Q);D("comparator",B,Q),this.loose=Q,this.parse(B),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(B,Q){return r(Q,B)},e.major=function(B,Q){return new T(B,Q).major},e.minor=function(B,Q){return new T(B,Q).minor},e.patch=function(B,Q){return new T(B,Q).patch},e.compare=v,e.compareLoose=function(B,Q){return v(B,Q,!0)},e.rcompare=function(B,Q,_){return v(Q,B,_)},e.sort=function(B,Q){return B.sort(function(_,$e){return e.compare(_,$e,Q)})},e.rsort=function(B,Q){return B.sort(function(_,$e){return e.rcompare(_,$e,Q)})},e.gt=z,e.lt=F,e.eq=J,e.neq=Z,e.gte=oe,e.lte=fe,e.cmp=de,e.Comparator=ue;var ge={};function me(B,Q){if(B instanceof me)return B.loose===Q?B:new me(B.raw,Q);if(B instanceof ue)return new me(B.value,Q);if(!(this instanceof me))return new me(B,Q);if(this.loose=Q,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function he(B){return!B||B.toLowerCase()==="x"||B==="*"}function be(B,Q,_,$e,we,Re,ke,Ae,Pe,Le,ze,Ie,Ne){return((Q=he(_)?"":he($e)?">="+_+".0.0":he(we)?">="+_+"."+$e+".0":">="+Q)+" "+(Ae=he(Pe)?"":he(Le)?"<"+(+Pe+1)+".0.0":he(ze)?"<"+Pe+"."+(+Le+1)+".0":Ie?"<="+Pe+"."+Le+"."+ze+"-"+Ie:"<="+Ae)).trim()}function Ee(B,Q){for(var _=0;_<B.length;_++)if(!B[_].test(Q))return!1;if(Q.prerelease.length){for(_=0;_<B.length;_++)if(D(B[_].semver),B[_].semver!==ge&&B[_].semver.prerelease.length>0){var $e=B[_].semver;if($e.major===Q.major&&$e.minor===Q.minor&&$e.patch===Q.patch)return!0}return!1}return!0}function je(B,Q,_){try{Q=new me(Q,_)}catch{return!1}return Q.test(B)}function Te(B,Q,_,$e){var we,Re,ke,Ae,Pe;switch(B=new T(B,$e),Q=new me(Q,$e),_){case">":we=z,Re=fe,ke=F,Ae=">",Pe=">=";break;case"<":we=F,Re=oe,ke=z,Ae="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(B,Q,$e))return!1;for(var Le=0;Le<Q.set.length;++Le){var ze=Q.set[Le],Ie=null,Ne=null;if(ze.forEach(function(De){De.semver===ge&&(De=new ue(">=0.0.0")),Ie=Ie||De,Ne=Ne||De,we(De.semver,Ie.semver,$e)?Ie=De:ke(De.semver,Ne.semver,$e)&&(Ne=De)}),Ie.operator===Ae||Ie.operator===Pe||(!Ne.operator||Ne.operator===Ae)&&Re(B,Ne.semver)||Ne.operator===Pe&&ke(B,Ne.semver))return!1}return!0}ue.prototype.parse=function(B){var Q=this.loose?b[V]:b[H],_=B.match(Q);if(!_)throw new TypeError("Invalid comparator: "+B);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new T(_[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(B){return D("Comparator.test",B,this.loose),this.semver===ge||(typeof B=="string"&&(B=new T(B,this.loose)),de(B,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(B,Q){if(!(B instanceof ue))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new me(B.value,Q),je(this.value,_,Q);if(B.operator==="")return _=new me(this.value,Q),je(B.semver,_,Q);var $e=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Re=this.semver.version===B.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Ae=de(this.semver,"<",B.semver,Q)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),Pe=de(this.semver,">",B.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return $e||we||Re&&ke||Ae||Pe},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(B){var Q=this.loose;B=B.trim(),D("range",B,Q);var _=Q?b[q]:b[U];B=B.replace(_,be),D("hyphen replace",B),B=B.replace(b[C],"$1$2$3"),D("comparator trim",B,b[C]),B=(B=(B=B.replace(b[ee],"$1~")).replace(b[ae],"$1^")).split(/\s+/).join(" ");var $e=Q?b[V]:b[H],we=B.split(" ").map(function(Re){return function(ke,Ae){return D("comp",ke),ke=function(Pe,Le){return Pe.trim().split(/\s+/).map(function(ze){return function(Ie,Ne){D("caret",Ie,Ne);var De=Ne?b[ie]:b[ce];return Ie.replace(De,function(Ue,ye,ve,Se,Oe){var Me;return D("caret",Ie,Ue,ye,ve,Se,Oe),he(ye)?Me="":he(ve)?Me=">="+ye+".0.0 <"+(+ye+1)+".0.0":he(Se)?Me=ye==="0"?">="+ye+"."+ve+".0 <"+ye+"."+(+ve+1)+".0":">="+ye+"."+ve+".0 <"+(+ye+1)+".0.0":Oe?(D("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Me=ye==="0"?ve==="0"?">="+ye+"."+ve+"."+Se+Oe+" <"+ye+"."+ve+"."+(+Se+1):">="+ye+"."+ve+"."+Se+Oe+" <"+ye+"."+(+ve+1)+".0":">="+ye+"."+ve+"."+Se+Oe+" <"+(+ye+1)+".0.0"):(D("no pr"),Me=ye==="0"?ve==="0"?">="+ye+"."+ve+"."+Se+" <"+ye+"."+ve+"."+(+Se+1):">="+ye+"."+ve+"."+Se+" <"+ye+"."+(+ve+1)+".0":">="+ye+"."+ve+"."+Se+" <"+(+ye+1)+".0.0"),D("caret return",Me),Me})}(ze,Le)}).join(" ")}(ke,Ae),D("caret",ke),ke=function(Pe,Le){return Pe.trim().split(/\s+/).map(function(ze){return function(Ie,Ne){var De=Ne?b[le]:b[x];return Ie.replace(De,function(Ue,ye,ve,Se,Oe){var Me;return D("tilde",Ie,Ue,ye,ve,Se,Oe),he(ye)?Me="":he(ve)?Me=">="+ye+".0.0 <"+(+ye+1)+".0.0":he(Se)?Me=">="+ye+"."+ve+".0 <"+ye+"."+(+ve+1)+".0":Oe?(D("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Me=">="+ye+"."+ve+"."+Se+Oe+" <"+ye+"."+(+ve+1)+".0"):Me=">="+ye+"."+ve+"."+Se+" <"+ye+"."+(+ve+1)+".0",D("tilde return",Me),Me})}(ze,Le)}).join(" ")}(ke,Ae),D("tildes",ke),ke=function(Pe,Le){return D("replaceXRanges",Pe,Le),Pe.split(/\s+/).map(function(ze){return function(Ie,Ne){Ie=Ie.trim();var De=Ne?b[k]:b[E];return Ie.replace(De,function(Ue,ye,ve,Se,Oe,Me){D("xRange",Ie,Ue,ye,ve,Se,Oe,Me);var We=he(ve),Fe=We||he(Se),Ve=Fe||he(Oe);return ye==="="&&Ve&&(ye=""),We?Ue=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Ve?(Fe&&(Se=0),Ve&&(Oe=0),ye===">"?(ye=">=",Fe?(ve=+ve+1,Se=0,Oe=0):Ve&&(Se=+Se+1,Oe=0)):ye==="<="&&(ye="<",Fe?ve=+ve+1:Se=+Se+1),Ue=ye+ve+"."+Se+"."+Oe):Fe?Ue=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ve&&(Ue=">="+ve+"."+Se+".0 <"+ve+"."+(+Se+1)+".0"),D("xRange return",Ue),Ue})}(ze,Le)}).join(" ")}(ke,Ae),D("xrange",ke),ke=function(Pe,Le){return D("replaceStars",Pe,Le),Pe.trim().replace(b[X],"")}(ke,Ae),D("stars",ke),ke}(Re,Q)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Re){return!!Re.match($e)})),we=we.map(function(Re){return new ue(Re,Q)})},me.prototype.intersects=function(B,Q){if(!(B instanceof me))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function($e){return B.set.some(function(we){return we.every(function(Re){return $e.intersects(Re,Q)})})})})},e.toComparators=function(B,Q){return new me(B,Q).set.map(function(_){return _.map(function($e){return $e.value}).join(" ").trim().split(" ")})},me.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new T(B,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Ee(this.set[Q],B))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(B,Q,_){var $e=null,we=null;try{var Re=new me(Q,_)}catch{return null}return B.forEach(function(ke){Re.test(ke)&&($e&&we.compare(ke)!==-1||(we=new T($e=ke,_)))}),$e},e.minSatisfying=function(B,Q,_){var $e=null,we=null;try{var Re=new me(Q,_)}catch{return null}return B.forEach(function(ke){Re.test(ke)&&($e&&we.compare(ke)!==1||(we=new T($e=ke,_)))}),$e},e.validRange=function(B,Q){try{return new me(B,Q).range||"*"}catch{return null}},e.ltr=function(B,Q,_){return Te(B,Q,"<",_)},e.gtr=function(B,Q,_){return Te(B,Q,">",_)},e.outside=Te,e.prerelease=function(B,Q){var _=K(B,Q);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(B,Q,_){return B=new me(B,_),Q=new me(Q,_),B.intersects(Q)},e.coerce=function(B){if(B instanceof T)return B;if(typeof B!="string")return null;var Q=B.match(b[j]);return Q==null?null:K((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,M(1))},function(G,e){var M,N,D=G.exports={};function A(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function b(g){if(M===setTimeout)return setTimeout(g,0);if((M===A||!M)&&setTimeout)return M=setTimeout,setTimeout(g,0);try{return M(g,0)}catch{try{return M.call(null,g,0)}catch{return M.call(this,g,0)}}}(function(){try{M=typeof setTimeout=="function"?setTimeout:A}catch{M=A}try{N=typeof clearTimeout=="function"?clearTimeout:L}catch{N=L}})();var u,c=[],w=!1,O=-1;function m(){w&&u&&(w=!1,u.length?c=u.concat(c):O=-1,c.length&&h())}function h(){if(!w){var g=b(m);w=!0;for(var d=c.length;d;){for(u=c,c=[];++O<d;)u&&u[O].run();O=-1,d=c.length}u=null,w=!1,function(f){if(N===clearTimeout)return clearTimeout(f);if((N===L||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(f);try{N(f)}catch{try{return N.call(null,f)}catch{return N.call(this,f)}}}(g)}}function S(g,d){this.fun=g,this.array=d}function y(){}D.nextTick=function(g){var d=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)d[f-1]=arguments[f];c.push(new S(g,d)),c.length!==1||w||b(h)},S.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=y,D.addListener=y,D.once=y,D.off=y,D.removeListener=y,D.removeAllListeners=y,D.emit=y,D.prependListener=y,D.prependOnceListener=y,D.listeners=function(g){return[]},D.binding=function(g){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(g){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(ne[73],re([0,1]),function(G,e){"use strict";var M;Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class N{constructor(b,u,c){this.level=b,this.key=u,this.value=c,this.forward=[]}}const D=void 0;class A{constructor(b,u=2**16){this.comparator=b,this[M]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new N(this.c,D,D)}get size(){return this.f}clear(){this.e=new N(this.c,D,D)}has(b){return!!A.g(this,b,this.comparator)}get(b){return A.g(this,b,this.comparator)?.value}set(b,u){return A.h(this,b,u,this.comparator)&&(this.f+=1),this}delete(b){const u=A.k(this,b,this.comparator);return u&&(this.f-=1),u}forEach(b,u){let c=this.e.forward[0];for(;c;)b.call(u,c.value,c.key,this),c=c.forward[0]}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this.e.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this.e.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this.e.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",u=this.e.forward[0];for(;u;)b+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return b}static g(b,u,c){let w=b.e;for(let O=b.d-1;O>=0;O--)for(;w.forward[O]&&c(w.forward[O].key,u)<0;)w=w.forward[O];if(w=w.forward[0],w&&c(w.key,u)===0)return w}static h(b,u,c,w){const O=[];let m=b.e;for(let h=b.d-1;h>=0;h--){for(;m.forward[h]&&w(m.forward[h].key,u)<0;)m=m.forward[h];O[h]=m}if(m=m.forward[0],m&&w(m.key,u)===0)return m.value=c,!1;{const h=A.j(b);if(h>b.d){for(let S=b.d;S<h;S++)O[S]=b.e;b.d=h}m=new N(h,u,c);for(let S=0;S<h;S++)m.forward[S]=O[S].forward[S],O[S].forward[S]=m;return!0}}static j(b,u=.5){let c=1;for(;Math.random()<u&&c<b.c;)c+=1;return c}static k(b,u,c){const w=[];let O=b.e;for(let m=b.d-1;m>=0;m--){for(;O.forward[m]&&c(O.forward[m].key,u)<0;)O=O.forward[m];w[m]=O}if(O=O.forward[0],!O||c(O.key,u)!==0)return!1;for(let m=0;m<b.d&&w[m].forward[m]===O;m++)w[m].forward[m]=O.forward[m];for(;b.d>0&&b.e.forward[b.d-1]===D;)b.d-=1;return!0}}e.$br=A}),define(ne[41],re([0,1,9,2]),function(G,e,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=void 0;function D($){const p=$;return p?typeof p.read=="function":!1}e.$ub=D;function A($){const p=$;return p?[p.on,p.pause,p.resume,p.destroy].every(t=>typeof t=="function"):!1}e.$vb=A;function L($){const p=$;return p?A(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.$wb=L;function b($,p){return new u($,p)}e.$xb=b;class u{constructor(p,t){this.e=p,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(t=>t(p))}h(p){this.c.error.length===0?(0,M.$Y)(p):this.c.error.slice(0).forEach(t=>t(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,t){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(p,t){if(this.a.destroyed)return;let a;switch(p){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c($,p){const t=[];let a;for(;(a=$.read())!==null;)t.push(a);return p(t)}e.$yb=c;function w($,p,t){const a=[];let i;for(;(i=$.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?p(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return $.read()}}}e.$zb=w;function O($,p){return new Promise((t,a)=>{const i=[];m($,{onData:n=>{p&&i.push(n)},onError:n=>{p?a(n):t(void 0)},onEnd:()=>{t(p?p(i):void 0)}})})}e.$Ab=O;function m($,p){let t=!1;return $.on("error",a=>{t||p.onError(a)}),$.on("end",()=>{t||p.onEnd()}),$.on("data",a=>{t||p.onData(a)}),(0,N.$jb)(()=>t=!0)}e.$Bb=m;function h($,p){return new Promise((t,a)=>{const i=new N.$kb,n=[],s=I=>{if(n.push(I),n.length>p)return i.dispose(),$.pause(),t({stream:$,buffer:n,ended:!1})},o=I=>a(I),l=()=>t({stream:$,buffer:n,ended:!0});i.add((0,N.$jb)(()=>$.removeListener("error",o))),$.on("error",o),i.add((0,N.$jb)(()=>$.removeListener("end",l))),$.on("end",l),i.add((0,N.$jb)(()=>$.removeListener("data",s))),$.on("data",s)})}e.$Cb=h;function S($,p){const t=b(p);return t.end($),t}e.$Db=S;function y(){const $=b(()=>{throw new Error("not supported")});return $.end(),$}e.$Eb=y;function g($){let p=!1;return{read:()=>p?null:(p=!0,$)}}e.$Fb=g;function d($,p,t){const a=b(t);return m($,{onData:i=>a.write(p.data(i)),onError:i=>a.error(p.error?p.error(i):i),onEnd:()=>a.end()}),a}e.$Gb=d;function f($,p,t){let a=!1;return{read:()=>{const i=p.read();return a?i:(a=!0,i!==null?t([$,i]):$)}}}e.$Hb=f;function P($,p,t){let a=!1;const i=b(t);return m(p,{onData:n=>a?i.write(n):(a=!0,i.write(t([$,n]))),onError:n=>i.error(n),onEnd:()=>{a||(a=!0,i.write($)),i.end()}}),i}e.$Ib=P}),define(ne[14],re([0,1,164,41]),function(G,e,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=void 0;const D=typeof Buffer<"u",A=new M.$T(()=>new Uint8Array(256));let L,b;class u{static alloc(j){return D?new u(Buffer.allocUnsafe(j)):new u(new Uint8Array(j))}static wrap(j){return D&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new u(j)}static fromString(j,W){return!(W?.dontUseNodeBuffer||!1)&&D?new u(Buffer.from(j)):(L||(L=new TextEncoder),new u(L.encode(j)))}static fromByteArray(j){const W=u.alloc(j.length);for(let ee=0,x=j.length;ee<x;ee++)W.buffer[ee]=j[ee];return W}static concat(j,W){if(typeof W>"u"){W=0;for(let le=0,te=j.length;le<te;le++)W+=j[le].byteLength}const ee=u.alloc(W);let x=0;for(let le=0,te=j.length;le<te;le++){const ae=j[le];ee.set(ae,x),x+=ae.byteLength}return ee}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=u.alloc(this.byteLength);return j.set(this),j}toString(){return D?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(j,W){return new u(this.buffer.subarray(j,W))}set(j,W){if(j instanceof u)this.buffer.set(j.buffer,W);else if(j instanceof Uint8Array)this.buffer.set(j,W);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),W);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),W);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return m(this.buffer,j)}writeUInt32BE(j,W){h(this.buffer,j,W)}readUInt32LE(j){return S(this.buffer,j)}writeUInt32LE(j,W){y(this.buffer,j,W)}readUInt8(j){return g(this.buffer,j)}writeUInt8(j,W){d(this.buffer,j,W)}indexOf(j,W=0){return c(this.buffer,j instanceof u?j.buffer:j,W)}}e.$Jb=u;function c(k,j,W=0){const ee=j.byteLength,x=k.byteLength;if(ee===0)return 0;if(ee===1)return k.indexOf(j[0]);if(ee>x-W)return-1;const le=A.value;le.fill(j.length);for(let ie=0;ie<j.length;ie++)le[j[ie]]=j.length-ie-1;let te=W+j.length-1,ae=te,ce=-1;for(;te<x;)if(k[te]===j[ae]){if(ae===0){ce=te;break}te--,ae--}else te+=Math.max(j.length-ae,le[k[te]]),ae=j.length-1;return ce}e.$Kb=c;function w(k,j){return k[j+0]<<0>>>0|k[j+1]<<8>>>0}e.$Lb=w;function O(k,j,W){k[W+0]=j&255,j=j>>>8,k[W+1]=j&255}e.$Mb=O;function m(k,j){return k[j]*2**24+k[j+1]*2**16+k[j+2]*2**8+k[j+3]}e.$Nb=m;function h(k,j,W){k[W+3]=j,j=j>>>8,k[W+2]=j,j=j>>>8,k[W+1]=j,j=j>>>8,k[W]=j}e.$Ob=h;function S(k,j){return k[j+0]<<0>>>0|k[j+1]<<8>>>0|k[j+2]<<16>>>0|k[j+3]<<24>>>0}e.$Pb=S;function y(k,j,W){k[W+0]=j&255,j=j>>>8,k[W+1]=j&255,j=j>>>8,k[W+2]=j&255,j=j>>>8,k[W+3]=j&255}e.$Qb=y;function g(k,j){return k[j]}e.$Rb=g;function d(k,j,W){k[W]=j}e.$Sb=d;function f(k){return N.$yb(k,j=>u.concat(j))}e.$Tb=f;function P(k){return N.$Fb(k)}e.$Ub=P;function $(k){return N.$Ab(k,j=>u.concat(j))}e.$Vb=$;async function p(k){return k.ended?u.concat(k.buffer):u.concat([...k.buffer,await $(k.stream)])}e.$Wb=p;function t(k){return N.$Db(k,j=>u.concat(j))}e.$Xb=t;function a(k){return N.$Gb(k,{data:j=>typeof j=="string"?u.fromString(j):u.wrap(j)},j=>u.concat(j))}e.$Yb=a;function i(k){return N.$xb(j=>u.concat(j),k)}e.$Zb=i;function n(k,j){return N.$Hb(k,j,W=>u.concat(W))}e.$1b=n;function s(k,j){return N.$Ib(k,j,W=>u.concat(W))}e.$2b=s;function o(k){let j=0,W=0,ee=0;const x=new Uint8Array(Math.floor(k.length/4*3)),le=ae=>{switch(W){case 3:x[ee++]=j|ae,W=0;break;case 2:x[ee++]=j|ae>>>2,j=ae<<6,W=3;break;case 1:x[ee++]=j|ae>>>4,j=ae<<4,W=2;break;default:j=ae<<2,W=1}};for(let ae=0;ae<k.length;ae++){const ce=k.charCodeAt(ae);if(ce>=65&&ce<=90)le(ce-65);else if(ce>=97&&ce<=122)le(ce-97+26);else if(ce>=48&&ce<=57)le(ce-48+52);else if(ce===43||ce===45)le(62);else if(ce===47||ce===95)le(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${k[ae]}`)}}const te=ee;for(;W>0;)le(0);return u.wrap(x).slice(0,te)}e.$3b=o;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:k},j=!0,W=!1){const ee=W?I:l;let x="";const le=k.byteLength%3;let te=0;for(;te<k.byteLength-le;te+=3){const ae=k[te+0],ce=k[te+1],ie=k[te+2];x+=ee[ae>>>2],x+=ee[(ae<<4|ce>>>4)&63],x+=ee[(ce<<2|ie>>>6)&63],x+=ee[ie&63]}if(le===1){const ae=k[te+0];x+=ee[ae>>>2],x+=ee[ae<<4&63],j&&(x+="==")}else if(le===2){const ae=k[te+0],ce=k[te+1];x+=ee[ae>>>2],x+=ee[(ae<<4|ce>>>4)&63],x+=ee[ce<<2&63],j&&(x+="=")}return x}e.$4b=E}),define(ne[42],re([0,1,28]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=void 0;function N(d){return D(d,0)}e.$di=N;function D(d,f){switch(typeof d){case"object":return d===null?A(349,f):Array.isArray(d)?u(d,f):c(d,f);case"string":return b(d,f);case"boolean":return L(d,f);case"number":return A(d,f);case"undefined":return A(937,f);default:return A(617,f)}}e.$ei=D;function A(d,f){return(f<<5)-f+d|0}e.$fi=A;function L(d,f){return A(d?433:863,f)}function b(d,f){f=A(149417,f);for(let P=0,$=d.length;P<$;P++)f=A(d.charCodeAt(P),f);return f}e.$gi=b;function u(d,f){return f=A(104579,f),d.reduce((P,$)=>D($,P),f)}function c(d,f){return f=A(181387,f),Object.keys(d).sort().reduce((P,$)=>(P=b($,P),D(d[$],P)),f)}class w{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=D(f,this.g),this.g}}e.$hi=w;var O;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function m(d,f,P=32){const $=P-f,p=~((1<<$)-1);return(d<<f|(p&d)>>>$)>>>0}function h(d,f=0,P=d.byteLength,$=0){for(let p=0;p<P;p++)d[f+p]=$}function S(d,f,P="0"){for(;d.length<f;)d=P+d;return d}function y(d,f=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(P=>P.toString(16).padStart(2,"0")).join(""):S((d>>>0).toString(16),f/4)}e.$ii=y;class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const P=f.length;if(P===0)return;const $=this.p;let p=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=f.charCodeAt(0),i=0);;){let n=a;if(M.$Qd(a))if(i+1<P){const s=f.charCodeAt(i+1);M.$Rd(s)?(i++,n=M.$Sd(a,s)):n=65533}else{t=a;break}else M.$Rd(a)&&(n=65533);if(p=this.w($,p,n),i++,i<P)a=f.charCodeAt(i);else break}this.r=p,this.u=t}w(f,P,$){return $<128?f[P++]=$:$<2048?(f[P++]=192|($&1984)>>>6,f[P++]=128|($&63)>>>0):$<65536?(f[P++]=224|($&61440)>>>12,f[P++]=128|($&4032)>>>6,f[P++]=128|($&63)>>>0):(f[P++]=240|($&1835008)>>>18,f[P++]=128|($&258048)>>>12,f[P++]=128|($&4032)>>>6,f[P++]=128|($&63)>>>0),P>=64&&(this.y(),P-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=g.g,P=this.q;for(let l=0;l<64;l+=4)f.setUint32(l,P.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)f.setUint32(l,m(f.getUint32(l-12,!1)^f.getUint32(l-32,!1)^f.getUint32(l-56,!1)^f.getUint32(l-64,!1),1),!1);let $=this.h,p=this.l,t=this.m,a=this.n,i=this.o,n,s,o;for(let l=0;l<80;l++)l<20?(n=p&t|~p&a,s=1518500249):l<40?(n=p^t^a,s=1859775393):l<60?(n=p&t|p&a|t&a,s=2400959708):(n=p^t^a,s=3395469782),o=m($,5)+n+i+s+f.getUint32(l*4,!1)&4294967295,i=a,a=t,t=m(p,30),p=$,$=o;this.h=this.h+$&4294967295,this.l=this.l+p&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}e.$ji=g}),define(ne[54],re([0,1,28]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(N||(N={})),function(D){const A="error",L="warning",b="warn",u="info",c="ignore";function w(m){return m?M.$Md(A,m)?D.Error:M.$Md(L,m)||M.$Md(b,m)?D.Warning:M.$Md(u,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=w;function O(m){switch(m){case D.Error:return A;case D.Warning:return L;case D.Info:return u;default:return c}}D.toString=O}(N||(N={})),e.default=N}),define(ne[30],re([0,1,3]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=void 0;function N(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const f=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([P,$])=>{f[P]=$&&typeof $=="object"?N($):$}),f}e.$Hm=N;function D(d){if(!d||typeof d!="object")return d;const f=[d];for(;f.length>0;){const P=f.shift();Object.freeze(P);for(const $ in P)if(A.call(P,$)){const p=P[$];typeof p=="object"&&!Object.isFrozen(p)&&!(0,M.$me)(p)&&f.push(p)}}return d}e.$Im=D;const A=Object.prototype.hasOwnProperty;function L(d,f){return b(d,f,new Set)}e.$Jm=L;function b(d,f,P){if((0,M.$se)(d))return d;const $=f(d);if(typeof $<"u")return $;if(Array.isArray(d)){const p=[];for(const t of d)p.push(b(t,f,P));return p}if((0,M.$le)(d)){if(P.has(d))throw new Error("Cannot clone recursive data-structure");P.add(d);const p={};for(const t in d)A.call(d,t)&&(p[t]=b(d[t],f,P));return P.delete(d),p}return d}function u(d,f,P=!0){return(0,M.$le)(d)?((0,M.$le)(f)&&Object.keys(f).forEach($=>{$ in d?P&&((0,M.$le)(d[$])&&(0,M.$le)(f[$])?u(d[$],f[$],P):d[$]=f[$]):d[$]=f[$]}),d):f}e.$Km=u;function c(d,f){if(d===f)return!0;if(d==null||f===null||f===void 0||typeof d!=typeof f||typeof d!="object"||Array.isArray(d)!==Array.isArray(f))return!1;let P,$;if(Array.isArray(d)){if(d.length!==f.length)return!1;for(P=0;P<d.length;P++)if(!c(d[P],f[P]))return!1}else{const p=[];for($ in d)p.push($);p.sort();const t=[];for($ in f)t.push($);if(t.sort(),!c(p,t))return!1;for(P=0;P<p.length;P++)if(!c(d[p[P]],f[p[P]]))return!1}return!0}e.$Lm=c;function w(d){const f=new Set;return JSON.stringify(d,(P,$)=>{if((0,M.$le)($)||Array.isArray($)){if(f.has($))return"[Circular]";f.add($)}return $})}e.$Mm=w;function O(d,f){const P=Object.create(null);return!d||!f||Object.keys(f).forEach(p=>{const t=d[p],a=f[p];c(t,a)||(P[p]=a)}),P}e.$Nm=O;function m(d,f){const P=f.toLowerCase(),$=Object.keys(d).find(p=>p.toLowerCase()===P);return $?d[$]:d[f]}e.$Om=m;function h(d,f){const P=Object.create(null);for(const[$,p]of Object.entries(d))f($,p)&&(P[$]=p);return P}e.$Pm=h;function S(d){let f=[];for(;Object.prototype!==d;)f=f.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return f}e.$Qm=S;function y(d){const f=[];for(const P of S(d))typeof d[P]=="function"&&f.push(P);return f}e.$Rm=y;function g(d,f){const P=p=>function(){const t=Array.prototype.slice.call(arguments,0);return f(p,t)},$={};for(const p of d)$[p]=P(p);return $}e.$Sm=g}),define(ne[29],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=void 0;const M=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(D){return M.test(D)}e.$5e=N,e.$6e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(b){for(let u=0;u<b.length;u++)b[u]=Math.floor(Math.random()*256);return b};const A=new Uint8Array(16),L=[];for(let b=0;b<256;b++)L.push(b.toString(16).padStart(2,"0"));return function(){D(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,c="";return c+=L[A[u++]],c+=L[A[u++]],c+=L[A[u++]],c+=L[A[u++]],c+="-",c+=L[A[u++]],c+=L[A[u++]],c+="-",c+=L[A[u++]],c+=L[A[u++]],c+="-",c+=L[A[u++]],c+=L[A[u++]],c+="-",c+=L[A[u++]],c+=L[A[u++]],c+=L[A[u++]],c+=L[A[u++]],c+=L[A[u++]],c+=L[A[u++]],c}}()}),define(ne[74],re([0,1,32]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(L){const b=L.replace(/\-/g,":").toLowerCase();return!N.has(b)}function A(){const L=(0,M.networkInterfaces)();for(const b in L){const u=L[b];if(u){for(const{mac:c}of u)if(D(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$sm=A}),define(ne[75],re([0,1,32,46,29,74]),function(G,e,M,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0,e.$tm=new class{c(c){return this.a||(this.a=N.$vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(c)}value(){if(this.b===void 0){let c=0,w=0;const O=(0,M.networkInterfaces)();for(const m in O){const h=O[m];if(h)for(const{mac:S,internal:y}of h)y||(w+=1,this.c(S.toUpperCase())&&(c+=1))}this.b=w>0?c/w:0}return this.b}};let L;async function b(c){return L||(L=(async()=>await u(c)||D.$6e())()),L}e.$um=b;async function u(c){try{const w=await new Promise((m,h)=>{G(["crypto"],m,h)}),O=(0,A.$sm)();return w.createHash("sha256").update(O,"utf8").digest("hex")}catch(w){c(w);return}}}),define(ne[76],re([7,5]),function(G,e){return G.create("vs/base/common/date",e)}),define(ne[77],re([0,1,76]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=void 0;const N=60,D=N*60,A=D*24,L=A*7,b=A*30,u=A*365;function c(O,m,h,S){typeof O!="number"&&(O=O.getTime());const y=Math.round((new Date().getTime()-O)/1e3);if(y<-30)return(0,M.localize)(0,null,c(new Date().getTime()+y*1e3,!1));if(!S&&y<30)return(0,M.localize)(1,null);let g;return y<N?(g=y,m?g===1?h?(0,M.localize)(2,null,g):(0,M.localize)(3,null,g):h?(0,M.localize)(4,null,g):(0,M.localize)(5,null,g):g===1?h?(0,M.localize)(6,null,g):(0,M.localize)(7,null,g):h?(0,M.localize)(8,null,g):(0,M.localize)(9,null,g)):y<D?(g=Math.floor(y/N),m?g===1?h?(0,M.localize)(10,null,g):(0,M.localize)(11,null,g):h?(0,M.localize)(12,null,g):(0,M.localize)(13,null,g):g===1?h?(0,M.localize)(14,null,g):(0,M.localize)(15,null,g):h?(0,M.localize)(16,null,g):(0,M.localize)(17,null,g)):y<A?(g=Math.floor(y/D),m?g===1?h?(0,M.localize)(18,null,g):(0,M.localize)(19,null,g):h?(0,M.localize)(20,null,g):(0,M.localize)(21,null,g):g===1?h?(0,M.localize)(22,null,g):(0,M.localize)(23,null,g):h?(0,M.localize)(24,null,g):(0,M.localize)(25,null,g)):y<L?(g=Math.floor(y/A),m?g===1?(0,M.localize)(26,null,g):(0,M.localize)(27,null,g):g===1?(0,M.localize)(28,null,g):(0,M.localize)(29,null,g)):y<b?(g=Math.floor(y/L),m?g===1?h?(0,M.localize)(30,null,g):(0,M.localize)(31,null,g):h?(0,M.localize)(32,null,g):(0,M.localize)(33,null,g):g===1?h?(0,M.localize)(34,null,g):(0,M.localize)(35,null,g):h?(0,M.localize)(36,null,g):(0,M.localize)(37,null,g)):y<u?(g=Math.floor(y/b),m?g===1?h?(0,M.localize)(38,null,g):(0,M.localize)(39,null,g):h?(0,M.localize)(40,null,g):(0,M.localize)(41,null,g):g===1?h?(0,M.localize)(42,null,g):(0,M.localize)(43,null,g):h?(0,M.localize)(44,null,g):(0,M.localize)(45,null,g)):(g=Math.floor(y/u),m?g===1?h?(0,M.localize)(46,null,g):(0,M.localize)(47,null,g):h?(0,M.localize)(48,null,g):(0,M.localize)(49,null,g):g===1?h?(0,M.localize)(50,null,g):(0,M.localize)(51,null,g):h?(0,M.localize)(52,null,g):(0,M.localize)(53,null,g))}e.$Rl=c;function w(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Sl=w}),define(ne[78],re([7,5]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ne[33],re([0,1,19,3,78]),function(G,e,M,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=void 0;function A(O,m){return m&&(O.stack||O.stacktrace)?D.localize(0,null,b(O),L(O.stack)||L(O.stacktrace)):b(O)}function L(O){return Array.isArray(O)?O.join(`
`):O}function b(O){return O.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${O.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof O.code=="string"&&typeof O.errno=="number"&&typeof O.syscall=="string"?D.localize(1,null,O.message):O.message||D.localize(2,null)}function u(O=null,m=!1){if(!O)return D.localize(3,null);if(Array.isArray(O)){const h=M.$mf(O),S=u(h[0],m);return h.length>1?D.localize(4,null,S,h.length):S}if(N.$je(O))return O;if(O.detail){const h=O.detail;if(h.error)return A(h.error,m);if(h.exception)return A(h.exception,m)}return O.stack?A(O,m):O.message?O.message:D.localize(5,null)}e.$ai=u;function c(O){const m=O;return m instanceof Error&&Array.isArray(m.actions)}e.$bi=c;function w(O,m){let h;return typeof O=="string"?h=new Error(O):h=O,h.actions=m,h}e.$ci=w}),define(ne[79],re([7,5]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ne[80],re([0,1,79]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=void 0;function N(D){switch(D){case 1:return(0,M.localize)(0,null);case 2:return(0,M.localize)(1,null);case 3:return(0,M.localize)(2,null);case 4:return(0,M.localize)(3,null);case 5:return(0,M.localize)(4,null);case 6:return(0,M.localize)(5,null);case 7:return(0,M.localize)(6,null);case 8:return(0,M.localize)(7,null);case 9:return(0,M.localize)(8,null);default:return""}}e.$bp=N}),define(ne[55],re([0,1,13]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.TerminateResponseCode=e.Source=void 0;var N;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(N||(e.Source=N={}));var D;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(D||(e.TerminateResponseCode=D={}));function A(b,...u){const c=u.reduce((m,h)=>(m[h]=!0,m),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!c[m]).forEach(m=>{for(let h=0;h<w.length;h++)if(m.search(w[h])!==-1){delete b[m];break}})}e.$fl=A;function L(b){b&&(delete b.DEBUG,M.$j&&delete b.DYLD_LIBRARY_PATH,M.$k&&delete b.LD_PRELOAD)}e.$gl=L}),define(ne[81],re([0,1,11]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Ep=e.$Dp=e.$Cp=void 0;function N(c){const w=c;return w&&typeof w.type=="string"&&typeof w.severity=="string"}e.$Cp=N;function D(c){const w=[];let O;try{const m=JSON.parse(c.arguments),h=m[m.length-1];h&&h.__$stack&&(m.pop(),O=h.__$stack),w.push(...m)}catch{w.push("Unable to log remote console arguments",c.arguments)}return{args:w,stack:O}}e.$Dp=D;function A(c){if(typeof c!="string")return A(D(c).stack);const w=c;if(w){const O=L(w),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(m&&m.length===4)return{uri:M.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$Ep=A;function L(c){if(!c)return c;const w=c.indexOf(`
`);return w===-1?c:c.substring(0,w)}function b(c,w){const{args:O,stack:m}=D(c),h=typeof O[0]=="string"&&O.length===1;let S=L(m);S&&(S=`(${S.trim()})`);let y=[];if(typeof O[0]=="string"?S&&h?y=[`%c[${w}] %c${O[0]} %c${S}`,u("blue"),u(""),u("grey")]:y=[`%c[${w}] %c${O[0]}`,u("blue"),u(""),...O.slice(1)]:y=[`%c[${w}]%`,u("blue"),...O],S&&!h&&y.push(S),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,y)}e.log=b;function u(c){return`color: ${c}`}}),define(ne[47],re([0,1,14,28,11]),function(G,e,M,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=e.$Xg=e.$Wg=void 0;function A(c){return JSON.stringify(c,b)}e.$Wg=A;function L(c){let w=JSON.parse(c);return w=u(w),w}e.$Xg=L;function b(c,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,N.$zd)(w)}:w}function u(c,w=0){if(!c||w>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return D.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof M.$Jb||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let O=0;O<c.length;++O)c[O]=u(c[O],w+1);else for(const O in c)Object.hasOwnProperty.call(c,O)&&(c[O]=u(c[O],w+1))}return c}e.$Yg=u}),define(ne[82],re([0,1,70,15,13,11]),function(G,e,M,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WC=void 0;class L{constructor(m,h,S){this.id=m,this.dependencies=h,this.callback=S}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,h,S)=>{typeof m!="string"&&(S=h,h=m,m=null),(typeof h!="object"||!Array.isArray(h))&&(S=h,h=null),this.c.push(new L(m,h,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const h=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!h)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(m){return new Promise((h,S)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const g=()=>{y.removeEventListener("load",d),y.removeEventListener("error",f)},d=P=>{g(),h(this.c.pop())},f=P=>{g(),S(P)};y.addEventListener("load",d),y.addEventListener("error",f),this.f&&(m=this.f.createScriptURL(m)),y.setAttribute("src",m),document.getElementsByTagName("head")[0].appendChild(y)})}i(m){return new Promise((h,S)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),h(this.c.pop())}catch(y){S(y)}})}async j(m){try{const h=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,g=A.URI.parse(m).fsPath,d=h.readFileSync(g).toString(),f=y.wrap(d.replace(/^#!.*/,""));return new S.Script(f).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const u=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function w(O,m,h){if(M.$R){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[O]&&(O=c[O]);const S=`${O}/${m}`;if(u.has(S))return u.get(S);let y;if(/^\w[\w\d+.-]*:\/\//.test(S))y=S;else{const P=`${h&&!D.$o?N.$2e:N.$1e}/${S}`;y=N.$4e.asBrowserUri(P).toString(!0)}const g=b.INSTANCE.load(y);return u.set(S,g),g}else return await new Promise((S,y)=>{G([O],S,y)})}e.$WC=w}),define(ne[83],re([0,1,32,16,24]),function(G,e,M,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=void 0;const A=/^\d+$/,L=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var u;(function($){$[$.x64=0]="x64",$[$.x86=1]="x86",$[$.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class O{constructor(p,t,a){this.exePath=p,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:$=!1}={}){return $?c===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:$=!1,findPreview:p=!1}={}){const t=m({useAlternateBitness:$});if(!t)return null;const a=N.$ac(t,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(a))return null;let i=-1,n=null;for(const l of await D.Promises.readdir(a)){let I=-1;if(p){const k=l.indexOf("-");if(k<0)continue;const j=l.substring(0,k);if(!A.test(j)||l.substring(k+1)!=="preview")continue;I=parseInt(j,10)}else{if(!A.test(l))continue;I=parseInt(l,10)}if(I<=i)continue;const E=N.$ac(a,l,"pwsh.exe");await D.SymlinkSupport.existsFile(E)&&(n=E,i=I)}if(!n)return null;const s=t.includes("x86")?" (x86)":"",o=p?" Preview":"";return new O(n,`PowerShell${o}${s}`,!0)}async function S({findPreview:$}={}){if(!process.env.LOCALAPPDATA)return null;const p=N.$ac(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(p))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=$?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const i of await D.Promises.readdir(p))if(t.test(i)){const n=N.$ac(p,i,"pwsh.exe");return new O(n,a)}return null}function y(){const $=N.$ac(M.homedir(),".dotnet","tools","pwsh.exe");return new O($,".NET Core PowerShell Global Tool")}function g(){const $=N.$ac(process.env.windir,c===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O($,"Windows PowerShell",!0)}async function*d(){let $=await h();$&&(yield $),$=await h({useAlternateBitness:!0}),$&&(yield $),$=await S(),$&&(yield $),$=y(),$&&(yield $),$=await h({findPreview:!0}),$&&(yield $),$=await S({findPreview:!0}),$&&(yield $),$=await h({useAlternateBitness:!0,findPreview:!0}),$&&(yield $),$=g(),$&&(yield $)}async function*f(){for await(const $ of d())await $.exists()&&(yield $)}e.$dl=f;async function P(){for await(const $ of f())return $;return null}e.$el=P}),define(ne[56],re([0,1,16,13,34,55,3,24]),function(G,e,M,N,D,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$il=e.$hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(O=D.env){return O.comspec||"cmd.exe"}e.$hl=u;function c(O){let m=[],h=!1;const S=function(y){if(h){m.push(y);return}(!O.send(y,d=>{if(d&&console.error(d),h=!1,m.length>0){const f=m.slice(0);m=[],f.forEach(P=>S(P))}})||N.$i)&&(h=!0)};return{send:S}}e.$il=c;var w;(function(O){async function m(h,S,y){if(M.$_b(h))return h;if(S===void 0&&(S=D.cwd()),M.$dc(h)!=="."||(y===void 0&&L.$je(D.env.PATH)&&(y=D.env.PATH.split(M.$kc)),y===void 0||y.length===0))return M.$ac(S,h);async function d(f){if(await b.Promises.exists(f)){let P;try{P=await b.Promises.stat(f)}catch($){$.message.startsWith("EACCES")&&(P=await b.Promises.lstat(f))}return P?!P.isDirectory():!1}return!1}for(const f of y){let P;if(M.$_b(f)?P=M.$ac(f,h):P=M.$ac(S,f,h),await d(P))return P;let $=P+".com";if(await d($)||($=P+".exe",await d($)))return $}return M.$ac(S,h)}O.findExecutable=m})(w||(e.win32=w={}))}),define(ne[84],re([0,1,32,13,83,56]),function(G,e,M,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=void 0;async function L(O,m){return O===1?N.$i?w():A.$hl(m):u(O,m)}e.$jl=L;let b=null;function u(O,m){if(N.$k&&O===2||N.$j&&O===3)return"/bin/bash";if(!b){let h;if(N.$i)h="/bin/bash";else{if(h=m.SHELL,!h)try{h=(0,M.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}b=h}return b}let c=null;async function w(){return c||(c=(await(0,D.$el)()).exePath),c}});var pe=this&&this.__decorate||function(G,e,M,N){var D=arguments.length,A=D<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,M):N,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,M,N);else for(var b=G.length-1;b>=0;b--)(L=G[b])&&(A=(D<3?L(A):D>3?L(e,M,A):L(e,M))||A);return D>3&&A&&Object.defineProperty(e,M,A),A};define(ne[57],re([0,1,19,8,14,20,52,9,4,2,47,28,3]),function(G,e,M,N,D,A,L,b,u,c,w,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.ProxyChannel=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.RequestInitiator=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=void 0;var h;(function(C){C[C.Promise=100]="Promise",C[C.PromiseCancel=101]="PromiseCancel",C[C.EventListen=102]="EventListen",C[C.EventDispose=103]="EventDispose"})(h||(h={}));function S(C){switch(C){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(C){C[C.Initialize=200]="Initialize",C[C.PromiseSuccess=201]="PromiseSuccess",C[C.PromiseError=202]="PromiseError",C[C.PromiseErrorObj=203]="PromiseErrorObj",C[C.EventFire=204]="EventFire"})(y||(y={}));function g(C){switch(C){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(C){C[C.Uninitialized=0]="Uninitialized",C[C.Idle=1]="Idle"})(d||(d={}));function f(C){let U=0;for(let q=0;;q+=7){const X=C.read(1);if(U|=(X.buffer[0]&127)<<q,!(X.buffer[0]&128))return U}}const P=i(0);function $(C,U){if(U===0){C.write(P);return}let q=0;for(let Y=U;Y!==0;Y=Y>>>7)q++;const X=D.$Jb.alloc(q);for(let Y=0;U!==0;Y++)X.buffer[Y]=U&127,U=U>>>7,U>0&&(X.buffer[Y]|=128);C.write(X)}class p{constructor(U){this.b=U,this.a=0}read(U){const q=this.b.slice(this.a,this.a+U);return this.a+=q.byteLength,q}}e.$Zg=p;class t{constructor(){this.a=[]}get buffer(){return D.$Jb.concat(this.a)}write(U){this.a.push(U)}}e.$1g=t;var a;(function(C){C[C.Undefined=0]="Undefined",C[C.String=1]="String",C[C.Buffer=2]="Buffer",C[C.VSBuffer=3]="VSBuffer",C[C.Array=4]="Array",C[C.Object=5]="Object",C[C.Int=6]="Int"})(a||(a={}));function i(C){const U=D.$Jb.alloc(1);return U.writeUInt8(C,0),U}const n={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},s=typeof Buffer<"u";function o(C,U){if(typeof U>"u")C.write(n.Undefined);else if(typeof U=="string"){const q=D.$Jb.fromString(U);C.write(n.String),$(C,q.byteLength),C.write(q)}else if(s&&Buffer.isBuffer(U)){const q=D.$Jb.wrap(U);C.write(n.Buffer),$(C,q.byteLength),C.write(q)}else if(U instanceof D.$Jb)C.write(n.VSBuffer),$(C,U.byteLength),C.write(U);else if(Array.isArray(U)){C.write(n.Array),$(C,U.length);for(const q of U)o(C,q)}else if(typeof U=="number"&&(U|0)===U)C.write(n.Uint),$(C,U);else{const q=D.$Jb.fromString(JSON.stringify(U));C.write(n.Object),$(C,q.byteLength),C.write(q)}}e.$2g=o;function l(C){switch(C.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return C.read(f(C)).toString();case a.Buffer:return C.read(f(C)).buffer;case a.VSBuffer:return C.read(f(C));case a.Array:{const q=f(C),X=[];for(let Y=0;Y<q;Y++)X.push(l(C));return X}case a.Object:return JSON.parse(C.read(f(C)).toString());case a.Int:return f(C)}}e.$3g=l;class I{constructor(U,q,X=null,Y=1e3){this.h=U,this.j=q,this.k=X,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(U,q){this.b.set(U,q),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const q=this.o([U.type]);this.k?.logOutgoing(q,0,1,g(U.type));return}case 201:case 202:case 204:case 203:{const q=this.o([U.type,U.id],U.data);this.k?.logOutgoing(q,U.id,1,g(U.type),U.data);return}}}o(U,q=void 0){const X=new t;return o(X,U),o(X,q),this.p(X.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const q=new p(U),X=l(q),Y=l(q),K=X[0];switch(K){case 100:return this.k?.logIncoming(U.byteLength,X[1],1,`${S(K)}: ${X[2]}.${X[3]}`,Y),this.s({type:K,id:X[1],channelName:X[2],name:X[3],arg:Y});case 102:return this.k?.logIncoming(U.byteLength,X[1],1,`${S(K)}: ${X[2]}.${X[3]}`,Y),this.t({type:K,id:X[1],channelName:X[2],name:X[3],arg:Y});case 101:return this.k?.logIncoming(U.byteLength,X[1],1,`${S(K)}`),this.u({type:K,id:X[1]});case 103:return this.k?.logIncoming(U.byteLength,X[1],1,`${S(K)}`),this.u({type:K,id:X[1]})}}s(U){const q=this.b.get(U.channelName);if(!q){this.v(U);return}const X=new A.$ed;let Y;try{Y=q.call(this.j,U.name,U.arg,X.token)}catch(R){Y=Promise.reject(R)}const K=U.id;Y.then(R=>{this.m({id:K,data:R,type:201}),this.d.delete(U.id)},R=>{R instanceof Error?this.m({id:K,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.m({id:K,data:R,type:203}),this.d.delete(U.id)});const T=(0,c.$jb)(()=>X.cancel());this.d.set(U.id,T)}t(U){const q=this.b.get(U.channelName);if(!q){this.v(U);return}const X=U.id,K=q.listen(this.j,U.name,U.arg)(T=>this.m({id:X,data:T,type:204}));this.d.set(U.id,K)}u(U){const q=this.d.get(U.id);q&&(q.dispose(),this.d.delete(U.id))}v(U){let q=this.g.get(U.channelName);q||(q=[],this.g.set(U.channelName,q));const X=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:U,timeoutTimer:X})}w(U){const q=this.g.get(U);if(q){for(const X of q)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$gb)(this.d.values()),this.d.clear()}}e.$4g=I;var E;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));class k{constructor(U,q=null){this.l=U,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$8c,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=q}getChannel(U){const q=this;return{call(X,Y,K){return q.a?Promise.reject(new b.$3):q.m(U,X,Y,K)},listen(X,Y){return q.a?u.Event.None:q.o(U,X,Y)}}}m(U,q,X,Y=A.CancellationToken.None){const K=this.g++,R={id:K,type:100,channelName:U,name:q,arg:X};if(Y.isCancellationRequested)return Promise.reject(new b.$3);let r;return new Promise((z,F)=>{if(Y.isCancellationRequested)return F(new b.$3);const J=()=>{const de=ue=>{switch(ue.type){case 201:this.f.delete(K),z(ue.data);break;case 202:{this.f.delete(K);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,F(ge);break}case 203:this.f.delete(K),F(ue.data);break}};this.f.set(K,de),this.p(R)};let Z=null;this.b===d.Idle?J():(Z=(0,N.$jg)(de=>this.u()),Z.then(()=>{Z=null,J()}));const oe=()=>{Z?(Z.cancel(),Z=null):this.p({id:K,type:101}),F(new b.$3)},fe=Y.onCancellationRequested(oe);r=(0,c.$ib)((0,c.$jb)(oe),fe),this.d.add(r)}).finally(()=>{this.d.delete(r)})}o(U,q,X){const Y=this.g++,T={id:Y,type:102,channelName:U,name:q,arg:X};let R=null;const r=new u.$8c({onWillAddFirstListener:()=>{R=(0,N.$jg)(z=>this.u()),R.then(()=>{R=null,this.d.add(r),this.p(T)})},onDidRemoveLastListener:()=>{R?(R.cancel(),R=null):(this.d.delete(r),this.p({id:Y,type:103}))}}),v=z=>r.fire(z.data);return this.f.set(Y,v),r.event}p(U){switch(U.type){case 100:case 102:{const q=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(q,U.id,0,`${S(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const q=this.q([U.type,U.id]);this.j?.logOutgoing(q,U.id,0,S(U.type));return}}}q(U,q=void 0){const X=new t;return o(X,U),o(X,q),this.r(X.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const q=new p(U),X=l(q),Y=l(q),K=X[0];switch(K){case 200:return this.j?.logIncoming(U.byteLength,0,0,g(K)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,X[1],0,g(K),Y),this.t({type:X[0],id:X[1],data:Y})}}t(U){if(U.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$gb)(this.d.values()),this.d.clear()}}e.$5g=k,pe([L.$Tg],k.prototype,"onDidInitializePromise",null);class j{get connections(){const U=[];return this.f.forEach(q=>U.push(q)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new u.$8c,this.onDidAddConnection=this.g.event,this.h=new u.$8c,this.onDidRemoveConnection=this.h.event,U(({protocol:q,onDidClientDisconnect:X})=>{u.Event.once(q.onMessage)(K=>{const T=new p(K),R=l(T),r=new I(q,R),v=new k(q);this.a.forEach((F,J)=>r.registerChannel(J,F));const z={channelServer:r,channelClient:v,ctx:R};this.f.add(z),this.g.fire(z),X(()=>{r.dispose(),v.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(U,q){const X=this;return{call(Y,K,T){let R;if((0,m.$xe)(q)){const v=(0,M.$Kf)(X.connections.filter(q));R=v?Promise.resolve(v):u.Event.toPromise(u.Event.filter(X.onDidAddConnection,q))}else R=q.routeCall(X,Y,K);const r=R.then(v=>v.channelClient.getChannel(U));return ee(r).call(Y,K,T)},listen(Y,K){if((0,m.$xe)(q))return X.j(U,q,Y,K);const T=q.routeEvent(X,Y,K).then(R=>R.channelClient.getChannel(U));return ee(T).listen(Y,K)}}}j(U,q,X,Y){const K=this;let T=new c.$kb;const R=new u.$8c({onWillAddFirstListener:()=>{T=new c.$kb;const r=new u.$bd,v=new Map,z=J=>{const oe=J.channelClient.getChannel(U).listen(X,Y),fe=r.add(oe);v.set(J,fe)},F=J=>{const Z=v.get(J);Z&&(Z.dispose(),v.delete(J))};K.connections.filter(q).forEach(z),u.Event.filter(K.onDidAddConnection,q)(z,void 0,T),K.onDidRemoveConnection(F,void 0,T),r.event(R.fire,R,T),T.add(r)},onDidRemoveLastListener:()=>{T.dispose()}});return R.event}registerChannel(U,q){this.a.set(U,q),this.f.forEach(X=>{X.channelServer.registerChannel(U,q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$6g=j;class W{constructor(U,q,X=null){const Y=new t;o(Y,q),U.send(Y.buffer),this.a=new k(U,X),this.d=new I(U,q,X)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,q){this.d.registerChannel(U,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$7g=W;function ee(C){return{call(U,q,X){return C.then(Y=>Y.call(U,q,X))},listen(U,q){const X=new u.$dd;return C.then(Y=>X.input=Y.listen(U,q)),X.event}}}e.$8g=ee;function x(C){let U=!1;return{call(q,X,Y){return U?C.call(q,X,Y):(0,N.$wg)(0).then(()=>U=!0).then(()=>C.call(q,X,Y))},listen(q,X){if(U)return C.listen(q,X);const Y=new u.$dd;return(0,N.$wg)(0).then(()=>U=!0).then(()=>Y.input=C.listen(q,X)),Y.event}}}e.$9g=x;class le{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const q of U.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await u.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$0g=le;var te;(function(C){function U(K,T){const R=K,r=T&&T.disableMarshalling,v=new Map;for(const z in R)X(z)&&v.set(z,u.Event.buffer(R[z],!0));return new class{listen(z,F,J){const Z=v.get(F);if(Z)return Z;if(Y(F)){const oe=R[F];if(typeof oe=="function")return oe.call(R,J)}throw new b.$ab(`Event not found: ${F}`)}call(z,F,J){const Z=R[F];if(typeof Z=="function"){if(!r&&Array.isArray(J))for(let oe=0;oe<J.length;oe++)J[oe]=(0,w.$Yg)(J[oe]);return Z.apply(R,J)}throw new b.$ab(`Method not found: ${F}`)}}}C.fromService=U;function q(K,T){const R=T&&T.disableMarshalling;return new Proxy({},{get(r,v){if(typeof v=="string")return T?.properties?.has(v)?T.properties.get(v):Y(v)?function(z){return K.listen(v,z)}:X(v)?K.listen(v):async function(...z){let F;T&&!(0,m.$se)(T.context)?F=[T.context,...z]:F=z;const J=await K.call(v,F);return R?J:(0,w.$Yg)(J)};throw new b.$ab(`Property not found: ${String(v)}`)}})}C.toService=q;function X(K){return K[0]==="o"&&K[1]==="n"&&O.$Ld(K.charCodeAt(2))}function Y(K){return/^onDynamic/.test(K)&&O.$Ld(K.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(C){if(Array.isArray(C))return C;if(C&&typeof C=="object"&&typeof C.toString=="function"){const U=C.toString();if(U!=="[object Object]")return U}return C}function ie(C){return Array.isArray(C)?C.map(ce):ce(C)}function V(C,U,q,X,Y,K,T){T=ie(T);const R=ae[Y],r=R[X%R.length];let v=[`%c[${C}]%c[${String(U).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${r}`];/\($/.test(K)?(v=v.concat(T),v.push(")")):v.push(T),console.log.apply(console,v)}class H{constructor(U,q){this.d=U,this.f=q,this.a=0,this.b=0}logOutgoing(U,q,X,Y,K){this.b+=U,V(this.d,this.b,U,q,X,Y,K)}logIncoming(U,q,X,Y,K){this.a+=U,V(this.f,this.a,U,q,X,Y,K)}}e.$$g=H}),define(ne[85],re([0,1,58,8,14,20,81,9,4,2,30,56,55,57]),function(G,e,M,N,D,A,L,b,u,c,w,O,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=void 0;class S extends h.$4g{constructor(d){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>D.$Jb.wrap(Buffer.from(f,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$Gp=S;class y{constructor(d,f){this.i=d,this.j=f,this.c=new Set,this.g=new Map,this.h=new u.$8c,this.onDidProcessExit=this.h.event;const P=f&&f.timeout?f.timeout:6e4;this.b=new N.$sg(P),this.d=null,this.f=null}getChannel(d){const f=this;return{call(P,$,p){return f.k(d,P,$,p)},listen(P,$){return f.l(d,P,$)}}}k(d,f,P,$=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(b.$4());this.b.cancel();const p=this.n(d),t=(0,N.$jg)(n=>p.call(f,P,n)),a=$.onCancellationRequested(()=>t.cancel()),i=(0,c.$jb)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(d,f,P){if(!this.b)return u.Event.None;this.b.cancel();let $;const p=new u.$8c({onWillAddFirstListener:()=>{$=this.n(d).listen(f,P)(p.fire,p),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return p.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,w.$Hm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,m.$gl)(f.env),this.d=(0,M.fork)(this.i,d,f);const P=new u.$8c;u.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,L.$Cp)(s)){(0,L.log)(s,`IPC Library: ${this.j.serverName}`);return}P.fire(D.$Jb.wrap(Buffer.from(s,"base64")))});const p=this.j.useQueue?(0,O.$il)(this.d):this.d,t=s=>this.d&&this.d.connected&&p.send(s.buffer.toString("base64")),a=P.event,i={send:t,onMessage:a};this.f=new h.$5g(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,o)=>{process.removeListener("exit",n),this.c.forEach(l=>(0,c.$gb)(l)),this.c.clear(),s!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:o})})}return this.f}n(d){let f=this.g.get(d);return f||(f=this.m.getChannel(d),this.g.set(d,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Hp=y}),define(ne[86],re([0,1,8,4,2,47,3]),function(G,e,M,N,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.StorageState=e.$Fo=e.StorageHint=void 0;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function u(m){const h=m;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$Fo=u;var c;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(c||(e.StorageState=c={}));class w extends D.$lb{static{this.a=100}constructor(h,S=Object.create(null)){super(),this.m=h,this.n=S,this.b=this.B(new N.$$c),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=new M.$tg(w.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(h=>this.r(h)))}r(h){this.b.pause();try{h.changed?.forEach((S,y)=>this.s(y,S)),h.deleted?.forEach(S=>this.s(S,void 0))}finally{this.b.resume()}}s(h,S){if(this.c===c.Closed)return;let y=!1;(0,L.$se)(S)?y=this.f.delete(h):this.f.get(h)!==S&&(this.f.set(h,S),y=!0),y&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.n.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(h,S){const y=this.f.get(h);return(0,L.$se)(y)?S:y}getBoolean(h,S){const y=this.get(h);return(0,L.$se)(y)?S:y==="true"}getNumber(h,S){const y=this.get(h);return(0,L.$se)(y)?S:parseInt(y,10)}getObject(h,S){const y=this.get(h);return(0,L.$se)(y)?S:(0,A.$Xg)(y)}async set(h,S,y=!1){if(this.c===c.Closed)return;if((0,L.$se)(S))return this.delete(h,y);const g=(0,L.$le)(S)||Array.isArray(S)?(0,A.$Wg)(S):String(S);if(this.f.get(h)!==g)return this.f.set(h,g),this.j.set(h,g),this.h.delete(h),this.b.fire({key:h,external:y}),this.w()}async delete(h,S=!1){if(!(this.c===c.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:S}),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=c.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(h).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(h){if(this.u)return this.w(h)}async w(h){return this.g.trigger(()=>this.v(),h)}async whenFlushed(){if(this.u)return new Promise(h=>this.l.push(h))}isInMemory(){return this.n.hint===b.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Go=w;class O{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((S,y)=>this.a.set(y,S)),h.delete?.forEach(S=>this.a.delete(S))}async close(){}}e.$Ho=O}),define(ne[87],re([7,5]),function(G,e){return G.create("vs/base/node/zip",e)}),define(ne[88],re([7,5]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],re([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],re([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],re([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],re([7,5]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],re([7,5]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ne[100],re([7,5]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ne[101],re([7,5]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],re([7,5]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],re([7,5]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ne[104],re([7,5]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],re([7,5]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],re([7,5]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],re([7,5]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],re([0,1,9,90]),function(G,e,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.TokenType=void 0;var D;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(D||(e.TokenType=D={}));function A(...c){switch(c.length){case 1:return(0,N.localize)(0,null,c[0]);case 2:return(0,N.localize)(1,null,c[0],c[1]);case 3:return(0,N.localize)(2,null,c[0],c[1],c[2]);default:return}}const L=(0,N.localize)(3,null),b=(0,N.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return w.isTripleEq?"===":"==";case 4:return w.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return w.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return w.lexeme;case 18:return w.lexeme;case 19:return w.lexeme;case 20:return"EOF";default:throw(0,M.$6)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(w){return this.c=w,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const O=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:O})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const O=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:O})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(w){return this.r()||this.c.charCodeAt(this.e)!==w?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(w){this.f.push({type:w,offset:this.d})}l(w){const O=this.d,m=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:m};this.g.push({offset:O,lexeme:m,additionalInfo:w}),this.f.push(h)}n(){this.m.lastIndex=this.d;const w=this.m.exec(this.c);if(w){this.e=this.d+w[0].length;const O=this.c.substring(this.d,this.e),m=u.b.get(O);m?this.k(m):this.f.push({type:17,lexeme:O,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let w=this.e,O=!1,m=!1;for(;;){if(w>=this.c.length){this.e=w,this.l(b);return}const S=this.c.charCodeAt(w);if(O)O=!1;else if(S===47&&!m){w++;break}else S===91?m=!0:S===92?O=!0:S===93&&(m=!1);w++}for(;w<this.c.length&&u.a.has(this.c.charCodeAt(w));)w++;this.e=w;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$si=u}),define(ne[109],re([0,1,77,52,15,16,34,17,11]),function(G,e,M,N,D,A,L,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=e.$Ul=e.$Tl=void 0,e.$Tl=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.$dc)(D.$4e.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$ac)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,b.$0f)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:D.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,b.$0f)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,M.$Sl)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$ac)(this.userDataPath,"logs",h)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.$0f)(u.URI.file((0,A.$ac)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.$0f)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.$0f)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.$0f)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=L.env.VSCODE_PORTABLE;return h?u.URI.file((0,A.$ac)(h,"argv.json")):(0,b.$0f)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$ac)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,A.$bc)(h):(0,A.$$b)((0,A.$ac)(D.$4e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?u.URI.file((0,A.$bc)(h)):u.URI.file((0,A.$ac)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,A.$bc)(h);const S=L.env.VSCODE_EXTENSIONS;if(S)return S;const y=L.env.VSCODE_PORTABLE;return y?(0,A.$ac)(y,"extensions"):(0,b.$0f)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(S=>/^[^:/?#]+?:\/\//.test(S)?u.URI.parse(S):u.URI.file((0,A.$$b)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?u.URI.parse(h):u.URI.file((0,A.$$b)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$Tl.test(h))}get extensionLogLevel(){const h=[];for(const S of this.args.log||[]){const y=e.$Tl.exec(S);y&&y[1]&&y[2]&&h.push([y[1],y[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,b.$0f)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get disableKeytar(){return!!this.args["disable-keytar"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=L.env.VSCODE_PORTABLE;return h?u.URI.file((0,A.$ac)(h,"policy.json")):(0,b.$0f)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,S,y){this.a=h,this.b=S,this.c=y,this.editSessionId=this.args.editSessionId}}e.$Ul=c,pe([N.$Tg],c.prototype,"appRoot",null),pe([N.$Tg],c.prototype,"userHome",null),pe([N.$Tg],c.prototype,"userDataPath",null),pe([N.$Tg],c.prototype,"appSettingsHome",null),pe([N.$Tg],c.prototype,"tmpDir",null),pe([N.$Tg],c.prototype,"cacheHome",null),pe([N.$Tg],c.prototype,"stateResource",null),pe([N.$Tg],c.prototype,"userRoamingDataHome",null),pe([N.$Tg],c.prototype,"userDataSyncHome",null),pe([N.$Tg],c.prototype,"sync",null),pe([N.$Tg],c.prototype,"machineSettingsResource",null),pe([N.$Tg],c.prototype,"workspaceStorageHome",null),pe([N.$Tg],c.prototype,"localHistoryHome",null),pe([N.$Tg],c.prototype,"keyboardLayoutResource",null),pe([N.$Tg],c.prototype,"argvResource",null),pe([N.$Tg],c.prototype,"isExtensionDevelopment",null),pe([N.$Tg],c.prototype,"untitledWorkspacesHome",null),pe([N.$Tg],c.prototype,"builtinExtensionsPath",null),pe([N.$Tg],c.prototype,"extensionsPath",null),pe([N.$Tg],c.prototype,"extensionDevelopmentLocationURI",null),pe([N.$Tg],c.prototype,"extensionDevelopmentKind",null),pe([N.$Tg],c.prototype,"extensionTestsLocationURI",null),pe([N.$Tg],c.prototype,"debugExtensionHost",null),pe([N.$Tg],c.prototype,"logLevel",null),pe([N.$Tg],c.prototype,"extensionLogLevel",null),pe([N.$Tg],c.prototype,"serviceMachineIdResource",null),pe([N.$Tg],c.prototype,"disableTelemetry",null),pe([N.$Tg],c.prototype,"disableWorkspaceTrust",null),pe([N.$Tg],c.prototype,"disableKeytar",null),pe([N.$Tg],c.prototype,"policyFile",null);function w(m,h){return O(m["inspect-extensions"],m["inspect-brk-extensions"],5870,h,m.debugId,m.extensionEnvironment)}e.$Vl=w;function O(m,h,S,y,g,d){const P=Number(h||m)||(y?null:S),$=P?!!h:!1;let p;if(d)try{p=JSON.parse(d)}catch{}return{port:P,break:$,debugId:g,env:p}}e.$Wl=O}),function(){"use strict";function G(e,M,N){function D(L,b){const u=A(L,b),c=[u];return e.isAbsolute(u)||c.unshift(N),e.resolve(...c)}function A(L,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,b);const w=L["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(O,"AppData","Roaming")}break;case"darwin":c=e.join(M.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(M.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,b)}return{getUserDataPath:D}}if(typeof define=="function")define(ne[110],re([165,32,34]),function(e,M,N){return G(e,M,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),M=require("os");module.exports=G(e,M,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],re([0,1,32,109,110]),function(G,e,M,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=e.$Xl=void 0;class A extends N.$Ul{constructor(c,w){super(c,{homeDir:(0,M.homedir)(),tmpDir:(0,M.tmpdir)(),userDataDir:(0,D.getUserDataPath)(c,w.nameShort)},w)}}e.$Xl=A;function L(u,c){return(0,N.$Wl)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}e.$Yl=L;function b(u,c){return(0,N.$Wl)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,c,u.extensionEnvironment)}e.$Zl=b}),define(ne[112],re([0,1,3,94]),function(G,e,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=void 0;function D(L,b,u){try{A(L,b,u)}catch(c){console.error(c?.message??c)}return L}e.$cp=D;function A(L,b,u){const c=(w,O,m)=>{const h=w[O];if((0,M.$je)(h)){const S=h,y=S.length;if(y>1&&S[0]==="%"&&S[y-1]==="%"){const g=S.substr(1,y-2);let d=b[g];d===void 0&&u&&(d=u[g]);const f=typeof d=="string"?d:d?.message,P=u?.[g],$=typeof P=="string"?P:P?.message;if(!f){$||console.warn(`[${L.name}]: ${(0,N.localize)(0,null,g)}`);return}if(m&&(O==="title"||O==="category")&&$&&$!==f){const p={value:f,original:$};w[O]=p}else w[O]=f}}else if((0,M.$le)(h))for(const S in h)h.hasOwnProperty(S)&&(S==="commands"?c(h,S,!0):c(h,S,m));else if(Array.isArray(h))for(let S=0;S<h.length;S++)c(h,S,m)};for(const w in L)L.hasOwnProperty(w)&&c(L,w)}}),define(ne[48],re([0,1,17,54,98,43]),function(G,e,M,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function u(d){return d=d.trim(),d==="*"||L.test(d)}e.$ro=u;function c(d){if(!u(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=d.match(L);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$so=c;function w(d){if(!d)return null;const f=d.majorBase,P=d.majorMustEqual,$=d.minorBase;let p=d.minorMustEqual;const t=d.patchBase;let a=d.patchMustEqual;d.hasCaret&&(f===0||(p=!1),a=!1);let i=0;if(d.preRelease){const n=b.exec(d.preRelease);if(n){const[,s,o,l]=n;i=Date.UTC(Number(s),Number(o)-1,Number(l))}}return{majorBase:f,majorMustEqual:P,minorBase:$,minorMustEqual:p,patchBase:t,patchMustEqual:a,isMinimum:d.hasGreaterEquals,notBefore:i}}e.$to=w;function O(d,f,P){let $;typeof d=="string"?$=w(c(d)):$=d;let p;f instanceof Date?p=f.getTime():typeof f=="string"&&(p=new Date(f).getTime());let t;if(typeof P=="string"?t=w(c(P)):t=P,!$||!t)return!1;const a=$.majorBase,i=$.minorBase,n=$.patchBase;let s=t.majorBase,o=t.minorBase,l=t.patchBase;const I=t.notBefore;let E=t.majorMustEqual,k=t.minorMustEqual,j=t.patchMustEqual;return t.isMinimum?a>s?!0:a<s?!1:i>o?!0:i<o||p&&p<I?!1:n>=l:(a===1&&s===0&&(!E||!k||!j)&&(s=1,o=0,l=0,E=!0,k=!1,j=!1),a<s?!1:a>s?!E:i<o?!1:i>o?!k:n<l?!1:n>l?!j:!(p&&p<I))}e.$uo=O;function m(d,f,P,$,p){const t=[];if(typeof $.publisher<"u"&&typeof $.publisher!="string")return t.push([N.default.Error,D.localize(0,null)]),t;if(typeof $.name!="string")return t.push([N.default.Error,D.localize(1,null,"name")]),t;if(typeof $.version!="string")return t.push([N.default.Error,D.localize(2,null,"version")]),t;if(!$.engines)return t.push([N.default.Error,D.localize(3,null,"engines")]),t;if(typeof $.engines.vscode!="string")return t.push([N.default.Error,D.localize(4,null,"engines.vscode")]),t;if(typeof $.extensionDependencies<"u"&&!g($.extensionDependencies))return t.push([N.default.Error,D.localize(5,null,"extensionDependencies")]),t;if(typeof $.activationEvents<"u"){if(!g($.activationEvents))return t.push([N.default.Error,D.localize(6,null,"activationEvents")]),t;if(typeof $.main>"u"&&typeof $.browser>"u")return t.push([N.default.Error,D.localize(7,null,"activationEvents","main","browser")]),t}if(typeof $.extensionKind<"u"&&typeof $.main>"u"&&t.push([N.default.Warning,D.localize(8,null,"extensionKind")]),typeof $.main<"u"){if(typeof $.main!="string")return t.push([N.default.Error,D.localize(9,null,"main")]),t;{const n=(0,M.$0f)(P,$.main);(0,M.$4f)(n,P)||t.push([N.default.Warning,D.localize(10,null,n.path,P.path)])}}if(typeof $.browser<"u"){if(typeof $.browser!="string")return t.push([N.default.Error,D.localize(11,null,"browser")]),t;{const n=(0,M.$0f)(P,$.browser);(0,M.$4f)(n,P)||t.push([N.default.Warning,D.localize(12,null,n.path,P.path)])}}if(!A.valid($.version))return t.push([N.default.Error,D.localize(13,null)]),t;const a=[];if(!h(d,f,$,p,a))for(const n of a)t.push([N.default.Error,n]);return t}e.$vo=m;function h(d,f,P,$,p){return $||typeof P.main>"u"&&typeof P.browser>"u"?!0:y(d,f,P.engines.vscode,p)}e.$wo=h;function S(d,f,P){return d==="*"||y(f,P,d)}e.$xo=S;function y(d,f,P,$=[]){const p=w(c(P));if(!p)return $.push(D.localize(14,null,P)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return $.push(D.localize(15,null,P)),!1}else if(!p.majorMustEqual)return $.push(D.localize(16,null,P)),!1;return O(d,f,p)?!0:($.push(D.localize(17,null,d,P)),!1)}function g(d){if(!Array.isArray(d))return!1;for(let f=0,P=d.length;f<P;f++)if(typeof d[f]!="string")return!1;return!0}}),define(ne[113],re([0,1,14,29]),function(G,e,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=void 0;async function D(A,L,b){let u=b&&b.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const w=(await L.readFile(A.serviceMachineIdResource)).value.toString();u=(0,N.$5e)(w)?w:null}catch{u=null}if(!u){u=(0,N.$6e)();try{await L.writeFile(A.serviceMachineIdResource,M.$Jb.fromString(u))}catch{}}return b?.store("storage.serviceMachineId",u,-1,1),u}e.$Qo=D}),define(ne[49],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=void 0;class M{constructor(D,A=[],L=!1){this.ctor=D,this.staticArguments=A,this.supportsDelayedInstantiation=L}}e.$mh=M}),define(ne[114],re([0,1,49]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=e.InstantiationType=void 0;const N=[];var D;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function A(b,u,c){u instanceof M.$mh||(u=new M.$mh(u,[],!!c)),N.push([b,u])}e.$_q=A;function L(){return N}e.$ar=L}),define(ne[115],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=void 0;class M{constructor(A,L){this.key=A,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$Sp=M;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const L of this.a.values())L.outgoing.size===0&&A.push(L);return A}insertEdge(A,L){const b=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(L);b.outgoing.set(u.key,u),u.incoming.set(b.key,b)}removeNode(A){const L=this.b(A);this.a.delete(L);for(const b of this.a.values())b.outgoing.delete(L),b.incoming.delete(L)}lookupOrInsertNode(A){const L=this.b(A);let b=this.a.get(L);return b||(b=new M(L,A),this.a.set(L,b)),b}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[L,b]of this.a)A.push(`${L}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,L]of this.a){const b=new Set([A]),u=this.c(L,b);if(u)return u}}c(A,L){for(const[b,u]of A.outgoing){if(L.has(b))return[...L,b].join(" -> ");L.add(b);const c=this.c(u,L);if(c)return c;L.delete(b)}}}e.$Tp=N}),define(ne[25],re([0,1,3,11,10]),function(G,e,M,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.ConfigurationTarget=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,D.$ph)("configurationService");function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof N.URI)}e.$Wh=A;function L(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof N.URI)}e.$Xh=L;var b;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function u(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Yh=u;function c(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}e.$Zh=c;function w(d,f){const P=Object.create(null);for(const $ in d)O(P,$,d[$],f);return P}e.$1h=w;function O(d,f,P,$){const p=f.split("."),t=p.pop();let a=d;for(let i=0;i<p.length;i++){const n=p[i];let s=a[n];switch(typeof s){case"undefined":s=a[n]=Object.create(null);break;case"object":break;default:$(`Ignoring ${f} as ${p.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}a=s}if(typeof a=="object"&&a!==null)try{a[t]=P}catch{$(`Ignoring ${f} as ${p.join(".")} is ${JSON.stringify(a)}`)}else $(`Ignoring ${f} as ${p.join(".")} is ${JSON.stringify(a)}`)}e.$2h=O;function m(d,f){const P=f.split(".");h(d,P)}e.$3h=m;function h(d,f){const P=f.shift();if(f.length===0){delete d[P];return}if(Object.keys(d).indexOf(P)!==-1){const $=d[P];typeof $=="object"&&!Array.isArray($)&&(h($,f),Object.keys($).length===0&&delete d[P])}}function S(d,f,P){function $(a,i){let n=a;for(const s of i){if(typeof n!="object"||n===null)return;n=n[s]}return n}const p=f.split("."),t=$(d,p);return typeof t>"u"?P:t}e.$4h=S;function y(d,f,P){Object.keys(f).forEach($=>{$!=="__proto__"&&($ in d?M.$le(d[$])&&M.$le(f[$])?y(d[$],f[$],P):P&&(d[$]=f[$]):d[$]=f[$])})}e.$5h=y;function g(d){return d.replace(/[\[\]]/g,"")}e.$6h=g}),define(ne[116],re([0,1,13,28,108,10,89,9]),function(G,e,M,N,D,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ContextKeyExprType=e.$ti=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",M.$j),u.set("isLinux",M.$k),u.set("isWindows",M.$i),u.set("isWeb",M.$o),u.set("isMacNative",M.$j&&!M.$o),u.set("isEdge",M.$G),u.set("isFirefox",M.$E),u.set("isChrome",M.$D),u.set("isSafari",M.$F);function c(R,r){if(u.get(R)!==void 0)throw(0,b.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(R,r)}e.$ti=c;const w=Object.prototype.hasOwnProperty;var O;(function(R){R[R.False=0]="False",R[R.True=1]="True",R[R.Defined=2]="Defined",R[R.Not=3]="Not",R[R.Equals=4]="Equals",R[R.NotEquals=5]="NotEquals",R[R.And=6]="And",R[R.Regex=7]="Regex",R[R.NotRegex=8]="NotRegex",R[R.Or=9]="Or",R[R.In=10]="In",R[R.NotIn=11]="NotIn",R[R.Greater=12]="Greater",R[R.GreaterEquals=13]="GreaterEquals",R[R.Smaller=14]="Smaller",R[R.SmallerEquals=15]="SmallerEquals"})(O||(e.ContextKeyExprType=O={}));const m={regexParsingWithErrorRecovery:!0},h=(0,L.localize)(0,null),S=(0,L.localize)(1,null),y=(0,L.localize)(2,null),g=(0,L.localize)(3,null),d=(0,L.localize)(4,null),f=(0,L.localize)(5,null),P=(0,L.localize)(6,null),$=(0,L.localize)(7,null);class p{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(r=m){this.k=r,this.d=new D.$si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(r){if(r===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(r).scan(),this.g=0,this.h=[];try{const v=this.l();if(!this.E()){const z=this.D(),F=z.type===17?f:void 0;throw this.h.push({message:d,offset:z.offset,lexeme:D.$si.getLexeme(z),additionalInfo:F}),p.c}return v}catch(v){if(v!==p.c)throw v;return}}l(){return this.m()}m(){const r=[this.o()];for(;this.y(16);){const v=this.o();r.push(v)}return r.length===1?r[0]:t.or(...r)}o(){const r=[this.s()];for(;this.y(15);){const v=this.s();r.push(v)}return r.length===1?r[0]:t.and(...r)}s(){if(this.y(2)){const r=this.D();switch(r.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const v=this.l();return this.A(1,g),v?.negate()}case 17:return this.z(),W.create(r.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",r)}}return this.t()}t(){const r=this.D();switch(r.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const v=this.l();return this.A(1,g),v}case 17:{const v=r.lexeme;if(this.z(),this.y(9)){const F=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),F.type!==10)throw this.B("REGEX",F);const J=F.lexeme,Z=J.lastIndexOf("/"),oe=Z===J.length-1?void 0:this.w(J.substring(Z+1));let fe;try{fe=new RegExp(J.substring(1,Z),oe)}catch{throw this.B("REGEX",F)}return ce.create(v,fe)}switch(F.type){case 10:case 19:{const J=[F.lexeme];this.z();let Z=this.D(),oe=0;for(let me=0;me<F.lexeme.length;me++)F.lexeme.charCodeAt(me)===40?oe++:F.lexeme.charCodeAt(me)===41&&oe--;for(;!this.E()&&Z.type!==15&&Z.type!==16;){switch(Z.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let me=0;me<Z.lexeme.length;me++)Z.lexeme.charCodeAt(me)===40?oe++:F.lexeme.charCodeAt(me)===41&&oe--}if(oe<0)break;J.push(D.$si.getLexeme(Z)),this.z(),Z=this.D()}const fe=J.join(""),de=fe.lastIndexOf("/"),ue=de===fe.length-1?void 0:this.w(fe.substring(de+1));let ge;try{ge=new RegExp(fe.substring(1,de),ue)}catch{throw this.B("REGEX",F)}return t.regex(v,ge)}case 18:{const J=F.lexeme;this.z();let Z=null;if(!(0,N.$kd)(J)){const oe=J.indexOf("/"),fe=J.lastIndexOf("/");if(oe!==fe&&oe>=0){const de=J.slice(oe+1,fe),ue=J[fe+1]==="i"?"i":"";try{Z=new RegExp(de,ue)}catch{throw this.B("REGEX",F)}}}if(Z===null)throw this.B("REGEX",F);return ce.create(v,Z)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const F=this.u();return t.notIn(v,F)}switch(this.D().type){case 3:{this.z();const F=this.u();if(this.x().type===18)return t.equals(v,F);switch(F){case"true":return t.has(v);case"false":return t.not(v);default:return t.equals(v,F)}}case 4:{this.z();const F=this.u();if(this.x().type===18)return t.notEquals(v,F);switch(F){case"true":return t.not(v);case"false":return t.has(v);default:return t.notEquals(v,F)}}case 5:return this.z(),te.create(v,this.u());case 6:return this.z(),ae.create(v,this.u());case 7:return this.z(),x.create(v,this.u());case 8:return this.z(),le.create(v,this.u());case 13:return this.z(),t.in(v,this.u());default:return t.has(v)}}case 20:throw this.h.push({message:P,offset:r.offset,lexeme:"",additionalInfo:$}),p.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const r=this.D();switch(r.type){case 17:case 18:return this.z(),r.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(r){return r.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(r){return this.C(r)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(r,v){if(this.C(r))return this.z();throw this.B(v,this.D())}B(r,v,z){const F=(0,L.localize)(8,null,r,D.$si.getLexeme(v)),J=v.offset,Z=D.$si.getLexeme(v);return this.h.push({message:F,offset:J,lexeme:Z,additionalInfo:z}),p.c}C(r){return this.D().type===r}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ui=p;class t{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(r){return l.create(r)}static equals(r,v){return I.create(r,v)}static notEquals(r,v){return j.create(r,v)}static regex(r,v){return ce.create(r,v)}static in(r,v){return E.create(r,v)}static notIn(r,v){return k.create(r,v)}static not(r){return W.create(r)}static and(...r){return H.create(r,null,!0)}static or(...r){return C.create(r,null,!0)}static greater(r,v){return x.create(r,v)}static greaterEquals(r,v){return le.create(r,v)}static smaller(r,v){return te.create(r,v)}static smallerEquals(r,v){return ae.create(r,v)}static{this.c=new p({regexParsingWithErrorRecovery:!1})}static deserialize(r){return r==null?void 0:this.c.parse(r)}}e.$vi=t;function a(R){const r=new p({regexParsingWithErrorRecovery:!1});return R.map(v=>(r.parse(v),r.lexingErrors.length>0?r.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,L.localize)(9,null,z.additionalInfo):(0,L.localize)(10,null),offset:z.offset,length:z.lexeme.length})):r.parsingErrors.length>0?r.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$wi=a;function i(R,r){const v=R?R.substituteConstants():void 0,z=r?r.substituteConstants():void 0;return!v&&!z?!0:!v||!z?!1:v.equals(z)}e.$xi=i;function n(R,r){return R.cmp(r)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(r){return this.type-r.type}equals(r){return r.type===this.type}substituteConstants(){return this}evaluate(r){return!1}serialize(){return"false"}keys(){return[]}map(r){return this}negate(){return o.INSTANCE}}e.$yi=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(r){return this.type-r.type}equals(r){return r.type===this.type}substituteConstants(){return this}evaluate(r){return!0}serialize(){return"true"}keys(){return[]}map(r){return this}negate(){return s.INSTANCE}}e.$zi=o;class l{static create(r,v=null){const z=u.get(r);return typeof z=="boolean"?z?o.INSTANCE:s.INSTANCE:new l(r,v)}constructor(r,v){this.key=r,this.c=v,this.type=2}cmp(r){return r.type!==this.type?this.type-r.type:q(this.key,r.key)}equals(r){return r.type===this.type?this.key===r.key:!1}substituteConstants(){const r=u.get(this.key);return typeof r=="boolean"?r?o.INSTANCE:s.INSTANCE:this}evaluate(r){return!!r.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(r){return r.mapDefined(this.key)}negate(){return this.c||(this.c=W.create(this.key,this)),this.c}}e.$Ai=l;class I{static create(r,v,z=null){if(typeof v=="boolean")return v?l.create(r,z):W.create(r,z);const F=u.get(r);return typeof F=="boolean"?v===(F?"true":"false")?o.INSTANCE:s.INSTANCE:new I(r,v,z)}constructor(r,v,z){this.c=r,this.d=v,this.f=z,this.type=4}cmp(r){return r.type!==this.type?this.type-r.type:X(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){const r=u.get(this.c);if(typeof r=="boolean"){const v=r?"true":"false";return this.d===v?o.INSTANCE:s.INSTANCE}return this}evaluate(r){return r.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(r){return r.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Bi=I;class E{static create(r,v){return new E(r,v)}constructor(r,v){this.d=r,this.f=v,this.type=10,this.c=null}cmp(r){return r.type!==this.type?this.type-r.type:X(this.d,this.f,r.d,r.f)}equals(r){return r.type===this.type?this.d===r.d&&this.f===r.f:!1}substituteConstants(){return this}evaluate(r){const v=r.getValue(this.f),z=r.getValue(this.d);return Array.isArray(v)?v.includes(z):typeof z=="string"&&typeof v=="object"&&v!==null?w.call(v,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(r){return r.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Ci=E;class k{static create(r,v){return new k(r,v)}constructor(r,v){this.d=r,this.f=v,this.type=11,this.c=E.create(r,v)}cmp(r){return r.type!==this.type?this.type-r.type:this.c.cmp(r.c)}equals(r){return r.type===this.type?this.c.equals(r.c):!1}substituteConstants(){return this}evaluate(r){return!this.c.evaluate(r)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(r){return r.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Di=k;class j{static create(r,v,z=null){if(typeof v=="boolean")return v?W.create(r,z):l.create(r,z);const F=u.get(r);return typeof F=="boolean"?v===(F?"true":"false")?s.INSTANCE:o.INSTANCE:new j(r,v,z)}constructor(r,v,z){this.c=r,this.d=v,this.f=z,this.type=5}cmp(r){return r.type!==this.type?this.type-r.type:X(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){const r=u.get(this.c);if(typeof r=="boolean"){const v=r?"true":"false";return this.d===v?s.INSTANCE:o.INSTANCE}return this}evaluate(r){return r.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(r){return r.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ei=j;class W{static create(r,v=null){const z=u.get(r);return typeof z=="boolean"?z?s.INSTANCE:o.INSTANCE:new W(r,v)}constructor(r,v){this.c=r,this.d=v,this.type=3}cmp(r){return r.type!==this.type?this.type-r.type:q(this.c,r.c)}equals(r){return r.type===this.type?this.c===r.c:!1}substituteConstants(){const r=u.get(this.c);return typeof r=="boolean"?r?s.INSTANCE:o.INSTANCE:this}evaluate(r){return!r.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(r){return r.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Fi=W;function ee(R,r){if(typeof R=="string"){const v=parseFloat(R);isNaN(v)||(R=v)}return typeof R=="string"||typeof R=="number"?r(R):s.INSTANCE}class x{static create(r,v,z=null){return ee(v,F=>new x(r,F,z))}constructor(r,v,z){this.c=r,this.d=v,this.f=z,this.type=12}cmp(r){return r.type!==this.type?this.type-r.type:X(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){return this}evaluate(r){return typeof this.d=="string"?!1:parseFloat(r.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(r){return r.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Gi=x;class le{static create(r,v,z=null){return ee(v,F=>new le(r,F,z))}constructor(r,v,z){this.c=r,this.d=v,this.f=z,this.type=13}cmp(r){return r.type!==this.type?this.type-r.type:X(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){return this}evaluate(r){return typeof this.d=="string"?!1:parseFloat(r.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(r){return r.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Hi=le;class te{static create(r,v,z=null){return ee(v,F=>new te(r,F,z))}constructor(r,v,z){this.c=r,this.d=v,this.f=z,this.type=14}cmp(r){return r.type!==this.type?this.type-r.type:X(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){return this}evaluate(r){return typeof this.d=="string"?!1:parseFloat(r.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(r){return r.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$Ii=te;class ae{static create(r,v,z=null){return ee(v,F=>new ae(r,F,z))}constructor(r,v,z){this.c=r,this.d=v,this.f=z,this.type=15}cmp(r){return r.type!==this.type?this.type-r.type:X(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){return this}evaluate(r){return typeof this.d=="string"?!1:parseFloat(r.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(r){return r.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Ji=ae;class ce{static create(r,v){return new ce(r,v)}constructor(r,v){this.d=r,this.f=v,this.type=7,this.c=null}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.d<r.d)return-1;if(this.d>r.d)return 1;const v=this.f?this.f.source:"",z=r.f?r.f.source:"";return v<z?-1:v>z?1:0}equals(r){if(r.type===this.type){const v=this.f?this.f.source:"",z=r.f?r.f.source:"";return this.d===r.d&&v===z}return!1}substituteConstants(){return this}evaluate(r){const v=r.getValue(this.d);return this.f?this.f.test(v):!1}serialize(){const r=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${r}`}keys(){return[this.d]}map(r){return r.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$Ki=ce;class ie{static create(r){return new ie(r)}constructor(r){this.c=r,this.type=8}cmp(r){return r.type!==this.type?this.type-r.type:this.c.cmp(r.c)}equals(r){return r.type===this.type?this.c.equals(r.c):!1}substituteConstants(){return this}evaluate(r){return!this.c.evaluate(r)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(r){return new ie(this.c.map(r))}negate(){return this.c}}e.$Li=ie;function V(R){let r=null;for(let v=0,z=R.length;v<z;v++){const F=R[v].substituteConstants();if(R[v]!==F&&r===null){r=[];for(let J=0;J<v;J++)r[J]=R[J]}r!==null&&(r[v]=F)}return r===null?R:r}class H{static create(r,v,z){return H.d(r,v,z)}constructor(r,v){this.expr=r,this.c=v,this.type=6}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.expr.length<r.expr.length)return-1;if(this.expr.length>r.expr.length)return 1;for(let v=0,z=this.expr.length;v<z;v++){const F=n(this.expr[v],r.expr[v]);if(F!==0)return F}return 0}equals(r){if(r.type===this.type){if(this.expr.length!==r.expr.length)return!1;for(let v=0,z=this.expr.length;v<z;v++)if(!this.expr[v].equals(r.expr[v]))return!1;return!0}return!1}substituteConstants(){const r=V(this.expr);return r===this.expr?this:H.create(r,this.c,!1)}evaluate(r){for(let v=0,z=this.expr.length;v<z;v++)if(!this.expr[v].evaluate(r))return!1;return!0}static d(r,v,z){const F=[];let J=!1;for(const Z of r)if(Z){if(Z.type===1){J=!0;continue}if(Z.type===0)return s.INSTANCE;if(Z.type===6){F.push(...Z.expr);continue}F.push(Z)}if(F.length===0&&J)return o.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(n);for(let Z=1;Z<F.length;Z++)F[Z-1].equals(F[Z])&&(F.splice(Z,1),Z--);if(F.length===1)return F[0];for(;F.length>1;){const Z=F[F.length-1];if(Z.type!==9)break;F.pop();const oe=F.pop(),fe=F.length===0,de=C.create(Z.expr.map(ue=>H.create([ue,oe],null,z)),null,fe);de&&(F.push(de),F.sort(n))}if(F.length===1)return F[0];if(z){for(let Z=0;Z<F.length;Z++)for(let oe=Z+1;oe<F.length;oe++)if(F[Z].negate().equals(F[oe]))return s.INSTANCE;if(F.length===1)return F[0]}return new H(F,v)}}serialize(){return this.expr.map(r=>r.serialize()).join(" && ")}keys(){const r=[];for(const v of this.expr)r.push(...v.keys());return r}map(r){return new H(this.expr.map(v=>v.map(r)),null)}negate(){if(!this.c){const r=[];for(const v of this.expr)r.push(v.negate());this.c=C.create(r,this,!0)}return this.c}}e.$Mi=H;class C{static create(r,v,z){return C.d(r,v,z)}constructor(r,v){this.expr=r,this.c=v,this.type=9}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.expr.length<r.expr.length)return-1;if(this.expr.length>r.expr.length)return 1;for(let v=0,z=this.expr.length;v<z;v++){const F=n(this.expr[v],r.expr[v]);if(F!==0)return F}return 0}equals(r){if(r.type===this.type){if(this.expr.length!==r.expr.length)return!1;for(let v=0,z=this.expr.length;v<z;v++)if(!this.expr[v].equals(r.expr[v]))return!1;return!0}return!1}substituteConstants(){const r=V(this.expr);return r===this.expr?this:C.create(r,this.c,!1)}evaluate(r){for(let v=0,z=this.expr.length;v<z;v++)if(this.expr[v].evaluate(r))return!0;return!1}static d(r,v,z){let F=[],J=!1;if(r){for(let Z=0,oe=r.length;Z<oe;Z++){const fe=r[Z];if(fe){if(fe.type===0){J=!0;continue}if(fe.type===1)return o.INSTANCE;if(fe.type===9){F=F.concat(fe.expr);continue}F.push(fe)}}if(F.length===0&&J)return s.INSTANCE;F.sort(n)}if(F.length!==0){if(F.length===1)return F[0];for(let Z=1;Z<F.length;Z++)F[Z-1].equals(F[Z])&&(F.splice(Z,1),Z--);if(F.length===1)return F[0];if(z){for(let Z=0;Z<F.length;Z++)for(let oe=Z+1;oe<F.length;oe++)if(F[Z].negate().equals(F[oe]))return o.INSTANCE;if(F.length===1)return F[0]}return new C(F,v)}}serialize(){return this.expr.map(r=>r.serialize()).join(" || ")}keys(){const r=[];for(const v of this.expr)r.push(...v.keys());return r}map(r){return new C(this.expr.map(v=>v.map(r)),null)}negate(){if(!this.c){const r=[];for(const v of this.expr)r.push(v.negate());for(;r.length>1;){const v=r.shift(),z=r.shift(),F=[];for(const J of T(v))for(const Z of T(z))F.push(H.create([J,Z],null,!1));r.unshift(C.create(F,null,!1))}this.c=C.create(r,this,!0)}return this.c}}e.$Ni=C;class U extends l{static{this.d=[]}static all(){return U.d.values()}constructor(r,v,z){super(r,null),this.f=v,typeof z=="object"?U.d.push({...z,key:r}):z!==!0&&U.d.push({key:r,description:z,type:v!=null?typeof v:void 0})}bindTo(r){return r.createKey(this.key,this.f)}getValue(r){return r.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(r){return I.create(this.key,r)}notEqualsTo(r){return j.create(this.key,r)}}e.$Oi=U,e.$Pi=(0,A.$ph)("contextKeyService");function q(R,r){return R<r?-1:R>r?1:0}function X(R,r,v,z){return R<v?-1:R>v?1:r<z?-1:r>z?1:0}function Y(R,r){if(R.type===0||r.type===1)return!0;if(R.type===9)return r.type===9?K(R.expr,r.expr):!1;if(r.type===9){for(const v of r.expr)if(Y(R,v))return!0;return!1}if(R.type===6){if(r.type===6)return K(r.expr,R.expr);for(const v of R.expr)if(Y(v,r))return!0;return!1}return R.equals(r)}e.$Qi=Y;function K(R,r){let v=0,z=0;for(;v<R.length&&z<r.length;){const F=R[v].cmp(r[z]);if(F<0)return!1;F===0&&v++,z++}return v===R.length}function T(R){return R.type===9?R.expr:[R]}}),define(ne[59],re([0,1,10]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=void 0,e.$un=(0,M.$ph)("downloadService")}),define(ne[18],re([0,1,10]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=void 0,e.$wh=(0,M.$ph)("environmentService"),e.$xh=(0,M.$qh)(e.$wh)}),define(ne[21],re([0,1,92,10]),function(G,e,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Pn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=void 0,e.$Dn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$En=new RegExp(e.$Dn),e.$Fn="__web_extension",e.$Gn="skipWalkthrough",e.$Hn="extensionsSync";function D(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$In=D;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Jn=A;function L(f,P){switch(f){case 3:return P==="x64"?"win32-x64":P==="ia32"?"win32-ia32":P==="arm64"?"win32-arm64":"unknown";case 2:return P==="x64"?"linux-x64":P==="arm64"?"linux-arm64":P==="arm"?"linux-armhf":"unknown";case"alpine":return P==="x64"?"alpine-x64":P==="arm64"?"alpine-arm64":"unknown";case 1:return P==="x64"?"darwin-x64":P==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Kn=L;function b(f,P){return P==="web"&&!f.includes("web")}e.$Ln=b;function u(f,P,$){return b(P,$)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===$?!0:c($).includes(f)}e.$Mn=u;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Nn=c;function w(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$On=w;var O;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(O||(e.SortBy=O={}));var m;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var h;(function(f){f.Install="install",f.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var S;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$Pn=(0,N.$ph)("extensionGalleryService");var y;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var g;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(g||(e.ExtensionSignaturetErrorCode=g={}));class d extends Error{constructor(P,$){super(P),this.code=$,this.name=$}}e.$Qn=d,e.$Rn=(0,N.$ph)("extensionManagementService"),e.$Sn="extensionsIdentifiers/disabled",e.$Tn="extensionsIdentifiers/enabled",e.$Un=(0,N.$ph)("IGlobalExtensionEnablementService"),e.$Vn=(0,N.$ph)("IExtensionTipsService"),e.$Wn=(0,M.localize)(0,null),e.$Xn={value:e.$Wn,original:"Extensions"},e.$Yn={value:(0,M.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=void 0,e.$Vo=(0,M.$ph)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((A,L)=>G(["node-vsce-sign"],async b=>A(b),L))),this.a}async verify(A,L,b){let u;try{u=await this.b()}catch{return!1}return u.verify(A,L,b)}}e.$Wo=N}),define(ne[61],re([0,1,14,9,100,12]),function(G,e,M,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=void 0;async function L(w,O,m,h,S,y){let g;try{await b(w,O,m,h,S,y)}catch(d){g=d}finally{g&&S.errorTransformer&&(g=S.errorTransformer(g)),typeof g<"u"&&m.error(g),m.end()}}e.$rp=L;async function b(w,O,m,h,S,y){u(y);const g=await w.open(O,{create:!1});try{u(y);let d=0,f=0,P=S&&typeof S.length=="number"?S.length:void 0,$=M.$Jb.alloc(Math.min(S.bufferSize,typeof P=="number"?P:S.bufferSize)),p=S&&typeof S.position=="number"?S.position:0,t=0;do f=await w.read(g,p,$.buffer,t,$.byteLength-t),p+=f,t+=f,d+=f,typeof P=="number"&&(P-=f),t===$.byteLength&&(await m.write(h($)),$=M.$Jb.alloc(Math.min(S.bufferSize,typeof P=="number"?P:S.bufferSize)),t=0);while(f>0&&(typeof P!="number"||P>0)&&u(y)&&c(d,S));if(t>0){let a=t;typeof P=="number"&&(a=Math.min(t,P)),m.write(h($.slice(0,a)))}}catch(d){throw(0,A.$6j)(d)}finally{await w.close(g)}}function u(w){if(w.isCancellationRequested)throw(0,N.$4)();return!0}function c(w,O){if(typeof O?.limits?.size=="number"&&w>O.limits.size)throw(0,A.$5j)((0,D.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],re([0,1,4,166,2,13,167]),function(G,e,M,N,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;class b extends D.$lb{constructor(){super(...arguments),this.a=this.B(new M.$8c),this.onDidChangeFile=this.a.event,this.b=this.B(new M.$8c),this.onDidLogMessage=this.b.event,this.onDidError=M.Event.None,this.c=new Map,this.f=!1}async watch(c){const w=this.i(c),O=w.filter(h=>{const S=this.c.get(h.path);return S?!(0,N.$ij)(S.request.excludes,h.excludes)||!(0,N.$ij)(S.request.includes,h.includes):!0}),m=Array.from(this.c.values()).filter(({request:h})=>!w.find(S=>S.path===h.path&&(0,N.$ij)(S.excludes,h.excludes)&&(0,N.$ij)(S.includes,h.includes))).map(({request:h})=>h.path);O.length&&this.j(`Request to start watching: ${O.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const h of m)this.h(h);for(const h of O)this.g(h)}g(c){const w=new L.$Np(c,m=>this.a.fire(m),m=>this.b.fire(m),this.f),O={request:c,instance:w};this.c.set(c.path,O)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const w=this.c.get(c);w&&(this.c.delete(c),w.instance.dispose())}i(c){const w=new Map;for(const O of c){const m=A.$k?O.path:O.path.toLowerCase();w.set(m,O)}return Array.from(w.values())}async setVerboseLogging(c){this.f=c;for(const[,w]of this.c)w.instance.setVerboseLogging(c)}j(c){this.f&&this.b.fire({type:"trace",message:this.k(c)})}k(c,w){return w?`[File Watcher (node.js)] ${c} (path: ${w.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$Pp=b}),define(ne[118],re([0,1,62,117]),function(G,e,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;class D extends M.$vp{constructor(L,b,u){super(L,b,u),this.m()}l(){return new N.$Pp}}e.$Qp=D}),define(ne[119],re([0,1,15,57,85,62]),function(G,e,M,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;class L extends A.$wp{constructor(u,c,w){super(u,c,w),this.m()}l(u){const c=u.add(new D.$Hp(M.$4e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(c.onDidProcessExit(({code:w,signal:O})=>this.n(`terminated by itself with code ${w}, signal: ${O}`))),N.ProxyChannel.toService((0,N.$9g)(c.getChannel("watcher")))}}e.$Ip=L}),define(ne[63],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=void 0;class M{constructor(...D){this.a=new Map;for(const[A,L]of D)this.set(A,L)}set(D,A){const L=this.a.get(D);return this.a.set(D,A),L}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.$nh=M}),define(ne[120],re([0,1,8,9,2,49,115,10,63,168]),function(G,e,M,N,D,A,L,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0;const w=!1;class O extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class m{constructor(g=new u.$nh,d=!1,f,P=w){this.f=g,this.g=d,this.h=f,this.i=P,this.o=new Set,this.f.set(b.$oh,this),this._globalGraph=P?f?._globalGraph??new L.$Tp($=>$):void 0}createChild(g){return new m(g,this.g,this,this.i)}invokeFunction(g,...d){const f=S.traceInvocation(this.i,g);let P=!1;try{return g({get:p=>{if(P)throw(0,N.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(p,f);if(!t)throw new Error(`[invokeFunction] unknown service '${p}'`);return t}},...d)}finally{P=!0,f.stop()}}createInstance(g,...d){let f,P;return g instanceof A.$mh?(f=S.traceCreation(this.i,g.ctor),P=this.j(g.ctor,g.staticArguments.concat(d),f)):(f=S.traceCreation(this.i,g),P=this.j(g,d,f)),f.stop(),P}j(g,d=[],f){const P=b._util.getServiceDependencies(g).sort((t,a)=>t.index-a.index),$=[];for(const t of P){const a=this.m(t.id,f);a||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),$.push(a)}const p=P.length>0?P[0].index:d.length;if(d.length!==p){console.trace(`[createInstance] First service dependency of ${g.name} at position ${p+1} conflicts with ${d.length} static arguments`);const t=p-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,p)}return Reflect.construct(g,d.concat($))}k(g,d){if(this.f.get(g)instanceof A.$mh)this.f.set(g,d);else if(this.h)this.h.k(g,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const d=this.f.get(g);return!d&&this.h?this.h.l(g):d}m(g,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const f=this.l(g);return f instanceof A.$mh?this.q(g,f,d.branch(g,!0)):(d.branch(g,!1),f)}q(g,d,f){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,d,f)}finally{this.o.delete(g)}}r(g,d,f){const P=new L.$Tp(t=>t.id.toString());let $=0;const p=[{id:g,desc:d,_trace:f}];for(;p.length;){const t=p.pop();if(P.lookupOrInsertNode(t),$++>1e3)throw new O(P);for(const a of b._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${g} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof A.$mh){const n={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};P.insertEdge(t,n),p.push(n)}}}for(;;){const t=P.roots();if(t.length===0){if(!P.isEmpty())throw new O(P);break}for(const{data:a}of t){if(this.l(a.id)instanceof A.$mh){const n=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,n)}P.removeNode(a)}}return this.l(g)}s(g,d,f=[],P,$){if(this.f.get(g)instanceof A.$mh)return this.t(g,d,f,P,$);if(this.h)return this.h.s(g,d,f,P,$);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(g,d,f=[],P,$){if(P){const p=new m(void 0,this.g,this,this.i);p.c=String(g);const t=new Map,a=new M.$Lg(()=>{const i=p.j(d,f,$);for(const[n,s]of t){const o=i[n];if(typeof o=="function")for(const l of s)o.apply(i,l)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let l=t.get(n);return l||(l=new c.$lc,t.set(n,l)),(E,k,j)=>{const W=l.push([E,k,j]);return(0,D.$jb)(W)}}if(n in i)return i[n];const s=a.value;let o=s[n];return typeof o!="function"||(o=o.bind(s),i[n]=o),o},set(i,n,s){return a.value[n]=s,!0},getPrototypeOf(i){return d.prototype}})}else return this.j(d,f,$)}u(g,d){if(d&&console.warn(g),this.g)throw new Error(g)}}e.$Up=m;var h;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(h||(h={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,d){return g?new S(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(g,d){return g?new S(1,d.name):S.c}static{this.f=0}constructor(g,d){this.type=g,this.name=d,this.g=Date.now(),this.h=[]}branch(g,d){const f=new S(3,g.toString());return this.h.push([g,d,f]),f}stop(){const g=Date.now()-this.g;S.f+=g;let d=!1;function f($,p){const t=[],a=new Array($+1).join("	");for(const[i,n,s]of p.h)if(n&&s){d=!0,t.push(`${a}CREATES -> ${i}`);const o=f($+1,s);o&&t.push(o)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const P=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(g>2||d)&&S.all.add(P.join(`
`))}}e.$Vp=S});var se=this&&this.__param||function(G,e){return function(M,N){e(M,N,G)}};define(ne[64],re([0,1,20,2,13,102,21,10]),function(G,e,M,N,D,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=void 0;function u(w){return w.tags.find(O=>O.startsWith("lp-"))?.split("lp-")[1]}e.$wq=u,e.$xq=(0,b.$ph)("languagePackService");let c=class extends N.$lb{constructor(O){super(),this.c=O}async getAvailableLanguages(){const O=new M.$ed;setTimeout(()=>O.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},O.token)}catch{return[]}const S=m.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(g=>g.startsWith("lp-"))).map(y=>{const g=y.properties.localizedLanguages?.[0],d=u(y);return{...this.f(d,g,y),extensionId:y.identifier.id,galleryExtension:y}});return S.push(this.f("en","English")),S}f(O,m,h){const S=m??O;let y;if(S!==O&&(y=`(${O})`),O.toLowerCase()===D.$v.toLowerCase()&&(y??="",y+=(0,A.localize)(0,null)),h?.installCount){y??="";const g=h.installCount;let d;g>1e6?d=`${Math.floor(g/1e5)/10}M`:g>1e3?d=`${Math.floor(g/1e3)}K`:d=String(g),y+=` $(cloud-download) ${d}`}return{id:O,label:S,description:y}}};e.$yq=c,e.$yq=c=pe([se(0,L.$Pn)],c)}),define(ne[6],re([0,1,33,4,42,2,35,13,17,3,11,116,10]),function(G,e,M,N,D,A,L,b,u,c,w,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.log=e.$Ui=e.LogLevel=e.$Ti=e.$Si=e.$Ri=void 0,e.$Ri=(0,m.$ph)("logService"),e.$Si=(0,m.$ph)("loggerService");function h(){return new Date().toISOString()}function S(E){return(0,c.$ne)(E)}e.$Ti=S;var y;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$Ui=y.Info;function g(E,k,j){switch(k){case y.Trace:E.trace(j);break;case y.Debug:E.debug(j);break;case y.Info:E.info(j);break;case y.Warning:E.warn(j);break;case y.Error:E.error(j);break;case y.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=g;function d(E,k=!1){let j="";for(let W=0;W<E.length;W++){let ee=E[W];if(ee instanceof Error&&(ee=(0,M.$ai)(ee,k)),typeof ee=="object")try{ee=JSON.stringify(ee)}catch{}j+=(W>0?" ":"")+ee}return j}class f extends A.$lb{constructor(){super(...arguments),this.b=e.$Ui,this.c=this.B(new N.$8c),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==y.Off&&this.b<=k}}e.$Wi=f;class P extends f{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...j){this.f(y.Trace)&&this.g(y.Trace,d([k,...j],!0))}debug(k,...j){this.f(y.Debug)&&this.g(y.Debug,d([k,...j]))}info(k,...j){this.f(y.Info)&&this.g(y.Info,d([k,...j]))}warn(k,...j){this.f(y.Warning)&&this.g(y.Warning,d([k,...j]))}error(k,...j){if(this.f(y.Error))if(k instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=k.stack,this.g(y.Error,d(W))}else this.g(y.Error,d([k,...j]))}flush(){}}e.$Xi=P;class $ extends f{constructor(k=e.$Ui){super(),this.setLevel(k),this.g=!b.$i}trace(k,...j){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,k,...j):console.log(`[main ${h()}]`,k,...j))}debug(k,...j){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,k,...j):console.log(`[main ${h()}]`,k,...j))}info(k,...j){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,k,...j):console.log(`[main ${h()}]`,k,...j))}warn(k,...j){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,k,...j):console.warn(`[main ${h()}]`,k,...j))}error(k,...j){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,k,...j):console.error(`[main ${h()}]`,k,...j))}dispose(){}flush(){}}e.$Yi=$;class p extends f{constructor(k=e.$Ui,j=!0){super(),this.g=j,this.setLevel(k)}trace(k,...j){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...j):console.log(k,...j))}debug(k,...j){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...j):console.log(k,...j))}info(k,...j){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...j):console.log(k,...j))}warn(k,...j){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...j):console.log(k,...j))}error(k,...j){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...j):console.error(k,...j))}dispose(){}flush(){}}e.$Zi=p;class t extends f{constructor(k,j=e.$Ui){super(),this.g=k,this.setLevel(j)}trace(k,...j){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(k),...j])}debug(k,...j){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(k),...j])}info(k,...j){this.f(y.Info)&&this.g.log(y.Info,[this.h(k),...j])}warn(k,...j){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(k),...j])}error(k,...j){this.f(y.Error)&&this.g.log(y.Error,[this.h(k),...j])}h(k){return typeof k=="string"?k:(0,M.$ai)(k,this.f(y.Trace))}dispose(){}flush(){}}e.$1i=t;class a extends f{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const j of this.g)j.setLevel(k);super.setLevel(k)}trace(k,...j){for(const W of this.g)W.trace(k,...j)}debug(k,...j){for(const W of this.g)W.debug(k,...j)}info(k,...j){for(const W of this.g)W.info(k,...j)}warn(k,...j){for(const W of this.g)W.warn(k,...j)}error(k,...j){for(const W of this.g)W.error(k,...j)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.$2i=a;class i extends A.$lb{constructor(k,j,W){if(super(),this.h=k,this.j=j,this.b=new L.$ni,this.c=this.B(new N.$8c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$8c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$8c),this.onDidChangeVisibility=this.g.event,W)for(const ee of W)this.b.set(ee.resource,{logger:void 0,info:ee})}k(k){return(0,c.$je)(k)?[...this.b.values()].find(j=>j.info.id===k):this.b.get(k)}getLogger(k){return this.k(k)?.logger}createLogger(k,j){const W=this.l(k),ee=(0,c.$je)(k)?k:j?.id??(0,D.$di)(W.toString()).toString(16);let x=this.b.get(W)?.logger;const le=j?.logLevel==="always"?y.Trace:j?.logLevel;x||(x=this.m(W,le??this.getLogLevel(W)??this.h,{...j,id:ee}));const te={logger:x,info:{resource:W,id:ee,logLevel:le,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(te.info),this.b.set(W,te),x}l(k){return(0,c.$je)(k)?(0,u.$0f)(this.j,`${k}.log`):k}setLogLevel(k,j){if(w.URI.isUri(k)){const W=k,ee=j,x=this.b.get(W);x&&ee!==x.info.logLevel&&(x.info.logLevel=ee===this.h?void 0:ee,x.logger?.setLevel(ee),this.b.set(x.info.resource,x),this.f.fire([W,ee]))}else{this.h=k;for(const[W,ee]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&ee.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,j){const W=this.k(k);W&&j!==!W.info.hidden&&(W.info.hidden=!j,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,j]))}getLogLevel(k){let j;return k&&(j=this.b.get(k)?.info.logLevel),j??this.h}registerLogger(k){const j=this.b.get(k.resource);j?j.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const j=this.b.get(k);j&&(j.logger&&j.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$3i=i;class n{constructor(){this.onDidChangeLogLevel=new N.$8c().event}setLevel(k){}getLevel(){return y.Info}trace(k,...j){}debug(k,...j){}info(k,...j){}warn(k,...j){}error(k,...j){}critical(k,...j){}dispose(){}flush(){}}e.$4i=n;class s extends n{}e.$5i=s;function o(E){if(E.verbose)return y.Trace;if(typeof E.logLevel=="string"){const k=I(E.logLevel.toLowerCase());if(k!==void 0)return k}return e.$Ui}e.$6i=o;function l(E){switch(E){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$7i=l;function I(E){switch(E){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$8i=I,e.$9i=new O.$Oi("logLevel",l(y.Info))}),define(ne[121],re([0,1,19,8,9,4,2,16,62,6]),function(G,e,M,N,D,A,L,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;class w extends L.$lb{constructor(m,h){super(),this.a=m,this.b=h,this.c=this.B(new A.$8c),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$8c),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new N.$tg(0)),this.s=[],this.t=this.B(new N.$tg(0))}watch(m,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(m,h):this.u(m,h)}l(m,h){const S={path:this.C(m),excludes:h.excludes,includes:h.includes,recursive:h.recursive},y=(0,M.$Bf)(this.j,S);return this.m(),(0,L.$jb)(()=>{y(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,D.$Y)(m))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,u.$xp)(h)),h=>this.z(h),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const h of this.j)(0,u.$tp)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const h of this.j)(0,u.$tp)(h)&&m.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,h){const S={path:this.C(m),excludes:h.excludes,includes:h.includes,recursive:!1},y=(0,M.$Bf)(this.s,S);return this.v(),(0,L.$jb)(()=>{y(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,D.$Y)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,u.$xp)(m)),m=>this.z(m),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,b.$$b)(m.fsPath)}}e.$Bp=w}),define(ne[122],re([0,1,19,8,14,20,4,42,65,2,46,15,123,17,41,99,12,61,6,9]),function(G,e,M,N,D,A,L,b,u,c,w,O,m,h,S,y,g,d,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=void 0;let $=class extends c.$lb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new L.$8c),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.$8c),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.$8c),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new L.$8c),this.onDidRunOperation=this.m.event,this.R=this.B(new L.$8c),this.onDidFilesChange=this.R.event,this.S=this.B(new L.$8c),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new N.$Dg)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${t}`);const i=new c.$kb;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(n=>this.R.fire(new g.$$j(n,!this.O(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,c.$jb)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,c.$gb)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await N.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return u.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,h.$bg)(t))throw new g.$ak((0,y.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new P.$ab;throw i.message=(0,y.localize)(1,null,t.toString()),i}return a}async k(t){const a=await this.j(t);if((0,g.$Xj)(a)||(0,g.$Uj)(a)||(0,g.$Yj)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,g.$Xj)(a)||(0,g.$Uj)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(i){throw(0,g.$8j)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.$ak((0,y.localize)(2,null,this.nb(t)),1):(0,g.$6j)(i)}}async n(t,a){const i=await this.j(t),n=this.O(i),s=a?.resolveTo,o=a?.resolveSingleChildDescendants,l=a?.resolveMetadata,I=await i.stat(t);let E;return this.p(i,t,I,void 0,!!l,(k,j)=>(E||(E=w.$vh.forUris(()=>!n),E.set(t,!0),s&&E.fill(!0,s)),E.get(k.resource)||E.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&o?j===1:!1))}async p(t,a,i,n,s,o){const{providerExtUri:l}=this.N(t),I={resource:a,name:l.basename(a),isFile:(i.type&g.FileType.File)!==0,isDirectory:(i.type&g.FileType.Directory)!==0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&g.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((i.permissions??0)&g.FilePermission.Locked),etag:(0,g.$lk)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&o(I,n)){try{const E=await t.readdir(a),k=await N.Promises.settled(E.map(async([j,W])=>{try{const ee=l.joinPath(a,j),x=s?await t.stat(ee):{type:W};return await this.p(t,ee,x,E.length,s,o)}catch(ee){return this.b.trace(ee),null}}));I.children=(0,M.$mf)(k)}catch(E){this.b.trace(E),I.children=[]}return I}return I}async resolveAll(t){return N.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.p(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.r(t,a)}catch(i){return i}return!0}async r(t,a){if(!a?.overwrite&&await this.exists(t))throw new g.$ak((0,y.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=D.$Jb.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,a);return this.m.fire(new g.$0j(t,0,n)),n}async writeFile(t,a,i){const n=this.lb(await this.l(t),t),{providerExtUri:s}=this.N(n);try{await this.s(n,t,i)||await this.P(n,s.dirname(t));let l;if((0,g.$Uj)(n)&&!(a instanceof D.$Jb))if((0,S.$vb)(a)){const I=await(0,S.$Cb)(a,3);I.ended?l=D.$Jb.concat(I.buffer):l=I}else l=(0,S.$zb)(a,I=>D.$Jb.concat(I),3);else l=a;if(!(0,g.$Xj)(n)||(0,g.$Uj)(n)&&l instanceof D.$Jb)await this.cb(n,t,i,l);else{const I=l instanceof D.$Jb?(0,D.$Ub)(l):l;i?.atomic!==!1&&i?.atomic?.postfix?await this.Y(n,t,(0,h.$0f)((0,h.$9f)(t),`${(0,h.$7f)(t)}${i.atomic.postfix}`),i,I):await this.Z(n,t,i,I)}this.m.fire(new g.$0j(t,4))}catch(o){throw new g.$ak((0,y.localize)(4,null,this.nb(t),(0,g.$6j)(o).toString()),(0,g.$9j)(o),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,a,i){const n=!!i?.unlock;if(n&&!(t.capabilities&8192))throw new Error((0,y.localize)(5,null,this.nb(a)));if(!!i?.atomic){if(!(t.capabilities&32768))throw new Error((0,y.localize)(6,null,this.nb(a)));if(n)throw new Error((0,y.localize)(7,null,this.nb(a)))}let o;try{o=await t.stat(a)}catch{return}if(o.type&g.FileType.Directory)throw new g.$ak((0,y.localize)(8,null,this.nb(a)),0,i);if(this.mb(a,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.$kk&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,g.$lk)({mtime:i.mtime,size:o.size}))throw new g.$ak((0,y.localize)(9,null),3,i);return o}async readFile(t,a,i){const n=await this.k(t);return a?.atomic?this.t(n,t,a,i):this.u(n,t,a,i)}async t(t,a,i,n){return new Promise((s,o)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const l=await this.u(t,a,i,n);s(l)}catch(l){o(l)}})})}async u(t,a,i,n){const s=await this.v(t,a,{...i,preferUnbuffered:!0},n);return{...s,value:await(0,D.$Vb)(s.value)}}async readFileStream(t,a,i){const n=await this.k(t);return this.v(n,t,a,i)}async v(t,a,i,n){const s=new A.$ed(n),o=this.F(a,i).then(I=>I,I=>{throw s.cancel(),I});let l;try{return typeof i?.etag=="string"&&i.etag!==g.$kk&&await o,i?.atomic&&(0,g.$Zj)(t)||!((0,g.$Xj)(t)||(0,g.$Yj)(t))||(0,g.$Uj)(t)&&i?.preferUnbuffered?l=this.D(t,a,i):(0,g.$Yj)(t)?l=this.z(t,a,s.token,i):l=this.C(t,a,s.token,i),{...await o,value:l}}catch(I){throw l&&await(0,S.$Ab)(l),this.w(I,a,i)}}w(t,a,i){const n=(0,y.localize)(10,null,this.nb(a),(0,g.$6j)(t).toString());return t instanceof g.$ck?new g.$ck(n,t.stat,i):t instanceof g.$bk?new g.$bk(n,t.fileOperationResult,t.size,t.options):new g.$ak(n,(0,g.$9j)(t),i)}z(t,a,i,n=Object.create(null)){const s=t.readFileStream(a,n,i);return(0,S.$Gb)(s,{data:o=>o instanceof D.$Jb?o:D.$Jb.wrap(o),error:o=>this.w(o,a,n)},o=>D.$Jb.concat(o))}C(t,a,i,n=Object.create(null)){const s=(0,D.$Zb)();return(0,d.$rp)(t,a,s,o=>o,{...n,bufferSize:this.a,errorTransformer:o=>this.w(o,a,n)},i),s}D(t,a,i){const n=(0,S.$xb)(s=>D.$Jb.concat(s));return(async()=>{try{let s;i?.atomic&&(0,g.$Zj)(t)?s=await t.readFile(a,{atomic:!0}):s=await t.readFile(a),typeof i?.position=="number"&&(s=s.slice(i.position)),typeof i?.length=="number"&&(s=s.slice(0,i.length)),this.G(a,s.byteLength,i),n.end(D.$Jb.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async F(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new g.$ak((0,y.localize)(11,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==g.$kk&&a.etag===i.etag)throw new g.$ck((0,y.localize)(12,null),i,a);return this.G(t,i.size,a),i}G(t,a,i){if(typeof i?.limits?.size=="number"&&a>i.limits.size)throw new g.$bk((0,y.localize)(13,null,this.nb(t)),7,a,i)}async canMove(t,a,i){return this.H(t,a,"move",i)}async canCopy(t,a,i){return this.H(t,a,"copy",i)}async H(t,a,i,n){if(t.toString()!==a.toString())try{const s=i==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(a),a);await this.M(s,t,o,a,i,n)}catch(s){return s}return!0}async move(t,a,i){const n=this.lb(await this.l(t),t),s=this.lb(await this.l(a),a),o=await this.I(n,t,s,a,"move",!!i),l=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new g.$0j(t,o==="move"?2:3,l)),l}async copy(t,a,i){const n=await this.k(t),s=this.lb(await this.l(a),a),o=await this.I(n,t,s,a,"copy",!!i),l=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new g.$0j(t,o==="copy"?3:2,l)),l}async I(t,a,i,n,s,o){if(a.toString()===n.toString())return s;const{exists:l,isSameResourceWithDifferentPathCase:I}=await this.M(t,a,i,n,s,o);if(l&&!I&&o&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),s==="copy"){if(t===i&&(0,g.$Vj)(t))await t.copy(a,n,{overwrite:o});else{const E=await this.resolve(a);E.isDirectory?await this.L(t,E,i,n):await this.J(t,a,i,n)}return s}else return t===i?(await t.rename(a,n,{overwrite:o}),s):(await this.I(t,a,i,n,"copy",o),await this.del(a,{recursive:!0}),"copy")}async J(t,a,i,n){if((0,g.$Xj)(t)&&(0,g.$Xj)(i))return this.eb(t,a,i,n);if((0,g.$Xj)(t)&&(0,g.$Uj)(i))return this.kb(t,a,i,n);if((0,g.$Uj)(t)&&(0,g.$Xj)(i))return this.ib(t,a,i,n);if((0,g.$Uj)(t)&&(0,g.$Uj)(i))return this.gb(t,a,i,n)}async L(t,a,i,n){await i.mkdir(n),Array.isArray(a.children)&&await N.Promises.settled(a.children.map(async s=>{const o=this.N(i).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.L(t,await this.resolve(s.resource),i,o):this.J(t,s.resource,i,o)}))}async M(t,a,i,n,s,o){let l=!1;if(t===i){const{providerExtUri:E,isPathCaseSensitive:k}=this.N(t);if(k||(l=E.isEqual(a,n)),l&&s==="copy")throw new Error((0,y.localize)(14,null,this.nb(a),this.nb(n)));if(!l&&E.isEqualOrParent(n,a))throw new Error((0,y.localize)(15,null,this.nb(a),this.nb(n)))}const I=await this.exists(n);if(I&&!l){if(!o)throw new g.$ak((0,y.localize)(16,null,this.nb(a),this.nb(n)),4);if(t===i){const{providerExtUri:E}=this.N(t);if(E.isEqualOrParent(a,n))throw new Error((0,y.localize)(17,null,this.nb(a),this.nb(n)))}}return{exists:I,isSameResourceWithDifferentPathCase:l}}N(t){const a=this.O(t);return{providerExtUri:a?h.$Zf:h.$2f,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new g.$0j(t,0,i)),i}async P(t,a){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(a,n.dirname(a));)try{if(!((await t.stat(a)).type&g.FileType.Directory))throw new Error((0,y.localize)(18,null,this.nb(a)));break}catch(s){if((0,g.$8j)(s)!==g.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(n.basename(a)),a=n.dirname(a)}for(let s=i.length-1;s>=0;s--){a=n.joinPath(a,i[s]);try{await t.mkdir(a)}catch(o){if((0,g.$8j)(o)!==g.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,a){try{await this.Q(t,a)}catch(i){return i}return!0}async Q(t,a){const i=this.lb(await this.j(t),t),n=!!a?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,y.localize)(19,null,this.nb(t)));const s=a?.atomic;if(s&&!(i.capabilities&65536))throw new Error((0,y.localize)(20,null,this.nb(t)));if(n&&s)throw new Error((0,y.localize)(21,null,this.nb(t)));let o;try{o=await i.stat(t)}catch{}if(o)this.mb(t,o);else throw new g.$ak((0,y.localize)(22,null,this.nb(t)),1);if(!!!a?.recursive){const I=await this.resolve(t);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,y.localize)(23,null,this.nb(t)))}return i}async del(t,a){const i=await this.Q(t,a),n=!!a?.useTrash,s=!!a?.recursive,o=a?.atomic??!1;await i.delete(t,{recursive:s,useTrash:n,atomic:o}),this.m.fire(new g.$0j(t,1))}async cloneFile(t,a){const i=await this.j(t),n=this.lb(await this.l(a),a);if(i===n&&this.N(i).providerExtUri.isEqual(t,a))return;if(i===n&&(0,g.$Wj)(i))return i.cloneFile(t,a);await this.P(n,this.N(n).providerExtUri.dirname(a));const s=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,g.$Vj)(i)?s.queue(()=>i.copy(t,a,{overwrite:!0})):s.queue(()=>this.J(i,t,n,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new c.$kb;let n=!1,s=()=>{n=!0};return i.add((0,c.$jb)(()=>s())),(async()=>{try{const o=await this.W(t,a);n?(0,c.$gb)(o):s=()=>(0,c.$gb)(o)}catch(o){this.b.error(o)}})(),i}async W(t,a){const i=await this.j(t),n=(0,b.$di)([this.N(i).providerExtUri.getComparisonKey(t),a]);let s=this.U.get(n);return s||(s={count:0,disposable:i.watch(t,a)},this.U.set(n,s)),s.count+=1,(0,c.$jb)(()=>{s&&(s.count--,s.count===0&&((0,c.$gb)(s.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,c.$gb)(t.disposable);this.U.clear()}async Y(t,a,i,n,s){await this.Z(t,i,n,s);try{await t.rename(i,a,{overwrite:!0})}catch(o){try{await t.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}async Z(t,a,i,n){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const s=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,S.$vb)(n)||(0,S.$wb)(n)?await this.$(t,s,n):await this.ab(t,s,n)}catch(o){throw(0,g.$6j)(o)}finally{await t.close(s)}})}async $(t,a,i){let n=0,s;if((0,S.$wb)(i)){if(i.buffer.length>0){const o=D.$Jb.concat(i.buffer);await this.bb(t,a,o,o.byteLength,n,0),n+=o.byteLength}if(i.ended)return;s=i.stream}else s=i;return new Promise((o,l)=>{(0,S.$Bb)(s,{onData:async I=>{s.pause();try{await this.bb(t,a,I,I.byteLength,n,0)}catch(E){return l(E)}n+=I.byteLength,setTimeout(()=>s.resume())},onError:I=>l(I),onEnd:()=>o()})})}async ab(t,a,i){let n=0,s;for(;(s=i.read())!==null;)await this.bb(t,a,s,s.byteLength,n,0),n+=s.byteLength}async bb(t,a,i,n,s,o){let l=0;for(;l<n;){const I=await t.write(a,s+l,i.buffer,o+l,n-l);l+=I}}async cb(t,a,i,n){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,i,n))}async db(t,a,i,n){let s;n instanceof D.$Jb?s=n:(0,S.$vb)(n)?s=await(0,D.$Vb)(n):(0,S.$wb)(n)?s=await(0,D.$Wb)(n):s=(0,D.$Tb)(n),await t.writeFile(a,s.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async eb(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,a,i,n))}async fb(t,a,i,n){let s,o;try{s=await t.open(a,{create:!1}),o=await i.open(n,{create:!0,unlock:!1});const l=D.$Jb.alloc(this.a);let I=0,E=0,k=0;do k=await t.read(s,I,l.buffer,E,l.byteLength-E),await this.bb(i,o,l,k,I,E),I+=k,E+=k,E===l.byteLength&&(E=0);while(k>0)}catch(l){throw(0,g.$6j)(l)}finally{await N.Promises.settled([typeof s=="number"?t.close(s):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async gb(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,a,i,n))}async hb(t,a,i,n){return i.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,a,i,n))}async jb(t,a,i,n){const s=await i.open(n,{create:!0,unlock:!1});try{const o=await t.readFile(a);await this.bb(i,s,D.$Jb.wrap(o),o.byteLength,0,0)}catch(o){throw(0,g.$6j)(o)}finally{await i.close(s)}}async kb(t,a,i,n){const s=await(0,D.$Vb)(this.C(t,a,A.CancellationToken.None));await this.cb(i,n,void 0,s)}lb(t,a){if(t.capabilities&2048)throw new g.$ak((0,y.localize)(24,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&g.FilePermission.Readonly)throw new g.$ak((0,y.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===O.Schemas.file?t.fsPath:t.toString(!0)}};e.$sp=$,e.$sp=$=pe([se(0,f.$Ri)],$)}),define(ne[124],re([0,1,125,169,8,35,14,4,170,2,16,13,17,41,24,101,12,61,121,33,119,118]),function(G,e,M,N,D,A,L,b,u,c,w,O,m,h,S,y,g,d,f,P,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0,(()=>{try{(0,N.gracefulify)(M)}catch(a){console.error(`Error enabling graceful-fs: ${(0,P.$ai)(a)}`)}})();class t extends f.$Bp{static{this.D=!1}constructor(i,n){super(i,n),this.onDidChangeCapabilities=b.Event.None,this.I=new A.$ni(s=>m.$1f.getComparisonKey(s)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,O.$k&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:s}=await S.SymlinkSupport.stat(this.C(i));return{type:this.H(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:g.FilePermission.Locked}}catch(n){throw this.ab(n)}}async G(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const n=await S.Promises.readdir(this.C(i),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,m.$0f)(i,o.name))).type:l=this.H(o),s.push([o.name,l])}catch(l){this.a.trace(l)}})),s}catch(n){throw this.ab(n)}}H(i,n){let s;return n?.dangling?s=g.FileType.Unknown:i.isFile()?s=g.FileType.File:i.isDirectory()?s=g.FileType.Directory:s=g.FileType.Unknown,n&&(s|=g.FileType.SymbolicLink),s}async J(i){const n=this.C(i);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.I.get(i);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const o=new D.$ug;return this.I.set(i,o),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,c.$jb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.I.get(i)===o&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.I.delete(i)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(i,n){let s;try{n?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),s=await this.J(i));const o=this.C(i);return await S.Promises.readFile(o)}catch(o){throw this.ab(o)}finally{s?.dispose()}}L(i){t.D&&this.a.trace(i)}readFileStream(i,n,s){const o=(0,h.$xb)(l=>L.$Jb.concat(l.map(I=>L.$Jb.wrap(I))).buffer);return(0,d.$rp)(this,i,o,l=>l.buffer,{...n,bufferSize:256*1024},s),o}async writeFile(i,n,s){return s?.atomic!==!1&&s?.atomic?.postfix?this.M(i,(0,m.$0f)((0,m.$9f)(i),`${(0,m.$7f)(i)}${s.atomic.postfix}`),n,s):this.N(i,n,s)}async M(i,n,s,o){await this.N(n,s,o);try{await this.rename(n,i,{overwrite:!0})}catch(l){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}async N(i,n,s){let o;try{const l=this.C(i);if(!s.create||!s.overwrite){if(await S.Promises.exists(l)){if(!s.overwrite)throw(0,g.$5j)((0,y.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,g.$5j)((0,y.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(o,0,n,0,n.byteLength)}catch(l){throw await this.bb(i,l)}finally{typeof o=="number"&&await this.close(o)}}static{this.R=!0}static configureFlushOnWrite(i){t.R=i}async open(i,n){const s=this.C(i);let o;(0,g.$Tj)(n)&&(o=await this.J(i));let l;try{if((0,g.$Tj)(n)&&n.unlock)try{const{stat:E}=await S.SymlinkSupport.stat(s);E.mode&128||await S.Promises.chmod(s,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let I;if((0,g.$Tj)(n)){if(O.$i)try{await S.Promises.truncate(s,0),I="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}I||(I="w")}else I="r";l=await S.Promises.open(s,I)}catch(I){throw o?.dispose(),(0,g.$Tj)(n)?await this.bb(i,I):this.ab(I)}if(this.O.set(l,0),(0,g.$Tj)(n)&&this.Q.set(l,i),o){const I=this.P.get(l);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.P.set(l,o),I&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),I.dispose())}return l}async close(i){const n=this.P.get(i);try{if(this.O.delete(i),this.Q.delete(i)&&t.R)try{await S.Promises.fdatasync(i)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await S.Promises.close(i)}catch(s){throw this.ab(s)}finally{n&&(this.P.get(i)===n&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.P.delete(i)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,s,o,l){const I=this.S(i,n);let E=null;try{E=(await S.Promises.read(i,s,o,l,I)).bytesRead}catch(k){throw this.ab(k)}finally{this.U(i,I,E)}return E}S(i,n){return n===this.O.get(i)?null:n}U(i,n,s){const o=this.O.get(i);typeof o=="number"&&(typeof n=="number"||(typeof s=="number"?this.O.set(i,o+s):this.O.delete(i)))}async write(i,n,s,o,l){return(0,D.$Mg)(()=>this.W(i,n,s,o,l),100,3)}async W(i,n,s,o,l){const I=this.S(i,n);let E=null;try{E=(await S.Promises.write(i,s,o,l,I)).bytesWritten}catch(k){throw await this.bb(this.Q.get(i),k)}finally{this.U(i,I,E)}return E}async mkdir(i){try{await S.Promises.mkdir(this.C(i))}catch(n){throw this.ab(n)}}async delete(i,n){try{const s=this.C(i);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,w.$ac)((0,w.$dc)(s),`${(0,w.$ec)(s)}${n.atomic.postfix}`)),await S.Promises.rm(s,S.RimRafMode.MOVE,o)}else try{await S.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:I,symbolicLink:E}=await S.SymlinkSupport.stat(s);l=I.isDirectory()&&!E}catch{}if(l)await S.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.ab(s)}}async rename(i,n,s){const o=this.C(i),l=this.C(n);if(o!==l)try{await this.X(i,n,"move",s.overwrite),await S.Promises.rename(o,l)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,y.localize)(2,null,(0,w.$ec)(o),(0,w.$ec)((0,w.$dc)(l)),I.toString()))),this.ab(I)}}async copy(i,n,s){const o=this.C(i),l=this.C(n);if(o!==l)try{await this.X(i,n,"copy",s.overwrite),await S.Promises.copy(o,l,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,y.localize)(3,null,(0,w.$ec)(o),(0,w.$ec)((0,w.$dc)(l)),I.toString()))),this.ab(I)}}async X(i,n,s,o){const l=this.C(i),I=this.C(n);let E=!1;if(!!(this.capabilities&1024)||(E=(0,u.$Je)(l,I,!0)),E){if(s==="copy")throw(0,g.$5j)((0,y.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const j=await this.G(i);if(!j)throw(0,g.$5j)((0,y.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const W=await this.G(n);if(W){if(!o)throw(0,g.$5j)((0,y.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);j.type&g.FileType.File&&W.type&g.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,n){return this.Y(i,n,!1)}async Y(i,n,s){const o=this.C(i),l=this.C(n),I=!!(this.capabilities&1024);if((0,u.$Je)(o,l,!I))return;const E=new c.$kb;try{const[k,j]=await Promise.all([this.J(i),this.J(n)]);E.add(k),E.add(j),s&&await S.Promises.mkdir((0,w.$dc)(l),{recursive:!0}),await S.Promises.copyFile(o,l)}catch(k){if(k.code==="ENOENT"&&!s)return this.Y(i,n,!0);throw this.ab(k)}finally{E.dispose()}}p(i,n,s){return new $.$Ip(o=>i(o),o=>n(o),s)}y(i,n,s){return new p.$Qp(o=>i(o),o=>n(o),s)}ab(i){if(i instanceof g.$4j)return i;let n=i,s;switch(i.code){case"ENOENT":s=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=g.FileSystemProviderErrorCode.Unknown;break;default:s=g.FileSystemProviderErrorCode.Unknown}return(0,g.$5j)(n,s)}async bb(i,n){let s=this.ab(n);if(i&&s.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await S.SymlinkSupport.stat(this.C(i));o.mode&128||(s=(0,g.$5j)(n,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$Rp=t}),define(ne[126],re([0,1,2,6]),function(G,e,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=void 0;class D extends M.$lb{constructor(L,b=[]){super(),this.a=new N.$2i([L,...b]),this.B(L.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...b){this.a.trace(L,...b)}debug(L,...b){this.a.debug(L,...b)}info(L,...b){this.a.info(L,...b)}warn(L,...b){this.a.warn(L,...b)}error(L,...b){this.a.error(L,...b)}flush(){this.a.flush()}}e.$1M=D}),define(ne[127],re([0,1,12,6]),function(G,e,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=void 0;var D;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(D||(D={}));async function A(c,w,O,m,h){try{const S=await new Promise((g,d)=>{G(["@vscode/spdlog"],g,d)});S.setFlushOn(D.Trace);const y=await S.createAsyncRotatingLogger(c,w,O,m);return h?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(S){console.error(S)}return null}function L(c,w,O){switch(w){case N.LogLevel.Trace:c.trace(O);break;case N.LogLevel.Debug:c.debug(O);break;case N.LogLevel.Info:c.info(O);break;case N.LogLevel.Warning:c.warn(O);break;case N.LogLevel.Error:c.error(O);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function b(c,w){switch(w){case N.LogLevel.Trace:c.setLevel(D.Trace);break;case N.LogLevel.Debug:c.setLevel(D.Debug);break;case N.LogLevel.Info:c.setLevel(D.Info);break;case N.LogLevel.Warning:c.setLevel(D.Warning);break;case N.LogLevel.Error:c.setLevel(D.Error);break;case N.LogLevel.Off:c.setLevel(D.Off);break;default:throw new Error(`Invalid log level ${w}`)}}class u extends N.$Xi{constructor(w,O,m,h,S){super(),this.k=[],this.setLevel(S),this.l=this.n(w,O,m,h),this.B(this.onDidChangeLogLevel(y=>{this.m&&b(this.m,y)}))}async n(w,O,m,h){const S=m?6:1,y=30/S*M.$nk.MB,g=await A(w,O,y,S,h);if(g){this.m=g,b(this.m,this.getLevel());for(const{level:d,message:f}of this.k)L(this.m,d,f);this.k=[]}}g(w,O){this.m?L(this.m,w,O):this.getLevel()<=w&&this.k.push({level:w,message:O})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$PM=u}),define(ne[128],re([0,1,29,6,127]),function(G,e,M,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=void 0;class A extends N.$3i{m(b,u,c){return new D.$PM((0,M.$6e)(),b.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,u)}}e.$QM=A}),define(ne[38],re([0,1,4,65,2,10]),function(G,e,M,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=e.$Vm=void 0,e.$Vm=(0,A.$ph)("policy");class L extends D.$lb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new M.$8c),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const w=Object.keys(this.f).length;return this.f={...c,...this.f},w!==Object.keys(this.f).length&&await this.i(c),N.Iterable.reduce(this.g.entries(),(O,[m,h])=>({...O,[m]:h}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(c,[w,O])=>({...c,[w]:{definition:O,value:this.g.get(w)}}),{})}}e.$Wm=L;class b{constructor(){this.onDidChange=M.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Xm=b}),define(ne[129],re([0,1,8,4,65,3,12,6,38]),function(G,e,M,N,D,A,L,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a5b=void 0;function c(O,m){const h=[];for(const S of new Set(D.Iterable.concat(O.keys(),m.keys())))O.get(S)!==m.get(S)&&h.push(S);return h}let w=class extends u.$Wm{constructor(m,h,S){super(),this.j=m,this.k=h,this.l=S,this.c=this.B(new M.$tg(500));const y=N.Event.filter(h.onDidFilesChange,g=>g.affects(m));this.B(h.watch(m)),this.B(y(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const m=new Map;try{const h=await this.k.readFile(this.j),S=JSON.parse(h.value.toString());if(!(0,A.$le)(S))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(S))this.f[y]&&m.set(y,S[y])}catch(h){h.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",h)}return m}async p(){const m=await this.n(),h=c(this.g,m);this.g=m,h.length>0&&this.h.fire(h)}};e.$a5b=w,e.$a5b=w=pe([se(1,L.$Sj),se(2,b.$Ri)],w)}),define(ne[130],re([0,1,38,8,171,2,6]),function(G,e,M,N,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_4b=void 0;let b=class extends M.$Wm{constructor(c,w){super(),this.j=c,this.k=w,this.a=new N.$pg,this.b=this.B(new A.$mb)}async i(c){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((w,O)=>{try{this.b.value=(0,D.createWatcher)(this.k,c,m=>{this.m(m),w()})}catch(m){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),O(m)}}))}m(c){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const w in c){const O=c[w];O===void 0?this.g.delete(w):this.g.set(w,O)}this.h.fire(Object.keys(c))}};e.$_4b=b,e.$_4b=b=pe([se(0,L.$Ri)],b)}),define(ne[31],re([0,1,10]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=void 0,e.$0i=(0,M.$ph)("productService"),e.$$i="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,71,3]),function(G,e,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=void 0;class D{constructor(){this.a=new Map}add(L,b){M.ok(N.$je(L)),M.ok(N.$le(b)),M.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,b)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$Tm=new D}),define(ne[131],re([0,1,4,36]),function(G,e,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0,e.$Um={JSONContribution:"base.contributions.json"};function D(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class A{constructor(){this.b=new M.$8c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[D(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const L=new A;N.$Tm.add(e.$Um.JSONContribution,L)}),define(ne[44],re([0,1,19,4,3,88,25,131,36]),function(G,e,M,N,D,A,L,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.ConfigurationScope=e.$Ym=e.EditPresentationTypes=void 0;var c;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$Ym={Configuration:"base.contributions.configuration"};var w;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w||(e.ConfigurationScope=w={})),e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m={properties:{},patternProperties:{}},e.$5m={properties:{},patternProperties:{}},e.$6m="vscode://schemas/settings/resourceLanguage",e.$7m="vscode://schemas/settings/configurationDefaults";const O=u.$Tm.as(b.$Um.JSONContribution);class m{constructor(){this.h=new Set,this.i=new N.$8c,this.onDidSchemaChange=this.i.event,this.j=new N.$8c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},O.registerSchema(e.$6m,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),O.registerSchema(e.$6m,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),O.registerSchema(e.$6m,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),O.registerSchema(e.$6m,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:n,source:s}of t)for(const o in n)if(a.add(o),e.$9m.test(o)){const l=this.a.get(o),I=l?.valuesSources??new Map;if(s)for(const W of Object.keys(n[o]))I.set(W,s);const E={...l?.value||{},...n[o]};this.a.set(o,{source:s,value:E,valuesSources:I});const k=(0,L.$6h)(o),j={type:"object",default:E,description:A.localize(1,null,k),$ref:e.$6m,defaultDefaultValue:E,source:D.$je(s)?void 0:s,defaultValueSource:s};i.push(...y(o)),this.d[o]=j,this.b.properties[o]=j}else{this.a.set(o,{value:n[o],source:s});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:n}of t)for(const s in i){const o=this.a.get(s),l=D.$je(n)?n:n?.id,I=D.$je(o?.source)?o?.source:o?.source?.id;if(l===I)if(a.add(s),this.a.delete(s),e.$9m.test(s))delete this.d[s],delete this.b.properties[s];else{const E=this.d[s];E&&(this.w(s,E),this.r(s,E))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(n=>{this.p(n,a,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,a){const i=n=>{if(n.properties)for(const s in n.properties){a.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>i(s))};for(const n of t){i(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(t,a=!0,i,n,s=3,o){s=D.$se(t.scope)?s:t.scope;const l=t.properties;if(l)for(const E in l){const k=l[E];if(a&&P(E,k)){delete l[E];continue}if(k.source=i,k.defaultDefaultValue=l[E].default,this.w(E,k),e.$9m.test(E)?k.scope=void 0:(k.scope=D.$se(k.scope)?s:k.scope,k.restricted=D.$se(k.restricted)?!!n?.includes(E):k.restricted),l[E].hasOwnProperty("included")&&!l[E].included){this.f[E]=l[E],delete l[E];continue}else this.d[E]=l[E],l[E].policy?.name&&this.e.set(l[E].policy.name,E);!l[E].deprecationMessage&&l[E].markdownDeprecationMessage&&(l[E].deprecationMessage=l[E].markdownDeprecationMessage),o.add(E)}const I=t.allOf;if(I)for(const E of I)this.p(E,a,i,n,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const n=i.properties;if(n)for(const o in n)this.r(o,n[o]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.$Zm.properties[t]=a,a.scope){case 1:e.$1m.properties[t]=a;break;case 2:e.$2m.properties[t]=a;break;case 6:e.$3m.properties[t]=a;break;case 3:e.$4m.properties[t]=a;break;case 4:e.$5m.properties[t]=a;break;case 5:e.$5m.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.$Zm.properties[t],a.scope){case 1:delete e.$1m.properties[t];break;case 2:delete e.$2m.properties[t];break;case 6:delete e.$3m.properties[t];break;case 3:delete e.$4m.properties[t];break;case 4:case 5:delete e.$5m.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$6m};this.w(a,i),e.$Zm.properties[a]=i,e.$1m.properties[a]=i,e.$2m.properties[a]=i,e.$3m.properties[a]=i,e.$4m.properties[a]=i,e.$5m.properties[a]=i}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$6m};e.$Zm.patternProperties[e.$8m]=t,e.$1m.patternProperties[e.$8m]=t,e.$2m.patternProperties[e.$8m]=t,e.$3m.patternProperties[e.$8m]=t,e.$4m.patternProperties[e.$8m]=t,e.$5m.patternProperties[e.$8m]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let n=i?.value,s=i?.source;D.$qe(n)&&(n=a.defaultDefaultValue,s=void 0),D.$qe(n)&&(n=d(a.type)),a.default=n,a.defaultValueSource=s}}const h="\\[([^\\]]+)\\]",S=new RegExp(h,"g");e.$8m=`^(${h})+$`,e.$9m=new RegExp(e.$8m);function y(p){const t=[];if(e.$9m.test(p)){let a=S.exec(p);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=S.exec(p)}}return(0,M.$rf)(t)}e.$0m=y;function g(p){return p.reduce((t,a)=>`${t}[${a}]`,"")}e.$$m=g;function d(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$_m=d;const f=new m;u.$Tm.add(e.$Ym.Configuration,f);function P(p,t){return p.trim()?e.$9m.test(p)?A.localize(7,null,p):f.getConfigurationProperties()[p]!==void 0?A.localize(8,null,p):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,p,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$an=P;function $(){const p=[],t=f.getConfigurationProperties();for(const a of Object.keys(t))p.push([a,t[a].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.$bn=$}),define(ne[66],re([0,1,19,4,53,2,35,30,3,11,25,44,36]),function(G,e,M,N,D,A,L,b,u,c,w,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=void 0;function h(a){return Object.isFrozen(a)?a:b.$Im(a)}class S{constructor(i={},n=[],s=[],o){this.b=i,this.c=n,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof S)return n;const s=new y("");return s.parseRaw(n),s.configurationModel});this.f=i.reduce((n,s)=>s===n?s:n.merge(s),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,w.$4h)(this.contents,i):this.contents}inspect(i,n){const s=this.rawConfiguration.getValue(i),o=n?this.rawConfiguration.getOverrideValue(i,n):void 0,l=n?this.rawConfiguration.override(n).getValue(i):s;return{value:s,override:o,merged:l}}getOverrideValue(i,n){const s=this.i(n);return s?i?(0,w.$4h)(s,i):s:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const s of this.overrides)s.identifiers.includes(i)&&n.push(...s.keys);return M.$rf(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return M.$rf(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=b.$Hm(this.contents),s=b.$Hm(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const I of i)if(l.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(n,I.contents);for(const E of I.overrides){const[k]=s.filter(j=>M.$bf(j.identifiers,E.identifiers));k?(this.h(k.contents,E.contents),k.keys.push(...E.keys),k.keys=M.$rf(k.keys)):s.push(b.$Hm(E))}for(const E of I.keys)o.indexOf(E)===-1&&o.push(E)}return new S(n,o,s,l.every(I=>I instanceof S)?void 0:l)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const o of M.$rf([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[o];const I=n[o];I&&(typeof l=="object"&&typeof I=="object"?(l=b.$Hm(l),this.h(l,I)):l=I),s[o]=l}return new S(s,this.keys,this.overrides)}h(i,n){for(const s of Object.keys(n)){if(s in i&&u.$le(i[s])&&u.$le(n[s])){this.h(i[s],n[s]);continue}i[s]=b.$Hm(n[s])}}i(i){let n=null,s=null;const o=l=>{l&&(s?this.h(s,l):s=b.$Hm(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===i?n=l.contents:l.identifiers.includes(i)&&o(l.contents);return o(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,w.$3h)(this.contents,i),O.$9m.test(i)&&this.overrides.splice(this.overrides.findIndex(s=>M.$bf(s.identifiers,(0,O.$0m)(i))),1))}j(i,n,s){(0,w.$2h)(this.contents,i,n,o=>console.error(o)),s=s||this.keys.indexOf(i)===-1,s&&this.keys.push(i),O.$9m.test(i)&&this.overrides.push({identifiers:(0,O.$0m)(i),keys:Object.keys(this.contents[i]),contents:(0,w.$1h)(this.contents[i],o=>console.error(o))})}}e.$cn=S;class y{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!u.$se(i)){const s=this.g(i);this.parseRaw(s,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:s,keys:o,overrides:l,restricted:I,hasExcludedProperties:E}=this.h(i,n);this.b=new S(s,o,l,E?[i]:void 0),this.c=I||[]}g(i){let n={},s=null,o=[];const l=[],I=[];function E(j){Array.isArray(o)?o.push(j):s!==null&&(o[s]=j)}const k={onObjectBegin:()=>{const j={};E(j),l.push(o),o=j,s=null},onObjectProperty:j=>{s=j},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const j=[];E(j),l.push(o),o=j,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:E,onError:(j,W,ee)=>{I.push({error:j,offset:W,length:ee})}};if(i)try{D.$Em(i,k),n=o[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return n}h(i,n){const s=m.$Tm.as(O.$Ym.Configuration).getConfigurationProperties(),o=this.i(i,s,!0,n);i=o.raw;const l=(0,w.$1h)(i,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),I=Object.keys(i),E=this.j(i,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:l,keys:I,overrides:E,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(i,n,s,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:l};const I={},E=[];for(const k in i)if(O.$9m.test(k)&&s){const j=this.i(i[k],n,!1,o);I[k]=j.raw,l=l||j.hasExcludedProperties,E.push(...j.restricted)}else{const j=n[k],W=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&E.push(k),!o.exclude?.includes(k)&&(o.include?.includes(k)||(W===void 0||o.scopes===void 0||o.scopes.includes(W))&&!(o.skipRestricted&&j?.restricted))?I[k]=i[k]:l=!0}return{raw:I,restricted:E,hasExcludedProperties:l}}j(i,n){const s=[];for(const o of Object.keys(i))if(O.$9m.test(o)){const l={};for(const I in i[o])l[I]=i[o][I];s.push({identifiers:(0,O.$0m)(o),keys:Object.keys(l),contents:(0,w.$1h)(l,n)})}return s}}e.$dn=y;class g extends A.$lb{constructor(i,n,s,o){super(),this.c=i,this.f=n,this.g=o,this.b=this.B(new N.$8c),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$en=g;class d{constructor(i,n,s,o,l,I,E,k,j,W,ee,x,le){this.a=i,this.b=n,this.c=s,this.overrideIdentifiers=o,this.d=l,this.f=I,this.g=E,this.h=k,this.i=j,this.j=W,this.k=ee,this.l=x,this.m=le}get value(){return h(this.c)}n(i,n,s){const o=i.inspect(n,s);return{get value(){return h(o.value)},get override(){return h(o.override)},get merged(){return h(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(i,n,s,o,l=new S,I=new S,E=new L.$ni,k=new S,j=new L.$ni){this.c=i,this.d=n,this.f=s,this.g=o,this.h=l,this.i=I,this.j=E,this.l=k,this.m=j,this.a=null,this.b=new L.$ni,this.n=null}getValue(i,n,s){return this.q(i,n,s).getValue(i)}updateValue(i,n,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new S,this.m.set(s.resource,o))):o=this.l,n===void 0?o.removeValue(i):o.setValue(i,n),s.resource||(this.a=null)}inspect(i,n,s){const o=this.q(i,n,s),l=this.u(n.resource,s),I=n.resource?this.m.get(n.resource)||this.l:this.l,E=new Set;for(const k of o.overrides)for(const j of k.identifiers)o.getOverrideValue(i,j)!==void 0&&E.add(j);return new d(i,n,o.getValue(i),E.size?[...E]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,l||void 0,I)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const s=[];if(!n){const{added:o,updated:l,removed:I}=p(this.c,i);n=[...o,...l,...I]}for(const o of n)for(const l of(0,O.$0m)(o)){const I=this.c.getKeysForOverrideIdentifier(l),E=i.getKeysForOverrideIdentifier(l),k=[...E.filter(j=>I.indexOf(j)===-1),...I.filter(j=>E.indexOf(j)===-1),...I.filter(j=>!b.$Lm(this.c.override(l).getValue(j),i.override(l).getValue(j)))];s.push([l,k])}return this.updateDefaultConfiguration(i),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:s,removed:o}=p(this.d,i),l=[...n,...s,...o];return l.length&&this.updatePolicyConfiguration(i),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:s,removed:o,overrides:l}=p(this.applicationConfiguration,i),I=[...n,...s,...o];return I.length&&this.updateApplicationConfiguration(i),{keys:I,overrides:l}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:s,removed:o,overrides:l}=p(this.localUserConfiguration,i),I=[...n,...s,...o];return I.length&&this.updateLocalUserConfiguration(i),{keys:I,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:s,removed:o,overrides:l}=p(this.remoteUserConfiguration,i),I=[...n,...s,...o];return I.length&&this.updateRemoteUserConfiguration(i),{keys:I,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:s,removed:o,overrides:l}=p(this.workspaceConfiguration,i),I=[...n,...s,...o];return I.length&&this.updateWorkspaceConfiguration(i),{keys:I,overrides:l}}compareAndUpdateFolderConfiguration(i,n){const s=this.p.get(i),{added:o,updated:l,removed:I,overrides:E}=p(s,n),k=[...o,...l,...I];return(k.length||!s)&&this.updateFolderConfiguration(i,n),{keys:k,overrides:E}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:o,removed:l,overrides:I}=p(n,void 0);return{keys:[...s,...o,...l],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,s){let o=this.r(n,s);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(o=o.merge(this.d)),o}r({resource:i},n){let s=this.s();if(n&&i){const o=n.getFolder(i);o&&(s=this.t(o.uri)||s);const l=this.m.get(i);l&&(s=s.merge(l))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const s=this.s(),o=this.j.get(i);o?(n=s.merge(o),this.b.set(i,n)):n=s}return n}u(i,n){if(n&&i){const s=n.getFolder(i);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:s,overrides:o,keys:l}=this.j.get(n);return i.push([n,{contents:s,overrides:o,keys:l}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(s=>i.add(s))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>i.add(s))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o))),[...n.values()]}static parse(i){const n=this.x(i.defaults),s=this.x(i.policy),o=this.x(i.application),l=this.x(i.user),I=this.x(i.workspace),E=i.folders.reduce((k,j)=>(k.set(c.URI.revive(j[0]),this.x(j[1])),k),new L.$ni);return new f(n,s,o,l,new S,I,E,new S,new L.$ni)}static x(i){return new S(i.contents,i.keys,i.overrides)}}e.$fn=f;function P(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const o of a)o.keys.forEach(l=>i.add(l)),o.overrides.forEach(([l,I])=>{const E=(0,L.$ki)(n,l,new Set);I.forEach(k=>E.add(k))});const s=[];return n.forEach((o,l)=>s.push([l,[...o.values()]])),{keys:[...i.values()],overrides:s}}e.$gn=P;class ${constructor(i,n,s,o){this.change=i,this.f=n,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of i.keys)this.affectedKeys.add(l);for(const[,l]of i.overrides)for(const I of l)this.affectedKeys.add(I);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(i,n){const s=this.a+i,o=this.d.indexOf(s);if(o<0)return!1;const l=o+s.length;if(l>=this.d.length)return!1;const I=this.d.charCodeAt(l);if(I!==this.b&&I!==this.c)return!1;if(n){const E=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,k=this.g.getValue(i,n,this.h);return!b.$Lm(E,k)}return!0}}e.$hn=$;function p(a,i){const{added:n,removed:s,updated:o}=t(i?.rawConfiguration,a?.rawConfiguration),l=[],I=a?.getAllOverrideIdentifiers()||[],E=i?.getAllOverrideIdentifiers()||[];if(i){const k=E.filter(j=>!I.includes(j));for(const j of k)l.push([j,i.getKeysForOverrideIdentifier(j)])}if(a){const k=I.filter(j=>!E.includes(j));for(const j of k)l.push([j,a.getKeysForOverrideIdentifier(j)])}if(i&&a){for(const k of I)if(E.includes(k)){const j=t({contents:a.getOverrideValue(void 0,k)||{},keys:a.getKeysForOverrideIdentifier(k)},{contents:i.getOverrideValue(void 0,k)||{},keys:i.getKeysForOverrideIdentifier(k)});l.push([k,[...j.added,...j.removed,...j.updated]])}}return{added:n,removed:s,updated:o,overrides:l}}function t(a,i){const n=a?i?a.keys.filter(l=>i.keys.indexOf(l)===-1):[...a.keys]:[],s=i?a?i.keys.filter(l=>a.keys.indexOf(l)===-1):[...i.keys]:[],o=[];if(a&&i){for(const l of i.keys)if(a.keys.indexOf(l)!==-1){const I=(0,w.$4h)(i.contents,l),E=(0,w.$4h)(a.contents,l);b.$Lm(I,E)||o.push(l)}}return{added:n,removed:s,updated:o}}}),define(ne[132],re([0,1,19,4,2,30,3,66,44,6,38,36]),function(G,e,M,N,D,A,L,b,u,c,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=void 0;class m extends D.$lb{constructor(){super(...arguments),this.a=this.B(new N.$8c),this.onDidChangeConfiguration=this.a.event,this.b=new b.$cn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(O.$Tm.as(u.$Ym.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:d})=>this.c(Array.from(g),d))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(g,d){this.h(g,O.$Tm.as(u.$Ym.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}g(){this.b=new b.$cn;const g=O.$Tm.as(u.$Ym.Configuration).getConfigurationProperties();this.h(Object.keys(g),g)}h(g,d){const f=this.f();for(const P of g){const $=f[P],p=d[P];$!==void 0?this.b.addValue(P,$):p?this.b.addValue(P,p.default):this.b.removeValue(P)}}}e.$in=m;class h{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new b.$cn}async initialize(){return this.configurationModel}}e.$jn=h;let S=class extends D.$lb{get configurationModel(){return this.b}constructor(g,d,f){super(),this.c=g,this.f=d,this.g=f,this.a=this.B(new N.$8c),this.onDidChangeConfiguration=this.a.event,this.b=new b.$cn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.i(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.j(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const d={},f=[],P=O.$Tm.as(u.$Ym.Configuration).getConfigurationProperties();for(const $ of g){const p=P[$];if(!p){f.push($);continue}if(p.policy){if(p.type!=="string"&&p.type!=="number"){this.g.warn(`Policy ${p.policy.name} has unsupported type ${p.type}`);continue}f.push($),d[p.policy.name]={type:p.type}}}return(0,L.$we)(d)||await this.f.updatePolicyDefinitions(d),f}i(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const d=O.$Tm.as(u.$Ym.Configuration).getPolicyConfigurations(),f=(0,M.$mf)(g.map(P=>d.get(P)));this.j(f,!0)}j(g,d){this.g.trace("PolicyConfiguration#update",g);const f=O.$Tm.as(u.$Ym.Configuration).getConfigurationProperties(),P=[],$=this.b.isEmpty();for(const p of g){const t=f[p]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);($?a!==void 0:!(0,A.$Lm)(this.b.getValue(p),a))&&P.push([p,a])}else this.b.getValue(p)!==void 0&&P.push([p,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const p=this.b;this.b=new b.$cn;for(const t of p.keys)this.b.setValue(t,p.getValue(t));for(const[t,a]of P)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);d&&this.a.fire(this.b)}}};e.$kn=S,e.$kn=S=pe([se(1,w.$Vm),se(2,c.$Ri)],S)}),define(ne[133],re([0,1,8,4,2,17,25,66,132,38]),function(G,e,M,N,D,A,L,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0;class w extends D.$lb{constructor(m,h,S,y){super(),this.i=m,this.h=this.B(new N.$8c),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$in),this.c=S instanceof c.$Xm?new u.$jn:this.B(new u.$kn(this.b,S,y)),this.f=this.B(new b.$en(this.i,{},A.$1f,h)),this.a=new b.$fn(this.b.configurationModel,this.c.configurationModel,new b.$cn,new b.$cn),this.g=this.B(new M.$Gg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:g,properties:d})=>this.k(g,d))),this.B(this.c.onDidChangeConfiguration(g=>this.l(g))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,h,S]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new b.$fn(m,h,new b.$cn,S)}getConfigurationData(){return this.a.toData()}getValue(m,h){const S=typeof m=="string"?m:void 0,y=(0,L.$Wh)(m)?m:(0,L.$Wh)(h)?h:{};return this.a.getValue(S,y,void 0)}updateValue(m,h,S,y){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const h=this.a.toData(),S=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(S,h,2)}k(m,h){const S=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(m,h);this.m(y,S,7)}l(m){const h=this.a.toData(),S=this.a.compareAndUpdatePolicyConfiguration(m);this.m(S,h,7)}m(m,h,S){const y=new b.$hn(m,{data:h},this.a);y.source=S,y.sourceConfig=this.n(S),this.h.fire(y)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$ln=w}),define(ne[67],re([0,1,15]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=void 0;function N(c){return c.scheme===M.Schemas.vscodeRemote?c.authority:void 0}e.$Bk=N;function D(c){if(!c)return;const w=c.indexOf("+");return w<0?c:c.substr(0,w)}e.$Ck=D;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Dk=A;function L(c){const{host:w,port:O}=u(c);if(typeof O>"u")throw new Error("Remote authority doesn't contain a port!");return{host:w,port:O}}e.$Ek=L;function b(c,w){let{host:O,port:m}=u(c);return typeof m>"u"&&(m=w),{host:O,port:m}}e.$Fk=b;function u(c){const w=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const O=c.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const m=c.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:c,port:void 0}}}),define(ne[37],re([0,1,28,10,67]),function(G,e,M,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.TargetPlatform=e.ExtensionType=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=void 0,e.$Bl="extensions.user.cache",e.$Cl="extensions.builtin.cache",e.$Dl="undefined_publisher",e.$El=["ui","workspace","web"];function A(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$Fl=A,e.$Gl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(L||(e.ExtensionType=L={}));var b;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class u{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,d){if(typeof g>"u"||g===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof g=="string"||typeof d=="string"){const f=typeof g=="string"?g:g.value,P=typeof d=="string"?d:d.value;return M.$Md(f,P)}return g._lower===d._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Hl=u;class c{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const d of g)this.add(d)}add(g){this.c.add(u.toKey(g))}delete(g){return this.c.delete(u.toKey(g))}has(g){return this.c.has(u.toKey(g))}}e.$Il=c;class w{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(u.toKey(g))}get(g){return this.c.get(u.toKey(g))}has(g){return this.c.has(u.toKey(g))}set(g,d){this.c.set(u.toKey(g),d)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Jl=w;function O(y){return m(y)}e.$Kl=O;function m(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$Ll=m;function h(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$Ml=h;function S(y,g){if(g){const d=`onResolveRemoteAuthority:${(0,D.$Ck)(g)}`;return!!y.activationEvents?.includes(d)}return!1}e.$Nl=S,e.$Ol=(0,N.$ph)("IBuiltinExtensionsScannerService")}),define(ne[134],re([0,1,2,37,12]),function(G,e,M,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=void 0;class A extends M.$lb{constructor(b,u,c,w,O){super(),this.a=b,this.b=u,this.c=c,this.f=O,this.B(w.onDidInstallExtensions(m=>this.g(m))),this.B(w.onDidUninstallExtension(m=>this.h(m)))}g(b){for(const u of b)u.local&&this.invalidate(u.profileLocation)}h(b){b.error||this.invalidate(b.profileLocation)}async invalidate(b){if(b)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,b)&&await this.i(u);else await this.i(this.a.defaultProfile)}async i(b){try{await this.b.del(this.c.extUri.joinPath(b.cacheHome,N.$Bl))}catch(u){(0,D.$9j)(u)!==1&&this.f.error(u)}}}e.$lp=A}),define(ne[45],re([0,1,14,9,2,103,44,10,6,36]),function(G,e,M,N,D,A,L,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=void 0,e.$yo=(0,b.$ph)("requestService");class w{constructor(p){this.b=p}toJSON(){if(!this.a){const p=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?p[t]="*****":p[t]=this.b[t];this.a=p}return this.a}}class O extends D.$lb{constructor(p){super(),this.b=0,this.a=p.createLogger("network",{name:(0,A.localize)(0,null),when:u.$9i.isEqualTo((0,u.$7i)(u.LogLevel.Trace)).serialize()})}async c(p,t,a){const i=`${p} #${++this.b}: ${t.url}`;this.a.trace(`${i} - begin`,t.type,new w(t.headers??{}));try{const n=await a();return this.a.trace(`${i} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${i} - error`,t.type,(0,N.$9)(n)),n}}}e.$zo=O;function m($){return $.res.statusCode&&$.res.statusCode>=200&&$.res.statusCode<300||$.res.statusCode===1223}e.$Ao=m;function h($){return $.res.statusCode===204}async function S($){return h($)?null:(await(0,M.$Vb)($.stream)).toString()}e.$Bo=S;async function y($){if(!m($))throw new Error("Server returned "+$.res.statusCode);return S($)}e.$Co=y;async function g($){if(!m($))throw new Error("Server returned "+$.res.statusCode);if(h($))return null;const t=(await(0,M.$Vb)($.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.$Do=g;function d($){P($)}e.$Eo=d;let f;function P($){const p=c.$Tm.as(L.$Ym.Configuration),t=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:$,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},p.updateConfigurations({add:[f],remove:t?[t]:[]})}P(1)}),define(ne[135],re([0,1,20,15,12,45]),function(G,e,M,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=void 0;let L=class{constructor(u,c){this.a=u,this.b=c}async download(u,c,w=M.CancellationToken.None){if(u.scheme===N.Schemas.file||u.scheme===N.Schemas.vscodeRemote){await this.b.copy(u,c);return}const O={type:"GET",url:u.toString(!0)},m=await this.a.request(O,w);if(m.res.statusCode===200)await this.b.writeFile(c,m.stream);else{const h=await(0,A.$Co)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${h}`)}}};e.$dN=L,e.$dN=L=pe([se(0,A.$yo),se(1,D.$Sj)],L)}),define(ne[136],re([0,1,137,3]),function(G,e,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;function D(L,b){return L.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:L.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function A(L,b,u={}){const c=(0,M.parse)(L),w=u.proxyUrl||D(c,b);if(!w)return null;const O=(0,M.parse)(w);if(!/^https?:$/.test(O.protocol||""))return null;const m={host:O.hostname||"",port:O.port||(O.protocol==="https"?"443":"80"),auth:O.auth,rejectUnauthorized:(0,N.$pe)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((h,S)=>{G(["http-proxy-agent"],h,S)}))(m):new(await new Promise((h,S)=>{G(["https-proxy-agent"],h,S)}))(m)}e.$Cq=A}),define(ne[138],re([0,1,58,16,104,20,33,9,13,29,84,172,8,72]),function(G,e,M,N,D,A,L,b,u,c,w,O,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=void 0;let S;async function y(d,f,P,$){return P["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.$sl)($)&&!P["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.$sl)($)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),S||(S=m.Promises.withAsyncBody(async(p,t)=>{const a=new A.$ed;let i=1e4;const n=d.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,h.$tl)(n,1,120)*1e3);const s=setTimeout(()=>{a.dispose(!0),t(new Error((0,D.localize)(0,null)))},i);try{p(await g(f,a.token))}catch(o){!(0,b.$2)(o)&&!a.token.isCancellationRequested?t(new Error((0,D.localize)(1,null,(0,L.$ai)(o)))):p({})}finally{clearTimeout(s),a.dispose()}})),S)}e.$yl=y;async function g(d,f){const P=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",P);const $=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",$);const p=(0,c.$6e)().replace(/-/g,"").substr(0,12),t=new RegExp(p+"({.*})"+p),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",a);const i=await(0,w.$jl)(u.OS,a);return d.trace("getUnixShellEnvironment#shell",i),new Promise((n,s)=>{if(f.isCancellationRequested)return s(new b.$3);const o=(0,N.$ec)(i);let l,I;const E=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${E} -p '''${p}'' + JSON.stringify(process.env) + ''${p}'''`,I=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${E} -p '"${p}" + JSON.stringify(process.env) + "${p}"'`,I=["-i","-l","-c"]):(l=`'${process.execPath}' ${E} -p '"${p}" + JSON.stringify(process.env) + "${p}"'`,o==="tcsh"||o==="csh"?I=["-ic"]:I=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),l);const k=(0,M.spawn)(i,[...I,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});f.onCancellationRequested(()=>(k.kill(),s(new b.$3))),k.on("error",ee=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,L.$ai)(ee)),s(ee)});const j=[];k.stdout.on("data",ee=>j.push(ee));const W=[];k.stderr.on("data",ee=>W.push(ee)),k.on("close",(ee,x)=>{const le=Buffer.concat(j).toString("utf8");d.trace("getUnixShellEnvironment#raw",le);const te=Buffer.concat(W).toString("utf8");if(te.trim()&&d.trace("getUnixShellEnvironment#stderr",te),ee||x)return s(new Error((0,D.localize)(2,null,ee,x)));const ae=t.exec(le),ce=ae?ae[1]:"{}";try{const ie=JSON.parse(ce);P?ie.ELECTRON_RUN_AS_NODE=P:delete ie.ELECTRON_RUN_AS_NODE,$?ie.ELECTRON_NO_ATTACH_CONSOLE=$:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.VSCODE_RESOLVING_ENVIRONMENT,delete ie.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",ie),n(ie)}catch(ie){d.error("getUnixShellEnvironment#errorCaught",(0,L.$ai)(ie)),s(ie)}})})}}),define(ne[139],re([0,1,10]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=void 0,e.$RM=(0,M.$ph)("stateReadService"),e.$SM=(0,M.$ph)("stateService")}),define(ne[68],re([0,1,8,14,3,18,12,6]),function(G,e,M,N,D,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.$UM=e.$TM=e.SaveStrategy=void 0;var u;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class c{constructor(h,S,y,g){this.f=h,this.g=y,this.h=g,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=S===0?void 0:new M.$tg(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(h){h.fileOperationResult!==1&&this.g.error(h)}}getItem(h,S){const y=this.a[h];return(0,D.$se)(y)?S:y}setItem(h,S){this.setItems([{key:h,data:S}])}setItems(h){let S=!1;for(const{key:y,data:g}of h)this.a[y]!==g&&((0,D.$se)(g)?(0,D.$qe)(this.a[y])||(this.a[y]=void 0,S=!0):(this.a[y]=g,S=!0));S&&this.j()}removeItem(h){(0,D.$qe)(this.a[h])||(this.a[h]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const h=JSON.stringify(this.a,null,4);if(h!==this.b)try{await this.h.writeFile(this.f,N.$Jb.fromString(h),{atomic:{postfix:".vsctmp"}}),this.b=h}catch(S){this.g.error(S)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.$TM=c;let w=class{constructor(h,S,y,g){this.a=new c(S.stateResource,h,y,g)}async init(){await this.a.init()}getItem(h,S){return this.a.getItem(h,S)}};e.$UM=w,e.$UM=w=pe([se(1,A.$wh),se(2,b.$Ri),se(3,L.$Sj)],w);class O extends w{setItem(h,S){this.a.setItem(h,S)}setItems(h){this.a.setItems(h)}removeItem(h){this.a.removeItem(h)}close(){return this.a.close()}}e.$VM=O}),define(ne[69],re([0,1,13,34,29]),function(G,e,M,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=void 0;function A(u){if(M.$t===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function L(u,c,w,O,m,h,S,y){const g=Object.create(null);g["common.machineId"]=h,g.sessionID=(0,D.$6e)()+Date.now(),g.commitHash=O,g.version=m,g["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,M.$h)(M.$t),g["common.nodePlatform"]=N.$7b,g["common.nodeArch"]=w,g["common.product"]=y||"desktop",S&&(g["common.msftInternal"]=S);let d=0;const f=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),M.$l&&(g["common.snap"]="true");const P=A(c);return P&&(g["common.platformDetail"]=P),g}e.$Zn=L;function b(u){const c=N.env.USERDNSDOMAIN;if(!c)return!1;const w=c.toLowerCase();return u.some(O=>w===O)}e.$1n=b}),define(ne[26],re([0,1,10]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0,e.$Vk=(0,M.$ph)("telemetryService"),e.$Wk=(0,M.$ph)("customEndpointTelemetryService"),e.$Xk="telemetry.currentSessionDate",e.$Yk="telemetry.firstSessionDate",e.$Zk="telemetry.lastSessionDate",e.$1k="telemetry.machineId",e.$2k="telemetry",e.$3k="telemetry.telemetryLevel",e.$4k="telemetry.enableCrashReporter",e.$5k="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var D;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(ne[39],re([0,1,30,3,4,25,67,69,26]),function(G,e,M,N,D,A,L,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0;class c{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$2n=c;class w{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$3n=w,e.$4n=new w;class O{async publicLog(s,o,l){}async publicLogError(s,o,l){}}e.$5n=O,e.$6n="telemetry",e.$7n="extensionTelemetryLog",e.$8n={log:()=>null,flush:()=>Promise.resolve(null)};function m(n,s){return D.Event.debounce(s.onDidChangeConfiguration,(l,I)=>{const E=l?new Set([...l.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:E}},1e3,!0)(l=>{l.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,A.$Yh)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$9n=m;function h(n,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!n.enableTelemetry||s.extensionTestsLocationURI)}e.$0n=h;function S(n,s){return!(s.isBuilt||s.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$$n=S;function y(n){const s=n.getValue(u.$3k),o=n.getValue(u.$4k);if(n.getValue(u.$5k)===!1||o===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$_n=y;function g(n){const s={},o={},l={};P(n,l);for(let I in l){I=I.length>150?I.substr(I.length-149):I;const E=l[I];typeof E=="number"?o[I]=E:typeof E=="boolean"?o[I]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${E.length}`),s[I]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(s[I]=E)}return{properties:s,measurements:o}}e.$ao=g;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(n){if(!n)return"none";const s=(0,L.$Ck)(n);return d.has(s)?s:"other"}e.$bo=f;function P(n,s,o=0,l){if(n)for(const I of Object.getOwnPropertyNames(n)){const E=n[I],k=l?l+I:I;Array.isArray(E)?s[k]=(0,M.$Mm)(E):E instanceof Date?s[k]=E.toISOString():(0,N.$le)(E)?o<2?P(E,s,o+1,k+"."):s[k]=(0,M.$Mm)(E):s[k]=E}}function $(n,s){const o=n.msftInternalDomains||[],l=s.getValue("telemetry.internalTesting");return(0,b.$1n)(o)||l}e.$co=$;function p(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$do=p;function t(n,s){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let o=n;const l=[];for(const j of s)for(;;){const W=j.exec(n);if(!W)break;l.push([W.index,j.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(o="";;){const j=E.exec(n);if(!j)break;const W=l.some(([ee,x])=>j.index<x&&ee<E.lastIndex);!I.test(j[0])&&!W&&(o+=n.substring(k,j.index)+"<REDACTED: user-file-path>",k=E.lastIndex)}return k<n.length&&(o+=n.substr(k)),o}function a(n){if(!n)return n;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of s)if(o.regex.test(n))return`<REDACTED: ${o.label}>`;return n}function i(n,s){return(0,M.$Jm)(n,o=>{if(o instanceof c||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let l=o.replaceAll("%20"," ");l=t(l,s);for(const I of s)l=l.replace(I,"");return l=a(l),l}})}e.$eo=i}),define(ne[27],re([0,1,28,21,37,13,11,9,34,39]),function(G,e,M,N,D,A,L,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=void 0;function w(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,M.$Hd)(i.id,n.id)===0}e.$fo=w;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(n){const s=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new m(n.identifier,s,o)}static parse(n){const s=O.exec(n);return s&&s[1]&&s[2]?new m({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof m?w(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$go=m;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(i){const n=h.exec(i);return n&&n[1]?[g(n[1]),n[2]]:[g(i),void 0]}e.$ho=S;function y(i,n){return`${i}.${n}`}e.$io=y;function g(i){return i.toLowerCase()}e.$jo=g;function d(i,n){return g(y(i??D.$Dl,n))}e.$ko=d;function f(i,n){const s=[],o=l=>{for(const I of s)if(I.some(E=>w(n(E),n(l))))return I;return null};for(const l of i){const I=o(l);I?I.push(l):s.push([l])}return s}e.$lo=f;function P(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$mo=P;function $(i){return{id:new c.$2n(i.identifier.id),name:new c.$2n(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$no=$,e.$oo=new D.$Hl("pprice.better-merge");function p(i,n){const s=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&s.every(I=>!w(I.identifier,{id:l}))){const I=i.filter(E=>w(E.identifier,{id:l}));I.length===1&&(s.push(I[0]),o.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$po=p;async function t(i,n){if(!A.$k)return!1;let s;try{s=(await i.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await i.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,b.$9)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,n){const s=await t(i,n),o=(0,N.$Kn)(s?"alpine":A.$t,u.$8b);return n.debug("ComputeTargetPlatform:",o),o}e.$qo=a}),define(ne[140],re([0,1,20,9,15,17,43,11,93,21,27,37]),function(G,e,M,N,D,A,L,b,u,c,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=void 0;const m=g=>(0,u.localize)(0,null,g),h=(0,u.localize)(1,null,"ms-dotnettools.csharp");function S(g,d){return d?`${g.publisher}.${g.name}@${g.version}`:`${g.publisher}.${g.name}`}let y=class{constructor(d,f,P){this.a=d,this.b=f,this.d=P}get f(){}async listExtensions(d,f,P){let $=await this.b.getInstalled(1,P);const p=O.$Gl.map(a=>a.toLowerCase());if(f&&f!==""){if(p.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}$=$.filter(a=>a.manifest.categories?a.manifest.categories.map(n=>n.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),p.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),$=$.sort((a,i)=>a.identifier.id.localeCompare(i.identifier.id));let t;for(const a of $)t!==a.identifier.id&&(t=a.identifier.id,this.a.info(S(a.manifest,d)))}async installExtensions(d,f,P,$){const p=[];try{const t=[];d.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const a=[];let i=[];const n=(o,l,I)=>{i.push({id:o,version:l!=="prerelease"?l:void 0,installOptions:{...P,isBuiltin:I,installPreReleaseVersion:l==="prerelease"||P.installPreReleaseVersion}})};for(const o of d)if(o instanceof b.URI)a.push({vsix:o,installOptions:P});else{const[l,I]=(0,w.$ho)(o);n(l,I,!1)}for(const o of f)if(o instanceof b.URI)a.push({vsix:o,installOptions:{...P,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,I]=(0,w.$ho)(o);n(l,I,!0)}const s=await this.b.getInstalled(1,P.profileLocation);if(a.length&&await Promise.all(a.map(async({vsix:o,installOptions:l})=>{try{const I=await this.g(o,l,$,s);I&&t.push(I)}catch(I){this.a.error(I),p.push(o.toString())}})),i.length&&(i=i.filter(({id:o,version:l})=>{const I=s.find(E=>(0,w.$fo)(E.identifier,{id:o}));if(I){if(!$&&(!l||l==="prerelease"&&I.preRelease))return this.a.info((0,u.localize)(5,null,o,I.manifest.version,o)),!1;if(l&&I.manifest.version===l)return this.a.info((0,u.localize)(6,null,`${o}@${l}`)),!1}return!0}),i.length)){const o=await this.h(i);await Promise.all(i.map(async l=>{const I=o.get(l.id.toLowerCase());if(I)try{const E=await this.j(l,I,s);E&&t.push(E)}catch(E){this.a.error(E.message||E.stack||E),p.push(l.id)}else this.a.error(`${m(l.version?`${l.id}@${l.version}`:l.id)}
${h}`),p.push(l.id)}))}}catch(t){throw this.a.error((0,u.localize)(7,null,(0,N.$9)(t))),t}if(p.length)throw new Error((0,u.localize)(8,null,p.join(", ")))}async g(d,f,P,$){const p=await this.b.getManifest(d);if(!p)throw new Error("Invalid vsix");if(await this.l(p,P,f.profileLocation,$))try{return await this.b.install(d,f),this.a.info((0,u.localize)(9,null,(0,A.$7f)(d))),p}catch(a){if((0,N.$2)(a))return this.a.info((0,u.localize)(10,null,(0,A.$7f)(d))),null;throw a}return null}async h(d){const f=new Map,P=d.some(t=>t.installOptions.installPreReleaseVersion),$=await this.b.getTargetPlatform(),p=[];for(const t of d)c.$En.test(t.id)&&p.push({...t,preRelease:P});if(p.length){const t=await this.d.getExtensions(p,{targetPlatform:$},M.CancellationToken.None);for(const a of t)f.set(a.identifier.id.toLowerCase(),a)}return f}async j({id:d,version:f,installOptions:P},$,p){const t=await this.d.getManifest($,M.CancellationToken.None);if(t&&!this.k(t))return null;const a=p.find(i=>(0,w.$fo)(i.identifier,$.identifier));if(a){if($.version===a.manifest.version)return this.a.info((0,u.localize)(11,null,f?`${d}@${f}`:d)),null;this.a.info((0,u.localize)(12,null,d,$.version))}try{P.isBuiltin?this.a.info(f?(0,u.localize)(13,null,d,f):(0,u.localize)(14,null,d)):this.a.info(f?(0,u.localize)(15,null,d,f):(0,u.localize)(16,null,d));const i=await this.b.installFromGallery($,{...P,installGivenVersion:!!f});return this.a.info((0,u.localize)(17,null,d,i.manifest.version)),t}catch(i){if((0,N.$2)(i))return this.a.info((0,u.localize)(18,null,d)),null;throw i}}k(d){return!0}async l(d,f,P,$){if(!f){const p={id:(0,w.$ko)(d.publisher,d.name)},t=$.find(a=>(0,w.$fo)(p,a.identifier)&&(0,L.gt)(a.manifest.version,d.version));if(t)return this.a.info((0,u.localize)(19,null,t.identifier.id,t.manifest.version,d.version)),!1}return this.k(d)}async uninstallExtensions(d,f,P){const $=async t=>{if(t instanceof b.URI){const a=await this.b.getManifest(t);return S(a)}return t},p=[];for(const t of d){const a=await $(t),n=(await this.b.getInstalled(void 0,P)).filter(s=>(0,w.$fo)(s.identifier,{id:a}));if(!n.length)throw new Error(`${this.m(a)}
${h}`);if(n.some(s=>s.type===0)){this.a.info((0,u.localize)(20,null,a));return}if(!f&&n.some(s=>s.isBuiltin)){this.a.info((0,u.localize)(21,null,a));return}this.a.info((0,u.localize)(22,null,a));for(const s of n)await this.b.uninstall(s,{profileLocation:P}),p.push(s);this.f?this.a.info((0,u.localize)(23,null,a,this.f)):this.a.info((0,u.localize)(24,null,a))}}async locateExtension(d){const f=await this.b.getInstalled();d.forEach(P=>{f.forEach($=>{if($.identifier.id===P&&$.location.scheme===D.Schemas.file){this.a.info($.location.fsPath);return}})})}m(d){return this.f?(0,u.localize)(25,null,d,this.f):(0,u.localize)(26,null,d)}};e.$Xo=y,e.$Xo=y=pe([se(1,c.$Rn),se(2,c.$Pn)],y)}),define(ne[141],re([0,1,4,2,35,27,37]),function(G,e,M,N,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;class b extends N.$lb{constructor(c,w,O,m,h,S,y){super(),this.f=c,this.g=w,this.h=O,this.i=m,this.j=h,this.k=S,this.l=y,this.a=this.B(new M.$8c),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$tb),this.m().then(null,g=>y.error(g))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles),this.n(),await this.z()}n(){this.B(this.h.onDidChangeProfiles(c=>this.p(c.added))),this.B(this.i.onAddExtensions(c=>this.r(c))),this.B(this.i.onDidAddExtensions(c=>this.s(c))),this.B(this.i.onRemoveExtensions(c=>this.t(c))),this.B(this.i.onDidRemoveExtensions(c=>this.u(c))),this.B(this.k.onDidFilesChange(c=>this.v(c)))}async p(c){try{c.length&&await Promise.all(c.map(w=>(this.c.set(w.id,(0,N.$ib)(this.k.watch(this.j.extUri.dirname(w.extensionsResource)),this.k.watch(w.extensionsResource))),this.y(w.extensionsResource))))}catch(w){throw this.l.error(w),w}}async r(c){for(const w of c.extensions)this.C(this.F(w.identifier,w.version),c.profileLocation)}async s(c){for(const w of c.extensions){const O=this.F(w.identifier,w.version);c.error?this.D(O,c.profileLocation):this.C(O,c.profileLocation)}}async t(c){for(const w of c.extensions)this.D(this.F(w.identifier,w.version),c.profileLocation)}async u(c){const w=[],O=[];for(const m of c.extensions){const h=this.F(m.identifier,m.version);c.error?this.C(h,c.profileLocation):(this.D(h,c.profileLocation),this.b.has(h)||(this.l.debug("Extension is removed from all profiles",m.identifier.id,m.version),O.push(this.f.scanInstalledExtensionAtLocation(m.location).then(S=>{S?w.push(S):this.l.info("Extension not found at the location",m.location.toString())},S=>this.l.error(S)))))}try{await Promise.all(O),w.length&&await this.z(w)}catch(m){this.l.error(m)}}v(c){for(const w of this.h.profiles)c.contains(w.extensionsResource,0,1)&&this.w(w.extensionsResource)}async w(c){const w=[],O=[],m=await this.i.scanProfileExtensions(c),h=new Set,S=new Set;for(const[y,g]of this.b)g.has(c)&&S.add(y);for(const y of m){const g=this.F(y.identifier,y.version);h.add(g),S.has(g)||(w.push(y.identifier),this.C(g,c))}for(const y of S)if(!h.has(y)){const g=this.G(y);g&&(O.push(g.identifier),this.D(y,c))}(w.length||O.length)&&this.a.fire({added:w.length?{extensions:w,profileLocation:c}:void 0,removed:O.length?{extensions:O,profileLocation:c}:void 0})}async y(c){const w=await this.i.scanProfileExtensions(c);for(const O of w)this.C(this.F(O.identifier,O.version),c)}async z(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(O=>!this.b.has(this.F(O.identifier,O.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}C(c,w){let O=this.b.get(c);O||this.b.set(c,O=new D.$oi(m=>this.j.extUri.getComparisonKey(m))),O.add(w)}D(c,w){const O=this.b.get(c);O&&O.delete(w),O?.size||this.b.delete(c)}F(c,w){return`${L.$Hl.toKey(c.id)}@${w}`}G(c){const[w,O]=(0,A.$ho)(c);return O?{identifier:{id:w},version:O}:void 0}}e.$mp=b}),define(ne[142],re([0,1,113,39]),function(G,e,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=void 0;async function D(A,L,b,u,c,w,O){const m={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${L.nameShort})`};if((0,N.$0n)(L,b)&&(0,N.$_n)(u)===3){const h=await(0,M.$Qo)(b,c,w);m["X-Market-User-Id"]=h,m["VSCode-SessionId"]=O.machineId||h}return m}e.$Ro=D}),define(ne[143],re([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(G,e,M,N,D,A,L,b,u,c,w,O,m,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;let y=class extends h.$yq{constructor(P,$,p,t){super(p),this.h=P,this.i=t,this.g=this.B(new g($,t)),this.h.registerParticipant({postInstall:async a=>this.j(a),postUninstall:async a=>this.k(a)})}async getBuiltInExtensionTranslationsUri(P,$){const t=(await this.g.getLanguagePacks())[$];if(!t){this.i.warn(`No language pack found for ${$}`);return}const a=t.translations[P];return a?S.URI.file(a):void 0}async getInstalledLanguages(){const P=await this.g.getLanguagePacks(),$=Object.keys(P).map(p=>{const t=P[p];return{...this.f(p,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return $.push(this.f("en","English")),$.sort((p,t)=>p.label.localeCompare(t.label)),$}async j(P){P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",P.identifier.id),await this.update())}async k(P){const $=await this.g.getLanguagePacks();Object.keys($).some(p=>$[p]&&$[p].extensions.some(t=>(0,O.$fo)(t.extensionIdentifier,P.identifier)))&&(this.i.info("Removing language packs from the extension",P.identifier.id),await this.update())}async update(){const[P,$]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),p=await this.g.update($);return!(0,N.$bf)(Object.keys(P),Object.keys(p))}};e.$zq=y,e.$zq=y=pe([se(0,w.$Rn),se(1,c.$xh),se(2,w.$Pn),se(3,m.$Ri)],y);let g=class extends A.$lb{constructor(P,$){super(),this.i=$,this.c={},this.f=(0,b.$ac)(P.userDataPath,"languagepacks.json"),this.g=new D.$Cg}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(P){return this.m($=>{Object.keys($).forEach(p=>delete $[p]),this.j($,...P)}).then(()=>this.c)}j(P,...$){for(const p of $)p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&this.k(P,p);Object.keys(P).forEach(p=>this.l(P[p]))}k(P,$){const p=$.identifier,t=$.manifest.contributes&&$.manifest.contributes.localizations?$.manifest.contributes.localizations:[];for(const a of t)if($.location.scheme===L.Schemas.file&&d(a)){let i=P[a.languageId];i||(i={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},P[a.languageId]=i);const n=i.extensions.filter(s=>(0,O.$fo)(s.extensionIdentifier,p))[0];n?n.version=$.manifest.version:i.extensions.push({extensionIdentifier:p,version:$.manifest.version});for(const s of a.translations)i.translations[s.id]=(0,b.$ac)($.location.fsPath,s.path)}}l(P){if(P){const $=(0,M.createHash)("md5");for(const p of P.extensions)$.update(p.extensionIdentifier.uuid||p.extensionIdentifier.id).update(p.version);P.hash=$.digest("hex")}}m(P=()=>null){return this.g.queue(()=>{let $=null;return u.Promises.readFile(this.f,"utf8").then(void 0,p=>p.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(p)).then(p=>{try{return JSON.parse(p)}catch{return{}}}).then(p=>($=P(p),p)).then(p=>{for(const a of Object.keys(p))p[a]||delete p[a];this.c=p,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),u.Promises.writeFile(this.f,t)}).then(()=>$,p=>this.i.error(p))})}};g=pe([se(0,c.$xh),se(1,m.$Ri)],g);function d(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const P of f.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ne[144],re([0,1,82,9,30,39]),function(G,e,M,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0",b="https://mobile.events.data.microsoft.com/ping";async function u(w,O,m){const h=await(0,M.$WC)("@microsoft/1ds-core-js","dist/ms.core.js"),S=await(0,M.$WC)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new h.AppInsightsCore,g=new S.PostChannel,d={instrumentationKey:w,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(m){d.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:m};d.extensionConfig[g.identifier]=f}return y.initialize(d,[]),y}class c{constructor(O,m,h,S,y){this.e=O,this.f=m,this.g=h,this.h=y,this.c=L,this.d=b,this.g||(this.g={}),typeof S=="function"?this.a=S():this.a=S,this.b=null}i(O){if(this.a){if(typeof this.a!="string"){O(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(m=>{O(m)},m=>{(0,N.$Y)(m),console.error(m)})}}log(O,m){if(!this.a)return;m=(0,D.$Km)(m,this.g),m=(0,A.$ao)(m);const h=this.f+"/"+O;try{this.i(S=>{S.pluginVersionString=m?.properties.version??"Unknown",S.track({name:h,baseData:{name:h,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(O=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,O(void 0)})})}):Promise.resolve(void 0)}}e.$NM=c}),define(ne[145],re([0,1,2,30,13,28,105,25,44,146,31,36,26,39]),function(G,e,M,N,D,A,L,b,u,c,w,O,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=void 0;let S=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,f,P){this.k=f,this.l=P,this.d={},this.i=new M.$kb,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=3,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const $ of this.f)this.j.push(new RegExp((0,A.$od)($),"gi")),$.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$od)($.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration($=>{($.affectsConfiguration(m.$3k)||$.affectsConfiguration(m.$5k)||$.affectsConfiguration(m.$4k))&&this.m()}))}setExperimentProperty(d,f){this.d[d]=f}m(){let d=(0,h.$_n)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const P=f.usage?3:f.error?2:0;d=Math.min(d,P)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,f,P){this.g<f||(P=(0,N.$Km)(P,this.d),P=(0,h.$eo)(P,this.j),P=(0,N.$Km)(P,this.c),this.b.forEach($=>$.log(d,P)))}publicLog(d,f){this.n(d,3,f)}publicLog2(d,f){this.publicLog(d,f)}publicLogError(d,f){this.h&&this.n(d,2,f)}publicLogError2(d,f){this.publicLogError(d,f)}};e.$Fq=S,e.$Fq=S=pe([se(1,b.$Vh),se(2,w.$0i)],S);function y(){const g=(0,L.localize)(0,null,c.default.nameLong),d=c.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=D.$o?"":(0,L.localize)(3,null),P=(0,L.localize)(4,null),$=(0,L.localize)(5,null),p=(0,L.localize)(6,null),t=(0,L.localize)(7,null),a=`
|       | ${P} | ${$} | ${p} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,L.localize)(8,null);return`
${g} ${d} ${f}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}O.$Tm.as(u.$Ym.Configuration).registerConfiguration({id:m.$2k,order:1,type:"object",title:(0,L.localize)(9,null),properties:{[m.$3k]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),O.$Tm.as(u.$Ym.Configuration).registerConfiguration({id:m.$2k,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[m.$5k]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,L.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,L.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${m.$3k}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],re([0,1,14,20,144]),function(G,e,M,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=void 0;async function A(u,c){const w=await c.request(u,N.CancellationToken.None),O=(await(0,M.$Vb)(w.stream)).toString(),m=w.res.statusCode??200;return{headers:w.res.headers,statusCode:m,responseData:O}}function L(u,c){const w={method:u.type,headers:u.headers},O=c.request(u.url??"",w,m=>{m.on("data",function(h){return{headers:m.headers,statusCode:m.statusCode??200,responseData:h.toString()}}),m.on("error",function(h){throw h})});O.write(u.data),O.end()}class b extends D.$NM{constructor(c,w,O,m,h){let S;c||(S=G("https"));const y={sendPOST:(g,d)=>{const f=typeof g.data=="string"?g.data:new TextDecoder().decode(g.data),P={type:"POST",headers:{...g.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(g.data).toString()},url:g.urlString,data:f};try{if(c)A(P,c).then(({statusCode:$,headers:p,responseData:t})=>{d($,p,t)});else{if(!S)throw new Error("https module is undefined");L(P,S)}}catch{d(0,{})}}};super(w,O,m,h,y)}}e.$OM=b}),define(ne[148],re([0,1,16,24]),function(G,e,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x5b=void 0;async function D(A,L){const b=Object.create(null),u=(w,O)=>{const m=JSON.parse(w);b[O]=m};if(L){const w=[],O=await N.Promises.readdir(L);for(const h of O)try{(await N.Promises.stat((0,M.$ac)(L,h))).isDirectory()&&w.push(h)}catch{}const m=[];for(const h of w)(await N.Promises.readdir((0,M.$ac)(L,h))).filter(y=>y==="telemetry.json").length===1&&m.push(h);for(const h of m){const S=(await N.Promises.readFile((0,M.$ac)(L,h,"telemetry.json"))).toString();u(S,h)}}let c=(await N.Promises.readFile((0,M.$ac)(A,"telemetry-core.json"))).toString();return u(c,"vscode-core"),c=(await N.Promises.readFile((0,M.$ac)(A,"telemetry-extensions.json"))).toString(),u(c,"vscode-extensions"),JSON.stringify(b,null,4)}e.$x5b=D}),define(ne[149],re([0,1,13,75,26]),function(G,e,M,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T4b=void 0;async function A(L,b){let u=L.getItem(D.$1k);return(typeof u!="string"||M.$j&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,N.$um)(b.error.bind(b))),u}e.$T4b=A}),define(ne[22],re([0,1,10]),function(G,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=void 0,e.$pk=(0,M.$ph)("IUriIdentityService")}),define(ne[150],re([0,1,22,114,12,17,73,4,2]),function(G,e,M,N,D,A,L,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class c{static{this._clock=0}constructor(m){this.uri=m,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let w=class{constructor(m){this.g=m,this.c=new u.$kb,this.f=2**16;const h=new Map,S=y=>{let g=h.get(y.scheme);return g===void 0&&(g=m.hasProvider(y)&&!this.g.hasCapability(y,1024),h.set(y.scheme,g)),g};this.c.add(b.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(y=>{h.delete(y.scheme)})),this.extUri=new A.$Yf(S),this.d=new L.$br((y,g)=>this.extUri.compare(y,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,A.$$f)(m));const h=this.d.get(m);return h?h.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new c(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((S,y)=>S[1].time<y[1].time?1:S[1].time>y[1].time?-1:0);c._clock=0,this.d.clear();const h=this.f*.5;for(let S=0;S<h;S++)this.d.set(m[S][0],m[S][1].touch())}};e.$cr=w,e.$cr=w=pe([se(0,D.$Sj)],w),(0,N.$_q)(M.$pk,w,1)}),define(ne[151],re([0,1,4,2,12,41,46,14]),function(G,e,M,N,D,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b5b=void 0;class u extends N.$lb{get capabilities(){return this.f.capabilities&-5}constructor(w,O,m,h){super(),this.c=w,this.f=O,this.g=m,this.h=h,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new M.$8c),this.onDidChangeFile=this.a.event,this.b=L.$vh.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(S=>this.i(S)))}watch(w,O){this.b.set(w,w);const m=this.f.watch(this.j(w),O);return(0,N.$jb)(()=>{this.b.delete(w),m.dispose()})}stat(w){return this.f.stat(this.j(w))}mkdir(w){return this.f.mkdir(this.j(w))}rename(w,O,m){return this.f.rename(this.j(w),this.j(O),m)}readFile(w){return this.f.readFile(this.j(w),{atomic:!0})}readFileStream(w,O,m){const h=(0,A.$xb)(S=>b.$Jb.concat(S.map(y=>b.$Jb.wrap(y))).buffer);return(async()=>{try{const S=await this.readFile(w);h.end(S)}catch(S){h.error(S),h.end()}})(),h}readdir(w){return this.f.readdir(this.j(w))}writeFile(w,O,m){return this.f.writeFile(this.j(w),O,m)}delete(w,O){return this.f.delete(this.j(w),O)}copy(w,O,m){if((0,D.$Vj)(this.f))return this.f.copy(this.j(w),this.j(O),m);throw new Error("copy not supported")}i(w){const O=[];for(const m of w){if(m.resource.scheme!==this.c)continue;const h=this.k(m.resource);this.b.findSubstr(h)&&O.push({resource:h,type:m.type})}O.length&&(this.h.debug("User data changed"),this.a.fire(O))}j(w){return w.with({scheme:this.c})}k(w){return w.with({scheme:this.g})}}e.$b5b=u}),define(ne[152],re([0,1,107,16,46,17,11,10,15]),function(G,e,M,N,D,A,L,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.WorkbenchState=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$yh=(0,b.$ph)("contextService");function c(n){const s=n;return typeof s?.id=="string"&&L.URI.isUri(s.uri)}e.$zh=c;function w(n){return typeof n?.id=="string"&&!c(n)&&!m(n)}e.$Ah=w,e.$Bh={id:"ext-dev"},e.$Ch={id:"empty-window"};function O(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,N.$ec)(n)}:s?e.$Bh:e.$Ch;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$Dh=O;function m(n){const s=n;return typeof s?.id=="string"&&L.URI.isUri(s.configPath)}e.$Eh=m;function h(n){const s=n;if(s?.uri)return{id:s.id,uri:L.URI.revive(s.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:L.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.$Fh=h;var S;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function y(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$Gh=y;function g(n){const s=n;return!!(s&&typeof s=="object"&&L.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$Hh=g;class d{constructor(s,o,l,I,E){this.h=s,this.j=l,this.k=I,this.l=E,this.c=D.$vh.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=D.$vh.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ih=d;class f{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.$0f)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Jh=f;function P(n){return new f({uri:n,index:0,name:(0,A.$6f)(n)},{uri:n.toString()})}e.$Kh=P,e.$Lh="code-workspace",e.$Mh=`.${e.$Lh}`,e.$Nh=[{name:(0,M.localize)(0,null),extensions:[e.$Lh]}],e.$Oh="workspace.json";function $(n,s){return A.$1f.isEqualOrParent(n,s.untitledWorkspacesHome)}e.$Ph=$;function p(n){let s;return L.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===u.Schemas.tmp}e.$Qh=p,e.$Rh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$Rh}e.$Sh=t;function a(n,s){return!$(n,s)&&!p(n)}e.$Th=a;function i(n){return(typeof n=="string"?(0,N.$fc)(n):(0,A.$8f)(n))===e.$Mh}e.$Uh=i}),define(ne[23],re([0,1,42,4,2,17,11,106,18,12,10,6,152,35,22,8,29,28,3]),function(G,e,M,N,D,A,L,b,u,c,w,O,m,h,S,y,g,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.ProfileResourceType=void 0;var P;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function $(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&L.URI.isUri(s.location)&&L.URI.isUri(s.globalStorageHome)&&L.URI.isUri(s.settingsResource)&&L.URI.isUri(s.keybindingsResource)&&L.URI.isUri(s.tasksResource)&&L.URI.isUri(s.snippetsHome)&&L.URI.isUri(s.extensionsResource))}e.$qk=$,e.$rk=(0,w.$ph)("IUserDataProfilesService");function p(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:L.URI.revive(n.location).with({scheme:s}),globalStorageHome:L.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:L.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:L.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:L.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:L.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:L.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:L.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$sk=p;function t(n,s,o,l,I,E){return{id:n,name:s,location:o,isDefault:!1,shortName:I?.shortName,globalStorageHome:E&&I?.useDefaultFlags?.globalState?E.globalStorageHome:(0,A.$0f)(o,"globalStorage"),settingsResource:E&&I?.useDefaultFlags?.settings?E.settingsResource:(0,A.$0f)(o,"settings.json"),keybindingsResource:E&&I?.useDefaultFlags?.keybindings?E.keybindingsResource:(0,A.$0f)(o,"keybindings.json"),tasksResource:E&&I?.useDefaultFlags?.tasks?E.tasksResource:(0,A.$0f)(o,"tasks.json"),snippetsHome:E&&I?.useDefaultFlags?.snippets?E.snippetsHome:(0,A.$0f)(o,"snippets"),extensionsResource:E&&I?.useDefaultFlags?.extensions?E.extensionsResource:(0,A.$0f)(o,"extensions.json"),cacheHome:(0,A.$0f)(l,n),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$tk=t;let a=class extends D.$lb{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(s,o,l,I){super(),this.n=s,this.r=o,this.s=l,this.t=I,this.f=!0,this.h=this.B(new N.$8c),this.onDidChangeProfiles=this.h.event,this.i=this.B(new N.$8c),this.onWillCreateProfile=this.i.event,this.j=this.B(new N.$8c),this.onWillRemoveProfile=this.j.event,this.k=this.B(new N.$8c),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new h.$ni,emptyWindows:new Map},this.profilesHome=(0,A.$0f)(this.n.userRoamingDataHome,"profiles"),this.g=(0,A.$0f)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(s){this.f!==s&&(this.u=void 0,this.f=s)}isEnabled(){return this.f}get v(){if(!this.u){const s=this.w(),o=[s];if(this.f)try{for(const E of this.J()){if(!E.name||!(0,f.$je)(E.name)||!E.location){this.t.warn("Skipping the invalid stored profile",E.location||E.name);continue}o.push(t((0,A.$7f)(E.location),E.name,E.location,this.g,{shortName:E.shortName,useDefaultFlags:E.useDefaultFlags},s))}}catch(E){this.t.error(E)}const l=new h.$ni,I=new Map;if(o.length)try{const E=this.M();if(E.workspaces)for(const[k,j]of Object.entries(E.workspaces)){const W=L.URI.parse(k),ee=o.find(x=>x.id===j);ee&&l.set(W,ee)}if(E.emptyWindows)for(const[k,j]of Object.entries(E.emptyWindows)){const W=o.find(ee=>ee.id===j);W&&I.set(k,W)}}catch(E){this.t.error(E)}this.u={profiles:o,workspaces:l,emptyWindows:I}}return this.u}w(){const s=t("__default__profile__",(0,b.localize)(0,null),this.n.userRoamingDataHome,this.g);return{...s,extensionsResource:this.O()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",l=new RegExp(`${(0,d.$od)(o)}\\s(\\d+)`);let I=0;for(const k of this.profiles){const j=l.exec(k.name),W=j?parseInt(j[1]):0;I=W>I?W:I}const E=`${o} ${I+1}`;return this.createProfile((0,M.$di)((0,g.$6e)()).toString(16),E,{transient:!0},s)}async createNamedProfile(s,o,l){return this.createProfile((0,M.$di)((0,g.$6e)()).toString(16),s,o,l)}async createProfile(s,o,l,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=await this.y(s,o,l);return I&&await this.setProfileForWorkspace(I,E),E}async y(s,o,l){if(!(0,f.$je)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.l.get(o);return I||(I=(async()=>{try{const E=this.profiles.find(W=>W.name===o||W.id===s);if(E)return E;const k=t(s,o,(0,A.$0f)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.r.createFolder(k.location);const j=[];return this.i.fire({profile:k,join(W){j.push(W)}}),await y.Promises.settled(j),this.D([k],[],[]),k}finally{this.l.delete(o)}})(),this.l.set(o,I)),I}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(I=>I.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=t(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.D([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(I=>I.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.j.fire({profile:o,join(I){l.push(I)}});try{await Promise.allSettled(l)}catch(I){this.t.error(I)}for(const I of[...this.v.emptyWindows.keys()])o.id===this.v.emptyWindows.get(I)?.id&&this.v.emptyWindows.delete(I);for(const I of[...this.v.workspaces.keys()])o.id===this.v.workspaces.get(I)?.id&&this.v.workspaces.delete(I);this.H(),this.D([],[o],[]);try{await this.r.del(o.cacheHome,{recursive:!0})}catch(I){(0,c.$9j)(I)!==1&&this.t.error(I)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(I=>I.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.G(s,l)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(s,void 0,o)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const s=await this.r.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.s.extUri.isEqual(l.location,o.resource))).map(o=>this.r.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.m.profiles.filter(o=>!this.C(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.z(s);return L.URI.isUri(o)?this.m.workspaces.get(o)??this.v.workspaces.get(o):this.m.emptyWindows.get(o)??this.v.emptyWindows.get(o)}z(s){return(0,m.$zh)(s)?s.uri:(0,m.$Eh)(s)?s.configPath:s.id}C(s){return!!([...this.m.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,s.location))||[...this.m.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,s.location))||[...this.v.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,s.location))||[...this.v.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,s.location)))}D(s,o,l){const I=[...this.profiles,...s],E=[];this.m.profiles=[];for(let k of I)k.isDefault||o.some(j=>k.id===j.id)||(k=l.find(j=>k.id===j.id)??k,k.isTransient?this.m.profiles.push(k):E.push({location:k.location,name:k.name,shortName:k.shortName,useDefaultFlags:k.useDefaultFlags}));this.L(E),this.u=void 0,this.F(s,o,l)}F(s,o,l){this.h.fire({added:s,removed:o,updated:l,all:this.profiles})}G(s,o,l){l=o?.isTransient?!0:l,l||this.G(s,void 0,!0);const I=this.z(s),E=l?this.m:this.v;L.URI.isUri(I)?(E.workspaces.delete(I),o&&E.workspaces.set(I,o)):(E.emptyWindows.delete(I),o&&E.emptyWindows.set(I,o)),l||this.H()}H(){const s={};for(const[l,I]of this.v.workspaces.entries())s[l.toString()]=I.id;const o={};for(const[l,I]of this.v.emptyWindows.entries())o[l.toString()]=I.id;this.N({workspaces:s,emptyWindows:o}),this.u=void 0}I(s){const o={},l=this.w();if(s.workspaces)for(const[E,k]of Object.entries(s.workspaces)){const j=L.URI.parse(k);o[E]=this.s.extUri.isEqual(j,l.location)?l.id:this.s.extUri.basename(j)}const I={};if(s.emptyWindows)for(const[E,k]of Object.entries(s.emptyWindows)){const j=L.URI.parse(k);I[E]=this.s.extUri.isEqual(j,l.location)?l.id:this.s.extUri.basename(j)}return{workspaces:o,emptyWindows:I}}J(){return[]}L(s){throw new Error("not implemented")}M(){return{}}N(s){throw new Error("not implemented")}O(){}};e.$uk=a,e.$uk=a=pe([se(0,u.$wh),se(1,c.$Sj),se(2,S.$pk),se(3,O.$Ri)],a);class i extends a{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(s){this.a=s}M(){return this.R}N(s){this.R=s}}e.$vk=i}),define(ne[153],re([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,31,26,22,23]),function(G,e,M,N,D,A,L,b,u,c,w,O,m,h,S,y,g,d,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=void 0;let $=class extends b.$lb{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}get onDidUpdateExtensionMetadata(){return this.s.event}constructor(s,o,l,I,E,k){super(),this.u=s,this.v=o,this.w=l,this.y=I,this.z=E,this.C=k,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new L.$8c),this.m=this.B(new L.$8c),this.n=this.B(new L.$8c),this.p=this.B(new L.$8c),this.s=this.B(new L.$8c),this.t=[],this.B((0,b.$jb)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.k.forEach(j=>j.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,m.$Mn)(l,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const I=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:E})=>(0,h.$fo)(E,s.identifier));if(I?.local)return I?.local;throw I?.error?I.error:t(new Error(`Unknown error while installing extension ${s.identifier.id}`))}catch(l){throw t(l)}}async installGalleryExtensions(s){if(!this.u.isEnabled())throw new m.$Qn(O.localize(0,null),m.ExtensionManagementErrorCode.Internal);const o=[],l=[];await Promise.allSettled(s.map(async({extension:I,options:E})=>{try{const k=await this.J(I,!!E?.installGivenVersion,!!E?.installPreReleaseVersion);l.push({...k,options:E})}catch(k){o.push({identifier:I.identifier,operation:2,source:I,error:k})}})),l.length&&o.push(...await this.D(l));for(const I of o)I.error&&(this.y.error("Failed to install extension.",I.identifier.id),this.y.error(I.error),I.source&&!w.URI.isUri(I.source)&&a(this.v,"extensionGallery:install",{extensionData:(0,h.$no)(I.source),error:I.error}));return o}async uninstall(s,o={}){return this.y.trace("ExtensionManagementService#uninstall",s.identifier.id),this.M(s,o)}async toggleAppliationScope(s,o){if((0,S.$Kl)(s.manifest))return s;if(s.isApplicationScoped){let l=await this.updateMetadata(s,{isApplicationScoped:!1},this.C.defaultProfile.extensionsResource);this.w.extUri.isEqual(o,this.C.defaultProfile.extensionsResource)||(l=await this.X(s,this.C.defaultProfile.extensionsResource,o));for(const I of this.C.profiles){const E=(await this.getInstalled(1,I.extensionsResource)).find(k=>(0,h.$fo)(k.identifier,s.identifier));E?this.s.fire(E):this.p.fire({identifier:s.identifier,profileLocation:I.extensionsResource})}return l}else{const l=this.w.extUri.isEqual(o,this.C.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.C.defaultProfile.extensionsResource):await this.X(s,o,this.C.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.m.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.C.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.R(),this.h=s),this.g}registerParticipant(s){this.t.push(s)}async D(s){const o=[];return await Promise.allSettled(s.map(async l=>{try{const I=await this.F(l);o.push(...I)}catch(I){o.push({identifier:{id:(0,h.$ko)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:I})}})),this.m.fire(o),o}async F({manifest:s,extension:o,options:l}){const I=l.isApplicationScoped||l.isBuiltin||(0,S.$Kl)(s),E={...l,installOnlyNewlyAddedFromExtensionPack:w.URI.isUri(o)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:I,profileLocation:I?this.C.defaultProfile.extensionsResource:l.profileLocation??this.S()},k=te=>`${h.$go.create(te).toString()}${E.profileLocation?`-${E.profileLocation.toString()}`:""}`;if(!w.URI.isUri(o)){const te=this.j.get(k(o));if(te)return this.y.info("Extensions is already requested to install",o.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const j=[],W=[],ee=[],x=this.U(s,o,E);w.URI.isUri(o)||this.j.set(k(o),{task:x,waitingTasks:[]}),this.l.fire({identifier:x.identifier,source:o,profileLocation:E.profileLocation}),this.y.info("Installing extension:",x.identifier.id),j.push({task:x,manifest:s});let le=!1;try{if(E.donotIncludePackAndDependencies)this.y.info("Installing the extension without checking dependencies and pack",x.identifier.id);else try{const ae=await this.I(x.identifier,s,!!E.installOnlyNewlyAddedFromExtensionPack,!!E.installPreReleaseVersion,E.profileLocation),ce=await this.getInstalled(void 0,E.profileLocation);for(const{gallery:ie,manifest:V}of(0,M.$rf)(ae,({gallery:H})=>H.identifier.id)){le=le||!!V.extensionDependencies?.some(U=>(0,h.$fo)({id:U},x.identifier));const H=k(ie),C=this.j.get(H);if(C){if(this.G(x,C.task)){const U=C.task.identifier;this.y.info("Waiting for already requested installing extension",U.id,x.identifier.id),C.waitingTasks.push(x),W.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,q=>q.some(X=>(0,h.$fo)(X.identifier,U)))).then(q=>{if(this.y.info("Finished waiting for already requested installing extension",U.id,x.identifier.id),!q.find(Y=>(0,h.$fo)(Y.identifier,U))?.local)throw new Error(`Extension ${U.id} is not installed`)}))}}else if(!ce.some(({identifier:U})=>(0,h.$fo)(U,ie.identifier))){const U=this.U(V,ie,{...E,donotIncludePackAndDependencies:!0});this.j.set(H,{task:U,waitingTasks:[x]}),this.l.fire({identifier:U.identifier,source:ie,profileLocation:E.profileLocation}),this.y.info("Installing extension:",U.identifier.id,x.identifier.id),j.push({task:U,manifest:V})}}}catch(ae){if(w.URI.isUri(x.source))(0,M.$qf)(s.extensionDependencies)&&this.y.warn("Cannot install dependencies of extension:",x.identifier.id,ae.message),(0,M.$qf)(s.extensionPack)&&this.y.warn("Cannot install packed extensions of extension:",x.identifier.id,ae.message);else throw this.y.error("Error while preparing to install dependencies and extension packs of the extension:",x.identifier.id),ae}const te=j.reduce((ae,{task:ce,manifest:ie})=>(ae.set(ce.identifier.id.toLowerCase(),{task:ce,manifest:ie}),ae),new Map);for(;te.size;){let ae;const ce=[...te.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(V=>te.has(V.toLowerCase())));ce.length?ae=te.size===1?ce:ce.filter(({task:ie})=>!(ie===x&&!le)):(this.y.info("Found extensions with circular dependencies",ce.map(({task:ie})=>ie.identifier.id)),ae=[...te.values()]),await this.H(ae.map(async({task:ie})=>{const V=new Date().getTime();try{const H=await ie.run();if(await this.H(this.t.map(C=>C.postInstall(H,ie.source,E,D.CancellationToken.None))),!w.URI.isUri(ie.source)){const C=ie.operation===3,U=C?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(a(this.v,C?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$no)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-V,durationSinceUpdate:U}),u.$o&&ie.operation!==3)try{await this.u.reportStatistic(H.manifest.publisher,H.manifest.name,H.manifest.version,"install")}catch{}}ee.push({local:H,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:E.context,profileLocation:ie.profileLocation,applicationScoped:H.isApplicationScoped})}catch(H){throw w.URI.isUri(ie.source)||a(this.v,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$no)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-V,error:H}),this.y.error("Error while installing the extension:",ie.identifier.id),H}finally{te.delete(ie.identifier.id.toLowerCase())}}))}return W.length&&await this.H(W),ee.forEach(({identifier:ae})=>this.y.info("Extension installed successfully:",ae.id)),ee}catch(te){if(j.forEach(({task:ae})=>ae.cancel()),ee.length)try{const ae=await Promise.allSettled(ee.map(({local:ce})=>this.W(ce,{versionOnly:!0,profileLocation:E.profileLocation}).run()));for(let ce=0;ce<ae.length;ce++){const ie=ae[ce],{identifier:V}=ee[ce];ie.status==="fulfilled"?this.y.info("Rollback: Uninstalled extension",V.id):this.y.warn("Rollback: Error while uninstalling extension",V.id,(0,A.$9)(ie.reason))}}catch(ae){this.y.warn("Error while rolling back extensions",(0,A.$9)(ae),ee.map(({identifier:ce})=>ce.id))}return j.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:E.context,profileLocation:E.profileLocation,error:te}))}finally{for(const{task:te}of j)te.source&&!w.URI.isUri(te.source)&&this.j.delete(k(te.source))}}G(s,o){for(const[,{task:l,waitingTasks:I}]of this.j.entries())if(l===s&&(I.includes(o)||I.some(E=>this.G(E,o)))||l===o&&I[0]&&!this.G(s,I[0]))return!1;return!0}async H(s){const o=[],l=[],I=await Promise.allSettled(s);for(const E of I)E.status==="fulfilled"?o.push(E.value):l.push(E.reason);if(l.length)throw p(l);return o}async I(s,o,l,I,E){if(!this.u.isEnabled())return[];const k=await this.getInstalled(void 0,E),j=[],W=[],ee=async(x,le)=>{j.push(x);const te=le.extensionDependencies||[],ae=[...te];if(le.extensionPack){const ce=l?k.find(ie=>(0,h.$fo)(ie.identifier,x)):void 0;for(const ie of le.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(V=>(0,h.$fo)({id:V},{id:ie}))||ae.every(V=>!(0,h.$fo)({id:V},{id:ie}))&&ae.push(ie)}if(ae.length){const ce=ae.filter(ie=>j.every(V=>!(0,h.$fo)(V,{id:ie})));if(ce.length){const ie=await this.u.getExtensions(ce.map(V=>({id:V,preRelease:I})),D.CancellationToken.None);for(const V of ie){if(j.find(U=>(0,h.$fo)(U,V.identifier)))continue;const H=te.some(U=>(0,h.$fo)({id:U},V.identifier));let C;try{C=await this.J(V,!1,I)}catch(U){if(H)throw U;this.y.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,A.$9)(U));continue}W.push({gallery:C.extension,manifest:C.manifest}),await ee(C.extension.identifier,C.manifest)}}}};return await ee(s,o),W}async J(s,o,l){let I;const E=await this.getExtensionsControlManifest();if(E.malicious.some(W=>(0,h.$fo)(s.identifier,W)))throw new m.$Qn(O.localize(1,null,s.identifier.id),m.ExtensionManagementErrorCode.Malicious);const k=E.deprecated[s.identifier.id.toLowerCase()];if(k?.extension?.autoMigrate){if(this.y.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${k.extension.id}' extension instead.`),I=(await this.u.getExtensions([{id:k.extension.id,preRelease:k.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0],!I)throw new m.$Qn(O.localize(2,null,s.identifier.id,k.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const W=await this.getTargetPlatform();throw new m.$Qn(O.localize(3,null,s.identifier.id,this.z.nameLong,(0,m.$In)(W)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(I=await this.L(s,o,l),!I)throw!l&&s.properties.isPreReleaseVersion&&(await this.u.getExtensions([s.identifier],D.CancellationToken.None))[0]?new m.$Qn(O.localize(4,null,s.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$Qn(O.localize(5,null,s.identifier.id,this.z.nameLong,this.z.version),m.ExtensionManagementErrorCode.Incompatible)}this.y.info("Getting Manifest...",I.identifier.id);const j=await this.u.getManifest(I,D.CancellationToken.None);if(j===null)throw new m.$Qn(`Missing manifest for extension ${I.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(j.version!==I.version)throw new m.$Qn(`Cannot install '${I.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:j}}async L(s,o,l){const I=await this.getTargetPlatform();let E=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(E=(await this.u.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:I,compatible:!0},D.CancellationToken.None))[0]||null),!E&&await this.u.isExtensionCompatible(s,l,I)&&(E=s),E||(o?E=(await this.u.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:I,compatible:!0},D.CancellationToken.None))[0]||null:E=await this.u.getCompatibleExtension(s,l,I)),E}async M(s,o){const l={...o,profileLocation:s.isApplicationScoped?this.C.defaultProfile.extensionsResource:o.profileLocation??this.S()},I=x=>`${x.id.toLowerCase()}${l.versionOnly?`-${s.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,E=this.k.get(I(s.identifier));if(E)return this.y.info("Extensions is already requested to uninstall",s.identifier.id),E.waitUntilTaskIsFinished();const k=x=>{const le=this.W(x,l);return this.k.set(I(le.extension.identifier),le),l.profileLocation?this.y.info("Uninstalling extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,l.profileLocation.toString()):this.y.info("Uninstalling extension:",`${x.identifier.id}@${x.manifest.version}`),this.n.fire({identifier:x.identifier,profileLocation:l.profileLocation,applicationScoped:x.isApplicationScoped}),le},j=(x,le)=>{le?l.profileLocation?this.y.error("Failed to uninstall extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,l.profileLocation.toString(),le.message):this.y.error("Failed to uninstall extension:",`${x.identifier.id}@${x.manifest.version}`,le.message):l.profileLocation?this.y.info("Successfully uninstalled extension from the profile",`${x.identifier.id}@${x.manifest.version}`,l.profileLocation.toString()):this.y.info("Successfully uninstalled extension:",`${x.identifier.id}@${x.manifest.version}`),a(this.v,"extensionGallery:uninstall",{extensionData:(0,h.$mo)(x),error:le}),this.p.fire({identifier:x.identifier,error:le?.code,profileLocation:l.profileLocation,applicationScoped:x.isApplicationScoped})},W=[],ee=[];try{W.push(k(s));const x=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.y.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const le=this.P(s,x);for(const te of le)this.k.has(I(te.identifier))?this.y.info("Extensions is already requested to uninstall",te.identifier.id):W.push(k(te))}l.donotCheckDependents?this.y.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.N(W.map(le=>le.extension),x,s),await this.H(W.map(async le=>{try{if(await le.run(),await this.H(this.t.map(te=>te.postUninstall(le.extension,l,D.CancellationToken.None))),le.extension.identifier.uuid)try{await this.u.reportStatistic(le.extension.manifest.publisher,le.extension.manifest.name,le.extension.manifest.version,"uninstall")}catch{}j(le.extension)}catch(te){const ae=te instanceof m.$Qn?te:new m.$Qn((0,A.$9)(te),m.ExtensionManagementErrorCode.Internal);throw j(le.extension,ae),ae}finally{ee.push(le)}}))}catch(x){const le=x instanceof m.$Qn?x:new m.$Qn((0,A.$9)(x),m.ExtensionManagementErrorCode.Internal);for(const te of W){try{te.cancel()}catch{}ee.includes(te)||j(te.extension,le)}throw le}finally{for(const x of W)this.k.delete(I(x.extension.identifier))||this.y.warn("Uninstallation task is not found in the cache",x.extension.identifier.id)}}N(s,o,l){for(const I of s){const E=this.Q(I,o);if(E.length){const k=E.filter(j=>!s.some(W=>(0,h.$fo)(W.identifier,j.identifier)));if(k.length)throw new Error(this.O(I,k,l))}}}O(s,o,l){return l===s?o.length===1?O.localize(6,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?O.localize(7,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):O.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?O.localize(9,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?O.localize(10,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):O.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}P(s,o,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const I=s.manifest.extensionPack?s.manifest.extensionPack:[];if(I.length){const E=o.filter(j=>!j.isBuiltin&&I.some(W=>(0,h.$fo)({id:W},j.identifier))),k=[];for(const j of E)k.push(...this.P(j,o,l));return[...E,...k]}return[]}Q(s,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(I=>(0,h.$fo)({id:I},s.identifier)))}async R(){try{this.y.trace("ExtensionManagementService.refreshReportedCache");const s=await this.u.getExtensionsControlManifest();return this.y.trace("ExtensionManagementService.refreshControlCache",s),s}catch{return this.y.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$7o=$,e.$7o=$=pe([se(0,m.$Pn),se(1,d.$Vk),se(2,f.$pk),se(3,y.$Ri),se(4,g.$0i),se(5,P.$rk)],$);function p(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$8o=p;function t(n){if(n instanceof m.$Qn)return n;const s=new m.$Qn(n.message,m.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}e.$9o=t;function a(n,s,{extensionData:o,verificationStatus:l,duration:I,error:E,durationSinceUpdate:k}){let j,W;(0,c.$re)(l)&&(l===!0?l="Verified":(l===!1||(j=m.ExtensionManagementErrorCode.Signature,W=l),l="Unverified")),E&&(E instanceof m.$Qn?(j=E.code,E.code===m.ExtensionManagementErrorCode.Signature&&(W=E.message)):j=m.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...o,verificationStatus:l,success:!E,duration:I,errorcode:j,errorcodeDetail:W,durationSinceUpdate:k})}class i{constructor(){this.d=new N.$ug}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$jg)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$jg)(s=>new Promise((o,l)=>{const I=s.onCancellationRequested(()=>{I.dispose(),l(new A.$3)})})),this.d.open()),this.g.cancel()}}e.$0o=i}),define(ne[40],re([0,1,8,14,2,4,35,11,21,27,12,10,6,23,22,3,9,26]),function(G,e,M,N,D,A,L,b,u,c,w,O,m,h,S,y,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=e.$_o=e.$$o=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class P extends Error{constructor(i,n){super(i),this.code=n}}e.$$o=P,e.$_o=(0,O.$ph)("IExtensionsProfileScannerService");let $=class extends D.$lb{constructor(i,n,s,o,l,I){super(),this.i=i,this.j=n,this.k=s,this.l=o,this.m=l,this.n=I,this.b=this.B(new A.$8c),this.onAddExtensions=this.b.event,this.c=this.B(new A.$8c),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$8c),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$8c),this.onDidRemoveExtensions=this.g.event,this.h=new L.$ni}scanProfileExtensions(i,n){return this.p(i,void 0,n)}async addExtensionsToProfile(i,n){const s=[],o=[];try{return await this.p(n,l=>{const I=[];for(const E of l)i.some(([k])=>(0,c.$fo)(k.identifier,E.identifier))?s.push(E):I.push(E);for(const[E,k]of i)if(!I.some(j=>(0,c.$fo)(j.identifier,E.identifier)&&j.version===E.manifest.version)){const j={identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:k};o.push(j),I.push(j)}return o.length&&this.b.fire({extensions:o,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),I}),o.length&&this.c.fire({extensions:o,profileLocation:n}),s.length&&this.g.fire({extensions:s,profileLocation:n}),o}catch(l){throw o.length&&this.c.fire({extensions:o,error:l,profileLocation:n}),s.length&&this.g.fire({extensions:s,error:l,profileLocation:n}),l}}async updateMetadata(i,n){const s=[];return await this.p(n,o=>{const l=[];for(const I of o){const E=i.find(([k])=>(0,c.$fo)(k.identifier,I.identifier)&&k.manifest.version===I.version);E&&(I.metadata={...I.metadata,...E[1]},s.push(I)),l.push(I)}return l}),s}async removeExtensionFromProfile(i,n){const s=[];this.f.fire({extensions:s,profileLocation:n});try{await this.p(n,o=>{const l=[];for(const I of o)(0,c.$fo)(I.identifier,i.identifier)?s.push(I):l.push(I);return s.length&&this.f.fire({extensions:s,profileLocation:n}),l}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:n}),o}}async p(i,n,s){return this.w(i).queue(async()=>{let o=[],l;try{const I=await this.j.readFile(i);l=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,w.$9j)(I)!==1)throw I;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(l=await this.v()),!l&&s?.bailOutWhenFileNotFound)throw new P((0,g.$9)(I),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.r(i);let I=!1;for(const E of l){p(E)||this.r(i);let k;if((0,y.$je)(E.relativeLocation)&&E.relativeLocation)k=this.t(E.relativeLocation);else if((0,y.$je)(E.location))k=this.t(E.location),I=!0,E.relativeLocation=E.location,E.location=k.toJSON();else{k=b.URI.revive(E.location);const j=this.s(k);j&&(I=!0,E.relativeLocation=j)}o.push({identifier:E.identifier,location:k,version:E.version,metadata:E.metadata})}I&&await this.j.writeFile(i,N.$Jb.fromString(JSON.stringify(l)))}if(n){o=n(o);const I=o.map(E=>({identifier:E.identifier,version:E.version,location:E.location.toJSON(),relativeLocation:this.s(E.location),metadata:E.metadata}));await this.j.writeFile(i,N.$Jb.fromString(JSON.stringify(I)))}return o})}r(i){const n=new P(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let s;try{s=(await this.j.readFile(i)).value.toString()}catch(l){if((0,w.$9j)(l)===1)return;throw l}this.n.info("Migrating extensions from old default profile location",i.toString());let o;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(I=>p(I))?o=l:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.n.error(l)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,N.$Jb.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(l){if((0,w.$9j)(l)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw l}try{await this.j.del(i)}catch(l){(0,w.$9j)(l)!==1&&this.n.error(l)}try{await this.j.del(n)}catch(l){(0,w.$9j)(l)!==1&&this.n.error(l)}return o})()),this.u}w(i){let n=this.h.get(i);return n||(n=new M.$Cg,this.h.set(i,n)),n}};e.$ap=$,e.$ap=$=pe([se(1,w.$Sj),se(2,h.$rk),se(3,S.$pk),se(4,d.$Vk),se(5,m.$Ri)],$);function p(a){return(0,y.$le)(a)&&(0,u.$On)(a.identifier)&&(t(a.location)||(0,y.$je)(a.location)&&a.location)&&((0,y.$qe)(a.relativeLocation)||(0,y.$je)(a.relativeLocation))&&a.version&&(0,y.$je)(a.version)}function t(a){return a?(0,y.$je)(a.path)&&(0,y.$je)(a.scheme):!1}}),define(ne[50],re([0,1,19,8,30,14,9,53,80,2,15,16,13,17,43,54,3,11,95,18,27,37,48,12,10,6,31,4,47,40,23,22,112]),function(G,e,M,N,D,A,L,b,u,c,w,O,m,h,S,y,g,d,f,P,$,p,t,a,i,n,s,o,l,I,E,k,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.Translations=void 0;var W;(function(ie){function V(H,C){if(H===C)return!0;const U=Object.keys(H),q=new Set;for(const X of Object.keys(C))q.add(X);if(U.length!==q.size)return!1;for(const X of U){if(H[X]!==C[X])return!1;q.delete(X)}return q.size===0}ie.equals=V})(W||(e.Translations=W={})),e.$dp=(0,i.$ph)("IExtensionsScannerService");let ee=class extends c.$lb{constructor(V,H,C,U,q,X,Y,K,T,R,r,v){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=H,this.l=C,this.m=U,this.n=q,this.r=X,this.s=Y,this.t=K,this.u=T,this.v=R,this.w=r,this.y=v,this.g=this.B(new o.$8c),this.onDidChangeCache=this.g.event,this.h=(0,h.$0f)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(te,this.m,this.h)),this.j=this.B(this.y.createInstance(te,this.m,this.h)),this.k=this.B(this.y.createInstance(le,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,$.$qo)(this.s,this.t)),this.z}async scanAllExtensions(V,H,C){const[U,q]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(H)]),X=C?await this.scanExtensionsUnderDevelopment(V,[...U,...q]):[];return this.G(U,q,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const H=[];H.push(this.H(!!V.useCache,V.language)),H.push(this.I(V.language,!!V.checkControlFile));const[C,U]=await Promise.all(H);return this.F([...C,...U],0,V,!1)}async scanUserExtensions(V){const H=V.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",H);const C=this.w.extUri.isEqual(V.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.L(H,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,C),q=V.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k;let X;try{X=await q.scanExtensions(U)}catch(Y){if(Y instanceof I.$$o&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),X=await q.scanExtensions(U);else throw Y}return X=await this.F(X,1,V,!0),this.t.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(V,H){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const C=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(U=>U.scheme===w.Schemas.file).map(async U=>{const q=await this.L(U,!1,1,!0,V.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(q)).map(Y=>(Y.type=H.find(K=>(0,$.$fo)(K.identifier,Y.identifier))?.type??Y.type,this.k.validate(Y,q)))}))).flat();return this.F(C,"development",V,!0)}return[]}async scanExistingExtension(V,H,C){const U=await this.L(V,!1,H,!0,C.language,!0,void 0),q=await this.k.scanExtension(U);return!q||!C.includeInvalid&&!q.isValid?null:q}async scanOneOrMultipleExtensions(V,H,C){const U=await this.L(V,!1,H,!0,C.language,!0,void 0),q=await this.k.scanOneOrMultipleExtensions(U);return this.F(q,H,C,!0)}async scanMetadata(V){const H=(0,h.$0f)(V,"package.json"),C=(await this.s.readFile(H)).value.toString();return JSON.parse(C).__metadata}async updateMetadata(V,H){const C=(0,h.$0f)(V,"package.json"),U=(await this.s.readFile(C)).value.toString(),q=JSON.parse(U);H.isMachineScoped=H.isMachineScoped||void 0,H.isBuiltin=H.isBuiltin||void 0,q.__metadata={...q.__metadata,...H},await this.s.writeFile((0,h.$0f)(V,"package.json"),A.$Jb.fromString(JSON.stringify(q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof I.$$o&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw V}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.r.addExtensionsToProfile(V.map(H=>[H,H.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,A.$Jb.fromString(JSON.stringify([])))}catch(H){(0,a.$9j)(H)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.$9)(H))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.t.error(V)}finally{this.C=void 0}})()),this.C}async F(V,H,C,U){return C.includeAllVersions||(V=this.G(H===0?V:void 0,H===1?V:void 0,H==="development"?V:void 0,await this.getTargetPlatform(),U)),C.includeInvalid||(V=V.filter(q=>q.isValid)),V.sort((q,X)=>{const Y=O.$ec(q.location.fsPath),K=O.$ec(X.location.fsPath);return Y<K?-1:Y>K?1:0})}G(V,H,C,U,q){const X=(K,T,R)=>{if(K.isValid&&!T.isValid)return!1;if(K.isValid===T.isValid){if(q&&S.gt(K.manifest.version,T.manifest.version))return this.t.debug(`Skipping extension ${T.location.path} with lower version ${T.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(S.eq(K.manifest.version,T.manifest.version)){if(K.type===0)return this.t.debug(`Skipping extension ${T.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===U)return this.t.debug(`Skipping extension ${T.location.path} from different target platform ${T.targetPlatform}`),!1}}return R?this.t.warn(`Overwriting user extension ${K.location.path} with ${T.location.path}.`):this.t.debug(`Overwriting user extension ${K.location.path} with ${T.location.path}.`),!0},Y=new p.$Jl;return V?.forEach(K=>{const T=Y.get(K.identifier.id);(!T||X(T,K,!1))&&Y.set(K.identifier.id,K)}),H?.forEach(K=>{const T=Y.get(K.identifier.id);if(!T&&V&&K.type===0){this.t.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!T||X(T,K,!1))&&Y.set(K.identifier.id,K)}),C?.forEach(K=>{const T=Y.get(K.identifier.id);(!T||X(T,K,!0))&&Y.set(K.identifier.id,K),Y.set(K.identifier.id,K)}),[...Y.values()]}async H(V,H){this.t.trace("Started scanning system extensions");const C=await this.L(this.systemExtensionsLocation,!1,0,!0,H,!0,void 0),q=await(V&&!C.devMode?this.i:this.k).scanExtensions(C);return this.t.trace("Scanned system extensions:",q.length),q}async I(V,H){const C=this.u.isBuilt?[]:this.v.builtInExtensions;if(!C?.length)return[];this.t.trace("Started scanning dev system extensions");const U=H?await this.J():{},q=[],X=d.URI.file(O.$$b(O.$ac(w.$4e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of C){const T=U[K.name]||"marketplace";switch(T){case"disabled":break;case"marketplace":q.push((0,h.$0f)(X,K.name));break;default:q.push(d.URI.file(T));break}}const Y=await Promise.all(q.map(async K=>this.k.scanExtension(await this.L(K,!1,0,!0,V,!0,void 0))));return this.t.trace("Scanned dev system extensions:",Y.length),(0,M.$mf)(Y)}async J(){try{const V=await this.s.readFile(this.l);return JSON.parse(V.value.toString())}catch{return{}}}async L(V,H,C,U,q,X,Y){const K=await this.f(q??m.$v),T=await this.M(V),R=H&&!this.w.extUri.isEqual(V,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,r=R?await this.M(R):void 0;return new x(V,T,R,r,H,Y,C,U,X,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,q,K)}async M(V){try{const H=await this.s.stat(V);if(typeof H.mtime=="number")return H.mtime}catch{}}};e.$ep=ee,e.$ep=ee=pe([se(4,E.$rk),se(5,I.$_o),se(6,a.$Sj),se(7,n.$Ri),se(8,P.$wh),se(9,s.$0i),se(10,k.$pk),se(11,i.$oh)],ee);class x{constructor(V,H,C,U,q,X,Y,K,T,R,r,v,z,F,J){this.location=V,this.mtime=H,this.applicationExtensionslocation=C,this.applicationExtensionslocationMtime=U,this.profile=q,this.profileScanOptions=X,this.type=Y,this.excludeObsolete=K,this.validate=T,this.productVersion=R,this.productDate=r,this.productCommit=v,this.devMode=z,this.language=F,this.translations=J}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,H){return(0,h.$3f)(V.location,H.location)&&V.mtime===H.mtime&&(0,h.$3f)(V.applicationExtensionslocation,H.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===H.applicationExtensionslocationMtime&&V.profile===H.profile&&D.$Lm(V.profileScanOptions,H.profileScanOptions)&&V.type===H.type&&V.excludeObsolete===H.excludeObsolete&&V.validate===H.validate&&V.productVersion===H.productVersion&&V.productDate===H.productDate&&V.productCommit===H.productCommit&&V.devMode===H.devMode&&V.language===H.language&&W.equals(V.translations,H.translations)}}e.$fp=x;let le=class extends c.$lb{constructor(V,H,C,U,q){super(),this.f=V,this.g=H,this.h=C,this.i=U,this.j=q}async scanExtensions(V){const H=V.profile?await this.l(V):await this.k(V);let C={};if(V.excludeObsolete&&V.type===1)try{const U=(await this.i.readFile(this.f)).value.toString();C=JSON.parse(U)}catch{}return(0,g.$we)(C)?H:H.filter(U=>!C[$.$go.create(U).toString()])}async k(V){const H=await this.i.resolve(V.location);if(!H.children?.length)return[];const C=await Promise.all(H.children.map(async U=>{if(!U.isDirectory||V.type===1&&(0,h.$7f)(U.resource).indexOf(".")===0)return null;const q=new x(U.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(q)}));return(0,M.$mf)(C).sort((U,q)=>U.location.path<q.location.path?-1:1)}async l(V){let H=await this.m(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){H=H.filter(U=>!U.metadata?.isApplicationScoped);const C=await this.m(V.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,V);H.push(...C)}return H}async m(V,H,C){const U=await this.g.scanProfileExtensions(V,C.profileScanOptions);if(!U.length)return[];const q=await Promise.all(U.map(async X=>{if(H(X)){const Y=new x(X.location,C.mtime,C.applicationExtensionslocation,C.applicationExtensionslocationMtime,C.profile,C.profileScanOptions,C.type,C.excludeObsolete,C.validate,C.productVersion,C.productDate,C.productCommit,C.devMode,C.language,C.translations);return this.scanExtension(Y,X.metadata)}return null}));return(0,M.$mf)(q)}async scanOneOrMultipleExtensions(V){try{if(await this.i.exists((0,h.$0f)(V.location,"package.json"))){const H=await this.scanExtension(V);return H?[H]:[]}else return await this.scanExtensions(V)}catch(H){return this.j.error(`Error scanning extensions at ${V.location.path}:`,(0,L.$9)(H)),[]}}async scanExtension(V,H){try{let C=await this.scanExtensionManifest(V.location);if(C){C.publisher||(C.publisher=p.$Dl),H=H??C.__metadata,delete C.__metadata;const U=(0,$.$ko)(C.publisher,C.name),q=H?.id?{id:U,uuid:H.id}:{id:U},X=H?.isSystem?0:V.type,Y=X===0||!!H?.isBuiltin;C=await this.n(V.location,C,x.createNlsConfiguration(V));const K={type:X,identifier:q,manifest:C,location:V.location,isBuiltin:Y,targetPlatform:H?.targetPlatform??"undefined",metadata:H,isValid:!0,validations:[]};return V.validate?this.validate(K,V):K}}catch(C){V.type!==0&&this.j.error(C)}return null}validate(V,H){let C=!0;const U=(0,t.$vo)(H.productVersion,H.productDate,H.location,V.manifest,V.isBuiltin);for(const[q,X]of U)q===y.default.Error&&(C=!1,this.j.error(this.u(H.location,X)));return V.isValid=C,V.validations=U,V}async scanExtensionManifest(V){const H=(0,h.$0f)(V,"package.json");let C;try{C=(await this.i.readFile(H)).value.toString()}catch(q){return(0,a.$9j)(q)!==1&&this.j.error(this.u(V,(0,f.localize)(0,null,H.path,q.message))),null}let U;try{U=JSON.parse(C)}catch{const X=[];(0,b.$xm)(C,X);for(const Y of X)this.j.error(this.u(V,(0,f.localize)(1,null,H.path,Y.offset,Y.length,(0,u.$bp)(Y.error))));return null}return(0,b.$Gm)(U)!=="object"?(this.j.error(this.u(V,(0,f.localize)(2,null,H.path))),null):U}async n(V,H,C){const U=await this.r(V,H,C);if(U)try{const q=[],X=await this.s(U.default,q);if(q.length>0)return q.forEach(K=>{this.j.error(this.u(V,(0,f.localize)(3,null,U.default?.path,(0,u.$bp)(K.error))))}),H;if((0,b.$Gm)(U)!=="object")return this.j.error(this.u(V,(0,f.localize)(4,null,U.default?.path))),H;const Y=U.values||Object.create(null);return(0,j.$cp)(H,Y,X)}catch{}return H}async r(V,H,C){const U=(0,h.$0f)(V,"package.nls.json"),q=(T,R)=>{R.forEach(r=>{this.j.error(this.u(V,(0,f.localize)(5,null,T?.path,(0,u.$bp)(r.error))))})},X=T=>{this.j.error(this.u(V,(0,f.localize)(6,null,T?.path)))},Y=`${H.publisher}.${H.name}`,K=C.translations[Y];if(K)try{const T=d.URI.file(K),R=(await this.i.readFile(T)).value.toString(),r=[],v=(0,b.$xm)(R,r);return r.length>0?(q(T,r),{values:void 0,default:U}):(0,b.$Gm)(v)!=="object"?(X(T),{values:void 0,default:U}):{values:v.contents?v.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.i.exists(U))return;let R;try{R=await this.t(V,C)}catch{return}if(!R.localized)return{values:void 0,default:R.original};try{const r=(await this.i.readFile(R.localized)).value.toString(),v=[],z=(0,b.$xm)(r,v);return v.length>0?(q(R.localized,v),{values:void 0,default:R.original}):(0,b.$Gm)(z)!=="object"?(X(R.localized),{values:void 0,default:R.original}):{values:z,default:R.original}}catch{return{values:void 0,default:R.original}}}}async s(V,H){if(V)try{const C=(await this.i.readFile(V)).value.toString();return(0,b.$xm)(C,H)}catch{}}t(V,H){return new Promise((C,U)=>{const q=X=>{const Y=(0,h.$0f)(V,`package.nls.${X}.json`);this.i.exists(Y).then(K=>{K&&C({localized:Y,original:(0,h.$0f)(V,"package.nls.json")});const T=X.lastIndexOf("-");T===-1?C({localized:(0,h.$0f)(V,"package.nls.json"),original:null}):(X=X.substring(0,T),q(X))})};if(H.devMode||H.pseudo||!H.language)return C({localized:(0,h.$0f)(V,"package.nls.json"),original:null});q(H.language)})}u(V,H){return`[${V.path}]: ${H}`}};le=pe([se(1,I.$_o),se(2,k.$pk),se(3,a.$Sj),se(4,n.$Ri)],le);let te=class extends le{constructor(V,H,C,U,q,X,Y){super(H,U,q,X,Y),this.z=V,this.C=C,this.w=this.B(new N.$tg(3e3)),this.y=this.B(new o.$8c),this.onDidChangeCache=this.y.event}async scanExtensions(V){const H=this.H(V),C=await this.D(H);if(this.v=V,C&&C.input&&x.equals(C.input,this.v))return this.j.debug("Using cached extensions scan result",V.location.toString()),this.w.trigger(()=>this.G()),C.result.map(q=>(q.location=d.URI.revive(q.location),q));const U=await super.scanExtensions(V);return await this.F(H,{input:V,result:U}),U}async D(V){try{const H=await this.i.readFile(V),C=JSON.parse(H.value.toString());return{result:C.result,input:(0,l.$Yg)(C.input)}}catch(H){this.j.debug("Error while reading the extension cache file:",V.path,(0,L.$9)(H))}return null}async F(V,H){try{await this.i.writeFile(V,A.$Jb.fromString(JSON.stringify(H)))}catch(C){this.j.debug("Error while writing the extension cache file:",V.path,(0,L.$9)(C))}}async G(){if(!this.v)return;const V=this.H(this.v),H=await this.D(V);if(!H)return;const C=H.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!D.$Lm(U,C))try{this.j.info("Invalidating Cache",C,U),await this.i.del(V),this.y.fire()}catch(q){this.j.error(q)}}H(V){const H=this.I(V);return this.h.extUri.joinPath(H.cacheHome,V.type===0?p.$Cl:p.$Bl)}I(V){return V.type===0?this.C.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.z.extensionsResource)?this.z:this.C.profiles.find(H=>this.h.extUri.isEqual(V.location,H.extensionsResource))??this.z:this.C.defaultProfile}};te=pe([se(2,E.$rk),se(3,I.$_o),se(4,k.$pk),se(5,a.$Sj),se(6,n.$Ri)],te);function ae(ie,V){const H=(0,$.$io)(ie.manifest.publisher,ie.manifest.name);return{id:H,identifier:new p.$Hl(H),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:V,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.$gp=ae;class ce extends ee{constructor(V,H,C,U,q,X,Y,K,T,R,r,v){super(V,H,(0,h.$0f)(C,".vscode-oss-dev","extensions","control.json"),U,q,X,Y,K,T,R,r,v),this.N=(async()=>{if(m.$y)try{const z=await this.s.readFile(d.URI.file(m.$y));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(V){return this.N}}e.$hp=ce}),define(ne[154],re([0,1,58,8,33,4,2,15,16,24,6,23]),function(G,e,M,N,D,A,L,b,u,c,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=void 0;let m=class extends L.$lb{constructor(S,y){super(),this.b=S,this.f=y,this.a=new N.$Bg(5)}async postUninstall(S){const y=this.g(S,"uninstall");y&&(this.f.info(S.identifier.id,S.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,S),this.f.info("Finished running post uninstall script",S.identifier.id,S.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",S.identifier.id,S.manifest.version),this.f.error(g)}}));try{await c.Promises.rm(this.j(S))}catch(g){this.f.error("Error while removing extension storage path",S.identifier.id),this.f.error(g)}}g(S,y){const g=`vscode:${y}`;if(S.location.scheme===b.Schemas.file&&S.manifest&&S.manifest.scripts&&typeof S.manifest.scripts[g]=="string"){const d=S.manifest.scripts[g].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn(S.identifier.id,S.manifest.version,`${g} should be a node script`),null):{script:(0,u.$ac)(S.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h(S,y,g,d,f){return new Promise((P,$)=>{const p=this.i(S,y,g,f);let t;const a=i=>{t&&(clearTimeout(t),t=null),i?$(i):P(void 0)};p.on("error",i=>{a((0,D.$ai)(i)||"Unknown")}),p.on("exit",(i,n)=>{a(i?`post-${y} process exited with code ${i}`:void 0)}),d&&(t=setTimeout(()=>{t=null,p.kill(),$("timed out")},5e3))})}i(S,y,g,d){const f={silent:!0,execArgv:void 0},P=(0,M.fork)(S,[`--type=extension-post-${y}`,...g],f);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const $=A.Event.fromNodeEventEmitter(P.stdout,"data"),p=A.Event.fromNodeEventEmitter(P.stderr,"data");$(i=>this.f.info(d.identifier.id,d.manifest.version,`post-${y}`,i)),p(i=>this.f.error(d.identifier.id,d.manifest.version,`post-${y}`,i));const t=A.Event.any(A.Event.map($,i=>({data:`%c${i}`,format:[""]})),A.Event.map(p,i=>({data:`%c${i}`,format:["color: red"]})));return A.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(d.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),P}j(S){return(0,u.$ac)(this.b.defaultProfile.globalStorageHome.fsPath,S.identifier.id.toLowerCase())}};e.$jp=m,e.$jp=m=pe([se(0,O.$rk),se(1,w.$Ri)],m)}),define(ne[155],re([0,1,6,23,22,26,40,12,18,11]),function(G,e,M,N,D,A,L,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=void 0;let w=class extends L.$ap{constructor(m,h,S,y,g,d){super(c.URI.file(m.extensionsPath),h,S,y,g,d)}};e.$ZM=w,e.$ZM=w=pe([se(0,u.$xh),se(1,b.$Sj),se(2,N.$rk),se(3,D.$pk),se(4,A.$Vk),se(5,M.$Ri)],w)}),define(ne[156],re([0,1,11,18,40,50,12,10,6,31,22,23]),function(G,e,M,N,D,A,L,b,u,c,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q4b=void 0;let m=class extends A.$hp{constructor(S,y,g,d,f,P,$,p){super(M.URI.file(f.builtinExtensionsPath),M.URI.file(f.extensionsPath),f.userHome,S.defaultProfile,S,y,g,d,f,P,$,p)}};e.$Q4b=m,e.$Q4b=m=pe([se(0,O.$rk),se(1,D.$_o),se(2,L.$Sj),se(3,u.$Ri),se(4,N.$xh),se(5,c.$0i),se(6,w.$pk),se(7,b.$oh)],m)}),define(ne[157],re([0,1,8,4,2,123,3,86,10,23]),function(G,e,M,N,D,A,L,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Ko=e.$Jo=e.$Io=void 0,e.$Io="__$__isNewStorageMarker",e.$Jo="__$__targetStorageMarker",e.$Ko=(0,u.$ph)("storageService");var w;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(w||(e.WillSaveStateReason=w={}));var O;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(O||(e.StorageScope=O={}));var m;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function h(f){const P=f.get(e.$Jo);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}e.$Lo=h;class S extends D.$lb{static{this.a=60*1e3}constructor(P={flushInterval:S.a}){super(),this.j=P,this.b=this.B(new N.$$c),this.c=this.B(new N.$$c),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$8c),this.onWillSaveState=this.f.event,this.h=this.B(new M.$Gg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new D.$mb),this.v=void 0,this.y=void 0,this.C=void 0}onDidChangeValue(P,$,p){return N.Event.filter(this.b.event,t=>t.scope===P&&($===void 0||t.key===$),p)}k(){this.i.value=(0,M.$Kg)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,D.$gb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(P,$){const{key:p,external:t}=$;if(p===e.$Jo){switch(P){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:p,target:this.F(P)[p],external:t})}r(P){this.f.fire({reason:P})}get(P,$,p){return this.L($)?.get(P,p)}getBoolean(P,$,p){return this.L($)?.getBoolean(P,p)}getNumber(P,$,p){return this.L($)?.getNumber(P,p)}getObject(P,$,p){return this.L($)?.getObject(P,p)}storeAll(P,$){this.t(()=>{for(const p of P)this.store(p.key,p.value,p.scope,p.target,$)})}store(P,$,p,t,a=!1){if((0,L.$se)($)){this.remove(P,p,a);return}this.t(()=>{this.u(P,p,t),this.L(p)?.set(P,$,a)})}remove(P,$,p=!1){this.t(()=>{this.u(P,$,void 0),this.L($)?.delete(P,p)})}t(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,$){const p=[],t=this.F(P);for(const a of Object.keys(t))t[a]===$&&p.push(a);return p}u(P,$,p,t=!1){const a=this.F($);typeof p=="number"?a[P]!==p&&(a[P]=p,this.L($)?.set(e.$Jo,JSON.stringify(a),t)):typeof a[P]=="number"&&(delete a[P],this.L($)?.set(e.$Jo,JSON.stringify(a),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(P){switch(P){case-1:return this.D;case 0:return this.z;default:return this.w}}G(P){const $=this.L(P);return $?h($):Object.create(null)}isNew(P){return this.getBoolean(e.$Io,P)===!0}async flush(P=w.NONE){this.f.fire({reason:P});const $=this.L(-1),p=this.L(0),t=this.L(1);switch(P){case w.NONE:await M.Promises.settled([$?.whenFlushed()??Promise.resolve(),p?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await M.Promises.settled([$?.flush(0)??Promise.resolve(),p?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.L(-1)?.items??new Map,$=this.L(0)?.items??new Map,p=this.L(1)?.items??new Map;return d(P,$,p,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(P,$){return this.r(w.NONE),(0,c.$qk)(P)?this.N(P,$):this.O(P,$)}H(P,$){return!(P.id===$.id||y($)&&y(P))}I(P,$,p){this.t(()=>{const t=new Set;for(const[a,i]of P)t.add(a),$.get(a)!==i&&this.n(p,{key:a,external:!0});for(const[a]of $.items)t.has(a)||this.n(p,{key:a,external:!0})})}}e.$Mo=S;function y(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$No=y;class g extends S{constructor(){super(),this.p=this.B(new b.$Go(new b.$Ho,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new b.$Go(new b.$Ho,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new b.$Go(new b.$Ho,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(P=>this.n(1,P))),this.B(this.P.onDidChangeStorage(P=>this.n(0,P))),this.B(this.p.onDidChangeStorage(P=>this.n(-1,P)))}L(P){switch(P){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(P){switch(P){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(P){return!1}}e.$Oo=g;async function d(f,P,$,p,t,a){const i=W=>{try{return JSON.parse(W)}catch{return W}},n=new Map,s=new Map;f.forEach((W,ee)=>{n.set(ee,W),s.set(ee,i(W))});const o=new Map,l=new Map;P.forEach((W,ee)=>{o.set(ee,W),l.set(ee,i(W))});const I=new Map,E=new Map;$.forEach((W,ee)=>{I.set(ee,W),E.set(ee,i(W))}),console.group(p!==t?`Storage: Application (path: ${p})`:`Storage: Application & Profile (path: ${p}, default profile)`);const k=[];if(n.forEach((W,ee)=>{k.push({key:ee,value:W})}),console.table(k),console.groupEnd(),console.log(s),p!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const W=[];o.forEach((ee,x)=>{W.push({key:x,value:ee})}),console.table(W),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${a})`);const j=[];I.forEach((W,ee)=>{j.push({key:ee,value:W})}),console.table(j),console.groupEnd(),console.log(E)}e.$Po=d}),define(ne[158],re([0,1,19,20,9,13,34,3,11,25,18,21,27,48,12,6,31,45,142,157,26]),function(G,e,M,N,D,A,L,b,u,c,w,O,m,h,S,y,g,d,f,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=void 0;const p=A.$o?"web":(0,O.$Kn)(A.$t,L.$8b),t="X-Market-Search-Activity-Id";var a;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(a||(a={}));function i(...R){return String(R.reduce((r,v)=>r|v,0))}var n;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class E{constructor(r=I){this.d=r}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(r,v=this.d.pageSize){return new E({...this.d,pageNumber:r,pageSize:v})}withFilter(r,...v){const z=[...this.d.criteria,...v.length?v.map(F=>({filterType:r,value:F})):[{filterType:r}]];return new E({...this.d,criteria:z})}withSortBy(r){return new E({...this.d,sortBy:r})}withSortOrder(r){return new E({...this.d,sortOrder:r})}withFlags(...r){return new E({...this.d,flags:r.reduce((v,z)=>v|z,0)})}withAssetTypes(...r){return new E({...this.d,assetTypes:r})}withSource(r){return new E({...this.d,source:r})}get raw(){const{criteria:r,pageNumber:v,pageSize:z,sortBy:F,sortOrder:J,flags:Z,assetTypes:oe}=this.d;return{filters:[{criteria:r,pageNumber:v,pageSize:z,sortBy:F,sortOrder:J}],assetTypes:oe,flags:Z}}get searchText(){const r=this.d.criteria.filter(v=>v.filterType===n.SearchText)[0];return r&&r.value?r.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(r=>String(r.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function k(R,r){const v=(R||[]).filter(z=>z.statisticName===r)[0];return v?v.value:0}function j(R){const r="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(z=>z.assetType.indexOf(r)===0).reduce((z,F)=>{const J=x(R,F.assetType);return J&&z.push([F.assetType.substring(r.length),J]),z},[])}function W(R){if(R.properties){const r=R.properties.filter(F=>F.key===s.Repository),v=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=r.filter(F=>v.test(F.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return x(R,s.Repository)}function ee(R){return{uri:`${R.fallbackAssetUri}/${s.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${s.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function x(R,r){return R.files.filter(z=>z.assetType===r)[0]?{uri:`${R.assetUri}/${r}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${r}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function le(R,r){const v=R.properties?R.properties.filter(F=>F.key===r):[],z=v.length>0&&v[0].value;return z?z.split(",").map(F=>(0,m.$jo)(F)):[]}function te(R){const r=R.properties?R.properties.filter(v=>v.key===o.Engine):[];return r.length>0&&r[0].value||""}function ae(R){const r=R.properties?R.properties.filter(v=>v.key===o.PreRelease):[];return r.length>0&&r[0].value==="true"}function ce(R){const r=R.properties?R.properties.filter(z=>z.key===o.LocalizedLanguages):[],v=r.length>0&&r[0].value||"";return v?v.split(","):[]}function ie(R){return R.properties?.find(r=>r.key===o.SponsorLink)?.value}function V(R){return R.indexOf("preview")!==-1}function H(R){return R.targetPlatform?(0,O.$Jn)(R.targetPlatform):"undefined"}function C(R){const r=(0,M.$rf)(R.versions.map(H)),v=!!R.tags?.includes(O.$Fn),z=r.indexOf("web");return v?z===-1&&r.push("web"):z!==-1&&r.splice(z,1),r}function U(R,r){const v=(0,O.$Nn)(r);for(let z=0;z<R.length;z++){const F=R[z];if(F.version===R[z-1]?.version){let J=z;const Z=H(F);if(Z===r)for(;J>0&&R[J-1].version===F.version;)J--;else if(v.includes(Z))for(;J>0&&R[J-1].version===F.version&&H(R[J-1])!==r;)J--;J!==z&&(R.splice(z,1),R.splice(J,0,F))}}return R}e.$So=U;function q(R,r,v){R.telemetryData={index:r,querySource:v,queryActivityId:R.queryContext?.[t]}}function X(R,r,v,z){const F=R.versions[0],J={manifest:x(r,s.Manifest),readme:x(r,s.Details),changelog:x(r,s.Changelog),license:x(r,s.License),repository:W(r),download:ee(r),icon:x(r,s.Icon),signature:x(r,s.Signature),coreTranslations:j(r)};return{identifier:{id:(0,m.$ko)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:r.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:ie(F),description:R.shortDescription||"",installCount:k(R.statistics,"install"),rating:k(R.statistics,"averagerating"),ratingCount:k(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:v,assets:J,properties:{dependencies:le(r,o.Dependency),extensionPack:le(r,o.ExtensionPack),engine:te(r),localizedLanguages:ce(r),targetPlatform:H(r),isPreReleaseVersion:ae(r)},hasPreReleaseVersion:ae(F),hasReleaseVersion:!0,preview:V(R.flags),isSigned:!!J.signature,queryContext:z}}let Y=class{constructor(r,v,z,F,J,Z,oe,fe){this.k=v,this.l=z,this.n=F,this.o=J,this.q=Z,this.u=oe,this.w=fe;const de=oe.extensionsGallery,ue=de?.servicePPEUrl&&fe.getValue("_extensionsGallery.enablePPE");this.d=ue?de.servicePPEUrl:de?.serviceUrl,this.g=ue?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,f.$Ro)(oe.version,oe,this.n,this.w,this.q,r,this.o)}x(r=""){return`${this.d}${r}`}isEnabled(){return!!this.d}async getExtensions(r,v,z){const F=N.CancellationToken.isCancellationToken(v)?{}:v,J=N.CancellationToken.isCancellationToken(v)?v:z,Z=[],oe=[],fe=[],de=[];let ue=!0;for(const he of r){he.uuid?oe.push(he.uuid):Z.push(he.id);const be=!!(he.version||he.preRelease);fe.push({id:he.id,uuid:he.uuid,includePreRelease:be}),he.version&&de.push({id:he.id,uuid:he.uuid,version:he.version}),ue=ue&&!!he.hasPreRelease&&!be}if(!oe.length&&!Z.length)return[];let ge=new E().withPage(1,r.length);oe.length&&(ge=ge.withFilter(n.ExtensionId,...oe)),Z.length&&(ge=ge.withFilter(n.ExtensionName,...Z)),(F.queryAllVersions||ue)&&(ge=ge.withFlags(ge.flags,a.IncludeVersions)),F.source&&(ge=ge.withSource(F.source));const{extensions:me}=await this.z(ge,{targetPlatform:F.targetPlatform??p,includePreRelease:fe,versions:de,compatible:!!F.compatible},J);return F.source&&me.forEach((he,be)=>q(he,be,F.source)),me}async getCompatibleExtension(r,v,z){if((0,O.$Ln)(r.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(r,v,z))return r;const F=new E().withFlags(a.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,r.identifier.uuid),{extensions:J}=await this.z(F,{targetPlatform:z,compatible:!0,includePreRelease:v},N.CancellationToken.None);return J[0]||null}async isExtensionCompatible(r,v,z){if(!(0,O.$Mn)(r.properties.targetPlatform,r.allTargetPlatforms,z)||!v&&r.properties.isPreReleaseVersion)return!1;let F=r.properties.engine;if(!F){const J=await this.getManifest(r,N.CancellationToken.None);if(!J)throw new Error("Manifest was not found");F=J.engines.vscode}return(0,h.$xo)(F,this.u.version,this.u.date)}async y(r,v,z,F,J){if(!(0,O.$Mn)(H(r),F,J)||v!=="any"&&ae(r)!==(v==="prerelease"))return!1;if(z)try{const Z=await this.E(r);if(!(0,h.$xo)(Z,this.u.version,this.u.date))return!1}catch(Z){return this.l.error(`Error while getting the engine for the version ${r.version}.`,(0,D.$9)(Z)),!1}return!0}async query(r,v){let z=r.text||"";const F=r.pageSize??50;let J=new E().withPage(1,F);z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ge,me)=>(J=J.withFilter(n.Category,me||ge),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ge,me)=>(J=J.withFilter(n.Tag,me||ge),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(n.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),J=J.withFilter(n.SearchText,z)),J=J.withSortBy(0)):r.ids?J=J.withFilter(n.ExtensionId,...r.ids):r.names?J=J.withFilter(n.ExtensionName,...r.names):J=J.withSortBy(4),typeof r.sortBy=="number"&&(J=J.withSortBy(r.sortBy)),typeof r.sortOrder=="number"&&(J=J.withSortOrder(r.sortOrder)),r.source&&(J=J.withSource(r.source));const Z=async(ue,ge)=>{const{extensions:me,total:he}=await this.z(ue,{targetPlatform:p,compatible:!1,includePreRelease:!!r.includePreRelease},ge);return me.forEach((be,Ee)=>q(be,(ue.pageNumber-1)*ue.pageSize+Ee,r.source)),{extensions:me,total:he}},{extensions:oe,total:fe}=await Z(J,v),de=async(ue,ge)=>{if(ge.isCancellationRequested)throw new D.$3;const{extensions:me}=await Z(J.withPage(ue+1),ge);return me};return{firstPage:oe,total:fe,pageSize:J.pageSize,getPage:de}}async z(r,v,z){const F=r.flags;r.flags&a.IncludeLatestVersionOnly&&r.flags&a.IncludeVersions&&(r=r.withFlags(r.flags&~a.IncludeVersions,a.IncludeLatestVersionOnly)),!(r.flags&a.IncludeLatestVersionOnly)&&!(r.flags&a.IncludeVersions)&&(r=r.withFlags(r.flags,a.IncludeLatestVersionOnly)),v.versions?.length&&(r=r.withFlags(r.flags&~a.IncludeLatestVersionOnly,a.IncludeVersions)),r=r.withFlags(r.flags,a.IncludeAssetUri,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeStatistics,a.IncludeVersionProperties);const{galleryExtensions:J,total:Z,context:oe}=await this.B(r,z);if(!(r.flags&a.IncludeLatestVersionOnly)){const ge=[];for(const me of J){const he=await this.A(me,v,oe);he&&ge.push(he)}return{extensions:ge,total:Z}}const de=[],ue=new Map;for(let ge=0;ge<J.length;ge++){const me=J[ge],he={id:(0,m.$ko)(me.publisher.publisherName,me.extensionName),uuid:me.extensionId},be=(0,b.$pe)(v.includePreRelease)?v.includePreRelease:!!v.includePreRelease.find(je=>(0,m.$fo)(je,he))?.includePreRelease;if(v.compatible&&(0,O.$Ln)(C(me),v.targetPlatform))continue;const Ee=await this.A(me,v,oe);!Ee||Ee.properties.isPreReleaseVersion&&(!be||!Ee.hasReleaseVersion)||!Ee.properties.isPreReleaseVersion&&Ee.properties.targetPlatform!==v.targetPlatform&&Ee.hasPreReleaseVersion?ue.set(me.extensionId,ge):de.push([ge,Ee])}if(ue.size){const ge=new Date().getTime(),me=new E().withFlags(F&~a.IncludeLatestVersionOnly,a.IncludeVersions).withPage(1,ue.size).withFilter(n.ExtensionId,...ue.keys()),{extensions:he}=await this.z(me,v,z);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:ue.size});for(const be of he){const Ee=ue.get(be.identifier.uuid);de.push([Ee,be])}}return{extensions:de.sort((ge,me)=>ge[0]-me[0]).map(([,ge])=>ge),total:Z}}async A(r,v,z){const F={id:(0,m.$ko)(r.publisher.publisherName,r.extensionName),uuid:r.extensionId},J=v.versions?.find(de=>(0,m.$fo)(de,F))?.version,Z=(0,b.$pe)(v.includePreRelease)?v.includePreRelease:!!v.includePreRelease.find(de=>(0,m.$fo)(de,F))?.includePreRelease,oe=C(r),fe=U(r.versions,v.targetPlatform);if(v.compatible&&(0,O.$Ln)(oe,v.targetPlatform))return null;for(let de=0;de<fe.length;de++){const ue=fe[de];if(!(J&&ue.version!==J)){if(await this.y(ue,Z?"any":"release",v.compatible,oe,v.targetPlatform))return X(r,ue,oe,z);if(J&&ue.version===J)return null}}return J||v.compatible?null:X(r,r.versions[0],oe)}async B(r,v){if(!this.isEnabled())throw new Error("No extension gallery service configured.");r=r.withFlags(r.flags,a.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(a.Unpublished));const z=await this.j,F=JSON.stringify(r.raw),J={...z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(F.length)},Z=new Date().getTime();let oe,fe,de=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&r.criteria.some(ge=>ge.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:F,headers:J},v),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:de};const ue=await(0,d.$Do)(oe);if(ue){const ge=ue.results[0],me=ge.extensions,he=ge.resultMetadata&&ge.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=he&&he.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:de,context:{[t]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ue){throw fe=ue,ue}finally{this.o.publicLog2("galleryService:query",{...r.telemetryData,requestBodySize:String(F.length),duration:new Date().getTime()-Z,success:!!oe&&(0,d.$Ao)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:fe?(0,D.$2)(fe)?"canceled":(0,D.$9)(fe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(r,v,z,F){if(!this.isEnabled())return;const J=A.$o?this.x(`/itemName/${r}.${v}/version/${z}/statType/${F==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${r}/extensions/${v}/${z}/stats?statType=${F}`),Z=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",fe={...await this.j,Accept:Z};try{await this.k.request({type:"POST",url:J,headers:fe},N.CancellationToken.None)}catch{}}async download(r,v,z){this.l.trace("ExtensionGalleryService#download",r.identifier.id);const F=(0,m.$no)(r),J=new Date().getTime(),Z=ge=>this.o.publicLog("galleryService:downloadVSIX",{...F,duration:ge}),oe=z===2?"install":z===3?"update":"",fe=oe?{uri:`${r.assets.download.uri}${u.URI.parse(r.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${r.assets.download.fallbackUri}${u.URI.parse(r.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:r.assets.download,de=r.queryContext?.[t]?{[t]:r.queryContext[t]}:void 0,ue=await this.D(fe,de?{headers:de}:void 0);await this.q.writeFile(v,ue.stream),Z(new Date().getTime()-J)}async downloadSignatureArchive(r,v){if(!r.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",r.identifier.id);const z=await this.D(r.assets.signature);await this.q.writeFile(v,z.stream)}async getReadme(r,v){if(r.assets.readme){const z=await this.D(r.assets.readme,{},v);return await(0,d.$Co)(z)||""}return""}async getManifest(r,v){if(r.assets.manifest){const z=await this.D(r.assets.manifest,{},v),F=await(0,d.$Co)(z);return F?JSON.parse(F):null}return null}async C(r,v){const z=x(r,s.Manifest);if(!z)throw new Error("Manifest was not found");const F={"Accept-Encoding":"gzip"},J=await this.D(z,{headers:F});return await(0,d.$Do)(J)}async getCoreTranslation(r,v){const z=r.assets.coreTranslations.filter(F=>F[0]===v.toUpperCase())[0];if(z){const F=await this.D(z[1]),J=await(0,d.$Co)(F);return J?JSON.parse(J):null}return null}async getChangelog(r,v){if(r.assets.changelog){const z=await this.D(r.assets.changelog,{},v);return await(0,d.$Co)(z)||""}return""}async getAllCompatibleVersions(r,v,z){let F=new E().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1);r.identifier.uuid?F=F.withFilter(n.ExtensionId,r.identifier.uuid):F=F.withFilter(n.ExtensionName,r.identifier.id);const{galleryExtensions:J}=await this.B(F,N.CancellationToken.None);if(!J.length)return[];const Z=C(J[0]);if((0,O.$Ln)(Z,z))return[];const oe=[];await Promise.all(J[0].versions.map(async ue=>{try{await this.y(ue,v?"any":"release",!0,Z,z)&&oe.push(ue)}catch{}}));const fe=[],de=new Set;for(const ue of U(oe,z))de.has(ue.version)||(de.add(ue.version),fe.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:ae(ue)}));return fe}async D(r,v={},z=N.CancellationToken.None){const F=await this.j,J={type:"GET"},Z={...F,...v.headers||{}};v={...v,...J,headers:Z};const oe=r.uri,fe=r.fallbackUri,de={...v,url:oe};try{const ue=await this.k.request(de,z);if(ue.res.statusCode===200)return ue;const ge=await(0,d.$Co)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${ge}`)}catch(ue){if((0,D.$2)(ue))throw ue;const ge=(0,D.$9)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:ge});const me={...v,url:fe};return this.k.request(me,z)}}async E(r){let v=te(r);if(!v){const z=await this.C(r,N.CancellationToken.None);if(!z)throw new Error("Manifest was not found");v=z.engines.vscode}return v}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const r=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(r.res.statusCode!==200)throw new Error("Could not get extensions report.");const v=await(0,d.$Do)(r),z=[],F={},J=[];if(v){for(const Z of v.malicious)z.push({id:Z});if(v.migrateToPreRelease)for(const[Z,oe]of Object.entries(v.migrateToPreRelease))(!oe.engine||(0,h.$xo)(oe.engine,this.u.version,this.u.date))&&(F[Z.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(v.deprecated)for(const[Z,oe]of Object.entries(v.deprecated))oe&&(F[Z.toLowerCase()]=(0,b.$pe)(oe)?{}:oe);if(v.search)for(const Z of v.search)J.push(Z)}return{malicious:z,deprecated:F,search:J}}};Y=pe([se(1,d.$yo),se(2,y.$Ri),se(3,w.$wh),se(4,$.$Vk),se(5,S.$Sj),se(6,g.$0i),se(7,c.$Vh)],Y);let K=class extends Y{constructor(r,v,z,F,J,Z,oe,fe){super(r,v,z,F,J,Z,oe,fe)}};e.$To=K,e.$To=K=pe([se(0,P.$Ko),se(1,d.$yo),se(2,y.$Ri),se(3,w.$wh),se(4,$.$Vk),se(5,S.$Sj),se(6,g.$0i),se(7,c.$Vh)],K);let T=class extends Y{constructor(r,v,z,F,J,Z,oe){super(void 0,r,v,z,F,J,Z,oe)}};e.$Uo=T,e.$Uo=T=pe([se(0,d.$yo),se(1,y.$Ri),se(2,w.$wh),se(3,$.$Vk),se(4,S.$Sj),se(5,g.$0i),se(6,c.$Vh)],T)}),define(ne[159],re([0,1,11,18,12,6,139,22,23,3,68]),function(G,e,M,N,D,A,L,b,u,c,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=e.$XM=e.$WM=void 0;let O=class Be extends u.$uk{static{this.a="profileAssociationsMigration"}constructor(y,g,d,f,P){super(d,f,g,P),this.P=y,this.Q=d}J(){return this.P.getItem(Be.b,[]).map(g=>({...g,location:(0,c.$je)(g.location)?this.s.extUri.joinPath(this.profilesHome,g.location):M.URI.revive(g.location)}))}M(){const y=this.P.getItem(Be.c,{});return this.P.getItem(Be.a,!1)?y:this.I(y)}O(){return this.s.extUri.joinPath(M.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$WM=O,e.$WM=O=pe([se(0,L.$RM),se(1,b.$pk),se(2,N.$xh),se(3,D.$Sj),se(4,A.$Ri)],O);let m=class Ce extends O{constructor(y,g,d,f,P){super(y,g,d,f,P),this.W=y}L(y){y.length?this.W.setItem(Ce.b,y.map(g=>({...g,location:this.s.extUri.basename(g.location)}))):this.W.removeItem(Ce.b)}J(){const y=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(y),this.W.setItem("userDataProfilesMigration",!0)),y}N(y){y.emptyWindows||y.workspaces?this.W.setItem(Ce.c,y):this.W.removeItem(Ce.c)}M(){const y="workspaceAndProfileInfo",g=this.W.getItem(y,void 0);if(g){this.W.removeItem(y);const f=g.reduce((P,{workspace:$,profile:p})=>(P[M.URI.revive($).toString()]=M.URI.revive(p).toString(),P),{});this.W.setItem(Ce.c,{workspaces:f})}const d=super.M();return this.W.getItem(Ce.a,!1)||(this.N(d),this.W.setItem(Ce.a,!0)),d}};e.$XM=m,e.$XM=m=pe([se(0,L.$SM),se(1,b.$pk),se(2,N.$xh),se(3,D.$Sj),se(4,A.$Ri)],m);let h=class extends m{constructor(y,g,d,f){super(new w.$VM(0,g,f,d),y,g,d,f)}async init(){return await this.W.init(),super.init()}};e.$YM=h,e.$YM=h=pe([se(0,b.$pk),se(1,N.$xh),se(2,D.$Sj),se(3,A.$Ri)],h)}),define(ne[51],re([0,1,125,8,16,3,24,87,174,175]),function(G,e,M,N,D,A,L,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.zip=e.$3o=e.$2o=void 0,e.$2o="end of central directory record signature not found";const w=new RegExp(e.$2o);class O extends Error{constructor(a,i){let n=i.message;switch(a){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=a,this.cause=i}}e.$3o=O;function m(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>a&i).reduce((i,n)=>i+n,a&61440)}function h(t){if(t instanceof O)return t;let a;return w.test(t.message)&&(a="CorruptZip"),new O(a,t)}function S(t,a,i,n,s,o){const l=D.$dc(a),I=D.$ac(n,l);if(!I.startsWith(n))return Promise.reject(new Error(b.localize(0,null,a)));const E=D.$ac(n,a);let k;return o.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(L.Promises.mkdir(I,{recursive:!0})).then(()=>new Promise((j,W)=>{if(!o.isCancellationRequested)try{k=(0,M.createWriteStream)(E,{mode:i}),k.once("close",()=>j()),k.once("error",W),t.once("error",W),t.pipe(k)}catch(ee){W(ee)}}))}function y(t,a,i,n){let s=(0,N.$jg)(()=>Promise.resolve()),o=0;return n.onCancellationRequested(()=>{s.cancel(),t.close()}),new Promise((l,I)=>{const E=new N.$qg,k=j=>{j.isCancellationRequested||(o++,t.readEntry())};t.once("error",I),t.once("close",()=>s.then(()=>{n.isCancellationRequested||t.entryCount===o?l():I(new O("Incomplete",new Error(b.localize(1,null,o,t.entryCount))))},I)),t.readEntry(),t.on("entry",j=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(j.fileName)){k(n);return}const W=j.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(W)){const le=D.$ac(a,W);s=(0,N.$jg)(te=>L.Promises.mkdir(le,{recursive:!0}).then(()=>k(te)).then(void 0,I));return}const ee=d(t,j),x=m(j);s=(0,N.$jg)(le=>E.queue(()=>ee.then(te=>S(te,W,x,a,i,le).then(()=>k(le)))).then(null,I))})})}function g(t,a=!1){return new Promise((i,n)=>{(0,u.open)(t,a?{lazyEntries:!0}:void 0,(s,o)=>{s?n(h(s)):i((0,A.$ue)(o))})})}function d(t,a){return new Promise((i,n)=>{t.openReadStream(a,(s,o)=>{s?n(h(s)):i((0,A.$ue)(o))})})}function f(t,a){return new Promise((i,n)=>{const s=new c.ZipFile;a.forEach(l=>{l.contents?s.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&s.addFile(l.localPath,l.path)}),s.end();const o=(0,M.createWriteStream)(t);s.outputStream.pipe(o),s.outputStream.once("error",n),o.once("error",n),o.once("finish",()=>i(t))})}e.zip=f;function P(t,a,i={},n){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let o=g(t,!0);return i.overwrite&&(o=o.then(l=>L.Promises.rm(a).then(()=>l))),o.then(l=>y(l,a,{sourcePathRegex:s},n))}e.$5o=P;function $(t,a){return g(t).then(i=>new Promise((n,s)=>{i.on("entry",o=>{o.fileName===a&&d(i,o).then(l=>n(l),l=>s(l))}),i.once("close",()=>s(new Error(b.localize(2,null,a))))}))}function p(t,a){return $(t,a).then(i=>new Promise((n,s)=>{const o=[];i.once("error",s),i.on("data",l=>o.push(l)),i.on("end",()=>n(Buffer.concat(o)))}))}e.$6o=p}),define(ne[160],re([0,1,8,9,2,15,17,43,3,29,24,51,25,18,21,27,60,12,6]),function(G,e,M,N,D,A,L,b,u,c,w,O,m,h,S,y,g,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=void 0;let P=class qe extends D.$lb{static{this.c=".sigzip"}constructor(p,t,a,i,n,s){super(),this.h=t,this.i=a,this.j=i,this.k=n,this.l=s,this.extensionsDownloadDir=p.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(p,t,a){await this.g;const i=(0,L.$0f)(this.extensionsDownloadDir,this.u(p));try{await this.r(p,i,s=>this.i.download(p,s,t))}catch(s){throw new S.$Qn(s.message,S.ExtensionManagementErrorCode.Download)}let n=!1;if(a&&this.m(p)){const s=await this.n(p);try{n=await this.k.verify(i.fsPath,s.fsPath,this.l.getLevel()===f.LogLevel.Trace)}catch(o){const l=o;if(n=l.code,l.output&&this.l.trace(`Extension signature verification details for ${p.identifier.id} ${p.version}:
${l.output}`),n===S.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===S.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new S.$Qn(O.$2o,S.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(s)}catch(o){this.l.error(o)}}}return n===!0?this.l.info(`Extension signature is verified: ${p.identifier.id}`):n===!1?this.l.info(`Extension signature verification is not done: ${p.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${n}': ${p.identifier.id}`),{location:i,verificationStatus:n}}m(p){if(!p.isSigned)return!1;const t=this.j.getValue("extensions.verifySignature");return(0,u.$pe)(t)?t:!0}async n(p){await this.g;const t=(0,L.$0f)(this.extensionsDownloadDir,`${this.u(p)}${qe.c}`);return await this.r(p,t,a=>this.i.downloadSignatureArchive(p,a)),t}async r(p,t,a){if(await this.h.exists(t))return;if(t.scheme!==A.Schemas.file){await a(t);return}const i=(0,L.$0f)(this.extensionsDownloadDir,`.${(0,c.$6e)()}`);await this.h.exists(i)||await a(i);try{await w.Promises.rename(i.fsPath,t.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",p.identifier.id,t.path);else throw this.l.info(`Rename failed because of ${(0,N.$9)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(p){await this.g,await this.h.del(p)}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const p=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(p.children){const t=[],a=[],i=[];for(const o of p.children)if(o.name.endsWith(qe.c))i.push(o.resource);else{const l=y.$go.parse(o.name);l&&a.push([l,o])}const n=(0,y.$lo)(a,([o])=>o),s=[];for(const o of n)o.sort((l,I)=>b.rcompare(l[0].version,I[0].version)),t.push(...o.slice(1).map(l=>l[1].resource)),s.push(o[0][1]);s.sort((o,l)=>o.mtime-l.mtime),t.push(...s.slice(0,Math.max(0,s.length-this.f)).map(o=>o.resource)),t.push(...i),await M.Promises.settled(t.map(o=>(this.l.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(p){this.l.error(p)}}u(p){return this.f?y.$go.create(p).toString().toLowerCase():(0,c.$6e)()}};e.$ip=P,e.$ip=P=pe([se(0,h.$xh),se(1,d.$Sj),se(2,S.$Pn),se(3,m.$Vh),se(4,g.$Vo),se(5,f.$Ri)],P)}),define(ne[161],re([0,1,51,97]),function(G,e,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;function D(A){return(0,M.$6o)(A,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$kp=D}),define(ne[162],re([0,1,8,14,20,33,9,4,42,2,35,15,16,17,43,3,11,29,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,31,26,22,23]),function(G,e,M,N,D,A,L,b,u,c,w,O,m,h,S,y,g,d,f,P,$,p,t,a,i,n,s,o,l,I,E,k,j,W,ee,x,le,te,ae,ce,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=void 0,e.$np=(0,x.$qh)(i.$Rn);const V=".vsctmp";let H=class extends a.$7o{constructor(T,R,r,v,z,F,J,Z,oe,fe,de,ue){super(T,R,de,r,fe,ue),this.bb=z,this.cb=F,this.db=J,this.eb=oe,this.ab=new Map,this.nb=new w.$oi;const ge=this.B(Z.createInstance(I.$jp));this.Y=this.B(Z.createInstance(C,he=>ge.postUninstall(he))),this.Z=this.B(new k.$lp(ue,oe,de,this,this.y)),this.$=this.B(Z.createInstance(l.$ip));const me=this.B(new j.$mp(this,this.bb,ue,F,de,oe,r));this.B(me.onDidChangeExtensionsByAnotherSource(he=>this.mb(he))),this.ob()}getTargetPlatform(){return this.fb||(this.fb=(0,n.$qo)(this.eb,this.y)),this.fb}async zip(T){this.y.trace("ExtensionManagementService#zip",T.identifier.id);const R=await this.lb(T),r=await(0,P.zip)((0,h.$0f)(this.$.extensionsDownloadDir,(0,d.$6e)()).fsPath,R);return g.URI.file(r)}async unzip(T){return this.y.trace("ExtensionManagementService#unzip",T.toString()),(await this.install(T)).identifier}async getManifest(T){const{location:R,cleanup:r}=await this.hb(T),v=m.$bc(R.fsPath);try{return await(0,E.$kp)(v)}finally{await r()}}getInstalled(T,R=this.C.defaultProfile.extensionsResource){return this.Y.scanExtensions(T??null,R)}scanAllUserInstalledExtensions(){return this.Y.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(T){return this.Y.scanUserExtensionAtLocation(T)}async install(T,R={}){this.y.trace("ExtensionManagementService#install",T.toString());const{location:r,cleanup:v}=await this.hb(T);try{const z=await(0,E.$kp)(m.$bc(r.fsPath)),F=(0,n.$ko)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,W.$xo)(z.engines.vscode,this.z.version,this.z.date))throw new Error($.localize(0,null,F,this.z.version));const J=await this.D([{manifest:z,extension:r,options:R}]);if(J[0]?.local)return J[0]?.local;throw J[0]?.error?J[0].error:(0,a.$9o)(new Error(`Unknown error while installing extension ${F}`))}finally{await v()}}async installFromLocation(T,R){this.y.trace("ExtensionManagementService#installFromLocation",T.toString());const r=await this.Y.scanUserExtensionAtLocation(T);if(!r)throw new Error(`Cannot find a valid extension from the location ${T.toString()}`);return await this.qb([[r,void 0]],R),this.y.info("Successfully installed extension",r.identifier.id,R.toString()),r}async installExtensionsFromProfile(T,R,r){this.y.trace("ExtensionManagementService#installExtensionsFromProfile",T,R.toString(),r.toString());const v=(await this.Y.scanExtensions(1,R)).filter(z=>T.some(F=>(0,n.$fo)(F,z.identifier)));if(v.length){const z=await Promise.all(v.map(F=>this.Y.scanMetadata(F,R)));await this.qb(v.map((F,J)=>[F,z[J]]),r),this.y.info("Successfully installed extensions",v.map(F=>F.identifier.id),r.toString())}return v}async updateMetadata(T,R,r=this.C.defaultProfile.extensionsResource){return this.y.trace("ExtensionManagementService#updateMetadata",T.identifier.id),R.isPreReleaseVersion&&(R.preRelease=!0),R.isMachineScoped=R.isMachineScoped||void 0,R.isBuiltin=R.isBuiltin||void 0,R.pinned=R.pinned||void 0,T=await this.Y.updateMetadata(T,R,r),this.Z.invalidate(r),this.s.fire(T),T}async reinstallFromGallery(T){if(this.y.trace("ExtensionManagementService#reinstallFromGallery",T.identifier.id),!this.u.isEnabled())throw new Error($.localize(1,null));const R=await this.getTargetPlatform(),[r]=await this.u.getExtensions([{...T.identifier,preRelease:T.preRelease}],{targetPlatform:R,compatible:!0},D.CancellationToken.None);if(!r)throw new Error($.localize(2,null));await this.Y.setUninstalled(T);try{await this.Y.removeUninstalledExtension(T)}catch(v){throw new Error($.localize(3,null,(0,A.$ai)(v)))}return this.installFromGallery(r)}X(T,R,r,v){return this.Y.copyExtension(T,R,r,v)}copyExtensions(T,R){return this.Y.copyExtensions(T,R)}markAsUninstalled(...T){return this.Y.setUninstalled(...T)}async cleanUp(){this.y.trace("ExtensionManagementService#cleanUp");try{await this.Y.cleanUp()}catch(T){this.y.error(T)}}async download(T,R,r){const{location:v}=await this.$.download(T,R,!r);return v}async hb(T){if(T.scheme===O.Schemas.file)return{location:T,async cleanup(){}};this.y.trace("Downloading extension from",T.toString());const R=(0,h.$0f)(this.$.extensionsDownloadDir,(0,d.$6e)());return await this.db.download(T,R),this.y.info("Downloaded extension to",R.toString()),{location:R,cleanup:async()=>{try{await this.eb.del(R)}catch(v){this.y.error(v)}}}}S(){return this.C.defaultProfile.extensionsResource}U(T,R,r){if(g.URI.isUri(R))return new X(T,R,r,this.u,this.Y,this.w,this.C,this.bb,this.cb,this.y);const v=n.$go.create(R).toString();let z=this.ab.get(v);return z||(this.ab.set(v,z=new q(T,R,r,this.$,this.Y,this.w,this.C,this.bb,this.cb,this.y)),z.waitUntilTaskIsFinished().finally(()=>this.ab.delete(v))),z}W(T,R){return new Y(T,R.profileLocation,this.cb)}async lb(T){const R=async v=>{let z=await f.Promises.readdir(v);z=z.map(Z=>m.$ac(v,Z));const F=await Promise.all(z.map(Z=>f.Promises.stat(Z)));let J=Promise.resolve([]);return F.forEach((Z,oe)=>{const fe=z[oe];Z.isFile()&&(J=J.then(de=>[...de,fe])),Z.isDirectory()&&(J=J.then(de=>R(fe).then(ue=>[...de,...ue])))}),J};return(await R(T.location.fsPath)).map(v=>({path:`extension/${m.$cc(T.location.fsPath,v)}`,localPath:v}))}async mb({added:T,removed:R}){if(R)for(const r of R.extensions)this.y.info("Extensions removed from another source",r.id,R.profileLocation.toString()),this.p.fire({identifier:r,profileLocation:R.profileLocation});if(T){const v=(await this.Y.scanExtensions(1,T.profileLocation)).filter(z=>T.extensions.some(F=>(0,n.$fo)(F,z.identifier)));this.m.fire(v.map(z=>(this.y.info("Extensions added from another source",z.identifier.id,T.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:T.profileLocation,operation:1})))}}async ob(){this.B(this.Y.onExtract(R=>this.nb.add(R)));const T=await this.eb.resolve(this.bb.userExtensionsLocation);for(const R of T.children??[])R.isDirectory&&this.nb.add(R.resource);this.B(this.eb.watch(this.bb.userExtensionsLocation)),this.B(this.eb.onDidFilesChange(R=>this.pb(R)))}async pb(T){if(!T.affects(this.bb.userExtensionsLocation,1))return;const R=[];for(const r of T.rawAdded){if(this.nb.has(r)||!this.w.extUri.isEqual(this.w.extUri.dirname(r),this.bb.userExtensionsLocation)||this.w.extUri.isEqual(r,this.w.extUri.joinPath(this.bb.userExtensionsLocation,".obsolete"))||this.w.extUri.basename(r).startsWith(".")||!(await this.eb.stat(r)).isDirectory)continue;const v=await this.Y.scanUserExtensionAtLocation(r);v&&v.installedTimestamp===void 0&&(this.nb.add(r),R.push(v))}R.length&&(await this.qb(R.map(r=>[r,void 0]),this.C.defaultProfile.extensionsResource),this.y.info("Added extensions to default profile from external source",R.map(r=>r.identifier.id)))}async qb(T,R){const r=T.map(v=>v[0]);await this.rb(r),await this.cb.addExtensionsToProfile(T,R),this.m.fire(r.map(v=>({local:v,identifier:v.identifier,operation:1,profileLocation:R})))}async rb(T){const R=await this.Y.getUninstalledExtensions();for(const r of T){const v=n.$go.create(r);R[v.toString()]&&(this.y.trace("Removing the extension from uninstalled list:",v.id),await this.Y.setInstalled(v),this.y.info("Removed the extension from uninstalled list:",v.id))}}};e.$op=H,e.$op=H=pe([se(0,i.$Pn),se(1,ae.$Vk),se(2,le.$Ri),se(3,t.$xh),se(4,o.$dp),se(5,s.$_o),se(6,p.$un),se(7,x.$oh),se(8,ee.$Sj),se(9,te.$0i),se(10,ce.$pk),se(11,ie.$rk)],H);let C=class extends c.$lb{constructor(T,R,r,v,z,F){super(),this.j=T,this.k=R,this.l=r,this.m=v,this.n=z,this.p=F,this.h=this.B(new b.$8c),this.onExtract=this.h.event,this.c=(0,h.$0f)(this.l.userExtensionsLocation,".obsolete"),this.g=new M.$Cg}async cleanUp(){await this.C(),await this.z()}async scanExtensions(T,R){const r={includeInvalid:!0,profileLocation:R};let v=[];return T===null||T===0?v.push(...await this.l.scanAllExtensions({includeInvalid:!0},r,!1)):T===1&&v.push(...await this.l.scanUserExtensions(r)),v=T!==null?v.filter(z=>z.type===T):v,Promise.all(v.map(z=>this.y(z)))}async scanAllUserExtensions(T){const R=await this.l.scanUserExtensions({includeAllVersions:!T,includeInvalid:!0});return Promise.all(R.map(r=>this.y(r)))}async scanUserExtensionAtLocation(T){try{const R=await this.l.scanExistingExtension(T,1,{includeInvalid:!0});if(R)return await this.y(R)}catch(R){this.p.error(R)}return null}async extractUserExtension(T,R,r,v,z){const F=T.toString(),J=g.URI.file(m.$ac(this.l.userExtensionsLocation.fsPath,`.${(0,d.$6e)()}`)),Z=g.URI.file(m.$ac(this.l.userExtensionsLocation.fsPath,F));let oe=await this.k.exists(Z);if(oe&&v){try{await this.t(T.id,Z,"removeExisting")}catch{throw new i.$Qn($.localize(4,null,Z.fsPath,T.id),i.ExtensionManagementErrorCode.Delete)}oe=!1}if(!oe)try{try{this.p.trace(`Started extracting the extension from ${R} to ${Z.fsPath}`),await(0,P.$5o)(R,J.fsPath,{sourcePath:"extension",overwrite:!0},z),this.p.info(`Extracted extension to ${Z}:`,T.id)}catch(fe){let de=i.ExtensionManagementErrorCode.Extract;throw fe instanceof P.$3o&&(fe.type==="CorruptZip"?de=i.ExtensionManagementErrorCode.CorruptZip:fe.type==="Incomplete"&&(de=i.ExtensionManagementErrorCode.IncompleteZip)),new i.$Qn(fe.message,de)}await this.l.updateMetadata(J,r);try{this.p.trace(`Started renaming the extension from ${J.fsPath} to ${Z.fsPath}`),await this.v(J.fsPath,Z.fsPath),this.p.info("Renamed to",Z.fsPath)}catch(fe){if(fe.code==="ENOTEMPTY")this.p.info("Rename failed because extension was installed by another source. So ignoring renaming.",T.id);else throw this.p.info(`Rename failed because of ${(0,L.$9)(fe)}. Deleted from extracted location`,J),fe}this.h.fire(Z)}catch(fe){try{await this.k.del(J,{recursive:!0})}catch{}throw fe}return this.w(Z,1)}async scanMetadata(T,R){return R?(await this.s(T,R))?.metadata:this.l.scanMetadata(T.location)}async s(T,R){return(await this.m.scanProfileExtensions(R)).find(v=>(0,n.$fo)(v.identifier,T.identifier))}async updateMetadata(T,R,r){return r?await this.m.updateMetadata([[T,R]],r):await this.l.updateMetadata(T.location,R),this.w(T.location,T.type,r)}getUninstalledExtensions(){return this.u()}async setUninstalled(...T){const R=T.map(r=>n.$go.create(r));await this.u(r=>R.forEach(v=>{r[v.toString()]=!0,this.p.info("Marked extension as uninstalled",v.toString())}))}async setInstalled(T){await this.u(R=>delete R[T.toString()])}async removeExtension(T,R){if(this.n.extUri.isEqualOrParent(T.location,this.l.userExtensionsLocation))return this.t(T.identifier.id,T.location,R)}async removeUninstalledExtension(T){await this.removeExtension(T,"uninstalled"),await this.u(R=>delete R[n.$go.create(T).toString()])}async copyExtension(T,R,r,v){const z=await this.s(T,R),F=await this.s(T,r);return v={...z?.metadata,...v},F?await this.m.updateMetadata([[T,{...F.metadata,...v}]],r):await this.m.addExtensionsToProfile([[T,v]],r),this.w(T.location,T.type,r)}async copyExtensions(T,R){const r=await this.scanExtensions(1,T),v=await Promise.all(r.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,T)]));await this.m.addExtensionsToProfile(v,R)}async t(T,R,r){this.p.trace(`Deleting ${r} extension from disk`,T,R.fsPath);const v=this.n.extUri.joinPath(this.n.extUri.dirname(R),`${this.n.extUri.basename(R)}.${(0,u.$di)((0,d.$6e)()).toString(16)}${V}`);await this.v(R.fsPath,v.fsPath),await this.k.del(v,{recursive:!0}),this.p.info(`Deleted ${r} extension from disk`,T,R.fsPath)}async u(T){return this.g.queue(async()=>{let R;try{R=(await this.k.readFile(this.c,"utf8")).value.toString()}catch(v){if((0,ee.$9j)(v)!==1)throw v}let r={};if(R)try{r=JSON.parse(R)}catch{}return T&&(T(r),Object.keys(r).length?await this.k.writeFile(this.c,N.$Jb.fromString(JSON.stringify(r))):await this.k.del(this.c)),r})}async v(T,R){try{await f.Promises.rename(T,R,2*60*1e3)}catch(r){throw new i.$Qn(r.message||$.localize(5,null,T,R),r.code||i.ExtensionManagementErrorCode.Rename)}}async w(T,R,r){if(r){const z=(await this.l.scanUserExtensions({profileLocation:r})).find(F=>this.n.extUri.isEqual(F.location,T));if(z)return this.y(z)}else{const v=await this.l.scanExistingExtension(T,R,{includeInvalid:!0});if(v)return this.y(v)}throw new Error($.localize(6,null,T.path))}async y(T){const R=await this.k.resolve(T.location);let r,v;return R.children&&(r=R.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,v=R.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:T.identifier,type:T.type,isBuiltin:T.isBuiltin||!!T.metadata?.isBuiltin,location:T.location,manifest:T.manifest,targetPlatform:T.targetPlatform,validations:T.validations,isValid:T.isValid,readmeUrl:r,changelogUrl:v,publisherDisplayName:T.metadata?.publisherDisplayName||null,publisherId:T.metadata?.publisherId||null,isApplicationScoped:!!T.metadata?.isApplicationScoped,isMachineScoped:!!T.metadata?.isMachineScoped,isPreReleaseVersion:!!T.metadata?.isPreReleaseVersion,preRelease:!!T.metadata?.preRelease,installedTimestamp:T.metadata?.installedTimestamp,updated:!!T.metadata?.updated,pinned:!!T.metadata?.pinned}}async z(){const T=await this.getUninstalledExtensions();if(Object.keys(T).length===0){this.p.debug("No uninstalled extensions found.");return}this.p.debug("Removing uninstalled extensions:",Object.keys(T));const R=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),r=new Set;for(const z of R)T[n.$go.create(z).toString()]||r.add(z.identifier.id.toLowerCase());try{const z=(0,n.$lo)(R,F=>F.identifier);await M.Promises.settled(z.map(async F=>{const J=F.sort((Z,oe)=>S.rcompare(Z.manifest.version,oe.manifest.version))[0];r.has(J.identifier.id.toLowerCase())||await this.j(await this.y(J))}))}catch(z){this.p.error(z)}const v=R.filter(z=>z.metadata&&T[n.$go.create(z).toString()]);await Promise.allSettled(v.map(z=>this.removeUninstalledExtension(z)))}async C(){this.p.trace("ExtensionManagementService#removeTempDeleteFolders");let T;try{T=await this.k.resolve(this.l.userExtensionsLocation)}catch(R){(0,ee.$9j)(R)!==1&&this.p.error(R);return}if(T?.children)try{await Promise.allSettled(T.children.map(async R=>{if(!(!R.isDirectory||!R.name.endsWith(V))){this.p.trace("Deleting the temporarily deleted folder",R.resource.toString());try{await this.k.del(R.resource,{recursive:!0}),this.p.trace("Deleted the temporarily deleted folder",R.resource.toString())}catch(r){(0,ee.$9j)(r)!==1&&this.p.error(r)}}}))}catch{}}};e.$pp=C,e.$pp=C=pe([se(1,ee.$Sj),se(2,o.$dp),se(3,s.$_o),se(4,ce.$pk),se(5,le.$Ri)],C);class U extends a.$0o{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,y.$qe)(this.m.operation)?this.l:this.m.operation}constructor(T,R,r,v,z,F,J,Z,oe){super(),this.identifier=T,this.source=R,this.m=r,this.n=v,this.o=z,this.p=F,this.q=J,this.s=Z,this.t=oe,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h(T){const[R,r]=await this.y(T);return this.j=R.isBuiltin||R.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[R,r]],this.j),R}async v({zipPath:T,key:R,metadata:r},v,z){let F=await this.w(R);return F||(this.t.trace("Extracting extension...",R.id),F=await this.n.extractUserExtension(R,T,r,v,z),this.t.info("Extracting extension completed.",R.id)),F}async w(T){return await this.x(T)?(this.t.trace("Removing the extension from uninstalled list:",T.id),await this.n.setInstalled(T),this.t.info("Removed the extension from uninstalled list:",T.id),(await this.n.scanAllUserExtensions(!0)).find(v=>n.$go.create(v).equals(T))):void 0}async x(T){return!!(await this.n.getUninstalledExtensions())[T.toString()]}}class q extends U{constructor(T,R,r,v,z,F,J,Z,oe,fe){super(R.identifier,R,r,z,F,J,Z,oe,fe),this.z=R,this.A=v}async y(T){const r=(await this.n.scanExtensions(null,this.m.profileLocation)).find(J=>(0,n.$fo)(J.identifier,this.z.identifier));r&&(this.l=3);const v={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||r?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||r?.isMachineScoped,isBuiltin:this.m.isBuiltin||r?.isBuiltin,isSystem:r?.type===0?!0:void 0,updated:!!r,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,y.$pe)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:r?.preRelease)};if(r?.manifest.version===this.z.version)return[await this.n.updateMetadata(r,v),v];const{location:z,verificationStatus:F}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=F,this.C(z.fsPath),[await this.v({zipPath:z.fsPath,key:n.$go.create(this.z),metadata:v},!1,T),v]}catch(J){try{await this.A.delete(z)}catch(Z){this.t.warn("Error while deleting the downloaded file",z.toString(),(0,L.$9)(Z))}throw J}}async C(T){try{await(0,E.$kp)(T)}catch(R){throw new i.$Qn((0,a.$8o)(R).message,i.ExtensionManagementErrorCode.Invalid)}}}e.$qp=q;class X extends U{constructor(T,R,r,v,z,F,J,Z,oe,fe){super({id:(0,n.$ko)(T.publisher,T.name)},R,r,z,F,J,Z,oe,fe),this.z=T,this.A=R,this.B=v}async h(T){const R=await super.h(T);return this.E(R,T),R}async y(T){const R=new n.$go(this.identifier,this.z.version),v=(await this.n.scanExtensions(1,this.m.profileLocation)).find(J=>(0,n.$fo)(this.identifier,J.identifier)),z={isApplicationScoped:this.m.isApplicationScoped||v?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||v?.isMachineScoped,isBuiltin:this.m.isBuiltin||v?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(v)if(this.l=3,R.equals(new n.$go(v.identifier,v.manifest.version)))try{await this.n.removeExtension(v,"existing")}catch{throw new Error($.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&S.gt(v.manifest.version,this.z.version)&&await this.n.setUninstalled(v);else{const J=await this.w(R);if(J)try{await this.n.removeExtension(J,"existing")}catch{throw new Error($.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:m.$bc(this.A.fsPath),key:R,metadata:z},!0,T),z]}async E(T,R){try{let[r]=await this.B.getExtensions([{id:T.identifier.id,version:T.manifest.version}],R);if(r||([r]=await this.B.getExtensions([{id:T.identifier.id}],R)),r){const v={id:r.identifier.uuid,publisherDisplayName:r.publisherDisplayName,publisherId:r.publisherId,isPreReleaseVersion:r.properties.isPreReleaseVersion,preRelease:r.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata(T,v,this.m.profileLocation)}}catch{}}}class Y extends a.$0o{constructor(T,R,r){super(),this.extension=T,this.j=R,this.k=r}async h(T){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,137,8,14,9,3,25,18,138,6,45,136,176]),function(G,e,M,N,D,A,L,b,u,c,w,O,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=void 0;let S=class extends O.$zo{constructor(f,P,$,p){super(p),this.j=f,this.k=P,this.l=$,this.m(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const f=this.j.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,P){const{f:$,g:p}=this;let t;try{t=await(0,c.$yl)(this.j,this.l,this.k.args,process.env)}catch(n){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,A.$9)(n)))}const a={...process.env,...t},i=f.agent?f.agent:await(0,m.$Cq)(f.url||"",a,{proxyUrl:$,strictSSL:p});return f.agent=i,f.strictSSL=p,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>g(f,P))}async resolveProxy(f){}};e.$Dq=S,e.$Dq=S=pe([se(0,b.$Vh),se(1,u.$xh),se(2,w.$Ri),se(3,w.$Si)],S);async function y(d){return((0,M.parse)(d.url).protocol==="https:"?await new Promise(($,p)=>{G(["https"],$,p)}):await new Promise(($,p)=>{G(["http"],$,p)})).request}async function g(d,f){return N.Promises.withAsyncBody(async(P,$)=>{const p=(0,M.parse)(d.url),t=d.getRawRequest?d.getRawRequest(d):await y(d),a={hostname:p.hostname,port:p.port?parseInt(p.port):p.protocol==="https:"?443:80,protocol:p.protocol,path:p.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,L.$pe)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(a.auth=d.user+":"+d.password);const i=t(a,n=>{const s=(0,L.$ne)(d.followRedirects)?d.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)g({...d,url:n.headers.location,followRedirects:s-1},f).then(P,$);else{let o=n;!d.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,h.createGunzip)())),P({res:n,stream:(0,D.$Yb)(o)})}});i.on("error",$),d.timeout&&i.setTimeout(d.timeout),d.isChromiumNetwork&&i.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&i.write(d.data),i.end(),f.onCancellationRequested(()=>{i.abort(),$(new A.$3)})})}e.$Eq=g}),define(ne[177],re([0,1,32,8,33,9,2,15,16,13,34,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,31,45,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(G,e,M,N,D,A,L,b,u,c,w,O,m,h,S,y,g,d,f,P,$,p,t,a,i,n,s,o,l,I,E,k,j,W,ee,x,le,te,ae,ce,ie,V,H,C,U,q,X,Y,K,T,R,r,v,z,F,J,Z,oe,fe,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ue extends L.$lb{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,be]=await this.f();return he.invokeFunction(async Ee=>{const je=Ee.get(x.$Ri),Te=Ee.get(o.$Sj),B=Ee.get(d.$xh),Q=Ee.get(v.$rk);je.info("CLI main",this.b),this.g(je),await this.h(B,Te,Q,he),await Promise.all(be.map(_=>{(0,N.$ng)(_.flush(),1e3)}))})}async f(){const he=new j.$nh,be={_serviceBrand:void 0,...ce.default};he.set(ie.$0i,be);const Ee=new f.$Xl(this.b,be);he.set(d.$xh,Ee),await Promise.all([Ee.appSettingsHome.fsPath,Ee.extensionsPath].map(De=>De?m.Promises.mkdir(De,{recursive:!0}):void 0));const je=new oe.$QM((0,x.$6i)(Ee),Ee.logsHome);he.set(x.$Si,je);const Te=this.B(je.createLogger("cli",{name:(0,fe.localize)(0,null)})),B=[];je.getLogLevel()===x.LogLevel.Trace&&B.push(new x.$Zi(je.getLogLevel()));const Q=this.B(new Z.$1M(Te,B));he.set(x.$Ri,Q);const _=this.B(new l.$sp(Q));he.set(o.$Sj,_);const $e=this.B(new I.$Rp(Q));_.registerProvider(b.Schemas.file,$e),_.registerProvider(b.Schemas.vscodeUserData,new de.$b5b(b.Schemas.file,$e,b.Schemas.vscodeUserData,Q));const we=new r.$cr(_);he.set(R.$pk,we);const Re=new C.$UM(1,Ee,Q,_),ke=new z.$WM(Re,we,Ee,_,Q);he.set(v.$rk,ke);const Ae=c.$i&&be.win32RegValueName?this.B(new ae.$_4b(Q,be.win32RegValueName)):Ee.policyFile?this.B(new le.$a5b(Ee.policyFile,_,Q)):new te.$Xm;he.set(te.$Vm,Ae);const Pe=this.B(new S.$ln(ke.defaultProfile.settingsResource,_,Ae,Q));he.set(h.$Vh,Pe),await Promise.all([Re.init(),Pe.initialize()]);let Le;try{Le=await(0,F.$T4b)(Re,Q)}catch(De){De.code!=="ENOENT"&&Q.error(De)}ke.init(),he.set(R.$pk,new r.$cr(_));const ze=new H.$Dq(Pe,Ee,Q,je);he.set(V.$yo,ze),he.set(y.$un,new E.$mh(g.$dN,void 0,!0)),he.set(a.$_o,new E.$mh(J.$ZM,void 0,!0)),he.set(i.$dp,new E.$mh(s.$Q4b,void 0,!0)),he.set(p.$Vo,new E.$mh(p.$Wo,void 0,!0)),he.set(n.$np,new E.$mh(n.$op,void 0,!0)),he.set($.$Pn,new E.$mh(P.$Uo,void 0,!0)),he.set(W.$xq,new E.$mh(ee.$zq,void 0,!1));const Ie=[],Ne=(0,Y.$co)(be,Pe);if((0,Y.$0n)(be,Ee)){be.aiConfig&&be.aiConfig.ariaKey&&Ie.push(new K.$OM(ze,Ne,"monacoworkbench",null,be.aiConfig.ariaKey));const De={appenders:Ie,sendErrorTelemetry:!1,commonProperties:(0,U.$Zn)((0,M.release)(),(0,M.hostname)(),process.arch,be.commit,be.version,Le,Ne),piiPaths:(0,Y.$do)(Ee)};he.set(q.$Vk,new E.$mh(X.$Fq,[De],!1))}else he.set(q.$Vk,Y.$4n);return[new k.$Up(he),Ie]}g(he){(0,A.setUnexpectedErrorHandler)(be=>{const Ee=(0,D.$ai)(be,!0);Ee&&he.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",be=>{(0,A.$X)(be)||(0,A.$Y)(be)}),process.on("unhandledRejection",be=>(0,A.$Y)(be))}async h(he,be,Ee,je){let Te;if(he.args.profile&&(Te=Ee.profiles.find(Q=>Q.name===he.args.profile),!Te))throw new Error(`Profile '${he.args.profile}' not found.`);const B=(Te??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return je.createInstance(t.$Xo,new x.$Zi(x.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,B);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Q={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:B};return je.createInstance(t.$Xo,new x.$Zi(x.LogLevel.Info,!1)).installExtensions(this.i(this.b["install-extension"]||[]),this.i(this.b["install-builtin-extension"]||[]),Q,!!this.b.force)}else{if(this.b["uninstall-extension"])return je.createInstance(t.$Xo,new x.$Zi(x.LogLevel.Info,!1)).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,B);if(this.b["locate-extension"])return je.createInstance(t.$Xo,new x.$Zi(x.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,T.$x5b)(he.appRoot,he.extensionsPath))}}i(he){return he.map(be=>/\.vsix$/i.test(be)?O.URI.file((0,u.$_b)(be)?be:(0,u.$ac)((0,w.cwd)(),be)):be)}}async function ge(me){const he=new ue(me);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/93d3731736cc6fefbd63810d5fb2d57bedc84ca0/core/vs/code/node/cliProcessMain.js.map
