/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/base/common/types","vs/nls","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/network","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/amd","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","stream","util","path","graceful-fs","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(ne){for(var e=[],I=0,T=ne.length;I<T;I++)e[I]=oe[ne[I]];return e};define(oe[122],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class I{static get(){const O=new Map,j=new Map,L=new Map,P=new Map;function S(h,d){h.has(d.detail)||h.set(d.detail,-d.timestamp)}function b(h,d){const v=h.get(d.detail);v&&(v>=0||h.set(d.detail,v+d.timestamp))}let C=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(C=ne.getStats().slice(0).sort((h,d)=>h.timestamp-d.timestamp));for(const h of C)switch(h.type){case 10:S(O,h);break;case 11:case 12:b(O,h);break;case 21:S(j,h);break;case 22:b(j,h);break;case 33:S(L,h);break;case 34:b(L,h);break;case 31:S(P,h);break;case 32:b(P,h);break}let E=0;L.forEach(h=>E+=h);function m(h){const d=[];return h.forEach((v,c)=>d.push([c,v])),d}return{amdLoad:m(O),amdInvoke:m(j),nodeRequire:m(L),nodeEval:m(P),nodeRequireTotal:E}}static toMarkdownTable(O,j){let L="";const P=[];return O.forEach((S,b)=>{P[b]=S.length}),j.forEach(S=>{S.forEach((b,C)=>{typeof b>"u"&&(b=S[C]="-");const E=b.toString().length;P[C]=Math.max(E,P[C])})}),O.forEach((S,b)=>{L+=`| ${S+" ".repeat(P[b]-S.toString().length)} `}),L+=`|
`,O.forEach((S,b)=>{L+=`| ${"-".repeat(P[b])} `}),L+=`|
`,j.forEach(S=>{S.forEach((b,C)=>{typeof b<"u"&&(L+=`| ${b+" ".repeat(P[C]-b.toString().length)} `)}),L+=`|
`}),L}}e.$S=I}),define(oe[81],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.$Ug=e.$Tg=void 0;function I(L){return(P,S,b)=>{let C=null,E=null;if(typeof b.value=="function"?(C="value",E=b.value):typeof b.get=="function"&&(C="get",E=b.get),!E)throw new Error("not supported");b[C]=L(E,S)}}function T(L,P,S){let b=null,C=null;if(typeof S.value=="function"?(b="value",C=S.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(b="get",C=S.get),!C)throw new Error("not supported");const E=`$memoize$${P}`;S[b]=function(...m){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,m)}),this[E]}}e.$Tg=T;function O(L,P,S){return I((b,C)=>{const E=`$debounce$${C}`,m=`$debounce$result$${C}`;return function(...h){this[m]||(this[m]=S?S():void 0),clearTimeout(this[E]),P&&(this[m]=P(this[m],...h),h=[this[m]]),this[E]=setTimeout(()=>{b.apply(this,h),this[m]=S?S():void 0},L)}})}e.$Ug=O;function j(L,P,S){return I((b,C)=>{const E=`$throttle$timer$${C}`,m=`$throttle$result$${C}`,h=`$throttle$lastRun$${C}`,d=`$throttle$pending$${C}`;return function(...v){if(this[m]||(this[m]=S?S():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),P&&(this[m]=P(this[m],...v)),this[d])return;const c=this[h]+L;c<=Date.now()?(this[h]=Date.now(),b.apply(this,[this[m]]),this[m]=S?S():void 0):(this[d]=!0,this[E]=setTimeout(()=>{this[d]=!1,this[h]=Date.now(),b.apply(this,[this[m]]),this[m]=S?S():void 0},c-Date.now()))}})}e.$Vg=j}),define(oe[7],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class I{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?p.isErrorNoTelemetry(o)?new p(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(n=>{n(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.$U=I,e.$V=new I;function T(t){e.$V.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=T;function O(t){if(!t||typeof t!="object")return!1;const o=t;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.$X=O;function j(t){b(t)||e.$V.onUnexpectedError(t)}e.$Y=j;function L(t){b(t)||e.$V.onUnexpectedExternalError(t)}e.$Z=L;function P(t){if(t instanceof Error){const{name:o,message:n}=t,s=t.stacktrace||t.stack;return{$isError:!0,name:o,message:n,stack:s,noTelemetry:p.isErrorNoTelemetry(t)}}return t}e.$1=P;const S="Canceled";function b(t){return t instanceof C?!0:t instanceof Error&&t.name===S&&t.message===S}e.$2=b;class C extends Error{constructor(){super(S),this.name=this.message}}e.$3=C;function E(){const t=new Error(S);return t.name=t.message,t}e.$4=E;function m(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.$5=m;function h(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.$6=h;function d(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.$7=d;function v(t){const o=new Error(`${t} has been disposed`);return o.name="DISPOSED",o}e.$8=v;function c(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.$9=c;class l extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.$0=l;class u extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.$$=u;class y extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=y;class p extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof p)return o;const n=new p;return n.message=o.message,n.stack=o.stack,n}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.$ab=p;class R extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,R.prototype)}}e.$bb=R}),define(oe[21],ae([0,1,7]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.CompareResult=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.top=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=void 0;function T(H,ee=0){return H[H.length-(1+ee)]}e.$_e=T;function O(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.$af=O;function j(H,ee,ie=(le,he)=>le===he){if(H===ee)return!0;if(!H||!ee||H.length!==ee.length)return!1;for(let le=0,he=H.length;le<he;le++)if(!ie(H[le],ee[le]))return!1;return!0}e.$bf=j;function L(H,ee){const ie=H.length-1;ee<ie&&(H[ee]=H[ie]),H.pop()}e.$cf=L;function P(H,ee,ie){return S(H.length,le=>ie(H[le],ee))}e.$df=P;function S(H,ee){let ie=0,le=H-1;for(;ie<=le;){const he=(ie+le)/2|0,me=ee(he);if(me<0)ie=he+1;else if(me>0)le=he-1;else return he}return-(ie+1)}e.$ef=S;function b(H,ee){let ie=0,le=H.length;if(le===0)return 0;for(;ie<le;){const he=Math.floor((ie+le)/2);ee(H[he])?le=he:ie=he+1}return ie}e.$ff=b;function C(H,ee,ie){if(H=H|0,H>=ee.length)throw new TypeError("invalid index");const le=ee[Math.floor(ee.length*Math.random())],he=[],me=[],be=[];for(const ke of ee){const Pe=ie(ke,le);Pe<0?he.push(ke):Pe>0?me.push(ke):be.push(ke)}return H<he.length?C(H,he,ie):H<he.length+be.length?be[0]:C(H-(he.length+be.length),me,ie)}e.$gf=C;function E(H,ee){const ie=[];let le;for(const he of H.slice(0).sort(ee))!le||ee(le[0],he)!==0?(le=[he],ie.push(le)):le.push(he);return ie}e.$hf=E;function m(H,ee,ie){const le=[];function he(ke,Pe,je){if(Pe===0&&je.length===0)return;const De=le[le.length-1];De&&De.start+De.deleteCount===ke?(De.deleteCount+=Pe,De.toInsert.push(...je)):le.push({start:ke,deleteCount:Pe,toInsert:je})}let me=0,be=0;for(;;){if(me===H.length){he(me,0,ee.slice(be));break}if(be===ee.length){he(me,H.length-me,[]);break}const ke=H[me],Pe=ee[be],je=ie(ke,Pe);je===0?(me+=1,be+=1):je<0?(he(me,1,[]),me+=1):je>0&&(he(me,0,[Pe]),be+=1)}return le}e.$if=m;function h(H,ee,ie){const le=m(H,ee,ie),he=[],me=[];for(const be of le)he.push(...H.slice(be.start,be.start+be.deleteCount)),me.push(...be.toInsert);return{removed:he,added:me}}e.$jf=h;function d(H,ee,ie){if(ie===0)return[];const le=H.slice(0,ie).sort(ee);return c(H,ee,le,ie,H.length),le}e.top=d;function v(H,ee,ie,le,he){return ie===0?Promise.resolve([]):new Promise((me,be)=>{(async()=>{const ke=H.length,Pe=H.slice(0,ie).sort(ee);for(let je=ie,De=Math.min(ie+le,ke);je<ke;je=De,De=Math.min(De+le,ke)){if(je>ie&&await new Promise(We=>setTimeout(We)),he&&he.isCancellationRequested)throw new I.$3;c(H,ee,Pe,je,De)}return Pe})().then(me,be)})}e.$lf=v;function c(H,ee,ie,le,he){for(const me=ie.length;le<he;le++){const be=H[le];if(ee(be,ie[me-1])<0){ie.pop();const ke=b(ie,Pe=>ee(be,Pe)<0);ie.splice(ke,0,be)}}}function l(H){return H.filter(ee=>!!ee)}e.$mf=l;function u(H){let ee=0;for(let ie=0;ie<H.length;ie++)H[ie]&&(H[ee]=H[ie],ee+=1);H.length=ee}e.$nf=u;function y(H,ee,ie){H.splice(ie,0,H.splice(ee,1)[0])}e.$of=y;function p(H){return!Array.isArray(H)||H.length===0}e.$pf=p;function R(H){return Array.isArray(H)&&H.length>0}e.$qf=R;function t(H,ee=ie=>ie){const ie=new Set;return H.filter(le=>{const he=ee(le);return ie.has(he)?!1:(ie.add(he),!0)})}e.$rf=t;function o(H){const ee=new Set;return ie=>{const le=H(ie);return ee.has(le)?!1:(ee.add(le),!0)}}e.$sf=o;function n(H,ee){const ie=s(H,ee);if(ie!==-1)return H[ie]}e.$tf=n;function s(H,ee){for(let ie=H.length-1;ie>=0;ie--){const le=H[ie];if(ee(le))return ie}return-1}e.$uf=s;function i(H,ee){return H.length>0?H[0]:ee}e.$vf=i;function r(H,ee){return H.length>0?H[H.length-1]:ee}e.$wf=r;function a(H,ee,ie=(le,he)=>le===he){let le=0;for(let he=0,me=Math.min(H.length,ee.length);he<me&&ie(H[he],ee[he]);he++)le++;return le}e.$xf=a;function w(H){return[].concat(...H)}e.$yf=w;function g(H,ee){let ie=typeof ee=="number"?H:0;typeof ee=="number"?ie=H:(ie=0,ee=H);const le=[];if(ie<=ee)for(let he=ie;he<ee;he++)le.push(he);else for(let he=ie;he>ee;he--)le.push(he);return le}e.$zf=g;function f(H,ee,ie){return H.reduce((le,he)=>(le[ee(he)]=ie?ie(he):he,le),Object.create(null))}e.$Af=f;function k(H,ee){return H.push(ee),()=>A(H,ee)}e.$Bf=k;function A(H,ee){const ie=H.indexOf(ee);if(ie>-1)return H.splice(ie,1),ee}e.$Cf=A;function M(H,ee,ie){const le=H.slice(0,ee),he=H.slice(ee);return le.concat(ie,he)}e.$Df=M;function F(H,ee){let ie;if(typeof ee=="number"){let le=ee;ie=()=>{const he=Math.sin(le++)*179426549;return he-Math.floor(he)}}else ie=Math.random;for(let le=H.length-1;le>0;le-=1){const he=Math.floor(ie()*(le+1)),me=H[le];H[le]=H[he],H[he]=me}}e.$Ef=F;function V(H,ee){const ie=H.indexOf(ee);ie>-1&&(H.splice(ie,1),H.unshift(ee))}e.$Ff=V;function B(H,ee){const ie=H.indexOf(ee);ie>-1&&(H.splice(ie,1),H.push(ee))}e.$Gf=B;function x(H,ee){for(const ie of ee)H.push(ie)}e.$Hf=x;function Z(H,ee){return Array.isArray(H)?H.map(ee):ee(H)}e.$If=Z;function Q(H){return Array.isArray(H)?H:[H]}e.$Jf=Q;function J(H){return H[Math.floor(Math.random()*H.length)]}e.$Kf=J;function X(H,ee){for(const ie of H){const le=ee(ie);if(le!==void 0)return le}}e.$Lf=X;function W(H,ee,ie){const le=q(H,ee),he=H.length,me=ie.length;H.length=he+me;for(let be=he-1;be>=le;be--)H[be+me]=H[be];for(let be=0;be<me;be++)H[be+le]=ie[be]}e.$Mf=W;function U(H,ee,ie,le){const he=q(H,ee),me=H.splice(he,ie);return W(H,he,le),me}e.$Nf=U;function q(H,ee){return ee<0?Math.max(ee+H.length,0):Math.min(ee,H.length)}var te;(function(H){function ee(he){return he<0}H.isLessThan=ee;function ie(he){return he>0}H.isGreaterThan=ie;function le(he){return he===0}H.isNeitherLessOrGreaterThan=le,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(te||(e.CompareResult=te={}));function re(H,ee){return(ie,le)=>ee(H(ie),H(le))}e.$Of=re;function ce(...H){return(ee,ie)=>{for(const le of H){const he=le(ee,ie);if(!te.isNeitherLessOrGreaterThan(he))return he}return te.neitherLessOrGreaterThan}}e.$Pf=ce;const G=(H,ee)=>H-ee;e.$Qf=G;function N(H){return(ee,ie)=>-H(ee,ie)}e.$Rf=N;function $(H,ee){if(H.length===0)return;let ie=H[0];for(let le=1;le<H.length;le++){const he=H[le];ee(he,ie)>0&&(ie=he)}return ie}e.$Sf=$;function D(H,ee){if(H.length===0)return;let ie=H[0];for(let le=1;le<H.length;le++){const he=H[le];ee(he,ie)>=0&&(ie=he)}return ie}e.$Tf=D;function z(H,ee){return $(H,(ie,le)=>-ee(ie,le))}e.$Uf=z;class K{constructor(ee){this.f=ee,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let ie=this.c;for(;ie<this.f.length&&ee(this.f[ie]);)ie++;const le=ie===this.c?null:this.f.slice(this.c,ie);return this.c=ie,le}takeFromEndWhile(ee){let ie=this.d;for(;ie>=0&&ee(this.f[ie]);)ie--;const le=ie===this.d?null:this.f.slice(ie+1,this.d+1);return this.d=ie,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ee=this.f[this.c];return this.c++,ee}removeLast(){const ee=this.f[this.d];return this.d--,ee}takeCount(ee){const ie=this.f.slice(this.c,this.c+ee);return this.c+=ee,ie}}e.$Vf=K;class _{static{this.empty=new _(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(ie=>(ee(ie),!0))}toArray(){const ee=[];return this.iterate(ie=>(ee.push(ie),!0)),ee}filter(ee){return new _(ie=>this.iterate(le=>ee(le)?ie(le):!0))}map(ee){return new _(ie=>this.iterate(le=>ie(ee(le))))}some(ee){let ie=!1;return this.iterate(le=>(ie=ee(le),!ie)),ie}findFirst(ee){let ie;return this.iterate(le=>ee(le)?(ie=le,!1):!0),ie}findLast(ee){let ie;return this.iterate(le=>(ee(le)&&(ie=le),!0)),ie}findLastMaxBy(ee){let ie,le=!0;return this.iterate(he=>((le||te.isGreaterThan(ee(he,ie)))&&(le=!1,ie=he),!0)),ie}}e.$Wf=_}),define(oe[123],ae([0,1,7]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qc=e.$pc=e.$oc=e.$nc=e.ok=void 0;function T(S,b){if(!S)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=T;function O(S,b="Unreachable"){throw new Error(b)}e.$nc=O;function j(S){if(!S)throw new I.$bb("Assertion Failed")}e.$oc=j;function L(S){if(!S()){debugger;S(),(0,I.$Y)(new I.$bb("Assertion Failed"))}}e.$pc=L;function P(S,b){let C=0;for(;C<S.length-1;){const E=S[C],m=S[C+1];if(!b(E,m))return!1;C++}return!0}e.$qc=P}),define(oe[82],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function I(T){const O=this;let j=!1,L;return function(){return j||(j=!0,L=T.apply(O,arguments)),L}}e.$cb=I}),define(oe[59],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(T){function O(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}T.is=O;const j=Object.freeze([]);function L(){return j}T.empty=L;function*P(p){yield p}T.single=P;function S(p){return O(p)?p:P(p)}T.wrap=S;function b(p){return p||j}T.from=b;function C(p){return!p||p[Symbol.iterator]().next().done===!0}T.isEmpty=C;function E(p){return p[Symbol.iterator]().next().value}T.first=E;function m(p,R){for(const t of p)if(R(t))return!0;return!1}T.some=m;function h(p,R){for(const t of p)if(R(t))return t}T.find=h;function*d(p,R){for(const t of p)R(t)&&(yield t)}T.filter=d;function*v(p,R){let t=0;for(const o of p)yield R(o,t++)}T.map=v;function*c(...p){for(const R of p)for(const t of R)yield t}T.concat=c;function l(p,R,t){let o=t;for(const n of p)o=R(o,n);return o}T.reduce=l;function*u(p,R,t=p.length){for(R<0&&(R+=p.length),t<0?t+=p.length:t>p.length&&(t=p.length);R<t;R++)yield p[R]}T.slice=u;function y(p,R=Number.POSITIVE_INFINITY){const t=[];if(R===0)return[t,p];const o=p[Symbol.iterator]();for(let n=0;n<R;n++){const s=o.next();if(s.done)return[t,T.empty()];t.push(s.value)}return[t,{[Symbol.iterator](){return o}}]}T.consume=y})(I||(e.Iterable=I={}))}),define(oe[34],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var O;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(O||(e.ParseErrorCode=O={}));var j;(function(t){t.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function L(t,o=!1){let n=0;const s=t.length;let i="",r=0,a=16,w=0;function g(B){let x=0,Z=0;for(;x<B;){const Q=t.charCodeAt(n);if(Q>=48&&Q<=57)Z=Z*16+Q-48;else if(Q>=65&&Q<=70)Z=Z*16+Q-65+10;else if(Q>=97&&Q<=102)Z=Z*16+Q-97+10;else break;n++,x++}return x<B&&(Z=-1),Z}function f(B){n=B,i="",r=0,a=16,w=0}function k(){const B=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&b(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&b(t.charCodeAt(n)))for(n++;n<t.length&&b(t.charCodeAt(n));)n++;else return w=3,t.substring(B,n);let x=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&b(t.charCodeAt(n))){for(n++;n<t.length&&b(t.charCodeAt(n));)n++;x=n}else w=3;return t.substring(B,x)}function A(){let B="",x=n;for(;;){if(n>=s){B+=t.substring(x,n),w=2;break}const Z=t.charCodeAt(n);if(Z===34){B+=t.substring(x,n),n++;break}if(Z===92){if(B+=t.substring(x,n),n++,n>=s){w=2;break}switch(t.charCodeAt(n++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const J=g(4);J>=0?B+=String.fromCharCode(J):w=4;break}default:w=5}x=n;continue}if(Z>=0&&Z<=31)if(S(Z)){B+=t.substring(x,n),w=2;break}else w=6;n++}return B}function M(){if(i="",w=0,r=n,n>=s)return r=s,a=17;let B=t.charCodeAt(n);if(P(B)){do n++,i+=String.fromCharCode(B),B=t.charCodeAt(n);while(P(B));return a=15}if(S(B))return n++,i+=String.fromCharCode(B),B===13&&t.charCodeAt(n)===10&&(n++,i+=`
`),a=14;switch(B){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,i=A(),a=10;case 47:{const x=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!S(t.charCodeAt(n));)n++;return i=t.substring(x,n),a=12}if(t.charCodeAt(n+1)===42){n+=2;const Z=s-1;let Q=!1;for(;n<Z;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,Q=!0;break}n++}return Q||(n++,w=1),i=t.substring(x,n),a=13}return i+=String.fromCharCode(B),n++,a=16}case 45:if(i+=String.fromCharCode(B),n++,n===s||!b(t.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=k(),a=11;default:for(;n<s&&F(B);)n++,B=t.charCodeAt(n);if(r!==n){switch(i=t.substring(r,n),i){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return i+=String.fromCharCode(B),n++,a=16}}function F(B){if(P(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let B;do B=M();while(B>=12&&B<=15);return B}return{setPosition:f,getPosition:()=>n,scan:o?V:M,getToken:()=>a,getTokenValue:()=>i,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>w}}e.$vm=L;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function E(t,o){const n=[],s=new Object;let i;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function w(g,f,k,A){r.value=g,r.offset=f,r.length=k,r.type=A,r.colonOffset=void 0,i=r}try{y(t,{onObjectBegin:(g,f)=>{if(o<=g)throw s;i=void 0,a=o>g,n.push("")},onObjectProperty:(g,f,k)=>{if(o<f||(w(g,f,k,"property"),n[n.length-1]=g,o<=f+k))throw s},onObjectEnd:(g,f)=>{if(o<=g)throw s;i=void 0,n.pop()},onArrayBegin:(g,f)=>{if(o<=g)throw s;i=void 0,n.push(0)},onArrayEnd:(g,f)=>{if(o<=g)throw s;i=void 0,n.pop()},onLiteralValue:(g,f,k)=>{if(o<f||(w(g,f,k,R(g)),o<=f+k))throw s},onSeparator:(g,f,k)=>{if(o<=f)throw s;if(g===":"&&i&&i.type==="property")i.colonOffset=f,a=!1,i=void 0;else if(g===","){const A=n[n.length-1];typeof A=="number"?n[n.length-1]=A+1:(a=!0,n[n.length-1]=""),i=void 0}}})}catch(g){if(g!==s)throw g}return{path:n,previousNode:i,isAtPropertyKey:a,matches:g=>{let f=0;for(let k=0;f<g.length&&k<n.length;k++)if(g[f]===n[k]||g[f]==="*")f++;else if(g[f]!=="**")return!1;return f===g.length}}}e.$wm=E;function m(t,o=[],n=j.DEFAULT){let s=null,i=[];const r=[];function a(g){Array.isArray(i)?i.push(g):s!==null&&(i[s]=g)}return y(t,{onObjectBegin:()=>{const g={};a(g),r.push(i),i=g,s=null},onObjectProperty:g=>{s=g},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const g=[];a(g),r.push(i),i=g,s=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:a,onError:(g,f,k)=>{o.push({error:g,offset:f,length:k})}},n),i[0]}e.$xm=m;function h(t,o=[],n=j.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(g){s.type==="property"&&(s.length=g-s.offset,s=s.parent)}function r(g){return s.children.push(g),g}y(t,{onObjectBegin:g=>{s=r({type:"object",offset:g,length:-1,parent:s,children:[]})},onObjectProperty:(g,f,k)=>{s=r({type:"property",offset:f,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:g,offset:f,length:k,parent:s})},onObjectEnd:(g,f)=>{s.length=g+f-s.offset,s=s.parent,i(g+f)},onArrayBegin:(g,f)=>{s=r({type:"array",offset:g,length:-1,parent:s,children:[]})},onArrayEnd:(g,f)=>{s.length=g+f-s.offset,s=s.parent,i(g+f)},onLiteralValue:(g,f,k)=>{r({type:R(g),offset:f,length:k,parent:s,value:g}),i(f+k)},onSeparator:(g,f,k)=>{s.type==="property"&&(g===":"?s.colonOffset=f:g===","&&i(f))},onError:(g,f,k)=>{o.push({error:g,offset:f,length:k})}},n);const w=s.children[0];return w&&delete w.parent,w}e.$ym=h;function d(t,o){if(!t)return;let n=t;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],i=!0;break}if(!i)return}else{const i=s;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}e.$zm=d;function v(t){if(!t.parent||!t.parent.children)return[];const o=v(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;o.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&o.push(n)}return o}e.$Am=v;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const o=Object.create(null);for(const n of t.children){const s=n.children[1];s&&(o[n.children[0].value]=c(s))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Bm=c;function l(t,o,n=!1){return o>=t.offset&&o<t.offset+t.length||n&&o===t.offset+t.length}e.$Cm=l;function u(t,o,n=!1){if(l(t,o,n)){const s=t.children;if(Array.isArray(s))for(let i=0;i<s.length&&s[i].offset<=o;i++){const r=u(s[i],o,n);if(r)return r}return t}}e.$Dm=u;function y(t,o,n=j.DEFAULT){const s=L(t,!1);function i(re){return re?()=>re(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(re){return re?ce=>re(ce,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=i(o.onObjectBegin),w=r(o.onObjectProperty),g=i(o.onObjectEnd),f=i(o.onArrayBegin),k=i(o.onArrayEnd),A=r(o.onLiteralValue),M=r(o.onSeparator),F=i(o.onComment),V=r(o.onError),B=n&&n.disallowComments,x=n&&n.allowTrailingComma;function Z(){for(;;){const re=s.scan();switch(s.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:B||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(re){case 12:case 13:B?Q(10):F();break;case 16:Q(1);break;case 15:case 14:break;default:return re}}}function Q(re,ce=[],G=[]){if(V(re),ce.length+G.length>0){let N=s.getToken();for(;N!==17;){if(ce.indexOf(N)!==-1){Z();break}else if(G.indexOf(N)!==-1)break;N=Z()}}}function J(re){const ce=s.getTokenValue();return re?A(ce):w(ce),Z(),!0}function X(){switch(s.getToken()){case 11:{let re=0;try{re=JSON.parse(s.getTokenValue()),typeof re!="number"&&(Q(2),re=0)}catch{Q(2)}A(re);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return Z(),!0}function W(){return s.getToken()!==10?(Q(3,[],[2,5]),!1):(J(!1),s.getToken()===6?(M(":"),Z(),te()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function U(){a(),Z();let re=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(re||Q(4,[],[]),M(","),Z(),s.getToken()===2&&x)break}else re&&Q(6,[],[]);W()||Q(4,[],[2,5]),re=!0}return g(),s.getToken()!==2?Q(7,[2],[]):Z(),!0}function q(){f(),Z();let re=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(re||Q(4,[],[]),M(","),Z(),s.getToken()===4&&x)break}else re&&Q(6,[],[]);te()||Q(4,[],[4,5]),re=!0}return k(),s.getToken()!==4?Q(8,[4],[]):Z(),!0}function te(){switch(s.getToken()){case 3:return q();case 1:return U();case 10:return J(!0);default:return X()}}return Z(),s.getToken()===17?n.allowEmptyContent?!0:(Q(4,[],[]),!1):te()?(s.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.$Em=y;function p(t,o){const n=L(t),s=[];let i,r=0,a;do switch(a=n.getPosition(),i=n.scan(),i){case 12:case 13:case 17:r!==a&&s.push(t.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(i!==17);return s.join("")}e.$Fm=p;function R(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Gm=R}),define(oe[41],ae([0,1,34]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9R=e.$8R=e.$7R=e.$6R=void 0;function T(b,C,E){let m,h,d,v,c;if(C){for(v=C.offset,c=v+C.length,d=v;d>0&&!S(b,d-1);)d--;let a=c;for(;a<b.length&&!S(b,a);)a++;h=b.substring(d,a),m=L(h,E)}else h=b,m=0,d=0,v=0,c=b.length;const l=P(E,b);let u=!1,y=0,p;E.insertSpaces?p=j(" ",E.tabSize||4):p="	";const R=(0,I.$vm)(h,!1);let t=!1;function o(){return l+j(p,m+y)}function n(){let a=R.scan();for(u=!1;a===15||a===14;)u=u||a===14,a=R.scan();return t=a===16||R.getTokenError()!==0,a}const s=[];function i(a,w,g){!t&&w<c&&g>v&&b.substring(w,g)!==a&&s.push({offset:w,length:g-w,content:a})}let r=n();if(r!==17){const a=R.getTokenOffset()+d,w=j(p,m);i(w,d,a)}for(;r!==17;){let a=R.getTokenOffset()+R.getTokenLength()+d,w=n(),g="";for(;!u&&(w===12||w===13);){const k=R.getTokenOffset()+d;i(" ",a,k),a=R.getTokenOffset()+R.getTokenLength()+d,g=w===12?o():"",w=n()}if(w===2)r!==1&&(y--,g=o());else if(w===4)r!==3&&(y--,g=o());else{switch(r){case 3:case 1:y++,g=o();break;case 5:case 12:g=o();break;case 13:u?g=o():g=" ";break;case 6:g=" ";break;case 10:if(w===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?g=" ":w!==5&&w!==17&&(t=!0);break;case 16:t=!0;break}u&&(w===12||w===13)&&(g=o())}const f=R.getTokenOffset()+d;i(g,a,f),r=w}return s}e.$6R=T;function O(b,C){const E=JSON.stringify(b,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?E.replace(/\r\n|\r|\n/g,C.eol):E}e.$7R=O;function j(b,C){let E="";for(let m=0;m<C;m++)E+=b;return E}function L(b,C){let E=0,m=0;const h=C.tabSize||4;for(;E<b.length;){const d=b.charAt(E);if(d===" ")m++;else if(d==="	")m+=h;else break;E++}return Math.floor(m/h)}function P(b,C){for(let E=0;E<C.length;E++){const m=C.charAt(E);if(m==="\r")return E+1<C.length&&C.charAt(E+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return b&&b.eol||`
`}e.$8R=P;function S(b,C){return`\r
`.indexOf(b.charAt(C))!==-1}e.$9R=S}),define(oe[83],ae([0,1,34,41]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bS=e.$aS=e.$_R=e.$$R=e.$0R=void 0;function O(b,C,E){return j(b,C,void 0,E)}e.$0R=O;function j(b,C,E,m,h){const d=C.slice(),v=[],c=(0,I.$ym)(b,v);let l,u;for(;d.length>0&&(u=d.pop(),l=(0,I.$zm)(c,d),l===void 0&&E!==void 0);)typeof u=="string"?E={[u]:E}:E=[E];if(l)if(l.type==="object"&&typeof u=="string"&&Array.isArray(l.children)){const y=(0,I.$zm)(l,[u]);if(y!==void 0)if(E===void 0){if(!y.parent)throw new Error("Malformed AST");const p=l.children.indexOf(y.parent);let R,t=y.parent.offset+y.parent.length;if(p>0){const o=l.children[p-1];R=o.offset+o.length}else R=l.offset+1,l.children.length>1&&(t=l.children[1].offset);return L(b,{offset:R,length:t-R,content:""},m)}else return L(b,{offset:y.offset,length:y.length,content:JSON.stringify(E)},m);else{if(E===void 0)return[];const p=`${JSON.stringify(u)}: ${JSON.stringify(E)}`,R=h?h(l.children.map(o=>o.children[0].value)):l.children.length;let t;if(R>0){const o=l.children[R-1];t={offset:o.offset+o.length,length:0,content:","+p}}else l.children.length===0?t={offset:l.offset+1,length:0,content:p}:t={offset:l.offset+1,length:0,content:p+","};return L(b,t,m)}}else if(l.type==="array"&&typeof u=="number"&&Array.isArray(l.children))if(E!==void 0){const y=`${JSON.stringify(E)}`;let p;if(l.children.length===0||u===0)p={offset:l.offset+1,length:0,content:l.children.length===0?y:y+","};else{const R=u===-1||u>l.children.length?l.children.length:u,t=l.children[R-1];p={offset:t.offset+t.length,length:0,content:","+y}}return L(b,p,m)}else{const y=u,p=l.children[y];let R;if(l.children.length===1)R={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===y){const t=l.children[y-1],o=t.offset+t.length,n=l.offset+l.length;R={offset:o,length:n-2-o,content:""}}else R={offset:p.offset,length:l.children[y+1].offset-p.offset,content:""};return L(b,R,m)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${l.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return L(b,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(E)},m)}}e.$$R=j;function L(b,C,E){let m=P(b,C),h=C.offset,d=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;h>0&&!(0,T.$9R)(m,h-1);)h--;for(;d<m.length&&!(0,T.$9R)(m,d);)d++}const v=(0,T.$6R)(m,{offset:h,length:d-h},E);for(let l=v.length-1;l>=0;l--){const u=v[l];m=P(m,u),h=Math.min(h,u.offset),d=Math.max(d,u.offset+u.length),d+=u.content.length-u.length}const c=b.length-(m.length-d)-h;return[{offset:h,length:c,content:m.substring(h,d)}]}e.$_R=L;function P(b,C){return b.substring(0,C.offset)+C.content+b.substring(C.offset+C.length)}e.$aS=P;function S(b,C){const E=C.slice(0).sort((h,d)=>{const v=h.offset-d.offset;return v===0?h.length-d.length:v});let m=b.length;for(let h=E.length-1;h>=0;h--){const d=E[h];if(d.offset+d.length<=m)b=P(b,d);else throw new Error("Overlapping edit");m=d.offset}return b}e.$bS=S}),define(oe[84],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class I{constructor(O){this.d=O,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(O){this.c=O}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=I}),define(oe[2],ae([0,1,82,59]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tb=e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;const O=!1;let j=null;function L(r){j=r}if(e.$db=L,O){const r="__is_disposable_tracked__";L(new class{trackDisposable(a){const w=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(w)},3e3)}setParent(a,w){if(a&&a!==u.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==u.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function P(r){return j?.trackDisposable(r),r}function S(r){j?.markAsDisposed(r)}function b(r,a){j?.setParent(r,a)}function C(r,a){if(j)for(const w of r)j.setParent(w,a)}function E(r){return j?.markAsSingleton(r),r}e.$eb=E;function m(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.$fb=m;function h(r){if(T.Iterable.is(r)){const a=[];for(const w of r)if(w)try{w.dispose()}catch(g){a.push(g)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.$gb=h;function d(r){for(const a of r)m(a)&&a.dispose();return[]}e.$hb=d;function v(...r){const a=c(()=>h(r));return C(r,a),a}e.$ib=v;function c(r){const a=P({dispose:(0,I.$cb)(()=>{S(a),r()})});return a}e.$jb=c;class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(S(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return b(a,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(a),a}}e.$kb=l;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,P(this),b(this.q,this)}dispose(){S(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}e.$lb=u;class y{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&b(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&b(a,null),a}}e.$mb=y;class p{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$nb=p;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(a){let w=a;return this.unset=()=>w=void 0,this.isset=()=>w!==void 0,this.dispose=()=>{w&&(w(),w=void 0,S(this))},this}}e.$ob=R;class t{constructor(){this.a=new Map}acquire(a,...w){let g=this.a.get(a);g||(g={counter:0,object:this.b(a,...w)},this.a.set(a,g));const{object:f}=g,k=(0,I.$cb)(()=>{--g.counter===0&&(this.c(a,g.object),this.a.delete(a))});return g.counter++,{object:f,dispose:k}}}e.$pb=t;class o{constructor(a){this.a=a}async acquire(a,...w){const g=this.a.acquire(a,...w);try{return{object:await g.object,dispose:()=>g.dispose()}}catch(f){throw g.dispose(),f}}}e.$qb=o;class n{constructor(a){this.object=a}dispose(){}}e.$rb=n;function s(r){const a=new l;try{r(a)}finally{a.dispose()}}e.$sb=s;class i{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get(a){return this.a.get(a)}set(a,w,g=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),g||this.a.get(a)?.dispose(),this.a.set(a,w)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$tb=i}),define(oe[85],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lc=void 0;class I{static{this.Undefined=new I(void 0)}constructor(j){this.element=j,this.next=I.Undefined,this.prev=I.Undefined}}class T{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let j=this.a;for(;j!==I.Undefined;){const L=j.next;j.prev=I.Undefined,j.next=I.Undefined,j=L}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,L){const P=new I(j);if(this.a===I.Undefined)this.a=P,this.b=P;else if(L){const b=this.b;this.b=P,P.prev=b,b.next=P}else{const b=this.a;this.a=P,P.next=b,b.prev=P}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(P))}}shift(){if(this.a!==I.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==I.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==I.Undefined&&j.next!==I.Undefined){const L=j.prev;L.next=j.next,j.next.prev=L}else j.prev===I.Undefined&&j.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):j.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):j.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==I.Undefined;)yield j.element,j=j.next}}e.$lc=T}),define(oe[35],ae([0,1]),function(ne,e){"use strict";var I,T,O;Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.Touch=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;function j(v,c,l){let u=v.get(c);return u===void 0&&(u=l,v.set(c,u)),u}e.$ki=j;function L(v){const c=[];return v.forEach((l,u)=>{c.push(`${u} => ${l}`)}),`Map(${v.size}) {${c.join(", ")}}`}e.$li=L;function P(v){const c=[];return v.forEach(l=>{c.push(l)}),`Set(${v.size}) {${c.join(", ")}}`}e.$mi=P;class S{constructor(c,l){this.uri=c,this.value=l}}class b{static{this.a=c=>c.toString()}constructor(c,l){this[I]="ResourceMap",c instanceof b?(this.b=new Map(c.b),this.c=l??b.a):(this.b=new Map,this.c=c??b.a)}set(c,l){return this.b.set(this.c(c),new S(c,l)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,l){typeof l<"u"&&(c=c.bind(l));for(const[u,y]of this.b)c(y.value,y.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$ni=b;class C{constructor(c,l){this[T]="ResourceSet",!c||typeof c=="function"?this.a=new b(c):(this.a=new b(l),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,l){this.a.forEach((u,y)=>c.call(l,y,y,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$oi=C;var E;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(E||(e.Touch=E={}));class m{constructor(){this[O]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,l=0){const u=this.a.get(c);if(u)return l!==0&&this.j(u,l),u.value}set(c,l,u=0){let y=this.a.get(c);if(y)y.value=l,u!==0&&this.j(y,u);else{switch(y={key:c,value:l,next:void 0,previous:void 0},u){case 0:this.h(y);break;case 1:this.g(y);break;case 2:this.h(y);break;default:this.h(y);break}this.a.set(c,y),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const l=this.a.get(c);if(l)return this.a.delete(c),this.i(l),this.d--,l.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,l){const u=this.e;let y=this.b;for(;y;){if(l?c.bind(l)(y.value,y.key,this):c(y.value,y.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");y=y.next}}keys(){const c=this,l=this.e;let u=this.b;const y={[Symbol.iterator](){return y},next(){if(c.e!==l)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.key,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return y}values(){const c=this,l=this.e;let u=this.b;const y={[Symbol.iterator](){return y},next(){if(c.e!==l)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.value,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return y}entries(){const c=this,l=this.e;let u=this.b;const y={[Symbol.iterator](){return y},next(){if(c.e!==l)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:[u.key,u.value],done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return y}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let l=this.b,u=this.size;for(;l&&u>c;)this.a.delete(l.key),l=l.next,u--;this.b=l,this.d=u,l&&(l.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const l=c.next,u=c.previous;if(!l||!u)throw new Error("Invalid list");l.previous=u,u.next=l}c.next=void 0,c.previous=void 0,this.e++}j(c,l){if(!this.b||!this.c)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(c===this.b)return;const u=c.next,y=c.previous;c===this.c?(y.next=void 0,this.c=y):(u.previous=y,y.next=u),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(l===2){if(c===this.c)return;const u=c.next,y=c.previous;c===this.b?(u.previous=void 0,this.b=u):(u.previous=y,y.next=u),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((l,u)=>{c.push([u,l])}),c}fromJSON(c){this.clear();for(const[l,u]of c)this.set(l,u)}}e.$pi=m;class h extends m{constructor(c,l=1){super(),this.k=c,this.l=Math.min(Math.max(0,l),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,l=2){return super.get(c,l)}peek(c){return super.get(c,0)}set(c,l){return super.set(c,l,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$qi=h;class d{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let l=this.a.get(c)||0;return l===0?!1:(l--,l===0?this.a.delete(c):this.a.set(c,l),!0)}has(c){return this.a.has(c)}}e.$ri=d}),define(oe[86],ae([0,1,35]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=void 0;const T=new I.$qi(1e4);function O(b){return S(b,"NFC",T)}e.$7k=O;const j=new I.$qi(1e4);function L(b){return S(b,"NFD",j)}e.$8k=L;const P=/[^\u0000-\u0080]/;function S(b,C,E){if(!b)return b;const m=E.get(b);if(m)return m;let h;return P.test(b)?h=b.normalize(C):h=b,E.set(b,h),h}e.$9k=function(){const b=/[\u0300-\u036f]/g;return function(C){return L(C).replace(b,"")}}()}),function(){function ne(O){const j=[];typeof O=="number"&&j.push("code/timeOrigin",O);function L(S){j.push(S,Date.now())}function P(){const S=[];for(let b=0;b<j.length;b+=2)S.push({name:j[b],startTime:j[b+1]});return S}return{mark:L,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(O){performance.mark(O)},getMarks(){let O=performance.timeOrigin;typeof O!="number"&&(O=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(O)}];for(const L of performance.getEntriesByType("mark"))j.push({name:L.name,startTime:Math.round(O+L.startTime)});return j}};if(typeof process=="object"){const O=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(O)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function I(O){return O.MonacoPerformanceMarks||(O.MonacoPerformanceMarks=e()),O.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=I(T))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var T in I)(typeof exports=="object"?exports:ne)[T]=I[T]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function I(T){if(e[T])return e[T].exports;var O=e[T]={i:T,l:!1,exports:{}};return ne[T].call(O.exports,O,O.exports,I),O.l=!0,O.exports}return I.m=ne,I.c=e,I.d=function(T,O,j){I.o(T,O)||Object.defineProperty(T,O,{enumerable:!0,get:j})},I.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},I.t=function(T,O){if(1&O&&(T=I(T)),8&O||4&O&&typeof T=="object"&&T&&T.__esModule)return T;var j=Object.create(null);if(I.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:T}),2&O&&typeof T!="string")for(var L in T)I.d(j,L,function(P){return T[P]}.bind(null,L));return j},I.n=function(T){var O=T&&T.__esModule?function(){return T.default}:function(){return T};return I.d(O,"a",O),O},I.o=function(T,O){return Object.prototype.hasOwnProperty.call(T,O)},I.p="",I(I.s=0)}([function(ne,e,I){(function(T){var O;e=ne.exports=G,O=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],S=e.src=[],b=0,C=b++;S[C]="0|[1-9]\\d*";var E=b++;S[E]="[0-9]+";var m=b++;S[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=b++;S[h]="("+S[C]+")\\.("+S[C]+")\\.("+S[C]+")";var d=b++;S[d]="("+S[E]+")\\.("+S[E]+")\\.("+S[E]+")";var v=b++;S[v]="(?:"+S[C]+"|"+S[m]+")";var c=b++;S[c]="(?:"+S[E]+"|"+S[m]+")";var l=b++;S[l]="(?:-("+S[v]+"(?:\\."+S[v]+")*))";var u=b++;S[u]="(?:-?("+S[c]+"(?:\\."+S[c]+")*))";var y=b++;S[y]="[0-9A-Za-z-]+";var p=b++;S[p]="(?:\\+("+S[y]+"(?:\\."+S[y]+")*))";var R=b++,t="v?"+S[h]+S[l]+"?"+S[p]+"?";S[R]="^"+t+"$";var o="[v=\\s]*"+S[d]+S[u]+"?"+S[p]+"?",n=b++;S[n]="^"+o+"$";var s=b++;S[s]="((?:<|>)?=?)";var i=b++;S[i]=S[E]+"|x|X|\\*";var r=b++;S[r]=S[C]+"|x|X|\\*";var a=b++;S[a]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[l]+")?"+S[p]+"?)?)?";var w=b++;S[w]="[v=\\s]*("+S[i]+")(?:\\.("+S[i]+")(?:\\.("+S[i]+")(?:"+S[u]+")?"+S[p]+"?)?)?";var g=b++;S[g]="^"+S[s]+"\\s*"+S[a]+"$";var f=b++;S[f]="^"+S[s]+"\\s*"+S[w]+"$";var k=b++;S[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=b++;S[A]="(?:~>?)";var M=b++;S[M]="(\\s*)"+S[A]+"\\s+",P[M]=new RegExp(S[M],"g");var F=b++;S[F]="^"+S[A]+S[a]+"$";var V=b++;S[V]="^"+S[A]+S[w]+"$";var B=b++;S[B]="(?:\\^)";var x=b++;S[x]="(\\s*)"+S[B]+"\\s+",P[x]=new RegExp(S[x],"g");var Z=b++;S[Z]="^"+S[B]+S[a]+"$";var Q=b++;S[Q]="^"+S[B]+S[w]+"$";var J=b++;S[J]="^"+S[s]+"\\s*("+o+")$|^$";var X=b++;S[X]="^"+S[s]+"\\s*("+t+")$|^$";var W=b++;S[W]="(\\s*)"+S[s]+"\\s*("+o+"|"+S[a]+")",P[W]=new RegExp(S[W],"g");var U=b++;S[U]="^\\s*("+S[a]+")\\s+-\\s+("+S[a]+")\\s*$";var q=b++;S[q]="^\\s*("+S[w]+")\\s+-\\s+("+S[w]+")\\s*$";var te=b++;S[te]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)O(re,S[re]),P[re]||(P[re]=new RegExp(S[re]));function ce(ue,de){if(ue instanceof G)return ue;if(typeof ue!="string"||ue.length>j||!(de?P[n]:P[R]).test(ue))return null;try{return new G(ue,de)}catch{return null}}function G(ue,de){if(ue instanceof G){if(ue.loose===de)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof G))return new G(ue,de);O("SemVer",ue,de),this.loose=de;var $e=ue.trim().match(de?P[n]:P[R]);if(!$e)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+$e[1],this.minor=+$e[2],this.patch=+$e[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");$e[4]?this.prerelease=$e[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Ce=+Se;if(Ce>=0&&Ce<L)return Ce}return Se}):this.prerelease=[],this.build=$e[5]?$e[5].split("."):[],this.format()}e.parse=ce,e.valid=function(ue,de){var $e=ce(ue,de);return $e?$e.version:null},e.clean=function(ue,de){var $e=ce(ue.trim().replace(/^[=v]+/,""),de);return $e?$e.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(ue){return O("SemVer.compare",this.version,this.loose,ue),ue instanceof G||(ue=new G(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},G.prototype.compareMain=function(ue){return ue instanceof G||(ue=new G(ue,this.loose)),$(this.major,ue.major)||$(this.minor,ue.minor)||$(this.patch,ue.patch)},G.prototype.comparePre=function(ue){if(ue instanceof G||(ue=new G(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var de=0;do{var $e=this.prerelease[de],Se=ue.prerelease[de];if(O("prerelease compare",de,$e,Se),$e===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if($e===void 0)return-1;if($e!==Se)return $($e,Se)}while(++de)},G.prototype.inc=function(ue,de){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $e=this.prerelease.length;--$e>=0;)typeof this.prerelease[$e]=="number"&&(this.prerelease[$e]++,$e=-2);$e===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,de,$e,Se){typeof $e=="string"&&(Se=$e,$e=void 0);try{return new G(ue,$e).inc(de,Se).version}catch{return null}},e.diff=function(ue,de){if(_(ue,de))return null;var $e=ce(ue),Se=ce(de);if($e.prerelease.length||Se.prerelease.length){for(var Ce in $e)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&$e[Ce]!==Se[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in $e)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&$e[Ce]!==Se[Ce])return Ce},e.compareIdentifiers=$;var N=/^[0-9]+$/;function $(ue,de){var $e=N.test(ue),Se=N.test(de);return $e&&Se&&(ue=+ue,de=+de),$e&&!Se?-1:Se&&!$e?1:ue<de?-1:ue>de?1:0}function D(ue,de,$e){return new G(ue,$e).compare(new G(de,$e))}function z(ue,de,$e){return D(ue,de,$e)>0}function K(ue,de,$e){return D(ue,de,$e)<0}function _(ue,de,$e){return D(ue,de,$e)===0}function H(ue,de,$e){return D(ue,de,$e)!==0}function ee(ue,de,$e){return D(ue,de,$e)>=0}function ie(ue,de,$e){return D(ue,de,$e)<=0}function le(ue,de,$e,Se){var Ce;switch(de){case"===":typeof ue=="object"&&(ue=ue.version),typeof $e=="object"&&($e=$e.version),Ce=ue===$e;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof $e=="object"&&($e=$e.version),Ce=ue!==$e;break;case"":case"=":case"==":Ce=_(ue,$e,Se);break;case"!=":Ce=H(ue,$e,Se);break;case">":Ce=z(ue,$e,Se);break;case">=":Ce=ee(ue,$e,Se);break;case"<":Ce=K(ue,$e,Se);break;case"<=":Ce=ie(ue,$e,Se);break;default:throw new TypeError("Invalid operator: "+de)}return Ce}function he(ue,de){if(ue instanceof he){if(ue.loose===de)return ue;ue=ue.value}if(!(this instanceof he))return new he(ue,de);O("comparator",ue,de),this.loose=de,this.parse(ue),this.semver===me?this.value="":this.value=this.operator+this.semver.version,O("comp",this)}e.rcompareIdentifiers=function(ue,de){return $(de,ue)},e.major=function(ue,de){return new G(ue,de).major},e.minor=function(ue,de){return new G(ue,de).minor},e.patch=function(ue,de){return new G(ue,de).patch},e.compare=D,e.compareLoose=function(ue,de){return D(ue,de,!0)},e.rcompare=function(ue,de,$e){return D(de,ue,$e)},e.sort=function(ue,de){return ue.sort(function($e,Se){return e.compare($e,Se,de)})},e.rsort=function(ue,de){return ue.sort(function($e,Se){return e.rcompare($e,Se,de)})},e.gt=z,e.lt=K,e.eq=_,e.neq=H,e.gte=ee,e.lte=ie,e.cmp=le,e.Comparator=he;var me={};function be(ue,de){if(ue instanceof be)return ue.loose===de?ue:new be(ue.raw,de);if(ue instanceof he)return new be(ue.value,de);if(!(this instanceof be))return new be(ue,de);if(this.loose=de,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function($e){return this.parseRange($e.trim())},this).filter(function($e){return $e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function ke(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function Pe(ue,de,$e,Se,Ce,Fe,Le,Ue,Ae,Ne,ze,se,fe){return((de=ke($e)?"":ke(Se)?">="+$e+".0.0":ke(Ce)?">="+$e+"."+Se+".0":">="+de)+" "+(Ue=ke(Ae)?"":ke(Ne)?"<"+(+Ae+1)+".0.0":ke(ze)?"<"+Ae+"."+(+Ne+1)+".0":se?"<="+Ae+"."+Ne+"."+ze+"-"+se:"<="+Ue)).trim()}function je(ue,de){for(var $e=0;$e<ue.length;$e++)if(!ue[$e].test(de))return!1;if(de.prerelease.length){for($e=0;$e<ue.length;$e++)if(O(ue[$e].semver),ue[$e].semver!==me&&ue[$e].semver.prerelease.length>0){var Se=ue[$e].semver;if(Se.major===de.major&&Se.minor===de.minor&&Se.patch===de.patch)return!0}return!1}return!0}function De(ue,de,$e){try{de=new be(de,$e)}catch{return!1}return de.test(ue)}function We(ue,de,$e,Se){var Ce,Fe,Le,Ue,Ae;switch(ue=new G(ue,Se),de=new be(de,Se),$e){case">":Ce=z,Fe=ie,Le=K,Ue=">",Ae=">=";break;case"<":Ce=K,Fe=ee,Le=z,Ue="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(De(ue,de,Se))return!1;for(var Ne=0;Ne<de.set.length;++Ne){var ze=de.set[Ne],se=null,fe=null;if(ze.forEach(function(ge){ge.semver===me&&(ge=new he(">=0.0.0")),se=se||ge,fe=fe||ge,Ce(ge.semver,se.semver,Se)?se=ge:Le(ge.semver,fe.semver,Se)&&(fe=ge)}),se.operator===Ue||se.operator===Ae||(!fe.operator||fe.operator===Ue)&&Fe(ue,fe.semver)||fe.operator===Ae&&Le(ue,fe.semver))return!1}return!0}he.prototype.parse=function(ue){var de=this.loose?P[J]:P[X],$e=ue.match(de);if(!$e)throw new TypeError("Invalid comparator: "+ue);this.operator=$e[1],this.operator==="="&&(this.operator=""),$e[2]?this.semver=new G($e[2],this.loose):this.semver=me},he.prototype.toString=function(){return this.value},he.prototype.test=function(ue){return O("Comparator.test",ue,this.loose),this.semver===me||(typeof ue=="string"&&(ue=new G(ue,this.loose)),le(ue,this.operator,this.semver,this.loose))},he.prototype.intersects=function(ue,de){if(!(ue instanceof he))throw new TypeError("a Comparator is required");var $e;if(this.operator==="")return $e=new be(ue.value,de),De(this.value,$e,de);if(ue.operator==="")return $e=new be(this.value,de),De(ue.semver,$e,de);var Se=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),Fe=this.semver.version===ue.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),Ue=le(this.semver,"<",ue.semver,de)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),Ae=le(this.semver,">",ue.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return Se||Ce||Fe&&Le||Ue||Ae},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ue){var de=this.loose;ue=ue.trim(),O("range",ue,de);var $e=de?P[q]:P[U];ue=ue.replace($e,Pe),O("hyphen replace",ue),ue=ue.replace(P[W],"$1$2$3"),O("comparator trim",ue,P[W]),ue=(ue=(ue=ue.replace(P[M],"$1~")).replace(P[x],"$1^")).split(/\s+/).join(" ");var Se=de?P[J]:P[X],Ce=ue.split(" ").map(function(Fe){return function(Le,Ue){return O("comp",Le),Le=function(Ae,Ne){return Ae.trim().split(/\s+/).map(function(ze){return function(se,fe){O("caret",se,fe);var ge=fe?P[Q]:P[Z];return se.replace(ge,function(pe,ye,Ee,Re,Ie){var Oe;return O("caret",se,pe,ye,Ee,Re,Ie),ke(ye)?Oe="":ke(Ee)?Oe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ke(Re)?Oe=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":Ie?(O("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Oe=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Re+Ie+" <"+ye+"."+Ee+"."+(+Re+1):">="+ye+"."+Ee+"."+Re+Ie+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Re+Ie+" <"+(+ye+1)+".0.0"):(O("no pr"),Oe=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Re+" <"+ye+"."+Ee+"."+(+Re+1):">="+ye+"."+Ee+"."+Re+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Re+" <"+(+ye+1)+".0.0"),O("caret return",Oe),Oe})}(ze,Ne)}).join(" ")}(Le,Ue),O("caret",Le),Le=function(Ae,Ne){return Ae.trim().split(/\s+/).map(function(ze){return function(se,fe){var ge=fe?P[V]:P[F];return se.replace(ge,function(pe,ye,Ee,Re,Ie){var Oe;return O("tilde",se,pe,ye,Ee,Re,Ie),ke(ye)?Oe="":ke(Ee)?Oe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ke(Re)?Oe=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":Ie?(O("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Oe=">="+ye+"."+Ee+"."+Re+Ie+" <"+ye+"."+(+Ee+1)+".0"):Oe=">="+ye+"."+Ee+"."+Re+" <"+ye+"."+(+Ee+1)+".0",O("tilde return",Oe),Oe})}(ze,Ne)}).join(" ")}(Le,Ue),O("tildes",Le),Le=function(Ae,Ne){return O("replaceXRanges",Ae,Ne),Ae.split(/\s+/).map(function(ze){return function(se,fe){se=se.trim();var ge=fe?P[f]:P[g];return se.replace(ge,function(pe,ye,Ee,Re,Ie,Oe){O("xRange",se,pe,ye,Ee,Re,Ie,Oe);var Be=ke(Ee),Me=Be||ke(Re),qe=Me||ke(Ie);return ye==="="&&qe&&(ye=""),Be?pe=ye===">"||ye==="<"?"<0.0.0":"*":ye&&qe?(Me&&(Re=0),qe&&(Ie=0),ye===">"?(ye=">=",Me?(Ee=+Ee+1,Re=0,Ie=0):qe&&(Re=+Re+1,Ie=0)):ye==="<="&&(ye="<",Me?Ee=+Ee+1:Re=+Re+1),pe=ye+Ee+"."+Re+"."+Ie):Me?pe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":qe&&(pe=">="+Ee+"."+Re+".0 <"+Ee+"."+(+Re+1)+".0"),O("xRange return",pe),pe})}(ze,Ne)}).join(" ")}(Le,Ue),O("xrange",Le),Le=function(Ae,Ne){return O("replaceStars",Ae,Ne),Ae.trim().replace(P[te],"")}(Le,Ue),O("stars",Le),Le}(Fe,de)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Fe){return!!Fe.match(Se)})),Ce=Ce.map(function(Fe){return new he(Fe,de)})},be.prototype.intersects=function(ue,de){if(!(ue instanceof be))throw new TypeError("a Range is required");return this.set.some(function($e){return $e.every(function(Se){return ue.set.some(function(Ce){return Ce.every(function(Fe){return Se.intersects(Fe,de)})})})})},e.toComparators=function(ue,de){return new be(ue,de).set.map(function($e){return $e.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new G(ue,this.loose));for(var de=0;de<this.set.length;de++)if(je(this.set[de],ue))return!0;return!1},e.satisfies=De,e.maxSatisfying=function(ue,de,$e){var Se=null,Ce=null;try{var Fe=new be(de,$e)}catch{return null}return ue.forEach(function(Le){Fe.test(Le)&&(Se&&Ce.compare(Le)!==-1||(Ce=new G(Se=Le,$e)))}),Se},e.minSatisfying=function(ue,de,$e){var Se=null,Ce=null;try{var Fe=new be(de,$e)}catch{return null}return ue.forEach(function(Le){Fe.test(Le)&&(Se&&Ce.compare(Le)!==1||(Ce=new G(Se=Le,$e)))}),Se},e.validRange=function(ue,de){try{return new be(ue,de).range||"*"}catch{return null}},e.ltr=function(ue,de,$e){return We(ue,de,"<",$e)},e.gtr=function(ue,de,$e){return We(ue,de,">",$e)},e.outside=We,e.prerelease=function(ue,de){var $e=ce(ue,de);return $e&&$e.prerelease.length?$e.prerelease:null},e.intersects=function(ue,de,$e){return ue=new be(ue,$e),de=new be(de,$e),ue.intersects(de)},e.coerce=function(ue){if(ue instanceof G)return ue;if(typeof ue!="string")return null;var de=ue.match(P[k]);return de==null?null:ce((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,I(1))},function(ne,e){var I,T,O=ne.exports={};function j(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function P(c){if(I===setTimeout)return setTimeout(c,0);if((I===j||!I)&&setTimeout)return I=setTimeout,setTimeout(c,0);try{return I(c,0)}catch{try{return I.call(null,c,0)}catch{return I.call(this,c,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:j}catch{I=j}try{T=typeof clearTimeout=="function"?clearTimeout:L}catch{T=L}})();var S,b=[],C=!1,E=-1;function m(){C&&S&&(C=!1,S.length?b=S.concat(b):E=-1,b.length&&h())}function h(){if(!C){var c=P(m);C=!0;for(var l=b.length;l;){for(S=b,b=[];++E<l;)S&&S[E].run();E=-1,l=b.length}S=null,C=!1,function(u){if(T===clearTimeout)return clearTimeout(u);if((T===L||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(u);try{T(u)}catch{try{return T.call(null,u)}catch{return T.call(this,u)}}}(c)}}function d(c,l){this.fun=c,this.array=l}function v(){}O.nextTick=function(c){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];b.push(new d(c,l)),b.length!==1||C||P(h)},d.prototype.run=function(){this.fun.apply(null,this.array)},O.title="browser",O.browser=!0,O.env={},O.argv=[],O.version="",O.versions={},O.on=v,O.addListener=v,O.once=v,O.off=v,O.removeListener=v,O.removeAllListeners=v,O.emit=v,O.prependListener=v,O.prependOnceListener=v,O.listeners=function(c){return[]},O.binding=function(c){throw new Error("process.binding is not supported")},O.cwd=function(){return"/"},O.chdir=function(c){throw new Error("process.chdir is not supported")},O.umask=function(){return 0}}])}),define(oe[124],ae([0,1]),function(ne,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class T{constructor(P,S,b){this.level=P,this.key=S,this.value=b,this.forward=[]}}const O=void 0;class j{constructor(P,S=2**16){this.comparator=P,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(S)|0),this.e=new T(this.c,O,O)}get size(){return this.f}clear(){this.e=new T(this.c,O,O)}has(P){return!!j.g(this,P,this.comparator)}get(P){return j.g(this,P,this.comparator)?.value}set(P,S){return j.h(this,P,S,this.comparator)&&(this.f+=1),this}delete(P){const S=j.k(this,P,this.comparator);return S&&(this.f-=1),S}forEach(P,S){let b=this.e.forward[0];for(;b;)P.call(S,b.value,b.key,this),b=b.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",S=this.e.forward[0];for(;S;)P+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return P}static g(P,S,b){let C=P.e;for(let E=P.d-1;E>=0;E--)for(;C.forward[E]&&b(C.forward[E].key,S)<0;)C=C.forward[E];if(C=C.forward[0],C&&b(C.key,S)===0)return C}static h(P,S,b,C){const E=[];let m=P.e;for(let h=P.d-1;h>=0;h--){for(;m.forward[h]&&C(m.forward[h].key,S)<0;)m=m.forward[h];E[h]=m}if(m=m.forward[0],m&&C(m.key,S)===0)return m.value=b,!1;{const h=j.j(P);if(h>P.d){for(let d=P.d;d<h;d++)E[d]=P.e;P.d=h}m=new T(h,S,b);for(let d=0;d<h;d++)m.forward[d]=E[d].forward[d],E[d].forward[d]=m;return!0}}static j(P,S=.5){let b=1;for(;Math.random()<S&&b<P.c;)b+=1;return b}static k(P,S,b){const C=[];let E=P.e;for(let m=P.d-1;m>=0;m--){for(;E.forward[m]&&b(E.forward[m].key,S)<0;)E=E.forward[m];C[m]=E}if(E=E.forward[0],!E||b(E.key,S)!==0)return!1;for(let m=0;m<P.d&&C[m].forward[m]===E;m++)C[m].forward[m]=E.forward[m];for(;P.d>0&&P.e.forward[P.d-1]===O;)P.d-=1;return!0}}e.$br=j}),define(oe[87],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(j){return new T(j)}constructor(j){this.c=I&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$4c=T}),define(oe[3],ae([0,1,7,82,2,85,87]),function(ne,e,I,T,O,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.Event=void 0;const P=!1,S=!1;var b;(function(w){w.None=()=>O.$lb.None;function g(_){if(S){const{onDidAddListener:H}=_,ee=d.create();let ie=0;_.onDidAddListener=()=>{++ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),H?.()}}}function f(_,H){return Q(_,()=>{},0,void 0,!0,void 0,H)}w.defer=f;function k(_){return(H,ee=null,ie)=>{let le=!1,he;return he=_(me=>{if(!le)return he?he.dispose():le=!0,H.call(ee,me)},null,ie),le&&he.dispose(),he}}w.once=k;function A(_,H,ee){return Z((ie,le=null,he)=>_(me=>ie.call(le,H(me)),null,he),ee)}w.map=A;function M(_,H,ee){return Z((ie,le=null,he)=>_(me=>{H(me),ie.call(le,me)},null,he),ee)}w.forEach=M;function F(_,H,ee){return Z((ie,le=null,he)=>_(me=>H(me)&&ie.call(le,me),null,he),ee)}w.filter=F;function V(_){return _}w.signal=V;function B(..._){return(H,ee=null,ie)=>(0,O.$ib)(..._.map(le=>le(he=>H.call(ee,he),null,ie)))}w.any=B;function x(_,H,ee,ie){let le=ee;return A(_,he=>(le=H(le,he),le),ie)}w.reduce=x;function Z(_,H){let ee;const ie={onWillAddFirstListener(){ee=_(le.fire,le)},onDidRemoveLastListener(){ee?.dispose()}};H||g(ie);const le=new y(ie);return H?.add(le),le.event}function Q(_,H,ee=100,ie=!1,le=!1,he,me){let be,ke,Pe,je=0,De;const We={leakWarningThreshold:he,onWillAddFirstListener(){be=_(de=>{je++,ke=H(ke,de),ie&&!Pe&&(ue.fire(ke),ke=void 0),De=()=>{const $e=ke;ke=void 0,Pe=void 0,(!ie||je>1)&&ue.fire($e),je=0},typeof ee=="number"?(clearTimeout(Pe),Pe=setTimeout(De,ee)):Pe===void 0&&(Pe=0,queueMicrotask(De))})},onWillRemoveListener(){le&&je>0&&De?.()},onDidRemoveLastListener(){De=void 0,be.dispose()}};me||g(We);const ue=new y(We);return me?.add(ue),ue.event}w.debounce=Q;function J(_,H=0,ee){return w.debounce(_,(ie,le)=>ie?(ie.push(le),ie):[le],H,void 0,!0,void 0,ee)}w.accumulate=J;function X(_,H=(ie,le)=>ie===le,ee){let ie=!0,le;return F(_,he=>{const me=ie||!H(he,le);return ie=!1,le=he,me},ee)}w.latch=X;function W(_,H,ee){return[w.filter(_,H,ee),w.filter(_,ie=>!H(ie),ee)]}w.split=W;function U(_,H=!1,ee=[]){let ie=ee.slice(),le=_(be=>{ie?ie.push(be):me.fire(be)});const he=()=>{ie?.forEach(be=>me.fire(be)),ie=null},me=new y({onWillAddFirstListener(){le||(le=_(be=>me.fire(be)))},onDidAddFirstListener(){ie&&(H?setTimeout(he):he())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return me.event}w.buffer=U;class q{constructor(H){this.event=H,this.d=new O.$kb}map(H){return new q(A(this.event,H,this.d))}forEach(H){return new q(M(this.event,H,this.d))}filter(H){return new q(F(this.event,H,this.d))}reduce(H,ee){return new q(x(this.event,H,ee,this.d))}latch(){return new q(X(this.event,void 0,this.d))}debounce(H,ee=100,ie=!1,le=!1,he){return new q(Q(this.event,H,ee,ie,le,he,this.d))}on(H,ee,ie){return this.event(H,ee,ie)}once(H,ee,ie){return k(this.event)(H,ee,ie)}dispose(){this.d.dispose()}}function te(_){return new q(_)}w.chain=te;function re(_,H,ee=ie=>ie){const ie=(...be)=>me.fire(ee(...be)),le=()=>_.on(H,ie),he=()=>_.removeListener(H,ie),me=new y({onWillAddFirstListener:le,onDidRemoveLastListener:he});return me.event}w.fromNodeEventEmitter=re;function ce(_,H,ee=ie=>ie){const ie=(...be)=>me.fire(ee(...be)),le=()=>_.addEventListener(H,ie),he=()=>_.removeEventListener(H,ie),me=new y({onWillAddFirstListener:le,onDidRemoveLastListener:he});return me.event}w.fromDOMEventEmitter=ce;function G(_){return new Promise(H=>k(_)(H))}w.toPromise=G;function N(_,H){return H(void 0),_(ee=>H(ee))}w.runAndSubscribe=N;function $(_,H){let ee=null;function ie(he){ee?.dispose(),ee=new O.$kb,H(he,ee)}ie(void 0);const le=_(he=>ie(he));return(0,O.$jb)(()=>{le.dispose(),ee?.dispose()})}w.runAndSubscribeWithStore=$;class D{constructor(H,ee){this._observable=H,this.d=0,this.f=!1;const ie={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};ee||g(ie),this.emitter=new y(ie),ee&&ee.add(this.emitter)}beginUpdate(H){this.d++}handlePossibleChange(H){}handleChange(H,ee){this.f=!0}endUpdate(H){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function z(_,H){return new D(_,H).emitter.event}w.fromObservable=z;function K(_){return H=>{let ee=0,ie=!1;const le={beginUpdate(){ee++},endUpdate(){ee--,ee===0&&(_.reportChanges(),ie&&(ie=!1,H()))},handlePossibleChange(){},handleChange(){ie=!0}};return _.addObserver(le),_.reportChanges(),{dispose(){_.removeObserver(le)}}}}w.fromObservableLight=K})(b||(e.Event=b={}));class C{static{this.all=new Set}static{this.d=0}constructor(g){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${g}_${C.d++}`,C.all.add(this)}start(g){this.f=new L.$4c,this.listenerCount=g}stop(){if(this.f){const g=this.f.elapsed();this.durations.push(g),this.elapsedOverall+=g,this.invocationCount+=1,this.f=void 0}}}e.$6c=C;let E=-1;function m(w){const g=E;return E=w,{dispose(){E=g}}}e.$7c=m;class h{constructor(g,f=Math.random().toString(18).slice(2,5)){this.threshold=g,this.name=f,this.f=0}dispose(){this.d?.clear()}check(g,f){const k=this.threshold;if(k<=0||f<k)return;this.d||(this.d=new Map);const A=this.d.get(g.value)||0;if(this.d.set(g.value,A+1),this.f-=1,this.f<=0){this.f=k*.5;let M,F=0;for(const[V,B]of this.d)(!M||F<B)&&(M=V,F=B);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${F}):`),console.warn(M)}return()=>{const M=this.d.get(g.value)||0;this.d.set(g.value,M-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(g){this.value=g}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class c{constructor(g){this.value=g,this.id=v++}}const l=2,u=(w,g)=>{if(w instanceof c)g(w);else for(let f=0;f<w.length;f++){const k=w[f];k&&g(k)}};class y{constructor(g){this.u=0,this.d=g,this.f=E>0||this.d?.leakWarningThreshold?new h(this.d?.leakWarningThreshold??E):void 0,this.g=this.d?._profName?new C(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(P){const g=this.q;queueMicrotask(()=>{u(g,f=>f.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(g,f,k)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),O.$lb.None;if(this.j)return O.$lb.None;f&&(g=g.bind(f));const A=new c(g);let M,F;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(A.stack=d.create(),M=this.f.check(A.stack,this.u+1)),P&&(A.stack=F??d.create()),this.q?this.q instanceof c?(this.t??=new R,this.q=[this.q,A]):this.q.push(A):(this.d?.onWillAddFirstListener?.(this),this.q=A,this.d?.onDidAddFirstListener?.(this)),this.u++;const V=(0,O.$jb)(()=>{M?.(),this.v(A)});return k instanceof O.$kb?k.add(V):Array.isArray(k)&&k.push(V),V},this.m}v(g){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const f=this.q,k=f.indexOf(g);if(k===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,f[k]=void 0;const A=this.t.current===this;if(this.u*l<=f.length){let M=0;for(let F=0;F<f.length;F++)f[F]?f[M++]=f[F]:A&&(this.t.end--,M<this.t.i&&this.t.i--);f.length=M}}w(g,f){if(!g)return;const k=this.d?.onListenerError||I.$Y;if(!k){g.value(f);return}try{g.value(f)}catch(A){k(A)}}x(g){const f=g.current.q;for(;g.i<g.end;)this.w(f[g.i++],g.value);g.reset()}fire(g){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof c)this.w(this.q,g);else{const f=this.t;f.enqueue(this,g,this.q.length),this.x(f)}this.g?.stop()}hasListeners(){return this.u>0}}e.$8c=y;const p=()=>new R;e.$9c=p;class R{constructor(){this.i=-1,this.end=0}enqueue(g,f,k){this.i=0,this.end=k,this.current=g,this.value=f}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends y{async fireAsync(g,f,k){if(this.q)for(this.h||(this.h=new j.$lc),u(this.q,A=>this.h.push([A.value,g]));this.h.size>0&&!f.isCancellationRequested;){const[A,M]=this.h.shift(),F=[],V={...M,token:f,waitUntil:B=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");k&&(B=k(B,A)),F.push(B)}};try{A(V)}catch(B){(0,I.$Y)(B);continue}Object.freeze(F),await Promise.allSettled(F).then(B=>{for(const x of B)x.status==="rejected"&&(0,I.$Y)(x.reason)})}}}e.$0c=t;class o extends y{get isPaused(){return this.h!==0}constructor(g){super(g),this.h=0,this.s=new j.$lc,this.y=g?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const g=Array.from(this.s);this.s.clear(),super.fire(this.y(g))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(g){this.u&&(this.h!==0?this.s.push(g):super.fire(g))}}e.$$c=o;class n extends o{constructor(g){super(g),this.k=g.delay??100}fire(g){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(g)}}e.$_c=n;class s extends y{constructor(g){super(g),this.h=[],this.k=g?.merge}fire(g){this.hasListeners()&&(this.h.push(g),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(f=>super.fire(f)),this.h=[]}))}}e.$ad=s;class i{constructor(){this.f=!1,this.g=[],this.d=new y({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(g){const f={event:g,listener:null};this.g.push(f),this.f&&this.k(f);const k=()=>{this.f&&this.m(f);const A=this.g.indexOf(f);this.g.splice(A,1)};return(0,O.$jb)((0,T.$cb)(k))}h(){this.f=!0,this.g.forEach(g=>this.k(g))}j(){this.f=!1,this.g.forEach(g=>this.m(g))}k(g){g.listener=g.event(f=>this.d.fire(f))}m(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.d.dispose()}}e.$bd=i;class r{constructor(){this.d=[]}wrapEvent(g){return(f,k,A)=>g(M=>{const F=this.d[this.d.length-1];F?F.push(()=>f.call(k,M)):f.call(k,M)},void 0,A)}bufferEvents(g){const f=[];this.d.push(f);const k=g();return this.d.pop(),f.forEach(A=>A()),k}}e.$cd=r;class a{constructor(){this.d=!1,this.f=b.None,this.g=O.$lb.None,this.h=new y({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(g){this.f=g,this.d&&(this.g.dispose(),this.g=g(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}e.$dd=a}),define(oe[25],ae([0,1,3]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ed=e.CancellationToken=void 0;const T=Object.freeze(function(P,S){const b=setTimeout(P.bind(S),0);return{dispose(){clearTimeout(b)}}});var O;(function(P){function S(b){return b===P.None||b===P.Cancelled||b instanceof j?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=S,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(O||(e.CancellationToken=O={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new I.$8c),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new j),this.a}cancel(){this.a?this.a instanceof j&&this.a.cancel():this.a=O.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof j&&this.a.dispose():this.a=O.None}}e.$ed=L}),define(oe[125],ae([0,1,25]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hd=e.$gd=e.$fd=void 0;class T{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new I.$ed,S=this.b(P.token);return this.a={promise:S,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$fd=T;class O{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const S=JSON.stringify(P);return this.b!==S&&(this.b=S,this.a=this.c(P)),this.a}}e.$gd=O;class j{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const S=this.b(P);return this.a.set(P,S),S}}e.$hd=j}),define(oe[42],ae([0,1,7,2]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=void 0;function O(p){const R=p;return R?typeof R.read=="function":!1}e.$ub=O;function j(p){const R=p;return R?[R.on,R.pause,R.resume,R.destroy].every(t=>typeof t=="function"):!1}e.$vb=j;function L(p){const R=p;return R?j(R.stream)&&Array.isArray(R.buffer)&&typeof R.ended=="boolean":!1}e.$wb=L;function P(p,R){return new S(p,R)}e.$xb=P;class S{constructor(R,t){this.e=R,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(R){if(!this.a.destroyed){if(this.a.flowing)this.g(R);else if(this.b.data.push(R),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(R){this.a.destroyed||(this.a.flowing?this.h(R):this.b.error.push(R))}end(R){this.a.destroyed||(typeof R<"u"&&this.write(R),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(R){this.c.data.slice(0).forEach(t=>t(R))}h(R){this.c.error.length===0?(0,I.$Y)(R):this.c.error.slice(0).forEach(t=>t(R))}i(){this.c.end.slice(0).forEach(R=>R())}on(R,t){if(!this.a.destroyed)switch(R){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(R,t){if(this.a.destroyed)return;let o;switch(R){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(t);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const R=this.e(this.b.data);this.g(R),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const R of this.b.error)this.h(R);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(p,R){const t=[];let o;for(;(o=p.read())!==null;)t.push(o);return R(t)}e.$yb=b;function C(p,R,t){const o=[];let n;for(;(n=p.read())!==null&&o.length<t;)o.push(n);return n===null&&o.length>0?R(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return p.read()}}}e.$zb=C;function E(p,R){return new Promise((t,o)=>{const n=[];m(p,{onData:s=>{R&&n.push(s)},onError:s=>{R?o(s):t(void 0)},onEnd:()=>{t(R?R(n):void 0)}})})}e.$Ab=E;function m(p,R){let t=!1;return p.on("error",o=>{t||R.onError(o)}),p.on("end",()=>{t||R.onEnd()}),p.on("data",o=>{t||R.onData(o)}),(0,T.$jb)(()=>t=!0)}e.$Bb=m;function h(p,R){return new Promise((t,o)=>{const n=new T.$kb,s=[],i=w=>{if(s.push(w),s.length>R)return n.dispose(),p.pause(),t({stream:p,buffer:s,ended:!1})},r=w=>o(w),a=()=>t({stream:p,buffer:s,ended:!0});n.add((0,T.$jb)(()=>p.removeListener("error",r))),p.on("error",r),n.add((0,T.$jb)(()=>p.removeListener("end",a))),p.on("end",a),n.add((0,T.$jb)(()=>p.removeListener("data",i))),p.on("data",i)})}e.$Cb=h;function d(p,R){const t=P(R);return t.end(p),t}e.$Db=d;function v(){const p=P(()=>{throw new Error("not supported")});return p.end(),p}e.$Eb=v;function c(p){let R=!1;return{read:()=>R?null:(R=!0,p)}}e.$Fb=c;function l(p,R,t){const o=P(t);return m(p,{onData:n=>o.write(R.data(n)),onError:n=>o.error(R.error?R.error(n):n),onEnd:()=>o.end()}),o}e.$Gb=l;function u(p,R,t){let o=!1;return{read:()=>{const n=R.read();return o?n:(o=!0,n!==null?t([p,n]):p)}}}e.$Hb=u;function y(p,R,t){let o=!1;const n=P(t);return m(R,{onData:s=>o?n.write(s):(o=!0,n.write(t([p,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(p)),n.end()}}),n}e.$Ib=y}),define(oe[14],ae([0,1,84,42]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=void 0;const O=typeof Buffer<"u",j=new I.$T(()=>new Uint8Array(256));let L,P;class S{static alloc(k){return O?new S(Buffer.allocUnsafe(k)):new S(new Uint8Array(k))}static wrap(k){return O&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new S(k)}static fromString(k,A){return!(A?.dontUseNodeBuffer||!1)&&O?new S(Buffer.from(k)):(L||(L=new TextEncoder),new S(L.encode(k)))}static fromByteArray(k){const A=S.alloc(k.length);for(let M=0,F=k.length;M<F;M++)A.buffer[M]=k[M];return A}static concat(k,A){if(typeof A>"u"){A=0;for(let V=0,B=k.length;V<B;V++)A+=k[V].byteLength}const M=S.alloc(A);let F=0;for(let V=0,B=k.length;V<B;V++){const x=k[V];M.set(x,F),F+=x.byteLength}return M}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=S.alloc(this.byteLength);return k.set(this),k}toString(){return O?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(k,A){return new S(this.buffer.subarray(k,A))}set(k,A){if(k instanceof S)this.buffer.set(k.buffer,A);else if(k instanceof Uint8Array)this.buffer.set(k,A);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),A);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return m(this.buffer,k)}writeUInt32BE(k,A){h(this.buffer,k,A)}readUInt32LE(k){return d(this.buffer,k)}writeUInt32LE(k,A){v(this.buffer,k,A)}readUInt8(k){return c(this.buffer,k)}writeUInt8(k,A){l(this.buffer,k,A)}indexOf(k,A=0){return b(this.buffer,k instanceof S?k.buffer:k,A)}}e.$Jb=S;function b(f,k,A=0){const M=k.byteLength,F=f.byteLength;if(M===0)return 0;if(M===1)return f.indexOf(k[0]);if(M>F-A)return-1;const V=j.value;V.fill(k.length);for(let Q=0;Q<k.length;Q++)V[k[Q]]=k.length-Q-1;let B=A+k.length-1,x=B,Z=-1;for(;B<F;)if(f[B]===k[x]){if(x===0){Z=B;break}B--,x--}else B+=Math.max(k.length-x,V[f[B]]),x=k.length-1;return Z}e.$Kb=b;function C(f,k){return f[k+0]<<0>>>0|f[k+1]<<8>>>0}e.$Lb=C;function E(f,k,A){f[A+0]=k&255,k=k>>>8,f[A+1]=k&255}e.$Mb=E;function m(f,k){return f[k]*2**24+f[k+1]*2**16+f[k+2]*2**8+f[k+3]}e.$Nb=m;function h(f,k,A){f[A+3]=k,k=k>>>8,f[A+2]=k,k=k>>>8,f[A+1]=k,k=k>>>8,f[A]=k}e.$Ob=h;function d(f,k){return f[k+0]<<0>>>0|f[k+1]<<8>>>0|f[k+2]<<16>>>0|f[k+3]<<24>>>0}e.$Pb=d;function v(f,k,A){f[A+0]=k&255,k=k>>>8,f[A+1]=k&255,k=k>>>8,f[A+2]=k&255,k=k>>>8,f[A+3]=k&255}e.$Qb=v;function c(f,k){return f[k]}e.$Rb=c;function l(f,k,A){f[A]=k}e.$Sb=l;function u(f){return T.$yb(f,k=>S.concat(k))}e.$Tb=u;function y(f){return T.$Fb(f)}e.$Ub=y;function p(f){return T.$Ab(f,k=>S.concat(k))}e.$Vb=p;async function R(f){return f.ended?S.concat(f.buffer):S.concat([...f.buffer,await p(f.stream)])}e.$Wb=R;function t(f){return T.$Db(f,k=>S.concat(k))}e.$Xb=t;function o(f){return T.$Gb(f,{data:k=>typeof k=="string"?S.fromString(k):S.wrap(k)},k=>S.concat(k))}e.$Yb=o;function n(f){return T.$xb(k=>S.concat(k),f)}e.$Zb=n;function s(f,k){return T.$Hb(f,k,A=>S.concat(A))}e.$1b=s;function i(f,k){return T.$Ib(f,k,A=>S.concat(A))}e.$2b=i;function r(f){let k=0,A=0,M=0;const F=new Uint8Array(Math.floor(f.length/4*3)),V=x=>{switch(A){case 3:F[M++]=k|x,A=0;break;case 2:F[M++]=k|x>>>2,k=x<<6,A=3;break;case 1:F[M++]=k|x>>>4,k=x<<4,A=2;break;default:k=x<<2,A=1}};for(let x=0;x<f.length;x++){const Z=f.charCodeAt(x);if(Z>=65&&Z<=90)V(Z-65);else if(Z>=97&&Z<=122)V(Z-97+26);else if(Z>=48&&Z<=57)V(Z-48+52);else if(Z===43||Z===45)V(62);else if(Z===47||Z===95)V(63);else{if(Z===61)break;throw new SyntaxError(`Unexpected base64 character ${f[x]}`)}}const B=M;for(;A>0;)V(0);return S.wrap(F).slice(0,B)}e.$3b=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:f},k=!0,A=!1){const M=A?w:a;let F="";const V=f.byteLength%3;let B=0;for(;B<f.byteLength-V;B+=3){const x=f[B+0],Z=f[B+1],Q=f[B+2];F+=M[x>>>2],F+=M[(x<<4|Z>>>4)&63],F+=M[(Z<<2|Q>>>6)&63],F+=M[Q&63]}if(V===1){const x=f[B+0];F+=M[x>>>2],F+=M[x<<4&63],k&&(F+="==")}else if(V===2){const x=f[B+0],Z=f[B+1];F+=M[x>>>2],F+=M[(x<<4|Z>>>4)&63],F+=M[Z<<2&63],k&&(F+="=")}return F}e.$4b=g}),define(oe[27],ae([0,1,125,84]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.GraphemeBreakType=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=void 0;function O(se){return!se||typeof se!="string"?!0:se.trim().length===0}e.$kd=O;const j=/{(\d+)}/g;function L(se,...fe){return fe.length===0?se:se.replace(j,function(ge,pe){const ye=parseInt(pe,10);return isNaN(ye)||ye<0||ye>=fe.length?ge:fe[ye]})}e.$ld=L;const P=/{([^}]+)}/g;function S(se,fe){return se.replace(P,(ge,pe)=>fe[pe]??ge)}e.$md=S;function b(se){return se.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$nd=b;function C(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$od=C;function E(se,fe){let ge=0;const pe=fe.charCodeAt(0);for(let ye=se.length-1;ye>=0;ye--)se.charCodeAt(ye)===pe&&ge++;return ge}e.$pd=E;function m(se,fe,ge="\u2026"){return se.length<=fe?se:`${se.substr(0,fe)}${ge}`}e.$qd=m;function h(se,fe=" "){const ge=d(se,fe);return v(ge,fe)}e.$rd=h;function d(se,fe){if(!se||!fe)return se;const ge=fe.length;if(ge===0||se.length===0)return se;let pe=0;for(;se.indexOf(fe,pe)===pe;)pe=pe+ge;return se.substring(pe)}e.$sd=d;function v(se,fe){if(!se||!fe)return se;const ge=fe.length,pe=se.length;if(ge===0||pe===0)return se;let ye=pe,Ee=-1;for(;Ee=se.lastIndexOf(fe,ye-1),!(Ee===-1||Ee+ge!==ye);){if(Ee===0)return"";ye=Ee}return se.substring(0,ye)}e.$td=v;function c(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$ud=c;function l(se){return se.replace(/\*/g,"")}e.$vd=l;function u(se,fe,ge={}){if(!se)throw new Error("Cannot create regex from empty string");fe||(se=C(se)),ge.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let pe="";return ge.global&&(pe+="g"),ge.matchCase||(pe+="i"),ge.multiline&&(pe+="m"),ge.unicode&&(pe+="u"),new RegExp(se,pe)}e.$wd=u;function y(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}e.$xd=y;function p(se){return!!se.match(/([^\\]|^)(\\\\)*\\\d+/)}e.$yd=p;function R(se){return(se.global?"g":"")+(se.ignoreCase?"i":"")+(se.multiline?"m":"")+(se.unicode?"u":"")}e.$zd=R;function t(se){return se.split(/\r\n|\r|\n/)}e.$Ad=t;function o(se){for(let fe=0,ge=se.length;fe<ge;fe++){const pe=se.charCodeAt(fe);if(pe!==32&&pe!==9)return fe}return-1}e.$Bd=o;function n(se,fe=0,ge=se.length){for(let pe=fe;pe<ge;pe++){const ye=se.charCodeAt(pe);if(ye!==32&&ye!==9)return se.substring(fe,pe)}return se.substring(fe,ge)}e.$Cd=n;function s(se,fe=se.length-1){for(let ge=fe;ge>=0;ge--){const pe=se.charCodeAt(ge);if(pe!==32&&pe!==9)return ge}return-1}e.$Dd=s;function i(se,fe,ge){const pe=[];let ye=0;for(const Ee of se.matchAll(fe)){if(pe.push(se.slice(ye,Ee.index)),Ee.index===void 0)throw new Error("match.index should be defined");ye=Ee.index+Ee[0].length,pe.push(ge(Ee[0],...Ee.slice(1),Ee.index,se,Ee.groups))}return pe.push(se.slice(ye)),Promise.all(pe).then(Ee=>Ee.join(""))}e.$Ed=i;function r(se,fe){return se<fe?-1:se>fe?1:0}e.$Fd=r;function a(se,fe,ge=0,pe=se.length,ye=0,Ee=fe.length){for(;ge<pe&&ye<Ee;ge++,ye++){const Oe=se.charCodeAt(ge),Be=fe.charCodeAt(ye);if(Oe<Be)return-1;if(Oe>Be)return 1}const Re=pe-ge,Ie=Ee-ye;return Re<Ie?-1:Re>Ie?1:0}e.$Gd=a;function w(se,fe){return g(se,fe,0,se.length,0,fe.length)}e.$Hd=w;function g(se,fe,ge=0,pe=se.length,ye=0,Ee=fe.length){for(;ge<pe&&ye<Ee;ge++,ye++){let Oe=se.charCodeAt(ge),Be=fe.charCodeAt(ye);if(Oe===Be)continue;if(Oe>=128||Be>=128)return a(se.toLowerCase(),fe.toLowerCase(),ge,pe,ye,Ee);k(Oe)&&(Oe-=32),k(Be)&&(Be-=32);const Me=Oe-Be;if(Me!==0)return Me}const Re=pe-ge,Ie=Ee-ye;return Re<Ie?-1:Re>Ie?1:0}e.$Id=g;function f(se){return se>=48&&se<=57}e.$Jd=f;function k(se){return se>=97&&se<=122}e.$Kd=k;function A(se){return se>=65&&se<=90}e.$Ld=A;function M(se,fe){return se.length===fe.length&&g(se,fe)===0}e.$Md=M;function F(se,fe){const ge=fe.length;return fe.length>se.length?!1:g(se,fe,0,ge)===0}e.$Nd=F;function V(se,fe){const ge=Math.min(se.length,fe.length);let pe;for(pe=0;pe<ge;pe++)if(se.charCodeAt(pe)!==fe.charCodeAt(pe))return pe;return ge}e.$Od=V;function B(se,fe){const ge=Math.min(se.length,fe.length);let pe;const ye=se.length-1,Ee=fe.length-1;for(pe=0;pe<ge;pe++)if(se.charCodeAt(ye-pe)!==fe.charCodeAt(Ee-pe))return pe;return ge}e.$Pd=B;function x(se){return 55296<=se&&se<=56319}e.$Qd=x;function Z(se){return 56320<=se&&se<=57343}e.$Rd=Z;function Q(se,fe){return(se-55296<<10)+(fe-56320)+65536}e.$Sd=Q;function J(se,fe,ge){const pe=se.charCodeAt(ge);if(x(pe)&&ge+1<fe){const ye=se.charCodeAt(ge+1);if(Z(ye))return Q(pe,ye)}return pe}e.$Td=J;function X(se,fe){const ge=se.charCodeAt(fe-1);if(Z(ge)&&fe>1){const pe=se.charCodeAt(fe-2);if(x(pe))return Q(pe,ge)}return ge}class W{get offset(){return this.e}constructor(fe,ge=0){this.c=fe,this.d=fe.length,this.e=ge}setOffset(fe){this.e=fe}prevCodePoint(){const fe=X(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=J(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$Ud=W;class U{get offset(){return this.c.offset}constructor(fe,ge=0){this.c=new W(fe,ge)}nextGraphemeLength(){const fe=Se.getInstance(),ge=this.c,pe=ge.offset;let ye=fe.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ee=ge.offset,Re=fe.getGraphemeBreakType(ge.nextCodePoint());if(de(ye,Re)){ge.setOffset(Ee);break}ye=Re}return ge.offset-pe}prevGraphemeLength(){const fe=Se.getInstance(),ge=this.c,pe=ge.offset;let ye=fe.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ee=ge.offset,Re=fe.getGraphemeBreakType(ge.prevCodePoint());if(de(Re,ye)){ge.setOffset(Ee);break}ye=Re}return pe-ge.offset}eol(){return this.c.eol()}}e.$Vd=U;function q(se,fe){return new U(se,fe).nextGraphemeLength()}e.$Wd=q;function te(se,fe){return new U(se,fe).prevGraphemeLength()}e.$Xd=te;function re(se,fe){fe>0&&Z(se.charCodeAt(fe))&&fe--;const ge=fe+q(se,fe);return[ge-te(se,ge),ge]}e.$Yd=re;function ce(se){const fe=new U(se);let ge=0;for(;!fe.eol();)ge++,fe.nextGraphemeLength();return ge}e.$Zd=ce;let G;function N(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function $(se){return G||(G=N()),G.test(se)}e.$1d=$;const D=/^[\t\n\r\x20-\x7E]*$/;function z(se){return D.test(se)}e.$2d=z,e.$3d=/[\u2028\u2029]/;function K(se){return e.$3d.test(se)}e.$4d=K;function _(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}e.$5d=_;function H(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}e.$6d=H;function ee(se,fe){if(se.length<fe)return se;const ge=/\b/g;let pe=0;for(;ge.test(se)&&!(se.length-ge.lastIndex<fe);)pe=ge.lastIndex,ge.lastIndex+=1;return se.substring(pe).replace(/^\s/,"")}e.$7d=ee;const ie=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,le=/\x1b\].*?\x07/g;function he(se){return se&&(se=se.replace(ie,"").replace(le,"")),se}e.$8d=he,e.$9d=String.fromCharCode(65279);function me(se){return!!(se&&se.length>0&&se.charCodeAt(0)===65279)}e.$0d=me;function be(se){return me(se)?se.substr(1):se}e.$$d=be;function ke(se,fe){if(!se||!fe||se.length<fe.length)return!1;const ge=fe.length,pe=se.toLowerCase();let ye=0,Ee=-1;for(;ye<ge;){const Re=pe.indexOf(fe[ye],Ee+1);if(Re<0)return!1;Ee=Re,ye++}return!0}e.$_d=ke;function Pe(se,fe=!1){return se?(fe&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}e.$ae=Pe;function je(se){return se.charAt(0).toUpperCase()+se.slice(1)}e.$be=je;function De(se,fe=1){if(fe===0)return"";let ge=-1;do ge=se.indexOf(`
`,ge+1),fe--;while(fe>0&&ge>=0);return ge===-1?se:(se[ge-1]==="\r"&&ge--,se.substr(0,ge))}e.$ce=De;function We(se){return se=se%(2*26),se<26?String.fromCharCode(97+se):String.fromCharCode(65+se-26)}e.$de=We;function ue(se){return Se.getInstance().getGraphemeBreakType(se)}e.$ee=ue;function de(se,fe){return se===0?fe!==5&&fe!==7:se===2&&fe===3?!1:se===4||se===2||se===3||fe===4||fe===2||fe===3?!0:!(se===8&&(fe===8||fe===9||fe===11||fe===12)||(se===11||se===9)&&(fe===9||fe===10)||(se===12||se===10)&&fe===10||fe===5||fe===13||fe===7||se===1||se===13&&fe===14||se===6&&fe===6)}var $e;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})($e||(e.GraphemeBreakType=$e={}));class Se{static{this.c=null}static getInstance(){return Se.c||(Se.c=new Se),Se.c}constructor(){this.d=Ce()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const ge=this.d,pe=ge.length/3;let ye=1;for(;ye<=pe;)if(fe<ge[3*ye])ye=2*ye;else if(fe>ge[3*ye+1])ye=2*ye+1;else return ge[3*ye+2];return 0}}function Ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(se,fe){if(se===0)return 0;const ge=Le(se,fe);if(ge!==void 0)return ge;const pe=new W(fe,se);return pe.prevCodePoint(),pe.offset}e.$fe=Fe;function Le(se,fe){const ge=new W(fe,se);let pe=ge.prevCodePoint();for(;Ue(pe)||pe===65039||pe===8419;){if(ge.offset===0)return;pe=ge.prevCodePoint()}if(!H(pe))return;let ye=ge.offset;return ye>0&&ge.prevCodePoint()===8205&&(ye=ge.offset),ye}function Ue(se){return 127995<=se&&se<=127999}var Ae;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={})),e.$ge="\xA0";class Ne{static{this.c=new T.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$gd(fe=>{function ge(Me){const qe=new Map;for(let He=0;He<Me.length;He+=2)qe.set(Me[He],Me[He+1]);return qe}function pe(Me,qe){const He=new Map(Me);for(const[_e,nt]of qe)He.set(_e,nt);return He}function ye(Me,qe){if(!Me)return qe;const He=new Map;for(const[_e,nt]of Me)qe.has(_e)&&He.set(_e,nt);return He}const Ee=this.c.value;let Re=fe.filter(Me=>!Me.startsWith("_")&&Me in Ee);Re.length===0&&(Re=["_default"]);let Ie;for(const Me of Re){const qe=ge(Ee[Me]);Ie=ye(Ie,qe)}const Oe=ge(Ee._common),Be=pe(Oe,Ie);return new Ne(Be)})}static getInstance(fe){return Ne.d.get(Array.from(fe))}static{this.e=new T.$T(()=>Object.keys(Ne.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return Ne.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$he=Ne;class ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ze.c())),this.d}static isInvisibleCharacter(fe){return ze.e().has(fe)}static get codePoints(){return ze.e()}}e.$ie=ze}),define(oe[51],ae([0,1,27]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=void 0;function T(l){return O(l,0)}e.$di=T;function O(l,u){switch(typeof l){case"object":return l===null?j(349,u):Array.isArray(l)?S(l,u):b(l,u);case"string":return P(l,u);case"boolean":return L(l,u);case"number":return j(l,u);case"undefined":return j(937,u);default:return j(617,u)}}e.$ei=O;function j(l,u){return(u<<5)-u+l|0}e.$fi=j;function L(l,u){return j(l?433:863,u)}function P(l,u){u=j(149417,u);for(let y=0,p=l.length;y<p;y++)u=j(l.charCodeAt(y),u);return u}e.$gi=P;function S(l,u){return u=j(104579,u),l.reduce((y,p)=>O(p,y),u)}function b(l,u){return u=j(181387,u),Object.keys(l).sort().reduce((y,p)=>(y=P(p,y),O(l[p],y)),u)}class C{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=O(u,this.g),this.g}}e.$hi=C;var E;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function m(l,u,y=32){const p=y-u,R=~((1<<p)-1);return(l<<u|(R&l)>>>p)>>>0}function h(l,u=0,y=l.byteLength,p=0){for(let R=0;R<y;R++)l[u+R]=p}function d(l,u,y="0"){for(;l.length<u;)l=y+l;return l}function v(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(y=>y.toString(16).padStart(2,"0")).join(""):d((l>>>0).toString(16),u/4)}e.$ii=v;class c{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const y=u.length;if(y===0)return;const p=this.p;let R=this.r,t=this.u,o,n;for(t!==0?(o=t,n=-1,t=0):(o=u.charCodeAt(0),n=0);;){let s=o;if(I.$Qd(o))if(n+1<y){const i=u.charCodeAt(n+1);I.$Rd(i)?(n++,s=I.$Sd(o,i)):s=65533}else{t=o;break}else I.$Rd(o)&&(s=65533);if(R=this.w(p,R,s),n++,n<y)o=u.charCodeAt(n);else break}this.r=R,this.u=t}w(u,y,p){return p<128?u[y++]=p:p<2048?(u[y++]=192|(p&1984)>>>6,u[y++]=128|(p&63)>>>0):p<65536?(u[y++]=224|(p&61440)>>>12,u[y++]=128|(p&4032)>>>6,u[y++]=128|(p&63)>>>0):(u[y++]=240|(p&1835008)>>>18,u[y++]=128|(p&258048)>>>12,u[y++]=128|(p&4032)>>>6,u[y++]=128|(p&63)>>>0),y>=64&&(this.y(),y-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),y}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=c.g,y=this.q;for(let a=0;a<64;a+=4)u.setUint32(a,y.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)u.setUint32(a,m(u.getUint32(a-12,!1)^u.getUint32(a-32,!1)^u.getUint32(a-56,!1)^u.getUint32(a-64,!1),1),!1);let p=this.h,R=this.l,t=this.m,o=this.n,n=this.o,s,i,r;for(let a=0;a<80;a++)a<20?(s=R&t|~R&o,i=1518500249):a<40?(s=R^t^o,i=1859775393):a<60?(s=R&t|R&o|t&o,i=2400959708):(s=R^t^o,i=3395469782),r=m(p,5)+s+n+i+u.getUint32(a*4,!1)&4294967295,n=o,o=t,t=m(R,30),R=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+R&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$ji=c}),define(oe[88],ae([0,1,27]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(O){O[O.Ignore=0]="Ignore",O[O.Info=1]="Info",O[O.Warning=2]="Warning",O[O.Error=3]="Error"})(T||(T={})),function(O){const j="error",L="warning",P="warn",S="info",b="ignore";function C(m){return m?I.$Md(j,m)?O.Error:I.$Md(L,m)||I.$Md(P,m)?O.Warning:I.$Md(S,m)?O.Info:O.Ignore:O.Ignore}O.fromValue=C;function E(m){switch(m){case O.Error:return j;case O.Warning:return L;case O.Info:return S;default:return b}}O.toString=E}(T||(T={})),e.default=T}),define(oe[126],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0,e.$5c=Symbol("MicrotaskDelay")}),define(oe[47],ae([0,1,21,27]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=void 0;class O{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const d=h.charCodeAt(0),v=this.b.charCodeAt(this.c);return d-v}value(){return this.b[this.c]}}e.$rh=O;class j{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,T.$Gd)(h,this.b,0,h.length,this.c,this.d):(0,T.$Id)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$sh=j;class L{constructor(h=!0,d=!0){this.f=h,this.g=d}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let d=h.length-1;d>=0;d--,this.c--){const v=this.b.charCodeAt(d);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,T.$Gd)(h,this.b,0,h.length,this.d,this.e):(0,T.$Id)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$th=L;var P;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(P||(P={}));class S{constructor(h,d){this.f=h,this.g=d,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,T.$Hd)(h,this.c.scheme);if(this.d[this.e]===2)return(0,T.$Hd)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,T.$Fd)(h,this.c.query);if(this.d[this.e]===5)return(0,T.$Fd)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$uh=S;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(C||(C={}));class E{static forUris(h=()=>!1,d=()=>!1){return new E(new S(h,d))}static forPaths(h=!1){return new E(new L(void 0,!h))}static forStrings(){return new E(new O)}static forConfigKeys(){return new E(new j)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,d){if(d){const v=d.slice(0);(0,I.$Ef)(v);for(const c of v)this.set(c,h)}else{const v=h.slice(0);(0,I.$Ef)(v);for(const c of v)this.set(c[0],c[1])}}set(h,d){const v=this.b.reset(h);let c;this.c||(this.c=new b,this.c.segment=v.value());const l=[];for(c=this.c;;){const y=v.cmp(c.segment);if(y>0)c.left||(c.left=new b,c.left.segment=v.value()),l.push([-1,c]),c=c.left;else if(y<0)c.right||(c.right=new b,c.right.segment=v.value()),l.push([1,c]),c=c.right;else if(v.hasNext())v.next(),c.mid||(c.mid=new b,c.mid.segment=v.value()),l.push([0,c]),c=c.mid;else break}const u=c.value;c.value=d,c.key=h;for(let y=l.length-1;y>=0;y--){const p=l[y][1];p.updateHeight();const R=p.balanceFactor();if(R<-1||R>1){const t=l[y][0],o=l[y+1][0];if(t===1&&o===1)l[y][1]=p.rotateLeft();else if(t===-1&&o===-1)l[y][1]=p.rotateRight();else if(t===1&&o===-1)p.right=l[y+1][1]=l[y+1][1].rotateRight(),l[y][1]=p.rotateLeft();else if(t===-1&&o===1)p.left=l[y+1][1]=l[y+1][1].rotateLeft(),l[y][1]=p.rotateRight();else throw new Error;if(y>0)switch(l[y-1][0]){case-1:l[y-1][1].left=l[y][1];break;case 1:l[y-1][1].right=l[y][1];break;case 0:l[y-1][1].mid=l[y][1];break}else this.c=l[0][1]}}return u}get(h){return this.d(h)?.value}d(h){const d=this.b.reset(h);let v=this.c;for(;v;){const c=d.cmp(v.segment);if(c>0)v=v.left;else if(c<0)v=v.right;else if(d.hasNext())d.next(),v=v.mid;else break}return v}has(h){const d=this.d(h);return!(d?.value===void 0&&d?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,d){const v=this.b.reset(h),c=[];let l=this.c;for(;l;){const u=v.cmp(l.segment);if(u>0)c.push([-1,l]),l=l.left;else if(u<0)c.push([1,l]),l=l.right;else if(v.hasNext())v.next(),c.push([0,l]),l=l.mid;else break}if(l){if(d?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const u=this.f(l.right);if(u.key){const{key:y,value:p,segment:R}=u;this.e(u.key,!1),l.key=y,l.value=p,l.segment=R}}else{const u=l.left??l.right;if(c.length>0){const[y,p]=c[c.length-1];switch(y){case-1:p.left=u;break;case 0:p.mid=u;break;case 1:p.right=u;break}}else this.c=u}for(let u=c.length-1;u>=0;u--){const y=c[u][1];y.updateHeight();const p=y.balanceFactor();if(p>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),c[u][1]=y.rotateLeft()):p<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),c[u][1]=y.rotateRight()),u>0)switch(c[u-1][0]){case-1:c[u-1][1].left=c[u][1];break;case 1:c[u-1][1].right=c[u][1];break;case 0:c[u-1][1].mid=c[u][1];break}else this.c=c[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const d=this.b.reset(h);let v=this.c,c;for(;v;){const l=d.cmp(v.segment);if(l>0)v=v.left;else if(l<0)v=v.right;else if(d.hasNext())d.next(),c=v.value||c,v=v.mid;else break}return v&&v.value||c}findSuperstr(h){return this.g(h,!1)}g(h,d){const v=this.b.reset(h);let c=this.c;for(;c;){const l=v.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(v.hasNext())v.next(),c=c.mid;else return c.mid?this.h(c.mid):d?c.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[d,v]of this)h(v,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const d=[];return this.j(h,d),d[Symbol.iterator]()}j(h,d){h&&(h.left&&this.j(h.left,d),h.value&&d.push([h.key,h.value]),h.mid&&this.j(h.mid,d),h.right&&this.j(h.right,d))}_isBalanced(){const h=d=>{if(!d)return!0;const v=d.balanceFactor();return v<-1||v>1?!1:h(d.left)&&h(d.right)};return h(this.c)}}e.$vh=E}),define(oe[11],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;function I(o){return typeof o=="string"}e.$je=I;function T(o){return Array.isArray(o)&&o.every(n=>I(n))}e.$ke=T;function O(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.$le=O;function j(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}e.$me=j;function L(o){return typeof o=="number"&&!isNaN(o)}e.$ne=L;function P(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.$oe=P;function S(o){return o===!0||o===!1}e.$pe=S;function b(o){return typeof o>"u"}e.$qe=b;function C(o){return!E(o)}e.$re=C;function E(o){return b(o)||o===null}e.$se=E;function m(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.$te=m;function h(o){if(E(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.$ue=h;function d(...o){const n=[];for(let s=0;s<o.length;s++){const i=o[s];if(E(i))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(i)}return n}e.$ve=d;const v=Object.prototype.hasOwnProperty;function c(o){if(!O(o))return!1;for(const n in o)if(v.call(o,n))return!1;return!0}e.$we=c;function l(o){return typeof o=="function"}e.$xe=l;function u(...o){return o.length>0&&o.every(l)}e.$ye=u;function y(o,n){const s=Math.min(o.length,n.length);for(let i=0;i<s;i++)p(o[i],n[i])}e.$ze=y;function p(o,n){if(I(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(l(n)){try{if(o instanceof n)return}catch{}if(!E(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Ae=p;function R(o){return o===null?void 0:o}e.$Be=R;function t(o){return typeof o>"u"?null:o}e.$Ce=t}),define(oe[30],ae([0,1,11]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=void 0;function T(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([y,p])=>{u[y]=p&&typeof p=="object"?T(p):p}),u}e.$Hm=T;function O(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const y=u.shift();Object.freeze(y);for(const p in y)if(j.call(y,p)){const R=y[p];typeof R=="object"&&!Object.isFrozen(R)&&!(0,I.$me)(R)&&u.push(R)}}return l}e.$Im=O;const j=Object.prototype.hasOwnProperty;function L(l,u){return P(l,u,new Set)}e.$Jm=L;function P(l,u,y){if((0,I.$se)(l))return l;const p=u(l);if(typeof p<"u")return p;if(Array.isArray(l)){const R=[];for(const t of l)R.push(P(t,u,y));return R}if((0,I.$le)(l)){if(y.has(l))throw new Error("Cannot clone recursive data-structure");y.add(l);const R={};for(const t in l)j.call(l,t)&&(R[t]=P(l[t],u,y));return y.delete(l),R}return l}function S(l,u,y=!0){return(0,I.$le)(l)?((0,I.$le)(u)&&Object.keys(u).forEach(p=>{p in l?y&&((0,I.$le)(l[p])&&(0,I.$le)(u[p])?S(l[p],u[p],y):l[p]=u[p]):l[p]=u[p]}),l):u}e.$Km=S;function b(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let y,p;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(y=0;y<l.length;y++)if(!b(l[y],u[y]))return!1}else{const R=[];for(p in l)R.push(p);R.sort();const t=[];for(p in u)t.push(p);if(t.sort(),!b(R,t))return!1;for(y=0;y<R.length;y++)if(!b(l[R[y]],u[R[y]]))return!1}return!0}e.$Lm=b;function C(l){const u=new Set;return JSON.stringify(l,(y,p)=>{if((0,I.$le)(p)||Array.isArray(p)){if(u.has(p))return"[Circular]";u.add(p)}return p})}e.$Mm=C;function E(l,u){const y=Object.create(null);return!l||!u||Object.keys(u).forEach(R=>{const t=l[R],o=u[R];b(t,o)||(y[R]=o)}),y}e.$Nm=E;function m(l,u){const y=u.toLowerCase(),p=Object.keys(l).find(R=>R.toLowerCase()===y);return p?l[p]:l[u]}e.$Om=m;function h(l,u){const y=Object.create(null);for(const[p,R]of Object.entries(l))u(p,R)&&(y[p]=R);return y}e.$Pm=h;function d(l){let u=[];for(;Object.prototype!==l;)u=u.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return u}e.$Qm=d;function v(l){const u=[];for(const y of d(l))typeof l[y]=="function"&&u.push(y);return u}e.$Rm=v;function c(l,u){const y=R=>function(){const t=Array.prototype.slice.call(arguments,0);return u(R,t)},p={};for(const R of l)p[R]=y(R);return p}e.$Sm=c}),define(oe[32],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(O){return I.test(O)}e.$5e=T,e.$6e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(P){for(let S=0;S<P.length;S++)P[S]=Math.floor(Math.random()*256);return P};const j=new Uint8Array(16),L=[];for(let P=0;P<256;P++)L.push(P.toString(16).padStart(2,"0"));return function(){O(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let S=0,b="";return b+=L[j[S++]],b+=L[j[S++]],b+=L[j[S++]],b+=L[j[S++]],b+="-",b+=L[j[S++]],b+=L[j[S++]],b+="-",b+=L[j[S++]],b+=L[j[S++]],b+="-",b+=L[j[S++]],b+=L[j[S++]],b+="-",b+=L[j[S++]],b+=L[j[S++]],b+=L[j[S++]],b+=L[j[S++]],b+=L[j[S++]],b+=L[j[S++]],b}}()}),define(oe[127],ae([0,1,36]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=void 0;const T=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function O(L){const P=L.replace(/\-/g,":").toLowerCase();return!T.has(P)}function j(){const L=(0,I.networkInterfaces)();for(const P in L){const S=L[P];if(S){for(const{mac:b}of S)if(O(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$sm=j}),define(oe[128],ae([0,1,36,47,32,127]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0,e.$tm=new class{c(b){return this.a||(this.a=T.$vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,C=0;const E=(0,I.networkInterfaces)();for(const m in E){const h=E[m];if(h)for(const{mac:d,internal:v}of h)v||(C+=1,this.c(d.toUpperCase())&&(b+=1))}this.b=C>0?b/C:0}return this.b}};let L;async function P(b){return L||(L=(async()=>await S(b)||O.$6e())()),L}e.$um=P;async function S(b){try{const C=await new Promise((m,h)=>{ne(["crypto"],m,h)}),E=(0,j.$sm)();return C.createHash("sha256").update(E,"utf8").digest("hex")}catch(C){b(C);return}}}),define(oe[129],ae([0,1,263,14]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kS=void 0;class O extends I.Transform{constructor(L){if(super(),typeof L=="number")this.b=L,this.c=1;else{const P=Buffer.isBuffer(L)?L:Buffer.from(L);this.b=P.length===1?P[0]:P,this.c=P.length}}_transform(L,P,S){this.a?this.a=Buffer.concat([this.a,L]):this.a=L;let b=0;for(;b<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,b):(0,T.$Kb)(this.a,this.b,b);if(C===-1)break;this.push(this.a.slice(b,C+this.c)),b=C+this.c}this.a=b===this.a.length?void 0:this.a.slice(b),S()}_flush(L){this.a&&this.push(this.a),L()}}e.$kS=O}),define(oe[130],ae([0,1,60]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$8e=void 0;function T(P,S,b,C=1){let E=!1;return new Promise(m=>{const h=setTimeout(()=>{if(!E)return E=!0,m(0)},b);O(P,S,C,d=>{if(!E)return E=!0,clearTimeout(h),m(d)})})}e.$8e=T;function O(P,S,b,C){if(S===0)return C(0);const E=new I.Socket;E.once("connect",()=>(L(E),O(P+b,S-1,b,C))),E.once("data",()=>{}),E.once("error",m=>(L(E),m.code!=="ECONNREFUSED"?O(P+b,S-1,b,C):C(P))),E.connect(P,"127.0.0.1")}e.$9e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(P,S,b,C="127.0.0.1"){let E=!1,m,h=1;const d=I.createServer({pauseOnConnect:!0});function v(c,l){E||(E=!0,d.removeAllListeners(),d.close(),m&&clearTimeout(m),l(c))}return new Promise(c=>{m=setTimeout(()=>{v(0,c)},b),d.on("listening",()=>{v(P,c)}),d.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&h<S?(P++,h++,d.listen(P,C)):v(0,c)}),d.on("close",()=>{v(0,c)}),d.listen(P,C)})}e.$0e=j;function L(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(S){console.error(S)}}}),define(oe[131],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AS=void 0;function I(T){return!!T.parentPort}e.$AS=I}),define(oe[132],ae([12,9]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(oe[61],ae([0,1,132]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=void 0;const T=60,O=T*60,j=O*24,L=j*7,P=j*30,S=j*365;function b(E,m,h,d){typeof E!="number"&&(E=E.getTime());const v=Math.round((new Date().getTime()-E)/1e3);if(v<-30)return(0,I.localize)(0,null,b(new Date().getTime()+v*1e3,!1));if(!d&&v<30)return(0,I.localize)(1,null);let c;return v<T?(c=v,m?c===1?h?(0,I.localize)(2,null,c):(0,I.localize)(3,null,c):h?(0,I.localize)(4,null,c):(0,I.localize)(5,null,c):c===1?h?(0,I.localize)(6,null,c):(0,I.localize)(7,null,c):h?(0,I.localize)(8,null,c):(0,I.localize)(9,null,c)):v<O?(c=Math.floor(v/T),m?c===1?h?(0,I.localize)(10,null,c):(0,I.localize)(11,null,c):h?(0,I.localize)(12,null,c):(0,I.localize)(13,null,c):c===1?h?(0,I.localize)(14,null,c):(0,I.localize)(15,null,c):h?(0,I.localize)(16,null,c):(0,I.localize)(17,null,c)):v<j?(c=Math.floor(v/O),m?c===1?h?(0,I.localize)(18,null,c):(0,I.localize)(19,null,c):h?(0,I.localize)(20,null,c):(0,I.localize)(21,null,c):c===1?h?(0,I.localize)(22,null,c):(0,I.localize)(23,null,c):h?(0,I.localize)(24,null,c):(0,I.localize)(25,null,c)):v<L?(c=Math.floor(v/j),m?c===1?(0,I.localize)(26,null,c):(0,I.localize)(27,null,c):c===1?(0,I.localize)(28,null,c):(0,I.localize)(29,null,c)):v<P?(c=Math.floor(v/L),m?c===1?h?(0,I.localize)(30,null,c):(0,I.localize)(31,null,c):h?(0,I.localize)(32,null,c):(0,I.localize)(33,null,c):c===1?h?(0,I.localize)(34,null,c):(0,I.localize)(35,null,c):h?(0,I.localize)(36,null,c):(0,I.localize)(37,null,c)):v<S?(c=Math.floor(v/P),m?c===1?h?(0,I.localize)(38,null,c):(0,I.localize)(39,null,c):h?(0,I.localize)(40,null,c):(0,I.localize)(41,null,c):c===1?h?(0,I.localize)(42,null,c):(0,I.localize)(43,null,c):h?(0,I.localize)(44,null,c):(0,I.localize)(45,null,c)):(c=Math.floor(v/S),m?c===1?h?(0,I.localize)(46,null,c):(0,I.localize)(47,null,c):h?(0,I.localize)(48,null,c):(0,I.localize)(49,null,c):c===1?h?(0,I.localize)(50,null,c):(0,I.localize)(51,null,c):h?(0,I.localize)(52,null,c):(0,I.localize)(53,null,c))}e.$Rl=b;function C(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Sl=C}),define(oe[133],ae([12,9]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,21,11,133]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=void 0;function j(E,m){return m&&(E.stack||E.stacktrace)?O.localize(0,null,P(E),L(E.stack)||L(E.stacktrace)):P(E)}function L(E){return Array.isArray(E)?E.join(`
`):E}function P(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?O.localize(1,null,E.message):E.message||O.localize(2,null)}function S(E=null,m=!1){if(!E)return O.localize(3,null);if(Array.isArray(E)){const h=I.$mf(E),d=S(h[0],m);return h.length>1?O.localize(4,null,d,h.length):d}if(T.$je(E))return E;if(E.detail){const h=E.detail;if(h.error)return j(h.error,m);if(h.exception)return j(h.exception,m)}return E.stack?j(E,m):E.message?E.message:O.localize(5,null)}e.$ai=S;function b(E){const m=E;return m instanceof Error&&Array.isArray(m.actions)}e.$bi=b;function C(E,m){let h;return typeof E=="string"?h=new Error(E):h=E,h.actions=m,h}e.$ci=C}),define(oe[134],ae([12,9]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(oe[135],ae([0,1,134]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=void 0;function T(O){switch(O){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.$bp=T}),define(oe[136],ae([12,9]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(oe[5],ae([0,1,136]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let T=!1,O=!1,j=!1,L=!1,P=!1,S=!1,b=!1,C=!1,E=!1,m=!1,h,d=e.$f,v=e.$f,c,l;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?u=e.$g.vscode.process:typeof process<"u"&&(u=process);const y=typeof u?.versions?.electron=="string",p=y&&u?.type==="renderer";if(typeof navigator=="object"&&!p)l=navigator.userAgent,T=l.indexOf("Windows")>=0,O=l.indexOf("Macintosh")>=0,C=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=l.indexOf("Linux")>=0,m=l?.indexOf("Mobi")>=0,S=!0,h=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$f,d=h,v=navigator.language;else if(typeof u=="object"){T=u.platform==="win32",O=u.platform==="darwin",j=u.platform==="linux",L=j&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,b=y,E=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$f,d=e.$f;const w=u.env.VSCODE_NLS_CONFIG;if(w)try{const g=JSON.parse(w),f=g.availableLanguages["*"];h=g.locale,v=g.osLocale,d=f||e.$f,c=g._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var R;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(R||(e.Platform=R={}));function t(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let o=0;O?o=1:T?o=3:j&&(o=2),e.$i=T,e.$j=O,e.$k=j,e.$l=L,e.$m=P,e.$n=b,e.$o=S,e.$p=S&&typeof e.$g.importScripts=="function",e.$q=C,e.$r=m,e.$s=E,e.$t=o,e.$u=l,e.$v=d;var n;(function(w){function g(){return e.$v}w.value=g;function f(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}w.isDefaultVariant=f;function k(){return e.$v==="en"}w.isDefault=k})(n||(e.Language=n={})),e.$w=h,e.$x=v,e.$y=c,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const w=[];e.$g.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let k=0,A=w.length;k<A;k++){const M=w[k];if(M.id===f.data.vscodeScheduleAsyncWork){w.splice(k,1),M.callback();return}}});let g=0;return f=>{const k=++g;w.push({id:k,callback:f}),e.$g.postMessage({vscodeScheduleAsyncWork:k},"*")}}return w=>setTimeout(w)})();var s;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=O||C?2:T?1:3;let i=!0,r=!1;function a(){if(!r){r=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,i=new Uint16Array(w.buffer)[0]===(2<<8)+1}return i}e.$C=a,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(oe[37],ae([0,1,5]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8b=e.$7b=e.env=e.cwd=void 0;let T;if(typeof I.$g.vscode<"u"&&typeof I.$g.vscode.process<"u"){const O=I.$g.vscode.process;T={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return I.$i?"win32":I.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$7b=T.platform,e.$8b=T.arch}),define(oe[16],ae([0,1,37]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kc=e.sep=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=void 0;const T=65,O=97,j=90,L=122,P=46,S=47,b=92,C=58,E=63;class m extends Error{constructor(o,n,s){let i;typeof n=="string"&&n.indexOf("not ")===0?(i="must not be",n=n.replace(/^not /,"")):i="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${i} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,o){if(t===null||typeof t!="object")throw new m(o,"Object",t)}function d(t,o){if(typeof t!="string")throw new m(o,"string",t)}const v=I.$7b==="win32";function c(t){return t===S||t===b}function l(t){return t===S}function u(t){return t>=T&&t<=j||t>=O&&t<=L}function y(t,o,n,s){let i="",r=0,a=-1,w=0,g=0;for(let f=0;f<=t.length;++f){if(f<t.length)g=t.charCodeAt(f);else{if(s(g))break;g=S}if(s(g)){if(!(a===f-1||w===1))if(w===2){if(i.length<2||r!==2||i.charCodeAt(i.length-1)!==P||i.charCodeAt(i.length-2)!==P){if(i.length>2){const k=i.lastIndexOf(n);k===-1?(i="",r=0):(i=i.slice(0,k),r=i.length-1-i.lastIndexOf(n)),a=f,w=0;continue}else if(i.length!==0){i="",r=0,a=f,w=0;continue}}o&&(i+=i.length>0?`${n}..`:"..",r=2)}else i.length>0?i+=`${n}${t.slice(a+1,f)}`:i=t.slice(a+1,f),r=f-a-1;a=f,w=0}else g===P&&w!==-1?++w:w=-1}return i}function p(t,o){h(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${t}${s}`:s}e.$9b={resolve(...t){let o="",n="",s=!1;for(let i=t.length-1;i>=-1;i--){let r;if(i>=0){if(r=t[i],d(r,"path"),r.length===0)continue}else o.length===0?r=I.cwd():(r=I.env[`=${o}`]||I.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===b)&&(r=`${o}\\`));const a=r.length;let w=0,g="",f=!1;const k=r.charCodeAt(0);if(a===1)c(k)&&(w=1,f=!0);else if(c(k))if(f=!0,c(r.charCodeAt(1))){let A=2,M=A;for(;A<a&&!c(r.charCodeAt(A));)A++;if(A<a&&A!==M){const F=r.slice(M,A);for(M=A;A<a&&c(r.charCodeAt(A));)A++;if(A<a&&A!==M){for(M=A;A<a&&!c(r.charCodeAt(A));)A++;(A===a||A!==M)&&(g=`\\\\${F}\\${r.slice(M,A)}`,w=A)}}}else w=1;else u(k)&&r.charCodeAt(1)===C&&(g=r.slice(0,2),w=2,a>2&&c(r.charCodeAt(2))&&(f=!0,w=3));if(g.length>0)if(o.length>0){if(g.toLowerCase()!==o.toLowerCase())continue}else o=g;if(s){if(o.length>0)break}else if(n=`${r.slice(w)}\\${n}`,s=f,f&&o.length>0)break}return n=y(n,!s,"\\",c),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(t){d(t,"path");const o=t.length;if(o===0)return".";let n=0,s,i=!1;const r=t.charCodeAt(0);if(o===1)return l(r)?"\\":t;if(c(r))if(i=!0,c(t.charCodeAt(1))){let w=2,g=w;for(;w<o&&!c(t.charCodeAt(w));)w++;if(w<o&&w!==g){const f=t.slice(g,w);for(g=w;w<o&&c(t.charCodeAt(w));)w++;if(w<o&&w!==g){for(g=w;w<o&&!c(t.charCodeAt(w));)w++;if(w===o)return`\\\\${f}\\${t.slice(g)}\\`;w!==g&&(s=`\\\\${f}\\${t.slice(g,w)}`,n=w)}}}else n=1;else u(r)&&t.charCodeAt(1)===C&&(s=t.slice(0,2),n=2,o>2&&c(t.charCodeAt(2))&&(i=!0,n=3));let a=n<o?y(t.slice(n),!i,"\\",c):"";return a.length===0&&!i&&(a="."),a.length>0&&c(t.charCodeAt(o-1))&&(a+="\\"),s===void 0?i?`\\${a}`:a:i?`${s}\\${a}`:`${s}${a}`},isAbsolute(t){d(t,"path");const o=t.length;if(o===0)return!1;const n=t.charCodeAt(0);return c(n)||o>2&&u(n)&&t.charCodeAt(1)===C&&c(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,n;for(let r=0;r<t.length;++r){const a=t[r];d(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,i=0;if(typeof n=="string"&&c(n.charCodeAt(0))){++i;const r=n.length;r>1&&c(n.charCodeAt(1))&&(++i,r>2&&(c(n.charCodeAt(2))?++i:s=!1))}if(s){for(;i<o.length&&c(o.charCodeAt(i));)i++;i>=2&&(o=`\\${o.slice(i)}`)}return e.$9b.normalize(o)},relative(t,o){if(d(t,"from"),d(o,"to"),t===o)return"";const n=e.$9b.resolve(t),s=e.$9b.resolve(o);if(n===s||(t=n.toLowerCase(),o=s.toLowerCase(),t===o))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===b;)i++;let r=t.length;for(;r-1>i&&t.charCodeAt(r-1)===b;)r--;const a=r-i;let w=0;for(;w<o.length&&o.charCodeAt(w)===b;)w++;let g=o.length;for(;g-1>w&&o.charCodeAt(g-1)===b;)g--;const f=g-w,k=a<f?a:f;let A=-1,M=0;for(;M<k;M++){const V=t.charCodeAt(i+M);if(V!==o.charCodeAt(w+M))break;V===b&&(A=M)}if(M!==k){if(A===-1)return s}else{if(f>k){if(o.charCodeAt(w+M)===b)return s.slice(w+M+1);if(M===2)return s.slice(w+M)}a>k&&(t.charCodeAt(i+M)===b?A=M:M===2&&(A=3)),A===-1&&(A=0)}let F="";for(M=i+A+1;M<=r;++M)(M===r||t.charCodeAt(M)===b)&&(F+=F.length===0?"..":"\\..");return w+=A,F.length>0?`${F}${s.slice(w,g)}`:(s.charCodeAt(w)===b&&++w,s.slice(w,g))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$9b.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===b){if(o.charCodeAt(1)===b){const n=o.charCodeAt(2);if(n!==E&&n!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(u(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===b)return`\\\\?\\${o}`;return t},dirname(t){d(t,"path");const o=t.length;if(o===0)return".";let n=-1,s=0;const i=t.charCodeAt(0);if(o===1)return c(i)?t:".";if(c(i)){if(n=s=1,c(t.charCodeAt(1))){let w=2,g=w;for(;w<o&&!c(t.charCodeAt(w));)w++;if(w<o&&w!==g){for(g=w;w<o&&c(t.charCodeAt(w));)w++;if(w<o&&w!==g){for(g=w;w<o&&!c(t.charCodeAt(w));)w++;if(w===o)return t;w!==g&&(n=s=w+1)}}}}else u(i)&&t.charCodeAt(1)===C&&(n=o>2&&c(t.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let w=o-1;w>=s;--w)if(c(t.charCodeAt(w))){if(!a){r=w;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return t.slice(0,r)},basename(t,o){o!==void 0&&d(o,"ext"),d(t,"path");let n=0,s=-1,i=!0,r;if(t.length>=2&&u(t.charCodeAt(0))&&t.charCodeAt(1)===C&&(n=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let a=o.length-1,w=-1;for(r=t.length-1;r>=n;--r){const g=t.charCodeAt(r);if(c(g)){if(!i){n=r+1;break}}else w===-1&&(i=!1,w=r+1),a>=0&&(g===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=w))}return n===s?s=w:s===-1&&(s=t.length),t.slice(n,s)}for(r=t.length-1;r>=n;--r)if(c(t.charCodeAt(r))){if(!i){n=r+1;break}}else s===-1&&(i=!1,s=r+1);return s===-1?"":t.slice(n,s)},extname(t){d(t,"path");let o=0,n=-1,s=0,i=-1,r=!0,a=0;t.length>=2&&t.charCodeAt(1)===C&&u(t.charCodeAt(0))&&(o=s=2);for(let w=t.length-1;w>=o;--w){const g=t.charCodeAt(w);if(c(g)){if(!r){s=w+1;break}continue}i===-1&&(r=!1,i=w+1),g===P?n===-1?n=w:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||i===-1||a===0||a===1&&n===i-1&&n===s+1?"":t.slice(n,i)},format:p.bind(null,"\\"),parse(t){d(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.length;let s=0,i=t.charCodeAt(0);if(n===1)return c(i)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(c(i)){if(s=1,c(t.charCodeAt(1))){let A=2,M=A;for(;A<n&&!c(t.charCodeAt(A));)A++;if(A<n&&A!==M){for(M=A;A<n&&c(t.charCodeAt(A));)A++;if(A<n&&A!==M){for(M=A;A<n&&!c(t.charCodeAt(A));)A++;A===n?s=A:A!==M&&(s=A+1)}}}}else if(u(i)&&t.charCodeAt(1)===C){if(n<=2)return o.root=o.dir=t,o;if(s=2,c(t.charCodeAt(2))){if(n===3)return o.root=o.dir=t,o;s=3}}s>0&&(o.root=t.slice(0,s));let r=-1,a=s,w=-1,g=!0,f=t.length-1,k=0;for(;f>=s;--f){if(i=t.charCodeAt(f),c(i)){if(!g){a=f+1;break}continue}w===-1&&(g=!1,w=f+1),i===P?r===-1?r=f:k!==1&&(k=1):r!==-1&&(k=-1)}return w!==-1&&(r===-1||k===0||k===1&&r===w-1&&r===a+1?o.base=o.name=t.slice(a,w):(o.name=t.slice(a,r),o.base=t.slice(a,w),o.ext=t.slice(r,w))),a>0&&a!==s?o.dir=t.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const R=(()=>{if(v){const t=/\\/g;return()=>{const o=I.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>I.cwd()})();e.$0b={resolve(...t){let o="",n=!1;for(let s=t.length-1;s>=-1&&!n;s--){const i=s>=0?t[s]:R();d(i,"path"),i.length!==0&&(o=`${i}/${o}`,n=i.charCodeAt(0)===S)}return o=y(o,!n,"/",l),n?`/${o}`:o.length>0?o:"."},normalize(t){if(d(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===S,n=t.charCodeAt(t.length-1)===S;return t=y(t,!o,"/",l),t.length===0?o?"/":n?"./":".":(n&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return d(t,"path"),t.length>0&&t.charCodeAt(0)===S},join(...t){if(t.length===0)return".";let o;for(let n=0;n<t.length;++n){const s=t[n];d(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.$0b.normalize(o)},relative(t,o){if(d(t,"from"),d(o,"to"),t===o||(t=e.$0b.resolve(t),o=e.$0b.resolve(o),t===o))return"";const n=1,s=t.length,i=s-n,r=1,a=o.length-r,w=i<a?i:a;let g=-1,f=0;for(;f<w;f++){const A=t.charCodeAt(n+f);if(A!==o.charCodeAt(r+f))break;A===S&&(g=f)}if(f===w)if(a>w){if(o.charCodeAt(r+f)===S)return o.slice(r+f+1);if(f===0)return o.slice(r+f)}else i>w&&(t.charCodeAt(n+f)===S?g=f:f===0&&(g=0));let k="";for(f=n+g+1;f<=s;++f)(f===s||t.charCodeAt(f)===S)&&(k+=k.length===0?"..":"/..");return`${k}${o.slice(r+g)}`},toNamespacedPath(t){return t},dirname(t){if(d(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===S;let n=-1,s=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===S){if(!s){n=i;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":t.slice(0,n)},basename(t,o){o!==void 0&&d(o,"ext"),d(t,"path");let n=0,s=-1,i=!0,r;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let a=o.length-1,w=-1;for(r=t.length-1;r>=0;--r){const g=t.charCodeAt(r);if(g===S){if(!i){n=r+1;break}}else w===-1&&(i=!1,w=r+1),a>=0&&(g===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=w))}return n===s?s=w:s===-1&&(s=t.length),t.slice(n,s)}for(r=t.length-1;r>=0;--r)if(t.charCodeAt(r)===S){if(!i){n=r+1;break}}else s===-1&&(i=!1,s=r+1);return s===-1?"":t.slice(n,s)},extname(t){d(t,"path");let o=-1,n=0,s=-1,i=!0,r=0;for(let a=t.length-1;a>=0;--a){const w=t.charCodeAt(a);if(w===S){if(!i){n=a+1;break}continue}s===-1&&(i=!1,s=a+1),w===P?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":t.slice(o,s)},format:p.bind(null,"/"),parse(t){d(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.charCodeAt(0)===S;let s;n?(o.root="/",s=1):s=0;let i=-1,r=0,a=-1,w=!0,g=t.length-1,f=0;for(;g>=s;--g){const k=t.charCodeAt(g);if(k===S){if(!w){r=g+1;break}continue}a===-1&&(w=!1,a=g+1),k===P?i===-1?i=g:f!==1&&(f=1):i!==-1&&(f=-1)}if(a!==-1){const k=r===0&&n?1:r;i===-1||f===0||f===1&&i===a-1&&i===r+1?o.base=o.name=t.slice(k,a):(o.name=t.slice(k,i),o.base=t.slice(k,a),o.ext=t.slice(i,a))}return r>0?o.dir=t.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$0b.win32=e.$9b.win32=e.$9b,e.$0b.posix=e.$9b.posix=e.$0b,e.$$b=v?e.$9b.normalize:e.$0b.normalize,e.$_b=v?e.$9b.isAbsolute:e.$0b.isAbsolute,e.$ac=v?e.$9b.join:e.$0b.join,e.$bc=v?e.$9b.resolve:e.$0b.resolve,e.$cc=v?e.$9b.relative:e.$0b.relative,e.$dc=v?e.$9b.dirname:e.$0b.dirname,e.$ec=v?e.$9b.basename:e.$0b.basename,e.$fc=v?e.$9b.extname:e.$0b.extname,e.$gc=v?e.$9b.format:e.$0b.format,e.$hc=v?e.$9b.parse:e.$0b.parse,e.$ic=v?e.$9b.toNamespacedPath:e.$0b.toNamespacedPath,e.sep=v?e.$9b.sep:e.$0b.sep,e.$kc=v?e.$9b.delimiter:e.$0b.delimiter}),define(oe[48],ae([0,1,16,5,27,11]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=void 0;function L(r){return r===47||r===92}e.$De=L;function P(r){return r.replace(/[\\/]/g,I.$0b.sep)}e.$Ee=P;function S(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Fe=S;function b(r,a=I.$0b.sep){if(!r)return"";const w=r.length,g=r.charCodeAt(0);if(L(g)){if(L(r.charCodeAt(1))&&!L(r.charCodeAt(2))){let k=3;const A=k;for(;k<w&&!L(r.charCodeAt(k));k++);if(A!==k&&!L(r.charCodeAt(k+1))){for(k+=1;k<w;k++)if(L(r.charCodeAt(k)))return r.slice(0,k+1).replace(/[\\/]/g,a)}}return a}else if(l(g)&&r.charCodeAt(1)===58)return L(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<w;f++)if(L(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.$Ge=b;function C(r){if(!T.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let w=2;const g=w;for(;w<r.length&&(a=r.charCodeAt(w),a!==92);w++);return!(g===w||(a=r.charCodeAt(w+1),isNaN(a)||a===92))}e.$He=C;const E=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,a=T.$i){const w=a?E:m;return!(!r||r.length===0||/^\s+$/.test(r)||(w.lastIndex=0,w.test(r))||a&&h.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$Ie=d;function v(r,a,w){const g=r===a;return!w||g?g:!r||!a?!1:(0,O.$Md)(r,a)}e.$Je=v;function c(r,a,w,g=I.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(w){if(!(0,O.$Nd)(r,a))return!1;if(a.length===r.length)return!0;let k=a.length;return a.charAt(a.length-1)===g&&k--,r.charAt(k)===g}return a.charAt(a.length-1)!==g&&(a+=g),r.indexOf(a)===0}e.$Ke=c;function l(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Le=l;function u(r,a){return T.$i&&r.endsWith(":")&&(r+=I.sep),(0,I.$_b)(r)||(r=(0,I.$ac)(a,r)),r=(0,I.$$b)(r),T.$i?(r=(0,O.$td)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,O.$td)(r,I.sep),r||(r=I.sep)),r}e.$Me=u;function y(r){const a=(0,I.$$b)(r);return T.$i?r.length>3?!1:p(a)&&(r.length===2||a.charCodeAt(2)===92):a===I.$0b.sep}e.$Ne=y;function p(r,a=T.$i){return a?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$Oe=p;function R(r,a=T.$i){return p(r,a)?r[0]:void 0}e.$Pe=R;function t(r,a,w){return a.length>r.length?-1:r===a?0:(w&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$Qe=t;function o(r){const a=r.split(":");let w,g,f;for(const k of a){const A=Number(k);(0,j.$ne)(A)?g===void 0?g=A:f===void 0&&(f=A):w=w?[w,k].join(":"):k}if(!w)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:w,line:g!==void 0?g:void 0,column:f!==void 0?f:g!==void 0?1:void 0}}e.$Re=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(r,a,w=8){let g="";for(let k=0;k<w;k++){let A;k===0&&T.$i&&!a&&(w===3||w===4)?A=s:A=n,g+=A.charAt(Math.floor(Math.random()*A.length))}let f;return a?f=`${a}-${g}`:f=g,r?(0,I.$ac)(r,f):f}e.$Se=i}),define(oe[137],ae([0,1,16]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.$wr=e.$vr=e.$ur=void 0,e.$ur=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},O={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(C){const E=(0,I.$fc)(C),m=T[E.toLowerCase()];return m!==void 0?m:L(C)}e.$vr=j;function L(C){const E=(0,I.$fc)(C);return O[E.toLowerCase()]}e.$wr=L;function P(C){for(const E in O)if(O[E]===C)return E}e.$xr=P;const S=/^(.+)\/(.+?)(;.+)?$/;function b(C,E){const m=S.exec(C);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:E?void 0:C}e.$yr=b}),define(oe[89],ae([0,1,5]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.TerminateResponseCode=e.Source=void 0;var T;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(T||(e.Source=T={}));var O;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(O||(e.TerminateResponseCode=O={}));function j(P,...S){const b=S.reduce((m,h)=>(m[h]=!0,m),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(m=>!b[m]).forEach(m=>{for(let h=0;h<C.length;h++)if(m.search(C[h])!==-1){delete P[m];break}})}e.$fl=j;function L(P){P&&(delete P.DEBUG,I.$j&&delete P.DYLD_LIBRARY_PATH,I.$k&&delete P.LD_PRELOAD)}e.$gl=L}),define(oe[10],ae([0,1,16,5]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ve=e.$Ue=e.URI=void 0;const O=/^\w[\w\d+.-]*$/,j=/^\//,L=/^\/\//;function P(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!O.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!j.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,i){return!s&&!i?"file":s}function b(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==E&&(i=E+i):i=E;break}return i}const C="",E="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,r,a,w,g,f=!1){typeof i=="object"?(this.scheme=i.scheme||C,this.authority=i.authority||C,this.path=i.path||C,this.query=i.query||C,this.fragment=i.fragment||C):(this.scheme=S(i,f),this.authority=r||C,this.path=b(this.scheme,a||C),this.query=w||C,this.fragment=g||C,P(this,f))}get fsPath(){return p(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:a,path:w,query:g,fragment:f}=i;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),w===void 0?w=this.path:w===null&&(w=C),g===void 0?g=this.query:g===null&&(g=C),f===void 0?f=this.fragment:f===null&&(f=C),r===this.scheme&&a===this.authority&&w===this.path&&g===this.query&&f===this.fragment?this:new c(r,a,w,g,f)}static parse(i,r=!1){const a=m.exec(i);return a?new c(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),r):new c(C,C,C,C,C)}static file(i){let r=C;if(T.$i&&(i=i.replace(/\\/g,E)),i[0]===E&&i[1]===E){const a=i.indexOf(E,2);a===-1?(r=i.substring(2),i=E):(r=i.substring(2,a),i=i.substring(a)||E)}return new c("file",r,i,C,C)}static from(i,r){return new c(i.scheme,i.authority,i.path,i.query,i.fragment,r)}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return T.$i&&i.scheme==="file"?a=h.file(I.$9b.join(p(i,!0),...r)).path:a=I.$0b.join(i.path,...r),i.with({path:a})}toString(i=!1){return R(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const r=new c(i);return r._formatted=i.external??null,r._fsPath=i._sep===v?i.fsPath??null:null,r}}else return i}}e.URI=h;function d(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$Ue=d;const v=T.$i?1:void 0;class c extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(i=!1){return i?R(this,!0):(this._formatted||(this._formatted=R(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=v),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const l={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(s,i,r){let a,w=-1;for(let g=0;g<s.length;g++){const f=s.charCodeAt(g);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||i&&f===47||r&&f===91||r&&f===93||r&&f===58)w!==-1&&(a+=encodeURIComponent(s.substring(w,g)),w=-1),a!==void 0&&(a+=s.charAt(g));else{a===void 0&&(a=s.substr(0,g));const k=l[f];k!==void 0?(w!==-1&&(a+=encodeURIComponent(s.substring(w,g)),w=-1),a+=k):w===-1&&(w=g)}}return w!==-1&&(a+=encodeURIComponent(s.substring(w))),a!==void 0?a:s}function y(s){let i;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(i===void 0&&(i=s.substr(0,r)),i+=l[a]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function p(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,T.$i&&(r=r.replace(/\//g,"\\")),r}e.$Ve=p;function R(s,i){const r=i?y:u;let a="",{scheme:w,authority:g,path:f,query:k,fragment:A}=s;if(w&&(a+=w,a+=":"),(g||w==="file")&&(a+=E,a+=E),g){let M=g.indexOf("@");if(M!==-1){const F=g.substr(0,M);g=g.substr(M+1),M=F.lastIndexOf(":"),M===-1?a+=r(F,!1,!1):(a+=r(F.substr(0,M),!1,!1),a+=":",a+=r(F.substr(M+1),!1,!0)),a+="@"}g=g.toLowerCase(),M=g.lastIndexOf(":"),M===-1?a+=r(g,!1,!0):(a+=r(g.substr(0,M),!1,!0),a+=g.substr(M))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const M=f.charCodeAt(1);M>=65&&M<=90&&(f=`/${String.fromCharCode(M+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const M=f.charCodeAt(0);M>=65&&M<=90&&(f=`${String.fromCharCode(M+32)}:${f.substr(2)}`)}a+=r(f,!0,!1)}return k&&(a+="?",a+=r(k,!1,!1)),A&&(a+="#",a+=i?A:u(A,!1,!1)),a}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,i=>t(i)):s}}),define(oe[138],ae([0,1,10]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Ep=e.$Dp=e.$Cp=void 0;function T(b){const C=b;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$Cp=T;function O(b){const C=[];let E;try{const m=JSON.parse(b.arguments),h=m[m.length-1];h&&h.__$stack&&(m.pop(),E=h.__$stack),C.push(...m)}catch{C.push("Unable to log remote console arguments",b.arguments)}return{args:C,stack:E}}e.$Dp=O;function j(b){if(typeof b!="string")return j(O(b).stack);const C=b;if(C){const E=L(C),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(m&&m.length===4)return{uri:I.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$Ep=j;function L(b){if(!b)return b;const C=b.indexOf(`
`);return C===-1?b:b.substring(0,C)}function P(b,C){const{args:E,stack:m}=O(b),h=typeof E[0]=="string"&&E.length===1;let d=L(m);d&&(d=`(${d.trim()})`);let v=[];if(typeof E[0]=="string"?d&&h?v=[`%c[${C}] %c${E[0]} %c${d}`,S("blue"),S(""),S("grey")]:v=[`%c[${C}] %c${E[0]}`,S("blue"),S(""),...E.slice(1)]:v=[`%c[${C}]%`,S("blue"),...E],d&&!h&&v.push(d),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,v)}e.log=P;function S(b){return`color: ${b}`}}),define(oe[62],ae([0,1,14,27,10]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=e.$Xg=e.$Wg=void 0;function j(b){return JSON.stringify(b,P)}e.$Wg=j;function L(b){let C=JSON.parse(b);return C=S(C),C}e.$Xg=L;function P(b,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,T.$zd)(C)}:C}function S(b,C=0){if(!b||C>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return O.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 16:return new Date(b.source)}if(b instanceof I.$Jb||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let E=0;E<b.length;++E)b[E]=S(b[E],C+1);else for(const E in b)Object.hasOwnProperty.call(b,E)&&(b[E]=S(b[E],C+1))}return b}e.$Yg=S}),define(oe[26],ae([0,1,7,5,10]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.Schemas=void 0;var j;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(j||(e.Schemas=j={})),e.$We="vscode-tkn",e.$Xe="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${j.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${j.vscodeRemoteResource}`}set(C,E,m){this.a[C]=E,this.b[C]=m}setConnectionToken(C,E){this.c[C]=E}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(c){return I.$Y(c),C}const E=C.authority;let m=this.a[E];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const h=this.b[E],d=this.c[E];let v=`path=${encodeURIComponent(C.path)}`;return typeof d=="string"&&(v+=`&${e.$Xe}=${encodeURIComponent(d)}`),O.URI.from({scheme:T.$o?this.d:j.vscodeRemoteResource,authority:`${m}:${h}`,path:this.f,query:v})}}e.$Ye=new L,e.$Ze="vs/../../extensions",e.$1e="vs/../../node_modules",e.$2e="vs/../../node_modules.asar",e.$3e="vs/../../node_modules.asar.unpacked";class P{static{this.a="vscode-app"}asBrowserUri(C){const E=this.b(C,ne);return this.uriToBrowserUri(E)}uriToBrowserUri(C){return C.scheme===j.vscodeRemote?e.$Ye.rewrite(C):C.scheme===j.file&&(T.$m||T.$p&&T.$g.origin===`${j.vscodeFileResource}://${P.a}`)?C.with({scheme:j.vscodeFileResource,authority:C.authority||P.a,query:null,fragment:null}):C}asFileUri(C){const E=this.b(C,ne);return this.uriToFileUri(E)}uriToFileUri(C){return C.scheme===j.vscodeFileResource?C.with({scheme:j.file,authority:C.authority!==P.a?C.authority:null,query:null,fragment:null}):C}b(C,E){return O.URI.isUri(C)?C:O.URI.parse(E.toUrl(C))}}e.$4e=new P;var S;(function(b){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(C.get("3"));const E="vscode-coi";function m(d){let v;typeof d=="string"?v=new URL(d).searchParams:d instanceof URL?v=d.searchParams:O.URI.isUri(d)&&(v=new URL(d.toString(!0)).searchParams);const c=v?.get(E);if(c)return C.get(c)}b.getHeadersFromQuery=m;function h(d,v,c){if(!globalThis.crossOriginIsolated)return;const l=v&&c?"3":c?"2":"1";d instanceof URLSearchParams?d.set(E,l):d[E]=l}b.addSearchParam=h})(S||(e.COI=S={}))}),define(oe[139],ae([0,1,122,26,5,10]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WC=void 0;class L{constructor(m,h,d){this.id=m,this.dependencies=h,this.callback=d}}class P{static{this.INSTANCE=new P}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,h,d)=>{typeof m!="string"&&(d=h,h=m,m=null),(typeof h!="object"||!Array.isArray(h))&&(d=h,h=null),this.c.push(new L(m,h,d))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const h=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!h)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(m){return new Promise((h,d)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const c=()=>{v.removeEventListener("load",l),v.removeEventListener("error",u)},l=y=>{c(),h(this.c.pop())},u=y=>{c(),d(y)};v.addEventListener("load",l),v.addEventListener("error",u),this.f&&(m=this.f.createScriptURL(m)),v.setAttribute("src",m),document.getElementsByTagName("head")[0].appendChild(v)})}i(m){return new Promise((h,d)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),h(this.c.pop())}catch(v){d(v)}})}async j(m){try{const h=globalThis._VSCODE_NODE_MODULES.fs,d=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,c=j.URI.parse(m).fsPath,l=h.readFileSync(c).toString(),u=v.wrap(l.replace(/^#!.*/,""));return new d.Script(u).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const S=new Map;let b={};typeof globalThis.require=="object"&&(b=globalThis.require.paths??{});async function C(E,m,h){if(I.$R){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),b[E]&&(E=b[E]);const d=`${E}/${m}`;if(S.has(d))return S.get(d);let v;if(/^\w[\w\d+.-]*:\/\//.test(d))v=d;else{const y=`${h&&!O.$o?T.$2e:T.$1e}/${d}`;v=T.$4e.asBrowserUri(y).toString(!0)}const c=P.INSTANCE.load(v);return S.set(d,c),c}else return await new Promise((d,v)=>{ne([E],d,v)})}e.$WC=C}),define(oe[22],ae([0,1,48,26,16,5,27,10]),function(ne,e,I,T,O,j,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.DataUri=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=void 0;function S(h){return(0,P.$Ve)(h,!0)}e.$Xf=S;class b{constructor(d){this.a=d}compare(d,v,c=!1){return d===v?0:(0,L.$Fd)(this.getComparisonKey(d,c),this.getComparisonKey(v,c))}isEqual(d,v,c=!1){return d===v?!0:!d||!v?!1:this.getComparisonKey(d,c)===this.getComparisonKey(v,c)}getComparisonKey(d,v=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,v,c=!1){if(d.scheme===v.scheme){if(d.scheme===T.Schemas.file)return I.$Ke(S(d),S(v),this.a(d))&&d.query===v.query&&(c||d.fragment===v.fragment);if((0,e.$cg)(d.authority,v.authority))return I.$Ke(d.path,v.path,this.a(d),"/")&&d.query===v.query&&(c||d.fragment===v.fragment)}return!1}joinPath(d,...v){return P.URI.joinPath(d,...v)}basenameOrAuthority(d){return(0,e.$7f)(d)||d.authority}basename(d){return O.$0b.basename(d.path)}extname(d){return O.$0b.extname(d.path)}dirname(d){if(d.path.length===0)return d;let v;return d.scheme===T.Schemas.file?v=P.URI.file(O.$dc(S(d))).path:(v=O.$0b.dirname(d.path),d.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),v="/")),d.with({path:v})}normalizePath(d){if(!d.path.length)return d;let v;return d.scheme===T.Schemas.file?v=P.URI.file(O.$$b(S(d))).path:v=O.$0b.normalize(d.path),d.with({path:v})}relativePath(d,v){if(d.scheme!==v.scheme||!(0,e.$cg)(d.authority,v.authority))return;if(d.scheme===T.Schemas.file){const u=O.$cc(S(d),S(v));return j.$i?I.$Ee(u):u}let c=d.path||"/";const l=v.path||"/";if(this.a(d)){let u=0;for(const y=Math.min(c.length,l.length);u<y&&!(c.charCodeAt(u)!==l.charCodeAt(u)&&c.charAt(u).toLowerCase()!==l.charAt(u).toLowerCase());u++);c=l.substr(0,u)+c.substr(u)}return O.$0b.relative(c,l)}resolvePath(d,v){if(d.scheme===T.Schemas.file){const c=P.URI.file(O.$bc(S(d),v));return d.with({authority:c.authority,path:c.path})}return v=I.$Fe(v),d.with({path:O.$0b.resolve(d.path,v)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,v){return d===v||d!==void 0&&v!==void 0&&(0,L.$Md)(d,v)}hasTrailingPathSeparator(d,v=O.sep){if(d.scheme===T.Schemas.file){const c=S(d);return c.length>I.$Ge(c).length&&c[c.length-1]===v}else{const c=d.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,v=O.sep){return(0,e.$dg)(d,v)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,v=O.sep){let c=!1;if(d.scheme===T.Schemas.file){const l=S(d);c=l!==void 0&&l.length===I.$Ge(l).length&&l[l.length-1]===v}else{v="/";const l=d.path;c=l.length===1&&l.charCodeAt(l.length-1)===47}return!c&&!(0,e.$dg)(d,v)?d.with({path:d.path+"/"}):d}}e.$Yf=b,e.$Zf=new b(()=>!1),e.$1f=new b(h=>h.scheme===T.Schemas.file?!j.$k:!0),e.$2f=new b(h=>!0),e.$3f=e.$Zf.isEqual.bind(e.$Zf),e.$4f=e.$Zf.isEqualOrParent.bind(e.$Zf),e.$5f=e.$Zf.getComparisonKey.bind(e.$Zf),e.$6f=e.$Zf.basenameOrAuthority.bind(e.$Zf),e.$7f=e.$Zf.basename.bind(e.$Zf),e.$8f=e.$Zf.extname.bind(e.$Zf),e.$9f=e.$Zf.dirname.bind(e.$Zf),e.$0f=e.$Zf.joinPath.bind(e.$Zf),e.$$f=e.$Zf.normalizePath.bind(e.$Zf),e.$_f=e.$Zf.relativePath.bind(e.$Zf),e.$ag=e.$Zf.resolvePath.bind(e.$Zf),e.$bg=e.$Zf.isAbsolutePath.bind(e.$Zf),e.$cg=e.$Zf.isEqualAuthority.bind(e.$Zf),e.$dg=e.$Zf.hasTrailingPathSeparator.bind(e.$Zf),e.$eg=e.$Zf.removeTrailingPathSeparator.bind(e.$Zf),e.$fg=e.$Zf.addTrailingPathSeparator.bind(e.$Zf);function C(h,d){const v=[];for(let c=0;c<h.length;c++){const l=d(h[c]);h.some((u,y)=>y===c?!1:(0,e.$4f)(l,d(u)))||v.push(h[c])}return v}e.$gg=C;var E;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function d(v){const c=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(y=>{const[p,R]=y.split(":");p&&R&&c.set(p,R)});const u=v.path.substring(0,v.path.indexOf(";"));return u&&c.set(h.META_DATA_MIME,u),c}h.parseMetaData=d})(E||(e.DataUri=E={}));function m(h,d,v){if(d){let c=h.path;return c&&c[0]!==O.$0b.sep&&(c=O.$0b.sep+c),h.with({scheme:v,authority:d,path:c})}return h.with({scheme:v})}e.$hg=m}),define(oe[6],ae([0,1,25,7,3,2,22,5,126]),function(ne,e,I,T,O,j,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.$Rg=e.$Qg=e.Promises=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function b(N){return!!N&&typeof N.then=="function"}e.$ig=b;function C(N){const $=new I.$ed,D=N($.token),z=new Promise((K,_)=>{const H=$.token.onCancellationRequested(()=>{H.dispose(),$.dispose(),_(new T.$3)});Promise.resolve(D).then(ee=>{H.dispose(),$.dispose(),K(ee)},ee=>{H.dispose(),$.dispose(),_(ee)})});return new class{cancel(){$.cancel()}then(K,_){return z.then(K,_)}catch(K){return this.then(void 0,K)}finally(K){return z.finally(K)}}}e.$jg=C;function E(N,$,D){return new Promise((z,K)=>{const _=$.onCancellationRequested(()=>{_.dispose(),z(D)});N.then(z,K).finally(()=>_.dispose())})}e.$kg=E;function m(N,$){return new Promise((D,z)=>{const K=$.onCancellationRequested(()=>{K.dispose(),z(new T.$3)});N.then(D,z).finally(()=>K.dispose())})}e.$lg=m;async function h(N){let $=-1;const D=N.map((z,K)=>z.then(_=>($=K,_)));try{return await Promise.race(D)}finally{N.forEach((z,K)=>{K!==$&&z.cancel()})}}e.$mg=h;function d(N,$,D){let z;const K=setTimeout(()=>{z?.(void 0),D?.()},$);return Promise.race([N.finally(()=>clearTimeout(K)),new Promise(_=>z=_)])}e.$ng=d;function v(N){return new Promise(($,D)=>{const z=N();b(z)?z.then($,D):$(z)})}e.$og=v;class c{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue($){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=$,!this.b){const D=()=>{if(this.b=null,this.f)return;const z=this.queue(this.d);return this.d=null,z};this.b=new Promise(z=>{this.a.then(D,D).then(z)})}return new Promise((D,z)=>{this.b.then(D,z)})}return this.a=$(),new Promise((D,z)=>{this.a.then(K=>{this.a=null,D(K)},K=>{this.a=null,z(K)})})}dispose(){this.f=!0}}e.$pg=c;class l{constructor(){this.a=Promise.resolve(null)}queue($){return this.a=this.a.then(()=>$(),()=>$())}}e.$qg=l;class u{constructor(){this.a=new Map}queue($,D){const K=(this.a.get($)??Promise.resolve()).catch(()=>{}).then(D).finally(()=>{this.a.get($)===K&&this.a.delete($)});return this.a.set($,K),K}}e.$rg=u;const y=(N,$)=>{let D=!0;const z=setTimeout(()=>{D=!1,$()},N);return{isTriggered:()=>D,dispose:()=>{clearTimeout(z),D=!1}}},p=N=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,N())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};class R{constructor($){this.defaultDelay=$,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger($,D=this.defaultDelay){this.g=$,this.h(),this.b||(this.b=new Promise((K,_)=>{this.d=K,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const K=this.g;return this.g=null,K()}}));const z=()=>{this.a=null,this.d?.(null)};return this.a=D===S.$5c?p(z):y(D,z),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$sg=R;class t{constructor($){this.a=new R($),this.b=new c}trigger($,D){return this.a.trigger(()=>this.b.queue($),D)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$tg=t;class o{constructor(){this.a=!1,this.b=new Promise(($,D)=>{this.d=$})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ug=o;class n extends o{constructor($){super(),this.f=setTimeout(()=>this.open(),$)}open(){clearTimeout(this.f),super.open()}}e.$vg=n;function s(N,$){return $?new Promise((D,z)=>{const K=setTimeout(()=>{_.dispose(),D()},N),_=$.onCancellationRequested(()=>{clearTimeout(K),_.dispose(),z(new T.$3)})}):C(D=>s(N,D))}e.$wg=s;function i(N,$=0){const D=setTimeout(N,$);return(0,j.$jb)(()=>clearTimeout(D))}e.$xg=i;function r(N){const $=[];let D=0;const z=N.length;function K(){return D<z?N[D++]():null}function _(H){H!=null&&$.push(H);const ee=K();return ee?ee.then(_):Promise.resolve($)}return Promise.resolve(null).then(_)}e.$yg=r;function a(N,$=z=>!!z,D=null){let z=0;const K=N.length,_=()=>{if(z>=K)return Promise.resolve(D);const H=N[z++];return Promise.resolve(H()).then(ie=>$(ie)?Promise.resolve(ie):_())};return _()}e.$zg=a;function w(N,$=z=>!!z,D=null){if(N.length===0)return Promise.resolve(D);let z=N.length;const K=()=>{z=-1;for(const _ of N)_.cancel?.()};return new Promise((_,H)=>{for(const ee of N)ee.then(ie=>{--z>=0&&$(ie)?(K(),_(ie)):z===0&&_(D)}).catch(ie=>{--z>=0&&(K(),H(ie))})})}e.$Ag=w;class g{constructor($){this.a=0,this.d=$,this.f=[],this.b=0,this.g=new O.$8c}get onDrained(){return this.g.event}get size(){return this.a}queue($){return this.a++,new Promise((D,z)=>{this.f.push({factory:$,c:D,e:z}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const $=this.f.shift();this.b++;const D=$.factory();D.then($.c,$.e),D.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Bg=g;class f extends g{constructor(){super(1)}}e.$Cg=f;class k{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const $=new U;return this.b.add($),$.p}d(){for(const[,$]of this.a)if($.size>0)return!1;return!0}queueFor($,D=L.$Zf){const z=D.getComparisonKey($);let K=this.a.get(z);return K||(K=new f,O.Event.once(K.onDrained)(()=>{K?.dispose(),this.a.delete(z),this.f()}),this.a.set(z,K)),K}f(){this.d()&&this.g()}g(){for(const $ of this.b)$.complete();this.b.clear()}dispose(){for(const[,$]of this.a)$.dispose();this.a.clear(),this.g()}}e.$Dg=k;class A{constructor($,D){this.a=-1,typeof $=="function"&&typeof D=="number"&&this.setIfNotSet($,D)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet($,D){this.cancel(),this.a=setTimeout(()=>{this.a=-1,$()},D)}setIfNotSet($,D){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,$()},D))}}e.$Eg=A;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet($,D){this.cancel(),this.a=setInterval(()=>{$()},D)}}e.$Fg=M;class F{constructor($,D){this.b=-1,this.a=$,this.d=D,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule($=this.d){this.cancel(),this.b=setTimeout(this.f,$)}get delay(){return this.d}set delay($){this.d=$}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Gg=F;class V{constructor($,D){D%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${D}ms is not a multiple of 1000ms.`),this.a=$,this.b=D,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule($=this.b){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil($/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Hg=V;class B extends F{constructor($,D){super($,D),this.j=[]}work($){this.j.push($),this.isScheduled()||this.schedule()}h(){const $=this.j;this.j=[],this.a?.($)}dispose(){this.j=[],super.dispose()}}e.$Ig=B;class x extends j.$lb{constructor($,D){super(),this.g=$,this.h=D,this.a=[],this.b=this.B(new j.$mb),this.f=!1}get pending(){return this.a.length}work($){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+$.length>this.g.maxBufferedWork)return!1}else if(this.pending+$.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const D of $)this.a.push(D);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new F(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Jg=x,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Kg=N=>{(0,P.$A)(()=>{if($)return;const D=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,D-Date.now())}}))});let $=!1;return{dispose(){$||($=!0)}}}:e.$Kg=(N,$)=>{const D=requestIdleCallback(N,typeof $=="number"?{timeout:$}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(D))}}}}();class Z{constructor($){this.d=!1,this.a=()=>{try{this.f=$()}catch(D){this.g=D}finally{this.d=!0}},this.b=(0,e.$Kg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Lg=Z;async function Q(N,$,D){let z;for(let K=0;K<D;K++)try{return await N()}catch(_){z=_,await s($)}throw z}e.$Mg=Q;class J{hasPending($){return this.a?typeof $=="number"?this.a.taskId===$:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending($,D,z){return this.a={taskId:$,cancel:()=>z?.(),promise:D},D.then(()=>this.d($),()=>this.d($)),D}d($){this.a&&$===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const $=this.b;this.b=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this.b)this.b.run=$;else{let D,z;const K=new Promise((_,H)=>{D=_,z=H});this.b={run:$,promise:K,promiseResolve:D,promiseReject:z}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ng=J;class X{constructor($,D=()=>Date.now()){this.d=$,this.f=D,this.a=0,this.b=0}increment(){const $=this.f();return $-this.a>this.d&&(this.a=$,this.b=0),this.b++,this.b}}e.$Og=X;var W;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(W||(W={}));class U{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise(($,D)=>{this.a=$,this.b=D})}complete($){return new Promise(D=>{this.a($),this.d={outcome:0,value:$},D()})}error($){return new Promise(D=>{this.b($),this.d={outcome:1,value:$},D()})}cancel(){return this.error(new T.$3)}}e.$Pg=U;var q;(function(N){async function $(z){let K;const _=await Promise.all(z.map(H=>H.then(ee=>ee,ee=>{K||(K=ee)})));if(typeof K<"u")throw K;return _}N.settled=$;function D(z){return new Promise(async(K,_)=>{try{await z(K,_)}catch(H){_(H)}})}N.withAsyncBody=D})(q||(e.Promises=q={}));var te;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(te||(te={}));class re{static fromArray($){return new re(D=>{D.emitMany($)})}static fromPromise($){return new re(async D=>{D.emitMany(await $)})}static fromPromises($){return new re(async D=>{await Promise.all($.map(async z=>D.emitOne(await z)))})}static merge($){return new re(async D=>{await Promise.all($.map(async z=>{for await(const K of z)D.emitOne(K)}))})}static{this.EMPTY=re.fromArray([])}constructor($){this.a=0,this.b=[],this.d=null,this.f=new O.$8c,queueMicrotask(async()=>{const D={emitOne:z=>this.g(z),emitMany:z=>this.h(z),reject:z=>this.k(z)};try{await Promise.resolve($(D)),this.j()}catch(z){this.k(z)}finally{D.emitOne=void 0,D.emitMany=void 0,D.reject=void 0}})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this.a===2)throw this.d;if($<this.b.length)return{done:!1,value:this.b[$++]};if(this.a===1)return{done:!0,value:void 0};await O.Event.toPromise(this.f.event)}while(!0)}}}static map($,D){return new re(async z=>{for await(const K of $)z.emitOne(D(K))})}map($){return re.map(this,$)}static filter($,D){return new re(async z=>{for await(const K of $)D(K)&&z.emitOne(K)})}filter($){return re.filter(this,$)}static coalesce($){return re.filter($,D=>!!D)}coalesce(){return re.coalesce(this)}static async toPromise($){const D=[];for await(const z of $)D.push(z);return D}toPromise(){return re.toPromise(this)}g($){this.a===0&&(this.b.push($),this.f.fire())}h($){this.a===0&&(this.b=this.b.concat($),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k($){this.a===0&&(this.a=2,this.d=$,this.f.fire())}}e.$Qg=re;class ce extends re{constructor($,D){super(D),this.l=$}cancel(){this.l.cancel()}}e.$Rg=ce;function G(N){const $=new I.$ed,D=N($.token);return new ce($,async z=>{const K=$.token.onCancellationRequested(()=>{K.dispose(),$.dispose(),z.reject(new T.$3)});try{for await(const _ of D){if($.token.isCancellationRequested)return;z.emitOne(_)}K.dispose(),$.dispose()}catch(_){K.dispose(),$.dispose(),z.reject(_)}})}e.$Sg=G}),define(oe[90],ae([0,1,21,6,48,35,16,5,27]),function(ne,e,I,T,O,j,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=void 0;function b(){return Object.create(null)}e.$_i=b,e.$aj="**",e.$bj="/";const C="[/\\\\]",E="[^/\\\\]",m=/\//g;function h(X,W){switch(X){case 0:return"";case 1:return`${E}*?`;default:return`(?:${C}|${E}+${C}${W?`|${C}${E}+`:""})*?`}}function d(X,W){if(!X)return[];const U=[];let q=!1,te=!1,re="";for(const ce of X){switch(ce){case W:if(!q&&!te){U.push(re),re="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":te=!0;break;case"]":te=!1;break}re+=ce}return re&&U.push(re),U}e.$cj=d;function v(X){if(!X)return"";let W="";const U=d(X,e.$bj);if(U.every(q=>q===e.$aj))W=".*";else{let q=!1;U.forEach((te,re)=>{if(te===e.$aj){if(q)return;W+=h(2,re===U.length-1)}else{let ce=!1,G="",N=!1,$="";for(const D of te){if(D!=="}"&&ce){G+=D;continue}if(N&&(D!=="]"||!$)){let z;D==="-"?z=D:(D==="^"||D==="!")&&!$?z="^":D===e.$bj?z="":z=(0,S.$od)(D),$+=z;continue}switch(D){case"{":ce=!0;continue;case"[":N=!0;continue;case"}":{const K=`(?:${d(G,",").map(_=>v(_)).join("|")})`;W+=K,ce=!1,G="";break}case"]":{W+="["+$+"]",N=!1,$="";break}case"?":W+=E;continue;case"*":W+=h(1);continue;default:W+=(0,S.$od)(D)}}re<U.length-1&&(U[re+1]!==e.$aj||re+2<U.length)&&(W+=C)}q=te===e.$aj})}return W}const c=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,R=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new j.$qi(1e4),o=function(){return!1},n=function(){return null};function s(X,W){if(!X)return n;let U;typeof X!="string"?U=X.pattern:U=X,U=U.trim();const q=`${U}_${!!W.trimForExclusions}`;let te=t.get(q);if(te)return i(te,X);let re;return c.test(U)?te=a(U.substr(4),U):(re=l.exec(r(U,W)))?te=w(re[1],U):(W.trimForExclusions?y:u).test(U)?te=g(U,W):(re=p.exec(r(U,W)))?te=f(re[1].substr(1),U,!0):(re=R.exec(r(U,W)))?te=f(re[1],U,!1):te=k(U),t.set(q,te),i(te,X)}function i(X,W){if(typeof W=="string")return X;const U=function(q,te){return(0,O.$Ke)(q,W.base,!P.$k)?X((0,S.$sd)(q.substr(W.base.length),L.sep),te):null};return U.allBasenames=X.allBasenames,U.allPaths=X.allPaths,U.basenames=X.basenames,U.patterns=X.patterns,U}function r(X,W){return W.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function a(X,W){return function(U,q){return typeof U=="string"&&U.endsWith(X)?W:null}}function w(X,W){const U=`/${X}`,q=`\\${X}`,te=function(ce,G){return typeof ce!="string"?null:G?G===X?W:null:ce===X||ce.endsWith(U)||ce.endsWith(q)?W:null},re=[X];return te.basenames=re,te.patterns=[W],te.allBasenames=re,te}function g(X,W){const U=Q(X.slice(1,-1).split(",").map(G=>s(G,W)).filter(G=>G!==n),X),q=U.length;if(!q)return n;if(q===1)return U[0];const te=function(G,N){for(let $=0,D=U.length;$<D;$++)if(U[$](G,N))return X;return null},re=U.find(G=>!!G.allBasenames);re&&(te.allBasenames=re.allBasenames);const ce=U.reduce((G,N)=>N.allPaths?G.concat(N.allPaths):G,[]);return ce.length&&(te.allPaths=ce),te}function f(X,W,U){const q=L.sep===L.$0b.sep,te=q?X:X.replace(m,L.sep),re=L.sep+te,ce=L.$0b.sep+X;let G;return U?G=function(N,$){return typeof N=="string"&&(N===te||N.endsWith(re)||!q&&(N===X||N.endsWith(ce)))?W:null}:G=function(N,$){return typeof N=="string"&&(N===te||!q&&N===X)?W:null},G.allPaths=[(U?"*/":"./")+X],G}function k(X){try{const W=new RegExp(`^${v(X)}$`);return function(U){return W.lastIndex=0,typeof U=="string"&&W.test(U)?X:null}}catch{return n}}function A(X,W,U){return!X||typeof W!="string"?!1:M(X)(W,void 0,U)}e.$dj=A;function M(X,W={}){if(!X)return o;if(typeof X=="string"||F(X)){const U=s(X,W);if(U===n)return o;const q=function(te,re){return!!U(te,re)};return U.allBasenames&&(q.allBasenames=U.allBasenames),U.allPaths&&(q.allPaths=U.allPaths),q}return x(X,W)}e.$ej=M;function F(X){const W=X;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.$fj=F;function V(X){return X.allBasenames||[]}e.$gj=V;function B(X){return X.allPaths||[]}e.$hj=B;function x(X,W){const U=Q(Object.getOwnPropertyNames(X).map(G=>Z(G,X[G],W)).filter(G=>G!==n)),q=U.length;if(!q)return n;if(!U.some(G=>!!G.requiresSiblings)){if(q===1)return U[0];const G=function(D,z){let K;for(let _=0,H=U.length;_<H;_++){const ee=U[_](D,z);if(typeof ee=="string")return ee;(0,T.$ig)(ee)&&(K||(K=[]),K.push(ee))}return K?(async()=>{for(const _ of K){const H=await _;if(typeof H=="string")return H}return null})():null},N=U.find(D=>!!D.allBasenames);N&&(G.allBasenames=N.allBasenames);const $=U.reduce((D,z)=>z.allPaths?D.concat(z.allPaths):D,[]);return $.length&&(G.allPaths=$),G}const te=function(G,N,$){let D,z;for(let K=0,_=U.length;K<_;K++){const H=U[K];H.requiresSiblings&&$&&(N||(N=(0,L.$ec)(G)),D||(D=N.substr(0,N.length-(0,L.$fc)(G).length)));const ee=H(G,N,D,$);if(typeof ee=="string")return ee;(0,T.$ig)(ee)&&(z||(z=[]),z.push(ee))}return z?(async()=>{for(const K of z){const _=await K;if(typeof _=="string")return _}return null})():null},re=U.find(G=>!!G.allBasenames);re&&(te.allBasenames=re.allBasenames);const ce=U.reduce((G,N)=>N.allPaths?G.concat(N.allPaths):G,[]);return ce.length&&(te.allPaths=ce),te}function Z(X,W,U){if(W===!1)return n;const q=s(X,U);if(q===n)return n;if(typeof W=="boolean")return q;if(W){const te=W.when;if(typeof te=="string"){const re=(ce,G,N,$)=>{if(!$||!q(ce,G))return null;const D=te.replace("$(basename)",()=>N),z=$(D);return(0,T.$ig)(z)?z.then(K=>K?X:null):z?X:null};return re.requiresSiblings=!0,re}}return q}function Q(X,W){const U=X.filter(G=>!!G.basenames);if(U.length<2)return X;const q=U.reduce((G,N)=>{const $=N.basenames;return $?G.concat($):G},[]);let te;if(W){te=[];for(let G=0,N=q.length;G<N;G++)te.push(W)}else te=U.reduce((G,N)=>{const $=N.patterns;return $?G.concat($):G},[]);const re=function(G,N){if(typeof G!="string")return null;if(!N){let D;for(D=G.length;D>0;D--){const z=G.charCodeAt(D-1);if(z===47||z===92)break}N=G.substr(D)}const $=q.indexOf(N);return $!==-1?te[$]:null};re.basenames=q,re.patterns=te,re.allBasenames=q;const ce=X.filter(G=>!G.basenames);return ce.push(re),ce}function J(X,W){return(0,I.$bf)(X,W,(U,q)=>typeof U=="string"&&typeof q=="string"?U===q:typeof U!="string"&&typeof q!="string"?U.base===q.base&&U.pattern===q.pattern:!1)}e.$ij=J}),define(oe[91],ae([0,1,14,10]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=e.$om=e.$nm=void 0;function O(E){return E.toJSON()}class j{constructor(m){this.a=m}transformIncoming(m){const h=this.a.transformIncoming(m);return h===m?m:O(T.URI.from(h))}transformOutgoing(m){const h=this.a.transformOutgoing(m);return h===m?m:O(T.URI.from(h))}transformOutgoingURI(m){const h=this.a.transformOutgoing(m);return h===m?m:T.URI.from(h)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$nm=j,e.$om=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function L(E,m,h){if(!E||h>200)return null;if(typeof E=="object"){if(E instanceof T.URI)return m.transformOutgoing(E);for(const d in E)if(Object.hasOwnProperty.call(E,d)){const v=L(E[d],m,h+1);v!==null&&(E[d]=v)}}return null}function P(E,m){const h=L(E,m,0);return h===null?E:h}e.$pm=P;function S(E,m,h,d){if(!E||d>200)return null;if(typeof E=="object"){if(E.$mid===1)return h?T.URI.revive(m.transformIncoming(E)):m.transformIncoming(E);if(E instanceof I.$Jb)return null;for(const v in E)if(Object.hasOwnProperty.call(E,v)){const c=S(E[v],m,h,d+1);c!==null&&(E[v]=c)}}return null}function b(E,m){const h=S(E,m,!1,0);return h===null?E:h}e.$qm=b;function C(E,m){const h=S(E,m,!0,0);return h===null?E:h}e.$rm=C}),define(oe[31],ae([0,1,52,36,264,6,48,86,16,5,22,10]),function(ne,e,I,T,O,j,L,P,S,b,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(Z){Z[Z.UNLINK=0]="UNLINK",Z[Z.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function h(Z,Q=m.UNLINK,J){if((0,L.$Ne)(Z))throw new Error("rimraf - will refuse to recursively delete root");return Q===m.UNLINK?v(Z):d(Z,J)}async function d(Z,Q=(0,L.$Se)((0,T.tmpdir)())){try{try{await I.promises.rename(Z,Q)}catch(J){return J.code==="ENOENT"?void 0:v(Z)}v(Q).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function v(Z){return(0,O.promisify)(I.rm)(Z,{recursive:!0,force:!0,maxRetries:3})}function c(Z){if((0,L.$Ne)(Z))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(Z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function l(Z,Q){return p(await(Q?u(Z):(0,O.promisify)(I.readdir)(Z)))}async function u(Z){try{return await(0,O.promisify)(I.readdir)(Z,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const Q=[],J=await l(Z);for(const X of J){let W=!1,U=!1,q=!1;try{const te=await e.Promises.lstat((0,S.$ac)(Z,X));W=te.isFile(),U=te.isDirectory(),q=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}Q.push({name:X,isFile:()=>W,isDirectory:()=>U,isSymbolicLink:()=>q})}return Q}function y(Z){return p(I.readdirSync(Z))}e.readdirSync=y;function p(Z){return Z.map(Q=>typeof Q=="string"?b.$j?(0,P.$7k)(Q):Q:(Q.name=b.$j?(0,P.$7k)(Q.name):Q.name,Q))}async function R(Z){const Q=await l(Z),J=[];for(const X of Q)await o.existsDirectory((0,S.$ac)(Z,X))&&J.push(X);return J}function t(Z,Q=1e3){return new Promise(J=>{let X=!1;const W=setInterval(()=>{X||(X=!0,I.access(Z,U=>{X=!1,U&&(clearInterval(W),J(void 0))}))},Q)})}e.whenDeleted=t;var o;(function(Z){async function Q(W){let U;try{if(U=await e.Promises.lstat(W),!U.isSymbolicLink())return{stat:U}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(b.$i&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw te}throw q}}Z.stat=Q;async function J(W){try{const{stat:U,symbolicLink:q}=await Z.stat(W);return U.isFile()&&q?.dangling!==!0}catch{}return!1}Z.existsFile=J;async function X(W){try{const{stat:U,symbolicLink:q}=await Z.stat(W);return U.isDirectory()&&q?.dangling!==!0}catch{}return!1}Z.existsDirectory=X})(o||(e.SymlinkSupport=o={}));const n=new j.$Dg;function s(Z,Q,J){return n.queueFor(E.URI.file(Z),C.$1f).queue(()=>{const X=g(J);return new Promise((W,U)=>a(Z,Q,X,q=>q?U(q):W()))})}let i=!0;function r(Z){i=Z}e.configureFlushOnWrite=r;function a(Z,Q,J,X){if(!i)return I.writeFile(Z,Q,{mode:J.mode,flag:J.flag},X);I.open(Z,J.flag,J.mode,(W,U)=>{if(W)return X(W);I.writeFile(U,Q,q=>{if(q)return I.close(U,()=>X(q));I.fdatasync(U,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),r(!1)),I.close(U,re=>X(re))))})})}function w(Z,Q,J){const X=g(J);if(!i)return I.writeFileSync(Z,Q,{mode:X.mode,flag:X.flag});const W=I.openSync(Z,X.flag,X.mode);try{I.writeFileSync(W,Q);try{I.fdatasyncSync(W)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),r(!1)}}finally{I.closeSync(W)}}e.writeFileSync=w;function g(Z){return Z?{mode:typeof Z.mode=="number"?Z.mode:438,flag:typeof Z.flag=="string"?Z.flag:"w"}:{mode:438,flag:"w"}}async function f(Z,Q,J=6e4){if(Z!==Q)try{b.$i&&typeof J=="number"?await k(Z,Q,Date.now(),J):await(0,O.promisify)(I.rename)(Z,Q)}catch(X){if(Z.toLowerCase()!==Q.toLowerCase()&&X.code==="EXDEV"||Z.endsWith("."))await A(Z,Q,{preserveSymlinks:!1}),await h(Z,m.MOVE);else throw X}}async function k(Z,Q,J,X,W=0){try{return await(0,O.promisify)(I.rename)(Z,Q)}catch(U){if(U.code!=="EACCES"&&U.code!=="EPERM"&&U.code!=="EBUSY")throw U;if(Date.now()-J>=X)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${U}`),U;if(W===0){let q=!1;try{const{stat:te}=await o.stat(Q);te.isFile()||(q=!0)}catch{}if(q)throw U}return await(0,j.$wg)(Math.min(100,W*10)),k(Z,Q,J,X,W+1)}}async function A(Z,Q,J){return F(Z,Q,{root:{source:Z,target:Q},options:J,handledSourcePaths:new Set})}const M=511;async function F(Z,Q,J){if(J.handledSourcePaths.has(Z))return;J.handledSourcePaths.add(Z);const{stat:X,symbolicLink:W}=await o.stat(Z);if(W){if(J.options.preserveSymlinks)try{return await x(Z,Q,J)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(W.dangling)return}return X.isDirectory()?V(Z,Q,X.mode&M,J):B(Z,Q,X.mode&M)}async function V(Z,Q,J,X){await e.Promises.mkdir(Q,{recursive:!0,mode:J});const W=await l(Z);for(const U of W)await F((0,S.$ac)(Z,U),(0,S.$ac)(Q,U),X)}async function B(Z,Q,J){await e.Promises.copyFile(Z,Q),await e.Promises.chmod(Q,J)}async function x(Z,Q,J){let X=await e.Promises.readlink(Z);(0,L.$Ke)(X,J.root.source,!b.$k)&&(X=(0,S.$ac)(J.root.target,X.substr(J.root.source.length+1))),await e.Promises.symlink(X,Q)}e.Promises=new class{get access(){return(0,O.promisify)(I.access)}get stat(){return(0,O.promisify)(I.stat)}get lstat(){return(0,O.promisify)(I.lstat)}get utimes(){return(0,O.promisify)(I.utimes)}get read(){return(Z,Q,J,X,W)=>new Promise((U,q)=>{I.read(Z,Q,J,X,W,(te,re,ce)=>te?q(te):U({bytesRead:re,buffer:ce}))})}get readFile(){return(0,O.promisify)(I.readFile)}get write(){return(Z,Q,J,X,W)=>new Promise((U,q)=>{I.write(Z,Q,J,X,W,(te,re,ce)=>te?q(te):U({bytesWritten:re,buffer:ce}))})}get appendFile(){return(0,O.promisify)(I.appendFile)}get fdatasync(){return(0,O.promisify)(I.fdatasync)}get truncate(){return(0,O.promisify)(I.truncate)}get copyFile(){return(0,O.promisify)(I.copyFile)}get open(){return(0,O.promisify)(I.open)}get close(){return(0,O.promisify)(I.close)}get symlink(){return(0,O.promisify)(I.symlink)}get readlink(){return(0,O.promisify)(I.readlink)}get chmod(){return(0,O.promisify)(I.chmod)}get mkdir(){return(0,O.promisify)(I.mkdir)}get unlink(){return(0,O.promisify)(I.unlink)}get rmdir(){return(0,O.promisify)(I.rmdir)}get realpath(){return(0,O.promisify)(I.realpath)}async exists(Z){try{return await e.Promises.access(Z),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return R}get writeFile(){return s}get rm(){return h}get rename(){return f}get copy(){return A}}}),define(oe[140],ae([0,1,52,16,5,27,31]),function(ne,e,I,T,O,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=e.$Kp=e.$Jp=void 0;function P(m){if(O.$k)return m;const h=(0,T.$dc)(m);if(m===h)return m;const d=((0,T.$ec)(m)||m).toLowerCase();try{const c=(0,L.readdirSync)(h).filter(l=>l.toLowerCase()===d);if(c.length===1){const l=P(h);if(l)return(0,T.$ac)(l,c[0])}else if(c.length>1){const l=c.indexOf(d);if(l>=0){const u=P(h);if(u)return(0,T.$ac)(u,c[l])}}}catch{}return null}e.$Jp=P;async function S(m){if(O.$k)return m;const h=(0,T.$dc)(m);if(m===h)return m;const d=((0,T.$ec)(m)||m).toLowerCase();try{const c=(await L.Promises.readdir(h)).filter(l=>l.toLowerCase()===d);if(c.length===1){const l=await S(h);if(l)return(0,T.$ac)(l,c[0])}else if(c.length>1){const l=c.indexOf(d);if(l>=0){const u=await S(h);if(u)return(0,T.$ac)(u,c[l])}}}catch{}return null}e.$Kp=S;async function b(m){try{return await L.Promises.realpath(m)}catch{const d=E(m);return await L.Promises.access(d,I.constants.R_OK),d}}e.$Lp=b;function C(m){try{return I.realpathSync(m)}catch{const d=E(m);return I.accessSync(d,I.constants.R_OK),d}}e.$Mp=C;function E(m){return(0,j.$td)((0,T.$$b)(m),T.sep)}}),define(oe[141],ae([0,1,16,5,37,89,11,31]),function(ne,e,I,T,O,j,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$il=e.$hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function S(E=O.env){return E.comspec||"cmd.exe"}e.$hl=S;function b(E){let m=[],h=!1;const d=function(v){if(h){m.push(v);return}(!E.send(v,l=>{if(l&&console.error(l),h=!1,m.length>0){const u=m.slice(0);m=[],u.forEach(y=>d(y))}})||T.$i)&&(h=!0)};return{send:d}}e.$il=b;var C;(function(E){async function m(h,d,v){if(I.$_b(h))return h;if(d===void 0&&(d=O.cwd()),I.$dc(h)!=="."||(v===void 0&&L.$je(O.env.PATH)&&(v=O.env.PATH.split(I.$kc)),v===void 0||v.length===0))return I.$ac(d,h);async function l(u){if(await P.Promises.exists(u)){let y;try{y=await P.Promises.stat(u)}catch(p){p.message.startsWith("EACCES")&&(y=await P.Promises.lstat(u))}return y?!y.isDirectory():!1}return!1}for(const u of v){let y;if(I.$_b(u)?y=I.$ac(u,h):y=I.$ac(d,u,h),await l(y))return y;let p=y+".com";if(await l(p)||(p=y+".exe",await l(p)))return p}return I.$ac(d,h)}E.findExecutable=m})(C||(e.win32=C={}))}),define(oe[142],ae([0,1,63,26]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;function O(L){return new Promise((P,S)=>{let b;const C=new Map;function E(h,d,v,c,l){const u=C.get(d);if(h===L||u){const y={name:m(v),cmd:v,pid:h,ppid:d,load:c,mem:l};C.set(h,y),h===L&&(b=y),u&&(u.children||(u.children=[]),u.children.push(y),u.children.length>1&&(u.children=u.children.sort((p,R)=>p.pid-R.pid)))}}function m(h){const d=/--utility-sub-type=network/i,v=/--ms-enable-electron-run-as-node/i,c=/--crashes-directory/i,l=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,y=/--type=([a-zA-Z-]+)/;if(c.exec(h))return"electron-crash-reporter";if(l.exec(h))return"winpty-agent";if(u.exec(h))return"conpty-agent";let p=y.exec(h);if(p&&p.length===2)return p[1]==="renderer"?"window":p[1]==="utility"?d.exec(h)?"utility-network-service":"utility-process":p[1]==="extensionHost"?"extension-host":p[1];const R=/[a-zA-Z-]+\.js/g;let t="";do p=R.exec(h),p&&(t+=p+" ");while(p);return t&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${t})`:v.exec(h)?`electron-nodejs (${h})`:h}if(process.platform==="win32"){const h=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,v)=>{ne(["@vscode/windows-process-tree"],d,v)}).then(d=>{d.getProcessList(L,v=>{if(!v){S(new Error(`Root process ${L} not found`));return}d.getProcessCpuUsage(v,c=>{const l=new Map;c.forEach(u=>{const y=h(u.commandLine||"");l.set(u.pid,{name:m(y),cmd:y,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),b=l.get(L),b?(l.forEach(u=>{const y=l.get(u.ppid);y&&(y.children||(y.children=[]),y.children.push(u))}),l.forEach(u=>{u.children&&(u.children=u.children.sort((y,p)=>y.pid-p.pid))}),P(b)):S(new Error(`Root process ${L} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let h=function(){let d=[b];const v=[];for(;d.length;){const l=d.shift();l&&(v.push(l.pid),l.children&&(d=d.concat(l.children)))}let c=JSON.stringify(T.$4e.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+v.join(" "),(0,I.exec)(c,{},(l,u,y)=>{if(l||y)S(l||new Error(y.toString()));else{const p=u.toString().split(`
`);for(let R=0;R<v.length;R++){const t=C.get(v[R]);t.load=parseFloat(p[R])}if(!b){S(new Error(`Root process ${L} not found`));return}P(b)}})};(0,I.exec)("which ps",{},(d,v,c)=>{if(d||c)if(process.platform!=="linux")S(d||new Error(c.toString()));else{const l=JSON.stringify(T.$4e.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(l,{},(u,y,p)=>{u||p?S(u||new Error(p.toString())):(j(y,E),h())})}else{const l=v.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${l} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,p,R)=>{y||R&&!R.includes("screen size is bogus")?S(y||new Error(R.toString())):(j(p,E),process.platform==="linux"?h():b?P(b):S(new Error(`Root process ${L} not found`)))})}})}})}e.$fr=O;function j(L,P){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=L.toString().split(`
`);for(const C of b){const E=S.exec(C.trim());E&&E.length===6&&P(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var we=this&&this.__decorate||function(ne,e,I,T){var O=arguments.length,j=O<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,I):T,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ne,e,I,T);else for(var P=ne.length-1;P>=0;P--)(L=ne[P])&&(j=(O<3?L(j):O>3?L(e,I,j):L(e,I))||j);return O>3&&j&&Object.defineProperty(e,I,j),j};define(oe[43],ae([0,1,21,6,14,25,81,7,3,2,62,27,11]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.ProxyChannel=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.RequestInitiator=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=void 0;var h;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(h||(h={}));function d(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(v||(v={}));function c(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(l||(l={}));function u(W){let U=0;for(let q=0;;q+=7){const te=W.read(1);if(U|=(te.buffer[0]&127)<<q,!(te.buffer[0]&128))return U}}const y=n(0);function p(W,U){if(U===0){W.write(y);return}let q=0;for(let re=U;re!==0;re=re>>>7)q++;const te=O.$Jb.alloc(q);for(let re=0;U!==0;re++)te.buffer[re]=U&127,U=U>>>7,U>0&&(te.buffer[re]|=128);W.write(te)}class R{constructor(U){this.b=U,this.a=0}read(U){const q=this.b.slice(this.a,this.a+U);return this.a+=q.byteLength,q}}e.$Zg=R;class t{constructor(){this.a=[]}get buffer(){return O.$Jb.concat(this.a)}write(U){this.a.push(U)}}e.$1g=t;var o;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(o||(o={}));function n(W){const U=O.$Jb.alloc(1);return U.writeUInt8(W,0),U}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},i=typeof Buffer<"u";function r(W,U){if(typeof U>"u")W.write(s.Undefined);else if(typeof U=="string"){const q=O.$Jb.fromString(U);W.write(s.String),p(W,q.byteLength),W.write(q)}else if(i&&Buffer.isBuffer(U)){const q=O.$Jb.wrap(U);W.write(s.Buffer),p(W,q.byteLength),W.write(q)}else if(U instanceof O.$Jb)W.write(s.VSBuffer),p(W,U.byteLength),W.write(U);else if(Array.isArray(U)){W.write(s.Array),p(W,U.length);for(const q of U)r(W,q)}else if(typeof U=="number"&&(U|0)===U)W.write(s.Uint),p(W,U);else{const q=O.$Jb.fromString(JSON.stringify(U));W.write(s.Object),p(W,q.byteLength),W.write(q)}}e.$2g=r;function a(W){switch(W.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return W.read(u(W)).toString();case o.Buffer:return W.read(u(W)).buffer;case o.VSBuffer:return W.read(u(W));case o.Array:{const q=u(W),te=[];for(let re=0;re<q;re++)te.push(a(W));return te}case o.Object:return JSON.parse(W.read(u(W)).toString());case o.Int:return u(W)}}e.$3g=a;class w{constructor(U,q,te=null,re=1e3){this.h=U,this.j=q,this.k=te,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(U,q){this.b.set(U,q),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const q=this.o([U.type]);this.k?.logOutgoing(q,0,1,c(U.type));return}case 201:case 202:case 204:case 203:{const q=this.o([U.type,U.id],U.data);this.k?.logOutgoing(q,U.id,1,c(U.type),U.data);return}}}o(U,q=void 0){const te=new t;return r(te,U),r(te,q),this.p(te.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const q=new R(U),te=a(q),re=a(q),ce=te[0];switch(ce){case 100:return this.k?.logIncoming(U.byteLength,te[1],1,`${d(ce)}: ${te[2]}.${te[3]}`,re),this.s({type:ce,id:te[1],channelName:te[2],name:te[3],arg:re});case 102:return this.k?.logIncoming(U.byteLength,te[1],1,`${d(ce)}: ${te[2]}.${te[3]}`,re),this.t({type:ce,id:te[1],channelName:te[2],name:te[3],arg:re});case 101:return this.k?.logIncoming(U.byteLength,te[1],1,`${d(ce)}`),this.u({type:ce,id:te[1]});case 103:return this.k?.logIncoming(U.byteLength,te[1],1,`${d(ce)}`),this.u({type:ce,id:te[1]})}}s(U){const q=this.b.get(U.channelName);if(!q){this.v(U);return}const te=new j.$ed;let re;try{re=q.call(this.j,U.name,U.arg,te.token)}catch(N){re=Promise.reject(N)}const ce=U.id;re.then(N=>{this.m({id:ce,data:N,type:201}),this.d.delete(U.id)},N=>{N instanceof Error?this.m({id:ce,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.m({id:ce,data:N,type:203}),this.d.delete(U.id)});const G=(0,b.$jb)(()=>te.cancel());this.d.set(U.id,G)}t(U){const q=this.b.get(U.channelName);if(!q){this.v(U);return}const te=U.id,ce=q.listen(this.j,U.name,U.arg)(G=>this.m({id:te,data:G,type:204}));this.d.set(U.id,ce)}u(U){const q=this.d.get(U.id);q&&(q.dispose(),this.d.delete(U.id))}v(U){let q=this.g.get(U.channelName);q||(q=[],this.g.set(U.channelName,q));const te=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:U,timeoutTimer:te})}w(U){const q=this.g.get(U);if(q){for(const te of q)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.s(te.request);break;case 102:this.t(te.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$gb)(this.d.values()),this.d.clear()}}e.$4g=w;var g;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));class f{constructor(U,q=null){this.l=U,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$8c,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(te=>this.s(te)),this.j=q}getChannel(U){const q=this;return{call(te,re,ce){return q.a?Promise.reject(new P.$3):q.m(U,te,re,ce)},listen(te,re){return q.a?S.Event.None:q.o(U,te,re)}}}m(U,q,te,re=j.CancellationToken.None){const ce=this.g++,N={id:ce,type:100,channelName:U,name:q,arg:te};if(re.isCancellationRequested)return Promise.reject(new P.$3);let $;return new Promise((z,K)=>{if(re.isCancellationRequested)return K(new P.$3);const _=()=>{const le=he=>{switch(he.type){case 201:this.f.delete(ce),z(he.data);break;case 202:{this.f.delete(ce);const me=new Error(he.data.message);me.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,me.name=he.data.name,K(me);break}case 203:this.f.delete(ce),K(he.data);break}};this.f.set(ce,le),this.p(N)};let H=null;this.b===l.Idle?_():(H=(0,T.$jg)(le=>this.u()),H.then(()=>{H=null,_()}));const ee=()=>{H?(H.cancel(),H=null):this.p({id:ce,type:101}),K(new P.$3)},ie=re.onCancellationRequested(ee);$=(0,b.$ib)((0,b.$jb)(ee),ie),this.d.add($)}).finally(()=>{this.d.delete($)})}o(U,q,te){const re=this.g++,G={id:re,type:102,channelName:U,name:q,arg:te};let N=null;const $=new S.$8c({onWillAddFirstListener:()=>{N=(0,T.$jg)(z=>this.u()),N.then(()=>{N=null,this.d.add($),this.p(G)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.d.delete($),this.p({id:re,type:103}))}}),D=z=>$.fire(z.data);return this.f.set(re,D),$.event}p(U){switch(U.type){case 100:case 102:{const q=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(q,U.id,0,`${d(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const q=this.q([U.type,U.id]);this.j?.logOutgoing(q,U.id,0,d(U.type));return}}}q(U,q=void 0){const te=new t;return r(te,U),r(te,q),this.r(te.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const q=new R(U),te=a(q),re=a(q),ce=te[0];switch(ce){case 200:return this.j?.logIncoming(U.byteLength,0,0,c(ce)),this.t({type:te[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,te[1],0,c(ce),re),this.t({type:te[0],id:te[1],data:re})}}t(U){if(U.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$gb)(this.d.values()),this.d.clear()}}e.$5g=f,we([L.$Tg],f.prototype,"onDidInitializePromise",null);class k{get connections(){const U=[];return this.f.forEach(q=>U.push(q)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new S.$8c,this.onDidAddConnection=this.g.event,this.h=new S.$8c,this.onDidRemoveConnection=this.h.event,U(({protocol:q,onDidClientDisconnect:te})=>{S.Event.once(q.onMessage)(ce=>{const G=new R(ce),N=a(G),$=new w(q,N),D=new f(q);this.a.forEach((K,_)=>$.registerChannel(_,K));const z={channelServer:$,channelClient:D,ctx:N};this.f.add(z),this.g.fire(z),te(()=>{$.dispose(),D.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(U,q){const te=this;return{call(re,ce,G){let N;if((0,m.$xe)(q)){const D=(0,I.$Kf)(te.connections.filter(q));N=D?Promise.resolve(D):S.Event.toPromise(S.Event.filter(te.onDidAddConnection,q))}else N=q.routeCall(te,re,ce);const $=N.then(D=>D.channelClient.getChannel(U));return M($).call(re,ce,G)},listen(re,ce){if((0,m.$xe)(q))return te.j(U,q,re,ce);const G=q.routeEvent(te,re,ce).then(N=>N.channelClient.getChannel(U));return M(G).listen(re,ce)}}}j(U,q,te,re){const ce=this;let G=new b.$kb;const N=new S.$8c({onWillAddFirstListener:()=>{G=new b.$kb;const $=new S.$bd,D=new Map,z=_=>{const ee=_.channelClient.getChannel(U).listen(te,re),ie=$.add(ee);D.set(_,ie)},K=_=>{const H=D.get(_);H&&(H.dispose(),D.delete(_))};ce.connections.filter(q).forEach(z),S.Event.filter(ce.onDidAddConnection,q)(z,void 0,G),ce.onDidRemoveConnection(K,void 0,G),$.event(N.fire,N,G),G.add($)},onDidRemoveLastListener:()=>{G.dispose()}});return N.event}registerChannel(U,q){this.a.set(U,q),this.f.forEach(te=>{te.channelServer.registerChannel(U,q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$6g=k;class A{constructor(U,q,te=null){const re=new t;r(re,q),U.send(re.buffer),this.a=new f(U,te),this.d=new w(U,q,te)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,q){this.d.registerChannel(U,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$7g=A;function M(W){return{call(U,q,te){return W.then(re=>re.call(U,q,te))},listen(U,q){const te=new S.$dd;return W.then(re=>te.input=re.listen(U,q)),te.event}}}e.$8g=M;function F(W){let U=!1;return{call(q,te,re){return U?W.call(q,te,re):(0,T.$wg)(0).then(()=>U=!0).then(()=>W.call(q,te,re))},listen(q,te){if(U)return W.listen(q,te);const re=new S.$dd;return(0,T.$wg)(0).then(()=>U=!0).then(()=>re.input=W.listen(q,te)),re.event}}}e.$9g=F;class V{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const q of U.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await S.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$0g=V;var B;(function(W){function U(ce,G){const N=ce,$=G&&G.disableMarshalling,D=new Map;for(const z in N)te(z)&&D.set(z,S.Event.buffer(N[z],!0));return new class{listen(z,K,_){const H=D.get(K);if(H)return H;if(re(K)){const ee=N[K];if(typeof ee=="function")return ee.call(N,_)}throw new P.$ab(`Event not found: ${K}`)}call(z,K,_){const H=N[K];if(typeof H=="function"){if(!$&&Array.isArray(_))for(let ee=0;ee<_.length;ee++)_[ee]=(0,C.$Yg)(_[ee]);return H.apply(N,_)}throw new P.$ab(`Method not found: ${K}`)}}}W.fromService=U;function q(ce,G){const N=G&&G.disableMarshalling;return new Proxy({},{get($,D){if(typeof D=="string")return G?.properties?.has(D)?G.properties.get(D):re(D)?function(z){return ce.listen(D,z)}:te(D)?ce.listen(D):async function(...z){let K;G&&!(0,m.$se)(G.context)?K=[G.context,...z]:K=z;const _=await ce.call(D,K);return N?_:(0,C.$Yg)(_)};throw new P.$ab(`Property not found: ${String(D)}`)}})}W.toService=q;function te(ce){return ce[0]==="o"&&ce[1]==="n"&&E.$Ld(ce.charCodeAt(2))}function re(ce){return/^onDynamic/.test(ce)&&E.$Ld(ce.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const x=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Z(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const U=W.toString();if(U!=="[object Object]")return U}return W}function Q(W){return Array.isArray(W)?W.map(Z):Z(W)}function J(W,U,q,te,re,ce,G){G=Q(G);const N=x[re],$=N[te%N.length];let D=[`%c[${W}]%c[${String(U).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(ce)?(D=D.concat(G),D.push(")")):D.push(G),console.log.apply(console,D)}class X{constructor(U,q){this.d=U,this.f=q,this.a=0,this.b=0}logOutgoing(U,q,te,re,ce){this.b+=U,J(this.d,this.b,U,q,te,re,ce)}logIncoming(U,q,te,re,ce){this.a+=U,J(this.f,this.a,U,q,te,re,ce)}}e.$$g=X}),define(oe[92],ae([0,1,14,3,2,43]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dh=e.$ch=e.$bh=e.$ah=e.ProtocolConstants=e.$_g=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var P;(function(s){s.enableDiagnostics=!1,s.records=[];const i=new WeakMap;let r=0;function a(g,f){if(!i.has(g)){const k=String(++r);i.set(g,k)}return i.get(g)}function w(g,f,k,A){if(!s.enableDiagnostics)return;const M=a(g,f);if(A instanceof I.$Jb||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const F=I.$Jb.alloc(A.byteLength);F.set(A),s.records.push({timestamp:Date.now(),id:M,label:f,type:k,buff:F})}else s.records.push({timestamp:Date.now(),id:M,label:f,type:k,data:A})}s.traceSocketEvent=w})(P||(e.SocketDiagnostics=P={}));var S;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let b=null;function C(){return b||(b=I.$Jb.alloc(0)),b}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,r){if(i===0)return C();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const f=this.a[0];return r&&(this.a.shift(),this.b-=i),f}if(this.a[0].byteLength>i){const f=this.a[0].slice(0,i);return r&&(this.a[0]=this.a[0].slice(i),this.b-=i),f}const a=I.$Jb.alloc(i);let w=0,g=0;for(;i>0;){const f=this.a[g];if(f.byteLength>i){const k=f.slice(0,i);a.set(k,w),w+=i,r&&(this.a[g]=f.slice(i),this.b-=i),i-=i}else a.set(f,w),w+=f.byteLength,r?(this.a.shift(),this.b-=f.byteLength):g++,i-=f.byteLength}return a}}e.$_g=E;var m;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(m||(m={}));function h(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class v{constructor(i,r,a,w){this.type=i,this.id=r,this.ack=a,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends O.$lb{constructor(i){super(),this.f=this.B(new T.$8c),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new E,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,w=this.g.id,g=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new v(a,w,g,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$Jb.alloc(13);r.writeUInt8(i.type,0),r.writeUInt32BE(i.id,1),r.writeUInt32BE(i.ack,5),r.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(r,i.data)}g(i,r){const a=this.f===0;return this.d.push(i,r),this.f+=i.byteLength+r.byteLength,a}h(){const i=I.$Jb.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,r){this.g(i,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class u extends O.$lb{constructor(i){super(),this.f=new T.$8c,this.onMessage=this.f.event,this.g=new T.$8c,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new l(this.a)),this.c=this.B(new c(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new v(1,0,0,i))}}e.$ah=u;class y extends j.$7g{static fromSocket(i,r){return new y(new u(i),r)}get onDidDispose(){return this.b.onDidDispose}constructor(i,r,a=null){super(i,r,a),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$bh=y;class p{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$8c({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$ch=p;class R{constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,r=this.a;for(;r;)r=r.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let r=0,a=this.a;for(;a;)i[r++]=a.data,a=a.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const r=new R(i);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const i=Date.now();for(let r=0;r<o.a;r++)this.c[r]=i-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),r=(1+o.a)*1e3;let a=0;for(let w=0;w<o.a;w++)i-this.c[w]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new p,this.onControlMessage=this.u.event,this.v=new p,this.onMessage=this.v.event,this.w=new p,this.onDidDispose=this.w.event,this.x=new p,this.onSocketClose=this.x.event,this.y=new p,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??o.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new O.$kb,this.o=i.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new v(5,0,0,C());this.p.write(i),this.p.flush()}sendPause(){const i=new v(7,0,0,C());this.p.write(i)}sendResume(){const i=new v(8,0,0,C());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,r){this.a=!0,this.r.dispose(),this.r=new O.$kb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new v(3,0,this.h,C());this.p.write(i);const r=this.b.toArray();for(let a=0,w=r.length;a<w;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const r=this.b.peek();if(r&&r.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new v(6,0,0,C())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,w=r.length;a<w;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const r=++this.c;this.h=this.g;const a=new v(1,r,this.h,i);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(i){const r=new v(2,0,0,i);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),r=Date.now()-i.writtenTime,a=Date.now()-this.q.lastReadTime,w=Date.now()-this.n;if(r>=2e4&&a>=2e4&&w>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const g=Math.max(2e4-r,2e4-a,2e4-w,500);this.f=setTimeout(()=>{this.f=null,this.B()},g)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new v(3,0,this.h,C());this.p.write(i)}D(){this.h=this.g;const i=new v(9,0,this.h,C());this.p.write(i)}}e.$dh=n}),define(oe[93],ae([0,1,63,6,14,25,138,7,3,2,30,141,89,43]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=void 0;class d extends h.$4g{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",u=>O.$Jb.wrap(Buffer.from(u,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$Gp=d;class v{constructor(l,u){this.i=l,this.j=u,this.c=new Set,this.g=new Map,this.h=new S.$8c,this.onDidProcessExit=this.h.event;const y=u&&u.timeout?u.timeout:6e4;this.b=new T.$sg(y),this.d=null,this.f=null}getChannel(l){const u=this;return{call(y,p,R){return u.k(l,y,p,R)},listen(y,p){return u.l(l,y,p)}}}k(l,u,y,p=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(P.$4());this.b.cancel();const R=this.n(l),t=(0,T.$jg)(s=>R.call(u,y,s)),o=p.onCancellationRequested(()=>t.cancel()),n=(0,b.$jb)(()=>t.cancel());return this.c.add(n),t.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(l,u,y){if(!this.b)return S.Event.None;this.b.cancel();let p;const R=new S.$8c({onWillAddFirstListener:()=>{p=this.n(l).listen(u,y)(R.fire,R),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return R.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,C.$Hm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,m.$gl)(u.env),this.d=(0,I.fork)(this.i,l,u);const y=new S.$8c;S.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,L.$Cp)(i)){(0,L.log)(i,`IPC Library: ${this.j.serverName}`);return}y.fire(O.$Jb.wrap(Buffer.from(i,"base64")))});const R=this.j.useQueue?(0,E.$il)(this.d):this.d,t=i=>this.d&&this.d.connected&&R.send(i.buffer.toString("base64")),o=y.event,n={send:t,onMessage:o};this.f=new h.$5g(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,r)=>{process.removeListener("exit",s),this.c.forEach(a=>(0,b.$gb)(a)),this.c.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:r})})}return this.f}n(l){let u=this.g.get(l);return u||(u=this.m.getChannel(l),this.g.set(l,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Hp=v}),define(oe[143],ae([0,1,131,14,43,3,11,21]),function(ne,e,I,T,O,j,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CS=e.$BS=void 0;class S{constructor(m){this.a=m,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",h=>T.$Jb.wrap(h.data)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class b extends O.$6g{static b(){(0,L.$te)((0,I.$AS)(process),"Electron Utility Process");const m=new j.$8c;return process.parentPort.on("message",h=>{const d=(0,P.$vf)(h.ports);d&&m.fire(d)}),j.Event.map(m.event,h=>({protocol:new S(h),onDidClientDisconnect:j.Event.fromNodeEventEmitter(h,"close")}))}constructor(){super(b.b())}}e.$BS=b;function C(E,m,h){const d=v=>{v.data===m&&(E.removeListener("message",d),h())};E.on("message",d)}e.$CS=C}),define(oe[64],ae([0,1,6,3,2,62,11]),function(ne,e,I,T,O,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.StorageState=e.$Fo=e.StorageHint=void 0;var P;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function S(m){const h=m;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$Fo=S;var b;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(b||(e.StorageState=b={}));class C extends O.$lb{static{this.a=100}constructor(h,d=Object.create(null)){super(),this.m=h,this.n=d,this.b=this.B(new T.$$c),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=new I.$tg(C.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(h=>this.r(h)))}r(h){this.b.pause();try{h.changed?.forEach((d,v)=>this.s(v,d)),h.deleted?.forEach(d=>this.s(d,void 0))}finally{this.b.resume()}}s(h,d){if(this.c===b.Closed)return;let v=!1;(0,L.$se)(d)?v=this.f.delete(h):this.f.get(h)!==d&&(this.f.set(h,d),v=!0),v&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.n.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(h,d){const v=this.f.get(h);return(0,L.$se)(v)?d:v}getBoolean(h,d){const v=this.get(h);return(0,L.$se)(v)?d:v==="true"}getNumber(h,d){const v=this.get(h);return(0,L.$se)(v)?d:parseInt(v,10)}getObject(h,d){const v=this.get(h);return(0,L.$se)(v)?d:(0,j.$Xg)(v)}async set(h,d,v=!1){if(this.c===b.Closed)return;if((0,L.$se)(d))return this.delete(h,v);const c=(0,L.$le)(d)||Array.isArray(d)?(0,j.$Wg)(d):String(d);if(this.f.get(h)!==c)return this.f.set(h,c),this.j.set(h,c),this.h.delete(h),this.b.fire({key:h,external:v}),this.w()}async delete(h,d=!1){if(!(this.c===b.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:d}),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=b.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(h).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(h){if(this.u)return this.w(h)}async w(h){return this.g.trigger(()=>this.v(),h)}async whenFlushed(){if(this.u)return new Promise(h=>this.l.push(h))}isInMemory(){return this.n.hint===P.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Go=C;class E{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((d,v)=>this.a.set(v,d)),h.delete?.forEach(d=>this.a.delete(d))}async close(){}}e.$Ho=E}),define(oe[144],ae([12,9]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(oe[145],ae([12,9]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[146],ae([12,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[147],ae([12,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(oe[148],ae([12,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[149],ae([12,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[150],ae([12,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[151],ae([12,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[152],ae([12,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[153],ae([12,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[154],ae([12,9]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[155],ae([12,9]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(oe[156],ae([12,9]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(oe[157],ae([12,9]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(oe[158],ae([12,9]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[159],ae([12,9]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[160],ae([12,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[161],ae([12,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[162],ae([12,9]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(oe[163],ae([12,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[164],ae([12,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[165],ae([12,9]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[166],ae([12,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[167],ae([12,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[168],ae([12,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[169],ae([12,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[170],ae([12,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[171],ae([12,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[172],ae([12,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[173],ae([12,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[174],ae([12,9]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(oe[175],ae([0,1,7,147]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.TokenType=void 0;var O;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(O||(e.TokenType=O={}));function j(...b){switch(b.length){case 1:return(0,T.localize)(0,null,b[0]);case 2:return(0,T.localize)(1,null,b[0],b[1]);case 3:return(0,T.localize)(2,null,b[0],b[1],b[2]);default:return}}const L=(0,T.localize)(3,null),P=(0,T.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,I.$6)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const E=this.d,m=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:m};this.g.push({offset:E,lexeme:m,additionalInfo:C}),this.f.push(h)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const E=this.c.substring(this.d,this.e),m=S.b.get(E);m?this.k(m):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,E=!1,m=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(P);return}const d=this.c.charCodeAt(C);if(E)E=!1;else if(d===47&&!m){C++;break}else d===91?m=!0:d===92?E=!0:d===93&&(m=!1);C++}for(;C<this.c.length&&S.a.has(this.c.charCodeAt(C));)C++;this.e=C;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$si=S}),define(oe[176],ae([0,1,61,81,26,16,37,22,10]),function(ne,e,I,T,O,j,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=e.$Ul=e.$Tl=void 0,e.$Tl=/^([^.]+\..+):(.+)$/;class b{get appRoot(){return(0,j.$dc)(O.$4e.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return S.URI.file((0,j.$ac)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.b.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,P.$0f)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:O.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$0f)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,I.$Sl)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$ac)(this.userDataPath,"logs",h)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$0f)(S.URI.file((0,j.$ac)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$0f)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$0f)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$0f)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=L.env.VSCODE_PORTABLE;return h?S.URI.file((0,j.$ac)(h,"argv.json")):(0,P.$0f)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,j.$ac)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,j.$bc)(h):(0,j.$$b)((0,j.$ac)(O.$4e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?S.URI.file((0,j.$bc)(h)):S.URI.file((0,j.$ac)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,j.$bc)(h);const d=L.env.VSCODE_EXTENSIONS;if(d)return d;const v=L.env.VSCODE_PORTABLE;return v?(0,j.$ac)(v,"extensions"):(0,P.$0f)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(d=>/^[^:/?#]+?:\/\//.test(d)?S.URI.parse(d):S.URI.file((0,j.$$b)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?S.URI.parse(h):S.URI.file((0,j.$$b)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$Tl.test(h))}get extensionLogLevel(){const h=[];for(const d of this.args.log||[]){const v=e.$Tl.exec(d);v&&v[1]&&v[2]&&h.push([v[1],v[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,P.$0f)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get disableKeytar(){return!!this.args["disable-keytar"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=L.env.VSCODE_PORTABLE;return h?S.URI.file((0,j.$ac)(h,"policy.json")):(0,P.$0f)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,d,v){this.a=h,this.b=d,this.c=v,this.editSessionId=this.args.editSessionId}}e.$Ul=b,we([T.$Tg],b.prototype,"appRoot",null),we([T.$Tg],b.prototype,"userHome",null),we([T.$Tg],b.prototype,"userDataPath",null),we([T.$Tg],b.prototype,"appSettingsHome",null),we([T.$Tg],b.prototype,"tmpDir",null),we([T.$Tg],b.prototype,"cacheHome",null),we([T.$Tg],b.prototype,"stateResource",null),we([T.$Tg],b.prototype,"userRoamingDataHome",null),we([T.$Tg],b.prototype,"userDataSyncHome",null),we([T.$Tg],b.prototype,"sync",null),we([T.$Tg],b.prototype,"machineSettingsResource",null),we([T.$Tg],b.prototype,"workspaceStorageHome",null),we([T.$Tg],b.prototype,"localHistoryHome",null),we([T.$Tg],b.prototype,"keyboardLayoutResource",null),we([T.$Tg],b.prototype,"argvResource",null),we([T.$Tg],b.prototype,"isExtensionDevelopment",null),we([T.$Tg],b.prototype,"untitledWorkspacesHome",null),we([T.$Tg],b.prototype,"builtinExtensionsPath",null),we([T.$Tg],b.prototype,"extensionsPath",null),we([T.$Tg],b.prototype,"extensionDevelopmentLocationURI",null),we([T.$Tg],b.prototype,"extensionDevelopmentKind",null),we([T.$Tg],b.prototype,"extensionTestsLocationURI",null),we([T.$Tg],b.prototype,"debugExtensionHost",null),we([T.$Tg],b.prototype,"logLevel",null),we([T.$Tg],b.prototype,"extensionLogLevel",null),we([T.$Tg],b.prototype,"serviceMachineIdResource",null),we([T.$Tg],b.prototype,"disableTelemetry",null),we([T.$Tg],b.prototype,"disableWorkspaceTrust",null),we([T.$Tg],b.prototype,"disableKeytar",null),we([T.$Tg],b.prototype,"policyFile",null);function C(m,h){return E(m["inspect-extensions"],m["inspect-brk-extensions"],5870,h,m.debugId,m.extensionEnvironment)}e.$Vl=C;function E(m,h,d,v,c,l){const y=Number(h||m)||(v?null:d),p=y?!!h:!1;let R;if(l)try{R=JSON.parse(l)}catch{}return{port:y,break:p,debugId:c,env:R}}e.$Wl=E}),function(){"use strict";function ne(e,I,T){function O(L,P){const S=j(L,P),b=[S];return e.isAbsolute(S)||b.unshift(T),e.resolve(...b)}function j(L,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,P);const C=L["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(E,"AppData","Roaming")}break;case"darwin":b=e.join(I.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,P)}return{getUserDataPath:O}}if(typeof define=="function")define(oe[177],ae([265,36,37]),function(e,I,T){return ne(e,I,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=ne(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[178],ae([0,1,36,176,177]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=e.$Xl=void 0;class j extends T.$Ul{constructor(b,C){super(b,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,O.getUserDataPath)(b,C.nameShort)},C)}}e.$Xl=j;function L(S,b){return(0,T.$Wl)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,b,S.extensionEnvironment)}e.$Yl=L;function P(S,b){return(0,T.$Wl)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,b,S.extensionEnvironment)}e.$Zl=P}),define(oe[179],ae([0,1,11,150]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=void 0;function O(L,P,S){try{j(L,P,S)}catch(b){console.error(b?.message??b)}return L}e.$cp=O;function j(L,P,S){const b=(C,E,m)=>{const h=C[E];if((0,I.$je)(h)){const d=h,v=d.length;if(v>1&&d[0]==="%"&&d[v-1]==="%"){const c=d.substr(1,v-2);let l=P[c];l===void 0&&S&&(l=S[c]);const u=typeof l=="string"?l:l?.message,y=S?.[c],p=typeof y=="string"?y:y?.message;if(!u){p||console.warn(`[${L.name}]: ${(0,T.localize)(0,null,c)}`);return}if(m&&(E==="title"||E==="category")&&p&&p!==u){const R={value:u,original:p};C[E]=R}else C[E]=u}}else if((0,I.$le)(h))for(const d in h)h.hasOwnProperty(d)&&(d==="commands"?b(h,d,!0):b(h,d,m));else if(Array.isArray(h))for(let d=0;d<h.length;d++)b(h,d,m)};for(const C in L)L.hasOwnProperty(C)&&b(L,C)}}),define(oe[180],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$95b=e.$85b=void 0;class I{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$85b=I;class T{constructor(j){this.a=j}listen(j,L){throw new Error(`Event not found: ${L}`)}call(j,L,P){switch(L){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(P[0])}throw new Error(`Call not found: ${L}`)}}e.$95b=T}),define(oe[65],ae([0,1,22,88,154,53]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||L.test(l)}e.$ro=S;function b(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(L);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$so=b;function C(l){if(!l)return null;const u=l.majorBase,y=l.majorMustEqual,p=l.minorBase;let R=l.minorMustEqual;const t=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(u===0||(R=!1),o=!1);let n=0;if(l.preRelease){const s=P.exec(l.preRelease);if(s){const[,i,r,a]=s;n=Date.UTC(Number(i),Number(r)-1,Number(a))}}return{majorBase:u,majorMustEqual:y,minorBase:p,minorMustEqual:R,patchBase:t,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:n}}e.$to=C;function E(l,u,y){let p;typeof l=="string"?p=C(b(l)):p=l;let R;u instanceof Date?R=u.getTime():typeof u=="string"&&(R=new Date(u).getTime());let t;if(typeof y=="string"?t=C(b(y)):t=y,!p||!t)return!1;const o=p.majorBase,n=p.minorBase,s=p.patchBase;let i=t.majorBase,r=t.minorBase,a=t.patchBase;const w=t.notBefore;let g=t.majorMustEqual,f=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?o>i?!0:o<i?!1:n>r?!0:n<r||R&&R<w?!1:s>=a:(o===1&&i===0&&(!g||!f||!k)&&(i=1,r=0,a=0,g=!0,f=!1,k=!1),o<i?!1:o>i?!g:n<r?!1:n>r?!f:s<a?!1:s>a?!k:!(R&&R<w))}e.$uo=E;function m(l,u,y,p,R){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([T.default.Error,O.localize(0,null)]),t;if(typeof p.name!="string")return t.push([T.default.Error,O.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([T.default.Error,O.localize(2,null,"version")]),t;if(!p.engines)return t.push([T.default.Error,O.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([T.default.Error,O.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!c(p.extensionDependencies))return t.push([T.default.Error,O.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!c(p.activationEvents))return t.push([T.default.Error,O.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([T.default.Error,O.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([T.default.Warning,O.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([T.default.Error,O.localize(9,null,"main")]),t;{const s=(0,I.$0f)(y,p.main);(0,I.$4f)(s,y)||t.push([T.default.Warning,O.localize(10,null,s.path,y.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([T.default.Error,O.localize(11,null,"browser")]),t;{const s=(0,I.$0f)(y,p.browser);(0,I.$4f)(s,y)||t.push([T.default.Warning,O.localize(12,null,s.path,y.path)])}}if(!j.valid(p.version))return t.push([T.default.Error,O.localize(13,null)]),t;const o=[];if(!h(l,u,p,R,o))for(const s of o)t.push([T.default.Error,s]);return t}e.$vo=m;function h(l,u,y,p,R){return p||typeof y.main>"u"&&typeof y.browser>"u"?!0:v(l,u,y.engines.vscode,R)}e.$wo=h;function d(l,u,y){return l==="*"||v(u,y,l)}e.$xo=d;function v(l,u,y,p=[]){const R=C(b(y));if(!R)return p.push(O.localize(14,null,y)),!1;if(R.majorBase===0){if(!R.majorMustEqual||!R.minorMustEqual)return p.push(O.localize(15,null,y)),!1}else if(!R.majorMustEqual)return p.push(O.localize(16,null,y)),!1;return E(l,u,R)?!0:(p.push(O.localize(17,null,l,y)),!1)}function c(l){if(!Array.isArray(l))return!1;for(let u=0,y=l.length;u<y;u++)if(typeof l[u]!="string")return!1;return!0}}),define(oe[44],ae([0,1,14,32]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=void 0;async function O(j,L,P){let S=P&&P.get("storage.serviceMachineId",-1)||null;if(S)return S;try{const C=(await L.readFile(j.serviceMachineIdResource)).value.toString();S=(0,T.$5e)(C)?C:null}catch{S=null}if(!S){S=(0,T.$6e)();try{await L.writeFile(j.serviceMachineIdResource,I.$Jb.fromString(S))}catch{}}return P?.store("storage.serviceMachineId",S,-1,1),S}e.$Qo=O}),define(oe[66],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=void 0;class I{constructor(O,j=[],L=!1){this.ctor=O,this.staticArguments=j,this.supportsDelayedInstantiation=L}}e.$mh=I}),define(oe[181],ae([0,1,66]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=e.InstantiationType=void 0;const T=[];var O;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(O||(e.InstantiationType=O={}));function j(P,S,b){S instanceof I.$mh||(S=new I.$mh(S,[],!!b)),T.push([P,S])}e.$_q=j;function L(){return T}e.$ar=L}),define(oe[182],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=void 0;class I{constructor(j,L){this.key=j,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$Sp=I;class T{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const L of this.a.values())L.outgoing.size===0&&j.push(L);return j}insertEdge(j,L){const P=this.lookupOrInsertNode(j),S=this.lookupOrInsertNode(L);P.outgoing.set(S.key,S),S.incoming.set(P.key,P)}removeNode(j){const L=this.b(j);this.a.delete(L);for(const P of this.a.values())P.outgoing.delete(L),P.incoming.delete(L)}lookupOrInsertNode(j){const L=this.b(j);let P=this.a.get(L);return P||(P=new I(L,j),this.a.set(L,P)),P}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[L,P]of this.a)j.push(`${L}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,L]of this.a){const P=new Set([j]),S=this.c(L,P);if(S)return S}}c(j,L){for(const[P,S]of j.outgoing){if(L.has(P))return[...L,P].join(" -> ");L.add(P);const b=this.c(S,L);if(b)return b;L.delete(P)}}}e.$Tp=T}),define(oe[4],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e._util=void 0;var I;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function P(S){return S[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=P})(I||(e._util=I={})),e.$oh=O("instantiationService");function T(L,P,S){P[I.DI_TARGET]===P?P[I.DI_DEPENDENCIES].push({id:L,index:S}):(P[I.DI_DEPENDENCIES]=[{id:L,index:S}],P[I.DI_TARGET]=P)}function O(L){if(I.serviceIds.has(L))return I.serviceIds.get(L);const P=function(S,b,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(P,S,C)};return P.toString=()=>L,I.serviceIds.set(L,P),P}e.$ph=O;function j(L){return L}e.$qh=j}),define(oe[183],ae([0,1,4]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E5b=void 0,e.$E5b=(0,I.$ph)("checksumService")}),define(oe[18],ae([0,1,11,10,4]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.ConfigurationTarget=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,O.$ph)("configurationService");function j(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof T.URI)}e.$Wh=j;function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof T.URI)}e.$Xh=L;var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function S(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Yh=S;function b(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.$Zh=b;function C(l,u){const y=Object.create(null);for(const p in l)E(y,p,l[p],u);return y}e.$1h=C;function E(l,u,y,p){const R=u.split("."),t=R.pop();let o=l;for(let n=0;n<R.length;n++){const s=R[n];let i=o[s];switch(typeof i){case"undefined":i=o[s]=Object.create(null);break;case"object":break;default:p(`Ignoring ${u} as ${R.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[t]=y}catch{p(`Ignoring ${u} as ${R.join(".")} is ${JSON.stringify(o)}`)}else p(`Ignoring ${u} as ${R.join(".")} is ${JSON.stringify(o)}`)}e.$2h=E;function m(l,u){const y=u.split(".");h(l,y)}e.$3h=m;function h(l,u){const y=u.shift();if(u.length===0){delete l[y];return}if(Object.keys(l).indexOf(y)!==-1){const p=l[y];typeof p=="object"&&!Array.isArray(p)&&(h(p,u),Object.keys(p).length===0&&delete l[y])}}function d(l,u,y){function p(o,n){let s=o;for(const i of n){if(typeof s!="object"||s===null)return;s=s[i]}return s}const R=u.split("."),t=p(l,R);return typeof t>"u"?y:t}e.$4h=d;function v(l,u,y){Object.keys(u).forEach(p=>{p!=="__proto__"&&(p in l?I.$le(l[p])&&I.$le(u[p])?v(l[p],u[p],y):y&&(l[p]=u[p]):l[p]=u[p])})}e.$5h=v;function c(l){return l.replace(/[\[\]]/g,"")}e.$6h=c}),define(oe[94],ae([0,1,5,27,175,4,146,7]),function(ne,e,I,T,O,j,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ContextKeyExprType=e.$ti=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",I.$j),S.set("isLinux",I.$k),S.set("isWindows",I.$i),S.set("isWeb",I.$o),S.set("isMacNative",I.$j&&!I.$o),S.set("isEdge",I.$G),S.set("isFirefox",I.$E),S.set("isChrome",I.$D),S.set("isSafari",I.$F);function b(N,$){if(S.get(N)!==void 0)throw(0,P.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(N,$)}e.$ti=b;const C=Object.prototype.hasOwnProperty;var E;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const m={regexParsingWithErrorRecovery:!0},h=(0,L.localize)(0,null),d=(0,L.localize)(1,null),v=(0,L.localize)(2,null),c=(0,L.localize)(3,null),l=(0,L.localize)(4,null),u=(0,L.localize)(5,null),y=(0,L.localize)(6,null),p=(0,L.localize)(7,null);class R{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor($=m){this.k=$,this.d=new O.$si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse($){if($===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset($).scan(),this.g=0,this.h=[];try{const D=this.l();if(!this.E()){const z=this.D(),K=z.type===17?u:void 0;throw this.h.push({message:l,offset:z.offset,lexeme:O.$si.getLexeme(z),additionalInfo:K}),R.c}return D}catch(D){if(D!==R.c)throw D;return}}l(){return this.m()}m(){const $=[this.o()];for(;this.y(16);){const D=this.o();$.push(D)}return $.length===1?$[0]:t.or(...$)}o(){const $=[this.s()];for(;this.y(15);){const D=this.s();$.push(D)}return $.length===1?$[0]:t.and(...$)}s(){if(this.y(2)){const $=this.D();switch($.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const D=this.l();return this.A(1,c),D?.negate()}case 17:return this.z(),A.create($.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",$)}}return this.t()}t(){const $=this.D();switch($.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const D=this.l();return this.A(1,c),D}case 17:{const D=$.lexeme;if(this.z(),this.y(9)){const K=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),K.type!==10)throw this.B("REGEX",K);const _=K.lexeme,H=_.lastIndexOf("/"),ee=H===_.length-1?void 0:this.w(_.substring(H+1));let ie;try{ie=new RegExp(_.substring(1,H),ee)}catch{throw this.B("REGEX",K)}return Z.create(D,ie)}switch(K.type){case 10:case 19:{const _=[K.lexeme];this.z();let H=this.D(),ee=0;for(let be=0;be<K.lexeme.length;be++)K.lexeme.charCodeAt(be)===40?ee++:K.lexeme.charCodeAt(be)===41&&ee--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let be=0;be<H.lexeme.length;be++)H.lexeme.charCodeAt(be)===40?ee++:K.lexeme.charCodeAt(be)===41&&ee--}if(ee<0)break;_.push(O.$si.getLexeme(H)),this.z(),H=this.D()}const ie=_.join(""),le=ie.lastIndexOf("/"),he=le===ie.length-1?void 0:this.w(ie.substring(le+1));let me;try{me=new RegExp(ie.substring(1,le),he)}catch{throw this.B("REGEX",K)}return t.regex(D,me)}case 18:{const _=K.lexeme;this.z();let H=null;if(!(0,T.$kd)(_)){const ee=_.indexOf("/"),ie=_.lastIndexOf("/");if(ee!==ie&&ee>=0){const le=_.slice(ee+1,ie),he=_[ie+1]==="i"?"i":"";try{H=new RegExp(le,he)}catch{throw this.B("REGEX",K)}}}if(H===null)throw this.B("REGEX",K);return Z.create(D,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const K=this.u();return t.notIn(D,K)}switch(this.D().type){case 3:{this.z();const K=this.u();if(this.x().type===18)return t.equals(D,K);switch(K){case"true":return t.has(D);case"false":return t.not(D);default:return t.equals(D,K)}}case 4:{this.z();const K=this.u();if(this.x().type===18)return t.notEquals(D,K);switch(K){case"true":return t.not(D);case"false":return t.has(D);default:return t.notEquals(D,K)}}case 5:return this.z(),B.create(D,this.u());case 6:return this.z(),x.create(D,this.u());case 7:return this.z(),F.create(D,this.u());case 8:return this.z(),V.create(D,this.u());case 13:return this.z(),t.in(D,this.u());default:return t.has(D)}}case 20:throw this.h.push({message:y,offset:$.offset,lexeme:"",additionalInfo:p}),R.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const $=this.D();switch($.type){case 17:case 18:return this.z(),$.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w($){return $.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y($){return this.C($)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A($,D){if(this.C($))return this.z();throw this.B(D,this.D())}B($,D,z){const K=(0,L.localize)(8,null,$,O.$si.getLexeme(D)),_=D.offset,H=O.$si.getLexeme(D);return this.h.push({message:K,offset:_,lexeme:H,additionalInfo:z}),R.c}C($){return this.D().type===$}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ui=R;class t{static false(){return i.INSTANCE}static true(){return r.INSTANCE}static has($){return a.create($)}static equals($,D){return w.create($,D)}static notEquals($,D){return k.create($,D)}static regex($,D){return Z.create($,D)}static in($,D){return g.create($,D)}static notIn($,D){return f.create($,D)}static not($){return A.create($)}static and(...$){return X.create($,null,!0)}static or(...$){return W.create($,null,!0)}static greater($,D){return F.create($,D)}static greaterEquals($,D){return V.create($,D)}static smaller($,D){return B.create($,D)}static smallerEquals($,D){return x.create($,D)}static{this.c=new R({regexParsingWithErrorRecovery:!1})}static deserialize($){return $==null?void 0:this.c.parse($)}}e.$vi=t;function o(N){const $=new R({regexParsingWithErrorRecovery:!1});return N.map(D=>($.parse(D),$.lexingErrors.length>0?$.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,L.localize)(9,null,z.additionalInfo):(0,L.localize)(10,null),offset:z.offset,length:z.lexeme.length})):$.parsingErrors.length>0?$.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$wi=o;function n(N,$){const D=N?N.substituteConstants():void 0,z=$?$.substituteConstants():void 0;return!D&&!z?!0:!D||!z?!1:D.equals(z)}e.$xi=n;function s(N,$){return N.cmp($)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp($){return this.type-$.type}equals($){return $.type===this.type}substituteConstants(){return this}evaluate($){return!1}serialize(){return"false"}keys(){return[]}map($){return this}negate(){return r.INSTANCE}}e.$yi=i;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp($){return this.type-$.type}equals($){return $.type===this.type}substituteConstants(){return this}evaluate($){return!0}serialize(){return"true"}keys(){return[]}map($){return this}negate(){return i.INSTANCE}}e.$zi=r;class a{static create($,D=null){const z=S.get($);return typeof z=="boolean"?z?r.INSTANCE:i.INSTANCE:new a($,D)}constructor($,D){this.key=$,this.c=D,this.type=2}cmp($){return $.type!==this.type?this.type-$.type:q(this.key,$.key)}equals($){return $.type===this.type?this.key===$.key:!1}substituteConstants(){const $=S.get(this.key);return typeof $=="boolean"?$?r.INSTANCE:i.INSTANCE:this}evaluate($){return!!$.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map($){return $.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$Ai=a;class w{static create($,D,z=null){if(typeof D=="boolean")return D?a.create($,z):A.create($,z);const K=S.get($);return typeof K=="boolean"?D===(K?"true":"false")?r.INSTANCE:i.INSTANCE:new w($,D,z)}constructor($,D,z){this.c=$,this.d=D,this.f=z,this.type=4}cmp($){return $.type!==this.type?this.type-$.type:te(this.c,this.d,$.c,$.d)}equals($){return $.type===this.type?this.c===$.c&&this.d===$.d:!1}substituteConstants(){const $=S.get(this.c);if(typeof $=="boolean"){const D=$?"true":"false";return this.d===D?r.INSTANCE:i.INSTANCE}return this}evaluate($){return $.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map($){return $.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Bi=w;class g{static create($,D){return new g($,D)}constructor($,D){this.d=$,this.f=D,this.type=10,this.c=null}cmp($){return $.type!==this.type?this.type-$.type:te(this.d,this.f,$.d,$.f)}equals($){return $.type===this.type?this.d===$.d&&this.f===$.f:!1}substituteConstants(){return this}evaluate($){const D=$.getValue(this.f),z=$.getValue(this.d);return Array.isArray(D)?D.includes(z):typeof z=="string"&&typeof D=="object"&&D!==null?C.call(D,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map($){return $.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Ci=g;class f{static create($,D){return new f($,D)}constructor($,D){this.d=$,this.f=D,this.type=11,this.c=g.create($,D)}cmp($){return $.type!==this.type?this.type-$.type:this.c.cmp($.c)}equals($){return $.type===this.type?this.c.equals($.c):!1}substituteConstants(){return this}evaluate($){return!this.c.evaluate($)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map($){return $.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Di=f;class k{static create($,D,z=null){if(typeof D=="boolean")return D?A.create($,z):a.create($,z);const K=S.get($);return typeof K=="boolean"?D===(K?"true":"false")?i.INSTANCE:r.INSTANCE:new k($,D,z)}constructor($,D,z){this.c=$,this.d=D,this.f=z,this.type=5}cmp($){return $.type!==this.type?this.type-$.type:te(this.c,this.d,$.c,$.d)}equals($){return $.type===this.type?this.c===$.c&&this.d===$.d:!1}substituteConstants(){const $=S.get(this.c);if(typeof $=="boolean"){const D=$?"true":"false";return this.d===D?i.INSTANCE:r.INSTANCE}return this}evaluate($){return $.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map($){return $.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Ei=k;class A{static create($,D=null){const z=S.get($);return typeof z=="boolean"?z?i.INSTANCE:r.INSTANCE:new A($,D)}constructor($,D){this.c=$,this.d=D,this.type=3}cmp($){return $.type!==this.type?this.type-$.type:q(this.c,$.c)}equals($){return $.type===this.type?this.c===$.c:!1}substituteConstants(){const $=S.get(this.c);return typeof $=="boolean"?$?i.INSTANCE:r.INSTANCE:this}evaluate($){return!$.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map($){return $.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$Fi=A;function M(N,$){if(typeof N=="string"){const D=parseFloat(N);isNaN(D)||(N=D)}return typeof N=="string"||typeof N=="number"?$(N):i.INSTANCE}class F{static create($,D,z=null){return M(D,K=>new F($,K,z))}constructor($,D,z){this.c=$,this.d=D,this.f=z,this.type=12}cmp($){return $.type!==this.type?this.type-$.type:te(this.c,this.d,$.c,$.d)}equals($){return $.type===this.type?this.c===$.c&&this.d===$.d:!1}substituteConstants(){return this}evaluate($){return typeof this.d=="string"?!1:parseFloat($.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map($){return $.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Gi=F;class V{static create($,D,z=null){return M(D,K=>new V($,K,z))}constructor($,D,z){this.c=$,this.d=D,this.f=z,this.type=13}cmp($){return $.type!==this.type?this.type-$.type:te(this.c,this.d,$.c,$.d)}equals($){return $.type===this.type?this.c===$.c&&this.d===$.d:!1}substituteConstants(){return this}evaluate($){return typeof this.d=="string"?!1:parseFloat($.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map($){return $.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Hi=V;class B{static create($,D,z=null){return M(D,K=>new B($,K,z))}constructor($,D,z){this.c=$,this.d=D,this.f=z,this.type=14}cmp($){return $.type!==this.type?this.type-$.type:te(this.c,this.d,$.c,$.d)}equals($){return $.type===this.type?this.c===$.c&&this.d===$.d:!1}substituteConstants(){return this}evaluate($){return typeof this.d=="string"?!1:parseFloat($.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map($){return $.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Ii=B;class x{static create($,D,z=null){return M(D,K=>new x($,K,z))}constructor($,D,z){this.c=$,this.d=D,this.f=z,this.type=15}cmp($){return $.type!==this.type?this.type-$.type:te(this.c,this.d,$.c,$.d)}equals($){return $.type===this.type?this.c===$.c&&this.d===$.d:!1}substituteConstants(){return this}evaluate($){return typeof this.d=="string"?!1:parseFloat($.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map($){return $.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Ji=x;class Z{static create($,D){return new Z($,D)}constructor($,D){this.d=$,this.f=D,this.type=7,this.c=null}cmp($){if($.type!==this.type)return this.type-$.type;if(this.d<$.d)return-1;if(this.d>$.d)return 1;const D=this.f?this.f.source:"",z=$.f?$.f.source:"";return D<z?-1:D>z?1:0}equals($){if($.type===this.type){const D=this.f?this.f.source:"",z=$.f?$.f.source:"";return this.d===$.d&&D===z}return!1}substituteConstants(){return this}evaluate($){const D=$.getValue(this.d);return this.f?this.f.test(D):!1}serialize(){const $=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${$}`}keys(){return[this.d]}map($){return $.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Q.create(this)),this.c}}e.$Ki=Z;class Q{static create($){return new Q($)}constructor($){this.c=$,this.type=8}cmp($){return $.type!==this.type?this.type-$.type:this.c.cmp($.c)}equals($){return $.type===this.type?this.c.equals($.c):!1}substituteConstants(){return this}evaluate($){return!this.c.evaluate($)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map($){return new Q(this.c.map($))}negate(){return this.c}}e.$Li=Q;function J(N){let $=null;for(let D=0,z=N.length;D<z;D++){const K=N[D].substituteConstants();if(N[D]!==K&&$===null){$=[];for(let _=0;_<D;_++)$[_]=N[_]}$!==null&&($[D]=K)}return $===null?N:$}class X{static create($,D,z){return X.d($,D,z)}constructor($,D){this.expr=$,this.c=D,this.type=6}cmp($){if($.type!==this.type)return this.type-$.type;if(this.expr.length<$.expr.length)return-1;if(this.expr.length>$.expr.length)return 1;for(let D=0,z=this.expr.length;D<z;D++){const K=s(this.expr[D],$.expr[D]);if(K!==0)return K}return 0}equals($){if($.type===this.type){if(this.expr.length!==$.expr.length)return!1;for(let D=0,z=this.expr.length;D<z;D++)if(!this.expr[D].equals($.expr[D]))return!1;return!0}return!1}substituteConstants(){const $=J(this.expr);return $===this.expr?this:X.create($,this.c,!1)}evaluate($){for(let D=0,z=this.expr.length;D<z;D++)if(!this.expr[D].evaluate($))return!1;return!0}static d($,D,z){const K=[];let _=!1;for(const H of $)if(H){if(H.type===1){_=!0;continue}if(H.type===0)return i.INSTANCE;if(H.type===6){K.push(...H.expr);continue}K.push(H)}if(K.length===0&&_)return r.INSTANCE;if(K.length!==0){if(K.length===1)return K[0];K.sort(s);for(let H=1;H<K.length;H++)K[H-1].equals(K[H])&&(K.splice(H,1),H--);if(K.length===1)return K[0];for(;K.length>1;){const H=K[K.length-1];if(H.type!==9)break;K.pop();const ee=K.pop(),ie=K.length===0,le=W.create(H.expr.map(he=>X.create([he,ee],null,z)),null,ie);le&&(K.push(le),K.sort(s))}if(K.length===1)return K[0];if(z){for(let H=0;H<K.length;H++)for(let ee=H+1;ee<K.length;ee++)if(K[H].negate().equals(K[ee]))return i.INSTANCE;if(K.length===1)return K[0]}return new X(K,D)}}serialize(){return this.expr.map($=>$.serialize()).join(" && ")}keys(){const $=[];for(const D of this.expr)$.push(...D.keys());return $}map($){return new X(this.expr.map(D=>D.map($)),null)}negate(){if(!this.c){const $=[];for(const D of this.expr)$.push(D.negate());this.c=W.create($,this,!0)}return this.c}}e.$Mi=X;class W{static create($,D,z){return W.d($,D,z)}constructor($,D){this.expr=$,this.c=D,this.type=9}cmp($){if($.type!==this.type)return this.type-$.type;if(this.expr.length<$.expr.length)return-1;if(this.expr.length>$.expr.length)return 1;for(let D=0,z=this.expr.length;D<z;D++){const K=s(this.expr[D],$.expr[D]);if(K!==0)return K}return 0}equals($){if($.type===this.type){if(this.expr.length!==$.expr.length)return!1;for(let D=0,z=this.expr.length;D<z;D++)if(!this.expr[D].equals($.expr[D]))return!1;return!0}return!1}substituteConstants(){const $=J(this.expr);return $===this.expr?this:W.create($,this.c,!1)}evaluate($){for(let D=0,z=this.expr.length;D<z;D++)if(this.expr[D].evaluate($))return!0;return!1}static d($,D,z){let K=[],_=!1;if($){for(let H=0,ee=$.length;H<ee;H++){const ie=$[H];if(ie){if(ie.type===0){_=!0;continue}if(ie.type===1)return r.INSTANCE;if(ie.type===9){K=K.concat(ie.expr);continue}K.push(ie)}}if(K.length===0&&_)return i.INSTANCE;K.sort(s)}if(K.length!==0){if(K.length===1)return K[0];for(let H=1;H<K.length;H++)K[H-1].equals(K[H])&&(K.splice(H,1),H--);if(K.length===1)return K[0];if(z){for(let H=0;H<K.length;H++)for(let ee=H+1;ee<K.length;ee++)if(K[H].negate().equals(K[ee]))return r.INSTANCE;if(K.length===1)return K[0]}return new W(K,D)}}serialize(){return this.expr.map($=>$.serialize()).join(" || ")}keys(){const $=[];for(const D of this.expr)$.push(...D.keys());return $}map($){return new W(this.expr.map(D=>D.map($)),null)}negate(){if(!this.c){const $=[];for(const D of this.expr)$.push(D.negate());for(;$.length>1;){const D=$.shift(),z=$.shift(),K=[];for(const _ of G(D))for(const H of G(z))K.push(X.create([_,H],null,!1));$.unshift(W.create(K,null,!1))}this.c=W.create($,this,!0)}return this.c}}e.$Ni=W;class U extends a{static{this.d=[]}static all(){return U.d.values()}constructor($,D,z){super($,null),this.f=D,typeof z=="object"?U.d.push({...z,key:$}):z!==!0&&U.d.push({key:$,description:z,type:D!=null?typeof D:void 0})}bindTo($){return $.createKey(this.key,this.f)}getValue($){return $.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo($){return w.create(this.key,$)}notEqualsTo($){return k.create(this.key,$)}}e.$Oi=U,e.$Pi=(0,j.$ph)("contextKeyService");function q(N,$){return N<$?-1:N>$?1:0}function te(N,$,D,z){return N<D?-1:N>D?1:$<z?-1:$>z?1:0}function re(N,$){if(N.type===0||$.type===1)return!0;if(N.type===9)return $.type===9?ce(N.expr,$.expr):!1;if($.type===9){for(const D of $.expr)if(re(N,D))return!0;return!1}if(N.type===6){if($.type===6)return ce($.expr,N.expr);for(const D of N.expr)if(re(D,$))return!0;return!1}return N.equals($)}e.$Qi=re;function ce(N,$){let D=0,z=0;for(;D<N.length&&z<$.length;){const K=N[D].cmp($[z]);if(K<0)return!1;K===0&&D++,z++}return D===N.length}function G(N){return N.type===9?N.expr:[N]}}),define(oe[95],ae([0,1,4]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=e.$5l=e.ID=void 0,e.ID="diagnosticsService",e.$5l=(0,I.$ph)(e.ID);function T(j){return!!j.hostName&&!!j.errorMessage}e.$6l=T;class O{async getPerformanceInfo(L,P){return{}}async getSystemInfo(L,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(L,P){return""}async getWorkspaceFileExtensions(L){return{extensions:[]}}async reportWorkspaceStats(L){}}e.$7l=O}),define(oe[96],ae([0,1,4]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=void 0,e.$un=(0,I.$ph)("downloadService")}),define(oe[15],ae([0,1,4]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=void 0,e.$wh=(0,I.$ph)("environmentService"),e.$xh=(0,I.$qh)(e.$wh)}),define(oe[29],ae([0,1,149,4]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Pn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=void 0,e.$Dn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$En=new RegExp(e.$Dn),e.$Fn="__web_extension",e.$Gn="skipWalkthrough",e.$Hn="extensionsSync";function O(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$In=O;function j(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Jn=j;function L(u,y){switch(u){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Kn=L;function P(u,y){return y==="web"&&!u.includes("web")}e.$Ln=P;function S(u,y,p){return P(y,p)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===p?!0:b(p).includes(u)}e.$Mn=S;function b(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Nn=b;function C(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$On=C;var E;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var m;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var h;(function(u){u.Install="install",u.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var d;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(d||(e.InstallOperation=d={})),e.$Pn=(0,T.$ph)("extensionGalleryService");var v;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var c;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class l extends Error{constructor(y,p){super(y),this.code=p,this.name=p}}e.$Qn=l,e.$Rn=(0,T.$ph)("extensionManagementService"),e.$Sn="extensionsIdentifiers/disabled",e.$Tn="extensionsIdentifiers/enabled",e.$Un=(0,T.$ph)("IGlobalExtensionEnablementService"),e.$Vn=(0,T.$ph)("IExtensionTipsService"),e.$Wn=(0,I.localize)(0,null),e.$Xn={value:e.$Wn,original:"Extensions"},e.$Yn={value:(0,I.localize)(1,null),original:"Preferences"}}),define(oe[184],ae([0,1,3,2,30,10,91,29]),function(ne,e,I,T,O,j,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=void 0;function S(c,l){return c?j.URI.revive(l?l.transformIncoming(c):c):void 0}function b(c,l){return l?l.transformOutgoingURI(c):c}function C(c,l){l=l||L.$om;const u=c.manifest;return{...(0,L.$rm)({...c,manifest:void 0},l),manifest:u}}function E(c,l){return c?.profileLocation?(0,L.$rm)(c,l??L.$om):c}function m(c,l){return l?(0,O.$Jm)(c,u=>u instanceof j.URI?l.transformOutgoingURI(u):void 0):c}class h{constructor(l,u){this.a=l,this.b=u,this.onInstallExtension=I.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,u){const y=this.b(l);switch(u){case"onInstallExtension":return I.Event.map(this.onInstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,y):p.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,p=>p.map(R=>({...R,local:R.local?m(R.local,y):R.local,profileLocation:R.profileLocation?b(R.profileLocation,y):R.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,y):p.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,y):p.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,p=>m(p,y))}throw new Error("Invalid listen")}async call(l,u,y){const p=this.b(l);switch(u){case"zip":{const R=C(y[0],p),t=await this.a.zip(R);return b(t,p)}case"unzip":return this.a.unzip(S(y[0],p));case"install":return this.a.install(S(y[0],p),E(y[1],p));case"installFromLocation":return this.a.installFromLocation(S(y[0],p),S(y[1],p));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(y[0],S(y[1],p),S(y[2],p));case"getManifest":return this.a.getManifest(S(y[0],p));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(y[0]);case"installFromGallery":return this.a.installFromGallery(y[0],E(y[1],p));case"installGalleryExtensions":{const R=y[0];return this.a.installGalleryExtensions(R.map(({extension:t,options:o})=>({extension:t,options:E(o,p)??{}})))}case"uninstall":return this.a.uninstall(C(y[0],p),E(y[1],p));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(y[0],p));case"getInstalled":return(await this.a.getInstalled(y[0],S(y[1],p))).map(t=>m(t,p));case"toggleAppliationScope":{const R=await this.a.toggleAppliationScope(C(y[0],p),S(y[1],p));return m(R,p)}case"copyExtensions":return this.a.copyExtensions(S(y[0],p),S(y[1],p));case"updateMetadata":{const R=await this.a.updateMetadata(C(y[0],p),y[1],S(y[2],p));return m(R,p)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(y[0],y[1],y[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Yo=h;class d extends T.$lb{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.k=l,this.c=this.B(new I.$8c),this.f=this.B(new I.$8c),this.g=this.B(new I.$8c),this.h=this.B(new I.$8c),this.j=this.B(new I.$8c),this.B(this.k.listen("onInstallExtension")(u=>this.l(this.c,{...u,source:this.m(u.source)?j.URI.revive(u.source):u.source,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(u=>this.l(this.f,u.map(y=>({...y,local:y.local?C(y.local,null):y.local,source:this.m(y.source)?j.URI.revive(y.source):y.source,profileLocation:j.URI.revive(y.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(u=>this.l(this.g,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(u=>this.l(this.h,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(C(u,null))))}l(l,u){l.fire(u)}m(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(l){const u=await this.getTargetPlatform();return l.allTargetPlatforms.some(y=>(0,P.$Mn)(y,l.allTargetPlatforms,u))}zip(l){return Promise.resolve(this.k.call("zip",[l]).then(u=>j.URI.revive(u)))}unzip(l){return Promise.resolve(this.k.call("unzip",[l]))}install(l,u){return Promise.resolve(this.k.call("install",[l,u])).then(y=>C(y,null))}installFromLocation(l,u){return Promise.resolve(this.k.call("installFromLocation",[l,u])).then(y=>C(y,null))}async installExtensionsFromProfile(l,u,y){return(await this.k.call("installExtensionsFromProfile",[l,u,y])).map(R=>C(R,null))}getManifest(l){return Promise.resolve(this.k.call("getManifest",[l]))}installFromGallery(l,u){return Promise.resolve(this.k.call("installFromGallery",[l,u])).then(y=>C(y,null))}async installGalleryExtensions(l){return(await this.k.call("installGalleryExtensions",[l])).map(y=>({...y,local:y.local?C(y.local,null):y.local,source:this.m(y.source)?j.URI.revive(y.source):y.source,profileLocation:j.URI.revive(y.profileLocation)}))}uninstall(l,u){return Promise.resolve(this.k.call("uninstall",[l,u]))}reinstallFromGallery(l){return Promise.resolve(this.k.call("reinstallFromGallery",[l])).then(u=>C(u,null))}getInstalled(l=null,u){return Promise.resolve(this.k.call("getInstalled",[l,u])).then(y=>y.map(p=>C(p,null)))}updateMetadata(l,u,y){return Promise.resolve(this.k.call("updateMetadata",[l,u,y])).then(p=>C(p,null))}toggleAppliationScope(l,u){return this.k.call("toggleAppliationScope",[l,u]).then(y=>C(y,null))}copyExtensions(l,u){return this.k.call("copyExtensions",[l,u])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(l,u,y){const p=await this.k.call("download",[l,u,y]);return j.URI.revive(p)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Zo=d;class v{constructor(l){this.a=l}listen(l,u){throw new Error("Invalid listen")}call(l,u,y){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(y[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$1o=v}),define(oe[97],ae([0,1,4]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=void 0,e.$Vo=(0,I.$ph)("IExtensionSignatureVerificationService");class T{b(){return this.a||(this.a=new Promise((j,L)=>ne(["node-vsce-sign"],async P=>j(P),L))),this.a}async verify(j,L,P){let S;try{S=await this.b()}catch{return!1}return S.verify(j,L,P)}}e.$Wo=T}),define(oe[98],ae([0,1,4]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZSb=e.RecommendationsNotificationResult=e.$YSb=e.RecommendationSource=void 0;var T;(function(L){L[L.FILE=1]="FILE",L[L.WORKSPACE=2]="WORKSPACE",L[L.EXE=3]="EXE"})(T||(e.RecommendationSource=T={}));function O(L){switch(L){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$YSb=O;var j;(function(L){L.Ignored="ignored",L.Cancelled="cancelled",L.TooMany="toomany",L.IncompatibleWindow="incompatibleWindow",L.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$ZSb=(0,I.$ph)("IExtensionRecommendationNotificationService")}),define(oe[13],ae([0,1,47,16,27,11,10,156,4,5,26]),function(ne,e,I,T,O,j,L,P,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileKind=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileOperationResult=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileChangeType=e.$0j=e.FileOperation=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.FileSystemProviderErrorCode=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tj=e.$Sj=void 0,e.$Sj=(0,S.$ph)("fileService");function E(q){return q.create===!0}e.$Tj=E;var m;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var h;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var d;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function v(q){return!!(q.capabilities&2)}e.$Uj=v;function c(q){return!!(q.capabilities&8)}e.$Vj=c;function l(q){return!!(q.capabilities&131072)}e.$Wj=l;function u(q){return!!(q.capabilities&4)}e.$Xj=u;function y(q){return!!(q.capabilities&16)}e.$Yj=y;function p(q){return v(q)?!!(q.capabilities&16384):!1}e.$Zj=p;function R(q){return v(q)?!!(q.capabilities&32768):!1}e.$1j=R;function t(q){return!!(q.capabilities&65536)}e.$2j=t;function o(q){return!!(q.capabilities&2048)}e.$3j=o;var n;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class s extends Error{static create(te,re){const ce=new s(te.toString(),re);return a(ce,re),ce}constructor(te,re){super(te),this.code=re}}e.$4j=s;function i(q,te){return s.create(q,te)}e.$5j=i;function r(q){return q||i((0,P.localize)(0,null),n.Unknown)}e.$6j=r;function a(q,te){return q.name=te?`${te} (FileSystemError)`:"FileSystemError",q}e.$7j=a;function w(q){if(!q)return n.Unknown;if(q instanceof s)return q.code;const te=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!te)return n.Unknown;switch(te[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$8j=w;function g(q){if(q instanceof V)return q.fileOperationResult;switch(w(q)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$9j=g;var f;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(f||(e.FileOperation=f={}));class k{constructor(te,re,ce){this.resource=te,this.operation=re,this.target=ce}isOperation(te){return this.operation===te}}e.$0j=k;var A;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(A||(e.FileChangeType=A={}));class M{constructor(te,re){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const G of te){const N=ce.get(G.type);switch(N?N.push([G.resource,G]):ce.set(G.type,[[G.resource,G]]),G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}}for(const[G,N]of ce)switch(G){case 1:this.a=I.$vh.forUris(()=>re),this.a.fill(N);break;case 0:this.b=I.$vh.forUris(()=>re),this.b.fill(N);break;case 2:this.c=I.$vh.forUris(()=>re),this.c.fill(N);break}}contains(te,...re){return this.d(te,{includeChildren:!1},...re)}affects(te,...re){return this.d(te,{includeChildren:!0},...re)}d(te,re,...ce){if(!te)return!1;const G=ce.length>0;return!!((!G||ce.includes(1))&&(this.a?.get(te)||re.includeChildren&&this.a?.findSuperstr(te))||(!G||ce.includes(0))&&(this.b?.get(te)||re.includeChildren&&this.b?.findSuperstr(te))||(!G||ce.includes(2))&&(this.c?.findSubstr(te)||re.includeChildren&&this.c?.findSuperstr(te)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$$j=M;function F(q,te,re){return!q||!te||q===te||te.length>q.length?!1:(te.charAt(te.length-1)!==T.sep&&(te+=T.sep),re?(0,O.$Nd)(q,te):q.indexOf(te)===0)}e.$_j=F;class V extends Error{constructor(te,re,ce){super(te),this.fileOperationResult=re,this.options=ce}}e.$ak=V;class B extends V{constructor(te,re,ce,G){super(te,re,G),this.fileOperationResult=re,this.size=ce}}e.$bk=B;class x extends V{constructor(te,re,ce){super(te,2,ce),this.stat=re}}e.$ck=x;var Z;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$dk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ek={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$fk="files.associations",e.$gk="files.exclude",e.$hk="files.readonlyInclude",e.$ik="files.readonlyExclude",e.$jk="files.readonlyFromPermissions";var Q;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$kk="";function J(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$lk=J;async function X(q,te){if(!te.hasProvider(L.URI.from({scheme:q.scheme})))return new Promise(re=>{const ce=te.onDidChangeFileSystemProviderRegistrations(G=>{G.scheme===q.scheme&&G.added&&(ce.dispose(),re())})})}e.$mk=X;class W{static{this.KB=1024}static{this.MB=W.KB*W.KB}static{this.GB=W.MB*W.KB}static{this.TB=W.GB*W.KB}static formatSize(te){return(0,j.$ne)(te)||(te=0),te<W.KB?(0,P.localize)(1,null,te.toFixed(0)):te<W.MB?(0,P.localize)(2,null,(te/W.KB).toFixed(2)):te<W.GB?(0,P.localize)(3,null,(te/W.MB).toFixed(2)):te<W.TB?(0,P.localize)(4,null,(te/W.GB).toFixed(2)):(0,P.localize)(5,null,(te/W.TB).toFixed(2))}}e.$nk=W;function U(q){const te=typeof q=="string"||q?.scheme===C.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===C.Schemas.file?1024*W.MB:te?10*W.MB:b.$o?50*W.MB:1024*W.MB}e.$ok=U});var Y=this&&this.__param||function(ne,e){return function(I,T){e(I,T,ne)}};define(oe[185],ae([0,1,67,42,13]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F5b=void 0;let j=class{constructor(P){this.a=P}async checksum(P){const S=(await this.a.readFileStream(P)).value;return new Promise((b,C)=>{const E=(0,I.createHash)("md5");(0,T.$Bb)(S,{onData:m=>E.update(m.buffer),onError:m=>C(m),onEnd:()=>b(E.digest("base64").replace(/=+$/,""))})})}};e.$F5b=j,e.$F5b=j=we([Y(0,O.$Sj)],j)}),define(oe[186],ae([0,1,14,38,7,3,2,42,10,32,13]),function(ne,e,I,T,O,j,L,P,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JM=e.$IM=void 0,e.$IM="localFilesystem";class E extends L.$lb{constructor(h,d){super(),this.a=h,this.b=d,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$8c),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$8c),this.onDidWatchError=this.g.event,this.h=(0,b.$6e)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,d){const{buffer:v}=await this.a.call("readFile",[h,d]);return v}readFileStream(h,d,v){const c=(0,P.$xb)(u=>I.$Jb.concat(u.map(y=>I.$Jb.wrap(y))).buffer),l=this.a.listen("readFileStream",[h,d])(u=>{if(u instanceof I.$Jb)c.write(u.buffer);else{if(u==="end")c.end();else{let y;if(u instanceof Error)y=u;else{const p=u;y=(0,C.$5j)(p.message??(0,T.$ai)(p),p.code??C.FileSystemProviderErrorCode.Unknown)}c.error(y),c.end()}l.dispose()}});return v.onCancellationRequested(()=>{c.error((0,O.$4)()),c.end(),l.dispose()}),c}writeFile(h,d,v){return this.a.call("writeFile",[h,I.$Jb.wrap(d),v])}open(h,d){return this.a.call("open",[h,d])}close(h){return this.a.call("close",[h])}async read(h,d,v,c,l){const[u,y]=await this.a.call("read",[h,d,l]);return v.set(u.buffer.slice(0,y),c),y}write(h,d,v,c,l){return this.a.call("write",[h,d,I.$Jb.wrap(v),c,l])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,d){return this.a.call("delete",[h,d])}rename(h,d,v){return this.a.call("rename",[h,d,v])}copy(h,d,v){return this.a.call("copy",[h,d,v])}cloneFile(h,d){return this.a.call("cloneFile",[h,d])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const d=h;this.f.fire(d.map(v=>({resource:S.URI.revive(v.resource),type:v.type})))}else{const d=h;this.g.fire(d)}}))}watch(h,d){const v=(0,b.$6e)();return this.a.call("watch",[this.h,v,h,d]),(0,L.$jb)(()=>this.a.call("unwatch",[this.h,v]))}}e.$JM=E}),define(oe[99],ae([0,1,14,7,157,13]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=void 0;async function L(C,E,m,h,d,v){let c;try{await P(C,E,m,h,d,v)}catch(l){c=l}finally{c&&d.errorTransformer&&(c=d.errorTransformer(c)),typeof c<"u"&&m.error(c),m.end()}}e.$rp=L;async function P(C,E,m,h,d,v){S(v);const c=await C.open(E,{create:!1});try{S(v);let l=0,u=0,y=d&&typeof d.length=="number"?d.length:void 0,p=I.$Jb.alloc(Math.min(d.bufferSize,typeof y=="number"?y:d.bufferSize)),R=d&&typeof d.position=="number"?d.position:0,t=0;do u=await C.read(c,R,p.buffer,t,p.byteLength-t),R+=u,t+=u,l+=u,typeof y=="number"&&(y-=u),t===p.byteLength&&(await m.write(h(p)),p=I.$Jb.alloc(Math.min(d.bufferSize,typeof y=="number"?y:d.bufferSize)),t=0);while(u>0&&(typeof y!="number"||y>0)&&S(v)&&b(l,d));if(t>0){let o=t;typeof y=="number"&&(o=Math.min(t,y)),m.write(h(p.slice(0,o)))}}catch(l){throw(0,j.$6j)(l)}finally{await C.close(c)}}function S(C){if(C.isCancellationRequested)throw(0,T.$4)();return!0}function b(C,E){if(typeof E?.limits?.size=="number"&&C>E.limits.size)throw(0,j.$5j)((0,O.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[54],ae([0,1,90,2,16,5,10,13]),function(ne,e,I,T,O,j,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=void 0;function S(l){return l.recursive===!0}e.$tp=S;class b extends T.$lb{static{this.a=5}constructor(u,y,p,R){super(),this.h=u,this.i=y,this.j=p,this.k=R,this.c=this.B(new T.$mb),this.f=void 0,this.g=0}m(){const u=new T.$kb;this.c.value=u,this.b=this.l(u),this.b.setVerboseLogging(this.j),u.add(this.b.onDidChangeFile(y=>this.h(y))),u.add(this.b.onDidLogMessage(y=>this.i(y))),u.add(this.b.onDidError(y=>this.n(y)))}n(u){this.k.restartOnError?this.g<b.a&&this.f?(this.r(`restarting watcher after error: ${u}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${u}`):this.r(u)}p(u){this.g++,this.m(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.j=u,await this.b?.setVerboseLogging(u)}r(u){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${u}`})}s(u){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$up=b;class C extends b{constructor(u,y,p){super(u,y,p,{type:"node.js",restartOnError:!1})}}e.$vp=C;class E extends b{constructor(u,y,p){super(u,y,p,{type:"universal",restartOnError:!0})}}e.$wp=E;function m(l){return l.map(u=>({type:u.type,resource:L.URI.file(u.path)}))}e.$xp=m;function h(l){const u=new c;for(const y of l)u.processEvent(y);return u.coalesce()}e.$yp=h;function d(l,u){return typeof u=="string"&&!u.startsWith(I.$aj)&&!(0,O.$_b)(u)?{base:l,pattern:u}:u}e.$zp=d;function v(l,u){const y=[];for(const p of u)y.push((0,I.$ej)(d(l,p)));return y}e.$Ap=v;class c{constructor(){this.a=new Set,this.b=new Map}c(u){return j.$k?u.path:u.path.toLowerCase()}processEvent(u){const y=this.b.get(this.c(u));let p=!1;if(y){const R=y.type,t=u.type;y.path!==u.path&&(u.type===2||u.type===1)?p=!0:R===1&&t===2?(this.b.delete(this.c(u)),this.a.delete(y)):R===2&&t===1?y.type=0:R===1&&t===0||(y.type=t)}else p=!0;p&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],y=[];return Array.from(this.a).filter(p=>p.type!==2?(u.push(p),!1):!0).sort((p,R)=>p.path.length-R.path.length).filter(p=>y.some(R=>(0,P.$_j)(p.path,R,!j.$k))?!1:(y.push(p.path),!0)).concat(u)}}}),define(oe[187],ae([0,1,52,6,25,48,2,86,16,5,140,31,54]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0;class h extends L.$lb{static{this.a=100}static{this.b=75}constructor(c,l,u,y){super(),this.j=c,this.k=l,this.l=u,this.m=y,this.c=this.B(new T.$Jg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},p=>this.k(p))),this.f=this.B(new T.$Ig(p=>this.u(p),h.b)),this.g=(0,m.$Ap)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,m.$Ap)(this.j.path,this.j.includes):void 0,this.i=new O.$ed,this.ready=this.n()}async n(){try{const c=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const l=await E.Promises.stat(c);this.B(await this.s(c,l.isDirectory()))}catch(c){c.code!=="ENOENT"?this.w(c):this.z(c)}}async r(c){let l=c.path;try{l=await E.Promises.realpath(c.path),c.path===l&&(l=await(0,C.$Kp)(c.path)??c.path),c.path!==l&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${l})`)}catch{}return l}async s(c,l){if(b.$j&&(0,j.$Ke)(c,"/Volumes/",!0))return this.w(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.$lb.None;const u=new O.$ed(this.i.token),y=new L.$kb;try{const p=(0,S.$ec)(c),R=(0,I.watch)(c);y.add((0,L.$jb)(()=>{R.removeAllListeners(),R.close()})),this.z(`Started watching: '${c}'`);const t=new Set;if(l)try{for(const n of await E.Promises.readdir(c))t.add(n)}catch(n){this.w(n)}const o=new Map;y.add((0,L.$jb)(()=>{for(const[,n]of o)n.dispose();o.clear()})),R.on("error",(n,s)=>{this.w(`Failed to watch ${c} for changes using fs.watch() (${n}, ${s})`),this.dispose()}),R.on("change",(n,s)=>{if(u.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${s}`);let i="";if(s&&(i=s.toString(),b.$j&&(i=(0,P.$7k)(i))),!(!i||n!=="change"&&n!=="rename"))if(l)if(n==="rename"){o.get(i)?.dispose();const r=setTimeout(async()=>{if(o.delete(i),i===p&&!await E.Promises.exists(c)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.v((0,S.$ac)(c,i));if(u.token.isCancellationRequested)return;let w;a?t.has(i)?w=0:(w=1,t.add(i)):(t.delete(i),w=2),this.t({path:(0,S.$ac)(this.j.path,i),type:w})},h.a);o.set(i,(0,L.$jb)(()=>clearTimeout(r)))}else{let r;t.has(i)?r=0:(r=1,t.add(i)),this.t({path:(0,S.$ac)(this.j.path,i),type:r})}else if(n==="rename"||i!==p){const r=setTimeout(async()=>{const a=await E.Promises.exists(c);u.token.isCancellationRequested||(a?(this.t({path:this.j.path,type:0},!0),y.add(await this.s(c,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},h.a);y.clear(),y.add((0,L.$jb)(()=>clearTimeout(r)))}else this.t({path:this.j.path,type:0},!0)})}catch(p){await E.Promises.exists(c)&&!u.token.isCancellationRequested&&this.w(`Failed to watch ${c} for changes using fs.watch() (${p.toString()})`)}return(0,L.$jb)(()=>{u.dispose(!0),y.dispose()})}t(c,l=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!l&&this.g.some(u=>u(c.path))?this.m&&this.z(` >> ignored (excluded) ${c.path}`):!l&&this.h&&this.h.length>0&&!this.h.some(u=>u(c.path))?this.m&&this.z(` >> ignored (not included) ${c.path}`):this.f.work(c))}u(c){const l=(0,m.$yp)(c);if(l.length>0){if(this.m)for(const y of l)this.z(`>> normalized ${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`);this.c.work(l)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(c){if(b.$k)return E.Promises.exists(c);try{const l=(0,S.$ec)(c);return(await E.Promises.readdir((0,S.$dc)(c))).some(y=>y===l)}catch(l){return this.z(l),!1}}setVerboseLogging(c){this.m=c}w(c){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}y(c){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}z(c){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Np=h;async function d(v,c,l,u,y=512){const p=await E.Promises.open(v,"r"),R=Buffer.allocUnsafe(y),t=new O.$ed(u);let o,n=!1;const s={path:v,excludes:[],recursive:!1},i=new h(s,r=>{(async()=>{for(const{type:a}of r)if(a===0){if(n)return;n=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:w}=await E.Promises.read(p,R,0,y,null);if(!w||t.token.isCancellationRequested)break;c(R.slice(0,w))}}catch(w){o=new Error(w),t.dispose(!0)}finally{n=!1}}})()});return await i.ready,l(),new Promise((r,a)=>{t.token.onCancellationRequested(async()=>{i.dispose();try{await E.Promises.close(p)}catch(w){o=new Error(w)}o?a(o):r()})})}e.$Op=d}),define(oe[188],ae([0,1,3,90,2,5,187]),function(ne,e,I,T,O,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;class P extends O.$lb{constructor(){super(...arguments),this.a=this.B(new I.$8c),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$8c),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(b){const C=this.i(b),E=C.filter(h=>{const d=this.c.get(h.path);return d?!(0,T.$ij)(d.request.excludes,h.excludes)||!(0,T.$ij)(d.request.includes,h.includes):!0}),m=Array.from(this.c.values()).filter(({request:h})=>!C.find(d=>d.path===h.path&&(0,T.$ij)(d.excludes,h.excludes)&&(0,T.$ij)(d.includes,h.includes))).map(({request:h})=>h.path);E.length&&this.j(`Request to start watching: ${E.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const h of m)this.h(h);for(const h of E)this.g(h)}g(b){const C=new L.$Np(b,m=>this.a.fire(m),m=>this.b.fire(m),this.f),E={request:b,instance:C};this.c.set(b.path,E)}async stop(){for(const[b]of this.c)this.h(b);this.c.clear()}h(b){const C=this.c.get(b);C&&(this.c.delete(b),C.instance.dispose())}i(b){const C=new Map;for(const E of b){const m=j.$k?E.path:E.path.toLowerCase();C.set(m,E)}return Array.from(C.values())}async setVerboseLogging(b){this.f=b;for(const[,C]of this.c)C.instance.setVerboseLogging(b)}j(b){this.f&&this.b.fire({type:"trace",message:this.k(b)})}k(b,C){return C?`[File Watcher (node.js)] ${b} (path: ${C.request.path})`:`[File Watcher (node.js)] ${b}`}}e.$Pp=P}),define(oe[189],ae([0,1,54,188]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;class O extends I.$vp{constructor(L,P,S){super(L,P,S),this.m()}l(){return new T.$Pp}}e.$Qp=O}),define(oe[190],ae([0,1,26,43,93,54]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;class L extends j.$wp{constructor(S,b,C){super(S,b,C),this.m()}l(S){const b=S.add(new O.$Hp(I.$4e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(b.onDidProcessExit(({code:C,signal:E})=>this.n(`terminated by itself with code ${C}, signal: ${E}`))),T.ProxyChannel.toService((0,T.$9g)(b.getChannel("watcher")))}}e.$Ip=L}),define(oe[68],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=void 0;class I{constructor(...O){this.a=new Map;for(const[j,L]of O)this.set(j,L)}set(O,j){const L=this.a.get(O);return this.a.set(O,j),L}has(O){return this.a.has(O)}get(O){return this.a.get(O)}}e.$nh=I}),define(oe[191],ae([0,1,6,7,2,66,182,4,68,85]),function(ne,e,I,T,O,j,L,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0;const C=!1;class E extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class m{constructor(c=new S.$nh,l=!1,u,y=C){this.f=c,this.g=l,this.h=u,this.i=y,this.o=new Set,this.f.set(P.$oh,this),this._globalGraph=y?u?._globalGraph??new L.$Tp(p=>p):void 0}createChild(c){return new m(c,this.g,this,this.i)}invokeFunction(c,...l){const u=d.traceInvocation(this.i,c);let y=!1;try{return c({get:R=>{if(y)throw(0,T.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(R,u);if(!t)throw new Error(`[invokeFunction] unknown service '${R}'`);return t}},...l)}finally{y=!0,u.stop()}}createInstance(c,...l){let u,y;return c instanceof j.$mh?(u=d.traceCreation(this.i,c.ctor),y=this.j(c.ctor,c.staticArguments.concat(l),u)):(u=d.traceCreation(this.i,c),y=this.j(c,l,u)),u.stop(),y}j(c,l=[],u){const y=P._util.getServiceDependencies(c).sort((t,o)=>t.index-o.index),p=[];for(const t of y){const o=this.m(t.id,u);o||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(o)}const R=y.length>0?y[0].index:l.length;if(l.length!==R){console.trace(`[createInstance] First service dependency of ${c.name} at position ${R+1} conflicts with ${l.length} static arguments`);const t=R-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,R)}return Reflect.construct(c,l.concat(p))}k(c,l){if(this.f.get(c)instanceof j.$mh)this.f.set(c,l);else if(this.h)this.h.k(c,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const l=this.f.get(c);return!l&&this.h?this.h.l(c):l}m(c,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const u=this.l(c);return u instanceof j.$mh?this.q(c,u,l.branch(c,!0)):(l.branch(c,!1),u)}q(c,l,u){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,l,u)}finally{this.o.delete(c)}}r(c,l,u){const y=new L.$Tp(t=>t.id.toString());let p=0;const R=[{id:c,desc:l,_trace:u}];for(;R.length;){const t=R.pop();if(y.lookupOrInsertNode(t),p++>1e3)throw new E(y);for(const o of P._util.getServiceDependencies(t.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${c} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),n instanceof j.$mh){const s={id:o.id,desc:n,_trace:t._trace.branch(o.id,!0)};y.insertEdge(t,s),R.push(s)}}}for(;;){const t=y.roots();if(t.length===0){if(!y.isEmpty())throw new E(y);break}for(const{data:o}of t){if(this.l(o.id)instanceof j.$mh){const s=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,s)}y.removeNode(o)}}return this.l(c)}s(c,l,u=[],y,p){if(this.f.get(c)instanceof j.$mh)return this.t(c,l,u,y,p);if(this.h)return this.h.s(c,l,u,y,p);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(c,l,u=[],y,p){if(y){const R=new m(void 0,this.g,this,this.i);R.c=String(c);const t=new Map,o=new I.$Lg(()=>{const n=R.j(l,u,p);for(const[s,i]of t){const r=n[s];if(typeof r=="function")for(const a of i)r.apply(n,a)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=t.get(s);return a||(a=new b.$lc,t.set(s,a)),(g,f,k)=>{const A=a.push([g,f,k]);return(0,O.$jb)(A)}}if(s in n)return n[s];const i=o.value;let r=i[s];return typeof r!="function"||(r=r.bind(i),n[s]=r),r},set(n,s,i){return o.value[s]=i,!0},getPrototypeOf(n){return l.prototype}})}else return this.j(l,u,p)}u(c,l){if(l&&console.warn(c),this.g)throw new Error(c)}}e.$Up=m;var h;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(h||(h={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,l){return c?new d(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(c,l){return c?new d(1,l.name):d.c}static{this.f=0}constructor(c,l){this.type=c,this.name=l,this.g=Date.now(),this.h=[]}branch(c,l){const u=new d(3,c.toString());return this.h.push([c,l,u]),u}stop(){const c=Date.now()-this.g;d.f+=c;let l=!1;function u(p,R){const t=[],o=new Array(p+1).join("	");for(const[n,s,i]of R.h)if(s&&i){l=!0,t.push(`${o}CREATES -> ${n}`);const r=u(p+1,i);r&&t.push(r)}else t.push(`${o}uses -> ${n}`);return t.join(`
`)}const y=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(c>2||l)&&d.all.add(y.join(`
`))}}e.$Vp=d}),define(oe[69],ae([0,1,4]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d5b=e.$c5b=void 0,e.$c5b=(0,I.$ph)("mainProcessService");class T{constructor(j,L){this.a=j,this.b=L}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,L){this.a.registerChannel(j,L)}}e.$d5b=T}),define(oe[70],ae([0,1,25,2,5,159,29,4]),function(ne,e,I,T,O,j,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=void 0;function S(C){return C.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$wq=S,e.$xq=(0,P.$ph)("languagePackService");let b=class extends T.$lb{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new I.$ed;setTimeout(()=>E.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const d=m.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some(c=>c.startsWith("lp-"))).map(v=>{const c=v.properties.localizedLanguages?.[0],l=S(v);return{...this.f(l,c,v),extensionId:v.identifier.id,galleryExtension:v}});return d.push(this.f("en","English")),d}f(E,m,h){const d=m??E;let v;if(d!==E&&(v=`(${E})`),E.toLowerCase()===O.$v.toLowerCase()&&(v??="",v+=(0,j.localize)(0,null)),h?.installCount){v??="";const c=h.installCount;let l;c>1e6?l=`${Math.floor(c/1e5)/10}M`:c>1e3?l=`${Math.floor(c/1e3)}K`:l=String(c),v+=` $(cloud-download) ${l}`}return{id:E,label:d,description:v}}};e.$yq=b,e.$yq=b=we([Y(0,L.$Pn)],b)}),define(oe[192],ae([0,1,2,70]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B5b=void 0;let O=class extends I.$lb{constructor(L){super(),this.a=L,this.b()}b(){this.a.update()}};e.$B5b=O,e.$B5b=O=we([Y(0,T.$xq)],O)}),define(oe[8],ae([0,1,38,3,51,2,35,5,22,11,10,94,4]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.log=e.$Ui=e.LogLevel=e.$Ti=e.$Si=e.$Ri=void 0,e.$Ri=(0,m.$ph)("logService"),e.$Si=(0,m.$ph)("loggerService");function h(){return new Date().toISOString()}function d(g){return(0,b.$ne)(g)}e.$Ti=d;var v;(function(g){g[g.Off=0]="Off",g[g.Trace=1]="Trace",g[g.Debug=2]="Debug",g[g.Info=3]="Info",g[g.Warning=4]="Warning",g[g.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$Ui=v.Info;function c(g,f,k){switch(f){case v.Trace:g.trace(k);break;case v.Debug:g.debug(k);break;case v.Info:g.info(k);break;case v.Warning:g.warn(k);break;case v.Error:g.error(k);break;case v.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=c;function l(g,f=!1){let k="";for(let A=0;A<g.length;A++){let M=g[A];if(M instanceof Error&&(M=(0,I.$ai)(M,f)),typeof M=="object")try{M=JSON.stringify(M)}catch{}k+=(A>0?" ":"")+M}return k}class u extends j.$lb{constructor(){super(...arguments),this.b=e.$Ui,this.c=this.B(new T.$8c),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==v.Off&&this.b<=f}}e.$Wi=u;class y extends u{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...k){this.f(v.Trace)&&this.g(v.Trace,l([f,...k],!0))}debug(f,...k){this.f(v.Debug)&&this.g(v.Debug,l([f,...k]))}info(f,...k){this.f(v.Info)&&this.g(v.Info,l([f,...k]))}warn(f,...k){this.f(v.Warning)&&this.g(v.Warning,l([f,...k]))}error(f,...k){if(this.f(v.Error))if(f instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=f.stack,this.g(v.Error,l(A))}else this.g(v.Error,l([f,...k]))}flush(){}}e.$Xi=y;class p extends u{constructor(f=e.$Ui){super(),this.setLevel(f),this.g=!P.$i}trace(f,...k){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,f,...k):console.log(`[main ${h()}]`,f,...k))}debug(f,...k){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,f,...k):console.log(`[main ${h()}]`,f,...k))}info(f,...k){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,f,...k):console.log(`[main ${h()}]`,f,...k))}warn(f,...k){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,f,...k):console.warn(`[main ${h()}]`,f,...k))}error(f,...k){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,f,...k):console.error(`[main ${h()}]`,f,...k))}dispose(){}flush(){}}e.$Yi=p;class R extends u{constructor(f=e.$Ui,k=!0){super(),this.g=k,this.setLevel(f)}trace(f,...k){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...k):console.log(f,...k))}debug(f,...k){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...k):console.log(f,...k))}info(f,...k){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...k):console.log(f,...k))}warn(f,...k){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...k):console.log(f,...k))}error(f,...k){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...k):console.error(f,...k))}dispose(){}flush(){}}e.$Zi=R;class t extends u{constructor(f,k=e.$Ui){super(),this.g=f,this.setLevel(k)}trace(f,...k){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(f),...k])}debug(f,...k){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(f),...k])}info(f,...k){this.f(v.Info)&&this.g.log(v.Info,[this.h(f),...k])}warn(f,...k){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(f),...k])}error(f,...k){this.f(v.Error)&&this.g.log(v.Error,[this.h(f),...k])}h(f){return typeof f=="string"?f:(0,I.$ai)(f,this.f(v.Trace))}dispose(){}flush(){}}e.$1i=t;class o extends u{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const k of this.g)k.setLevel(f);super.setLevel(f)}trace(f,...k){for(const A of this.g)A.trace(f,...k)}debug(f,...k){for(const A of this.g)A.debug(f,...k)}info(f,...k){for(const A of this.g)A.info(f,...k)}warn(f,...k){for(const A of this.g)A.warn(f,...k)}error(f,...k){for(const A of this.g)A.error(f,...k)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$2i=o;class n extends j.$lb{constructor(f,k,A){if(super(),this.h=f,this.j=k,this.b=new L.$ni,this.c=this.B(new T.$8c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$8c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$8c),this.onDidChangeVisibility=this.g.event,A)for(const M of A)this.b.set(M.resource,{logger:void 0,info:M})}k(f){return(0,b.$je)(f)?[...this.b.values()].find(k=>k.info.id===f):this.b.get(f)}getLogger(f){return this.k(f)?.logger}createLogger(f,k){const A=this.l(f),M=(0,b.$je)(f)?f:k?.id??(0,O.$di)(A.toString()).toString(16);let F=this.b.get(A)?.logger;const V=k?.logLevel==="always"?v.Trace:k?.logLevel;F||(F=this.m(A,V??this.getLogLevel(A)??this.h,{...k,id:M}));const B={logger:F,info:{resource:A,id:M,logLevel:V,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(B.info),this.b.set(A,B),F}l(f){return(0,b.$je)(f)?(0,S.$0f)(this.j,`${f}.log`):f}setLogLevel(f,k){if(C.URI.isUri(f)){const A=f,M=k,F=this.b.get(A);F&&M!==F.info.logLevel&&(F.info.logLevel=M===this.h?void 0:M,F.logger?.setLevel(M),this.b.set(F.info.resource,F),this.f.fire([A,M]))}else{this.h=f;for(const[A,M]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,k){const A=this.k(f);A&&k!==!A.info.hidden&&(A.info.hidden=!k,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,k]))}getLogLevel(f){let k;return f&&(k=this.b.get(f)?.info.logLevel),k??this.h}registerLogger(f){const k=this.b.get(f.resource);k?k.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const k=this.b.get(f);k&&(k.logger&&k.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$3i=n;class s{constructor(){this.onDidChangeLogLevel=new T.$8c().event}setLevel(f){}getLevel(){return v.Info}trace(f,...k){}debug(f,...k){}info(f,...k){}warn(f,...k){}error(f,...k){}critical(f,...k){}dispose(){}flush(){}}e.$4i=s;class i extends s{}e.$5i=i;function r(g){if(g.verbose)return v.Trace;if(typeof g.logLevel=="string"){const f=w(g.logLevel.toLowerCase());if(f!==void 0)return f}return e.$Ui}e.$6i=r;function a(g){switch(g){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$7i=a;function w(g){switch(g){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$8i=w,e.$9i=new E.$Oi("logLevel",a(v.Info))}),define(oe[193],ae([0,1,6,7,2,22,31,15,8]),function(ne,e,I,T,O,j,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C5b=void 0;let b=class extends O.$lb{constructor(E,m){super(),this.a=E,this.b=m,this.B(new I.$Gg(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,j.$7f)(this.a.logsHome),m=(0,j.$9f)(this.a.logsHome),v=(await L.Promises.readdir(m.fsPath)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==E),c=v.slice(0,Math.max(0,v.length-9));c.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${c.join(", ")}'`),await Promise.all(c.map(l=>L.Promises.rm((0,j.$0f)(m,l).fsPath))))}catch(E){(0,T.$Y)(E)}}};e.$C5b=b,e.$C5b=b=we([Y(0,P.$wh),Y(1,S.$Ri)],b)}),define(oe[194],ae([0,1,21,6,7,3,2,16,54,8]),function(ne,e,I,T,O,j,L,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;class C extends L.$lb{constructor(m,h){super(),this.a=m,this.b=h,this.c=this.B(new j.$8c),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$8c),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new T.$tg(0)),this.s=[],this.t=this.B(new T.$tg(0))}watch(m,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(m,h):this.u(m,h)}l(m,h){const d={path:this.C(m),excludes:h.excludes,includes:h.includes,recursive:h.recursive},v=(0,I.$Bf)(this.j,d);return this.m(),(0,L.$jb)(()=>{v(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,O.$Y)(m))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,S.$xp)(h)),h=>this.z(h),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const h of this.j)(0,S.$tp)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const h of this.j)(0,S.$tp)(h)&&m.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,h){const d={path:this.C(m),excludes:h.excludes,includes:h.includes,recursive:!1},v=(0,I.$Bf)(this.s,d);return this.v(),(0,L.$jb)(()=>{v(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,O.$Y)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,S.$xp)(m)),m=>this.z(m),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,P.$$b)(m.fsPath)}}e.$Bp=C}),define(oe[195],ae([0,1,21,6,14,25,3,51,59,2,47,26,100,22,42,155,13,99,8,7]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=void 0;let p=class extends b.$lb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new L.$8c),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.$8c),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.$8c),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new L.$8c),this.onDidRunOperation=this.m.event,this.R=this.B(new L.$8c),this.onDidFilesChange=this.R.event,this.S=this.B(new L.$8c),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new T.$Dg)}registerProvider(t,o){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${t}`);const n=new b.$kb;return this.h.set(t,o),this.c.fire({added:!0,scheme:t,provider:o}),n.add(o.onDidChangeFile(s=>this.R.fire(new c.$$j(s,!this.O(o))))),typeof o.onDidWatchError=="function"&&n.add(o.onDidWatchError(s=>this.S.fire(new Error(s)))),n.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:t}))),(0,b.$jb)(()=>{this.c.fire({added:!1,scheme:t,provider:o}),this.h.delete(t),(0,b.$gb)(n)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const o=[];this.f.fire({scheme:t,join(n){o.push(n)}}),!this.h.has(t)&&await T.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,o){const n=this.h.get(t.scheme);return!!(n&&n.capabilities&o)}listCapabilities(){return S.Iterable.map(this.h,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async j(t){if(!(0,h.$bg)(t))throw new c.$ak((0,v.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const o=this.h.get(t.scheme);if(!o){const n=new y.$ab;throw n.message=(0,v.localize)(1,null,t.toString()),n}return o}async k(t){const o=await this.j(t);if((0,c.$Xj)(o)||(0,c.$Uj)(o)||(0,c.$Yj)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const o=await this.j(t);if((0,c.$Xj)(o)||(0,c.$Uj)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.n(t,o)}catch(n){throw(0,c.$8j)(n)===c.FileSystemProviderErrorCode.FileNotFound?new c.$ak((0,v.localize)(2,null,this.nb(t)),1):(0,c.$6j)(n)}}async n(t,o){const n=await this.j(t),s=this.O(n),i=o?.resolveTo,r=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,w=await n.stat(t);let g;return this.p(n,t,w,void 0,!!a,(f,k)=>(g||(g=C.$vh.forUris(()=>!s),g.set(t,!0),i&&g.fill(!0,i)),g.get(f.resource)||g.findSuperstr(f.resource.with({query:null,fragment:null}))?!0:f.isDirectory&&r?k===1:!1))}async p(t,o,n,s,i,r){const{providerExtUri:a}=this.N(t),w={resource:o,name:a.basename(o),isFile:(n.type&c.FileType.File)!==0,isDirectory:(n.type&c.FileType.Directory)!==0,isSymbolicLink:(n.type&c.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&c.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((n.permissions??0)&c.FilePermission.Locked),etag:(0,c.$lk)({mtime:n.mtime,size:n.size}),children:void 0};if(w.isDirectory&&r(w,s)){try{const g=await t.readdir(o),f=await T.Promises.settled(g.map(async([k,A])=>{try{const M=a.joinPath(o,k),F=i?await t.stat(M):{type:A};return await this.p(t,M,F,g.length,i,r)}catch(M){return this.b.trace(M),null}}));w.children=(0,I.$mf)(f)}catch(g){this.b.trace(g),w.children=[]}return w}return w}async resolveAll(t){return T.Promises.settled(t.map(async o=>{try{return{stat:await this.n(o.resource,o.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.j(t),n=await o.stat(t);return this.p(o,t,n,void 0,!0,()=>!1)}async exists(t){const o=await this.j(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.r(t,o)}catch(n){return n}return!0}async r(t,o){if(!o?.overwrite&&await this.exists(t))throw new c.$ak((0,v.localize)(3,null,this.nb(t)),3,o)}async createFile(t,o=O.$Jb.fromString(""),n){await this.r(t,n);const s=await this.writeFile(t,o);return this.m.fire(new c.$0j(t,0,s)),s}async writeFile(t,o,n){const s=this.lb(await this.l(t),t),{providerExtUri:i}=this.N(s);try{await this.s(s,t,n)||await this.P(s,i.dirname(t));let a;if((0,c.$Uj)(s)&&!(o instanceof O.$Jb))if((0,d.$vb)(o)){const w=await(0,d.$Cb)(o,3);w.ended?a=O.$Jb.concat(w.buffer):a=w}else a=(0,d.$zb)(o,w=>O.$Jb.concat(w),3);else a=o;if(!(0,c.$Xj)(s)||(0,c.$Uj)(s)&&a instanceof O.$Jb)await this.cb(s,t,n,a);else{const w=a instanceof O.$Jb?(0,O.$Ub)(a):a;n?.atomic!==!1&&n?.atomic?.postfix?await this.Y(s,t,(0,h.$0f)((0,h.$9f)(t),`${(0,h.$7f)(t)}${n.atomic.postfix}`),n,w):await this.Z(s,t,n,w)}this.m.fire(new c.$0j(t,4))}catch(r){throw new c.$ak((0,v.localize)(4,null,this.nb(t),(0,c.$6j)(r).toString()),(0,c.$9j)(r),n)}return this.resolve(t,{resolveMetadata:!0})}async s(t,o,n){const s=!!n?.unlock;if(s&&!(t.capabilities&8192))throw new Error((0,v.localize)(5,null,this.nb(o)));if(!!n?.atomic){if(!(t.capabilities&32768))throw new Error((0,v.localize)(6,null,this.nb(o)));if(s)throw new Error((0,v.localize)(7,null,this.nb(o)))}let r;try{r=await t.stat(o)}catch{return}if(r.type&c.FileType.Directory)throw new c.$ak((0,v.localize)(8,null,this.nb(o)),0,n);if(this.mb(o,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==c.$kk&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,c.$lk)({mtime:n.mtime,size:r.size}))throw new c.$ak((0,v.localize)(9,null),3,n);return r}async readFile(t,o,n){const s=await this.k(t);return o?.atomic?this.t(s,t,o,n):this.u(s,t,o,n)}async t(t,o,n,s){return new Promise((i,r)=>{this.X.queueFor(o,this.N(t).providerExtUri).queue(async()=>{try{const a=await this.u(t,o,n,s);i(a)}catch(a){r(a)}})})}async u(t,o,n,s){const i=await this.v(t,o,{...n,preferUnbuffered:!0},s);return{...i,value:await(0,O.$Vb)(i.value)}}async readFileStream(t,o,n){const s=await this.k(t);return this.v(s,t,o,n)}async v(t,o,n,s){const i=new j.$ed(s),r=this.F(o,n).then(w=>w,w=>{throw i.cancel(),w});let a;try{return typeof n?.etag=="string"&&n.etag!==c.$kk&&await r,n?.atomic&&(0,c.$Zj)(t)||!((0,c.$Xj)(t)||(0,c.$Yj)(t))||(0,c.$Uj)(t)&&n?.preferUnbuffered?a=this.D(t,o,n):(0,c.$Yj)(t)?a=this.z(t,o,i.token,n):a=this.C(t,o,i.token,n),{...await r,value:a}}catch(w){throw a&&await(0,d.$Ab)(a),this.w(w,o,n)}}w(t,o,n){const s=(0,v.localize)(10,null,this.nb(o),(0,c.$6j)(t).toString());return t instanceof c.$ck?new c.$ck(s,t.stat,n):t instanceof c.$bk?new c.$bk(s,t.fileOperationResult,t.size,t.options):new c.$ak(s,(0,c.$9j)(t),n)}z(t,o,n,s=Object.create(null)){const i=t.readFileStream(o,s,n);return(0,d.$Gb)(i,{data:r=>r instanceof O.$Jb?r:O.$Jb.wrap(r),error:r=>this.w(r,o,s)},r=>O.$Jb.concat(r))}C(t,o,n,s=Object.create(null)){const i=(0,O.$Zb)();return(0,l.$rp)(t,o,i,r=>r,{...s,bufferSize:this.a,errorTransformer:r=>this.w(r,o,s)},n),i}D(t,o,n){const s=(0,d.$xb)(i=>O.$Jb.concat(i));return(async()=>{try{let i;n?.atomic&&(0,c.$Zj)(t)?i=await t.readFile(o,{atomic:!0}):i=await t.readFile(o),typeof n?.position=="number"&&(i=i.slice(n.position)),typeof n?.length=="number"&&(i=i.slice(0,n.length)),this.G(o,i.byteLength,n),s.end(O.$Jb.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async F(t,o){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new c.$ak((0,v.localize)(11,null,this.nb(t)),0,o);if(typeof o?.etag=="string"&&o.etag!==c.$kk&&o.etag===n.etag)throw new c.$ck((0,v.localize)(12,null),n,o);return this.G(t,n.size,o),n}G(t,o,n){if(typeof n?.limits?.size=="number"&&o>n.limits.size)throw new c.$bk((0,v.localize)(13,null,this.nb(t)),7,o,n)}async canMove(t,o,n){return this.H(t,o,"move",n)}async canCopy(t,o,n){return this.H(t,o,"copy",n)}async H(t,o,n,s){if(t.toString()!==o.toString())try{const i=n==="move"?this.lb(await this.l(t),t):await this.k(t),r=this.lb(await this.l(o),o);await this.M(i,t,r,o,n,s)}catch(i){return i}return!0}async move(t,o,n){const s=this.lb(await this.l(t),t),i=this.lb(await this.l(o),o),r=await this.I(s,t,i,o,"move",!!n),a=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new c.$0j(t,r==="move"?2:3,a)),a}async copy(t,o,n){const s=await this.k(t),i=this.lb(await this.l(o),o),r=await this.I(s,t,i,o,"copy",!!n),a=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new c.$0j(t,r==="copy"?3:2,a)),a}async I(t,o,n,s,i,r){if(o.toString()===s.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:w}=await this.M(t,o,n,s,i,r);if(a&&!w&&r&&await this.del(s,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(s)),i==="copy"){if(t===n&&(0,c.$Vj)(t))await t.copy(o,s,{overwrite:r});else{const g=await this.resolve(o);g.isDirectory?await this.L(t,g,n,s):await this.J(t,o,n,s)}return i}else return t===n?(await t.rename(o,s,{overwrite:r}),i):(await this.I(t,o,n,s,"copy",r),await this.del(o,{recursive:!0}),"copy")}async J(t,o,n,s){if((0,c.$Xj)(t)&&(0,c.$Xj)(n))return this.eb(t,o,n,s);if((0,c.$Xj)(t)&&(0,c.$Uj)(n))return this.kb(t,o,n,s);if((0,c.$Uj)(t)&&(0,c.$Xj)(n))return this.ib(t,o,n,s);if((0,c.$Uj)(t)&&(0,c.$Uj)(n))return this.gb(t,o,n,s)}async L(t,o,n,s){await n.mkdir(s),Array.isArray(o.children)&&await T.Promises.settled(o.children.map(async i=>{const r=this.N(n).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.L(t,await this.resolve(i.resource),n,r):this.J(t,i.resource,n,r)}))}async M(t,o,n,s,i,r){let a=!1;if(t===n){const{providerExtUri:g,isPathCaseSensitive:f}=this.N(t);if(f||(a=g.isEqual(o,s)),a&&i==="copy")throw new Error((0,v.localize)(14,null,this.nb(o),this.nb(s)));if(!a&&g.isEqualOrParent(s,o))throw new Error((0,v.localize)(15,null,this.nb(o),this.nb(s)))}const w=await this.exists(s);if(w&&!a){if(!r)throw new c.$ak((0,v.localize)(16,null,this.nb(o),this.nb(s)),4);if(t===n){const{providerExtUri:g}=this.N(t);if(g.isEqualOrParent(o,s))throw new Error((0,v.localize)(17,null,this.nb(o),this.nb(s)))}}return{exists:w,isSameResourceWithDifferentPathCase:a}}N(t){const o=this.O(t);return{providerExtUri:o?h.$Zf:h.$2f,isPathCaseSensitive:o}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const o=this.lb(await this.j(t),t);await this.P(o,t);const n=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new c.$0j(t,0,n)),n}async P(t,o){const n=[],{providerExtUri:s}=this.N(t);for(;!s.isEqual(o,s.dirname(o));)try{if(!((await t.stat(o)).type&c.FileType.Directory))throw new Error((0,v.localize)(18,null,this.nb(o)));break}catch(i){if((0,c.$8j)(i)!==c.FileSystemProviderErrorCode.FileNotFound)throw i;n.push(s.basename(o)),o=s.dirname(o)}for(let i=n.length-1;i>=0;i--){o=s.joinPath(o,n[i]);try{await t.mkdir(o)}catch(r){if((0,c.$8j)(r)!==c.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,o){try{await this.Q(t,o)}catch(n){return n}return!0}async Q(t,o){const n=this.lb(await this.j(t),t),s=!!o?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,v.localize)(19,null,this.nb(t)));const i=o?.atomic;if(i&&!(n.capabilities&65536))throw new Error((0,v.localize)(20,null,this.nb(t)));if(s&&i)throw new Error((0,v.localize)(21,null,this.nb(t)));let r;try{r=await n.stat(t)}catch{}if(r)this.mb(t,r);else throw new c.$ak((0,v.localize)(22,null,this.nb(t)),1);if(!!!o?.recursive){const w=await this.resolve(t);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,v.localize)(23,null,this.nb(t)))}return n}async del(t,o){const n=await this.Q(t,o),s=!!o?.useTrash,i=!!o?.recursive,r=o?.atomic??!1;await n.delete(t,{recursive:i,useTrash:s,atomic:r}),this.m.fire(new c.$0j(t,1))}async cloneFile(t,o){const n=await this.j(t),s=this.lb(await this.l(o),o);if(n===s&&this.N(n).providerExtUri.isEqual(t,o))return;if(n===s&&(0,c.$Wj)(n))return n.cloneFile(t,o);await this.P(s,this.N(s).providerExtUri.dirname(o));const i=this.X.queueFor(t,this.N(n).providerExtUri);return n===s&&(0,c.$Vj)(n)?i.queue(()=>n.copy(t,o,{overwrite:!0})):i.queue(()=>this.J(n,t,s,o))}watch(t,o={recursive:!1,excludes:[]}){const n=new b.$kb;let s=!1,i=()=>{s=!0};return n.add((0,b.$jb)(()=>i())),(async()=>{try{const r=await this.W(t,o);s?(0,b.$gb)(r):i=()=>(0,b.$gb)(r)}catch(r){this.b.error(r)}})(),n}async W(t,o){const n=await this.j(t),s=(0,P.$di)([this.N(n).providerExtUri.getComparisonKey(t),o]);let i=this.U.get(s);return i||(i={count:0,disposable:n.watch(t,o)},this.U.set(s,i)),i.count+=1,(0,b.$jb)(()=>{i&&(i.count--,i.count===0&&((0,b.$gb)(i.disposable),this.U.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,b.$gb)(t.disposable);this.U.clear()}async Y(t,o,n,s,i){await this.Z(t,n,s,i);try{await t.rename(n,o,{overwrite:!0})}catch(r){try{await t.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}async Z(t,o,n,s){return this.X.queueFor(o,this.N(t).providerExtUri).queue(async()=>{const i=await t.open(o,{create:!0,unlock:n?.unlock??!1});try{(0,d.$vb)(s)||(0,d.$wb)(s)?await this.$(t,i,s):await this.ab(t,i,s)}catch(r){throw(0,c.$6j)(r)}finally{await t.close(i)}})}async $(t,o,n){let s=0,i;if((0,d.$wb)(n)){if(n.buffer.length>0){const r=O.$Jb.concat(n.buffer);await this.bb(t,o,r,r.byteLength,s,0),s+=r.byteLength}if(n.ended)return;i=n.stream}else i=n;return new Promise((r,a)=>{(0,d.$Bb)(i,{onData:async w=>{i.pause();try{await this.bb(t,o,w,w.byteLength,s,0)}catch(g){return a(g)}s+=w.byteLength,setTimeout(()=>i.resume())},onError:w=>a(w),onEnd:()=>r()})})}async ab(t,o,n){let s=0,i;for(;(i=n.read())!==null;)await this.bb(t,o,i,i.byteLength,s,0),s+=i.byteLength}async bb(t,o,n,s,i,r){let a=0;for(;a<s;){const w=await t.write(o,i+a,n.buffer,r+a,s-a);a+=w}}async cb(t,o,n,s){return this.X.queueFor(o,this.N(t).providerExtUri).queue(()=>this.db(t,o,n,s))}async db(t,o,n,s){let i;s instanceof O.$Jb?i=s:(0,d.$vb)(s)?i=await(0,O.$Vb)(s):(0,d.$wb)(s)?i=await(0,O.$Wb)(s):i=(0,O.$Tb)(s),await t.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async eb(t,o,n,s){return this.X.queueFor(s,this.N(n).providerExtUri).queue(()=>this.fb(t,o,n,s))}async fb(t,o,n,s){let i,r;try{i=await t.open(o,{create:!1}),r=await n.open(s,{create:!0,unlock:!1});const a=O.$Jb.alloc(this.a);let w=0,g=0,f=0;do f=await t.read(i,w,a.buffer,g,a.byteLength-g),await this.bb(n,r,a,f,w,g),w+=f,g+=f,g===a.byteLength&&(g=0);while(f>0)}catch(a){throw(0,c.$6j)(a)}finally{await T.Promises.settled([typeof i=="number"?t.close(i):Promise.resolve(),typeof r=="number"?n.close(r):Promise.resolve()])}}async gb(t,o,n,s){return this.X.queueFor(s,this.N(n).providerExtUri).queue(()=>this.hb(t,o,n,s))}async hb(t,o,n,s){return n.writeFile(s,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,o,n,s){return this.X.queueFor(s,this.N(n).providerExtUri).queue(()=>this.jb(t,o,n,s))}async jb(t,o,n,s){const i=await n.open(s,{create:!0,unlock:!1});try{const r=await t.readFile(o);await this.bb(n,i,O.$Jb.wrap(r),r.byteLength,0,0)}catch(r){throw(0,c.$6j)(r)}finally{await n.close(i)}}async kb(t,o,n,s){const i=await(0,O.$Vb)(this.C(t,o,j.CancellationToken.None));await this.cb(n,s,void 0,i)}lb(t,o){if(t.capabilities&2048)throw new c.$ak((0,v.localize)(24,null,this.nb(o)),6);return t}mb(t,o){if((o.permissions??0)&c.FilePermission.Readonly)throw new c.$ak((0,v.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===E.Schemas.file?t.fsPath:t.toString(!0)}};e.$sp=p,e.$sp=p=we([Y(0,u.$Ri)],p)}),define(oe[196],ae([0,1,52,266,6,35,14,3,48,2,16,5,22,42,31,158,13,99,194,38,190,189]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u,y,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0,(()=>{try{(0,T.gracefulify)(I)}catch(o){console.error(`Error enabling graceful-fs: ${(0,y.$ai)(o)}`)}})();class t extends u.$Bp{static{this.D=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=P.Event.None,this.I=new j.$ni(i=>m.$1f.getComparisonKey(i)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,E.$k&&(this.F|=1024)),this.F}async stat(n){try{const{stat:s,symbolicLink:i}=await d.SymlinkSupport.stat(this.C(n));return{type:this.H(s,i),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:c.FilePermission.Locked}}catch(s){throw this.ab(s)}}async G(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await d.Promises.readdir(this.C(n),{withFileTypes:!0}),i=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,m.$0f)(n,r.name))).type:a=this.H(r),i.push([r.name,a])}catch(a){this.a.trace(a)}})),i}catch(s){throw this.ab(s)}}H(n,s){let i;return s?.dangling?i=c.FileType.Unknown:n.isFile()?i=c.FileType.File:n.isDirectory()?i=c.FileType.Directory:i=c.FileType.Unknown,s&&(i|=c.FileType.SymbolicLink),i}async J(n){const s=this.C(n);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let i;for(;i=this.I.get(n);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await i.wait();const r=new O.$ug;return this.I.set(n,r),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,b.$jb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.I.get(n)===r&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.I.delete(n)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let i;try{s?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),i=await this.J(n));const r=this.C(n);return await d.Promises.readFile(r)}catch(r){throw this.ab(r)}finally{i?.dispose()}}L(n){t.D&&this.a.trace(n)}readFileStream(n,s,i){const r=(0,h.$xb)(a=>L.$Jb.concat(a.map(w=>L.$Jb.wrap(w))).buffer);return(0,l.$rp)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},i),r}async writeFile(n,s,i){return i?.atomic!==!1&&i?.atomic?.postfix?this.M(n,(0,m.$0f)((0,m.$9f)(n),`${(0,m.$7f)(n)}${i.atomic.postfix}`),s,i):this.N(n,s,i)}async M(n,s,i,r){await this.N(s,i,r);try{await this.rename(s,n,{overwrite:!0})}catch(a){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async N(n,s,i){let r;try{const a=this.C(n);if(!i.create||!i.overwrite){if(await d.Promises.exists(a)){if(!i.overwrite)throw(0,c.$5j)((0,v.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,c.$5j)((0,v.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(n,{create:!0,unlock:i.unlock}),await this.write(r,0,s,0,s.byteLength)}catch(a){throw await this.bb(n,a)}finally{typeof r=="number"&&await this.close(r)}}static{this.R=!0}static configureFlushOnWrite(n){t.R=n}async open(n,s){const i=this.C(n);let r;(0,c.$Tj)(s)&&(r=await this.J(n));let a;try{if((0,c.$Tj)(s)&&s.unlock)try{const{stat:g}=await d.SymlinkSupport.stat(i);g.mode&128||await d.Promises.chmod(i,g.mode|128)}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}let w;if((0,c.$Tj)(s)){if(E.$i)try{await d.Promises.truncate(i,0),w="r+"}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}w||(w="w")}else w="r";a=await d.Promises.open(i,w)}catch(w){throw r?.dispose(),(0,c.$Tj)(s)?await this.bb(n,w):this.ab(w)}if(this.O.set(a,0),(0,c.$Tj)(s)&&this.Q.set(a,n),r){const w=this.P.get(a);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${i})`),this.P.set(a,r),w&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${i})`),w.dispose())}return a}async close(n){const s=this.P.get(n);try{if(this.O.delete(n),this.Q.delete(n)&&t.R)try{await d.Promises.fdatasync(n)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await d.Promises.close(n)}catch(i){throw this.ab(i)}finally{s&&(this.P.get(n)===s&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.P.delete(n)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,i,r,a){const w=this.S(n,s);let g=null;try{g=(await d.Promises.read(n,i,r,a,w)).bytesRead}catch(f){throw this.ab(f)}finally{this.U(n,w,g)}return g}S(n,s){return s===this.O.get(n)?null:s}U(n,s,i){const r=this.O.get(n);typeof r=="number"&&(typeof s=="number"||(typeof i=="number"?this.O.set(n,r+i):this.O.delete(n)))}async write(n,s,i,r,a){return(0,O.$Mg)(()=>this.W(n,s,i,r,a),100,3)}async W(n,s,i,r,a){const w=this.S(n,s);let g=null;try{g=(await d.Promises.write(n,i,r,a,w)).bytesWritten}catch(f){throw await this.bb(this.Q.get(n),f)}finally{this.U(n,w,g)}return g}async mkdir(n){try{await d.Promises.mkdir(this.C(n))}catch(s){throw this.ab(s)}}async delete(n,s){try{const i=this.C(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,C.$ac)((0,C.$dc)(i),`${(0,C.$ec)(i)}${s.atomic.postfix}`)),await d.Promises.rm(i,d.RimRafMode.MOVE,r)}else try{await d.Promises.unlink(i)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:w,symbolicLink:g}=await d.SymlinkSupport.stat(i);a=w.isDirectory()&&!g}catch{}if(a)await d.Promises.rmdir(i);else throw r}else throw r}}catch(i){throw this.ab(i)}}async rename(n,s,i){const r=this.C(n),a=this.C(s);if(r!==a)try{await this.X(n,s,"move",i.overwrite),await d.Promises.rename(r,a)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,v.localize)(2,null,(0,C.$ec)(r),(0,C.$ec)((0,C.$dc)(a)),w.toString()))),this.ab(w)}}async copy(n,s,i){const r=this.C(n),a=this.C(s);if(r!==a)try{await this.X(n,s,"copy",i.overwrite),await d.Promises.copy(r,a,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,v.localize)(3,null,(0,C.$ec)(r),(0,C.$ec)((0,C.$dc)(a)),w.toString()))),this.ab(w)}}async X(n,s,i,r){const a=this.C(n),w=this.C(s);let g=!1;if(!!(this.capabilities&1024)||(g=(0,S.$Je)(a,w,!0)),g){if(i==="copy")throw(0,c.$5j)((0,v.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const k=await this.G(n);if(!k)throw(0,c.$5j)((0,v.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const A=await this.G(s);if(A){if(!r)throw(0,c.$5j)((0,v.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);k.type&c.FileType.File&&A.type&c.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.Y(n,s,!1)}async Y(n,s,i){const r=this.C(n),a=this.C(s),w=!!(this.capabilities&1024);if((0,S.$Je)(r,a,!w))return;const g=new b.$kb;try{const[f,k]=await Promise.all([this.J(n),this.J(s)]);g.add(f),g.add(k),i&&await d.Promises.mkdir((0,C.$dc)(a),{recursive:!0}),await d.Promises.copyFile(r,a)}catch(f){if(f.code==="ENOENT"&&!i)return this.Y(n,s,!0);throw this.ab(f)}finally{g.dispose()}}p(n,s,i){return new p.$Ip(r=>n(r),r=>s(r),i)}y(n,s,i){return new R.$Qp(r=>n(r),r=>s(r),i)}ab(n){if(n instanceof c.$4j)return n;let s=n,i;switch(n.code){case"ENOENT":i=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=c.FileSystemProviderErrorCode.Unknown;break;default:i=c.FileSystemProviderErrorCode.Unknown}return(0,c.$5j)(s,i)}async bb(n,s){let i=this.ab(s);if(n&&i.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await d.SymlinkSupport.stat(this.C(n));r.mode&128||(i=(0,c.$5j)(s,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return i}}e.$Rp=t}),define(oe[101],ae([0,1,3,2,4,8]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$65b=e.$55b=void 0,e.$55b=(0,O.$ph)("sharedProcessLifecycleService");let L=class extends T.$lb{constructor(S){super(),this.b=S,this.a=this.B(new I.$8c),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$65b=L,e.$65b=L=we([Y(0,j.$Ri)],L)}),define(oe[197],ae([0,1,10,3,8,2]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=e.$Nq=void 0;class L extends O.$3i{constructor(E,m,h,d,v){super(m,h,d),this.n=E,this.p=v,this.B(v.listen("onDidChangeLogLevel",E)(c=>{(0,O.$Ti)(c)?super.setLogLevel(c):super.setLogLevel(I.URI.revive(c[0]),c[1])})),this.B(v.listen("onDidChangeVisibility",E)(([c,l])=>super.setVisibility(I.URI.revive(c),l))),this.B(v.listen("onDidChangeLoggers",E)(({added:c,removed:l})=>{for(const u of c)super.registerLogger({...u,resource:I.URI.revive(u.resource)});for(const u of l)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new O.$1i({log:(E,m)=>{this.p.call("consoleLog",[E,m])}})}registerLogger(E){super.registerLogger(E),this.p.call("registerLogger",[E,this.n])}deregisterLogger(E){super.deregisterLogger(E),this.p.call("deregisterLogger",[E,this.n])}setLogLevel(E,m){super.setLogLevel(E,m),this.p.call("setLogLevel",[E,m])}setVisibility(E,m){super.setVisibility(E,m),this.p.call("setVisibility",[this.l(E),m])}m(E,m,h){return new P(this.p,E,m,h,this.n)}static setLogLevel(E,m,h){return E.call("setLogLevel",[m,h])}}e.$Nq=L;class P extends O.$Xi{constructor(E,m,h,d,v){super(d?.logLevel==="always"),this.m=E,this.n=m,this.k=!1,this.l=[],this.setLevel(h),this.m.call("createLogger",[m,d,v]).then(()=>{this.r(this.l),this.k=!0})}g(E,m){const h=[[E,m]];this.k?this.r(h):this.l.push(...h)}r(E){this.m.call("log",[this.n,E])}}class S{constructor(E,m){this.a=E,this.b=m}listen(E,m){const h=this.b(E);switch(m){case"onDidChangeLoggers":return T.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(v=>this.c(v,h)),removed:[...d.removed].map(v=>this.c(v,h))}));case"onDidChangeVisibility":return T.Event.map(this.a.onDidChangeVisibility,d=>[h.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return T.Event.map(this.a.onDidChangeLogLevel,d=>(0,O.$Ti)(d)?d:[h.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${m}`)}async call(E,m,h){const d=this.b(E);switch(m){case"setLogLevel":return(0,O.$Ti)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(I.URI.revive(d.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(v=>this.c(v,d)))}throw new Error(`Call not found: ${m}`)}c(E,m){return{...E,resource:m.transformOutgoingURI(E.resource)}}}e.$Oq=S;class b extends j.$lb{constructor(E,m){super(),m.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(h=>m.call("setLogLevel",[h]))),m.call("getRegisteredLoggers").then(h=>{for(const d of h)E.registerLogger({...d,resource:I.URI.revive(d.resource)})}),this.B(m.listen("onDidChangeVisibility")(([h,d])=>E.setVisibility(I.URI.revive(h),d))),this.B(m.listen("onDidChangeLoggers")(({added:h,removed:d})=>{for(const v of h)E.registerLogger({...v,resource:I.URI.revive(v.resource)});for(const v of d)E.deregisterLogger(v.resource)}))}}e.$Pq=b}),define(oe[198],ae([0,1,2,8]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=void 0;class O extends I.$lb{constructor(L,P=[]){super(),this.a=new T.$2i([L,...P]),this.B(L.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...P){this.a.trace(L,...P)}debug(L,...P){this.a.debug(L,...P)}info(L,...P){this.a.info(L,...P)}warn(L,...P){this.a.warn(L,...P)}error(L,...P){this.a.error(L,...P)}flush(){this.a.flush()}}e.$1M=O}),define(oe[55],ae([0,1,4]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$13b=void 0,e.$13b=(0,I.$ph)("nativeHostService")}),define(oe[56],ae([0,1,3,59,2,4]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=e.$Vm=void 0,e.$Vm=(0,j.$ph)("policy");class L extends O.$lb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$8c),this.onDidChange=this.h.event}async updatePolicyDefinitions(b){const C=Object.keys(this.f).length;return this.f={...b,...this.f},C!==Object.keys(this.f).length&&await this.i(b),T.Iterable.reduce(this.g.entries(),(E,[m,h])=>({...E,[m]:h}),{})}getPolicyValue(b){return this.g.get(b)}serialize(){return T.Iterable.reduce(Object.entries(this.f),(b,[C,E])=>({...b,[C]:{definition:E,value:this.g.get(C)}}),{})}}e.$Wm=L;class P{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Xm=P}),define(oe[199],ae([0,1,3,2,56]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P4b=e.$O4b=void 0;class j{constructor(S){this.b=S,this.a=new T.$kb}listen(S,b){switch(b){case"onDidChange":return I.Event.map(this.b.onDidChange,C=>C.reduce((E,m)=>({...E,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${b}`)}call(S,b,C){switch(b){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${b}`)}dispose(){this.a.dispose()}}e.$O4b=j;class L extends O.$Wm{constructor(S,b){super(),this.a=b;for(const C in S){const{definition:E,value:m}=S[C];this.f[C]=E,m!==void 0&&this.g.set(C,m)}this.a.listen("onDidChange")(C=>{for(const E in C){const m=C[E];m===null?this.g.delete(E):this.g.set(E,m)}this.h.fire(Object.keys(C))})}async i(S){const b=await this.a.call("updatePolicyDefinitions",S);for(const C in b)this.g.set(C,b[C])}}e.$P4b=L}),define(oe[102],ae([0,1,5,37]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;if(typeof I.$g.vscode<"u"&&typeof I.$g.vscode.context<"u"){const j=I.$g.vscode.context.configuration();if(j)O=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(O=globalThis._VSCODE_PRODUCT_JSON,T.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:j.version})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(oe[24],ae([0,1,4]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=void 0,e.$0i=(0,I.$ph)("productService"),e.$$i="vscode://schemas/vscode-product"}),define(oe[200],ae([0,1,6,7,2,16,31,8,24]),function(ne,e,I,T,O,j,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z5b=void 0;let b=class extends O.$lb{constructor(E,m,h){super(),this.b=m,this.c=h,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new I.$Gg(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),h=(0,j.$dc)(E),d=(0,j.$ec)(E),v=await L.Promises.readdir(h);await Promise.all(v.map(async c=>{if(c===d)return;const l=(0,j.$ac)(h,c),u=await L.Promises.stat(l);if(u.isDirectory()&&m-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${c}.`),L.Promises.rm(l)}))}catch(m){(0,T.$Y)(m)}}};e.$z5b=b,e.$z5b=b=we([Y(1,S.$0i),Y(2,P.$Ri)],b)}),define(oe[201],ae([0,1,6,7,2,16,31,15,8,24]),function(ne,e,I,T,O,j,L,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A5b=void 0;let C=class extends O.$lb{constructor(m,h,d){super(),this.b=m,this.c=h,this.f=d,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new I.$Gg(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),h=JSON.parse(await L.Promises.readFile((0,j.$ac)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(h)){const y=h[u];m[`${y.hash}.${u}`]=!0}const d=(0,j.$ac)(this.b.userDataPath,"clp");if(!await L.Promises.exists(d))return;const c=await L.Promises.readdir(d);for(const u of c){if(m[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await L.Promises.rm((0,j.$ac)(d,u))}const l=Date.now();for(const u of Object.keys(m)){const y=(0,j.$ac)(d,u),p=await L.Promises.readdir(y);for(const R of p){if(R==="tcf.json")continue;const t=(0,j.$ac)(y,R),o=await L.Promises.stat(t);o.isDirectory()&&l-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$ac)(u,R)}`),await L.Promises.rm(t))}}}catch(m){(0,T.$Y)(m)}}};e.$A5b=C,e.$A5b=C=we([Y(0,P.$xh),Y(1,S.$Ri),Y(2,b.$0i)],C)}),define(oe[202],ae([0,1,16,4]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$lF=void 0,e.$lF=(0,T.$ph)("IV8InspectProfilingService");var O;(function(j){function L(S){return!!(S.samples&&S.timeDeltas)}j.isValidProfile=L;function P(S,b="noAbsolutePaths"){for(const C of S.nodes)C.callFrame&&C.callFrame.url&&((0,I.$_b)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,I.$ac)(b,(0,I.$ec)(C.callFrame.url)));return S}j.rewriteAbsolutePaths=P})(O||(e.Utils=O={}))}),define(oe[203],ae([0,1,32]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U5b=void 0;class T{constructor(){this.a=new Map}async startProfiling(j){const P=await(await new Promise((b,C)=>{ne(["v8-inspect-profiler"],b,C)})).startProfiling({port:j.port,checkForPaused:!0}),S=(0,I.$6e)();return this.a.set(S,P),S}async stopProfiling(j){const L=this.a.get(j);if(!L)throw new Error(`UNKNOWN session '${j}'`);const P=await L.stop();return this.a.delete(j),P.profile}}e.$U5b=T}),define(oe[40],ae([0,1,123,11]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=void 0;class O{constructor(){this.a=new Map}add(L,P){I.ok(T.$je(L)),I.ok(T.$le(P)),I.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,P)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$Tm=new O}),define(oe[103],ae([0,1,3,40]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0,e.$Um={JSONContribution:"base.contributions.json"};function O(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class j{constructor(){this.b=new I.$8c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,b){this.a[O(S)]=b,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const L=new j;T.$Tm.add(e.$Um.JSONContribution,L)}),define(oe[49],ae([0,1,21,3,11,145,18,103,40]),function(ne,e,I,T,O,j,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.ConfigurationScope=e.$Ym=e.EditPresentationTypes=void 0;var b;(function(R){R.Multiline="multilineText",R.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$Ym={Configuration:"base.contributions.configuration"};var C;(function(R){R[R.APPLICATION=1]="APPLICATION",R[R.MACHINE=2]="MACHINE",R[R.WINDOW=3]="WINDOW",R[R.RESOURCE=4]="RESOURCE",R[R.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",R[R.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m={properties:{},patternProperties:{}},e.$5m={properties:{},patternProperties:{}},e.$6m="vscode://schemas/settings/resourceLanguage",e.$7m="vscode://schemas/settings/configurationDefaults";const E=S.$Tm.as(P.$Um.JSONContribution);class m{constructor(){this.h=new Set,this.i=new T.$8c,this.onDidSchemaChange=this.i.event,this.j=new T.$8c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$6m,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const n=new Set;this.n(t,o,n),E.registerSchema(e.$6m,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const o=new Set;this.o(t,o),E.registerSchema(e.$6m,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const n=new Set;this.o(o,n),this.n(t,!1,n),E.registerSchema(e.$6m,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const n=[];for(const{overrides:s,source:i}of t)for(const r in s)if(o.add(r),e.$9m.test(r)){const a=this.a.get(r),w=a?.valuesSources??new Map;if(i)for(const A of Object.keys(s[r]))w.set(A,i);const g={...a?.value||{},...s[r]};this.a.set(r,{source:i,value:g,valuesSources:w});const f=(0,L.$6h)(r),k={type:"object",default:g,description:j.localize(1,null,f),$ref:e.$6m,defaultDefaultValue:g,source:O.$je(i)?void 0:i,defaultValueSource:i};n.push(...v(r)),this.d[r]=k,this.b.properties[r]=k}else{this.a.set(r,{value:s[r],source:i});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:n,source:s}of t)for(const i in n){const r=this.a.get(i),a=O.$je(s)?s:s?.id,w=O.$je(r?.source)?r?.source:r?.source?.id;if(a===w)if(o.add(i),this.a.delete(i),e.$9m.test(i))delete this.d[i],delete this.b.properties[i];else{const g=this.d[i];g&&(this.w(i,g),this.r(i,g))}}this.u()}deltaConfiguration(t){let o=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,n){t.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(t,o){const n=s=>{if(s.properties)for(const i in s.properties){o.add(i);const r=this.d[i];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[i],this.s(i,s.properties[i])}s.allOf?.forEach(i=>n(i))};for(const s of t){n(s);const i=this.c.indexOf(s);i!==-1&&this.c.splice(i,1)}}p(t,o=!0,n,s,i=3,r){i=O.$se(t.scope)?i:t.scope;const a=t.properties;if(a)for(const g in a){const f=a[g];if(o&&y(g,f)){delete a[g];continue}if(f.source=n,f.defaultDefaultValue=a[g].default,this.w(g,f),e.$9m.test(g)?f.scope=void 0:(f.scope=O.$se(f.scope)?i:f.scope,f.restricted=O.$se(f.restricted)?!!s?.includes(g):f.restricted),a[g].hasOwnProperty("included")&&!a[g].included){this.f[g]=a[g],delete a[g];continue}else this.d[g]=a[g],a[g].policy?.name&&this.e.set(a[g].policy.name,g);!a[g].deprecationMessage&&a[g].markdownDeprecationMessage&&(a[g].deprecationMessage=a[g].markdownDeprecationMessage),r.add(g)}const w=t.allOf;if(w)for(const g of w)this.p(g,o,n,s,i,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$Zm.properties[t]=o,o.scope){case 1:e.$1m.properties[t]=o;break;case 2:e.$2m.properties[t]=o;break;case 6:e.$3m.properties[t]=o;break;case 3:e.$4m.properties[t]=o;break;case 4:e.$5m.properties[t]=o;break;case 5:e.$5m.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$Zm.properties[t],o.scope){case 1:delete e.$1m.properties[t];break;case 2:delete e.$2m.properties[t];break;case 6:delete e.$3m.properties[t];break;case 3:delete e.$4m.properties[t];break;case 4:case 5:delete e.$5m.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,n={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$6m};this.w(o,n),e.$Zm.properties[o]=n,e.$1m.properties[o]=n,e.$2m.properties[o]=n,e.$3m.properties[o]=n,e.$4m.properties[o]=n,e.$5m.properties[o]=n}}v(){const t={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$6m};e.$Zm.patternProperties[e.$8m]=t,e.$1m.patternProperties[e.$8m]=t,e.$2m.patternProperties[e.$8m]=t,e.$3m.patternProperties[e.$8m]=t,e.$4m.patternProperties[e.$8m]=t,e.$5m.patternProperties[e.$8m]=t,this.i.fire()}w(t,o){const n=this.a.get(t);let s=n?.value,i=n?.source;O.$qe(s)&&(s=o.defaultDefaultValue,i=void 0),O.$qe(s)&&(s=l(o.type)),o.default=s,o.defaultValueSource=i}}const h="\\[([^\\]]+)\\]",d=new RegExp(h,"g");e.$8m=`^(${h})+$`,e.$9m=new RegExp(e.$8m);function v(R){const t=[];if(e.$9m.test(R)){let o=d.exec(R);for(;o?.length;){const n=o[1].trim();n&&t.push(n),o=d.exec(R)}}return(0,I.$rf)(t)}e.$0m=v;function c(R){return R.reduce((t,o)=>`${t}[${o}]`,"")}e.$$m=c;function l(R){switch(Array.isArray(R)?R[0]:R){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$_m=l;const u=new m;S.$Tm.add(e.$Ym.Configuration,u);function y(R,t){return R.trim()?e.$9m.test(R)?j.localize(7,null,R):u.getConfigurationProperties()[R]!==void 0?j.localize(8,null,R):t.policy?.name&&u.getPolicyConfigurations().get(t.policy?.name)!==void 0?j.localize(9,null,R,t.policy?.name,u.getPolicyConfigurations().get(t.policy?.name)):null:j.localize(6,null)}e.$an=y;function p(){const R=[],t=u.getConfigurationProperties();for(const o of Object.keys(t))R.push([o,t[o].scope]);return R.push(["launch",4]),R.push(["task",4]),R}e.$bn=p}),define(oe[71],ae([0,1,21,3,34,2,35,30,11,10,18,49,40]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=void 0;function h(o){return Object.isFrozen(o)?o:P.$Im(o)}class d{constructor(n={},s=[],i=[],r){this.b=n,this.c=s,this.d=i,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof d)return s;const i=new v("");return i.parseRaw(s),i.configurationModel});this.f=n.reduce((s,i)=>i===s?i:s.merge(i),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$4h)(this.contents,n):this.contents}inspect(n,s){const i=this.rawConfiguration.getValue(n),r=s?this.rawConfiguration.getOverrideValue(n,s):void 0,a=s?this.rawConfiguration.override(s).getValue(n):i;return{value:i,override:r,merged:a}}getOverrideValue(n,s){const i=this.i(s);return i?n?(0,C.$4h)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const i of this.overrides)i.identifiers.includes(n)&&s.push(...i.keys);return I.$rf(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return I.$rf(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=P.$Hm(this.contents),i=P.$Hm(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const w of n)if(a.push(...w.raw?.length?w.raw:[w]),!w.isEmpty()){this.h(s,w.contents);for(const g of w.overrides){const[f]=i.filter(k=>I.$bf(k.identifiers,g.identifiers));f?(this.h(f.contents,g.contents),f.keys.push(...g.keys),f.keys=I.$rf(f.keys)):i.push(P.$Hm(g))}for(const g of w.keys)r.indexOf(g)===-1&&r.push(g)}return new d(s,r,i,a.every(w=>w instanceof d)?void 0:a)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const i={};for(const r of I.$rf([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const w=s[r];w&&(typeof a=="object"&&typeof w=="object"?(a=P.$Hm(a),this.h(a,w)):a=w),i[r]=a}return new d(i,this.keys,this.overrides)}h(n,s){for(const i of Object.keys(s)){if(i in n&&S.$le(n[i])&&S.$le(s[i])){this.h(n[i],s[i]);continue}n[i]=P.$Hm(s[i])}}i(n){let s=null,i=null;const r=a=>{a&&(i?this.h(i,a):i=P.$Hm(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,C.$3h)(this.contents,n),E.$9m.test(n)&&this.overrides.splice(this.overrides.findIndex(i=>I.$bf(i.identifiers,(0,E.$0m)(n))),1))}j(n,s,i){(0,C.$2h)(this.contents,n,s,r=>console.error(r)),i=i||this.keys.indexOf(n)===-1,i&&this.keys.push(n),E.$9m.test(n)&&this.overrides.push({identifiers:(0,E.$0m)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$1h)(this.contents[n],r=>console.error(r))})}}e.$cn=d;class v{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!S.$se(n)){const i=this.g(n);this.parseRaw(i,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:i,keys:r,overrides:a,restricted:w,hasExcludedProperties:g}=this.h(n,s);this.b=new d(i,r,a,g?[n]:void 0),this.c=w||[]}g(n){let s={},i=null,r=[];const a=[],w=[];function g(k){Array.isArray(r)?r.push(k):i!==null&&(r[i]=k)}const f={onObjectBegin:()=>{const k={};g(k),a.push(r),r=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const k=[];g(k),a.push(r),r=k,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:g,onError:(k,A,M)=>{w.push({error:k,offset:A,length:M})}};if(n)try{O.$Em(n,f),s=r[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return s}h(n,s){const i=m.$Tm.as(E.$Ym.Configuration).getConfigurationProperties(),r=this.i(n,i,!0,s);n=r.raw;const a=(0,C.$1h)(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),w=Object.keys(n),g=this.j(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:a,keys:w,overrides:g,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,s,i,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const w={},g=[];for(const f in n)if(E.$9m.test(f)&&i){const k=this.i(n[f],s,!1,r);w[f]=k.raw,a=a||k.hasExcludedProperties,g.push(...k.restricted)}else{const k=s[f],A=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&g.push(f),!r.exclude?.includes(f)&&(r.include?.includes(f)||(A===void 0||r.scopes===void 0||r.scopes.includes(A))&&!(r.skipRestricted&&k?.restricted))?w[f]=n[f]:a=!0}return{raw:w,restricted:g,hasExcludedProperties:a}}j(n,s){const i=[];for(const r of Object.keys(n))if(E.$9m.test(r)){const a={};for(const w in n[r])a[w]=n[r][w];i.push({identifiers:(0,E.$0m)(r),keys:Object.keys(a),contents:(0,C.$1h)(a,s)})}return i}}e.$dn=v;class c extends j.$lb{constructor(n,s,i,r){super(),this.c=n,this.f=s,this.g=r,this.b=this.B(new T.$8c),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&i.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new d}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$en=c;class l{constructor(n,s,i,r,a,w,g,f,k,A,M,F,V){this.a=n,this.b=s,this.c=i,this.overrideIdentifiers=r,this.d=a,this.f=w,this.g=g,this.h=f,this.i=k,this.j=A,this.k=M,this.l=F,this.m=V}get value(){return h(this.c)}n(n,s,i){const r=n.inspect(s,i);return{get value(){return h(r.value)},get override(){return h(r.override)},get merged(){return h(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(n,s,i,r,a=new d,w=new d,g=new L.$ni,f=new d,k=new L.$ni){this.c=n,this.d=s,this.f=i,this.g=r,this.h=a,this.i=w,this.j=g,this.l=f,this.m=k,this.a=null,this.b=new L.$ni,this.n=null}getValue(n,s,i){return this.q(n,s,i).getValue(n)}updateValue(n,s,i={}){let r;i.resource?(r=this.m.get(i.resource),r||(r=new d,this.m.set(i.resource,r))):r=this.l,s===void 0?r.removeValue(n):r.setValue(n,s),i.resource||(this.a=null)}inspect(n,s,i){const r=this.q(n,s,i),a=this.u(s.resource,i),w=s.resource?this.m.get(s.resource)||this.l:this.l,g=new Set;for(const f of r.overrides)for(const k of f.identifiers)r.getOverrideValue(n,k)!==void 0&&g.add(k);return new l(n,s,r.getValue(n),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,a||void 0,w)}keys(n){const s=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const i=[];if(!s){const{added:r,updated:a,removed:w}=R(this.c,n);s=[...r,...a,...w]}for(const r of s)for(const a of(0,E.$0m)(r)){const w=this.c.getKeysForOverrideIdentifier(a),g=n.getKeysForOverrideIdentifier(a),f=[...g.filter(k=>w.indexOf(k)===-1),...w.filter(k=>g.indexOf(k)===-1),...w.filter(k=>!P.$Lm(this.c.override(a).getValue(k),n.override(a).getValue(k)))];i.push([a,f])}return this.updateDefaultConfiguration(n),{keys:s,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:i,removed:r}=R(this.d,n),a=[...s,...i,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=R(this.applicationConfiguration,n),w=[...s,...i,...r];return w.length&&this.updateApplicationConfiguration(n),{keys:w,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=R(this.localUserConfiguration,n),w=[...s,...i,...r];return w.length&&this.updateLocalUserConfiguration(n),{keys:w,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=R(this.remoteUserConfiguration,n),w=[...s,...i,...r];return w.length&&this.updateRemoteUserConfiguration(n),{keys:w,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=R(this.workspaceConfiguration,n),w=[...s,...i,...r];return w.length&&this.updateWorkspaceConfiguration(n),{keys:w,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const i=this.p.get(n),{added:r,updated:a,removed:w,overrides:g}=R(i,s),f=[...r,...a,...w];return(f.length||!i)&&this.updateFolderConfiguration(n,s),{keys:f,overrides:g}}compareAndDeleteFolderConfiguration(n){const s=this.p.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:r,removed:a,overrides:w}=R(s,void 0);return{keys:[...i,...r,...a],overrides:w}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,s,i){let r=this.r(s,i);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}r({resource:n},s){let i=this.s();if(s&&n){const r=s.getFolder(n);r&&(i=this.t(r.uri)||i);const a=this.m.get(n);a&&(i=i.merge(a))}return i}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let s=this.b.get(n);if(!s){const i=this.s(),r=this.j.get(n);r?(s=i.merge(r),this.b.set(n,s)):s=i}return s}u(n,s){if(s&&n){const i=s.getFolder(n);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:i,overrides:r,keys:a}=this.j.get(s);return n.push([s,{contents:i,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(i=>n.add(i))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}w(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.i.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.x(n.defaults),i=this.x(n.policy),r=this.x(n.application),a=this.x(n.user),w=this.x(n.workspace),g=n.folders.reduce((f,k)=>(f.set(b.URI.revive(k[0]),this.x(k[1])),f),new L.$ni);return new u(s,i,r,a,new d,w,g,new d,new L.$ni)}static x(n){return new d(n.contents,n.keys,n.overrides)}}e.$fn=u;function y(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,w])=>{const g=(0,L.$ki)(s,a,new Set);w.forEach(f=>g.add(f))});const i=[];return s.forEach((r,a)=>i.push([a,[...r.values()]])),{keys:[...n.values()],overrides:i}}e.$gn=y;class p{constructor(n,s,i,r){this.change=n,this.f=s,this.g=i,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const w of a)this.affectedKeys.add(w);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(n,s){const i=this.a+n,r=this.d.indexOf(i);if(r<0)return!1;const a=r+i.length;if(a>=this.d.length)return!1;const w=this.d.charCodeAt(a);if(w!==this.b&&w!==this.c)return!1;if(s){const g=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,f=this.g.getValue(n,s,this.h);return!P.$Lm(g,f)}return!0}}e.$hn=p;function R(o,n){const{added:s,removed:i,updated:r}=t(n?.rawConfiguration,o?.rawConfiguration),a=[],w=o?.getAllOverrideIdentifiers()||[],g=n?.getAllOverrideIdentifiers()||[];if(n){const f=g.filter(k=>!w.includes(k));for(const k of f)a.push([k,n.getKeysForOverrideIdentifier(k)])}if(o){const f=w.filter(k=>!g.includes(k));for(const k of f)a.push([k,o.getKeysForOverrideIdentifier(k)])}if(n&&o){for(const f of w)if(g.includes(f)){const k=t({contents:o.getOverrideValue(void 0,f)||{},keys:o.getKeysForOverrideIdentifier(f)},{contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)});a.push([f,[...k.added,...k.removed,...k.updated]])}}return{added:s,removed:i,updated:r,overrides:a}}function t(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],i=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const w=(0,C.$4h)(n.contents,a),g=(0,C.$4h)(o.contents,a);P.$Lm(w,g)||r.push(a)}}return{added:s,removed:i,updated:r}}}),define(oe[204],ae([0,1,21,3,2,30,11,71,49,8,56,40]),function(ne,e,I,T,O,j,L,P,S,b,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=void 0;class m extends O.$lb{constructor(){super(...arguments),this.a=this.B(new T.$8c),this.onDidChangeConfiguration=this.a.event,this.b=new P.$cn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$Tm.as(S.$Ym.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:l})=>this.c(Array.from(c),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(c,l){this.h(c,E.$Tm.as(S.$Ym.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:c})}f(){return{}}g(){this.b=new P.$cn;const c=E.$Tm.as(S.$Ym.Configuration).getConfigurationProperties();this.h(Object.keys(c),c)}h(c,l){const u=this.f();for(const y of c){const p=u[y],R=l[y];p!==void 0?this.b.addValue(y,p):R?this.b.addValue(y,R.default):this.b.removeValue(y)}}}e.$in=m;class h{constructor(){this.onDidChangeConfiguration=T.Event.None,this.configurationModel=new P.$cn}async initialize(){return this.configurationModel}}e.$jn=h;let d=class extends O.$lb{get configurationModel(){return this.b}constructor(c,l,u){super(),this.c=c,this.f=l,this.g=u,this.a=this.B(new T.$8c),this.onDidChangeConfiguration=this.a.event,this.b=new P.$cn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(c=>this.i(c))),this.B(this.c.onDidChangeConfiguration(async({properties:c})=>this.j(await this.h(c),!0))),this.b}async h(c){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",c);const l={},u=[],y=E.$Tm.as(S.$Ym.Configuration).getConfigurationProperties();for(const p of c){const R=y[p];if(!R){u.push(p);continue}if(R.policy){if(R.type!=="string"&&R.type!=="number"){this.g.warn(`Policy ${R.policy.name} has unsupported type ${R.type}`);continue}u.push(p),l[R.policy.name]={type:R.type}}}return(0,L.$we)(l)||await this.f.updatePolicyDefinitions(l),u}i(c){this.g.trace("PolicyConfiguration#onDidChangePolicies",c);const l=E.$Tm.as(S.$Ym.Configuration).getPolicyConfigurations(),u=(0,I.$mf)(c.map(y=>l.get(y)));this.j(u,!0)}j(c,l){this.g.trace("PolicyConfiguration#update",c);const u=E.$Tm.as(S.$Ym.Configuration).getConfigurationProperties(),y=[],p=this.b.isEmpty();for(const R of c){const t=u[R]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(p?o!==void 0:!(0,j.$Lm)(this.b.getValue(R),o))&&y.push([R,o])}else this.b.getValue(R)!==void 0&&y.push([R,void 0])}if(y.length){this.g.trace("PolicyConfiguration#changed",y);const R=this.b;this.b=new P.$cn;for(const t of R.keys)this.b.setValue(t,R.getValue(t));for(const[t,o]of y)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);l&&this.a.fire(this.b)}}};e.$kn=d,e.$kn=d=we([Y(1,C.$Vm),Y(2,b.$Ri)],d)}),define(oe[205],ae([0,1,6,3,2,22,18,71,204,56]),function(ne,e,I,T,O,j,L,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0;class C extends O.$lb{constructor(m,h,d,v){super(),this.i=m,this.h=this.B(new T.$8c),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$in),this.c=d instanceof b.$Xm?new S.$jn:this.B(new S.$kn(this.b,d,v)),this.f=this.B(new P.$en(this.i,{},j.$1f,h)),this.a=new P.$fn(this.b.configurationModel,this.c.configurationModel,new P.$cn,new P.$cn),this.g=this.B(new I.$Gg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:l})=>this.k(c,l))),this.B(this.c.onDidChangeConfiguration(c=>this.l(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,h,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.$fn(m,h,new P.$cn,d)}getConfigurationData(){return this.a.toData()}getValue(m,h){const d=typeof m=="string"?m:void 0,v=(0,L.$Wh)(m)?m:(0,L.$Wh)(h)?h:{};return this.a.getValue(d,v,void 0)}updateValue(m,h,d,v){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const h=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(d,h,2)}k(m,h){const d=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(m,h);this.m(v,d,7)}l(m){const h=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(m);this.m(d,h,7)}m(m,h,d){const v=new P.$hn(m,{data:h},this.a);v.source=d,v.sourceConfig=this.n(d),this.h.fire(v)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$ln=C}),define(oe[206],ae([0,1,14]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xib=e.$Wib=void 0;const T=(O,j,L)=>{const P=new Uint8Array(16);for(let C=0;C<16;C++)P[C]=Math.round(Math.random()*256);const S=(0,I.$4b)(I.$Jb.wrap(P));return[`GET ws://localhost${O}?${j}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.$Wib=T,e.$Xib=I.$Jb.fromString(`\r
\r
`)}),define(oe[207],ae([0,1,7,4]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.RemoteAuthorityResolverErrorCode=e.$yk=e.$xk=e.RemoteConnectionType=e.$wk=void 0,e.$wk=(0,T.$ph)("remoteAuthorityResolverService");var O;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(O||(e.RemoteConnectionType=O={}));class j{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$xk=j;class L{constructor(E,m){this.host=E,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$yk=L;var P;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class S extends I.$ab{static isNotAvailable(E){return E instanceof S&&E._code===P.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof S&&E._code===P.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof S&&E._code===P.NoResolverFound}static isInvalidAuthority(E){return E instanceof S&&E._code===P.InvalidAuthority}static isHandled(E){return E instanceof S&&E.isHandled}constructor(E,m=P.Unknown,h){super(E),this._message=E,this._code=m,this._detail=h,this.isHandled=m===P.NotAvailable&&h===!0,Object.setPrototypeOf(this,S.prototype)}}e.$zk=S;function b(C){const E=C.indexOf("+");return E===-1?C:C.substring(0,E)}e.$Ak=b}),define(oe[72],ae([0,1,26]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=void 0;function T(b){return b.scheme===I.Schemas.vscodeRemote?b.authority:void 0}e.$Bk=T;function O(b){if(!b)return;const C=b.indexOf("+");return C<0?b:b.substr(0,C)}e.$Ck=O;function j(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$Dk=j;function L(b){const{host:C,port:E}=S(b);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:E}}e.$Ek=L;function P(b,C){let{host:E,port:m}=S(b);return typeof m>"u"&&(m=C),{host:E,port:m}}e.$Fk=P;function S(b){const C=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const E=b.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const m=b.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:b,port:void 0}}}),define(oe[45],ae([0,1,27,4,72]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.TargetPlatform=e.ExtensionType=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=void 0,e.$Bl="extensions.user.cache",e.$Cl="extensions.builtin.cache",e.$Dl="undefined_publisher",e.$El=["ui","workspace","web"];function j(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Fl=j,e.$Gl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(L||(e.ExtensionType=L={}));var P;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class S{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,l){if(typeof c>"u"||c===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof c=="string"||typeof l=="string"){const u=typeof c=="string"?c:c.value,y=typeof l=="string"?l:l.value;return I.$Md(u,y)}return c._lower===l._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$Hl=S;class b{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const l of c)this.add(l)}add(c){this.c.add(S.toKey(c))}delete(c){return this.c.delete(S.toKey(c))}has(c){return this.c.has(S.toKey(c))}}e.$Il=b;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(S.toKey(c))}get(c){return this.c.get(S.toKey(c))}has(c){return this.c.has(S.toKey(c))}set(c,l){this.c.set(S.toKey(c),l)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Jl=C;function E(v){return m(v)}e.$Kl=E;function m(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$Ll=m;function h(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$Ml=h;function d(v,c){if(c){const l=`onResolveRemoteAuthority:${(0,O.$Ck)(c)}`;return!!v.activationEvents?.includes(l)}return!1}e.$Nl=d,e.$Ol=(0,T.$ph)("IBuiltinExtensionsScannerService")}),define(oe[208],ae([0,1,2,45,13]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=void 0;class j extends I.$lb{constructor(P,S,b,C,E){super(),this.a=P,this.b=S,this.c=b,this.f=E,this.B(C.onDidInstallExtensions(m=>this.g(m))),this.B(C.onDidUninstallExtension(m=>this.h(m)))}g(P){for(const S of P)S.local&&this.invalidate(S.profileLocation)}h(P){P.error||this.invalidate(P.profileLocation)}async invalidate(P){if(P)for(const S of this.a.profiles)this.c.extUri.isEqual(S.extensionsResource,P)&&await this.i(S);else await this.i(this.a.defaultProfile)}async i(P){try{await this.b.del(this.c.extUri.joinPath(P.cacheHome,T.$Bl))}catch(S){(0,O.$9j)(S)!==1&&this.f.error(S)}}}e.$lp=j}),define(oe[209],ae([0,1,6,14,25,7,3,2,100,87,32,92,207,72]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.PersistentConnectionEventType=e.$Mk=e.$Lk=e.$Kk=e.ConnectionType=void 0;const d=30*1e3;var v;(function(N){N[N.Management=1]="Management",N[N.ExtensionHost=2]="ExtensionHost",N[N.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function c(N){switch(N){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(N){const $=new O.$ed;return setTimeout(()=>$.cancel(),N),$.token}function u(N,$){if(N.isCancellationRequested||$.isCancellationRequested)return O.CancellationToken.Cancelled;const D=new O.$ed;return N.onCancellationRequested(()=>D.cancel()),$.onCancellationRequested(()=>D.cancel()),D.token}class y{get didTimeout(){return this.c==="timedout"}constructor($){this.c="pending",this.d=new P.$kb,this.promise=new Promise((D,z)=>{this.f=D,this.g=z}),$.isCancellationRequested?this.h():this.d.add($.onCancellationRequested(()=>this.h()))}registerDisposable($){this.c==="pending"?this.d.add($):$.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const $=new Error("Time limit reached");return $.code="ETIMEDOUT",$.syscall="connect",$}resolve($){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f($))}reject($){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g($))}}function p(N,$){const D=new y($);return D.registerDisposable(N.onControlMessage(z=>{const K=JSON.parse(z.toString()),_=U(K);_?D.reject(_):D.resolve(K)})),D.promise}function R(N,$,D,z,K,_,H,ee){const ie=new y(ee),le=b.$4c.create(!1);return N.info(`Creating a socket (${H})...`),S.mark(`code/willCreateSocket/${_}`),$.connect(D,z,K,H).then(he=>{ie.didTimeout?(S.mark(`code/didCreateSocketError/${_}`),N.info(`Creating a socket (${H}) finished after ${le.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(S.mark(`code/didCreateSocketOK/${_}`),N.info(`Creating a socket (${H}) was successful after ${le.elapsed()} ms.`),ie.resolve(he))},he=>{S.mark(`code/didCreateSocketError/${_}`),N.info(`Creating a socket (${H}) returned an error after ${le.elapsed()} ms.`),N.error(he),ie.reject(he)}),ie.promise}function t(N,$){const D=new y($);return N.then(z=>{D.didTimeout||D.resolve(z)},z=>{D.didTimeout||D.reject(z)}),D.promise}async function o(N,$,D,z){const K=ce(N,$);N.logService.trace(`${K} 1/6. invoking socketFactory.connect().`);let _;try{_=await R(N.logService,N.remoteSocketFactoryService,N.connectTo,(0,h.$Dk)(N),`reconnectionToken=${N.reconnectionToken}&reconnection=${N.reconnectionProtocol?"true":"false"}`,c($),`renderer-${c($)}-${N.reconnectionToken}`,z)}catch(he){throw N.logService.error(`${K} socketFactory.connect() failed or timed out. Error:`),N.logService.error(he),he}N.logService.trace(`${K} 2/6. socketFactory.connect() was successful.`);let H,ee;N.reconnectionProtocol?(N.reconnectionProtocol.beginAcceptReconnection(_,null),H=N.reconnectionProtocol,ee=!1):(H=new E.$dh({socket:_}),ee=!0),N.logService.trace(`${K} 3/6. sending AuthRequest control message.`);const ie=await t(N.signService.createNewMessage((0,C.$6e)()),z),le={type:"auth",auth:N.connectionToken||"00000000000000000000",data:ie.data};H.sendControl(T.$Jb.fromString(JSON.stringify(le)));try{const he=await p(H,u(z,l(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(N.logService.trace(`${K} 4/6. received SignRequest control message.`),!await t(N.signService.validate(ie,he.signedData),z)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const be=await t(N.signService.sign(he.data),z),ke={type:"connectionType",commit:N.commit,signedData:be,desiredConnectionType:$};return D&&(ke.args=D),N.logService.trace(`${K} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(T.$Jb.fromString(JSON.stringify(ke))),{protocol:H,ownsProtocol:ee}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(N.logService.error(`${K} the handshake timed out. Error:`),N.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(N.logService.error(`${K} received error control message when negotiating connection. Error:`),N.logService.error(he)),ee&&W(H),he}}async function n(N,$,D,z){const K=Date.now(),_=ce(N,$),{protocol:H,ownsProtocol:ee}=await o(N,$,D,z),ie=new y(z);return ie.registerDisposable(H.onControlMessage(le=>{const he=JSON.parse(le.toString()),me=U(he);me?(N.logService.error(`${_} received error control message when negotiating connection. Error:`),N.logService.error(me),ee&&W(H),ie.reject(me)):(N.reconnectionProtocol?.endAcceptReconnection(),N.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${G(K)}!`),ie.resolve({protocol:H,firstMessage:he}))})),ie.promise}async function s(N,$){const{protocol:D}=await n(N,1,void 0,$);return{protocol:D}}async function i(N,$,D){const{protocol:z,firstMessage:K}=await n(N,2,$,D),_=K&&K.debugPort;return{protocol:z,debugPort:_}}async function r(N,$,D){const z=Date.now(),K=ce(N,3),{protocol:_}=await o(N,3,$,D);return N.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${G(z)}!`),_}async function a(N,$,D){const{connectTo:z,connectionToken:K}=await N.addressProvider.getAddress();return{commit:N.commit,quality:N.quality,connectTo:z,connectionToken:K,reconnectionToken:$,reconnectionProtocol:D,remoteSocketFactoryService:N.remoteSocketFactoryService,signService:N.signService,logService:N.logService}}async function w(N,$,D){return f(N,async z=>{const{protocol:K}=await s(z,O.CancellationToken.None);return new J(N,$,D,z.reconnectionToken,K)})}e.$Kk=w;async function g(N,$){return f(N,async D=>{const{protocol:z,debugPort:K}=await i(D,$,O.CancellationToken.None);return new X(N,$,D.reconnectionToken,z,K)})}e.$Lk=g;async function f(N,$){for(let z=1;;z++)try{const K=(0,C.$6e)(),_=await a(N,K,null);return await $(_)}catch(K){if(z<5)N.logService.error(`[remote-connection][attempt ${z}] An error occurred in initial connection! Will retry... Error:`),N.logService.error(K);else throw N.logService.error(`[remote-connection][attempt ${z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),N.logService.error(K),Q.triggerPermanentFailure(0,0,m.$zk.isHandled(K)),K}}async function k(N,$,D){const z=await a(N,(0,C.$6e)(),null);return await r(z,{host:$,port:D},O.CancellationToken.None)}e.$Mk=k;function A(N){return(0,I.$jg)($=>new Promise((D,z)=>{const K=setTimeout(D,N*1e3);$.onCancellationRequested(()=>{clearTimeout(K),D()})}))}var M;(function(N){N[N.ConnectionLost=0]="ConnectionLost",N[N.ReconnectionWait=1]="ReconnectionWait",N[N.ReconnectionRunning=2]="ReconnectionRunning",N[N.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",N[N.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class F{constructor($,D){this.reconnectionToken=$,this.millisSinceLastIncomingData=D,this.type=0}}e.$Nk=F;class V{constructor($,D,z,K){this.reconnectionToken=$,this.millisSinceLastIncomingData=D,this.durationSeconds=z,this.c=K,this.type=1}skipWait(){this.c.cancel()}}e.$Ok=V;class B{constructor($,D,z){this.reconnectionToken=$,this.millisSinceLastIncomingData=D,this.attempt=z,this.type=2}}e.$Pk=B;class x{constructor($,D,z){this.reconnectionToken=$,this.millisSinceLastIncomingData=D,this.attempt=z,this.type=4}}e.$Qk=x;class Z{constructor($,D,z,K){this.reconnectionToken=$,this.millisSinceLastIncomingData=D,this.attempt=z,this.handled=K,this.type=3}}e.$Rk=Z;class Q extends P.$lb{static triggerPermanentFailure($,D,z){this._permanentFailure=!0,this.f=$,this.g=D,this.h=z,this.i.forEach(K=>K.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach($=>$.s())}static debugPauseSocketWriting(){this.i.forEach($=>$.w())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.i=[]}get k(){return this.c||Q._permanentFailure}constructor($,D,z,K,_){super(),this.n=$,this.p=D,this.reconnectionToken=z,this.protocol=K,this.r=_,this.j=this.B(new L.$8c),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new x(this.reconnectionToken,0,0)),this.B(K.onSocketClose(H=>{const ee=re(this.n,this.reconnectionToken,!0);H?H.type===0?(this.p.logService.info(`${ee} received socket close event (hadError: ${H.hadError}).`),H.error&&this.p.logService.error(H.error)):(this.p.logService.info(`${ee} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this.p.logService.error(H.event)):this.p.logService.info(`${ee} received socket close event.`),this.s()})),this.B(K.onSocketTimeout(H=>{const ee=re(this.n,this.reconnectionToken,!0);this.p.logService.info(`${ee} received socket timeout event (unacknowledgedMsgCount: ${H.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${H.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${H.timeSinceLastReceivedSomeData}).`),this.s()})),Q.i.push(this),this.B((0,P.$jb)(()=>{const H=Q.i.indexOf(this);H>=0&&Q.i.splice(H,1)})),this.k&&this.v(Q.f,Q.g,Q.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const $=re(this.n,this.reconnectionToken,!0);this.p.logService.info(`${$} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const K=z<D.length?D[z]:D[D.length-1];try{if(K>0){const H=A(K);this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K,H)),this.p.logService.info(`${$} waiting for ${K} seconds before reconnecting...`);try{await H}catch{}}if(this.k){this.p.logService.error(`${$} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this.p.logService.info(`${$} resolving connection...`);const _=await a(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${$} connecting to ${_.connectTo}...`),await this.y(_,l(d)),this.p.logService.info(`${$} reconnected!`),this.j.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(_){if(_.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${$} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(_),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this.p.logService.error(`${$} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(_),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(m.$zk.isTemporarilyNotAvailable(_)){this.p.logService.info(`${$} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(_);continue}if((_.code==="ETIMEDOUT"||_.code==="ENETUNREACH"||_.code==="ECONNREFUSED"||_.code==="ECONNRESET")&&_.syscall==="connect"){this.p.logService.info(`${$} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(_);continue}if((0,j.$2)(_)){this.p.logService.info(`${$} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(_);continue}if(_ instanceof m.$zk){this.p.logService.error(`${$} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(_),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,m.$zk.isHandled(_));break}this.p.logService.error(`${$} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(_),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!this.k&&!this.m)}u($,D,z){this.r?Q.triggerPermanentFailure($,D,z):this.v($,D,z)}v($,D,z){this.j.fire(new Z(this.reconnectionToken,$,D,z)),W(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.$Sk=Q;class J extends Q{constructor($,D,z,K,_){super(1,$,K,_,!0),this.client=this.B(new E.$bh(_,{remoteAuthority:D,clientId:z},$.ipcLogger))}async y($,D){await s($,D)}}e.$Tk=J;class X extends Q{constructor($,D,z,K,_){super(2,$,z,K,!1),this.z=D,this.debugPort=_}async y($,D){await i($,this.z,D)}}e.$Uk=X;function W(N){try{N.acceptDisconnect();const $=N.getSocket();N.dispose(),$.dispose()}catch($){(0,j.$Y)($)}}function U(N){if(N&&N.type==="error"){const $=new Error(`Connection error: ${N.reason}`);return $.code="VSCODE_CONNECTION_ERROR",$}return null}function q(N,$){for(;N.length<$;)N+=" ";return N}function te(N,$){return`[remote-connection][${q(c(N),13)}][${$.substr(0,5)}\u2026]`}function re(N,$,D){return`${te(N,$)}[${D?"reconnect":"initial"}]`}function ce(N,$){return`${re($,N.reconnectionToken,!!N.reconnectionProtocol)}[${N.connectTo}]`}function G(N){return`${Date.now()-N} ms`}}),define(oe[104],ae([0,1,2,4]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=void 0,e.$Gk=(0,T.$ph)("remoteSocketFactoryService");class O{constructor(){this.a={}}register(L,P){return this.a[L]??=[],this.a[L].push(P),(0,I.$jb)(()=>{const S=this.a[L]?.indexOf(P);typeof S=="number"&&S>=0&&this.a[L]?.splice(S,1)})}b(L){return(this.a[L.type]||[]).find(S=>S.supports(L))}connect(L,P,S,b){const C=this.b(L);if(!C)throw new Error(`No socket factory found for ${L}`);return C.connect(L,P,S,b)}}e.$Hk=O}),define(oe[210],ae([0,1,4]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S5b=e.$R5b=void 0,e.$R5b=(0,I.$ph)("sharedProcessTunnelService"),e.$S5b="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,160]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$35b=e.$25b=e.$15b=e.$Z5b=e.$Y5b=e.TunnelStates=e.$X5b=e.$W5b=void 0,e.$W5b=(0,I.$ph)("IRemoteTunnelService"),e.$X5b={active:!1};var O;(function(j){j.disconnected=L=>({type:"disconnected",onTokenFailed:L}),j.connected=(L,P)=>({type:"connected",info:L,serviceInstallFailed:P}),j.connecting=L=>({type:"connecting",progress:L}),j.uninitialized={type:"uninitialized"}})(O||(e.TunnelStates=O={})),e.$Y5b="remote.tunnels.access",e.$Z5b=e.$Y5b+".hostNameOverride",e.$15b=e.$Y5b+".preventSleep",e.$25b="remoteTunnelService",e.$35b=(0,T.localize)(0,null)}),define(oe[57],ae([0,1,14,7,2,162,49,4,8,40]),function(ne,e,I,T,O,j,L,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=void 0,e.$yo=(0,P.$ph)("requestService");class C{constructor(R){this.b=R}toJSON(){if(!this.a){const R=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?R[t]="*****":R[t]=this.b[t];this.a=R}return this.a}}class E extends O.$lb{constructor(R){super(),this.b=0,this.a=R.createLogger("network",{name:(0,j.localize)(0,null),when:S.$9i.isEqualTo((0,S.$7i)(S.LogLevel.Trace)).serialize()})}async c(R,t,o){const n=`${R} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new C(t.headers??{}));try{const s=await o();return this.a.trace(`${n} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,t.type,(0,T.$9)(s)),s}}}e.$zo=E;function m(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$Ao=m;function h(p){return p.res.statusCode===204}async function d(p){return h(p)?null:(await(0,I.$Vb)(p.stream)).toString()}e.$Bo=d;async function v(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);return d(p)}e.$Co=v;async function c(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);if(h(p))return null;const t=(await(0,I.$Vb)(p.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$Do=c;function l(p){y(p)}e.$Eo=l;let u;function y(p){const R=b.$Tm.as(L.$Ym.Configuration),t=u;u={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0}}},R.updateConfigurations({add:[u],remove:t?[t]:[]})}y(1)}),define(oe[211],ae([0,1,25,26,13,57]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=void 0;let L=class{constructor(S,b){this.a=S,this.b=b}async download(S,b,C=I.CancellationToken.None){if(S.scheme===T.Schemas.file||S.scheme===T.Schemas.vscodeRemote){await this.b.copy(S,b);return}const E={type:"GET",url:S.toString(!0)},m=await this.a.request(E,C);if(m.res.statusCode===200)await this.b.writeFile(b,m.stream);else{const h=await(0,j.$Co)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${h}`)}}};e.$dN=L,e.$dN=L=we([Y(0,j.$yo),Y(1,O.$Sj)],L)}),define(oe[212],ae([0,1,14,25]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$Aq=void 0;class O{constructor(P){this.a=P}listen(P,S){throw new Error("Invalid listen")}call(P,S,b,C=T.CancellationToken.None){switch(S){case"request":return this.a.request(b[0],C).then(async({res:E,stream:m})=>{const h=await(0,I.$Vb)(m);return[{statusCode:E.statusCode,headers:E.headers},h]});case"resolveProxy":return this.a.resolveProxy(b[0])}throw new Error("Invalid call")}}e.$Aq=O;class j{constructor(P){this.a=P}async request(P,S){const[b,C]=await this.a.call("request",[P],S);return{res:b,stream:(0,I.$Xb)(C)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.$Bq=j}),define(oe[213],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pZb=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(O){try{const j=await this.c();if(j){const L=String(I.a++);return this.b.set(L,j),{id:L,data:j.createNewMessage(O)}}}catch{}return{id:"",data:O}}async validate(O,j){if(!O.id)return!0;const L=this.b.get(O.id);if(!L)return!1;this.b.delete(O.id);try{return L.validate(j)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(O){try{return await this.d(O)}catch{}return O}}e.$pZb=I}),define(oe[106],ae([0,1,4]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.$Ik=void 0,e.$Ik="signService",e.$Jk=(0,I.$ph)(e.$Ik)}),define(oe[214],ae([0,1,213]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$4b=void 0;class T extends I.$pZb{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(L=>new L.signer().sign(j))}h(){return new Promise((j,L)=>ne(["vsda"],j,L))}}e.$$4b=T}),define(oe[73],ae([0,1,3,2]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3xb=e.$2xb=e.$1xb=e.$Zxb=void 0;class O extends T.$lb{constructor(E,m,h){super(),this.a=E,this.b=m,this.c=h}async getItems(){const E={profile:this.b,workspace:this.c},m=await this.a.call("getItems",E);return new Map(m)}updateItems(E){const m={profile:this.b,workspace:this.c};return E.insert&&(m.insert=Array.from(E.insert.entries())),E.delete&&(m.delete=Array.from(E.delete.values())),this.a.call("updateItems",m)}}class j extends O{constructor(E,m){super(E,m,void 0),this.f=this.B(new I.$8c),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class L extends j{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.$Zxb=L;class P extends j{constructor(E,m){super(E,m)}async close(){this.dispose()}}e.$1xb=P;class S extends O{constructor(E,m){super(E,void 0,m),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$2xb=S;class b{constructor(E){this.a=E}isUsed(E){const m={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.$3xb=b}),define(oe[107],ae([0,1,5,37,32]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=void 0;function j(S){if(I.$t===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function L(S,b,C,E,m,h,d,v){const c=Object.create(null);c["common.machineId"]=h,c.sessionID=(0,O.$6e)()+Date.now(),c.commitHash=E,c.version=m,c["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,I.$h)(I.$t),c["common.nodePlatform"]=T.$7b,c["common.nodeArch"]=C,c["common.product"]=v||"desktop",d&&(c["common.msftInternal"]=d);let l=0;const u=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),I.$l&&(c["common.snap"]="true");const y=j(b);return y&&(c["common.platformDetail"]=y),c}e.$Zn=L;function P(S){const b=T.env.USERDNSDOMAIN;if(!b)return!1;const C=b.toLowerCase();return S.some(E=>C===E)}e.$1n=P}),define(oe[20],ae([0,1,4]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0,e.$Vk=(0,I.$ph)("telemetryService"),e.$Wk=(0,I.$ph)("customEndpointTelemetryService"),e.$Xk="telemetry.currentSessionDate",e.$Yk="telemetry.firstSessionDate",e.$Zk="telemetry.lastSessionDate",e.$1k="telemetry.machineId",e.$2k="telemetry",e.$3k="telemetry.telemetryLevel",e.$4k="telemetry.enableCrashReporter",e.$5k="telemetry.enableTelemetry";var T;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var O;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(O||(e.TelemetryConfiguration=O={}))}),define(oe[215],ae([0,1,36,6,34,26,16,5,10,128,31,142,95,13,24,20]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=e.$hr=e.$gr=void 0;const c=new Map;async function l(t,o){const n=`${t}::${o.join(":")}`,s=c.get(n);if(s)return s;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,w=2e4;function g(k,A,M,F){const V=A.substring(k.length+1);return T.Promises.withAsyncBody(async B=>{let x;try{x=await C.Promises.readdir(A,{withFileTypes:!0})}catch{B();return}if(F.count>=w){F.count+=x.length,F.maxReached=!0,B();return}let Z=x.length;if(Z===0){B();return}let Q=x;F.count+x.length>w&&(F.maxReached=!0,Z=w-F.count,Q=x.slice(0,Z)),F.count+=x.length;for(const J of Q)if(J.isDirectory()){if(M.includes(J.name)||await g(k,(0,L.$ac)(A,J.name),M,F),--Z===0){B();return}}else{const X=J.name.lastIndexOf(".");if(X>=0){const W=J.name.substring(X+1);W&&r.set(W,(r.get(W)??0)+1)}for(const W of i)W.relativePathPattern?.test(V)!==!1&&W.filePattern.test(J.name)&&a.set(W.tag,(a.get(W.tag)??0)+1);if(--Z===0){B();return}}})}const f=T.Promises.withAsyncBody(async k=>{const A={count:0,maxReached:!1};await g(t,t,o,A);const M=await p(t);k({configFiles:u(a),fileTypes:u(r),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:M})});return c.set(n,f),f}e.$gr=l;function u(t){return Array.from(t.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function y(){const t={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/h.$nk.GB).toFixed(2)}GB (${(I.freemem()/h.$nk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.$tm.value()*100)}%`},o=I.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.$hr=y;async function p(t){try{const o=new Map,n=(0,L.$ac)(t,".vscode","launch.json"),s=await C.Promises.readFile(n),i=[],r=(0,O.$xm)(s.toString(),i);if(i.length)return console.log(`Unable to parse ${n}`),[];if((0,O.$Gm)(r)==="object"&&r.configurations)for(const a of r.configurations){const w=a.type;w&&(o.has(w)?o.set(w,o.get(w)+1):o.set(w,1))}return u(o)}catch{return[]}}e.$ir=p;let R=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const s=I.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(I.totalmem()/h.$nk.GB).toFixed(2)}GB (${(I.freemem()/h.$nk.GB).toFixed(2)}GB free)`),P.$i||n.push(`Load (avg):       ${I.loadavg().map(i=>Math.round(i)).join(", ")}`),n.push(`VM:               ${Math.round(b.$tm.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,E.$fr)(o.mainPID),this.k(o)]).then(async s=>{let[i,r]=s,a=this.m(o,i);return n.forEach(w=>{if((0,m.$6l)(w))a+=`
${w.errorMessage}`,r+=`
${w.errorMessage}`;else if(a+=`

Remote: ${w.hostName}`,w.processes&&(a+=`
${this.m(o,w.processes)}`),w.workspaceMetadata){r+=`
|  Remote: ${w.hostName}`;for(const g of Object.keys(w.workspaceMetadata)){const f=w.workspaceMetadata[g];let k=`${f.fileCount} files`;f.maxFilesReached&&(k=`more than ${k}`),r+=`|    Folder (${g}): ${k}`,r+=this.h(f)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:i,os:r,cpus:a}=y(),w={os:r,memory:s,cpus:a,vmHint:i,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return P.$i||(w.load=`${I.loadavg().map(g=>Math.round(g)).join(", ")}`),P.$k&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(o,n){const s=[];return(0,E.$fr)(o.mainPID).then(async i=>(s.push(""),s.push(this.g(o)),s.push(""),s.push(this.m(o,i)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(o))),n.forEach(r=>{if((0,m.$6l)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const w=r.workspaceMetadata[a];let g=`${w.fileCount} files`;w.maxFilesReached&&(g=`more than ${g}`),s.push(`Folder (${a}): ${g}`),s.push(this.h(w))}}),s.push(""),s.push(""),s.join(`
`)))}h(o){const n=[];let i=0;const r=(f,k)=>{const A=` ${f}(${k})`;i+A.length>60?(n.push(a),a="|                 ",i=a.length):i+=A.length,a+=A};let a="|      File types:";const w=10,g=o.fileTypes.length>w?w:o.fileTypes.length;for(let f=0;f<g;f++){const k=o.fileTypes[f];r(k.name,k.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",i=0,o.configFiles.forEach(f=>{r(f.name,f.count)}),n.push(a)),o.launchConfigFiles.length>0){let f="|      Launch Configs:";o.launchConfigFiles.forEach(k=>{const A=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`;f+=A}),n.push(f)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}k(o){const n=[],s=[];return o.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(n.push(`|  Window (${i.title})`),i.folderURIs.forEach(r=>{const a=S.URI.revive(r);if(a.scheme===j.Schemas.file){const w=a.fsPath;s.push(l(w,["node_modules",".git"]).then(g=>{let f=`${g.fileCount} files`;g.maxFilesReached&&(f=`more than ${f}`),n.push(`|    Folder (${(0,L.$ec)(w)}): ${f}`),n.push(this.h(g))}).catch(g=>{n.push(`|      Error: Unable to collect workspace stats for folder ${w} (${g.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(i=>n.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,s,i,n,0),i.join(`
`)}n(o,n,s,i,r){const a=r===0;let w;a?w=i.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(i.pid)?w=n.get(i.pid):w=`${"  ".repeat(r)} ${i.name}`;const g=process.platform==="win32"?i.mem:I.totalmem()*(i.mem/100);s.push(`${i.load.toFixed(0).padStart(5," ")}	${(g/h.$nk.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(i.children)&&i.children.forEach(f=>this.n(o,n,s,f,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const i=S.URI.revive(s);if(i.scheme!==j.Schemas.file)continue;const r=i.fsPath;try{(await l(r,["node_modules",".git"])).fileTypes.forEach(w=>n.add(w.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=S.URI.revive(n);if(s.scheme!==j.Schemas.file)continue;const i=s.fsPath;try{const r=await l(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$jr=R,e.$jr=R=we([Y(0,v.$Vk),Y(1,d.$0i)],R)}),define(oe[108],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q4b=e.$p4b=void 0;class I{constructor(j){this.b=j}listen(j,L){throw new Error(`Event not found: ${L}`)}call(j,L,{eventName:P,data:S}){return this.b.forEach(b=>b.log(P,S)),Promise.resolve(null)}}e.$p4b=I;class T{constructor(j){this.b=j}log(j,L){return this.b.call("log",{eventName:j,data:L}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$q4b=T}),define(oe[46],ae([0,1,30,11,3,18,72,107,20]),function(ne,e,I,T,O,j,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0;class b{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$2n=b;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$3n=C,e.$4n=new C;class E{async publicLog(i,r,a){}async publicLogError(i,r,a){}}e.$5n=E,e.$6n="telemetry",e.$7n="extensionTelemetryLog",e.$8n={log:()=>null,flush:()=>Promise.resolve(null)};function m(s,i){return O.Event.debounce(i.onDidChangeConfiguration,(a,w)=>{const g=a?new Set([...a.affectedKeys,...w.affectedKeys]):w.affectedKeys;return{...w,affectedKeys:g}},1e3,!0)(a=>{a.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,j.$Yh)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.$9n=m;function h(s,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!s.enableTelemetry||i.extensionTestsLocationURI)}e.$0n=h;function d(s,i){return!(i.isBuilt||i.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$$n=d;function v(s){const i=s.getValue(S.$3k),r=s.getValue(S.$4k);if(s.getValue(S.$5k)===!1||r===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$_n=v;function c(s){const i={},r={},a={};y(s,a);for(let w in a){w=w.length>150?w.substr(w.length-149):w;const g=a[w];typeof g=="number"?r[w]=g:typeof g=="boolean"?r[w]=g?1:0:typeof g=="string"?(g.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${g.length}`),i[w]=g.substring(0,8191)):typeof g<"u"&&g!==null&&(i[w]=g)}return{properties:i,measurements:r}}e.$ao=c;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(s){if(!s)return"none";const i=(0,L.$Ck)(s);return l.has(i)?i:"other"}e.$bo=u;function y(s,i,r=0,a){if(s)for(const w of Object.getOwnPropertyNames(s)){const g=s[w],f=a?a+w:w;Array.isArray(g)?i[f]=(0,I.$Mm)(g):g instanceof Date?i[f]=g.toISOString():(0,T.$le)(g)?r<2?y(g,i,r+1,f+"."):i[f]=(0,I.$Mm)(g):i[f]=g}}function p(s,i){const r=s.msftInternalDomains||[],a=i.getValue("telemetry.internalTesting");return(0,P.$1n)(r)||a}e.$co=p;function R(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$do=R;function t(s,i){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let r=s;const a=[];for(const k of i)for(;;){const A=k.exec(s);if(!A)break;a.push([A.index,k.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(r="";;){const k=g.exec(s);if(!k)break;const A=a.some(([M,F])=>k.index<F&&M<g.lastIndex);!w.test(k[0])&&!A&&(r+=s.substring(f,k.index)+"<REDACTED: user-file-path>",f=g.lastIndex)}return f<s.length&&(r+=s.substr(f)),r}function o(s){if(!s)return s;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of i)if(r.regex.test(s))return`<REDACTED: ${r.label}>`;return s}function n(s,i){return(0,I.$Jm)(s,r=>{if(r instanceof b||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=t(a,i);for(const w of i)a=a.replace(w,"");return a=o(a),a}})}e.$eo=n}),define(oe[33],ae([0,1,27,29,45,5,10,7,37,46]),function(ne,e,I,T,O,j,L,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=void 0;function C(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,I.$Hd)(n.id,s.id)===0}e.$fo=C;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const i=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,i,r)}static parse(s){const i=E.exec(s);return i&&i[1]&&i[2]?new m({id:i[1]},i[2],i[4]||void 0):null}constructor(s,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?C(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$go=m;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(n){const s=h.exec(n);return s&&s[1]?[c(s[1]),s[2]]:[c(n),void 0]}e.$ho=d;function v(n,s){return`${n}.${s}`}e.$io=v;function c(n){return n.toLowerCase()}e.$jo=c;function l(n,s){return c(v(n??O.$Dl,s))}e.$ko=l;function u(n,s){const i=[],r=a=>{for(const w of i)if(w.some(g=>C(s(g),s(a))))return w;return null};for(const a of n){const w=r(a);w?w.push(a):i.push([a])}return i}e.$lo=u;function y(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$mo=y;function p(n){return{id:new b.$2n(n.identifier.id),name:new b.$2n(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$no=p,e.$oo=new O.$Hl("pprice.better-merge");function R(n,s){const i=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&i.every(w=>!C(w.identifier,{id:a}))){const w=n.filter(g=>C(g.identifier,{id:a}));w.length===1&&(i.push(w[0]),r.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.$po=R;async function t(n,s){if(!j.$k)return!1;let i;try{i=(await n.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await n.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,P.$9)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const i=await t(n,s),r=(0,T.$Kn)(i?"alpine":j.$t,S.$8b);return s.debug("ComputeTargetPlatform:",r),r}e.$qo=o}),define(oe[216],ae([0,1,21,2,22,10,13,24,6,3,16,5,37,33]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w2b=e.$v2b=void 0;let d=class extends T.$lb{constructor(y,p){super(),this.b=y,this.c=p,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,R])=>this.a.set(R.configPath,R))}getConfigBasedTips(y){return this.f(y)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(y){const p=[];for(const[R,t]of this.a)if(!(t.configScheme&&t.configScheme!==y.scheme))try{const o=(await this.b.readFile((0,O.$0f)(y,R))).value.toString();for(const[n,s]of Object.entries(t.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&p.push({extensionId:n,extensionName:s.name,configName:t.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return p}};e.$v2b=d,e.$v2b=d=we([Y(0,L.$Sj),Y(1,P.$0i)],d);const v="extensionTips/promptedExecutableTips",c="extensionTips/lastPromptedMediumImpExeTime";class l extends d{constructor(y,p,R,t,o,n,s,i){super(s,i),this.m=y,this.n=p,this.r=R,this.s=t,this.t=o,this.u=n,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([r,a])=>{const w=[],g=[],f=[];Object.entries(a.recommendations).forEach(([k,A])=>{A.important?a.important?w.push({extensionId:k,extensionName:A.name,isExtensionPack:!!A.isExtensionPack}):g.push({extensionId:k,extensionName:A.name,isExtensionPack:!!A.isExtensionPack}):f.push({extensionId:k,extensionName:A.name,isExtensionPack:!!A.isExtensionPack})}),w.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:w}),g.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:g}),f.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:f})}),(0,S.$wg)(3e3).then(async()=>{await this.v(),this.z(),this.C()})}async getImportantExecutableBasedTips(){const y=await this.L(this.g),p=await this.L(this.h);return[...y,...p]}getOtherExecutableBasedTips(){return this.L(this.j)}async v(){const y=await this.L(this.g),p=await this.L(this.h),R=await this.s.getInstalled();this.k=this.w(y,R),this.l=this.w(p,R)}w(y,p){const R=new Map;y.forEach(i=>R.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:o}=this.J([...R.keys()],p);for(const i of t){const r=R.get(i);r&&this.r.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:r.exeName})}for(const i of o){const r=R.get(i);r&&this.r.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:r.exeName})}const n=this.H(),s=new Map;for(const i of o){const r=R.get(i);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}z(){if(this.k.size===0)return;const[y,p]=[...this.k.entries()][0];this.D(p).then(R=>{switch(R){case"reacted":this.I(p[0].exeName,p);break;case"ignored":this.k.delete(y);break;case"incompatibleWindow":{const t=b.Event.once(b.Event.latch(b.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(t(()=>this.z()));break}case"toomany":{const t=this.B((0,S.$xg)(()=>{t.dispose(),this.z()},36e5));break}}})}C(){if(this.l.size===0)return;const y=this.F(),p=Date.now()-y,R=7*24*60*60*1e3;if(p<R){const n=this.B((0,S.$xg)(()=>{n.dispose(),this.C()},R-p));return}const[t,o]=[...this.l.entries()][0];this.D(o).then(n=>{switch(n){case"reacted":{this.G(Date.now()),this.l.delete(t),this.I(o[0].exeName,o);const s=this.B((0,S.$xg)(()=>{s.dispose(),this.C()},R));break}case"ignored":this.l.delete(t),this.C();break;case"incompatibleWindow":{const s=b.Event.once(b.Event.latch(b.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(s(()=>this.C()));break}case"toomany":{const s=this.B((0,S.$xg)(()=>{s.dispose(),this.C()},36e5));break}}})}async D(y){const p=await this.s.getInstalled(1),R=y.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(o=>p.every(n=>!(0,h.$fo)(n.identifier,{id:o})))).map(({extensionId:t})=>t.toLowerCase());return this.u.promptImportantExtensionsInstallNotification({extensions:R,source:3,name:y[0].exeFriendlyName,searchValue:`@exe:"${y[0].exeName}"`})}F(){let y=this.t.getNumber(c,-1);return y||(y=Date.now(),this.G(y)),y}G(y){this.t.store(c,y,-1,1)}H(){return JSON.parse(this.t.get(v,-1,"{}"))}I(y,p){const R=this.H();R[y]=p.map(({extensionId:t})=>t.toLowerCase()),this.t.store(v,JSON.stringify(R),-1,0)}J(y,p){const R=[],t=[],o=p.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return y.forEach(n=>{o.has(n.toLowerCase())?R.push(n):t.push(n)}),{installed:R,uninstalled:t}}async L(y){const p=[],R=new Map;for(const t of y.keys()){const o=y.get(t);if(!o||!(0,I.$qf)(o.recommendations))continue;const n=[];E.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(n.push((0,C.$ac)("/usr/local/bin",t)),n.push((0,C.$ac)("/usr/bin",t)),n.push((0,C.$ac)(this.m.fsPath,t)));for(const s of n){let i=R.get(s);if(i===void 0&&(i=await this.b.exists(j.URI.file(s)),R.set(s,i)),i)for(const{extensionId:r,extensionName:a,isExtensionPack:w,whenNotInstalled:g}of o.recommendations)p.push({extensionId:r,extensionName:a,isExtensionPack:w,exeName:t,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:g})}}return p}}e.$w2b=l}),define(oe[217],ae([0,1,25,33]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dTb=void 0;async function O(j,L,P,S,b){try{const C=await j.getExtensionsControlManifest();if(!C.deprecated)return;const E=await j.getInstalled(1);for(const[m,h]of Object.entries(C.deprecated)){if(!h?.extension)continue;const{id:d,autoMigrate:v,preRelease:c}=h.extension;if(!v)continue;const l=E.find(y=>(0,T.$fo)(y.identifier,{id:m}));if(!l)continue;const u=(await L.getExtensions([{id:d,preRelease:c}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!u){b.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{b.info(`Migrating '${l.identifier.id}' extension to '${d}' extension...`);const y=!S.getDisabledExtensions().some(R=>(0,T.$fo)(R,l.identifier));await j.uninstall(l),b.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let p=E.find(R=>(0,T.$fo)(R.identifier,{id:d}));(!p||!p.isPreReleaseVersion&&y)&&(p=await j.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),b.info(`Installed the pre-release extension '${p.identifier.id}'`),y||(await S.disableExtension(p.identifier),b.info(`Disabled the pre-release extension '${p.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),v.storage&&(P.addToMigrationList((0,T.$io)(l.manifest.publisher,l.manifest.name),(0,T.$io)(p.manifest.publisher,p.manifest.name)),b.info("Added pre-release extension to the storage migration list"))),b.info(`Migrated '${l.identifier.id}' extension to '${d}' extension.`)}catch(y){b.error(y)}}}catch(C){b.error(C)}}e.$dTb=O}),define(oe[218],ae([0,1,3,2,35,33,45]),function(ne,e,I,T,O,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;class P extends T.$lb{constructor(b,C,E,m,h,d,v){super(),this.f=b,this.g=C,this.h=E,this.i=m,this.j=h,this.k=d,this.l=v,this.a=this.B(new I.$8c),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new T.$tb),this.m().then(null,c=>v.error(c))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles),this.n(),await this.z()}n(){this.B(this.h.onDidChangeProfiles(b=>this.p(b.added))),this.B(this.i.onAddExtensions(b=>this.r(b))),this.B(this.i.onDidAddExtensions(b=>this.s(b))),this.B(this.i.onRemoveExtensions(b=>this.t(b))),this.B(this.i.onDidRemoveExtensions(b=>this.u(b))),this.B(this.k.onDidFilesChange(b=>this.v(b)))}async p(b){try{b.length&&await Promise.all(b.map(C=>(this.c.set(C.id,(0,T.$ib)(this.k.watch(this.j.extUri.dirname(C.extensionsResource)),this.k.watch(C.extensionsResource))),this.y(C.extensionsResource))))}catch(C){throw this.l.error(C),C}}async r(b){for(const C of b.extensions)this.C(this.F(C.identifier,C.version),b.profileLocation)}async s(b){for(const C of b.extensions){const E=this.F(C.identifier,C.version);b.error?this.D(E,b.profileLocation):this.C(E,b.profileLocation)}}async t(b){for(const C of b.extensions)this.D(this.F(C.identifier,C.version),b.profileLocation)}async u(b){const C=[],E=[];for(const m of b.extensions){const h=this.F(m.identifier,m.version);b.error?this.C(h,b.profileLocation):(this.D(h,b.profileLocation),this.b.has(h)||(this.l.debug("Extension is removed from all profiles",m.identifier.id,m.version),E.push(this.f.scanInstalledExtensionAtLocation(m.location).then(d=>{d?C.push(d):this.l.info("Extension not found at the location",m.location.toString())},d=>this.l.error(d)))))}try{await Promise.all(E),C.length&&await this.z(C)}catch(m){this.l.error(m)}}v(b){for(const C of this.h.profiles)b.contains(C.extensionsResource,0,1)&&this.w(C.extensionsResource)}async w(b){const C=[],E=[],m=await this.i.scanProfileExtensions(b),h=new Set,d=new Set;for(const[v,c]of this.b)c.has(b)&&d.add(v);for(const v of m){const c=this.F(v.identifier,v.version);h.add(c),d.has(c)||(C.push(v.identifier),this.C(c,b))}for(const v of d)if(!h.has(v)){const c=this.G(v);c&&(E.push(c.identifier),this.D(v,b))}(C.length||E.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:b}:void 0,removed:E.length?{extensions:E,profileLocation:b}:void 0})}async y(b){const C=await this.i.scanProfileExtensions(b);for(const E of C)this.C(this.F(E.identifier,E.version),b)}async z(b){b||(b=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.F(E.identifier,E.manifest.version)))),b.length&&await this.f.markAsUninstalled(...b)}C(b,C){let E=this.b.get(b);E||this.b.set(b,E=new O.$oi(m=>this.j.extUri.getComparisonKey(m))),E.add(C)}D(b,C){const E=this.b.get(b);E&&E.delete(C),E?.size||this.b.delete(b)}F(b,C){return`${L.$Hl.toKey(b.id)}@${C}`}G(b){const[C,E]=(0,j.$ho)(b);return E?{identifier:{id:C},version:E}:void 0}}e.$mp=P}),define(oe[219],ae([0,1,44,46]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=void 0;async function O(j,L,P,S,b,C,E){const m={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${L.nameShort})`};if((0,T.$0n)(L,P)&&(0,T.$_n)(S)===3){const h=await(0,I.$Qo)(P,b,C);m["X-Market-User-Id"]=h,m["VSCode-SessionId"]=E.machineId||h}return m}e.$Ro=O}),define(oe[220],ae([0,1,67,21,6,2,26,16,31,15,29,33,8,70,10]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;let v=class extends h.$yq{constructor(y,p,R,t){super(R),this.h=y,this.i=t,this.g=this.B(new c(p,t)),this.h.registerParticipant({postInstall:async o=>this.j(o),postUninstall:async o=>this.k(o)})}async getBuiltInExtensionTranslationsUri(y,p){const t=(await this.g.getLanguagePacks())[p];if(!t){this.i.warn(`No language pack found for ${p}`);return}const o=t.translations[y];return o?d.URI.file(o):void 0}async getInstalledLanguages(){const y=await this.g.getLanguagePacks(),p=Object.keys(y).map(R=>{const t=y[R];return{...this.f(R,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((R,t)=>R.label.localeCompare(t.label)),p}async j(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",y.identifier.id),await this.update())}async k(y){const p=await this.g.getLanguagePacks();Object.keys(p).some(R=>p[R]&&p[R].extensions.some(t=>(0,E.$fo)(t.extensionIdentifier,y.identifier)))&&(this.i.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),R=await this.g.update(p);return!(0,T.$bf)(Object.keys(y),Object.keys(R))}};e.$zq=v,e.$zq=v=we([Y(0,C.$Rn),Y(1,b.$xh),Y(2,C.$Pn),Y(3,m.$Ri)],v);let c=class extends j.$lb{constructor(y,p){super(),this.i=p,this.c={},this.f=(0,P.$ac)(y.userDataPath,"languagepacks.json"),this.g=new O.$Cg}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(y){return this.m(p=>{Object.keys(p).forEach(R=>delete p[R]),this.j(p,...y)}).then(()=>this.c)}j(y,...p){for(const R of p)R&&R.manifest&&R.manifest.contributes&&R.manifest.contributes.localizations&&R.manifest.contributes.localizations.length&&this.k(y,R);Object.keys(y).forEach(R=>this.l(y[R]))}k(y,p){const R=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const o of t)if(p.location.scheme===L.Schemas.file&&l(o)){let n=y[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},y[o.languageId]=n);const s=n.extensions.filter(i=>(0,E.$fo)(i.extensionIdentifier,R))[0];s?s.version=p.manifest.version:n.extensions.push({extensionIdentifier:R,version:p.manifest.version});for(const i of o.translations)n.translations[i.id]=(0,P.$ac)(p.location.fsPath,i.path)}}l(y){if(y){const p=(0,I.createHash)("md5");for(const R of y.extensions)p.update(R.extensionIdentifier.uuid||R.extensionIdentifier.id).update(R.version);y.hash=p.digest("hex")}}m(y=()=>null){return this.g.queue(()=>{let p=null;return S.Promises.readFile(this.f,"utf8").then(void 0,R=>R.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(R)).then(R=>{try{return JSON.parse(R)}catch{return{}}}).then(R=>(p=y(R),R)).then(R=>{for(const o of Object.keys(R))R[o]||delete R[o];this.c=R,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),S.Promises.writeFile(this.f,t)}).then(()=>p,R=>this.i.error(R))})}};c=we([Y(0,b.$xh),Y(1,m.$Ri)],c);function l(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const y of u.translations)if(typeof y.id!="string"||typeof y.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(oe[221],ae([0,1,139,7,30,46]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0",P="https://mobile.events.data.microsoft.com/ping";async function S(C,E,m){const h=await(0,I.$WC)("@microsoft/1ds-core-js","dist/ms.core.js"),d=await(0,I.$WC)("@microsoft/1ds-post-js","dist/ms.post.js"),v=new h.AppInsightsCore,c=new d.PostChannel,l={instrumentationKey:C,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[c]]};if(m){l.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:m};l.extensionConfig[c.identifier]=u}return v.initialize(l,[]),v}class b{constructor(E,m,h,d,v){this.e=E,this.f=m,this.g=h,this.h=v,this.c=L,this.d=P,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(m=>{E(m)},m=>{(0,T.$Y)(m),console.error(m)})}}log(E,m){if(!this.a)return;m=(0,O.$Km)(m,this.g),m=(0,j.$ao)(m);const h=this.f+"/"+E;try{this.i(d=>{d.pluginVersionString=m?.properties.version??"Unknown",d.track({name:h,baseData:{name:h,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$NM=b}),define(oe[109],ae([0,1,2,163,15,8,24,46]),function(ne,e,I,T,O,j,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W1b=void 0;let S=class extends I.$lb{constructor(C,E,m,h,d=""){super(),this.b=d;const v=E.getLogger(P.$6n);if(v)this.a=this.B(v);else{const l=(0,P.$$n)(h,m)?" (Not Sent)":"",u=()=>(0,P.$0n)(h,m)&&C.getLevel()===j.LogLevel.Trace;this.a=this.B(E.createLogger(P.$6n,{name:(0,T.localize)(0,null,l),hidden:!u()})),this.B(C.onDidChangeLogLevel(()=>E.setVisibility(P.$6n,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,E){this.a.trace(`${this.b}telemetry/${C}`,(0,P.$ao)(E))}};e.$W1b=S,e.$W1b=S=we([Y(0,j.$Ri),Y(1,j.$Si),Y(2,O.$wh),Y(3,L.$0i)],S)}),define(oe[110],ae([0,1,2,30,5,27,164,18,49,102,24,40,20,46]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=void 0;let d=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,u,y){this.k=u,this.l=y,this.d={},this.i=new I.$kb,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,j.$od)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$od)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(m.$3k)||p.affectsConfiguration(m.$5k)||p.affectsConfiguration(m.$4k))&&this.m()}))}setExperimentProperty(l,u){this.d[l]=u}m(){let l=(0,h.$_n)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const y=u.usage?3:u.error?2:0;l=Math.min(l,y)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,u,y){this.g<u||(y=(0,T.$Km)(y,this.d),y=(0,h.$eo)(y,this.j),y=(0,T.$Km)(y,this.c),this.b.forEach(p=>p.log(l,y)))}publicLog(l,u){this.n(l,3,u)}publicLog2(l,u){this.publicLog(l,u)}publicLogError(l,u){this.h&&this.n(l,2,u)}publicLogError2(l,u){this.publicLogError(l,u)}};e.$Fq=d,e.$Fq=d=we([Y(1,P.$Vh),Y(2,C.$0i)],d);function v(){const c=(0,L.localize)(0,null,b.default.nameLong),l=b.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=O.$o?"":(0,L.localize)(3,null),y=(0,L.localize)(4,null),p=(0,L.localize)(5,null),R=(0,L.localize)(6,null),t=(0,L.localize)(7,null),o=`
|       | ${y} | ${p} | ${R} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,L.localize)(8,null);return`
${c} ${l} ${u}

&nbsp;

${t}
${o}

&nbsp;

${n}
`}E.$Tm.as(S.$Ym.Configuration).registerConfiguration({id:m.$2k,order:1,type:"object",title:(0,L.localize)(9,null),properties:{[m.$3k]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$Tm.as(S.$Ym.Configuration).registerConfiguration({id:m.$2k,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[m.$5k]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,L.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,L.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${m.$3k}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[222],ae([0,1,14,25,221]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=void 0;async function j(S,b){const C=await b.request(S,T.CancellationToken.None),E=(await(0,I.$Vb)(C.stream)).toString(),m=C.res.statusCode??200;return{headers:C.res.headers,statusCode:m,responseData:E}}function L(S,b){const C={method:S.type,headers:S.headers},E=b.request(S.url??"",C,m=>{m.on("data",function(h){return{headers:m.headers,statusCode:m.statusCode??200,responseData:h.toString()}}),m.on("error",function(h){throw h})});E.write(S.data),E.end()}class P extends O.$NM{constructor(b,C,E,m,h){let d;b||(d=ne("https"));const v={sendPOST:(c,l)=>{const u=typeof c.data=="string"?c.data:new TextDecoder().decode(c.data),y={type:"POST",headers:{...c.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(c.data).toString()},url:c.urlString,data:u};try{if(b)j(y,b).then(({statusCode:p,headers:R,responseData:t})=>{l(p,R,t)});else{if(!d)throw new Error("https module is undefined");L(y,d)}}catch{l(0,{})}}};super(C,E,m,h,v)}}e.$OM=P}),define(oe[223],ae([0,1,26,93,18,15,8,24,20,108,109,110]),function(ne,e,I,T,O,j,L,P,S,b,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G5b=void 0;let m=class{constructor(d,v,c,l,u,y){this.b=d,this.c=v,this.d=c,this.e=l,this.f=u,this.g=y,this.a=new Map}h(d){if(!this.a.has(d.id)){const v=Object.create(null);v["common.vscodemachineid"]=this.c.machineId,v["common.vscodesessionid"]=this.c.sessionId;const c=[d.id,JSON.stringify(v),d.aiKey],u=new T.$Hp(I.$4e.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:c,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),y=[new b.$q4b(u),new C.$W1b(this.d,this.e,this.f,this.g,`[${d.id}] `)];this.a.set(d.id,new E.$Fq({appenders:y,sendErrorTelemetry:d.sendErrorTelemetry},this.b,this.g))}return this.a.get(d.id)}publicLog(d,v,c){this.h(d).publicLog(v,c)}publicLogError(d,v,c){this.h(d).publicLogError(v,c)}};e.$G5b=m,e.$G5b=m=we([Y(0,O.$Vh),Y(1,S.$Vk),Y(2,L.$Ri),Y(3,L.$Si),Y(4,j.$wh),Y(5,P.$0i)],m)}),define(oe[74],ae([0,1,3,18,4,8]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pz=e.$Oz=e.$Nz=e.$Mz=e.$Lz=e.$Kz=e.$Jz=e.$Iz=e.ProvidedOnAutoForward=e.$Hz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Gz=e.$Fz=void 0,e.$Fz=(0,O.$ph)("tunnelService"),e.$Gz=(0,O.$ph)("sharedTunnelsService");var L;(function(c){c.Http="http",c.Https="https"})(L||(e.TunnelProtocol=L={}));var P;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(P||(e.TunnelPrivacyId=P={}));function S(c){return!!c.forwardPort}e.$Hz=S;var b;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function C(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(l)return{address:l[1],port:+l[2]}}e.$Iz=C,e.$Jz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(c){return e.$Jz.indexOf(c)>=0}e.$Kz=E,e.$Lz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(c){return e.$Lz.indexOf(c)>=0}e.$Mz=m;function h(c,l,u,y){if(u===1)return!1;if(u===2&&m(l)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(y);if(p?.length===4&&parseInt(p[1])>=18)return!1}return c<1024}e.$Nz=h;class d{constructor(l,u,y){this.remoteAddress=l,this.localAddress=u,this.b=y,this.a=new I.$8c,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Oz=d;let v=class{constructor(l,u){this.i=l,this.j=u,this.a=new I.$8c,this.onTunnelOpened=this.a.event,this.b=new I.$8c,this.onTunnelClosed=this.b.event,this.c=new I.$8c,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const l=this.j.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.e=l,l?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.f=l.elevation,this.g=l.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const l=[],u=Array.from(this.d.values());for(const y of u){const p=Array.from(y.values());for(const R of p){const t=await R.value;t&&l.push(t)}}return l}async dispose(){for(const l of this.d.values()){for(const{value:u}of l.values())await u.then(y=>y?.dispose());l.clear()}this.d.clear()}setEnvironmentTunnel(l,u,y,p,R){this.o(l,u,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:u,localAddress:y,privacy:p,protocol:R,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,u){(m(l)||E(l))&&(l=e.$Jz[0]);const y=this.q(l,u);if(y)return++y.refcount,y.value}openTunnel(l,u,y,p,R,t=!1,o,n){this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${y} on local port ${R}.`);const s=this.e??l;if(!s)return;if(u||(u="localhost"),p||(p=this.k),this.e&&this.h.has(y)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(s,u,y,p,R,t,o,n);return i?i.then(r=>{if(!r){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,y);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.m(r);return(r.tunnelRemoteHost!==u||r.tunnelRemotePort!==y)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const u=this.d.get(l.tunnelRemoteHost);if(u){const y=u.get(l.tunnelRemotePort);y&&(y.refcount--,await this.n(l.tunnelRemoteHost,l.tunnelRemotePort,y))}}}}async n(l,u,y){if(y.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${u}.`);const p=y.value.then(async R=>{R&&(await R.dispose(!0),this.b.fire({host:R.tunnelRemoteHost,port:R.tunnelRemotePort}))});return this.d.has(l)&&this.d.get(l).delete(u),p}}async closeTunnel(l,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${u} `);const y=this.d.get(l);if(y&&y.has(u)){const p=y.get(u);p.refcount=0,await this.n(l,u,p)}}o(l,u,y){this.d.has(l)||this.d.set(l,new Map),this.d.get(l).set(u,{refcount:1,value:y})}async p(l,u){const y=this.d.get(l);if(y){const p=y.get(u);(p?await p.value:void 0)||y.delete(u),y.size===0&&this.d.delete(l)}}q(l,u){const y=[l];E(l)?(y.push(...e.$Jz),y.push(...e.$Lz)):m(l)&&y.push(...e.$Lz);const p=y.map(R=>this.d.get(R));for(const R of p){const t=R?.get(u);if(t)return t}}canTunnel(l){return!!C(l)}s(l,u,y,p,R,t,o){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${y} on local port ${p}.`);const n=y;this.h.add(n);const s=p===void 0?y:p,i={elevationRequired:R?this.isPortPrivileged(s):!1},r={remoteAddress:{host:u,port:y},localAddressPort:p,privacy:t,public:t?t!==P.Private:void 0,protocol:o},a=l.forwardPort(r,i);return a?(this.o(u,y,a),a.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(n)})):this.h.delete(n),a}};e.$Pz=v,e.$Pz=v=we([Y(0,j.$Ri),Y(1,T.$Vh)],v)}),define(oe[224],ae([0,1,8,74,2,7,6]),function(ne,e,I,T,O,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T5b=void 0;class P extends O.$lb{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new L.$Pg),this.b.p)}setAddress(C){this.a=C,this.b&&(this.b.complete(C),this.b=null)}setTunnel(C){this.B(C)}}let S=class kt extends O.$lb{static{this.a=0}constructor(C,E){super(),this.f=C,this.g=E,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(C=>C.dispose())}async createTunnel(){return{id:String(++kt.a)}}async startTunnel(C,E,m,h,d,v,c){const l=new P,u=await Promise.resolve(this.f.openTunnel(C,l,m,h,d,v,c));if(!u)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${h} (remote).`),l.dispose(),new Error("Could not create tunnel");if(this.c.has(E))throw this.c.delete(E),l.dispose(),await u.dispose(),(0,j.$4)();return l.setTunnel(u),this.b.set(E,l),this.g.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${u.localAddress} (local) to ${m}:${h} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(C,E){const m=this.b.get(C);m&&m.setAddress(E)}async destroyTunnel(C){const E=this.b.get(C);if(E){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${C}.`),this.b.delete(C),await E.dispose();return}this.c.add(C)}};e.$T5b=S,e.$T5b=S=we([Y(0,T.$Gz),Y(1,I.$Ri)],S)}),define(oe[225],ae([0,1,60,36,130,6,2,18,8,24,209,74,106,5,104]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$94b=e.$84b=e.$74b=void 0;async function v(p,R,t,o,n){let s;for(let i=3;i&&(s?.dispose(),s=await new c(p,R,t,o,n).waitForReady(),!(n&&O.$9e[n]||!O.$9e[s.tunnelLocalPort]));i--);return s}class c extends L.$lb{constructor(R,t,o,n,s){super(),this.j=t,this.k=s,this.privacy=E.TunnelPrivacyId.Private,this.i=new Map,this.a=R,this.b=I.createServer(),this.c=new j.$ug,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=i=>this.l(i),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const R=this.k??this.tunnelRemotePort,t=(0,E.$Mz)(this.j)?"0.0.0.0":"127.0.0.1";let o=await(0,O.$0e)(R,2,1e3,t),n=null;return this.b.listen(o,this.j),await this.c.wait(),n=this.b.address(),n||(o=0,this.b.listen(o,this.j),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async l(R){R.pause();const t=(0,E.$Kz)(this.tunnelRemoteHost)||(0,E.$Mz)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,C.$Mk)(this.a,t,this.tunnelRemotePort),n=o.getSocket().socket,s=o.readEntireBuffer();o.dispose(),s.byteLength>0&&R.write(s.buffer),R.on("end",()=>{R.localAddress&&this.i.delete(R.localAddress),n.end()}),R.on("close",()=>n.end()),R.on("error",()=>{R.localAddress&&this.i.delete(R.localAddress),n.destroy()}),n.on("end",()=>R.end()),n.on("close",()=>R.end()),n.on("error",()=>{R.destroy()}),R.pipe(n),n.pipe(R),R.localAddress&&this.i.set(R.localAddress,()=>{R.end(),n.end()})}}let l=class extends E.$Pz{constructor(R,t,o,n,s){super(t,s),this.t=R,this.u=o,this.v=n}isPortPrivileged(R){return(0,E.$Nz)(R,this.k,h.OS,T.release())}r(R,t,o,n,s,i,r,a){const w=this.q(t,o);if(w)return++w.refcount,w.value;if((0,E.$Hz)(R))return this.s(R,t,o,s,i,r,a);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${o} on local port ${s}.`);const g={commit:this.v.commit,quality:this.v.quality,addressProvider:R,remoteSocketFactoryService:this.t,signService:this.u,logService:this.i,ipcLogger:null},f=v(g,n,t,o,s);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,o,f),f}}};e.$74b=l,e.$74b=l=we([Y(0,d.$Gk),Y(1,S.$Ri),Y(2,m.$Jk),Y(3,b.$0i),Y(4,P.$Vh)],l);let u=class extends l{constructor(R,t,o,n,s){super(R,t,o,n,s)}};e.$84b=u,e.$84b=u=we([Y(0,d.$Gk),Y(1,S.$Ri),Y(2,m.$Jk),Y(3,b.$0i),Y(4,P.$Vh)],u);let y=class extends L.$lb{constructor(R,t,o,n,s){super(),this.b=R,this.c=t,this.f=o,this.g=n,this.h=s,this.a=new Map}async openTunnel(R,t,o,n,s,i,r,a,w){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${n} on local port ${i}.`),!this.a.has(R)){const g=new u(this.b,this.c,this.g,this.f,this.h);this.B(g),this.a.set(R,g),g.onTunnelClosed(async()=>{(await g.tunnels).length===0&&(g.dispose(),this.a.delete(R))})}return this.a.get(R).openTunnel(t,o,n,s,i,r,a,w)}};e.$94b=y,e.$94b=y=we([Y(0,d.$Gk),Y(1,S.$Ri),Y(2,b.$0i),Y(3,m.$Jk),Y(4,P.$Vh)],y)}),define(oe[28],ae([0,1,4]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=void 0,e.$pk=(0,I.$ph)("IUriIdentityService")}),define(oe[226],ae([0,1,28,181,13,22,124,3,2]),function(ne,e,I,T,O,j,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class b{static{this._clock=0}constructor(m){this.uri=m,this.time=b._clock++}touch(){return this.time=b._clock++,this}}let C=class{constructor(m){this.g=m,this.c=new S.$kb,this.f=2**16;const h=new Map,d=v=>{let c=h.get(v.scheme);return c===void 0&&(c=m.hasProvider(v)&&!this.g.hasCapability(v,1024),h.set(v.scheme,c)),c};this.c.add(P.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(v=>{h.delete(v.scheme)})),this.extUri=new j.$Yf(d),this.d=new L.$br((v,c)=>this.extUri.compare(v,c,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,j.$$f)(m));const h=this.d.get(m);return h?h.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new b(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((d,v)=>d[1].time<v[1].time?1:d[1].time>v[1].time?-1:0);b._clock=0,this.d.clear();const h=this.f*.5;for(let d=0;d<h;d++)this.d.set(m[d][0],m[d][1].touch())}};e.$cr=C,e.$cr=C=we([Y(0,O.$Sj)],C),(0,T.$_q)(I.$pk,C,1)}),define(oe[227],ae([0,1,3,2,13,42,47,14]),function(ne,e,I,T,O,j,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b5b=void 0;class S extends T.$lb{get capabilities(){return this.f.capabilities&-5}constructor(C,E,m,h){super(),this.c=C,this.f=E,this.g=m,this.h=h,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new I.$8c),this.onDidChangeFile=this.a.event,this.b=L.$vh.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(d=>this.i(d)))}watch(C,E){this.b.set(C,C);const m=this.f.watch(this.j(C),E);return(0,T.$jb)(()=>{this.b.delete(C),m.dispose()})}stat(C){return this.f.stat(this.j(C))}mkdir(C){return this.f.mkdir(this.j(C))}rename(C,E,m){return this.f.rename(this.j(C),this.j(E),m)}readFile(C){return this.f.readFile(this.j(C),{atomic:!0})}readFileStream(C,E,m){const h=(0,j.$xb)(d=>P.$Jb.concat(d.map(v=>P.$Jb.wrap(v))).buffer);return(async()=>{try{const d=await this.readFile(C);h.end(d)}catch(d){h.error(d),h.end()}})(),h}readdir(C){return this.f.readdir(this.j(C))}writeFile(C,E,m){return this.f.writeFile(this.j(C),E,m)}delete(C,E){return this.f.delete(this.j(C),E)}copy(C,E,m){if((0,O.$Vj)(this.f))return this.f.copy(this.j(C),this.j(E),m);throw new Error("copy not supported")}i(C){const E=[];for(const m of C){if(m.resource.scheme!==this.c)continue;const h=this.k(m.resource);this.b.findSubstr(h)&&E.push({resource:h,type:m.type})}E.length&&(this.h.debug("User data changed"),this.a.fire(E))}j(C){return C.with({scheme:this.c})}k(C){return C.with({scheme:this.g})}}e.$b5b=S}),define(oe[75],ae([0,1,83]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gxb=e.$Fxb=e.edit=void 0;function T(L,P,S,b){const C=(0,I.$$R)(L,P,S,b)[0];return C&&(L=L.substring(0,C.offset)+C.content+L.substring(C.offset+C.length)),L}e.edit=T;function O(L,P,S){let b=S;for(;b>=0;){if(L.charAt(b)===P.charAt(P.length-1)&&P.length===1)return b+1;if(b--,P.length===2&&b>=0&&L.charAt(b)===P.charAt(0))return b+2}return 0}e.$Fxb=O;function j(L,P,S){let b=S;for(;b>=0;)if(L.charAt(b)===P.charAt(P.length-1)&&P.length===1||(b++,P.length===2&&b>=0&&L.charAt(b)===P.charAt(1)))return b;return L.length-1}e.$Gxb=j}),define(oe[228],ae([0,1,30,53,11]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EZb=void 0;function j(h,d,v,c,l,u){const y=[],p=[],R=[];if(!d){const B=h.filter(({identifier:x})=>l.every(Z=>Z.toLowerCase()!==x.id.toLowerCase()));return{local:{added:y,removed:p,updated:R},remote:B.length>0?{added:B,updated:[],removed:[],all:B}:null}}h=h.map(E),d=d.map(E),v=v?v.map(E):null;const t=new Map,o=B=>{B.uuid&&t.set(B.id.toLowerCase(),B.uuid)};h.forEach(({identifier:B})=>o(B)),d.forEach(({identifier:B})=>o(B)),v?.forEach(({identifier:B})=>o(B));const n=B=>{const x=B.identifier.uuid||t.get(B.identifier.id.toLowerCase());return x?`uuid:${x}`:`id:${B.identifier.id.toLowerCase()}`},s=(B,x)=>(B.set(n(x),x),B),i=h.reduce(s,new Map),r=d.reduce(s,new Map),a=d.reduce((B,x)=>s(B,(0,I.$Hm)(x)),new Map),w=v?v.reduce(s,new Map):null,g=c.reduce(s,new Map),f=l.reduce((B,x)=>{const Z=t.get(x.toLowerCase());return B.add(Z?`uuid:${Z}`:`id:${x.toLowerCase()}`)},new Set),k=u?u.reduce((B,{id:x,uuid:Z})=>(Z=Z??t.get(x.toLowerCase()),B.add(Z?`uuid:${Z}`:`id:${x.toLowerCase()}`)),new Set):null,A=L(i,r,f,!1);if(A.added.size>0||A.removed.size>0||A.updated.size>0){const B=L(w,i,f,!1),x=L(w,r,f,!0),Z=(Q,J,X,W)=>{let U,q,te;return J.installed?(U=W.pinned,te=W.preRelease,U&&(q=W.version)):(U=X.pinned,te=X.preRelease,U&&(q=X.version)),U===void 0&&(U=J.pinned,U&&(q=J.version)),te===void 0&&(te=J.preRelease),{...W,installed:J.installed||X.installed,pinned:U,preRelease:te,version:q??(X.version&&(!J.installed||T.gt(X.version,J.version))?X.version:J.version),state:S(J,X,w?.get(Q))}};for(const Q of x.removed.values()){const J=i.get(Q);if(!J)continue;const X=(0,O.$ue)(w?.get(Q)),W=k&&!k.has(Q)&&X.installed;J.installed&&W?p.push(J.identifier):a.set(Q,J)}for(const Q of x.added.values()){const J=(0,O.$ue)(r.get(Q)),X=i.get(Q);if(X){if(A.updated.has(Q)){const W=Z(Q,X,J,J);P(X,J,!1,!1)||R.push(m(W,Q)),a.set(Q,W)}}else J.installed&&y.push(m(J,Q))}for(const Q of x.updated.values()){const J=(0,O.$ue)(r.get(Q)),X=(0,O.$ue)(w?.get(Q)),W=i.get(Q);if(W)if(k&&!k.has(Q)&&X.installed&&W.installed&&!J.installed)p.push(W.identifier);else{const q=Z(Q,W,J,J);R.push(m(q,Q)),a.set(Q,q)}else J.installed&&y.push(m(J,Q))}for(const Q of B.added.values())x.added.has(Q)||a.set(Q,(0,O.$ue)(i.get(Q)));for(const Q of B.updated.values()){if(x.removed.has(Q)||x.updated.has(Q))continue;const J=(0,O.$ue)(i.get(Q)),X=(0,O.$ue)(r.get(Q));a.set(Q,Z(Q,J,X,J))}for(const Q of B.removed.values())x.updated.has(Q)||x.removed.has(Q)||g.has(Q)||(0,O.$ue)(r.get(Q)).installed&&k&&(k.has(Q)||!(0,O.$ue)(w?.get(Q)).installed||a.delete(Q))}const M=[],F=L(r,a,new Set,!0),V=F.added.size>0||F.updated.size>0||F.removed.size>0;return V&&a.forEach((B,x)=>M.push(m(B,x))),{local:{added:y,removed:p,updated:R},remote:V?{added:[...F.added].map(B=>a.get(B)),updated:[...F.updated].map(B=>a.get(B)),removed:[...F.removed].map(B=>r.get(B)),all:M}:null}}e.$EZb=j;function L(h,d,v,c){const l=h?[...h.keys()].filter(t=>!v.has(t)):[],u=[...d.keys()].filter(t=>!v.has(t)),y=u.filter(t=>!l.includes(t)).reduce((t,o)=>(t.add(o),t),new Set),p=l.filter(t=>!u.includes(t)).reduce((t,o)=>(t.add(o),t),new Set),R=new Set;for(const t of l){if(p.has(t))continue;const o=h.get(t),n=d.get(t);(!n||!P(o,n,c,!0))&&R.add(t)}return{added:y,removed:p,updated:R}}function P(h,d,v,c){return!(h.disabled!==d.disabled||!!h.isApplicationScoped!=!!d.isApplicationScoped||c&&h.installed!==d.installed||h.installed&&d.installed&&(h.preRelease!==d.preRelease||h.pinned!==d.pinned||d.pinned&&h.version!==d.version)||!C(h.state,d.state)||v&&h.version!==d.version)}function S(h,d,v){const c=h.state,l=d.state,u=v?.state;if(!d.version||c&&T.gt(h.version,d.version))return c;if(l&&T.gt(d.version,h.version)||!c)return l;if(!l)return c;const y=(0,I.$Hm)(c),p=u?b(u,l):{added:Object.keys(l).reduce((t,o)=>(t.add(o),t),new Set),removed:new Set,updated:new Set},R=u?b(u,c):{added:Object.keys(c).reduce((t,o)=>(t.add(o),t),new Set),removed:new Set,updated:new Set};for(const t of[...p.added.values(),...p.updated.values()])y[t]=l[t];for(const t of p.removed.values())R.updated.has(t)||delete y[t];return y}function b(h,d){const v=Object.keys(h),c=Object.keys(d),l=c.filter(p=>!v.includes(p)).reduce((p,R)=>(p.add(R),p),new Set),u=v.filter(p=>!c.includes(p)).reduce((p,R)=>(p.add(R),p),new Set),y=new Set;for(const p of v){if(u.has(p))continue;const R=h[p],t=d[p];(0,I.$Lm)(R,t)||y.add(p)}return{added:l,removed:u,updated:y}}function C(h={},d={}){const{added:v,removed:c,updated:l}=b(h,d);return v.size===0&&c.size===0&&l.size===0}function E(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function m(h,d){const v={...h,identifier:{id:h.identifier.id,uuid:d.startsWith("uuid:")?d.substring(5):void 0},preRelease:!!h.preRelease,pinned:!!h.pinned};return h.disabled||delete v.disabled,h.installed||delete v.installed,h.state||delete v.state,h.isApplicationScoped||delete v.isApplicationScoped,v}}),define(oe[111],ae([0,1,21,18,4]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yzb=e.$xzb=void 0,e.$xzb=(0,O.$ph)("IIgnoredExtensionsManagementService");let j=class{constructor(P){this.a=P}hasToNeverSyncExtension(P){return this.b().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.b().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,S){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return b=b.filter(C=>C!==P&&C!==`-${P}`),S&&b.push(P.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}updateSynchronizedExtensions(P,S){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return b=b.filter(C=>C!==P&&C!==`-${P}`),S&&b.push(`-${P.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}getIgnoredExtensions(P){const S=P.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),b=this.b().map(m=>m.toLowerCase()),C=[],E=[];if(Array.isArray(b))for(const m of b)m.startsWith("-")?E.push(m.substring(1)):C.push(m);return(0,I.$rf)([...S,...C].filter(m=>!E.includes(m)))}b(){let P=this.a.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.a.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};e.$yzb=j,e.$yzb=j=we([Y(0,T.$Vh)],j)}),define(oe[229],ae([0,1,21,34,30,94,75]),function(ne,e,I,T,O,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KZb=void 0;function P(p){return(0,T.$xm)(p)||[]}async function S(p,R,t,o,n){const s=P(p),i=P(R),r=t?P(t):null,a=[...s,...i,...r||[]].map(Z=>Z.key),w=await n.resolveUserBindings(a),g=C(s,i,r,w);if(!g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:p,hasChanges:!1,hasConflicts:!1};if(!g.hasLocalForwarded&&g.hasRemoteForwarded)return{mergeContent:R,hasChanges:!0,hasConflicts:!1};if(g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:p,hasChanges:!0,hasConflicts:!1};const f=m(s),k=m(i),A=r?m(r):null,M=d(f,k,w),F=A?d(A,f,w):{added:[...f.keys()].reduce((Z,Q)=>(Z.add(Q),Z),new Set),removed:new Set,updated:new Set},V=A?d(A,k,w):{added:[...k.keys()].reduce((Z,Q)=>(Z.add(Q),Z),new Set),removed:new Set,updated:new Set},B=b(M,F,V);let x=p;for(const Z of B.removed.values())B.conflicts.has(Z)||(x=u(x,Z,o));for(const Z of B.added.values()){if(B.conflicts.has(Z))continue;const Q=k.get(Z);if(Q.some(J=>J.command!==`-${Z}`&&g.conflicts.has(w[J.key]))){B.conflicts.add(Z);continue}x=l(x,Q,o)}for(const Z of B.updated.values()){if(B.conflicts.has(Z))continue;const Q=k.get(Z);if(Q.some(J=>J.command!==`-${Z}`&&g.conflicts.has(w[J.key]))){B.conflicts.add(Z);continue}x=y(x,Z,Q,o)}return{mergeContent:x,hasChanges:!0,hasConflicts:B.conflicts.size>0}}e.$KZb=S;function b(p,R,t){const o=new Set,n=new Set,s=new Set,i=new Set;for(const r of R.removed.values())t.updated.has(r)&&i.add(r);for(const r of t.removed.values())i.has(r)||(R.updated.has(r)?i.add(r):n.add(r));for(const r of R.added.values())i.has(r)||t.added.has(r)&&p.updated.has(r)&&i.add(r);for(const r of t.added.values())i.has(r)||(R.added.has(r)?p.updated.has(r)&&i.add(r):o.add(r));for(const r of R.updated.values())i.has(r)||t.updated.has(r)&&p.updated.has(r)&&i.add(r);for(const r of t.updated.values())i.has(r)||(R.updated.has(r)?p.updated.has(r)&&i.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:i}}function C(p,R,t,o){const n=new Set,s=E(p,o),i=E(R,o),r=t?E(t,o):null,a=h(s,i);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const w=r?h(r,s):{added:[...s.keys()].reduce((F,V)=>(F.add(V),F),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const g=r?h(r,i):{added:[...i.keys()].reduce((F,V)=>(F.add(V),F),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:f,removed:k,updated:A,conflicts:M}=b(a,w,g);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:k,updated:A,conflicts:M}}function E(p,R){const t=new Map;for(const o of p){const n=R[o.key];let s=t.get(n);s||(s=[],t.set(n,s)),s.push(o)}return t}function m(p){const R=new Map;for(const t of p){const o=t.command[0]==="-"?t.command.substring(1):t.command;let n=R.get(o);n||(n=[],R.set(o,n)),n.push(t)}return R}function h(p,R){const t=[...p.keys()],o=[...R.keys()],n=o.filter(r=>!t.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=t.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),i=new Set;for(const r of t){if(s.has(r))continue;const a=p.get(r).map(g=>({...g,key:r})),w=R.get(r).map(g=>({...g,key:r}));(0,I.$bf)(a,w,(g,f)=>c(g,f))||i.add(r)}return{added:n,removed:s,updated:i}}function d(p,R,t){const o=[...p.keys()],n=[...R.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,w)=>(a.add(w),a),new Set),i=o.filter(a=>!n.includes(a)).reduce((a,w)=>(a.add(w),a),new Set),r=new Set;for(const a of o){if(i.has(a))continue;const w=p.get(a).map(f=>({...f,key:t[f.key]})),g=R.get(a).map(f=>({...f,key:t[f.key]}));v(w,g)||r.add(a)}return{added:s,removed:i,updated:r}}function v(p,R){return!(!(0,I.$bf)(p.filter(({command:t})=>t[0]!=="-"),R.filter(({command:t})=>t[0]!=="-"),(t,o)=>c(t,o))||!(0,I.$bf)(p.filter(({command:t})=>t[0]==="-"),R.filter(({command:t})=>t[0]==="-"),(t,o)=>c(t,o)))}function c(p,R){if(p.command!==R.command||p.key!==R.key)return!1;const t=j.$vi.deserialize(p.when),o=j.$vi.deserialize(R.when);return!(t&&!o||!t&&o||t&&o&&!t.equals(o)||!O.$Lm(p.args,R.args))}function l(p,R,t){for(const o of R)p=L.edit(p,[-1],o,t);return p}function u(p,R,t){const o=P(p);for(let n=o.length-1;n>=0;n--)(o[n].command===R||o[n].command===`-${R}`)&&(p=L.edit(p,[n],void 0,t));return p}function y(p,R,t,o){const n=P(p),s=n.findIndex(i=>i.command===R||i.command===`-${R}`);for(let i=n.length-1;i>=0;i--)(n[i].command===R||n[i].command===`-${R}`)&&(p=L.edit(p,[i],void 0,o));for(let i=t.length-1;i>=0;i--)p=L.edit(p,[s],t[i],o);return p}}),define(oe[230],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SZb=e.$RZb=void 0;function I(j,L,P){const S={},b={},C=new Set;if(!L)return{local:{added:S,updated:b,removed:[...C.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const E=T(j,L);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:S,updated:b,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=T(P,j),h=T(P,L),d={},v={},c=new Set,l=new Set;for(const u of m.removed.values())h.updated.has(u)?S[u]=L[u]:c.add(u);for(const u of h.removed.values())l.has(u)||(m.updated.has(u)?l.add(u):C.add(u));for(const u of m.updated.values())l.has(u)||(h.updated.has(u)?E.updated.has(u)&&l.add(u):v[u]=j[u]);for(const u of h.updated.values())l.has(u)||(m.updated.has(u)?E.updated.has(u)&&l.add(u):j[u]!==void 0&&(b[u]=L[u]));for(const u of m.added.values())l.has(u)||(h.added.has(u)?E.updated.has(u)&&l.add(u):d[u]=j[u]);for(const u of h.added.values())l.has(u)||(m.added.has(u)?E.updated.has(u)&&l.add(u):S[u]=L[u]);return{local:{added:S,removed:[...C.values()],updated:b},remote:{added:d,removed:[...c.values()],updated:v},conflicts:[...l.values()]}}e.$RZb=I;function T(j,L){const P=j?Object.keys(j):[],S=L?Object.keys(L):[],b=S.filter(m=>!P.includes(m)).reduce((m,h)=>(m.add(h),m),new Set),C=P.filter(m=>!S.includes(m)).reduce((m,h)=>(m.add(h),m),new Set),E=new Set;for(const m of P){if(C.has(m))continue;const h=j[m],d=L[m];h!==d&&E.add(m)}return{added:b,removed:C,updated:E}}function O(j,L){const{added:P,removed:S,updated:b}=T(j,L);return P.size===0&&S.size===0&&b.size===0}e.$SZb=O}),define(oe[231],ae([0,1,30]),function(ne,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z2b=void 0;function T(j,L,P,S){const b={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!L){const m=j.filter(({id:h})=>!S.includes(h));return m.length?C.added=m:C=null,{local:b,remote:C}}const E=O(j,L,S);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const m=O(P,j,S),h=O(P,L,S);for(const d of h.removed){const v=j.find(c=>c.id===d);v&&b.removed.push(v)}for(const d of h.added){const v=L.find(c=>c.id===d);m.added.includes(d)?E.updated.includes(d)&&b.updated.push(v):b.added.push(v)}for(const d of h.updated)b.updated.push(L.find(v=>v.id===d));for(const d of m.added)h.added.includes(d)||C.added.push(j.find(v=>v.id===d));for(const d of m.updated)h.removed.includes(d)||h.updated.includes(d)||C.updated.push(j.find(v=>v.id===d));for(const d of m.removed){const v=L.find(c=>c.id===d);v&&C.removed.push(v)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:b,remote:C}}e.$z2b=T;function O(j,L,P){j=j?j.filter(({id:h})=>!P.includes(h)):[],L=L.filter(({id:h})=>!P.includes(h));const S=j.map(({id:h})=>h),b=L.map(({id:h})=>h),C=b.filter(h=>!S.includes(h)),E=S.filter(h=>!b.includes(h)),m=[];for(const{id:h,name:d,shortName:v,useDefaultFlags:c}of j){if(E.includes(h))continue;const l=L.find(u=>u.id===h);(!l||l.name!==d||l.shortName!==v||!(0,I.$Lm)(l.useDefaultFlags,c))&&m.push(h)}return{added:C,removed:E,updated:m}}}),define(oe[23],ae([0,1,21,11,170,49,29,4,103,40]),function(ne,e,I,T,O,j,L,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffb=e.$efb=e.$dfb=e.$cfb=e.$bfb=e.$afb=e.$_eb=e.$$eb=e.$0eb=e.$9eb=e.$8eb=e.MergeState=e.Change=e.SyncStatus=e.$7eb=e.$6eb=e.$5eb=e.UserDataSyncErrorCode=e.$4eb=e.$3eb=e.$2eb=e.$1eb=e.$Zeb=e.$Yeb=e.$Xeb=e.$Web=e.$Veb=e.SyncResource=e.$Ueb=e.$Teb=e.$Seb=e.$Reb=e.$Qeb=e.$Peb=void 0;function C(){const i=b.$Tm.as(j.$Ym.Configuration).getConfigurationProperties();return Object.keys(i).filter(r=>!!i[r].disallowSyncIgnore)}e.$Peb=C;function E(){const i=b.$Tm.as(j.$Ym.Configuration).getConfigurationProperties(),r=Object.keys(i).filter(g=>!!i[g].ignoreSync),a=Object.keys(i).filter(g=>i[g].scope===2||i[g].scope===6),w=C();return(0,I.$rf)([...r,...a,...w])}e.$Qeb=E,e.$Reb="settingsSync",e.$Seb="settingsSync.keybindingsPerPlatform";function m(){const i="vscode://schemas/ignoredSettings",r=b.$Tm.as(j.$Ym.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,O.localize)(0,null),type:"object",properties:{[e.$Seb]:{type:"boolean",description:(0,O.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,O.localize)(2,null),items:[{type:"string",pattern:L.$Dn,errorMessage:(0,O.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,O.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=b.$Tm.as(S.$Um.JSONContribution),w=()=>{const g=C(),f=E(),k=Object.keys(j.$Zm.properties).filter(F=>!f.includes(F)),A=f.filter(F=>!g.includes(F)),M={items:{type:"string",enum:[...k,...A.map(F=>`-${F}`)]}};a.registerSchema(i,M)};return r.onDidUpdateConfiguration(()=>w())}e.$Teb=m;function h(i){return i&&(0,T.$le)(i)&&(0,T.$je)(i.id)&&Array.isArray(i.scopes)}e.$Ueb=h;var d;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(d||(e.SyncResource=d={})),e.$Veb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function v(i,...r){return i?[i,...r]:r}e.$Web=v;function c(i,r,a,w){return w.joinPath(a.userDataSyncHome,...v(i,r,`lastSync${r}.json`))}e.$Xeb=c,e.$Yeb=(0,P.$ph)("IUserDataSyncStoreManagementService"),e.$Zeb=(0,P.$ph)("IUserDataSyncStoreService"),e.$1eb=(0,P.$ph)("IUserDataSyncBackupStoreService"),e.$2eb="x-operation-id",e.$3eb="X-Execution-Id";function l(i){const r={};return r[e.$3eb]=i,r}e.$4eb=l;var u;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class y extends Error{constructor(r,a,w,g){super(r),this.code=a,this.resource=w,this.operationId=g,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$5eb=y;class p extends y{constructor(r,a,w,g,f){super(r,w,void 0,f),this.url=a,this.serverCode=g}}e.$6eb=p;class R extends y{constructor(r,a){super(r,a)}}e.$7eb=R,function(i){function r(a){if(a instanceof i)return a;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(w&&w[1]){const g=w[2]==="unknown"?void 0:w[2],f=w[3]==="unknown"?void 0:w[3];return new i(a.message,w[1],g,f)}return new i(a.message,"Unknown")}i.toUserDataSyncError=r}(y||(e.$5eb=y={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var o;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(n||(e.MergeState=n={})),e.$8eb="sync.store.url.type";function s(i){return`sync.enable.${i}`}e.$9eb=s,e.$0eb=(0,P.$ph)("IUserDataSyncEnablementService"),e.$$eb=(0,P.$ph)("IUserDataSyncService"),e.$_eb=(0,P.$ph)("IUserDataSyncResourceProviderService"),e.$afb=(0,P.$ph)("IUserDataAutoSyncService"),e.$bfb=(0,P.$ph)("IUserDataSyncUtilService"),e.$cfb=(0,P.$ph)("IUserDataSyncLogService"),e.$dfb="userDataSync",e.$efb="vscode-userdata-sync",e.$ffb="preview"}),define(oe[232],ae([0,1,30,23]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tyb=void 0;function O(L,P,S,b,C){if(!P)return{remote:{added:Object.keys(L),removed:[],updated:[],all:Object.keys(L).length>0?L:null},local:{added:{},removed:[],updated:{}}};const E=j(L,P);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=S?j(S,P):{added:Object.keys(P).reduce((u,y)=>(u.add(y),u),new Set),removed:new Set,updated:new Set},h=S?j(S,L):{added:Object.keys(L).reduce((u,y)=>(u.add(y),u),new Set),removed:new Set,updated:new Set},d={added:{},removed:[],updated:{}},v=I.$Hm(P),c=!S;for(const u of h.added.values())u!==T.$8eb&&c&&m.added.has(u)||(v[u]=L[u]);for(const u of h.updated.values())v[u]=L[u];for(const u of h.removed.values())b.unregistered.includes(u)||delete v[u];for(const u of m.added.values()){const y=P[u];if(b.machine.includes(u)){C.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(S&&h.added.has(u))continue;const p=L[u];p&&p.value===y.value||u===T.$8eb&&c&&h.added.has(u)||(p?d.updated[u]=y:d.added[u]=y)}for(const u of m.updated.values()){const y=P[u];if(b.machine.includes(u)){C.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(u)||h.removed.has(u))continue;const p=L[u];p&&p.value===y.value||(d.updated[u]=y)}for(const u of m.removed.values()){if(b.machine.includes(u)){C.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}h.updated.has(u)||h.removed.has(u)||d.removed.push(u)}const l=j(P,v);return{local:d,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:v}}}e.$Tyb=O;function j(L,P){const S=Object.keys(L),b=Object.keys(P),C=b.filter(h=>!S.includes(h)).reduce((h,d)=>(h.add(d),h),new Set),E=S.filter(h=>!b.includes(h)).reduce((h,d)=>(h.add(d),h),new Set),m=new Set;for(const h of S){if(E.has(h))continue;const d=L[h],v=P[h];I.$Lm(d,v)||m.add(h)}return{added:C,removed:E,updated:m}}}),define(oe[233],ae([0,1,21,34,83,41,30,75,23]),function(ne,e,I,T,O,j,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mxb=e.$Lxb=e.$Kxb=e.$Jxb=e.$Ixb=e.$Hxb=void 0;function b(a,w,g){let f=[];g?f=E(g):f=C(w);const k=[],A=[...(0,S.$Peb)()];if(Array.isArray(f))for(const M of f)M.startsWith("-")?A.push(M.substring(1)):k.push(M);return(0,I.$rf)([...a,...k].filter(M=>!A.includes(M)))}e.$Hxb=b;function C(a){let w=a.inspect("settingsSync.ignoredSettings").userValue;return w!==void 0||(w=a.inspect("sync.ignoredSettings").userValue,w!==void 0)?w:a.getValue("settingsSync.ignoredSettings")||[]}function E(a){const w=(0,T.$xm)(a);return w?w["settingsSync.ignoredSettings"]||w["sync.ignoredSettings"]||[]:[]}function m(a,w){const g=(0,T.$xm)(a)||{};let f="{}";for(const k of Object.keys(g)){const A=(0,O.$$R)(f,[k],g[k],w);f=(0,O.$bS)(f,A)}return f}e.$Ixb=m;function h(a,w,g,f){if(g.length){const k=r(w),A=(0,T.$xm)(w)||{},M=(0,T.$xm)(a);if(!M)return a;const F=[];for(const V of g){const B=A[V],x=M[V];B===void 0?a=P.edit(a,[V],void 0,f):x!==void 0?a=P.edit(a,[V],B,f):F.push(t(V,k))}F.sort((V,B)=>V.startOffset-B.startOffset),F.forEach(V=>a=u(V.setting.key,w,a,f))}return a}e.$Jxb=h;function d(a,w,g,f,k,A){const M=h(a,w,f,A),F=g!==M,V=g!==w;if(!F&&!V)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!V)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(V&&!F)return{conflictsSettings:[],localContent:h(w,a,f,A),remoteContent:null,hasConflicts:!1};if(g===null&&c(a)){const D=v(a,w,f)?null:h(w,a,f,A);return{conflictsSettings:[],localContent:D,remoteContent:null,hasConflicts:!1}}let B=a,x=w;const Z=(0,T.$xm)(a),Q=(0,T.$xm)(w),J=g?(0,T.$xm)(g):null,X=f.reduce((D,z)=>(D.add(z),D),new Set),W=l(Z,Q,X),U=l(J,Z,X),q=l(J,Q,X),te=new Map,re=new Set,ce=D=>{re.add(D);const z=k.filter(({key:K})=>K===D)[0];z?(B=P.edit(B,[D],z.value,A),x=P.edit(x,[D],z.value,A)):te.set(D,{key:D,localValue:Z[D],remoteValue:Q[D]})};for(const D of U.removed.values())q.updated.has(D)?ce(D):x=P.edit(x,[D],void 0,A);for(const D of q.removed.values())re.has(D)||(U.updated.has(D)?ce(D):B=P.edit(B,[D],void 0,A));for(const D of U.updated.values())re.has(D)||(q.updated.has(D)?W.updated.has(D)&&ce(D):x=P.edit(x,[D],Z[D],A));for(const D of q.updated.values())re.has(D)||(U.updated.has(D)?W.updated.has(D)&&ce(D):B=P.edit(B,[D],Q[D],A));for(const D of U.added.values())re.has(D)||(q.added.has(D)?W.updated.has(D)&&ce(D):x=u(D,B,x,A));for(const D of q.added.values())re.has(D)||(U.added.has(D)?W.updated.has(D)&&ce(D):B=u(D,x,B,A));const G=te.size>0||!v(B,x,f),N=G||!v(B,a,[]),$=G||!v(x,w,[]);return{localContent:N?B:null,remoteContent:$?x:null,conflictsSettings:[...te.values()],hasConflicts:G}}e.$Kxb=d;function v(a,w,g){if(a===w)return!0;const f=(0,T.$xm)(a),k=(0,T.$xm)(w),A=g.reduce((V,B)=>(V.add(B),V),new Set),M=r(a).filter(V=>!(V.setting&&A.has(V.setting.key))),F=r(w).filter(V=>!(V.setting&&A.has(V.setting.key)));if(M.length!==F.length)return!1;for(let V=0;V<M.length;V++){const B=M[V],x=F[V];if(B.setting&&x.setting){if(B.setting.key!==x.setting.key||!L.$Lm(f[B.setting.key],k[B.setting.key]))return!1}else if(!B.setting&&!x.setting){if(B.value!==x.value)return!1}else return!1}return!0}function c(a){return a?r(a).length===0:!0}e.$Lxb=c;function l(a,w,g){const f=a?Object.keys(a).filter(V=>!g.has(V)):[],k=Object.keys(w).filter(V=>!g.has(V)),A=k.filter(V=>!f.includes(V)).reduce((V,B)=>(V.add(B),V),new Set),M=f.filter(V=>!k.includes(V)).reduce((V,B)=>(V.add(B),V),new Set),F=new Set;if(a)for(const V of f){if(M.has(V))continue;const B=a[V],x=w[V];L.$Lm(B,x)||F.add(V)}return{added:A,removed:M,updated:F}}function u(a,w,g,f){const k=(0,T.$xm)(w),A=r(w),M=r(g),F=y(a,A,M);return p(g,a,k[a],F,M,f)}e.$Mxb=u;function y(a,w,g){const f=w.findIndex(A=>A.setting?.key===a),k=w[f-1];if(k){if(k.setting){const M=t(k.setting.key,g);if(M)return{index:g.indexOf(M),insertAfter:!0}}else{const M=o(f,w);if(M){const F=t(M.setting.key,g);if(F){const V=n(g.indexOf(F),g),B=s(w,M,w[f]);if(V){const x=s(g,F,V),Z=i(B,x);return Z?{index:g.indexOf(Z),insertAfter:!0}:{index:g.indexOf(V),insertAfter:!1}}else{const x=s(g,F,g[g.length-1]),Z=i(B,x);return Z?{index:g.indexOf(Z),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const A=w[f+1];if(A)if(A.setting){const M=t(A.setting.key,g);if(M)return{index:g.indexOf(M),insertAfter:!1}}else{const M=n(f,w);if(M){const F=t(M.setting.key,g);if(F){const V=o(g.indexOf(F),g),B=s(w,w[f],M);if(V){const x=s(g,V,F),Z=i(B.reverse(),x.reverse());return Z?{index:g.indexOf(Z),insertAfter:!1}:{index:g.indexOf(V),insertAfter:!0}}else{const x=s(g,g[0],F),Z=i(B.reverse(),x.reverse());return Z?{index:g.indexOf(Z),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function p(a,w,g,f,k,A){let M;return f.index===-1?M=(0,O.$$R)(a,[w],g,A):M=R(a,w,g,f,k,A).map(F=>(0,O.$_R)(a,F,A)[0]),(0,O.$bS)(a,M)}function R(a,w,g,f,k,A){const M=`${JSON.stringify(w)}: ${JSON.stringify(g)}`,F=(0,j.$8R)(A,a),V=k[f.index];if(f.insertAfter){const B=[];if(V.setting)B.push({offset:V.endOffset,length:0,content:","+M});else{const x=n(f.index,k),Z=o(f.index,k),Q=Z?.setting?.commaOffset;Z&&Q===void 0&&B.push({offset:Z.endOffset,length:0,content:","});const J=Q!==void 0&&Q>V.endOffset;B.push({offset:J?Q+1:V.endOffset,length:0,content:x?F+M+",":F+M})}return B}else{if(V.setting)return[{offset:V.startOffset,length:0,content:M+","}];const B=(k[f.index-1]&&!k[f.index-1].setting?F:"")+M+(n(f.index,k)?",":"")+F;return[{offset:V.startOffset,length:0,content:B}]}}function t(a,w){return w.filter(g=>g.setting?.key===a)[0]}function o(a,w){for(let g=a-1;g>=0;g--)if(w[g].setting)return w[g]}function n(a,w){for(let g=a+1;g<w.length;g++)if(w[g].setting)return w[g]}function s(a,w,g){const f=a.indexOf(w),k=a.indexOf(g);return a.filter((A,M)=>f<M&&M<k)}function i(a,w){if(a.length&&w.length){let g=0;for(;g<w.length&&g<a.length;g++)if(a[g].value!==w[g].value)return w[g-1];return w[g-1]}}function r(a){const w=[];let g=-1,f,k;const A={onObjectBegin:M=>{g++},onObjectProperty:(M,F,V)=>{g===0&&(f=F,k=M)},onObjectEnd:(M,F)=>{g--,g===0&&w.push({startOffset:f,endOffset:M+F,value:a.substring(f,M+F),setting:{key:k,commaOffset:void 0}})},onArrayBegin:(M,F)=>{g++},onArrayEnd:(M,F)=>{g--,g===0&&w.push({startOffset:f,endOffset:M+F,value:a.substring(f,M+F),setting:{key:k,commaOffset:void 0}})},onLiteralValue:(M,F,V)=>{g===0&&w.push({startOffset:f,endOffset:F+V,value:a.substring(f,F+V),setting:{key:k,commaOffset:void 0}})},onSeparator:(M,F,V)=>{if(g===0&&M===","){let B=w.length-1;for(;B>=0&&!w[B].setting;B--);const x=w[B];x&&w.splice(B,1,{startOffset:x.startOffset,endOffset:x.endOffset,value:x.value,setting:{key:x.setting.key,commaOffset:F}})}},onComment:(M,F)=>{g===0&&w.push({startOffset:M,endOffset:M+F,value:a.substring(M,M+F)})}};return(0,T.$Em)(a,A),w}}),define(oe[76],ae([0,1,3,2,4,23]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sxb=e.$rxb=void 0,e.$rxb=(0,O.$ph)("IUserDataSyncAccountService");let L=class extends T.$lb{get account(){return this.a}constructor(S,b){super(),this.g=S,this.h=b,this.b=this.B(new I.$8c),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$8c),this.onTokenFailed=this.c.event,this.f=!1,this.B(S.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(S.onTokenSucceed(()=>this.f=!1))}async updateAccount(S){(S&&this.a?S.token!==this.a.token||S.authenticationProviderId!==this.a.authenticationProviderId:S!==this.a)&&(this.a=S,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(S))}};e.$sxb=L,e.$sxb=L=we([Y(0,j.$Zeb),Y(1,j.$cfb)],L)}),define(oe[234],ae([0,1,2,10]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N5b=e.$M5b=e.$L5b=e.$K5b=e.$J5b=e.$I5b=e.$H5b=void 0;class O{constructor(m){this.a=m}listen(m,h){switch(h){case"onError":return this.a.onError}throw new Error(`Event not found: ${h}`)}call(m,h,d){switch(h){case"triggerSync":return this.a.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(d[0])}throw new Error("Invalid call")}}e.$H5b=O;class j{constructor(m){this.a=m}listen(m,h){throw new Error(`Event not found: ${h}`)}call(m,h,d){switch(h){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(T.URI.revive(d[0]))}throw new Error("Invalid call")}}e.$I5b=j;class L{constructor(m){this.a=m}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.a.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.a.call("resolveFormattingOptions",[m])}}e.$J5b=L;class P{constructor(m){this.a=m}listen(m,h){switch(h){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${h}`)}async call(m,h,d){switch(h){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(d[0],d[1]);case"setEnablements":return this.a.setEnablements(d)}throw new Error("Invalid call")}}e.$K5b=P;class S{constructor(m){this.a=m}listen(m,h){switch(h){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${h}`)}call(m,h,d){switch(h){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(d)}throw new Error("Invalid call")}}e.$L5b=S;class b{constructor(m){this.a=m}listen(m,h){switch(h){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${h}`)}call(m,h,d){switch(h){case"switch":return this.a.switch(d[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$M5b=b;class C extends I.$lb{constructor(m){super(),this.a=m,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.a.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.a.call("getPreviousUserDataSyncStore");return this.b(m)}b(m){return{url:T.URI.revive(m.url),type:m.type,defaultUrl:T.URI.revive(m.defaultUrl),insidersUrl:T.URI.revive(m.insidersUrl),stableUrl:T.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.$N5b=C}),define(oe[235],ae([0,1,171,8,23]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zzb=void 0;let j=class extends T.$Wi{constructor(P){super(),this.g=this.B(P.createLogger(O.$dfb,{name:(0,I.localize)(0,null)}))}trace(P,...S){this.g.trace(P,...S)}debug(P,...S){this.g.debug(P,...S)}info(P,...S){this.g.info(P,...S)}warn(P,...S){this.g.warn(P,...S)}error(P,...S){this.g.error(P,...S)}flush(){this.g.flush()}};e.$zzb=j,e.$zzb=j=we([Y(0,T.$Si)],j)}),define(oe[236],ae([0,1,6,3,2]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L4b=void 0;class j extends O.$lb{constructor({onDidOpenWindow:P,onDidFocusWindow:S,getActiveWindowId:b}){super(),this.a=this.B(new O.$kb),T.Event.latch(T.Event.any(P,S))(this.f,this,this.a),this.b=(0,I.$jg)(()=>b()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$L4b=j}),define(oe[112],ae([0,1,174,16,47,22,10,4,26]),function(ne,e,I,T,O,j,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.WorkbenchState=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$yh=(0,P.$ph)("contextService");function b(s){const i=s;return typeof i?.id=="string"&&L.URI.isUri(i.uri)}e.$zh=b;function C(s){return typeof s?.id=="string"&&!b(s)&&!m(s)}e.$Ah=C,e.$Bh={id:"ext-dev"},e.$Ch={id:"empty-window"};function E(s,i){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,T.$ec)(s)}:i?e.$Bh:e.$Ch;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$Dh=E;function m(s){const i=s;return typeof i?.id=="string"&&L.URI.isUri(i.configPath)}e.$Eh=m;function h(s){const i=s;if(i?.uri)return{id:i.id,uri:L.URI.revive(i.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:L.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.$Fh=h;var d;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function v(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.$Gh=v;function c(s){const i=s;return!!(i&&typeof i=="object"&&L.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.$Hh=c;class l{constructor(i,r,a,w,g){this.h=i,this.j=a,this.k=w,this.l=g,this.c=O.$vh.forUris(this.l,()=>!0),this.folders=r}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=O.$vh.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ih=l;class u{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,j.$0f)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Jh=u;function y(s){return new u({uri:s,index:0,name:(0,j.$6f)(s)},{uri:s.toString()})}e.$Kh=y,e.$Lh="code-workspace",e.$Mh=`.${e.$Lh}`,e.$Nh=[{name:(0,I.localize)(0,null),extensions:[e.$Lh]}],e.$Oh="workspace.json";function p(s,i){return j.$1f.isEqualOrParent(s,i.untitledWorkspacesHome)}e.$Ph=p;function R(s){let i;return L.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===S.Schemas.tmp}e.$Qh=R,e.$Rh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$Rh}e.$Sh=t;function o(s,i){return!p(s,i)&&!R(s)}e.$Th=o;function n(s){return(typeof s=="string"?(0,T.$fc)(s):(0,j.$8f)(s))===e.$Mh}e.$Uh=n}),define(oe[17],ae([0,1,51,3,2,22,10,165,15,13,4,8,112,35,28,6,32,27,11]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.ProfileResourceType=void 0;var y;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(y||(e.ProfileResourceType=y={}));function p(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&L.URI.isUri(i.location)&&L.URI.isUri(i.globalStorageHome)&&L.URI.isUri(i.settingsResource)&&L.URI.isUri(i.keybindingsResource)&&L.URI.isUri(i.tasksResource)&&L.URI.isUri(i.snippetsHome)&&L.URI.isUri(i.extensionsResource))}e.$qk=p,e.$rk=(0,C.$ph)("IUserDataProfilesService");function R(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:L.URI.revive(s.location).with({scheme:i}),globalStorageHome:L.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:L.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:L.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:L.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:L.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:L.URI.revive(s.extensionsResource).with({scheme:i}),cacheHome:L.URI.revive(s.cacheHome).with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$sk=R;function t(s,i,r,a,w,g){return{id:s,name:i,location:r,isDefault:!1,shortName:w?.shortName,globalStorageHome:g&&w?.useDefaultFlags?.globalState?g.globalStorageHome:(0,j.$0f)(r,"globalStorage"),settingsResource:g&&w?.useDefaultFlags?.settings?g.settingsResource:(0,j.$0f)(r,"settings.json"),keybindingsResource:g&&w?.useDefaultFlags?.keybindings?g.keybindingsResource:(0,j.$0f)(r,"keybindings.json"),tasksResource:g&&w?.useDefaultFlags?.tasks?g.tasksResource:(0,j.$0f)(r,"tasks.json"),snippetsHome:g&&w?.useDefaultFlags?.snippets?g.snippetsHome:(0,j.$0f)(r,"snippets"),extensionsResource:g&&w?.useDefaultFlags?.extensions?g.extensionsResource:(0,j.$0f)(r,"extensions.json"),cacheHome:(0,j.$0f)(a,s),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}e.$tk=t;let o=class extends O.$lb{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,r,a,w){super(),this.n=i,this.r=r,this.s=a,this.t=w,this.f=!0,this.h=this.B(new T.$8c),this.onDidChangeProfiles=this.h.event,this.i=this.B(new T.$8c),this.onWillCreateProfile=this.i.event,this.j=this.B(new T.$8c),this.onWillRemoveProfile=this.j.event,this.k=this.B(new T.$8c),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new h.$ni,emptyWindows:new Map},this.profilesHome=(0,j.$0f)(this.n.userRoamingDataHome,"profiles"),this.g=(0,j.$0f)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=this.w(),r=[i];if(this.f)try{for(const g of this.J()){if(!g.name||!(0,u.$je)(g.name)||!g.location){this.t.warn("Skipping the invalid stored profile",g.location||g.name);continue}r.push(t((0,j.$7f)(g.location),g.name,g.location,this.g,{shortName:g.shortName,useDefaultFlags:g.useDefaultFlags},i))}}catch(g){this.t.error(g)}const a=new h.$ni,w=new Map;if(r.length)try{const g=this.M();if(g.workspaces)for(const[f,k]of Object.entries(g.workspaces)){const A=L.URI.parse(f),M=r.find(F=>F.id===k);M&&a.set(A,M)}if(g.emptyWindows)for(const[f,k]of Object.entries(g.emptyWindows)){const A=r.find(M=>M.id===k);A&&w.set(f,A)}}catch(g){this.t.error(g)}this.u={profiles:r,workspaces:a,emptyWindows:w}}return this.u}w(){const i=t("__default__profile__",(0,P.localize)(0,null),this.n.userRoamingDataHome,this.g);return{...i,extensionsResource:this.O()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const r="Temp",a=new RegExp(`${(0,l.$od)(r)}\\s(\\d+)`);let w=0;for(const f of this.profiles){const k=a.exec(f.name),A=k?parseInt(k[1]):0;w=A>w?A:w}const g=`${r} ${w+1}`;return this.createProfile((0,I.$di)((0,c.$6e)()).toString(16),g,{transient:!0},i)}async createNamedProfile(i,r,a){return this.createProfile((0,I.$di)((0,c.$6e)()).toString(16),i,r,a)}async createProfile(i,r,a,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=await this.y(i,r,a);return w&&await this.setProfileForWorkspace(w,g),g}async y(i,r,a){if(!(0,u.$je)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.l.get(r);return w||(w=(async()=>{try{const g=this.profiles.find(A=>A.name===r||A.id===i);if(g)return g;const f=t(i,r,(0,j.$0f)(this.profilesHome,i),this.g,a,this.defaultProfile);await this.r.createFolder(f.location);const k=[];return this.i.fire({profile:f,join(A){k.push(A)}}),await v.Promises.settled(k),this.D([f],[],[]),f}finally{this.l.delete(r)}})(),this.l.set(r,w)),w}async updateProfile(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(w=>w.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=t(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.D([],[],[a]),a}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(w=>w.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this.j.fire({profile:r,join(w){a.push(w)}});try{await Promise.allSettled(a)}catch(w){this.t.error(w)}for(const w of[...this.v.emptyWindows.keys()])r.id===this.v.emptyWindows.get(w)?.id&&this.v.emptyWindows.delete(w);for(const w of[...this.v.workspaces.keys()])r.id===this.v.workspaces.get(w)?.id&&this.v.workspaces.delete(w);this.H(),this.D([],[r],[]);try{await this.r.del(r.cacheHome,{recursive:!0})}catch(w){(0,b.$9j)(w)!==1&&this.t.error(w)}}async setProfileForWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(w=>w.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.G(i,a)}unsetWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,r)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.s.extUri.isEqual(a.location,r.resource))).map(r=>this.r.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(r=>!this.C(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.z(i);return L.URI.isUri(r)?this.m.workspaces.get(r)??this.v.workspaces.get(r):this.m.emptyWindows.get(r)??this.v.emptyWindows.get(r)}z(i){return(0,m.$zh)(i)?i.uri:(0,m.$Eh)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.m.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.v.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.v.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,i.location)))}D(i,r,a){const w=[...this.profiles,...i],g=[];this.m.profiles=[];for(let f of w)f.isDefault||r.some(k=>f.id===k.id)||(f=a.find(k=>f.id===k.id)??f,f.isTransient?this.m.profiles.push(f):g.push({location:f.location,name:f.name,shortName:f.shortName,useDefaultFlags:f.useDefaultFlags}));this.L(g),this.u=void 0,this.F(i,r,a)}F(i,r,a){this.h.fire({added:i,removed:r,updated:a,all:this.profiles})}G(i,r,a){a=r?.isTransient?!0:a,a||this.G(i,void 0,!0);const w=this.z(i),g=a?this.m:this.v;L.URI.isUri(w)?(g.workspaces.delete(w),r&&g.workspaces.set(w,r)):(g.emptyWindows.delete(w),r&&g.emptyWindows.set(w,r)),a||this.H()}H(){const i={};for(const[a,w]of this.v.workspaces.entries())i[a.toString()]=w.id;const r={};for(const[a,w]of this.v.emptyWindows.entries())r[a.toString()]=w.id;this.N({workspaces:i,emptyWindows:r}),this.u=void 0}I(i){const r={},a=this.w();if(i.workspaces)for(const[g,f]of Object.entries(i.workspaces)){const k=L.URI.parse(f);r[g]=this.s.extUri.isEqual(k,a.location)?a.id:this.s.extUri.basename(k)}const w={};if(i.emptyWindows)for(const[g,f]of Object.entries(i.emptyWindows)){const k=L.URI.parse(f);w[g]=this.s.extUri.isEqual(k,a.location)?a.id:this.s.extUri.basename(k)}return{workspaces:r,emptyWindows:w}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};e.$uk=o,e.$uk=o=we([Y(0,S.$wh),Y(1,b.$Sj),Y(2,d.$pk),Y(3,E.$Ri)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.$vk=n}),define(oe[237],ae([0,1,6,2,17]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V5b=void 0;let j=class extends T.$lb{constructor(P){super(),this.B(new I.$Gg(()=>{P.cleanUp()},10*1e3)).schedule()}};e.$V5b=j,e.$V5b=j=we([Y(0,O.$rk)],j)}),define(oe[238],ae([0,1,21,6,25,7,3,2,5,11,10,148,29,33,45,8,24,20,28,17]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=void 0;let p=class extends P.$lb{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}get onDidUpdateExtensionMetadata(){return this.s.event}constructor(i,r,a,w,g,f){super(),this.u=i,this.v=r,this.w=a,this.y=w,this.z=g,this.C=f,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new L.$8c),this.m=this.B(new L.$8c),this.n=this.B(new L.$8c),this.p=this.B(new L.$8c),this.s=this.B(new L.$8c),this.t=[],this.B((0,P.$jb)(()=>{this.j.forEach(({task:k})=>k.cancel()),this.k.forEach(k=>k.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(a=>(0,m.$Mn)(a,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{const w=(await this.installGalleryExtensions([{extension:i,options:r}])).find(({identifier:g})=>(0,h.$fo)(g,i.identifier));if(w?.local)return w?.local;throw w?.error?w.error:t(new Error(`Unknown error while installing extension ${i.identifier.id}`))}catch(a){throw t(a)}}async installGalleryExtensions(i){if(!this.u.isEnabled())throw new m.$Qn(E.localize(0,null),m.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(i.map(async({extension:w,options:g})=>{try{const f=await this.J(w,!!g?.installGivenVersion,!!g?.installPreReleaseVersion);a.push({...f,options:g})}catch(f){r.push({identifier:w.identifier,operation:2,source:w,error:f})}})),a.length&&r.push(...await this.D(a));for(const w of r)w.error&&(this.y.error("Failed to install extension.",w.identifier.id),this.y.error(w.error),w.source&&!C.URI.isUri(w.source)&&o(this.v,"extensionGallery:install",{extensionData:(0,h.$no)(w.source),error:w.error}));return r}async uninstall(i,r={}){return this.y.trace("ExtensionManagementService#uninstall",i.identifier.id),this.M(i,r)}async toggleAppliationScope(i,r){if((0,d.$Kl)(i.manifest))return i;if(i.isApplicationScoped){let a=await this.updateMetadata(i,{isApplicationScoped:!1},this.C.defaultProfile.extensionsResource);this.w.extUri.isEqual(r,this.C.defaultProfile.extensionsResource)||(a=await this.X(i,this.C.defaultProfile.extensionsResource,r));for(const w of this.C.profiles){const g=(await this.getInstalled(1,w.extensionsResource)).find(f=>(0,h.$fo)(f.identifier,i.identifier));g?this.s.fire(g):this.p.fire({identifier:i.identifier,profileLocation:w.extensionsResource})}return a}else{const a=this.w.extUri.isEqual(r,this.C.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.C.defaultProfile.extensionsResource):await this.X(i,r,this.C.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.m.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.C.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.R(),this.h=i),this.g}registerParticipant(i){this.t.push(i)}async D(i){const r=[];return await Promise.allSettled(i.map(async a=>{try{const w=await this.F(a);r.push(...w)}catch(w){r.push({identifier:{id:(0,h.$ko)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:w})}})),this.m.fire(r),r}async F({manifest:i,extension:r,options:a}){const w=a.isApplicationScoped||a.isBuiltin||(0,d.$Kl)(i),g={...a,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:w,profileLocation:w?this.C.defaultProfile.extensionsResource:a.profileLocation??this.S()},f=B=>`${h.$go.create(B).toString()}${g.profileLocation?`-${g.profileLocation.toString()}`:""}`;if(!C.URI.isUri(r)){const B=this.j.get(f(r));if(B)return this.y.info("Extensions is already requested to install",r.identifier.id),await B.task.waitUntilTaskIsFinished(),[]}const k=[],A=[],M=[],F=this.U(i,r,g);C.URI.isUri(r)||this.j.set(f(r),{task:F,waitingTasks:[]}),this.l.fire({identifier:F.identifier,source:r,profileLocation:g.profileLocation}),this.y.info("Installing extension:",F.identifier.id),k.push({task:F,manifest:i});let V=!1;try{if(g.donotIncludePackAndDependencies)this.y.info("Installing the extension without checking dependencies and pack",F.identifier.id);else try{const x=await this.I(F.identifier,i,!!g.installOnlyNewlyAddedFromExtensionPack,!!g.installPreReleaseVersion,g.profileLocation),Z=await this.getInstalled(void 0,g.profileLocation);for(const{gallery:Q,manifest:J}of(0,I.$rf)(x,({gallery:X})=>X.identifier.id)){V=V||!!J.extensionDependencies?.some(U=>(0,h.$fo)({id:U},F.identifier));const X=f(Q),W=this.j.get(X);if(W){if(this.G(F,W.task)){const U=W.task.identifier;this.y.info("Waiting for already requested installing extension",U.id,F.identifier.id),W.waitingTasks.push(F),A.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,q=>q.some(te=>(0,h.$fo)(te.identifier,U)))).then(q=>{if(this.y.info("Finished waiting for already requested installing extension",U.id,F.identifier.id),!q.find(re=>(0,h.$fo)(re.identifier,U))?.local)throw new Error(`Extension ${U.id} is not installed`)}))}}else if(!Z.some(({identifier:U})=>(0,h.$fo)(U,Q.identifier))){const U=this.U(J,Q,{...g,donotIncludePackAndDependencies:!0});this.j.set(X,{task:U,waitingTasks:[F]}),this.l.fire({identifier:U.identifier,source:Q,profileLocation:g.profileLocation}),this.y.info("Installing extension:",U.identifier.id,F.identifier.id),k.push({task:U,manifest:J})}}}catch(x){if(C.URI.isUri(F.source))(0,I.$qf)(i.extensionDependencies)&&this.y.warn("Cannot install dependencies of extension:",F.identifier.id,x.message),(0,I.$qf)(i.extensionPack)&&this.y.warn("Cannot install packed extensions of extension:",F.identifier.id,x.message);else throw this.y.error("Error while preparing to install dependencies and extension packs of the extension:",F.identifier.id),x}const B=k.reduce((x,{task:Z,manifest:Q})=>(x.set(Z.identifier.id.toLowerCase(),{task:Z,manifest:Q}),x),new Map);for(;B.size;){let x;const Z=[...B.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(J=>B.has(J.toLowerCase())));Z.length?x=B.size===1?Z:Z.filter(({task:Q})=>!(Q===F&&!V)):(this.y.info("Found extensions with circular dependencies",Z.map(({task:Q})=>Q.identifier.id)),x=[...B.values()]),await this.H(x.map(async({task:Q})=>{const J=new Date().getTime();try{const X=await Q.run();if(await this.H(this.t.map(W=>W.postInstall(X,Q.source,g,O.CancellationToken.None))),!C.URI.isUri(Q.source)){const W=Q.operation===3,U=W?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(o(this.v,W?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$no)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-J,durationSinceUpdate:U}),S.$o&&Q.operation!==3)try{await this.u.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}M.push({local:X,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:g.context,profileLocation:Q.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw C.URI.isUri(Q.source)||o(this.v,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$no)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-J,error:X}),this.y.error("Error while installing the extension:",Q.identifier.id),X}finally{B.delete(Q.identifier.id.toLowerCase())}}))}return A.length&&await this.H(A),M.forEach(({identifier:x})=>this.y.info("Extension installed successfully:",x.id)),M}catch(B){if(k.forEach(({task:x})=>x.cancel()),M.length)try{const x=await Promise.allSettled(M.map(({local:Z})=>this.W(Z,{versionOnly:!0,profileLocation:g.profileLocation}).run()));for(let Z=0;Z<x.length;Z++){const Q=x[Z],{identifier:J}=M[Z];Q.status==="fulfilled"?this.y.info("Rollback: Uninstalled extension",J.id):this.y.warn("Rollback: Error while uninstalling extension",J.id,(0,j.$9)(Q.reason))}}catch(x){this.y.warn("Error while rolling back extensions",(0,j.$9)(x),M.map(({identifier:Z})=>Z.id))}return k.map(({task:x})=>({identifier:x.identifier,operation:2,source:x.source,context:g.context,profileLocation:g.profileLocation,error:B}))}finally{for(const{task:B}of k)B.source&&!C.URI.isUri(B.source)&&this.j.delete(f(B.source))}}G(i,r){for(const[,{task:a,waitingTasks:w}]of this.j.entries())if(a===i&&(w.includes(r)||w.some(g=>this.G(g,r)))||a===r&&w[0]&&!this.G(i,w[0]))return!1;return!0}async H(i){const r=[],a=[],w=await Promise.allSettled(i);for(const g of w)g.status==="fulfilled"?r.push(g.value):a.push(g.reason);if(a.length)throw R(a);return r}async I(i,r,a,w,g){if(!this.u.isEnabled())return[];const f=await this.getInstalled(void 0,g),k=[],A=[],M=async(F,V)=>{k.push(F);const B=V.extensionDependencies||[],x=[...B];if(V.extensionPack){const Z=a?f.find(Q=>(0,h.$fo)(Q.identifier,F)):void 0;for(const Q of V.extensionPack)Z&&Z.manifest.extensionPack&&Z.manifest.extensionPack.some(J=>(0,h.$fo)({id:J},{id:Q}))||x.every(J=>!(0,h.$fo)({id:J},{id:Q}))&&x.push(Q)}if(x.length){const Z=x.filter(Q=>k.every(J=>!(0,h.$fo)(J,{id:Q})));if(Z.length){const Q=await this.u.getExtensions(Z.map(J=>({id:J,preRelease:w})),O.CancellationToken.None);for(const J of Q){if(k.find(U=>(0,h.$fo)(U,J.identifier)))continue;const X=B.some(U=>(0,h.$fo)({id:U},J.identifier));let W;try{W=await this.J(J,!1,w)}catch(U){if(X)throw U;this.y.info("Skipping the packed extension as it cannot be installed",J.identifier.id,(0,j.$9)(U));continue}A.push({gallery:W.extension,manifest:W.manifest}),await M(W.extension.identifier,W.manifest)}}}};return await M(i,r),A}async J(i,r,a){let w;const g=await this.getExtensionsControlManifest();if(g.malicious.some(A=>(0,h.$fo)(i.identifier,A)))throw new m.$Qn(E.localize(1,null,i.identifier.id),m.ExtensionManagementErrorCode.Malicious);const f=g.deprecated[i.identifier.id.toLowerCase()];if(f?.extension?.autoMigrate){if(this.y.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${f.extension.id}' extension instead.`),w=(await this.u.getExtensions([{id:f.extension.id,preRelease:f.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},O.CancellationToken.None))[0],!w)throw new m.$Qn(E.localize(2,null,i.identifier.id,f.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const A=await this.getTargetPlatform();throw new m.$Qn(E.localize(3,null,i.identifier.id,this.z.nameLong,(0,m.$In)(A)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(w=await this.L(i,r,a),!w)throw!a&&i.properties.isPreReleaseVersion&&(await this.u.getExtensions([i.identifier],O.CancellationToken.None))[0]?new m.$Qn(E.localize(4,null,i.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$Qn(E.localize(5,null,i.identifier.id,this.z.nameLong,this.z.version),m.ExtensionManagementErrorCode.Incompatible)}this.y.info("Getting Manifest...",w.identifier.id);const k=await this.u.getManifest(w,O.CancellationToken.None);if(k===null)throw new m.$Qn(`Missing manifest for extension ${w.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(k.version!==w.version)throw new m.$Qn(`Cannot install '${w.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:w,manifest:k}}async L(i,r,a){const w=await this.getTargetPlatform();let g=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==a&&(g=(await this.u.getExtensions([{...i.identifier,preRelease:a}],{targetPlatform:w,compatible:!0},O.CancellationToken.None))[0]||null),!g&&await this.u.isExtensionCompatible(i,a,w)&&(g=i),g||(r?g=(await this.u.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:w,compatible:!0},O.CancellationToken.None))[0]||null:g=await this.u.getCompatibleExtension(i,a,w)),g}async M(i,r){const a={...r,profileLocation:i.isApplicationScoped?this.C.defaultProfile.extensionsResource:r.profileLocation??this.S()},w=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${i.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,g=this.k.get(w(i.identifier));if(g)return this.y.info("Extensions is already requested to uninstall",i.identifier.id),g.waitUntilTaskIsFinished();const f=F=>{const V=this.W(F,a);return this.k.set(w(V.extension.identifier),V),a.profileLocation?this.y.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.y.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.n.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),V},k=(F,V)=>{V?a.profileLocation?this.y.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),V.message):this.y.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,V.message):a.profileLocation?this.y.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.y.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),o(this.v,"extensionGallery:uninstall",{extensionData:(0,h.$mo)(F),error:V}),this.p.fire({identifier:F.identifier,error:V?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},A=[],M=[];try{A.push(f(i));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.y.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const V=this.P(i,F);for(const B of V)this.k.has(w(B.identifier))?this.y.info("Extensions is already requested to uninstall",B.identifier.id):A.push(f(B))}a.donotCheckDependents?this.y.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.N(A.map(V=>V.extension),F,i),await this.H(A.map(async V=>{try{if(await V.run(),await this.H(this.t.map(B=>B.postUninstall(V.extension,a,O.CancellationToken.None))),V.extension.identifier.uuid)try{await this.u.reportStatistic(V.extension.manifest.publisher,V.extension.manifest.name,V.extension.manifest.version,"uninstall")}catch{}k(V.extension)}catch(B){const x=B instanceof m.$Qn?B:new m.$Qn((0,j.$9)(B),m.ExtensionManagementErrorCode.Internal);throw k(V.extension,x),x}finally{M.push(V)}}))}catch(F){const V=F instanceof m.$Qn?F:new m.$Qn((0,j.$9)(F),m.ExtensionManagementErrorCode.Internal);for(const B of A){try{B.cancel()}catch{}M.includes(B)||k(B.extension,V)}throw V}finally{for(const F of A)this.k.delete(w(F.extension.identifier))||this.y.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}N(i,r,a){for(const w of i){const g=this.Q(w,r);if(g.length){const f=g.filter(k=>!i.some(A=>(0,h.$fo)(A.identifier,k.identifier)));if(f.length)throw new Error(this.O(w,f,a))}}}O(i,r,a){return a===i?r.length===1?E.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}P(i,r,a=[]){if(a.indexOf(i)!==-1)return[];a.push(i);const w=i.manifest.extensionPack?i.manifest.extensionPack:[];if(w.length){const g=r.filter(k=>!k.isBuiltin&&w.some(A=>(0,h.$fo)({id:A},k.identifier))),f=[];for(const k of g)f.push(...this.P(k,r,a));return[...g,...f]}return[]}Q(i,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(w=>(0,h.$fo)({id:w},i.identifier)))}async R(){try{this.y.trace("ExtensionManagementService.refreshReportedCache");const i=await this.u.getExtensionsControlManifest();return this.y.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.y.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$7o=p,e.$7o=p=we([Y(0,m.$Pn),Y(1,l.$Vk),Y(2,u.$pk),Y(3,v.$Ri),Y(4,c.$0i),Y(5,y.$rk)],p);function R(s){const i=Array.isArray(s)?s:[s];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$8o=R;function t(s){if(s instanceof m.$Qn)return s;const i=new m.$Qn(s.message,m.ExtensionManagementErrorCode.Internal);return i.stack=s.stack,i}e.$9o=t;function o(s,i,{extensionData:r,verificationStatus:a,duration:w,error:g,durationSinceUpdate:f}){let k,A;(0,b.$re)(a)&&(a===!0?a="Verified":(a===!1||(k=m.ExtensionManagementErrorCode.Signature,A=a),a="Unverified")),g&&(g instanceof m.$Qn?(k=g.code,g.code===m.ExtensionManagementErrorCode.Signature&&(A=g.message)):k=m.ExtensionManagementErrorCode.Internal),s.publicLog(i,{...r,verificationStatus:a,success:!g,duration:w,errorcode:k,errorcodeDetail:A,durationSinceUpdate:f})}class n{constructor(){this.d=new T.$ug}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,T.$jg)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,T.$jg)(i=>new Promise((r,a)=>{const w=i.onCancellationRequested(()=>{w.dispose(),a(new j.$3)})})),this.d.open()),this.g.cancel()}}e.$0o=n}),define(oe[50],ae([0,1,6,14,2,3,35,10,29,33,13,4,8,17,28,11,7,20]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=e.$_o=e.$$o=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class y extends Error{constructor(n,s){super(n),this.code=s}}e.$$o=y,e.$_o=(0,E.$ph)("IExtensionsProfileScannerService");let p=class extends O.$lb{constructor(n,s,i,r,a,w){super(),this.i=n,this.j=s,this.k=i,this.l=r,this.m=a,this.n=w,this.b=this.B(new j.$8c),this.onAddExtensions=this.b.event,this.c=this.B(new j.$8c),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$8c),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$8c),this.onDidRemoveExtensions=this.g.event,this.h=new L.$ni}scanProfileExtensions(n,s){return this.p(n,void 0,s)}async addExtensionsToProfile(n,s){const i=[],r=[];try{return await this.p(s,a=>{const w=[];for(const g of a)n.some(([f])=>(0,b.$fo)(f.identifier,g.identifier))?i.push(g):w.push(g);for(const[g,f]of n)if(!w.some(k=>(0,b.$fo)(k.identifier,g.identifier)&&k.version===g.manifest.version)){const k={identifier:g.identifier,version:g.manifest.version,location:g.location,metadata:f};r.push(k),w.push(k)}return r.length&&this.b.fire({extensions:r,profileLocation:s}),i.length&&this.f.fire({extensions:i,profileLocation:s}),w}),r.length&&this.c.fire({extensions:r,profileLocation:s}),i.length&&this.g.fire({extensions:i,profileLocation:s}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:s}),i.length&&this.g.fire({extensions:i,error:a,profileLocation:s}),a}}async updateMetadata(n,s){const i=[];return await this.p(s,r=>{const a=[];for(const w of r){const g=n.find(([f])=>(0,b.$fo)(f.identifier,w.identifier)&&f.manifest.version===w.version);g&&(w.metadata={...w.metadata,...g[1]},i.push(w)),a.push(w)}return a}),i}async removeExtensionFromProfile(n,s){const i=[];this.f.fire({extensions:i,profileLocation:s});try{await this.p(s,r=>{const a=[];for(const w of r)(0,b.$fo)(w.identifier,n.identifier)?i.push(w):a.push(w);return i.length&&this.f.fire({extensions:i,profileLocation:s}),a}),i.length&&this.g.fire({extensions:i,profileLocation:s})}catch(r){throw i.length&&this.g.fire({extensions:i,error:r,profileLocation:s}),r}}async p(n,s,i){return this.w(n).queue(async()=>{let r=[],a;try{const w=await this.j.readFile(n);a=JSON.parse(w.value.toString().trim()||"[]")}catch(w){if((0,C.$9j)(w)!==1)throw w;if(this.l.extUri.isEqual(n,this.k.defaultProfile.extensionsResource)&&(a=await this.v()),!a&&i?.bailOutWhenFileNotFound)throw new y((0,c.$9)(w),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.r(n);let w=!1;for(const g of a){R(g)||this.r(n);let f;if((0,v.$je)(g.relativeLocation)&&g.relativeLocation)f=this.t(g.relativeLocation);else if((0,v.$je)(g.location))f=this.t(g.location),w=!0,g.relativeLocation=g.location,g.location=f.toJSON();else{f=P.URI.revive(g.location);const k=this.s(f);k&&(w=!0,g.relativeLocation=k)}r.push({identifier:g.identifier,location:f,version:g.version,metadata:g.metadata})}w&&await this.j.writeFile(n,T.$Jb.fromString(JSON.stringify(a)))}if(s){r=s(r);const w=r.map(g=>({identifier:g.identifier,version:g.version,location:g.location.toJSON(),relativeLocation:this.s(g.location),metadata:g.metadata}));await this.j.writeFile(n,T.$Jb.fromString(JSON.stringify(w)))}return r})}r(n){const s=new y(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}s(n){return this.l.extUri.isEqual(this.l.extUri.dirname(n),this.i)?this.l.extUri.basename(n):void 0}t(n){return this.l.extUri.joinPath(this.i,n)}async v(){return this.u||(this.u=(async()=>{const n=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),s=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let i;try{i=(await this.j.readFile(n)).value.toString()}catch(a){if((0,C.$9j)(a)===1)return;throw a}this.n.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(i);Array.isArray(a)&&a.every(w=>R(w))?r=a:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.n.error(a)}if(r)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,T.$Jb.fromString(JSON.stringify(r)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",n.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$9j)(a)===3)this.n.info("Migration from old default profile location to new location is done by another window",n.toString(),this.k.defaultProfile.extensionsResource.toString());else throw a}try{await this.j.del(n)}catch(a){(0,C.$9j)(a)!==1&&this.n.error(a)}try{await this.j.del(s)}catch(a){(0,C.$9j)(a)!==1&&this.n.error(a)}return r})()),this.u}w(n){let s=this.h.get(n);return s||(s=new I.$Cg,this.h.set(n,s)),s}};e.$ap=p,e.$ap=p=we([Y(1,C.$Sj),Y(2,h.$rk),Y(3,d.$pk),Y(4,l.$Vk),Y(5,m.$Ri)],p);function R(o){return(0,v.$le)(o)&&(0,S.$On)(o.identifier)&&(t(o.location)||(0,v.$je)(o.location)&&o.location)&&((0,v.$qe)(o.relativeLocation)||(0,v.$je)(o.relativeLocation))&&o.version&&(0,v.$je)(o.version)}function t(o){return o?(0,v.$je)(o.path)&&(0,v.$je)(o.scheme):!1}}),define(oe[77],ae([0,1,21,6,30,14,7,34,135,2,26,16,5,22,53,88,11,10,151,15,33,45,65,13,4,8,24,3,62,50,17,28,179]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u,y,p,R,t,o,n,s,i,r,a,w,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.Translations=void 0;var A;(function(Q){function J(X,W){if(X===W)return!0;const U=Object.keys(X),q=new Set;for(const te of Object.keys(W))q.add(te);if(U.length!==q.size)return!1;for(const te of U){if(X[te]!==W[te])return!1;q.delete(te)}return q.size===0}Q.equals=J})(A||(e.Translations=A={})),e.$dp=(0,n.$ph)("IExtensionsScannerService");let M=class extends b.$lb{constructor(J,X,W,U,q,te,re,ce,G,N,$,D){super(),this.systemExtensionsLocation=J,this.userExtensionsLocation=X,this.l=W,this.m=U,this.n=q,this.r=te,this.s=re,this.t=ce,this.u=G,this.v=N,this.w=$,this.y=D,this.g=this.B(new r.$8c),this.onDidChangeCache=this.g.event,this.h=(0,h.$0f)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(B,this.m,this.h)),this.j=this.B(this.y.createInstance(B,this.m,this.h)),this.k=this.B(this.y.createInstance(V,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,p.$qo)(this.s,this.t)),this.z}async scanAllExtensions(J,X,W){const[U,q]=await Promise.all([this.scanSystemExtensions(J),this.scanUserExtensions(X)]),te=W?await this.scanExtensionsUnderDevelopment(J,[...U,...q]):[];return this.G(U,q,te,await this.getTargetPlatform(),!0)}async scanSystemExtensions(J){const X=[];X.push(this.H(!!J.useCache,J.language)),X.push(this.I(J.language,!!J.checkControlFile));const[W,U]=await Promise.all(X);return this.F([...W,...U],0,J,!1)}async scanUserExtensions(J){const X=J.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",X);const W=this.w.extUri.isEqual(J.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.L(X,!!J.profileLocation,1,!J.includeUninstalled,J.language,!0,W),q=J.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k;let te;try{te=await q.scanExtensions(U)}catch(re){if(re instanceof w.$$o&&re.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),te=await q.scanExtensions(U);else throw re}return te=await this.F(te,1,J,!0),this.t.trace("Scanned user extensions:",te.length),te}async scanExtensionsUnderDevelopment(J,X){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const W=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(U=>U.scheme===C.Schemas.file).map(async U=>{const q=await this.L(U,!1,1,!0,J.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(q)).map(re=>(re.type=X.find(ce=>(0,p.$fo)(ce.identifier,re.identifier))?.type??re.type,this.k.validate(re,q)))}))).flat();return this.F(W,"development",J,!0)}return[]}async scanExistingExtension(J,X,W){const U=await this.L(J,!1,X,!0,W.language,!0,void 0),q=await this.k.scanExtension(U);return!q||!W.includeInvalid&&!q.isValid?null:q}async scanOneOrMultipleExtensions(J,X,W){const U=await this.L(J,!1,X,!0,W.language,!0,void 0),q=await this.k.scanOneOrMultipleExtensions(U);return this.F(q,X,W,!0)}async scanMetadata(J){const X=(0,h.$0f)(J,"package.json"),W=(await this.s.readFile(X)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(J,X){const W=(0,h.$0f)(J,"package.json"),U=(await this.s.readFile(W)).value.toString(),q=JSON.parse(U);X.isMachineScoped=X.isMachineScoped||void 0,X.isBuiltin=X.isBuiltin||void 0,q.__metadata={...q.__metadata,...X},await this.s.writeFile((0,h.$0f)(J,"package.json"),j.$Jb.fromString(JSON.stringify(q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(J){if(J instanceof w.$$o&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw J}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const J=await this.scanUserExtensions({includeInvalid:!0});if(J.length)await this.r.addExtensionsToProfile(J.map(X=>[X,X.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,j.$Jb.fromString(JSON.stringify([])))}catch(X){(0,o.$9j)(X)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.$9)(X))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(J){this.t.error(J)}finally{this.C=void 0}})()),this.C}async F(J,X,W,U){return W.includeAllVersions||(J=this.G(X===0?J:void 0,X===1?J:void 0,X==="development"?J:void 0,await this.getTargetPlatform(),U)),W.includeInvalid||(J=J.filter(q=>q.isValid)),J.sort((q,te)=>{const re=E.$ec(q.location.fsPath),ce=E.$ec(te.location.fsPath);return re<ce?-1:re>ce?1:0})}G(J,X,W,U,q){const te=(ce,G,N)=>{if(ce.isValid&&!G.isValid)return!1;if(ce.isValid===G.isValid){if(q&&d.gt(ce.manifest.version,G.manifest.version))return this.t.debug(`Skipping extension ${G.location.path} with lower version ${G.manifest.version} in favour of ${ce.location.path} with version ${ce.manifest.version}`),!1;if(d.eq(ce.manifest.version,G.manifest.version)){if(ce.type===0)return this.t.debug(`Skipping extension ${G.location.path} in favour of system extension ${ce.location.path} with same version`),!1;if(ce.targetPlatform===U)return this.t.debug(`Skipping extension ${G.location.path} from different target platform ${G.targetPlatform}`),!1}}return N?this.t.warn(`Overwriting user extension ${ce.location.path} with ${G.location.path}.`):this.t.debug(`Overwriting user extension ${ce.location.path} with ${G.location.path}.`),!0},re=new R.$Jl;return J?.forEach(ce=>{const G=re.get(ce.identifier.id);(!G||te(G,ce,!1))&&re.set(ce.identifier.id,ce)}),X?.forEach(ce=>{const G=re.get(ce.identifier.id);if(!G&&J&&ce.type===0){this.t.debug(`Skipping obsolete system extension ${ce.location.path}.`);return}(!G||te(G,ce,!1))&&re.set(ce.identifier.id,ce)}),W?.forEach(ce=>{const G=re.get(ce.identifier.id);(!G||te(G,ce,!0))&&re.set(ce.identifier.id,ce),re.set(ce.identifier.id,ce)}),[...re.values()]}async H(J,X){this.t.trace("Started scanning system extensions");const W=await this.L(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),q=await(J&&!W.devMode?this.i:this.k).scanExtensions(W);return this.t.trace("Scanned system extensions:",q.length),q}async I(J,X){const W=this.u.isBuilt?[]:this.v.builtInExtensions;if(!W?.length)return[];this.t.trace("Started scanning dev system extensions");const U=X?await this.J():{},q=[],te=l.URI.file(E.$$b(E.$ac(C.$4e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ce of W){const G=U[ce.name]||"marketplace";switch(G){case"disabled":break;case"marketplace":q.push((0,h.$0f)(te,ce.name));break;default:q.push(l.URI.file(G));break}}const re=await Promise.all(q.map(async ce=>this.k.scanExtension(await this.L(ce,!1,0,!0,J,!0,void 0))));return this.t.trace("Scanned dev system extensions:",re.length),(0,I.$mf)(re)}async J(){try{const J=await this.s.readFile(this.l);return JSON.parse(J.value.toString())}catch{return{}}}async L(J,X,W,U,q,te,re){const ce=await this.f(q??m.$v),G=await this.M(J),N=X&&!this.w.extUri.isEqual(J,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,$=N?await this.M(N):void 0;return new F(J,G,N,$,X,re,W,U,te,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,q,ce)}async M(J){try{const X=await this.s.stat(J);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$ep=M,e.$ep=M=we([Y(4,g.$rk),Y(5,w.$_o),Y(6,o.$Sj),Y(7,s.$Ri),Y(8,y.$wh),Y(9,i.$0i),Y(10,f.$pk),Y(11,n.$oh)],M);class F{constructor(J,X,W,U,q,te,re,ce,G,N,$,D,z,K,_){this.location=J,this.mtime=X,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=U,this.profile=q,this.profileScanOptions=te,this.type=re,this.excludeObsolete=ce,this.validate=G,this.productVersion=N,this.productDate=$,this.productCommit=D,this.devMode=z,this.language=K,this.translations=_}static createNlsConfiguration(J){return{language:J.language,pseudo:J.language==="pseudo",devMode:J.devMode,translations:J.translations}}static equals(J,X){return(0,h.$3f)(J.location,X.location)&&J.mtime===X.mtime&&(0,h.$3f)(J.applicationExtensionslocation,X.applicationExtensionslocation)&&J.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&J.profile===X.profile&&O.$Lm(J.profileScanOptions,X.profileScanOptions)&&J.type===X.type&&J.excludeObsolete===X.excludeObsolete&&J.validate===X.validate&&J.productVersion===X.productVersion&&J.productDate===X.productDate&&J.productCommit===X.productCommit&&J.devMode===X.devMode&&J.language===X.language&&A.equals(J.translations,X.translations)}}e.$fp=F;let V=class extends b.$lb{constructor(J,X,W,U,q){super(),this.f=J,this.g=X,this.h=W,this.i=U,this.j=q}async scanExtensions(J){const X=J.profile?await this.l(J):await this.k(J);let W={};if(J.excludeObsolete&&J.type===1)try{const U=(await this.i.readFile(this.f)).value.toString();W=JSON.parse(U)}catch{}return(0,c.$we)(W)?X:X.filter(U=>!W[p.$go.create(U).toString()])}async k(J){const X=await this.i.resolve(J.location);if(!X.children?.length)return[];const W=await Promise.all(X.children.map(async U=>{if(!U.isDirectory||J.type===1&&(0,h.$7f)(U.resource).indexOf(".")===0)return null;const q=new F(U.resource,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(q)}));return(0,I.$mf)(W).sort((U,q)=>U.location.path<q.location.path?-1:1)}async l(J){let X=await this.m(J.location,()=>!0,J);if(J.applicationExtensionslocation&&!this.h.extUri.isEqual(J.location,J.applicationExtensionslocation)){X=X.filter(U=>!U.metadata?.isApplicationScoped);const W=await this.m(J.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,J);X.push(...W)}return X}async m(J,X,W){const U=await this.g.scanProfileExtensions(J,W.profileScanOptions);if(!U.length)return[];const q=await Promise.all(U.map(async te=>{if(X(te)){const re=new F(te.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(re,te.metadata)}return null}));return(0,I.$mf)(q)}async scanOneOrMultipleExtensions(J){try{if(await this.i.exists((0,h.$0f)(J.location,"package.json"))){const X=await this.scanExtension(J);return X?[X]:[]}else return await this.scanExtensions(J)}catch(X){return this.j.error(`Error scanning extensions at ${J.location.path}:`,(0,L.$9)(X)),[]}}async scanExtension(J,X){try{let W=await this.scanExtensionManifest(J.location);if(W){W.publisher||(W.publisher=R.$Dl),X=X??W.__metadata,delete W.__metadata;const U=(0,p.$ko)(W.publisher,W.name),q=X?.id?{id:U,uuid:X.id}:{id:U},te=X?.isSystem?0:J.type,re=te===0||!!X?.isBuiltin;W=await this.n(J.location,W,F.createNlsConfiguration(J));const ce={type:te,identifier:q,manifest:W,location:J.location,isBuiltin:re,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return J.validate?this.validate(ce,J):ce}}catch(W){J.type!==0&&this.j.error(W)}return null}validate(J,X){let W=!0;const U=(0,t.$vo)(X.productVersion,X.productDate,X.location,J.manifest,J.isBuiltin);for(const[q,te]of U)q===v.default.Error&&(W=!1,this.j.error(this.u(X.location,te)));return J.isValid=W,J.validations=U,J}async scanExtensionManifest(J){const X=(0,h.$0f)(J,"package.json");let W;try{W=(await this.i.readFile(X)).value.toString()}catch(q){return(0,o.$9j)(q)!==1&&this.j.error(this.u(J,(0,u.localize)(0,null,X.path,q.message))),null}let U;try{U=JSON.parse(W)}catch{const te=[];(0,P.$xm)(W,te);for(const re of te)this.j.error(this.u(J,(0,u.localize)(1,null,X.path,re.offset,re.length,(0,S.$bp)(re.error))));return null}return(0,P.$Gm)(U)!=="object"?(this.j.error(this.u(J,(0,u.localize)(2,null,X.path))),null):U}async n(J,X,W){const U=await this.r(J,X,W);if(U)try{const q=[],te=await this.s(U.default,q);if(q.length>0)return q.forEach(ce=>{this.j.error(this.u(J,(0,u.localize)(3,null,U.default?.path,(0,S.$bp)(ce.error))))}),X;if((0,P.$Gm)(U)!=="object")return this.j.error(this.u(J,(0,u.localize)(4,null,U.default?.path))),X;const re=U.values||Object.create(null);return(0,k.$cp)(X,re,te)}catch{}return X}async r(J,X,W){const U=(0,h.$0f)(J,"package.nls.json"),q=(G,N)=>{N.forEach($=>{this.j.error(this.u(J,(0,u.localize)(5,null,G?.path,(0,S.$bp)($.error))))})},te=G=>{this.j.error(this.u(J,(0,u.localize)(6,null,G?.path)))},re=`${X.publisher}.${X.name}`,ce=W.translations[re];if(ce)try{const G=l.URI.file(ce),N=(await this.i.readFile(G)).value.toString(),$=[],D=(0,P.$xm)(N,$);return $.length>0?(q(G,$),{values:void 0,default:U}):(0,P.$Gm)(D)!=="object"?(te(G),{values:void 0,default:U}):{values:D.contents?D.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.i.exists(U))return;let N;try{N=await this.t(J,W)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const $=(await this.i.readFile(N.localized)).value.toString(),D=[],z=(0,P.$xm)($,D);return D.length>0?(q(N.localized,D),{values:void 0,default:N.original}):(0,P.$Gm)(z)!=="object"?(te(N.localized),{values:void 0,default:N.original}):{values:z,default:N.original}}catch{return{values:void 0,default:N.original}}}}async s(J,X){if(J)try{const W=(await this.i.readFile(J)).value.toString();return(0,P.$xm)(W,X)}catch{}}t(J,X){return new Promise((W,U)=>{const q=te=>{const re=(0,h.$0f)(J,`package.nls.${te}.json`);this.i.exists(re).then(ce=>{ce&&W({localized:re,original:(0,h.$0f)(J,"package.nls.json")});const G=te.lastIndexOf("-");G===-1?W({localized:(0,h.$0f)(J,"package.nls.json"),original:null}):(te=te.substring(0,G),q(te))})};if(X.devMode||X.pseudo||!X.language)return W({localized:(0,h.$0f)(J,"package.nls.json"),original:null});q(X.language)})}u(J,X){return`[${J.path}]: ${X}`}};V=we([Y(1,w.$_o),Y(2,f.$pk),Y(3,o.$Sj),Y(4,s.$Ri)],V);let B=class extends V{constructor(J,X,W,U,q,te,re){super(X,U,q,te,re),this.z=J,this.C=W,this.w=this.B(new T.$tg(3e3)),this.y=this.B(new r.$8c),this.onDidChangeCache=this.y.event}async scanExtensions(J){const X=this.H(J),W=await this.D(X);if(this.v=J,W&&W.input&&F.equals(W.input,this.v))return this.j.debug("Using cached extensions scan result",J.location.toString()),this.w.trigger(()=>this.G()),W.result.map(q=>(q.location=l.URI.revive(q.location),q));const U=await super.scanExtensions(J);return await this.F(X,{input:J,result:U}),U}async D(J){try{const X=await this.i.readFile(J),W=JSON.parse(X.value.toString());return{result:W.result,input:(0,a.$Yg)(W.input)}}catch(X){this.j.debug("Error while reading the extension cache file:",J.path,(0,L.$9)(X))}return null}async F(J,X){try{await this.i.writeFile(J,j.$Jb.fromString(JSON.stringify(X)))}catch(W){this.j.debug("Error while writing the extension cache file:",J.path,(0,L.$9)(W))}}async G(){if(!this.v)return;const J=this.H(this.v),X=await this.D(J);if(!X)return;const W=X.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!O.$Lm(U,W))try{this.j.info("Invalidating Cache",W,U),await this.i.del(J),this.y.fire()}catch(q){this.j.error(q)}}H(J){const X=this.I(J);return this.h.extUri.joinPath(X.cacheHome,J.type===0?R.$Cl:R.$Bl)}I(J){return J.type===0?this.C.defaultProfile:J.profile?this.h.extUri.isEqual(J.location,this.z.extensionsResource)?this.z:this.C.profiles.find(X=>this.h.extUri.isEqual(J.location,X.extensionsResource))??this.z:this.C.defaultProfile}};B=we([Y(2,g.$rk),Y(3,w.$_o),Y(4,f.$pk),Y(5,o.$Sj),Y(6,s.$Ri)],B);function x(Q,J){const X=(0,p.$io)(Q.manifest.publisher,Q.manifest.name);return{id:X,identifier:new R.$Hl(X),isBuiltin:Q.type===0,isUserBuiltin:Q.type===1&&Q.isBuiltin,isUnderDevelopment:J,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,...Q.manifest}}e.$gp=x;class Z extends M{constructor(J,X,W,U,q,te,re,ce,G,N,$,D){super(J,X,(0,h.$0f)(W,".vscode-oss-dev","extensions","control.json"),U,q,te,re,ce,G,N,$,D),this.N=(async()=>{if(m.$y)try{const z=await this.s.readFile(l.URI.file(m.$y));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(J){return this.N}}e.$hp=Z}),define(oe[239],ae([0,1,63,6,38,3,2,26,16,31,8,17]),function(ne,e,I,T,O,j,L,P,S,b,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=void 0;let m=class extends L.$lb{constructor(d,v){super(),this.b=d,this.f=v,this.a=new T.$Bg(5)}async postUninstall(d){const v=this.g(d,"uninstall");v&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(v.script,"uninstall",v.args,!0,d),this.f.info("Finished running post uninstall script",d.identifier.id,d.manifest.version)}catch(c){this.f.error("Failed to run post uninstall script",d.identifier.id,d.manifest.version),this.f.error(c)}}));try{await b.Promises.rm(this.j(d))}catch(c){this.f.error("Error while removing extension storage path",d.identifier.id),this.f.error(c)}}g(d,v){const c=`vscode:${v}`;if(d.location.scheme===P.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[c]=="string"){const l=d.manifest.scripts[c].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${c} should be a node script`),null):{script:(0,S.$ac)(d.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(d,v,c,l,u){return new Promise((y,p)=>{const R=this.i(d,v,c,u);let t;const o=n=>{t&&(clearTimeout(t),t=null),n?p(n):y(void 0)};R.on("error",n=>{o((0,O.$ai)(n)||"Unknown")}),R.on("exit",(n,s)=>{o(n?`post-${v} process exited with code ${n}`:void 0)}),l&&(t=setTimeout(()=>{t=null,R.kill(),p("timed out")},5e3))})}i(d,v,c,l){const u={silent:!0,execArgv:void 0},y=(0,I.fork)(d,[`--type=extension-post-${v}`,...c],u);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const p=j.Event.fromNodeEventEmitter(y.stdout,"data"),R=j.Event.fromNodeEventEmitter(y.stderr,"data");p(n=>this.f.info(l.identifier.id,l.manifest.version,`post-${v}`,n)),R(n=>this.f.error(l.identifier.id,l.manifest.version,`post-${v}`,n));const t=j.Event.any(j.Event.map(p,n=>({data:`%c${n}`,format:[""]})),j.Event.map(R,n=>({data:`%c${n}`,format:["color: red"]})));return j.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),y}j(d){return(0,S.$ac)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};e.$jp=m,e.$jp=m=we([Y(0,E.$rk),Y(1,C.$Ri)],m)}),define(oe[240],ae([0,1,8,17,28,20,50,13,15,10]),function(ne,e,I,T,O,j,L,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=void 0;let C=class extends L.$ap{constructor(m,h,d,v,c,l){super(b.URI.file(m.extensionsPath),h,d,v,c,l)}};e.$ZM=C,e.$ZM=C=we([Y(0,S.$xh),Y(1,P.$Sj),Y(2,T.$rk),Y(3,O.$pk),Y(4,j.$Vk),Y(5,I.$Ri)],C)}),define(oe[241],ae([0,1,10,15,50,77,13,4,8,24,28,17]),function(ne,e,I,T,O,j,L,P,S,b,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q4b=void 0;let m=class extends j.$hp{constructor(d,v,c,l,u,y,p,R){super(I.URI.file(u.builtinExtensionsPath),I.URI.file(u.extensionsPath),u.userHome,d.defaultProfile,d,v,c,l,u,y,p,R)}};e.$Q4b=m,e.$Q4b=m=we([Y(0,E.$rk),Y(1,O.$_o),Y(2,L.$Sj),Y(3,S.$Ri),Y(4,T.$xh),Y(5,b.$0i),Y(6,C.$pk),Y(7,P.$oh)],m)}),define(oe[19],ae([0,1,6,3,2,100,11,64,4,17]),function(ne,e,I,T,O,j,L,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Ko=e.$Jo=e.$Io=void 0,e.$Io="__$__isNewStorageMarker",e.$Jo="__$__targetStorageMarker",e.$Ko=(0,S.$ph)("storageService");var C;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var E;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var m;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function h(u){const y=u.get(e.$Jo);if(y)try{return JSON.parse(y)}catch{}return Object.create(null)}e.$Lo=h;class d extends O.$lb{static{this.a=60*1e3}constructor(y={flushInterval:d.a}){super(),this.j=y,this.b=this.B(new T.$$c),this.c=this.B(new T.$$c),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$8c),this.onWillSaveState=this.f.event,this.h=this.B(new I.$Gg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new O.$mb),this.v=void 0,this.y=void 0,this.C=void 0}onDidChangeValue(y,p,R){return T.Event.filter(this.b.event,t=>t.scope===y&&(p===void 0||t.key===p),R)}k(){this.i.value=(0,I.$Kg)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,O.$gb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.J()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(y,p){const{key:R,external:t}=p;if(R===e.$Jo){switch(y){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:y})}else this.b.fire({scope:y,key:R,target:this.F(y)[R],external:t})}r(y){this.f.fire({reason:y})}get(y,p,R){return this.L(p)?.get(y,R)}getBoolean(y,p,R){return this.L(p)?.getBoolean(y,R)}getNumber(y,p,R){return this.L(p)?.getNumber(y,R)}getObject(y,p,R){return this.L(p)?.getObject(y,R)}storeAll(y,p){this.t(()=>{for(const R of y)this.store(R.key,R.value,R.scope,R.target,p)})}store(y,p,R,t,o=!1){if((0,L.$se)(p)){this.remove(y,R,o);return}this.t(()=>{this.u(y,R,t),this.L(R)?.set(y,p,o)})}remove(y,p,R=!1){this.t(()=>{this.u(y,p,void 0),this.L(p)?.delete(y,R)})}t(y){this.b.pause(),this.c.pause();try{y()}finally{this.b.resume(),this.c.resume()}}keys(y,p){const R=[],t=this.F(y);for(const o of Object.keys(t))t[o]===p&&R.push(o);return R}u(y,p,R,t=!1){const o=this.F(p);typeof R=="number"?o[y]!==R&&(o[y]=R,this.L(p)?.set(e.$Jo,JSON.stringify(o),t)):typeof o[y]=="number"&&(delete o[y],this.L(p)?.set(e.$Jo,JSON.stringify(o),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(y){switch(y){case-1:return this.D;case 0:return this.z;default:return this.w}}G(y){const p=this.L(y);return p?h(p):Object.create(null)}isNew(y){return this.getBoolean(e.$Io,y)===!0}async flush(y=C.NONE){this.f.fire({reason:y});const p=this.L(-1),R=this.L(0),t=this.L(1);switch(y){case C.NONE:await I.Promises.settled([p?.whenFlushed()??Promise.resolve(),R?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await I.Promises.settled([p?.flush(0)??Promise.resolve(),R?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const y=this.L(-1)?.items??new Map,p=this.L(0)?.items??new Map,R=this.L(1)?.items??new Map;return l(y,p,R,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(y,p){return this.r(C.NONE),(0,b.$qk)(y)?this.N(y,p):this.O(y,p)}H(y,p){return!(y.id===p.id||v(p)&&v(y))}I(y,p,R){this.t(()=>{const t=new Set;for(const[o,n]of y)t.add(o),p.get(o)!==n&&this.n(R,{key:o,external:!0});for(const[o]of p.items)t.has(o)||this.n(R,{key:o,external:!0})})}}e.$Mo=d;function v(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$No=v;class c extends d{constructor(){super(),this.p=this.B(new P.$Go(new P.$Ho,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.$Go(new P.$Ho,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.$Go(new P.$Ho,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(y=>this.n(1,y))),this.B(this.P.onDidChangeStorage(y=>this.n(0,y))),this.B(this.p.onDidChangeStorage(y=>this.n(-1,y)))}L(y){switch(y){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(y){switch(y){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(y){return!1}}e.$Oo=c;async function l(u,y,p,R,t,o){const n=A=>{try{return JSON.parse(A)}catch{return A}},s=new Map,i=new Map;u.forEach((A,M)=>{s.set(M,A),i.set(M,n(A))});const r=new Map,a=new Map;y.forEach((A,M)=>{r.set(M,A),a.set(M,n(A))});const w=new Map,g=new Map;p.forEach((A,M)=>{w.set(M,A),g.set(M,n(A))}),console.group(R!==t?`Storage: Application (path: ${R})`:`Storage: Application & Profile (path: ${R}, default profile)`);const f=[];if(s.forEach((A,M)=>{f.push({key:M,value:A})}),console.table(f),console.groupEnd(),console.log(i),R!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const A=[];r.forEach((M,F)=>{A.push({key:F,value:M})}),console.table(A),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const k=[];w.forEach((A,M)=>{k.push({key:M,value:A})}),console.table(k),console.groupEnd(),console.log(g)}e.$Po=l}),define(oe[113],ae([0,1,3,2,11,29,33,19]),function(ne,e,I,T,O,j,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qxb=e.$pxb=void 0;let S=class extends T.$lb{constructor(E,m){super(),this.a=new I.$8c,this.onDidChangeEnablement=this.a.event,this.b=this.B(new b(E)),this.B(this.b.onDidChange(h=>this.a.fire({extensions:h,source:"storage"}))),this.B(m.onDidInstallExtensions(h=>h.forEach(({local:d,operation:v})=>{d&&v===4&&this.f(d.identifier)})))}async enableExtension(E,m){return this.f(E)?(this.a.fire({extensions:[E],source:m}),!0):!1}async disableExtension(E,m){return this.c(E)?(this.a.fire({extensions:[E],source:m}),!0):!1}getDisabledExtensions(){return this.h(j.$Sn)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const m=this.getDisabledExtensions();return m.every(h=>!(0,L.$fo)(h,E))?(m.push(E),this.g(m),!0):!1}f(E){const m=this.getDisabledExtensions();for(let h=0;h<m.length;h++){const d=m[h];if((0,L.$fo)(d,E))return m.splice(h,1),this.g(m),!0}return!1}g(E){this.i(j.$Sn,E)}h(E){return this.b.get(E,0)}i(E,m){this.b.set(E,m,0)}};e.$pxb=S,e.$pxb=S=we([Y(0,P.$Ko),Y(1,j.$Rn)],S);class b extends T.$lb{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new I.$8c),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(0,void 0,this.B(new T.$kb))(m=>this.f(m)))}get(E,m){let h;return m===0?((0,O.$se)(this.a[E])&&(this.a[E]=this.g(E,m)),h=this.a[E]):h=this.g(E,m),JSON.parse(h)}set(E,m,h){const d=JSON.stringify(m.map(({id:c,uuid:l})=>({id:c,uuid:l})));this.g(E,h)!==d&&(h===0&&(m.length?this.a[E]=d:delete this.a[E]),this.h(E,m.length?d:void 0,h))}f(E){if(!(0,O.$se)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const h=this.get(E.key,E.scope);delete this.a[E.key];const d=this.get(E.key,E.scope),v=h.filter(l=>!d.some(u=>(0,L.$fo)(l,u))),c=d.filter(l=>!h.some(u=>(0,L.$fo)(u,l)));(v.length||c.length)&&this.b.fire([...v,...c])}}g(E,m){return this.c.get(E,m,"[]")}h(E,m,h){m?this.c.store(E,m,h,1):this.c.remove(E,h)}}e.$qxb=b}),define(oe[242],ae([0,1,21,25,7,5,37,11,10,18,15,29,33,65,13,8,24,57,219,19,20]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=void 0;const R=j.$o?"web":(0,E.$Kn)(j.$t,L.$8b),t="X-Market-Search-Activity-Id";var o;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function n(...N){return String(N.reduce(($,D)=>$|D,0))}var s;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class g{constructor($=w){this.d=$}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage($,D=this.d.pageSize){return new g({...this.d,pageNumber:$,pageSize:D})}withFilter($,...D){const z=[...this.d.criteria,...D.length?D.map(K=>({filterType:$,value:K})):[{filterType:$}]];return new g({...this.d,criteria:z})}withSortBy($){return new g({...this.d,sortBy:$})}withSortOrder($){return new g({...this.d,sortOrder:$})}withFlags(...$){return new g({...this.d,flags:$.reduce((D,z)=>D|z,0)})}withAssetTypes(...$){return new g({...this.d,assetTypes:$})}withSource($){return new g({...this.d,source:$})}get raw(){const{criteria:$,pageNumber:D,pageSize:z,sortBy:K,sortOrder:_,flags:H,assetTypes:ee}=this.d;return{filters:[{criteria:$,pageNumber:D,pageSize:z,sortBy:K,sortOrder:_}],assetTypes:ee,flags:H}}get searchText(){const $=this.d.criteria.filter(D=>D.filterType===s.SearchText)[0];return $&&$.value?$.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map($=>String($.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function f(N,$){const D=(N||[]).filter(z=>z.statisticName===$)[0];return D?D.value:0}function k(N){const $="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(z=>z.assetType.indexOf($)===0).reduce((z,K)=>{const _=F(N,K.assetType);return _&&z.push([K.assetType.substring($.length),_]),z},[])}function A(N){if(N.properties){const $=N.properties.filter(K=>K.key===i.Repository),D=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=$.filter(K=>D.test(K.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return F(N,i.Repository)}function M(N){return{uri:`${N.fallbackAssetUri}/${i.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${i.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function F(N,$){return N.files.filter(z=>z.assetType===$)[0]?{uri:`${N.assetUri}/${$}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${$}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function V(N,$){const D=N.properties?N.properties.filter(K=>K.key===$):[],z=D.length>0&&D[0].value;return z?z.split(",").map(K=>(0,m.$jo)(K)):[]}function B(N){const $=N.properties?N.properties.filter(D=>D.key===r.Engine):[];return $.length>0&&$[0].value||""}function x(N){const $=N.properties?N.properties.filter(D=>D.key===r.PreRelease):[];return $.length>0&&$[0].value==="true"}function Z(N){const $=N.properties?N.properties.filter(z=>z.key===r.LocalizedLanguages):[],D=$.length>0&&$[0].value||"";return D?D.split(","):[]}function Q(N){return N.properties?.find($=>$.key===r.SponsorLink)?.value}function J(N){return N.indexOf("preview")!==-1}function X(N){return N.targetPlatform?(0,E.$Jn)(N.targetPlatform):"undefined"}function W(N){const $=(0,I.$rf)(N.versions.map(X)),D=!!N.tags?.includes(E.$Fn),z=$.indexOf("web");return D?z===-1&&$.push("web"):z!==-1&&$.splice(z,1),$}function U(N,$){const D=(0,E.$Nn)($);for(let z=0;z<N.length;z++){const K=N[z];if(K.version===N[z-1]?.version){let _=z;const H=X(K);if(H===$)for(;_>0&&N[_-1].version===K.version;)_--;else if(D.includes(H))for(;_>0&&N[_-1].version===K.version&&X(N[_-1])!==$;)_--;_!==z&&(N.splice(z,1),N.splice(_,0,K))}}return N}e.$So=U;function q(N,$,D){N.telemetryData={index:$,querySource:D,queryActivityId:N.queryContext?.[t]}}function te(N,$,D,z){const K=N.versions[0],_={manifest:F($,i.Manifest),readme:F($,i.Details),changelog:F($,i.Changelog),license:F($,i.License),repository:A($),download:M($),icon:F($,i.Icon),signature:F($,i.Signature),coreTranslations:k($)};return{identifier:{id:(0,m.$ko)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:$.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,publisherSponsorLink:Q(K),description:N.shortDescription||"",installCount:f(N.statistics,"install"),rating:f(N.statistics,"averagerating"),ratingCount:f(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:D,assets:_,properties:{dependencies:V($,r.Dependency),extensionPack:V($,r.ExtensionPack),engine:B($),localizedLanguages:Z($),targetPlatform:X($),isPreReleaseVersion:x($)},hasPreReleaseVersion:x(K),hasReleaseVersion:!0,preview:J(N.flags),isSigned:!!_.signature,queryContext:z}}let re=class{constructor($,D,z,K,_,H,ee,ie){this.k=D,this.l=z,this.n=K,this.o=_,this.q=H,this.u=ee,this.w=ie;const le=ee.extensionsGallery,he=le?.servicePPEUrl&&ie.getValue("_extensionsGallery.enablePPE");this.d=he?le.servicePPEUrl:le?.serviceUrl,this.g=he?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,u.$Ro)(ee.version,ee,this.n,this.w,this.q,$,this.o)}x($=""){return`${this.d}${$}`}isEnabled(){return!!this.d}async getExtensions($,D,z){const K=T.CancellationToken.isCancellationToken(D)?{}:D,_=T.CancellationToken.isCancellationToken(D)?D:z,H=[],ee=[],ie=[],le=[];let he=!0;for(const ke of $){ke.uuid?ee.push(ke.uuid):H.push(ke.id);const Pe=!!(ke.version||ke.preRelease);ie.push({id:ke.id,uuid:ke.uuid,includePreRelease:Pe}),ke.version&&le.push({id:ke.id,uuid:ke.uuid,version:ke.version}),he=he&&!!ke.hasPreRelease&&!Pe}if(!ee.length&&!H.length)return[];let me=new g().withPage(1,$.length);ee.length&&(me=me.withFilter(s.ExtensionId,...ee)),H.length&&(me=me.withFilter(s.ExtensionName,...H)),(K.queryAllVersions||he)&&(me=me.withFlags(me.flags,o.IncludeVersions)),K.source&&(me=me.withSource(K.source));const{extensions:be}=await this.z(me,{targetPlatform:K.targetPlatform??R,includePreRelease:ie,versions:le,compatible:!!K.compatible},_);return K.source&&be.forEach((ke,Pe)=>q(ke,Pe,K.source)),be}async getCompatibleExtension($,D,z){if((0,E.$Ln)($.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible($,D,z))return $;const K=new g().withFlags(o.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,$.identifier.uuid),{extensions:_}=await this.z(K,{targetPlatform:z,compatible:!0,includePreRelease:D},T.CancellationToken.None);return _[0]||null}async isExtensionCompatible($,D,z){if(!(0,E.$Mn)($.properties.targetPlatform,$.allTargetPlatforms,z)||!D&&$.properties.isPreReleaseVersion)return!1;let K=$.properties.engine;if(!K){const _=await this.getManifest($,T.CancellationToken.None);if(!_)throw new Error("Manifest was not found");K=_.engines.vscode}return(0,h.$xo)(K,this.u.version,this.u.date)}async y($,D,z,K,_){if(!(0,E.$Mn)(X($),K,_)||D!=="any"&&x($)!==(D==="prerelease"))return!1;if(z)try{const H=await this.E($);if(!(0,h.$xo)(H,this.u.version,this.u.date))return!1}catch(H){return this.l.error(`Error while getting the engine for the version ${$.version}.`,(0,O.$9)(H)),!1}return!0}async query($,D){let z=$.text||"";const K=$.pageSize??50;let _=new g().withPage(1,K);z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,me,be)=>(_=_.withFilter(s.Category,be||me),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,me,be)=>(_=_.withFilter(s.Tag,be||me),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(s.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),_=_.withFilter(s.SearchText,z)),_=_.withSortBy(0)):$.ids?_=_.withFilter(s.ExtensionId,...$.ids):$.names?_=_.withFilter(s.ExtensionName,...$.names):_=_.withSortBy(4),typeof $.sortBy=="number"&&(_=_.withSortBy($.sortBy)),typeof $.sortOrder=="number"&&(_=_.withSortOrder($.sortOrder)),$.source&&(_=_.withSource($.source));const H=async(he,me)=>{const{extensions:be,total:ke}=await this.z(he,{targetPlatform:R,compatible:!1,includePreRelease:!!$.includePreRelease},me);return be.forEach((Pe,je)=>q(Pe,(he.pageNumber-1)*he.pageSize+je,$.source)),{extensions:be,total:ke}},{extensions:ee,total:ie}=await H(_,D),le=async(he,me)=>{if(me.isCancellationRequested)throw new O.$3;const{extensions:be}=await H(_.withPage(he+1),me);return be};return{firstPage:ee,total:ie,pageSize:_.pageSize,getPage:le}}async z($,D,z){const K=$.flags;$.flags&o.IncludeLatestVersionOnly&&$.flags&o.IncludeVersions&&($=$.withFlags($.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!($.flags&o.IncludeLatestVersionOnly)&&!($.flags&o.IncludeVersions)&&($=$.withFlags($.flags,o.IncludeLatestVersionOnly)),D.versions?.length&&($=$.withFlags($.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),$=$.withFlags($.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:_,total:H,context:ee}=await this.B($,z);if(!($.flags&o.IncludeLatestVersionOnly)){const me=[];for(const be of _){const ke=await this.A(be,D,ee);ke&&me.push(ke)}return{extensions:me,total:H}}const le=[],he=new Map;for(let me=0;me<_.length;me++){const be=_[me],ke={id:(0,m.$ko)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Pe=(0,P.$pe)(D.includePreRelease)?D.includePreRelease:!!D.includePreRelease.find(De=>(0,m.$fo)(De,ke))?.includePreRelease;if(D.compatible&&(0,E.$Ln)(W(be),D.targetPlatform))continue;const je=await this.A(be,D,ee);!je||je.properties.isPreReleaseVersion&&(!Pe||!je.hasReleaseVersion)||!je.properties.isPreReleaseVersion&&je.properties.targetPlatform!==D.targetPlatform&&je.hasPreReleaseVersion?he.set(be.extensionId,me):le.push([me,je])}if(he.size){const me=new Date().getTime(),be=new g().withFlags(K&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,he.size).withFilter(s.ExtensionId,...he.keys()),{extensions:ke}=await this.z(be,D,z);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-me,count:he.size});for(const Pe of ke){const je=he.get(Pe.identifier.uuid);le.push([je,Pe])}}return{extensions:le.sort((me,be)=>me[0]-be[0]).map(([,me])=>me),total:H}}async A($,D,z){const K={id:(0,m.$ko)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},_=D.versions?.find(le=>(0,m.$fo)(le,K))?.version,H=(0,P.$pe)(D.includePreRelease)?D.includePreRelease:!!D.includePreRelease.find(le=>(0,m.$fo)(le,K))?.includePreRelease,ee=W($),ie=U($.versions,D.targetPlatform);if(D.compatible&&(0,E.$Ln)(ee,D.targetPlatform))return null;for(let le=0;le<ie.length;le++){const he=ie[le];if(!(_&&he.version!==_)){if(await this.y(he,H?"any":"release",D.compatible,ee,D.targetPlatform))return te($,he,ee,z);if(_&&he.version===_)return null}}return _||D.compatible?null:te($,$.versions[0],ee)}async B($,D){if(!this.isEnabled())throw new Error("No extension gallery service configured.");$=$.withFlags($.flags,o.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(o.Unpublished));const z=await this.j,K=JSON.stringify($.raw),_={...z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(K.length)},H=new Date().getTime();let ee,ie,le=0;try{if(ee=await this.k.request({type:"POST",url:this.g&&$.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:K,headers:_},D),ee.res.statusCode&&ee.res.statusCode>=400&&ee.res.statusCode<500)return{galleryExtensions:[],total:le};const he=await(0,l.$Do)(ee);if(he){const me=he.results[0],be=me.extensions,ke=me.resultMetadata&&me.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return le=ke&&ke.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:le,context:{[t]:ee.res.headers.activityid}}}return{galleryExtensions:[],total:le}}catch(he){throw ie=he,he}finally{this.o.publicLog2("galleryService:query",{...$.telemetryData,requestBodySize:String(K.length),duration:new Date().getTime()-H,success:!!ee&&(0,l.$Ao)(ee),responseBodySize:ee?.res.headers["Content-Length"],statusCode:ee?String(ee.res.statusCode):void 0,errorCode:ie?(0,O.$2)(ie)?"canceled":(0,O.$9)(ie).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic($,D,z,K){if(!this.isEnabled())return;const _=j.$o?this.x(`/itemName/${$}.${D}/version/${z}/statType/${K==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${$}/extensions/${D}/${z}/stats?statType=${K}`),H=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ie={...await this.j,Accept:H};try{await this.k.request({type:"POST",url:_,headers:ie},T.CancellationToken.None)}catch{}}async download($,D,z){this.l.trace("ExtensionGalleryService#download",$.identifier.id);const K=(0,m.$no)($),_=new Date().getTime(),H=me=>this.o.publicLog("galleryService:downloadVSIX",{...K,duration:me}),ee=z===2?"install":z===3?"update":"",ie=ee?{uri:`${$.assets.download.uri}${S.URI.parse($.assets.download.uri).query?"&":"?"}${ee}=true`,fallbackUri:`${$.assets.download.fallbackUri}${S.URI.parse($.assets.download.fallbackUri).query?"&":"?"}${ee}=true`}:$.assets.download,le=$.queryContext?.[t]?{[t]:$.queryContext[t]}:void 0,he=await this.D(ie,le?{headers:le}:void 0);await this.q.writeFile(D,he.stream),H(new Date().getTime()-_)}async downloadSignatureArchive($,D){if(!$.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",$.identifier.id);const z=await this.D($.assets.signature);await this.q.writeFile(D,z.stream)}async getReadme($,D){if($.assets.readme){const z=await this.D($.assets.readme,{},D);return await(0,l.$Co)(z)||""}return""}async getManifest($,D){if($.assets.manifest){const z=await this.D($.assets.manifest,{},D),K=await(0,l.$Co)(z);return K?JSON.parse(K):null}return null}async C($,D){const z=F($,i.Manifest);if(!z)throw new Error("Manifest was not found");const K={"Accept-Encoding":"gzip"},_=await this.D(z,{headers:K});return await(0,l.$Do)(_)}async getCoreTranslation($,D){const z=$.assets.coreTranslations.filter(K=>K[0]===D.toUpperCase())[0];if(z){const K=await this.D(z[1]),_=await(0,l.$Co)(K);return _?JSON.parse(_):null}return null}async getChangelog($,D){if($.assets.changelog){const z=await this.D($.assets.changelog,{},D);return await(0,l.$Co)(z)||""}return""}async getAllCompatibleVersions($,D,z){let K=new g().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);$.identifier.uuid?K=K.withFilter(s.ExtensionId,$.identifier.uuid):K=K.withFilter(s.ExtensionName,$.identifier.id);const{galleryExtensions:_}=await this.B(K,T.CancellationToken.None);if(!_.length)return[];const H=W(_[0]);if((0,E.$Ln)(H,z))return[];const ee=[];await Promise.all(_[0].versions.map(async he=>{try{await this.y(he,D?"any":"release",!0,H,z)&&ee.push(he)}catch{}}));const ie=[],le=new Set;for(const he of U(ee,z))le.has(he.version)||(le.add(he.version),ie.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:x(he)}));return ie}async D($,D={},z=T.CancellationToken.None){const K=await this.j,_={type:"GET"},H={...K,...D.headers||{}};D={...D,..._,headers:H};const ee=$.uri,ie=$.fallbackUri,le={...D,url:ee};try{const he=await this.k.request(le,z);if(he.res.statusCode===200)return he;const me=await(0,l.$Co)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${me}`)}catch(he){if((0,O.$2)(he))throw he;const me=(0,O.$9)(he);this.o.publicLog2("galleryService:cdnFallback",{url:ee,message:me});const be={...D,url:ie};return this.k.request(be,z)}}async E($){let D=B($);if(!D){const z=await this.C($,T.CancellationToken.None);if(!z)throw new Error("Manifest was not found");D=z.engines.vscode}return D}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const $=await this.k.request({type:"GET",url:this.h},T.CancellationToken.None);if($.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,l.$Do)($),z=[],K={},_=[];if(D){for(const H of D.malicious)z.push({id:H});if(D.migrateToPreRelease)for(const[H,ee]of Object.entries(D.migrateToPreRelease))(!ee.engine||(0,h.$xo)(ee.engine,this.u.version,this.u.date))&&(K[H.toLowerCase()]={disallowInstall:!0,extension:{id:ee.id,displayName:ee.displayName,autoMigrate:{storage:!!ee.migrateStorage},preRelease:!0}});if(D.deprecated)for(const[H,ee]of Object.entries(D.deprecated))ee&&(K[H.toLowerCase()]=(0,P.$pe)(ee)?{}:ee);if(D.search)for(const H of D.search)_.push(H)}return{malicious:z,deprecated:K,search:_}}};re=we([Y(1,l.$yo),Y(2,v.$Ri),Y(3,C.$wh),Y(4,p.$Vk),Y(5,d.$Sj),Y(6,c.$0i),Y(7,b.$Vh)],re);let ce=class extends re{constructor($,D,z,K,_,H,ee,ie){super($,D,z,K,_,H,ee,ie)}};e.$To=ce,e.$To=ce=we([Y(0,y.$Ko),Y(1,l.$yo),Y(2,v.$Ri),Y(3,C.$wh),Y(4,p.$Vk),Y(5,d.$Sj),Y(6,c.$0i),Y(7,b.$Vh)],ce);let G=class extends re{constructor($,D,z,K,_,H,ee){super(void 0,$,D,z,K,_,H,ee)}};e.$Uo=G,e.$Uo=G=we([Y(0,l.$yo),Y(1,v.$Ri),Y(2,C.$wh),Y(3,p.$Vk),Y(4,d.$Sj),Y(5,c.$0i),Y(6,b.$Vh)],G)}),define(oe[78],ae([0,1,4,3,2,19,33,24,21,8,11]),function(ne,e,I,T,O,j,L,P,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dz=e.$Cz=void 0,e.$Cz=(0,I.$ph)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class Xe extends O.$lb{static{this.a=512*1024}static b(d){return`extensionKeys/${(0,L.$jo)(d.id)}@${d.version}`}static c(d){const v=E.exec(d);if(v&&v[1])return{id:v[1],version:v[2]}}static async removeOutdatedExtensionVersions(d,v){const c=await d.getInstalled(),l=[];for(const[u,y]of Xe.f(v)){const p=c.find(R=>(0,L.$fo)(R.identifier,{id:u}))?.manifest.version;for(const R of y)p!==R&&l.push(Xe.b({id:u,version:R}))}for(const u of l)v.remove(u,0)}static f(d){const v=new Map,c=d.keys(0,1);for(const l of c){const u=Xe.c(l);if(u){let y=v.get(u.id.toLowerCase());y||v.set(u.id.toLowerCase(),y=[]),y.push(u.version)}}return v}constructor(d,v,c){super(),this.i=d,this.j=v,this.k=c,this.g=this.B(new T.$8c),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Xe.f(d),this.B(this.i.onDidChangeValue(0,void 0,this.B(new O.$kb))(l=>this.l(l)))}l(d){if(this.h.has(d.key.toLowerCase())){this.g.fire();return}const v=Xe.c(d.key);if(v){if(this.i.get(d.key,0)===void 0)this.h.delete(v.id.toLowerCase());else{let c=this.h.get(v.id.toLowerCase());c||this.h.set(v.id.toLowerCase(),c=[]),c.push(v.version),this.g.fire()}return}}m(d){if((0,C.$je)(d))return d;const v=d.manifest?d.manifest.publisher:d.publisher,c=d.manifest?d.manifest.name:d.name;return(0,L.$io)(v,c)}getExtensionState(d,v){const c=this.m(d),l=this.getExtensionStateRaw(d,v);if(l)try{return JSON.parse(l)}catch(u){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${c}, global: ${v}): ${u}`)}}getExtensionStateRaw(d,v){const c=this.m(d),l=this.i.get(c,v?0:1);return l&&l?.length>Xe.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${c}, global: ${v}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(d,v,c){const l=this.m(d);v===void 0?this.i.remove(l,c?0:1):this.i.store(l,JSON.stringify(v),c?0:1,1)}setKeysForSync(d,v){this.i.store(Xe.b(d),JSON.stringify(v),0,1)}getKeysForSync(d){const v=this.j.extensionSyncedKeys?.[d.id.toLowerCase()],c=this.i.get(Xe.b(d),0),l=c?JSON.parse(c):void 0;return l&&v?(0,S.$rf)([...l,...v]):l||v}addToMigrationList(d,v){if(d!==v){const c=this.n.filter(l=>!l.includes(d)&&!l.includes(v));c.push([d,v]),this.n=c}}getSourceExtensionToMigrate(d){const v=this.n.find(([,c])=>d===c);return v?v[0]:void 0}get n(){const d=this.i.get("extensionStorage.migrationList",-1,"[]");try{const v=JSON.parse(d);if(Array.isArray(v))return v}catch{}return[]}set n(d){d.length?this.i.store("extensionStorage.migrationList",JSON.stringify(d),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};e.$Dz=m,e.$Dz=m=we([Y(0,j.$Ko),Y(1,P.$0i),Y(2,b.$Ri)],m)}),define(oe[243],ae([0,1,29,13,24,15,98,55,19,20,216]),function(ne,e,I,T,O,j,L,P,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$5b=void 0;let E=class extends C.$w2b{constructor(h,d,v,c,l,u,y,p){super(h.userHome,l,d,v,c,u,y,p)}};e.$$5b=E,e.$$5b=E=we([Y(0,j.$xh),Y(1,b.$Vk),Y(2,I.$Rn),Y(3,S.$Ko),Y(4,P.$13b),Y(5,L.$ZSb),Y(6,T.$Sj),Y(7,O.$0i)],E)}),define(oe[244],ae([0,1,105,3,20,15,2,8,16,63,24,5,6,101,18,161,36,19,11,129]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$75b=void 0;const p=[I.$Z5b,I.$15b],R="remoteTunnelSession",t="remoteTunnelIsService";let o=class extends L.$lb{constructor(r,a,w,g,f,k,A){super(),this.t=r,this.u=a,this.v=w,this.w=k,this.y=A,this.f=new T.$8c,this.onDidTokenFailed=this.f.event,this.g=new T.$8c,this.onDidChangeTunnelStatus=this.g.event,this.h=new T.$8c,this.onDidChangeMode=this.h.event,this.j=I.$X5b,this.s=!1,this.D=(M,F)=>{F?this.i.error(M):this.i.info(M)},this.i=this.B(g.createLogger(I.$25b,{name:I.$35b})),this.p=new m.$sg(100),this.B(this.i.onDidChangeLogLevel(M=>this.i.info("Log level changed to "+(0,P.$7i)(M)))),this.B(f.onWillShutdown(()=>{this.k?.cancel(),this.k=void 0,this.dispose()})),this.B(k.onDidChangeConfiguration(M=>{p.some(F=>M.affectsConfiguration(F))&&this.p.trigger(()=>this.G())})),this.j=this.N(),this.n=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.n}z(r){this.n=r,this.g.fire(r)}C(r){s(this.j,r)||(this.j=r,this.O(r),this.h.fire(this.j),r.active?(this.i.info(`Session updated: ${r.session.accountLabel} (${r.session.providerId}) (service=${r.asService})`),r.session.token&&this.i.info(`Session token updated: ${r.session.accountLabel} (${r.session.providerId})`)):this.i.info("Session reset"))}getMode(){return Promise.resolve(this.j)}async initialize(r){if(this.s)return this.n;this.s=!0,this.C(r);try{await this.p.trigger(()=>this.G())}catch(a){this.i.error(a)}return this.n}F(){if(!this.r){let r;E.$j?r=this.v.appRoot:r=(0,S.$dc)((0,S.$dc)(this.v.appRoot)),this.r=(0,S.$ac)(r,"bin",`${this.u.tunnelApplicationName}${E.$i?".exe":""}`)}return this.r}async startTunnel(r){if(s(this.j,r)&&this.n.type!=="disconnected")return this.n;this.C(r);try{await this.p.trigger(()=>this.G())}catch(a){this.i.error(a)}return this.n}async stopTunnel(){if(this.k&&(this.k.cancel(),this.k=void 0),!this.j.active)return;const r=this.j.asService;this.C(I.$X5b);try{r&&this.J("uninstallService",["service","uninstall"])}catch(a){this.i.error(a)}try{await this.J("stop",["kill"])}catch(a){this.i.error(a)}this.z(I.TunnelStates.disconnected())}async G(){this.t.publicLog2("remoteTunnel.enablement",{enabled:this.j.active,service:this.j.active&&this.j.asService}),this.k&&(this.k.cancel(),this.k=void 0);let r="",a=!1;const w=(F,V)=>{V?this.i.error(F):r+=F,!this.v.isBuilt&&F.startsWith("   Compiling")&&this.z(I.TunnelStates.connecting((0,v.localize)(0,null)))},g=this.J("status",["status"],w);this.k=g;try{if(await g,this.k!==g)return;const F=JSON.parse(r.trim().split(`
`).find(V=>V.startsWith("{")));if(a=F.service_installed,this.i.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.j.active){this.z(I.TunnelStates.disconnected());return}}catch(F){this.i.error(F),this.z(I.TunnelStates.disconnected());return}finally{this.k===g&&(this.k=void 0)}const f=this.j.active?this.j.session:void 0;if(f&&f.token){const F=f.token;this.z(I.TunnelStates.connecting((0,v.localize)(1,null,f.accountLabel,f.providerId)));const V=(x,Z)=>{x=x.replaceAll(F,"*".repeat(4)),w(x,Z)},B=this.J("login",["user","login","--provider",f.providerId,"--access-token",F,"--log",(0,P.$7i)(this.i.getLevel())],V);this.k=B;try{if(await B,this.k!==B)return}catch(x){this.i.error(x),this.k=void 0,this.f.fire(f),this.z(I.TunnelStates.disconnected(f));return}}const k=this.M();k?this.z(I.TunnelStates.connecting((0,v.localize)(2,null,k))):this.z(I.TunnelStates.connecting((0,v.localize)(3,null)));const A=["--accept-server-license-terms","--log",(0,P.$7i)(this.i.getLevel())];k?A.push("--name",k):A.push("--random-name");let M=!1;return this.j.active&&this.j.asService&&!a&&(M=await this.H(A)===!1),this.I(f,A,M)}async H(r){let a;try{a=await this.J("serviceInstall",["service","install",...r])}catch(w){this.i.error(w),a=1}if(a!==0){const w=(0,v.localize)(4,null);return this.i.warn(w),this.z(I.TunnelStates.connecting(w)),!1}return!0}async I(r,a,w){a.push("--parent-process-id",String(process.pid)),this.L()&&a.push("--no-sleep");let g=!1;const f=this.J("tunnel",a,(k,A)=>{A?this.i.error(k):this.i.info(k),k.includes("Connected to an existing tunnel process")&&(g=!0);const M=k.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const F={link:M[1],domain:M[2],tunnelName:M[4],isAttached:g};this.z(I.TunnelStates.connected(F,w))}else k.match(/error refreshing token/)&&(f.cancel(),this.f.fire(r),this.z(I.TunnelStates.disconnected(r)))});this.k=f,f.finally(()=>{f===this.k&&(this.i.info("tunnel process terminated"),this.k=void 0,this.j=I.$X5b,this.z(I.TunnelStates.disconnected()))})}J(r,a,w=this.D){return(0,m.$jg)(g=>new Promise((f,k)=>{g.isCancellationRequested&&f(-1);let A;const M=["ignore","pipe","pipe"];if(g.onCancellationRequested(()=>{A&&(this.i.info(`${r} terminating(${A.pid})`),A.kill())}),!this.v.isBuilt)w(`Building tunnel CLI from sources and run
`,!1),w(`${r} Spawning: cargo run -- tunnel ${a.join(" ")}
`,!1),A=(0,b.spawn)("cargo",["run","--","tunnel",...a],{cwd:(0,S.$ac)(this.v.appRoot,"cli"),stdio:M});else{w(`Running tunnel CLI
`,!1);const F=this.F();w(`${r} Spawning: ${F} tunnel ${a.join(" ")}
`,!1),A=(0,b.spawn)(F,["tunnel",...a],{cwd:(0,c.homedir)(),stdio:M})}A.stdout.pipe(new y.$kS(`
`)).on("data",F=>{if(A){const V=F.toString();w(V,!1)}}),A.stderr.pipe(new y.$kS(`
`)).on("data",F=>{if(A){const V=F.toString();w(V,!0)}}),A.on("exit",F=>{A&&(w(`${r} exit(${A.pid}): + ${F} `,!1),A=void 0,f(F||0))}),A.on("error",F=>{A&&(w(`${r} error(${A.pid}): + ${F} `,!0),A=void 0,k())})}))}async getTunnelName(){return this.M()}L(){return!!this.w.getValue(I.$15b)}M(){let r=this.w.getValue(I.$Z5b)||(0,c.hostname)();return r=r.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),r||void 0}N(){try{const r=this.y.get(R,-1),a=this.y.getBoolean(t,-1,!1);if(r){const w=JSON.parse(r);if(w&&(0,u.$je)(w.accountLabel)&&(0,u.$je)(w.sessionId)&&(0,u.$je)(w.providerId))return{active:!0,session:w,asService:a};this.i.error("Problems restoring session from storage, invalid format",w)}}catch(r){this.i.error("Problems restoring session from storage",r)}return I.$X5b}O(r){if(r.active){const a={providerId:r.session.providerId,sessionId:r.session.sessionId,accountLabel:r.session.accountLabel};this.y.store(R,JSON.stringify(a),-1,1),this.y.store(t,r.asService,-1,1)}else this.y.remove(R,-1),this.y.remove(t,-1)}};e.$75b=o,e.$75b=o=we([Y(0,O.$Vk),Y(1,C.$0i),Y(2,j.$xh),Y(3,P.$Si),Y(4,h.$55b),Y(5,d.$Vh),Y(6,l.$Ko)],o);function n(i,r){return i&&r?i.sessionId===r.sessionId&&i.providerId===r.providerId&&i.token===r.token:i===r}const s=(i,r)=>i.active!==r.active?!1:i.active&&r.active?i.asService===r.asService&&n(i.session,r.session):!0}),define(oe[245],ae([0,1,6,2,22,64,19,73,17]),function(ne,e,I,T,O,j,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_5b=void 0;class b extends L.$Mo{constructor(E,m,h,d){super(),this.X=E,this.Y=m,this.Z=h,this.$=d,this.p=this.Y.defaultProfile,this.s=this.ab(),this.P=this.Y.currentProfile,this.Q=this.B(new T.$kb),this.R=this.bb(this.P),this.S=this.X?.id,this.U=this.B(new T.$kb),this.W=this.cb(this.X)}ab(){const E=this.B(new P.$Zxb(this.Z.getChannel("storage"))),m=this.B(new j.$Go(E));return this.B(m.onDidChangeStorage(h=>this.n(-1,h))),m}bb(E){this.Q.clear(),this.P=E;let m;if((0,L.$No)(E))m=this.s;else{const h=this.Q.add(new P.$1xb(this.Z.getChannel("storage"),E));m=this.Q.add(new j.$Go(h))}return this.Q.add(m.onDidChangeStorage(h=>this.n(0,h))),m}cb(E){this.U.clear(),this.S=E?.id;let m;if(E){const h=this.U.add(new P.$2xb(this.Z.getChannel("storage"),E));m=this.U.add(new j.$Go(h)),this.U.add(m.onDidChangeStorage(d=>this.n(1,d)))}return m}async J(){await I.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(E){switch(E){case-1:return this.s;case 0:return this.R;default:return this.W}}M(E){switch(E){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,O.$0f)(this.$.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(L.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(E){if(!this.H(this.P,E))return;const m=this.R,h=m.items;m!==this.s&&await m.close(),this.R=this.bb(E),await this.R.init(),this.I(h,this.R,0)}async O(E,m){const h=this.W,d=h?.items??new Map;await h?.close(),this.W=this.cb(E),await this.W.init(),this.I(d,this.W,1)}hasScope(E){return(0,S.$qk)(E)?this.P.id===E.id:this.S===E.id}}e.$_5b=b}),define(oe[246],ae([0,1,3,2,17,91]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=void 0;class L{constructor(b,C){this.a=b,this.b=C}listen(b,C){const E=this.b(b);switch(C){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map(h=>(0,j.$pm)({...h},E)),added:m.added.map(h=>(0,j.$pm)({...h},E)),removed:m.removed.map(h=>(0,j.$pm)({...h},E)),updated:m.updated.map(h=>(0,j.$pm)({...h},E))}))}throw new Error(`Invalid listen ${C}`)}async call(b,C,E){const m=this.b(b);switch(C){case"createProfile":{const h=await this.a.createProfile(E[0],E[1],E[2]);return(0,j.$pm)({...h},m)}case"updateProfile":{let h=(0,O.$sk)((0,j.$qm)(E[0],m),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,E[1]),(0,j.$pm)({...h},m)}case"removeProfile":{const h=(0,O.$sk)((0,j.$qm)(E[0],m),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${C}`)}}e.$7M=L;class P extends T.$lb{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(b,C,E){super(),this.profilesHome=C,this.f=E,this.a=[],this.b=this.B(new I.$8c),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=b.map(m=>(0,O.$sk)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const h=m.added.map(c=>(0,O.$sk)(c,this.profilesHome.scheme)),d=m.removed.map(c=>(0,O.$sk)(c,this.profilesHome.scheme)),v=m.updated.map(c=>(0,O.$sk)(c,this.profilesHome.scheme));this.a=m.all.map(c=>(0,O.$sk)(c,this.profilesHome.scheme)),this.b.fire({added:h,removed:d,updated:v,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(b){this.c=b}isEnabled(){return this.c}async createNamedProfile(b,C,E){const m=await this.f.call("createNamedProfile",[b,C,E]);return(0,O.$sk)(m,this.profilesHome.scheme)}async createProfile(b,C,E,m){const h=await this.f.call("createProfile",[b,C,E,m]);return(0,O.$sk)(h,this.profilesHome.scheme)}async createTransientProfile(b){const C=await this.f.call("createTransientProfile",[b]);return(0,O.$sk)(C,this.profilesHome.scheme)}async setProfileForWorkspace(b,C){await this.f.call("setProfileForWorkspace",[b,C])}removeProfile(b){return this.f.call("removeProfile",[b])}async updateProfile(b,C){const E=await this.f.call("updateProfile",[b,C]);return(0,O.$sk)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$8M=P}),define(oe[58],ae([0,1,2,64,4,19,3,73,17]),function(ne,e,I,T,O,j,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6xb=e.$5xb=e.$4xb=void 0,e.$4xb=(0,O.$ph)("IUserDataProfileStorageService");let b=class extends I.$lb{constructor(h){super(),this.a=h}async readStorageData(h){return this.withProfileScopedStorageService(h,async d=>this.b(d))}async updateStorageData(h,d,v){return this.withProfileScopedStorageService(h,async c=>this.c(c,d,v))}async withProfileScopedStorageService(h,d){if(this.a.hasScope(h))return d(this.a);const v=await this.g(h),c=new E(v);try{await c.initialize();const l=await d(c);return await c.flush(),l}finally{c.dispose(),await this.f(v)}}b(h){const d=new Map,v=c=>{for(const l of h.keys(0,c))d.set(l,{value:h.get(l,0),target:c})};return v(0),v(1),d}c(h,d,v){h.storeAll(Array.from(d.entries()).map(([c,l])=>({key:c,value:l,scope:0,target:v})),!0)}async f(h){try{await h.close()}finally{(0,I.$fb)(h)&&h.dispose()}}};e.$5xb=b,e.$5xb=b=we([Y(0,j.$Ko)],b);class C extends b{constructor(h,d,v,c){super(v),this.i=h;const l=h.getChannel("profileStorageListener"),u=this.B(new I.$mb);this.h=this.B(new L.$8c({onWillAddFirstListener:()=>{u.value=l.listen("onDidChange")(y=>{c.trace("profile storage changes",y),this.h.fire({targetChanges:y.targetChanges.map(p=>(0,S.$sk)(p,d.profilesHome.scheme)),valueChanges:y.valueChanges.map(p=>({...p,profile:(0,S.$sk)(p.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(h){const d=this.i.getChannel("storage");return(0,j.$No)(h)?new P.$Zxb(d):new P.$1xb(d,h)}}e.$6xb=C;class E extends j.$Mo{constructor(h){super({flushInterval:100}),this.p=this.B(new T.$Go(h))}J(){return this.p.init()}L(h){return h===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(oe[247],ae([0,1,19,8,17,69,58]),function(ne,e,I,T,O,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q5b=void 0;let P=class extends L.$6xb{constructor(b,C,E,m){super(b,C,E,m)}};e.$Q5b=P,e.$Q5b=P=we([Y(0,j.$c5b),Y(1,O.$rk),Y(2,I.$Ko),Y(3,T.$Ri)],P)}),define(oe[39],ae([0,1,21,6,14,25,3,34,2,27,11,166,18,15,13,8,44,19,20,28,23,17]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u,y,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Syb=e.$Ryb=e.$Qyb=e.$Pyb=e.$Oyb=e.$Nyb=e.$Myb=void 0;function t(w){return!!(w&&w.ref!==void 0&&typeof w.ref=="string"&&w.ref!==""&&w.syncData!==void 0&&(w.syncData===null||o(w.syncData)))}e.$Myb=t;function o(w){return!!(w&&w.version!==void 0&&typeof w.version=="number"&&w.content!==void 0&&typeof w.content=="string"&&(Object.keys(w).length===2||Object.keys(w).length===3&&w.machineId!==void 0&&typeof w.machineId=="string"))}e.$Nyb=o;function n(w,g){return`${(0,b.$be)(w)}${g.isDefault?"":` (${g.name})`}`}e.$Oyb=n;let s=class extends S.$lb{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(g,f,k,A,M,F,V,B,x,Z,Q,J){super(),this.syncResource=g,this.collection=f,this.C=k,this.D=A,this.F=M,this.G=F,this.H=V,this.I=B,this.J=x,this.L=Z,this.M=Q,this.c=null,this.k="idle",this.l=this.B(new L.$8c),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new L.$8c),this.onDidChangeConflicts=this.n.event,this.s=new T.$tg(50),this.t=this.B(new L.$8c),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=n(g.syncResource,g.profile),this.h=J.extUri,this.f=this.h.joinPath(A.userDataSyncHome,...(0,p.$Web)(g.profile.isDefault?void 0:g.profile.id,g.syncResource)),this.g=this.h.joinPath(this.f,p.$ffb),this.u=(0,p.$Xeb)(g.profile.isDefault?void 0:g.profile.id,g.syncResource,A,this.h),this.j=(0,c.$Qo)(A,k,M)}N(){this.s.trigger(()=>this.O())}async O(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const g=await this.c;this.c=null;const f=await this.U(g.remoteUserData,g.lastSyncUserData,!0,this.lb());this.P(f)}else{this.L.trace(`${this.y}: Checking for local changes...`);const g=await this.getLastSyncUserData();(g?await this.rb(g):!0)&&this.t.fire()}}P(g){this.k!==g&&(this.k=g,this.l.fire(g))}async sync(g,f={}){await this.Q(g,!0,this.lb(),f)}async preview(g,f,k={}){return this.Q(g,!1,f,k)}async apply(g,f={}){try{this.z={...f};const k=await this.Y(g);return this.P(k),this.c}finally{this.z={}}}async Q(g,f,k,A){try{if(this.z={...A},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.P("syncing");let M="idle";try{const F=await this.getLastSyncUserData(),V=await this.S(g,F);return M=await this.U(V,F,f,k),M==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):M==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.P(M)}}finally{this.z={}}}async replace(g){const f=this.hb(g);if(!f)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.P("syncing");const k=await this.getLastSyncUserData(),A=await this.S(null,k),M=await this.R(A),F=await this.nb({ref:A.ref,syncData:f},k,M,this.lb(),j.CancellationToken.None),V=[];for(const B of F){const x=await this.pb(B,B.remoteResource,void 0,j.CancellationToken.None),{remoteChange:Z}=await this.pb(B,B.previewResource,B.remoteContent,j.CancellationToken.None);V.push([B,{...x,remoteChange:Z!==0?Z:2}])}await this.qb(A,k,V,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.P("idle")}return!0}async R(g){const f=await this.j;return!!g.syncData?.machineId&&g.syncData.machineId===f}async S(g,f){if(f){const k=g?g[this.resource]:void 0;if(f.ref===k||k===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async U(g,f,k,A){if(g.syncData&&g.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new p.$5eb((0,E.localize)(0,null,this.resource,this.mb,g.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.W(g,f,k,A)}catch(M){if(M instanceof p.$5eb)switch(M.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.U(g,f,k,A);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),g=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.U(g,f,k,A)}throw M}}async W(g,f,k,A){try{const M=await this.R(g),F=!M&&f===null&&this.db()!==void 0,V=k&&!F;this.c||(this.c=(0,T.$jg)(x=>this.bb(g,f,M,V,A,x)));let B=await this.c;if(k&&F){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const x of B.resourcePreviews)B=await this.accept(x.remoteResource)||B}return this.$(B.resourcePreviews),B.resourcePreviews.some(({mergeState:x})=>x==="conflict")?"hasConflicts":k?await this.Y(!1):"syncing"}catch(M){throw this.c=null,M}}async merge(g){return await this.X(g,async f=>{const k=await this.ob(f,j.CancellationToken.None);await this.C.writeFile(f.previewResource,O.$Jb.fromString(k?.content||""));const A=k&&!k.hasConflicts?await this.pb(f,f.previewResource,void 0,j.CancellationToken.None):void 0;return f.acceptResult=A,f.mergeState=k.hasConflicts?"conflict":A?"accepted":"preview",f.localChange=A?A.localChange:k.localChange,f.remoteChange=A?A.remoteChange:k.remoteChange,f}),this.c}async accept(g,f){return await this.X(g,async k=>{const A=await this.pb(k,g,f,j.CancellationToken.None);return k.acceptResult=A,k.mergeState="accepted",k.localChange=A.localChange,k.remoteChange=A.remoteChange,k}),this.c}async discard(g){return await this.X(g,async f=>{const k=await this.ob(f,j.CancellationToken.None);return await this.C.writeFile(f.previewResource,O.$Jb.fromString(k.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=k.localChange,f.remoteChange=k.remoteChange,f}),this.c}async X(g,f){if(!this.c)return;let k=await this.c;const A=k.resourcePreviews.findIndex(({localResource:M,remoteResource:F,previewResource:V})=>this.h.isEqual(M,g)||this.h.isEqual(F,g)||this.h.isEqual(V,g));A!==-1&&(this.c=(0,T.$jg)(async M=>{const F=[...k.resourcePreviews];return F[A]=await f(F[A]),{...k,resourcePreviews:F}}),k=await this.c,this.$(k.resourcePreviews),k.resourcePreviews.some(({mergeState:M})=>M==="conflict")?this.P("hasConflicts"):this.P("syncing"))}async Y(g){if(!this.c)return"idle";const f=await this.c;return f.resourcePreviews.some(({mergeState:k})=>k==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:k})=>k!=="accepted")?"syncing":(await this.qb(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(k=>[k,k.acceptResult]),g),this.c=null,await this.Z(),"idle")}async Z(){try{await this.C.del(this.g,{recursive:!0})}catch{}}$(g){const f=g.filter(({mergeState:k})=>k==="conflict");(0,I.$bf)(this.m,f,(k,A)=>this.h.isEqual(k.previewResource,A.previewResource))||(this.m=f,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const g=await this.getLastSyncUserData();return!!g&&g.syncData!==null}async ab(g){const f=this.c?await this.c:null;if(f)for(const k of f.resourcePreviews){if(this.h.isEqual(k.acceptedResource,g))return k.acceptResult?k.acceptResult.content:null;if(this.h.isEqual(k.remoteResource,g))return k.remoteContent;if(this.h.isEqual(k.localResource,g))return k.localContent;if(this.h.isEqual(k.baseResource,g))return k.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(g){(0,d.$9j)(g)!==1&&this.L.error(g)}}async bb(g,f,k,A,M,F){const V=await this.nb(g,f,k,M,F),B=[];for(const x of V){const Z=x.previewResource.with({scheme:p.$efb,authority:"accepted"});if(x.localChange===0&&x.remoteChange===0)B.push({...x,acceptedResource:Z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Q=A?await this.ob(x,F):void 0;if(F.isCancellationRequested)break;await this.C.writeFile(x.previewResource,O.$Jb.fromString(Q?.content||""));const J=Q&&!Q.hasConflicts?await this.pb(x,x.previewResource,void 0,F):void 0;B.push({...x,acceptResult:J,mergeState:Q?.hasConflicts?"conflict":J?"accepted":"preview",localChange:J?J.localChange:Q?Q.localChange:x.localChange,remoteChange:J?J.remoteChange:Q?Q.remoteChange:x.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:g,lastSyncUserData:f,resourcePreviews:B,isLastSyncFromCurrentMachine:k}}async getLastSyncUserData(){let g=this.db();if(g||(g=await this.gb()),!g)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const f=JSON.parse(g),k=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!f.version&&!!k&&f.version!==k,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${k}.`),await this.resetLocal(),null;let A,M=1;for(;A===void 0&&M++<6;)try{const F=await this.eb();F&&(F.ref===f.ref?A=F.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof d.$ak&&F.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(F instanceof p.$5eb)throw F;this.L.error(F,M)}}if(A===void 0)try{const F=await this.G.resolveResourceContent(this.resource,f.ref,this.collection,this.z);A=F===null?null:this.hb(F),await this.fb({ref:f.ref,syncData:A})}catch(F){if(F instanceof p.$5eb&&F.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw F}return A===void 0?null:{...f,syncData:A}}async cb(g,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const k=this.I.getResourceSyncStateVersion(this.resource),A={ref:g.ref,version:k,...f};this.F.store(this.v,JSON.stringify(A),-1,1),await this.fb(g)}db(){return this.F.get(this.v,-1)}async eb(){const g=(await this.C.readFile(this.u)).value.toString();try{const f=g?JSON.parse(g):void 0;if(t(f))return f}catch(f){this.L.error(f)}}async fb(g){await this.C.writeFile(this.u,O.$Jb.fromString(JSON.stringify(g)))}async gb(){try{const g=await this.C.readFile(this.u),f=JSON.parse(g.value.toString());await this.C.del(this.u),f.ref&&f.content!==void 0?(this.F.store(this.v,JSON.stringify({...f,content:void 0}),-1,1),await this.fb({ref:f.ref,syncData:f.content===null?null:JSON.parse(f.content)})):this.L.info(`${this.y}: Migrating last sync user data. Invalid data.`,f)}catch(g){g instanceof d.$ak&&g.fileOperationResult===1?this.L.info(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(g)}return this.F.get(this.v,-1)}async getRemoteUserData(g){const{ref:f,content:k}=await this.ib(g);let A=null;return k!==null&&(A=this.hb(k)),{ref:f,syncData:A}}hb(g){try{const f=JSON.parse(g);if(o(f))return f}catch(f){this.L.error(f)}throw new p.$5eb((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(g){const f=g?{ref:g.ref,content:g.syncData?JSON.stringify(g.syncData):null}:null;return this.G.readResource(this.resource,f,this.collection,this.z)}async jb(g,f){const k=await this.j,A={version:this.mb,machineId:k,content:g};try{return f=await this.G.writeResource(this.resource,JSON.stringify(A),f,this.collection,this.z),{ref:f,syncData:A}}catch(M){throw M instanceof p.$5eb&&M.code==="TooLarge"&&(M=new p.$5eb(M.message,M.code,this.resource)),M}}async kb(g){const f={version:this.mb,content:g};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(f))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.$([]),await this.Z(),this.P("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(p.$Reb)}};e.$Pyb=s,e.$Pyb=s=we([Y(2,d.$Sj),Y(3,h.$wh),Y(4,l.$Ko),Y(5,p.$Zeb),Y(6,p.$1eb),Y(7,p.$0eb),Y(8,u.$Vk),Y(9,p.$cfb),Y(10,m.$Vh),Y(11,y.$pk)],s);let i=class extends s{constructor(g,f,k,A,M,F,V,B,x,Z,Q,J,X){super(f,k,A,M,F,V,B,x,Z,Q,J,X),this.i=g,this.B(this.C.watch(this.h.dirname(g))),this.B(this.C.onDidFilesChange(W=>this.tb(W)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(g,f,k){try{f?await this.C.writeFile(this.i,O.$Jb.fromString(g),k?void 0:f):await this.C.createFile(this.i,O.$Jb.fromString(g),{overwrite:k})}catch(A){throw A instanceof d.$ak&&A.fileOperationResult===1||A instanceof d.$ak&&A.fileOperationResult===3?new p.$5eb(A.message,"LocalPreconditionFailed"):A}}async sb(){try{await this.C.del(this.i)}catch(g){if(!(g instanceof d.$ak&&g.fileOperationResult===1))throw g}}tb(g){g.contains(this.i)&&this.N()}};e.$Qyb=i,e.$Qyb=i=we([Y(3,d.$Sj),Y(4,h.$wh),Y(5,l.$Ko),Y(6,p.$Zeb),Y(7,p.$1eb),Y(8,p.$0eb),Y(9,u.$Vk),Y(10,p.$cfb),Y(11,m.$Vh),Y(12,y.$pk)],i);let r=class extends i{constructor(g,f,k,A,M,F,V,B,x,Z,Q,J,X,W){super(g,f,k,A,M,F,V,B,x,Z,Q,X,W),this.ub=J,this.wb=void 0}vb(g,f){const k=[],A=(0,P.$xm)(g,k,{allowEmptyContent:!0,allowTrailingComma:!0});return k.length>0||!(0,C.$qe)(A)&&f!==Array.isArray(A)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};e.$Ryb=r,e.$Ryb=r=we([Y(3,d.$Sj),Y(4,h.$wh),Y(5,l.$Ko),Y(6,p.$Zeb),Y(7,p.$1eb),Y(8,p.$0eb),Y(9,u.$Vk),Y(10,p.$cfb),Y(11,p.$bfb),Y(12,m.$Vh),Y(13,y.$pk)],r);let a=class{constructor(g,f,k,A,M,F,V){this.resource=g,this.g=f,this.h=k,this.j=A,this.k=M,this.l=F,this.d=V.extUri,this.f=(0,p.$Xeb)(void 0,this.resource,k,this.d)}async initialize({ref:g,content:f}){if(!f){this.j.info("Remote content does not exist.",this.resource);return}const k=this.m(f);if(k)try{await this.o({ref:g,syncData:k})}catch(A){this.j.error(A)}}m(g){try{const f=JSON.parse(g);if(o(f))return f}catch(f){this.j.error(f)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(g,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const k={ref:g.ref,version:void 0,...f};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(k),-1,1),await this.k.writeFile(this.f,O.$Jb.fromString(JSON.stringify(g)))}};e.$Syb=a,e.$Syb=a=we([Y(1,R.$rk),Y(2,h.$wh),Y(3,v.$Ri),Y(4,d.$Sj),Y(5,l.$Ko),Y(6,y.$pk)],a)}),define(oe[114],ae([0,1,6,25,7,3,41,2,27,18,15,113,29,33,78,45,13,4,68,8,19,20,28,17,39,228,111,23,58]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u,y,p,R,t,o,n,s,i,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JZb=e.$IZb=e.$HZb=e.$GZb=e.$FZb=void 0;async function w(F,V){const B=JSON.parse(F.content);if(F.version===1||F.version===2){const x=(await V.getInstalled(0)).filter(Z=>Z.isBuiltin);for(const Z of B)F.version===1&&(Z.enabled===!1&&(Z.disabled=!0),delete Z.enabled),F.version===2&&x.every(Q=>!(0,h.$fo)(Q.identifier,Z.identifier))&&(Z.installed=!0)}return B}function g(F){return JSON.parse(F.content)}e.$FZb=g;function f(F,V){return F.sort((B,x)=>!B.identifier.uuid&&x.identifier.uuid?-1:B.identifier.uuid&&!x.identifier.uuid?1:(0,S.$Fd)(B.identifier.id,x.identifier.id)),V?(0,L.$7R)(F,{}):JSON.stringify(F)}e.$GZb=f;let k=class extends n.$Pyb{constructor(V,B,x,Z,Q,J,X,W,U,q,te,re,ce,G,N,$,D){super({syncResource:"extensions",profile:V},B,Z,x,Q,J,X,re,ce,q,te,N),this.yb=W,this.zb=U,this.Ab=D,this.mb=6,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:r.$efb,authority:"base"}),this.ub=this.sb.with({scheme:r.$efb,authority:"local"}),this.vb=this.sb.with({scheme:r.$efb,authority:"remote"}),this.wb=this.sb.with({scheme:r.$efb,authority:"accepted"}),this.xb=this.Ab.createInstance(A),this.B(j.Event.any(j.Event.filter(this.yb.onDidInstallExtensions,z=>z.some(({local:K})=>!!K)),j.Event.filter(this.yb.onDidUninstallExtension,z=>!z.error),j.Event.filter($.onDidChange,z=>z.valueChanges.some(({profile:K,changes:_})=>this.syncResource.profile.id===K.id&&_.some(H=>H.key===m.$Sn))),G.onDidChangeExtensionStorageToSync)(()=>this.N()))}async nb(V,B){const x=V.syncData?await w(V.syncData,this.yb):null,Z=B?.skippedExtensions??[],Q=B?.builtinExtensions??null,J=B?.syncData?await w(B.syncData,this.yb):null,{localExtensions:X,ignoredExtensions:W}=await this.xb.getLocalExtensions(this.syncResource.profile);x?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:U,remote:q}=(0,s.$EZb)(X,x,J,Z,W,Q),te={local:U,remote:q,content:this.Db(X,U.added,U.updated,U.removed),localChange:U.added.length>0||U.removed.length>0||U.updated.length>0?2:0,remoteChange:q!==null?2:0},re=this.Kb(X,!1);return[{skippedExtensions:Z,builtinExtensions:Q,baseResource:this.tb,baseContent:J?this.Kb(J,!1):re,localResource:this.ub,localContent:re,localExtensions:X,remoteResource:this.vb,remoteExtensions:x,remoteContent:x?this.Kb(x,!1):null,previewResource:this.sb,previewResult:te,localChange:te.localChange,remoteChange:te.remoteChange,acceptedResource:this.wb}]}async rb(V){const B=V.syncData?await w(V.syncData,this.yb):null,{localExtensions:x,ignoredExtensions:Z}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,s.$EZb)(x,B,B,V.skippedExtensions||[],Z,V.builtinExtensions||[]);return Q!==null}Db(V,B,x,Z){const Q=[...B,...x],J=new Set,X=W=>{J.add(W.id.toLowerCase()),W.uuid&&J.add(W.uuid)};Q.forEach(({identifier:W})=>X(W)),Z.forEach(X);for(const W of V)J.has(W.identifier.id.toLowerCase())||W.identifier.uuid&&J.has(W.identifier.uuid)||Q.push(W);return this.Kb(Q,!1)}async ob(V,B){return{...V.previewResult,hasConflicts:!1}}async pb(V,B,x,Z){if(this.h.isEqual(B,this.ub))return this.Gb(V);if(this.h.isEqual(B,this.vb))return this.Hb(V);if(this.h.isEqual(B,this.sb))return V.previewResult;throw new Error(`Invalid Resource: ${B.toString()}`)}async Gb(V){const B=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),x=this.zb.getIgnoredExtensions(B),Z=(0,s.$EZb)(V.localExtensions,null,null,V.skippedExtensions,x,V.builtinExtensions),{local:Q,remote:J}=Z;return{content:V.localContent,local:Q,remote:J,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:J!==null?2:0}}async Hb(V){const B=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),x=this.zb.getIgnoredExtensions(B),Z=V.remoteContent?JSON.parse(V.remoteContent):null;if(Z!==null){const Q=(0,s.$EZb)(V.localExtensions,Z,V.localExtensions,[],x,V.builtinExtensions),{local:J,remote:X}=Q;return{content:V.remoteContent,local:J,remote:X,localChange:J.added.length>0||J.removed.length>0||J.updated.length>0?2:0,remoteChange:X!==null?2:0}}else return{content:V.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(V,B,x,Z){let{skippedExtensions:Q,builtinExtensions:J,localExtensions:X}=x[0][0];const{local:W,remote:U,localChange:q,remoteChange:te}=x[0][1];if(q===0&&te===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),q!==0&&(await this.kb(JSON.stringify(X)),Q=await this.xb.updateLocalExtensions(W.added,W.removed,W.updated,Q,this.syncResource.profile)),U){this.L.trace(`${this.y}: Updating remote extensions...`);const re=JSON.stringify(U.all);V=await this.jb(re,Z?null:V.ref),this.L.info(`${this.y}: Updated remote extensions.${U.added.length?` Added: ${JSON.stringify(U.added.map(ce=>ce.identifier.id))}.`:""}${U.updated.length?` Updated: ${JSON.stringify(U.updated.map(ce=>ce.identifier.id))}.`:""}${U.removed.length?` Removed: ${JSON.stringify(U.removed.map(ce=>ce.identifier.id))}.`:""}`)}B?.ref!==V.ref&&(this.L.trace(`${this.y}: Updating last synchronized extensions...`),J=this.Jb(X,J),await this.cb(V,{skippedExtensions:Q,builtinExtensions:J}),this.L.info(`${this.y}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(re=>re.identifier.id))}.`:""}`))}Jb(V,B){const x=new Set,Z=[];for(const Q of V)x.add(Q.identifier.id.toLowerCase()),Q.installed||Z.push(Q.identifier);if(B)for(const Q of B)x.has(Q.id.toLowerCase())||Z.push(Q);return Z}async resolveContent(V){if(this.h.isEqual(this.vb,V)||this.h.isEqual(this.tb,V)||this.h.isEqual(this.ub,V)||this.h.isEqual(this.wb,V)){const B=await this.ab(V);return B&&this.Kb(JSON.parse(B),!0)}return null}Kb(V,B){return f(V,B)}async hasLocalData(){try{const{localExtensions:V}=await this.xb.getLocalExtensions(this.syncResource.profile);if(V.some(B=>B.installed||B.disabled))return!0}catch{}return!1}};e.$HZb=k,e.$HZb=k=we([Y(2,C.$wh),Y(3,c.$Sj),Y(4,p.$Ko),Y(5,r.$Zeb),Y(6,r.$1eb),Y(7,m.$Rn),Y(8,i.$xzb),Y(9,r.$cfb),Y(10,b.$Vh),Y(11,r.$0eb),Y(12,R.$Vk),Y(13,d.$Cz),Y(14,t.$pk),Y(15,a.$4xb),Y(16,l.$oh)],k);let A=class{constructor(V,B,x,Z,Q,J){this.a=V,this.b=B,this.c=x,this.d=Z,this.f=Q,this.g=J}async getLocalExtensions(V){const B=await this.a.getInstalled(void 0,V.extensionsResource),x=this.d.getIgnoredExtensions(B);return{localExtensions:await this.j(V,async(Q,J)=>{const X=Q.getDisabledExtensions();return B.map(W=>{const{identifier:U,isBuiltin:q,manifest:te,preRelease:re,pinned:ce,isApplicationScoped:G}=W,N={identifier:U,preRelease:re,version:te.version,pinned:!!ce};G&&!(0,v.$Kl)(te)&&(N.isApplicationScoped=G),X.some($=>(0,h.$fo)($,U))&&(N.disabled=!0),q||(N.installed=!0);try{const $=J.getKeysForSync({id:U.id,version:te.version});if($){const D=J.getExtensionState(W,!0)||{};N.state=Object.keys(D).reduce((z,K)=>($.includes(K)&&(z[K]=D[K]),z),{})}}catch($){this.g.info(`${(0,n.$Oyb)("extensions",V)}: Error while parsing extension state`,(0,O.$9)($))}return N})}),ignoredExtensions:x}}async updateLocalExtensions(V,B,x,Z,Q){const J=(0,n.$Oyb)("extensions",Q),X=[],W=new Map,U=[],q=[],te=await this.a.getInstalled(void 0,Q.extensionsResource);if((V.length||x.length)&&await this.j(Q,async(G,N)=>{await I.Promises.settled([...V,...x].map(async $=>{const D=te.find(_=>(0,h.$fo)(_.identifier,$.identifier));if(D&&D.isBuiltin){$.state&&D.manifest.version===$.version&&this.h($.state,D,D.manifest.version,N),G.getDisabledExtensions().some(H=>(0,h.$fo)(H,$.identifier))!==!!$.disabled&&($.disabled?(this.g.trace(`${J}: Disabling extension...`,$.identifier.id),await G.disableExtension($.identifier),this.g.info(`${J}: Disabled extension`,$.identifier.id)):(this.g.trace(`${J}: Enabling extension...`,$.identifier.id),await G.enableExtension($.identifier),this.g.info(`${J}: Enabled extension`,$.identifier.id))),U.push($.identifier);return}const z=$.pinned?$.version:void 0,K=(await this.c.getExtensions([{...$.identifier,version:z,preRelease:z?void 0:$.preRelease}],T.CancellationToken.None))[0];if($.state&&(D?D.manifest.version===$.version:K)&&this.h($.state,D||K,D?.manifest.version,N),K)try{G.getDisabledExtensions().some(H=>(0,h.$fo)(H,$.identifier))!==!!$.disabled&&($.disabled?(this.g.trace(`${J}: Disabling extension...`,$.identifier.id,K.version),await G.disableExtension(K.identifier),this.g.info(`${J}: Disabled extension`,$.identifier.id,K.version)):(this.g.trace(`${J}: Enabling extension...`,$.identifier.id,K.version),await G.enableExtension(K.identifier),this.g.info(`${J}: Enabled extension`,$.identifier.id,K.version))),(!D||D.preRelease!==$.preRelease||D.pinned!==$.pinned||z&&D.manifest.version!==z)&&(await this.a.canInstall(K)?(X.push({extension:K,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:$.pinned&&!!$.version,installPreReleaseVersion:$.preRelease,profileLocation:Q.extensionsResource,isApplicationScoped:$.isApplicationScoped,context:{[m.$Gn]:!0,[m.$Hn]:!0}}}),W.set(K.identifier.id.toLowerCase(),$)):(this.g.info(`${J}: Skipped synchronizing extension because it cannot be installed.`,K.displayName||K.identifier.id),q.push($)))}catch(_){q.push($),this.g.error(_),this.g.info(`${J}: Skipped synchronizing extension`,K.displayName||K.identifier.id)}else q.push($),this.g.info(`${J}: Skipped synchronizing extension because the extension is not found.`,$.identifier.id)}))}),B.length){const G=te.filter(({identifier:N,isBuiltin:$})=>!$&&B.some(D=>(0,h.$fo)(N,D)));await I.Promises.settled(G.map(async N=>{this.g.trace(`${J}: Uninstalling local extension...`,N.identifier.id),await this.a.uninstall(N,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.g.info(`${J}: Uninstalled local extension.`,N.identifier.id),U.push(N.identifier)}))}const re=await this.a.installGalleryExtensions(X);for(const{identifier:G,local:N,error:$,source:D}of re){const z=D;if(N)this.g.info(`${J}: Installed extension.`,G.id,z.version),U.push(G);else{const K=W.get(G.id.toLowerCase());K&&(q.push(K),this.g.info(`${J}: Skipped synchronizing extension`,z.displayName||z.identifier.id)),$ instanceof m.$Qn&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes($.code)?this.g.info(`${J}: Skipped synchronizing extension because the compatible extension is not found.`,z.displayName||z.identifier.id):$&&this.g.error($)}}const ce=[];for(const G of Z)U.some(N=>(0,h.$fo)(N,G.identifier))||ce.push(G);for(const G of q)ce.some(N=>(0,h.$fo)(N.identifier,G.identifier))||ce.push(G);return ce}h(V,B,x,Z){const Q=Z.getExtensionState(B,!0)||{},J=x?Z.getKeysForSync({id:B.identifier.id,version:x}):void 0;J?J.forEach(X=>{Q[X]=V[X]}):Object.keys(V).forEach(X=>Q[X]=V[X]),Z.setExtensionState(B,Q,!0)}async j(V,B){return this.b.withProfileScopedStorageService(V,async x=>{const Z=new P.$kb,Q=this.f.createChild(new u.$nh([p.$Ko,x])),J=Z.add(Q.createInstance(E.$pxb)),X=Z.add(Q.createInstance(d.$Dz));try{return await B(J,X)}finally{Z.dispose()}})}};e.$IZb=A,e.$IZb=A=we([Y(0,m.$Rn),Y(1,a.$4xb),Y(2,m.$Pn),Y(3,i.$xzb),Y(4,l.$oh),Y(5,r.$cfb)],A);let M=class extends n.$Syb{constructor(V,B,x,Z,Q,J,X,W){super("extensions",Z,Q,J,x,X,W),this.p=V,this.q=B}async t(V){return V.syncData?await w(V.syncData,this.p):null}u(V,B){const x=[],Z=[],Q=[];for(const J of V){if(this.q.hasToNeverSyncExtension(J.identifier.id))continue;const X=B.find(W=>(0,h.$fo)(W.identifier,J.identifier));X?(x.push(X),J.disabled&&Q.push(J.identifier)):J.installed&&(Z.push({...J.identifier,preRelease:!!J.preRelease}),J.disabled&&Q.push(J.identifier))}return{installedExtensions:x,newExtensions:Z,disabledExtensions:Q,remoteExtensions:V}}};e.$JZb=M,e.$JZb=M=we([Y(0,m.$Rn),Y(1,i.$xzb),Y(2,c.$Sj),Y(3,o.$rk),Y(4,C.$wh),Y(5,y.$Ri),Y(6,p.$Ko),Y(7,t.$pk)],M)}),define(oe[115],ae([0,1,14,7,3,34,41,5,32,18,15,13,8,44,19,20,28,39,75,232,23,17,58,4]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u,y,p,R,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yyb=e.$Xyb=e.$Wyb=e.$Vyb=e.$Uyb=void 0;const n="globalState.argv.",s=["locale"];function i(k,A){const M=k.storage?Object.keys(k.storage).sort():[],F={};return M.forEach(V=>F[V]=k.storage[V]),k.storage=F,A?(0,L.$7R)(k,{}):JSON.stringify(k)}e.$Uyb=i;const r=1;let a=class extends l.$Pyb{constructor(A,M,F,V,B,x,Z,Q,J,X,W,U,q,te){super({syncResource:"globalState",profile:A},M,V,Q,U,B,x,J,X,Z,W,q),this.wb=F,this.mb=r,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:p.$efb,authority:"base"}),this.sb=this.p.with({scheme:p.$efb,authority:"local"}),this.tb=this.p.with({scheme:p.$efb,authority:"remote"}),this.ub=this.p.with({scheme:p.$efb,authority:"accepted"}),this.vb=te.createInstance(w),this.B(V.watch(this.h.dirname(this.D.argvResource))),this.B(O.Event.any(O.Event.filter(V.onDidFilesChange,re=>re.contains(this.D.argvResource)),O.Event.filter(F.onDidChange,re=>!!(re.targetChanges.some(ce=>this.syncResource.profile.id===ce.id)||re.valueChanges.some(({profile:ce,changes:G})=>this.syncResource.profile.id===ce.id&&G.some(N=>N.target===0)))))(()=>this.N()))}async nb(A,M,F){const V=A.syncData?JSON.parse(A.syncData.content):null;M=M===null&&F?A:M;const B=M&&M.syncData?JSON.parse(M.syncData.content):null,x=await this.vb.getLocalGlobalState(this.syncResource.profile);V?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Z=await this.Eb(B),{local:Q,remote:J}=(0,y.$Tyb)(x.storage,V?V.storage:null,B?B.storage:null,Z,this.L),X={content:null,local:Q,remote:J,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?2:0,remoteChange:J.all!==null?2:0},W=i(x,!1);return[{baseResource:this.r,baseContent:B?i(B,!1):W,localResource:this.sb,localContent:W,localUserData:x,remoteResource:this.tb,remoteContent:V?i(V,!1):null,previewResource:this.p,previewResult:X,localChange:X.localChange,remoteChange:X.remoteChange,acceptedResource:this.ub,storageKeys:Z}]}async rb(A){const M=A.syncData?JSON.parse(A.syncData.content):null;if(M===null)return!0;const F=await this.vb.getLocalGlobalState(this.syncResource.profile),V=await this.Eb(M),{remote:B}=(0,y.$Tyb)(F.storage,M.storage,M.storage,V,this.L);return B.all!==null}async ob(A,M){return{...A.previewResult,hasConflicts:!1}}async pb(A,M,F,V){if(this.h.isEqual(M,this.sb))return this.Bb(A);if(this.h.isEqual(M,this.tb))return this.Cb(A);if(this.h.isEqual(M,this.p))return A.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Bb(A){return{content:A.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(A.localUserData.storage),removed:[],updated:[],all:A.localUserData.storage},localChange:0,remoteChange:2}}async Cb(A){if(A.remoteContent!==null){const M=JSON.parse(A.remoteContent),{local:F,remote:V}=(0,y.$Tyb)(A.localUserData.storage,M.storage,null,A.storageKeys,this.L);return{content:A.remoteContent,local:F,remote:V,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:V!==null?2:0}}else return{content:A.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(A,M,F,V){const{localUserData:B}=F[0][0],{local:x,remote:Z,localChange:Q,remoteChange:J}=F[0][1];if(Q===0&&J===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),Q!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify(B)),await this.vb.writeLocalGlobalState(x,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),J!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const X=JSON.stringify({storage:Z.all});A=await this.jb(X,V?null:A.ref),this.L.info(`${this.y}: Updated remote ui state.${Z.added.length?` Added: ${Z.added}.`:""}${Z.updated.length?` Updated: ${Z.updated}.`:""}${Z.removed.length?` Removed: ${Z.removed}.`:""}`)}M?.ref!==A.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(A),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(A){if(this.h.isEqual(this.tb,A)||this.h.isEqual(this.r,A)||this.h.isEqual(this.sb,A)||this.h.isEqual(this.ub,A)){const M=await this.ab(A);return M&&i(JSON.parse(M),!0)}return null}async hasLocalData(){try{const{storage:A}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(A).length>1||A[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(A){const M=await this.wb.readStorageData(this.syncResource.profile),F=[],V=[];for(const[Z,Q]of M)Q.target===0?F.push(Z):Q.target===1&&V.push(Z);const B=[...F,...V],x=A?.storage?Object.keys(A.storage).filter(Z=>!Z.startsWith(n)&&!B.includes(Z)&&M.get(Z)!==void 0):[];if(!P.$o){const Z=[...p.$Veb.map(Q=>(0,p.$9eb)(Q)),p.$8eb];x.push(...Z),V.push(...Z)}return{user:F,machine:V,unregistered:x}}};e.$Vyb=a,e.$Vyb=a=we([Y(2,t.$4xb),Y(3,E.$Sj),Y(4,p.$Zeb),Y(5,p.$1eb),Y(6,p.$cfb),Y(7,C.$wh),Y(8,p.$0eb),Y(9,v.$Vk),Y(10,b.$Vh),Y(11,d.$Ko),Y(12,c.$pk),Y(13,o.$oh)],a);let w=class{constructor(A,M,F,V){this.a=A,this.b=M,this.c=F,this.d=V}async getLocalGlobalState(A){const M={};if(A.isDefault){const V=await this.f(),B=(0,j.$xm)(V);for(const x of s)B[x]!==void 0&&(M[`${n}${x}`]={version:1,value:B[x]})}const F=await this.c.readStorageData(A);for(const[V,B]of F)B.value&&B.target===0&&(M[V]={version:1,value:B.value});return{storage:M}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const A=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),A.value.toString()}catch(A){this.d.debug((0,T.$9)(A))}return"{}"}async writeLocalGlobalState({added:A,removed:M,updated:F},V){const B=(0,l.$Oyb)("globalState",V),x={},Z=new Map,Q=await this.c.readStorageData(V),J=(X,W)=>{for(const U of X){if(U.startsWith(n)){x[U.substring(n.length)]=W?W[U].value:void 0;continue}if(W){const q=W[U];q.value!==Q.get(U)?.value&&Z.set(U,q.value)}else Q.get(U)!==void 0&&Z.set(U,void 0)}};if(J(Object.keys(A),A),J(Object.keys(F),F),J(M),Object.keys(x).length){this.d.trace(`${B}: Updating locale...`);const X=await this.f();let W=X;for(const U of Object.keys(x))W=(0,u.edit)(W,[U],x[U],{});X!==W&&(this.d.trace(`${B}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$Jb.fromString(W)),this.d.info(`${B}: Updated locale.`)),this.d.info(`${B}: Updated locale`)}Z.size&&(this.d.trace(`${B}: Updating global state...`),await this.c.updateStorageData(V,Z,0),this.d.info(`${B}: Updated global state`,[...Z.keys()]))}};e.$Wyb=w,e.$Wyb=w=we([Y(0,E.$Sj),Y(1,C.$wh),Y(2,t.$4xb),Y(3,p.$cfb)],w);let g=class extends l.$Syb{constructor(A,M,F,V,B,x){super("globalState",F,V,B,M,A,x)}async o(A){const M=A.syncData?JSON.parse(A.syncData.content):null;if(!M){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},V={};for(const B of Object.keys(M.storage))B.startsWith(n)?F[B.substring(n.length)]=M.storage[B].value:this.l.get(B,0)===void 0&&(V[B]=M.storage[B].value);if(Object.keys(F).length){let B="{}";try{B=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const x of Object.keys(F))B=(0,u.edit)(B,[x],F[x],{});await this.k.writeFile(this.h.argvResource,I.$Jb.fromString(B))}if(Object.keys(V).length){const B=[];for(const x of Object.keys(V))B.push({key:x,value:V[x],scope:0,target:0});this.l.storeAll(B,!0)}}};e.$Xyb=g,e.$Xyb=g=we([Y(0,d.$Ko),Y(1,E.$Sj),Y(2,R.$rk),Y(3,C.$wh),Y(4,p.$cfb),Y(5,c.$pk)],g);let f=class{constructor(A,M,F,V,B){this.a=A,this.b=M,this.c=F,this.d=V,this.f=B}getSyncStoreType(A){return this.h(A)?.storage[p.$8eb]?.value}async sync(A){const M=(0,p.$4eb)((0,S.$6e)());try{return await this.g(A,M)}catch(F){if(F instanceof p.$5eb)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(A,M)}throw F}}async g(A,M){const F=await this.a.readResource("globalState",null,void 0,M),V=this.h(F)||{storage:{}};V.storage[p.$8eb]={value:A,version:r};const B=await(0,h.$Qo)(this.c,this.d,this.b),x={version:r,machineId:B,content:i(V,!1)};await this.a.writeResource("globalState",JSON.stringify(x),F.ref,void 0,M)}h({content:A}){if(!A)return null;const M=JSON.parse(A);if((0,l.$Nyb)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};e.$Yyb=f,e.$Yyb=f=we([Y(1,d.$Ko),Y(2,C.$wh),Y(3,E.$Sj),Y(4,m.$Ri)],f)}),define(oe[116],ae([0,1,21,14,3,34,5,11,167,18,15,13,19,20,28,17,39,229,23]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NZb=e.$MZb=e.$LZb=void 0;function y(t,o,n){try{const s=JSON.parse(t);if(!o)return(0,P.$qe)(s.all)?null:s.all;switch(L.OS){case 2:return(0,P.$qe)(s.mac)?null:s.mac;case 3:return(0,P.$qe)(s.linux)?null:s.linux;case 1:return(0,P.$qe)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.$LZb=y;let p=class extends c.$Ryb{constructor(o,n,s,i,r,a,w,g,f,k,A,M,F){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,g,f,k,s,i,w,M,r,A,a,F),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:u.$efb,authority:"base"}),this.Bb=this.zb.with({scheme:u.$efb,authority:"local"}),this.Cb=this.zb.with({scheme:u.$efb,authority:"remote"}),this.Db=this.zb.with({scheme:u.$efb,authority:"accepted"}),this.B(O.Event.filter(a.onDidChangeConfiguration,V=>V.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.N()))}async nb(o,n,s,i){const r=o.syncData?y(o.syncData.content,i.keybindingsPerPlatform??this.Lb(),this.L):null;n=n===null&&s?o:n;const a=n?this.Jb(n):null,w=await this.p(),g=await this.xb();let f=null,k=!1,A=!1,M=!1;if(r){let B=w?w.value.toString():"[]";if(B=B||"[]",this.vb(B,!0))throw new u.$5eb((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==B||a!==r){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const x=await(0,l.$KZb)(B,r,a,g,this.ub);x.hasChanges&&(f=x.mergeContent,M=x.hasConflicts,k=M||x.mergeContent!==B,A=M||x.mergeContent!==r)}}else w&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=w.value.toString(),A=!0);const F={content:M?a:f,localChange:k?w?2:1:0,remoteChange:A?2:0,hasConflicts:M},V=w?w.value.toString():null;return[{fileContent:w,baseResource:this.Ab,baseContent:a,localResource:this.Bb,localContent:V,localChange:F.localChange,remoteResource:this.Cb,remoteContent:r,remoteChange:F.remoteChange,previewResource:this.zb,previewResult:F,acceptedResource:this.Db}]}async rb(o){const n=this.Jb(o);if(n===null)return!0;const s=await this.p(),i=s?s.value.toString():"",r=await this.xb(),a=await(0,l.$KZb)(i||"[]",n,n,r,this.ub);return a.hasConflicts||a.mergeContent!==n}async ob(o,n){return o.previewResult}async pb(o,n,s,i){if(this.h.isEqual(n,this.Bb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Cb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.zb))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async qb(o,n,s,i){const{fileContent:r}=s[0][0];let{content:a,localChange:w,remoteChange:g}=s[0][1];if(w===0&&g===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.vb(a,!0)))throw new u.$5eb((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(w!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),r&&await this.kb(this.Kb(r.value.toString())),await this.r(a||"[]",r,i),this.L.info(`${this.y}: Updated local keybindings`)),g!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const f=this.Kb(a||"[]",o.syncData?.content);o=await this.jb(f,i?null:o.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}n?.ref!==o.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(o,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.p();if(o){const n=(0,j.$xm)(o.value.toString());if((0,I.$qf)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Cb,o)||this.h.isEqual(this.Ab,o)||this.h.isEqual(this.Bb,o)||this.h.isEqual(this.Db,o)?this.ab(o):null}Jb(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Lb()?null:y(o.syncData.content,this.Lb(),this.L)}Kb(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(i){this.L.error(i)}switch(this.Lb()?delete s.all:s.all=o,L.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}Lb(){return!!this.M.getValue(u.$Seb)}};e.$MZb=p,e.$MZb=p=we([Y(2,u.$Zeb),Y(3,u.$1eb),Y(4,u.$cfb),Y(5,b.$Vh),Y(6,u.$0eb),Y(7,E.$Sj),Y(8,C.$wh),Y(9,m.$Ko),Y(10,u.$bfb),Y(11,h.$Vk),Y(12,d.$pk)],p);let R=class extends c.$Syb{constructor(o,n,s,i,r,a){super("keybindings",n,s,i,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,T.$Jb.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,j.$xm)(o.value.toString());return!(0,I.$qf)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return y(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$NZb=R,e.$NZb=R=we([Y(0,E.$Sj),Y(1,v.$rk),Y(2,C.$wh),Y(3,u.$cfb),Y(4,m.$Ko),Y(5,d.$pk)],R)}),define(oe[117],ae([0,1,14,3,168,18,71,15,29,13,19,20,28,17,39,233,23]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QZb=e.$PZb=e.$OZb=void 0;function l(R){return R&&R.settings&&typeof R.settings=="string"&&Object.keys(R).length===1}function u(R){const t=JSON.parse(R);return l(t)?t:{settings:R}}e.$OZb=u;let y=class extends d.$Ryb{constructor(t,o,n,s,i,r,a,w,g,f,k,A,M,F){super(t.settingsResource,{syncResource:"settings",profile:t},o,n,s,i,r,a,k,A,w,g,f,F),this.zb=M,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:c.$efb,authority:"base"}),this.localResource=this.previewResource.with({scheme:c.$efb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.$efb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.$efb,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(t){const o=await this.getLastSyncUserData(),n=await this.S(t,o),s=this.Gb(n),i=new L.$dn(c.$Reb);return s?.settings&&i.parse(s.settings),i.configurationModel.getValue(c.$Reb)||{}}async nb(t,o,n){const s=await this.p(),i=await this.xb(),r=this.Gb(t);o=o===null&&n?t:o;const a=o?this.Gb(o):null,w=await this.Kb();let g=null,f=!1,k=!1,A=!1;if(r){let B=s?s.value.toString().trim():"{}";B=B||"{}",this.Lb(B),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const x=(0,v.$Kxb)(B,r.settings,a?a.settings:null,w,[],i);g=x.localContent||x.remoteContent,f=x.localContent!==null,k=x.remoteContent!==null,A=x.hasConflicts}else s&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),g=s.value.toString().trim()||"{}",this.Lb(g),k=!0);const M=s?s.value.toString():null,F=a?.settings??null,V={content:A?F:g,localChange:f?2:0,remoteChange:k?2:0,hasConflicts:A};return[{fileContent:s,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:M,localChange:V.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:V.remoteChange,previewResource:this.previewResource,previewResult:V,acceptedResource:this.acceptedResource}]}async rb(t){const o=this.Gb(t);if(o===null)return!0;const n=await this.p(),s=n?n.value.toString().trim():"",i=await this.Kb(),r=await this.xb();return(0,v.$Kxb)(s||"{}",o.settings,o.settings,i,[],r).remoteContent!==null}async ob(t,o){const n=await this.xb(),s=await this.Kb();return{...t.previewResult,content:t.previewResult.content?(0,v.$Jxb)(t.previewResult.content,"{}",s,n):null}}async pb(t,o,n,s){const i=await this.xb(),r=await this.Kb();if(this.h.isEqual(o,this.localResource))return{content:t.fileContent?(0,v.$Jxb)(t.fileContent.value.toString(),"{}",r,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:t.remoteContent!==null?(0,v.$Jxb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,v.$Jxb)(n,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async qb(t,o,n,s){const{fileContent:i}=n[0][0];let{content:r,localChange:a,remoteChange:w}=n[0][1];if(a===0&&w===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Lb(r),a!==0&&(this.L.trace(`${this.y}: Updating local settings...`),i&&await this.kb(JSON.stringify(this.Ib(i.value.toString()))),await this.r(r,i,s),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),w!==0){const g=await this.xb(),f=this.Gb(t),k=await this.Kb(r);r=(0,v.$Jxb)(r,f?f.settings:"{}",k,g),this.L.trace(`${this.y}: Updating remote settings...`),t=await this.jb(JSON.stringify(this.Ib(r)),s?null:t.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}o?.ref!==t.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(t),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.p();if(t)return!(0,v.$Lxb)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.ab(t):null}async ab(t){let o=await super.ab(t);if(o){const n=await this.xb(),s=await this.Kb();o=(0,v.$Jxb)(o,"{}",s,n)}return o}Gb(t){return t.syncData?this.Hb(t.syncData.content):null}Hb(t){try{return u(t)}catch(o){this.L.error(o)}return null}Ib(t){return{settings:t}}async Kb(t){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const n=T.Event.any(T.Event.filter(this.zb.onDidInstallExtensions,s=>s.some(({local:i})=>!!i)),T.Event.filter(this.zb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Jb=void 0})}const o=await this.Jb;return(0,v.$Hxb)(o,this.M,t)}Lb(t){if(this.vb(t,!1))throw new c.$5eb((0,O.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$PZb=y,e.$PZb=y=we([Y(2,b.$Sj),Y(3,P.$wh),Y(4,C.$Ko),Y(5,c.$Zeb),Y(6,c.$1eb),Y(7,c.$cfb),Y(8,c.$bfb),Y(9,j.$Vh),Y(10,c.$0eb),Y(11,E.$Vk),Y(12,S.$Rn),Y(13,m.$pk)],y);let p=class extends d.$Syb{constructor(t,o,n,s,i,r){super("settings",o,n,s,t,i,r)}async o(t){const o=t.syncData?this.p(t.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,I.$Jb.fromString(o.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,v.$Lxb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}p(t){try{return u(t)}catch(o){this.j.error(o)}return null}};e.$QZb=p,e.$QZb=p=we([Y(0,b.$Sj),Y(1,h.$rk),Y(2,P.$wh),Y(3,c.$cfb),Y(4,C.$Ko),Y(5,m.$pk)],p)}),define(oe[118],ae([0,1,14,3,30,18,15,13,19,20,28,17,39,230,23]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VZb=e.$UZb=e.$TZb=void 0;function v(u){return JSON.parse(u.content)}e.$TZb=v;let c=class extends m.$Pyb{constructor(y,p,R,t,o,n,s,i,r,a,w,g){super({syncResource:"snippets",profile:y},p,t,R,o,n,s,a,w,i,r,g),this.mb=1,this.p=y.snippetsHome,this.B(this.C.watch(R.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(T.Event.filter(this.C.onDidFilesChange,f=>f.affects(this.p))(()=>this.N()))}async nb(y,p,R){const t=await this.Cb(),o=this.Bb(t),n=y.syncData?this.Ab(y.syncData):null;p=p===null&&R?y:p;const s=p&&p.syncData?this.Ab(p.syncData):null;n?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,h.$RZb)(o,n,s);return this.wb(i,t,n||{},s||{})}async rb(y){const p=y.syncData?this.Ab(y.syncData):null;if(p===null)return!0;const R=await this.Cb(),t=this.Bb(R),o=(0,h.$RZb)(t,p,p);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async ob(y,p){return y.previewResult}async pb(y,p,R,t){if(this.h.isEqualOrParent(p,this.g.with({scheme:d.$efb,authority:"local"})))return{content:y.fileContent?y.fileContent.value.toString():null,localChange:0,remoteChange:y.fileContent?y.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(p,this.g.with({scheme:d.$efb,authority:"remote"})))return{content:y.remoteContent,localChange:y.remoteContent!==null?y.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(p,this.g))return R===void 0?{content:y.previewResult.content,localChange:y.previewResult.localChange,remoteChange:y.previewResult.remoteChange}:{content:R,localChange:R===null?y.fileContent!==null?3:0:2,remoteChange:R===null?y.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${p.toString()}`)}async qb(y,p,R,t){const o=R.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.xb(o),await this.yb(o,t)),o.some(({remoteChange:n})=>n!==0)&&(y=await this.zb(o,y,t)),p?.ref!==y.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb(y),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.C.del(n)}catch{}}wb(y,p,R,t){const o=new Map;for(const n of Object.keys(y.local.added)){const s={content:y.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"remote"}),remoteContent:R[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"accepted"})})}for(const n of Object.keys(y.local.updated)){const s={content:y.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},i=p[n]?p[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"local"}),fileContent:p[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"remote"}),remoteContent:R[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"accepted"})})}for(const n of y.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=p[n]?p[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"local"}),fileContent:p[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"accepted"})})}for(const n of Object.keys(y.remote.added)){const s={content:y.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},i=p[n]?p[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"local"}),fileContent:p[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"accepted"})})}for(const n of Object.keys(y.remote.updated)){const s={content:y.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},i=p[n]?p[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"local"}),fileContent:p[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"remote"}),remoteContent:R[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"accepted"})})}for(const n of y.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"remote"}),remoteContent:R[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"accepted"})})}for(const n of y.conflicts){const s={content:t[n]??null,hasConflicts:!0,localChange:p[n]?2:1,remoteChange:R[n]?2:1},i=p[n]?p[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"local"}),fileContent:p[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"remote"}),remoteContent:R[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"accepted"})})}for(const n of Object.keys(p))if(!o.has(n)){const s={content:p[n]?p[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=p[n]?p[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"local"}),fileContent:p[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"remote"}),remoteContent:R[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$efb,authority:"accepted"})})}return[...o.values()]}async resolveContent(y){return this.h.isEqualOrParent(y,this.g.with({scheme:d.$efb,authority:"remote"}))||this.h.isEqualOrParent(y,this.g.with({scheme:d.$efb,authority:"local"}))||this.h.isEqualOrParent(y,this.g.with({scheme:d.$efb,authority:"base"}))||this.h.isEqualOrParent(y,this.g.with({scheme:d.$efb,authority:"accepted"}))?this.ab(y):null}async hasLocalData(){try{const y=await this.Cb();if(Object.keys(y).length)return!0}catch{}return!1}async xb(y){const p={};for(const R of y)R.fileContent&&(p[this.h.basename(R.localResource)]=R.fileContent);await this.kb(JSON.stringify(this.Bb(p)))}async yb(y,p){for(const{fileContent:R,acceptResult:t,localResource:o,remoteResource:n,localChange:s}of y)if(s!==0){const i=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.p,i);s===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(r)),await this.C.del(r),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(r))):s===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(r)),await this.C.createFile(r,I.$Jb.fromString(t.content),{overwrite:p}),this.L.info(`${this.y}: Created snippet`,this.h.basename(r))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(r)),await this.C.writeFile(r,I.$Jb.fromString(t.content),p?void 0:R),this.L.info(`${this.y}: Updated snippet`,this.h.basename(r)))}}async zb(y,p,R){const t=p.syncData?this.Ab(p.syncData):{},o=(0,O.$Hm)(t);for(const{acceptResult:n,localResource:s,remoteResource:i,remoteChange:r}of y)if(r!==0){const a=s?this.h.basename(s):this.h.basename(i);r===3?delete o[a]:o[a]=n.content}return(0,h.$SZb)(t,o)||(this.L.trace(`${this.y}: Updating remote snippets...`),p=await this.jb(JSON.stringify(o),R?null:p.ref),this.L.info(`${this.y}: Updated remote snippets`)),p}Ab(y){return v(y)}Bb(y){const p={};for(const R of Object.keys(y))p[R]=y[R].value.toString();return p}async Cb(){const y={};let p;try{p=await this.C.resolve(this.p)}catch(R){if(R instanceof P.$ak&&R.fileOperationResult===1)return y;throw R}for(const R of p.children||[]){const t=R.resource,o=this.h.extname(t);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.p,t),s=await this.C.readFile(t);y[n]=s}}return y}};e.$UZb=c,e.$UZb=c=we([Y(2,L.$wh),Y(3,P.$Sj),Y(4,S.$Ko),Y(5,d.$Zeb),Y(6,d.$1eb),Y(7,d.$cfb),Y(8,j.$Vh),Y(9,d.$0eb),Y(10,b.$Vk),Y(11,C.$pk)],c);let l=class extends m.$Syb{constructor(y,p,R,t,o,n){super("snippets",p,R,t,y,o,n)}async o(y){const p=y.syncData?JSON.parse(y.syncData.content):null;if(!p){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(p)){const o=p[t];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(n,I.$Jb.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(y)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(y){return y.fileOperationResult===1}}};e.$VZb=l,e.$VZb=l=we([Y(0,P.$Sj),Y(1,E.$rk),Y(2,L.$wh),Y(3,d.$cfb),Y(4,S.$Ko),Y(5,C.$pk)],l)}),define(oe[119],ae([0,1,14,18,15,13,19,20,28,17,39,23]),function(ne,e,I,T,O,j,L,P,S,b,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YZb=e.$XZb=e.$WZb=void 0;function m(c,l){try{return JSON.parse(c).tasks??null}catch(u){return l.error(u),null}}e.$WZb=m;let h=class extends C.$Qyb{constructor(l,u,y,p,R,t,o,n,s,i,r,a){super(l.tasksResource,{syncResource:"tasks",profile:l},u,n,s,i,y,p,o,r,R,t,a),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:E.$efb,authority:"base"}),this.xb=this.vb.with({scheme:E.$efb,authority:"local"}),this.yb=this.vb.with({scheme:E.$efb,authority:"remote"}),this.zb=this.vb.with({scheme:E.$efb,authority:"accepted"})}async nb(l,u,y,p){const R=l.syncData?m(l.syncData.content,this.L):null;u=u===null&&y?l:u;const t=u?.syncData?m(u.syncData.content,this.L):null,o=await this.p();let n=null,s=!1,i=!1,r=!1;if(l.syncData){const g=o?o.value.toString():null;if(!t||t!==g||t!==R){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const f=v(g,R,t);n=f.content,r=f.hasConflicts,s=f.hasLocalChanged,i=f.hasRemoteChanged}}else o&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),i=!0);const a={content:r?t:n,localChange:s?o?2:1:0,remoteChange:i?2:0,hasConflicts:r},w=o?o.value.toString():null;return[{fileContent:o,baseResource:this.wb,baseContent:t,localResource:this.xb,localContent:w,localChange:a.localChange,remoteResource:this.yb,remoteContent:R,remoteChange:a.remoteChange,previewResource:this.vb,previewResult:a,acceptedResource:this.zb}]}async rb(l){const u=l?.syncData?m(l.syncData.content,this.L):null;if(u===null)return!0;const y=await this.p(),p=y?y.value.toString():null,R=v(p,u,u);return R.hasLocalChanged||R.hasRemoteChanged}async ob(l,u){return l.previewResult}async pb(l,u,y,p){if(this.h.isEqual(u,this.xb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.yb))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.vb))return y===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:y,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async qb(l,u,y,p){const{fileContent:R}=y[0][0],{content:t,localChange:o,remoteChange:n}=y[0][1];if(o===0&&n===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),o!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),R&&await this.kb(JSON.stringify(this.Fb(R.value.toString()))),t?await this.r(t,R,p):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),n!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const s=JSON.stringify(this.Fb(t));l=await this.jb(s,p?null:l.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}u?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(l){return this.h.isEqual(this.yb,l)||this.h.isEqual(this.wb,l)||this.h.isEqual(this.xb,l)||this.h.isEqual(this.zb,l)?this.ab(l):null}Fb(l){return l?{tasks:l}:{}}};e.$XZb=h,e.$XZb=h=we([Y(2,E.$Zeb),Y(3,E.$1eb),Y(4,E.$cfb),Y(5,T.$Vh),Y(6,E.$0eb),Y(7,j.$Sj),Y(8,O.$wh),Y(9,L.$Ko),Y(10,P.$Vk),Y(11,S.$pk)],h);let d=class extends C.$Syb{constructor(l,u,y,p,R,t){super("tasks",u,y,p,l,R,t),this.c=this.g.defaultProfile.tasksResource}async o(l){const u=l.syncData?m(l.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$Jb.fromString(u)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$YZb=d,e.$YZb=d=we([Y(0,j.$Sj),Y(1,b.$rk),Y(2,O.$wh),Y(3,E.$cfb),Y(4,L.$Ko),Y(5,S.$pk)],d);function v(c,l,u){if(c===null&&l===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(c===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const y=u!==c,p=u!==l;return!y&&!p?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:y&&!p?{content:c,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:p&&!y?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:c,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[120],ae([0,1,41,18,15,13,19,20,28,17,39,231,23]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C2b=e.$B2b=e.$A2b=void 0;let h=class extends C.$Pyb{constructor(l,u,y,p,R,t,o,n,s,i,r,a,w){super({syncResource:"profiles",profile:l},u,p,R,t,o,n,r,a,s,i,w),this.r=y,this.mb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.$efb,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.$efb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.$efb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.$efb,authority:"accepted"}),this.B(y.onDidChangeProfiles(()=>this.N()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?v(l.syncData):null}async getRemoteSyncedProfiles(l){const u=await this.getLastSyncUserData(),y=await this.S(l,u);return y?.syncData?v(y.syncData):null}async nb(l,u,y){if(!this.r.isEnabled())throw new m.$5eb("Cannot sync profiles because they are disabled","LocalError");const p=l.syncData?v(l.syncData):null,R=u?.syncData?v(u.syncData):null,t=this.zb(),{local:o,remote:n}=(0,E.$z2b)(t,p,R,[]),s={local:o,remote:n,content:R?this.Ab(R):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},i=d(t,!1);return[{baseResource:this.baseResource,baseContent:R?this.Ab(R):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:p?this.Ab(p):null,remoteProfiles:p,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async rb(l){const u=l?.syncData?v(l.syncData):null,y=this.zb(),{remote:p}=(0,E.$z2b)(y,u,u,[]);return!!p?.added.length||!!p?.removed.length||!!p?.updated.length}async ob(l,u){return{...l.previewResult,hasConflicts:!1}}async pb(l,u,y,p){if(this.h.isEqual(u,this.localResource))return this.wb(l);if(this.h.isEqual(u,this.remoteResource))return this.xb(l);if(this.h.isEqual(u,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async wb(l){const u=this.zb(),y=(0,E.$z2b)(u,null,null,[]),{local:p,remote:R}=y;return{content:l.localContent,local:p,remote:R,localChange:p.added.length>0||p.removed.length>0||p.updated.length>0?2:0,remoteChange:R!==null?2:0}}async xb(l){const u=l.remoteContent?JSON.parse(l.remoteContent):null,y=[],p=[];for(const R of this.zb()){const t=u?.find(o=>o.id===R.id);t&&(y.push({id:R.id,name:R.name,collection:t.collection}),p.push(R))}if(u!==null){const R=(0,E.$z2b)(p,u,y,[]),{local:t,remote:o}=R;return{content:l.remoteContent,local:t,remote:o,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(l,u,y,p){const{local:R,remote:t,localChange:o,remoteChange:n}=y[0][1];o===0&&n===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const s=y[0][0].remoteProfiles||[];if(s.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new m.$5eb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.kb(d(this.zb(),!1));const i=[];for(const r of R.added)i.push((async()=>{this.L.trace(`${this.y}: Creating '${r.name}' profile...`),await this.r.createProfile(r.id,r.name,{shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.L.info(`${this.y}: Created profile '${r.name}'.`)})());for(const r of R.removed)i.push((async()=>{this.L.trace(`${this.y}: Removing '${r.name}' profile...`),await this.r.removeProfile(r),this.L.info(`${this.y}: Removed profile '${r.name}'.`)})());for(const r of R.updated){const a=this.r.profiles.find(w=>w.id===r.id);a?i.push((async()=>{this.L.trace(`${this.y}: Updating '${r.name}' profile...`),await this.r.updateProfile(a,{name:r.name,shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.L.info(`${this.y}: Updated profile '${r.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(i)}if(n!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const i=[],r=s.length+(t?.added.length??0)<=20;if(r)for(const a of t?.added||[]){const w=await this.G.createCollection(this.z);i.push(w),s.push({id:a.id,name:a.name,collection:w,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const a of t?.removed||[])s.splice(s.findIndex(({id:w})=>a.id===w),1);for(const a of t?.updated||[]){const w=s.find(({id:g})=>a.id===g);w&&s.splice(s.indexOf(w),1,{...w,id:a.id,name:a.name,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(s,p?null:l.ref),this.L.info(`${this.y}: Updated remote profiles.${r&&t?.added.length?` Added: ${JSON.stringify(t.added.map(a=>a.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(a=>a.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(a=>a.name))}.`:""}`)}catch(a){if(i.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const w of i)await this.G.deleteCollection(w,this.z)}throw a}for(const a of t?.removed||[])await this.G.deleteCollection(a.collection,this.z)}u?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,u){return this.jb(this.Ab(l),u)}async hasLocalData(){return this.zb().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const u=await this.ab(l);return u&&(0,I.$7R)(JSON.parse(u),{})}return null}zb(){return this.r.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Ab(l){return JSON.stringify([...l].sort((u,y)=>u.name.localeCompare(y.name)))}};e.$A2b=h,e.$A2b=h=we([Y(2,b.$rk),Y(3,j.$Sj),Y(4,O.$wh),Y(5,L.$Ko),Y(6,m.$Zeb),Y(7,m.$1eb),Y(8,m.$cfb),Y(9,T.$Vh),Y(10,m.$0eb),Y(11,P.$Vk),Y(12,S.$pk)],h);function d(c,l){const u=[...c].sort((y,p)=>y.name.localeCompare(p.name)).map(y=>({id:y.id,name:y.name}));return l?(0,I.$7R)(u,{}):JSON.stringify(u)}e.$B2b=d;function v(c){return JSON.parse(c.content)}e.$C2b=v}),define(oe[248],ae([0,1,6,14,61,2,22,18,15,13,17,23]),function(ne,e,I,T,O,j,L,P,S,b,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y2b=void 0;let m=class extends j.$lb{constructor(d,v,c,l,u){super(),this.a=d,this.b=v,this.c=c,this.f=l,this.g=u,this.h()}async h(){for(const v of this.g.profiles)for(const c of E.$Veb)try{await this.j(this.i(v,c))}catch(l){this.f.error(l)}let d;try{d=await this.b.resolve(this.a.userDataSyncHome)}catch(v){(0,b.$9j)(v)!==1&&this.f.error(v);return}if(d.children){for(const v of d.children)if(v.isDirectory&&!this.g.profiles.some(c=>c.id===v.name))try{this.f.info("Deleting non existing profile from backup",v.resource.path),await this.b.del(v.resource,{recursive:!0})}catch(c){this.f.error(c)}}}async getAllRefs(d,v){const c=this.i(d,v);try{const l=await this.b.resolve(c);if(l.children)return l.children.filter(y=>y.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(y.name)).sort().reverse().map(y=>({ref:y.name,created:this.k(y)}))}catch(l){if((0,b.$9j)(l)!==1)throw l}return[]}async resolveContent(d,v,c){const l=this.i(d,v),u=(0,L.$0f)(l,c);try{return(await this.b.readFile(u)).value.toString()}catch(y){return this.f.error(y),null}}async backup(d,v,c){const l=this.i(d,v),u=(0,L.$0f)(l,`${(0,O.$Sl)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(u,T.$Jb.fromString(c))}catch(y){this.f.error(y)}try{this.j(l)}catch{}}i(d,v){return(0,L.$0f)(this.a.userDataSyncHome,...d.isDefault?[v]:[d.id,v])}async j(d){try{try{if(!await this.b.exists(d))return}catch{return}const v=await this.b.resolve(d);if(v.children){const c=v.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=c.filter(p=>Date.now()-this.k(p)>l);const y=c.length-u.length;y<10&&(u=u.slice(10-y)),await I.Promises.settled(u.map(async p=>{this.f.info("Deleting from backup",p.resource.path),await this.b.del(p.resource)}))}}catch(v){this.f.error(v)}}k(d){return d.ctime||new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};e.$y2b=m,e.$y2b=m=we([Y(0,S.$wh),Y(1,b.$Sj),Y(2,P.$Vh),Y(3,E.$cfb),Y(4,C.$rk)],m)}),define(oe[249],ae([0,1,3,2,5,15,19,20,23]),function(ne,e,I,T,O,j,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n2b=void 0;const b="sync.enable";let C=class extends T.$lb{constructor(m,h,d,v){super(),this.c=m,this.f=h,this.g=d,this.h=v,this.a=new I.$8c,this.onDidChangeEnablement=this.a.event,this.b=new I.$8c,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(-1,void 0,this.B(new T.$kb))(c=>this.j(c)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(b,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(b,{enabled:m}),this.c.store(b,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,S.$9eb)(m),-1,!0)}setResourceEnablement(m,h){if(this.isResourceEnabled(m)!==h){const d=(0,S.$9eb)(m);this.i(d,h)}}getResourceSyncStateVersion(m){}i(m,h){this.c.store(m,h,-1,O.$o?0:1)}j(m){if(b===m.key){this.a.fire(this.isEnabled());return}const h=S.$Veb.filter(d=>(0,S.$9eb)(d)===m.key)[0];if(h){this.b.fire([h,this.isResourceEnabled(h)]);return}}};e.$n2b=C,e.$n2b=C=we([Y(0,L.$Ko),Y(1,P.$Vk),Y(2,j.$wh),Y(3,S.$Yeb)],C)}),define(oe[79],ae([0,1,3,2,5,27,172,15,13,4,24,44,19,23]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AXb=e.$zXb=e.$yXb=void 0,e.$yXb=(0,b.$ph)("IUserDataSyncMachinesService");const d="sync.currentMachineName",v="Safari",c="Chrome",l="Edge",u="Firefox",y="Android";function p(o){switch(o){case v:case c:case l:case u:case y:case(0,O.$h)(0):return!0}return!1}e.$zXb=p;function R(){return O.$F?v:O.$D?c:O.$G?l:O.$E?u:O.$H?y:(0,O.$h)(O.$o?0:O.$t)}let t=class it extends T.$lb{static{this.a=1}static{this.b="machines"}constructor(n,s,i,r,a,w){super(),this.h=i,this.i=r,this.j=a,this.k=w,this.c=this.B(new I.$8c),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.$Qo)(n,s,i)}async getMachines(n){const s=await this.f;return(await this.m(n)).machines.map(r=>({...r,isCurrent:r.id===s}))}async addCurrentMachine(n){const s=await this.f,i=await this.m(n);i.machines.some(({id:r})=>r===s)||(i.machines.push({id:s,name:this.l(i.machines),platform:R()}),await this.n(i))}async removeCurrentMachine(n){const s=await this.f,i=await this.m(n),r=i.machines.filter(({id:a})=>a!==s);r.length!==i.machines.length&&(i.machines=r,await this.n(i))}async renameMachine(n,s,i){const r=await this.m(i),a=r.machines.find(({id:w})=>w===n);if(a){a.name=s,await this.n(r);const w=await this.f;n===w&&this.h.store(d,s,-1,1)}}async setEnablements(n){const s=await this.m();for(const[i,r]of n){const a=s.machines.find(w=>w.id===i);a&&(a.disabled=r?void 0:!0)}await this.n(s)}l(n){const s=this.h.get(d,-1);if(s)return s;const i=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${R()} (${this.k.nameShort})`,r=new RegExp(`${(0,j.$od)(i)}\\s#(\\d+)`);let a=0;for(const w of n){const g=r.exec(w.name),f=g?parseInt(g[1]):0;a=f>a?f:a}return`${i} #${a+1}`}async m(n){this.g=await this.p(n);const s=this.r(this.g);if(s.version!==it.a)throw new Error((0,L.localize)(0,null,this.k.nameLong));return s}async n(n){const s=JSON.stringify(n),i=await this.i.writeResource(it.b,s,this.g?.ref||null);this.g={ref:i,content:s},this.c.fire()}async p(n){if(this.g){const s=n&&n.latest?n.latest[it.b]:void 0;if(this.g.ref===s)return this.g;if(s===void 0&&this.g.content===null)return this.g}return this.i.readResource(it.b,this.g)}r(n){if(n.content!==null)try{return JSON.parse(n.content)}catch(s){this.j.error(s)}return{version:it.a,machines:[]}}};e.$AXb=t,e.$AXb=t=we([Y(0,P.$wh),Y(1,S.$Sj),Y(2,m.$Ko),Y(3,h.$Zeb),Y(4,h.$cfb),Y(5,C.$0i)],t)}),define(oe[250],ae([0,1,6,61,38,7,3,2,5,22,10,169,24,19,20,23,76,79]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E2b=void 0;const u="sync.disableMachineEventually",y="sync.sessionId",p="sync.storeUrl",R="sync.productQuality";let t=class extends P.$lb{get j(){const s=this.z.get(p,-1);return s?C.URI.parse(s):void 0}set j(s){s?this.z.store(p,s.toString(),-1,1):this.z.remove(p,-1)}get l(){return this.z.get(R,-1)}set l(s){s?this.z.store(R,s,-1,1):this.z.remove(R,-1)}constructor(s,i,r,a,w,g,f,k,A,M){super(),this.n=i,this.p=r,this.r=a,this.s=w,this.u=g,this.v=f,this.w=k,this.y=A,this.z=M,this.a=this.B(new P.$mb),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new L.$8c),this.onError=this.h.event,this.N=[],this.f=this.B(new I.$tg(this.O())),this.i=this.j,this.j=i.userDataSyncStore?.url,this.k=this.l,this.l=s.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(i.onDidChangeUserDataSyncStore(()=>{(0,b.$3f)(this.j,i.userDataSyncStore?.url)||(this.i=this.j,this.j=i.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(f.onDidChangeAccount(()=>this.C())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(w.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(L.Event.filter(this.r.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:s,message:i}=this.F();s?this.a.value===void 0&&(this.a.value=new o(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.w,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.I(r))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(i&&this.u.info(i),this.a.clear()):i&&this.r.isEnabled()&&this.u.info(i))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,T.$Sl)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(s,i,r){try{this.v.account&&!r&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(y,-1),s?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(a){if(this.u.error(a),i)this.G(!1);else throw a}}G(s){this.r.isEnabled()!==s&&(this.r.setEnablement(s),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(s){if(!s){this.b=0;return}const i=v.$5eb.toUserDataSyncError(s);i instanceof v.$7eb&&this.w.publicLog2("autosync/error",{code:i.code,service:this.n.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?S.$o&&i.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(i),this.b++),this.h.fire(i)}async J(){this.z.store(u,!0,-1,1),await(0,I.$wg)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(u,-1,!1)}M(){this.z.remove(u,-1)}async triggerSync(s,i,r){if(this.a.value===void 0)return this.f.cancel();if(i&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...s),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const a=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:a}),this.N=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};e.$E2b=t,e.$E2b=t=we([Y(0,m.$0i),Y(1,v.$Yeb),Y(2,v.$Zeb),Y(3,v.$0eb),Y(4,v.$$eb),Y(5,v.$cfb),Y(6,c.$rxb),Y(7,d.$Vk),Y(8,l.$yXb),Y(9,h.$Ko)],t);class o extends P.$lb{static{this.a="Interval"}constructor(s,i,r,a,w,g,f,k,A){super(),this.j=s,this.k=i,this.l=r,this.m=a,this.n=w,this.p=g,this.r=f,this.s=k,this.u=A,this.b=this.B(new P.$mb),this.c=this.B(new L.$8c),this.onDidStartSync=this.c.event,this.f=this.B(new L.$8c),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.v())),this.B((0,P.$jb)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}v(){this.b.value=(0,I.$xg)(()=>this.sync(o.a,!1),this.k)}sync(s,i){const r=(0,I.$jg)(async a=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(w){if((0,j.$2)(w))return}return this.z(s,i,a)});return this.i=r,this.i.finally(()=>this.i=void 0),this.i}w(){return this.j!==void 0&&!(0,b.$3f)(this.j,this.l.userDataSyncStore?.url)}async y(){const s=await this.l.getPreviousUserDataSyncStore(),i=this.l.userDataSyncStore;return!!i&&!!s&&(!(0,b.$3f)(i.defaultUrl,s.defaultUrl)||!(0,b.$3f)(i.insidersUrl,s.insidersUrl)||!(0,b.$3f)(i.stableUrl,s.stableUrl))}async z(s,i,r){this.r.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.C(i,r)}catch(w){if(this.r.error(w),a=w,v.$5eb.toUserDataSyncError(w).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.C(i,r),a=void 0}catch(g){this.r.error(g),a=g}}this.f.fire(a)}async C(s,i){if(this.h=await this.n.createSyncTask(this.g,s),i.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.w()?await this.y()?new v.$7eb((0,E.localize)(0,null),"DefaultServiceChanged"):new v.$7eb((0,E.localize)(1,null),"ServiceChanged"):new v.$7eb((0,E.localize)(2,null),"TurnedOff");const r=this.u.get(y,-1);if(r&&this.g&&r!==this.g.session)throw this.w()?await this.y()?new v.$7eb((0,E.localize)(3,null),"DefaultServiceChanged"):new v.$7eb((0,E.localize)(4,null),"ServiceChanged"):new v.$7eb((0,E.localize)(5,null),"SessionExpired");const a=await this.p.getMachines(this.g||void 0);if(i.isCancellationRequested)return;const w=a.find(f=>f.isCurrent);if(w?.disabled)throw new v.$7eb((0,E.localize)(6,null),"TurnedOff");const g=new Date().getTime();if(await this.h.run(),this.s.publicLog2("settingsSync:sync",{duration:new Date().getTime()-g}),this.g===null)try{this.g=await this.m.manifest(null)}catch(f){throw new v.$7eb((0,O.$ai)(f),f instanceof v.$5eb?f.code:"Unknown")}this.g&&this.g.session!==r&&this.u.store(y,this.g.session,-1,1),!i.isCancellationRequested&&(w||await this.p.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(oe[251],ae([0,1,10,173,15,13,44,19,28,23,17,39,118,117,116,18,119,114,115,4,120,41]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u,y,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d3b=void 0;let t=class Ve{static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(n,s,i,r,a,w,g,f,k,A){this.e=n,this.f=s,this.g=i,this.h=a,this.i=w,this.j=g,this.k=f,this.l=k,this.m=A,this.d=r.extUri}async getRemoteSyncedProfiles(){const n=await this.e.readResource("profiles",null,void 0);if(n.content){const s=this.K(n.content,"profiles");return(0,p.$C2b)(s)}return[]}async getRemoteSyncResourceHandles(n,s){return(await this.e.getAllResourceRefs(n,s?.collection)).map(({created:r,ref:a})=>({created:r,uri:this.I({remote:!0,syncResource:n,profile:s?.id??this.k.defaultProfile.id,collection:s?.collection,ref:a,node:void 0})}))}async getLocalSyncResourceHandles(n,s){return(await this.f.getAllRefs(s,n)).map(({created:r,ref:a})=>({created:r,uri:this.I({remote:!1,syncResource:n,profile:s.id,collection:void 0,ref:a,node:void 0})}))}resolveUserDataSyncResource({uri:n}){const s=this.J(n),i=s?this.k.profiles.find(r=>r.id===s.profile):void 0;return s&&i?{profile:i,syncResource:s?.syncResource}:void 0}async getAssociatedResources({uri:n}){const s=this.J(n);if(!s)return[];const i=this.k.profiles.find(r=>r.id===s.profile);switch(s.syncResource){case"settings":return this.r(n,i);case"keybindings":return this.t(n,i);case"tasks":return this.v(n,i);case"snippets":return this.x(n,i);case"globalState":return this.C(n,i);case"extensions":return this.z(n,i);case"profiles":return this.F(n,i);case"workspaceState":return[]}}async getMachineId({uri:n}){const s=this.J(n);if(s){if(s.remote){if(s.ref){const{content:i}=await this.L(s.syncResource,s.ref,s.collection);if(i)return this.K(i,s.syncResource)?.machineId}return}return(0,L.$Qo)(this.h,this.j,this.i)}}async resolveContent(n){const s=this.J(n);if(!s||s.node===Ve.a)return null;if(s.ref){const i=await this.n(s.remote,s.syncResource,s.profile,s.collection,s.ref);return s.node&&i?this.o(s.syncResource,i,s.node):i}return!s.remote&&!s.node?this.q(s.syncResource,s.profile):null}async n(n,s,i,r,a){if(n){const{content:g}=await this.L(s,a,r);return g}const w=this.k.profiles.find(g=>g.id===i);return w?this.f.resolveContent(w,s,a):null}o(n,s,i){const r=this.K(s,n);switch(n){case"settings":return this.s(r,i);case"keybindings":return this.u(r,i);case"tasks":return this.w(r,i);case"snippets":return this.y(r,i);case"globalState":return this.D(r,i);case"extensions":return this.A(r,i);case"profiles":return this.G(r,i);case"workspaceState":return null}}async q(n,s){const i=this.k.profiles.find(r=>r.id===s);if(!i)return null;switch(n){case"globalState":return this.E(i);case"extensions":return this.B(i);case"profiles":return this.H(i);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}r(n,s){const i=this.d.joinPath(n,"settings.json"),r=s?s.settingsResource:this.d.joinPath(n,Ve.a);return[{resource:i,comparableResource:r}]}s(n,s){switch(s){case"settings.json":return(0,h.$OZb)(n.content).settings}return null}t(n,s){const i=this.d.joinPath(n,"keybindings.json"),r=s?s.keybindingsResource:this.d.joinPath(n,Ve.a);return[{resource:i,comparableResource:r}]}u(n,s){switch(s){case"keybindings.json":return(0,d.$LZb)(n.content,!!this.l.getValue(b.$Seb),this.g)}return null}v(n,s){const i=this.d.joinPath(n,"tasks.json"),r=s?s.tasksResource:this.d.joinPath(n,Ve.a);return[{resource:i,comparableResource:r}]}w(n,s){switch(s){case"tasks.json":return(0,c.$WZb)(n.content,this.g)}return null}async x(n,s){const i=await this.resolveContent(n);if(i){const r=this.K(i,"snippets");if(r){const a=(0,m.$TZb)(r),w=[];for(const g of Object.keys(a)){const f=this.d.joinPath(n,g),k=s?this.d.joinPath(s.snippetsHome,g):this.d.joinPath(n,Ve.a);w.push({resource:f,comparableResource:k})}return w}}return[]}y(n,s){return(0,m.$TZb)(n)[s]||null}z(n,s){const i=this.d.joinPath(n,"extensions.json"),r=s?this.I({remote:!1,syncResource:"extensions",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,Ve.a);return[{resource:i,comparableResource:r}]}A(n,s){switch(s){case"extensions.json":return(0,l.$GZb)((0,l.$FZb)(n),!0)}return null}async B(n){const{localExtensions:s}=await this.m.createInstance(l.$IZb).getLocalExtensions(n);return(0,l.$GZb)(s,!0)}C(n,s){const i=this.d.joinPath(n,"globalState.json"),r=s?this.I({remote:!1,syncResource:"globalState",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,Ve.a);return[{resource:i,comparableResource:r}]}D(n,s){switch(s){case"globalState.json":return(0,u.$Uyb)(JSON.parse(n.content),!0)}return null}async E(n){const s=await this.m.createInstance(u.$Wyb).getLocalGlobalState(n);return(0,u.$Uyb)(s,!0)}F(n,s){const i=this.d.joinPath(n,"profiles.json"),r=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:i,comparableResource:r}]}G(n,s){switch(s){case"profiles.json":return(0,R.$7R)(JSON.parse(n.content),{})}return null}async H(n){return(0,p.$B2b)(this.k.profiles.filter(s=>!s.isDefault&&!s.isTransient),!0)}I(n){const s=n.remote?Ve.b:Ve.c,i=[n.syncResource,n.profile];return n.collection&&i.push(`collection:${n.collection}`),n.ref&&i.push(`ref:${n.ref}`),n.node&&i.push(n.node),this.d.joinPath(I.URI.from({scheme:b.$efb,authority:s,path:"/"}),...i)}J(n){if(n.scheme!==b.$efb||n.authority!==Ve.c&&n.authority!==Ve.b)return;const s=[];for(;n.path!=="/";)s.unshift(this.d.basename(n)),n=this.d.dirname(n);if(s.length<2)return;const i=n.authority===Ve.b,r=s.shift(),a=s.shift();let w,g,f;for(;s.length;){const k=s.shift();k.startsWith("collection:")?w=k.substring(11):k.startsWith("ref:")?g=k.substring(4):f=k}return{remote:i,syncResource:r,profile:a,collection:w,ref:g,node:f}}K(n,s){try{const i=JSON.parse(n);if((0,E.$Nyb)(i))return i}catch(i){this.g.error(i)}throw new b.$5eb((0,T.localize)(0,null),"IncompatibleRemoteContent",s)}async L(n,s,i){const r=await this.e.resolveResourceContent(n,s,i);return{ref:s,content:r}}};e.$d3b=t,e.$d3b=t=we([Y(0,b.$Zeb),Y(1,b.$1eb),Y(2,b.$cfb),Y(3,S.$pk),Y(4,O.$wh),Y(5,P.$Ko),Y(6,j.$Sj),Y(7,C.$rk),Y(8,v.$Vh),Y(9,y.$oh)],t)}),define(oe[252],ae([0,1,21,6,25,38,3,2,22,11,32,18,29,4,19,20,17,114,115,116,117,118,119,120,23]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u,y,p,R,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D2b=void 0;const s="sync.lastSyncTime";let i=class extends P.$lb{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(f,k,A,M,F,V,B,x,Z){super(),this.v=f,this.w=k,this.y=A,this.z=M,this.C=F,this.D=V,this.F=B,this.G=x,this.H=Z,this.f="uninitialized",this.g=this.B(new L.$8c),this.onDidChangeStatus=this.g.event,this.h=this.B(new L.$8c),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new L.$8c),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new L.$8c),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new L.$8c),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new L.$8c),this.onDidResetLocal=this.r.event,this.t=this.B(new L.$8c),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=k.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(s,-1,void 0),this.B((0,P.$jb)(()=>this.W()))}async createSyncTask(f,k){this.X(),this.z.info("Sync started.");const A=new Date().getTime(),M=(0,C.$6e)();try{const x=(0,n.$4eb)(M);k&&(x["Cache-Control"]="no-cache"),f=await this.v.manifest(f,x)}catch(x){const Z=n.$5eb.toUserDataSyncError(x);throw w(Z,M,this.w,this.C),Z}const F=!1,V=this;let B;return{manifest:f,async run(){if(F)throw new Error("Can run a task only once");B=(0,T.$jg)(x=>V.I(f,!1,M,x)),await B.finally(()=>B=void 0),V.z.info(`Sync done. Took ${new Date().getTime()-A}ms`),V.S()},stop(){return B?.cancel(),V.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new n.$5eb("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const f=new Date().getTime(),k=(0,C.$6e)(),A=(0,n.$4eb)(k);let M;try{M=await this.v.manifest(null,A)}catch(B){const x=n.$5eb.toUserDataSyncError(B);throw w(x,k,this.w,this.C),x}await this.resetLocal();const F=this,V=new O.$ed;return{id:k,async merge(){return F.I(M,!0,k,V.token)},async apply(){try{try{await F.L(M,k,V.token)}catch(B){if(n.$5eb.toUserDataSyncError(B).code==="MethodNotFound")F.z.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.z.info("Applying manual sync again..."),await F.L(M,k,V.token);else throw B}}catch(B){throw F.z.error(B),B}F.z.info(`Sync done. Took ${new Date().getTime()-f}ms`),F.S()},async stop(){V.cancel(),await F.N(),await F.resetLocal()}}}async I(f,k,A,M){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(F,f,k,A,M));const V=F.enabled.find(B=>B.resource==="profiles");if(V){const B=await V.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.J(B,f,k,A,M)}}finally{this.l.fire(this.k)}}async J(f,k,A,M,F){for(const V of f){if(F.isCancellationRequested)return;const B=this.G.profiles.find(Z=>Z.id===V.id);if(!B){this.z.error(`Profile with id:${V.id} and name: ${V.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",V.name);const x=this.getOrCreateActiveProfileSynchronizer(B,V);this.k.push(...await this.M(x,k,A,M,F))}for(const[V,B]of this.u.entries())this.G.profiles.some(x=>x.id===B[0].profile.id)||(B[1].dispose(),this.u.delete(V))}async L(f,k,A){const M=this.U();for(const Z of M){if(A.isCancellationRequested)return;await Z.apply(k,A)}const F=M.find(Z=>Z.profile.isDefault);if(!F)return;const V=F.enabled.find(Z=>Z.resource==="profiles");if(!V)return;const x=(await V.getRemoteSyncedProfiles(f?.latest??null)||[]).filter(Z=>M.every(Q=>Q.profile.id!==Z.id));x.length&&await this.J(x,f,!1,k,A)}async M(f,k,A,M,F){return(await f.sync(k,A,M,F)).map(([B,x])=>({profile:f.profile,syncResource:B,error:x}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(f=>f.stop()))}async resolveContent(f){const k=await this.H.resolveContent(f);if(k)return k;for(const A of this.U())for(const M of A.enabled){const F=await M.resolveContent(f);if(F)return F}return null}async replace(f){this.X();const k=this.H.resolveUserDataSyncResource(f);if(!k)return;const A=await this.resolveContent(f.uri);A&&await this.O(k.profile,async M=>{if(k.syncResource===M.resource)return await M.replace(A),!0})}async accept(f,k,A,M){this.X(),await this.O(f.profile,async F=>{if(f.syncResource===F.resource)return await F.accept(k,A),M&&await F.apply((0,b.$pe)(M)?!1:M.force,(0,n.$4eb)((0,C.$6e)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(f,k){return this.H.getRemoteSyncResourceHandles(f,k)}async getLocalSyncResourceHandles(f,k){return this.H.getLocalSyncResourceHandles(f,k??this.G.defaultProfile)}async getAssociatedResources(f){return this.H.getAssociatedResources(f)}async getMachineId(f){return this.H.getMachineId(f)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async k=>{if(k.resource!=="globalState"&&await k.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async k=>{if(await k.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(f){this.z.error(f)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(s,-1);for(const[f]of this.u.values())try{await f.resetLocal()}catch(k){this.z.error(k)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const f=await this.H.getRemoteSyncedProfiles(),k=f.map(V=>V.collection),A=await this.v.getAllCollections(),M=A.filter(V=>!k.includes(V));M.length&&(this.z.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(V=>this.v.deleteCollection(V))),this.z.info("Deleted redundant collections on server"));const F=f.filter(V=>A.includes(V.collection));if(F.length!==f.length){const V=this.y.createInstance(o.$A2b,this.G.defaultProfile,void 0);try{this.z.info("Resetting the last synced state of profiles"),await V.resetLocal(),this.z.info("Did reset the last synced state of profiles"),this.z.info("Updating remote profiles with invalid collections on server"),await V.updateRemoteProfiles(F,null),this.z.info("Updated remote profiles on server")}finally{V.dispose()}}}async O(f,k){const A=new P.$kb;try{const M=this.u.get(f.id);if(M){const Z=await this.P(M[0],k,A);return(0,b.$qe)(Z)?null:Z}if(f.isDefault){const Z=A.add(this.y.createInstance(r,f,void 0)),Q=await this.P(Z,k,A);return(0,b.$qe)(Q)?null:Q}if(this.G.isEnabled())return null;const F=A.add(this.y.createInstance(o.$A2b,f,void 0)),V=await this.v.manifest(null),x=(await F.getRemoteSyncedProfiles(V?.latest??null)||[]).find(Z=>Z.id===f.id);if(x){const Z=A.add(this.y.createInstance(r,f,x.collection)),Q=await this.P(Z,k,A);return(0,b.$qe)(Q)?null:Q}return null}finally{A.dispose()}}async P(f,k,A){const M=[...f.enabled,...f.disabled.reduce((F,V)=>(V!=="workspaceState"&&F.push(A.add(f.createSynchronizer(V))),F),[])];for(const F of M){const V=await k(F);if(!(0,b.$qe)(V))return V}}Q(f){const k=this.f;this.f!==f&&(this.f=f,this.g.fire(f),k==="hasConflicts"&&this.S())}R(){const f=this.U().map(k=>k.conflicts).flat();(0,I.$bf)(this.i,f,(k,A)=>k.profile.id===A.profile.id&&k.syncResource===A.syncResource&&(0,I.$bf)(k.conflicts,A.conflicts,(M,F)=>(0,S.$3f)(M.previewResource,F.previewResource)))||(this.i=f,this.j.fire(f))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(s,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(f,k){let A=this.u.get(f.id);if(A&&A[0].collection!==k?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),A[1].dispose(),A=void 0,this.u.delete(f.id)),!A){const M=new P.$kb,F=M.add(this.y.createInstance(r,f,k?.collection));M.add(F.onDidChangeStatus(V=>this.Q(V))),M.add(F.onDidChangeConflicts(V=>this.R())),M.add(F.onDidChangeLocal(V=>this.h.fire(V))),this.u.set(f.id,A=[F,M])}return A[0]}U(){const f=[];for(const[k]of this.u.values())f.push(k);return f}W(){this.u.forEach(([,f])=>f.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};e.$D2b=i,e.$D2b=i=we([Y(0,n.$Zeb),Y(1,n.$Yeb),Y(2,h.$oh),Y(3,n.$cfb),Y(4,v.$Vk),Y(5,d.$Ko),Y(6,n.$0eb),Y(7,c.$rk),Y(8,n.$_eb)],i);let r=class extends P.$lb{get enabled(){return this.f.sort((f,k)=>f[1]-k[1]).map(([f])=>f)}get disabled(){return n.$Veb.filter(f=>!this.l.isResourceEnabled(f))}get status(){return this.g}get conflicts(){return this.j}constructor(f,k,A,M,F,V,B,x,Z,Q){super(),this.profile=f,this.collection=k,this.l=A,this.m=M,this.n=F,this.r=V,this.t=B,this.u=x,this.v=Z,this.w=Q,this.f=[],this.g="idle",this.h=this.B(new L.$8c),this.onDidChangeStatus=this.h.event,this.i=this.B(new L.$8c),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new L.$8c),this.onDidChangeConflicts=this.k.event,this.B(A.onDidChangeResourceEnablement(([J,X])=>this.y(J,X))),this.B((0,P.$jb)(()=>this.f.splice(0,this.f.length).forEach(([,,J])=>J.dispose())));for(const J of n.$Veb)A.isResourceEnabled(J)&&this.z(J)}y(f,k){k?this.z(f):this.C(f)}z(f){if(this.f.some(([F])=>F.resource===f))return;if(f==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(f==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled())||f==="workspaceState")return;if(f!=="profiles"&&this.profile.useDefaultFlags?.[f]){this.u.debug(`Skipping syncing ${f} in ${this.profile.name} because it is already synced by default profile`);return}const k=new P.$kb,A=k.add(this.createSynchronizer(f));k.add(A.onDidChangeStatus(()=>this.G())),k.add(A.onDidChangeConflicts(()=>this.H())),k.add(A.onDidChangeLocal(()=>this.i.fire(f)));const M=this.I(f);this.f.push([A,M,k])}C(f){const k=this.f.findIndex(([A])=>A.resource===f);if(k!==-1){const[[A,,M]]=this.f.splice(k,1);M.dispose(),this.G(),Promise.allSettled([A.stop(),A.resetLocal()]).then(null,F=>this.u.error(F))}}createSynchronizer(f){switch(f){case"settings":return this.m.createInstance(p.$PZb,this.profile,this.collection);case"keybindings":return this.m.createInstance(y.$MZb,this.profile,this.collection);case"snippets":return this.m.createInstance(R.$UZb,this.profile,this.collection);case"tasks":return this.m.createInstance(t.$XZb,this.profile,this.collection);case"globalState":return this.m.createInstance(u.$Vyb,this.profile,this.collection);case"extensions":return this.m.createInstance(l.$HZb,this.profile,this.collection);case"profiles":return this.m.createInstance(o.$A2b,this.profile,this.collection)}}async sync(f,k,A,M){if(M.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const V=[],B=(0,n.$4eb)(A),x=(this.collection?f?.collections?.[this.collection]?.latest:f?.latest)??null,Z=k?await this.D(x):{};for(const Q of F){if(M.isCancellationRequested)return[];if(!this.l.isResourceEnabled(Q.resource))return[];try{if(k){const J=await Q.preview(x,Z,B);if(J)for(const X of J.resourcePreviews)(X.localChange!==0||X.remoteChange!==0)&&X.mergeState==="preview"&&await Q.merge(X.previewResource)}else await Q.sync(x,B)}catch(J){const X=n.$5eb.toUserDataSyncError(J);if(w(X,A,this.r,this.t),a(J))throw X;this.u.error(J),this.u.error(`${Q.resource}: ${(0,j.$ai)(J)}`),V.push([Q.resource,X])}}return V}finally{this.G()}}async apply(f,k){const A=(0,n.$4eb)(f);for(const M of this.enabled){if(k.isCancellationRequested)return;try{await M.apply(!1,A)}catch(F){const V=n.$5eb.toUserDataSyncError(F);if(w(V,f,this.r,this.t),a(F))throw V;this.u.error(F),this.u.error(`${M.resource}: ${(0,j.$ai)(F)}`)}}}async stop(){for(const f of this.enabled)try{f.status!=="idle"&&await f.stop()}catch(k){this.u.error(k)}}async resetLocal(){for(const f of this.enabled)try{await f.resetLocal()}catch(k){this.u.error(`${f.resource}: ${(0,j.$ai)(k)}`),this.u.error(k)}}async D(f){if(!this.profile.isDefault)return{};const k=this.w.getValue(n.$Reb),A=this.enabled.find(M=>M instanceof p.$PZb);if(A){const M=await A.getRemoteUserDataSyncConfiguration(f);return{...k,...M}}return k}F(f){this.g!==f&&(this.g=f,this.h.fire(f))}G(){return this.H(),this.enabled.some(f=>f.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(f=>f.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const f=this.enabled.filter(k=>k.status==="hasConflicts").filter(k=>k.conflicts.conflicts.length>0).map(k=>k.conflicts);(0,I.$bf)(this.j,f,(k,A)=>k.syncResource===A.syncResource&&(0,I.$bf)(k.conflicts,A.conflicts,(M,F)=>(0,S.$3f)(M.previewResource,F.previewResource)))||(this.j=f,this.k.fire(f))}I(f){switch(f){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};r=we([Y(2,n.$0eb),Y(3,h.$oh),Y(4,m.$Pn),Y(5,n.$Yeb),Y(6,v.$Vk),Y(7,n.$cfb),Y(8,c.$rk),Y(9,E.$Vh)],r);function a(g){if(g instanceof n.$5eb)switch(g.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function w(g,f,k,A){A.publicLog2("sync/error",{code:g.code,serverCode:g instanceof n.$6eb?String(g.serverCode):void 0,url:g instanceof n.$6eb?g.url:void 0,resource:g.resource,executionId:f,service:k.userDataSyncStore.url.toString()})}}),define(oe[253],ae([0,1,3,2,10,17,23]),function(ne,e,I,T,O,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P5b=e.$O5b=void 0;function P(m,h){return{...m,profile:(0,j.$sk)(m.profile,h.profilesHome.scheme)}}function S(m){return{created:m.created,uri:O.URI.revive(m.uri)}}class b{constructor(h,d,v){this.c=h,this.d=d,this.f=v,this.a=new Map,this.b=new I.$8c}listen(h,d){switch(d){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${d}`)}async call(h,d,v){try{return await this.g(h,d,v)}catch(c){throw this.f.error(c),c}}async g(h,d,v){switch(d){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(O.URI.revive(v[0]));case"accept":return this.c.accept(P(v[0],this.d),O.URI.revive(v[1]),v[2],v[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(v[0],v[1]?(0,j.$sk)(v[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(v[0],v[1]);case"replace":return this.c.replace(S(v[0]));case"getAssociatedResources":return this.c.getAssociatedResources(S(v[0]));case"getMachineId":return this.c.getMachineId(S(v[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(d.startsWith("manualSync/")){const c=d.substring(11),l=v[0],u=this.h(l);switch(v=v.slice(1),c){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(h){const d=this.a.get(this.j(h));if(!d)throw new Error(`Manual sync taks not found: ${h}`);return d}async i(){const h=await this.c.createManualSyncTask();return this.a.set(this.j(h.id),h),h.id}j(h){return`manualSyncTask-${h}`}}e.$O5b=b;let C=class extends T.$lb{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(h,d){super(),this.k=d,this.b="uninitialized",this.c=this.B(new I.$8c),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$8c),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new I.$8c),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new I.$8c),this.onSyncErrors=this.j.event,this.a={call(v,c,l){return h.call(v,c,l).then(null,u=>{throw L.$5eb.toUserDataSyncError(u)})},listen(v,c){return h.listen(v,c)}},this.a.call("_getInitialData").then(([v,c,l])=>{this.l(v),this.m(c),l&&this.n(l),this.B(this.a.listen("onDidChangeStatus")(u=>this.l(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.n(u)))}),this.B(this.a.listen("onDidChangeConflicts")(v=>this.m(v))),this.B(this.a.listen("onSyncErrors")(v=>this.j.fire(v.map(c=>({...c,error:L.$5eb.toUserDataSyncError(c.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const h=await this.a.call("createManualSyncTask"),d=this;return new E(h,{async call(c,l,u){return d.a.call(`manualSync/${c}`,[h,...Array.isArray(l)?l:[l]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(h,d,v,c){return this.a.call("accept",[h,d,v,c])}resolveContent(h){return this.a.call("resolveContent",[h])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(h,d){return(await this.a.call("getLocalSyncResourceHandles",[h,d])).map(({created:c,uri:l})=>({created:c,uri:O.URI.revive(l)}))}async getRemoteSyncResourceHandles(h,d){return(await this.a.call("getRemoteSyncResourceHandles",[h,d])).map(({created:c,uri:l})=>({created:c,uri:O.URI.revive(l)}))}async getAssociatedResources(h){return(await this.a.call("getAssociatedResources",[h])).map(({resource:v,comparableResource:c})=>({resource:O.URI.revive(v),comparableResource:O.URI.revive(c)}))}getMachineId(h){return this.a.call("getMachineId",[h])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(h){return this.a.call("replace",[h])}async l(h){this.b=h,this.c.fire(h)}async m(h){this.f=h.map(d=>({syncResource:d.syncResource,profile:(0,j.$sk)(d.profile,this.k.profilesHome.scheme),conflicts:d.conflicts.map(v=>({...v,baseResource:O.URI.revive(v.baseResource),localResource:O.URI.revive(v.localResource),remoteResource:O.URI.revive(v.remoteResource),previewResource:O.URI.revive(v.previewResource)}))})),this.g.fire(this.f)}n(h){this.h!==h&&(this.h=h,this.i.fire(h))}};e.$P5b=C,e.$P5b=C=we([Y(1,j.$rk)],C);class E extends T.$lb{constructor(h,d){super(),this.id=h,this.a=d}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[254],ae([0,1,6,25,7,3,2,137,5,22,11,10,32,18,15,13,24,57,44,19,23]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lyb=e.$Kyb=e.$Jyb=e.$Iyb=e.$Hyb=void 0;const R="configurationSync.store",t="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",i=100,r=1e3*60*5;let a=class extends L.$lb{get userDataSyncStore(){return this.b}get c(){return this.h.get(p.$8eb,-1)}set c(M){this.h.store(p.$8eb,M,-1,S.$o?0:1)}constructor(M,F,V){super(),this.f=M,this.g=F,this.h=V,this.a=this.B(new j.$8c),this.onDidChangeUserDataSyncStore=this.a.event,this.i();const B=this.B(new L.$kb);this.B(j.Event.filter(V.onDidChangeValue(-1,p.$8eb,B),()=>this.c!==this.userDataSyncStore?.type,B)(()=>this.i()))}i(){this.b=this.j(this.f[R]),this.a.fire()}j(M){if(M&&(M=S.$o&&M.web?{...M,...M.web}:M,(0,C.$je)(M.url)&&(0,C.$le)(M.authenticationProviders)&&Object.keys(M.authenticationProviders).every(F=>Array.isArray(M.authenticationProviders[F].scopes)))){const F=M,V=!!F.canSwitch,B=F.url===F.insidersUrl?"insiders":"stable",x=(V?this.c:void 0)||B,Z=x==="insiders"?F.insidersUrl:x==="stable"?F.stableUrl:F.url;return{url:E.URI.parse(Z),type:x,defaultType:B,defaultUrl:E.URI.parse(F.url),stableUrl:E.URI.parse(F.stableUrl),insidersUrl:E.URI.parse(F.insidersUrl),canSwitch:V,authenticationProviders:Object.keys(F.authenticationProviders).reduce((Q,J)=>(Q.push({id:J,scopes:F.authenticationProviders[J].scopes}),Q),[])}}}};e.$Hyb=a,e.$Hyb=a=we([Y(0,c.$0i),Y(1,h.$Vh),Y(2,y.$Ko)],a);let w=class extends a{constructor(M,F,V){super(M,F,V);const B=this.h.get(t,-1);B&&(this.k=JSON.parse(B));const x=this.f[R];x?this.h.store(t,JSON.stringify(x),-1,1):this.h.remove(t,-1)}async switch(M){M!==this.c&&(this.c=M,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};e.$Iyb=w,e.$Iyb=w=we([Y(0,c.$0i),Y(1,h.$Vh),Y(2,y.$Ko)],w);let g=class extends L.$lb{get donotMakeRequestsUntil(){return this.i}constructor(M,F,V,B,x,Z,Q){super(),this.k=V,this.l=B,this.m=Q,this.g=this.B(new j.$8c),this.onTokenFailed=this.g.event,this.h=this.B(new j.$8c),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new j.$8c),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.r=void 0,this.n(M),this.c=(0,u.$Qo)(x,Z,Q).then(J=>{const X={"X-Client-Name":`${F.applicationName}${S.$o?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(X["X-Client-Commit"]=F.commit),X}),this.f=new k(i,r,this.k,this.l),this.p(),this.B((0,L.$jb)(()=>{this.r&&(this.r.cancel(),this.r=void 0)}))}setAuthToken(M,F){this.b={token:M,type:F}}n(M){this.a=M?(0,b.$0f)(M,"v1"):void 0}p(){const M=this.m.getNumber(o,-1);M&&Date.now()<M&&this.s(new Date(M))}s(M){this.i?.getTime()!==M?.getTime()&&(this.i=M,this.r&&(this.r.cancel(),this.r=void 0),this.i?(this.m.store(o,this.i.getTime(),-1,1),this.r=(0,I.$jg)(F=>(0,I.$wg)(this.i.getTime()-Date.now(),F).then(()=>this.s(void 0))),this.r.then(null,F=>null)):this.m.remove(o,-1),this.j.fire())}async getAllCollections(M={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,b.$0f)(this.a,"collection").toString();M={...M},M["Content-Type"]="application/json";const V=await this.v(F,{type:"GET",headers:M},[],T.CancellationToken.None);return(await(0,l.$Do)(V))?.map(({id:B})=>B)||[]}async createCollection(M={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,b.$0f)(this.a,"collection").toString();M={...M},M["Content-Type"]=P.$ur.text;const V=await this.v(F,{type:"POST",headers:M},[],T.CancellationToken.None),B=await(0,l.$Co)(V);if(!B)throw new p.$6eb("Server did not return the collection id",F,"NoCollection",V.res.statusCode,V.res.headers[p.$2eb]);return B}async deleteCollection(M,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=M?(0,b.$0f)(this.a,"collection",M).toString():(0,b.$0f)(this.a,"collection").toString();F={...F},await this.v(V,{type:"DELETE",headers:F},[],T.CancellationToken.None)}async getAllResourceRefs(M,F){if(!this.a)throw new Error("No settings sync store url configured.");const V=this.t(this.a,F,M),B={},x=await this.v(V.toString(),{type:"GET",headers:B},[],T.CancellationToken.None);return(await(0,l.$Do)(x)||[]).map(({url:Q,created:J})=>({ref:(0,b.$_f)(V,V.with({path:Q})),created:J*1e3}))}async resolveResourceContent(M,F,V,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const x=(0,b.$0f)(this.t(this.a,V,M),F).toString();B={...B},B["Cache-Control"]="no-cache";const Z=await this.v(x,{type:"GET",headers:B},[],T.CancellationToken.None);return await(0,l.$Co)(Z)}async deleteResource(M,F,V){if(!this.a)throw new Error("No settings sync store url configured.");const B=F!==null?(0,b.$0f)(this.t(this.a,V,M),F).toString():this.t(this.a,V,M).toString(),x={};await this.v(B,{type:"DELETE",headers:x},[],T.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,b.$0f)(this.a,"resource").toString(),F={"Content-Type":P.$ur.text};await this.v(M,{type:"DELETE",headers:F},[],T.CancellationToken.None)}async readResource(M,F,V,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const x=(0,b.$0f)(this.t(this.a,V,M),"latest").toString();B={...B},B["Cache-Control"]="no-cache",F&&(B["If-None-Match"]=F.ref);const Z=await this.v(x,{type:"GET",headers:B},[304],T.CancellationToken.None);let Q=null;if(Z.res.statusCode===304&&(Q=F),Q===null){const J=Z.res.headers.etag;if(!J)throw new p.$6eb("Server did not return the ref",x,"NoRef",Z.res.statusCode,Z.res.headers[p.$2eb]);const X=await(0,l.$Co)(Z);if(!X&&Z.res.statusCode===304)throw new p.$6eb("Empty response",x,"EmptyResponse",Z.res.statusCode,Z.res.headers[p.$2eb]);Q={ref:J,content:X}}return Q}async writeResource(M,F,V,B,x={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=this.t(this.a,B,M).toString();x={...x},x["Content-Type"]=P.$ur.text,V&&(x["If-Match"]=V);const Q=await this.v(Z,{type:"POST",data:F,headers:x},[],T.CancellationToken.None),J=Q.res.headers.etag;if(!J)throw new p.$6eb("Server did not return the ref",Z,"NoRef",Q.res.statusCode,Q.res.headers[p.$2eb]);return J}async manifest(M,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=(0,b.$0f)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",M&&(F["If-None-Match"]=M.ref);const B=await this.v(V,{type:"GET",headers:F},[304],T.CancellationToken.None);let x=null;if(B.res.statusCode===304&&(x=M),!x){const Q=B.res.headers.etag;if(!Q)throw new p.$6eb("Server did not return the ref",V,"NoRef",B.res.statusCode,B.res.headers[p.$2eb]);const J=await(0,l.$Co)(B);if(!J&&B.res.statusCode===304)throw new p.$6eb("Empty response",V,"EmptyResponse",B.res.statusCode,B.res.headers[p.$2eb]);J&&(x={...JSON.parse(J),ref:Q})}const Z=this.m.get(n,-1);return Z&&x&&Z!==x.session&&this.u(),x===null&&Z&&this.u(),x&&this.m.store(n,x.session,-1,1),x}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.u()}t(M,F,V){return F?(0,b.$0f)(M,"collection",F,"resource",V):(0,b.$0f)(M,"resource",V)}u(){this.m.remove(n,-1),this.m.remove(s,-1)}async v(M,F,V,B){if(!this.b)throw new p.$6eb("No Auth Token Available",M,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new p.$6eb(`${F.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",void 0,void 0);this.s(void 0);const x=await this.c;F.headers={...F.headers||{},...x,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.w(F.headers),this.l.trace("Sending request to server",{url:M,type:F.type,headers:{...F.headers,authorization:void 0}});let Z;try{Z=await this.f.request(M,F,B)}catch(U){if(!(U instanceof p.$6eb)){let q="RequestFailed";const te=(0,O.$9)(U).toLowerCase();te.includes("xhr timeout")?q="RequestTimeout":te.includes("protocol")&&te.includes("not supported")?q="RequestProtocolNotSupported":te.includes("request path contains unescaped characters")?q="RequestPathNotEscaped":te.includes("headers must be an object")?q="RequestHeadersNotObject":(0,O.$2)(U)&&(q="RequestCanceled"),U=new p.$6eb(`Connection refused for the request '${M}'.`,M,q,void 0,void 0)}throw this.l.info("Request failed",M),U}const Q=Z.res.headers[p.$2eb],J={url:M,status:Z.res.statusCode,"execution-id":F.headers[p.$3eb],"operation-id":Q},X=(0,l.$Ao)(Z)||Z.res.statusCode&&V.includes(Z.res.statusCode);let W="";if(X?this.l.trace("Request succeeded",J):(W=await(0,l.$Bo)(Z)||"",this.l.info("Request failed",J,W)),Z.res.statusCode===401||Z.res.statusCode===403){if(this.b=void 0,Z.res.statusCode===401)throw this.g.fire("Unauthorized"),new p.$6eb(`${F.type} request '${M}' failed because of Unauthorized (401).`,M,"Unauthorized",Z.res.statusCode,Q);if(Z.res.statusCode===403)throw this.g.fire("Forbidden"),new p.$6eb(`${F.type} request '${M}' failed because the access is forbidden (403).`,M,"Forbidden",Z.res.statusCode,Q)}if(this.h.fire(),Z.res.statusCode===404)throw new p.$6eb(`${F.type} request '${M}' failed because the requested resource is not found (404).`,M,"NotFound",Z.res.statusCode,Q);if(Z.res.statusCode===405)throw new p.$6eb(`${F.type} request '${M}' failed because the requested endpoint is not found (405). ${W}`,M,"MethodNotFound",Z.res.statusCode,Q);if(Z.res.statusCode===409)throw new p.$6eb(`${F.type} request '${M}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,M,"Conflict",Z.res.statusCode,Q);if(Z.res.statusCode===410)throw new p.$6eb(`${F.type} request '${M}' failed because the requested resource is not longer available (410).`,M,"Gone",Z.res.statusCode,Q);if(Z.res.statusCode===412)throw new p.$6eb(`${F.type} request '${M}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,M,"PreconditionFailed",Z.res.statusCode,Q);if(Z.res.statusCode===413)throw new p.$6eb(`${F.type} request '${M}' failed because of too large payload (413).`,M,"TooLarge",Z.res.statusCode,Q);if(Z.res.statusCode===426)throw new p.$6eb(`${F.type} request '${M}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,M,"UpgradeRequired",Z.res.statusCode,Q);if(Z.res.statusCode===429){const U=Z.res.headers["retry-after"];throw U?(this.s(new Date(Date.now()+parseInt(U)*1e3)),new p.$6eb(`${F.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",Z.res.statusCode,Q)):new p.$6eb(`${F.type} request '${M}' failed because of too many requests (429).`,M,"RemoteTooManyRequests",Z.res.statusCode,Q)}if(!X)throw new p.$6eb("Server returned "+Z.res.statusCode,M,"Unknown",Z.res.statusCode,Q);return Z}w(M){let F=this.m.get(s,-1);F===void 0&&(F=(0,m.$6e)(),this.m.store(s,F,-1,1)),M["X-Machine-Session-Id"]=F;const V=this.m.get(n,-1);V!==void 0&&(M["X-User-Session-Id"]=V)}};e.$Jyb=g,e.$Jyb=g=we([Y(1,c.$0i),Y(2,l.$yo),Y(3,p.$cfb),Y(4,d.$wh),Y(5,v.$Sj),Y(6,y.$Ko)],g);let f=class extends g{constructor(M,F,V,B,x,Z,Q){super(M.userDataSyncStore?.url,F,V,B,x,Z,Q),this.B(M.onDidChangeUserDataSyncStore(()=>this.n(M.userDataSyncStore?.url)))}};e.$Kyb=f,e.$Kyb=f=we([Y(0,p.$Yeb),Y(1,c.$0i),Y(2,l.$yo),Y(3,p.$cfb),Y(4,d.$wh),Y(5,v.$Sj),Y(6,y.$Ko)],f);class k{constructor(M,F,V,B){this.c=M,this.d=F,this.f=V,this.g=B,this.a=[],this.b=void 0}request(M,F,V){if(this.h()&&this.i(),F.url=M,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new p.$6eb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,M,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(M),this.f.request(F,V)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$Lyb=k}),define(oe[255],ae([0,1,3,55,24,19,20,250,23,76,79]),function(ne,e,I,T,O,j,L,P,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$05b=void 0;let E=class extends P.$E2b{constructor(h,d,v,c,l,u,y,p,R,t,o){super(h,d,v,c,l,y,p,R,t,o),this.B(I.Event.debounce(I.Event.any(I.Event.map(u.onDidFocusWindow,()=>"windowFocus"),I.Event.map(u.onDidOpenWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$05b=E,e.$05b=E=we([Y(0,O.$0i),Y(1,S.$Yeb),Y(2,S.$Zeb),Y(3,S.$0eb),Y(4,S.$$eb),Y(5,T.$13b),Y(6,S.$cfb),Y(7,b.$rxb),Y(8,L.$Vk),Y(9,C.$yXb),Y(10,j.$Ko)],E)}),define(oe[256],ae([0,1,67,26,5,22]),function(ne,e,I,T,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C3b=e.$B3b=e.$A3b=e.$z3b=void 0,e.$z3b=128/4;function L(b){function C(){let E=b.scheme===T.Schemas.file?(0,j.$Xf)(b):b.toString();return O.$k||(E=E.toLowerCase()),(0,I.createHash)("md5").update(E).digest("hex")}return{id:C(),configPath:b}}e.$A3b=L;function P(b,C){function E(){if(b.scheme!==T.Schemas.file)return(0,I.createHash)("md5").update(b.toString()).digest("hex");if(!C)return;let h;return O.$k?h=C.ino:O.$j?h=C.birthtime.getTime():O.$i&&(typeof C.birthtimeMs=="number"?h=Math.floor(C.birthtimeMs):h=C.birthtime.getTime()),(0,I.createHash)("md5").update(b.fsPath).update(h?String(h):"").digest("hex")}const m=E();if(typeof m=="string")return{id:m,uri:b}}e.$B3b=P;function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$C3b=S}),define(oe[257],ae([0,1,6,7,2,16,31,15,8,73,112,256,55,69]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D5b=void 0;let d=class extends O.$lb{constructor(c,l,u,y){super(),this.a=c,this.b=l,this.c=u,this.f=y,this.B(new I.$Gg(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=await L.Promises.readdir(this.a.workspaceStorageHome.fsPath),l=new b.$3xb(this.f.getChannel("storage"));await Promise.all(c.map(async u=>{const y=(0,j.$ac)(this.a.workspaceStorageHome.fsPath,u);u.length===E.$z3b||u===C.$Bh.id||(await this.c.getWindows()).some(t=>t.workspace?.id===u)||await l.isUsed(y)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${u} as it seems to be an unused empty workspace.`),await L.Promises.rm(y))}))}catch(c){(0,T.$Y)(c)}}};e.$D5b=d,e.$D5b=d=we([Y(0,P.$xh),Y(1,S.$Ri),Y(2,m.$13b),Y(3,h.$c5b)],d)}),define(oe[80],ae([0,1,52,6,16,11,31,144,267,268]),function(ne,e,I,T,O,j,L,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.zip=e.$3o=e.$2o=void 0,e.$2o="end of central directory record signature not found";const C=new RegExp(e.$2o);class E extends Error{constructor(o,n){let s=n.message;switch(o){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=o,this.cause=n}}e.$3o=E;function m(t){const o=t.externalFileAttributes>>16||33188;return[448,56,7].map(n=>o&n).reduce((n,s)=>n+s,o&61440)}function h(t){if(t instanceof E)return t;let o;return C.test(t.message)&&(o="CorruptZip"),new E(o,t)}function d(t,o,n,s,i,r){const a=O.$dc(o),w=O.$ac(s,a);if(!w.startsWith(s))return Promise.reject(new Error(P.localize(0,null,o)));const g=O.$ac(s,o);let f;return r.onCancellationRequested(()=>{f?.destroy()}),Promise.resolve(L.Promises.mkdir(w,{recursive:!0})).then(()=>new Promise((k,A)=>{if(!r.isCancellationRequested)try{f=(0,I.createWriteStream)(g,{mode:n}),f.once("close",()=>k()),f.once("error",A),t.once("error",A),t.pipe(f)}catch(M){A(M)}}))}function v(t,o,n,s){let i=(0,T.$jg)(()=>Promise.resolve()),r=0;return s.onCancellationRequested(()=>{i.cancel(),t.close()}),new Promise((a,w)=>{const g=new T.$qg,f=k=>{k.isCancellationRequested||(r++,t.readEntry())};t.once("error",w),t.once("close",()=>i.then(()=>{s.isCancellationRequested||t.entryCount===r?a():w(new E("Incomplete",new Error(P.localize(1,null,r,t.entryCount))))},w)),t.readEntry(),t.on("entry",k=>{if(s.isCancellationRequested)return;if(!n.sourcePathRegex.test(k.fileName)){f(s);return}const A=k.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(A)){const V=O.$ac(o,A);i=(0,T.$jg)(B=>L.Promises.mkdir(V,{recursive:!0}).then(()=>f(B)).then(void 0,w));return}const M=l(t,k),F=m(k);i=(0,T.$jg)(V=>g.queue(()=>M.then(B=>d(B,A,F,o,n,V).then(()=>f(V)))).then(null,w))})})}function c(t,o=!1){return new Promise((n,s)=>{(0,S.open)(t,o?{lazyEntries:!0}:void 0,(i,r)=>{i?s(h(i)):n((0,j.$ue)(r))})})}function l(t,o){return new Promise((n,s)=>{t.openReadStream(o,(i,r)=>{i?s(h(i)):n((0,j.$ue)(r))})})}function u(t,o){return new Promise((n,s)=>{const i=new b.ZipFile;o.forEach(a=>{a.contents?i.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&i.addFile(a.localPath,a.path)}),i.end();const r=(0,I.createWriteStream)(t);i.outputStream.pipe(r),i.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>n(t))})}e.zip=u;function y(t,o,n={},s){const i=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=c(t,!0);return n.overwrite&&(r=r.then(a=>L.Promises.rm(o).then(()=>a))),r.then(a=>v(a,o,{sourcePathRegex:i},s))}e.$5o=y;function p(t,o){return c(t).then(n=>new Promise((s,i)=>{n.on("entry",r=>{r.fileName===o&&l(n,r).then(a=>s(a),a=>i(a))}),n.once("close",()=>i(new Error(P.localize(2,null,o))))}))}function R(t,o){return p(t,o).then(n=>new Promise((s,i)=>{const r=[];n.once("error",i),n.on("data",a=>r.push(a)),n.on("end",()=>s(Buffer.concat(r)))}))}e.$6o=R}),define(oe[258],ae([0,1,6,7,2,26,22,53,11,32,31,80,18,15,29,33,97,13,8]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=void 0;let y=class $t extends O.$lb{static{this.c=".sigzip"}constructor(R,t,o,n,s,i){super(),this.h=t,this.i=o,this.j=n,this.k=s,this.l=i,this.extensionsDownloadDir=R.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(R,t,o){await this.g;const n=(0,L.$0f)(this.extensionsDownloadDir,this.u(R));try{await this.r(R,n,i=>this.i.download(R,i,t))}catch(i){throw new d.$Qn(i.message,d.ExtensionManagementErrorCode.Download)}let s=!1;if(o&&this.m(R)){const i=await this.n(R);try{s=await this.k.verify(n.fsPath,i.fsPath,this.l.getLevel()===u.LogLevel.Trace)}catch(r){const a=r;if(s=a.code,a.output&&this.l.trace(`Extension signature verification details for ${R.identifier.id} ${R.version}:
${a.output}`),s===d.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===d.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new d.$Qn(E.$2o,d.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(i)}catch(r){this.l.error(r)}}}return s===!0?this.l.info(`Extension signature is verified: ${R.identifier.id}`):s===!1?this.l.info(`Extension signature verification is not done: ${R.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${s}': ${R.identifier.id}`),{location:n,verificationStatus:s}}m(R){if(!R.isSigned)return!1;const t=this.j.getValue("extensions.verifySignature");return(0,S.$pe)(t)?t:!0}async n(R){await this.g;const t=(0,L.$0f)(this.extensionsDownloadDir,`${this.u(R)}${$t.c}`);return await this.r(R,t,o=>this.i.downloadSignatureArchive(R,o)),t}async r(R,t,o){if(await this.h.exists(t))return;if(t.scheme!==j.Schemas.file){await o(t);return}const n=(0,L.$0f)(this.extensionsDownloadDir,`.${(0,b.$6e)()}`);await this.h.exists(n)||await o(n);try{await C.Promises.rename(n.fsPath,t.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",R.identifier.id,t.path);else throw this.l.info(`Rename failed because of ${(0,T.$9)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(R){await this.g,await this.h.del(R)}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const R=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(R.children){const t=[],o=[],n=[];for(const r of R.children)if(r.name.endsWith($t.c))n.push(r.resource);else{const a=v.$go.parse(r.name);a&&o.push([a,r])}const s=(0,v.$lo)(o,([r])=>r),i=[];for(const r of s)r.sort((a,w)=>P.rcompare(a[0].version,w[0].version)),t.push(...r.slice(1).map(a=>a[1].resource)),i.push(r[0][1]);i.sort((r,a)=>r.mtime-a.mtime),t.push(...i.slice(0,Math.max(0,i.length-this.f)).map(r=>r.resource)),t.push(...n),await I.Promises.settled(t.map(r=>(this.l.trace("Deleting from cache",r.path),this.h.del(r))))}}catch(R){this.l.error(R)}}u(R){return this.f?v.$go.create(R).toString().toLowerCase():(0,b.$6e)()}};e.$ip=y,e.$ip=y=we([Y(0,h.$xh),Y(1,l.$Sj),Y(2,d.$Pn),Y(3,m.$Vh),Y(4,c.$Vo),Y(5,u.$Ri)],y)}),define(oe[259],ae([0,1,80,153]),function(ne,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;function O(j){return(0,I.$6o)(j,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,T.localize)(0,null))}})}e.$kp=O}),define(oe[121],ae([0,1,6,14,25,38,7,3,51,2,35,26,16,22,53,11,10,32,31,80,152,96,15,238,29,33,50,77,258,239,259,208,218,65,13,4,8,24,20,28,17]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u,y,p,R,t,o,n,s,i,r,a,w,g,f,k,A,M,F,V,B,x,Z,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=void 0,e.$np=(0,F.$qh)(n.$Rn);const J=".vsctmp";let X=class extends o.$7o{constructor(G,N,$,D,z,K,_,H,ee,ie,le,he){super(G,N,le,$,ie,he),this.bb=z,this.cb=K,this.db=_,this.eb=ee,this.ab=new Map,this.nb=new C.$oi;const me=this.B(H.createInstance(w.$jp));this.Y=this.B(H.createInstance(W,ke=>me.postUninstall(ke))),this.Z=this.B(new f.$lp(he,ee,le,this,this.y)),this.$=this.B(H.createInstance(a.$ip));const be=this.B(new k.$mp(this,this.bb,he,K,le,ee,$));this.B(be.onDidChangeExtensionsByAnotherSource(ke=>this.mb(ke))),this.ob()}getTargetPlatform(){return this.fb||(this.fb=(0,s.$qo)(this.eb,this.y)),this.fb}async zip(G){this.y.trace("ExtensionManagementService#zip",G.identifier.id);const N=await this.lb(G),$=await(0,y.zip)((0,h.$0f)(this.$.extensionsDownloadDir,(0,l.$6e)()).fsPath,N);return c.URI.file($)}async unzip(G){return this.y.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const{location:N,cleanup:$}=await this.hb(G),D=m.$bc(N.fsPath);try{return await(0,g.$kp)(D)}finally{await $()}}getInstalled(G,N=this.C.defaultProfile.extensionsResource){return this.Y.scanExtensions(G??null,N)}scanAllUserInstalledExtensions(){return this.Y.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(G){return this.Y.scanUserExtensionAtLocation(G)}async install(G,N={}){this.y.trace("ExtensionManagementService#install",G.toString());const{location:$,cleanup:D}=await this.hb(G);try{const z=await(0,g.$kp)(m.$bc($.fsPath)),K=(0,s.$ko)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,A.$xo)(z.engines.vscode,this.z.version,this.z.date))throw new Error(p.localize(0,null,K,this.z.version));const _=await this.D([{manifest:z,extension:$,options:N}]);if(_[0]?.local)return _[0]?.local;throw _[0]?.error?_[0].error:(0,o.$9o)(new Error(`Unknown error while installing extension ${K}`))}finally{await D()}}async installFromLocation(G,N){this.y.trace("ExtensionManagementService#installFromLocation",G.toString());const $=await this.Y.scanUserExtensionAtLocation(G);if(!$)throw new Error(`Cannot find a valid extension from the location ${G.toString()}`);return await this.qb([[$,void 0]],N),this.y.info("Successfully installed extension",$.identifier.id,N.toString()),$}async installExtensionsFromProfile(G,N,$){this.y.trace("ExtensionManagementService#installExtensionsFromProfile",G,N.toString(),$.toString());const D=(await this.Y.scanExtensions(1,N)).filter(z=>G.some(K=>(0,s.$fo)(K,z.identifier)));if(D.length){const z=await Promise.all(D.map(K=>this.Y.scanMetadata(K,N)));await this.qb(D.map((K,_)=>[K,z[_]]),$),this.y.info("Successfully installed extensions",D.map(K=>K.identifier.id),$.toString())}return D}async updateMetadata(G,N,$=this.C.defaultProfile.extensionsResource){return this.y.trace("ExtensionManagementService#updateMetadata",G.identifier.id),N.isPreReleaseVersion&&(N.preRelease=!0),N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.pinned=N.pinned||void 0,G=await this.Y.updateMetadata(G,N,$),this.Z.invalidate($),this.s.fire(G),G}async reinstallFromGallery(G){if(this.y.trace("ExtensionManagementService#reinstallFromGallery",G.identifier.id),!this.u.isEnabled())throw new Error(p.localize(1,null));const N=await this.getTargetPlatform(),[$]=await this.u.getExtensions([{...G.identifier,preRelease:G.preRelease}],{targetPlatform:N,compatible:!0},O.CancellationToken.None);if(!$)throw new Error(p.localize(2,null));await this.Y.setUninstalled(G);try{await this.Y.removeUninstalledExtension(G)}catch(D){throw new Error(p.localize(3,null,(0,j.$ai)(D)))}return this.installFromGallery($)}X(G,N,$,D){return this.Y.copyExtension(G,N,$,D)}copyExtensions(G,N){return this.Y.copyExtensions(G,N)}markAsUninstalled(...G){return this.Y.setUninstalled(...G)}async cleanUp(){this.y.trace("ExtensionManagementService#cleanUp");try{await this.Y.cleanUp()}catch(G){this.y.error(G)}}async download(G,N,$){const{location:D}=await this.$.download(G,N,!$);return D}async hb(G){if(G.scheme===E.Schemas.file)return{location:G,async cleanup(){}};this.y.trace("Downloading extension from",G.toString());const N=(0,h.$0f)(this.$.extensionsDownloadDir,(0,l.$6e)());return await this.db.download(G,N),this.y.info("Downloaded extension to",N.toString()),{location:N,cleanup:async()=>{try{await this.eb.del(N)}catch(D){this.y.error(D)}}}}S(){return this.C.defaultProfile.extensionsResource}U(G,N,$){if(c.URI.isUri(N))return new te(G,N,$,this.u,this.Y,this.w,this.C,this.bb,this.cb,this.y);const D=s.$go.create(N).toString();let z=this.ab.get(D);return z||(this.ab.set(D,z=new q(G,N,$,this.$,this.Y,this.w,this.C,this.bb,this.cb,this.y)),z.waitUntilTaskIsFinished().finally(()=>this.ab.delete(D))),z}W(G,N){return new re(G,N.profileLocation,this.cb)}async lb(G){const N=async D=>{let z=await u.Promises.readdir(D);z=z.map(H=>m.$ac(D,H));const K=await Promise.all(z.map(H=>u.Promises.stat(H)));let _=Promise.resolve([]);return K.forEach((H,ee)=>{const ie=z[ee];H.isFile()&&(_=_.then(le=>[...le,ie])),H.isDirectory()&&(_=_.then(le=>N(ie).then(he=>[...le,...he])))}),_};return(await N(G.location.fsPath)).map(D=>({path:`extension/${m.$cc(G.location.fsPath,D)}`,localPath:D}))}async mb({added:G,removed:N}){if(N)for(const $ of N.extensions)this.y.info("Extensions removed from another source",$.id,N.profileLocation.toString()),this.p.fire({identifier:$,profileLocation:N.profileLocation});if(G){const D=(await this.Y.scanExtensions(1,G.profileLocation)).filter(z=>G.extensions.some(K=>(0,s.$fo)(K,z.identifier)));this.m.fire(D.map(z=>(this.y.info("Extensions added from another source",z.identifier.id,G.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:G.profileLocation,operation:1})))}}async ob(){this.B(this.Y.onExtract(N=>this.nb.add(N)));const G=await this.eb.resolve(this.bb.userExtensionsLocation);for(const N of G.children??[])N.isDirectory&&this.nb.add(N.resource);this.B(this.eb.watch(this.bb.userExtensionsLocation)),this.B(this.eb.onDidFilesChange(N=>this.pb(N)))}async pb(G){if(!G.affects(this.bb.userExtensionsLocation,1))return;const N=[];for(const $ of G.rawAdded){if(this.nb.has($)||!this.w.extUri.isEqual(this.w.extUri.dirname($),this.bb.userExtensionsLocation)||this.w.extUri.isEqual($,this.w.extUri.joinPath(this.bb.userExtensionsLocation,".obsolete"))||this.w.extUri.basename($).startsWith(".")||!(await this.eb.stat($)).isDirectory)continue;const D=await this.Y.scanUserExtensionAtLocation($);D&&D.installedTimestamp===void 0&&(this.nb.add($),N.push(D))}N.length&&(await this.qb(N.map($=>[$,void 0]),this.C.defaultProfile.extensionsResource),this.y.info("Added extensions to default profile from external source",N.map($=>$.identifier.id)))}async qb(G,N){const $=G.map(D=>D[0]);await this.rb($),await this.cb.addExtensionsToProfile(G,N),this.m.fire($.map(D=>({local:D,identifier:D.identifier,operation:1,profileLocation:N})))}async rb(G){const N=await this.Y.getUninstalledExtensions();for(const $ of G){const D=s.$go.create($);N[D.toString()]&&(this.y.trace("Removing the extension from uninstalled list:",D.id),await this.Y.setInstalled(D),this.y.info("Removed the extension from uninstalled list:",D.id))}}};e.$op=X,e.$op=X=we([Y(0,n.$Pn),Y(1,x.$Vk),Y(2,V.$Ri),Y(3,t.$xh),Y(4,r.$dp),Y(5,i.$_o),Y(6,R.$un),Y(7,F.$oh),Y(8,M.$Sj),Y(9,B.$0i),Y(10,Z.$pk),Y(11,Q.$rk)],X);let W=class extends b.$lb{constructor(G,N,$,D,z,K){super(),this.j=G,this.k=N,this.l=$,this.m=D,this.n=z,this.p=K,this.h=this.B(new P.$8c),this.onExtract=this.h.event,this.c=(0,h.$0f)(this.l.userExtensionsLocation,".obsolete"),this.g=new I.$Cg}async cleanUp(){await this.C(),await this.z()}async scanExtensions(G,N){const $={includeInvalid:!0,profileLocation:N};let D=[];return G===null||G===0?D.push(...await this.l.scanAllExtensions({includeInvalid:!0},$,!1)):G===1&&D.push(...await this.l.scanUserExtensions($)),D=G!==null?D.filter(z=>z.type===G):D,Promise.all(D.map(z=>this.y(z)))}async scanAllUserExtensions(G){const N=await this.l.scanUserExtensions({includeAllVersions:!G,includeInvalid:!0});return Promise.all(N.map($=>this.y($)))}async scanUserExtensionAtLocation(G){try{const N=await this.l.scanExistingExtension(G,1,{includeInvalid:!0});if(N)return await this.y(N)}catch(N){this.p.error(N)}return null}async extractUserExtension(G,N,$,D,z){const K=G.toString(),_=c.URI.file(m.$ac(this.l.userExtensionsLocation.fsPath,`.${(0,l.$6e)()}`)),H=c.URI.file(m.$ac(this.l.userExtensionsLocation.fsPath,K));let ee=await this.k.exists(H);if(ee&&D){try{await this.t(G.id,H,"removeExisting")}catch{throw new n.$Qn(p.localize(4,null,H.fsPath,G.id),n.ExtensionManagementErrorCode.Delete)}ee=!1}if(!ee)try{try{this.p.trace(`Started extracting the extension from ${N} to ${H.fsPath}`),await(0,y.$5o)(N,_.fsPath,{sourcePath:"extension",overwrite:!0},z),this.p.info(`Extracted extension to ${H}:`,G.id)}catch(ie){let le=n.ExtensionManagementErrorCode.Extract;throw ie instanceof y.$3o&&(ie.type==="CorruptZip"?le=n.ExtensionManagementErrorCode.CorruptZip:ie.type==="Incomplete"&&(le=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$Qn(ie.message,le)}await this.l.updateMetadata(_,$);try{this.p.trace(`Started renaming the extension from ${_.fsPath} to ${H.fsPath}`),await this.v(_.fsPath,H.fsPath),this.p.info("Renamed to",H.fsPath)}catch(ie){if(ie.code==="ENOTEMPTY")this.p.info("Rename failed because extension was installed by another source. So ignoring renaming.",G.id);else throw this.p.info(`Rename failed because of ${(0,L.$9)(ie)}. Deleted from extracted location`,_),ie}this.h.fire(H)}catch(ie){try{await this.k.del(_,{recursive:!0})}catch{}throw ie}return this.w(H,1)}async scanMetadata(G,N){return N?(await this.s(G,N))?.metadata:this.l.scanMetadata(G.location)}async s(G,N){return(await this.m.scanProfileExtensions(N)).find(D=>(0,s.$fo)(D.identifier,G.identifier))}async updateMetadata(G,N,$){return $?await this.m.updateMetadata([[G,N]],$):await this.l.updateMetadata(G.location,N),this.w(G.location,G.type,$)}getUninstalledExtensions(){return this.u()}async setUninstalled(...G){const N=G.map($=>s.$go.create($));await this.u($=>N.forEach(D=>{$[D.toString()]=!0,this.p.info("Marked extension as uninstalled",D.toString())}))}async setInstalled(G){await this.u(N=>delete N[G.toString()])}async removeExtension(G,N){if(this.n.extUri.isEqualOrParent(G.location,this.l.userExtensionsLocation))return this.t(G.identifier.id,G.location,N)}async removeUninstalledExtension(G){await this.removeExtension(G,"uninstalled"),await this.u(N=>delete N[s.$go.create(G).toString()])}async copyExtension(G,N,$,D){const z=await this.s(G,N),K=await this.s(G,$);return D={...z?.metadata,...D},K?await this.m.updateMetadata([[G,{...K.metadata,...D}]],$):await this.m.addExtensionsToProfile([[G,D]],$),this.w(G.location,G.type,$)}async copyExtensions(G,N){const $=await this.scanExtensions(1,G),D=await Promise.all($.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,G)]));await this.m.addExtensionsToProfile(D,N)}async t(G,N,$){this.p.trace(`Deleting ${$} extension from disk`,G,N.fsPath);const D=this.n.extUri.joinPath(this.n.extUri.dirname(N),`${this.n.extUri.basename(N)}.${(0,S.$di)((0,l.$6e)()).toString(16)}${J}`);await this.v(N.fsPath,D.fsPath),await this.k.del(D,{recursive:!0}),this.p.info(`Deleted ${$} extension from disk`,G,N.fsPath)}async u(G){return this.g.queue(async()=>{let N;try{N=(await this.k.readFile(this.c,"utf8")).value.toString()}catch(D){if((0,M.$9j)(D)!==1)throw D}let $={};if(N)try{$=JSON.parse(N)}catch{}return G&&(G($),Object.keys($).length?await this.k.writeFile(this.c,T.$Jb.fromString(JSON.stringify($))):await this.k.del(this.c)),$})}async v(G,N){try{await u.Promises.rename(G,N,2*60*1e3)}catch($){throw new n.$Qn($.message||p.localize(5,null,G,N),$.code||n.ExtensionManagementErrorCode.Rename)}}async w(G,N,$){if($){const z=(await this.l.scanUserExtensions({profileLocation:$})).find(K=>this.n.extUri.isEqual(K.location,G));if(z)return this.y(z)}else{const D=await this.l.scanExistingExtension(G,N,{includeInvalid:!0});if(D)return this.y(D)}throw new Error(p.localize(6,null,G.path))}async y(G){const N=await this.k.resolve(G.location);let $,D;return N.children&&($=N.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,D=N.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:G.identifier,type:G.type,isBuiltin:G.isBuiltin||!!G.metadata?.isBuiltin,location:G.location,manifest:G.manifest,targetPlatform:G.targetPlatform,validations:G.validations,isValid:G.isValid,readmeUrl:$,changelogUrl:D,publisherDisplayName:G.metadata?.publisherDisplayName||null,publisherId:G.metadata?.publisherId||null,isApplicationScoped:!!G.metadata?.isApplicationScoped,isMachineScoped:!!G.metadata?.isMachineScoped,isPreReleaseVersion:!!G.metadata?.isPreReleaseVersion,preRelease:!!G.metadata?.preRelease,installedTimestamp:G.metadata?.installedTimestamp,updated:!!G.metadata?.updated,pinned:!!G.metadata?.pinned}}async z(){const G=await this.getUninstalledExtensions();if(Object.keys(G).length===0){this.p.debug("No uninstalled extensions found.");return}this.p.debug("Removing uninstalled extensions:",Object.keys(G));const N=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),$=new Set;for(const z of N)G[s.$go.create(z).toString()]||$.add(z.identifier.id.toLowerCase());try{const z=(0,s.$lo)(N,K=>K.identifier);await I.Promises.settled(z.map(async K=>{const _=K.sort((H,ee)=>d.rcompare(H.manifest.version,ee.manifest.version))[0];$.has(_.identifier.id.toLowerCase())||await this.j(await this.y(_))}))}catch(z){this.p.error(z)}const D=N.filter(z=>z.metadata&&G[s.$go.create(z).toString()]);await Promise.allSettled(D.map(z=>this.removeUninstalledExtension(z)))}async C(){this.p.trace("ExtensionManagementService#removeTempDeleteFolders");let G;try{G=await this.k.resolve(this.l.userExtensionsLocation)}catch(N){(0,M.$9j)(N)!==1&&this.p.error(N);return}if(G?.children)try{await Promise.allSettled(G.children.map(async N=>{if(!(!N.isDirectory||!N.name.endsWith(J))){this.p.trace("Deleting the temporarily deleted folder",N.resource.toString());try{await this.k.del(N.resource,{recursive:!0}),this.p.trace("Deleted the temporarily deleted folder",N.resource.toString())}catch($){(0,M.$9j)($)!==1&&this.p.error($)}}}))}catch{}}};e.$pp=W,e.$pp=W=we([Y(1,M.$Sj),Y(2,r.$dp),Y(3,i.$_o),Y(4,Z.$pk),Y(5,V.$Ri)],W);class U extends o.$0o{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,v.$qe)(this.m.operation)?this.l:this.m.operation}constructor(G,N,$,D,z,K,_,H,ee){super(),this.identifier=G,this.source=N,this.m=$,this.n=D,this.o=z,this.p=K,this.q=_,this.s=H,this.t=ee,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h(G){const[N,$]=await this.y(G);return this.j=N.isBuiltin||N.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[N,$]],this.j),N}async v({zipPath:G,key:N,metadata:$},D,z){let K=await this.w(N);return K||(this.t.trace("Extracting extension...",N.id),K=await this.n.extractUserExtension(N,G,$,D,z),this.t.info("Extracting extension completed.",N.id)),K}async w(G){return await this.x(G)?(this.t.trace("Removing the extension from uninstalled list:",G.id),await this.n.setInstalled(G),this.t.info("Removed the extension from uninstalled list:",G.id),(await this.n.scanAllUserExtensions(!0)).find(D=>s.$go.create(D).equals(G))):void 0}async x(G){return!!(await this.n.getUninstalledExtensions())[G.toString()]}}class q extends U{constructor(G,N,$,D,z,K,_,H,ee,ie){super(N.identifier,N,$,z,K,_,H,ee,ie),this.z=N,this.A=D}async y(G){const $=(await this.n.scanExtensions(null,this.m.profileLocation)).find(_=>(0,s.$fo)(_.identifier,this.z.identifier));$&&(this.l=3);const D={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||$?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||$?.isMachineScoped,isBuiltin:this.m.isBuiltin||$?.isBuiltin,isSystem:$?.type===0?!0:void 0,updated:!!$,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,v.$pe)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:$?.preRelease)};if($?.manifest.version===this.z.version)return[await this.n.updateMetadata($,D),D];const{location:z,verificationStatus:K}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=K,this.C(z.fsPath),[await this.v({zipPath:z.fsPath,key:s.$go.create(this.z),metadata:D},!1,G),D]}catch(_){try{await this.A.delete(z)}catch(H){this.t.warn("Error while deleting the downloaded file",z.toString(),(0,L.$9)(H))}throw _}}async C(G){try{await(0,g.$kp)(G)}catch(N){throw new n.$Qn((0,o.$8o)(N).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$qp=q;class te extends U{constructor(G,N,$,D,z,K,_,H,ee,ie){super({id:(0,s.$ko)(G.publisher,G.name)},N,$,z,K,_,H,ee,ie),this.z=G,this.A=N,this.B=D}async h(G){const N=await super.h(G);return this.E(N,G),N}async y(G){const N=new s.$go(this.identifier,this.z.version),D=(await this.n.scanExtensions(1,this.m.profileLocation)).find(_=>(0,s.$fo)(this.identifier,_.identifier)),z={isApplicationScoped:this.m.isApplicationScoped||D?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||D?.isMachineScoped,isBuiltin:this.m.isBuiltin||D?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(D)if(this.l=3,N.equals(new s.$go(D.identifier,D.manifest.version)))try{await this.n.removeExtension(D,"existing")}catch{throw new Error(p.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&d.gt(D.manifest.version,this.z.version)&&await this.n.setUninstalled(D);else{const _=await this.w(N);if(_)try{await this.n.removeExtension(_,"existing")}catch{throw new Error(p.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:m.$bc(this.A.fsPath),key:N,metadata:z},!0,G),z]}async E(G,N){try{let[$]=await this.B.getExtensions([{id:G.identifier.id,version:G.manifest.version}],N);if($||([$]=await this.B.getExtensions([{id:G.identifier.id}],N)),$){const D={id:$.identifier.uuid,publisherDisplayName:$.publisherDisplayName,publisherId:$.publisherId,isPreReleaseVersion:$.properties.isPreReleaseVersion,preRelease:$.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata(G,D,this.m.profileLocation)}}catch{}}}class re extends o.$0o{constructor(G,N,$){super(),this.extension=G,this.j=N,this.k=$}async h(G){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[260],ae([0,1,2,29,78,217,121,8,19]),function(ne,e,I,T,O,j,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$45b=void 0;let b=class extends I.$lb{constructor(E,m,h,d,v,c){super(),E.cleanUp(),(0,j.$dTb)(E,m,h,d,c),O.$Dz.removeOutdatedExtensionVersions(E,v)}};e.$45b=b,e.$45b=b=we([Y(0,L.$np),Y(1,T.$Pn),Y(2,O.$Cz),Y(3,T.$Un),Y(4,S.$Ko),Y(5,P.$Ri)],b)}),define(oe[261],ae([0,1,67,60,36,269,14,7,3,2,16,5,32,43,92]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=void 0;class v{traceSocketEvent(f,k){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,k)}constructor(f,k=""){this.f=!0,this.debugLabel=k,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,P.$Y)(A)}},this.socket.on("error",this.a),this.b=A=>{this.traceSocketEvent("close",{hadError:A}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const k=A=>{this.traceSocketEvent("read",A),f(L.$Jb.wrap(A))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(f){const k=A=>{f({type:0,hadError:A,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(f){const k=()=>{f()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,P.$Y)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,P.$Y)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.$eh=v;var c;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize",g[g.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(c||(c={}));var l;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(l||(l={}));class u extends b.$lb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,k){this.socket.traceSocketEvent(f,k)}constructor(f,k,A,M){super(),this.f=this.B(new S.$8c),this.g=this.B(new S.$8c),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:A?.byteLength||0,recordInflateBytes:M}),this.a=this.B(new y(this,k,A,M,this.f,(F,V)=>this.k(F,V))),this.B(this.a.onError(F=>{console.error(F),(0,P.$Y)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new d.$_g,this.B(this.socket.onData(F=>this.l(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let k=0;for(;k<f.byteLength;)this.a.writeMessage(f.slice(k,Math.min(k+262144,f.byteLength))),k+=262144}k(f,k){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let A=2;f.byteLength<126?A+=0:f.byteLength<2**16?A+=2:A+=8;const M=L.$Jb.alloc(A);if(k?M.writeUInt8(194,0):M.writeUInt8(130,0),f.byteLength<126)M.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){M.writeUInt8(126,1);let F=1;M.writeUInt8(f.byteLength>>>8&255,++F),M.writeUInt8(f.byteLength>>>0&255,++F)}else{M.writeUInt8(127,1);let F=1;M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(f.byteLength>>>24&255,++F),M.writeUInt8(f.byteLength>>>16&255,++F),M.writeUInt8(f.byteLength>>>8&255,++F),M.writeUInt8(f.byteLength>>>0&255,++F)}this.socket.write(L.$Jb.concat([M,f]))}end(){this.h=!0,this.socket.end()}l(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),A=k.readUInt8(0),M=(A&128)>>>7,F=(A&64)>>>6,V=k.readUInt8(1),B=(V&128)>>>7,x=V&127;this.j.state=2,this.j.readLen=2+(B?4:0)+(x===126?2:0)+(x===127?8:0),this.j.fin=M,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!M,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),A=k.readUInt8(1),M=(A&128)>>>7;let F=A&127,V=1;F===126?F=k.readUInt8(++V)*2**8+k.readUInt8(++V):F===127&&(F=k.readUInt8(++V)*0+k.readUInt8(++V)*0+k.readUInt8(++V)*0+k.readUInt8(++V)*0+k.readUInt8(++V)*2**24+k.readUInt8(++V)*2**16+k.readUInt8(++V)*2**8+k.readUInt8(++V));let B=0;M&&(B=k.readUInt8(++V)*2**24+k.readUInt8(++V)*2**16+k.readUInt8(++V)*2**8+k.readUInt8(++V)),this.j.state=3,this.j.readLen=F,this.j.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(k,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$fh=u;class y extends b.$lb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$Jb.alloc(0)}constructor(f,k,A,M,F,V){super(),this.l=f,this.m=F,this.n=V,this.a=this.B(new S.$8c),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$8c),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new S.$8c),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,k?(this.b=this.B(new p(this.l,M,A,{windowBits:15})),this.f=this.B(new R(this.l,{windowBits:15})),this.B(this.b.onError(B=>this.a.fire(B))),this.B(this.f.onError(B=>this.a.fire(B)))):(this.b=null,this.f=null)}writeMessage(f){this.g.push(f),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const f=this.g.shift();if(this.f){const k=await this.s(this.f,f);this.n(k,!0)}else this.n(f,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(f,k){return new Promise((A,M)=>{f.write(k),f.flush(F=>A(F))})}acceptFrame(f,k,A){this.h.push({data:f,isCompressed:k,isLastFrameOfMessage:A}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const k=await this.w(this.b,f.data,f.isLastFrameOfMessage);this.m.fire(k)}else this.m.fire(f.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(f,k,A){return new Promise((M,F)=>{f.write(k),A&&f.write(L.$Jb.fromByteArray([0,0,255,255])),f.flush(V=>M(V))})}}class p extends b.$lb{get recordedInflateBytes(){return this.j?L.$Jb.concat(this.f):L.$Jb.alloc(0)}constructor(f,k,A,M){super(),this.h=f,this.j=k,this.a=this.B(new S.$8c),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(M),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(L.$Jb.wrap(F))}),A&&(this.h.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this.b.write(A.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=L.$Jb.concat(this.g);this.g.length=0,f(k)})}}class R extends b.$lb{constructor(f,k){super(),this.g=f,this.a=this.B(new S.$8c),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",A=>{this.g.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this.a.fire(A)}),this.b.on("data",A=>{this.g.traceSocketEvent("zlibDeflateData",A),this.f.push(L.$Jb.wrap(A))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=L.$Jb.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),f(k)})}}function t(g,f){if(f===0)return;const k=g.byteLength>>>2;for(let x=0;x<k;x++){const Z=g.readUInt32BE(x*4);g.writeUInt32BE(Z^f,x*4)}const A=k*4,M=g.byteLength-A,F=f>>>24&255,V=f>>>16&255,B=f>>>8&255;M>=1&&g.writeUInt8(g.readUInt8(A)^F,A),M>=2&&g.writeUInt8(g.readUInt8(A+1)^V,A+1),M>=3&&g.writeUInt8(g.readUInt8(A+2)^B,A+2)}e.$gh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function n(){const g=(0,m.$6e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;const f=process.platform!=="darwin"&&e.$gh?e.$gh:(0,O.tmpdir)(),k=(0,C.$ac)(f,`vscode-ipc-${g}.sock`);return i(k),k}e.$hh=n;function s(g,f,k){const A=(0,I.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${k}-${f}-sock`;const M=k.substr(0,4),F=f.substr(0,6),V=A.substr(0,8);let B;return process.platform!=="darwin"&&e.$gh&&!process.env.VSCODE_PORTABLE?B=(0,C.$ac)(e.$gh,`vscode-${V}-${M}-${F}.sock`):B=(0,C.$ac)(g,`${M}-${F}.sock`),i(B),B}e.$ih=s;function i(g){const f=o[E.$t];typeof f=="number"&&g.length>=f&&console.warn(`WARNING: IPC handle "${g}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends h.$6g{static b(f){const k=S.Event.fromNodeEventEmitter(f,"connection");return S.Event.map(k,A=>({protocol:new d.$ah(new v(A,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(A,"close"))}))}constructor(f){super(r.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$jh=r;function a(g){return new Promise((f,k)=>{const A=(0,T.createServer)();A.on("error",k),A.listen(g,()=>{A.removeListener("error",k),f(new r(A))})})}e.$kh=a;function w(g,f){return new Promise((k,A)=>{const M=(0,T.createConnection)(g,()=>{M.removeListener("error",A),k(d.$bh.fromSocket(new v(M,`ipc-client${f}`),f))});M.once("error",A)})}e.$lh=w}),define(oe[262],ae([0,1,60,261,206]),function(ne,e,I,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a6b=void 0,e.$a6b=new class{supports(j){return!0}connect({host:j,port:L},P,S,b){return new Promise((C,E)=>{const m=I.createConnection({host:j,port:L},()=>{m.removeListener("error",E),m.write((0,O.$Wib)(P,S,b));const h=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",h),C(new T.$eh(m,b)))};m.on("data",h)});m.setNoDelay(!0),m.once("error",E)})}}}),define(oe[270],ae([0,1,36,38,7,2,26,10,43,143,200,201,192,193,257,183,185,18,205,95,215,96,211,15,113,242,29,97,184,121,98,13,195,196,66,4,191,68,70,220,8,197,102,24,57,19,107,20,108,109,110,46,223,78,111,23,76,248,234,235,79,249,252,253,254,58,247,236,106,214,74,225,210,224,28,226,5,227,186,203,202,77,241,17,50,199,56,246,222,237,105,251,260,9,198,101,244,240,212,180,55,255,243,69,245,104,262,178]),function(ne,e,I,T,O,j,L,P,S,b,C,E,m,h,d,v,c,l,u,y,p,R,t,o,n,s,i,r,a,w,g,f,k,A,M,F,V,B,x,Z,Q,J,X,W,U,q,te,re,ce,G,N,$,D,z,K,_,H,ee,ie,le,he,me,be,ke,Pe,je,De,We,ue,de,$e,Se,Ce,Fe,Le,Ue,Ae,Ne,ze,se,fe,ge,pe,ye,Ee,Re,Ie,Oe,Be,Me,qe,He,_e,nt,St,gt,Ct,Pt,Rt,It,Lt,jt,Ot,mt,Dt,bt,At,Nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Tt extends j.$lb{constructor(ve){super(),this.c=ve,this.a=this.B(new b.$BS),this.b=void 0,this.f()}f(){let ve=!1;const Te=()=>{ve||(ve=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Te),(0,b.$CS)(process.parentPort,"vscode:electron-main->shared-process=exit",Te)}async init(){const ve=await this.g();(0,_.$Teb)(),ve.invokeFunction(Te=>{const Ye=Te.get(Q.$Ri);Ye.trace("sharedProcess configuration",JSON.stringify(this.c)),this.h(Te),this.i(Ye)}),this.B((0,j.$ib)(ve.createInstance(C.$z5b,this.c.codeCachePath),ve.createInstance(E.$A5b),ve.createInstance(d.$D5b),ve.createInstance(h.$C5b),ve.createInstance(m.$B5b),ve.createInstance(_e.$45b),ve.createInstance(Me.$V5b)))}async g(){const ve=new B.$nh,Te={_serviceBrand:void 0,...X.default};ve.set(W.$0i,Te);const Ye=new S.$0g(Je=>Je==="main"),Ge=new mt.$d5b(this.a,Ye);ve.set(mt.$c5b,Ge);const at=this.c.policiesData?new Re.$P4b(this.c.policiesData,Ge.getChannel("policy")):new Ie.$Xm;ve.set(Ie.$Vm,at);const Ze=new Nt.$Xl(this.c.args,Te);ve.set(o.$xh,Ze);const et=new J.$Nq(void 0,this.c.logLevel,Ze.logsHome,this.c.loggers.map(Je=>({...Je,resource:P.URI.revive(Je.resource)})),Ge.getChannel("logger"));ve.set(Q.$Si,et);const ct=this.B(et.createLogger("sharedprocess",{name:(0,nt.localize)(0,null)})),ut=this.B(new Q.$Zi(ct.getLevel())),Ke=this.B(new St.$1M(ct,[ut]));ve.set(Q.$Ri,Ke),this.b=this.B(new gt.$65b(Ke)),ve.set(gt.$55b,this.b);const Qe=this.B(new k.$sp(Ke));ve.set(f.$Sj,Qe);const ft=this.B(new A.$Rp(Ke));Qe.registerProvider(L.Schemas.file,ft);const dt=this.B(new Ne.$b5b(L.Schemas.file,this.B(new ze.$JM(Ge.getChannel(ze.$IM),{pathCaseSensitive:Ae.$k})),L.Schemas.vscodeUserData,Ke));Qe.registerProvider(L.Schemas.vscodeUserData,dt);const tt=this.B(new Oe.$8M(this.c.profiles.all,P.URI.revive(this.c.profiles.home).with({scheme:Ze.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));ve.set(ye.$rk,tt);const xe=this.B(new u.$ln(tt.defaultProfile.settingsResource,Qe,at,Ke));ve.set(l.$Vh,xe);const st=new Dt.$_5b(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},Ge,Ze);ve.set(q.$Ko,st),this.B((0,j.$jb)(()=>st.flush())),await Promise.all([xe.initialize(),st.initialize()]);const Mt=new Ue.$cr(Qe);ve.set(Le.$pk,Mt);const yt=new Rt.$Bq(Ge.getChannel("request"));ve.set(U.$yo,yt),ve.set(v.$E5b,new M.$mh(c.$F5b,void 0,!1)),ve.set(fe.$lF,new M.$mh(se.$U5b,void 0,!1));const pt=S.ProxyChannel.toService(Ge.getChannel("nativeHost"));ve.set(Lt.$13b,pt),ve.set(R.$un,new M.$mh(t.$dN,void 0,!0));const Ft=this.B(new We.$L4b(pt)),zt=new S.$0g(Je=>Ft.getActiveClientId().then(ht=>Je===ht));ve.set(g.$ZSb,new It.$85b(this.a.getChannel("extensionRecommendationNotification",zt)));let lt;const rt=[],vt=(0,$.$co)(Te,xe);if((0,$.$0n)(Te,Ze)){const Je=new G.$W1b(Ke,et,Ze,Te);if(rt.push(Je),Te.aiConfig?.ariaKey){const ht=new Be.$OM(yt,vt,"monacoworkbench",null,Te.aiConfig.ariaKey);this.B((0,j.$jb)(()=>ht.flush())),rt.push(ht)}lt=new N.$Fq({appenders:rt,commonProperties:(0,te.$Zn)((0,I.release)(),(0,I.hostname)(),process.arch,Te.commit,Te.version,this.c.machineId,vt),sendErrorTelemetry:!0,piiPaths:(0,$.$do)(Ze)},xe,Te)}else{lt=$.$4n;const Je=$.$8n;rt.push(Je)}this.a.registerChannel("telemetryAppender",new ce.$p4b(rt)),ve.set(re.$Vk,lt);const Ut=new D.$G5b(xe,lt,Ke,et,Ze,Te);ve.set(re.$Wk,Ut),ve.set(Ee.$_o,new M.$mh(Pt.$ZM,void 0,!0)),ve.set(ge.$dp,new M.$mh(pe.$Q4b,void 0,!0)),ve.set(r.$Vo,new M.$mh(r.$Wo,void 0,!0)),ve.set(w.$np,new M.$mh(w.$op,void 0,!0)),ve.set(i.$Pn,new M.$mh(s.$To,void 0,!0)),ve.set(i.$Vn,new M.$mh(Ot.$$5b,void 0,!1)),ve.set(x.$xq,new M.$mh(Z.$zq,void 0,!1)),ve.set(y.$5l,new M.$mh(p.$jr,void 0,!1)),ve.set(H.$rxb,new M.$mh(H.$sxb,void 0,!0)),ve.set(_.$cfb,new M.$mh(le.$zzb,void 0,!0)),ve.set(_.$bfb,new ie.$J5b(this.a.getChannel("userDataSyncUtil",Je=>Je.ctx!=="main"))),ve.set(i.$Un,new M.$mh(n.$pxb,void 0,!1)),ve.set(K.$xzb,new M.$mh(K.$yzb,void 0,!0)),ve.set(z.$Cz,new M.$mh(z.$Dz)),ve.set(_.$Yeb,new M.$mh(Pe.$Iyb,void 0,!0)),ve.set(_.$Zeb,new M.$mh(Pe.$Kyb,void 0,!0)),ve.set(he.$yXb,new M.$mh(he.$AXb,void 0,!0)),ve.set(_.$1eb,new M.$mh(ee.$y2b,void 0,!1)),ve.set(_.$0eb,new M.$mh(me.$n2b,void 0,!0)),ve.set(_.$$eb,new M.$mh(be.$D2b,void 0,!1)),ve.set(je.$4xb,new M.$mh(De.$Q5b,void 0,!0)),ve.set(_.$_eb,new M.$mh(He.$d3b,void 0,!0)),ve.set(ue.$Jk,new M.$mh(de.$$4b,void 0,!1));const Et=new bt.$Hk;return ve.set(bt.$Gk,Et),Et.register(0,At.$a6b),ve.set($e.$Gz,new M.$mh(Se.$94b)),ve.set(Ce.$R5b,new M.$mh(Fe.$T5b)),ve.set(qe.$W5b,new M.$mh(Ct.$75b)),new V.$Up(ve)}h(ve){const Te=new a.$Yo(ve.get(i.$Rn),()=>null);this.a.registerChannel("extensions",Te);const Ye=S.ProxyChannel.fromService(ve.get(x.$xq));this.a.registerChannel("languagePacks",Ye);const Ge=S.ProxyChannel.fromService(ve.get(y.$5l));this.a.registerChannel("diagnostics",Ge);const at=new a.$1o(ve.get(i.$Vn));this.a.registerChannel("extensionTipsService",at);const Ze=S.ProxyChannel.fromService(ve.get(v.$E5b));this.a.registerChannel("checksum",Ze);const et=S.ProxyChannel.fromService(ve.get(fe.$lF));this.a.registerChannel("v8InspectProfiling",et);const ct=new ie.$K5b(ve.get(he.$yXb));this.a.registerChannel("userDataSyncMachines",ct);const ut=S.ProxyChannel.fromService(ve.get(re.$Wk));this.a.registerChannel("customEndpointTelemetry",ut);const Ke=new ie.$L5b(ve.get(H.$rxb));this.a.registerChannel("userDataSyncAccount",Ke);const Qe=new ie.$M5b(ve.get(_.$Yeb));this.a.registerChannel("userDataSyncStoreManagement",Qe);const ft=new ke.$O5b(ve.get(_.$$eb),ve.get(ye.$rk),ve.get(Q.$Ri));this.a.registerChannel("userDataSync",ft);const dt=this.B(ve.get(F.$oh).createInstance(jt.$05b)),tt=new ie.$H5b(dt);this.a.registerChannel("userDataAutoSync",tt);const xe=S.ProxyChannel.fromService(ve.get(Ce.$R5b));this.a.registerChannel(Ce.$S5b,xe);const st=S.ProxyChannel.fromService(ve.get(qe.$W5b));this.a.registerChannel("remoteTunnel",st)}i(ve){process.on("uncaughtException",Te=>(0,O.$Y)(Te)),process.on("unhandledRejection",Te=>(0,O.$Y)(Te)),(0,O.setUnexpectedErrorHandler)(Te=>{const Ye=(0,T.$ai)(Te,!0);Ye&&ve.error(`[uncaught exception in sharedProcess]: ${Ye}`)})}}async function wt(ot){const ve=new Tt(ot);process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"),await ve.init(),process.parentPort.postMessage("vscode:shared-process->electron-main=init-done")}e.main=wt,process.parentPort.once("message",ot=>{wt(ot.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/93d3731736cc6fefbd63810d5fb2d57bedc84ca0/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
