/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/event","vs/base/common/lifecycle","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/strings","vs/base/common/path","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/process","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","child_process","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","fs","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/htmlContent","os","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/labels","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist","dns"],Ce=function(fe){for(var e=[],k=0,F=fe.length;k<F;k++)e[k]=Se[fe[k]];return e};define(Se[150],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class k{static get(){const h=new Map,A=new Map,P=new Map,m=new Map;function E(D,S){D.has(S.detail)||D.set(S.detail,-S.timestamp)}function b(D,S){const p=D.get(S.detail);p&&(p>=0||D.set(S.detail,p+S.timestamp))}let R=[];typeof fe=="function"&&typeof fe.getStats=="function"&&(R=fe.getStats().slice(0).sort((D,S)=>D.timestamp-S.timestamp));for(const D of R)switch(D.type){case 10:E(h,D);break;case 11:case 12:b(h,D);break;case 21:E(A,D);break;case 22:b(A,D);break;case 33:E(P,D);break;case 34:b(P,D);break;case 31:E(m,D);break;case 32:b(m,D);break}let I=0;P.forEach(D=>I+=D);function $(D){const S=[];return D.forEach((p,r)=>S.push([r,p])),S}return{amdLoad:$(h),amdInvoke:$(A),nodeRequire:$(P),nodeEval:$(m),nodeRequireTotal:I}}static toMarkdownTable(h,A){let P="";const m=[];return h.forEach((E,b)=>{m[b]=E.length}),A.forEach(E=>{E.forEach((b,R)=>{typeof b>"u"&&(b=E[R]="-");const I=b.toString().length;m[R]=Math.max(I,m[R])})}),h.forEach((E,b)=>{P+=`| ${E+" ".repeat(m[b]-E.toString().length)} `}),P+=`|
`,h.forEach((E,b)=>{P+=`| ${"-".repeat(m[b])} `}),P+=`|
`,A.forEach(E=>{E.forEach((b,R)=>{typeof b<"u"&&(P+=`| ${b+" ".repeat(m[R]-b.toString().length)} `)}),P+=`|
`}),P}}e.$S=k}),define(Se[65],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function k(P,m){const E=Object.create(null);for(const b of P){const R=m(b);let I=E[R];I||(I=E[R]=[]),I.push(b)}return E}e.$I=k;function F(P,m){const E=[],b=[];for(const R of P)m.has(R)||E.push(R);for(const R of m)P.has(R)||b.push(R);return{removed:E,added:b}}e.$J=F;function h(P,m){const E=[],b=[];for(const[R,I]of P)m.has(R)||E.push(I);for(const[R,I]of m)P.has(R)||b.push(I);return{removed:E,added:b}}e.$K=h;class A{constructor(){this.a=new Map}add(m,E){let b=this.a.get(m);b||(b=new Set,this.a.set(m,b)),b.add(E)}delete(m,E){const b=this.a.get(m);b&&(b.delete(E),b.size===0&&this.a.delete(m))}forEach(m,E){const b=this.a.get(m);b&&b.forEach(E)}get(m){const E=this.a.get(m);return E||new Set}}e.$L=A}),define(Se[66],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.$Ug=e.$Tg=void 0;function k(P){return(m,E,b)=>{let R=null,I=null;if(typeof b.value=="function"?(R="value",I=b.value):typeof b.get=="function"&&(R="get",I=b.get),!I)throw new Error("not supported");b[R]=P(I,E)}}function F(P,m,E){let b=null,R=null;if(typeof E.value=="function"?(b="value",R=E.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(b="get",R=E.get),!R)throw new Error("not supported");const I=`$memoize$${m}`;E[b]=function(...$){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,$)}),this[I]}}e.$Tg=F;function h(P,m,E){return k((b,R)=>{const I=`$debounce$${R}`,$=`$debounce$result$${R}`;return function(...D){this[$]||(this[$]=E?E():void 0),clearTimeout(this[I]),m&&(this[$]=m(this[$],...D),D=[this[$]]),this[I]=setTimeout(()=>{b.apply(this,D),this[$]=E?E():void 0},P)}})}e.$Ug=h;function A(P,m,E){return k((b,R)=>{const I=`$throttle$timer$${R}`,$=`$throttle$result$${R}`,D=`$throttle$lastRun$${R}`,S=`$throttle$pending$${R}`;return function(...p){if(this[$]||(this[$]=E?E():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),m&&(this[$]=m(this[$],...p)),this[S])return;const r=this[D]+P;r<=Date.now()?(this[D]=Date.now(),b.apply(this,[this[$]]),this[$]=E?E():void 0):(this[S]=!0,this[I]=setTimeout(()=>{this[S]=!1,this[D]=Date.now(),b.apply(this,[this[$]]),this[$]=E?E():void 0},r-Date.now()))}})}e.$Vg=A}),define(Se[8],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class k{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?y.isErrorNoTelemetry(o)?new y(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(n=>{n(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.$U=k,e.$V=new k;function F(i){e.$V.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=F;function h(i){if(!i||typeof i!="object")return!1;const o=i;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.$X=h;function A(i){b(i)||e.$V.onUnexpectedError(i)}e.$Y=A;function P(i){b(i)||e.$V.onUnexpectedExternalError(i)}e.$Z=P;function m(i){if(i instanceof Error){const{name:o,message:n}=i,t=i.stacktrace||i.stack;return{$isError:!0,name:o,message:n,stack:t,noTelemetry:y.isErrorNoTelemetry(i)}}return i}e.$1=m;const E="Canceled";function b(i){return i instanceof R?!0:i instanceof Error&&i.name===E&&i.message===E}e.$2=b;class R extends Error{constructor(){super(E),this.name=this.message}}e.$3=R;function I(){const i=new Error(E);return i.name=i.message,i}e.$4=I;function $(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.$5=$;function D(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.$6=D;function S(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.$7=S;function p(i){const o=new Error(`${i} has been disposed`);return o.name="DISPOSED",o}e.$8=p;function r(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.$9=r;class s extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.$0=s;class c extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.$$=c;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=f;class y extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof y)return o;const n=new y;return n.message=o.message,n.stack=o.stack,n}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.$ab=y;class C extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,C.prototype)}}e.$bb=C}),define(Se[19],Ce([1,0,8]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.CompareResult=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.top=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=void 0;function F(X,he=0){return X[X.length-(1+he)]}e.$_e=F;function h(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.$af=h;function A(X,he,K=(oe,_)=>oe===_){if(X===he)return!0;if(!X||!he||X.length!==he.length)return!1;for(let oe=0,_=X.length;oe<_;oe++)if(!K(X[oe],he[oe]))return!1;return!0}e.$bf=A;function P(X,he){const K=X.length-1;he<K&&(X[he]=X[K]),X.pop()}e.$cf=P;function m(X,he,K){return E(X.length,oe=>K(X[oe],he))}e.$df=m;function E(X,he){let K=0,oe=X-1;for(;K<=oe;){const _=(K+oe)/2|0,le=he(_);if(le<0)K=_+1;else if(le>0)oe=_-1;else return _}return-(K+1)}e.$ef=E;function b(X,he){let K=0,oe=X.length;if(oe===0)return 0;for(;K<oe;){const _=Math.floor((K+oe)/2);he(X[_])?oe=_:K=_+1}return K}e.$ff=b;function R(X,he,K){if(X=X|0,X>=he.length)throw new TypeError("invalid index");const oe=he[Math.floor(he.length*Math.random())],_=[],le=[],$e=[];for(const U of he){const G=K(U,oe);G<0?_.push(U):G>0?le.push(U):$e.push(U)}return X<_.length?R(X,_,K):X<_.length+$e.length?$e[0]:R(X-(_.length+$e.length),le,K)}e.$gf=R;function I(X,he){const K=[];let oe;for(const _ of X.slice(0).sort(he))!oe||he(oe[0],_)!==0?(oe=[_],K.push(oe)):oe.push(_);return K}e.$hf=I;function $(X,he,K){const oe=[];function _(U,G,Z){if(G===0&&Z.length===0)return;const ee=oe[oe.length-1];ee&&ee.start+ee.deleteCount===U?(ee.deleteCount+=G,ee.toInsert.push(...Z)):oe.push({start:U,deleteCount:G,toInsert:Z})}let le=0,$e=0;for(;;){if(le===X.length){_(le,0,he.slice($e));break}if($e===he.length){_(le,X.length-le,[]);break}const U=X[le],G=he[$e],Z=K(U,G);Z===0?(le+=1,$e+=1):Z<0?(_(le,1,[]),le+=1):Z>0&&(_(le,0,[G]),$e+=1)}return oe}e.$if=$;function D(X,he,K){const oe=$(X,he,K),_=[],le=[];for(const $e of oe)_.push(...X.slice($e.start,$e.start+$e.deleteCount)),le.push(...$e.toInsert);return{removed:_,added:le}}e.$jf=D;function S(X,he,K){if(K===0)return[];const oe=X.slice(0,K).sort(he);return r(X,he,oe,K,X.length),oe}e.top=S;function p(X,he,K,oe,_){return K===0?Promise.resolve([]):new Promise((le,$e)=>{(async()=>{const U=X.length,G=X.slice(0,K).sort(he);for(let Z=K,ee=Math.min(K+oe,U);Z<U;Z=ee,ee=Math.min(ee+oe,U)){if(Z>K&&await new Promise(be=>setTimeout(be)),_&&_.isCancellationRequested)throw new k.$3;r(X,he,G,Z,ee)}return G})().then(le,$e)})}e.$lf=p;function r(X,he,K,oe,_){for(const le=K.length;oe<_;oe++){const $e=X[oe];if(he($e,K[le-1])<0){K.pop();const U=b(K,G=>he($e,G)<0);K.splice(U,0,$e)}}}function s(X){return X.filter(he=>!!he)}e.$mf=s;function c(X){let he=0;for(let K=0;K<X.length;K++)X[K]&&(X[he]=X[K],he+=1);X.length=he}e.$nf=c;function f(X,he,K){X.splice(K,0,X.splice(he,1)[0])}e.$of=f;function y(X){return!Array.isArray(X)||X.length===0}e.$pf=y;function C(X){return Array.isArray(X)&&X.length>0}e.$qf=C;function i(X,he=K=>K){const K=new Set;return X.filter(oe=>{const _=he(oe);return K.has(_)?!1:(K.add(_),!0)})}e.$rf=i;function o(X){const he=new Set;return K=>{const oe=X(K);return he.has(oe)?!1:(he.add(oe),!0)}}e.$sf=o;function n(X,he){const K=t(X,he);if(K!==-1)return X[K]}e.$tf=n;function t(X,he){for(let K=X.length-1;K>=0;K--){const oe=X[K];if(he(oe))return K}return-1}e.$uf=t;function a(X,he){return X.length>0?X[0]:he}e.$vf=a;function g(X,he){return X.length>0?X[X.length-1]:he}e.$wf=g;function u(X,he,K=(oe,_)=>oe===_){let oe=0;for(let _=0,le=Math.min(X.length,he.length);_<le&&K(X[_],he[_]);_++)oe++;return oe}e.$xf=u;function d(X){return[].concat(...X)}e.$yf=d;function v(X,he){let K=typeof he=="number"?X:0;typeof he=="number"?K=X:(K=0,he=X);const oe=[];if(K<=he)for(let _=K;_<he;_++)oe.push(_);else for(let _=K;_>he;_--)oe.push(_);return oe}e.$zf=v;function l(X,he,K){return X.reduce((oe,_)=>(oe[he(_)]=K?K(_):_,oe),Object.create(null))}e.$Af=l;function w(X,he){return X.push(he),()=>L(X,he)}e.$Bf=w;function L(X,he){const K=X.indexOf(he);if(K>-1)return X.splice(K,1),he}e.$Cf=L;function O(X,he,K){const oe=X.slice(0,he),_=X.slice(he);return oe.concat(K,_)}e.$Df=O;function N(X,he){let K;if(typeof he=="number"){let oe=he;K=()=>{const _=Math.sin(oe++)*179426549;return _-Math.floor(_)}}else K=Math.random;for(let oe=X.length-1;oe>0;oe-=1){const _=Math.floor(K()*(oe+1)),le=X[oe];X[oe]=X[_],X[_]=le}}e.$Ef=N;function T(X,he){const K=X.indexOf(he);K>-1&&(X.splice(K,1),X.unshift(he))}e.$Ff=T;function j(X,he){const K=X.indexOf(he);K>-1&&(X.splice(K,1),X.push(he))}e.$Gf=j;function W(X,he){for(const K of he)X.push(K)}e.$Hf=W;function M(X,he){return Array.isArray(X)?X.map(he):he(X)}e.$If=M;function Y(X){return Array.isArray(X)?X:[X]}e.$Jf=Y;function V(X){return X[Math.floor(Math.random()*X.length)]}e.$Kf=V;function de(X,he){for(const K of X){const oe=he(K);if(oe!==void 0)return oe}}e.$Lf=de;function re(X,he,K){const oe=q(X,he),_=X.length,le=K.length;X.length=_+le;for(let $e=_-1;$e>=oe;$e--)X[$e+le]=X[$e];for(let $e=0;$e<le;$e++)X[$e+oe]=K[$e]}e.$Mf=re;function x(X,he,K,oe){const _=q(X,he),le=X.splice(_,K);return re(X,_,oe),le}e.$Nf=x;function q(X,he){return he<0?Math.max(he+X.length,0):Math.min(he,X.length)}var ne;(function(X){function he(_){return _<0}X.isLessThan=he;function K(_){return _>0}X.isGreaterThan=K;function oe(_){return _===0}X.isNeitherLessOrGreaterThan=oe,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function pe(X,he){return(K,oe)=>he(X(K),X(oe))}e.$Of=pe;function H(...X){return(he,K)=>{for(const oe of X){const _=oe(he,K);if(!ne.isNeitherLessOrGreaterThan(_))return _}return ne.neitherLessOrGreaterThan}}e.$Pf=H;const ue=(X,he)=>X-he;e.$Qf=ue;function ce(X){return(he,K)=>-X(he,K)}e.$Rf=ce;function z(X,he){if(X.length===0)return;let K=X[0];for(let oe=1;oe<X.length;oe++){const _=X[oe];he(_,K)>0&&(K=_)}return K}e.$Sf=z;function ie(X,he){if(X.length===0)return;let K=X[0];for(let oe=1;oe<X.length;oe++){const _=X[oe];he(_,K)>=0&&(K=_)}return K}e.$Tf=ie;function Ee(X,he){return z(X,(K,oe)=>-he(K,oe))}e.$Uf=Ee;class Re{constructor(he){this.f=he,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(he){let K=this.c;for(;K<this.f.length&&he(this.f[K]);)K++;const oe=K===this.c?null:this.f.slice(this.c,K);return this.c=K,oe}takeFromEndWhile(he){let K=this.d;for(;K>=0&&he(this.f[K]);)K--;const oe=K===this.d?null:this.f.slice(K+1,this.d+1);return this.d=K,oe}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const he=this.f[this.c];return this.c++,he}removeLast(){const he=this.f[this.d];return this.d--,he}takeCount(he){const K=this.f.slice(this.c,this.c+he);return this.c+=he,K}}e.$Vf=Re;class ye{static{this.empty=new ye(he=>{})}constructor(he){this.iterate=he}forEach(he){this.iterate(K=>(he(K),!0))}toArray(){const he=[];return this.iterate(K=>(he.push(K),!0)),he}filter(he){return new ye(K=>this.iterate(oe=>he(oe)?K(oe):!0))}map(he){return new ye(K=>this.iterate(oe=>K(he(oe))))}some(he){let K=!1;return this.iterate(oe=>(K=he(oe),!K)),K}findFirst(he){let K;return this.iterate(oe=>he(oe)?(K=oe,!1):!0),K}findLast(he){let K;return this.iterate(oe=>(he(oe)&&(K=oe),!0)),K}findLastMaxBy(he){let K,oe=!0;return this.iterate(_=>((oe||ne.isGreaterThan(he(_,K)))&&(oe=!1,K=_),!0)),K}}e.$Wf=ye}),define(Se[53],Ce([1,0,8]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qc=e.$pc=e.$oc=e.$nc=e.ok=void 0;function F(E,b){if(!E)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=F;function h(E,b="Unreachable"){throw new Error(b)}e.$nc=h;function A(E){if(!E)throw new k.$bb("Assertion Failed")}e.$oc=A;function P(E){if(!E()){debugger;E(),(0,k.$Y)(new k.$bb("Assertion Failed"))}}e.$pc=P;function m(E,b){let R=0;for(;R<E.length-1;){const I=E[R],$=E[R+1];if(!b(I,$))return!1;R++}return!0}e.$qc=m}),define(Se[67],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function k(F){const h=this;let A=!1,P;return function(){return A||(A=!0,P=F.apply(h,arguments)),P}}e.$cb=k}),define(Se[111],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JL=e.$IL=void 0;class k{constructor(h){this.a=h,this.b=0}nextId(){return this.a+ ++this.b}}e.$IL=k,e.$JL=new k("id#")}),define(Se[48],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(F){function h(y){return y&&typeof y=="object"&&typeof y[Symbol.iterator]=="function"}F.is=h;const A=Object.freeze([]);function P(){return A}F.empty=P;function*m(y){yield y}F.single=m;function E(y){return h(y)?y:m(y)}F.wrap=E;function b(y){return y||A}F.from=b;function R(y){return!y||y[Symbol.iterator]().next().done===!0}F.isEmpty=R;function I(y){return y[Symbol.iterator]().next().value}F.first=I;function $(y,C){for(const i of y)if(C(i))return!0;return!1}F.some=$;function D(y,C){for(const i of y)if(C(i))return i}F.find=D;function*S(y,C){for(const i of y)C(i)&&(yield i)}F.filter=S;function*p(y,C){let i=0;for(const o of y)yield C(o,i++)}F.map=p;function*r(...y){for(const C of y)for(const i of C)yield i}F.concat=r;function s(y,C,i){let o=i;for(const n of y)o=C(o,n);return o}F.reduce=s;function*c(y,C,i=y.length){for(C<0&&(C+=y.length),i<0?i+=y.length:i>y.length&&(i=y.length);C<i;C++)yield y[C]}F.slice=c;function f(y,C=Number.POSITIVE_INFINITY){const i=[];if(C===0)return[i,y];const o=y[Symbol.iterator]();for(let n=0;n<C;n++){const t=o.next();if(t.done)return[i,F.empty()];i.push(t.value)}return[i,{[Symbol.iterator](){return o}}]}F.consume=f})(k||(e.Iterable=k={}))}),define(Se[151],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(k||(e.ScanError=k={}));var F;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var h;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(h||(e.ParseErrorCode=h={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function P(i,o=!1){let n=0;const t=i.length;let a="",g=0,u=16,d=0;function v(j){let W=0,M=0;for(;W<j;){const Y=i.charCodeAt(n);if(Y>=48&&Y<=57)M=M*16+Y-48;else if(Y>=65&&Y<=70)M=M*16+Y-65+10;else if(Y>=97&&Y<=102)M=M*16+Y-97+10;else break;n++,W++}return W<j&&(M=-1),M}function l(j){n=j,a="",g=0,u=16,d=0}function w(){const j=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&b(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&b(i.charCodeAt(n)))for(n++;n<i.length&&b(i.charCodeAt(n));)n++;else return d=3,i.substring(j,n);let W=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&b(i.charCodeAt(n))){for(n++;n<i.length&&b(i.charCodeAt(n));)n++;W=n}else d=3;return i.substring(j,W)}function L(){let j="",W=n;for(;;){if(n>=t){j+=i.substring(W,n),d=2;break}const M=i.charCodeAt(n);if(M===34){j+=i.substring(W,n),n++;break}if(M===92){if(j+=i.substring(W,n),n++,n>=t){d=2;break}switch(i.charCodeAt(n++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const V=v(4);V>=0?j+=String.fromCharCode(V):d=4;break}default:d=5}W=n;continue}if(M>=0&&M<=31)if(E(M)){j+=i.substring(W,n),d=2;break}else d=6;n++}return j}function O(){if(a="",d=0,g=n,n>=t)return g=t,u=17;let j=i.charCodeAt(n);if(m(j)){do n++,a+=String.fromCharCode(j),j=i.charCodeAt(n);while(m(j));return u=15}if(E(j))return n++,a+=String.fromCharCode(j),j===13&&i.charCodeAt(n)===10&&(n++,a+=`
`),u=14;switch(j){case 123:return n++,u=1;case 125:return n++,u=2;case 91:return n++,u=3;case 93:return n++,u=4;case 58:return n++,u=6;case 44:return n++,u=5;case 34:return n++,a=L(),u=10;case 47:{const W=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<t&&!E(i.charCodeAt(n));)n++;return a=i.substring(W,n),u=12}if(i.charCodeAt(n+1)===42){n+=2;const M=t-1;let Y=!1;for(;n<M;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,Y=!0;break}n++}return Y||(n++,d=1),a=i.substring(W,n),u=13}return a+=String.fromCharCode(j),n++,u=16}case 45:if(a+=String.fromCharCode(j),n++,n===t||!b(i.charCodeAt(n)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=w(),u=11;default:for(;n<t&&N(j);)n++,j=i.charCodeAt(n);if(g!==n){switch(a=i.substring(g,n),a){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return a+=String.fromCharCode(j),n++,u=16}}function N(j){if(m(j)||E(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let j;do j=O();while(j>=12&&j<=15);return j}return{setPosition:l,getPosition:()=>n,scan:o?T:O,getToken:()=>u,getTokenValue:()=>a,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>d}}e.$vm=P;function m(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function E(i){return i===10||i===13||i===8232||i===8233}function b(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function I(i,o){const n=[],t=new Object;let a;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function d(v,l,w,L){g.value=v,g.offset=l,g.length=w,g.type=L,g.colonOffset=void 0,a=g}try{f(i,{onObjectBegin:(v,l)=>{if(o<=v)throw t;a=void 0,u=o>v,n.push("")},onObjectProperty:(v,l,w)=>{if(o<l||(d(v,l,w,"property"),n[n.length-1]=v,o<=l+w))throw t},onObjectEnd:(v,l)=>{if(o<=v)throw t;a=void 0,n.pop()},onArrayBegin:(v,l)=>{if(o<=v)throw t;a=void 0,n.push(0)},onArrayEnd:(v,l)=>{if(o<=v)throw t;a=void 0,n.pop()},onLiteralValue:(v,l,w)=>{if(o<l||(d(v,l,w,C(v)),o<=l+w))throw t},onSeparator:(v,l,w)=>{if(o<=l)throw t;if(v===":"&&a&&a.type==="property")a.colonOffset=l,u=!1,a=void 0;else if(v===","){const L=n[n.length-1];typeof L=="number"?n[n.length-1]=L+1:(u=!0,n[n.length-1]=""),a=void 0}}})}catch(v){if(v!==t)throw v}return{path:n,previousNode:a,isAtPropertyKey:u,matches:v=>{let l=0;for(let w=0;l<v.length&&w<n.length;w++)if(v[l]===n[w]||v[l]==="*")l++;else if(v[l]!=="**")return!1;return l===v.length}}}e.$wm=I;function $(i,o=[],n=A.DEFAULT){let t=null,a=[];const g=[];function u(v){Array.isArray(a)?a.push(v):t!==null&&(a[t]=v)}return f(i,{onObjectBegin:()=>{const v={};u(v),g.push(a),a=v,t=null},onObjectProperty:v=>{t=v},onObjectEnd:()=>{a=g.pop()},onArrayBegin:()=>{const v=[];u(v),g.push(a),a=v,t=null},onArrayEnd:()=>{a=g.pop()},onLiteralValue:u,onError:(v,l,w)=>{o.push({error:v,offset:l,length:w})}},n),a[0]}e.$xm=$;function D(i,o=[],n=A.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(v){t.type==="property"&&(t.length=v-t.offset,t=t.parent)}function g(v){return t.children.push(v),v}f(i,{onObjectBegin:v=>{t=g({type:"object",offset:v,length:-1,parent:t,children:[]})},onObjectProperty:(v,l,w)=>{t=g({type:"property",offset:l,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:v,offset:l,length:w,parent:t})},onObjectEnd:(v,l)=>{t.length=v+l-t.offset,t=t.parent,a(v+l)},onArrayBegin:(v,l)=>{t=g({type:"array",offset:v,length:-1,parent:t,children:[]})},onArrayEnd:(v,l)=>{t.length=v+l-t.offset,t=t.parent,a(v+l)},onLiteralValue:(v,l,w)=>{g({type:C(v),offset:l,length:w,parent:t,value:v}),a(l+w)},onSeparator:(v,l,w)=>{t.type==="property"&&(v===":"?t.colonOffset=l:v===","&&a(l))},onError:(v,l,w)=>{o.push({error:v,offset:l,length:w})}},n);const d=t.children[0];return d&&delete d.parent,d}e.$ym=D;function S(i,o){if(!i)return;let n=i;for(const t of o)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===t){n=g.children[1],a=!0;break}if(!a)return}else{const a=t;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}e.$zm=S;function p(i){if(!i.parent||!i.parent.children)return[];const o=p(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}e.$Am=p;function r(i){switch(i.type){case"array":return i.children.map(r);case"object":{const o=Object.create(null);for(const n of i.children){const t=n.children[1];t&&(o[n.children[0].value]=r(t))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$Bm=r;function s(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}e.$Cm=s;function c(i,o,n=!1){if(s(i,o,n)){const t=i.children;if(Array.isArray(t))for(let a=0;a<t.length&&t[a].offset<=o;a++){const g=c(t[a],o,n);if(g)return g}return i}}e.$Dm=c;function f(i,o,n=A.DEFAULT){const t=P(i,!1);function a(pe){return pe?()=>pe(t.getTokenOffset(),t.getTokenLength()):()=>!0}function g(pe){return pe?H=>pe(H,t.getTokenOffset(),t.getTokenLength()):()=>!0}const u=a(o.onObjectBegin),d=g(o.onObjectProperty),v=a(o.onObjectEnd),l=a(o.onArrayBegin),w=a(o.onArrayEnd),L=g(o.onLiteralValue),O=g(o.onSeparator),N=a(o.onComment),T=g(o.onError),j=n&&n.disallowComments,W=n&&n.allowTrailingComma;function M(){for(;;){const pe=t.scan();switch(t.getTokenError()){case 4:Y(14);break;case 5:Y(15);break;case 3:Y(13);break;case 1:j||Y(11);break;case 2:Y(12);break;case 6:Y(16);break}switch(pe){case 12:case 13:j?Y(10):N();break;case 16:Y(1);break;case 15:case 14:break;default:return pe}}}function Y(pe,H=[],ue=[]){if(T(pe),H.length+ue.length>0){let ce=t.getToken();for(;ce!==17;){if(H.indexOf(ce)!==-1){M();break}else if(ue.indexOf(ce)!==-1)break;ce=M()}}}function V(pe){const H=t.getTokenValue();return pe?L(H):d(H),M(),!0}function de(){switch(t.getToken()){case 11:{let pe=0;try{pe=JSON.parse(t.getTokenValue()),typeof pe!="number"&&(Y(2),pe=0)}catch{Y(2)}L(pe);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return M(),!0}function re(){return t.getToken()!==10?(Y(3,[],[2,5]),!1):(V(!1),t.getToken()===6?(O(":"),M(),ne()||Y(4,[],[2,5])):Y(5,[],[2,5]),!0)}function x(){u(),M();let pe=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(pe||Y(4,[],[]),O(","),M(),t.getToken()===2&&W)break}else pe&&Y(6,[],[]);re()||Y(4,[],[2,5]),pe=!0}return v(),t.getToken()!==2?Y(7,[2],[]):M(),!0}function q(){l(),M();let pe=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(pe||Y(4,[],[]),O(","),M(),t.getToken()===4&&W)break}else pe&&Y(6,[],[]);ne()||Y(4,[],[4,5]),pe=!0}return w(),t.getToken()!==4?Y(8,[4],[]):M(),!0}function ne(){switch(t.getToken()){case 3:return q();case 1:return x();case 10:return V(!0);default:return de()}}return M(),t.getToken()===17?n.allowEmptyContent?!0:(Y(4,[],[]),!1):ne()?(t.getToken()!==17&&Y(9,[],[]),!0):(Y(4,[],[]),!1)}e.$Em=f;function y(i,o){const n=P(i),t=[];let a,g=0,u;do switch(u=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:g!==u&&t.push(i.substring(g,u)),o!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,o)),g=n.getPosition();break}while(a!==17);return t.join("")}e.$Fm=y;function C(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$Gm=C}),define(Se[54],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class k{constructor(h){this.d=h,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(h){this.c=h}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=k}),define(Se[4],Ce([1,0,67,48]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tb=e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;const h=!1;let A=null;function P(g){A=g}if(e.$db=P,h){const g="__is_disposable_tracked__";P(new class{trackDisposable(u){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[g]||console.log(d)},3e3)}setParent(u,d){if(u&&u!==c.None)try{u[g]=!0}catch{}}markAsDisposed(u){if(u&&u!==c.None)try{u[g]=!0}catch{}}markAsSingleton(u){}})}function m(g){return A?.trackDisposable(g),g}function E(g){A?.markAsDisposed(g)}function b(g,u){A?.setParent(g,u)}function R(g,u){if(A)for(const d of g)A.setParent(d,u)}function I(g){return A?.markAsSingleton(g),g}e.$eb=I;function $(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.$fb=$;function D(g){if(F.Iterable.is(g)){const u=[];for(const d of g)if(d)try{d.dispose()}catch(v){u.push(v)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}e.$gb=D;function S(g){for(const u of g)$(u)&&u.dispose();return[]}e.$hb=S;function p(...g){const u=r(()=>D(g));return R(g,u),u}e.$ib=p;function r(g){const u=m({dispose:(0,k.$cb)(()=>{E(u),g()})});return u}e.$jb=r;class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,m(this)}dispose(){this.g||(E(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{D(this.f)}finally{this.f.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return b(u,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(u),u}}e.$kb=s;class c{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,m(this),b(this.q,this)}dispose(){E(this),this.q.dispose()}B(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(u)}}e.$lb=c;class f{constructor(){this.b=!1,m(this)}get value(){return this.b?void 0:this.a}set value(u){this.b||u===this.a||(this.a?.dispose(),u&&b(u,this),this.a=u)}clear(){this.value=void 0}dispose(){this.b=!0,E(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const u=this.a;return this.a=void 0,u&&b(u,null),u}}e.$mb=f;class y{constructor(u){this.b=u,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$nb=y;class C{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(u){let d=u;return this.unset=()=>d=void 0,this.isset=()=>d!==void 0,this.dispose=()=>{d&&(d(),d=void 0,E(this))},this}}e.$ob=C;class i{constructor(){this.a=new Map}acquire(u,...d){let v=this.a.get(u);v||(v={counter:0,object:this.b(u,...d)},this.a.set(u,v));const{object:l}=v,w=(0,k.$cb)(()=>{--v.counter===0&&(this.c(u,v.object),this.a.delete(u))});return v.counter++,{object:l,dispose:w}}}e.$pb=i;class o{constructor(u){this.a=u}async acquire(u,...d){const v=this.a.acquire(u,...d);try{return{object:await v.object,dispose:()=>v.dispose()}}catch(l){throw v.dispose(),l}}}e.$qb=o;class n{constructor(u){this.object=u}dispose(){}}e.$rb=n;function t(g){const u=new s;try{g(u)}finally{u.dispose()}}e.$sb=t;class a{constructor(){this.a=new Map,this.b=!1,m(this)}dispose(){E(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{D(this.a.values())}finally{this.a.clear()}}has(u){return this.a.has(u)}get(u){return this.a.get(u)}set(u,d,v=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),v||this.a.get(u)?.dispose(),this.a.set(u,d)}deleteAndDispose(u){this.a.get(u)?.dispose(),this.a.delete(u)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$tb=a}),define(Se[68],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lc=void 0;class k{static{this.Undefined=new k(void 0)}constructor(A){this.element=A,this.next=k.Undefined,this.prev=k.Undefined}}class F{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let A=this.a;for(;A!==k.Undefined;){const P=A.next;A.prev=k.Undefined,A.next=k.Undefined,A=P}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,P){const m=new k(A);if(this.a===k.Undefined)this.a=m,this.b=m;else if(P){const b=this.b;this.b=m,m.prev=b,b.next=m}else{const b=this.a;this.a=m,m.next=b,b.prev=m}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(m))}}shift(){if(this.a!==k.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==k.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==k.Undefined&&A.next!==k.Undefined){const P=A.prev;P.next=A.next,A.next.prev=P}else A.prev===k.Undefined&&A.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):A.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):A.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==k.Undefined;)yield A.element,A=A.next}}e.$lc=F}),define(Se[28],Ce([1,0]),function(fe,e){"use strict";var k,F,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.Touch=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;function A(p,r,s){let c=p.get(r);return c===void 0&&(c=s,p.set(r,c)),c}e.$ki=A;function P(p){const r=[];return p.forEach((s,c)=>{r.push(`${c} => ${s}`)}),`Map(${p.size}) {${r.join(", ")}}`}e.$li=P;function m(p){const r=[];return p.forEach(s=>{r.push(s)}),`Set(${p.size}) {${r.join(", ")}}`}e.$mi=m;class E{constructor(r,s){this.uri=r,this.value=s}}class b{static{this.a=r=>r.toString()}constructor(r,s){this[k]="ResourceMap",r instanceof b?(this.b=new Map(r.b),this.c=s??b.a):(this.b=new Map,this.c=r??b.a)}set(r,s){return this.b.set(this.c(r),new E(r,s)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[c,f]of this.b)r(f.value,f.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}e.$ni=b;class R{constructor(r,s){this[F]="ResourceSet",!r||typeof r=="function"?this.a=new b(r):(this.a=new b(s),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,s){this.a.forEach((c,f)=>r.call(s,f,f,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$oi=R;var I;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(I||(e.Touch=I={}));class ${constructor(){this[h]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,s=0){const c=this.a.get(r);if(c)return s!==0&&this.j(c,s),c.value}set(r,s,c=0){let f=this.a.get(r);if(f)f.value=s,c!==0&&this.j(f,c);else{switch(f={key:r,value:s,next:void 0,previous:void 0},c){case 0:this.h(f);break;case 1:this.g(f);break;case 2:this.h(f);break;default:this.h(f);break}this.a.set(r,f),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this.a.get(r);if(s)return this.a.delete(r),this.i(s),this.d--,s.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,s){const c=this.e;let f=this.b;for(;f;){if(s?r.bind(s)(f.value,f.key,this):r(f.value,f.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,s=this.e;let c=this.b;const f={[Symbol.iterator](){return f},next(){if(r.e!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const y={value:c.key,done:!1};return c=c.next,y}else return{value:void 0,done:!0}}};return f}values(){const r=this,s=this.e;let c=this.b;const f={[Symbol.iterator](){return f},next(){if(r.e!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const y={value:c.value,done:!1};return c=c.next,y}else return{value:void 0,done:!0}}};return f}entries(){const r=this,s=this.e;let c=this.b;const f={[Symbol.iterator](){return f},next(){if(r.e!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const y={value:[c.key,c.value],done:!1};return c=c.next,y}else return{value:void 0,done:!0}}};return f}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this.b,c=this.size;for(;s&&c>r;)this.a.delete(s.key),s=s.next,c--;this.b=s,this.d=c,s&&(s.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const s=r.next,c=r.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}r.next=void 0,r.previous=void 0,this.e++}j(r,s){if(!this.b||!this.c)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this.b)return;const c=r.next,f=r.previous;r===this.c?(f.next=void 0,this.c=f):(c.previous=f,f.next=c),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(s===2){if(r===this.c)return;const c=r.next,f=r.previous;r===this.b?(c.previous=void 0,this.b=c):(c.previous=f,f.next=c),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((s,c)=>{r.push([c,s])}),r}fromJSON(r){this.clear();for(const[s,c]of r)this.set(s,c)}}e.$pi=$;class D extends ${constructor(r,s=1){super(),this.k=r,this.l=Math.min(Math.max(0,s),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$qi=D;class S{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let s=this.a.get(r)||0;return s===0?!1:(s--,s===0?this.a.delete(r):this.a.set(r,s),!0)}has(r){return this.a.has(r)}}e.$ri=S}),function(fe,e){typeof define=="function"&&define.amd?define(Se[152],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(fe=typeof globalThis<"u"?globalThis:fe||self,e(fe.marked={}))}(this,function(fe){"use strict";function e(ye,X){for(var he=0;he<X.length;he++){var K=X[he];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(ye,K.key,K)}}function k(ye,X,he){return X&&e(ye.prototype,X),he&&e(ye,he),Object.defineProperty(ye,"prototype",{writable:!1}),ye}function F(ye,X){if(ye){if(typeof ye=="string")return h(ye,X);var he=Object.prototype.toString.call(ye).slice(8,-1);if(he==="Object"&&ye.constructor&&(he=ye.constructor.name),he==="Map"||he==="Set")return Array.from(ye);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return h(ye,X)}}function h(ye,X){(X==null||X>ye.length)&&(X=ye.length);for(var he=0,K=new Array(X);he<X;he++)K[he]=ye[he];return K}function A(ye,X){var he=typeof Symbol<"u"&&ye[Symbol.iterator]||ye["@@iterator"];if(he)return(he=he.call(ye)).next.bind(he);if(Array.isArray(ye)||(he=F(ye))||X&&ye&&typeof ye.length=="number"){he&&(ye=he);var K=0;return function(){return K>=ye.length?{done:!0}:{done:!1,value:ye[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function P(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}fe.defaults=P();function m(ye){fe.defaults=ye}var E=/[&<>"']/,b=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},D=function(X){return $[X]};function S(ye,X){if(X){if(E.test(ye))return ye.replace(b,D)}else if(R.test(ye))return ye.replace(I,D);return ye}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(ye){return ye.replace(p,function(X,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var s=/(^|[^\[])\^/g;function c(ye,X){ye=typeof ye=="string"?ye:ye.source,X=X||"";var he={replace:function(oe,_){return _=_.source||_,_=_.replace(s,"$1"),ye=ye.replace(oe,_),he},getRegex:function(){return new RegExp(ye,X)}};return he}var f=/[^\w:]/g,y=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function C(ye,X,he){if(ye){var K;try{K=decodeURIComponent(r(he)).replace(f,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}X&&!y.test(he)&&(he=a(X,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var i={},o=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ye,X){i[" "+ye]||(o.test(ye)?i[" "+ye]=ye+"/":i[" "+ye]=v(ye,"/",!0)),ye=i[" "+ye];var he=ye.indexOf(":")===-1;return X.substring(0,2)==="//"?he?X:ye.replace(n,"$1")+X:X.charAt(0)==="/"?he?X:ye.replace(t,"$1")+X:ye+X}var g={exec:function(){}};function u(ye){for(var X=1,he,K;X<arguments.length;X++){he=arguments[X];for(K in he)Object.prototype.hasOwnProperty.call(he,K)&&(ye[K]=he[K])}return ye}function d(ye,X){var he=ye.replace(/\|/g,function(_,le,$e){for(var U=!1,G=le;--G>=0&&$e[G]==="\\";)U=!U;return U?"|":" |"}),K=he.split(/ \|/),oe=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>X)K.splice(X);else for(;K.length<X;)K.push("");for(;oe<K.length;oe++)K[oe]=K[oe].trim().replace(/\\\|/g,"|");return K}function v(ye,X,he){var K=ye.length;if(K===0)return"";for(var oe=0;oe<K;){var _=ye.charAt(K-oe-1);if(_===X&&!he)oe++;else if(_!==X&&he)oe++;else break}return ye.slice(0,K-oe)}function l(ye,X){if(ye.indexOf(X[1])===-1)return-1;for(var he=ye.length,K=0,oe=0;oe<he;oe++)if(ye[oe]==="\\")oe++;else if(ye[oe]===X[0])K++;else if(ye[oe]===X[1]&&(K--,K<0))return oe;return-1}function w(ye){ye&&ye.sanitize&&!ye.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(ye,X){if(X<1)return"";for(var he="";X>1;)X&1&&(he+=ye),X>>=1,ye+=ye;return he+ye}function O(ye,X,he,K){var oe=X.href,_=X.title?S(X.title):null,le=ye[1].replace(/\\([\[\]])/g,"$1");if(ye[0].charAt(0)!=="!"){K.state.inLink=!0;var $e={type:"link",raw:he,href:oe,title:_,text:le,tokens:K.inlineTokens(le)};return K.state.inLink=!1,$e}return{type:"image",raw:he,href:oe,title:_,text:S(le)}}function N(ye,X){var he=ye.match(/^(\s+)(?:```)/);if(he===null)return X;var K=he[1];return X.split(`
`).map(function(oe){var _=oe.match(/^\s+/);if(_===null)return oe;var le=_[0];return le.length>=K.length?oe.slice(K.length):oe}).join(`
`)}var T=function(){function ye(he){this.options=he||fe.defaults}var X=ye.prototype;return X.space=function(K){var oe=this.rules.block.newline.exec(K);if(oe&&oe[0].length>0)return{type:"space",raw:oe[0]}},X.code=function(K){var oe=this.rules.block.code.exec(K);if(oe){var _=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?_:v(_,`
`)}}},X.fences=function(K){var oe=this.rules.block.fences.exec(K);if(oe){var _=oe[0],le=N(_,oe[3]||"");return{type:"code",raw:_,lang:oe[2]?oe[2].trim():oe[2],text:le}}},X.heading=function(K){var oe=this.rules.block.heading.exec(K);if(oe){var _=oe[2].trim();if(/#$/.test(_)){var le=v(_,"#");(this.options.pedantic||!le||/ $/.test(le))&&(_=le.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:_,tokens:this.lexer.inline(_)}}},X.hr=function(K){var oe=this.rules.block.hr.exec(K);if(oe)return{type:"hr",raw:oe[0]}},X.blockquote=function(K){var oe=this.rules.block.blockquote.exec(K);if(oe){var _=oe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(_,[]),text:_}}},X.list=function(K){var oe=this.rules.block.list.exec(K);if(oe){var _,le,$e,U,G,Z,ee,be,se,we,Ie,je,Ve=oe[1].trim(),_e=Ve.length>1,Ge={type:"list",raw:"",ordered:_e,start:_e?+Ve.slice(0,-1):"",loose:!1,items:[]};Ve=_e?"\\d{1,9}\\"+Ve.slice(-1):"\\"+Ve,this.options.pedantic&&(Ve=_e?Ve:"[*+-]");for(var et=new RegExp("^( {0,3}"+Ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(je=!1,!(!(oe=et.exec(K))||this.rules.block.hr.test(K)));){if(_=oe[0],K=K.substring(_.length),be=oe[2].split(`
`,1)[0],se=K.split(`
`,1)[0],this.options.pedantic?(U=2,Ie=be.trimLeft()):(U=oe[2].search(/[^ ]/),U=U>4?1:U,Ie=be.slice(U),U+=oe[1].length),Z=!1,!be&&/^ *$/.test(se)&&(_+=se+`
`,K=K.substring(se.length+1),je=!0),!je)for(var Qe=new RegExp("^ {0,"+Math.min(3,U-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,U-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,U-1)+"}(?:```|~~~)"),Pe=new RegExp("^ {0,"+Math.min(3,U-1)+"}#");K&&(we=K.split(`
`,1)[0],be=we,this.options.pedantic&&(be=be.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(be)||Pe.test(be)||Qe.test(be)||st.test(K)));){if(be.search(/[^ ]/)>=U||!be.trim())Ie+=`
`+be.slice(U);else if(!Z)Ie+=`
`+be;else break;!Z&&!be.trim()&&(Z=!0),_+=we+`
`,K=K.substring(we.length+1)}Ge.loose||(ee?Ge.loose=!0:/\n *\n *$/.test(_)&&(ee=!0)),this.options.gfm&&(le=/^\[[ xX]\] /.exec(Ie),le&&($e=le[0]!=="[ ] ",Ie=Ie.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:_,task:!!le,checked:$e,loose:!1,text:Ie}),Ge.raw+=_}Ge.items[Ge.items.length-1].raw=_.trimRight(),Ge.items[Ge.items.length-1].text=Ie.trimRight(),Ge.raw=Ge.raw.trimRight();var ke=Ge.items.length;for(G=0;G<ke;G++){this.lexer.state.top=!1,Ge.items[G].tokens=this.lexer.blockTokens(Ge.items[G].text,[]);var Be=Ge.items[G].tokens.filter(function(Q){return Q.type==="space"}),te=Be.every(function(Q){for(var ve=Q.raw.split(""),Ue=0,Ne=A(ve),Ye;!(Ye=Ne()).done;){var xe=Ye.value;if(xe===`
`&&(Ue+=1),Ue>1)return!0}return!1});!Ge.loose&&Be.length&&te&&(Ge.loose=!0,Ge.items[G].loose=!0)}return Ge}},X.html=function(K){var oe=this.rules.block.html.exec(K);if(oe){var _={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};if(this.options.sanitize){var le=this.options.sanitizer?this.options.sanitizer(oe[0]):S(oe[0]);_.type="paragraph",_.text=le,_.tokens=this.lexer.inline(le)}return _}},X.def=function(K){var oe=this.rules.block.def.exec(K);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var _=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:_,raw:oe[0],href:oe[2],title:oe[3]}}},X.table=function(K){var oe=this.rules.block.table.exec(K);if(oe){var _={type:"table",header:d(oe[1]).map(function(ee){return{text:ee}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]&&oe[3].trim()?oe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(_.header.length===_.align.length){_.raw=oe[0];var le=_.align.length,$e,U,G,Z;for($e=0;$e<le;$e++)/^ *-+: *$/.test(_.align[$e])?_.align[$e]="right":/^ *:-+: *$/.test(_.align[$e])?_.align[$e]="center":/^ *:-+ *$/.test(_.align[$e])?_.align[$e]="left":_.align[$e]=null;for(le=_.rows.length,$e=0;$e<le;$e++)_.rows[$e]=d(_.rows[$e],_.header.length).map(function(ee){return{text:ee}});for(le=_.header.length,U=0;U<le;U++)_.header[U].tokens=this.lexer.inline(_.header[U].text);for(le=_.rows.length,U=0;U<le;U++)for(Z=_.rows[U],G=0;G<Z.length;G++)Z[G].tokens=this.lexer.inline(Z[G].text);return _}}},X.lheading=function(K){var oe=this.rules.block.lheading.exec(K);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:this.lexer.inline(oe[1])}},X.paragraph=function(K){var oe=this.rules.block.paragraph.exec(K);if(oe){var _=oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1];return{type:"paragraph",raw:oe[0],text:_,tokens:this.lexer.inline(_)}}},X.text=function(K){var oe=this.rules.block.text.exec(K);if(oe)return{type:"text",raw:oe[0],text:oe[0],tokens:this.lexer.inline(oe[0])}},X.escape=function(K){var oe=this.rules.inline.escape.exec(K);if(oe)return{type:"escape",raw:oe[0],text:S(oe[1])}},X.tag=function(K){var oe=this.rules.inline.tag.exec(K);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):S(oe[0]):oe[0]}},X.link=function(K){var oe=this.rules.inline.link.exec(K);if(oe){var _=oe[2].trim();if(!this.options.pedantic&&/^</.test(_)){if(!/>$/.test(_))return;var le=v(_.slice(0,-1),"\\");if((_.length-le.length)%2===0)return}else{var $e=l(oe[2],"()");if($e>-1){var U=oe[0].indexOf("!")===0?5:4,G=U+oe[1].length+$e;oe[2]=oe[2].substring(0,$e),oe[0]=oe[0].substring(0,G).trim(),oe[3]=""}}var Z=oe[2],ee="";if(this.options.pedantic){var be=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Z);be&&(Z=be[1],ee=be[3])}else ee=oe[3]?oe[3].slice(1,-1):"";return Z=Z.trim(),/^</.test(Z)&&(this.options.pedantic&&!/>$/.test(_)?Z=Z.slice(1):Z=Z.slice(1,-1)),O(oe,{href:Z&&Z.replace(this.rules.inline._escapes,"$1"),title:ee&&ee.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},X.reflink=function(K,oe){var _;if((_=this.rules.inline.reflink.exec(K))||(_=this.rules.inline.nolink.exec(K))){var le=(_[2]||_[1]).replace(/\s+/g," ");if(le=oe[le.toLowerCase()],!le||!le.href){var $e=_[0].charAt(0);return{type:"text",raw:$e,text:$e}}return O(_,le,_[0],this.lexer)}},X.emStrong=function(K,oe,_){_===void 0&&(_="");var le=this.rules.inline.emStrong.lDelim.exec(K);if(le&&!(le[3]&&_.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $e=le[1]||le[2]||"";if(!$e||$e&&(_===""||this.rules.inline.punctuation.exec(_))){var U=le[0].length-1,G,Z,ee=U,be=0,se=le[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(se.lastIndex=0,oe=oe.slice(-1*K.length+U);(le=se.exec(oe))!=null;)if(G=le[1]||le[2]||le[3]||le[4]||le[5]||le[6],!!G){if(Z=G.length,le[3]||le[4]){ee+=Z;continue}else if((le[5]||le[6])&&U%3&&!((U+Z)%3)){be+=Z;continue}if(ee-=Z,!(ee>0)){if(Z=Math.min(Z,Z+ee+be),Math.min(U,Z)%2){var we=K.slice(1,U+le.index+Z);return{type:"em",raw:K.slice(0,U+le.index+Z+1),text:we,tokens:this.lexer.inlineTokens(we)}}var Ie=K.slice(2,U+le.index+Z-1);return{type:"strong",raw:K.slice(0,U+le.index+Z+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}}}}},X.codespan=function(K){var oe=this.rules.inline.code.exec(K);if(oe){var _=oe[2].replace(/\n/g," "),le=/[^ ]/.test(_),$e=/^ /.test(_)&&/ $/.test(_);return le&&$e&&(_=_.substring(1,_.length-1)),_=S(_,!0),{type:"codespan",raw:oe[0],text:_}}},X.br=function(K){var oe=this.rules.inline.br.exec(K);if(oe)return{type:"br",raw:oe[0]}},X.del=function(K){var oe=this.rules.inline.del.exec(K);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2])}},X.autolink=function(K,oe){var _=this.rules.inline.autolink.exec(K);if(_){var le,$e;return _[2]==="@"?(le=S(this.options.mangle?oe(_[1]):_[1]),$e="mailto:"+le):(le=S(_[1]),$e=le),{type:"link",raw:_[0],text:le,href:$e,tokens:[{type:"text",raw:le,text:le}]}}},X.url=function(K,oe){var _;if(_=this.rules.inline.url.exec(K)){var le,$e;if(_[2]==="@")le=S(this.options.mangle?oe(_[0]):_[0]),$e="mailto:"+le;else{var U;do U=_[0],_[0]=this.rules.inline._backpedal.exec(_[0])[0];while(U!==_[0]);le=S(_[0]),_[1]==="www."?$e="http://"+le:$e=le}return{type:"link",raw:_[0],text:le,href:$e,tokens:[{type:"text",raw:le,text:le}]}}},X.inlineText=function(K,oe){var _=this.rules.inline.text.exec(K);if(_){var le;return this.lexer.state.inRawBlock?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(_[0]):S(_[0]):_[0]:le=S(this.options.smartypants?oe(_[0]):_[0]),{type:"text",raw:_[0],text:le}}},ye}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=c(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=c(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=c(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=c(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=c(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=c(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=u({},j),j.gfm=u({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=c(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=c(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=u({},j.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:c(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=c(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=c(j._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=c(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=c(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=c(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=c(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=c(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=c(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=c(W.reflink).replace("label",W._label).replace("ref",j._label).getRegex(),W.nolink=c(W.nolink).replace("ref",j._label).getRegex(),W.reflinkSearch=c(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=u({},W),W.pedantic=u({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=u({},W.normal,{escape:c(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),W.gfm.url=c(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=u({},W.gfm,{br:c(W.br).replace("{2,}","*").getRegex(),text:c(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(ye){return ye.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(ye){var X="",he,K,oe=ye.length;for(he=0;he<oe;he++)K=ye.charCodeAt(he),Math.random()>.5&&(K="x"+K.toString(16)),X+="&#"+K+";";return X}var V=function(){function ye(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||fe.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:j.normal,inline:W.normal};this.options.pedantic?(K.block=j.pedantic,K.inline=W.pedantic):this.options.gfm&&(K.block=j.gfm,this.options.breaks?K.inline=W.breaks:K.inline=W.gfm),this.tokenizer.rules=K}ye.lex=function(K,oe){var _=new ye(oe);return _.lex(K)},ye.lexInline=function(K,oe){var _=new ye(oe);return _.inlineTokens(K)};var X=ye.prototype;return X.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},X.blockTokens=function(K,oe){var _=this;oe===void 0&&(oe=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(ee,be,se){return be+"    ".repeat(se.length)});for(var le,$e,U,G;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ee){return(le=ee.call({lexer:_},K,oe))?(K=K.substring(le.raw.length),oe.push(le),!0):!1}))){if(le=this.tokenizer.space(K)){K=K.substring(le.raw.length),le.raw.length===1&&oe.length>0?oe[oe.length-1].raw+=`
`:oe.push(le);continue}if(le=this.tokenizer.code(K)){K=K.substring(le.raw.length),$e=oe[oe.length-1],$e&&($e.type==="paragraph"||$e.type==="text")?($e.raw+=`
`+le.raw,$e.text+=`
`+le.text,this.inlineQueue[this.inlineQueue.length-1].src=$e.text):oe.push(le);continue}if(le=this.tokenizer.fences(K)){K=K.substring(le.raw.length),oe.push(le);continue}if(le=this.tokenizer.heading(K)){K=K.substring(le.raw.length),oe.push(le);continue}if(le=this.tokenizer.hr(K)){K=K.substring(le.raw.length),oe.push(le);continue}if(le=this.tokenizer.blockquote(K)){K=K.substring(le.raw.length),oe.push(le);continue}if(le=this.tokenizer.list(K)){K=K.substring(le.raw.length),oe.push(le);continue}if(le=this.tokenizer.html(K)){K=K.substring(le.raw.length),oe.push(le);continue}if(le=this.tokenizer.def(K)){K=K.substring(le.raw.length),$e=oe[oe.length-1],$e&&($e.type==="paragraph"||$e.type==="text")?($e.raw+=`
`+le.raw,$e.text+=`
`+le.raw,this.inlineQueue[this.inlineQueue.length-1].src=$e.text):this.tokens.links[le.tag]||(this.tokens.links[le.tag]={href:le.href,title:le.title});continue}if(le=this.tokenizer.table(K)){K=K.substring(le.raw.length),oe.push(le);continue}if(le=this.tokenizer.lheading(K)){K=K.substring(le.raw.length),oe.push(le);continue}if(U=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var ee=1/0,be=K.slice(1),se=void 0;_.options.extensions.startBlock.forEach(function(we){se=we.call({lexer:this},be),typeof se=="number"&&se>=0&&(ee=Math.min(ee,se))}),ee<1/0&&ee>=0&&(U=K.substring(0,ee+1))}(),this.state.top&&(le=this.tokenizer.paragraph(U))){$e=oe[oe.length-1],G&&$e.type==="paragraph"?($e.raw+=`
`+le.raw,$e.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$e.text):oe.push(le),G=U.length!==K.length,K=K.substring(le.raw.length);continue}if(le=this.tokenizer.text(K)){K=K.substring(le.raw.length),$e=oe[oe.length-1],$e&&$e.type==="text"?($e.raw+=`
`+le.raw,$e.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$e.text):oe.push(le);continue}if(K){var Z="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return this.state.top=!0,oe},X.inline=function(K,oe){return oe===void 0&&(oe=[]),this.inlineQueue.push({src:K,tokens:oe}),oe},X.inlineTokens=function(K,oe){var _=this;oe===void 0&&(oe=[]);var le,$e,U,G=K,Z,ee,be;if(this.tokens.links){var se=Object.keys(this.tokens.links);if(se.length>0)for(;(Z=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)se.includes(Z[0].slice(Z[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,Z.index)+"["+L("a",Z[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Z=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,Z.index)+"["+L("a",Z[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Z=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,Z.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(ee||(be=""),ee=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ie){return(le=Ie.call({lexer:_},K,oe))?(K=K.substring(le.raw.length),oe.push(le),!0):!1}))){if(le=this.tokenizer.escape(K)){K=K.substring(le.raw.length),oe.push(le);continue}if(le=this.tokenizer.tag(K)){K=K.substring(le.raw.length),$e=oe[oe.length-1],$e&&le.type==="text"&&$e.type==="text"?($e.raw+=le.raw,$e.text+=le.text):oe.push(le);continue}if(le=this.tokenizer.link(K)){K=K.substring(le.raw.length),oe.push(le);continue}if(le=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(le.raw.length),$e=oe[oe.length-1],$e&&le.type==="text"&&$e.type==="text"?($e.raw+=le.raw,$e.text+=le.text):oe.push(le);continue}if(le=this.tokenizer.emStrong(K,G,be)){K=K.substring(le.raw.length),oe.push(le);continue}if(le=this.tokenizer.codespan(K)){K=K.substring(le.raw.length),oe.push(le);continue}if(le=this.tokenizer.br(K)){K=K.substring(le.raw.length),oe.push(le);continue}if(le=this.tokenizer.del(K)){K=K.substring(le.raw.length),oe.push(le);continue}if(le=this.tokenizer.autolink(K,Y)){K=K.substring(le.raw.length),oe.push(le);continue}if(!this.state.inLink&&(le=this.tokenizer.url(K,Y))){K=K.substring(le.raw.length),oe.push(le);continue}if(U=K,this.options.extensions&&this.options.extensions.startInline&&function(){var Ie=1/0,je=K.slice(1),Ve=void 0;_.options.extensions.startInline.forEach(function(_e){Ve=_e.call({lexer:this},je),typeof Ve=="number"&&Ve>=0&&(Ie=Math.min(Ie,Ve))}),Ie<1/0&&Ie>=0&&(U=K.substring(0,Ie+1))}(),le=this.tokenizer.inlineText(U,M)){K=K.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(be=le.raw.slice(-1)),ee=!0,$e=oe[oe.length-1],$e&&$e.type==="text"?($e.raw+=le.raw,$e.text+=le.text):oe.push(le);continue}if(K){var we="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return oe},k(ye,null,[{key:"rules",get:function(){return{block:j,inline:W}}}]),ye}(),de=function(){function ye(he){this.options=he||fe.defaults}var X=ye.prototype;return X.code=function(K,oe,_){var le=(oe||"").match(/\S*/)[0];if(this.options.highlight){var $e=this.options.highlight(K,le);$e!=null&&$e!==K&&(_=!0,K=$e)}return K=K.replace(/\n$/,"")+`
`,le?'<pre><code class="'+this.options.langPrefix+S(le,!0)+'">'+(_?K:S(K,!0))+`</code></pre>
`:"<pre><code>"+(_?K:S(K,!0))+`</code></pre>
`},X.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},X.html=function(K){return K},X.heading=function(K,oe,_,le){if(this.options.headerIds){var $e=this.options.headerPrefix+le.slug(_);return"<h"+oe+' id="'+$e+'">'+K+"</h"+oe+`>
`}return"<h"+oe+">"+K+"</h"+oe+`>
`},X.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},X.list=function(K,oe,_){var le=oe?"ol":"ul",$e=oe&&_!==1?' start="'+_+'"':"";return"<"+le+$e+`>
`+K+"</"+le+`>
`},X.listitem=function(K){return"<li>"+K+`</li>
`},X.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},X.paragraph=function(K){return"<p>"+K+`</p>
`},X.table=function(K,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+oe+`</table>
`},X.tablerow=function(K){return`<tr>
`+K+`</tr>
`},X.tablecell=function(K,oe){var _=oe.header?"th":"td",le=oe.align?"<"+_+' align="'+oe.align+'">':"<"+_+">";return le+K+("</"+_+`>
`)},X.strong=function(K){return"<strong>"+K+"</strong>"},X.em=function(K){return"<em>"+K+"</em>"},X.codespan=function(K){return"<code>"+K+"</code>"},X.br=function(){return this.options.xhtml?"<br/>":"<br>"},X.del=function(K){return"<del>"+K+"</del>"},X.link=function(K,oe,_){if(K=C(this.options.sanitize,this.options.baseUrl,K),K===null)return _;var le='<a href="'+S(K)+'"';return oe&&(le+=' title="'+oe+'"'),le+=">"+_+"</a>",le},X.image=function(K,oe,_){if(K=C(this.options.sanitize,this.options.baseUrl,K),K===null)return _;var le='<img src="'+K+'" alt="'+_+'"';return oe&&(le+=' title="'+oe+'"'),le+=this.options.xhtml?"/>":">",le},X.text=function(K){return K},ye}(),re=function(){function ye(){}var X=ye.prototype;return X.strong=function(K){return K},X.em=function(K){return K},X.codespan=function(K){return K},X.del=function(K){return K},X.html=function(K){return K},X.text=function(K){return K},X.link=function(K,oe,_){return""+_},X.image=function(K,oe,_){return""+_},X.br=function(){return""},ye}(),x=function(){function ye(){this.seen={}}var X=ye.prototype;return X.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},X.getNextSafeSlug=function(K,oe){var _=K,le=0;if(this.seen.hasOwnProperty(_)){le=this.seen[K];do le++,_=K+"-"+le;while(this.seen.hasOwnProperty(_))}return oe||(this.seen[K]=le,this.seen[_]=0),_},X.slug=function(K,oe){oe===void 0&&(oe={});var _=this.serialize(K);return this.getNextSafeSlug(_,oe.dryrun)},ye}(),q=function(){function ye(he){this.options=he||fe.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new re,this.slugger=new x}ye.parse=function(K,oe){var _=new ye(oe);return _.parse(K)},ye.parseInline=function(K,oe){var _=new ye(oe);return _.parseInline(K)};var X=ye.prototype;return X.parse=function(K,oe){oe===void 0&&(oe=!0);var _="",le,$e,U,G,Z,ee,be,se,we,Ie,je,Ve,_e,Ge,et,Qe,st,tt,Pe,ke=K.length;for(le=0;le<ke;le++){if(Ie=K[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(Pe=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),Pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ie.type))){_+=Pe||"";continue}switch(Ie.type){case"space":continue;case"hr":{_+=this.renderer.hr();continue}case"heading":{_+=this.renderer.heading(this.parseInline(Ie.tokens),Ie.depth,r(this.parseInline(Ie.tokens,this.textRenderer)),this.slugger);continue}case"code":{_+=this.renderer.code(Ie.text,Ie.lang,Ie.escaped);continue}case"table":{for(se="",be="",G=Ie.header.length,$e=0;$e<G;$e++)be+=this.renderer.tablecell(this.parseInline(Ie.header[$e].tokens),{header:!0,align:Ie.align[$e]});for(se+=this.renderer.tablerow(be),we="",G=Ie.rows.length,$e=0;$e<G;$e++){for(ee=Ie.rows[$e],be="",Z=ee.length,U=0;U<Z;U++)be+=this.renderer.tablecell(this.parseInline(ee[U].tokens),{header:!1,align:Ie.align[U]});we+=this.renderer.tablerow(be)}_+=this.renderer.table(se,we);continue}case"blockquote":{we=this.parse(Ie.tokens),_+=this.renderer.blockquote(we);continue}case"list":{for(je=Ie.ordered,Ve=Ie.start,_e=Ie.loose,G=Ie.items.length,we="",$e=0;$e<G;$e++)et=Ie.items[$e],Qe=et.checked,st=et.task,Ge="",et.task&&(tt=this.renderer.checkbox(Qe),_e?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=tt+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=tt+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:tt}):Ge+=tt),Ge+=this.parse(et.tokens,_e),we+=this.renderer.listitem(Ge,st,Qe);_+=this.renderer.list(we,je,Ve);continue}case"html":{_+=this.renderer.html(Ie.text);continue}case"paragraph":{_+=this.renderer.paragraph(this.parseInline(Ie.tokens));continue}case"text":{for(we=Ie.tokens?this.parseInline(Ie.tokens):Ie.text;le+1<ke&&K[le+1].type==="text";)Ie=K[++le],we+=`
`+(Ie.tokens?this.parseInline(Ie.tokens):Ie.text);_+=oe?this.renderer.paragraph(we):we;continue}default:{var Be='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return _},X.parseInline=function(K,oe){oe=oe||this.renderer;var _="",le,$e,U,G=K.length;for(le=0;le<G;le++){if($e=K[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$e.type]&&(U=this.options.extensions.renderers[$e.type].call({parser:this},$e),U!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($e.type))){_+=U||"";continue}switch($e.type){case"escape":{_+=oe.text($e.text);break}case"html":{_+=oe.html($e.text);break}case"link":{_+=oe.link($e.href,$e.title,this.parseInline($e.tokens,oe));break}case"image":{_+=oe.image($e.href,$e.title,$e.text);break}case"strong":{_+=oe.strong(this.parseInline($e.tokens,oe));break}case"em":{_+=oe.em(this.parseInline($e.tokens,oe));break}case"codespan":{_+=oe.codespan($e.text);break}case"br":{_+=oe.br();break}case"del":{_+=oe.del(this.parseInline($e.tokens,oe));break}case"text":{_+=oe.text($e.text);break}default:{var Z='Token with "'+$e.type+'" type was not found.';if(this.options.silent){console.error(Z);return}else throw new Error(Z)}}}return _},ye}();function ne(ye,X,he){if(typeof ye>"u"||ye===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");if(typeof X=="function"&&(he=X,X=null),X=u({},ne.defaults,X||{}),w(X),he){var K=X.highlight,oe;try{oe=V.lex(ye,X)}catch(G){return he(G)}var _=function(Z){var ee;if(!Z)try{X.walkTokens&&ne.walkTokens(oe,X.walkTokens),ee=q.parse(oe,X)}catch(be){Z=be}return X.highlight=K,Z?he(Z):he(null,ee)};if(!K||K.length<3||(delete X.highlight,!oe.length))return _();var le=0;ne.walkTokens(oe,function(G){G.type==="code"&&(le++,setTimeout(function(){K(G.text,G.lang,function(Z,ee){if(Z)return _(Z);ee!=null&&ee!==G.text&&(G.text=ee,G.escaped=!0),le--,le===0&&_()})},0))}),le===0&&_();return}function $e(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,X.silent)return"<p>An error occurred:</p><pre>"+S(G.message+"",!0)+"</pre>";throw G}try{var U=V.lex(ye,X);if(X.walkTokens){if(X.async)return Promise.all(ne.walkTokens(U,X.walkTokens)).then(function(){return q.parse(U,X)}).catch($e);ne.walkTokens(U,X.walkTokens)}return q.parse(U,X)}catch(G){$e(G)}}ne.options=ne.setOptions=function(ye){return u(ne.defaults,ye),m(ne.defaults),ne},ne.getDefaults=P,ne.defaults=fe.defaults,ne.use=function(){for(var ye=arguments.length,X=new Array(ye),he=0;he<ye;he++)X[he]=arguments[he];var K=u.apply(void 0,[{}].concat(X)),oe=ne.defaults.extensions||{renderers:{},childTokens:{}},_;X.forEach(function(le){if(le.extensions&&(_=!0,le.extensions.forEach(function(U){if(!U.name)throw new Error("extension name required");if(U.renderer){var G=oe.renderers?oe.renderers[U.name]:null;G?oe.renderers[U.name]=function(){for(var Z=arguments.length,ee=new Array(Z),be=0;be<Z;be++)ee[be]=arguments[be];var se=U.renderer.apply(this,ee);return se===!1&&(se=G.apply(this,ee)),se}:oe.renderers[U.name]=U.renderer}if(U.tokenizer){if(!U.level||U.level!=="block"&&U.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");oe[U.level]?oe[U.level].unshift(U.tokenizer):oe[U.level]=[U.tokenizer],U.start&&(U.level==="block"?oe.startBlock?oe.startBlock.push(U.start):oe.startBlock=[U.start]:U.level==="inline"&&(oe.startInline?oe.startInline.push(U.start):oe.startInline=[U.start]))}U.childTokens&&(oe.childTokens[U.name]=U.childTokens)})),le.renderer&&function(){var U=ne.defaults.renderer||new de,G=function(be){var se=U[be];U[be]=function(){for(var we=arguments.length,Ie=new Array(we),je=0;je<we;je++)Ie[je]=arguments[je];var Ve=le.renderer[be].apply(U,Ie);return Ve===!1&&(Ve=se.apply(U,Ie)),Ve}};for(var Z in le.renderer)G(Z);K.renderer=U}(),le.tokenizer&&function(){var U=ne.defaults.tokenizer||new T,G=function(be){var se=U[be];U[be]=function(){for(var we=arguments.length,Ie=new Array(we),je=0;je<we;je++)Ie[je]=arguments[je];var Ve=le.tokenizer[be].apply(U,Ie);return Ve===!1&&(Ve=se.apply(U,Ie)),Ve}};for(var Z in le.tokenizer)G(Z);K.tokenizer=U}(),le.walkTokens){var $e=ne.defaults.walkTokens;K.walkTokens=function(U){var G=[];return G.push(le.walkTokens.call(this,U)),$e&&(G=G.concat($e.call(this,U))),G}}_&&(K.extensions=oe),ne.setOptions(K)})},ne.walkTokens=function(ye,X){for(var he=[],K=function(){var $e=_.value;switch(he=he.concat(X.call(ne,$e)),$e.type){case"table":{for(var U=A($e.header),G;!(G=U()).done;){var Z=G.value;he=he.concat(ne.walkTokens(Z.tokens,X))}for(var ee=A($e.rows),be;!(be=ee()).done;)for(var se=be.value,we=A(se),Ie;!(Ie=we()).done;){var je=Ie.value;he=he.concat(ne.walkTokens(je.tokens,X))}break}case"list":{he=he.concat(ne.walkTokens($e.items,X));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[$e.type]?ne.defaults.extensions.childTokens[$e.type].forEach(function(Ve){he=he.concat(ne.walkTokens($e[Ve],X))}):$e.tokens&&(he=he.concat(ne.walkTokens($e.tokens,X)))}},oe=A(ye),_;!(_=oe()).done;)K();return he},ne.parseInline=function(ye,X){if(typeof ye>"u"||ye===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");X=u({},ne.defaults,X||{}),w(X);try{var he=V.lexInline(ye,X);return X.walkTokens&&ne.walkTokens(he,X.walkTokens),q.parseInline(he,X)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,X.silent)return"<p>An error occurred:</p><pre>"+S(K.message+"",!0)+"</pre>";throw K}},ne.Parser=q,ne.parser=q.parse,ne.Renderer=de,ne.TextRenderer=re,ne.Lexer=V,ne.lexer=V.lex,ne.Tokenizer=T,ne.Slugger=x,ne.parse=ne;var pe=ne.options,H=ne.setOptions,ue=ne.use,ce=ne.walkTokens,z=ne.parseInline,ie=ne,Ee=q.parse,Re=V.lex;fe.Lexer=V,fe.Parser=q,fe.Renderer=de,fe.Slugger=x,fe.TextRenderer=re,fe.Tokenizer=T,fe.getDefaults=P,fe.lexer=Re,fe.marked=ne,fe.options=pe,fe.parse=ie,fe.parseInline=z,fe.parser=Ee,fe.setOptions=H,fe.use=ue,fe.walkTokens=ce,Object.defineProperty(fe,"__esModule",{value:!0})}),define(Se[69],Ce([1,0,28]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=void 0;const F=new k.$qi(1e4);function h(b){return E(b,"NFC",F)}e.$7k=h;const A=new k.$qi(1e4);function P(b){return E(b,"NFD",A)}e.$8k=P;const m=/[^\u0000-\u0080]/;function E(b,R,I){if(!b)return b;const $=I.get(b);if($)return $;let D;return m.test(b)?D=b.normalize(R):D=b,I.set(b,D),D}e.$9k=function(){const b=/[\u0300-\u036f]/g;return function(R){return P(R).replace(b,"")}}()}),define(Se[112],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=e.$vl=e.rot=e.$tl=void 0;function k(m,E,b){return Math.min(Math.max(m,E),b)}e.$tl=k;function F(m,E){return(E+m%E)%E}e.rot=F;class h{constructor(){this.a=0}getNext(){return this.a++}}e.$vl=h;class A{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$wl=A;class P{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const b=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$xl=P}),function(){function fe(h){const A=[];typeof h=="number"&&A.push("code/timeOrigin",h);function P(E){A.push(E,Date.now())}function m(){const E=[];for(let b=0;b<A.length;b+=2)E.push({name:A[b],startTime:A[b+1]});return E}return{mark:P,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?fe():{mark(h){performance.mark(h)},getMarks(){let h=performance.timeOrigin;typeof h!="number"&&(h=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(h)}];for(const P of performance.getEntriesByType("mark"))A.push({name:P.name,startTime:Math.round(h+P.startTime)});return A}};if(typeof process=="object"){const h=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return fe(h)}else return console.trace("perf-util loaded in UNKNOWN environment"),fe()}function k(h){return h.MonacoPerformanceMarks||(h.MonacoPerformanceMarks=e()),h.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=k(F))}(),function(fe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var F in k)(typeof exports=="object"?exports:fe)[F]=k[F]}}(typeof self<"u"?self:this,function(){return function(fe){var e={};function k(F){if(e[F])return e[F].exports;var h=e[F]={i:F,l:!1,exports:{}};return fe[F].call(h.exports,h,h.exports,k),h.l=!0,h.exports}return k.m=fe,k.c=e,k.d=function(F,h,A){k.o(F,h)||Object.defineProperty(F,h,{enumerable:!0,get:A})},k.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},k.t=function(F,h){if(1&h&&(F=k(F)),8&h||4&h&&typeof F=="object"&&F&&F.__esModule)return F;var A=Object.create(null);if(k.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:F}),2&h&&typeof F!="string")for(var P in F)k.d(A,P,function(m){return F[m]}.bind(null,P));return A},k.n=function(F){var h=F&&F.__esModule?function(){return F.default}:function(){return F};return k.d(h,"a",h),h},k.o=function(F,h){return Object.prototype.hasOwnProperty.call(F,h)},k.p="",k(k.s=0)}([function(fe,e,k){(function(F){var h;e=fe.exports=ue,h=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var se=Array.prototype.slice.call(arguments,0);se.unshift("SEMVER"),console.log.apply(console,se)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],E=e.src=[],b=0,R=b++;E[R]="0|[1-9]\\d*";var I=b++;E[I]="[0-9]+";var $=b++;E[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=b++;E[D]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var S=b++;E[S]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var p=b++;E[p]="(?:"+E[R]+"|"+E[$]+")";var r=b++;E[r]="(?:"+E[I]+"|"+E[$]+")";var s=b++;E[s]="(?:-("+E[p]+"(?:\\."+E[p]+")*))";var c=b++;E[c]="(?:-?("+E[r]+"(?:\\."+E[r]+")*))";var f=b++;E[f]="[0-9A-Za-z-]+";var y=b++;E[y]="(?:\\+("+E[f]+"(?:\\."+E[f]+")*))";var C=b++,i="v?"+E[D]+E[s]+"?"+E[y]+"?";E[C]="^"+i+"$";var o="[v=\\s]*"+E[S]+E[c]+"?"+E[y]+"?",n=b++;E[n]="^"+o+"$";var t=b++;E[t]="((?:<|>)?=?)";var a=b++;E[a]=E[I]+"|x|X|\\*";var g=b++;E[g]=E[R]+"|x|X|\\*";var u=b++;E[u]="[v=\\s]*("+E[g]+")(?:\\.("+E[g]+")(?:\\.("+E[g]+")(?:"+E[s]+")?"+E[y]+"?)?)?";var d=b++;E[d]="[v=\\s]*("+E[a]+")(?:\\.("+E[a]+")(?:\\.("+E[a]+")(?:"+E[c]+")?"+E[y]+"?)?)?";var v=b++;E[v]="^"+E[t]+"\\s*"+E[u]+"$";var l=b++;E[l]="^"+E[t]+"\\s*"+E[d]+"$";var w=b++;E[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=b++;E[L]="(?:~>?)";var O=b++;E[O]="(\\s*)"+E[L]+"\\s+",m[O]=new RegExp(E[O],"g");var N=b++;E[N]="^"+E[L]+E[u]+"$";var T=b++;E[T]="^"+E[L]+E[d]+"$";var j=b++;E[j]="(?:\\^)";var W=b++;E[W]="(\\s*)"+E[j]+"\\s+",m[W]=new RegExp(E[W],"g");var M=b++;E[M]="^"+E[j]+E[u]+"$";var Y=b++;E[Y]="^"+E[j]+E[d]+"$";var V=b++;E[V]="^"+E[t]+"\\s*("+o+")$|^$";var de=b++;E[de]="^"+E[t]+"\\s*("+i+")$|^$";var re=b++;E[re]="(\\s*)"+E[t]+"\\s*("+o+"|"+E[u]+")",m[re]=new RegExp(E[re],"g");var x=b++;E[x]="^\\s*("+E[u]+")\\s+-\\s+("+E[u]+")\\s*$";var q=b++;E[q]="^\\s*("+E[d]+")\\s+-\\s+("+E[d]+")\\s*$";var ne=b++;E[ne]="(<|>)?=?\\s*\\*";for(var pe=0;pe<35;pe++)h(pe,E[pe]),m[pe]||(m[pe]=new RegExp(E[pe]));function H(se,we){if(se instanceof ue)return se;if(typeof se!="string"||se.length>A||!(we?m[n]:m[C]).test(se))return null;try{return new ue(se,we)}catch{return null}}function ue(se,we){if(se instanceof ue){if(se.loose===we)return se;se=se.version}else if(typeof se!="string")throw new TypeError("Invalid Version: "+se);if(se.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof ue))return new ue(se,we);h("SemVer",se,we),this.loose=we;var Ie=se.trim().match(we?m[n]:m[C]);if(!Ie)throw new TypeError("Invalid Version: "+se);if(this.raw=se,this.major=+Ie[1],this.minor=+Ie[2],this.patch=+Ie[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");Ie[4]?this.prerelease=Ie[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Ve=+je;if(Ve>=0&&Ve<P)return Ve}return je}):this.prerelease=[],this.build=Ie[5]?Ie[5].split("."):[],this.format()}e.parse=H,e.valid=function(se,we){var Ie=H(se,we);return Ie?Ie.version:null},e.clean=function(se,we){var Ie=H(se.trim().replace(/^[=v]+/,""),we);return Ie?Ie.version:null},e.SemVer=ue,ue.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ue.prototype.toString=function(){return this.version},ue.prototype.compare=function(se){return h("SemVer.compare",this.version,this.loose,se),se instanceof ue||(se=new ue(se,this.loose)),this.compareMain(se)||this.comparePre(se)},ue.prototype.compareMain=function(se){return se instanceof ue||(se=new ue(se,this.loose)),z(this.major,se.major)||z(this.minor,se.minor)||z(this.patch,se.patch)},ue.prototype.comparePre=function(se){if(se instanceof ue||(se=new ue(se,this.loose)),this.prerelease.length&&!se.prerelease.length)return-1;if(!this.prerelease.length&&se.prerelease.length)return 1;if(!this.prerelease.length&&!se.prerelease.length)return 0;var we=0;do{var Ie=this.prerelease[we],je=se.prerelease[we];if(h("prerelease compare",we,Ie,je),Ie===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(Ie===void 0)return-1;if(Ie!==je)return z(Ie,je)}while(++we)},ue.prototype.inc=function(se,we){switch(se){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",we);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",we);break;case"prepatch":this.prerelease.length=0,this.inc("patch",we),this.inc("pre",we);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",we),this.inc("pre",we);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ie=this.prerelease.length;--Ie>=0;)typeof this.prerelease[Ie]=="number"&&(this.prerelease[Ie]++,Ie=-2);Ie===-1&&this.prerelease.push(0)}we&&(this.prerelease[0]===we?isNaN(this.prerelease[1])&&(this.prerelease=[we,0]):this.prerelease=[we,0]);break;default:throw new Error("invalid increment argument: "+se)}return this.format(),this.raw=this.version,this},e.inc=function(se,we,Ie,je){typeof Ie=="string"&&(je=Ie,Ie=void 0);try{return new ue(se,Ie).inc(we,je).version}catch{return null}},e.diff=function(se,we){if(ye(se,we))return null;var Ie=H(se),je=H(we);if(Ie.prerelease.length||je.prerelease.length){for(var Ve in Ie)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Ie[Ve]!==je[Ve])return"pre"+Ve;return"prerelease"}for(var Ve in Ie)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Ie[Ve]!==je[Ve])return Ve},e.compareIdentifiers=z;var ce=/^[0-9]+$/;function z(se,we){var Ie=ce.test(se),je=ce.test(we);return Ie&&je&&(se=+se,we=+we),Ie&&!je?-1:je&&!Ie?1:se<we?-1:se>we?1:0}function ie(se,we,Ie){return new ue(se,Ie).compare(new ue(we,Ie))}function Ee(se,we,Ie){return ie(se,we,Ie)>0}function Re(se,we,Ie){return ie(se,we,Ie)<0}function ye(se,we,Ie){return ie(se,we,Ie)===0}function X(se,we,Ie){return ie(se,we,Ie)!==0}function he(se,we,Ie){return ie(se,we,Ie)>=0}function K(se,we,Ie){return ie(se,we,Ie)<=0}function oe(se,we,Ie,je){var Ve;switch(we){case"===":typeof se=="object"&&(se=se.version),typeof Ie=="object"&&(Ie=Ie.version),Ve=se===Ie;break;case"!==":typeof se=="object"&&(se=se.version),typeof Ie=="object"&&(Ie=Ie.version),Ve=se!==Ie;break;case"":case"=":case"==":Ve=ye(se,Ie,je);break;case"!=":Ve=X(se,Ie,je);break;case">":Ve=Ee(se,Ie,je);break;case">=":Ve=he(se,Ie,je);break;case"<":Ve=Re(se,Ie,je);break;case"<=":Ve=K(se,Ie,je);break;default:throw new TypeError("Invalid operator: "+we)}return Ve}function _(se,we){if(se instanceof _){if(se.loose===we)return se;se=se.value}if(!(this instanceof _))return new _(se,we);h("comparator",se,we),this.loose=we,this.parse(se),this.semver===le?this.value="":this.value=this.operator+this.semver.version,h("comp",this)}e.rcompareIdentifiers=function(se,we){return z(we,se)},e.major=function(se,we){return new ue(se,we).major},e.minor=function(se,we){return new ue(se,we).minor},e.patch=function(se,we){return new ue(se,we).patch},e.compare=ie,e.compareLoose=function(se,we){return ie(se,we,!0)},e.rcompare=function(se,we,Ie){return ie(we,se,Ie)},e.sort=function(se,we){return se.sort(function(Ie,je){return e.compare(Ie,je,we)})},e.rsort=function(se,we){return se.sort(function(Ie,je){return e.rcompare(Ie,je,we)})},e.gt=Ee,e.lt=Re,e.eq=ye,e.neq=X,e.gte=he,e.lte=K,e.cmp=oe,e.Comparator=_;var le={};function $e(se,we){if(se instanceof $e)return se.loose===we?se:new $e(se.raw,we);if(se instanceof _)return new $e(se.value,we);if(!(this instanceof $e))return new $e(se,we);if(this.loose=we,this.raw=se,this.set=se.split(/\s*\|\|\s*/).map(function(Ie){return this.parseRange(Ie.trim())},this).filter(function(Ie){return Ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+se);this.format()}function U(se){return!se||se.toLowerCase()==="x"||se==="*"}function G(se,we,Ie,je,Ve,_e,Ge,et,Qe,st,tt,Pe,ke){return((we=U(Ie)?"":U(je)?">="+Ie+".0.0":U(Ve)?">="+Ie+"."+je+".0":">="+we)+" "+(et=U(Qe)?"":U(st)?"<"+(+Qe+1)+".0.0":U(tt)?"<"+Qe+"."+(+st+1)+".0":Pe?"<="+Qe+"."+st+"."+tt+"-"+Pe:"<="+et)).trim()}function Z(se,we){for(var Ie=0;Ie<se.length;Ie++)if(!se[Ie].test(we))return!1;if(we.prerelease.length){for(Ie=0;Ie<se.length;Ie++)if(h(se[Ie].semver),se[Ie].semver!==le&&se[Ie].semver.prerelease.length>0){var je=se[Ie].semver;if(je.major===we.major&&je.minor===we.minor&&je.patch===we.patch)return!0}return!1}return!0}function ee(se,we,Ie){try{we=new $e(we,Ie)}catch{return!1}return we.test(se)}function be(se,we,Ie,je){var Ve,_e,Ge,et,Qe;switch(se=new ue(se,je),we=new $e(we,je),Ie){case">":Ve=Ee,_e=K,Ge=Re,et=">",Qe=">=";break;case"<":Ve=Re,_e=he,Ge=Ee,et="<",Qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ee(se,we,je))return!1;for(var st=0;st<we.set.length;++st){var tt=we.set[st],Pe=null,ke=null;if(tt.forEach(function(Be){Be.semver===le&&(Be=new _(">=0.0.0")),Pe=Pe||Be,ke=ke||Be,Ve(Be.semver,Pe.semver,je)?Pe=Be:Ge(Be.semver,ke.semver,je)&&(ke=Be)}),Pe.operator===et||Pe.operator===Qe||(!ke.operator||ke.operator===et)&&_e(se,ke.semver)||ke.operator===Qe&&Ge(se,ke.semver))return!1}return!0}_.prototype.parse=function(se){var we=this.loose?m[V]:m[de],Ie=se.match(we);if(!Ie)throw new TypeError("Invalid comparator: "+se);this.operator=Ie[1],this.operator==="="&&(this.operator=""),Ie[2]?this.semver=new ue(Ie[2],this.loose):this.semver=le},_.prototype.toString=function(){return this.value},_.prototype.test=function(se){return h("Comparator.test",se,this.loose),this.semver===le||(typeof se=="string"&&(se=new ue(se,this.loose)),oe(se,this.operator,this.semver,this.loose))},_.prototype.intersects=function(se,we){if(!(se instanceof _))throw new TypeError("a Comparator is required");var Ie;if(this.operator==="")return Ie=new $e(se.value,we),ee(this.value,Ie,we);if(se.operator==="")return Ie=new $e(this.value,we),ee(se.semver,Ie,we);var je=!(this.operator!==">="&&this.operator!==">"||se.operator!==">="&&se.operator!==">"),Ve=!(this.operator!=="<="&&this.operator!=="<"||se.operator!=="<="&&se.operator!=="<"),_e=this.semver.version===se.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||se.operator!==">="&&se.operator!=="<="),et=oe(this.semver,"<",se.semver,we)&&(this.operator===">="||this.operator===">")&&(se.operator==="<="||se.operator==="<"),Qe=oe(this.semver,">",se.semver,we)&&(this.operator==="<="||this.operator==="<")&&(se.operator===">="||se.operator===">");return je||Ve||_e&&Ge||et||Qe},e.Range=$e,$e.prototype.format=function(){return this.range=this.set.map(function(se){return se.join(" ").trim()}).join("||").trim(),this.range},$e.prototype.toString=function(){return this.range},$e.prototype.parseRange=function(se){var we=this.loose;se=se.trim(),h("range",se,we);var Ie=we?m[q]:m[x];se=se.replace(Ie,G),h("hyphen replace",se),se=se.replace(m[re],"$1$2$3"),h("comparator trim",se,m[re]),se=(se=(se=se.replace(m[O],"$1~")).replace(m[W],"$1^")).split(/\s+/).join(" ");var je=we?m[V]:m[de],Ve=se.split(" ").map(function(_e){return function(Ge,et){return h("comp",Ge),Ge=function(Qe,st){return Qe.trim().split(/\s+/).map(function(tt){return function(Pe,ke){h("caret",Pe,ke);var Be=ke?m[Y]:m[M];return Pe.replace(Be,function(te,Q,ve,Ue,Ne){var Ye;return h("caret",Pe,te,Q,ve,Ue,Ne),U(Q)?Ye="":U(ve)?Ye=">="+Q+".0.0 <"+(+Q+1)+".0.0":U(Ue)?Ye=Q==="0"?">="+Q+"."+ve+".0 <"+Q+"."+(+ve+1)+".0":">="+Q+"."+ve+".0 <"+(+Q+1)+".0.0":Ne?(h("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ye=Q==="0"?ve==="0"?">="+Q+"."+ve+"."+Ue+Ne+" <"+Q+"."+ve+"."+(+Ue+1):">="+Q+"."+ve+"."+Ue+Ne+" <"+Q+"."+(+ve+1)+".0":">="+Q+"."+ve+"."+Ue+Ne+" <"+(+Q+1)+".0.0"):(h("no pr"),Ye=Q==="0"?ve==="0"?">="+Q+"."+ve+"."+Ue+" <"+Q+"."+ve+"."+(+Ue+1):">="+Q+"."+ve+"."+Ue+" <"+Q+"."+(+ve+1)+".0":">="+Q+"."+ve+"."+Ue+" <"+(+Q+1)+".0.0"),h("caret return",Ye),Ye})}(tt,st)}).join(" ")}(Ge,et),h("caret",Ge),Ge=function(Qe,st){return Qe.trim().split(/\s+/).map(function(tt){return function(Pe,ke){var Be=ke?m[T]:m[N];return Pe.replace(Be,function(te,Q,ve,Ue,Ne){var Ye;return h("tilde",Pe,te,Q,ve,Ue,Ne),U(Q)?Ye="":U(ve)?Ye=">="+Q+".0.0 <"+(+Q+1)+".0.0":U(Ue)?Ye=">="+Q+"."+ve+".0 <"+Q+"."+(+ve+1)+".0":Ne?(h("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ye=">="+Q+"."+ve+"."+Ue+Ne+" <"+Q+"."+(+ve+1)+".0"):Ye=">="+Q+"."+ve+"."+Ue+" <"+Q+"."+(+ve+1)+".0",h("tilde return",Ye),Ye})}(tt,st)}).join(" ")}(Ge,et),h("tildes",Ge),Ge=function(Qe,st){return h("replaceXRanges",Qe,st),Qe.split(/\s+/).map(function(tt){return function(Pe,ke){Pe=Pe.trim();var Be=ke?m[l]:m[v];return Pe.replace(Be,function(te,Q,ve,Ue,Ne,Ye){h("xRange",Pe,te,Q,ve,Ue,Ne,Ye);var xe=U(ve),rt=xe||U(Ue),ft=rt||U(Ne);return Q==="="&&ft&&(Q=""),xe?te=Q===">"||Q==="<"?"<0.0.0":"*":Q&&ft?(rt&&(Ue=0),ft&&(Ne=0),Q===">"?(Q=">=",rt?(ve=+ve+1,Ue=0,Ne=0):ft&&(Ue=+Ue+1,Ne=0)):Q==="<="&&(Q="<",rt?ve=+ve+1:Ue=+Ue+1),te=Q+ve+"."+Ue+"."+Ne):rt?te=">="+ve+".0.0 <"+(+ve+1)+".0.0":ft&&(te=">="+ve+"."+Ue+".0 <"+ve+"."+(+Ue+1)+".0"),h("xRange return",te),te})}(tt,st)}).join(" ")}(Ge,et),h("xrange",Ge),Ge=function(Qe,st){return h("replaceStars",Qe,st),Qe.trim().replace(m[ne],"")}(Ge,et),h("stars",Ge),Ge}(_e,we)}).join(" ").split(/\s+/);return this.loose&&(Ve=Ve.filter(function(_e){return!!_e.match(je)})),Ve=Ve.map(function(_e){return new _(_e,we)})},$e.prototype.intersects=function(se,we){if(!(se instanceof $e))throw new TypeError("a Range is required");return this.set.some(function(Ie){return Ie.every(function(je){return se.set.some(function(Ve){return Ve.every(function(_e){return je.intersects(_e,we)})})})})},e.toComparators=function(se,we){return new $e(se,we).set.map(function(Ie){return Ie.map(function(je){return je.value}).join(" ").trim().split(" ")})},$e.prototype.test=function(se){if(!se)return!1;typeof se=="string"&&(se=new ue(se,this.loose));for(var we=0;we<this.set.length;we++)if(Z(this.set[we],se))return!0;return!1},e.satisfies=ee,e.maxSatisfying=function(se,we,Ie){var je=null,Ve=null;try{var _e=new $e(we,Ie)}catch{return null}return se.forEach(function(Ge){_e.test(Ge)&&(je&&Ve.compare(Ge)!==-1||(Ve=new ue(je=Ge,Ie)))}),je},e.minSatisfying=function(se,we,Ie){var je=null,Ve=null;try{var _e=new $e(we,Ie)}catch{return null}return se.forEach(function(Ge){_e.test(Ge)&&(je&&Ve.compare(Ge)!==1||(Ve=new ue(je=Ge,Ie)))}),je},e.validRange=function(se,we){try{return new $e(se,we).range||"*"}catch{return null}},e.ltr=function(se,we,Ie){return be(se,we,"<",Ie)},e.gtr=function(se,we,Ie){return be(se,we,">",Ie)},e.outside=be,e.prerelease=function(se,we){var Ie=H(se,we);return Ie&&Ie.prerelease.length?Ie.prerelease:null},e.intersects=function(se,we,Ie){return se=new $e(se,Ie),we=new $e(we,Ie),se.intersects(we)},e.coerce=function(se){if(se instanceof ue)return se;if(typeof se!="string")return null;var we=se.match(m[w]);return we==null?null:H((we[1]||"0")+"."+(we[2]||"0")+"."+(we[3]||"0"))}}).call(this,k(1))},function(fe,e){var k,F,h=fe.exports={};function A(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function m(r){if(k===setTimeout)return setTimeout(r,0);if((k===A||!k)&&setTimeout)return k=setTimeout,setTimeout(r,0);try{return k(r,0)}catch{try{return k.call(null,r,0)}catch{return k.call(this,r,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:A}catch{k=A}try{F=typeof clearTimeout=="function"?clearTimeout:P}catch{F=P}})();var E,b=[],R=!1,I=-1;function $(){R&&E&&(R=!1,E.length?b=E.concat(b):I=-1,b.length&&D())}function D(){if(!R){var r=m($);R=!0;for(var s=b.length;s;){for(E=b,b=[];++I<s;)E&&E[I].run();I=-1,s=b.length}E=null,R=!1,function(c){if(F===clearTimeout)return clearTimeout(c);if((F===P||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(c);try{F(c)}catch{try{return F.call(null,c)}catch{return F.call(this,c)}}}(r)}}function S(r,s){this.fun=r,this.array=s}function p(){}h.nextTick=function(r){var s=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)s[c-1]=arguments[c];b.push(new S(r,s)),b.length!==1||R||m(D)},S.prototype.run=function(){this.fun.apply(null,this.array)},h.title="browser",h.browser=!0,h.env={},h.argv=[],h.version="",h.versions={},h.on=p,h.addListener=p,h.once=p,h.off=p,h.removeListener=p,h.removeAllListeners=p,h.emit=p,h.prependListener=p,h.prependOnceListener=p,h.listeners=function(r){return[]},h.binding=function(r){throw new Error("process.binding is not supported")},h.cwd=function(){return"/"},h.chdir=function(r){throw new Error("process.chdir is not supported")},h.umask=function(){return 0}}])}),define(Se[39],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(A){return new F(A)}constructor(A){this.c=k&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$4c=F}),define(Se[3],Ce([1,0,8,67,4,68,39]),function(fe,e,k,F,h,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.Event=void 0;const m=!1,E=!1;var b;(function(d){d.None=()=>h.$lb.None;function v(ye){if(E){const{onDidAddListener:X}=ye,he=S.create();let K=0;ye.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),X?.()}}}function l(ye,X){return Y(ye,()=>{},0,void 0,!0,void 0,X)}d.defer=l;function w(ye){return(X,he=null,K)=>{let oe=!1,_;return _=ye(le=>{if(!oe)return _?_.dispose():oe=!0,X.call(he,le)},null,K),oe&&_.dispose(),_}}d.once=w;function L(ye,X,he){return M((K,oe=null,_)=>ye(le=>K.call(oe,X(le)),null,_),he)}d.map=L;function O(ye,X,he){return M((K,oe=null,_)=>ye(le=>{X(le),K.call(oe,le)},null,_),he)}d.forEach=O;function N(ye,X,he){return M((K,oe=null,_)=>ye(le=>X(le)&&K.call(oe,le),null,_),he)}d.filter=N;function T(ye){return ye}d.signal=T;function j(...ye){return(X,he=null,K)=>(0,h.$ib)(...ye.map(oe=>oe(_=>X.call(he,_),null,K)))}d.any=j;function W(ye,X,he,K){let oe=he;return L(ye,_=>(oe=X(oe,_),oe),K)}d.reduce=W;function M(ye,X){let he;const K={onWillAddFirstListener(){he=ye(oe.fire,oe)},onDidRemoveLastListener(){he?.dispose()}};X||v(K);const oe=new f(K);return X?.add(oe),oe.event}function Y(ye,X,he=100,K=!1,oe=!1,_,le){let $e,U,G,Z=0,ee;const be={leakWarningThreshold:_,onWillAddFirstListener(){$e=ye(we=>{Z++,U=X(U,we),K&&!G&&(se.fire(U),U=void 0),ee=()=>{const Ie=U;U=void 0,G=void 0,(!K||Z>1)&&se.fire(Ie),Z=0},typeof he=="number"?(clearTimeout(G),G=setTimeout(ee,he)):G===void 0&&(G=0,queueMicrotask(ee))})},onWillRemoveListener(){oe&&Z>0&&ee?.()},onDidRemoveLastListener(){ee=void 0,$e.dispose()}};le||v(be);const se=new f(be);return le?.add(se),se.event}d.debounce=Y;function V(ye,X=0,he){return d.debounce(ye,(K,oe)=>K?(K.push(oe),K):[oe],X,void 0,!0,void 0,he)}d.accumulate=V;function de(ye,X=(K,oe)=>K===oe,he){let K=!0,oe;return N(ye,_=>{const le=K||!X(_,oe);return K=!1,oe=_,le},he)}d.latch=de;function re(ye,X,he){return[d.filter(ye,X,he),d.filter(ye,K=>!X(K),he)]}d.split=re;function x(ye,X=!1,he=[]){let K=he.slice(),oe=ye($e=>{K?K.push($e):le.fire($e)});const _=()=>{K?.forEach($e=>le.fire($e)),K=null},le=new f({onWillAddFirstListener(){oe||(oe=ye($e=>le.fire($e)))},onDidAddFirstListener(){K&&(X?setTimeout(_):_())},onDidRemoveLastListener(){oe&&oe.dispose(),oe=null}});return le.event}d.buffer=x;class q{constructor(X){this.event=X,this.d=new h.$kb}map(X){return new q(L(this.event,X,this.d))}forEach(X){return new q(O(this.event,X,this.d))}filter(X){return new q(N(this.event,X,this.d))}reduce(X,he){return new q(W(this.event,X,he,this.d))}latch(){return new q(de(this.event,void 0,this.d))}debounce(X,he=100,K=!1,oe=!1,_){return new q(Y(this.event,X,he,K,oe,_,this.d))}on(X,he,K){return this.event(X,he,K)}once(X,he,K){return w(this.event)(X,he,K)}dispose(){this.d.dispose()}}function ne(ye){return new q(ye)}d.chain=ne;function pe(ye,X,he=K=>K){const K=(...$e)=>le.fire(he(...$e)),oe=()=>ye.on(X,K),_=()=>ye.removeListener(X,K),le=new f({onWillAddFirstListener:oe,onDidRemoveLastListener:_});return le.event}d.fromNodeEventEmitter=pe;function H(ye,X,he=K=>K){const K=(...$e)=>le.fire(he(...$e)),oe=()=>ye.addEventListener(X,K),_=()=>ye.removeEventListener(X,K),le=new f({onWillAddFirstListener:oe,onDidRemoveLastListener:_});return le.event}d.fromDOMEventEmitter=H;function ue(ye){return new Promise(X=>w(ye)(X))}d.toPromise=ue;function ce(ye,X){return X(void 0),ye(he=>X(he))}d.runAndSubscribe=ce;function z(ye,X){let he=null;function K(_){he?.dispose(),he=new h.$kb,X(_,he)}K(void 0);const oe=ye(_=>K(_));return(0,h.$jb)(()=>{oe.dispose(),he?.dispose()})}d.runAndSubscribeWithStore=z;class ie{constructor(X,he){this._observable=X,this.d=0,this.f=!1;const K={onWillAddFirstListener:()=>{X.addObserver(this)},onDidRemoveLastListener:()=>{X.removeObserver(this)}};he||v(K),this.emitter=new f(K),he&&he.add(this.emitter)}beginUpdate(X){this.d++}handlePossibleChange(X){}handleChange(X,he){this.f=!0}endUpdate(X){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function Ee(ye,X){return new ie(ye,X).emitter.event}d.fromObservable=Ee;function Re(ye){return X=>{let he=0,K=!1;const oe={beginUpdate(){he++},endUpdate(){he--,he===0&&(ye.reportChanges(),K&&(K=!1,X()))},handlePossibleChange(){},handleChange(){K=!0}};return ye.addObserver(oe),ye.reportChanges(),{dispose(){ye.removeObserver(oe)}}}}d.fromObservableLight=Re})(b||(e.Event=b={}));class R{static{this.all=new Set}static{this.d=0}constructor(v){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${v}_${R.d++}`,R.all.add(this)}start(v){this.f=new P.$4c,this.listenerCount=v}stop(){if(this.f){const v=this.f.elapsed();this.durations.push(v),this.elapsedOverall+=v,this.invocationCount+=1,this.f=void 0}}}e.$6c=R;let I=-1;function $(d){const v=I;return I=d,{dispose(){I=v}}}e.$7c=$;class D{constructor(v,l=Math.random().toString(18).slice(2,5)){this.threshold=v,this.name=l,this.f=0}dispose(){this.d?.clear()}check(v,l){const w=this.threshold;if(w<=0||l<w)return;this.d||(this.d=new Map);const L=this.d.get(v.value)||0;if(this.d.set(v.value,L+1),this.f-=1,this.f<=0){this.f=w*.5;let O,N=0;for(const[T,j]of this.d)(!O||N<j)&&(O=T,N=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${N}):`),console.warn(O)}return()=>{const O=this.d.get(v.value)||0;this.d.set(v.value,O-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(v){this.value=v}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class r{constructor(v){this.value=v,this.id=p++}}const s=2,c=(d,v)=>{if(d instanceof r)v(d);else for(let l=0;l<d.length;l++){const w=d[l];w&&v(w)}};class f{constructor(v){this.u=0,this.d=v,this.f=I>0||this.d?.leakWarningThreshold?new D(this.d?.leakWarningThreshold??I):void 0,this.g=this.d?._profName?new R(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(m){const v=this.q;queueMicrotask(()=>{c(v,l=>l.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(v,l,w)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),h.$lb.None;if(this.j)return h.$lb.None;l&&(v=v.bind(l));const L=new r(v);let O,N;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(L.stack=S.create(),O=this.f.check(L.stack,this.u+1)),m&&(L.stack=N??S.create()),this.q?this.q instanceof r?(this.t??=new C,this.q=[this.q,L]):this.q.push(L):(this.d?.onWillAddFirstListener?.(this),this.q=L,this.d?.onDidAddFirstListener?.(this)),this.u++;const T=(0,h.$jb)(()=>{O?.(),this.v(L)});return w instanceof h.$kb?w.add(T):Array.isArray(w)&&w.push(T),T},this.m}v(v){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const l=this.q,w=l.indexOf(v);if(w===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,l[w]=void 0;const L=this.t.current===this;if(this.u*s<=l.length){let O=0;for(let N=0;N<l.length;N++)l[N]?l[O++]=l[N]:L&&(this.t.end--,O<this.t.i&&this.t.i--);l.length=O}}w(v,l){if(!v)return;const w=this.d?.onListenerError||k.$Y;if(!w){v.value(l);return}try{v.value(l)}catch(L){w(L)}}x(v){const l=v.current.q;for(;v.i<v.end;)this.w(l[v.i++],v.value);v.reset()}fire(v){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof r)this.w(this.q,v);else{const l=this.t;l.enqueue(this,v,this.q.length),this.x(l)}this.g?.stop()}hasListeners(){return this.u>0}}e.$8c=f;const y=()=>new C;e.$9c=y;class C{constructor(){this.i=-1,this.end=0}enqueue(v,l,w){this.i=0,this.end=w,this.current=v,this.value=l}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends f{async fireAsync(v,l,w){if(this.q)for(this.h||(this.h=new A.$lc),c(this.q,L=>this.h.push([L.value,v]));this.h.size>0&&!l.isCancellationRequested;){const[L,O]=this.h.shift(),N=[],T={...O,token:l,waitUntil:j=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");w&&(j=w(j,L)),N.push(j)}};try{L(T)}catch(j){(0,k.$Y)(j);continue}Object.freeze(N),await Promise.allSettled(N).then(j=>{for(const W of j)W.status==="rejected"&&(0,k.$Y)(W.reason)})}}}e.$0c=i;class o extends f{get isPaused(){return this.h!==0}constructor(v){super(v),this.h=0,this.s=new A.$lc,this.y=v?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const v=Array.from(this.s);this.s.clear(),super.fire(this.y(v))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(v){this.u&&(this.h!==0?this.s.push(v):super.fire(v))}}e.$$c=o;class n extends o{constructor(v){super(v),this.k=v.delay??100}fire(v){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(v)}}e.$_c=n;class t extends f{constructor(v){super(v),this.h=[],this.k=v?.merge}fire(v){this.hasListeners()&&(this.h.push(v),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(l=>super.fire(l)),this.h=[]}))}}e.$ad=t;class a{constructor(){this.f=!1,this.g=[],this.d=new f({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(v){const l={event:v,listener:null};this.g.push(l),this.f&&this.k(l);const w=()=>{this.f&&this.m(l);const L=this.g.indexOf(l);this.g.splice(L,1)};return(0,h.$jb)((0,F.$cb)(w))}h(){this.f=!0,this.g.forEach(v=>this.k(v))}j(){this.f=!1,this.g.forEach(v=>this.m(v))}k(v){v.listener=v.event(l=>this.d.fire(l))}m(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.d.dispose()}}e.$bd=a;class g{constructor(){this.d=[]}wrapEvent(v){return(l,w,L)=>v(O=>{const N=this.d[this.d.length-1];N?N.push(()=>l.call(w,O)):l.call(w,O)},void 0,L)}bufferEvents(v){const l=[];this.d.push(l);const w=v();return this.d.pop(),l.forEach(L=>L()),w}}e.$cd=g;class u{constructor(){this.d=!1,this.f=b.None,this.g=h.$lb.None,this.h=new f({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(v){this.f=v,this.d&&(this.g.dispose(),this.g=v(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}e.$dd=u}),define(Se[21],Ce([1,0,3]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ed=e.CancellationToken=void 0;const F=Object.freeze(function(m,E){const b=setTimeout(m.bind(E),0);return{dispose(){clearTimeout(b)}}});var h;(function(m){function E(b){return b===m.None||b===m.Cancelled||b instanceof A?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}m.isCancellationToken=E,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(h||(e.CancellationToken=h={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new k.$8c),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class P{constructor(E){this.a=void 0,this.b=void 0,this.b=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=h.Cancelled}dispose(E=!1){E&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=h.None}}e.$ed=P}),define(Se[153],Ce([1,0,21]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hd=e.$gd=e.$fd=void 0;class F{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new k.$ed,E=this.b(m.token);return this.a={promise:E,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}e.$fd=F;class h{constructor(m){this.c=m,this.a=void 0,this.b=void 0}get(m){const E=JSON.stringify(m);return this.b!==E&&(this.b=E,this.a=this.c(m)),this.a}}e.$gd=h;class A{get cachedValues(){return this.a}constructor(m){this.b=m,this.a=new Map}get(m){if(this.a.has(m))return this.a.get(m);const E=this.b(m);return this.a.set(m,E),E}}e.$hd=A}),define(Se[92],Ce([1,0,8,4]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=void 0;function h(y){const C=y;return C?typeof C.read=="function":!1}e.$ub=h;function A(y){const C=y;return C?[C.on,C.pause,C.resume,C.destroy].every(i=>typeof i=="function"):!1}e.$vb=A;function P(y){const C=y;return C?A(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.$wb=P;function m(y,C){return new E(y,C)}e.$xb=m;class E{constructor(C,i){this.e=C,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(C){if(!this.a.destroyed){if(this.a.flowing)this.g(C);else if(this.b.data.push(C),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(C){this.a.destroyed||(this.a.flowing?this.h(C):this.b.error.push(C))}end(C){this.a.destroyed||(typeof C<"u"&&this.write(C),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(C){this.c.data.slice(0).forEach(i=>i(C))}h(C){this.c.error.length===0?(0,k.$Y)(C):this.c.error.slice(0).forEach(i=>i(C))}i(){this.c.end.slice(0).forEach(C=>C())}on(C,i){if(!this.a.destroyed)switch(C){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(C,i){if(this.a.destroyed)return;let o;switch(C){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const C=this.e(this.b.data);this.g(C),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const C of this.b.error)this.h(C);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(y,C){const i=[];let o;for(;(o=y.read())!==null;)i.push(o);return C(i)}e.$yb=b;function R(y,C,i){const o=[];let n;for(;(n=y.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?C(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return y.read()}}}e.$zb=R;function I(y,C){return new Promise((i,o)=>{const n=[];$(y,{onData:t=>{C&&n.push(t)},onError:t=>{C?o(t):i(void 0)},onEnd:()=>{i(C?C(n):void 0)}})})}e.$Ab=I;function $(y,C){let i=!1;return y.on("error",o=>{i||C.onError(o)}),y.on("end",()=>{i||C.onEnd()}),y.on("data",o=>{i||C.onData(o)}),(0,F.$jb)(()=>i=!0)}e.$Bb=$;function D(y,C){return new Promise((i,o)=>{const n=new F.$kb,t=[],a=d=>{if(t.push(d),t.length>C)return n.dispose(),y.pause(),i({stream:y,buffer:t,ended:!1})},g=d=>o(d),u=()=>i({stream:y,buffer:t,ended:!0});n.add((0,F.$jb)(()=>y.removeListener("error",g))),y.on("error",g),n.add((0,F.$jb)(()=>y.removeListener("end",u))),y.on("end",u),n.add((0,F.$jb)(()=>y.removeListener("data",a))),y.on("data",a)})}e.$Cb=D;function S(y,C){const i=m(C);return i.end(y),i}e.$Db=S;function p(){const y=m(()=>{throw new Error("not supported")});return y.end(),y}e.$Eb=p;function r(y){let C=!1;return{read:()=>C?null:(C=!0,y)}}e.$Fb=r;function s(y,C,i){const o=m(i);return $(y,{onData:n=>o.write(C.data(n)),onError:n=>o.error(C.error?C.error(n):n),onEnd:()=>o.end()}),o}e.$Gb=s;function c(y,C,i){let o=!1;return{read:()=>{const n=C.read();return o?n:(o=!0,n!==null?i([y,n]):y)}}}e.$Hb=c;function f(y,C,i){let o=!1;const n=m(i);return $(C,{onData:t=>o?n.write(t):(o=!0,n.write(i([y,t]))),onError:t=>n.error(t),onEnd:()=>{o||(o=!0,n.write(y)),n.end()}}),n}e.$Ib=f}),define(Se[22],Ce([1,0,54,92]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=void 0;const h=typeof Buffer<"u",A=new k.$T(()=>new Uint8Array(256));let P,m;class E{static alloc(w){return h?new E(Buffer.allocUnsafe(w)):new E(new Uint8Array(w))}static wrap(w){return h&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new E(w)}static fromString(w,L){return!(L?.dontUseNodeBuffer||!1)&&h?new E(Buffer.from(w)):(P||(P=new TextEncoder),new E(P.encode(w)))}static fromByteArray(w){const L=E.alloc(w.length);for(let O=0,N=w.length;O<N;O++)L.buffer[O]=w[O];return L}static concat(w,L){if(typeof L>"u"){L=0;for(let T=0,j=w.length;T<j;T++)L+=w[T].byteLength}const O=E.alloc(L);let N=0;for(let T=0,j=w.length;T<j;T++){const W=w[T];O.set(W,N),N+=W.byteLength}return O}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=E.alloc(this.byteLength);return w.set(this),w}toString(){return h?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(w,L){return new E(this.buffer.subarray(w,L))}set(w,L){if(w instanceof E)this.buffer.set(w.buffer,L);else if(w instanceof Uint8Array)this.buffer.set(w,L);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),L);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return $(this.buffer,w)}writeUInt32BE(w,L){D(this.buffer,w,L)}readUInt32LE(w){return S(this.buffer,w)}writeUInt32LE(w,L){p(this.buffer,w,L)}readUInt8(w){return r(this.buffer,w)}writeUInt8(w,L){s(this.buffer,w,L)}indexOf(w,L=0){return b(this.buffer,w instanceof E?w.buffer:w,L)}}e.$Jb=E;function b(l,w,L=0){const O=w.byteLength,N=l.byteLength;if(O===0)return 0;if(O===1)return l.indexOf(w[0]);if(O>N-L)return-1;const T=A.value;T.fill(w.length);for(let Y=0;Y<w.length;Y++)T[w[Y]]=w.length-Y-1;let j=L+w.length-1,W=j,M=-1;for(;j<N;)if(l[j]===w[W]){if(W===0){M=j;break}j--,W--}else j+=Math.max(w.length-W,T[l[j]]),W=w.length-1;return M}e.$Kb=b;function R(l,w){return l[w+0]<<0>>>0|l[w+1]<<8>>>0}e.$Lb=R;function I(l,w,L){l[L+0]=w&255,w=w>>>8,l[L+1]=w&255}e.$Mb=I;function $(l,w){return l[w]*2**24+l[w+1]*2**16+l[w+2]*2**8+l[w+3]}e.$Nb=$;function D(l,w,L){l[L+3]=w,w=w>>>8,l[L+2]=w,w=w>>>8,l[L+1]=w,w=w>>>8,l[L]=w}e.$Ob=D;function S(l,w){return l[w+0]<<0>>>0|l[w+1]<<8>>>0|l[w+2]<<16>>>0|l[w+3]<<24>>>0}e.$Pb=S;function p(l,w,L){l[L+0]=w&255,w=w>>>8,l[L+1]=w&255,w=w>>>8,l[L+2]=w&255,w=w>>>8,l[L+3]=w&255}e.$Qb=p;function r(l,w){return l[w]}e.$Rb=r;function s(l,w,L){l[L]=w}e.$Sb=s;function c(l){return F.$yb(l,w=>E.concat(w))}e.$Tb=c;function f(l){return F.$Fb(l)}e.$Ub=f;function y(l){return F.$Ab(l,w=>E.concat(w))}e.$Vb=y;async function C(l){return l.ended?E.concat(l.buffer):E.concat([...l.buffer,await y(l.stream)])}e.$Wb=C;function i(l){return F.$Db(l,w=>E.concat(w))}e.$Xb=i;function o(l){return F.$Gb(l,{data:w=>typeof w=="string"?E.fromString(w):E.wrap(w)},w=>E.concat(w))}e.$Yb=o;function n(l){return F.$xb(w=>E.concat(w),l)}e.$Zb=n;function t(l,w){return F.$Hb(l,w,L=>E.concat(L))}e.$1b=t;function a(l,w){return F.$Ib(l,w,L=>E.concat(L))}e.$2b=a;function g(l){let w=0,L=0,O=0;const N=new Uint8Array(Math.floor(l.length/4*3)),T=W=>{switch(L){case 3:N[O++]=w|W,L=0;break;case 2:N[O++]=w|W>>>2,w=W<<6,L=3;break;case 1:N[O++]=w|W>>>4,w=W<<4,L=2;break;default:w=W<<2,L=1}};for(let W=0;W<l.length;W++){const M=l.charCodeAt(W);if(M>=65&&M<=90)T(M-65);else if(M>=97&&M<=122)T(M-97+26);else if(M>=48&&M<=57)T(M-48+52);else if(M===43||M===45)T(62);else if(M===47||M===95)T(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${l[W]}`)}}const j=O;for(;L>0;)T(0);return E.wrap(N).slice(0,j)}e.$3b=g;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:l},w=!0,L=!1){const O=L?d:u;let N="";const T=l.byteLength%3;let j=0;for(;j<l.byteLength-T;j+=3){const W=l[j+0],M=l[j+1],Y=l[j+2];N+=O[W>>>2],N+=O[(W<<4|M>>>4)&63],N+=O[(M<<2|Y>>>6)&63],N+=O[Y&63]}if(T===1){const W=l[j+0];N+=O[W>>>2],N+=O[W<<4&63],w&&(N+="==")}else if(T===2){const W=l[j+0],M=l[j+1];N+=O[W>>>2],N+=O[(W<<4|M>>>4)&63],N+=O[M<<2&63],w&&(N+="=")}return N}e.$4b=v}),define(Se[12],Ce([1,0,153,54]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.GraphemeBreakType=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=void 0;function h(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}e.$kd=h;const A=/{(\d+)}/g;function P(Pe,...ke){return ke.length===0?Pe:Pe.replace(A,function(Be,te){const Q=parseInt(te,10);return isNaN(Q)||Q<0||Q>=ke.length?Be:ke[Q]})}e.$ld=P;const m=/{([^}]+)}/g;function E(Pe,ke){return Pe.replace(m,(Be,te)=>ke[te]??Be)}e.$md=E;function b(Pe){return Pe.replace(/[<>&]/g,function(ke){switch(ke){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ke}})}e.$nd=b;function R(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$od=R;function I(Pe,ke){let Be=0;const te=ke.charCodeAt(0);for(let Q=Pe.length-1;Q>=0;Q--)Pe.charCodeAt(Q)===te&&Be++;return Be}e.$pd=I;function $(Pe,ke,Be="\u2026"){return Pe.length<=ke?Pe:`${Pe.substr(0,ke)}${Be}`}e.$qd=$;function D(Pe,ke=" "){const Be=S(Pe,ke);return p(Be,ke)}e.$rd=D;function S(Pe,ke){if(!Pe||!ke)return Pe;const Be=ke.length;if(Be===0||Pe.length===0)return Pe;let te=0;for(;Pe.indexOf(ke,te)===te;)te=te+Be;return Pe.substring(te)}e.$sd=S;function p(Pe,ke){if(!Pe||!ke)return Pe;const Be=ke.length,te=Pe.length;if(Be===0||te===0)return Pe;let Q=te,ve=-1;for(;ve=Pe.lastIndexOf(ke,Q-1),!(ve===-1||ve+Be!==Q);){if(ve===0)return"";Q=ve}return Pe.substring(0,Q)}e.$td=p;function r(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$ud=r;function s(Pe){return Pe.replace(/\*/g,"")}e.$vd=s;function c(Pe,ke,Be={}){if(!Pe)throw new Error("Cannot create regex from empty string");ke||(Pe=R(Pe)),Be.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let te="";return Be.global&&(te+="g"),Be.matchCase||(te+="i"),Be.multiline&&(te+="m"),Be.unicode&&(te+="u"),new RegExp(Pe,te)}e.$wd=c;function f(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}e.$xd=f;function y(Pe){return!!Pe.match(/([^\\]|^)(\\\\)*\\\d+/)}e.$yd=y;function C(Pe){return(Pe.global?"g":"")+(Pe.ignoreCase?"i":"")+(Pe.multiline?"m":"")+(Pe.unicode?"u":"")}e.$zd=C;function i(Pe){return Pe.split(/\r\n|\r|\n/)}e.$Ad=i;function o(Pe){for(let ke=0,Be=Pe.length;ke<Be;ke++){const te=Pe.charCodeAt(ke);if(te!==32&&te!==9)return ke}return-1}e.$Bd=o;function n(Pe,ke=0,Be=Pe.length){for(let te=ke;te<Be;te++){const Q=Pe.charCodeAt(te);if(Q!==32&&Q!==9)return Pe.substring(ke,te)}return Pe.substring(ke,Be)}e.$Cd=n;function t(Pe,ke=Pe.length-1){for(let Be=ke;Be>=0;Be--){const te=Pe.charCodeAt(Be);if(te!==32&&te!==9)return Be}return-1}e.$Dd=t;function a(Pe,ke,Be){const te=[];let Q=0;for(const ve of Pe.matchAll(ke)){if(te.push(Pe.slice(Q,ve.index)),ve.index===void 0)throw new Error("match.index should be defined");Q=ve.index+ve[0].length,te.push(Be(ve[0],...ve.slice(1),ve.index,Pe,ve.groups))}return te.push(Pe.slice(Q)),Promise.all(te).then(ve=>ve.join(""))}e.$Ed=a;function g(Pe,ke){return Pe<ke?-1:Pe>ke?1:0}e.$Fd=g;function u(Pe,ke,Be=0,te=Pe.length,Q=0,ve=ke.length){for(;Be<te&&Q<ve;Be++,Q++){const Ye=Pe.charCodeAt(Be),xe=ke.charCodeAt(Q);if(Ye<xe)return-1;if(Ye>xe)return 1}const Ue=te-Be,Ne=ve-Q;return Ue<Ne?-1:Ue>Ne?1:0}e.$Gd=u;function d(Pe,ke){return v(Pe,ke,0,Pe.length,0,ke.length)}e.$Hd=d;function v(Pe,ke,Be=0,te=Pe.length,Q=0,ve=ke.length){for(;Be<te&&Q<ve;Be++,Q++){let Ye=Pe.charCodeAt(Be),xe=ke.charCodeAt(Q);if(Ye===xe)continue;if(Ye>=128||xe>=128)return u(Pe.toLowerCase(),ke.toLowerCase(),Be,te,Q,ve);w(Ye)&&(Ye-=32),w(xe)&&(xe-=32);const rt=Ye-xe;if(rt!==0)return rt}const Ue=te-Be,Ne=ve-Q;return Ue<Ne?-1:Ue>Ne?1:0}e.$Id=v;function l(Pe){return Pe>=48&&Pe<=57}e.$Jd=l;function w(Pe){return Pe>=97&&Pe<=122}e.$Kd=w;function L(Pe){return Pe>=65&&Pe<=90}e.$Ld=L;function O(Pe,ke){return Pe.length===ke.length&&v(Pe,ke)===0}e.$Md=O;function N(Pe,ke){const Be=ke.length;return ke.length>Pe.length?!1:v(Pe,ke,0,Be)===0}e.$Nd=N;function T(Pe,ke){const Be=Math.min(Pe.length,ke.length);let te;for(te=0;te<Be;te++)if(Pe.charCodeAt(te)!==ke.charCodeAt(te))return te;return Be}e.$Od=T;function j(Pe,ke){const Be=Math.min(Pe.length,ke.length);let te;const Q=Pe.length-1,ve=ke.length-1;for(te=0;te<Be;te++)if(Pe.charCodeAt(Q-te)!==ke.charCodeAt(ve-te))return te;return Be}e.$Pd=j;function W(Pe){return 55296<=Pe&&Pe<=56319}e.$Qd=W;function M(Pe){return 56320<=Pe&&Pe<=57343}e.$Rd=M;function Y(Pe,ke){return(Pe-55296<<10)+(ke-56320)+65536}e.$Sd=Y;function V(Pe,ke,Be){const te=Pe.charCodeAt(Be);if(W(te)&&Be+1<ke){const Q=Pe.charCodeAt(Be+1);if(M(Q))return Y(te,Q)}return te}e.$Td=V;function de(Pe,ke){const Be=Pe.charCodeAt(ke-1);if(M(Be)&&ke>1){const te=Pe.charCodeAt(ke-2);if(W(te))return Y(te,Be)}return Be}class re{get offset(){return this.e}constructor(ke,Be=0){this.c=ke,this.d=ke.length,this.e=Be}setOffset(ke){this.e=ke}prevCodePoint(){const ke=de(this.c,this.e);return this.e-=ke>=65536?2:1,ke}nextCodePoint(){const ke=V(this.c,this.d,this.e);return this.e+=ke>=65536?2:1,ke}eol(){return this.e>=this.d}}e.$Ud=re;class x{get offset(){return this.c.offset}constructor(ke,Be=0){this.c=new re(ke,Be)}nextGraphemeLength(){const ke=je.getInstance(),Be=this.c,te=Be.offset;let Q=ke.getGraphemeBreakType(Be.nextCodePoint());for(;!Be.eol();){const ve=Be.offset,Ue=ke.getGraphemeBreakType(Be.nextCodePoint());if(we(Q,Ue)){Be.setOffset(ve);break}Q=Ue}return Be.offset-te}prevGraphemeLength(){const ke=je.getInstance(),Be=this.c,te=Be.offset;let Q=ke.getGraphemeBreakType(Be.prevCodePoint());for(;Be.offset>0;){const ve=Be.offset,Ue=ke.getGraphemeBreakType(Be.prevCodePoint());if(we(Ue,Q)){Be.setOffset(ve);break}Q=Ue}return te-Be.offset}eol(){return this.c.eol()}}e.$Vd=x;function q(Pe,ke){return new x(Pe,ke).nextGraphemeLength()}e.$Wd=q;function ne(Pe,ke){return new x(Pe,ke).prevGraphemeLength()}e.$Xd=ne;function pe(Pe,ke){ke>0&&M(Pe.charCodeAt(ke))&&ke--;const Be=ke+q(Pe,ke);return[Be-ne(Pe,Be),Be]}e.$Yd=pe;function H(Pe){const ke=new x(Pe);let Be=0;for(;!ke.eol();)Be++,ke.nextGraphemeLength();return Be}e.$Zd=H;let ue;function ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function z(Pe){return ue||(ue=ce()),ue.test(Pe)}e.$1d=z;const ie=/^[\t\n\r\x20-\x7E]*$/;function Ee(Pe){return ie.test(Pe)}e.$2d=Ee,e.$3d=/[\u2028\u2029]/;function Re(Pe){return e.$3d.test(Pe)}e.$4d=Re;function ye(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}e.$5d=ye;function X(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}e.$6d=X;function he(Pe,ke){if(Pe.length<ke)return Pe;const Be=/\b/g;let te=0;for(;Be.test(Pe)&&!(Pe.length-Be.lastIndex<ke);)te=Be.lastIndex,Be.lastIndex+=1;return Pe.substring(te).replace(/^\s/,"")}e.$7d=he;const K=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,oe=/\x1b\].*?\x07/g;function _(Pe){return Pe&&(Pe=Pe.replace(K,"").replace(oe,"")),Pe}e.$8d=_,e.$9d=String.fromCharCode(65279);function le(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===65279)}e.$0d=le;function $e(Pe){return le(Pe)?Pe.substr(1):Pe}e.$$d=$e;function U(Pe,ke){if(!Pe||!ke||Pe.length<ke.length)return!1;const Be=ke.length,te=Pe.toLowerCase();let Q=0,ve=-1;for(;Q<Be;){const Ue=te.indexOf(ke[Q],ve+1);if(Ue<0)return!1;ve=Ue,Q++}return!0}e.$_d=U;function G(Pe,ke=!1){return Pe?(ke&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}e.$ae=G;function Z(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}e.$be=Z;function ee(Pe,ke=1){if(ke===0)return"";let Be=-1;do Be=Pe.indexOf(`
`,Be+1),ke--;while(ke>0&&Be>=0);return Be===-1?Pe:(Pe[Be-1]==="\r"&&Be--,Pe.substr(0,Be))}e.$ce=ee;function be(Pe){return Pe=Pe%(2*26),Pe<26?String.fromCharCode(97+Pe):String.fromCharCode(65+Pe-26)}e.$de=be;function se(Pe){return je.getInstance().getGraphemeBreakType(Pe)}e.$ee=se;function we(Pe,ke){return Pe===0?ke!==5&&ke!==7:Pe===2&&ke===3?!1:Pe===4||Pe===2||Pe===3||ke===4||ke===2||ke===3?!0:!(Pe===8&&(ke===8||ke===9||ke===11||ke===12)||(Pe===11||Pe===9)&&(ke===9||ke===10)||(Pe===12||Pe===10)&&ke===10||ke===5||ke===13||ke===7||Pe===1||Pe===13&&ke===14||Pe===6&&ke===6)}var Ie;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Ie||(e.GraphemeBreakType=Ie={}));class je{static{this.c=null}static getInstance(){return je.c||(je.c=new je),je.c}constructor(){this.d=Ve()}getGraphemeBreakType(ke){if(ke<32)return ke===10?3:ke===13?2:4;if(ke<127)return 0;const Be=this.d,te=Be.length/3;let Q=1;for(;Q<=te;)if(ke<Be[3*Q])Q=2*Q;else if(ke>Be[3*Q+1])Q=2*Q+1;else return Be[3*Q+2];return 0}}function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function _e(Pe,ke){if(Pe===0)return 0;const Be=Ge(Pe,ke);if(Be!==void 0)return Be;const te=new re(ke,Pe);return te.prevCodePoint(),te.offset}e.$fe=_e;function Ge(Pe,ke){const Be=new re(ke,Pe);let te=Be.prevCodePoint();for(;et(te)||te===65039||te===8419;){if(Be.offset===0)return;te=Be.prevCodePoint()}if(!X(te))return;let Q=Be.offset;return Q>0&&Be.prevCodePoint()===8205&&(Q=Be.offset),Q}function et(Pe){return 127995<=Pe&&Pe<=127999}var Qe;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.$ge="\xA0";class st{static{this.c=new F.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new k.$gd(ke=>{function Be(rt){const ft=new Map;for(let vt=0;vt<rt.length;vt+=2)ft.set(rt[vt],rt[vt+1]);return ft}function te(rt,ft){const vt=new Map(rt);for(const[Ft,Lt]of ft)vt.set(Ft,Lt);return vt}function Q(rt,ft){if(!rt)return ft;const vt=new Map;for(const[Ft,Lt]of rt)ft.has(Ft)&&vt.set(Ft,Lt);return vt}const ve=this.c.value;let Ue=ke.filter(rt=>!rt.startsWith("_")&&rt in ve);Ue.length===0&&(Ue=["_default"]);let Ne;for(const rt of Ue){const ft=Be(ve[rt]);Ne=Q(Ne,ft)}const Ye=Be(ve._common),xe=te(Ye,Ne);return new st(xe)})}static getInstance(ke){return st.d.get(Array.from(ke))}static{this.e=new F.$T(()=>Object.keys(st.c.value).filter(ke=>!ke.startsWith("_")))}static getLocales(){return st.e.value}constructor(ke){this.f=ke}isAmbiguous(ke){return this.f.has(ke)}getPrimaryConfusable(ke){return this.f.get(ke)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$he=st;class tt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(tt.c())),this.d}static isInvisibleCharacter(ke){return tt.e().has(ke)}static get codePoints(){return tt.e()}}e.$ie=tt}),define(Se[113],Ce([1,0,28,12]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.FuzzyScore=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.or=void 0;function h(..._){return function(le,$e){for(let U=0,G=_.length;U<G;U++){const Z=_[U](le,$e);if(Z)return Z}return null}}e.or=h,e.$kj=A.bind(void 0,!1),e.$lj=A.bind(void 0,!0);function A(_,le,$e){if(!$e||$e.length<le.length)return null;let U;return _?U=F.$Nd($e,le):U=$e.indexOf(le)===0,U?le.length>0?[{start:0,end:le.length}]:[]:null}function P(_,le){const $e=le.toLowerCase().indexOf(_.toLowerCase());return $e===-1?null:[{start:$e,end:$e+_.length}]}e.$mj=P;function m(_,le){return E(_.toLowerCase(),le.toLowerCase(),0,0)}e.$nj=m;function E(_,le,$e,U){if($e===_.length)return[];if(U===le.length)return null;if(_[$e]===le[U]){let G=null;return(G=E(_,le,$e+1,U+1))?s({start:U,end:U+1},G):null}return E(_,le,$e,U+1)}function b(_){return 97<=_&&_<=122}function R(_){return 65<=_&&_<=90}e.$oj=R;function I(_){return 48<=_&&_<=57}function $(_){return _===32||_===9||_===10||_===13}const D=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(_=>D.add(_.charCodeAt(0)));function S(_){return $(_)||D.has(_)}function p(_,le){return _===le||S(_)&&S(le)}function r(_){return b(_)||R(_)||I(_)}function s(_,le){return le.length===0?le=[_]:_.end===le[0].start?le[0].start=_.start:le.unshift(_),le}function c(_,le){for(let $e=le;$e<_.length;$e++){const U=_.charCodeAt($e);if(R(U)||I(U)||$e>0&&!r(_.charCodeAt($e-1)))return $e}return _.length}function f(_,le,$e,U){if($e===_.length)return[];if(U===le.length)return null;if(_[$e]!==le[U].toLowerCase())return null;{let G=null,Z=U+1;for(G=f(_,le,$e+1,U+1);!G&&(Z=c(le,Z))<le.length;)G=f(_,le,$e+1,Z),Z++;return G===null?null:s({start:U,end:U+1},G)}}function y(_){let le=0,$e=0,U=0,G=0,Z=0;for(let Ie=0;Ie<_.length;Ie++)Z=_.charCodeAt(Ie),R(Z)&&le++,b(Z)&&$e++,r(Z)&&U++,I(Z)&&G++;const ee=le/_.length,be=$e/_.length,se=U/_.length,we=G/_.length;return{upperPercent:ee,lowerPercent:be,alphaPercent:se,numericPercent:we}}function C(_){const{upperPercent:le,lowerPercent:$e}=_;return $e===0&&le>.6}function i(_){const{upperPercent:le,lowerPercent:$e,alphaPercent:U,numericPercent:G}=_;return $e>.2&&le<.8&&U>.6&&G<.2}function o(_){let le=0,$e=0,U=0,G=0;for(let Z=0;Z<_.length;Z++)U=_.charCodeAt(Z),R(U)&&le++,b(U)&&$e++,$(U)&&G++;return(le===0||$e===0)&&G===0?_.length<=30:le<=5}function n(_,le){if(!le||(le=le.trim(),le.length===0)||!o(_)||le.length>60)return null;const $e=y(le);if(!i($e)){if(!C($e))return null;le=le.toLowerCase()}let U=null,G=0;for(_=_.toLowerCase();G<le.length&&(U=f(_,le,0,G))===null;)G=c(le,G+1);return U}e.$pj=n;function t(_,le,$e=!1){if(!le||le.length===0)return null;let U=null,G=0;for(_=_.toLowerCase(),le=le.toLowerCase();G<le.length&&(U=a(_,le,0,G,$e))===null;)G=g(le,G+1);return U}e.$qj=t;function a(_,le,$e,U,G){if($e===_.length)return[];if(U===le.length)return null;if(p(_.charCodeAt($e),le.charCodeAt(U))){let Z=null,ee=U+1;if(Z=a(_,le,$e+1,U+1,G),!G)for(;!Z&&(ee=g(le,ee))<le.length;)Z=a(_,le,$e+1,ee,G),ee++;return Z?_.charCodeAt($e)!==le.charCodeAt(U)?Z:s({start:U,end:U+1},Z):null}else return null}function g(_,le){for(let $e=le;$e<_.length;$e++)if(S(_.charCodeAt($e))||$e>0&&S(_.charCodeAt($e-1)))return $e;return _.length}const u=h(e.$lj,n,P),d=h(e.$lj,n,m),v=new k.$qi(1e4);function l(_,le,$e=!1){if(typeof _!="string"||typeof le!="string")return null;let U=v.get(_);U||(U=new RegExp(F.$ud(_),"i"),v.set(_,U));const G=U.exec(le);return G?[{start:G.index,end:G.index+G[0].length}]:$e?d(_,le):u(_,le)}e.$rj=l;function w(_,le){const $e=Ee(_,_.toLowerCase(),0,le,le.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $e?O($e):null}e.$sj=w;function L(_,le,$e,U,G,Z){const ee=Math.min(13,_.length);for(;$e<ee;$e++){const be=Ee(_,le,$e,U,G,Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(be)return be}return[0,Z]}e.$tj=L;function O(_){if(typeof _>"u")return[];const le=[],$e=_[1];for(let U=_.length-1;U>1;U--){const G=_[U]+$e,Z=le[le.length-1];Z&&Z.end===G?Z.end=G+1:le.push({start:G,end:G+1})}return le}e.$uj=O;const N=128;function T(){const _=[],le=[];for(let $e=0;$e<=N;$e++)le[$e]=0;for(let $e=0;$e<=N;$e++)_.push(le.slice(0));return _}function j(_){const le=[];for(let $e=0;$e<=_;$e++)le[$e]=0;return le}const W=j(2*N),M=j(2*N),Y=T(),V=T(),de=T(),re=!1;function x(_,le,$e,U,G){function Z(be,se,we=" "){for(;be.length<se;)be=we+be;return be}let ee=` |   |${U.split("").map(be=>Z(be,3)).join("|")}
`;for(let be=0;be<=$e;be++)be===0?ee+=" |":ee+=`${le[be-1]}|`,ee+=_[be].slice(0,G+1).map(se=>Z(se.toString(),3)).join("|")+`
`;return ee}function q(_,le,$e,U){_=_.substr(le),$e=$e.substr(U),console.log(x(V,_,_.length,$e,$e.length)),console.log(x(de,_,_.length,$e,$e.length)),console.log(x(Y,_,_.length,$e,$e.length))}function ne(_,le){if(le<0||le>=_.length)return!1;const $e=_.codePointAt(le);switch($e){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$6d($e)}}function pe(_,le){if(le<0||le>=_.length)return!1;switch(_.charCodeAt(le)){case 32:case 9:return!0;default:return!1}}function H(_,le,$e){return le[_]!==$e[_]}function ue(_,le,$e,U,G,Z,ee=!1){for(;le<$e&&G<Z;)_[le]===U[G]&&(ee&&(W[le]=G),le+=1),G+=1;return le===$e}e.$vj=ue;var ce;(function(_){_[_.Diag=1]="Diag",_[_.Left=2]="Left",_[_.LeftLeft=3]="LeftLeft"})(ce||(ce={}));var z;(function(_){_.Default=[-100,0];function le($e){return!$e||$e.length===2&&$e[0]===-100&&$e[1]===0}_.isDefault=le})(z||(e.FuzzyScore=z={}));class ie{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(le,$e){this.firstMatchCanBeWeak=le,this.boostFullMatch=$e}}e.$wj=ie;function Ee(_,le,$e,U,G,Z,ee=ie.default){const be=_.length>N?N:_.length,se=U.length>N?N:U.length;if($e>=be||Z>=se||be-$e>se-Z||!ue(le,$e,be,G,Z,se,!0))return;Re(be,se,$e,Z,le,G);let we=1,Ie=1,je=$e,Ve=Z;const _e=[!1];for(we=1,je=$e;je<be;we++,je++){const tt=W[je],Pe=M[je],ke=je+1<be?M[je+1]:se;for(Ie=tt-Z+1,Ve=tt;Ve<ke;Ie++,Ve++){let Be=Number.MIN_SAFE_INTEGER,te=!1;Ve<=Pe&&(Be=ye(_,le,je,$e,U,G,Ve,se,Z,Y[we-1][Ie-1]===0,_e));let Q=0;Be!==Number.MAX_SAFE_INTEGER&&(te=!0,Q=Be+V[we-1][Ie-1]);const ve=Ve>tt,Ue=ve?V[we][Ie-1]+(Y[we][Ie-1]>0?-5:0):0,Ne=Ve>tt+1&&Y[we][Ie-1]>0,Ye=Ne?V[we][Ie-2]+(Y[we][Ie-2]>0?-5:0):0;if(Ne&&(!ve||Ye>=Ue)&&(!te||Ye>=Q))V[we][Ie]=Ye,de[we][Ie]=3,Y[we][Ie]=0;else if(ve&&(!te||Ue>=Q))V[we][Ie]=Ue,de[we][Ie]=2,Y[we][Ie]=0;else if(te)V[we][Ie]=Q,de[we][Ie]=1,Y[we][Ie]=Y[we-1][Ie-1]+1;else throw new Error("not possible")}}if(re&&q(_,$e,U,Z),!_e[0]&&!ee.firstMatchCanBeWeak)return;we--,Ie--;const Ge=[V[we][Ie],Z];let et=0,Qe=0;for(;we>=1;){let tt=Ie;do{const Pe=de[we][tt];if(Pe===3)tt=tt-2;else if(Pe===2)tt=tt-1;else break}while(tt>=1);et>1&&le[$e+we-1]===G[Z+Ie-1]&&!H(tt+Z-1,U,G)&&et+1>Y[we][tt]&&(tt=Ie),tt===Ie?et++:et=1,Qe||(Qe=tt),we--,Ie=tt-1,Ge.push(Ie)}se===be&&ee.boostFullMatch&&(Ge[0]+=2);const st=Qe-be;return Ge[0]-=st,Ge}e.$xj=Ee;function Re(_,le,$e,U,G,Z){let ee=_-1,be=le-1;for(;ee>=$e&&be>=U;)G[ee]===Z[be]&&(M[ee]=be,ee--),be--}function ye(_,le,$e,U,G,Z,ee,be,se,we,Ie){if(le[$e]!==Z[ee])return Number.MIN_SAFE_INTEGER;let je=1,Ve=!1;return ee===$e-U?je=_[$e]===G[ee]?7:5:H(ee,G,Z)&&(ee===0||!H(ee-1,G,Z))?(je=_[$e]===G[ee]?7:5,Ve=!0):ne(Z,ee)&&(ee===0||!ne(Z,ee-1))?je=5:(ne(Z,ee-1)||pe(Z,ee-1))&&(je=5,Ve=!0),je>1&&$e===U&&(Ie[0]=!0),Ve||(Ve=H(ee,G,Z)||ne(Z,ee-1)||pe(Z,ee-1)),$e===U?ee>se&&(je-=Ve?3:5):we?je+=Ve?2:0:je+=Ve?0:1,ee+1===be&&(je-=Ve?3:5),je}function X(_,le,$e,U,G,Z,ee){return K(_,le,$e,U,G,Z,!0,ee)}e.$yj=X;function he(_,le,$e,U,G,Z,ee){return K(_,le,$e,U,G,Z,!1,ee)}e.$zj=he;function K(_,le,$e,U,G,Z,ee,be){let se=Ee(_,le,$e,U,G,Z,be);if(se&&!ee)return se;if(_.length>=3){const we=Math.min(7,_.length-1);for(let Ie=$e+1;Ie<we;Ie++){const je=oe(_,Ie);if(je){const Ve=Ee(je,je.toLowerCase(),$e,U,G,Z,be);Ve&&(Ve[0]-=3,(!se||Ve[0]>se[0])&&(se=Ve))}}}return se}function oe(_,le){if(le+1>=_.length)return;const $e=_[le],U=_[le+1];if($e!==U)return _.slice(0,le)+U+$e+_.slice(le+2)}}),define(Se[70],Ce([1,0,12]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=void 0;function F(s){return h(s,0)}e.$di=F;function h(s,c){switch(typeof s){case"object":return s===null?A(349,c):Array.isArray(s)?E(s,c):b(s,c);case"string":return m(s,c);case"boolean":return P(s,c);case"number":return A(s,c);case"undefined":return A(937,c);default:return A(617,c)}}e.$ei=h;function A(s,c){return(c<<5)-c+s|0}e.$fi=A;function P(s,c){return A(s?433:863,c)}function m(s,c){c=A(149417,c);for(let f=0,y=s.length;f<y;f++)c=A(s.charCodeAt(f),c);return c}e.$gi=m;function E(s,c){return c=A(104579,c),s.reduce((f,y)=>h(y,f),c)}function b(s,c){return c=A(181387,c),Object.keys(s).sort().reduce((f,y)=>(f=m(y,f),h(s[y],f)),c)}class R{constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=h(c,this.g),this.g}}e.$hi=R;var I;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function $(s,c,f=32){const y=f-c,C=~((1<<y)-1);return(s<<c|(C&s)>>>y)>>>0}function D(s,c=0,f=s.byteLength,y=0){for(let C=0;C<f;C++)s[c+C]=y}function S(s,c,f="0"){for(;s.length<c;)s=f+s;return s}function p(s,c=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(f=>f.toString(16).padStart(2,"0")).join(""):S((s>>>0).toString(16),c/4)}e.$ii=p;class r{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const f=c.length;if(f===0)return;const y=this.p;let C=this.r,i=this.u,o,n;for(i!==0?(o=i,n=-1,i=0):(o=c.charCodeAt(0),n=0);;){let t=o;if(k.$Qd(o))if(n+1<f){const a=c.charCodeAt(n+1);k.$Rd(a)?(n++,t=k.$Sd(o,a)):t=65533}else{i=o;break}else k.$Rd(o)&&(t=65533);if(C=this.w(y,C,t),n++,n<f)o=c.charCodeAt(n);else break}this.r=C,this.u=i}w(c,f,y){return y<128?c[f++]=y:y<2048?(c[f++]=192|(y&1984)>>>6,c[f++]=128|(y&63)>>>0):y<65536?(c[f++]=224|(y&61440)>>>12,c[f++]=128|(y&4032)>>>6,c[f++]=128|(y&63)>>>0):(c[f++]=240|(y&1835008)>>>18,c[f++]=128|(y&258048)>>>12,c[f++]=128|(y&4032)>>>6,c[f++]=128|(y&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,D(this.p,this.r),this.r>56&&(this.y(),D(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=r.g,f=this.q;for(let u=0;u<64;u+=4)c.setUint32(u,f.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)c.setUint32(u,$(c.getUint32(u-12,!1)^c.getUint32(u-32,!1)^c.getUint32(u-56,!1)^c.getUint32(u-64,!1),1),!1);let y=this.h,C=this.l,i=this.m,o=this.n,n=this.o,t,a,g;for(let u=0;u<80;u++)u<20?(t=C&i|~C&o,a=1518500249):u<40?(t=C^i^o,a=1859775393):u<60?(t=C&i|C&o|i&o,a=2400959708):(t=C^i^o,a=3395469782),g=$(y,5)+t+n+a+c.getUint32(u*4,!1)&4294967295,n=o,o=i,i=$(C,30),C=y,y=g;this.h=this.h+y&4294967295,this.l=this.l+C&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$ji=r}),define(Se[40],Ce([1,0,12]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(h){h[h.Ignore=0]="Ignore",h[h.Info=1]="Info",h[h.Warning=2]="Warning",h[h.Error=3]="Error"})(F||(F={})),function(h){const A="error",P="warning",m="warn",E="info",b="ignore";function R($){return $?k.$Md(A,$)?h.Error:k.$Md(P,$)||k.$Md(m,$)?h.Warning:k.$Md(E,$)?h.Info:h.Ignore:h.Ignore}h.fromValue=R;function I($){switch($){case h.Error:return A;case h.Warning:return P;case h.Info:return E;default:return b}}h.toString=I}(F||(F={})),e.default=F}),define(Se[154],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0,e.$5c=Symbol("MicrotaskDelay")}),define(Se[71],Ce([1,0,19,12]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=void 0;class h{constructor(){this.b="",this.c=0}reset(D){return this.b=D,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(D){const S=D.charCodeAt(0),p=this.b.charCodeAt(this.c);return S-p}value(){return this.b[this.c]}}e.$rh=h;class A{constructor(D=!0){this.e=D}reset(D){return this.b=D,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let D=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(D)this.c++;else break;else D=!1;return this}cmp(D){return this.e?(0,F.$Gd)(D,this.b,0,D.length,this.c,this.d):(0,F.$Id)(D,this.b,0,D.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$sh=A;class P{constructor(D=!0,S=!0){this.f=D,this.g=S}reset(D){this.d=0,this.e=0,this.b=D,this.c=D.length;for(let S=D.length-1;S>=0;S--,this.c--){const p=this.b.charCodeAt(S);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let D=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(D)this.d++;else break;else D=!1}return this}cmp(D){return this.g?(0,F.$Gd)(D,this.b,0,D.length,this.d,this.e):(0,F.$Id)(D,this.b,0,D.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$th=P;var m;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(m||(m={}));class E{constructor(D,S){this.f=D,this.g=S,this.d=[],this.e=0}reset(D){return this.c=D,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f(D)),this.b.reset(D.path),this.b.value()&&this.d.push(3)),this.g(D)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(D){if(this.d[this.e]===1)return(0,F.$Hd)(D,this.c.scheme);if(this.d[this.e]===2)return(0,F.$Hd)(D,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(D);if(this.d[this.e]===4)return(0,F.$Fd)(D,this.c.query);if(this.d[this.e]===5)return(0,F.$Fd)(D,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$uh=E;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const D=this.right;return this.right=D.left,D.left=this,this.updateHeight(),D.updateHeight(),D}rotateRight(){const D=this.left;return this.left=D.right,D.right=this,this.updateHeight(),D.updateHeight(),D}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(R||(R={}));class I{static forUris(D=()=>!1,S=()=>!1){return new I(new E(D,S))}static forPaths(D=!1){return new I(new P(void 0,!D))}static forStrings(){return new I(new h)}static forConfigKeys(){return new I(new A)}constructor(D){this.b=D}clear(){this.c=void 0}fill(D,S){if(S){const p=S.slice(0);(0,k.$Ef)(p);for(const r of p)this.set(r,D)}else{const p=D.slice(0);(0,k.$Ef)(p);for(const r of p)this.set(r[0],r[1])}}set(D,S){const p=this.b.reset(D);let r;this.c||(this.c=new b,this.c.segment=p.value());const s=[];for(r=this.c;;){const f=p.cmp(r.segment);if(f>0)r.left||(r.left=new b,r.left.segment=p.value()),s.push([-1,r]),r=r.left;else if(f<0)r.right||(r.right=new b,r.right.segment=p.value()),s.push([1,r]),r=r.right;else if(p.hasNext())p.next(),r.mid||(r.mid=new b,r.mid.segment=p.value()),s.push([0,r]),r=r.mid;else break}const c=r.value;r.value=S,r.key=D;for(let f=s.length-1;f>=0;f--){const y=s[f][1];y.updateHeight();const C=y.balanceFactor();if(C<-1||C>1){const i=s[f][0],o=s[f+1][0];if(i===1&&o===1)s[f][1]=y.rotateLeft();else if(i===-1&&o===-1)s[f][1]=y.rotateRight();else if(i===1&&o===-1)y.right=s[f+1][1]=s[f+1][1].rotateRight(),s[f][1]=y.rotateLeft();else if(i===-1&&o===1)y.left=s[f+1][1]=s[f+1][1].rotateLeft(),s[f][1]=y.rotateRight();else throw new Error;if(f>0)switch(s[f-1][0]){case-1:s[f-1][1].left=s[f][1];break;case 1:s[f-1][1].right=s[f][1];break;case 0:s[f-1][1].mid=s[f][1];break}else this.c=s[0][1]}}return c}get(D){return this.d(D)?.value}d(D){const S=this.b.reset(D);let p=this.c;for(;p;){const r=S.cmp(p.segment);if(r>0)p=p.left;else if(r<0)p=p.right;else if(S.hasNext())S.next(),p=p.mid;else break}return p}has(D){const S=this.d(D);return!(S?.value===void 0&&S?.mid===void 0)}delete(D){return this.e(D,!1)}deleteSuperstr(D){return this.e(D,!0)}e(D,S){const p=this.b.reset(D),r=[];let s=this.c;for(;s;){const c=p.cmp(s.segment);if(c>0)r.push([-1,s]),s=s.left;else if(c<0)r.push([1,s]),s=s.right;else if(p.hasNext())p.next(),r.push([0,s]),s=s.mid;else break}if(s){if(S?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const c=this.f(s.right);if(c.key){const{key:f,value:y,segment:C}=c;this.e(c.key,!1),s.key=f,s.value=y,s.segment=C}}else{const c=s.left??s.right;if(r.length>0){const[f,y]=r[r.length-1];switch(f){case-1:y.left=c;break;case 0:y.mid=c;break;case 1:y.right=c;break}}else this.c=c}for(let c=r.length-1;c>=0;c--){const f=r[c][1];f.updateHeight();const y=f.balanceFactor();if(y>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),r[c][1]=f.rotateLeft()):y<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),r[c][1]=f.rotateRight()),c>0)switch(r[c-1][0]){case-1:r[c-1][1].left=r[c][1];break;case 1:r[c-1][1].right=r[c][1];break;case 0:r[c-1][1].mid=r[c][1];break}else this.c=r[0][1]}}}f(D){for(;D.left;)D=D.left;return D}findSubstr(D){const S=this.b.reset(D);let p=this.c,r;for(;p;){const s=S.cmp(p.segment);if(s>0)p=p.left;else if(s<0)p=p.right;else if(S.hasNext())S.next(),r=p.value||r,p=p.mid;else break}return p&&p.value||r}findSuperstr(D){return this.g(D,!1)}g(D,S){const p=this.b.reset(D);let r=this.c;for(;r;){const s=p.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(p.hasNext())p.next(),r=r.mid;else return r.mid?this.h(r.mid):S?r.value:void 0}}hasElementOrSubtree(D){return this.g(D,!0)!==void 0}forEach(D){for(const[S,p]of this)D(p,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(D){const S=[];return this.j(D,S),S[Symbol.iterator]()}j(D,S){D&&(D.left&&this.j(D.left,S),D.value&&S.push([D.key,D.value]),D.mid&&this.j(D.mid,S),D.right&&this.j(D.right,S))}_isBalanced(){const D=S=>{if(!S)return!0;const p=S.balanceFactor();return p<-1||p>1?!1:D(S.left)&&D(S.right)};return D(this.c)}}e.$vh=I}),define(Se[14],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;function k(o){return typeof o=="string"}e.$je=k;function F(o){return Array.isArray(o)&&o.every(n=>k(n))}e.$ke=F;function h(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.$le=h;function A(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}e.$me=A;function P(o){return typeof o=="number"&&!isNaN(o)}e.$ne=P;function m(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.$oe=m;function E(o){return o===!0||o===!1}e.$pe=E;function b(o){return typeof o>"u"}e.$qe=b;function R(o){return!I(o)}e.$re=R;function I(o){return b(o)||o===null}e.$se=I;function $(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.$te=$;function D(o){if(I(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.$ue=D;function S(...o){const n=[];for(let t=0;t<o.length;t++){const a=o[t];if(I(a))throw new Error(`Assertion Failed: argument at index ${t} is undefined or null`);n.push(a)}return n}e.$ve=S;const p=Object.prototype.hasOwnProperty;function r(o){if(!h(o))return!1;for(const n in o)if(p.call(o,n))return!1;return!0}e.$we=r;function s(o){return typeof o=="function"}e.$xe=s;function c(...o){return o.length>0&&o.every(s)}e.$ye=c;function f(o,n){const t=Math.min(o.length,n.length);for(let a=0;a<t;a++)y(o[a],n[a])}e.$ze=f;function y(o,n){if(k(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(s(n)){try{if(o instanceof n)return}catch{}if(!I(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Ae=y;function C(o){return o===null?void 0:o}e.$Be=C;function i(o){return typeof o>"u"?null:o}e.$Ce=i}),define(Se[72],Ce([1,0,14]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=e.$Aj=void 0;const F=Object.create(null);function h(m,E){if((0,k.$je)(E)){const b=F[E];if(b===void 0)throw new Error(`${m} references an unknown codicon: ${E}`);E=b}return F[m]=E,{id:m}}function A(){return F}e.$Aj=A;function P(){return Object.values(e.$Cj)}e.$Bj=P,e.$Cj={add:h("add",6e4),plus:h("plus",6e4),gistNew:h("gist-new",6e4),repoCreate:h("repo-create",6e4),lightbulb:h("lightbulb",60001),lightBulb:h("light-bulb",60001),repo:h("repo",60002),repoDelete:h("repo-delete",60002),gistFork:h("gist-fork",60003),repoForked:h("repo-forked",60003),gitPullRequest:h("git-pull-request",60004),gitPullRequestAbandoned:h("git-pull-request-abandoned",60004),recordKeys:h("record-keys",60005),keyboard:h("keyboard",60005),tag:h("tag",60006),tagAdd:h("tag-add",60006),tagRemove:h("tag-remove",60006),gitPullRequestLabel:h("git-pull-request-label",60006),person:h("person",60007),personFollow:h("person-follow",60007),personOutline:h("person-outline",60007),personFilled:h("person-filled",60007),gitBranch:h("git-branch",60008),gitBranchCreate:h("git-branch-create",60008),gitBranchDelete:h("git-branch-delete",60008),sourceControl:h("source-control",60008),mirror:h("mirror",60009),mirrorPublic:h("mirror-public",60009),star:h("star",60010),starAdd:h("star-add",60010),starDelete:h("star-delete",60010),starEmpty:h("star-empty",60010),comment:h("comment",60011),commentAdd:h("comment-add",60011),alert:h("alert",60012),warning:h("warning",60012),search:h("search",60013),searchSave:h("search-save",60013),logOut:h("log-out",60014),signOut:h("sign-out",60014),logIn:h("log-in",60015),signIn:h("sign-in",60015),eye:h("eye",60016),eyeUnwatch:h("eye-unwatch",60016),eyeWatch:h("eye-watch",60016),circleFilled:h("circle-filled",60017),primitiveDot:h("primitive-dot",60017),closeDirty:h("close-dirty",60017),debugBreakpoint:h("debug-breakpoint",60017),debugBreakpointDisabled:h("debug-breakpoint-disabled",60017),debugHint:h("debug-hint",60017),primitiveSquare:h("primitive-square",60018),edit:h("edit",60019),pencil:h("pencil",60019),info:h("info",60020),issueOpened:h("issue-opened",60020),gistPrivate:h("gist-private",60021),gitForkPrivate:h("git-fork-private",60021),lock:h("lock",60021),mirrorPrivate:h("mirror-private",60021),close:h("close",60022),removeClose:h("remove-close",60022),x:h("x",60022),repoSync:h("repo-sync",60023),sync:h("sync",60023),clone:h("clone",60024),desktopDownload:h("desktop-download",60024),beaker:h("beaker",60025),microscope:h("microscope",60025),vm:h("vm",60026),deviceDesktop:h("device-desktop",60026),file:h("file",60027),fileText:h("file-text",60027),more:h("more",60028),ellipsis:h("ellipsis",60028),kebabHorizontal:h("kebab-horizontal",60028),mailReply:h("mail-reply",60029),reply:h("reply",60029),organization:h("organization",60030),organizationFilled:h("organization-filled",60030),organizationOutline:h("organization-outline",60030),newFile:h("new-file",60031),fileAdd:h("file-add",60031),newFolder:h("new-folder",60032),fileDirectoryCreate:h("file-directory-create",60032),trash:h("trash",60033),trashcan:h("trashcan",60033),history:h("history",60034),clock:h("clock",60034),folder:h("folder",60035),fileDirectory:h("file-directory",60035),symbolFolder:h("symbol-folder",60035),logoGithub:h("logo-github",60036),markGithub:h("mark-github",60036),github:h("github",60036),terminal:h("terminal",60037),console:h("console",60037),repl:h("repl",60037),zap:h("zap",60038),symbolEvent:h("symbol-event",60038),error:h("error",60039),stop:h("stop",60039),variable:h("variable",60040),symbolVariable:h("symbol-variable",60040),array:h("array",60042),symbolArray:h("symbol-array",60042),symbolModule:h("symbol-module",60043),symbolPackage:h("symbol-package",60043),symbolNamespace:h("symbol-namespace",60043),symbolObject:h("symbol-object",60043),symbolMethod:h("symbol-method",60044),symbolFunction:h("symbol-function",60044),symbolConstructor:h("symbol-constructor",60044),symbolBoolean:h("symbol-boolean",60047),symbolNull:h("symbol-null",60047),symbolNumeric:h("symbol-numeric",60048),symbolNumber:h("symbol-number",60048),symbolStructure:h("symbol-structure",60049),symbolStruct:h("symbol-struct",60049),symbolParameter:h("symbol-parameter",60050),symbolTypeParameter:h("symbol-type-parameter",60050),symbolKey:h("symbol-key",60051),symbolText:h("symbol-text",60051),symbolReference:h("symbol-reference",60052),goToFile:h("go-to-file",60052),symbolEnum:h("symbol-enum",60053),symbolValue:h("symbol-value",60053),symbolRuler:h("symbol-ruler",60054),symbolUnit:h("symbol-unit",60054),activateBreakpoints:h("activate-breakpoints",60055),archive:h("archive",60056),arrowBoth:h("arrow-both",60057),arrowDown:h("arrow-down",60058),arrowLeft:h("arrow-left",60059),arrowRight:h("arrow-right",60060),arrowSmallDown:h("arrow-small-down",60061),arrowSmallLeft:h("arrow-small-left",60062),arrowSmallRight:h("arrow-small-right",60063),arrowSmallUp:h("arrow-small-up",60064),arrowUp:h("arrow-up",60065),bell:h("bell",60066),bold:h("bold",60067),book:h("book",60068),bookmark:h("bookmark",60069),debugBreakpointConditionalUnverified:h("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:h("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:h("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:h("debug-breakpoint-data-unverified",60072),debugBreakpointData:h("debug-breakpoint-data",60073),debugBreakpointDataDisabled:h("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:h("debug-breakpoint-log-unverified",60074),debugBreakpointLog:h("debug-breakpoint-log",60075),debugBreakpointLogDisabled:h("debug-breakpoint-log-disabled",60075),briefcase:h("briefcase",60076),broadcast:h("broadcast",60077),browser:h("browser",60078),bug:h("bug",60079),calendar:h("calendar",60080),caseSensitive:h("case-sensitive",60081),check:h("check",60082),checklist:h("checklist",60083),chevronDown:h("chevron-down",60084),dropDownButton:h("drop-down-button",60084),chevronLeft:h("chevron-left",60085),chevronRight:h("chevron-right",60086),chevronUp:h("chevron-up",60087),chromeClose:h("chrome-close",60088),chromeMaximize:h("chrome-maximize",60089),chromeMinimize:h("chrome-minimize",60090),chromeRestore:h("chrome-restore",60091),circle:h("circle",60092),circleOutline:h("circle-outline",60092),debugBreakpointUnverified:h("debug-breakpoint-unverified",60092),circleSlash:h("circle-slash",60093),circuitBoard:h("circuit-board",60094),clearAll:h("clear-all",60095),clippy:h("clippy",60096),closeAll:h("close-all",60097),cloudDownload:h("cloud-download",60098),cloudUpload:h("cloud-upload",60099),code:h("code",60100),collapseAll:h("collapse-all",60101),colorMode:h("color-mode",60102),commentDiscussion:h("comment-discussion",60103),compareChanges:h("compare-changes",60157),creditCard:h("credit-card",60105),dash:h("dash",60108),dashboard:h("dashboard",60109),database:h("database",60110),debugContinue:h("debug-continue",60111),debugDisconnect:h("debug-disconnect",60112),debugPause:h("debug-pause",60113),debugRestart:h("debug-restart",60114),debugStart:h("debug-start",60115),debugStepInto:h("debug-step-into",60116),debugStepOut:h("debug-step-out",60117),debugStepOver:h("debug-step-over",60118),debugStop:h("debug-stop",60119),debug:h("debug",60120),deviceCameraVideo:h("device-camera-video",60121),deviceCamera:h("device-camera",60122),deviceMobile:h("device-mobile",60123),diffAdded:h("diff-added",60124),diffIgnored:h("diff-ignored",60125),diffModified:h("diff-modified",60126),diffRemoved:h("diff-removed",60127),diffRenamed:h("diff-renamed",60128),diff:h("diff",60129),discard:h("discard",60130),editorLayout:h("editor-layout",60131),emptyWindow:h("empty-window",60132),exclude:h("exclude",60133),extensions:h("extensions",60134),eyeClosed:h("eye-closed",60135),fileBinary:h("file-binary",60136),fileCode:h("file-code",60137),fileMedia:h("file-media",60138),filePdf:h("file-pdf",60139),fileSubmodule:h("file-submodule",60140),fileSymlinkDirectory:h("file-symlink-directory",60141),fileSymlinkFile:h("file-symlink-file",60142),fileZip:h("file-zip",60143),files:h("files",60144),filter:h("filter",60145),flame:h("flame",60146),foldDown:h("fold-down",60147),foldUp:h("fold-up",60148),fold:h("fold",60149),folderActive:h("folder-active",60150),folderOpened:h("folder-opened",60151),gear:h("gear",60152),gift:h("gift",60153),gistSecret:h("gist-secret",60154),gist:h("gist",60155),gitCommit:h("git-commit",60156),gitCompare:h("git-compare",60157),gitMerge:h("git-merge",60158),githubAction:h("github-action",60159),githubAlt:h("github-alt",60160),globe:h("globe",60161),grabber:h("grabber",60162),graph:h("graph",60163),gripper:h("gripper",60164),heart:h("heart",60165),home:h("home",60166),horizontalRule:h("horizontal-rule",60167),hubot:h("hubot",60168),inbox:h("inbox",60169),issueClosed:h("issue-closed",60324),issueReopened:h("issue-reopened",60171),issues:h("issues",60172),italic:h("italic",60173),jersey:h("jersey",60174),json:h("json",60175),bracket:h("bracket",60175),kebabVertical:h("kebab-vertical",60176),key:h("key",60177),law:h("law",60178),lightbulbAutofix:h("lightbulb-autofix",60179),linkExternal:h("link-external",60180),link:h("link",60181),listOrdered:h("list-ordered",60182),listUnordered:h("list-unordered",60183),liveShare:h("live-share",60184),loading:h("loading",60185),location:h("location",60186),mailRead:h("mail-read",60187),mail:h("mail",60188),markdown:h("markdown",60189),megaphone:h("megaphone",60190),mention:h("mention",60191),milestone:h("milestone",60192),gitPullRequestMilestone:h("git-pull-request-milestone",60192),mortarBoard:h("mortar-board",60193),move:h("move",60194),multipleWindows:h("multiple-windows",60195),mute:h("mute",60196),noNewline:h("no-newline",60197),note:h("note",60198),octoface:h("octoface",60199),openPreview:h("open-preview",60200),package_:h("package",60201),paintcan:h("paintcan",60202),pin:h("pin",60203),play:h("play",60204),run:h("run",60204),plug:h("plug",60205),preserveCase:h("preserve-case",60206),preview:h("preview",60207),project:h("project",60208),pulse:h("pulse",60209),question:h("question",60210),quote:h("quote",60211),radioTower:h("radio-tower",60212),reactions:h("reactions",60213),references:h("references",60214),refresh:h("refresh",60215),regex:h("regex",60216),remoteExplorer:h("remote-explorer",60217),remote:h("remote",60218),remove:h("remove",60219),replaceAll:h("replace-all",60220),replace:h("replace",60221),repoClone:h("repo-clone",60222),repoForcePush:h("repo-force-push",60223),repoPull:h("repo-pull",60224),repoPush:h("repo-push",60225),report:h("report",60226),requestChanges:h("request-changes",60227),rocket:h("rocket",60228),rootFolderOpened:h("root-folder-opened",60229),rootFolder:h("root-folder",60230),rss:h("rss",60231),ruby:h("ruby",60232),saveAll:h("save-all",60233),saveAs:h("save-as",60234),save:h("save",60235),screenFull:h("screen-full",60236),screenNormal:h("screen-normal",60237),searchStop:h("search-stop",60238),server:h("server",60240),settingsGear:h("settings-gear",60241),settings:h("settings",60242),shield:h("shield",60243),smiley:h("smiley",60244),sortPrecedence:h("sort-precedence",60245),splitHorizontal:h("split-horizontal",60246),splitVertical:h("split-vertical",60247),squirrel:h("squirrel",60248),starFull:h("star-full",60249),starHalf:h("star-half",60250),symbolClass:h("symbol-class",60251),symbolColor:h("symbol-color",60252),symbolCustomColor:h("symbol-customcolor",60252),symbolConstant:h("symbol-constant",60253),symbolEnumMember:h("symbol-enum-member",60254),symbolField:h("symbol-field",60255),symbolFile:h("symbol-file",60256),symbolInterface:h("symbol-interface",60257),symbolKeyword:h("symbol-keyword",60258),symbolMisc:h("symbol-misc",60259),symbolOperator:h("symbol-operator",60260),symbolProperty:h("symbol-property",60261),wrench:h("wrench",60261),wrenchSubaction:h("wrench-subaction",60261),symbolSnippet:h("symbol-snippet",60262),tasklist:h("tasklist",60263),telescope:h("telescope",60264),textSize:h("text-size",60265),threeBars:h("three-bars",60266),thumbsdown:h("thumbsdown",60267),thumbsup:h("thumbsup",60268),tools:h("tools",60269),triangleDown:h("triangle-down",60270),triangleLeft:h("triangle-left",60271),triangleRight:h("triangle-right",60272),triangleUp:h("triangle-up",60273),twitter:h("twitter",60274),unfold:h("unfold",60275),unlock:h("unlock",60276),unmute:h("unmute",60277),unverified:h("unverified",60278),verified:h("verified",60279),versions:h("versions",60280),vmActive:h("vm-active",60281),vmOutline:h("vm-outline",60282),vmRunning:h("vm-running",60283),watch:h("watch",60284),whitespace:h("whitespace",60285),wholeWord:h("whole-word",60286),window:h("window",60287),wordWrap:h("word-wrap",60288),zoomIn:h("zoom-in",60289),zoomOut:h("zoom-out",60290),listFilter:h("list-filter",60291),listFlat:h("list-flat",60292),listSelection:h("list-selection",60293),selection:h("selection",60293),listTree:h("list-tree",60294),debugBreakpointFunctionUnverified:h("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:h("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:h("debug-breakpoint-function-disabled",60296),debugStackframeActive:h("debug-stackframe-active",60297),circleSmallFilled:h("circle-small-filled",60298),debugStackframeDot:h("debug-stackframe-dot",60298),debugStackframe:h("debug-stackframe",60299),debugStackframeFocused:h("debug-stackframe-focused",60299),debugBreakpointUnsupported:h("debug-breakpoint-unsupported",60300),symbolString:h("symbol-string",60301),debugReverseContinue:h("debug-reverse-continue",60302),debugStepBack:h("debug-step-back",60303),debugRestartFrame:h("debug-restart-frame",60304),callIncoming:h("call-incoming",60306),callOutgoing:h("call-outgoing",60307),menu:h("menu",60308),expandAll:h("expand-all",60309),feedback:h("feedback",60310),gitPullRequestReviewer:h("git-pull-request-reviewer",60310),groupByRefType:h("group-by-ref-type",60311),ungroupByRefType:h("ungroup-by-ref-type",60312),account:h("account",60313),gitPullRequestAssignee:h("git-pull-request-assignee",60313),bellDot:h("bell-dot",60314),debugConsole:h("debug-console",60315),library:h("library",60316),output:h("output",60317),runAll:h("run-all",60318),syncIgnored:h("sync-ignored",60319),pinned:h("pinned",60320),githubInverted:h("github-inverted",60321),debugAlt:h("debug-alt",60305),serverProcess:h("server-process",60322),serverEnvironment:h("server-environment",60323),pass:h("pass",60324),stopCircle:h("stop-circle",60325),playCircle:h("play-circle",60326),record:h("record",60327),debugAltSmall:h("debug-alt-small",60328),vmConnect:h("vm-connect",60329),cloud:h("cloud",60330),merge:h("merge",60331),exportIcon:h("export",60332),graphLeft:h("graph-left",60333),magnet:h("magnet",60334),notebook:h("notebook",60335),redo:h("redo",60336),checkAll:h("check-all",60337),pinnedDirty:h("pinned-dirty",60338),passFilled:h("pass-filled",60339),circleLargeFilled:h("circle-large-filled",60340),circleLarge:h("circle-large",60341),circleLargeOutline:h("circle-large-outline",60341),combine:h("combine",60342),gather:h("gather",60342),table:h("table",60343),variableGroup:h("variable-group",60344),typeHierarchy:h("type-hierarchy",60345),typeHierarchySub:h("type-hierarchy-sub",60346),typeHierarchySuper:h("type-hierarchy-super",60347),gitPullRequestCreate:h("git-pull-request-create",60348),runAbove:h("run-above",60349),runBelow:h("run-below",60350),notebookTemplate:h("notebook-template",60351),debugRerun:h("debug-rerun",60352),workspaceTrusted:h("workspace-trusted",60353),workspaceUntrusted:h("workspace-untrusted",60354),workspaceUnspecified:h("workspace-unspecified",60355),terminalCmd:h("terminal-cmd",60356),terminalDebian:h("terminal-debian",60357),terminalLinux:h("terminal-linux",60358),terminalPowershell:h("terminal-powershell",60359),terminalTmux:h("terminal-tmux",60360),terminalUbuntu:h("terminal-ubuntu",60361),terminalBash:h("terminal-bash",60362),arrowSwap:h("arrow-swap",60363),copy:h("copy",60364),personAdd:h("person-add",60365),filterFilled:h("filter-filled",60366),wand:h("wand",60367),debugLineByLine:h("debug-line-by-line",60368),inspect:h("inspect",60369),layers:h("layers",60370),layersDot:h("layers-dot",60371),layersActive:h("layers-active",60372),compass:h("compass",60373),compassDot:h("compass-dot",60374),compassActive:h("compass-active",60375),azure:h("azure",60376),issueDraft:h("issue-draft",60377),gitPullRequestClosed:h("git-pull-request-closed",60378),gitPullRequestDraft:h("git-pull-request-draft",60379),debugAll:h("debug-all",60380),debugCoverage:h("debug-coverage",60381),runErrors:h("run-errors",60382),folderLibrary:h("folder-library",60383),debugContinueSmall:h("debug-continue-small",60384),beakerStop:h("beaker-stop",60385),graphLine:h("graph-line",60386),graphScatter:h("graph-scatter",60387),pieChart:h("pie-chart",60388),bracketDot:h("bracket-dot",60389),bracketError:h("bracket-error",60390),lockSmall:h("lock-small",60391),azureDevops:h("azure-devops",60392),verifiedFilled:h("verified-filled",60393),newLine:h("newline",60394),layout:h("layout",60395),layoutActivitybarLeft:h("layout-activitybar-left",60396),layoutActivitybarRight:h("layout-activitybar-right",60397),layoutPanelLeft:h("layout-panel-left",60398),layoutPanelCenter:h("layout-panel-center",60399),layoutPanelJustify:h("layout-panel-justify",60400),layoutPanelRight:h("layout-panel-right",60401),layoutPanel:h("layout-panel",60402),layoutSidebarLeft:h("layout-sidebar-left",60403),layoutSidebarRight:h("layout-sidebar-right",60404),layoutStatusbar:h("layout-statusbar",60405),layoutMenubar:h("layout-menubar",60406),layoutCentered:h("layout-centered",60407),layoutSidebarRightOff:h("layout-sidebar-right-off",60416),layoutPanelOff:h("layout-panel-off",60417),layoutSidebarLeftOff:h("layout-sidebar-left-off",60418),target:h("target",60408),indent:h("indent",60409),recordSmall:h("record-small",60410),errorSmall:h("error-small",60411),arrowCircleDown:h("arrow-circle-down",60412),arrowCircleLeft:h("arrow-circle-left",60413),arrowCircleRight:h("arrow-circle-right",60414),arrowCircleUp:h("arrow-circle-up",60415),heartFilled:h("heart-filled",60420),map:h("map",60421),mapFilled:h("map-filled",60422),circleSmall:h("circle-small",60423),bellSlash:h("bell-slash",60424),bellSlashDot:h("bell-slash-dot",60425),commentUnresolved:h("comment-unresolved",60426),gitPullRequestGoToChanges:h("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:h("git-pull-request-new-changes",60428),searchFuzzy:h("search-fuzzy",60429),commentDraft:h("comment-draft",60430),send:h("send",60431),sparkle:h("sparkle",60432),insert:h("insert",60433),dialogError:h("dialog-error","error"),dialogWarning:h("dialog-warning","warning"),dialogInfo:h("dialog-info","info"),dialogClose:h("dialog-close","close"),treeItemExpanded:h("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:h("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:h("tree-filter-on-type-off","list-selection"),treeFilterClear:h("tree-filter-clear","close"),treeItemLoading:h("tree-item-loading","loading"),menuSelection:h("menu-selection","check"),menuSubmenu:h("menu-submenu","chevron-right"),menuBarMore:h("menubar-more","more"),scrollbarButtonLeft:h("scrollbar-button-left","triangle-left"),scrollbarButtonRight:h("scrollbar-button-right","triangle-right"),scrollbarButtonUp:h("scrollbar-button-up","triangle-up"),scrollbarButtonDown:h("scrollbar-button-down","triangle-down"),toolBarMore:h("toolbar-more","more"),quickInputBack:h("quick-input-back","arrow-left")}}),define(Se[23],Ce([1,0,14]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=void 0;function F(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const c=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([f,y])=>{c[f]=y&&typeof y=="object"?F(y):y}),c}e.$Hm=F;function h(s){if(!s||typeof s!="object")return s;const c=[s];for(;c.length>0;){const f=c.shift();Object.freeze(f);for(const y in f)if(A.call(f,y)){const C=f[y];typeof C=="object"&&!Object.isFrozen(C)&&!(0,k.$me)(C)&&c.push(C)}}return s}e.$Im=h;const A=Object.prototype.hasOwnProperty;function P(s,c){return m(s,c,new Set)}e.$Jm=P;function m(s,c,f){if((0,k.$se)(s))return s;const y=c(s);if(typeof y<"u")return y;if(Array.isArray(s)){const C=[];for(const i of s)C.push(m(i,c,f));return C}if((0,k.$le)(s)){if(f.has(s))throw new Error("Cannot clone recursive data-structure");f.add(s);const C={};for(const i in s)A.call(s,i)&&(C[i]=m(s[i],c,f));return f.delete(s),C}return s}function E(s,c,f=!0){return(0,k.$le)(s)?((0,k.$le)(c)&&Object.keys(c).forEach(y=>{y in s?f&&((0,k.$le)(s[y])&&(0,k.$le)(c[y])?E(s[y],c[y],f):s[y]=c[y]):s[y]=c[y]}),s):c}e.$Km=E;function b(s,c){if(s===c)return!0;if(s==null||c===null||c===void 0||typeof s!=typeof c||typeof s!="object"||Array.isArray(s)!==Array.isArray(c))return!1;let f,y;if(Array.isArray(s)){if(s.length!==c.length)return!1;for(f=0;f<s.length;f++)if(!b(s[f],c[f]))return!1}else{const C=[];for(y in s)C.push(y);C.sort();const i=[];for(y in c)i.push(y);if(i.sort(),!b(C,i))return!1;for(f=0;f<C.length;f++)if(!b(s[C[f]],c[C[f]]))return!1}return!0}e.$Lm=b;function R(s){const c=new Set;return JSON.stringify(s,(f,y)=>{if((0,k.$le)(y)||Array.isArray(y)){if(c.has(y))return"[Circular]";c.add(y)}return y})}e.$Mm=R;function I(s,c){const f=Object.create(null);return!s||!c||Object.keys(c).forEach(C=>{const i=s[C],o=c[C];b(i,o)||(f[C]=o)}),f}e.$Nm=I;function $(s,c){const f=c.toLowerCase(),y=Object.keys(s).find(C=>C.toLowerCase()===f);return y?s[y]:s[c]}e.$Om=$;function D(s,c){const f=Object.create(null);for(const[y,C]of Object.entries(s))c(y,C)&&(f[y]=C);return f}e.$Pm=D;function S(s){let c=[];for(;Object.prototype!==s;)c=c.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return c}e.$Qm=S;function p(s){const c=[];for(const f of S(s))typeof s[f]=="function"&&c.push(f);return c}e.$Rm=p;function r(s,c){const f=C=>function(){const i=Array.prototype.slice.call(arguments,0);return c(C,i)},y={};for(const C of s)y[C]=f(C);return y}e.$Sm=r}),define(Se[55],Ce([1,0,72]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Dj=e.ThemeColor=void 0;var F;(function(P){function m(E){return E&&typeof E=="object"&&typeof E.id=="string"}P.isThemeColor=m})(F||(e.ThemeColor=F={}));function h(P){return{id:P}}e.$Dj=h;var A;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function E(c){const f=m.exec(c.id);if(!f)return E(k.$Cj.error);const[,y,C]=f,i=["codicon","codicon-"+y];return C&&i.push("codicon-modifier-"+C.substring(1)),i}P.asClassNameArray=E;function b(c){return E(c).join(" ")}P.asClassName=b;function R(c){return"."+E(c).join(".")}P.asCSSSelector=R;function I(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||F.isThemeColor(c.color))}P.isThemeIcon=I;const $=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function D(c){const f=$.exec(c);if(!f)return;const[,y]=f;return{id:y}}P.fromString=D;function S(c){return{id:c}}P.fromId=S;function p(c,f){let y=c.id;const C=y.lastIndexOf("~");return C!==-1&&(y=y.substring(0,C)),f&&(y=`${y}~${f}`),{id:y}}P.modify=p;function r(c){const f=c.id.lastIndexOf("~");if(f!==-1)return c.id.substring(f+1)}P.getModifier=r;function s(c,f){return c.id===f.id&&c.color?.id===f.color?.id}P.isEqual=s})(A||(e.ThemeIcon=A={}))}),define(Se[155],Ce([1,0,113,12,55]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=void 0;const A="$(",P=new RegExp(`\\$\\(${h.ThemeIcon.iconNameExpression}(?:${h.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${P.source}`,"g");function E(s){return s.replace(m,(c,f)=>f?c:`\\${c}`)}e.$Ej=E;const b=new RegExp(`\\\\${P.source}`,"g");function R(s){return s.replace(b,c=>`\\${c}`)}e.$Fj=R;const I=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function $(s){return s.indexOf(A)===-1?s:s.replace(I,(c,f,y,C)=>y?c:f||C||"")}e.$Gj=$;function D(s){return s?s.replace(/\$\((.*?)\)/g,(c,f)=>` ${f} `).trim():""}e.$Hj=D;const S=new RegExp(`\\$\\(${h.ThemeIcon.iconNameCharacter}+\\)`,"g");function p(s){S.lastIndex=0;let c="";const f=[];let y=0;for(;;){const C=S.lastIndex,i=S.exec(s),o=s.substring(C,i?.index);if(o.length>0){c+=o;for(let n=0;n<o.length;n++)f.push(y)}if(!i)break;y+=i[0].length}return{text:c,iconOffsets:f}}e.$Ij=p;function r(s,c,f=!1){const{text:y,iconOffsets:C}=c;if(!C||C.length===0)return(0,k.$rj)(s,y,f);const i=(0,F.$sd)(y," "),o=y.length-i.length,n=(0,k.$rj)(s,i,f);if(n)for(const t of n){const a=C[t.start+o]+o;t.start+=a,t.end+=a}return n}e.$Jj=r}),define(Se[114],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jd=e.$id=e.Constants=void 0;var k;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(k||(e.Constants=k={}));function F(A){return A<0?0:A>255?255:A|0}e.$id=F;function h(A){return A<0?0:A>4294967295?4294967295:A|0}e.$jd=h}),define(Se[32],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(h){return k.test(h)}e.$5e=F,e.$6e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let h;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?h=crypto.getRandomValues.bind(crypto):h=function(m){for(let E=0;E<m.length;E++)m[E]=Math.floor(Math.random()*256);return m};const A=new Uint8Array(16),P=[];for(let m=0;m<256;m++)P.push(m.toString(16).padStart(2,"0"));return function(){h(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let E=0,b="";return b+=P[A[E++]],b+=P[A[E++]],b+=P[A[E++]],b+=P[A[E++]],b+="-",b+=P[A[E++]],b+=P[A[E++]],b+="-",b+=P[A[E++]],b+=P[A[E++]],b+="-",b+=P[A[E++]],b+=P[A[E++]],b+="-",b+=P[A[E++]],b+=P[A[E++]],b+=P[A[E++]],b+=P[A[E++]],b+=P[A[E++]],b+=P[A[E++]],b}}()}),define(Se[156],Ce([1,0,19,48,32]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=e.$bs=e.$as=e.$_r=e.$$r=void 0;function A(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$$r=A;function P(I,$,D){const S={id:(0,h.$6e)(),name:I,uri:$,data:D};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$_r=P;class m{constructor(){this.a=new Map}get size(){let $=0;for(const D of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const D=[...this.a.keys()];return F.Iterable.some(this,([S,p])=>p.asFile())&&D.push("files"),R(E($),D)}get($){return this.a.get(this.b($))?.[0]}append($,D){const S=this.a.get($);S?S.push(D):this.a.set(this.b($),[D])}replace($,D){this.a.set(this.b($),[D])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,D]of this.a)for(const S of D)yield[$,S]}b($){return E($)}}e.$as=m;function E(I){return I.toLowerCase()}function b(I,$){return R(E(I),$.map(E))}e.$bs=b;function R(I,$){if(I==="*/*")return $.length>0;if($.includes(I))return!0;const D=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!D)return!1;const[S,p,r]=D;return r==="*"?$.some(s=>s.startsWith(p+"/")):!1}e.$cs=Object.freeze({create:I=>(0,k.$rf)(I.map($=>$.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$cs.split(I).filter($=>!$.startsWith("#"))})}),define(Se[115],Ce([1,0,114]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=void 0;class F{constructor(m){const E=(0,k.$id)(m);this.c=E,this.a=F.d(E),this.b=new Map}static d(m){const E=new Uint8Array(256);return E.fill(m),E}set(m,E){const b=(0,k.$id)(E);m>=0&&m<256?this.a[m]=b:this.b.set(m,b)}get(m){return m>=0&&m<256?this.a[m]:this.b.get(m)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$3r=F;var h;(function(P){P[P.False=0]="False",P[P.True=1]="True"})(h||(h={}));class A{constructor(){this.a=new F(0)}add(m){this.a.set(m,1)}has(m){return this.a.get(m)===1}clear(){return this.a.clear()}}e.$4r=A}),define(Se[56],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=void 0;class k{constructor(h,A){this.lineNumber=h,this.column=A}with(h=this.lineNumber,A=this.column){return h===this.lineNumber&&A===this.column?this:new k(h,A)}delta(h=0,A=0){return this.with(this.lineNumber+h,this.column+A)}equals(h){return k.equals(this,h)}static equals(h,A){return!h&&!A?!0:!!h&&!!A&&h.lineNumber===A.lineNumber&&h.column===A.column}isBefore(h){return k.isBefore(this,h)}static isBefore(h,A){return h.lineNumber<A.lineNumber?!0:A.lineNumber<h.lineNumber?!1:h.column<A.column}isBeforeOrEqual(h){return k.isBeforeOrEqual(this,h)}static isBeforeOrEqual(h,A){return h.lineNumber<A.lineNumber?!0:A.lineNumber<h.lineNumber?!1:h.column<=A.column}static compare(h,A){const P=h.lineNumber|0,m=A.lineNumber|0;if(P===m){const E=h.column|0,b=A.column|0;return E-b}return P-m}clone(){return new k(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(h){return new k(h.lineNumber,h.column)}static isIPosition(h){return h&&typeof h.lineNumber=="number"&&typeof h.column=="number"}}e.$Nr=k}),define(Se[33],Ce([1,0,56]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=void 0;class F{constructor(A,P,m,E){A>m||A===m&&P>E?(this.startLineNumber=m,this.startColumn=E,this.endLineNumber=A,this.endColumn=P):(this.startLineNumber=A,this.startColumn=P,this.endLineNumber=m,this.endColumn=E)}isEmpty(){return F.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return F.containsPosition(this,A)}static containsPosition(A,P){return!(P.lineNumber<A.startLineNumber||P.lineNumber>A.endLineNumber||P.lineNumber===A.startLineNumber&&P.column<A.startColumn||P.lineNumber===A.endLineNumber&&P.column>A.endColumn)}static strictContainsPosition(A,P){return!(P.lineNumber<A.startLineNumber||P.lineNumber>A.endLineNumber||P.lineNumber===A.startLineNumber&&P.column<=A.startColumn||P.lineNumber===A.endLineNumber&&P.column>=A.endColumn)}containsRange(A){return F.containsRange(this,A)}static containsRange(A,P){return!(P.startLineNumber<A.startLineNumber||P.endLineNumber<A.startLineNumber||P.startLineNumber>A.endLineNumber||P.endLineNumber>A.endLineNumber||P.startLineNumber===A.startLineNumber&&P.startColumn<A.startColumn||P.endLineNumber===A.endLineNumber&&P.endColumn>A.endColumn)}strictContainsRange(A){return F.strictContainsRange(this,A)}static strictContainsRange(A,P){return!(P.startLineNumber<A.startLineNumber||P.endLineNumber<A.startLineNumber||P.startLineNumber>A.endLineNumber||P.endLineNumber>A.endLineNumber||P.startLineNumber===A.startLineNumber&&P.startColumn<=A.startColumn||P.endLineNumber===A.endLineNumber&&P.endColumn>=A.endColumn)}plusRange(A){return F.plusRange(this,A)}static plusRange(A,P){let m,E,b,R;return P.startLineNumber<A.startLineNumber?(m=P.startLineNumber,E=P.startColumn):P.startLineNumber===A.startLineNumber?(m=P.startLineNumber,E=Math.min(P.startColumn,A.startColumn)):(m=A.startLineNumber,E=A.startColumn),P.endLineNumber>A.endLineNumber?(b=P.endLineNumber,R=P.endColumn):P.endLineNumber===A.endLineNumber?(b=P.endLineNumber,R=Math.max(P.endColumn,A.endColumn)):(b=A.endLineNumber,R=A.endColumn),new F(m,E,b,R)}intersectRanges(A){return F.intersectRanges(this,A)}static intersectRanges(A,P){let m=A.startLineNumber,E=A.startColumn,b=A.endLineNumber,R=A.endColumn;const I=P.startLineNumber,$=P.startColumn,D=P.endLineNumber,S=P.endColumn;return m<I?(m=I,E=$):m===I&&(E=Math.max(E,$)),b>D?(b=D,R=S):b===D&&(R=Math.min(R,S)),m>b||m===b&&E>R?null:new F(m,E,b,R)}equalsRange(A){return F.equalsRange(this,A)}static equalsRange(A,P){return!A&&!P?!0:!!A&&!!P&&A.startLineNumber===P.startLineNumber&&A.startColumn===P.startColumn&&A.endLineNumber===P.endLineNumber&&A.endColumn===P.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(A){return new k.$Nr(A.endLineNumber,A.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(A){return new k.$Nr(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,P){return new F(this.startLineNumber,this.startColumn,A,P)}setStartPosition(A,P){return new F(A,P,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(A){return new F(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(A){return new F(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new F(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,P=A){return new F(A.lineNumber,A.column,P.lineNumber,P.column)}static lift(A){return A?new F(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,P){return!(A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<P.startColumn||P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<A.startColumn)}static areIntersecting(A,P){return!(A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<=P.startColumn||P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,P){if(A&&P){const b=A.startLineNumber|0,R=P.startLineNumber|0;if(b===R){const I=A.startColumn|0,$=P.startColumn|0;if(I===$){const D=A.endLineNumber|0,S=P.endLineNumber|0;if(D===S){const p=A.endColumn|0,r=P.endColumn|0;return p-r}return D-S}return I-$}return b-R}return(A?1:0)-(P?1:0)}static compareRangesUsingEnds(A,P){return A.endLineNumber===P.endLineNumber?A.endColumn===P.endColumn?A.startLineNumber===P.startLineNumber?A.startColumn-P.startColumn:A.startLineNumber-P.startLineNumber:A.endColumn-P.endColumn:A.endLineNumber-P.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.$Or=F}),define(Se[157],Ce([1,0,33]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=void 0;class F{static insert(A,P){return{range:new k.$Or(A.lineNumber,A.column,A.lineNumber,A.column),text:P,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,P){return{range:A,text:P}}static replaceMove(A,P){return{range:A,text:P,forceMoveMarkers:!0}}}e.$Vr=F}),define(Se[158],Ce([1,0,56,33]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.SelectionDirection=void 0;var h;(function(P){P[P.LTR=0]="LTR",P[P.RTL=1]="RTL"})(h||(e.SelectionDirection=h={}));class A extends F.$Or{constructor(m,E,b,R){super(m,E,b,R),this.selectionStartLineNumber=m,this.selectionStartColumn=E,this.positionLineNumber=b,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return A.selectionsEqual(this,m)}static selectionsEqual(m,E){return m.selectionStartLineNumber===E.selectionStartLineNumber&&m.selectionStartColumn===E.selectionStartColumn&&m.positionLineNumber===E.positionLineNumber&&m.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,E){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,m,E):new A(m,E,this.startLineNumber,this.startColumn)}getPosition(){return new k.$Nr(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new k.$Nr(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,E){return this.getDirection()===0?new A(m,E,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,m,E)}static fromPositions(m,E=m){return new A(m.lineNumber,m.column,E.lineNumber,E.column)}static fromRange(m,E){return E===0?new A(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new A(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new A(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,E){if(m&&!E||!m&&E)return!1;if(!m&&!E)return!0;if(m.length!==E.length)return!1;for(let b=0,R=m.length;b<R;b++)if(!this.selectionsEqual(m[b],E[b]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,E,b,R,I){return I===0?new A(m,E,b,R):new A(b,R,m,E)}}e.$Wr=A}),define(Se[159],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0,e.$Hr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[160],Ce([1,0,115]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=e.$5r=e.WordCharacterClass=void 0;var F;(function(P){P[P.Regular=0]="Regular",P[P.Whitespace=1]="Whitespace",P[P.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class h extends k.$3r{constructor(m){super(0);for(let E=0,b=m.length;E<b;E++)this.set(m.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$5r=h;function A(P){const m={};return E=>(m.hasOwnProperty(E)||(m[E]=P(E)),m[E])}e.$6r=A(P=>new h(P))}),define(Se[116],Ce([1,0,48,4,68]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=e.$Lr=e.$Kr=e.$Jr=e.$Ir=void 0,e.$Ir="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(I=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.$Ir)I.indexOf(D)>=0||($+="\\"+D);return $+="\\s]+)",new RegExp($,"g")}e.$Jr=A();function P(I){let $=e.$Jr;if(I&&I instanceof RegExp)if(I.global)$=I;else{let D="g";I.ignoreCase&&(D+="i"),I.multiline&&(D+="m"),I.unicode&&(D+="u"),$=new RegExp(I.source,D)}return $.lastIndex=0,$}e.$Kr=P;const m=new h.$lc;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(I){const $=m.unshift(I);return(0,F.$jb)($)}e.$Lr=E;function b(I,$,D,S,p){if(p||(p=k.Iterable.first(m)),D.length>p.maxLen){let y=I-p.maxLen/2;return y<0?y=0:S+=y,D=D.substring(y,I+p.maxLen/2),b(I,$,D,S,p)}const r=Date.now(),s=I-1-S;let c=-1,f=null;for(let y=1;!(Date.now()-r>=p.timeBudget);y++){const C=s-p.windowSize*y;$.lastIndex=Math.max(0,C);const i=R($,D,s,c);if(!i&&f||(f=i,C<=0))break;c=C}if(f){const y={word:f[0],startColumn:S+1+f.index,endColumn:S+1+f.index+f[0].length};return $.lastIndex=0,y}return null}e.$Mr=b;function R(I,$,D,S){let p;for(;p=I.exec($);){const r=p.index||0;if(r<=D&&I.lastIndex>=D)return p;if(S>0&&r>S)return null}return null}}),define(Se[161],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=e.$Bs=e.IndentAction=void 0;var k;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(k||(e.IndentAction=k={}));class F{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let E=0,b=m.notIn.length;E<b;E++)switch(m.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,E){if(m.getTokenCount()===0)return!0;const b=m.findTokenIndexAtOffset(E-2),R=m.getStandardTokenType(b);return this.isOK(R)}g(m,E){for(let b=m;b<=E;b++){const R=String.fromCharCode(b);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Bs=F;class h{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of m)A(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),A(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),A(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),A(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&A(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$Cs=h;function A(P,m,E){P.has(m)?P.get(m).push(E):P.set(m,[E])}}),define(Se[162],Ce([1,0,115]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aX=e.$_W=e.$$W=e.State=void 0;var F;(function(D){D[D.Invalid=0]="Invalid",D[D.Start=1]="Start",D[D.H=2]="H",D[D.HT=3]="HT",D[D.HTT=4]="HTT",D[D.HTTP=5]="HTTP",D[D.F=6]="F",D[D.FI=7]="FI",D[D.FIL=8]="FIL",D[D.BeforeColon=9]="BeforeColon",D[D.AfterColon=10]="AfterColon",D[D.AlmostThere=11]="AlmostThere",D[D.End=12]="End",D[D.Accept=13]="Accept",D[D.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class h{constructor(S,p,r){const s=new Uint8Array(S*p);for(let c=0,f=S*p;c<f;c++)s[c]=r;this.a=s,this.rows=S,this.cols=p}get(S,p){return this.a[S*this.cols+p]}set(S,p,r){this.a[S*this.cols+p]=r}}class A{constructor(S){let p=0,r=0;for(let c=0,f=S.length;c<f;c++){const[y,C,i]=S[c];C>p&&(p=C),y>r&&(r=y),i>r&&(r=i)}p++,r++;const s=new h(r,p,0);for(let c=0,f=S.length;c<f;c++){const[y,C,i]=S[c];s.set(y,C,i)}this.a=s,this.b=p}nextState(S,p){return p<0||p>=this.b?0:this.a.get(S,p)}}e.$$W=A;let P=null;function m(){return P===null&&(P=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),P}var E;(function(D){D[D.None=0]="None",D[D.ForceTermination=1]="ForceTermination",D[D.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let b=null;function R(){if(b===null){b=new k.$3r(0);const D=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<D.length;p++)b.set(D.charCodeAt(p),1);const S=".,;:";for(let p=0;p<S.length;p++)b.set(S.charCodeAt(p),2)}return b}class I{static a(S,p,r,s,c){let f=c-1;do{const y=p.charCodeAt(f);if(S.get(y)!==2)break;f--}while(f>s);if(s>0){const y=p.charCodeAt(s-1),C=p.charCodeAt(f);(y===40&&C===41||y===91&&C===93||y===123&&C===125)&&f--}return{range:{startLineNumber:r,startColumn:s+1,endLineNumber:r,endColumn:f+2},url:p.substring(s,f+1)}}static computeLinks(S,p=m()){const r=R(),s=[];for(let c=1,f=S.getLineCount();c<=f;c++){const y=S.getLineContent(c),C=y.length;let i=0,o=0,n=0,t=1,a=!1,g=!1,u=!1,d=!1;for(;i<C;){let v=!1;const l=y.charCodeAt(i);if(t===13){let w;switch(l){case 40:a=!0,w=0;break;case 41:w=a?0:1;break;case 91:u=!0,g=!0,w=0;break;case 93:u=!1,w=g?0:1;break;case 123:d=!0,w=0;break;case 125:w=d?0:1;break;case 39:case 34:case 96:n===l?w=1:n===39||n===34||n===96?w=0:w=1;break;case 42:w=n===42?1:0;break;case 124:w=n===124?1:0;break;case 32:w=u?0:1;break;default:w=r.get(l)}w===1&&(s.push(I.a(r,y,c,o,i)),v=!0)}else if(t===12){let w;l===91?(g=!0,w=0):w=r.get(l),w===1?v=!0:t=13}else t=p.nextState(t,l),t===0&&(v=!0);v&&(t=1,a=!1,g=!1,d=!1,o=i+1,n=l),i++}t===13&&s.push(I.a(r,y,c,o,C))}return s}}e.$_W=I;function $(D){return!D||typeof D.getLineCount!="function"||typeof D.getLineContent!="function"?[]:I.computeLinks(D)}e.$aX=$}),define(Se[117],Ce([1,0,23]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2t=e.$1t=e.$Zt=e.$Yt=e.ModelConstants=e.PositionAffinity=e.$Xt=e.TrackedRangeStickiness=e.$Wt=e.$Vt=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(y){y[y.Left=1]="Left",y[y.Center=2]="Center",y[y.Right=4]="Right",y[y.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var h;(function(y){y[y.Left=1]="Left",y[y.Right=2]="Right"})(h||(e.GlyphMarginLane=h={}));var A;(function(y){y[y.Inline=1]="Inline",y[y.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var P;(function(y){y[y.Both=0]="Both",y[y.Right=1]="Right",y[y.Left=2]="Left",y[y.None=3]="None"})(P||(e.InjectedTextCursorStops=P={}));var m;(function(y){y[y.TextDefined=0]="TextDefined",y[y.LF=1]="LF",y[y.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var E;(function(y){y[y.LF=1]="LF",y[y.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var b;(function(y){y[y.LF=0]="LF",y[y.CRLF=1]="CRLF"})(b||(e.EndOfLineSequence=b={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(C){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,C.tabSize|0),C.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,C.indentSize|0),this.a=!1),this.insertSpaces=!!C.insertSpaces,this.defaultEOL=C.defaultEOL|0,this.trimAutoWhitespace=!!C.trimAutoWhitespace,this.bracketPairColorizationOptions=C.bracketPairColorizationOptions}equals(C){return this.tabSize===C.tabSize&&this.a===C.a&&this.indentSize===C.indentSize&&this.insertSpaces===C.insertSpaces&&this.defaultEOL===C.defaultEOL&&this.trimAutoWhitespace===C.trimAutoWhitespace&&(0,k.$Lm)(this.bracketPairColorizationOptions,C.bracketPairColorizationOptions)}createChangeEvent(C){return{tabSize:this.tabSize!==C.tabSize,indentSize:this.indentSize!==C.indentSize,insertSpaces:this.insertSpaces!==C.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==C.trimAutoWhitespace}}}e.$Vt=R;class I{constructor(C,i){this._findMatchBrand=void 0,this.range=C,this.matches=i}}e.$Wt=I;var $;(function(y){y[y.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",y[y.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",y[y.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",y[y.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($||(e.TrackedRangeStickiness=$={}));function D(y){return y&&typeof y.read=="function"}e.$Xt=D;var S;(function(y){y[y.Left=0]="Left",y[y.Right=1]="Right",y[y.None=2]="None",y[y.LeftOfInjectedText=3]="LeftOfInjectedText",y[y.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var p;(function(y){y[y.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(p||(e.ModelConstants=p={}));class r{constructor(C,i,o,n,t,a){this.identifier=C,this.range=i,this.text=o,this.forceMoveMarkers=n,this.isAutoWhitespaceEdit=t,this._isTracked=a}}e.$Yt=r;class s{constructor(C,i,o){this.regex=C,this.wordSeparators=i,this.simpleSearch=o}}e.$Zt=s;class c{constructor(C,i,o){this.reverseEdits=C,this.changes=i,this.trimAutoWhitespaceLineNumbers=o}}e.$1t=c;function f(y){return!y.isTooLargeForSyncing()&&!y.isForSimpleWidget}e.$2t=f}),define(Se[163],Ce([1,0,19,114]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vu=e.$uu=e.$tu=void 0;class h{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,b){E=(0,F.$jd)(E);const R=this.a,I=this.b,$=b.length;return $===0?!1:(this.a=new Uint32Array(R.length+$),this.a.set(R.subarray(0,E),0),this.a.set(R.subarray(E),E+$),this.a.set(b,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(E,b){return E=(0,F.$jd)(E),b=(0,F.$jd)(b),this.a[E]===b?!1:(this.a[E]=b,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,b){E=(0,F.$jd)(E),b=(0,F.$jd)(b);const R=this.a,I=this.b;if(E>=R.length)return!1;const $=R.length-E;return b>=$&&(b=$),b===0?!1:(this.a=new Uint32Array(R.length-b),this.a.set(R.subarray(0,E),0),this.a.set(R.subarray(E+b),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,F.$jd)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let b=this.c[0]+1;b===0&&(this.b[0]=this.a[0],b++),E>=this.a.length&&(E=this.a.length-1);for(let R=b;R<=E;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let b=0,R=this.a.length-1,I=0,$=0,D=0;for(;b<=R;)if(I=b+(R-b)/2|0,$=this.b[I],D=$-this.a[I],E<D)R=I-1;else if(E>=$)b=I+1;else break;return new P(I,E-D)}}e.$tu=h;class A{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const b=this.e[E],R=b>0?this.d[b-1]:0;return new P(b,E-R)}removeValues(E,b){this.a.splice(E,b),this.f(E)}insertValues(E,b){this.a=(0,k.$Df)(this.a,E,b),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,b=this.a.length;E<b;E++){const R=this.a[E],I=E>0?this.d[E-1]:0;this.d[E]=I+R;for(let $=0;$<R;$++)this.e[I+$]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,b){this.a[E]!==b&&(this.a[E]=b,this.f(E))}}e.$uu=A;class P{constructor(E,b){this.index=E,this.remainder=b,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=b}}e.$vu=P}),define(Se[164],Ce([1,0,12,56,163]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wu=void 0;class A{constructor(m,E,b,R){this.d=m,this.f=E,this.g=b,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(m){m.eol&&m.eol!==this.g&&(this.g=m.eol,this.j=null);const E=m.changes;for(const b of E)this.o(b.range),this.p(new F.$Nr(b.range.startLineNumber,b.range.startColumn),b.text);this.h=m.versionId,this.k=null}l(){if(!this.j){const m=this.g.length,E=this.f.length,b=new Uint32Array(E);for(let R=0;R<E;R++)b[R]=this.f[R].length+m;this.j=new h.$tu(b)}}n(m,E){this.f[m]=E,this.j&&this.j.setValue(m,this.f[m].length+this.g.length)}o(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.startLineNumber-1].substring(m.endColumn-1));return}this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.endLineNumber-1].substring(m.endColumn-1)),this.f.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this.j&&this.j.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}p(m,E){if(E.length===0)return;const b=(0,k.$Ad)(E);if(b.length===1){this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+b[0]+this.f[m.lineNumber-1].substring(m.column-1));return}b[b.length-1]+=this.f[m.lineNumber-1].substring(m.column-1),this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+b[0]);const R=new Uint32Array(b.length-1);for(let I=1;I<b.length;I++)this.f.splice(m.lineNumber+I-1,0,b[I]),R[I-1]=b[I].length+this.g.length;this.j&&this.j.insertValues(m.lineNumber,R)}}e.$wu=A}),define(Se[165],Ce([1,0,12,160,56,33,117]),function(fe,e,k,F,h,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8B=e.$7B=e.$6B=e.$5B=e.$4B=e.$3B=void 0;const m=999;class E{constructor(c,f,y,C){this.searchString=c,this.isRegex=f,this.matchCase=y,this.wordSeparators=C}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=b(this.searchString):c=this.searchString.indexOf(`
`)>=0;let f=null;try{f=k.$wd(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch{return null}if(!f)return null;let y=!this.isRegex&&!c;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new P.$Zt(f,this.wordSeparators?(0,F.$6r)(this.wordSeparators):null,y?this.searchString:null)}}e.$3B=E;function b(s){if(!s||s.length===0)return!1;for(let c=0,f=s.length;c<f;c++){const y=s.charCodeAt(c);if(y===10)return!0;if(y===92){if(c++,c>=f)break;const C=s.charCodeAt(c);if(C===110||C===114||C===87)return!0}}return!1}e.$4B=b;function R(s,c,f){if(!f)return new P.$Wt(s,null);const y=[];for(let C=0,i=c.length;C<i;C++)y[C]=c[C];return new P.$Wt(s,y)}e.$5B=R;class I{constructor(c){const f=[];let y=0;for(let C=0,i=c.length;C<i;C++)c.charCodeAt(C)===10&&(f[y++]=C);this.a=f}findLineFeedCountBeforeOffset(c){const f=this.a;let y=0,C=f.length-1;if(C===-1||c<=f[0])return 0;for(;y<C;){const i=y+((C-y)/2>>0);f[i]>=c?C=i-1:f[i+1]>=c?(y=i,C=i):y=i+1}return y+1}}class ${static findMatches(c,f,y,C,i){const o=f.parseSearchRequest();return o?o.regex.multiline?this.b(c,y,new r(o.wordSeparators,o.regex),C,i):this.c(c,y,o,C,i):[]}static a(c,f,y,C,i,o){let n,t=0;C?(t=C.findLineFeedCountBeforeOffset(i),n=f+i+t):n=f+i;let a;if(C){const v=C.findLineFeedCountBeforeOffset(i+o.length)-t;a=n+o.length+v}else a=n+o.length;const g=c.getPositionAt(n),u=c.getPositionAt(a);return new A.$Or(g.lineNumber,g.column,u.lineNumber,u.column)}static b(c,f,y,C,i){const o=c.getOffsetAt(f.getStartPosition()),n=c.getValueInRange(f,1),t=c.getEOL()===`\r
`?new I(n):null,a=[];let g=0,u;for(y.reset(0);u=y.next(n);)if(a[g++]=R(this.a(c,o,n,t,u.index,u[0]),u,C),g>=i)return a;return a}static c(c,f,y,C,i){const o=[];let n=0;if(f.startLineNumber===f.endLineNumber){const a=c.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return n=this.d(y,a,f.startLineNumber,f.startColumn-1,n,o,C,i),o}const t=c.getLineContent(f.startLineNumber).substring(f.startColumn-1);n=this.d(y,t,f.startLineNumber,f.startColumn-1,n,o,C,i);for(let a=f.startLineNumber+1;a<f.endLineNumber&&n<i;a++)n=this.d(y,c.getLineContent(a),a,0,n,o,C,i);if(n<i){const a=c.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);n=this.d(y,a,f.endLineNumber,0,n,o,C,i)}return o}static d(c,f,y,C,i,o,n,t){const a=c.wordSeparators;if(!n&&c.simpleSearch){const d=c.simpleSearch,v=d.length,l=f.length;let w=-v;for(;(w=f.indexOf(d,w+v))!==-1;)if((!a||p(a,f,l,w,v))&&(o[i++]=new P.$Wt(new A.$Or(y,w+1+C,y,w+1+v+C),null),i>=t))return i;return i}const g=new r(c.wordSeparators,c.regex);let u;g.reset(0);do if(u=g.next(f),u&&(o[i++]=R(new A.$Or(y,u.index+1+C,y,u.index+1+u[0].length+C),u,n),i>=t))return i;while(u);return i}static findNextMatch(c,f,y,C){const i=f.parseSearchRequest();if(!i)return null;const o=new r(i.wordSeparators,i.regex);return i.regex.multiline?this.e(c,y,o,C):this.f(c,y,o,C)}static e(c,f,y,C){const i=new h.$Nr(f.lineNumber,1),o=c.getOffsetAt(i),n=c.getLineCount(),t=c.getValueInRange(new A.$Or(i.lineNumber,i.column,n,c.getLineMaxColumn(n)),1),a=c.getEOL()===`\r
`?new I(t):null;y.reset(f.column-1);const g=y.next(t);return g?R(this.a(c,o,t,a,g.index,g[0]),g,C):f.lineNumber!==1||f.column!==1?this.e(c,new h.$Nr(1,1),y,C):null}static f(c,f,y,C){const i=c.getLineCount(),o=f.lineNumber,n=c.getLineContent(o),t=this.g(y,n,o,f.column,C);if(t)return t;for(let a=1;a<=i;a++){const g=(o+a-1)%i,u=c.getLineContent(g+1),d=this.g(y,u,g+1,1,C);if(d)return d}return null}static g(c,f,y,C,i){c.reset(C-1);const o=c.next(f);return o?R(new A.$Or(y,o.index+1,y,o.index+1+o[0].length),o,i):null}static findPreviousMatch(c,f,y,C){const i=f.parseSearchRequest();if(!i)return null;const o=new r(i.wordSeparators,i.regex);return i.regex.multiline?this.h(c,y,o,C):this.j(c,y,o,C)}static h(c,f,y,C){const i=this.b(c,new A.$Or(1,1,f.lineNumber,f.column),y,C,10*m);if(i.length>0)return i[i.length-1];const o=c.getLineCount();return f.lineNumber!==o||f.column!==c.getLineMaxColumn(o)?this.h(c,new h.$Nr(o,c.getLineMaxColumn(o)),y,C):null}static j(c,f,y,C){const i=c.getLineCount(),o=f.lineNumber,n=c.getLineContent(o).substring(0,f.column-1),t=this.k(y,n,o,C);if(t)return t;for(let a=1;a<=i;a++){const g=(i+o-a-1)%i,u=c.getLineContent(g+1),d=this.k(y,u,g+1,C);if(d)return d}return null}static k(c,f,y,C){let i=null,o;for(c.reset(0);o=c.next(f);)i=R(new A.$Or(y,o.index+1,y,o.index+1+o[0].length),o,C);return i}}e.$6B=$;function D(s,c,f,y,C){if(y===0)return!0;const i=c.charCodeAt(y-1);if(s.get(i)!==0||i===13||i===10)return!0;if(C>0){const o=c.charCodeAt(y);if(s.get(o)!==0)return!0}return!1}function S(s,c,f,y,C){if(y+C===f)return!0;const i=c.charCodeAt(y+C);if(s.get(i)!==0||i===13||i===10)return!0;if(C>0){const o=c.charCodeAt(y+C-1);if(s.get(o)!==0)return!0}return!1}function p(s,c,f,y,C){return D(s,c,f,y,C)&&S(s,c,f,y,C)}e.$7B=p;class r{constructor(c,f){this._wordSeparators=c,this.a=f,this.b=-1,this.c=0}reset(c){this.a.lastIndex=c,this.b=-1,this.c=0}next(c){const f=c.length;let y;do{if(this.b+this.c===f||(y=this.a.exec(c),!y))return null;const C=y.index,i=y[0].length;if(C===this.b&&i===this.c){if(i===0){k.$Td(c,f,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=C,this.c=i,!this._wordSeparators||p(this._wordSeparators,c,f,C,i))return y}while(y);return null}}e.$8B=r}),define(Se[166],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A5=e.$z5=void 0;class k{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const P=this.a.get(A);return this.a.delete(A),P}}addDragOperationTransfer(A,P){this.a.set(A,P)}}e.$z5=k;class F{constructor(A){this.identifier=A}}e.$A5=F}),define(Se[167],Ce([1,0,3,4]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0;class h{constructor(){this.a=new Map,this.b=new Map,this.c=new k.$8c,this.onDidChange=this.c.event,this.d=null}handleChange(m){this.c.fire({changedLanguages:m,changedColorMap:!1})}register(m,E){return this.a.set(m,E),this.handleChange([m]),(0,F.$jb)(()=>{this.a.get(m)===E&&(this.a.delete(m),this.handleChange([m]))})}get(m){return this.a.get(m)||null}registerFactory(m,E){this.b.get(m)?.dispose();const b=new A(this,m,E);return this.b.set(m,b),(0,F.$jb)(()=>{const R=this.b.get(m);!R||R!==b||(this.b.delete(m),R.dispose())})}async getOrCreate(m){const E=this.get(m);if(E)return E;const b=this.b.get(m);return!b||b.isResolved?null:(await b.resolve(),this.get(m))}isResolved(m){if(this.get(m))return!0;const b=this.b.get(m);return!!(!b||b.isResolved)}setColorMap(m){this.d=m,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$es=h;class A extends F.$lb{get isResolved(){return this.c}constructor(m,E,b){super(),this.f=m,this.g=E,this.h=b,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const m=await this.h.tokenizationSupport;this.c=!0,m&&!this.a&&this.B(this.f.register(this.g,m))}}}),define(Se[168],Ce([9,10]),function(fe,e){return fe.create("vs/base/common/actions",e)}),define(Se[169],Ce([1,0,3,4,168]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0;class A extends F.$lb{constructor($,D="",S="",p=!0,r){super(),this.h=this.B(new k.$8c),this.onDidChange=this.h.event,this.w=!0,this.j=$,this.m=D,this.u=S,this.w=p,this.C=r}get id(){return this.j}get label(){return this.m}set label($){this.D($)}D($){this.m!==$&&(this.m=$,this.h.fire({label:$}))}get tooltip(){return this.n||""}set tooltip($){this.F($)}F($){this.n!==$&&(this.n=$,this.h.fire({tooltip:$}))}get class(){return this.u}set class($){this.G($)}G($){this.u!==$&&(this.u=$,this.h.fire({class:$}))}get enabled(){return this.w}set enabled($){this.H($)}H($){this.w!==$&&(this.w=$,this.h.fire({enabled:$}))}get checked(){return this.z}set checked($){this.I($)}I($){this.z!==$&&(this.z=$,this.h.fire({checked:$}))}async run($,D){this.C&&await this.C($)}}e.$7h=A;class P extends F.$lb{constructor(){super(...arguments),this.f=this.B(new k.$8c),this.onWillRun=this.f.event,this.k=this.B(new k.$8c),this.onDidRun=this.k.event}async run($,D){if(!$.enabled)return;this.f.fire({action:$});let S;try{await this.l($,D)}catch(p){S=p}this.k.fire({action:$,error:S})}async l($,D){await $.run(D)}}e.$8h=P;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let D=[];for(const S of $)S.length&&(D.length?D=[...D,new m,...S]:D=S);return D}static{this.ID="vs.actions.separator"}async run(){}}e.$9h=m;class E{get actions(){return this.a}constructor($,D,S,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=D,this.class=p,this.a=S}async run(){}}e.$0h=E;class b extends A{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,h.localize(0,null),void 0,!1)}}e.$$h=b;function R(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}e.$_h=R}),define(Se[170],Ce([9,10]),function(fe,e){return fe.create("vs/base/common/date",e)}),define(Se[171],Ce([1,0,170]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=void 0;const F=60,h=F*60,A=h*24,P=A*7,m=A*30,E=A*365;function b(I,$,D,S){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,k.localize)(0,null,b(new Date().getTime()+p*1e3,!1));if(!S&&p<30)return(0,k.localize)(1,null);let r;return p<F?(r=p,$?r===1?D?(0,k.localize)(2,null,r):(0,k.localize)(3,null,r):D?(0,k.localize)(4,null,r):(0,k.localize)(5,null,r):r===1?D?(0,k.localize)(6,null,r):(0,k.localize)(7,null,r):D?(0,k.localize)(8,null,r):(0,k.localize)(9,null,r)):p<h?(r=Math.floor(p/F),$?r===1?D?(0,k.localize)(10,null,r):(0,k.localize)(11,null,r):D?(0,k.localize)(12,null,r):(0,k.localize)(13,null,r):r===1?D?(0,k.localize)(14,null,r):(0,k.localize)(15,null,r):D?(0,k.localize)(16,null,r):(0,k.localize)(17,null,r)):p<A?(r=Math.floor(p/h),$?r===1?D?(0,k.localize)(18,null,r):(0,k.localize)(19,null,r):D?(0,k.localize)(20,null,r):(0,k.localize)(21,null,r):r===1?D?(0,k.localize)(22,null,r):(0,k.localize)(23,null,r):D?(0,k.localize)(24,null,r):(0,k.localize)(25,null,r)):p<P?(r=Math.floor(p/A),$?r===1?(0,k.localize)(26,null,r):(0,k.localize)(27,null,r):r===1?(0,k.localize)(28,null,r):(0,k.localize)(29,null,r)):p<m?(r=Math.floor(p/P),$?r===1?D?(0,k.localize)(30,null,r):(0,k.localize)(31,null,r):D?(0,k.localize)(32,null,r):(0,k.localize)(33,null,r):r===1?D?(0,k.localize)(34,null,r):(0,k.localize)(35,null,r):D?(0,k.localize)(36,null,r):(0,k.localize)(37,null,r)):p<E?(r=Math.floor(p/m),$?r===1?D?(0,k.localize)(38,null,r):(0,k.localize)(39,null,r):D?(0,k.localize)(40,null,r):(0,k.localize)(41,null,r):r===1?D?(0,k.localize)(42,null,r):(0,k.localize)(43,null,r):D?(0,k.localize)(44,null,r):(0,k.localize)(45,null,r)):(r=Math.floor(p/E),$?r===1?D?(0,k.localize)(46,null,r):(0,k.localize)(47,null,r):D?(0,k.localize)(48,null,r):(0,k.localize)(49,null,r):r===1?D?(0,k.localize)(50,null,r):(0,k.localize)(51,null,r):D?(0,k.localize)(52,null,r):(0,k.localize)(53,null,r))}e.$Rl=b;function R(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Sl=R}),define(Se[172],Ce([9,10]),function(fe,e){return fe.create("vs/base/common/errorMessage",e)}),define(Se[45],Ce([1,0,19,14,172]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=void 0;function A(I,$){return $&&(I.stack||I.stacktrace)?h.localize(0,null,m(I),P(I.stack)||P(I.stacktrace)):m(I)}function P(I){return Array.isArray(I)?I.join(`
`):I}function m(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?h.localize(1,null,I.message):I.message||h.localize(2,null)}function E(I=null,$=!1){if(!I)return h.localize(3,null);if(Array.isArray(I)){const D=k.$mf(I),S=E(D[0],$);return D.length>1?h.localize(4,null,S,D.length):S}if(F.$je(I))return I;if(I.detail){const D=I.detail;if(D.error)return A(D.error,$);if(D.exception)return A(D.exception,$)}return I.stack?A(I,$):I.message?I.message:h.localize(5,null)}e.$ai=E;function b(I){const $=I;return $ instanceof Error&&Array.isArray($.actions)}e.$bi=b;function R(I,$){let D;return typeof I=="string"?D=new Error(I):D=I,D.actions=$,D}e.$ci=R}),define(Se[173],Ce([9,10]),function(fe,e){return fe.create("vs/base/common/platform",e)}),define(Se[11],Ce([1,0,173]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let F=!1,h=!1,A=!1,P=!1,m=!1,E=!1,b=!1,R=!1,I=!1,$=!1,D,S=e.$f,p=e.$f,r,s;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?c=e.$g.vscode.process:typeof process<"u"&&(c=process);const f=typeof c?.versions?.electron=="string",y=f&&c?.type==="renderer";if(typeof navigator=="object"&&!y)s=navigator.userAgent,F=s.indexOf("Windows")>=0,h=s.indexOf("Macintosh")>=0,R=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=s.indexOf("Linux")>=0,$=s?.indexOf("Mobi")>=0,E=!0,D=k.getConfiguredDefaultLocale(k.localize(0,null))||e.$f,S=D,p=navigator.language;else if(typeof c=="object"){F=c.platform==="win32",h=c.platform==="darwin",A=c.platform==="linux",P=A&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,b=f,I=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,D=e.$f,S=e.$f;const d=c.env.VSCODE_NLS_CONFIG;if(d)try{const v=JSON.parse(d),l=v.availableLanguages["*"];D=v.locale,p=v.osLocale,S=l||e.$f,r=v._translationsConfigFile}catch{}m=!0}else console.error("Unable to resolve platform.");var C;(function(d){d[d.Web=0]="Web",d[d.Mac=1]="Mac",d[d.Linux=2]="Linux",d[d.Windows=3]="Windows"})(C||(e.Platform=C={}));function i(d){switch(d){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=i;let o=0;h?o=1:F?o=3:A&&(o=2),e.$i=F,e.$j=h,e.$k=A,e.$l=P,e.$m=m,e.$n=b,e.$o=E,e.$p=E&&typeof e.$g.importScripts=="function",e.$q=R,e.$r=$,e.$s=I,e.$t=o,e.$u=s,e.$v=S;var n;(function(d){function v(){return e.$v}d.value=v;function l(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}d.isDefaultVariant=l;function w(){return e.$v==="en"}d.isDefault=w})(n||(e.Language=n={})),e.$w=D,e.$x=p,e.$y=r,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const d=[];e.$g.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let w=0,L=d.length;w<L;w++){const O=d[w];if(O.id===l.data.vscodeScheduleAsyncWork){d.splice(w,1),O.callback();return}}});let v=0;return l=>{const w=++v;d.push({id:w,callback:l}),e.$g.postMessage({vscodeScheduleAsyncWork:w},"*")}}return d=>setTimeout(d)})();var t;(function(d){d[d.Windows=1]="Windows",d[d.Macintosh=2]="Macintosh",d[d.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=h||R?2:F?1:3;let a=!0,g=!1;function u(){if(!g){g=!0;const d=new Uint8Array(2);d[0]=1,d[1]=2,a=new Uint16Array(d.buffer)[0]===(2<<8)+1}return a}e.$C=u,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(Se[41],Ce([1,0,11]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8b=e.$7b=e.env=e.cwd=void 0;let F;if(typeof k.$g.vscode<"u"&&typeof k.$g.vscode.process<"u"){const h=k.$g.vscode.process;F={get platform(){return h.platform},get arch(){return h.arch},get env(){return h.env},cwd(){return h.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return k.$i?"win32":k.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$7b=F.platform,e.$8b=F.arch}),define(Se[13],Ce([1,0,41]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kc=e.sep=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=void 0;const F=65,h=97,A=90,P=122,m=46,E=47,b=92,R=58,I=63;class $ extends Error{constructor(o,n,t){let a;typeof n=="string"&&n.indexOf("not ")===0?(a="must not be",n=n.replace(/^not /,"")):a="must be";const g=o.indexOf(".")!==-1?"property":"argument";let u=`The "${o}" ${g} ${a} of type ${n}`;u+=`. Received type ${typeof t}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function D(i,o){if(i===null||typeof i!="object")throw new $(o,"Object",i)}function S(i,o){if(typeof i!="string")throw new $(o,"string",i)}const p=k.$7b==="win32";function r(i){return i===E||i===b}function s(i){return i===E}function c(i){return i>=F&&i<=A||i>=h&&i<=P}function f(i,o,n,t){let a="",g=0,u=-1,d=0,v=0;for(let l=0;l<=i.length;++l){if(l<i.length)v=i.charCodeAt(l);else{if(t(v))break;v=E}if(t(v)){if(!(u===l-1||d===1))if(d===2){if(a.length<2||g!==2||a.charCodeAt(a.length-1)!==m||a.charCodeAt(a.length-2)!==m){if(a.length>2){const w=a.lastIndexOf(n);w===-1?(a="",g=0):(a=a.slice(0,w),g=a.length-1-a.lastIndexOf(n)),u=l,d=0;continue}else if(a.length!==0){a="",g=0,u=l,d=0;continue}}o&&(a+=a.length>0?`${n}..`:"..",g=2)}else a.length>0?a+=`${n}${i.slice(u+1,l)}`:a=i.slice(u+1,l),g=l-u-1;u=l,d=0}else v===m&&d!==-1?++d:d=-1}return a}function y(i,o){D(o,"pathObject");const n=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${t}`:`${n}${i}${t}`:t}e.$9b={resolve(...i){let o="",n="",t=!1;for(let a=i.length-1;a>=-1;a--){let g;if(a>=0){if(g=i[a],S(g,"path"),g.length===0)continue}else o.length===0?g=k.cwd():(g=k.env[`=${o}`]||k.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==o.toLowerCase()&&g.charCodeAt(2)===b)&&(g=`${o}\\`));const u=g.length;let d=0,v="",l=!1;const w=g.charCodeAt(0);if(u===1)r(w)&&(d=1,l=!0);else if(r(w))if(l=!0,r(g.charCodeAt(1))){let L=2,O=L;for(;L<u&&!r(g.charCodeAt(L));)L++;if(L<u&&L!==O){const N=g.slice(O,L);for(O=L;L<u&&r(g.charCodeAt(L));)L++;if(L<u&&L!==O){for(O=L;L<u&&!r(g.charCodeAt(L));)L++;(L===u||L!==O)&&(v=`\\\\${N}\\${g.slice(O,L)}`,d=L)}}}else d=1;else c(w)&&g.charCodeAt(1)===R&&(v=g.slice(0,2),d=2,u>2&&r(g.charCodeAt(2))&&(l=!0,d=3));if(v.length>0)if(o.length>0){if(v.toLowerCase()!==o.toLowerCase())continue}else o=v;if(t){if(o.length>0)break}else if(n=`${g.slice(d)}\\${n}`,t=l,l&&o.length>0)break}return n=f(n,!t,"\\",r),t?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){S(i,"path");const o=i.length;if(o===0)return".";let n=0,t,a=!1;const g=i.charCodeAt(0);if(o===1)return s(g)?"\\":i;if(r(g))if(a=!0,r(i.charCodeAt(1))){let d=2,v=d;for(;d<o&&!r(i.charCodeAt(d));)d++;if(d<o&&d!==v){const l=i.slice(v,d);for(v=d;d<o&&r(i.charCodeAt(d));)d++;if(d<o&&d!==v){for(v=d;d<o&&!r(i.charCodeAt(d));)d++;if(d===o)return`\\\\${l}\\${i.slice(v)}\\`;d!==v&&(t=`\\\\${l}\\${i.slice(v,d)}`,n=d)}}}else n=1;else c(g)&&i.charCodeAt(1)===R&&(t=i.slice(0,2),n=2,o>2&&r(i.charCodeAt(2))&&(a=!0,n=3));let u=n<o?f(i.slice(n),!a,"\\",r):"";return u.length===0&&!a&&(u="."),u.length>0&&r(i.charCodeAt(o-1))&&(u+="\\"),t===void 0?a?`\\${u}`:u:a?`${t}\\${u}`:`${t}${u}`},isAbsolute(i){S(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return r(n)||o>2&&c(n)&&i.charCodeAt(1)===R&&r(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let g=0;g<i.length;++g){const u=i[g];S(u,"path"),u.length>0&&(o===void 0?o=n=u:o+=`\\${u}`)}if(o===void 0)return".";let t=!0,a=0;if(typeof n=="string"&&r(n.charCodeAt(0))){++a;const g=n.length;g>1&&r(n.charCodeAt(1))&&(++a,g>2&&(r(n.charCodeAt(2))?++a:t=!1))}if(t){for(;a<o.length&&r(o.charCodeAt(a));)a++;a>=2&&(o=`\\${o.slice(a)}`)}return e.$9b.normalize(o)},relative(i,o){if(S(i,"from"),S(o,"to"),i===o)return"";const n=e.$9b.resolve(i),t=e.$9b.resolve(o);if(n===t||(i=n.toLowerCase(),o=t.toLowerCase(),i===o))return"";let a=0;for(;a<i.length&&i.charCodeAt(a)===b;)a++;let g=i.length;for(;g-1>a&&i.charCodeAt(g-1)===b;)g--;const u=g-a;let d=0;for(;d<o.length&&o.charCodeAt(d)===b;)d++;let v=o.length;for(;v-1>d&&o.charCodeAt(v-1)===b;)v--;const l=v-d,w=u<l?u:l;let L=-1,O=0;for(;O<w;O++){const T=i.charCodeAt(a+O);if(T!==o.charCodeAt(d+O))break;T===b&&(L=O)}if(O!==w){if(L===-1)return t}else{if(l>w){if(o.charCodeAt(d+O)===b)return t.slice(d+O+1);if(O===2)return t.slice(d+O)}u>w&&(i.charCodeAt(a+O)===b?L=O:O===2&&(L=3)),L===-1&&(L=0)}let N="";for(O=a+L+1;O<=g;++O)(O===g||i.charCodeAt(O)===b)&&(N+=N.length===0?"..":"\\..");return d+=L,N.length>0?`${N}${t.slice(d,v)}`:(t.charCodeAt(d)===b&&++d,t.slice(d,v))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$9b.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===b){if(o.charCodeAt(1)===b){const n=o.charCodeAt(2);if(n!==I&&n!==m)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(c(o.charCodeAt(0))&&o.charCodeAt(1)===R&&o.charCodeAt(2)===b)return`\\\\?\\${o}`;return i},dirname(i){S(i,"path");const o=i.length;if(o===0)return".";let n=-1,t=0;const a=i.charCodeAt(0);if(o===1)return r(a)?i:".";if(r(a)){if(n=t=1,r(i.charCodeAt(1))){let d=2,v=d;for(;d<o&&!r(i.charCodeAt(d));)d++;if(d<o&&d!==v){for(v=d;d<o&&r(i.charCodeAt(d));)d++;if(d<o&&d!==v){for(v=d;d<o&&!r(i.charCodeAt(d));)d++;if(d===o)return i;d!==v&&(n=t=d+1)}}}}else c(a)&&i.charCodeAt(1)===R&&(n=o>2&&r(i.charCodeAt(2))?3:2,t=n);let g=-1,u=!0;for(let d=o-1;d>=t;--d)if(r(i.charCodeAt(d))){if(!u){g=d;break}}else u=!1;if(g===-1){if(n===-1)return".";g=n}return i.slice(0,g)},basename(i,o){o!==void 0&&S(o,"ext"),S(i,"path");let n=0,t=-1,a=!0,g;if(i.length>=2&&c(i.charCodeAt(0))&&i.charCodeAt(1)===R&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let u=o.length-1,d=-1;for(g=i.length-1;g>=n;--g){const v=i.charCodeAt(g);if(r(v)){if(!a){n=g+1;break}}else d===-1&&(a=!1,d=g+1),u>=0&&(v===o.charCodeAt(u)?--u===-1&&(t=g):(u=-1,t=d))}return n===t?t=d:t===-1&&(t=i.length),i.slice(n,t)}for(g=i.length-1;g>=n;--g)if(r(i.charCodeAt(g))){if(!a){n=g+1;break}}else t===-1&&(a=!1,t=g+1);return t===-1?"":i.slice(n,t)},extname(i){S(i,"path");let o=0,n=-1,t=0,a=-1,g=!0,u=0;i.length>=2&&i.charCodeAt(1)===R&&c(i.charCodeAt(0))&&(o=t=2);for(let d=i.length-1;d>=o;--d){const v=i.charCodeAt(d);if(r(v)){if(!g){t=d+1;break}continue}a===-1&&(g=!1,a=d+1),v===m?n===-1?n=d:u!==1&&(u=1):n!==-1&&(u=-1)}return n===-1||a===-1||u===0||u===1&&n===a-1&&n===t+1?"":i.slice(n,a)},format:y.bind(null,"\\"),parse(i){S(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let t=0,a=i.charCodeAt(0);if(n===1)return r(a)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(r(a)){if(t=1,r(i.charCodeAt(1))){let L=2,O=L;for(;L<n&&!r(i.charCodeAt(L));)L++;if(L<n&&L!==O){for(O=L;L<n&&r(i.charCodeAt(L));)L++;if(L<n&&L!==O){for(O=L;L<n&&!r(i.charCodeAt(L));)L++;L===n?t=L:L!==O&&(t=L+1)}}}}else if(c(a)&&i.charCodeAt(1)===R){if(n<=2)return o.root=o.dir=i,o;if(t=2,r(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;t=3}}t>0&&(o.root=i.slice(0,t));let g=-1,u=t,d=-1,v=!0,l=i.length-1,w=0;for(;l>=t;--l){if(a=i.charCodeAt(l),r(a)){if(!v){u=l+1;break}continue}d===-1&&(v=!1,d=l+1),a===m?g===-1?g=l:w!==1&&(w=1):g!==-1&&(w=-1)}return d!==-1&&(g===-1||w===0||w===1&&g===d-1&&g===u+1?o.base=o.name=i.slice(u,d):(o.name=i.slice(u,g),o.base=i.slice(u,d),o.ext=i.slice(g,d))),u>0&&u!==t?o.dir=i.slice(0,u-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(p){const i=/\\/g;return()=>{const o=k.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>k.cwd()})();e.$0b={resolve(...i){let o="",n=!1;for(let t=i.length-1;t>=-1&&!n;t--){const a=t>=0?i[t]:C();S(a,"path"),a.length!==0&&(o=`${a}/${o}`,n=a.charCodeAt(0)===E)}return o=f(o,!n,"/",s),n?`/${o}`:o.length>0?o:"."},normalize(i){if(S(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===E,n=i.charCodeAt(i.length-1)===E;return i=f(i,!o,"/",s),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return S(i,"path"),i.length>0&&i.charCodeAt(0)===E},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const t=i[n];S(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.$0b.normalize(o)},relative(i,o){if(S(i,"from"),S(o,"to"),i===o||(i=e.$0b.resolve(i),o=e.$0b.resolve(o),i===o))return"";const n=1,t=i.length,a=t-n,g=1,u=o.length-g,d=a<u?a:u;let v=-1,l=0;for(;l<d;l++){const L=i.charCodeAt(n+l);if(L!==o.charCodeAt(g+l))break;L===E&&(v=l)}if(l===d)if(u>d){if(o.charCodeAt(g+l)===E)return o.slice(g+l+1);if(l===0)return o.slice(g+l)}else a>d&&(i.charCodeAt(n+l)===E?v=l:l===0&&(v=0));let w="";for(l=n+v+1;l<=t;++l)(l===t||i.charCodeAt(l)===E)&&(w+=w.length===0?"..":"/..");return`${w}${o.slice(g+v)}`},toNamespacedPath(i){return i},dirname(i){if(S(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===E;let n=-1,t=!0;for(let a=i.length-1;a>=1;--a)if(i.charCodeAt(a)===E){if(!t){n=a;break}}else t=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&S(o,"ext"),S(i,"path");let n=0,t=-1,a=!0,g;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let u=o.length-1,d=-1;for(g=i.length-1;g>=0;--g){const v=i.charCodeAt(g);if(v===E){if(!a){n=g+1;break}}else d===-1&&(a=!1,d=g+1),u>=0&&(v===o.charCodeAt(u)?--u===-1&&(t=g):(u=-1,t=d))}return n===t?t=d:t===-1&&(t=i.length),i.slice(n,t)}for(g=i.length-1;g>=0;--g)if(i.charCodeAt(g)===E){if(!a){n=g+1;break}}else t===-1&&(a=!1,t=g+1);return t===-1?"":i.slice(n,t)},extname(i){S(i,"path");let o=-1,n=0,t=-1,a=!0,g=0;for(let u=i.length-1;u>=0;--u){const d=i.charCodeAt(u);if(d===E){if(!a){n=u+1;break}continue}t===-1&&(a=!1,t=u+1),d===m?o===-1?o=u:g!==1&&(g=1):o!==-1&&(g=-1)}return o===-1||t===-1||g===0||g===1&&o===t-1&&o===n+1?"":i.slice(o,t)},format:y.bind(null,"/"),parse(i){S(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===E;let t;n?(o.root="/",t=1):t=0;let a=-1,g=0,u=-1,d=!0,v=i.length-1,l=0;for(;v>=t;--v){const w=i.charCodeAt(v);if(w===E){if(!d){g=v+1;break}continue}u===-1&&(d=!1,u=v+1),w===m?a===-1?a=v:l!==1&&(l=1):a!==-1&&(l=-1)}if(u!==-1){const w=g===0&&n?1:g;a===-1||l===0||l===1&&a===u-1&&a===g+1?o.base=o.name=i.slice(w,u):(o.name=i.slice(w,a),o.base=i.slice(w,u),o.ext=i.slice(a,u))}return g>0?o.dir=i.slice(0,g-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$0b.win32=e.$9b.win32=e.$9b,e.$0b.posix=e.$9b.posix=e.$0b,e.$$b=p?e.$9b.normalize:e.$0b.normalize,e.$_b=p?e.$9b.isAbsolute:e.$0b.isAbsolute,e.$ac=p?e.$9b.join:e.$0b.join,e.$bc=p?e.$9b.resolve:e.$0b.resolve,e.$cc=p?e.$9b.relative:e.$0b.relative,e.$dc=p?e.$9b.dirname:e.$0b.dirname,e.$ec=p?e.$9b.basename:e.$0b.basename,e.$fc=p?e.$9b.extname:e.$0b.extname,e.$gc=p?e.$9b.format:e.$0b.format,e.$hc=p?e.$9b.parse:e.$0b.parse,e.$ic=p?e.$9b.toNamespacedPath:e.$0b.toNamespacedPath,e.sep=p?e.$9b.sep:e.$0b.sep,e.$kc=p?e.$9b.delimiter:e.$0b.delimiter}),define(Se[118],Ce([1,0,54,13]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=e.$Yp=void 0;const h=new k.$T(()=>{const d=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:d,collatorIsNumeric:d.resolvedOptions().numeric}}),A=new k.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new k.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(d,v,l=!1){const w=d||"",L=v||"",O=h.value.collator.compare(w,L);return h.value.collatorIsNumeric&&O===0&&w!==L?w<L?-1:1:O}e.$Yp=m;function E(d,v){const l=A.value.collator;return d=d||"",v=v||"",y(l,d,v)}e.$Zp=E;function b(d,v){const l=A.value.collator;return d=d||"",v=v||"",n(d,v)||y(l,d,v)}e.$1p=b;function R(d,v){const l=A.value.collator;return d=d||"",v=v||"",o(d,v)||y(l,d,v)}e.$2p=R;function I(d,v){return d=d||"",v=v||"",d===v?0:d<v?-1:1}e.$3p=I;function $(d,v){const[l,w]=c(d),[L,O]=c(v);let N=h.value.collator.compare(w,O);if(N===0){if(h.value.collatorIsNumeric&&w!==O)return w<O?-1:1;if(N=h.value.collator.compare(l,L),h.value.collatorIsNumeric&&N===0&&l!==L)return l<L?-1:1}return N}e.$4p=$;function D(d,v){d=d||"",v=v||"";const l=f(d),w=f(v),L=A.value.collator,O=P.value.collator;return y(O,l,w)||y(L,d,v)}e.$5p=D;function S(d,v){d=d||"",v=v||"";const l=f(d),w=f(v),L=A.value.collator,O=P.value.collator;return y(O,l,w)||n(d,v)||y(L,d,v)}e.$6p=S;function p(d,v){d=d||"",v=v||"";const l=f(d),w=f(v),L=A.value.collator,O=P.value.collator;return y(O,l,w)||o(d,v)||y(L,d,v)}e.$7p=p;function r(d,v){d=d||"",v=v||"";const l=f(d).toLowerCase(),w=f(v).toLowerCase();return l!==w?l<w?-1:1:d!==v?d<v?-1:1:0}e.$8p=r;const s=/^(.*?)(\.([^.]*))?$/;function c(d,v=!1){const l=d?s.exec(d):[];let w=[l&&l[1]||"",l&&l[3]||""];return v&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function f(d){const v=d?s.exec(d):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function y(d,v,l){const w=d.compare(v,l);return w!==0?w:v.length!==l.length?v.length<l.length?-1:1:0}function C(d){const v=d.charAt(0);return v.toLocaleUpperCase()!==v}function i(d){const v=d.charAt(0);return v.toLocaleLowerCase()!==v}function o(d,v){return C(d)&&i(v)?-1:i(d)&&C(v)?1:0}function n(d,v){return i(d)&&C(v)?-1:C(d)&&i(v)?1:0}function t(d,v,l=!1){return l||(d=d&&d.toLowerCase(),v=v&&v.toLowerCase()),d===v?0:d<v?-1:1}function a(d,v,l=!1){const w=d.split(F.sep),L=v.split(F.sep),O=w.length-1,N=L.length-1;let T,j;for(let W=0;;W++){if(T=O===W,j=N===W,T&&j)return m(w[W],L[W],l);if(T)return-1;if(j)return 1;const M=t(w[W],L[W],l);if(M!==0)return M}}e.$9p=a;function g(d,v,l){const w=d.toLowerCase(),L=v.toLowerCase(),O=u(d,v,l);if(O)return O;const N=w.endsWith(l),T=L.endsWith(l);if(N!==T)return N?-1:1;const j=m(w,L);return j!==0?j:w.localeCompare(L)}e.$0p=g;function u(d,v,l){const w=d.toLowerCase(),L=v.toLowerCase(),O=w.startsWith(l),N=L.startsWith(l);if(O!==N)return O?-1:1;if(O&&N){if(w.length<L.length)return-1;if(w.length>L.length)return 1}return 0}e.$$p=u}),define(Se[31],Ce([1,0,13,11,12,14]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=void 0;function P(g){return g===47||g===92}e.$De=P;function m(g){return g.replace(/[\\/]/g,k.$0b.sep)}e.$Ee=m;function E(g){return g.indexOf("/")===-1&&(g=m(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}e.$Fe=E;function b(g,u=k.$0b.sep){if(!g)return"";const d=g.length,v=g.charCodeAt(0);if(P(v)){if(P(g.charCodeAt(1))&&!P(g.charCodeAt(2))){let w=3;const L=w;for(;w<d&&!P(g.charCodeAt(w));w++);if(L!==w&&!P(g.charCodeAt(w+1))){for(w+=1;w<d;w++)if(P(g.charCodeAt(w)))return g.slice(0,w+1).replace(/[\\/]/g,u)}}return u}else if(s(v)&&g.charCodeAt(1)===58)return P(g.charCodeAt(2))?g.slice(0,2)+u:g.slice(0,2);let l=g.indexOf("://");if(l!==-1){for(l+=3;l<d;l++)if(P(g.charCodeAt(l)))return g.slice(0,l+1)}return""}e.$Ge=b;function R(g){if(!F.$i||!g||g.length<5)return!1;let u=g.charCodeAt(0);if(u!==92||(u=g.charCodeAt(1),u!==92))return!1;let d=2;const v=d;for(;d<g.length&&(u=g.charCodeAt(d),u!==92);d++);return!(v===d||(u=g.charCodeAt(d+1),isNaN(u)||u===92))}e.$He=R;const I=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,D=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(g,u=F.$i){const d=u?I:$;return!(!g||g.length===0||/^\s+$/.test(g)||(d.lastIndex=0,d.test(g))||u&&D.test(g)||g==="."||g===".."||u&&g[g.length-1]==="."||u&&g.length!==g.trim().length||g.length>255)}e.$Ie=S;function p(g,u,d){const v=g===u;return!d||v?v:!g||!u?!1:(0,h.$Md)(g,u)}e.$Je=p;function r(g,u,d,v=k.sep){if(g===u)return!0;if(!g||!u||u.length>g.length)return!1;if(d){if(!(0,h.$Nd)(g,u))return!1;if(u.length===g.length)return!0;let w=u.length;return u.charAt(u.length-1)===v&&w--,g.charAt(w)===v}return u.charAt(u.length-1)!==v&&(u+=v),g.indexOf(u)===0}e.$Ke=r;function s(g){return g>=65&&g<=90||g>=97&&g<=122}e.$Le=s;function c(g,u){return F.$i&&g.endsWith(":")&&(g+=k.sep),(0,k.$_b)(g)||(g=(0,k.$ac)(u,g)),g=(0,k.$$b)(g),F.$i?(g=(0,h.$td)(g,k.sep),g.endsWith(":")&&(g+=k.sep)):(g=(0,h.$td)(g,k.sep),g||(g=k.sep)),g}e.$Me=c;function f(g){const u=(0,k.$$b)(g);return F.$i?g.length>3?!1:y(u)&&(g.length===2||u.charCodeAt(2)===92):u===k.$0b.sep}e.$Ne=f;function y(g,u=F.$i){return u?s(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}e.$Oe=y;function C(g,u=F.$i){return y(g,u)?g[0]:void 0}e.$Pe=C;function i(g,u,d){return u.length>g.length?-1:g===u?0:(d&&(g=g.toLowerCase(),u=u.toLowerCase()),g.indexOf(u))}e.$Qe=i;function o(g){const u=g.split(":");let d,v,l;for(const w of u){const L=Number(w);(0,A.$ne)(L)?v===void 0?v=L:l===void 0&&(l=L):d=d?[d,w].join(":"):w}if(!d)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:d,line:v!==void 0?v:void 0,column:l!==void 0?l:v!==void 0?1:void 0}}e.$Re=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(g,u,d=8){let v="";for(let w=0;w<d;w++){let L;w===0&&F.$i&&!u&&(d===3||d===4)?L=t:L=n,v+=L.charAt(Math.floor(Math.random()*L.length))}let l;return u?l=`${u}-${v}`:l=v,g?(0,k.$ac)(g,l):l}e.$Se=a}),define(Se[119],Ce([1,0,118,113,70,13,11,12]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=void 0;const E=0,b=[E,[]];function R(Y,V,de,re){if(!Y||!V)return b;const x=Y.length,q=V.length;if(x<q)return b;const ne=Y.toLowerCase();return I(V,de,q,Y,ne,x,re)}e.$_p=R;function I(Y,V,de,re,x,q,ne){const pe=[],H=[];for(let ie=0;ie<de;ie++){const Ee=ie*q,Re=Ee-q,ye=ie>0,X=Y[ie],he=V[ie];for(let K=0;K<q;K++){const oe=K>0,_=Ee+K,le=_-1,$e=Re+K-1,U=oe?pe[le]:0,G=ye&&oe?pe[$e]:0,Z=ye&&oe?H[$e]:0;let ee;!G&&ye?ee=0:ee=$(X,he,re,x,K,Z),ee&&G+ee>=U&&(ne||ye||x.startsWith(V,K))?(H[_]=Z+1,pe[_]=G+ee):(H[_]=E,pe[_]=U)}}const ue=[];let ce=de-1,z=q-1;for(;ce>=0&&z>=0;){const ie=ce*q+z;H[ie]===E||(ue.push(z),ce--),z--}return[pe[de*q-1],ue.reverse()]}function $(Y,V,de,re,x,q){let ne=0;if(!D(V,re[x]))return ne;if(ne+=1,q>0&&(ne+=q*5),Y===de[x]&&(ne+=1),x===0)ne+=8;else{const pe=S(de.charCodeAt(x-1));pe?ne+=pe:(0,F.$oj)(de.charCodeAt(x))&&q===0&&(ne+=2)}return ne}function D(Y,V){return Y===V?!0:Y==="/"||Y==="\\"?V==="/"||V==="\\":!1}function S(Y){switch(Y){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function r(Y,V,de=0,re=0){const x=V;return x.values&&x.values.length>1?s(Y,x.values,de,re):c(Y,V,de,re)}e.$aq=r;function s(Y,V,de,re){let x=0;const q=[];for(const ne of V){const[pe,H]=c(Y,ne,de,re);if(typeof pe!="number")return p;x+=pe,q.push(...H)}return[x,d(q)]}function c(Y,V,de,re){const x=(0,F.$xj)(V.original,V.originalLowercase,de,Y,Y.toLowerCase(),re,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return x?[x[0],(0,F.$uj)(x)]:p}const f=Object.freeze({score:0}),y=1<<18,C=1<<17,i=1<<16;function o(Y,V,de,re){const x=re.values?re.values:[re];return(0,h.$di)({[re.normalized]:{values:x.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:Y,description:V,allowNonContiguousMatches:de}})}function n(Y,V,de,re,x){if(!Y||!V.normalized)return f;const q=re.getItemLabel(Y);if(!q)return f;const ne=re.getItemDescription(Y),pe=o(q,ne,de,V),H=x[pe];if(H)return H;const ue=t(q,ne,re.getItemPath(Y),V,de);return x[pe]=ue,ue}e.$bq=n;function t(Y,V,de,re,x){const q=!de||!re.containsPathSeparator;return de&&(P.$k?re.pathNormalized===de:(0,m.$Md)(re.pathNormalized,de))?{score:y,labelMatch:[{start:0,end:Y.length}],descriptionMatch:V?[{start:0,end:V.length}]:void 0}:re.values&&re.values.length>1?a(Y,V,de,re.values,q,x):g(Y,V,de,re,q,x)}function a(Y,V,de,re,x,q){let ne=0;const pe=[],H=[];for(const ue of re){const{score:ce,labelMatch:z,descriptionMatch:ie}=g(Y,V,de,ue,x,q);if(ce===E)return f;ne+=ce,z&&pe.push(...z),ie&&H.push(...ie)}return{score:ne,labelMatch:d(pe),descriptionMatch:d(H)}}function g(Y,V,de,re,x,q){if(x||!V){const[ne,pe]=R(Y,re.normalized,re.normalizedLowercase,q&&!re.expectContiguousMatch);if(ne){const H=(0,F.$lj)(re.normalized,Y);let ue;if(H){ue=C;const ce=Math.round(re.normalized.length/Y.length*100);ue+=ce}else ue=i;return{score:ue+ne,labelMatch:H||u(pe)}}}if(V){let ne=V;de&&(ne=`${V}${A.sep}`);const pe=ne.length,H=`${ne}${Y}`,[ue,ce]=R(H,re.normalized,re.normalizedLowercase,q&&!re.expectContiguousMatch);if(ue){const z=u(ce),ie=[],Ee=[];return z.forEach(Re=>{Re.start<pe&&Re.end>pe?(ie.push({start:0,end:Re.end-pe}),Ee.push({start:Re.start,end:pe})):Re.start>=pe?ie.push({start:Re.start-pe,end:Re.end-pe}):Ee.push(Re)}),{score:ue,labelMatch:ie,descriptionMatch:Ee}}}return f}function u(Y){const V=[];if(!Y)return V;let de;for(const re of Y)de&&de.end===re?de.end+=1:(de={start:re,end:re+1},V.push(de));return V}function d(Y){const V=Y.sort((x,q)=>x.start-q.start),de=[];let re;for(const x of V)!re||!v(re,x)?(re=x,de.push(x)):(re.start=Math.min(re.start,x.start),re.end=Math.max(re.end,x.end));return de}function v(Y,V){return!(Y.end<V.start||V.end<Y.start)}function l(Y,V,de,re,x,q){const ne=n(Y,de,re,x,q),pe=n(V,de,re,x,q),H=ne.score,ue=pe.score;if((H===y||ue===y)&&H!==ue)return H===y?-1:1;if(H>i||ue>i){if(H!==ue)return H>ue?-1:1;if(H<C&&ue<C){const X=L(ne.labelMatch,pe.labelMatch);if(X!==0)return X}const Re=x.getItemLabel(Y)||"",ye=x.getItemLabel(V)||"";if(Re.length!==ye.length)return Re.length-ye.length}if(H!==ue)return H>ue?-1:1;const ce=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,z=Array.isArray(pe.labelMatch)&&pe.labelMatch.length>0;if(ce&&!z)return-1;if(z&&!ce)return 1;const ie=w(Y,ne,x),Ee=w(V,pe,x);return ie&&Ee&&ie!==Ee?Ee>ie?-1:1:O(Y,V,de,x)}e.$cq=l;function w(Y,V,de){let re=-1,x=-1;if(V.descriptionMatch&&V.descriptionMatch.length?re=V.descriptionMatch[0].start:V.labelMatch&&V.labelMatch.length&&(re=V.labelMatch[0].start),V.labelMatch&&V.labelMatch.length){if(x=V.labelMatch[V.labelMatch.length-1].end,V.descriptionMatch&&V.descriptionMatch.length){const q=de.getItemDescription(Y);q&&(x+=q.length)}}else V.descriptionMatch&&V.descriptionMatch.length&&(x=V.descriptionMatch[V.descriptionMatch.length-1].end);return x-re}function L(Y,V){if(!Y&&!V||(!Y||!Y.length)&&(!V||!V.length))return 0;if(!V||!V.length)return-1;if(!Y||!Y.length)return 1;const de=Y[0].start,x=Y[Y.length-1].end-de,q=V[0].start,pe=V[V.length-1].end-q;return x===pe?0:pe<x?1:-1}function O(Y,V,de,re){const x=re.getItemLabel(Y)||"",q=re.getItemLabel(V)||"",ne=re.getItemDescription(Y),pe=re.getItemDescription(V),H=x.length+(ne?ne.length:0),ue=q.length+(pe?pe.length:0);if(H!==ue)return H-ue;const ce=re.getItemPath(Y),z=re.getItemPath(V);return ce&&z&&ce.length!==z.length?ce.length-z.length:x!==q?(0,k.$0p)(x,q,de.normalized):ne&&pe&&ne!==pe?(0,k.$0p)(ne,pe,de.normalized):ce&&z&&ce!==z?(0,k.$0p)(ce,z,de.normalized):0}function N(Y){return Y.startsWith('"')&&Y.endsWith('"')}const T=" ";function j(Y){typeof Y!="string"&&(Y="");const V=Y.toLowerCase(),{pathNormalized:de,normalized:re,normalizedLowercase:x}=W(Y),q=de.indexOf(A.sep)>=0,ne=N(Y);let pe;const H=Y.split(T);if(H.length>1)for(const ue of H){const ce=N(ue),{pathNormalized:z,normalized:ie,normalizedLowercase:Ee}=W(ue);ie&&(pe||(pe=[]),pe.push({original:ue,originalLowercase:ue.toLowerCase(),pathNormalized:z,normalized:ie,normalizedLowercase:Ee,expectContiguousMatch:ce}))}return{original:Y,originalLowercase:V,pathNormalized:de,normalized:re,normalizedLowercase:x,values:pe,containsPathSeparator:q,expectContiguousMatch:ne}}e.$dq=j;function W(Y){let V;P.$i?V=Y.replace(/\//g,A.sep):V=Y.replace(/\\/g,A.sep);const de=(0,m.$vd)(V).replace(/\s|"/g,"");return{pathNormalized:V,normalized:de,normalizedLowercase:de.toLowerCase()}}function M(Y){return Array.isArray(Y)?j(Y.map(V=>V.original).join(T)):j(Y.original)}e.$eq=M}),define(Se[93],Ce([1,0,13]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.$wr=e.$vr=e.$ur=void 0,e.$ur=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},h={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const I=(0,k.$fc)(R),$=F[I.toLowerCase()];return $!==void 0?$:P(R)}e.$vr=A;function P(R){const I=(0,k.$fc)(R);return h[I.toLowerCase()]}e.$wr=P;function m(R){for(const I in h)if(h[I]===R)return I}e.$xr=m;const E=/^(.+)\/(.+?)(;.+)?$/;function b(R,I){const $=E.exec(R);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:I?void 0:R}e.$yr=b}),define(Se[94],Ce([1,0,11]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.TerminateResponseCode=e.Source=void 0;var F;(function(m){m[m.stdout=0]="stdout",m[m.stderr=1]="stderr"})(F||(e.Source=F={}));var h;(function(m){m[m.Success=0]="Success",m[m.Unknown=1]="Unknown",m[m.AccessDenied=2]="AccessDenied",m[m.ProcessNotFound=3]="ProcessNotFound"})(h||(e.TerminateResponseCode=h={}));function A(m,...E){const b=E.reduce(($,D)=>($[D]=!0,$),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(m).filter($=>!b[$]).forEach($=>{for(let D=0;D<R.length;D++)if($.search(R[D])!==-1){delete m[$];break}})}e.$fl=A;function P(m){m&&(delete m.DEBUG,k.$j&&delete m.DYLD_LIBRARY_PATH,k.$k&&delete m.LD_PRELOAD)}e.$gl=P}),define(Se[2],Ce([1,0,13,11]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ve=e.$Ue=e.URI=void 0;const h=/^\w[\w\d+.-]*$/,A=/^\//,P=/^\/\//;function m(t,a){if(!t.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!h.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!A.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(t,a){return!t&&!a?"file":t}function b(t,a){switch(t){case"https":case"http":case"file":a?a[0]!==I&&(a=I+a):a=I;break}return a}const R="",I="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class D{static isUri(a){return a instanceof D?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,g,u,d,v,l=!1){typeof a=="object"?(this.scheme=a.scheme||R,this.authority=a.authority||R,this.path=a.path||R,this.query=a.query||R,this.fragment=a.fragment||R):(this.scheme=E(a,l),this.authority=g||R,this.path=b(this.scheme,u||R),this.query=d||R,this.fragment=v||R,m(this,l))}get fsPath(){return y(this,!1)}with(a){if(!a)return this;let{scheme:g,authority:u,path:d,query:v,fragment:l}=a;return g===void 0?g=this.scheme:g===null&&(g=R),u===void 0?u=this.authority:u===null&&(u=R),d===void 0?d=this.path:d===null&&(d=R),v===void 0?v=this.query:v===null&&(v=R),l===void 0?l=this.fragment:l===null&&(l=R),g===this.scheme&&u===this.authority&&d===this.path&&v===this.query&&l===this.fragment?this:new r(g,u,d,v,l)}static parse(a,g=!1){const u=$.exec(a);return u?new r(u[2]||R,n(u[4]||R),n(u[5]||R),n(u[7]||R),n(u[9]||R),g):new r(R,R,R,R,R)}static file(a){let g=R;if(F.$i&&(a=a.replace(/\\/g,I)),a[0]===I&&a[1]===I){const u=a.indexOf(I,2);u===-1?(g=a.substring(2),a=I):(g=a.substring(2,u),a=a.substring(u)||I)}return new r("file",g,a,R,R)}static from(a,g){return new r(a.scheme,a.authority,a.path,a.query,a.fragment,g)}static joinPath(a,...g){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return F.$i&&a.scheme==="file"?u=D.file(k.$9b.join(y(a,!0),...g)).path:u=k.$0b.join(a.path,...g),a.with({path:u})}toString(a=!1){return C(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof D)return a;{const g=new r(a);return g._formatted=a.external??null,g._fsPath=a._sep===p?a.fsPath??null:null,g}}else return a}}e.URI=D;function S(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.$Ue=S;const p=F.$i?1:void 0;class r extends D{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(a=!1){return a?C(this,!0):(this._formatted||(this._formatted=C(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=p),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function c(t,a,g){let u,d=-1;for(let v=0;v<t.length;v++){const l=t.charCodeAt(v);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||a&&l===47||g&&l===91||g&&l===93||g&&l===58)d!==-1&&(u+=encodeURIComponent(t.substring(d,v)),d=-1),u!==void 0&&(u+=t.charAt(v));else{u===void 0&&(u=t.substr(0,v));const w=s[l];w!==void 0?(d!==-1&&(u+=encodeURIComponent(t.substring(d,v)),d=-1),u+=w):d===-1&&(d=v)}}return d!==-1&&(u+=encodeURIComponent(t.substring(d))),u!==void 0?u:t}function f(t){let a;for(let g=0;g<t.length;g++){const u=t.charCodeAt(g);u===35||u===63?(a===void 0&&(a=t.substr(0,g)),a+=s[u]):a!==void 0&&(a+=t[g])}return a!==void 0?a:t}function y(t,a){let g;return t.authority&&t.path.length>1&&t.scheme==="file"?g=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?a?g=t.path.substr(1):g=t.path[1].toLowerCase()+t.path.substr(2):g=t.path,F.$i&&(g=g.replace(/\//g,"\\")),g}e.$Ve=y;function C(t,a){const g=a?f:c;let u="",{scheme:d,authority:v,path:l,query:w,fragment:L}=t;if(d&&(u+=d,u+=":"),(v||d==="file")&&(u+=I,u+=I),v){let O=v.indexOf("@");if(O!==-1){const N=v.substr(0,O);v=v.substr(O+1),O=N.lastIndexOf(":"),O===-1?u+=g(N,!1,!1):(u+=g(N.substr(0,O),!1,!1),u+=":",u+=g(N.substr(O+1),!1,!0)),u+="@"}v=v.toLowerCase(),O=v.lastIndexOf(":"),O===-1?u+=g(v,!1,!0):(u+=g(v.substr(0,O),!1,!0),u+=v.substr(O))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const O=l.charCodeAt(1);O>=65&&O<=90&&(l=`/${String.fromCharCode(O+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const O=l.charCodeAt(0);O>=65&&O<=90&&(l=`${String.fromCharCode(O+32)}:${l.substr(2)}`)}u+=g(l,!0,!1)}return w&&(u+="?",u+=g(w,!1,!1)),L&&(u+="#",u+=a?L:c(L,!1,!1)),u}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(t){return t.match(o)?t.replace(o,a=>i(a)):t}}),define(Se[174],Ce([1,0,2]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Ep=e.$Dp=e.$Cp=void 0;function F(b){const R=b;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$Cp=F;function h(b){const R=[];let I;try{const $=JSON.parse(b.arguments),D=$[$.length-1];D&&D.__$stack&&($.pop(),I=D.__$stack),R.push(...$)}catch{R.push("Unable to log remote console arguments",b.arguments)}return{args:R,stack:I}}e.$Dp=h;function A(b){if(typeof b!="string")return A(h(b).stack);const R=b;if(R){const I=P(R),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if($&&$.length===4)return{uri:k.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$Ep=A;function P(b){if(!b)return b;const R=b.indexOf(`
`);return R===-1?b:b.substring(0,R)}function m(b,R){const{args:I,stack:$}=h(b),D=typeof I[0]=="string"&&I.length===1;let S=P($);S&&(S=`(${S.trim()})`);let p=[];if(typeof I[0]=="string"?S&&D?p=[`%c[${R}] %c${I[0]} %c${S}`,E("blue"),E(""),E("grey")]:p=[`%c[${R}] %c${I[0]}`,E("blue"),E(""),...I.slice(1)]:p=[`%c[${R}]%`,E("blue"),...I],S&&!D&&p.push(S),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,p)}e.log=m;function E(b){return`color: ${b}`}}),define(Se[73],Ce([1,0,22,12,2]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=e.$Xg=e.$Wg=void 0;function A(b){return JSON.stringify(b,m)}e.$Wg=A;function P(b){let R=JSON.parse(b);return R=E(R),R}e.$Xg=P;function m(b,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,F.$zd)(R)}:R}function E(b,R=0){if(!b||R>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return h.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 16:return new Date(b.source)}if(b instanceof k.$Jb||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let I=0;I<b.length;++I)b[I]=E(b[I],R+1);else for(const I in b)Object.hasOwnProperty.call(b,I)&&(b[I]=E(b[I],R+1))}return b}e.$Yg=E}),define(Se[15],Ce([1,0,8,11,2]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.Schemas=void 0;var A;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.$We="vscode-tkn",e.$Xe="tkn";class P{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${A.vscodeRemoteResource}`}set(R,I,$){this.a[R]=I,this.b[R]=$}setConnectionToken(R,I){this.c[R]=I}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(r){return k.$Y(r),R}const I=R.authority;let $=this.a[I];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const D=this.b[I],S=this.c[I];let p=`path=${encodeURIComponent(R.path)}`;return typeof S=="string"&&(p+=`&${e.$Xe}=${encodeURIComponent(S)}`),h.URI.from({scheme:F.$o?this.d:A.vscodeRemoteResource,authority:`${$}:${D}`,path:this.f,query:p})}}e.$Ye=new P,e.$Ze="vs/../../extensions",e.$1e="vs/../../node_modules",e.$2e="vs/../../node_modules.asar",e.$3e="vs/../../node_modules.asar.unpacked";class m{static{this.a="vscode-app"}asBrowserUri(R){const I=this.b(R,fe);return this.uriToBrowserUri(I)}uriToBrowserUri(R){return R.scheme===A.vscodeRemote?e.$Ye.rewrite(R):R.scheme===A.file&&(F.$m||F.$p&&F.$g.origin===`${A.vscodeFileResource}://${m.a}`)?R.with({scheme:A.vscodeFileResource,authority:R.authority||m.a,query:null,fragment:null}):R}asFileUri(R){const I=this.b(R,fe);return this.uriToFileUri(I)}uriToFileUri(R){return R.scheme===A.vscodeFileResource?R.with({scheme:A.file,authority:R.authority!==m.a?R.authority:null,query:null,fragment:null}):R}b(R,I){return h.URI.isUri(R)?R:h.URI.parse(I.toUrl(R))}}e.$4e=new m;var E;(function(b){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(R.get("3"));const I="vscode-coi";function $(S){let p;typeof S=="string"?p=new URL(S).searchParams:S instanceof URL?p=S.searchParams:h.URI.isUri(S)&&(p=new URL(S.toString(!0)).searchParams);const r=p?.get(I);if(r)return R.get(r)}b.getHeadersFromQuery=$;function D(S,p,r){if(!globalThis.crossOriginIsolated)return;const s=p&&r?"3":r?"2":"1";S instanceof URLSearchParams?S.set(I,s):S[I]=s}b.addSearchParam=D})(E||(e.COI=E={}))}),define(Se[175],Ce([1,0,150,15,11,2]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WC=void 0;class P{constructor($,D,S){this.id=$,this.dependencies=D,this.callback=S}}class m{static{this.INSTANCE=new m}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,D,S)=>{typeof $!="string"&&(S=D,D=$,$=null),(typeof D!="object"||!Array.isArray(D))&&(S=D,D=null),this.c.push(new P($,D,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const D=await(this.a?this.i($):this.b?this.h($):this.j($));if(!D)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(D.dependencies)&&D.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${D.dependencies.join(", ")}`);return typeof D.callback=="function"?D.callback([]):D.callback}h($){return new Promise((D,S)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const r=()=>{p.removeEventListener("load",s),p.removeEventListener("error",c)},s=f=>{r(),D(this.c.pop())},c=f=>{r(),S(f)};p.addEventListener("load",s),p.addEventListener("error",c),this.f&&($=this.f.createScriptURL($)),p.setAttribute("src",$),document.getElementsByTagName("head")[0].appendChild(p)})}i($){return new Promise((D,S)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),D(this.c.pop())}catch(p){S(p)}})}async j($){try{const D=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,r=A.URI.parse($).fsPath,s=D.readFileSync(r).toString(),c=p.wrap(s.replace(/^#!.*/,""));return new S.Script(c).runInThisContext().apply(),this.c.pop()}catch(D){throw D}}}const E=new Map;let b={};typeof globalThis.require=="object"&&(b=globalThis.require.paths??{});async function R(I,$,D){if(k.$R){D===void 0&&(D=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),b[I]&&(I=b[I]);const S=`${I}/${$}`;if(E.has(S))return E.get(S);let p;if(/^\w[\w\d+.-]*:\/\//.test(S))p=S;else{const f=`${D&&!h.$o?F.$2e:F.$1e}/${S}`;p=F.$4e.asBrowserUri(f).toString(!0)}const r=m.INSTANCE.load(p);return E.set(S,r),r}else return await new Promise((S,p)=>{fe([I],S,p)})}e.$WC=R}),define(Se[24],Ce([1,0,31,15,13,11,12,2]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.DataUri=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=void 0;function E(D){return(0,m.$Ve)(D,!0)}e.$Xf=E;class b{constructor(S){this.a=S}compare(S,p,r=!1){return S===p?0:(0,P.$Fd)(this.getComparisonKey(S,r),this.getComparisonKey(p,r))}isEqual(S,p,r=!1){return S===p?!0:!S||!p?!1:this.getComparisonKey(S,r)===this.getComparisonKey(p,r)}getComparisonKey(S,p=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,p,r=!1){if(S.scheme===p.scheme){if(S.scheme===F.Schemas.file)return k.$Ke(E(S),E(p),this.a(S))&&S.query===p.query&&(r||S.fragment===p.fragment);if((0,e.$cg)(S.authority,p.authority))return k.$Ke(S.path,p.path,this.a(S),"/")&&S.query===p.query&&(r||S.fragment===p.fragment)}return!1}joinPath(S,...p){return m.URI.joinPath(S,...p)}basenameOrAuthority(S){return(0,e.$7f)(S)||S.authority}basename(S){return h.$0b.basename(S.path)}extname(S){return h.$0b.extname(S.path)}dirname(S){if(S.path.length===0)return S;let p;return S.scheme===F.Schemas.file?p=m.URI.file(h.$dc(E(S))).path:(p=h.$0b.dirname(S.path),S.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),p="/")),S.with({path:p})}normalizePath(S){if(!S.path.length)return S;let p;return S.scheme===F.Schemas.file?p=m.URI.file(h.$$b(E(S))).path:p=h.$0b.normalize(S.path),S.with({path:p})}relativePath(S,p){if(S.scheme!==p.scheme||!(0,e.$cg)(S.authority,p.authority))return;if(S.scheme===F.Schemas.file){const c=h.$cc(E(S),E(p));return A.$i?k.$Ee(c):c}let r=S.path||"/";const s=p.path||"/";if(this.a(S)){let c=0;for(const f=Math.min(r.length,s.length);c<f&&!(r.charCodeAt(c)!==s.charCodeAt(c)&&r.charAt(c).toLowerCase()!==s.charAt(c).toLowerCase());c++);r=s.substr(0,c)+r.substr(c)}return h.$0b.relative(r,s)}resolvePath(S,p){if(S.scheme===F.Schemas.file){const r=m.URI.file(h.$bc(E(S),p));return S.with({authority:r.authority,path:r.path})}return p=k.$Fe(p),S.with({path:h.$0b.resolve(S.path,p)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,p){return S===p||S!==void 0&&p!==void 0&&(0,P.$Md)(S,p)}hasTrailingPathSeparator(S,p=h.sep){if(S.scheme===F.Schemas.file){const r=E(S);return r.length>k.$Ge(r).length&&r[r.length-1]===p}else{const r=S.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,p=h.sep){return(0,e.$dg)(S,p)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,p=h.sep){let r=!1;if(S.scheme===F.Schemas.file){const s=E(S);r=s!==void 0&&s.length===k.$Ge(s).length&&s[s.length-1]===p}else{p="/";const s=S.path;r=s.length===1&&s.charCodeAt(s.length-1)===47}return!r&&!(0,e.$dg)(S,p)?S.with({path:S.path+"/"}):S}}e.$Yf=b,e.$Zf=new b(()=>!1),e.$1f=new b(D=>D.scheme===F.Schemas.file?!A.$k:!0),e.$2f=new b(D=>!0),e.$3f=e.$Zf.isEqual.bind(e.$Zf),e.$4f=e.$Zf.isEqualOrParent.bind(e.$Zf),e.$5f=e.$Zf.getComparisonKey.bind(e.$Zf),e.$6f=e.$Zf.basenameOrAuthority.bind(e.$Zf),e.$7f=e.$Zf.basename.bind(e.$Zf),e.$8f=e.$Zf.extname.bind(e.$Zf),e.$9f=e.$Zf.dirname.bind(e.$Zf),e.$0f=e.$Zf.joinPath.bind(e.$Zf),e.$$f=e.$Zf.normalizePath.bind(e.$Zf),e.$_f=e.$Zf.relativePath.bind(e.$Zf),e.$ag=e.$Zf.resolvePath.bind(e.$Zf),e.$bg=e.$Zf.isAbsolutePath.bind(e.$Zf),e.$cg=e.$Zf.isEqualAuthority.bind(e.$Zf),e.$dg=e.$Zf.hasTrailingPathSeparator.bind(e.$Zf),e.$eg=e.$Zf.removeTrailingPathSeparator.bind(e.$Zf),e.$fg=e.$Zf.addTrailingPathSeparator.bind(e.$Zf);function R(D,S){const p=[];for(let r=0;r<D.length;r++){const s=S(D[r]);D.some((c,f)=>f===r?!1:(0,e.$4f)(s,S(c)))||p.push(D[r])}return p}e.$gg=R;var I;(function(D){D.META_DATA_LABEL="label",D.META_DATA_DESCRIPTION="description",D.META_DATA_SIZE="size",D.META_DATA_MIME="mime";function S(p){const r=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(f=>{const[y,C]=f.split(":");y&&C&&r.set(y,C)});const c=p.path.substring(0,p.path.indexOf(";"));return c&&r.set(D.META_DATA_MIME,c),r}D.parseMetaData=S})(I||(e.DataUri=I={}));function $(D,S,p){if(S){let r=D.path;return r&&r[0]!==h.$0b.sep&&(r=h.$0b.sep+r),D.with({scheme:p,authority:S,path:r})}return D.with({scheme:p})}e.$hg=$}),define(Se[17],Ce([1,0,21,8,3,4,24,11,154]),function(fe,e,k,F,h,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.$Rg=e.$Qg=e.Promises=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function b(ce){return!!ce&&typeof ce.then=="function"}e.$ig=b;function R(ce){const z=new k.$ed,ie=ce(z.token),Ee=new Promise((Re,ye)=>{const X=z.token.onCancellationRequested(()=>{X.dispose(),z.dispose(),ye(new F.$3)});Promise.resolve(ie).then(he=>{X.dispose(),z.dispose(),Re(he)},he=>{X.dispose(),z.dispose(),ye(he)})});return new class{cancel(){z.cancel()}then(Re,ye){return Ee.then(Re,ye)}catch(Re){return this.then(void 0,Re)}finally(Re){return Ee.finally(Re)}}}e.$jg=R;function I(ce,z,ie){return new Promise((Ee,Re)=>{const ye=z.onCancellationRequested(()=>{ye.dispose(),Ee(ie)});ce.then(Ee,Re).finally(()=>ye.dispose())})}e.$kg=I;function $(ce,z){return new Promise((ie,Ee)=>{const Re=z.onCancellationRequested(()=>{Re.dispose(),Ee(new F.$3)});ce.then(ie,Ee).finally(()=>Re.dispose())})}e.$lg=$;async function D(ce){let z=-1;const ie=ce.map((Ee,Re)=>Ee.then(ye=>(z=Re,ye)));try{return await Promise.race(ie)}finally{ce.forEach((Ee,Re)=>{Re!==z&&Ee.cancel()})}}e.$mg=D;function S(ce,z,ie){let Ee;const Re=setTimeout(()=>{Ee?.(void 0),ie?.()},z);return Promise.race([ce.finally(()=>clearTimeout(Re)),new Promise(ye=>Ee=ye)])}e.$ng=S;function p(ce){return new Promise((z,ie)=>{const Ee=ce();b(Ee)?Ee.then(z,ie):z(Ee)})}e.$og=p;class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(z){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=z,!this.b){const ie=()=>{if(this.b=null,this.f)return;const Ee=this.queue(this.d);return this.d=null,Ee};this.b=new Promise(Ee=>{this.a.then(ie,ie).then(Ee)})}return new Promise((ie,Ee)=>{this.b.then(ie,Ee)})}return this.a=z(),new Promise((ie,Ee)=>{this.a.then(Re=>{this.a=null,ie(Re)},Re=>{this.a=null,Ee(Re)})})}dispose(){this.f=!0}}e.$pg=r;class s{constructor(){this.a=Promise.resolve(null)}queue(z){return this.a=this.a.then(()=>z(),()=>z())}}e.$qg=s;class c{constructor(){this.a=new Map}queue(z,ie){const Re=(this.a.get(z)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(z)===Re&&this.a.delete(z)});return this.a.set(z,Re),Re}}e.$rg=c;const f=(ce,z)=>{let ie=!0;const Ee=setTimeout(()=>{ie=!1,z()},ce);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(Ee),ie=!1}}},y=ce=>{let z=!0;return queueMicrotask(()=>{z&&(z=!1,ce())}),{isTriggered:()=>z,dispose:()=>{z=!1}}};class C{constructor(z){this.defaultDelay=z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(z,ie=this.defaultDelay){this.g=z,this.h(),this.b||(this.b=new Promise((Re,ye)=>{this.d=Re,this.f=ye}).then(()=>{if(this.b=null,this.d=null,this.g){const Re=this.g;return this.g=null,Re()}}));const Ee=()=>{this.a=null,this.d?.(null)};return this.a=ie===E.$5c?y(Ee):f(ie,Ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$sg=C;class i{constructor(z){this.a=new C(z),this.b=new r}trigger(z,ie){return this.a.trigger(()=>this.b.queue(z),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$tg=i;class o{constructor(){this.a=!1,this.b=new Promise((z,ie)=>{this.d=z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ug=o;class n extends o{constructor(z){super(),this.f=setTimeout(()=>this.open(),z)}open(){clearTimeout(this.f),super.open()}}e.$vg=n;function t(ce,z){return z?new Promise((ie,Ee)=>{const Re=setTimeout(()=>{ye.dispose(),ie()},ce),ye=z.onCancellationRequested(()=>{clearTimeout(Re),ye.dispose(),Ee(new F.$3)})}):R(ie=>t(ce,ie))}e.$wg=t;function a(ce,z=0){const ie=setTimeout(ce,z);return(0,A.$jb)(()=>clearTimeout(ie))}e.$xg=a;function g(ce){const z=[];let ie=0;const Ee=ce.length;function Re(){return ie<Ee?ce[ie++]():null}function ye(X){X!=null&&z.push(X);const he=Re();return he?he.then(ye):Promise.resolve(z)}return Promise.resolve(null).then(ye)}e.$yg=g;function u(ce,z=Ee=>!!Ee,ie=null){let Ee=0;const Re=ce.length,ye=()=>{if(Ee>=Re)return Promise.resolve(ie);const X=ce[Ee++];return Promise.resolve(X()).then(K=>z(K)?Promise.resolve(K):ye())};return ye()}e.$zg=u;function d(ce,z=Ee=>!!Ee,ie=null){if(ce.length===0)return Promise.resolve(ie);let Ee=ce.length;const Re=()=>{Ee=-1;for(const ye of ce)ye.cancel?.()};return new Promise((ye,X)=>{for(const he of ce)he.then(K=>{--Ee>=0&&z(K)?(Re(),ye(K)):Ee===0&&ye(ie)}).catch(K=>{--Ee>=0&&(Re(),X(K))})})}e.$Ag=d;class v{constructor(z){this.a=0,this.d=z,this.f=[],this.b=0,this.g=new h.$8c}get onDrained(){return this.g.event}get size(){return this.a}queue(z){return this.a++,new Promise((ie,Ee)=>{this.f.push({factory:z,c:ie,e:Ee}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const z=this.f.shift();this.b++;const ie=z.factory();ie.then(z.c,z.e),ie.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Bg=v;class l extends v{constructor(){super(1)}}e.$Cg=l;class w{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const z=new x;return this.b.add(z),z.p}d(){for(const[,z]of this.a)if(z.size>0)return!1;return!0}queueFor(z,ie=P.$Zf){const Ee=ie.getComparisonKey(z);let Re=this.a.get(Ee);return Re||(Re=new l,h.Event.once(Re.onDrained)(()=>{Re?.dispose(),this.a.delete(Ee),this.f()}),this.a.set(Ee,Re)),Re}f(){this.d()&&this.g()}g(){for(const z of this.b)z.complete();this.b.clear()}dispose(){for(const[,z]of this.a)z.dispose();this.a.clear(),this.g()}}e.$Dg=w;class L{constructor(z,ie){this.a=-1,typeof z=="function"&&typeof ie=="number"&&this.setIfNotSet(z,ie)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(z,ie){this.cancel(),this.a=setTimeout(()=>{this.a=-1,z()},ie)}setIfNotSet(z,ie){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,z()},ie))}}e.$Eg=L;class O{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(z,ie){this.cancel(),this.a=setInterval(()=>{z()},ie)}}e.$Fg=O;class N{constructor(z,ie){this.b=-1,this.a=z,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(z=this.d){this.cancel(),this.b=setTimeout(this.f,z)}get delay(){return this.d}set delay(z){this.d=z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Gg=N;class T{constructor(z,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=z,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(z=this.b){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Hg=T;class j extends N{constructor(z,ie){super(z,ie),this.j=[]}work(z){this.j.push(z),this.isScheduled()||this.schedule()}h(){const z=this.j;this.j=[],this.a?.(z)}dispose(){this.j=[],super.dispose()}}e.$Ig=j;class W extends A.$lb{constructor(z,ie){super(),this.g=z,this.h=ie,this.a=[],this.b=this.B(new A.$mb),this.f=!1}get pending(){return this.a.length}work(z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+z.length>this.g.maxBufferedWork)return!1}else if(this.pending+z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of z)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Jg=W,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Kg=ce=>{(0,m.$A)(()=>{if(z)return;const ie=Date.now()+15;ce(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let z=!1;return{dispose(){z||(z=!0)}}}:e.$Kg=(ce,z)=>{const ie=requestIdleCallback(ce,typeof z=="number"?{timeout:z}:void 0);let Ee=!1;return{dispose(){Ee||(Ee=!0,cancelIdleCallback(ie))}}}}();class M{constructor(z){this.d=!1,this.a=()=>{try{this.f=z()}catch(ie){this.g=ie}finally{this.d=!0}},this.b=(0,e.$Kg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Lg=M;async function Y(ce,z,ie){let Ee;for(let Re=0;Re<ie;Re++)try{return await ce()}catch(ye){Ee=ye,await t(z)}throw Ee}e.$Mg=Y;class V{hasPending(z){return this.a?typeof z=="number"?this.a.taskId===z:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(z,ie,Ee){return this.a={taskId:z,cancel:()=>Ee?.(),promise:ie},ie.then(()=>this.d(z),()=>this.d(z)),ie}d(z){this.a&&z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const z=this.b;this.b=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this.b)this.b.run=z;else{let ie,Ee;const Re=new Promise((ye,X)=>{ie=ye,Ee=X});this.b={run:z,promise:Re,promiseResolve:ie,promiseReject:Ee}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ng=V;class de{constructor(z,ie=()=>Date.now()){this.d=z,this.f=ie,this.a=0,this.b=0}increment(){const z=this.f();return z-this.a>this.d&&(this.a=z,this.b=0),this.b++,this.b}}e.$Og=de;var re;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})(re||(re={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((z,ie)=>{this.a=z,this.b=ie})}complete(z){return new Promise(ie=>{this.a(z),this.d={outcome:0,value:z},ie()})}error(z){return new Promise(ie=>{this.b(z),this.d={outcome:1,value:z},ie()})}cancel(){return this.error(new F.$3)}}e.$Pg=x;var q;(function(ce){async function z(Ee){let Re;const ye=await Promise.all(Ee.map(X=>X.then(he=>he,he=>{Re||(Re=he)})));if(typeof Re<"u")throw Re;return ye}ce.settled=z;function ie(Ee){return new Promise(async(Re,ye)=>{try{await Ee(Re,ye)}catch(X){ye(X)}})}ce.withAsyncBody=ie})(q||(e.Promises=q={}));var ne;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(ne||(ne={}));class pe{static fromArray(z){return new pe(ie=>{ie.emitMany(z)})}static fromPromise(z){return new pe(async ie=>{ie.emitMany(await z)})}static fromPromises(z){return new pe(async ie=>{await Promise.all(z.map(async Ee=>ie.emitOne(await Ee)))})}static merge(z){return new pe(async ie=>{await Promise.all(z.map(async Ee=>{for await(const Re of Ee)ie.emitOne(Re)}))})}static{this.EMPTY=pe.fromArray([])}constructor(z){this.a=0,this.b=[],this.d=null,this.f=new h.$8c,queueMicrotask(async()=>{const ie={emitOne:Ee=>this.g(Ee),emitMany:Ee=>this.h(Ee),reject:Ee=>this.k(Ee)};try{await Promise.resolve(z(ie)),this.j()}catch(Ee){this.k(Ee)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}[Symbol.asyncIterator](){let z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(z<this.b.length)return{done:!1,value:this.b[z++]};if(this.a===1)return{done:!0,value:void 0};await h.Event.toPromise(this.f.event)}while(!0)}}}static map(z,ie){return new pe(async Ee=>{for await(const Re of z)Ee.emitOne(ie(Re))})}map(z){return pe.map(this,z)}static filter(z,ie){return new pe(async Ee=>{for await(const Re of z)ie(Re)&&Ee.emitOne(Re)})}filter(z){return pe.filter(this,z)}static coalesce(z){return pe.filter(z,ie=>!!ie)}coalesce(){return pe.coalesce(this)}static async toPromise(z){const ie=[];for await(const Ee of z)ie.push(Ee);return ie}toPromise(){return pe.toPromise(this)}g(z){this.a===0&&(this.b.push(z),this.f.fire())}h(z){this.a===0&&(this.b=this.b.concat(z),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(z){this.a===0&&(this.a=2,this.d=z,this.f.fire())}}e.$Qg=pe;class H extends pe{constructor(z,ie){super(ie),this.l=z}cancel(){this.l.cancel()}}e.$Rg=H;function ue(ce){const z=new k.$ed,ie=ce(z.token);return new H(z,async Ee=>{const Re=z.token.onCancellationRequested(()=>{Re.dispose(),z.dispose(),Ee.reject(new F.$3)});try{for await(const ye of ie){if(z.token.isCancellationRequested)return;Ee.emitOne(ye)}Re.dispose(),z.dispose()}catch(ye){Re.dispose(),z.dispose(),Ee.reject(ye)}})}e.$Sg=ue}),define(Se[34],Ce([1,0,19,17,31,28,13,11,12]),function(fe,e,k,F,h,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=void 0;function b(){return Object.create(null)}e.$_i=b,e.$aj="**",e.$bj="/";const R="[/\\\\]",I="[^/\\\\]",$=/\//g;function D(de,re){switch(de){case 0:return"";case 1:return`${I}*?`;default:return`(?:${R}|${I}+${R}${re?`|${R}${I}+`:""})*?`}}function S(de,re){if(!de)return[];const x=[];let q=!1,ne=!1,pe="";for(const H of de){switch(H){case re:if(!q&&!ne){x.push(pe),pe="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}pe+=H}return pe&&x.push(pe),x}e.$cj=S;function p(de){if(!de)return"";let re="";const x=S(de,e.$bj);if(x.every(q=>q===e.$aj))re=".*";else{let q=!1;x.forEach((ne,pe)=>{if(ne===e.$aj){if(q)return;re+=D(2,pe===x.length-1)}else{let H=!1,ue="",ce=!1,z="";for(const ie of ne){if(ie!=="}"&&H){ue+=ie;continue}if(ce&&(ie!=="]"||!z)){let Ee;ie==="-"?Ee=ie:(ie==="^"||ie==="!")&&!z?Ee="^":ie===e.$bj?Ee="":Ee=(0,E.$od)(ie),z+=Ee;continue}switch(ie){case"{":H=!0;continue;case"[":ce=!0;continue;case"}":{const Re=`(?:${S(ue,",").map(ye=>p(ye)).join("|")})`;re+=Re,H=!1,ue="";break}case"]":{re+="["+z+"]",ce=!1,z="";break}case"?":re+=I;continue;case"*":re+=D(1);continue;default:re+=(0,E.$od)(ie)}}pe<x.length-1&&(x[pe+1]!==e.$aj||pe+2<x.length)&&(re+=R)}q=ne===e.$aj})}return re}const r=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new A.$qi(1e4),o=function(){return!1},n=function(){return null};function t(de,re){if(!de)return n;let x;typeof de!="string"?x=de.pattern:x=de,x=x.trim();const q=`${x}_${!!re.trimForExclusions}`;let ne=i.get(q);if(ne)return a(ne,de);let pe;return r.test(x)?ne=u(x.substr(4),x):(pe=s.exec(g(x,re)))?ne=d(pe[1],x):(re.trimForExclusions?f:c).test(x)?ne=v(x,re):(pe=y.exec(g(x,re)))?ne=l(pe[1].substr(1),x,!0):(pe=C.exec(g(x,re)))?ne=l(pe[1],x,!1):ne=w(x),i.set(q,ne),a(ne,de)}function a(de,re){if(typeof re=="string")return de;const x=function(q,ne){return(0,h.$Ke)(q,re.base,!m.$k)?de((0,E.$sd)(q.substr(re.base.length),P.sep),ne):null};return x.allBasenames=de.allBasenames,x.allPaths=de.allPaths,x.basenames=de.basenames,x.patterns=de.patterns,x}function g(de,re){return re.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function u(de,re){return function(x,q){return typeof x=="string"&&x.endsWith(de)?re:null}}function d(de,re){const x=`/${de}`,q=`\\${de}`,ne=function(H,ue){return typeof H!="string"?null:ue?ue===de?re:null:H===de||H.endsWith(x)||H.endsWith(q)?re:null},pe=[de];return ne.basenames=pe,ne.patterns=[re],ne.allBasenames=pe,ne}function v(de,re){const x=Y(de.slice(1,-1).split(",").map(ue=>t(ue,re)).filter(ue=>ue!==n),de),q=x.length;if(!q)return n;if(q===1)return x[0];const ne=function(ue,ce){for(let z=0,ie=x.length;z<ie;z++)if(x[z](ue,ce))return de;return null},pe=x.find(ue=>!!ue.allBasenames);pe&&(ne.allBasenames=pe.allBasenames);const H=x.reduce((ue,ce)=>ce.allPaths?ue.concat(ce.allPaths):ue,[]);return H.length&&(ne.allPaths=H),ne}function l(de,re,x){const q=P.sep===P.$0b.sep,ne=q?de:de.replace($,P.sep),pe=P.sep+ne,H=P.$0b.sep+de;let ue;return x?ue=function(ce,z){return typeof ce=="string"&&(ce===ne||ce.endsWith(pe)||!q&&(ce===de||ce.endsWith(H)))?re:null}:ue=function(ce,z){return typeof ce=="string"&&(ce===ne||!q&&ce===de)?re:null},ue.allPaths=[(x?"*/":"./")+de],ue}function w(de){try{const re=new RegExp(`^${p(de)}$`);return function(x){return re.lastIndex=0,typeof x=="string"&&re.test(x)?de:null}}catch{return n}}function L(de,re,x){return!de||typeof re!="string"?!1:O(de)(re,void 0,x)}e.$dj=L;function O(de,re={}){if(!de)return o;if(typeof de=="string"||N(de)){const x=t(de,re);if(x===n)return o;const q=function(ne,pe){return!!x(ne,pe)};return x.allBasenames&&(q.allBasenames=x.allBasenames),x.allPaths&&(q.allPaths=x.allPaths),q}return W(de,re)}e.$ej=O;function N(de){const re=de;return re?typeof re.base=="string"&&typeof re.pattern=="string":!1}e.$fj=N;function T(de){return de.allBasenames||[]}e.$gj=T;function j(de){return de.allPaths||[]}e.$hj=j;function W(de,re){const x=Y(Object.getOwnPropertyNames(de).map(ue=>M(ue,de[ue],re)).filter(ue=>ue!==n)),q=x.length;if(!q)return n;if(!x.some(ue=>!!ue.requiresSiblings)){if(q===1)return x[0];const ue=function(ie,Ee){let Re;for(let ye=0,X=x.length;ye<X;ye++){const he=x[ye](ie,Ee);if(typeof he=="string")return he;(0,F.$ig)(he)&&(Re||(Re=[]),Re.push(he))}return Re?(async()=>{for(const ye of Re){const X=await ye;if(typeof X=="string")return X}return null})():null},ce=x.find(ie=>!!ie.allBasenames);ce&&(ue.allBasenames=ce.allBasenames);const z=x.reduce((ie,Ee)=>Ee.allPaths?ie.concat(Ee.allPaths):ie,[]);return z.length&&(ue.allPaths=z),ue}const ne=function(ue,ce,z){let ie,Ee;for(let Re=0,ye=x.length;Re<ye;Re++){const X=x[Re];X.requiresSiblings&&z&&(ce||(ce=(0,P.$ec)(ue)),ie||(ie=ce.substr(0,ce.length-(0,P.$fc)(ue).length)));const he=X(ue,ce,ie,z);if(typeof he=="string")return he;(0,F.$ig)(he)&&(Ee||(Ee=[]),Ee.push(he))}return Ee?(async()=>{for(const Re of Ee){const ye=await Re;if(typeof ye=="string")return ye}return null})():null},pe=x.find(ue=>!!ue.allBasenames);pe&&(ne.allBasenames=pe.allBasenames);const H=x.reduce((ue,ce)=>ce.allPaths?ue.concat(ce.allPaths):ue,[]);return H.length&&(ne.allPaths=H),ne}function M(de,re,x){if(re===!1)return n;const q=t(de,x);if(q===n)return n;if(typeof re=="boolean")return q;if(re){const ne=re.when;if(typeof ne=="string"){const pe=(H,ue,ce,z)=>{if(!z||!q(H,ue))return null;const ie=ne.replace("$(basename)",()=>ce),Ee=z(ie);return(0,F.$ig)(Ee)?Ee.then(Re=>Re?de:null):Ee?de:null};return pe.requiresSiblings=!0,pe}}return q}function Y(de,re){const x=de.filter(ue=>!!ue.basenames);if(x.length<2)return de;const q=x.reduce((ue,ce)=>{const z=ce.basenames;return z?ue.concat(z):ue},[]);let ne;if(re){ne=[];for(let ue=0,ce=q.length;ue<ce;ue++)ne.push(re)}else ne=x.reduce((ue,ce)=>{const z=ce.patterns;return z?ue.concat(z):ue},[]);const pe=function(ue,ce){if(typeof ue!="string")return null;if(!ce){let ie;for(ie=ue.length;ie>0;ie--){const Ee=ue.charCodeAt(ie-1);if(Ee===47||Ee===92)break}ce=ue.substr(ie)}const z=q.indexOf(ce);return z!==-1?ne[z]:null};pe.basenames=q,pe.patterns=ne,pe.allBasenames=q;const H=de.filter(ue=>!ue.basenames);return H.push(pe),H}function V(de,re){return(0,k.$bf)(de,re,(x,q)=>typeof x=="string"&&typeof q=="string"?x===q:typeof x!="string"&&typeof q!="string"?x.base===q.base&&x.pattern===q.pattern:!1)}e.$ij=V}),define(Se[74],Ce([1,0,8,155,24,12,2]),function(fe,e,k,F,h,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class E{constructor(s="",c=!1){if(this.value=s,typeof this.value!="string")throw(0,k.$5)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(s,c=0){return this.value+=$(this.supportThemeIcons?(0,F.$Ej)(s):s).replace(/([ \t]+)/g,(f,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,c){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(s,c,f){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(s),")"),f&&(this.value+=` "${this.c(this.c(f,'"'),")")}"`),this.value+=")",this}c(s,c){const f=new RegExp((0,A.$od)(c),"g");return s.replace(f,(y,C)=>s.charAt(C-1)!=="\\"?`\\${y}`:y)}}e.$Kj=E;function b(r){return R(r)?!r.value:Array.isArray(r)?r.every(b):!0}e.$Lj=b;function R(r){return r instanceof E?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.$Mj=R;function I(r,s){return r===s?!0:!r||!s?!1:r.value===s.value&&r.isTrusted===s.isTrusted&&r.supportThemeIcons===s.supportThemeIcons&&r.supportHtml===s.supportHtml&&(r.baseUri===s.baseUri||!!r.baseUri&&!!s.baseUri&&(0,h.$3f)(P.URI.from(r.baseUri),P.URI.from(s.baseUri)))}e.$Nj=I;function $(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Oj=$;function D(r){return r.replace(/"/g,"&quot;")}e.$Pj=D;function S(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Qj=S;function p(r){const s=[],c=r.split("|").map(y=>y.trim());r=c[0];const f=c[1];if(f){const y=/height=(\d+)/.exec(f),C=/width=(\d+)/.exec(f),i=y?y[1]:"",o=C?C[1]:"",n=isFinite(parseInt(o)),t=isFinite(parseInt(i));n&&s.push(`width="${o}"`),t&&s.push(`height="${i}"`)}return{href:r,dimensions:s}}e.$Rj=p}),define(Se[120],Ce([1,0,19,31,13,11,24,12]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9z=e.$8z=e.$7z=e.$6z=e.$5z=e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=void 0;function E(t,a){const{os:g,tildify:u,relative:d}=a;if(d){const w=b(t,d,g);if(typeof w=="string")return w}let v=t.fsPath;if(g===1&&!A.$i?v=v.replace(/\//g,"\\"):g!==1&&A.$i&&(v=v.replace(/\\/g,"/")),g!==1&&u?.userHome){const w=u.userHome.fsPath;let L;t.scheme!==u.userHome.scheme&&t.path.startsWith(h.$0b.sep)?L=u.userHome.with({path:t.path}).fsPath:L=t.fsPath,v=$(L,w,g)}return(g===1?h.$9b:h.$0b).normalize(R(v,g===1))}e.$Zz=E;function b(t,a,g){const u=g===1?h.$9b:h.$0b,d=g===3?P.$Zf:P.$2f,v=a.getWorkspace(),l=(0,k.$vf)(v.folders);if(!l)return;t.scheme!==l.uri.scheme&&t.path.startsWith(h.$0b.sep)&&(t=l.uri.with({path:t.path}));const w=a.getWorkspaceFolder(t);if(!w)return;let L;if(d.isEqual(w.uri,t)?L="":L=d.relativePath(w.uri,t)??"",L&&(L=u.normalize(L)),v.folders.length>1&&!a.noPrefix){const O=w.name?w.name:d.basenameOrAuthority(w.uri);L=L?`${O} \u2022 ${L}`:O}return L}function R(t,a=A.$i){return(0,F.$Oe)(t,a)?t.charAt(0).toUpperCase()+t.slice(1):t}e.$1z=R;let I=Object.create(null);function $(t,a,g=A.OS){if(g===1||!t||!a)return t;let u=I.original===a?I.normalized:void 0;u||(u=a,A.$i&&(u=(0,F.$Ee)(u)),u=`${(0,m.$td)(u,h.$0b.sep)}${h.$0b.sep}`,I={original:a,normalized:u});let d=t;return A.$i&&(d=(0,F.$Ee)(d)),(g===3?d.startsWith(u):(0,m.$Nd)(d,u))?`~/${d.substr(u.length)}`:t}e.$2z=$;function D(t,a){return t.replace(/^~($|\/|\\)/,`${a}$1`)}e.$3z=D;const S="\u2026",p="\\\\",r="~";function s(t,a=h.sep){const g=new Array(t.length);let u=!1;for(let d=0;d<t.length;d++){const v=t[d];if(v===""){g[d]=`.${a}`;continue}if(!v){g[d]=v;continue}u=!0;let l="",w=v;w.indexOf(p)===0?(l=w.substr(0,w.indexOf(p)+p.length),w=w.substr(w.indexOf(p)+p.length)):w.indexOf(a)===0?(l=w.substr(0,w.indexOf(a)+a.length),w=w.substr(w.indexOf(a)+a.length)):w.indexOf(r)===0&&(l=w.substr(0,w.indexOf(r)+r.length),w=w.substr(w.indexOf(r)+r.length));const L=w.split(a);for(let O=1;u&&O<=L.length;O++)for(let N=L.length-O;u&&N>=0;N--){u=!1;let T=L.slice(N,N+O).join(a);for(let j=0;!u&&j<t.length;j++)if(j!==d&&t[j]&&t[j].indexOf(T)>-1){const W=N+O===L.length,M=N>0&&t[j].indexOf(a)>-1?a+T:T,Y=t[j].endsWith(M);u=!W||Y}if(!u){let j="";(L[0].endsWith(":")||l!=="")&&(N===1&&(N=0,O++,T=L[0]+a+T),N>0&&(j=L[0]+a),j=l+j),N>0&&(j=j+S+a),j=j+T,N+O<L.length&&(j=j+a+S),g[d]=j}}u&&(g[d]=v)}return g}e.$4z=s;var c;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function f(t,a=Object.create(null)){const g=[];let u=!1,d="";for(const v of t)if(v==="$"||u&&v==="{")d&&g.push({value:d,type:c.TEXT}),d="",u=!0;else if(v==="}"&&u){const l=a[d];if(typeof l=="string")l.length&&g.push({value:l,type:c.VARIABLE});else if(l){const w=g[g.length-1];(!w||w.type!==c.SEPARATOR)&&g.push({value:l.label,type:c.SEPARATOR})}d="",u=!1}else d+=v;return d&&!u&&g.push({value:d,type:c.TEXT}),g.filter((v,l)=>{if(v.type===c.SEPARATOR){const w=g[l-1],L=g[l+1];return[w,L].every(O=>O&&(O.type===c.VARIABLE||O.type===c.TEXT)&&O.value.length>0)}return!0}).map(v=>v.value).join("")}e.$5z=f;function y(t,a){return A.$j||a?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):t.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.$6z=y;function C(t,a){return A.$j||a?t.replace(/\(&&\w\)|&&/g,""):A.$i?t.replace(/&&|&/g,g=>g==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.$7z=C;function i(t){return t.replace(/&/g,"&&")}e.$8z=i;function o(t){if(t.endsWith("]")){const a=t.lastIndexOf(" [",t.length-2);if(a!==-1){const g=n(t.substring(0,a));return{name:g.name,parentPath:g.parentPath+t.substring(a)}}}return n(t)}e.$9z=o;function n(t){const a=t.indexOf("/")!==-1?h.$0b:h.$9b,g=a.basename(t),u=a.dirname(t);return g.length?{name:g,parentPath:u}:{name:u,parentPath:""}}}),define(Se[121],Ce([1,0,22,2]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=e.$om=e.$nm=void 0;function h(I){return I.toJSON()}class A{constructor($){this.a=$}transformIncoming($){const D=this.a.transformIncoming($);return D===$?$:h(F.URI.from(D))}transformOutgoing($){const D=this.a.transformOutgoing($);return D===$?$:h(F.URI.from(D))}transformOutgoingURI($){const D=this.a.transformOutgoing($);return D===$?$:F.URI.from(D)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$nm=A,e.$om=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function P(I,$,D){if(!I||D>200)return null;if(typeof I=="object"){if(I instanceof F.URI)return $.transformOutgoing(I);for(const S in I)if(Object.hasOwnProperty.call(I,S)){const p=P(I[S],$,D+1);p!==null&&(I[S]=p)}}return null}function m(I,$){const D=P(I,$,0);return D===null?I:D}e.$pm=m;function E(I,$,D,S){if(!I||S>200)return null;if(typeof I=="object"){if(I.$mid===1)return D?F.URI.revive($.transformIncoming(I)):$.transformIncoming(I);if(I instanceof k.$Jb)return null;for(const p in I)if(Object.hasOwnProperty.call(I,p)){const r=E(I[p],$,D,S+1);r!==null&&(I[p]=r)}}return null}function b(I,$){const D=E(I,$,!1,0);return D===null?I:D}e.$qm=b;function R(I,$){const D=E(I,$,!0,0);return D===null?I:D}e.$rm=R}),define(Se[29],Ce([1,0,49,75,350,17,31,69,13,11,24,2]),function(fe,e,k,F,h,A,P,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var $;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function D(M,Y=$.UNLINK,V){if((0,P.$Ne)(M))throw new Error("rimraf - will refuse to recursively delete root");return Y===$.UNLINK?p(M):S(M,V)}async function S(M,Y=(0,P.$Se)((0,F.tmpdir)())){try{try{await k.promises.rename(M,Y)}catch(V){return V.code==="ENOENT"?void 0:p(M)}p(Y).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function p(M){return(0,h.promisify)(k.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function r(M){if((0,P.$Ne)(M))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=r;async function s(M,Y){return y(await(Y?c(M):(0,h.promisify)(k.readdir)(M)))}async function c(M){try{return await(0,h.promisify)(k.readdir)(M,{withFileTypes:!0})}catch(de){console.warn("[node.js fs] readdir with filetypes failed with error: ",de)}const Y=[],V=await s(M);for(const de of V){let re=!1,x=!1,q=!1;try{const ne=await e.Promises.lstat((0,E.$ac)(M,de));re=ne.isFile(),x=ne.isDirectory(),q=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}Y.push({name:de,isFile:()=>re,isDirectory:()=>x,isSymbolicLink:()=>q})}return Y}function f(M){return y(k.readdirSync(M))}e.readdirSync=f;function y(M){return M.map(Y=>typeof Y=="string"?b.$j?(0,m.$7k)(Y):Y:(Y.name=b.$j?(0,m.$7k)(Y.name):Y.name,Y))}async function C(M){const Y=await s(M),V=[];for(const de of Y)await o.existsDirectory((0,E.$ac)(M,de))&&V.push(de);return V}function i(M,Y=1e3){return new Promise(V=>{let de=!1;const re=setInterval(()=>{de||(de=!0,k.access(M,x=>{de=!1,x&&(clearInterval(re),V(void 0))}))},Y)})}e.whenDeleted=i;var o;(function(M){async function Y(re){let x;try{if(x=await e.Promises.lstat(re),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(re),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(b.$i&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(re)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw ne}throw q}}M.stat=Y;async function V(re){try{const{stat:x,symbolicLink:q}=await M.stat(re);return x.isFile()&&q?.dangling!==!0}catch{}return!1}M.existsFile=V;async function de(re){try{const{stat:x,symbolicLink:q}=await M.stat(re);return x.isDirectory()&&q?.dangling!==!0}catch{}return!1}M.existsDirectory=de})(o||(e.SymlinkSupport=o={}));const n=new A.$Dg;function t(M,Y,V){return n.queueFor(I.URI.file(M),R.$1f).queue(()=>{const de=v(V);return new Promise((re,x)=>u(M,Y,de,q=>q?x(q):re()))})}let a=!0;function g(M){a=M}e.configureFlushOnWrite=g;function u(M,Y,V,de){if(!a)return k.writeFile(M,Y,{mode:V.mode,flag:V.flag},de);k.open(M,V.flag,V.mode,(re,x)=>{if(re)return de(re);k.writeFile(x,Y,q=>{if(q)return k.close(x,()=>de(q));k.fdatasync(x,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),g(!1)),k.close(x,pe=>de(pe))))})})}function d(M,Y,V){const de=v(V);if(!a)return k.writeFileSync(M,Y,{mode:de.mode,flag:de.flag});const re=k.openSync(M,de.flag,de.mode);try{k.writeFileSync(re,Y);try{k.fdatasyncSync(re)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),g(!1)}}finally{k.closeSync(re)}}e.writeFileSync=d;function v(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function l(M,Y,V=6e4){if(M!==Y)try{b.$i&&typeof V=="number"?await w(M,Y,Date.now(),V):await(0,h.promisify)(k.rename)(M,Y)}catch(de){if(M.toLowerCase()!==Y.toLowerCase()&&de.code==="EXDEV"||M.endsWith("."))await L(M,Y,{preserveSymlinks:!1}),await D(M,$.MOVE);else throw de}}async function w(M,Y,V,de,re=0){try{return await(0,h.promisify)(k.rename)(M,Y)}catch(x){if(x.code!=="EACCES"&&x.code!=="EPERM"&&x.code!=="EBUSY")throw x;if(Date.now()-V>=de)throw console.error(`[node.js fs] rename failed after ${re} retries with error: ${x}`),x;if(re===0){let q=!1;try{const{stat:ne}=await o.stat(Y);ne.isFile()||(q=!0)}catch{}if(q)throw x}return await(0,A.$wg)(Math.min(100,re*10)),w(M,Y,V,de,re+1)}}async function L(M,Y,V){return N(M,Y,{root:{source:M,target:Y},options:V,handledSourcePaths:new Set})}const O=511;async function N(M,Y,V){if(V.handledSourcePaths.has(M))return;V.handledSourcePaths.add(M);const{stat:de,symbolicLink:re}=await o.stat(M);if(re){if(V.options.preserveSymlinks)try{return await W(M,Y,V)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(re.dangling)return}return de.isDirectory()?T(M,Y,de.mode&O,V):j(M,Y,de.mode&O)}async function T(M,Y,V,de){await e.Promises.mkdir(Y,{recursive:!0,mode:V});const re=await s(M);for(const x of re)await N((0,E.$ac)(M,x),(0,E.$ac)(Y,x),de)}async function j(M,Y,V){await e.Promises.copyFile(M,Y),await e.Promises.chmod(Y,V)}async function W(M,Y,V){let de=await e.Promises.readlink(M);(0,P.$Ke)(de,V.root.source,!b.$k)&&(de=(0,E.$ac)(V.root.target,de.substr(V.root.source.length+1))),await e.Promises.symlink(de,Y)}e.Promises=new class{get access(){return(0,h.promisify)(k.access)}get stat(){return(0,h.promisify)(k.stat)}get lstat(){return(0,h.promisify)(k.lstat)}get utimes(){return(0,h.promisify)(k.utimes)}get read(){return(M,Y,V,de,re)=>new Promise((x,q)=>{k.read(M,Y,V,de,re,(ne,pe,H)=>ne?q(ne):x({bytesRead:pe,buffer:H}))})}get readFile(){return(0,h.promisify)(k.readFile)}get write(){return(M,Y,V,de,re)=>new Promise((x,q)=>{k.write(M,Y,V,de,re,(ne,pe,H)=>ne?q(ne):x({bytesWritten:pe,buffer:H}))})}get appendFile(){return(0,h.promisify)(k.appendFile)}get fdatasync(){return(0,h.promisify)(k.fdatasync)}get truncate(){return(0,h.promisify)(k.truncate)}get copyFile(){return(0,h.promisify)(k.copyFile)}get open(){return(0,h.promisify)(k.open)}get close(){return(0,h.promisify)(k.close)}get symlink(){return(0,h.promisify)(k.symlink)}get readlink(){return(0,h.promisify)(k.readlink)}get chmod(){return(0,h.promisify)(k.chmod)}get mkdir(){return(0,h.promisify)(k.mkdir)}get unlink(){return(0,h.promisify)(k.unlink)}get rmdir(){return(0,h.promisify)(k.rmdir)}get realpath(){return(0,h.promisify)(k.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return C}get writeFile(){return t}get rm(){return D}get rename(){return l}get copy(){return L}}}),define(Se[95],Ce([1,0,49,13,11,12,29]),function(fe,e,k,F,h,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=e.$Kp=e.$Jp=void 0;function m($){if(h.$k)return $;const D=(0,F.$dc)($);if($===D)return $;const S=((0,F.$ec)($)||$).toLowerCase();try{const r=(0,P.readdirSync)(D).filter(s=>s.toLowerCase()===S);if(r.length===1){const s=m(D);if(s)return(0,F.$ac)(s,r[0])}else if(r.length>1){const s=r.indexOf(S);if(s>=0){const c=m(D);if(c)return(0,F.$ac)(c,r[s])}}}catch{}return null}e.$Jp=m;async function E($){if(h.$k)return $;const D=(0,F.$dc)($);if($===D)return $;const S=((0,F.$ec)($)||$).toLowerCase();try{const r=(await P.Promises.readdir(D)).filter(s=>s.toLowerCase()===S);if(r.length===1){const s=await E(D);if(s)return(0,F.$ac)(s,r[0])}else if(r.length>1){const s=r.indexOf(S);if(s>=0){const c=await E(D);if(c)return(0,F.$ac)(c,r[s])}}}catch{}return null}e.$Kp=E;async function b($){try{return await P.Promises.realpath($)}catch{const S=I($);return await P.Promises.access(S,k.constants.R_OK),S}}e.$Lp=b;function R($){try{return k.realpathSync($)}catch{const S=I($);return k.accessSync(S,k.constants.R_OK),S}}e.$Mp=R;function I($){return(0,A.$td)((0,F.$$b)($),F.sep)}}),define(Se[96],Ce([1,0,13,11,41,94,14,29]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$il=e.$hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function E(I=h.env){return I.comspec||"cmd.exe"}e.$hl=E;function b(I){let $=[],D=!1;const S=function(p){if(D){$.push(p);return}(!I.send(p,s=>{if(s&&console.error(s),D=!1,$.length>0){const c=$.slice(0);$=[],c.forEach(f=>S(f))}})||F.$i)&&(D=!0)};return{send:S}}e.$il=b;var R;(function(I){async function $(D,S,p){if(k.$_b(D))return D;if(S===void 0&&(S=h.cwd()),k.$dc(D)!=="."||(p===void 0&&P.$je(h.env.PATH)&&(p=h.env.PATH.split(k.$kc)),p===void 0||p.length===0))return k.$ac(S,D);async function s(c){if(await m.Promises.exists(c)){let f;try{f=await m.Promises.stat(c)}catch(y){y.message.startsWith("EACCES")&&(f=await m.Promises.lstat(c))}return f?!f.isDirectory():!1}return!1}for(const c of p){let f;if(k.$_b(c)?f=k.$ac(c,D):f=k.$ac(S,c,D),await s(f))return f;let y=f+".com";if(await s(y)||(y=f+".exe",await s(y)))return y}return k.$ac(S,D)}I.findExecutable=$})(R||(e.win32=R={}))});var Je=this&&this.__decorate||function(fe,e,k,F){var h=arguments.length,A=h<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,k):F,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(fe,e,k,F);else for(var m=fe.length-1;m>=0;m--)(P=fe[m])&&(A=(h<3?P(A):h>3?P(e,k,A):P(e,k))||A);return h>3&&A&&Object.defineProperty(e,k,A),A};define(Se[76],Ce([1,0,19,17,22,21,66,8,3,4,73,12,14]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.ProxyChannel=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.RequestInitiator=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=void 0;var D;(function(re){re[re.Promise=100]="Promise",re[re.PromiseCancel=101]="PromiseCancel",re[re.EventListen=102]="EventListen",re[re.EventDispose=103]="EventDispose"})(D||(D={}));function S(re){switch(re){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(re){re[re.Initialize=200]="Initialize",re[re.PromiseSuccess=201]="PromiseSuccess",re[re.PromiseError=202]="PromiseError",re[re.PromiseErrorObj=203]="PromiseErrorObj",re[re.EventFire=204]="EventFire"})(p||(p={}));function r(re){switch(re){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(re){re[re.Uninitialized=0]="Uninitialized",re[re.Idle=1]="Idle"})(s||(s={}));function c(re){let x=0;for(let q=0;;q+=7){const ne=re.read(1);if(x|=(ne.buffer[0]&127)<<q,!(ne.buffer[0]&128))return x}}const f=n(0);function y(re,x){if(x===0){re.write(f);return}let q=0;for(let pe=x;pe!==0;pe=pe>>>7)q++;const ne=h.$Jb.alloc(q);for(let pe=0;x!==0;pe++)ne.buffer[pe]=x&127,x=x>>>7,x>0&&(ne.buffer[pe]|=128);re.write(ne)}class C{constructor(x){this.b=x,this.a=0}read(x){const q=this.b.slice(this.a,this.a+x);return this.a+=q.byteLength,q}}e.$Zg=C;class i{constructor(){this.a=[]}get buffer(){return h.$Jb.concat(this.a)}write(x){this.a.push(x)}}e.$1g=i;var o;(function(re){re[re.Undefined=0]="Undefined",re[re.String=1]="String",re[re.Buffer=2]="Buffer",re[re.VSBuffer=3]="VSBuffer",re[re.Array=4]="Array",re[re.Object=5]="Object",re[re.Int=6]="Int"})(o||(o={}));function n(re){const x=h.$Jb.alloc(1);return x.writeUInt8(re,0),x}const t={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},a=typeof Buffer<"u";function g(re,x){if(typeof x>"u")re.write(t.Undefined);else if(typeof x=="string"){const q=h.$Jb.fromString(x);re.write(t.String),y(re,q.byteLength),re.write(q)}else if(a&&Buffer.isBuffer(x)){const q=h.$Jb.wrap(x);re.write(t.Buffer),y(re,q.byteLength),re.write(q)}else if(x instanceof h.$Jb)re.write(t.VSBuffer),y(re,x.byteLength),re.write(x);else if(Array.isArray(x)){re.write(t.Array),y(re,x.length);for(const q of x)g(re,q)}else if(typeof x=="number"&&(x|0)===x)re.write(t.Uint),y(re,x);else{const q=h.$Jb.fromString(JSON.stringify(x));re.write(t.Object),y(re,q.byteLength),re.write(q)}}e.$2g=g;function u(re){switch(re.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return re.read(c(re)).toString();case o.Buffer:return re.read(c(re)).buffer;case o.VSBuffer:return re.read(c(re));case o.Array:{const q=c(re),ne=[];for(let pe=0;pe<q;pe++)ne.push(u(re));return ne}case o.Object:return JSON.parse(re.read(c(re)).toString());case o.Int:return c(re)}}e.$3g=u;class d{constructor(x,q,ne=null,pe=1e3){this.h=x,this.j=q,this.k=ne,this.l=pe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(H=>this.q(H)),this.m({type:200})}registerChannel(x,q){this.b.set(x,q),setTimeout(()=>this.w(x),0)}m(x){switch(x.type){case 200:{const q=this.o([x.type]);this.k?.logOutgoing(q,0,1,r(x.type));return}case 201:case 202:case 204:case 203:{const q=this.o([x.type,x.id],x.data);this.k?.logOutgoing(q,x.id,1,r(x.type),x.data);return}}}o(x,q=void 0){const ne=new i;return g(ne,x),g(ne,q),this.p(ne.buffer)}p(x){try{return this.h.send(x),x.byteLength}catch{return 0}}q(x){const q=new C(x),ne=u(q),pe=u(q),H=ne[0];switch(H){case 100:return this.k?.logIncoming(x.byteLength,ne[1],1,`${S(H)}: ${ne[2]}.${ne[3]}`,pe),this.s({type:H,id:ne[1],channelName:ne[2],name:ne[3],arg:pe});case 102:return this.k?.logIncoming(x.byteLength,ne[1],1,`${S(H)}: ${ne[2]}.${ne[3]}`,pe),this.t({type:H,id:ne[1],channelName:ne[2],name:ne[3],arg:pe});case 101:return this.k?.logIncoming(x.byteLength,ne[1],1,`${S(H)}`),this.u({type:H,id:ne[1]});case 103:return this.k?.logIncoming(x.byteLength,ne[1],1,`${S(H)}`),this.u({type:H,id:ne[1]})}}s(x){const q=this.b.get(x.channelName);if(!q){this.v(x);return}const ne=new A.$ed;let pe;try{pe=q.call(this.j,x.name,x.arg,ne.token)}catch(ce){pe=Promise.reject(ce)}const H=x.id;pe.then(ce=>{this.m({id:H,data:ce,type:201}),this.d.delete(x.id)},ce=>{ce instanceof Error?this.m({id:H,data:{message:ce.message,name:ce.name,stack:ce.stack?ce.stack.split?ce.stack.split(`
`):ce.stack:void 0},type:202}):this.m({id:H,data:ce,type:203}),this.d.delete(x.id)});const ue=(0,b.$jb)(()=>ne.cancel());this.d.set(x.id,ue)}t(x){const q=this.b.get(x.channelName);if(!q){this.v(x);return}const ne=x.id,H=q.listen(this.j,x.name,x.arg)(ue=>this.m({id:ne,data:ue,type:204}));this.d.set(x.id,H)}u(x){const q=this.d.get(x.id);q&&(q.dispose(),this.d.delete(x.id))}v(x){let q=this.g.get(x.channelName);q||(q=[],this.g.set(x.channelName,q));const ne=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.m({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:x,timeoutTimer:ne})}w(x){const q=this.g.get(x);if(q){for(const ne of q)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(x)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$gb)(this.d.values()),this.d.clear()}}e.$4g=d;var v;(function(re){re[re.LocalSide=0]="LocalSide",re[re.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class l{constructor(x,q=null){this.l=x,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$8c,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=q}getChannel(x){const q=this;return{call(ne,pe,H){return q.a?Promise.reject(new m.$3):q.m(x,ne,pe,H)},listen(ne,pe){return q.a?E.Event.None:q.o(x,ne,pe)}}}m(x,q,ne,pe=A.CancellationToken.None){const H=this.g++,ce={id:H,type:100,channelName:x,name:q,arg:ne};if(pe.isCancellationRequested)return Promise.reject(new m.$3);let z;return new Promise((Ee,Re)=>{if(pe.isCancellationRequested)return Re(new m.$3);const ye=()=>{const oe=_=>{switch(_.type){case 201:this.f.delete(H),Ee(_.data);break;case 202:{this.f.delete(H);const le=new Error(_.data.message);le.stack=Array.isArray(_.data.stack)?_.data.stack.join(`
`):_.data.stack,le.name=_.data.name,Re(le);break}case 203:this.f.delete(H),Re(_.data);break}};this.f.set(H,oe),this.p(ce)};let X=null;this.b===s.Idle?ye():(X=(0,F.$jg)(oe=>this.u()),X.then(()=>{X=null,ye()}));const he=()=>{X?(X.cancel(),X=null):this.p({id:H,type:101}),Re(new m.$3)},K=pe.onCancellationRequested(he);z=(0,b.$ib)((0,b.$jb)(he),K),this.d.add(z)}).finally(()=>{this.d.delete(z)})}o(x,q,ne){const pe=this.g++,ue={id:pe,type:102,channelName:x,name:q,arg:ne};let ce=null;const z=new E.$8c({onWillAddFirstListener:()=>{ce=(0,F.$jg)(Ee=>this.u()),ce.then(()=>{ce=null,this.d.add(z),this.p(ue)})},onDidRemoveLastListener:()=>{ce?(ce.cancel(),ce=null):(this.d.delete(z),this.p({id:pe,type:103}))}}),ie=Ee=>z.fire(Ee.data);return this.f.set(pe,ie),z.event}p(x){switch(x.type){case 100:case 102:{const q=this.q([x.type,x.id,x.channelName,x.name],x.arg);this.j?.logOutgoing(q,x.id,0,`${S(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const q=this.q([x.type,x.id]);this.j?.logOutgoing(q,x.id,0,S(x.type));return}}}q(x,q=void 0){const ne=new i;return g(ne,x),g(ne,q),this.r(ne.buffer)}r(x){try{return this.l.send(x),x.byteLength}catch{return 0}}s(x){const q=new C(x),ne=u(q),pe=u(q),H=ne[0];switch(H){case 200:return this.j?.logIncoming(x.byteLength,0,0,r(H)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(x.byteLength,ne[1],0,r(H),pe),this.t({type:ne[0],id:ne[1],data:pe})}}t(x){if(x.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(x.id)?.(x)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$gb)(this.d.values()),this.d.clear()}}e.$5g=l,Je([P.$Tg],l.prototype,"onDidInitializePromise",null);class w{get connections(){const x=[];return this.f.forEach(q=>x.push(q)),x}constructor(x){this.a=new Map,this.f=new Set,this.g=new E.$8c,this.onDidAddConnection=this.g.event,this.h=new E.$8c,this.onDidRemoveConnection=this.h.event,x(({protocol:q,onDidClientDisconnect:ne})=>{E.Event.once(q.onMessage)(H=>{const ue=new C(H),ce=u(ue),z=new d(q,ce),ie=new l(q);this.a.forEach((Re,ye)=>z.registerChannel(ye,Re));const Ee={channelServer:z,channelClient:ie,ctx:ce};this.f.add(Ee),this.g.fire(Ee),ne(()=>{z.dispose(),ie.dispose(),this.f.delete(Ee),this.h.fire(Ee)})})})}getChannel(x,q){const ne=this;return{call(pe,H,ue){let ce;if((0,$.$xe)(q)){const ie=(0,k.$Kf)(ne.connections.filter(q));ce=ie?Promise.resolve(ie):E.Event.toPromise(E.Event.filter(ne.onDidAddConnection,q))}else ce=q.routeCall(ne,pe,H);const z=ce.then(ie=>ie.channelClient.getChannel(x));return O(z).call(pe,H,ue)},listen(pe,H){if((0,$.$xe)(q))return ne.j(x,q,pe,H);const ue=q.routeEvent(ne,pe,H).then(ce=>ce.channelClient.getChannel(x));return O(ue).listen(pe,H)}}}j(x,q,ne,pe){const H=this;let ue=new b.$kb;const ce=new E.$8c({onWillAddFirstListener:()=>{ue=new b.$kb;const z=new E.$bd,ie=new Map,Ee=ye=>{const he=ye.channelClient.getChannel(x).listen(ne,pe),K=z.add(he);ie.set(ye,K)},Re=ye=>{const X=ie.get(ye);X&&(X.dispose(),ie.delete(ye))};H.connections.filter(q).forEach(Ee),E.Event.filter(H.onDidAddConnection,q)(Ee,void 0,ue),H.onDidRemoveConnection(Re,void 0,ue),z.event(ce.fire,ce,ue),ue.add(z)},onDidRemoveLastListener:()=>{ue.dispose()}});return ce.event}registerChannel(x,q){this.a.set(x,q),this.f.forEach(ne=>{ne.channelServer.registerChannel(x,q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$6g=w;class L{constructor(x,q,ne=null){const pe=new i;g(pe,q),x.send(pe.buffer),this.a=new l(x,ne),this.d=new d(x,q,ne)}getChannel(x){return this.a.getChannel(x)}registerChannel(x,q){this.d.registerChannel(x,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$7g=L;function O(re){return{call(x,q,ne){return re.then(pe=>pe.call(x,q,ne))},listen(x,q){const ne=new E.$dd;return re.then(pe=>ne.input=pe.listen(x,q)),ne.event}}}e.$8g=O;function N(re){let x=!1;return{call(q,ne,pe){return x?re.call(q,ne,pe):(0,F.$wg)(0).then(()=>x=!0).then(()=>re.call(q,ne,pe))},listen(q,ne){if(x)return re.listen(q,ne);const pe=new E.$dd;return(0,F.$wg)(0).then(()=>x=!0).then(()=>pe.input=re.listen(q,ne)),pe.event}}}e.$9g=N;class T{constructor(x){this.a=x}routeCall(x){return this.b(x)}routeEvent(x){return this.b(x)}async b(x){for(const q of x.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await E.Event.toPromise(x.onDidAddConnection),await this.b(x)}}e.$0g=T;var j;(function(re){function x(H,ue){const ce=H,z=ue&&ue.disableMarshalling,ie=new Map;for(const Ee in ce)ne(Ee)&&ie.set(Ee,E.Event.buffer(ce[Ee],!0));return new class{listen(Ee,Re,ye){const X=ie.get(Re);if(X)return X;if(pe(Re)){const he=ce[Re];if(typeof he=="function")return he.call(ce,ye)}throw new m.$ab(`Event not found: ${Re}`)}call(Ee,Re,ye){const X=ce[Re];if(typeof X=="function"){if(!z&&Array.isArray(ye))for(let he=0;he<ye.length;he++)ye[he]=(0,R.$Yg)(ye[he]);return X.apply(ce,ye)}throw new m.$ab(`Method not found: ${Re}`)}}}re.fromService=x;function q(H,ue){const ce=ue&&ue.disableMarshalling;return new Proxy({},{get(z,ie){if(typeof ie=="string")return ue?.properties?.has(ie)?ue.properties.get(ie):pe(ie)?function(Ee){return H.listen(ie,Ee)}:ne(ie)?H.listen(ie):async function(...Ee){let Re;ue&&!(0,$.$se)(ue.context)?Re=[ue.context,...Ee]:Re=Ee;const ye=await H.call(ie,Re);return ce?ye:(0,R.$Yg)(ye)};throw new m.$ab(`Property not found: ${String(ie)}`)}})}re.toService=q;function ne(H){return H[0]==="o"&&H[1]==="n"&&I.$Ld(H.charCodeAt(2))}function pe(H){return/^onDynamic/.test(H)&&I.$Ld(H.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(re){if(Array.isArray(re))return re;if(re&&typeof re=="object"&&typeof re.toString=="function"){const x=re.toString();if(x!=="[object Object]")return x}return re}function Y(re){return Array.isArray(re)?re.map(M):M(re)}function V(re,x,q,ne,pe,H,ue){ue=Y(ue);const ce=W[pe],z=ce[ne%ce.length];let ie=[`%c[${re}]%c[${String(x).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${z}`];/\($/.test(H)?(ie=ie.concat(ue),ie.push(")")):ie.push(ue),console.log.apply(console,ie)}class de{constructor(x,q){this.d=x,this.f=q,this.a=0,this.b=0}logOutgoing(x,q,ne,pe,H){this.b+=x,V(this.d,this.b,x,q,ne,pe,H)}logIncoming(x,q,ne,pe,H){this.a+=x,V(this.f,this.a,x,q,ne,pe,H)}}e.$$g=de}),define(Se[122],Ce([1,0,22,3,4,76]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dh=e.$ch=e.$bh=e.$ah=e.ProtocolConstants=e.$_g=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(P||(e.SocketDiagnosticsEventType=P={}));var m;(function(t){t.enableDiagnostics=!1,t.records=[];const a=new WeakMap;let g=0;function u(v,l){if(!a.has(v)){const w=String(++g);a.set(v,w)}return a.get(v)}function d(v,l,w,L){if(!t.enableDiagnostics)return;const O=u(v,l);if(L instanceof k.$Jb||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const N=k.$Jb.alloc(L.byteLength);N.set(L),t.records.push({timestamp:Date.now(),id:O,label:l,type:w,buff:N})}else t.records.push({timestamp:Date.now(),id:O,label:l,type:w,data:L})}t.traceSocketEvent=d})(m||(e.SocketDiagnostics=m={}));var E;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let b=null;function R(){return b||(b=k.$Jb.alloc(0)),b}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,g){if(a===0)return R();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const l=this.a[0];return g&&(this.a.shift(),this.b-=a),l}if(this.a[0].byteLength>a){const l=this.a[0].slice(0,a);return g&&(this.a[0]=this.a[0].slice(a),this.b-=a),l}const u=k.$Jb.alloc(a);let d=0,v=0;for(;a>0;){const l=this.a[v];if(l.byteLength>a){const w=l.slice(0,a);u.set(w,d),d+=a,g&&(this.a[v]=l.slice(a),this.b-=a),a-=a}else u.set(l,d),d+=l.byteLength,g?(this.a.shift(),this.b-=l.byteLength):v++,a-=l.byteLength}return u}}e.$_g=I;var $;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})($||($={}));function D(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class p{constructor(a,g,u,d){this.type=a,this.id=g,this.ack=u,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class r extends h.$lb{constructor(a){super(),this.f=this.B(new F.$8c),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new I,this.B(this.a.onData(g=>this.acceptChunk(g))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const g=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=g.readUInt32BE(9),this.g.messageType=g.readUInt8(0),this.g.id=g.readUInt32BE(1),this.g.ack=g.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:D(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const u=this.g.messageType,d=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",g),this.f.fire(new p(u,d,v,g)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const g=k.$Jb.alloc(13);g.writeUInt8(a.type,0),g.writeUInt32BE(a.id,1),g.writeUInt32BE(a.ack,5),g.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:D(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(g,a.data)}g(a,g){const u=this.f===0;return this.d.push(a,g),this.f+=a.byteLength+g.byteLength,u}h(){const a=k.$Jb.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,g){this.g(a,g)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class c extends h.$lb{constructor(a){super(),this.f=new F.$8c,this.onMessage=this.f.event,this.g=new F.$8c,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new s(this.a)),this.c=this.B(new r(this.a)),this.B(this.c.onMessage(g=>{g.type===1&&this.f.fire(g.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new p(1,0,0,a))}}e.$ah=c;class f extends A.$7g{static fromSocket(a,g){return new f(new c(a),g)}get onDidDispose(){return this.b.onDidDispose}constructor(a,g,u=null){super(a,g,u),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$bh=f;class y{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$8c({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$ch=y;class C{constructor(a){this.data=a,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let a=0,g=this.a;for(;g;)g=g.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let g=0,u=this.a;for(;u;)a[g++]=u.data,u=u.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const g=new C(a);if(!this.a){this.a=g,this.b=g;return}this.b.next=g,this.b=g}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const a=Date.now();for(let g=0;g<o.a;g++)this.c[g]=a-1e3*g;setInterval(()=>{for(let g=o.a;g>=1;g--)this.c[g]=this.c[g-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),g=(1+o.a)*1e3;let u=0;for(let d=0;d<o.a;d++)a-this.c[d]<=g&&u++;return 1-u/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new y,this.onControlMessage=this.u.event,this.v=new y,this.onMessage=this.v.event,this.w=new y,this.onDidDispose=this.w.event,this.x=new y,this.onSocketClose=this.x.event,this.y=new y,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??o.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new h.$kb,this.o=a.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new r(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new p(5,0,0,R());this.p.write(a),this.p.flush()}sendPause(){const a=new p(7,0,0,R());this.p.write(a)}sendResume(){const a=new p(8,0,0,R());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,g){this.a=!0,this.r.dispose(),this.r=new h.$kb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new r(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),this.q.acceptChunk(g)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new p(3,0,this.h,R());this.p.write(a);const g=this.b.toArray();for(let u=0,d=g.length;u<d;u++)this.p.write(g[u]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const g=this.b.peek();if(g&&g.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const g=Date.now();g-this.m>1e4&&(this.m=g,this.p.write(new p(6,0,0,R())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const g=this.b.toArray();for(let u=0,d=g.length;u<d;u++)this.p.write(g[u]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const g=++this.c;this.h=this.g;const u=new p(1,g,this.h,a);this.b.push(u),this.a||(this.p.write(u),this.B())}sendControl(a){const g=new p(2,0,0,a);this.p.write(g)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),g=Date.now()-a.writtenTime,u=Date.now()-this.q.lastReadTime,d=Date.now()-this.n;if(g>=2e4&&u>=2e4&&d>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:g,timeSinceLastReceivedSomeData:u});return}const v=Math.max(2e4-g,2e4-u,2e4-d,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new p(3,0,this.h,R());this.p.write(a)}D(){this.h=this.g;const a=new p(9,0,this.h,R());this.p.write(a)}}e.$dh=n}),define(Se[176],Ce([1,0,46,17,22,21,174,8,3,4,23,96,94,76]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=void 0;class S extends D.$4g{constructor(s){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",c=>h.$Jb.wrap(Buffer.from(c,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$Gp=S;class p{constructor(s,c){this.i=s,this.j=c,this.c=new Set,this.g=new Map,this.h=new E.$8c,this.onDidProcessExit=this.h.event;const f=c&&c.timeout?c.timeout:6e4;this.b=new F.$sg(f),this.d=null,this.f=null}getChannel(s){const c=this;return{call(f,y,C){return c.k(s,f,y,C)},listen(f,y){return c.l(s,f,y)}}}k(s,c,f,y=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(m.$4());this.b.cancel();const C=this.n(s),i=(0,F.$jg)(t=>C.call(c,f,t)),o=y.onCancellationRequested(()=>i.cancel()),n=(0,b.$jb)(()=>i.cancel());return this.c.add(n),i.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(s,c,f){if(!this.b)return E.Event.None;this.b.cancel();let y;const C=new E.$8c({onWillAddFirstListener:()=>{y=this.n(s).listen(c,f)(C.fire,C),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return C.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],c=Object.create(null);c.env={...(0,R.$Hm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(c.env={...c.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(c.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,$.$gl)(c.env),this.d=(0,k.fork)(this.i,s,c);const f=new E.$8c;E.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,P.$Cp)(a)){(0,P.log)(a,`IPC Library: ${this.j.serverName}`);return}f.fire(h.$Jb.wrap(Buffer.from(a,"base64")))});const C=this.j.useQueue?(0,I.$il)(this.d):this.d,i=a=>this.d&&this.d.connected&&C.send(a.buffer.toString("base64")),o=f.event,n={send:i,onMessage:o};this.f=new D.$5g(n);const t=()=>this.o();process.once("exit",t),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,g)=>{process.removeListener("exit",t),this.c.forEach(u=>(0,b.$gb)(u)),this.c.clear(),a!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+g),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:g})})}return this.f}n(s){let c=this.g.get(s);return c||(c=this.m.getChannel(s),this.g.set(s,c)),c}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Hp=p}),define(Se[177],Ce([1,0,34,13]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YE=void 0;function h(A,P,m,E,b,R){if(Array.isArray(A)){let I=0;for(const $ of A){const D=h($,P,m,E,b,R);if(D===10)return D;D>I&&(I=D)}return I}else{if(typeof A=="string")return E?A==="*"?5:A===m?10:0:0;if(A){const{language:I,pattern:$,scheme:D,hasAccessToAllModels:S,notebookType:p}=A;if(!E&&!S)return 0;p&&b&&(P=b);let r=0;if(D)if(D===P.scheme)r=10;else if(D==="*")r=5;else return 0;if(I)if(I===m)r=10;else if(I==="*")r=Math.max(r,5);else return 0;if(p)if(p===R)r=10;else if(p==="*"&&R!==void 0)r=Math.max(r,5);else return 0;if($){let s;if(typeof $=="string"?s=$:s={...$,base:(0,F.$$b)($.base)},s===P.fsPath||(0,k.$dj)(s,P.fsPath))r=10;else return 0}return r}else return 0}}e.$YE=h}),define(Se[123],Ce([1,0,22,11]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H8=e.$G8=void 0;var h;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(h||(h={}));function A(I){for(let $=0,D=I.length;$<D;$+=4){const S=I[$+0],p=I[$+1],r=I[$+2],s=I[$+3];I[$+0]=s,I[$+1]=r,I[$+2]=p,I[$+3]=S}}function P(I){const $=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return F.$C()||A($),k.$Jb.wrap($)}function m(I){const $=I.buffer;if(F.$C()||A($),$.byteOffset%4===0)return new Uint32Array($.buffer,$.byteOffset,$.length/4);{const D=new Uint8Array($.byteLength);return D.set($),new Uint32Array(D.buffer,D.byteOffset,D.length/4)}}function E(I){const $=new Uint32Array(b(I));let D=0;if($[D++]=I.id,I.type==="full")$[D++]=1,$[D++]=I.data.length,$.set(I.data,D),D+=I.data.length;else{$[D++]=2,$[D++]=I.deltas.length;for(const S of I.deltas)$[D++]=S.start,$[D++]=S.deleteCount,S.data?($[D++]=S.data.length,$.set(S.data,D),D+=S.data.length):$[D++]=0}return P($)}e.$G8=E;function b(I){let $=0;if($+=1+1,I.type==="full")$+=1+I.data.length;else{$+=1,$+=(1+1+1)*I.deltas.length;for(const D of I.deltas)D.data&&($+=D.data.length)}return $}function R(I){const $=m(I);let D=0;const S=$[D++];if($[D++]===1){const c=$[D++],f=$.subarray(D,D+c);return D+=c,{id:S,type:"full",data:f}}const r=$[D++],s=[];for(let c=0;c<r;c++){const f=$[D++],y=$[D++],C=$[D++];let i;C>0&&(i=$.subarray(D,D+C),D+=C),s[c]={start:f,deleteCount:y,data:i}}return{id:S,type:"delta",deltas:s}}e.$H8=R}),define(Se[178],Ce([9,10]),function(fe,e){return fe.create("vs/editor/common/config/editorOptions",e)}),define(Se[124],Ce([1,0,19,23,11,159,116,178]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(te){te[te.None=0]="None",te[te.Keep=1]="Keep",te[te.Brackets=2]="Brackets",te[te.Advanced=3]="Advanced",te[te.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class b{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=b;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class I{constructor(Q,ve,Ue,Ne){this.id=Q,this.name=ve,this.defaultValue=Ue,this.schema=Ne}applyUpdate(Q,ve){return D(Q,ve)}compute(Q,ve,Ue){return Ue}}class ${constructor(Q,ve){this.newValue=Q,this.didChange=ve}}e.ApplyUpdateResult=$;function D(te,Q){if(typeof te!="object"||typeof Q!="object"||!te||!Q)return new $(Q,te!==Q);if(Array.isArray(te)||Array.isArray(Q)){const Ue=Array.isArray(te)&&Array.isArray(Q)&&k.$bf(te,Q);return new $(Q,!Ue)}let ve=!1;for(const Ue in Q)if(Q.hasOwnProperty(Ue)){const Ne=D(te[Ue],Q[Ue]);Ne.didChange&&(te[Ue]=Ne.newValue,ve=!0)}return new $(te,ve)}class S{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ve){return D(Q,ve)}validate(Q){return this.defaultValue}}class p{constructor(Q,ve,Ue,Ne){this.id=Q,this.name=ve,this.defaultValue=Ue,this.schema=Ne}applyUpdate(Q,ve){return D(Q,ve)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,ve,Ue){return Ue}}function r(te,Q){return typeof te>"u"?Q:te==="false"?!1:!!te}e.boolean=r;class s extends p{constructor(Q,ve,Ue,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Ue),super(Q,ve,Ue,Ne)}validate(Q){return r(Q,this.defaultValue)}}function c(te,Q,ve,Ue){if(typeof te>"u")return Q;let Ne=parseInt(te,10);return isNaN(Ne)?Q:(Ne=Math.max(ve,Ne),Ne=Math.min(Ue,Ne),Ne|0)}e.clampedInt=c;class f extends p{static clampedInt(Q,ve,Ue,Ne){return c(Q,ve,Ue,Ne)}constructor(Q,ve,Ue,Ne,Ye,xe=void 0){typeof xe<"u"&&(xe.type="integer",xe.default=Ue,xe.minimum=Ne,xe.maximum=Ye),super(Q,ve,Ue,xe),this.minimum=Ne,this.maximum=Ye}validate(Q){return f.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function y(te,Q,ve,Ue){if(typeof te>"u")return Q;const Ne=C.float(te,Q);return C.clamp(Ne,ve,Ue)}e.clampedFloat=y;class C extends p{static clamp(Q,ve,Ue){return Q<ve?ve:Q>Ue?Ue:Q}static float(Q,ve){if(typeof Q=="number")return Q;if(typeof Q>"u")return ve;const Ue=parseFloat(Q);return isNaN(Ue)?ve:Ue}constructor(Q,ve,Ue,Ne,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=Ue),super(Q,ve,Ue,Ye),this.validationFn=Ne}validate(Q){return this.validationFn(C.float(Q,this.defaultValue))}}class i extends p{static string(Q,ve){return typeof Q!="string"?ve:Q}constructor(Q,ve,Ue,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Ue),super(Q,ve,Ue,Ne)}validate(Q){return i.string(Q,this.defaultValue)}}function o(te,Q,ve,Ue){return typeof te!="string"?Q:Ue&&te in Ue?Ue[te]:ve.indexOf(te)===-1?Q:te}e.stringSet=o;class n extends p{constructor(Q,ve,Ue,Ne,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=Ne,Ye.default=Ue),super(Q,ve,Ue,Ye),this.c=Ne}validate(Q){return o(Q,this.defaultValue,this.c)}}class t extends I{constructor(Q,ve,Ue,Ne,Ye,xe,rt=void 0){typeof rt<"u"&&(rt.type="string",rt.enum=Ye,rt.default=Ne),super(Q,ve,Ue,rt),this.c=Ye,this.d=xe}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function a(te){switch(te){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ve,Ue){return Ue===0?Q.accessibilitySupport:Ue}}class u extends I{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(22,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:m.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{insertSpace:r(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var d;(function(te){te[te.Hidden=0]="Hidden",te[te.Blink=1]="Blink",te[te.Smooth=2]="Smooth",te[te.Phase=3]="Phase",te[te.Expand=4]="Expand",te[te.Solid=5]="Solid"})(d||(e.TextEditorCursorBlinkingStyle=d={}));function v(te){switch(te){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(te){te[te.Line=1]="Line",te[te.Block=2]="Block",te[te.Underline=3]="Underline",te[te.LineThin=4]="LineThin",te[te.BlockOutline=5]="BlockOutline",te[te.UnderlineThin=6]="UnderlineThin"})(l||(e.TextEditorCursorStyle=l={}));function w(te){switch(te){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function L(te){switch(te){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class O extends S{constructor(){super(139)}compute(Q,ve,Ue){const Ne=["monaco-editor"];return ve.get(38)&&Ne.push(ve.get(38)),Q.extraEditorClassName&&Ne.push(Q.extraEditorClassName),ve.get(72)==="default"?Ne.push("mouse-default"):ve.get(72)==="copy"&&Ne.push("mouse-copy"),ve.get(109)&&Ne.push("showUnused"),ve.get(137)&&Ne.push("showDeprecated"),Ne.join(" ")}}class N extends s{constructor(){super(36,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(Q,ve,Ue){return Ue&&Q.emptySelectionClipboard}}class T extends I{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(40,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:m.localize(16,null),included:h.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:m.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{cursorMoveOnType:r(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":o(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":o(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(ve.loop,this.defaultValue.loop)}}}class j extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(50,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?j.OFF:Q==="true"?j.ON:Q:Q?j.ON:j.OFF}}e.EditorFontLigatures=j;class W extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(53,"fontVariations",W.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?W.OFF:Q==="true"?W.TRANSLATE:Q:Q?W.TRANSLATE:W.OFF}compute(Q,ve,Ue){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=W;class M extends S{constructor(){super(49)}compute(Q,ve,Ue){return Q.fontInfo}}class Y extends p{constructor(){super(51,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(Q){const ve=C.float(Q,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:C.clamp(ve,6,100)}compute(Q,ve,Ue){return Q.fontInfo.fontSize}}class V extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(52,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(f.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}class de extends I{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(57,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ue,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ue,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ue,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ue,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ue,description:m.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{multiple:o(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??o(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??o(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??o(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??o(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??o(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class re extends I{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(59,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:m.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:m.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:r(ve.enabled,this.defaultValue.enabled),delay:f.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:r(ve.sticky,this.defaultValue.sticky),above:r(ve.above,this.defaultValue.above)}}}var x;(function(te){te[te.None=0]="None",te[te.Text=1]="Text",te[te.Blocks=2]="Blocks"})(x||(e.RenderMinimap=x={}));class q extends S{constructor(){super(142)}compute(Q,ve,Ue){return q.computeLayout(ve,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const ve=Q.height/Q.lineHeight,Ue=Math.floor(Q.paddingTop/Q.lineHeight);let Ne=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Ne=Math.max(Ne,ve-1));const Ye=(Ue+Q.viewLineCount+Ne)/(Q.pixelRatio*Q.height),xe=Math.floor(Q.viewLineCount/Ye);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:Ue,extraLinesBeyondLastLine:Ne,desiredRatio:Ye,minimapLineCount:xe}}static c(Q,ve){const Ue=Q.outerWidth,Ne=Q.outerHeight,Ye=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const xe=ve.stableMinimapLayoutInput,rt=xe&&Q.outerHeight===xe.outerHeight&&Q.lineHeight===xe.lineHeight&&Q.typicalHalfwidthCharacterWidth===xe.typicalHalfwidthCharacterWidth&&Q.pixelRatio===xe.pixelRatio&&Q.scrollBeyondLastLine===xe.scrollBeyondLastLine&&Q.paddingTop===xe.paddingTop&&Q.paddingBottom===xe.paddingBottom&&Q.minimap.enabled===xe.minimap.enabled&&Q.minimap.side===xe.minimap.side&&Q.minimap.size===xe.minimap.size&&Q.minimap.showSlider===xe.minimap.showSlider&&Q.minimap.renderCharacters===xe.minimap.renderCharacters&&Q.minimap.maxColumn===xe.minimap.maxColumn&&Q.minimap.scale===xe.minimap.scale&&Q.verticalScrollbarWidth===xe.verticalScrollbarWidth&&Q.isViewportWrapping===xe.isViewportWrapping,ft=Q.lineHeight,vt=Q.typicalHalfwidthCharacterWidth,Ft=Q.scrollBeyondLastLine,Lt=Q.minimap.renderCharacters;let Et=Ye>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Tt=Q.minimap.maxColumn,Ot=Q.minimap.size,zt=Q.minimap.side,Bt=Q.verticalScrollbarWidth,Mt=Q.viewLineCount,at=Q.remainingWidth,dt=Q.isViewportWrapping,Wt=Lt?2:3;let Nt=Math.floor(Ye*Ne);const Dt=Nt/Ye;let ct=!1,At=!1,jt=Wt*Et,Te=Et/Ye,Le=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:it,extraLinesBeforeFirstLine:wt,extraLinesBeyondLastLine:St,desiredRatio:Ct,minimapLineCount:pt}=q.computeContainedMinimapLineCount({viewLineCount:Mt,scrollBeyondLastLine:Ft,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Ne,lineHeight:ft,pixelRatio:Ye});if(Mt/pt>1)ct=!0,At=!0,Et=1,jt=1,Te=Et/Ye;else{let ht=!1,bt=Et+1;if(Ot==="fit"){const gt=Math.ceil((wt+Mt+St)*jt);dt&&rt&&at<=ve.stableFitRemainingWidth?(ht=!0,bt=ve.stableFitMaxMinimapScale):ht=gt>Nt}if(Ot==="fill"||ht){ct=!0;const gt=Et;jt=Math.min(ft*Ye,Math.max(1,Math.floor(1/Ct))),dt&&rt&&at<=ve.stableFitRemainingWidth&&(bt=ve.stableFitMaxMinimapScale),Et=Math.min(bt,Math.max(1,Math.floor(jt/Wt))),Et>gt&&(Le=Math.min(2,Et/gt)),Te=Et/Ye/Le,Nt=Math.ceil(Math.max(it,wt+Mt+St)*jt),dt?(ve.stableMinimapLayoutInput=Q,ve.stableFitRemainingWidth=at,ve.stableFitMaxMinimapScale=Et):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const Ae=Math.floor(Tt*Te),ae=Math.min(Ae,Math.max(0,Math.floor((at-Bt-2)*Te/(vt+Te)))+e.MINIMAP_GUTTER_WIDTH);let Oe=Math.floor(Ye*ae);const We=Oe/Ye;Oe=Math.floor(Oe*Le);const Ze=Lt?1:2,He=zt==="left"?0:Ue-ae-Bt;return{renderMinimap:Ze,minimapLeft:He,minimapWidth:ae,minimapHeightIsEditorHeight:ct,minimapIsSampling:At,minimapScale:Et,minimapLineHeight:jt,minimapCanvasInnerWidth:Oe,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:We,minimapCanvasOuterHeight:Dt}}static computeLayout(Q,ve){const Ue=ve.outerWidth|0,Ne=ve.outerHeight|0,Ye=ve.lineHeight|0,xe=ve.lineNumbersDigitCount|0,rt=ve.typicalHalfwidthCharacterWidth,ft=ve.maxDigitWidth,vt=ve.pixelRatio,Ft=ve.viewLineCount,Lt=Q.get(134),Et=Lt==="inherit"?Q.get(133):Lt,Tt=Et==="inherit"?Q.get(129):Et,Ot=Q.get(132),zt=ve.isDominatedByLongLines,Bt=Q.get(56),Mt=Q.get(66).renderType!==0,at=Q.get(67),dt=Q.get(103),Wt=Q.get(82),Nt=Q.get(71),Dt=Q.get(101),ct=Dt.verticalScrollbarSize,At=Dt.verticalHasArrows,jt=Dt.arrowSize,Te=Dt.horizontalScrollbarSize,Le=Q.get(42),Ae=Q.get(108)!=="never";let ae=Q.get(64);Le&&Ae&&(ae+=16);let Oe=0;if(Mt){const qt=Math.max(xe,at);Oe=Math.round(qt*ft)}let We=0;Bt&&(We=Ye*ve.glyphMarginDecorationLaneCount);let Ze=0,He=Ze+We,it=He+Oe,wt=it+ae;const St=Ue-We-Oe-ae;let Ct=!1,pt=!1,$t=-1;Et==="inherit"&&zt?(Ct=!0,pt=!0):Tt==="on"||Tt==="bounded"?pt=!0:Tt==="wordWrapColumn"&&($t=Ot);const ht=q.c({outerWidth:Ue,outerHeight:Ne,lineHeight:Ye,typicalHalfwidthCharacterWidth:rt,pixelRatio:vt,scrollBeyondLastLine:dt,paddingTop:Wt.top,paddingBottom:Wt.bottom,minimap:Nt,verticalScrollbarWidth:ct,viewLineCount:Ft,remainingWidth:St,isViewportWrapping:pt},ve.memory||new R);ht.renderMinimap!==0&&ht.minimapLeft===0&&(Ze+=ht.minimapWidth,He+=ht.minimapWidth,it+=ht.minimapWidth,wt+=ht.minimapWidth);const bt=St-ht.minimapWidth,gt=Math.max(1,Math.floor((bt-ct-2)/rt)),Qt=At?jt:0;return pt&&($t=Math.max(1,gt),Tt==="bounded"&&($t=Math.min($t,Ot))),{width:Ue,height:Ne,glyphMarginLeft:Ze,glyphMarginWidth:We,glyphMarginDecorationLaneCount:ve.glyphMarginDecorationLaneCount,lineNumbersLeft:He,lineNumbersWidth:Oe,decorationsLeft:it,decorationsWidth:ae,contentLeft:wt,contentWidth:bt,minimap:ht,viewportColumn:gt,isWordWrapMinified:Ct,isViewportWrapping:pt,wrappingColumn:$t,verticalScrollbarWidth:ct,horizontalScrollbarHeight:Te,overviewRuler:{top:Qt,width:ct,height:Ne-2*Qt,right:0}}}}e.EditorLayoutInfoComputer=q;class ne extends I{constructor(){super(136,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(46,null),m.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(48,null)}})}validate(Q){return o(Q,"simple",["simple","advanced"])}compute(Q,ve,Ue){return ve.get(2)===2?"advanced":Ue}}class pe extends I{constructor(){const Q={enabled:!0};super(63,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:m.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:r(Q.enabled,this.defaultValue.enabled)}}}class H extends I{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(113,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:m.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:m.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:m.localize(52,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:r(ve.enabled,this.defaultValue.enabled),maxLineCount:f.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:o(ve.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class ue extends I{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(138,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:m.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(54,null),m.localize(55,null,h.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(56,null,h.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:m.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:m.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:m.localize(60,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:o(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:f.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(ve.fontFamily,this.defaultValue.fontFamily),padding:r(ve.padding,this.defaultValue.padding)}}}class ce extends I{constructor(){super(64,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):f.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,ve,Ue){return Ue<0?f.clampedInt(-Ue*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ue}}class z extends C{constructor(){super(65,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>C.clamp(Q,0,150),{markdownDescription:m.localize(61,null)})}compute(Q,ve,Ue){return Q.fontInfo.lineHeight}}class ie extends I{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(71,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:m.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:m.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(64,null),m.localize(65,null),m.localize(66,null)],default:Q.size,description:m.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:m.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:m.localize(69,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:m.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:m.localize(72,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:r(ve.enabled,this.defaultValue.enabled),autohide:r(ve.autohide,this.defaultValue.autohide),size:o(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(ve.side,this.defaultValue.side,["right","left"]),showSlider:o(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(ve.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(ve.scale,1,1,3),maxColumn:f.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ee(te){return te==="ctrlCmd"?h.$j?"metaKey":"ctrlKey":"altKey"}class Re extends I{constructor(){super(82,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{top:f.clampedInt(ve.top,0,0,1e3),bottom:f.clampedInt(ve.bottom,0,0,1e3)}}}class ye extends I{constructor(){const Q={enabled:!0,cycle:!0};super(84,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:m.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:m.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:r(ve.enabled,this.defaultValue.enabled),cycle:r(ve.cycle,this.defaultValue.cycle)}}}class X extends S{constructor(){super(140)}compute(Q,ve,Ue){return Q.pixelRatio}}class he extends I{constructor(){const Q={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(77,null),m.localize(78,null),m.localize(79,null)]}];super(87,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:Q.strings,description:m.localize(80,null)},comments:{anyOf:ve,default:Q.comments,description:m.localize(81,null)},other:{anyOf:ve,default:Q.other,description:m.localize(82,null)}},default:Q,markdownDescription:m.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const vt=Q?"on":"off";return{comments:vt,strings:vt,other:vt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:ve,comments:Ue,strings:Ne}=Q,Ye=["on","inline","off"];let xe,rt,ft;return typeof ve=="boolean"?xe=ve?"on":"off":xe=o(ve,this.defaultValue.other,Ye),typeof Ue=="boolean"?rt=Ue?"on":"off":rt=o(Ue,this.defaultValue.comments,Ye),typeof Ne=="boolean"?ft=Ne?"on":"off":ft=o(Ne,this.defaultValue.strings,Ye),{other:xe,comments:rt,strings:ft}}}var K;(function(te){te[te.Off=0]="Off",te[te.On=1]="On",te[te.Relative=2]="Relative",te[te.Interval=3]="Interval",te[te.Custom=4]="Custom"})(K||(e.RenderLineNumbersType=K={}));class oe extends I{constructor(){super(66,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(84,null),m.localize(85,null),m.localize(86,null),m.localize(87,null)],default:"on",description:m.localize(88,null)})}validate(Q){let ve=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(ve=4,Ue=Q):Q==="interval"?ve=3:Q==="relative"?ve=2:Q==="on"?ve=1:ve=0),{renderType:ve,renderFn:Ue}}}function _(te){const Q=te.get(96);return Q==="editable"?te.get(89):Q!=="on"}e.filterValidationDecorations=_;class le extends I{constructor(){const Q=[],ve={type:"number",description:m.localize(89,null)};super(100,"rulers",Q,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:m.localize(90,null),format:"color-hex"}}}]},default:Q,description:m.localize(91,null)})}validate(Q){if(Array.isArray(Q)){const ve=[];for(const Ue of Q)if(typeof Ue=="number")ve.push({column:f.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Ne=Ue;ve.push({column:f.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return ve.sort((Ue,Ne)=>Ue.column-Ne.column),ve}return this.defaultValue}}class $e extends I{constructor(){super(90,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function U(te,Q){if(typeof te!="string")return Q;switch(te){case"hidden":return 2;case"visible":return 3;default:return 1}}class G extends I{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(101,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(92,null),m.localize(93,null),m.localize(94,null)],default:"auto",description:m.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(96,null),m.localize(97,null),m.localize(98,null)],default:"auto",description:m.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:m.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:m.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:m.localize(102,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q,Ue=f.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=f.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:U(ve.vertical,this.defaultValue.vertical),horizontal:U(ve.horizontal,this.defaultValue.horizontal),useShadows:r(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:f.clampedInt(ve.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:f.clampedInt(ve.verticalSliderSize,Ne,0,1e3),scrollByPage:r(ve.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Z extends I{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(123,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:m.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:m.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:m.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:m.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:m.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:m.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:m.localize(109,null)}})}applyUpdate(Q,ve){let Ue=!1;ve.allowedCharacters&&Q&&(F.$Lm(Q.allowedCharacters,ve.allowedCharacters)||(Q={...Q,allowedCharacters:ve.allowedCharacters},Ue=!0)),ve.allowedLocales&&Q&&(F.$Lm(Q.allowedLocales,ve.allowedLocales)||(Q={...Q,allowedLocales:ve.allowedLocales},Ue=!0));const Ne=super.applyUpdate(Q,ve);return Ue?new $(Ne.newValue,!0):Ne}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{nonBasicASCII:we(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:r(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:r(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:we(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:we(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,ve){if(typeof Q!="object"||!Q)return ve;const Ue={};for(const[Ne,Ye]of Object.entries(Q))Ye===!0&&(Ue[Ne]=!0);return Ue}}class ee extends I{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(61,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:m.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[m.localize(111,null),m.localize(112,null)],description:m.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:m.localize(114,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:r(ve.enabled,this.defaultValue.enabled),mode:o(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:o(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:r(ve.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:r(ve.keepOnBlur,this.defaultValue.keepOnBlur)}}}class be extends I{constructor(){const Q={enabled:A.$Hr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$Hr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(14,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:m.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:m.localize(116,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:r(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:r(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class se extends I{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(15,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],default:Q.bracketPairs,description:m.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(121,null),m.localize(122,null),m.localize(123,null)],default:Q.bracketPairsHorizontal,description:m.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:m.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:m.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(127,null),m.localize(128,null),m.localize(129,null)],default:Q.highlightActiveIndentation,description:m.localize(130,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{bracketPairs:we(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:we(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:we(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function we(te,Q,ve){const Ue=ve.indexOf(te);return Ue===-1?Q:ve[Ue]}class Ie extends I{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(116,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(131,null),m.localize(132,null)],default:Q.insertMode,description:m.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:m.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:m.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:m.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(137,null),m.localize(138,null),m.localize(139,null),m.localize(140,null)],default:Q.selectionMode,markdownDescription:m.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:m.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:m.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:m.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:m.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:m.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{insertMode:o(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:o(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:r(ve.showIcons,this.defaultValue.showIcons),showStatusBar:r(ve.showStatusBar,this.defaultValue.showStatusBar),preview:r(ve.preview,this.defaultValue.preview),previewMode:o(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(ve.showMethods,this.defaultValue.showMethods),showFunctions:r(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:r(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:r(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:r(ve.showFields,this.defaultValue.showFields),showVariables:r(ve.showVariables,this.defaultValue.showVariables),showClasses:r(ve.showClasses,this.defaultValue.showClasses),showStructs:r(ve.showStructs,this.defaultValue.showStructs),showInterfaces:r(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:r(ve.showModules,this.defaultValue.showModules),showProperties:r(ve.showProperties,this.defaultValue.showProperties),showEvents:r(ve.showEvents,this.defaultValue.showEvents),showOperators:r(ve.showOperators,this.defaultValue.showOperators),showUnits:r(ve.showUnits,this.defaultValue.showUnits),showValues:r(ve.showValues,this.defaultValue.showValues),showConstants:r(ve.showConstants,this.defaultValue.showConstants),showEnums:r(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:r(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(ve.showKeywords,this.defaultValue.showKeywords),showWords:r(ve.showWords,this.defaultValue.showWords),showColors:r(ve.showColors,this.defaultValue.showColors),showFiles:r(ve.showFiles,this.defaultValue.showFiles),showReferences:r(ve.showReferences,this.defaultValue.showReferences),showFolders:r(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:r(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(ve.showSnippets,this.defaultValue.showSnippets),showUsers:r(ve.showUsers,this.defaultValue.showUsers),showIssues:r(ve.showIssues,this.defaultValue.showIssues)}}}class je extends I{constructor(){super(111,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(179,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(180,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:r(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(te){te[te.None=0]="None",te[te.Same=1]="Same",te[te.Indent=2]="Indent",te[te.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class _e extends I{constructor(){super(135,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(181,null),m.localize(182,null),m.localize(183,null),m.localize(184,null)],description:m.localize(185,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,ve,Ue){return ve.get(2)===2?0:Ue}}class Ge extends S{constructor(){super(143)}compute(Q,ve,Ue){const Ne=ve.get(142);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class et extends I{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(35,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:m.localize(186,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(187,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(188,null),m.localize(189,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:r(ve.enabled,this.defaultValue.enabled),showDropSelector:o(ve.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Qe extends I{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(83,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:m.localize(190,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(191,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(192,null),m.localize(193,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:r(ve.enabled,this.defaultValue.enabled),showPasteSelector:o(ve.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const st="Consolas, 'Courier New', monospace",tt="Menlo, Monaco, 'Courier New', monospace",Pe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:h.$j?tt:h.$k?Pe:st,fontWeight:"normal",fontSize:h.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(te){return e.editorOptionsRegistry[te.id]=te,te}var Be;(function(te){te[te.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",te[te.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",te[te.accessibilitySupport=2]="accessibilitySupport",te[te.accessibilityPageSize=3]="accessibilityPageSize",te[te.ariaLabel=4]="ariaLabel",te[te.ariaRequired=5]="ariaRequired",te[te.autoClosingBrackets=6]="autoClosingBrackets",te[te.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",te[te.autoClosingDelete=8]="autoClosingDelete",te[te.autoClosingOvertype=9]="autoClosingOvertype",te[te.autoClosingQuotes=10]="autoClosingQuotes",te[te.autoIndent=11]="autoIndent",te[te.automaticLayout=12]="automaticLayout",te[te.autoSurround=13]="autoSurround",te[te.bracketPairColorization=14]="bracketPairColorization",te[te.guides=15]="guides",te[te.codeLens=16]="codeLens",te[te.codeLensFontFamily=17]="codeLensFontFamily",te[te.codeLensFontSize=18]="codeLensFontSize",te[te.colorDecorators=19]="colorDecorators",te[te.colorDecoratorsLimit=20]="colorDecoratorsLimit",te[te.columnSelection=21]="columnSelection",te[te.comments=22]="comments",te[te.contextmenu=23]="contextmenu",te[te.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",te[te.cursorBlinking=25]="cursorBlinking",te[te.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",te[te.cursorStyle=27]="cursorStyle",te[te.cursorSurroundingLines=28]="cursorSurroundingLines",te[te.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",te[te.cursorWidth=30]="cursorWidth",te[te.disableLayerHinting=31]="disableLayerHinting",te[te.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",te[te.domReadOnly=33]="domReadOnly",te[te.dragAndDrop=34]="dragAndDrop",te[te.dropIntoEditor=35]="dropIntoEditor",te[te.emptySelectionClipboard=36]="emptySelectionClipboard",te[te.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",te[te.extraEditorClassName=38]="extraEditorClassName",te[te.fastScrollSensitivity=39]="fastScrollSensitivity",te[te.find=40]="find",te[te.fixedOverflowWidgets=41]="fixedOverflowWidgets",te[te.folding=42]="folding",te[te.foldingStrategy=43]="foldingStrategy",te[te.foldingHighlight=44]="foldingHighlight",te[te.foldingImportsByDefault=45]="foldingImportsByDefault",te[te.foldingMaximumRegions=46]="foldingMaximumRegions",te[te.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",te[te.fontFamily=48]="fontFamily",te[te.fontInfo=49]="fontInfo",te[te.fontLigatures=50]="fontLigatures",te[te.fontSize=51]="fontSize",te[te.fontWeight=52]="fontWeight",te[te.fontVariations=53]="fontVariations",te[te.formatOnPaste=54]="formatOnPaste",te[te.formatOnType=55]="formatOnType",te[te.glyphMargin=56]="glyphMargin",te[te.gotoLocation=57]="gotoLocation",te[te.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",te[te.hover=59]="hover",te[te.inDiffEditor=60]="inDiffEditor",te[te.inlineSuggest=61]="inlineSuggest",te[te.letterSpacing=62]="letterSpacing",te[te.lightbulb=63]="lightbulb",te[te.lineDecorationsWidth=64]="lineDecorationsWidth",te[te.lineHeight=65]="lineHeight",te[te.lineNumbers=66]="lineNumbers",te[te.lineNumbersMinChars=67]="lineNumbersMinChars",te[te.linkedEditing=68]="linkedEditing",te[te.links=69]="links",te[te.matchBrackets=70]="matchBrackets",te[te.minimap=71]="minimap",te[te.mouseStyle=72]="mouseStyle",te[te.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",te[te.mouseWheelZoom=74]="mouseWheelZoom",te[te.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",te[te.multiCursorModifier=76]="multiCursorModifier",te[te.multiCursorPaste=77]="multiCursorPaste",te[te.multiCursorLimit=78]="multiCursorLimit",te[te.occurrencesHighlight=79]="occurrencesHighlight",te[te.overviewRulerBorder=80]="overviewRulerBorder",te[te.overviewRulerLanes=81]="overviewRulerLanes",te[te.padding=82]="padding",te[te.pasteAs=83]="pasteAs",te[te.parameterHints=84]="parameterHints",te[te.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",te[te.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",te[te.quickSuggestions=87]="quickSuggestions",te[te.quickSuggestionsDelay=88]="quickSuggestionsDelay",te[te.readOnly=89]="readOnly",te[te.readOnlyMessage=90]="readOnlyMessage",te[te.renameOnType=91]="renameOnType",te[te.renderControlCharacters=92]="renderControlCharacters",te[te.renderFinalNewline=93]="renderFinalNewline",te[te.renderLineHighlight=94]="renderLineHighlight",te[te.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",te[te.renderValidationDecorations=96]="renderValidationDecorations",te[te.renderWhitespace=97]="renderWhitespace",te[te.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",te[te.roundedSelection=99]="roundedSelection",te[te.rulers=100]="rulers",te[te.scrollbar=101]="scrollbar",te[te.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",te[te.scrollBeyondLastLine=103]="scrollBeyondLastLine",te[te.scrollPredominantAxis=104]="scrollPredominantAxis",te[te.selectionClipboard=105]="selectionClipboard",te[te.selectionHighlight=106]="selectionHighlight",te[te.selectOnLineNumbers=107]="selectOnLineNumbers",te[te.showFoldingControls=108]="showFoldingControls",te[te.showUnused=109]="showUnused",te[te.snippetSuggestions=110]="snippetSuggestions",te[te.smartSelect=111]="smartSelect",te[te.smoothScrolling=112]="smoothScrolling",te[te.stickyScroll=113]="stickyScroll",te[te.stickyTabStops=114]="stickyTabStops",te[te.stopRenderingLineAfter=115]="stopRenderingLineAfter",te[te.suggest=116]="suggest",te[te.suggestFontSize=117]="suggestFontSize",te[te.suggestLineHeight=118]="suggestLineHeight",te[te.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",te[te.suggestSelection=120]="suggestSelection",te[te.tabCompletion=121]="tabCompletion",te[te.tabIndex=122]="tabIndex",te[te.unicodeHighlighting=123]="unicodeHighlighting",te[te.unusualLineTerminators=124]="unusualLineTerminators",te[te.useShadowDOM=125]="useShadowDOM",te[te.useTabStops=126]="useTabStops",te[te.wordBreak=127]="wordBreak",te[te.wordSeparators=128]="wordSeparators",te[te.wordWrap=129]="wordWrap",te[te.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",te[te.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",te[te.wordWrapColumn=132]="wordWrapColumn",te[te.wordWrapOverride1=133]="wordWrapOverride1",te[te.wordWrapOverride2=134]="wordWrapOverride2",te[te.wrappingIndent=135]="wrappingIndent",te[te.wrappingStrategy=136]="wrappingStrategy",te[te.showDeprecated=137]="showDeprecated",te[te.inlayHints=138]="inlayHints",te[te.editorClassName=139]="editorClassName",te[te.pixelRatio=140]="pixelRatio",te[te.tabFocusMode=141]="tabFocusMode",te[te.layoutInfo=142]="layoutInfo",te[te.wrappingInfo=143]="wrappingInfo",te[te.defaultColorDecorators=144]="defaultColorDecorators",te[te.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn"})(Be||(e.EditorOption=Be={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(194,null)})),acceptSuggestionOnEnter:ke(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(195,null),""],markdownDescription:m.localize(196,null)})),accessibilitySupport:ke(new g),accessibilityPageSize:ke(new f(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(197,null),tags:["accessibility"]})),ariaLabel:ke(new i(4,"ariaLabel",m.localize(198,null))),ariaRequired:ke(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ke(new s(7,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(199,null),tags:["accessibility"]})),autoClosingBrackets:ke(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(200,null),m.localize(201,null),""],description:m.localize(202,null)})),autoClosingDelete:ke(new n(8,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(203,null),""],description:m.localize(204,null)})),autoClosingOvertype:ke(new n(9,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(205,null),""],description:m.localize(206,null)})),autoClosingQuotes:ke(new n(10,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(207,null),m.localize(208,null),""],description:m.localize(209,null)})),autoIndent:ke(new t(11,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[m.localize(210,null),m.localize(211,null),m.localize(212,null),m.localize(213,null),m.localize(214,null)],description:m.localize(215,null)})),automaticLayout:ke(new s(12,"automaticLayout",!1)),autoSurround:ke(new n(13,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(216,null),m.localize(217,null),m.localize(218,null),""],description:m.localize(219,null)})),bracketPairColorization:ke(new be),bracketPairGuides:ke(new se),stickyTabStops:ke(new s(114,"stickyTabStops",!1,{description:m.localize(220,null)})),codeLens:ke(new s(16,"codeLens",!0,{description:m.localize(221,null)})),codeLensFontFamily:ke(new i(17,"codeLensFontFamily","",{description:m.localize(222,null)})),codeLensFontSize:ke(new f(18,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(223,null)})),colorDecorators:ke(new s(19,"colorDecorators",!0,{description:m.localize(224,null)})),colorDecoratorActivatedOn:ke(new n(145,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(225,null),m.localize(226,null),m.localize(227,null)],description:m.localize(228,null)})),colorDecoratorsLimit:ke(new f(20,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(229,null)})),columnSelection:ke(new s(21,"columnSelection",!1,{description:m.localize(230,null)})),comments:ke(new u),contextmenu:ke(new s(23,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new s(24,"copyWithSyntaxHighlighting",!0,{description:m.localize(231,null)})),cursorBlinking:ke(new t(25,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:m.localize(232,null)})),cursorSmoothCaretAnimation:ke(new n(26,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(233,null),m.localize(234,null),m.localize(235,null)],description:m.localize(236,null)})),cursorStyle:ke(new t(27,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:m.localize(237,null)})),cursorSurroundingLines:ke(new f(28,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(238,null)})),cursorSurroundingLinesStyle:ke(new n(29,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(239,null),m.localize(240,null)],description:m.localize(241,null)})),cursorWidth:ke(new f(30,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(242,null)})),disableLayerHinting:ke(new s(31,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new s(32,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new s(33,"domReadOnly",!1)),dragAndDrop:ke(new s(34,"dragAndDrop",!0,{description:m.localize(243,null)})),emptySelectionClipboard:ke(new N),dropIntoEditor:ke(new et),stickyScroll:ke(new H),experimentalWhitespaceRendering:ke(new n(37,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),extraEditorClassName:ke(new i(38,"extraEditorClassName","")),fastScrollSensitivity:ke(new C(39,"fastScrollSensitivity",5,te=>te<=0?5:te,{markdownDescription:m.localize(248,null)})),find:ke(new T),fixedOverflowWidgets:ke(new s(41,"fixedOverflowWidgets",!1)),folding:ke(new s(42,"folding",!0,{description:m.localize(249,null)})),foldingStrategy:ke(new n(43,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(250,null),m.localize(251,null)],description:m.localize(252,null)})),foldingHighlight:ke(new s(44,"foldingHighlight",!0,{description:m.localize(253,null)})),foldingImportsByDefault:ke(new s(45,"foldingImportsByDefault",!1,{description:m.localize(254,null)})),foldingMaximumRegions:ke(new f(46,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(255,null)})),unfoldOnClickAfterEndOfLine:ke(new s(47,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(256,null)})),fontFamily:ke(new i(48,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(257,null)})),fontInfo:ke(new M),fontLigatures2:ke(new j),fontSize:ke(new Y),fontWeight:ke(new V),fontVariations:ke(new W),formatOnPaste:ke(new s(54,"formatOnPaste",!1,{description:m.localize(258,null)})),formatOnType:ke(new s(55,"formatOnType",!1,{description:m.localize(259,null)})),glyphMargin:ke(new s(56,"glyphMargin",!0,{description:m.localize(260,null)})),gotoLocation:ke(new de),hideCursorInOverviewRuler:ke(new s(58,"hideCursorInOverviewRuler",!1,{description:m.localize(261,null)})),hover:ke(new re),inDiffEditor:ke(new s(60,"inDiffEditor",!1)),letterSpacing:ke(new C(62,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,te=>C.clamp(te,-5,20),{description:m.localize(262,null)})),lightbulb:ke(new pe),lineDecorationsWidth:ke(new ce),lineHeight:ke(new z),lineNumbers:ke(new oe),lineNumbersMinChars:ke(new f(67,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new s(68,"linkedEditing",!1,{description:m.localize(263,null)})),links:ke(new s(69,"links",!0,{description:m.localize(264,null)})),matchBrackets:ke(new n(70,"matchBrackets","always",["always","near","never"],{description:m.localize(265,null)})),minimap:ke(new ie),mouseStyle:ke(new n(72,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new C(73,"mouseWheelScrollSensitivity",1,te=>te===0?1:te,{markdownDescription:m.localize(266,null)})),mouseWheelZoom:ke(new s(74,"mouseWheelZoom",!1,{markdownDescription:m.localize(267,null)})),multiCursorMergeOverlapping:ke(new s(75,"multiCursorMergeOverlapping",!0,{description:m.localize(268,null)})),multiCursorModifier:ke(new t(76,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ee,{markdownEnumDescriptions:[m.localize(269,null),m.localize(270,null)],markdownDescription:m.localize(271,null)})),multiCursorPaste:ke(new n(77,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(272,null),m.localize(273,null)],markdownDescription:m.localize(274,null)})),multiCursorLimit:ke(new f(78,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(275,null)})),occurrencesHighlight:ke(new s(79,"occurrencesHighlight",!0,{description:m.localize(276,null)})),overviewRulerBorder:ke(new s(80,"overviewRulerBorder",!0,{description:m.localize(277,null)})),overviewRulerLanes:ke(new f(81,"overviewRulerLanes",3,0,3)),padding:ke(new Re),pasteAs:ke(new Qe),parameterHints:ke(new ye),peekWidgetDefaultFocus:ke(new n(85,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(278,null),m.localize(279,null)],description:m.localize(280,null)})),definitionLinkOpensInPeek:ke(new s(86,"definitionLinkOpensInPeek",!1,{description:m.localize(281,null)})),quickSuggestions:ke(new he),quickSuggestionsDelay:ke(new f(88,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(282,null)})),readOnly:ke(new s(89,"readOnly",!1)),readOnlyMessage:ke(new $e),renameOnType:ke(new s(91,"renameOnType",!1,{description:m.localize(283,null),markdownDeprecationMessage:m.localize(284,null)})),renderControlCharacters:ke(new s(92,"renderControlCharacters",!0,{description:m.localize(285,null),restricted:!0})),renderFinalNewline:ke(new n(93,"renderFinalNewline",h.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(286,null)})),renderLineHighlight:ke(new n(94,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(287,null)],description:m.localize(288,null)})),renderLineHighlightOnlyWhenFocus:ke(new s(95,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(289,null)})),renderValidationDecorations:ke(new n(96,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new n(97,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(290,null),m.localize(291,null),m.localize(292,null),""],description:m.localize(293,null)})),revealHorizontalRightPadding:ke(new f(98,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ke(new s(99,"roundedSelection",!0,{description:m.localize(294,null)})),rulers:ke(new le),scrollbar:ke(new G),scrollBeyondLastColumn:ke(new f(102,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(295,null)})),scrollBeyondLastLine:ke(new s(103,"scrollBeyondLastLine",!0,{description:m.localize(296,null)})),scrollPredominantAxis:ke(new s(104,"scrollPredominantAxis",!0,{description:m.localize(297,null)})),selectionClipboard:ke(new s(105,"selectionClipboard",!0,{description:m.localize(298,null),included:h.$k})),selectionHighlight:ke(new s(106,"selectionHighlight",!0,{description:m.localize(299,null)})),selectOnLineNumbers:ke(new s(107,"selectOnLineNumbers",!0)),showFoldingControls:ke(new n(108,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(300,null),m.localize(301,null),m.localize(302,null)],description:m.localize(303,null)})),showUnused:ke(new s(109,"showUnused",!0,{description:m.localize(304,null)})),showDeprecated:ke(new s(137,"showDeprecated",!0,{description:m.localize(305,null)})),inlayHints:ke(new ue),snippetSuggestions:ke(new n(110,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(306,null),m.localize(307,null),m.localize(308,null),m.localize(309,null)],description:m.localize(310,null)})),smartSelect:ke(new je),smoothScrolling:ke(new s(112,"smoothScrolling",!1,{description:m.localize(311,null)})),stopRenderingLineAfter:ke(new f(115,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new Ie),inlineSuggest:ke(new ee),suggestFontSize:ke(new f(117,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(312,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ke(new f(118,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(313,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ke(new s(119,"suggestOnTriggerCharacters",!0,{description:m.localize(314,null)})),suggestSelection:ke(new n(120,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(315,null),m.localize(316,null),m.localize(317,null)],description:m.localize(318,null)})),tabCompletion:ke(new n(121,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(319,null),m.localize(320,null),m.localize(321,null)],description:m.localize(322,null)})),tabIndex:ke(new f(122,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new Z),unusualLineTerminators:ke(new n(124,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(323,null),m.localize(324,null),m.localize(325,null)],description:m.localize(326,null)})),useShadowDOM:ke(new s(125,"useShadowDOM",!0)),useTabStops:ke(new s(126,"useTabStops",!0,{description:m.localize(327,null)})),wordBreak:ke(new n(127,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(328,null),m.localize(329,null)],description:m.localize(330,null)})),wordSeparators:ke(new i(128,"wordSeparators",P.$Ir,{description:m.localize(331,null)})),wordWrap:ke(new n(129,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(332,null),m.localize(333,null),m.localize(334,null),m.localize(335,null)],description:m.localize(336,null)})),wordWrapBreakAfterCharacters:ke(new i(130,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new i(131,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new f(132,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(337,null)})),wordWrapOverride1:ke(new n(133,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new n(134,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ke(new O),defaultColorDecorators:ke(new s(144,"defaultColorDecorators",!1,{markdownDescription:m.localize(338,null)})),pixelRatio:ke(new X),tabFocusMode:ke(new s(141,"tabFocusMode",!1,{markdownDescription:m.localize(339,null)})),layoutInfo:ke(new q),wrappingInfo:ke(new Ge),wrappingIndent:ke(new _e),wrappingStrategy:ke(new ne)}}),define(Se[179],Ce([9,10]),function(fe,e){return fe.create("vs/editor/common/languages",e)}),define(Se[77],Ce([1,0,72,2,157,33,167,179]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$ws=e.$vs=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$us=e.$ts=e.SymbolKinds=e.SymbolTag=e.$ss=e.$rs=e.SymbolKind=e.$qs=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$ps=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$os=e.$ns=e.$ms=void 0;class E{constructor(j,W,M){this.offset=j,this.type=W,this.language=M,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$ms=E;class b{constructor(j,W){this.tokens=j,this.endState=W,this._tokenizationResultBrand=void 0}}e.$ns=b;class R{constructor(j,W){this.tokens=j,this.endState=W,this._encodedTokenizationResultBrand=void 0}}e.$os=R;var I;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var $;(function(T){const j=new Map;j.set(0,k.$Cj.symbolMethod),j.set(1,k.$Cj.symbolFunction),j.set(2,k.$Cj.symbolConstructor),j.set(3,k.$Cj.symbolField),j.set(4,k.$Cj.symbolVariable),j.set(5,k.$Cj.symbolClass),j.set(6,k.$Cj.symbolStruct),j.set(7,k.$Cj.symbolInterface),j.set(8,k.$Cj.symbolModule),j.set(9,k.$Cj.symbolProperty),j.set(10,k.$Cj.symbolEvent),j.set(11,k.$Cj.symbolOperator),j.set(12,k.$Cj.symbolUnit),j.set(13,k.$Cj.symbolValue),j.set(15,k.$Cj.symbolEnum),j.set(14,k.$Cj.symbolConstant),j.set(15,k.$Cj.symbolEnum),j.set(16,k.$Cj.symbolEnumMember),j.set(17,k.$Cj.symbolKeyword),j.set(27,k.$Cj.symbolSnippet),j.set(18,k.$Cj.symbolText),j.set(19,k.$Cj.symbolColor),j.set(20,k.$Cj.symbolFile),j.set(21,k.$Cj.symbolReference),j.set(22,k.$Cj.symbolCustomColor),j.set(23,k.$Cj.symbolFolder),j.set(24,k.$Cj.symbolTypeParameter),j.set(25,k.$Cj.account),j.set(26,k.$Cj.issues);function W(V){let de=j.get(V);return de||(console.info("No codicon found for CompletionItemKind "+V),de=k.$Cj.symbolProperty),de}T.toIcon=W;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function Y(V,de){let re=M.get(V);return typeof re>"u"&&!de&&(re=9),re}T.fromString=Y})($||(e.CompletionItemKinds=$={}));var D;(function(T){T[T.Deprecated=1]="Deprecated"})(D||(e.CompletionItemTag=D={}));var S;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var p;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(e.CompletionTriggerKind=p={}));var r;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(r||(e.InlineCompletionTriggerKind=r={}));class s{constructor(j,W,M,Y){this.range=j,this.text=W,this.completionKind=M,this.isSnippetText=Y}equals(j){return A.$Or.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$ps=s;var c;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})(c||(e.CodeActionTriggerType=c={}));var f;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(f||(e.SignatureHelpTriggerKind=f={}));var y;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(y||(e.DocumentHighlightKind=y={}));function C(T){return T&&F.URI.isUri(T.uri)&&A.$Or.isIRange(T.range)&&(A.$Or.isIRange(T.originSelectionRange)||A.$Or.isIRange(T.targetSelectionRange))}e.$qs=C;var i;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(i||(e.SymbolKind=i={})),e.$rs={[17]:(0,m.localize)(0,null),[16]:(0,m.localize)(1,null),[4]:(0,m.localize)(2,null),[13]:(0,m.localize)(3,null),[8]:(0,m.localize)(4,null),[9]:(0,m.localize)(5,null),[21]:(0,m.localize)(6,null),[23]:(0,m.localize)(7,null),[7]:(0,m.localize)(8,null),[0]:(0,m.localize)(9,null),[11]:(0,m.localize)(10,null),[10]:(0,m.localize)(11,null),[19]:(0,m.localize)(12,null),[5]:(0,m.localize)(13,null),[1]:(0,m.localize)(14,null),[2]:(0,m.localize)(15,null),[20]:(0,m.localize)(16,null),[15]:(0,m.localize)(17,null),[18]:(0,m.localize)(18,null),[24]:(0,m.localize)(19,null),[3]:(0,m.localize)(20,null),[6]:(0,m.localize)(21,null),[14]:(0,m.localize)(22,null),[22]:(0,m.localize)(23,null),[25]:(0,m.localize)(24,null),[12]:(0,m.localize)(25,null)};function o(T,j){return(0,m.localize)(26,null,T,e.$rs[j])}e.$ss=o;var n;(function(T){T[T.Deprecated=1]="Deprecated"})(n||(e.SymbolTag=n={}));var t;(function(T){const j=new Map;j.set(0,k.$Cj.symbolFile),j.set(1,k.$Cj.symbolModule),j.set(2,k.$Cj.symbolNamespace),j.set(3,k.$Cj.symbolPackage),j.set(4,k.$Cj.symbolClass),j.set(5,k.$Cj.symbolMethod),j.set(6,k.$Cj.symbolProperty),j.set(7,k.$Cj.symbolField),j.set(8,k.$Cj.symbolConstructor),j.set(9,k.$Cj.symbolEnum),j.set(10,k.$Cj.symbolInterface),j.set(11,k.$Cj.symbolFunction),j.set(12,k.$Cj.symbolVariable),j.set(13,k.$Cj.symbolConstant),j.set(14,k.$Cj.symbolString),j.set(15,k.$Cj.symbolNumber),j.set(16,k.$Cj.symbolBoolean),j.set(17,k.$Cj.symbolArray),j.set(18,k.$Cj.symbolObject),j.set(19,k.$Cj.symbolKey),j.set(20,k.$Cj.symbolNull),j.set(21,k.$Cj.symbolEnumMember),j.set(22,k.$Cj.symbolStruct),j.set(23,k.$Cj.symbolEvent),j.set(24,k.$Cj.symbolOperator),j.set(25,k.$Cj.symbolTypeParameter);function W(M){let Y=j.get(M);return Y||(console.info("No codicon found for SymbolKind "+M),Y=k.$Cj.symbolProperty),Y}T.toIcon=W})(t||(e.SymbolKinds=t={}));class a{static asEditOperation(j){return h.$Vr.replace(A.$Or.lift(j.range),j.text)}}e.$ts=a;class g{static{this.Comment=new g("comment")}static{this.Imports=new g("imports")}static{this.Region=new g("region")}static fromValue(j){switch(j){case"comment":return g.Comment;case"imports":return g.Imports;case"region":return g.Region}return new g(j)}constructor(j){this.value=j}}e.$us=g;var u;(function(T){function j(W){return!W||typeof W!="object"?!1:typeof W.id=="string"&&typeof W.title=="string"}T.is=j})(u||(e.Command=u={}));var d;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(d||(e.CommentThreadCollapsibleState=d={}));var v;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(v||(e.CommentThreadState=v={}));var l;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(l||(e.CommentMode=l={}));var w;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(w||(e.CommentState=w={}));var L;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(L||(e.InlayHintKind=L={}));class O{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$vs=O,e.$ws=new P.$es;var N;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(N||(e.ExternalUriOpenerPriority=N={}))}),define(Se[180],Ce([9,10]),function(fe,e){return fe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[181],Ce([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[182],Ce([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/scanner",e)}),define(Se[183],Ce([9,10]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[184],Ce([9,10]),function(fe,e){return fe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[185],Ce([9,10]),function(fe,e){return fe.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[186],Ce([9,10]),function(fe,e){return fe.create("vs/platform/files/common/files",e)}),define(Se[187],Ce([9,10]),function(fe,e){return fe.create("vs/platform/files/common/io",e)}),define(Se[188],Ce([9,10]),function(fe,e){return fe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[189],Ce([9,10]),function(fe,e){return fe.create("vs/platform/markers/common/markers",e)}),define(Se[190],Ce([9,10]),function(fe,e){return fe.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[191],Ce([9,10]),function(fe,e){return fe.create("vs/platform/workspace/common/workspace",e)}),define(Se[192],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChat",e)}),define(Se[193],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[194],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[195],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[196],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[197],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[198],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[199],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[200],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[201],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[202],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[203],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[204],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[205],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[206],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/common/editor",e)}),define(Se[207],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/common/views",e)}),define(Se[208],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[209],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[210],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[211],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[212],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[213],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[214],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[215],Ce([9,10]),function(fe,e){return fe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[216],Ce([1,0,8,182]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.TokenType=void 0;var h;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(h||(e.TokenType=h={}));function A(...b){switch(b.length){case 1:return(0,F.localize)(0,null,b[0]);case 2:return(0,F.localize)(1,null,b[0],b[1]);case 3:return(0,F.localize)(2,null,b[0],b[1],b[2]);default:return}}const P=(0,F.localize)(3,null),m=(0,F.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,k.$6)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const I=this.d,$=this.c.substring(this.d,this.e),D={type:19,offset:this.d,lexeme:$};this.g.push({offset:I,lexeme:$,additionalInfo:R}),this.f.push(D)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const I=this.c.substring(this.d,this.e),$=E.b.get(I);$?this.k($):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,I=!1,$=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(m);return}const S=this.c.charCodeAt(R);if(I)I=!1;else if(S===47&&!$){R++;break}else S===91?$=!0:S===92?I=!0:S===93&&($=!1);R++}for(;R<this.c.length&&E.a.has(this.c.charCodeAt(R));)R++;this.e=R;const D=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:D,offset:this.d})}r(){return this.e>=this.c.length}}e.$si=E}),define(Se[217],Ce([1,0,24,40,184,351]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function E(s){return s=s.trim(),s==="*"||P.test(s)}e.$ro=E;function b(s){if(!E(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=s.match(P);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$so=b;function R(s){if(!s)return null;const c=s.majorBase,f=s.majorMustEqual,y=s.minorBase;let C=s.minorMustEqual;const i=s.patchBase;let o=s.patchMustEqual;s.hasCaret&&(c===0||(C=!1),o=!1);let n=0;if(s.preRelease){const t=m.exec(s.preRelease);if(t){const[,a,g,u]=t;n=Date.UTC(Number(a),Number(g)-1,Number(u))}}return{majorBase:c,majorMustEqual:f,minorBase:y,minorMustEqual:C,patchBase:i,patchMustEqual:o,isMinimum:s.hasGreaterEquals,notBefore:n}}e.$to=R;function I(s,c,f){let y;typeof s=="string"?y=R(b(s)):y=s;let C;c instanceof Date?C=c.getTime():typeof c=="string"&&(C=new Date(c).getTime());let i;if(typeof f=="string"?i=R(b(f)):i=f,!y||!i)return!1;const o=y.majorBase,n=y.minorBase,t=y.patchBase;let a=i.majorBase,g=i.minorBase,u=i.patchBase;const d=i.notBefore;let v=i.majorMustEqual,l=i.minorMustEqual,w=i.patchMustEqual;return i.isMinimum?o>a?!0:o<a?!1:n>g?!0:n<g||C&&C<d?!1:t>=u:(o===1&&a===0&&(!v||!l||!w)&&(a=1,g=0,u=0,v=!0,l=!1,w=!1),o<a?!1:o>a?!v:n<g?!1:n>g?!l:t<u?!1:t>u?!w:!(C&&C<d))}e.$uo=I;function $(s,c,f,y,C){const i=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return i.push([F.default.Error,h.localize(0,null)]),i;if(typeof y.name!="string")return i.push([F.default.Error,h.localize(1,null,"name")]),i;if(typeof y.version!="string")return i.push([F.default.Error,h.localize(2,null,"version")]),i;if(!y.engines)return i.push([F.default.Error,h.localize(3,null,"engines")]),i;if(typeof y.engines.vscode!="string")return i.push([F.default.Error,h.localize(4,null,"engines.vscode")]),i;if(typeof y.extensionDependencies<"u"&&!r(y.extensionDependencies))return i.push([F.default.Error,h.localize(5,null,"extensionDependencies")]),i;if(typeof y.activationEvents<"u"){if(!r(y.activationEvents))return i.push([F.default.Error,h.localize(6,null,"activationEvents")]),i;if(typeof y.main>"u"&&typeof y.browser>"u")return i.push([F.default.Error,h.localize(7,null,"activationEvents","main","browser")]),i}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&i.push([F.default.Warning,h.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return i.push([F.default.Error,h.localize(9,null,"main")]),i;{const t=(0,k.$0f)(f,y.main);(0,k.$4f)(t,f)||i.push([F.default.Warning,h.localize(10,null,t.path,f.path)])}}if(typeof y.browser<"u"){if(typeof y.browser!="string")return i.push([F.default.Error,h.localize(11,null,"browser")]),i;{const t=(0,k.$0f)(f,y.browser);(0,k.$4f)(t,f)||i.push([F.default.Warning,h.localize(12,null,t.path,f.path)])}}if(!A.valid(y.version))return i.push([F.default.Error,h.localize(13,null)]),i;const o=[];if(!D(s,c,y,C,o))for(const t of o)i.push([F.default.Error,t]);return i}e.$vo=$;function D(s,c,f,y,C){return y||typeof f.main>"u"&&typeof f.browser>"u"?!0:p(s,c,f.engines.vscode,C)}e.$wo=D;function S(s,c,f){return s==="*"||p(c,f,s)}e.$xo=S;function p(s,c,f,y=[]){const C=R(b(f));if(!C)return y.push(h.localize(14,null,f)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return y.push(h.localize(15,null,f)),!1}else if(!C.majorMustEqual)return y.push(h.localize(16,null,f)),!1;return I(s,c,C)?!0:(y.push(h.localize(17,null,s,f)),!1)}function r(s){if(!Array.isArray(s))return!1;for(let c=0,f=s.length;c<f;c++)if(typeof s[c]!="string")return!1;return!0}}),define(Se[97],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=void 0;class k{constructor(h,A=[],P=!1){this.ctor=h,this.staticArguments=A,this.supportsDelayedInstantiation=P}}e.$mh=k}),define(Se[98],Ce([1,0,97]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=e.InstantiationType=void 0;const F=[];var h;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(h||(e.InstantiationType=h={}));function A(m,E,b){E instanceof k.$mh||(E=new k.$mh(E,[],!!b)),F.push([m,E])}e.$_q=A;function P(){return F}e.$ar=P}),define(Se[218],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=void 0;class k{constructor(A,P){this.key=A,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.$Sp=k;class F{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const P of this.a.values())P.outgoing.size===0&&A.push(P);return A}insertEdge(A,P){const m=this.lookupOrInsertNode(A),E=this.lookupOrInsertNode(P);m.outgoing.set(E.key,E),E.incoming.set(m.key,m)}removeNode(A){const P=this.b(A);this.a.delete(P);for(const m of this.a.values())m.outgoing.delete(P),m.incoming.delete(P)}lookupOrInsertNode(A){const P=this.b(A);let m=this.a.get(P);return m||(m=new k(P,A),this.a.set(P,m)),m}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[P,m]of this.a)A.push(`${P}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,P]of this.a){const m=new Set([A]),E=this.c(P,m);if(E)return E}}c(A,P){for(const[m,E]of A.outgoing){if(P.has(m))return[...P,m].join(" -> ");P.add(m);const b=this.c(E,P);if(b)return b;P.delete(m)}}}e.$Tp=F}),define(Se[5],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e._util=void 0;var k;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function m(E){return E[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=m})(k||(e._util=k={})),e.$oh=h("instantiationService");function F(P,m,E){m[k.DI_TARGET]===m?m[k.DI_DEPENDENCIES].push({id:P,index:E}):(m[k.DI_DEPENDENCIES]=[{id:P,index:E}],m[k.DI_TARGET]=m)}function h(P){if(k.serviceIds.has(P))return k.serviceIds.get(P);const m=function(E,b,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(m,E,R)};return m.toString=()=>P,k.serviceIds.set(P,m),m}e.$ph=h;function A(P){return P}e.$qh=A}),define(Se[57],Ce([1,0,14,2,5]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.ConfigurationTarget=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,h.$ph)("configurationService");function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof F.URI)}e.$Wh=A;function P(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof F.URI)}e.$Xh=P;var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function E(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Yh=E;function b(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$Zh=b;function R(s,c){const f=Object.create(null);for(const y in s)I(f,y,s[y],c);return f}e.$1h=R;function I(s,c,f,y){const C=c.split("."),i=C.pop();let o=s;for(let n=0;n<C.length;n++){const t=C[n];let a=o[t];switch(typeof a){case"undefined":a=o[t]=Object.create(null);break;case"object":break;default:y(`Ignoring ${c} as ${C.slice(0,n+1).join(".")} is ${JSON.stringify(a)}`);return}o=a}if(typeof o=="object"&&o!==null)try{o[i]=f}catch{y(`Ignoring ${c} as ${C.join(".")} is ${JSON.stringify(o)}`)}else y(`Ignoring ${c} as ${C.join(".")} is ${JSON.stringify(o)}`)}e.$2h=I;function $(s,c){const f=c.split(".");D(s,f)}e.$3h=$;function D(s,c){const f=c.shift();if(c.length===0){delete s[f];return}if(Object.keys(s).indexOf(f)!==-1){const y=s[f];typeof y=="object"&&!Array.isArray(y)&&(D(y,c),Object.keys(y).length===0&&delete s[f])}}function S(s,c,f){function y(o,n){let t=o;for(const a of n){if(typeof t!="object"||t===null)return;t=t[a]}return t}const C=c.split("."),i=y(s,C);return typeof i>"u"?f:i}e.$4h=S;function p(s,c,f){Object.keys(c).forEach(y=>{y!=="__proto__"&&(y in s?k.$le(s[y])&&k.$le(c[y])?p(s[y],c[y],f):f&&(s[y]=c[y]):s[y]=c[y])})}e.$5h=p;function r(s){return s.replace(/[\[\]]/g,"")}e.$6h=r}),define(Se[47],Ce([1,0,11,12,216,5,181,8]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ContextKeyExprType=e.$ti=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",k.$j),E.set("isLinux",k.$k),E.set("isWindows",k.$i),E.set("isWeb",k.$o),E.set("isMacNative",k.$j&&!k.$o),E.set("isEdge",k.$G),E.set("isFirefox",k.$E),E.set("isChrome",k.$D),E.set("isSafari",k.$F);function b(ce,z){if(E.get(ce)!==void 0)throw(0,m.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(ce,z)}e.$ti=b;const R=Object.prototype.hasOwnProperty;var I;(function(ce){ce[ce.False=0]="False",ce[ce.True=1]="True",ce[ce.Defined=2]="Defined",ce[ce.Not=3]="Not",ce[ce.Equals=4]="Equals",ce[ce.NotEquals=5]="NotEquals",ce[ce.And=6]="And",ce[ce.Regex=7]="Regex",ce[ce.NotRegex=8]="NotRegex",ce[ce.Or=9]="Or",ce[ce.In=10]="In",ce[ce.NotIn=11]="NotIn",ce[ce.Greater=12]="Greater",ce[ce.GreaterEquals=13]="GreaterEquals",ce[ce.Smaller=14]="Smaller",ce[ce.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const $={regexParsingWithErrorRecovery:!0},D=(0,P.localize)(0,null),S=(0,P.localize)(1,null),p=(0,P.localize)(2,null),r=(0,P.localize)(3,null),s=(0,P.localize)(4,null),c=(0,P.localize)(5,null),f=(0,P.localize)(6,null),y=(0,P.localize)(7,null);class C{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=$){this.k=z,this.d=new h.$si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:D,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const Ee=this.D(),Re=Ee.type===17?c:void 0;throw this.h.push({message:s,offset:Ee.offset,lexeme:h.$si.getLexeme(Ee),additionalInfo:Re}),C.c}return ie}catch(ie){if(ie!==C.c)throw ie;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const ie=this.o();z.push(ie)}return z.length===1?z[0]:i.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const ie=this.s();z.push(ie)}return z.length===1?z[0]:i.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),g.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,r),ie?.negate()}case 17:return this.z(),L.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const ie=this.l();return this.A(1,r),ie}case 17:{const ie=z.lexeme;if(this.z(),this.y(9)){const Re=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Re.type!==10)throw this.B("REGEX",Re);const ye=Re.lexeme,X=ye.lastIndexOf("/"),he=X===ye.length-1?void 0:this.w(ye.substring(X+1));let K;try{K=new RegExp(ye.substring(1,X),he)}catch{throw this.B("REGEX",Re)}return M.create(ie,K)}switch(Re.type){case 10:case 19:{const ye=[Re.lexeme];this.z();let X=this.D(),he=0;for(let $e=0;$e<Re.lexeme.length;$e++)Re.lexeme.charCodeAt($e)===40?he++:Re.lexeme.charCodeAt($e)===41&&he--;for(;!this.E()&&X.type!==15&&X.type!==16;){switch(X.type){case 0:he++;break;case 1:he--;break;case 10:case 18:for(let $e=0;$e<X.lexeme.length;$e++)X.lexeme.charCodeAt($e)===40?he++:Re.lexeme.charCodeAt($e)===41&&he--}if(he<0)break;ye.push(h.$si.getLexeme(X)),this.z(),X=this.D()}const K=ye.join(""),oe=K.lastIndexOf("/"),_=oe===K.length-1?void 0:this.w(K.substring(oe+1));let le;try{le=new RegExp(K.substring(1,oe),_)}catch{throw this.B("REGEX",Re)}return i.regex(ie,le)}case 18:{const ye=Re.lexeme;this.z();let X=null;if(!(0,F.$kd)(ye)){const he=ye.indexOf("/"),K=ye.lastIndexOf("/");if(he!==K&&he>=0){const oe=ye.slice(he+1,K),_=ye[K+1]==="i"?"i":"";try{X=new RegExp(oe,_)}catch{throw this.B("REGEX",Re)}}}if(X===null)throw this.B("REGEX",Re);return M.create(ie,X)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const Re=this.u();return i.notIn(ie,Re)}switch(this.D().type){case 3:{this.z();const Re=this.u();if(this.x().type===18)return i.equals(ie,Re);switch(Re){case"true":return i.has(ie);case"false":return i.not(ie);default:return i.equals(ie,Re)}}case 4:{this.z();const Re=this.u();if(this.x().type===18)return i.notEquals(ie,Re);switch(Re){case"true":return i.not(ie);case"false":return i.has(ie);default:return i.notEquals(ie,Re)}}case 5:return this.z(),j.create(ie,this.u());case 6:return this.z(),W.create(ie,this.u());case 7:return this.z(),N.create(ie,this.u());case 8:return this.z(),T.create(ie,this.u());case 13:return this.z(),i.in(ie,this.u());default:return i.has(ie)}}case 20:throw this.h.push({message:f,offset:z.offset,lexeme:"",additionalInfo:y}),C.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,ie){if(this.C(z))return this.z();throw this.B(ie,this.D())}B(z,ie,Ee){const Re=(0,P.localize)(8,null,z,h.$si.getLexeme(ie)),ye=ie.offset,X=h.$si.getLexeme(ie);return this.h.push({message:Re,offset:ye,lexeme:X,additionalInfo:Ee}),C.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ui=C;class i{static false(){return a.INSTANCE}static true(){return g.INSTANCE}static has(z){return u.create(z)}static equals(z,ie){return d.create(z,ie)}static notEquals(z,ie){return w.create(z,ie)}static regex(z,ie){return M.create(z,ie)}static in(z,ie){return v.create(z,ie)}static notIn(z,ie){return l.create(z,ie)}static not(z){return L.create(z)}static and(...z){return de.create(z,null,!0)}static or(...z){return re.create(z,null,!0)}static greater(z,ie){return N.create(z,ie)}static greaterEquals(z,ie){return T.create(z,ie)}static smaller(z,ie){return j.create(z,ie)}static smallerEquals(z,ie){return W.create(z,ie)}static{this.c=new C({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$vi=i;function o(ce){const z=new C({regexParsingWithErrorRecovery:!1});return ce.map(ie=>(z.parse(ie),z.lexingErrors.length>0?z.lexingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?(0,P.localize)(9,null,Ee.additionalInfo):(0,P.localize)(10,null),offset:Ee.offset,length:Ee.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?`${Ee.message}. ${Ee.additionalInfo}`:Ee.message,offset:Ee.offset,length:Ee.lexeme.length})):[]))}e.$wi=o;function n(ce,z){const ie=ce?ce.substituteConstants():void 0,Ee=z?z.substituteConstants():void 0;return!ie&&!Ee?!0:!ie||!Ee?!1:ie.equals(Ee)}e.$xi=n;function t(ce,z){return ce.cmp(z)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return g.INSTANCE}}e.$yi=a;class g{static{this.INSTANCE=new g}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return a.INSTANCE}}e.$zi=g;class u{static create(z,ie=null){const Ee=E.get(z);return typeof Ee=="boolean"?Ee?g.INSTANCE:a.INSTANCE:new u(z,ie)}constructor(z,ie){this.key=z,this.c=ie,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:q(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=E.get(this.key);return typeof z=="boolean"?z?g.INSTANCE:a.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Ai=u;class d{static create(z,ie,Ee=null){if(typeof ie=="boolean")return ie?u.create(z,Ee):L.create(z,Ee);const Re=E.get(z);return typeof Re=="boolean"?ie===(Re?"true":"false")?g.INSTANCE:a.INSTANCE:new d(z,ie,Ee)}constructor(z,ie,Ee){this.c=z,this.d=ie,this.f=Ee,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:ne(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=E.get(this.c);if(typeof z=="boolean"){const ie=z?"true":"false";return this.d===ie?g.INSTANCE:a.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Bi=d;class v{static create(z,ie){return new v(z,ie)}constructor(z,ie){this.d=z,this.f=ie,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:ne(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const ie=z.getValue(this.f),Ee=z.getValue(this.d);return Array.isArray(ie)?ie.includes(Ee):typeof Ee=="string"&&typeof ie=="object"&&ie!==null?R.call(ie,Ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=l.create(this.d,this.f)),this.c}}e.$Ci=v;class l{static create(z,ie){return new l(z,ie)}constructor(z,ie){this.d=z,this.f=ie,this.type=11,this.c=v.create(z,ie)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Di=l;class w{static create(z,ie,Ee=null){if(typeof ie=="boolean")return ie?L.create(z,Ee):u.create(z,Ee);const Re=E.get(z);return typeof Re=="boolean"?ie===(Re?"true":"false")?a.INSTANCE:g.INSTANCE:new w(z,ie,Ee)}constructor(z,ie,Ee){this.c=z,this.d=ie,this.f=Ee,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:ne(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=E.get(this.c);if(typeof z=="boolean"){const ie=z?"true":"false";return this.d===ie?a.INSTANCE:g.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.$Ei=w;class L{static create(z,ie=null){const Ee=E.get(z);return typeof Ee=="boolean"?Ee?a.INSTANCE:g.INSTANCE:new L(z,ie)}constructor(z,ie){this.c=z,this.d=ie,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:q(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=E.get(this.c);return typeof z=="boolean"?z?a.INSTANCE:g.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$Fi=L;function O(ce,z){if(typeof ce=="string"){const ie=parseFloat(ce);isNaN(ie)||(ce=ie)}return typeof ce=="string"||typeof ce=="number"?z(ce):a.INSTANCE}class N{static create(z,ie,Ee=null){return O(ie,Re=>new N(z,Re,Ee))}constructor(z,ie,Ee){this.c=z,this.d=ie,this.f=Ee,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:ne(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Gi=N;class T{static create(z,ie,Ee=null){return O(ie,Re=>new T(z,Re,Ee))}constructor(z,ie,Ee){this.c=z,this.d=ie,this.f=Ee,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:ne(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Hi=T;class j{static create(z,ie,Ee=null){return O(ie,Re=>new j(z,Re,Ee))}constructor(z,ie,Ee){this.c=z,this.d=ie,this.f=Ee,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:ne(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Ii=j;class W{static create(z,ie,Ee=null){return O(ie,Re=>new W(z,Re,Ee))}constructor(z,ie,Ee){this.c=z,this.d=ie,this.f=Ee,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:ne(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Ji=W;class M{static create(z,ie){return new M(z,ie)}constructor(z,ie){this.d=z,this.f=ie,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const ie=this.f?this.f.source:"",Ee=z.f?z.f.source:"";return ie<Ee?-1:ie>Ee?1:0}equals(z){if(z.type===this.type){const ie=this.f?this.f.source:"",Ee=z.f?z.f.source:"";return this.d===z.d&&ie===Ee}return!1}substituteConstants(){return this}evaluate(z){const ie=z.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Y.create(this)),this.c}}e.$Ki=M;class Y{static create(z){return new Y(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new Y(this.c.map(z))}negate(){return this.c}}e.$Li=Y;function V(ce){let z=null;for(let ie=0,Ee=ce.length;ie<Ee;ie++){const Re=ce[ie].substituteConstants();if(ce[ie]!==Re&&z===null){z=[];for(let ye=0;ye<ie;ye++)z[ye]=ce[ye]}z!==null&&(z[ie]=Re)}return z===null?ce:z}class de{static create(z,ie,Ee){return de.d(z,ie,Ee)}constructor(z,ie){this.expr=z,this.c=ie,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let ie=0,Ee=this.expr.length;ie<Ee;ie++){const Re=t(this.expr[ie],z.expr[ie]);if(Re!==0)return Re}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let ie=0,Ee=this.expr.length;ie<Ee;ie++)if(!this.expr[ie].equals(z.expr[ie]))return!1;return!0}return!1}substituteConstants(){const z=V(this.expr);return z===this.expr?this:de.create(z,this.c,!1)}evaluate(z){for(let ie=0,Ee=this.expr.length;ie<Ee;ie++)if(!this.expr[ie].evaluate(z))return!1;return!0}static d(z,ie,Ee){const Re=[];let ye=!1;for(const X of z)if(X){if(X.type===1){ye=!0;continue}if(X.type===0)return a.INSTANCE;if(X.type===6){Re.push(...X.expr);continue}Re.push(X)}if(Re.length===0&&ye)return g.INSTANCE;if(Re.length!==0){if(Re.length===1)return Re[0];Re.sort(t);for(let X=1;X<Re.length;X++)Re[X-1].equals(Re[X])&&(Re.splice(X,1),X--);if(Re.length===1)return Re[0];for(;Re.length>1;){const X=Re[Re.length-1];if(X.type!==9)break;Re.pop();const he=Re.pop(),K=Re.length===0,oe=re.create(X.expr.map(_=>de.create([_,he],null,Ee)),null,K);oe&&(Re.push(oe),Re.sort(t))}if(Re.length===1)return Re[0];if(Ee){for(let X=0;X<Re.length;X++)for(let he=X+1;he<Re.length;he++)if(Re[X].negate().equals(Re[he]))return a.INSTANCE;if(Re.length===1)return Re[0]}return new de(Re,ie)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const ie of this.expr)z.push(...ie.keys());return z}map(z){return new de(this.expr.map(ie=>ie.map(z)),null)}negate(){if(!this.c){const z=[];for(const ie of this.expr)z.push(ie.negate());this.c=re.create(z,this,!0)}return this.c}}e.$Mi=de;class re{static create(z,ie,Ee){return re.d(z,ie,Ee)}constructor(z,ie){this.expr=z,this.c=ie,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let ie=0,Ee=this.expr.length;ie<Ee;ie++){const Re=t(this.expr[ie],z.expr[ie]);if(Re!==0)return Re}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let ie=0,Ee=this.expr.length;ie<Ee;ie++)if(!this.expr[ie].equals(z.expr[ie]))return!1;return!0}return!1}substituteConstants(){const z=V(this.expr);return z===this.expr?this:re.create(z,this.c,!1)}evaluate(z){for(let ie=0,Ee=this.expr.length;ie<Ee;ie++)if(this.expr[ie].evaluate(z))return!0;return!1}static d(z,ie,Ee){let Re=[],ye=!1;if(z){for(let X=0,he=z.length;X<he;X++){const K=z[X];if(K){if(K.type===0){ye=!0;continue}if(K.type===1)return g.INSTANCE;if(K.type===9){Re=Re.concat(K.expr);continue}Re.push(K)}}if(Re.length===0&&ye)return a.INSTANCE;Re.sort(t)}if(Re.length!==0){if(Re.length===1)return Re[0];for(let X=1;X<Re.length;X++)Re[X-1].equals(Re[X])&&(Re.splice(X,1),X--);if(Re.length===1)return Re[0];if(Ee){for(let X=0;X<Re.length;X++)for(let he=X+1;he<Re.length;he++)if(Re[X].negate().equals(Re[he]))return g.INSTANCE;if(Re.length===1)return Re[0]}return new re(Re,ie)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const ie of this.expr)z.push(...ie.keys());return z}map(z){return new re(this.expr.map(ie=>ie.map(z)),null)}negate(){if(!this.c){const z=[];for(const ie of this.expr)z.push(ie.negate());for(;z.length>1;){const ie=z.shift(),Ee=z.shift(),Re=[];for(const ye of ue(ie))for(const X of ue(Ee))Re.push(de.create([ye,X],null,!1));z.unshift(re.create(Re,null,!1))}this.c=re.create(z,this,!0)}return this.c}}e.$Ni=re;class x extends u{static{this.d=[]}static all(){return x.d.values()}constructor(z,ie,Ee){super(z,null),this.f=ie,typeof Ee=="object"?x.d.push({...Ee,key:z}):Ee!==!0&&x.d.push({key:z,description:Ee,type:ie!=null?typeof ie:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return d.create(this.key,z)}notEqualsTo(z){return w.create(this.key,z)}}e.$Oi=x,e.$Pi=(0,A.$ph)("contextKeyService");function q(ce,z){return ce<z?-1:ce>z?1:0}function ne(ce,z,ie,Ee){return ce<ie?-1:ce>ie?1:z<Ee?-1:z>Ee?1:0}function pe(ce,z){if(ce.type===0||z.type===1)return!0;if(ce.type===9)return z.type===9?H(ce.expr,z.expr):!1;if(z.type===9){for(const ie of z.expr)if(pe(ce,ie))return!0;return!1}if(ce.type===6){if(z.type===6)return H(z.expr,ce.expr);for(const ie of ce.expr)if(pe(ie,z))return!0;return!1}return ce.equals(z)}e.$Qi=pe;function H(ce,z){let ie=0,Ee=0;for(;ie<ce.length&&Ee<z.length;){const Re=ce[ie].cmp(z[Ee]);if(Re<0)return!1;Re===0&&ie++,Ee++}return ie===ce.length}function ue(ce){return ce.type===9?ce.expr:[ce]}}),define(Se[219],Ce([1,0,5]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=void 0,e.$wh=(0,k.$ph)("environmentService"),e.$xh=(0,k.$qh)(e.$wh)}),define(Se[125],Ce([1,0,183,5]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Pn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=void 0,e.$Dn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$En=new RegExp(e.$Dn),e.$Fn="__web_extension",e.$Gn="skipWalkthrough",e.$Hn="extensionsSync";function h(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$In=h;function A(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Jn=A;function P(c,f){switch(c){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Kn=P;function m(c,f){return f==="web"&&!c.includes("web")}e.$Ln=m;function E(c,f,y){return m(f,y)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===y?!0:b(y).includes(c)}e.$Mn=E;function b(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Nn=b;function R(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$On=R;var I;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var $;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})($||(e.SortOrder=$={}));var D;(function(c){c.Install="install",c.Uninstall="uninstall"})(D||(e.StatisticType=D={}));var S;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$Pn=(0,F.$ph)("extensionGalleryService");var p;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var r;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class s extends Error{constructor(f,y){super(f),this.code=y,this.name=y}}e.$Qn=s,e.$Rn=(0,F.$ph)("extensionManagementService"),e.$Sn="extensionsIdentifiers/disabled",e.$Tn="extensionsIdentifiers/enabled",e.$Un=(0,F.$ph)("IGlobalExtensionEnablementService"),e.$Vn=(0,F.$ph)("IExtensionTipsService"),e.$Wn=(0,k.localize)(0,null),e.$Xn={value:e.$Wn,original:"Extensions"},e.$Yn={value:(0,k.localize)(1,null),original:"Preferences"}}),define(Se[220],Ce([1,0,5]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qVb=e.$pVb=e.$oVb=void 0,e.$oVb=(0,k.$ph)("externalTerminal"),e.$pVb="Terminal.app",e.$qVb=(0,k.$ph)("externalTerminal")}),define(Se[221],Ce([1,0,46,15,13,11,94,29,96,185,220]),function(fe,e,k,F,h,A,P,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y3b=e.$X3b=e.$W3b=void 0;const I=b.localize(0,null);class ${async getDefaultTerminalForPlatforms(){return{windows:D.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class D extends ${static{this.b="cmd.exe"}openTerminal(y,C){return this.spawnTerminal(k,y,E.$hl(),C)}spawnTerminal(y,C,i,o){const n=C.windowsExec||D.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const t=h.$ec(n,".exe").toLowerCase();if(t==="cmder")return y.spawn(n,o?[o]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return n.indexOf(" ")>=0&&a.push('""'),a.push(n),t==="wt"&&a.push("-d ."),new Promise((g,u)=>{const d=r(process),v=y.spawn(i,a,{cwd:o,env:d});v.on("error",u),v.on("exit",()=>g())})}runInTerminal(y,C,i,o,n){const t="windowsExec"in n&&n.windowsExec?n.windowsExec:D.getDefaultTerminalWindows();return new Promise((a,g)=>{const u=`"${C} - ${I}"`,d=`""${i.join('" "')}" & pause"`,v=Object.assign({},r(process),o);Object.keys(v).filter(N=>v[N]===null).forEach(N=>delete v[N]);const l={cwd:C,env:v,windowsVerbatimArguments:!0};let w,L;h.$ec(t,".exe")==="wt"?(w=t,L=["-d",".",D.b,"/c",d]):(w=D.b,L=["/c","start",u,"/wait",t,"/c",d]),k.spawn(w,L,l).on("error",N=>{g(s(N))}),a(void 0)})}static getDefaultTerminalWindows(){if(!D.d){const y=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");D.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${y?"Sysnative":"System32"}\\cmd.exe`}return D.d}}e.$W3b=D;class S extends ${static{this.b="/usr/bin/osascript"}openTerminal(y,C){return this.spawnTerminal(k,y,C)}runInTerminal(y,C,i,o,n){const t=n.osxExec||R.$pVb;return new Promise((a,g)=>{if(t===R.$pVb||t==="iTerm.app"){const u=t===R.$pVb?"TerminalHelper":"iTermHelper",v=[F.$4e.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`).fsPath,"-t",y||I,"-w",C];for(const L of i)v.push("-a"),v.push(L);if(o){const L=Object.assign({},r(process),o);for(const O in L){const N=L[O];N===null?(v.push("-u"),v.push(O)):(v.push("-e"),v.push(`${O}=${N}`))}}let l="";const w=k.spawn(S.b,v);w.on("error",L=>{g(s(L))}),w.stderr.on("data",L=>{l+=L.toString()}),w.on("exit",L=>{if(L===0)a(void 0);else if(l){const O=l.split(`
`,1);g(new Error(O[0]))}else g(new Error(b.localize(1,null,u,L)))})}else g(new Error(b.localize(2,null,t)))})}spawnTerminal(y,C,i){const o=C.osxExec||R.$pVb;return new Promise((n,t)=>{const a=["-a",o];i&&a.push(i);const g=r(process),u=y.spawn("/usr/bin/open",a,{cwd:i,env:g});u.on("error",t),u.on("exit",()=>n())})}}e.$X3b=S;class p extends ${static{this.b=b.localize(3,null)}openTerminal(y,C){return this.spawnTerminal(k,y,C)}runInTerminal(y,C,i,o,n){const t=n.linuxExec?Promise.resolve(n.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((a,g)=>{const u=[];t.then(d=>{d.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const v=`${c(i)}; echo; read -p "${p.b}" -n1;`;u.push(`''${v}''`);const l=Object.assign({},r(process),o);Object.keys(l).filter(N=>l[N]===null).forEach(N=>delete l[N]);const w={cwd:C,env:l};let L="";const O=k.spawn(d,u,w);O.on("error",N=>{g(s(N))}),O.stderr.on("data",N=>{L+=N.toString()}),O.on("exit",N=>{if(N===0)a(void 0);else if(L){const T=L.split(`
`,1);g(new Error(T[0]))}else g(new Error(b.localize(4,null,d,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!A.$k)p.d=Promise.resolve("xterm");else{const y=await m.Promises.exists("/etc/debian_version");p.d=new Promise(C=>{y?C("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?C("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?C("konsole"):process.env.COLORTERM?C(process.env.COLORTERM):process.env.TERM?C(process.env.TERM):C("xterm")})}return p.d}spawnTerminal(y,C,i){const o=C.linuxExec?Promise.resolve(C.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{o.then(a=>{const g=r(process),u=y.spawn(a,[],{cwd:i,env:g});u.on("error",t),u.on("exit",()=>n())})})}}e.$Y3b=p;function r(f){const y={...f.env};return(0,P.$fl)(y),y}function s(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(b.localize(5,null,f.path)):f}function c(f){let y="";for(const C of f)C.indexOf(" ")>=0?y+='"'+C+'"':y+=C,y+=" ";return y}}),define(Se[30],Ce([1,0,71,13,12,14,2,186,5,11,15]),function(fe,e,k,F,h,A,P,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileKind=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileOperationResult=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileChangeType=e.$0j=e.FileOperation=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.FileSystemProviderErrorCode=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tj=e.$Sj=void 0,e.$Sj=(0,E.$ph)("fileService");function I(q){return q.create===!0}e.$Tj=I;var $;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var D;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(D||(e.FilePermission=D={}));var S;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(S||(e.FileSystemProviderCapabilities=S={}));function p(q){return!!(q.capabilities&2)}e.$Uj=p;function r(q){return!!(q.capabilities&8)}e.$Vj=r;function s(q){return!!(q.capabilities&131072)}e.$Wj=s;function c(q){return!!(q.capabilities&4)}e.$Xj=c;function f(q){return!!(q.capabilities&16)}e.$Yj=f;function y(q){return p(q)?!!(q.capabilities&16384):!1}e.$Zj=y;function C(q){return p(q)?!!(q.capabilities&32768):!1}e.$1j=C;function i(q){return!!(q.capabilities&65536)}e.$2j=i;function o(q){return!!(q.capabilities&2048)}e.$3j=o;var n;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class t extends Error{static create(ne,pe){const H=new t(ne.toString(),pe);return u(H,pe),H}constructor(ne,pe){super(ne),this.code=pe}}e.$4j=t;function a(q,ne){return t.create(q,ne)}e.$5j=a;function g(q){return q||a((0,m.localize)(0,null),n.Unknown)}e.$6j=g;function u(q,ne){return q.name=ne?`${ne} (FileSystemError)`:"FileSystemError",q}e.$7j=u;function d(q){if(!q)return n.Unknown;if(q instanceof t)return q.code;const ne=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!ne)return n.Unknown;switch(ne[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$8j=d;function v(q){if(q instanceof T)return q.fileOperationResult;switch(d(q)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$9j=v;var l;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(l||(e.FileOperation=l={}));class w{constructor(ne,pe,H){this.resource=ne,this.operation=pe,this.target=H}isOperation(ne){return this.operation===ne}}e.$0j=w;var L;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class O{constructor(ne,pe){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const H=new Map;for(const ue of ne){const ce=H.get(ue.type);switch(ce?ce.push([ue.resource,ue]):H.set(ue.type,[[ue.resource,ue]]),ue.type){case 1:this.rawAdded.push(ue.resource);break;case 0:this.rawUpdated.push(ue.resource);break;case 2:this.rawDeleted.push(ue.resource);break}}for(const[ue,ce]of H)switch(ue){case 1:this.a=k.$vh.forUris(()=>pe),this.a.fill(ce);break;case 0:this.b=k.$vh.forUris(()=>pe),this.b.fill(ce);break;case 2:this.c=k.$vh.forUris(()=>pe),this.c.fill(ce);break}}contains(ne,...pe){return this.d(ne,{includeChildren:!1},...pe)}affects(ne,...pe){return this.d(ne,{includeChildren:!0},...pe)}d(ne,pe,...H){if(!ne)return!1;const ue=H.length>0;return!!((!ue||H.includes(1))&&(this.a?.get(ne)||pe.includeChildren&&this.a?.findSuperstr(ne))||(!ue||H.includes(0))&&(this.b?.get(ne)||pe.includeChildren&&this.b?.findSuperstr(ne))||(!ue||H.includes(2))&&(this.c?.findSubstr(ne)||pe.includeChildren&&this.c?.findSuperstr(ne)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$$j=O;function N(q,ne,pe){return!q||!ne||q===ne||ne.length>q.length?!1:(ne.charAt(ne.length-1)!==F.sep&&(ne+=F.sep),pe?(0,h.$Nd)(q,ne):q.indexOf(ne)===0)}e.$_j=N;class T extends Error{constructor(ne,pe,H){super(ne),this.fileOperationResult=pe,this.options=H}}e.$ak=T;class j extends T{constructor(ne,pe,H,ue){super(ne,pe,ue),this.fileOperationResult=pe,this.size=H}}e.$bk=j;class W extends T{constructor(ne,pe,H){super(ne,2,H),this.stat=pe}}e.$ck=W;var M;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(M||(e.FileOperationResult=M={})),e.$dk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ek={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$fk="files.associations",e.$gk="files.exclude",e.$hk="files.readonlyInclude",e.$ik="files.readonlyExclude",e.$jk="files.readonlyFromPermissions";var Y;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.$kk="";function V(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$lk=V;async function de(q,ne){if(!ne.hasProvider(P.URI.from({scheme:q.scheme})))return new Promise(pe=>{const H=ne.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===q.scheme&&ue.added&&(H.dispose(),pe())})})}e.$mk=de;class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(ne){return(0,A.$ne)(ne)||(ne=0),ne<re.KB?(0,m.localize)(1,null,ne.toFixed(0)):ne<re.MB?(0,m.localize)(2,null,(ne/re.KB).toFixed(2)):ne<re.GB?(0,m.localize)(3,null,(ne/re.MB).toFixed(2)):ne<re.TB?(0,m.localize)(4,null,(ne/re.GB).toFixed(2)):(0,m.localize)(5,null,(ne/re.TB).toFixed(2))}}e.$nk=re;function x(q){const ne=typeof q=="string"||q?.scheme===R.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===R.Schemas.file?1024*re.MB:ne?10*re.MB:b.$o?50*re.MB:1024*re.MB}e.$ok=x}),define(Se[222],Ce([1,0,22,8,187,30]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=void 0;async function P(R,I,$,D,S,p){let r;try{await m(R,I,$,D,S,p)}catch(s){r=s}finally{r&&S.errorTransformer&&(r=S.errorTransformer(r)),typeof r<"u"&&$.error(r),$.end()}}e.$rp=P;async function m(R,I,$,D,S,p){E(p);const r=await R.open(I,{create:!1});try{E(p);let s=0,c=0,f=S&&typeof S.length=="number"?S.length:void 0,y=k.$Jb.alloc(Math.min(S.bufferSize,typeof f=="number"?f:S.bufferSize)),C=S&&typeof S.position=="number"?S.position:0,i=0;do c=await R.read(r,C,y.buffer,i,y.byteLength-i),C+=c,i+=c,s+=c,typeof f=="number"&&(f-=c),i===y.byteLength&&(await $.write(D(y)),y=k.$Jb.alloc(Math.min(S.bufferSize,typeof f=="number"?f:S.bufferSize)),i=0);while(c>0&&(typeof f!="number"||f>0)&&E(p)&&b(s,S));if(i>0){let o=i;typeof f=="number"&&(o=Math.min(i,f)),$.write(D(y.slice(0,o)))}}catch(s){throw(0,A.$6j)(s)}finally{await R.close(r)}}function E(R){if(R.isCancellationRequested)throw(0,F.$4)();return!0}function b(R,I){if(typeof I?.limits?.size=="number"&&R>I.limits.size)throw(0,A.$5j)((0,h.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[78],Ce([1,0,34,4,13,11,2,30]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=void 0;function E(s){return s.recursive===!0}e.$tp=E;class b extends F.$lb{static{this.a=5}constructor(c,f,y,C){super(),this.h=c,this.i=f,this.j=y,this.k=C,this.c=this.B(new F.$mb),this.f=void 0,this.g=0}m(){const c=new F.$kb;this.c.value=c,this.b=this.l(c),this.b.setVerboseLogging(this.j),c.add(this.b.onDidChangeFile(f=>this.h(f))),c.add(this.b.onDidLogMessage(f=>this.i(f))),c.add(this.b.onDidError(f=>this.n(f)))}n(c){this.k.restartOnError?this.g<b.a&&this.f?(this.r(`restarting watcher after error: ${c}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${c}`):this.r(c)}p(c){this.g++,this.m(),this.watch(c)}async watch(c){this.f=c,await this.b?.watch(c)}async setVerboseLogging(c){this.j=c,await this.b?.setVerboseLogging(c)}r(c){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${c}`})}s(c){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${c}`})}dispose(){return this.b=void 0,super.dispose()}}e.$up=b;class R extends b{constructor(c,f,y){super(c,f,y,{type:"node.js",restartOnError:!1})}}e.$vp=R;class I extends b{constructor(c,f,y){super(c,f,y,{type:"universal",restartOnError:!0})}}e.$wp=I;function $(s){return s.map(c=>({type:c.type,resource:P.URI.file(c.path)}))}e.$xp=$;function D(s){const c=new r;for(const f of s)c.processEvent(f);return c.coalesce()}e.$yp=D;function S(s,c){return typeof c=="string"&&!c.startsWith(k.$aj)&&!(0,h.$_b)(c)?{base:s,pattern:c}:c}e.$zp=S;function p(s,c){const f=[];for(const y of c)f.push((0,k.$ej)(S(s,y)));return f}e.$Ap=p;class r{constructor(){this.a=new Set,this.b=new Map}c(c){return A.$k?c.path:c.path.toLowerCase()}processEvent(c){const f=this.b.get(this.c(c));let y=!1;if(f){const C=f.type,i=c.type;f.path!==c.path&&(c.type===2||c.type===1)?y=!0:C===1&&i===2?(this.b.delete(this.c(c)),this.a.delete(f)):C===2&&i===1?f.type=0:C===1&&i===0||(f.type=i)}else y=!0;y&&(this.a.add(c),this.b.set(this.c(c),c))}coalesce(){const c=[],f=[];return Array.from(this.a).filter(y=>y.type!==2?(c.push(y),!1):!0).sort((y,C)=>y.path.length-C.path.length).filter(y=>f.some(C=>(0,m.$_j)(y.path,C,!A.$k))?!1:(f.push(y.path),!0)).concat(c)}}}),define(Se[223],Ce([1,0,49,17,21,31,4,69,13,11,95,29,78]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0;class D extends P.$lb{static{this.a=100}static{this.b=75}constructor(r,s,c,f){super(),this.j=r,this.k=s,this.l=c,this.m=f,this.c=this.B(new F.$Jg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},y=>this.k(y))),this.f=this.B(new F.$Ig(y=>this.u(y),D.b)),this.g=(0,$.$Ap)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,$.$Ap)(this.j.path,this.j.includes):void 0,this.i=new h.$ed,this.ready=this.n()}async n(){try{const r=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const s=await I.Promises.stat(r);this.B(await this.s(r,s.isDirectory()))}catch(r){r.code!=="ENOENT"?this.w(r):this.z(r)}}async r(r){let s=r.path;try{s=await I.Promises.realpath(r.path),r.path===s&&(s=await(0,R.$Kp)(r.path)??r.path),r.path!==s&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${s})`)}catch{}return s}async s(r,s){if(b.$j&&(0,A.$Ke)(r,"/Volumes/",!0))return this.w(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),P.$lb.None;const c=new h.$ed(this.i.token),f=new P.$kb;try{const y=(0,E.$ec)(r),C=(0,k.watch)(r);f.add((0,P.$jb)(()=>{C.removeAllListeners(),C.close()})),this.z(`Started watching: '${r}'`);const i=new Set;if(s)try{for(const n of await I.Promises.readdir(r))i.add(n)}catch(n){this.w(n)}const o=new Map;f.add((0,P.$jb)(()=>{for(const[,n]of o)n.dispose();o.clear()})),C.on("error",(n,t)=>{this.w(`Failed to watch ${r} for changes using fs.watch() (${n}, ${t})`),this.dispose()}),C.on("change",(n,t)=>{if(c.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${t}`);let a="";if(t&&(a=t.toString(),b.$j&&(a=(0,m.$7k)(a))),!(!a||n!=="change"&&n!=="rename"))if(s)if(n==="rename"){o.get(a)?.dispose();const g=setTimeout(async()=>{if(o.delete(a),a===y&&!await I.Promises.exists(r)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.v((0,E.$ac)(r,a));if(c.token.isCancellationRequested)return;let d;u?i.has(a)?d=0:(d=1,i.add(a)):(i.delete(a),d=2),this.t({path:(0,E.$ac)(this.j.path,a),type:d})},D.a);o.set(a,(0,P.$jb)(()=>clearTimeout(g)))}else{let g;i.has(a)?g=0:(g=1,i.add(a)),this.t({path:(0,E.$ac)(this.j.path,a),type:g})}else if(n==="rename"||a!==y){const g=setTimeout(async()=>{const u=await I.Promises.exists(r);c.token.isCancellationRequested||(u?(this.t({path:this.j.path,type:0},!0),f.add(await this.s(r,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},D.a);f.clear(),f.add((0,P.$jb)(()=>clearTimeout(g)))}else this.t({path:this.j.path,type:0},!0)})}catch(y){await I.Promises.exists(r)&&!c.token.isCancellationRequested&&this.w(`Failed to watch ${r} for changes using fs.watch() (${y.toString()})`)}return(0,P.$jb)(()=>{c.dispose(!0),f.dispose()})}t(r,s=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`),!s&&this.g.some(c=>c(r.path))?this.m&&this.z(` >> ignored (excluded) ${r.path}`):!s&&this.h&&this.h.length>0&&!this.h.some(c=>c(r.path))?this.m&&this.z(` >> ignored (not included) ${r.path}`):this.f.work(r))}u(r){const s=(0,$.$yp)(r);if(s.length>0){if(this.m)for(const f of s)this.z(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.c.work(s)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(r){if(b.$k)return I.Promises.exists(r);try{const s=(0,E.$ec)(r);return(await I.Promises.readdir((0,E.$dc)(r))).some(f=>f===s)}catch(s){return this.z(s),!1}}setVerboseLogging(r){this.m=r}w(r){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}y(r){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}z(r){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Np=D;async function S(p,r,s,c,f=512){const y=await I.Promises.open(p,"r"),C=Buffer.allocUnsafe(f),i=new h.$ed(c);let o,n=!1;const t={path:p,excludes:[],recursive:!1},a=new D(t,g=>{(async()=>{for(const{type:u}of g)if(u===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:d}=await I.Promises.read(y,C,0,f,null);if(!d||i.token.isCancellationRequested)break;r(C.slice(0,d))}}catch(d){o=new Error(d),i.dispose(!0)}finally{n=!1}}})()});return await a.ready,s(),new Promise((g,u)=>{i.token.onCancellationRequested(async()=>{a.dispose();try{await I.Promises.close(y)}catch(d){o=new Error(d)}o?u(o):g()})})}e.$Op=S}),define(Se[224],Ce([1,0,3,34,4,11,223]),function(fe,e,k,F,h,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;class m extends h.$lb{constructor(){super(...arguments),this.a=this.B(new k.$8c),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$8c),this.onDidLogMessage=this.b.event,this.onDidError=k.Event.None,this.c=new Map,this.f=!1}async watch(b){const R=this.i(b),I=R.filter(D=>{const S=this.c.get(D.path);return S?!(0,F.$ij)(S.request.excludes,D.excludes)||!(0,F.$ij)(S.request.includes,D.includes):!0}),$=Array.from(this.c.values()).filter(({request:D})=>!R.find(S=>S.path===D.path&&(0,F.$ij)(S.excludes,D.excludes)&&(0,F.$ij)(S.includes,D.includes))).map(({request:D})=>D.path);I.length&&this.j(`Request to start watching: ${I.map(D=>`${D.path} (excludes: ${D.excludes.length>0?D.excludes:"<none>"}, includes: ${D.includes&&D.includes.length>0?JSON.stringify(D.includes):"<all>"})`).join(",")}`),$.length&&this.j(`Request to stop watching: ${$.join(",")}`);for(const D of $)this.h(D);for(const D of I)this.g(D)}g(b){const R=new P.$Np(b,$=>this.a.fire($),$=>this.b.fire($),this.f),I={request:b,instance:R};this.c.set(b.path,I)}async stop(){for(const[b]of this.c)this.h(b);this.c.clear()}h(b){const R=this.c.get(b);R&&(this.c.delete(b),R.instance.dispose())}i(b){const R=new Map;for(const I of b){const $=A.$k?I.path:I.path.toLowerCase();R.set($,I)}return Array.from(R.values())}async setVerboseLogging(b){this.f=b;for(const[,R]of this.c)R.instance.setVerboseLogging(b)}j(b){this.f&&this.b.fire({type:"trace",message:this.k(b)})}k(b,R){return R?`[File Watcher (node.js)] ${b} (path: ${R.request.path})`:`[File Watcher (node.js)] ${b}`}}e.$Pp=m}),define(Se[225],Ce([1,0,78,224]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;class h extends k.$vp{constructor(P,m,E){super(P,m,E),this.m()}l(){return new F.$Pp}}e.$Qp=h}),define(Se[226],Ce([1,0,15,76,176,78]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;class P extends A.$wp{constructor(E,b,R){super(E,b,R),this.m()}l(E){const b=E.add(new h.$Hp(k.$4e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(b.onDidProcessExit(({code:R,signal:I})=>this.n(`terminated by itself with code ${R}, signal: ${I}`))),F.ProxyChannel.toService((0,F.$9g)(b.getChannel("watcher")))}}e.$Ip=P}),define(Se[99],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=void 0;class k{constructor(...h){this.a=new Map;for(const[A,P]of h)this.set(A,P)}set(h,A){const P=this.a.get(h);return this.a.set(h,A),P}has(h){return this.a.has(h)}get(h){return this.a.get(h)}}e.$nh=k}),define(Se[227],Ce([1,0,17,8,4,97,218,5,99,68]),function(fe,e,k,F,h,A,P,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0;const R=!1;class I extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class ${constructor(r=new E.$nh,s=!1,c,f=R){this.f=r,this.g=s,this.h=c,this.i=f,this.o=new Set,this.f.set(m.$oh,this),this._globalGraph=f?c?._globalGraph??new P.$Tp(y=>y):void 0}createChild(r){return new $(r,this.g,this,this.i)}invokeFunction(r,...s){const c=S.traceInvocation(this.i,r);let f=!1;try{return r({get:C=>{if(f)throw(0,F.$6)("service accessor is only valid during the invocation of its target method");const i=this.m(C,c);if(!i)throw new Error(`[invokeFunction] unknown service '${C}'`);return i}},...s)}finally{f=!0,c.stop()}}createInstance(r,...s){let c,f;return r instanceof A.$mh?(c=S.traceCreation(this.i,r.ctor),f=this.j(r.ctor,r.staticArguments.concat(s),c)):(c=S.traceCreation(this.i,r),f=this.j(r,s,c)),c.stop(),f}j(r,s=[],c){const f=m._util.getServiceDependencies(r).sort((i,o)=>i.index-o.index),y=[];for(const i of f){const o=this.m(i.id,c);o||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${i.id}.`,!1),y.push(o)}const C=f.length>0?f[0].index:s.length;if(s.length!==C){console.trace(`[createInstance] First service dependency of ${r.name} at position ${C+1} conflicts with ${s.length} static arguments`);const i=C-s.length;i>0?s=s.concat(new Array(i)):s=s.slice(0,C)}return Reflect.construct(r,s.concat(y))}k(r,s){if(this.f.get(r)instanceof A.$mh)this.f.set(r,s);else if(this.h)this.h.k(r,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const s=this.f.get(r);return!s&&this.h?this.h.l(r):s}m(r,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const c=this.l(r);return c instanceof A.$mh?this.q(r,c,s.branch(r,!0)):(s.branch(r,!1),c)}q(r,s,c){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,s,c)}finally{this.o.delete(r)}}r(r,s,c){const f=new P.$Tp(i=>i.id.toString());let y=0;const C=[{id:r,desc:s,_trace:c}];for(;C.length;){const i=C.pop();if(f.lookupOrInsertNode(i),y++>1e3)throw new I(f);for(const o of m._util.getServiceDependencies(i.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${r} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof A.$mh){const t={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};f.insertEdge(i,t),C.push(t)}}}for(;;){const i=f.roots();if(i.length===0){if(!f.isEmpty())throw new I(f);break}for(const{data:o}of i){if(this.l(o.id)instanceof A.$mh){const t=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,t)}f.removeNode(o)}}return this.l(r)}s(r,s,c=[],f,y){if(this.f.get(r)instanceof A.$mh)return this.t(r,s,c,f,y);if(this.h)return this.h.s(r,s,c,f,y);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(r,s,c=[],f,y){if(f){const C=new $(void 0,this.g,this,this.i);C.c=String(r);const i=new Map,o=new k.$Lg(()=>{const n=C.j(s,c,y);for(const[t,a]of i){const g=n[t];if(typeof g=="function")for(const u of a)g.apply(n,u)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,t){if(!o.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let u=i.get(t);return u||(u=new b.$lc,i.set(t,u)),(v,l,w)=>{const L=u.push([v,l,w]);return(0,h.$jb)(L)}}if(t in n)return n[t];const a=o.value;let g=a[t];return typeof g!="function"||(g=g.bind(a),n[t]=g),g},set(n,t,a){return o.value[t]=a,!0},getPrototypeOf(n){return s.prototype}})}else return this.j(s,c,y)}u(r,s){if(s&&console.warn(r),this.g)throw new Error(r)}}e.$Up=$;var D;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(D||(D={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(r,s){return r?new S(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(r,s){return r?new S(1,s.name):S.c}static{this.f=0}constructor(r,s){this.type=r,this.name=s,this.g=Date.now(),this.h=[]}branch(r,s){const c=new S(3,r.toString());return this.h.push([r,s,c]),c}stop(){const r=Date.now()-this.g;S.f+=r;let s=!1;function c(y,C){const i=[],o=new Array(y+1).join("	");for(const[n,t,a]of C.h)if(t&&a){s=!0,i.push(`${o}CREATES -> ${n}`);const g=c(y+1,a);g&&i.push(g)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(r>2||s)&&S.all.add(f.join(`
`))}}e.$Vp=S}),define(Se[18],Ce([1,0,45,3,70,4,28,11,24,14,2,47,5]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.log=e.$Ui=e.LogLevel=e.$Ti=e.$Si=e.$Ri=void 0,e.$Ri=(0,$.$ph)("logService"),e.$Si=(0,$.$ph)("loggerService");function D(){return new Date().toISOString()}function S(v){return(0,b.$ne)(v)}e.$Ti=S;var p;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$Ui=p.Info;function r(v,l,w){switch(l){case p.Trace:v.trace(w);break;case p.Debug:v.debug(w);break;case p.Info:v.info(w);break;case p.Warning:v.warn(w);break;case p.Error:v.error(w);break;case p.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=r;function s(v,l=!1){let w="";for(let L=0;L<v.length;L++){let O=v[L];if(O instanceof Error&&(O=(0,k.$ai)(O,l)),typeof O=="object")try{O=JSON.stringify(O)}catch{}w+=(L>0?" ":"")+O}return w}class c extends A.$lb{constructor(){super(...arguments),this.b=e.$Ui,this.c=this.B(new F.$8c),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==p.Off&&this.b<=l}}e.$Wi=c;class f extends c{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...w){this.f(p.Trace)&&this.g(p.Trace,s([l,...w],!0))}debug(l,...w){this.f(p.Debug)&&this.g(p.Debug,s([l,...w]))}info(l,...w){this.f(p.Info)&&this.g(p.Info,s([l,...w]))}warn(l,...w){this.f(p.Warning)&&this.g(p.Warning,s([l,...w]))}error(l,...w){if(this.f(p.Error))if(l instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=l.stack,this.g(p.Error,s(L))}else this.g(p.Error,s([l,...w]))}flush(){}}e.$Xi=f;class y extends c{constructor(l=e.$Ui){super(),this.setLevel(l),this.g=!m.$i}trace(l,...w){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,l,...w):console.log(`[main ${D()}]`,l,...w))}debug(l,...w){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,l,...w):console.log(`[main ${D()}]`,l,...w))}info(l,...w){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,l,...w):console.log(`[main ${D()}]`,l,...w))}warn(l,...w){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,l,...w):console.warn(`[main ${D()}]`,l,...w))}error(l,...w){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,l,...w):console.error(`[main ${D()}]`,l,...w))}dispose(){}flush(){}}e.$Yi=y;class C extends c{constructor(l=e.$Ui,w=!0){super(),this.g=w,this.setLevel(l)}trace(l,...w){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",l,...w):console.log(l,...w))}debug(l,...w){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",l,...w):console.log(l,...w))}info(l,...w){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",l,...w):console.log(l,...w))}warn(l,...w){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",l,...w):console.log(l,...w))}error(l,...w){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",l,...w):console.error(l,...w))}dispose(){}flush(){}}e.$Zi=C;class i extends c{constructor(l,w=e.$Ui){super(),this.g=l,this.setLevel(w)}trace(l,...w){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(l),...w])}debug(l,...w){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(l),...w])}info(l,...w){this.f(p.Info)&&this.g.log(p.Info,[this.h(l),...w])}warn(l,...w){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(l),...w])}error(l,...w){this.f(p.Error)&&this.g.log(p.Error,[this.h(l),...w])}h(l){return typeof l=="string"?l:(0,k.$ai)(l,this.f(p.Trace))}dispose(){}flush(){}}e.$1i=i;class o extends c{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const w of this.g)w.setLevel(l);super.setLevel(l)}trace(l,...w){for(const L of this.g)L.trace(l,...w)}debug(l,...w){for(const L of this.g)L.debug(l,...w)}info(l,...w){for(const L of this.g)L.info(l,...w)}warn(l,...w){for(const L of this.g)L.warn(l,...w)}error(l,...w){for(const L of this.g)L.error(l,...w)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.$2i=o;class n extends A.$lb{constructor(l,w,L){if(super(),this.h=l,this.j=w,this.b=new P.$ni,this.c=this.B(new F.$8c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$8c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$8c),this.onDidChangeVisibility=this.g.event,L)for(const O of L)this.b.set(O.resource,{logger:void 0,info:O})}k(l){return(0,b.$je)(l)?[...this.b.values()].find(w=>w.info.id===l):this.b.get(l)}getLogger(l){return this.k(l)?.logger}createLogger(l,w){const L=this.l(l),O=(0,b.$je)(l)?l:w?.id??(0,h.$di)(L.toString()).toString(16);let N=this.b.get(L)?.logger;const T=w?.logLevel==="always"?p.Trace:w?.logLevel;N||(N=this.m(L,T??this.getLogLevel(L)??this.h,{...w,id:O}));const j={logger:N,info:{resource:L,id:O,logLevel:T,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId,when:w?.when}};return this.registerLogger(j.info),this.b.set(L,j),N}l(l){return(0,b.$je)(l)?(0,E.$0f)(this.j,`${l}.log`):l}setLogLevel(l,w){if(R.URI.isUri(l)){const L=l,O=w,N=this.b.get(L);N&&O!==N.info.logLevel&&(N.info.logLevel=O===this.h?void 0:O,N.logger?.setLevel(O),this.b.set(N.info.resource,N),this.f.fire([L,O]))}else{this.h=l;for(const[L,O]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(l,w){const L=this.k(l);L&&w!==!L.info.hidden&&(L.info.hidden=!w,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,w]))}getLogLevel(l){let w;return l&&(w=this.b.get(l)?.info.logLevel),w??this.h}registerLogger(l){const w=this.b.get(l.resource);w?w.info.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.b.set(l.resource,{info:l,logger:void 0}),this.c.fire({added:[l],removed:[]}))}deregisterLogger(l){const w=this.b.get(l);w&&(w.logger&&w.logger.dispose(),this.b.delete(l),this.c.fire({added:[],removed:[w.info]}))}*getRegisteredLoggers(){for(const l of this.b.values())yield l.info}getRegisteredLogger(l){return this.b.get(l)?.info}dispose(){this.b.forEach(l=>l.logger?.dispose()),this.b.clear(),super.dispose()}}e.$3i=n;class t{constructor(){this.onDidChangeLogLevel=new F.$8c().event}setLevel(l){}getLevel(){return p.Info}trace(l,...w){}debug(l,...w){}info(l,...w){}warn(l,...w){}error(l,...w){}critical(l,...w){}dispose(){}flush(){}}e.$4i=t;class a extends t{}e.$5i=a;function g(v){if(v.verbose)return p.Trace;if(typeof v.logLevel=="string"){const l=d(v.logLevel.toLowerCase());if(l!==void 0)return l}return e.$Ui}e.$6i=g;function u(v){switch(v){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$7i=u;function d(v){switch(v){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$8i=d,e.$9i=new I.$Oi("logLevel",u(p.Info))}),define(Se[228],Ce([1,0,19,17,8,3,4,13,78,18]),function(fe,e,k,F,h,A,P,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;class R extends P.$lb{constructor($,D){super(),this.a=$,this.b=D,this.c=this.B(new A.$8c),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$8c),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new F.$tg(0)),this.s=[],this.t=this.B(new F.$tg(0))}watch($,D){return D.recursive||this.b?.watcher?.forceUniversal?this.l($,D):this.u($,D)}l($,D){const S={path:this.C($),excludes:D.excludes,includes:D.includes,recursive:D.recursive},p=(0,k.$Bf)(this.j,S);return this.m(),(0,P.$jb)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch($=>(0,h.$Y)($))}n(){this.h||(this.h=this.B(this.p(D=>this.c.fire((0,E.$xp)(D)),D=>this.z(D),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const D of this.j)(0,E.$tp)(D)&&(D.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const D of this.j)(0,E.$tp)(D)&&$.includes(D.path)&&(D.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u($,D){const S={path:this.C($),excludes:D.excludes,includes:D.includes,recursive:!1},p=(0,k.$Bf)(this.s,S);return this.v(),(0,P.$jb)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch($=>(0,h.$Y)($))}w(){return this.r||(this.r=this.B(this.y($=>this.c.fire((0,E.$xp)($)),$=>this.z($),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)}))),this.r.watch(this.s)}z($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}C($){return(0,m.$$b)($.fsPath)}}e.$Bp=R}),define(Se[229],Ce([1,0,49,352,17,28,22,3,31,4,13,11,24,92,29,188,30,222,228,45,226,225]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c,f,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0,(()=>{try{(0,F.gracefulify)(k)}catch(o){console.error(`Error enabling graceful-fs: ${(0,f.$ai)(o)}`)}})();class i extends c.$Bp{static{this.D=!1}constructor(n,t){super(n,t),this.onDidChangeCapabilities=m.Event.None,this.I=new A.$ni(a=>$.$1f.getComparisonKey(a)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,I.$k&&(this.F|=1024)),this.F}async stat(n){try{const{stat:t,symbolicLink:a}=await S.SymlinkSupport.stat(this.C(n));return{type:this.H(t,a),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:r.FilePermission.Locked}}catch(t){throw this.ab(t)}}async G(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const t=await S.Promises.readdir(this.C(n),{withFileTypes:!0}),a=[];return await Promise.all(t.map(async g=>{try{let u;g.isSymbolicLink()?u=(await this.stat((0,$.$0f)(n,g.name))).type:u=this.H(g),a.push([g.name,u])}catch(u){this.a.trace(u)}})),a}catch(t){throw this.ab(t)}}H(n,t){let a;return t?.dangling?a=r.FileType.Unknown:n.isFile()?a=r.FileType.File:n.isDirectory()?a=r.FileType.Directory:a=r.FileType.Unknown,t&&(a|=r.FileType.SymbolicLink),a}async J(n){const t=this.C(n);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let a;for(;a=this.I.get(n);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await a.wait();const g=new h.$ug;return this.I.set(n,g),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,b.$jb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.I.get(n)===g&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.I.delete(n)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),g.open()})}async readFile(n,t){let a;try{t?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),a=await this.J(n));const g=this.C(n);return await S.Promises.readFile(g)}catch(g){throw this.ab(g)}finally{a?.dispose()}}L(n){i.D&&this.a.trace(n)}readFileStream(n,t,a){const g=(0,D.$xb)(u=>P.$Jb.concat(u.map(d=>P.$Jb.wrap(d))).buffer);return(0,s.$rp)(this,n,g,u=>u.buffer,{...t,bufferSize:256*1024},a),g}async writeFile(n,t,a){return a?.atomic!==!1&&a?.atomic?.postfix?this.M(n,(0,$.$0f)((0,$.$9f)(n),`${(0,$.$7f)(n)}${a.atomic.postfix}`),t,a):this.N(n,t,a)}async M(n,t,a,g){await this.N(t,a,g);try{await this.rename(t,n,{overwrite:!0})}catch(u){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw u}}async N(n,t,a){let g;try{const u=this.C(n);if(!a.create||!a.overwrite){if(await S.Promises.exists(u)){if(!a.overwrite)throw(0,r.$5j)((0,p.localize)(0,null),r.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,r.$5j)((0,p.localize)(1,null),r.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(n,{create:!0,unlock:a.unlock}),await this.write(g,0,t,0,t.byteLength)}catch(u){throw await this.bb(n,u)}finally{typeof g=="number"&&await this.close(g)}}static{this.R=!0}static configureFlushOnWrite(n){i.R=n}async open(n,t){const a=this.C(n);let g;(0,r.$Tj)(t)&&(g=await this.J(n));let u;try{if((0,r.$Tj)(t)&&t.unlock)try{const{stat:v}=await S.SymlinkSupport.stat(a);v.mode&128||await S.Promises.chmod(a,v.mode|128)}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}let d;if((0,r.$Tj)(t)){if(I.$i)try{await S.Promises.truncate(a,0),d="r+"}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}d||(d="w")}else d="r";u=await S.Promises.open(a,d)}catch(d){throw g?.dispose(),(0,r.$Tj)(t)?await this.bb(n,d):this.ab(d)}if(this.O.set(u,0),(0,r.$Tj)(t)&&this.Q.set(u,n),g){const d=this.P.get(u);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${a})`),this.P.set(u,g),d&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${a})`),d.dispose())}return u}async close(n){const t=this.P.get(n);try{if(this.O.delete(n),this.Q.delete(n)&&i.R)try{await S.Promises.fdatasync(n)}catch(a){i.configureFlushOnWrite(!1),this.a.error(a)}return await S.Promises.close(n)}catch(a){throw this.ab(a)}finally{t&&(this.P.get(n)===t&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.P.delete(n)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),t.dispose())}}async read(n,t,a,g,u){const d=this.S(n,t);let v=null;try{v=(await S.Promises.read(n,a,g,u,d)).bytesRead}catch(l){throw this.ab(l)}finally{this.U(n,d,v)}return v}S(n,t){return t===this.O.get(n)?null:t}U(n,t,a){const g=this.O.get(n);typeof g=="number"&&(typeof t=="number"||(typeof a=="number"?this.O.set(n,g+a):this.O.delete(n)))}async write(n,t,a,g,u){return(0,h.$Mg)(()=>this.W(n,t,a,g,u),100,3)}async W(n,t,a,g,u){const d=this.S(n,t);let v=null;try{v=(await S.Promises.write(n,a,g,u,d)).bytesWritten}catch(l){throw await this.bb(this.Q.get(n),l)}finally{this.U(n,d,v)}return v}async mkdir(n){try{await S.Promises.mkdir(this.C(n))}catch(t){throw this.ab(t)}}async delete(n,t){try{const a=this.C(n);if(t.recursive){let g;t?.atomic!==!1&&t.atomic.postfix&&(g=(0,R.$ac)((0,R.$dc)(a),`${(0,R.$ec)(a)}${t.atomic.postfix}`)),await S.Promises.rm(a,S.RimRafMode.MOVE,g)}else try{await S.Promises.unlink(a)}catch(g){if(g.code==="EPERM"||g.code==="EISDIR"){let u=!1;try{const{stat:d,symbolicLink:v}=await S.SymlinkSupport.stat(a);u=d.isDirectory()&&!v}catch{}if(u)await S.Promises.rmdir(a);else throw g}else throw g}}catch(a){throw this.ab(a)}}async rename(n,t,a){const g=this.C(n),u=this.C(t);if(g!==u)try{await this.X(n,t,"move",a.overwrite),await S.Promises.rename(g,u)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,p.localize)(2,null,(0,R.$ec)(g),(0,R.$ec)((0,R.$dc)(u)),d.toString()))),this.ab(d)}}async copy(n,t,a){const g=this.C(n),u=this.C(t);if(g!==u)try{await this.X(n,t,"copy",a.overwrite),await S.Promises.copy(g,u,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,p.localize)(3,null,(0,R.$ec)(g),(0,R.$ec)((0,R.$dc)(u)),d.toString()))),this.ab(d)}}async X(n,t,a,g){const u=this.C(n),d=this.C(t);let v=!1;if(!!(this.capabilities&1024)||(v=(0,E.$Je)(u,d,!0)),v){if(a==="copy")throw(0,r.$5j)((0,p.localize)(4,null),r.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const w=await this.G(n);if(!w)throw(0,r.$5j)((0,p.localize)(5,null),r.FileSystemProviderErrorCode.FileNotFound);const L=await this.G(t);if(L){if(!g)throw(0,r.$5j)((0,p.localize)(6,null),r.FileSystemProviderErrorCode.FileExists);w.type&r.FileType.File&&L.type&r.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,t){return this.Y(n,t,!1)}async Y(n,t,a){const g=this.C(n),u=this.C(t),d=!!(this.capabilities&1024);if((0,E.$Je)(g,u,!d))return;const v=new b.$kb;try{const[l,w]=await Promise.all([this.J(n),this.J(t)]);v.add(l),v.add(w),a&&await S.Promises.mkdir((0,R.$dc)(u),{recursive:!0}),await S.Promises.copyFile(g,u)}catch(l){if(l.code==="ENOENT"&&!a)return this.Y(n,t,!0);throw this.ab(l)}finally{v.dispose()}}p(n,t,a){return new y.$Ip(g=>n(g),g=>t(g),a)}y(n,t,a){return new C.$Qp(g=>n(g),g=>t(g),a)}ab(n){if(n instanceof r.$4j)return n;let t=n,a;switch(n.code){case"ENOENT":a=r.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=r.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=r.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=r.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=r.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=r.FileSystemProviderErrorCode.Unknown;break;default:a=r.FileSystemProviderErrorCode.Unknown}return(0,r.$5j)(t,a)}async bb(n,t){let a=this.ab(t);if(n&&a.code===r.FileSystemProviderErrorCode.NoPermissions)try{const{stat:g}=await S.SymlinkSupport.stat(this.C(n));g.mode&128||(a=(0,r.$5j)(t,r.FileSystemProviderErrorCode.FileWriteLocked))}catch(g){this.a.trace(g)}return a}}e.$Rp=i}),define(Se[230],Ce([1,0,4,18]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=void 0;class h extends k.$lb{constructor(P,m=[]){super(),this.a=new F.$2i([P,...m]),this.B(P.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...m){this.a.trace(P,...m)}debug(P,...m){this.a.debug(P,...m)}info(P,...m){this.a.info(P,...m)}warn(P,...m){this.a.warn(P,...m)}error(P,...m){this.a.error(P,...m)}flush(){this.a.flush()}}e.$1M=h}),define(Se[231],Ce([1,0,30,18]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=void 0;var h;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(h||(h={}));async function A(b,R,I,$,D){try{const S=await new Promise((r,s)=>{fe(["@vscode/spdlog"],r,s)});S.setFlushOn(h.Trace);const p=await S.createAsyncRotatingLogger(b,R,I,$);return D?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(S){console.error(S)}return null}function P(b,R,I){switch(R){case F.LogLevel.Trace:b.trace(I);break;case F.LogLevel.Debug:b.debug(I);break;case F.LogLevel.Info:b.info(I);break;case F.LogLevel.Warning:b.warn(I);break;case F.LogLevel.Error:b.error(I);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function m(b,R){switch(R){case F.LogLevel.Trace:b.setLevel(h.Trace);break;case F.LogLevel.Debug:b.setLevel(h.Debug);break;case F.LogLevel.Info:b.setLevel(h.Info);break;case F.LogLevel.Warning:b.setLevel(h.Warning);break;case F.LogLevel.Error:b.setLevel(h.Error);break;case F.LogLevel.Off:b.setLevel(h.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class E extends F.$Xi{constructor(R,I,$,D,S){super(),this.k=[],this.setLevel(S),this.l=this.n(R,I,$,D),this.B(this.onDidChangeLogLevel(p=>{this.m&&m(this.m,p)}))}async n(R,I,$,D){const S=$?6:1,p=30/S*k.$nk.MB,r=await A(R,I,p,S,D);if(r){this.m=r,m(this.m,this.getLevel());for(const{level:s,message:c}of this.k)P(this.m,s,c);this.k=[]}}g(R,I){this.m?P(this.m,R,I):this.getLevel()<=R&&this.k.push({level:R,message:I})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$PM=E}),define(Se[126],Ce([1,0,40,189,5]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var P;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(P||(e.MarkerSeverity=P={})),function(E){function b(S,p){return p-S}E.compare=b;const R=Object.create(null);R[E.Error]=(0,F.localize)(0,null),R[E.Warning]=(0,F.localize)(1,null),R[E.Info]=(0,F.localize)(2,null);function I(S){return R[S]||""}E.toString=I;function $(S){switch(S){case k.default.Error:return E.Error;case k.default.Warning:return E.Warning;case k.default.Info:return E.Info;case k.default.Ignore:return E.Hint}}E.fromSeverity=$;function D(S){switch(S){case E.Error:return k.default.Error;case E.Warning:return k.default.Warning;case E.Info:return k.default.Info;case E.Hint:return k.default.Ignore}}E.toSeverity=D}(P||(e.MarkerSeverity=P={}));var m;(function(E){const b="";function R($){return I($,!0)}E.makeKey=R;function I($,D){const S=[b];return $.source?S.push($.source.replace("\xA6","\\\xA6")):S.push(b),$.code?typeof $.code=="string"?S.push($.code.replace("\xA6","\\\xA6")):S.push($.code.value.replace("\xA6","\\\xA6")):S.push(b),$.severity!==void 0&&$.severity!==null?S.push(P.toString($.severity)):S.push(b),$.message&&D?S.push($.message.replace("\xA6","\\\xA6")):S.push(b),$.startLineNumber!==void 0&&$.startLineNumber!==null?S.push($.startLineNumber.toString()):S.push(b),$.startColumn!==void 0&&$.startColumn!==null?S.push($.startColumn.toString()):S.push(b),$.endLineNumber!==void 0&&$.endLineNumber!==null?S.push($.endLineNumber.toString()):S.push(b),$.endColumn!==void 0&&$.endColumn!==null?S.push($.endColumn.toString()):S.push(b),S.push(b),S.join("\xA6")}E.makeKeyOptionalMessage=I})(m||(e.IMarkerData=m={})),e.$ls=(0,h.$ph)("markerService")}),define(Se[232],Ce([1,0,3,40,5]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ku=e.$Ju=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Iu=e.Severity=void 0,e.Severity=F.default,e.$Iu=(0,h.$ph)("notificationService");var A;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var P;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(P||(e.NeverShowAgainScope=P={}));var m;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class E{constructor(){this.progress=new b,this.onDidClose=k.Event.None,this.onDidChangeVisibility=k.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$Ju=E;class b{infinite(){}done(){}total(I){}worked(I){}}e.$Ku=b}),define(Se[127],Ce([1,0,12,2,5]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cZ=e.$bZ=e.$aZ=e.$_Y=e.$$Y=void 0,e.$$Y=(0,h.$ph)("openerService");function A(b,R){return F.URI.isUri(b)?(0,k.$Md)(b.scheme,R):(0,k.$Nd)(b,R+":")}e.$_Y=A;function P(b,...R){return R.some(I=>A(b,I))}e.$aZ=P;function m(b,R){return b.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$bZ=m;function E(b){let R;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(b.fragment);return I&&(R={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},b=b.with({fragment:""})),{selection:R,uri:b}}e.$cZ=E}),define(Se[233],Ce([1,0,11,41]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;if(typeof k.$g.vscode<"u"&&typeof k.$g.vscode.context<"u"){const A=k.$g.vscode.context.configuration();if(A)h=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,F.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:A.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(Se[234],Ce([1,0,5]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=void 0,e.$0i=(0,k.$ph)("productService"),e.$$i="vscode://schemas/vscode-product"});var qe=this&&this.__param||function(fe,e){return function(k,F){e(k,F,fe)}};define(Se[128],Ce([1,0,17,21,4,5]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qu=e.$Pu=e.$Ou=e.$Nu=e.$Mu=e.ProgressLocation=e.$Lu=void 0,e.$Lu=(0,A.$ph)("progressService");var P;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(P||(e.ProgressLocation=P={})),e.$Mu=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(I,$){this.c=I,this.report=$?.async?this.e.bind(this):this.d.bind(this)}d(I){this.a=I,this.c(this.a)}e(I){Promise.resolve(this.b).finally(()=>{this.a=I;const $=this.c(this.a);this.b=Promise.resolve($).finally(()=>this.b=void 0)})}}e.$Nu=m;let E=class extends h.$lb{constructor(I,$){super(),this.a=new k.$Pg,$.withProgress(I,D=>(this.b=D,this.c&&D.report(this.c),this.a.p)),this.B((0,h.$jb)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};e.$Ou=E,e.$Ou=E=Je([qe(1,e.$Lu)],E);class b extends h.$lb{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new h.$kb)}start(I){this.stop();const $=++this.a,D=new F.$ed;return this.f=setTimeout(()=>{$===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,h.$jb)(()=>clearTimeout(this.f))),this.b.add((0,h.$jb)(()=>D.cancel())),this.b.add((0,h.$jb)(()=>this.c?this.c.done():void 0)),{id:$,token:D.token,stop:()=>this.h($),isCurrent:()=>this.a===$}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.$Pu=b,e.$Qu=(0,A.$ph)("editorProgressService")}),define(Se[42],Ce([1,0,53,14]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=void 0;class h{constructor(){this.a=new Map}add(P,m){k.ok(F.$je(P)),k.ok(F.$le(m)),k.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,m)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.$Tm=new h}),define(Se[100],Ce([1,0,3,42]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0,e.$Um={JSONContribution:"base.contributions.json"};function h(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class A{constructor(){this.b=new k.$8c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,b){this.a[h(E)]=b,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const P=new A;F.$Tm.add(e.$Um.JSONContribution,P)}),define(Se[129],Ce([1,0,19,3,14,180,57,100,42]),function(fe,e,k,F,h,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.ConfigurationScope=e.$Ym=e.EditPresentationTypes=void 0;var b;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$Ym={Configuration:"base.contributions.configuration"};var R;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m={properties:{},patternProperties:{}},e.$5m={properties:{},patternProperties:{}},e.$6m="vscode://schemas/settings/resourceLanguage",e.$7m="vscode://schemas/settings/configurationDefaults";const I=E.$Tm.as(m.$Um.JSONContribution);class ${constructor(){this.h=new Set,this.i=new F.$8c,this.onDidSchemaChange=this.i.event,this.j=new F.$8c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$6m,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.n(i,o,n),I.registerSchema(e.$6m,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.o(i,o),I.registerSchema(e.$6m,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.o(o,n),this.n(i,!1,n),I.registerSchema(e.$6m,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const n=[];for(const{overrides:t,source:a}of i)for(const g in t)if(o.add(g),e.$9m.test(g)){const u=this.a.get(g),d=u?.valuesSources??new Map;if(a)for(const L of Object.keys(t[g]))d.set(L,a);const v={...u?.value||{},...t[g]};this.a.set(g,{source:a,value:v,valuesSources:d});const l=(0,P.$6h)(g),w={type:"object",default:v,description:A.localize(1,null,l),$ref:e.$6m,defaultDefaultValue:v,source:h.$je(a)?void 0:a,defaultValueSource:a};n.push(...p(g)),this.d[g]=w,this.b.properties[g]=w}else{this.a.set(g,{value:t[g],source:a});const u=this.d[g];u&&(this.w(g,u),this.r(g,u))}this.m(n)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:n,source:t}of i)for(const a in n){const g=this.a.get(a),u=h.$je(t)?t:t?.id,d=h.$je(g?.source)?g?.source:g?.source?.id;if(u===d)if(o.add(a),this.a.delete(a),e.$9m.test(a))delete this.d[a],delete this.b.properties[a];else{const v=this.d[a];v&&(this.w(a,v),this.r(a,v))}}this.u()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,n){i.forEach(t=>{this.p(t,o,t.extensionInfo,t.restrictedProperties,void 0,n),this.c.push(t),this.q(t)})}o(i,o){const n=t=>{if(t.properties)for(const a in t.properties){o.add(a);const g=this.d[a];g?.policy?.name&&this.e.delete(g.policy.name),delete this.d[a],this.s(a,t.properties[a])}t.allOf?.forEach(a=>n(a))};for(const t of i){n(t);const a=this.c.indexOf(t);a!==-1&&this.c.splice(a,1)}}p(i,o=!0,n,t,a=3,g){a=h.$se(i.scope)?a:i.scope;const u=i.properties;if(u)for(const v in u){const l=u[v];if(o&&f(v,l)){delete u[v];continue}if(l.source=n,l.defaultDefaultValue=u[v].default,this.w(v,l),e.$9m.test(v)?l.scope=void 0:(l.scope=h.$se(l.scope)?a:l.scope,l.restricted=h.$se(l.restricted)?!!t?.includes(v):l.restricted),u[v].hasOwnProperty("included")&&!u[v].included){this.f[v]=u[v],delete u[v];continue}else this.d[v]=u[v],u[v].policy?.name&&this.e.set(u[v].policy.name,v);!u[v].deprecationMessage&&u[v].markdownDeprecationMessage&&(u[v].deprecationMessage=u[v].markdownDeprecationMessage),g.add(v)}const d=i.allOf;if(d)for(const v of d)this.p(v,o,n,t,a,g)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=n=>{const t=n.properties;if(t)for(const g in t)this.r(g,t[g]);n.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$Zm.properties[i]=o,o.scope){case 1:e.$1m.properties[i]=o;break;case 2:e.$2m.properties[i]=o;break;case 6:e.$3m.properties[i]=o;break;case 3:e.$4m.properties[i]=o;break;case 4:e.$5m.properties[i]=o;break;case 5:e.$5m.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$Zm.properties[i],o.scope){case 1:delete e.$1m.properties[i];break;case 2:delete e.$2m.properties[i];break;case 6:delete e.$3m.properties[i];break;case 3:delete e.$4m.properties[i];break;case 4:case 5:delete e.$5m.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$6m};this.w(o,n),e.$Zm.properties[o]=n,e.$1m.properties[o]=n,e.$2m.properties[o]=n,e.$3m.properties[o]=n,e.$4m.properties[o]=n,e.$5m.properties[o]=n}}v(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$6m};e.$Zm.patternProperties[e.$8m]=i,e.$1m.patternProperties[e.$8m]=i,e.$2m.patternProperties[e.$8m]=i,e.$3m.patternProperties[e.$8m]=i,e.$4m.patternProperties[e.$8m]=i,e.$5m.patternProperties[e.$8m]=i,this.i.fire()}w(i,o){const n=this.a.get(i);let t=n?.value,a=n?.source;h.$qe(t)&&(t=o.defaultDefaultValue,a=void 0),h.$qe(t)&&(t=s(o.type)),o.default=t,o.defaultValueSource=a}}const D="\\[([^\\]]+)\\]",S=new RegExp(D,"g");e.$8m=`^(${D})+$`,e.$9m=new RegExp(e.$8m);function p(C){const i=[];if(e.$9m.test(C)){let o=S.exec(C);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=S.exec(C)}}return(0,k.$rf)(i)}e.$0m=p;function r(C){return C.reduce((i,o)=>`${i}[${o}]`,"")}e.$$m=r;function s(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$_m=s;const c=new $;E.$Tm.add(e.$Ym.Configuration,c);function f(C,i){return C.trim()?e.$9m.test(C)?A.localize(7,null,C):c.getConfigurationProperties()[C]!==void 0?A.localize(8,null,C):i.policy?.name&&c.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,C,i.policy?.name,c.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}e.$an=f;function y(){const C=[],i=c.getConfigurationProperties();for(const o of Object.keys(i))C.push([o,i[o].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.$bn=y}),define(Se[235],Ce([1,0,19,3,151,4,28,23,14,2,57,129,42]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=void 0;function D(o){return Object.isFrozen(o)?o:m.$Im(o)}class S{constructor(n={},t=[],a=[],g){this.b=n,this.c=t,this.d=a,this.raw=g,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(t=>{if(t instanceof S)return t;const a=new p("");return a.parseRaw(t),a.configurationModel});this.f=n.reduce((t,a)=>a===t?a:t.merge(a),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,R.$4h)(this.contents,n):this.contents}inspect(n,t){const a=this.rawConfiguration.getValue(n),g=t?this.rawConfiguration.getOverrideValue(n,t):void 0,u=t?this.rawConfiguration.override(t).getValue(n):a;return{value:a,override:g,merged:u}}getOverrideValue(n,t){const a=this.i(t);return a?n?(0,R.$4h)(a,n):a:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const a of this.overrides)a.identifiers.includes(n)&&t.push(...a.keys);return k.$rf(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return k.$rf(n)}override(n){let t=this.a.get(n);return t||(t=this.g(n),this.a.set(n,t)),t}merge(...n){const t=m.$Hm(this.contents),a=m.$Hm(this.overrides),g=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const d of n)if(u.push(...d.raw?.length?d.raw:[d]),!d.isEmpty()){this.h(t,d.contents);for(const v of d.overrides){const[l]=a.filter(w=>k.$bf(w.identifiers,v.identifiers));l?(this.h(l.contents,v.contents),l.keys.push(...v.keys),l.keys=k.$rf(l.keys)):a.push(m.$Hm(v))}for(const v of d.keys)g.indexOf(v)===-1&&g.push(v)}return new S(t,g,a,u.every(d=>d instanceof S)?void 0:u)}g(n){const t=this.i(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const a={};for(const g of k.$rf([...Object.keys(this.contents),...Object.keys(t)])){let u=this.contents[g];const d=t[g];d&&(typeof u=="object"&&typeof d=="object"?(u=m.$Hm(u),this.h(u,d)):u=d),a[g]=u}return new S(a,this.keys,this.overrides)}h(n,t){for(const a of Object.keys(t)){if(a in n&&E.$le(n[a])&&E.$le(t[a])){this.h(n[a],t[a]);continue}n[a]=m.$Hm(t[a])}}i(n){let t=null,a=null;const g=u=>{u&&(a?this.h(a,u):a=m.$Hm(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===n?t=u.contents:u.identifiers.includes(n)&&g(u.contents);return g(t),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,t){this.j(n,t,!0)}setValue(n,t){this.j(n,t,!1)}removeValue(n){const t=this.keys.indexOf(n);t!==-1&&(this.keys.splice(t,1),(0,R.$3h)(this.contents,n),I.$9m.test(n)&&this.overrides.splice(this.overrides.findIndex(a=>k.$bf(a.identifiers,(0,I.$0m)(n))),1))}j(n,t,a){(0,R.$2h)(this.contents,n,t,g=>console.error(g)),a=a||this.keys.indexOf(n)===-1,a&&this.keys.push(n),I.$9m.test(n)&&this.overrides.push({identifiers:(0,I.$0m)(n),keys:Object.keys(this.contents[n]),contents:(0,R.$1h)(this.contents[n],g=>console.error(g))})}}e.$cn=S;class p{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,t){if(!E.$se(n)){const a=this.g(n);this.parseRaw(a,t)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,t){this.a=n;const{contents:a,keys:g,overrides:u,restricted:d,hasExcludedProperties:v}=this.h(n,t);this.b=new S(a,g,u,v?[n]:void 0),this.c=d||[]}g(n){let t={},a=null,g=[];const u=[],d=[];function v(w){Array.isArray(g)?g.push(w):a!==null&&(g[a]=w)}const l={onObjectBegin:()=>{const w={};v(w),u.push(g),g=w,a=null},onObjectProperty:w=>{a=w},onObjectEnd:()=>{g=u.pop()},onArrayBegin:()=>{const w=[];v(w),u.push(g),g=w,a=null},onArrayEnd:()=>{g=u.pop()},onLiteralValue:v,onError:(w,L,O)=>{d.push({error:w,offset:L,length:O})}};if(n)try{h.$Em(n,l),t=g[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return t}h(n,t){const a=$.$Tm.as(I.$Ym.Configuration).getConfigurationProperties(),g=this.i(n,a,!0,t);n=g.raw;const u=(0,R.$1h)(n,l=>console.error(`Conflict in settings file ${this.f}: ${l}`)),d=Object.keys(n),v=this.j(n,l=>console.error(`Conflict in settings file ${this.f}: ${l}`));return{contents:u,keys:d,overrides:v,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}i(n,t,a,g){let u=!1;if(!g?.scopes&&!g?.skipRestricted&&!g?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:u};const d={},v=[];for(const l in n)if(I.$9m.test(l)&&a){const w=this.i(n[l],t,!1,g);d[l]=w.raw,u=u||w.hasExcludedProperties,v.push(...w.restricted)}else{const w=t[l],L=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&v.push(l),!g.exclude?.includes(l)&&(g.include?.includes(l)||(L===void 0||g.scopes===void 0||g.scopes.includes(L))&&!(g.skipRestricted&&w?.restricted))?d[l]=n[l]:u=!0}return{raw:d,restricted:v,hasExcludedProperties:u}}j(n,t){const a=[];for(const g of Object.keys(n))if(I.$9m.test(g)){const u={};for(const d in n[g])u[d]=n[g][d];a.push({identifiers:(0,I.$0m)(g),keys:Object.keys(u),contents:(0,R.$1h)(u,t)})}return a}}e.$dn=p;class r extends A.$lb{constructor(n,t,a,g){super(),this.c=n,this.f=t,this.g=g,this.b=this.B(new F.$8c),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,u=>u.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&a.isEqual(u.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$en=r;class s{constructor(n,t,a,g,u,d,v,l,w,L,O,N,T){this.a=n,this.b=t,this.c=a,this.overrideIdentifiers=g,this.d=u,this.f=d,this.g=v,this.h=l,this.i=w,this.j=L,this.k=O,this.l=N,this.m=T}get value(){return D(this.c)}n(n,t,a){const g=n.inspect(t,a);return{get value(){return D(g.value)},get override(){return D(g.override)},get merged(){return D(g.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(n,t,a,g,u=new S,d=new S,v=new P.$ni,l=new S,w=new P.$ni){this.c=n,this.d=t,this.f=a,this.g=g,this.h=u,this.i=d,this.j=v,this.l=l,this.m=w,this.a=null,this.b=new P.$ni,this.n=null}getValue(n,t,a){return this.q(n,t,a).getValue(n)}updateValue(n,t,a={}){let g;a.resource?(g=this.m.get(a.resource),g||(g=new S,this.m.set(a.resource,g))):g=this.l,t===void 0?g.removeValue(n):g.setValue(n,t),a.resource||(this.a=null)}inspect(n,t,a){const g=this.q(n,t,a),u=this.u(t.resource,a),d=t.resource?this.m.get(t.resource)||this.l:this.l,v=new Set;for(const l of g.overrides)for(const w of l.identifiers)g.getOverrideValue(n,w)!==void 0&&v.add(w);return new s(n,t,g.getValue(n),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,u||void 0,d)}keys(n){const t=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,t){this.j.set(n,t),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const a=[];if(!t){const{added:g,updated:u,removed:d}=C(this.c,n);t=[...g,...u,...d]}for(const g of t)for(const u of(0,I.$0m)(g)){const d=this.c.getKeysForOverrideIdentifier(u),v=n.getKeysForOverrideIdentifier(u),l=[...v.filter(w=>d.indexOf(w)===-1),...d.filter(w=>v.indexOf(w)===-1),...d.filter(w=>!m.$Lm(this.c.override(u).getValue(w),n.override(u).getValue(w)))];a.push([u,l])}return this.updateDefaultConfiguration(n),{keys:t,overrides:a}}compareAndUpdatePolicyConfiguration(n){const{added:t,updated:a,removed:g}=C(this.d,n),u=[...t,...a,...g];return u.length&&this.updatePolicyConfiguration(n),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:t,updated:a,removed:g,overrides:u}=C(this.applicationConfiguration,n),d=[...t,...a,...g];return d.length&&this.updateApplicationConfiguration(n),{keys:d,overrides:u}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:a,removed:g,overrides:u}=C(this.localUserConfiguration,n),d=[...t,...a,...g];return d.length&&this.updateLocalUserConfiguration(n),{keys:d,overrides:u}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:a,removed:g,overrides:u}=C(this.remoteUserConfiguration,n),d=[...t,...a,...g];return d.length&&this.updateRemoteUserConfiguration(n),{keys:d,overrides:u}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:a,removed:g,overrides:u}=C(this.workspaceConfiguration,n),d=[...t,...a,...g];return d.length&&this.updateWorkspaceConfiguration(n),{keys:d,overrides:u}}compareAndUpdateFolderConfiguration(n,t){const a=this.p.get(n),{added:g,updated:u,removed:d,overrides:v}=C(a,t),l=[...g,...u,...d];return(l.length||!a)&&this.updateFolderConfiguration(n,t),{keys:l,overrides:v}}compareAndDeleteFolderConfiguration(n){const t=this.p.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:a,updated:g,removed:u,overrides:d}=C(t,void 0);return{keys:[...a,...g,...u],overrides:d}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,t,a){let g=this.r(t,a);return t.overrideIdentifier&&(g=g.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(g=g.merge(this.d)),g}r({resource:n},t){let a=this.s();if(t&&n){const g=t.getFolder(n);g&&(a=this.t(g.uri)||a);const u=this.m.get(n);u&&(a=a.merge(u))}return a}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let t=this.b.get(n);if(!t){const a=this.s(),g=this.j.get(n);g?(t=a.merge(g),this.b.set(n,t)):t=a}return t}u(n,t){if(t&&n){const a=t.getFolder(n);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,t)=>{const{contents:a,overrides:g,keys:u}=this.j.get(t);return n.push([t,{contents:a,overrides:g,keys:u}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(t=>n.add(t)),this.userConfiguration.keys.forEach(t=>n.add(t)),this.i.keys.forEach(t=>n.add(t)),this.j.forEach(t=>t.keys.forEach(a=>n.add(a))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(a=>n.add(a))),[...n.values()]}w(n){const t=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(a=>t.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(a=>t.add(a)),this.i.getKeysForOverrideIdentifier(n).forEach(a=>t.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(n).forEach(g=>t.add(g))),[...t.values()]}static parse(n){const t=this.x(n.defaults),a=this.x(n.policy),g=this.x(n.application),u=this.x(n.user),d=this.x(n.workspace),v=n.folders.reduce((l,w)=>(l.set(b.URI.revive(w[0]),this.x(w[1])),l),new P.$ni);return new c(t,a,g,u,new S,d,v,new S,new P.$ni)}static x(n){return new S(n.contents,n.keys,n.overrides)}}e.$fn=c;function f(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,t=new Map;for(const g of o)g.keys.forEach(u=>n.add(u)),g.overrides.forEach(([u,d])=>{const v=(0,P.$ki)(t,u,new Set);d.forEach(l=>v.add(l))});const a=[];return t.forEach((g,u)=>a.push([u,[...g.values()]])),{keys:[...n.values()],overrides:a}}e.$gn=f;class y{constructor(n,t,a,g){this.change=n,this.f=t,this.g=a,this.h=g,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const u of n.keys)this.affectedKeys.add(u);for(const[,u]of n.overrides)for(const d of u)this.affectedKeys.add(d);this.d=this.a;for(const u of this.affectedKeys)this.d+=u+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(n,t){const a=this.a+n,g=this.d.indexOf(a);if(g<0)return!1;const u=g+a.length;if(u>=this.d.length)return!1;const d=this.d.charCodeAt(u);if(d!==this.b&&d!==this.c)return!1;if(t){const v=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.f?.workspace):void 0,l=this.g.getValue(n,t,this.h);return!m.$Lm(v,l)}return!0}}e.$hn=y;function C(o,n){const{added:t,removed:a,updated:g}=i(n?.rawConfiguration,o?.rawConfiguration),u=[],d=o?.getAllOverrideIdentifiers()||[],v=n?.getAllOverrideIdentifiers()||[];if(n){const l=v.filter(w=>!d.includes(w));for(const w of l)u.push([w,n.getKeysForOverrideIdentifier(w)])}if(o){const l=d.filter(w=>!v.includes(w));for(const w of l)u.push([w,o.getKeysForOverrideIdentifier(w)])}if(n&&o){for(const l of d)if(v.includes(l)){const w=i({contents:o.getOverrideValue(void 0,l)||{},keys:o.getKeysForOverrideIdentifier(l)},{contents:n.getOverrideValue(void 0,l)||{},keys:n.getKeysForOverrideIdentifier(l)});u.push([l,[...w.added,...w.removed,...w.updated]])}}return{added:t,removed:a,updated:g,overrides:u}}function i(o,n){const t=o?n?o.keys.filter(u=>n.keys.indexOf(u)===-1):[...o.keys]:[],a=n?o?n.keys.filter(u=>o.keys.indexOf(u)===-1):[...n.keys]:[],g=[];if(o&&n){for(const u of n.keys)if(o.keys.indexOf(u)!==-1){const d=(0,R.$4h)(n.contents,u),v=(0,R.$4h)(o.contents,u);m.$Lm(d,v)||g.push(u)}}return{added:t,removed:a,updated:g}}}),define(Se[130],Ce([1,0,8,5]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.RemoteAuthorityResolverErrorCode=e.$yk=e.$xk=e.RemoteConnectionType=e.$wk=void 0,e.$wk=(0,F.$ph)("remoteAuthorityResolverService");var h;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(h||(e.RemoteConnectionType=h={}));class A{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$xk=A;class P{constructor(I,$){this.host=I,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$yk=P;var m;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class E extends k.$ab{static isNotAvailable(I){return I instanceof E&&I._code===m.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof E&&I._code===m.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof E&&I._code===m.NoResolverFound}static isInvalidAuthority(I){return I instanceof E&&I._code===m.InvalidAuthority}static isHandled(I){return I instanceof E&&I.isHandled}constructor(I,$=m.Unknown,D){super(I),this._message=I,this._code=$,this._detail=D,this.isHandled=$===m.NotAvailable&&D===!0,Object.setPrototypeOf(this,E.prototype)}}e.$zk=E;function b(R){const I=R.indexOf("+");return I===-1?R:R.substring(0,I)}e.$Ak=b}),define(Se[79],Ce([1,0,15]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=void 0;function F(b){return b.scheme===k.Schemas.vscodeRemote?b.authority:void 0}e.$Bk=F;function h(b){if(!b)return;const R=b.indexOf("+");return R<0?b:b.substr(0,R)}e.$Ck=h;function A(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$Dk=A;function P(b){const{host:R,port:I}=E(b);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:I}}e.$Ek=P;function m(b,R){let{host:I,port:$}=E(b);return typeof $>"u"&&($=R),{host:I,port:$}}e.$Fk=m;function E(b){const R=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const I=b.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const $=b.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:b,port:void 0}}}),define(Se[25],Ce([1,0,12,5,79]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.TargetPlatform=e.ExtensionType=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=void 0,e.$Bl="extensions.user.cache",e.$Cl="extensions.builtin.cache",e.$Dl="undefined_publisher",e.$El=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$Fl=A,e.$Gl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(P||(e.ExtensionType=P={}));var m;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class E{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,s){if(typeof r>"u"||r===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof r=="string"||typeof s=="string"){const c=typeof r=="string"?r:r.value,f=typeof s=="string"?s:s.value;return k.$Md(c,f)}return r._lower===s._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.$Hl=E;class b{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const s of r)this.add(s)}add(r){this.c.add(E.toKey(r))}delete(r){return this.c.delete(E.toKey(r))}has(r){return this.c.has(E.toKey(r))}}e.$Il=b;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(E.toKey(r))}get(r){return this.c.get(E.toKey(r))}has(r){return this.c.has(E.toKey(r))}set(r,s){this.c.set(E.toKey(r),s)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Jl=R;function I(p){return $(p)}e.$Kl=I;function $(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$Ll=$;function D(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$Ml=D;function S(p,r){if(r){const s=`onResolveRemoteAuthority:${(0,h.$Ck)(r)}`;return!!p.activationEvents?.includes(s)}return!1}e.$Nl=S,e.$Ol=(0,F.$ph)("IBuiltinExtensionsScannerService")}),define(Se[131],Ce([1,0,8,25]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kF=e.$jF=void 0;class h{constructor(){this.a=new Map,this.b=new WeakMap}register(P,m){this.a.set(P,m)}readActivationEvents(P){return this.b.has(P)||this.b.set(P,this.c(P)),this.b.get(P)}createActivationEventsMap(P){const m=Object.create(null);for(const E of P){const b=this.readActivationEvents(E);b.length>0&&(m[F.$Hl.toKey(E.identifier)]=b)}return m}c(P){if(typeof P.main>"u"&&typeof P.browser>"u")return[];const m=Array.isArray(P.activationEvents)?P.activationEvents.slice(0):[];if(!P.contributes)return m;for(const E in P.contributes){const b=this.a.get(E);if(!b)continue;const R=P.contributes[E],I=Array.isArray(R)?R:[R];try{b(I,m)}catch($){(0,k.$Y)($)}}return m}}e.$jF=h,e.$kF=new h}),define(Se[236],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pZb=void 0;class k{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(h){try{const A=await this.c();if(A){const P=String(k.a++);return this.b.set(P,A),{id:P,data:A.createNewMessage(h)}}}catch{}return{id:"",data:h}}async validate(h,A){if(!h.id)return!0;const P=this.b.get(h.id);if(!P)return!1;this.b.delete(h.id);try{return P.validate(A)==="ok"}catch{return!1}finally{P.dispose?.()}}async sign(h){try{return await this.d(h)}catch{}return h}}e.$pZb=k}),define(Se[237],Ce([1,0,236]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$4b=void 0;class F extends k.$pZb{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(P=>new P.signer().sign(A))}h(){return new Promise((A,P)=>fe(["vsda"],A,P))}}e.$$4b=F}),define(Se[238],Ce([1,0,11,41,32]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=void 0;function A(E){if(k.$t===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function P(E,b,R,I,$,D,S,p){const r=Object.create(null);r["common.machineId"]=D,r.sessionID=(0,h.$6e)()+Date.now(),r.commitHash=I,r.version=$,r["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,k.$h)(k.$t),r["common.nodePlatform"]=F.$7b,r["common.nodeArch"]=R,r["common.product"]=p||"desktop",S&&(r["common.msftInternal"]=S);let s=0;const c=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),k.$l&&(r["common.snap"]="true");const f=A(b);return f&&(r["common.platformDetail"]=f),r}e.$Zn=P;function m(E){const b=F.env.USERDNSDOMAIN;if(!b)return!1;const R=b.toLowerCase();return E.some(I=>R===I)}e.$1n=m}),define(Se[239],Ce([1,0,5]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0,e.$Vk=(0,k.$ph)("telemetryService"),e.$Wk=(0,k.$ph)("customEndpointTelemetryService"),e.$Xk="telemetry.currentSessionDate",e.$Yk="telemetry.firstSessionDate",e.$Zk="telemetry.lastSessionDate",e.$1k="telemetry.machineId",e.$2k="telemetry",e.$3k="telemetry.telemetryLevel",e.$4k="telemetry.enableCrashReporter",e.$5k="telemetry.enableTelemetry";var F;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var h;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(h||(e.TelemetryConfiguration=h={}))}),define(Se[80],Ce([1,0,23,14,3,57,79,238,239]),function(fe,e,k,F,h,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0;class b{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.$2n=b;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$3n=R,e.$4n=new R;class I{async publicLog(a,g,u){}async publicLogError(a,g,u){}}e.$5n=I,e.$6n="telemetry",e.$7n="extensionTelemetryLog",e.$8n={log:()=>null,flush:()=>Promise.resolve(null)};function $(t,a){return h.Event.debounce(a.onDidChangeConfiguration,(u,d)=>{const v=u?new Set([...u.affectedKeys,...d.affectedKeys]):d.affectedKeys;return{...d,affectedKeys:v}},1e3,!0)(u=>{u.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,A.$Yh)(u.source),configurationKeys:Array.from(u.affectedKeys)})})}e.$9n=$;function D(t,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!t.enableTelemetry||a.extensionTestsLocationURI)}e.$0n=D;function S(t,a){return!(a.isBuilt||a.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$$n=S;function p(t){const a=t.getValue(E.$3k),g=t.getValue(E.$4k);if(t.getValue(E.$5k)===!1||g===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$_n=p;function r(t){const a={},g={},u={};f(t,u);for(let d in u){d=d.length>150?d.substr(d.length-149):d;const v=u[d];typeof v=="number"?g[d]=v:typeof v=="boolean"?g[d]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${v.length}`),a[d]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(a[d]=v)}return{properties:a,measurements:g}}e.$ao=r;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const a=(0,P.$Ck)(t);return s.has(a)?a:"other"}e.$bo=c;function f(t,a,g=0,u){if(t)for(const d of Object.getOwnPropertyNames(t)){const v=t[d],l=u?u+d:d;Array.isArray(v)?a[l]=(0,k.$Mm)(v):v instanceof Date?a[l]=v.toISOString():(0,F.$le)(v)?g<2?f(v,a,g+1,l+"."):a[l]=(0,k.$Mm)(v):a[l]=v}}function y(t,a){const g=t.msftInternalDomains||[],u=a.getValue("telemetry.internalTesting");return(0,m.$1n)(g)||u}e.$co=y;function C(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$do=C;function i(t,a){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let g=t;const u=[];for(const w of a)for(;;){const L=w.exec(t);if(!L)break;u.push([L.index,w.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(g="";;){const w=v.exec(t);if(!w)break;const L=u.some(([O,N])=>w.index<N&&O<v.lastIndex);!d.test(w[0])&&!L&&(g+=t.substring(l,w.index)+"<REDACTED: user-file-path>",l=v.lastIndex)}return l<t.length&&(g+=t.substr(l)),g}function o(t){if(!t)return t;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of a)if(g.regex.test(t))return`<REDACTED: ${g.label}>`;return t}function n(t,a){return(0,k.$Jm)(t,g=>{if(g instanceof b||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let u=g.replaceAll("%20"," ");u=i(u,a);for(const d of a)u=u.replace(d,"");return u=o(u),u}})}e.$eo=n}),define(Se[240],Ce([1,0,12,125,25,11,2,8,41,80]),function(fe,e,k,F,h,A,P,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=void 0;function R(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,k.$Hd)(n.id,t.id)===0}e.$fo=R;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(t){const a=t.manifest?t.manifest.version:t.version,g=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new $(t.identifier,a,g)}static parse(t){const a=I.exec(t);return a&&a[1]&&a[2]?new $({id:a[1]},a[2],a[4]||void 0):null}constructor(t,a,g="undefined"){this.version=a,this.targetPlatform=g,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof $?R(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$go=$;const D=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(n){const t=D.exec(n);return t&&t[1]?[r(t[1]),t[2]]:[r(n),void 0]}e.$ho=S;function p(n,t){return`${n}.${t}`}e.$io=p;function r(n){return n.toLowerCase()}e.$jo=r;function s(n,t){return r(p(n??h.$Dl,t))}e.$ko=s;function c(n,t){const a=[],g=u=>{for(const d of a)if(d.some(v=>R(t(v),t(u))))return d;return null};for(const u of n){const d=g(u);d?d.push(u):a.push([u])}return a}e.$lo=c;function f(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$mo=f;function y(n){return{id:new b.$2n(n.identifier.id),name:new b.$2n(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$no=y,e.$oo=new h.$Hl("pprice.better-merge");function C(n,t){const a=[],g=t.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const u=g.shift();if(u&&a.every(d=>!R(d.identifier,{id:u}))){const d=n.filter(v=>R(v.identifier,{id:u}));d.length===1&&(a.push(d[0]),g.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.$po=C;async function i(n,t){if(!A.$k)return!1;let a;try{a=(await n.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await n.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,m.$9)(u))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,t){const a=await i(n,t),g=(0,F.$Kn)(a?"alpine":A.$t,E.$8b);return t.debug("ComputeTargetPlatform:",g),g}e.$qo=o}),define(Se[241],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=e.$2q=e.$1q=e.$Zq=void 0;function k(E){return[...E.entries()]}e.$Zq=k;function F(E){return E?[...E.entries()]:[]}e.$1q=F;function h(E){return new Map(E)}e.$2q=h;function A(E){return new Map(E??[])}e.$3q=A;function P(E){return Array.from(E.entries()).map(b=>[b[0],k(b[1].map),F(b[1].descriptionMap)])}e.$4q=P;function m(E){return new Map(E.map(b=>[b[0],{map:h(b[1]),descriptionMap:A(b[2])}]))}e.$5q=m}),define(Se[242],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjb=void 0;class k{constructor(h){this.b=h,this.a=new Map}dispose(){for(const h of this.a.values())h.dispose()}startBuffering(h,A,P=5){const m=A(E=>{const b=typeof E=="string"?E:E.data;let R=this.a.get(h);if(R){R.data.push(b);return}const I=setTimeout(()=>this.flushBuffer(h),P);R={data:[b],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(h),m.dispose()}},this.a.set(h,R)});return m}stopBuffering(h){this.a.get(h)?.dispose()}flushBuffer(h){const A=this.a.get(h);A&&(this.a.delete(h),this.b(h,A.data.join("")))}}e.$bjb=k}),define(Se[243],Ce([1,0,17,72,55,3,14,2,190,100,42]),function(fe,e,k,F,h,A,P,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zu=e.$Yu=e.$Xu=e.$Wu=e.$Vu=e.$Uu=e.$Tu=e.$Su=e.IconFontDefinition=e.IconContribution=e.$Ru=void 0,e.$Ru={IconContribution:"base.contributions.icons"};var I;(function(y){function C(i,o){let n=i.defaults;for(;h.ThemeIcon.isThemeIcon(n);){const t=S.getIcon(n.id);if(!t)return;n=t.defaults}return n}y.getDefinition=C})(I||(e.IconContribution=I={}));var $;(function(y){function C(o){return{weight:o.weight,style:o.style,src:o.src.map(n=>({format:n.format,location:n.location.toString()}))}}y.toJSONObject=C;function i(o){const n=t=>(0,P.$je)(t)?t:void 0;if(o&&Array.isArray(o.src)&&o.src.every(t=>(0,P.$je)(t.format)&&(0,P.$je)(t.location)))return{weight:n(o.weight),style:n(o.style),src:o.src.map(t=>({format:t.format,location:m.URI.parse(t.location)}))}}y.fromJSONObject=i})($||(e.IconFontDefinition=$={}));class D{constructor(){this.a=new A.$8c,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${h.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(C,i,o,n){const t=this.b[C];if(t){if(o&&!t.description){t.description=o,this.d.properties[C].markdownDescription=`${o} $(${C})`;const u=this.e.enum.indexOf(C);u!==-1&&(this.e.enumDescriptions[u]=o),this.a.fire()}return t}const a={id:C,description:o,defaults:i,deprecationMessage:n};this.b[C]=a;const g={$ref:"#/definitions/icons"};return n&&(g.deprecationMessage=n),o&&(g.markdownDescription=`${o}: $(${C})`),this.d.properties[C]=g,this.e.enum.push(C),this.e.enumDescriptions.push(o||""),this.a.fire(),{id:C}}deregisterIcon(C){delete this.b[C],delete this.d.properties[C];const i=this.e.enum.indexOf(C);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(C=>this.b[C])}getIcon(C){return this.b[C]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(C,i){const o=this.f[C];return o||(this.f[C]=i,this.a.fire(),i)}deregisterIconFont(C){delete this.f[C]}getIconFont(C){return this.f[C]}toString(){const C=(t,a)=>t.id.localeCompare(a.id),i=t=>{for(;h.ThemeIcon.isThemeIcon(t.defaults);)t=this.b[t.defaults.id];return`codicon codicon-${t?t.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(t=>this.b[t]);for(const t of n.filter(a=>!!a.description).sort(C))o.push(`|<i class="${i(t)}"></i>|${t.id}|${h.ThemeIcon.isThemeIcon(t.defaults)?t.defaults.id:t.id}|${t.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const t of n.filter(a=>!h.ThemeIcon.isThemeIcon(a.defaults)).sort(C))o.push(`|<i class="${i(t)}"></i>|${t.id}|`);return o.join(`
`)}}const S=new D;R.$Tm.add(e.$Ru.IconContribution,S);function p(y,C,i,o){return S.registerIcon(y,C,i,o)}e.$Su=p;function r(){return S}e.$Tu=r;function s(){const y=(0,F.$Aj)();for(const C in y){const i="\\"+y[C].toString(16);S.registerIcon(C,{fontCharacter:i})}}s(),e.$Uu="vscode://schemas/icons";const c=R.$Tm.as(b.$Um.JSONContribution);c.registerSchema(e.$Uu,S.getIconSchema());const f=new k.$Gg(()=>c.notifySchemaChanged(e.$Uu),200);S.onDidChange(()=>{f.isScheduled()||f.schedule()}),e.$Vu=p("widget-close",F.$Cj.close,(0,E.localize)(2,null)),e.$Wu=p("goto-previous-location",F.$Cj.arrowUp,(0,E.localize)(3,null)),e.$Xu=p("goto-next-location",F.$Cj.arrowDown,(0,E.localize)(4,null)),e.$Yu=h.ThemeIcon.modify(F.$Cj.sync,"spin"),e.$Zu=h.ThemeIcon.modify(F.$Cj.loading,"spin")}),define(Se[132],Ce([1,0,3,57,5,18]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pz=e.$Oz=e.$Nz=e.$Mz=e.$Lz=e.$Kz=e.$Jz=e.$Iz=e.ProvidedOnAutoForward=e.$Hz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Gz=e.$Fz=void 0,e.$Fz=(0,h.$ph)("tunnelService"),e.$Gz=(0,h.$ph)("sharedTunnelsService");var P;(function(r){r.Http="http",r.Https="https"})(P||(e.TunnelProtocol=P={}));var m;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(m||(e.TunnelPrivacyId=m={}));function E(r){return!!r.forwardPort}e.$Hz=E;var b;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function R(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(s)return{address:s[1],port:+s[2]}}e.$Iz=R,e.$Jz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(r){return e.$Jz.indexOf(r)>=0}e.$Kz=I,e.$Lz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(r){return e.$Lz.indexOf(r)>=0}e.$Mz=$;function D(r,s,c,f){if(c===1)return!1;if(c===2&&$(s)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(y?.length===4&&parseInt(y[1])>=18)return!1}return r<1024}e.$Nz=D;class S{constructor(s,c,f){this.remoteAddress=s,this.localAddress=c,this.b=f,this.a=new k.$8c,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Oz=S;let p=class{constructor(s,c){this.i=s,this.j=c,this.a=new k.$8c,this.onTunnelOpened=this.a.event,this.b=new k.$8c,this.onTunnelClosed=this.b.event,this.c=new k.$8c,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const s=this.j.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.e=s,s?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.f=s.elevation,this.g=s.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const s=[],c=Array.from(this.d.values());for(const f of c){const y=Array.from(f.values());for(const C of y){const i=await C.value;i&&s.push(i)}}return s}async dispose(){for(const s of this.d.values()){for(const{value:c}of s.values())await c.then(f=>f?.dispose());s.clear()}this.d.clear()}setEnvironmentTunnel(s,c,f,y,C){this.o(s,c,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:c,localAddress:f,privacy:y,protocol:C,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,c){($(s)||I(s))&&(s=e.$Jz[0]);const f=this.q(s,c);if(f)return++f.refcount,f.value}openTunnel(s,c,f,y,C,i=!1,o,n){this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${f} on local port ${C}.`);const t=this.e??s;if(!t)return;if(c||(c="localhost"),y||(y=this.k),this.e&&this.h.has(f)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.r(t,c,f,y,C,i,o,n);return a?a.then(g=>{if(!g){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(c,f);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.m(g);return(g.tunnelRemoteHost!==c||g.tunnelRemotePort!==f)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&g.privacy!==o&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(u),u}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}m(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const c=this.d.get(s.tunnelRemoteHost);if(c){const f=c.get(s.tunnelRemotePort);f&&(f.refcount--,await this.n(s.tunnelRemoteHost,s.tunnelRemotePort,f))}}}}async n(s,c,f){if(f.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${c}.`);const y=f.value.then(async C=>{C&&(await C.dispose(!0),this.b.fire({host:C.tunnelRemoteHost,port:C.tunnelRemotePort}))});return this.d.has(s)&&this.d.get(s).delete(c),y}}async closeTunnel(s,c){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${c} `);const f=this.d.get(s);if(f&&f.has(c)){const y=f.get(c);y.refcount=0,await this.n(s,c,y)}}o(s,c,f){this.d.has(s)||this.d.set(s,new Map),this.d.get(s).set(c,{refcount:1,value:f})}async p(s,c){const f=this.d.get(s);if(f){const y=f.get(c);(y?await y.value:void 0)||f.delete(c),f.size===0&&this.d.delete(s)}}q(s,c){const f=[s];I(s)?(f.push(...e.$Jz),f.push(...e.$Lz)):$(s)&&f.push(...e.$Lz);const y=f.map(C=>this.d.get(C));for(const C of y){const i=C?.get(c);if(i)return i}}canTunnel(s){return!!R(s)}s(s,c,f,y,C,i,o){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${f} on local port ${y}.`);const n=f;this.h.add(n);const t=y===void 0?f:y,a={elevationRequired:C?this.isPortPrivileged(t):!1},g={remoteAddress:{host:c,port:f},localAddressPort:y,privacy:i,public:i?i!==m.Private:void 0,protocol:o},u=s.forwardPort(g,a);return u?(this.o(c,f,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(n)})):this.h.delete(n),u}};e.$Pz=p,e.$Pz=p=Je([qe(0,A.$Ri),qe(1,F.$Vh)],p)}),define(Se[244],Ce([1,0,5]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Qz=void 0,e.$Qz=(0,k.$ph)("editSessionIdentityService");var F;(function(h){h[h.Complete=100]="Complete",h[h.Partial=50]="Partial",h[h.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Se[245],Ce([1,0,15]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=void 0;function F(E){return E.scheme!==k.Schemas.file&&E.scheme!==k.Schemas.vscodeRemote}e.$$I=F;function h(E){if(E.folders.length)return E.folders.every(b=>F(b.uri))?E.folders[0].uri:void 0;if(E.configuration&&F(E.configuration))return E.configuration}e.$_I=h;function A(E){return h(E)?.scheme}e.$aJ=A;function P(E){return h(E)?.authority}e.$bJ=P;function m(E){return h(E)!==void 0}e.$cJ=m}),define(Se[50],Ce([1,0,191,13,71,24,2,5,15]),function(fe,e,k,F,h,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.WorkbenchState=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$yh=(0,m.$ph)("contextService");function b(t){const a=t;return typeof a?.id=="string"&&P.URI.isUri(a.uri)}e.$zh=b;function R(t){return typeof t?.id=="string"&&!b(t)&&!$(t)}e.$Ah=R,e.$Bh={id:"ext-dev"},e.$Ch={id:"empty-window"};function I(t,a){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,F.$ec)(t)}:a?e.$Bh:e.$Ch;const g=t;return g.configuration?{id:g.id,configPath:g.configuration}:g.folders.length===1?{id:g.id,uri:g.folders[0].uri}:{id:g.id}}e.$Dh=I;function $(t){const a=t;return typeof a?.id=="string"&&P.URI.isUri(a.configPath)}e.$Eh=$;function D(t){const a=t;if(a?.uri)return{id:a.id,uri:P.URI.revive(a.uri)};const g=t;if(g?.configPath)return{id:g.id,configPath:P.URI.revive(g.configPath)};if(t?.id)return{id:t.id}}e.$Fh=D;var S;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function p(t){const a=t;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.$Gh=p;function r(t){const a=t;return!!(a&&typeof a=="object"&&P.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.$Hh=r;class s{constructor(a,g,u,d,v){this.h=a,this.j=u,this.k=d,this.l=v,this.c=h.$vh.forUris(this.l,()=>!0),this.folders=g}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=h.$vh.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ih=s;class c{constructor(a,g){this.raw=g,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,A.$0f)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Jh=c;function f(t){return new c({uri:t,index:0,name:(0,A.$6f)(t)},{uri:t.toString()})}e.$Kh=f,e.$Lh="code-workspace",e.$Mh=`.${e.$Lh}`,e.$Nh=[{name:(0,k.localize)(0,null),extensions:[e.$Lh]}],e.$Oh="workspace.json";function y(t,a){return A.$1f.isEqualOrParent(t,a.untitledWorkspacesHome)}e.$Ph=y;function C(t){let a;return P.URI.isUri(t)?a=t:a=t.configuration,a?.scheme===E.Schemas.tmp}e.$Qh=C,e.$Rh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.$Rh}e.$Sh=i;function o(t,a){return!y(t,a)&&!C(t)}e.$Th=o;function n(t){return(typeof t=="string"?(0,F.$fc)(t):(0,A.$8f)(t))===e.$Mh}e.$Uh=n}),define(Se[81],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N$b=void 0;class k{static{this.a=!1}constructor(h){this.d=h,this.b=new Map,this.c=1}add(h){const A=this.c++;return this.b.set(A,h),this.e(),A}get(h,A){return this.b.has(h)?this.b.get(h)[A]:void 0}delete(h){this.b.delete(h),this.e()}e(){k.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$N$b=k}),define(Se[51],Ce([1,0,15,24,5]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q$b=e.$P$b=void 0;class A{constructor(){this.a=new Set(Object.keys(k.Schemas)),this.b=new Map,this.extUri=new F.$Yf(m=>{const E=this.b.get(m.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(m,E){E===null?this.b.delete(m.scheme):this.b.set(m.scheme,E)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$P$b=A,e.$Q$b=(0,h.$ph)("IExtHostFileSystemInfo")}),define(Se[26],Ce([1,0,5]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=void 0,e.$TL=(0,k.$ph)("IExtHostInitDataService")}),define(Se[246],Ce([1,0,196,18,230,26]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sac=void 0;let P=class extends h.$1M{constructor(E,b,R){const I=R.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",$=R.remote.isRemote?(0,k.localize)(0,null):E?(0,k.localize)(1,null):(0,k.localize)(2,null);super(b.createLogger(I,{name:$}))}};e.$Sac=P,e.$Sac=P=Je([qe(1,F.$Si),qe(2,A.$TL)],P)}),define(Se[247],Ce([1,0,17]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h_b=e.$g_b=void 0;class F{constructor(P,m,E){this.h=new Map,this.a=P,this.b=m,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(b=>(this.f=b,this)),this.g=this.c.onDidChangeStorage(b=>{b.shared===this.b&&b.key===this.a&&(this.f=b.value)}),this.i=new k.$Gg(()=>{const b=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of b.values())R.complete()}catch(R){for(const I of b.values())I.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this.d}get(P,m){let E=this.f[P];return typeof E>"u"&&(E=m),E}update(P,m){this.f[P]=m;const E=this.h.get(P);if(E!==void 0)return E.p;const b=new k.$Pg;return this.h.set(P,b),this.i.isScheduled()||this.i.schedule(),b.p}dispose(){this.g.dispose()}}e.$g_b=F;class h extends F{setKeysForSync(P){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},P)}constructor(P,m){super(P.identifier.value,!0,m),this.j=P}}e.$h_b=h}),define(Se[248],Ce([1,0,3,2]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fac=void 0;class h{constructor(P){this.c=P,this.a=new k.$8c,this.onDidSaveNotebookDocument=this.a.event,this.b=new k.$8c,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(P,m,E,b){const I=this.c.getNotebookDocument(F.URI.revive(P)).acceptModelChanged(m.value,E,b);this.b.fire(I)}$acceptDirtyStateChanged(P,m){this.c.getNotebookDocument(F.URI.revive(P)).acceptDirty(m)}$acceptModelSaved(P){const m=this.c.getNotebookDocument(F.URI.revive(P));this.a.fire(m.apiNotebook)}}e.$Fac=h}),define(Se[20],Ce([1,0,5]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$DL=void 0,e.$DL=(0,k.$ph)("IExtHostRpcService");class F{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$EL=F}),define(Se[249],Ce([1,0,25,3]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s_b=void 0;class h{#e;constructor(P,m){this.b=new F.$8c,this.onDidChange=this.b.event,this.a=k.$Hl.toKey(P.identifier),this.#e=m,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(P){return this.#e.get(this.a,P)}store(P,m){return this.#e.store(this.a,P,m)}delete(P){return this.#e.delete(this.a,P)}}e.$s_b=h}),define(Se[58],Ce([1,0,5]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2$b=e.$1$b=void 0,e.$1$b=(0,k.$ph)("IURITransformerService");class F{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.$2$b=F}),define(Se[250],Ce([1,0,22]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$00=e.$90=void 0;class F{constructor(){this.buffers=[]}add(E){let b=this.buffers.indexOf(E);return b<0&&(b=this.buffers.length,this.buffers.push(E)),b}}function h(m,E){if(E.serializeBuffersForPostMessage){const b=new F,I=JSON.stringify(m,(D,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:b.add(S)};if(ArrayBuffer.isView(S)){const p=A(S);if(p)return{$$vscode_array_buffer_reference$$:!0,index:b.add(S.buffer),view:{type:p,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),$=b.buffers.map(D=>{const S=new Uint8Array(D);return k.$Jb.wrap(S)});return{message:I,buffers:$}}else return{message:JSON.stringify(m),buffers:[]}}e.$90=h;function A(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(m,E){const b=E.map($=>{const D=new ArrayBuffer($.byteLength);return new Uint8Array(D).set($.buffer),D}),R=E.length?($,D)=>{if(D&&typeof D=="object"&&D.$$vscode_array_buffer_reference$$){const S=D,{index:p}=S,r=b[p];if(S.view)switch(S.view.type){case 1:return new Int8Array(r,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(r,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(r,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(r,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(r,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(r,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(r,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(r,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(r,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(r,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(r,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return r}return D}:void 0;return{message:JSON.parse(m,R),arrayBuffers:b}}e.$00=P}),define(Se[251],Ce([1,0,252,353,354,101,2,355]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$obc=void 0;const E=!1;function b(c,f,y,C,i,o){const n=o.environment.useHostProxy,t=typeof n=="boolean"?n:!o.remote.isRemote,a={resolveProxy:d=>c.resolveProxy(d),lookupProxyAuthorization:p.bind(void 0,C,i,f,{},o.remote.isRemote),getProxyURL:()=>f.getConfiguration("http").get("proxy"),getProxySupport:()=>f.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>I(f),getSystemCertificatesV2:()=>$(f),log:(d,v,...l)=>{switch(d){case m.LogLevel.Trace:C.trace(v,...l);break;case m.LogLevel.Debug:C.debug(v,...l);break;case m.LogLevel.Info:C.info(v,...l);break;case m.LogLevel.Warning:C.warn(v,...l);break;case m.LogLevel.Error:C.error(v,...l);break;case m.LogLevel.Critical:C.error(v,...l);break;case m.LogLevel.Off:break;default:w(d,v,l);break}function w(L,O,...N){C.error("Unknown log level",L),C.error(O,...N)}},getLogLevel:()=>C.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:t,addCertificates:[],env:process.env},g=(0,m.createProxyResolver)(a),u=R(a,g);return S(y,u)}e.$obc=b;function R(c,f){return{http:Object.assign(k,(0,m.createHttpPatch)(c,k,f)),https:Object.assign(F,(0,m.createHttpPatch)(c,F,f)),net:Object.assign(A,(0,m.createNetPatch)(c,A)),tls:Object.assign(h,(0,m.createTlsPatch)(c,h))}}function I(c){const f=c.getConfiguration("http");return!f.get("experimental.systemCertificatesV2",E)&&!!f.get("systemCertificates")}function $(c){const f=c.getConfiguration("http");return!!f.get("experimental.systemCertificatesV2",E)&&!!f.get("systemCertificates")}const D=new Map;function S(c,f){return c.getExtensionPathIndex().then(y=>{const C=globalThis._VSCODE_NODE_MODULES.module,i=C._load;C._load=function(n,t,a){if(n==="net")return f.net;if(n==="tls")return f.tls;if(n!=="http"&&n!=="https")return i.apply(this,arguments);const g=y.findSubstr(P.URI.file(t.filename));let u=D.get(g);if(u||D.set(g,u={}),!u[n]){const d=f[n];u[n]={...d}}return u[n]}})}async function p(c,f,y,C,i,o,n,t){const a=C[o];n&&(C[o]=n),c.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${o}`,`proxyAuthenticate:${n}`,`proxyAuthenticateCache:${a}`);const g=n||a,u=Array.isArray(g)?g:typeof g=="string"?[g]:[];if(s(f,u,i),u.some(d=>/^(Negotiate|Kerberos)( |$)/i.test(d))&&!t.kerberosRequested)try{t.kerberosRequested=!0;const d=await new Promise((O,N)=>{fe(["kerberos"],O,N)}),v=new URL(o),l=y.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${v.hostname}`:`HTTP@${v.hostname}`);return c.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${o}`,`spn:${l}`),"Negotiate "+await(await d.initializeClient(l)).step("")}catch(d){c.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",d)}}let r=!1;function s(c,f,y){r||!f.length||(r=!0,c.$publicLog2("proxyAuthenticationRequest",{authenticationType:f.map(C=>C.split(" ")[0]).join(","),extensionHostType:y?"remote":"local"}))}}),define(Se[253],Ce([1,0,121]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;function F(A){return{transformIncoming:P=>P.scheme==="vscode-remote"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="file"?{scheme:"vscode-local",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoing:P=>P.scheme==="file"?{scheme:"vscode-remote",authority:A,path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="vscode-local"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoingScheme:P=>P==="file"?"vscode-remote":P==="vscode-local"?"file":P}}function h(A){return new k.$nm(F(A))}e.$dr=h}),define(Se[133],Ce([1,0,206,14,2,4,5,42,30,15,45,169,40]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QE=e.$PE=e.$OE=e.EditorsOrder=e.$NE=e.CloseDirection=e.$ME=e.$LE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$KE=e.$JE=e.$IE=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=e.EditorInputCapabilities=e.$CE=e.SaveReason=e.Verbosity=e.$BE=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=void 0,e.$qE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$rE={id:"default",displayName:(0,k.localize)(0,null),providerDisplayName:(0,k.localize)(1,null)},e.$sE="workbench.editor.sidebysideEditor",e.$tE="workbench.editors.textDiffEditor",e.$uE="workbench.editors.binaryResourceDiffEditor";var D;(function(H){H[H.PROGRAMMATIC=1]="PROGRAMMATIC",H[H.USER=2]="USER",H[H.EDIT=3]="EDIT",H[H.NAVIGATION=4]="NAVIGATION",H[H.JUMP=5]="JUMP"})(D||(e.EditorPaneSelectionChangeReason=D={}));var S;(function(H){H[H.IDENTICAL=1]="IDENTICAL",H[H.SIMILAR=2]="SIMILAR",H[H.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function p(H){const ue=H;return!!ue&&typeof ue.getSelection=="function"&&!!ue.onDidChangeSelection}e.$vE=p;function r(H,ue,ce){for(const z of ce.visibleEditorPanes)if(z.group.id===ue&&H.matches(z.input))return z.getViewState()}e.$wE=r;function s(H){if(g(H))return!1;const ue=H;return h.URI.isUri(ue?.resource)}e.$xE=s;function c(H){if(g(H))return!1;const ue=H;return ue?.original!==void 0&&ue.modified!==void 0}e.$yE=c;function f(H){if(g(H)||c(H))return!1;const ue=H;return ue?.primary!==void 0&&ue.secondary!==void 0}e.$zE=f;function y(H){if(g(H))return!1;const ue=H;return ue?ue.resource===void 0||ue.resource.scheme===b.Schemas.untitled||ue.forceUntitled===!0:!1}e.$AE=y;function C(H){if(g(H))return!1;const ue=H;return h.URI.isUri(ue?.base?.resource)&&h.URI.isUri(ue?.input1?.resource)&&h.URI.isUri(ue?.input2?.resource)&&h.URI.isUri(ue?.result?.resource)}e.$BE=C;var i;(function(H){H[H.SHORT=0]="SHORT",H[H.MEDIUM=1]="MEDIUM",H[H.LONG=2]="LONG"})(i||(e.Verbosity=i={}));var o;(function(H){H[H.EXPLICIT=1]="EXPLICIT",H[H.AUTO=2]="AUTO",H[H.FOCUS_CHANGE=3]="FOCUS_CHANGE",H[H.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o||(e.SaveReason=o={}));class n{constructor(){this.a=new Map}registerSource(ue,ce){let z=this.a.get(ue);return z||(z={source:ue,label:ce},this.a.set(ue,z)),z.source}getSourceLabel(ue){return this.a.get(ue)?.label??ue}}e.$CE=new n;var t;(function(H){H[H.None=0]="None",H[H.Readonly=2]="Readonly",H[H.Untitled=4]="Untitled",H[H.Singleton=8]="Singleton",H[H.RequiresTrust=16]="RequiresTrust",H[H.CanSplitInGroup=32]="CanSplitInGroup",H[H.ForceDescription=64]="ForceDescription",H[H.CanDropIntoEditor=128]="CanDropIntoEditor",H[H.MultipleEditors=256]="MultipleEditors",H[H.Scratchpad=512]="Scratchpad"})(t||(e.EditorInputCapabilities=t={}));class a extends A.$lb{}e.$DE=a;function g(H){return H instanceof a}e.$EE=g;function u(H){const ue=H;return h.URI.isUri(ue?.preferredResource)}function d(H){const ue=H;return g(ue?.primary)&&g(ue?.secondary)}e.$FE=d;function v(H){const ue=H;return g(ue?.modified)&&g(ue?.original)}e.$GE=v;function l(H,ue,ce,z,ie){return pe(z,[(0,I.$_h)({id:"workbench.action.openLargeFile",label:(0,k.localize)(2,null),run:()=>{const Ee={...ce,limits:{size:Number.MAX_VALUE}};H.openEditor(ue,Ee)}}),(0,I.$_h)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,k.localize)(3,null),run:()=>ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}e.$HE=l;function w(H){return g(H?.editor)}e.$IE=w;function L(H){const ue=H;return w(H)&&ue?.group!==void 0}e.$JE=L;function O(H){const ue=H;return typeof ue?.groupId=="number"&&g(ue.editor)}e.$KE=O;var N;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.REPLACE=1]="REPLACE",H[H.MOVE=2]="MOVE",H[H.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var T;(function(H){H[H.GROUP_ACTIVE=0]="GROUP_ACTIVE",H[H.GROUP_INDEX=1]="GROUP_INDEX",H[H.GROUP_LOCKED=2]="GROUP_LOCKED",H[H.EDITOR_OPEN=3]="EDITOR_OPEN",H[H.EDITOR_CLOSE=4]="EDITOR_CLOSE",H[H.EDITOR_MOVE=5]="EDITOR_MOVE",H[H.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",H[H.EDITOR_LABEL=7]="EDITOR_LABEL",H[H.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",H[H.EDITOR_PIN=9]="EDITOR_PIN",H[H.EDITOR_STICKY=10]="EDITOR_STICKY",H[H.EDITOR_DIRTY=11]="EDITOR_DIRTY",H[H.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(T||(e.GroupModelChangeKind=T={}));var j;(function(H){H[H.PRIMARY=1]="PRIMARY",H[H.SECONDARY=2]="SECONDARY",H[H.BOTH=3]="BOTH",H[H.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class W{getOriginalUri(ue,ce){if(!ue)return;if(C(ue))return e.$ME.getOriginalUri(ue.result,ce);if(ce?.supportSideBySide){const{primary:ie,secondary:Ee}=this.a(ue);if(ie&&Ee){if(ce?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(ie,{filterByScheme:ce.filterByScheme}),secondary:this.getOriginalUri(Ee,{filterByScheme:ce.filterByScheme})};if(ce?.supportSideBySide===j.ANY)return this.getOriginalUri(ie,{filterByScheme:ce.filterByScheme})??this.getOriginalUri(Ee,{filterByScheme:ce.filterByScheme});ue=ce.supportSideBySide===j.PRIMARY?ie:Ee}}if(c(ue)||f(ue)||C(ue))return;const z=u(ue)?ue.preferredResource:ue.resource;return!z||!ce||!ce.filterByScheme?z:this.b(z,ce.filterByScheme)}a(ue){return d(ue)||f(ue)?{primary:ue.primary,secondary:ue.secondary}:v(ue)||c(ue)?{primary:ue.modified,secondary:ue.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ue,ce){if(!ue)return;if(C(ue))return e.$ME.getCanonicalUri(ue.result,ce);if(ce?.supportSideBySide){const{primary:ie,secondary:Ee}=this.a(ue);if(ie&&Ee){if(ce?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(ie,{filterByScheme:ce.filterByScheme}),secondary:this.getCanonicalUri(Ee,{filterByScheme:ce.filterByScheme})};if(ce?.supportSideBySide===j.ANY)return this.getCanonicalUri(ie,{filterByScheme:ce.filterByScheme})??this.getCanonicalUri(Ee,{filterByScheme:ce.filterByScheme});ue=ce.supportSideBySide===j.PRIMARY?ie:Ee}}if(c(ue)||f(ue)||C(ue))return;const z=ue.resource;return!z||!ce||!ce.filterByScheme?z:this.b(z,ce.filterByScheme)}b(ue,ce){if(Array.isArray(ce)){if(ce.some(z=>ue.scheme===z))return ue}else if(ce===ue.scheme)return ue}}var M;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.KEYBOARD=1]="KEYBOARD",H[H.MOUSE=2]="MOUSE"})(M||(e.EditorCloseMethod=M={}));function Y(H,ue,ce,z){if(!H.isSticky(ue))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return ce===M.MOUSE||ce===M.KEYBOARD;case"mouse":return ce===M.MOUSE;case"keyboard":return ce===M.KEYBOARD}return!1}e.$LE=Y,e.$ME=new W;var V;(function(H){H[H.LEFT=0]="LEFT",H[H.RIGHT=1]="RIGHT"})(V||(e.CloseDirection=V={}));class de{constructor(){this.c=new Map,this.d=new Map}start(ue){const ce=this.a=ue.get(P.$oh);for(const[z,ie]of this.c)this.e(z,ie,ce);this.c.clear()}e(ue,ce,z){const ie=z.createInstance(ce);this.d.set(ue,ie)}registerFileEditorFactory(ue){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ue}getFileEditorFactory(){return(0,F.$ue)(this.b)}registerEditorSerializer(ue,ce){if(this.c.has(ue)||this.d.has(ue))throw new Error(`A editor serializer with type ID '${ue}' was already registered.`);return this.a?this.e(ue,ce,this.a):this.c.set(ue,ce),(0,A.$jb)(()=>{this.c.delete(ue),this.d.delete(ue)})}getEditorSerializer(ue){return this.d.get(typeof ue=="string"?ue:ue.typeId)}}m.$Tm.add(e.$qE.EditorFactory,new de);async function re(H,ue,ce){return!H||!H.length?[]:await Promise.all(H.map(async z=>{const ie=h.URI.revive(z.fileUri);if(!ie){ce.info("Cannot resolve the path because it is not valid.",z);return}if(!await ue.canHandleResource(ie)){ce.info("Cannot resolve the path because it cannot be handled",z);return}let Re=z.exists,ye=z.type;if(typeof Re!="boolean"||typeof ye!="number")try{ye=(await ue.stat(ie)).isDirectory?E.FileType.Directory:E.FileType.Unknown,Re=!0}catch(he){ce.error(he),Re=!1}if(!Re&&z.openOnlyIfExists){ce.info("Cannot resolve the path because it does not exist",z);return}if(ye===E.FileType.Directory){ce.info("Cannot resolve the path because it is a directory",z);return}const X={...z.options,pinned:!0};return Re?{resource:ie,options:X}:{resource:ie,options:X,forceUntitled:!0}}))}e.$NE=re;var x;(function(H){H[H.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",H[H.SEQUENTIAL=1]="SEQUENTIAL"})(x||(e.EditorsOrder=x={}));function q(H){const ue=H;if(!ue)return!1;const ce=ue;if(ce.modified)return q(ce.modified);const z=ue;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$OE=q;function ne(H){return(0,R.$bi)(H)}e.$PE=ne;function pe(H,ue,ce){const z=(0,R.$ci)(H,ue);return z.forceMessage=ce?.forceMessage,z.forceSeverity=ce?.forceSeverity,z.allowDialog=ce?.allowDialog,z}e.$QE=pe}),define(Se[254],Ce([1,0,3,207,5,4,28,42,19,65,23,72,243]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XE=e.$WE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$VE=e.$UE=e.ViewContentGroups=e.$TE=e.$SE=e.ViewContainerLocation=e.Extensions=e.$RE=void 0,e.$RE=(0,$.$Su)("default-view-icon",I.$Cj.window,(0,F.localize)(0,null));var D;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(D||(e.Extensions=D={}));var S;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(S||(e.ViewContainerLocation=S={})),e.$SE=[0,1,2];function p(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$TE=p;class r extends A.$lb{constructor(){super(...arguments),this.c=this.B(new k.$8c),this.onDidRegister=this.c.event,this.f=this.B(new k.$8c),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$yf)([...this.g.values()])}registerViewContainer(t,a,g){const u=this.get(t.id);if(u)return u;const d=t;return d.openCommandActionDescriptor=g?.doNotRegisterOpenCommand?void 0:d.openCommandActionDescriptor??{id:d.id},(0,P.$ki)(this.g,a,[]).push(d),g?.isDefault&&this.h.push(d),this.c.fire({viewContainer:d,viewContainerLocation:a}),d}deregisterViewContainer(t){for(const a of this.g.keys()){const g=this.g.get(a),u=g?.indexOf(t);if(u!==-1){g?.splice(u,1),g.length===0&&this.g.delete(a),this.f.fire({viewContainer:t,viewContainerLocation:a});return}}}get(t){return this.all.filter(a=>a.id===t)[0]}getViewContainers(t){return[...this.g.get(t)||[]]}getViewContainerLocation(t){return[...this.g.keys()].filter(a=>this.getViewContainers(a).filter(g=>g?.id===t.id).length>0)[0]}getDefaultViewContainer(t){return this.h.find(a=>this.getViewContainerLocation(a)===t)}}m.$Tm.add(D.ViewContainersRegistry,new r);var s;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(s||(e.ViewContentGroups=s={}));function c(n,t){const a=n.group??s.More,g=t.group??s.More;return a!==g?a.localeCompare(g):(n.order??5)-(t.order??5)}class f extends A.$lb{constructor(){super(...arguments),this.c=this.B(new k.$8c),this.onViewsRegistered=this.c.event,this.f=this.B(new k.$8c),this.onViewsDeregistered=this.f.event,this.g=this.B(new k.$8c),this.onDidChangeContainer=this.g.event,this.h=this.B(new k.$8c),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new b.$L}registerViews(t,a){this.registerViews2([{views:t,viewContainer:a}])}registerViews2(t){t.forEach(({views:a,viewContainer:g})=>this.l(a,g)),this.c.fire(t)}deregisterViews(t,a){const g=this.m(t,a);g.length&&this.f.fire({views:g,viewContainer:a})}moveViews(t,a){for(const g of this.j.keys())if(g!==a){const u=this.m(t,g);u.length&&(this.l(u,a),this.g.fire({views:u,from:g,to:a}))}}getViews(t){return this.j.get(t)||[]}getView(t){for(const a of this.i){const g=(this.j.get(a)||[]).filter(u=>u.id===t)[0];if(g)return g}return null}getViewContainer(t){for(const a of this.i)if((this.j.get(a)||[]).filter(u=>u.id===t)[0])return a;return null}registerViewWelcomeContent(t,a){return this.k.add(t,a),this.h.fire(t),(0,A.$jb)(()=>{this.k.delete(t,a),this.h.fire(t)})}registerViewWelcomeContent2(t,a){const g=new Map;for(const[u,d]of a)this.k.add(t,d),g.set(u,(0,A.$jb)(()=>{this.k.delete(t,d),this.h.fire(t)}));return this.h.fire(t),g}getViewWelcomeContent(t){const a=[];return this.k.forEach(t,g=>a.push(g)),a.sort(c)}l(t,a){let g=this.j.get(a);g||(g=[],this.j.set(a,g),this.i.push(a));for(const u of t){if(this.getView(u.id)!==null)throw new Error((0,F.localize)(1,null,u.id));g.push(u)}}m(t,a){const g=this.j.get(a);if(!g)return[];const u=[],d=[];for(const v of g)t.includes(v)?u.push(v):d.push(v);return u.length&&(d.length?this.j.set(a,d):(this.j.delete(a),this.i.splice(this.i.indexOf(a),1))),u}}m.$Tm.add(D.ViewsRegistry,new f),e.$UE=(0,h.$ph)("viewsService"),e.$VE=(0,h.$ph)("viewDescriptorService");var y;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(y||(e.ViewVisibilityState=y={}));var C;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(C||(e.TreeItemCollapsibleState=C={}));class i{constructor(t,a){this.c=!1,this.d=!1,(0,R.$Km)(this,t),this.d=!!a,this.resolve=async g=>{if(a&&!this.c){const u=await a(g);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}g.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$WE=i;class o extends Error{constructor(t){super((0,F.localize)(2,null,t)),this.name="NoTreeViewError"}static is(t){return t.name==="NoTreeViewError"}}e.$XE=o}),define(Se[134],Ce([1,0,3,17,208]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C$=void 0;class A{constructor(){this.f=new Map,this.k=[],this.m=new k.$8c,this.n=new k.$8c,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,E,b,R){const I={command:m};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.s("request",I),typeof R=="number"){const $=setTimeout(()=>{clearTimeout($);const D=this.f.get(I.seq);if(D){this.f.delete(I.seq);const S={type:"response",seq:0,request_seq:I.seq,success:!1,command:m,message:(0,h.localize)(0,null,R,m)};D(S)}},R)}return b&&this.f.set(I.seq,b),I.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,E){return m.type!=="event"||E.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,F.$wg)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const E=m,b=this.f.get(E.request_seq);b&&(this.f.delete(E.request_seq),b(E));break}}}}s(m,E){E.type=m,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((E,b)=>m.set(b,E)),await(0,F.$wg)(500),m.forEach((E,b)=>{E({type:"response",seq:0,request_seq:b,success:!1,command:"canceled",message:"canceled"}),this.f.delete(b)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$C$=A}),define(Se[255],Ce([1,0,209,47,5]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$9G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$8G=e.MemoryRangeType=e.$7G=e.State=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=void 0,e.$5F="workbench.view.debug",e.$6F="workbench.debug.variablesView",e.$7F="workbench.debug.watchExpressionsView",e.$8F="workbench.debug.callStackView",e.$9F="workbench.debug.loadedScriptsView",e.$0F="workbench.debug.breakPointsView",e.$$F="workbench.debug.disassemblyView",e.$_F="workbench.panel.repl",e.$aG="workbench.panel.repl.view",e.$bG=new F.$Oi("debugType",void 0,{type:"string",description:k.localize(0,null)}),e.$cG=new F.$Oi("debugConfigurationType",void 0,{type:"string",description:k.localize(1,null)}),e.$dG=new F.$Oi("debugState","inactive",{type:"string",description:k.localize(2,null)}),e.$eG="debugUx",e.$fG=new F.$Oi(e.$eG,"default",{type:"string",description:k.localize(3,null)}),e.$gG=new F.$Oi("hasDebugged",!1,{type:"boolean",description:k.localize(4,null)}),e.$hG=new F.$Oi("inDebugMode",!1,{type:"boolean",description:k.localize(5,null)}),e.$iG=new F.$Oi("inDebugRepl",!1,{type:"boolean",description:k.localize(6,null)}),e.$jG=new F.$Oi("breakpointWidgetVisible",!1,{type:"boolean",description:k.localize(7,null)}),e.$kG=new F.$Oi("inBreakpointWidget",!1,{type:"boolean",description:k.localize(8,null)}),e.$lG=new F.$Oi("breakpointsFocused",!0,{type:"boolean",description:k.localize(9,null)}),e.$mG=new F.$Oi("watchExpressionsFocused",!0,{type:"boolean",description:k.localize(10,null)}),e.$nG=new F.$Oi("watchExpressionsExist",!1,{type:"boolean",description:k.localize(11,null)}),e.$oG=new F.$Oi("variablesFocused",!0,{type:"boolean",description:k.localize(12,null)}),e.$pG=new F.$Oi("expressionSelected",!1,{type:"boolean",description:k.localize(13,null)}),e.$qG=new F.$Oi("breakpointInputFocused",!1,{type:"boolean",description:k.localize(14,null)}),e.$rG=new F.$Oi("callStackItemType",void 0,{type:"string",description:k.localize(15,null)}),e.$sG=new F.$Oi("callStackSessionIsAttach",!1,{type:"boolean",description:k.localize(16,null)}),e.$tG=new F.$Oi("callStackItemStopped",!1,{type:"boolean",description:k.localize(17,null)}),e.$uG=new F.$Oi("callStackSessionHasOneThread",!1,{type:"boolean",description:k.localize(18,null)}),e.$vG=new F.$Oi("watchItemType",void 0,{type:"string",description:k.localize(19,null)}),e.$wG=new F.$Oi("canViewMemory",void 0,{type:"boolean",description:k.localize(20,null)}),e.$xG=new F.$Oi("breakpointItemType",void 0,{type:"string",description:k.localize(21,null)}),e.$yG=new F.$Oi("breakpointSupportsCondition",!1,{type:"boolean",description:k.localize(22,null)}),e.$zG=new F.$Oi("loadedScriptsSupported",!1,{type:"boolean",description:k.localize(23,null)}),e.$AG=new F.$Oi("loadedScriptsItemType",void 0,{type:"string",description:k.localize(24,null)}),e.$BG=new F.$Oi("focusedSessionIsAttach",!1,{type:"boolean",description:k.localize(25,null)}),e.$CG=new F.$Oi("stepBackSupported",!1,{type:"boolean",description:k.localize(26,null)}),e.$DG=new F.$Oi("restartFrameSupported",!1,{type:"boolean",description:k.localize(27,null)}),e.$EG=new F.$Oi("stackFrameSupportsRestart",!1,{type:"boolean",description:k.localize(28,null)}),e.$FG=new F.$Oi("jumpToCursorSupported",!1,{type:"boolean",description:k.localize(29,null)}),e.$GG=new F.$Oi("stepIntoTargetsSupported",!1,{type:"boolean",description:k.localize(30,null)}),e.$HG=new F.$Oi("breakpointsExist",!1,{type:"boolean",description:k.localize(31,null)}),e.$IG=new F.$Oi("debuggersAvailable",!1,{type:"boolean",description:k.localize(32,null)}),e.$JG=new F.$Oi("debugExtensionAvailable",!0,{type:"boolean",description:k.localize(33,null)}),e.$KG=new F.$Oi("debugProtocolVariableMenuContext",void 0,{type:"string",description:k.localize(34,null)}),e.$LG=new F.$Oi("debugSetVariableSupported",!1,{type:"boolean",description:k.localize(35,null)}),e.$MG=new F.$Oi("debugSetExpressionSupported",!1,{type:"boolean",description:k.localize(36,null)}),e.$NG=new F.$Oi("breakWhenValueChangesSupported",!1,{type:"boolean",description:k.localize(37,null)}),e.$OG=new F.$Oi("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:k.localize(38,null)}),e.$PG=new F.$Oi("breakWhenValueIsReadSupported",!1,{type:"boolean",description:k.localize(39,null)}),e.$QG=new F.$Oi("terminateDebuggeeSupported",!1,{type:"boolean",description:k.localize(40,null)}),e.$RG=new F.$Oi("suspendDebuggeeSupported",!1,{type:"boolean",description:k.localize(41,null)}),e.$SG=new F.$Oi("variableEvaluateNamePresent",!1,{type:"boolean",description:k.localize(42,null)}),e.$TG=new F.$Oi("variableIsReadonly",!1,{type:"boolean",description:k.localize(43,null)}),e.$UG=new F.$Oi("exceptionWidgetVisible",!1,{type:"boolean",description:k.localize(44,null)}),e.$VG=new F.$Oi("multiSessionRepl",!1,{type:"boolean",description:k.localize(45,null)}),e.$WG=new F.$Oi("multiSessionDebug",!1,{type:"boolean",description:k.localize(46,null)}),e.$XG=new F.$Oi("disassembleRequestSupported",!1,{type:"boolean",description:k.localize(47,null)}),e.$YG=new F.$Oi("disassemblyViewFocus",!1,{type:"boolean",description:k.localize(48,null)}),e.$ZG=new F.$Oi("languageSupportsDisassembleRequest",!1,{type:"boolean",description:k.localize(49,null)}),e.$1G=new F.$Oi("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:k.localize(50,null)});const A=$=>k.localize(51,null,$);e.$2G=A,e.$3G="editor.contrib.debug",e.$4G="editor.contrib.breakpoint",e.$5G="debug",e.$6G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:k.localize(52,null)};var P;(function($){$[$.Inactive=0]="Inactive",$[$.Initializing=1]="Initializing",$[$.Stopped=2]="Stopped",$[$.Running=3]="Running"})(P||(e.State=P={}));function m($){switch($){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$7G=m;var E;(function($){$[$.Valid=0]="Valid",$[$.Unreadable=1]="Unreadable",$[$.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$8G="vscode-debug-memory";var b;(function($){$[$.Initial=1]="Initial",$[$.Dynamic=2]="Dynamic"})(b||(e.DebugConfigurationProviderTriggerKind=b={}));var R;(function($){$.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$9G=(0,h.$ph)("debugService");var I;(function($){$[$.CONDITION=0]="CONDITION",$[$.HIT_COUNT=1]="HIT_COUNT",$[$.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(Se[256],Ce([1,0,12,2,13,23,15,33,21,19]),function(fe,e,k,F,h,A,P,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.$5E=void 0;const R=/{([^}]+)}/g;function I(u,d,v){return u.replace(R,function(l,w){return d&&w.length>0&&w[0]!=="_"?l:v&&v.hasOwnProperty(w)?v[w]:l})}e.$5E=I;function $(u){const d={};for(const v of Object.keys(u))v.startsWith("!")||(d[v]=u[v]);return d}e.$6E=$;function D(u){return u.configuration.request==="attach"&&!S(u)&&(!u.parentSession||D(u.parentSession))}e.$7E=D;function S(u){let d=u.configuration.type;if(d)return d==="vslsShare"&&(d=u.configuration.adapterProxy.configuration.type),(0,k.$Md)(d,"extensionhost")||(0,k.$Md)(d,"pwa-extensionhost")?u:u.parentSession?S(u.parentSession):void 0}e.$8E=S;function p(u){return u.type&&(u.label||u.program||u.runtime)}e.$9E=p;function r(u,d,v){let l,w=0;const L=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=L.exec(u);){const N=O.index+1,T=N+O[0].length;if(N<=d&&T>=v){l=O[0],w=N;break}}if(l){const N=/\w+/g;let T=null;for(;(T=N.exec(l))&&!(T.index+1+w+T[0].length>=v););T&&(l=l.substring(0,N.lastIndex))}return l?{start:w,end:w+l.length-1}:{start:0,end:0}}e.$0E=r;async function s(u,d,v,l){if(u.evaluatableExpressionProvider.has(d)){const w=u.evaluatableExpressionProvider.ordered(d),L=(0,b.$mf)(await Promise.all(w.map(async O=>{try{return await O.provideEvaluatableExpression(d,v,l??E.CancellationToken.None)}catch{return}})));if(L.length>0){let O=L[0].expression;const N=L[0].range;return O||(O=d.getLineContent(v.lineNumber).substring(N.startColumn-1,N.endColumn-1)),{range:N,matchingExpression:O}}}else{const w=d.getLineContent(v.lineNumber),{start:L,end:O}=r(w,v.column,v.column),N=w.substring(L-1,O);return{matchingExpression:N,range:new m.$Or(v.lineNumber,L,v.lineNumber,L+N.length)}}return null}e.$$E=s;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function f(u){return!!(u&&u.match(c))}e.$_E=f;function y(u){if(typeof u.path=="string"&&!(typeof u.sourceReference=="number"&&u.sourceReference>0)){if(f(u.path))return F.URI.parse(u.path);if((0,h.$_b)(u.path))return F.URI.file(u.path)}return u.path}function C(u){if(typeof u.path=="object"){const d=F.URI.revive(u.path);if(d)return d.scheme===P.Schemas.file?d.fsPath:d.toString()}return u.path}function i(u,d){const v=d?y:C,l=(0,A.$Hm)(u);return n(l,(w,L)=>{w&&L&&(L.path=v(L))}),l}e.$aF=i;function o(u,d){const v=d?y:C,l=(0,A.$Hm)(u);return n(l,(w,L)=>{!w&&L&&(L.path=v(L))}),l}e.$bF=o;function n(u,d){switch(u.type){case"event":{const v=u;switch(v.event){case"output":d(!1,v.body.source);break;case"loadedSource":d(!1,v.body.source);break;case"breakpoint":d(!1,v.body.breakpoint.source);break;default:break}break}case"request":{const v=u;switch(v.command){case"setBreakpoints":d(!0,v.arguments.source);break;case"breakpointLocations":d(!0,v.arguments.source);break;case"source":d(!0,v.arguments.source);break;case"gotoTargets":d(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(l=>d(!1,l));break;default:break}break}case"response":{const v=u;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(l=>d(!1,l.source));break;case"loadedSources":v.body.sources.forEach(l=>d(!1,l));break;case"scopes":v.body.scopes.forEach(l=>d(!1,l.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(l=>d(!1,l.source));break;case"setBreakpoints":v.body.breakpoints.forEach(l=>d(!1,l.source));break;case"disassemble":v.body?.instructions.forEach(w=>d(!1,w.location));break;default:break}break}}}function t(u){return u.filter(d=>!d.presentation?.hidden).sort((d,v)=>d.presentation?v.presentation?d.presentation.group?v.presentation.group?d.presentation.group!==v.presentation.group?d.presentation.group.localeCompare(v.presentation.group):a(d.presentation.order,v.presentation.order):-1:v.presentation.group?1:a(d.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.$cF=t;function a(u,d){return typeof u!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:u-d}async function g(u,d){const v=u.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(v!=="none"&&(await d.saveAll(),v==="allEditorsInActiveGroup")){const l=d.activeEditorPane;l&&l.input.resource?.scheme===P.Schemas.untitled&&await d.save({editor:l.input,groupId:l.group.id})}await u.reloadConfiguration()}e.$dF=g}),define(Se[257],Ce([1,0,46,101,23,13,11,12,29,210,134]),function(fe,e,k,F,h,A,P,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=e.$2ac=e.$1ac=e.$Zac=e.$Yac=void 0;class I extends R.$C${static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(s,c){this.p=c,this.r=Buffer.allocUnsafe(0),this.t=-1,s.on("data",f=>this.w(f))}sendMessage(s){if(this.p){const c=JSON.stringify(s);this.p.write(`Content-Length: ${Buffer.byteLength(c,"utf8")}${I.a}${c}`,"utf8")}}w(s){for(this.r=Buffer.concat([this.r,s]);;){if(this.t>=0){if(this.r.length>=this.t){const c=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,c.length>0)try{this.acceptMessage(JSON.parse(c))}catch(f){this.m.fire(new Error((f.message||f)+`
`+c))}continue}}else{const c=this.r.indexOf(I.a);if(c!==-1){const y=this.r.toString("utf8",0,c).split(I.b);for(const C of y){const i=C.split(I.l);i[0]==="Content-Length"&&(this.t=Number(i[1]))}this.r=this.r.slice(c+I.a.length);continue}}break}}}e.$Yac=I;class $ extends I{startSession(){return new Promise((s,c)=>{let f=!1;this.x=this.y(()=>{this.v(this.x,this.x),s(),f=!0}),this.x.on("close",()=>{f?this.m.fire(new Error("connection closed")):c(new Error("connection closed"))}),this.x.on("error",y=>{f?this.m.fire(y):c(y)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Zac=$;class D extends ${constructor(s){super(),this.z=s}y(s){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$1ac=D;class S extends ${constructor(s){super(),this.z=s}y(s){return F.createConnection(this.z.path,s)}}e.$2ac=S;class p extends I{constructor(s,c){super(),this.y=s,this.z=c}async startSession(){const s=this.y.command,c=this.y.args,f=this.y.options||{};try{if(s)if(A.$_b(s)){if(!await E.Promises.exists(s))throw new Error(b.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(b.localize(1,null,this.z));let y=process.env;if(f.env&&Object.keys(f.env).length>0&&(y=h.$Km(h.$Hm(process.env),f.env)),s==="node")if(Array.isArray(c)&&c.length>0){const C=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:y,execArgv:C?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};f.cwd&&(i.cwd=f.cwd);const o=k.fork(c[0],c.slice(1),i);if(!o.pid)throw new Error(b.localize(2,null,c[0]));this.x=o}else throw new Error(b.localize(3,null));else{const C={env:y};f.cwd&&(C.cwd=f.cwd),this.x=k.spawn(s,c,C)}this.x.on("error",C=>{this.m.fire(C)}),this.x.on("exit",(C,i)=>{this.n.fire(C)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",C=>{this.m.fire(C)}),this.x.stdin.on("error",C=>{this.m.fire(C)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(y){this.m.fire(y)}}async stopSession(){return this.x?(await this.u(),P.$i?new Promise((s,c)=>{const f=k.exec(`taskkill /F /T /PID ${this.x.pid}`,function(y,C,i){if(y)return c(y)});f.on("exit",s),f.on("error",c)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,c){if(!s)return;const f=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?f.runtime=A.$ac(c,s.runtime):f.runtime=s.runtime),s.runtimeArgs&&(f.runtimeArgs=s.runtimeArgs),s.program&&(A.$_b(s.program)?f.program=s.program:f.program=A.$ac(c,s.program)),s.args&&(f.args=s.args);const y=s;return y.win&&(f.win=p.A(y.win,c)),y.winx86&&(f.winx86=p.A(y.winx86,c)),y.windows&&(f.windows=p.A(y.windows,c)),y.osx&&(f.osx=p.A(y.osx,c)),y.linux&&(f.linux=p.A(y.linux,c)),f}static platformAdapterExecutable(s,c){let f=Object.create(null);c=c.toLowerCase();for(const t of s)if(t.contributes){const a=t.contributes.debuggers;a&&a.length>0&&a.filter(g=>typeof g.type=="string"&&m.$Md(g.type,c)).forEach(g=>{const u=p.A(g,t.extensionLocation.fsPath);f=h.$Km(f,u,t.isBuiltin)})}let y;P.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?y=f.winx86||f.win||f.windows:P.$i?y=f.win||f.windows:P.$j?y=f.osx:P.$k&&(y=f.linux),y=y||f;const C=y.program||f.program,i=y.args||f.args,o=y.runtime||f.runtime,n=y.runtimeArgs||f.runtimeArgs;if(o)return{type:"executable",command:o,args:(n||[]).concat(typeof C=="string"?[C]:[]).concat(i||[])};if(C)return{type:"executable",command:C,args:i||[]}}}e.$3ac=p}),define(Se[258],Ce([1,0,46,31,11]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=e.$4ac=void 0;function A(b,R){return new Promise((I,$)=>{let D="";const S=k.spawn(b,R);S.pid&&S.stdout.on("data",p=>{D+=p.toString()}),S.on("error",p=>{$(p)}),S.on("close",p=>{I(D)})})}async function P(b){if(b)if(h.$i){const R=await new Promise((I,$)=>{fe(["@vscode/windows-process-tree"],I,$)});return new Promise(I=>{R.getProcessTree(b,$=>{I(!!$&&$.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(b)]).then(R=>{const I=R.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$4ac=P;var m;(function(b){b[b.cmd=0]="cmd",b[b.powershell=1]="powershell",b[b.bash=2]="bash"})(m||(m={}));function E(b,R,I,$,D){b=b.trim().toLowerCase();let S;b.indexOf("powershell")>=0||b.indexOf("pwsh")>=0?S=1:b.indexOf("cmd.exe")>=0?S=0:b.indexOf("bash")>=0?S=2:h.$i?S=0:S=2;let p,r=" ";switch(S){case 1:if(p=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),$){const s=(0,F.$Pe)($);s&&(r+=`${s}:; `),r+=`cd ${p($)}; `}if(D)for(const s in D){const c=D[s];c===null?r+=`Remove-Item env:${s}; `:r+=`\${env:${s}}='${c}'; `}if(R.length>0){const s=R.shift(),c=I?s:p(s);r+=c[0]==="'"?`& ${c} `:`${c} `;for(const f of R)r+=f==="<"||f===">"||I?f:p(f),r+=" "}break;case 0:if(p=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(c=>s.includes(c))||s.length===0?`"${s}"`:s),$){const s=(0,F.$Pe)($);s&&(r+=`${s}: && `),r+=`cd ${p($)} && `}if(D){r+='cmd /C "';for(const s in D){let c=D[s];c===null?r+=`set "${s}=" && `:(c=c.replace(/[&^|<>]/g,f=>`^${f}`),r+=`set "${s}=${c}" && `)}}for(const s of R)r+=s==="<"||s===">"||I?s:p(s),r+=" ";D&&(r+='"');break;case 2:{p=c=>(c=c.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),c.length===0?'""':c);const s=c=>/[^\w@%\/+=,.:^-]/.test(c)?`'${c.replace(/'/g,"'\\''")}'`:c;if($&&(r+=`cd ${p($)} ; `),D){r+="/usr/bin/env";for(const c in D){const f=D[c];f===null?r+=` -u ${s(c)}`:r+=` ${s(`${c}=${f}`)}`}r+=" "}for(const c of R)r+=c==="<"||c===">"||I?c:p(c),r+=" ";break}}return r}e.$5ac=E}),define(Se[102],Ce([1,0,22,34,48,93,15,13,11,47]),function(fe,e,k,F,h,A,P,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KH=e.$JH=e.$IH=e.$HH=e.CellStatusbarAlignment=e.$GH=e.$FH=e.$EH=e.NotebookEditorPriority=e.$DH=e.$CH=e.$BH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$AH=e.$zH=e.$yH=e.$xH=e.CellKind=e.$wH=e.$vH=e.$uH=void 0,e.$uH="workbench.editor.notebook",e.$vH="workbench.editor.notebookTextDiffEditor",e.$wH="workbench.editor.interactive";var R;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(R||(e.CellKind=R={})),e.$xH=["application/json","application/javascript","text/html","image/svg+xml",A.$ur.latex,A.$ur.markdown,"image/png","image/jpeg",A.$ur.text],e.$yH=[A.$ur.latex,A.$ur.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$ur.text],e.$zH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$AH="_notAvailable";var I;(function(M){M[M.Running=1]="Running",M[M.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var $;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})($||(e.NotebookCellExecutionState=$={}));var D;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(D||(e.NotebookExecutionState=D={}));var S;(function(M){M[M.WithHardKernelDependency=0]="WithHardKernelDependency",M[M.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",M[M.Pure=2]="Pure",M[M.Never=3]="Never"})(S||(e.NotebookRendererMatch=S={}));var p;(function(M){M.Always="always",M.Never="never",M.Optional="optional"})(p||(e.RendererMessagingSpec=p={}));var r;(function(M){M[M.ModelChange=1]="ModelChange",M[M.Move=2]="Move",M[M.ChangeCellLanguage=5]="ChangeCellLanguage",M[M.Initialize=6]="Initialize",M[M.ChangeCellMetadata=7]="ChangeCellMetadata",M[M.Output=8]="Output",M[M.OutputItem=9]="OutputItem",M[M.ChangeCellContent=10]="ChangeCellContent",M[M.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",M[M.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",M[M.ChangeCellMime=13]="ChangeCellMime",M[M.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var s;(function(M){M[M.Handle=0]="Handle",M[M.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var c;(function(M){M[M.Replace=1]="Replace",M[M.Output=2]="Output",M[M.Metadata=3]="Metadata",M[M.CellLanguage=4]="CellLanguage",M[M.DocumentMetadata=5]="DocumentMetadata",M[M.Move=6]="Move",M[M.OutputItems=7]="OutputItems",M[M.PartialMetadata=8]="PartialMetadata",M[M.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var f;(function(M){M.scheme=P.Schemas.vscodeNotebookCell;const Y=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${Y.join("")}]+`),de=7;function re(ue,ce){const z=ce.toString(de),Ee=`${z.length<Y.length?Y[z.length-1]:"z"}${z}s${(0,k.$4b)(k.$Jb.fromString(ue.scheme),!0,!0)}`;return ue.with({scheme:M.scheme,fragment:Ee})}M.generate=re;function x(ue){if(ue.scheme!==M.scheme)return;const ce=ue.fragment.indexOf("s");if(ce<0)return;const z=parseInt(ue.fragment.substring(0,ce).replace(V,""),de),ie=(0,k.$3b)(ue.fragment.substring(ce+1)).toString();if(!isNaN(z))return{handle:z,notebook:ue.with({scheme:ie,fragment:null})}}M.parse=x;function q(ue,ce){return ue.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${ce??""},${ue.scheme!==P.Schemas.file?ue.scheme:""}`})}M.generateCellOutputUri=q;function ne(ue){if(ue.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const ce=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ue.fragment);if(!ce)return;const z=ce[1]&&ce[1]!==""?ce[1]:void 0,ie=ce[2];return{outputId:z,notebook:ue.with({scheme:ie||P.Schemas.file,fragment:null})}}M.parseCellOutputUri=ne;function pe(ue,ce,z){return M.generate(ue,ce).with({scheme:z})}M.generateCellPropertyUri=pe;function H(ue,ce){if(ue.scheme===ce)return M.parse(ue.with({scheme:M.scheme}))}M.parseCellPropertyUri=H})(f||(e.CellUri=f={}));const y=M=>E.$i?M.replace(/\//g,"\\"):M;class C{constructor(Y=[],V=e.$xH){this.e=V,this.d=[...new Set(Y)].map(de=>({pattern:de,matches:F.$ej(y(de))}))}sort(Y){const V=new Map(h.Iterable.map(Y,re=>[re,y(re)]));let de=[];for(const{matches:re}of this.d)for(const[x,q]of V)if(re(q)){de.push(x),V.delete(x);break}return V.size&&(de=de.concat([...V.keys()].sort((re,x)=>this.e.indexOf(re)-this.e.indexOf(x)))),de}prioritize(Y,V){const de=this.f(Y);if(de===-1){this.d.unshift({pattern:Y,matches:F.$ej(y(Y))});return}const re=new Set(V.map(q=>this.f(q,de)));re.delete(-1);const x=Array.from(re).sort();this.d.splice(de+1,0,...x.map(q=>this.d[q]));for(let q=x.length-1;q>=0;q--)this.d.splice(x[q],1)}toArray(){return this.d.map(Y=>Y.pattern)}f(Y,V=this.d.length){const de=y(Y);for(let re=0;re<V;re++)if(this.d[re].matches(de))return re;return-1}}e.$BH=C;function i(M,Y,V,de=(re,x)=>re===x){const re=[];function x(pe,H,ue){if(H===0&&ue.length===0)return;const ce=re[re.length-1];ce&&ce.start+ce.deleteCount===pe?(ce.deleteCount+=H,ce.toInsert.push(...ue)):re.push({start:pe,deleteCount:H,toInsert:ue})}let q=0,ne=0;for(;;){if(q===M.length){x(q,0,Y.slice(ne));break}if(ne===Y.length){x(q,M.length-q,[]);break}const pe=M[q],H=Y[ne];if(de(pe,H)){q+=1,ne+=1;continue}V(H)?(x(q,1,[]),q+=1):(x(q,0,[H]),ne+=1)}return re}e.$CH=i,e.$DH=new b.$Oi("notebookEditorCursorAtBoundary","none");var o;(function(M){M.default="default",M.option="option"})(o||(e.NotebookEditorPriority=o={}));function n(M){const Y=M;return!!((typeof Y.include=="string"||F.$fj(Y.include))&&(typeof Y.exclude=="string"||F.$fj(Y.exclude)))}e.$EH=n;function t(M,Y,V){if(Array.isArray(M.viewType)&&M.viewType.indexOf(Y)>=0||M.viewType===Y)return!0;if(M.filenamePattern){const de=n(M.filenamePattern)?M.filenamePattern.include:M.filenamePattern,re=n(M.filenamePattern)?M.filenamePattern.exclude:void 0;if(F.$dj(de,(0,m.$ec)(V.fsPath).toLowerCase()))return!(re&&F.$dj(re,(0,m.$ec)(V.fsPath).toLowerCase()))}return!1}e.$FH=t,e.$GH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var a;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class g{static{this.d="notebook/"}static create(Y){return`${g.d}${Y}`}static parse(Y){if(Y.startsWith(g.d))return Y.substring(g.d.length)}}e.$HH=g;function u(M){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(M)}e.$IH=u;const d=new TextDecoder;function v(M){const Y=[];let V=!1;for(const q of M)(Y.length===0||V)&&(Y.push(q),V=!0);let de=L(Y);const re=k.$Jb.concat(Y.map(q=>k.$Jb.wrap(q))),x=W(re);return de=de||x.byteLength!==re.byteLength,{data:x,didCompression:de}}e.$JH=v,e.$KH=`${String.fromCharCode(27)}[A`;const l=e.$KH.split("").map(M=>M.charCodeAt(0)),w=10;function L(M){let Y=!1;return M.forEach((V,de)=>{if(de===0||V.length<e.$KH.length)return;const re=M[de-1],x=V.subarray(0,e.$KH.length);if(x[0]===l[0]&&x[1]===l[1]&&x[2]===l[2]){const q=re.lastIndexOf(w);if(q===-1)return;Y=!0,M[de-1]=re.subarray(0,q),M[de]=V.subarray(e.$KH.length)}}),Y}function O(M){let Y=M;do M=Y,Y=M.replace(/[^\n]\x08/gm,"");while(Y.length<M.length);return M}function N(M){for(M=M.replace(/\r+\n/gm,`
`);M.search(/\r[^$]/g)>-1;){const Y=M.match(/^(.*)\r+/m)[1];let V=M.match(/\r+(.*)$/m)[1];V=V+Y.slice(V.length,Y.length),M=M.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return M}const T="\b".charCodeAt(0),j="\r".charCodeAt(0);function W(M){return!M.buffer.includes(T)&&!M.buffer.includes(j)?M:k.$Jb.fromString(N(O(d.decode(M.buffer))))}}),define(Se[7],Ce([1,0,19,8,74,28,93,12,14,2,32,25,30,130,102]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S){"use strict";var p,r,s,c,f,y,C,i,o,n,t,a,g,u,d,v,l,w;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.TestRunProfileKind=e.TestResultState=e.$_K=e.$$K=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$0K=e.$9K=e.$8K=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$7K=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.ColorThemeKind=e.$1K=e.$ZK=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$YK=e.DebugConsoleMode=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$SK=e.$RK=e.FileChangeType=e.$QK=e.$PK=e.$OK=e.$NK=e.InlineCompletionTriggerKind=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.ConfigurationTarget=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$qK=e.ViewBadge=e.ProgressLocation=e.$pK=e.$oK=e.TaskScope=e.ShellQuoting=e.$nK=e.$mK=e.$lK=e.TaskPanelKind=e.TaskRevealKind=e.$kK=e.TerminalLocation=e.$jK=e.$iK=e.$hK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$gK=e.$fK=e.$eK=e.$dK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$cK=e.StatusBarAlignment=e.ViewColumn=e.$bK=e.$aK=e.$_J=e.$$J=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$0J=e.$9J=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.LanguageStatusSeverity=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.CodeActionTriggerKind=e.$VJ=e.$UJ=e.SymbolTag=e.SymbolKind=e.$TJ=e.DocumentHighlightKind=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.DiagnosticSeverity=e.DiagnosticTag=e.$OJ=e.$NJ=e.FileEditType=e.$MJ=e.$LJ=e.$KJ=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function L(J){return Object.assign(J,{apply:function(){const ge=arguments.length===1?[]:arguments[1];return Reflect.construct(J,ge,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(J,[]);{const[ge,...Fe]=arguments;return Reflect.construct(J,Fe,ge.constructor)}}})}var O;(function(J){J[J.Top=0]="Top",J[J.Bottom=1]="Bottom"})(O||(e.TerminalOutputAnchor=O={}));var N;(function(J){J[J.Command=0]="Command",J[J.Opener=1]="Opener"})(N||(e.TerminalQuickFixType=N={}));let T=p=class{static from(...B){let ge=B;return new p(function(){if(ge){for(const Fe of ge)Fe&&typeof Fe.dispose=="function"&&Fe.dispose();ge=void 0}})}#e;constructor(B){this.#e=B}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$DJ=T,e.$DJ=T=p=Je([L],T);let j=r=class{static Min(...B){if(B.length===0)throw new TypeError;let ge=B[0];for(let Fe=1;Fe<B.length;Fe++){const Ke=B[Fe];Ke.isBefore(ge)&&(ge=Ke)}return ge}static Max(...B){if(B.length===0)throw new TypeError;let ge=B[0];for(let Fe=1;Fe<B.length;Fe++){const Ke=B[Fe];Ke.isAfter(ge)&&(ge=Ke)}return ge}static isPosition(B){if(!B)return!1;if(B instanceof r)return!0;const{line:ge,character:Fe}=B;return typeof ge=="number"&&typeof Fe=="number"}static of(B){if(B instanceof r)return B;if(this.isPosition(B))return new r(B.line,B.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(B,ge){if(B<0)throw(0,F.$5)("line must be non-negative");if(ge<0)throw(0,F.$5)("character must be non-negative");this.c=B,this.e=ge}isBefore(B){return this.c<B.c?!0:B.c<this.c?!1:this.e<B.e}isBeforeOrEqual(B){return this.c<B.c?!0:B.c<this.c?!1:this.e<=B.e}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this.c===B.c&&this.e===B.e}compareTo(B){return this.c<B.c?-1:this.c>B.line?1:this.e<B.e?-1:this.e>B.e?1:0}translate(B,ge=0){if(B===null||ge===null)throw(0,F.$5)();let Fe;return typeof B>"u"?Fe=0:typeof B=="number"?Fe=B:(Fe=typeof B.lineDelta=="number"?B.lineDelta:0,ge=typeof B.characterDelta=="number"?B.characterDelta:0),Fe===0&&ge===0?this:new r(this.line+Fe,this.character+ge)}with(B,ge=this.character){if(B===null||ge===null)throw(0,F.$5)();let Fe;return typeof B>"u"?Fe=this.line:typeof B=="number"?Fe=B:(Fe=typeof B.line=="number"?B.line:this.line,ge=typeof B.character=="number"?B.character:this.character),Fe===this.line&&ge===this.character?this:new r(Fe,ge)}toJSON(){return{line:this.line,character:this.character}}};e.$EJ=j,e.$EJ=j=r=Je([L],j);let W=s=class{static isRange(B){return B instanceof s?!0:B?j.isPosition(B.start)&&j.isPosition(B.end):!1}static of(B){if(B instanceof s)return B;if(this.isRange(B))return new s(B.start,B.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(B,ge,Fe,Ke){let Xe,ot;if(typeof B=="number"&&typeof ge=="number"&&typeof Fe=="number"&&typeof Ke=="number"?(Xe=new j(B,ge),ot=new j(Fe,Ke)):j.isPosition(B)&&j.isPosition(ge)&&(Xe=j.of(B),ot=j.of(ge)),!Xe||!ot)throw new Error("Invalid arguments");Xe.isBefore(ot)?(this.c=Xe,this.e=ot):(this.c=ot,this.e=Xe)}contains(B){return s.isRange(B)?this.contains(B.start)&&this.contains(B.end):j.isPosition(B)?!(j.of(B).isBefore(this.c)||this.e.isBefore(B)):!1}isEqual(B){return this.c.isEqual(B.c)&&this.e.isEqual(B.e)}intersection(B){const ge=j.Max(B.start,this.c),Fe=j.Min(B.end,this.e);if(!ge.isAfter(Fe))return new s(ge,Fe)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const ge=j.Min(B.start,this.c),Fe=j.Max(B.end,this.end);return new s(ge,Fe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(B,ge=this.end){if(B===null||ge===null)throw(0,F.$5)();let Fe;return B?j.isPosition(B)?Fe=B:(Fe=B.start||this.start,ge=B.end||this.end):Fe=this.start,Fe.isEqual(this.c)&&ge.isEqual(this.end)?this:new s(Fe,ge)}toJSON(){return[this.start,this.end]}};e.$FJ=W,e.$FJ=W=s=Je([L],W);let M=c=class extends W{static isSelection(B){return B instanceof c?!0:B?W.isRange(B)&&j.isPosition(B.anchor)&&j.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(B,ge,Fe,Ke){let Xe,ot;if(typeof B=="number"&&typeof ge=="number"&&typeof Fe=="number"&&typeof Ke=="number"?(Xe=new j(B,ge),ot=new j(Fe,Ke)):j.isPosition(B)&&j.isPosition(ge)&&(Xe=j.of(B),ot=j.of(ge)),!Xe||!ot)throw new Error("Invalid arguments");super(Xe,ot),this.f=Xe,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$GJ=M,e.$GJ=M=c=Je([L],M);const Y=J=>{if(typeof J!="string"||J.length===0||!/^[0-9A-Za-z_\-]+$/.test(J))throw(0,F.$5)("connectionToken")};class V{static isResolvedAuthority(B){return B&&typeof B=="object"&&typeof B.host=="string"&&typeof B.port=="number"&&(B.connectionToken===void 0||typeof B.connectionToken=="string")}constructor(B,ge,Fe){if(typeof B!="string"||B.length===0)throw(0,F.$5)("host");if(typeof ge!="number"||ge===0||Math.round(ge)!==ge)throw(0,F.$5)("port");typeof Fe<"u"&&Y(Fe),this.host=B,this.port=Math.round(ge),this.connectionToken=Fe}}e.$HJ=V;class de{static isManagedResolvedAuthority(B){return B&&typeof B=="object"&&typeof B.makeConnection=="function"&&(B.connectionToken===void 0||typeof B.connectionToken=="string")}constructor(B,ge){this.makeConnection=B,this.connectionToken=ge,typeof ge<"u"&&Y(ge)}}e.$IJ=de;class re extends Error{static NotAvailable(B,ge){return new re(B,D.RemoteAuthorityResolverErrorCode.NotAvailable,ge)}static TemporarilyNotAvailable(B){return new re(B,D.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(B,ge=D.RemoteAuthorityResolverErrorCode.Unknown,Fe){super(B),this._message=B,this._code=ge,this._detail=Fe,Object.setPrototypeOf(this,re.prototype)}}e.$JJ=re;var x;(function(J){J[J.LF=1]="LF",J[J.CRLF=2]="CRLF"})(x||(e.EndOfLine=x={}));var q;(function(J){J[J.Replace=1]="Replace",J[J.Append=2]="Append",J[J.Prepend=3]="Prepend"})(q||(e.EnvironmentVariableMutatorType=q={}));let ne=f=class{static isTextEdit(B){return B instanceof f?!0:B?W.isRange(B)&&typeof B.newText=="string":!1}static replace(B,ge){return new f(B,ge)}static insert(B,ge){return f.replace(new W(B,B),ge)}static delete(B){return f.replace(B,"")}static setEndOfLine(B){const ge=new f(new W(new j(0,0),new j(0,0)),"");return ge.newEol=B,ge}get range(){return this.c}set range(B){if(B&&!W.isRange(B))throw(0,F.$5)("range");this.c=B}get newText(){return this.e||""}set newText(B){if(B&&typeof B!="string")throw(0,F.$5)("newText");this.e=B}get newEol(){return this.f}set newEol(B){if(B&&typeof B!="number")throw(0,F.$5)("newEol");this.f=B}constructor(B,ge){this.c=B,this.e=ge}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$KJ=ne,e.$KJ=ne=f=Je([L],ne);let pe=y=class{static isNotebookCellEdit(B){return B instanceof y?!0:B?Zt.isNotebookRange(B)&&Array.isArray(B.newCells):!1}static replaceCells(B,ge){return new y(B,ge)}static insertCells(B,ge){return new y(new Zt(B,B),ge)}static deleteCells(B){return new y(B,[])}static updateCellMetadata(B,ge){const Fe=new y(new Zt(B,B),[]);return Fe.newCellMetadata=ge,Fe}static updateNotebookMetadata(B){const ge=new y(new Zt(0,0),[]);return ge.newNotebookMetadata=B,ge}constructor(B,ge){this.range=B,this.newCells=ge}};e.$LJ=pe,e.$LJ=pe=y=Je([L],pe);class H{static isSnippetTextEdit(B){return B instanceof H?!0:B?W.isRange(B.range)&&z.isSnippetString(B.snippet):!1}static replace(B,ge){return new H(B,ge)}static insert(B,ge){return H.replace(new W(B,B),ge)}constructor(B,ge){this.range=B,this.snippet=ge}}e.$MJ=H;var ue;(function(J){J[J.File=1]="File",J[J.Text=2]="Text",J[J.Cell=3]="Cell",J[J.CellReplace=5]="CellReplace",J[J.Snippet=6]="Snippet"})(ue||(e.FileEditType=ue={}));let ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(B,ge,Fe,Ke){this.c.push({_type:1,from:B,to:ge,options:Fe,metadata:Ke})}createFile(B,ge,Fe){this.c.push({_type:1,from:void 0,to:B,options:ge,metadata:Fe})}deleteFile(B,ge,Fe){this.c.push({_type:1,from:B,to:void 0,options:ge,metadata:Fe})}e(B,ge,Fe){this.c.push({_type:3,metadata:Fe,uri:B,edit:{editType:5,metadata:ge},notebookMetadata:ge})}f(B,ge,Fe,Ke){const Xe=ge.start,ot=ge.end;(Xe!==ot||Fe.length>0)&&this.c.push({_type:5,uri:B,index:Xe,count:ot-Xe,cells:Fe,metadata:Ke})}g(B,ge,Fe,Ke){this.c.push({_type:3,metadata:Ke,uri:B,edit:{editType:3,index:ge,metadata:Fe}})}replace(B,ge,Fe,Ke){this.c.push({_type:2,uri:B,edit:new ne(ge,Fe),metadata:Ke})}insert(B,ge,Fe,Ke){this.replace(B,new W(ge,ge),Fe,Ke)}delete(B,ge,Fe){this.replace(B,ge,"",Fe)}has(B){return this.c.some(ge=>ge._type===2&&ge.uri.toString()===B.toString())}set(B,ge){if(ge)for(const Fe of ge){if(!Fe)continue;let Ke,Xe;Array.isArray(Fe)?(Ke=Fe[0],Xe=Fe[1]):Ke=Fe,pe.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(B,Ke.range.start,Ke.newCellMetadata,Xe):Ke.newNotebookMetadata?this.e(B,Ke.newNotebookMetadata,Xe):this.f(B,Ke.range,Ke.newCells,Xe):H.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:B,range:Ke.range,edit:Ke.snippet,metadata:Xe}):this.c.push({_type:2,uri:B,edit:Ke,metadata:Xe})}else{for(let Fe=0;Fe<this.c.length;Fe++){const Ke=this.c[Fe];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===B.toString()&&(this.c[Fe]=void 0);break}}(0,k.$nf)(this.c)}}get(B){const ge=[];for(const Fe of this.c)Fe._type===2&&Fe.uri.toString()===B.toString()&&ge.push(Fe.edit);return ge}entries(){const B=new A.$ni;for(const ge of this.c)if(ge._type===2){let Fe=B.get(ge.uri);Fe||(Fe=[ge.uri,[]],B.set(ge.uri,Fe)),Fe[1].push(ge.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$NJ=ce,e.$NJ=ce=Je([L],ce);let z=C=class{static isSnippetString(B){return B instanceof C?!0:B?typeof B.value=="string":!1}static c(B){return B.replace(/\$|}|\\/g,"\\$&")}constructor(B){this.e=1,this.value=B||""}appendText(B){return this.value+=C.c(B),this}appendTabstop(B=this.e++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,ge=this.e++){if(typeof B=="function"){const Fe=new C;Fe.e=this.e,B(Fe),this.e=Fe.e,B=Fe.value}else B=C.c(B);return this.value+="${",this.value+=ge,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,ge=this.e++){const Fe=B.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ge,this.value+="|",this.value+=Fe,this.value+="|}",this}appendVariable(B,ge){if(typeof ge=="function"){const Fe=new C;Fe.e=this.e,ge(Fe),this.e=Fe.e,ge=Fe.value}else typeof ge=="string"&&(ge=ge.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,ge&&(this.value+=":",this.value+=ge),this.value+="}",this}};e.$OJ=z,e.$OJ=z=C=Je([L],z);var ie;(function(J){J[J.Unnecessary=1]="Unnecessary",J[J.Deprecated=2]="Deprecated"})(ie||(e.DiagnosticTag=ie={}));var Ee;(function(J){J[J.Hint=3]="Hint",J[J.Information=2]="Information",J[J.Warning=1]="Warning",J[J.Error=0]="Error"})(Ee||(e.DiagnosticSeverity=Ee={}));let Re=i=class{static isLocation(B){return B instanceof i?!0:B?W.isRange(B.range)&&b.URI.isUri(B.uri):!1}constructor(B,ge){if(this.uri=B,ge)if(W.isRange(ge))this.range=W.of(ge);else if(j.isPosition(ge))this.range=new W(ge,ge);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$PJ=Re,e.$PJ=Re=i=Je([L],Re);let ye=class{static is(B){return B?typeof B.message=="string"&&B.location&&W.isRange(B.location.range)&&b.URI.isUri(B.location.uri):!1}constructor(B,ge){this.location=B,this.message=ge}static isEqual(B,ge){return B===ge?!0:!B||!ge?!1:B.message===ge.message&&B.location.range.isEqual(ge.location.range)&&B.location.uri.toString()===ge.location.uri.toString()}};e.$QJ=ye,e.$QJ=ye=Je([L],ye);let X=class{constructor(B,ge,Fe=Ee.Error){if(!W.isRange(B))throw new TypeError("range must be set");if(!ge)throw new TypeError("message must be set");this.range=B,this.message=ge,this.severity=Fe}toJSON(){return{severity:Ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,ge){return B===ge?!0:!B||!ge?!1:B.message===ge.message&&B.severity===ge.severity&&B.code===ge.code&&B.severity===ge.severity&&B.source===ge.source&&B.range.isEqual(ge.range)&&(0,k.$bf)(B.tags,ge.tags)&&(0,k.$bf)(B.relatedInformation,ge.relatedInformation,ye.isEqual)}};e.$RJ=X,e.$RJ=X=Je([L],X);let he=class{constructor(B,ge){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:this.contents=[B],this.range=ge}};e.$SJ=he,e.$SJ=he=Je([L],he);var K;(function(J){J[J.Text=0]="Text",J[J.Read=1]="Read",J[J.Write=2]="Write"})(K||(e.DocumentHighlightKind=K={}));let oe=class{constructor(B,ge=K.Text){this.range=B,this.kind=ge}toJSON(){return{range:this.range,kind:K[this.kind]}}};e.$TJ=oe,e.$TJ=oe=Je([L],oe);var _;(function(J){J[J.File=0]="File",J[J.Module=1]="Module",J[J.Namespace=2]="Namespace",J[J.Package=3]="Package",J[J.Class=4]="Class",J[J.Method=5]="Method",J[J.Property=6]="Property",J[J.Field=7]="Field",J[J.Constructor=8]="Constructor",J[J.Enum=9]="Enum",J[J.Interface=10]="Interface",J[J.Function=11]="Function",J[J.Variable=12]="Variable",J[J.Constant=13]="Constant",J[J.String=14]="String",J[J.Number=15]="Number",J[J.Boolean=16]="Boolean",J[J.Array=17]="Array",J[J.Object=18]="Object",J[J.Key=19]="Key",J[J.Null=20]="Null",J[J.EnumMember=21]="EnumMember",J[J.Struct=22]="Struct",J[J.Event=23]="Event",J[J.Operator=24]="Operator",J[J.TypeParameter=25]="TypeParameter"})(_||(e.SymbolKind=_={}));var le;(function(J){J[J.Deprecated=1]="Deprecated"})(le||(e.SymbolTag=le={}));let $e=o=class{static validate(B){if(!B.name)throw new Error("name must not be falsy")}constructor(B,ge,Fe,Ke,Xe){this.name=B,this.kind=ge,this.containerName=Xe,typeof Fe=="string"&&(this.containerName=Fe),Ke instanceof Re?this.location=Ke:Fe instanceof W&&(this.location=new Re(Ke,Fe)),o.validate(this)}toJSON(){return{name:this.name,kind:_[this.kind],location:this.location,containerName:this.containerName}}};e.$UJ=$e,e.$UJ=$e=o=Je([L],$e);let U=n=class{static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children?.forEach(n.validate)}constructor(B,ge,Fe,Ke,Xe){this.name=B,this.detail=ge,this.kind=Fe,this.range=Ke,this.selectionRange=Xe,this.children=[],n.validate(this)}};e.$VJ=U,e.$VJ=U=n=Je([L],U);var G;(function(J){J[J.Invoke=1]="Invoke",J[J.Automatic=2]="Automatic"})(G||(e.CodeActionTriggerKind=G={}));let Z=class{constructor(B,ge){this.title=B,this.kind=ge}};e.$WJ=Z,e.$WJ=Z=Je([L],Z);let ee=class{static{t=this}static{this.c="."}constructor(B){this.value=B}append(B){return new t(this.value?this.value+t.c+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+t.c)}};e.$XJ=ee,e.$XJ=ee=t=Je([L],ee);class be extends ee{constructor(B){super(B),this.value=B}}e.$YJ=be,ee.Empty=new ee(""),ee.QuickFix=ee.Empty.append("quickfix"),ee.Refactor=ee.Empty.append("refactor"),ee.RefactorExtract=ee.Refactor.append("extract"),ee.RefactorInline=ee.Refactor.append("inline"),ee.RefactorMove=ee.Refactor.append("move"),ee.RefactorRewrite=ee.Refactor.append("rewrite"),ee.Source=ee.Empty.append("source"),ee.SourceOrganizeImports=ee.Source.append("organizeImports"),ee.SourceFixAll=ee.Source.append("fixAll"),ee.Notebook=ee.Empty.append("notebook");let se=class{constructor(B,ge){if(this.range=B,this.parent=ge,ge&&!ge.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$ZJ=se,e.$ZJ=se=Je([L],se);class we{constructor(B,ge,Fe,Ke,Xe,ot){this.kind=B,this.name=ge,this.detail=Fe,this.uri=Ke,this.range=Xe,this.selectionRange=ot}}e.$1J=we;class Ie{constructor(B,ge){this.fromRanges=ge,this.from=B}}e.$2J=Ie;class je{constructor(B,ge){this.fromRanges=ge,this.to=B}}e.$3J=je;var Ve;(function(J){J[J.Information=0]="Information",J[J.Warning=1]="Warning",J[J.Error=2]="Error"})(Ve||(e.LanguageStatusSeverity=Ve={}));let _e=class{constructor(B,ge){this.range=B,this.command=ge}get isResolved(){return!!this.command}};e.$4J=_e,e.$4J=_e=Je([L],_e);let Ge=a=class{#e;static isMarkdownString(B){return B instanceof a?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}constructor(B,ge=!1){this.#e=new h.$Kj(B,{supportThemeIcons:ge})}get value(){return this.#e.value}set value(B){this.#e.value=B}get isTrusted(){return this.#e.isTrusted}set isTrusted(B){this.#e.isTrusted=B}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(B){this.#e.supportThemeIcons=B}get supportHtml(){return this.#e.supportHtml}set supportHtml(B){this.#e.supportHtml=B}get baseUri(){return this.#e.baseUri}set baseUri(B){this.#e.baseUri=B}appendText(B){return this.#e.appendText(B),this}appendMarkdown(B){return this.#e.appendMarkdown(B),this}appendCodeblock(B,ge){return this.#e.appendCodeblock(ge??"",B),this}};e.$5J=Ge,e.$5J=Ge=a=Je([L],Ge);let et=class{constructor(B,ge){this.label=B,this.documentation=ge}};e.$6J=et,e.$6J=et=Je([L],et);let Qe=class{constructor(B,ge){this.label=B,this.documentation=ge,this.parameters=[]}};e.$7J=Qe,e.$7J=Qe=Je([L],Qe);let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$8J=st,e.$8J=st=Je([L],st);var tt;(function(J){J[J.Invoke=1]="Invoke",J[J.TriggerCharacter=2]="TriggerCharacter",J[J.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var Pe;(function(J){J[J.Type=1]="Type",J[J.Parameter=2]="Parameter"})(Pe||(e.InlayHintKind=Pe={}));let ke=class{constructor(B){this.value=B}};e.$9J=ke,e.$9J=ke=Je([L],ke);let Be=class{constructor(B,ge,Fe){this.position=B,this.label=ge,this.kind=Fe}};e.$0J=Be,e.$0J=Be=Je([L],Be);var te;(function(J){J[J.Invoke=0]="Invoke",J[J.TriggerCharacter=1]="TriggerCharacter",J[J.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(te||(e.CompletionTriggerKind=te={}));var Q;(function(J){J[J.Text=0]="Text",J[J.Method=1]="Method",J[J.Function=2]="Function",J[J.Constructor=3]="Constructor",J[J.Field=4]="Field",J[J.Variable=5]="Variable",J[J.Class=6]="Class",J[J.Interface=7]="Interface",J[J.Module=8]="Module",J[J.Property=9]="Property",J[J.Unit=10]="Unit",J[J.Value=11]="Value",J[J.Enum=12]="Enum",J[J.Keyword=13]="Keyword",J[J.Snippet=14]="Snippet",J[J.Color=15]="Color",J[J.File=16]="File",J[J.Reference=17]="Reference",J[J.Folder=18]="Folder",J[J.EnumMember=19]="EnumMember",J[J.Constant=20]="Constant",J[J.Struct=21]="Struct",J[J.Event=22]="Event",J[J.Operator=23]="Operator",J[J.TypeParameter=24]="TypeParameter",J[J.User=25]="User",J[J.Issue=26]="Issue"})(Q||(e.CompletionItemKind=Q={}));var ve;(function(J){J[J.Deprecated=1]="Deprecated"})(ve||(e.CompletionItemTag=ve={}));let Ue=class{constructor(B,ge){this.label=B,this.kind=ge}toJSON(){return{label:this.label,kind:this.kind&&Q[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$$J=Ue,e.$$J=Ue=Je([L],Ue);let Ne=class{constructor(B=[],ge=!1){this.items=B,this.isIncomplete=ge}};e.$_J=Ne,e.$_J=Ne=Je([L],Ne);let Ye=class{constructor(B,ge,Fe){this.insertText=B,this.range=ge,this.command=Fe}};e.$aK=Ye,e.$aK=Ye=Je([L],Ye);let xe=class{constructor(B){this.commands=void 0,this.suppressSuggestions=void 0,this.items=B}};e.$bK=xe,e.$bK=xe=Je([L],xe);var rt;(function(J){J[J.Active=-1]="Active",J[J.Beside=-2]="Beside",J[J.One=1]="One",J[J.Two=2]="Two",J[J.Three=3]="Three",J[J.Four=4]="Four",J[J.Five=5]="Five",J[J.Six=6]="Six",J[J.Seven=7]="Seven",J[J.Eight=8]="Eight",J[J.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var ft;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(ft||(e.StatusBarAlignment=ft={}));function vt(J,B){return`${I.$Hl.toKey(J)}.${B}`}e.$cK=vt;var Ft;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative"})(Ft||(e.TextEditorLineNumbersStyle=Ft={}));var Lt;(function(J){J[J.Manual=1]="Manual",J[J.AfterDelay=2]="AfterDelay",J[J.FocusOut=3]="FocusOut"})(Lt||(e.TextDocumentSaveReason=Lt={}));var Et;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(Et||(e.TextEditorRevealType=Et={}));var Tt;(function(J){J[J.Keyboard=1]="Keyboard",J[J.Mouse=2]="Mouse",J[J.Command=3]="Command"})(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Ot;(function(J){J[J.Undo=1]="Undo",J[J.Redo=2]="Redo"})(Ot||(e.TextDocumentChangeReason=Ot={}));var zt;(function(J){J[J.OpenOpen=0]="OpenOpen",J[J.ClosedClosed=1]="ClosedClosed",J[J.OpenClosed=2]="OpenClosed",J[J.ClosedOpen=3]="ClosedOpen"})(zt||(e.DecorationRangeBehavior=zt={})),function(J){function B(ge){switch(ge){case"keyboard":return J.Keyboard;case"mouse":return J.Mouse;case"api":return J.Command}}J.fromValue=B}(Tt||(e.TextEditorSelectionChangeKind=Tt={}));let Bt=class{constructor(B,ge){if(ge&&!b.URI.isUri(ge))throw(0,F.$5)("target");if(!W.isRange(B)||B.isEmpty)throw(0,F.$5)("range");this.range=B,this.target=ge}};e.$dK=Bt,e.$dK=Bt=Je([L],Bt);let Mt=class{constructor(B,ge,Fe,Ke){this.red=B,this.green=ge,this.blue=Fe,this.alpha=Ke}};e.$eK=Mt,e.$eK=Mt=Je([L],Mt);let at=class{constructor(B,ge){if(ge&&!(ge instanceof Mt))throw(0,F.$5)("color");if(!W.isRange(B)||B.isEmpty)throw(0,F.$5)("range");this.range=B,this.color=ge}};e.$fK=at,e.$fK=at=Je([L],at);let dt=class{constructor(B){if(!B||typeof B!="string")throw(0,F.$5)("label");this.label=B}};e.$gK=dt,e.$gK=dt=Je([L],dt);var Wt;(function(J){J[J.RGB=0]="RGB",J[J.HEX=1]="HEX",J[J.HSL=2]="HSL"})(Wt||(e.ColorFormat=Wt={}));var Nt;(function(J){J[J.Error=0]="Error",J[J.Warning=1]="Warning",J[J.Information=2]="Information"})(Nt||(e.SourceControlInputBoxValidationType=Nt={}));var Dt;(function(J){J[J.Unknown=0]="Unknown",J[J.Shutdown=1]="Shutdown",J[J.Process=2]="Process",J[J.User=3]="User",J[J.Extension=4]="Extension"})(Dt||(e.TerminalExitReason=Dt={}));class ct{constructor(B,ge,Fe){if(this.startIndex=B,this.length=ge,this.tooltip=Fe,typeof B!="number"||B<0)throw(0,F.$5)("startIndex");if(typeof ge!="number"||ge<1)throw(0,F.$5)("length");if(Fe!==void 0&&typeof Fe!="string")throw(0,F.$5)("tooltip")}}e.$hK=ct;class At{constructor(B){this.uri=B}}e.$iK=At;class jt{constructor(B){this.terminalCommand=B}}e.$jK=jt;var Te;(function(J){J[J.Panel=1]="Panel",J[J.Editor=2]="Editor"})(Te||(e.TerminalLocation=Te={}));class Le{constructor(B){if(this.options=B,typeof B!="object")throw(0,F.$5)("options")}}e.$kK=Le;var Ae;(function(J){J[J.Always=1]="Always",J[J.Silent=2]="Silent",J[J.Never=3]="Never"})(Ae||(e.TaskRevealKind=Ae={}));var ae;(function(J){J[J.Shared=1]="Shared",J[J.Dedicated=2]="Dedicated",J[J.New=3]="New"})(ae||(e.TaskPanelKind=ae={}));let Oe=class{static{g=this}static{this.Clean=new g("clean","Clean")}static{this.Build=new g("build","Build")}static{this.Rebuild=new g("rebuild","Rebuild")}static{this.Test=new g("test","Test")}static from(B){switch(B){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}constructor(B,ge){if(this.label=ge,typeof B!="string"||typeof ge!="string")throw(0,F.$5)("name");this.c=B}get id(){return this.c}};e.$lK=Oe,e.$lK=Oe=g=Je([L],Oe);function We(J){let B="";for(let ge=0;ge<J.length;ge++)B+=J[ge].replace(/,/g,",,")+",";return B}let Ze=class{constructor(B,ge,Fe){if(typeof B!="string")throw(0,F.$5)("process");this.e=[],this.c=B,ge!==void 0&&(Array.isArray(ge)?(this.e=ge,this.f=Fe):this.f=ge)}get process(){return this.c}set process(B){if(typeof B!="string")throw(0,F.$5)("process");this.c=B}get args(){return this.e}set args(B){Array.isArray(B)||(B=[]),this.e=B}get options(){return this.f}set options(B){this.f=B}computeId(){const B=[];if(B.push("process"),this.c!==void 0&&B.push(this.c),this.e&&this.e.length>0)for(const ge of this.e)B.push(ge);return We(B)}};e.$mK=Ze,e.$mK=Ze=Je([L],Ze);let He=class{constructor(B,ge,Fe){if(this.f=[],Array.isArray(ge)){if(!B)throw(0,F.$5)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,F.$5)("command");this.e=B,this.f=ge,this.g=Fe}else{if(typeof B!="string")throw(0,F.$5)("commandLine");this.c=B,this.g=ge}}get commandLine(){return this.c}set commandLine(B){if(typeof B!="string")throw(0,F.$5)("commandLine");this.c=B}get command(){return this.e?this.e:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,F.$5)("command");this.e=B}get args(){return this.f}set args(B){this.f=B||[]}get options(){return this.g}set options(B){this.g=B}computeId(){const B=[];if(B.push("shell"),this.c!==void 0&&B.push(this.c),this.e!==void 0&&B.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ge of this.f)B.push(typeof ge=="string"?ge:ge.value);return We(B)}};e.$nK=He,e.$nK=He=Je([L],He);var it;(function(J){J[J.Escape=1]="Escape",J[J.Strong=2]="Strong",J[J.Weak=3]="Weak"})(it||(e.ShellQuoting=it={}));var wt;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace"})(wt||(e.TaskScope=wt={}));class St{constructor(B){this.c=B}computeId(){return"customExecution"+(0,R.$6e)()}set callback(B){this.c=B}get callback(){return this.c}}e.$oK=St;let Ct=class{static{u=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(B,ge,Fe,Ke,Xe,ot){this.j=!1,this.k=this.definition=B;let lt;typeof ge=="string"?(this.m=this.name=ge,this.t=this.source=Fe,this.execution=Ke,lt=Xe,this.j=!0):ge===wt.Global||ge===wt.Workspace?(this.target=ge,this.m=this.name=Fe,this.t=this.source=Ke,this.execution=Xe,lt=ot):(this.target=ge,this.m=this.name=Fe,this.t=this.source=Ke,this.execution=Xe,lt=ot),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(B){this.h=B}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Ze?this.k={type:u.e,id:this.n.computeId()}:this.n instanceof He?this.k={type:u.f,id:this.n.computeId()}:this.n instanceof St?this.k={type:u.c,id:this.n.computeId()}:this.k={type:u.g,id:(0,R.$6e)()}}get definition(){return this.k}set definition(B){if(B==null)throw(0,F.$5)("Kind can't be undefined or null");this.y(),this.k=B}get scope(){return this.l}set target(B){this.y(),this.l=B}get name(){return this.m}set name(B){if(typeof B!="string")throw(0,F.$5)("name");this.y(),this.m=B}get execution(){return this.n}set execution(B){B===null&&(B=void 0),this.y(),this.n=B;const ge=this.k.type;(u.g===ge||u.e===ge||u.f===ge||u.c===ge)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(B){if(Array.isArray(B))this.y(),this.o=B,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.y(),this.r=B}get source(){return this.t}set source(B){if(typeof B!="string"||B.length===0)throw(0,F.$5)("source must be a string of length > 0");this.y(),this.t=B}get group(){return this.u}set group(B){B===null&&(B=void 0),this.y(),this.u=B}get detail(){return this.x}set detail(B){B===null&&(B=void 0),this.x=B}get presentationOptions(){return this.v}set presentationOptions(B){B==null&&(B=Object.create(null)),this.y(),this.v=B}get runOptions(){return this.w}set runOptions(B){B==null&&(B=Object.create(null)),this.y(),this.w=B}};e.$pK=Ct,e.$pK=Ct=u=Je([L],Ct);var pt;(function(J){J[J.SourceControl=1]="SourceControl",J[J.Window=10]="Window",J[J.Notification=15]="Notification"})(pt||(e.ProgressLocation=pt={}));var $t;(function(J){function B(ge){const Fe=ge;return(0,E.$ne)(Fe.value)?Fe.tooltip&&!(0,E.$je)(Fe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Fe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Fe.value),!1)}J.isViewBadge=B})($t||(e.ViewBadge=$t={}));let ht=d=class{static isTreeItem(B,ge){const Fe=B;if(Fe.checkboxState!==void 0){const Ke=(0,E.$ne)(Fe.checkboxState)?Fe.checkboxState:(0,E.$le)(Fe.checkboxState)&&(0,E.$ne)(Fe.checkboxState.state)?Fe.checkboxState.state:void 0,Xe=!(0,E.$ne)(Fe.checkboxState)&&(0,E.$le)(Fe.checkboxState)?Fe.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==gt.Checked&&Ke!==gt.Unchecked||Xe!==void 0&&!(0,E.$je)(Xe))return console.log("INVALID tree item, invalid checkboxState",Fe.checkboxState),!1}if(B instanceof d)return!0;if(Fe.label!==void 0&&!(0,E.$je)(Fe.label)&&!Fe.label?.label)return console.log("INVALID tree item, invalid label",Fe.label),!1;if(Fe.id!==void 0&&!(0,E.$je)(Fe.id))return console.log("INVALID tree item, invalid id",Fe.id),!1;if(Fe.iconPath!==void 0&&!(0,E.$je)(Fe.iconPath)&&!b.URI.isUri(Fe.iconPath)&&(!Fe.iconPath||!(0,E.$je)(Fe.iconPath.id))){const Ke=Fe.iconPath;if(!Ke||!(0,E.$je)(Ke.light)&&!b.URI.isUri(Ke.light)&&!(0,E.$je)(Ke.dark)&&!b.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Fe.iconPath),!1}return Fe.description!==void 0&&!(0,E.$je)(Fe.description)&&typeof Fe.description!="boolean"?(console.log("INVALID tree item, invalid description",Fe.description),!1):Fe.resourceUri!==void 0&&!b.URI.isUri(Fe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Fe.resourceUri),!1):Fe.tooltip!==void 0&&!(0,E.$je)(Fe.tooltip)&&!(Fe.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",Fe.tooltip),!1):Fe.command!==void 0&&!Fe.command.command?(console.log("INVALID tree item, invalid command",Fe.command),!1):Fe.collapsibleState!==void 0&&Fe.collapsibleState<bt.None&&Fe.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Fe.collapsibleState),!1):Fe.contextValue!==void 0&&!(0,E.$je)(Fe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Fe.contextValue),!1):Fe.accessibilityInformation!==void 0&&!Fe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Fe.accessibilityInformation),!1):!0}constructor(B,ge=bt.None){this.collapsibleState=ge,b.URI.isUri(B)?this.resourceUri=B:this.label=B}};e.$qK=ht,e.$qK=ht=d=Je([L],ht);var bt;(function(J){J[J.None=0]="None",J[J.Collapsed=1]="Collapsed",J[J.Expanded=2]="Expanded"})(bt||(e.TreeItemCollapsibleState=bt={}));var gt;(function(J){J[J.Unchecked=0]="Unchecked",J[J.Checked=1]="Checked"})(gt||(e.TreeItemCheckboxState=gt={}));let Qt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(B){this.value=B}};e.$rK=Qt,e.$rK=Qt=Je([L],Qt);class qt extends Qt{}e.$sK=qt;class Xi extends qt{#e;constructor(B){super(""),this.#e=B}asFile(){return this.#e}}e.$tK=Xi;class hi{constructor(B,ge,Fe,Ke){this.name=B,this.uri=ge,this._itemId=Fe,this.c=Ke}data(){return this.c()}}e.$uK=hi;let di=class{#e=new Map;constructor(B){for(const[ge,Fe]of B??[]){const Ke=this.#e.get(this.#t(ge));Ke?Ke.push(Fe):this.#e.set(this.#t(ge),[Fe])}}get(B){return this.#e.get(this.#t(B))?.[0]}set(B,ge){this.#e.set(this.#t(B),[ge])}forEach(B,ge){for(const[Fe,Ke]of this.#e)for(const Xe of Ke)B.call(ge,Xe,Fe,this)}*[Symbol.iterator](){for(const[B,ge]of this.#e)for(const Fe of ge)yield[B,Fe]}#t(B){return B.toLowerCase()}};e.$vK=di,e.$vK=di=Je([L],di);let It=class{constructor(B){this.insertText=B}};e.$wK=It,e.$wK=It=Je([L],It);let yi=class{constructor(B,ge,Fe){this.id=ge,this.label=Fe,this.insertText=B}};e.$xK=yi,e.$xK=yi=Je([L],yi);let Ht=class{constructor(B,ge){this.id=B,this.color=ge}static isThemeIcon(B){return typeof B.id!="string"?(console.log("INVALID ThemeIcon, invalid id",B.id),!1):!0}};e.$yK=Ht,e.$yK=Ht=Je([L],Ht),Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let kt=class{constructor(B){this.id=B}};e.$zK=kt,e.$zK=kt=Je([L],kt);var Ei;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace",J[J.WorkspaceFolder=3]="WorkspaceFolder"})(Ei||(e.ConfigurationTarget=Ei={}));let fi=class{get base(){return this.c}set base(B){this.c=B,this.e=b.URI.file(B)}get baseUri(){return this.e}set baseUri(B){this.e=B,this.c=B.fsPath}constructor(B,ge){if(typeof B!="string"&&(!B||!b.URI.isUri(B)&&!b.URI.isUri(B.uri)))throw(0,F.$5)("base");if(typeof ge!="string")throw(0,F.$5)("pattern");typeof B=="string"?this.baseUri=b.URI.file(B):b.URI.isUri(B)?this.baseUri=B:this.baseUri=B.uri,this.pattern=ge}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$AK=fi,e.$AK=fi=Je([L],fi);const ai=new WeakMap;function _i(J,B){ai.set(J,B)}e.$BK=_i;let ni=class{constructor(B,ge,Fe,Ke){this.enabled=typeof B=="boolean"?B:!0,typeof ge=="string"&&(this.condition=ge),typeof Fe=="string"&&(this.hitCondition=Fe),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=ai.get(this)??(0,R.$6e)()),this.c}};e.$CK=ni,e.$CK=ni=Je([L],ni);let Rt=class extends ni{constructor(B,ge,Fe,Ke,Xe){if(super(ge,Fe,Ke,Xe),B===null)throw(0,F.$5)("location");this.location=B}};e.$DK=Rt,e.$DK=Rt=Je([L],Rt);let mi=class extends ni{constructor(B,ge,Fe,Ke,Xe){super(ge,Fe,Ke,Xe),this.functionName=B}};e.$EK=mi,e.$EK=mi=Je([L],mi);let ki=class extends ni{constructor(B,ge,Fe,Ke,Xe,ot,lt){if(super(Ke,Xe,ot,lt),!ge)throw(0,F.$5)("dataId");this.label=B,this.dataId=ge,this.canPersist=Fe}};e.$FK=ki,e.$FK=ki=Je([L],ki);let ri=class{constructor(B,ge,Fe){this.command=B,this.args=ge||[],this.options=Fe}};e.$GK=ri,e.$GK=ri=Je([L],ri);let si=class{constructor(B,ge){this.port=B,this.host=ge}};e.$HK=si,e.$HK=si=Je([L],si);let ut=class{constructor(B){this.path=B}};e.$IK=ut,e.$IK=ut=Je([L],ut);let Di=class{constructor(B){this.implementation=B}};e.$JK=Di,e.$JK=Di=Je([L],Di);let Kt=class{constructor(B,ge,Fe){this.session=B,this.threadId=ge,this.frameId=Fe}};e.$KK=Kt,e.$KK=Kt=Je([L],Kt);let xt=class{constructor(B,ge){this.session=B,this.threadId=ge}};e.$LK=xt,e.$LK=xt=Je([L],xt);let gi=class{constructor(B,ge){this.range=B,this.expression=ge}};e.$MK=gi,e.$MK=gi=Je([L],gi);var zi;(function(J){J[J.Invoke=0]="Invoke",J[J.Automatic=1]="Automatic"})(zi||(e.InlineCompletionTriggerKind=zi={}));let Si=class{constructor(B,ge){this.range=B,this.text=ge}};e.$NK=Si,e.$NK=Si=Je([L],Si);let Ci=class{constructor(B,ge,Fe=!0){this.range=B,this.variableName=ge,this.caseSensitiveLookup=Fe}};e.$OK=Ci,e.$OK=Ci=Je([L],Ci);let $i=class{constructor(B,ge){this.range=B,this.expression=ge}};e.$PK=$i,e.$PK=$i=Je([L],$i);let Ii=class{constructor(B,ge){this.frameId=B,this.stoppedLocation=ge}};e.$QK=Ii,e.$QK=Ii=Je([L],Ii);var Pi;(function(J){J[J.Changed=1]="Changed",J[J.Created=2]="Created",J[J.Deleted=3]="Deleted"})(Pi||(e.FileChangeType=Pi={}));let ei=v=class extends Error{static FileExists(B){return new v(B,$.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(B){return new v(B,$.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(B){return new v(B,$.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(B){return new v(B,$.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(B){return new v(B,$.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(B){return new v(B,$.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(B,ge=$.FileSystemProviderErrorCode.Unknown,Fe){super(b.URI.isUri(B)?B.toString(!0):B),this.code=Fe?.name??"Unknown",(0,$.$7j)(this,ge),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof Fe=="function"&&Error.captureStackTrace(this,Fe)}};e.$RK=ei,e.$RK=ei=v=Je([L],ei);let Ai=class{constructor(B,ge,Fe){this.start=B,this.end=ge,this.kind=Fe}};e.$SK=Ai,e.$SK=Ai=Je([L],Ai);var bi;(function(J){J[J.Comment=1]="Comment",J[J.Imports=2]="Imports",J[J.Region=3]="Region"})(bi||(e.FoldingRangeKind=bi={}));var pi;(function(J){J[J.Collapsed=0]="Collapsed",J[J.Expanded=1]="Expanded"})(pi||(e.CommentThreadCollapsibleState=pi={}));var ji;(function(J){J[J.Editing=0]="Editing",J[J.Preview=1]="Preview"})(ji||(e.CommentMode=ji={}));var Ui;(function(J){J[J.Published=0]="Published",J[J.Draft=1]="Draft"})(Ui||(e.CommentState=Ui={}));var oi;(function(J){J[J.Unresolved=0]="Unresolved",J[J.Resolved=1]="Resolved"})(oi||(e.CommentThreadState=oi={}));class xi{constructor(B,ge=[]){this.tokenTypes=B,this.tokenModifiers=ge}}e.$TK=xi;function en(J){return typeof J>"u"||(0,E.$ke)(J)}class Li{constructor(B){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,B){this.l=!0;for(let ge=0,Fe=B.tokenTypes.length;ge<Fe;ge++)this.j.set(B.tokenTypes[ge],ge);for(let ge=0,Fe=B.tokenModifiers.length;ge<Fe;ge++)this.k.set(B.tokenModifiers[ge],ge)}}push(B,ge,Fe,Ke,Xe){if(typeof B=="number"&&typeof ge=="number"&&typeof Fe=="number"&&typeof Ke=="number"&&(typeof Xe=="number"||typeof Xe>"u"))return typeof Xe>"u"&&(Xe=0),this.n(B,ge,Fe,Ke,Xe);if(W.isRange(B)&&typeof ge=="string"&&en(Fe))return this.m(B,ge,Fe);throw(0,F.$5)()}m(B,ge,Fe){if(!this.l)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ge))throw new Error("`tokenType` is not in the provided legend");const Ke=B.start.line,Xe=B.start.character,ot=B.end.character-B.start.character,lt=this.j.get(ge);let Ut=0;if(Fe)for(const Jt of Fe){if(!this.k.has(Jt))throw new Error("`tokenModifier` is not in the provided legend");const Yt=this.k.get(Jt);Ut|=1<<Yt>>>0}this.n(Ke,Xe,ot,lt,Ut)}n(B,ge,Fe,Ke,Xe){if(this.f&&(B<this.c||B===this.c&&ge<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Jt=0,Yt=0;for(let _t=0;_t<Ut;_t++){let ti=this.g[5*_t],Mi=this.g[5*_t+1];ti===0?(ti=Jt,Mi+=Yt):ti+=Jt,this.g[5*_t]=ti,this.g[5*_t+1]=Mi,Jt=ti,Yt=Mi}}let ot=B,lt=ge;this.f&&this.h>0&&(ot-=this.c,ot===0&&(lt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=lt,this.g[this.h++]=Fe,this.g[this.h++]=Ke,this.g[this.h++]=Xe,this.c=B,this.e=ge}static o(B){const ge=[],Fe=B.length/5|0;for(let lt=0;lt<Fe;lt++)ge[lt]=lt;ge.sort((lt,Ut)=>{const Jt=B[5*lt],Yt=B[5*Ut];if(Jt===Yt){const _t=B[5*lt+1],ti=B[5*Ut+1];return _t-ti}return Jt-Yt});const Ke=new Uint32Array(B.length);let Xe=0,ot=0;for(let lt=0;lt<Fe;lt++){const Ut=5*ge[lt],Jt=B[Ut+0],Yt=B[Ut+1],_t=B[Ut+2],ti=B[Ut+3],Mi=B[Ut+4],yn=Jt-Xe,Nn=yn===0?Yt-ot:Yt,Ni=5*lt;Ke[Ni+0]=yn,Ke[Ni+1]=Nn,Ke[Ni+2]=_t,Ke[Ni+3]=ti,Ke[Ni+4]=Mi,Xe=Jt,ot=Yt}return Ke}build(B){return this.f?new Xt(new Uint32Array(this.g),B):new Xt(Li.o(this.g),B)}}e.$UK=Li;class Xt{constructor(B,ge){this.resultId=ge,this.data=B}}e.$VK=Xt;class tn{constructor(B,ge,Fe){this.start=B,this.deleteCount=ge,this.data=Fe}}e.$WK=tn;class nn{constructor(B,ge){this.resultId=ge,this.edits=B}}e.$XK=nn;var Ri;(function(J){J[J.Separate=0]="Separate",J[J.MergeWithParent=1]="MergeWithParent"})(Ri||(e.DebugConsoleMode=Ri={}));let Fi=class{static{this.Back={iconPath:new Ht("arrow-left")}}constructor(){}};e.$YK=Fi,e.$YK=Fi=Je([L],Fi);var Bi;(function(J){J[J.Separator=-1]="Separator",J[J.Default=0]="Default"})(Bi||(e.QuickPickItemKind=Bi={}));var Wi;(function(J){J[J.Info=1]="Info",J[J.Warning=2]="Warning",J[J.Error=3]="Error"})(Wi||(e.InputBoxValidationSeverity=Wi={}));var wi;(function(J){J[J.UI=1]="UI",J[J.Workspace=2]="Workspace"})(wi||(e.ExtensionKind=wi={}));class qi{static validate(B){if(typeof B.badge=="string"){let ge=(0,m.$Wd)(B.badge,0);if(ge<B.badge.length&&(ge+=(0,m.$Wd)(B.badge,ge)),B.badge.length>ge)throw new Error("The 'badge'-property must be undefined or a short character")}else if(B.badge&&!Ht.isThemeIcon(B.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty");return!0}constructor(B,ge,Fe){this.badge=B,this.tooltip=ge,this.color=Fe}}e.$ZK=qi;let ze=class{constructor(B){this.kind=B}};e.$1K=ze,e.$1K=ze=Je([L],ze);var Gt;(function(J){J[J.Light=1]="Light",J[J.Dark=2]="Dark",J[J.HighContrast=3]="HighContrast",J[J.HighContrastLight=4]="HighContrastLight"})(Gt||(e.ColorThemeKind=Gt={}));class Zt{static isNotebookRange(B){return B instanceof Zt?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(B,ge){if(B<0)throw(0,F.$5)("start must be positive");if(ge<0)throw(0,F.$5)("end must be positive");B<=ge?(this.c=B,this.e=ge):(this.c=ge,this.e=B)}with(B){let ge=this.c,Fe=this.e;return B.start!==void 0&&(ge=B.start),B.end!==void 0&&(Fe=B.end),ge===this.c&&Fe===this.e?this:new Zt(ge,Fe)}}e.$2K=Zt;class mt{static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(ge=>mt.isNotebookCellData(ge))}static isNotebookCellData(B){return!0}constructor(B,ge,Fe,Ke,Xe,ot,lt){this.kind=B,this.value=ge,this.languageId=Fe,this.mime=Ke,this.outputs=Xe??[],this.metadata=ot,this.executionSummary=lt,mt.validate(this)}}e.$3K=mt;class rn{constructor(B){this.cells=B}}e.$4K=rn;class Vt{static isNotebookCellOutputItem(B){return B instanceof Vt?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const ge={name:B.name,message:B.message,stack:B.stack};return Vt.json(ge,"application/vnd.code.notebook.error")}static stdout(B){return Vt.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return Vt.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,ge="application/octet-stream"){return new Vt(B,ge)}static#e=new TextEncoder;static text(B,ge=P.$ur.text){const Fe=Vt.#e.encode(String(B));return new Vt(Fe,ge)}static json(B,ge="text/x-json"){const Fe=JSON.stringify(B,void 0,"	");return Vt.text(Fe,ge)}constructor(B,ge){this.data=B,this.mime=ge;const Fe=(0,P.$yr)(ge,!0);if(!Fe)throw new Error(`INVALID mime type: ${ge}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Fe}}e.$5K=Vt;class ci{static isNotebookCellOutput(B){return B instanceof ci?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&Array.isArray(B.items)}static ensureUniqueMimeTypes(B,ge=!1){const Fe=new Set,Ke=new Set;for(let Xe=0;Xe<B.length;Xe++){const ot=B[Xe],lt=(0,P.$yr)(ot.mime);if(!Fe.has(lt)||(0,S.$IH)(lt)){Fe.add(lt);continue}Ke.add(Xe),ge&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ke.size===0?B:B.filter((Xe,ot)=>!Ke.has(ot))}constructor(B,ge,Fe){this.items=ci.ensureUniqueMimeTypes(B,!0),typeof ge=="string"?(this.id=ge,this.metadata=Fe):(this.id=(0,R.$6e)(),this.metadata=ge??Fe)}}e.$6K=ci;var Vi;(function(J){J[J.Markup=1]="Markup",J[J.Code=2]="Code"})(Vi||(e.NotebookCellKind=Vi={}));var ui;(function(J){J[J.Idle=1]="Idle",J[J.Pending=2]="Pending",J[J.Executing=3]="Executing"})(ui||(e.NotebookCellExecutionState=ui={}));var Ji;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(Ji||(e.NotebookCellStatusBarAlignment=Ji={}));var Hi;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(Hi||(e.NotebookEditorRevealType=Hi={}));class sn{constructor(B,ge){this.text=B,this.alignment=ge}}e.$7K=sn;var Ti;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred"})(Ti||(e.NotebookControllerAffinity=Ti={}));var Ki;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred",J[J.Hidden=-1]="Hidden"})(Ki||(e.NotebookControllerAffinity2=Ki={}));class on{constructor(B,ge=[]){this.uri=B,this.provides=(0,k.$Jf)(ge)}}e.$8K=on;class an{constructor(B){this.label=B}}e.$9K=an;let Oi=class{constructor(B,ge){this.label=B,this.timestamp=ge}};e.$0K=Oi,e.$0K=Oi=Je([L],Oi);var Gi;(function(J){J[J.Production=1]="Production",J[J.Development=2]="Development",J[J.Test=3]="Test"})(Gi||(e.ExtensionMode=Gi={}));var Zi;(function(J){J[J.Node=1]="Node",J[J.Webworker=2]="Webworker"})(Zi||(e.ExtensionRuntime=Zi={}));var Yi;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(Yi||(e.StandardTokenType=Yi={}));class cn{constructor(B,ge){this.ranges=B,this.wordPattern=ge}}e.$$K=cn;class un{constructor(B){this.c=B}get autoForwardAction(){return this.c}}e.$_K=un;var me;(function(J){J[J.Queued=1]="Queued",J[J.Running=2]="Running",J[J.Passed=3]="Passed",J[J.Failed=4]="Failed",J[J.Skipped=5]="Skipped",J[J.Errored=6]="Errored"})(me||(e.TestResultState=me={}));var De;(function(J){J[J.Run=1]="Run",J[J.Debug=2]="Debug",J[J.Coverage=3]="Coverage"})(De||(e.TestRunProfileKind=De={}));let Me=class{constructor(B=void 0,ge=void 0,Fe=void 0,Ke=!1){this.include=B,this.exclude=ge,this.profile=Fe,this.continuous=Ke}};e.$aL=Me,e.$aL=Me=Je([L],Me);let nt=class extends Me{};e.$bL=nt,e.$bL=nt=Je([L],nt);let yt=l=class{static diff(B,ge,Fe){const Ke=new l(B);return Ke.expectedOutput=ge,Ke.actualOutput=Fe,Ke}constructor(B){this.message=B}};e.$cL=yt,e.$cL=yt=l=Je([L],yt);let Pt=class{constructor(B){this.id=B}};e.$dL=Pt,e.$dL=Pt=Je([L],Pt);let vi=class{constructor(B,ge){this.covered=B,this.total=ge}};e.$eL=vi,e.$eL=vi=Je([L],vi);let ln=w=class{static fromDetails(B,ge){const Fe=new vi(0,0),Ke=new vi(0,0),Xe=new vi(0,0);for(const lt of ge)if("branches"in lt){Fe.total+=1,Fe.covered+=lt.executionCount>0?1:0;for(const Ut of lt.branches)Ke.total+=1,Ke.covered+=Ut.executionCount>0?1:0}else Xe.total+=1,Xe.covered+=lt.executionCount>0?1:0;const ot=new w(B,Fe,Ke.total>0?Ke:void 0,Xe.total>0?Xe:void 0);return ot.detailedCoverage=ge,ot}constructor(B,ge,Fe,Ke){this.uri=B,this.statementCoverage=ge,this.branchCoverage=Fe,this.functionCoverage=Ke}};e.$fL=ln,e.$fL=ln=w=Je([L],ln);let hn=class{constructor(B,ge,Fe=[]){this.executionCount=B,this.location=ge,this.branches=Fe}};e.$gL=hn,e.$gL=hn=Je([L],hn);let dn=class{constructor(B,ge){this.executionCount=B,this.location=ge}};e.$hL=dn,e.$hL=dn=Je([L],dn);let fn=class{constructor(B,ge){this.executionCount=B,this.location=ge}};e.$iL=fn,e.$iL=fn=Je([L],fn);var gn;(function(J){J[J.None=0]="None",J[J.Option=1]="Option",J[J.Default=2]="Default",J[J.Preferred=3]="Preferred"})(gn||(e.ExternalUriOpenerPriority=gn={}));var $n;(function(J){J[J.Untrusted=0]="Untrusted",J[J.Trusted=1]="Trusted",J[J.Unspecified=2]="Unspecified"})($n||(e.WorkspaceTrustState=$n={}));var bn;(function(J){J[J.Notify=1]="Notify",J[J.OpenBrowser=2]="OpenBrowser",J[J.OpenPreview=3]="OpenPreview",J[J.Silent=4]="Silent",J[J.Ignore=5]="Ignore",J[J.OpenBrowserOnce=6]="OpenBrowserOnce"})(bn||(e.PortAutoForwardAction=bn={}));class Cn{constructor(B,ge,Fe,Ke,Xe,ot){this.kind=B,this.name=ge,this.detail=Fe,this.uri=Ke,this.range=Xe,this.selectionRange=ot}}e.$jL=Cn;class In{constructor(B){this.uri=B}}e.$kL=In;class Pn{constructor(B,ge){this.original=B,this.modified=ge}}e.$lL=Pn;class An{constructor(B,ge,Fe,Ke){this.base=B,this.input1=ge,this.input2=Fe,this.result=Ke}}e.$mL=An;class Ln{constructor(B,ge){this.uri=B,this.viewType=ge}}e.$nL=Ln;class Rn{constructor(B){this.viewType=B}}e.$oL=Rn;class Fn{constructor(B,ge){this.uri=B,this.notebookType=ge}}e.$pL=Fn;class Tn{constructor(B,ge,Fe){this.original=B,this.modified=ge,this.notebookType=Fe}}e.$qL=Tn;class On{constructor(){}}e.$rL=On;class Mn{constructor(B,ge){this.uri=B,this.inputBoxUri=ge}}e.$sL=Mn;var pn;(function(J){J[J.Up=1]="Up",J[J.Down=2]="Down"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var wn;(function(J){J[J.Action=1]="Action",J[J.Toolbar=2]="Toolbar"})(wn||(e.InteractiveSessionCopyKind=wn={}));var vn;(function(J){J[J.Unhelpful=0]="Unhelpful",J[J.Helpful=1]="Helpful",J[J.Undone=2]="Undone",J[J.Accepted=3]="Accepted"})(vn||(e.InteractiveEditorResponseFeedbackKind=vn={}))}),define(Se[135],Ce([1,0,53,15,12,164,116,7,19]),function(fe,e,k,F,h,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HL=e.$GL=e.$FL=void 0;const b=new Map;function R(S,p){p?b.set(S,p):b.delete(S)}e.$FL=R;function I(S){return b.get(S)}class $ extends A.$wu{constructor(p,r,s,c,f,y,C,i){super(r,s,c,f),this.c=p,this.m=y,this.q=C,this.notebook=i,this.b=!1}dispose(){(0,k.ok)(!this.b),this.b=!0,this.q=!1}equalLines(p){return(0,E.$bf)(this.f,p)}get document(){if(!this.a){const p=this;this.a={get uri(){return p.d},get fileName(){return p.d.fsPath},get isUntitled(){return p.d.scheme===F.Schemas.untitled},get languageId(){return p.m},get version(){return p.h},get isClosed(){return p.b},get isDirty(){return p.q},save(){return p.r()},getText(r){return r?p.s(r):p.getText()},get eol(){return p.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return p.f.length},lineAt(r){return p.t(r)},offsetAt(r){return p.u(r)},positionAt(r){return p.v(r)},validateRange(r){return p.w(r)},validatePosition(r){return p.x(r)},getWordRangeAtPosition(r,s){return p.y(r,s)}}}return Object.freeze(this.a)}_acceptLanguageId(p){(0,k.ok)(!this.b),this.m=p}_acceptIsDirty(p){(0,k.ok)(!this.b),this.q=p}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(p){const r=this.w(p);if(r.isEmpty)return"";if(r.isSingleLine)return this.f[r.start.line].substring(r.start.character,r.end.character);const s=this.g,c=r.start.line,f=r.end.line,y=[];y.push(this.f[c].substring(r.start.character));for(let C=c+1;C<f;C++)y.push(this.f[C]);return y.push(this.f[f].substring(0,r.end.character)),y.join(s)}t(p){let r;if(p instanceof m.$EJ?r=p.line:typeof p=="number"&&(r=p),typeof r!="number"||r<0||r>=this.f.length||Math.floor(r)!==r)throw new Error("Illegal value for `line`");return new D(r,this.f[r],r===this.f.length-1)}u(p){return p=this.x(p),this.l(),this.j.getPrefixSum(p.line-1)+p.character}v(p){p=Math.floor(p),p=Math.max(0,p),this.l();const r=this.j.getIndexOf(p),s=this.f[r.index].length;return new m.$EJ(r.index,Math.min(r.remainder,s))}w(p){if(!(p instanceof m.$FJ))throw new Error("Invalid argument");const r=this.x(p.start),s=this.x(p.end);return r===p.start&&s===p.end?p:new m.$FJ(r.line,r.character,s.line,s.character)}x(p){if(!(p instanceof m.$EJ))throw new Error("Invalid argument");if(this.f.length===0)return p.with(0,0);let{line:r,character:s}=p,c=!1;if(r<0)r=0,s=0,c=!0;else if(r>=this.f.length)r=this.f.length-1,s=this.f[r].length,c=!0;else{const f=this.f[r].length;s<0?(s=0,c=!0):s>f&&(s=f,c=!0)}return c?new m.$EJ(r,s):p}y(p,r){const s=this.x(p);if(!r)r=I(this.m);else if((0,h.$xd)(r))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${r.source}' because it matches the empty string.`);const c=(0,P.$Mr)(s.character+1,(0,P.$Kr)(r),this.f[s.line],0);if(c)return new m.$FJ(s.line,c.startColumn-1,s.line,c.endColumn-1)}}e.$GL=$;class D{constructor(p,r,s){this.a=p,this.b=r,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$FJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$FJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$HL=D}),define(Se[259],Ce([1,0,7,20,3]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=void 0;let A=class{constructor(m){this.a=new k.$1K(k.ColorThemeKind.Dark),this.b=new h.$8c}get activeColorTheme(){return this.a}$onColorThemeChange(m){let E;switch(m){case"light":E=k.ColorThemeKind.Light;break;case"hcDark":E=k.ColorThemeKind.HighContrast;break;case"hcLight":E=k.ColorThemeKind.HighContrastLight;break;default:E=k.ColorThemeKind.Dark}this.a=new k.$1K(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$oac=A,e.$oac=A=Je([qe(0,F.$DL)],A)}),define(Se[260],Ce([1,0,5]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MH=e.CellExecutionUpdateType=void 0;var F;(function(h){h[h.Output=1]="Output",h[h.OutputItems=2]="OutputItems",h[h.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$MH=(0,k.$ph)("INotebookExecutionService")}),define(Se[59],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nI=e.TestPosition=e.TestIdPathParts=void 0;var k;(function(A){A.Delimiter="\0"})(k||(e.TestIdPathParts=k={}));var F;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class h{static fromExtHostTestItem(P,m,E=P.parent){if(P._isRoot)return new h([m]);const b=[P.id];for(let R=E;R&&R.id!==m;R=R.parent)b.push(R.id);return b.push(m),new h(b.reverse())}static isRoot(P){return!P.includes("\0")}static root(P){const m=P.indexOf("\0");return m===-1?P:P.slice(0,m)}static fromString(P){return new h(P.split("\0"))}static join(P,m){return new h([...P.path,m])}static joinToString(P,m){return P.toString()+"\0"+m}static parentId(P){const m=P.lastIndexOf("\0");return m===-1?void 0:P.slice(0,m)}static localId(P){const m=P.lastIndexOf("\0");return m===-1?P:P.slice(m+1)}static isChild(P,m){return m.startsWith(P)&&m[P.length]==="\0"}static compare(P,m){return P===m?0:h.isChild(P,m)?2:h.isChild(m,P)?3:1}constructor(P,m=P.length){if(this.path=P,this.d=m,P.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new h(this.path,1)}get parentId(){return this.d>1?new h(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let P=1;P<=this.d;P++)yield new h(this.path,P)}*idsToRoot(){for(let P=this.d;P>0;P--)yield new h(this.path,P)}compare(P){if(typeof P=="string")return h.compare(this.toString(),P);for(let m=0;m<P.d&&m<this.d;m++)if(P.path[m]!==this.path[m])return 1;return P.d>this.d?2:P.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let P=1;P<this.d;P++)this.c+="\0",this.c+=this.path[P]}return this.c}}e.$nI=h}),define(Se[82],Ce([1,0,2,33,59]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$tI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$sI=e.$rI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$qI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$pI=e.$oI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(d){d[d.Unset=0]="Unset",d[d.Queued=1]="Queued",d[d.Running=2]="Running",d[d.Passed=3]="Passed",d[d.Failed=4]="Failed",d[d.Skipped=5]="Skipped",d[d.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var P;(function(d){d[d.Run=1]="Run",d[d.Debug=2]="Debug",d[d.Coverage=3]="Coverage"})(P||(e.ExtTestRunProfileKind=P={}));var m;(function(d){d[d.Run=2]="Run",d[d.Debug=4]="Debug",d[d.Coverage=8]="Coverage",d[d.HasNonDefaultProfile=16]="HasNonDefaultProfile",d[d.HasConfigurable=32]="HasConfigurable",d[d.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$oI=[2,4,8,16,32,64];const E=d=>"runId"in d;e.$pI=E;var b;(function(d){d.serialize=v=>({range:v.range.toJSON(),uri:v.uri.toJSON()}),d.deserialize=v=>({range:F.$Or.lift(v.range),uri:k.URI.revive(v.uri)})})(b||(e.IRichLocation=b={}));var R;(function(d){d[d.Error=0]="Error",d[d.Output=1]="Output"})(R||(e.TestMessageType=R={}));var I;(function(d){d.serialize=v=>({message:v.message,type:0,expected:v.expected,actual:v.actual,location:v.location&&b.serialize(v.location)}),d.deserialize=v=>({message:v.message,type:0,expected:v.expected,actual:v.actual,location:v.location&&b.deserialize(v.location)})})(I||(e.ITestErrorMessage=I={}));const $=(d,v)=>`${v?"s":"e"}${d}`;e.$qI=$;var D;(function(d){d.serialize=v=>({message:v.message,type:1,offset:v.offset,length:v.length,location:v.location&&b.serialize(v.location)}),d.deserialize=v=>({message:v.message,type:1,offset:v.offset,length:v.length,location:v.location&&b.deserialize(v.location)})})(D||(e.ITestOutputMessage=D={}));var S;(function(d){d.serialize=v=>v.type===0?I.serialize(v):D.serialize(v),d.deserialize=v=>v.type===0?I.deserialize(v):D.deserialize(v)})(S||(e.ITestMessage=S={}));var p;(function(d){d.serializeWithoutMessages=v=>({state:v.state,duration:v.duration,messages:[]}),d.serialize=v=>({state:v.state,duration:v.duration,messages:v.messages.map(S.serialize)}),d.deserialize=v=>({state:v.state,duration:v.duration,messages:v.messages.map(S.deserialize)})})(p||(e.ITestTaskState=p={}));const r="\0",s=(d,v)=>d+r+v;e.$rI=s;const c=d=>{const v=d.indexOf(r);return{ctrlId:d.slice(0,v),tagId:d.slice(v+1)}};e.$sI=c;var f;(function(d){d.serialize=v=>({extId:v.extId,label:v.label,tags:v.tags,busy:v.busy,children:void 0,uri:v.uri?.toJSON(),range:v.range?.toJSON()||null,description:v.description,error:v.error,sortText:v.sortText}),d.deserialize=v=>({extId:v.extId,label:v.label,tags:v.tags,busy:v.busy,children:void 0,uri:v.uri?k.URI.revive(v.uri):void 0,range:v.range?F.$Or.lift(v.range):null,description:v.description,error:v.error,sortText:v.sortText})})(f||(e.ITestItem=f={}));var y;(function(d){d[d.NotExpandable=0]="NotExpandable",d[d.Expandable=1]="Expandable",d[d.BusyExpanding=2]="BusyExpanding",d[d.Expanded=3]="Expanded"})(y||(e.TestItemExpandState=y={}));var C;(function(d){d.serialize=v=>({expand:v.expand,item:f.serialize(v.item)}),d.deserialize=v=>({controllerId:h.$nI.root(v.item.extId),expand:v.expand,item:f.deserialize(v.item)})})(C||(e.InternalTestItem=C={}));var i;(function(d){d.serialize=v=>{let l;return v.item&&(l={},v.item.label!==void 0&&(l.label=v.item.label),v.item.tags!==void 0&&(l.tags=v.item.tags),v.item.busy!==void 0&&(l.busy=v.item.busy),v.item.uri!==void 0&&(l.uri=v.item.uri?.toJSON()),v.item.range!==void 0&&(l.range=v.item.range?.toJSON()),v.item.description!==void 0&&(l.description=v.item.description),v.item.error!==void 0&&(l.error=v.item.error),v.item.sortText!==void 0&&(l.sortText=v.item.sortText)),{extId:v.extId,expand:v.expand,item:l}},d.deserialize=v=>{let l;return v.item&&(l={},v.item.label!==void 0&&(l.label=v.item.label),v.item.tags!==void 0&&(l.tags=v.item.tags),v.item.busy!==void 0&&(l.busy=v.item.busy),v.item.range!==void 0&&(l.range=v.item.range?F.$Or.lift(v.item.range):null),v.item.description!==void 0&&(l.description=v.item.description),v.item.error!==void 0&&(l.error=v.item.error),v.item.sortText!==void 0&&(l.sortText=v.item.sortText)),{extId:v.extId,expand:v.expand,item:l}}})(i||(e.ITestItemUpdate=i={}));const o=(d,v)=>{v.expand!==void 0&&(d.expand=v.expand),v.item!==void 0&&(d.item=d.item?Object.assign(d.item,v.item):v.item)};e.$tI=o;var n;(function(d){d.serializeWithoutMessages=v=>({...C.serialize(v),ownComputedState:v.ownComputedState,computedState:v.computedState,tasks:v.tasks.map(p.serializeWithoutMessages)}),d.serialize=v=>({...C.serialize(v),ownComputedState:v.ownComputedState,computedState:v.computedState,tasks:v.tasks.map(p.serialize)}),d.deserialize=v=>({...C.deserialize(v),ownComputedState:v.ownComputedState,computedState:v.computedState,tasks:v.tasks.map(p.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var t;(function(d){d[d.Function=0]="Function",d[d.Statement=1]="Statement"})(t||(e.DetailType=t={}));var a;(function(d){d[d.Add=0]="Add",d[d.Update=1]="Update",d[d.DocumentSynced=2]="DocumentSynced",d[d.Remove=3]="Remove",d[d.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",d[d.Retire=5]="Retire",d[d.AddTag=6]="AddTag",d[d.RemoveTag=7]="RemoveTag"})(a||(e.TestDiffOpType=a={}));var g;(function(d){d.deserialize=v=>v.op===0?{op:v.op,item:C.deserialize(v.item)}:v.op===1?{op:v.op,item:i.deserialize(v.item)}:v.op===2?{op:v.op,uri:k.URI.revive(v.uri),docv:v.docv}:v,d.serialize=v=>v.op===0?{op:v.op,item:C.serialize(v.item)}:v.op===1?{op:v.op,item:i.serialize(v.item)}:v})(g||(e.TestsDiffOp=g={}));class u{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(v){const l=this.o();for(const w of v)switch(w.op){case 0:this.j(C.deserialize(w.item),l);break;case 1:this.k(i.deserialize(w.item),l);break;case 3:this.l(w.itemId,l);break;case 5:this.m(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.c.set(w.tag.id,w.tag);break;case 7:this.c.delete(w.id);break}l.complete?.()}j(v,l){const w=h.$nI.parentId(v.item.extId)?.toString();let L;if(!w)L=this.p(v),this.f.add(L),this.d.set(v.item.extId,L);else if(this.d.has(w)){const O=this.d.get(w);O.children.add(v.item.extId),L=this.p(v,O),this.d.set(v.item.extId,L)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(v)}`);return}return l.add?.(L),v.expand===2&&this.g++,L}k(v,l){const w=this.d.get(v.extId);if(w)return v.expand!==void 0&&(w.expand===2&&this.g--,v.expand===2&&this.g++),(0,e.$tI)(w,v),l.update?.(w),w}l(v,l){const w=this.d.get(v);if(!w)return;const L=h.$nI.parentId(w.item.extId)?.toString();L?this.d.get(L).children.delete(w.item.extId):this.f.delete(w);const O=[[v]];for(;O.length;)for(const N of O.pop()){const T=this.d.get(N);T&&(O.push(T.children),this.d.delete(N),l.remove?.(T,T!==w),T.expand===2&&this.g--)}}m(v){}updatePendingRoots(v){this.h+=v}o(){return{}}}e.$uI=u}),define(Se[103],Ce([1,0,17,3,4,53,82,59]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.TestItemEventOp=void 0;var E;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const b=(c,f)=>c===f,I=Object.entries({range:(c,f)=>c===f?!0:!c||!f?!1:c.equalsRange(f),busy:b,label:b,description:b,error:b,sortText:b,tags:(c,f)=>!(c.length!==f.length||c.some(y=>!f.includes(y)))}),$=(c,f)=>{let y;for(const[C,i]of I)i(c[C],f[C])||(y?y[C]=f[C]:y={[C]:f[C]});return y};class D extends h.$lb{get root(){return this.m.root}constructor(f){super(),this.m=f,this.f=this.B(new k.$Gg(()=>this.flushDiff(),200)),this.g=this.B(new F.$8c),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(f){this.h=f;for(const y of this.tree.values())this.G(y)}get resolveHandler(){return this.h}collectDiff(){const f=this.k;return this.k=[],f}pushDiff(f){switch(f.op){case 2:{for(const y of this.k)if(y.op===2&&y.uri===f.uri){y.docv=f.docv;return}break}case 1:{const y=this.k[this.k.length-1];if(y){if(y.op===1&&y.item.extId===f.item.extId){(0,P.$tI)(y.item,f.item);return}if(y.op===0&&y.item.item.extId===f.item.extId){(0,P.$tI)(y.item,f.item);return}}break}}this.k.push(f),this.f.isScheduled()||this.f.schedule()}expand(f,y){const C=this.tree.get(f);if(C){if((C.expandLevels===void 0||y>C.expandLevels)&&(C.expandLevels=y),C.expand===1){const i=this.I(C);return i.isOpen()?this.H(C,y-1):i.wait().then(()=>this.H(C,y-1))}else if(C.expand===3)return C.resolveBarrier?.isOpen()===!1?C.resolveBarrier.wait().then(()=>this.H(C,y-1)):this.H(C,y-1)}}dispose(){for(const f of this.tree.values())this.m.getApiFor(f.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(f,y){switch(y.op){case 3:this.L(m.$nI.joinToString(f.fullId,y.id));break;case 0:this.u(y.item,f);break;case 5:for(const C of y.ops)this.p(f,C);break;case 1:this.w(y.new,y.old,f.fullId.toString());break;case 2:this.G(f);break;case 4:this.pushDiff({op:1,item:{extId:f.fullId.toString(),item:y.update}});break;case 6:this.s(f.actual.uri);break;default:(0,A.$nc)(y)}}s(f){f&&this.pushDiff({op:2,uri:f,docv:this.m.getDocumentVersion(f)})}u(f,y){const C=m.$nI.fromExtHostTestItem(f,this.root.id,y?.actual),i=this.m.getApiFor(f);i.parent&&i.parent!==y?.actual&&this.m.getChildren(i.parent).delete(f.id);let o=this.tree.get(C.toString());if(!o){o={fullId:C,actual:f,expandLevels:y?.expandLevels?y.expandLevels-1:void 0,expand:0},f.tags.forEach(this.y,this),this.tree.set(o.fullId.toString(),o),this.C(f,y),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:o.expand,item:this.m.toITestItem(f)}}),this.F(f,o,y);return}if(o.actual===f){this.D(f,o,y);return}if(o.actual.uri?.toString()!==f.uri?.toString())return this.L(C.toString()),this.u(f,y);const n=this.m.getChildren(o.actual),t=o.actual,a=$(this.m.toITestItem(t),this.m.toITestItem(f));this.m.getApiFor(t).listener=void 0,o.actual=f,o.expand=0,a&&(a.hasOwnProperty("tags")&&(this.w(f.tags,t.tags,C.toString()),delete a.tags),this.p(o,{op:4,update:a})),this.F(f,o,y);for(const[g,u]of n)this.m.getChildren(f).get(u.id)||this.L(m.$nI.joinToString(C,u.id));this.s(o.actual.uri)}w(f,y,C){const i=new Set(y.map(o=>o.id));for(const o of f)i.delete(o.id)||this.y(o);this.pushDiff({op:1,item:{extId:C,item:{tags:f.map(o=>(0,P.$rI)(this.m.controllerId,o.id))}}}),i.forEach(this.z,this)}y(f){const y=this.j.get(f.id);y?y.refCount++:(this.j.set(f.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,P.$rI)(this.m.controllerId,f.id)}}))}z(f){const y=this.j.get(f);y&&!--y.refCount&&(this.j.delete(f),this.pushDiff({op:7,id:(0,P.$rI)(this.m.controllerId,f)}))}C(f,y){this.m.getApiFor(f).parent=y&&y.actual!==this.root?y.actual:void 0}D(f,y,C){this.C(f,C);const i=this.m.getApiFor(f);i.parent=C?.actual,i.listener=o=>this.p(y,o),this.G(y)}F(f,y,C){this.D(f,y,C);for(const[i,o]of this.m.getChildren(f))this.u(o,y)}G(f){let y;this.h?f.resolveBarrier?y=f.resolveBarrier.isOpen()?3:2:y=f.actual.canResolveChildren?1:0:y=0,y!==f.expand&&(f.expand=y,this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:y}}),y===1&&f.expandLevels!==void 0&&this.I(f))}H(f,y){if(y<0)return;const C=[];for(const[i,o]of this.m.getChildren(f.actual)){const n=this.expand(m.$nI.joinToString(f.fullId,o.id),y);(0,k.$ig)(n)&&C.push(n)}if(C.length)return Promise.all(C).then(()=>{})}I(f){if(f.resolveBarrier)return f.resolveBarrier;if(!this.h){const o=new k.$ug;return o.open(),o}f.expand=2,this.J(f);const y=f.resolveBarrier=new k.$ug,C=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,o)};let i;try{i=this.h(f.actual===this.root?void 0:f.actual)}catch(o){C(o)}return(0,k.$ig)(i)?i.catch(C).then(()=>{y.open(),this.G(f)}):(y.open(),this.G(f)),f.resolveBarrier}J(f){this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:f.expand}})}L(f){const y=this.tree.get(f);if(!y)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:f});const C=[y];for(;C.length;){const i=C.pop();if(i){this.m.getApiFor(i.actual).listener=void 0;for(const o of i.actual.tags)this.z(o.id);this.tree.delete(i.fullId.toString());for(const[o,n]of this.m.getChildren(i.actual))C.push(this.tree.get(m.$nI.joinToString(i.fullId,n.id)))}}}flushDiff(){const f=this.collectDiff();f.length&&this.g.fire(f)}}e.$tL=D;class S extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.$uL=S;class p extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$vL=p;class r extends Error{constructor(f,y,C){super(`TestItem with ID "${f}" is from controller "${y}" and cannot be added as a child of an item from controller "${C}".`)}}e.$wL=r;const s=(c,f,y)=>{let C=new Map;return{get size(){return C.size},forEach(i,o){for(const n of C.values())i.call(o,n,this)},[Symbol.iterator](){return C.entries()},replace(i){const o=new Map,n=new Set(C.keys()),t={op:5,ops:[]};for(const a of i){if(!(a instanceof y))throw new p(a.id);const g=f(a).controllerId;if(g!==c.controllerId)throw new r(a.id,g,c.controllerId);if(o.has(a.id))throw new S(a.id);o.set(a.id,a),n.delete(a.id),t.ops.push({op:0,item:a})}for(const a of n.keys())t.ops.push({op:3,id:a});c.listener?.(t),C=o},add(i){if(!(i instanceof y))throw new p(i.id);C.set(i.id,i),c.listener?.({op:0,item:i})},delete(i){C.delete(i)&&c.listener?.({op:3,id:i})},get(i){return C.get(i)},toJSON(){return Array.from(C.values())}}};e.$xL=s}),define(Se[136],Ce([1,0,103]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zL=e.$yL=void 0;const F=new WeakMap,h=(P,m)=>{const E={controllerId:m};return F.set(P,E),E};e.$yL=h;const A=P=>{const m=F.get(P);if(!m)throw new k.$vL(P?.id||"<unknown>");return m};e.$zL=A}),define(Se[104],Ce([1,0,15,2]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnb=e.$knb=e.$jnb=e.$inb=e.$hnb=void 0,e.$hnb="vscode-cdn.net",e.$inb=`vscode-resource.${e.$hnb}`,e.$jnb=`'self' https://*.${e.$hnb}`;function h(m,E){return m.scheme===k.Schemas.http||m.scheme===k.Schemas.https?m:(E&&E.authority&&E.isRemote&&m.scheme===k.Schemas.file&&(m=F.URI.from({scheme:k.Schemas.vscodeRemote,authority:E.authority,path:m.path})),F.URI.from({scheme:k.Schemas.https,authority:`${m.scheme}+${A(m.authority)}.${e.$inb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$knb=h;function A(m){return m.replace(/./g,E=>{const b=E.charCodeAt(0);return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57?E:"-"+b.toString(16).padStart(4,"0")})}function P(m){return m.replace(/-([0-9a-f]{4})/g,(E,b)=>String.fromCharCode(parseInt(b,16)))}e.$lnb=P}),define(Se[261],Ce([1,0,3,4,104]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y_b=void 0;class A{constructor(m,E,b){this.d=m,this.e=E,this.f=b,this.a=0,this.b=new F.$kb,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const R=E.getVisibleTextEditors();for(const I of this.c.values())R.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,E,b,R,I){let $;for(const f of this.e.getVisibleTextEditors(!0))if(f.value===m){$=f;break}if(!$)throw new Error("not a visible editor");const D=this,S=this.a++,p=new k.$8c,r=new k.$8c,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(f){return(0,h.$knb)(f,D.f)}get cspSource(){return h.$jnb}set options(f){this.b=f,D.d.$setOptions(S,f)}get options(){return this.b}set html(f){this.a=f,D.d.$setHtml(S,f)}get html(){return this.a}get onDidReceiveMessage(){return p.event}postMessage(f){return D.d.$postMessage(S,f)}},c=new class{constructor(){this.editor=m,this.line=E,this.height=b,this.webview=s,this.onDidDispose=r.event}dispose(){D.c.has(S)&&(D.c.delete(S),D.d.$disposeEditorInset(S),r.fire(),r.dispose(),p.dispose())}};return this.d.$createEditorInset(S,$.id,$.value.document.uri,E+1,b,R||{},I.identifier,I.extensionLocation),this.c.set(S,{editor:m,inset:c,onDidReceiveMessage:p}),c}$onDidDispose(m){const E=this.c.get(m);E&&E.inset.dispose()}$onDidReceiveMessage(m,E){this.c.get(m)?.onDidReceiveMessage.fire(E)}}e.$Y_b=A}),define(Se[262],Ce([1,0,5]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.VariableKind=e.$pM=void 0,e.$pM=(0,k.$ph)("configurationResolverService");var F;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class h extends Error{constructor(P,m){super(m),this.variable=P}}e.$qM=h}),define(Se[263],Ce([1,0,13,41,14,23,11,120,213,262,12]),function(fe,e,k,F,h,A,P,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EM=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(D,S,p,r){this.h=new Map,this.a=D,this.b=S,this.g=p,r&&(this.c=r.then(s=>this.i(s)))}i(D){if(P.$i){const S=Object.create(null);return Object.keys(D).forEach(p=>{S[p.toLowerCase()]=D[p]}),S}return D}resolveWithEnvironment(D,S,p){return this.l({env:this.i(D),userHome:void 0},S?S.uri:void 0,p)}async resolveAsync(D,S){const p={env:await this.c,userHome:await this.g};return this.l(p,D?D.uri:void 0,S)}async j(D,S,p,r){const s=A.$Hm(S);P.$i&&s.windows?Object.keys(s.windows).forEach(f=>s[f]=s.windows[f]):P.$j&&s.osx?Object.keys(s.osx).forEach(f=>s[f]=s.osx[f]):P.$k&&s.linux&&Object.keys(s.linux).forEach(f=>s[f]=s.linux[f]),delete s.windows,delete s.osx,delete s.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,D?D.uri:void 0,s,p,r)}async resolveAnyAsync(D,S,p){return this.j(D,S,p)}async resolveAnyMap(D,S,p){const r=new Map;return{newConfig:await this.j(D,S,p,r),resolvedVariables:r}}resolveWithInteractionReplace(D,S,p,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,S,p,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,S){if(this.h.has(D))throw new Error("Variable "+D+" is contributed twice.");this.h.set(D,S)}async l(D,S,p,r,s){if(h.$je(p))return this.m(D,S,p,r,s);if(Array.isArray(p))return Promise.all(p.map(c=>this.l(D,S,c,r,s)));if(h.$le(p)){const c=Object.create(null),f=await Promise.all(Object.keys(p).map(async y=>[await this.m(D,S,y,r,s),await this.l(D,S,p[y],r,s)]));for(const[y,C]of f)c[y]=C;return c}return p}m(D,S,p,r,s){return(0,R.$Ed)(p,I.VARIABLE_REGEXP,async(c,f)=>{if(f.includes(I.VARIABLE_LHS))return c;let y=await this.o(D,c,f,S,r);return s?.set(f,y),y!==c&&h.$je(y)&&y.match(I.VARIABLE_REGEXP)&&(y=await this.m(D,S,y,r,s)),y})}n(D){return this.b?this.b.getUriLabel(D,{noPrefix:!0}):D.fsPath}async o(D,S,p,r,s){let c;const f=p.split(":");f.length>1&&(p=f[0],c=f[1]);const y=o=>{const n=this.a.getFilePath();if(n)return(0,m.$1z)(n);throw new b.$qM(o,(0,E.localize)(0,null,S))},C=o=>{const n=y(o);if(this.a.getWorkspaceFolderPathForFile){const t=this.a.getWorkspaceFolderPathForFile();if(t)return(0,m.$1z)(t)}throw new b.$qM(o,(0,E.localize)(1,null,S,k.$ec(n)))},i=o=>{if(c){const n=this.a.getFolderUri(c);if(n)return n;throw new b.$qM(o,(0,E.localize)(2,null,S,c))}if(r)return r;throw this.a.getWorkspaceFolderCount()>1?new b.$qM(o,(0,E.localize)(3,null,S)):new b.$qM(o,(0,E.localize)(4,null,S))};switch(p){case"env":if(c){if(D.env){const o=D.env[P.$i?c.toLowerCase():c];if(h.$je(o))return o}return""}throw new b.$qM(b.VariableKind.Env,(0,E.localize)(5,null,S));case"config":if(c){const o=this.a.getConfigurationValue(r,c);if(h.$se(o))throw new b.$qM(b.VariableKind.Config,(0,E.localize)(6,null,S,c));if(h.$le(o))throw new b.$qM(b.VariableKind.Config,(0,E.localize)(7,null,S,c));return o}throw new b.$qM(b.VariableKind.Config,(0,E.localize)(8,null,S));case"command":return this.p(b.VariableKind.Command,S,c,s,"command");case"input":return this.p(b.VariableKind.Input,S,c,s,"input");case"extensionInstallFolder":if(c){const o=await this.a.getExtension(c);if(!o)throw new b.$qM(b.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,S,c));return this.n(o.extensionLocation)}throw new b.$qM(b.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,S));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,m.$1z)(this.n(i(b.VariableKind.WorkspaceFolder)));case"cwd":return r||c?(0,m.$1z)(this.n(i(b.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$1z)(k.$ec(this.n(i(b.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(D.userHome)return D.userHome;throw new b.$qM(b.VariableKind.UserHome,(0,E.localize)(11,null,S))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new b.$qM(b.VariableKind.LineNumber,(0,E.localize)(12,null,S))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new b.$qM(b.VariableKind.SelectedText,(0,E.localize)(13,null,S))}case"file":return y(b.VariableKind.File);case"fileWorkspaceFolder":return C(b.VariableKind.FileWorkspaceFolder);case"relativeFile":return r||c?k.$cc(this.n(i(b.VariableKind.RelativeFile)),y(b.VariableKind.RelativeFile)):y(b.VariableKind.RelativeFile);case"relativeFileDirname":{const o=k.$dc(y(b.VariableKind.RelativeFileDirname));if(r||c){const n=k.$cc(this.n(i(b.VariableKind.RelativeFileDirname)),o);return n.length===0?".":n}return o}case"fileDirname":return k.$dc(y(b.VariableKind.FileDirname));case"fileExtname":return k.$fc(y(b.VariableKind.FileExtname));case"fileBasename":return k.$ec(y(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=k.$ec(y(b.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-k.$fc(o).length)}case"fileDirnameBasename":return k.$ec(k.$dc(y(b.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||S}case"execInstallFolder":{const o=this.a.getAppRoot();return o||S}case"pathSeparator":return k.sep;default:try{const o=c?`${p}:${c}`:p;return this.p(b.VariableKind.Unknown,S,o,s,void 0)}catch{return S}}}}p(D,S,p,r,s){if(p&&r){const c=s===void 0?r[p]:r[s+":"+p];if(typeof c=="string")return c;throw new b.$qM(D,(0,E.localize)(14,null,S))}return S}}e.$EM=I}),define(Se[137],Ce([1,0,5,133]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RC=e.$QC=e.OpenEditorContext=e.GroupsOrder=e.$PC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$OC=void 0,e.$OC=(0,k.$ph)("editorGroupsService");var h;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(h||(e.GroupDirection=h={}));var A;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var P;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(P||(e.GroupLocation=P={}));var m;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EVEN=1]="EVEN",S[S.TOGGLE=2]="TOGGLE"})(m||(e.GroupsArrangement=m={}));var E;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function b(S){const p=S;return(0,F.$EE)(p?.editor)&&(0,F.$EE)(p?.replacement)}e.$PC=b;var R;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var I;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function $(S){const p=S;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.$QC=$;function D(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$RC=D}),define(Se[264],Ce([1,0,5,137]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VC=e.$UC=e.$TC=e.$SC=void 0,e.$SC=(0,k.$ph)("editorService"),e.$TC=-1,e.$UC=-2;function h(A){const P=A;return typeof A=="number"||(0,F.$QC)(P)}e.$VC=h}),define(Se[16],Ce([1,0,19,22,156,67,74,28,152,73,93,23,14,2,33,77,126,136,133,102,59,82,264,7]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c,f,y,C,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$CL=e.$BL=e.MarkdownString=e.$AL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Te){function Le(ae){const{selectionStartLineNumber:Oe,selectionStartColumn:We,positionLineNumber:Ze,positionColumn:He}=ae,it=new o.$EJ(Oe-1,We-1),wt=new o.$EJ(Ze-1,He-1);return new o.$GJ(it,wt)}Te.to=Le;function Ae(ae){const{anchor:Oe,active:We}=ae;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Te.from=Ae})(n||(e.Selection=n={}));var t;(function(Te){function Le(ae){if(!ae)return;const{start:Oe,end:We}=ae;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Te.from=Le;function Ae(ae){if(!ae)return;const{startLineNumber:Oe,startColumn:We,endLineNumber:Ze,endColumn:He}=ae;return new o.$FJ(Oe-1,We-1,Ze-1,He-1)}Te.to=Ae})(t||(e.Range=t={}));var a;(function(Te){function Le(Ae){switch(Ae){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Te.to=Le})(a||(e.TokenType=a={}));var g;(function(Te){function Le(ae){return new o.$EJ(ae.lineNumber-1,ae.column-1)}Te.to=Le;function Ae(ae){return{lineNumber:ae.line+1,column:ae.character+1}}Te.from=Ae})(g||(e.Position=g={}));var u;(function(Te){function Le(Oe,We,Ze){return(0,k.$mf)((0,k.$Jf)(Oe).map(He=>Ae(He,We,Ze)))}Te.from=Le;function Ae(Oe,We,Ze){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:Ze?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:ae(Oe.scheme,We),pattern:Be.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:Ze?.isBuiltin}}function ae(Oe,We){return We&&typeof Oe=="string"?We.transformOutgoingScheme(Oe):Oe}})(u||(e.DocumentSelector=u={}));var d;(function(Te){function Le(ae){switch(ae){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Te.from=Le;function Ae(ae){switch(ae){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Te.to=Ae})(d||(e.DiagnosticTag=d={}));var v;(function(Te){function Le(ae){let Oe;return ae.code&&((0,$.$je)(ae.code)||(0,$.$ne)(ae.code)?Oe=String(ae.code):Oe={value:String(ae.code.value),target:ae.code.target}),{...t.from(ae.range),message:ae.message,source:ae.source,code:Oe,severity:w.from(ae.severity),relatedInformation:ae.relatedInformation&&ae.relatedInformation.map(l.from),tags:Array.isArray(ae.tags)?(0,k.$mf)(ae.tags.map(d.from)):void 0}}Te.from=Le;function Ae(ae){const Oe=new o.$RJ(t.to(ae),ae.message,w.to(ae.severity));return Oe.source=ae.source,Oe.code=(0,$.$je)(ae.code)?ae.code:ae.code?.value,Oe.relatedInformation=ae.relatedInformation&&ae.relatedInformation.map(l.to),Oe.tags=ae.tags&&(0,k.$mf)(ae.tags.map(d.to)),Oe}Te.to=Ae})(v||(e.Diagnostic=v={}));var l;(function(Te){function Le(ae){return{...t.from(ae.location.range),message:ae.message,resource:ae.location.uri}}Te.from=Le;function Ae(ae){return new o.$QJ(new o.$PJ(ae.resource,t.to(ae)),ae.message)}Te.to=Ae})(l||(e.DiagnosticRelatedInformation=l={}));var w;(function(Te){function Le(ae){switch(ae){case o.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}Te.from=Le;function Ae(ae){switch(ae){case r.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Te.to=Ae})(w||(e.DiagnosticSeverity=w={}));var L;(function(Te){function Le(ae){return typeof ae=="number"&&ae>=o.ViewColumn.One?ae-1:ae===o.ViewColumn.Beside?i.$UC:i.$TC}Te.from=Le;function Ae(ae){if(typeof ae=="number"&&ae>=0)return ae+1;throw new Error("invalid 'EditorGroupColumn'")}Te.to=Ae})(L||(e.ViewColumn=L={}));function O(Te){return typeof Te.range<"u"}function N(Te){return Te.length===0?!0:!!O(Te[0])}e.$AL=N;var T;(function(Te){function Le(He){return He.map(Te.from)}Te.fromMany=Le;function Ae(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function ae(He){let it;if(Ae(He)){const{language:pt,value:$t}=He;it={value:"```"+pt+`
`+$t+"\n```\n"}}else o.$5J.isMarkdownString(He)?it={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?it={value:He}:it={value:""};const wt=Object.create(null);it.uris=wt;const St=pt=>{try{let $t=D.URI.parse(pt,!0);$t=$t.with({query:Oe($t.query,wt)}),wt[pt]=$t}catch{}return""},Ct=new E.marked.Renderer;return Ct.link=St,Ct.image=pt=>typeof pt=="string"?St(P.$Rj(pt).href):"",(0,E.marked)(it.value,{renderer:Ct}),it}Te.from=ae;function Oe(He,it){if(!He)return He;let wt;try{wt=(0,b.$Xg)(He)}catch{}if(!wt)return He;let St=!1;return wt=(0,I.$Jm)(wt,Ct=>{if(D.URI.isUri(Ct)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[pt]=Ct,St=!0,pt}else return}),St?JSON.stringify(wt):He}function We(He){const it=new o.$5J(He.value,He.supportThemeIcons);return it.isTrusted=He.isTrusted,it.supportHtml=He.supportHtml,it.baseUri=He.baseUri?D.URI.from(He.baseUri):void 0,it}Te.to=We;function Ze(He){if(He)return typeof He=="string"?He:Te.from(He)}Te.fromStrict=Ze})(T||(e.MarkdownString=T={}));function j(Te){return N(Te)?Te.map(Le=>({range:t.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?T.fromMany(Le.hoverMessage):Le.hoverMessage?T.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Te.map(Le=>({range:t.from(Le)}))}e.$BL=j;function W(Te){return typeof Te>"u"?Te:typeof Te=="string"?D.URI.file(Te):Te}e.$CL=W;var M;(function(Te){function Le(Ae){return typeof Ae>"u"?Ae:{contentText:Ae.contentText,contentIconPath:Ae.contentIconPath?W(Ae.contentIconPath):void 0,border:Ae.border,borderColor:Ae.borderColor,fontStyle:Ae.fontStyle,fontWeight:Ae.fontWeight,textDecoration:Ae.textDecoration,color:Ae.color,backgroundColor:Ae.backgroundColor,margin:Ae.margin,width:Ae.width,height:Ae.height}}Te.from=Le})(M||(e.ThemableDecorationAttachmentRenderOptions=M={}));var Y;(function(Te){function Le(Ae){return typeof Ae>"u"?Ae:{backgroundColor:Ae.backgroundColor,outline:Ae.outline,outlineColor:Ae.outlineColor,outlineStyle:Ae.outlineStyle,outlineWidth:Ae.outlineWidth,border:Ae.border,borderColor:Ae.borderColor,borderRadius:Ae.borderRadius,borderSpacing:Ae.borderSpacing,borderStyle:Ae.borderStyle,borderWidth:Ae.borderWidth,fontStyle:Ae.fontStyle,fontWeight:Ae.fontWeight,textDecoration:Ae.textDecoration,cursor:Ae.cursor,color:Ae.color,opacity:Ae.opacity,letterSpacing:Ae.letterSpacing,gutterIconPath:Ae.gutterIconPath?W(Ae.gutterIconPath):void 0,gutterIconSize:Ae.gutterIconSize,overviewRulerColor:Ae.overviewRulerColor,before:Ae.before?M.from(Ae.before):void 0,after:Ae.after?M.from(Ae.after):void 0}}Te.from=Le})(Y||(e.ThemableDecorationRenderOptions=Y={}));var V;(function(Te){function Le(Ae){if(typeof Ae>"u")return Ae;switch(Ae){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Te.from=Le})(V||(e.DecorationRangeBehavior=V={}));var de;(function(Te){function Le(Ae){return{isWholeLine:Ae.isWholeLine,rangeBehavior:Ae.rangeBehavior?V.from(Ae.rangeBehavior):void 0,overviewRulerLane:Ae.overviewRulerLane,light:Ae.light?Y.from(Ae.light):void 0,dark:Ae.dark?Y.from(Ae.dark):void 0,backgroundColor:Ae.backgroundColor,outline:Ae.outline,outlineColor:Ae.outlineColor,outlineStyle:Ae.outlineStyle,outlineWidth:Ae.outlineWidth,border:Ae.border,borderColor:Ae.borderColor,borderRadius:Ae.borderRadius,borderSpacing:Ae.borderSpacing,borderStyle:Ae.borderStyle,borderWidth:Ae.borderWidth,fontStyle:Ae.fontStyle,fontWeight:Ae.fontWeight,textDecoration:Ae.textDecoration,cursor:Ae.cursor,color:Ae.color,opacity:Ae.opacity,letterSpacing:Ae.letterSpacing,gutterIconPath:Ae.gutterIconPath?W(Ae.gutterIconPath):void 0,gutterIconSize:Ae.gutterIconSize,overviewRulerColor:Ae.overviewRulerColor,before:Ae.before?M.from(Ae.before):void 0,after:Ae.after?M.from(Ae.after):void 0}}Te.from=Le})(de||(e.DecorationRenderOptions=de={}));var re;(function(Te){function Le(ae){return{text:ae.newText,eol:ae.newEol&&Qe.from(ae.newEol),range:t.from(ae.range)}}Te.from=Le;function Ae(ae){const Oe=new o.$KJ(t.to(ae.range),ae.text);return Oe.newEol=typeof ae.eol>"u"?void 0:Qe.to(ae.eol),Oe}Te.to=Ae})(re||(e.TextEdit=re={}));var x;(function(Te){function Le(ae,Oe){const We={edits:[]};if(ae instanceof o.$NJ){const Ze=new m.$oi;for(const He of ae._allEntries())He._type===1&&D.URI.isUri(He.to)&&He.from===void 0&&Ze.add(He.to);for(const He of ae._allEntries())if(He._type===1){let it;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?it={type:"base64",value:(0,F.$4b)(F.$Jb.wrap(He.options.contents))}:it={type:"dataTransferItem",id:He.options.contents._itemId}),We.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:it},metadata:He.metadata})}else He._type===2?We.edits.push({resource:He.uri,textEdit:re.from(He.edit),versionId:Ze.has(He.uri)?void 0:Oe?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===6?We.edits.push({resource:He.uri,textEdit:{range:t.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Ze.has(He.uri)?void 0:Oe?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===3?We.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(He.uri)}):He._type===5&&We.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(xe.from)}})}return We}Te.from=Le;function Ae(ae){const Oe=new o.$NJ,We=new m.$ni;for(const Ze of ae.edits)if(Ze.textEdit){const He=Ze,it=D.URI.revive(He.resource),wt=t.to(He.textEdit.range),St=He.textEdit.text,Ct=He.textEdit.insertAsSnippet;let pt;Ct?pt=o.$MJ.replace(wt,new o.$OJ(St)):pt=o.$KJ.replace(wt,St);const $t=We.get(it);$t?$t.push(pt):We.set(it,[pt])}else Oe.renameFile(D.URI.revive(Ze.oldResource),D.URI.revive(Ze.newResource),Ze.options);for(const[Ze,He]of We)Oe.set(Ze,He);return Oe}Te.to=Ae})(x||(e.WorkspaceEdit=x={}));var q;(function(Te){const Le=Object.create(null);Le[o.SymbolKind.File]=0,Le[o.SymbolKind.Module]=1,Le[o.SymbolKind.Namespace]=2,Le[o.SymbolKind.Package]=3,Le[o.SymbolKind.Class]=4,Le[o.SymbolKind.Method]=5,Le[o.SymbolKind.Property]=6,Le[o.SymbolKind.Field]=7,Le[o.SymbolKind.Constructor]=8,Le[o.SymbolKind.Enum]=9,Le[o.SymbolKind.Interface]=10,Le[o.SymbolKind.Function]=11,Le[o.SymbolKind.Variable]=12,Le[o.SymbolKind.Constant]=13,Le[o.SymbolKind.String]=14,Le[o.SymbolKind.Number]=15,Le[o.SymbolKind.Boolean]=16,Le[o.SymbolKind.Array]=17,Le[o.SymbolKind.Object]=18,Le[o.SymbolKind.Key]=19,Le[o.SymbolKind.Null]=20,Le[o.SymbolKind.EnumMember]=21,Le[o.SymbolKind.Struct]=22,Le[o.SymbolKind.Event]=23,Le[o.SymbolKind.Operator]=24,Le[o.SymbolKind.TypeParameter]=25;function Ae(Oe){return typeof Le[Oe]=="number"?Le[Oe]:6}Te.from=Ae;function ae(Oe){for(const We in Le)if(Le[We]===Oe)return Number(We);return o.SymbolKind.Property}Te.to=ae})(q||(e.SymbolKind=q={}));var ne;(function(Te){function Le(ae){switch(ae){case o.SymbolTag.Deprecated:return 1}}Te.from=Le;function Ae(ae){switch(ae){case 1:return o.SymbolTag.Deprecated}}Te.to=Ae})(ne||(e.SymbolTag=ne={}));var pe;(function(Te){function Le(ae){return{name:ae.name,kind:q.from(ae.kind),tags:ae.tags&&ae.tags.map(ne.from),containerName:ae.containerName,location:ie.from(ae.location)}}Te.from=Le;function Ae(ae){const Oe=new o.$UJ(ae.name,q.to(ae.kind),ae.containerName,ie.to(ae.location));return Oe.tags=ae.tags&&ae.tags.map(ne.to),Oe}Te.to=Ae})(pe||(e.WorkspaceSymbol=pe={}));var H;(function(Te){function Le(ae){const Oe={name:ae.name||"!!MISSING: name!!",detail:ae.detail,range:t.from(ae.range),selectionRange:t.from(ae.selectionRange),kind:q.from(ae.kind),tags:ae.tags?.map(ne.from)??[]};return ae.children&&(Oe.children=ae.children.map(Le)),Oe}Te.from=Le;function Ae(ae){const Oe=new o.$VJ(ae.name,ae.detail,q.to(ae.kind),t.to(ae.range),t.to(ae.selectionRange));return(0,k.$qf)(ae.tags)&&(Oe.tags=ae.tags.map(ne.to)),ae.children&&(Oe.children=ae.children.map(Ae)),Oe}Te.to=Ae})(H||(e.DocumentSymbol=H={}));var ue;(function(Te){function Le(ae){const Oe=new o.$1J(q.to(ae.kind),ae.name,ae.detail||"",D.URI.revive(ae.uri),t.to(ae.range),t.to(ae.selectionRange));return Oe._sessionId=ae._sessionId,Oe._itemId=ae._itemId,Oe}Te.to=Le;function Ae(ae,Oe,We){if(Oe=Oe??ae._sessionId,We=We??ae._itemId,Oe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:We,name:ae.name,detail:ae.detail,kind:q.from(ae.kind),uri:ae.uri,range:t.from(ae.range),selectionRange:t.from(ae.selectionRange),tags:ae.tags?.map(ne.from)}}Te.from=Ae})(ue||(e.CallHierarchyItem=ue={}));var ce;(function(Te){function Le(Ae){return new o.$2J(ue.to(Ae.from),Ae.fromRanges.map(ae=>t.to(ae)))}Te.to=Le})(ce||(e.CallHierarchyIncomingCall=ce={}));var z;(function(Te){function Le(Ae){return new o.$3J(ue.to(Ae.to),Ae.fromRanges.map(ae=>t.to(ae)))}Te.to=Le})(z||(e.CallHierarchyOutgoingCall=z={}));var ie;(function(Te){function Le(ae){return{range:ae.range&&t.from(ae.range),uri:ae.uri}}Te.from=Le;function Ae(ae){return new o.$PJ(D.URI.revive(ae.uri),t.to(ae.range))}Te.to=Ae})(ie||(e.location=ie={}));var Ee;(function(Te){function Le(ae){const Oe=ae,We=ae;return{originSelectionRange:Oe.originSelectionRange?t.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:We.uri,range:t.from(Oe.targetRange?Oe.targetRange:We.range),targetSelectionRange:Oe.targetSelectionRange?t.from(Oe.targetSelectionRange):void 0}}Te.from=Le;function Ae(ae){return{targetUri:D.URI.revive(ae.uri),targetRange:t.to(ae.range),targetSelectionRange:ae.targetSelectionRange?t.to(ae.targetSelectionRange):void 0,originSelectionRange:ae.originSelectionRange?t.to(ae.originSelectionRange):void 0}}Te.to=Ae})(Ee||(e.DefinitionLink=Ee={}));var Re;(function(Te){function Le(ae){return{range:t.from(ae.range),contents:T.fromMany(ae.contents)}}Te.from=Le;function Ae(ae){return new o.$SJ(ae.contents.map(T.to),t.to(ae.range))}Te.to=Ae})(Re||(e.Hover=Re={}));var ye;(function(Te){function Le(ae){return{range:t.from(ae.range),expression:ae.expression}}Te.from=Le;function Ae(ae){return new o.$MK(t.to(ae.range),ae.expression)}Te.to=Ae})(ye||(e.EvaluatableExpression=ye={}));var X;(function(Te){function Le(ae){if(ae instanceof o.$NK)return{type:"text",range:t.from(ae.range),text:ae.text};if(ae instanceof o.$OK)return{type:"variable",range:t.from(ae.range),variableName:ae.variableName,caseSensitiveLookup:ae.caseSensitiveLookup};if(ae instanceof o.$PK)return{type:"expression",range:t.from(ae.range),expression:ae.expression};throw new Error("Unknown 'InlineValue' type")}Te.from=Le;function Ae(ae){switch(ae.type){case"text":return{range:t.to(ae.range),text:ae.text};case"variable":return{range:t.to(ae.range),variableName:ae.variableName,caseSensitiveLookup:ae.caseSensitiveLookup};case"expression":return{range:t.to(ae.range),expression:ae.expression}}}Te.to=Ae})(X||(e.InlineValue=X={}));var he;(function(Te){function Le(ae){return{frameId:ae.frameId,stoppedLocation:t.from(ae.stoppedLocation)}}Te.from=Le;function Ae(ae){return new o.$QK(ae.frameId,t.to(ae.stoppedLocation))}Te.to=Ae})(he||(e.InlineValueContext=he={}));var K;(function(Te){function Le(ae){return{range:t.from(ae.range),kind:ae.kind}}Te.from=Le;function Ae(ae){return new o.$TJ(t.to(ae.range),ae.kind)}Te.to=Ae})(K||(e.DocumentHighlight=K={}));var oe;(function(Te){function Le(Ae){switch(Ae){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Te.to=Le})(oe||(e.CompletionTriggerKind=oe={}));var _;(function(Te){function Le(Ae){return{triggerKind:oe.to(Ae.triggerKind),triggerCharacter:Ae.triggerCharacter}}Te.to=Le})(_||(e.CompletionContext=_={}));var le;(function(Te){function Le(ae){switch(ae){case o.CompletionItemTag.Deprecated:return 1}}Te.from=Le;function Ae(ae){switch(ae){case 1:return o.CompletionItemTag.Deprecated}}Te.to=Ae})(le||(e.CompletionItemTag=le={}));var $e;(function(Te){const Le=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function Ae(We){return Le.get(We)??9}Te.from=Ae;const ae=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Oe(We){return ae.get(We)??o.CompletionItemKind.Property}Te.to=Oe})($e||(e.CompletionItemKind=$e={}));var U;(function(Te){function Le(Ae,ae){const Oe=new o.$$J(Ae.label);return Oe.insertText=Ae.insertText,Oe.kind=$e.to(Ae.kind),Oe.tags=Ae.tags?.map(le.to),Oe.detail=Ae.detail,Oe.documentation=P.$Mj(Ae.documentation)?T.to(Ae.documentation):Ae.documentation,Oe.sortText=Ae.sortText,Oe.filterText=Ae.filterText,Oe.preselect=Ae.preselect,Oe.commitCharacters=Ae.commitCharacters,S.$Or.isIRange(Ae.range)?Oe.range=t.to(Ae.range):typeof Ae.range=="object"&&(Oe.range={inserting:t.to(Ae.range.insert),replacing:t.to(Ae.range.replace)}),Oe.keepWhitespace=typeof Ae.insertTextRules>"u"?!1:!!(Ae.insertTextRules&1),typeof Ae.insertTextRules<"u"&&Ae.insertTextRules&4?Oe.insertText=new o.$OJ(Ae.insertText):(Oe.insertText=Ae.insertText,Oe.textEdit=Oe.range instanceof o.$FJ?new o.$KJ(Oe.range,Oe.insertText):void 0),Ae.additionalTextEdits&&Ae.additionalTextEdits.length>0&&(Oe.additionalTextEdits=Ae.additionalTextEdits.map(We=>re.to(We))),Oe.command=ae&&Ae.command?ae.fromInternal(Ae.command):void 0,Oe}Te.to=Le})(U||(e.CompletionItem=U={}));var G;(function(Te){function Le(ae){if(typeof ae.label!="string"&&!Array.isArray(ae.label))throw new TypeError("Invalid label");return{label:ae.label,documentation:T.fromStrict(ae.documentation)}}Te.from=Le;function Ae(ae){return{label:ae.label,documentation:P.$Mj(ae.documentation)?T.to(ae.documentation):ae.documentation}}Te.to=Ae})(G||(e.ParameterInformation=G={}));var Z;(function(Te){function Le(ae){return{label:ae.label,documentation:T.fromStrict(ae.documentation),parameters:Array.isArray(ae.parameters)?ae.parameters.map(G.from):[],activeParameter:ae.activeParameter}}Te.from=Le;function Ae(ae){return{label:ae.label,documentation:P.$Mj(ae.documentation)?T.to(ae.documentation):ae.documentation,parameters:Array.isArray(ae.parameters)?ae.parameters.map(G.to):[],activeParameter:ae.activeParameter}}Te.to=Ae})(Z||(e.SignatureInformation=Z={}));var ee;(function(Te){function Le(ae){return{activeSignature:ae.activeSignature,activeParameter:ae.activeParameter,signatures:Array.isArray(ae.signatures)?ae.signatures.map(Z.from):[]}}Te.from=Le;function Ae(ae){return{activeSignature:ae.activeSignature,activeParameter:ae.activeParameter,signatures:Array.isArray(ae.signatures)?ae.signatures.map(Z.to):[]}}Te.to=Ae})(ee||(e.SignatureHelp=ee={}));var be;(function(Te){function Le(Ae,ae){const Oe=new o.$0J(g.to(ae.position),typeof ae.label=="string"?ae.label:ae.label.map(se.to.bind(void 0,Ae)),ae.kind&&we.to(ae.kind));return Oe.textEdits=ae.textEdits&&ae.textEdits.map(re.to),Oe.tooltip=P.$Mj(ae.tooltip)?T.to(ae.tooltip):ae.tooltip,Oe.paddingLeft=ae.paddingLeft,Oe.paddingRight=ae.paddingRight,Oe}Te.to=Le})(be||(e.InlayHint=be={}));var se;(function(Te){function Le(Ae,ae){const Oe=new o.$9J(ae.label);return Oe.tooltip=P.$Mj(ae.tooltip)?T.to(ae.tooltip):ae.tooltip,p.Command.is(ae.command)&&(Oe.command=Ae.fromInternal(ae.command)),ae.location&&(Oe.location=ie.to(ae.location)),Oe}Te.to=Le})(se||(e.InlayHintLabelPart=se={}));var we;(function(Te){function Le(ae){return ae}Te.from=Le;function Ae(ae){return ae}Te.to=Ae})(we||(e.InlayHintKind=we={}));var Ie;(function(Te){function Le(ae){return{range:t.from(ae.range),url:ae.target,tooltip:ae.tooltip}}Te.from=Le;function Ae(ae){let Oe;if(ae.url)try{Oe=typeof ae.url=="string"?D.URI.parse(ae.url,!0):D.URI.revive(ae.url)}catch{}return new o.$dK(t.to(ae.range),Oe)}Te.to=Ae})(Ie||(e.DocumentLink=Ie={}));var je;(function(Te){function Le(ae){const Oe=new o.$gK(ae.label);return ae.textEdit&&(Oe.textEdit=re.to(ae.textEdit)),ae.additionalTextEdits&&(Oe.additionalTextEdits=ae.additionalTextEdits.map(We=>re.to(We))),Oe}Te.to=Le;function Ae(ae){return{label:ae.label,textEdit:ae.textEdit?re.from(ae.textEdit):void 0,additionalTextEdits:ae.additionalTextEdits?ae.additionalTextEdits.map(Oe=>re.from(Oe)):void 0}}Te.from=Ae})(je||(e.ColorPresentation=je={}));var Ve;(function(Te){function Le(ae){return new o.$eK(ae[0],ae[1],ae[2],ae[3])}Te.to=Le;function Ae(ae){return[ae.red,ae.green,ae.blue,ae.alpha]}Te.from=Ae})(Ve||(e.Color=Ve={}));var _e;(function(Te){function Le(ae){return{range:t.from(ae.range)}}Te.from=Le;function Ae(ae){return new o.$ZJ(t.to(ae.range))}Te.to=Ae})(_e||(e.SelectionRange=_e={}));var Ge;(function(Te){function Le(Ae){switch(Ae){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Te.to=Le})(Ge||(e.TextDocumentSaveReason=Ge={}));var et;(function(Te){function Le(ae){switch(ae){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Te.from=Le;function Ae(ae){switch(ae){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Te.to=Ae})(et||(e.TextEditorLineNumbersStyle=et={}));var Qe;(function(Te){function Le(ae){if(ae===o.EndOfLine.CRLF)return 1;if(ae===o.EndOfLine.LF)return 0}Te.from=Le;function Ae(ae){if(ae===1)return o.EndOfLine.CRLF;if(ae===0)return o.EndOfLine.LF}Te.to=Ae})(Qe||(e.EndOfLine=Qe={}));var st;(function(Te){function Le(Ae){if(typeof Ae=="object")return Ae.viewId;switch(Ae){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Te.from=Le})(st||(e.ProgressLocation=st={}));var tt;(function(Te){function Le(ae){const Oe={start:ae.start+1,end:ae.end+1};return ae.kind&&(Oe.kind=Pe.from(ae.kind)),Oe}Te.from=Le;function Ae(ae){const Oe={start:ae.start-1,end:ae.end-1};return ae.kind&&(Oe.kind=Pe.to(ae.kind)),Oe}Te.to=Ae})(tt||(e.FoldingRange=tt={}));var Pe;(function(Te){function Le(ae){if(ae)switch(ae){case o.FoldingRangeKind.Comment:return p.$us.Comment;case o.FoldingRangeKind.Imports:return p.$us.Imports;case o.FoldingRangeKind.Region:return p.$us.Region}}Te.from=Le;function Ae(ae){if(ae)switch(ae.value){case p.$us.Comment.value:return o.FoldingRangeKind.Comment;case p.$us.Imports.value:return o.FoldingRangeKind.Imports;case p.$us.Region.value:return o.FoldingRangeKind.Region}}Te.to=Ae})(Pe||(e.FoldingRangeKind=Pe={}));var ke;(function(Te){function Le(Ae){if(Ae)return{pinned:typeof Ae.preview=="boolean"?!Ae.preview:void 0,inactive:Ae.background,preserveFocus:Ae.preserveFocus,selection:typeof Ae.selection=="object"?t.from(Ae.selection):void 0,override:typeof Ae.override=="boolean"?c.$rE.id:void 0}}Te.from=Le})(ke||(e.TextEditorOpenOptions=ke={}));var Be;(function(Te){function Le(We){return We instanceof o.$AK?We.toJSON():typeof We=="string"?We:Ae(We)||ae(We)?new o.$AK(We.baseUri??We.base,We.pattern).toJSON():We}Te.from=Le;function Ae(We){const Ze=We;return Ze?D.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function ae(We){const Ze=We;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Oe(We){return typeof We=="string"?We:new o.$AK(D.URI.revive(We.baseUri),We.pattern)}Te.to=Oe})(Be||(e.GlobPattern=Be={}));var te;(function(Te){function Le(Ae){if(Ae){if(Array.isArray(Ae))return Ae.map(Le);if(typeof Ae=="string")return Ae;{const ae=Ae;return{language:ae.language,scheme:ae.scheme,pattern:Be.from(ae.pattern),exclusive:ae.exclusive,notebookType:ae.notebookType}}}else return}Te.from=Le})(te||(e.LanguageSelector=te={}));var Q;(function(Te){function Le(ae){return{start:ae.start,end:ae.end}}Te.from=Le;function Ae(ae){return new o.$2K(ae.start,ae.end)}Te.to=Ae})(Q||(e.NotebookRange=Q={}));var ve;(function(Te){function Le(ae){return{timing:typeof ae.runStartTime=="number"&&typeof ae.runEndTime=="number"?{startTime:ae.runStartTime,endTime:ae.runEndTime}:void 0,executionOrder:ae.executionOrder,success:ae.lastRunSuccess}}Te.to=Le;function Ae(ae){return{lastRunSuccess:ae.success,runStartTime:ae.timing?.startTime,runEndTime:ae.timing?.endTime,executionOrder:ae.executionOrder}}Te.from=Ae})(ve||(e.NotebookCellExecutionSummary=ve={}));var Ue;(function(Te){function Le(Ae){if(Ae===f.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(Ae===f.NotebookCellExecutionState.Pending)return;if(Ae===f.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ae}`)}Te.to=Le})(Ue||(e.NotebookCellExecutionState=Ue={}));var Ne;(function(Te){function Le(ae){switch(ae){case o.NotebookCellKind.Markup:return f.CellKind.Markup;case o.NotebookCellKind.Code:default:return f.CellKind.Code}}Te.from=Le;function Ae(ae){switch(ae){case f.CellKind.Markup:return o.NotebookCellKind.Markup;case f.CellKind.Code:default:return o.NotebookCellKind.Code}}Te.to=Ae})(Ne||(e.NotebookCellKind=Ne={}));var Ye;(function(Te){function Le(ae){const Oe={metadata:ae.metadata??Object.create(null),cells:[]};for(const We of ae.cells)o.$3K.validate(We),Oe.cells.push(xe.from(We));return Oe}Te.from=Le;function Ae(ae){const Oe=new o.$4K(ae.cells.map(xe.to));return(0,$.$we)(ae.metadata)||(Oe.metadata=ae.metadata),Oe}Te.to=Ae})(Ye||(e.NotebookData=Ye={}));var xe;(function(Te){function Le(ae){return{cellKind:Ne.from(ae.kind),language:ae.languageId,mime:ae.mime,source:ae.value,metadata:ae.metadata,internalMetadata:ve.from(ae.executionSummary??{}),outputs:ae.outputs?ae.outputs.map(ft.from):[]}}Te.from=Le;function Ae(ae){return new o.$3K(Ne.to(ae.cellKind),ae.source,ae.language,ae.mime,ae.outputs?ae.outputs.map(ft.to):void 0,ae.metadata,ae.internalMetadata?ve.to(ae.internalMetadata):void 0)}Te.to=Ae})(xe||(e.NotebookCellData=xe={}));var rt;(function(Te){function Le(ae){return{mime:ae.mime,valueBytes:F.$Jb.wrap(ae.data)}}Te.from=Le;function Ae(ae){return new o.$5K(ae.valueBytes.buffer,ae.mime)}Te.to=Ae})(rt||(e.NotebookCellOutputItem=rt={}));var ft;(function(Te){function Le(ae){return{outputId:ae.id,items:ae.items.map(rt.from),metadata:ae.metadata}}Te.from=Le;function Ae(ae){const Oe=ae.items.map(rt.to);return new o.$6K(Oe,ae.outputId,ae.metadata)}Te.to=Ae})(ft||(e.NotebookCellOutput=ft={}));var vt;(function(Te){function Le(Oe){return ae(Oe)?{include:(0,$.$Be)(Be.from(Oe.include)),exclude:(0,$.$Be)(Be.from(Oe.exclude))}:(0,$.$Be)(Be.from(Oe))}Te.from=Le;function Ae(Oe){return ae(Oe)?{include:Be.to(Oe.include),exclude:Be.to(Oe.exclude)}:Be.to(Oe)}Te.to=Ae;function ae(Oe){const We=Oe;return We?!(0,$.$se)(We.include)&&!(0,$.$se)(We.exclude):!1}})(vt||(e.NotebookExclusiveDocumentPattern=vt={}));var Ft;(function(Te){function Le(Ae,ae,Oe){const We=typeof Ae.command=="string"?{title:"",command:Ae.command}:Ae.command;return{alignment:Ae.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:ae.toInternal(We,Oe),text:Ae.text,tooltip:Ae.tooltip,accessibilityInformation:Ae.accessibilityInformation,priority:Ae.priority}}Te.from=Le})(Ft||(e.NotebookStatusBarItem=Ft={}));var Lt;(function(Te){function Le(Ae,ae,Oe){const We=typeof Ae.command=="string"?{title:"",command:Ae.command}:Ae.command;return{command:ae.toInternal(We,Oe),label:Ae.label,description:Ae.description,detail:Ae.detail,documentation:Ae.documentation}}Te.from=Le})(Lt||(e.NotebookKernelSourceAction=Lt={}));var Et;(function(Te){function Le(Ae){return{transientOutputs:Ae?.transientOutputs??!1,transientCellMetadata:Ae?.transientCellMetadata??{},transientDocumentMetadata:Ae?.transientDocumentMetadata??{},cellContentMetadata:Ae?.cellContentMetadata??{}}}Te.from=Le})(Et||(e.NotebookDocumentContentOptions=Et={}));var Tt;(function(Te){function Le(ae){return{uri:ae.uri,provides:ae.provides}}Te.from=Le;function Ae(ae){return new o.$8K(D.URI.revive(ae.uri),ae.provides)}Te.to=Ae})(Tt||(e.NotebookRendererScript=Tt={}));var Ot;(function(Te){function Le(ae){return{message:T.fromStrict(ae.message)||"",type:0,expected:ae.expectedOutput,actual:ae.actualOutput,location:ae.location&&{range:t.from(ae.location.range),uri:ae.location.uri}}}Te.from=Le;function Ae(ae){const Oe=new o.$cL(typeof ae.message=="string"?ae.message:T.to(ae.message));return Oe.actualOutput=ae.actual,Oe.expectedOutput=ae.expected,Oe.location=ae.location?ie.to(ae.location):void 0,Oe}Te.to=Ae})(Ot||(e.TestMessage=Ot={}));var zt;(function(Te){Te.namespace=C.$rI,Te.denamespace=C.$sI})(zt||(e.TestTag=zt={}));var Bt;(function(Te){function Le(ae){const Oe=(0,s.$zL)(ae).controllerId;return{extId:y.$nI.fromExtHostTestItem(ae,Oe).toString(),label:ae.label,uri:D.URI.revive(ae.uri),busy:ae.busy,tags:ae.tags.map(We=>zt.namespace(Oe,We.id)),range:S.$Or.lift(t.from(ae.range)),description:ae.description||null,sortText:ae.sortText||null,error:ae.error&&T.fromStrict(ae.error)||null}}Te.from=Le;function Ae(ae){return{parent:void 0,error:void 0,id:y.$nI.fromString(ae.extId).localId,label:ae.label,uri:D.URI.revive(ae.uri),tags:(ae.tags||[]).map(Oe=>{const{tagId:We}=zt.denamespace(Oe);return new o.$dL(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:t.to(ae.range||void 0),canResolveChildren:!1,busy:ae.busy,description:ae.description||void 0,sortText:ae.sortText||void 0}}Te.toPlain=Ae})(Bt||(e.TestItem=Bt={})),function(Te){function Le(ae){return{id:ae.id}}Te.from=Le;function Ae(ae){return new o.$dL(ae.id)}Te.to=Ae}(zt||(e.TestTag=zt={}));var Mt;(function(Te){const Le=(ae,Oe)=>{const We=[];for(const[He,it]of Oe)y.$nI.compare(it.item.extId,He)===2&&(Oe.delete(He),We.push(it));const Ze={...Bt.toPlain(ae.item),parent:void 0,taskStates:ae.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(it=>it.type===0).map(Ot.to)})),children:We.map(He=>Le(He,Oe))};for(const He of Ze.children)He.parent=Ze;return Ze};function Ae(ae){const Oe=[],We=new Map;for(const Ze of ae.items){We.set(Ze.item.extId,Ze);const He=y.$nI.root(Ze.item.extId);ae.request.targets.some(it=>it.controllerId===He&&it.testIds.includes(Ze.item.extId))&&Oe.push(Ze)}return{completedAt:ae.completedAt,results:Oe.map(Ze=>Le(Ze,We))}}Te.to=Ae})(Mt||(e.TestResults=Mt={}));var at;(function(Te){function Le(We){return{covered:We.covered,total:We.covered}}function Ae(We){return"line"in We?g.from(We):t.from(We)}function ae(We){return"branches"in We?{count:We.executionCount,location:Ae(We.location),type:1,branches:We.branches.length?We.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&Ae(Ze.location)})):void 0}:{type:0,count:We.executionCount,location:Ae(We.location)}}Te.fromDetailed=ae;function Oe(We){return{uri:We.uri,statement:Le(We.statementCoverage),branch:We.branchCoverage&&Le(We.branchCoverage),function:We.functionCoverage&&Le(We.functionCoverage),details:We.detailedCoverage?.map(ae)}}Te.fromFile=Oe})(at||(e.TestCoverage=at={}));var dt;(function(Te){function Le(Ae){switch(Ae){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Te.to=Le})(dt||(e.CodeActionTriggerKind=dt={}));var Wt;(function(Te){function Le(ae){const Oe=new o.$jL(q.to(ae.kind),ae.name,ae.detail||"",D.URI.revive(ae.uri),t.to(ae.range),t.to(ae.selectionRange));return Oe._sessionId=ae._sessionId,Oe._itemId=ae._itemId,Oe}Te.to=Le;function Ae(ae,Oe,We){if(Oe=Oe??ae._sessionId,We=We??ae._itemId,Oe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:We,kind:q.from(ae.kind),name:ae.name,detail:ae.detail??"",uri:ae.uri,range:t.from(ae.range),selectionRange:t.from(ae.selectionRange),tags:ae.tags?.map(ne.from)}}Te.from=Ae})(Wt||(e.TypeHierarchyItem=Wt={}));var Nt;(function(Te){function Le(Ae){if(Ae)return{value:Ae.value,tooltip:Ae.tooltip}}Te.from=Le})(Nt||(e.ViewBadge=Nt={}));var Dt;(function(Te){function Le(We,Ze,He){const it=Ze.fileData;return it?new o.$tK(new o.$uK(it.name,D.URI.revive(it.uri),it.id,(0,A.$cb)(()=>He(it.id)))):We===R.$ur.uriList&&Ze.uriListData?new o.$sK(Oe(Ze.uriListData)):new o.$sK(Ze.asString)}Te.to=Le;async function Ae(We,Ze){const He=await Ze.asString();if(We===R.$ur.uriList)return{asString:He,fileData:void 0,uriListData:ae(He)};const it=Ze.asFile();return{asString:He,fileData:it?{name:it.name,uri:it.uri,id:it._itemId??it.id}:void 0}}Te.from=Ae;function ae(We){return h.$cs.split(We).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return D.URI.parse(Ze)}catch{}return Ze})}function Oe(We){return h.$cs.create(We.map(Ze=>typeof Ze=="string"?Ze:D.URI.revive(Ze)))}})(Dt||(e.DataTransferItem=Dt={}));var ct;(function(Te){function Le(ae,Oe){const We=ae.items.map(([Ze,He])=>[Ze,Dt.to(Ze,He,Oe)]);return new o.$vK(We)}Te.toDataTransfer=Le;async function Ae(ae){const Oe={items:[]},We=[];for(const[Ze,He]of ae)We.push((async()=>{Oe.items.push([Ze,await Dt.from(Ze,He)])})());return await Promise.all(We),Oe}Te.from=Ae})(ct||(e.DataTransfer=ct={}));var At;(function(Te){function Le(ae){return{message:ae.message,metadata:ae.metadata,title:ae.title,tooltip:ae.tooltip}}Te.to=Le;function Ae(ae){return{kind:"reply",message:ae.message,metadata:ae.metadata,title:ae.title,tooltip:ae.tooltip}}Te.from=Ae})(At||(e.ChatReplyFollowup=At={}));var jt;(function(Te){function Le(Ae){return typeof Ae=="string"?{title:Ae,message:Ae,kind:"reply"}:"commandId"in Ae?{kind:"command",title:Ae.title??"",commandId:Ae.commandId??"",args:Ae.args}:At.from(Ae)}Te.from=Le})(jt||(e.ChatFollowup=jt={}))}),define(Se[265],Ce([1,0,2,8,7,16,68]),function(fe,e,k,F,h,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0$b=void 0;class m{constructor(b,R,I,$={timeout:1500,errors:3}){this.c=b,this.d=R,this.f=I,this.g=$,this.a=new P.$lc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(b){return(R,I,$)=>{const S={dispose:this.a.push([R,I,b])};return Array.isArray($)&&$.push(S),S}}async $participateInSave(b,R){const I=k.URI.revive(b);let $=!1;const D=setTimeout(()=>$=!0,this.g.timeout),S=[];try{for(const p of[...this.a]){if($)break;const r=this.d.getDocument(I),s=await this.h(p,{document:r,reason:A.TextDocumentSaveReason.to(R)});S.push(s)}}finally{clearTimeout(D)}return S}h([b,R,I],$){const D=this.b.get(b);return typeof D=="number"&&D>this.g.errors?Promise.resolve(!1):this.i(I,b,R,$).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const p=this.b.get(b);this.b.set(b,p?p+1:1),typeof p=="number"&&p>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(b,R,I,$){const D=[],S=Date.now(),{document:p,reason:r}=$,{version:s}=p,c=Object.freeze({document:p,reason:r,waitUntil(f){if(Object.isFrozen(D))throw(0,F.$6)("waitUntil can not be called async");D.push(Promise.resolve(f))}});try{R.apply(I,[c])}catch(f){return Promise.reject(f)}return Object.freeze(D),new Promise((f,y)=>{const C=setTimeout(()=>y(new Error("timeout")),this.g.timeout);return Promise.all(D).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(C),f(i)}).catch(i=>{clearTimeout(C),y(i)})}).then(f=>{const y={edits:[]};for(const C of f)if(Array.isArray(C)&&C.every(i=>i instanceof h.$KJ))for(const{newText:i,newEol:o,range:n}of C)y.edits.push({resource:p.uri,versionId:void 0,textEdit:{range:n&&A.Range.from(n),text:i,eol:o&&A.EndOfLine.from(o)}});if(y.edits.length!==0)return s===p.version?this.f.$tryApplyWorkspaceEdit(y):Promise.reject(new Error("concurrent_edits"))})}}e.$0$b=m}),define(Se[266],Ce([1,0,15,2,16,7,102]),function(fe,e,k,F,h,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lac=e.$kac=void 0;class m{constructor(I,$,D,S){this.start=I,this.deletedCount=$,this.deletedItems=D,this.items=S}asApiEvent(){return{range:new A.$2K(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(I,$){return{EOL:$.eol,lines:$.source,languageId:$.language,uri:$.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,$,D){this.notebook=I,this.h=$,this.j=D,this.handle=D.handle,this.uri=F.URI.revive(D.uri),this.cellKind=D.cellKind,this.a=D.outputs.map(h.NotebookCellOutput.to),this.e=D.internalMetadata??{},this.b=Object.freeze(D.metadata??{}),this.d=Object.freeze(h.NotebookCellExecutionSummary.to(D.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,$=this.h.getDocument(this.uri);if(!$)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const D={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:h.NotebookCellKind.to(this.j.cellKind),document:$.document,get mime(){return I.g},set mime(S){I.g=S},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(D)}return this.f}setOutputs(I){this.a=I.map(h.NotebookCellOutput.to)}setOutputItems(I,$,D){const S=D.map(h.NotebookCellOutputItem.to),p=this.a.find(r=>r.id===I);if(p&&($||(p.items.length=0),p.items.push(...S),p.items.length>1&&p.items.every(r=>P.$IH(r.mime)))){const r=new Map,s=[];p.items.forEach(c=>{let f;r.has(c.mime)?f=r.get(c.mime):(f=[],r.set(c.mime,f),s.push(c.mime)),f.push(c.data)}),p.items.length=0,s.forEach(c=>{const f=P.$JH(r.get(c));p.items.push({mime:c,data:f.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(h.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$kac=E;class b{static{this.a=0}constructor(I,$,D,S,p){this.k=I,this.l=$,this.m=D,this.uri=S,this.handle=b.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=p.viewType,this.f=Object.freeze(p.metadata??Object.create(null)),this.r([[0,0,p.cells]],!0,void 0),this.g=p.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,$={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===k.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(D){return D=I.n(D),I.b[D].apiCell},getCells(D){return(D?I.p(D):I.b).map(p=>p.apiCell)},save(){return I.q()}};this.e=Object.freeze($)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,$,D){this.g=I.versionId,this.h=$,this.acceptDocumentPropertiesChanged({metadata:D});const S={notebook:this.apiNotebook,metadata:D,cellChanges:[],contentChanges:[]},p=[];for(const s of I.rawEvents)s.kind===P.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,S.contentChanges):s.kind===P.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,S.contentChanges):s.kind===P.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),p.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===P.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),p.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===P.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),p.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===P.NotebookCellsChangeType.ChangeCellContent?p.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===P.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===P.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),p.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),p.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const r=new Map;for(let s=0;s<p.length;s++){const c=p[s],f=r.get(c.cell);if(f===void 0){const y=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});r.set(c.cell,y-1)}else S.cellChanges[f]={...S.cellChanges[f],...c}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let $=I.start|0,D=I.end|0;return $<0&&($=0),D>this.b.length&&(D=this.b.length),I.with({start:$,end:D})}p(I){I=this.o(I);const $=[];for(let D=I.start;D<I.end;D++)$.push(this.b[D]);return $}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,$,D){if(this.j)return;const S=[],p=[],r=[];if(I.reverse().forEach(s=>{const f=s[2].map(i=>{const o=new E(this,this.l,i);return $||p.push(E.asModelAddData(this.apiNotebook,i)),o}),y=new m(s[0],s[1],[],f),C=this.b.splice(s[0],s[1],...f);for(const i of C)r.push(i.uri),y.deletedItems.push(i.apiCell);S.push(y)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:r}),D)for(const s of S)D.push(s.asApiEvent())}s(I,$,D,S){const p=this.b.splice(I,$);this.b.splice(D,0,...p);const r=[new m(I,$,p.map(s=>s.apiCell),[]),new m(D,0,[],p)];for(const s of r)S.push(s.asApiEvent())}t(I,$){this.b[I].setOutputs($)}u(I,$,D,S){this.b[I].setOutputItems($,D,S)}v(I,$){const D=this.b[I];D.apiCell.document.languageId!==$&&this.m.$acceptModelLanguageChanged(D.uri,$)}w(I,$){const D=this.b[I];D.apiCell.mime=$}x(I,$){this.b[I].setMetadata($)}y(I,$){this.b[I].setInternalMetadata($)}getCellFromApiCell(I){return this.b.find($=>$.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find($=>$.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$lac=b}),define(Se[267],Ce([1,0,3,2,16,7]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=void 0;class P{constructor(E,b,R,I={timeout:1500,errors:3}){this.b=E,this.c=b,this.d=R,this.f=I,this.a=new k.$0c}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(b,R,I)=>{const $=function(S){b.call(R,S)};return $.extension=E,this.a.event($,void 0,I)}}async $participateInSave(E,b,R){const I=F.URI.revive(E),$=this.c.getNotebookDocument(I);if(!$)throw new Error("Unable to resolve notebook document");const D=[];if(await this.a.fireAsync({notebook:$.apiNotebook,reason:h.TextDocumentSaveReason.to(b)},R,async(p,r)=>{const s=Date.now(),c=await await Promise.resolve(p);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier),!R.isCancellationRequested&&c&&(c instanceof A.$NJ?D.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(D.length===0)return!0;const S={edits:[]};for(const p of D){const{edits:r}=h.WorkspaceEdit.from(p);S.edits=S.edits.concat(r)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$Lac=P}),define(Se[138],Ce([1,0,8,16,7]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mac=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,E,b,R,I,$){this.id=m,this.f=E,this.notebookData=b,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=R,this.c=$}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(E){this.selections=[E]},get selections(){return m.a},set selections(E){if(!Array.isArray(E)||!E.every(h.$2K.isNotebookRange))throw(0,k.$5)("selections");m.a=E,m.g(E)},get visibleRanges(){return m.b},revealRange(E,b){m.f.$tryRevealRange(m.id,F.NotebookRange.from(E),b??h.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(F.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$mac=A}),define(Se[268],Ce([1,0,8,3,18,16]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=void 0;let P=class{constructor(E,b){this.c=E,this.d=b,this.a=new F.$8c({onListenerError:k.$Z}),this.b=new F.$8c({onListenerError:k.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,b);const R=this.d.getEditorById(E);b.visibleRanges&&R._acceptVisibleRanges(b.visibleRanges.ranges.map(A.NotebookRange.to)),b.selections&&R._acceptSelections(b.selections.selections.map(A.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const b in E)this.d.getEditorById(b)._acceptViewColumn(A.ViewColumn.to(E[b]))}};e.$Eac=P,e.$Eac=P=Je([qe(0,h.$Ri)],P)}),define(Se[269],Ce([1,0,16,128,198,21,66,8]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I_b=void 0;class E{constructor($){this.b=0,this.c=new Map,this.a=$}async withProgress($,D,S){const p=this.b++,{title:r,location:s,cancellable:c}=D,f={label:(0,h.localize)(0,null,$.displayName||$.name),id:$.identifier.value};return this.a.$startProgress(p,{location:k.ProgressLocation.from(s),title:r,source:f,cancellable:c},$.isUnderDevelopment?void 0:$.identifier.value).catch(m.$Z),this.d(p,S,!!c)}d($,D,S){let p;S&&(p=new A.$ed,this.c.set($,p));const r=c=>{this.a.$progressEnd(c),this.c.delete(c),p?.dispose()};let s;try{s=D(new R(this.a,$),S&&p?p.token:A.CancellationToken.None)}catch(c){throw r($),c}return s.then(c=>r($),c=>r($)),s}$acceptProgressCanceled($){const D=this.c.get($);D&&(D.cancel(),this.c.delete($))}}e.$I_b=E;function b(I,$){return I.message=$.message,typeof $.increment=="number"&&(typeof I.increment=="number"?I.increment+=$.increment:I.increment=$.increment),I}class R extends F.$Nu{constructor($,D){super(S=>this.throttledReport(S)),this.f=$,this.g=D}throttledReport($){this.f.$progressReport(this.g,$)}}Je([(0,P.$Vg)(100,(I,$)=>b(I,$),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Se[139],Ce([1,0,33,136,59,103,82,16,2]),function(fe,e,k,F,h,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SL=e.$RL=e.$QL=e.$PL=void 0;const b=(f,y,C,i)=>{let o=y;return{enumerable:!0,configurable:!1,get(){return o},set(n){if(!C(o,n)){const t=o;o=n,f.listener?.(i(n,t))}}}},R=(f,y)=>f===y,I={range:(f,y)=>f===y?!0:!f||!y?!1:f.isEqual(y),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(f,y)=>!(f.length!==y.length||f.some(C=>!y.find(i=>C.id===i.id)))},$=f=>y=>({op:4,update:f(y)}),D=(f,y)=>({range:(()=>{let C;const i=$(o=>({range:k.$Or.lift(m.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return C},set(o){f.listener?.({op:6}),I.range(C,o)||(C=o,f.listener?.(i(o)))}}})(),label:b(f,y,I.label,$(C=>({label:C}))),description:b(f,void 0,I.description,$(C=>({description:C}))),sortText:b(f,void 0,I.sortText,$(C=>({sortText:C}))),canResolveChildren:b(f,!1,I.canResolveChildren,C=>({op:2,state:C})),busy:b(f,!1,I.busy,$(C=>({busy:C}))),error:b(f,void 0,I.error,$(C=>({error:m.MarkdownString.fromStrict(C)||null}))),tags:b(f,[],I.tags,(C,i)=>({op:1,new:C.map(m.TestTag.from),old:i.map(m.TestTag.from)}))}),S=f=>{const y=h.$nI.fromString(f.extId),C=new r(y.controllerId,y.localId,f.label,E.URI.revive(f.uri)||void 0);return C.range=m.Range.to(f.range||void 0),C.description=f.description||void 0,C.sortText=f.sortText||void 0,C.tags=f.tags.map(i=>m.TestTag.to({id:(0,P.$sI)(i).tagId})),C},p=f=>{let y;for(const C of f.tests){const i=S(C.item);(0,F.$zL)(i).parent=y,y=i}return y};e.$PL=p;class r{constructor(y,C,i,o){if(C.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(C)} symbol`);const n=(0,F.$yL)(this,y);Object.defineProperties(this,{id:{value:C,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof s?void 0:n.parent}},children:{value:(0,A.$xL)(n,F.$zL,r),enumerable:!0,writable:!1},...D(n,i)})}}e.$QL=r;class s extends r{constructor(y,C){super(y,y,C,void 0),this._isRoot=!0}}e.$RL=s;class c extends A.$tL{constructor(y,C,i){super({controllerId:y,getDocumentVersion:o=>o&&i.getDocument(o)?.version,getApiFor:F.$zL,getChildren:o=>o.children,root:new s(y,C),toITestItem:m.TestItem.from})}}e.$SL=c}),define(Se[140],Ce([1,0,53,8,111,16,7]),function(fe,e,k,F,h,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.$LL=e.$KL=void 0;class m{static{this.c=new h.$IL("TextEditorDecorationType")}constructor($,D,S){const p=m.c.nextId();$.$registerTextEditorDecorationType(D.identifier,p,A.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:p,dispose(){$.$removeTextEditorDecorationType(p)}})}}e.$KL=m;class E{constructor($,D){this.g=[],this.h=void 0,this.j=!1,this.c=$,this.d=$.version,this.e=D.undoStopBefore,this.f=D.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace($,D){this.k();let S=null;if($ instanceof P.$EJ)S=new P.$FJ($,$);else if($ instanceof P.$FJ)S=$;else throw new Error("Unrecognized location");this.l(S,D,!1)}insert($,D){this.k(),this.l(new P.$FJ($,$),D,!0)}delete($){this.k();let D=null;if($ instanceof P.$FJ)D=$;else throw new Error("Unrecognized location");this.l(D,null,!0)}l($,D,S){const p=this.c.validateRange($);this.g.push({range:p,text:D,forceMoveMarkers:S})}setEndOfLine($){if(this.k(),$!==P.EndOfLine.LF&&$!==P.EndOfLine.CRLF)throw(0,F.$5)("endOfLine");this.h=$}}class b{constructor($,D,S,p){this.c=$,this.d=D,this._accept(S),this.e=p;const r=this;this.value={get tabSize(){return r.f},set tabSize(s){r.m(s)},get indentSize(){return r.g},set indentSize(s){r.o(s)},get insertSpaces(){return r.h},set insertSpaces(s){r.q(s)},get cursorStyle(){return r.j},set cursorStyle(s){r.s(s)},get lineNumbers(){return r.k},set lineNumbers(s){r.t(s)}}}_accept($){this.f=$.tabSize,this.g=$.indentSize,this.h=$.insertSpaces,this.j=$.cursorStyle,this.k=A.TextEditorLineNumbersStyle.to($.lineNumbers)}l($){if($==="auto")return"auto";if(typeof $=="number"){const D=Math.floor($);return D>0?D:null}if(typeof $=="string"){const D=parseInt($,10);return isNaN(D)?null:D>0?D:null}return null}m($){const D=this.l($);if(D!==null){if(typeof D=="number"){if(this.f===D)return;this.f=D}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:D}))}}n($){if($==="tabSize")return"tabSize";if(typeof $=="number"){const D=Math.floor($);return D>0?D:null}if(typeof $=="string"){const D=parseInt($,10);return isNaN(D)?null:D>0?D:null}return null}o($){const D=this.n($);if(D!==null){if(typeof D=="number"){if(this.g===D)return;this.g=D}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:D}))}}p($){return $==="auto"?"auto":$==="false"?!1:!!$}q($){const D=this.p($);if(typeof D=="boolean"){if(this.h===D)return;this.h=D}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:D}))}s($){this.j!==$&&(this.j=$,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:$})))}t($){this.k!==$&&(this.k=$,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from($)})))}assign($){const D={};let S=!1;if(typeof $.tabSize<"u"){const p=this.l($.tabSize);p==="auto"?(S=!0,D.tabSize=p):typeof p=="number"&&this.f!==p&&(this.f=p,S=!0,D.tabSize=p)}if(typeof $.indentSize<"u"){const p=this.n($.indentSize);p==="tabSize"?(S=!0,D.indentSize=p):typeof p=="number"&&this.g!==p&&(this.g=p,S=!0,D.indentSize=p)}if(typeof $.insertSpaces<"u"){const p=this.p($.insertSpaces);p==="auto"?(S=!0,D.insertSpaces=p):this.h!==p&&(this.h=p,S=!0,D.insertSpaces=p)}typeof $.cursorStyle<"u"&&this.j!==$.cursorStyle&&(this.j=$.cursorStyle,S=!0,D.cursorStyle=$.cursorStyle),typeof $.lineNumbers<"u"&&this.k!==$.lineNumbers&&(this.k=$.lineNumbers,S=!0,D.lineNumbers=A.TextEditorLineNumbersStyle.from($.lineNumbers)),S&&this.u("setOptions",this.c.$trySetOptions(this.d,D))}u($,D){D.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${$}' failed:'`),this.e.warn(S)})}}e.$LL=b;class R{constructor($,D,S,p,r,s,c,f){this.id=$,this.j=D,this.k=S,this.g=!1,this.h=new Set,this.c=r,this.d=new b(this.j,this.id,s,S),this.e=c,this.f=f;const y=this;this.value=Object.freeze({get document(){return p.value},set document(C){throw(0,F.$7)("document")},get selection(){return y.c&&y.c[0]},set selection(C){if(!(C instanceof P.$GJ))throw(0,F.$5)("selection");y.c=[C],y.l()},get selections(){return y.c},set selections(C){if(!Array.isArray(C)||C.some(i=>!(i instanceof P.$GJ)))throw(0,F.$5)("selections");y.c=C,y.l()},get visibleRanges(){return y.e},set visibleRanges(C){throw(0,F.$7)("visibleRanges")},get options(){return y.d.value},set options(C){y.g||y.d.assign(C)},get viewColumn(){return y.f},set viewColumn(C){throw(0,F.$7)("viewColumn")},edit(C,i={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new E(p.value,i);return C(o),y.m(o)},insertSnippet(C,i,o={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!i||Array.isArray(i)&&i.length===0)n=y.c.map(t=>A.Range.from(t));else if(i instanceof P.$EJ){const{lineNumber:t,column:a}=A.Position.from(i);n=[{startLineNumber:t,startColumn:a,endLineNumber:t,endColumn:a}]}else if(i instanceof P.$FJ)n=[A.Range.from(i)];else{n=[];for(const t of i)if(t instanceof P.$FJ)n.push(A.Range.from(t));else{const{lineNumber:a,column:g}=A.Position.from(t);n.push({startLineNumber:a,startColumn:g,endLineNumber:a,endColumn:g})}}return D.$tryInsertSnippet($,p.value.version,C.value,n,o)},setDecorations(C,i){const o=i.length===0;o&&!y.h.has(C.key)||(o?y.h.delete(C.key):y.h.add(C.key),y.n(()=>{if(A.$AL(i))return D.$trySetDecorations($,C.key,A.$BL(i));{const n=new Array(4*i.length);for(let t=0,a=i.length;t<a;t++){const g=i[t];n[4*t]=g.start.line+1,n[4*t+1]=g.start.character+1,n[4*t+2]=g.end.line+1,n[4*t+3]=g.end.character+1}return D.$trySetDecorationsFast($,C.key,n)}}))},revealRange(C,i){y.n(()=>D.$tryRevealRange($,A.Range.from(C),i||P.TextEditorRevealType.Default))},show(C){D.$tryShowEditor($,A.ViewColumn.from(C))},hide(){D.$tryHideEditor($)}})}dispose(){(0,k.ok)(!this.g),this.g=!0}_acceptOptions($){(0,k.ok)(!this.g),this.d._accept($)}_acceptVisibleRanges($){(0,k.ok)(!this.g),this.e=$}_acceptViewColumn($){(0,k.ok)(!this.g),this.f=$}_acceptSelections($){(0,k.ok)(!this.g),this.c=$}async l(){const $=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,$)),this.value}m($){const D=$.finalize();if(D.edits.length===0&&!D.setEndOfLine)return Promise.resolve(!0);const S=D.edits.map(r=>r.range);S.sort((r,s)=>r.end.line===s.end.line?r.end.character===s.end.character?r.start.line===s.start.line?r.start.character-s.start.character:r.start.line-s.start.line:r.end.character-s.end.character:r.end.line-s.end.line);for(let r=0,s=S.length-1;r<s;r++){const c=S[r].end;if(S[r+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=D.edits.map(r=>({range:A.Range.from(r.range),text:r.text,forceMoveMarkers:r.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,D.documentVersionId,p,{setEndOfLine:typeof D.setEndOfLine=="number"?A.EndOfLine.from(D.setEndOfLine):void 0,undoStopBefore:D.undoStopBefore,undoStopAfter:D.undoStopAfter})}n($){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):$().then(()=>this,D=>(D instanceof Error&&D.name==="DISPOSED"||this.k.warn(D),null))}}e.$ML=R}),define(Se[270],Ce([1,0,5,219]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RI=void 0,e.$RI=(0,k.$qh)(F.$wh)}),define(Se[141],Ce([1,0,25,3,13,4]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v1b=e.$u1b=e.$t1b=e.$s1b=e.$r1b=void 0;class P{constructor(r){this.removedDueToLooping=r}}e.$r1b=P;class m{static isHostExtension(r,s,c){if(s.getExtensionDescription(r))return!1;const f=c.getExtensionDescription(r);return f?!!((f.main||f.browser)&&f.api==="none"):!1}constructor(r,s){this.h=r,this.c=new F.$8c,this.onDidChange=this.c.event,this.d=s,this.j()}j(){this.d.sort(D),this.e=new k.$Jl,this.f=[],this.g=new Map;for(const r of this.d){if(this.e.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.e.set(r.identifier,r),this.f.push(r);const s=this.h.readActivationEvents(r);if(Array.isArray(s))for(let c of s)c==="onUri"&&(c=`onUri:${k.$Hl.toKey(r.identifier)}`),this.g.has(c)||this.g.set(c,[]),this.g.get(c).push(r)}}set(r){this.d=r,this.j(),this.c.fire(void 0)}deltaExtensions(r,s){this.d=S(this.d,s),this.d=this.d.concat(r);const c=m.k(this.d);return this.d=S(this.d,c.map(f=>f.identifier)),this.j(),this.c.fire(void 0),new P(c)}static k(r){const s=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(i){this.d.has(i)||(this.d.add(i),this.e.push(i))}addArc(i,o){this.addNode(i),this.addNode(o),this.c.has(i)?this.c.get(i).push(o):this.c.set(i,[o])}getArcs(i){return this.c.has(i)?this.c.get(i):[]}hasOnlyGoodArcs(i,o){const n=s.getArcs(i);for(let t=0;t<n.length;t++)if(!o.has(n[t]))return!1;return!0}getNodes(){return this.e}},c=new k.$Jl;for(const i of r)if(c.set(i.identifier,i),i.extensionDependencies)for(const o of i.extensionDependencies)s.addArc(k.$Hl.toKey(i.identifier),k.$Hl.toKey(o));const f=new Set;s.getNodes().filter(i=>s.getArcs(i).length===0).forEach(i=>f.add(i));const y=s.getNodes().filter(i=>!f.has(i));let C;do{C=!1;for(let i=0;i<y.length;i++){const o=y[i];s.hasOnlyGoodArcs(o,f)&&(y.splice(i,1),i--,f.add(o),C=!0)}}while(C);return y.map(i=>c.get(i))}containsActivationEvent(r){return this.g.has(r)}containsExtension(r){return this.e.has(r)}getExtensionDescriptionsForActivationEvent(r){const s=this.g.get(r);return s?s.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(r){const s=this.e.get(r);return s||void 0}getExtensionDescriptionByUUID(r){for(const s of this.f)if(s.uuid===r)return s}getExtensionDescriptionByIdOrUUID(r,s){return this.getExtensionDescription(r)??(s?this.getExtensionDescriptionByUUID(s):void 0)}}e.$s1b=m,e.$t1b={readActivationEvents:p=>p.activationEvents};class E{constructor(r){this.d=new I,this.c=new m(r,[])}async acquireLock(r){const s=await this.d.acquire(r);return new b(this,s)}deltaExtensions(r,s,c){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(s,c)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,s){return this.c.getExtensionDescriptionByIdOrUUID(r,s)}}e.$u1b=E;class b extends A.$lb{constructor(r,s){super(),this.f=r,this.c=!1,this.B(s)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$v1b=b;class R{constructor(r){this.name=r,this.promise=new Promise((s,c)=>{this.c=s})}resolve(r){this.c(r)}}class I{constructor(){this.c=[],this.d=!1}async acquire(r){const s=new R(r);return this.c.push(s),this.e(),s.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let s=!0;const c=setTimeout(()=>{s&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),f=()=>{s&&(clearTimeout(c),s=!1,this.d=!1,this.e())};r.resolve((0,A.$jb)(f))}}var $;(function(p){p[p.Builtin=0]="Builtin",p[p.User=1]="User",p[p.Dev=2]="Dev"})($||($={}));function D(p,r){const s=p.isBuiltin?0:p.isUnderDevelopment?2:1,c=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(s!==c)return s-c;const f=h.$0b.basename(p.extensionLocation.path),y=h.$0b.basename(r.extensionLocation.path);return f<y?-1:f>y?1:0}function S(p,r){const s=new k.$Il(r);return p.filter(c=>!s.has(c.identifier))}}),define(Se[271],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.ExtHostConnectionType=void 0;var k;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(k||(e.ExtHostConnectionType=k={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[F.ENV_KEY]=this.pipeName}}e.$_l=F;class h{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[h.ENV_KEY]="1"}}e.$am=h;class A{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[A.ENV_KEY]="1"}}e.$bm=A;function P(R){delete R[F.ENV_KEY],delete R[h.ENV_KEY],delete R[A.ENV_KEY]}function m(R,I){P(I),R.serialize(I)}e.$cm=m;function E(R){if(R[F.ENV_KEY])return b(R,new F(R[F.ENV_KEY]));if(R[h.ENV_KEY])return b(R,new h);if(R[A.ENV_KEY])return b(R,new A);throw new Error("No connection information defined in environment!")}e.$dm=E;function b(R,I){return P(R),I}}),define(Se[105],Ce([1,0,22]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Ql=e.$Pl=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(F||(e.UIKind=F={}));var h;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(h||(e.ExtensionHostExitCode=h={}));var A;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function P(b){const R=k.$Jb.alloc(1);switch(b){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$Pl=P;function m(b,R){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$Ql=m;var E;(function(b){b.Start="START_NATIVE_LOG",b.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(Se[83],Ce([1,0,5,3,18,26,105,79,80,23,2,4,200]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XL=e.$WL=e.$VL=e.$UL=void 0;let D=class extends I.$lb{constructor(s,c){super(),this.n=s,this.p=c,this.a=this.B(new F.$8c),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$8c),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=R.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=c.createLogger(this.j,{id:E.$7n,name:(0,$.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(f=>{(0,h.$Ti)(f)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===h.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,c,f){const y=this.getTelemetryDetails(),C=new S(c,f,s,this.k,this.i,this.getBuiltInCommonProperties(s),{isUsageEnabled:y.isUsageEnabled,isErrorsEnabled:y.isErrorsEnabled}),i=this.m.get(s.identifier.value)??[];return this.m.set(s.identifier.value,[...i,C]),C.apiTelemetryLogger}$initializeTelemetryLevel(s,c,f){this.f=s,this.g=c,this.c=f??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(s){const c=Object.create(null);switch(c["common.extname"]=`${s.publisher}.${s.name}`,c["common.extversion"]=s.version,c["common.vscodemachineid"]=this.n.telemetryInfo.machineId,c["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,c["common.vscodeversion"]=this.n.version,c["common.isnewappinstall"]=p(this.n.telemetryInfo.firstSessionDate),c["common.product"]=this.n.environment.appHost,this.n.uiKind){case P.UIKind.Web:c["common.uikind"]="web";break;case P.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,m.$Ck)((0,E.$bo)(this.n.remote.authority)),c}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const c=this.getTelemetryDetails();this.m.forEach((f,y)=>{const C=f.filter(i=>!i.isDisposed);C.length===0?this.m.delete(y):this.m.set(y,C)}),this.m.forEach(f=>{for(const y of f)y.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(s,c){const y=this.m.get(s.value)?.filter(i=>!i.isDisposed);if(!y)return this.m.delete(s.value),!1;let C=!1;for(const i of y)i.ignoreUnhandledExtHostErrors||(i.logError(c),C=!0);return C}};e.$UL=D,e.$UL=D=Je([qe(0,A.$TL),qe(1,h.$Si)],D);class S{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,c,f,y,C,i,o){this.g=f,this.h=y,this.i=C,this.j=i,this.a=new F.$8c,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(s,c){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let c="properties"in s?s.properties??{}:s;return c=(0,E.$eo)(c,[]),this.c&&(c=(0,b.$Km)(c,this.c)),this.b||(c=(0,b.$Km)(c,this.j)),"properties"in s?s.properties=c:s=c,s}k(s,c){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(s,c),this.h.trace(s,c))}logUsage(s,c){this.d.isUsageEnabled&&this.k(s,c)}logError(s,c){!this.d.isErrorsEnabled||!this.f||(typeof s=="string"?this.k(s,c):this.f.sendErrorData(s,c))}get apiTelemetryLogger(){if(!this.e){const s=this,c={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$VL=S;function p(r){const s=Date.now()-new Date(r).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$WL=p,e.$XL=(0,k.$ph)("IExtHostTelemetry")}),define(Se[27],Ce([1,0,3,2,240,131,25,5]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EF=e.$DF=e.$CF=e.ActivationKind=e.$BF=e.$AF=e.$zF=e.$yF=e.$xF=e.ExtensionHostStartup=e.$wF=e.$vF=e.$uF=e.$tF=void 0,e.$tF=Object.freeze({identifier:new P.$Hl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$uF="extensions.webWorker",e.$vF=(0,m.$ph)("extensionService");class E{constructor(C){this.dependency=C}}e.$wF=E;var b;(function(y){y[y.EagerAutoStart=1]="EagerAutoStart",y[y.EagerManualStart=2]="EagerManualStart",y[y.Lazy=3]="Lazy"})(b||(e.ExtensionHostStartup=b={}));class R{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:A.$kF.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(C,i){const o=[],n=[],t=[],a=[],g=I(this.c),u=I(C),d=(O,N)=>O.extensionLocation.toString()===N.extensionLocation.toString()||O.isBuiltin===N.isBuiltin||O.isUserBuiltin===N.isUserBuiltin||O.isUnderDevelopment===N.isUnderDevelopment;for(const O of this.c){const N=u.get(O.identifier);if(!N){o.push(O.identifier),g.delete(O.identifier);continue}if(!d(O,N)){o.push(O.identifier),g.delete(O.identifier);continue}}for(const O of C){const N=g.get(O.identifier);if(!N){n.push(O);continue}if(!d(N,O)){o.push(N.identifier),g.delete(N.identifier);continue}}const v=new P.$Il(this.d),l=new P.$Il(i);for(const O of this.d)l.has(O)||t.push(O);for(const O of i)v.has(O)||a.push(O);const w=A.$kF.createActivationEventsMap(n),L={toRemove:o,toAdd:n,addActivationEvents:w,myToRemove:t,myToAdd:a};return this.delta(L),L}delta(C){const{toRemove:i,toAdd:o,myToRemove:n,myToAdd:t}=C,a=new P.$Il(i),g=new P.$Il(n);for(let u=0;u<this.c.length;u++)a.has(this.c[u].identifier)&&(this.c.splice(u,1),u--);for(let u=0;u<this.d.length;u++)g.has(this.d[u])&&(this.d.splice(u,1),u--);for(const u of o)this.c.push(u);for(const u of t)this.d.push(u)}containsExtension(C){for(const i of this.d)if(P.$Hl.equals(i,C))return!0;return!1}}e.$xF=R;function I(y){const C=new P.$Jl;for(const i of y)C.set(i.identifier,i);return C}function $(y,C){return y.enabledApiProposals?y.enabledApiProposals.includes(C):!1}e.$yF=$;function D(y,C){if(!$(y,C))throw new Error(`Extension '${y.identifier.value}' CANNOT use API proposal: ${C}.
Its package.json#enabledApiProposals-property declares: ${y.enabledApiProposals?.join(", ")??"[]"} but NOT ${C}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${y.identifier.value}`)}e.$zF=D;class S{constructor(C,i,o,n){this.codeLoadingTime=C,this.activateCallTime=i,this.activateResolvedTime=o,this.activationReason=n}}e.$AF=S;class p{constructor(C,i){this.description=C,this.value=i}}e.$BF=p;var r;(function(y){y[y.Normal=0]="Normal",y[y.Immediate=1]="Immediate"})(r||(e.ActivationKind=r={}));function s(y){return{type:y.isBuiltin?0:1,isBuiltin:y.isBuiltin||y.isUserBuiltin,identifier:{id:(0,h.$ko)(y.publisher,y.name),uuid:y.uuid},manifest:y,location:y.extensionLocation,targetPlatform:y.targetPlatform,validations:[],isValid:!0}}e.$CF=s;function c(y,C){return{identifier:new P.$Hl((0,h.$io)(y.manifest.publisher,y.manifest.name)),isBuiltin:y.type===0,isUserBuiltin:y.type===1&&y.isBuiltin,isUnderDevelopment:!!C,extensionLocation:y.location,...y.manifest,uuid:y.identifier.uuid,targetPlatform:y.targetPlatform}}e.$DF=c;class f{constructor(){this.onDidRegisterExtensions=k.Event.None,this.onDidChangeExtensionsStatus=k.Event.None,this.onDidChangeExtensions=k.Event.None,this.onWillActivateByEvent=k.Event.None,this.onDidChangeResponsiveChange=k.Event.None,this.onWillStop=k.Event.None,this.extensions=[]}activateByEvent(C){return Promise.resolve(void 0)}activationEventIsDone(C){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(C){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(C,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(C){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$EF=f}),define(Se[272],Ce([1,0,8,141,25,27,18,17]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d_b=e.$c_b=e.$b_b=e.$a_b=e.$_$b=e.$$$b=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(s,c,f,y){this.startup=s,this.codeLoadingTime=c,this.activateCallTime=f,this.activateResolvedTime=y}}e.$$$b=E;class b{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,c){return s===-1||c===-1?-1:c-s}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$_$b=b;class R{constructor(s,c,f,y,C,i){this.activationFailed=s,this.activationFailedError=c,this.activationTimes=f,this.module=y,this.exports=C,this.subscriptions=i}}e.$a_b=R;class I extends R{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$b_b=I;class $ extends R{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$c_b=$;class D extends R{constructor(s){super(!0,s,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(s,c,f,y){this.g=y,this.a=s,this.b=c,this.c=f,this.d=new h.$Jl,this.f=Object.create(null)}dispose(){for(const[s,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const s=[];for(const[c,f]of this.d)s.push(f.wait());await Promise.all(s)}isActivated(s){const c=this.d.get(s);return!!(c&&c.value)}getActivatedExtension(s){const c=this.d.get(s);if(!c||!c.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return c.value}async activateByEvent(s,c){if(this.f[s])return;const f=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(f.map(y=>({id:y.identifier,reason:{startup:c,extensionId:y.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,c){const f=this.a.getExtensionDescription(s);if(!f)throw new Error(`Extension '${s}' is not known`);return this.h([{id:f.identifier,reason:c}])}async h(s){const c=s.filter(f=>!this.isActivated(f.id)).map(f=>this.j(f));await Promise.all(c.map(f=>f.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const c=this.a.getExtensionDescription(s.id);if(!c){const C=new Error(`Cannot activate unknown extension '${s.id.value}'`),i=this.k(s,null,[],new D(C));return this.c.onExtensionActivationError(s.id,C,new A.$wF(s.id.value)),i}const f=[],y=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const C of y){if(this.m(C))continue;const i=this.d.get(C);if(i){f.push(i);continue}if(this.l(C)){f.push(this.j({id:this.b.getExtensionDescription(C).identifier,reason:s.reason}));continue}const o=this.a.getExtensionDescription(C);if(o){if(!o.main&&!o.browser)continue;f.push(this.j({id:o.identifier,reason:s.reason}));continue}const n=c.displayName||c.identifier.value,t=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${C}'`),a=this.k(s,c.displayName,[],new D(t));return this.c.onExtensionActivationError(c.identifier,t,new A.$wF(C)),a}return this.k(s,c.displayName,f,null)}k(s,c,f,y){const C=new p(s.id,c,s.reason,f,y,this.c,this.g);return this.d.set(s.id,C),C}l(s){return F.$s1b.isHostExtension(s,this.a,this.b)}m(s){const c=this.b.getExtensionDescription(s);return c?!c.main&&!c.browser:!1}};e.$d_b=S,e.$d_b=S=Je([qe(3,P.$Ri)],S);let p=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,c,f,y,C,i,o){this.c=s,this.d=c,this.f=f,this.g=y,this.h=C,this.j=i,this.k=o,this.a=new m.$ug,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const c=this.g[s];if(c.value&&!c.value.activationFailed){this.g.splice(s,1),s--;continue}if(c.value&&c.value.activationFailed){const f=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);f.detail=c.value.activationFailedError,this.h=new D(f),this.j.onExtensionActivationError(this.c,f,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const c=new Error;if(s&&s.name&&(c.name=s.name),s&&s.message?c.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(c.stack=s.stack),this.h=new D(c),this.b&&k.$2(s))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};p=Je([qe(6,P.$Ri)],p)}),define(Se[273],Ce([1,0,202,7,24,2,3,4,254,17,7,14,19,16,74,21,166,27]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P_b=void 0;function c(C,i){if((0,I.$je)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let o;return Array.isArray(C.highlights)&&(o=C.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),o=o.length?o:void 0),{label:C.label,highlights:o}}}class f{constructor(i,o,n){this.d=i,this.e=o,this.f=n,this.a=new Map,this.b=new r.$z5;function t(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}o.registerArgumentProcessor({processArgument:a=>t(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(g=>t(g)?this.i(g):g):a})}registerTreeDataProvider(i,o,n){const t=this.createTreeView(i,{treeDataProvider:o},n);return{dispose:()=>t.dispose()}}createTreeView(i,o,n){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=o.dragAndDropController?.dropMimeTypes??[],a=o.dragAndDropController?.dragMimeTypes??[],g=!!o.dragAndDropController?.handleDrag,u=!!o.dragAndDropController?.handleDrop,d=this.h(i,o,n),v={showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dropMimeTypes:t,dragMimeTypes:a,hasHandleDrag:g,hasHandleDrop:u,manuallyManageCheckboxes:!!o.manageCheckboxStateManually},l=this.d.$registerTreeViewDataProvider(i,v);return{get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get activeItem(){return(0,s.$zF)(n,"treeViewActiveItem"),d.focusedElement},get onDidChangeActiveItem(){return(0,s.$zF)(n,"treeViewActiveItem"),d.onDidChangeActiveItem},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return d.onDidChangeCheckboxState},get message(){return d.message},set message(L){(0,S.$Mj)(L)&&(0,s.$zF)(n,"treeViewMarkdownMessage"),d.message=L},get title(){return d.title},set title(L){d.title=L},get description(){return d.description},set description(L){d.description=L},get badge(){return d.badge},set badge(L){L!==void 0&&R.ViewBadge.isViewBadge(L)?d.badge={value:Math.floor(Math.abs(L.value)),tooltip:L.tooltip}:L===void 0&&(d.badge=void 0)},reveal:(L,O)=>d.reveal(L,O),dispose:async()=>{await l,this.a.delete(i),d.dispose()}}}$getChildren(i,o){const n=this.a.get(i);return n?n.getChildren(o):Promise.reject(new E.$XE(i))}async $handleDrop(i,o,n,t,a,g,u,d){const v=this.a.get(i);if(!v)return Promise.reject(new E.$XE(i));const l=D.DataTransfer.toDataTransfer(n,async w=>(await this.d.$resolveDropFileData(i,o,w)).buffer);return u===i&&d&&await this.g(l,v,d,a,g),v.onDrop(l,t,a)}async g(i,o,n,t,a){const g=this.b.removeDragOperationTransfer(a);if(g)(await g)?.forEach((u,d)=>{u&&i.set(d,u)});else if(a&&o.handleDrag){const u=o.handleDrag(n,i,t);this.b.addDragOperationTransfer(a,u),await u}return i}async $handleDrag(i,o,n,t){const a=this.a.get(i);if(!a)return Promise.reject(new E.$XE(i));const g=await this.g(new F.$vK,a,o,t,n);if(!(!g||t.isCancellationRequested))return D.DataTransfer.from(g)}async $hasResolve(i){const o=this.a.get(i);if(!o)throw new E.$XE(i);return o.hasResolve}$resolve(i,o,n){const t=this.a.get(i);if(!t)throw new E.$XE(i);return t.resolveTreeItem(o,n)}$setExpanded(i,o,n){const t=this.a.get(i);if(!t)throw new E.$XE(i);t.setExpanded(o,n)}$setSelectionAndFocus(i,o,n){const t=this.a.get(i);if(!t)throw new E.$XE(i);t.setSelectionAndFocus(o,n)}$setVisible(i,o){const n=this.a.get(i);if(!n)throw new E.$XE(i);n.setVisible(o)}$changeCheckboxState(i,o){const n=this.a.get(i);if(!n)throw new E.$XE(i);n.setCheckboxState(o)}h(i,o,n){const t=new y(i,o,this.d,this.e.converter,this.f,n);return this.a.set(i,t),t}i(i){const o=this.a.get(i.$treeViewId);return o&&"$treeItemHandle"in i?o.getExtensionElement(i.$treeItemHandle):o&&"$focusedTreeItem"in i&&i.$focusedTreeItem?o.focusedElement:null}}e.$P_b=f;class y extends m.$lb{static{this.a="0"}static{this.b="1"}get visible(){return this.k}get selectedElements(){return this.l.map(i=>this.getExtensionElement(i)).filter(i=>!(0,I.$se)(i))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(i,o,n,t,a,g){if(super(),this.D=i,this.F=n,this.G=t,this.H=a,this.I=g,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new P.$8c),this.onDidExpandElement=this.r.event,this.s=this.B(new P.$8c),this.onDidCollapseElement=this.s.event,this.t=this.B(new P.$8c),this.onDidChangeSelection=this.t.event,this.u=this.B(new P.$8c),this.onDidChangeActiveItem=this.u.event,this.v=this.B(new P.$8c),this.onDidChangeVisibility=this.v.event,this.w=this.B(new P.$8c),this.onDidChangeCheckboxState=this.w.event,this.y=this.B(new P.$8c),this.z=Promise.resolve(),this.C=Promise.resolve(),this.J="",this.L="",this.U=new p.$ed,g.contributes&&g.contributes.views)for(const v in g.contributes.views)for(const l of g.contributes.views[v])l.id===i&&(this.L=l.name);this.f=o.treeDataProvider,this.g=o.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.y.fire({message:!1,element:v})));let u,d;this.B(P.Event.debounce(this.y.event,(v,l)=>(v||(v={message:!1,elements:[]}),l.element!==!1&&(u||(u=new Promise(w=>d=w),this.z=this.z.then(()=>u)),Array.isArray(l.element)?v.elements.push(...l.element):v.elements.push(l.element)),l.message&&(v.message=!0),v),200,!0)(({message:v,elements:l})=>{l.length&&(this.C=this.C.then(()=>{const w=d;return u=null,this.W(l).then(()=>w())})),v&&this.F.$setMessage(this.D,D.MarkdownString.fromStrict(this.J)??"")}))}async getChildren(i){const o=i?this.getExtensionElement(i):void 0;if(i&&!o)return this.H.error(`No tree item with id '${i}' found.`),Promise.resolve([]);let n=this.R(i);return n||(n=await this.S(o)),n?n.map(t=>t.item):void 0}getExtensionElement(i){return this.i.get(i)}reveal(i,o){o=o||{select:!0,focus:!1};const n=(0,I.$se)(o.select)?!0:o.select,t=(0,I.$se)(o.focus)?!1:o.focus,a=(0,I.$se)(o.expand)?!1:o.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):i?this.z.then(()=>this.O(i)).then(g=>this.Q(i,g[g.length-1]).then(u=>this.F.$reveal(this.D,{item:u.item,parentChain:g.map(d=>d.item)},{select:n,focus:t,expand:a})),g=>this.H.error(g)):this.F.$reveal(this.D,void 0,{select:n,focus:t,expand:a})}get message(){return this.J}set message(i){this.J=i,this.y.fire({message:!0,element:!1})}get title(){return this.L}set title(i){this.L=i,this.F.$setTitle(this.D,i,this.M)}get description(){return this.M}set description(i){this.M=i,this.F.$setTitle(this.D,this.L,i)}get badge(){return this.N}set badge(i){this.N?.value===i?.value&&this.N?.tooltip===i?.tooltip||(this.N=D.ViewBadge.from(i),this.F.$setBadge(this.D,i))}setExpanded(i,o){const n=this.getExtensionElement(i);n&&(o?this.r.fire(Object.freeze({element:n})):this.s.fire(Object.freeze({element:n})))}setSelectionAndFocus(i,o){const n=!(0,$.$bf)(this.l,i);this.l=i;const t=this.m!==o;this.m=o,n&&this.t.fire(Object.freeze({selection:this.selectedElements})),t&&this.u.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(i){i!==this.k&&(this.k=i,this.v.fire(Object.freeze({visible:this.k})))}async setCheckboxState(i){const o=(await Promise.all(i.map(async n=>{const t=this.getExtensionElement(n.treeItemHandle);return t?{extensionItem:t,treeItem:await this.f.getTreeItem(t),newState:n.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);o.forEach(n=>{n.treeItem.checkboxState=n.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}),this.w.fire({items:o.map(n=>[n.extensionItem,n.newState])})}async handleDrag(i,o,n){const t=[];for(const a of i){const g=this.getExtensionElement(a);g&&t.push(g)}if(!(!this.g?.handleDrag||t.length===0))return await this.g.handleDrag(t,o,n),o}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(i,o,n){const t=o?this.getExtensionElement(o):void 0;if(!(!t&&o||!this.g?.handleDrop))return(0,b.$og)(()=>this.g?.handleDrop?this.g.handleDrop(t,i,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(i,o){if(!this.f.resolveTreeItem)return;const n=this.i.get(i);if(n){const t=this.j.get(n);if(t){const a=await this.f.resolveTreeItem(t.extensionItem,n,o)??t.extensionItem;return this.db(a),t.item.tooltip=this.ab(a.tooltip),t.item.command=this.bb(t.disposableStore,a.command),t.item}}}O(i){return this.P(i).then(o=>o?this.O(o).then(n=>this.Q(o,n[n.length-1]).then(t=>(n.push(t),n))):Promise.resolve([]))}P(i){const o=this.j.get(i);return o?Promise.resolve(o.parent?this.i.get(o.parent.item.handle):void 0):(0,b.$og)(()=>this.f.getParent(i))}Q(i,o){const n=this.j.get(i);return n?Promise.resolve(n):(0,b.$og)(()=>this.f.getTreeItem(i)).then(t=>this.gb(i,t,o,!0)).then(t=>this.getChildren(o?o.item.handle:void 0).then(()=>{const a=this.getExtensionElement(t);if(a){const g=this.j.get(a);if(g)return Promise.resolve(g)}throw new Error(`Cannot resolve tree item for element ${t} from extension ${this.I.identifier.value}`)}))}R(i){if(i){let o;if(typeof i=="string"){const n=this.getExtensionElement(i);o=n?this.j.get(n):void 0}else o=i;return o&&o.children||void 0}return this.h}async S(i){this.nb(i);const o=new p.$ed(this.U.token);try{const n=i?this.j.get(i):void 0,t=await this.f.getChildren(i);if(o.token.isCancellationRequested)return;const a=await Promise.all((0,$.$mf)(t||[]).map(async g=>{const u=await this.f.getTreeItem(g);return u&&!o.token.isCancellationRequested?this.$(g,u,n):null}));return o.token.isCancellationRequested?void 0:(0,$.$mf)(a)}finally{o.dispose()}}W(i){if(i.some(n=>!n))return this.U.dispose(!0),this.U=new p.$ed,this.pb(),this.F.$refresh(this.D);{const n=this.X(i);if(n.length)return this.Y(n)}return Promise.resolve(void 0)}X(i){const o=new Set,n=i.map(a=>this.j.get(a));for(const a of n)if(a&&!o.has(a.item.handle)){let g=a;for(;g&&g.parent&&n.findIndex(u=>g&&g.parent&&u&&u.item.handle===g.parent.item.handle)===-1;){const u=this.i.get(g.parent.item.handle);g=u?this.j.get(u):void 0}g&&!g.parent&&o.add(a.item.handle)}const t=[];return o.forEach(a=>{const g=this.i.get(a);if(g){const u=this.j.get(g);u&&(!u.parent||!o.has(u.parent.item.handle))&&t.push(a)}}),t}Y(i){const o={};return Promise.all(i.map(n=>this.Z(n).then(t=>{t&&(o[n]=t.item)}))).then(()=>Object.keys(o).length?this.F.$refresh(this.D,o):void 0)}Z(i){const o=this.getExtensionElement(i);if(o){const n=this.j.get(o);if(n)return this.nb(o),(0,b.$og)(()=>this.f.getTreeItem(o)).then(t=>{if(t){const a=this.eb(o,t,n.parent);return this.lb(o,a,n,n.parent),n.dispose(),a}return null})}return Promise.resolve(null)}$(i,o,n){const t=this.eb(i,o,n);if(o.id&&this.i.has(t.item.handle))throw new Error((0,k.localize)(0,null,o.id));return this.kb(i,t),this.mb(t,n),t}ab(i){return R.$5J.isMarkdownString(i)?D.MarkdownString.from(i):i}bb(i,o){return o?{...this.G.toInternal(o,i),originalId:o.command}:void 0}cb(i){if(i.checkboxState===void 0)return;let o,n,t;return typeof i.checkboxState=="number"?o=i.checkboxState:(o=i.checkboxState.state,n=i.checkboxState.tooltip,t=i.checkboxState.accessibilityInformation),{isChecked:o===R.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:t}}db(i){if(!R.$qK.isTreeItem(i,this.I))throw new Error(`Extension ${this.I.identifier.value} has provided an invalid tree item.`)}eb(i,o,n){this.db(o);const t=new m.$kb,a=this.gb(i,o,n),g=this.hb(o);return{item:{handle:a,parentHandle:n?n.item.handle:void 0,label:c(o.label,this.I),description:o.description,resourceUri:o.resourceUri,tooltip:this.ab(o.tooltip),command:this.bb(t,o.command),contextValue:o.contextValue,icon:g,iconDark:this.ib(o)||g,themeIcon:this.fb(o),collapsibleState:(0,I.$se)(o.collapsibleState)?R.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation,checkbox:this.cb(o)},extensionItem:o,parent:n,children:void 0,disposableStore:t,dispose(){t.dispose()}}}fb(i){return i.iconPath instanceof R.$yK?i.iconPath:void 0}gb(i,{id:o,label:n,resourceUri:t},a,g){if(o)return`${y.b}/${o}`;const u=c(n,this.I),d=a?a.item.handle:y.a;let v=u?u.label:t?(0,h.$7f)(t):"";v=v.indexOf("/")!==-1?v.replace("/","//"):v;const l=this.j.has(i)?this.j.get(i).item.handle:void 0,w=this.R(a)||[];let L,O=0;do{if(L=`${d}/${O}:${v}`,g||!this.i.has(L)||l===L)break;O++}while(O<=w.length);return L}hb(i){if(i.iconPath&&!(i.iconPath instanceof R.$yK))return typeof i.iconPath=="string"||A.URI.isUri(i.iconPath)?this.jb(i.iconPath):this.jb(i.iconPath.light)}ib(i){if(i.iconPath&&!(i.iconPath instanceof R.$yK)&&i.iconPath.dark)return this.jb(i.iconPath.dark)}jb(i){return A.URI.isUri(i)?i:A.URI.file(i)}kb(i,o){this.i.set(o.item.handle,i),this.j.set(i,o)}lb(i,o,n,t){this.i.delete(o.item.handle),this.j.delete(i),o.item.handle!==n.item.handle&&this.i.delete(n.item.handle),this.kb(i,o);const a=this.R(t)||[],g=a.filter(u=>u.item.handle===n.item.handle)[0];g&&a.splice(a.indexOf(g),1,o)}mb(i,o){o?(o.children||(o.children=[]),o.children.push(i)):(this.h||(this.h=[]),this.h.push(i))}nb(i){if(i){const o=this.j.get(i);if(o){if(o.children)for(const n of o.children){const t=this.i.get(n.item.handle);t&&this.ob(t)}o.children=void 0}}else this.pb()}ob(i){const o=this.j.get(i);if(o){if(o.children)for(const n of o.children){const t=this.i.get(n.item.handle);t&&this.ob(t)}this.j.delete(i),this.i.delete(o.item.handle),o.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(i=>i.dispose()),this.j.clear()}dispose(){this.U.dispose(),this.pb(),this.F.$disposeTree(this.D)}}}),define(Se[274],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionOptions.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveSlashCommands.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[275],Ce([1,0,214,8,40,125,100,42,25,274,234,131]),function(fe,e,k,F,h,A,P,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KF=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=void 0;const $=m.$Tm.as(P.$Um.JSONContribution);class D{constructor(C,i,o){this.a=C,this.b=i,this.c=o}d(C,i){this.a({type:C,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(C){this.d(h.default.Error,C)}warn(C){this.d(h.default.Warning,C)}info(C){this.d(h.default.Info,C)}}e.$FF=D;class S{static a(C){const i=new E.$Il;for(let o=0,n=C.length;o<n;o++)i.add(C[o].description.identifier);return i}static compute(C,i){if(!C||!C.length)return new S(i,[]);if(!i||!i.length)return new S([],C);const o=this.a(C),n=this.a(i),t=i.filter(g=>!o.has(g.description.identifier)),a=C.filter(g=>!n.has(g.description.identifier));return new S(t,a)}constructor(C,i){this.added=C,this.removed=i}}e.$GF=S;class p{constructor(C,i){this.name=C,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(C){if(this.a!==null)throw new Error("Handler already set!");this.a=C,this.d()}acceptUsers(C){this.c=S.compute(this.b,C),this.b=C,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(C){(0,F.$Y)(C)}}}e.$HF=p;const r={type:"string",enum:["ui","workspace"],enumDescriptions:[k.localize(0,null),k.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$IF={properties:{engines:{type:"object",description:k.localize(2,null),properties:{vscode:{type:"string",description:k.localize(3,null),default:"^1.22.0"}}},publisher:{description:k.localize(4,null),type:"string"},displayName:{description:k.localize(5,null),type:"string"},categories:{description:k.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$Gl},{type:"string",const:"Languages",deprecationMessage:k.localize(7,null)}]}},galleryBanner:{type:"object",description:k.localize(8,null),properties:{color:{description:k.localize(9,null),type:"string"},theme:{description:k.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:k.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:k.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:k.localize(13,null)},enabledApiProposals:{markdownDescription:k.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}},api:{markdownDescription:k.localize(15,null),type:"string",enum:["none"],enumDescriptions:[k.localize(16,null)]},activationEvents:{description:k.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:k.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:k.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:k.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:k.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:k.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:k.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:k.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:k.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:k.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:k.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:k.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:k.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:k.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:k.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:k.localize(32,null)},{label:"onUri",body:"onUri",description:k.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:k.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:k.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:k.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:k.localize(37,null)},{label:"onRenderer",description:k.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:k.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:k.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:k.localize(41,null)},{label:"*",description:k.localize(42,null),body:"*"}]}},badges:{type:"array",description:k.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:k.localize(44,null)},href:{type:"string",description:k.localize(45,null)},description:{type:"string",description:k.localize(46,null)}}}},markdown:{type:"string",description:k.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:k.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:k.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Dn}},extensionPack:{description:k.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Dn}},extensionKind:{description:k.localize(51,null),type:"array",items:r,default:["workspace"],defaultSnippets:[{body:["ui"],description:k.localize(52,null)},{body:["workspace"],description:k.localize(53,null)},{body:["ui","workspace"],description:k.localize(54,null)},{body:["workspace","ui"],description:k.localize(55,null)},{body:[],description:k.localize(56,null)}]},capabilities:{description:k.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:k.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:k.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[k.localize(60,null),k.localize(61,null),k.localize(62,null)]},description:{type:"string",markdownDescription:k.localize(63,null)}}},untrustedWorkspaces:{description:k.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:k.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[k.localize(66,null),k.localize(67,null),k.localize(68,null)]},restrictedConfigurations:{description:k.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:k.localize(70,null)}}}}},sponsor:{description:k.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:k.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:k.localize(73,null),type:"string"},"vscode:uninstall":{description:k.localize(74,null),type:"string"}}},icon:{type:"string",description:k.localize(75,null)},l10n:{type:"string",description:k.localize(76,null)}}};class c{constructor(){this.a=new Map}registerExtensionPoint(C){if(this.a.has(C.extensionPoint))throw new Error("Duplicate extension point: "+C.extensionPoint);const i=new p(C.extensionPoint,C.defaultExtensionKind);return this.a.set(C.extensionPoint,i),C.activationEventsGenerator&&I.$kF.register(C.extensionPoint,C.activationEventsGenerator),e.$IF.properties.contributes.properties[C.extensionPoint]=C.jsonSchema,$.registerSchema(s,e.$IF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$JF=c;const f={ExtensionsRegistry:"ExtensionsRegistry"};m.$Tm.add(f.ExtensionsRegistry,new c),e.$KF=m.$Tm.as(f.ExtensionsRegistry),$.registerSchema(s,e.$IF),$.registerSchema(R.$$i,{properties:{extensionEnabledApiProposals:{description:k.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}}]}}}})}),define(Se[276],Ce([1,0,211,14,23,275,47,3]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:k.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:k.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:k.localize(2,null),default:""}}};var b;(function($){function D(S,p,r){if(!S)return;const s=F.$je(S.type)?S.type:void 0;if(!s||s.length===0){r.error(k.localize(3,null));return}const c=[];if(Array.isArray(S.required))for(const f of S.required)F.$je(f)&&c.push(f);return{extensionId:p.value,taskType:s,required:c,properties:S.properties?h.$Hm(S.properties):{},when:S.when?P.$vi.deserialize(S.when):void 0}}$.from=D})(b||(b={}));const R=A.$KF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:($,D)=>{for(const S of $)S.type&&D.push(`onTaskType:${S.type}`)},jsonSchema:{description:k.localize(4,null),type:"array",items:E}});class I{constructor(){this.d=new m.$8c,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((D,S)=>{R.setHandler((p,r)=>{this.c=void 0;try{for(const s of r.removed){const c=s.value;for(const f of c)this.a&&f.type&&this.a[f.type]&&delete this.a[f.type]}for(const s of r.added){const c=s.value;for(const f of c){const y=b.from(f,s.description.identifier,s.collector);y&&(this.a[y.taskType]=y)}}(r.removed.length>0||r.added.length>0)&&this.d.fire()}catch{}D(void 0)})})}onReady(){return this.b}get(D){return this.a[D]}all(){return Object.keys(this.a).map(D=>this.a[D])}getJsonSchema(){if(this.c===void 0){const D=[];for(const S of this.all()){const p={type:"object",additionalProperties:!1};S.required.length>0&&(p.required=S.required.slice(0)),S.properties!==void 0?p.properties=h.$Hm(S.properties):p.properties=Object.create(null),p.properties.type={type:"string",enum:[S.taskType]},D.push(p)}this.c={oneOf:D}}return this.c}}e.$TF=new I}),define(Se[277],Ce([1,0,212,14,24,23,47,276]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$4F=e.JsonSchemaVersion=e.ExecutionEngine=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$XF=e.ShellQuoting=e.$WF=e.$VF=e.$UF=void 0,e.$UF="settings",e.$VF=new P.$Oi("taskRunning",!1,k.localize(0,null)),e.$WF={value:k.localize(1,null),original:"Tasks"};var E;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$XF="$customized",function(W){function M(Y){if(!Y)return W.Strong;switch(Y.toLowerCase()){case"escape":return W.Escape;case"strong":return W.Strong;case"weak":return W.Weak;default:return W.Strong}}W.from=M}(E||(e.ShellQuoting=E={}));var b;(function(W){W.defaults={cwd:"${workspaceFolder}"}})(b||(e.CommandOptions=b={}));var R;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(R||(e.RevealKind=R={})),function(W){function M(Y){switch(Y.toLowerCase()){case"always":return W.Always;case"silent":return W.Silent;case"never":return W.Never;default:return W.Always}}W.fromString=M}(R||(e.RevealKind=R={}));var I;(function(W){W[W.Never=1]="Never",W[W.OnProblem=2]="OnProblem",W[W.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(W){function M(Y){switch(Y.toLowerCase()){case"always":return W.Always;case"never":return W.Never;case"onproblem":return W.OnProblem;default:return W.OnProblem}}W.fromString=M}(I||(e.RevealProblemKind=I={}));var $;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})($||(e.PanelKind=$={})),function(W){function M(Y){switch(Y.toLowerCase()){case"shared":return W.Shared;case"dedicated":return W.Dedicated;case"new":return W.New;default:return W.Shared}}W.fromString=M}($||(e.PanelKind=$={}));var D;(function(W){W.defaults={echo:!0,reveal:R.Always,revealProblems:I.Never,focus:!1,panel:$.Shared,showReuseMessage:!0,clear:!1}})(D||(e.PresentationOptions=D={}));var S;(function(W){W[W.Shell=1]="Shell",W[W.Process=2]="Process",W[W.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(W){function M(V){switch(V.toLowerCase()){case"shell":return W.Shell;case"process":return W.Process;case"customExecution":return W.CustomExecution;default:return W.Process}}W.fromString=M;function Y(V){switch(V){case W.Shell:return"shell";case W.Process:return"process";case W.CustomExecution:return"customExecution";default:return"process"}}W.toString=Y}(S||(e.RuntimeType=S={}));var p;(function(W){function M(Y){return F.$je(Y)?Y:Y.value}W.value=M})(p||(e.CommandString=p={}));var r;(function(W){W.Clean={_id:"clean",isDefault:!1},W.Build={_id:"build",isDefault:!1},W.Rebuild={_id:"rebuild",isDefault:!1},W.Test={_id:"test",isDefault:!1};function M(V){return V===W.Clean._id||V===W.Build._id||V===W.Rebuild._id||V===W.Test._id}W.is=M;function Y(V){if(V!==void 0)return F.$je(V)?M(V)?{_id:V,isDefault:!1}:void 0:V}W.from=Y})(r||(e.TaskGroup=r={}));var s;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var c;(function(W){W.Workspace="workspace",W.Extension="extension",W.InMemory="inMemory",W.WorkspaceFile="workspaceFile",W.User="user";function M(Y){switch(Y){case W.User:return 2;case W.WorkspaceFile:return 5;default:return 6}}W.toConfigurationTarget=M})(c||(e.TaskSourceKind=c={}));var f;(function(W){W.parallel="parallel",W.sequence="sequence"})(f||(e.DependsOrder=f={}));var y;(function(W){W[W.default=1]="default",W[W.folderOpen=2]="folderOpen"})(y||(e.RunOnOptions=y={}));var C;(function(W){W.defaults={reevaluateOnRerun:!0,runOn:y.default,instanceLimit:1}})(C||(e.RunOptions=C={}));class i{constructor(M,Y,V,de,re,x){this._label="",this._id=M,Y&&(this._label=Y),V&&(this.type=V),this.runOptions=de,this.configurationProperties=re,this._source=x}getDefinition(M){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const M={folder:this.d(),id:this._id};return JSON.stringify(M)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,Y=!1){if(M===void 0)return!1;if(F.$je(M))return M===this._label||M===this.configurationProperties.identifier||Y&&M===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this.c===void 0&&(this.c=[]),M&&(this.c=this.c.concat(M))}get taskLoadMessages(){return this.c}}e.$YF=i;class o extends i{constructor(M,Y,V,de,re,x,q,ne){super(M,V,void 0,q,ne,Y),this.command={},this._source=Y,this.hasDefinedMatchers=x,re&&(this.command=re)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let Y;switch(this.command?this.command.runtime:void 0){case S.Shell:Y="shell";break;case S.Process:Y="process";break;case S.CustomExecution:Y="customExecution";break;case void 0:Y="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Y,_key:this._id,id:this._id}}}static is(M){return M instanceof o}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$UF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const M=this.d();if(!M)return;let Y=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(Y+=this._source.kind);const V={type:e.$XF,folder:M,id:Y};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.$7f(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(M){return new o(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.$ZF=o;class n extends i{constructor(M,Y,V,de,re,x,q){super(M,V,de,x,q,Y),this._source=Y,this.configures=re}static is(M){return M instanceof n}f(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.$7f(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$UF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const M=this.d();if(!M)return;let Y=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(Y+=this._source.kind);const V={type:e.$XF,folder:M,id:Y};return JSON.stringify(V)}}e.$1F=n;class t extends i{constructor(M,Y,V,de,re,x,q,ne,pe){super(M,V,de,ne,pe,Y),this.defines=re,this.hasDefinedMatchers=q,this.command=x,this.icon=pe.icon,this.hide=pe.hide}clone(){return new t(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof t}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.d(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(M){return new t(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.$2F=t;class a extends i{constructor(M,Y,V,de,re,x){super(M,V,de,re,x,Y),this._source=Y}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(M){return new a(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.$3F=a;var g;(function(W){W[W.Process=1]="Process",W[W.Terminal=2]="Terminal"})(g||(e.ExecutionEngine=g={})),function(W){W._default=W.Terminal}(g||(e.ExecutionEngine=g={}));var u;(function(W){W[W.V0_1_0=1]="V0_1_0",W[W.V2_0_0=2]="V2_0_0"})(u||(e.JsonSchemaVersion=u={}));class d{constructor(M){this.c=new Map;for(let Y=0;Y<M.length;Y++)this.c.set(M[Y].uri.toString(),Y)}compare(M,Y){const V=M.getWorkspaceFolder(),de=Y.getWorkspaceFolder();if(V&&de){let re=this.c.get(V.uri.toString());re=re===void 0?0:re+1;let x=this.c.get(de.uri.toString());return x=x===void 0?0:x+1,re===x?M._label.localeCompare(Y._label):re-x}else return!V&&de?-1:V&&!de?1:0}}e.$4F=d;var v;(function(W){W.DependsOnStarted="dependsOnStarted",W.AcquiredInput="acquiredInput",W.Start="start",W.ProcessStarted="processStarted",W.Active="active",W.Inactive="inactive",W.Changed="changed",W.Terminated="terminated",W.ProcessEnded="processEnded",W.End="end"})(v||(e.TaskEventKind=v={}));var l;(function(W){W.SingleRun="singleRun",W.Background="background"})(l||(e.TaskRunType=l={}));var w;(function(W){W[W.System=0]="System",W[W.User=1]="User",W[W.FolderOpen=2]="FolderOpen",W[W.ConfigurationChange=3]="ConfigurationChange",W[W.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var L;(function(W){function M(Y,V,de,re){if(V){const x={kind:Y,taskId:V._id,taskName:V.configurationProperties.name,runType:V.configurationProperties.isBackground?"background":"singleRun",group:V.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:de,__task:V};return Y==="start"?x.resolvedVariables=re:Y==="processStarted"?x.processId=re:Y==="processEnded"&&(x.exitCode=re),Object.freeze(x)}else return Object.freeze({kind:"changed"})}W.create=M})(L||(e.TaskEvent=L={}));var O;(function(W){function M(V){const de=Object.keys(V).sort();let re="";for(const x of de){let q=V[x];q instanceof Object?q=M(q):typeof q=="string"&&(q=q.replace(/,/g,",,")),re+=x+","+q+","}return re}function Y(V){const re={_key:M(V),type:V.taskType};return Object.assign(re,V),re}W.create=Y})(O||(e.KeyedTaskIdentifier=O={}));var N;(function(W){W.AutoDetect="task.autoDetect",W.SaveBeforeRun="task.saveBeforeRun",W.ShowDecorations="task.showDecorations",W.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",W.SlowProviderWarning="task.slowProviderWarning",W.QuickOpenHistory="task.quickOpen.history",W.QuickOpenDetail="task.quickOpen.detail",W.QuickOpenSkip="task.quickOpen.skip",W.QuickOpenShowAll="task.quickOpen.showAll",W.AllowAutomaticTasks="task.allowAutomaticTasks",W.Reconnection="task.reconnection"})(N||(e.TaskSettingId=N={}));var T;(function(W){W.Tasks="tasks",W.SuppressTaskName="tasks.suppressTaskName",W.Windows="tasks.windows",W.Osx="tasks.osx",W.Linux="tasks.linux",W.ShowOutput="tasks.showOutput",W.IsShellCommand="tasks.isShellCommand",W.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var j;(function(W){function M(Y,V){const de=m.$TF.get(Y.type);if(de===void 0){const ne=A.$Hm(Y);return delete ne._key,O.create(ne)}const re=Object.create(null);re.type=de.taskType;const x=new Set;de.required.forEach(ne=>x.add(ne));const q=de.properties;for(const ne of Object.keys(q)){const pe=Y[ne];if(pe!=null)re[ne]=pe;else if(x.has(ne)){const H=q[ne];if(H.default!==void 0)re[ne]=A.$Hm(H.default);else switch(H.type){case"boolean":re[ne]=!1;break;case"number":case"integer":re[ne]=0;break;case"string":re[ne]="";break;default:V.error(k.localize(2,null,JSON.stringify(Y,void 0,0),ne));return}}}return O.create(re)}W.createTaskIdentifier=M})(j||(e.TaskDefinition=j={}))}),define(Se[278],Ce([1,0,8]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x1b=e.$w1b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((P,m)=>{this.b=P,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(P){this.f||this.h||(this.f=!0,this.g=P,this.a&&this.b(P))}resolveErr(P){this.f||this.h||(this.h=!0,this.i=P,this.a?this.d(P):(0,k.$Y)(P))}then(P,m){return this.j().then(P,m)}catch(P){return this.j().then(void 0,P)}finally(P){return this.j().finally(P)}}e.$w1b=F;class h extends F{constructor(){super(),this.h=!0,this.i=new k.$3}}e.$x1b=h}),define(Se[60],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yz=e.$Xz=e.$Wz=e.$Vz=void 0;class k{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++k.count}}e.$Vz=k;const F=[];function h(m){const E=new k(m);return F[E.nid]=E,E}e.$Wz=h;function A(m){return F[m].sid}e.$Xz=A;class P{constructor(E){this.value=E}}e.$Yz=P}),define(Se[6],Ce([1,0,60]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=e.$BJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$AJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var h;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(h||(e.TabInputKind=h={}));var A;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var P;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(P||(e.WebviewEditorCapabilities=P={}));var m;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var E;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var b;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(b||(e.NotebookEditorRevealType=b={}));var R;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class I{static{this.a=0}static mixin(r){return r._id=I.a++,r}}e.$AJ=I;var $;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.kindModifier="m",p.commandIdent="n",p.commandId="o",p.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var D;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(D||(e.ISuggestResultDtoField=D={}));var S;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$BJ={MainThreadAuthentication:(0,k.$Wz)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.$Wz)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.$Wz)("MainThreadClipboard"),MainThreadCommands:(0,k.$Wz)("MainThreadCommands"),MainThreadComments:(0,k.$Wz)("MainThreadComments"),MainThreadConfiguration:(0,k.$Wz)("MainThreadConfiguration"),MainThreadConsole:(0,k.$Wz)("MainThreadConsole"),MainThreadDebugService:(0,k.$Wz)("MainThreadDebugService"),MainThreadDecorations:(0,k.$Wz)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.$Wz)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.$Wz)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.$Wz)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.$Wz)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.$Wz)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.$Wz)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.$Wz)("MainThreadEditorTabs"),MainThreadErrors:(0,k.$Wz)("MainThreadErrors"),MainThreadTreeViews:(0,k.$Wz)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.$Wz)("MainThreadDownloadService"),MainThreadKeytar:(0,k.$Wz)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.$Wz)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.$Wz)("MainThreadLanguages"),MainThreadLogger:(0,k.$Wz)("MainThreadLogger"),MainThreadMessageService:(0,k.$Wz)("MainThreadMessageService"),MainThreadOutputService:(0,k.$Wz)("MainThreadOutputService"),MainThreadProgress:(0,k.$Wz)("MainThreadProgress"),MainThreadQuickDiff:(0,k.$Wz)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,k.$Wz)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.$Wz)("MainThreadStatusBar"),MainThreadSecretState:(0,k.$Wz)("MainThreadSecretState"),MainThreadStorage:(0,k.$Wz)("MainThreadStorage"),MainThreadTelemetry:(0,k.$Wz)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.$Wz)("MainThreadTerminalService"),MainThreadWebviews:(0,k.$Wz)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.$Wz)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.$Wz)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.$Wz)("MainThreadCustomEditors"),MainThreadUrls:(0,k.$Wz)("MainThreadUrls"),MainThreadUriOpeners:(0,k.$Wz)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,k.$Wz)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,k.$Wz)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.$Wz)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.$Wz)("MainThreadExtensionService"),MainThreadSCM:(0,k.$Wz)("MainThreadSCM"),MainThreadSearch:(0,k.$Wz)("MainThreadSearch"),MainThreadShare:(0,k.$Wz)("MainThreadShare"),MainThreadTask:(0,k.$Wz)("MainThreadTask"),MainThreadWindow:(0,k.$Wz)("MainThreadWindow"),MainThreadLabelService:(0,k.$Wz)("MainThreadLabelService"),MainThreadNotebook:(0,k.$Wz)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.$Wz)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.$Wz)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.$Wz)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.$Wz)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.$Wz)("MainThreadInteractive"),MainThreadChat:(0,k.$Wz)("MainThreadChat"),MainThreadInlineChat:(0,k.$Wz)("MainThreadInlineChatShape"),MainThreadTheming:(0,k.$Wz)("MainThreadTheming"),MainThreadTunnelService:(0,k.$Wz)("MainThreadTunnelService"),MainThreadManagedSockets:(0,k.$Wz)("MainThreadManagedSockets"),MainThreadTimeline:(0,k.$Wz)("MainThreadTimeline"),MainThreadTesting:(0,k.$Wz)("MainThreadTesting"),MainThreadLocalization:(0,k.$Wz)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,k.$Wz)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,k.$Wz)("MainThreadIssueReporter")},e.$CJ={ExtHostCommands:(0,k.$Wz)("ExtHostCommands"),ExtHostConfiguration:(0,k.$Wz)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.$Wz)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.$Wz)("ExtHostDebugService"),ExtHostDecorations:(0,k.$Wz)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.$Wz)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.$Wz)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.$Wz)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.$Wz)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.$Wz)("ExtHostEditors"),ExtHostTreeViews:(0,k.$Wz)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.$Wz)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.$Wz)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.$Wz)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,k.$Wz)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,k.$Wz)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.$Wz)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,k.$Wz)("ExtHostQuickDiff"),ExtHostStatusBar:(0,k.$Wz)("ExtHostStatusBar"),ExtHostShare:(0,k.$Wz)("ExtHostShare"),ExtHostExtensionService:(0,k.$Wz)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,k.$Wz)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,k.$Wz)("ExtHostTerminalService"),ExtHostSCM:(0,k.$Wz)("ExtHostSCM"),ExtHostSearch:(0,k.$Wz)("ExtHostSearch"),ExtHostTask:(0,k.$Wz)("ExtHostTask"),ExtHostWorkspace:(0,k.$Wz)("ExtHostWorkspace"),ExtHostWindow:(0,k.$Wz)("ExtHostWindow"),ExtHostWebviews:(0,k.$Wz)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.$Wz)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.$Wz)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.$Wz)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.$Wz)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.$Wz)("ExtHostEditorTabs"),ExtHostProgress:(0,k.$Wz)("ExtHostProgress"),ExtHostComments:(0,k.$Wz)("ExtHostComments"),ExtHostSecretState:(0,k.$Wz)("ExtHostSecretState"),ExtHostStorage:(0,k.$Wz)("ExtHostStorage"),ExtHostUrls:(0,k.$Wz)("ExtHostUrls"),ExtHostUriOpeners:(0,k.$Wz)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,k.$Wz)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,k.$Wz)("ExtHostOutputService"),ExtHosLabelService:(0,k.$Wz)("ExtHostLabelService"),ExtHostNotebook:(0,k.$Wz)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.$Wz)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.$Wz)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.$Wz)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.$Wz)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,k.$Wz)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,k.$Wz)("ExtHostInteractive"),ExtHostInlineChat:(0,k.$Wz)("ExtHostInlineChatShape"),ExtHostChat:(0,k.$Wz)("ExtHostChat"),ExtHostSemanticSimilarity:(0,k.$Wz)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,k.$Wz)("ExtHostTheming"),ExtHostTunnelService:(0,k.$Wz)("ExtHostTunnelService"),ExtHostManagedSockets:(0,k.$Wz)("ExtHostManagedSockets"),ExtHostAuthentication:(0,k.$Wz)("ExtHostAuthentication"),ExtHostTimeline:(0,k.$Wz)("ExtHostTimeline"),ExtHostTesting:(0,k.$Wz)("ExtHostTesting"),ExtHostTelemetry:(0,k.$Wz)("ExtHostTelemetry"),ExtHostLocalization:(0,k.$Wz)("ExtHostLocalization"),ExtHostIssueReporter:(0,k.$Wz)("ExtHostIssueReporter")}}),define(Se[84],Ce([1,0,5,18,6,20]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V$b=e.$U$b=e.$T$b=void 0,e.$T$b=(0,k.$ph)("IExtHostApiDeprecationService");let P=class{constructor(E,b){this.c=b,this.a=new Set,this.b=E.getProxy(h.$BJ.MainThreadTelemetry)}report(E,b,R){const I=this.d(E,b);this.a.has(I)||(this.a.add(I),b.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:b.identifier.value,apiId:E}))}d(E,b){return`${E}-${b.identifier.value}`}};e.$U$b=P,e.$U$b=P=Je([qe(0,A.$DL),qe(1,F.$Ri)],P),e.$V$b=Object.freeze(new class{report(m,E,b){}})}),define(Se[279],Ce([1,0,3,6,7,25]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=void 0;class P{constructor(b){this.b=new Map,this.c=[],this.d=new k.$8c,this.onDidChangeSessions=this.d.event,this.f=new m,this.g=new m,this.a=b.getProxy(F.$BJ.MainThreadAuthentication)}$setProviders(b){return this.c=b,Promise.resolve()}async getSession(b,R,I,$={}){const D=A.$Hl.toKey(b.identifier),S=[...I].sort().join(" ");return await this.f.getOrCreate(`${D} ${R} ${S}`,async()=>{await this.a.$ensureProvider(R);const p=b.displayName||b.name;return this.a.$getSession(R,I,D,p,$)})}async getSessions(b,R,I){const $=A.$Hl.toKey(b.identifier),D=[...I].sort().join(" ");return await this.g.getOrCreate(`${$} ${D}`,async()=>{await this.a.$ensureProvider(R);const S=b.displayName||b.name;return this.a.$getSessions(R,I,$,S)})}async removeSession(b,R){const I=this.b.get(b);return I?I.provider.removeSession(R):this.a.$removeSession(b,R)}registerAuthenticationProvider(b,R,I,$){if(this.b.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this.b.set(b,{label:R,provider:I,options:$??{supportsMultipleAccounts:!1}}),this.c.find(S=>S.id===b)||this.c.push({id:b,label:R});const D=I.onDidChangeSessions(S=>{this.a.$sendDidChangeSessions(b,{added:S.added??[],changed:S.changed??[],removed:S.removed??[]})});return this.a.$registerAuthenticationProvider(b,R,$?.supportsMultipleAccounts??!1),new h.$DJ(()=>{D.dispose(),this.b.delete(b);const S=this.c.findIndex(p=>p.id===b);S>-1&&this.c.splice(S),this.a.$unregisterAuthenticationProvider(b)})}$createSession(b,R,I){const $=this.b.get(b);if($)return Promise.resolve($.provider.createSession(R,I));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,R){const I=this.b.get(b);if(I)return Promise.resolve(I.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,R){const I=this.b.get(b);if(I)return Promise.resolve(I.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,R){return this.d.fire({provider:{id:b,label:R}}),Promise.resolve()}}e.$pac=P;class m{constructor(){this.a=new Map}getOrCreate(b,R){const I=this.a.get(b);if(I)return I;const $=R().finally(()=>this.a.delete(b));return this.a.set(b,$),$}}}),define(Se[280],Ce([1,0,6,20,16]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vac=void 0;let A=class{constructor(m,E){this.a=m.getProxy(k.$BJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:b=>E.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,E,b){const R=h.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,b?.isRefactoring??!1)}};e.$vac=A,e.$vac=A=Je([qe(0,F.$DL)],A)}),define(Se[281],Ce([1,0,17,3,48,4,39,14,192,6,16]),function(fe,e,k,F,h,A,P,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=void 0;class I{static{this.a=0}constructor(S,p){this.extension=S,this.provider=p,this.handle=I.a++}}class ${static{this.a=0}constructor(S,p){this.i=p,this.b=new Map,this.d=new Map,this.e=new Map,this.g=new F.$8c,this.onDidPerformUserAction=this.g.event,this.h=S.getProxy(b.$BJ.MainThreadChat)}registerChatProvider(S,p,r){const s=new I(S,r);return this.b.set(s.handle,s),this.h.$registerChatProvider(s.handle,p),(0,A.$jb)(()=>{this.h.$unregisterChatProvider(s.handle),this.b.delete(s.handle)})}transferChatSession(S,p){const r=h.Iterable.find(this.e.keys(),s=>this.e.get(s)===S)??0;typeof r=="number"&&this.h.$transferChatSession(r,p)}addChatRequest(S){this.h.$addRequest(S)}sendInteractiveRequestToProvider(S,p){this.h.$sendRequestToProvider(S,p)}async $prepareChat(S,p,r){const s=this.b.get(S);if(!s)return;const c=await s.provider.prepareSession(p,r);if(!c)return;const f=$.a++;return this.e.set(f,c),{id:f,requesterUsername:c.requester?.name,requesterAvatarIconUri:c.requester?.icon,responderUsername:c.responder?.name,responderAvatarIconUri:c.responder?.icon,inputPlaceholder:c.inputPlaceholder}}async $resolveRequest(S,p,r,s){const c=this.b.get(S);if(!c)return;const f=this.e.get(p);if(!f||!c.provider.resolveRequest)return;const y=await c.provider.resolveRequest(f,r,s);if(y)return{message:typeof y.message=="string"?y.message:R.ChatReplyFollowup.from(y.message)}}async $provideWelcomeMessage(S,p){const r=this.b.get(S);if(!r||!r.provider.provideWelcomeMessage)return;const s=await r.provider.provideWelcomeMessage(p);if(s)return s.map(c=>typeof c=="string"?c:c.map(f=>R.ChatReplyFollowup.from(f)))}async $provideFollowups(S,p,r){const s=this.b.get(S);if(!s)return;const c=this.e.get(p);return!c||!s.provider.provideFollowups?void 0:(await s.provider.provideFollowups(c,r))?.map(y=>R.ChatFollowup.from(y))}$removeRequest(S,p,r){const s=this.b.get(S);if(!s)return;const c=this.e.get(p);c&&s.provider.removeRequest&&s.provider.removeRequest(c,r)}async $provideReply(S,p,r,s){const c=this.b.get(S);if(!c)return;const f=this.e.get(p);if(!f)return;const y={session:f,message:typeof r.message=="string"?r.message:R.ChatReplyFollowup.to(r.message)},C=P.$4c.create(!1);let i;const o={report:a=>{if(!s.isCancellationRequested)if(typeof i>"u"&&(i=C.elapsed()),"responseId"in a)this.h.$acceptResponseProgress(S,p,{requestId:a.responseId});else if("placeholder"in a&&"resolvedContent"in a){const g=Promise.all([this.h.$acceptResponseProgress(S,p,{placeholder:a.placeholder}),a.resolvedContent]);(0,k.$kg)(g,s).then(u=>{if(!u)return;const[d,v]=u;this.h.$acceptResponseProgress(S,p,v,d??void 0)})}else this.h.$acceptResponseProgress(S,p,a)}};let n;try{n=await c.provider.provideResponseWithProgress(y,o,s),n||(n={errorDetails:{message:(0,E.localize)(0,null)}})}catch(a){n={errorDetails:{message:(0,E.localize)(1,null,a.message),responseIsIncomplete:!0}},this.i.error(a)}try{if(f.saveState&&this.e.has(p)){const a=f.saveState();this.h.$acceptChatState(p,a)}}catch(a){this.i.warn(a)}const t={firstProgress:i??0,totalElapsed:C.elapsed()};return{errorDetails:n.errorDetails,timings:t}}async $provideSlashCommands(S,p,r){const s=this.b.get(S);if(!s)return;const c=this.e.get(p);return!c||!s.provider.provideSlashCommands?void 0:(await s.provider.provideSlashCommands(c,r))?.map(y=>({...y,kind:R.CompletionItemKind.from(y.kind)}))}$releaseSession(S){this.e.delete(S)}async $onDidPerformUserAction(S){this.g.fire(S)}registerSlashCommandProvider(S,p,r){const s=new I(S,r);return this.d.set(s.handle,s),this.h.$registerSlashCommandProvider(s.handle,p),(0,A.$jb)(()=>{this.h.$unregisterSlashCommandProvider(s.handle),this.d.delete(s.handle)})}async $provideProviderSlashCommands(S,p){const r=this.d.get(S);return r?(await r.provider.provideSlashCommands(p))?.map(c=>({...c,kind:R.CompletionItemKind.from(c.kind)})):void 0}async $resolveSlashCommand(S,p,r){const s=this.d.get(S);if(!s)return;const c=await s.provider.resolveSlashCommand(p,r);return(0,m.$Be)(c)}}e.$Jac=$}),define(Se[282],Ce([1,0,6]),function(fe,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y$b=void 0;class F{constructor(A){const P=A.getProxy(k.$BJ.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(m){return P.$writeText(m)}})}}e.$Y$b=F}),define(Se[36],Ce([1,0,14,7,16,23,6,19,18,73,33,56,2,4,5,20,139,22,60,45,39,80,83]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c,f,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=void 0;let o=class{#e;#t;#i;constructor(d,v,l){this.b=new Map,this.c=new Map,this.#e=d.getProxy(P.$BJ.MainThreadCommands),this.d=v,this.#i=l,this.#t=d.getProxy(P.$BJ.MainThreadTelemetry),this.converter=new n(this,w=>{const L=this.c.get(w);return L?.result===a.Void?L:void 0},v),this.f=[{processArgument(w){return(0,b.$Yg)(w)}},{processArgument(w){return(0,A.$Jm)(w,function(L){if(R.$Or.isIRange(L))return h.Range.to(L);if(I.$Nr.isIPosition(L))return h.Position.to(L);if(R.$Or.isIRange(L.range)&&$.URI.isUri(L.uri))return h.location.to(L);if(L instanceof s.$Jb)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(d){this.f.push(d)}registerApiCommand(d){const v=this.registerCommand(!1,d.id,async(...l)=>{const w=d.args.map((O,N)=>{if(!O.validate(l[N]))throw new Error(`Invalid argument '${O.name}' when running '${d.id}', received: ${l[N]}`);return O.convert(l[N])}),L=await this.executeCommand(d.internalId,...w);return d.result.convert(L,l,this.converter)},void 0,{description:d.description,args:d.args,returns:d.result.description});return this.c.set(d.id,d),new F.$DJ(()=>{v.dispose(),this.c.delete(d.id)})}registerCommand(d,v,l,w,L,O){if(this.d.trace("ExtHostCommands#registerCommand",v),!v.trim().length)throw new Error("invalid id");if(this.b.has(v))throw new Error(`command '${v}' already exists`);return this.b.set(v,{callback:l,thisArg:w,description:L,extension:O}),d&&this.#e.$registerCommand(v),new F.$DJ(()=>{this.b.delete(v)&&d&&this.#e.$unregisterCommand(v)})}executeCommand(d,...v){return this.d.trace("ExtHostCommands#executeCommand",d),this.g(d,v,!0)}async g(d,v,l){if(this.b.has(d))return this.#e.$fireCommandActivationEvent(d),this.h(d,v,!1);{let w=!1;const L=(0,A.$Jm)(v,function(O){if(O instanceof F.$EJ)return h.Position.from(O);if(O instanceof F.$FJ)return h.Range.from(O);if(O instanceof F.$PJ)return h.location.from(O);if(F.$2K.isNotebookRange(O))return h.NotebookRange.from(O);if(O instanceof ArrayBuffer)return w=!0,s.$Jb.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return w=!0,s.$Jb.wrap(O);if(O instanceof s.$Jb)return w=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(d,w?new c.$Yz(L):L,l);return(0,b.$Yg)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(d,v,!1);throw O}}}async h(d,v,l){const w=this.b.get(d);if(!w)throw new Error("Unknown command");const{callback:L,thisArg:O,description:N}=w;if(N)for(let j=0;j<N.args.length;j++)try{(0,k.$Ae)(v[j],N.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${d}' failed. Illegal argument '${N.args[j].name}' - ${N.args[j].description}`)}const T=y.$4c.create();try{return await L.apply(O,v)}catch(j){if(d===this.converter.delegatingCommandId){const W=this.converter.getActualCommand(...v);W&&(d=W.command)}if(this.d.error(j,d,w.extension?.identifier),!l)throw j;if(w.extension?.identifier){const W=this.#i.onExtensionError(w.extension.identifier,j);this.d.trace("forwarded error to extension?",W,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,f.$ai)(j)),this.id=d,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,d,T.elapsed())}}j(d,v,l){d.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:d.extension.identifier.value,id:new C.$2n(v),duration:l})}$executeContributedCommand(d,...v){this.d.trace("ExtHostCommands#$executeContributedCommand",d);const l=this.b.get(d);return l?(v=v.map(w=>this.f.reduce((L,O)=>O.processArgument(L,l.extension?.identifier),w)),this.h(d,v,!0)):Promise.reject(new Error(`Contributed command '${d}' does not exist.`))}getCommands(d=!1){return this.d.trace("ExtHostCommands#getCommands",d),this.#e.$getCommands().then(v=>(d&&(v=v.filter(l=>l[0]!=="_")),v))}$getContributedCommandHandlerDescriptions(){const d=Object.create(null);for(const[v,l]of this.b){const{description:w}=l;w&&(d[v]=w)}return Promise.resolve(d)}};e.$YL=o,e.$YL=o=Je([qe(0,p.$DL),qe(1,E.$Ri),qe(2,i.$XL)],o),e.$ZL=(0,S.$ph)("IExtHostCommands");class n{constructor(d,v,l){this.d=d,this.f=v,this.g=l,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(d,v){if(!d)return;const l={$ident:void 0,id:d.command,title:d.title,tooltip:d.tooltip};if(!d.command)return l;const w=this.f(d.command);if(w)l.id=w.internalId,l.arguments=w.args.map((L,O)=>L.convert(d.arguments&&d.arguments[O]));else if((0,m.$qf)(d.arguments)){const L=`${d.command}/${++this.c}`;this.b.set(L,d),v.add((0,D.$jb)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),l.$ident=L,l.id=this.delegatingCommandId,l.arguments=[L],this.g.trace("CommandsConverter#CREATE",d.command,L)}return l}fromInternal(d){return typeof d.$ident=="string"?this.b.get(d.$ident):{command:d.id,title:d.title,arguments:d.arguments}}getActualCommand(...d){return this.b.get(d[0])}h(...d){const v=this.getActualCommand(...d);return this.g.trace("CommandsConverter#EXECUTE",d[0],v?v.command:"MISSING"),v?this.d.executeCommand(v.command,...v.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${d[0]}`)}}e.$1L=n;class t{static{this.Uri=new t("uri","Uri of a text document",d=>$.URI.isUri(d),d=>d)}static{this.Position=new t("position","A position in a text document",d=>F.$EJ.isPosition(d),h.Position.from)}static{this.Range=new t("range","A range in a text document",d=>F.$FJ.isRange(d),h.Range.from)}static{this.Selection=new t("selection","A selection in a text document",d=>F.$GJ.isSelection(d),h.Selection.from)}static{this.Number=new t("number","",d=>typeof d=="number",d=>d)}static{this.String=new t("string","",d=>typeof d=="string",d=>d)}static{this.CallHierarchyItem=new t("item","A call hierarchy item",d=>d instanceof F.$1J,h.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new t("item","A type hierarchy item",d=>d instanceof F.$jL,h.TypeHierarchyItem.from)}static{this.TestItem=new t("testItem","A VS Code TestItem",d=>d instanceof r.$QL,h.TestItem.from)}constructor(d,v,l,w){this.name=d,this.description=v,this.validate=l,this.convert=w}optional(){return new t(this.name,`(optional) ${this.description}`,d=>d==null||this.validate(d),d=>d===void 0?void 0:d===null?null:this.convert(d))}with(d,v){return new t(d??this.name,v??this.description,this.validate,this.convert)}}e.$2L=t;class a{static{this.Void=new a("no result",d=>d)}constructor(d,v){this.description=d,this.convert=v}}e.$3L=a;class g{constructor(d,v,l,w,L){this.id=d,this.internalId=v,this.description=l,this.args=w,this.result=L}}e.$4L=g}),define(Se[283],Ce([1,0,19,15,2,77,123,47,127,36,16,7]),function(fe,e,k,F,h,A,P,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X$b=void 0;const $=[new b.$4L("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$2L.Uri,b.$2L.Position],new b.$3L("A promise that resolves to an array of DocumentHighlight-instances.",S(R.DocumentHighlight.to))),new b.$4L("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$2L.Uri],new b.$3L("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,s)=>{if((0,k.$pf)(r))return;class c extends I.$UJ{static to(y){const C=new c(y.name,R.SymbolKind.to(y.kind),y.containerName||"",new I.$PJ(s[0],R.Range.to(y.range)));return C.detail=y.detail,C.range=C.location.range,C.selectionRange=R.Range.to(y.selectionRange),C.children=y.children?y.children.map(c.to):[],C}}return r.map(c.to)})),new b.$4L("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$2L.Uri,new b.$2L("options","Formatting options",r=>!0,r=>r)],new b.$3L("A promise that resolves to an array of TextEdits.",S(R.TextEdit.to))),new b.$4L("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$2L.Uri,b.$2L.Range,new b.$2L("options","Formatting options",r=>!0,r=>r)],new b.$3L("A promise that resolves to an array of TextEdits.",S(R.TextEdit.to))),new b.$4L("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$2L.Uri,b.$2L.Position,new b.$2L("ch","Trigger character",r=>typeof r=="string",r=>r),new b.$2L("options","Formatting options",r=>!0,r=>r)],new b.$3L("A promise that resolves to an array of TextEdits.",S(R.TextEdit.to))),new b.$4L("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$2L.Uri,b.$2L.Position],new b.$3L("A promise that resolves to an array of Location or LocationLink instances.",p)),new b.$4L("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$2L.Uri,b.$2L.Position],new b.$3L("A promise that resolves to an array of Location or LocationLink instances.",p)),new b.$4L("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$2L.Uri,b.$2L.Position],new b.$3L("A promise that resolves to an array of Location or LocationLink instances.",p)),new b.$4L("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$2L.Uri,b.$2L.Position],new b.$3L("A promise that resolves to an array of Location or LocationLink instances.",p)),new b.$4L("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$2L.Uri,b.$2L.Position],new b.$3L("A promise that resolves to an array of Location-instances.",S(R.location.to))),new b.$4L("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$2L.Uri,b.$2L.Position],new b.$3L("A promise that resolves to an array of Hover-instances.",S(R.Hover.to))),new b.$4L("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$2L.Uri,new b.$2L("position","A position in a text document",r=>Array.isArray(r)&&r.every(s=>I.$EJ.isPosition(s)),r=>r.map(R.Position.from))],new b.$3L("A promise that resolves to an array of ranges.",r=>r.map(s=>{let c;for(const f of s.reverse())c=new I.$ZJ(R.Range.to(f),c);return c}))),new b.$4L("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$2L.String.with("query","Search string")],new b.$3L("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(R.WorkspaceSymbol.to))),new b.$4L("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$2L.Uri,b.$2L.Position],new b.$3L("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(R.CallHierarchyItem.to))),new b.$4L("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$2L.CallHierarchyItem],new b.$3L("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(R.CallHierarchyIncomingCall.to))),new b.$4L("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$2L.CallHierarchyItem],new b.$3L("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(R.CallHierarchyOutgoingCall.to))),new b.$4L("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$2L.Uri,b.$2L.Position],new b.$3L("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:R.Range.to(r.range),placeholder:r.text}})),new b.$4L("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$2L.Uri,b.$2L.Position,b.$2L.String.with("newName","The new symbol name")],new b.$3L("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return R.WorkspaceEdit.to(r)}})),new b.$4L("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$2L.Uri,b.$2L.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$3L("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(R.DocumentLink.to))),new b.$4L("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$2L.Uri],new b.$3L("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$TK(r.tokenTypes,r.tokenModifiers)})),new b.$4L("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$2L.Uri],new b.$3L("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,P.$H8)(r);if(s.type==="full")return new I.$VK(s.data,void 0)})),new b.$4L("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$2L.Uri,b.$2L.Range.optional()],new b.$3L("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$TK(r.tokenTypes,r.tokenModifiers)})),new b.$4L("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$2L.Uri,b.$2L.Range],new b.$3L("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,P.$H8)(r);if(s.type==="full")return new I.$VK(s.data,void 0)})),new b.$4L("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$2L.Uri,b.$2L.Position,b.$2L.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$2L.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$3L("A promise that resolves to a CompletionList-instance.",(r,s,c)=>{if(!r)return new I.$_J([]);const f=r.suggestions.map(y=>R.CompletionItem.to(y,c));return new I.$_J(f,r.incomplete)})),new b.$4L("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$2L.Uri,b.$2L.Position,b.$2L.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$3L("A promise that resolves to SignatureHelp.",r=>{if(r)return R.SignatureHelp.to(r)})),new b.$4L("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$2L.Uri,b.$2L.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$3L("A promise that resolves to an array of CodeLens-instances.",(r,s,c)=>S(f=>new I.$4J(R.Range.to(f.range),f.command&&c.fromInternal(f.command)))(r))),new b.$4L("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$2L.Uri,new b.$2L("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.$FJ.isRange(r),r=>I.$GJ.isSelection(r)?R.Selection.from(r):R.Range.from(r)),b.$2L.String.with("kind","Code action kind to return code actions for").optional(),b.$2L.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$3L("A promise that resolves to an array of Command-instances.",(r,s,c)=>S(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(f.command)}else{const y=new I.$WJ(f.title,f.kind?new I.$XJ(f.kind):void 0);return f.edit&&(y.edit=R.WorkspaceEdit.to(f.edit)),f.command&&(y.command=c.fromInternal(f.command)),y.isPreferred=f.isPreferred,y}})(r))),new b.$4L("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$2L.Uri],new b.$3L("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(s=>new I.$fK(R.Range.to(s.range),R.Color.to(s.color))):[])),new b.$4L("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$2L("color","The color to show and insert",r=>r instanceof I.$eK,R.Color.from),new b.$2L("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:R.Range.from(r.range)}))],new b.$3L("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(R.ColorPresentation.to):[])),new b.$4L("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$2L.Uri,b.$2L.Range],new b.$3L("A promise that resolves to an array of Inlay objects",(r,s,c)=>r.map(R.InlayHint.to.bind(void 0,c)))),new b.$4L("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$2L.Uri],new b.$3L("A promise that resolves to an array of FoldingRange objects",(r,s)=>{if(r)return r.map(R.FoldingRange.to)})),new b.$4L("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$3L("A promise that resolves to an array of NotebookContentProvider static info objects.",S(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(s=>R.NotebookExclusiveDocumentPattern.to(s))})))),new b.$4L("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$2L.Uri,b.$2L.Range],new b.$3L("A promise that resolves to an array of InlineValue objects",r=>r.map(R.InlineValue.to))),new b.$4L("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$2L("uriOrString","Uri-instance or string (only http/https)",r=>h.URI.isUri(r)||typeof r=="string"&&(0,E.$aZ)(r,F.Schemas.http,F.Schemas.https),r=>r),new b.$2L("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[R.ViewColumn.from(r),void 0]:[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)])).optional(),b.$2L.String.with("label","").optional()],b.$3L.Void),new b.$4L("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$2L.Uri.with("resource","Resource to open"),b.$2L.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new b.$2L("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[R.ViewColumn.from(r),void 0]:[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)])).optional()],b.$3L.Void),new b.$4L("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$2L.Uri.with("left","Left-hand side resource of the diff editor"),b.$2L.Uri.with("right","Right-hand side resource of the diff editor"),b.$2L.String.with("title","Human readable title for the diff editor").optional(),new b.$2L("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)]).optional()],b.$3L.Void),new b.$4L("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$2L.Uri,b.$2L.Position],new b.$3L("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(R.TypeHierarchyItem.to))),new b.$4L("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$2L.TypeHierarchyItem],new b.$3L("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(R.TypeHierarchyItem.to))),new b.$4L("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$2L.TypeHierarchyItem],new b.$3L("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(R.TypeHierarchyItem.to))),new b.$4L("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$2L.TestItem],b.$3L.Void),new b.$4L("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$2L.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$3L.Void),new b.$4L("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$2L.String.with("name","The context key name"),new b.$2L("value","The context key value",()=>!0,r=>r)],b.$3L.Void)];class D{static register(s){$.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",m.$wi)}}e.$X$b=D;function S(r){return s=>{if(Array.isArray(s))return s.map(r)}}function p(r){if(!Array.isArray(r))return;const s=[];for(const c of r)A.$qs(c)?s.push(R.DefinitionLink.to(c)):s.push(R.location.to(c));return s}}),define(Se[284],Ce([1,0,17,66,3,4,2,77,25,16,7,6,27,14]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z$b=void 0;function S(p,r,s){const c=p.getProxy(I.$BJ.MainThreadComments);class f{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$Jl,r.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const d=this.b.get(u.handle);return d?d.value:u}else if(u&&u.$mid===7){const d=this.b.get(u.commentControlHandle);if(!d)return u;const v=d.getCommentThread(u.commentThreadHandle);return v?v.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const d=this.b.get(u.thread.commentControlHandle);if(!d)return u;const v=d.getCommentThread(u.thread.commentThreadHandle);return v?u.$mid===8?v.value:{thread:v.value,text:u.text}:u}else if(u&&u.$mid===10){const d=this.b.get(u.thread.commentControlHandle);if(!d)return u;const v=d.getCommentThread(u.thread.commentThreadHandle);if(!v)return u;const l=u.commentUniqueId,w=v.getCommentByUniqueId(l);return w||u}else if(u&&u.$mid===11){const d=this.b.get(u.thread.commentControlHandle);if(!d)return u;const v=d.getCommentThread(u.thread.commentThreadHandle);if(!v)return u;const l=u.text,w=u.commentUniqueId,L=v.getCommentByUniqueId(w);return L?(typeof L.body=="string"?L.body=l:L.body=new R.$5J(l),L):u}return u}})}createCommentController(u,d,v){const l=f.a++,w=new C(u,l,d,v);this.b.set(w.handle,w);const L=this.c.get(u.identifier)||[];return L.push(w),this.c.set(u.identifier,L),w.value}$createCommentThreadTemplate(u,d,v){const l=this.b.get(u);l&&l.$createCommentThreadTemplate(d,v)}async $updateCommentThreadTemplate(u,d,v){const l=this.b.get(u);l&&l.$updateCommentThreadTemplate(d,v)}$deleteCommentThread(u,d){this.b.get(u)?.$deleteCommentThread(d)}$provideCommentingRanges(u,d,v){const l=this.b.get(u);if(!l||!l.commentingRangeProvider)return Promise.resolve(void 0);const w=s.getDocument(P.URI.revive(d));return(0,k.$og)(async()=>{const L=await l.commentingRangeProvider.provideCommentingRanges(w,v);let O;return Array.isArray(L)?O={ranges:L,fileComments:!1}:L?O={ranges:L.ranges||[],fileComments:L.fileComments||!1}:O=(0,D.$Be)(L),O}).then(L=>{let O;return L&&(O={ranges:L.ranges.map(N=>b.Range.from(N)),fileComments:L.fileComments}),O})}$toggleReaction(u,d,v,l,w){const L=this.b.get(u);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,k.$og)(()=>{const O=L.getCommentThread(d);if(O){const N=O.getCommentByUniqueId(l.uniqueIdInThread);if(L!==void 0&&N&&L.reactionHandler)return L.reactionHandler(N,n(w))}return Promise.resolve(void 0)})}}class y{static{this.a=0}set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){(u===void 0!=(this.p===void 0)||!u||!this.p||!u.isEqual(this.p))&&(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return this.h}set state(u){this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,d,v,l,w,L,O,N){this.m=d,this.n=v,this.o=l,this.p=w,this.q=L,this.extensionDescription=O,this.r=N,this.handle=y.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new h.$8c,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$mb,this.l.value=new A.$kb,this.n===void 0&&(this.n=`${u}.${this.handle}`),c.$createCommentThread(d,this.handle,this.n,this.o,b.Range.from(this.p),O.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this.i.push({dispose:()=>{c.$deleteCommentThread(d,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(j){T.range=j},get comments(){return T.comments},set comments(j){T.comments=j},get collapsibleState(){return T.collapsibleState},set collapsibleState(j){T.collapsibleState=j},get canReply(){return T.canReply},set canReply(j){T.canReply=j},get contextValue(){return T.contextValue},set contextValue(j){T.contextValue=j},get label(){return T.label},set label(j){T.label=j},get state(){return T.state},set state(j){T.state=j},dispose:()=>{T.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$kb);const u=v=>Object.prototype.hasOwnProperty.call(this.b,v),d={};u("range")&&(d.range=b.Range.from(this.p)),u("label")&&(d.label=this.label),u("contextValue")&&(d.contextValue=this.contextValue??null),u("comments")&&(d.comments=this.q.map(v=>i(this,v,this.k,this.extensionDescription))),u("collapsibleState")&&(d.collapseState=t(this.g)),u("canReply")&&(d.canReply=this.canReply),u("state")&&(d.state=a(this.h)),u("isTemplate")&&(d.isTemplate=this.r),this.b={},c.$updateCommentThread(this.m,this.handle,this.n,this.o,d)}getCommentByUniqueId(u){for(const d of this.k){const v=d[0],l=d[1];if(u===l)return v}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}Je([(0,F.$Ug)(100)],y.prototype,"eventuallyUpdateCommentThread",null);class C{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,c.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,c.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,d,v,l){this.f=u,this.g=d,this.h=v,this.i=l,this.a=new Map,c.$registerCommentController(this.handle,v,l);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(L){w.options=L},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(L){w.commentingRangeProvider=L},get reactionHandler(){return w.reactionHandler},set reactionHandler(L){w.reactionHandler=L},createCommentThread(L,O,N){return w.createCommentThread(L,O,N).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(u,d,v){d===void 0&&(0,$.$zF)(this.f,"fileComments");const l=new y(this.id,this.handle,void 0,u,d,v,this.f,!1);return this.a.set(l.handle,l),l}$createCommentThreadTemplate(u,d){const v=new y(this.id,this.handle,void 0,P.URI.revive(u),b.Range.to(d),[],this.f,!0);return v.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(v.handle,v),v}$updateCommentThreadTemplate(u,d){const v=this.a.get(u);v&&(v.range=b.Range.to(d))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function i(g,u,d,v){let l=d.get(u);return l||(l=++g.commentHandle,d.set(u,l)),u.state!==void 0&&(0,$.$zF)(v,"commentsDraftState"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:l,body:typeof u.body=="string"?u.body:b.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(w=>o(w)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function o(g){return{label:g.label,iconPath:g.iconPath?b.$CL(g.iconPath):void 0,count:g.count,hasReacted:g.authorHasReacted}}function n(g){return{label:g.label||"",count:g.count||0,iconPath:g.iconPath?P.URI.revive(g.iconPath):"",authorHasReacted:g.hasReacted||!1}}function t(g){if(g!==void 0)switch(g){case R.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function a(g){if(g!==void 0)switch(g){case R.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new f}e.$Z$b=S}),define(Se[285],Ce([1,0,23,6,26,20]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=void 0;let P=class{constructor(R,I){this.a=R.getProxy(F.$BJ.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,I){const $=this,D=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){$.e(R,I,D,arguments)}})}e(R,I,$,D){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:E(D,this.b)}),this.c&&this.f(R,$,D)}};e.$Rac=P,e.$Rac=P=Je([qe(0,A.$DL),qe(1,h.$TL)],P);const m=1e5;function E(b,R){const I=[];if(b.length)for(let $=0;$<b.length;$++){let D=b[$];if(typeof D>"u")D="undefined";else if(D instanceof Error){const S=D;S.stack?D=S.stack:D=S.toString()}I.push(D)}if(R){const $=new Error().stack;$&&I.push({__$stack:$.split(`
`).slice(3).join(`
`)})}try{const $=(0,k.$Mm)(I);return $.length>m?"Output omitted for a large object that exceeds the limits":$}catch($){return`Output omitted for an object that cannot be inspected ('${$.toString()}')`}}}),define(Se[142],Ce([1,0,2,6,7,5,20,18,19,12,13,27]),function(fe,e,k,F,h,A,P,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2_b=e.$1_b=void 0;let $=class Qi{static{this.c=0}static{this.d=250}constructor(S,p){this.h=p,this.f=new Map,this.g=S.getProxy(F.$BJ.MainThreadDecorations)}registerFileDecorationProvider(S,p){const r=Qi.c++;this.f.set(r,{provider:S,extensionDescription:p}),this.g.$registerDecorationProvider(r,p.identifier.value);const s=S.onDidChangeFileDecorations&&S.onDidChangeFileDecorations(c=>{if(!c){this.g.$onDidChange(r,null);return}const f=(0,E.$Jf)(c);if(f.length<=Qi.d){this.g.$onDidChange(r,f);return}this.h.warn("[Decorations] CAPPING events from decorations provider",p.identifier.value,f.length);const y=f.map(o=>({uri:o,rank:(0,b.$pd)(o.path,"/")})),C=(0,E.$hf)(y,(o,n)=>o.rank-n.rank||(0,b.$Fd)(o.uri.path,n.uri.path)),i=[];e:for(const o of C){let n;for(const t of o){const a=(0,R.$dc)(t.uri.path);if(n!==a&&(n=a,i.push(t.uri)>=Qi.d))break e}}this.g.$onDidChange(r,i)});return new h.$DJ(()=>{s?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(S,p,r){if(!this.f.has(S))return Object.create(null);const s=Object.create(null),{provider:c,extensionDescription:f}=this.f.get(S);return await Promise.all(p.map(async y=>{try{const{uri:C,id:i}=y,o=await Promise.resolve(c.provideFileDecoration(k.URI.revive(C),r));if(!o)return;try{h.$ZK.validate(o),o.badge&&typeof o.badge!="string"&&(0,I.$zF)(f,"codiconDecoration"),s[i]=[o.propagate,o.tooltip,o.badge,o.color]}catch(n){this.h.warn(`INVALID decoration from extension '${f.identifier.value}': ${n}`)}}catch(C){this.h.error(C)}})),s}};e.$1_b=$,e.$1_b=$=Je([qe(0,P.$DL),qe(1,m.$Ri)],$),e.$2_b=(0,A.$ph)("IExtHostDecorations")}),define(Se[286],Ce([1,0,193,126,2,6,7,16,3,18,28,51]),function(fe,e,k,F,h,A,P,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S$b=e.$R$b=void 0;class ${#e;#t;#i;constructor(p,r,s,c,f,y,C,i){this.d=p,this.e=r,this.f=s,this.g=c,this.h=f,this.c=!1,this.f=Math.max(c,s),this.#i=new R.$ni(o=>y.getComparisonKey(o)),this.#e=C,this.#t=i}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(p,r){if(!p){this.clear();return}this.j();let s=[];if(h.URI.isUri(p)){if(!r){this.delete(p);return}this.#i.set(p,r.slice()),s=[p]}else if(Array.isArray(p)){s=[];let y;p=[...p].sort($.k);for(const C of p){const[i,o]=C;if((!y||i.toString()!==y.toString())&&(y&&this.#i.get(y).length===0&&this.#i.delete(y),y=i,s.push(i),this.#i.set(i,[])),o)this.#i.get(i)?.push(...o);else{const n=this.#i.get(i);n&&(n.length=0)}}}if(this.#t.fire(s),!this.#e)return;const c=[];let f=0;for(const y of s){let C=[];const i=this.#i.get(y);if(i)if(i.length>this.g){C=[];const o=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(const t of i)if(t.severity===o[n]&&C.push({...m.Diagnostic.from(t),modelVersionId:this.h(y)})===this.g)break e;C.push({severity:F.MarkerSeverity.Info,message:(0,k.localize)(0,null,i.length-this.g),startLineNumber:C[C.length-1].startLineNumber,startColumn:C[C.length-1].startColumn,endLineNumber:C[C.length-1].endLineNumber,endColumn:C[C.length-1].endColumn})}else C=i.map(o=>({...m.Diagnostic.from(o),modelVersionId:this.h(y)}));if(c.push([y,C]),f+=C.length,f>this.f)break}this.#e.$changeMany(this.e,c)}delete(p){this.j(),this.#t.fire([p]),this.#i.delete(p),this.#e?.$changeMany(this.e,[[p,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(p,r){this.j();for(const[s,c]of this)p.call(r,s,c,this)}*[Symbol.iterator](){this.j();for(const p of this.#i.keys())yield[p,this.get(p)]}get(p){this.j();const r=this.#i.get(p);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(p){return this.j(),Array.isArray(this.#i.get(p))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(p,r){return p[0].toString()<r[0].toString()?-1:p[0].toString()>r[0].toString()?1:0}}e.$R$b=$;let D=class li{static{this.c=0}static{this.d=1e3}static{this.e=1.1*li.d}static _mapper(p){const r=new R.$ni;for(const s of p)r.set(s,s);return{uris:Object.freeze(Array.from(r.values()))}}constructor(p,r,s,c){this.j=r,this.k=s,this.l=c,this.g=new Map,this.h=new E.$_c({merge:f=>f.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,li._mapper),this.f=p.getProxy(A.$BJ.MainThreadDiagnostics)}createDiagnosticCollection(p,r){const{g:s,f:c,h:f,j:y,k:C,l:i}=this,o=new class{$changeMany(a,g){c.$changeMany(a,g),y.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,a,g.length===0?"CLEARING":g)}$clear(a){c.$clear(a),y.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,a)}dispose(){c.dispose()}};let n;if(!r)r="_generated_diagnostic_collection_name_#"+li.c++,n=r;else if(!s.has(r))n=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do n=r+li.c++;while(s.has(n))}return new class extends ${constructor(){super(r,n,li.e,li.d,a=>i.getDocument(a)?.version,C.extUri,o,f),s.set(n,this)}dispose(){super.dispose(),s.delete(n)}}}getDiagnostics(p){if(p)return this.m(p);{const r=new Map,s=[];for(const c of this.g.values())c.forEach((f,y)=>{let C=r.get(f.toString());typeof C>"u"&&(C=s.length,r.set(f.toString(),C),s.push([f,[]])),s[C][1]=s[C][1].concat(...y)});return s}}m(p){let r=[];for(const s of this.g.values())s.has(p)&&(r=r.concat(s.get(p)));return r}$acceptMarkersChange(p){if(!this.n){const r="_generated_mirror",s=new $(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,c=>{},this.k.extUri,void 0,this.h);this.g.set(r,s),this.n=s}for(const[r,s]of p)this.n.set(h.URI.revive(r),s.map(m.Diagnostic.to))}};e.$S$b=D,e.$S$b=D=Je([qe(1,b.$Ri),qe(2,I.$Q$b)],D)}),define(Se[287],Ce([1,0,2,6,27]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8$b=void 0;class A{constructor(m){this.a=m.getProxy(F.$BJ.MainThreadDialogs)}showOpenDialog(m,E){return E?.allowUIResources&&(0,h.$zF)(m,"showLocal"),this.a.$showOpenDialog(E).then(b=>b?b.map(R=>k.URI.revive(R)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(E=>E?k.URI.revive(E):void 0)}}e.$8$b=A}),define(Se[288],Ce([1,0,8,2,7,6,15,21,12]),function(fe,e,k,F,h,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9$b=void 0;class b{static{this.a=0}constructor(I,$,D){this.d=$,this.e=D,this.b=new Map,this.c=I.getProxy(A.$BJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,$){if(Object.keys(P.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const D=b.a++;this.b.set(D,$),this.c.$registerTextContentProvider(D,I);let S;return typeof $.onDidChange=="function"&&(S=$.onDidChange(p=>{if(p.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this.d.getDocument(p)&&this.$provideTextDocumentContent(D,p).then(r=>{if(!r&&typeof r!="string")return;const s=this.d.getDocument(p);if(!s)return;const c=(0,E.$Ad)(r);if(!s.equalLines(c))return this.c.$onVirtualDocumentChange(p,r)},k.$Y)})),new h.$DJ(()=>{this.b.delete(D)&&this.c.$unregisterTextContentProvider(D),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(I,$){const D=this.b.get(I);return D?Promise.resolve(D.provideTextDocumentContent(F.URI.revive($),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${$.scheme}`))}}e.$9$b=b}),define(Se[289],Ce([1,0,3,4,2,6,135,16,14,23,7,8]),function(fe,e,k,F,h,A,P,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O$b=void 0;class ${constructor(S,p){this.a=new k.$8c({onListenerError:I.$Z}),this.b=new k.$8c({onListenerError:I.$Z}),this.c=new k.$8c({onListenerError:I.$Z}),this.d=new k.$8c({onListenerError:I.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$kb,this.h=new Map,this.f=S.getProxy(A.$BJ.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(r=>{for(const s of r)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const s of r)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const p=this.g.getDocument(S);if(p)return p}getDocument(S){const p=this.getDocumentData(S);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return p.document}ensureDocumentData(S){const p=this.g.getDocument(S);if(p)return Promise.resolve(p);let r=this.h.get(S.toString());return r||(r=this.f.$tryOpenDocument(S).then(s=>{this.h.delete(S.toString());const c=h.URI.revive(s);return(0,E.$ue)(this.g.getDocument(c))},s=>(this.h.delete(S.toString()),Promise.reject(s))),this.h.set(S.toString(),r)),r}createDocumentData(S){return this.f.$tryCreateDocument(S).then(p=>h.URI.revive(p))}$acceptModelLanguageChanged(S,p){const r=h.URI.revive(S),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(p),this.a.fire(s.document)}$acceptModelSaved(S){const p=h.URI.revive(S),r=this.g.getDocument(p);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(S,p){const r=h.URI.revive(S),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(p),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,p,r){const s=h.URI.revive(S),c=this.g.getDocument(s);if(!c)throw new Error("unknown document");c._acceptIsDirty(r),c.onEvents(p);let f;p.isUndoing?f=R.TextDocumentChangeReason.Undo:p.isRedoing&&(f=R.TextDocumentChangeReason.Redo),this.c.fire((0,b.$Im)({document:c.document,contentChanges:p.changes.map(y=>({range:m.Range.to(y.range),rangeOffset:y.rangeOffset,rangeLength:y.rangeLength,text:y.text})),reason:f}))}setWordDefinitionFor(S,p){(0,P.$FL)(S,p)}}e.$O$b=$}),define(Se[61],Ce([1,0,53,3,4,2,5,6,135,20,140,16,18,28,15,48,54]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$NL=void 0;class s{constructor(y){this.value=y,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(y,C){this.h=y,this.i=C,this.a=null,this.b=new Map,this.c=new D.$ni,this.d=new F.$8c,this.e=new F.$8c,this.f=new F.$8c,this.g=new F.$8c,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(y){this.acceptDocumentsAndEditorsDelta(y)}acceptDocumentsAndEditorsDelta(y){const C=[],i=[],o=[];if(y.removedDocuments)for(const n of y.removedDocuments){const t=A.URI.revive(n),a=this.c.get(t);a?.unref()&&(this.c.delete(t),C.push(a.value))}if(y.addedDocuments)for(const n of y.addedDocuments){const t=A.URI.revive(n.uri);let a=this.c.get(t);if(a&&t.scheme!==S.Schemas.vscodeNotebookCell&&t.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);a||(a=new s(new E.$GL(this.h.getProxy(m.$BJ.MainThreadDocuments),t,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(t,a),i.push(a.value)),a.ref()}if(y.removedEditors)for(const n of y.removedEditors){const t=this.b.get(n);this.b.delete(n),t&&o.push(t)}if(y.addedEditors)for(const n of y.addedEditors){const t=A.URI.revive(n.documentUri);k.ok(this.c.has(t),`document '${t}' does not exist`),k.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const a=this.c.get(t).value,g=new R.$ML(n.id,this.h.getProxy(m.$BJ.MainThreadTextEditors),this.i,new r.$T(()=>a.document),n.selections.map(I.Selection.to),n.options,n.visibleRanges.map(u=>I.Range.to(u)),typeof n.editorPosition=="number"?I.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,g)}y.newActiveEditor!==void 0&&(k.ok(y.newActiveEditor===null||this.b.has(y.newActiveEditor),`active editor '${y.newActiveEditor}' does not exist`),this.a=y.newActiveEditor),(0,h.$gb)(C),(0,h.$gb)(o),y.removedDocuments&&this.e.fire(C),y.addedDocuments&&this.d.fire(i),(y.removedEditors||y.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),y.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(y){return this.c.get(y)?.value}allDocuments(){return p.Iterable.map(this.c.values(),y=>y.value)}getEditor(y){return this.b.get(y)}activeEditor(y){if(!this.a)return;const C=this.b.get(this.a);return y?C:C?.value}allEditors(){return[...this.b.values()]}};e.$NL=c,e.$NL=c=Je([qe(0,b.$DL),qe(1,$.$Ri)],c),e.$OL=(0,P.$ph)("IExtHostDocumentsAndEditors")}),define(Se[62],Ce([1,0,16,6,2,3,5,7,20,14,65]),function(fe,e,k,F,h,A,P,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7_b=e.$6_b=void 0,e.$6_b=(0,P.$ph)("IExtHostEditorTabs");class I{constructor(r,s,c){this.e=c,this.d=s,this.acceptDtoUpdate(r)}get apiObject(){if(!this.a){const r=this,s={get isActive(){return r.b.id===r.e()},get label(){return r.b.label},get input(){return r.c},get isDirty(){return r.b.isDirty},get isPinned(){return r.b.isPinned},get isPreview(){return r.b.isPreview},get group(){return r.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(r){this.b=r,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new m.$kL(h.URI.revive(this.b.input.uri));case 2:return new m.$lL(h.URI.revive(this.b.input.original),h.URI.revive(this.b.input.modified));case 3:return new m.$mL(h.URI.revive(this.b.input.base),h.URI.revive(this.b.input.input1),h.URI.revive(this.b.input.input2),h.URI.revive(this.b.input.result));case 6:return new m.$nL(h.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new m.$oL(this.b.input.viewType);case 4:return new m.$pL(h.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new m.$qL(h.URI.revive(this.b.input.original),h.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new m.$rL;case 9:return new m.$sL(h.URI.revive(this.b.input.uri),h.URI.revive(this.b.input.inputBoxUri));default:return}}}class ${constructor(r,s){this.c=[],this.d="",this.b=r,this.e=s;for(const c of r.tabs)c.isActive&&(this.d=c.id),this.c.push(new I(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const r=this,s={get isActive(){return r.b.groupId===r.e()},get viewColumn(){return k.ViewColumn.to(r.b.viewColumn)},get activeTab(){return r.c.find(c=>c.tabId===r.d)?.apiObject},get tabs(){return Object.freeze(r.c.map(c=>c.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(r){this.b=r}acceptTabOperation(r){if(r.kind===0){const c=new I(r.tabDto,this,()=>this.activeTabId());return this.c.splice(r.index,0,c),r.tabDto.isActive&&(this.d=c.tabId),c}else if(r.kind===1){const c=this.c.splice(r.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${r.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(r.kind===3){if(r.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(r.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${r.oldIndex} which does not exist`);return this.c.splice(r.index,0,c),c}const s=this.c.find(c=>c.tabId===r.tabDto.id);if(!s)throw new Error("INVALID tab");return r.tabDto.isActive?this.d=r.tabDto.id:this.d===r.tabDto.id&&!r.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(r.tabDto),s}activeTabId(){return this.d}}let D=class{constructor(r){this.b=new A.$8c,this.c=new A.$8c,this.e=[],this.a=r.getProxy(F.$BJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const r=this,s={onDidChangeTabGroups:r.c.event,onDidChangeTabs:r.b.event,get all(){return Object.freeze(r.e.map(c=>c.apiObject))},get activeTabGroup(){const c=r.d;return(0,b.$ue)(r.e.find(y=>y.groupId===c)?.apiObject)},close:async(c,f)=>{const y=Array.isArray(c)?c:[c];return y.length?S(y[0])?this.j(y,f):this.i(y,f):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(r){const s=new Set(this.e.map(n=>n.groupId)),c=new Set(r.map(n=>n.groupId)),f=(0,R.$J)(s,c),y=this.e.filter(n=>f.removed.includes(n.groupId)).map(n=>n.apiObject),C=[],i=[];this.e=r.map(n=>{const t=new $(n,()=>this.d);return f.added.includes(t.groupId)?C.push(t.apiObject):i.push(t.apiObject),t});const o=(0,b.$ue)(r.find(n=>n.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:C,closed:y,changed:i}))}$acceptTabGroupUpdate(r){const s=this.e.find(c=>c.groupId===r.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(r),r.isActive&&(this.d=r.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(r){const s=this.e.find(f=>f.groupId===r.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const c=s.acceptTabOperation(r);switch(r.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(r){for(const s of this.e)for(const c of s.tabs)if(c.apiObject===r)return c}h(r){return this.e.find(s=>s.apiObject===r)}async i(r,s){const c=[];for(const f of r){const y=this.g(f);if(!y)throw new Error("Tab close: Invalid tab not found!");c.push(y.tabId)}return this.a.$closeTab(c,s)}async j(r,s){const c=[];for(const f of r){const y=this.h(f);if(!y)throw new Error("Group close: Invalid group not found!");c.push(y.groupId)}return this.a.$closeGroup(c,s)}};e.$7_b=D,e.$7_b=D=Je([qe(0,E.$DL)],D);function S(p){return p.tabs!==void 0}}),define(Se[290],Ce([1,0,2,6,4,7,16,162,12,22,27,74]),function(fe,e,k,F,h,A,P,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C_b=void 0;class ${constructor(){this.a=[]}add(p){this.b=void 0,this.a.push(p)}delete(p){const r=this.a.indexOf(p);r>=0&&(this.a.splice(r,1),this.b=void 0)}c(){if(!this.b){const p=this.a.sort(),r=[];let s,c,f=14,y=14;for(const C of p){let i=s?(0,E.$Od)(s,C):0;for(i===0?c=1:c=y;i<C.length;i++)i+1===C.length?(f=y,y=9):y+=1,r.push([c,C.toUpperCase().charCodeAt(i),y]),r.push([c,C.toLowerCase().charCodeAt(i),y]),c=y;s=C,y=f}r.push([9,58,10]),r.push([10,47,12]),this.b=new m.$$W(r)}}provideDocumentLinks(p){this.c();const r=[],s=m.$_W.computeLinks({getLineContent(c){return p.lineAt(c-1).text},getLineCount(){return p.lineCount}},this.b);for(const c of s){const f=P.DocumentLink.to(c);f.target&&r.push(f)}return r}}class D{constructor(p,r){this.i=r,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=p.getProxy(F.$BJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(p,r,s,c={}){if(D.j(s),this.d.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(p,"*",this.b));const f=this.h++;this.b.add(r),this.d.add(r),this.c.set(f,s);let y=2;c.isCaseSensitive&&(y+=1024),c.isReadonly&&(y+=2048),typeof s.copy=="function"&&(y+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,R.$zF)(p,"fsChunks"),y+=4);let C;c.isReadonly&&(0,I.$Mj)(c.isReadonly)&&((0,R.$zF)(p,"readonlyMessage"),C={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(f,r,y,C).catch(o=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${r}`),console.error(o)});const i=s.onDidChangeFile(o=>{const n=[];for(const t of o){const{uri:a,type:g}=t;if(a.scheme!==r)continue;let u;switch(g){case A.FileChangeType.Changed:u=0;break;case A.FileChangeType.Created:u=1;break;case A.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:a,type:u})}this.a.$onFileSystemChange(f,n)});return(0,h.$jb)(()=>{i.dispose(),this.b.delete(r),this.d.delete(r),this.c.delete(f),this.a.$unregisterProvider(f)})}static j(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static k(p){const{type:r,ctime:s,mtime:c,size:f,permissions:y}=p;return{type:r,ctime:s,mtime:c,size:f,permissions:y}}$stat(p,r){return Promise.resolve(this.l(p).stat(k.URI.revive(r))).then(s=>D.k(s))}$readdir(p,r){return Promise.resolve(this.l(p).readDirectory(k.URI.revive(r)))}$readFile(p,r){return Promise.resolve(this.l(p).readFile(k.URI.revive(r))).then(s=>b.$Jb.wrap(s))}$writeFile(p,r,s,c){return Promise.resolve(this.l(p).writeFile(k.URI.revive(r),s.buffer,c))}$delete(p,r,s){return Promise.resolve(this.l(p).delete(k.URI.revive(r),s))}$rename(p,r,s,c){return Promise.resolve(this.l(p).rename(k.URI.revive(r),k.URI.revive(s),c))}$copy(p,r,s,c){const f=this.l(p);if(!f.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(f.copy(k.URI.revive(r),k.URI.revive(s),c))}$mkdir(p,r){return Promise.resolve(this.l(p).createDirectory(k.URI.revive(r)))}$watch(p,r,s,c){const f=this.l(p).watch(k.URI.revive(s),c);this.f.set(r,f)}$unwatch(p,r){const s=this.f.get(r);s&&(s.dispose(),this.f.delete(r))}$open(p,r,s){const c=this.l(p);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(k.URI.revive(r),s))}$close(p,r){const s=this.l(p);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(r))}$read(p,r,s,c){const f=this.l(p);if(!f.read)throw new Error('FileSystemProvider does not implement "read"');const y=b.$Jb.alloc(c);return Promise.resolve(f.read(r,s,y.buffer,0,c)).then(C=>y.slice(0,C))}$write(p,r,s,c){const f=this.l(p);if(!f.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(f.write(r,s,c.buffer,0,c.byteLength))}l(p){const r=this.c.get(p);if(!r){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return r}}e.$C_b=D}),define(Se[63],Ce([1,0,6,30,7,22,5,20,51,4,17,24,15]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=e.$i_b=void 0;let D=class ii{constructor(p,r){this.b=new Map,this.c=new R.$Dg,this.a=p.getProxy(k.$BJ.MainThreadFileSystem);const s=this;this.value=Object.freeze({async stat(c){try{let f;const y=s.b.get(c.scheme);return y?(await s.a.$ensureActivation(c.scheme),f=await y.impl.stat(c)):f=await s.a.$stat(c),{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions===F.FilePermission.Readonly?1:void 0}}catch(f){ii.e(f)}},async readDirectory(c){try{const f=s.b.get(c.scheme);return f?(await s.a.$ensureActivation(c.scheme),(await f.impl.readDirectory(c)).slice()):await s.a.$readdir(c)}catch(f){return ii.e(f)}},async createDirectory(c){try{const f=s.b.get(c.scheme);return f&&!f.isReadonly?(await s.a.$ensureActivation(c.scheme),await s.d(f.impl,f.extUri,c)):await s.a.$mkdir(c)}catch(f){return ii.e(f)}},async readFile(c){try{const f=s.b.get(c.scheme);return f?(await s.a.$ensureActivation(c.scheme),(await f.impl.readFile(c)).slice()):(await s.a.$readFile(c)).buffer}catch(f){return ii.e(f)}},async writeFile(c,f){try{const y=s.b.get(c.scheme);return y&&!y.isReadonly?(await s.a.$ensureActivation(c.scheme),await s.d(y.impl,y.extUri,y.extUri.dirname(c)),await s.c.queueFor(c).queue(()=>Promise.resolve(y.impl.writeFile(c,f,{create:!0,overwrite:!0})))):await s.a.$writeFile(c,A.$Jb.wrap(f))}catch(y){return ii.e(y)}},async delete(c,f){try{const y=s.b.get(c.scheme);return y&&!y.isReadonly?(await s.a.$ensureActivation(c.scheme),await y.impl.delete(c,{recursive:!1,...f})):await s.a.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...f})}catch(y){return ii.e(y)}},async rename(c,f,y){try{return await s.a.$rename(c,f,{overwrite:!1,...y})}catch(C){return ii.e(C)}},async copy(c,f,y){try{return await s.a.$copy(c,f,{overwrite:!1,...y})}catch(C){return ii.e(C)}},isWritableFileSystem(c){const f=r.getCapabilities(c);if(typeof f=="number")return!(f&2048)}})}async d(p,r,s){const c=[];for(;!r.isEqual(s,r.dirname(s));)try{if(!((await p.stat(s)).type&F.FileType.Directory))throw h.$RK.FileExists(`Unable to create folder '${s.scheme===$.Schemas.file?s.fsPath:s.toString(!0)}' that already exists but is not a directory`);break}catch(f){if(F.$8j(f)!==F.FileSystemProviderErrorCode.FileNotFound)throw f;c.push(r.basename(s)),s=r.dirname(s)}for(let f=c.length-1;f>=0;f--){s=r.joinPath(s,c[f]);try{await p.createDirectory(s)}catch(y){if(F.$8j(y)!==F.FileSystemProviderErrorCode.FileExists)throw y}}}static e(p){if(p instanceof h.$RK)throw p;if(p instanceof F.$4j)switch(p.code){case F.FileSystemProviderErrorCode.FileExists:throw h.$RK.FileExists(p.message);case F.FileSystemProviderErrorCode.FileNotFound:throw h.$RK.FileNotFound(p.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw h.$RK.FileNotADirectory(p.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw h.$RK.FileIsADirectory(p.message);case F.FileSystemProviderErrorCode.NoPermissions:throw h.$RK.NoPermissions(p.message);case F.FileSystemProviderErrorCode.Unavailable:throw h.$RK.Unavailable(p.message);default:throw new h.$RK(p.message,p.name)}if(!(p instanceof Error))throw new h.$RK(String(p));if(p.name==="ENOPRO"||p.message.includes("ENOPRO"))throw h.$RK.Unavailable(p.message);switch(p.name){case F.FileSystemProviderErrorCode.FileExists:throw h.$RK.FileExists(p.message);case F.FileSystemProviderErrorCode.FileNotFound:throw h.$RK.FileNotFound(p.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw h.$RK.FileNotADirectory(p.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw h.$RK.FileIsADirectory(p.message);case F.FileSystemProviderErrorCode.NoPermissions:throw h.$RK.NoPermissions(p.message);case F.FileSystemProviderErrorCode.Unavailable:throw h.$RK.Unavailable(p.message);default:throw new h.$RK(p.message,p.name)}}addFileSystemProvider(p,r,s){return this.b.set(p,{impl:r,extUri:s?.isCaseSensitive?I.$Zf:I.$2f,isReadonly:!!s?.isReadonly}),(0,b.$jb)(()=>this.b.delete(p))}getFileSystemProviderExtUri(p){return this.b.get(p)?.extUri??I.$Zf}};e.$i_b=D,e.$i_b=D=Je([qe(0,m.$DL),qe(1,E.$Q$b)],D),e.$j_b=(0,P.$ph)("IExtHostConsumerFileSystem")}),define(Se[291],Ce([1,0,3,34,2,6,16,7]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D_b=void 0;class E{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(I,$,D,S,p,r,s,c){this.a=new k.$8c,this.b=new k.$8c,this.c=new k.$8c;const f=this.h(I,D,p);this.g=0,r&&(this.g+=1),s&&(this.g+=2),c&&(this.g+=4);const y=(0,F.$ej)(p),C=typeof p=="string",i=S(o=>{if(!r)for(const n of o.created){const t=h.URI.revive(n);y(t.fsPath)&&(!C||$.getWorkspaceFolder(t))&&this.a.fire(t)}if(!s)for(const n of o.changed){const t=h.URI.revive(n);y(t.fsPath)&&(!C||$.getWorkspaceFolder(t))&&this.b.fire(t)}if(!c)for(const n of o.deleted){const t=h.URI.revive(n);y(t.fsPath)&&(!C||$.getWorkspaceFolder(t))&&this.c.fire(t)}});this.d=m.$DJ.from(f,this.a,this.b,this.c,i)}h(I,$,D){const S=m.$DJ.from();if(typeof D=="string")return S;const p=I.getProxy(A.$BJ.MainThreadFileSystem);let r=!1;(D.pattern.includes(F.$aj)||D.pattern.includes(F.$bj))&&(r=!0);const s=Math.random();return p.$watch($.identifier.value,s,D.baseUri,{recursive:r,excludes:[]}),m.$DJ.from({dispose:()=>p.$unwatch(s)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class b{constructor(I,$,D){this.j=I,this.k=$,this.l=D,this.a=new k.$8c,this.b=new k.$8c,this.c=new k.$8c,this.d=new k.$8c,this.g=new k.$0c,this.h=new k.$0c,this.i=new k.$0c,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(I,$,D,S,p,r){return new E(this.j,I,$,this.a.event,P.GlobPattern.from(D),S,p,r)}$onFileEvent(I){this.a.fire(I)}$onDidRunFileOperation(I,$){switch(I){case 2:this.b.fire(Object.freeze({files:$.map(D=>({oldUri:h.URI.revive(D.source),newUri:h.URI.revive(D.target)}))}));break;case 1:this.d.fire(Object.freeze({files:$.map(D=>h.URI.revive(D.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:$.map(D=>h.URI.revive(D.target))}));break;default:}}getOnWillRenameFileEvent(I){return this.m(I,this.g)}getOnWillCreateFileEvent(I){return this.m(I,this.h)}getOnWillDeleteFileEvent(I){return this.m(I,this.i)}m(I,$){return(D,S,p)=>{const r=function(c){D.call(S,c)};return r.extension=I,$.event(r,void 0,p)}}async $onWillRunFileOperation(I,$,D,S){switch(I){case 2:return await this.n(this.g,{files:$.map(p=>({oldUri:h.URI.revive(p.source),newUri:h.URI.revive(p.target)}))},D,S);case 1:return await this.n(this.i,{files:$.map(p=>h.URI.revive(p.target))},D,S);case 0:case 3:return await this.n(this.h,{files:$.map(p=>h.URI.revive(p.target))},D,S)}}async n(I,$,D,S){const p=new Set,r=[];if(await I.fireAsync($,S,async(c,f)=>{const y=Date.now(),C=await Promise.resolve(c);C instanceof m.$NJ&&(r.push([f.extension,C]),p.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-y>D&&this.k.warn("SLOW file-participant",f.extension.identifier)}),S.isCancellationRequested||r.length===0)return;const s={edits:[]};for(const[,c]of r){const{edits:f}=P.WorkspaceEdit.from(c,{getTextDocumentVersion:y=>this.l.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(f)}return{edit:s,extensionNames:Array.from(p)}}}e.$D_b=b}),define(Se[292],Ce([1,0,4,2,6,16,7,36]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kac=void 0;class E{static{this.a=0}constructor($,D){this.extension=$,this.provider=D,this.handle=E.a++}}class b{constructor($){this.session=$,this.responses=[]}}class R{static{this.a=0}constructor($,D,S,p){this.f=S,this.g=p,this.b=new Map,this.d=new Map,this.e=$.getProxy(h.$BJ.MainThreadInlineChat),D.registerApiCommand(new m.$4L("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$2L("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?A.Range.from(r.initialRange):void 0,initialSelection:r.initialSelection?A.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?A.Position.from(r.position):void 0}})],m.$3L.Void))}registerProvider($,D){const S=new E($,D);return this.b.set(S.handle,S),this.e.$registerInteractiveEditorProvider(S.handle,$.identifier.value,typeof D.handleInteractiveEditorResponseFeedback=="function"),(0,k.$jb)(()=>{this.e.$unregisterInteractiveEditorProvider(S.handle),this.b.delete(S.handle)})}async $prepareSession($,D,S,p){const r=this.b.get($);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const s=this.f.getDocument(F.URI.revive(D)),c=A.Selection.to(S),f=await r.provider.prepareInteractiveEditorSession({document:s,selection:c},p);if(!f)return;if(f.wholeRange&&!f.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const y=R.a++;return this.d.set(y,new b(f)),{id:y,placeholder:f.placeholder,slashCommands:f.slashCommands?.map(C=>({command:C.command,detail:C.detail,refer:C.refer,executeImmediately:C.executeImmediately})),wholeRange:A.Range.from(f.wholeRange),message:f.message}}async $provideResponse($,D,S,p){const r=this.b.get($);if(!r)return;const s=this.d.get(D.id);if(!s)return;const c={session:s.session,prompt:S.prompt,selection:A.Selection.to(S.selection),wholeRange:A.Range.to(S.wholeRange),attempt:S.attempt,live:S.live};let f=!1;const y={report:o=>{if(!S.live)throw new Error("Progress reporting is only supported for live sessions");f||p.isCancellationRequested||!o.message&&!o.edits||this.e.$handleProgressChunk(S.requestId,{message:o.message,edits:o.edits?.map(A.TextEdit.from)})}},C=typeof r.provider.provideInteractiveEditorResponse2=="function"?r.provider.provideInteractiveEditorResponse2(c,y,p):r.provider.provideInteractiveEditorResponse(c,p);Promise.resolve(C).finally(()=>f=!0);const i=await C;if(i){const o=s.responses.push(i)-1,n={wholeRange:A.Range.from(i.wholeRange),placeholder:i.placeholder};if(R.h(i))return{...n,id:o,type:"message",message:A.MarkdownString.from(i.contents)};const{edits:t}=i;if(t instanceof P.$NJ)return{...n,id:o,type:"bulkEdit",edits:A.WorkspaceEdit.from(t)};if(Array.isArray(t))return{...n,id:o,type:"editorEdit",edits:t.map(A.TextEdit.from)}}}$handleFeedback($,D,S,p){const r=this.b.get($),s=this.d.get(D),c=s?.responses[S];if(r&&c){let f;switch(p){case 1:f=P.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:f=P.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:f=P.InteractiveEditorResponseFeedbackKind.Undone;break;case 3:f=P.InteractiveEditorResponseFeedbackKind.Accepted;break}r.provider.handleInteractiveEditorResponseFeedback?.(s.session,c,f)}}$releaseSession($,D){const S=this.d.get(D),p=this.b.get($);S&&p&&p.provider.releaseInteractiveEditorSession?.(S.session),this.d.delete(D)}static h($){return typeof $=="object"&&typeof $.contents=="object"}}e.$Kac=R}),define(Se[293],Ce([1,0,2,36]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=void 0;class h{constructor(P,m,E,b,R){this.a=m,this.b=E,this.c=b;const I=new F.$4L("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$2L("showOptions","Show Options",$=>!0,$=>$),new F.$2L("resource","Interactive resource Uri",$=>!0,$=>$),new F.$2L("controllerId","Notebook controller Id",$=>!0,$=>$),new F.$2L("title","Interactive editor title",$=>!0,$=>$)],new F.$3L("Notebook and input URI",$=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",$.notebookEditorId),$.notebookEditorId!==void 0){const D=this.a.getEditorById($.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",D.id),{notebookUri:k.URI.revive($.notebookUri),inputUri:k.URI.revive($.inputUri),notebookEditor:D.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",$.notebookUri,$.inputUri),{notebookUri:k.URI.revive($.notebookUri),inputUri:k.URI.revive($.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(P,m,E,b){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:E,uri:P,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(k.URI.revive(b))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.$Gac=h}),define(Se[294],Ce([1,0,6,7]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nac=void 0;class h{constructor(P){this.a=new Map,this.b=P.getProxy(k.$BJ.MainThreadIssueReporter)}async $getIssueReporterUri(P,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(P);if(!E)throw new Error("Issue request handler not found");const b=await E.handleIssueUrlRequest();if(!b)throw new Error("Issue request handler returned no result");return b}registerIssueUriRequestHandler(P,m){const E=P.identifier.value;return this.a.set(E,m),this.b.$registerIssueUriRequestHandler(E),new F.$DJ(()=>{this.b.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}}e.$Nac=h}),define(Se[295],Ce([1,0,4,6]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z_b=void 0;class h{constructor(P){this.b=0,this.a=P.getProxy(F.$BJ.MainThreadLabelService)}$registerResourceLabelFormatter(P){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,P),(0,k.$jb)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$Z_b=h}),define(Se[296],Ce([1,0,2,23,16,7,77,6,12,33,19,14,158,21,25,4,123,111,81,39,8,17,27,195]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c,f,y,C,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W$b=void 0;class n{constructor(U,G){this.d=U,this.e=G}async provideDocumentSymbols(U,G){const Z=this.d.getDocument(U),ee=await this.e.provideDocumentSymbols(Z,G);if(!(0,R.$pf)(ee))return ee[0]instanceof A.$VJ?ee.map(h.DocumentSymbol.from):n.f(ee)}static f(U){U=U.slice(0).sort((ee,be)=>{let se=ee.location.range.start.compareTo(be.location.range.start);return se===0&&(se=be.location.range.end.compareTo(ee.location.range.end)),se});const G=[],Z=[];for(const ee of U){const be={name:ee.name||"!!MISSING: name!!",kind:h.SymbolKind.from(ee.kind),tags:ee.tags?.map(h.SymbolTag.from)||[],detail:"",containerName:ee.containerName,range:h.Range.from(ee.location.range),selectionRange:h.Range.from(ee.location.range),children:[]};for(;;){if(Z.length===0){Z.push(be),G.push(be);break}const se=Z[Z.length-1];if(b.$Or.containsRange(se.range,be.range)&&!b.$Or.equalsRange(se.range,be.range)){se.children?.push(be),Z.push(be);break}Z.pop()}}return G}}class t{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(U,G,Z){this.g=U,this.h=G,this.j=Z,this.e=new c.$N$b("CodeLens"),this.f=new Map}async provideCodeLenses(U,G){const Z=this.g.getDocument(U),ee=await this.j.provideCodeLenses(Z,G);if(!ee||G.isCancellationRequested)return;const be=this.e.add(ee),se=new p.$kb;this.f.set(be,se);const we={cacheId:be,lenses:[]};for(let Ie=0;Ie<ee.length;Ie++)we.lenses.push({cacheId:[be,Ie],range:h.Range.from(ee[Ie].range),command:this.h.toInternal(ee[Ie].command,se)});return we}async resolveCodeLens(U,G){const Z=U.cacheId&&this.e.get(...U.cacheId);if(!Z)return;let ee;if(typeof this.j.resolveCodeLens!="function"||Z.isResolved?ee=Z:ee=await this.j.resolveCodeLens(Z,G),ee||(ee=Z),G.isCancellationRequested)return;const be=U.cacheId&&this.f.get(U.cacheId[0]);if(be)return U.command=this.h.toInternal(ee.command??t.d,be),U}releaseCodeLenses(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}}function a($e){return Array.isArray($e)?$e.map(h.DefinitionLink.from):$e?[h.DefinitionLink.from($e)]:[]}class g{constructor(U,G){this.d=U,this.e=G}async provideDefinition(U,G,Z){const ee=this.d.getDocument(U),be=h.Position.to(G),se=await this.e.provideDefinition(ee,be,Z);return a(se)}}class u{constructor(U,G){this.d=U,this.e=G}async provideDeclaration(U,G,Z){const ee=this.d.getDocument(U),be=h.Position.to(G),se=await this.e.provideDeclaration(ee,be,Z);return a(se)}}class d{constructor(U,G){this.d=U,this.e=G}async provideImplementation(U,G,Z){const ee=this.d.getDocument(U),be=h.Position.to(G),se=await this.e.provideImplementation(ee,be,Z);return a(se)}}class v{constructor(U,G){this.d=U,this.e=G}async provideTypeDefinition(U,G,Z){const ee=this.d.getDocument(U),be=h.Position.to(G),se=await this.e.provideTypeDefinition(ee,be,Z);return a(se)}}class l{constructor(U,G){this.d=U,this.e=G}async provideHover(U,G,Z){const ee=this.d.getDocument(U),be=h.Position.to(G),se=await this.e.provideHover(ee,be,Z);if(!(!se||(0,R.$pf)(se.contents)))return se.range||(se.range=ee.getWordRangeAtPosition(be)),se.range||(se.range=new A.$FJ(be,be)),h.Hover.from(se)}}class w{constructor(U,G){this.d=U,this.e=G}async provideEvaluatableExpression(U,G,Z){const ee=this.d.getDocument(U),be=h.Position.to(G),se=await this.e.provideEvaluatableExpression(ee,be,Z);if(se)return h.EvaluatableExpression.from(se)}}class L{constructor(U,G){this.d=U,this.e=G}async provideInlineValues(U,G,Z,ee){const be=this.d.getDocument(U),se=await this.e.provideInlineValues(be,h.Range.to(G),h.InlineValueContext.to(Z),ee);if(Array.isArray(se))return se.map(we=>h.InlineValue.from(we))}}class O{constructor(U,G){this.d=U,this.e=G}async provideDocumentHighlights(U,G,Z){const ee=this.d.getDocument(U),be=h.Position.to(G),se=await this.e.provideDocumentHighlights(ee,be,Z);if(Array.isArray(se))return se.map(h.DocumentHighlight.from)}}class N{constructor(U,G){this.d=U,this.e=G}async provideLinkedEditingRanges(U,G,Z){const ee=this.d.getDocument(U),be=h.Position.to(G),se=await this.e.provideLinkedEditingRanges(ee,be,Z);if(se&&Array.isArray(se.ranges))return{ranges:(0,R.$mf)(se.ranges.map(h.Range.from)),wordPattern:se.wordPattern}}}class T{constructor(U,G){this.d=U,this.e=G}async provideReferences(U,G,Z,ee){const be=this.d.getDocument(U),se=h.Position.to(G),we=await this.e.provideReferences(be,se,Z,ee);if(Array.isArray(we))return we.map(h.location.from)}}class j{static{this.d=1e3}constructor(U,G,Z,ee,be,se,we){this.h=U,this.j=G,this.k=Z,this.l=ee,this.m=be,this.n=se,this.o=we,this.e=new c.$N$b("CodeAction"),this.f=new Map,this.g=new A.$XJ("notebook")}async provideCodeActions(U,G,Z,ee){const be=this.h.getDocument(U),se=$.$Wr.isISelection(G)?h.Selection.to(G):h.Range.to(G),we=[];for(const et of this.k.getDiagnostics(U))if(se.intersection(et.range)&&we.push(et)>j.d)break;const Ie={diagnostics:we,only:Z.only?new A.$XJ(Z.only):void 0,triggerKind:h.CodeActionTriggerKind.to(Z.trigger)},je=await this.l.provideCodeActions(be,se,Ie,ee);if(!(0,R.$qf)(je)||ee.isCancellationRequested)return;const Ve=this.e.add(je),_e=new p.$kb;this.f.set(Ve,_e);const Ge=[];for(let et=0;et<je.length;et++){const Qe=je[et];if(Qe)if(j.p(Qe))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:Qe.title,command:this.j.toInternal(Qe,_e)});else{if(Ie.triggerKind!==A.CodeActionTriggerKind.Invoke&&Qe.kind&&this.g.contains(Qe.kind))continue;Ie.only&&(Qe.kind?Ie.only.contains(Qe.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[Ve,et],title:Qe.title,command:Qe.command&&this.j.toInternal(Qe.command,_e),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(h.Diagnostic.from),edit:Qe.edit&&h.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})}}return{cacheId:Ve,actions:Ge}}async resolveCodeAction(U,G){const[Z,ee]=U,be=this.e.get(Z,ee);if(!be||j.p(be))return{};if(!this.l.resolveCodeAction)return{};const se=await this.l.resolveCodeAction(be,G)??be;let we;se.edit&&(we=h.WorkspaceEdit.from(se.edit,void 0));let Ie;if(se.command){const je=this.f.get(Z);je&&(Ie=this.j.toInternal(se.command,je))}return{edit:we,command:Ie}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static p(U){return typeof U.command=="string"&&typeof U.title=="string"}}class W{constructor(U,G,Z,ee,be){this.d=U,this.e=G,this.f=Z,this.g=ee,this.h=be}async prepareDocumentPaste(U,G,Z,ee){if(!this.f.prepareDocumentPaste)return;const be=this.e.getDocument(U),se=G.map(je=>h.Range.to(je)),we=h.DataTransfer.toDataTransfer(Z,()=>{throw new y.$0});if(await this.f.prepareDocumentPaste(be,se,we,ee),ee.isCancellationRequested)return;const Ie=Array.from(we).filter(([,je])=>!(je instanceof A.$sK));return h.DataTransfer.from(Ie)}async providePasteEdits(U,G,Z,ee,be){if(!this.f.provideDocumentPasteEdits)return;const se=this.e.getDocument(G),we=Z.map(Ve=>h.Range.to(Ve)),Ie=h.DataTransfer.toDataTransfer(ee,async Ve=>(await this.d.$resolvePasteFileData(this.g,U,Ve)).buffer),je=await this.f.provideDocumentPasteEdits(se,we,Ie,be);if(je)return{id:je.id?this.h.identifier.value+"."+je.id:this.h.identifier.value,label:je.label??(0,o.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,priority:je.priority??0,insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?h.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class M{constructor(U,G){this.d=U,this.e=G}async provideDocumentFormattingEdits(U,G,Z){const ee=this.d.getDocument(U),be=await this.e.provideDocumentFormattingEdits(ee,G,Z);if(Array.isArray(be))return be.map(h.TextEdit.from)}}class Y{constructor(U,G){this.d=U,this.e=G}async provideDocumentRangeFormattingEdits(U,G,Z,ee){const be=this.d.getDocument(U),se=h.Range.to(G),we=await this.e.provideDocumentRangeFormattingEdits(be,se,Z,ee);if(Array.isArray(we))return we.map(h.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,G,Z,ee){(0,I.$te)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const be=this.d.getDocument(U),se=G.map(h.Range.to),we=await this.e.provideDocumentRangesFormattingEdits(be,se,Z,ee);if(Array.isArray(we))return we.map(h.TextEdit.from)}}class V{constructor(U,G){this.d=U,this.e=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,G,Z,ee,be){const se=this.d.getDocument(U),we=h.Position.to(G),Ie=await this.e.provideOnTypeFormattingEdits(se,we,Z,ee,be);if(Array.isArray(Ie))return Ie.map(h.TextEdit.from)}}class de{constructor(U,G){this.e=U,this.f=G,this.d=new c.$N$b("WorkspaceSymbols")}async provideWorkspaceSymbols(U,G){const Z=await this.e.provideWorkspaceSymbols(U,G);if(!(0,R.$qf)(Z))return{symbols:[]};const ee=this.d.add(Z),be={cacheId:ee,symbols:[]};for(let se=0;se<Z.length;se++){const we=Z[se];if(!we||!we.name){this.f.warn("INVALID SymbolInformation",we);continue}be.symbols.push({...h.WorkspaceSymbol.from(we),cacheId:[ee,se]})}return be}async resolveWorkspaceSymbol(U,G){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const Z=this.d.get(...U.cacheId);if(Z){const ee=await this.e.resolveWorkspaceSymbol(Z,G);return ee&&(0,F.$Km)(U,h.WorkspaceSymbol.from(ee),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class re{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,G,Z){this.d=U,this.e=G,this.f=Z}async provideRenameEdits(U,G,Z,ee){const be=this.d.getDocument(U),se=h.Position.to(G);try{const we=await this.e.provideRenameEdits(be,se,Z,ee);return we?h.WorkspaceEdit.from(we):void 0}catch(we){const Ie=re.g(we);return Ie?{rejectReason:Ie,edits:void 0}:Promise.reject(we)}}async resolveRenameLocation(U,G,Z){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const ee=this.d.getDocument(U),be=h.Position.to(G);try{const se=await this.e.prepareRename(ee,be,Z);let we,Ie;if(A.$FJ.isRange(se)?(we=se,Ie=ee.getText(se)):(0,I.$le)(se)&&(we=se.range,Ie=se.placeholder),!we||!Ie)return;if(we.start.line>be.line||we.end.line<be.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:h.Range.from(we),text:Ie}}catch(se){const we=re.g(se);return we?{rejectReason:we,range:void 0,text:void 0}:Promise.reject(se)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class x{constructor(U,G){this.resultId=U,this.tokens=G}}class q{constructor(U,G){this.f=U,this.g=G,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,G,Z){const ee=this.f.getDocument(U),be=G!==0?this.d.get(G):null;let se=typeof be?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(ee,be.resultId,Z):await this.g.provideDocumentSemanticTokens(ee,Z);return be&&this.d.delete(G),se?(se=q.h(se),this.o(q.n(be,se),se)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return q.j(U)?q.k(U)?U:new A.$VK(new Uint32Array(U.data),U.resultId):q.l(U)?q.m(U)?U:new A.$XK(U.edits.map(G=>new A.$WK(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const G of U.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static n(U,G){if(!q.j(G)||!U||!U.tokens)return G;const Z=U.tokens,ee=Z.length,be=G.data,se=be.length;let we=0;const Ie=Math.min(ee,se);for(;we<Ie&&Z[we]===be[we];)we++;if(we===ee&&we===se)return new A.$XK([],G.resultId);let je=0;const Ve=Ie-we;for(;je<Ve&&Z[ee-je-1]===be[se-je-1];)je++;return new A.$XK([{start:we,deleteCount:ee-we-je,data:be.subarray(we,se-je)}],G.resultId)}o(U,G){if(q.j(U)){const Z=this.e++;return this.d.set(Z,new x(U.resultId,U.data)),(0,r.$G8)({id:Z,type:"full",data:U.data})}if(q.l(U)){const Z=this.e++;return q.j(G)?this.d.set(Z,new x(G.resultId,G.data)):this.d.set(Z,new x(U.resultId)),(0,r.$G8)({id:Z,type:"delta",deltas:(U.edits||[]).map(ee=>({start:ee.start,deleteCount:ee.deleteCount,data:ee.data}))})}return null}}class ne{constructor(U,G){this.d=U,this.e=G}async provideDocumentRangeSemanticTokens(U,G,Z){const ee=this.d.getDocument(U),be=await this.e.provideDocumentRangeSemanticTokens(ee,h.Range.to(G),Z);return be?this.f(be):null}f(U){return(0,r.$G8)({id:0,type:"full",data:U.data})}}class pe{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,G,Z,ee,be){this.f=U,this.g=G,this.h=Z,this.j=ee,this.k=be,this.d=new c.$N$b("CompletionItem"),this.e=new Map}async provideCompletionItems(U,G,Z,ee){const be=this.f.getDocument(U),se=h.Position.to(G),we=be.getWordRangeAtPosition(se)||new A.$FJ(se,se),Ie=we.with({end:se}),je=new f.$4c,Ve=await this.h.provideCompletionItems(be,se,ee,h.CompletionContext.to(Z));if(!Ve||ee.isCancellationRequested)return;const _e=Array.isArray(Ve)?new A.$_J(Ve):Ve,Ge=pe.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),et=new p.$kb;this.e.set(Ge,et);const Qe=[],st={x:Ge,b:Qe,a:{replace:h.Range.from(we),insert:h.Range.from(Ie)},c:_e.isIncomplete||void 0,d:je.elapsed()};for(let tt=0;tt<_e.items.length;tt++){const Pe=_e.items[tt],ke=this.l(Pe,[Ge,tt],Ie,we);Qe.push(ke)}return st}async resolveCompletionItem(U,G){if(typeof this.h.resolveCompletionItem!="function")return;const Z=this.d.get(...U);if(!Z)return;const ee=this.l(Z,U),be=await this.h.resolveCompletionItem(Z,G);if(!be)return;const se=this.l(be,U);return(ee.h!==se.h||ee.i!==se.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(ee.n!==se.n||ee.o!==se.o||!(0,F.$Lm)(ee.p,se.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...ee,d:se.d,c:se.c,l:se.l,h:se.h,i:se.i,n:se.n,o:se.o,p:se.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,G,Z,ee){const be=this.e.get(G[0]);if(!be)throw Error("DisposableStore is missing...");const se=this.g.toInternal(U.command,be),we={x:G,a:U.label,b:U.kind!==void 0?h.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(h.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:h.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(h.TextEdit.from),n:se?.$ident,o:se?.id,p:se?.$ident?void 0:se?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=U.textEdit.newText):typeof U.insertText=="string"?we.h=U.insertText:U.insertText instanceof A.$OJ&&(we.h=U.insertText.value,we.i|=4);let Ie;return U.textEdit?Ie=U.textEdit.range:U.range&&(Ie=U.range),A.$FJ.isRange(Ie)?we.j=h.Range.from(Ie):Ie&&(!Z?.isEqual(Ie.inserting)||!ee?.isEqual(Ie.replacing))&&(we.j={insert:h.Range.from(Ie.inserting),replace:h.Range.from(Ie.replacing)}),we}}class H{async provideInlineCompletions(U,G,Z,ee){}disposeCompletions(U){}handleDidShowCompletionItem(U,G,Z){}handlePartialAccept(U,G,Z){}}class ue extends H{constructor(U,G,Z,ee){super(),this.f=U,this.g=G,this.h=Z,this.j=ee,this.d=new ce,this.e=(0,i.$yF)(this.f,"inlineCompletionsAdditions"),this.k={[P.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[P.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$yF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,G,Z,ee){const be=this.g.getDocument(U),se=h.Position.to(G),we=await this.h.provideInlineCompletionItems(be,se,{selectedCompletionInfo:Z.selectedSuggestionInfo?{range:h.Range.to(Z.selectedSuggestionInfo.range),text:Z.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Z.triggerKind]},ee);if(!we||ee.isCancellationRequested)return;const Ie=Array.isArray(we)?we:we.items,je=this.e?Array.isArray(we)?[]:we.commands||[]:[],Ve=this.e&&!Array.isArray(we)?we.suppressSuggestions:void 0,_e=this.e&&!Array.isArray(we)?we.enableForwardStability:void 0;let Ge;return{pid:this.d.createReferenceId({dispose(){Ge?.dispose()},items:Ie}),items:Ie.map((Qe,st)=>{let tt;Qe.command&&(Ge||(Ge=new p.$kb),tt=this.j.toInternal(Qe.command,Ge));const Pe=Qe.insertText;return{insertText:typeof Pe=="string"?Pe:{snippet:Pe.value},filterText:Qe.filterText,range:Qe.range?h.Range.from(Qe.range):void 0,command:tt,idx:st,completeBracketPairs:this.e?Qe.completeBracketPairs:!1}}),commands:je.map(Qe=>(Ge||(Ge=new p.$kb),this.j.toInternal(Qe,Ge))),suppressSuggestions:Ve,enableForwardStability:_e}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,G,Z){const ee=this.d.get(U)?.items[G];ee&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(ee,Z)}handlePartialAccept(U,G,Z){const ee=this.d.get(U)?.items[G];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(ee,Z)}}class ce{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const G=this.e++;return this.d.set(G,U),G}disposeReferenceId(U){const G=this.d.get(U);return this.d.delete(U),G}get(U){return this.d.get(U)}}class z{constructor(U,G){this.e=U,this.f=G,this.d=new c.$N$b("SignatureHelp")}async provideSignatureHelp(U,G,Z,ee){const be=this.e.getDocument(U),se=h.Position.to(G),we=this.g(Z),Ie=await this.f.provideSignatureHelp(be,se,ee,we);if(Ie){const je=this.d.add([Ie]);return{...h.SignatureHelp.from(Ie),id:je}}}g(U){let G;if(U.activeSignatureHelp){const Z=h.SignatureHelp.to(U.activeSignatureHelp),ee=this.d.get(U.activeSignatureHelp.id,0);ee?(G=ee,G.activeSignature=Z.activeSignature,G.activeParameter=Z.activeParameter):G=Z}return{...U,activeSignatureHelp:G}}releaseSignatureHelp(U){this.d.delete(U)}}class ie{constructor(U,G,Z,ee,be){this.f=U,this.g=G,this.h=Z,this.j=ee,this.k=be,this.d=new c.$N$b("InlayHints"),this.e=new Map}async provideInlayHints(U,G,Z){const ee=this.f.getDocument(U),be=h.Range.to(G),se=await this.h.provideInlayHints(ee,be,Z);if(!Array.isArray(se)||se.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${G}`);return}if(Z.isCancellationRequested)return;const we=this.d.add(se);this.e.set(we,new p.$kb);const Ie={hints:[],cacheId:we};for(let je=0;je<se.length;je++)this.l(se[je],be)&&Ie.hints.push(this.m(se[je],[we,je]));return this.j.trace(`[InlayHints] ${Ie.hints.length} inlay hints from '${this.k.identifier.value}' for ${G}`),Ie}async resolveInlayHint(U,G){if(typeof this.h.resolveInlayHint!="function")return;const Z=this.d.get(...U);if(!Z)return;const ee=await this.h.resolveInlayHint(Z,G);if(ee&&this.l(ee))return this.m(ee,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,G){return U.label.length===0||Array.isArray(U.label)&&U.label.every(Z=>Z.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(G&&!G.contains(U.position))}m(U,G){const Z=this.e.get(G[0]);if(!Z)throw Error("DisposableStore is missing...");const ee={label:"",cacheId:G,tooltip:h.MarkdownString.fromStrict(U.tooltip),position:h.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(h.TextEdit.from),kind:U.kind&&h.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};return typeof U.label=="string"?ee.label=U.label:ee.label=U.label.map(be=>{const se={label:be.value};return se.tooltip=h.MarkdownString.fromStrict(be.tooltip),A.$PJ.isLocation(be.location)&&(se.location=h.location.from(be.location)),be.command&&(se.command=this.g.toInternal(be.command,Z)),se}),ee}}class Ee{constructor(U,G){this.e=U,this.f=G,this.d=new c.$N$b("DocumentLink")}async provideLinks(U,G){const Z=this.e.getDocument(U),ee=await this.f.provideDocumentLinks(Z,G);if(!(!Array.isArray(ee)||ee.length===0)&&!G.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:ee.filter(Ee.g).map(h.DocumentLink.from)};{const be=this.d.add(ee),se={links:[],cacheId:be};for(let we=0;we<ee.length;we++){if(!Ee.g(ee[we]))continue;const Ie=h.DocumentLink.from(ee[we]);Ie.cacheId=[be,we],se.links.push(Ie)}return se}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,G){if(typeof this.f.resolveDocumentLink!="function")return;const Z=this.d.get(...U);if(!Z)return;const ee=await this.f.resolveDocumentLink(Z,G);if(!(!ee||!Ee.g(ee)))return h.DocumentLink.from(ee)}releaseLinks(U){this.d.delete(U)}}class Re{constructor(U,G){this.d=U,this.e=G}async provideColors(U,G){const Z=this.d.getDocument(U),ee=await this.e.provideDocumentColors(Z,G);return Array.isArray(ee)?ee.map(se=>({color:h.Color.from(se.color),range:h.Range.from(se.range)})):[]}async provideColorPresentations(U,G,Z){const ee=this.d.getDocument(U),be=h.Range.to(G.range),se=h.Color.to(G.color),we=await this.e.provideColorPresentations(se,{document:ee,range:be},Z);if(Array.isArray(we))return we.map(h.ColorPresentation.from)}}class ye{constructor(U,G){this.d=U,this.e=G}async provideFoldingRanges(U,G,Z){const ee=this.d.getDocument(U),be=await this.e.provideFoldingRanges(ee,G,Z);if(Array.isArray(be))return be.map(h.FoldingRange.from)}}class X{constructor(U,G,Z){this.d=U,this.e=G,this.f=Z}async provideSelectionRanges(U,G,Z){const ee=this.d.getDocument(U),be=G.map(h.Position.to),se=await this.e.provideSelectionRanges(ee,be,Z);if(!(0,R.$qf)(se))return[];if(se.length!==be.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const we=[];for(let Ie=0;Ie<be.length;Ie++){const je=[];we.push(je);let Ve=be[Ie],_e=se[Ie];for(;;){if(!_e.range.contains(Ve))throw new Error("INVALID selection range, must contain the previous range");if(je.push(h.SelectionRange.from(_e)),!_e.parent)break;Ve=_e.range,_e=_e.parent}}return we}}class he{constructor(U,G){this.f=U,this.g=G,this.d=new s.$IL(""),this.e=new Map}async prepareSession(U,G,Z){const ee=this.f.getDocument(U),be=h.Position.to(G),se=await this.g.prepareCallHierarchy(ee,be,Z);if(!se)return;const we=this.d.nextId();return this.e.set(we,new Map),Array.isArray(se)?se.map(Ie=>this.h(we,Ie)):[this.h(we,se)]}async provideCallsTo(U,G,Z){const ee=this.j(U,G);if(!ee)throw new Error("missing call hierarchy item");const be=await this.g.provideCallHierarchyIncomingCalls(ee,Z);if(be)return be.map(se=>({from:this.h(U,se.from),fromRanges:se.fromRanges.map(we=>h.Range.from(we))}))}async provideCallsFrom(U,G,Z){const ee=this.j(U,G);if(!ee)throw new Error("missing call hierarchy item");const be=await this.g.provideCallHierarchyOutgoingCalls(ee,Z);if(be)return be.map(se=>({to:this.h(U,se.to),fromRanges:se.fromRanges.map(we=>h.Range.from(we))}))}releaseSession(U){this.e.delete(U)}h(U,G){const Z=this.e.get(U),ee=h.CallHierarchyItem.from(G,U,Z.size.toString(36));return Z.set(ee._itemId,G),ee}j(U,G){return this.e.get(U)?.get(G)}}class K{constructor(U,G){this.f=U,this.g=G,this.d=new s.$IL(""),this.e=new Map}async prepareSession(U,G,Z){const ee=this.f.getDocument(U),be=h.Position.to(G),se=await this.g.prepareTypeHierarchy(ee,be,Z);if(!se)return;const we=this.d.nextId();return this.e.set(we,new Map),Array.isArray(se)?se.map(Ie=>this.h(we,Ie)):[this.h(we,se)]}async provideSupertypes(U,G,Z){const ee=this.j(U,G);if(!ee)throw new Error("missing type hierarchy item");const be=await this.g.provideTypeHierarchySupertypes(ee,Z);if(be)return be.map(se=>this.h(U,se))}async provideSubtypes(U,G,Z){const ee=this.j(U,G);if(!ee)throw new Error("missing type hierarchy item");const be=await this.g.provideTypeHierarchySubtypes(ee,Z);if(be)return be.map(se=>this.h(U,se))}releaseSession(U){this.e.delete(U)}h(U,G){const Z=this.e.get(U),ee=h.TypeHierarchyItem.from(G,U,Z.size.toString(36));return Z.set(ee._itemId,G),ee}j(U,G){return this.e.get(U)?.get(G)}}class oe{constructor(U,G,Z,ee,be){this.d=U,this.e=G,this.f=Z,this.g=ee,this.h=be}async provideDocumentOnDropEdits(U,G,Z,ee,be){const se=this.e.getDocument(G),we=h.Position.to(Z),Ie=h.DataTransfer.toDataTransfer(ee,async Ve=>(await this.d.$resolveDocumentOnDropFileData(this.g,U,Ve)).buffer),je=await this.f.provideDocumentDropEdits(se,we,Ie,be);if(je)return{id:je.id?this.h.identifier.value+"."+je.id:this.h.identifier.value,label:je.label??(0,o.localize)(1,null,this.h.displayName||this.h.name),priority:je.priority??0,insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?h.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class _{constructor(U,G){this.adapter=U,this.extension=G}}class le{static{this.d=0}constructor(U,G,Z,ee,be,se,we,Ie){this.g=G,this.h=Z,this.j=ee,this.k=be,this.l=se,this.m=we,this.n=Ie,this.f=new Map,this.e=U.getProxy(m.$BJ.MainThreadLanguageFeatures)}o(U,G){return h.DocumentSelector.from(U,this.g,G)}p(U){return new A.$DJ(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return le.d++}async s(U,G,Z,ee,be,se=!1){const we=this.f.get(U);if(!we||!(we.adapter instanceof G))return ee;const Ie=Date.now();se||this.l.trace(`[${we.extension.identifier.value}] INVOKE provider '${Z.toString().replace(/[\r\n]/g,"")}'`);const je=Z(we.adapter,we.extension);return Promise.resolve(je).catch(Ve=>{(0,y.$2)(Ve)||(this.l.error(`[${we.extension.identifier.value}] provider FAILED`),this.l.error(Ve),this.n.onExtensionError(we.extension.identifier,Ve))}).finally(()=>{se||this.l.trace(`[${we.extension.identifier.value}] provider DONE after ${Date.now()-Ie}ms`)}),D.CancellationToken.isCancellationToken(be)?(0,C.$lg)(je,be):je}t(U,G){const Z=this.q();return this.f.set(Z,new _(U,G)),Z}static u(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,G,Z,ee){const be=this.t(new n(this.h,Z),U),se=ee&&ee.label||le.u(U);return this.e.$registerDocumentSymbolProvider(be,this.o(G,U),se),this.p(be)}$provideDocumentSymbols(U,G,Z){return this.s(U,n,ee=>ee.provideDocumentSymbols(k.URI.revive(G),Z),void 0,Z)}registerCodeLensProvider(U,G,Z){const ee=this.q(),be=typeof Z.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(ee,new _(new t(this.h,this.j.converter,Z),U)),this.e.$registerCodeLensSupport(ee,this.o(G,U),be);let se=this.p(ee);if(be!==void 0){const we=Z.onDidChangeCodeLenses(Ie=>this.e.$emitCodeLensEvent(be));se=A.$DJ.from(se,we)}return se}$provideCodeLenses(U,G,Z){return this.s(U,t,ee=>ee.provideCodeLenses(k.URI.revive(G),Z),void 0,Z)}$resolveCodeLens(U,G,Z){return this.s(U,t,ee=>ee.resolveCodeLens(G,Z),void 0,void 0)}$releaseCodeLenses(U,G){this.s(U,t,Z=>Promise.resolve(Z.releaseCodeLenses(G)),void 0,void 0)}registerDefinitionProvider(U,G,Z){const ee=this.t(new g(this.h,Z),U);return this.e.$registerDefinitionSupport(ee,this.o(G,U)),this.p(ee)}$provideDefinition(U,G,Z,ee){return this.s(U,g,be=>be.provideDefinition(k.URI.revive(G),Z,ee),[],ee)}registerDeclarationProvider(U,G,Z){const ee=this.t(new u(this.h,Z),U);return this.e.$registerDeclarationSupport(ee,this.o(G,U)),this.p(ee)}$provideDeclaration(U,G,Z,ee){return this.s(U,u,be=>be.provideDeclaration(k.URI.revive(G),Z,ee),[],ee)}registerImplementationProvider(U,G,Z){const ee=this.t(new d(this.h,Z),U);return this.e.$registerImplementationSupport(ee,this.o(G,U)),this.p(ee)}$provideImplementation(U,G,Z,ee){return this.s(U,d,be=>be.provideImplementation(k.URI.revive(G),Z,ee),[],ee)}registerTypeDefinitionProvider(U,G,Z){const ee=this.t(new v(this.h,Z),U);return this.e.$registerTypeDefinitionSupport(ee,this.o(G,U)),this.p(ee)}$provideTypeDefinition(U,G,Z,ee){return this.s(U,v,be=>be.provideTypeDefinition(k.URI.revive(G),Z,ee),[],ee)}registerHoverProvider(U,G,Z,ee){const be=this.t(new l(this.h,Z),U);return this.e.$registerHoverProvider(be,this.o(G,U)),this.p(be)}$provideHover(U,G,Z,ee){return this.s(U,l,be=>be.provideHover(k.URI.revive(G),Z,ee),void 0,ee)}registerEvaluatableExpressionProvider(U,G,Z,ee){const be=this.t(new w(this.h,Z),U);return this.e.$registerEvaluatableExpressionProvider(be,this.o(G,U)),this.p(be)}$provideEvaluatableExpression(U,G,Z,ee){return this.s(U,w,be=>be.provideEvaluatableExpression(k.URI.revive(G),Z,ee),void 0,ee)}registerInlineValuesProvider(U,G,Z,ee){const be=typeof Z.onDidChangeInlineValues=="function"?this.q():void 0,se=this.t(new L(this.h,Z),U);this.e.$registerInlineValuesProvider(se,this.o(G,U),be);let we=this.p(se);if(be!==void 0){const Ie=Z.onDidChangeInlineValues(je=>this.e.$emitInlineValuesEvent(be));we=A.$DJ.from(we,Ie)}return we}$provideInlineValues(U,G,Z,ee,be){return this.s(U,L,se=>se.provideInlineValues(k.URI.revive(G),Z,ee,be),void 0,be)}registerDocumentHighlightProvider(U,G,Z){const ee=this.t(new O(this.h,Z),U);return this.e.$registerDocumentHighlightProvider(ee,this.o(G,U)),this.p(ee)}$provideDocumentHighlights(U,G,Z,ee){return this.s(U,O,be=>be.provideDocumentHighlights(k.URI.revive(G),Z,ee),void 0,ee)}registerLinkedEditingRangeProvider(U,G,Z){const ee=this.t(new N(this.h,Z),U);return this.e.$registerLinkedEditingRangeProvider(ee,this.o(G,U)),this.p(ee)}$provideLinkedEditingRanges(U,G,Z,ee){return this.s(U,N,async be=>{const se=await be.provideLinkedEditingRanges(k.URI.revive(G),Z,ee);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?le.w(se.wordPattern):void 0}},void 0,ee)}registerReferenceProvider(U,G,Z){const ee=this.t(new T(this.h,Z),U);return this.e.$registerReferenceSupport(ee,this.o(G,U)),this.p(ee)}$provideReferences(U,G,Z,ee,be){return this.s(U,T,se=>se.provideReferences(k.URI.revive(G),Z,ee,be),void 0,be)}registerCodeActionProvider(U,G,Z,ee){const be=new p.$kb,se=this.t(new j(this.h,this.j.converter,this.k,Z,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(se,this.o(G,U),{providedKinds:ee?.providedCodeActionKinds?.map(we=>we.value),documentation:ee?.documentation?.map(we=>({kind:we.kind.value,command:this.j.converter.toInternal(we.command,be)}))},le.u(U),!!Z.resolveCodeAction),be.add(this.p(se)),be}$provideCodeActions(U,G,Z,ee,be){return this.s(U,j,se=>se.provideCodeActions(k.URI.revive(G),Z,ee,be),void 0,be)}$resolveCodeAction(U,G,Z){return this.s(U,j,ee=>ee.resolveCodeAction(G,Z),{},void 0)}$releaseCodeActions(U,G){this.s(U,j,Z=>Promise.resolve(Z.releaseCodeActions(G)),void 0,void 0)}registerDocumentFormattingEditProvider(U,G,Z){const ee=this.t(new M(this.h,Z),U);return this.e.$registerDocumentFormattingSupport(ee,this.o(G,U),U.identifier,U.displayName||U.name),this.p(ee)}$provideDocumentFormattingEdits(U,G,Z,ee){return this.s(U,M,be=>be.provideDocumentFormattingEdits(k.URI.revive(G),Z,ee),void 0,ee)}registerDocumentRangeFormattingEditProvider(U,G,Z){const ee=typeof Z.provideDocumentRangesFormattingEdits=="function";ee&&(0,i.$zF)(U,"formatMultipleRanges");const be=this.t(new Y(this.h,Z),U);return this.e.$registerRangeFormattingSupport(be,this.o(G,U),U.identifier,U.displayName||U.name,ee),this.p(be)}$provideDocumentRangeFormattingEdits(U,G,Z,ee,be){return this.s(U,Y,se=>se.provideDocumentRangeFormattingEdits(k.URI.revive(G),Z,ee,be),void 0,be)}$provideDocumentRangesFormattingEdits(U,G,Z,ee,be){return this.s(U,Y,se=>se.provideDocumentRangesFormattingEdits(k.URI.revive(G),Z,ee,be),void 0,be)}registerOnTypeFormattingEditProvider(U,G,Z,ee){const be=this.t(new V(this.h,Z),U);return this.e.$registerOnTypeFormattingSupport(be,this.o(G,U),ee,U.identifier),this.p(be)}$provideOnTypeFormattingEdits(U,G,Z,ee,be,se){return this.s(U,V,we=>we.provideOnTypeFormattingEdits(k.URI.revive(G),Z,ee,be,se),void 0,se)}registerWorkspaceSymbolProvider(U,G){const Z=this.t(new de(G,this.l),U);return this.e.$registerNavigateTypeSupport(Z,typeof G.resolveWorkspaceSymbol=="function"),this.p(Z)}$provideWorkspaceSymbols(U,G,Z){return this.s(U,de,ee=>ee.provideWorkspaceSymbols(G,Z),{symbols:[]},Z)}$resolveWorkspaceSymbol(U,G,Z){return this.s(U,de,ee=>ee.resolveWorkspaceSymbol(G,Z),void 0,void 0)}$releaseWorkspaceSymbols(U,G){this.s(U,de,Z=>Z.releaseWorkspaceSymbols(G),void 0,void 0)}registerRenameProvider(U,G,Z){const ee=this.t(new re(this.h,Z,this.l),U);return this.e.$registerRenameSupport(ee,this.o(G,U),re.supportsResolving(Z)),this.p(ee)}$provideRenameEdits(U,G,Z,ee,be){return this.s(U,re,se=>se.provideRenameEdits(k.URI.revive(G),Z,ee,be),void 0,be)}$resolveRenameLocation(U,G,Z,ee){return this.s(U,re,be=>be.resolveRenameLocation(k.URI.revive(G),Z,ee),void 0,ee)}registerDocumentSemanticTokensProvider(U,G,Z,ee){const be=this.t(new q(this.h,Z),U),se=typeof Z.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(be,this.o(G,U),ee,se);let we=this.p(be);if(se){const Ie=Z.onDidChangeSemanticTokens(je=>this.e.$emitDocumentSemanticTokensEvent(se));we=A.$DJ.from(we,Ie)}return we}$provideDocumentSemanticTokens(U,G,Z,ee){return this.s(U,q,be=>be.provideDocumentSemanticTokens(k.URI.revive(G),Z,ee),null,ee)}$releaseDocumentSemanticTokens(U,G){this.s(U,q,Z=>Z.releaseDocumentSemanticColoring(G),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,G,Z,ee){const be=this.t(new ne(this.h,Z),U);return this.e.$registerDocumentRangeSemanticTokensProvider(be,this.o(G,U),ee),this.p(be)}$provideDocumentRangeSemanticTokens(U,G,Z,ee){return this.s(U,ne,be=>be.provideDocumentRangeSemanticTokens(k.URI.revive(G),Z,ee),null,ee)}registerCompletionItemProvider(U,G,Z,ee){const be=this.t(new pe(this.h,this.j.converter,Z,this.m,U),U);return this.e.$registerCompletionsProvider(be,this.o(G,U),ee,pe.supportsResolving(Z),U.identifier),this.p(be)}$provideCompletionItems(U,G,Z,ee,be){return this.s(U,pe,se=>se.provideCompletionItems(k.URI.revive(G),Z,ee,be),void 0,be)}$resolveCompletionItem(U,G,Z){return this.s(U,pe,ee=>ee.resolveCompletionItem(G,Z),void 0,Z)}$releaseCompletionItems(U,G){this.s(U,pe,Z=>Z.releaseCompletionItems(G),void 0,void 0)}registerInlineCompletionsProvider(U,G,Z,ee){const be=new ue(U,this.h,Z,this.j.converter),se=this.t(be,U);return this.e.$registerInlineCompletionsSupport(se,this.o(G,U),be.supportsHandleEvents,S.$Hl.toKey(U.identifier.value),ee?.yieldTo?.map(we=>S.$Hl.toKey(we))||[]),this.p(se)}$provideInlineCompletions(U,G,Z,ee,be){return this.s(U,H,se=>se.provideInlineCompletions(k.URI.revive(G),Z,ee,be),void 0,be)}$handleInlineCompletionDidShow(U,G,Z,ee){this.s(U,H,async be=>{be.handleDidShowCompletionItem(G,Z,ee)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,G,Z,ee){this.s(U,H,async be=>{be.handlePartialAccept(G,Z,ee)},void 0,void 0)}$freeInlineCompletionsList(U,G){this.s(U,H,async Z=>{Z.disposeCompletions(G)},void 0,void 0)}registerSignatureHelpProvider(U,G,Z,ee){const be=Array.isArray(ee)?{triggerCharacters:ee,retriggerCharacters:[]}:ee,se=this.t(new z(this.h,Z),U);return this.e.$registerSignatureHelpProvider(se,this.o(G,U),be),this.p(se)}$provideSignatureHelp(U,G,Z,ee,be){return this.s(U,z,se=>se.provideSignatureHelp(k.URI.revive(G),Z,ee,be),void 0,be)}$releaseSignatureHelp(U,G){this.s(U,z,Z=>Z.releaseSignatureHelp(G),void 0,void 0)}registerInlayHintsProvider(U,G,Z){const ee=typeof Z.onDidChangeInlayHints=="function"?this.q():void 0,be=this.t(new ie(this.h,this.j.converter,Z,this.l,U),U);this.e.$registerInlayHintsProvider(be,this.o(G,U),typeof Z.resolveInlayHint=="function",ee,le.u(U));let se=this.p(be);if(ee!==void 0){const we=Z.onDidChangeInlayHints(Ie=>this.e.$emitInlayHintsEvent(ee));se=A.$DJ.from(se,we)}return se}$provideInlayHints(U,G,Z,ee){return this.s(U,ie,be=>be.provideInlayHints(k.URI.revive(G),Z,ee),void 0,ee)}$resolveInlayHint(U,G,Z){return this.s(U,ie,ee=>ee.resolveInlayHint(G,Z),void 0,Z)}$releaseInlayHints(U,G){this.s(U,ie,Z=>Z.releaseHints(G),void 0,void 0)}registerDocumentLinkProvider(U,G,Z){const ee=this.t(new Ee(this.h,Z),U);return this.e.$registerDocumentLinkProvider(ee,this.o(G,U),typeof Z.resolveDocumentLink=="function"),this.p(ee)}$provideDocumentLinks(U,G,Z){return this.s(U,Ee,ee=>ee.provideLinks(k.URI.revive(G),Z),void 0,Z,G.scheme==="output")}$resolveDocumentLink(U,G,Z){return this.s(U,Ee,ee=>ee.resolveLink(G,Z),void 0,void 0,!0)}$releaseDocumentLinks(U,G){this.s(U,Ee,Z=>Z.releaseLinks(G),void 0,void 0,!0)}registerColorProvider(U,G,Z){const ee=this.t(new Re(this.h,Z),U);return this.e.$registerDocumentColorProvider(ee,this.o(G,U)),this.p(ee)}$provideDocumentColors(U,G,Z){return this.s(U,Re,ee=>ee.provideColors(k.URI.revive(G),Z),[],Z)}$provideColorPresentations(U,G,Z,ee){return this.s(U,Re,be=>be.provideColorPresentations(k.URI.revive(G),Z,ee),void 0,ee)}registerFoldingRangeProvider(U,G,Z){const ee=this.q(),be=typeof Z.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(ee,new _(new ye(this.h,Z),U)),this.e.$registerFoldingRangeProvider(ee,this.o(G,U),U.identifier,be);let se=this.p(ee);if(be!==void 0){const we=Z.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(be));se=A.$DJ.from(se,we)}return se}$provideFoldingRanges(U,G,Z,ee){return this.s(U,ye,be=>be.provideFoldingRanges(k.URI.revive(G),Z,ee),void 0,ee)}registerSelectionRangeProvider(U,G,Z){const ee=this.t(new X(this.h,Z,this.l),U);return this.e.$registerSelectionRangeProvider(ee,this.o(G,U)),this.p(ee)}$provideSelectionRanges(U,G,Z,ee){return this.s(U,X,be=>be.provideSelectionRanges(k.URI.revive(G),Z,ee),[],ee)}registerCallHierarchyProvider(U,G,Z){const ee=this.t(new he(this.h,Z),U);return this.e.$registerCallHierarchyProvider(ee,this.o(G,U)),this.p(ee)}$prepareCallHierarchy(U,G,Z,ee){return this.s(U,he,be=>Promise.resolve(be.prepareSession(k.URI.revive(G),Z,ee)),void 0,ee)}$provideCallHierarchyIncomingCalls(U,G,Z,ee){return this.s(U,he,be=>be.provideCallsTo(G,Z,ee),void 0,ee)}$provideCallHierarchyOutgoingCalls(U,G,Z,ee){return this.s(U,he,be=>be.provideCallsFrom(G,Z,ee),void 0,ee)}$releaseCallHierarchy(U,G){this.s(U,he,Z=>Promise.resolve(Z.releaseSession(G)),void 0,void 0)}registerTypeHierarchyProvider(U,G,Z){const ee=this.t(new K(this.h,Z),U);return this.e.$registerTypeHierarchyProvider(ee,this.o(G,U)),this.p(ee)}$prepareTypeHierarchy(U,G,Z,ee){return this.s(U,K,be=>Promise.resolve(be.prepareSession(k.URI.revive(G),Z,ee)),void 0,ee)}$provideTypeHierarchySupertypes(U,G,Z,ee){return this.s(U,K,be=>be.provideSupertypes(G,Z,ee),void 0,ee)}$provideTypeHierarchySubtypes(U,G,Z,ee){return this.s(U,K,be=>be.provideSubtypes(G,Z,ee),void 0,ee)}$releaseTypeHierarchy(U,G){this.s(U,K,Z=>Promise.resolve(Z.releaseSession(G)),void 0,void 0)}registerDocumentOnDropEditProvider(U,G,Z,ee){const be=this.q();return this.f.set(be,new _(new oe(this.e,this.h,Z,be,U),U)),this.e.$registerDocumentOnDropEditProvider(be,this.o(G,U),(0,i.$yF)(U,"dropMetadata")?ee:void 0),this.p(be)}$provideDocumentOnDropEdits(U,G,Z,ee,be,se){return this.s(U,oe,we=>Promise.resolve(we.provideDocumentOnDropEdits(G,k.URI.revive(Z),ee,be,se)),void 0,void 0)}registerDocumentPasteEditProvider(U,G,Z,ee){const be=this.q();return this.f.set(be,new _(new W(this.e,this.h,Z,be,U),U)),this.e.$registerPasteEditProvider(be,this.o(G,U),{supportsCopy:!!Z.prepareDocumentPaste,supportsPaste:!!Z.provideDocumentPasteEdits,copyMimeTypes:ee.copyMimeTypes,pasteMimeTypes:ee.pasteMimeTypes}),this.p(be)}$prepareDocumentPaste(U,G,Z,ee,be){return this.s(U,W,se=>se.prepareDocumentPaste(k.URI.revive(G),Z,ee,be),void 0,be)}$providePasteEdits(U,G,Z,ee,be,se){return this.s(U,W,we=>we.providePasteEdits(G,k.URI.revive(Z),ee,be,se),void 0,se)}static w(U){return{pattern:U.source,flags:(0,E.$zd)(U)}}static y(U){return{decreaseIndentPattern:le.w(U.decreaseIndentPattern),increaseIndentPattern:le.w(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?le.w(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?le.w(U.unIndentedLinePattern):void 0}}static z(U){return{beforeText:le.w(U.beforeText),afterText:U.afterText?le.w(U.afterText):void 0,previousLineText:U.previousLineText?le.w(U.previousLineText):void 0,action:U.action}}static B(U){return U.map(le.z)}setLanguageConfiguration(U,G,Z){const{wordPattern:ee}=Z;if(ee&&(0,E.$xd)(ee))throw new Error(`Invalid language configuration: wordPattern '${ee}' is not allowed to match the empty string.`);ee?this.h.setWordDefinitionFor(G,ee):this.h.setWordDefinitionFor(G,void 0),Z.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),Z.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use."),Z.autoClosingPairs&&(0,i.$zF)(U,"languageConfigurationAutoClosingPairs");const be=this.q(),se={comments:Z.comments,brackets:Z.brackets,wordPattern:Z.wordPattern?le.w(Z.wordPattern):void 0,indentationRules:Z.indentationRules?le.y(Z.indentationRules):void 0,onEnterRules:Z.onEnterRules?le.B(Z.onEnterRules):void 0,__electricCharacterSupport:Z.__electricCharacterSupport,__characterPairSupport:Z.__characterPairSupport,autoClosingPairs:Z.autoClosingPairs};return this.e.$setLanguageConfiguration(be,G,se),this.p(be)}$setWordDefinitions(U){for(const G of U)this.h.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.$W$b=le}),define(Se[297],Ce([1,0,6,16,7,40,17,4]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E_b=void 0;class E{constructor(R,I,$,D){this.c=I,this.d=$,this.e=D,this.b=[],this.f=0,this.g=new Set,this.a=R.getProxy(k.$BJ.MainThreadLanguages)}$acceptLanguageIds(R){this.b=R}async getLanguages(){return this.b.slice(0)}async changeLanguage(R,I){await this.a.$changeLanguage(R,I);const $=this.c.getDocumentData(R);if(!$)throw new Error(`document '${R.toString()}' NOT found`);return $.document}async tokenAtPosition(R,I){const $=R.version,D=F.Position.from(I),S=await this.a.$tokensAtPosition(R.uri,D),p={type:h.StandardTokenType.Other,range:R.getWordRangeAtPosition(I)??new h.$FJ(I.line,I.character,I.line,I.character)};if(!S)return p;const r={range:F.Range.to(S.range),type:F.TokenType.to(S.type)};return!r.range.contains(I)||$!==R.version?p:r}createLanguageStatusItem(R,I,$){const D=this.f++,S=this.a,p=this.g,r=`${R.identifier.value}/${I}`;if(p.has(r))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);p.add(r);const s={selector:$,id:I,name:R.displayName??R.name,severity:h.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const f=new m.$kb,y=()=>{if(c?.dispose(),!p.has(r)){console.warn(`LanguageStatusItem (${I}) from ${R.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,P.$xg)(()=>{f.clear(),this.a.$setLanguageStatus(D,{id:r,name:s.name??R.displayName??R.name,source:R.displayName??R.name,selector:F.DocumentSelector.from(s.selector,this.e),label:s.text,detail:s.detail??"",severity:s.severity===h.LanguageStatusSeverity.Error?A.default.Error:s.severity===h.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:s.command&&this.d.toInternal(s.command,f),accessibilityInfo:s.accessibilityInformation,busy:s.busy})},0)},C={dispose(){f.dispose(),c?.dispose(),S.$removeLanguageStatus(D),p.delete(r)},get id(){return s.id},get name(){return s.name},set name(i){s.name=i,y()},get selector(){return s.selector},set selector(i){s.selector=i,y()},get text(){return s.text},set text(i){s.text=i,y()},get detail(){return s.detail},set detail(i){s.detail=i,y()},get severity(){return s.severity},set severity(i){s.severity=i,y()},get accessibilityInformation(){return s.accessibilityInformation},set accessibilityInformation(i){s.accessibilityInformation=i,y()},get command(){return s.command},set command(i){s.command=i,y()},get busy(){return s.busy},set busy(i){s.busy=i,y()}};return y(),C}}e.$E_b=E}),define(Se[106],Ce([1,0,11,12,2,5,18,6,26,20]),function(fe,e,k,F,h,A,P,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u_b=e.$t_b=void 0;let R=class{constructor($,D,S){this.f=S,this.d=new Map,this.a=D.getProxy(m.$BJ.MainThreadLocalization),this.b=$.environment.appLanguage,this.c=this.b===k.$f}getMessage($,D){const{message:S,args:p,comment:r}=D;if(this.c)return(0,F.$md)(S,p??{});let s=S;r&&r.length>0&&(s+=`/${Array.isArray(r)?r.join(""):r}`);const c=this.d.get($)?.contents[s];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,F.$md)(c??S,p??{})}getBundle($){return this.d.get($)?.contents}getBundleUri($){return this.d.get($)?.uri}async initializeLocalizedMessages($){if(this.c||!$.l10n&&!$.isBuiltin||this.d.has($.identifier.value))return;let D;const S=await this.g($);if(!S){this.f.error(`No bundle location found for extension ${$.identifier.value}`);return}try{const p=await this.a.$fetchBundleContents(S),r=JSON.parse(p);D=$.isBuiltin?r.contents?.bundle:r}catch(p){this.f.error(`Failed to load translations for ${$.identifier.value} from ${S}: ${p.message}`);return}D&&this.d.set($.identifier.value,{contents:D,uri:S})}async g($){if($.isBuiltin){const D=await this.a.$fetchBuiltInBundleUri($.identifier.value,this.b);return h.URI.revive(D)}return $.l10n?h.URI.joinPath($.extensionLocation,$.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$t_b=R,e.$t_b=R=Je([qe(0,E.$TL),qe(1,b.$DL),qe(2,P.$Ri)],R),e.$u_b=(0,A.$ph)("IExtHostLocalizationService")}),define(Se[143],Ce([1,0,18,6,26,20,2,73]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qac=void 0;let E=class extends k.$3i{constructor(I,$){super($.logLevel,$.logsLocation,$.loggers.map(D=>(0,m.$Yg)(D))),this.n=I.getProxy(F.$BJ.MainThreadLogger)}$setLogLevel(I,$){$?this.setLogLevel(P.URI.revive($),I):this.setLogLevel(I)}setVisibility(I,$){super.setVisibility(I,$),this.n.$setVisibility(I,$)}m(I,$,D){return new b(this.n,I,$,D)}};e.$Qac=E,e.$Qac=E=Je([qe(0,A.$DL),qe(1,h.$TL)],E);class b extends k.$Xi{constructor(I,$,D,S){super(S?.logLevel==="always"),this.m=I,this.n=$,this.k=!1,this.l=[],this.setLevel(D),this.m.$createLogger($,S).then(()=>{this.r(this.l),this.k=!0})}g(I,$){const D=[[I,$]];this.k?this.r(D):this.l.push(...D)}r(I){this.m.$log(this.n,I)}flush(){this.m.$flush(this.n)}}}),define(Se[107],Ce([1,0,6,5,4,20,22]),function(fe,e,k,F,h,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w_b=e.$v_b=void 0,e.$v_b=(0,F.$ph)("IExtHostManagedSockets");let m=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(k.$BJ.MainThreadManagedSockets)}setFactory(I,$){for(const D of this.d.values())D.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(I,$),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const $=++this.b,D=await this.c.makeConnection(),S=new h.$kb;return this.d.set($,new b($,D,S)),S.add((0,h.$jb)(()=>this.d.delete($))),S.add(D.onDidEnd(()=>{this.a.$onDidManagedSocketEnd($),S.dispose()})),S.add(D.onDidClose(p=>{this.a.$onDidManagedSocketClose($,p?.stack??p?.message),S.dispose()})),S.add(D.onDidReceiveMessage(p=>this.a.$onDidManagedSocketHaveData($,P.$Jb.wrap(p)))),$}$remoteSocketWrite(I,$){this.d.get(I)?.actual.send($.buffer)}$remoteSocketEnd(I){const $=this.d.get(I);$&&($.actual.end(),$.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$w_b=m,e.$w_b=m=Je([qe(0,A.$DL)],m);class E{constructor(I,$){this.socketFactoryId=I,this.makeConnection=$}}class b extends h.$lb{constructor(I,$,D){super(),this.socketId=I,this.actual=$,this.B(D)}}}),define(Se[298],Ce([1,0,6,18,27]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F_b=void 0;function A(m){return m&&m.title}let P=class{constructor(E,b){this.b=b,this.a=E.getProxy(k.$BJ.MainThreadMessageService)}showMessage(E,b,R,I,$){const D={source:{identifier:E.identifier,label:E.displayName||E.name}};let S;typeof I=="string"||A(I)?S=[I,...$]:(D.modal=I?.modal,D.useCustom=I?.useCustom,D.detail=I?.detail,S=$),D.useCustom&&(0,h.$zF)(E,"resolvers");const p=[];for(let r=0;r<S.length;r++){const s=S[r];if(typeof s=="string")p.push({title:s,handle:r,isCloseAffordance:!1});else if(typeof s=="object"){const{title:c,isCloseAffordance:f}=s;p.push({title:c,isCloseAffordance:!!f,handle:r})}else this.b.warn("Invalid message item:",s)}return this.a.$showMessage(b,R,D,p).then(r=>{if(typeof r=="number")return S[r]})}};e.$F_b=P,e.$F_b=P=Je([qe(1,F.$Ri)],P)}),define(Se[299],Ce([1,0,197,22,3,4,28,12,14,2,30,81,6,36,16,7,60,266,138,8,23,15]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c,f,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=void 0;class i{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(n=>n.apiEditor)}constructor(n,t,a,g,u){this.q=a,this.r=g,this.s=u,this.f=new Map,this.g=new P.$ni,this.h=new Map,this.j=new h.$8c({onListenerError:f.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new h.$8c({onListenerError:f.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new h.$8c({onListenerError:f.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new h.$8c({onListenerError:f.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$N$b("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=n.getProxy($.$BJ.MainThreadNotebook),this.c=n.getProxy($.$BJ.MainThreadNotebookDocuments),this.d=n.getProxy($.$BJ.MainThreadNotebookEditors),this.i=t.converter,t.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===13){const v=d.notebookEditor?.notebookUri,l=d.cell.handle,L=this.g.get(v)?.getCell(l);if(L)return L.apiCell}if(d&&d.$mid===14){const v=d.uri,l=this.g.get(v);if(l)return l.apiNotebook}return d}}),i.A(t)}getEditorById(n){const t=this.h.get(n);if(!t)throw new Error(`unknown text editor: ${n}. known editors: ${[...this.h.keys()]} `);return t}getIdByEditor(n){for(const[t,a]of this.h)if(a.apiEditor===n)return t}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(n,t){const a=this.g.get(n);if(!a&&!t)throw new Error(`NO notebook document for '${n}'`);return a}static t(n,t){if(!t)return;const a=t.filenamePattern.map(g=>S.NotebookExclusiveDocumentPattern.from(g)).filter(g=>g!==void 0);if(t.filenamePattern&&!a){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:n.identifier,providerDisplayName:n.displayName||n.name,displayName:t.displayName,filenamePattern:a,exclusive:t.exclusive||!1}}registerNotebookCellStatusBarItemProvider(n,t,a){const g=i.a++,u=typeof a.onDidChangeCellStatusBarItems=="function"?i.a++:void 0;this.f.set(g,a),this.b.$registerNotebookCellStatusBarItemProvider(g,u,t);let d;return u!==void 0&&(d=a.onDidChangeCellStatusBarItems(v=>this.b.$emitCellStatusBarEvent(u))),new p.$DJ(()=>{this.f.delete(g),this.b.$unregisterNotebookCellStatusBarItemProvider(g,u),d?.dispose()})}async createNotebookDocument(n){const t=await this.c.$tryCreateNotebook({viewType:n.viewType,content:n.content&&S.NotebookData.from(n.content)});return b.URI.revive(t)}async openNotebookDocument(n){const t=this.g.get(n);if(t)return t.apiNotebook;const a=await this.c.$tryOpenNotebook(n),g=this.g.get(b.URI.revive(a));return(0,E.$ue)(g?.apiNotebook)}async showNotebookDocument(n,t){b.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let a;typeof t=="object"?a={position:S.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(S.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:a={preserveFocus:!1};const g=await this.d.$tryShowNotebookDocument(n.uri,n.notebookType,a),u=g&&this.h.get(g)?.apiEditor;if(u)return u;throw g?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(n,t,a,g){const u=this.f.get(n),d=b.URI.revive(t),v=this.g.get(d);if(!v||!u)return;const l=v.getCellFromIndex(a);if(!l)return;const w=await u.provideCellStatusBarItems(l.apiCell,g);if(!w)return;const L=new A.$kb,O=this.p.add([L]),T=(Array.isArray(w)?w:[w]).map(j=>S.NotebookStatusBarItem.from(j,this.i,L));return{cacheId:O,items:T}}$releaseNotebookCellStatusBarItems(n){this.p.delete(n)}registerNotebookSerializer(n,t,a,g,u){if((0,m.$kd)(t))throw new Error("viewType cannot be empty or just whitespace");const d=this.u++;return this.w.set(d,{viewType:t,serializer:a,options:g}),this.b.$registerNotebookSerializer(d,{id:n.identifier,location:n.extensionLocation},t,S.NotebookDocumentContentOptions.from(g),i.t(n,u)),(0,A.$jb)(()=>{this.b.$unregisterNotebookSerializer(d)})}async $dataToNotebook(n,t,a){const g=this.w.get(n);if(!g)throw new Error("NO serializer found");const u=await g.serializer.deserializeNotebook(t.buffer,a);return new r.$Yz(S.NotebookData.from(u))}async $notebookToData(n,t,a){const g=this.w.get(n);if(!g)throw new Error("NO serializer found");const u=await g.serializer.serializeNotebook(S.NotebookData.to(t.value),a);return F.$Jb.wrap(u)}async $saveNotebook(n,t,a,g,u){const d=b.URI.revive(t),v=this.w.get(n);if(!v)throw new Error("NO serializer found");const l=this.g.get(d);if(!l)throw new Error("Document NOT found");if(l.versionId!==a)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(d.scheme))throw new R.$ak((0,k.localize)(0,null,this.y(d)),6);await this.x(d,g);const w={metadata:(0,y.$Pm)(l.apiNotebook.metadata,j=>!(v.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of l.apiNotebook.getCells()){const W=new p.$3K(j.kind,j.document.getText(),j.document.languageId,j.mime,v.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);W.metadata=(0,y.$Pm)(j.metadata,M=>!(v.options?.transientCellMetadata??{})[M]),w.cells.push(W)}const L=await v.serializer.serializeNotebook(w,u);await this.s.value.writeFile(d,L);const O=this.s.getFileSystemProviderExtUri(d.scheme),N=await this.s.value.stat(d);return{name:O.basename(d),isFile:(N.type&R.FileType.File)!==0,isDirectory:(N.type&R.FileType.Directory)!==0,isSymbolicLink:(N.type&R.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(d.scheme),locked:!!((N.permissions??0)&R.FilePermission.Locked),etag:R.$lk({mtime:N.mtime,size:N.size}),children:void 0}}async x(n,t){const a=await this.s.value.stat(n);if(typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==R.$kk&&typeof a.mtime=="number"&&typeof a.size=="number"&&t.mtime<a.mtime&&t.etag!==R.$lk({mtime:t.mtime,size:a.size}))throw new R.$ak((0,k.localize)(1,null),3,t)}y(n){return n.scheme===C.Schemas.file?n.fsPath:n.toString()}z(n,t,a){if(this.h.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const g=new c.$mac(t,this.d,n,a.visibleRanges.map(S.NotebookRange.to),a.selections.map(S.NotebookRange.to),typeof a.viewColumn=="number"?S.ViewColumn.to(a.viewColumn):void 0);this.h.set(t,g)}$acceptDocumentAndEditorsDelta(n){if(n.value.removedDocuments)for(const a of n.value.removedDocuments){const g=b.URI.revive(a),u=this.g.get(g);u&&(u.dispose(),this.g.delete(g),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:u.apiNotebook.getCells().map(d=>d.document.uri)}),this.n.fire(u.apiNotebook));for(const d of this.h.values())d.notebookData.uri.toString()===g.toString()&&this.h.delete(d.id)}if(n.value.addedDocuments){const a=[];for(const g of n.value.addedDocuments){const u=b.URI.revive(g.uri);if(this.g.has(u))throw new Error(`adding EXISTING notebook ${u} `);const d=new s.$lac(this.c,this.q,this.r,u,g);a.push(...g.cells.map(v=>s.$kac.asModelAddData(d.apiNotebook,v))),this.g.get(u)?.dispose(),this.g.set(u,d),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:a}),this.m.fire(d.apiNotebook)}}if(n.value.addedEditors)for(const a of n.value.addedEditors){if(this.h.has(a.id))return;const g=b.URI.revive(a.documentUri),u=this.g.get(g);u&&this.z(u,a.id,a)}const t=[];if(n.value.removedEditors)for(const a of n.value.removedEditors){const g=this.h.get(a);g&&(this.h.delete(a),this.k?.id===g.id&&(this.k=void 0),t.push(g))}if(n.value.visibleEditors){this.l=n.value.visibleEditors.map(g=>this.h.get(g)).filter(g=>!!g);const a=new Set;this.l.forEach(g=>a.add(g.id));for(const g of this.h.values()){const u=a.has(g.id);g._acceptVisibility(u)}this.l=[...this.h.values()].map(g=>g).filter(g=>g.visible),this.o.fire(this.visibleNotebookEditors)}n.value.newActiveEditor===null?this.k=void 0:n.value.newActiveEditor&&(this.h.get(n.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${n.value.newActiveEditor}`),this.k=this.h.get(n.value.newActiveEditor)),n.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(n){const t=D.$2L.String.with("notebookType","A notebook type"),a=new D.$4L("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[t,new D.$2L("data","Bytes to convert to data",u=>u instanceof Uint8Array,u=>F.$Jb.wrap(u))],new D.$3L("Notebook Data",u=>S.NotebookData.to(u.value))),g=new D.$4L("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[t,new D.$2L("NotebookData","Notebook data to convert to bytes",u=>!0,u=>new r.$Yz(S.NotebookData.from(u)))],new D.$3L("Bytes",u=>u.buffer));n.registerApiCommand(a),n.registerApiCommand(g)}}e.$nac=i}),define(Se[300],Ce([1,0,19,17,21,3,4,28,2,25,18,81,6,36,16,7,104,260,27,60]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=e.$Bac=void 0;let y=class{constructor(u,d,v,l,w){this.m=d,this.n=v,this.o=l,this.q=w,this.b=new m.$ni,this.c=new m.$ni,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new I.$N$b("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new A.$8c,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=u.getProxy($.$BJ.MainThreadNotebookKernels);const L=new D.$4L("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new D.$2L("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const N=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:N}}else if(O&&"notebookEditor"in O){const N=this.n.getIdByEditor(O.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return O})],D.$3L.Void);this.o.registerApiCommand(L)}createNotebookController(u,d,v,l,w,L){for(const H of this.j.values())if(H.controller.id===d&&b.$Hl.equals(u.identifier,H.extensionId))throw new Error(`notebook controller with id '${d}' ALREADY exist`);const O=this.k++,N=this;this.q.trace(`NotebookController[${O}], CREATED by ${u.identifier.value}, ${d}`);const T=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${u.identifier}'`);let j=!1;const W=new P.$kb,M=new A.$8c,Y=new A.$8c,V={id:a(u.identifier,d),notebookType:v,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:l||u.identifier.value,preloads:L?L.map(S.NotebookRendererScript.from):[]};let de=w??T,re;this.a.$addKernel(O,V).catch(H=>{console.log(H),j=!0});let x=0;const q=()=>{if(j)return;const H=++x;Promise.resolve().then(()=>{H===x&&this.a.$updateKernel(O,V)})},ne=new m.$ni,pe={get id(){return d},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return V.label},set label(H){V.label=H??u.displayName??u.name,q()},get detail(){return V.detail??""},set detail(H){V.detail=H,q()},get description(){return V.description??""},set description(H){V.description=H,q()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(H){V.supportedLanguages=H,q()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(H){V.supportsExecutionOrder=H,q()},get rendererScripts(){return V.preloads?V.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return de},set executeHandler(H){de=H??T},get interruptHandler(){return re},set interruptHandler(H){re=H,V.supportsInterrupt=!!H,q()},createNotebookCellExecution(H){if(j)throw new Error("notebook controller is DISPOSED");if(!ne.has(H.notebook.uri))throw N.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${H.notebook.uri.toString()}`);return N._createNotebookCellExecution(H,a(u.identifier,this.id))},createNotebookExecution(H){if((0,c.$zF)(u,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!ne.has(H.uri))throw N.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${H.uri.toString()}`);return N._createNotebookExecution(H,a(u.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${O}], DISPOSED`),j=!0,this.j.delete(O),W.dispose(),M.dispose(),Y.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(H,ue){ue===p.NotebookControllerAffinity2.Hidden&&(0,c.$zF)(u,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(O,H.uri,ue)},onDidReceiveMessage:Y.event,postMessage(H,ue){return(0,c.$zF)(u,"notebookMessaging"),N.a.$postMessage(O,ue&&N.n.getIdByEditor(ue),H)},asWebviewUri(H){return(0,c.$zF)(u,"notebookMessaging"),(0,r.$knb)(H,N.m.remote)}};return this.j.set(O,{extensionId:u.identifier,controller:pe,onDidReceiveMessage:Y,onDidChangeSelection:M,associatedNotebooks:ne}),pe}getIdByController(u){for(const[d,v]of this.j)if(v.controller===u)return a(v.extensionId,u.id);return null}createNotebookControllerDetectionTask(u,d){const v=this.f++,l=this;this.q.trace(`NotebookControllerDetectionTask[${v}], CREATED by ${u.identifier.value}`),this.a.$addKernelDetectionTask(v,d);const w={dispose:()=>{this.e.delete(v),l.a.$removeKernelDetectionTask(v)}};return this.e.set(v,w),w}registerKernelSourceActionProvider(u,d,v){const l=this.h++,w=typeof v.onDidChangeNotebookKernelSourceActions=="function"?l:void 0,L=this;this.g.set(l,v),this.q.trace(`NotebookKernelSourceActionProvider[${l}], CREATED by ${u.identifier.value}`),this.a.$addKernelSourceActionProvider(l,l,d);let O;return w!==void 0&&(O=v.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.g.delete(l),L.a.$removeKernelSourceActionProvider(l,l),O?.dispose()}}}async $provideKernelSourceActions(u,d){const v=this.g.get(u);if(v){const l=new P.$kb;return this.i.add([l]),(await v.provideNotebookKernelSourceActions(d)??[]).map(L=>S.NotebookKernelSourceAction.from(L,this.o.converter,l))}return[]}$acceptNotebookAssociation(u,d,v){const l=this.j.get(u);if(l){const w=this.n.getNotebookDocument(E.URI.revive(d));v?l.associatedNotebooks.set(w.uri,!0):l.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${u}] ASSOCIATE notebook`,w.uri.toString(),v),l.onDidChangeSelection.fire({selected:v,notebook:w.apiNotebook})}}async $executeCells(u,d,v){const l=this.j.get(u);if(!l)return;const w=this.n.getNotebookDocument(E.URI.revive(d)),L=[];for(const O of v){const N=w.getCell(O);N&&L.push(N.apiCell)}try{this.q.trace(`NotebookController[${u}] EXECUTE cells`,w.uri.toString(),L.length),await l.controller.executeHandler.call(l.controller,L,w.apiNotebook,l.controller)}catch(O){this.q.error(`NotebookController[${u}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(u,d,v){const l=this.j.get(u);if(!l)return;const w=this.n.getNotebookDocument(E.URI.revive(d));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,w.apiNotebook);else for(const L of v){const O=w.getCell(L);O&&this.b.get(O.uri)?.cancel()}if(l.controller.interruptHandler){const L=this.c.get(w.uri);v.length&&Array.isArray(L)&&L.length&&L.forEach(O=>O.dispose())}}$acceptKernelMessageFromRenderer(u,d,v){const l=this.j.get(u);if(!l)return;const w=this.n.getEditorById(d);l.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:v}))}$cellExecutionChanged(u,d,v){const w=this.n.getNotebookDocument(E.URI.revive(u)).getCell(d);if(w){const L=v?S.NotebookCellExecutionState.to(v):p.NotebookCellExecutionState.Idle;L!==void 0&&this.l.fire({cell:w.apiCell,state:L})}}_createNotebookCellExecution(u,d){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this.n.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!l)throw new Error("invalid cell");if(this.b.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const w=new i(d,l,this.a);this.b.set(l.uri,w);const L=w.onDidChangeState(()=>{w.state===C.Resolved&&(w.dispose(),L.dispose(),this.b.delete(l.uri))});return w.asApiObject()}_createNotebookExecution(u,d){const v=this.n.getNotebookDocument(u.uri),l=u.getCells().find(O=>{const N=v.getCellFromApiCell(O);return N&&this.b.has(N.uri)});if(l)throw new Error(`duplicate cell execution for ${l.document.uri}`);if(this.c.has(v.uri))throw new Error(`duplicate notebook execution for ${v.uri}`);const w=new n(d,v,this.a),L=w.onDidChangeState(()=>{w.state===o.Resolved&&(w.dispose(),L.dispose(),this.c.delete(v.uri))});return this.c.set(v.uri,[w,L]),w.asApiObject()}};e.$Bac=y,e.$Bac=y=Je([qe(4,R.$Ri)],y);var C;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(C||(C={}));class i extends P.$lb{static{this.a=0}get state(){return this.f}constructor(u,d,v){super(),this.j=d,this.k=v,this.b=i.a++,this.c=new A.$8c,this.onDidChangeState=this.c.event,this.f=C.Init,this.g=this.B(new h.$ed),this.h=new t(10,l=>this.m(l)),this.i=d.internalMetadata.executionOrder,this.k.$createExecution(this.b,u,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(u){await this.h.addItem(u)}async m(u){const d=Array.isArray(u)?u:[u];return this.k.$updateExecution(this.b,new f.$Yz(d))}n(){if(this.f===C.Init)throw new Error("Must call start before modifying cell output");if(this.f===C.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(u){let d=this.j;if(u&&(d=this.j.notebook.getCellFromApiCell(u)),!d)throw new Error("INVALID cell");return d.handle}s(u){return u.map(d=>{const v=p.$6K.ensureUniqueMimeTypes(d.items,!0);return v===d.items?S.NotebookCellOutput.from(d):S.NotebookCellOutput.from({items:v,id:d.id,metadata:d.metadata})})}async t(u,d,v){const l=this.r(d),w=this.s((0,k.$Jf)(u));return this.l({editType:s.CellExecutionUpdateType.Output,cellHandle:l,append:v,outputs:w})}async w(u,d,v){return u=p.$6K.ensureUniqueMimeTypes((0,k.$Jf)(u),!0),this.l({editType:s.CellExecutionUpdateType.OutputItems,items:u.map(S.NotebookCellOutputItem.from),outputId:d.id,append:v})}asApiObject(){const u=this;return Object.freeze({get token(){return u.g.token},get cell(){return u.j.apiCell},get executionOrder(){return u.i},set executionOrder(v){u.i=v,u.m([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:u.i}])},start(v){if(u.f===C.Resolved||u.f===C.Started)throw new Error("Cannot call start again");u.f=C.Started,u.c.fire(),u.m({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:v})},end(v,l){if(u.f===C.Resolved)throw new Error("Cannot call resolve twice");u.f=C.Resolved,u.c.fire(),u.h.flush(),u.k.$completeExecution(u.b,new f.$Yz({runEndTime:l,lastRunSuccess:v}))},clearOutput(v){return u.n(),u.t([],v,!1)},appendOutput(v,l){return u.n(),u.t(v,l,!0)},replaceOutput(v,l){return u.n(),u.t(v,l,!1)},appendOutputItems(v,l){return u.n(),u.w(v,l,!0)},replaceOutputItems(v,l){return u.n(),u.w(v,l,!1)}})}}var o;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(o||(o={}));class n extends P.$lb{static{this.a=0}get state(){return this.f}constructor(u,d,v){super(),this.h=d,this.i=v,this.b=n.a++,this.c=new A.$8c,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new h.$ed),this.i.$createNotebookExecution(this.b,u,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===o.Resolved||this.f===o.Started)throw new Error("Cannot call start again");this.f=o.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===o.Resolved)throw new Error("Cannot call resolve twice");this.f=o.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}class t{constructor(u,d){this.e=u,this.f=d,this.a=[],this.b=Date.now()}addItem(u){return this.a.push(u),this.c||(this.c=new F.$Pg,this.b=Date.now(),(0,F.$wg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const u=this.c;this.c=void 0;const d=this.a;return this.a=[],this.f(d).finally(()=>u.complete())}}function a(g,u){return`${g.value}/${u}`}e.$Cac=a}),define(Se[301],Ce([1,0,3,6,138]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=void 0;class A{constructor(m,E){this.c=E,this.a=new Map,this.b=m.getProxy(F.$BJ.MainThreadNotebookRenderers)}$postRendererMessage(m,E,b){const R=this.c.getEditorById(m);this.a.get(E)?.fire({editor:R.apiEditor,message:b})}createRendererMessaging(m,E){if(!m.contributes?.notebookRenderer?.some(R=>R.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(R,I,$)=>this.d(E).event(R,I,$),postMessage:(R,I)=>{h.$mac.apiEditorsToExtHost.has(R)&&([R,I]=[I,R]);const $=I&&h.$mac.apiEditorsToExtHost.get(I);return this.b.$postMessage($?.id,E,R)}}}d(m){let E=this.a.get(m);return E||(E=new k.$8c({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(m)}}),this.a.set(m,E),E)}}e.$Dac=A}),define(Se[302],Ce([1,0,4,14,2,27,6]),function(fe,e,k,F,h,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=void 0;class m{constructor(b){this.b=new Map,this.a=b.getProxy(P.$BJ.MainThreadProfileContentHandlers)}registrProfileContentHandler(b,R,I){if((0,A.$zF)(b,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,I),this.a.$registerProfileContentHandler(R,I.name,I.description,b.identifier.value),(0,k.$jb)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(b,R,I,$){const D=this.b.get(b);if(!D)throw new Error(`Unknown handler with id: ${b}`);return D.saveProfile(R,I,$)}async $readProfile(b,R,I){const $=this.b.get(b);if(!$)throw new Error(`Unknown handler with id: ${b}`);return $.readProfile((0,F.$je)(R)?R:h.URI.revive(R),I)}}e.$Hac=m}),define(Se[303],Ce([1,0,2,6,17,16]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iac=void 0;class P{static{this.a=0}constructor(E,b){this.d=b,this.c=new Map,this.b=E.getProxy(F.$BJ.MainThreadQuickDiff)}$provideOriginalResource(E,b,R){const I=k.URI.revive(b),$=this.c.get(E);return $?(0,h.$og)(()=>$.provideOriginalResource(I,R)).then(D=>D||null):Promise.resolve(null)}registerQuickDiffProvider(E,b,R,I){const $=P.a++;return this.c.set($,b),this.b.$registerQuickDiffProvider($,A.DocumentSelector.from(E,this.d),R,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider($),this.c.delete($)}}}}e.$Iac=P}),define(Se[304],Ce([1,0,21,3,4,6,2,7,8,19,40,55,27,16]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_b=void 0;function S(p,r,s){const c=p.getProxy(A.$BJ.MainThreadQuickOpen);class f{constructor(u,d){this.e=new Map,this.f=0,this.a=u,this.b=d}showQuickPick(u,d,v,l=k.CancellationToken.None){this.c=void 0;const w=Promise.resolve(d),L=++this.f,O=c.$show(L,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},l),N={},T=O.then(()=>N);return Promise.race([T,w]).then(j=>{if(j===N)return;const W=(0,$.$yF)(u,"quickPickItemTooltip");return w.then(M=>{const Y=[];for(let V=0;V<M.length;V++){const de=M[V];if(typeof de=="string")Y.push({label:de,handle:V});else if(de.kind===m.QuickPickItemKind.Separator)Y.push({type:"separator",label:de.label});else{de.tooltip&&!W&&console.warn(`Extension '${u.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${u.identifier.value}`);const re=de.iconPath?n(de.iconPath):void 0;Y.push({label:de.label,iconPath:re?.iconPath,iconClass:re?.iconClass,description:de.description,detail:de.detail,picked:de.picked,alwaysShow:de.alwaysShow,tooltip:W?D.MarkdownString.fromStrict(de.tooltip):void 0,handle:V})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=V=>{v.onDidSelectItem(M[V])}),c.$setItems(L,Y),O.then(V=>{if(typeof V=="number")return M[V];if(Array.isArray(V))return V.map(de=>M[de])})})}).then(void 0,j=>{if(!(0,E.$2)(j))return c.$setError(L,j),Promise.reject(j)})}$onItemSelected(u){this.c?.(u)}showInput(u,d=k.CancellationToken.None){return this.d=u?.validateInput,c.$input(u,typeof this.d=="function",d).then(void 0,v=>{if(!(0,E.$2)(v))return Promise.reject(v)})}async $validateInput(u){if(!this.d)return;const d=await this.d(u);if(!d||typeof d=="string")return d;let v;switch(d.severity){case m.InputBoxValidationSeverity.Info:v=R.default.Info;break;case m.InputBoxValidationSeverity.Warning:v=R.default.Warning;break;case m.InputBoxValidationSeverity.Error:v=R.default.Error;break;default:v=d.message?R.default.Error:R.default.Ignore;break}return{content:d.message,severity:v}}async showWorkspaceFolderPick(u,d=k.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[u]);if(!v)return;const l=await this.a.getWorkspaceFolders2();if(l)return l.find(w=>w.uri.toString()===v.uri.toString())}createQuickPick(u){const d=new t(u,()=>this.e.delete(d._id));return this.e.set(d._id,d),d}createInputBox(u){const d=new a(u,()=>this.e.delete(d._id));return this.e.set(d._id,d),d}$onDidChangeValue(u,d){this.e.get(u)?._fireDidChangeValue(d)}$onDidAccept(u){this.e.get(u)?._fireDidAccept()}$onDidChangeActive(u,d){const v=this.e.get(u);v instanceof t&&v._fireDidChangeActive(d)}$onDidChangeSelection(u,d){const v=this.e.get(u);v instanceof t&&v._fireDidChangeSelection(d)}$onDidTriggerButton(u,d){this.e.get(u)?._fireDidTriggerButton(d)}$onDidTriggerItemButton(u,d,v){const l=this.e.get(u);l instanceof t&&l._fireDidTriggerItemButton(d,v)}$onDidHide(u){this.e.get(u)?._fireDidHide()}}class y{static{this.a=1}constructor(u,d){this.x=u,this.y=d,this._id=t.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$8c,this.q=new F.$8c,this.r=new F.$8c,this.s=new F.$8c,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(u){this.b=u,this.z({title:u})}get step(){return this.c}set step(u){this.c=u,this.z({step:u})}get totalSteps(){return this.d}set totalSteps(u){this.d=u,this.z({totalSteps:u})}get enabled(){return this.g}set enabled(u){this.g=u,this.z({enabled:u})}get busy(){return this.j}set busy(u){this.j=u,this.z({busy:u})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(u){this.k=u,this.z({ignoreFocusOut:u})}get value(){return this.l}set value(u){this.l=u,this.z({value:u})}get placeholder(){return this.m}set placeholder(u){this.m=u,this.z({placeholder:u})}get buttons(){return this.n}set buttons(u){this.n=u.slice(),this.o.clear(),u.forEach((d,v)=>{const l=d===m.$YK.Back?-1:v;this.o.set(l,d)}),this.z({buttons:u.map((d,v)=>({...n(d.iconPath),tooltip:d.tooltip,handle:d===m.$YK.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(u){this.l=u,this.q.fire(u)}_fireDidTriggerButton(u){const d=this.o.get(u);d&&this.r.fire(d)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,h.$gb)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(u){if(!this.v){for(const d of Object.keys(u)){const v=u[d];this.u[d]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function C(g){if(g instanceof m.$yK)return{id:g.id};const u=o(g),d=i(g);return{dark:typeof u=="string"?P.URI.file(u):u,light:typeof d=="string"?P.URI.file(d):d}}function i(g){return typeof g=="object"&&"light"in g?g.light:g}function o(g){return typeof g=="object"&&"dark"in g?g.dark:g}function n(g){const u=C(g);let d,v;return"id"in u?v=I.ThemeIcon.asClassName(u):d=u,{iconPath:d,iconClass:v}}class t extends y{constructor(u,d){super(u.identifier,d),this.O=u,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$8c,this.L=[],this.M=new F.$8c,this.N=new F.$8c,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(u){this.B=u.slice(),this.C.clear(),this.D.clear(),u.forEach((l,w)=>{this.C.set(w,l),this.D.set(l,w)});const d=(0,$.$yF)(this.O,"quickPickItemTooltip"),v=[];for(let l=0;l<u.length;l++){const w=u[l];if(w.kind===m.QuickPickItemKind.Separator)v.push({type:"separator",label:w.label});else{w.tooltip&&!d&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const L=w.iconPath?n(w.iconPath):void 0;v.push({handle:l,label:w.label,iconPath:L?.iconPath,iconClass:L?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:d?D.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((O,N)=>({...n(O.iconPath),tooltip:O.tooltip,handle:N}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(u){this.E=u,this.z({canSelectMany:u})}get matchOnDescription(){return this.F}set matchOnDescription(u){this.F=u,this.z({matchOnDescription:u})}get matchOnDetail(){return this.G}set matchOnDetail(u){this.G=u,this.z({matchOnDetail:u})}get sortByLabel(){return this.H}set sortByLabel(u){this.H=u,this.z({sortByLabel:u})}get keepScrollPosition(){return this.I}set keepScrollPosition(u){this.I=u,this.z({keepScrollPosition:u})}get activeItems(){return this.J}set activeItems(u){this.J=u.filter(d=>this.D.has(d)),this.z({activeItems:this.J.map(d=>this.D.get(d))})}get selectedItems(){return this.L}set selectedItems(u){this.L=u.filter(d=>this.D.has(d)),this.z({selectedItems:this.L.map(d=>this.D.get(d))})}_fireDidChangeActive(u){const d=(0,b.$mf)(u.map(v=>this.C.get(v)));this.J=d,this.K.fire(d)}_fireDidChangeSelection(u){const d=(0,b.$mf)(u.map(v=>this.C.get(v)));this.L=d,this.M.fire(d)}_fireDidTriggerItemButton(u,d){const v=this.C.get(u);if(!v||!v.buttons||!v.buttons.length)return;const l=v.buttons[d];l&&this.N.fire({button:l,item:v})}}class a extends y{constructor(u,d){super(u.identifier,d),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(u){this.B=u,this.z({password:u})}get prompt(){return this.C}set prompt(u){this.C=u,this.z({prompt:u})}get valueSelection(){return this.D}set valueSelection(u){this.D=u,this.z({valueSelection:u})}get validationMessage(){return this.E}set validationMessage(u){this.E=u,u?typeof u=="string"?this.z({validationMessage:u,severity:R.default.Error}):this.z({validationMessage:u.message,severity:u.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new f(r,s)}e.$J_b=S}),define(Se[305],Ce([1,0,2,3,66,4,17,6,19,118,18,25,55,16,27,15]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L_b=e.$K_b=void 0;function r(u){if(u)return typeof u.iconPath=="string"?k.URI.file(u.iconPath):k.URI.isUri(u.iconPath)||$.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function s(u,d){if(!u.iconPath&&!d.iconPath)return 0;if(u.iconPath){if(!d.iconPath)return 1}else return-1;const v=typeof u.iconPath=="string"?u.iconPath:k.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,l=typeof d.iconPath=="string"?d.iconPath:k.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,b.$9p)(v,l)}function c(u,d){let v=0;if(u.strikeThrough!==d.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==d.faded)return u.faded?1:-1;if(u.tooltip!==d.tooltip)return(u.tooltip||"").localeCompare(d.tooltip||"");if(v=s(u,d),v!==0)return v;if(u.light&&d.light)v=s(u.light,d.light);else{if(u.light)return 1;if(d.light)return-1}if(v!==0)return v;if(u.dark&&d.dark)v=s(u.dark,d.dark);else{if(u.dark)return 1;if(d.dark)return-1}return v}function f(u,d){if(u.command!==d.command)return u.command<d.command?-1:1;if(u.title!==d.title)return u.title<d.title?-1:1;if(u.tooltip!==d.tooltip){if(u.tooltip!==void 0&&d.tooltip!==void 0)return u.tooltip<d.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(u.arguments===d.arguments)return 0;if(u.arguments)if(d.arguments){if(u.arguments.length!==d.arguments.length)return u.arguments.length-d.arguments.length}else return 1;else return-1;for(let v=0;v<u.arguments.length;v++){const l=u.arguments[v],w=d.arguments[v];if(l!==w)return l<w?-1:1}return 0}function y(u,d){let v=(0,b.$9p)(u.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(v!==0)return v;if(u.command&&d.command)v=f(u.command,d.command);else{if(u.command)return 1;if(d.command)return-1}if(v!==0)return v;if(u.decorations&&d.decorations)v=c(u.decorations,d.decorations);else{if(u.decorations)return 1;if(d.decorations)return-1}return v}function C(u,d){for(let v=0;v<u.length;v++)if(u[v]!==d[v])return!1;return!0}function i(u,d){return u.command===d.command&&u.title===d.title&&u.tooltip===d.tooltip&&(u.arguments&&d.arguments?C(u.arguments,d.arguments):u.arguments===d.arguments)}function o(u,d){return(0,E.$bf)(u,d,i)}class n{#e;#t;get value(){return this.d}set value(d){d=d??"",this.#e.$setInputBoxValue(this.l,d),this.n(d)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(d){this.#e.$setInputBoxPlaceholder(this.l,d),this.f=d}get validateInput(){return(0,S.$zF)(this.k,"scmValidation"),this.g}set validateInput(d){if((0,S.$zF)(this.k,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=d,this.#e.$setValidationProviderIsEnabled(this.l,!!d)}get enabled(){return this.h}set enabled(d){d=!!d,this.h!==d&&(this.h=d,this.#e.$setInputBoxEnablement(this.l,d))}get visible(){return this.j}set visible(d){d=!!d,this.j!==d&&(this.j=d,this.#e.$setInputBoxVisibility(this.l,d))}get document(){return(0,S.$zF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(d,v,l,w,L){this.k=d,this.l=w,this.m=L,this.d="",this.e=new F.$8c,this.f="",this.h=!0,this.j=!0,this.#t=v,this.#e=l}showValidationMessage(d,v){(0,S.$zF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,d,v)}$onInputBoxValueChange(d){this.n(d)}n(d){this.d=d,this.e.fire(d)}}e.$K_b=n;class t{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(d){this.v=d,this.q.$updateGroupLabel(this.t,this.handle,d)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(d){this.p=d,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(d){this.f=[...d],this.k.fire()}constructor(d,v,l,w,L){this.q=d,this.s=v,this.t=l,this.u=w,this.v=L,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$8c,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$8c,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=t.d++}getResourceState(d){return this.g.get(d)}$executeResourceCommand(d,v){const l=this.h.get(d);return l?(0,P.$og)(()=>this.s.executeCommand(l.command,...l.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this.f].sort(y),l=(0,E.$if)(this.o,d,y).map(O=>{const N=O.toInsert.map(T=>{const j=this.e++;this.g.set(j,T);const W=T.resourceUri;let M;if(T.command)if(T.command.command==="vscode.open"||T.command.command==="vscode.diff"){const ue=new A.$kb;M=this.s.converter.toInternal(T.command,ue),this.j.set(j,ue)}else this.h.set(j,T.command);const Y=r(T.decorations),V=T.decorations&&r(T.decorations.light)||Y,de=T.decorations&&r(T.decorations.dark)||Y,re=[V,de],x=T.decorations&&T.decorations.tooltip||"",q=T.decorations&&!!T.decorations.strikeThrough,ne=T.decorations&&!!T.decorations.faded,pe=T.contextValue||"";return{rawResource:[j,W,re,x,q,ne,pe,M],handle:j}});return{start:O.start,deleteCount:O.deleteCount,toInsert:N}}),w=l.map(({start:O,deleteCount:N,toInsert:T})=>[O,N,T.map(j=>j.rawResource)]),L=l.reverse();for(const{start:O,deleteCount:N,toInsert:T}of L){const j=T.map(M=>M.handle),W=this.n.splice(O,N,...j);for(const M of W)this.g.delete(M),this.h.delete(M),this.j.get(M)?.dispose(),this.j.delete(M)}return this.o=d,w}dispose(){this.l=!0,this.m.fire()}}class a{static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(d){this.g!==d&&(this.g=d,this.#e.$updateSourceControl(this.t,{count:d}))}get quickDiffProvider(){return this.h}set quickDiffProvider(d){this.h=d;let v;(0,S.$yF)(this.u,"quickDiffProvider")&&(v=d?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!d,quickDiffLabel:v})}get commitTemplate(){return this.j}set commitTemplate(d){d!==this.j&&(this.j=d,this.#e.$updateSourceControl(this.t,{commitTemplate:d}))}get acceptInputCommand(){return this.l}set acceptInputCommand(d){this.k.value=new A.$kb,this.l=d;const v=this.v.converter.toInternal(d,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:v})}get actionButton(){return(0,S.$zF)(this.u,"scmActionButton"),this.n}set actionButton(d){(0,S.$zF)(this.u,"scmActionButton"),this.m.value=new A.$kb,this.n=d;const v=d!==void 0?{command:this.v.converter.toInternal(d.command,this.m.value),secondaryCommands:d.secondaryCommands?.map(l=>l.map(w=>this.v.converter.toInternal(w,this.m.value))),description:d.description,enabled:d.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:v??null})}get statusBarCommands(){return this.p}set statusBarCommands(d){if(this.p&&d&&o(this.p,d))return;this.o.value=new A.$kb,this.p=d;const v=(d||[]).map(l=>this.v.converter.toInternal(l,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:v})}get selected(){return this.q}constructor(d,v,l,w,L,O,N){this.u=d,this.v=w,this.w=L,this.x=O,this.y=N,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new A.$mb,this.l=void 0,this.m=new A.$mb,this.o=new A.$mb,this.p=void 0,this.q=!1,this.s=new F.$8c,this.onDidChangeSelection=this.s.event,this.t=a.d++,this.z=new Map,this.A=new Set,this.#e=l;const T=k.URI.from({scheme:p.Schemas.vscodeSourceControl,path:`${L}/scm${this.t}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this.f=new n(d,v,this.#e,this.t,T),this.#e.$registerSourceControl(this.t,L,O,N,T)}createResourceGroup(d,v){const l=new t(this.#e,this.v,this.t,d,v),w=F.Event.once(l.onDidDispose)(()=>this.z.delete(l));return this.z.set(l,w),this.eventuallyAddResourceGroups(),l}eventuallyAddResourceGroups(){const d=[],v=[];for(const[l,w]of this.z){w.dispose();const L=l.onDidUpdateResourceStates(()=>{this.A.add(l),this.eventuallyUpdateResourceStates()});F.Event.once(l.onDidDispose)(()=>{this.A.delete(l),L.dispose(),this.e.delete(l.handle),this.#e.$unregisterGroup(this.t,l.handle)}),d.push([l.handle,l.id,l.label,l.features]);const O=l._takeResourceStateSnapshot();O.length>0&&v.push([l.handle,O]),this.e.set(l.handle,l)}this.#e.$registerGroups(this.t,d,v),this.z.clear()}eventuallyUpdateResourceStates(){const d=[];this.A.forEach(v=>{const l=v._takeResourceStateSnapshot();l.length!==0&&d.push([v.handle,l])}),d.length>0&&this.#e.$spliceResourceStates(this.t,d),this.A.clear()}getResourceGroup(d){return this.e.get(d)}setSelectionState(d){this.q=d,this.s.fire(d)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(d=>d.dispose()),this.#e.$unregisterSourceControl(this.t)}}Je([(0,h.$Ug)(100)],a.prototype,"eventuallyAddResourceGroups",null),Je([(0,h.$Ug)(100)],a.prototype,"eventuallyUpdateResourceStates",null);let g=class En{static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(d,v,l,w){this.l=v,this.m=l,this.n=w,this.g=new Map,this.h=new I.$Jl,this.j=new F.$8c,this.e=d.getProxy(m.$BJ.MainThreadSCM),this.f=d.getProxy(m.$BJ.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const O=this.g.get(L.sourceControlHandle);if(!O)return L;const N=O.getResourceGroup(L.groupHandle);return N?N.getResourceState(L.handle):L}else if(L&&L.$mid===4){const O=this.g.get(L.sourceControlHandle);return O?O.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const O=this.g.get(L.handle);return O||L}return L}})}createSourceControl(d,v,l,w){this.n.trace("ExtHostSCM#createSourceControl",d.identifier.value,v,l,w),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const L=En.d++,O=new a(d,this.m,this.e,this.l,v,l,w);this.g.set(L,O);const N=this.h.get(d.identifier)||[];return N.push(O),this.h.set(d.identifier,N),O}getLastInputBox(d){this.n.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const v=this.h.get(d.identifier),l=v&&v[v.length-1];return l&&l.inputBox}$provideOriginalResource(d,v,l){const w=k.URI.revive(v);this.n.trace("ExtHostSCM#$provideOriginalResource",d,w.toString());const L=this.g.get(d);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.$og)(()=>L.quickDiffProvider.provideOriginalResource(w,l)).then(O=>O||null)}$onInputBoxValueChange(d,v){this.n.trace("ExtHostSCM#$onInputBoxValueChange",d);const l=this.g.get(d);return l&&l.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(d,v,l,w){this.n.trace("ExtHostSCM#$executeResourceCommand",d,v,l);const L=this.g.get(d);if(!L)return Promise.resolve(void 0);const O=L.getResourceGroup(v);return O?O.$executeResourceCommand(l,w):Promise.resolve(void 0)}$validateInput(d,v,l){this.n.trace("ExtHostSCM#$validateInput",d);const w=this.g.get(d);return!w||!w.inputBox.validateInput?Promise.resolve(void 0):(0,P.$og)(()=>w.inputBox.validateInput(v,l)).then(L=>{if(!L)return Promise.resolve(void 0);const O=D.MarkdownString.fromStrict(L.message);return O?Promise.resolve([O,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this.g.get(d)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=d,Promise.resolve(void 0)}};e.$L_b=g,e.$L_b=g=Je([qe(3,R.$Ri)],g)}),define(Se[108],Ce([1,0,6,3,5]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r_b=e.$q_b=void 0;class A{constructor(m){this.b=new F.$8c,this.onDidChangePassword=this.b.event,this.a=m.getProxy(k.$BJ.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,E){return this.a.$getPassword(m,E)}store(m,E,b){return this.a.$setPassword(m,E,b)}delete(m,E){return this.a.$deletePassword(m,E)}}e.$q_b=A,e.$r_b=(0,h.$ph)("IExtHostSecretState")}),define(Se[306],Ce([1,0,6,7]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mac=void 0;class h{constructor(P){this.a=new Map,this.b=0,this.c=P.getProxy(k.$BJ.MainThreadSemanticSimilarity)}async $provideSimilarityScore(P,m,E,b){if(this.a.size===0)throw new Error("No semantic similarity providers registered");const R=this.a.get(P);if(!R)throw new Error("Semantic similarity provider not found");return await R.provideSimilarityScore(m,E,b)}registerSemanticSimilarityProvider(P,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerSemanticSimilarityProvider(E),new F.$DJ(()=>{this.c.$unregisterSemanticSimilarityProvider(E),this.a.delete(E)})}}e.$Mac=h}),define(Se[307],Ce([1,0,6,16,2]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oac=void 0;class A{static{this.a=0}constructor(m,E){this.d=E,this.c=new Map,this.b=m.getProxy(k.$BJ.MainThreadShare)}async $provideShare(m,E,b){return await this.c.get(m)?.provideShare({selection:F.Range.to(E.selection),resourceUri:h.URI.revive(E.resourceUri)},b)??void 0}registerShareProvider(m,E){const b=A.a++;return this.c.set(b,E),this.b.$registerShareProvider(b,F.DocumentSelector.from(m,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(b),this.c.delete(b)}}}}e.$Oac=A}),define(Se[308],Ce([1,0,7,6,199,4,16,14]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N_b=e.$M_b=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new k.$zK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new k.$zK("statusBarItem.warningForeground")]])}#e;#t;constructor($,D,S,p,r,s=k.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new A.$kb,this.#e=$,this.#t=D,r&&p){this.c=(0,k.$cK)(p.identifier,r);const f=S.get(this.c);f&&(s=f.alignLeft?k.StatusBarAlignment.Left:k.StatusBarAlignment.Right,c=f.priority,this.j=!0,this.name=f.name,this.text=f.text,this.tooltip=f.tooltip,this.command=f.command,this.accessibilityInformation=f.accessibilityInformation)}else this.c=String(E.a++);this.e=p,this.f=r,this.g=s,this.h=this.u(c)}u($){if((0,m.$ne)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!E.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new A.$kb,typeof $=="string"?this.r={fromApi:$,internal:this.#t.toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:this.#t.toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let D;this.m?D=this.m:D=(0,h.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=E.b.get(this.o.id));const p=P.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,$,this.e?.identifier.value,D,this.k,p,this.r?.internal,S,this.o,this.g===k.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$M_b=E;class b{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",k.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,h.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const D={message:$};return this.b.unshift(D),this.c(),new k.$DJ(()=>{const S=this.b.indexOf(D);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor($,D){this.e=new Map,this.a=$.getProxy(F.$BJ.MainThreadStatusBar),this.b=D,this.c=new b(this)}$acceptStaticEntries($){for(const D of $)this.e.set(D.entryId,D)}createStatusBarEntry($,D,S,p){return new E(this.a,this.b,this.e,$,D,S,p)}setStatusBarMessage($,D){const S=this.c.setMessage($);let p;return typeof D=="number"?p=setTimeout(()=>S.dispose(),D):typeof D<"u"&&D.then(()=>S.dispose(),()=>S.dispose()),new k.$DJ(()=>{S.dispose(),clearTimeout(p)})}}e.$N_b=R}),define(Se[109],Ce([1,0,6,3,5]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f_b=e.$e_b=void 0;class A{constructor(m,E){this.c=E,this.b=new F.$8c,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(k.$BJ.MainThreadStorage)}registerExtensionStorageKeysToSync(m,E){this.a.$registerExtensionStorageKeysToSync(m,E)}async initializeExtensionStorage(m,E,b){const R=await this.a.$initializeExtensionStorage(m,E);let I;return R&&(I=this.d(m,E,R)),I||b}setValue(m,E,b){return this.a.$setValue(m,E,b)}$acceptValue(m,E,b){const R=this.d(m,E,b);R&&this.b.fire({shared:m,key:E,value:R})}d(m,E,b){try{return JSON.parse(b)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${m}): ${R}`)}}}e.$e_b=A,e.$f_b=(0,h.$ph)("IExtHostStorage")}),define(Se[85],Ce([1,0,5,26,18,63,2]),function(fe,e,k,F,h,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l_b=e.$k_b=void 0,e.$k_b=(0,k.$ph)("IExtensionStoragePaths");let m=class{constructor(b,R,I){this.d=R,this.f=I,this.a=b.workspace??void 0,this.b=b.environment,this.whenReady=this.h().then($=>this.c=$)}async g(b){return P.URI.joinPath(this.b.workspaceStorageHome,b)}async h(){if(!this.a)return Promise.resolve(void 0);const b=this.a.id,R=await this.g(b);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(P.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:P.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(b){if(this.c)return P.URI.joinPath(this.c,b.identifier.value)}globalValue(b){return P.URI.joinPath(this.b.globalStorageHome,b.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$l_b=m,e.$l_b=m=Je([qe(0,F.$TL),qe(1,h.$Ri),qe(2,A.$j_b)],m)}),define(Se[43],Ce([1,0,3,6,5,2,20,4,7,201,8,241,21,32,242,55,14,17,16,27]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p_b=e.$o_b=e.$n_b=e.$m_b=void 0,e.$m_b=(0,h.$ph)("IExtHostTerminalService");class y{constructor(l,w,L,O){this.k=l,this._id=w,this.l=L,this.m=O,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(T=>this.f=T);const N=this;this.value={get name(){return N.m||""},get processId(){return N.b},get creationOptions(){return N.l},get exitStatus(){return N.h},get state(){return N.i},get selection(){return N.j},sendText(T,j=!0){N.o(),N.k.$sendText(N._id,T,j)},show(T){N.o(),N.k.$show(N._id,T)},hide(){N.o(),N.k.$hide(N._id)},dispose(){N.a||(N.a=!0,N.k.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(l,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:l.name,shellPath:(0,r.$Be)(l.shellPath),shellArgs:(0,r.$Be)(l.shellArgs),cwd:(0,r.$Be)(l.cwd),env:(0,r.$Be)(l.env),icon:(0,r.$Be)(g(l.iconPath)),color:p.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,r.$Be)(l.message),strictEnv:(0,r.$Be)(l.strictEnv),hideFromUser:(0,r.$Be)(l.hideFromUser),isFeatureTerminal:(0,r.$Be)(w?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,r.$Be)(w?.useShellEnvironment),location:w?.location||this.n(l.location,w?.resolvedExtHostIdentifier),isTransient:(0,r.$Be)(l.isTransient)})}async createExtensionTerminal(l,w,L,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:L,color:p.ThemeColor.isThemeColor(O)?O.id:void 0,location:this.n(l,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(l,w){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in l?{viewColumn:c.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus}:void 0:l}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(l){this.m=l}setExitStatus(l,w){this.h=Object.freeze({code:l,reason:w})}setDimensions(l,w){return l===this.d&&w===this.g||l===0||w===0?!1:(this.d=l,this.g=w,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}setSelection(l){this.j=l}_setProcessId(l){this.f?(this.f(l),this.f=void 0):this.b.then(w=>{w!==l&&(this.b=Promise.resolve(l))})}}e.$n_b=y;class C{get onProcessReady(){return this.b.event}constructor(l){this.g=l,this.id=0,this.shouldPersist=!1,this.a=new k.$8c,this.onProcessData=this.a.event,this.b=new k.$8c,this.d=new k.$8c,this.onDidChangeProperty=this.d.event,this.f=new k.$8c,this.onProcessExit=this.f.event}refreshProperty(l){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${l}`)}updateProperty(l,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${l}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(l){this.g.handleInput?.(l)}resize(l,w){this.g.setDimensions?.({columns:l,rows:w})}clearBuffer(){}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(l){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(l||void 0),l&&this.g.setDimensions?.(l),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let i=1,o=class extends m.$lb{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(l=>l.value)}get onDidWriteTerminalData(){return this.H.event}constructor(l,w){super(),this.f=[],this.g=new Map,this.h={},this.i={},this.j={},this.k=new Map,this.s=new Set,this.u=new Map,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new k.$8c,this.onDidCloseTerminal=this.z.event,this.C=new k.$8c,this.onDidOpenTerminal=this.C.event,this.D=new k.$8c,this.onDidChangeActiveTerminal=this.D.event,this.F=new k.$8c,this.onDidChangeTerminalDimensions=this.F.event,this.G=new k.$8c,this.onDidChangeTerminalState=this.G.event,this.I=new k.$8c,this.onDidChangeShell=this.I.event,this.a=w.getProxy(F.$BJ.MainThreadTerminalService),this.n=new S.$bjb(this.a.$sendProcessData),this.H=new k.$8c({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(l),this.B({dispose:()=>{for(const[L,O]of this.g)O.shutdown(!0)}})}getDefaultShell(l){return(l?this.m:this.l)?.path||""}getDefaultShellArgs(l){return(l?this.m:this.l)?.args||[]}createExtensionTerminal(l,w){const L=new y(this.a,(0,D.$6e)(),l,l.name),O=new C(l.pty);return L.createExtensionTerminal(l.location,this.J(l,w).resolvedExtHostIdentifier,g(l.iconPath),u(l.color)).then(N=>{const T=this.L(N,O);this.h[N]=T}),this.f.push(L),L.value}J(l,w){if(w=w||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const L=l.location.parentTerminal;if(L){const O=this.f.find(N=>N.value===L);O&&(w.resolvedExtHostIdentifier=O._id)}}else l.location&&typeof l.location!="object"?w.location=l.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(l,w){if(!this.N(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const O=new C(w),N=this.L(l,O);this.h[l]=N}async $acceptActiveTerminalChanged(l){const w=this.b;if(l===null){this.b=void 0,w!==this.b&&this.D.fire(this.b);return}const L=this.N(l);L&&(this.b=L,w!==this.b&&this.D.fire(this.b.value))}async $acceptTerminalProcessData(l,w){const L=this.N(l);L&&this.H.fire({terminal:L.value,data:w})}async $acceptTerminalDimensions(l,w,L){const O=this.N(l);O&&O.setDimensions(w,L)&&this.F.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptTerminalMaximumDimensions(l,w,L){this.g.get(l)?.resize(w,L)}async $acceptTerminalTitleChange(l,w){const L=this.N(l);L&&(L.name=w)}async $acceptTerminalClosed(l,w,L){const O=this.P(this.f,l);if(O!==null){const N=this.f.splice(O,1)[0];N.setExitStatus(w,L),this.z.fire(N.value)}}$acceptTerminalOpened(l,w,L,O){if(w){const j=this.P(this.f,w);if(j!==null){this.f[j]._id=l,this.C.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const N={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:A.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},T=new y(this.a,l,N,L);this.f.push(T),this.C.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(l,w){this.N(l)?._setProcessId(w)}async $startExtensionTerminal(l,w){const L=this.N(l);if(!L)return{message:(0,b.localize)(0,null,l)};L.isOpen||await new Promise(N=>{const T=this.onDidOpenTerminal(async j=>{j===L.value&&(T.dispose(),N())})});const O=this.g.get(l);O?O.startSendingEvents(w):this.i[l]={initialDimensions:w}}L(l,w){const L=new m.$kb;L.add(w.onProcessReady(N=>this.a.$sendProcessReady(l,N.pid,N.cwd,N.windowsPty))),L.add(w.onDidChangeProperty(N=>this.a.$sendProcessProperty(l,N))),this.n.startBuffering(l,w.onProcessData),L.add(w.onProcessExit(N=>this.M(l,N))),this.g.set(l,w);const O=this.i[l];return O&&w instanceof C&&(w.startSendingEvents(O.initialDimensions),delete this.i[l]),L}$acceptProcessAckDataEvent(l,w){this.g.get(l)?.acknowledgeDataEvent(w)}$acceptProcessInput(l,w){this.g.get(l)?.input(w)}$acceptTerminalInteraction(l){const w=this.N(l);w?.setInteractedWith()&&this.G.fire(w.value)}$acceptTerminalSelection(l,w){this.N(l)?.setSelection(w)}$acceptProcessResize(l,w,L){try{this.g.get(l)?.resize(w,L)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(l,w){this.g.get(l)?.shutdown(w)}$acceptProcessRequestInitialCwd(l){this.g.get(l)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(l,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(l){this.g.get(l)?.getCwd().then(w=>this.a.$sendProcessProperty(l,{type:"cwd",value:w}))}$acceptProcessRequestLatency(l){return Promise.resolve(l)}registerLinkProvider(l){return this.s.add(l),this.s.size===1&&this.a.$startLinkProvider(),new E.$DJ(()=>{this.s.delete(l),this.s.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(l,w,L){if(this.u.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.u.set(w,L),this.a.$registerProfileProvider(w,l.identifier.value),new E.$DJ(()=>{this.u.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(l,w,L){if(this.v.has(l))throw new Error(`Terminal quick fix provider "${l}" is already registered`);return this.v.set(l,L),this.a.$registerQuickFixProvider(l,w),new E.$DJ(()=>{this.v.delete(l),this.a.$unregisterQuickFixProvider(l)})}async $provideTerminalQuickFixes(l,w){const L=new $.$ed().token;if(L.isCancellationRequested)return;const O=this.v.get(l);if(!O)return;const N=await O.provideTerminalQuickFixes(w,L);if(N!==null)return N}async $createContributedProfileTerminal(l,w){const L=new $.$ed().token;let O=await this.u.get(l)?.provideTerminalProfile(L);if(!L.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,w);return}this.createTerminalFromOptions(O.options,w)}}async $provideLinks(l,w){const L=this.N(l);if(!L)return[];this.w.delete(l),this.y.get(l)?.dispose(!0);const N=new $.$ed;this.y.set(l,N);const T=[],j={terminal:L.value,line:w},W=[];for(const V of this.s)W.push(s.Promises.withAsyncBody(async de=>{N.token.onCancellationRequested(()=>de({provider:V,links:[]}));const re=await V.provideTerminalLinks(j,N.token)||[];N.token.isCancellationRequested||de({provider:V,links:re})}));const M=await Promise.all(W);if(N.token.isCancellationRequested)return[];const Y=new Map;for(const V of M)V&&V.links.length>0&&T.push(...V.links.map(de=>{const re={id:i++,startIndex:de.startIndex,length:de.length,label:de.tooltip};return Y.set(re.id,{provider:V.provider,link:de}),re}));return this.w.set(l,Y),T}$activateLink(l,w){const L=this.w.get(l)?.get(w);L&&L.provider.handleTerminalLink(L.link)}M(l,w){this.n.stopBuffering(l),this.g.delete(l),delete this.i[l];const L=this.h[l];L&&(L.dispose(),delete this.h[l]),this.a.$sendProcessExit(l,w)}N(l){return this.O(this.f,l)}O(l,w){const L=this.P(l,w);return L!==null?l[L]:null}P(l,w){const L=l.findIndex(O=>O._id===w);return L===-1?null:L}getEnvironmentVariableCollection(l){let w=this.k.get(l.identifier.value);return w||(w=new n(l),this.R(l.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Q(l,w){const L=(0,I.$Zq)(w.map),O=(0,I.$1q)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(l,w.persistent,L.length===0?void 0:L,O)}$initEnvironmentVariableCollections(l){l.forEach(w=>{const L=w[0],O=new n(void 0,w[1]);this.R(L,O)})}$acceptDefaultProfile(l,w){const L=this.l;this.l=l,this.m=w,L?.path!==l.path&&this.I.fire(l.path)}R(l,w){this.k.set(l,w),w.onDidChangeCollection(()=>{this.Q(l,w)})}};e.$o_b=o,e.$o_b=o=Je([qe(1,P.$DL)],o);class n{get persistent(){return this.b}set persistent(l){this.b=l,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(l,w){this.f=l,this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new k.$8c,this.map=new Map(w)}getScopedEnvironmentVariableCollection(l){this.f&&l&&(0,f.$zF)(this.f,"envCollectionWorkspace");const w=this.i(l);let L=this.a.get(w);return L||(L=new t(this,l),this.a.set(w,L),L.onDidChangeCollection(()=>this.d.fire())),L}replace(l,w,L,O){this.f&&L&&(0,f.$zF)(this.f,"envCollectionOptions"),this.g(l,{value:w,type:E.EnvironmentVariableMutatorType.Replace,options:L??{},scope:O})}append(l,w,L,O){this.f&&L&&(0,f.$zF)(this.f,"envCollectionOptions"),this.g(l,{value:w,type:E.EnvironmentVariableMutatorType.Append,options:L??{},scope:O})}prepend(l,w,L,O){this.f&&L&&(0,f.$zF)(this.f,"envCollectionOptions"),this.g(l,{value:w,type:E.EnvironmentVariableMutatorType.Prepend,options:L??{},scope:O})}g(l,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const L=this.h(l,w.scope),O=this.map.get(L);if(!O||O.value!==w.value||O.type!==w.type||O.options?.applyAtProcessCreation!==(w.options.applyAtProcessCreation??!0)||O.options?.applyAtShellIntegration!==(w.options.applyAtShellIntegration??!1)||O.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const N=this.h(l,w.scope),T={variable:l,...w,options:{applyAtProcessCreation:w.options.applyAtProcessCreation??!0,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}};this.map.set(N,T),this.d.fire()}}get(l,w){const L=this.h(l,w),O=this.map.get(L);return O?d(O):void 0}h(l,w){const L=this.i(w);return L.length?`${l}:::${L}`:l}i(l){return this.j(l?.workspaceFolder)??""}j(l){return l?l.uri.toString():void 0}getVariableMap(l){const w=new Map;for(const[L,O]of this.map)this.i(O.scope)===this.i(l)&&w.set(O.variable,d(O));return w}delete(l,w){const L=this.h(l,w);this.map.delete(L),this.d.fire()}clear(l){if(l?.workspaceFolder){for(const[w,L]of this.map)L.scope?.workspaceFolder?.index===l.workspaceFolder.index&&this.map.delete(w);this.k(l)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(l,w){const L=this.i(w),O=this.descriptionMap.get(L);if(!O||O.description!==l){let N;typeof l=="string"?N=l:N=l?.value.split(`

`)[0];const T={description:N,scope:w};this.descriptionMap.set(L,T),this.d.fire()}}getDescription(l){const w=this.i(l);return this.descriptionMap.get(w)?.description}k(l){const w=this.i(l);this.descriptionMap.delete(w)}}class t{get persistent(){return this.b.persistent}set persistent(l){this.b.persistent=l}get onDidChangeCollection(){return this.a&&this.a.event}constructor(l,w){this.b=l,this.d=w,this.a=new k.$8c}getScopedEnvironmentVariableCollection(l){return this.b.getScopedEnvironmentVariableCollection(l)}replace(l,w,L){this.b.replace(l,w,L,this.d)}append(l,w,L){this.b.append(l,w,L,this.d)}prepend(l,w,L){this.b.prepend(l,w,L,this.d)}get(l){return this.b.get(l,this.d)}forEach(l,w){this.b.getVariableMap(this.d).forEach((L,O)=>l.call(w,O,L,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(l){this.b.delete(l,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(l){this.b.setDescription(l,this.d)}get description(){return this.b.getDescription(this.d)}}let a=class extends o{constructor(l){super(!1,l)}createTerminal(l,w,L){throw new R.$$}createTerminalFromOptions(l,w){throw new R.$$}};e.$p_b=a,e.$p_b=a=Je([qe(0,P.$DL)],a);function g(v){if(!(!v||typeof v=="string"))return"id"in v?{id:v.id,color:v.color}:v}function u(v){return p.ThemeColor.isThemeColor(v)?v:void 0}function d(v){const l={...v};return delete l.scope,l.options=l.options??void 0,delete l.variable,l}}),define(Se[309],Ce([1,0,19,17,22,21,3,67,70,4,23,14,32,6,20,139,16,7,59,103,82]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zac=e.$yac=e.$xac=e.$wac=void 0;let C=class{constructor(N,T,j){this.j=j,this.c=new P.$8c,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=N.getProxy(D.$BJ.MainThreadTesting),this.h=new l(this.f),this.g=new t(this.f),T.registerArgumentProcessor({processArgument:W=>{if(W?.$mid!==15)return W;const M=W,Y=M.tests[M.tests.length-1].item.extId;return this.d.get(c.$nI.root(Y))?.collection.tree.get(Y)?.actual??(0,p.$PL)(W)}}),T.registerCommand(!1,"testing.getExplorerSelection",async()=>{const W=await T.executeCommand("_testing.getExplorerSelection"),M=Y=>{const V=this.d.get(c.$nI.root(Y));if(V)return c.$nI.isRoot(Y)?V.controller:V.collection.tree.get(Y)?.actual};return{include:W?.include.map(M).filter(I.$re)||[],exclude:W?.exclude.map(M).filter(I.$re)||[]}})}createTestController(N,T,j,W){if(this.d.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const M=new b.$kb,Y=M.add(new p.$SL(T,j,this.j));Y.root.label=j;const V=new Map,de=this.f,re={items:Y.root.children,get label(){return j},set label(q){j=q,Y.root.label=q,de.$updateController(T,{label:j})},get refreshHandler(){return W},set refreshHandler(q){W=q,de.$updateController(T,{canRefresh:!!q})},get id(){return T},createRunProfile:(q,ne,pe,H,ue,ce)=>{let z=(0,E.$di)(q);for(;V.has(z);)z++;return new w(this.f,V,T,z,q,ne,pe,H,ue,ce)},createTestItem(q,ne,pe){return new p.$QL(T,q,ne,pe)},createTestRun:(q,ne,pe=!0)=>this.g.createTestRun(T,Y,q,ne,pe),invalidateTestResults:q=>{if(q===void 0)this.f.$markTestRetired(void 0);else{const ne=q instanceof Array?q:[q];this.f.$markTestRetired(ne.map(pe=>c.$nI.fromExtHostTestItem(pe,T).toString()))}},set resolveHandler(q){Y.resolveHandler=q},get resolveHandler(){return Y.resolveHandler},dispose:()=>{M.dispose()}};de.$registerTestController(T,j,!!W),M.add((0,b.$jb)(()=>de.$unregisterTestController(T)));const x={controller:re,collection:Y,profiles:V};return this.d.set(T,x),M.add((0,b.$jb)(()=>this.d.delete(T))),M.add(Y.onDidGenerateDiff(q=>de.$publishDiff(T,q.map(y.TestsDiffOp.serialize)))),re}createTestObserver(){return this.h.checkout()}async runTests(N,T=A.CancellationToken.None){const j=a(N);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.d.get(j.controllerId);if(!W)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(M=>c.$nI.fromExtHostTestItem(M,W.collection.root.id).toString())??[W.collection.root.id],profileGroup:L[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:N.exclude?.map(M=>M.id)},T)}$syncTests(){for(const{collection:N}of this.d.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,T,j){return(0,k.$Lf)(this.g.trackers,M=>M.id===N?M.getCoverage(T):void 0)?.provideFileCoverage(j)??Promise.resolve([])}$resolveFileCoverage(N,T,j,W){return(0,k.$Lf)(this.g.trackers,Y=>Y.id===N?Y.getCoverage(T):void 0)?.resolveFileCoverage(j,W)??Promise.resolve([])}$configureRunProfile(N,T){this.d.get(N)?.profiles.get(T)?.configureHandler?.()}async $refreshTests(N,T){await this.d.get(N)?.controller.refreshHandler?.(T)}$publishTestResults(N){this.results=Object.freeze(N.map(T=>(0,R.$Im)(r.TestResults.to(T))).concat(this.results).sort((T,j)=>j.completedAt-T.completedAt).slice(0,32)),this.c.fire()}async $expandTest(N,T){const j=this.d.get(c.$nI.fromString(N).controllerId)?.collection;j&&(await j.expand(N,T<0?1/0:T),j.flushDiff())}$acceptDiff(N){this.h.applyDiff(N.map(y.TestsDiffOp.deserialize))}async $runControllerTests(N,T){return Promise.all(N.map(j=>this.k(j,!1,T)))}async $startContinuousRun(N,T){const j=new A.$ed(T),W=await Promise.all(N.map(M=>this.k(M,!0,j.token)));return!T.isCancellationRequested&&!W.some(M=>M.error)&&await new Promise(M=>T.onCancellationRequested(M)),j.dispose(!0),W}async k(N,T,j){const W=this.d.get(N.controllerId);if(!W)return{};const{collection:M,profiles:Y}=W,V=Y.get(N.profileId);if(!V)return{};const de=N.testIds.map(ne=>M.tree.get(ne)).filter(I.$re),re=N.excludeExtIds.map(ne=>W.collection.tree.get(ne)).filter(I.$re).filter(ne=>de.some(pe=>pe.fullId.compare(ne.fullId)===2));if(!de.length)return{};const x=new s.$aL(de.some(ne=>ne.actual instanceof p.$RL)?void 0:de.map(ne=>ne.actual),re.map(ne=>ne.actual),V,T),q=(0,y.$pI)(N)&&this.g.prepareForMainThreadTestRun(x,g.fromInternal(N,W.collection),j);try{return await V.runHandler(x,j),{}}catch(ne){return{error:String(ne)}}finally{q&&(q.hasRunningTasks&&!j.isCancellationRequested&&await P.Event.toPromise(q.onEnd),q.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.g.cancelAllRuns():this.g.cancelRunById(N)}};e.$wac=C,e.$wac=C=Je([qe(0,S.$DL)],C);const i=1e4;var o;(function(O){O[O.Running=0]="Running",O[O.Cancelling=1]="Cancelling",O[O.Ended=2]="Ended"})(o||(o={}));class n extends b.$lb{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(N,T,j){super(),this.k=N,this.l=T,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new P.$8c),this.onEnd=this.j.event,this.h=this.B(new A.$ed(j));const W=this.B(new F.$Gg(()=>this.m(),i));this.B(this.h.token.onCancellationRequested(()=>W.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(N){return this.f.get(N)?.coverage}createRun(N){const T=this.k.id,j=this.k.controllerId,W=(0,$.$6e)(),M=new u(this.l,T,W),Y=x=>(q,...ne)=>{if(de){console.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}this.k.isIncluded(q)&&(this.s(q),x(q,...ne))},V=(x,q)=>{const ne=q instanceof Array?q.map(r.TestMessage.from):[r.TestMessage.from(q)];if(x.uri&&x.range){const pe={range:r.Range.from(x.range),uri:x.uri};for(const H of ne)H.location=H.location||pe}this.l.$appendTestMessagesInRun(T,W,c.$nI.fromExtHostTestItem(x,j).toString(),ne)};let de=!1;const re={isPersisted:this.k.isPersisted,token:this.h.token,name:N,get coverageProvider(){return M.coverageProvider},set coverageProvider(x){M.coverageProvider=x},enqueued:Y(x=>{this.l.$updateTestStateInRun(T,W,c.$nI.fromExtHostTestItem(x,j).toString(),1)}),skipped:Y(x=>{this.l.$updateTestStateInRun(T,W,c.$nI.fromExtHostTestItem(x,j).toString(),5)}),started:Y(x=>{this.l.$updateTestStateInRun(T,W,c.$nI.fromExtHostTestItem(x,j).toString(),2)}),errored:Y((x,q,ne)=>{V(x,q),this.l.$updateTestStateInRun(T,W,c.$nI.fromExtHostTestItem(x,j).toString(),6,ne)}),failed:Y((x,q,ne)=>{V(x,q),this.l.$updateTestStateInRun(T,W,c.$nI.fromExtHostTestItem(x,j).toString(),4,ne)}),passed:Y((x,q)=>{this.l.$updateTestStateInRun(T,W,c.$nI.fromExtHostTestItem(x,this.k.controllerId).toString(),3,q)}),appendOutput:(x,q,ne)=>{de||(ne&&(this.k.isIncluded(ne)?this.s(ne):ne=void 0),this.l.$appendOutputToRun(T,W,h.$Jb.fromString(x),q&&r.location.from(q),ne&&c.$nI.fromExtHostTestItem(ne,j).toString()))},end:()=>{de||(de=!0,this.l.$finishedTestRunTask(T,W),this.f.delete(W),this.f.size||this.p())}};return this.f.set(W,{run:re,coverage:M}),this.l.$startedTestRunTask(T,{id:W,name:N,running:!0}),re}m(){for(const{run:N}of this.f.values())N.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(N){if(!(N instanceof p.$QL))throw new f.$vL(N.id);if(this.g.has(c.$nI.fromExtHostTestItem(N,this.k.controllerId).toString()))return;const T=[],j=this.k.colllection.root;for(;;){const W=r.TestItem.from(N);if(T.unshift(W),this.g.has(W.extId)||(this.g.add(W.extId),N===j))break;N=N.parent||j}this.l.$addTestsToRun(this.k.controllerId,this.k.id,T)}}class t{get trackers(){return this.c.values()}constructor(N){this.d=N,this.c=new Map}prepareForMainThreadTestRun(N,T,j){return this.f(N,T,j)}cancelRunById(N){for(const T of this.c.values())if(T.id===N){T.cancel();return}}cancelAllRuns(){for(const N of this.c.values())N.cancel()}createTestRun(N,T,j,W,M){const Y=this.c.get(j);if(Y)return Y.createRun(W);const V=g.fromPublic(N,T,j,M),de=a(j);this.d.$startedExtensionTestRun({controllerId:N,continuous:!!j.continuous,profile:de&&{group:L[de.kind],id:de.profileId},exclude:j.exclude?.map(x=>c.$nI.fromExtHostTestItem(x,T.root.id).toString())??[],id:V.id,include:j.include?.map(x=>c.$nI.fromExtHostTestItem(x,T.root.id).toString())??[T.root.id],persist:M});const re=this.f(j,V);return re.onEnd(()=>{this.d.$finishedExtensionTestRun(V.id),re.dispose()}),re.createRun(W)}f(N,T,j){const W=new n(T,this.d,j);return this.c.set(N,W),W.onEnd(()=>this.c.delete(N)),W}}e.$xac=t;const a=O=>{if(O.profile){if(!(O.profile instanceof w))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return O.profile}};class g{static fromPublic(N,T,j,W){return new g(N,(0,$.$6e)(),j.include?.map(M=>c.$nI.fromExtHostTestItem(M,N).toString())??[N],j.exclude?.map(M=>c.$nI.fromExtHostTestItem(M,N).toString())??[],W,T)}static fromInternal(N,T){return new g(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,T)}constructor(N,T,j,W,M,Y){this.controllerId=N,this.id=T,this.isPersisted=M,this.colllection=Y,this.c=j.map(V=>V+"\0"),this.d=W.map(V=>V+"\0")}isIncluded(N){const T=c.$nI.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const j of this.d)if(T===j||T.startsWith(j))return!1;for(const j of this.c)if(T===j||T.startsWith(j))return!0;return!1}}e.$yac=g;class u{set coverageProvider(N){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");N&&(this.c=N,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(N,T,j){this.f=N,this.g=T,this.h=j}async provideFileCoverage(N){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(N))());try{return(await this.d)?.map(r.TestCoverage.fromFile)??[]}catch(T){throw this.d=void 0,T}}async resolveFileCoverage(N,T){const j=await this.d;let W=j?.[N];return!this.c||!j||!W?[]:(W.detailedCoverage||(W=j[N]=await this.c.resolveFileCoverage?.(W,T)??W),W.detailedCoverage?.map(r.TestCoverage.fromDetailed)??[])}}class d{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(N){this.h=N,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(N){this.c.add(N)}update(N){Object.assign(N.revived,r.TestItem.toPlain(N.item)),this.c.has(N)||this.d.add(N)}remove(N){if(this.c.has(N)){this.c.delete(N);return}this.d.delete(N);const T=c.$nI.parentId(N.item.extId);if(T&&this.g.has(T.toString())){this.g.add(N.item.extId);return}this.f.add(N)}getChangeEvent(){const{c:N,d:T,f:j}=this;return{get added(){return[...N].map(W=>W.revived)},get updated(){return[...T].map(W=>W.revived)},get removed(){return[...j].map(W=>W.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class v extends y.$uI{constructor(){super(...arguments),this.q=new P.$8c,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(N){return this.d.get(N)}getMirroredTestDataByReference(N){return this.d.get(N.id)}p(N,T){return{...N,revived:r.TestItem.toPlain(N.item),depth:T?T.depth+1:0,children:new Set}}o(){return new d(this.q)}}class l{constructor(N){this.d=N}checkout(){this.c||(this.c=this.f());const N=this.c;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(T=>T.revived)},dispose:(0,m.$cb)(()=>{--N.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(N){return this.c?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.c?.tests.apply(N)}f(){const N=new v;return this.d.$subscribeToDiffs(),{observers:0,tests:N}}}class w{#e;#t;get label(){return this.d}set label(N){N!==this.d&&(this.d=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(N){N!==this.g&&(this.g=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this.f}set isDefault(N){N!==this.f&&(this.f=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?r.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this.c}set configureHandler(N){N!==this.c&&(this.c=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}constructor(N,T,j,W,M,Y,V,de=!1,re=void 0,x=!1){this.controllerId=j,this.profileId=W,this.d=M,this.kind=Y,this.runHandler=V,this.f=de,this._tag=re,this.g=x,this.#e=N,this.#t=T,T.set(W,this);const q=L[Y];if(typeof q!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);this.#e.$publishTestRunProfile({profileId:W,controllerId:j,tag:re?r.TestTag.namespace(this.controllerId,re.id):null,label:M,group:q,isDefault:de,hasConfigurationHandler:!1,supportsContinuousRun:x})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$zac=w;const L={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Se[310],Ce([1,0,19,8,3,6,140,16,7]),function(fe,e,k,F,h,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O_b=void 0;class b{constructor(I,$){this.i=$,this.a=new h.$8c({onListenerError:F.$Z}),this.b=new h.$8c({onListenerError:F.$Z}),this.c=new h.$8c({onListenerError:F.$Z}),this.d=new h.$8c({onListenerError:F.$Z}),this.f=new h.$8c({onListenerError:F.$Z}),this.g=new h.$8c({onListenerError:F.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(A.$BJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(D=>this.g.fire(D)),this.i.onDidChangeActiveTextEditor(D=>this.f.fire(D))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const $=this.i.allEditors();return I?$:$.map(D=>D.value)}async showTextDocument(I,$,D){let S;typeof $=="number"?S={position:m.ViewColumn.from($),preserveFocus:D}:typeof $=="object"?S={position:m.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus,selection:typeof $.selection=="object"?m.Range.from($.selection):void 0,pinned:typeof $.preview=="boolean"?!$.preview:void 0}:S={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(I.uri,S),r=p&&this.i.getEditor(p);if(r)return r.value;throw p?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,$){return new P.$KL(this.h,I,$).value}$acceptEditorPropertiesChanged(I,$){const D=this.i.getEditor(I);if(!D)throw new Error("unknown text editor");if($.options&&D._acceptOptions($.options),$.selections){const S=$.selections.selections.map(m.Selection.to);D._acceptSelections(S)}if($.visibleRanges){const S=k.$mf($.visibleRanges.map(m.Range.to));D._acceptVisibleRanges(S)}if($.options&&this.b.fire({textEditor:D.value,options:{...$.options,lineNumbers:m.TextEditorLineNumbersStyle.to($.options.lineNumbers)}}),$.selections){const S=E.TextEditorSelectionChangeKind.fromValue($.selections.source),p=$.selections.selections.map(m.Selection.to);this.a.fire({textEditor:D.value,selections:p,kind:S})}if($.visibleRanges){const S=k.$mf($.visibleRanges.map(m.Range.to));this.c.fire({textEditor:D.value,visibleRanges:S})}}$acceptEditorPositionData(I){for(const $ in I){const D=this.i.getEditor($);if(!D)throw new Error("Unknown text editor");const S=m.ViewColumn.to(I[$]);D.value.viewColumn!==S&&(D._acceptViewColumn(S),this.d.fire({textEditor:D.value,viewColumn:S}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$O_b=b}),define(Se[311],Ce([1,0,2,5,6,4,7,16,25,14]),function(fe,e,k,F,h,A,P,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=e.$qac=void 0,e.$qac=(0,F.$ph)("IExtHostTimeline");class R{constructor(D,S){this.b=new Map,this.c=new Map,this.a=D.getProxy(h.$BJ.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(p,r)=>{if(p&&p.$mid===12)if(this.b.get(p.source)&&E.$Hl.equals(r,this.b.get(p.source)?.extension)){const s=p.uri===void 0?void 0:k.URI.revive(p.uri);return this.c.get(p.source)?.get(I(s))?.get(p.handle)}else return;return p}})}async $getTimeline(D,S,p,r){return this.b.get(D)?.provider.provideTimeline(k.URI.revive(S),p,r)}registerTimelineProvider(D,S,p,r){const s=new A.$kb,c=this.d(S.id,r,s).bind(this);let f;S.onDidChange&&(f=S.onDidChange(C=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...C,id:S.id}),this));const y=this.c;return this.f({...S,scheme:D,onDidChange:void 0,async provideTimeline(C,i,o){i?.resetCache&&(s.clear(),y.get(S.id)?.clear());const n=await S.provideTimeline(C,i,o);if(n==null)return;const t=c(C,i);return{...n,source:S.id,items:n.items.map(t)}},dispose(){for(const C of y.values())C.get(S.id)?.clear();f?.dispose(),s.dispose()}},p)}d(D,S,p){return(r,s)=>{let c;if(s?.cacheResults){let f=this.c.get(D);f===void 0&&(f=new Map,this.c.set(D,f));const y=I(r);c=f.get(y),c===void 0&&(c=new Map,f.set(y,c))}return f=>{const{iconPath:y,...C}=f,i=`${D}|${f.id??f.timestamp}`;c?.set(i,f);let o,n,t;f.iconPath&&(y instanceof P.$yK?t={id:y.id,color:y.color}:k.URI.isUri(y)?(o=y,n=y):{light:o,dark:n}=y);let a;return P.$5J.isMarkdownString(C.tooltip)?a=m.MarkdownString.from(C.tooltip):(0,b.$je)(C.tooltip)?a=C.tooltip:P.$5J.isMarkdownString(C.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=m.MarkdownString.from(C.detail)):(0,b.$je)(C.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=C.detail),{...C,id:C.id??void 0,handle:i,source:D,command:f.command?S.toInternal(f.command,p):void 0,icon:o,iconDark:n,themeIcon:t,tooltip:a,accessibilityInformation:f.accessibilityInformation}}}}f(D,S){if(this.b.get(D.id))throw new Error(`Timeline Provider ${D.id} already exists.`);return this.a.$registerTimelineProvider({id:D.id,label:D.label,scheme:D.scheme}),this.b.set(D.id,{provider:D,extension:S}),(0,A.$jb)(()=>{for(const r of this.c.values())r.get(D.id)?.clear();this.b.delete(D.id),this.a.$unregisterTimelineProvider(D.id),D.dispose()})}}e.$rac=R;function I($){return $?.toString()}}),define(Se[64],Ce([1,0,21,3,4,203,5,18,132,6,26,20,7]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpb=e.$Wpb=e.TunnelDtoConverter=void 0;class D extends E.$Oz{}var S;(function(r){function s(f){return{remoteAddress:f.remoteAddress,localAddress:f.localAddress,public:!!f.public,privacy:f.privacy??(f.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:f.protocol}}r.fromApiTunnel=s;function c(f){return{remoteAddress:{host:f.tunnelRemoteHost,port:f.tunnelRemotePort},localAddress:f.localAddress,public:f.privacy!==E.TunnelPrivacyId.ConstantPrivate&&f.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:f.privacy,protocol:f.protocol}}r.fromServiceTunnel=c})(S||(e.TunnelDtoConverter=S={})),e.$Wpb=(0,P.$ph)("IExtHostTunnelService");let p=class extends h.$lb{constructor(s,c,f){super(),this.n=f,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$8c,this.onDidChangeTunnels=this.h.event,this.k=0,this.l=new Map,this.a=s.getProxy(b.$BJ.MainThreadTunnelService)}async openTunnel(s,c){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const f=await this.a.$openTunnel(c,s.displayName);if(f){const y=new D(f.remoteAddress,f.localAddress,()=>this.a.$closeTunnel(f.remoteAddress));return this.B(y),y}}async getTunnels(){return this.a.$getTunnels()}p(){return this.k++}registerPortsAttributesProvider(s,c){const f=this.p();return this.l.set(f,{selector:s,provider:c}),this.a.$registerPortsAttributesProvider(s,f),new $.$DJ(()=>{this.l.delete(f),this.a.$unregisterPortsAttributesProvider(f)})}async $providePortAttributes(s,c,f,y,C){const i=[];for(const n of s){const t=this.l.get(n);if(!t)return[];i.push(...await Promise.all(c.map(async a=>({providedAttributes:await t.provider.providePortAttributes(a,f,y,C),port:a}))))}const o=i.filter(n=>!!n.providedAttributes);return o.length>0?o.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(y,C)=>await s.provideTunnel(y,C,new k.$ed().token)??void 0;const f=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(f),Promise.resolve((0,h.$jb)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s){if(s){if(s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter()),s.tunnelFactory){this.b=s.tunnelFactory;let c=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const f=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:c}:void 0;this.a.$setTunnelProvider(f)}}else this.b=void 0;return(0,h.$jb)(()=>{this.b=void 0})}async $closeTunnel(s,c){if(this.g.has(s.host)){const f=this.g.get(s.host);f.has(s.port)&&(c&&f.get(s.port).disposeListener.dispose(),await f.get(s.port).tunnel.dispose(),f.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,c){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const f=this.b(s,c);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),f!==void 0){const y=await f;if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),y===void 0){this.n.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const C=this.B(y.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(y.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:y,disposeListener:C}),S.fromApiTunnel(y)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(s){const c=await Promise.all(s.map(y=>this.f(y.host,y.port,y.detail??""))),f=s.filter((y,C)=>c[C]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(y=>y.port).join(", ")} to ${f.map(y=>y.port).join(", ")}`),f}};e.$Xpb=p,e.$Xpb=p=Je([qe(0,I.$DL),qe(1,R.$TL),qe(2,m.$Ri)],p)}),define(Se[312],Ce([1,0,4,15,2,6]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aac=void 0;class P{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(A.$BJ.MainThreadUriOpeners)}registerExternalUriOpener(E,b,R,I){if(this.c.has(b))throw new Error(`Opener with id '${b}' already registered`);const $=I.schemes.find(D=>!P.a.has(D));if($)throw new Error(`Scheme '${$}' is not supported. Only http and https are currently supported.`);return this.c.set(b,R),this.b.$registerUriOpener(b,I.schemes,E,I.label),(0,k.$jb)(()=>{this.c.delete(b),this.b.$unregisterUriOpener(b)})}async $canOpenUri(E,b,R){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const $=h.URI.revive(b);return I.canOpenExternalUri($,R)}async $openUri(E,b,R){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(h.URI.revive(b.resolvedUri),{sourceUri:h.URI.revive(b.sourceUri)},R)}}e.$Aac=P}),define(Se[313],Ce([1,0,6,2,4,8,25]),function(fe,e,k,F,h,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=void 0;class m{static{this.a=0}constructor(b){this.c=new P.$Il,this.d=new Map,this.b=b.getProxy(k.$BJ.MainThreadUrls)}registerUriHandler(b,R){const I=b.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const $=m.a++;return this.c.add(I),this.d.set($,R),this.b.$registerUriHandler($,I,b.displayName||b.name),(0,h.$jb)(()=>{this.c.delete(I),this.d.delete($),this.b.$unregisterUriHandler($)})}$handleExternalUri(b,R){const I=this.d.get(b);if(!I)return Promise.resolve(void 0);try{I.handleUri(F.URI.revive(R))}catch($){(0,A.$Y)($)}return Promise.resolve(void 0)}async createAppUri(b){return F.URI.revive(await this.b.$createAppUri(b))}}e.$Q_b=m}),define(Se[86],Ce([1,0,3,15,23,2,217,250,104,6]),function(fe,e,k,F,h,A,P,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V_b=e.$U_b=e.$T_b=e.$S_b=e.$R_b=void 0;class R{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(f,y,C,i,o,n,t){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new k.$8c,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new k.$8c,this._onDidDispose=this.#h.event,this.#e=f,this.#t=y,this.#r=C,this.#l=i,this.#u=o,this.#n=n,this.#c=I(n),this.#d=$(n),this.#i=t}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return this.#a=!0,(0,E.$knb)(f,this.#l)}get cspSource(){const f=this.#n.extensionLocation;if(f.scheme===F.Schemas.https||f.scheme===F.Schemas.http){let y=f.toString();return y.endsWith("/")||(y+="/"),y+" "+E.$jnb}return E.$jnb}get html(){return this.a(),this.#s}set html(f){this.a(),this.#s!==f&&(this.#s=f,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(f)))}get options(){return this.a(),this.#r}set options(f){this.a(),h.$Lm(this.#r,f)||this.#t.$setOptions(this.#e,p(this.#n,this.#u,f)),this.#r=f}async postMessage(f){if(this.#o)return!1;const y=(0,m.$90)(f,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,y.message,...y.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(f){if(!this.#d)return f;const y=this.#n.extensionLocation?.scheme===F.Schemas.vscodeRemote,C=this.#n.extensionLocation.scheme===F.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return f.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(i,o,n,t,a,g)=>{const u=A.URI.from({scheme:t||"file",path:decodeURIComponent(a)}),d=(0,E.$knb)(u,{isRemote:y,authority:C}).toString();return`${o}${d}${g}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(i,o,n,t,a,g)=>{const u=A.URI.from({scheme:t||"file",path:decodeURIComponent(a)}),d=(0,E.$knb)(u,{isRemote:y,authority:C}).toString();return`${o}${d}${g}`})}}e.$R_b=R;function I(c){try{const f=(0,P.$to)((0,P.$so)(c.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.$S_b=I;function $(c){try{const f=(0,P.$to)((0,P.$so)(c.engines.vscode));return f?f.majorBase<1||f.majorBase===1&&f.minorBase<60:!1}catch{return!1}}class D{constructor(f,y,C,i,o){this.c=y,this.d=C,this.e=i,this.f=o,this.b=new Map,this.a=f.getProxy(b.$BJ.MainThreadWebviews)}$onMessage(f,y,C){const i=this.g(f);if(i){const{message:o}=(0,m.$00)(y,C.value);i._onMessageEmitter.fire(o)}}$onMissingCsp(f,y){this.e.warn(`${y} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,y,C){const i=new R(f,this.a,r(y),this.c,this.d,C,this.f);return this.b.set(f,i),i._onDidDispose(()=>{this.b.delete(f)}),i}deleteWebview(f){this.b.delete(f)}g(f){return this.b.get(f)}}e.$T_b=D;function S(c){return{id:c.identifier,location:c.extensionLocation}}e.$U_b=S;function p(c,f,y){return{enableCommandUris:y.enableCommandUris,enableScripts:y.enableScripts,enableForms:y.enableForms,portMapping:y.portMapping,localResourceRoots:y.localResourceRoots||s(c,f)}}e.$V_b=p;function r(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(f=>A.URI.from(f))}}function s(c,f){return[...(f?.getWorkspaceFolders()||[]).map(y=>y.uri),c.extensionLocation]}}),define(Se[314],Ce([1,0,21,70,4,15,24,2,16,86,81,6,7]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=void 0;class D{constructor(o,n){this.document=o,this.b=n,this.a=1,this.c=new R.$N$b("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,n){await this.f(o).undo(),n||this.disposeBackup()}async redo(o,n){await this.f(o).redo(),n||this.disposeBackup()}disposeEdits(o){for(const n of o)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=C(this.document.uri)+this.a++;return(0,P.$0f)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const n=this.c.get(o,0);if(!n)throw new Error("No edit found");return n}}class S{constructor(){this.a=new Map}get(o,n){return this.a.get(this.b(o,n))}add(o,n,t){const a=this.b(o,n.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${o} resource:${n.uri}`);const g=new D(n,t);return this.a.set(a,g),g}delete(o,n){const t=this.b(o,n.uri);this.a.delete(t)}b(o,n){return`${o}@@@${n}`}}var p;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(p||(p={}));class r{constructor(){this.a=new Map}addTextProvider(o,n,t){return this.b(0,o,n,t)}addCustomProvider(o,n,t){return this.b(1,o,n,t)}get(o){return this.a.get(o)}b(o,n,t,a){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:o,extension:t,provider:a}),new $.$DJ(()=>this.a.delete(n))}}class s{constructor(o,n,t,a,g){this.d=n,this.f=t,this.g=a,this.h=g,this.b=new r,this.c=new S,this.a=o.getProxy(I.$BJ.MainThreadCustomEditors)}registerCustomEditorProvider(o,n,t,a){const g=new h.$kb;return f(t)?(g.add(this.b.addTextProvider(n,o,t)),this.a.$registerTextEditorProvider((0,b.$U_b)(o),n,a.webviewOptions||{},{supportsMove:!!t.moveCustomTextEditor},(0,b.$S_b)(o))):(g.add(this.b.addCustomProvider(n,o,t)),c(t)&&g.add(t.onDidChangeCustomDocument(u=>{const d=this.i(n,u.document.uri);if(y(u)){const v=d.addEdit(u);this.a.$onDidEdit(u.document.uri,n,v,u.label)}else this.a.$onContentChange(u.document.uri,n)})),this.a.$registerCustomEditorProvider((0,b.$U_b)(o),n,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,b.$S_b)(o))),$.$DJ.from(g,new $.$DJ(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(o,n,t,a,g){const u=this.b.get(n);if(!u)throw new Error(`No provider found for '${n}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${n}'`);const d=m.URI.revive(o),v=await u.provider.openCustomDocument(d,{backupId:t,untitledDocumentData:a?.buffer},g);let l;return c(u.provider)&&this.f&&(l=this.f.workspaceValue(u.extension)??this.f.globalValue(u.extension)),this.c.add(n,v,l),{editable:c(u.provider)}}async $disposeCustomDocument(o,n){const t=this.b.get(n);if(!t)throw new Error(`No provider found for '${n}'`);if(t.type!==1)throw new Error(`Invalid provider type for '${n}'`);const a=m.URI.revive(o),{document:g}=this.i(n,a);this.c.delete(n,g),g.dispose()}async $resolveCustomEditor(o,n,t,a,g,u){const d=this.b.get(t);if(!d)throw new Error(`No provider found for '${t}'`);const v=E.ViewColumn.to(g),l=this.g.createNewWebview(n,a.contentOptions,d.extension),w=this.h.createNewWebviewPanel(n,t,a.title,v,a.options,l,a.active),L=m.URI.revive(o);switch(d.type){case 1:{const{document:O}=this.i(t,L);return d.provider.resolveCustomEditor(O,w,u)}case 0:{const O=this.d.getDocument(L);return d.provider.resolveCustomTextEditor(O,w,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,n,t){this.i(n,o).disposeEdits(t)}async $onMoveCustomEditor(o,n,t){const a=this.b.get(t);if(!a)throw new Error(`No provider found for '${t}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${t}'`);const g=this.h.getWebviewPanel(o);if(!g)throw new Error("No webview found");const u=m.URI.revive(n),d=this.d.getDocument(u);await a.provider.moveCustomTextEditor(d,g,k.CancellationToken.None)}async $undo(o,n,t,a){return this.i(n,o).undo(t,a)}async $redo(o,n,t,a){return this.i(n,o).redo(t,a)}async $revert(o,n,t){const a=this.i(n,o);await this.j(n).revertCustomDocument(a.document,t),a.disposeBackup()}async $onSave(o,n,t){const a=this.i(n,o);await this.j(n).saveCustomDocument(a.document,t),a.disposeBackup()}async $onSaveAs(o,n,t,a){const g=this.i(n,o);return this.j(n).saveCustomDocumentAs(g.document,m.URI.revive(t),a)}async $backup(o,n,t){const a=this.i(n,o),u=await this.j(n).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},t);return a.updateBackup(u),u.id}i(o,n){const t=this.c.get(o,m.URI.revive(n));if(!t)throw new Error("No custom document found");return t}j(o){const t=this.b.get(o)?.provider;if(!t||!c(t))throw new Error("Custom document is not editable");return t}}e.$uac=s;function c(i){return!!i.onDidChangeCustomDocument}function f(i){return typeof i.resolveCustomTextEditor=="function"}function y(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function C(i){const o=i.scheme===A.Schemas.file||i.scheme===A.Schemas.untitled?i.fsPath:i.toString();return(0,F.$di)(o)+""}}),define(Se[315],Ce([1,0,3,4,2,32,16,86,6,7]),function(fe,e,k,F,h,A,P,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=void 0;class R extends F.$lb{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(S,p,r,s){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new k.$8c),this.onDidDispose=this.#d.event,this.#h=this.B(new k.$8c),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=p,this.#l=r,this.#i=s.viewType,this.#u=s.panelOptions,this.#r=s.viewColumn,this.#n=s.title,this.#a=s.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(S){this.c(),this.#n!==S&&(this.#n=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#s}set iconPath(S){this.c(),this.#s!==S&&(this.#s=S,this.#t.$setIconPath(this.#e,h.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(S){this.#c||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#a=S.active,this.#o=S.visible,this.#r=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,p){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:P.ViewColumn.from(S),preserveFocus:!!p})}c(){if(this.#c)throw new Error("Webview is disposed")}}class I{static c(){return(0,A.$6e)()}constructor(S,p,r){this.g=p,this.h=r,this.e=new Map,this.f=new Map,this.d=S.getProxy(E.$BJ.MainThreadWebviewPanels)}createWebviewPanel(S,p,r,s,c={}){const f=typeof s=="object"?s.viewColumn:s,y={viewColumn:P.ViewColumn.from(f),preserveFocus:typeof s=="object"&&!!s.preserveFocus},C=(0,m.$S_b)(S),i=I.c();this.d.$createWebviewPanel((0,m.$U_b)(S),i,p,{title:r,panelOptions:$(c),webviewOptions:(0,m.$V_b)(S,this.h,c),serializeBuffersForPostMessage:C},y);const o=this.g.createNewWebview(i,c,S);return this.createNewWebviewPanel(i,p,r,f,c,o,!0)}$onDidChangeWebviewPanelViewStates(S){const p=Object.keys(S);p.sort((r,s)=>{const c=S[r],f=S[s];return c.active?1:f.active?-1:+c.visible-+f.visible});for(const r of p){const s=this.getWebviewPanel(r);if(!s)continue;const c=S[r];s._updateViewState({active:c.active,visible:c.visible,viewColumn:P.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.e.delete(S),this.g.deleteWebview(S)}registerWebviewPanelSerializer(S,p,r){if(this.f.has(p))throw new Error(`Serializer for '${p}' already registered`);return this.f.set(p,{serializer:r,extension:S}),this.d.$registerSerializer(p,{serializeBuffersForPostMessage:(0,m.$S_b)(S)}),new b.$DJ(()=>{this.f.delete(p),this.d.$unregisterSerializer(p)})}async $deserializeWebviewPanel(S,p,r,s){const c=this.f.get(p);if(!c)throw new Error(`No serializer found for '${p}'`);const{serializer:f,extension:y}=c,C=this.g.createNewWebview(S,r.webviewOptions,y),i=this.createNewWebviewPanel(S,p,r.title,s,r.panelOptions,C,r.active);await f.deserializeWebviewPanel(i,r.state)}createNewWebviewPanel(S,p,r,s,c,f,y){const C=new R(S,this.d,f,{viewType:p,title:r,viewColumn:s,panelOptions:c,active:y});return this.e.set(S,C),C}getWebviewPanel(S){return this.e.get(S)}}e.$tac=I;function $(D){return{enableFindWidget:D.enableFindWidget,retainContextWhenHidden:D.retainContextWhenHidden}}}),define(Se[316],Ce([1,0,3,4,86,16,6,7]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sac=void 0;class E extends F.$lb{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(I,$,D,S,p,r){super(),this.#u=!1,this.#a=this.B(new k.$8c),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new k.$8c),this.onDidDispose=this.#c.event,this.#i=D,this.#s=S,this.#e=I,this.#t=$,this.#l=p,this.#n=r}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#r}set description(I){this.a(),this.#r!==I&&(this.#r=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#u||(this.#n=I,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(I){this.a(),!(I?.value===this.#o?.value&&I?.tooltip===this.#o?.tooltip)&&(this.#o=A.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#u)throw new Error("Webview is disposed")}}class b{constructor(I,$){this.d=$,this.b=new Map,this.c=new Map,this.a=I.getProxy(P.$BJ.MainThreadWebviewViews)}registerWebviewViewProvider(I,$,D,S){if(this.b.has($))throw new Error(`View provider for '${$}' already registered`);return this.b.set($,{provider:D,extension:I}),this.a.$registerWebviewViewProvider((0,h.$U_b)(I),$,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,h.$S_b)(I)}),new m.$DJ(()=>{this.b.delete($),this.a.$unregisterWebviewViewProvider($)})}async $resolveWebviewView(I,$,D,S,p){const r=this.b.get($);if(!r)throw new Error(`No view provider found for '${$}'`);const{provider:s,extension:c}=r,f=this.d.createNewWebview(I,{},c),y=new E(I,this.a,$,D,f,!0);this.c.set(I,y),await s.resolveWebviewView(y,{state:S},p)}async $onDidChangeWebviewViewVisibility(I,$){this.e(I)._setVisible($)}async $disposeWebviewView(I){const $=this.e(I);this.c.delete(I),$.dispose(),this.d.deleteWebview(I)}e(I){const $=this.c.get(I);if(!$)throw new Error("No webview found");return $}}e.$sac=b}),define(Se[144],Ce([1,0,3,6,2,15,12,5,20,27]),function(fe,e,k,F,h,A,P,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X_b=e.$W_b=void 0;let R=class kn{static{this.a={focused:!0,active:!0}}getState($){const D=this.d;return{get focused(){return D.focused},get active(){return(0,b.$zF)($,"windowActivity"),D.active}}}constructor($){this.c=new k.$8c,this.onDidChangeWindowState=this.c.event,this.d=kn.a,this.b=$.getProxy(F.$BJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:S})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",S)})}$onDidChangeWindowFocus($){this.onDidChangeWindowProperty("focused",$)}$onDidChangeWindowActive($){this.onDidChangeWindowProperty("active",$)}onDidChangeWindowProperty($,D){D!==this.d[$]&&(this.d={...this.d,[$]:D},this.c.fire(this.d))}openUri($,D){let S;if(typeof $=="string"){S=$;try{$=h.URI.parse($)}catch{return Promise.reject(`Invalid uri - '${$}'`)}}return(0,P.$kd)($.scheme)?Promise.reject("Invalid scheme - cannot be empty"):$.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${$.scheme}'`):this.b.$openUri($,S,D)}async asExternalUri($,D){if((0,P.$kd)($.scheme))return Promise.reject("Invalid scheme - cannot be empty");const S=await this.b.$asExternalUri($,D);return h.URI.from(S)}};e.$W_b=R,e.$W_b=R=Je([qe(0,E.$DL)],R),e.$X_b=(0,m.$ph)("IExtHostWindow")}),define(Se[317],Ce([1,0,285,26,20]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qbc=void 0;const A=1024*1024;let P=class extends k.$Rac{constructor(E,b){super(E,b),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,b,R){const I=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),b.apply(console,R),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,b){const R=process[E],I=R.write;let $="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(D,S,p)=>{if(!this.g){$+=D.toString(S);const r=$.length>A?$.length:$.lastIndexOf(`
`);r!==-1&&(console[b]($.slice(0,r)),$=$.slice(r+1))}I.call(R,D,S,p)}})}};e.$qbc=P,e.$qbc=P=Je([qe(0,h.$DL),qe(1,F.$TL)],P)}),define(Se[318],Ce([1,0,63,15,18,229,30,11]),function(fe,e,k,F,h,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=void 0;let E=class{constructor(I,$){I.addFileSystemProvider(F.Schemas.file,new b($),{isCaseSensitive:m.$k})}};e.$rbc=E,e.$rbc=E=Je([qe(0,k.$j_b),qe(1,h.$Ri)],E);class b{constructor(I){this.b=I,this.a=new A.$Rp(this.b)}async stat(I){const $=await this.a.stat(I);return{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===P.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,$,D){return this.a.writeFile(I,$,{...D,unlock:!1,atomic:!1})}delete(I,$){return this.a.delete(I,{...$,useTrash:!1,atomic:!1})}rename(I,$,D){return this.a.rename(I,$,D)}copy(I,$,D){return this.a.copy(I,$,D)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,$){throw new Error("Method not implemented.")}}}),define(Se[319],Ce([1,0,13,75,32,36,4,6,2,20]),function(fe,e,k,F,h,A,P,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=void 0;let R=class extends P.$lb{constructor($,D){super();const S=$.getProxy(m.$BJ.MainThreadDownloadService);D.registerCommand(!1,"_workbench.downloadResource",async p=>{const r=E.URI.file((0,k.$ac)((0,F.tmpdir)(),(0,h.$6e)()));return await S.$download(p,r),r})}};e.$pbc=R,e.$pbc=R=Je([qe(0,b.$DL),qe(1,A.$ZL)],R)}),define(Se[320],Ce([1,0,143,15,231,32]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=void 0;class P extends k.$Qac{m(E,b,R){return E.scheme===F.Schemas.file?new h.$PM(R?.name||(0,A.$6e)(),E.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,b):super.m(E,b,R)}registerLogger(E){super.registerLogger(E),this.n.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.n.$deregisterLogger(E)}}e.$Cbc=P}),define(Se[321],Ce([1,0,49,13,2,85,4,15,17,29]),function(fe,e,k,F,h,A,P,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=void 0;class R extends A.$l_b{constructor(){super(...arguments),this.i=null}async g(i){const o=await super.g(i);if(o.scheme!==m.Schemas.file)return o;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const n=o.fsPath;let t=0;do{let a;t===0?a=n:a=/[/\\]$/.test(n)?`${n.substr(0,n.length-1)}-${t}`:`${n}-${t}`,await I(a);const g=F.$ac(a,"vscode.lock"),u=await p(this.d,g,!1);if(u)return this.i=u,process.on("exit",()=>{u.dispose()}),h.URI.file(a);t++}while(t<10);return o}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Bbc=R;async function I(C){try{await b.Promises.stat(C);return}catch{}try{await b.Promises.mkdir(C,{recursive:!0})}catch{}}const $=1e3,D=10*60*1e3;class S extends P.$lb{constructor(i,o){super(),this.b=i,this.c=o,this.a=this.B(new E.$Fg),this.a.cancelAndSet(async()=>{const n=await r(i,o);(!n||n.pid!==process.pid)&&(i.info(`Lock '${o}': The lock was lost unexpectedly.`),this.a.cancel());try{await b.Promises.utimes(o,new Date,new Date)}catch(t){i.error(t),i.info(`Lock '${o}': Could not update mtime.`)}},$)}dispose(){super.dispose();try{k.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+i};await b.Promises.writeFile(this.c,JSON.stringify(o),{flag:"w"})}catch(o){this.b.error(o)}}}async function p(C,i,o){try{const t={pid:process.pid,willReleaseAt:0};await b.Promises.writeFile(i,JSON.stringify(t),{flag:"wx"})}catch(t){C.error(t)}const n=await r(C,i);return!n||n.pid!==process.pid?o?(C.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(C.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),f(C,i)):(C.info(`Lock '${i}': Lock acquired.`),new S(C,i))}async function r(C,i){let o;try{o=await b.Promises.readFile(i)}catch(n){return C.error(n),null}try{return JSON.parse(String(o))}catch(n){return C.error(n),null}}async function s(C,i){let o;try{o=await b.Promises.stat(i)}catch(n){return C.error(n),0}return o.mtime.getTime()}function c(C){try{return process.kill(C,0),!0}catch{return!1}}async function f(C,i){const o=await r(C,i);if(!o)return C.info(`Lock '${i}': Could not read pid of lock holder.`),y(C,i);if(o.willReleaseAt){let u=o.willReleaseAt-Date.now();if(u<5e3){for(u>0?C.info(`Lock '${i}': The lockfile is scheduled to be released in ${u} ms.`):C.info(`Lock '${i}': The lockfile is scheduled to have been released.`);u>0;){if(await(0,E.$wg)(Math.min(100,u)),await s(C,i)===0)return y(C,i);u=o.willReleaseAt-Date.now()}return y(C,i)}}if(!c(o.pid))return C.info(`Lock '${i}': The pid ${o.pid} appears to be gone.`),y(C,i);const n=await s(C,i),t=Date.now()-n;if(t<=D)return C.info(`Lock '${i}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;C.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,E.$wg)(2e3);const a=await s(C,i),g=Date.now()-a;return g<=D?(C.info(`Lock '${i}': The lock does not look stale, elapsed: ${g} ms, giving up.`),null):(C.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),y(C,i))}async function y(C,i){C.info(`Lock '${i}': Deleting a stale lock.`);try{await b.Promises.unlink(i)}catch{}return p(C,i,!0)}}),define(Se[322],Ce([1,0,32,20,43]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=void 0;let A=class extends h.$o_b{constructor(m){super(!0,m)}createTerminal(m,E,b){return this.createTerminalFromOptions({name:m,shellPath:E,shellArgs:b})}createTerminalFromOptions(m,E){const b=new h.$n_b(this.a,(0,k.$6e)(),m,m.name);return this.f.push(b),b.create(m,this.J(m,E)),b.value}};e.$Wac=A,e.$Wac=A=Je([qe(0,F.$DL)],A)}),define(Se[323],Ce([1,0,46,112,11,24,2,29,18,132,26,20,64]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=e.$zbc=e.$ybc=e.$xbc=e.$wbc=e.$vbc=e.$ubc=e.$tbc=void 0;function D(i){const o=i.trim().split(`
`),n=[];return o.forEach(a=>{const g=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(a);g&&g.length>=3&&n.push({pid:parseInt(g[1],10),socket:parseInt(g[2],10)})}),n.reduce((a,g)=>(a[g.socket]=g,a),{})}e.$tbc=D;function S(...i){const o=[].concat(...i.map(r));return[...new Map(o.filter(n=>n.st==="0A").map(n=>{const t=n.local_address.split(":");return{socket:parseInt(n.inode,10),ip:p(t[0]),port:parseInt(t[1],16)}}).map(n=>[n.ip+":"+n.port,n])).values()]}e.$ubc=S;function p(i){let o="";if(i.length===8)for(let n=i.length-2;n>=0;n-=2)o+=parseInt(i.substr(n,2),16),n!==0&&(o+=".");else for(let n=0;n<i.length;n+=8){const t=i.substring(n,n+8);let a="";for(let g=8;g>=2;g-=2)a+=t.substring(g-2,g),(g===6||g===2)&&(a=parseInt(a,16).toString(16),o+=`${a}`,a="",n+g!==i.length-6&&(o+=":"))}return o}e.$vbc=p;function r(i){const o=i.trim().split(`
`),n=o.shift().trim().split(/\s+/).filter(a=>a!=="rx_queue"&&a!=="tm->when");return o.map(a=>a.trim().split(/\s+/).reduce((g,u,d)=>(g[n[d]||d]=u,g),{}))}e.$wbc=r;function s(i){return!!i.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||i.indexOf("out/server-main.js")!==-1||i.indexOf("_productName=VSCode")!==-1}function c(i){const o=i.trim().split(`
`),n=[];return o.forEach(t=>{const a=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(t);a&&a.length>=4&&n.push({pid:parseInt(a[1],10),ppid:parseInt(a[2]),cmd:a[3]})}),n}e.$xbc=c;async function f(i,o,n){const t=n.reduce((g,u)=>(g[u.pid]=u,g),{}),a=[];return i.forEach(({socket:g,ip:u,port:d})=>{const v=o[g]?o[g].pid:void 0,l=v?t[v]?.cmd:void 0;v&&l&&!s(l)&&a.push({host:u,port:d,detail:l,pid:v})}),a}e.$ybc=f;function y(i,o,n){const t=new Map,a=c(o);for(const g of i){const u=n.get(g.port);if(u){t.set(g.port,u);continue}const d=a.find(v=>v.cmd.includes(`${g.port}`));if(d){let v=d,l;do l=a.find(w=>w.ppid===v.pid),l&&(v=l);while(l);t.set(g.port,{host:g.ip,port:g.port,pid:v.pid,detail:v.cmd,ppid:v.ppid})}else t.set(g.port,{host:g.ip,port:g.port,ppid:Number.MAX_VALUE})}return t}e.$zbc=y;let C=class extends $.$Xpb{constructor(o,n,t){super(o,n,t),this.r=void 0,this.s=new Map,this.t=!1,h.$k&&n.remote.isRemote&&n.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.v())}async $registerCandidateFinder(o){if(o&&this.t)return;this.t=o;let n;this.r&&(n=this.r,await this.a.$onFoundNewCandidates(this.r));const t=new F.$wl;let a=0;for(;this.t;){const g=new Date().getTime(),u=(await this.w()).filter(l=>(0,b.$Kz)(l.host)||(0,b.$Mz)(l.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${u.map(l=>l.port).join(", ")}`);const d=new Date().getTime()-g;this.n.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${d} ms.`),a++>3&&t.update(d),(!n||JSON.stringify(n)!==JSON.stringify(u))&&(n=u,await this.a.$onFoundNewCandidates(n));const v=this.u(t.value);this.n.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${v} ms.`),await new Promise(l=>setTimeout(()=>l(),v))}}u(o){return Math.max(o*20,2e3)}async v(){this.r=await this.w(),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.r.map(o=>o.port).join(", ")}`)}async w(){let o="",n="";try{o=await m.Promises.readFile("/proc/net/tcp","utf8"),n=await m.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const t=S(o,n),a=await new Promise(O=>{(0,k.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(N,T,j)=>{O(T)})}),g=D(a),u=await m.Promises.readdir("/proc"),d=[];for(const O of u)try{const N=Number(O),T=A.$0f(P.URI.file("/proc"),O);if((await m.Promises.stat(T.fsPath)).isDirectory()&&!isNaN(N)){const W=await m.Promises.readlink(A.$0f(T,"cwd").fsPath),M=await m.Promises.readFile(A.$0f(T,"cmdline").fsPath,"utf8");d.push({pid:N,cwd:W,cmd:M})}}catch{}const v=[],l=t.filter(O=>{const N=g[O.socket];return N||v.push(O),N}),w=f(l,g,d);let L;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${v.length}`),v.length>0){const O=await new Promise(N=>{(0,k.exec)("ps -F -A -l | grep root",(T,j,W)=>{N(j)})});this.s=y(v,O,this.s),L=Array.from(this.s.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${L.map(N=>N.port).join(", ")}`)}return w.then(O=>L?O.concat(L):O)}};e.$Abc=C,e.$Abc=C=Je([qe(0,I.$DL),qe(1,R.$TL),qe(2,E.$Ri)],C)}),define(Se[324],Ce([1,0,17,22,21,8,3,4,121,278,60]),function(fe,e,k,F,h,A,P,m,E,b,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$A1b=e.ResponsiveState=e.RequestInitiator=e.$z1b=e.$y1b=void 0;function $(l,w){try{return JSON.stringify(l,w)}catch{return"null"}}const D="$$ref$$",S={[D]:-1};class p{constructor(w,L){this.jsonString=w,this.referencedBuffers=L}}function r(l,w=null,L=!1){const O=[];return{jsonString:(L?$:JSON.stringify)(l,(T,j)=>{if(typeof j>"u")return S;if(typeof j=="object"){if(j instanceof F.$Jb){const W=O.push(j)-1;return{[D]:W}}if(w)return w(T,j)}return j}),referencedBuffers:O}}e.$y1b=r;function s(l,w,L){return JSON.parse(l,(O,N)=>{if(N){const T=N[D];if(typeof T=="number")return w[T];if(L&&N.$mid===1)return L.transformIncoming(N)}return N})}e.$z1b=s;function c(l,w){return JSON.stringify(l,w)}function f(l){return l?(w,L)=>L&&L.$mid===1?l.transformOutgoing(L):L:null}var y;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));var C;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})(C||(e.ResponsiveState=C={}));const i=()=>{},o=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class t extends m.$lb{static{I=o}static{this.a=3*1e3}constructor(w,L=null,O=null){super(),this[I]=!0,this.b=this.B(new P.$8c),this.onDidChangeResponsiveState=this.b.event,this.c=w,this.f=L,this.g=O,this.h=f(this.g),this.j=!1,this.k=[],this.l=[];for(let N=0,T=R.$Vz.count;N<T;N++)this.k[N]=null,this.l[N]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new k.$Gg(()=>this.C(),1e3)),this.c.onMessage(N=>this.G(N))}dispose(){this.j=!0,Object.keys(this.s).forEach(w=>{this.s[w].resolveErr(A.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(w){this.u===0&&(this.v=Date.now()+t.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(w){this.v=Date.now()+t.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(w){this.t!==w&&(this.t=w,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(w){return this.g?(0,E.$qm)(w,this.g):w}getProxy(w){const{nid:L,sid:O}=w;return this.l[L]||(this.l[L]=this.F(L,O)),this.l[L]}F(w,L){const O={get:(N,T)=>(typeof T=="string"&&!N[T]&&T.charCodeAt(0)===36&&(N[T]=(...j)=>this.O(w,T,j)),T===n?L:N[T])};return new Proxy(Object.create(null),O)}set(w,L){return this.k[w.nid]=L,L}assertRegistered(w){for(let L=0,O=w.length;L<O;L++){const N=w[L];if(!this.k[N.nid])throw new Error(`Missing proxy instance ${N.sid}`)}}G(w){if(this.j)return;const L=w.byteLength,O=a.read(w,0),N=O.readUInt8(),T=O.readUInt32();switch(N){case 1:case 2:{let{rpcId:j,method:W,args:M}=u.deserializeRequestJSONArgs(O);this.g&&(M=(0,E.$qm)(M,this.g)),this.H(L,T,j,W,M,N===2);break}case 3:case 4:{let{rpcId:j,method:W,args:M}=u.deserializeRequestMixedArgs(O);this.g&&(M=(0,E.$qm)(M,this.g)),this.H(L,T,j,W,M,N===4);break}case 5:{this.f?.logIncoming(L,T,0,"ack"),this.z(T);break}case 6:{this.I(L,T);break}case 7:{this.J(L,T,void 0);break}case 9:{let j=u.deserializeReplyOKJSON(O);this.g&&(j=(0,E.$qm)(j,this.g)),this.J(L,T,j);break}case 10:{const j=u.deserializeReplyOKJSONWithBuffers(O,this.g);this.J(L,T,j);break}case 8:{const j=u.deserializeReplyOKVSBuffer(O);this.J(L,T,j);break}case 11:{let j=u.deserializeReplyErrError(O);this.g&&(j=(0,E.$qm)(j,this.g)),this.L(L,T,j);break}case 12:{this.L(L,T,void 0);break}default:console.error("received unexpected message"),console.error(w)}}H(w,L,O,N,T,j){this.f?.logIncoming(w,L,1,`receiveRequest ${(0,R.$Xz)(O)}.${N}(`,T);const W=String(L);let M,Y;if(j){const de=new h.$ed;T.push(de.token),M=this.M(O,N,T),Y=()=>de.cancel()}else M=this.M(O,N,T),Y=i;this.p[W]=Y;const V=u.serializeAcknowledged(L);this.f?.logOutgoing(V.byteLength,L,1,"ack"),this.c.send(V),M.then(de=>{delete this.p[W];const re=u.serializeReplyOK(L,de,this.h);this.f?.logOutgoing(re.byteLength,L,1,"reply:",de),this.c.send(re)},de=>{delete this.p[W];const re=u.serializeReplyErr(L,de);this.f?.logOutgoing(re.byteLength,L,1,"replyErr:",de),this.c.send(re)})}I(w,L){this.f?.logIncoming(w,L,1,"receiveCancel");const O=String(L);this.p[O]?.()}J(w,L,O){this.f?.logIncoming(w,L,0,"receiveReply:",O);const N=String(L);if(!this.s.hasOwnProperty(N))return;const T=this.s[N];delete this.s[N],T.resolveOk(O)}L(w,L,O){this.f?.logIncoming(w,L,0,"receiveReplyErr:",O);const N=String(L);if(!this.s.hasOwnProperty(N))return;const T=this.s[N];delete this.s[N];let j;O&&(O.$isError?(j=new Error,j.name=O.name,j.message=O.message,j.stack=O.stack):j=O),T.resolveErr(j)}M(w,L,O){try{return Promise.resolve(this.N(w,L,O))}catch(N){return Promise.reject(N)}}N(w,L,O){const N=this.k[w];if(!N)throw new Error("Unknown actor "+(0,R.$Xz)(w));const T=N[L];if(typeof T!="function")throw new Error("Unknown method "+L+" on actor "+(0,R.$Xz)(w));return T.apply(N,O)}O(w,L,O){if(this.j)return new b.$x1b;let N=null;if(O.length>0&&h.CancellationToken.isCancellationToken(O[O.length-1])&&(N=O.pop()),N&&N.isCancellationRequested)return Promise.reject(A.$4());const T=u.serializeRequestArguments(O,this.h),j=++this.m,W=String(j),M=new b.$w1b;N&&N.onCancellationRequested(()=>{const V=u.serializeCancel(j);this.f?.logOutgoing(V.byteLength,j,0,"cancel"),this.c.send(u.serializeCancel(j))}),this.s[W]=M,this.y(j);const Y=u.serializeRequest(j,w,L,T,!!N);return this.f?.logOutgoing(Y.byteLength,j,0,`request: ${(0,R.$Xz)(w)}.${L}(`,O),this.c.send(Y),M}}e.$A1b=t;class a{static alloc(w,L,O){const N=new a(F.$Jb.alloc(O+1+4),0);return N.writeUInt8(w),N.writeUInt32(L),N}static read(w,L){return new a(w,L)}get buffer(){return this.a}constructor(w,L){this.a=w,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(w){this.a.writeUInt8(w,this.b),this.b+=1}readUInt8(){const w=this.a.readUInt8(this.b);return this.b+=1,w}writeUInt32(w){this.a.writeUInt32BE(w,this.b),this.b+=4}readUInt32(){const w=this.a.readUInt32BE(this.b);return this.b+=4,w}static sizeShortString(w){return 1+w.byteLength}writeShortString(w){this.a.writeUInt8(w.byteLength,this.b),this.b+=1,this.a.set(w,this.b),this.b+=w.byteLength}readShortString(){const w=this.a.readUInt8(this.b);this.b+=1;const O=this.a.slice(this.b,this.b+w).toString();return this.b+=w,O}static sizeLongString(w){return 4+w.byteLength}writeLongString(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readLongString(){const w=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+w).toString();return this.b+=w,O}writeBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}static sizeVSBuffer(w){return 4+w.byteLength}writeVSBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readVSBuffer(){const w=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+w);return this.b+=w,L}static sizeMixedArray(w){let L=0;L+=1;for(let O=0,N=w.length;O<N;O++){const T=w[O];switch(L+=1,T.type){case 1:L+=this.sizeLongString(T.value);break;case 2:L+=this.sizeVSBuffer(T.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(T.value);for(let j=0;j<T.buffers.length;++j)L+=this.sizeVSBuffer(T.buffers[j]);break;case 4:break}}return L}writeMixedArray(w){this.a.writeUInt8(w.length,this.b),this.b+=1;for(let L=0,O=w.length;L<O;L++){const N=w[L];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let T=0;T<N.buffers.length;++T)this.writeBuffer(N.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const w=this.a.readUInt8(this.b);this.b+=1;const L=new Array(w);for(let O=0;O<w;O++)switch(this.readUInt8()){case 1:L[O]=this.readLongString();break;case 2:L[O]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),j=this.readLongString(),W=[];for(let M=0;M<T;++M)W.push(this.readVSBuffer());L[O]=new R.$Yz(s(j,W,null));break}case 4:L[O]=void 0;break}return L}}var g;(function(l){l[l.Simple=0]="Simple",l[l.Mixed=1]="Mixed"})(g||(g={}));class u{static a(w){for(let L=0,O=w.length;L<O;L++)if(w[L]instanceof F.$Jb||w[L]instanceof R.$Yz||typeof w[L]>"u")return!0;return!1}static serializeRequestArguments(w,L){if(this.a(w)){const O=[];for(let N=0,T=w.length;N<T;N++){const j=w[N];if(j instanceof F.$Jb)O[N]={type:2,value:j};else if(typeof j>"u")O[N]={type:4};else if(j instanceof R.$Yz){const{jsonString:W,referencedBuffers:M}=r(j.value,L);O[N]={type:3,value:F.$Jb.fromString(W),buffers:M}}else O[N]={type:1,value:F.$Jb.fromString(c(j,L))}}return{type:1,args:O}}return{type:0,args:c(w,L)}}static serializeRequest(w,L,O,N,T){switch(N.type){case 0:return this.b(w,L,O,N.args,T);case 1:return this.c(w,L,O,N.args,T)}}static b(w,L,O,N,T){const j=F.$Jb.fromString(O),W=F.$Jb.fromString(N);let M=0;M+=a.sizeUInt8(),M+=a.sizeShortString(j),M+=a.sizeLongString(W);const Y=a.alloc(T?2:1,w,M);return Y.writeUInt8(L),Y.writeShortString(j),Y.writeLongString(W),Y.buffer}static deserializeRequestJSONArgs(w){const L=w.readUInt8(),O=w.readShortString(),N=w.readLongString();return{rpcId:L,method:O,args:JSON.parse(N)}}static c(w,L,O,N,T){const j=F.$Jb.fromString(O);let W=0;W+=a.sizeUInt8(),W+=a.sizeShortString(j),W+=a.sizeMixedArray(N);const M=a.alloc(T?4:3,w,W);return M.writeUInt8(L),M.writeShortString(j),M.writeMixedArray(N),M.buffer}static deserializeRequestMixedArgs(w){const L=w.readUInt8(),O=w.readShortString(),N=w.readMixedArray(),T=new Array(N.length);for(let j=0,W=N.length;j<W;j++){const M=N[j];typeof M=="string"?T[j]=JSON.parse(M):T[j]=M}return{rpcId:L,method:O,args:T}}static serializeAcknowledged(w){return a.alloc(5,w,0).buffer}static serializeCancel(w){return a.alloc(6,w,0).buffer}static serializeReplyOK(w,L,O){if(typeof L>"u")return this.d(w);if(L instanceof F.$Jb)return this.e(w,L);if(L instanceof R.$Yz){const{jsonString:N,referencedBuffers:T}=r(L.value,O,!0);return this.g(w,N,T)}else return this.f(w,$(L,O))}static d(w){return a.alloc(7,w,0).buffer}static e(w,L){let O=0;O+=a.sizeVSBuffer(L);const N=a.alloc(8,w,O);return N.writeVSBuffer(L),N.buffer}static deserializeReplyOKVSBuffer(w){return w.readVSBuffer()}static f(w,L){const O=F.$Jb.fromString(L);let N=0;N+=a.sizeLongString(O);const T=a.alloc(9,w,N);return T.writeLongString(O),T.buffer}static g(w,L,O){const N=F.$Jb.fromString(L);let T=0;T+=a.sizeUInt32,T+=a.sizeLongString(N);for(const W of O)T+=a.sizeVSBuffer(W);const j=a.alloc(10,w,T);j.writeUInt32(O.length),j.writeLongString(N);for(const W of O)j.writeBuffer(W);return j.buffer}static deserializeReplyOKJSON(w){const L=w.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(w,L){const O=w.readUInt32(),N=w.readLongString(),T=[];for(let j=0;j<O;++j)T.push(w.readVSBuffer());return new R.$Yz(s(N,T,L))}static serializeReplyErr(w,L){const O=L?$(A.$1(L),null):void 0;if(typeof O!="string")return this.h(w);const N=F.$Jb.fromString(O);let T=0;T+=a.sizeLongString(N);const j=a.alloc(11,w,T);return j.writeLongString(N),j.buffer}static deserializeReplyErrError(w){const L=w.readLongString();return JSON.parse(L)}static h(w){return a.alloc(12,w,0).buffer}}var d;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",l[l.ReplyErrError=11]="ReplyErrError",l[l.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var v;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",l[l.Undefined=4]="Undefined"})(v||(v={}))}),define(Se[325],Ce([1,0,3,42,47,5]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QI=e.$PI=e.OutputChannelUpdateMode=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=void 0,e.$EI="text/x-code-output",e.$FI="output",e.$GI="Log",e.$HI="text/x-code-log-output",e.$II="log",e.$JI="log",e.$KI="workbench.panel.output",e.$LI=new h.$Oi("inOutput",!1),e.$MI=new h.$Oi("activeLogOutput",!1),e.$NI=new h.$Oi("outputView.scrollLock",!1),e.$OI=(0,A.$ph)("outputService");var P;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(P||(e.OutputChannelUpdateMode=P={})),e.$PI={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new k.$8c,this.onDidRegisterChannel=this.b.event,this.c=new k.$8c,this.onDidRemoveChannel=this.c.event}registerChannel(b){this.a.has(b.id)||(this.a.set(b.id,b),this.b.fire(b.id))}getChannels(){const b=[];return this.a.forEach(R=>b.push(R)),b}getChannel(b){return this.a.get(b)}removeChannel(b){this.a.delete(b),this.c.fire(b)}}F.$Tm.add(e.$PI.OutputChannels,new m),e.$QI=new h.$Oi("activeOutputChannel","")}),define(Se[145],Ce([1,0,6,5,20,25,18,325,63,26,51,171,22,14,30,3,4]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H_b=e.$G_b=void 0;class s extends P.$Xi{get disposed(){return this.l}constructor(C,i,o,n,t){super(),this.id=C,this.name=i,this.m=o,this.n=n,this.extension=t,this.k=0,this.l=!1,this.visible=!1,this.setLevel(o.getLevel()),this.B(o.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(C){this.append(C+`
`)}append(C){this.info(C)}clear(){const C=this.k;this.m.flush(),this.n.$update(this.id,m.OutputChannelUpdateMode.Clear,C)}replace(C){const i=this.k;this.info(C),this.n.$update(this.id,m.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(C,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof C=="boolean"?C:i))}hide(){this.n.$close(this.id)}g(C,i){this.k+=$.$Jb.fromString(i).byteLength,(0,P.log)(this.m,C,i),this.visible&&(this.m.flush(),this.n.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class c extends s{appendLine(C){this.append(C)}}let f=class{constructor(C,i,o,n,t,a){this.i=i,this.j=o,this.k=n,this.l=t,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=C.getProxy(k.$BJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,I.$Sl)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(C){this.h=C;for(const[i,o]of this.g)o.visible=i===this.h}createOutputChannel(C,i,o){if(C=C.trim(),!C)throw new Error("illegal argument `name`. must not be falsy");const n=typeof i=="object"&&i.log,t=(0,D.$je)(i)?i:void 0;if((0,D.$je)(t)&&!t.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const g=this.i.environment.extensionLogLevel?.find(([d])=>A.$Hl.equals(o.identifier,d))?.[1];g&&(a=(0,P.$8i)(g));const u=n?this.o(C,a,o):this.n(C,t,o);return u.then(d=>{this.g.set(d.id,d),d.visible=d.id===this.h}),n?this.r(C,a??this.m.getLevel(),u):this.q(C,u)}async n(C,i,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,t=this.k.extUri.joinPath(n,`${this.f++}-${C.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(t,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.a.$register(C,t,i,o.identifier.value);return new s(g,C,a,this.a,o)}async o(C,i,o){const n=await this.p(o),t=C.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(n,`${t}.log`),g=`${o.identifier.value}.${t}`,u=this.l.createLogger(a,{id:g,name:C,logLevel:i,extensionId:o.identifier.value});return new c(g,C,u,this.a,o)}p(C){let i=this.d.get(C.identifier.value);if(!i){const o=this.k.extUri.joinPath(this.i.logsLocation,C.identifier.value);this.d.set(C.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(o)}catch(n){if((0,S.$8j)(n)!==S.FileSystemProviderErrorCode.FileExists)throw n}return o})())}return i}q(C,i){let o=!1;const n=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return C},append(t){n(),i.then(a=>a.append(t))},appendLine(t){n(),i.then(a=>a.appendLine(t))},clear(){n(),i.then(t=>t.clear())},replace(t){n(),i.then(a=>a.replace(t))},show(t,a){n(),i.then(g=>g.show(t,a))},hide(){n(),i.then(t=>t.hide())},dispose(){o=!0,i.then(t=>t.dispose())}}}r(C,i,o){const n=new r.$kb,t=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},a=n.add(new p.$8c);function g(u){i=u,a.fire(u)}return o.then(u=>{n.add(u),u.logLevel!==i&&g(u.logLevel),n.add(u.onDidChangeLogLevel(d=>g(d)))}),{...this.q(C,o),get logLevel(){return i},onDidChangeLogLevel:a.event,trace(u,...d){t(),o.then(v=>v.trace(u,...d))},debug(u,...d){t(),o.then(v=>v.debug(u,...d))},info(u,...d){t(),o.then(v=>v.info(u,...d))},warn(u,...d){t(),o.then(v=>v.warn(u,...d))},error(u,...d){t(),o.then(v=>v.error(u,...d))},dispose(){n.dispose()}}}};e.$G_b=f,e.$G_b=f=Je([qe(0,h.$DL),qe(1,b.$TL),qe(2,E.$j_b),qe(3,R.$Q$b),qe(4,P.$Si),qe(5,P.$Ri)],f),e.$H_b=(0,F.$ph)("IExtHostOutputService")}),define(Se[326],Ce([1,0,5,17]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=void 0,e.$8l=(0,k.$ph)("remoteAgentService"),e.$9l=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(h){let A=1/0;for(let m=0;m<this.maxSampleCount;m++){const E=await h.getRoundTripTime();if(E===void 0)return;A=Math.min(A,E/2),await(0,F.$wg)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let P;return this.initial.length<this.maxInitialCount?this.initial.push(A):P=this.initial.reduce((m,E)=>m+E,0)/this.initial.length,this.lastMeasurement={initial:P,current:A,average:this.average.reduce((m,E)=>m+E,0)/this.average.length,high:(()=>typeof P>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>P*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Se[327],Ce([1,0,31,15,13,11,24,2,5,245,50,270,326]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eJ=e.$dJ=void 0,e.$dJ=(0,E.$ph)("pathService");let D=class Dn{constructor(p,r,s,c){this.d=p,this.e=r,this.f=s,this.g=c,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const f=await this.e.getEnvironment();return this.c=f?.userHome??p})()}hasValidBasename(p,r,s){return typeof r=="string"||typeof r>"u"?this.a.then(c=>this.h(p,c,r)):this.h(p,r,s)}h(p,r,s){return p.scheme===F.Schemas.file||p.scheme===F.Schemas.vscodeRemote?(0,k.$Ie)(s??(0,P.$7f)(p),r===1):!0}get defaultUriScheme(){return Dn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(p,r){if(p.remoteAuthority)return F.Schemas.vscodeRemote;const s=(0,b.$aJ)(r.getWorkspace());if(s)return s;const c=r.getWorkspace().folders[0];if(c)return c.uri.scheme;const f=r.getWorkspace().configuration;return f?f.scheme:F.Schemas.file}userHome(p){return p?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(p=>p===1?h.$9b:h.$0b)}async fileURI(p){let r="";if(await this.a===1&&(p=p.replace(/\\/g,"/")),p[0]==="/"&&p[1]==="/"){const c=p.indexOf("/",2);c===-1?(r=p.substring(2),p="/"):(r=p.substring(2,c),p=p.substring(c)||"/")}return m.URI.from({scheme:F.Schemas.file,authority:r,path:p,query:"",fragment:""})}};e.$eJ=D,e.$eJ=D=Je([qe(1,$.$8l),qe(2,I.$RI),qe(3,R.$yh)],D)}),define(Se[87],Ce([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$TH=e.$SH=void 0;class k{constructor(P,m){this.line=P,this.character=m}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,m){return new k(0,0)}with(P){return new k(0,0)}}e.$SH=k;class F{constructor(P,m,E,b){this.isEmpty=!1,this.isSingleLine=!1,this.start=new k(P,m),this.end=new k(E,b)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new F(0,0,0,0)}with(P){return new F(0,0,0,0)}}e.$TH=F;var h;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(h||(e.TextSearchCompleteMessageType=h={}))}),define(Se[35],Ce([1,0,19,34,23,31,12,5,13,8,87,17]),function(fe,e,k,F,h,A,P,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.SearchErrorCode=e.$8H=e.$7H=e.SearchSortOrder=e.ViewMode=e.$6H=e.$5H=e.$4H=e.$3H=e.SearchCompletionExitCode=e.$2H=e.$1H=e.$ZH=e.QueryType=e.SearchProviderType=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$UH="workbench.view.search",e.$VH="workbench.panel.search",e.$WH="workbench.view.search",e.$XH="search.exclude";const $="\u27EA ",D=" characters skipped \u27EB",S=($.length+D.length+5)*2;e.$YH=(0,m.$ph)("searchService");var p;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(p||(e.SearchProviderType=p={}));var r;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(r||(e.QueryType=r={}));function s(q){return!!q.preview}e.$ZH=s;function c(q){return!!q.resource}e.$1H=c;function f(q){return!!q.message}e.$2H=f;var y;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(y||(e.SearchCompletionExitCode=y={}));class C{constructor(ne){this.resource=ne,this.results=[]}}e.$3H=C;class i{constructor(ne,pe,H,ue){this.ranges=pe,this.webviewIndex=ue;const ce=Array.isArray(pe)?pe:[pe];if(H&&H.matchLines===1&&o(ce)){ne=(0,P.$ce)(ne,H.matchLines);let z="",ie=0,Ee=0;const Re=Math.floor(H.charsPerLine/5),ye=[];for(const X of ce){const he=Math.max(X.startColumn-Re,0),K=X.startColumn+H.charsPerLine;if(he>Ee+Re+S){const oe=$+(he-Ee)+D;z+=oe+ne.slice(he,K),ie+=he-(Ee+oe.length)}else z+=ne.slice(Ee,K);ye.push(new t(0,X.startColumn-ie,X.endColumn-ie)),Ee=K}this.preview={text:z,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const z=Array.isArray(pe)?pe[0].startLineNumber:pe.startLineNumber;this.preview={text:ne,matches:(0,k.$If)(pe,ie=>new n(ie.startLineNumber-z,ie.startColumn,ie.endLineNumber-z,ie.endColumn))}}}}e.$4H=i;function o(q){const ne=q[0].startLineNumber;for(const pe of q)if(pe.startLineNumber!==ne||pe.endLineNumber!==ne)return!1;return!0}class n{constructor(ne,pe,H,ue){this.startLineNumber=ne,this.startColumn=pe,this.endLineNumber=H,this.endColumn=ue}}e.$5H=n;class t extends n{constructor(ne,pe,H){super(ne,pe,ne,H)}}e.$6H=t;var a;(function(q){q.List="list",q.Tree="tree"})(a||(e.ViewMode=a={}));var g;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(g||(e.SearchSortOrder=g={}));function u(q,ne=!0){const pe=q&&q.files&&q.files.exclude,H=ne&&q&&q.search&&q.search.exclude;if(!pe&&!H)return;if(!pe||!H)return pe||H;let ue=Object.create(null);return ue=h.$Km(ue,h.$Hm(pe)),ue=h.$Km(ue,h.$Hm(H),!0),ue}e.$7H=u;function d(q,ne){return q.excludePattern&&F.$dj(q.excludePattern,ne)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&F.$dj(q.includePattern,ne)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(pe=>{const H=pe.folder.fsPath;if(A.$Ke(ne,H)){const ue=E.$cc(H,ne);return!pe.includePattern||!!F.$dj(pe.includePattern,ue)}else return!1}):!1:!0}e.$8H=d;var v;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class l extends Error{constructor(ne,pe){super(ne),this.code=pe}}e.$9H=l;function w(q){const ne=q.message;if((0,b.$2)(q))return new l(ne,v.canceled);try{const pe=JSON.parse(ne);return new l(pe.message,pe.code)}catch{return new l(ne,v.other)}}e.$0H=w;function L(q){const ne={message:q.message,code:q.code};return new Error(JSON.stringify(ne))}e.$$H=L;function O(q){return q.type==="error"?!0:q.type==="success"}e.$_H=O;function N(q){return q.type==="success"}e.$aI=N;function T(q){return!!q.path}e.$bI=T;function j(q,ne){const pe=q.searchPath?q.searchPath:q.relativePath;return(0,P.$_d)(pe,ne)}e.$cI=j;class W{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$dI=W;function M(q,ne){const pe={...q||{},...ne||{}};return Object.keys(pe).filter(H=>{const ue=pe[H];return typeof ue=="boolean"&&ue})}e.$eI=M;class Y{constructor(ne,pe){this.c=null,this.a={...ne.excludePattern||{},...pe.excludePattern||{}},this.b=F.$ej(this.a);let H=ne.includePattern;pe.includePattern&&(H?H={...H,...pe.includePattern}:H=pe.includePattern),H&&(this.c=F.$ej(H))}matchesExcludesSync(ne,pe,H){return!!(this.b&&this.b(ne,pe,H))}includedInQuerySync(ne,pe,H){return!(this.b&&this.b(ne,pe,H)||this.c&&!this.c(ne,pe,H))}includedInQuery(ne,pe,H){const ue=this.b(ne,pe,H),ce=()=>this.c?!!this.c(ne,pe,H):!0;return(0,I.$ig)(ue)?ue.then(z=>z?!1:ce()):ce()}hasSiblingExcludeClauses(){return V(this.a)}}e.$fI=Y;function V(q){for(const ne in q)if(typeof q[ne]!="boolean")return!0;return!1}function de(q){if(!q)return;let ne;return pe=>(ne||(ne=(q()||Promise.resolve([])).then(H=>H?x(H):{})),ne.then(H=>!!H[pe]))}e.$gI=de;function re(q){if(!q)return;let ne;return pe=>{if(!ne){const H=q();ne=H?x(H):{}}return!!ne[pe]}}e.$hI=re;function x(q){const ne={};for(const pe of q)ne[pe]=!0;return ne}}),define(Se[37],Ce([1,0,19,17,21,3,4,71,15,112,24,12,14,2,204,5,18,232,50,51,26,20,16,7,58,35,6]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c,f,y,C,i,o,n,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4$b=e.$3$b=void 0;function g(N,T,j){return new R.$Yf(W=>l(W,j)).isEqual(N,T)}function u(N,T,j){return g(N.uri,T.uri,j)?0:(0,I.$Fd)(N.uri.toString(),T.uri.toString())}function d(N,T,j){return N.index!==T.index?N.index<T.index?-1:1:g(N.uri,T.uri,j)?(0,I.$Fd)(N.name,T.name):(0,I.$Fd)(N.uri.toString(),T.uri.toString())}function v(N,T,j,W){const M=N.slice(0).sort((V,de)=>j(V,de,W)),Y=T.slice(0).sort((V,de)=>j(V,de,W));return(0,k.$jf)(M,Y,(V,de)=>j(V,de,W))}function l(N,T){const j=T.getCapabilities(N.scheme);return!(j&&j&1024)}class w extends c.$Ih{static toExtHostWorkspace(T,j,W,M){if(!T)return{workspace:null,added:[],removed:[]};const{id:Y,name:V,folders:de,configuration:re,transient:x,isUntitled:q}=T,ne=[],pe=j;j?de.forEach((z,ie)=>{const Ee=D.URI.revive(z.uri),Re=w.o(W||j,Ee,M);Re?(Re.name=z.name,Re.index=z.index,ne.push(Re)):ne.push({uri:Ee,name:z.name,index:ie})}):ne.push(...de.map(({uri:z,name:ie,index:Ee})=>({uri:D.URI.revive(z),name:ie,index:Ee}))),ne.sort((z,ie)=>z.index<ie.index?-1:1);const H=new w(Y,V,ne,!!x,re?D.URI.revive(re):null,!!q,z=>l(z,M)),{added:ue,removed:ce}=v(pe?pe.workspaceFolders:[],H.workspaceFolders,u,M);return{workspace:H,added:ue,removed:ce}}static o(T,j,W){for(let M=0;M<T.folders.length;M++){const Y=T.workspaceFolders[M];if(g(Y.uri,j,W))return Y}}constructor(T,j,W,M,Y,V,de){super(T,W.map(re=>new c.$Jh(re)),M,Y,de),this.t=j,this.u=V,this.q=[],this.s=m.$vh.forUris(de),W.forEach(re=>{this.q.push(re),this.s.set(re.uri,re)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(T,j){return j&&this.s.get(T)&&(T=(0,R.$9f)(T)),this.s.findSubstr(T)}resolveWorkspaceFolder(T){return this.s.get(T)}}let L=class{constructor(T,j,W,M,Y){this.c=new A.$8c,this.onDidChangeWorkspace=this.c.event,this.g=new A.$8c,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new A.$0c,this.B=new Map,this.h=M,this.s=W,this.t=Y,this.j=new b.$vl,this.k=new F.$ug,this.o=T.getProxy(a.$BJ.MainThreadWorkspace),this.q=T.getProxy(a.$BJ.MainThreadMessageService);const V=j.workspace;this.l=V?new w(V.id,V.name,[],!!V.transient,V.configuration?D.URI.revive(V.configuration):null,!!V.isUntitled,de=>l(de,W)):void 0}$initializeWorkspace(T,j){this.v=j,this.$acceptWorkspaceData(T),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?D.URI.from({scheme:E.Schemas.untitled,path:(0,R.$7f)((0,R.$9f)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(T,j,W,...M){const Y=[];if(Array.isArray(M)&&M.forEach(q=>{D.URI.isUri(q.uri)&&!Y.some(ne=>g(ne.uri,q.uri,this.s))&&Y.push({uri:q.uri,name:q.name||(0,R.$6f)(q.uri)})}),this.n||[j,W].some(q=>typeof q!="number"||q<0)||W===0&&Y.length===0)return!1;const V=this.x?this.x.workspaceFolders:[];if(j+W>V.length)return!1;const de=V.slice(0);de.splice(j,W,...Y.map(q=>({uri:q.uri,name:q.name||(0,R.$6f)(q.uri),index:void 0})));for(let q=0;q<de.length;q++){const ne=de[q];if(de.some((pe,H)=>H!==q&&g(ne.uri,pe.uri,this.s)))return!1}de.forEach((q,ne)=>q.index=ne);const{added:re,removed:x}=v(V,de,d,this.s);if(re.length===0&&x.length===0)return!1;if(this.o){const q=T.displayName||T.name;this.o.$updateWorkspaceFolders(q,j,W,Y).then(void 0,ne=>{this.n=void 0;const pe={source:{identifier:T.identifier,label:T.displayName||T.name}};this.q.$showMessage(s.Severity.Error,(0,S.localize)(0,null,q,ne.toString()),pe,[])})}return this.y(de),!0}getWorkspaceFolder(T,j){if(this.x)return this.x.getWorkspaceFolder(T,j)}async getWorkspaceFolder2(T,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(T,j)}async resolveWorkspaceFolder(T){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(T)}getPath(){if(!this.x)return;const{folders:T}=this.x;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,j){let W,M="";if(typeof T=="string"?(W=D.URI.file(T),M=T):typeof T<"u"&&(W=T,M=T.fsPath),!W)return M;const Y=this.getWorkspaceFolder(W,!0);if(!Y)return M;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let V=(0,R.$_f)(Y.uri,W);return j&&Y.name&&(V=`${Y.name}/${V}`),V}y(T){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:T,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:j,added:W,removed:M}=w.toExtHostWorkspace(T,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:W,removed:M}))}findFiles(T,j,W,M,Y=h.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let V;if(j===null?V=!1:j&&(typeof j=="string"?V=j:V=j.pattern),Y&&Y.isCancellationRequested)return Promise.resolve([]);const{includePattern:de,folder:re}=O(i.GlobPattern.from(T));return this.o.$startFileSearch((0,$.$Ce)(de),(0,$.$Ce)(re),(0,$.$Ce)(V),(0,$.$Ce)(W),Y).then(x=>Array.isArray(x)?x.map(q=>D.URI.revive(q)):[])}async findTextInFiles(T,j,W,M,Y=h.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const V=this.j.getNext(),de=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:re,folder:x}=O(i.GlobPattern.from(j.include)),q=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,ne={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:de,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:re,excludePattern:q},pe=!1;if(this.u[V]=H=>{if(pe)return;const ue=D.URI.revive(H.resource);H.results.forEach(ce=>{(0,t.$ZH)(ce)?W({uri:ue,preview:{text:ce.preview.text,matches:(0,k.$If)(ce.preview.matches,z=>new o.$FJ(z.startLineNumber,z.startColumn,z.endLineNumber,z.endColumn))},ranges:(0,k.$If)(ce.ranges,z=>new o.$FJ(z.startLineNumber,z.startColumn,z.endLineNumber,z.endColumn))}):W({uri:ue,text:ce.text,lineNumber:ce.lineNumber})})},Y.isCancellationRequested)return{};try{const H=await this.o.$startTextSearch(T,(0,$.$Ce)(x),ne,V,Y);return delete this.u[V],H||{}}catch(H){throw delete this.u[V],H}}$handleTextSearchResult(T,j){this.u[j]?.(T)}async save(T){const j=await this.o.$save(T,{saveAs:!1});return D.URI.revive(j)}async saveAs(T){const j=await this.o.$save(T,{saveAs:!0});return D.URI.revive(j)}saveAll(T){return this.o.$saveAll(T)}resolveProxy(T){return this.o.$resolveProxy(T)}get trusted(){return this.v}requestWorkspaceTrust(T){return this.o.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(T,j){if(this.w.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.w.set(T,j);const W=this.t.transformOutgoingScheme(T),M=this.z++;return this.o.$registerEditSessionIdentityProvider(M,W),(0,P.$jb)(()=>{this.w.delete(T),this.o.$unregisterEditSessionIdentityProvider(M)})}async $getEditSessionIdentifier(T,j){this.h.info("Getting edit session identifier for workspaceFolder",T);const W=await this.resolveWorkspaceFolder(D.URI.revive(T));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const M=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!M),!M)return;const Y=await M.provideEditSessionIdentity(W,j);if(this.h.info("Provider returned edit session identifier: ",Y),!!Y)return Y}async $provideEditSessionIdentityMatch(T,j,W,M){this.h.info("Getting edit session identifier for workspaceFolder",T);const Y=await this.resolveWorkspaceFolder(D.URI.revive(T));if(!Y){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Y);const V=this.w.get(Y.uri.scheme);if(this.h.info(`Provider for scheme ${Y.uri.scheme} is defined: `,!!V),!V)return;const de=await V.provideEditSessionIdentityMatch?.(j,W,M);if(this.h.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(T){return(j,W,M)=>{const Y=function(de){j.call(W,de)};return Y.extension=T,this.A.event(Y,void 0,M)}}async $onWillCreateEditSessionIdentity(T,j,W){const M=await this.resolveWorkspaceFolder(D.URI.revive(T));if(M===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:M},j,async(Y,V)=>{const de=Date.now();await Promise.resolve(Y),Date.now()-de>W&&this.h.warn("SLOW edit session create-participant",V.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(T,j){if(this.B.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.B.set(T,j);const W=this.t.transformOutgoingScheme(T),M=this.z++;return this.o.$registerCanonicalUriProvider(M,W),(0,P.$jb)(()=>{this.B.delete(T),this.o.$unregisterCanonicalUriProvider(M)})}async provideCanonicalUri(T,j,W){const M=this.B.get(T.scheme);if(!M)return;const Y=await M.provideCanonicalUri?.(D.URI.revive(T),j,W);if(Y)return Y}async $provideCanonicalUri(T,j,W){return this.provideCanonicalUri(D.URI.revive(T),{targetScheme:j},W)}};e.$3$b=L,e.$3$b=L=Je([qe(0,C.$DL),qe(1,y.$TL),qe(2,f.$Q$b),qe(3,r.$Ri),qe(4,n.$1$b)],L),e.$4$b=(0,p.$ph)("IExtHostWorkspace");function O(N){let T,j;return N&&(typeof N=="string"?T=N:(T=N.pattern,j=D.URI.revive(N.baseUri))),{includePattern:T,folder:j}}}),define(Se[38],Ce([1,0,23,3,37,6,7,235,129,14,17,5,20,18,2]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7$b=e.$6$b=e.$5$b=void 0;function p(o,n){if(n){const t=n.split(".");let a=o;for(let g=0;a&&g<t.length;g++)a=a[t[g]];return a}}function r(o){return o instanceof S.URI}function s(o){return o&&o.uri instanceof S.URI&&o.languageId&&typeof o.languageId=="string"}function c(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function f(o){return o&&o.uri instanceof S.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function y(o){if(r(o))return{resource:o};if(s(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(c(o))return{overrideIdentifier:o.languageId};if(f(o))return{resource:o.uri};if(o===null)return{resource:null}}let C=class{constructor(n,t,a){this.a=n.getProxy(A.$BJ.MainThreadConfiguration),this.c=t,this.b=a,this.d=new R.$ug,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new i(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,t){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(n,t))}};e.$5$b=C,e.$5$b=C=Je([qe(0,$.$DL),qe(1,h.$4$b),qe(2,D.$Ri)],C);class i{constructor(n,t,a,g){this.a=new F.$8c,this.b=n,this.f=g,this.c=t,this.e=m.$fn.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,t){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$fn.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(t,a))}getConfiguration(n,t,a){const g=y(t)||{},u=this.g(n?p(this.e.getValue(void 0,g,this.c.workspace),n):this.e.getValue(void 0,g,this.c.workspace));n&&this.h(n,g,a?.identifier);function d(l){if(l==null)return null;if(typeof l=="boolean")return l?2:5;switch(l){case P.ConfigurationTarget.Global:return 2;case P.ConfigurationTarget.Workspace:return 5;case P.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(l){return typeof p(u,l)<"u"},get:(l,w)=>{this.h(n?`${n}.${l}`:l,g,a?.identifier);let L=p(u,l);if(typeof L>"u")L=w;else{let O;const N=(T,j)=>{if((0,b.$le)(T)){let W;const M=()=>{O=O||(0,k.$Hm)(u),W=W||p(O,j)};return new Proxy(T,{get:(Y,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return M(),()=>W;if(O)return W=W||p(O,j),W[V];const de=Y[V];return typeof V=="string"?N(de,`${j}.${V}`):de},set:(Y,V,de)=>(M(),W&&(W[V]=de),!0),deleteProperty:(Y,V)=>(M(),W&&delete W[V],!0),defineProperty:(Y,V,de)=>(M(),W&&Object.defineProperty(W,V,de),!0)})}return Array.isArray(T)?(0,k.$Hm)(T):T};L=N(L,l)}return L},update:(l,w,L,O)=>{l=n?`${n}.${l}`:l;const N=d(L);return w!==void 0?this.b.$updateConfigurationOption(N,l,w,g,O):this.b.$removeConfigurationOption(N,l,g,O)},inspect:l=>{l=n?`${n}.${l}`:l;const w=this.e.inspect(l,g,this.c.workspace);if(w)return{key:l,defaultValue:(0,k.$Hm)(w.policy?.value??w.default?.value),globalValue:(0,k.$Hm)(w.user?.value??w.application?.value),workspaceValue:(0,k.$Hm)(w.workspace?.value),workspaceFolderValue:(0,k.$Hm)(w.workspaceFolder?.value),defaultLanguageValue:(0,k.$Hm)(w.default?.override),globalLanguageValue:(0,k.$Hm)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,k.$Hm)(w.workspace?.override),workspaceFolderLanguageValue:(0,k.$Hm)(w.workspaceFolder?.override),languageIds:(0,k.$Hm)(w.overrideIdentifiers)}}};return typeof u=="object"&&(0,k.$Km)(v,u,!1),Object.freeze(v)}g(n){const t=a=>(0,b.$le)(a)?new Proxy(a,{get:(g,u)=>t(g[u]),set:(g,u,d)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(u)}' of object`)},deleteProperty:(g,u)=>{throw new Error(`TypeError: Cannot delete read only property '${String(u)}' of object`)},defineProperty:(g,u)=>{throw new Error(`TypeError: Cannot define property '${String(u)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return t(n)}h(n,t,a){const g=E.$9m.test(n)?4:this.d.get(n),u=a?`[${a.value}] `:"";if(g===4){typeof t?.resource>"u"&&this.f.warn(`${u}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){t?.resource&&this.f.warn(`${u}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,t){const a=new m.$hn(n,t,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(g,u)=>a.affectsConfiguration(g,y(u))})}k(n){return n.reduce((t,a)=>(t.set(a[0],a[1]),t),new Map)}}e.$6$b=i,e.$7$b=(0,I.$ph)("IExtHostConfiguration")}),define(Se[88],Ce([1,0,2,17,3,6,7,37,61,38,21,43,20,26,5,15,11,18,84,277,8]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5_b=e.$4_b=e.$3_b=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var C;(function(N){function T(W){if(W!=null)return W}N.from=T;function j(W){if(W!=null)return W}N.to=j})(C||(C={}));var i;(function(N){function T(W){if(W!=null)return W}N.from=T;function j(W){if(W!=null)return W}N.to=j})(i||(i={}));var o;(function(N){function T(W){if(W!=null)return W}N.from=T;function j(W){if(W!=null)return W}N.to=j})(o||(o={}));var n;(function(N){function T(M){if(M){const Y=M;return Y&&!!Y.process}else return!1}N.is=T;function j(M){if(M==null)return;const Y={process:M.process,args:M.args};return M.options&&(Y.options=o.from(M.options)),Y}N.from=j;function W(M){if(M!=null)return new P.$mK(M.process,M.args,M.options)}N.to=W})(n||(n={}));var t;(function(N){function T(W){if(W!=null)return W}N.from=T;function j(W){if(W!=null)return W}N.to=j})(t||(t={}));var a;(function(N){function T(M){if(M){const Y=M;return Y&&(!!Y.commandLine||!!Y.command)}else return!1}N.is=T;function j(M){if(M==null)return;const Y={};return M.commandLine!==void 0?Y.commandLine=M.commandLine:(Y.command=M.command,Y.args=M.args),M.options&&(Y.options=t.from(M.options)),Y}N.from=j;function W(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new P.$nK(M.commandLine,M.options):new P.$nK(M.command,M.args?M.args:[],M.options)}N.to=W})(a||(a={}));var g;(function(N){function T(M){if(M){const Y=M;return Y&&Y.customExecution==="customExecution"}else return!1}N.is=T;function j(M){return{customExecution:"customExecution"}}N.from=j;function W(M,Y){return Y.get(M)}N.to=W})(g||(e.CustomExecutionDTO=g={}));var u;(function(N){function T(j,W){let M;return j.scope!==void 0&&typeof j.scope!="number"?M=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===P.TaskScope.Workspace&&W&&W.workspaceFile?M=W.workspaceFile:M=f.$UF),{id:j._id,workspaceFolder:M}}N.from=T})(u||(e.TaskHandleDTO=u={}));var d;(function(N){function T(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}N.from=T})(d||(d={}));var v;(function(N){function T(M,Y){if(M==null)return[];const V=[];for(const de of M){const re=j(de,Y);re&&V.push(re)}return V}N.fromMany=T;function j(M,Y){if(M==null)return;let V;M.execution instanceof P.$mK?V=n.from(M.execution):M.execution instanceof P.$nK?V=a.from(M.execution):M.execution&&M.execution instanceof P.$oK&&(V=g.from(M.execution));const de=C.from(M.definition);let re;return M.scope?typeof M.scope=="number"?re=M.scope:re=M.scope.uri:re=P.TaskScope.Workspace,!de||!re?void 0:{_id:M._id,definition:de,name:M.name,source:{extensionId:Y.identifier.value,label:M.source,scope:re},execution:V,isBackground:M.isBackground,group:d.from(M.group),presentationOptions:i.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}N.from=j;async function W(M,Y,V){if(M==null)return;let de;n.is(M.execution)?de=n.to(M.execution):a.is(M.execution)?de=a.to(M.execution):g.is(M.execution)&&(de=g.to(M._id,V));const re=C.to(M.definition);let x;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?x=M.source.scope:x=await Y.resolveWorkspaceFolder(k.URI.revive(M.source.scope)):x=P.TaskScope.Workspace),!re||!x)return;const q=new P.$pK(re,x,M.name,M.source.label,de,M.problemMatchers);return M.isBackground!==void 0&&(q.isBackground=M.isBackground),M.group!==void 0&&(q.group=P.$lK.from(M.group._id),q.group&&M.group.isDefault&&(q.group=new P.$lK(q.group.id,q.group.label),M.group.isDefault===!0&&(q.group.isDefault=M.group.isDefault))),M.presentationOptions&&(q.presentationOptions=i.to(M.presentationOptions)),M._id&&(q._id=M._id),M.detail&&(q.detail=M.detail),q}N.to=W})(v||(e.TaskDTO=v={}));var l;(function(N){function T(W){return W}N.from=T;function j(W){if(W)return Object.assign(Object.create(null),W)}N.to=j})(l||(l={}));class w{#e;constructor(T,j,W){this._id=j,this.a=W,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let L=class{constructor(T,j,W,M,Y,V,de,re){this.q=new h.$8c,this.r=new h.$8c,this.s=new h.$8c,this.t=new h.$8c,this.a=T.getProxy(A.$BJ.MainThreadTask),this.b=W,this.c=M,this.d=Y,this.e=V,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=de,this.g=re,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,j,W){if(!W)return new P.$DJ(()=>{});const M=this.w();return this.j.set(M,{type:j,provider:W,extension:T}),this.a.$registerTaskProvider(M,j),new P.$DJ(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(T,j){this.a.$registerTaskSystem(T,j)}fetchTasks(T){return this.a.$fetchTasks(l.from(T)).then(async j=>{const W=[];for(const M of j){const Y=await v.to(M,this.b,this.m);Y&&W.push(Y)}return W})}get taskExecutions(){const T=[];return this.k.forEach(j=>T.push(j)),T}terminateTask(T){if(!(T instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,j,W){const M=this.m.get(T.id);M&&(this.o.set(T.id,M),this.e.attachPtyToTerminal(j,await M.callback(W))),this.p=T.id,this.q.fire({execution:await this.y(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){const j=await this.y(T);this.l.delete(T.id),this.k.delete(T.id),this.A(T),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const j=await this.y(T.id);this.s.fire({execution:j,processId:T.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(T){const j=await this.y(T.id);this.t.fire({execution:j,exitCode:T.exitCode})}$provideTasks(T,j){const W=this.j.get(T);if(!W)return Promise.reject(new Error("no handler found"));const M=[],Y=(0,F.$og)(()=>W.provider.provideTasks(R.CancellationToken.None)).then(V=>this.u(j,M,W,V));return new Promise(V=>{Y.then(de=>{Promise.all(M).then(()=>{V(de)})})})}async $resolveTask(T,j){const W=this.j.get(T);if(!W)return Promise.reject(new Error("no handler found"));if(j.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${W.type}].`);const M=await v.to(j,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const Y=await W.provider.resolveTask(M,R.CancellationToken.None);if(!Y)return;this.z(Y,W);const V=v.from(Y,W.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(Y.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(V.execution)&&await this.x(V,Y,!0),await this.v(V)}w(){return this.h++}async x(T,j,W){const M=await this.a.$createTaskId(T);!W&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,j.execution)),this.m.set(M,j.execution)}async y(T,j){if(typeof T=="string"){const Y=this.l.get(T);if(!Y)throw new y.$ab("Unexpected: The specified task is missing an execution");return Y}const W=this.l.get(T.id);if(W)return W;const M=new Promise((Y,V)=>{function de(re,x,q){q?Y(new w(re,x.id,q)):V("Unexpected: Task does not exist.")}j?de(this,T,j):v.to(T.task,this.b,this.m).then(re=>de(this,T,re))});return this.l.set(T.id,M),M.then(Y=>(this.k.set(T.id,Y),Y),Y=>Promise.reject(Y))}z(T,j){T._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const W=this.n.values();let M=W.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=W.next()}};e.$3_b=L,e.$3_b=L=Je([qe(0,$.$DL),qe(1,D.$TL),qe(2,m.$4$b),qe(3,E.$OL),qe(4,b.$7$b),qe(5,I.$m_b),qe(6,s.$Ri),qe(7,c.$T$b)],L);let O=class extends L{constructor(T,j,W,M,Y,V,de,re){super(T,j,W,M,Y,V,de,re),this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:r.$h(0)})}async executeTask(T,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const W=v.from(j,T);if(W===void 0)throw new Error("Task is not valid");if(g.is(W.execution))await this.x(W,j,!1);else throw new y.$$;const M=await this.y(await this.a.$getTaskExecution(W),j);return this.a.$executeTask(W).catch(Y=>{throw new Error(Y)}),M}u(T,j,W,M){const Y=[];if(M)for(const V of M){this.z(V,W),(!V.definition||!T[V.definition.type])&&this.f.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const de=v.from(V,W.extension);de&&g.is(de.execution)?(Y.push(de),j.push(this.x(de,V,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Y,extension:W.extension}}async v(T){if(g.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,j,W){}};e.$4_b=O,e.$4_b=O=Je([qe(0,$.$DL),qe(1,D.$TL),qe(2,m.$4$b),qe(3,E.$OL),qe(4,b.$7$b),qe(5,I.$m_b),qe(6,s.$Ri),qe(7,c.$T$b)],O),e.$5_b=(0,S.$ph)("IExtHostTask")}),define(Se[328],Ce([1,0,13,21,45,34,24,39,35]),function(fe,e,k,F,h,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cac=void 0;class b{constructor($,D,S){this.k=$,this.l=D,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=$.filePattern,this.b=$.includePattern&&A.$ej($.includePattern),this.c=$.maxResults||void 0,this.d=$.exists,this.h=new Set,this.j=$.excludePattern&&A.$ej($.excludePattern)}cancel(){this.g=!0,this.h.forEach($=>$.cancel()),this.h=new Set}search($){const D=this.k.folderQueries||[];return new Promise((S,p)=>{const r=s=>{this.f++,$(s)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const c=s.toString(),f=k.$ec(c);this.j&&this.j(c,f)||this.v(r,{base:s,basename:f})}),Promise.all(D.map(s=>this.p(s,r))).then(s=>{S({limitHit:this.e,stats:s[0]||void 0})},s=>{p(new Error((0,h.$ai)(s)))})})}async p($,D){const S=new F.$ed,p=this.q($),r=this.r(),s=new E.$fI(this.k,$),c=!s.hasSiblingExcludeClauses();let f;try{this.h.add(S),f=m.$4c.create();const y=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},p,S.token),C=f.elapsed(),i=m.$4c.create();return this.g&&!this.e||(y&&y.forEach(o=>{const n=k.$0b.relative($.folder.path,o.path);if(c){const t=k.$ec(o.path);this.v(D,{base:$.folder,relativePath:n,basename:t});return}this.s(r,$.folder,n,D)}),this.g&&!this.e)?null:(this.u(r,s,D),{providerTime:C,postProcessTime:i.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q($){const D=(0,E.$eI)(this.k.includePattern,$.includePattern),S=(0,E.$eI)(this.k.excludePattern,$.excludePattern);return{folder:$.folder,excludes:S,includes:D,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const $={rootEntries:[],pathToEntries:Object.create(null)};return $.pathToEntries["."]=$.rootEntries,$}s({pathToEntries:$},D,S,p){if(S===this.a){const s=k.$ec(this.a);this.v(p,{base:D,relativePath:this.a,basename:s})}function r(s){const c=k.$ec(s),f=k.$dc(s);let y=$[f];y||(y=$[f]=[],r(f)),y.push({base:D,relativePath:s,basename:c})}r(S)}u({rootEntries:$,pathToEntries:D},S,p){const r=this,s=this.a;function c(f){const y=(0,E.$hI)(()=>f.map(C=>C.basename));for(let C=0,i=f.length;C<i;C++){const o=f[C],{relativePath:n,basename:t}=o;if(S.matchesExcludesSync(n,t,s!==t?y:void 0))continue;const a=D[n];if(a)c(a);else{if(n===s)continue;r.v(p,o)}if(r.e)break}}c($)}v($,D){(!this.b||D.relativePath&&this.b(D.relativePath,D.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||$(D))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch($,D,S,p){const r=this.c($.cacheKey),s=new b($,D,r&&r.token);let c=0;const f=y=>{c+=y.length,S(y.map(C=>this.d(C)))};return this.e(s,R.a,f,p).then(y=>({limitHit:y.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:y.stats}}))}clearCache($){this.c($)?.cancel()}c($){if($)return this.b.has($)||this.b.set($,new F.$ed),this.b.get($)}d($){return $.relativePath?{resource:P.$0f($.base,$.relativePath)}:{resource:$.base}}e($,D,S,p){p.onCancellationRequested(()=>{$.cancel()});const r=c=>{c&&(s.push(c),D>0&&s.length>=D&&(S(s),s=[]))};let s=[];return $.search(r).then(c=>(s.length&&S(s),c),c=>(s.length&&S(s),Promise.reject(c)))}}e.$cac=R}),define(Se[329],Ce([1,0,19,65,34,120,28,15,13,24,12,14,2,165,215,57,18,50,137,327,35]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gJ=e.$fJ=void 0;let C=class{constructor(l,w,L,O,N){this.a=l,this.b=w,this.c=L,this.d=O,this.e=N}text(l,w,L={}){l=this.f(l,L);const O=this.a.getValue(),N=w&&w.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(w?.map(s.$Kh),L),type:2,contentPattern:l,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:O.search.usePCRE2||N||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(l,w){const L=this.a.getValue();l.isRegExp&&(l.pattern=l.pattern.replace(/\r?\n/g,"\\n"));const O={...l,wordSeparators:L.editor.wordSeparators};return this.j(l,w)&&(O.isCaseSensitive=!0),this.k(l)&&(O.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),O}file(l,w={}){return{...this.h(l,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(l,w){return l?(l=Array.isArray(l)?l.map(a):a(l),w?this.parseSearchPaths(l):{pattern:o(...Array.isArray(l)?l:[l])}):{}}h(l=[],w={}){const L=this.g(w.includePattern,w.expandPatterns),O=this.g(w.excludePattern,w.expandPatterns),N=l.length>1,T=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(M=>this.q(M,w,O)):l.map(M=>this.r(M,w,O,N))).filter(M=>!!M),j={_reason:w._reason,folderQueries:T,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:O.pattern,includePattern:L.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const M=k.$mf(k.$yf(this.c.groups.map(de=>de.editors.map(re=>re.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const Y=M.filter(de=>(0,y.$8H)(j,de.fsPath)),V=this.i(Y);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...j,...V}}const W=w.extraFileResources&&w.extraFileResources.filter(M=>(0,y.$8H)(j,M.fsPath));return j.extraFileResources=W&&W.length?W:void 0,j}i(l){const w=[],L=new P.$ni,O={};let N=!1;return l.forEach(T=>{if(T.scheme===m.Schemas.walkThrough)return;if((0,b.$bg)(T)){const W=this.b.getWorkspaceFolder(T)?.uri??T.with({path:E.$dc(T.fsPath)});let M=L.get(W);M||(N=!0,M={folder:W,includePattern:{}},w.push(M),L.set(W,M));const Y=E.$cc(W.fsPath,T.fsPath);(0,I.$ue)(M.includePattern)[Y.replace(/\\/g,"/")]=!0}else T.fsPath&&(N=!0,O[T.fsPath]=!0)}),{folderQueries:w,includePattern:O,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(l,w){if(w.isSmartCase){if(l.isRegExp){if(R.$ae(l.pattern,!0))return!0}else if(R.$ae(l.pattern))return!0}return!!l.isCaseSensitive}k(l){return l.isMultiline||l.isRegExp&&(0,D.$4B)(l.pattern)||l.pattern.indexOf(`
`)>=0?!0:!!l.isMultiline}parseSearchPaths(l){const w=V=>E.$_b(V)||/^\.\.?([\/\\]|$)/.test(V),O=(Array.isArray(l)?l:n(l)).map(V=>{const de=this.e.resolvedUserHome;return de?(0,A.$3z)(V,de.scheme===m.Schemas.file?de.fsPath:de.path):V}),N=F.$I(O,V=>w(V)?"searchPaths":"exprSegments"),T=(N.exprSegments||[]).map(V=>R.$td(V,"/")).map(V=>R.$td(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),t(V))),j={},W=this.m(N.searchPaths||[]);W&&W.length&&(j.searchPaths=W);const M=k.$yf(T),Y=o(...M);return Y&&(j.pattern=Y),j}l(l,w){return w.disregardExcludeSettings?void 0:(0,y.$7H)(l,!w.disregardSearchExcludeSettings)}m(l){if(!l||!l.length)return[];const w=l.flatMap(O=>{let{pathPortion:N,globPortion:T}=i(O);return T&&(T=g(T)),this.n(N).flatMap(W=>this.o(W,T))}),L=new Map;return w.forEach(O=>{const N=O.searchPath.toString(),T=L.get(N);T?O.pattern&&(T.pattern=T.pattern||{},T.pattern[O.pattern]=!0):L.set(N,{searchPath:O.searchPath,pattern:O.pattern?o(O.pattern):void 0})}),Array.from(L.values())}n(l){if(E.$_b(l)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==m.Schemas.file?[{searchPath:w[0].uri.with({path:l})}]:[{searchPath:$.URI.file(E.$$b(l))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(l=a(l),l.startsWith("../")||l===".."){const O=E.$0b.resolve(w.path,l);return[{searchPath:w.with({path:O})}]}const L=g(l);return[{searchPath:w,pattern:L}]}else{if(l==="./"||l===".\\")return[];{const w=l.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(N=>{const T=w.match(new RegExp(`^${R.$od(N.name)}(?:/(.*)|$)`));return T?{match:T,folder:N}:null}).filter(I.$re);if(O.length)return O.map(N=>{const T=N.match[1];return{searchPath:N.folder.uri,pattern:T&&g(T)}});{const N=l.match(/\.[\/\\](.+)[\/\\]?/),T=N?N[1]:l,j=S.localize(0,null,T);throw new Error(j)}}}}o(l,w){const L=l.pattern&&w?`${l.pattern}/${w}`:l.pattern||w,O=[{searchPath:l.searchPath,pattern:L}];return L&&!L.endsWith("**")&&O.push({searchPath:l.searchPath,pattern:L+"/**"}),O}q(l,w,L){const O=this.r((0,s.$Kh)(l.searchPath),w,L,!1);return O?{...O,includePattern:l.pattern}:null}r(l,w,L,O){let N;const T=$.URI.isUri(l)?l:l.uri;if(L.searchPaths){const V=L.searchPaths.filter(de=>(0,b.$3f)(de.searchPath,T))[0];if(V&&!V.pattern)return null;V&&(N=V.pattern)}const j=this.a.getValue({resource:T}),M={...this.l(j,w)||{},...N||{}},Y=$.URI.isUri(l)?(0,b.$7f)(l):l.name;return{folder:T,folderName:O?Y:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!j.search.followSymlinks}}};e.$fJ=C,e.$fJ=C=Je([qe(0,p.$Vh),qe(1,s.$yh),qe(2,c.$OC),qe(3,r.$Ri),qe(4,f.$dJ)],C);function i(v){const l=v.match(/[\*\{\}\(\)\[\]\?]/);if(l){const w=l.index,L=v.substr(0,w).match(/[/|\\][^/\\]*$/);if(L){let O=v.substr(0,L.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:v.substr((L.index||0)+1)}}}return{pathPortion:v}}function o(...v){return v.length?v.reduce((l,w)=>(l[w]=!0,l),Object.create(null)):void 0}function n(v){return h.$cj(v,",").map(l=>l.trim()).filter(l=>!!l.length)}function t(v){return[`**/${v}/**`,`**/${v}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function a(v){return v.replace(/\\/g,"/")}function g(v){return a(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(v){return v.replace(/([?*[\]])/g,"[$1]")}function d(v,l){v=k.$rf(v,O=>O.toString());const w=[],L=l.getWorkspace();return v&&v.forEach(O=>{let N;if(l.getWorkbenchState()===2)N=(0,b.$_f)(L.folders[0].uri,O),N&&N!=="."&&(N="./"+N);else{const T=l.getWorkspaceFolder(O);if(T){const j=T.name;if(L.folders.filter(M=>M.name===j).length===1){const M=(0,b.$_f)(T.uri,O);M===""?N=`./${T.name}`:N=`./${T.name}/${M}`}else N=O.fsPath}}N&&w.push(u(N))}),w}e.$gJ=d}),define(Se[330],Ce([1,0,24,2,21,8,5,329,35,50]),function(fe,e,k,F,h,A,P,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjb=e.$Vjb=void 0;const R=7e3;function I(p,r){const s=r.activationEvents;if(!s)return Promise.resolve(void 0);const c=[],f=[];for(const t of s)if(/^workspaceContains:/.test(t)){const a=t.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||p.forceUsingSearch?f.push(a):c.push(a)}if(c.length===0&&f.length===0)return Promise.resolve(void 0);let y;const C=new Promise((t,a)=>{y=t}),i=t=>y({activationEvent:t}),o=Promise.all(c.map(t=>$(p,t,i))).then(()=>{}),n=D(p,r.identifier,f,i);return Promise.all([o,n]).then(()=>{y(void 0)}),C}e.$Vjb=I;async function $(p,r,s){for(const c of p.folders)if(await p.exists(k.$0f(F.URI.revive(c),r))){s(`workspaceContains:${r}`);return}}async function D(p,r,s,c){if(s.length===0)return Promise.resolve(void 0);const f=new h.$ed,y=p.checkExists(p.folders,s,f.token),C=setTimeout(async()=>{f.cancel(),p.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},R);let i=!1;try{i=await y}catch(o){A.$2(o)||A.$Y(o)}f.dispose(),clearTimeout(C),i&&c(`workspaceContains:${s.join(",")}`)}function S(p,r,s,c){const f=p.get(P.$oh),y=p.get(E.$YH),i=f.createInstance(m.$fJ).file(r.map(o=>(0,b.$Kh)(F.URI.revive(o))),{_reason:"checkExists",includePattern:s,exists:!0});return y.fileSearch(i,c).then(o=>!!o.limitHit,o=>A.$2(o)?!1:Promise.reject(o))}e.$Wjb=S}),define(Se[44],Ce([1,0,194,13,89,24,17,4,71,2,18,6,38,272,109,37,27,141,8,25,22,247,7,130,5,26,85,20,99,64,43,3,330,108,249,15,106,39,11,107]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c,f,y,C,i,o,n,t,a,g,u,d,v,l,w,L,O,N,T,j,W,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B_b=e.$A_b=e.$z_b=e.$y_b=e.$x_b=void 0,e.$x_b=(0,n.$ph)("IHostUtils");let Y=class Sn extends m.$lb{constructor(H,ue,ce,z,ie,Ee,Re,ye,X,he,K,oe){super(),this.R=oe,this.a=this.B(new l.$8c),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=ue,this.g=ce,this.f=Re,this.j=z,this.k=ie,this.l=Ee,this.m=X,this.p=he,this.s=K,this.t=this.g.getProxy(I.$BJ.MainThreadWorkspace),this.u=this.g.getProxy(I.$BJ.MainThreadTelemetry),this.v=this.g.getProxy(I.$BJ.MainThreadExtensionService),this.w=new P.$ug,this.y=new P.$ug,this.z=new P.$ug,this.C=new P.$ug,this.D=new ne(this.f.activationEvents),this.G=new s.$s1b(this.D,this.f.allExtensions);const _=new f.$Il(this.f.myExtensions);this.F=new s.$s1b(this.D,x(this.G,_)),this.H=new S.$e_b(this.g,this.l),this.I=new L.$q_b(this.g),this.J=ye,this.h=H.createChild(new u.$nh([S.$f_b,this.H],[L.$r_b,this.I])),this.L=this.B(new D.$d_b(this.F,this.G,{onExtensionActivationError:(le,$e,U)=>{this.v.$onExtensionActivationError(le,c.$1($e),U)},actualActivateExtension:async(le,$e)=>{if(s.$s1b.isHostExtension(le,this.F,this.G))return await this.v.$activateExtension(le,$e),new D.$c_b;const U=this.F.getExtensionDescription(le);return this.$(U,$e)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),h.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(H){c.$Y(H)}}async S(){this.J.onWillDeactivateAll();let H=[];try{H=this.F.getAllExtensionDescriptions().map(ie=>ie.identifier).filter(ie=>this.isActivated(ie)).map(ie=>this.Z(ie))}catch{}await Promise.all(H)}terminate(H,ue=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${H}`),this.l.flush(),this.p.dispose(),this.L.dispose(),c.setUnexpectedErrorHandler(z=>{this.l.error(z)}),this.g.dispose();const ce=this.S();Promise.race([(0,P.$wg)(5e3),ce]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${ue}`):this.l.info(`Extension host exiting with code ${ue}`),this.l.flush(),this.l.dispose(),this.c.exit(ue)})}isActivated(H){return this.z.isOpen()?this.L.isActivated(H):!1}async getExtension(H){const ue=await this.v.$getExtension(H);return ue&&{...ue,identifier:new f.$Hl(ue.identifier.value),extensionLocation:b.URI.revive(ue.extensionLocation)}}U(H,ue){return this.L.activateByEvent(H,ue)}W(H,ue){return this.L.activateById(H,ue)}activateByIdWithErrors(H,ue){return this.W(H,ue).then(()=>{const ce=this.L.getActivatedExtension(H);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(H=>this.F)}getExtensionExports(H){if(this.z.isOpen())return this.L.getActivatedExtension(H).exports;try{return this.L.getActivatedExtension(H).exports}catch{return null}}async X(H){if(H.scheme===N.Schemas.file&&this.c.fsRealpath){const ue=await this.c.fsRealpath(H.fsPath);return b.URI.file(ue)}return H}async getExtensionPathIndex(){return this.M||(this.M=this.Y(this.F.getAllExtensionDescriptions()).then(H=>new q(H))),this.M}async Y(H){const ue=E.$vh.forUris(ce=>A.$1f.ignorePathCasing(ce));return await Promise.all(H.map(async ce=>{if(this.qb(ce)){const z=await this.X(ce.extensionLocation);ue.set(z,ce)}})),ue}Z(H){let ue=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(H))return ue;const ce=this.L.getActivatedExtension(H);if(!ce)return ue;try{typeof ce.module.deactivate=="function"&&(ue=Promise.resolve(ce.module.deactivate()).then(void 0,z=>(this.l.error(z),Promise.resolve(void 0))))}catch(z){this.l.error(`An error occurred when deactivating the extension '${H.value}':`),this.l.error(z)}try{(0,m.$gb)(ce.subscriptions)}catch(z){this.l.error(`An error occurred when deactivating the subscriptions for extension '${H.value}':`),this.l.error(z)}return ue}async $(H,ue){return this.f.remote.isRemote?this.v.$onWillActivateExtension(H.identifier):await this.v.$onWillActivateExtension(H.identifier),this.bb(H,ue).then(ce=>{const z=ce.activationTimes;return this.v.$onDidActivateExtension(H.identifier,z.codeLoadingTime,z.activateCallTime,z.activateResolvedTime,ue),this.ab(H,ue,"success",z),ce},ce=>{throw this.ab(H,ue,"failure"),ce})}ab(H,ue,ce,z){const ie=de(H,ue);this.u.$publicLog2("extensionActivationTimes",{...ie,...z||{},outcome:ce})}bb(H,ue){const ce=de(H,ue);this.u.$publicLog2("activatePlugin",ce);const z=this.qb(H);if(!z)return Promise.resolve(new D.$b_b(D.$$$b.NONE));this.l.info(`ExtensionService#_doActivateExtension ${H.identifier.value}, startup: ${ue.startup}, activationEvent: '${ue.activationEvent}'${H.identifier.value!==ue.extensionId.value?`, root cause: ${ue.extensionId.value}`:""}`),this.l.flush();const ie=new D.$_$b(ue.startup);return Promise.all([this.rb(H,(0,A.$0f)(H.extensionLocation,z),ie),this.cb(H)]).then(Ee=>(h.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),Sn.db(this.l,H.identifier,Ee[0],Ee[1],ie))).then(Ee=>(h.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),Ee))}cb(H){const ue=new C.$h_b(H,this.H),ce=new C.$g_b(H.identifier.value,!1,this.H),z=new O.$s_b(H,this.I),ie=H.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ee=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([ue.whenReady,ce.whenReady,this.J.whenReady]).then(()=>{const Re=this;let ye,X;const he=(0,r.$yF)(H,"ipc")?this.f.messagePorts?.get(f.$Hl.toKey(H.identifier)):void 0;return Object.freeze({globalState:ue,workspaceState:ce,secrets:z,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(K){return F.$ac(H.extensionLocation.fsPath,K)},get storagePath(){return Re.J.workspaceValue(H)?.fsPath},get globalStoragePath(){return Re.J.globalValue(H).fsPath},get logPath(){return F.$ac(Re.f.logsLocation.fsPath,H.identifier.value)},get logUri(){return b.URI.joinPath(Re.f.logsLocation,H.identifier.value)},get storageUri(){return Re.J.workspaceValue(H)},get globalStorageUri(){return Re.J.globalValue(H)},get extensionMode(){return ie},get extension(){return ye===void 0&&(ye=new re(Re,H.identifier,H,Ee,!1)),ye},get extensionRuntime(){return(0,r.$zF)(H,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re.p.getEnvironmentVariableCollection(H)},get messagePassingProtocol(){if(!X){if(!he)return;const K=l.Event.buffer(l.Event.fromDOMEventEmitter(he,"message",oe=>oe.data));he.start(),X={onDidReceiveMessage:K,postMessage:he.postMessage.bind(he)}}return X}})})}static db(H,ue,ce,z,ie){return ce=ce||{activate:void 0,deactivate:void 0},this.eb(H,ue,ce,z,ie).then(Ee=>new D.$a_b(!1,null,ie.build(),ce,Ee,z.subscriptions))}static eb(H,ue,ce,z,ie){if(typeof ce.activate=="function")try{ie.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${ue.value}`);const Ee=typeof global=="object"?global:self,Re=ce.activate.apply(Ee,[z]);return ie.activateCallStop(),ie.activateResolveStart(),Promise.resolve(Re).then(ye=>(ie.activateResolveStop(),ye))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(ce)}fb(H,ue){this.W(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:ue}).then(void 0,ce=>{this.l.error(ce)})}gb(H,ue=0){const z=Date.now();(0,W.$A)(()=>{for(let ie=ue;ie<H.length;ie+=1){const Ee=H[ie];for(const Re of Ee.activationEvents??[])if(Re==="onStartupFinished")if(Date.now()-z>50){this.gb(H,ie);break}else this.fb(Ee,Re)}})}hb(){this.v.$setPerformanceMarks(h.getMarks()),this.k.getConfigProvider().then(H=>{const ue=H.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ce=this.F.getAllExtensionDescriptions();if(ue)this.gb(ce);else for(const z of ce)if(z.activationEvents)for(const ie of z.activationEvents)ie==="onStartupFinished"&&this.fb(z,ie)})}ib(){const H=this.U("*",!0).then(void 0,Ee=>{this.l.error(Ee)});this.B(this.j.onDidChangeWorkspace(Ee=>this.jb(Ee.added)));const ue=this.j.workspace?this.j.workspace.folders:[],ce=this.jb(ue),z=this.lb(),ie=Promise.all([z,H,ce]).then(()=>{});return Promise.race([ie,(0,P.$wg)(1e4)]).then(()=>{this.hb()}),ie}jb(H){return H.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(ue=>this.kb(H,ue))).then(()=>{})}async kb(H,ue){if(this.isActivated(ue.identifier))return;const ce=!this.f.remote.isRemote&&!!this.f.remote.authority,z={logService:this.l,folders:H.map(Ee=>Ee.uri),forceUsingSearch:ce||!this.c.fsExists,exists:Ee=>this.c.fsExists(Ee.fsPath),checkExists:(Ee,Re,ye)=>this.t.$checkExists(Ee,Re,ye)},ie=await(0,w.$Vjb)(z,ue);if(ie)return this.W(ue.identifier,{startup:!0,extensionId:ue.identifier,activationEvent:ie.activationEvent}).then(void 0,Ee=>this.l.error(Ee))}async lb(){if(this.f.remote.authority)return this.U(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(H){throw console.error(H),H}}async mb(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:ue}=this.f.environment;if(!H||!ue)throw new Error(k.localize(0,null));const ce=await this.rb(null,ue,new D.$_$b(!1));if(!ce||typeof ce.run!="function")throw new Error(k.localize(1,null,ue.toString()));return new Promise((z,ie)=>{const Ee=(X,he)=>{X?ie(X):z(typeof he=="number"&&he>0?1:0)},Re=(0,A.$Xf)(ue),ye=ce.run(Re,Ee);ye&&ye.then&&ye.then(()=>{z(0)}).catch(X=>{ie(X instanceof Error&&X.stack?X.stack:String(X))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,P.$wg)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(H,ue){return this.N[H]=ue,(0,m.$jb)(()=>{delete this.N[H]})}async getRemoteExecServer(H){const{resolver:ue}=await this.ob(H);return ue?.resolveExecServer?.(H,{resolveAttempt:0})}async ob(H){const ue=H.indexOf("+");if(ue===-1)throw new i.$JJ("Not an authority that can be resolved!",o.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ce=H.substr(0,ue);return await this.w.wait(),await this.U(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this.N[ce]}}async $resolveAuthority(H,ue){const ce=j.$4c.create(!1),z=()=>`[resolveAuthority(${(0,o.$Ak)(H)},${ue})][${ce.elapsed()}ms] `,ie=Z=>this.l.info(`${z()}${Z}`),Ee=Z=>this.l.warn(`${z()}${Z}`),Re=(Z,ee=void 0)=>this.l.error(`${z()}${Z}`,ee),ye=Z=>{if(Z instanceof i.$JJ)return{type:"error",error:{code:Z._code,message:Z._message,detail:Z._detail}};throw Z},X=async Z=>{ie(`activating resolver for ${Z}...`);const{resolver:ee,authorityPrefix:be}=await this.ob(Z);if(!ee)throw Re(`no resolver for ${be}`),new i.$JJ(`No remote extension installed to resolve ${be}.`,o.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:ee,authorityPrefix:be,remoteAuthority:Z}},he=H.split(/@|%40/g).reverse();ie(`activating remote resolvers ${he.join(" -> ")}`);let K;try{K=await Promise.all(he.map(X)).catch(async Z=>{if(!(Z instanceof i.$JJ)||Z._code!==o.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Z;return Ee(`resolving nested authorities failed: ${Z.message}`),[await X(H)]})}catch(Z){return ye(Z)}const oe=new P.$Fg;oe.cancelAndSet(()=>ie("waiting..."),1e3);let _,le;for(const[Z,{authorityPrefix:ee,resolver:be,remoteAuthority:se}]of K.entries())try{if(Z===K.length-1)ie("invoking final resolve()..."),h.mark(`code/extHost/willResolveAuthority/${ee}`),_=await be.resolve(se,{resolveAttempt:ue,execServer:le}),h.mark(`code/extHost/didResolveAuthorityOK/${ee}`),ie("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(be));else{if(ie(`invoking resolveExecServer() for ${se}`),h.mark(`code/extHost/willResolveExecServer/${ee}`),le=await be.resolveExecServer?.(se,{resolveAttempt:ue,execServer:le}),!le)throw new i.$JJ(`Exec server was not available for ${se}`,o.RemoteAuthorityResolverErrorCode.NoResolverFound);h.mark(`code/extHost/didResolveExecServerOK/${ee}`)}}catch(we){return h.mark(`code/extHost/didResolveAuthorityError/${ee}`),Re("returned an error",we),oe.dispose(),ye(we)}oe.dispose();const $e={environmentTunnels:_.environmentTunnels,features:_.tunnelFeatures},U={extensionHostEnv:_.extensionHostEnv,isTrusted:_.isTrusted,authenticationSession:_.authenticationSessionForInitializingExtensions?{id:_.authenticationSessionForInitializingExtensions.id,providerId:_.authenticationSessionForInitializingExtensions.providerId}:void 0};ie(`returned ${i.$IJ.isManagedResolvedAuthority(_)?"managed authority":`${_.host}:${_.port}`}`);let G;if(i.$IJ.isManagedResolvedAuthority(_)){const Z=ue;this.R.setFactory(Z,_.makeConnection),G={authority:H,connectTo:new o.$xk(Z),connectionToken:_.connectionToken}}else G={authority:H,connectTo:new o.$yk(_.host,_.port),connectionToken:_.connectionToken};return{type:"ok",value:{authority:G,options:U,tunnelInformation:$e}}}async $getCanonicalURI(H,ue){this.l.info(`$getCanonicalURI invoked for authority (${(0,o.$Ak)(H)})`);const{resolver:ce}=await this.ob(H);if(!ce)return null;const z=b.URI.revive(ue);if(typeof ce.getCanonicalURI>"u")return z;const ie=await(0,P.$og)(()=>ce.getCanonicalURI(z));return ie||z}$startExtensionHost(H){H.toAdd.forEach(z=>z.extensionLocation=b.URI.revive(z.extensionLocation));const{globalRegistry:ue,myExtensions:ce}=V(this.D,this.G,this.F,H);return this.G.set(ue.getAllExtensionDescriptions()),this.F.set(ce),this.nb()}$activateByEvent(H,ue){return ue===1?this.w.wait().then(ce=>this.U(H,!1)):this.z.wait().then(ce=>this.U(H,!1))}async $activate(H,ue){return await this.z.wait(),this.F.getExtensionDescription(H)?(await this.W(H,ue),!0):!1}async $deltaExtensions(H){H.toAdd.forEach(Ee=>Ee.extensionLocation=b.URI.revive(Ee.extensionLocation));const{globalRegistry:ue,myExtensions:ce}=V(this.D,this.G,this.F,H),z=await this.Y(ce);return(await this.getExtensionPathIndex()).setSearchTree(z),this.G.set(ue.getAllExtensionDescriptions()),this.F.set(ce),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){const ue=y.$Jb.alloc(H),ce=Math.random()%256;for(let z=0;z<H;z++)ue.writeUInt8(ce,z);return ue}async $updateRemoteConnectionData(H){this.Q=H,this.a.fire()}};e.$y_b=Y,e.$y_b=Y=Je([qe(0,n.$oh),qe(1,e.$x_b),qe(2,g.$DL),qe(3,p.$4$b),qe(4,$.$7$b),qe(5,R.$Ri),qe(6,t.$TL),qe(7,a.$k_b),qe(8,d.$Wpb),qe(9,v.$m_b),qe(10,T.$u_b),qe(11,M.$v_b)],Y);function V(pe,H,ue,ce){pe.addActivationEvents(ce.addActivationEvents);const z=new s.$s1b(pe,H.getAllExtensionDescriptions());z.deltaExtensions(ce.toAdd,ce.toRemove);const ie=new f.$Il(ue.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of ce.myToRemove)ie.delete(Re);for(const Re of ce.myToAdd)ie.add(Re);const Ee=x(z,ie);return{globalRegistry:z,myExtensions:Ee}}function de(pe,H){return{id:pe.identifier.value,name:pe.name,extensionVersion:pe.version,publisherDisplayName:pe.publisher,activationEvents:pe.activationEvents?pe.activationEvents.join(","):null,isBuiltin:pe.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}e.$z_b=(0,n.$ph)("IExtHostExtensionService");class re{#e;#t;#i;constructor(H,ue,ce,z,ie){this.#e=H,this.#t=ue,this.#i=ce.identifier,this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=F.$$b((0,A.$Xf)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=z,this.isFromDifferentExtensionHost=ie}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$A_b=re;function x(pe,H){return pe.getAllExtensionDescriptions().filter(ue=>H.has(ue.identifier))}class q{constructor(H){this.a=H}setSearchTree(H){this.a=H}findSubstr(H){return this.a.findSubstr(H)}forEach(H){return this.a.forEach(H)}}e.$B_b=q;class ne{constructor(H){this.a=new f.$Jl,this.addActivationEvents(H)}readActivationEvents(H){return this.a.get(H.identifier)}addActivationEvents(H){for(const ue of Object.keys(H))this.a.set(ue,H[ue])}}}),define(Se[331],Ce([1,0,89,2,6,38,27,25,20,26,5,44,41,18,12]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=void 0;let p=class{constructor(C,i,o,n,t,a,g){this.c=C,this.d=i,this.e=o,this.f=n,this.g=t,this.h=a,this.i=g,this.a=new Map,this.b=[]}async install(){this.j(),k.mark("code/extHost/willWaitForConfig");const C=await this.f.getConfigProvider();k.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new s(this.c,i,this.d,C,this.i)),this.register(this.e.createInstance(c,i)),this.register(this.e.createInstance(r)),this.h.remote.isRemote&&this.register(this.e.createInstance(f,i,this.h.environment.appUriScheme))}register(C){if("nodeModuleName"in C)if(Array.isArray(C.nodeModuleName))for(const i of C.nodeModuleName)this.a.set(i,C);else this.a.set(C.nodeModuleName,C);typeof C.alternativeModuleName=="function"&&this.b.push(i=>C.alternativeModuleName(i))}};e.$Tac=p,e.$Tac=p=Je([qe(2,R.$oh),qe(3,A.$7$b),qe(4,I.$z_b),qe(5,b.$TL),qe(6,D.$Ri)],p);let r=class mn{static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(C){if(C.environment.appRoot&&mn.a.size){const i=(0,S.$od)(this.c(C.environment.appRoot.fsPath)),o="[a-z0-9_.-]",n=`@${o}+\\/${o}+|${o}+`,t="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${t}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(C){if(!this.b)return;const i=this.b.exec(this.c(C));if(!i)return;const[,o,n,t]=i,a=mn.a.get(n);if(a!==void 0)return console.warn(`${n} as been renamed to ${a}, please update your imports`),o+a+t}c(C){return C.replace(/\\/g,"/")}};r=Je([qe(0,b.$TL)],r);class s{constructor(C,i,o,n,t){this.c=C,this.d=i,this.e=o,this.f=n,this.g=t,this.nodeModuleName="vscode",this.a=new m.$Jl}load(C,i){const o=this.d.findSubstr(i);if(o){let n=this.a.get(o.identifier);return n||(n=this.c(o,this.e,this.f),this.a.set(o.identifier,n)),n}if(!this.b){let n="";this.d.forEach((t,a)=>n+=`	${a} -> ${t.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${n}`),this.b=this.c(P.$tF,this.e,this.f)}return this.b}}let c=class{constructor(C,i,o){this.d=C,this.nodeModuleName="keytar",this.a=i.getProxy(h.$BJ.MainThreadTelemetry);const{environment:n}=o,t=i.getProxy(h.$BJ.MainThreadKeytar);if(n.appRoot){let a=n.appRoot.fsPath;$.$7b==="win32"&&(a=a.replace(/\\/g,"/")),a[a.length-1]==="/"&&(a=a.substr(0,a.length-1)),this.b=new Set,this.b.add(`${a}/node_modules.asar/keytar`),this.b.add(`${a}/node_modules/keytar`)}this.c={getPassword:(a,g)=>t.$getPassword(a,g),setPassword:(a,g,u)=>t.$setPassword(a,g,u),deletePassword:(a,g)=>t.$deletePassword(a,g),findPassword:a=>t.$findPassword(a),findCredentials(a){return t.$findCredentials(a)}}}load(C,i){const o=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(C){const i=C.length;if(i<=7||!this.b)return;const o=i-7;if((C.charAt(o)==="/"||C.charAt(o)==="\\")&&C.endsWith("keytar")&&(C=C.replace(/\\/g,"/"),this.b.has(C)))return"keytar"}};c=Je([qe(1,E.$DL),qe(2,b.$TL)],c);let f=class{constructor(C,i,o){this.e=C,this.f=i,this.nodeModuleName=["open","opn"],this.d=o.getProxy(h.$BJ.MainThreadTelemetry);const n=o.getProxy(h.$BJ.MainThreadWindow);this.c=(t,a)=>{const g=F.URI.parse(t);return a?this.g(t,a):g.scheme==="http"||g.scheme==="https"?n.$openUri(g,t,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this.f?n.$openUri(g,t,{}):this.g(t,a)}}load(C,i,o){const n=this.e.findSubstr(i);return n&&(this.a=n.identifier.value,this.h()),this.b=o(C),this.c}g(C,i){return this.i(),this.b(C,i)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};f=Je([qe(2,E.$DL)],f)}),define(Se[52],Ce([1,0,54,4,13,41,5,61,62,44,7,37,263,38]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9_b=e.$8_b=void 0,e.$8_b=(0,P.$ph)("IExtHostVariableResolverProvider");class S extends $.$EM{constructor(s,c,f,y,C,i,o){function n(){if(f){const t=f.activeEditor();if(t)return t.document.uri;const a=y.tabGroups.all.find(g=>g.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof R.$lL||a.input instanceof R.$qL)return a.input.modified;if(a.input instanceof R.$kL||a.input instanceof R.$pL||a.input instanceof R.$nL)return a.input.uri}}}super({getFolderUri:t=>{const a=i.folders.filter(g=>g.name===t);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(t,a)=>C.getConfiguration(void 0,t).get(a),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const t=n();if(t)return h.$$b(t.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const t=n();if(t){const a=c.getWorkspaceFolder(t);if(a)return h.$$b(a.uri.fsPath)}}},getSelectedText:()=>{if(f){const t=f.activeEditor();if(t&&!t.selection.isEmpty)return t.document.getText(t.selection)}},getLineNumber:()=>{if(f){const t=f.activeEditor();if(t)return String(t.selection.end.line+1)}},getExtension:t=>s.getExtension(t)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(A.env))}}let p=class extends F.$lb{constructor(s,c,f,y,C){super(),this.b=s,this.c=c,this.g=f,this.h=y,this.i=C,this.a=new k.$T(async()=>{const i=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async t=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.i,i,n,this.j())})}getResolver(){return this.a.value}j(){}};e.$9_b=p,e.$9_b=p=Je([qe(0,b.$z_b),qe(1,I.$4$b),qe(2,m.$OL),qe(3,D.$7$b),qe(4,E.$6_b)],p)}),define(Se[90],Ce([1,0,17,3,14,2,5,6,62,44,20,7,37,134,256,38,52]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bac=e.$aac=e.$__b=e.$$_b=e.$0_b=void 0,e.$0_b=(0,P.$ph)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(n,t,a,g,u,d){this.E=t,this.F=a,this.G=g,this.H=u,this.I=d,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$8c,this.n=new F.$8c,this.o=new F.$8c,this.u=new F.$8c,this.k=n.getProxy(m.$BJ.MainThreadDebugService),this.y=new F.$8c,this.A=new F.$8c,this.v=new f(this.k),this.w=new Map,this.F.getExtensionRegistry().then(v=>{v.onDidChange(l=>{this.J(v)}),this.J(v)})}asDebugSourceUri(n,t){const a=n;if(typeof a.sourceReference=="number"&&a.sourceReference>0){let g=`debug:${encodeURIComponent(a.path||"")}`,u="?";return t&&(g+=`${u}session=${encodeURIComponent(t.id)}`,u="&"),g+=`${u}ref=${a.sourceReference}`,A.URI.parse(g)}else{if(a.path)return A.URI.file(a.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(n){const t=[];for(const a of n.getAllExtensionDescriptions())if(a.contributes){const g=a.contributes.debuggers;if(g&&g.length>0)for(const u of g)(0,S.$9E)(u)&&t.push(u.type)}this.k.$registerDebugTypes(t)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const n=[];return this.w.forEach(t=>n.push(t)),n}addBreakpoints(n){const t=n.filter(u=>{const d=u.id;return this.w.has(d)?!1:(this.w.set(d,u),!0)});this.U(t,[],[]);const a=[],g=new Map;for(const u of t)if(u instanceof I.$DK){let d=g.get(u.location.uri.toString());d||(d={type:"sourceMulti",uri:u.location.uri,lines:[]},g.set(u.location.uri.toString(),d),a.push(d)),d.lines.push({id:u.id,enabled:u.enabled,condition:u.condition,hitCondition:u.hitCondition,logMessage:u.logMessage,line:u.location.range.start.line,character:u.location.range.start.character})}else u instanceof I.$EK&&a.push({type:"function",id:u.id,enabled:u.enabled,hitCondition:u.hitCondition,logMessage:u.logMessage,condition:u.condition,functionName:u.functionName});return this.k.$registerBreakpoints(a)}removeBreakpoints(n){const t=n.filter(d=>this.w.delete(d.id));this.U([],t,[]);const a=t.filter(d=>d instanceof I.$DK).map(d=>d.id),g=t.filter(d=>d instanceof I.$EK).map(d=>d.id),u=t.filter(d=>d instanceof I.$FK).map(d=>d.id);return this.k.$unregisterBreakpoints(a,g,u)}startDebugging(n,t,a){return this.k.$startDebugging(n?n.uri:void 0,t,{parentSessionID:a.parentSession?a.parentSession.id:void 0,lifecycleManagedByParent:a.lifecycleManagedByParent,repl:a.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:a.noDebug,compact:a.compact,suppressSaveBeforeStart:a.suppressSaveBeforeStart,suppressDebugStatusbar:a.suppressDebugStatusbar??a.debugUI?.simple,suppressDebugToolbar:a.suppressDebugToolbar??a.debugUI?.simple,suppressDebugView:a.suppressDebugView??a.debugUI?.simple})}stopDebugging(n){return this.k.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,t,a){if(!t)return new I.$DJ(()=>{});const g=this.d++;return this.f.push({type:n,handle:g,provider:t}),this.k.$registerDebugConfigurationProvider(n,a,!!t.provideDebugConfigurations,!!t.resolveDebugConfiguration,!!t.resolveDebugConfigurationWithSubstitutedVariables,g),new I.$DJ(()=>{this.f=this.f.filter(u=>u.provider!==t),this.k.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(n,t,a){if(!a)return new I.$DJ(()=>{});if(!this.Q(n,t))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${t}' debugger.`);if(this.N(t))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this.g++;return this.h.push({type:t,handle:g,factory:a}),this.k.$registerDebugAdapterDescriptorFactory(t,g),new I.$DJ(()=>{this.h=this.h.filter(u=>u.factory!==a),this.k.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(n,t){if(!t)return new I.$DJ(()=>{});const a=this.i++;return this.j.push({type:n,handle:a,factory:t}),new I.$DJ(()=>{this.j=this.j.filter(g=>g.factory!==t)})}async $runInTerminal(n,t){return Promise.resolve(void 0)}async $substituteVariables(n,t){let a;const g=await this.W(n);return g&&(a={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(a,t)}K(n,t){if(n.type==="implementation")return new C(n.implementation)}L(){}async $startDASession(n,t){const a=this,g=await this.V(t);return this.S(this.N(g.type),g).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const d=this.M(u),v=this.K(d,g);if(!v)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const l=v;return this.B.set(n,l),this.R(g).then(w=>(w&&this.C.set(n,w),l.onMessage(async L=>{if(L.type==="request"&&L.command==="handshake"){const O=L,N={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const T=await this.D.sign(O.arguments.value);N.body={signature:T},l.sendResponse(N)}else throw new Error("no signer")}catch(T){N.success=!1,N.message=T.message,l.sendResponse(N)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(L),L=(0,S.$bF)(L,!0),a.k.$acceptDAMessage(n,L)}),l.onError(L=>{w&&w.onError&&w.onError(L),this.k.$acceptDAError(n,L.name,L.message,L.stack)}),l.onExit(L=>{w&&w.onExit&&w.onExit((0,h.$Be)(L),void 0),this.k.$acceptDAExit(n,(0,h.$Be)(L),void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),l.startSession()))})}$sendDAMessage(n,t){t=(0,S.$aF)(t,!1);const a=this.C.get(n);a&&a.onWillReceiveMessage&&a.onWillReceiveMessage(t),this.B.get(n)?.sendMessage(t)}$stopDASession(n){const t=this.C.get(n);this.C.delete(n),t&&t.onWillStopSession&&t.onWillStopSession();const a=this.B.get(n);return this.B.delete(n),a?a.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const t=[],a=[],g=[];if(n.added)for(const u of n.added){const d=u.id;if(d&&!this.w.has(d)){let v;if(u.type==="function")v=new I.$EK(u.functionName,u.enabled,u.condition,u.hitCondition,u.logMessage);else if(u.type==="data")v=new I.$FK(u.label,u.dataId,u.canPersist,u.enabled,u.hitCondition,u.condition,u.logMessage);else{const l=A.URI.revive(u.uri);v=new I.$DK(new I.$PJ(l,new I.$EJ(u.line,u.character)),u.enabled,u.condition,u.hitCondition,u.logMessage)}(0,I.$BK)(v,d),this.w.set(d,v),t.push(v)}}if(n.removed)for(const u of n.removed){const d=this.w.get(u);d&&(this.w.delete(u),a.push(d))}if(n.changed){for(const u of n.changed)if(u.id){const d=this.w.get(u.id);if(d){if(d instanceof I.$EK&&u.type==="function"){const v=d;v.enabled=u.enabled,v.condition=u.condition,v.hitCondition=u.hitCondition,v.logMessage=u.logMessage,v.functionName=u.functionName}else if(d instanceof I.$DK&&u.type==="source"){const v=d;v.enabled=u.enabled,v.condition=u.condition,v.hitCondition=u.hitCondition,v.logMessage=u.logMessage,v.location=new I.$PJ(A.URI.revive(u.uri),new I.$EJ(u.line,u.character))}g.push(d)}}}this.U(t,a,g)}async $acceptStackFrameFocus(n){let t;const a=n.sessionId?await this.V(n.sessionId):void 0;if(!a)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?t=new I.$LK(a,n.threadId):t=new I.$KK(a,n.threadId,n.frameId),this.z=t,this.A.fire(this.z)}$provideDebugConfigurations(n,t,a){return(0,k.$og)(async()=>{const g=this.P(n);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const u=await this.W(t);return g.provideDebugConfigurations(u,a)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(n,t,a,g){return(0,k.$og)(async()=>{const u=this.P(n);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const d=await this.W(t);return u.resolveDebugConfiguration(d,a,g)})}$resolveDebugConfigurationWithSubstitutedVariables(n,t,a,g){return(0,k.$og)(async()=>{const u=this.P(n);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const d=await this.W(t);return u.resolveDebugConfigurationWithSubstitutedVariables(d,a,g)})}async $provideDebugAdapter(n,t){const a=this.O(n);if(!a)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.V(t);return this.S(a,g).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.M(u)})}async $acceptDebugSessionStarted(n){const t=await this.V(n);this.m.fire(t)}async $acceptDebugSessionTerminated(n){const t=await this.V(n);t&&(this.n.fire(t),this.l.delete(t.id))}async $acceptDebugSessionActiveChanged(n){this.q=n?await this.V(n):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(n,t){(await this.V(n))?._acceptNameChanged(t)}async $acceptDebugSessionCustomEvent(n,t){const g={session:await this.V(n),event:t.event,body:t.body};this.u.fire(g)}M(n){if(n instanceof I.$GK)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof I.$HK)return{type:"server",port:n.port,host:n.host};if(n instanceof I.$IK)return{type:"pipeServer",path:n.path};if(n instanceof I.$JK)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}N(n){const t=this.h.filter(a=>a.type===n);if(t.length>0)return t[0].factory}O(n){const t=this.h.filter(a=>a.handle===n);if(t.length>0)return t[0].factory}P(n){const t=this.f.filter(a=>a.handle===n);if(t.length>0)return t[0].provider}Q(n,t){if(n.contributes){const a=n.contributes.debuggers;if(a&&a.length>0){for(const g of a)if(g.label&&g.type&&g.type===t)return!0}}return!1}R(n){const a=n.configuration.type,g=this.j.filter(u=>u.type===a||u.type==="*").map(u=>(0,k.$og)(()=>u.factory.createDebugAdapterTracker(n)).then(d=>d,d=>null));return Promise.race([Promise.all(g).then(u=>{const d=u.filter(v=>!!v);if(d.length>0)return new y(d)}),new Promise(u=>setTimeout(()=>u(void 0),1e3))]).catch(u=>{})}async S(n,t){const a=t.configuration.debugServer;if(typeof a=="number")return Promise.resolve(new I.$HK(a));if(n){const u=await this.F.getExtensionRegistry();return(0,k.$og)(()=>n.createDebugAdapterDescriptor(t,this.T(t,u))).then(d=>{if(d)return d})}const g=await this.F.getExtensionRegistry();return Promise.resolve(this.T(t,g))}T(n,t){}U(n,t,a){(n.length>0||t.length>0||a.length>0)&&this.y.fire(Object.freeze({added:n,removed:t,changed:a}))}async V(n){if(n)if(typeof n=="string"){const t=this.l.get(n);if(t)return t}else{let t=this.l.get(n.id);if(!t){const a=await this.W(n.folderUri),g=n.parent?this.l.get(n.parent):void 0;t=new c(this.k,n.id,n.type,n.name,a,n.configuration,g),this.l.set(t.id,t),this.k.$sessionCached(t.id)}return t}throw new Error("cannot find session")}W(n){if(n){const t=A.URI.revive(n);return this.E.resolveWorkspaceFolder(t)}return Promise.resolve(void 0)}};e.$$_b=s,e.$$_b=s=Je([qe(0,R.$DL),qe(1,$.$4$b),qe(2,b.$z_b),qe(3,p.$7$b),qe(4,E.$6_b),qe(5,r.$8_b)],s);class c{constructor(n,t,a,g,u,d,v){this.d=n,this.f=t,this.g=a,this.h=g,this.i=u,this.j=d,this.k=v}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(n){this.h=n,this.d.$setDebugSessionName(this.f,n)}get parentSession(){return this.k}_acceptNameChanged(n){this.h=n}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(n,t){return this.d.$customDebugAdapterRequest(this.f,n,t)}getDebugProtocolBreakpoint(n){return this.d.$getDebugProtocolBreakpoint(this.f,n.id)}}e.$__b=c;class f{constructor(n){this.value=Object.freeze({append(t){n.$appendDebugConsole(t)},appendLine(t){this.append(t+`
`)}})}}e.$aac=f;class y{constructor(n){this.d=n}onWillStartSession(){this.d.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.d.forEach(t=>t.onWillReceiveMessage?t.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.d.forEach(t=>t.onDidSendMessage?t.onDidSendMessage(n):void 0)}onWillStopSession(){this.d.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.d.forEach(t=>t.onError?t.onError(n):void 0)}onExit(n,t){this.d.forEach(a=>a.onExit?a.onExit(n,t):void 0)}}class C extends D.$C${constructor(n){super(),this.h=n,n.onDidSendMessage(t=>{this.acceptMessage(t)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.h.handleMessage(n)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends s{constructor(n,t,a,g,u,d){super(n,t,a,g,u,d)}};e.$bac=i,e.$bac=i=Je([qe(0,R.$DL),qe(1,$.$4$b),qe(2,b.$z_b),qe(3,p.$7$b),qe(4,E.$6_b),qe(5,r.$8_b)],i)}),define(Se[332],Ce([1,0,8,89,2,6,324,18,98,99,26,227,20,58,44,83]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=e.$Uac=void 0;class r{static async installEarlyHandler(f){Error.stackTraceLimit=100;const y=f.get(m.$Ri),i=f.get($.$DL).getProxy(A.$BJ.MainThreadErrors);k.setUnexpectedErrorHandler(o=>{y.error(o);const n=k.$1(o);i.$onUnexpectedError(n)})}static async installFullHandler(f){const y=f.get(m.$Ri),C=f.get($.$DL),i=f.get(S.$z_b),o=f.get(p.$XL),n=C.getProxy(A.$BJ.MainThreadExtensionService),t=C.getProxy(A.$BJ.MainThreadErrors),a=await i.getExtensionPathIndex(),g=new WeakMap;function u(l,w){if(g.has(l))return g.get(l).stack;let L="",O,N;for(const j of w)L+=`
	at ${j.toString()}`,N=j.getFileName(),!O&&N&&(O=a.findSubstr(h.URI.file(N)));const T=`${l.name||"Error"}: ${l.message||""}${L}`;return g.set(l,{extensionIdentifier:O?.identifier,stack:T}),T}const d=Symbol("prepareStackTrace wrapped");let v=u;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(l){if(l===u||l[d]){v=l;return}v=function(w,L){return u(w,L),l.call(Error,w,L)},Object.assign(v,{[d]:!0})}}),k.setUnexpectedErrorHandler(l=>{y.error(l);const w=k.$1(l),L=g.get(l);if(!L?.extensionIdentifier){t.$onUnexpectedError(w);return}n.$onExtensionRuntimeError(L.extensionIdentifier,w);const O=o.onExtensionError(L.extensionIdentifier,l);y.trace("forwarded error to extension?",O,L)})}}e.$Uac=r;class s{constructor(f,y,C,i,o){this.a=C,this.b=new P.$A1b(f,null,i),y=s.e(y,this.b);const n=new b.$nh(...(0,E.$ar)());n.set(R.$TL,{_serviceBrand:void 0,...y,messagePorts:o}),n.set($.$DL,new $.$EL(this.b)),n.set(D.$1$b,new D.$2$b(i)),n.set(S.$x_b,C);const t=new I.$Up(n,!0);t.invokeFunction(r.installEarlyHandler),this.d=t.invokeFunction(a=>a.get(m.$Ri)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",y),this.c=t.invokeFunction(a=>a.get(S.$z_b)),this.c.initialize(),t.invokeFunction(r.installFullHandler)}async asBrowserUri(f){const y=this.b.getProxy(A.$BJ.MainThreadExtensionService);return h.URI.revive(await y.$asBrowserUri(f))}terminate(f){this.c.terminate(f)}static e(f,y){f.allExtensions.forEach(i=>{i.extensionLocation=h.URI.revive(y.transformIncomingURIs(i.extensionLocation))}),f.environment.appRoot=h.URI.revive(y.transformIncomingURIs(f.environment.appRoot));const C=f.environment.extensionDevelopmentLocationURI;return C&&(f.environment.extensionDevelopmentLocationURI=C.map(i=>h.URI.revive(y.transformIncomingURIs(i)))),f.environment.extensionTestsLocationURI=h.URI.revive(y.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=h.URI.revive(y.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=h.URI.revive(y.transformIncomingURIs(f.environment.workspaceStorageHome)),f.environment.extensionTelemetryLogResource=h.URI.revive(y.transformIncomingURIs(f.environment.extensionTelemetryLogResource)),f.nlsBaseUrl=h.URI.revive(y.transformIncomingURIs(f.nlsBaseUrl)),f.logsLocation=h.URI.revive(y.transformIncomingURIs(f.logsLocation)),f.workspace=y.transformIncomingURIs(f.workspace),f}}e.$Vac=s}),define(Se[333],Ce([1,0,17,11,205,221,237,90,62,44,20,43,7,52,37,257,258,38]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ac=void 0;let c=class extends m.$$_b{constructor(o,n,t,a,g,u,d){super(o,n,t,a,u,d),this.Z=g,this.X=new C}K(o,n){switch(o.type){case"server":return new p.$1ac(o);case"pipeServer":return new p.$2ac(o);case"executable":return new p.$3ac(o,n.type)}return super.K(o,n)}T(o,n){const t=p.$3ac.platformAdapterExecutable(n.getAllExtensionDescriptions(),o.type);if(t)return new $.$GK(t.command,t.args,t.options)}L(){return new P.$$4b}async $runInTerminal(o,n){if(o.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(T=>{this.X.onTerminalClosed(T)}));const t=await this.G.getConfigProvider(),a=this.Z.getDefaultShell(!0),g=this.Z.getDefaultShellArgs(!0),u=o.title||h.localize(0,null),d=JSON.stringify({shell:a,shellArgs:g});let v=await this.X.checkout(d,u),l,w=!1;if(v)l=o.cwd;else{const T={shellPath:a,shellArgs:g,cwd:o.cwd,name:u,iconPath:new $.$yK("debug")};w=!0,v=this.Z.createTerminalFromOptions(T,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(v,d)}v.show(!0);const L=await v.processId;w?await new Promise(T=>setTimeout(T,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?v.sendText("cls"):a.indexOf("bash")>=0?v.sendText("clear"):F.$i?v.sendText("cls"):v.sendText("clear"));const O=(0,r.$5ac)(a,o.args,!!o.argsCanBeInterpretedByShell,l,o.env);v.sendText(O);const N=this.onDidTerminateDebugSession(T=>{T.id===n&&(this.X.free(v),N.dispose())});return L}else if(o.kind==="external")return y(o,await this.G.getConfigProvider());return super.$runInTerminal(o,n)}};e.$6ac=c,e.$6ac=c=Je([qe(0,R.$DL),qe(1,S.$4$b),qe(2,b.$z_b),qe(3,s.$7$b),qe(4,I.$m_b),qe(5,E.$6_b),qe(6,D.$8_b)],c);let f;function y(i,o){if(!f)if(F.$i)f=new A.$W3b;else if(F.$j)f=new A.$X3b;else if(F.$k)f=new A.$Y3b;else throw new Error("external terminals not supported on this platform");const n=o.getConfiguration("terminal");return f.runInTerminal(i.title,i.cwd,i.args,i.env||{},n.external||{})}class C{constructor(){this.b=new Map}static{this.a=1e3}async checkout(o,n){const a=[...this.b.entries()].map(([g,u])=>(0,k.$jg)(async d=>{if(g.name!==n||u.lastUsedAt!==-1&&await(0,r.$4ac)(await g.processId))return null;const v=Date.now();return u.lastUsedAt+C.a>v||d.isCancellationRequested||u.config!==o?null:(u.lastUsedAt=v,g)}));return await(0,k.$Ag)(a,g=>!!g)}insert(o,n){this.b.set(o,{lastUsedAt:Date.now(),config:n})}free(o){const n=this.b.get(o);n&&(n.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}}),define(Se[334],Ce([1,0,13,2,96,37,61,38,50,43,20,26,88,15,18,84,24,75,52]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xac=void 0;let f=class extends $.$3_b{constructor(C,i,o,n,t,a,g,u,d){super(C,i,o,n,t,a,g,u),this.B=o,this.C=d,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(D.Schemas.vscodeRemote,{scheme:D.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(D.Schemas.file,{scheme:D.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(C,i){const o=i;if(!i.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const n=$.TaskHandleDTO.from(o,this.B),t=await this.a.$getTaskExecution(n);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.y(t,i);return this.a.$executeTask(n).catch(()=>{}),a}else{const n=$.TaskDTO.from(i,C);if(n===void 0)return Promise.reject(new Error("Task is not valid"));$.CustomExecutionDTO.is(n.execution)&&await this.x(n,i,!1);const t=await this.y(await this.a.$getTaskExecution(n),i);return this.a.$executeTask(n).catch(()=>{}),t}}u(C,i,o,n){const t=[];if(n)for(const a of n){this.z(a,o),(!a.definition||!C[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const g=$.TaskDTO.from(a,o.extension);g&&(t.push(g),$.CustomExecutionDTO.is(g.execution)&&i.push(this.x(g,a,!0)))}return{tasks:t,extension:o.extension}}async v(C){return C}async F(C){let i=C&&C.length>0?C[0]:void 0;if(!i){const o=F.URI.file((0,s.homedir)());i=new E.$Jh({uri:o,name:r.$7f(o),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(C,i){const o=F.URI.revive(C),n={process:void 0,variables:Object.create(null)},t=await this.b.resolveWorkspaceFolder(o),a=await this.b.getWorkspaceFolders2()??[],g=await this.C.getResolver(),u=t?{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(a);for(const d of i.variables)n.variables[d]=await g.resolveAsync(u,d);if(i.process!==void 0){let d;if(i.process.path!==void 0){d=i.process.path.split(k.$kc);for(let v=0;v<d.length;v++)d[v]=await g.resolveAsync(u,d[v])}n.process=await h.win32.findExecutable(await g.resolveAsync(u,i.process.name),i.process.cwd!==void 0?await g.resolveAsync(u,i.process.cwd):void 0,d)}return n}async $jsonTasksSupported(){return!0}async $findExecutable(C,i,o){return h.win32.findExecutable(C,i,o)}};e.$Xac=f,e.$Xac=f=Je([qe(0,R.$DL),qe(1,I.$TL),qe(2,A.$4$b),qe(3,P.$OL),qe(4,m.$7$b),qe(5,b.$m_b),qe(6,S.$Ri),qe(7,p.$T$b),qe(8,c.$8_b)],f)}),define(Se[335],Ce([1,0,75,52]),function(fe,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=void 0;class h extends F.$9_b{j(){return(0,k.homedir)()}}e.$Dbc=h}),define(Se[146],Ce([1,0,19,17,21,45,15,13,24,2,35]),function(fe,e,k,F,h,A,P,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gac=e.$fac=e.$eac=e.$dac=void 0;class I{constructor(c,f,y,C){this.d=c,this.e=f,this.f=y,this.g=C,this.a=null,this.b=!1,this.c=0}search(c,f){const y=this.d.folderQueries||[],C=new h.$ed;return f.onCancellationRequested(()=>C.cancel()),new Promise((i,o)=>{this.a=new D(c);let n=!1;const t=(a,g)=>{if(!n&&!this.b){const u=this.h(a);p(a)&&typeof this.d.maxResults=="number"&&this.c+u>this.d.maxResults&&(this.b=!0,n=!0,C.cancel(),a=this.j(a,this.d.maxResults-this.c));const d=this.h(a);this.c+=d,(d>0||!p(a))&&this.a.add(a,g)}};Promise.all(y.map((a,g)=>this.k(a,u=>t(u,g),C.token))).then(a=>{C.dispose(),this.a.flush();const g=a.some(u=>!!u&&!!u.limitHit);i({limitHit:this.b||g,messages:(0,k.$yf)(a.map(u=>u?.message?Array.isArray(u.message)?u.message:[u.message]:[])),stats:{type:this.g}})},a=>{C.dispose();const g=(0,A.$ai)(a);o(new Error(g))})})}h(c){return p(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,f){const y=Array.isArray(c.ranges)?c.ranges:[c.ranges],C=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:y.slice(0,f),preview:{matches:C.slice(0,f),text:c.preview.text},uri:c.uri}}async k(c,f,y){const C=new R.$fI(this.d,c),i=[],o={report:a=>{if(!this.l(a))return;const g=c.folder.scheme===P.Schemas.file?(0,R.$gI)(()=>this.f.readdir(E.$9f(a.uri))):void 0,u=E.$_f(c.folder,a.uri);if(u){const d=C.includedInQuery(u,m.$ec(u),g);(0,F.$ig)(d)?i.push(d.then(v=>{v&&f(a)})):d&&f(a)}}},n=this.n(c),t=await this.e.provideTextSearchResults($(this.d.contentPattern),n,o,y);return i.length&&await Promise.all(i),t}l(c){if(p(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const f=(0,R.$eI)(this.d.includePattern,c.includePattern),y=(0,R.$eI)(this.d.excludePattern,c.excludePattern),C={folder:b.URI.from(c.folder),excludes:y,includes:f,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return C.usePCRE2=this.d.usePCRE2,C}}e.$dac=I;function $(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class D{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new r(512,f=>this.g(f))}add(c,f){this.d&&(this.b!==f||!E.$3f(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=f,this.d={resource:c.uri,results:[]}),this.d.results.push(S(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$eac=D;function S(s){return p(s)?{preview:{matches:(0,k.$If)(s.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:s.preview.text},ranges:(0,k.$If)(s.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function p(s){return!!s.preview}e.$fac=p;class r{static{this.a=4e3}static{this.b=50}constructor(c,f){this.g=c,this.h=f,this.c=0,this.d=[],this.e=0}addItem(c,f){c&&this.j(c,f)}addItems(c,f){c&&this.k(c,f)}j(c,f){this.d.push(c),this.e+=f,this.l()}k(c,f){this.d=this.d.concat(c),this.e+=f,this.l()}l(){this.c<r.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},r.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$gac=r}),define(Se[91],Ce([1,0,4,6,5,328,20,58,18,2,146]),function(fe,e,k,F,h,A,P,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jac=e.$iac=e.$hac=void 0,e.$hac=(0,h.$ph)("IExtHostSearch");let I=class{constructor(p,r,s){this.k=p,this.l=r,this.n=s,this.c=this.k.getProxy(F.$BJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new A.$cac}o(p){return this.l.transformOutgoingScheme(p)}registerTextSearchProvider(p,r){if(this.g.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this.g.add(p);const s=this.d++;return this.e.set(s,r),this.c.$registerTextSearchProvider(s,this.o(p)),(0,k.$jb)(()=>{this.g.delete(p),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(p,r){if(this.i.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this.i.add(p);const s=this.d++;return this.h.set(s,r),this.c.$registerFileSearchProvider(s,this.o(p)),(0,k.$jb)(()=>{this.i.delete(p),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(p,r,s,c){const f=$(s),y=this.h.get(p);if(y)return this.j.fileSearch(f,y,C=>{this.c.$handleFileMatch(p,r,C.map(i=>i.resource))},c);throw new Error("unknown provider: "+p)}$clearCache(p){return this.j.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,r,s,c){const f=this.e.get(p);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const y=$(s);return this.q(y,f).search(i=>this.c.$handleTextMatch(p,r,i),c)}$enableExtensionHostSearch(){}q(p,r){return new R.$dac(p,r,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$iac=I,e.$iac=I=Je([qe(0,P.$DL),qe(1,m.$1$b),qe(2,E.$Ri)],I);function $(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(D),extraFileResources:S.extraFileResources&&S.extraFileResources.map(p=>b.URI.revive(p))}}e.$jac=$;function D(S){return{...S,folder:b.URI.revive(S.folder)}}}),define(Se[336],Ce([1,0,21,8,3,40,2,124,117,161,177,30,6,105,283,282,36,284,38,286,287,288,265,289,61,44,290,291,296,297,298,145,269,304,305,308,109,43,310,273,16,7,80,313,86,144,37,25,261,295,79,142,88,90,91,18,58,20,26,299,259,64,84,279,311,85,63,316,314,315,280,51,309,312,108,62,83,300,87,301,15,127,268,248,293,4,27,255,106,244,302,303,281,292,267,306,294,107,307]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c,f,y,C,i,o,n,t,a,g,u,d,v,l,w,L,O,N,T,j,W,M,Y,V,de,re,x,q,ne,pe,H,ue,ce,z,ie,Ee,Re,ye,X,he,K,oe,_,le,$e,U,G,Z,ee,be,se,we,Ie,je,Ve,_e,Ge,et,Qe,st,tt,Pe,ke,Be,te,Q,ve,Ue,Ne,Ye,xe,rt,ft,vt,Ft,Lt,Et,Tt,Ot,zt,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=void 0;function Mt(at){const dt=at.get(K.$TL),Wt=at.get(je.$Q$b),Nt=at.get(ee.$j_b),Dt=at.get(t.$z_b),ct=at.get(ne.$4$b),At=at.get(Qe.$XL),jt=at.get(c.$7$b),Te=at.get(X.$1$b),Le=at.get(he.$DL),Ae=at.get(T.$f_b),ae=at.get(Z.$k_b),Oe=at.get(ye.$Si),We=at.get(ye.$Ri),Ze=at.get(le.$Wpb),He=at.get($e.$T$b),it=at.get(q.$X_b),wt=at.get(Ge.$r_b),St=at.get(et.$6_b),Ct=at.get(zt.$v_b);Le.set($.$CJ.ExtHostFileSystemInfo,Wt),Le.set($.$CJ.ExtHostLogLevelServiceShape,Oe),Le.set($.$CJ.ExtHostWorkspace,ct),Le.set($.$CJ.ExtHostConfiguration,jt),Le.set($.$CJ.ExtHostExtensionService,Dt),Le.set($.$CJ.ExtHostStorage,Ae),Le.set($.$CJ.ExtHostTunnelService,Ze),Le.set($.$CJ.ExtHostWindow,it),Le.set($.$CJ.ExtHostSecretState,wt),Le.set($.$CJ.ExtHostTelemetry,At),Le.set($.$CJ.ExtHostEditorTabs,St),Le.set($.$CJ.ExtHostManagedSockets,Ct);const pt=Le.set($.$CJ.ExtHostDecorations,at.get(z.$2_b)),$t=Le.set($.$CJ.ExtHostDocumentsAndEditors,at.get(n.$OL)),ht=Le.set($.$CJ.ExtHostCommands,at.get(r.$ZL)),bt=Le.set($.$CJ.ExtHostTerminalService,at.get(j.$m_b)),gt=Le.set($.$CJ.ExtHostDebugService,at.get(Ee.$0_b)),Qt=Le.set($.$CJ.ExtHostSearch,at.get(Re.$hac)),qt=Le.set($.$CJ.ExtHostTask,at.get(ie.$5_b)),Xi=Le.set($.$CJ.ExtHostOutputService,at.get(l.$H_b)),hi=Le.set($.$CJ.ExtHostLocalization,at.get(xe.$u_b)),di=Le.set($.$CJ.ExtHostUrls,new re.$Q_b(Le)),It=Le.set($.$CJ.ExtHostDocuments,new o.$O$b(Le,$t)),yi=Le.set($.$CJ.ExtHostDocumentContentProviders,new C.$9$b(Le,$t,We)),Ht=Le.set($.$CJ.ExtHostDocumentSaveParticipant,new i.$0$b(We,It,Le.getProxy($.$BJ.MainThreadBulkEdits))),kt=Le.set($.$CJ.ExtHostNotebook,new oe.$nac(Le,ht,$t,It,Nt)),Ei=Le.set($.$CJ.ExtHostNotebookDocuments,new Q.$Fac(kt)),fi=Le.set($.$CJ.ExtHostNotebookEditors,new te.$Eac(We,kt)),ai=Le.set($.$CJ.ExtHostNotebookKernels,new st.$Bac(Le,dt,kt,ht,We)),_i=Le.set($.$CJ.ExtHostNotebookRenderers,new Pe.$Dac(Le,kt)),ni=Le.set($.$CJ.ExtHostNotebookDocumentSaveParticipant,new Et.$Lac(We,kt,Le.getProxy($.$BJ.MainThreadBulkEdits))),Rt=Le.set($.$CJ.ExtHostEditors,new W.$O_b(Le,$t)),mi=Le.set($.$CJ.ExtHostTreeViews,new M.$P_b(Le.getProxy($.$BJ.MainThreadTreeViews),ht,We)),ki=Le.set($.$CJ.ExtHostEditorInsets,new H.$Y_b(Le.getProxy($.$BJ.MainThreadEditorInsets),Rt,dt.remote)),ri=Le.set($.$CJ.ExtHostDiagnostics,new f.$S$b(Le,We,Wt,$t)),si=Le.set($.$CJ.ExtHostLanguages,new d.$E_b(Le,It,ht.converter,Te)),ut=Le.set($.$CJ.ExtHostLanguageFeatures,new u.$W$b(Le,Te,It,ht,ri,We,He,At)),Di=Le.set($.$CJ.ExtHostFileSystem,new a.$C_b(Le,ut)),Kt=Le.set($.$CJ.ExtHostFileSystemEventService,new g.$D_b(Le,We,$t)),xt=Le.set($.$CJ.ExtHostQuickOpen,(0,L.$J_b)(Le,ct,ht)),gi=Le.set($.$CJ.ExtHostSCM,new O.$L_b(Le,ht,It,We)),zi=Le.set($.$CJ.ExtHostQuickDiff,new vt.$Iac(Le,Te)),Si=Le.set($.$CJ.ExtHostShare,new Bt.$Oac(Le,Te)),Ci=Le.set($.$CJ.ExtHostComments,(0,s.$Z$b)(Le,ht,It)),$i=Le.set($.$CJ.ExtHostProgress,new w.$I_b(Le.getProxy($.$BJ.MainThreadProgress))),Ii=Le.set($.$CJ.ExtHosLabelService,new ue.$Z_b(Le)),Pi=Le.set($.$CJ.ExtHostTheming,new _.$oac(Le)),ei=Le.set($.$CJ.ExtHostAuthentication,new U.$pac(Le)),Ai=Le.set($.$CJ.ExtHostTimeline,new G.$rac(Le,ht)),bi=Le.set($.$CJ.ExtHostWebviews,new x.$T_b(Le,dt.remote,ct,We,He)),pi=Le.set($.$CJ.ExtHostWebviewPanels,new we.$tac(Le,bi,ct)),ji=Le.set($.$CJ.ExtHostCustomEditors,new se.$uac(Le,It,ae,bi,pi)),Ui=Le.set($.$CJ.ExtHostWebviewViews,new be.$sac(Le,bi)),oi=Le.set($.$CJ.ExtHostTesting,new Ve.$wac(Le,ht,$t)),xi=Le.set($.$CJ.ExtHostUriOpeners,new _e.$Aac(Le)),en=Le.set($.$CJ.ExtHostProfileContentHandlers,new ft.$Hac(Le));Le.set($.$CJ.ExtHostInteractive,new ve.$Gac(Le,kt,$t,ht,We));const Li=Le.set($.$CJ.ExtHostInlineChat,new Lt.$Kac(Le,ht,It,We)),Xt=Le.set($.$CJ.ExtHostChat,new Ft.$Jac(Le,We)),tn=Le.set($.$CJ.ExtHostSemanticSimilarity,new Tt.$Mac(Le)),nn=Le.set($.$CJ.ExtHostIssueReporter,new Ot.$Nac(Le)),Ri=Le.set($.$CJ.ExtHostStatusBar,new N.$N_b(Le,ht.converter)),Fi=Object.values($.$CJ);Le.assertRegistered(Fi);const Bi=new Ie.$vac(Le,$t),Wi=new p.$Y$b(Le),wi=new v.$F_b(Le,We),qi=new y.$8$b(Le);return S.$X$b.register(ht),function(ze,Gt,Zt){const mt=function(){let me=!ze.isUnderDevelopment;function De(){me||(We.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function Me(nt){if(Array.isArray(nt))nt.forEach(Me);else if(typeof nt=="string")De();else{const yt=nt;typeof yt.scheme>"u"&&De(),typeof yt.exclusive=="boolean"&&(0,Ne.$zF)(ze,"documentFiltersExclusive")}return nt}}(),rn={getSession(me,De,Me){return ei.getSession(ze,me,De,Me)},getSessions(me,De){return(0,Ne.$zF)(ze,"authGetSessions"),ei.getSessions(ze,me,De)},async hasSession(me,De){return(0,Ne.$zF)(ze,"authSession"),!!await ei.getSession(ze,me,De,{silent:!0})},get onDidChangeSessions(){return ei.onDidChangeSessions},registerAuthenticationProvider(me,De,Me,nt){return ei.registerAuthenticationProvider(me,De,Me,nt)}},Vt={registerCommand(me,De,Me){return ht.registerCommand(!0,me,De,Me,void 0,ze)},registerTextEditorCommand(me,De,Me){return ht.registerCommand(!0,me,(...nt)=>{const yt=Rt.getActiveTextEditor();if(!yt){We.warn("Cannot execute "+me+" because there is no active text editor.");return}return yt.edit(Pt=>{De.apply(Me,[yt,Pt,...nt])}).then(Pt=>{Pt||We.warn("Edits from command "+me+" were not applied.")},Pt=>{We.warn("An error occurred while running command "+me,Pt)})},void 0,void 0,ze)},registerDiffInformationCommand:(me,De,Me)=>((0,Ne.$zF)(ze,"diffCommand"),ht.registerCommand(!0,me,async(...nt)=>{const yt=$t.activeEditor(!0);if(!yt){We.warn("Cannot execute "+me+" because there is no active text editor.");return}const Pt=await Rt.getDiffInformation(yt.id);De.apply(Me,[Pt,...nt])},void 0,void 0,ze)),executeCommand(me,...De){return ht.executeCommand(me,...De)},getCommands(me=!1){return ht.getCommands(me)}},ci={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return Wi.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ne.$zF)(ze,"envShellEvent"),bt.onDidChangeShell},get isTelemetryEnabled(){return At.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return At.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.$zF)(ze,"telemetry"),At.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.$zF)(ze,"telemetry"),At.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Qe.$WL)(dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(me,De){return Qe.$VL.validateSender(me),At.instantiateLogger(ze,me,De)},openExternal(me,De){return it.openUri(me,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:De?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===dt.environment.appUriScheme)return di.createAppUri(me);try{return await it.asExternalUri(me,{allowTunneling:!!dt.remote.authority})}catch(De){if((0,Be.$_Y)(me,ke.Schemas.http)||(0,Be.$_Y)(me,ke.Schemas.https))return me;throw De}},get remoteName(){return(0,ce.$Ck)(dt.remote.authority)},get remoteAuthority(){return(0,Ne.$zF)(ze,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind},get logLevel(){return We.getLevel()},get onDidChangeLogLevel(){return We.onDidChangeLogLevel},registerIssueUriRequestHandler(me){return(0,Ne.$zF)(ze,"handleIssueUri"),nn.registerIssueUriRequestHandler(ze,me)},get appQuality(){return(0,Ne.$zF)(ze,"resolvers"),dt.quality},get appCommit(){return(0,Ne.$zF)(ze,"resolvers"),dt.commit}};dt.environment.extensionTestsLocationURI||Object.freeze(ci);const Vi={createTestController(me,De,Me){return oi.createTestController(ze,me,De,Me)},createTestObserver(){return(0,Ne.$zF)(ze,"testObserver"),oi.createTestObserver()},runTests(me){return(0,Ne.$zF)(ze,"testObserver"),oi.runTests(me)},get onDidChangeTestResults(){return(0,Ne.$zF)(ze,"testObserver"),oi.onResultsChanged},get testResults(){return(0,Ne.$zF)(ze,"testObserver"),oi.results}},ui=dt.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,Ji={getExtension(me,De){(0,Ne.$yF)(ze,"extensionsAny")||(De=!1);const Me=Gt.mine.getExtensionDescription(me);if(Me)return new t.$A_b(Dt,ze.identifier,Me,ui,!1);if(De){const nt=Gt.all.getExtensionDescription(me);if(nt)return new t.$A_b(Dt,ze.identifier,nt,ui,!0)}},get all(){const me=[];for(const De of Gt.mine.getAllExtensionDescriptions())me.push(new t.$A_b(Dt,ze.identifier,De,ui,!1));return me},get allAcrossExtensionHosts(){(0,Ne.$zF)(ze,"extensionsAny");const me=new pe.$Il(Gt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),De=[];for(const Me of Gt.all.getAllExtensionDescriptions()){const nt=!me.has(Me.identifier);De.push(new t.$A_b(Dt,ze.identifier,Me,ui,nt))}return De},get onDidChange(){return(0,Ne.$yF)(ze,"extensionsAny")?h.Event.any(Gt.mine.onDidChange,Gt.all.onDidChange):Gt.mine.onDidChange}},Hi={createDiagnosticCollection(me){return ri.createDiagnosticCollection(ze.identifier,me)},get onDidChangeDiagnostics(){return ri.onDidChangeDiagnostics},getDiagnostics:me=>ri.getDiagnostics(me),getLanguages(){return si.getLanguages()},setTextDocumentLanguage(me,De){return si.changeLanguage(me.uri,De)},match(me,De){const Me=It.getDocumentData(De.uri)?.notebook;return(0,R.$YE)(Y.LanguageSelector.from(me),De.uri,De.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(me,De,Me){return ut.registerCodeActionProvider(ze,mt(me),De,Me)},registerDocumentPasteEditProvider(me,De,Me){return(0,Ne.$zF)(ze,"documentPaste"),ut.registerDocumentPasteEditProvider(ze,mt(me),De,Me)},registerCodeLensProvider(me,De){return ut.registerCodeLensProvider(ze,mt(me),De)},registerDefinitionProvider(me,De){return ut.registerDefinitionProvider(ze,mt(me),De)},registerDeclarationProvider(me,De){return ut.registerDeclarationProvider(ze,mt(me),De)},registerImplementationProvider(me,De){return ut.registerImplementationProvider(ze,mt(me),De)},registerTypeDefinitionProvider(me,De){return ut.registerTypeDefinitionProvider(ze,mt(me),De)},registerHoverProvider(me,De){return ut.registerHoverProvider(ze,mt(me),De,ze.identifier)},registerEvaluatableExpressionProvider(me,De){return ut.registerEvaluatableExpressionProvider(ze,mt(me),De,ze.identifier)},registerInlineValuesProvider(me,De){return ut.registerInlineValuesProvider(ze,mt(me),De,ze.identifier)},registerDocumentHighlightProvider(me,De){return ut.registerDocumentHighlightProvider(ze,mt(me),De)},registerLinkedEditingRangeProvider(me,De){return ut.registerLinkedEditingRangeProvider(ze,mt(me),De)},registerReferenceProvider(me,De){return ut.registerReferenceProvider(ze,mt(me),De)},registerRenameProvider(me,De){return ut.registerRenameProvider(ze,mt(me),De)},registerDocumentSymbolProvider(me,De,Me){return ut.registerDocumentSymbolProvider(ze,mt(me),De,Me)},registerWorkspaceSymbolProvider(me){return ut.registerWorkspaceSymbolProvider(ze,me)},registerDocumentFormattingEditProvider(me,De){return ut.registerDocumentFormattingEditProvider(ze,mt(me),De)},registerDocumentRangeFormattingEditProvider(me,De){return ut.registerDocumentRangeFormattingEditProvider(ze,mt(me),De)},registerOnTypeFormattingEditProvider(me,De,Me,...nt){return ut.registerOnTypeFormattingEditProvider(ze,mt(me),De,[Me].concat(nt))},registerDocumentSemanticTokensProvider(me,De,Me){return ut.registerDocumentSemanticTokensProvider(ze,mt(me),De,Me)},registerDocumentRangeSemanticTokensProvider(me,De,Me){return ut.registerDocumentRangeSemanticTokensProvider(ze,mt(me),De,Me)},registerSignatureHelpProvider(me,De,Me,...nt){return typeof Me=="object"?ut.registerSignatureHelpProvider(ze,mt(me),De,Me):ut.registerSignatureHelpProvider(ze,mt(me),De,typeof Me>"u"?[]:[Me,...nt])},registerCompletionItemProvider(me,De,...Me){return ut.registerCompletionItemProvider(ze,mt(me),De,Me)},registerInlineCompletionItemProvider(me,De,Me){return De.handleDidShowCompletionItem&&(0,Ne.$zF)(ze,"inlineCompletionsAdditions"),De.handleDidPartiallyAcceptCompletionItem&&(0,Ne.$zF)(ze,"inlineCompletionsAdditions"),Me&&(0,Ne.$zF)(ze,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(ze,mt(me),De,Me)},registerDocumentLinkProvider(me,De){return ut.registerDocumentLinkProvider(ze,mt(me),De)},registerColorProvider(me,De){return ut.registerColorProvider(ze,mt(me),De)},registerFoldingRangeProvider(me,De){return ut.registerFoldingRangeProvider(ze,mt(me),De)},registerSelectionRangeProvider(me,De){return ut.registerSelectionRangeProvider(ze,me,De)},registerCallHierarchyProvider(me,De){return ut.registerCallHierarchyProvider(ze,me,De)},registerTypeHierarchyProvider(me,De){return ut.registerTypeHierarchyProvider(ze,me,De)},setLanguageConfiguration:(me,De)=>ut.setLanguageConfiguration(ze,me,De),getTokenInformationAtPosition(me,De){return(0,Ne.$zF)(ze,"tokenInformation"),si.tokenAtPosition(me,De)},registerInlayHintsProvider(me,De){return ut.registerInlayHintsProvider(ze,me,De)},createLanguageStatusItem(me,De){return si.createLanguageStatusItem(ze,me,De)},registerDocumentDropEditProvider(me,De,Me){return ut.registerDocumentOnDropEditProvider(ze,me,De,(0,Ne.$yF)(ze,"dropMetadata")?Me:void 0)}},sn={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(me,De,Me){const nt=await(P.URI.isUri(me)?Promise.resolve(Ti.openTextDocument(me)):Promise.resolve(me));return Rt.showTextDocument(nt,De,Me)},createTextEditorDecorationType(me){return Rt.createTextEditorDecorationType(ze,me)},onDidChangeActiveTextEditor(me,De,Me){return Rt.onDidChangeActiveTextEditor(me,De,Me)},onDidChangeVisibleTextEditors(me,De,Me){return Rt.onDidChangeVisibleTextEditors(me,De,Me)},onDidChangeTextEditorSelection(me,De,Me){return Rt.onDidChangeTextEditorSelection(me,De,Me)},onDidChangeTextEditorOptions(me,De,Me){return Rt.onDidChangeTextEditorOptions(me,De,Me)},onDidChangeTextEditorVisibleRanges(me,De,Me){return Rt.onDidChangeTextEditorVisibleRanges(me,De,Me)},onDidChangeTextEditorViewColumn(me,De,Me){return Rt.onDidChangeTextEditorViewColumn(me,De,Me)},onDidCloseTerminal(me,De,Me){return bt.onDidCloseTerminal(me,De,Me)},onDidOpenTerminal(me,De,Me){return bt.onDidOpenTerminal(me,De,Me)},onDidChangeActiveTerminal(me,De,Me){return bt.onDidChangeActiveTerminal(me,De,Me)},onDidChangeTerminalDimensions(me,De,Me){return(0,Ne.$zF)(ze,"terminalDimensions"),bt.onDidChangeTerminalDimensions(me,De,Me)},onDidChangeTerminalState(me,De,Me){return bt.onDidChangeTerminalState(me,De,Me)},onDidWriteTerminalData(me,De,Me){return(0,Ne.$zF)(ze,"terminalDataWriteEvent"),bt.onDidWriteTerminalData(me,De,Me)},get state(){return it.getState(ze)},onDidChangeWindowState(me,De,Me){return it.onDidChangeWindowState(me,De,Me)},showInformationMessage(me,...De){return wi.showMessage(ze,A.default.Info,me,De[0],De.slice(1))},showWarningMessage(me,...De){return wi.showMessage(ze,A.default.Warning,me,De[0],De.slice(1))},showErrorMessage(me,...De){return wi.showMessage(ze,A.default.Error,me,De[0],De.slice(1))},showQuickPick(me,De,Me){return xt.showQuickPick(ze,me,De,Me)},showWorkspaceFolderPick(me){return xt.showWorkspaceFolderPick(me)},showInputBox(me,De){return xt.showInput(me,De)},showOpenDialog(me){return qi.showOpenDialog(ze,me)},showSaveDialog(me){return qi.showSaveDialog(me)},createStatusBarItem(me,De,Me){let nt,yt,Pt;return typeof me=="string"?(nt=me,yt=De,Pt=Me):(yt=me,Pt=De),Ri.createStatusBarEntry(ze,nt,yt,Pt)},setStatusBarMessage(me,De){return Ri.setStatusBarMessage(me,De)},withScmProgress(me){return He.report("window.withScmProgress",ze,"Use 'withProgress' instead."),$i.withProgress(ze,{location:V.ProgressLocation.SourceControl},(De,Me)=>me({report(nt){}}))},withProgress(me,De){return $i.withProgress(ze,me,De)},createOutputChannel(me,De){return Xi.createOutputChannel(me,De,ze)},createWebviewPanel(me,De,Me,nt){return pi.createWebviewPanel(ze,me,De,Me,nt)},createWebviewTextEditorInset(me,De,Me,nt){return(0,Ne.$zF)(ze,"editorInsets"),ki.createWebviewEditorInset(me,De,Me,nt,ze)},createTerminal(me,De,Me){return typeof me=="object"?"pty"in me?bt.createExtensionTerminal(me):bt.createTerminalFromOptions(me):bt.createTerminal(me,De,Me)},registerTerminalLinkProvider(me){return bt.registerLinkProvider(me)},registerTerminalProfileProvider(me,De){return bt.registerProfileProvider(ze,me,De)},registerTerminalQuickFixProvider(me,De){return(0,Ne.$zF)(ze,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(me,ze.identifier.value,De)},registerTreeDataProvider(me,De){return mi.registerTreeDataProvider(me,De,ze)},createTreeView(me,De){return mi.createTreeView(me,De,ze)},registerWebviewPanelSerializer:(me,De)=>pi.registerWebviewPanelSerializer(ze,me,De),registerCustomEditorProvider:(me,De,Me={})=>ji.registerCustomEditorProvider(ze,me,De,Me),registerFileDecorationProvider(me){return pt.registerFileDecorationProvider(me,ze)},registerUriHandler(me){return di.registerUriHandler(ze,me)},createQuickPick(){return xt.createQuickPick(ze)},createInputBox(){return xt.createInputBox(ze)},get activeColorTheme(){return Pi.activeColorTheme},onDidChangeActiveColorTheme(me,De,Me){return Pi.onDidChangeActiveColorTheme(me,De,Me)},registerWebviewViewProvider(me,De,Me){return Ui.registerWebviewViewProvider(ze,me,De,Me?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,De,Me){return kt.onDidChangeActiveNotebookEditor(me,De,Me)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(me,De,Me){return fi.onDidChangeNotebookEditorSelection(me,De,Me)},onDidChangeNotebookEditorVisibleRanges(me,De,Me){return fi.onDidChangeNotebookEditorVisibleRanges(me,De,Me)},showNotebookDocument(me,De){return kt.showNotebookDocument(me,De)},registerExternalUriOpener(me,De,Me){return(0,Ne.$zF)(ze,"externalUriOpener"),xi.registerExternalUriOpener(ze.identifier,me,De,Me)},registerProfileContentHandler(me,De){return(0,Ne.$zF)(ze,"profileContentHandlers"),en.registrProfileContentHandler(ze,me,De)},registerQuickDiffProvider(me,De,Me,nt){return(0,Ne.$zF)(ze,"quickDiffProvider"),zi.registerQuickDiffProvider(mt(me),De,Me,nt)},get tabGroups(){return St.tabGroups},registerShareProvider(me,De){return(0,Ne.$zF)(ze,"shareProvider"),Si.registerShareProvider(mt(me),De)}},Ti={get rootPath(){return He.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ct.getPath()},set rootPath(me){throw F.$7()},getWorkspaceFolder(me){return ct.getWorkspaceFolder(me)},get workspaceFolders(){return ct.getWorkspaceFolders()},get name(){return ct.name},set name(me){throw F.$7()},get workspaceFile(){return ct.workspaceFile},set workspaceFile(me){throw F.$7()},updateWorkspaceFolders:(me,De,...Me)=>ct.updateWorkspaceFolders(ze,me,De||0,...Me),onDidChangeWorkspaceFolders:function(me,De,Me){return ct.onDidChangeWorkspace(me,De,Me)},asRelativePath:(me,De)=>ct.getRelativePath(me,De),findFiles:(me,De,Me,nt)=>ct.findFiles(me,De,Me,ze.identifier,nt),findTextInFiles:(me,De,Me,nt)=>{(0,Ne.$zF)(ze,"findTextInFiles");let yt,Pt;return typeof De=="object"?(yt=De,Pt=Me):(yt={},Pt=De,nt=Me),ct.findTextInFiles(me,yt||{},Pt,ze.identifier,nt)},save:me=>((0,Ne.$zF)(ze,"saveEditor"),ct.save(me)),saveAs:me=>((0,Ne.$zF)(ze,"saveEditor"),ct.saveAs(me)),saveAll:me=>ct.saveAll(me),applyEdit(me,De){return Bi.applyWorkspaceEdit(me,ze,De)},createFileSystemWatcher:(me,De,Me,nt)=>Kt.createFileSystemWatcher(ct,ze,me,De,Me,nt),get textDocuments(){return It.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw F.$7()},openTextDocument(me){let De;const Me=me;if(typeof me=="string")De=Promise.resolve(P.URI.file(me));else if(P.URI.isUri(me))De=Promise.resolve(me);else if(!Me||typeof Me=="object")De=It.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return De.then(nt=>It.ensureDocumentData(nt).then(yt=>yt.document))},onDidOpenTextDocument:(me,De,Me)=>It.onDidAddDocument(me,De,Me),onDidCloseTextDocument:(me,De,Me)=>It.onDidRemoveDocument(me,De,Me),onDidChangeTextDocument:(me,De,Me)=>It.onDidChangeDocument(me,De,Me),onDidSaveTextDocument:(me,De,Me)=>It.onDidSaveDocument(me,De,Me),onWillSaveTextDocument:(me,De,Me)=>Ht.getOnWillSaveTextDocumentEvent(ze)(me,De,Me),get notebookDocuments(){return kt.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,De){let Me;if(P.URI.isUri(me))Me=me,await kt.openNotebookDocument(me);else if(typeof me=="string")Me=P.URI.revive(await kt.createNotebookDocument({viewType:me,content:De}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(me,De,Me){return Ei.onDidSaveNotebookDocument(me,De,Me)},onDidChangeNotebookDocument(me,De,Me){return Ei.onDidChangeNotebookDocument(me,De,Me)},onWillSaveNotebookDocument(me,De,Me){return ni.getOnWillSaveNotebookDocumentEvent(ze)(me,De,Me)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(me,De,Me,nt){return kt.registerNotebookSerializer(ze,me,De,Me,(0,Ne.$yF)(ze,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:(me,De,Me)=>Zt.onDidChangeConfiguration(me,De,Me),getConfiguration(me,De){return De=arguments.length===1?void 0:De,Zt.getConfiguration(me,De,ze)},registerTextDocumentContentProvider(me,De){return yi.registerTextDocumentContentProvider(me,De)},registerTaskProvider:(me,De)=>(He.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),qt.registerTaskProvider(ze,me,De)),registerFileSystemProvider(me,De,Me){return(0,Ue.$ib)(Di.registerFileSystemProvider(ze,me,De,Me),Nt.addFileSystemProvider(me,De,Me))},get fs(){return Nt.value},registerFileSearchProvider:(me,De)=>((0,Ne.$zF)(ze,"fileSearchProvider"),Qt.registerFileSearchProvider(me,De)),registerTextSearchProvider:(me,De)=>((0,Ne.$zF)(ze,"textSearchProvider"),Qt.registerTextSearchProvider(me,De)),registerRemoteAuthorityResolver:(me,De)=>((0,Ne.$zF)(ze,"resolvers"),Dt.registerRemoteAuthorityResolver(me,De)),registerResourceLabelFormatter:me=>((0,Ne.$zF)(ze,"resolvers"),Ii.$registerResourceLabelFormatter(me)),getRemoteExecServer:me=>((0,Ne.$zF)(ze,"resolvers"),Dt.getRemoteExecServer(me)),onDidCreateFiles:(me,De,Me)=>Kt.onDidCreateFile(me,De,Me),onDidDeleteFiles:(me,De,Me)=>Kt.onDidDeleteFile(me,De,Me),onDidRenameFiles:(me,De,Me)=>Kt.onDidRenameFile(me,De,Me),onWillCreateFiles:(me,De,Me)=>Kt.getOnWillCreateFileEvent(ze)(me,De,Me),onWillDeleteFiles:(me,De,Me)=>Kt.getOnWillDeleteFileEvent(ze)(me,De,Me),onWillRenameFiles:(me,De,Me)=>Kt.getOnWillRenameFileEvent(ze)(me,De,Me),openTunnel:me=>((0,Ne.$zF)(ze,"tunnels"),Ze.openTunnel(ze,me).then(De=>{if(!De)throw new Error("cannot open tunnel");return De})),get tunnels(){return(0,Ne.$zF)(ze,"tunnels"),Ze.getTunnels()},onDidChangeTunnels:(me,De,Me)=>((0,Ne.$zF)(ze,"tunnels"),Ze.onDidChangeTunnels(me,De,Me)),registerPortAttributesProvider:(me,De)=>((0,Ne.$zF)(ze,"portsAttributes"),Ze.registerPortsAttributesProvider(me,De)),registerTunnelProvider:(me,De)=>((0,Ne.$zF)(ze,"tunnelFactory"),Ze.registerTunnelProvider(me,De)),registerTimelineProvider:(me,De)=>((0,Ne.$zF)(ze,"timeline"),Ai.registerTimelineProvider(me,De,ze.identifier,ht.converter)),get isTrusted(){return ct.trusted},requestWorkspaceTrust:me=>((0,Ne.$zF)(ze,"workspaceTrust"),ct.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,De,Me)=>ct.onDidGrantWorkspaceTrust(me,De,Me),registerEditSessionIdentityProvider:(me,De)=>((0,Ne.$zF)(ze,"editSessionIdentityProvider"),ct.registerEditSessionIdentityProvider(me,De)),onWillCreateEditSessionIdentity:(me,De,Me)=>((0,Ne.$zF)(ze,"editSessionIdentityProvider"),ct.getOnWillCreateEditSessionIdentityEvent(ze)(me,De,Me)),registerCanonicalUriProvider:(me,De)=>((0,Ne.$zF)(ze,"canonicalUriProvider"),ct.registerCanonicalUriProvider(me,De)),getCanonicalUri:(me,De,Me)=>((0,Ne.$zF)(ze,"canonicalUriProvider"),ct.provideCanonicalUri(me,De,Me))},Ki={get inputBox(){return He.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),gi.getLastInputBox(ze)},createSourceControl(me,De,Me){return gi.createSourceControl(ze,me,De,Me)}},on={createCommentController(me,De){return Ci.createCommentController(ze,me,De)}},an={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},get stackFrameFocus(){return gt.stackFrameFocus},onDidStartDebugSession(me,De,Me){return gt.onDidStartDebugSession(me,De,Me)},onDidTerminateDebugSession(me,De,Me){return gt.onDidTerminateDebugSession(me,De,Me)},onDidChangeActiveDebugSession(me,De,Me){return gt.onDidChangeActiveDebugSession(me,De,Me)},onDidReceiveDebugSessionCustomEvent(me,De,Me){return gt.onDidReceiveDebugSessionCustomEvent(me,De,Me)},onDidChangeBreakpoints(me,De,Me){return gt.onDidChangeBreakpoints(me,De,Me)},onDidChangeStackFrameFocus(me,De,Me){return(0,Ne.$zF)(ze,"debugFocus"),gt.onDidChangeStackFrameFocus(me,De,Me)},registerDebugConfigurationProvider(me,De,Me){return gt.registerDebugConfigurationProvider(me,De,Me||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,De){return gt.registerDebugAdapterDescriptorFactory(ze,me,De)},registerDebugAdapterTrackerFactory(me,De){return gt.registerDebugAdapterTrackerFactory(me,De)},startDebugging(me,De,Me){return!Me||typeof Me=="object"&&"configuration"in Me?gt.startDebugging(me,De,{parentSession:Me}):gt.startDebugging(me,De,Me||{})},stopDebugging(me){return gt.stopDebugging(me)},addBreakpoints(me){return gt.addBreakpoints(me)},removeBreakpoints(me){return gt.removeBreakpoints(me)},asDebugSourceUri(me,De){return gt.asDebugSourceUri(me,De)}},Oi={registerTaskProvider:(me,De)=>qt.registerTaskProvider(ze,me,De),fetchTasks:me=>qt.fetchTasks(me),executeTask:me=>qt.executeTask(ze,me),get taskExecutions(){return qt.taskExecutions},onDidStartTask:(me,De,Me)=>qt.onDidStartTask(me,De,Me),onDidEndTask:(me,De,Me)=>qt.onDidEndTask(me,De,Me),onDidStartTaskProcess:(me,De,Me)=>qt.onDidStartTaskProcess(me,De,Me),onDidEndTaskProcess:(me,De,Me)=>qt.onDidEndTaskProcess(me,De,Me)},Gi={createNotebookController(me,De,Me,nt,yt){return ai.createNotebookController(ze,me,De,Me,nt,(0,Ne.$yF)(ze,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(me,De)=>kt.registerNotebookCellStatusBarItemProvider(ze,me,De),createRendererMessaging(me){return _i.createRendererMessaging(ze,me)},createNotebookControllerDetectionTask(me){return(0,Ne.$zF)(ze,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(ze,me)},registerKernelSourceActionProvider(me,De){return(0,Ne.$zF)(ze,"notebookKernelSource"),ai.registerKernelSourceActionProvider(ze,me,De)},onDidChangeNotebookCellExecutionState(me,De,Me){return(0,Ne.$zF)(ze,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(me,De,Me)}},Zi={t(...me){if(typeof me[0]=="string"){const De=me.shift(),Me=!me||typeof me[0]!="object"?me:me[0];return hi.getMessage(ze.identifier.value,{message:De,args:Me})}return hi.getMessage(ze.identifier.value,me[0])},get bundle(){return hi.getBundle(ze.identifier.value)},get uri(){return hi.getBundleUri(ze.identifier.value)}},Yi={_version:1,registerInteractiveEditorSessionProvider(me){return(0,Ne.$zF)(ze,"interactive"),Li.registerProvider(ze,me)},registerInteractiveSessionProvider(me,De){return(0,Ne.$zF)(ze,"interactive"),Xt.registerChatProvider(ze,me,De)},addInteractiveRequest(me){return(0,Ne.$zF)(ze,"interactive"),Xt.addChatRequest(me)},sendInteractiveRequestToProvider(me,De){return(0,Ne.$zF)(ze,"interactive"),Xt.sendInteractiveRequestToProvider(me,De)},get onDidPerformUserAction(){return(0,Ne.$zF)(ze,"interactiveUserActions"),Xt.onDidPerformUserAction},transferChatSession(me,De){return(0,Ne.$zF)(ze,"interactive"),Xt.transferChatSession(me,De)}},cn={registerSlashCommandProvider(me,De){return(0,Ne.$zF)(ze,"interactiveSlashCommands"),Xt.registerSlashCommandProvider(ze,me,De)}},un={registerSemanticSimilarityProvider(me){return(0,Ne.$zF)(ze,"semanticSimilarity"),tn.registerSemanticSimilarityProvider(ze,me)}};return{version:dt.version,ai:un,authentication:rn,commands:Vt,comments:on,debug:an,env:ci,extensions:Ji,interactive:Yi,interactiveSlashCommands:cn,l10n:Zi,languages:Hi,notebooks:Gi,scm:Ki,tasks:Oi,tests:Vi,window:sn,workspace:Ti,Breakpoint:V.$CK,TerminalOutputAnchor:V.TerminalOutputAnchor,CallHierarchyIncomingCall:V.$2J,CallHierarchyItem:V.$1J,CallHierarchyOutgoingCall:V.$3J,CancellationError:F.$3,CancellationTokenSource:k.$ed,CandidatePortSource:$.CandidatePortSource,CodeAction:V.$WJ,CodeActionKind:V.$XJ,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.$4J,Color:V.$eK,ColorInformation:V.$fK,ColorPresentation:V.$gK,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentState:V.CommentState,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.$$J,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.$_J,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.$oK,DebugAdapterExecutable:V.$GK,DebugAdapterInlineImplementation:V.$JK,DebugAdapterNamedPipeServer:V.$IK,DebugAdapterServer:V.$HK,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.$RJ,DiagnosticRelatedInformation:V.$QJ,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.$DJ,DocumentHighlight:V.$TJ,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.$dK,DocumentSymbol:V.$VJ,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.$MK,InlineValueText:V.$NK,InlineValueVariableLookup:V.$OK,InlineValueEvaluatableExpression:V.$PK,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:h.$8c,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.$ZK,FileDecoration2:V.$ZK,FileSystemError:V.$RK,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:V.$SK,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.$EK,InlineCompletionItem:V.$aK,InlineCompletionList:V.$bK,Hover:V.$SJ,IndentAction:b.IndentAction,Location:V.$PJ,MarkdownString:V.$5J,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:V.$6J,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.$EJ,ProcessExecution:V.$mK,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.$YK,Range:V.$FJ,RelativePattern:V.$AK,Selection:V.$GJ,SelectionRange:V.$ZJ,SemanticTokens:V.$VK,SemanticTokensBuilder:V.$UK,SemanticTokensEdit:V.$WK,SemanticTokensEdits:V.$XK,SemanticTokensLegend:V.$TK,ShellExecution:V.$nK,ShellQuoting:V.ShellQuoting,SignatureHelp:V.$8J,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.$7J,SnippetString:V.$OJ,SourceBreakpoint:V.$DK,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.$UJ,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.$pK,TaskGroup:V.$lK,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.$hK,TerminalQuickFixCommand:V.$jK,TerminalQuickFixOpener:V.$iK,TerminalLocation:V.TerminalLocation,TerminalProfile:V.$kK,TerminalExitReason:V.TerminalExitReason,TerminalQuickFixType:V.TerminalQuickFixType,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.$KJ,SnippetTextEdit:V.$MJ,TextEditorCursorStyle:m.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.$zK,ThemeIcon:V.$yK,TreeItem:V.$qK,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.$jL,UIKind:D.UIKind,Uri:P.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.$NJ,DocumentDropEdit:V.$wK,DocumentPasteEdit:V.$xK,InlayHint:V.$0J,InlayHintLabelPart:V.$9J,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.$JJ,ResolvedAuthority:V.$HJ,ManagedResolvedAuthority:V.$IJ,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.$0K,NotebookRange:V.$2K,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.$3K,NotebookData:V.$4K,NotebookRendererScript:V.$8K,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.$6K,NotebookCellOutputItem:V.$5K,NotebookCellStatusBarItem:V.$7K,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.$LJ,NotebookKernelSourceAction:V.$9K,PortAttributes:V.$_K,LinkedEditingRanges:V.$$K,TestResultState:V.TestResultState,TestRunRequest:V.$aL,TestRunRequest2:V.$bL,TestMessage:V.$cL,TestTag:V.$dL,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:tt.TextSearchCompleteMessageType,DataTransfer:V.$vK,DataTransferItem:V.$rK,CoveredCount:V.$eL,FileCoverage:V.$fL,StatementCoverage:V.$gL,BranchCoverage:V.$hL,FunctionCoverage:V.$iL,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.$kL,TabInputTextDiff:V.$lL,TabInputTextMerge:V.$mL,TabInputCustom:V.$nL,TabInputNotebook:V.$pL,TabInputNotebookDiff:V.$qL,TabInputWebview:V.$oL,TabInputTerminal:V.$rL,TabInputInteractiveWindow:V.$sL,TelemetryTrustedValue:de.$2n,LogLevel:ye.LogLevel,EditSessionIdentityMatch:rt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:V.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:V.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:V.InteractiveEditorResponseFeedbackKind,StackFrameFocus:V.$KK,ThreadFocus:V.$LK,NotebookCodeActionKind:V.$YJ}}}e.$Pac=Mt}),define(Se[337],Ce([1,0,98,145,37,142,38,36,61,43,88,90,91,109,64,84,144,63,51,108,83,62,143,18,52,106,107]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c,f,y,C,i,o,n,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,k.$_q)(t.$u_b,t.$t_b,1),(0,k.$_q)(o.$Si,i.$Qac,1),(0,k.$_q)(p.$T$b,p.$U$b,1),(0,k.$_q)(m.$ZL,m.$YL,0),(0,k.$_q)(P.$7$b,P.$5$b,0),(0,k.$_q)(s.$j_b,s.$i_b,0),(0,k.$_q)(I.$0_b,I.$bac,0),(0,k.$_q)(A.$2_b,A.$1_b,0),(0,k.$_q)(E.$OL,E.$NL,0),(0,k.$_q)(a.$v_b,a.$w_b,0),(0,k.$_q)(c.$Q$b,c.$P$b,0),(0,k.$_q)(F.$H_b,F.$G_b,1),(0,k.$_q)($.$hac,$.$iac,0),(0,k.$_q)(D.$f_b,D.$e_b,0),(0,k.$_q)(R.$5_b,R.$4_b,0),(0,k.$_q)(b.$m_b,b.$p_b,0),(0,k.$_q)(S.$Wpb,S.$Xpb,0),(0,k.$_q)(r.$X_b,r.$W_b,0),(0,k.$_q)(h.$4$b,h.$3$b,0),(0,k.$_q)(f.$r_b,f.$q_b,0),(0,k.$_q)(y.$XL,y.$UL,0),(0,k.$_q)(C.$6_b,C.$7_b,0),(0,k.$_q)(n.$8_b,n.$9_b,0)}),define(Se[110],Ce([1,0,19,18,35,87]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=e.$8ac=e.$7ac=void 0;function P(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$7ac=P;function m(I,$,D,S){const p=(0,k.$If)(D,E),r=new h.$4H($,p,S),s=r.preview.matches;return{ranges:(0,k.$If)(p,b),uri:I,preview:{text:r.preview.text,matches:(0,k.$If)(s,b)}}}e.$8ac=m;function E(I){return new h.$5H(I.start.line,I.start.character,I.end.line,I.end.character)}function b(I){return new A.$TH(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let R=class{constructor($,D){this.a=$,this.b=D}appendLine($){this.b.debug(`${this.a}#search`,$)}};e.$9ac=R,e.$9ac=R=Je([qe(1,F.$Ri)],R)}),define(Se[338],Ce([1,0,46,13,69,31,11,12,110,339]),function(fe,e,k,F,h,A,P,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ac=e.$$ac=e.$0ac=void 0;const R=b.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(f,y,C,i){const o=$(f,y,C,i),n=y.folder.fsPath;return{cmd:k.spawn(R,o.args,{cwd:n}),rgDiskPath:R,siblingClauses:o.siblingClauses,rgArgs:o,cwd:n}}e.$0ac=I;function $(f,y,C,i){const o=["--files","--hidden","--case-sensitive","--no-require-git"];S([y],C,!1).forEach(t=>{const a=(0,E.$7ac)(t);if(o.push("-g",a),P.$j){const g=(0,h.$8k)(a);g!==a&&o.push("-g",g)}});const n=D([y],i,void 0,!1);return n.globArgs.forEach(t=>{const a=`!${(0,E.$7ac)(t)}`;if(o.push("-g",a),P.$j){const g=(0,h.$8k)(a);g!==a&&o.push("-g",g)}}),y.disregardIgnoreFiles!==!1?o.push("--no-ignore"):y.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),y.ignoreSymlinks||o.push("--follow"),f.exists&&o.push("--quiet"),o.push("--no-config"),y.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:n.siblingClauses}}function D(f,y,C,i=!0){const o=[];let n={};return f.forEach(t=>{const a=Object.assign({},t.excludePattern||{},y||{}),g=p(a,i?t.folder.fsPath:void 0,C);o.push(...g.globArgs),g.siblingClauses&&(n=Object.assign(n,g.siblingClauses))}),{globArgs:o,siblingClauses:n}}function S(f,y,C=!0){const i=[];return f.forEach(o=>{const n=Object.assign({},y||{},o.includePattern||{}),t=p(n,C?o.folder.fsPath:void 0);i.push(...t.globArgs)}),i}function p(f,y,C){const i=[],o={};return Object.keys(f).forEach(n=>{if(C&&C.has(n)||!n)return;const t=f[n];n=s(y?r(y,n):n),n.startsWith("\\\\")?n="\\\\"+n.substr(2).replace(/\\/g,"/"):n=n.replace(/\\/g,"/"),typeof t=="boolean"&&t?(n.startsWith("\\\\")&&(n+="**"),i.push(c(n))):t&&t.when&&(o[n]=t)}),{globArgs:i,siblingClauses:o}}function r(f,y){return F.$_b(y)?y:F.$ac(f,y)}e.$$ac=r;function s(f){return f=m.$td(f,"\\"),m.$td(f,"/")}function c(f){return A.$Ge(f).toLowerCase()==="c:/"?f.replace(/^c:[/\\]/i,"/"):f}e.$_ac=c}),define(Se[340],Ce([1,0,46,49,13,341,19,45,34,69,31,11,39,12,14,29,35,338,119]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bbc=e.$abc=void 0;const f=new Set;process.on("exit",()=>{f.forEach(n=>n())});class y{constructor(t){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=t,this.b=t.filePattern||"",this.d=t.includePattern&&E.$ej(t.includePattern),this.f=t.maxResults||null,this.g=!!t.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,c.$dq)(this.b).normalizedLowercase),this.u=t.excludePattern&&E.$ej(t.excludePattern),this.t=new Map,t.folderQueries.forEach(a=>{const g=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),u=a.folder.fsPath;t.folderQueries.map(d=>d.folder.fsPath).filter(d=>d!==u).forEach(d=>{(0,R.$Ke)(d,u)&&(g[h.$cc(u,d)]=!0)}),this.t.set(u,new i(g,u))})}cancel(){this.l=!0,f.forEach(t=>t())}walk(t,a,g,u,d){if(this.m=$.$4c.create(!1),this.l)return d(null,this.j);a.forEach(v=>{const l=h.$ec(v.fsPath);this.u&&this.u(v.fsPath,l)||this.J(g,{relativePath:v.fsPath,searchPath:void 0})}),this.r=$.$4c.create(!1),this.w(t,(v,l)=>{this.x(this.y,this,v,g,u,w=>{if(w){const L=(0,m.$ai)(w);console.error(L),this.q.push(L),l(w,void 0)}else l(null,void 0)})},(v,l)=>{this.m.stop();const w=v?P.$mf(v)[0]:null;d(w,this.j)})}w(t,a,g){const u=new Array(t.length),d=new Array(t.length);let v=!1,l=0;if(t.length===0)return g(null,[]);t.forEach((w,L)=>{a(w,(O,N)=>{if(O?(v=!0,u[L]=null,d[L]=O):(u[L]=N,d[L]=null),++l===t.length)return g(v?d:null,u)})})}x(t,a,...g){try{t.apply(a,g)}catch(u){g[g.length-1](u)}}y(t,a,g,u){const d=t.folder.fsPath,v=I.$j,l=()=>T&&T.kill();f.add(l);let w=Y=>{f.delete(l),w=()=>{},u(Y)},L="";const O=this.D(),N=(0,s.$0ac)(this.a,t,this.a.includePattern,this.t.get(t.folder.fsPath).expression),T=N.cmd,j=!Object.keys(N.siblingClauses).length,W=N.rgArgs.args.map(Y=>Y.match(/^-/)?Y:`'${Y}'`).join(" ");let M=`${N.rgDiskPath} ${W}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(M+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),g({message:M}),this.s=0,this.z(T,"utf8",g,(Y,V,de)=>{if(Y){w(Y);return}if(this.j){w();return}const x=(L+(v?b.$7k(V||""):V)).split(`
`);if(de){const q=x.length;x[q-1]=x[q-1].trim(),x[q-1]||x.pop()}else L=x.pop()||"";if(x.length&&x[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.s+=x.length,j){for(const q of x)if(this.J(a,{base:d,relativePath:q,searchPath:this.N(t,q)}),this.j){l();break}(de||this.j)&&w();return}this.G(t,O,d,x,a),de&&(this.H(O,d,a),w())})}spawnFindCmd(t){const a=this.t.get(t.folder.fsPath),g=a.getBasenameTerms(),u=a.getPathTerms(),d=["-L","."];if(g.length||u.length){d.push("-not","(","(");for(const v of g)d.push("-name",v),d.push("-o");for(const v of u)d.push("-path",v),d.push("-o");d.pop(),d.push(")","-prune",")")}return d.push("-type","f"),k.spawn("find",d,{cwd:t.folder.fsPath})}readStdout(t,a,g){let u="";this.z(t,a,()=>{},(d,v,l)=>{if(d){g(d);return}u+=v,l&&g(null,u)})}z(t,a,g,u){let d=(w,L,O)=>{(w||O)&&(d=()=>{},this.r?.stop()),u(w,L,O)},v=!1;t.stdout?(this.A(t.stdout,a,d),t.stdout.once("data",()=>v=!0)):g({message:"stdout is null"});let l;t.stderr?l=this.B(t.stderr):g({message:"stderr is null"}),t.on("error",w=>{d(w)}),t.on("close",w=>{let L;!v&&(L=this.C(l,a))&&o(L)?d(new Error(`command failed with error code ${w}: ${this.C(l,a)}`)):(this.g&&w===0&&(this.j=!0),d(null,"",!0))})}A(t,a,g){const u=new A.StringDecoder(a);return t.on("data",d=>{g(null,u.write(d))}),u}B(t){const a=[];return t.on("data",g=>{a.push(g)}),a}C(t,a){const g=new A.StringDecoder(a);return t.map(u=>g.write(u)).join("")}D(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}G(t,{pathToEntries:a},g,u,d){u.indexOf(this.b)!==-1&&this.J(d,{base:g,relativePath:this.b,searchPath:this.N(t,this.b)});const v=l=>{const w=h.$ec(l),L=h.$dc(l);let O=a[L];O||(O=a[L]=[],v(L)),O.push({base:g,relativePath:l,basename:w,searchPath:this.N(t,l)})};u.forEach(v)}H({rootEntries:t,pathToEntries:a},g,u){const d=this,v=this.t.get(g),l=this.b;function w(L){d.o++;const O=(0,r.$hI)(()=>L.map(N=>N.basename));for(let N=0,T=L.length;N<T;N++){const j=L[N],{relativePath:W,basename:M}=j;if(v.test(W,M,l!==M?O:void 0))continue;const Y=a[W];if(Y)w(Y);else{if(d.p++,W===l)continue;d.J(u,j)}if(d.j)break}}w(t)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(t,a,g,u,d){const v=t.folder,l=(0,r.$hI)(()=>g);this.w(g,(w,L)=>{if(this.l||this.j)return L(null);const O=a?[a,w].join(h.sep):w;if(this.t.get(t.folder.fsPath).test(O,w,this.a.filePattern!==w?l:void 0))return L(null);const N=[v.fsPath,O].join(h.sep);F.lstat(N,(T,j)=>{if(T||this.l||this.j)return L(null);this.L(N,j,(W,M)=>W||this.l||this.j?L(null):M.isDirectory()?(this.o++,this.M(N,j,(Y,V)=>Y||this.l||this.j||(V=V||"",this.v[V])?L(null):(this.v[V]=!0,p.Promises.readdir(N).then(de=>{if(this.l||this.j)return L(null);this.I(t,O,de,u,re=>L(re||null))},de=>{L(null)})))):(this.p++,O===this.b||this.h&&S.$ne(M.size)&&M.size>this.h||this.J(u,{base:v.fsPath,relativePath:O,searchPath:this.N(t,O)}),L(null,void 0)))})},w=>{const L=w&&P.$mf(w);return d(L&&L.length>0?L[0]:void 0)})}J(t,a){this.K(a)&&(!this.d||this.d(a.relativePath,h.$ec(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||t(a))}K(t){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,r.$cI)(t,this.c)}return!0}L(t,a,g){return a.isSymbolicLink()?F.stat(t,g):g(null,a)}M(t,a,g){return a.isSymbolicLink()?F.realpath(t,(u,d)=>u?g(u):g(null,d)):g(null,t)}N(t,a){return t.folderName?h.$ac(t.folderName,a):a}}e.$abc=y;class C{constructor(t){this.a=t.folderQueries,this.b=t.extraFileResources||[],this.c=new y(t)}search(t,a,g){this.c.walk(this.a,this.b,t,a,(u,d)=>{g(u,{limitHit:d,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$bbc=C;class i{constructor(t,a){this.expression=t,this.c=a,this.d(t)}d(t){let a,g;Object.keys(t).filter(u=>t[u]).forEach(u=>{h.$_b(u)?(a=a||E.$_i(),a[u]=t[u]):(g=g||E.$_i(),g[u]=t[u])}),this.a=a&&E.$ej(a,{trimForExclusions:!0}),this.b=g&&E.$ej(g,{trimForExclusions:!0})}test(t,a,g){return this.b&&this.b(t,a,g)||this.a&&this.a(h.$ac(this.c,t),a,g)}getBasenameTerms(){const t=[];return this.a&&t.push(...E.$gj(this.a)),this.b&&t.push(...E.$gj(this.b)),t}getPathTerms(){const t=[];return this.a&&t.push(...E.$hj(this.a)),this.b&&t.push(...E.$hj(this.b)),t}}function o(n){const t=n.trim().split(`
`),a=t[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return D.$be(t[t.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(Se[342],Ce([1,0,92,22,175]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bD=e.$aD=e.$_C=e.$$C=e.$0C=e.$9C=e.$8C=e.$7C=e.$6C=e.DecodeStreamErrorKind=e.$5C=e.$4C=e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=void 0,e.$XC="utf8",e.$YC="utf8bom",e.$ZC="utf16be",e.$1C="utf16le";function A(t){return[e.$XC,e.$YC,e.$ZC,e.$1C].some(a=>a===t)}e.$2C=A,e.$3C=[254,255],e.$4C=[255,254],e.$5C=[239,187,191];const P=512,m=512,E=512*8,b=512*128;var R;(function(t){t[t.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(R||(e.DecodeStreamErrorKind=R={}));class I extends Error{constructor(a,g){super(a),this.decodeStreamErrorKind=g}}e.$6C=I;class ${static async create(a){let g;if(a!==e.$XC)g=(await(0,h.$WC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(r(a));else{const u=new TextDecoder;g={write(d){return u.decode(d,{stream:!0})},end(){return u.decode()}}}return new $(g)}constructor(a){this.a=a}write(a){return this.a.write(a)}end(){return this.a.end()}}function D(t,a){const g=a.minBytesRequiredForDetection??a.guessEncoding?E:m;return new Promise((u,d)=>{const v=(0,k.$xb)(T=>T.join("")),l=[];let w=0,L;const O=async()=>{try{const T=await n({buffer:F.$Jb.concat(l),bytesRead:w},a.guessEncoding);if(T.seemsBinary&&a.acceptTextOnly)throw new I("Stream is binary but only text is accepted for decoding",1);T.encoding=await a.overwriteEncoding(T.encoding),L=await $.create(T.encoding);const j=L.write(F.$Jb.concat(l).buffer);v.write(j),l.length=0,w=0,u({stream:v,detected:T})}catch(T){N?.dispose(),v.destroy(),d(T)}},N=(0,k.$Bb)(t,{onData:async T=>{L?v.write(L.write(T.buffer)):(l.push(T),w+=T.byteLength,w>=g&&(t.pause(),await O(),setTimeout(()=>t.resume())))},onError:T=>v.error(T),onEnd:async()=>{L||await O(),v.end(L?.end())}})})}e.$7C=D;async function S(t,a,g){const d=(await(0,h.$WC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(r(a),g);let v=!1,l=!1;return{read(){if(l)return null;const w=t.read();if(typeof w!="string"){if(l=!0,!v&&g?.addBOM)switch(a){case e.$XC:case e.$YC:return F.$Jb.wrap(Uint8Array.from(e.$5C));case e.$ZC:return F.$Jb.wrap(Uint8Array.from(e.$3C));case e.$1C:return F.$Jb.wrap(Uint8Array.from(e.$4C))}const L=d.end();return L&&L.length>0?(v=!0,F.$Jb.wrap(L)):null}return v=!0,F.$Jb.wrap(d.write(w))}}}e.$8C=S;async function p(t){return(await(0,h.$WC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(r(t))}e.$9C=p;function r(t){return t===e.$YC||t===null?e.$XC:t}e.$0C=r;function s(t,a){if(!t||a<e.$3C.length)return null;const g=t.readUInt8(0),u=t.readUInt8(1);if(g===e.$3C[0]&&u===e.$3C[1])return e.$ZC;if(g===e.$4C[0]&&u===e.$4C[1])return e.$1C;if(a<e.$5C.length)return null;const d=t.readUInt8(2);return g===e.$5C[0]&&u===e.$5C[1]&&d===e.$5C[2]?e.$YC:null}e.$$C=s;const c=["ascii","utf-16","utf-32"];async function f(t){const a=await(0,h.$WC)("jschardet","dist/jschardet.min.js"),g=t.slice(0,b),u=i(g.buffer),d=a.detect(u);if(!d||!d.encoding)return null;const v=d.encoding.toLowerCase();return 0<=c.indexOf(v)?null:C(d.encoding)}const y={ibm866:"cp866",big5:"cp950"};function C(t){const a=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return y[a]||a}function i(t){let a="";for(let g=0;g<t.length;g++)a+=String.fromCharCode(t[g]);return a}function o(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const a=t.match(/windows(\d+)/);return a?"windows-"+a[1]:t}}}e.$_C=o;function n({buffer:t,bytesRead:a},g){let u=s(t,a),d=!1;if(u!==e.$ZC&&u!==e.$1C&&t){let v=!0,l=!0,w=!1;for(let L=0;L<a&&L<P;L++){const O=L%2===1,N=t.readUInt8(L)===0;if(N&&(w=!0),v&&(O&&!N||!O&&N)&&(v=!1),l&&(O&&N||!O&&!N)&&(l=!1),N&&!v&&!l)break}w&&(v?u=e.$1C:l?u=e.$ZC:d=!0)}return g&&!d&&!u&&t?f(t.slice(0,a)).then(v=>({seemsBinary:!1,encoding:v})):{seemsBinary:d,encoding:u}}e.$aD=n,e.$bD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[147],Ce([1,0,342,29,146]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=void 0;class A extends h.$dac{constructor(m,E,b=F,R="searchProcess"){super(m,E,{readdir:I=>b.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,k.$_C)(I)},R)}}e.$jbc=A}),define(Se[148],Ce([1,0,46,356,341,19,65,34,13,12,2,35,87,357,339,110]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=e.$hbc=e.$gbc=e.$fbc=e.$ebc=e.$dbc=e.$cbc=void 0;const r=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(w){this.a=w}provideTextSearchResults(w,L,O,N){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...L,folder:L.folder.toString()})}`),new Promise((T,j)=>{N.onCancellationRequested(()=>q());const W=o(w,L),M=L.folder.fsPath,Y=W.map(ce=>ce.match(/^-/)?ce:`'${ce}'`).join(" ");this.a.appendLine(`${r} ${Y}
 - cwd: ${M}`);let V=k.spawn(r,W,{cwd:M});V.on("error",ce=>{console.error(ce),this.a.appendLine("Error: "+(ce&&ce.message)),j((0,I.$$H)(new I.$9H(ce&&ce.message,I.SearchErrorCode.rgProcessError)))});let de=!1;const re=new y(L.maxResults,M,L.previewOptions);re.on("result",ce=>{de=!0,pe="",O.report(ce)});let x=!1;const q=()=>{x=!0,V?.kill(),re?.cancel()};let ne=!1;re.on("hitLimit",()=>{ne=!0,q()});let pe="";V.stdout.on("data",ce=>{re.handleData(ce),de||(pe+=ce)});let H=!1;V.stdout.once("data",()=>H=!0);let ue="";V.stderr.on("data",ce=>{const z=ce.toString();this.a.appendLine(z),ue.length+z.length<1e6&&(ue+=z)}),V.on("close",()=>{if(this.a.appendLine(H?"Got data from stdout":"No data from stdout"),this.a.appendLine(de?"Got result from parser":"No result from parser"),pe&&this.a.appendLine(`Got data without result: ${pe}`),this.a.appendLine(""),x)T({limitHit:ne});else{re.flush(),V=null;let ce;ue&&!H&&(ce=c(ue))?j((0,I.$$H)(new I.$9H(ce.message,ce.code))):T({limitHit:ne})}})})}}e.$cbc=s;function c(l){const w=l.split(`
`),L=w[0].trim();if(w.some(N=>N.startsWith("regex parse error")))return new I.$9H(f(w),I.SearchErrorCode.regexParseError);const O=L.match(/grep config error: unknown encoding: (.*)/);if(O)return new I.$9H(`Unknown encoding: ${O[1]}`,I.SearchErrorCode.unknownEncoding);if(L.startsWith("error parsing glob"))return new I.$9H(L.charAt(0).toUpperCase()+L.substr(1),I.SearchErrorCode.globParseError);if(L.startsWith("the literal"))return new I.$9H(L.charAt(0).toUpperCase()+L.substr(1),I.SearchErrorCode.invalidLiteral);if(L.startsWith("PCRE2: error compiling pattern"))return new I.$9H(L,I.SearchErrorCode.regexParseError)}function f(l){const w=["Regex parse error"],L=l.filter(O=>O.startsWith("PCRE2:"));if(L.length>=1){const O=L[0].replace("PCRE2:","");if(O.indexOf(":")!==-1&&O.split(":").length>=2){const N=O.split(":")[1];w.push(":"+N)}}return w.join("")}class y extends F.EventEmitter{constructor(w,L,O){super(),this.g=w,this.h=L,this.j=O,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new h.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,L){return super.on(w,L),this}handleData(w){if(this.b)return;const L=typeof w=="string"?w:this.d.write(w);this.k(L)}k(w){let L=w.indexOf(`
`);const O=this.a+w;if(L>=0)L+=this.a.length;else{this.a=O;return}let N=0;for(;L>=0;)this.m(O.substring(N,L).trim()),N=L+1,L=O.indexOf(`
`,N);this.a=O.substring(N)}m(w){if(this.b||!w)return;let L;try{L=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(L.type==="match"){const O=C(L.data.path),N=R.URI.file(E.$ac(this.h,O)),T=this.n(L.data,N);this.p(T),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(L.type==="context"){const O=C(L.data.path),N=R.URI.file(E.$ac(this.h,O));this.o(L.data,N).forEach(j=>this.p(j))}}n(w,L){const O=w.line_number-1,N=C(w.lines),T=Buffer.from(N);let j=0,W=0,M=O;w.submatches.length===0&&w.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const Y=(0,A.$mf)(w.submatches.map((V,de)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const re=C(V.match),x=T.slice(j,V.start).toString(),q=i(x),ne=q.numLines>0?q.lastLineLength:q.lastLineLength+W,pe=i(re),H=q.numLines+M,ue=pe.numLines+H,ce=pe.numLines>0?pe.lastLineLength:pe.lastLineLength+ne;return j=V.end,W=ce,M=ue,new $.$TH(H,ne,ue,ce)}));return(0,p.$8ac)(L,N,Y,this.j)}o(w,L){const O=C(w.lines),N=w.line_number;return O.replace(/\r?\n$/,"").split(`
`).map((T,j)=>({text:T,uri:L,lineNumber:N+j}))}p(w){this.emit("result",w)}}e.$dbc=y;function C(l){return l.bytes?Buffer.from(l.bytes,"base64").toString():l.text}function i(l){const w=/\n/g;let L=0,O=-1,N;for(;N=w.exec(l);)L++,O=N.index;const T=O>=0?l.length-O-1:l.length;return{numLines:L,lastLineLength:T}}function o(l,w){const L=["--hidden","--no-require-git"];L.push(l.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:O,otherIncludes:N}=(0,P.$I)(w.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const j=new Set;N.forEach(W=>{j.add(W)}),L.push("-g","!*"),j.forEach(W=>{n(W).map(p.$7ac).forEach(M=>{L.push("-g",M)})})}O&&O.length&&O.forEach(j=>{L.push("-g",j)}),w.excludes.map(p.$7ac).forEach(j=>L.push("-g",`!${j}`)),w.maxFileSize&&L.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||L.push("--no-ignore-parent"):L.push("--no-ignore"),w.followSymlinks&&L.push("--follow"),w.encoding&&w.encoding!=="utf8"&&L.push("--encoding",w.encoding),l.pattern==="--"&&(l.isRegExp=!0,l.pattern="\\-\\-"),l.isMultiline&&!l.isRegExp&&(l.pattern=(0,b.$od)(l.pattern),l.isRegExp=!0),w.usePCRE2&&L.push("--pcre2"),L.push("--crlf"),l.isRegExp&&(l.pattern=t(l.pattern),L.push("--engine","auto"));let T;if(l.isWordMatch){const W=(0,b.$wd)(l.pattern,!!l.isRegExp,{wholeWord:l.isWordMatch}).source.replace(/\\\//g,"/");L.push("--regexp",W)}else if(l.isRegExp){let j=g(l.pattern);j=u(j),L.push("--regexp",j)}else T=l.pattern,L.push("--fixed-strings");return L.push("--no-config"),w.useGlobalIgnoreFiles||L.push("--no-ignore-global"),L.push("--json"),l.isMultiline&&L.push("--multiline"),w.beforeContext&&L.push("--before-context",w.beforeContext+""),w.afterContext&&L.push("--after-context",w.afterContext+""),L.push("--"),T&&L.push(T),L.push("."),L}e.$ebc=o;function n(l){return v(l).flatMap(L=>{const O=(0,m.$cj)(L,"/");return O.map((N,T)=>O.slice(0,T+1).join("/"))})}function t(l){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;l.match(w);)l=l.replace(w,"$1\\x{$2}");const L=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;l.match(L);)l=l.replace(L,"$1\\x{$2}");return l}e.$fbc=t;const a=l=>l.type==="Assertion"&&l.kind==="lookbehind";function g(l){let w;try{w=new D.RegExpParser().parsePattern(l)}catch{return l}let L="",O=0;const N=(W,M,Y)=>{L+=l.slice(O,W)+Y,O=M},T=[];return new D.RegExpVisitor({onCharacterEnter(W){if(W.raw!=="\\n")return;const M=T[0];if(!M)N(W.start,W.end,"\\r?\\n");else if(!T.some(a))if(M.type==="CharacterClass")if(M.negate){const Y=l.slice(M.start+2,W.start)+l.slice(W.end,M.end-1);M.parent?.type==="Quantifier"?N(M.start,M.end,Y?`[^${Y}]`:"."):N(M.start,M.end,"(?!\\r?\\n"+(Y?`|[${Y}]`:"")+")")}else{const Y=l.slice(M.start+1,W.start)+l.slice(W.end,M.end-1);N(M.start,M.end,Y===""?"\\r?\\n":`(?:[${Y}]|\\r?\\n)`)}else M.type==="Quantifier"&&N(W.start,W.end,"(?:\\r?\\n)")},onQuantifierEnter(W){T.unshift(W)},onQuantifierLeave(){T.shift()},onCharacterClassRangeEnter(W){T.unshift(W)},onCharacterClassRangeLeave(){T.shift()},onCharacterClassEnter(W){T.unshift(W)},onCharacterClassLeave(){T.shift()},onAssertionEnter(W){a(W)&&T.push(W)},onAssertionLeave(W){T[0]===W&&T.shift()}}).visit(w),L+=l.slice(O),L}e.$gbc=g;function u(l){return l.replace(/\n/g,"\\r?\\n")}e.$hbc=u;function d(l){let w=!1,L=!1,O="",N="";for(let T=0;T<l.length;T++){const j=l[T];switch(j){case"\\":L?(w?N+="\\"+j:O+="\\"+j,L=!1):L=!0;break;case"{":if(L)w?N+=j:O+=j,L=!1;else{if(w)return{strInBraces:O+"{"+N+"{"+l.substring(T+1)};w=!0}break;case"}":if(L)w?N+=j:O+=j,L=!1;else{if(w)return{fixedStart:O,strInBraces:N,fixedEnd:l.substring(T+1)};O+=j}break;default:w?N+=(L?"\\":"")+j:O+=(L?"\\":"")+j,L=!1;break}}return{strInBraces:O+(w?"{"+N:"")}}function v(l){const{fixedStart:w,strInBraces:L,fixedEnd:O}=d(l);if(w===void 0||O===void 0)return[L];let N=(0,m.$cj)(L,",");N.length||(N=[""]);const T=v(O);return N.flatMap(j=>{const W=w+j;return T.map(M=>W+M)})}e.$ibc=v}),define(Se[343],Ce([1,0,21,148,128,15]),function(fe,e,k,F,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=void 0;class P{constructor(b){this.b=b,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(b,R,I,$){const D=new F.$cbc(this.b);if(R.folder.scheme===A.Schemas.vscodeUserData){const S={...R,folder:R.folder.with({scheme:A.Schemas.file})},p=new h.$Nu(r=>I.report({...r,uri:r.uri.with({scheme:R.folder.scheme})}));return this.c($,r=>D.provideTextSearchResults(b,S,p,r))}else return this.c($,S=>D.provideTextSearchResults(b,R,I,S))}async c(b,R){const I=m(b);this.a.add(I);const $=await R(I.token);return this.a.delete(I),$}d(){this.a.forEach(b=>b.cancel())}}e.$mbc=P;function m(E){const b=new k.$ed;return E.onCancellationRequested(()=>b.cancel()),b}}),define(Se[344],Ce([1,0,29,148,147]),function(fe,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=void 0;class A{constructor(E){this.a=E}search(E,b,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(D){R({message:D})}},$=new h.$jbc(this.a,new F.$cbc(I),k);return new Promise((D,S)=>$.search(p=>{b(p.map(P))},E).then(p=>D({limitHit:p.limitHit,type:"success",stats:p.stats}),S))}}e.$kbc=A;function P(m){return{path:m.resource&&m.resource.fsPath,results:m.results,numMatches:(m.results||[]).reduce((E,b)=>{if(b.ranges){const R=b;return E+(Array.isArray(R.ranges)?R.ranges.length:1)}else return E+1},0)}}}),define(Se[345],Ce([1,0,19,17,8,3,119,13,39,2,30,35,340,344]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=void 0;class S{static{this.a=512}constructor(y="searchProcess"){this.d=y,this.b=Object.create(null)}fileSearch(y){let C;const i=s(y),o=new A.$8c({onDidAddFirstListener:()=>{C=(0,F.$jg)(n=>this.doFileSearchWithEngine($.$bbc,i,t=>o.fire(t),n)),C.then(n=>o.fire(n),n=>o.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onDidRemoveLastListener:()=>{C.cancel()}});return o.event}textSearch(y){let C;const i=s(y),o=new A.$8c({onDidAddFirstListener:()=>{C=(0,F.$jg)(n=>this.f(i,t=>o.fire(t),n)),C.then(n=>o.fire(n),n=>o.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onDidRemoveLastListener:()=>{C.cancel()}});return o.event}f(y,C,i){return y.maxFileSize=this.g().maxFileSize,new D.$kbc(y).search(i,C,C)}g(){return{maxFileSize:process.arch==="ia32"?300*R.$nk.MB:16*R.$nk.GB}}doFileSearch(y,C,i){return this.doFileSearchWithEngine($.$bbc,y,C,i)}doFileSearchWithEngine(y,C,i,o,n=S.a){let t=0;const a=u=>{Array.isArray(u)?(t+=u.length,i(u.map(d=>this.h(d)))):u.relativePath?(t++,i(this.h(u))):i(u)};if(C.sortByScore){let u=this.l(C,a,o);if(!u){const d=C.maxResults?Object.assign({},C,{maxResults:null}):C,v=new y(d);u=this.j(v,C,i,a,o)}return new Promise((d,v)=>{u.then(([l,w])=>{const L=w.map(O=>this.h(O));this.o(L,i,n),d(l)},v)})}const g=new y(C);return this.r(g,a,n,o).then(u=>({limitHit:u.limitHit,type:"success",stats:{detailStats:u.stats,type:this.d,fromCache:!1,resultCount:t,sortingTime:void 0}}))}h(y){return{path:y.base?(0,m.$ac)(y.base,y.relativePath):y.relativePath}}j(y,C,i,o,n){const t=new A.$8c;let a=(0,F.$jg)(u=>{let d=[];const v=l=>{Array.isArray(l)?d=l:(o(l),t.fire(l))};return this.r(y,v,-1,u).then(l=>[l,d])}),g;if(C.cacheKey){g=this.k(C.cacheKey);const u={promise:a,event:t.event,resolved:!1};g.resultsToSearchCache[C.filePattern||""]=u,a.then(()=>{u.resolved=!0},d=>{delete g.resultsToSearchCache[C.filePattern||""]}),a=this.s(a)}return a.then(([u,d])=>{const v=g?g.scorerCache:Object.create(null),l=(typeof C.maxResults!="number"||C.maxResults>0)&&E.$4c.create(!1);return this.n(C,d,v,n).then(w=>{const L=l?l.elapsed():-1;return[{type:"success",stats:{detailStats:u.stats,sortingTime:L,fromCache:!1,type:this.d,workspaceFolderCount:C.folderQueries.length,resultCount:w.length},messages:u.messages,limitHit:u.limitHit||typeof C.maxResults=="number"&&d.length>C.maxResults},w]})})}k(y){const C=this.b[y];return C||(this.b[y]=new p)}l(y,C,i){const o=y.cacheKey&&this.b[y.cacheKey];if(!o)return;const n=this.q(o,y.filePattern||"",C,i);if(n)return n.then(([t,a,g])=>{const u=E.$4c.create(!1);return this.n(y,a,o.scorerCache,i).then(d=>{const v=u.elapsed(),l={fromCache:!0,detailStats:g,type:this.d,resultCount:a.length,sortingTime:v};return[{type:"success",limitHit:t.limitHit||typeof y.maxResults=="number"&&a.length>y.maxResults,stats:l},d]})})}n(y,C,i,o){const n=(0,P.$dq)(y.filePattern||""),t=(g,u)=>(0,P.$cq)(g,u,n,!0,r,i),a=typeof y.maxResults=="number"?y.maxResults:Number.MAX_VALUE;return k.$lf(C,t,a,1e4,o)}o(y,C,i){if(i&&i>0)for(let o=0;o<y.length;o+=i)C(y.slice(o,o+i));else C(y)}q(y,C,i,o){const n=E.$4c.create(!1),t=C.indexOf(m.sep)>=0;let a;for(const v in y.resultsToSearchCache)if(C.startsWith(v)){if(t&&v.indexOf(m.sep)<0&&v!=="")continue;const l=y.resultsToSearchCache[v];a={promise:this.s(l.promise),event:l.event,resolved:l.resolved};break}if(!a)return null;const g=n.elapsed(),u=E.$4c.create(!1),d=a.event(i);return o&&o.onCancellationRequested(()=>{d.dispose()}),a.promise.then(([v,l])=>{if(o&&o.isCancellationRequested)throw(0,h.$4)();const w=[],L=(0,P.$dq)(C).normalizedLowercase;for(const O of l)(0,I.$cI)(O,L)&&w.push(O);return[v,w,{cacheWasResolved:a.resolved,cacheLookupTime:g,cacheFilterTime:u.elapsed(),cacheEntryCount:l.length}]})}r(y,C,i,o){return new Promise((n,t)=>{let a=[];o?.onCancellationRequested(()=>y.cancel()),y.search(g=>{g&&(i?(a.push(g),i>0&&a.length>=i&&(C(a),a=[])):C(g))},g=>{C(g)},(g,u)=>{a.length&&C(a),g?t(g):n(u)})})}clearCache(y){return delete this.b[y],Promise.resolve(void 0)}s(y){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(C,i){return y.then(C,i)}catch(C){return this.then(void 0,C)}finally(C){return y.finally(C)}}}}e.$lbc=S;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const r=new class{getItemLabel(f){return(0,m.$ec)(f.relativePath)}getItemDescription(f){return(0,m.$dc)(f.relativePath)}getItemPath(f){return f.relativePath}};function s(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(c),extraFileResources:f.extraFileResources&&f.extraFileResources.map(y=>b.URI.revive(y))}}function c(f){return{...f,folder:b.URI.revive(f.folder)}}}),define(Se[346],Ce([1,0,4,15,2,29,18,26,20,91,58,35,345,343,110,147]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=void 0;let r=class extends b.$iac{constructor(c,f,y,C){super(c,y,C),this.s=A,this.t=-1,this.v=null,this.w=!1;const i=new S.$9ac("RipgrepSearchUD",this.n);this.registerTextSearchProvider(F.Schemas.vscodeUserData,new D.$mbc(i)),f.remote.isRemote&&f.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const c=new S.$9ac("RipgrepSearchEH",this.n);this.registerTextSearchProvider(F.Schemas.file,new D.$mbc(c)),this.y(F.Schemas.file,new $.$lbc("fileSearchProvider"))}y(c,f){const y=this.d++;return this.v=f,this.t=y,this.c.$registerFileSearchProvider(y,this.o(c)),(0,k.$jb)(()=>{this.v=null,this.c.$unregisterProvider(y)})}$provideFileSearchResults(c,f,y,C){const i=(0,b.$jac)(y);return c===this.t?this.z(c,f,i,C):super.$provideFileSearchResults(c,f,y,C)}z(c,f,y,C){const i=o=>{if((0,I.$bI)(o)&&(o=[o]),Array.isArray(o)){this.c.$handleFileMatch(c,f,o.map(n=>h.URI.file(n.path)));return}o.message&&this.n.debug("ExtHostSearch",o.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(y,i,C)}$clearCache(c){return this.v?.clearCache(c),super.$clearCache(c)}q(c,f){return new p.$jbc(c,f,void 0,"textSearchProvider")}};e.$nbc=r,e.$nbc=r=Je([qe(0,E.$DL),qe(1,m.$TL),qe(2,R.$1$b),qe(3,P.$Ri)],r)}),define(Se[149],Ce([1,0,358,101,75,359,22,8,3,4,13,11,32,76,122]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=void 0;class p{traceSocketEvent(l,w){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,w)}constructor(l,w=""){this.f=!0,this.debugLabel=w,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,m.$Y)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(l){const w=L=>{this.traceSocketEvent("read",L),l(P.$Jb.wrap(L))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(l){const w=L=>{l({type:0,hadError:L,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(l){const w=()=>{l()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(l){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,m.$Y)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,m.$Y)(w)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$eh=p;var r;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(r||(r={}));var s;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(s||(s={}));class c extends b.$lb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(l,w){this.socket.traceSocketEvent(l,w)}constructor(l,w,L,O){super(),this.f=this.B(new E.$8c),this.g=this.B(new E.$8c),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:L?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new f(this,w,L,O,this.f,(N,T)=>this.k(N,T))),this.B(this.a.onError(N=>{console.error(N),(0,m.$Y)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new S.$_g,this.B(this.socket.onData(N=>this.l(N))),this.B(this.socket.onClose(async N=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(N)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this.f.event(l)}onClose(l){return this.g.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){let w=0;for(;w<l.byteLength;)this.a.writeMessage(l.slice(w,Math.min(w+262144,l.byteLength))),w+=262144}k(l,w){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let L=2;l.byteLength<126?L+=0:l.byteLength<2**16?L+=2:L+=8;const O=P.$Jb.alloc(L);if(w?O.writeUInt8(194,0):O.writeUInt8(130,0),l.byteLength<126)O.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){O.writeUInt8(126,1);let N=1;O.writeUInt8(l.byteLength>>>8&255,++N),O.writeUInt8(l.byteLength>>>0&255,++N)}else{O.writeUInt8(127,1);let N=1;O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(l.byteLength>>>24&255,++N),O.writeUInt8(l.byteLength>>>16&255,++N),O.writeUInt8(l.byteLength>>>8&255,++N),O.writeUInt8(l.byteLength>>>0&255,++N)}this.socket.write(P.$Jb.concat([O,l]))}end(){this.h=!0,this.socket.end()}l(l){if(l.byteLength!==0){for(this.b.acceptChunk(l);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const w=this.b.peek(this.j.readLen),L=w.readUInt8(0),O=(L&128)>>>7,N=(L&64)>>>6,T=w.readUInt8(1),j=(T&128)>>>7,W=T&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(W===126?2:0)+(W===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!N),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const w=this.b.read(this.j.readLen),L=w.readUInt8(1),O=(L&128)>>>7;let N=L&127,T=1;N===126?N=w.readUInt8(++T)*2**8+w.readUInt8(++T):N===127&&(N=w.readUInt8(++T)*0+w.readUInt8(++T)*0+w.readUInt8(++T)*0+w.readUInt8(++T)*0+w.readUInt8(++T)*2**24+w.readUInt8(++T)*2**16+w.readUInt8(++T)*2**8+w.readUInt8(++T));let j=0;O&&(j=w.readUInt8(++T)*2**24+w.readUInt8(++T)*2**16+w.readUInt8(++T)*2**8+w.readUInt8(++T)),this.j.state=3,this.j.readLen=N,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const w=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",w),i(w,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",w),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(w,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$fh=c;class f extends b.$lb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:P.$Jb.alloc(0)}constructor(l,w,L,O,N,T){super(),this.l=l,this.m=N,this.n=T,this.a=this.B(new E.$8c),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$8c),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new E.$8c),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,w?(this.b=this.B(new y(this.l,O,L,{windowBits:15})),this.f=this.B(new C(this.l,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(l){this.g.push(l),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const l=this.g.shift();if(this.f){const w=await this.s(this.f,l);this.n(w,!0)}else this.n(l,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(l,w){return new Promise((L,O)=>{l.write(w),l.flush(N=>L(N))})}acceptFrame(l,w,L){this.h.push({data:l,isCompressed:w,isLastFrameOfMessage:L}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const l=this.h.shift();if(this.b&&l.isCompressed){const w=await this.w(this.b,l.data,l.isLastFrameOfMessage);this.m.fire(w)}else this.m.fire(l.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(l,w,L){return new Promise((O,N)=>{l.write(w),L&&l.write(P.$Jb.fromByteArray([0,0,255,255])),l.flush(T=>O(T))})}}class y extends b.$lb{get recordedInflateBytes(){return this.j?P.$Jb.concat(this.f):P.$Jb.alloc(0)}constructor(l,w,L,O){super(),this.h=l,this.j=w,this.a=this.B(new E.$8c),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(O),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(P.$Jb.wrap(N))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(l){this.j&&this.f.push(l.clone()),this.h.traceSocketEvent("zlibInflateWrite",l),this.b.write(l.buffer)}flush(l){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const w=P.$Jb.concat(this.g);this.g.length=0,l(w)})}}class C extends b.$lb{constructor(l,w){super(),this.g=l,this.a=this.B(new E.$8c),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(P.$Jb.wrap(L))})}write(l){this.g.traceSocketEvent("zlibDeflateWrite",l.buffer),this.b.write(l.buffer)}flush(l){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let w=P.$Jb.concat(this.f);this.f.length=0,w=w.slice(0,w.byteLength-4),l(w)})}}function i(v,l){if(l===0)return;const w=v.byteLength>>>2;for(let W=0;W<w;W++){const M=v.readUInt32BE(W*4);v.writeUInt32BE(M^l,W*4)}const L=w*4,O=v.byteLength-L,N=l>>>24&255,T=l>>>16&255,j=l>>>8&255;O>=1&&v.writeUInt8(v.readUInt8(L)^N,L),O>=2&&v.writeUInt8(v.readUInt8(L+1)^T,L+1),O>=3&&v.writeUInt8(v.readUInt8(L+2)^j,L+2)}e.$gh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function n(){const v=(0,$.$6e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const l=process.platform!=="darwin"&&e.$gh?e.$gh:(0,h.tmpdir)(),w=(0,R.$ac)(l,`vscode-ipc-${v}.sock`);return a(w),w}e.$hh=n;function t(v,l,w){const L=(0,k.createHash)("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${w}-${l}-sock`;const O=w.substr(0,4),N=l.substr(0,6),T=L.substr(0,8);let j;return process.platform!=="darwin"&&e.$gh&&!process.env.VSCODE_PORTABLE?j=(0,R.$ac)(e.$gh,`vscode-${T}-${O}-${N}.sock`):j=(0,R.$ac)(v,`${O}-${N}.sock`),a(j),j}e.$ih=t;function a(v){const l=o[I.$t];typeof l=="number"&&v.length>=l&&console.warn(`WARNING: IPC handle "${v}" is longer than ${l} chars, try a shorter --user-data-dir`)}class g extends D.$6g{static b(l){const w=E.Event.fromNodeEventEmitter(l,"connection");return E.Event.map(w,L=>({protocol:new S.$ah(new p(L,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(L,"close"))}))}constructor(l){super(g.b(l)),this.d=l}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$jh=g;function u(v){return new Promise((l,w)=>{const L=(0,F.createServer)();L.on("error",w),L.listen(v,()=>{L.removeListener("error",w),l(new g(L))})})}e.$kh=u;function d(v,l){return new Promise((w,L)=>{const O=(0,F.createConnection)(v,()=>{O.removeListener("error",L),w(S.$bh.fromSocket(new p(O,`ipc-client${l}`),l))});O.once("error",L)})}e.$lh=d}),define(Se[347],Ce([1,0,149,252,49,36,2,18,50]),function(fe,e,k,F,h,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=void 0;class b{constructor($,D,S){this.b=$,this.c=D,this.f=S,this.a=F.createServer((p,r)=>this.h(p,r)),this.g().catch(p=>(D.error(p),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,D){const S=(r,s)=>{D.writeHead(r,{"content-type":"application/json"}),D.end(JSON.stringify(s||null),c=>c&&this.c.error(c))},p=[];$.setEncoding("utf8"),$.on("data",r=>p.push(r)),$.on("end",async()=>{try{const r=JSON.parse(p.join(""));let s;switch(r.type){case"open":s=await this.i(r);break;case"openExternal":s=await this.j(r);break;case"status":s=await this.l(r);break;case"extensionManagement":s=await this.k(r);break;default:S(404,`Unknown message type: ${r.type}`);break}S(200,s)}catch(r){const s=r instanceof Error?r.message:JSON.stringify(r);S(500,s),this.c.error("Error while processing pipe request",r)}})}async i($){const{fileURIs:D,folderURIs:S,forceNewWindow:p,diffMode:r,mergeMode:s,addMode:c,forceReuseWindow:f,gotoLineMode:y,waitMarkerFilePath:C,remoteAuthority:i}=$,o=[];if(Array.isArray(S))for(const g of S)try{o.push({folderUri:P.URI.parse(g)})}catch{}if(Array.isArray(D))for(const g of D)try{(0,E.$Uh)(g)?o.push({workspaceUri:P.URI.parse(g)}):o.push({fileUri:P.URI.parse(g)})}catch{}const n=C?P.URI.file(C):void 0,a={forceNewWindow:p,diffMode:r,mergeMode:s,addMode:c,gotoLineMode:y,forceReuseWindow:f,preferNewWindow:!f&&!n&&!c,waitMarkerFileURI:n,remoteAuthority:i};this.b.executeCommand("_remoteCLI.windowOpen",o,a)}async j($){for(const D of $.uris){const S=P.URI.parse(D),p=S.scheme==="file"?S:D;await this.b.executeCommand("_remoteCLI.openExternal",p)}}async k($){const D=p=>p?.map(r=>/\.vsix$/i.test(r)?P.URI.parse(r):r),S={list:$.list,install:D($.install),uninstall:D($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&h.existsSync(this.f)&&h.unlinkSync(this.f)}}e.$5L=b;let R=class extends b{constructor($,D){super($,D,(0,k.$hh)())}};e.$6L=R,e.$6L=R=Je([qe(0,A.$ZL),qe(1,m.$Ri)],R)}),define(Se[348],Ce([1,0,89,336,331,251,44,319,2,15,7,347,95,317,318]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sbc=void 0;class p extends h.$Tac{j(){const c=this,f=globalThis._VSCODE_NODE_MODULES.module,y=f._load;f._load=function(n,t,a){return n=i(n),c.a.has(n)?c.a.get(n).load(n,E.URI.file((0,$.$Mp)(t.filename)),g=>y.apply(this,[g,t,a])):y.apply(this,arguments)};const C=f._resolveLookupPaths;f._resolveLookupPaths=(o,n)=>C.call(this,i(o),n);const i=o=>{for(const n of c.b){const t=n(o);if(t){o=t;break}}return o}}}class r extends P.$y_b{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async pb(){this.h.createInstance(D.$qbc);const c=this.h.invokeFunction(F.$Pac);if(this.h.createInstance(m.$pbc),this.f.remote.isRemote&&this.f.remote.authority){const C=this.h.createInstance(I.$6L);process.env.VSCODE_IPC_HOOK_CLI=C.ipcHandlePath}this.h.createInstance(S.$rbc),await this.h.createInstance(p,c,{mine:this.F,all:this.G}).install(),k.mark("code/extHost/didInitAPI");const y=await this.k.getConfigProvider();await(0,A.$obc)(this.j,y,this,this.l,this.u,this.f),k.mark("code/extHost/didInitProxyResolver")}qb(c){return c.main}async rb(c,f,y){if(f.scheme!==b.Schemas.file)throw new Error(`Cannot load URI: '${f}', must be of file-scheme`);let C=null;y.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${f.toString(!0)}`),this.l.flush();const i=c?.identifier.value;c&&await this.s.initializeLocalizedMessages(c);try{i&&k.mark(`code/extHost/willLoadExtensionCode/${i}`),C=fe.__$__nodeRequire(f.fsPath)}finally{i&&k.mark(`code/extHost/didLoadExtensionCode/${i}`),y.codeLoadingStop()}return C}async $setRemoteEnvironment(c){if(this.f.remote.isRemote)for(const f in c){const y=c[f];y===null?delete process.env[f]:process.env[f]=y}}}e.$sbc=r}),define(Se[349],Ce([1,0,98,322,334,333,346,348,323,90,44,91,88,43,64,85,321,320,18,335,52,246,97]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c,f,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,k.$_q)(R.$z_b,m.$sbc,0),(0,k.$_q)(c.$Si,s.$Cbc,1),(0,k.$_q)(c.$Ri,new i.$mh(C.$Sac,[!1],!0)),(0,k.$_q)(p.$k_b,r.$Bbc,0),(0,k.$_q)(b.$0_b,A.$6ac,0),(0,k.$_q)(I.$hac,P.$nbc,0),(0,k.$_q)($.$5_b,h.$Xac,0),(0,k.$_q)(D.$m_b,F.$Wac,0),(0,k.$_q)(S.$Wpb,E.$Abc,0),(0,k.$_q)(y.$8_b,f.$Dbc,0)}),define(Se[360],Ce([1,0,101,361,362,89,8,122,149,233,105,332,22,29,95,17,124,253,271,337,349]),function(fe,e,k,F,h,A,P,m,E,b,R,I,$,D,S,p,r,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let u=0;u<process.execArgv.length;u++)process.execArgv[u]==="--inspect-port=0"&&(process.execArgv.splice(u,1),u--)}(),function(){h.setDefaultResultOrder("ipv4first")}();const f=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const g=globalThis._VSCODE_NODE_MODULES.module,u=g._load;g._load=function(d){if(d==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return u.apply(this,arguments)}})();const y=process.exit.bind(process);function C(g){process.exit=function(u){if(g)y(u);else{const d=new Error("An extension called process.exit() and this was prevented.");console.warn(d.stack)}},process.crash=function(){const u=new Error("An extension called process.crash() and this was prevented.");console.warn(u.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let i=function(g){y()};function o(){const g=(0,c.$dm)(process.env);if(g.type===3)return new Promise((u,d)=>{const v=l=>{const w=l[0],L=new m.$ch;w.on("message",O=>L.fire($.$Jb.wrap(O.data))),w.on("close",()=>{i("renderer closed the MessagePort")}),w.start(),u({onMessage:L.event,send:O=>w.postMessage(O.buffer)})};process.parentPort.on("message",l=>v(l.ports))});if(g.type===2)return new Promise((u,d)=>{let v=null;const l=setTimeout(()=>{i("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),w=108e5,L=3e5,O=new p.$Hg(()=>i("renderer disconnected for too long (1)"),w),N=new p.$Hg(()=>i("renderer disconnected for too long (2)"),L);process.on("message",(j,W)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){W.setNoDelay(!0);const M=$.$Jb.wrap(Buffer.from(j.initialDataChunk,"base64"));let Y;if(j.skipWebSocketFrames)Y=new E.$eh(W,"extHost-socket");else{const V=$.$Jb.wrap(Buffer.from(j.inflateBytes,"base64"));Y=new E.$fh(new E.$eh(W,"extHost-socket"),j.permessageDeflate,V,!1)}v?(O.cancel(),N.cancel(),v.beginAcceptReconnection(Y,M),v.endAcceptReconnection(),v.sendResume()):(clearTimeout(l),v=new m.$dh({socket:Y,initialChunk:M}),v.sendResume(),v.onDidDispose(()=>i("renderer disconnected")),u(v),v.onSocketClose(()=>{O.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;O.isScheduled()&&N.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(T)});{const u=g.pipeName;return new Promise((d,v)=>{const l=k.createConnection(u,()=>{l.removeListener("error",v);const w=new m.$dh({socket:new E.$eh(l,"extHost-renderer")});w.sendResume(),d(w)});l.once("error",v),l.on("close",()=>{i("renderer closed the socket")})})}}async function n(){const g=await o();return new class{constructor(){this.a=new m.$ch,this.onMessage=this.a.event,this.b=!1,g.onMessage(u=>{(0,R.$Ql)(u,2)?(this.b=!0,i("received terminate message from renderer")):this.a.fire(u)})}send(u){this.b||g.send(u)}async drain(){if(g.drain)return g.drain()}}}function t(g){return new Promise(u=>{const d=g.onMessage(v=>{d.dispose();const l=JSON.parse(v.toString()),w=l.commit,L=b.default.commit;if(w&&L&&w!==L&&y(55),l.parentPid){let O=0;setInterval(function(){try{process.kill(l.parentPid,0),O=0}catch(T){T&&T.code==="EPERM"?(O++,O>=3&&i(`parent process ${l.parentPid} does not exist anymore (3 x EPERM): ${T.message} (code: ${T.code}) (errno: ${T.errno})`)):i(`parent process ${l.parentPid} does not exist anymore: ${T.message} (code: ${T.code}) (errno: ${T.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(l.parentPid)}catch(T){(0,P.$Y)(T)}}g.send((0,R.$Pl)(0)),u({protocol:g,initData:l})});g.send((0,R.$Pl)(1))})}async function a(){const g=[];process.on("unhandledRejection",(O,N)=>{g.push(N),setTimeout(()=>{const T=g.indexOf(N);T>=0&&N.catch(j=>{g.splice(T,1),(0,P.$2)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),O&&(0,P.$Y)(O))})},1e3)}),process.on("rejectionHandled",O=>{const N=g.indexOf(O);N>=0&&g.splice(N,1)}),process.on("uncaughtException",function(O){(0,P.$X)(O)||(0,P.$Y)(O)}),A.mark("code/extHost/willConnectToRenderer");const u=await n();A.mark("code/extHost/didConnectToRenderer");const d=await t(u);A.mark("code/extHost/didWaitForInitData");const{initData:v}=d;C(!!v.environment.extensionTestsLocationURI),v.environment.useHostProxy=f.useHostProxy!==void 0?f.useHostProxy!=="false":void 0,v.environment.skipWorkspaceStorageLock=(0,r.boolean)(f.skipWorkspaceStorageLock,!1);const l=new class{constructor(){this.pid=process.pid}exit(N){y(N)}fsExists(N){return D.Promises.exists(N)}fsRealpath(N){return(0,S.$Lp)(N)}};let w=null;v.remote.authority&&f.transformURIs&&(w=(0,s.$dr)(v.remote.authority));const L=new I.$Vac(d.protocol,v,l,w);i=O=>L.terminate(O)}a().catch(g=>console.log(g))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/93d3731736cc6fefbd63810d5fb2d57bedc84ca0/core/vs/workbench/api/node/extensionHostProcess.js.map
