/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/base/common/collections","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Fe=function($e){for(var e=[],w=0,T=$e.length;w<T;w++)e[w]=Ae[$e[w]];return e};define(Ae[65],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.$Ug=e.$Tg=void 0;function w(P){return(g,D,p)=>{let A=null,E=null;if(typeof p.value=="function"?(A="value",E=p.value):typeof p.get=="function"&&(A="get",E=p.get),!E)throw new Error("not supported");p[A]=P(E,D)}}function T(P,g,D){let p=null,A=null;if(typeof D.value=="function"?(p="value",A=D.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(p="get",A=D.get),!A)throw new Error("not supported");const E=`$memoize$${g}`;D[p]=function(...c){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,c)}),this[E]}}e.$Tg=T;function C(P,g,D){return w((p,A)=>{const E=`$debounce$${A}`,c=`$debounce$result$${A}`;return function(...y){this[c]||(this[c]=D?D():void 0),clearTimeout(this[E]),g&&(this[c]=g(this[c],...y),y=[this[c]]),this[E]=setTimeout(()=>{p.apply(this,y),this[c]=D?D():void 0},P)}})}e.$Ug=C;function M(P,g,D){return w((p,A)=>{const E=`$throttle$timer$${A}`,c=`$throttle$result$${A}`,y=`$throttle$lastRun$${A}`,b=`$throttle$pending$${A}`;return function(...o){if(this[c]||(this[c]=D?D():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),g&&(this[c]=g(this[c],...o)),this[b])return;const t=this[y]+P;t<=Date.now()?(this[y]=Date.now(),p.apply(this,[this[c]]),this[c]=D?D():void 0):(this[b]=!0,this[E]=setTimeout(()=>{this[b]=!1,this[y]=Date.now(),p.apply(this,[this[c]]),this[c]=D?D():void 0},t-Date.now()))}})}e.$Vg=M}),define(Ae[87],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JL=e.$IL=void 0;class w{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$IL=w,e.$JL=new w("id#")}),define(Ae[115],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var T;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var C;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var M;(function(r){r.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function P(r,h=!1){let n=0;const s=r.length;let $="",k=0,l=16,f=0;function v(U){let N=0,O=0;for(;N<U;){const ce=r.charCodeAt(n);if(ce>=48&&ce<=57)O=O*16+ce-48;else if(ce>=65&&ce<=70)O=O*16+ce-65+10;else if(ce>=97&&ce<=102)O=O*16+ce-97+10;else break;n++,N++}return N<U&&(O=-1),O}function u(U){n=U,$="",k=0,l=16,f=0}function d(){const U=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&p(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&p(r.charCodeAt(n)))for(n++;n<r.length&&p(r.charCodeAt(n));)n++;else return f=3,r.substring(U,n);let N=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&p(r.charCodeAt(n))){for(n++;n<r.length&&p(r.charCodeAt(n));)n++;N=n}else f=3;return r.substring(U,N)}function R(){let U="",N=n;for(;;){if(n>=s){U+=r.substring(N,n),f=2;break}const O=r.charCodeAt(n);if(O===34){U+=r.substring(N,n),n++;break}if(O===92){if(U+=r.substring(N,n),n++,n>=s){f=2;break}switch(r.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const X=v(4);X>=0?U+=String.fromCharCode(X):f=4;break}default:f=5}N=n;continue}if(O>=0&&O<=31)if(D(O)){U+=r.substring(N,n),f=2;break}else f=6;n++}return U}function W(){if($="",f=0,k=n,n>=s)return k=s,l=17;let U=r.charCodeAt(n);if(g(U)){do n++,$+=String.fromCharCode(U),U=r.charCodeAt(n);while(g(U));return l=15}if(D(U))return n++,$+=String.fromCharCode(U),U===13&&r.charCodeAt(n)===10&&(n++,$+=`
`),l=14;switch(U){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,$=R(),l=10;case 47:{const N=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<s&&!D(r.charCodeAt(n));)n++;return $=r.substring(N,n),l=12}if(r.charCodeAt(n+1)===42){n+=2;const O=s-1;let ce=!1;for(;n<O;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,ce=!0;break}n++}return ce||(n++,f=1),$=r.substring(N,n),l=13}return $+=String.fromCharCode(U),n++,l=16}case 45:if($+=String.fromCharCode(U),n++,n===s||!p(r.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return $+=d(),l=11;default:for(;n<s&&B(U);)n++,U=r.charCodeAt(n);if(k!==n){switch($=r.substring(k,n),$){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return $+=String.fromCharCode(U),n++,l=16}}function B(U){if(g(U)||D(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let U;do U=W();while(U>=12&&U<=15);return U}return{setPosition:u,getPosition:()=>n,scan:h?q:W,getToken:()=>l,getTokenValue:()=>$,getTokenOffset:()=>k,getTokenLength:()=>n-k,getTokenError:()=>f}}e.$vm=P;function g(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function D(r){return r===10||r===13||r===8232||r===8233}function p(r){return r>=48&&r<=57}var A;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(A||(A={}));function E(r,h){const n=[],s=new Object;let $;const k={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function f(v,u,d,R){k.value=v,k.offset=u,k.length=d,k.type=R,k.colonOffset=void 0,$=k}try{m(r,{onObjectBegin:(v,u)=>{if(h<=v)throw s;$=void 0,l=h>v,n.push("")},onObjectProperty:(v,u,d)=>{if(h<u||(f(v,u,d,"property"),n[n.length-1]=v,h<=u+d))throw s},onObjectEnd:(v,u)=>{if(h<=v)throw s;$=void 0,n.pop()},onArrayBegin:(v,u)=>{if(h<=v)throw s;$=void 0,n.push(0)},onArrayEnd:(v,u)=>{if(h<=v)throw s;$=void 0,n.pop()},onLiteralValue:(v,u,d)=>{if(h<u||(f(v,u,d,I(v)),h<=u+d))throw s},onSeparator:(v,u,d)=>{if(h<=u)throw s;if(v===":"&&$&&$.type==="property")$.colonOffset=u,l=!1,$=void 0;else if(v===","){const R=n[n.length-1];typeof R=="number"?n[n.length-1]=R+1:(l=!0,n[n.length-1]=""),$=void 0}}})}catch(v){if(v!==s)throw v}return{path:n,previousNode:$,isAtPropertyKey:l,matches:v=>{let u=0;for(let d=0;u<v.length&&d<n.length;d++)if(v[u]===n[d]||v[u]==="*")u++;else if(v[u]!=="**")return!1;return u===v.length}}}e.$wm=E;function c(r,h=[],n=M.DEFAULT){let s=null,$=[];const k=[];function l(v){Array.isArray($)?$.push(v):s!==null&&($[s]=v)}return m(r,{onObjectBegin:()=>{const v={};l(v),k.push($),$=v,s=null},onObjectProperty:v=>{s=v},onObjectEnd:()=>{$=k.pop()},onArrayBegin:()=>{const v=[];l(v),k.push($),$=v,s=null},onArrayEnd:()=>{$=k.pop()},onLiteralValue:l,onError:(v,u,d)=>{h.push({error:v,offset:u,length:d})}},n),$[0]}e.$xm=c;function y(r,h=[],n=M.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function $(v){s.type==="property"&&(s.length=v-s.offset,s=s.parent)}function k(v){return s.children.push(v),v}m(r,{onObjectBegin:v=>{s=k({type:"object",offset:v,length:-1,parent:s,children:[]})},onObjectProperty:(v,u,d)=>{s=k({type:"property",offset:u,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:v,offset:u,length:d,parent:s})},onObjectEnd:(v,u)=>{s.length=v+u-s.offset,s=s.parent,$(v+u)},onArrayBegin:(v,u)=>{s=k({type:"array",offset:v,length:-1,parent:s,children:[]})},onArrayEnd:(v,u)=>{s.length=v+u-s.offset,s=s.parent,$(v+u)},onLiteralValue:(v,u,d)=>{k({type:I(v),offset:u,length:d,parent:s,value:v}),$(u+d)},onSeparator:(v,u,d)=>{s.type==="property"&&(v===":"?s.colonOffset=u:v===","&&$(u))},onError:(v,u,d)=>{h.push({error:v,offset:u,length:d})}},n);const f=s.children[0];return f&&delete f.parent,f}e.$ym=y;function b(r,h){if(!r)return;let n=r;for(const s of h)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let $=!1;for(const k of n.children)if(Array.isArray(k.children)&&k.children[0].value===s){n=k.children[1],$=!0;break}if(!$)return}else{const $=s;if(n.type!=="array"||$<0||!Array.isArray(n.children)||$>=n.children.length)return;n=n.children[$]}return n}e.$zm=b;function o(r){if(!r.parent||!r.parent.children)return[];const h=o(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;h.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&h.push(n)}return h}e.$Am=o;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const h=Object.create(null);for(const n of r.children){const s=n.children[1];s&&(h[n.children[0].value]=t(s))}return h}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.$Bm=t;function i(r,h,n=!1){return h>=r.offset&&h<r.offset+r.length||n&&h===r.offset+r.length}e.$Cm=i;function a(r,h,n=!1){if(i(r,h,n)){const s=r.children;if(Array.isArray(s))for(let $=0;$<s.length&&s[$].offset<=h;$++){const k=a(s[$],h,n);if(k)return k}return r}}e.$Dm=a;function m(r,h,n=M.DEFAULT){const s=P(r,!1);function $(Ce){return Ce?()=>Ce(s.getTokenOffset(),s.getTokenLength()):()=>!0}function k(Ce){return Ce?H=>Ce(H,s.getTokenOffset(),s.getTokenLength()):()=>!0}const l=$(h.onObjectBegin),f=k(h.onObjectProperty),v=$(h.onObjectEnd),u=$(h.onArrayBegin),d=$(h.onArrayEnd),R=k(h.onLiteralValue),W=k(h.onSeparator),B=$(h.onComment),q=k(h.onError),U=n&&n.disallowComments,N=n&&n.allowTrailingComma;function O(){for(;;){const Ce=s.scan();switch(s.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:U||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(Ce){case 12:case 13:U?ce(10):B();break;case 16:ce(1);break;case 15:case 14:break;default:return Ce}}}function ce(Ce,H=[],ne=[]){if(q(Ce),H.length+ne.length>0){let re=s.getToken();for(;re!==17;){if(H.indexOf(re)!==-1){O();break}else if(ne.indexOf(re)!==-1)break;re=O()}}}function X(Ce){const H=s.getTokenValue();return Ce?R(H):f(H),O(),!0}function be(){switch(s.getToken()){case 11:{let Ce=0;try{Ce=JSON.parse(s.getTokenValue()),typeof Ce!="number"&&(ce(2),Ce=0)}catch{ce(2)}R(Ce);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return O(),!0}function Ee(){return s.getToken()!==10?(ce(3,[],[2,5]),!1):(X(!1),s.getToken()===6?(W(":"),O(),he()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function Re(){l(),O();let Ce=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(Ce||ce(4,[],[]),W(","),O(),s.getToken()===2&&N)break}else Ce&&ce(6,[],[]);Ee()||ce(4,[],[2,5]),Ce=!0}return v(),s.getToken()!==2?ce(7,[2],[]):O(),!0}function Z(){u(),O();let Ce=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(Ce||ce(4,[],[]),W(","),O(),s.getToken()===4&&N)break}else Ce&&ce(6,[],[]);he()||ce(4,[],[4,5]),Ce=!0}return d(),s.getToken()!==4?ce(8,[4],[]):O(),!0}function he(){switch(s.getToken()){case 3:return Z();case 1:return Re();case 10:return X(!0);default:return be()}}return O(),s.getToken()===17?n.allowEmptyContent?!0:(ce(4,[],[]),!1):he()?(s.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}e.$Em=m;function S(r,h){const n=P(r),s=[];let $,k=0,l;do switch(l=n.getPosition(),$=n.scan(),$){case 12:case 13:case 17:k!==l&&s.push(r.substring(k,l)),h!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,h)),k=n.getPosition();break}while($!==17);return s.join("")}e.$Fm=S;function I(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.$Gm=I}),define(Ae[28],Fe([1,0]),function($e,e){"use strict";var w,T,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.Touch=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;function M(o,t,i){let a=o.get(t);return a===void 0&&(a=i,o.set(t,a)),a}e.$ki=M;function P(o){const t=[];return o.forEach((i,a)=>{t.push(`${a} => ${i}`)}),`Map(${o.size}) {${t.join(", ")}}`}e.$li=P;function g(o){const t=[];return o.forEach(i=>{t.push(i)}),`Set(${o.size}) {${t.join(", ")}}`}e.$mi=g;class D{constructor(t,i){this.uri=t,this.value=i}}class p{static{this.a=t=>t.toString()}constructor(t,i){this[w]="ResourceMap",t instanceof p?(this.b=new Map(t.b),this.c=i??p.a):(this.b=new Map,this.c=t??p.a)}set(t,i){return this.b.set(this.c(t),new D(t,i)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,i){typeof i<"u"&&(t=t.bind(i));for(const[a,m]of this.b)t(m.value,m.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}e.$ni=p;class A{constructor(t,i){this[T]="ResourceSet",!t||typeof t=="function"?this.a=new p(t):(this.a=new p(i),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,i){this.a.forEach((a,m)=>t.call(i,m,m,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$oi=A;var E;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(E||(e.Touch=E={}));class c{constructor(){this[C]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,i=0){const a=this.a.get(t);if(a)return i!==0&&this.j(a,i),a.value}set(t,i,a=0){let m=this.a.get(t);if(m)m.value=i,a!==0&&this.j(m,a);else{switch(m={key:t,value:i,next:void 0,previous:void 0},a){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(t,m),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const i=this.a.get(t);if(i)return this.a.delete(t),this.i(i),this.d--,i.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,i){const a=this.e;let m=this.b;for(;m;){if(i?t.bind(i)(m.value,m.key,this):t(m.value,m.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const t=this,i=this.e;let a=this.b;const m={[Symbol.iterator](){return m},next(){if(t.e!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const S={value:a.key,done:!1};return a=a.next,S}else return{value:void 0,done:!0}}};return m}values(){const t=this,i=this.e;let a=this.b;const m={[Symbol.iterator](){return m},next(){if(t.e!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const S={value:a.value,done:!1};return a=a.next,S}else return{value:void 0,done:!0}}};return m}entries(){const t=this,i=this.e;let a=this.b;const m={[Symbol.iterator](){return m},next(){if(t.e!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const S={value:[a.key,a.value],done:!1};return a=a.next,S}else return{value:void 0,done:!0}}};return m}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let i=this.b,a=this.size;for(;i&&a>t;)this.a.delete(i.key),i=i.next,a--;this.b=i,this.d=a,i&&(i.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const i=t.next,a=t.previous;if(!i||!a)throw new Error("Invalid list");i.previous=a,a.next=i}t.next=void 0,t.previous=void 0,this.e++}j(t,i){if(!this.b||!this.c)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(t===this.b)return;const a=t.next,m=t.previous;t===this.c?(m.next=void 0,this.c=m):(a.previous=m,m.next=a),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(i===2){if(t===this.c)return;const a=t.next,m=t.previous;t===this.b?(a.previous=void 0,this.b=a):(a.previous=m,m.next=a),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((i,a)=>{t.push([a,i])}),t}fromJSON(t){this.clear();for(const[i,a]of t)this.set(i,a)}}e.$pi=c;class y extends c{constructor(t,i=1){super(),this.k=t,this.l=Math.min(Math.max(0,i),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,i=2){return super.get(t,i)}peek(t){return super.get(t,0)}set(t,i){return super.set(t,i,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$qi=y;class b{constructor(){this.a=new Map}add(t){return this.a.set(t,(this.a.get(t)||0)+1),this}delete(t){let i=this.a.get(t)||0;return i===0?!1:(i--,i===0?this.a.delete(t):this.a.set(t,i),!0)}has(t){return this.a.has(t)}}e.$ri=b}),function($e,e){typeof define=="function"&&define.amd?define(Ae[116],Fe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(De,ye){for(var Se=0;Se<ye.length;Se++){var oe=ye[Se];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(De,oe.key,oe)}}function w(De,ye,Se){return ye&&e(De.prototype,ye),Se&&e(De,Se),Object.defineProperty(De,"prototype",{writable:!1}),De}function T(De,ye){if(De){if(typeof De=="string")return C(De,ye);var Se=Object.prototype.toString.call(De).slice(8,-1);if(Se==="Object"&&De.constructor&&(Se=De.constructor.name),Se==="Map"||Se==="Set")return Array.from(De);if(Se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Se))return C(De,ye)}}function C(De,ye){(ye==null||ye>De.length)&&(ye=De.length);for(var Se=0,oe=new Array(ye);Se<ye;Se++)oe[Se]=De[Se];return oe}function M(De,ye){var Se=typeof Symbol<"u"&&De[Symbol.iterator]||De["@@iterator"];if(Se)return(Se=Se.call(De)).next.bind(Se);if(Array.isArray(De)||(Se=T(De))||ye&&De&&typeof De.length=="number"){Se&&(De=Se);var oe=0;return function(){return oe>=De.length?{done:!0}:{done:!1,value:De[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function P(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=P();function g(De){$e.defaults=De}var D=/[&<>"']/,p=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(ye){return c[ye]};function b(De,ye){if(ye){if(D.test(De))return De.replace(p,y)}else if(A.test(De))return De.replace(E,y);return De}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(De){return De.replace(o,function(ye,Se){return Se=Se.toLowerCase(),Se==="colon"?":":Se.charAt(0)==="#"?Se.charAt(1)==="x"?String.fromCharCode(parseInt(Se.substring(2),16)):String.fromCharCode(+Se.substring(1)):""})}var i=/(^|[^\[])\^/g;function a(De,ye){De=typeof De=="string"?De:De.source,ye=ye||"";var Se={replace:function(de,ee){return ee=ee.source||ee,ee=ee.replace(i,"$1"),De=De.replace(de,ee),Se},getRegex:function(){return new RegExp(De,ye)}};return Se}var m=/[^\w:]/g,S=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function I(De,ye,Se){if(De){var oe;try{oe=decodeURIComponent(t(Se)).replace(m,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}ye&&!S.test(Se)&&(Se=$(ye,Se));try{Se=encodeURI(Se).replace(/%25/g,"%")}catch{return null}return Se}var r={},h=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function $(De,ye){r[" "+De]||(h.test(De)?r[" "+De]=De+"/":r[" "+De]=v(De,"/",!0)),De=r[" "+De];var Se=De.indexOf(":")===-1;return ye.substring(0,2)==="//"?Se?ye:De.replace(n,"$1")+ye:ye.charAt(0)==="/"?Se?ye:De.replace(s,"$1")+ye:De+ye}var k={exec:function(){}};function l(De){for(var ye=1,Se,oe;ye<arguments.length;ye++){Se=arguments[ye];for(oe in Se)Object.prototype.hasOwnProperty.call(Se,oe)&&(De[oe]=Se[oe])}return De}function f(De,ye){var Se=De.replace(/\|/g,function(ee,ie,le){for(var F=!1,V=ie;--V>=0&&le[V]==="\\";)F=!F;return F?"|":" |"}),oe=Se.split(/ \|/),de=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>ye)oe.splice(ye);else for(;oe.length<ye;)oe.push("");for(;de<oe.length;de++)oe[de]=oe[de].trim().replace(/\\\|/g,"|");return oe}function v(De,ye,Se){var oe=De.length;if(oe===0)return"";for(var de=0;de<oe;){var ee=De.charAt(oe-de-1);if(ee===ye&&!Se)de++;else if(ee!==ye&&Se)de++;else break}return De.slice(0,oe-de)}function u(De,ye){if(De.indexOf(ye[1])===-1)return-1;for(var Se=De.length,oe=0,de=0;de<Se;de++)if(De[de]==="\\")de++;else if(De[de]===ye[0])oe++;else if(De[de]===ye[1]&&(oe--,oe<0))return de;return-1}function d(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(De,ye){if(ye<1)return"";for(var Se="";ye>1;)ye&1&&(Se+=De),ye>>=1,De+=De;return Se+De}function W(De,ye,Se,oe){var de=ye.href,ee=ye.title?b(ye.title):null,ie=De[1].replace(/\\([\[\]])/g,"$1");if(De[0].charAt(0)!=="!"){oe.state.inLink=!0;var le={type:"link",raw:Se,href:de,title:ee,text:ie,tokens:oe.inlineTokens(ie)};return oe.state.inLink=!1,le}return{type:"image",raw:Se,href:de,title:ee,text:b(ie)}}function B(De,ye){var Se=De.match(/^(\s+)(?:```)/);if(Se===null)return ye;var oe=Se[1];return ye.split(`
`).map(function(de){var ee=de.match(/^\s+/);if(ee===null)return de;var ie=ee[0];return ie.length>=oe.length?de.slice(oe.length):de}).join(`
`)}var q=function(){function De(Se){this.options=Se||$e.defaults}var ye=De.prototype;return ye.space=function(oe){var de=this.rules.block.newline.exec(oe);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},ye.code=function(oe){var de=this.rules.block.code.exec(oe);if(de){var ee=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:v(ee,`
`)}}},ye.fences=function(oe){var de=this.rules.block.fences.exec(oe);if(de){var ee=de[0],ie=B(ee,de[3]||"");return{type:"code",raw:ee,lang:de[2]?de[2].trim():de[2],text:ie}}},ye.heading=function(oe){var de=this.rules.block.heading.exec(oe);if(de){var ee=de[2].trim();if(/#$/.test(ee)){var ie=v(ee,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(ee=ie.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:ee,tokens:this.lexer.inline(ee)}}},ye.hr=function(oe){var de=this.rules.block.hr.exec(oe);if(de)return{type:"hr",raw:de[0]}},ye.blockquote=function(oe){var de=this.rules.block.blockquote.exec(oe);if(de){var ee=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},ye.list=function(oe){var de=this.rules.block.list.exec(oe);if(de){var ee,ie,le,F,V,J,K,ae,G,ue,me,Ne,Be=de[1].trim(),Ye=Be.length>1,Ke={type:"list",raw:"",ordered:Ye,start:Ye?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Ye?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Ye?Be:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(Ne=!1,!(!(de=Xe.exec(oe))||this.rules.block.hr.test(oe)));){if(ee=de[0],oe=oe.substring(ee.length),ae=de[2].split(`
`,1)[0],G=oe.split(`
`,1)[0],this.options.pedantic?(F=2,me=ae.trimLeft()):(F=de[2].search(/[^ ]/),F=F>4?1:F,me=ae.slice(F),F+=de[1].length),J=!1,!ae&&/^ *$/.test(G)&&(ee+=G+`
`,oe=oe.substring(G.length+1),Ne=!0),!Ne)for(var Ge=new RegExp("^ {0,"+Math.min(3,F-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ct=new RegExp("^ {0,"+Math.min(3,F-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),xe=new RegExp("^ {0,"+Math.min(3,F-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,F-1)+"}#");oe&&(ue=oe.split(`
`,1)[0],ae=ue,this.options.pedantic&&(ae=ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(xe.test(ae)||tt.test(ae)||Ge.test(ae)||ct.test(oe)));){if(ae.search(/[^ ]/)>=F||!ae.trim())me+=`
`+ae.slice(F);else if(!J)me+=`
`+ae;else break;!J&&!ae.trim()&&(J=!0),ee+=ue+`
`,oe=oe.substring(ue.length+1)}Ke.loose||(K?Ke.loose=!0:/\n *\n *$/.test(ee)&&(K=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(me),ie&&(le=ie[0]!=="[ ] ",me=me.replace(/^\[[ xX]\] +/,""))),Ke.items.push({type:"list_item",raw:ee,task:!!ie,checked:le,loose:!1,text:me}),Ke.raw+=ee}Ke.items[Ke.items.length-1].raw=ee.trimRight(),Ke.items[Ke.items.length-1].text=me.trimRight(),Ke.raw=Ke.raw.trimRight();var Oe=Ke.items.length;for(V=0;V<Oe;V++){this.lexer.state.top=!1,Ke.items[V].tokens=this.lexer.blockTokens(Ke.items[V].text,[]);var nt=Ke.items[V].tokens.filter(function(Y){return Y.type==="space"}),x=nt.every(function(Y){for(var ge=Y.raw.split(""),je=0,Me=M(ge),Ze;!(Ze=Me()).done;){var et=Ze.value;if(et===`
`&&(je+=1),je>1)return!0}return!1});!Ke.loose&&nt.length&&x&&(Ke.loose=!0,Ke.items[V].loose=!0)}return Ke}},ye.html=function(oe){var de=this.rules.block.html.exec(oe);if(de){var ee={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var ie=this.options.sanitizer?this.options.sanitizer(de[0]):b(de[0]);ee.type="paragraph",ee.text=ie,ee.tokens=this.lexer.inline(ie)}return ee}},ye.def=function(oe){var de=this.rules.block.def.exec(oe);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var ee=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:de[0],href:de[2],title:de[3]}}},ye.table=function(oe){var de=this.rules.block.table.exec(oe);if(de){var ee={type:"table",header:f(de[1]).map(function(K){return{text:K}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=de[0];var ie=ee.align.length,le,F,V,J;for(le=0;le<ie;le++)/^ *-+: *$/.test(ee.align[le])?ee.align[le]="right":/^ *:-+: *$/.test(ee.align[le])?ee.align[le]="center":/^ *:-+ *$/.test(ee.align[le])?ee.align[le]="left":ee.align[le]=null;for(ie=ee.rows.length,le=0;le<ie;le++)ee.rows[le]=f(ee.rows[le],ee.header.length).map(function(K){return{text:K}});for(ie=ee.header.length,F=0;F<ie;F++)ee.header[F].tokens=this.lexer.inline(ee.header[F].text);for(ie=ee.rows.length,F=0;F<ie;F++)for(J=ee.rows[F],V=0;V<J.length;V++)J[V].tokens=this.lexer.inline(J[V].text);return ee}}},ye.lheading=function(oe){var de=this.rules.block.lheading.exec(oe);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},ye.paragraph=function(oe){var de=this.rules.block.paragraph.exec(oe);if(de){var ee=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:ee,tokens:this.lexer.inline(ee)}}},ye.text=function(oe){var de=this.rules.block.text.exec(oe);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},ye.escape=function(oe){var de=this.rules.inline.escape.exec(oe);if(de)return{type:"escape",raw:de[0],text:b(de[1])}},ye.tag=function(oe){var de=this.rules.inline.tag.exec(oe);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):b(de[0]):de[0]}},ye.link=function(oe){var de=this.rules.inline.link.exec(oe);if(de){var ee=de[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var ie=v(ee.slice(0,-1),"\\");if((ee.length-ie.length)%2===0)return}else{var le=u(de[2],"()");if(le>-1){var F=de[0].indexOf("!")===0?5:4,V=F+de[1].length+le;de[2]=de[2].substring(0,le),de[0]=de[0].substring(0,V).trim(),de[3]=""}}var J=de[2],K="";if(this.options.pedantic){var ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J);ae&&(J=ae[1],K=ae[3])}else K=de[3]?de[3].slice(1,-1):"";return J=J.trim(),/^</.test(J)&&(this.options.pedantic&&!/>$/.test(ee)?J=J.slice(1):J=J.slice(1,-1)),W(de,{href:J&&J.replace(this.rules.inline._escapes,"$1"),title:K&&K.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ye.reflink=function(oe,de){var ee;if((ee=this.rules.inline.reflink.exec(oe))||(ee=this.rules.inline.nolink.exec(oe))){var ie=(ee[2]||ee[1]).replace(/\s+/g," ");if(ie=de[ie.toLowerCase()],!ie||!ie.href){var le=ee[0].charAt(0);return{type:"text",raw:le,text:le}}return W(ee,ie,ee[0],this.lexer)}},ye.emStrong=function(oe,de,ee){ee===void 0&&(ee="");var ie=this.rules.inline.emStrong.lDelim.exec(oe);if(ie&&!(ie[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var le=ie[1]||ie[2]||"";if(!le||le&&(ee===""||this.rules.inline.punctuation.exec(ee))){var F=ie[0].length-1,V,J,K=F,ae=0,G=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(G.lastIndex=0,de=de.slice(-1*oe.length+F);(ie=G.exec(de))!=null;)if(V=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!V){if(J=V.length,ie[3]||ie[4]){K+=J;continue}else if((ie[5]||ie[6])&&F%3&&!((F+J)%3)){ae+=J;continue}if(K-=J,!(K>0)){if(J=Math.min(J,J+K+ae),Math.min(F,J)%2){var ue=oe.slice(1,F+ie.index+J);return{type:"em",raw:oe.slice(0,F+ie.index+J+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}var me=oe.slice(2,F+ie.index+J-1);return{type:"strong",raw:oe.slice(0,F+ie.index+J+1),text:me,tokens:this.lexer.inlineTokens(me)}}}}}},ye.codespan=function(oe){var de=this.rules.inline.code.exec(oe);if(de){var ee=de[2].replace(/\n/g," "),ie=/[^ ]/.test(ee),le=/^ /.test(ee)&&/ $/.test(ee);return ie&&le&&(ee=ee.substring(1,ee.length-1)),ee=b(ee,!0),{type:"codespan",raw:de[0],text:ee}}},ye.br=function(oe){var de=this.rules.inline.br.exec(oe);if(de)return{type:"br",raw:de[0]}},ye.del=function(oe){var de=this.rules.inline.del.exec(oe);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},ye.autolink=function(oe,de){var ee=this.rules.inline.autolink.exec(oe);if(ee){var ie,le;return ee[2]==="@"?(ie=b(this.options.mangle?de(ee[1]):ee[1]),le="mailto:"+ie):(ie=b(ee[1]),le=ie),{type:"link",raw:ee[0],text:ie,href:le,tokens:[{type:"text",raw:ie,text:ie}]}}},ye.url=function(oe,de){var ee;if(ee=this.rules.inline.url.exec(oe)){var ie,le;if(ee[2]==="@")ie=b(this.options.mangle?de(ee[0]):ee[0]),le="mailto:"+ie;else{var F;do F=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(F!==ee[0]);ie=b(ee[0]),ee[1]==="www."?le="http://"+ie:le=ie}return{type:"link",raw:ee[0],text:ie,href:le,tokens:[{type:"text",raw:ie,text:ie}]}}},ye.inlineText=function(oe,de){var ee=this.rules.inline.text.exec(oe);if(ee){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):b(ee[0]):ee[0]:ie=b(this.options.smartypants?de(ee[0]):ee[0]),{type:"text",raw:ee[0],text:ie}}},De}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:k,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=a(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=a(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=a(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=a(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=a(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=a(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=l({},U),U.gfm=l({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=a(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=a(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=l({},U.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:k,paragraph:a(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:k,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:k,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=a(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=a(U._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=a(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=a(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=a(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=a(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=a(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=a(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=a(N.reflink).replace("label",N._label).replace("ref",U._label).getRegex(),N.nolink=a(N.nolink).replace("ref",U._label).getRegex(),N.reflinkSearch=a(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=l({},N),N.pedantic=l({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=l({},N.normal,{escape:a(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=a(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=l({},N.gfm,{br:a(N.br).replace("{2,}","*").getRegex(),text:a(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ce(De){var ye="",Se,oe,de=De.length;for(Se=0;Se<de;Se++)oe=De.charCodeAt(Se),Math.random()>.5&&(oe="x"+oe.toString(16)),ye+="&#"+oe+";";return ye}var X=function(){function De(Se){this.tokens=[],this.tokens.links=Object.create(null),this.options=Se||$e.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:U.normal,inline:N.normal};this.options.pedantic?(oe.block=U.pedantic,oe.inline=N.pedantic):this.options.gfm&&(oe.block=U.gfm,this.options.breaks?oe.inline=N.breaks:oe.inline=N.gfm),this.tokenizer.rules=oe}De.lex=function(oe,de){var ee=new De(de);return ee.lex(oe)},De.lexInline=function(oe,de){var ee=new De(de);return ee.inlineTokens(oe)};var ye=De.prototype;return ye.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ye.blockTokens=function(oe,de){var ee=this;de===void 0&&(de=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(K,ae,G){return ae+"    ".repeat(G.length)});for(var ie,le,F,V;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(K){return(ie=K.call({lexer:ee},oe,de))?(oe=oe.substring(ie.raw.length),de.push(ie),!0):!1}))){if(ie=this.tokenizer.space(oe)){oe=oe.substring(ie.raw.length),ie.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(ie);continue}if(ie=this.tokenizer.code(oe)){oe=oe.substring(ie.raw.length),le=de[de.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+ie.raw,le.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=le.text):de.push(ie);continue}if(ie=this.tokenizer.fences(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.heading(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.hr(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.blockquote(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.list(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.html(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.def(oe)){oe=oe.substring(ie.raw.length),le=de[de.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+ie.raw,le.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=le.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.lheading(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(F=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var K=1/0,ae=oe.slice(1),G=void 0;ee.options.extensions.startBlock.forEach(function(ue){G=ue.call({lexer:this},ae),typeof G=="number"&&G>=0&&(K=Math.min(K,G))}),K<1/0&&K>=0&&(F=oe.substring(0,K+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(F))){le=de[de.length-1],V&&le.type==="paragraph"?(le.raw+=`
`+ie.raw,le.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):de.push(ie),V=F.length!==oe.length,oe=oe.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(oe)){oe=oe.substring(ie.raw.length),le=de[de.length-1],le&&le.type==="text"?(le.raw+=`
`+ie.raw,le.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):de.push(ie);continue}if(oe){var J="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return this.state.top=!0,de},ye.inline=function(oe,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:oe,tokens:de}),de},ye.inlineTokens=function(oe,de){var ee=this;de===void 0&&(de=[]);var ie,le,F,V=oe,J,K,ae;if(this.tokens.links){var G=Object.keys(this.tokens.links);if(G.length>0)for(;(J=this.tokenizer.rules.inline.reflinkSearch.exec(V))!=null;)G.includes(J[0].slice(J[0].lastIndexOf("[")+1,-1))&&(V=V.slice(0,J.index)+"["+R("a",J[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(J=this.tokenizer.rules.inline.blockSkip.exec(V))!=null;)V=V.slice(0,J.index)+"["+R("a",J[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(J=this.tokenizer.rules.inline.escapedEmSt.exec(V))!=null;)V=V.slice(0,J.index)+"++"+V.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(K||(ae=""),K=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(me){return(ie=me.call({lexer:ee},oe,de))?(oe=oe.substring(ie.raw.length),de.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.tag(oe)){oe=oe.substring(ie.raw.length),le=de[de.length-1],le&&ie.type==="text"&&le.type==="text"?(le.raw+=ie.raw,le.text+=ie.text):de.push(ie);continue}if(ie=this.tokenizer.link(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ie.raw.length),le=de[de.length-1],le&&ie.type==="text"&&le.type==="text"?(le.raw+=ie.raw,le.text+=ie.text):de.push(ie);continue}if(ie=this.tokenizer.emStrong(oe,V,ae)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.codespan(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.br(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.del(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.autolink(oe,ce)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(oe,ce))){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(F=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var me=1/0,Ne=oe.slice(1),Be=void 0;ee.options.extensions.startInline.forEach(function(Ye){Be=Ye.call({lexer:this},Ne),typeof Be=="number"&&Be>=0&&(me=Math.min(me,Be))}),me<1/0&&me>=0&&(F=oe.substring(0,me+1))}(),ie=this.tokenizer.inlineText(F,O)){oe=oe.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(ae=ie.raw.slice(-1)),K=!0,le=de[de.length-1],le&&le.type==="text"?(le.raw+=ie.raw,le.text+=ie.text):de.push(ie);continue}if(oe){var ue="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return de},w(De,null,[{key:"rules",get:function(){return{block:U,inline:N}}}]),De}(),be=function(){function De(Se){this.options=Se||$e.defaults}var ye=De.prototype;return ye.code=function(oe,de,ee){var ie=(de||"").match(/\S*/)[0];if(this.options.highlight){var le=this.options.highlight(oe,ie);le!=null&&le!==oe&&(ee=!0,oe=le)}return oe=oe.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+b(ie,!0)+'">'+(ee?oe:b(oe,!0))+`</code></pre>
`:"<pre><code>"+(ee?oe:b(oe,!0))+`</code></pre>
`},ye.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},ye.html=function(oe){return oe},ye.heading=function(oe,de,ee,ie){if(this.options.headerIds){var le=this.options.headerPrefix+ie.slug(ee);return"<h"+de+' id="'+le+'">'+oe+"</h"+de+`>
`}return"<h"+de+">"+oe+"</h"+de+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(oe,de,ee){var ie=de?"ol":"ul",le=de&&ee!==1?' start="'+ee+'"':"";return"<"+ie+le+`>
`+oe+"</"+ie+`>
`},ye.listitem=function(oe){return"<li>"+oe+`</li>
`},ye.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(oe){return"<p>"+oe+`</p>
`},ye.table=function(oe,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+de+`</table>
`},ye.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},ye.tablecell=function(oe,de){var ee=de.header?"th":"td",ie=de.align?"<"+ee+' align="'+de.align+'">':"<"+ee+">";return ie+oe+("</"+ee+`>
`)},ye.strong=function(oe){return"<strong>"+oe+"</strong>"},ye.em=function(oe){return"<em>"+oe+"</em>"},ye.codespan=function(oe){return"<code>"+oe+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(oe){return"<del>"+oe+"</del>"},ye.link=function(oe,de,ee){if(oe=I(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var ie='<a href="'+b(oe)+'"';return de&&(ie+=' title="'+de+'"'),ie+=">"+ee+"</a>",ie},ye.image=function(oe,de,ee){if(oe=I(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var ie='<img src="'+oe+'" alt="'+ee+'"';return de&&(ie+=' title="'+de+'"'),ie+=this.options.xhtml?"/>":">",ie},ye.text=function(oe){return oe},De}(),Ee=function(){function De(){}var ye=De.prototype;return ye.strong=function(oe){return oe},ye.em=function(oe){return oe},ye.codespan=function(oe){return oe},ye.del=function(oe){return oe},ye.html=function(oe){return oe},ye.text=function(oe){return oe},ye.link=function(oe,de,ee){return""+ee},ye.image=function(oe,de,ee){return""+ee},ye.br=function(){return""},De}(),Re=function(){function De(){this.seen={}}var ye=De.prototype;return ye.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(oe,de){var ee=oe,ie=0;if(this.seen.hasOwnProperty(ee)){ie=this.seen[oe];do ie++,ee=oe+"-"+ie;while(this.seen.hasOwnProperty(ee))}return de||(this.seen[oe]=ie,this.seen[ee]=0),ee},ye.slug=function(oe,de){de===void 0&&(de={});var ee=this.serialize(oe);return this.getNextSafeSlug(ee,de.dryrun)},De}(),Z=function(){function De(Se){this.options=Se||$e.defaults,this.options.renderer=this.options.renderer||new be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ee,this.slugger=new Re}De.parse=function(oe,de){var ee=new De(de);return ee.parse(oe)},De.parseInline=function(oe,de){var ee=new De(de);return ee.parseInline(oe)};var ye=De.prototype;return ye.parse=function(oe,de){de===void 0&&(de=!0);var ee="",ie,le,F,V,J,K,ae,G,ue,me,Ne,Be,Ye,Ke,Xe,Ge,ct,xe,tt,Oe=oe.length;for(ie=0;ie<Oe;ie++){if(me=oe[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(tt=this.options.extensions.renderers[me.type].call({parser:this},me),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(me.type))){ee+=tt||"";continue}switch(me.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(me.tokens),me.depth,t(this.parseInline(me.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(me.text,me.lang,me.escaped);continue}case"table":{for(G="",ae="",V=me.header.length,le=0;le<V;le++)ae+=this.renderer.tablecell(this.parseInline(me.header[le].tokens),{header:!0,align:me.align[le]});for(G+=this.renderer.tablerow(ae),ue="",V=me.rows.length,le=0;le<V;le++){for(K=me.rows[le],ae="",J=K.length,F=0;F<J;F++)ae+=this.renderer.tablecell(this.parseInline(K[F].tokens),{header:!1,align:me.align[F]});ue+=this.renderer.tablerow(ae)}ee+=this.renderer.table(G,ue);continue}case"blockquote":{ue=this.parse(me.tokens),ee+=this.renderer.blockquote(ue);continue}case"list":{for(Ne=me.ordered,Be=me.start,Ye=me.loose,V=me.items.length,ue="",le=0;le<V;le++)Xe=me.items[le],Ge=Xe.checked,ct=Xe.task,Ke="",Xe.task&&(xe=this.renderer.checkbox(Ge),Ye?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=xe+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=xe+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:xe}):Ke+=xe),Ke+=this.parse(Xe.tokens,Ye),ue+=this.renderer.listitem(Ke,ct,Ge);ee+=this.renderer.list(ue,Ne,Be);continue}case"html":{ee+=this.renderer.html(me.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(me.tokens));continue}case"text":{for(ue=me.tokens?this.parseInline(me.tokens):me.text;ie+1<Oe&&oe[ie+1].type==="text";)me=oe[++ie],ue+=`
`+(me.tokens?this.parseInline(me.tokens):me.text);ee+=de?this.renderer.paragraph(ue):ue;continue}default:{var nt='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(nt);return}else throw new Error(nt)}}}return ee},ye.parseInline=function(oe,de){de=de||this.renderer;var ee="",ie,le,F,V=oe.length;for(ie=0;ie<V;ie++){if(le=oe[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(F=this.options.extensions.renderers[le.type].call({parser:this},le),F!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(le.type))){ee+=F||"";continue}switch(le.type){case"escape":{ee+=de.text(le.text);break}case"html":{ee+=de.html(le.text);break}case"link":{ee+=de.link(le.href,le.title,this.parseInline(le.tokens,de));break}case"image":{ee+=de.image(le.href,le.title,le.text);break}case"strong":{ee+=de.strong(this.parseInline(le.tokens,de));break}case"em":{ee+=de.em(this.parseInline(le.tokens,de));break}case"codespan":{ee+=de.codespan(le.text);break}case"br":{ee+=de.br();break}case"del":{ee+=de.del(this.parseInline(le.tokens,de));break}case"text":{ee+=de.text(le.text);break}default:{var J='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return ee},De}();function he(De,ye,Se){if(typeof De>"u"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof ye=="function"&&(Se=ye,ye=null),ye=l({},he.defaults,ye||{}),d(ye),Se){var oe=ye.highlight,de;try{de=X.lex(De,ye)}catch(V){return Se(V)}var ee=function(J){var K;if(!J)try{ye.walkTokens&&he.walkTokens(de,ye.walkTokens),K=Z.parse(de,ye)}catch(ae){J=ae}return ye.highlight=oe,J?Se(J):Se(null,K)};if(!oe||oe.length<3||(delete ye.highlight,!de.length))return ee();var ie=0;he.walkTokens(de,function(V){V.type==="code"&&(ie++,setTimeout(function(){oe(V.text,V.lang,function(J,K){if(J)return ee(J);K!=null&&K!==V.text&&(V.text=K,V.escaped=!0),ie--,ie===0&&ee()})},0))}),ie===0&&ee();return}function le(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+b(V.message+"",!0)+"</pre>";throw V}try{var F=X.lex(De,ye);if(ye.walkTokens){if(ye.async)return Promise.all(he.walkTokens(F,ye.walkTokens)).then(function(){return Z.parse(F,ye)}).catch(le);he.walkTokens(F,ye.walkTokens)}return Z.parse(F,ye)}catch(V){le(V)}}he.options=he.setOptions=function(De){return l(he.defaults,De),g(he.defaults),he},he.getDefaults=P,he.defaults=$e.defaults,he.use=function(){for(var De=arguments.length,ye=new Array(De),Se=0;Se<De;Se++)ye[Se]=arguments[Se];var oe=l.apply(void 0,[{}].concat(ye)),de=he.defaults.extensions||{renderers:{},childTokens:{}},ee;ye.forEach(function(ie){if(ie.extensions&&(ee=!0,ie.extensions.forEach(function(F){if(!F.name)throw new Error("extension name required");if(F.renderer){var V=de.renderers?de.renderers[F.name]:null;V?de.renderers[F.name]=function(){for(var J=arguments.length,K=new Array(J),ae=0;ae<J;ae++)K[ae]=arguments[ae];var G=F.renderer.apply(this,K);return G===!1&&(G=V.apply(this,K)),G}:de.renderers[F.name]=F.renderer}if(F.tokenizer){if(!F.level||F.level!=="block"&&F.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[F.level]?de[F.level].unshift(F.tokenizer):de[F.level]=[F.tokenizer],F.start&&(F.level==="block"?de.startBlock?de.startBlock.push(F.start):de.startBlock=[F.start]:F.level==="inline"&&(de.startInline?de.startInline.push(F.start):de.startInline=[F.start]))}F.childTokens&&(de.childTokens[F.name]=F.childTokens)})),ie.renderer&&function(){var F=he.defaults.renderer||new be,V=function(ae){var G=F[ae];F[ae]=function(){for(var ue=arguments.length,me=new Array(ue),Ne=0;Ne<ue;Ne++)me[Ne]=arguments[Ne];var Be=ie.renderer[ae].apply(F,me);return Be===!1&&(Be=G.apply(F,me)),Be}};for(var J in ie.renderer)V(J);oe.renderer=F}(),ie.tokenizer&&function(){var F=he.defaults.tokenizer||new q,V=function(ae){var G=F[ae];F[ae]=function(){for(var ue=arguments.length,me=new Array(ue),Ne=0;Ne<ue;Ne++)me[Ne]=arguments[Ne];var Be=ie.tokenizer[ae].apply(F,me);return Be===!1&&(Be=G.apply(F,me)),Be}};for(var J in ie.tokenizer)V(J);oe.tokenizer=F}(),ie.walkTokens){var le=he.defaults.walkTokens;oe.walkTokens=function(F){var V=[];return V.push(ie.walkTokens.call(this,F)),le&&(V=V.concat(le.call(this,F))),V}}ee&&(oe.extensions=de),he.setOptions(oe)})},he.walkTokens=function(De,ye){for(var Se=[],oe=function(){var le=ee.value;switch(Se=Se.concat(ye.call(he,le)),le.type){case"table":{for(var F=M(le.header),V;!(V=F()).done;){var J=V.value;Se=Se.concat(he.walkTokens(J.tokens,ye))}for(var K=M(le.rows),ae;!(ae=K()).done;)for(var G=ae.value,ue=M(G),me;!(me=ue()).done;){var Ne=me.value;Se=Se.concat(he.walkTokens(Ne.tokens,ye))}break}case"list":{Se=Se.concat(he.walkTokens(le.items,ye));break}default:he.defaults.extensions&&he.defaults.extensions.childTokens&&he.defaults.extensions.childTokens[le.type]?he.defaults.extensions.childTokens[le.type].forEach(function(Be){Se=Se.concat(he.walkTokens(le[Be],ye))}):le.tokens&&(Se=Se.concat(he.walkTokens(le.tokens,ye)))}},de=M(De),ee;!(ee=de()).done;)oe();return Se},he.parseInline=function(De,ye){if(typeof De>"u"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");ye=l({},he.defaults,ye||{}),d(ye);try{var Se=X.lexInline(De,ye);return ye.walkTokens&&he.walkTokens(Se,ye.walkTokens),Z.parseInline(Se,ye)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+b(oe.message+"",!0)+"</pre>";throw oe}},he.Parser=Z,he.parser=Z.parse,he.Renderer=be,he.TextRenderer=Ee,he.Lexer=X,he.lexer=X.lex,he.Tokenizer=q,he.Slugger=Re,he.parse=he;var Ce=he.options,H=he.setOptions,ne=he.use,re=he.walkTokens,L=he.parseInline,_=he,pe=Z.parse,Ie=X.lex;$e.Lexer=X,$e.Parser=Z,$e.Renderer=be,$e.Slugger=Re,$e.TextRenderer=Ee,$e.Tokenizer=q,$e.getDefaults=P,$e.lexer=Ie,$e.marked=he,$e.options=Ce,$e.parse=_,$e.parseInline=L,$e.parser=pe,$e.setOptions=H,$e.use=ne,$e.walkTokens=re,Object.defineProperty($e,"__esModule",{value:!0})}),define(Ae[117],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=e.$vl=e.rot=e.$tl=void 0;function w(g,D,p){return Math.min(Math.max(g,D),p)}e.$tl=w;function T(g,D){return(D+g%D)%D}e.rot=T;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$vl=C;class M{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$wl=M;class P{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const p=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=p,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$xl=P}),function(){function $e(C){const M=[];typeof C=="number"&&M.push("code/timeOrigin",C);function P(D){M.push(D,Date.now())}function g(){const D=[];for(let p=0;p<M.length;p+=2)D.push({name:M[p],startTime:M[p+1]});return D}return{mark:P,getMarks:g}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const P of performance.getEntriesByType("mark"))M.push({name:P.name,startTime:Math.round(C+P.startTime)});return M}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function w(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=w(T))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var T in w)(typeof exports=="object"?exports:$e)[T]=w[T]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function w(T){if(e[T])return e[T].exports;var C=e[T]={i:T,l:!1,exports:{}};return $e[T].call(C.exports,C,C.exports,w),C.l=!0,C.exports}return w.m=$e,w.c=e,w.d=function(T,C,M){w.o(T,C)||Object.defineProperty(T,C,{enumerable:!0,get:M})},w.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},w.t=function(T,C){if(1&C&&(T=w(T)),8&C||4&C&&typeof T=="object"&&T&&T.__esModule)return T;var M=Object.create(null);if(w.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:T}),2&C&&typeof T!="string")for(var P in T)w.d(M,P,function(g){return T[g]}.bind(null,P));return M},w.n=function(T){var C=T&&T.__esModule?function(){return T.default}:function(){return T};return w.d(C,"a",C),C},w.o=function(T,C){return Object.prototype.hasOwnProperty.call(T,C)},w.p="",w(w.s=0)}([function($e,e,w){(function(T){var C;e=$e.exports=ne,C=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var G=Array.prototype.slice.call(arguments,0);G.unshift("SEMVER"),console.log.apply(console,G)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,g=e.re=[],D=e.src=[],p=0,A=p++;D[A]="0|[1-9]\\d*";var E=p++;D[E]="[0-9]+";var c=p++;D[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=p++;D[y]="("+D[A]+")\\.("+D[A]+")\\.("+D[A]+")";var b=p++;D[b]="("+D[E]+")\\.("+D[E]+")\\.("+D[E]+")";var o=p++;D[o]="(?:"+D[A]+"|"+D[c]+")";var t=p++;D[t]="(?:"+D[E]+"|"+D[c]+")";var i=p++;D[i]="(?:-("+D[o]+"(?:\\."+D[o]+")*))";var a=p++;D[a]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var m=p++;D[m]="[0-9A-Za-z-]+";var S=p++;D[S]="(?:\\+("+D[m]+"(?:\\."+D[m]+")*))";var I=p++,r="v?"+D[y]+D[i]+"?"+D[S]+"?";D[I]="^"+r+"$";var h="[v=\\s]*"+D[b]+D[a]+"?"+D[S]+"?",n=p++;D[n]="^"+h+"$";var s=p++;D[s]="((?:<|>)?=?)";var $=p++;D[$]=D[E]+"|x|X|\\*";var k=p++;D[k]=D[A]+"|x|X|\\*";var l=p++;D[l]="[v=\\s]*("+D[k]+")(?:\\.("+D[k]+")(?:\\.("+D[k]+")(?:"+D[i]+")?"+D[S]+"?)?)?";var f=p++;D[f]="[v=\\s]*("+D[$]+")(?:\\.("+D[$]+")(?:\\.("+D[$]+")(?:"+D[a]+")?"+D[S]+"?)?)?";var v=p++;D[v]="^"+D[s]+"\\s*"+D[l]+"$";var u=p++;D[u]="^"+D[s]+"\\s*"+D[f]+"$";var d=p++;D[d]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=p++;D[R]="(?:~>?)";var W=p++;D[W]="(\\s*)"+D[R]+"\\s+",g[W]=new RegExp(D[W],"g");var B=p++;D[B]="^"+D[R]+D[l]+"$";var q=p++;D[q]="^"+D[R]+D[f]+"$";var U=p++;D[U]="(?:\\^)";var N=p++;D[N]="(\\s*)"+D[U]+"\\s+",g[N]=new RegExp(D[N],"g");var O=p++;D[O]="^"+D[U]+D[l]+"$";var ce=p++;D[ce]="^"+D[U]+D[f]+"$";var X=p++;D[X]="^"+D[s]+"\\s*("+h+")$|^$";var be=p++;D[be]="^"+D[s]+"\\s*("+r+")$|^$";var Ee=p++;D[Ee]="(\\s*)"+D[s]+"\\s*("+h+"|"+D[l]+")",g[Ee]=new RegExp(D[Ee],"g");var Re=p++;D[Re]="^\\s*("+D[l]+")\\s+-\\s+("+D[l]+")\\s*$";var Z=p++;D[Z]="^\\s*("+D[f]+")\\s+-\\s+("+D[f]+")\\s*$";var he=p++;D[he]="(<|>)?=?\\s*\\*";for(var Ce=0;Ce<35;Ce++)C(Ce,D[Ce]),g[Ce]||(g[Ce]=new RegExp(D[Ce]));function H(G,ue){if(G instanceof ne)return G;if(typeof G!="string"||G.length>M||!(ue?g[n]:g[I]).test(G))return null;try{return new ne(G,ue)}catch{return null}}function ne(G,ue){if(G instanceof ne){if(G.loose===ue)return G;G=G.version}else if(typeof G!="string")throw new TypeError("Invalid Version: "+G);if(G.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ne))return new ne(G,ue);C("SemVer",G,ue),this.loose=ue;var me=G.trim().match(ue?g[n]:g[I]);if(!me)throw new TypeError("Invalid Version: "+G);if(this.raw=G,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Be=+Ne;if(Be>=0&&Be<P)return Be}return Ne}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=H,e.valid=function(G,ue){var me=H(G,ue);return me?me.version:null},e.clean=function(G,ue){var me=H(G.trim().replace(/^[=v]+/,""),ue);return me?me.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(G){return C("SemVer.compare",this.version,this.loose,G),G instanceof ne||(G=new ne(G,this.loose)),this.compareMain(G)||this.comparePre(G)},ne.prototype.compareMain=function(G){return G instanceof ne||(G=new ne(G,this.loose)),L(this.major,G.major)||L(this.minor,G.minor)||L(this.patch,G.patch)},ne.prototype.comparePre=function(G){if(G instanceof ne||(G=new ne(G,this.loose)),this.prerelease.length&&!G.prerelease.length)return-1;if(!this.prerelease.length&&G.prerelease.length)return 1;if(!this.prerelease.length&&!G.prerelease.length)return 0;var ue=0;do{var me=this.prerelease[ue],Ne=G.prerelease[ue];if(C("prerelease compare",ue,me,Ne),me===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(me===void 0)return-1;if(me!==Ne)return L(me,Ne)}while(++ue)},ne.prototype.inc=function(G,ue){switch(G){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+G)}return this.format(),this.raw=this.version,this},e.inc=function(G,ue,me,Ne){typeof me=="string"&&(Ne=me,me=void 0);try{return new ne(G,me).inc(ue,Ne).version}catch{return null}},e.diff=function(G,ue){if(De(G,ue))return null;var me=H(G),Ne=H(ue);if(me.prerelease.length||Ne.prerelease.length){for(var Be in me)if((Be==="major"||Be==="minor"||Be==="patch")&&me[Be]!==Ne[Be])return"pre"+Be;return"prerelease"}for(var Be in me)if((Be==="major"||Be==="minor"||Be==="patch")&&me[Be]!==Ne[Be])return Be},e.compareIdentifiers=L;var re=/^[0-9]+$/;function L(G,ue){var me=re.test(G),Ne=re.test(ue);return me&&Ne&&(G=+G,ue=+ue),me&&!Ne?-1:Ne&&!me?1:G<ue?-1:G>ue?1:0}function _(G,ue,me){return new ne(G,me).compare(new ne(ue,me))}function pe(G,ue,me){return _(G,ue,me)>0}function Ie(G,ue,me){return _(G,ue,me)<0}function De(G,ue,me){return _(G,ue,me)===0}function ye(G,ue,me){return _(G,ue,me)!==0}function Se(G,ue,me){return _(G,ue,me)>=0}function oe(G,ue,me){return _(G,ue,me)<=0}function de(G,ue,me,Ne){var Be;switch(ue){case"===":typeof G=="object"&&(G=G.version),typeof me=="object"&&(me=me.version),Be=G===me;break;case"!==":typeof G=="object"&&(G=G.version),typeof me=="object"&&(me=me.version),Be=G!==me;break;case"":case"=":case"==":Be=De(G,me,Ne);break;case"!=":Be=ye(G,me,Ne);break;case">":Be=pe(G,me,Ne);break;case">=":Be=Se(G,me,Ne);break;case"<":Be=Ie(G,me,Ne);break;case"<=":Be=oe(G,me,Ne);break;default:throw new TypeError("Invalid operator: "+ue)}return Be}function ee(G,ue){if(G instanceof ee){if(G.loose===ue)return G;G=G.value}if(!(this instanceof ee))return new ee(G,ue);C("comparator",G,ue),this.loose=ue,this.parse(G),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(G,ue){return L(ue,G)},e.major=function(G,ue){return new ne(G,ue).major},e.minor=function(G,ue){return new ne(G,ue).minor},e.patch=function(G,ue){return new ne(G,ue).patch},e.compare=_,e.compareLoose=function(G,ue){return _(G,ue,!0)},e.rcompare=function(G,ue,me){return _(ue,G,me)},e.sort=function(G,ue){return G.sort(function(me,Ne){return e.compare(me,Ne,ue)})},e.rsort=function(G,ue){return G.sort(function(me,Ne){return e.rcompare(me,Ne,ue)})},e.gt=pe,e.lt=Ie,e.eq=De,e.neq=ye,e.gte=Se,e.lte=oe,e.cmp=de,e.Comparator=ee;var ie={};function le(G,ue){if(G instanceof le)return G.loose===ue?G:new le(G.raw,ue);if(G instanceof ee)return new le(G.value,ue);if(!(this instanceof le))return new le(G,ue);if(this.loose=ue,this.raw=G,this.set=G.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+G);this.format()}function F(G){return!G||G.toLowerCase()==="x"||G==="*"}function V(G,ue,me,Ne,Be,Ye,Ke,Xe,Ge,ct,xe,tt,Oe){return((ue=F(me)?"":F(Ne)?">="+me+".0.0":F(Be)?">="+me+"."+Ne+".0":">="+ue)+" "+(Xe=F(Ge)?"":F(ct)?"<"+(+Ge+1)+".0.0":F(xe)?"<"+Ge+"."+(+ct+1)+".0":tt?"<="+Ge+"."+ct+"."+xe+"-"+tt:"<="+Xe)).trim()}function J(G,ue){for(var me=0;me<G.length;me++)if(!G[me].test(ue))return!1;if(ue.prerelease.length){for(me=0;me<G.length;me++)if(C(G[me].semver),G[me].semver!==ie&&G[me].semver.prerelease.length>0){var Ne=G[me].semver;if(Ne.major===ue.major&&Ne.minor===ue.minor&&Ne.patch===ue.patch)return!0}return!1}return!0}function K(G,ue,me){try{ue=new le(ue,me)}catch{return!1}return ue.test(G)}function ae(G,ue,me,Ne){var Be,Ye,Ke,Xe,Ge;switch(G=new ne(G,Ne),ue=new le(ue,Ne),me){case">":Be=pe,Ye=oe,Ke=Ie,Xe=">",Ge=">=";break;case"<":Be=Ie,Ye=Se,Ke=pe,Xe="<",Ge="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(K(G,ue,Ne))return!1;for(var ct=0;ct<ue.set.length;++ct){var xe=ue.set[ct],tt=null,Oe=null;if(xe.forEach(function(nt){nt.semver===ie&&(nt=new ee(">=0.0.0")),tt=tt||nt,Oe=Oe||nt,Be(nt.semver,tt.semver,Ne)?tt=nt:Ke(nt.semver,Oe.semver,Ne)&&(Oe=nt)}),tt.operator===Xe||tt.operator===Ge||(!Oe.operator||Oe.operator===Xe)&&Ye(G,Oe.semver)||Oe.operator===Ge&&Ke(G,Oe.semver))return!1}return!0}ee.prototype.parse=function(G){var ue=this.loose?g[X]:g[be],me=G.match(ue);if(!me)throw new TypeError("Invalid comparator: "+G);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new ne(me[2],this.loose):this.semver=ie},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(G){return C("Comparator.test",G,this.loose),this.semver===ie||(typeof G=="string"&&(G=new ne(G,this.loose)),de(G,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(G,ue){if(!(G instanceof ee))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new le(G.value,ue),K(this.value,me,ue);if(G.operator==="")return me=new le(this.value,ue),K(G.semver,me,ue);var Ne=!(this.operator!==">="&&this.operator!==">"||G.operator!==">="&&G.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||G.operator!=="<="&&G.operator!=="<"),Ye=this.semver.version===G.semver.version,Ke=!(this.operator!==">="&&this.operator!=="<="||G.operator!==">="&&G.operator!=="<="),Xe=de(this.semver,"<",G.semver,ue)&&(this.operator===">="||this.operator===">")&&(G.operator==="<="||G.operator==="<"),Ge=de(this.semver,">",G.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(G.operator===">="||G.operator===">");return Ne||Be||Ye&&Ke||Xe||Ge},e.Range=le,le.prototype.format=function(){return this.range=this.set.map(function(G){return G.join(" ").trim()}).join("||").trim(),this.range},le.prototype.toString=function(){return this.range},le.prototype.parseRange=function(G){var ue=this.loose;G=G.trim(),C("range",G,ue);var me=ue?g[Z]:g[Re];G=G.replace(me,V),C("hyphen replace",G),G=G.replace(g[Ee],"$1$2$3"),C("comparator trim",G,g[Ee]),G=(G=(G=G.replace(g[W],"$1~")).replace(g[N],"$1^")).split(/\s+/).join(" ");var Ne=ue?g[X]:g[be],Be=G.split(" ").map(function(Ye){return function(Ke,Xe){return C("comp",Ke),Ke=function(Ge,ct){return Ge.trim().split(/\s+/).map(function(xe){return function(tt,Oe){C("caret",tt,Oe);var nt=Oe?g[ce]:g[O];return tt.replace(nt,function(x,Y,ge,je,Me){var Ze;return C("caret",tt,x,Y,ge,je,Me),F(Y)?Ze="":F(ge)?Ze=">="+Y+".0.0 <"+(+Y+1)+".0.0":F(je)?Ze=Y==="0"?">="+Y+"."+ge+".0 <"+Y+"."+(+ge+1)+".0":">="+Y+"."+ge+".0 <"+(+Y+1)+".0.0":Me?(C("replaceCaret pr",Me),Me.charAt(0)!=="-"&&(Me="-"+Me),Ze=Y==="0"?ge==="0"?">="+Y+"."+ge+"."+je+Me+" <"+Y+"."+ge+"."+(+je+1):">="+Y+"."+ge+"."+je+Me+" <"+Y+"."+(+ge+1)+".0":">="+Y+"."+ge+"."+je+Me+" <"+(+Y+1)+".0.0"):(C("no pr"),Ze=Y==="0"?ge==="0"?">="+Y+"."+ge+"."+je+" <"+Y+"."+ge+"."+(+je+1):">="+Y+"."+ge+"."+je+" <"+Y+"."+(+ge+1)+".0":">="+Y+"."+ge+"."+je+" <"+(+Y+1)+".0.0"),C("caret return",Ze),Ze})}(xe,ct)}).join(" ")}(Ke,Xe),C("caret",Ke),Ke=function(Ge,ct){return Ge.trim().split(/\s+/).map(function(xe){return function(tt,Oe){var nt=Oe?g[q]:g[B];return tt.replace(nt,function(x,Y,ge,je,Me){var Ze;return C("tilde",tt,x,Y,ge,je,Me),F(Y)?Ze="":F(ge)?Ze=">="+Y+".0.0 <"+(+Y+1)+".0.0":F(je)?Ze=">="+Y+"."+ge+".0 <"+Y+"."+(+ge+1)+".0":Me?(C("replaceTilde pr",Me),Me.charAt(0)!=="-"&&(Me="-"+Me),Ze=">="+Y+"."+ge+"."+je+Me+" <"+Y+"."+(+ge+1)+".0"):Ze=">="+Y+"."+ge+"."+je+" <"+Y+"."+(+ge+1)+".0",C("tilde return",Ze),Ze})}(xe,ct)}).join(" ")}(Ke,Xe),C("tildes",Ke),Ke=function(Ge,ct){return C("replaceXRanges",Ge,ct),Ge.split(/\s+/).map(function(xe){return function(tt,Oe){tt=tt.trim();var nt=Oe?g[u]:g[v];return tt.replace(nt,function(x,Y,ge,je,Me,Ze){C("xRange",tt,x,Y,ge,je,Me,Ze);var et=F(ge),gt=et||F(je),wt=gt||F(Me);return Y==="="&&wt&&(Y=""),et?x=Y===">"||Y==="<"?"<0.0.0":"*":Y&&wt?(gt&&(je=0),wt&&(Me=0),Y===">"?(Y=">=",gt?(ge=+ge+1,je=0,Me=0):wt&&(je=+je+1,Me=0)):Y==="<="&&(Y="<",gt?ge=+ge+1:je=+je+1),x=Y+ge+"."+je+"."+Me):gt?x=">="+ge+".0.0 <"+(+ge+1)+".0.0":wt&&(x=">="+ge+"."+je+".0 <"+ge+"."+(+je+1)+".0"),C("xRange return",x),x})}(xe,ct)}).join(" ")}(Ke,Xe),C("xrange",Ke),Ke=function(Ge,ct){return C("replaceStars",Ge,ct),Ge.trim().replace(g[he],"")}(Ke,Xe),C("stars",Ke),Ke}(Ye,ue)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Ye){return!!Ye.match(Ne)})),Be=Be.map(function(Ye){return new ee(Ye,ue)})},le.prototype.intersects=function(G,ue){if(!(G instanceof le))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Ne){return G.set.some(function(Be){return Be.every(function(Ye){return Ne.intersects(Ye,ue)})})})})},e.toComparators=function(G,ue){return new le(G,ue).set.map(function(me){return me.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},le.prototype.test=function(G){if(!G)return!1;typeof G=="string"&&(G=new ne(G,this.loose));for(var ue=0;ue<this.set.length;ue++)if(J(this.set[ue],G))return!0;return!1},e.satisfies=K,e.maxSatisfying=function(G,ue,me){var Ne=null,Be=null;try{var Ye=new le(ue,me)}catch{return null}return G.forEach(function(Ke){Ye.test(Ke)&&(Ne&&Be.compare(Ke)!==-1||(Be=new ne(Ne=Ke,me)))}),Ne},e.minSatisfying=function(G,ue,me){var Ne=null,Be=null;try{var Ye=new le(ue,me)}catch{return null}return G.forEach(function(Ke){Ye.test(Ke)&&(Ne&&Be.compare(Ke)!==1||(Be=new ne(Ne=Ke,me)))}),Ne},e.validRange=function(G,ue){try{return new le(G,ue).range||"*"}catch{return null}},e.ltr=function(G,ue,me){return ae(G,ue,"<",me)},e.gtr=function(G,ue,me){return ae(G,ue,">",me)},e.outside=ae,e.prerelease=function(G,ue){var me=H(G,ue);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(G,ue,me){return G=new le(G,me),ue=new le(ue,me),G.intersects(ue)},e.coerce=function(G){if(G instanceof ne)return G;if(typeof G!="string")return null;var ue=G.match(g[d]);return ue==null?null:H((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,w(1))},function($e,e){var w,T,C=$e.exports={};function M(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function g(t){if(w===setTimeout)return setTimeout(t,0);if((w===M||!w)&&setTimeout)return w=setTimeout,setTimeout(t,0);try{return w(t,0)}catch{try{return w.call(null,t,0)}catch{return w.call(this,t,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:M}catch{w=M}try{T=typeof clearTimeout=="function"?clearTimeout:P}catch{T=P}})();var D,p=[],A=!1,E=-1;function c(){A&&D&&(A=!1,D.length?p=D.concat(p):E=-1,p.length&&y())}function y(){if(!A){var t=g(c);A=!0;for(var i=p.length;i;){for(D=p,p=[];++E<i;)D&&D[E].run();E=-1,i=p.length}D=null,A=!1,function(a){if(T===clearTimeout)return clearTimeout(a);if((T===P||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(a);try{T(a)}catch{try{return T.call(null,a)}catch{return T.call(this,a)}}}(t)}}function b(t,i){this.fun=t,this.array=i}function o(){}C.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)i[a-1]=arguments[a];p.push(new b(t,i)),p.length!==1||A||g(y)},b.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=o,C.addListener=o,C.once=o,C.off=o,C.removeListener=o,C.removeAllListeners=o,C.emit=o,C.prependListener=o,C.prependOnceListener=o,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[118],Fe([1,0,11,6]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=void 0;function C(S){const I=S;return I?typeof I.read=="function":!1}e.$ub=C;function M(S){const I=S;return I?[I.on,I.pause,I.resume,I.destroy].every(r=>typeof r=="function"):!1}e.$vb=M;function P(S){const I=S;return I?M(I.stream)&&Array.isArray(I.buffer)&&typeof I.ended=="boolean":!1}e.$wb=P;function g(S,I){return new D(S,I)}e.$xb=g;class D{constructor(I,r){this.e=I,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(I){if(!this.a.destroyed){if(this.a.flowing)this.g(I);else if(this.b.data.push(I),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(I){this.a.destroyed||(this.a.flowing?this.h(I):this.b.error.push(I))}end(I){this.a.destroyed||(typeof I<"u"&&this.write(I),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(I){this.c.data.slice(0).forEach(r=>r(I))}h(I){this.c.error.length===0?(0,w.$Y)(I):this.c.error.slice(0).forEach(r=>r(I))}i(){this.c.end.slice(0).forEach(I=>I())}on(I,r){if(!this.a.destroyed)switch(I){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(I,r){if(this.a.destroyed)return;let h;switch(I){case"data":h=this.c.data;break;case"end":h=this.c.end;break;case"error":h=this.c.error;break}if(h){const n=h.indexOf(r);n>=0&&h.splice(n,1)}}j(){if(this.b.data.length>0){const I=this.e(this.b.data);this.g(I),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(h=>h())}}k(){if(this.c.error.length>0){for(const I of this.b.error)this.h(I);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function p(S,I){const r=[];let h;for(;(h=S.read())!==null;)r.push(h);return I(r)}e.$yb=p;function A(S,I,r){const h=[];let n;for(;(n=S.read())!==null&&h.length<r;)h.push(n);return n===null&&h.length>0?I(h):{read:()=>{if(h.length>0)return h.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return S.read()}}}e.$zb=A;function E(S,I){return new Promise((r,h)=>{const n=[];c(S,{onData:s=>{I&&n.push(s)},onError:s=>{I?h(s):r(void 0)},onEnd:()=>{r(I?I(n):void 0)}})})}e.$Ab=E;function c(S,I){let r=!1;return S.on("error",h=>{r||I.onError(h)}),S.on("end",()=>{r||I.onEnd()}),S.on("data",h=>{r||I.onData(h)}),(0,T.$jb)(()=>r=!0)}e.$Bb=c;function y(S,I){return new Promise((r,h)=>{const n=new T.$kb,s=[],$=f=>{if(s.push(f),s.length>I)return n.dispose(),S.pause(),r({stream:S,buffer:s,ended:!1})},k=f=>h(f),l=()=>r({stream:S,buffer:s,ended:!0});n.add((0,T.$jb)(()=>S.removeListener("error",k))),S.on("error",k),n.add((0,T.$jb)(()=>S.removeListener("end",l))),S.on("end",l),n.add((0,T.$jb)(()=>S.removeListener("data",$))),S.on("data",$)})}e.$Cb=y;function b(S,I){const r=g(I);return r.end(S),r}e.$Db=b;function o(){const S=g(()=>{throw new Error("not supported")});return S.end(),S}e.$Eb=o;function t(S){let I=!1;return{read:()=>I?null:(I=!0,S)}}e.$Fb=t;function i(S,I,r){const h=g(r);return c(S,{onData:n=>h.write(I.data(n)),onError:n=>h.error(I.error?I.error(n):n),onEnd:()=>h.end()}),h}e.$Gb=i;function a(S,I,r){let h=!1;return{read:()=>{const n=I.read();return h?n:(h=!0,n!==null?r([S,n]):S)}}}e.$Hb=a;function m(S,I,r){let h=!1;const n=g(r);return c(I,{onData:s=>h?n.write(s):(h=!0,n.write(r([S,s]))),onError:s=>n.error(s),onEnd:()=>{h||(h=!0,n.write(S)),n.end()}}),n}e.$Ib=m}),define(Ae[25],Fe([1,0,66,118]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=void 0;const C=typeof Buffer<"u",M=new w.$T(()=>new Uint8Array(256));let P,g;class D{static alloc(d){return C?new D(Buffer.allocUnsafe(d)):new D(new Uint8Array(d))}static wrap(d){return C&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new D(d)}static fromString(d,R){return!(R?.dontUseNodeBuffer||!1)&&C?new D(Buffer.from(d)):(P||(P=new TextEncoder),new D(P.encode(d)))}static fromByteArray(d){const R=D.alloc(d.length);for(let W=0,B=d.length;W<B;W++)R.buffer[W]=d[W];return R}static concat(d,R){if(typeof R>"u"){R=0;for(let q=0,U=d.length;q<U;q++)R+=d[q].byteLength}const W=D.alloc(R);let B=0;for(let q=0,U=d.length;q<U;q++){const N=d[q];W.set(N,B),B+=N.byteLength}return W}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=D.alloc(this.byteLength);return d.set(this),d}toString(){return C?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(d,R){return new D(this.buffer.subarray(d,R))}set(d,R){if(d instanceof D)this.buffer.set(d.buffer,R);else if(d instanceof Uint8Array)this.buffer.set(d,R);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),R);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return c(this.buffer,d)}writeUInt32BE(d,R){y(this.buffer,d,R)}readUInt32LE(d){return b(this.buffer,d)}writeUInt32LE(d,R){o(this.buffer,d,R)}readUInt8(d){return t(this.buffer,d)}writeUInt8(d,R){i(this.buffer,d,R)}indexOf(d,R=0){return p(this.buffer,d instanceof D?d.buffer:d,R)}}e.$Jb=D;function p(u,d,R=0){const W=d.byteLength,B=u.byteLength;if(W===0)return 0;if(W===1)return u.indexOf(d[0]);if(W>B-R)return-1;const q=M.value;q.fill(d.length);for(let ce=0;ce<d.length;ce++)q[d[ce]]=d.length-ce-1;let U=R+d.length-1,N=U,O=-1;for(;U<B;)if(u[U]===d[N]){if(N===0){O=U;break}U--,N--}else U+=Math.max(d.length-N,q[u[U]]),N=d.length-1;return O}e.$Kb=p;function A(u,d){return u[d+0]<<0>>>0|u[d+1]<<8>>>0}e.$Lb=A;function E(u,d,R){u[R+0]=d&255,d=d>>>8,u[R+1]=d&255}e.$Mb=E;function c(u,d){return u[d]*2**24+u[d+1]*2**16+u[d+2]*2**8+u[d+3]}e.$Nb=c;function y(u,d,R){u[R+3]=d,d=d>>>8,u[R+2]=d,d=d>>>8,u[R+1]=d,d=d>>>8,u[R]=d}e.$Ob=y;function b(u,d){return u[d+0]<<0>>>0|u[d+1]<<8>>>0|u[d+2]<<16>>>0|u[d+3]<<24>>>0}e.$Pb=b;function o(u,d,R){u[R+0]=d&255,d=d>>>8,u[R+1]=d&255,d=d>>>8,u[R+2]=d&255,d=d>>>8,u[R+3]=d&255}e.$Qb=o;function t(u,d){return u[d]}e.$Rb=t;function i(u,d,R){u[R]=d}e.$Sb=i;function a(u){return T.$yb(u,d=>D.concat(d))}e.$Tb=a;function m(u){return T.$Fb(u)}e.$Ub=m;function S(u){return T.$Ab(u,d=>D.concat(d))}e.$Vb=S;async function I(u){return u.ended?D.concat(u.buffer):D.concat([...u.buffer,await S(u.stream)])}e.$Wb=I;function r(u){return T.$Db(u,d=>D.concat(d))}e.$Xb=r;function h(u){return T.$Gb(u,{data:d=>typeof d=="string"?D.fromString(d):D.wrap(d)},d=>D.concat(d))}e.$Yb=h;function n(u){return T.$xb(d=>D.concat(d),u)}e.$Zb=n;function s(u,d){return T.$Hb(u,d,R=>D.concat(R))}e.$1b=s;function $(u,d){return T.$Ib(u,d,R=>D.concat(R))}e.$2b=$;function k(u){let d=0,R=0,W=0;const B=new Uint8Array(Math.floor(u.length/4*3)),q=N=>{switch(R){case 3:B[W++]=d|N,R=0;break;case 2:B[W++]=d|N>>>2,d=N<<6,R=3;break;case 1:B[W++]=d|N>>>4,d=N<<4,R=2;break;default:d=N<<2,R=1}};for(let N=0;N<u.length;N++){const O=u.charCodeAt(N);if(O>=65&&O<=90)q(O-65);else if(O>=97&&O<=122)q(O-97+26);else if(O>=48&&O<=57)q(O-48+52);else if(O===43||O===45)q(62);else if(O===47||O===95)q(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${u[N]}`)}}const U=W;for(;R>0;)q(0);return D.wrap(B).slice(0,U)}e.$3b=k;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:u},d=!0,R=!1){const W=R?f:l;let B="";const q=u.byteLength%3;let U=0;for(;U<u.byteLength-q;U+=3){const N=u[U+0],O=u[U+1],ce=u[U+2];B+=W[N>>>2],B+=W[(N<<4|O>>>4)&63],B+=W[(O<<2|ce>>>6)&63],B+=W[ce&63]}if(q===1){const N=u[U+0];B+=W[N>>>2],B+=W[N<<4&63],d&&(B+="==")}else if(q===2){const N=u[U+0],O=u[U+1];B+=W[N>>>2],B+=W[(N<<4|O>>>4)&63],B+=W[O<<2&63],d&&(B+="=")}return B}e.$4b=v}),define(Ae[119],Fe([1,0,28,15]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.FuzzyScore=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.or=void 0;function C(...ee){return function(ie,le){for(let F=0,V=ee.length;F<V;F++){const J=ee[F](ie,le);if(J)return J}return null}}e.or=C,e.$kj=M.bind(void 0,!1),e.$lj=M.bind(void 0,!0);function M(ee,ie,le){if(!le||le.length<ie.length)return null;let F;return ee?F=T.$Nd(le,ie):F=le.indexOf(ie)===0,F?ie.length>0?[{start:0,end:ie.length}]:[]:null}function P(ee,ie){const le=ie.toLowerCase().indexOf(ee.toLowerCase());return le===-1?null:[{start:le,end:le+ee.length}]}e.$mj=P;function g(ee,ie){return D(ee.toLowerCase(),ie.toLowerCase(),0,0)}e.$nj=g;function D(ee,ie,le,F){if(le===ee.length)return[];if(F===ie.length)return null;if(ee[le]===ie[F]){let V=null;return(V=D(ee,ie,le+1,F+1))?i({start:F,end:F+1},V):null}return D(ee,ie,le,F+1)}function p(ee){return 97<=ee&&ee<=122}function A(ee){return 65<=ee&&ee<=90}e.$oj=A;function E(ee){return 48<=ee&&ee<=57}function c(ee){return ee===32||ee===9||ee===10||ee===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>y.add(ee.charCodeAt(0)));function b(ee){return c(ee)||y.has(ee)}function o(ee,ie){return ee===ie||b(ee)&&b(ie)}function t(ee){return p(ee)||A(ee)||E(ee)}function i(ee,ie){return ie.length===0?ie=[ee]:ee.end===ie[0].start?ie[0].start=ee.start:ie.unshift(ee),ie}function a(ee,ie){for(let le=ie;le<ee.length;le++){const F=ee.charCodeAt(le);if(A(F)||E(F)||le>0&&!t(ee.charCodeAt(le-1)))return le}return ee.length}function m(ee,ie,le,F){if(le===ee.length)return[];if(F===ie.length)return null;if(ee[le]!==ie[F].toLowerCase())return null;{let V=null,J=F+1;for(V=m(ee,ie,le+1,F+1);!V&&(J=a(ie,J))<ie.length;)V=m(ee,ie,le+1,J),J++;return V===null?null:i({start:F,end:F+1},V)}}function S(ee){let ie=0,le=0,F=0,V=0,J=0;for(let me=0;me<ee.length;me++)J=ee.charCodeAt(me),A(J)&&ie++,p(J)&&le++,t(J)&&F++,E(J)&&V++;const K=ie/ee.length,ae=le/ee.length,G=F/ee.length,ue=V/ee.length;return{upperPercent:K,lowerPercent:ae,alphaPercent:G,numericPercent:ue}}function I(ee){const{upperPercent:ie,lowerPercent:le}=ee;return le===0&&ie>.6}function r(ee){const{upperPercent:ie,lowerPercent:le,alphaPercent:F,numericPercent:V}=ee;return le>.2&&ie<.8&&F>.6&&V<.2}function h(ee){let ie=0,le=0,F=0,V=0;for(let J=0;J<ee.length;J++)F=ee.charCodeAt(J),A(F)&&ie++,p(F)&&le++,c(F)&&V++;return(ie===0||le===0)&&V===0?ee.length<=30:ie<=5}function n(ee,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!h(ee)||ie.length>60)return null;const le=S(ie);if(!r(le)){if(!I(le))return null;ie=ie.toLowerCase()}let F=null,V=0;for(ee=ee.toLowerCase();V<ie.length&&(F=m(ee,ie,0,V))===null;)V=a(ie,V+1);return F}e.$pj=n;function s(ee,ie,le=!1){if(!ie||ie.length===0)return null;let F=null,V=0;for(ee=ee.toLowerCase(),ie=ie.toLowerCase();V<ie.length&&(F=$(ee,ie,0,V,le))===null;)V=k(ie,V+1);return F}e.$qj=s;function $(ee,ie,le,F,V){if(le===ee.length)return[];if(F===ie.length)return null;if(o(ee.charCodeAt(le),ie.charCodeAt(F))){let J=null,K=F+1;if(J=$(ee,ie,le+1,F+1,V),!V)for(;!J&&(K=k(ie,K))<ie.length;)J=$(ee,ie,le+1,K,V),K++;return J?ee.charCodeAt(le)!==ie.charCodeAt(F)?J:i({start:F,end:F+1},J):null}else return null}function k(ee,ie){for(let le=ie;le<ee.length;le++)if(b(ee.charCodeAt(le))||le>0&&b(ee.charCodeAt(le-1)))return le;return ee.length}const l=C(e.$lj,n,P),f=C(e.$lj,n,g),v=new w.$qi(1e4);function u(ee,ie,le=!1){if(typeof ee!="string"||typeof ie!="string")return null;let F=v.get(ee);F||(F=new RegExp(T.$ud(ee),"i"),v.set(ee,F));const V=F.exec(ie);return V?[{start:V.index,end:V.index+V[0].length}]:le?f(ee,ie):l(ee,ie)}e.$rj=u;function d(ee,ie){const le=pe(ee,ee.toLowerCase(),0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return le?W(le):null}e.$sj=d;function R(ee,ie,le,F,V,J){const K=Math.min(13,ee.length);for(;le<K;le++){const ae=pe(ee,ie,le,F,V,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ae)return ae}return[0,J]}e.$tj=R;function W(ee){if(typeof ee>"u")return[];const ie=[],le=ee[1];for(let F=ee.length-1;F>1;F--){const V=ee[F]+le,J=ie[ie.length-1];J&&J.end===V?J.end=V+1:ie.push({start:V,end:V+1})}return ie}e.$uj=W;const B=128;function q(){const ee=[],ie=[];for(let le=0;le<=B;le++)ie[le]=0;for(let le=0;le<=B;le++)ee.push(ie.slice(0));return ee}function U(ee){const ie=[];for(let le=0;le<=ee;le++)ie[le]=0;return ie}const N=U(2*B),O=U(2*B),ce=q(),X=q(),be=q(),Ee=!1;function Re(ee,ie,le,F,V){function J(ae,G,ue=" "){for(;ae.length<G;)ae=ue+ae;return ae}let K=` |   |${F.split("").map(ae=>J(ae,3)).join("|")}
`;for(let ae=0;ae<=le;ae++)ae===0?K+=" |":K+=`${ie[ae-1]}|`,K+=ee[ae].slice(0,V+1).map(G=>J(G.toString(),3)).join("|")+`
`;return K}function Z(ee,ie,le,F){ee=ee.substr(ie),le=le.substr(F),console.log(Re(X,ee,ee.length,le,le.length)),console.log(Re(be,ee,ee.length,le,le.length)),console.log(Re(ce,ee,ee.length,le,le.length))}function he(ee,ie){if(ie<0||ie>=ee.length)return!1;const le=ee.codePointAt(ie);switch(le){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$6d(le)}}function Ce(ee,ie){if(ie<0||ie>=ee.length)return!1;switch(ee.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function H(ee,ie,le){return ie[ee]!==le[ee]}function ne(ee,ie,le,F,V,J,K=!1){for(;ie<le&&V<J;)ee[ie]===F[V]&&(K&&(N[ie]=V),ie+=1),V+=1;return ie===le}e.$vj=ne;var re;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(re||(re={}));var L;(function(ee){ee.Default=[-100,0];function ie(le){return!le||le.length===2&&le[0]===-100&&le[1]===0}ee.isDefault=ie})(L||(e.FuzzyScore=L={}));class _{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ie,le){this.firstMatchCanBeWeak=ie,this.boostFullMatch=le}}e.$wj=_;function pe(ee,ie,le,F,V,J,K=_.default){const ae=ee.length>B?B:ee.length,G=F.length>B?B:F.length;if(le>=ae||J>=G||ae-le>G-J||!ne(ie,le,ae,V,J,G,!0))return;Ie(ae,G,le,J,ie,V);let ue=1,me=1,Ne=le,Be=J;const Ye=[!1];for(ue=1,Ne=le;Ne<ae;ue++,Ne++){const xe=N[Ne],tt=O[Ne],Oe=Ne+1<ae?O[Ne+1]:G;for(me=xe-J+1,Be=xe;Be<Oe;me++,Be++){let nt=Number.MIN_SAFE_INTEGER,x=!1;Be<=tt&&(nt=De(ee,ie,Ne,le,F,V,Be,G,J,ce[ue-1][me-1]===0,Ye));let Y=0;nt!==Number.MAX_SAFE_INTEGER&&(x=!0,Y=nt+X[ue-1][me-1]);const ge=Be>xe,je=ge?X[ue][me-1]+(ce[ue][me-1]>0?-5:0):0,Me=Be>xe+1&&ce[ue][me-1]>0,Ze=Me?X[ue][me-2]+(ce[ue][me-2]>0?-5:0):0;if(Me&&(!ge||Ze>=je)&&(!x||Ze>=Y))X[ue][me]=Ze,be[ue][me]=3,ce[ue][me]=0;else if(ge&&(!x||je>=Y))X[ue][me]=je,be[ue][me]=2,ce[ue][me]=0;else if(x)X[ue][me]=Y,be[ue][me]=1,ce[ue][me]=ce[ue-1][me-1]+1;else throw new Error("not possible")}}if(Ee&&Z(ee,le,F,J),!Ye[0]&&!K.firstMatchCanBeWeak)return;ue--,me--;const Ke=[X[ue][me],J];let Xe=0,Ge=0;for(;ue>=1;){let xe=me;do{const tt=be[ue][xe];if(tt===3)xe=xe-2;else if(tt===2)xe=xe-1;else break}while(xe>=1);Xe>1&&ie[le+ue-1]===V[J+me-1]&&!H(xe+J-1,F,V)&&Xe+1>ce[ue][xe]&&(xe=me),xe===me?Xe++:Xe=1,Ge||(Ge=xe),ue--,me=xe-1,Ke.push(me)}G===ae&&K.boostFullMatch&&(Ke[0]+=2);const ct=Ge-ae;return Ke[0]-=ct,Ke}e.$xj=pe;function Ie(ee,ie,le,F,V,J){let K=ee-1,ae=ie-1;for(;K>=le&&ae>=F;)V[K]===J[ae]&&(O[K]=ae,K--),ae--}function De(ee,ie,le,F,V,J,K,ae,G,ue,me){if(ie[le]!==J[K])return Number.MIN_SAFE_INTEGER;let Ne=1,Be=!1;return K===le-F?Ne=ee[le]===V[K]?7:5:H(K,V,J)&&(K===0||!H(K-1,V,J))?(Ne=ee[le]===V[K]?7:5,Be=!0):he(J,K)&&(K===0||!he(J,K-1))?Ne=5:(he(J,K-1)||Ce(J,K-1))&&(Ne=5,Be=!0),Ne>1&&le===F&&(me[0]=!0),Be||(Be=H(K,V,J)||he(J,K-1)||Ce(J,K-1)),le===F?K>G&&(Ne-=Be?3:5):ue?Ne+=Be?2:0:Ne+=Be?0:1,K+1===ae&&(Ne-=Be?3:5),Ne}function ye(ee,ie,le,F,V,J,K){return oe(ee,ie,le,F,V,J,!0,K)}e.$yj=ye;function Se(ee,ie,le,F,V,J,K){return oe(ee,ie,le,F,V,J,!1,K)}e.$zj=Se;function oe(ee,ie,le,F,V,J,K,ae){let G=pe(ee,ie,le,F,V,J,ae);if(G&&!K)return G;if(ee.length>=3){const ue=Math.min(7,ee.length-1);for(let me=le+1;me<ue;me++){const Ne=de(ee,me);if(Ne){const Be=pe(Ne,Ne.toLowerCase(),le,F,V,J,ae);Be&&(Be[0]-=3,(!G||Be[0]>G[0])&&(G=Be))}}}return G}function de(ee,ie){if(ie+1>=ee.length)return;const le=ee[ie],F=ee[ie+1];if(le!==F)return ee.slice(0,ie)+F+le+ee.slice(ie+2)}}),define(Ae[29],Fe([1,0,15]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(T||(T={})),function(C){const M="error",P="warning",g="warn",D="info",p="ignore";function A(c){return c?w.$Md(M,c)?C.Error:w.$Md(P,c)||w.$Md(g,c)?C.Warning:w.$Md(D,c)?C.Info:C.Ignore:C.Ignore}C.fromValue=A;function E(c){switch(c){case C.Error:return M;case C.Warning:return P;case C.Info:return D;default:return p}}C.toString=E}(T||(T={})),e.default=T}),define(Ae[120],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0,e.$5c=Symbol("MicrotaskDelay")}),define(Ae[48],Fe([1,0,18,15]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=void 0;class C{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const b=y.charCodeAt(0),o=this.b.charCodeAt(this.c);return b-o}value(){return this.b[this.c]}}e.$rh=C;class M{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,T.$Gd)(y,this.b,0,y.length,this.c,this.d):(0,T.$Id)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$sh=M;class P{constructor(y=!0,b=!0){this.f=y,this.g=b}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let b=y.length-1;b>=0;b--,this.c--){const o=this.b.charCodeAt(b);if(!(o===47||this.f&&o===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const b=this.b.charCodeAt(this.e);if(b===47||this.f&&b===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,T.$Gd)(y,this.b,0,y.length,this.d,this.e):(0,T.$Id)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$th=P;var g;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(g||(g={}));class D{constructor(y,b){this.f=y,this.g=b,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,T.$Hd)(y,this.c.scheme);if(this.d[this.e]===2)return(0,T.$Hd)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,T.$Fd)(y,this.c.query);if(this.d[this.e]===5)return(0,T.$Fd)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$uh=D;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(A||(A={}));class E{static forUris(y=()=>!1,b=()=>!1){return new E(new D(y,b))}static forPaths(y=!1){return new E(new P(void 0,!y))}static forStrings(){return new E(new C)}static forConfigKeys(){return new E(new M)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,b){if(b){const o=b.slice(0);(0,w.$Ef)(o);for(const t of o)this.set(t,y)}else{const o=y.slice(0);(0,w.$Ef)(o);for(const t of o)this.set(t[0],t[1])}}set(y,b){const o=this.b.reset(y);let t;this.c||(this.c=new p,this.c.segment=o.value());const i=[];for(t=this.c;;){const m=o.cmp(t.segment);if(m>0)t.left||(t.left=new p,t.left.segment=o.value()),i.push([-1,t]),t=t.left;else if(m<0)t.right||(t.right=new p,t.right.segment=o.value()),i.push([1,t]),t=t.right;else if(o.hasNext())o.next(),t.mid||(t.mid=new p,t.mid.segment=o.value()),i.push([0,t]),t=t.mid;else break}const a=t.value;t.value=b,t.key=y;for(let m=i.length-1;m>=0;m--){const S=i[m][1];S.updateHeight();const I=S.balanceFactor();if(I<-1||I>1){const r=i[m][0],h=i[m+1][0];if(r===1&&h===1)i[m][1]=S.rotateLeft();else if(r===-1&&h===-1)i[m][1]=S.rotateRight();else if(r===1&&h===-1)S.right=i[m+1][1]=i[m+1][1].rotateRight(),i[m][1]=S.rotateLeft();else if(r===-1&&h===1)S.left=i[m+1][1]=i[m+1][1].rotateLeft(),i[m][1]=S.rotateRight();else throw new Error;if(m>0)switch(i[m-1][0]){case-1:i[m-1][1].left=i[m][1];break;case 1:i[m-1][1].right=i[m][1];break;case 0:i[m-1][1].mid=i[m][1];break}else this.c=i[0][1]}}return a}get(y){return this.d(y)?.value}d(y){const b=this.b.reset(y);let o=this.c;for(;o;){const t=b.cmp(o.segment);if(t>0)o=o.left;else if(t<0)o=o.right;else if(b.hasNext())b.next(),o=o.mid;else break}return o}has(y){const b=this.d(y);return!(b?.value===void 0&&b?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,b){const o=this.b.reset(y),t=[];let i=this.c;for(;i;){const a=o.cmp(i.segment);if(a>0)t.push([-1,i]),i=i.left;else if(a<0)t.push([1,i]),i=i.right;else if(o.hasNext())o.next(),t.push([0,i]),i=i.mid;else break}if(i){if(b?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const a=this.f(i.right);if(a.key){const{key:m,value:S,segment:I}=a;this.e(a.key,!1),i.key=m,i.value=S,i.segment=I}}else{const a=i.left??i.right;if(t.length>0){const[m,S]=t[t.length-1];switch(m){case-1:S.left=a;break;case 0:S.mid=a;break;case 1:S.right=a;break}}else this.c=a}for(let a=t.length-1;a>=0;a--){const m=t[a][1];m.updateHeight();const S=m.balanceFactor();if(S>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),t[a][1]=m.rotateLeft()):S<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),t[a][1]=m.rotateRight()),a>0)switch(t[a-1][0]){case-1:t[a-1][1].left=t[a][1];break;case 1:t[a-1][1].right=t[a][1];break;case 0:t[a-1][1].mid=t[a][1];break}else this.c=t[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const b=this.b.reset(y);let o=this.c,t;for(;o;){const i=b.cmp(o.segment);if(i>0)o=o.left;else if(i<0)o=o.right;else if(b.hasNext())b.next(),t=o.value||t,o=o.mid;else break}return o&&o.value||t}findSuperstr(y){return this.g(y,!1)}g(y,b){const o=this.b.reset(y);let t=this.c;for(;t;){const i=o.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(o.hasNext())o.next(),t=t.mid;else return t.mid?this.h(t.mid):b?t.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[b,o]of this)y(o,b)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const b=[];return this.j(y,b),b[Symbol.iterator]()}j(y,b){y&&(y.left&&this.j(y.left,b),y.value&&b.push([y.key,y.value]),y.mid&&this.j(y.mid,b),y.right&&this.j(y.right,b))}_isBalanced(){const y=b=>{if(!b)return!0;const o=b.balanceFactor();return o<-1||o>1?!1:y(b.left)&&y(b.right)};return y(this.c)}}e.$vh=E}),define(Ae[40],Fe([1,0,88]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Dj=e.ThemeColor=void 0;var T;(function(P){function g(D){return D&&typeof D=="object"&&typeof D.id=="string"}P.isThemeColor=g})(T||(e.ThemeColor=T={}));function C(P){return{id:P}}e.$Dj=C;var M;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const g=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function D(a){const m=g.exec(a.id);if(!m)return D(w.$Cj.error);const[,S,I]=m,r=["codicon","codicon-"+S];return I&&r.push("codicon-modifier-"+I.substring(1)),r}P.asClassNameArray=D;function p(a){return D(a).join(" ")}P.asClassName=p;function A(a){return"."+D(a).join(".")}P.asCSSSelector=A;function E(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||T.isThemeColor(a.color))}P.isThemeIcon=E;const c=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function y(a){const m=c.exec(a);if(!m)return;const[,S]=m;return{id:S}}P.fromString=y;function b(a){return{id:a}}P.fromId=b;function o(a,m){let S=a.id;const I=S.lastIndexOf("~");return I!==-1&&(S=S.substring(0,I)),m&&(S=`${S}~${m}`),{id:S}}P.modify=o;function t(a){const m=a.id.lastIndexOf("~");if(m!==-1)return a.id.substring(m+1)}P.getModifier=t;function i(a,m){return a.id===m.id&&a.color?.id===m.color?.id}P.isEqual=i})(M||(e.ThemeIcon=M={}))}),define(Ae[121],Fe([1,0,119,15,40]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=void 0;const M="$(",P=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),g=new RegExp(`(\\\\)?${P.source}`,"g");function D(i){return i.replace(g,(a,m)=>m?a:`\\${a}`)}e.$Ej=D;const p=new RegExp(`\\\\${P.source}`,"g");function A(i){return i.replace(p,a=>`\\${a}`)}e.$Fj=A;const E=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function c(i){return i.indexOf(M)===-1?i:i.replace(E,(a,m,S,I)=>S?a:m||I||"")}e.$Gj=c;function y(i){return i?i.replace(/\$\((.*?)\)/g,(a,m)=>` ${m} `).trim():""}e.$Hj=y;const b=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function o(i){b.lastIndex=0;let a="";const m=[];let S=0;for(;;){const I=b.lastIndex,r=b.exec(i),h=i.substring(I,r?.index);if(h.length>0){a+=h;for(let n=0;n<h.length;n++)m.push(S)}if(!r)break;S+=r[0].length}return{text:a,iconOffsets:m}}e.$Ij=o;function t(i,a,m=!1){const{text:S,iconOffsets:I}=a;if(!I||I.length===0)return(0,w.$rj)(i,S,m);const r=(0,T.$sd)(S," "),h=S.length-r.length,n=(0,w.$rj)(i,r,m);if(n)for(const s of n){const $=I[s.start+h]+h;s.start+=$,s.end+=$}return n}e.$Jj=t}),define(Ae[36],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(C){return w.test(C)}e.$5e=T,e.$6e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(g){for(let D=0;D<g.length;D++)g[D]=Math.floor(Math.random()*256);return g};const M=new Uint8Array(16),P=[];for(let g=0;g<256;g++)P.push(g.toString(16).padStart(2,"0"));return function(){C(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let D=0,p="";return p+=P[M[D++]],p+=P[M[D++]],p+=P[M[D++]],p+=P[M[D++]],p+="-",p+=P[M[D++]],p+=P[M[D++]],p+="-",p+=P[M[D++]],p+=P[M[D++]],p+="-",p+=P[M[D++]],p+=P[M[D++]],p+="-",p+=P[M[D++]],p+=P[M[D++]],p+=P[M[D++]],p+=P[M[D++]],p+=P[M[D++]],p+=P[M[D++]],p}}()}),define(Ae[122],Fe([1,0,18,67,36]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=e.$bs=e.$as=e.$_r=e.$$r=void 0;function M(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}e.$$r=M;function P(E,c,y){const b={id:(0,C.$6e)(),name:E,uri:c,data:y};return{asString:async()=>"",asFile:()=>b,value:void 0}}e.$_r=P;class g{constructor(){this.a=new Map}get size(){let c=0;for(const y of this.a)c++;return c}has(c){return this.a.has(this.b(c))}matches(c){const y=[...this.a.keys()];return T.Iterable.some(this,([b,o])=>o.asFile())&&y.push("files"),A(D(c),y)}get(c){return this.a.get(this.b(c))?.[0]}append(c,y){const b=this.a.get(c);b?b.push(y):this.a.set(this.b(c),[y])}replace(c,y){this.a.set(this.b(c),[y])}delete(c){this.a.delete(this.b(c))}*[Symbol.iterator](){for(const[c,y]of this.a)for(const b of y)yield[c,b]}b(c){return D(c)}}e.$as=g;function D(E){return E.toLowerCase()}function p(E,c){return A(D(E),c.map(D))}e.$bs=p;function A(E,c){if(E==="*/*")return c.length>0;if(c.includes(E))return!0;const y=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[b,o,t]=y;return t==="*"?c.some(i=>i.startsWith(o+"/")):!1}e.$cs=Object.freeze({create:E=>(0,w.$rf)(E.map(c=>c.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$cs.split(E).filter(c=>!c.startsWith("#"))})}),define(Ae[123],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0,e.$Hr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[124],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=e.$Bs=e.IndentAction=void 0;var w;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class T{constructor(g){if(this.e=null,this.f=!1,this.open=g.open,this.close=g.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(g.notIn))for(let D=0,p=g.notIn.length;D<p;D++)switch(g.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(g){switch(g){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(g,D){if(g.getTokenCount()===0)return!0;const p=g.findTokenIndexAtOffset(D-2),A=g.getStandardTokenType(p);return this.isOK(A)}g(g,D){for(let p=g;p<=D;p++){const A=String.fromCharCode(p);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Bs=T;class C{constructor(g){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of g)M(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),M(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),M(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),M(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&M(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.$Cs=C;function M(P,g,D){P.has(g)?P.get(g).push(D):P.set(g,[D])}}),define(Ae[125],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A5=e.$z5=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const P=this.a.get(M);return this.a.delete(M),P}}addDragOperationTransfer(M,P){this.a.set(M,P)}}e.$z5=w;class T{constructor(M){this.identifier=M}}e.$A5=T}),define(Ae[126],Fe([9,10]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(Ae[127],Fe([1,0,5,6,126]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0;class M extends T.$lb{constructor(c,y="",b="",o=!0,t){super(),this.h=this.B(new w.$8c),this.onDidChange=this.h.event,this.w=!0,this.j=c,this.m=y,this.u=b,this.w=o,this.C=t}get id(){return this.j}get label(){return this.m}set label(c){this.D(c)}D(c){this.m!==c&&(this.m=c,this.h.fire({label:c}))}get tooltip(){return this.n||""}set tooltip(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.h.fire({tooltip:c}))}get class(){return this.u}set class(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.h.fire({class:c}))}get enabled(){return this.w}set enabled(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.h.fire({enabled:c}))}get checked(){return this.z}set checked(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.h.fire({checked:c}))}async run(c,y){this.C&&await this.C(c)}}e.$7h=M;class P extends T.$lb{constructor(){super(...arguments),this.f=this.B(new w.$8c),this.onWillRun=this.f.event,this.k=this.B(new w.$8c),this.onDidRun=this.k.event}async run(c,y){if(!c.enabled)return;this.f.fire({action:c});let b;try{await this.l(c,y)}catch(o){b=o}this.k.fire({action:c,error:b})}async l(c,y){await c.run(y)}}e.$8h=P;class g{constructor(){this.id=g.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let y=[];for(const b of c)b.length&&(y.length?y=[...y,new g,...b]:y=b);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$9h=g;class D{get actions(){return this.a}constructor(c,y,b,o){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=y,this.class=o,this.a=b}async run(){}}e.$0h=D;class p extends M{static{this.ID="vs.actions.empty"}constructor(){super(p.ID,C.localize(0,null),void 0,!1)}}e.$$h=p;function A(E){return{id:E.id,label:E.label,class:void 0,enabled:E.enabled??!0,checked:E.checked??!1,run:async()=>E.run(),tooltip:E.label}}e.$_h=A}),define(Ae[128],Fe([9,10]),function($e,e){return $e.create("vs/base/common/date",e)}),define(Ae[129],Fe([1,0,128]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=void 0;const T=60,C=T*60,M=C*24,P=M*7,g=M*30,D=M*365;function p(E,c,y,b){typeof E!="number"&&(E=E.getTime());const o=Math.round((new Date().getTime()-E)/1e3);if(o<-30)return(0,w.localize)(0,null,p(new Date().getTime()+o*1e3,!1));if(!b&&o<30)return(0,w.localize)(1,null);let t;return o<T?(t=o,c?t===1?y?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):y?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t):t===1?y?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):y?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):o<C?(t=Math.floor(o/T),c?t===1?y?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):y?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t):t===1?y?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):y?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):o<M?(t=Math.floor(o/C),c?t===1?y?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):y?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t):t===1?y?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):y?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):o<P?(t=Math.floor(o/M),c?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t)):o<g?(t=Math.floor(o/P),c?t===1?y?(0,w.localize)(30,null,t):(0,w.localize)(31,null,t):y?(0,w.localize)(32,null,t):(0,w.localize)(33,null,t):t===1?y?(0,w.localize)(34,null,t):(0,w.localize)(35,null,t):y?(0,w.localize)(36,null,t):(0,w.localize)(37,null,t)):o<D?(t=Math.floor(o/g),c?t===1?y?(0,w.localize)(38,null,t):(0,w.localize)(39,null,t):y?(0,w.localize)(40,null,t):(0,w.localize)(41,null,t):t===1?y?(0,w.localize)(42,null,t):(0,w.localize)(43,null,t):y?(0,w.localize)(44,null,t):(0,w.localize)(45,null,t)):(t=Math.floor(o/D),c?t===1?y?(0,w.localize)(46,null,t):(0,w.localize)(47,null,t):y?(0,w.localize)(48,null,t):(0,w.localize)(49,null,t):t===1?y?(0,w.localize)(50,null,t):(0,w.localize)(51,null,t):y?(0,w.localize)(52,null,t):(0,w.localize)(53,null,t))}e.$Rl=p;function A(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Sl=A}),define(Ae[130],Fe([9,10]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(Ae[41],Fe([1,0,18,12,130]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=void 0;function M(E,c){return c&&(E.stack||E.stacktrace)?C.localize(0,null,g(E),P(E.stack)||P(E.stacktrace)):g(E)}function P(E){return Array.isArray(E)?E.join(`
`):E}function g(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?C.localize(1,null,E.message):E.message||C.localize(2,null)}function D(E=null,c=!1){if(!E)return C.localize(3,null);if(Array.isArray(E)){const y=w.$mf(E),b=D(y[0],c);return y.length>1?C.localize(4,null,b,y.length):b}if(T.$je(E))return E;if(E.detail){const y=E.detail;if(y.error)return M(y.error,c);if(y.exception)return M(y.exception,c)}return E.stack?M(E,c):E.message?E.message:C.localize(5,null)}e.$ai=D;function p(E){const c=E;return c instanceof Error&&Array.isArray(c.actions)}e.$bi=p;function A(E,c){let y;return typeof E=="string"?y=new Error(E):y=E,y.actions=c,y}e.$ci=A}),define(Ae[131],Fe([1,0,66,19]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=e.$Yp=void 0;const C=new w.$T(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),M=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function g(f,v,u=!1){const d=f||"",R=v||"",W=C.value.collator.compare(d,R);return C.value.collatorIsNumeric&&W===0&&d!==R?d<R?-1:1:W}e.$Yp=g;function D(f,v){const u=M.value.collator;return f=f||"",v=v||"",S(u,f,v)}e.$Zp=D;function p(f,v){const u=M.value.collator;return f=f||"",v=v||"",n(f,v)||S(u,f,v)}e.$1p=p;function A(f,v){const u=M.value.collator;return f=f||"",v=v||"",h(f,v)||S(u,f,v)}e.$2p=A;function E(f,v){return f=f||"",v=v||"",f===v?0:f<v?-1:1}e.$3p=E;function c(f,v){const[u,d]=a(f),[R,W]=a(v);let B=C.value.collator.compare(d,W);if(B===0){if(C.value.collatorIsNumeric&&d!==W)return d<W?-1:1;if(B=C.value.collator.compare(u,R),C.value.collatorIsNumeric&&B===0&&u!==R)return u<R?-1:1}return B}e.$4p=c;function y(f,v){f=f||"",v=v||"";const u=m(f),d=m(v),R=M.value.collator,W=P.value.collator;return S(W,u,d)||S(R,f,v)}e.$5p=y;function b(f,v){f=f||"",v=v||"";const u=m(f),d=m(v),R=M.value.collator,W=P.value.collator;return S(W,u,d)||n(f,v)||S(R,f,v)}e.$6p=b;function o(f,v){f=f||"",v=v||"";const u=m(f),d=m(v),R=M.value.collator,W=P.value.collator;return S(W,u,d)||h(f,v)||S(R,f,v)}e.$7p=o;function t(f,v){f=f||"",v=v||"";const u=m(f).toLowerCase(),d=m(v).toLowerCase();return u!==d?u<d?-1:1:f!==v?f<v?-1:1:0}e.$8p=t;const i=/^(.*?)(\.([^.]*))?$/;function a(f,v=!1){const u=f?i.exec(f):[];let d=[u&&u[1]||"",u&&u[3]||""];return v&&(!d[0]&&d[1]||d[0]&&d[0].charAt(0)===".")&&(d=[d[0]+"."+d[1],""]),d}function m(f){const v=f?i.exec(f):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function S(f,v,u){const d=f.compare(v,u);return d!==0?d:v.length!==u.length?v.length<u.length?-1:1:0}function I(f){const v=f.charAt(0);return v.toLocaleUpperCase()!==v}function r(f){const v=f.charAt(0);return v.toLocaleLowerCase()!==v}function h(f,v){return I(f)&&r(v)?-1:r(f)&&I(v)?1:0}function n(f,v){return r(f)&&I(v)?-1:I(f)&&r(v)?1:0}function s(f,v,u=!1){return u||(f=f&&f.toLowerCase(),v=v&&v.toLowerCase()),f===v?0:f<v?-1:1}function $(f,v,u=!1){const d=f.split(T.sep),R=v.split(T.sep),W=d.length-1,B=R.length-1;let q,U;for(let N=0;;N++){if(q=W===N,U=B===N,q&&U)return g(d[N],R[N],u);if(q)return-1;if(U)return 1;const O=s(d[N],R[N],u);if(O!==0)return O}}e.$9p=$;function k(f,v,u){const d=f.toLowerCase(),R=v.toLowerCase(),W=l(f,v,u);if(W)return W;const B=d.endsWith(u),q=R.endsWith(u);if(B!==q)return B?-1:1;const U=g(d,R);return U!==0?U:d.localeCompare(R)}e.$0p=k;function l(f,v,u){const d=f.toLowerCase(),R=v.toLowerCase(),W=d.startsWith(u),B=R.startsWith(u);if(W!==B)return W?-1:1;if(W&&B){if(d.length<R.length)return-1;if(d.length>R.length)return 1}return 0}e.$$p=l}),define(Ae[42],Fe([1,0,19,22,15,12]),function($e,e,w,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=void 0;function P(k){return k===47||k===92}e.$De=P;function g(k){return k.replace(/[\\/]/g,w.$0b.sep)}e.$Ee=g;function D(k){return k.indexOf("/")===-1&&(k=g(k)),/^[a-zA-Z]:(\/|$)/.test(k)&&(k="/"+k),k}e.$Fe=D;function p(k,l=w.$0b.sep){if(!k)return"";const f=k.length,v=k.charCodeAt(0);if(P(v)){if(P(k.charCodeAt(1))&&!P(k.charCodeAt(2))){let d=3;const R=d;for(;d<f&&!P(k.charCodeAt(d));d++);if(R!==d&&!P(k.charCodeAt(d+1))){for(d+=1;d<f;d++)if(P(k.charCodeAt(d)))return k.slice(0,d+1).replace(/[\\/]/g,l)}}return l}else if(i(v)&&k.charCodeAt(1)===58)return P(k.charCodeAt(2))?k.slice(0,2)+l:k.slice(0,2);let u=k.indexOf("://");if(u!==-1){for(u+=3;u<f;u++)if(P(k.charCodeAt(u)))return k.slice(0,u+1)}return""}e.$Ge=p;function A(k){if(!T.$i||!k||k.length<5)return!1;let l=k.charCodeAt(0);if(l!==92||(l=k.charCodeAt(1),l!==92))return!1;let f=2;const v=f;for(;f<k.length&&(l=k.charCodeAt(f),l!==92);f++);return!(v===f||(l=k.charCodeAt(f+1),isNaN(l)||l===92))}e.$He=A;const E=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(k,l=T.$i){const f=l?E:c;return!(!k||k.length===0||/^\s+$/.test(k)||(f.lastIndex=0,f.test(k))||l&&y.test(k)||k==="."||k===".."||l&&k[k.length-1]==="."||l&&k.length!==k.trim().length||k.length>255)}e.$Ie=b;function o(k,l,f){const v=k===l;return!f||v?v:!k||!l?!1:(0,C.$Md)(k,l)}e.$Je=o;function t(k,l,f,v=w.sep){if(k===l)return!0;if(!k||!l||l.length>k.length)return!1;if(f){if(!(0,C.$Nd)(k,l))return!1;if(l.length===k.length)return!0;let d=l.length;return l.charAt(l.length-1)===v&&d--,k.charAt(d)===v}return l.charAt(l.length-1)!==v&&(l+=v),k.indexOf(l)===0}e.$Ke=t;function i(k){return k>=65&&k<=90||k>=97&&k<=122}e.$Le=i;function a(k,l){return T.$i&&k.endsWith(":")&&(k+=w.sep),(0,w.$_b)(k)||(k=(0,w.$ac)(l,k)),k=(0,w.$$b)(k),T.$i?(k=(0,C.$td)(k,w.sep),k.endsWith(":")&&(k+=w.sep)):(k=(0,C.$td)(k,w.sep),k||(k=w.sep)),k}e.$Me=a;function m(k){const l=(0,w.$$b)(k);return T.$i?k.length>3?!1:S(l)&&(k.length===2||l.charCodeAt(2)===92):l===w.$0b.sep}e.$Ne=m;function S(k,l=T.$i){return l?i(k.charCodeAt(0))&&k.charCodeAt(1)===58:!1}e.$Oe=S;function I(k,l=T.$i){return S(k,l)?k[0]:void 0}e.$Pe=I;function r(k,l,f){return l.length>k.length?-1:k===l?0:(f&&(k=k.toLowerCase(),l=l.toLowerCase()),k.indexOf(l))}e.$Qe=r;function h(k){const l=k.split(":");let f,v,u;for(const d of l){const R=Number(d);(0,M.$ne)(R)?v===void 0?v=R:u===void 0&&(u=R):f=f?[f,d].join(":"):d}if(!f)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:f,line:v!==void 0?v:void 0,column:u!==void 0?u:v!==void 0?1:void 0}}e.$Re=h;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function $(k,l,f=8){let v="";for(let d=0;d<f;d++){let R;d===0&&T.$i&&!l&&(f===3||f===4)?R=s:R=n,v+=R.charAt(Math.floor(Math.random()*R.length))}let u;return l?u=`${l}-${v}`:u=v,k?(0,w.$ac)(k,u):u}e.$Se=$}),define(Ae[68],Fe([1,0,19]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.$wr=e.$vr=e.$ur=void 0,e.$ur=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(A){const E=(0,w.$fc)(A),c=T[E.toLowerCase()];return c!==void 0?c:P(A)}e.$vr=M;function P(A){const E=(0,w.$fc)(A);return C[E.toLowerCase()]}e.$wr=P;function g(A){for(const E in C)if(C[E]===A)return E}e.$xr=g;const D=/^(.+)\/(.+?)(;.+)?$/;function p(A,E){const c=D.exec(A);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:E?void 0:A}e.$yr=p}),define(Ae[69],Fe([1,0,25,15,2]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=e.$Xg=e.$Wg=void 0;function M(p){return JSON.stringify(p,g)}e.$Wg=M;function P(p){let A=JSON.parse(p);return A=D(A),A}e.$Xg=P;function g(p,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,T.$zd)(A)}:A}function D(p,A=0){if(!p||A>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return C.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 16:return new Date(p.source)}if(p instanceof w.$Jb||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let E=0;E<p.length;++E)p[E]=D(p[E],A+1);else for(const E in p)Object.hasOwnProperty.call(p,E)&&(p[E]=D(p[E],A+1))}return p}e.$Yg=D}),define(Ae[13],Fe([1,0,11,22,2]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.Schemas=void 0;var M;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$We="vscode-tkn",e.$Xe="tkn";class P{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${M.vscodeRemoteResource}`}set(A,E,c){this.a[A]=E,this.b[A]=c}setConnectionToken(A,E){this.c[A]=E}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(t){return w.$Y(t),A}const E=A.authority;let c=this.a[E];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const y=this.b[E],b=this.c[E];let o=`path=${encodeURIComponent(A.path)}`;return typeof b=="string"&&(o+=`&${e.$Xe}=${encodeURIComponent(b)}`),C.URI.from({scheme:T.$o?this.d:M.vscodeRemoteResource,authority:`${c}:${y}`,path:this.f,query:o})}}e.$Ye=new P,e.$Ze="vs/../../extensions",e.$1e="vs/../../node_modules",e.$2e="vs/../../node_modules.asar",e.$3e="vs/../../node_modules.asar.unpacked";class g{static{this.a="vscode-app"}asBrowserUri(A){const E=this.b(A,$e);return this.uriToBrowserUri(E)}uriToBrowserUri(A){return A.scheme===M.vscodeRemote?e.$Ye.rewrite(A):A.scheme===M.file&&(T.$m||T.$p&&T.$g.origin===`${M.vscodeFileResource}://${g.a}`)?A.with({scheme:M.vscodeFileResource,authority:A.authority||g.a,query:null,fragment:null}):A}asFileUri(A){const E=this.b(A,$e);return this.uriToFileUri(E)}uriToFileUri(A){return A.scheme===M.vscodeFileResource?A.with({scheme:M.file,authority:A.authority!==g.a?A.authority:null,query:null,fragment:null}):A}b(A,E){return C.URI.isUri(A)?A:C.URI.parse(E.toUrl(A))}}e.$4e=new g;var D;(function(p){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(A.get("3"));const E="vscode-coi";function c(b){let o;typeof b=="string"?o=new URL(b).searchParams:b instanceof URL?o=b.searchParams:C.URI.isUri(b)&&(o=new URL(b.toString(!0)).searchParams);const t=o?.get(E);if(t)return A.get(t)}p.getHeadersFromQuery=c;function y(b,o,t){if(!globalThis.crossOriginIsolated)return;const i=o&&t?"3":t?"2":"1";b instanceof URLSearchParams?b.set(E,i):b[E]=i}p.addSearchParam=y})(D||(e.COI=D={}))}),define(Ae[23],Fe([1,0,42,13,19,22,15,2]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.DataUri=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=void 0;function D(y){return(0,g.$Ve)(y,!0)}e.$Xf=D;class p{constructor(b){this.a=b}compare(b,o,t=!1){return b===o?0:(0,P.$Fd)(this.getComparisonKey(b,t),this.getComparisonKey(o,t))}isEqual(b,o,t=!1){return b===o?!0:!b||!o?!1:this.getComparisonKey(b,t)===this.getComparisonKey(o,t)}getComparisonKey(b,o=!1){return b.with({path:this.a(b)?b.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(b){return this.a(b)}isEqualOrParent(b,o,t=!1){if(b.scheme===o.scheme){if(b.scheme===T.Schemas.file)return w.$Ke(D(b),D(o),this.a(b))&&b.query===o.query&&(t||b.fragment===o.fragment);if((0,e.$cg)(b.authority,o.authority))return w.$Ke(b.path,o.path,this.a(b),"/")&&b.query===o.query&&(t||b.fragment===o.fragment)}return!1}joinPath(b,...o){return g.URI.joinPath(b,...o)}basenameOrAuthority(b){return(0,e.$7f)(b)||b.authority}basename(b){return C.$0b.basename(b.path)}extname(b){return C.$0b.extname(b.path)}dirname(b){if(b.path.length===0)return b;let o;return b.scheme===T.Schemas.file?o=g.URI.file(C.$dc(D(b))).path:(o=C.$0b.dirname(b.path),b.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),o="/")),b.with({path:o})}normalizePath(b){if(!b.path.length)return b;let o;return b.scheme===T.Schemas.file?o=g.URI.file(C.$$b(D(b))).path:o=C.$0b.normalize(b.path),b.with({path:o})}relativePath(b,o){if(b.scheme!==o.scheme||!(0,e.$cg)(b.authority,o.authority))return;if(b.scheme===T.Schemas.file){const a=C.$cc(D(b),D(o));return M.$i?w.$Ee(a):a}let t=b.path||"/";const i=o.path||"/";if(this.a(b)){let a=0;for(const m=Math.min(t.length,i.length);a<m&&!(t.charCodeAt(a)!==i.charCodeAt(a)&&t.charAt(a).toLowerCase()!==i.charAt(a).toLowerCase());a++);t=i.substr(0,a)+t.substr(a)}return C.$0b.relative(t,i)}resolvePath(b,o){if(b.scheme===T.Schemas.file){const t=g.URI.file(C.$bc(D(b),o));return b.with({authority:t.authority,path:t.path})}return o=w.$Fe(o),b.with({path:C.$0b.resolve(b.path,o)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,o){return b===o||b!==void 0&&o!==void 0&&(0,P.$Md)(b,o)}hasTrailingPathSeparator(b,o=C.sep){if(b.scheme===T.Schemas.file){const t=D(b);return t.length>w.$Ge(t).length&&t[t.length-1]===o}else{const t=b.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,o=C.sep){return(0,e.$dg)(b,o)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,o=C.sep){let t=!1;if(b.scheme===T.Schemas.file){const i=D(b);t=i!==void 0&&i.length===w.$Ge(i).length&&i[i.length-1]===o}else{o="/";const i=b.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$dg)(b,o)?b.with({path:b.path+"/"}):b}}e.$Yf=p,e.$Zf=new p(()=>!1),e.$1f=new p(y=>y.scheme===T.Schemas.file?!M.$k:!0),e.$2f=new p(y=>!0),e.$3f=e.$Zf.isEqual.bind(e.$Zf),e.$4f=e.$Zf.isEqualOrParent.bind(e.$Zf),e.$5f=e.$Zf.getComparisonKey.bind(e.$Zf),e.$6f=e.$Zf.basenameOrAuthority.bind(e.$Zf),e.$7f=e.$Zf.basename.bind(e.$Zf),e.$8f=e.$Zf.extname.bind(e.$Zf),e.$9f=e.$Zf.dirname.bind(e.$Zf),e.$0f=e.$Zf.joinPath.bind(e.$Zf),e.$$f=e.$Zf.normalizePath.bind(e.$Zf),e.$_f=e.$Zf.relativePath.bind(e.$Zf),e.$ag=e.$Zf.resolvePath.bind(e.$Zf),e.$bg=e.$Zf.isAbsolutePath.bind(e.$Zf),e.$cg=e.$Zf.isEqualAuthority.bind(e.$Zf),e.$dg=e.$Zf.hasTrailingPathSeparator.bind(e.$Zf),e.$eg=e.$Zf.removeTrailingPathSeparator.bind(e.$Zf),e.$fg=e.$Zf.addTrailingPathSeparator.bind(e.$Zf);function A(y,b){const o=[];for(let t=0;t<y.length;t++){const i=b(y[t]);y.some((a,m)=>m===t?!1:(0,e.$4f)(i,b(a)))||o.push(y[t])}return o}e.$gg=A;var E;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function b(o){const t=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(m=>{const[S,I]=m.split(":");S&&I&&t.set(S,I)});const a=o.path.substring(0,o.path.indexOf(";"));return a&&t.set(y.META_DATA_MIME,a),t}y.parseMetaData=b})(E||(e.DataUri=E={}));function c(y,b,o){if(b){let t=y.path;return t&&t[0]!==C.$0b.sep&&(t=C.$0b.sep+t),y.with({scheme:o,authority:b,path:t})}return y.with({scheme:o})}e.$hg=c}),define(Ae[16],Fe([1,0,20,11,5,6,23,22,120]),function($e,e,w,T,C,M,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.$Rg=e.$Qg=e.Promises=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function p(re){return!!re&&typeof re.then=="function"}e.$ig=p;function A(re){const L=new w.$ed,_=re(L.token),pe=new Promise((Ie,De)=>{const ye=L.token.onCancellationRequested(()=>{ye.dispose(),L.dispose(),De(new T.$3)});Promise.resolve(_).then(Se=>{ye.dispose(),L.dispose(),Ie(Se)},Se=>{ye.dispose(),L.dispose(),De(Se)})});return new class{cancel(){L.cancel()}then(Ie,De){return pe.then(Ie,De)}catch(Ie){return this.then(void 0,Ie)}finally(Ie){return pe.finally(Ie)}}}e.$jg=A;function E(re,L,_){return new Promise((pe,Ie)=>{const De=L.onCancellationRequested(()=>{De.dispose(),pe(_)});re.then(pe,Ie).finally(()=>De.dispose())})}e.$kg=E;function c(re,L){return new Promise((_,pe)=>{const Ie=L.onCancellationRequested(()=>{Ie.dispose(),pe(new T.$3)});re.then(_,pe).finally(()=>Ie.dispose())})}e.$lg=c;async function y(re){let L=-1;const _=re.map((pe,Ie)=>pe.then(De=>(L=Ie,De)));try{return await Promise.race(_)}finally{re.forEach((pe,Ie)=>{Ie!==L&&pe.cancel()})}}e.$mg=y;function b(re,L,_){let pe;const Ie=setTimeout(()=>{pe?.(void 0),_?.()},L);return Promise.race([re.finally(()=>clearTimeout(Ie)),new Promise(De=>pe=De)])}e.$ng=b;function o(re){return new Promise((L,_)=>{const pe=re();p(pe)?pe.then(L,_):L(pe)})}e.$og=o;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(L){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=L,!this.b){const _=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(_,_).then(pe)})}return new Promise((_,pe)=>{this.b.then(_,pe)})}return this.a=L(),new Promise((_,pe)=>{this.a.then(Ie=>{this.a=null,_(Ie)},Ie=>{this.a=null,pe(Ie)})})}dispose(){this.f=!0}}e.$pg=t;class i{constructor(){this.a=Promise.resolve(null)}queue(L){return this.a=this.a.then(()=>L(),()=>L())}}e.$qg=i;class a{constructor(){this.a=new Map}queue(L,_){const Ie=(this.a.get(L)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.a.get(L)===Ie&&this.a.delete(L)});return this.a.set(L,Ie),Ie}}e.$rg=a;const m=(re,L)=>{let _=!0;const pe=setTimeout(()=>{_=!1,L()},re);return{isTriggered:()=>_,dispose:()=>{clearTimeout(pe),_=!1}}},S=re=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,re())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};class I{constructor(L){this.defaultDelay=L,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(L,_=this.defaultDelay){this.g=L,this.h(),this.b||(this.b=new Promise((Ie,De)=>{this.d=Ie,this.f=De}).then(()=>{if(this.b=null,this.d=null,this.g){const Ie=this.g;return this.g=null,Ie()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=_===D.$5c?S(pe):m(_,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$sg=I;class r{constructor(L){this.a=new I(L),this.b=new t}trigger(L,_){return this.a.trigger(()=>this.b.queue(L),_)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$tg=r;class h{constructor(){this.a=!1,this.b=new Promise((L,_)=>{this.d=L})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ug=h;class n extends h{constructor(L){super(),this.f=setTimeout(()=>this.open(),L)}open(){clearTimeout(this.f),super.open()}}e.$vg=n;function s(re,L){return L?new Promise((_,pe)=>{const Ie=setTimeout(()=>{De.dispose(),_()},re),De=L.onCancellationRequested(()=>{clearTimeout(Ie),De.dispose(),pe(new T.$3)})}):A(_=>s(re,_))}e.$wg=s;function $(re,L=0){const _=setTimeout(re,L);return(0,M.$jb)(()=>clearTimeout(_))}e.$xg=$;function k(re){const L=[];let _=0;const pe=re.length;function Ie(){return _<pe?re[_++]():null}function De(ye){ye!=null&&L.push(ye);const Se=Ie();return Se?Se.then(De):Promise.resolve(L)}return Promise.resolve(null).then(De)}e.$yg=k;function l(re,L=pe=>!!pe,_=null){let pe=0;const Ie=re.length,De=()=>{if(pe>=Ie)return Promise.resolve(_);const ye=re[pe++];return Promise.resolve(ye()).then(oe=>L(oe)?Promise.resolve(oe):De())};return De()}e.$zg=l;function f(re,L=pe=>!!pe,_=null){if(re.length===0)return Promise.resolve(_);let pe=re.length;const Ie=()=>{pe=-1;for(const De of re)De.cancel?.()};return new Promise((De,ye)=>{for(const Se of re)Se.then(oe=>{--pe>=0&&L(oe)?(Ie(),De(oe)):pe===0&&De(_)}).catch(oe=>{--pe>=0&&(Ie(),ye(oe))})})}e.$Ag=f;class v{constructor(L){this.a=0,this.d=L,this.f=[],this.b=0,this.g=new C.$8c}get onDrained(){return this.g.event}get size(){return this.a}queue(L){return this.a++,new Promise((_,pe)=>{this.f.push({factory:L,c:_,e:pe}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const L=this.f.shift();this.b++;const _=L.factory();_.then(L.c,L.e),_.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Bg=v;class u extends v{constructor(){super(1)}}e.$Cg=u;class d{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const L=new Re;return this.b.add(L),L.p}d(){for(const[,L]of this.a)if(L.size>0)return!1;return!0}queueFor(L,_=P.$Zf){const pe=_.getComparisonKey(L);let Ie=this.a.get(pe);return Ie||(Ie=new u,C.Event.once(Ie.onDrained)(()=>{Ie?.dispose(),this.a.delete(pe),this.f()}),this.a.set(pe,Ie)),Ie}f(){this.d()&&this.g()}g(){for(const L of this.b)L.complete();this.b.clear()}dispose(){for(const[,L]of this.a)L.dispose();this.a.clear(),this.g()}}e.$Dg=d;class R{constructor(L,_){this.a=-1,typeof L=="function"&&typeof _=="number"&&this.setIfNotSet(L,_)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(L,_){this.cancel(),this.a=setTimeout(()=>{this.a=-1,L()},_)}setIfNotSet(L,_){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,L()},_))}}e.$Eg=R;class W{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(L,_){this.cancel(),this.a=setInterval(()=>{L()},_)}}e.$Fg=W;class B{constructor(L,_){this.b=-1,this.a=L,this.d=_,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(L=this.d){this.cancel(),this.b=setTimeout(this.f,L)}get delay(){return this.d}set delay(L){this.d=L}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Gg=B;class q{constructor(L,_){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.a=L,this.b=_,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(L=this.b){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(L/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Hg=q;class U extends B{constructor(L,_){super(L,_),this.j=[]}work(L){this.j.push(L),this.isScheduled()||this.schedule()}h(){const L=this.j;this.j=[],this.a?.(L)}dispose(){this.j=[],super.dispose()}}e.$Ig=U;class N extends M.$lb{constructor(L,_){super(),this.g=L,this.h=_,this.a=[],this.b=this.B(new M.$mb),this.f=!1}get pending(){return this.a.length}work(L){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+L.length>this.g.maxBufferedWork)return!1}else if(this.pending+L.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const _ of L)this.a.push(_);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new B(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Jg=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Kg=re=>{(0,g.$A)(()=>{if(L)return;const _=Date.now()+15;re(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,_-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.$Kg=(re,L)=>{const _=requestIdleCallback(re,typeof L=="number"?{timeout:L}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,cancelIdleCallback(_))}}}}();class O{constructor(L){this.d=!1,this.a=()=>{try{this.f=L()}catch(_){this.g=_}finally{this.d=!0}},this.b=(0,e.$Kg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Lg=O;async function ce(re,L,_){let pe;for(let Ie=0;Ie<_;Ie++)try{return await re()}catch(De){pe=De,await s(L)}throw pe}e.$Mg=ce;class X{hasPending(L){return this.a?typeof L=="number"?this.a.taskId===L:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(L,_,pe){return this.a={taskId:L,cancel:()=>pe?.(),promise:_},_.then(()=>this.d(L),()=>this.d(L)),_}d(L){this.a&&L===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const L=this.b;this.b=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this.b)this.b.run=L;else{let _,pe;const Ie=new Promise((De,ye)=>{_=De,pe=ye});this.b={run:L,promise:Ie,promiseResolve:_,promiseReject:pe}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ng=X;class be{constructor(L,_=()=>Date.now()){this.d=L,this.f=_,this.a=0,this.b=0}increment(){const L=this.f();return L-this.a>this.d&&(this.a=L,this.b=0),this.b++,this.b}}e.$Og=be;var Ee;(function(re){re[re.Resolved=0]="Resolved",re[re.Rejected=1]="Rejected"})(Ee||(Ee={}));class Re{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((L,_)=>{this.a=L,this.b=_})}complete(L){return new Promise(_=>{this.a(L),this.d={outcome:0,value:L},_()})}error(L){return new Promise(_=>{this.b(L),this.d={outcome:1,value:L},_()})}cancel(){return this.error(new T.$3)}}e.$Pg=Re;var Z;(function(re){async function L(pe){let Ie;const De=await Promise.all(pe.map(ye=>ye.then(Se=>Se,Se=>{Ie||(Ie=Se)})));if(typeof Ie<"u")throw Ie;return De}re.settled=L;function _(pe){return new Promise(async(Ie,De)=>{try{await pe(Ie,De)}catch(ye){De(ye)}})}re.withAsyncBody=_})(Z||(e.Promises=Z={}));var he;(function(re){re[re.Initial=0]="Initial",re[re.DoneOK=1]="DoneOK",re[re.DoneError=2]="DoneError"})(he||(he={}));class Ce{static fromArray(L){return new Ce(_=>{_.emitMany(L)})}static fromPromise(L){return new Ce(async _=>{_.emitMany(await L)})}static fromPromises(L){return new Ce(async _=>{await Promise.all(L.map(async pe=>_.emitOne(await pe)))})}static merge(L){return new Ce(async _=>{await Promise.all(L.map(async pe=>{for await(const Ie of pe)_.emitOne(Ie)}))})}static{this.EMPTY=Ce.fromArray([])}constructor(L){this.a=0,this.b=[],this.d=null,this.f=new C.$8c,queueMicrotask(async()=>{const _={emitOne:pe=>this.g(pe),emitMany:pe=>this.h(pe),reject:pe=>this.k(pe)};try{await Promise.resolve(L(_)),this.j()}catch(pe){this.k(pe)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(L<this.b.length)return{done:!1,value:this.b[L++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(L,_){return new Ce(async pe=>{for await(const Ie of L)pe.emitOne(_(Ie))})}map(L){return Ce.map(this,L)}static filter(L,_){return new Ce(async pe=>{for await(const Ie of L)_(Ie)&&pe.emitOne(Ie)})}filter(L){return Ce.filter(this,L)}static coalesce(L){return Ce.filter(L,_=>!!_)}coalesce(){return Ce.coalesce(this)}static async toPromise(L){const _=[];for await(const pe of L)_.push(pe);return _}toPromise(){return Ce.toPromise(this)}g(L){this.a===0&&(this.b.push(L),this.f.fire())}h(L){this.a===0&&(this.b=this.b.concat(L),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(L){this.a===0&&(this.a=2,this.d=L,this.f.fire())}}e.$Qg=Ce;class H extends Ce{constructor(L,_){super(_),this.l=L}cancel(){this.l.cancel()}}e.$Rg=H;function ne(re){const L=new w.$ed,_=re(L.token);return new H(L,async pe=>{const Ie=L.token.onCancellationRequested(()=>{Ie.dispose(),L.dispose(),pe.reject(new T.$3)});try{for await(const De of _){if(L.token.isCancellationRequested)return;pe.emitOne(De)}Ie.dispose(),L.dispose()}catch(De){Ie.dispose(),L.dispose(),pe.reject(De)}})}e.$Sg=ne}),define(Ae[37],Fe([1,0,18,16,42,28,19,22,15]),function($e,e,w,T,C,M,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=void 0;function p(){return Object.create(null)}e.$_i=p,e.$aj="**",e.$bj="/";const A="[/\\\\]",E="[^/\\\\]",c=/\//g;function y(be,Ee){switch(be){case 0:return"";case 1:return`${E}*?`;default:return`(?:${A}|${E}+${A}${Ee?`|${A}${E}+`:""})*?`}}function b(be,Ee){if(!be)return[];const Re=[];let Z=!1,he=!1,Ce="";for(const H of be){switch(H){case Ee:if(!Z&&!he){Re.push(Ce),Ce="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":he=!0;break;case"]":he=!1;break}Ce+=H}return Ce&&Re.push(Ce),Re}e.$cj=b;function o(be){if(!be)return"";let Ee="";const Re=b(be,e.$bj);if(Re.every(Z=>Z===e.$aj))Ee=".*";else{let Z=!1;Re.forEach((he,Ce)=>{if(he===e.$aj){if(Z)return;Ee+=y(2,Ce===Re.length-1)}else{let H=!1,ne="",re=!1,L="";for(const _ of he){if(_!=="}"&&H){ne+=_;continue}if(re&&(_!=="]"||!L)){let pe;_==="-"?pe=_:(_==="^"||_==="!")&&!L?pe="^":_===e.$bj?pe="":pe=(0,D.$od)(_),L+=pe;continue}switch(_){case"{":H=!0;continue;case"[":re=!0;continue;case"}":{const Ie=`(?:${b(ne,",").map(De=>o(De)).join("|")})`;Ee+=Ie,H=!1,ne="";break}case"]":{Ee+="["+L+"]",re=!1,L="";break}case"?":Ee+=E;continue;case"*":Ee+=y(1);continue;default:Ee+=(0,D.$od)(_)}}Ce<Re.length-1&&(Re[Ce+1]!==e.$aj||Ce+2<Re.length)&&(Ee+=A)}Z=he===e.$aj})}return Ee}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new M.$qi(1e4),h=function(){return!1},n=function(){return null};function s(be,Ee){if(!be)return n;let Re;typeof be!="string"?Re=be.pattern:Re=be,Re=Re.trim();const Z=`${Re}_${!!Ee.trimForExclusions}`;let he=r.get(Z);if(he)return $(he,be);let Ce;return t.test(Re)?he=l(Re.substr(4),Re):(Ce=i.exec(k(Re,Ee)))?he=f(Ce[1],Re):(Ee.trimForExclusions?m:a).test(Re)?he=v(Re,Ee):(Ce=S.exec(k(Re,Ee)))?he=u(Ce[1].substr(1),Re,!0):(Ce=I.exec(k(Re,Ee)))?he=u(Ce[1],Re,!1):he=d(Re),r.set(Z,he),$(he,be)}function $(be,Ee){if(typeof Ee=="string")return be;const Re=function(Z,he){return(0,C.$Ke)(Z,Ee.base,!g.$k)?be((0,D.$sd)(Z.substr(Ee.base.length),P.sep),he):null};return Re.allBasenames=be.allBasenames,Re.allPaths=be.allPaths,Re.basenames=be.basenames,Re.patterns=be.patterns,Re}function k(be,Ee){return Ee.trimForExclusions&&be.endsWith("/**")?be.substr(0,be.length-2):be}function l(be,Ee){return function(Re,Z){return typeof Re=="string"&&Re.endsWith(be)?Ee:null}}function f(be,Ee){const Re=`/${be}`,Z=`\\${be}`,he=function(H,ne){return typeof H!="string"?null:ne?ne===be?Ee:null:H===be||H.endsWith(Re)||H.endsWith(Z)?Ee:null},Ce=[be];return he.basenames=Ce,he.patterns=[Ee],he.allBasenames=Ce,he}function v(be,Ee){const Re=ce(be.slice(1,-1).split(",").map(ne=>s(ne,Ee)).filter(ne=>ne!==n),be),Z=Re.length;if(!Z)return n;if(Z===1)return Re[0];const he=function(ne,re){for(let L=0,_=Re.length;L<_;L++)if(Re[L](ne,re))return be;return null},Ce=Re.find(ne=>!!ne.allBasenames);Ce&&(he.allBasenames=Ce.allBasenames);const H=Re.reduce((ne,re)=>re.allPaths?ne.concat(re.allPaths):ne,[]);return H.length&&(he.allPaths=H),he}function u(be,Ee,Re){const Z=P.sep===P.$0b.sep,he=Z?be:be.replace(c,P.sep),Ce=P.sep+he,H=P.$0b.sep+be;let ne;return Re?ne=function(re,L){return typeof re=="string"&&(re===he||re.endsWith(Ce)||!Z&&(re===be||re.endsWith(H)))?Ee:null}:ne=function(re,L){return typeof re=="string"&&(re===he||!Z&&re===be)?Ee:null},ne.allPaths=[(Re?"*/":"./")+be],ne}function d(be){try{const Ee=new RegExp(`^${o(be)}$`);return function(Re){return Ee.lastIndex=0,typeof Re=="string"&&Ee.test(Re)?be:null}}catch{return n}}function R(be,Ee,Re){return!be||typeof Ee!="string"?!1:W(be)(Ee,void 0,Re)}e.$dj=R;function W(be,Ee={}){if(!be)return h;if(typeof be=="string"||B(be)){const Re=s(be,Ee);if(Re===n)return h;const Z=function(he,Ce){return!!Re(he,Ce)};return Re.allBasenames&&(Z.allBasenames=Re.allBasenames),Re.allPaths&&(Z.allPaths=Re.allPaths),Z}return N(be,Ee)}e.$ej=W;function B(be){const Ee=be;return Ee?typeof Ee.base=="string"&&typeof Ee.pattern=="string":!1}e.$fj=B;function q(be){return be.allBasenames||[]}e.$gj=q;function U(be){return be.allPaths||[]}e.$hj=U;function N(be,Ee){const Re=ce(Object.getOwnPropertyNames(be).map(ne=>O(ne,be[ne],Ee)).filter(ne=>ne!==n)),Z=Re.length;if(!Z)return n;if(!Re.some(ne=>!!ne.requiresSiblings)){if(Z===1)return Re[0];const ne=function(_,pe){let Ie;for(let De=0,ye=Re.length;De<ye;De++){const Se=Re[De](_,pe);if(typeof Se=="string")return Se;(0,T.$ig)(Se)&&(Ie||(Ie=[]),Ie.push(Se))}return Ie?(async()=>{for(const De of Ie){const ye=await De;if(typeof ye=="string")return ye}return null})():null},re=Re.find(_=>!!_.allBasenames);re&&(ne.allBasenames=re.allBasenames);const L=Re.reduce((_,pe)=>pe.allPaths?_.concat(pe.allPaths):_,[]);return L.length&&(ne.allPaths=L),ne}const he=function(ne,re,L){let _,pe;for(let Ie=0,De=Re.length;Ie<De;Ie++){const ye=Re[Ie];ye.requiresSiblings&&L&&(re||(re=(0,P.$ec)(ne)),_||(_=re.substr(0,re.length-(0,P.$fc)(ne).length)));const Se=ye(ne,re,_,L);if(typeof Se=="string")return Se;(0,T.$ig)(Se)&&(pe||(pe=[]),pe.push(Se))}return pe?(async()=>{for(const Ie of pe){const De=await Ie;if(typeof De=="string")return De}return null})():null},Ce=Re.find(ne=>!!ne.allBasenames);Ce&&(he.allBasenames=Ce.allBasenames);const H=Re.reduce((ne,re)=>re.allPaths?ne.concat(re.allPaths):ne,[]);return H.length&&(he.allPaths=H),he}function O(be,Ee,Re){if(Ee===!1)return n;const Z=s(be,Re);if(Z===n)return n;if(typeof Ee=="boolean")return Z;if(Ee){const he=Ee.when;if(typeof he=="string"){const Ce=(H,ne,re,L)=>{if(!L||!Z(H,ne))return null;const _=he.replace("$(basename)",()=>re),pe=L(_);return(0,T.$ig)(pe)?pe.then(Ie=>Ie?be:null):pe?be:null};return Ce.requiresSiblings=!0,Ce}}return Z}function ce(be,Ee){const Re=be.filter(ne=>!!ne.basenames);if(Re.length<2)return be;const Z=Re.reduce((ne,re)=>{const L=re.basenames;return L?ne.concat(L):ne},[]);let he;if(Ee){he=[];for(let ne=0,re=Z.length;ne<re;ne++)he.push(Ee)}else he=Re.reduce((ne,re)=>{const L=re.patterns;return L?ne.concat(L):ne},[]);const Ce=function(ne,re){if(typeof ne!="string")return null;if(!re){let _;for(_=ne.length;_>0;_--){const pe=ne.charCodeAt(_-1);if(pe===47||pe===92)break}re=ne.substr(_)}const L=Z.indexOf(re);return L!==-1?he[L]:null};Ce.basenames=Z,Ce.patterns=he,Ce.allBasenames=Z;const H=be.filter(ne=>!ne.basenames);return H.push(Ce),H}function X(be,Ee){return(0,w.$bf)(be,Ee,(Re,Z)=>typeof Re=="string"&&typeof Z=="string"?Re===Z:typeof Re!="string"&&typeof Z!="string"?Re.base===Z.base&&Re.pattern===Z.pattern:!1)}e.$ij=X}),define(Ae[49],Fe([1,0,11,121,23,15,2]),function($e,e,w,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(g||(e.MarkdownStringTextNewlineStyle=g={}));class D{constructor(i="",a=!1){if(this.value=i,typeof this.value!="string")throw(0,w.$5)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(i,a=0){return this.value+=c(this.supportThemeIcons?(0,T.$Ej)(i):i).replace(/([ \t]+)/g,(m,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,a){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}appendLink(i,a,m){return this.value+="[",this.value+=this.c(a,"]"),this.value+="](",this.value+=this.c(String(i),")"),m&&(this.value+=` "${this.c(this.c(m,'"'),")")}"`),this.value+=")",this}c(i,a){const m=new RegExp((0,M.$od)(a),"g");return i.replace(m,(S,I)=>i.charAt(I-1)!=="\\"?`\\${S}`:S)}}e.$Kj=D;function p(t){return A(t)?!t.value:Array.isArray(t)?t.every(p):!0}e.$Lj=p;function A(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$Mj=A;function E(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,C.$3f)(P.URI.from(t.baseUri),P.URI.from(i.baseUri)))}e.$Nj=E;function c(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Oj=c;function y(t){return t.replace(/"/g,"&quot;")}e.$Pj=y;function b(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Qj=b;function o(t){const i=[],a=t.split("|").map(S=>S.trim());t=a[0];const m=a[1];if(m){const S=/height=(\d+)/.exec(m),I=/width=(\d+)/.exec(m),r=S?S[1]:"",h=I?I[1]:"",n=isFinite(parseInt(h)),s=isFinite(parseInt(r));n&&i.push(`width="${h}"`),s&&i.push(`height="${r}"`)}return{href:t,dimensions:i}}e.$Rj=o}),define(Ae[89],Fe([1,0,18,42,19,22,23,15]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9z=e.$8z=e.$7z=e.$6z=e.$5z=e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=void 0;function D(s,$){const{os:k,tildify:l,relative:f}=$;if(f){const d=p(s,f,k);if(typeof d=="string")return d}let v=s.fsPath;if(k===1&&!M.$i?v=v.replace(/\//g,"\\"):k!==1&&M.$i&&(v=v.replace(/\\/g,"/")),k!==1&&l?.userHome){const d=l.userHome.fsPath;let R;s.scheme!==l.userHome.scheme&&s.path.startsWith(C.$0b.sep)?R=l.userHome.with({path:s.path}).fsPath:R=s.fsPath,v=c(R,d,k)}return(k===1?C.$9b:C.$0b).normalize(A(v,k===1))}e.$Zz=D;function p(s,$,k){const l=k===1?C.$9b:C.$0b,f=k===3?P.$Zf:P.$2f,v=$.getWorkspace(),u=(0,w.$vf)(v.folders);if(!u)return;s.scheme!==u.uri.scheme&&s.path.startsWith(C.$0b.sep)&&(s=u.uri.with({path:s.path}));const d=$.getWorkspaceFolder(s);if(!d)return;let R;if(f.isEqual(d.uri,s)?R="":R=f.relativePath(d.uri,s)??"",R&&(R=l.normalize(R)),v.folders.length>1&&!$.noPrefix){const W=d.name?d.name:f.basenameOrAuthority(d.uri);R=R?`${W} \u2022 ${R}`:W}return R}function A(s,$=M.$i){return(0,T.$Oe)(s,$)?s.charAt(0).toUpperCase()+s.slice(1):s}e.$1z=A;let E=Object.create(null);function c(s,$,k=M.OS){if(k===1||!s||!$)return s;let l=E.original===$?E.normalized:void 0;l||(l=$,M.$i&&(l=(0,T.$Ee)(l)),l=`${(0,g.$td)(l,C.$0b.sep)}${C.$0b.sep}`,E={original:$,normalized:l});let f=s;return M.$i&&(f=(0,T.$Ee)(f)),(k===3?f.startsWith(l):(0,g.$Nd)(f,l))?`~/${f.substr(l.length)}`:s}e.$2z=c;function y(s,$){return s.replace(/^~($|\/|\\)/,`${$}$1`)}e.$3z=y;const b="\u2026",o="\\\\",t="~";function i(s,$=C.sep){const k=new Array(s.length);let l=!1;for(let f=0;f<s.length;f++){const v=s[f];if(v===""){k[f]=`.${$}`;continue}if(!v){k[f]=v;continue}l=!0;let u="",d=v;d.indexOf(o)===0?(u=d.substr(0,d.indexOf(o)+o.length),d=d.substr(d.indexOf(o)+o.length)):d.indexOf($)===0?(u=d.substr(0,d.indexOf($)+$.length),d=d.substr(d.indexOf($)+$.length)):d.indexOf(t)===0&&(u=d.substr(0,d.indexOf(t)+t.length),d=d.substr(d.indexOf(t)+t.length));const R=d.split($);for(let W=1;l&&W<=R.length;W++)for(let B=R.length-W;l&&B>=0;B--){l=!1;let q=R.slice(B,B+W).join($);for(let U=0;!l&&U<s.length;U++)if(U!==f&&s[U]&&s[U].indexOf(q)>-1){const N=B+W===R.length,O=B>0&&s[U].indexOf($)>-1?$+q:q,ce=s[U].endsWith(O);l=!N||ce}if(!l){let U="";(R[0].endsWith(":")||u!=="")&&(B===1&&(B=0,W++,q=R[0]+$+q),B>0&&(U=R[0]+$),U=u+U),B>0&&(U=U+b+$),U=U+q,B+W<R.length&&(U=U+$+b),k[f]=U}}l&&(k[f]=v)}return k}e.$4z=i;var a;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function m(s,$=Object.create(null)){const k=[];let l=!1,f="";for(const v of s)if(v==="$"||l&&v==="{")f&&k.push({value:f,type:a.TEXT}),f="",l=!0;else if(v==="}"&&l){const u=$[f];if(typeof u=="string")u.length&&k.push({value:u,type:a.VARIABLE});else if(u){const d=k[k.length-1];(!d||d.type!==a.SEPARATOR)&&k.push({value:u.label,type:a.SEPARATOR})}f="",l=!1}else f+=v;return f&&!l&&k.push({value:f,type:a.TEXT}),k.filter((v,u)=>{if(v.type===a.SEPARATOR){const d=k[u-1],R=k[u+1];return[d,R].every(W=>W&&(W.type===a.VARIABLE||W.type===a.TEXT)&&W.value.length>0)}return!0}).map(v=>v.value).join("")}e.$5z=m;function S(s,$){return M.$j||$?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):s.replace(/&&|&/g,k=>k==="&"?"&&":"&")}e.$6z=S;function I(s,$){return M.$j||$?s.replace(/\(&&\w\)|&&/g,""):M.$i?s.replace(/&&|&/g,k=>k==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.$7z=I;function r(s){return s.replace(/&/g,"&&")}e.$8z=r;function h(s){if(s.endsWith("]")){const $=s.lastIndexOf(" [",s.length-2);if($!==-1){const k=n(s.substring(0,$));return{name:k.name,parentPath:k.parentPath+s.substring($)}}}return n(s)}e.$9z=h;function n(s){const $=s.indexOf("/")!==-1?C.$0b:C.$9b,k=$.basename(s),l=$.dirname(s);return k.length?{name:k,parentPath:l}:{name:l,parentPath:""}}}),define(Ae[132],Fe([1,0,25,2]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=e.$om=e.$nm=void 0;function C(E){return E.toJSON()}class M{constructor(c){this.a=c}transformIncoming(c){const y=this.a.transformIncoming(c);return y===c?c:C(T.URI.from(y))}transformOutgoing(c){const y=this.a.transformOutgoing(c);return y===c?c:C(T.URI.from(y))}transformOutgoingURI(c){const y=this.a.transformOutgoing(c);return y===c?c:T.URI.from(y)}transformOutgoingScheme(c){return this.a.transformOutgoingScheme(c)}}e.$nm=M,e.$om=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function P(E,c,y){if(!E||y>200)return null;if(typeof E=="object"){if(E instanceof T.URI)return c.transformOutgoing(E);for(const b in E)if(Object.hasOwnProperty.call(E,b)){const o=P(E[b],c,y+1);o!==null&&(E[b]=o)}}return null}function g(E,c){const y=P(E,c,0);return y===null?E:y}e.$pm=g;function D(E,c,y,b){if(!E||b>200)return null;if(typeof E=="object"){if(E.$mid===1)return y?T.URI.revive(c.transformIncoming(E)):c.transformIncoming(E);if(E instanceof w.$Jb)return null;for(const o in E)if(Object.hasOwnProperty.call(E,o)){const t=D(E[o],c,y,b+1);t!==null&&(E[o]=t)}}return null}function p(E,c){const y=D(E,c,!1,0);return y===null?E:y}e.$qm=p;function A(E,c){const y=D(E,c,!0,0);return y===null?E:y}e.$rm=A}),define(Ae[133],Fe([1,0,37,19]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YE=void 0;function C(M,P,g,D,p,A){if(Array.isArray(M)){let E=0;for(const c of M){const y=C(c,P,g,D,p,A);if(y===10)return y;y>E&&(E=y)}return E}else{if(typeof M=="string")return D?M==="*"?5:M===g?10:0:0;if(M){const{language:E,pattern:c,scheme:y,hasAccessToAllModels:b,notebookType:o}=M;if(!D&&!b)return 0;o&&p&&(P=p);let t=0;if(y)if(y===P.scheme)t=10;else if(y==="*")t=5;else return 0;if(E)if(E===g)t=10;else if(E==="*")t=Math.max(t,5);else return 0;if(o)if(o===A)t=10;else if(o==="*"&&A!==void 0)t=Math.max(t,5);else return 0;if(c){let i;if(typeof c=="string"?i=c:i={...c,base:(0,T.$$b)(c.base)},i===P.fsPath||(0,w.$dj)(i,P.fsPath))t=10;else return 0}return t}else return 0}}e.$YE=C}),define(Ae[90],Fe([1,0,25,22]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H8=e.$G8=void 0;var C;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(C||(C={}));function M(E){for(let c=0,y=E.length;c<y;c+=4){const b=E[c+0],o=E[c+1],t=E[c+2],i=E[c+3];E[c+0]=i,E[c+1]=t,E[c+2]=o,E[c+3]=b}}function P(E){const c=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return T.$C()||M(c),w.$Jb.wrap(c)}function g(E){const c=E.buffer;if(T.$C()||M(c),c.byteOffset%4===0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const y=new Uint8Array(c.byteLength);return y.set(c),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function D(E){const c=new Uint32Array(p(E));let y=0;if(c[y++]=E.id,E.type==="full")c[y++]=1,c[y++]=E.data.length,c.set(E.data,y),y+=E.data.length;else{c[y++]=2,c[y++]=E.deltas.length;for(const b of E.deltas)c[y++]=b.start,c[y++]=b.deleteCount,b.data?(c[y++]=b.data.length,c.set(b.data,y),y+=b.data.length):c[y++]=0}return P(c)}e.$G8=D;function p(E){let c=0;if(c+=1+1,E.type==="full")c+=1+E.data.length;else{c+=1,c+=(1+1+1)*E.deltas.length;for(const y of E.deltas)y.data&&(c+=y.data.length)}return c}function A(E){const c=g(E);let y=0;const b=c[y++];if(c[y++]===1){const a=c[y++],m=c.subarray(y,y+a);return y+=a,{id:b,type:"full",data:m}}const t=c[y++],i=[];for(let a=0;a<t;a++){const m=c[y++],S=c[y++],I=c[y++];let r;I>0&&(r=c.subarray(y,y+I),y+=I),i[a]={start:m,deleteCount:S,data:r}}return{id:b,type:"delta",deltas:i}}e.$H8=A}),define(Ae[134],Fe([9,10]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(Ae[135],Fe([1,0,18,24,22,123,136,134]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(x){x[x.None=0]="None",x[x.Keep=1]="Keep",x[x.Brackets=2]="Brackets",x[x.Advanced=3]="Advanced",x[x.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class p{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=p;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class E{constructor(Y,ge,je,Me){this.id=Y,this.name=ge,this.defaultValue=je,this.schema=Me}applyUpdate(Y,ge){return y(Y,ge)}compute(Y,ge,je){return je}}class c{constructor(Y,ge){this.newValue=Y,this.didChange=ge}}e.ApplyUpdateResult=c;function y(x,Y){if(typeof x!="object"||typeof Y!="object"||!x||!Y)return new c(Y,x!==Y);if(Array.isArray(x)||Array.isArray(Y)){const je=Array.isArray(x)&&Array.isArray(Y)&&w.$bf(x,Y);return new c(Y,!je)}let ge=!1;for(const je in Y)if(Y.hasOwnProperty(je)){const Me=y(x[je],Y[je]);Me.didChange&&(x[je]=Me.newValue,ge=!0)}return new c(x,ge)}class b{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,ge){return y(Y,ge)}validate(Y){return this.defaultValue}}class o{constructor(Y,ge,je,Me){this.id=Y,this.name=ge,this.defaultValue=je,this.schema=Me}applyUpdate(Y,ge){return y(Y,ge)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,ge,je){return je}}function t(x,Y){return typeof x>"u"?Y:x==="false"?!1:!!x}e.boolean=t;class i extends o{constructor(Y,ge,je,Me=void 0){typeof Me<"u"&&(Me.type="boolean",Me.default=je),super(Y,ge,je,Me)}validate(Y){return t(Y,this.defaultValue)}}function a(x,Y,ge,je){if(typeof x>"u")return Y;let Me=parseInt(x,10);return isNaN(Me)?Y:(Me=Math.max(ge,Me),Me=Math.min(je,Me),Me|0)}e.clampedInt=a;class m extends o{static clampedInt(Y,ge,je,Me){return a(Y,ge,je,Me)}constructor(Y,ge,je,Me,Ze,et=void 0){typeof et<"u"&&(et.type="integer",et.default=je,et.minimum=Me,et.maximum=Ze),super(Y,ge,je,et),this.minimum=Me,this.maximum=Ze}validate(Y){return m.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function S(x,Y,ge,je){if(typeof x>"u")return Y;const Me=I.float(x,Y);return I.clamp(Me,ge,je)}e.clampedFloat=S;class I extends o{static clamp(Y,ge,je){return Y<ge?ge:Y>je?je:Y}static float(Y,ge){if(typeof Y=="number")return Y;if(typeof Y>"u")return ge;const je=parseFloat(Y);return isNaN(je)?ge:je}constructor(Y,ge,je,Me,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=je),super(Y,ge,je,Ze),this.validationFn=Me}validate(Y){return this.validationFn(I.float(Y,this.defaultValue))}}class r extends o{static string(Y,ge){return typeof Y!="string"?ge:Y}constructor(Y,ge,je,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.default=je),super(Y,ge,je,Me)}validate(Y){return r.string(Y,this.defaultValue)}}function h(x,Y,ge,je){return typeof x!="string"?Y:je&&x in je?je[x]:ge.indexOf(x)===-1?Y:x}e.stringSet=h;class n extends o{constructor(Y,ge,je,Me,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Me,Ze.default=je),super(Y,ge,je,Ze),this.c=Me}validate(Y){return h(Y,this.defaultValue,this.c)}}class s extends E{constructor(Y,ge,je,Me,Ze,et,gt=void 0){typeof gt<"u"&&(gt.type="string",gt.enum=Ze,gt.default=Me),super(Y,ge,je,gt),this.c=Ze,this.d=et}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function $(x){switch(x){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class k extends E{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",tags:["accessibility"],description:g.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,ge,je){return je===0?Y.accessibilitySupport:je}}class l extends E{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(22,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:g.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{insertSpace:t(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var f;(function(x){x[x.Hidden=0]="Hidden",x[x.Blink=1]="Blink",x[x.Smooth=2]="Smooth",x[x.Phase=3]="Phase",x[x.Expand=4]="Expand",x[x.Solid=5]="Solid"})(f||(e.TextEditorCursorBlinkingStyle=f={}));function v(x){switch(x){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(x){x[x.Line=1]="Line",x[x.Block=2]="Block",x[x.Underline=3]="Underline",x[x.LineThin=4]="LineThin",x[x.BlockOutline=5]="BlockOutline",x[x.UnderlineThin=6]="UnderlineThin"})(u||(e.TextEditorCursorStyle=u={}));function d(x){switch(x){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function R(x){switch(x){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class W extends b{constructor(){super(139)}compute(Y,ge,je){const Me=["monaco-editor"];return ge.get(38)&&Me.push(ge.get(38)),Y.extraEditorClassName&&Me.push(Y.extraEditorClassName),ge.get(72)==="default"?Me.push("mouse-default"):ge.get(72)==="copy"&&Me.push("mouse-copy"),ge.get(109)&&Me.push("showUnused"),ge.get(137)&&Me.push("showDeprecated"),Me.join(" ")}}class B extends i{constructor(){super(36,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(Y,ge,je){return je&&Y.emptySelectionClipboard}}class q extends E{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(40,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:g.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:g.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{cursorMoveOnType:t(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":h(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":h(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(ge.loop,this.defaultValue.loop)}}}class U extends E{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(50,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?U.OFF:Y==="true"?U.ON:Y:Y?U.ON:U.OFF}}e.EditorFontLigatures=U;class N extends E{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(53,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:g.localize(22,null)},{type:"string",description:g.localize(23,null)}],description:g.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?N.OFF:Y==="true"?N.TRANSLATE:Y:Y?N.TRANSLATE:N.OFF}compute(Y,ge,je){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class O extends b{constructor(){super(49)}compute(Y,ge,je){return Y.fontInfo}}class ce extends o{constructor(){super(51,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(25,null)})}validate(Y){const ge=I.float(Y,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:I.clamp(ge,6,100)}compute(Y,ge,je){return Y.fontInfo.fontSize}}class X extends E{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(52,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:g.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(m.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}class be extends E{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[g.localize(28,null),g.localize(29,null),g.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(57,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:g.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:g.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:g.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:je,description:g.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:je,description:g.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:je,description:g.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:je,description:g.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:je,description:g.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{multiple:h(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??h(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??h(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??h(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??h(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??h(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Ee extends E{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(59,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:g.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:g.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:g.localize(44,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:g.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:t(ge.enabled,this.defaultValue.enabled),delay:m.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:t(ge.sticky,this.defaultValue.sticky),above:t(ge.above,this.defaultValue.above)}}}var Re;(function(x){x[x.None=0]="None",x[x.Text=1]="Text",x[x.Blocks=2]="Blocks"})(Re||(e.RenderMinimap=Re={}));class Z extends b{constructor(){super(142)}compute(Y,ge,je){return Z.computeLayout(ge,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const ge=Y.height/Y.lineHeight,je=Math.floor(Y.paddingTop/Y.lineHeight);let Me=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(Me=Math.max(Me,ge-1));const Ze=(je+Y.viewLineCount+Me)/(Y.pixelRatio*Y.height),et=Math.floor(Y.viewLineCount/Ze);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Me,desiredRatio:Ze,minimapLineCount:et}}static c(Y,ge){const je=Y.outerWidth,Me=Y.outerHeight,Ze=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Me),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Me};const et=ge.stableMinimapLayoutInput,gt=et&&Y.outerHeight===et.outerHeight&&Y.lineHeight===et.lineHeight&&Y.typicalHalfwidthCharacterWidth===et.typicalHalfwidthCharacterWidth&&Y.pixelRatio===et.pixelRatio&&Y.scrollBeyondLastLine===et.scrollBeyondLastLine&&Y.paddingTop===et.paddingTop&&Y.paddingBottom===et.paddingBottom&&Y.minimap.enabled===et.minimap.enabled&&Y.minimap.side===et.minimap.side&&Y.minimap.size===et.minimap.size&&Y.minimap.showSlider===et.minimap.showSlider&&Y.minimap.renderCharacters===et.minimap.renderCharacters&&Y.minimap.maxColumn===et.minimap.maxColumn&&Y.minimap.scale===et.minimap.scale&&Y.verticalScrollbarWidth===et.verticalScrollbarWidth&&Y.isViewportWrapping===et.isViewportWrapping,wt=Y.lineHeight,Nt=Y.typicalHalfwidthCharacterWidth,Jt=Y.scrollBeyondLastLine,Wt=Y.minimap.renderCharacters;let yt=Ze>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const At=Y.minimap.maxColumn,Ft=Y.minimap.size,zt=Y.minimap.side,Ut=Y.verticalScrollbarWidth,Lt=Y.viewLineCount,st=Y.remainingWidth,ht=Y.isViewportWrapping,jt=Wt?2:3;let Tt=Math.floor(Ze*Me);const Dt=Tt/Ze;let ot=!1,Pt=!1,Mt=jt*yt,Pe=yt/Ze,we=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:_e,extraLinesBeforeFirstLine:bt,extraLinesBeyondLastLine:kt,desiredRatio:St,minimapLineCount:pt}=Z.computeContainedMinimapLineCount({viewLineCount:Lt,scrollBeyondLastLine:Jt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:Me,lineHeight:wt,pixelRatio:Ze});if(Lt/pt>1)ot=!0,Pt=!0,yt=1,Mt=1,Pe=yt/Ze;else{let lt=!1,$t=yt+1;if(Ft==="fit"){const ft=Math.ceil((bt+Lt+kt)*Mt);ht&&gt&&st<=ge.stableFitRemainingWidth?(lt=!0,$t=ge.stableFitMaxMinimapScale):lt=ft>Tt}if(Ft==="fill"||lt){ot=!0;const ft=yt;Mt=Math.min(wt*Ze,Math.max(1,Math.floor(1/St))),ht&&gt&&st<=ge.stableFitRemainingWidth&&($t=ge.stableFitMaxMinimapScale),yt=Math.min($t,Math.max(1,Math.floor(Mt/jt))),yt>ft&&(we=Math.min(2,yt/ft)),Pe=yt/Ze/we,Tt=Math.ceil(Math.max(_e,bt+Lt+kt)*Mt),ht?(ge.stableMinimapLayoutInput=Y,ge.stableFitRemainingWidth=st,ge.stableFitMaxMinimapScale=yt):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const ve=Math.floor(At*Pe),Q=Math.min(ve,Math.max(0,Math.floor((st-Ut-2)*Pe/(Nt+Pe)))+e.MINIMAP_GUTTER_WIDTH);let Le=Math.floor(Ze*Q);const Ue=Le/Ze;Le=Math.floor(Le*we);const He=Wt?1:2,We=zt==="left"?0:je-Q-Ut;return{renderMinimap:He,minimapLeft:We,minimapWidth:Q,minimapHeightIsEditorHeight:ot,minimapIsSampling:Pt,minimapScale:yt,minimapLineHeight:Mt,minimapCanvasInnerWidth:Le,minimapCanvasInnerHeight:Tt,minimapCanvasOuterWidth:Ue,minimapCanvasOuterHeight:Dt}}static computeLayout(Y,ge){const je=ge.outerWidth|0,Me=ge.outerHeight|0,Ze=ge.lineHeight|0,et=ge.lineNumbersDigitCount|0,gt=ge.typicalHalfwidthCharacterWidth,wt=ge.maxDigitWidth,Nt=ge.pixelRatio,Jt=ge.viewLineCount,Wt=Y.get(134),yt=Wt==="inherit"?Y.get(133):Wt,At=yt==="inherit"?Y.get(129):yt,Ft=Y.get(132),zt=ge.isDominatedByLongLines,Ut=Y.get(56),Lt=Y.get(66).renderType!==0,st=Y.get(67),ht=Y.get(103),jt=Y.get(82),Tt=Y.get(71),Dt=Y.get(101),ot=Dt.verticalScrollbarSize,Pt=Dt.verticalHasArrows,Mt=Dt.arrowSize,Pe=Dt.horizontalScrollbarSize,we=Y.get(42),ve=Y.get(108)!=="never";let Q=Y.get(64);we&&ve&&(Q+=16);let Le=0;if(Lt){const Bt=Math.max(et,st);Le=Math.round(Bt*wt)}let Ue=0;Ut&&(Ue=Ze*ge.glyphMarginDecorationLaneCount);let He=0,We=He+Ue,_e=We+Le,bt=_e+Q;const kt=je-Ue-Le-Q;let St=!1,pt=!1,mt=-1;yt==="inherit"&&zt?(St=!0,pt=!0):At==="on"||At==="bounded"?pt=!0:At==="wordWrapColumn"&&(mt=Ft);const lt=Z.c({outerWidth:je,outerHeight:Me,lineHeight:Ze,typicalHalfwidthCharacterWidth:gt,pixelRatio:Nt,scrollBeyondLastLine:ht,paddingTop:jt.top,paddingBottom:jt.bottom,minimap:Tt,verticalScrollbarWidth:ot,viewLineCount:Jt,remainingWidth:kt,isViewportWrapping:pt},ge.memory||new A);lt.renderMinimap!==0&&lt.minimapLeft===0&&(He+=lt.minimapWidth,We+=lt.minimapWidth,_e+=lt.minimapWidth,bt+=lt.minimapWidth);const $t=kt-lt.minimapWidth,ft=Math.max(1,Math.floor(($t-ot-2)/gt)),Yt=Pt?Mt:0;return pt&&(mt=Math.max(1,ft),At==="bounded"&&(mt=Math.min(mt,Ft))),{width:je,height:Me,glyphMarginLeft:He,glyphMarginWidth:Ue,glyphMarginDecorationLaneCount:ge.glyphMarginDecorationLaneCount,lineNumbersLeft:We,lineNumbersWidth:Le,decorationsLeft:_e,decorationsWidth:Q,contentLeft:bt,contentWidth:$t,minimap:lt,viewportColumn:ft,isWordWrapMinified:St,isViewportWrapping:pt,wrappingColumn:mt,verticalScrollbarWidth:ot,horizontalScrollbarHeight:Pe,overviewRuler:{top:Yt,width:ot,height:Me-2*Yt,right:0}}}}e.EditorLayoutInfoComputer=Z;class he extends E{constructor(){super(136,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[g.localize(46,null),g.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:g.localize(48,null)}})}validate(Y){return h(Y,"simple",["simple","advanced"])}compute(Y,ge,je){return ge.get(2)===2?"advanced":je}}class Ce extends E{constructor(){const Y={enabled:!0};super(63,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:g.localize(49,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:t(Y.enabled,this.defaultValue.enabled)}}}class H extends E{constructor(){const Y={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(113,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:g.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:g.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:g.localize(52,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:t(ge.enabled,this.defaultValue.enabled),maxLineCount:m.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:h(ge.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class ne extends E{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(138,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:g.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[g.localize(54,null),g.localize(55,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),g.localize(56,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),g.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:g.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:g.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:g.localize(60,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:h(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:m.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(ge.fontFamily,this.defaultValue.fontFamily),padding:t(ge.padding,this.defaultValue.padding)}}}class re extends E{constructor(){super(64,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):m.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,ge,je){return je<0?m.clampedInt(-je*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class L extends I{constructor(){super(65,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>I.clamp(Y,0,150),{markdownDescription:g.localize(61,null)})}compute(Y,ge,je){return Y.fontInfo.lineHeight}}class _ extends E{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(71,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:g.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:g.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(64,null),g.localize(65,null),g.localize(66,null)],default:Y.size,description:g.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:g.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:g.localize(69,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:g.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:g.localize(72,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:t(ge.enabled,this.defaultValue.enabled),autohide:t(ge.autohide,this.defaultValue.autohide),size:h(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(ge.side,this.defaultValue.side,["right","left"]),showSlider:h(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(ge.renderCharacters,this.defaultValue.renderCharacters),scale:m.clampedInt(ge.scale,1,1,3),maxColumn:m.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function pe(x){return x==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class Ie extends E{constructor(){super(82,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(74,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{top:m.clampedInt(ge.top,0,0,1e3),bottom:m.clampedInt(ge.bottom,0,0,1e3)}}}class De extends E{constructor(){const Y={enabled:!0,cycle:!0};super(84,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:g.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:g.localize(76,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:t(ge.enabled,this.defaultValue.enabled),cycle:t(ge.cycle,this.defaultValue.cycle)}}}class ye extends b{constructor(){super(140)}compute(Y,ge,je){return Y.pixelRatio}}class Se extends E{constructor(){const Y={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[g.localize(77,null),g.localize(78,null),g.localize(79,null)]}];super(87,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:Y.strings,description:g.localize(80,null)},comments:{anyOf:ge,default:Y.comments,description:g.localize(81,null)},other:{anyOf:ge,default:Y.other,description:g.localize(82,null)}},default:Y,markdownDescription:g.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const Nt=Y?"on":"off";return{comments:Nt,strings:Nt,other:Nt}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:ge,comments:je,strings:Me}=Y,Ze=["on","inline","off"];let et,gt,wt;return typeof ge=="boolean"?et=ge?"on":"off":et=h(ge,this.defaultValue.other,Ze),typeof je=="boolean"?gt=je?"on":"off":gt=h(je,this.defaultValue.comments,Ze),typeof Me=="boolean"?wt=Me?"on":"off":wt=h(Me,this.defaultValue.strings,Ze),{other:et,comments:gt,strings:wt}}}var oe;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative",x[x.Interval=3]="Interval",x[x.Custom=4]="Custom"})(oe||(e.RenderLineNumbersType=oe={}));class de extends E{constructor(){super(66,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(84,null),g.localize(85,null),g.localize(86,null),g.localize(87,null)],default:"on",description:g.localize(88,null)})}validate(Y){let ge=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(ge=4,je=Y):Y==="interval"?ge=3:Y==="relative"?ge=2:Y==="on"?ge=1:ge=0),{renderType:ge,renderFn:je}}}function ee(x){const Y=x.get(96);return Y==="editable"?x.get(89):Y!=="on"}e.filterValidationDecorations=ee;class ie extends E{constructor(){const Y=[],ge={type:"number",description:g.localize(89,null)};super(100,"rulers",Y,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:g.localize(90,null),format:"color-hex"}}}]},default:Y,description:g.localize(91,null)})}validate(Y){if(Array.isArray(Y)){const ge=[];for(const je of Y)if(typeof je=="number")ge.push({column:m.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Me=je;ge.push({column:m.clampedInt(Me.column,0,0,1e4),color:Me.color})}return ge.sort((je,Me)=>je.column-Me.column),ge}return this.defaultValue}}class le extends E{constructor(){super(90,"readOnlyMessage",void 0)}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:Y}}function F(x,Y){if(typeof x!="string")return Y;switch(x){case"hidden":return 2;case"visible":return 3;default:return 1}}class V extends E{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(101,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(92,null),g.localize(93,null),g.localize(94,null)],default:"auto",description:g.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(96,null),g.localize(97,null),g.localize(98,null)],default:"auto",description:g.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:g.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:g.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:g.localize(102,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y,je=m.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Me=m.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:m.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:F(ge.vertical,this.defaultValue.vertical),horizontal:F(ge.horizontal,this.defaultValue.horizontal),useShadows:t(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:m.clampedInt(ge.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Me,verticalSliderSize:m.clampedInt(ge.verticalSliderSize,Me,0,1e3),scrollByPage:t(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends E{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(123,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:g.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:g.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:g.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:g.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:g.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:g.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:g.localize(109,null)}})}applyUpdate(Y,ge){let je=!1;ge.allowedCharacters&&Y&&(T.$Lm(Y.allowedCharacters,ge.allowedCharacters)||(Y={...Y,allowedCharacters:ge.allowedCharacters},je=!0)),ge.allowedLocales&&Y&&(T.$Lm(Y.allowedLocales,ge.allowedLocales)||(Y={...Y,allowedLocales:ge.allowedLocales},je=!0));const Me=super.applyUpdate(Y,ge);return je?new c(Me.newValue,!0):Me}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{nonBasicASCII:ue(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ue(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ue(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,ge){if(typeof Y!="object"||!Y)return ge;const je={};for(const[Me,Ze]of Object.entries(Y))Ze===!0&&(je[Me]=!0);return je}}class K extends E{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(61,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:g.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover"],enumDescriptions:[g.localize(111,null),g.localize(112,null)],description:g.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:g.localize(114,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:t(ge.enabled,this.defaultValue.enabled),mode:h(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(ge.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(ge.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(ge.keepOnBlur,this.defaultValue.keepOnBlur)}}}class ae extends E{constructor(){const Y={enabled:M.$Hr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$Hr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(14,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:g.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:g.localize(116,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:t(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class G extends E{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(15,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(117,null),g.localize(118,null),g.localize(119,null)],default:Y.bracketPairs,description:g.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(121,null),g.localize(122,null),g.localize(123,null)],default:Y.bracketPairsHorizontal,description:g.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:g.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:g.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[g.localize(127,null),g.localize(128,null),g.localize(129,null)],default:Y.highlightActiveIndentation,description:g.localize(130,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{bracketPairs:ue(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ue(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:ue(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ue(x,Y,ge){const je=ge.indexOf(x);return je===-1?Y:ge[je]}class me extends E{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(116,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(131,null),g.localize(132,null)],default:Y.insertMode,description:g.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:g.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:g.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:g.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[g.localize(137,null),g.localize(138,null),g.localize(139,null),g.localize(140,null)],default:Y.selectionMode,markdownDescription:g.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:g.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:g.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:g.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:g.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:g.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:g.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(178,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{insertMode:h(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(ge.showIcons,this.defaultValue.showIcons),showStatusBar:t(ge.showStatusBar,this.defaultValue.showStatusBar),preview:t(ge.preview,this.defaultValue.preview),previewMode:h(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(ge.showMethods,this.defaultValue.showMethods),showFunctions:t(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:t(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(ge.showFields,this.defaultValue.showFields),showVariables:t(ge.showVariables,this.defaultValue.showVariables),showClasses:t(ge.showClasses,this.defaultValue.showClasses),showStructs:t(ge.showStructs,this.defaultValue.showStructs),showInterfaces:t(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:t(ge.showModules,this.defaultValue.showModules),showProperties:t(ge.showProperties,this.defaultValue.showProperties),showEvents:t(ge.showEvents,this.defaultValue.showEvents),showOperators:t(ge.showOperators,this.defaultValue.showOperators),showUnits:t(ge.showUnits,this.defaultValue.showUnits),showValues:t(ge.showValues,this.defaultValue.showValues),showConstants:t(ge.showConstants,this.defaultValue.showConstants),showEnums:t(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:t(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(ge.showKeywords,this.defaultValue.showKeywords),showWords:t(ge.showWords,this.defaultValue.showWords),showColors:t(ge.showColors,this.defaultValue.showColors),showFiles:t(ge.showFiles,this.defaultValue.showFiles),showReferences:t(ge.showReferences,this.defaultValue.showReferences),showFolders:t(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:t(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(ge.showSnippets,this.defaultValue.showSnippets),showUsers:t(ge.showUsers,this.defaultValue.showUsers),showIssues:t(ge.showIssues,this.defaultValue.showIssues)}}}class Ne extends E{constructor(){super(111,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(179,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:g.localize(180,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Y.selectSubwords,this.defaultValue.selectSubwords)}}}var Be;(function(x){x[x.None=0]="None",x[x.Same=1]="Same",x[x.Indent=2]="Indent",x[x.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class Ye extends E{constructor(){super(135,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[g.localize(181,null),g.localize(182,null),g.localize(183,null),g.localize(184,null)],description:g.localize(185,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,ge,je){return ge.get(2)===2?0:je}}class Ke extends b{constructor(){super(143)}compute(Y,ge,je){const Me=ge.get(142);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:Me.isWordWrapMinified,isViewportWrapping:Me.isViewportWrapping,wrappingColumn:Me.wrappingColumn}}}class Xe extends E{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(35,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:g.localize(186,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:g.localize(187,null),enum:["afterDrop","never"],enumDescriptions:[g.localize(188,null),g.localize(189,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:t(ge.enabled,this.defaultValue.enabled),showDropSelector:h(ge.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ge extends E{constructor(){const Y={enabled:!0,showPasteSelector:"afterPaste"};super(83,"pasteAs",Y,{"editor.pasteAs.enabled":{type:"boolean",default:Y.enabled,markdownDescription:g.localize(190,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:g.localize(191,null),enum:["afterPaste","never"],enumDescriptions:[g.localize(192,null),g.localize(193,null)],default:"afterPaste"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:t(ge.enabled,this.defaultValue.enabled),showPasteSelector:h(ge.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",xe="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?xe:C.$k?tt:ct,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Oe(x){return e.editorOptionsRegistry[x.id]=x,x}var nt;(function(x){x[x.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",x[x.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",x[x.accessibilitySupport=2]="accessibilitySupport",x[x.accessibilityPageSize=3]="accessibilityPageSize",x[x.ariaLabel=4]="ariaLabel",x[x.ariaRequired=5]="ariaRequired",x[x.autoClosingBrackets=6]="autoClosingBrackets",x[x.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",x[x.autoClosingDelete=8]="autoClosingDelete",x[x.autoClosingOvertype=9]="autoClosingOvertype",x[x.autoClosingQuotes=10]="autoClosingQuotes",x[x.autoIndent=11]="autoIndent",x[x.automaticLayout=12]="automaticLayout",x[x.autoSurround=13]="autoSurround",x[x.bracketPairColorization=14]="bracketPairColorization",x[x.guides=15]="guides",x[x.codeLens=16]="codeLens",x[x.codeLensFontFamily=17]="codeLensFontFamily",x[x.codeLensFontSize=18]="codeLensFontSize",x[x.colorDecorators=19]="colorDecorators",x[x.colorDecoratorsLimit=20]="colorDecoratorsLimit",x[x.columnSelection=21]="columnSelection",x[x.comments=22]="comments",x[x.contextmenu=23]="contextmenu",x[x.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",x[x.cursorBlinking=25]="cursorBlinking",x[x.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",x[x.cursorStyle=27]="cursorStyle",x[x.cursorSurroundingLines=28]="cursorSurroundingLines",x[x.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",x[x.cursorWidth=30]="cursorWidth",x[x.disableLayerHinting=31]="disableLayerHinting",x[x.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",x[x.domReadOnly=33]="domReadOnly",x[x.dragAndDrop=34]="dragAndDrop",x[x.dropIntoEditor=35]="dropIntoEditor",x[x.emptySelectionClipboard=36]="emptySelectionClipboard",x[x.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",x[x.extraEditorClassName=38]="extraEditorClassName",x[x.fastScrollSensitivity=39]="fastScrollSensitivity",x[x.find=40]="find",x[x.fixedOverflowWidgets=41]="fixedOverflowWidgets",x[x.folding=42]="folding",x[x.foldingStrategy=43]="foldingStrategy",x[x.foldingHighlight=44]="foldingHighlight",x[x.foldingImportsByDefault=45]="foldingImportsByDefault",x[x.foldingMaximumRegions=46]="foldingMaximumRegions",x[x.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",x[x.fontFamily=48]="fontFamily",x[x.fontInfo=49]="fontInfo",x[x.fontLigatures=50]="fontLigatures",x[x.fontSize=51]="fontSize",x[x.fontWeight=52]="fontWeight",x[x.fontVariations=53]="fontVariations",x[x.formatOnPaste=54]="formatOnPaste",x[x.formatOnType=55]="formatOnType",x[x.glyphMargin=56]="glyphMargin",x[x.gotoLocation=57]="gotoLocation",x[x.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",x[x.hover=59]="hover",x[x.inDiffEditor=60]="inDiffEditor",x[x.inlineSuggest=61]="inlineSuggest",x[x.letterSpacing=62]="letterSpacing",x[x.lightbulb=63]="lightbulb",x[x.lineDecorationsWidth=64]="lineDecorationsWidth",x[x.lineHeight=65]="lineHeight",x[x.lineNumbers=66]="lineNumbers",x[x.lineNumbersMinChars=67]="lineNumbersMinChars",x[x.linkedEditing=68]="linkedEditing",x[x.links=69]="links",x[x.matchBrackets=70]="matchBrackets",x[x.minimap=71]="minimap",x[x.mouseStyle=72]="mouseStyle",x[x.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",x[x.mouseWheelZoom=74]="mouseWheelZoom",x[x.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",x[x.multiCursorModifier=76]="multiCursorModifier",x[x.multiCursorPaste=77]="multiCursorPaste",x[x.multiCursorLimit=78]="multiCursorLimit",x[x.occurrencesHighlight=79]="occurrencesHighlight",x[x.overviewRulerBorder=80]="overviewRulerBorder",x[x.overviewRulerLanes=81]="overviewRulerLanes",x[x.padding=82]="padding",x[x.pasteAs=83]="pasteAs",x[x.parameterHints=84]="parameterHints",x[x.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",x[x.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",x[x.quickSuggestions=87]="quickSuggestions",x[x.quickSuggestionsDelay=88]="quickSuggestionsDelay",x[x.readOnly=89]="readOnly",x[x.readOnlyMessage=90]="readOnlyMessage",x[x.renameOnType=91]="renameOnType",x[x.renderControlCharacters=92]="renderControlCharacters",x[x.renderFinalNewline=93]="renderFinalNewline",x[x.renderLineHighlight=94]="renderLineHighlight",x[x.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",x[x.renderValidationDecorations=96]="renderValidationDecorations",x[x.renderWhitespace=97]="renderWhitespace",x[x.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",x[x.roundedSelection=99]="roundedSelection",x[x.rulers=100]="rulers",x[x.scrollbar=101]="scrollbar",x[x.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",x[x.scrollBeyondLastLine=103]="scrollBeyondLastLine",x[x.scrollPredominantAxis=104]="scrollPredominantAxis",x[x.selectionClipboard=105]="selectionClipboard",x[x.selectionHighlight=106]="selectionHighlight",x[x.selectOnLineNumbers=107]="selectOnLineNumbers",x[x.showFoldingControls=108]="showFoldingControls",x[x.showUnused=109]="showUnused",x[x.snippetSuggestions=110]="snippetSuggestions",x[x.smartSelect=111]="smartSelect",x[x.smoothScrolling=112]="smoothScrolling",x[x.stickyScroll=113]="stickyScroll",x[x.stickyTabStops=114]="stickyTabStops",x[x.stopRenderingLineAfter=115]="stopRenderingLineAfter",x[x.suggest=116]="suggest",x[x.suggestFontSize=117]="suggestFontSize",x[x.suggestLineHeight=118]="suggestLineHeight",x[x.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",x[x.suggestSelection=120]="suggestSelection",x[x.tabCompletion=121]="tabCompletion",x[x.tabIndex=122]="tabIndex",x[x.unicodeHighlighting=123]="unicodeHighlighting",x[x.unusualLineTerminators=124]="unusualLineTerminators",x[x.useShadowDOM=125]="useShadowDOM",x[x.useTabStops=126]="useTabStops",x[x.wordBreak=127]="wordBreak",x[x.wordSeparators=128]="wordSeparators",x[x.wordWrap=129]="wordWrap",x[x.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",x[x.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",x[x.wordWrapColumn=132]="wordWrapColumn",x[x.wordWrapOverride1=133]="wordWrapOverride1",x[x.wordWrapOverride2=134]="wordWrapOverride2",x[x.wrappingIndent=135]="wrappingIndent",x[x.wrappingStrategy=136]="wrappingStrategy",x[x.showDeprecated=137]="showDeprecated",x[x.inlayHints=138]="inlayHints",x[x.editorClassName=139]="editorClassName",x[x.pixelRatio=140]="pixelRatio",x[x.tabFocusMode=141]="tabFocusMode",x[x.layoutInfo=142]="layoutInfo",x[x.wrappingInfo=143]="wrappingInfo",x[x.defaultColorDecorators=144]="defaultColorDecorators",x[x.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn"})(nt||(e.EditorOption=nt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(194,null)})),acceptSuggestionOnEnter:Oe(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(195,null),""],markdownDescription:g.localize(196,null)})),accessibilitySupport:Oe(new k),accessibilityPageSize:Oe(new m(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(197,null),tags:["accessibility"]})),ariaLabel:Oe(new r(4,"ariaLabel",g.localize(198,null))),ariaRequired:Oe(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Oe(new i(7,"screenReaderAnnounceInlineSuggestion",!0,{description:g.localize(199,null),tags:["accessibility"]})),autoClosingBrackets:Oe(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(200,null),g.localize(201,null),""],description:g.localize(202,null)})),autoClosingDelete:Oe(new n(8,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(203,null),""],description:g.localize(204,null)})),autoClosingOvertype:Oe(new n(9,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(205,null),""],description:g.localize(206,null)})),autoClosingQuotes:Oe(new n(10,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(207,null),g.localize(208,null),""],description:g.localize(209,null)})),autoIndent:Oe(new s(11,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],$,{enumDescriptions:[g.localize(210,null),g.localize(211,null),g.localize(212,null),g.localize(213,null),g.localize(214,null)],description:g.localize(215,null)})),automaticLayout:Oe(new i(12,"automaticLayout",!1)),autoSurround:Oe(new n(13,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(216,null),g.localize(217,null),g.localize(218,null),""],description:g.localize(219,null)})),bracketPairColorization:Oe(new ae),bracketPairGuides:Oe(new G),stickyTabStops:Oe(new i(114,"stickyTabStops",!1,{description:g.localize(220,null)})),codeLens:Oe(new i(16,"codeLens",!0,{description:g.localize(221,null)})),codeLensFontFamily:Oe(new r(17,"codeLensFontFamily","",{description:g.localize(222,null)})),codeLensFontSize:Oe(new m(18,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(223,null)})),colorDecorators:Oe(new i(19,"colorDecorators",!0,{description:g.localize(224,null)})),colorDecoratorActivatedOn:Oe(new n(145,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[g.localize(225,null),g.localize(226,null),g.localize(227,null)],description:g.localize(228,null)})),colorDecoratorsLimit:Oe(new m(20,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:g.localize(229,null)})),columnSelection:Oe(new i(21,"columnSelection",!1,{description:g.localize(230,null)})),comments:Oe(new l),contextmenu:Oe(new i(23,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new i(24,"copyWithSyntaxHighlighting",!0,{description:g.localize(231,null)})),cursorBlinking:Oe(new s(25,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:g.localize(232,null)})),cursorSmoothCaretAnimation:Oe(new n(26,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[g.localize(233,null),g.localize(234,null),g.localize(235,null)],description:g.localize(236,null)})),cursorStyle:Oe(new s(27,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:g.localize(237,null)})),cursorSurroundingLines:Oe(new m(28,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(238,null)})),cursorSurroundingLinesStyle:Oe(new n(29,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(239,null),g.localize(240,null)],description:g.localize(241,null)})),cursorWidth:Oe(new m(30,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(242,null)})),disableLayerHinting:Oe(new i(31,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new i(32,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new i(33,"domReadOnly",!1)),dragAndDrop:Oe(new i(34,"dragAndDrop",!0,{description:g.localize(243,null)})),emptySelectionClipboard:Oe(new B),dropIntoEditor:Oe(new Xe),stickyScroll:Oe(new H),experimentalWhitespaceRendering:Oe(new n(37,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),extraEditorClassName:Oe(new r(38,"extraEditorClassName","")),fastScrollSensitivity:Oe(new I(39,"fastScrollSensitivity",5,x=>x<=0?5:x,{markdownDescription:g.localize(248,null)})),find:Oe(new q),fixedOverflowWidgets:Oe(new i(41,"fixedOverflowWidgets",!1)),folding:Oe(new i(42,"folding",!0,{description:g.localize(249,null)})),foldingStrategy:Oe(new n(43,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(250,null),g.localize(251,null)],description:g.localize(252,null)})),foldingHighlight:Oe(new i(44,"foldingHighlight",!0,{description:g.localize(253,null)})),foldingImportsByDefault:Oe(new i(45,"foldingImportsByDefault",!1,{description:g.localize(254,null)})),foldingMaximumRegions:Oe(new m(46,"foldingMaximumRegions",5e3,10,65e3,{description:g.localize(255,null)})),unfoldOnClickAfterEndOfLine:Oe(new i(47,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(256,null)})),fontFamily:Oe(new r(48,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(257,null)})),fontInfo:Oe(new O),fontLigatures2:Oe(new U),fontSize:Oe(new ce),fontWeight:Oe(new X),fontVariations:Oe(new N),formatOnPaste:Oe(new i(54,"formatOnPaste",!1,{description:g.localize(258,null)})),formatOnType:Oe(new i(55,"formatOnType",!1,{description:g.localize(259,null)})),glyphMargin:Oe(new i(56,"glyphMargin",!0,{description:g.localize(260,null)})),gotoLocation:Oe(new be),hideCursorInOverviewRuler:Oe(new i(58,"hideCursorInOverviewRuler",!1,{description:g.localize(261,null)})),hover:Oe(new Ee),inDiffEditor:Oe(new i(60,"inDiffEditor",!1)),letterSpacing:Oe(new I(62,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,x=>I.clamp(x,-5,20),{description:g.localize(262,null)})),lightbulb:Oe(new Ce),lineDecorationsWidth:Oe(new re),lineHeight:Oe(new L),lineNumbers:Oe(new de),lineNumbersMinChars:Oe(new m(67,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new i(68,"linkedEditing",!1,{description:g.localize(263,null)})),links:Oe(new i(69,"links",!0,{description:g.localize(264,null)})),matchBrackets:Oe(new n(70,"matchBrackets","always",["always","near","never"],{description:g.localize(265,null)})),minimap:Oe(new _),mouseStyle:Oe(new n(72,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new I(73,"mouseWheelScrollSensitivity",1,x=>x===0?1:x,{markdownDescription:g.localize(266,null)})),mouseWheelZoom:Oe(new i(74,"mouseWheelZoom",!1,{markdownDescription:g.localize(267,null)})),multiCursorMergeOverlapping:Oe(new i(75,"multiCursorMergeOverlapping",!0,{description:g.localize(268,null)})),multiCursorModifier:Oe(new s(76,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[g.localize(269,null),g.localize(270,null)],markdownDescription:g.localize(271,null)})),multiCursorPaste:Oe(new n(77,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(272,null),g.localize(273,null)],markdownDescription:g.localize(274,null)})),multiCursorLimit:Oe(new m(78,"multiCursorLimit",1e4,1,1e5,{markdownDescription:g.localize(275,null)})),occurrencesHighlight:Oe(new i(79,"occurrencesHighlight",!0,{description:g.localize(276,null)})),overviewRulerBorder:Oe(new i(80,"overviewRulerBorder",!0,{description:g.localize(277,null)})),overviewRulerLanes:Oe(new m(81,"overviewRulerLanes",3,0,3)),padding:Oe(new Ie),pasteAs:Oe(new Ge),parameterHints:Oe(new De),peekWidgetDefaultFocus:Oe(new n(85,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(278,null),g.localize(279,null)],description:g.localize(280,null)})),definitionLinkOpensInPeek:Oe(new i(86,"definitionLinkOpensInPeek",!1,{description:g.localize(281,null)})),quickSuggestions:Oe(new Se),quickSuggestionsDelay:Oe(new m(88,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(282,null)})),readOnly:Oe(new i(89,"readOnly",!1)),readOnlyMessage:Oe(new le),renameOnType:Oe(new i(91,"renameOnType",!1,{description:g.localize(283,null),markdownDeprecationMessage:g.localize(284,null)})),renderControlCharacters:Oe(new i(92,"renderControlCharacters",!0,{description:g.localize(285,null),restricted:!0})),renderFinalNewline:Oe(new n(93,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:g.localize(286,null)})),renderLineHighlight:Oe(new n(94,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(287,null)],description:g.localize(288,null)})),renderLineHighlightOnlyWhenFocus:Oe(new i(95,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(289,null)})),renderValidationDecorations:Oe(new n(96,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new n(97,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(290,null),g.localize(291,null),g.localize(292,null),""],description:g.localize(293,null)})),revealHorizontalRightPadding:Oe(new m(98,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Oe(new i(99,"roundedSelection",!0,{description:g.localize(294,null)})),rulers:Oe(new ie),scrollbar:Oe(new V),scrollBeyondLastColumn:Oe(new m(102,"scrollBeyondLastColumn",4,0,1073741824,{description:g.localize(295,null)})),scrollBeyondLastLine:Oe(new i(103,"scrollBeyondLastLine",!0,{description:g.localize(296,null)})),scrollPredominantAxis:Oe(new i(104,"scrollPredominantAxis",!0,{description:g.localize(297,null)})),selectionClipboard:Oe(new i(105,"selectionClipboard",!0,{description:g.localize(298,null),included:C.$k})),selectionHighlight:Oe(new i(106,"selectionHighlight",!0,{description:g.localize(299,null)})),selectOnLineNumbers:Oe(new i(107,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new n(108,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[g.localize(300,null),g.localize(301,null),g.localize(302,null)],description:g.localize(303,null)})),showUnused:Oe(new i(109,"showUnused",!0,{description:g.localize(304,null)})),showDeprecated:Oe(new i(137,"showDeprecated",!0,{description:g.localize(305,null)})),inlayHints:Oe(new ne),snippetSuggestions:Oe(new n(110,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(306,null),g.localize(307,null),g.localize(308,null),g.localize(309,null)],description:g.localize(310,null)})),smartSelect:Oe(new Ne),smoothScrolling:Oe(new i(112,"smoothScrolling",!1,{description:g.localize(311,null)})),stopRenderingLineAfter:Oe(new m(115,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new me),inlineSuggest:Oe(new K),suggestFontSize:Oe(new m(117,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(312,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Oe(new m(118,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(313,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Oe(new i(119,"suggestOnTriggerCharacters",!0,{description:g.localize(314,null)})),suggestSelection:Oe(new n(120,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(315,null),g.localize(316,null),g.localize(317,null)],description:g.localize(318,null)})),tabCompletion:Oe(new n(121,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(319,null),g.localize(320,null),g.localize(321,null)],description:g.localize(322,null)})),tabIndex:Oe(new m(122,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new J),unusualLineTerminators:Oe(new n(124,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(323,null),g.localize(324,null),g.localize(325,null)],description:g.localize(326,null)})),useShadowDOM:Oe(new i(125,"useShadowDOM",!0)),useTabStops:Oe(new i(126,"useTabStops",!0,{description:g.localize(327,null)})),wordBreak:Oe(new n(127,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[g.localize(328,null),g.localize(329,null)],description:g.localize(330,null)})),wordSeparators:Oe(new r(128,"wordSeparators",P.$Ir,{description:g.localize(331,null)})),wordWrap:Oe(new n(129,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(332,null),g.localize(333,null),g.localize(334,null),g.localize(335,null)],description:g.localize(336,null)})),wordWrapBreakAfterCharacters:Oe(new r(130,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new r(131,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new m(132,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(337,null)})),wordWrapOverride1:Oe(new n(133,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new n(134,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Oe(new W),defaultColorDecorators:Oe(new i(144,"defaultColorDecorators",!1,{markdownDescription:g.localize(338,null)})),pixelRatio:Oe(new ye),tabFocusMode:Oe(new i(141,"tabFocusMode",!1,{markdownDescription:g.localize(339,null)})),layoutInfo:Oe(new Z),wrappingInfo:Oe(new Ke),wrappingIndent:Oe(new Ye),wrappingStrategy:Oe(new he)}}),define(Ae[137],Fe([9,10]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[138],Fe([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[139],Fe([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[140],Fe([9,10]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[141],Fe([9,10]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[142],Fe([9,10]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(Ae[143],Fe([9,10]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(Ae[144],Fe([9,10]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[145],Fe([9,10]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(Ae[146],Fe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[147],Fe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[148],Fe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[149],Fe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[150],Fe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[151],Fe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[152],Fe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[153],Fe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[154],Fe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[155],Fe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[156],Fe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[157],Fe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[158],Fe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[159],Fe([9,10]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(Ae[160],Fe([9,10]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(Ae[161],Fe([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[162],Fe([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[163],Fe([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[164],Fe([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[165],Fe([9,10]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[166],Fe([9,10]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[167],Fe([9,10]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[168],Fe([1,0,11,139]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.TokenType=void 0;var C;(function(p){p[p.LParen=0]="LParen",p[p.RParen=1]="RParen",p[p.Neg=2]="Neg",p[p.Eq=3]="Eq",p[p.NotEq=4]="NotEq",p[p.Lt=5]="Lt",p[p.LtEq=6]="LtEq",p[p.Gt=7]="Gt",p[p.GtEq=8]="GtEq",p[p.RegexOp=9]="RegexOp",p[p.RegexStr=10]="RegexStr",p[p.True=11]="True",p[p.False=12]="False",p[p.In=13]="In",p[p.Not=14]="Not",p[p.And=15]="And",p[p.Or=16]="Or",p[p.Str=17]="Str",p[p.QuotedStr=18]="QuotedStr",p[p.Error=19]="Error",p[p.EOF=20]="EOF"})(C||(e.TokenType=C={}));function M(...p){switch(p.length){case 1:return(0,T.localize)(0,null,p[0]);case 2:return(0,T.localize)(1,null,p[0],p[1]);case 3:return(0,T.localize)(2,null,p[0],p[1],p[2]);default:return}}const P=(0,T.localize)(3,null),g=(0,T.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,w.$6)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const E=this.d,c=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:c};this.g.push({offset:E,lexeme:c,additionalInfo:A}),this.f.push(y)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const E=this.c.substring(this.d,this.e),c=D.b.get(E);c?this.k(c):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,E=!1,c=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(g);return}const b=this.c.charCodeAt(A);if(E)E=!1;else if(b===47&&!c){A++;break}else b===91?c=!0:b===92?E=!0:b===93&&(c=!1);A++}for(;A<this.c.length&&D.a.has(this.c.charCodeAt(A));)A++;this.e=A;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$si=D}),define(Ae[169],Fe([1,0,23,29,141,272]),function($e,e,w,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function D(i){return i=i.trim(),i==="*"||P.test(i)}e.$ro=D;function p(i){if(!D(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=i.match(P);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.$so=p;function A(i){if(!i)return null;const a=i.majorBase,m=i.majorMustEqual,S=i.minorBase;let I=i.minorMustEqual;const r=i.patchBase;let h=i.patchMustEqual;i.hasCaret&&(a===0||(I=!1),h=!1);let n=0;if(i.preRelease){const s=g.exec(i.preRelease);if(s){const[,$,k,l]=s;n=Date.UTC(Number($),Number(k)-1,Number(l))}}return{majorBase:a,majorMustEqual:m,minorBase:S,minorMustEqual:I,patchBase:r,patchMustEqual:h,isMinimum:i.hasGreaterEquals,notBefore:n}}e.$to=A;function E(i,a,m){let S;typeof i=="string"?S=A(p(i)):S=i;let I;a instanceof Date?I=a.getTime():typeof a=="string"&&(I=new Date(a).getTime());let r;if(typeof m=="string"?r=A(p(m)):r=m,!S||!r)return!1;const h=S.majorBase,n=S.minorBase,s=S.patchBase;let $=r.majorBase,k=r.minorBase,l=r.patchBase;const f=r.notBefore;let v=r.majorMustEqual,u=r.minorMustEqual,d=r.patchMustEqual;return r.isMinimum?h>$?!0:h<$?!1:n>k?!0:n<k||I&&I<f?!1:s>=l:(h===1&&$===0&&(!v||!u||!d)&&($=1,k=0,l=0,v=!0,u=!1,d=!1),h<$?!1:h>$?!v:n<k?!1:n>k?!u:s<l?!1:s>l?!d:!(I&&I<f))}e.$uo=E;function c(i,a,m,S,I){const r=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return r.push([T.default.Error,C.localize(0,null)]),r;if(typeof S.name!="string")return r.push([T.default.Error,C.localize(1,null,"name")]),r;if(typeof S.version!="string")return r.push([T.default.Error,C.localize(2,null,"version")]),r;if(!S.engines)return r.push([T.default.Error,C.localize(3,null,"engines")]),r;if(typeof S.engines.vscode!="string")return r.push([T.default.Error,C.localize(4,null,"engines.vscode")]),r;if(typeof S.extensionDependencies<"u"&&!t(S.extensionDependencies))return r.push([T.default.Error,C.localize(5,null,"extensionDependencies")]),r;if(typeof S.activationEvents<"u"){if(!t(S.activationEvents))return r.push([T.default.Error,C.localize(6,null,"activationEvents")]),r;if(typeof S.main>"u"&&typeof S.browser>"u")return r.push([T.default.Error,C.localize(7,null,"activationEvents","main","browser")]),r}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&r.push([T.default.Warning,C.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return r.push([T.default.Error,C.localize(9,null,"main")]),r;{const s=(0,w.$0f)(m,S.main);(0,w.$4f)(s,m)||r.push([T.default.Warning,C.localize(10,null,s.path,m.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return r.push([T.default.Error,C.localize(11,null,"browser")]),r;{const s=(0,w.$0f)(m,S.browser);(0,w.$4f)(s,m)||r.push([T.default.Warning,C.localize(12,null,s.path,m.path)])}}if(!M.valid(S.version))return r.push([T.default.Error,C.localize(13,null)]),r;const h=[];if(!y(i,a,S,I,h))for(const s of h)r.push([T.default.Error,s]);return r}e.$vo=c;function y(i,a,m,S,I){return S||typeof m.main>"u"&&typeof m.browser>"u"?!0:o(i,a,m.engines.vscode,I)}e.$wo=y;function b(i,a,m){return i==="*"||o(a,m,i)}e.$xo=b;function o(i,a,m,S=[]){const I=A(p(m));if(!I)return S.push(C.localize(14,null,m)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return S.push(C.localize(15,null,m)),!1}else if(!I.majorMustEqual)return S.push(C.localize(16,null,m)),!1;return E(i,a,I)?!0:(S.push(C.localize(17,null,i,m)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let a=0,m=i.length;a<m;a++)if(typeof i[a]!="string")return!1;return!0}}),define(Ae[70],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=void 0;class w{constructor(C,M=[],P=!1){this.ctor=C,this.staticArguments=M,this.supportsDelayedInstantiation=P}}e.$mh=w}),define(Ae[71],Fe([1,0,70]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=e.InstantiationType=void 0;const T=[];var C;(function(g){g[g.Eager=0]="Eager",g[g.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function M(g,D,p){D instanceof w.$mh||(D=new w.$mh(D,[],!!p)),T.push([g,D])}e.$_q=M;function P(){return T}e.$ar=P}),define(Ae[170],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=void 0;class w{constructor(M,P){this.key=M,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.$Sp=w;class T{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const P of this.a.values())P.outgoing.size===0&&M.push(P);return M}insertEdge(M,P){const g=this.lookupOrInsertNode(M),D=this.lookupOrInsertNode(P);g.outgoing.set(D.key,D),D.incoming.set(g.key,g)}removeNode(M){const P=this.b(M);this.a.delete(P);for(const g of this.a.values())g.outgoing.delete(P),g.incoming.delete(P)}lookupOrInsertNode(M){const P=this.b(M);let g=this.a.get(P);return g||(g=new w(P,M),this.a.set(P,g)),g}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[P,g]of this.a)M.push(`${P}
	(-> incoming)[${[...g.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...g.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,P]of this.a){const g=new Set([M]),D=this.c(P,g);if(D)return D}}c(M,P){for(const[g,D]of M.outgoing){if(P.has(g))return[...P,g].join(" -> ");P.add(g);const p=this.c(D,P);if(p)return p;P.delete(g)}}}e.$Tp=T}),define(Ae[3],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e._util=void 0;var w;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function g(D){return D[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=g})(w||(e._util=w={})),e.$oh=C("instantiationService");function T(P,g,D){g[w.DI_TARGET]===g?g[w.DI_DEPENDENCIES].push({id:P,index:D}):(g[w.DI_DEPENDENCIES]=[{id:P,index:D}],g[w.DI_TARGET]=g)}function C(P){if(w.serviceIds.has(P))return w.serviceIds.get(P);const g=function(D,p,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(g,D,A)};return g.toString=()=>P,w.serviceIds.set(P,g),g}e.$ph=C;function M(P){return P}e.$qh=M}),define(Ae[43],Fe([1,0,12,2,3]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.ConfigurationTarget=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,C.$ph)("configurationService");function M(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof T.URI)}e.$Wh=M;function P(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof T.URI)}e.$Xh=P;var g;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(g||(e.ConfigurationTarget=g={}));function D(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Yh=D;function p(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$Zh=p;function A(i,a){const m=Object.create(null);for(const S in i)E(m,S,i[S],a);return m}e.$1h=A;function E(i,a,m,S){const I=a.split("."),r=I.pop();let h=i;for(let n=0;n<I.length;n++){const s=I[n];let $=h[s];switch(typeof $){case"undefined":$=h[s]=Object.create(null);break;case"object":break;default:S(`Ignoring ${a} as ${I.slice(0,n+1).join(".")} is ${JSON.stringify($)}`);return}h=$}if(typeof h=="object"&&h!==null)try{h[r]=m}catch{S(`Ignoring ${a} as ${I.join(".")} is ${JSON.stringify(h)}`)}else S(`Ignoring ${a} as ${I.join(".")} is ${JSON.stringify(h)}`)}e.$2h=E;function c(i,a){const m=a.split(".");y(i,m)}e.$3h=c;function y(i,a){const m=a.shift();if(a.length===0){delete i[m];return}if(Object.keys(i).indexOf(m)!==-1){const S=i[m];typeof S=="object"&&!Array.isArray(S)&&(y(S,a),Object.keys(S).length===0&&delete i[m])}}function b(i,a,m){function S(h,n){let s=h;for(const $ of n){if(typeof s!="object"||s===null)return;s=s[$]}return s}const I=a.split("."),r=S(i,I);return typeof r>"u"?m:r}e.$4h=b;function o(i,a,m){Object.keys(a).forEach(S=>{S!=="__proto__"&&(S in i?w.$le(i[S])&&w.$le(a[S])?o(i[S],a[S],m):m&&(i[S]=a[S]):i[S]=a[S])})}e.$5h=o;function t(i){return i.replace(/[\[\]]/g,"")}e.$6h=t}),define(Ae[31],Fe([1,0,22,15,168,3,138,11]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ContextKeyExprType=e.$ti=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",w.$j),D.set("isLinux",w.$k),D.set("isWindows",w.$i),D.set("isWeb",w.$o),D.set("isMacNative",w.$j&&!w.$o),D.set("isEdge",w.$G),D.set("isFirefox",w.$E),D.set("isChrome",w.$D),D.set("isSafari",w.$F);function p(re,L){if(D.get(re)!==void 0)throw(0,g.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(re,L)}e.$ti=p;const A=Object.prototype.hasOwnProperty;var E;(function(re){re[re.False=0]="False",re[re.True=1]="True",re[re.Defined=2]="Defined",re[re.Not=3]="Not",re[re.Equals=4]="Equals",re[re.NotEquals=5]="NotEquals",re[re.And=6]="And",re[re.Regex=7]="Regex",re[re.NotRegex=8]="NotRegex",re[re.Or=9]="Or",re[re.In=10]="In",re[re.NotIn=11]="NotIn",re[re.Greater=12]="Greater",re[re.GreaterEquals=13]="GreaterEquals",re[re.Smaller=14]="Smaller",re[re.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const c={regexParsingWithErrorRecovery:!0},y=(0,P.localize)(0,null),b=(0,P.localize)(1,null),o=(0,P.localize)(2,null),t=(0,P.localize)(3,null),i=(0,P.localize)(4,null),a=(0,P.localize)(5,null),m=(0,P.localize)(6,null),S=(0,P.localize)(7,null);class I{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(L=c){this.k=L,this.d=new C.$si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(L){if(L===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(L).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const pe=this.D(),Ie=pe.type===17?a:void 0;throw this.h.push({message:i,offset:pe.offset,lexeme:C.$si.getLexeme(pe),additionalInfo:Ie}),I.c}return _}catch(_){if(_!==I.c)throw _;return}}l(){return this.m()}m(){const L=[this.o()];for(;this.y(16);){const _=this.o();L.push(_)}return L.length===1?L[0]:r.or(...L)}o(){const L=[this.s()];for(;this.y(15);){const _=this.s();L.push(_)}return L.length===1?L[0]:r.and(...L)}s(){if(this.y(2)){const L=this.D();switch(L.type){case 11:return this.z(),$.INSTANCE;case 12:return this.z(),k.INSTANCE;case 0:{this.z();const _=this.l();return this.A(1,t),_?.negate()}case 17:return this.z(),R.create(L.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",L)}}return this.t()}t(){const L=this.D();switch(L.type){case 11:return this.z(),r.true();case 12:return this.z(),r.false();case 0:{this.z();const _=this.l();return this.A(1,t),_}case 17:{const _=L.lexeme;if(this.z(),this.y(9)){const Ie=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ie.type!==10)throw this.B("REGEX",Ie);const De=Ie.lexeme,ye=De.lastIndexOf("/"),Se=ye===De.length-1?void 0:this.w(De.substring(ye+1));let oe;try{oe=new RegExp(De.substring(1,ye),Se)}catch{throw this.B("REGEX",Ie)}return O.create(_,oe)}switch(Ie.type){case 10:case 19:{const De=[Ie.lexeme];this.z();let ye=this.D(),Se=0;for(let le=0;le<Ie.lexeme.length;le++)Ie.lexeme.charCodeAt(le)===40?Se++:Ie.lexeme.charCodeAt(le)===41&&Se--;for(;!this.E()&&ye.type!==15&&ye.type!==16;){switch(ye.type){case 0:Se++;break;case 1:Se--;break;case 10:case 18:for(let le=0;le<ye.lexeme.length;le++)ye.lexeme.charCodeAt(le)===40?Se++:Ie.lexeme.charCodeAt(le)===41&&Se--}if(Se<0)break;De.push(C.$si.getLexeme(ye)),this.z(),ye=this.D()}const oe=De.join(""),de=oe.lastIndexOf("/"),ee=de===oe.length-1?void 0:this.w(oe.substring(de+1));let ie;try{ie=new RegExp(oe.substring(1,de),ee)}catch{throw this.B("REGEX",Ie)}return r.regex(_,ie)}case 18:{const De=Ie.lexeme;this.z();let ye=null;if(!(0,T.$kd)(De)){const Se=De.indexOf("/"),oe=De.lastIndexOf("/");if(Se!==oe&&Se>=0){const de=De.slice(Se+1,oe),ee=De[oe+1]==="i"?"i":"";try{ye=new RegExp(de,ee)}catch{throw this.B("REGEX",Ie)}}}if(ye===null)throw this.B("REGEX",Ie);return O.create(_,ye)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,o);const Ie=this.u();return r.notIn(_,Ie)}switch(this.D().type){case 3:{this.z();const Ie=this.u();if(this.x().type===18)return r.equals(_,Ie);switch(Ie){case"true":return r.has(_);case"false":return r.not(_);default:return r.equals(_,Ie)}}case 4:{this.z();const Ie=this.u();if(this.x().type===18)return r.notEquals(_,Ie);switch(Ie){case"true":return r.not(_);case"false":return r.has(_);default:return r.notEquals(_,Ie)}}case 5:return this.z(),U.create(_,this.u());case 6:return this.z(),N.create(_,this.u());case 7:return this.z(),B.create(_,this.u());case 8:return this.z(),q.create(_,this.u());case 13:return this.z(),r.in(_,this.u());default:return r.has(_)}}case 20:throw this.h.push({message:m,offset:L.offset,lexeme:"",additionalInfo:S}),I.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const L=this.D();switch(L.type){case 17:case 18:return this.z(),L.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(L){return L.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(L){return this.C(L)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(L,_){if(this.C(L))return this.z();throw this.B(_,this.D())}B(L,_,pe){const Ie=(0,P.localize)(8,null,L,C.$si.getLexeme(_)),De=_.offset,ye=C.$si.getLexeme(_);return this.h.push({message:Ie,offset:De,lexeme:ye,additionalInfo:pe}),I.c}C(L){return this.D().type===L}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ui=I;class r{static false(){return $.INSTANCE}static true(){return k.INSTANCE}static has(L){return l.create(L)}static equals(L,_){return f.create(L,_)}static notEquals(L,_){return d.create(L,_)}static regex(L,_){return O.create(L,_)}static in(L,_){return v.create(L,_)}static notIn(L,_){return u.create(L,_)}static not(L){return R.create(L)}static and(...L){return be.create(L,null,!0)}static or(...L){return Ee.create(L,null,!0)}static greater(L,_){return B.create(L,_)}static greaterEquals(L,_){return q.create(L,_)}static smaller(L,_){return U.create(L,_)}static smallerEquals(L,_){return N.create(L,_)}static{this.c=new I({regexParsingWithErrorRecovery:!1})}static deserialize(L){return L==null?void 0:this.c.parse(L)}}e.$vi=r;function h(re){const L=new I({regexParsingWithErrorRecovery:!1});return re.map(_=>(L.parse(_),L.lexingErrors.length>0?L.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,P.localize)(9,null,pe.additionalInfo):(0,P.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}e.$wi=h;function n(re,L){const _=re?re.substituteConstants():void 0,pe=L?L.substituteConstants():void 0;return!_&&!pe?!0:!_||!pe?!1:_.equals(pe)}e.$xi=n;function s(re,L){return re.cmp(L)}class ${static{this.INSTANCE=new $}constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return k.INSTANCE}}e.$yi=$;class k{static{this.INSTANCE=new k}constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return $.INSTANCE}}e.$zi=k;class l{static create(L,_=null){const pe=D.get(L);return typeof pe=="boolean"?pe?k.INSTANCE:$.INSTANCE:new l(L,_)}constructor(L,_){this.key=L,this.c=_,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:Z(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=D.get(this.key);return typeof L=="boolean"?L?k.INSTANCE:$.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$Ai=l;class f{static create(L,_,pe=null){if(typeof _=="boolean")return _?l.create(L,pe):R.create(L,pe);const Ie=D.get(L);return typeof Ie=="boolean"?_===(Ie?"true":"false")?k.INSTANCE:$.INSTANCE:new f(L,_,pe)}constructor(L,_,pe){this.c=L,this.d=_,this.f=pe,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:he(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=D.get(this.c);if(typeof L=="boolean"){const _=L?"true":"false";return this.d===_?k.INSTANCE:$.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.$Bi=f;class v{static create(L,_){return new v(L,_)}constructor(L,_){this.d=L,this.f=_,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:he(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const _=L.getValue(this.f),pe=L.getValue(this.d);return Array.isArray(_)?_.includes(pe):typeof pe=="string"&&typeof _=="object"&&_!==null?A.call(_,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.$Ci=v;class u{static create(L,_){return new u(L,_)}constructor(L,_){this.d=L,this.f=_,this.type=11,this.c=v.create(L,_)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Di=u;class d{static create(L,_,pe=null){if(typeof _=="boolean")return _?R.create(L,pe):l.create(L,pe);const Ie=D.get(L);return typeof Ie=="boolean"?_===(Ie?"true":"false")?$.INSTANCE:k.INSTANCE:new d(L,_,pe)}constructor(L,_,pe){this.c=L,this.d=_,this.f=pe,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:he(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=D.get(this.c);if(typeof L=="boolean"){const _=L?"true":"false";return this.d===_?$.INSTANCE:k.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.$Ei=d;class R{static create(L,_=null){const pe=D.get(L);return typeof pe=="boolean"?pe?$.INSTANCE:k.INSTANCE:new R(L,_)}constructor(L,_){this.c=L,this.d=_,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:Z(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=D.get(this.c);return typeof L=="boolean"?L?$.INSTANCE:k.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Fi=R;function W(re,L){if(typeof re=="string"){const _=parseFloat(re);isNaN(_)||(re=_)}return typeof re=="string"||typeof re=="number"?L(re):$.INSTANCE}class B{static create(L,_,pe=null){return W(_,Ie=>new B(L,Ie,pe))}constructor(L,_,pe){this.c=L,this.d=_,this.f=pe,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:he(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Gi=B;class q{static create(L,_,pe=null){return W(_,Ie=>new q(L,Ie,pe))}constructor(L,_,pe){this.c=L,this.d=_,this.f=pe,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:he(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Hi=q;class U{static create(L,_,pe=null){return W(_,Ie=>new U(L,Ie,pe))}constructor(L,_,pe){this.c=L,this.d=_,this.f=pe,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:he(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Ii=U;class N{static create(L,_,pe=null){return W(_,Ie=>new N(L,Ie,pe))}constructor(L,_,pe){this.c=L,this.d=_,this.f=pe,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:he(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Ji=N;class O{static create(L,_){return new O(L,_)}constructor(L,_){this.d=L,this.f=_,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const _=this.f?this.f.source:"",pe=L.f?L.f.source:"";return _<pe?-1:_>pe?1:0}equals(L){if(L.type===this.type){const _=this.f?this.f.source:"",pe=L.f?L.f.source:"";return this.d===L.d&&_===pe}return!1}substituteConstants(){return this}evaluate(L){const _=L.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Ki=O;class ce{static create(L){return new ce(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(L){return new ce(this.c.map(L))}negate(){return this.c}}e.$Li=ce;function X(re){let L=null;for(let _=0,pe=re.length;_<pe;_++){const Ie=re[_].substituteConstants();if(re[_]!==Ie&&L===null){L=[];for(let De=0;De<_;De++)L[De]=re[De]}L!==null&&(L[_]=Ie)}return L===null?re:L}class be{static create(L,_,pe){return be.d(L,_,pe)}constructor(L,_){this.expr=L,this.c=_,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let _=0,pe=this.expr.length;_<pe;_++){const Ie=s(this.expr[_],L.expr[_]);if(Ie!==0)return Ie}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].equals(L.expr[_]))return!1;return!0}return!1}substituteConstants(){const L=X(this.expr);return L===this.expr?this:be.create(L,this.c,!1)}evaluate(L){for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].evaluate(L))return!1;return!0}static d(L,_,pe){const Ie=[];let De=!1;for(const ye of L)if(ye){if(ye.type===1){De=!0;continue}if(ye.type===0)return $.INSTANCE;if(ye.type===6){Ie.push(...ye.expr);continue}Ie.push(ye)}if(Ie.length===0&&De)return k.INSTANCE;if(Ie.length!==0){if(Ie.length===1)return Ie[0];Ie.sort(s);for(let ye=1;ye<Ie.length;ye++)Ie[ye-1].equals(Ie[ye])&&(Ie.splice(ye,1),ye--);if(Ie.length===1)return Ie[0];for(;Ie.length>1;){const ye=Ie[Ie.length-1];if(ye.type!==9)break;Ie.pop();const Se=Ie.pop(),oe=Ie.length===0,de=Ee.create(ye.expr.map(ee=>be.create([ee,Se],null,pe)),null,oe);de&&(Ie.push(de),Ie.sort(s))}if(Ie.length===1)return Ie[0];if(pe){for(let ye=0;ye<Ie.length;ye++)for(let Se=ye+1;Se<Ie.length;Se++)if(Ie[ye].negate().equals(Ie[Se]))return $.INSTANCE;if(Ie.length===1)return Ie[0]}return new be(Ie,_)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const _ of this.expr)L.push(..._.keys());return L}map(L){return new be(this.expr.map(_=>_.map(L)),null)}negate(){if(!this.c){const L=[];for(const _ of this.expr)L.push(_.negate());this.c=Ee.create(L,this,!0)}return this.c}}e.$Mi=be;class Ee{static create(L,_,pe){return Ee.d(L,_,pe)}constructor(L,_){this.expr=L,this.c=_,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let _=0,pe=this.expr.length;_<pe;_++){const Ie=s(this.expr[_],L.expr[_]);if(Ie!==0)return Ie}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].equals(L.expr[_]))return!1;return!0}return!1}substituteConstants(){const L=X(this.expr);return L===this.expr?this:Ee.create(L,this.c,!1)}evaluate(L){for(let _=0,pe=this.expr.length;_<pe;_++)if(this.expr[_].evaluate(L))return!0;return!1}static d(L,_,pe){let Ie=[],De=!1;if(L){for(let ye=0,Se=L.length;ye<Se;ye++){const oe=L[ye];if(oe){if(oe.type===0){De=!0;continue}if(oe.type===1)return k.INSTANCE;if(oe.type===9){Ie=Ie.concat(oe.expr);continue}Ie.push(oe)}}if(Ie.length===0&&De)return $.INSTANCE;Ie.sort(s)}if(Ie.length!==0){if(Ie.length===1)return Ie[0];for(let ye=1;ye<Ie.length;ye++)Ie[ye-1].equals(Ie[ye])&&(Ie.splice(ye,1),ye--);if(Ie.length===1)return Ie[0];if(pe){for(let ye=0;ye<Ie.length;ye++)for(let Se=ye+1;Se<Ie.length;Se++)if(Ie[ye].negate().equals(Ie[Se]))return k.INSTANCE;if(Ie.length===1)return Ie[0]}return new Ee(Ie,_)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const _ of this.expr)L.push(..._.keys());return L}map(L){return new Ee(this.expr.map(_=>_.map(L)),null)}negate(){if(!this.c){const L=[];for(const _ of this.expr)L.push(_.negate());for(;L.length>1;){const _=L.shift(),pe=L.shift(),Ie=[];for(const De of ne(_))for(const ye of ne(pe))Ie.push(be.create([De,ye],null,!1));L.unshift(Ee.create(Ie,null,!1))}this.c=Ee.create(L,this,!0)}return this.c}}e.$Ni=Ee;class Re extends l{static{this.d=[]}static all(){return Re.d.values()}constructor(L,_,pe){super(L,null),this.f=_,typeof pe=="object"?Re.d.push({...pe,key:L}):pe!==!0&&Re.d.push({key:L,description:pe,type:_!=null?typeof _:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return f.create(this.key,L)}notEqualsTo(L){return d.create(this.key,L)}}e.$Oi=Re,e.$Pi=(0,M.$ph)("contextKeyService");function Z(re,L){return re<L?-1:re>L?1:0}function he(re,L,_,pe){return re<_?-1:re>_?1:L<pe?-1:L>pe?1:0}function Ce(re,L){if(re.type===0||L.type===1)return!0;if(re.type===9)return L.type===9?H(re.expr,L.expr):!1;if(L.type===9){for(const _ of L.expr)if(Ce(re,_))return!0;return!1}if(re.type===6){if(L.type===6)return H(L.expr,re.expr);for(const _ of re.expr)if(Ce(_,L))return!0;return!1}return re.equals(L)}e.$Qi=Ce;function H(re,L){let _=0,pe=0;for(;_<re.length&&pe<L.length;){const Ie=re[_].cmp(L[pe]);if(Ie<0)return!1;Ie===0&&_++,pe++}return _===re.length}function ne(re){return re.type===9?re.expr:[re]}}),define(Ae[171],Fe([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=void 0,e.$wh=(0,w.$ph)("environmentService"),e.$xh=(0,w.$qh)(e.$wh)}),define(Ae[91],Fe([1,0,140,3]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Pn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=void 0,e.$Dn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$En=new RegExp(e.$Dn),e.$Fn="__web_extension",e.$Gn="skipWalkthrough",e.$Hn="extensionsSync";function C(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$In=C;function M(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Jn=M;function P(a,m){switch(a){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Kn=P;function g(a,m){return m==="web"&&!a.includes("web")}e.$Ln=g;function D(a,m,S){return g(m,S)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===S?!0:p(S).includes(a)}e.$Mn=D;function p(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Nn=p;function A(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.$On=A;var E;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var c;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(c||(e.SortOrder=c={}));var y;(function(a){a.Install="install",a.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var b;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$Pn=(0,T.$ph)("extensionGalleryService");var o;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(o||(e.ExtensionManagementErrorCode=o={}));var t;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(m,S){super(m),this.code=S,this.name=S}}e.$Qn=i,e.$Rn=(0,T.$ph)("extensionManagementService"),e.$Sn="extensionsIdentifiers/disabled",e.$Tn="extensionsIdentifiers/enabled",e.$Un=(0,T.$ph)("IGlobalExtensionEnablementService"),e.$Vn=(0,T.$ph)("IExtensionTipsService"),e.$Wn=(0,w.localize)(0,null),e.$Xn={value:e.$Wn,original:"Extensions"},e.$Yn={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Ae[38],Fe([1,0,48,19,15,12,2,142,3,22,13]),function($e,e,w,T,C,M,P,g,D,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileKind=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileOperationResult=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileChangeType=e.$0j=e.FileOperation=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.FileSystemProviderErrorCode=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tj=e.$Sj=void 0,e.$Sj=(0,D.$ph)("fileService");function E(Z){return Z.create===!0}e.$Tj=E;var c;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var y;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(y||(e.FilePermission=y={}));var b;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function o(Z){return!!(Z.capabilities&2)}e.$Uj=o;function t(Z){return!!(Z.capabilities&8)}e.$Vj=t;function i(Z){return!!(Z.capabilities&131072)}e.$Wj=i;function a(Z){return!!(Z.capabilities&4)}e.$Xj=a;function m(Z){return!!(Z.capabilities&16)}e.$Yj=m;function S(Z){return o(Z)?!!(Z.capabilities&16384):!1}e.$Zj=S;function I(Z){return o(Z)?!!(Z.capabilities&32768):!1}e.$1j=I;function r(Z){return!!(Z.capabilities&65536)}e.$2j=r;function h(Z){return!!(Z.capabilities&2048)}e.$3j=h;var n;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class s extends Error{static create(he,Ce){const H=new s(he.toString(),Ce);return l(H,Ce),H}constructor(he,Ce){super(he),this.code=Ce}}e.$4j=s;function $(Z,he){return s.create(Z,he)}e.$5j=$;function k(Z){return Z||$((0,g.localize)(0,null),n.Unknown)}e.$6j=k;function l(Z,he){return Z.name=he?`${he} (FileSystemError)`:"FileSystemError",Z}e.$7j=l;function f(Z){if(!Z)return n.Unknown;if(Z instanceof s)return Z.code;const he=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!he)return n.Unknown;switch(he[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$8j=f;function v(Z){if(Z instanceof q)return Z.fileOperationResult;switch(f(Z)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$9j=v;var u;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(u||(e.FileOperation=u={}));class d{constructor(he,Ce,H){this.resource=he,this.operation=Ce,this.target=H}isOperation(he){return this.operation===he}}e.$0j=d;var R;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(R||(e.FileChangeType=R={}));class W{constructor(he,Ce){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const H=new Map;for(const ne of he){const re=H.get(ne.type);switch(re?re.push([ne.resource,ne]):H.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,re]of H)switch(ne){case 1:this.a=w.$vh.forUris(()=>Ce),this.a.fill(re);break;case 0:this.b=w.$vh.forUris(()=>Ce),this.b.fill(re);break;case 2:this.c=w.$vh.forUris(()=>Ce),this.c.fill(re);break}}contains(he,...Ce){return this.d(he,{includeChildren:!1},...Ce)}affects(he,...Ce){return this.d(he,{includeChildren:!0},...Ce)}d(he,Ce,...H){if(!he)return!1;const ne=H.length>0;return!!((!ne||H.includes(1))&&(this.a?.get(he)||Ce.includeChildren&&this.a?.findSuperstr(he))||(!ne||H.includes(0))&&(this.b?.get(he)||Ce.includeChildren&&this.b?.findSuperstr(he))||(!ne||H.includes(2))&&(this.c?.findSubstr(he)||Ce.includeChildren&&this.c?.findSuperstr(he)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$$j=W;function B(Z,he,Ce){return!Z||!he||Z===he||he.length>Z.length?!1:(he.charAt(he.length-1)!==T.sep&&(he+=T.sep),Ce?(0,C.$Nd)(Z,he):Z.indexOf(he)===0)}e.$_j=B;class q extends Error{constructor(he,Ce,H){super(he),this.fileOperationResult=Ce,this.options=H}}e.$ak=q;class U extends q{constructor(he,Ce,H,ne){super(he,Ce,ne),this.fileOperationResult=Ce,this.size=H}}e.$bk=U;class N extends q{constructor(he,Ce,H){super(he,2,H),this.stat=Ce}}e.$ck=N;var O;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(O||(e.FileOperationResult=O={})),e.$dk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ek={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$fk="files.associations",e.$gk="files.exclude",e.$hk="files.readonlyInclude",e.$ik="files.readonlyExclude",e.$jk="files.readonlyFromPermissions";var ce;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$kk="";function X(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}e.$lk=X;async function be(Z,he){if(!he.hasProvider(P.URI.from({scheme:Z.scheme})))return new Promise(Ce=>{const H=he.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===Z.scheme&&ne.added&&(H.dispose(),Ce())})})}e.$mk=be;class Ee{static{this.KB=1024}static{this.MB=Ee.KB*Ee.KB}static{this.GB=Ee.MB*Ee.KB}static{this.TB=Ee.GB*Ee.KB}static formatSize(he){return(0,M.$ne)(he)||(he=0),he<Ee.KB?(0,g.localize)(1,null,he.toFixed(0)):he<Ee.MB?(0,g.localize)(2,null,(he/Ee.KB).toFixed(2)):he<Ee.GB?(0,g.localize)(3,null,(he/Ee.MB).toFixed(2)):he<Ee.TB?(0,g.localize)(4,null,(he/Ee.GB).toFixed(2)):(0,g.localize)(5,null,(he/Ee.TB).toFixed(2))}}e.$nk=Ee;function Re(Z){const he=typeof Z=="string"||Z?.scheme===A.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===A.Schemas.file?1024*Ee.MB:he?10*Ee.MB:p.$o?50*Ee.MB:1024*Ee.MB}e.$ok=Re}),define(Ae[72],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=void 0;class w{constructor(...C){this.a=new Map;for(const[M,P]of C)this.set(M,P)}set(C,M){const P=this.a.get(C);return this.a.set(C,M),P}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$nh=w}),define(Ae[172],Fe([1,0,16,11,6,70,170,3,72,173]),function($e,e,w,T,C,M,P,g,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0;const A=!1;class E extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class c{constructor(t=new D.$nh,i=!1,a,m=A){this.f=t,this.g=i,this.h=a,this.i=m,this.o=new Set,this.f.set(g.$oh,this),this._globalGraph=m?a?._globalGraph??new P.$Tp(S=>S):void 0}createChild(t){return new c(t,this.g,this,this.i)}invokeFunction(t,...i){const a=b.traceInvocation(this.i,t);let m=!1;try{return t({get:I=>{if(m)throw(0,T.$6)("service accessor is only valid during the invocation of its target method");const r=this.m(I,a);if(!r)throw new Error(`[invokeFunction] unknown service '${I}'`);return r}},...i)}finally{m=!0,a.stop()}}createInstance(t,...i){let a,m;return t instanceof M.$mh?(a=b.traceCreation(this.i,t.ctor),m=this.j(t.ctor,t.staticArguments.concat(i),a)):(a=b.traceCreation(this.i,t),m=this.j(t,i,a)),a.stop(),m}j(t,i=[],a){const m=g._util.getServiceDependencies(t).sort((r,h)=>r.index-h.index),S=[];for(const r of m){const h=this.m(r.id,a);h||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),S.push(h)}const I=m.length>0?m[0].index:i.length;if(i.length!==I){console.trace(`[createInstance] First service dependency of ${t.name} at position ${I+1} conflicts with ${i.length} static arguments`);const r=I-i.length;r>0?i=i.concat(new Array(r)):i=i.slice(0,I)}return Reflect.construct(t,i.concat(S))}k(t,i){if(this.f.get(t)instanceof M.$mh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const a=this.l(t);return a instanceof M.$mh?this.q(t,a,i.branch(t,!0)):(i.branch(t,!1),a)}q(t,i,a){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,a)}finally{this.o.delete(t)}}r(t,i,a){const m=new P.$Tp(r=>r.id.toString());let S=0;const I=[{id:t,desc:i,_trace:a}];for(;I.length;){const r=I.pop();if(m.lookupOrInsertNode(r),S++>1e3)throw new E(m);for(const h of g._util.getServiceDependencies(r.desc.ctor)){const n=this.l(h.id);if(n||this.u(`[createInstance] ${t} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(h.id)),n instanceof M.$mh){const s={id:h.id,desc:n,_trace:r._trace.branch(h.id,!0)};m.insertEdge(r,s),I.push(s)}}}for(;;){const r=m.roots();if(r.length===0){if(!m.isEmpty())throw new E(m);break}for(const{data:h}of r){if(this.l(h.id)instanceof M.$mh){const s=this.s(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this.k(h.id,s)}m.removeNode(h)}}return this.l(t)}s(t,i,a=[],m,S){if(this.f.get(t)instanceof M.$mh)return this.t(t,i,a,m,S);if(this.h)return this.h.s(t,i,a,m,S);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,a=[],m,S){if(m){const I=new c(void 0,this.g,this,this.i);I.c=String(t);const r=new Map,h=new w.$Lg(()=>{const n=I.j(i,a,S);for(const[s,$]of r){const k=n[s];if(typeof k=="function")for(const l of $)k.apply(n,l)}return r.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!h.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let l=r.get(s);return l||(l=new p.$lc,r.set(s,l)),(v,u,d)=>{const R=l.push([v,u,d]);return(0,C.$jb)(R)}}if(s in n)return n[s];const $=h.value;let k=$[s];return typeof k!="function"||(k=k.bind($),n[s]=k),k},set(n,s,$){return h.value[s]=$,!0},getPrototypeOf(n){return i.prototype}})}else return this.j(i,a,S)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$Up=c;var y;(function(o){o[o.None=0]="None",o[o.Creation=1]="Creation",o[o.Invocation=2]="Invocation",o[o.Branch=3]="Branch"})(y||(y={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new b(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(t,i){return t?new b(1,i.name):b.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const a=new b(3,t.toString());return this.h.push([t,i,a]),a}stop(){const t=Date.now()-this.g;b.f+=t;let i=!1;function a(S,I){const r=[],h=new Array(S+1).join("	");for(const[n,s,$]of I.h)if(s&&$){i=!0,r.push(`${h}CREATES -> ${n}`);const k=a(S+1,$);k&&r.push(k)}else r.push(`${h}uses -> ${n}`);return r.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(t>2||i)&&b.all.add(m.join(`
`))}}e.$Vp=b}),define(Ae[14],Fe([1,0,41,5,92,6,28,22,23,12,2,31,3]),function($e,e,w,T,C,M,P,g,D,p,A,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.log=e.$Ui=e.LogLevel=e.$Ti=e.$Si=e.$Ri=void 0,e.$Ri=(0,c.$ph)("logService"),e.$Si=(0,c.$ph)("loggerService");function y(){return new Date().toISOString()}function b(v){return(0,p.$ne)(v)}e.$Ti=b;var o;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$Ui=o.Info;function t(v,u,d){switch(u){case o.Trace:v.trace(d);break;case o.Debug:v.debug(d);break;case o.Info:v.info(d);break;case o.Warning:v.warn(d);break;case o.Error:v.error(d);break;case o.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=t;function i(v,u=!1){let d="";for(let R=0;R<v.length;R++){let W=v[R];if(W instanceof Error&&(W=(0,w.$ai)(W,u)),typeof W=="object")try{W=JSON.stringify(W)}catch{}d+=(R>0?" ":"")+W}return d}class a extends M.$lb{constructor(){super(...arguments),this.b=e.$Ui,this.c=this.B(new T.$8c),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==o.Off&&this.b<=u}}e.$Wi=a;class m extends a{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...d){this.f(o.Trace)&&this.g(o.Trace,i([u,...d],!0))}debug(u,...d){this.f(o.Debug)&&this.g(o.Debug,i([u,...d]))}info(u,...d){this.f(o.Info)&&this.g(o.Info,i([u,...d]))}warn(u,...d){this.f(o.Warning)&&this.g(o.Warning,i([u,...d]))}error(u,...d){if(this.f(o.Error))if(u instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=u.stack,this.g(o.Error,i(R))}else this.g(o.Error,i([u,...d]))}flush(){}}e.$Xi=m;class S extends a{constructor(u=e.$Ui){super(),this.setLevel(u),this.g=!g.$i}trace(u,...d){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,u,...d):console.log(`[main ${y()}]`,u,...d))}debug(u,...d){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,u,...d):console.log(`[main ${y()}]`,u,...d))}info(u,...d){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,u,...d):console.log(`[main ${y()}]`,u,...d))}warn(u,...d){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,u,...d):console.warn(`[main ${y()}]`,u,...d))}error(u,...d){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,u,...d):console.error(`[main ${y()}]`,u,...d))}dispose(){}flush(){}}e.$Yi=S;class I extends a{constructor(u=e.$Ui,d=!0){super(),this.g=d,this.setLevel(u)}trace(u,...d){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",u,...d):console.log(u,...d))}debug(u,...d){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",u,...d):console.log(u,...d))}info(u,...d){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",u,...d):console.log(u,...d))}warn(u,...d){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",u,...d):console.log(u,...d))}error(u,...d){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",u,...d):console.error(u,...d))}dispose(){}flush(){}}e.$Zi=I;class r extends a{constructor(u,d=e.$Ui){super(),this.g=u,this.setLevel(d)}trace(u,...d){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(u),...d])}debug(u,...d){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(u),...d])}info(u,...d){this.f(o.Info)&&this.g.log(o.Info,[this.h(u),...d])}warn(u,...d){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(u),...d])}error(u,...d){this.f(o.Error)&&this.g.log(o.Error,[this.h(u),...d])}h(u){return typeof u=="string"?u:(0,w.$ai)(u,this.f(o.Trace))}dispose(){}flush(){}}e.$1i=r;class h extends a{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const d of this.g)d.setLevel(u);super.setLevel(u)}trace(u,...d){for(const R of this.g)R.trace(u,...d)}debug(u,...d){for(const R of this.g)R.debug(u,...d)}info(u,...d){for(const R of this.g)R.info(u,...d)}warn(u,...d){for(const R of this.g)R.warn(u,...d)}error(u,...d){for(const R of this.g)R.error(u,...d)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose()}}e.$2i=h;class n extends M.$lb{constructor(u,d,R){if(super(),this.h=u,this.j=d,this.b=new P.$ni,this.c=this.B(new T.$8c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$8c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$8c),this.onDidChangeVisibility=this.g.event,R)for(const W of R)this.b.set(W.resource,{logger:void 0,info:W})}k(u){return(0,p.$je)(u)?[...this.b.values()].find(d=>d.info.id===u):this.b.get(u)}getLogger(u){return this.k(u)?.logger}createLogger(u,d){const R=this.l(u),W=(0,p.$je)(u)?u:d?.id??(0,C.$di)(R.toString()).toString(16);let B=this.b.get(R)?.logger;const q=d?.logLevel==="always"?o.Trace:d?.logLevel;B||(B=this.m(R,q??this.getLogLevel(R)??this.h,{...d,id:W}));const U={logger:B,info:{resource:R,id:W,logLevel:q,name:d?.name,hidden:d?.hidden,extensionId:d?.extensionId,when:d?.when}};return this.registerLogger(U.info),this.b.set(R,U),B}l(u){return(0,p.$je)(u)?(0,D.$0f)(this.j,`${u}.log`):u}setLogLevel(u,d){if(A.URI.isUri(u)){const R=u,W=d,B=this.b.get(R);B&&W!==B.info.logLevel&&(B.info.logLevel=W===this.h?void 0:W,B.logger?.setLevel(W),this.b.set(B.info.resource,B),this.f.fire([R,W]))}else{this.h=u;for(const[R,W]of this.b.entries())this.b.get(R)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(u,d){const R=this.k(u);R&&d!==!R.info.hidden&&(R.info.hidden=!d,this.b.set(R.info.resource,R),this.g.fire([R.info.resource,d]))}getLogLevel(u){let d;return u&&(d=this.b.get(u)?.info.logLevel),d??this.h}registerLogger(u){const d=this.b.get(u.resource);d?d.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.b.set(u.resource,{info:u,logger:void 0}),this.c.fire({added:[u],removed:[]}))}deregisterLogger(u){const d=this.b.get(u);d&&(d.logger&&d.logger.dispose(),this.b.delete(u),this.c.fire({added:[],removed:[d.info]}))}*getRegisteredLoggers(){for(const u of this.b.values())yield u.info}getRegisteredLogger(u){return this.b.get(u)?.info}dispose(){this.b.forEach(u=>u.logger?.dispose()),this.b.clear(),super.dispose()}}e.$3i=n;class s{constructor(){this.onDidChangeLogLevel=new T.$8c().event}setLevel(u){}getLevel(){return o.Info}trace(u,...d){}debug(u,...d){}info(u,...d){}warn(u,...d){}error(u,...d){}critical(u,...d){}dispose(){}flush(){}}e.$4i=s;class $ extends s{}e.$5i=$;function k(v){if(v.verbose)return o.Trace;if(typeof v.logLevel=="string"){const u=f(v.logLevel.toLowerCase());if(u!==void 0)return u}return e.$Ui}e.$6i=k;function l(v){switch(v){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}e.$7i=l;function f(v){switch(v){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$8i=f,e.$9i=new E.$Oi("logLevel",l(o.Info))}),define(Ae[174],Fe([1,0,6,14]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=void 0;class C extends w.$lb{constructor(P,g=[]){super(),this.a=new T.$2i([P,...g]),this.B(P.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...g){this.a.trace(P,...g)}debug(P,...g){this.a.debug(P,...g)}info(P,...g){this.a.info(P,...g)}warn(P,...g){this.a.warn(P,...g)}error(P,...g){this.a.error(P,...g)}flush(){this.a.flush()}}e.$1M=C}),define(Ae[93],Fe([1,0,29,143,3]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var P;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(P||(e.MarkerSeverity=P={})),function(D){function p(b,o){return o-b}D.compare=p;const A=Object.create(null);A[D.Error]=(0,T.localize)(0,null),A[D.Warning]=(0,T.localize)(1,null),A[D.Info]=(0,T.localize)(2,null);function E(b){return A[b]||""}D.toString=E;function c(b){switch(b){case w.default.Error:return D.Error;case w.default.Warning:return D.Warning;case w.default.Info:return D.Info;case w.default.Ignore:return D.Hint}}D.fromSeverity=c;function y(b){switch(b){case D.Error:return w.default.Error;case D.Warning:return w.default.Warning;case D.Info:return w.default.Info;case D.Hint:return w.default.Ignore}}D.toSeverity=y}(P||(e.MarkerSeverity=P={}));var g;(function(D){const p="";function A(c){return E(c,!0)}D.makeKey=A;function E(c,y){const b=[p];return c.source?b.push(c.source.replace("\xA6","\\\xA6")):b.push(p),c.code?typeof c.code=="string"?b.push(c.code.replace("\xA6","\\\xA6")):b.push(c.code.value.replace("\xA6","\\\xA6")):b.push(p),c.severity!==void 0&&c.severity!==null?b.push(P.toString(c.severity)):b.push(p),c.message&&y?b.push(c.message.replace("\xA6","\\\xA6")):b.push(p),c.startLineNumber!==void 0&&c.startLineNumber!==null?b.push(c.startLineNumber.toString()):b.push(p),c.startColumn!==void 0&&c.startColumn!==null?b.push(c.startColumn.toString()):b.push(p),c.endLineNumber!==void 0&&c.endLineNumber!==null?b.push(c.endLineNumber.toString()):b.push(p),c.endColumn!==void 0&&c.endColumn!==null?b.push(c.endColumn.toString()):b.push(p),b.push(p),b.join("\xA6")}D.makeKeyOptionalMessage=E})(g||(e.IMarkerData=g={})),e.$ls=(0,C.$ph)("markerService")}),define(Ae[175],Fe([1,0,5,29,3]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ku=e.$Ju=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Iu=e.Severity=void 0,e.Severity=T.default,e.$Iu=(0,C.$ph)("notificationService");var M;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var P;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(P||(e.NeverShowAgainScope=P={}));var g;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(g||(e.NotificationsFilter=g={}));class D{constructor(){this.progress=new p,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(E){}updateMessage(E){}updateActions(E){}close(){}}e.$Ju=D;class p{infinite(){}done(){}total(E){}worked(E){}}e.$Ku=p}),define(Ae[94],Fe([1,0,15,2,3]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cZ=e.$bZ=e.$aZ=e.$_Y=e.$$Y=void 0,e.$$Y=(0,C.$ph)("openerService");function M(p,A){return T.URI.isUri(p)?(0,w.$Md)(p.scheme,A):(0,w.$Nd)(p,A+":")}e.$_Y=M;function P(p,...A){return A.some(E=>M(p,E))}e.$aZ=P;function g(p,A){return p.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$bZ=g;function D(p){let A;const E=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(p.fragment);return E&&(A={startLineNumber:parseInt(E[1]),startColumn:E[2]?parseInt(E[2]):1,endLineNumber:E[4]?parseInt(E[4]):void 0,endColumn:E[4]?E[5]?parseInt(E[5]):1:void 0},p=p.with({fragment:""})),{selection:A,uri:p}}e.$cZ=D}),define(Ae[176],Fe([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=void 0,e.$0i=(0,w.$ph)("productService"),e.$$i="vscode://schemas/vscode-product"});var Ve=this&&this.__decorate||function($e,e,w,T){var C=arguments.length,M=C<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,w):T,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate($e,e,w,T);else for(var g=$e.length-1;g>=0;g--)(P=$e[g])&&(M=(C<3?P(M):C>3?P(e,w,M):P(e,w))||M);return C>3&&M&&Object.defineProperty(e,w,M),M},qe=this&&this.__param||function($e,e){return function(w,T){e(w,T,$e)}};define(Ae[177],Fe([1,0,16,20,6,3]),function($e,e,w,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qu=e.$Pu=e.$Ou=e.$Nu=e.$Mu=e.ProgressLocation=e.$Lu=void 0,e.$Lu=(0,M.$ph)("progressService");var P;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(P||(e.ProgressLocation=P={})),e.$Mu=Object.freeze({total(){},worked(){},done(){}});class g{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(E,c){this.c=E,this.report=c?.async?this.e.bind(this):this.d.bind(this)}d(E){this.a=E,this.c(this.a)}e(E){Promise.resolve(this.b).finally(()=>{this.a=E;const c=this.c(this.a);this.b=Promise.resolve(c).finally(()=>this.b=void 0)})}}e.$Nu=g;let D=class extends C.$lb{constructor(E,c){super(),this.a=new w.$Pg,c.withProgress(E,y=>(this.b=y,this.c&&y.report(this.c),this.a.p)),this.B((0,C.$jb)(()=>this.a.complete()))}report(E){this.b?this.b.report(E):this.c=E}};e.$Ou=D,e.$Ou=D=Ve([qe(1,e.$Lu)],D);class p extends C.$lb{constructor(E){super(),this.g=E,this.a=0,this.b=this.B(new C.$kb)}start(E){this.stop();const c=++this.a,y=new T.$ed;return this.f=setTimeout(()=>{c===this.a&&(this.c=this.g.show(!0))},E),this.b.add((0,C.$jb)(()=>clearTimeout(this.f))),this.b.add((0,C.$jb)(()=>y.cancel())),this.b.add((0,C.$jb)(()=>this.c?this.c.done():void 0)),{id:c,token:y.token,stop:()=>this.h(c),isCurrent:()=>this.a===c}}stop(){this.h(this.a)}h(E){this.a===E&&this.b.clear()}}e.$Pu=p,e.$Qu=(0,M.$ph)("editorProgressService")}),define(Ae[30],Fe([1,0,50,12]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=void 0;class C{constructor(){this.a=new Map}add(P,g){w.ok(T.$je(P)),w.ok(T.$le(g)),w.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,g)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.$Tm=new C}),define(Ae[73],Fe([1,0,5,30]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0,e.$Um={JSONContribution:"base.contributions.json"};function C(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class M{constructor(){this.b=new w.$8c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,p){this.a[C(D)]=p,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const P=new M;T.$Tm.add(e.$Um.JSONContribution,P)}),define(Ae[95],Fe([1,0,18,5,12,137,43,73,30]),function($e,e,w,T,C,M,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.ConfigurationScope=e.$Ym=e.EditPresentationTypes=void 0;var p;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(p||(e.EditPresentationTypes=p={})),e.$Ym={Configuration:"base.contributions.configuration"};var A;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m={properties:{},patternProperties:{}},e.$5m={properties:{},patternProperties:{}},e.$6m="vscode://schemas/settings/resourceLanguage",e.$7m="vscode://schemas/settings/configurationDefaults";const E=D.$Tm.as(g.$Um.JSONContribution);class c{constructor(){this.h=new Set,this.i=new T.$8c,this.onDidSchemaChange=this.i.event,this.j=new T.$8c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$6m,this.g),this.v()}registerConfiguration(r,h=!0){this.registerConfigurations([r],h)}registerConfigurations(r,h=!0){const n=new Set;this.n(r,h,n),E.registerSchema(e.$6m,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(r){const h=new Set;this.o(r,h),E.registerSchema(e.$6m,this.g),this.i.fire(),this.j.fire({properties:h})}updateConfigurations({add:r,remove:h}){const n=new Set;this.o(h,n),this.n(r,!1,n),E.registerSchema(e.$6m,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(r){const h=new Set;this.k(r,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}k(r,h){const n=[];for(const{overrides:s,source:$}of r)for(const k in s)if(h.add(k),e.$9m.test(k)){const l=this.a.get(k),f=l?.valuesSources??new Map;if($)for(const R of Object.keys(s[k]))f.set(R,$);const v={...l?.value||{},...s[k]};this.a.set(k,{source:$,value:v,valuesSources:f});const u=(0,P.$6h)(k),d={type:"object",default:v,description:M.localize(1,null,u),$ref:e.$6m,defaultDefaultValue:v,source:C.$je($)?void 0:$,defaultValueSource:$};n.push(...o(k)),this.d[k]=d,this.b.properties[k]=d}else{this.a.set(k,{value:s[k],source:$});const l=this.d[k];l&&(this.w(k,l),this.r(k,l))}this.m(n)}deregisterDefaultConfigurations(r){const h=new Set;this.l(r,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}l(r,h){for(const{overrides:n,source:s}of r)for(const $ in n){const k=this.a.get($),l=C.$je(s)?s:s?.id,f=C.$je(k?.source)?k?.source:k?.source?.id;if(l===f)if(h.add($),this.a.delete($),e.$9m.test($))delete this.d[$],delete this.b.properties[$];else{const v=this.d[$];v&&(this.w($,v),this.r($,v))}}this.u()}deltaConfiguration(r){let h=!1;const n=new Set;r.removedDefaults&&(this.l(r.removedDefaults,n),h=!0),r.addedDefaults&&(this.k(r.addedDefaults,n),h=!0),r.removedConfigurations&&this.o(r.removedConfigurations,n),r.addedConfigurations&&this.n(r.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:h})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const h of r)this.h.add(h);this.u()}n(r,h,n){r.forEach(s=>{this.p(s,h,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(r,h){const n=s=>{if(s.properties)for(const $ in s.properties){h.add($);const k=this.d[$];k?.policy?.name&&this.e.delete(k.policy.name),delete this.d[$],this.s($,s.properties[$])}s.allOf?.forEach($=>n($))};for(const s of r){n(s);const $=this.c.indexOf(s);$!==-1&&this.c.splice($,1)}}p(r,h=!0,n,s,$=3,k){$=C.$se(r.scope)?$:r.scope;const l=r.properties;if(l)for(const v in l){const u=l[v];if(h&&m(v,u)){delete l[v];continue}if(u.source=n,u.defaultDefaultValue=l[v].default,this.w(v,u),e.$9m.test(v)?u.scope=void 0:(u.scope=C.$se(u.scope)?$:u.scope,u.restricted=C.$se(u.restricted)?!!s?.includes(v):u.restricted),l[v].hasOwnProperty("included")&&!l[v].included){this.f[v]=l[v],delete l[v];continue}else this.d[v]=l[v],l[v].policy?.name&&this.e.set(l[v].policy.name,v);!l[v].deprecationMessage&&l[v].markdownDeprecationMessage&&(l[v].deprecationMessage=l[v].markdownDeprecationMessage),k.add(v)}const f=r.allOf;if(f)for(const v of f)this.p(v,h,n,s,$,k)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const h=n=>{const s=n.properties;if(s)for(const k in s)this.r(k,s[k]);n.allOf?.forEach(h)};h(r)}r(r,h){switch(e.$Zm.properties[r]=h,h.scope){case 1:e.$1m.properties[r]=h;break;case 2:e.$2m.properties[r]=h;break;case 6:e.$3m.properties[r]=h;break;case 3:e.$4m.properties[r]=h;break;case 4:e.$5m.properties[r]=h;break;case 5:e.$5m.properties[r]=h,this.g.properties[r]=h;break}}s(r,h){switch(delete e.$Zm.properties[r],h.scope){case 1:delete e.$1m.properties[r];break;case 2:delete e.$2m.properties[r];break;case 6:delete e.$3m.properties[r];break;case 3:delete e.$4m.properties[r];break;case 4:case 5:delete e.$5m.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const h=`[${r}]`,n={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$6m};this.w(h,n),e.$Zm.properties[h]=n,e.$1m.properties[h]=n,e.$2m.properties[h]=n,e.$3m.properties[h]=n,e.$4m.properties[h]=n,e.$5m.properties[h]=n}}v(){const r={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$6m};e.$Zm.patternProperties[e.$8m]=r,e.$1m.patternProperties[e.$8m]=r,e.$2m.patternProperties[e.$8m]=r,e.$3m.patternProperties[e.$8m]=r,e.$4m.patternProperties[e.$8m]=r,e.$5m.patternProperties[e.$8m]=r,this.i.fire()}w(r,h){const n=this.a.get(r);let s=n?.value,$=n?.source;C.$qe(s)&&(s=h.defaultDefaultValue,$=void 0),C.$qe(s)&&(s=i(h.type)),h.default=s,h.defaultValueSource=$}}const y="\\[([^\\]]+)\\]",b=new RegExp(y,"g");e.$8m=`^(${y})+$`,e.$9m=new RegExp(e.$8m);function o(I){const r=[];if(e.$9m.test(I)){let h=b.exec(I);for(;h?.length;){const n=h[1].trim();n&&r.push(n),h=b.exec(I)}}return(0,w.$rf)(r)}e.$0m=o;function t(I){return I.reduce((r,h)=>`${r}[${h}]`,"")}e.$$m=t;function i(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$_m=i;const a=new c;D.$Tm.add(e.$Ym.Configuration,a);function m(I,r){return I.trim()?e.$9m.test(I)?M.localize(7,null,I):a.getConfigurationProperties()[I]!==void 0?M.localize(8,null,I):r.policy?.name&&a.getPolicyConfigurations().get(r.policy?.name)!==void 0?M.localize(9,null,I,r.policy?.name,a.getPolicyConfigurations().get(r.policy?.name)):null:M.localize(6,null)}e.$an=m;function S(){const I=[],r=a.getConfigurationProperties();for(const h of Object.keys(r))I.push([h,r[h].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.$bn=S}),define(Ae[178],Fe([1,0,18,5,115,6,28,24,12,2,43,95,30]),function($e,e,w,T,C,M,P,g,D,p,A,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=void 0;function y(h){return Object.isFrozen(h)?h:g.$Im(h)}class b{constructor(n={},s=[],$=[],k){this.b=n,this.c=s,this.d=$,this.raw=k,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof b)return s;const $=new o("");return $.parseRaw(s),$.configurationModel});this.f=n.reduce((s,$)=>$===s?$:s.merge($),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,A.$4h)(this.contents,n):this.contents}inspect(n,s){const $=this.rawConfiguration.getValue(n),k=s?this.rawConfiguration.getOverrideValue(n,s):void 0,l=s?this.rawConfiguration.override(s).getValue(n):$;return{value:$,override:k,merged:l}}getOverrideValue(n,s){const $=this.i(s);return $?n?(0,A.$4h)($,n):$:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const $ of this.overrides)$.identifiers.includes(n)&&s.push(...$.keys);return w.$rf(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return w.$rf(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=g.$Hm(this.contents),$=g.$Hm(this.overrides),k=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const f of n)if(l.push(...f.raw?.length?f.raw:[f]),!f.isEmpty()){this.h(s,f.contents);for(const v of f.overrides){const[u]=$.filter(d=>w.$bf(d.identifiers,v.identifiers));u?(this.h(u.contents,v.contents),u.keys.push(...v.keys),u.keys=w.$rf(u.keys)):$.push(g.$Hm(v))}for(const v of f.keys)k.indexOf(v)===-1&&k.push(v)}return new b(s,k,$,l.every(f=>f instanceof b)?void 0:l)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const $={};for(const k of w.$rf([...Object.keys(this.contents),...Object.keys(s)])){let l=this.contents[k];const f=s[k];f&&(typeof l=="object"&&typeof f=="object"?(l=g.$Hm(l),this.h(l,f)):l=f),$[k]=l}return new b($,this.keys,this.overrides)}h(n,s){for(const $ of Object.keys(s)){if($ in n&&D.$le(n[$])&&D.$le(s[$])){this.h(n[$],s[$]);continue}n[$]=g.$Hm(s[$])}}i(n){let s=null,$=null;const k=l=>{l&&($?this.h($,l):$=g.$Hm(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===n?s=l.contents:l.identifiers.includes(n)&&k(l.contents);return k(s),$}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,A.$3h)(this.contents,n),E.$9m.test(n)&&this.overrides.splice(this.overrides.findIndex($=>w.$bf($.identifiers,(0,E.$0m)(n))),1))}j(n,s,$){(0,A.$2h)(this.contents,n,s,k=>console.error(k)),$=$||this.keys.indexOf(n)===-1,$&&this.keys.push(n),E.$9m.test(n)&&this.overrides.push({identifiers:(0,E.$0m)(n),keys:Object.keys(this.contents[n]),contents:(0,A.$1h)(this.contents[n],k=>console.error(k))})}}e.$cn=b;class o{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!D.$se(n)){const $=this.g(n);this.parseRaw($,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:$,keys:k,overrides:l,restricted:f,hasExcludedProperties:v}=this.h(n,s);this.b=new b($,k,l,v?[n]:void 0),this.c=f||[]}g(n){let s={},$=null,k=[];const l=[],f=[];function v(d){Array.isArray(k)?k.push(d):$!==null&&(k[$]=d)}const u={onObjectBegin:()=>{const d={};v(d),l.push(k),k=d,$=null},onObjectProperty:d=>{$=d},onObjectEnd:()=>{k=l.pop()},onArrayBegin:()=>{const d=[];v(d),l.push(k),k=d,$=null},onArrayEnd:()=>{k=l.pop()},onLiteralValue:v,onError:(d,R,W)=>{f.push({error:d,offset:R,length:W})}};if(n)try{C.$Em(n,u),s=k[0]||{}}catch(d){console.error(`Error while parsing settings file ${this.f}: ${d}`),this.d=[d]}return s}h(n,s){const $=c.$Tm.as(E.$Ym.Configuration).getConfigurationProperties(),k=this.i(n,$,!0,s);n=k.raw;const l=(0,A.$1h)(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`)),f=Object.keys(n),v=this.j(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`));return{contents:l,keys:f,overrides:v,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}i(n,s,$,k){let l=!1;if(!k?.scopes&&!k?.skipRestricted&&!k?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:l};const f={},v=[];for(const u in n)if(E.$9m.test(u)&&$){const d=this.i(n[u],s,!1,k);f[u]=d.raw,l=l||d.hasExcludedProperties,v.push(...d.restricted)}else{const d=s[u],R=d?typeof d.scope<"u"?d.scope:3:void 0;d?.restricted&&v.push(u),!k.exclude?.includes(u)&&(k.include?.includes(u)||(R===void 0||k.scopes===void 0||k.scopes.includes(R))&&!(k.skipRestricted&&d?.restricted))?f[u]=n[u]:l=!0}return{raw:f,restricted:v,hasExcludedProperties:l}}j(n,s){const $=[];for(const k of Object.keys(n))if(E.$9m.test(k)){const l={};for(const f in n[k])l[f]=n[k][f];$.push({identifiers:(0,E.$0m)(k),keys:Object.keys(l),contents:(0,A.$1h)(l,s)})}return $}}e.$dn=o;class t extends M.$lb{constructor(n,s,$,k){super(),this.c=n,this.f=s,this.g=k,this.b=this.B(new T.$8c),this.onDidChange=this.b.event,this.a=new o(this.c.toString()),this.B(this.g.watch($.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&$.isEqual(l.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new b}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$en=t;class i{constructor(n,s,$,k,l,f,v,u,d,R,W,B,q){this.a=n,this.b=s,this.c=$,this.overrideIdentifiers=k,this.d=l,this.f=f,this.g=v,this.h=u,this.i=d,this.j=R,this.k=W,this.l=B,this.m=q}get value(){return y(this.c)}n(n,s,$){const k=n.inspect(s,$);return{get value(){return y(k.value)},get override(){return y(k.override)},get merged(){return y(k.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class a{constructor(n,s,$,k,l=new b,f=new b,v=new P.$ni,u=new b,d=new P.$ni){this.c=n,this.d=s,this.f=$,this.g=k,this.h=l,this.i=f,this.j=v,this.l=u,this.m=d,this.a=null,this.b=new P.$ni,this.n=null}getValue(n,s,$){return this.q(n,s,$).getValue(n)}updateValue(n,s,$={}){let k;$.resource?(k=this.m.get($.resource),k||(k=new b,this.m.set($.resource,k))):k=this.l,s===void 0?k.removeValue(n):k.setValue(n,s),$.resource||(this.a=null)}inspect(n,s,$){const k=this.q(n,s,$),l=this.u(s.resource,$),f=s.resource?this.m.get(s.resource)||this.l:this.l,v=new Set;for(const u of k.overrides)for(const d of u.identifiers)k.getOverrideValue(n,d)!==void 0&&v.add(d);return new i(n,s,k.getValue(n),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,$?this.i:void 0,l||void 0,f)}keys(n){const s=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const $=[];if(!s){const{added:k,updated:l,removed:f}=I(this.c,n);s=[...k,...l,...f]}for(const k of s)for(const l of(0,E.$0m)(k)){const f=this.c.getKeysForOverrideIdentifier(l),v=n.getKeysForOverrideIdentifier(l),u=[...v.filter(d=>f.indexOf(d)===-1),...f.filter(d=>v.indexOf(d)===-1),...f.filter(d=>!g.$Lm(this.c.override(l).getValue(d),n.override(l).getValue(d)))];$.push([l,u])}return this.updateDefaultConfiguration(n),{keys:s,overrides:$}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:$,removed:k}=I(this.d,n),l=[...s,...$,...k];return l.length&&this.updatePolicyConfiguration(n),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:$,removed:k,overrides:l}=I(this.applicationConfiguration,n),f=[...s,...$,...k];return f.length&&this.updateApplicationConfiguration(n),{keys:f,overrides:l}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:$,removed:k,overrides:l}=I(this.localUserConfiguration,n),f=[...s,...$,...k];return f.length&&this.updateLocalUserConfiguration(n),{keys:f,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:$,removed:k,overrides:l}=I(this.remoteUserConfiguration,n),f=[...s,...$,...k];return f.length&&this.updateRemoteUserConfiguration(n),{keys:f,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:$,removed:k,overrides:l}=I(this.workspaceConfiguration,n),f=[...s,...$,...k];return f.length&&this.updateWorkspaceConfiguration(n),{keys:f,overrides:l}}compareAndUpdateFolderConfiguration(n,s){const $=this.p.get(n),{added:k,updated:l,removed:f,overrides:v}=I($,s),u=[...k,...l,...f];return(u.length||!$)&&this.updateFolderConfiguration(n,s),{keys:u,overrides:v}}compareAndDeleteFolderConfiguration(n){const s=this.p.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:$,updated:k,removed:l,overrides:f}=I(s,void 0);return{keys:[...$,...k,...l],overrides:f}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,s,$){let k=this.r(s,$);return s.overrideIdentifier&&(k=k.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(k=k.merge(this.d)),k}r({resource:n},s){let $=this.s();if(s&&n){const k=s.getFolder(n);k&&($=this.t(k.uri)||$);const l=this.m.get(n);l&&($=$.merge(l))}return $}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let s=this.b.get(n);if(!s){const $=this.s(),k=this.j.get(n);k?(s=$.merge(k),this.b.set(n,s)):s=$}return s}u(n,s){if(s&&n){const $=s.getFolder(n);if($)return this.j.get($.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:$,overrides:k,keys:l}=this.j.get(s);return n.push([s,{contents:$,overrides:k,keys:l}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach($=>n.add($))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach($=>n.add($))),[...n.values()]}w(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach($=>s.add($)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach($=>s.add($)),this.i.getKeysForOverrideIdentifier(n).forEach($=>s.add($)),this.j.forEach($=>$.getKeysForOverrideIdentifier(n).forEach(k=>s.add(k))),[...s.values()]}static parse(n){const s=this.x(n.defaults),$=this.x(n.policy),k=this.x(n.application),l=this.x(n.user),f=this.x(n.workspace),v=n.folders.reduce((u,d)=>(u.set(p.URI.revive(d[0]),this.x(d[1])),u),new P.$ni);return new a(s,$,k,l,new b,f,v,new b,new P.$ni)}static x(n){return new b(n.contents,n.keys,n.overrides)}}e.$fn=a;function m(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const n=new Set,s=new Map;for(const k of h)k.keys.forEach(l=>n.add(l)),k.overrides.forEach(([l,f])=>{const v=(0,P.$ki)(s,l,new Set);f.forEach(u=>v.add(u))});const $=[];return s.forEach((k,l)=>$.push([l,[...k.values()]])),{keys:[...n.values()],overrides:$}}e.$gn=m;class S{constructor(n,s,$,k){this.change=n,this.f=s,this.g=$,this.h=k,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of n.keys)this.affectedKeys.add(l);for(const[,l]of n.overrides)for(const f of l)this.affectedKeys.add(f);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=a.parse(this.f.data)),this.i}affectsConfiguration(n,s){const $=this.a+n,k=this.d.indexOf($);if(k<0)return!1;const l=k+$.length;if(l>=this.d.length)return!1;const f=this.d.charCodeAt(l);if(f!==this.b&&f!==this.c)return!1;if(s){const v=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,u=this.g.getValue(n,s,this.h);return!g.$Lm(v,u)}return!0}}e.$hn=S;function I(h,n){const{added:s,removed:$,updated:k}=r(n?.rawConfiguration,h?.rawConfiguration),l=[],f=h?.getAllOverrideIdentifiers()||[],v=n?.getAllOverrideIdentifiers()||[];if(n){const u=v.filter(d=>!f.includes(d));for(const d of u)l.push([d,n.getKeysForOverrideIdentifier(d)])}if(h){const u=f.filter(d=>!v.includes(d));for(const d of u)l.push([d,h.getKeysForOverrideIdentifier(d)])}if(n&&h){for(const u of f)if(v.includes(u)){const d=r({contents:h.getOverrideValue(void 0,u)||{},keys:h.getKeysForOverrideIdentifier(u)},{contents:n.getOverrideValue(void 0,u)||{},keys:n.getKeysForOverrideIdentifier(u)});l.push([u,[...d.added,...d.removed,...d.updated]])}}return{added:s,removed:$,updated:k,overrides:l}}function r(h,n){const s=h?n?h.keys.filter(l=>n.keys.indexOf(l)===-1):[...h.keys]:[],$=n?h?n.keys.filter(l=>h.keys.indexOf(l)===-1):[...n.keys]:[],k=[];if(h&&n){for(const l of n.keys)if(h.keys.indexOf(l)!==-1){const f=(0,A.$4h)(n.contents,l),v=(0,A.$4h)(h.contents,l);g.$Lm(f,v)||k.push(l)}}return{added:s,removed:$,updated:k}}}),define(Ae[96],Fe([1,0,11,3]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.RemoteAuthorityResolverErrorCode=e.$yk=e.$xk=e.RemoteConnectionType=e.$wk=void 0,e.$wk=(0,T.$ph)("remoteAuthorityResolverService");var C;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class M{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$xk=M;class P{constructor(E,c){this.host=E,this.port=c,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$yk=P;var g;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(g||(e.RemoteAuthorityResolverErrorCode=g={}));class D extends w.$ab{static isNotAvailable(E){return E instanceof D&&E._code===g.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof D&&E._code===g.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof D&&E._code===g.NoResolverFound}static isInvalidAuthority(E){return E instanceof D&&E._code===g.InvalidAuthority}static isHandled(E){return E instanceof D&&E.isHandled}constructor(E,c=g.Unknown,y){super(E),this._message=E,this._code=c,this._detail=y,this.isHandled=c===g.NotAvailable&&y===!0,Object.setPrototypeOf(this,D.prototype)}}e.$zk=D;function p(A){const E=A.indexOf("+");return E===-1?A:A.substring(0,E)}e.$Ak=p}),define(Ae[51],Fe([1,0,13]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=void 0;function T(p){return p.scheme===w.Schemas.vscodeRemote?p.authority:void 0}e.$Bk=T;function C(p){if(!p)return;const A=p.indexOf("+");return A<0?p:p.substr(0,A)}e.$Ck=C;function M(p){return`/${p.quality??"oss"}-${p.commit??"dev"}`}e.$Dk=M;function P(p){const{host:A,port:E}=D(p);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:E}}e.$Ek=P;function g(p,A){let{host:E,port:c}=D(p);return typeof c>"u"&&(c=A),{host:E,port:c}}e.$Fk=g;function D(p){const A=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const E=p.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const c=p.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:p,port:void 0}}}),define(Ae[21],Fe([1,0,15,3,51]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.TargetPlatform=e.ExtensionType=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=void 0,e.$Bl="extensions.user.cache",e.$Cl="extensions.builtin.cache",e.$Dl="undefined_publisher",e.$El=["ui","workspace","web"];function M(o){if(typeof o=="object"&&o!==null&&o.supported!==!0)return o.description}e.$Fl=M,e.$Gl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(o){o[o.System=0]="System",o[o.User=1]="User"})(P||(e.ExtensionType=P={}));var g;(function(o){o.WIN32_X64="win32-x64",o.WIN32_IA32="win32-ia32",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(g||(e.TargetPlatform=g={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const a=typeof t=="string"?t:t.value,m=typeof i=="string"?i:i.value;return w.$Md(a,m)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$Hl=D;class p{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(D.toKey(t))}delete(t){return this.c.delete(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}}e.$Il=p;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(D.toKey(t))}get(t){return this.c.get(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}set(t,i){this.c.set(D.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Jl=A;function E(o){return c(o)}e.$Kl=E;function c(o){return o.contributes&&o.contributes.localizations?o.contributes.localizations.length>0:!1}e.$Ll=c;function y(o){return o.contributes&&o.contributes.authentication?o.contributes.authentication.length>0:!1}e.$Ml=y;function b(o,t){if(t){const i=`onResolveRemoteAuthority:${(0,C.$Ck)(t)}`;return!!o.activationEvents?.includes(i)}return!1}e.$Nl=b,e.$Ol=(0,T.$ph)("IBuiltinExtensionsScannerService")}),define(Ae[97],Fe([1,0,11,21]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kF=e.$jF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(P,g){this.a.set(P,g)}readActivationEvents(P){return this.b.has(P)||this.b.set(P,this.c(P)),this.b.get(P)}createActivationEventsMap(P){const g=Object.create(null);for(const D of P){const p=this.readActivationEvents(D);p.length>0&&(g[T.$Hl.toKey(D.identifier)]=p)}return g}c(P){if(typeof P.main>"u"&&typeof P.browser>"u")return[];const g=Array.isArray(P.activationEvents)?P.activationEvents.slice(0):[];if(!P.contributes)return g;for(const D in P.contributes){const p=this.a.get(D);if(!p)continue;const A=P.contributes[D],E=Array.isArray(A)?A:[A];try{p(E,g)}catch(c){(0,w.$Y)(c)}}return g}}e.$jF=C,e.$kF=new C}),define(Ae[179],Fe([1,0,22,52,36]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=void 0;function M(D){if(w.$t===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function P(D,p,A,E,c,y,b,o){const t=Object.create(null);t["common.machineId"]=y,t.sessionID=(0,C.$6e)()+Date.now(),t.commitHash=E,t.version=c,t["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,w.$h)(w.$t),t["common.nodePlatform"]=T.$7b,t["common.nodeArch"]=A,t["common.product"]=o||"desktop",b&&(t["common.msftInternal"]=b);let i=0;const a=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),w.$l&&(t["common.snap"]="true");const m=M(p);return m&&(t["common.platformDetail"]=m),t}e.$Zn=P;function g(D){const p=T.env.USERDNSDOMAIN;if(!p)return!1;const A=p.toLowerCase();return D.some(E=>A===E)}e.$1n=g}),define(Ae[180],Fe([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0,e.$Vk=(0,w.$ph)("telemetryService"),e.$Wk=(0,w.$ph)("customEndpointTelemetryService"),e.$Xk="telemetry.currentSessionDate",e.$Yk="telemetry.firstSessionDate",e.$Zk="telemetry.lastSessionDate",e.$1k="telemetry.machineId",e.$2k="telemetry",e.$3k="telemetry.telemetryLevel",e.$4k="telemetry.enableCrashReporter",e.$5k="telemetry.enableTelemetry";var T;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var C;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ae[53],Fe([1,0,24,12,5,43,51,179,180]),function($e,e,w,T,C,M,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0;class p{constructor($){this.value=$,this.isTrustedTelemetryValue=!0}}e.$2n=p;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$3n=A,e.$4n=new A;class E{async publicLog($,k,l){}async publicLogError($,k,l){}}e.$5n=E,e.$6n="telemetry",e.$7n="extensionTelemetryLog",e.$8n={log:()=>null,flush:()=>Promise.resolve(null)};function c(s,$){return C.Event.debounce($.onDidChangeConfiguration,(l,f)=>{const v=l?new Set([...l.affectedKeys,...f.affectedKeys]):f.affectedKeys;return{...f,affectedKeys:v}},1e3,!0)(l=>{l.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,M.$Yh)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$9n=c;function y(s,$){return!$.isBuilt&&!$.disableTelemetry?!0:!($.disableTelemetry||!s.enableTelemetry||$.extensionTestsLocationURI)}e.$0n=y;function b(s,$){return!($.isBuilt||$.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$$n=b;function o(s){const $=s.getValue(D.$3k),k=s.getValue(D.$4k);if(s.getValue(D.$5k)===!1||k===!1)return 0;switch($??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$_n=o;function t(s){const $={},k={},l={};m(s,l);for(let f in l){f=f.length>150?f.substr(f.length-149):f;const v=l[f];typeof v=="number"?k[f]=v:typeof v=="boolean"?k[f]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${f} has been trimmed to 8192, the original length is ${v.length}`),$[f]=v.substring(0,8191)):typeof v<"u"&&v!==null&&($[f]=v)}return{properties:$,measurements:k}}e.$ao=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(s){if(!s)return"none";const $=(0,P.$Ck)(s);return i.has($)?$:"other"}e.$bo=a;function m(s,$,k=0,l){if(s)for(const f of Object.getOwnPropertyNames(s)){const v=s[f],u=l?l+f:f;Array.isArray(v)?$[u]=(0,w.$Mm)(v):v instanceof Date?$[u]=v.toISOString():(0,T.$le)(v)?k<2?m(v,$,k+1,u+"."):$[u]=(0,w.$Mm)(v):$[u]=v}}function S(s,$){const k=s.msftInternalDomains||[],l=$.getValue("telemetry.internalTesting");return(0,g.$1n)(k)||l}e.$co=S;function I(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$do=I;function r(s,$){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let k=s;const l=[];for(const d of $)for(;;){const R=d.exec(s);if(!R)break;l.push([R.index,d.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(k="";;){const d=v.exec(s);if(!d)break;const R=l.some(([W,B])=>d.index<B&&W<v.lastIndex);!f.test(d[0])&&!R&&(k+=s.substring(u,d.index)+"<REDACTED: user-file-path>",u=v.lastIndex)}return u<s.length&&(k+=s.substr(u)),k}function h(s){if(!s)return s;const $=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const k of $)if(k.regex.test(s))return`<REDACTED: ${k.label}>`;return s}function n(s,$){return(0,w.$Jm)(s,k=>{if(k instanceof p||Object.hasOwnProperty.call(k,"isTrustedTelemetryValue"))return k.value;if(typeof k=="string"){let l=k.replaceAll("%20"," ");l=r(l,$);for(const f of $)l=l.replace(f,"");return l=h(l),l}})}e.$eo=n}),define(Ae[181],Fe([1,0,15,91,21,22,2,11,52,53]),function($e,e,w,T,C,M,P,g,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=void 0;function A(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,w.$Hd)(n.id,s.id)===0}e.$fo=A;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class c{static create(s){const $=s.manifest?s.manifest.version:s.version,k=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new c(s.identifier,$,k)}static parse(s){const $=E.exec(s);return $&&$[1]&&$[2]?new c({id:$[1]},$[2],$[4]||void 0):null}constructor(s,$,k="undefined"){this.version=$,this.targetPlatform=k,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof c?A(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$go=c;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(n){const s=y.exec(n);return s&&s[1]?[t(s[1]),s[2]]:[t(n),void 0]}e.$ho=b;function o(n,s){return`${n}.${s}`}e.$io=o;function t(n){return n.toLowerCase()}e.$jo=t;function i(n,s){return t(o(n??C.$Dl,s))}e.$ko=i;function a(n,s){const $=[],k=l=>{for(const f of $)if(f.some(v=>A(s(v),s(l))))return f;return null};for(const l of n){const f=k(l);f?f.push(l):$.push([l])}return $}e.$lo=a;function m(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$mo=m;function S(n){return{id:new p.$2n(n.identifier.id),name:new p.$2n(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$no=S,e.$oo=new C.$Hl("pprice.better-merge");function I(n,s){const $=[],k=s.manifest.extensionDependencies?.slice(0)??[];for(;k.length;){const l=k.shift();if(l&&$.every(f=>!A(f.identifier,{id:l}))){const f=n.filter(v=>A(v.identifier,{id:l}));f.length===1&&($.push(f[0]),k.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return $}e.$po=I;async function r(n,s){if(!M.$k)return!1;let $;try{$=(await n.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await n.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){s.debug("Error while getting the os-release file.",(0,g.$9)(l))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function h(n,s){const $=await r(n,s),k=(0,T.$Kn)($?"alpine":M.$t,D.$8b);return s.debug("ComputeTargetPlatform:",k),k}e.$qo=h}),define(Ae[182],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=e.$2q=e.$1q=e.$Zq=void 0;function w(D){return[...D.entries()]}e.$Zq=w;function T(D){return D?[...D.entries()]:[]}e.$1q=T;function C(D){return new Map(D)}e.$2q=C;function M(D){return new Map(D??[])}e.$3q=M;function P(D){return Array.from(D.entries()).map(p=>[p[0],w(p[1].map),T(p[1].descriptionMap)])}e.$4q=P;function g(D){return new Map(D.map(p=>[p[0],{map:C(p[1]),descriptionMap:M(p[2])}]))}e.$5q=g}),define(Ae[183],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjb=void 0;class w{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,M,P=5){const g=M(D=>{const p=typeof D=="string"?D:D.data;let A=this.a.get(C);if(A){A.data.push(p);return}const E=setTimeout(()=>this.flushBuffer(C),P);A={data:[p],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(C),g.dispose()}},this.a.set(C,A)});return g}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const M=this.a.get(C);M&&(this.a.delete(C),this.b(C,M.data.join("")))}}e.$bjb=w}),define(Ae[184],Fe([1,0,16,88,40,5,12,2,144,73,30]),function($e,e,w,T,C,M,P,g,D,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zu=e.$Yu=e.$Xu=e.$Wu=e.$Vu=e.$Uu=e.$Tu=e.$Su=e.IconFontDefinition=e.IconContribution=e.$Ru=void 0,e.$Ru={IconContribution:"base.contributions.icons"};var E;(function(S){function I(r,h){let n=r.defaults;for(;C.ThemeIcon.isThemeIcon(n);){const s=b.getIcon(n.id);if(!s)return;n=s.defaults}return n}S.getDefinition=I})(E||(e.IconContribution=E={}));var c;(function(S){function I(h){return{weight:h.weight,style:h.style,src:h.src.map(n=>({format:n.format,location:n.location.toString()}))}}S.toJSONObject=I;function r(h){const n=s=>(0,P.$je)(s)?s:void 0;if(h&&Array.isArray(h.src)&&h.src.every(s=>(0,P.$je)(s.format)&&(0,P.$je)(s.location)))return{weight:n(h.weight),style:n(h.style),src:h.src.map(s=>({format:s.format,location:g.URI.parse(s.location)}))}}S.fromJSONObject=r})(c||(e.IconFontDefinition=c={}));class y{constructor(){this.a=new M.$8c,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(I,r,h,n){const s=this.b[I];if(s){if(h&&!s.description){s.description=h,this.d.properties[I].markdownDescription=`${h} $(${I})`;const l=this.e.enum.indexOf(I);l!==-1&&(this.e.enumDescriptions[l]=h),this.a.fire()}return s}const $={id:I,description:h,defaults:r,deprecationMessage:n};this.b[I]=$;const k={$ref:"#/definitions/icons"};return n&&(k.deprecationMessage=n),h&&(k.markdownDescription=`${h}: $(${I})`),this.d.properties[I]=k,this.e.enum.push(I),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:I}}deregisterIcon(I){delete this.b[I],delete this.d.properties[I];const r=this.e.enum.indexOf(I);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(I=>this.b[I])}getIcon(I){return this.b[I]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(I,r){const h=this.f[I];return h||(this.f[I]=r,this.a.fire(),r)}deregisterIconFont(I){delete this.f[I]}getIconFont(I){return this.f[I]}toString(){const I=(s,$)=>s.id.localeCompare($.id),r=s=>{for(;C.ThemeIcon.isThemeIcon(s.defaults);)s=this.b[s.defaults.id];return`codicon codicon-${s?s.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(s=>this.b[s]);for(const s of n.filter($=>!!$.description).sort(I))h.push(`|<i class="${r(s)}"></i>|${s.id}|${C.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const s of n.filter($=>!C.ThemeIcon.isThemeIcon($.defaults)).sort(I))h.push(`|<i class="${r(s)}"></i>|${s.id}|`);return h.join(`
`)}}const b=new y;A.$Tm.add(e.$Ru.IconContribution,b);function o(S,I,r,h){return b.registerIcon(S,I,r,h)}e.$Su=o;function t(){return b}e.$Tu=t;function i(){const S=(0,T.$Aj)();for(const I in S){const r="\\"+S[I].toString(16);b.registerIcon(I,{fontCharacter:r})}}i(),e.$Uu="vscode://schemas/icons";const a=A.$Tm.as(p.$Um.JSONContribution);a.registerSchema(e.$Uu,b.getIconSchema());const m=new w.$Gg(()=>a.notifySchemaChanged(e.$Uu),200);b.onDidChange(()=>{m.isScheduled()||m.schedule()}),e.$Vu=o("widget-close",T.$Cj.close,(0,D.localize)(2,null)),e.$Wu=o("goto-previous-location",T.$Cj.arrowUp,(0,D.localize)(3,null)),e.$Xu=o("goto-next-location",T.$Cj.arrowDown,(0,D.localize)(4,null)),e.$Yu=C.ThemeIcon.modify(T.$Cj.sync,"spin"),e.$Zu=C.ThemeIcon.modify(T.$Cj.loading,"spin")}),define(Ae[185],Fe([1,0,5,43,3,14]),function($e,e,w,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pz=e.$Oz=e.$Nz=e.$Mz=e.$Lz=e.$Kz=e.$Jz=e.$Iz=e.ProvidedOnAutoForward=e.$Hz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Gz=e.$Fz=void 0,e.$Fz=(0,C.$ph)("tunnelService"),e.$Gz=(0,C.$ph)("sharedTunnelsService");var P;(function(t){t.Http="http",t.Https="https"})(P||(e.TunnelProtocol=P={}));var g;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(g||(e.TunnelPrivacyId=g={}));function D(t){return!!t.forwardPort}e.$Hz=D;var p;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(p||(e.ProvidedOnAutoForward=p={}));function A(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$Iz=A,e.$Jz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(t){return e.$Jz.indexOf(t)>=0}e.$Kz=E,e.$Lz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function c(t){return e.$Lz.indexOf(t)>=0}e.$Mz=c;function y(t,i,a,m){if(a===1)return!1;if(a===2&&c(i)){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(S?.length===4&&parseInt(S[1])>=18)return!1}return t<1024}e.$Nz=y;class b{constructor(i,a,m){this.remoteAddress=i,this.localAddress=a,this.b=m,this.a=new w.$8c,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Oz=b;let o=class{constructor(i,a){this.i=i,this.j=a,this.a=new w.$8c,this.onTunnelOpened=this.a.event,this.b=new w.$8c,this.onTunnelClosed=this.b.event,this.c=new w.$8c,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const i=this.j.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.e=i,i?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.f=i.elevation,this.g=i.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const i=[],a=Array.from(this.d.values());for(const m of a){const S=Array.from(m.values());for(const I of S){const r=await I.value;r&&i.push(r)}}return i}async dispose(){for(const i of this.d.values()){for(const{value:a}of i.values())await a.then(m=>m?.dispose());i.clear()}this.d.clear()}setEnvironmentTunnel(i,a,m,S,I){this.o(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:m,privacy:S,protocol:I,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(c(i)||E(i))&&(i=e.$Jz[0]);const m=this.q(i,a);if(m)return++m.refcount,m.value}openTunnel(i,a,m,S,I,r=!1,h,n){this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${m} on local port ${I}.`);const s=this.e??i;if(!s)return;if(a||(a="localhost"),S||(S=this.k),this.e&&this.h.has(m)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const $=this.r(s,a,m,S,I,r,h,n);return $?$.then(k=>{if(!k){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(a,m);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.m(k);return(k.tunnelRemoteHost!==a||k.tunnelRemotePort!==m)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),h&&k.privacy!==h&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(l),l}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),$)}m(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this.d.get(i.tunnelRemoteHost);if(a){const m=a.get(i.tunnelRemotePort);m&&(m.refcount--,await this.n(i.tunnelRemoteHost,i.tunnelRemotePort,m))}}}}async n(i,a,m){if(m.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const S=m.value.then(async I=>{I&&(await I.dispose(!0),this.b.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this.d.has(i)&&this.d.get(i).delete(a),S}}async closeTunnel(i,a){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const m=this.d.get(i);if(m&&m.has(a)){const S=m.get(a);S.refcount=0,await this.n(i,a,S)}}o(i,a,m){this.d.has(i)||this.d.set(i,new Map),this.d.get(i).set(a,{refcount:1,value:m})}async p(i,a){const m=this.d.get(i);if(m){const S=m.get(a);(S?await S.value:void 0)||m.delete(a),m.size===0&&this.d.delete(i)}}q(i,a){const m=[i];E(i)?(m.push(...e.$Jz),m.push(...e.$Lz)):c(i)&&m.push(...e.$Lz);const S=m.map(I=>this.d.get(I));for(const I of S){const r=I?.get(a);if(r)return r}}canTunnel(i){return!!A(i)}s(i,a,m,S,I,r,h){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${m} on local port ${S}.`);const n=m;this.h.add(n);const s=S===void 0?m:S,$={elevationRequired:I?this.isPortPrivileged(s):!1},k={remoteAddress:{host:a,port:m},localAddressPort:S,privacy:r,public:r?r!==g.Private:void 0,protocol:h},l=i.forwardPort(k,$);return l?(this.o(a,m,l),l.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(n)})):this.h.delete(n),l}};e.$Pz=o,e.$Pz=o=Ve([qe(0,M.$Ri),qe(1,T.$Vh)],o)}),define(Ae[186],Fe([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Qz=void 0,e.$Qz=(0,w.$ph)("editSessionIdentityService");var T;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Ae[187],Fe([1,0,13]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=void 0;function T(D){return D.scheme!==w.Schemas.file&&D.scheme!==w.Schemas.vscodeRemote}e.$$I=T;function C(D){if(D.folders.length)return D.folders.every(p=>T(p.uri))?D.folders[0].uri:void 0;if(D.configuration&&T(D.configuration))return D.configuration}e.$_I=C;function M(D){return C(D)?.scheme}e.$aJ=M;function P(D){return C(D)?.authority}e.$bJ=P;function g(D){return C(D)!==void 0}e.$cJ=g}),define(Ae[54],Fe([1,0,145,19,48,23,2,3,13]),function($e,e,w,T,C,M,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.WorkbenchState=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$yh=(0,g.$ph)("contextService");function p(s){const $=s;return typeof $?.id=="string"&&P.URI.isUri($.uri)}e.$zh=p;function A(s){return typeof s?.id=="string"&&!p(s)&&!c(s)}e.$Ah=A,e.$Bh={id:"ext-dev"},e.$Ch={id:"empty-window"};function E(s,$){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,T.$ec)(s)}:$?e.$Bh:e.$Ch;const k=s;return k.configuration?{id:k.id,configPath:k.configuration}:k.folders.length===1?{id:k.id,uri:k.folders[0].uri}:{id:k.id}}e.$Dh=E;function c(s){const $=s;return typeof $?.id=="string"&&P.URI.isUri($.configPath)}e.$Eh=c;function y(s){const $=s;if($?.uri)return{id:$.id,uri:P.URI.revive($.uri)};const k=s;if(k?.configPath)return{id:k.id,configPath:P.URI.revive(k.configPath)};if(s?.id)return{id:s.id}}e.$Fh=y;var b;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function o(s){const $=s;return!!($&&typeof $=="object"&&typeof $.id=="string"&&Array.isArray($.folders))}e.$Gh=o;function t(s){const $=s;return!!($&&typeof $=="object"&&P.URI.isUri($.uri)&&typeof $.name=="string"&&typeof $.toResource=="function")}e.$Hh=t;class i{constructor($,k,l,f,v){this.h=$,this.j=l,this.k=f,this.l=v,this.c=C.$vh.forUris(this.l,()=>!0),this.folders=k}update($){this.h=$.id,this.k=$.configuration,this.j=$.transient,this.l=$.l,this.folders=$.folders}get folders(){return this.g}set folders($){this.g=$,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration($){this.k=$}getFolder($){return $&&this.c.findSubstr($)||null}n(){this.c=C.$vh.forUris(this.l,()=>!0);for(const $ of this.folders)this.c.set($.uri,$)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ih=i;class a{constructor($,k){this.raw=k,this.uri=$.uri,this.index=$.index,this.name=$.name}toResource($){return(0,M.$0f)(this.uri,$)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Jh=a;function m(s){return new a({uri:s,index:0,name:(0,M.$6f)(s)},{uri:s.toString()})}e.$Kh=m,e.$Lh="code-workspace",e.$Mh=`.${e.$Lh}`,e.$Nh=[{name:(0,w.localize)(0,null),extensions:[e.$Lh]}],e.$Oh="workspace.json";function S(s,$){return M.$1f.isEqualOrParent(s,$.untitledWorkspacesHome)}e.$Ph=S;function I(s){let $;return P.URI.isUri(s)?$=s:$=s.configuration,$?.scheme===D.Schemas.tmp}e.$Qh=I,e.$Rh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(s){return s.id===e.$Rh}e.$Sh=r;function h(s,$){return!S(s,$)&&!I(s)}e.$Th=h;function n(s){return(typeof s=="string"?(0,T.$fc)(s):(0,M.$8f)(s))===e.$Mh}e.$Uh=n}),define(Ae[55],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N$b=void 0;class w{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const M=this.c++;return this.b.set(M,C),this.e(),M}get(C,M){return this.b.has(C)?this.b.get(C)[M]:void 0}delete(C){this.b.delete(C),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$N$b=w}),define(Ae[39],Fe([1,0,13,23,3]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q$b=e.$P$b=void 0;class M{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new T.$Yf(g=>{const D=this.b.get(g.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(g,D){D===null?this.b.delete(g.scheme):this.b.set(g.scheme,D)}isFreeScheme(g){return!this.b.has(g)&&!this.a.has(g)}getCapabilities(g){return this.b.get(g)}}e.$P$b=M,e.$Q$b=(0,C.$ph)("IExtHostFileSystemInfo")}),define(Ae[27],Fe([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=void 0,e.$TL=(0,w.$ph)("IExtHostInitDataService")}),define(Ae[188],Fe([1,0,150,14,174,27]),function($e,e,w,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sac=void 0;let P=class extends C.$1M{constructor(D,p,A){const E=A.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",c=A.remote.isRemote?(0,w.localize)(0,null):D?(0,w.localize)(1,null):(0,w.localize)(2,null);super(p.createLogger(E,{name:c}))}};e.$Sac=P,e.$Sac=P=Ve([qe(1,T.$Si),qe(2,M.$TL)],P)}),define(Ae[189],Fe([1,0,16]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h_b=e.$g_b=void 0;class T{constructor(P,g,D){this.h=new Map,this.a=P,this.b=g,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(p=>(this.f=p,this)),this.g=this.c.onDidChangeStorage(p=>{p.shared===this.b&&p.key===this.a&&(this.f=p.value)}),this.i=new w.$Gg(()=>{const p=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of p.values())A.complete()}catch(A){for(const E of p.values())E.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this.d}get(P,g){let D=this.f[P];return typeof D>"u"&&(D=g),D}update(P,g){this.f[P]=g;const D=this.h.get(P);if(D!==void 0)return D.p;const p=new w.$Pg;return this.h.set(P,p),this.i.isScheduled()||this.i.schedule(),p.p}dispose(){this.g.dispose()}}e.$g_b=T;class C extends T{setKeysForSync(P){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},P)}constructor(P,g){super(P.identifier.value,!0,g),this.j=P}}e.$h_b=C}),define(Ae[190],Fe([1,0,5,2]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fac=void 0;class C{constructor(P){this.c=P,this.a=new w.$8c,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$8c,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(P,g,D,p){const E=this.c.getNotebookDocument(T.URI.revive(P)).acceptModelChanged(g.value,D,p);this.b.fire(E)}$acceptDirtyStateChanged(P,g){this.c.getNotebookDocument(T.URI.revive(P)).acceptDirty(g)}$acceptModelSaved(P){const g=this.c.getNotebookDocument(T.URI.revive(P));this.a.fire(g.apiNotebook)}}e.$Fac=C}),define(Ae[17],Fe([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$DL=void 0,e.$DL=(0,w.$ph)("IExtHostRpcService");class T{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$EL=T}),define(Ae[191],Fe([1,0,21,5]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s_b=void 0;class C{#e;constructor(P,g){this.b=new T.$8c,this.onDidChange=this.b.event,this.a=w.$Hl.toKey(P.identifier),this.#e=g,this.#e.onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(P){return this.#e.get(this.a,P)}store(P,g){return this.#e.store(this.a,P,g)}delete(P){return this.#e.delete(this.a,P)}}e.$s_b=C}),define(Ae[56],Fe([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2$b=e.$1$b=void 0,e.$1$b=(0,w.$ph)("IURITransformerService");class T{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.$2$b=T}),define(Ae[192],Fe([1,0,25]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$00=e.$90=void 0;class T{constructor(){this.buffers=[]}add(D){let p=this.buffers.indexOf(D);return p<0&&(p=this.buffers.length,this.buffers.push(D)),p}}function C(g,D){if(D.serializeBuffersForPostMessage){const p=new T,E=JSON.stringify(g,(y,b)=>{if(b instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:p.add(b)};if(ArrayBuffer.isView(b)){const o=M(b);if(o)return{$$vscode_array_buffer_reference$$:!0,index:p.add(b.buffer),view:{type:o,byteLength:b.byteLength,byteOffset:b.byteOffset}}}return b}),c=p.buffers.map(y=>{const b=new Uint8Array(y);return w.$Jb.wrap(b)});return{message:E,buffers:c}}else return{message:JSON.stringify(g),buffers:[]}}e.$90=C;function M(g){switch(g.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(g,D){const p=D.map(c=>{const y=new ArrayBuffer(c.byteLength);return new Uint8Array(y).set(c.buffer),y}),A=D.length?(c,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const b=y,{index:o}=b,t=p[o];if(b.view)switch(b.view.type){case 1:return new Int8Array(t,b.view.byteOffset,b.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,b.view.byteOffset,b.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,b.view.byteOffset,b.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,b.view.byteOffset,b.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,b.view.byteOffset,b.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,b.view.byteOffset,b.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,b.view.byteOffset,b.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,b.view.byteOffset,b.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,b.view.byteOffset,b.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,b.view.byteOffset,b.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,b.view.byteOffset,b.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return y}:void 0;return{message:JSON.parse(g,A),arrayBuffers:p}}e.$00=P}),define(Ae[98],Fe([1,0,159,12,2,6,3,30,38,13,41,127,29]),function($e,e,w,T,C,M,P,g,D,p,A,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QE=e.$PE=e.$OE=e.EditorsOrder=e.$NE=e.CloseDirection=e.$ME=e.$LE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$KE=e.$JE=e.$IE=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=e.EditorInputCapabilities=e.$CE=e.SaveReason=e.Verbosity=e.$BE=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=void 0,e.$qE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$rE={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$sE="workbench.editor.sidebysideEditor",e.$tE="workbench.editors.textDiffEditor",e.$uE="workbench.editors.binaryResourceDiffEditor";var y;(function(H){H[H.PROGRAMMATIC=1]="PROGRAMMATIC",H[H.USER=2]="USER",H[H.EDIT=3]="EDIT",H[H.NAVIGATION=4]="NAVIGATION",H[H.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var b;(function(H){H[H.IDENTICAL=1]="IDENTICAL",H[H.SIMILAR=2]="SIMILAR",H[H.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function o(H){const ne=H;return!!ne&&typeof ne.getSelection=="function"&&!!ne.onDidChangeSelection}e.$vE=o;function t(H,ne,re){for(const L of re.visibleEditorPanes)if(L.group.id===ne&&H.matches(L.input))return L.getViewState()}e.$wE=t;function i(H){if(k(H))return!1;const ne=H;return C.URI.isUri(ne?.resource)}e.$xE=i;function a(H){if(k(H))return!1;const ne=H;return ne?.original!==void 0&&ne.modified!==void 0}e.$yE=a;function m(H){if(k(H)||a(H))return!1;const ne=H;return ne?.primary!==void 0&&ne.secondary!==void 0}e.$zE=m;function S(H){if(k(H))return!1;const ne=H;return ne?ne.resource===void 0||ne.resource.scheme===p.Schemas.untitled||ne.forceUntitled===!0:!1}e.$AE=S;function I(H){if(k(H))return!1;const ne=H;return C.URI.isUri(ne?.base?.resource)&&C.URI.isUri(ne?.input1?.resource)&&C.URI.isUri(ne?.input2?.resource)&&C.URI.isUri(ne?.result?.resource)}e.$BE=I;var r;(function(H){H[H.SHORT=0]="SHORT",H[H.MEDIUM=1]="MEDIUM",H[H.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var h;(function(H){H[H.EXPLICIT=1]="EXPLICIT",H[H.AUTO=2]="AUTO",H[H.FOCUS_CHANGE=3]="FOCUS_CHANGE",H[H.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(h||(e.SaveReason=h={}));class n{constructor(){this.a=new Map}registerSource(ne,re){let L=this.a.get(ne);return L||(L={source:ne,label:re},this.a.set(ne,L)),L.source}getSourceLabel(ne){return this.a.get(ne)?.label??ne}}e.$CE=new n;var s;(function(H){H[H.None=0]="None",H[H.Readonly=2]="Readonly",H[H.Untitled=4]="Untitled",H[H.Singleton=8]="Singleton",H[H.RequiresTrust=16]="RequiresTrust",H[H.CanSplitInGroup=32]="CanSplitInGroup",H[H.ForceDescription=64]="ForceDescription",H[H.CanDropIntoEditor=128]="CanDropIntoEditor",H[H.MultipleEditors=256]="MultipleEditors",H[H.Scratchpad=512]="Scratchpad"})(s||(e.EditorInputCapabilities=s={}));class $ extends M.$lb{}e.$DE=$;function k(H){return H instanceof $}e.$EE=k;function l(H){const ne=H;return C.URI.isUri(ne?.preferredResource)}function f(H){const ne=H;return k(ne?.primary)&&k(ne?.secondary)}e.$FE=f;function v(H){const ne=H;return k(ne?.modified)&&k(ne?.original)}e.$GE=v;function u(H,ne,re,L,_){return Ce(L,[(0,E.$_h)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const pe={...re,limits:{size:Number.MAX_VALUE}};H.openEditor(ne,pe)}}),(0,E.$_h)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>_.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:c.default.Warning})}e.$HE=u;function d(H){return k(H?.editor)}e.$IE=d;function R(H){const ne=H;return d(H)&&ne?.group!==void 0}e.$JE=R;function W(H){const ne=H;return typeof ne?.groupId=="number"&&k(ne.editor)}e.$KE=W;var B;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.REPLACE=1]="REPLACE",H[H.MOVE=2]="MOVE",H[H.UNPIN=3]="UNPIN"})(B||(e.EditorCloseContext=B={}));var q;(function(H){H[H.GROUP_ACTIVE=0]="GROUP_ACTIVE",H[H.GROUP_INDEX=1]="GROUP_INDEX",H[H.GROUP_LOCKED=2]="GROUP_LOCKED",H[H.EDITOR_OPEN=3]="EDITOR_OPEN",H[H.EDITOR_CLOSE=4]="EDITOR_CLOSE",H[H.EDITOR_MOVE=5]="EDITOR_MOVE",H[H.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",H[H.EDITOR_LABEL=7]="EDITOR_LABEL",H[H.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",H[H.EDITOR_PIN=9]="EDITOR_PIN",H[H.EDITOR_STICKY=10]="EDITOR_STICKY",H[H.EDITOR_DIRTY=11]="EDITOR_DIRTY",H[H.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(q||(e.GroupModelChangeKind=q={}));var U;(function(H){H[H.PRIMARY=1]="PRIMARY",H[H.SECONDARY=2]="SECONDARY",H[H.BOTH=3]="BOTH",H[H.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class N{getOriginalUri(ne,re){if(!ne)return;if(I(ne))return e.$ME.getOriginalUri(ne.result,re);if(re?.supportSideBySide){const{primary:_,secondary:pe}=this.a(ne);if(_&&pe){if(re?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(_,{filterByScheme:re.filterByScheme}),secondary:this.getOriginalUri(pe,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===U.ANY)return this.getOriginalUri(_,{filterByScheme:re.filterByScheme})??this.getOriginalUri(pe,{filterByScheme:re.filterByScheme});ne=re.supportSideBySide===U.PRIMARY?_:pe}}if(a(ne)||m(ne)||I(ne))return;const L=l(ne)?ne.preferredResource:ne.resource;return!L||!re||!re.filterByScheme?L:this.b(L,re.filterByScheme)}a(ne){return f(ne)||m(ne)?{primary:ne.primary,secondary:ne.secondary}:v(ne)||a(ne)?{primary:ne.modified,secondary:ne.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ne,re){if(!ne)return;if(I(ne))return e.$ME.getCanonicalUri(ne.result,re);if(re?.supportSideBySide){const{primary:_,secondary:pe}=this.a(ne);if(_&&pe){if(re?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(_,{filterByScheme:re.filterByScheme}),secondary:this.getCanonicalUri(pe,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===U.ANY)return this.getCanonicalUri(_,{filterByScheme:re.filterByScheme})??this.getCanonicalUri(pe,{filterByScheme:re.filterByScheme});ne=re.supportSideBySide===U.PRIMARY?_:pe}}if(a(ne)||m(ne)||I(ne))return;const L=ne.resource;return!L||!re||!re.filterByScheme?L:this.b(L,re.filterByScheme)}b(ne,re){if(Array.isArray(re)){if(re.some(L=>ne.scheme===L))return ne}else if(re===ne.scheme)return ne}}var O;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.KEYBOARD=1]="KEYBOARD",H[H.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function ce(H,ne,re,L){if(!H.isSticky(ne))return!1;switch(L.preventPinnedEditorClose){case"keyboardAndMouse":return re===O.MOUSE||re===O.KEYBOARD;case"mouse":return re===O.MOUSE;case"keyboard":return re===O.KEYBOARD}return!1}e.$LE=ce,e.$ME=new N;var X;(function(H){H[H.LEFT=0]="LEFT",H[H.RIGHT=1]="RIGHT"})(X||(e.CloseDirection=X={}));class be{constructor(){this.c=new Map,this.d=new Map}start(ne){const re=this.a=ne.get(P.$oh);for(const[L,_]of this.c)this.e(L,_,re);this.c.clear()}e(ne,re,L){const _=L.createInstance(re);this.d.set(ne,_)}registerFileEditorFactory(ne){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ne}getFileEditorFactory(){return(0,T.$ue)(this.b)}registerEditorSerializer(ne,re){if(this.c.has(ne)||this.d.has(ne))throw new Error(`A editor serializer with type ID '${ne}' was already registered.`);return this.a?this.e(ne,re,this.a):this.c.set(ne,re),(0,M.$jb)(()=>{this.c.delete(ne),this.d.delete(ne)})}getEditorSerializer(ne){return this.d.get(typeof ne=="string"?ne:ne.typeId)}}g.$Tm.add(e.$qE.EditorFactory,new be);async function Ee(H,ne,re){return!H||!H.length?[]:await Promise.all(H.map(async L=>{const _=C.URI.revive(L.fileUri);if(!_){re.info("Cannot resolve the path because it is not valid.",L);return}if(!await ne.canHandleResource(_)){re.info("Cannot resolve the path because it cannot be handled",L);return}let Ie=L.exists,De=L.type;if(typeof Ie!="boolean"||typeof De!="number")try{De=(await ne.stat(_)).isDirectory?D.FileType.Directory:D.FileType.Unknown,Ie=!0}catch(Se){re.error(Se),Ie=!1}if(!Ie&&L.openOnlyIfExists){re.info("Cannot resolve the path because it does not exist",L);return}if(De===D.FileType.Directory){re.info("Cannot resolve the path because it is a directory",L);return}const ye={...L.options,pinned:!0};return Ie?{resource:_,options:ye}:{resource:_,options:ye,forceUntitled:!0}}))}e.$NE=Ee;var Re;(function(H){H[H.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",H[H.SEQUENTIAL=1]="SEQUENTIAL"})(Re||(e.EditorsOrder=Re={}));function Z(H){const ne=H;if(!ne)return!1;const re=ne;if(re.modified)return Z(re.modified);const L=ne;return!!(L.contributionsState&&L.viewState&&Array.isArray(L.cursorState))}e.$OE=Z;function he(H){return(0,A.$bi)(H)}e.$PE=he;function Ce(H,ne,re){const L=(0,A.$ci)(H,ne);return L.forceMessage=re?.forceMessage,L.forceSeverity=re?.forceSeverity,L.allowDialog=re?.allowDialog,L}e.$QE=Ce}),define(Ae[193],Fe([1,0,5,160,3,6,28,30,18,99,24,88,184]),function($e,e,w,T,C,M,P,g,D,p,A,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XE=e.$WE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$VE=e.$UE=e.ViewContentGroups=e.$TE=e.$SE=e.ViewContainerLocation=e.Extensions=e.$RE=void 0,e.$RE=(0,c.$Su)("default-view-icon",E.$Cj.window,(0,T.localize)(0,null));var y;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var b;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$SE=[0,1,2];function o(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$TE=o;class t extends M.$lb{constructor(){super(...arguments),this.c=this.B(new w.$8c),this.onDidRegister=this.c.event,this.f=this.B(new w.$8c),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.$yf)([...this.g.values()])}registerViewContainer(s,$,k){const l=this.get(s.id);if(l)return l;const f=s;return f.openCommandActionDescriptor=k?.doNotRegisterOpenCommand?void 0:f.openCommandActionDescriptor??{id:f.id},(0,P.$ki)(this.g,$,[]).push(f),k?.isDefault&&this.h.push(f),this.c.fire({viewContainer:f,viewContainerLocation:$}),f}deregisterViewContainer(s){for(const $ of this.g.keys()){const k=this.g.get($),l=k?.indexOf(s);if(l!==-1){k?.splice(l,1),k.length===0&&this.g.delete($),this.f.fire({viewContainer:s,viewContainerLocation:$});return}}}get(s){return this.all.filter($=>$.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter($=>this.getViewContainers($).filter(k=>k?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find($=>this.getViewContainerLocation($)===s)}}g.$Tm.add(y.ViewContainersRegistry,new t);var i;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(i||(e.ViewContentGroups=i={}));function a(n,s){const $=n.group??i.More,k=s.group??i.More;return $!==k?$.localeCompare(k):(n.order??5)-(s.order??5)}class m extends M.$lb{constructor(){super(...arguments),this.c=this.B(new w.$8c),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$8c),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$8c),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$8c),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new p.$L}registerViews(s,$){this.registerViews2([{views:s,viewContainer:$}])}registerViews2(s){s.forEach(({views:$,viewContainer:k})=>this.l($,k)),this.c.fire(s)}deregisterViews(s,$){const k=this.m(s,$);k.length&&this.f.fire({views:k,viewContainer:$})}moveViews(s,$){for(const k of this.j.keys())if(k!==$){const l=this.m(s,k);l.length&&(this.l(l,$),this.g.fire({views:l,from:k,to:$}))}}getViews(s){return this.j.get(s)||[]}getView(s){for(const $ of this.i){const k=(this.j.get($)||[]).filter(l=>l.id===s)[0];if(k)return k}return null}getViewContainer(s){for(const $ of this.i)if((this.j.get($)||[]).filter(l=>l.id===s)[0])return $;return null}registerViewWelcomeContent(s,$){return this.k.add(s,$),this.h.fire(s),(0,M.$jb)(()=>{this.k.delete(s,$),this.h.fire(s)})}registerViewWelcomeContent2(s,$){const k=new Map;for(const[l,f]of $)this.k.add(s,f),k.set(l,(0,M.$jb)(()=>{this.k.delete(s,f),this.h.fire(s)}));return this.h.fire(s),k}getViewWelcomeContent(s){const $=[];return this.k.forEach(s,k=>$.push(k)),$.sort(a)}l(s,$){let k=this.j.get($);k||(k=[],this.j.set($,k),this.i.push($));for(const l of s){if(this.getView(l.id)!==null)throw new Error((0,T.localize)(1,null,l.id));k.push(l)}}m(s,$){const k=this.j.get($);if(!k)return[];const l=[],f=[];for(const v of k)s.includes(v)?l.push(v):f.push(v);return l.length&&(f.length?this.j.set($,f):(this.j.delete($),this.i.splice(this.i.indexOf($),1))),l}}g.$Tm.add(y.ViewsRegistry,new m),e.$UE=(0,C.$ph)("viewsService"),e.$VE=(0,C.$ph)("viewDescriptorService");var S;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(S||(e.ViewVisibilityState=S={}));var I;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(I||(e.TreeItemCollapsibleState=I={}));class r{constructor(s,$){this.c=!1,this.d=!1,(0,A.$Km)(this,s),this.d=!!$,this.resolve=async k=>{if($&&!this.c){const l=await $(k);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}k.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$WE=r;class h extends Error{constructor(s){super((0,T.localize)(2,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$XE=h}),define(Ae[194],Fe([1,0,5,16,161]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C$=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new w.$8c,this.n=new w.$8c,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(g){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=g}onEvent(g){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=g}onRequest(g){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=g}sendResponse(g){g.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${g.command}`)):this.s("response",g)}sendRequest(g,D,p,A){const E={command:g};if(D&&Object.keys(D).length>0&&(E.arguments=D),this.s("request",E),typeof A=="number"){const c=setTimeout(()=>{clearTimeout(c);const y=this.f.get(E.seq);if(y){this.f.delete(E.seq);const b={type:"response",seq:0,request_seq:E.seq,success:!1,command:g,message:(0,C.localize)(0,null,A,g)};y(b)}},A)}return p&&this.f.set(E.seq,p),E.seq}acceptMessage(g){this.j?this.j(g):(this.k.push(g),this.k.length===1&&this.q())}o(g,D){return g.type!=="event"||D.type!=="event"}async q(){let g;for(;this.k.length;){if((!g||this.o(this.k[0],g))&&await(0,T.$wg)(0),g=this.k.shift(),!g)return;switch(g.type){case"event":this.i?.(g);break;case"request":this.g?.(g);break;case"response":{const D=g,p=this.f.get(D.request_seq);p&&(this.f.delete(D.request_seq),p(D));break}}}}s(g,D){D.type=g,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const g=new Map;this.f.forEach((D,p)=>g.set(p,D)),await(0,T.$wg)(500),g.forEach((D,p)=>{D({type:"response",seq:0,request_seq:p,success:!1,command:"canceled",message:"canceled"}),this.f.delete(p)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$C$=M}),define(Ae[195],Fe([1,0,162,31,3]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$9G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$8G=e.MemoryRangeType=e.$7G=e.State=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=void 0,e.$5F="workbench.view.debug",e.$6F="workbench.debug.variablesView",e.$7F="workbench.debug.watchExpressionsView",e.$8F="workbench.debug.callStackView",e.$9F="workbench.debug.loadedScriptsView",e.$0F="workbench.debug.breakPointsView",e.$$F="workbench.debug.disassemblyView",e.$_F="workbench.panel.repl",e.$aG="workbench.panel.repl.view",e.$bG=new T.$Oi("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.$cG=new T.$Oi("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.$dG=new T.$Oi("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.$eG="debugUx",e.$fG=new T.$Oi(e.$eG,"default",{type:"string",description:w.localize(3,null)}),e.$gG=new T.$Oi("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.$hG=new T.$Oi("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.$iG=new T.$Oi("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.$jG=new T.$Oi("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.$kG=new T.$Oi("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.$lG=new T.$Oi("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.$mG=new T.$Oi("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.$nG=new T.$Oi("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.$oG=new T.$Oi("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.$pG=new T.$Oi("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.$qG=new T.$Oi("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.$rG=new T.$Oi("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.$sG=new T.$Oi("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.$tG=new T.$Oi("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.$uG=new T.$Oi("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.$vG=new T.$Oi("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.$wG=new T.$Oi("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.$xG=new T.$Oi("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.$yG=new T.$Oi("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.$zG=new T.$Oi("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.$AG=new T.$Oi("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.$BG=new T.$Oi("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.$CG=new T.$Oi("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.$DG=new T.$Oi("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.$EG=new T.$Oi("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.$FG=new T.$Oi("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.$GG=new T.$Oi("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.$HG=new T.$Oi("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.$IG=new T.$Oi("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.$JG=new T.$Oi("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.$KG=new T.$Oi("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.$LG=new T.$Oi("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.$MG=new T.$Oi("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.$NG=new T.$Oi("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.$OG=new T.$Oi("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.$PG=new T.$Oi("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.$QG=new T.$Oi("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.$RG=new T.$Oi("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.$SG=new T.$Oi("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.$TG=new T.$Oi("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.$UG=new T.$Oi("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.$VG=new T.$Oi("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.$WG=new T.$Oi("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.$XG=new T.$Oi("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.$YG=new T.$Oi("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.$ZG=new T.$Oi("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.$1G=new T.$Oi("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const M=c=>w.localize(51,null,c);e.$2G=M,e.$3G="editor.contrib.debug",e.$4G="editor.contrib.breakpoint",e.$5G="debug",e.$6G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var P;(function(c){c[c.Inactive=0]="Inactive",c[c.Initializing=1]="Initializing",c[c.Stopped=2]="Stopped",c[c.Running=3]="Running"})(P||(e.State=P={}));function g(c){switch(c){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$7G=g;var D;(function(c){c[c.Valid=0]="Valid",c[c.Unreadable=1]="Unreadable",c[c.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$8G="vscode-debug-memory";var p;(function(c){c[c.Initial=1]="Initial",c[c.Dynamic=2]="Dynamic"})(p||(e.DebugConfigurationProviderTriggerKind=p={}));var A;(function(c){c.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$9G=(0,C.$ph)("debugService");var E;(function(c){c[c.CONDITION=0]="CONDITION",c[c.HIT_COUNT=1]="HIT_COUNT",c[c.LOG_MESSAGE=2]="LOG_MESSAGE"})(E||(e.BreakpointWidgetContext=E={}))}),define(Ae[196],Fe([1,0,15,2,19,24,13,44,20,18]),function($e,e,w,T,C,M,P,g,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.$5E=void 0;const A=/{([^}]+)}/g;function E(l,f,v){return l.replace(A,function(u,d){return f&&d.length>0&&d[0]!=="_"?u:v&&v.hasOwnProperty(d)?v[d]:u})}e.$5E=E;function c(l){const f={};for(const v of Object.keys(l))v.startsWith("!")||(f[v]=l[v]);return f}e.$6E=c;function y(l){return l.configuration.request==="attach"&&!b(l)&&(!l.parentSession||y(l.parentSession))}e.$7E=y;function b(l){let f=l.configuration.type;if(f)return f==="vslsShare"&&(f=l.configuration.adapterProxy.configuration.type),(0,w.$Md)(f,"extensionhost")||(0,w.$Md)(f,"pwa-extensionhost")?l:l.parentSession?b(l.parentSession):void 0}e.$8E=b;function o(l){return l.type&&(l.label||l.program||l.runtime)}e.$9E=o;function t(l,f,v){let u,d=0;const R=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=R.exec(l);){const B=W.index+1,q=B+W[0].length;if(B<=f&&q>=v){u=W[0],d=B;break}}if(u){const B=/\w+/g;let q=null;for(;(q=B.exec(u))&&!(q.index+1+d+q[0].length>=v););q&&(u=u.substring(0,B.lastIndex))}return u?{start:d,end:d+u.length-1}:{start:0,end:0}}e.$0E=t;async function i(l,f,v,u){if(l.evaluatableExpressionProvider.has(f)){const d=l.evaluatableExpressionProvider.ordered(f),R=(0,p.$mf)(await Promise.all(d.map(async W=>{try{return await W.provideEvaluatableExpression(f,v,u??D.CancellationToken.None)}catch{return}})));if(R.length>0){let W=R[0].expression;const B=R[0].range;return W||(W=f.getLineContent(v.lineNumber).substring(B.startColumn-1,B.endColumn-1)),{range:B,matchingExpression:W}}}else{const d=f.getLineContent(v.lineNumber),{start:R,end:W}=t(d,v.column,v.column),B=d.substring(R-1,W);return{matchingExpression:B,range:new g.$Or(v.lineNumber,R,v.lineNumber,R+B.length)}}return null}e.$$E=i;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(l){return!!(l&&l.match(a))}e.$_E=m;function S(l){if(typeof l.path=="string"&&!(typeof l.sourceReference=="number"&&l.sourceReference>0)){if(m(l.path))return T.URI.parse(l.path);if((0,C.$_b)(l.path))return T.URI.file(l.path)}return l.path}function I(l){if(typeof l.path=="object"){const f=T.URI.revive(l.path);if(f)return f.scheme===P.Schemas.file?f.fsPath:f.toString()}return l.path}function r(l,f){const v=f?S:I,u=(0,M.$Hm)(l);return n(u,(d,R)=>{d&&R&&(R.path=v(R))}),u}e.$aF=r;function h(l,f){const v=f?S:I,u=(0,M.$Hm)(l);return n(u,(d,R)=>{!d&&R&&(R.path=v(R))}),u}e.$bF=h;function n(l,f){switch(l.type){case"event":{const v=l;switch(v.event){case"output":f(!1,v.body.source);break;case"loadedSource":f(!1,v.body.source);break;case"breakpoint":f(!1,v.body.breakpoint.source);break;default:break}break}case"request":{const v=l;switch(v.command){case"setBreakpoints":f(!0,v.arguments.source);break;case"breakpointLocations":f(!0,v.arguments.source);break;case"source":f(!0,v.arguments.source);break;case"gotoTargets":f(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(u=>f(!1,u));break;default:break}break}case"response":{const v=l;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(u=>f(!1,u.source));break;case"loadedSources":v.body.sources.forEach(u=>f(!1,u));break;case"scopes":v.body.scopes.forEach(u=>f(!1,u.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(u=>f(!1,u.source));break;case"setBreakpoints":v.body.breakpoints.forEach(u=>f(!1,u.source));break;case"disassemble":v.body?.instructions.forEach(d=>f(!1,d.location));break;default:break}break}}}function s(l){return l.filter(f=>!f.presentation?.hidden).sort((f,v)=>f.presentation?v.presentation?f.presentation.group?v.presentation.group?f.presentation.group!==v.presentation.group?f.presentation.group.localeCompare(v.presentation.group):$(f.presentation.order,v.presentation.order):-1:v.presentation.group?1:$(f.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.$cF=s;function $(l,f){return typeof l!="number"?typeof f!="number"?0:1:typeof f!="number"?-1:l-f}async function k(l,f){const v=l.getValue("debug.saveBeforeStart",{overrideIdentifier:f.activeTextEditorLanguageId});if(v!=="none"&&(await f.saveAll(),v==="allEditorsInActiveGroup")){const u=f.activeEditorPane;u&&u.input.resource?.scheme===P.Schemas.untitled&&await f.save({editor:u.input,groupId:u.group.id})}await l.reloadConfiguration()}e.$dF=k}),define(Ae[74],Fe([1,0,25,37,67,68,13,19,22,31]),function($e,e,w,T,C,M,P,g,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KH=e.$JH=e.$IH=e.$HH=e.CellStatusbarAlignment=e.$GH=e.$FH=e.$EH=e.NotebookEditorPriority=e.$DH=e.$CH=e.$BH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$AH=e.$zH=e.$yH=e.$xH=e.CellKind=e.$wH=e.$vH=e.$uH=void 0,e.$uH="workbench.editor.notebook",e.$vH="workbench.editor.notebookTextDiffEditor",e.$wH="workbench.editor.interactive";var A;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(A||(e.CellKind=A={})),e.$xH=["application/json","application/javascript","text/html","image/svg+xml",M.$ur.latex,M.$ur.markdown,"image/png","image/jpeg",M.$ur.text],e.$yH=[M.$ur.latex,M.$ur.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$ur.text],e.$zH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$AH="_notAvailable";var E;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(E||(e.NotebookRunState=E={}));var c;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(c||(e.NotebookCellExecutionState=c={}));var y;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var b;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(b||(e.NotebookRendererMatch=b={}));var o;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var t;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var a;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(a||(e.CellEditType=a={}));var m;(function(O){O.scheme=P.Schemas.vscodeNotebookCell;const ce=["W","X","Y","Z","a","b","c","d","e","f"],X=new RegExp(`^[${ce.join("")}]+`),be=7;function Ee(ne,re){const L=re.toString(be),pe=`${L.length<ce.length?ce[L.length-1]:"z"}${L}s${(0,w.$4b)(w.$Jb.fromString(ne.scheme),!0,!0)}`;return ne.with({scheme:O.scheme,fragment:pe})}O.generate=Ee;function Re(ne){if(ne.scheme!==O.scheme)return;const re=ne.fragment.indexOf("s");if(re<0)return;const L=parseInt(ne.fragment.substring(0,re).replace(X,""),be),_=(0,w.$3b)(ne.fragment.substring(re+1)).toString();if(!isNaN(L))return{handle:L,notebook:ne.with({scheme:_,fragment:null})}}O.parse=Re;function Z(ne,re){return ne.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${re??""},${ne.scheme!==P.Schemas.file?ne.scheme:""}`})}O.generateCellOutputUri=Z;function he(ne){if(ne.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const re=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!re)return;const L=re[1]&&re[1]!==""?re[1]:void 0,_=re[2];return{outputId:L,notebook:ne.with({scheme:_||P.Schemas.file,fragment:null})}}O.parseCellOutputUri=he;function Ce(ne,re,L){return O.generate(ne,re).with({scheme:L})}O.generateCellPropertyUri=Ce;function H(ne,re){if(ne.scheme===re)return O.parse(ne.with({scheme:O.scheme}))}O.parseCellPropertyUri=H})(m||(e.CellUri=m={}));const S=O=>D.$i?O.replace(/\//g,"\\"):O;class I{constructor(ce=[],X=e.$xH){this.e=X,this.d=[...new Set(ce)].map(be=>({pattern:be,matches:T.$ej(S(be))}))}sort(ce){const X=new Map(C.Iterable.map(ce,Ee=>[Ee,S(Ee)]));let be=[];for(const{matches:Ee}of this.d)for(const[Re,Z]of X)if(Ee(Z)){be.push(Re),X.delete(Re);break}return X.size&&(be=be.concat([...X.keys()].sort((Ee,Re)=>this.e.indexOf(Ee)-this.e.indexOf(Re)))),be}prioritize(ce,X){const be=this.f(ce);if(be===-1){this.d.unshift({pattern:ce,matches:T.$ej(S(ce))});return}const Ee=new Set(X.map(Z=>this.f(Z,be)));Ee.delete(-1);const Re=Array.from(Ee).sort();this.d.splice(be+1,0,...Re.map(Z=>this.d[Z]));for(let Z=Re.length-1;Z>=0;Z--)this.d.splice(Re[Z],1)}toArray(){return this.d.map(ce=>ce.pattern)}f(ce,X=this.d.length){const be=S(ce);for(let Ee=0;Ee<X;Ee++)if(this.d[Ee].matches(be))return Ee;return-1}}e.$BH=I;function r(O,ce,X,be=(Ee,Re)=>Ee===Re){const Ee=[];function Re(Ce,H,ne){if(H===0&&ne.length===0)return;const re=Ee[Ee.length-1];re&&re.start+re.deleteCount===Ce?(re.deleteCount+=H,re.toInsert.push(...ne)):Ee.push({start:Ce,deleteCount:H,toInsert:ne})}let Z=0,he=0;for(;;){if(Z===O.length){Re(Z,0,ce.slice(he));break}if(he===ce.length){Re(Z,O.length-Z,[]);break}const Ce=O[Z],H=ce[he];if(be(Ce,H)){Z+=1,he+=1;continue}X(H)?(Re(Z,1,[]),Z+=1):(Re(Z,0,[H]),he+=1)}return Ee}e.$CH=r,e.$DH=new p.$Oi("notebookEditorCursorAtBoundary","none");var h;(function(O){O.default="default",O.option="option"})(h||(e.NotebookEditorPriority=h={}));function n(O){const ce=O;return!!((typeof ce.include=="string"||T.$fj(ce.include))&&(typeof ce.exclude=="string"||T.$fj(ce.exclude)))}e.$EH=n;function s(O,ce,X){if(Array.isArray(O.viewType)&&O.viewType.indexOf(ce)>=0||O.viewType===ce)return!0;if(O.filenamePattern){const be=n(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,Ee=n(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(T.$dj(be,(0,g.$ec)(X.fsPath).toLowerCase()))return!(Ee&&T.$dj(Ee,(0,g.$ec)(X.fsPath).toLowerCase()))}return!1}e.$FH=s,e.$GH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var $;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})($||(e.CellStatusbarAlignment=$={}));class k{static{this.d="notebook/"}static create(ce){return`${k.d}${ce}`}static parse(ce){if(ce.startsWith(k.d))return ce.substring(k.d.length)}}e.$HH=k;function l(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$IH=l;const f=new TextDecoder;function v(O){const ce=[];let X=!1;for(const Z of O)(ce.length===0||X)&&(ce.push(Z),X=!0);let be=R(ce);const Ee=w.$Jb.concat(ce.map(Z=>w.$Jb.wrap(Z))),Re=N(Ee);return be=be||Re.byteLength!==Ee.byteLength,{data:Re,didCompression:be}}e.$JH=v,e.$KH=`${String.fromCharCode(27)}[A`;const u=e.$KH.split("").map(O=>O.charCodeAt(0)),d=10;function R(O){let ce=!1;return O.forEach((X,be)=>{if(be===0||X.length<e.$KH.length)return;const Ee=O[be-1],Re=X.subarray(0,e.$KH.length);if(Re[0]===u[0]&&Re[1]===u[1]&&Re[2]===u[2]){const Z=Ee.lastIndexOf(d);if(Z===-1)return;ce=!0,O[be-1]=Ee.subarray(0,Z),O[be]=X.subarray(e.$KH.length)}}),ce}function W(O){let ce=O;do O=ce,ce=O.replace(/[^\n]\x08/gm,"");while(ce.length<O.length);return O}function B(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const ce=O.match(/^(.*)\r+/m)[1];let X=O.match(/\r+(.*)$/m)[1];X=X+ce.slice(X.length,ce.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return O}const q="\b".charCodeAt(0),U="\r".charCodeAt(0);function N(O){return!O.buffer.includes(q)&&!O.buffer.includes(U)?O:w.$Jb.fromString(B(W(f.decode(O.buffer))))}}),define(Ae[7],Fe([1,0,18,11,49,28,68,15,12,2,36,21,38,96,74]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b){"use strict";var o,t,i,a,m,S,I,r,h,n,s,$,k,l,f,v,u,d;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.TestRunProfileKind=e.TestResultState=e.$_K=e.$$K=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$0K=e.$9K=e.$8K=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$7K=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.ColorThemeKind=e.$1K=e.$ZK=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$YK=e.DebugConsoleMode=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$SK=e.$RK=e.FileChangeType=e.$QK=e.$PK=e.$OK=e.$NK=e.InlineCompletionTriggerKind=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.ConfigurationTarget=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$qK=e.ViewBadge=e.ProgressLocation=e.$pK=e.$oK=e.TaskScope=e.ShellQuoting=e.$nK=e.$mK=e.$lK=e.TaskPanelKind=e.TaskRevealKind=e.$kK=e.TerminalLocation=e.$jK=e.$iK=e.$hK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$gK=e.$fK=e.$eK=e.$dK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$cK=e.StatusBarAlignment=e.ViewColumn=e.$bK=e.$aK=e.$_J=e.$$J=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$0J=e.$9J=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.LanguageStatusSeverity=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.CodeActionTriggerKind=e.$VJ=e.$UJ=e.SymbolTag=e.SymbolKind=e.$TJ=e.DocumentHighlightKind=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.DiagnosticSeverity=e.DiagnosticTag=e.$OJ=e.$NJ=e.FileEditType=e.$MJ=e.$LJ=e.$KJ=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function R(j){return Object.assign(j,{apply:function(){const se=arguments.length===1?[]:arguments[1];return Reflect.construct(j,se,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(j,[]);{const[se,...ke]=arguments;return Reflect.construct(j,ke,se.constructor)}}})}var W;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var B;(function(j){j[j.Command=0]="Command",j[j.Opener=1]="Opener"})(B||(e.TerminalQuickFixType=B={}));let q=o=class{static from(...z){let se=z;return new o(function(){if(se){for(const ke of se)ke&&typeof ke.dispose=="function"&&ke.dispose();se=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$DJ=q,e.$DJ=q=o=Ve([R],q);let U=t=class{static Min(...z){if(z.length===0)throw new TypeError;let se=z[0];for(let ke=1;ke<z.length;ke++){const Je=z[ke];Je.isBefore(se)&&(se=Je)}return se}static Max(...z){if(z.length===0)throw new TypeError;let se=z[0];for(let ke=1;ke<z.length;ke++){const Je=z[ke];Je.isAfter(se)&&(se=Je)}return se}static isPosition(z){if(!z)return!1;if(z instanceof t)return!0;const{line:se,character:ke}=z;return typeof se=="number"&&typeof ke=="number"}static of(z){if(z instanceof t)return z;if(this.isPosition(z))return new t(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,se){if(z<0)throw(0,T.$5)("line must be non-negative");if(se<0)throw(0,T.$5)("character must be non-negative");this.c=z,this.e=se}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,se=0){if(z===null||se===null)throw(0,T.$5)();let ke;return typeof z>"u"?ke=0:typeof z=="number"?ke=z:(ke=typeof z.lineDelta=="number"?z.lineDelta:0,se=typeof z.characterDelta=="number"?z.characterDelta:0),ke===0&&se===0?this:new t(this.line+ke,this.character+se)}with(z,se=this.character){if(z===null||se===null)throw(0,T.$5)();let ke;return typeof z>"u"?ke=this.line:typeof z=="number"?ke=z:(ke=typeof z.line=="number"?z.line:this.line,se=typeof z.character=="number"?z.character:this.character),ke===this.line&&se===this.character?this:new t(ke,se)}toJSON(){return{line:this.line,character:this.character}}};e.$EJ=U,e.$EJ=U=t=Ve([R],U);let N=i=class{static isRange(z){return z instanceof i?!0:z?U.isPosition(z.start)&&U.isPosition(z.end):!1}static of(z){if(z instanceof i)return z;if(this.isRange(z))return new i(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,se,ke,Je){let Qe,rt;if(typeof z=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof Je=="number"?(Qe=new U(z,se),rt=new U(ke,Je)):U.isPosition(z)&&U.isPosition(se)&&(Qe=U.of(z),rt=U.of(se)),!Qe||!rt)throw new Error("Invalid arguments");Qe.isBefore(rt)?(this.c=Qe,this.e=rt):(this.c=rt,this.e=Qe)}contains(z){return i.isRange(z)?this.contains(z.start)&&this.contains(z.end):U.isPosition(z)?!(U.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const se=U.Max(z.start,this.c),ke=U.Min(z.end,this.e);if(!se.isAfter(ke))return new i(se,ke)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const se=U.Min(z.start,this.c),ke=U.Max(z.end,this.end);return new i(se,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,se=this.end){if(z===null||se===null)throw(0,T.$5)();let ke;return z?U.isPosition(z)?ke=z:(ke=z.start||this.start,se=z.end||this.end):ke=this.start,ke.isEqual(this.c)&&se.isEqual(this.end)?this:new i(ke,se)}toJSON(){return[this.start,this.end]}};e.$FJ=N,e.$FJ=N=i=Ve([R],N);let O=a=class extends N{static isSelection(z){return z instanceof a?!0:z?N.isRange(z)&&U.isPosition(z.anchor)&&U.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,se,ke,Je){let Qe,rt;if(typeof z=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof Je=="number"?(Qe=new U(z,se),rt=new U(ke,Je)):U.isPosition(z)&&U.isPosition(se)&&(Qe=U.of(z),rt=U.of(se)),!Qe||!rt)throw new Error("Invalid arguments");super(Qe,rt),this.f=Qe,this.g=rt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$GJ=O,e.$GJ=O=a=Ve([R],O);const ce=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,T.$5)("connectionToken")};class X{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,se,ke){if(typeof z!="string"||z.length===0)throw(0,T.$5)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,T.$5)("port");typeof ke<"u"&&ce(ke),this.host=z,this.port=Math.round(se),this.connectionToken=ke}}e.$HJ=X;class be{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,se){this.makeConnection=z,this.connectionToken=se,typeof se<"u"&&ce(se)}}e.$IJ=be;class Ee extends Error{static NotAvailable(z,se){return new Ee(z,y.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(z){return new Ee(z,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,se=y.RemoteAuthorityResolverErrorCode.Unknown,ke){super(z),this._message=z,this._code=se,this._detail=ke,Object.setPrototypeOf(this,Ee.prototype)}}e.$JJ=Ee;var Re;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Re||(e.EndOfLine=Re={}));var Z;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(Z||(e.EnvironmentVariableMutatorType=Z={}));let he=m=class{static isTextEdit(z){return z instanceof m?!0:z?N.isRange(z)&&typeof z.newText=="string":!1}static replace(z,se){return new m(z,se)}static insert(z,se){return m.replace(new N(z,z),se)}static delete(z){return m.replace(z,"")}static setEndOfLine(z){const se=new m(new N(new U(0,0),new U(0,0)),"");return se.newEol=z,se}get range(){return this.c}set range(z){if(z&&!N.isRange(z))throw(0,T.$5)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,T.$5)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,T.$5)("newEol");this.f=z}constructor(z,se){this.c=z,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$KJ=he,e.$KJ=he=m=Ve([R],he);let Ce=S=class{static isNotebookCellEdit(z){return z instanceof S?!0:z?Zt.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,se){return new S(z,se)}static insertCells(z,se){return new S(new Zt(z,z),se)}static deleteCells(z){return new S(z,[])}static updateCellMetadata(z,se){const ke=new S(new Zt(z,z),[]);return ke.newCellMetadata=se,ke}static updateNotebookMetadata(z){const se=new S(new Zt(0,0),[]);return se.newNotebookMetadata=z,se}constructor(z,se){this.range=z,this.newCells=se}};e.$LJ=Ce,e.$LJ=Ce=S=Ve([R],Ce);class H{static isSnippetTextEdit(z){return z instanceof H?!0:z?N.isRange(z.range)&&L.isSnippetString(z.snippet):!1}static replace(z,se){return new H(z,se)}static insert(z,se){return H.replace(new N(z,z),se)}constructor(z,se){this.range=z,this.snippet=se}}e.$MJ=H;var ne;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(ne||(e.FileEditType=ne={}));let re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,se,ke,Je){this.c.push({_type:1,from:z,to:se,options:ke,metadata:Je})}createFile(z,se,ke){this.c.push({_type:1,from:void 0,to:z,options:se,metadata:ke})}deleteFile(z,se,ke){this.c.push({_type:1,from:z,to:void 0,options:se,metadata:ke})}e(z,se,ke){this.c.push({_type:3,metadata:ke,uri:z,edit:{editType:5,metadata:se},notebookMetadata:se})}f(z,se,ke,Je){const Qe=se.start,rt=se.end;(Qe!==rt||ke.length>0)&&this.c.push({_type:5,uri:z,index:Qe,count:rt-Qe,cells:ke,metadata:Je})}g(z,se,ke,Je){this.c.push({_type:3,metadata:Je,uri:z,edit:{editType:3,index:se,metadata:ke}})}replace(z,se,ke,Je){this.c.push({_type:2,uri:z,edit:new he(se,ke),metadata:Je})}insert(z,se,ke,Je){this.replace(z,new N(se,se),ke,Je)}delete(z,se,ke){this.replace(z,se,"",ke)}has(z){return this.c.some(se=>se._type===2&&se.uri.toString()===z.toString())}set(z,se){if(se)for(const ke of se){if(!ke)continue;let Je,Qe;Array.isArray(ke)?(Je=ke[0],Qe=ke[1]):Je=ke,Ce.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(z,Je.range.start,Je.newCellMetadata,Qe):Je.newNotebookMetadata?this.e(z,Je.newNotebookMetadata,Qe):this.f(z,Je.range,Je.newCells,Qe):H.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:z,range:Je.range,edit:Je.snippet,metadata:Qe}):this.c.push({_type:2,uri:z,edit:Je,metadata:Qe})}else{for(let ke=0;ke<this.c.length;ke++){const Je=this.c[ke];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===z.toString()&&(this.c[ke]=void 0);break}}(0,w.$nf)(this.c)}}get(z){const se=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===z.toString()&&se.push(ke.edit);return se}entries(){const z=new M.$ni;for(const se of this.c)if(se._type===2){let ke=z.get(se.uri);ke||(ke=[se.uri,[]],z.set(se.uri,ke)),ke[1].push(se.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$NJ=re,e.$NJ=re=Ve([R],re);let L=I=class{static isSnippetString(z){return z instanceof I?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=I.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,se=this.e++){if(typeof z=="function"){const ke=new I;ke.e=this.e,z(ke),this.e=ke.e,z=ke.value}else z=I.c(z);return this.value+="${",this.value+=se,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,se=this.e++){const ke=z.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(z,se){if(typeof se=="function"){const ke=new I;ke.e=this.e,se(ke),this.e=ke.e,se=ke.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$OJ=L,e.$OJ=L=I=Ve([R],L);var _;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(_||(e.DiagnosticTag=_={}));var pe;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(pe||(e.DiagnosticSeverity=pe={}));let Ie=r=class{static isLocation(z){return z instanceof r?!0:z?N.isRange(z.range)&&p.URI.isUri(z.uri):!1}constructor(z,se){if(this.uri=z,se)if(N.isRange(se))this.range=N.of(se);else if(U.isPosition(se))this.range=new N(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$PJ=Ie,e.$PJ=Ie=r=Ve([R],Ie);let De=class{static is(z){return z?typeof z.message=="string"&&z.location&&N.isRange(z.location.range)&&p.URI.isUri(z.location.uri):!1}constructor(z,se){this.location=z,this.message=se}static isEqual(z,se){return z===se?!0:!z||!se?!1:z.message===se.message&&z.location.range.isEqual(se.location.range)&&z.location.uri.toString()===se.location.uri.toString()}};e.$QJ=De,e.$QJ=De=Ve([R],De);let ye=class{constructor(z,se,ke=pe.Error){if(!N.isRange(z))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=z,this.message=se,this.severity=ke}toJSON(){return{severity:pe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,se){return z===se?!0:!z||!se?!1:z.message===se.message&&z.severity===se.severity&&z.code===se.code&&z.severity===se.severity&&z.source===se.source&&z.range.isEqual(se.range)&&(0,w.$bf)(z.tags,se.tags)&&(0,w.$bf)(z.relatedInformation,se.relatedInformation,De.isEqual)}};e.$RJ=ye,e.$RJ=ye=Ve([R],ye);let Se=class{constructor(z,se){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=se}};e.$SJ=Se,e.$SJ=Se=Ve([R],Se);var oe;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let de=class{constructor(z,se=oe.Text){this.range=z,this.kind=se}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$TJ=de,e.$TJ=de=Ve([R],de);var ee;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var ie;(function(j){j[j.Deprecated=1]="Deprecated"})(ie||(e.SymbolTag=ie={}));let le=h=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,se,ke,Je,Qe){this.name=z,this.kind=se,this.containerName=Qe,typeof ke=="string"&&(this.containerName=ke),Je instanceof Ie?this.location=Je:ke instanceof N&&(this.location=new Ie(Je,ke)),h.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.$UJ=le,e.$UJ=le=h=Ve([R],le);let F=n=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(n.validate)}constructor(z,se,ke,Je,Qe){this.name=z,this.detail=se,this.kind=ke,this.range=Je,this.selectionRange=Qe,this.children=[],n.validate(this)}};e.$VJ=F,e.$VJ=F=n=Ve([R],F);var V;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(V||(e.CodeActionTriggerKind=V={}));let J=class{constructor(z,se){this.title=z,this.kind=se}};e.$WJ=J,e.$WJ=J=Ve([R],J);let K=class{static{s=this}static{this.c="."}constructor(z){this.value=z}append(z){return new s(this.value?this.value+s.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+s.c)}};e.$XJ=K,e.$XJ=K=s=Ve([R],K);class ae extends K{constructor(z){super(z),this.value=z}}e.$YJ=ae,K.Empty=new K(""),K.QuickFix=K.Empty.append("quickfix"),K.Refactor=K.Empty.append("refactor"),K.RefactorExtract=K.Refactor.append("extract"),K.RefactorInline=K.Refactor.append("inline"),K.RefactorMove=K.Refactor.append("move"),K.RefactorRewrite=K.Refactor.append("rewrite"),K.Source=K.Empty.append("source"),K.SourceOrganizeImports=K.Source.append("organizeImports"),K.SourceFixAll=K.Source.append("fixAll"),K.Notebook=K.Empty.append("notebook");let G=class{constructor(z,se){if(this.range=z,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$ZJ=G,e.$ZJ=G=Ve([R],G);class ue{constructor(z,se,ke,Je,Qe,rt){this.kind=z,this.name=se,this.detail=ke,this.uri=Je,this.range=Qe,this.selectionRange=rt}}e.$1J=ue;class me{constructor(z,se){this.fromRanges=se,this.from=z}}e.$2J=me;class Ne{constructor(z,se){this.fromRanges=se,this.to=z}}e.$3J=Ne;var Be;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Be||(e.LanguageStatusSeverity=Be={}));let Ye=class{constructor(z,se){this.range=z,this.command=se}get isResolved(){return!!this.command}};e.$4J=Ye,e.$4J=Ye=Ve([R],Ye);let Ke=$=class{#e;static isMarkdownString(z){return z instanceof $?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,se=!1){this.#e=new C.$Kj(z,{supportThemeIcons:se})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,se){return this.#e.appendCodeblock(se??"",z),this}};e.$5J=Ke,e.$5J=Ke=$=Ve([R],Ke);let Xe=class{constructor(z,se){this.label=z,this.documentation=se}};e.$6J=Xe,e.$6J=Xe=Ve([R],Xe);let Ge=class{constructor(z,se){this.label=z,this.documentation=se,this.parameters=[]}};e.$7J=Ge,e.$7J=Ge=Ve([R],Ge);let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$8J=ct,e.$8J=ct=Ve([R],ct);var xe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(xe||(e.SignatureHelpTriggerKind=xe={}));var tt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let Oe=class{constructor(z){this.value=z}};e.$9J=Oe,e.$9J=Oe=Ve([R],Oe);let nt=class{constructor(z,se,ke){this.position=z,this.label=se,this.kind=ke}};e.$0J=nt,e.$0J=nt=Ve([R],nt);var x;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(x||(e.CompletionTriggerKind=x={}));var Y;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Y||(e.CompletionItemKind=Y={}));var ge;(function(j){j[j.Deprecated=1]="Deprecated"})(ge||(e.CompletionItemTag=ge={}));let je=class{constructor(z,se){this.label=z,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Y[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$$J=je,e.$$J=je=Ve([R],je);let Me=class{constructor(z=[],se=!1){this.items=z,this.isIncomplete=se}};e.$_J=Me,e.$_J=Me=Ve([R],Me);let Ze=class{constructor(z,se,ke){this.insertText=z,this.range=se,this.command=ke}};e.$aK=Ze,e.$aK=Ze=Ve([R],Ze);let et=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$bK=et,e.$bK=et=Ve([R],et);var gt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(gt||(e.ViewColumn=gt={}));var wt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(wt||(e.StatusBarAlignment=wt={}));function Nt(j,z){return`${E.$Hl.toKey(j)}.${z}`}e.$cK=Nt;var Jt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Jt||(e.TextEditorLineNumbersStyle=Jt={}));var Wt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Wt||(e.TextDocumentSaveReason=Wt={}));var yt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(yt||(e.TextEditorRevealType=yt={}));var At;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(At||(e.TextEditorSelectionChangeKind=At={}));var Ft;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Ft||(e.TextDocumentChangeReason=Ft={}));var zt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(zt||(e.DecorationRangeBehavior=zt={})),function(j){function z(se){switch(se){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=z}(At||(e.TextEditorSelectionChangeKind=At={}));let Ut=class{constructor(z,se){if(se&&!p.URI.isUri(se))throw(0,T.$5)("target");if(!N.isRange(z)||z.isEmpty)throw(0,T.$5)("range");this.range=z,this.target=se}};e.$dK=Ut,e.$dK=Ut=Ve([R],Ut);let Lt=class{constructor(z,se,ke,Je){this.red=z,this.green=se,this.blue=ke,this.alpha=Je}};e.$eK=Lt,e.$eK=Lt=Ve([R],Lt);let st=class{constructor(z,se){if(se&&!(se instanceof Lt))throw(0,T.$5)("color");if(!N.isRange(z)||z.isEmpty)throw(0,T.$5)("range");this.range=z,this.color=se}};e.$fK=st,e.$fK=st=Ve([R],st);let ht=class{constructor(z){if(!z||typeof z!="string")throw(0,T.$5)("label");this.label=z}};e.$gK=ht,e.$gK=ht=Ve([R],ht);var jt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(jt||(e.ColorFormat=jt={}));var Tt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Tt||(e.SourceControlInputBoxValidationType=Tt={}));var Dt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Dt||(e.TerminalExitReason=Dt={}));class ot{constructor(z,se,ke){if(this.startIndex=z,this.length=se,this.tooltip=ke,typeof z!="number"||z<0)throw(0,T.$5)("startIndex");if(typeof se!="number"||se<1)throw(0,T.$5)("length");if(ke!==void 0&&typeof ke!="string")throw(0,T.$5)("tooltip")}}e.$hK=ot;class Pt{constructor(z){this.uri=z}}e.$iK=Pt;class Mt{constructor(z){this.terminalCommand=z}}e.$jK=Mt;var Pe;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Pe||(e.TerminalLocation=Pe={}));class we{constructor(z){if(this.options=z,typeof z!="object")throw(0,T.$5)("options")}}e.$kK=we;var ve;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ve||(e.TaskRevealKind=ve={}));var Q;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Q||(e.TaskPanelKind=Q={}));let Le=class{static{k=this}static{this.Clean=new k("clean","Clean")}static{this.Build=new k("build","Build")}static{this.Rebuild=new k("rebuild","Rebuild")}static{this.Test=new k("test","Test")}static from(z){switch(z){case"clean":return k.Clean;case"build":return k.Build;case"rebuild":return k.Rebuild;case"test":return k.Test;default:return}}constructor(z,se){if(this.label=se,typeof z!="string"||typeof se!="string")throw(0,T.$5)("name");this.c=z}get id(){return this.c}};e.$lK=Le,e.$lK=Le=k=Ve([R],Le);function Ue(j){let z="";for(let se=0;se<j.length;se++)z+=j[se].replace(/,/g,",,")+",";return z}let He=class{constructor(z,se,ke){if(typeof z!="string")throw(0,T.$5)("process");this.e=[],this.c=z,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=ke):this.f=se)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,T.$5)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const se of this.e)z.push(se);return Ue(z)}};e.$mK=He,e.$mK=He=Ve([R],He);let We=class{constructor(z,se,ke){if(this.f=[],Array.isArray(se)){if(!z)throw(0,T.$5)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,T.$5)("command");this.e=z,this.f=se,this.g=ke}else{if(typeof z!="string")throw(0,T.$5)("commandLine");this.c=z,this.g=se}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,T.$5)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,T.$5)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)z.push(typeof se=="string"?se:se.value);return Ue(z)}};e.$nK=We,e.$nK=We=Ve([R],We);var _e;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(_e||(e.ShellQuoting=_e={}));var bt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(bt||(e.TaskScope=bt={}));class kt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,A.$6e)()}set callback(z){this.c=z}get callback(){return this.c}}e.$oK=kt;let St=class{static{l=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,se,ke,Je,Qe,rt){this.j=!1,this.k=this.definition=z;let ut;typeof se=="string"?(this.m=this.name=se,this.t=this.source=ke,this.execution=Je,ut=Qe,this.j=!0):se===bt.Global||se===bt.Workspace?(this.target=se,this.m=this.name=ke,this.t=this.source=Je,this.execution=Qe,ut=rt):(this.target=se,this.m=this.name=ke,this.t=this.source=Je,this.execution=Qe,ut=rt),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(z){this.h=z}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof He?this.k={type:l.e,id:this.n.computeId()}:this.n instanceof We?this.k={type:l.f,id:this.n.computeId()}:this.n instanceof kt?this.k={type:l.c,id:this.n.computeId()}:this.k={type:l.g,id:(0,A.$6e)()}}get definition(){return this.k}set definition(z){if(z==null)throw(0,T.$5)("Kind can't be undefined or null");this.y(),this.k=z}get scope(){return this.l}set target(z){this.y(),this.l=z}get name(){return this.m}set name(z){if(typeof z!="string")throw(0,T.$5)("name");this.y(),this.m=z}get execution(){return this.n}set execution(z){z===null&&(z=void 0),this.y(),this.n=z;const se=this.k.type;(l.g===se||l.e===se||l.f===se||l.c===se)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(z){if(Array.isArray(z))this.y(),this.o=z,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.y(),this.r=z}get source(){return this.t}set source(z){if(typeof z!="string"||z.length===0)throw(0,T.$5)("source must be a string of length > 0");this.y(),this.t=z}get group(){return this.u}set group(z){z===null&&(z=void 0),this.y(),this.u=z}get detail(){return this.x}set detail(z){z===null&&(z=void 0),this.x=z}get presentationOptions(){return this.v}set presentationOptions(z){z==null&&(z=Object.create(null)),this.y(),this.v=z}get runOptions(){return this.w}set runOptions(z){z==null&&(z=Object.create(null)),this.y(),this.w=z}};e.$pK=St,e.$pK=St=l=Ve([R],St);var pt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(pt||(e.ProgressLocation=pt={}));var mt;(function(j){function z(se){const ke=se;return(0,D.$ne)(ke.value)?ke.tooltip&&!(0,D.$je)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}j.isViewBadge=z})(mt||(e.ViewBadge=mt={}));let lt=f=class{static isTreeItem(z,se){const ke=z;if(ke.checkboxState!==void 0){const Je=(0,D.$ne)(ke.checkboxState)?ke.checkboxState:(0,D.$le)(ke.checkboxState)&&(0,D.$ne)(ke.checkboxState.state)?ke.checkboxState.state:void 0,Qe=!(0,D.$ne)(ke.checkboxState)&&(0,D.$le)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(Je===void 0||Je!==ft.Checked&&Je!==ft.Unchecked||Qe!==void 0&&!(0,D.$je)(Qe))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(z instanceof f)return!0;if(ke.label!==void 0&&!(0,D.$je)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,D.$je)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,D.$je)(ke.iconPath)&&!p.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,D.$je)(ke.iconPath.id))){const Je=ke.iconPath;if(!Je||!(0,D.$je)(Je.light)&&!p.URI.isUri(Je.light)&&!(0,D.$je)(Je.dark)&&!p.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,D.$je)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!p.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,D.$je)(ke.tooltip)&&!(ke.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<$t.None&&ke.collapsibleState>$t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,D.$je)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(z,se=$t.None){this.collapsibleState=se,p.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$qK=lt,e.$qK=lt=f=Ve([R],lt);var $t;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})($t||(e.TreeItemCollapsibleState=$t={}));var ft;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(ft||(e.TreeItemCheckboxState=ft={}));let Yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$rK=Yt,e.$rK=Yt=Ve([R],Yt);class Bt extends Yt{}e.$sK=Bt;class Xi extends Bt{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$tK=Xi;class hi{constructor(z,se,ke,Je){this.name=z,this.uri=se,this._itemId=ke,this.c=Je}data(){return this.c()}}e.$uK=hi;let di=class{#e=new Map;constructor(z){for(const[se,ke]of z??[]){const Je=this.#e.get(this.#t(se));Je?Je.push(ke):this.#e.set(this.#t(se),[ke])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,se){this.#e.set(this.#t(z),[se])}forEach(z,se){for(const[ke,Je]of this.#e)for(const Qe of Je)z.call(se,Qe,ke,this)}*[Symbol.iterator](){for(const[z,se]of this.#e)for(const ke of se)yield[z,ke]}#t(z){return z.toLowerCase()}};e.$vK=di,e.$vK=di=Ve([R],di);let It=class{constructor(z){this.insertText=z}};e.$wK=It,e.$wK=It=Ve([R],It);let yi=class{constructor(z,se,ke){this.id=se,this.label=ke,this.insertText=z}};e.$xK=yi,e.$xK=yi=Ve([R],yi);let Kt=class{constructor(z,se){this.id=z,this.color=se}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$yK=Kt,e.$yK=Kt=Ve([R],Kt),Kt.File=new Kt("file"),Kt.Folder=new Kt("folder");let Et=class{constructor(z){this.id=z}};e.$zK=Et,e.$zK=Et=Ve([R],Et);var Ei;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Ei||(e.ConfigurationTarget=Ei={}));let fi=class{get base(){return this.c}set base(z){this.c=z,this.e=p.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,se){if(typeof z!="string"&&(!z||!p.URI.isUri(z)&&!p.URI.isUri(z.uri)))throw(0,T.$5)("base");if(typeof se!="string")throw(0,T.$5)("pattern");typeof z=="string"?this.baseUri=p.URI.file(z):p.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$AK=fi,e.$AK=fi=Ve([R],fi);const ai=new WeakMap;function _i(j,z){ai.set(j,z)}e.$BK=_i;let ni=class{constructor(z,se,ke,Je){this.enabled=typeof z=="boolean"?z:!0,typeof se=="string"&&(this.condition=se),typeof ke=="string"&&(this.hitCondition=ke),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=ai.get(this)??(0,A.$6e)()),this.c}};e.$CK=ni,e.$CK=ni=Ve([R],ni);let Rt=class extends ni{constructor(z,se,ke,Je,Qe){if(super(se,ke,Je,Qe),z===null)throw(0,T.$5)("location");this.location=z}};e.$DK=Rt,e.$DK=Rt=Ve([R],Rt);let gi=class extends ni{constructor(z,se,ke,Je,Qe){super(se,ke,Je,Qe),this.functionName=z}};e.$EK=gi,e.$EK=gi=Ve([R],gi);let Di=class extends ni{constructor(z,se,ke,Je,Qe,rt,ut){if(super(Je,Qe,rt,ut),!se)throw(0,T.$5)("dataId");this.label=z,this.dataId=se,this.canPersist=ke}};e.$FK=Di,e.$FK=Di=Ve([R],Di);let ri=class{constructor(z,se,ke){this.command=z,this.args=se||[],this.options=ke}};e.$GK=ri,e.$GK=ri=Ve([R],ri);let si=class{constructor(z,se){this.port=z,this.host=se}};e.$HK=si,e.$HK=si=Ve([R],si);let at=class{constructor(z){this.path=z}};e.$IK=at,e.$IK=at=Ve([R],at);let ki=class{constructor(z){this.implementation=z}};e.$JK=ki,e.$JK=ki=Ve([R],ki);let Ht=class{constructor(z,se,ke){this.session=z,this.threadId=se,this.frameId=ke}};e.$KK=Ht,e.$KK=Ht=Ve([R],Ht);let xt=class{constructor(z,se){this.session=z,this.threadId=se}};e.$LK=xt,e.$LK=xt=Ve([R],xt);let mi=class{constructor(z,se){this.range=z,this.expression=se}};e.$MK=mi,e.$MK=mi=Ve([R],mi);var Ni;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Ni||(e.InlineCompletionTriggerKind=Ni={}));let Si=class{constructor(z,se){this.range=z,this.text=se}};e.$NK=Si,e.$NK=Si=Ve([R],Si);let Ii=class{constructor(z,se,ke=!0){this.range=z,this.variableName=se,this.caseSensitiveLookup=ke}};e.$OK=Ii,e.$OK=Ii=Ve([R],Ii);let $i=class{constructor(z,se){this.range=z,this.expression=se}};e.$PK=$i,e.$PK=$i=Ve([R],$i);let Ci=class{constructor(z,se){this.frameId=z,this.stoppedLocation=se}};e.$QK=Ci,e.$QK=Ci=Ve([R],Ci);var Pi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Pi||(e.FileChangeType=Pi={}));let ei=v=class extends Error{static FileExists(z){return new v(z,c.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(z){return new v(z,c.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(z){return new v(z,c.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(z){return new v(z,c.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(z){return new v(z,c.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(z){return new v(z,c.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(z,se=c.FileSystemProviderErrorCode.Unknown,ke){super(p.URI.isUri(z)?z.toString(!0):z),this.code=ke?.name??"Unknown",(0,c.$7j)(this,se),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$RK=ei,e.$RK=ei=v=Ve([R],ei);let Ri=class{constructor(z,se,ke){this.start=z,this.end=se,this.kind=ke}};e.$SK=Ri,e.$SK=Ri=Ve([R],Ri);var pi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(pi||(e.FoldingRangeKind=pi={}));var bi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(bi||(e.CommentThreadCollapsibleState=bi={}));var Ui;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Ui||(e.CommentMode=Ui={}));var ji;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(ji||(e.CommentState=ji={}));var oi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(oi||(e.CommentThreadState=oi={}));class xi{constructor(z,se=[]){this.tokenTypes=z,this.tokenModifiers=se}}e.$TK=xi;function en(j){return typeof j>"u"||(0,D.$ke)(j)}class Ai{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,z){this.l=!0;for(let se=0,ke=z.tokenTypes.length;se<ke;se++)this.j.set(z.tokenTypes[se],se);for(let se=0,ke=z.tokenModifiers.length;se<ke;se++)this.k.set(z.tokenModifiers[se],se)}}push(z,se,ke,Je,Qe){if(typeof z=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof Je=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this.n(z,se,ke,Je,Qe);if(N.isRange(z)&&typeof se=="string"&&en(ke))return this.m(z,se,ke);throw(0,T.$5)()}m(z,se,ke){if(!this.l)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(se))throw new Error("`tokenType` is not in the provided legend");const Je=z.start.line,Qe=z.start.character,rt=z.end.character-z.start.character,ut=this.j.get(se);let Ot=0;if(ke)for(const Vt of ke){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const Qt=this.k.get(Vt);Ot|=1<<Qt>>>0}this.n(Je,Qe,rt,ut,Ot)}n(z,se,ke,Je,Qe){if(this.f&&(z<this.c||z===this.c&&se<this.e)){this.f=!1;const Ot=this.g.length/5|0;let Vt=0,Qt=0;for(let _t=0;_t<Ot;_t++){let ti=this.g[5*_t],Mi=this.g[5*_t+1];ti===0?(ti=Vt,Mi+=Qt):ti+=Vt,this.g[5*_t]=ti,this.g[5*_t+1]=Mi,Vt=ti,Qt=Mi}}let rt=z,ut=se;this.f&&this.h>0&&(rt-=this.c,rt===0&&(ut-=this.e)),this.g[this.h++]=rt,this.g[this.h++]=ut,this.g[this.h++]=ke,this.g[this.h++]=Je,this.g[this.h++]=Qe,this.c=z,this.e=se}static o(z){const se=[],ke=z.length/5|0;for(let ut=0;ut<ke;ut++)se[ut]=ut;se.sort((ut,Ot)=>{const Vt=z[5*ut],Qt=z[5*Ot];if(Vt===Qt){const _t=z[5*ut+1],ti=z[5*Ot+1];return _t-ti}return Vt-Qt});const Je=new Uint32Array(z.length);let Qe=0,rt=0;for(let ut=0;ut<ke;ut++){const Ot=5*se[ut],Vt=z[Ot+0],Qt=z[Ot+1],_t=z[Ot+2],ti=z[Ot+3],Mi=z[Ot+4],yn=Vt-Qe,On=yn===0?Qt-rt:Qt,Oi=5*ut;Je[Oi+0]=yn,Je[Oi+1]=On,Je[Oi+2]=_t,Je[Oi+3]=ti,Je[Oi+4]=Mi,Qe=Vt,rt=Qt}return Je}build(z){return this.f?new Xt(new Uint32Array(this.g),z):new Xt(Ai.o(this.g),z)}}e.$UK=Ai;class Xt{constructor(z,se){this.resultId=se,this.data=z}}e.$VK=Xt;class tn{constructor(z,se,ke){this.start=z,this.deleteCount=se,this.data=ke}}e.$WK=tn;class nn{constructor(z,se){this.resultId=se,this.edits=z}}e.$XK=nn;var Fi;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Fi||(e.DebugConsoleMode=Fi={}));let Li=class{static{this.Back={iconPath:new Kt("arrow-left")}}constructor(){}};e.$YK=Li,e.$YK=Li=Ve([R],Li);var Bi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Bi||(e.QuickPickItemKind=Bi={}));var Wi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Wi||(e.InputBoxValidationSeverity=Wi={}));var vi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(vi||(e.ExtensionKind=vi={}));class qi{static validate(z){if(typeof z.badge=="string"){let se=(0,g.$Wd)(z.badge,0);if(se<z.badge.length&&(se+=(0,g.$Wd)(z.badge,se)),z.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!Kt.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,se,ke){this.badge=z,this.tooltip=se,this.color=ke}}e.$ZK=qi;let ze=class{constructor(z){this.kind=z}};e.$1K=ze,e.$1K=ze=Ve([R],ze);var Gt;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Gt||(e.ColorThemeKind=Gt={}));class Zt{static isNotebookRange(z){return z instanceof Zt?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,se){if(z<0)throw(0,T.$5)("start must be positive");if(se<0)throw(0,T.$5)("end must be positive");z<=se?(this.c=z,this.e=se):(this.c=se,this.e=z)}with(z){let se=this.c,ke=this.e;return z.start!==void 0&&(se=z.start),z.end!==void 0&&(ke=z.end),se===this.c&&ke===this.e?this:new Zt(se,ke)}}e.$2K=Zt;class dt{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(se=>dt.isNotebookCellData(se))}static isNotebookCellData(z){return!0}constructor(z,se,ke,Je,Qe,rt,ut){this.kind=z,this.value=se,this.languageId=ke,this.mime=Je,this.outputs=Qe??[],this.metadata=rt,this.executionSummary=ut,dt.validate(this)}}e.$3K=dt;class rn{constructor(z){this.cells=z}}e.$4K=rn;class qt{static isNotebookCellOutputItem(z){return z instanceof qt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const se={name:z.name,message:z.message,stack:z.stack};return qt.json(se,"application/vnd.code.notebook.error")}static stdout(z){return qt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return qt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,se="application/octet-stream"){return new qt(z,se)}static#e=new TextEncoder;static text(z,se=P.$ur.text){const ke=qt.#e.encode(String(z));return new qt(ke,se)}static json(z,se="text/x-json"){const ke=JSON.stringify(z,void 0,"	");return qt.text(ke,se)}constructor(z,se){this.data=z,this.mime=se;const ke=(0,P.$yr)(se,!0);if(!ke)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$5K=qt;class ci{static isNotebookCellOutput(z){return z instanceof ci?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,se=!1){const ke=new Set,Je=new Set;for(let Qe=0;Qe<z.length;Qe++){const rt=z[Qe],ut=(0,P.$yr)(rt.mime);if(!ke.has(ut)||(0,b.$IH)(ut)){ke.add(ut);continue}Je.add(Qe),se&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Je.size===0?z:z.filter((Qe,rt)=>!Je.has(rt))}constructor(z,se,ke){this.items=ci.ensureUniqueMimeTypes(z,!0),typeof se=="string"?(this.id=se,this.metadata=ke):(this.id=(0,A.$6e)(),this.metadata=se??ke)}}e.$6K=ci;var Vi;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Vi||(e.NotebookCellKind=Vi={}));var ui;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(ui||(e.NotebookCellExecutionState=ui={}));var Ji;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ji||(e.NotebookCellStatusBarAlignment=Ji={}));var Ki;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ki||(e.NotebookEditorRevealType=Ki={}));class sn{constructor(z,se){this.text=z,this.alignment=se}}e.$7K=sn;var Ti;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Ti||(e.NotebookControllerAffinity=Ti={}));var Hi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(Hi||(e.NotebookControllerAffinity2=Hi={}));class on{constructor(z,se=[]){this.uri=z,this.provides=(0,w.$Jf)(se)}}e.$8K=on;class an{constructor(z){this.label=z}}e.$9K=an;let zi=class{constructor(z,se){this.label=z,this.timestamp=se}};e.$0K=zi,e.$0K=zi=Ve([R],zi);var Gi;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Gi||(e.ExtensionMode=Gi={}));var Zi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Zi||(e.ExtensionRuntime=Zi={}));var Qi;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Qi||(e.StandardTokenType=Qi={}));class cn{constructor(z,se){this.ranges=z,this.wordPattern=se}}e.$$K=cn;class un{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$_K=un;var te;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(te||(e.TestResultState=te={}));var fe;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(fe||(e.TestRunProfileKind=fe={}));let Te=class{constructor(z=void 0,se=void 0,ke=void 0,Je=!1){this.include=z,this.exclude=se,this.profile=ke,this.continuous=Je}};e.$aL=Te,e.$aL=Te=Ve([R],Te);let it=class extends Te{};e.$bL=it,e.$bL=it=Ve([R],it);let vt=u=class{static diff(z,se,ke){const Je=new u(z);return Je.expectedOutput=se,Je.actualOutput=ke,Je}constructor(z){this.message=z}};e.$cL=vt,e.$cL=vt=u=Ve([R],vt);let Ct=class{constructor(z){this.id=z}};e.$dL=Ct,e.$dL=Ct=Ve([R],Ct);let wi=class{constructor(z,se){this.covered=z,this.total=se}};e.$eL=wi,e.$eL=wi=Ve([R],wi);let ln=d=class{static fromDetails(z,se){const ke=new wi(0,0),Je=new wi(0,0),Qe=new wi(0,0);for(const ut of se)if("branches"in ut){ke.total+=1,ke.covered+=ut.executionCount>0?1:0;for(const Ot of ut.branches)Je.total+=1,Je.covered+=Ot.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=ut.executionCount>0?1:0;const rt=new d(z,ke,Je.total>0?Je:void 0,Qe.total>0?Qe:void 0);return rt.detailedCoverage=se,rt}constructor(z,se,ke,Je){this.uri=z,this.statementCoverage=se,this.branchCoverage=ke,this.functionCoverage=Je}};e.$fL=ln,e.$fL=ln=d=Ve([R],ln);let hn=class{constructor(z,se,ke=[]){this.executionCount=z,this.location=se,this.branches=ke}};e.$gL=hn,e.$gL=hn=Ve([R],hn);let dn=class{constructor(z,se){this.executionCount=z,this.location=se}};e.$hL=dn,e.$hL=dn=Ve([R],dn);let fn=class{constructor(z,se){this.executionCount=z,this.location=se}};e.$iL=fn,e.$iL=fn=Ve([R],fn);var mn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(mn||(e.ExternalUriOpenerPriority=mn={}));var $n;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})($n||(e.WorkspaceTrustState=$n={}));var pn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(pn||(e.PortAutoForwardAction=pn={}));class In{constructor(z,se,ke,Je,Qe,rt){this.kind=z,this.name=se,this.detail=ke,this.uri=Je,this.range=Qe,this.selectionRange=rt}}e.$jL=In;class Cn{constructor(z){this.uri=z}}e.$kL=Cn;class Pn{constructor(z,se){this.original=z,this.modified=se}}e.$lL=Pn;class Rn{constructor(z,se,ke,Je){this.base=z,this.input1=se,this.input2=ke,this.result=Je}}e.$mL=Rn;class An{constructor(z,se){this.uri=z,this.viewType=se}}e.$nL=An;class Fn{constructor(z){this.viewType=z}}e.$oL=Fn;class Ln{constructor(z,se){this.uri=z,this.notebookType=se}}e.$pL=Ln;class Tn{constructor(z,se,ke){this.original=z,this.modified=se,this.notebookType=ke}}e.$qL=Tn;class zn{constructor(){}}e.$rL=zn;class Mn{constructor(z,se){this.uri=z,this.inputBoxUri=se}}e.$sL=Mn;var bn;(function(j){j[j.Up=1]="Up",j[j.Down=2]="Down"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var vn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var wn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})(wn||(e.InteractiveEditorResponseFeedbackKind=wn={}))}),define(Ae[100],Fe([1,0,50,13,15,273,136,7,18]),function($e,e,w,T,C,M,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HL=e.$GL=e.$FL=void 0;const p=new Map;function A(b,o){o?p.set(b,o):p.delete(b)}e.$FL=A;function E(b){return p.get(b)}class c extends M.$wu{constructor(o,t,i,a,m,S,I,r){super(t,i,a,m),this.c=o,this.m=S,this.q=I,this.notebook=r,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(o){return(0,D.$bf)(this.f,o)}get document(){if(!this.a){const o=this;this.a={get uri(){return o.d},get fileName(){return o.d.fsPath},get isUntitled(){return o.d.scheme===T.Schemas.untitled},get languageId(){return o.m},get version(){return o.h},get isClosed(){return o.b},get isDirty(){return o.q},save(){return o.r()},getText(t){return t?o.s(t):o.getText()},get eol(){return o.g===`
`?g.EndOfLine.LF:g.EndOfLine.CRLF},get lineCount(){return o.f.length},lineAt(t){return o.t(t)},offsetAt(t){return o.u(t)},positionAt(t){return o.v(t)},validateRange(t){return o.w(t)},validatePosition(t){return o.x(t)},getWordRangeAtPosition(t,i){return o.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(o){(0,w.ok)(!this.b),this.m=o}_acceptIsDirty(o){(0,w.ok)(!this.b),this.q=o}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(o){const t=this.w(o);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,a=t.start.line,m=t.end.line,S=[];S.push(this.f[a].substring(t.start.character));for(let I=a+1;I<m;I++)S.push(this.f[I]);return S.push(this.f[m].substring(0,t.end.character)),S.join(i)}t(o){let t;if(o instanceof g.$EJ?t=o.line:typeof o=="number"&&(t=o),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new y(t,this.f[t],t===this.f.length-1)}u(o){return o=this.x(o),this.l(),this.j.getPrefixSum(o.line-1)+o.character}v(o){o=Math.floor(o),o=Math.max(0,o),this.l();const t=this.j.getIndexOf(o),i=this.f[t.index].length;return new g.$EJ(t.index,Math.min(t.remainder,i))}w(o){if(!(o instanceof g.$FJ))throw new Error("Invalid argument");const t=this.x(o.start),i=this.x(o.end);return t===o.start&&i===o.end?o:new g.$FJ(t.line,t.character,i.line,i.character)}x(o){if(!(o instanceof g.$EJ))throw new Error("Invalid argument");if(this.f.length===0)return o.with(0,0);let{line:t,character:i}=o,a=!1;if(t<0)t=0,i=0,a=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,a=!0;else{const m=this.f[t].length;i<0?(i=0,a=!0):i>m&&(i=m,a=!0)}return a?new g.$EJ(t,i):o}y(o,t){const i=this.x(o);if(!t)t=E(this.m);else if((0,C.$xd)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const a=(0,P.$Mr)(i.character+1,(0,P.$Kr)(t),this.f[i.line],0);if(a)return new g.$FJ(i.line,a.startColumn-1,i.line,a.endColumn-1)}}e.$GL=c;class y{constructor(o,t,i){this.a=o,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new g.$FJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new g.$FJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$HL=y}),define(Ae[197],Fe([1,0,7,17,5]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=void 0;let M=class{constructor(g){this.a=new w.$1K(w.ColorThemeKind.Dark),this.b=new C.$8c}get activeColorTheme(){return this.a}$onColorThemeChange(g){let D;switch(g){case"light":D=w.ColorThemeKind.Light;break;case"hcDark":D=w.ColorThemeKind.HighContrast;break;case"hcLight":D=w.ColorThemeKind.HighContrastLight;break;default:D=w.ColorThemeKind.Dark}this.a=new w.$1K(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$oac=M,e.$oac=M=Ve([qe(0,T.$DL)],M)}),define(Ae[198],Fe([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MH=e.CellExecutionUpdateType=void 0;var T;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$MH=(0,w.$ph)("INotebookExecutionService")}),define(Ae[45],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nI=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(M){M.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var T;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class C{static fromExtHostTestItem(P,g,D=P.parent){if(P._isRoot)return new C([g]);const p=[P.id];for(let A=D;A&&A.id!==g;A=A.parent)p.push(A.id);return p.push(g),new C(p.reverse())}static isRoot(P){return!P.includes("\0")}static root(P){const g=P.indexOf("\0");return g===-1?P:P.slice(0,g)}static fromString(P){return new C(P.split("\0"))}static join(P,g){return new C([...P.path,g])}static joinToString(P,g){return P.toString()+"\0"+g}static parentId(P){const g=P.lastIndexOf("\0");return g===-1?void 0:P.slice(0,g)}static localId(P){const g=P.lastIndexOf("\0");return g===-1?P:P.slice(g+1)}static isChild(P,g){return g.startsWith(P)&&g[P.length]==="\0"}static compare(P,g){return P===g?0:C.isChild(P,g)?2:C.isChild(g,P)?3:1}constructor(P,g=P.length){if(this.path=P,this.d=g,P.length===0||g<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let P=1;P<=this.d;P++)yield new C(this.path,P)}*idsToRoot(){for(let P=this.d;P>0;P--)yield new C(this.path,P)}compare(P){if(typeof P=="string")return C.compare(this.toString(),P);for(let g=0;g<P.d&&g<this.d;g++)if(P.path[g]!==this.path[g])return 1;return P.d>this.d?2:P.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let P=1;P<this.d;P++)this.c+="\0",this.c+=this.path[P]}return this.c}}e.$nI=C}),define(Ae[57],Fe([1,0,2,44,45]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$tI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$sI=e.$rI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$qI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$pI=e.$oI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(f){f[f.Unset=0]="Unset",f[f.Queued=1]="Queued",f[f.Running=2]="Running",f[f.Passed=3]="Passed",f[f.Failed=4]="Failed",f[f.Skipped=5]="Skipped",f[f.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var P;(function(f){f[f.Run=1]="Run",f[f.Debug=2]="Debug",f[f.Coverage=3]="Coverage"})(P||(e.ExtTestRunProfileKind=P={}));var g;(function(f){f[f.Run=2]="Run",f[f.Debug=4]="Debug",f[f.Coverage=8]="Coverage",f[f.HasNonDefaultProfile=16]="HasNonDefaultProfile",f[f.HasConfigurable=32]="HasConfigurable",f[f.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$oI=[2,4,8,16,32,64];const D=f=>"runId"in f;e.$pI=D;var p;(function(f){f.serialize=v=>({range:v.range.toJSON(),uri:v.uri.toJSON()}),f.deserialize=v=>({range:T.$Or.lift(v.range),uri:w.URI.revive(v.uri)})})(p||(e.IRichLocation=p={}));var A;(function(f){f[f.Error=0]="Error",f[f.Output=1]="Output"})(A||(e.TestMessageType=A={}));var E;(function(f){f.serialize=v=>({message:v.message,type:0,expected:v.expected,actual:v.actual,location:v.location&&p.serialize(v.location)}),f.deserialize=v=>({message:v.message,type:0,expected:v.expected,actual:v.actual,location:v.location&&p.deserialize(v.location)})})(E||(e.ITestErrorMessage=E={}));const c=(f,v)=>`${v?"s":"e"}${f}`;e.$qI=c;var y;(function(f){f.serialize=v=>({message:v.message,type:1,offset:v.offset,length:v.length,location:v.location&&p.serialize(v.location)}),f.deserialize=v=>({message:v.message,type:1,offset:v.offset,length:v.length,location:v.location&&p.deserialize(v.location)})})(y||(e.ITestOutputMessage=y={}));var b;(function(f){f.serialize=v=>v.type===0?E.serialize(v):y.serialize(v),f.deserialize=v=>v.type===0?E.deserialize(v):y.deserialize(v)})(b||(e.ITestMessage=b={}));var o;(function(f){f.serializeWithoutMessages=v=>({state:v.state,duration:v.duration,messages:[]}),f.serialize=v=>({state:v.state,duration:v.duration,messages:v.messages.map(b.serialize)}),f.deserialize=v=>({state:v.state,duration:v.duration,messages:v.messages.map(b.deserialize)})})(o||(e.ITestTaskState=o={}));const t="\0",i=(f,v)=>f+t+v;e.$rI=i;const a=f=>{const v=f.indexOf(t);return{ctrlId:f.slice(0,v),tagId:f.slice(v+1)}};e.$sI=a;var m;(function(f){f.serialize=v=>({extId:v.extId,label:v.label,tags:v.tags,busy:v.busy,children:void 0,uri:v.uri?.toJSON(),range:v.range?.toJSON()||null,description:v.description,error:v.error,sortText:v.sortText}),f.deserialize=v=>({extId:v.extId,label:v.label,tags:v.tags,busy:v.busy,children:void 0,uri:v.uri?w.URI.revive(v.uri):void 0,range:v.range?T.$Or.lift(v.range):null,description:v.description,error:v.error,sortText:v.sortText})})(m||(e.ITestItem=m={}));var S;(function(f){f[f.NotExpandable=0]="NotExpandable",f[f.Expandable=1]="Expandable",f[f.BusyExpanding=2]="BusyExpanding",f[f.Expanded=3]="Expanded"})(S||(e.TestItemExpandState=S={}));var I;(function(f){f.serialize=v=>({expand:v.expand,item:m.serialize(v.item)}),f.deserialize=v=>({controllerId:C.$nI.root(v.item.extId),expand:v.expand,item:m.deserialize(v.item)})})(I||(e.InternalTestItem=I={}));var r;(function(f){f.serialize=v=>{let u;return v.item&&(u={},v.item.label!==void 0&&(u.label=v.item.label),v.item.tags!==void 0&&(u.tags=v.item.tags),v.item.busy!==void 0&&(u.busy=v.item.busy),v.item.uri!==void 0&&(u.uri=v.item.uri?.toJSON()),v.item.range!==void 0&&(u.range=v.item.range?.toJSON()),v.item.description!==void 0&&(u.description=v.item.description),v.item.error!==void 0&&(u.error=v.item.error),v.item.sortText!==void 0&&(u.sortText=v.item.sortText)),{extId:v.extId,expand:v.expand,item:u}},f.deserialize=v=>{let u;return v.item&&(u={},v.item.label!==void 0&&(u.label=v.item.label),v.item.tags!==void 0&&(u.tags=v.item.tags),v.item.busy!==void 0&&(u.busy=v.item.busy),v.item.range!==void 0&&(u.range=v.item.range?T.$Or.lift(v.item.range):null),v.item.description!==void 0&&(u.description=v.item.description),v.item.error!==void 0&&(u.error=v.item.error),v.item.sortText!==void 0&&(u.sortText=v.item.sortText)),{extId:v.extId,expand:v.expand,item:u}}})(r||(e.ITestItemUpdate=r={}));const h=(f,v)=>{v.expand!==void 0&&(f.expand=v.expand),v.item!==void 0&&(f.item=f.item?Object.assign(f.item,v.item):v.item)};e.$tI=h;var n;(function(f){f.serializeWithoutMessages=v=>({...I.serialize(v),ownComputedState:v.ownComputedState,computedState:v.computedState,tasks:v.tasks.map(o.serializeWithoutMessages)}),f.serialize=v=>({...I.serialize(v),ownComputedState:v.ownComputedState,computedState:v.computedState,tasks:v.tasks.map(o.serialize)}),f.deserialize=v=>({...I.deserialize(v),ownComputedState:v.ownComputedState,computedState:v.computedState,tasks:v.tasks.map(o.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var s;(function(f){f[f.Function=0]="Function",f[f.Statement=1]="Statement"})(s||(e.DetailType=s={}));var $;(function(f){f[f.Add=0]="Add",f[f.Update=1]="Update",f[f.DocumentSynced=2]="DocumentSynced",f[f.Remove=3]="Remove",f[f.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",f[f.Retire=5]="Retire",f[f.AddTag=6]="AddTag",f[f.RemoveTag=7]="RemoveTag"})($||(e.TestDiffOpType=$={}));var k;(function(f){f.deserialize=v=>v.op===0?{op:v.op,item:I.deserialize(v.item)}:v.op===1?{op:v.op,item:r.deserialize(v.item)}:v.op===2?{op:v.op,uri:w.URI.revive(v.uri),docv:v.docv}:v,f.serialize=v=>v.op===0?{op:v.op,item:I.serialize(v.item)}:v.op===1?{op:v.op,item:r.serialize(v.item)}:v})(k||(e.TestsDiffOp=k={}));class l{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(v){const u=this.o();for(const d of v)switch(d.op){case 0:this.j(I.deserialize(d.item),u);break;case 1:this.k(r.deserialize(d.item),u);break;case 3:this.l(d.itemId,u);break;case 5:this.m(d.itemId);break;case 4:this.updatePendingRoots(d.amount);break;case 6:this.c.set(d.tag.id,d.tag);break;case 7:this.c.delete(d.id);break}u.complete?.()}j(v,u){const d=C.$nI.parentId(v.item.extId)?.toString();let R;if(!d)R=this.p(v),this.f.add(R),this.d.set(v.item.extId,R);else if(this.d.has(d)){const W=this.d.get(d);W.children.add(v.item.extId),R=this.p(v,W),this.d.set(v.item.extId,R)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(v)}`);return}return u.add?.(R),v.expand===2&&this.g++,R}k(v,u){const d=this.d.get(v.extId);if(d)return v.expand!==void 0&&(d.expand===2&&this.g--,v.expand===2&&this.g++),(0,e.$tI)(d,v),u.update?.(d),d}l(v,u){const d=this.d.get(v);if(!d)return;const R=C.$nI.parentId(d.item.extId)?.toString();R?this.d.get(R).children.delete(d.item.extId):this.f.delete(d);const W=[[v]];for(;W.length;)for(const B of W.pop()){const q=this.d.get(B);q&&(W.push(q.children),this.d.delete(B),u.remove?.(q,q!==d),q.expand===2&&this.g--)}}m(v){}updatePendingRoots(v){this.h+=v}o(){return{}}}e.$uI=l}),define(Ae[75],Fe([1,0,16,5,6,50,57,45]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.TestItemEventOp=void 0;var D;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const p=(a,m)=>a===m,E=Object.entries({range:(a,m)=>a===m?!0:!a||!m?!1:a.equalsRange(m),busy:p,label:p,description:p,error:p,sortText:p,tags:(a,m)=>!(a.length!==m.length||a.some(S=>!m.includes(S)))}),c=(a,m)=>{let S;for(const[I,r]of E)r(a[I],m[I])||(S?S[I]=m[I]:S={[I]:m[I]});return S};class y extends C.$lb{get root(){return this.m.root}constructor(m){super(),this.m=m,this.f=this.B(new w.$Gg(()=>this.flushDiff(),200)),this.g=this.B(new T.$8c),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(m){this.h=m;for(const S of this.tree.values())this.G(S)}get resolveHandler(){return this.h}collectDiff(){const m=this.k;return this.k=[],m}pushDiff(m){switch(m.op){case 2:{for(const S of this.k)if(S.op===2&&S.uri===m.uri){S.docv=m.docv;return}break}case 1:{const S=this.k[this.k.length-1];if(S){if(S.op===1&&S.item.extId===m.item.extId){(0,P.$tI)(S.item,m.item);return}if(S.op===0&&S.item.item.extId===m.item.extId){(0,P.$tI)(S.item,m.item);return}}break}}this.k.push(m),this.f.isScheduled()||this.f.schedule()}expand(m,S){const I=this.tree.get(m);if(I){if((I.expandLevels===void 0||S>I.expandLevels)&&(I.expandLevels=S),I.expand===1){const r=this.I(I);return r.isOpen()?this.H(I,S-1):r.wait().then(()=>this.H(I,S-1))}else if(I.expand===3)return I.resolveBarrier?.isOpen()===!1?I.resolveBarrier.wait().then(()=>this.H(I,S-1)):this.H(I,S-1)}}dispose(){for(const m of this.tree.values())this.m.getApiFor(m.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(m,S){switch(S.op){case 3:this.L(g.$nI.joinToString(m.fullId,S.id));break;case 0:this.u(S.item,m);break;case 5:for(const I of S.ops)this.p(m,I);break;case 1:this.w(S.new,S.old,m.fullId.toString());break;case 2:this.G(m);break;case 4:this.pushDiff({op:1,item:{extId:m.fullId.toString(),item:S.update}});break;case 6:this.s(m.actual.uri);break;default:(0,M.$nc)(S)}}s(m){m&&this.pushDiff({op:2,uri:m,docv:this.m.getDocumentVersion(m)})}u(m,S){const I=g.$nI.fromExtHostTestItem(m,this.root.id,S?.actual),r=this.m.getApiFor(m);r.parent&&r.parent!==S?.actual&&this.m.getChildren(r.parent).delete(m.id);let h=this.tree.get(I.toString());if(!h){h={fullId:I,actual:m,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},m.tags.forEach(this.y,this),this.tree.set(h.fullId.toString(),h),this.C(m,S),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:h.expand,item:this.m.toITestItem(m)}}),this.F(m,h,S);return}if(h.actual===m){this.D(m,h,S);return}if(h.actual.uri?.toString()!==m.uri?.toString())return this.L(I.toString()),this.u(m,S);const n=this.m.getChildren(h.actual),s=h.actual,$=c(this.m.toITestItem(s),this.m.toITestItem(m));this.m.getApiFor(s).listener=void 0,h.actual=m,h.expand=0,$&&($.hasOwnProperty("tags")&&(this.w(m.tags,s.tags,I.toString()),delete $.tags),this.p(h,{op:4,update:$})),this.F(m,h,S);for(const[k,l]of n)this.m.getChildren(m).get(l.id)||this.L(g.$nI.joinToString(I,l.id));this.s(h.actual.uri)}w(m,S,I){const r=new Set(S.map(h=>h.id));for(const h of m)r.delete(h.id)||this.y(h);this.pushDiff({op:1,item:{extId:I,item:{tags:m.map(h=>(0,P.$rI)(this.m.controllerId,h.id))}}}),r.forEach(this.z,this)}y(m){const S=this.j.get(m.id);S?S.refCount++:(this.j.set(m.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,P.$rI)(this.m.controllerId,m.id)}}))}z(m){const S=this.j.get(m);S&&!--S.refCount&&(this.j.delete(m),this.pushDiff({op:7,id:(0,P.$rI)(this.m.controllerId,m)}))}C(m,S){this.m.getApiFor(m).parent=S&&S.actual!==this.root?S.actual:void 0}D(m,S,I){this.C(m,I);const r=this.m.getApiFor(m);r.parent=I?.actual,r.listener=h=>this.p(S,h),this.G(S)}F(m,S,I){this.D(m,S,I);for(const[r,h]of this.m.getChildren(m))this.u(h,S)}G(m){let S;this.h?m.resolveBarrier?S=m.resolveBarrier.isOpen()?3:2:S=m.actual.canResolveChildren?1:0:S=0,S!==m.expand&&(m.expand=S,this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:S}}),S===1&&m.expandLevels!==void 0&&this.I(m))}H(m,S){if(S<0)return;const I=[];for(const[r,h]of this.m.getChildren(m.actual)){const n=this.expand(g.$nI.joinToString(m.fullId,h.id),S);(0,w.$ig)(n)&&I.push(n)}if(I.length)return Promise.all(I).then(()=>{})}I(m){if(m.resolveBarrier)return m.resolveBarrier;if(!this.h){const h=new w.$ug;return h.open(),h}m.expand=2,this.J(m);const S=m.resolveBarrier=new w.$ug,I=h=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,h)};let r;try{r=this.h(m.actual===this.root?void 0:m.actual)}catch(h){I(h)}return(0,w.$ig)(r)?r.catch(I).then(()=>{S.open(),this.G(m)}):(S.open(),this.G(m)),m.resolveBarrier}J(m){this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:m.expand}})}L(m){const S=this.tree.get(m);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:m});const I=[S];for(;I.length;){const r=I.pop();if(r){this.m.getApiFor(r.actual).listener=void 0;for(const h of r.actual.tags)this.z(h.id);this.tree.delete(r.fullId.toString());for(const[h,n]of this.m.getChildren(r.actual))I.push(this.tree.get(g.$nI.joinToString(r.fullId,n.id)))}}}flushDiff(){const m=this.collectDiff();m.length&&this.g.fire(m)}}e.$tL=y;class b extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.$uL=b;class o extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$vL=o;class t extends Error{constructor(m,S,I){super(`TestItem with ID "${m}" is from controller "${S}" and cannot be added as a child of an item from controller "${I}".`)}}e.$wL=t;const i=(a,m,S)=>{let I=new Map;return{get size(){return I.size},forEach(r,h){for(const n of I.values())r.call(h,n,this)},[Symbol.iterator](){return I.entries()},replace(r){const h=new Map,n=new Set(I.keys()),s={op:5,ops:[]};for(const $ of r){if(!($ instanceof S))throw new o($.id);const k=m($).controllerId;if(k!==a.controllerId)throw new t($.id,k,a.controllerId);if(h.has($.id))throw new b($.id);h.set($.id,$),n.delete($.id),s.ops.push({op:0,item:$})}for(const $ of n.keys())s.ops.push({op:3,id:$});a.listener?.(s),I=h},add(r){if(!(r instanceof S))throw new o(r.id);I.set(r.id,r),a.listener?.({op:0,item:r})},delete(r){I.delete(r)&&a.listener?.({op:3,id:r})},get(r){return I.get(r)},toJSON(){return Array.from(I.values())}}};e.$xL=i}),define(Ae[101],Fe([1,0,75]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zL=e.$yL=void 0;const T=new WeakMap,C=(P,g)=>{const D={controllerId:g};return T.set(P,D),D};e.$yL=C;const M=P=>{const g=T.get(P);if(!g)throw new w.$vL(P?.id||"<unknown>");return g};e.$zL=M}),define(Ae[76],Fe([1,0,13,2]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnb=e.$knb=e.$jnb=e.$inb=e.$hnb=void 0,e.$hnb="vscode-cdn.net",e.$inb=`vscode-resource.${e.$hnb}`,e.$jnb=`'self' https://*.${e.$hnb}`;function C(g,D){return g.scheme===w.Schemas.http||g.scheme===w.Schemas.https?g:(D&&D.authority&&D.isRemote&&g.scheme===w.Schemas.file&&(g=T.URI.from({scheme:w.Schemas.vscodeRemote,authority:D.authority,path:g.path})),T.URI.from({scheme:w.Schemas.https,authority:`${g.scheme}+${M(g.authority)}.${e.$inb}`,path:g.path,fragment:g.fragment,query:g.query}))}e.$knb=C;function M(g){return g.replace(/./g,D=>{const p=D.charCodeAt(0);return p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57?D:"-"+p.toString(16).padStart(4,"0")})}function P(g){return g.replace(/-([0-9a-f]{4})/g,(D,p)=>String.fromCharCode(parseInt(p,16)))}e.$lnb=P}),define(Ae[199],Fe([1,0,5,6,76]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y_b=void 0;class M{constructor(g,D,p){this.d=g,this.e=D,this.f=p,this.a=0,this.b=new T.$kb,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const A=D.getVisibleTextEditors();for(const E of this.c.values())A.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(g=>g.inset.dispose()),this.b.dispose()}createWebviewEditorInset(g,D,p,A,E){let c;for(const m of this.e.getVisibleTextEditors(!0))if(m.value===g){c=m;break}if(!c)throw new Error("not a visible editor");const y=this,b=this.a++,o=new w.$8c,t=new w.$8c,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(m){return(0,C.$knb)(m,y.f)}get cspSource(){return C.$jnb}set options(m){this.b=m,y.d.$setOptions(b,m)}get options(){return this.b}set html(m){this.a=m,y.d.$setHtml(b,m)}get html(){return this.a}get onDidReceiveMessage(){return o.event}postMessage(m){return y.d.$postMessage(b,m)}},a=new class{constructor(){this.editor=g,this.line=D,this.height=p,this.webview=i,this.onDidDispose=t.event}dispose(){y.c.has(b)&&(y.c.delete(b),y.d.$disposeEditorInset(b),t.fire(),t.dispose(),o.dispose())}};return this.d.$createEditorInset(b,c.id,c.value.document.uri,D+1,p,A||{},E.identifier,E.extensionLocation),this.c.set(b,{editor:g,inset:a,onDidReceiveMessage:o}),a}$onDidDispose(g){const D=this.c.get(g);D&&D.inset.dispose()}$onDidReceiveMessage(g,D){this.c.get(g)?.onDidReceiveMessage.fire(D)}}e.$Y_b=M}),define(Ae[200],Fe([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.VariableKind=e.$pM=void 0,e.$pM=(0,w.$ph)("configurationResolverService");var T;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class C extends Error{constructor(P,g){super(g),this.variable=P}}e.$qM=C}),define(Ae[201],Fe([1,0,19,52,12,24,22,89,165,200,15]),function($e,e,w,T,C,M,P,g,D,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EM=void 0;class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,b,o,t){this.h=new Map,this.a=y,this.b=b,this.g=o,t&&(this.c=t.then(i=>this.i(i)))}i(y){if(P.$i){const b=Object.create(null);return Object.keys(y).forEach(o=>{b[o.toLowerCase()]=y[o]}),b}return y}resolveWithEnvironment(y,b,o){return this.l({env:this.i(y),userHome:void 0},b?b.uri:void 0,o)}async resolveAsync(y,b){const o={env:await this.c,userHome:await this.g};return this.l(o,y?y.uri:void 0,b)}async j(y,b,o,t){const i=M.$Hm(b);P.$i&&i.windows?Object.keys(i.windows).forEach(m=>i[m]=i.windows[m]):P.$j&&i.osx?Object.keys(i.osx).forEach(m=>i[m]=i.osx[m]):P.$k&&i.linux&&Object.keys(i.linux).forEach(m=>i[m]=i.linux[m]),delete i.windows,delete i.osx,delete i.linux;const a={env:await this.c,userHome:await this.g};return this.l(a,y?y.uri:void 0,i,o,t)}async resolveAnyAsync(y,b,o){return this.j(y,b,o)}async resolveAnyMap(y,b,o){const t=new Map;return{newConfig:await this.j(y,b,o,t),resolvedVariables:t}}resolveWithInteractionReplace(y,b,o,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,b,o,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,b){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,b)}async l(y,b,o,t,i){if(C.$je(o))return this.m(y,b,o,t,i);if(Array.isArray(o))return Promise.all(o.map(a=>this.l(y,b,a,t,i)));if(C.$le(o)){const a=Object.create(null),m=await Promise.all(Object.keys(o).map(async S=>[await this.m(y,b,S,t,i),await this.l(y,b,o[S],t,i)]));for(const[S,I]of m)a[S]=I;return a}return o}m(y,b,o,t,i){return(0,A.$Ed)(o,E.VARIABLE_REGEXP,async(a,m)=>{if(m.includes(E.VARIABLE_LHS))return a;let S=await this.o(y,a,m,b,t);return i?.set(m,S),S!==a&&C.$je(S)&&S.match(E.VARIABLE_REGEXP)&&(S=await this.m(y,b,S,t,i)),S})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,b,o,t,i){let a;const m=o.split(":");m.length>1&&(o=m[0],a=m[1]);const S=h=>{const n=this.a.getFilePath();if(n)return(0,g.$1z)(n);throw new p.$qM(h,(0,D.localize)(0,null,b))},I=h=>{const n=S(h);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,g.$1z)(s)}throw new p.$qM(h,(0,D.localize)(1,null,b,w.$ec(n)))},r=h=>{if(a){const n=this.a.getFolderUri(a);if(n)return n;throw new p.$qM(h,(0,D.localize)(2,null,b,a))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new p.$qM(h,(0,D.localize)(3,null,b)):new p.$qM(h,(0,D.localize)(4,null,b))};switch(o){case"env":if(a){if(y.env){const h=y.env[P.$i?a.toLowerCase():a];if(C.$je(h))return h}return""}throw new p.$qM(p.VariableKind.Env,(0,D.localize)(5,null,b));case"config":if(a){const h=this.a.getConfigurationValue(t,a);if(C.$se(h))throw new p.$qM(p.VariableKind.Config,(0,D.localize)(6,null,b,a));if(C.$le(h))throw new p.$qM(p.VariableKind.Config,(0,D.localize)(7,null,b,a));return h}throw new p.$qM(p.VariableKind.Config,(0,D.localize)(8,null,b));case"command":return this.p(p.VariableKind.Command,b,a,i,"command");case"input":return this.p(p.VariableKind.Input,b,a,i,"input");case"extensionInstallFolder":if(a){const h=await this.a.getExtension(a);if(!h)throw new p.$qM(p.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,b,a));return this.n(h.extensionLocation)}throw new p.$qM(p.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,b));default:switch(o){case"workspaceRoot":case"workspaceFolder":return(0,g.$1z)(this.n(r(p.VariableKind.WorkspaceFolder)));case"cwd":return t||a?(0,g.$1z)(this.n(r(p.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,g.$1z)(w.$ec(this.n(r(p.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new p.$qM(p.VariableKind.UserHome,(0,D.localize)(11,null,b))}case"lineNumber":{const h=this.a.getLineNumber();if(h)return h;throw new p.$qM(p.VariableKind.LineNumber,(0,D.localize)(12,null,b))}case"selectedText":{const h=this.a.getSelectedText();if(h)return h;throw new p.$qM(p.VariableKind.SelectedText,(0,D.localize)(13,null,b))}case"file":return S(p.VariableKind.File);case"fileWorkspaceFolder":return I(p.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||a?w.$cc(this.n(r(p.VariableKind.RelativeFile)),S(p.VariableKind.RelativeFile)):S(p.VariableKind.RelativeFile);case"relativeFileDirname":{const h=w.$dc(S(p.VariableKind.RelativeFileDirname));if(t||a){const n=w.$cc(this.n(r(p.VariableKind.RelativeFileDirname)),h);return n.length===0?".":n}return h}case"fileDirname":return w.$dc(S(p.VariableKind.FileDirname));case"fileExtname":return w.$fc(S(p.VariableKind.FileExtname));case"fileBasename":return w.$ec(S(p.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=w.$ec(S(p.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-w.$fc(h).length)}case"fileDirnameBasename":return w.$ec(w.$dc(S(p.VariableKind.FileDirnameBasename)));case"execPath":{const h=this.a.getExecPath();return h||b}case"execInstallFolder":{const h=this.a.getAppRoot();return h||b}case"pathSeparator":return w.sep;default:try{const h=a?`${o}:${a}`:o;return this.p(p.VariableKind.Unknown,b,h,i,void 0)}catch{return b}}}}p(y,b,o,t,i){if(o&&t){const a=i===void 0?t[o]:t[i+":"+o];if(typeof a=="string")return a;throw new p.$qM(y,(0,D.localize)(14,null,b))}return b}}e.$EM=E}),define(Ae[102],Fe([1,0,3,98]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RC=e.$QC=e.OpenEditorContext=e.GroupsOrder=e.$PC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$OC=void 0,e.$OC=(0,w.$ph)("editorGroupsService");var C;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var M;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var P;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(P||(e.GroupLocation=P={}));var g;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EVEN=1]="EVEN",b[b.TOGGLE=2]="TOGGLE"})(g||(e.GroupsArrangement=g={}));var D;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function p(b){const o=b;return(0,T.$EE)(o?.editor)&&(0,T.$EE)(o?.replacement)}e.$PC=p;var A;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var E;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function c(b){const o=b;return!!o&&typeof o.id=="number"&&Array.isArray(o.editors)}e.$QC=c;function y(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$RC=y}),define(Ae[202],Fe([1,0,3,102]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VC=e.$UC=e.$TC=e.$SC=void 0,e.$SC=(0,w.$ph)("editorService"),e.$TC=-1,e.$UC=-2;function C(M){const P=M;return typeof M=="number"||(0,T.$QC)(P)}e.$VC=C}),define(Ae[8],Fe([1,0,18,25,122,203,49,28,116,69,68,24,12,2,44,77,93,101,98,74,45,57,202,7]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t,i,a,m,S,I,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$CL=e.$BL=e.MarkdownString=e.$AL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Pe){function we(Q){const{selectionStartLineNumber:Le,selectionStartColumn:Ue,positionLineNumber:He,positionColumn:We}=Q,_e=new h.$EJ(Le-1,Ue-1),bt=new h.$EJ(He-1,We-1);return new h.$GJ(_e,bt)}Pe.to=we;function ve(Q){const{anchor:Le,active:Ue}=Q;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Pe.from=ve})(n||(e.Selection=n={}));var s;(function(Pe){function we(Q){if(!Q)return;const{start:Le,end:Ue}=Q;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Pe.from=we;function ve(Q){if(!Q)return;const{startLineNumber:Le,startColumn:Ue,endLineNumber:He,endColumn:We}=Q;return new h.$FJ(Le-1,Ue-1,He-1,We-1)}Pe.to=ve})(s||(e.Range=s={}));var $;(function(Pe){function we(ve){switch(ve){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}Pe.to=we})($||(e.TokenType=$={}));var k;(function(Pe){function we(Q){return new h.$EJ(Q.lineNumber-1,Q.column-1)}Pe.to=we;function ve(Q){return{lineNumber:Q.line+1,column:Q.character+1}}Pe.from=ve})(k||(e.Position=k={}));var l;(function(Pe){function we(Le,Ue,He){return(0,w.$mf)((0,w.$Jf)(Le).map(We=>ve(We,Ue,He)))}Pe.from=we;function ve(Le,Ue,He){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:He?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:Q(Le.scheme,Ue),pattern:nt.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:He?.isBuiltin}}function Q(Le,Ue){return Ue&&typeof Le=="string"?Ue.transformOutgoingScheme(Le):Le}})(l||(e.DocumentSelector=l={}));var f;(function(Pe){function we(Q){switch(Q){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}Pe.from=we;function ve(Q){switch(Q){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}Pe.to=ve})(f||(e.DiagnosticTag=f={}));var v;(function(Pe){function we(Q){let Le;return Q.code&&((0,c.$je)(Q.code)||(0,c.$ne)(Q.code)?Le=String(Q.code):Le={value:String(Q.code.value),target:Q.code.target}),{...s.from(Q.range),message:Q.message,source:Q.source,code:Le,severity:d.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(u.from),tags:Array.isArray(Q.tags)?(0,w.$mf)(Q.tags.map(f.from)):void 0}}Pe.from=we;function ve(Q){const Le=new h.$RJ(s.to(Q),Q.message,d.to(Q.severity));return Le.source=Q.source,Le.code=(0,c.$je)(Q.code)?Q.code:Q.code?.value,Le.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(u.to),Le.tags=Q.tags&&(0,w.$mf)(Q.tags.map(f.to)),Le}Pe.to=ve})(v||(e.Diagnostic=v={}));var u;(function(Pe){function we(Q){return{...s.from(Q.location.range),message:Q.message,resource:Q.location.uri}}Pe.from=we;function ve(Q){return new h.$QJ(new h.$PJ(Q.resource,s.to(Q)),Q.message)}Pe.to=ve})(u||(e.DiagnosticRelatedInformation=u={}));var d;(function(Pe){function we(Q){switch(Q){case h.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Pe.from=we;function ve(Q){switch(Q){case t.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}Pe.to=ve})(d||(e.DiagnosticSeverity=d={}));var R;(function(Pe){function we(Q){return typeof Q=="number"&&Q>=h.ViewColumn.One?Q-1:Q===h.ViewColumn.Beside?r.$UC:r.$TC}Pe.from=we;function ve(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=ve})(R||(e.ViewColumn=R={}));function W(Pe){return typeof Pe.range<"u"}function B(Pe){return Pe.length===0?!0:!!W(Pe[0])}e.$AL=B;var q;(function(Pe){function we(We){return We.map(Pe.from)}Pe.fromMany=we;function ve(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function Q(We){let _e;if(ve(We)){const{language:pt,value:mt}=We;_e={value:"```"+pt+`
`+mt+"\n```\n"}}else h.$5J.isMarkdownString(We)?_e={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?_e={value:We}:_e={value:""};const bt=Object.create(null);_e.uris=bt;const kt=pt=>{try{let mt=y.URI.parse(pt,!0);mt=mt.with({query:Le(mt.query,bt)}),bt[pt]=mt}catch{}return""},St=new D.marked.Renderer;return St.link=kt,St.image=pt=>typeof pt=="string"?kt(P.$Rj(pt).href):"",(0,D.marked)(_e.value,{renderer:St}),_e}Pe.from=Q;function Le(We,_e){if(!We)return We;let bt;try{bt=(0,p.$Xg)(We)}catch{}if(!bt)return We;let kt=!1;return bt=(0,E.$Jm)(bt,St=>{if(y.URI.isUri(St)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return _e[pt]=St,kt=!0,pt}else return}),kt?JSON.stringify(bt):We}function Ue(We){const _e=new h.$5J(We.value,We.supportThemeIcons);return _e.isTrusted=We.isTrusted,_e.supportHtml=We.supportHtml,_e.baseUri=We.baseUri?y.URI.from(We.baseUri):void 0,_e}Pe.to=Ue;function He(We){if(We)return typeof We=="string"?We:Pe.from(We)}Pe.fromStrict=He})(q||(e.MarkdownString=q={}));function U(Pe){return B(Pe)?Pe.map(we=>({range:s.from(we.range),hoverMessage:Array.isArray(we.hoverMessage)?q.fromMany(we.hoverMessage):we.hoverMessage?q.from(we.hoverMessage):void 0,renderOptions:we.renderOptions})):Pe.map(we=>({range:s.from(we)}))}e.$BL=U;function N(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?y.URI.file(Pe):Pe}e.$CL=N;var O;(function(Pe){function we(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?N(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Pe.from=we})(O||(e.ThemableDecorationAttachmentRenderOptions=O={}));var ce;(function(Pe){function we(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?N(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?O.from(ve.before):void 0,after:ve.after?O.from(ve.after):void 0}}Pe.from=we})(ce||(e.ThemableDecorationRenderOptions=ce={}));var X;(function(Pe){function we(ve){if(typeof ve>"u")return ve;switch(ve){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=we})(X||(e.DecorationRangeBehavior=X={}));var be;(function(Pe){function we(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?X.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?ce.from(ve.light):void 0,dark:ve.dark?ce.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?N(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?O.from(ve.before):void 0,after:ve.after?O.from(ve.after):void 0}}Pe.from=we})(be||(e.DecorationRenderOptions=be={}));var Ee;(function(Pe){function we(Q){return{text:Q.newText,eol:Q.newEol&&Ge.from(Q.newEol),range:s.from(Q.range)}}Pe.from=we;function ve(Q){const Le=new h.$KJ(s.to(Q.range),Q.text);return Le.newEol=typeof Q.eol>"u"?void 0:Ge.to(Q.eol),Le}Pe.to=ve})(Ee||(e.TextEdit=Ee={}));var Re;(function(Pe){function we(Q,Le){const Ue={edits:[]};if(Q instanceof h.$NJ){const He=new g.$oi;for(const We of Q._allEntries())We._type===1&&y.URI.isUri(We.to)&&We.from===void 0&&He.add(We.to);for(const We of Q._allEntries())if(We._type===1){let _e;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?_e={type:"base64",value:(0,T.$4b)(T.$Jb.wrap(We.options.contents))}:_e={type:"dataTransferItem",id:We.options.contents._itemId}),Ue.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:_e},metadata:We.metadata})}else We._type===2?Ue.edits.push({resource:We.uri,textEdit:Ee.from(We.edit),versionId:He.has(We.uri)?void 0:Le?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Ue.edits.push({resource:We.uri,textEdit:{range:s.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:He.has(We.uri)?void 0:Le?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Ue.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Ue.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Le?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(et.from)}})}return Ue}Pe.from=we;function ve(Q){const Le=new h.$NJ,Ue=new g.$ni;for(const He of Q.edits)if(He.textEdit){const We=He,_e=y.URI.revive(We.resource),bt=s.to(We.textEdit.range),kt=We.textEdit.text,St=We.textEdit.insertAsSnippet;let pt;St?pt=h.$MJ.replace(bt,new h.$OJ(kt)):pt=h.$KJ.replace(bt,kt);const mt=Ue.get(_e);mt?mt.push(pt):Ue.set(_e,[pt])}else Le.renameFile(y.URI.revive(He.oldResource),y.URI.revive(He.newResource),He.options);for(const[He,We]of Ue)Le.set(He,We);return Le}Pe.to=ve})(Re||(e.WorkspaceEdit=Re={}));var Z;(function(Pe){const we=Object.create(null);we[h.SymbolKind.File]=0,we[h.SymbolKind.Module]=1,we[h.SymbolKind.Namespace]=2,we[h.SymbolKind.Package]=3,we[h.SymbolKind.Class]=4,we[h.SymbolKind.Method]=5,we[h.SymbolKind.Property]=6,we[h.SymbolKind.Field]=7,we[h.SymbolKind.Constructor]=8,we[h.SymbolKind.Enum]=9,we[h.SymbolKind.Interface]=10,we[h.SymbolKind.Function]=11,we[h.SymbolKind.Variable]=12,we[h.SymbolKind.Constant]=13,we[h.SymbolKind.String]=14,we[h.SymbolKind.Number]=15,we[h.SymbolKind.Boolean]=16,we[h.SymbolKind.Array]=17,we[h.SymbolKind.Object]=18,we[h.SymbolKind.Key]=19,we[h.SymbolKind.Null]=20,we[h.SymbolKind.EnumMember]=21,we[h.SymbolKind.Struct]=22,we[h.SymbolKind.Event]=23,we[h.SymbolKind.Operator]=24,we[h.SymbolKind.TypeParameter]=25;function ve(Le){return typeof we[Le]=="number"?we[Le]:6}Pe.from=ve;function Q(Le){for(const Ue in we)if(we[Ue]===Le)return Number(Ue);return h.SymbolKind.Property}Pe.to=Q})(Z||(e.SymbolKind=Z={}));var he;(function(Pe){function we(Q){switch(Q){case h.SymbolTag.Deprecated:return 1}}Pe.from=we;function ve(Q){switch(Q){case 1:return h.SymbolTag.Deprecated}}Pe.to=ve})(he||(e.SymbolTag=he={}));var Ce;(function(Pe){function we(Q){return{name:Q.name,kind:Z.from(Q.kind),tags:Q.tags&&Q.tags.map(he.from),containerName:Q.containerName,location:_.from(Q.location)}}Pe.from=we;function ve(Q){const Le=new h.$UJ(Q.name,Z.to(Q.kind),Q.containerName,_.to(Q.location));return Le.tags=Q.tags&&Q.tags.map(he.to),Le}Pe.to=ve})(Ce||(e.WorkspaceSymbol=Ce={}));var H;(function(Pe){function we(Q){const Le={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:s.from(Q.range),selectionRange:s.from(Q.selectionRange),kind:Z.from(Q.kind),tags:Q.tags?.map(he.from)??[]};return Q.children&&(Le.children=Q.children.map(we)),Le}Pe.from=we;function ve(Q){const Le=new h.$VJ(Q.name,Q.detail,Z.to(Q.kind),s.to(Q.range),s.to(Q.selectionRange));return(0,w.$qf)(Q.tags)&&(Le.tags=Q.tags.map(he.to)),Q.children&&(Le.children=Q.children.map(ve)),Le}Pe.to=ve})(H||(e.DocumentSymbol=H={}));var ne;(function(Pe){function we(Q){const Le=new h.$1J(Z.to(Q.kind),Q.name,Q.detail||"",y.URI.revive(Q.uri),s.to(Q.range),s.to(Q.selectionRange));return Le._sessionId=Q._sessionId,Le._itemId=Q._itemId,Le}Pe.to=we;function ve(Q,Le,Ue){if(Le=Le??Q._sessionId,Ue=Ue??Q._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,name:Q.name,detail:Q.detail,kind:Z.from(Q.kind),uri:Q.uri,range:s.from(Q.range),selectionRange:s.from(Q.selectionRange),tags:Q.tags?.map(he.from)}}Pe.from=ve})(ne||(e.CallHierarchyItem=ne={}));var re;(function(Pe){function we(ve){return new h.$2J(ne.to(ve.from),ve.fromRanges.map(Q=>s.to(Q)))}Pe.to=we})(re||(e.CallHierarchyIncomingCall=re={}));var L;(function(Pe){function we(ve){return new h.$3J(ne.to(ve.to),ve.fromRanges.map(Q=>s.to(Q)))}Pe.to=we})(L||(e.CallHierarchyOutgoingCall=L={}));var _;(function(Pe){function we(Q){return{range:Q.range&&s.from(Q.range),uri:Q.uri}}Pe.from=we;function ve(Q){return new h.$PJ(y.URI.revive(Q.uri),s.to(Q.range))}Pe.to=ve})(_||(e.location=_={}));var pe;(function(Pe){function we(Q){const Le=Q,Ue=Q;return{originSelectionRange:Le.originSelectionRange?s.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ue.uri,range:s.from(Le.targetRange?Le.targetRange:Ue.range),targetSelectionRange:Le.targetSelectionRange?s.from(Le.targetSelectionRange):void 0}}Pe.from=we;function ve(Q){return{targetUri:y.URI.revive(Q.uri),targetRange:s.to(Q.range),targetSelectionRange:Q.targetSelectionRange?s.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?s.to(Q.originSelectionRange):void 0}}Pe.to=ve})(pe||(e.DefinitionLink=pe={}));var Ie;(function(Pe){function we(Q){return{range:s.from(Q.range),contents:q.fromMany(Q.contents)}}Pe.from=we;function ve(Q){return new h.$SJ(Q.contents.map(q.to),s.to(Q.range))}Pe.to=ve})(Ie||(e.Hover=Ie={}));var De;(function(Pe){function we(Q){return{range:s.from(Q.range),expression:Q.expression}}Pe.from=we;function ve(Q){return new h.$MK(s.to(Q.range),Q.expression)}Pe.to=ve})(De||(e.EvaluatableExpression=De={}));var ye;(function(Pe){function we(Q){if(Q instanceof h.$NK)return{type:"text",range:s.from(Q.range),text:Q.text};if(Q instanceof h.$OK)return{type:"variable",range:s.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof h.$PK)return{type:"expression",range:s.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=we;function ve(Q){switch(Q.type){case"text":return{range:s.to(Q.range),text:Q.text};case"variable":return{range:s.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:s.to(Q.range),expression:Q.expression}}}Pe.to=ve})(ye||(e.InlineValue=ye={}));var Se;(function(Pe){function we(Q){return{frameId:Q.frameId,stoppedLocation:s.from(Q.stoppedLocation)}}Pe.from=we;function ve(Q){return new h.$QK(Q.frameId,s.to(Q.stoppedLocation))}Pe.to=ve})(Se||(e.InlineValueContext=Se={}));var oe;(function(Pe){function we(Q){return{range:s.from(Q.range),kind:Q.kind}}Pe.from=we;function ve(Q){return new h.$TJ(s.to(Q.range),Q.kind)}Pe.to=ve})(oe||(e.DocumentHighlight=oe={}));var de;(function(Pe){function we(ve){switch(ve){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}Pe.to=we})(de||(e.CompletionTriggerKind=de={}));var ee;(function(Pe){function we(ve){return{triggerKind:de.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Pe.to=we})(ee||(e.CompletionContext=ee={}));var ie;(function(Pe){function we(Q){switch(Q){case h.CompletionItemTag.Deprecated:return 1}}Pe.from=we;function ve(Q){switch(Q){case 1:return h.CompletionItemTag.Deprecated}}Pe.to=ve})(ie||(e.CompletionItemTag=ie={}));var le;(function(Pe){const we=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function ve(Ue){return we.get(Ue)??9}Pe.from=ve;const Q=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Le(Ue){return Q.get(Ue)??h.CompletionItemKind.Property}Pe.to=Le})(le||(e.CompletionItemKind=le={}));var F;(function(Pe){function we(ve,Q){const Le=new h.$$J(ve.label);return Le.insertText=ve.insertText,Le.kind=le.to(ve.kind),Le.tags=ve.tags?.map(ie.to),Le.detail=ve.detail,Le.documentation=P.$Mj(ve.documentation)?q.to(ve.documentation):ve.documentation,Le.sortText=ve.sortText,Le.filterText=ve.filterText,Le.preselect=ve.preselect,Le.commitCharacters=ve.commitCharacters,b.$Or.isIRange(ve.range)?Le.range=s.to(ve.range):typeof ve.range=="object"&&(Le.range={inserting:s.to(ve.range.insert),replacing:s.to(ve.range.replace)}),Le.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&1),typeof ve.insertTextRules<"u"&&ve.insertTextRules&4?Le.insertText=new h.$OJ(ve.insertText):(Le.insertText=ve.insertText,Le.textEdit=Le.range instanceof h.$FJ?new h.$KJ(Le.range,Le.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Le.additionalTextEdits=ve.additionalTextEdits.map(Ue=>Ee.to(Ue))),Le.command=Q&&ve.command?Q.fromInternal(ve.command):void 0,Le}Pe.to=we})(F||(e.CompletionItem=F={}));var V;(function(Pe){function we(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:q.fromStrict(Q.documentation)}}Pe.from=we;function ve(Q){return{label:Q.label,documentation:P.$Mj(Q.documentation)?q.to(Q.documentation):Q.documentation}}Pe.to=ve})(V||(e.ParameterInformation=V={}));var J;(function(Pe){function we(Q){return{label:Q.label,documentation:q.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(V.from):[],activeParameter:Q.activeParameter}}Pe.from=we;function ve(Q){return{label:Q.label,documentation:P.$Mj(Q.documentation)?q.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(V.to):[],activeParameter:Q.activeParameter}}Pe.to=ve})(J||(e.SignatureInformation=J={}));var K;(function(Pe){function we(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(J.from):[]}}Pe.from=we;function ve(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(J.to):[]}}Pe.to=ve})(K||(e.SignatureHelp=K={}));var ae;(function(Pe){function we(ve,Q){const Le=new h.$0J(k.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(G.to.bind(void 0,ve)),Q.kind&&ue.to(Q.kind));return Le.textEdits=Q.textEdits&&Q.textEdits.map(Ee.to),Le.tooltip=P.$Mj(Q.tooltip)?q.to(Q.tooltip):Q.tooltip,Le.paddingLeft=Q.paddingLeft,Le.paddingRight=Q.paddingRight,Le}Pe.to=we})(ae||(e.InlayHint=ae={}));var G;(function(Pe){function we(ve,Q){const Le=new h.$9J(Q.label);return Le.tooltip=P.$Mj(Q.tooltip)?q.to(Q.tooltip):Q.tooltip,o.Command.is(Q.command)&&(Le.command=ve.fromInternal(Q.command)),Q.location&&(Le.location=_.to(Q.location)),Le}Pe.to=we})(G||(e.InlayHintLabelPart=G={}));var ue;(function(Pe){function we(Q){return Q}Pe.from=we;function ve(Q){return Q}Pe.to=ve})(ue||(e.InlayHintKind=ue={}));var me;(function(Pe){function we(Q){return{range:s.from(Q.range),url:Q.target,tooltip:Q.tooltip}}Pe.from=we;function ve(Q){let Le;if(Q.url)try{Le=typeof Q.url=="string"?y.URI.parse(Q.url,!0):y.URI.revive(Q.url)}catch{}return new h.$dK(s.to(Q.range),Le)}Pe.to=ve})(me||(e.DocumentLink=me={}));var Ne;(function(Pe){function we(Q){const Le=new h.$gK(Q.label);return Q.textEdit&&(Le.textEdit=Ee.to(Q.textEdit)),Q.additionalTextEdits&&(Le.additionalTextEdits=Q.additionalTextEdits.map(Ue=>Ee.to(Ue))),Le}Pe.to=we;function ve(Q){return{label:Q.label,textEdit:Q.textEdit?Ee.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Le=>Ee.from(Le)):void 0}}Pe.from=ve})(Ne||(e.ColorPresentation=Ne={}));var Be;(function(Pe){function we(Q){return new h.$eK(Q[0],Q[1],Q[2],Q[3])}Pe.to=we;function ve(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}Pe.from=ve})(Be||(e.Color=Be={}));var Ye;(function(Pe){function we(Q){return{range:s.from(Q.range)}}Pe.from=we;function ve(Q){return new h.$ZJ(s.to(Q.range))}Pe.to=ve})(Ye||(e.SelectionRange=Ye={}));var Ke;(function(Pe){function we(ve){switch(ve){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}Pe.to=we})(Ke||(e.TextDocumentSaveReason=Ke={}));var Xe;(function(Pe){function we(Q){switch(Q){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=we;function ve(Q){switch(Q){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}Pe.to=ve})(Xe||(e.TextEditorLineNumbersStyle=Xe={}));var Ge;(function(Pe){function we(Q){if(Q===h.EndOfLine.CRLF)return 1;if(Q===h.EndOfLine.LF)return 0}Pe.from=we;function ve(Q){if(Q===1)return h.EndOfLine.CRLF;if(Q===0)return h.EndOfLine.LF}Pe.to=ve})(Ge||(e.EndOfLine=Ge={}));var ct;(function(Pe){function we(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=we})(ct||(e.ProgressLocation=ct={}));var xe;(function(Pe){function we(Q){const Le={start:Q.start+1,end:Q.end+1};return Q.kind&&(Le.kind=tt.from(Q.kind)),Le}Pe.from=we;function ve(Q){const Le={start:Q.start-1,end:Q.end-1};return Q.kind&&(Le.kind=tt.to(Q.kind)),Le}Pe.to=ve})(xe||(e.FoldingRange=xe={}));var tt;(function(Pe){function we(Q){if(Q)switch(Q){case h.FoldingRangeKind.Comment:return o.$us.Comment;case h.FoldingRangeKind.Imports:return o.$us.Imports;case h.FoldingRangeKind.Region:return o.$us.Region}}Pe.from=we;function ve(Q){if(Q)switch(Q.value){case o.$us.Comment.value:return h.FoldingRangeKind.Comment;case o.$us.Imports.value:return h.FoldingRangeKind.Imports;case o.$us.Region.value:return h.FoldingRangeKind.Region}}Pe.to=ve})(tt||(e.FoldingRangeKind=tt={}));var Oe;(function(Pe){function we(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?s.from(ve.selection):void 0,override:typeof ve.override=="boolean"?a.$rE.id:void 0}}Pe.from=we})(Oe||(e.TextEditorOpenOptions=Oe={}));var nt;(function(Pe){function we(Ue){return Ue instanceof h.$AK?Ue.toJSON():typeof Ue=="string"?Ue:ve(Ue)||Q(Ue)?new h.$AK(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Pe.from=we;function ve(Ue){const He=Ue;return He?y.URI.isUri(He.baseUri)&&typeof He.pattern=="string":!1}function Q(Ue){const He=Ue;return He?typeof He.base=="string"&&typeof He.pattern=="string":!1}function Le(Ue){return typeof Ue=="string"?Ue:new h.$AK(y.URI.revive(Ue.baseUri),Ue.pattern)}Pe.to=Le})(nt||(e.GlobPattern=nt={}));var x;(function(Pe){function we(ve){if(ve){if(Array.isArray(ve))return ve.map(we);if(typeof ve=="string")return ve;{const Q=ve;return{language:Q.language,scheme:Q.scheme,pattern:nt.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}Pe.from=we})(x||(e.LanguageSelector=x={}));var Y;(function(Pe){function we(Q){return{start:Q.start,end:Q.end}}Pe.from=we;function ve(Q){return new h.$2K(Q.start,Q.end)}Pe.to=ve})(Y||(e.NotebookRange=Y={}));var ge;(function(Pe){function we(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}Pe.to=we;function ve(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}Pe.from=ve})(ge||(e.NotebookCellExecutionSummary=ge={}));var je;(function(Pe){function we(ve){if(ve===m.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;if(ve===m.NotebookCellExecutionState.Pending)return;if(ve===m.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Pe.to=we})(je||(e.NotebookCellExecutionState=je={}));var Me;(function(Pe){function we(Q){switch(Q){case h.NotebookCellKind.Markup:return m.CellKind.Markup;case h.NotebookCellKind.Code:default:return m.CellKind.Code}}Pe.from=we;function ve(Q){switch(Q){case m.CellKind.Markup:return h.NotebookCellKind.Markup;case m.CellKind.Code:default:return h.NotebookCellKind.Code}}Pe.to=ve})(Me||(e.NotebookCellKind=Me={}));var Ze;(function(Pe){function we(Q){const Le={metadata:Q.metadata??Object.create(null),cells:[]};for(const Ue of Q.cells)h.$3K.validate(Ue),Le.cells.push(et.from(Ue));return Le}Pe.from=we;function ve(Q){const Le=new h.$4K(Q.cells.map(et.to));return(0,c.$we)(Q.metadata)||(Le.metadata=Q.metadata),Le}Pe.to=ve})(Ze||(e.NotebookData=Ze={}));var et;(function(Pe){function we(Q){return{cellKind:Me.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:ge.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(wt.from):[]}}Pe.from=we;function ve(Q){return new h.$3K(Me.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(wt.to):void 0,Q.metadata,Q.internalMetadata?ge.to(Q.internalMetadata):void 0)}Pe.to=ve})(et||(e.NotebookCellData=et={}));var gt;(function(Pe){function we(Q){return{mime:Q.mime,valueBytes:T.$Jb.wrap(Q.data)}}Pe.from=we;function ve(Q){return new h.$5K(Q.valueBytes.buffer,Q.mime)}Pe.to=ve})(gt||(e.NotebookCellOutputItem=gt={}));var wt;(function(Pe){function we(Q){return{outputId:Q.id,items:Q.items.map(gt.from),metadata:Q.metadata}}Pe.from=we;function ve(Q){const Le=Q.items.map(gt.to);return new h.$6K(Le,Q.outputId,Q.metadata)}Pe.to=ve})(wt||(e.NotebookCellOutput=wt={}));var Nt;(function(Pe){function we(Le){return Q(Le)?{include:(0,c.$Be)(nt.from(Le.include)),exclude:(0,c.$Be)(nt.from(Le.exclude))}:(0,c.$Be)(nt.from(Le))}Pe.from=we;function ve(Le){return Q(Le)?{include:nt.to(Le.include),exclude:nt.to(Le.exclude)}:nt.to(Le)}Pe.to=ve;function Q(Le){const Ue=Le;return Ue?!(0,c.$se)(Ue.include)&&!(0,c.$se)(Ue.exclude):!1}})(Nt||(e.NotebookExclusiveDocumentPattern=Nt={}));var Jt;(function(Pe){function we(ve,Q,Le){const Ue=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Ue,Le),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Pe.from=we})(Jt||(e.NotebookStatusBarItem=Jt={}));var Wt;(function(Pe){function we(ve,Q,Le){const Ue=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:Q.toInternal(Ue,Le),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Pe.from=we})(Wt||(e.NotebookKernelSourceAction=Wt={}));var yt;(function(Pe){function we(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Pe.from=we})(yt||(e.NotebookDocumentContentOptions=yt={}));var At;(function(Pe){function we(Q){return{uri:Q.uri,provides:Q.provides}}Pe.from=we;function ve(Q){return new h.$8K(y.URI.revive(Q.uri),Q.provides)}Pe.to=ve})(At||(e.NotebookRendererScript=At={}));var Ft;(function(Pe){function we(Q){return{message:q.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,location:Q.location&&{range:s.from(Q.location.range),uri:Q.location.uri}}}Pe.from=we;function ve(Q){const Le=new h.$cL(typeof Q.message=="string"?Q.message:q.to(Q.message));return Le.actualOutput=Q.actual,Le.expectedOutput=Q.expected,Le.location=Q.location?_.to(Q.location):void 0,Le}Pe.to=ve})(Ft||(e.TestMessage=Ft={}));var zt;(function(Pe){Pe.namespace=I.$rI,Pe.denamespace=I.$sI})(zt||(e.TestTag=zt={}));var Ut;(function(Pe){function we(Q){const Le=(0,i.$zL)(Q).controllerId;return{extId:S.$nI.fromExtHostTestItem(Q,Le).toString(),label:Q.label,uri:y.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(Ue=>zt.namespace(Le,Ue.id)),range:b.$Or.lift(s.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&q.fromStrict(Q.error)||null}}Pe.from=we;function ve(Q){return{parent:void 0,error:void 0,id:S.$nI.fromString(Q.extId).localId,label:Q.label,uri:y.URI.revive(Q.uri),tags:(Q.tags||[]).map(Le=>{const{tagId:Ue}=zt.denamespace(Le);return new h.$dL(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:s.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}Pe.toPlain=ve})(Ut||(e.TestItem=Ut={})),function(Pe){function we(Q){return{id:Q.id}}Pe.from=we;function ve(Q){return new h.$dL(Q.id)}Pe.to=ve}(zt||(e.TestTag=zt={}));var Lt;(function(Pe){const we=(Q,Le)=>{const Ue=[];for(const[We,_e]of Le)S.$nI.compare(_e.item.extId,We)===2&&(Le.delete(We),Ue.push(_e));const He={...Ut.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(_e=>_e.type===0).map(Ft.to)})),children:Ue.map(We=>we(We,Le))};for(const We of He.children)We.parent=He;return He};function ve(Q){const Le=[],Ue=new Map;for(const He of Q.items){Ue.set(He.item.extId,He);const We=S.$nI.root(He.item.extId);Q.request.targets.some(_e=>_e.controllerId===We&&_e.testIds.includes(He.item.extId))&&Le.push(He)}return{completedAt:Q.completedAt,results:Le.map(He=>we(He,Ue))}}Pe.to=ve})(Lt||(e.TestResults=Lt={}));var st;(function(Pe){function we(Ue){return{covered:Ue.covered,total:Ue.covered}}function ve(Ue){return"line"in Ue?k.from(Ue):s.from(Ue)}function Q(Ue){return"branches"in Ue?{count:Ue.executionCount,location:ve(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(He=>({count:He.executionCount,location:He.location&&ve(He.location)})):void 0}:{type:0,count:Ue.executionCount,location:ve(Ue.location)}}Pe.fromDetailed=Q;function Le(Ue){return{uri:Ue.uri,statement:we(Ue.statementCoverage),branch:Ue.branchCoverage&&we(Ue.branchCoverage),function:Ue.functionCoverage&&we(Ue.functionCoverage),details:Ue.detailedCoverage?.map(Q)}}Pe.fromFile=Le})(st||(e.TestCoverage=st={}));var ht;(function(Pe){function we(ve){switch(ve){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}Pe.to=we})(ht||(e.CodeActionTriggerKind=ht={}));var jt;(function(Pe){function we(Q){const Le=new h.$jL(Z.to(Q.kind),Q.name,Q.detail||"",y.URI.revive(Q.uri),s.to(Q.range),s.to(Q.selectionRange));return Le._sessionId=Q._sessionId,Le._itemId=Q._itemId,Le}Pe.to=we;function ve(Q,Le,Ue){if(Le=Le??Q._sessionId,Ue=Ue??Q._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,kind:Z.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:s.from(Q.range),selectionRange:s.from(Q.selectionRange),tags:Q.tags?.map(he.from)}}Pe.from=ve})(jt||(e.TypeHierarchyItem=jt={}));var Tt;(function(Pe){function we(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Pe.from=we})(Tt||(e.ViewBadge=Tt={}));var Dt;(function(Pe){function we(Ue,He,We){const _e=He.fileData;return _e?new h.$tK(new h.$uK(_e.name,y.URI.revive(_e.uri),_e.id,(0,M.$cb)(()=>We(_e.id)))):Ue===A.$ur.uriList&&He.uriListData?new h.$sK(Le(He.uriListData)):new h.$sK(He.asString)}Pe.to=we;async function ve(Ue,He){const We=await He.asString();if(Ue===A.$ur.uriList)return{asString:We,fileData:void 0,uriListData:Q(We)};const _e=He.asFile();return{asString:We,fileData:_e?{name:_e.name,uri:_e.uri,id:_e._itemId??_e.id}:void 0}}Pe.from=ve;function Q(Ue){return C.$cs.split(Ue).map(He=>{if(He.startsWith("#"))return He;try{return y.URI.parse(He)}catch{}return He})}function Le(Ue){return C.$cs.create(Ue.map(He=>typeof He=="string"?He:y.URI.revive(He)))}})(Dt||(e.DataTransferItem=Dt={}));var ot;(function(Pe){function we(Q,Le){const Ue=Q.items.map(([He,We])=>[He,Dt.to(He,We,Le)]);return new h.$vK(Ue)}Pe.toDataTransfer=we;async function ve(Q){const Le={items:[]},Ue=[];for(const[He,We]of Q)Ue.push((async()=>{Le.items.push([He,await Dt.from(He,We)])})());return await Promise.all(Ue),Le}Pe.from=ve})(ot||(e.DataTransfer=ot={}));var Pt;(function(Pe){function we(Q){return{message:Q.message,metadata:Q.metadata,title:Q.title,tooltip:Q.tooltip}}Pe.to=we;function ve(Q){return{kind:"reply",message:Q.message,metadata:Q.metadata,title:Q.title,tooltip:Q.tooltip}}Pe.from=ve})(Pt||(e.ChatReplyFollowup=Pt={}));var Mt;(function(Pe){function we(ve){return typeof ve=="string"?{title:ve,message:ve,kind:"reply"}:"commandId"in ve?{kind:"command",title:ve.title??"",commandId:ve.commandId??"",args:ve.args}:Pt.from(ve)}Pe.from=we})(Mt||(e.ChatFollowup=Mt={}))}),define(Ae[204],Fe([1,0,2,11,7,8,173]),function($e,e,w,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0$b=void 0;class g{constructor(p,A,E,c={timeout:1500,errors:3}){this.c=p,this.d=A,this.f=E,this.g=c,this.a=new P.$lc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(p){return(A,E,c)=>{const b={dispose:this.a.push([A,E,p])};return Array.isArray(c)&&c.push(b),b}}async $participateInSave(p,A){const E=w.URI.revive(p);let c=!1;const y=setTimeout(()=>c=!0,this.g.timeout),b=[];try{for(const o of[...this.a]){if(c)break;const t=this.d.getDocument(E),i=await this.h(o,{document:t,reason:M.TextDocumentSaveReason.to(A)});b.push(i)}}finally{clearTimeout(y)}return b}h([p,A,E],c){const y=this.b.get(p);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(E,p,A,c).then(()=>!0,b=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this.c.error(b),!(b instanceof Error)||b.message!=="concurrent_edits"){const o=this.b.get(p);this.b.set(p,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(p,A,E,c){const y=[],b=Date.now(),{document:o,reason:t}=c,{version:i}=o,a=Object.freeze({document:o,reason:t,waitUntil(m){if(Object.isFrozen(y))throw(0,T.$6)("waitUntil can not be called async");y.push(Promise.resolve(m))}});try{A.apply(E,[a])}catch(m){return Promise.reject(m)}return Object.freeze(y),new Promise((m,S)=>{const I=setTimeout(()=>S(new Error("timeout")),this.g.timeout);return Promise.all(y).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' finished after ${Date.now()-b}ms`),clearTimeout(I),m(r)}).catch(r=>{clearTimeout(I),S(r)})}).then(m=>{const S={edits:[]};for(const I of m)if(Array.isArray(I)&&I.every(r=>r instanceof C.$KJ))for(const{newText:r,newEol:h,range:n}of I)S.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:n&&M.Range.from(n),text:r,eol:h&&M.EndOfLine.from(h)}});if(S.edits.length!==0)return i===o.version?this.f.$tryApplyWorkspaceEdit(S):Promise.reject(new Error("concurrent_edits"))})}}e.$0$b=g}),define(Ae[205],Fe([1,0,13,2,8,7,74]),function($e,e,w,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lac=e.$kac=void 0;class g{constructor(E,c,y,b){this.start=E,this.deletedCount=c,this.deletedItems=y,this.items=b}asApiEvent(){return{range:new M.$2K(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(E,c){return{EOL:c.eol,lines:c.source,languageId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:E}}constructor(E,c,y){this.notebook=E,this.h=c,this.j=y,this.handle=y.handle,this.uri=T.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(C.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,c=this.h.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:c.document,get mime(){return E.g},set mime(b){E.g=b},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(y)}return this.f}setOutputs(E){this.a=E.map(C.NotebookCellOutput.to)}setOutputItems(E,c,y){const b=y.map(C.NotebookCellOutputItem.to),o=this.a.find(t=>t.id===E);if(o&&(c||(o.items.length=0),o.items.push(...b),o.items.length>1&&o.items.every(t=>P.$IH(t.mime)))){const t=new Map,i=[];o.items.forEach(a=>{let m;t.has(a.mime)?m=t.get(a.mime):(m=[],t.set(a.mime,m),i.push(a.mime)),m.push(a.data)}),o.items.length=0,i.forEach(a=>{const m=P.$JH(t.get(a));o.items.push({mime:a,data:m.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$kac=D;class p{static{this.a=0}constructor(E,c,y,b,o){this.k=E,this.l=c,this.m=y,this.uri=b,this.handle=p.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=o.viewType,this.f=Object.freeze(o.metadata??Object.create(null)),this.r([[0,0,o.cells]],!0,void 0),this.g=o.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,c={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===w.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(y){return y=E.n(y),E.b[y].apiCell},getCells(y){return(y?E.p(y):E.b).map(o=>o.apiCell)},save(){return E.q()}};this.e=Object.freeze(c)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,c,y){this.g=E.versionId,this.h=c,this.acceptDocumentPropertiesChanged({metadata:y});const b={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},o=[];for(const i of E.rawEvents)i.kind===P.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,b.contentChanges):i.kind===P.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,b.contentChanges):i.kind===P.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),o.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===P.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),o.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===P.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),o.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===P.NotebookCellsChangeType.ChangeCellContent?o.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===P.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===P.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),o.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),o.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<o.length;i++){const a=o[i],m=t.get(a.cell);if(m===void 0){const S=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...a});t.set(a.cell,S-1)}else b.cellChanges[m]={...b.cellChanges[m],...a}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let c=E.start|0,y=E.end|0;return c<0&&(c=0),y>this.b.length&&(y=this.b.length),E.with({start:c,end:y})}p(E){E=this.o(E);const c=[];for(let y=E.start;y<E.end;y++)c.push(this.b[y]);return c}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,c,y){if(this.j)return;const b=[],o=[],t=[];if(E.reverse().forEach(i=>{const m=i[2].map(r=>{const h=new D(this,this.l,r);return c||o.push(D.asModelAddData(this.apiNotebook,r)),h}),S=new g(i[0],i[1],[],m),I=this.b.splice(i[0],i[1],...m);for(const r of I)t.push(r.uri),S.deletedItems.push(r.apiCell);b.push(S)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:t}),y)for(const i of b)y.push(i.asApiEvent())}s(E,c,y,b){const o=this.b.splice(E,c);this.b.splice(y,0,...o);const t=[new g(E,c,o.map(i=>i.apiCell),[]),new g(y,0,[],o)];for(const i of t)b.push(i.asApiEvent())}t(E,c){this.b[E].setOutputs(c)}u(E,c,y,b){this.b[E].setOutputItems(c,y,b)}v(E,c){const y=this.b[E];y.apiCell.document.languageId!==c&&this.m.$acceptModelLanguageChanged(y.uri,c)}w(E,c){const y=this.b[E];y.apiCell.mime=c}x(E,c){this.b[E].setMetadata(c)}y(E,c){this.b[E].setInternalMetadata(c)}getCellFromApiCell(E){return this.b.find(c=>c.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(c=>c.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$lac=p}),define(Ae[206],Fe([1,0,5,2,8,7]),function($e,e,w,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=void 0;class P{constructor(D,p,A,E={timeout:1500,errors:3}){this.b=D,this.c=p,this.d=A,this.f=E,this.a=new w.$0c}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(p,A,E)=>{const c=function(b){p.call(A,b)};return c.extension=D,this.a.event(c,void 0,E)}}async $participateInSave(D,p,A){const E=T.URI.revive(D),c=this.c.getNotebookDocument(E);if(!c)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:c.apiNotebook,reason:C.TextDocumentSaveReason.to(p)},A,async(o,t)=>{const i=Date.now(),a=await await Promise.resolve(o);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!A.isCancellationRequested&&a&&(a instanceof M.$NJ?y.push(a):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(y.length===0)return!0;const b={edits:[]};for(const o of y){const{edits:t}=C.WorkspaceEdit.from(o);b.edits=b.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(b)}}e.$Lac=P}),define(Ae[103],Fe([1,0,11,8,7]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mac=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor(g,D,p,A,E,c){this.id=g,this.f=D,this.notebookData=p,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=A,this.c=c}get apiEditor(){if(!this.e){const g=this;this.e={get notebook(){return g.notebookData.apiNotebook},get selection(){return g.a[0]},set selection(D){this.selections=[D]},get selections(){return g.a},set selections(D){if(!Array.isArray(D)||!D.every(C.$2K.isNotebookRange))throw(0,w.$5)("selections");g.a=D,g.g(D)},get visibleRanges(){return g.b},revealRange(D,p){g.f.$tryRevealRange(g.id,T.NotebookRange.from(D),p??C.NotebookEditorRevealType.Default)},get viewColumn(){return g.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(g){this.d=g}_acceptVisibleRanges(g){this.b=g}_acceptSelections(g){this.a=g}g(g){this.f.$trySetSelections(this.id,g.map(T.NotebookRange.from))}_acceptViewColumn(g){this.c=g}}e.$mac=M}),define(Ae[207],Fe([1,0,11,5,14,8]),function($e,e,w,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=void 0;let P=class{constructor(D,p){this.c=D,this.d=p,this.a=new T.$8c({onListenerError:w.$Z}),this.b=new T.$8c({onListenerError:w.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,p);const A=this.d.getEditorById(D);p.visibleRanges&&A._acceptVisibleRanges(p.visibleRanges.ranges.map(M.NotebookRange.to)),p.selections&&A._acceptSelections(p.selections.selections.map(M.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const p in D)this.d.getEditorById(p)._acceptViewColumn(M.ViewColumn.to(D[p]))}};e.$Eac=P,e.$Eac=P=Ve([qe(0,C.$Ri)],P)}),define(Ae[208],Fe([1,0,8,177,152,20,65,11]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I_b=void 0;class D{constructor(c){this.b=0,this.c=new Map,this.a=c}async withProgress(c,y,b){const o=this.b++,{title:t,location:i,cancellable:a}=y,m={label:(0,C.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this.a.$startProgress(o,{location:w.ProgressLocation.from(i),title:t,source:m,cancellable:a},c.isUnderDevelopment?void 0:c.identifier.value).catch(g.$Z),this.d(o,b,!!a)}d(c,y,b){let o;b&&(o=new M.$ed,this.c.set(c,o));const t=a=>{this.a.$progressEnd(a),this.c.delete(a),o?.dispose()};let i;try{i=y(new A(this.a,c),b&&o?o.token:M.CancellationToken.None)}catch(a){throw t(c),a}return i.then(a=>t(c),a=>t(c)),i}$acceptProgressCanceled(c){const y=this.c.get(c);y&&(y.cancel(),this.c.delete(c))}}e.$I_b=D;function p(E,c){return E.message=c.message,typeof c.increment=="number"&&(typeof E.increment=="number"?E.increment+=c.increment:E.increment=c.increment),E}class A extends T.$Nu{constructor(c,y){super(b=>this.throttledReport(b)),this.f=c,this.g=y}throttledReport(c){this.f.$progressReport(this.g,c)}}Ve([(0,P.$Vg)(100,(E,c)=>p(E,c),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Ae[104],Fe([1,0,44,101,45,75,57,8,2]),function($e,e,w,T,C,M,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SL=e.$RL=e.$QL=e.$PL=void 0;const p=(m,S,I,r)=>{let h=S;return{enumerable:!0,configurable:!1,get(){return h},set(n){if(!I(h,n)){const s=h;h=n,m.listener?.(r(n,s))}}}},A=(m,S)=>m===S,E={range:(m,S)=>m===S?!0:!m||!S?!1:m.isEqual(S),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(m,S)=>!(m.length!==S.length||m.some(I=>!S.find(r=>I.id===r.id)))},c=m=>S=>({op:4,update:m(S)}),y=(m,S)=>({range:(()=>{let I;const r=c(h=>({range:w.$Or.lift(g.Range.from(h))}));return{enumerable:!0,configurable:!1,get(){return I},set(h){m.listener?.({op:6}),E.range(I,h)||(I=h,m.listener?.(r(h)))}}})(),label:p(m,S,E.label,c(I=>({label:I}))),description:p(m,void 0,E.description,c(I=>({description:I}))),sortText:p(m,void 0,E.sortText,c(I=>({sortText:I}))),canResolveChildren:p(m,!1,E.canResolveChildren,I=>({op:2,state:I})),busy:p(m,!1,E.busy,c(I=>({busy:I}))),error:p(m,void 0,E.error,c(I=>({error:g.MarkdownString.fromStrict(I)||null}))),tags:p(m,[],E.tags,(I,r)=>({op:1,new:I.map(g.TestTag.from),old:r.map(g.TestTag.from)}))}),b=m=>{const S=C.$nI.fromString(m.extId),I=new t(S.controllerId,S.localId,m.label,D.URI.revive(m.uri)||void 0);return I.range=g.Range.to(m.range||void 0),I.description=m.description||void 0,I.sortText=m.sortText||void 0,I.tags=m.tags.map(r=>g.TestTag.to({id:(0,P.$sI)(r).tagId})),I},o=m=>{let S;for(const I of m.tests){const r=b(I.item);(0,T.$zL)(r).parent=S,S=r}return S};e.$PL=o;class t{constructor(S,I,r,h){if(I.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(I)} symbol`);const n=(0,T.$yL)(this,S);Object.defineProperties(this,{id:{value:I,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof i?void 0:n.parent}},children:{value:(0,M.$xL)(n,T.$zL,t),enumerable:!0,writable:!1},...y(n,r)})}}e.$QL=t;class i extends t{constructor(S,I){super(S,S,I,void 0),this._isRoot=!0}}e.$RL=i;class a extends M.$tL{constructor(S,I,r){super({controllerId:S,getDocumentVersion:h=>h&&r.getDocument(h)?.version,getApiFor:T.$zL,getChildren:h=>h.children,root:new i(S,I),toITestItem:g.TestItem.from})}}e.$SL=a}),define(Ae[105],Fe([1,0,50,11,87,8,7]),function($e,e,w,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.$LL=e.$KL=void 0;class g{static{this.c=new C.$IL("TextEditorDecorationType")}constructor(c,y,b){const o=g.c.nextId();c.$registerTextEditorDecorationType(y.identifier,o,M.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:o,dispose(){c.$removeTextEditorDecorationType(o)}})}}e.$KL=g;class D{constructor(c,y){this.g=[],this.h=void 0,this.j=!1,this.c=c,this.d=c.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(c,y){this.k();let b=null;if(c instanceof P.$EJ)b=new P.$FJ(c,c);else if(c instanceof P.$FJ)b=c;else throw new Error("Unrecognized location");this.l(b,y,!1)}insert(c,y){this.k(),this.l(new P.$FJ(c,c),y,!0)}delete(c){this.k();let y=null;if(c instanceof P.$FJ)y=c;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(c,y,b){const o=this.c.validateRange(c);this.g.push({range:o,text:y,forceMoveMarkers:b})}setEndOfLine(c){if(this.k(),c!==P.EndOfLine.LF&&c!==P.EndOfLine.CRLF)throw(0,T.$5)("endOfLine");this.h=c}}class p{constructor(c,y,b,o){this.c=c,this.d=y,this._accept(b),this.e=o;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(c){this.f=c.tabSize,this.g=c.indentSize,this.h=c.insertSpaces,this.j=c.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(c.lineNumbers)}l(c){if(c==="auto")return"auto";if(typeof c=="number"){const y=Math.floor(c);return y>0?y:null}if(typeof c=="string"){const y=parseInt(c,10);return isNaN(y)?null:y>0?y:null}return null}m(c){const y=this.l(c);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(c){if(c==="tabSize")return"tabSize";if(typeof c=="number"){const y=Math.floor(c);return y>0?y:null}if(typeof c=="string"){const y=parseInt(c,10);return isNaN(y)?null:y>0?y:null}return null}o(c){const y=this.n(c);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(c){return c==="auto"?"auto":c==="false"?!1:!!c}q(c){const y=this.p(c);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(c){this.j!==c&&(this.j=c,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:c})))}t(c){this.k!==c&&(this.k=c,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(c)})))}assign(c){const y={};let b=!1;if(typeof c.tabSize<"u"){const o=this.l(c.tabSize);o==="auto"?(b=!0,y.tabSize=o):typeof o=="number"&&this.f!==o&&(this.f=o,b=!0,y.tabSize=o)}if(typeof c.indentSize<"u"){const o=this.n(c.indentSize);o==="tabSize"?(b=!0,y.indentSize=o):typeof o=="number"&&this.g!==o&&(this.g=o,b=!0,y.indentSize=o)}if(typeof c.insertSpaces<"u"){const o=this.p(c.insertSpaces);o==="auto"?(b=!0,y.insertSpaces=o):this.h!==o&&(this.h=o,b=!0,y.insertSpaces=o)}typeof c.cursorStyle<"u"&&this.j!==c.cursorStyle&&(this.j=c.cursorStyle,b=!0,y.cursorStyle=c.cursorStyle),typeof c.lineNumbers<"u"&&this.k!==c.lineNumbers&&(this.k=c.lineNumbers,b=!0,y.lineNumbers=M.TextEditorLineNumbersStyle.from(c.lineNumbers)),b&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(c,y){y.catch(b=>{this.e.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this.e.warn(b)})}}e.$LL=p;class A{constructor(c,y,b,o,t,i,a,m){this.id=c,this.j=y,this.k=b,this.g=!1,this.h=new Set,this.c=t,this.d=new p(this.j,this.id,i,b),this.e=a,this.f=m;const S=this;this.value=Object.freeze({get document(){return o.value},set document(I){throw(0,T.$7)("document")},get selection(){return S.c&&S.c[0]},set selection(I){if(!(I instanceof P.$GJ))throw(0,T.$5)("selection");S.c=[I],S.l()},get selections(){return S.c},set selections(I){if(!Array.isArray(I)||I.some(r=>!(r instanceof P.$GJ)))throw(0,T.$5)("selections");S.c=I,S.l()},get visibleRanges(){return S.e},set visibleRanges(I){throw(0,T.$7)("visibleRanges")},get options(){return S.d.value},set options(I){S.g||S.d.assign(I)},get viewColumn(){return S.f},set viewColumn(I){throw(0,T.$7)("viewColumn")},edit(I,r={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new D(o.value,r);return I(h),S.m(h)},insertSnippet(I,r,h={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!r||Array.isArray(r)&&r.length===0)n=S.c.map(s=>M.Range.from(s));else if(r instanceof P.$EJ){const{lineNumber:s,column:$}=M.Position.from(r);n=[{startLineNumber:s,startColumn:$,endLineNumber:s,endColumn:$}]}else if(r instanceof P.$FJ)n=[M.Range.from(r)];else{n=[];for(const s of r)if(s instanceof P.$FJ)n.push(M.Range.from(s));else{const{lineNumber:$,column:k}=M.Position.from(s);n.push({startLineNumber:$,startColumn:k,endLineNumber:$,endColumn:k})}}return y.$tryInsertSnippet(c,o.value.version,I.value,n,h)},setDecorations(I,r){const h=r.length===0;h&&!S.h.has(I.key)||(h?S.h.delete(I.key):S.h.add(I.key),S.n(()=>{if(M.$AL(r))return y.$trySetDecorations(c,I.key,M.$BL(r));{const n=new Array(4*r.length);for(let s=0,$=r.length;s<$;s++){const k=r[s];n[4*s]=k.start.line+1,n[4*s+1]=k.start.character+1,n[4*s+2]=k.end.line+1,n[4*s+3]=k.end.character+1}return y.$trySetDecorationsFast(c,I.key,n)}}))},revealRange(I,r){S.n(()=>y.$tryRevealRange(c,M.Range.from(I),r||P.TextEditorRevealType.Default))},show(I){y.$tryShowEditor(c,M.ViewColumn.from(I))},hide(){y.$tryHideEditor(c)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(c){(0,w.ok)(!this.g),this.d._accept(c)}_acceptVisibleRanges(c){(0,w.ok)(!this.g),this.e=c}_acceptViewColumn(c){(0,w.ok)(!this.g),this.f=c}_acceptSelections(c){(0,w.ok)(!this.g),this.c=c}async l(){const c=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,c)),this.value}m(c){const y=c.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const b=y.edits.map(t=>t.range);b.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=b.length-1;t<i;t++){const a=b[t].end;if(b[t+1].start.isBefore(a))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=y.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,o,{setEndOfLine:typeof y.setEndOfLine=="number"?M.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(c){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$ML=A}),define(Ae[209],Fe([1,0,3,171]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RI=void 0,e.$RI=(0,w.$qh)(T.$wh)}),define(Ae[106],Fe([1,0,21,5,19,6]),function($e,e,w,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v1b=e.$u1b=e.$t1b=e.$s1b=e.$r1b=void 0;class P{constructor(t){this.removedDueToLooping=t}}e.$r1b=P;class g{static isHostExtension(t,i,a){if(i.getExtensionDescription(t))return!1;const m=a.getExtensionDescription(t);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(t,i){this.h=t,this.c=new T.$8c,this.onDidChange=this.c.event,this.d=i,this.j()}j(){this.d.sort(y),this.e=new w.$Jl,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const i=this.h.readActivationEvents(t);if(Array.isArray(i))for(let a of i)a==="onUri"&&(a=`onUri:${w.$Hl.toKey(t.identifier)}`),this.g.has(a)||this.g.set(a,[]),this.g.get(a).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,i){this.d=b(this.d,i),this.d=this.d.concat(t);const a=g.k(this.d);return this.d=b(this.d,a.map(m=>m.identifier)),this.j(),this.c.fire(void 0),new P(a)}static k(t){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,h){this.addNode(r),this.addNode(h),this.c.has(r)?this.c.get(r).push(h):this.c.set(r,[h])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,h){const n=i.getArcs(r);for(let s=0;s<n.length;s++)if(!h.has(n[s]))return!1;return!0}getNodes(){return this.e}},a=new w.$Jl;for(const r of t)if(a.set(r.identifier,r),r.extensionDependencies)for(const h of r.extensionDependencies)i.addArc(w.$Hl.toKey(r.identifier),w.$Hl.toKey(h));const m=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>m.add(r));const S=i.getNodes().filter(r=>!m.has(r));let I;do{I=!1;for(let r=0;r<S.length;r++){const h=S[r];i.hasOnlyGoodArcs(h,m)&&(S.splice(r,1),r--,m.add(h),I=!0)}}while(I);return S.map(r=>a.get(r))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const i=this.g.get(t);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const i=this.e.get(t);return i||void 0}getExtensionDescriptionByUUID(t){for(const i of this.f)if(i.uuid===t)return i}getExtensionDescriptionByIdOrUUID(t,i){return this.getExtensionDescription(t)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$s1b=g,e.$t1b={readActivationEvents:o=>o.activationEvents};class D{constructor(t){this.d=new E,this.c=new g(t,[])}async acquireLock(t){const i=await this.d.acquire(t);return new p(this,i)}deltaExtensions(t,i,a){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,a)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,i){return this.c.getExtensionDescriptionByIdOrUUID(t,i)}}e.$u1b=D;class p extends M.$lb{constructor(t,i){super(),this.f=t,this.c=!1,this.B(i)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$v1b=p;class A{constructor(t){this.name=t,this.promise=new Promise((i,a)=>{this.c=i})}resolve(t){this.c(t)}}class E{constructor(){this.c=[],this.d=!1}async acquire(t){const i=new A(t);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),m=()=>{i&&(clearTimeout(a),i=!1,this.d=!1,this.e())};t.resolve((0,M.$jb)(m))}}var c;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(c||(c={}));function y(o,t){const i=o.isBuiltin?0:o.isUnderDevelopment?2:1,a=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(i!==a)return i-a;const m=C.$0b.basename(o.extensionLocation.path),S=C.$0b.basename(t.extensionLocation.path);return m<S?-1:m>S?1:0}function b(o,t){const i=new w.$Il(t);return o.filter(a=>!i.has(a.identifier))}}),define(Ae[78],Fe([1,0,25]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Ql=e.$Pl=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(p){p[p.Desktop=1]="Desktop",p[p.Web=2]="Web"})(T||(e.UIKind=T={}));var C;(function(p){p[p.VersionMismatch=55]="VersionMismatch",p[p.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var M;(function(p){p[p.Initialized=0]="Initialized",p[p.Ready=1]="Ready",p[p.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function P(p){const A=w.$Jb.alloc(1);switch(p){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$Pl=P;function g(p,A){if(p.byteLength!==1)return!1;switch(p.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$Ql=g;var D;(function(p){p.Start="START_NATIVE_LOG",p.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Ae[58],Fe([1,0,3,5,14,27,78,51,53,24,2,6,154]),function($e,e,w,T,C,M,P,g,D,p,A,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XL=e.$WL=e.$VL=e.$UL=void 0;let y=class extends E.$lb{constructor(i,a){super(),this.n=i,this.p=a,this.a=this.B(new T.$8c),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$8c),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=A.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=a.createLogger(this.j,{id:D.$7n,name:(0,c.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(a.onDidChangeLogLevel(m=>{(0,C.$Ti)(m)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,a,m){const S=this.getTelemetryDetails(),I=new b(a,m,i,this.k,this.i,this.getBuiltInCommonProperties(i),{isUsageEnabled:S.isUsageEnabled,isErrorsEnabled:S.isErrorsEnabled}),r=this.m.get(i.identifier.value)??[];return this.m.set(i.identifier.value,[...r,I]),I.apiTelemetryLogger}$initializeTelemetryLevel(i,a,m){this.f=i,this.g=a,this.c=m??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(i){const a=Object.create(null);switch(a["common.extname"]=`${i.publisher}.${i.name}`,a["common.extversion"]=i.version,a["common.vscodemachineid"]=this.n.telemetryInfo.machineId,a["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,a["common.vscodeversion"]=this.n.version,a["common.isnewappinstall"]=o(this.n.telemetryInfo.firstSessionDate),a["common.product"]=this.n.environment.appHost,this.n.uiKind){case P.UIKind.Web:a["common.uikind"]="web";break;case P.UIKind.Desktop:a["common.uikind"]="desktop";break;default:a["common.uikind"]="unknown"}return a["common.remotename"]=(0,g.$Ck)((0,D.$bo)(this.n.remote.authority)),a}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const a=this.getTelemetryDetails();this.m.forEach((m,S)=>{const I=m.filter(r=>!r.isDisposed);I.length===0?this.m.delete(S):this.m.set(S,I)}),this.m.forEach(m=>{for(const S of m)S.updateTelemetryEnablements(a.isUsageEnabled,a.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(i,a){const S=this.m.get(i.value)?.filter(r=>!r.isDisposed);if(!S)return this.m.delete(i.value),!1;let I=!1;for(const r of S)r.ignoreUnhandledExtHostErrors||(r.logError(a),I=!0);return I}};e.$UL=y,e.$UL=y=Ve([qe(0,M.$TL),qe(1,C.$Si)],y);class b{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,a,m,S,I,r,h){this.g=m,this.h=S,this.i=I,this.j=r,this.a=new T.$8c,this.ignoreUnhandledExtHostErrors=a?.ignoreUnhandledErrors??!1,this.b=a?.ignoreBuiltInCommonProperties??!1,this.c=a?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(i,a){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:a},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let a="properties"in i?i.properties??{}:i;return a=(0,D.$eo)(a,[]),this.c&&(a=(0,p.$Km)(a,this.c)),this.b||(a=(0,p.$Km)(a,this.j)),"properties"in i?i.properties=a:i=a,i}k(i,a){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f?.sendEventData(i,a),this.h.trace(i,a))}logUsage(i,a){this.d.isUsageEnabled&&this.k(i,a)}logError(i,a){!this.d.isErrorsEnabled||!this.f||(typeof i=="string"?this.k(i,a):this.f.sendErrorData(i,a))}get apiTelemetryLogger(){if(!this.e){const i=this,a={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(a)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$VL=b;function o(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$WL=o,e.$XL=(0,w.$ph)("IExtHostTelemetry")}),define(Ae[26],Fe([1,0,5,2,181,97,21,3]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EF=e.$DF=e.$CF=e.ActivationKind=e.$BF=e.$AF=e.$zF=e.$yF=e.$xF=e.ExtensionHostStartup=e.$wF=e.$vF=e.$uF=e.$tF=void 0,e.$tF=Object.freeze({identifier:new P.$Hl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$uF="extensions.webWorker",e.$vF=(0,g.$ph)("extensionService");class D{constructor(I){this.dependency=I}}e.$wF=D;var p;(function(S){S[S.EagerAutoStart=1]="EagerAutoStart",S[S.EagerManualStart=2]="EagerManualStart",S[S.Lazy=3]="Lazy"})(p||(e.ExtensionHostStartup=p={}));class A{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:M.$kF.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(I,r){const h=[],n=[],s=[],$=[],k=E(this.c),l=E(I),f=(W,B)=>W.extensionLocation.toString()===B.extensionLocation.toString()||W.isBuiltin===B.isBuiltin||W.isUserBuiltin===B.isUserBuiltin||W.isUnderDevelopment===B.isUnderDevelopment;for(const W of this.c){const B=l.get(W.identifier);if(!B){h.push(W.identifier),k.delete(W.identifier);continue}if(!f(W,B)){h.push(W.identifier),k.delete(W.identifier);continue}}for(const W of I){const B=k.get(W.identifier);if(!B){n.push(W);continue}if(!f(B,W)){h.push(B.identifier),k.delete(B.identifier);continue}}const v=new P.$Il(this.d),u=new P.$Il(r);for(const W of this.d)u.has(W)||s.push(W);for(const W of r)v.has(W)||$.push(W);const d=M.$kF.createActivationEventsMap(n),R={toRemove:h,toAdd:n,addActivationEvents:d,myToRemove:s,myToAdd:$};return this.delta(R),R}delta(I){const{toRemove:r,toAdd:h,myToRemove:n,myToAdd:s}=I,$=new P.$Il(r),k=new P.$Il(n);for(let l=0;l<this.c.length;l++)$.has(this.c[l].identifier)&&(this.c.splice(l,1),l--);for(let l=0;l<this.d.length;l++)k.has(this.d[l])&&(this.d.splice(l,1),l--);for(const l of h)this.c.push(l);for(const l of s)this.d.push(l)}containsExtension(I){for(const r of this.d)if(P.$Hl.equals(r,I))return!0;return!1}}e.$xF=A;function E(S){const I=new P.$Jl;for(const r of S)I.set(r.identifier,r);return I}function c(S,I){return S.enabledApiProposals?S.enabledApiProposals.includes(I):!1}e.$yF=c;function y(S,I){if(!c(S,I))throw new Error(`Extension '${S.identifier.value}' CANNOT use API proposal: ${I}.
Its package.json#enabledApiProposals-property declares: ${S.enabledApiProposals?.join(", ")??"[]"} but NOT ${I}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${S.identifier.value}`)}e.$zF=y;class b{constructor(I,r,h,n){this.codeLoadingTime=I,this.activateCallTime=r,this.activateResolvedTime=h,this.activationReason=n}}e.$AF=b;class o{constructor(I,r){this.description=I,this.value=r}}e.$BF=o;var t;(function(S){S[S.Normal=0]="Normal",S[S.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(S){return{type:S.isBuiltin?0:1,isBuiltin:S.isBuiltin||S.isUserBuiltin,identifier:{id:(0,C.$ko)(S.publisher,S.name),uuid:S.uuid},manifest:S,location:S.extensionLocation,targetPlatform:S.targetPlatform,validations:[],isValid:!0}}e.$CF=i;function a(S,I){return{identifier:new P.$Hl((0,C.$io)(S.manifest.publisher,S.manifest.name)),isBuiltin:S.type===0,isUserBuiltin:S.type===1&&S.isBuiltin,isUnderDevelopment:!!I,extensionLocation:S.location,...S.manifest,uuid:S.identifier.uuid,targetPlatform:S.targetPlatform}}e.$DF=a;class m{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(I){return Promise.resolve(void 0)}activationEventIsDone(I){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(I){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(I,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(I){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$EF=m}),define(Ae[210],Fe([1,0,11,106,21,26,14,16]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d_b=e.$c_b=e.$b_b=e.$a_b=e.$_$b=e.$$$b=void 0;class D{static{this.NONE=new D(!1,-1,-1,-1)}constructor(i,a,m,S){this.startup=i,this.codeLoadingTime=a,this.activateCallTime=m,this.activateResolvedTime=S}}e.$$$b=D;class p{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,a){return i===-1||a===-1?-1:a-i}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$_$b=p;class A{constructor(i,a,m,S,I,r){this.activationFailed=i,this.activationFailedError=a,this.activationTimes=m,this.module=S,this.exports=I,this.subscriptions=r}}e.$a_b=A;class E extends A{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$b_b=E;class c extends A{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$c_b=c;class y extends A{constructor(i){super(!0,i,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let b=class{constructor(i,a,m,S){this.g=S,this.a=i,this.b=a,this.c=m,this.d=new C.$Jl,this.f=Object.create(null)}dispose(){for(const[i,a]of this.d)a.dispose()}async waitForActivatingExtensions(){const i=[];for(const[a,m]of this.d)i.push(m.wait());await Promise.all(i)}isActivated(i){const a=this.d.get(i);return!!(a&&a.value)}getActivatedExtension(i){const a=this.d.get(i);if(!a||!a.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return a.value}async activateByEvent(i,a){if(this.f[i])return;const m=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(m.map(S=>({id:S.identifier,reason:{startup:a,extensionId:S.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,a){const m=this.a.getExtensionDescription(i);if(!m)throw new Error(`Extension '${i}' is not known`);return this.h([{id:m.identifier,reason:a}])}async h(i){const a=i.filter(m=>!this.isActivated(m.id)).map(m=>this.j(m));await Promise.all(a.map(m=>m.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const a=this.a.getExtensionDescription(i.id);if(!a){const I=new Error(`Cannot activate unknown extension '${i.id.value}'`),r=this.k(i,null,[],new y(I));return this.c.onExtensionActivationError(i.id,I,new M.$wF(i.id.value)),r}const m=[],S=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const I of S){if(this.m(I))continue;const r=this.d.get(I);if(r){m.push(r);continue}if(this.l(I)){m.push(this.j({id:this.b.getExtensionDescription(I).identifier,reason:i.reason}));continue}const h=this.a.getExtensionDescription(I);if(h){if(!h.main&&!h.browser)continue;m.push(this.j({id:h.identifier,reason:i.reason}));continue}const n=a.displayName||a.identifier.value,s=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${I}'`),$=this.k(i,a.displayName,[],new y(s));return this.c.onExtensionActivationError(a.identifier,s,new M.$wF(I)),$}return this.k(i,a.displayName,m,null)}k(i,a,m,S){const I=new o(i.id,a,i.reason,m,S,this.c,this.g);return this.d.set(i.id,I),I}l(i){return T.$s1b.isHostExtension(i,this.a,this.b)}m(i){const a=this.b.getExtensionDescription(i);return a?!a.main&&!a.browser:!1}};e.$d_b=b,e.$d_b=b=Ve([qe(3,P.$Ri)],b);let o=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,a,m,S,I,r,h){this.c=i,this.d=a,this.f=m,this.g=S,this.h=I,this.j=r,this.k=h,this.a=new g.$ug,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const a=this.g[i];if(a.value&&!a.value.activationFailed){this.g.splice(i,1),i--;continue}if(a.value&&a.value.activationFailed){const m=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);m.detail=a.value.activationFailedError,this.h=new y(m),this.j.onExtensionActivationError(this.c,m,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const a=new Error;if(i&&i.name&&(a.name=i.name),i&&i.message?a.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:a.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(a.stack=i.stack),this.h=new y(a),this.b&&w.$2(i))return;this.j.onExtensionActivationError(this.c,a,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};o=Ve([qe(6,P.$Ri)],o)}),define(Ae[211],Fe([1,0,156,7,23,2,5,6,193,16,7,12,18,8,49,20,125,26]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P_b=void 0;function a(I,r){if((0,E.$je)(I))return{label:I};if(I&&typeof I=="object"&&typeof I.label=="string"){let h;return Array.isArray(I.highlights)&&(h=I.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),h=h.length?h:void 0),{label:I.label,highlights:h}}}class m{constructor(r,h,n){this.d=r,this.e=h,this.f=n,this.a=new Map,this.b=new t.$z5;function s($){return $&&$.$treeViewId&&($.$treeItemHandle||$.$selectedTreeItems||$.$focusedTreeItem)}h.registerArgumentProcessor({processArgument:$=>s($)?this.i($):Array.isArray($)&&$.length>0?$.map(k=>s(k)?this.i(k):k):$})}registerTreeDataProvider(r,h,n){const s=this.createTreeView(r,{treeDataProvider:h},n);return{dispose:()=>s.dispose()}}createTreeView(r,h,n){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=h.dragAndDropController?.dropMimeTypes??[],$=h.dragAndDropController?.dragMimeTypes??[],k=!!h.dragAndDropController?.handleDrag,l=!!h.dragAndDropController?.handleDrop,f=this.h(r,h,n),v={showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,dropMimeTypes:s,dragMimeTypes:$,hasHandleDrag:k,hasHandleDrop:l,manuallyManageCheckboxes:!!h.manageCheckboxStateManually},u=this.d.$registerTreeViewDataProvider(r,v);return{get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get activeItem(){return(0,i.$zF)(n,"treeViewActiveItem"),f.focusedElement},get onDidChangeActiveItem(){return(0,i.$zF)(n,"treeViewActiveItem"),f.onDidChangeActiveItem},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return f.onDidChangeCheckboxState},get message(){return f.message},set message(R){(0,b.$Mj)(R)&&(0,i.$zF)(n,"treeViewMarkdownMessage"),f.message=R},get title(){return f.title},set title(R){f.title=R},get description(){return f.description},set description(R){f.description=R},get badge(){return f.badge},set badge(R){R!==void 0&&A.ViewBadge.isViewBadge(R)?f.badge={value:Math.floor(Math.abs(R.value)),tooltip:R.tooltip}:R===void 0&&(f.badge=void 0)},reveal:(R,W)=>f.reveal(R,W),dispose:async()=>{await u,this.a.delete(r),f.dispose()}}}$getChildren(r,h){const n=this.a.get(r);return n?n.getChildren(h):Promise.reject(new D.$XE(r))}async $handleDrop(r,h,n,s,$,k,l,f){const v=this.a.get(r);if(!v)return Promise.reject(new D.$XE(r));const u=y.DataTransfer.toDataTransfer(n,async d=>(await this.d.$resolveDropFileData(r,h,d)).buffer);return l===r&&f&&await this.g(u,v,f,$,k),v.onDrop(u,s,$)}async g(r,h,n,s,$){const k=this.b.removeDragOperationTransfer($);if(k)(await k)?.forEach((l,f)=>{l&&r.set(f,l)});else if($&&h.handleDrag){const l=h.handleDrag(n,r,s);this.b.addDragOperationTransfer($,l),await l}return r}async $handleDrag(r,h,n,s){const $=this.a.get(r);if(!$)return Promise.reject(new D.$XE(r));const k=await this.g(new T.$vK,$,h,s,n);if(!(!k||s.isCancellationRequested))return y.DataTransfer.from(k)}async $hasResolve(r){const h=this.a.get(r);if(!h)throw new D.$XE(r);return h.hasResolve}$resolve(r,h,n){const s=this.a.get(r);if(!s)throw new D.$XE(r);return s.resolveTreeItem(h,n)}$setExpanded(r,h,n){const s=this.a.get(r);if(!s)throw new D.$XE(r);s.setExpanded(h,n)}$setSelectionAndFocus(r,h,n){const s=this.a.get(r);if(!s)throw new D.$XE(r);s.setSelectionAndFocus(h,n)}$setVisible(r,h){const n=this.a.get(r);if(!n)throw new D.$XE(r);n.setVisible(h)}$changeCheckboxState(r,h){const n=this.a.get(r);if(!n)throw new D.$XE(r);n.setCheckboxState(h)}h(r,h,n){const s=new S(r,h,this.d,this.e.converter,this.f,n);return this.a.set(r,s),s}i(r){const h=this.a.get(r.$treeViewId);return h&&"$treeItemHandle"in r?h.getExtensionElement(r.$treeItemHandle):h&&"$focusedTreeItem"in r&&r.$focusedTreeItem?h.focusedElement:null}}e.$P_b=m;class S extends g.$lb{static{this.a="0"}static{this.b="1"}get visible(){return this.k}get selectedElements(){return this.l.map(r=>this.getExtensionElement(r)).filter(r=>!(0,E.$se)(r))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(r,h,n,s,$,k){if(super(),this.D=r,this.F=n,this.G=s,this.H=$,this.I=k,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new P.$8c),this.onDidExpandElement=this.r.event,this.s=this.B(new P.$8c),this.onDidCollapseElement=this.s.event,this.t=this.B(new P.$8c),this.onDidChangeSelection=this.t.event,this.u=this.B(new P.$8c),this.onDidChangeActiveItem=this.u.event,this.v=this.B(new P.$8c),this.onDidChangeVisibility=this.v.event,this.w=this.B(new P.$8c),this.onDidChangeCheckboxState=this.w.event,this.y=this.B(new P.$8c),this.z=Promise.resolve(),this.C=Promise.resolve(),this.J="",this.L="",this.U=new o.$ed,k.contributes&&k.contributes.views)for(const v in k.contributes.views)for(const u of k.contributes.views[v])u.id===r&&(this.L=u.name);this.f=h.treeDataProvider,this.g=h.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.y.fire({message:!1,element:v})));let l,f;this.B(P.Event.debounce(this.y.event,(v,u)=>(v||(v={message:!1,elements:[]}),u.element!==!1&&(l||(l=new Promise(d=>f=d),this.z=this.z.then(()=>l)),Array.isArray(u.element)?v.elements.push(...u.element):v.elements.push(u.element)),u.message&&(v.message=!0),v),200,!0)(({message:v,elements:u})=>{u.length&&(this.C=this.C.then(()=>{const d=f;return l=null,this.W(u).then(()=>d())})),v&&this.F.$setMessage(this.D,y.MarkdownString.fromStrict(this.J)??"")}))}async getChildren(r){const h=r?this.getExtensionElement(r):void 0;if(r&&!h)return this.H.error(`No tree item with id '${r}' found.`),Promise.resolve([]);let n=this.R(r);return n||(n=await this.S(h)),n?n.map(s=>s.item):void 0}getExtensionElement(r){return this.i.get(r)}reveal(r,h){h=h||{select:!0,focus:!1};const n=(0,E.$se)(h.select)?!0:h.select,s=(0,E.$se)(h.focus)?!1:h.focus,$=(0,E.$se)(h.expand)?!1:h.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):r?this.z.then(()=>this.O(r)).then(k=>this.Q(r,k[k.length-1]).then(l=>this.F.$reveal(this.D,{item:l.item,parentChain:k.map(f=>f.item)},{select:n,focus:s,expand:$})),k=>this.H.error(k)):this.F.$reveal(this.D,void 0,{select:n,focus:s,expand:$})}get message(){return this.J}set message(r){this.J=r,this.y.fire({message:!0,element:!1})}get title(){return this.L}set title(r){this.L=r,this.F.$setTitle(this.D,r,this.M)}get description(){return this.M}set description(r){this.M=r,this.F.$setTitle(this.D,this.L,r)}get badge(){return this.N}set badge(r){this.N?.value===r?.value&&this.N?.tooltip===r?.tooltip||(this.N=y.ViewBadge.from(r),this.F.$setBadge(this.D,r))}setExpanded(r,h){const n=this.getExtensionElement(r);n&&(h?this.r.fire(Object.freeze({element:n})):this.s.fire(Object.freeze({element:n})))}setSelectionAndFocus(r,h){const n=!(0,c.$bf)(this.l,r);this.l=r;const s=this.m!==h;this.m=h,n&&this.t.fire(Object.freeze({selection:this.selectedElements})),s&&this.u.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(r){r!==this.k&&(this.k=r,this.v.fire(Object.freeze({visible:this.k})))}async setCheckboxState(r){const h=(await Promise.all(r.map(async n=>{const s=this.getExtensionElement(n.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:n.newState?A.TreeItemCheckboxState.Checked:A.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);h.forEach(n=>{n.treeItem.checkboxState=n.newState?A.TreeItemCheckboxState.Checked:A.TreeItemCheckboxState.Unchecked}),this.w.fire({items:h.map(n=>[n.extensionItem,n.newState])})}async handleDrag(r,h,n){const s=[];for(const $ of r){const k=this.getExtensionElement($);k&&s.push(k)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,h,n),h}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(r,h,n){const s=h?this.getExtensionElement(h):void 0;if(!(!s&&h||!this.g?.handleDrop))return(0,p.$og)(()=>this.g?.handleDrop?this.g.handleDrop(s,r,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(r,h){if(!this.f.resolveTreeItem)return;const n=this.i.get(r);if(n){const s=this.j.get(n);if(s){const $=await this.f.resolveTreeItem(s.extensionItem,n,h)??s.extensionItem;return this.db($),s.item.tooltip=this.ab($.tooltip),s.item.command=this.bb(s.disposableStore,$.command),s.item}}}O(r){return this.P(r).then(h=>h?this.O(h).then(n=>this.Q(h,n[n.length-1]).then(s=>(n.push(s),n))):Promise.resolve([]))}P(r){const h=this.j.get(r);return h?Promise.resolve(h.parent?this.i.get(h.parent.item.handle):void 0):(0,p.$og)(()=>this.f.getParent(r))}Q(r,h){const n=this.j.get(r);return n?Promise.resolve(n):(0,p.$og)(()=>this.f.getTreeItem(r)).then(s=>this.gb(r,s,h,!0)).then(s=>this.getChildren(h?h.item.handle:void 0).then(()=>{const $=this.getExtensionElement(s);if($){const k=this.j.get($);if(k)return Promise.resolve(k)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.I.identifier.value}`)}))}R(r){if(r){let h;if(typeof r=="string"){const n=this.getExtensionElement(r);h=n?this.j.get(n):void 0}else h=r;return h&&h.children||void 0}return this.h}async S(r){this.nb(r);const h=new o.$ed(this.U.token);try{const n=r?this.j.get(r):void 0,s=await this.f.getChildren(r);if(h.token.isCancellationRequested)return;const $=await Promise.all((0,c.$mf)(s||[]).map(async k=>{const l=await this.f.getTreeItem(k);return l&&!h.token.isCancellationRequested?this.$(k,l,n):null}));return h.token.isCancellationRequested?void 0:(0,c.$mf)($)}finally{h.dispose()}}W(r){if(r.some(n=>!n))return this.U.dispose(!0),this.U=new o.$ed,this.pb(),this.F.$refresh(this.D);{const n=this.X(r);if(n.length)return this.Y(n)}return Promise.resolve(void 0)}X(r){const h=new Set,n=r.map($=>this.j.get($));for(const $ of n)if($&&!h.has($.item.handle)){let k=$;for(;k&&k.parent&&n.findIndex(l=>k&&k.parent&&l&&l.item.handle===k.parent.item.handle)===-1;){const l=this.i.get(k.parent.item.handle);k=l?this.j.get(l):void 0}k&&!k.parent&&h.add($.item.handle)}const s=[];return h.forEach($=>{const k=this.i.get($);if(k){const l=this.j.get(k);l&&(!l.parent||!h.has(l.parent.item.handle))&&s.push($)}}),s}Y(r){const h={};return Promise.all(r.map(n=>this.Z(n).then(s=>{s&&(h[n]=s.item)}))).then(()=>Object.keys(h).length?this.F.$refresh(this.D,h):void 0)}Z(r){const h=this.getExtensionElement(r);if(h){const n=this.j.get(h);if(n)return this.nb(h),(0,p.$og)(()=>this.f.getTreeItem(h)).then(s=>{if(s){const $=this.eb(h,s,n.parent);return this.lb(h,$,n,n.parent),n.dispose(),$}return null})}return Promise.resolve(null)}$(r,h,n){const s=this.eb(r,h,n);if(h.id&&this.i.has(s.item.handle))throw new Error((0,w.localize)(0,null,h.id));return this.kb(r,s),this.mb(s,n),s}ab(r){return A.$5J.isMarkdownString(r)?y.MarkdownString.from(r):r}bb(r,h){return h?{...this.G.toInternal(h,r),originalId:h.command}:void 0}cb(r){if(r.checkboxState===void 0)return;let h,n,s;return typeof r.checkboxState=="number"?h=r.checkboxState:(h=r.checkboxState.state,n=r.checkboxState.tooltip,s=r.checkboxState.accessibilityInformation),{isChecked:h===A.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:s}}db(r){if(!A.$qK.isTreeItem(r,this.I))throw new Error(`Extension ${this.I.identifier.value} has provided an invalid tree item.`)}eb(r,h,n){this.db(h);const s=new g.$kb,$=this.gb(r,h,n),k=this.hb(h);return{item:{handle:$,parentHandle:n?n.item.handle:void 0,label:a(h.label,this.I),description:h.description,resourceUri:h.resourceUri,tooltip:this.ab(h.tooltip),command:this.bb(s,h.command),contextValue:h.contextValue,icon:k,iconDark:this.ib(h)||k,themeIcon:this.fb(h),collapsibleState:(0,E.$se)(h.collapsibleState)?A.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation,checkbox:this.cb(h)},extensionItem:h,parent:n,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(r){return r.iconPath instanceof A.$yK?r.iconPath:void 0}gb(r,{id:h,label:n,resourceUri:s},$,k){if(h)return`${S.b}/${h}`;const l=a(n,this.I),f=$?$.item.handle:S.a;let v=l?l.label:s?(0,C.$7f)(s):"";v=v.indexOf("/")!==-1?v.replace("/","//"):v;const u=this.j.has(r)?this.j.get(r).item.handle:void 0,d=this.R($)||[];let R,W=0;do{if(R=`${f}/${W}:${v}`,k||!this.i.has(R)||u===R)break;W++}while(W<=d.length);return R}hb(r){if(r.iconPath&&!(r.iconPath instanceof A.$yK))return typeof r.iconPath=="string"||M.URI.isUri(r.iconPath)?this.jb(r.iconPath):this.jb(r.iconPath.light)}ib(r){if(r.iconPath&&!(r.iconPath instanceof A.$yK)&&r.iconPath.dark)return this.jb(r.iconPath.dark)}jb(r){return M.URI.isUri(r)?r:M.URI.file(r)}kb(r,h){this.i.set(h.item.handle,r),this.j.set(r,h)}lb(r,h,n,s){this.i.delete(h.item.handle),this.j.delete(r),h.item.handle!==n.item.handle&&this.i.delete(n.item.handle),this.kb(r,h);const $=this.R(s)||[],k=$.filter(l=>l.item.handle===n.item.handle)[0];k&&$.splice($.indexOf(k),1,h)}mb(r,h){h?(h.children||(h.children=[]),h.children.push(r)):(this.h||(this.h=[]),this.h.push(r))}nb(r){if(r){const h=this.j.get(r);if(h){if(h.children)for(const n of h.children){const s=this.i.get(n.item.handle);s&&this.ob(s)}h.children=void 0}}else this.pb()}ob(r){const h=this.j.get(r);if(h){if(h.children)for(const n of h.children){const s=this.i.get(n.item.handle);s&&this.ob(s)}this.j.delete(r),this.i.delete(h.item.handle),h.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(r=>r.dispose()),this.j.clear()}dispose(){this.U.dispose(),this.pb(),this.F.$disposeTree(this.D)}}}),define(Ae[212],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionOptions.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveSlashCommands.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[213],Fe([1,0,166,11,29,91,73,30,21,212,176,97]),function($e,e,w,T,C,M,P,g,D,p,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KF=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=void 0;const c=g.$Tm.as(P.$Um.JSONContribution);class y{constructor(I,r,h){this.a=I,this.b=r,this.c=h}d(I,r){this.a({type:I,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(I){this.d(C.default.Error,I)}warn(I){this.d(C.default.Warning,I)}info(I){this.d(C.default.Info,I)}}e.$FF=y;class b{static a(I){const r=new D.$Il;for(let h=0,n=I.length;h<n;h++)r.add(I[h].description.identifier);return r}static compute(I,r){if(!I||!I.length)return new b(r,[]);if(!r||!r.length)return new b([],I);const h=this.a(I),n=this.a(r),s=r.filter(k=>!h.has(k.description.identifier)),$=I.filter(k=>!n.has(k.description.identifier));return new b(s,$)}constructor(I,r){this.added=I,this.removed=r}}e.$GF=b;class o{constructor(I,r){this.name=I,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(I){if(this.a!==null)throw new Error("Handler already set!");this.a=I,this.d()}acceptUsers(I){this.c=b.compute(this.b,I),this.b=I,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(I){(0,T.$Y)(I)}}}e.$HF=o;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$IF={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.$Gl},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(p.allApiProposals),markdownEnumDescriptions:Object.values(p.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$Dn}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$Dn}},extensionKind:{description:w.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)}}};class a{constructor(){this.a=new Map}registerExtensionPoint(I){if(this.a.has(I.extensionPoint))throw new Error("Duplicate extension point: "+I.extensionPoint);const r=new o(I.extensionPoint,I.defaultExtensionKind);return this.a.set(I.extensionPoint,r),I.activationEventsGenerator&&E.$kF.register(I.extensionPoint,I.activationEventsGenerator),e.$IF.properties.contributes.properties[I.extensionPoint]=I.jsonSchema,c.registerSchema(i,e.$IF),r}getExtensionPoints(){return Array.from(this.a.values())}}e.$JF=a;const m={ExtensionsRegistry:"ExtensionsRegistry"};g.$Tm.add(m.ExtensionsRegistry,new a),e.$KF=g.$Tm.as(m.ExtensionsRegistry),c.registerSchema(i,e.$IF),c.registerSchema(A.$$i,{properties:{extensionEnabledApiProposals:{description:w.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(p.allApiProposals),markdownEnumDescriptions:Object.values(p.allApiProposals)}}]}}}})}),define(Ae[214],Fe([1,0,163,12,24,213,31,5]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TF=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var p;(function(c){function y(b,o,t){if(!b)return;const i=T.$je(b.type)?b.type:void 0;if(!i||i.length===0){t.error(w.localize(3,null));return}const a=[];if(Array.isArray(b.required))for(const m of b.required)T.$je(m)&&a.push(m);return{extensionId:o.value,taskType:i,required:a,properties:b.properties?C.$Hm(b.properties):{},when:b.when?P.$vi.deserialize(b.when):void 0}}c.from=y})(p||(p={}));const A=M.$KF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(c,y)=>{for(const b of c)b.type&&y.push(`onTaskType:${b.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:D}});class E{constructor(){this.d=new g.$8c,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,b)=>{A.setHandler((o,t)=>{this.c=void 0;try{for(const i of t.removed){const a=i.value;for(const m of a)this.a&&m.type&&this.a[m.type]&&delete this.a[m.type]}for(const i of t.added){const a=i.value;for(const m of a){const S=p.from(m,i.description.identifier,i.collector);S&&(this.a[S.taskType]=S)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const b of this.all()){const o={type:"object",additionalProperties:!1};b.required.length>0&&(o.required=b.required.slice(0)),b.properties!==void 0?o.properties=C.$Hm(b.properties):o.properties=Object.create(null),o.properties.type={type:"string",enum:[b.taskType]},y.push(o)}this.c={oneOf:y}}return this.c}}e.$TF=new E}),define(Ae[215],Fe([1,0,164,12,23,24,31,214]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$4F=e.JsonSchemaVersion=e.ExecutionEngine=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$XF=e.ShellQuoting=e.$WF=e.$VF=e.$UF=void 0,e.$UF="settings",e.$VF=new P.$Oi("taskRunning",!1,w.localize(0,null)),e.$WF={value:w.localize(1,null),original:"Tasks"};var D;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.$XF="$customized",function(N){function O(ce){if(!ce)return N.Strong;switch(ce.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=O}(D||(e.ShellQuoting=D={}));var p;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(p||(e.CommandOptions=p={}));var A;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(A||(e.RevealKind=A={})),function(N){function O(ce){switch(ce.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=O}(A||(e.RevealKind=A={}));var E;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(E||(e.RevealProblemKind=E={})),function(N){function O(ce){switch(ce.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=O}(E||(e.RevealProblemKind=E={}));var c;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(c||(e.PanelKind=c={})),function(N){function O(ce){switch(ce.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=O}(c||(e.PanelKind=c={}));var y;(function(N){N.defaults={echo:!0,reveal:A.Always,revealProblems:E.Never,focus:!1,panel:c.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var b;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(b||(e.RuntimeType=b={})),function(N){function O(X){switch(X.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=O;function ce(X){switch(X){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=ce}(b||(e.RuntimeType=b={}));var o;(function(N){function O(ce){return T.$je(ce)?ce:ce.value}N.value=O})(o||(e.CommandString=o={}));var t;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function O(X){return X===N.Clean._id||X===N.Build._id||X===N.Rebuild._id||X===N.Test._id}N.is=O;function ce(X){if(X!==void 0)return T.$je(X)?O(X)?{_id:X,isDefault:!1}:void 0:X}N.from=ce})(t||(e.TaskGroup=t={}));var i;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var a;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function O(ce){switch(ce){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=O})(a||(e.TaskSourceKind=a={}));var m;(function(N){N.parallel="parallel",N.sequence="sequence"})(m||(e.DependsOrder=m={}));var S;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(S||(e.RunOnOptions=S={}));var I;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:S.default,instanceLimit:1}})(I||(e.RunOptions=I={}));class r{constructor(O,ce,X,be,Ee,Re){this._label="",this._id=O,ce&&(this._label=ce),X&&(this.type=X),this.runOptions=be,this.configurationProperties=Ee,this._source=Re}getDefinition(O){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,ce=!1){if(O===void 0)return!1;if(T.$je(O))return O===this._label||O===this.configurationProperties.identifier||ce&&O===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$YF=r;class h extends r{constructor(O,ce,X,be,Ee,Re,Z,he){super(O,X,void 0,Z,he,ce),this.command={},this._source=ce,this.hasDefinedMatchers=Re,Ee&&(this.command=Ee)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let ce;switch(this.command?this.command.runtime:void 0){case b.Shell:ce="shell";break;case b.Process:ce="process";break;case b.CustomExecution:ce="customExecution";break;case void 0:ce="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ce,_key:this._id,id:this._id}}}static is(O){return O instanceof h}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===a.User?e.$UF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let ce=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(ce+=this._source.kind);const X={type:e.$XF,folder:O,id:ce};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$7f(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new h(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$ZF=h;class n extends r{constructor(O,ce,X,be,Ee,Re,Z){super(O,X,be,Re,Z,ce),this._source=ce,this.configures=Ee}static is(O){return O instanceof n}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$7f(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===a.User?e.$UF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let ce=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(ce+=this._source.kind);const X={type:e.$XF,folder:O,id:ce};return JSON.stringify(X)}}e.$1F=n;class s extends r{constructor(O,ce,X,be,Ee,Re,Z,he,Ce){super(O,X,be,he,Ce,ce),this.defines=Ee,this.hasDefinedMatchers=Z,this.command=Re,this.icon=Ce.icon,this.hide=Ce.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof s}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new s(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$2F=s;class $ extends r{constructor(O,ce,X,be,Ee,Re){super(O,X,be,Ee,Re,ce),this._source=ce}clone(){return new $(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof $}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new $(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$3F=$;var k;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(k||(e.ExecutionEngine=k={})),function(N){N._default=N.Terminal}(k||(e.ExecutionEngine=k={}));var l;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(l||(e.JsonSchemaVersion=l={}));class f{constructor(O){this.c=new Map;for(let ce=0;ce<O.length;ce++)this.c.set(O[ce].uri.toString(),ce)}compare(O,ce){const X=O.getWorkspaceFolder(),be=ce.getWorkspaceFolder();if(X&&be){let Ee=this.c.get(X.uri.toString());Ee=Ee===void 0?0:Ee+1;let Re=this.c.get(be.uri.toString());return Re=Re===void 0?0:Re+1,Ee===Re?O._label.localeCompare(ce._label):Ee-Re}else return!X&&be?-1:X&&!be?1:0}}e.$4F=f;var v;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(v||(e.TaskEventKind=v={}));var u;(function(N){N.SingleRun="singleRun",N.Background="background"})(u||(e.TaskRunType=u={}));var d;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(d||(e.TaskRunSource=d={}));var R;(function(N){function O(ce,X,be,Ee){if(X){const Re={kind:ce,taskId:X._id,taskName:X.configurationProperties.name,runType:X.configurationProperties.isBackground?"background":"singleRun",group:X.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:be,__task:X};return ce==="start"?Re.resolvedVariables=Ee:ce==="processStarted"?Re.processId=Ee:ce==="processEnded"&&(Re.exitCode=Ee),Object.freeze(Re)}else return Object.freeze({kind:"changed"})}N.create=O})(R||(e.TaskEvent=R={}));var W;(function(N){function O(X){const be=Object.keys(X).sort();let Ee="";for(const Re of be){let Z=X[Re];Z instanceof Object?Z=O(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),Ee+=Re+","+Z+","}return Ee}function ce(X){const Ee={_key:O(X),type:X.taskType};return Object.assign(Ee,X),Ee}N.create=ce})(W||(e.KeyedTaskIdentifier=W={}));var B;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(B||(e.TaskSettingId=B={}));var q;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var U;(function(N){function O(ce,X){const be=g.$TF.get(ce.type);if(be===void 0){const he=M.$Hm(ce);return delete he._key,W.create(he)}const Ee=Object.create(null);Ee.type=be.taskType;const Re=new Set;be.required.forEach(he=>Re.add(he));const Z=be.properties;for(const he of Object.keys(Z)){const Ce=ce[he];if(Ce!=null)Ee[he]=Ce;else if(Re.has(he)){const H=Z[he];if(H.default!==void 0)Ee[he]=M.$Hm(H.default);else switch(H.type){case"boolean":Ee[he]=!1;break;case"number":case"integer":Ee[he]=0;break;case"string":Ee[he]="";break;default:X.error(w.localize(2,null,JSON.stringify(ce,void 0,0),he));return}}}return W.create(Ee)}N.createTaskIdentifier=O})(U||(e.TaskDefinition=U={}))}),define(Ae[216],Fe([1,0,11]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x1b=e.$w1b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((P,g)=>{this.b=P,this.d=g,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(P){this.f||this.h||(this.f=!0,this.g=P,this.a&&this.b(P))}resolveErr(P){this.f||this.h||(this.h=!0,this.i=P,this.a?this.d(P):(0,w.$Y)(P))}then(P,g){return this.j().then(P,g)}catch(P){return this.j().then(void 0,P)}finally(P){return this.j().finally(P)}}e.$w1b=T;class C extends T{constructor(){super(),this.h=!0,this.i=new w.$3}}e.$x1b=C}),define(Ae[46],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yz=e.$Xz=e.$Wz=e.$Vz=void 0;class w{static{this.count=0}constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++w.count}}e.$Vz=w;const T=[];function C(g){const D=new w(g);return T[D.nid]=D,D}e.$Wz=C;function M(g){return T[g].sid}e.$Xz=M;class P{constructor(D){this.value=D}}e.$Yz=P}),define(Ae[4],Fe([1,0,46]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=e.$BJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$AJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var C;(function(o){o[o.UnknownInput=0]="UnknownInput",o[o.TextInput=1]="TextInput",o[o.TextDiffInput=2]="TextDiffInput",o[o.TextMergeInput=3]="TextMergeInput",o[o.NotebookInput=4]="NotebookInput",o[o.NotebookDiffInput=5]="NotebookDiffInput",o[o.CustomEditorInput=6]="CustomEditorInput",o[o.WebviewEditorInput=7]="WebviewEditorInput",o[o.TerminalEditorInput=8]="TerminalEditorInput",o[o.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var M;(function(o){o[o.TAB_OPEN=0]="TAB_OPEN",o[o.TAB_CLOSE=1]="TAB_CLOSE",o[o.TAB_UPDATE=2]="TAB_UPDATE",o[o.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var P;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(P||(e.WebviewEditorCapabilities=P={}));var g;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(g||(e.WebviewMessageArrayBufferViewType=g={}));var D;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var p;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(p||(e.NotebookEditorRevealType=p={}));var A;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class E{static{this.a=0}static mixin(t){return t._id=E.a++,t}}e.$AJ=E;var c;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.kindModifier="m",o.commandIdent="n",o.commandId="o",o.commandArguments="p"})(c||(e.ISuggestDataDtoField=c={}));var y;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var b;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$BJ={MainThreadAuthentication:(0,w.$Wz)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$Wz)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.$Wz)("MainThreadClipboard"),MainThreadCommands:(0,w.$Wz)("MainThreadCommands"),MainThreadComments:(0,w.$Wz)("MainThreadComments"),MainThreadConfiguration:(0,w.$Wz)("MainThreadConfiguration"),MainThreadConsole:(0,w.$Wz)("MainThreadConsole"),MainThreadDebugService:(0,w.$Wz)("MainThreadDebugService"),MainThreadDecorations:(0,w.$Wz)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$Wz)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$Wz)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$Wz)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$Wz)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$Wz)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$Wz)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$Wz)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$Wz)("MainThreadErrors"),MainThreadTreeViews:(0,w.$Wz)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$Wz)("MainThreadDownloadService"),MainThreadKeytar:(0,w.$Wz)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.$Wz)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$Wz)("MainThreadLanguages"),MainThreadLogger:(0,w.$Wz)("MainThreadLogger"),MainThreadMessageService:(0,w.$Wz)("MainThreadMessageService"),MainThreadOutputService:(0,w.$Wz)("MainThreadOutputService"),MainThreadProgress:(0,w.$Wz)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$Wz)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$Wz)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$Wz)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$Wz)("MainThreadSecretState"),MainThreadStorage:(0,w.$Wz)("MainThreadStorage"),MainThreadTelemetry:(0,w.$Wz)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$Wz)("MainThreadTerminalService"),MainThreadWebviews:(0,w.$Wz)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$Wz)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$Wz)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$Wz)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$Wz)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$Wz)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$Wz)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$Wz)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$Wz)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.$Wz)("MainThreadExtensionService"),MainThreadSCM:(0,w.$Wz)("MainThreadSCM"),MainThreadSearch:(0,w.$Wz)("MainThreadSearch"),MainThreadShare:(0,w.$Wz)("MainThreadShare"),MainThreadTask:(0,w.$Wz)("MainThreadTask"),MainThreadWindow:(0,w.$Wz)("MainThreadWindow"),MainThreadLabelService:(0,w.$Wz)("MainThreadLabelService"),MainThreadNotebook:(0,w.$Wz)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$Wz)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$Wz)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$Wz)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$Wz)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$Wz)("MainThreadInteractive"),MainThreadChat:(0,w.$Wz)("MainThreadChat"),MainThreadInlineChat:(0,w.$Wz)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.$Wz)("MainThreadTheming"),MainThreadTunnelService:(0,w.$Wz)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$Wz)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$Wz)("MainThreadTimeline"),MainThreadTesting:(0,w.$Wz)("MainThreadTesting"),MainThreadLocalization:(0,w.$Wz)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,w.$Wz)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,w.$Wz)("MainThreadIssueReporter")},e.$CJ={ExtHostCommands:(0,w.$Wz)("ExtHostCommands"),ExtHostConfiguration:(0,w.$Wz)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$Wz)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$Wz)("ExtHostDebugService"),ExtHostDecorations:(0,w.$Wz)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$Wz)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$Wz)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$Wz)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$Wz)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$Wz)("ExtHostEditors"),ExtHostTreeViews:(0,w.$Wz)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$Wz)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$Wz)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$Wz)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$Wz)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$Wz)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$Wz)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$Wz)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$Wz)("ExtHostStatusBar"),ExtHostShare:(0,w.$Wz)("ExtHostShare"),ExtHostExtensionService:(0,w.$Wz)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$Wz)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$Wz)("ExtHostTerminalService"),ExtHostSCM:(0,w.$Wz)("ExtHostSCM"),ExtHostSearch:(0,w.$Wz)("ExtHostSearch"),ExtHostTask:(0,w.$Wz)("ExtHostTask"),ExtHostWorkspace:(0,w.$Wz)("ExtHostWorkspace"),ExtHostWindow:(0,w.$Wz)("ExtHostWindow"),ExtHostWebviews:(0,w.$Wz)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$Wz)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$Wz)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$Wz)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$Wz)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$Wz)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$Wz)("ExtHostProgress"),ExtHostComments:(0,w.$Wz)("ExtHostComments"),ExtHostSecretState:(0,w.$Wz)("ExtHostSecretState"),ExtHostStorage:(0,w.$Wz)("ExtHostStorage"),ExtHostUrls:(0,w.$Wz)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$Wz)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$Wz)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$Wz)("ExtHostOutputService"),ExtHosLabelService:(0,w.$Wz)("ExtHostLabelService"),ExtHostNotebook:(0,w.$Wz)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$Wz)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$Wz)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$Wz)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$Wz)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$Wz)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$Wz)("ExtHostInteractive"),ExtHostInlineChat:(0,w.$Wz)("ExtHostInlineChatShape"),ExtHostChat:(0,w.$Wz)("ExtHostChat"),ExtHostSemanticSimilarity:(0,w.$Wz)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,w.$Wz)("ExtHostTheming"),ExtHostTunnelService:(0,w.$Wz)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$Wz)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$Wz)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$Wz)("ExtHostTimeline"),ExtHostTesting:(0,w.$Wz)("ExtHostTesting"),ExtHostTelemetry:(0,w.$Wz)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$Wz)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.$Wz)("ExtHostIssueReporter")}}),define(Ae[79],Fe([1,0,3,14,4,17]),function($e,e,w,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V$b=e.$U$b=e.$T$b=void 0,e.$T$b=(0,w.$ph)("IExtHostApiDeprecationService");let P=class{constructor(D,p){this.c=p,this.a=new Set,this.b=D.getProxy(C.$BJ.MainThreadTelemetry)}report(D,p,A){const E=this.d(D,p);this.a.has(E)||(this.a.add(E),p.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:p.identifier.value,apiId:D}))}d(D,p){return`${D}-${p.identifier.value}`}};e.$U$b=P,e.$U$b=P=Ve([qe(0,M.$DL),qe(1,T.$Ri)],P),e.$V$b=Object.freeze(new class{report(g,D,p){}})}),define(Ae[217],Fe([1,0,5,4,7,21]),function($e,e,w,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=void 0;class P{constructor(p){this.b=new Map,this.c=[],this.d=new w.$8c,this.onDidChangeSessions=this.d.event,this.f=new g,this.g=new g,this.a=p.getProxy(T.$BJ.MainThreadAuthentication)}$setProviders(p){return this.c=p,Promise.resolve()}async getSession(p,A,E,c={}){const y=M.$Hl.toKey(p.identifier),b=[...E].sort().join(" ");return await this.f.getOrCreate(`${y} ${A} ${b}`,async()=>{await this.a.$ensureProvider(A);const o=p.displayName||p.name;return this.a.$getSession(A,E,y,o,c)})}async getSessions(p,A,E){const c=M.$Hl.toKey(p.identifier),y=[...E].sort().join(" ");return await this.g.getOrCreate(`${c} ${y}`,async()=>{await this.a.$ensureProvider(A);const b=p.displayName||p.name;return this.a.$getSessions(A,E,c,b)})}async removeSession(p,A){const E=this.b.get(p);return E?E.provider.removeSession(A):this.a.$removeSession(p,A)}registerAuthenticationProvider(p,A,E,c){if(this.b.get(p))throw new Error(`An authentication provider with id '${p}' is already registered.`);this.b.set(p,{label:A,provider:E,options:c??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===p)||this.c.push({id:p,label:A});const y=E.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(p,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(p,A,c?.supportsMultipleAccounts??!1),new C.$DJ(()=>{y.dispose(),this.b.delete(p);const b=this.c.findIndex(o=>o.id===p);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(p)})}$createSession(p,A,E){const c=this.b.get(p);if(c)return Promise.resolve(c.provider.createSession(A,E));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$removeSession(p,A){const E=this.b.get(p);if(E)return Promise.resolve(E.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$getSessions(p,A){const E=this.b.get(p);if(E)return Promise.resolve(E.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$onDidChangeAuthenticationSessions(p,A){return this.d.fire({provider:{id:p,label:A}}),Promise.resolve()}}e.$pac=P;class g{constructor(){this.a=new Map}getOrCreate(p,A){const E=this.a.get(p);if(E)return E;const c=A().finally(()=>this.a.delete(p));return this.a.set(p,c),c}}}),define(Ae[218],Fe([1,0,4,17,8]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vac=void 0;let M=class{constructor(g,D){this.a=g.getProxy(w.$BJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:p=>D.getDocument(p)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,D,p){const A=C.WorkspaceEdit.from(g,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,p?.isRefactoring??!1)}};e.$vac=M,e.$vac=M=Ve([qe(0,T.$DL)],M)}),define(Ae[219],Fe([1,0,16,5,67,6,59,12,146,4,8]),function($e,e,w,T,C,M,P,g,D,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=void 0;class E{static{this.a=0}constructor(b,o){this.extension=b,this.provider=o,this.handle=E.a++}}class c{static{this.a=0}constructor(b,o){this.i=o,this.b=new Map,this.d=new Map,this.e=new Map,this.g=new T.$8c,this.onDidPerformUserAction=this.g.event,this.h=b.getProxy(p.$BJ.MainThreadChat)}registerChatProvider(b,o,t){const i=new E(b,t);return this.b.set(i.handle,i),this.h.$registerChatProvider(i.handle,o),(0,M.$jb)(()=>{this.h.$unregisterChatProvider(i.handle),this.b.delete(i.handle)})}transferChatSession(b,o){const t=C.Iterable.find(this.e.keys(),i=>this.e.get(i)===b)??0;typeof t=="number"&&this.h.$transferChatSession(t,o)}addChatRequest(b){this.h.$addRequest(b)}sendInteractiveRequestToProvider(b,o){this.h.$sendRequestToProvider(b,o)}async $prepareChat(b,o,t){const i=this.b.get(b);if(!i)return;const a=await i.provider.prepareSession(o,t);if(!a)return;const m=c.a++;return this.e.set(m,a),{id:m,requesterUsername:a.requester?.name,requesterAvatarIconUri:a.requester?.icon,responderUsername:a.responder?.name,responderAvatarIconUri:a.responder?.icon,inputPlaceholder:a.inputPlaceholder}}async $resolveRequest(b,o,t,i){const a=this.b.get(b);if(!a)return;const m=this.e.get(o);if(!m||!a.provider.resolveRequest)return;const S=await a.provider.resolveRequest(m,t,i);if(S)return{message:typeof S.message=="string"?S.message:A.ChatReplyFollowup.from(S.message)}}async $provideWelcomeMessage(b,o){const t=this.b.get(b);if(!t||!t.provider.provideWelcomeMessage)return;const i=await t.provider.provideWelcomeMessage(o);if(i)return i.map(a=>typeof a=="string"?a:a.map(m=>A.ChatReplyFollowup.from(m)))}async $provideFollowups(b,o,t){const i=this.b.get(b);if(!i)return;const a=this.e.get(o);return!a||!i.provider.provideFollowups?void 0:(await i.provider.provideFollowups(a,t))?.map(S=>A.ChatFollowup.from(S))}$removeRequest(b,o,t){const i=this.b.get(b);if(!i)return;const a=this.e.get(o);a&&i.provider.removeRequest&&i.provider.removeRequest(a,t)}async $provideReply(b,o,t,i){const a=this.b.get(b);if(!a)return;const m=this.e.get(o);if(!m)return;const S={session:m,message:typeof t.message=="string"?t.message:A.ChatReplyFollowup.to(t.message)},I=P.$4c.create(!1);let r;const h={report:$=>{if(!i.isCancellationRequested)if(typeof r>"u"&&(r=I.elapsed()),"responseId"in $)this.h.$acceptResponseProgress(b,o,{requestId:$.responseId});else if("placeholder"in $&&"resolvedContent"in $){const k=Promise.all([this.h.$acceptResponseProgress(b,o,{placeholder:$.placeholder}),$.resolvedContent]);(0,w.$kg)(k,i).then(l=>{if(!l)return;const[f,v]=l;this.h.$acceptResponseProgress(b,o,v,f??void 0)})}else this.h.$acceptResponseProgress(b,o,$)}};let n;try{n=await a.provider.provideResponseWithProgress(S,h,i),n||(n={errorDetails:{message:(0,D.localize)(0,null)}})}catch($){n={errorDetails:{message:(0,D.localize)(1,null,$.message),responseIsIncomplete:!0}},this.i.error($)}try{if(m.saveState&&this.e.has(o)){const $=m.saveState();this.h.$acceptChatState(o,$)}}catch($){this.i.warn($)}const s={firstProgress:r??0,totalElapsed:I.elapsed()};return{errorDetails:n.errorDetails,timings:s}}async $provideSlashCommands(b,o,t){const i=this.b.get(b);if(!i)return;const a=this.e.get(o);return!a||!i.provider.provideSlashCommands?void 0:(await i.provider.provideSlashCommands(a,t))?.map(S=>({...S,kind:A.CompletionItemKind.from(S.kind)}))}$releaseSession(b){this.e.delete(b)}async $onDidPerformUserAction(b){this.g.fire(b)}registerSlashCommandProvider(b,o,t){const i=new E(b,t);return this.d.set(i.handle,i),this.h.$registerSlashCommandProvider(i.handle,o),(0,M.$jb)(()=>{this.h.$unregisterSlashCommandProvider(i.handle),this.d.delete(i.handle)})}async $provideProviderSlashCommands(b,o){const t=this.d.get(b);return t?(await t.provider.provideSlashCommands(o))?.map(a=>({...a,kind:A.CompletionItemKind.from(a.kind)})):void 0}async $resolveSlashCommand(b,o,t){const i=this.d.get(b);if(!i)return;const a=await i.provider.resolveSlashCommand(o,t);return(0,g.$Be)(a)}}e.$Jac=c}),define(Ae[220],Fe([1,0,4]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y$b=void 0;class T{constructor(M){const P=M.getProxy(w.$BJ.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(g){return P.$writeText(g)}})}}e.$Y$b=T}),define(Ae[32],Fe([1,0,12,7,8,24,4,18,14,69,44,274,2,6,3,17,104,25,46,41,59,53,58]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t,i,a,m,S,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=void 0;let h=class{#e;#t;#i;constructor(f,v,u){this.b=new Map,this.c=new Map,this.#e=f.getProxy(P.$BJ.MainThreadCommands),this.d=v,this.#i=u,this.#t=f.getProxy(P.$BJ.MainThreadTelemetry),this.converter=new n(this,d=>{const R=this.c.get(d);return R?.result===$.Void?R:void 0},v),this.f=[{processArgument(d){return(0,p.$Yg)(d)}},{processArgument(d){return(0,M.$Jm)(d,function(R){if(A.$Or.isIRange(R))return C.Range.to(R);if(E.$Nr.isIPosition(R))return C.Position.to(R);if(A.$Or.isIRange(R.range)&&c.URI.isUri(R.uri))return C.location.to(R);if(R instanceof i.$Jb)return R.buffer.buffer;if(!Array.isArray(R))return R})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const v=this.registerCommand(!1,f.id,async(...u)=>{const d=f.args.map((W,B)=>{if(!W.validate(u[B]))throw new Error(`Invalid argument '${W.name}' when running '${f.id}', received: ${u[B]}`);return W.convert(u[B])}),R=await this.executeCommand(f.internalId,...d);return f.result.convert(R,u,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new T.$DJ(()=>{v.dispose(),this.c.delete(f.id)})}registerCommand(f,v,u,d,R,W){if(this.d.trace("ExtHostCommands#registerCommand",v),!v.trim().length)throw new Error("invalid id");if(this.b.has(v))throw new Error(`command '${v}' already exists`);return this.b.set(v,{callback:u,thisArg:d,description:R,extension:W}),f&&this.#e.$registerCommand(v),new T.$DJ(()=>{this.b.delete(v)&&f&&this.#e.$unregisterCommand(v)})}executeCommand(f,...v){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,v,!0)}async g(f,v,u){if(this.b.has(f))return this.#e.$fireCommandActivationEvent(f),this.h(f,v,!1);{let d=!1;const R=(0,M.$Jm)(v,function(W){if(W instanceof T.$EJ)return C.Position.from(W);if(W instanceof T.$FJ)return C.Range.from(W);if(W instanceof T.$PJ)return C.location.from(W);if(T.$2K.isNotebookRange(W))return C.NotebookRange.from(W);if(W instanceof ArrayBuffer)return d=!0,i.$Jb.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return d=!0,i.$Jb.wrap(W);if(W instanceof i.$Jb)return d=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(f,d?new a.$Yz(R):R,u);return(0,p.$Yg)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(f,v,!1);throw W}}}async h(f,v,u){const d=this.b.get(f);if(!d)throw new Error("Unknown command");const{callback:R,thisArg:W,description:B}=d;if(B)for(let U=0;U<B.args.length;U++)try{(0,w.$Ae)(v[U],B.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${B.args[U].name}' - ${B.args[U].description}`)}const q=S.$4c.create();try{return await R.apply(W,v)}catch(U){if(f===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...v);N&&(f=N.command)}if(this.d.error(U,f,d.extension?.identifier),!u)throw U;if(d.extension?.identifier){const N=this.#i.onExtensionError(d.extension.identifier,U);this.d.trace("forwarded error to extension?",N,d.extension?.identifier)}throw new class extends Error{constructor(){super((0,m.$ai)(U)),this.id=f,this.source=d.extension?.displayName??d.extension?.name}}}finally{this.j(d,f,q.elapsed())}}j(f,v,u){f.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new I.$2n(v),duration:u})}$executeContributedCommand(f,...v){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const u=this.b.get(f);return u?(v=v.map(d=>this.f.reduce((R,W)=>W.processArgument(R,u.extension?.identifier),d)),this.h(f,v,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),this.#e.$getCommands().then(v=>(f&&(v=v.filter(u=>u[0]!=="_")),v))}$getContributedCommandHandlerDescriptions(){const f=Object.create(null);for(const[v,u]of this.b){const{description:d}=u;d&&(f[v]=d)}return Promise.resolve(f)}};e.$YL=h,e.$YL=h=Ve([qe(0,o.$DL),qe(1,D.$Ri),qe(2,r.$XL)],h),e.$ZL=(0,b.$ph)("IExtHostCommands");class n{constructor(f,v,u){this.d=f,this.f=v,this.g=u,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,v){if(!f)return;const u={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return u;const d=this.f(f.command);if(d)u.id=d.internalId,u.arguments=d.args.map((R,W)=>R.convert(f.arguments&&f.arguments[W]));else if((0,g.$qf)(f.arguments)){const R=`${f.command}/${++this.c}`;this.b.set(R,f),v.add((0,y.$jb)(()=>{this.b.delete(R),this.g.trace("CommandsConverter#DISPOSE",R)})),u.$ident=R,u.id=this.delegatingCommandId,u.arguments=[R],this.g.trace("CommandsConverter#CREATE",f.command,R)}return u}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const v=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],v?v.command:"MISSING"),v?this.d.executeCommand(v.command,...v.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.$1L=n;class s{static{this.Uri=new s("uri","Uri of a text document",f=>c.URI.isUri(f),f=>f)}static{this.Position=new s("position","A position in a text document",f=>T.$EJ.isPosition(f),C.Position.from)}static{this.Range=new s("range","A range in a text document",f=>T.$FJ.isRange(f),C.Range.from)}static{this.Selection=new s("selection","A selection in a text document",f=>T.$GJ.isSelection(f),C.Selection.from)}static{this.Number=new s("number","",f=>typeof f=="number",f=>f)}static{this.String=new s("string","",f=>typeof f=="string",f=>f)}static{this.CallHierarchyItem=new s("item","A call hierarchy item",f=>f instanceof T.$1J,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new s("item","A type hierarchy item",f=>f instanceof T.$jL,C.TypeHierarchyItem.from)}static{this.TestItem=new s("testItem","A VS Code TestItem",f=>f instanceof t.$QL,C.TestItem.from)}constructor(f,v,u,d){this.name=f,this.description=v,this.validate=u,this.convert=d}optional(){return new s(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,v){return new s(f??this.name,v??this.description,this.validate,this.convert)}}e.$2L=s;class ${static{this.Void=new $("no result",f=>f)}constructor(f,v){this.description=f,this.convert=v}}e.$3L=$;class k{constructor(f,v,u,d,R){this.id=f,this.internalId=v,this.description=u,this.args=d,this.result=R}}e.$4L=k}),define(Ae[221],Fe([1,0,18,13,2,77,90,31,94,32,8,7]),function($e,e,w,T,C,M,P,g,D,p,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X$b=void 0;const c=[new p.$4L("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$2L.Uri,p.$2L.Position],new p.$3L("A promise that resolves to an array of DocumentHighlight-instances.",b(A.DocumentHighlight.to))),new p.$4L("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$2L.Uri],new p.$3L("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,w.$pf)(t))return;class a extends E.$UJ{static to(S){const I=new a(S.name,A.SymbolKind.to(S.kind),S.containerName||"",new E.$PJ(i[0],A.Range.to(S.range)));return I.detail=S.detail,I.range=I.location.range,I.selectionRange=A.Range.to(S.selectionRange),I.children=S.children?S.children.map(a.to):[],I}}return t.map(a.to)})),new p.$4L("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$2L.Uri,new p.$2L("options","Formatting options",t=>!0,t=>t)],new p.$3L("A promise that resolves to an array of TextEdits.",b(A.TextEdit.to))),new p.$4L("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$2L.Uri,p.$2L.Range,new p.$2L("options","Formatting options",t=>!0,t=>t)],new p.$3L("A promise that resolves to an array of TextEdits.",b(A.TextEdit.to))),new p.$4L("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$2L.Uri,p.$2L.Position,new p.$2L("ch","Trigger character",t=>typeof t=="string",t=>t),new p.$2L("options","Formatting options",t=>!0,t=>t)],new p.$3L("A promise that resolves to an array of TextEdits.",b(A.TextEdit.to))),new p.$4L("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$2L.Uri,p.$2L.Position],new p.$3L("A promise that resolves to an array of Location or LocationLink instances.",o)),new p.$4L("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$2L.Uri,p.$2L.Position],new p.$3L("A promise that resolves to an array of Location or LocationLink instances.",o)),new p.$4L("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$2L.Uri,p.$2L.Position],new p.$3L("A promise that resolves to an array of Location or LocationLink instances.",o)),new p.$4L("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$2L.Uri,p.$2L.Position],new p.$3L("A promise that resolves to an array of Location or LocationLink instances.",o)),new p.$4L("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$2L.Uri,p.$2L.Position],new p.$3L("A promise that resolves to an array of Location-instances.",b(A.location.to))),new p.$4L("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$2L.Uri,p.$2L.Position],new p.$3L("A promise that resolves to an array of Hover-instances.",b(A.Hover.to))),new p.$4L("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$2L.Uri,new p.$2L("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>E.$EJ.isPosition(i)),t=>t.map(A.Position.from))],new p.$3L("A promise that resolves to an array of ranges.",t=>t.map(i=>{let a;for(const m of i.reverse())a=new E.$ZJ(A.Range.to(m),a);return a}))),new p.$4L("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$2L.String.with("query","Search string")],new p.$3L("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(A.WorkspaceSymbol.to))),new p.$4L("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$2L.Uri,p.$2L.Position],new p.$3L("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(A.CallHierarchyItem.to))),new p.$4L("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$2L.CallHierarchyItem],new p.$3L("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(A.CallHierarchyIncomingCall.to))),new p.$4L("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$2L.CallHierarchyItem],new p.$3L("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(A.CallHierarchyOutgoingCall.to))),new p.$4L("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$2L.Uri,p.$2L.Position],new p.$3L("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:A.Range.to(t.range),placeholder:t.text}})),new p.$4L("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$2L.Uri,p.$2L.Position,p.$2L.String.with("newName","The new symbol name")],new p.$3L("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return A.WorkspaceEdit.to(t)}})),new p.$4L("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$2L.Uri,p.$2L.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$3L("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(A.DocumentLink.to))),new p.$4L("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$2L.Uri],new p.$3L("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new E.$TK(t.tokenTypes,t.tokenModifiers)})),new p.$4L("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$2L.Uri],new p.$3L("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,P.$H8)(t);if(i.type==="full")return new E.$VK(i.data,void 0)})),new p.$4L("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$2L.Uri,p.$2L.Range.optional()],new p.$3L("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new E.$TK(t.tokenTypes,t.tokenModifiers)})),new p.$4L("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$2L.Uri,p.$2L.Range],new p.$3L("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,P.$H8)(t);if(i.type==="full")return new E.$VK(i.data,void 0)})),new p.$4L("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$2L.Uri,p.$2L.Position,p.$2L.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$2L.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$3L("A promise that resolves to a CompletionList-instance.",(t,i,a)=>{if(!t)return new E.$_J([]);const m=t.suggestions.map(S=>A.CompletionItem.to(S,a));return new E.$_J(m,t.incomplete)})),new p.$4L("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$2L.Uri,p.$2L.Position,p.$2L.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$3L("A promise that resolves to SignatureHelp.",t=>{if(t)return A.SignatureHelp.to(t)})),new p.$4L("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$2L.Uri,p.$2L.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$3L("A promise that resolves to an array of CodeLens-instances.",(t,i,a)=>b(m=>new E.$4J(A.Range.to(m.range),m.command&&a.fromInternal(m.command)))(t))),new p.$4L("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$2L.Uri,new p.$2L("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>E.$FJ.isRange(t),t=>E.$GJ.isSelection(t)?A.Selection.from(t):A.Range.from(t)),p.$2L.String.with("kind","Code action kind to return code actions for").optional(),p.$2L.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$3L("A promise that resolves to an array of Command-instances.",(t,i,a)=>b(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(m.command)}else{const S=new E.$WJ(m.title,m.kind?new E.$XJ(m.kind):void 0);return m.edit&&(S.edit=A.WorkspaceEdit.to(m.edit)),m.command&&(S.command=a.fromInternal(m.command)),S.isPreferred=m.isPreferred,S}})(t))),new p.$4L("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$2L.Uri],new p.$3L("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new E.$fK(A.Range.to(i.range),A.Color.to(i.color))):[])),new p.$4L("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$2L("color","The color to show and insert",t=>t instanceof E.$eK,A.Color.from),new p.$2L("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:A.Range.from(t.range)}))],new p.$3L("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(A.ColorPresentation.to):[])),new p.$4L("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$2L.Uri,p.$2L.Range],new p.$3L("A promise that resolves to an array of Inlay objects",(t,i,a)=>t.map(A.InlayHint.to.bind(void 0,a)))),new p.$4L("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$2L.Uri],new p.$3L("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(A.FoldingRange.to)})),new p.$4L("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$3L("A promise that resolves to an array of NotebookContentProvider static info objects.",b(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>A.NotebookExclusiveDocumentPattern.to(i))})))),new p.$4L("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$2L.Uri,p.$2L.Range],new p.$3L("A promise that resolves to an array of InlineValue objects",t=>t.map(A.InlineValue.to))),new p.$4L("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$2L("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,D.$aZ)(t,T.Schemas.http,T.Schemas.https),t=>t),new p.$2L("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional(),p.$2L.String.with("label","").optional()],p.$3L.Void),new p.$4L("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$2L.Uri.with("resource","Resource to open"),p.$2L.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new p.$2L("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional()],p.$3L.Void),new p.$4L("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$2L.Uri.with("left","Left-hand side resource of the diff editor"),p.$2L.Uri.with("right","Right-hand side resource of the diff editor"),p.$2L.String.with("title","Human readable title for the diff editor").optional(),new p.$2L("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)]).optional()],p.$3L.Void),new p.$4L("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$2L.Uri,p.$2L.Position],new p.$3L("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new p.$4L("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$2L.TypeHierarchyItem],new p.$3L("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new p.$4L("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$2L.TypeHierarchyItem],new p.$3L("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new p.$4L("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$2L.TestItem],p.$3L.Void),new p.$4L("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$2L.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$3L.Void),new p.$4L("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$2L.String.with("name","The context key name"),new p.$2L("value","The context key value",()=>!0,t=>t)],p.$3L.Void)];class y{static register(i){c.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",g.$wi)}}e.$X$b=y;function b(t){return i=>{if(Array.isArray(i))return i.map(t)}}function o(t){if(!Array.isArray(t))return;const i=[];for(const a of t)M.$qs(a)?i.push(A.DefinitionLink.to(a)):i.push(A.location.to(a));return i}}),define(Ae[222],Fe([1,0,16,65,5,6,2,77,21,8,7,4,26,12]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z$b=void 0;function b(o,t,i){const a=o.getProxy(E.$BJ.MainThreadComments);class m{static{this.a=0}constructor(){this.b=new Map,this.c=new D.$Jl,t.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const f=this.b.get(l.handle);return f?f.value:l}else if(l&&l.$mid===7){const f=this.b.get(l.commentControlHandle);if(!f)return l;const v=f.getCommentThread(l.commentThreadHandle);return v?v.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const f=this.b.get(l.thread.commentControlHandle);if(!f)return l;const v=f.getCommentThread(l.thread.commentThreadHandle);return v?l.$mid===8?v.value:{thread:v.value,text:l.text}:l}else if(l&&l.$mid===10){const f=this.b.get(l.thread.commentControlHandle);if(!f)return l;const v=f.getCommentThread(l.thread.commentThreadHandle);if(!v)return l;const u=l.commentUniqueId,d=v.getCommentByUniqueId(u);return d||l}else if(l&&l.$mid===11){const f=this.b.get(l.thread.commentControlHandle);if(!f)return l;const v=f.getCommentThread(l.thread.commentThreadHandle);if(!v)return l;const u=l.text,d=l.commentUniqueId,R=v.getCommentByUniqueId(d);return R?(typeof R.body=="string"?R.body=u:R.body=new A.$5J(u),R):l}return l}})}createCommentController(l,f,v){const u=m.a++,d=new I(l,u,f,v);this.b.set(d.handle,d);const R=this.c.get(l.identifier)||[];return R.push(d),this.c.set(l.identifier,R),d.value}$createCommentThreadTemplate(l,f,v){const u=this.b.get(l);u&&u.$createCommentThreadTemplate(f,v)}async $updateCommentThreadTemplate(l,f,v){const u=this.b.get(l);u&&u.$updateCommentThreadTemplate(f,v)}$deleteCommentThread(l,f){this.b.get(l)?.$deleteCommentThread(f)}$provideCommentingRanges(l,f,v){const u=this.b.get(l);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const d=i.getDocument(P.URI.revive(f));return(0,w.$og)(async()=>{const R=await u.commentingRangeProvider.provideCommentingRanges(d,v);let W;return Array.isArray(R)?W={ranges:R,fileComments:!1}:R?W={ranges:R.ranges||[],fileComments:R.fileComments||!1}:W=(0,y.$Be)(R),W}).then(R=>{let W;return R&&(W={ranges:R.ranges.map(B=>p.Range.from(B)),fileComments:R.fileComments}),W})}$toggleReaction(l,f,v,u,d){const R=this.b.get(l);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,w.$og)(()=>{const W=R.getCommentThread(f);if(W){const B=W.getCommentByUniqueId(u.uniqueIdInThread);if(R!==void 0&&B&&R.reactionHandler)return R.reactionHandler(B,n(d))}return Promise.resolve(void 0)})}}class S{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,f,v,u,d,R,W,B){this.m=f,this.n=v,this.o=u,this.p=d,this.q=R,this.extensionDescription=W,this.r=B,this.handle=S.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$8c,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$mb,this.l.value=new M.$kb,this.n===void 0&&(this.n=`${l}.${this.handle}`),a.$createCommentThread(f,this.handle,this.n,this.o,p.Range.from(this.p),W.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this.i.push({dispose:()=>{a.$deleteCommentThread(f,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(U){q.range=U},get comments(){return q.comments},set comments(U){q.comments=U},get collapsibleState(){return q.collapsibleState},set collapsibleState(U){q.collapsibleState=U},get canReply(){return q.canReply},set canReply(U){q.canReply=U},get contextValue(){return q.contextValue},set contextValue(U){q.contextValue=U},get label(){return q.label},set label(U){q.label=U},get state(){return q.state},set state(U){q.state=U},dispose:()=>{q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$kb);const l=v=>Object.prototype.hasOwnProperty.call(this.b,v),f={};l("range")&&(f.range=p.Range.from(this.p)),l("label")&&(f.label=this.label),l("contextValue")&&(f.contextValue=this.contextValue??null),l("comments")&&(f.comments=this.q.map(v=>r(this,v,this.k,this.extensionDescription))),l("collapsibleState")&&(f.collapseState=s(this.g)),l("canReply")&&(f.canReply=this.canReply),l("state")&&(f.state=$(this.h)),l("isTemplate")&&(f.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,f)}getCommentByUniqueId(l){for(const f of this.k){const v=f[0],u=f[1];if(l===u)return v}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Ve([(0,T.$Ug)(100)],S.prototype,"eventuallyUpdateCommentThread",null);class I{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,a.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,f,v,u){this.f=l,this.g=f,this.h=v,this.i=u,this.a=new Map,a.$registerCommentController(this.handle,v,u);const d=this;this.value=Object.freeze({id:d.id,label:d.label,get options(){return d.options},set options(R){d.options=R},get commentingRangeProvider(){return d.commentingRangeProvider},set commentingRangeProvider(R){d.commentingRangeProvider=R},get reactionHandler(){return d.reactionHandler},set reactionHandler(R){d.reactionHandler=R},createCommentThread(R,W,B){return d.createCommentThread(R,W,B).value},dispose:()=>{d.dispose()}}),this.e=[],this.e.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(l,f,v){f===void 0&&(0,c.$zF)(this.f,"fileComments");const u=new S(this.id,this.handle,void 0,l,f,v,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(l,f){const v=new S(this.id,this.handle,void 0,P.URI.revive(l),p.Range.to(f),[],this.f,!0);return v.collapsibleState=g.CommentThreadCollapsibleState.Expanded,this.a.set(v.handle,v),v}$updateCommentThreadTemplate(l,f){const v=this.a.get(l);v&&(v.range=p.Range.to(f))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function r(k,l,f,v){let u=f.get(l);return u||(u=++k.commentHandle,f.set(l,u)),l.state!==void 0&&(0,c.$zF)(v,"commentsDraftState"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:u,body:typeof l.body=="string"?l.body:p.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(d=>h(d)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function h(k){return{label:k.label,iconPath:k.iconPath?p.$CL(k.iconPath):void 0,count:k.count,hasReacted:k.authorHasReacted}}function n(k){return{label:k.label||"",count:k.count||0,iconPath:k.iconPath?P.URI.revive(k.iconPath):"",authorHasReacted:k.hasReacted||!1}}function s(k){if(k!==void 0)switch(k){case A.CommentThreadCollapsibleState.Expanded:return g.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return g.CommentThreadCollapsibleState.Collapsed}return g.CommentThreadCollapsibleState.Collapsed}function $(k){if(k!==void 0)switch(k){case A.CommentThreadState.Unresolved:return g.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return g.CommentThreadState.Resolved}return g.CommentThreadState.Unresolved}return new m}e.$Z$b=b}),define(Ae[223],Fe([1,0,24,4,27,17]),function($e,e,w,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=void 0;let P=class{constructor(A,E){this.a=A.getProxy(T.$BJ.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,E){const c=this,y=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){c.e(A,E,y,arguments)}})}e(A,E,c,y){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:D(y,this.b)}),this.c&&this.f(A,c,y)}};e.$Rac=P,e.$Rac=P=Ve([qe(0,M.$DL),qe(1,C.$TL)],P);const g=1e5;function D(p,A){const E=[];if(p.length)for(let c=0;c<p.length;c++){let y=p[c];if(typeof y>"u")y="undefined";else if(y instanceof Error){const b=y;b.stack?y=b.stack:y=b.toString()}E.push(y)}if(A){const c=new Error().stack;c&&E.push({__$stack:c.split(`
`).slice(3).join(`
`)})}try{const c=(0,w.$Mm)(E);return c.length>g?"Output omitted for a large object that exceeds the limits":c}catch(c){return`Output omitted for an object that cannot be inspected ('${c.toString()}')`}}}),define(Ae[107],Fe([1,0,2,4,7,3,17,14,18,15,19,26]),function($e,e,w,T,C,M,P,g,D,p,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2_b=e.$1_b=void 0;let c=class Yi{static{this.c=0}static{this.d=250}constructor(b,o){this.h=o,this.f=new Map,this.g=b.getProxy(T.$BJ.MainThreadDecorations)}registerFileDecorationProvider(b,o){const t=Yi.c++;this.f.set(t,{provider:b,extensionDescription:o}),this.g.$registerDecorationProvider(t,o.identifier.value);const i=b.onDidChangeFileDecorations&&b.onDidChangeFileDecorations(a=>{if(!a){this.g.$onDidChange(t,null);return}const m=(0,D.$Jf)(a);if(m.length<=Yi.d){this.g.$onDidChange(t,m);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,m.length);const S=m.map(h=>({uri:h,rank:(0,p.$pd)(h.path,"/")})),I=(0,D.$hf)(S,(h,n)=>h.rank-n.rank||(0,p.$Fd)(h.uri.path,n.uri.path)),r=[];e:for(const h of I){let n;for(const s of h){const $=(0,A.$dc)(s.uri.path);if(n!==$&&(n=$,r.push(s.uri)>=Yi.d))break e}}this.g.$onDidChange(t,r)});return new C.$DJ(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(b,o,t){if(!this.f.has(b))return Object.create(null);const i=Object.create(null),{provider:a,extensionDescription:m}=this.f.get(b);return await Promise.all(o.map(async S=>{try{const{uri:I,id:r}=S,h=await Promise.resolve(a.provideFileDecoration(w.URI.revive(I),t));if(!h)return;try{C.$ZK.validate(h),h.badge&&typeof h.badge!="string"&&(0,E.$zF)(m,"codiconDecoration"),i[r]=[h.propagate,h.tooltip,h.badge,h.color]}catch(n){this.h.warn(`INVALID decoration from extension '${m.identifier.value}': ${n}`)}}catch(I){this.h.error(I)}})),i}};e.$1_b=c,e.$1_b=c=Ve([qe(0,P.$DL),qe(1,g.$Ri)],c),e.$2_b=(0,M.$ph)("IExtHostDecorations")}),define(Ae[224],Fe([1,0,147,93,2,4,7,8,5,14,28,39]),function($e,e,w,T,C,M,P,g,D,p,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S$b=e.$R$b=void 0;class c{#e;#t;#i;constructor(o,t,i,a,m,S,I,r){this.d=o,this.e=t,this.f=i,this.g=a,this.h=m,this.c=!1,this.f=Math.max(a,i),this.#i=new A.$ni(h=>S.getComparisonKey(h)),this.#e=I,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,t){if(!o){this.clear();return}this.j();let i=[];if(C.URI.isUri(o)){if(!t){this.delete(o);return}this.#i.set(o,t.slice()),i=[o]}else if(Array.isArray(o)){i=[];let S;o=[...o].sort(c.k);for(const I of o){const[r,h]=I;if((!S||r.toString()!==S.toString())&&(S&&this.#i.get(S).length===0&&this.#i.delete(S),S=r,i.push(r),this.#i.set(r,[])),h)this.#i.get(r)?.push(...h);else{const n=this.#i.get(r);n&&(n.length=0)}}}if(this.#t.fire(i),!this.#e)return;const a=[];let m=0;for(const S of i){let I=[];const r=this.#i.get(S);if(r)if(r.length>this.g){I=[];const h=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(const s of r)if(s.severity===h[n]&&I.push({...g.Diagnostic.from(s),modelVersionId:this.h(S)})===this.g)break e;I.push({severity:T.MarkerSeverity.Info,message:(0,w.localize)(0,null,r.length-this.g),startLineNumber:I[I.length-1].startLineNumber,startColumn:I[I.length-1].startColumn,endLineNumber:I[I.length-1].endLineNumber,endColumn:I[I.length-1].endColumn})}else I=r.map(h=>({...g.Diagnostic.from(h),modelVersionId:this.h(S)}));if(a.push([S,I]),m+=I.length,m>this.f)break}this.#e.$changeMany(this.e,a)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,t){this.j();for(const[i,a]of this)o.call(t,i,a,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const t=this.#i.get(o);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,t){return o[0].toString()<t[0].toString()?-1:o[0].toString()>t[0].toString()?1:0}}e.$R$b=c;let y=class li{static{this.c=0}static{this.d=1e3}static{this.e=1.1*li.d}static _mapper(o){const t=new A.$ni;for(const i of o)t.set(i,i);return{uris:Object.freeze(Array.from(t.values()))}}constructor(o,t,i,a){this.j=t,this.k=i,this.l=a,this.g=new Map,this.h=new D.$_c({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.h.event,li._mapper),this.f=o.getProxy(M.$BJ.MainThreadDiagnostics)}createDiagnosticCollection(o,t){const{g:i,f:a,h:m,j:S,k:I,l:r}=this,h=new class{$changeMany($,k){a.$changeMany($,k),S.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,$,k.length===0?"CLEARING":k)}$clear($){a.$clear($),S.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,$)}dispose(){a.dispose()}};let n;if(!t)t="_generated_diagnostic_collection_name_#"+li.c++,n=t;else if(!i.has(t))n=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do n=t+li.c++;while(i.has(n))}return new class extends c{constructor(){super(t,n,li.e,li.d,$=>r.getDocument($)?.version,I.extUri,h,m),i.set(n,this)}dispose(){super.dispose(),i.delete(n)}}}getDiagnostics(o){if(o)return this.m(o);{const t=new Map,i=[];for(const a of this.g.values())a.forEach((m,S)=>{let I=t.get(m.toString());typeof I>"u"&&(I=i.length,t.set(m.toString(),I),i.push([m,[]])),i[I][1]=i[I][1].concat(...S)});return i}}m(o){let t=[];for(const i of this.g.values())i.has(o)&&(t=t.concat(i.get(o)));return t}$acceptMarkersChange(o){if(!this.n){const t="_generated_mirror",i=new c(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,a=>{},this.k.extUri,void 0,this.h);this.g.set(t,i),this.n=i}for(const[t,i]of o)this.n.set(C.URI.revive(t),i.map(g.Diagnostic.to))}};e.$S$b=y,e.$S$b=y=Ve([qe(1,p.$Ri),qe(2,E.$Q$b)],y)}),define(Ae[225],Fe([1,0,2,4,26]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8$b=void 0;class M{constructor(g){this.a=g.getProxy(T.$BJ.MainThreadDialogs)}showOpenDialog(g,D){return D?.allowUIResources&&(0,C.$zF)(g,"showLocal"),this.a.$showOpenDialog(D).then(p=>p?p.map(A=>w.URI.revive(A)):void 0)}showSaveDialog(g){return this.a.$showSaveDialog(g).then(D=>D?w.URI.revive(D):void 0)}}e.$8$b=M}),define(Ae[226],Fe([1,0,11,2,7,4,13,20,15]),function($e,e,w,T,C,M,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9$b=void 0;class p{static{this.a=0}constructor(E,c,y){this.d=c,this.e=y,this.b=new Map,this.c=E.getProxy(M.$BJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,c){if(Object.keys(P.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const y=p.a++;this.b.set(y,c),this.c.$registerTextContentProvider(y,E);let b;return typeof c.onDidChange=="function"&&(b=c.onDidChange(o=>{if(o.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}this.d.getDocument(o)&&this.$provideTextDocumentContent(y,o).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(o);if(!i)return;const a=(0,D.$Ad)(t);if(!i.equalLines(a))return this.c.$onVirtualDocumentChange(o,t)},w.$Y)})),new C.$DJ(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(E,c){const y=this.b.get(E);return y?Promise.resolve(y.provideTextDocumentContent(T.URI.revive(c),g.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.$9$b=p}),define(Ae[227],Fe([1,0,5,6,2,4,100,8,12,24,7,11]),function($e,e,w,T,C,M,P,g,D,p,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O$b=void 0;class c{constructor(b,o){this.a=new w.$8c({onListenerError:E.$Z}),this.b=new w.$8c({onListenerError:E.$Z}),this.c=new w.$8c({onListenerError:E.$Z}),this.d=new w.$8c({onListenerError:E.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$kb,this.h=new Map,this.f=b.getProxy(M.$BJ.MainThreadDocuments),this.g=o,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const o=this.g.getDocument(b);if(o)return o}getDocument(b){const o=this.getDocumentData(b);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return o.document}ensureDocumentData(b){const o=this.g.getDocument(b);if(o)return Promise.resolve(o);let t=this.h.get(b.toString());return t||(t=this.f.$tryOpenDocument(b).then(i=>{this.h.delete(b.toString());const a=C.URI.revive(i);return(0,D.$ue)(this.g.getDocument(a))},i=>(this.h.delete(b.toString()),Promise.reject(i))),this.h.set(b.toString(),t)),t}createDocumentData(b){return this.f.$tryCreateDocument(b).then(o=>C.URI.revive(o))}$acceptModelLanguageChanged(b,o){const t=C.URI.revive(b),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(o),this.a.fire(i.document)}$acceptModelSaved(b){const o=C.URI.revive(b),t=this.g.getDocument(o);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(b,o){const t=C.URI.revive(b),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(o),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,o,t){const i=C.URI.revive(b),a=this.g.getDocument(i);if(!a)throw new Error("unknown document");a._acceptIsDirty(t),a.onEvents(o);let m;o.isUndoing?m=A.TextDocumentChangeReason.Undo:o.isRedoing&&(m=A.TextDocumentChangeReason.Redo),this.c.fire((0,p.$Im)({document:a.document,contentChanges:o.changes.map(S=>({range:g.Range.to(S.range),rangeOffset:S.rangeOffset,rangeLength:S.rangeLength,text:S.text})),reason:m}))}setWordDefinitionFor(b,o){(0,P.$FL)(b,o)}}e.$O$b=c}),define(Ae[60],Fe([1,0,50,5,6,2,3,4,100,17,105,8,14,28,13,67,66]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$NL=void 0;class i{constructor(S){this.value=S,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let a=class{constructor(S,I){this.h=S,this.i=I,this.a=null,this.b=new Map,this.c=new y.$ni,this.d=new T.$8c,this.e=new T.$8c,this.f=new T.$8c,this.g=new T.$8c,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(S){this.acceptDocumentsAndEditorsDelta(S)}acceptDocumentsAndEditorsDelta(S){const I=[],r=[],h=[];if(S.removedDocuments)for(const n of S.removedDocuments){const s=M.URI.revive(n),$=this.c.get(s);$?.unref()&&(this.c.delete(s),I.push($.value))}if(S.addedDocuments)for(const n of S.addedDocuments){const s=M.URI.revive(n.uri);let $=this.c.get(s);if($&&s.scheme!==b.Schemas.vscodeNotebookCell&&s.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);$||($=new i(new D.$GL(this.h.getProxy(g.$BJ.MainThreadDocuments),s,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(s,$),r.push($.value)),$.ref()}if(S.removedEditors)for(const n of S.removedEditors){const s=this.b.get(n);this.b.delete(n),s&&h.push(s)}if(S.addedEditors)for(const n of S.addedEditors){const s=M.URI.revive(n.documentUri);w.ok(this.c.has(s),`document '${s}' does not exist`),w.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const $=this.c.get(s).value,k=new A.$ML(n.id,this.h.getProxy(g.$BJ.MainThreadTextEditors),this.i,new t.$T(()=>$.document),n.selections.map(E.Selection.to),n.options,n.visibleRanges.map(l=>E.Range.to(l)),typeof n.editorPosition=="number"?E.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,k)}S.newActiveEditor!==void 0&&(w.ok(S.newActiveEditor===null||this.b.has(S.newActiveEditor),`active editor '${S.newActiveEditor}' does not exist`),this.a=S.newActiveEditor),(0,C.$gb)(I),(0,C.$gb)(h),S.removedDocuments&&this.e.fire(I),S.addedDocuments&&this.d.fire(r),(S.removedEditors||S.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),S.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(S){return this.c.get(S)?.value}allDocuments(){return o.Iterable.map(this.c.values(),S=>S.value)}getEditor(S){return this.b.get(S)}activeEditor(S){if(!this.a)return;const I=this.b.get(this.a);return S?I:I?.value}allEditors(){return[...this.b.values()]}};e.$NL=a,e.$NL=a=Ve([qe(0,p.$DL),qe(1,c.$Ri)],a),e.$OL=(0,P.$ph)("IExtHostDocumentsAndEditors")}),define(Ae[61],Fe([1,0,8,4,2,5,3,7,17,12,99]),function($e,e,w,T,C,M,P,g,D,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7_b=e.$6_b=void 0,e.$6_b=(0,P.$ph)("IExtHostEditorTabs");class E{constructor(t,i,a){this.e=a,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new g.$kL(C.URI.revive(this.b.input.uri));case 2:return new g.$lL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new g.$mL(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new g.$nL(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new g.$oL(this.b.input.viewType);case 4:return new g.$pL(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new g.$qL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new g.$rL;case 9:return new g.$sL(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class c{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const a of t.tabs)a.isActive&&(this.d=a.id),this.c.push(new E(a,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return w.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(a=>a.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(a=>a.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const a=new E(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,a),t.tabDto.isActive&&(this.d=a.tabId),a}else if(t.kind===1){const a=this.c.splice(t.index,1)[0];if(!a)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return a.tabId===this.d&&(this.d=""),a}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const a=this.c.splice(t.oldIndex,1)[0];if(!a)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,a),a}const i=this.c.find(a=>a.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let y=class{constructor(t){this.b=new M.$8c,this.c=new M.$8c,this.e=[],this.a=t.getProxy(T.$BJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(a=>a.apiObject))},get activeTabGroup(){const a=t.d;return(0,p.$ue)(t.e.find(S=>S.groupId===a)?.apiObject)},close:async(a,m)=>{const S=Array.isArray(a)?a:[a];return S.length?b(S[0])?this.j(S,m):this.i(S,m):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(n=>n.groupId)),a=new Set(t.map(n=>n.groupId)),m=(0,A.$J)(i,a),S=this.e.filter(n=>m.removed.includes(n.groupId)).map(n=>n.apiObject),I=[],r=[];this.e=t.map(n=>{const s=new c(n,()=>this.d);return m.added.includes(s.groupId)?I.push(s.apiObject):r.push(s.apiObject),s});const h=(0,p.$ue)(t.find(n=>n.isActive===!0)?.groupId);h!==void 0&&this.d!==h&&(this.d=h),this.c.fire(Object.freeze({opened:I,closed:S,changed:r}))}$acceptTabGroupUpdate(t){const i=this.e.find(a=>a.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(m=>m.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const a=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[a.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[a.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[a.apiObject]}));return}}g(t){for(const i of this.e)for(const a of i.tabs)if(a.apiObject===t)return a}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const a=[];for(const m of t){const S=this.g(m);if(!S)throw new Error("Tab close: Invalid tab not found!");a.push(S.tabId)}return this.a.$closeTab(a,i)}async j(t,i){const a=[];for(const m of t){const S=this.h(m);if(!S)throw new Error("Group close: Invalid group not found!");a.push(S.groupId)}return this.a.$closeGroup(a,i)}};e.$7_b=y,e.$7_b=y=Ve([qe(0,D.$DL)],y);function b(o){return o.tabs!==void 0}}),define(Ae[228],Fe([1,0,2,4,6,7,8,275,15,25,26,49]),function($e,e,w,T,C,M,P,g,D,p,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C_b=void 0;class c{constructor(){this.a=[]}add(o){this.b=void 0,this.a.push(o)}delete(o){const t=this.a.indexOf(o);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const o=this.a.sort(),t=[];let i,a,m=14,S=14;for(const I of o){let r=i?(0,D.$Od)(i,I):0;for(r===0?a=1:a=S;r<I.length;r++)r+1===I.length?(m=S,S=9):S+=1,t.push([a,I.toUpperCase().charCodeAt(r),S]),t.push([a,I.toLowerCase().charCodeAt(r),S]),a=S;i=I,S=m}t.push([9,58,10]),t.push([10,47,12]),this.b=new g.$$W(t)}}provideDocumentLinks(o){this.c();const t=[],i=g.$_W.computeLinks({getLineContent(a){return o.lineAt(a-1).text},getLineCount(){return o.lineCount}},this.b);for(const a of i){const m=P.DocumentLink.to(a);m.target&&t.push(m)}return t}}class y{constructor(o,t){this.i=t,this.b=new c,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=o.getProxy(T.$BJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(o,t,i,a={}){if(y.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(o,"*",this.b));const m=this.h++;this.b.add(t),this.d.add(t),this.c.set(m,i);let S=2;a.isCaseSensitive&&(S+=1024),a.isReadonly&&(S+=2048),typeof i.copy=="function"&&(S+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,A.$zF)(o,"fsChunks"),S+=4);let I;a.isReadonly&&(0,E.$Mj)(a.isReadonly)&&((0,A.$zF)(o,"readonlyMessage"),I={value:a.isReadonly.value,isTrusted:a.isReadonly.isTrusted,supportThemeIcons:a.isReadonly.supportThemeIcons,supportHtml:a.isReadonly.supportHtml,baseUri:a.isReadonly.baseUri,uris:a.isReadonly.uris}),this.a.$registerFileSystemProvider(m,t,S,I).catch(h=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${t}`),console.error(h)});const r=i.onDidChangeFile(h=>{const n=[];for(const s of h){const{uri:$,type:k}=s;if($.scheme!==t)continue;let l;switch(k){case M.FileChangeType.Changed:l=0;break;case M.FileChangeType.Created:l=1;break;case M.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:$,type:l})}this.a.$onFileSystemChange(m,n)});return(0,C.$jb)(()=>{r.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(m),this.a.$unregisterProvider(m)})}static j(o){if(!o)throw new Error("MISSING provider");if(typeof o.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof o.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof o.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof o.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof o.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof o.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof o.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof o.rename!="function")throw new Error("Provider does NOT implement rename")}static k(o){const{type:t,ctime:i,mtime:a,size:m,permissions:S}=o;return{type:t,ctime:i,mtime:a,size:m,permissions:S}}$stat(o,t){return Promise.resolve(this.l(o).stat(w.URI.revive(t))).then(i=>y.k(i))}$readdir(o,t){return Promise.resolve(this.l(o).readDirectory(w.URI.revive(t)))}$readFile(o,t){return Promise.resolve(this.l(o).readFile(w.URI.revive(t))).then(i=>p.$Jb.wrap(i))}$writeFile(o,t,i,a){return Promise.resolve(this.l(o).writeFile(w.URI.revive(t),i.buffer,a))}$delete(o,t,i){return Promise.resolve(this.l(o).delete(w.URI.revive(t),i))}$rename(o,t,i,a){return Promise.resolve(this.l(o).rename(w.URI.revive(t),w.URI.revive(i),a))}$copy(o,t,i,a){const m=this.l(o);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(w.URI.revive(t),w.URI.revive(i),a))}$mkdir(o,t){return Promise.resolve(this.l(o).createDirectory(w.URI.revive(t)))}$watch(o,t,i,a){const m=this.l(o).watch(w.URI.revive(i),a);this.f.set(t,m)}$unwatch(o,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(o,t,i){const a=this.l(o);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(w.URI.revive(t),i))}$close(o,t){const i=this.l(o);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(o,t,i,a){const m=this.l(o);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const S=p.$Jb.alloc(a);return Promise.resolve(m.read(t,i,S.buffer,0,a)).then(I=>S.slice(0,I))}$write(o,t,i,a){const m=this.l(o);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(t,i,a.buffer,0,a.byteLength))}l(o){const t=this.c.get(o);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$C_b=y}),define(Ae[62],Fe([1,0,4,38,7,25,3,17,39,6,16,23,13]),function($e,e,w,T,C,M,P,g,D,p,A,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=e.$i_b=void 0;let y=class ii{constructor(o,t){this.b=new Map,this.c=new A.$Dg,this.a=o.getProxy(w.$BJ.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(a){try{let m;const S=i.b.get(a.scheme);return S?(await i.a.$ensureActivation(a.scheme),m=await S.impl.stat(a)):m=await i.a.$stat(a),{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===T.FilePermission.Readonly?1:void 0}}catch(m){ii.e(m)}},async readDirectory(a){try{const m=i.b.get(a.scheme);return m?(await i.a.$ensureActivation(a.scheme),(await m.impl.readDirectory(a)).slice()):await i.a.$readdir(a)}catch(m){return ii.e(m)}},async createDirectory(a){try{const m=i.b.get(a.scheme);return m&&!m.isReadonly?(await i.a.$ensureActivation(a.scheme),await i.d(m.impl,m.extUri,a)):await i.a.$mkdir(a)}catch(m){return ii.e(m)}},async readFile(a){try{const m=i.b.get(a.scheme);return m?(await i.a.$ensureActivation(a.scheme),(await m.impl.readFile(a)).slice()):(await i.a.$readFile(a)).buffer}catch(m){return ii.e(m)}},async writeFile(a,m){try{const S=i.b.get(a.scheme);return S&&!S.isReadonly?(await i.a.$ensureActivation(a.scheme),await i.d(S.impl,S.extUri,S.extUri.dirname(a)),await i.c.queueFor(a).queue(()=>Promise.resolve(S.impl.writeFile(a,m,{create:!0,overwrite:!0})))):await i.a.$writeFile(a,M.$Jb.wrap(m))}catch(S){return ii.e(S)}},async delete(a,m){try{const S=i.b.get(a.scheme);return S&&!S.isReadonly?(await i.a.$ensureActivation(a.scheme),await S.impl.delete(a,{recursive:!1,...m})):await i.a.$delete(a,{recursive:!1,useTrash:!1,atomic:!1,...m})}catch(S){return ii.e(S)}},async rename(a,m,S){try{return await i.a.$rename(a,m,{overwrite:!1,...S})}catch(I){return ii.e(I)}},async copy(a,m,S){try{return await i.a.$copy(a,m,{overwrite:!1,...S})}catch(I){return ii.e(I)}},isWritableFileSystem(a){const m=t.getCapabilities(a);if(typeof m=="number")return!(m&2048)}})}async d(o,t,i){const a=[];for(;!t.isEqual(i,t.dirname(i));)try{if(!((await o.stat(i)).type&T.FileType.Directory))throw C.$RK.FileExists(`Unable to create folder '${i.scheme===c.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(m){if(T.$8j(m)!==T.FileSystemProviderErrorCode.FileNotFound)throw m;a.push(t.basename(i)),i=t.dirname(i)}for(let m=a.length-1;m>=0;m--){i=t.joinPath(i,a[m]);try{await o.createDirectory(i)}catch(S){if(T.$8j(S)!==T.FileSystemProviderErrorCode.FileExists)throw S}}}static e(o){if(o instanceof C.$RK)throw o;if(o instanceof T.$4j)switch(o.code){case T.FileSystemProviderErrorCode.FileExists:throw C.$RK.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$RK.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$RK.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$RK.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$RK.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$RK.Unavailable(o.message);default:throw new C.$RK(o.message,o.name)}if(!(o instanceof Error))throw new C.$RK(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw C.$RK.Unavailable(o.message);switch(o.name){case T.FileSystemProviderErrorCode.FileExists:throw C.$RK.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$RK.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$RK.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$RK.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$RK.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$RK.Unavailable(o.message);default:throw new C.$RK(o.message,o.name)}}addFileSystemProvider(o,t,i){return this.b.set(o,{impl:t,extUri:i?.isCaseSensitive?E.$Zf:E.$2f,isReadonly:!!i?.isReadonly}),(0,p.$jb)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??E.$Zf}};e.$i_b=y,e.$i_b=y=Ve([qe(0,g.$DL),qe(1,D.$Q$b)],y),e.$j_b=(0,P.$ph)("IExtHostConsumerFileSystem")}),define(Ae[229],Fe([1,0,5,37,2,4,8,7]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D_b=void 0;class D{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(E,c,y,b,o,t,i,a){this.a=new w.$8c,this.b=new w.$8c,this.c=new w.$8c;const m=this.h(E,y,o);this.g=0,t&&(this.g+=1),i&&(this.g+=2),a&&(this.g+=4);const S=(0,T.$ej)(o),I=typeof o=="string",r=b(h=>{if(!t)for(const n of h.created){const s=C.URI.revive(n);S(s.fsPath)&&(!I||c.getWorkspaceFolder(s))&&this.a.fire(s)}if(!i)for(const n of h.changed){const s=C.URI.revive(n);S(s.fsPath)&&(!I||c.getWorkspaceFolder(s))&&this.b.fire(s)}if(!a)for(const n of h.deleted){const s=C.URI.revive(n);S(s.fsPath)&&(!I||c.getWorkspaceFolder(s))&&this.c.fire(s)}});this.d=g.$DJ.from(m,this.a,this.b,this.c,r)}h(E,c,y){const b=g.$DJ.from();if(typeof y=="string")return b;const o=E.getProxy(M.$BJ.MainThreadFileSystem);let t=!1;(y.pattern.includes(T.$aj)||y.pattern.includes(T.$bj))&&(t=!0);const i=Math.random();return o.$watch(c.identifier.value,i,y.baseUri,{recursive:t,excludes:[]}),g.$DJ.from({dispose:()=>o.$unwatch(i)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class p{constructor(E,c,y){this.j=E,this.k=c,this.l=y,this.a=new w.$8c,this.b=new w.$8c,this.c=new w.$8c,this.d=new w.$8c,this.g=new w.$0c,this.h=new w.$0c,this.i=new w.$0c,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,c,y,b,o,t){return new D(this.j,E,c,this.a.event,P.GlobPattern.from(y),b,o,t)}$onFileEvent(E){this.a.fire(E)}$onDidRunFileOperation(E,c){switch(E){case 2:this.b.fire(Object.freeze({files:c.map(y=>({oldUri:C.URI.revive(y.source),newUri:C.URI.revive(y.target)}))}));break;case 1:this.d.fire(Object.freeze({files:c.map(y=>C.URI.revive(y.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:c.map(y=>C.URI.revive(y.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,c){return(y,b,o)=>{const t=function(a){y.call(b,a)};return t.extension=E,c.event(t,void 0,o)}}async $onWillRunFileOperation(E,c,y,b){switch(E){case 2:return await this.n(this.g,{files:c.map(o=>({oldUri:C.URI.revive(o.source),newUri:C.URI.revive(o.target)}))},y,b);case 1:return await this.n(this.i,{files:c.map(o=>C.URI.revive(o.target))},y,b);case 0:case 3:return await this.n(this.h,{files:c.map(o=>C.URI.revive(o.target))},y,b)}}async n(E,c,y,b){const o=new Set,t=[];if(await E.fireAsync(c,b,async(a,m)=>{const S=Date.now(),I=await Promise.resolve(a);I instanceof g.$NJ&&(t.push([m.extension,I]),o.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-S>y&&this.k.warn("SLOW file-participant",m.extension.identifier)}),b.isCancellationRequested||t.length===0)return;const i={edits:[]};for(const[,a]of t){const{edits:m}=P.WorkspaceEdit.from(a,{getTextDocumentVersion:S=>this.l.getDocument(S)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(m)}return{edit:i,extensionNames:Array.from(o)}}}e.$D_b=p}),define(Ae[230],Fe([1,0,6,2,4,8,7,32]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kac=void 0;class D{static{this.a=0}constructor(c,y){this.extension=c,this.provider=y,this.handle=D.a++}}class p{constructor(c){this.session=c,this.responses=[]}}class A{static{this.a=0}constructor(c,y,b,o){this.f=b,this.g=o,this.b=new Map,this.d=new Map,this.e=c.getProxy(C.$BJ.MainThreadInlineChat),y.registerApiCommand(new g.$4L("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new g.$2L("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?M.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?M.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?M.Position.from(t.position):void 0}})],g.$3L.Void))}registerProvider(c,y){const b=new D(c,y);return this.b.set(b.handle,b),this.e.$registerInteractiveEditorProvider(b.handle,c.identifier.value,typeof y.handleInteractiveEditorResponseFeedback=="function"),(0,w.$jb)(()=>{this.e.$unregisterInteractiveEditorProvider(b.handle),this.b.delete(b.handle)})}async $prepareSession(c,y,b,o){const t=this.b.get(c);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(T.URI.revive(y)),a=M.Selection.to(b),m=await t.provider.prepareInteractiveEditorSession({document:i,selection:a},o);if(!m)return;if(m.wholeRange&&!m.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const S=A.a++;return this.d.set(S,new p(m)),{id:S,placeholder:m.placeholder,slashCommands:m.slashCommands?.map(I=>({command:I.command,detail:I.detail,refer:I.refer,executeImmediately:I.executeImmediately})),wholeRange:M.Range.from(m.wholeRange),message:m.message}}async $provideResponse(c,y,b,o){const t=this.b.get(c);if(!t)return;const i=this.d.get(y.id);if(!i)return;const a={session:i.session,prompt:b.prompt,selection:M.Selection.to(b.selection),wholeRange:M.Range.to(b.wholeRange),attempt:b.attempt,live:b.live};let m=!1;const S={report:h=>{if(!b.live)throw new Error("Progress reporting is only supported for live sessions");m||o.isCancellationRequested||!h.message&&!h.edits||this.e.$handleProgressChunk(b.requestId,{message:h.message,edits:h.edits?.map(M.TextEdit.from)})}},I=typeof t.provider.provideInteractiveEditorResponse2=="function"?t.provider.provideInteractiveEditorResponse2(a,S,o):t.provider.provideInteractiveEditorResponse(a,o);Promise.resolve(I).finally(()=>m=!0);const r=await I;if(r){const h=i.responses.push(r)-1,n={wholeRange:M.Range.from(r.wholeRange),placeholder:r.placeholder};if(A.h(r))return{...n,id:h,type:"message",message:M.MarkdownString.from(r.contents)};const{edits:s}=r;if(s instanceof P.$NJ)return{...n,id:h,type:"bulkEdit",edits:M.WorkspaceEdit.from(s)};if(Array.isArray(s))return{...n,id:h,type:"editorEdit",edits:s.map(M.TextEdit.from)}}}$handleFeedback(c,y,b,o){const t=this.b.get(c),i=this.d.get(y),a=i?.responses[b];if(t&&a){let m;switch(o){case 1:m=P.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:m=P.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:m=P.InteractiveEditorResponseFeedbackKind.Undone;break;case 3:m=P.InteractiveEditorResponseFeedbackKind.Accepted;break}t.provider.handleInteractiveEditorResponseFeedback?.(i.session,a,m)}}$releaseSession(c,y){const b=this.d.get(y),o=this.b.get(c);b&&o&&o.provider.releaseInteractiveEditorSession?.(b.session),this.d.delete(y)}static h(c){return typeof c=="object"&&typeof c.contents=="object"}}e.$Kac=A}),define(Ae[231],Fe([1,0,2,32]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=void 0;class C{constructor(P,g,D,p,A){this.a=g,this.b=D,this.c=p;const E=new T.$4L("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$2L("showOptions","Show Options",c=>!0,c=>c),new T.$2L("resource","Interactive resource Uri",c=>!0,c=>c),new T.$2L("controllerId","Notebook controller Id",c=>!0,c=>c),new T.$2L("title","Interactive editor title",c=>!0,c=>c)],new T.$3L("Notebook and input URI",c=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",c.notebookEditorId),c.notebookEditorId!==void 0){const y=this.a.getEditorById(c.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:w.URI.revive(c.notebookUri),inputUri:w.URI.revive(c.inputUri),notebookEditor:y.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",c.notebookUri,c.inputUri),{notebookUri:w.URI.revive(c.notebookUri),inputUri:w.URI.revive(c.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(P,g,D,p){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:g,lines:[""],languageId:D,uri:P,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(w.URI.revive(p))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,g){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.$Gac=C}),define(Ae[232],Fe([1,0,4,7]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nac=void 0;class C{constructor(P){this.a=new Map,this.b=P.getProxy(w.$BJ.MainThreadIssueReporter)}async $getIssueReporterUri(P,g){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(P);if(!D)throw new Error("Issue request handler not found");const p=await D.handleIssueUrlRequest();if(!p)throw new Error("Issue request handler returned no result");return p}registerIssueUriRequestHandler(P,g){const D=P.identifier.value;return this.a.set(D,g),this.b.$registerIssueUriRequestHandler(D),new T.$DJ(()=>{this.b.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}}e.$Nac=C}),define(Ae[233],Fe([1,0,6,4]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z_b=void 0;class C{constructor(P){this.b=0,this.a=P.getProxy(T.$BJ.MainThreadLabelService)}$registerResourceLabelFormatter(P){const g=this.b++;return this.a.$registerResourceLabelFormatter(g,P),(0,w.$jb)(()=>{this.a.$unregisterResourceLabelFormatter(g)})}}e.$Z_b=C}),define(Ae[234],Fe([1,0,2,24,8,7,77,4,15,44,18,12,276,20,21,6,90,87,55,59,11,16,26,149]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t,i,a,m,S,I,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W$b=void 0;class n{constructor(F,V){this.d=F,this.e=V}async provideDocumentSymbols(F,V){const J=this.d.getDocument(F),K=await this.e.provideDocumentSymbols(J,V);if(!(0,A.$pf)(K))return K[0]instanceof M.$VJ?K.map(C.DocumentSymbol.from):n.f(K)}static f(F){F=F.slice(0).sort((K,ae)=>{let G=K.location.range.start.compareTo(ae.location.range.start);return G===0&&(G=ae.location.range.end.compareTo(K.location.range.end)),G});const V=[],J=[];for(const K of F){const ae={name:K.name||"!!MISSING: name!!",kind:C.SymbolKind.from(K.kind),tags:K.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:C.Range.from(K.location.range),selectionRange:C.Range.from(K.location.range),children:[]};for(;;){if(J.length===0){J.push(ae),V.push(ae);break}const G=J[J.length-1];if(p.$Or.containsRange(G.range,ae.range)&&!p.$Or.equalsRange(G.range,ae.range)){G.children?.push(ae),J.push(ae);break}J.pop()}}return V}}class s{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(F,V,J){this.g=F,this.h=V,this.j=J,this.e=new a.$N$b("CodeLens"),this.f=new Map}async provideCodeLenses(F,V){const J=this.g.getDocument(F),K=await this.j.provideCodeLenses(J,V);if(!K||V.isCancellationRequested)return;const ae=this.e.add(K),G=new o.$kb;this.f.set(ae,G);const ue={cacheId:ae,lenses:[]};for(let me=0;me<K.length;me++)ue.lenses.push({cacheId:[ae,me],range:C.Range.from(K[me].range),command:this.h.toInternal(K[me].command,G)});return ue}async resolveCodeLens(F,V){const J=F.cacheId&&this.e.get(...F.cacheId);if(!J)return;let K;if(typeof this.j.resolveCodeLens!="function"||J.isResolved?K=J:K=await this.j.resolveCodeLens(J,V),K||(K=J),V.isCancellationRequested)return;const ae=F.cacheId&&this.f.get(F.cacheId[0]);if(ae)return F.command=this.h.toInternal(K.command??s.d,ae),F}releaseCodeLenses(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}}function $(le){return Array.isArray(le)?le.map(C.DefinitionLink.from):le?[C.DefinitionLink.from(le)]:[]}class k{constructor(F,V){this.d=F,this.e=V}async provideDefinition(F,V,J){const K=this.d.getDocument(F),ae=C.Position.to(V),G=await this.e.provideDefinition(K,ae,J);return $(G)}}class l{constructor(F,V){this.d=F,this.e=V}async provideDeclaration(F,V,J){const K=this.d.getDocument(F),ae=C.Position.to(V),G=await this.e.provideDeclaration(K,ae,J);return $(G)}}class f{constructor(F,V){this.d=F,this.e=V}async provideImplementation(F,V,J){const K=this.d.getDocument(F),ae=C.Position.to(V),G=await this.e.provideImplementation(K,ae,J);return $(G)}}class v{constructor(F,V){this.d=F,this.e=V}async provideTypeDefinition(F,V,J){const K=this.d.getDocument(F),ae=C.Position.to(V),G=await this.e.provideTypeDefinition(K,ae,J);return $(G)}}class u{constructor(F,V){this.d=F,this.e=V}async provideHover(F,V,J){const K=this.d.getDocument(F),ae=C.Position.to(V),G=await this.e.provideHover(K,ae,J);if(!(!G||(0,A.$pf)(G.contents)))return G.range||(G.range=K.getWordRangeAtPosition(ae)),G.range||(G.range=new M.$FJ(ae,ae)),C.Hover.from(G)}}class d{constructor(F,V){this.d=F,this.e=V}async provideEvaluatableExpression(F,V,J){const K=this.d.getDocument(F),ae=C.Position.to(V),G=await this.e.provideEvaluatableExpression(K,ae,J);if(G)return C.EvaluatableExpression.from(G)}}class R{constructor(F,V){this.d=F,this.e=V}async provideInlineValues(F,V,J,K){const ae=this.d.getDocument(F),G=await this.e.provideInlineValues(ae,C.Range.to(V),C.InlineValueContext.to(J),K);if(Array.isArray(G))return G.map(ue=>C.InlineValue.from(ue))}}class W{constructor(F,V){this.d=F,this.e=V}async provideDocumentHighlights(F,V,J){const K=this.d.getDocument(F),ae=C.Position.to(V),G=await this.e.provideDocumentHighlights(K,ae,J);if(Array.isArray(G))return G.map(C.DocumentHighlight.from)}}class B{constructor(F,V){this.d=F,this.e=V}async provideLinkedEditingRanges(F,V,J){const K=this.d.getDocument(F),ae=C.Position.to(V),G=await this.e.provideLinkedEditingRanges(K,ae,J);if(G&&Array.isArray(G.ranges))return{ranges:(0,A.$mf)(G.ranges.map(C.Range.from)),wordPattern:G.wordPattern}}}class q{constructor(F,V){this.d=F,this.e=V}async provideReferences(F,V,J,K){const ae=this.d.getDocument(F),G=C.Position.to(V),ue=await this.e.provideReferences(ae,G,J,K);if(Array.isArray(ue))return ue.map(C.location.from)}}class U{static{this.d=1e3}constructor(F,V,J,K,ae,G,ue){this.h=F,this.j=V,this.k=J,this.l=K,this.m=ae,this.n=G,this.o=ue,this.e=new a.$N$b("CodeAction"),this.f=new Map,this.g=new M.$XJ("notebook")}async provideCodeActions(F,V,J,K){const ae=this.h.getDocument(F),G=c.$Wr.isISelection(V)?C.Selection.to(V):C.Range.to(V),ue=[];for(const Xe of this.k.getDiagnostics(F))if(G.intersection(Xe.range)&&ue.push(Xe)>U.d)break;const me={diagnostics:ue,only:J.only?new M.$XJ(J.only):void 0,triggerKind:C.CodeActionTriggerKind.to(J.trigger)},Ne=await this.l.provideCodeActions(ae,G,me,K);if(!(0,A.$qf)(Ne)||K.isCancellationRequested)return;const Be=this.e.add(Ne),Ye=new o.$kb;this.f.set(Be,Ye);const Ke=[];for(let Xe=0;Xe<Ne.length;Xe++){const Ge=Ne[Xe];if(Ge)if(U.p(Ge))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:Ge.title,command:this.j.toInternal(Ge,Ye)});else{if(me.triggerKind!==M.CodeActionTriggerKind.Invoke&&Ge.kind&&this.g.contains(Ge.kind))continue;me.only&&(Ge.kind?me.only.contains(Ge.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${me.only.value} 'requested but returned code action is of kind '${Ge.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[Be,Xe],title:Ge.title,command:Ge.command&&this.j.toInternal(Ge.command,Ye),diagnostics:Ge.diagnostics&&Ge.diagnostics.map(C.Diagnostic.from),edit:Ge.edit&&C.WorkspaceEdit.from(Ge.edit,void 0),kind:Ge.kind&&Ge.kind.value,isPreferred:Ge.isPreferred,disabled:Ge.disabled?.reason})}}return{cacheId:Be,actions:Ke}}async resolveCodeAction(F,V){const[J,K]=F,ae=this.e.get(J,K);if(!ae||U.p(ae))return{};if(!this.l.resolveCodeAction)return{};const G=await this.l.resolveCodeAction(ae,V)??ae;let ue;G.edit&&(ue=C.WorkspaceEdit.from(G.edit,void 0));let me;if(G.command){const Ne=this.f.get(J);Ne&&(me=this.j.toInternal(G.command,Ne))}return{edit:ue,command:me}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static p(F){return typeof F.command=="string"&&typeof F.title=="string"}}class N{constructor(F,V,J,K,ae){this.d=F,this.e=V,this.f=J,this.g=K,this.h=ae}async prepareDocumentPaste(F,V,J,K){if(!this.f.prepareDocumentPaste)return;const ae=this.e.getDocument(F),G=V.map(Ne=>C.Range.to(Ne)),ue=C.DataTransfer.toDataTransfer(J,()=>{throw new S.$0});if(await this.f.prepareDocumentPaste(ae,G,ue,K),K.isCancellationRequested)return;const me=Array.from(ue).filter(([,Ne])=>!(Ne instanceof M.$sK));return C.DataTransfer.from(me)}async providePasteEdits(F,V,J,K,ae){if(!this.f.provideDocumentPasteEdits)return;const G=this.e.getDocument(V),ue=J.map(Be=>C.Range.to(Be)),me=C.DataTransfer.toDataTransfer(K,async Be=>(await this.d.$resolvePasteFileData(this.g,F,Be)).buffer),Ne=await this.f.provideDocumentPasteEdits(G,ue,me,ae);if(Ne)return{id:Ne.id?this.h.identifier.value+"."+Ne.id:this.h.identifier.value,label:Ne.label??(0,h.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,priority:Ne.priority??0,insertText:typeof Ne.insertText=="string"?Ne.insertText:{snippet:Ne.insertText.value},additionalEdit:Ne.additionalEdit?C.WorkspaceEdit.from(Ne.additionalEdit,void 0):void 0}}}class O{constructor(F,V){this.d=F,this.e=V}async provideDocumentFormattingEdits(F,V,J){const K=this.d.getDocument(F),ae=await this.e.provideDocumentFormattingEdits(K,V,J);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}}class ce{constructor(F,V){this.d=F,this.e=V}async provideDocumentRangeFormattingEdits(F,V,J,K){const ae=this.d.getDocument(F),G=C.Range.to(V),ue=await this.e.provideDocumentRangeFormattingEdits(ae,G,J,K);if(Array.isArray(ue))return ue.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,V,J,K){(0,E.$te)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ae=this.d.getDocument(F),G=V.map(C.Range.to),ue=await this.e.provideDocumentRangesFormattingEdits(ae,G,J,K);if(Array.isArray(ue))return ue.map(C.TextEdit.from)}}class X{constructor(F,V){this.d=F,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,V,J,K,ae){const G=this.d.getDocument(F),ue=C.Position.to(V),me=await this.e.provideOnTypeFormattingEdits(G,ue,J,K,ae);if(Array.isArray(me))return me.map(C.TextEdit.from)}}class be{constructor(F,V){this.e=F,this.f=V,this.d=new a.$N$b("WorkspaceSymbols")}async provideWorkspaceSymbols(F,V){const J=await this.e.provideWorkspaceSymbols(F,V);if(!(0,A.$qf)(J))return{symbols:[]};const K=this.d.add(J),ae={cacheId:K,symbols:[]};for(let G=0;G<J.length;G++){const ue=J[G];if(!ue||!ue.name){this.f.warn("INVALID SymbolInformation",ue);continue}ae.symbols.push({...C.WorkspaceSymbol.from(ue),cacheId:[K,G]})}return ae}async resolveWorkspaceSymbol(F,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const J=this.d.get(...F.cacheId);if(J){const K=await this.e.resolveWorkspaceSymbol(J,V);return K&&(0,T.$Km)(F,C.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class Ee{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,V,J){this.d=F,this.e=V,this.f=J}async provideRenameEdits(F,V,J,K){const ae=this.d.getDocument(F),G=C.Position.to(V);try{const ue=await this.e.provideRenameEdits(ae,G,J,K);return ue?C.WorkspaceEdit.from(ue):void 0}catch(ue){const me=Ee.g(ue);return me?{rejectReason:me,edits:void 0}:Promise.reject(ue)}}async resolveRenameLocation(F,V,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const K=this.d.getDocument(F),ae=C.Position.to(V);try{const G=await this.e.prepareRename(K,ae,J);let ue,me;if(M.$FJ.isRange(G)?(ue=G,me=K.getText(G)):(0,E.$le)(G)&&(ue=G.range,me=G.placeholder),!ue||!me)return;if(ue.start.line>ae.line||ue.end.line<ae.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ue),text:me}}catch(G){const ue=Ee.g(G);return ue?{rejectReason:ue,range:void 0,text:void 0}:Promise.reject(G)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class Re{constructor(F,V){this.resultId=F,this.tokens=V}}class Z{constructor(F,V){this.f=F,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,V,J){const K=this.f.getDocument(F),ae=V!==0?this.d.get(V):null;let G=typeof ae?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(K,ae.resultId,J):await this.g.provideDocumentSemanticTokens(K,J);return ae&&this.d.delete(V),G?(G=Z.h(G),this.o(Z.n(ae,G),G)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return Z.j(F)?Z.k(F)?F:new M.$VK(new Uint32Array(F.data),F.resultId):Z.l(F)?Z.m(F)?F:new M.$XK(F.edits.map(V=>new M.$WK(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const V of F.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(F,V){if(!Z.j(V)||!F||!F.tokens)return V;const J=F.tokens,K=J.length,ae=V.data,G=ae.length;let ue=0;const me=Math.min(K,G);for(;ue<me&&J[ue]===ae[ue];)ue++;if(ue===K&&ue===G)return new M.$XK([],V.resultId);let Ne=0;const Be=me-ue;for(;Ne<Be&&J[K-Ne-1]===ae[G-Ne-1];)Ne++;return new M.$XK([{start:ue,deleteCount:K-ue-Ne,data:ae.subarray(ue,G-Ne)}],V.resultId)}o(F,V){if(Z.j(F)){const J=this.e++;return this.d.set(J,new Re(F.resultId,F.data)),(0,t.$G8)({id:J,type:"full",data:F.data})}if(Z.l(F)){const J=this.e++;return Z.j(V)?this.d.set(J,new Re(V.resultId,V.data)):this.d.set(J,new Re(F.resultId)),(0,t.$G8)({id:J,type:"delta",deltas:(F.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class he{constructor(F,V){this.d=F,this.e=V}async provideDocumentRangeSemanticTokens(F,V,J){const K=this.d.getDocument(F),ae=await this.e.provideDocumentRangeSemanticTokens(K,C.Range.to(V),J);return ae?this.f(ae):null}f(F){return(0,t.$G8)({id:0,type:"full",data:F.data})}}class Ce{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,V,J,K,ae){this.f=F,this.g=V,this.h=J,this.j=K,this.k=ae,this.d=new a.$N$b("CompletionItem"),this.e=new Map}async provideCompletionItems(F,V,J,K){const ae=this.f.getDocument(F),G=C.Position.to(V),ue=ae.getWordRangeAtPosition(G)||new M.$FJ(G,G),me=ue.with({end:G}),Ne=new m.$4c,Be=await this.h.provideCompletionItems(ae,G,K,C.CompletionContext.to(J));if(!Be||K.isCancellationRequested)return;const Ye=Array.isArray(Be)?new M.$_J(Be):Be,Ke=Ce.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),Xe=new o.$kb;this.e.set(Ke,Xe);const Ge=[],ct={x:Ke,b:Ge,a:{replace:C.Range.from(ue),insert:C.Range.from(me)},c:Ye.isIncomplete||void 0,d:Ne.elapsed()};for(let xe=0;xe<Ye.items.length;xe++){const tt=Ye.items[xe],Oe=this.l(tt,[Ke,xe],me,ue);Ge.push(Oe)}return ct}async resolveCompletionItem(F,V){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...F);if(!J)return;const K=this.l(J,F),ae=await this.h.resolveCompletionItem(J,V);if(!ae)return;const G=this.l(ae,F);return(K.h!==G.h||K.i!==G.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(K.n!==G.n||K.o!==G.o||!(0,T.$Lm)(K.p,G.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...K,d:G.d,c:G.c,l:G.l,h:G.h,i:G.i,n:G.n,o:G.o,p:G.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,V,J,K){const ae=this.e.get(V[0]);if(!ae)throw Error("DisposableStore is missing...");const G=this.g.toInternal(F.command,ae),ue={x:V,a:F.label,b:F.kind!==void 0?C.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(C.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:C.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(C.TextEdit.from),n:G?.$ident,o:G?.id,p:G?.$ident?void 0:G?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ue.h=F.textEdit.newText):typeof F.insertText=="string"?ue.h=F.insertText:F.insertText instanceof M.$OJ&&(ue.h=F.insertText.value,ue.i|=4);let me;return F.textEdit?me=F.textEdit.range:F.range&&(me=F.range),M.$FJ.isRange(me)?ue.j=C.Range.from(me):me&&(!J?.isEqual(me.inserting)||!K?.isEqual(me.replacing))&&(ue.j={insert:C.Range.from(me.inserting),replace:C.Range.from(me.replacing)}),ue}}class H{async provideInlineCompletions(F,V,J,K){}disposeCompletions(F){}handleDidShowCompletionItem(F,V,J){}handlePartialAccept(F,V,J){}}class ne extends H{constructor(F,V,J,K){super(),this.f=F,this.g=V,this.h=J,this.j=K,this.d=new re,this.e=(0,r.$yF)(this.f,"inlineCompletionsAdditions"),this.k={[P.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[P.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$yF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,V,J,K){const ae=this.g.getDocument(F),G=C.Position.to(V),ue=await this.h.provideInlineCompletionItems(ae,G,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:C.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},K);if(!ue||K.isCancellationRequested)return;const me=Array.isArray(ue)?ue:ue.items,Ne=this.e?Array.isArray(ue)?[]:ue.commands||[]:[],Be=this.e&&!Array.isArray(ue)?ue.suppressSuggestions:void 0,Ye=this.e&&!Array.isArray(ue)?ue.enableForwardStability:void 0;let Ke;return{pid:this.d.createReferenceId({dispose(){Ke?.dispose()},items:me}),items:me.map((Ge,ct)=>{let xe;Ge.command&&(Ke||(Ke=new o.$kb),xe=this.j.toInternal(Ge.command,Ke));const tt=Ge.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ge.filterText,range:Ge.range?C.Range.from(Ge.range):void 0,command:xe,idx:ct,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:Ne.map(Ge=>(Ke||(Ke=new o.$kb),this.j.toInternal(Ge,Ke))),suppressSuggestions:Be,enableForwardStability:Ye}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,V,J){const K=this.d.get(F)?.items[V];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K,J)}handlePartialAccept(F,V,J){const K=this.d.get(F)?.items[V];K&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(K,J)}}class re{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const V=this.e++;return this.d.set(V,F),V}disposeReferenceId(F){const V=this.d.get(F);return this.d.delete(F),V}get(F){return this.d.get(F)}}class L{constructor(F,V){this.e=F,this.f=V,this.d=new a.$N$b("SignatureHelp")}async provideSignatureHelp(F,V,J,K){const ae=this.e.getDocument(F),G=C.Position.to(V),ue=this.g(J),me=await this.f.provideSignatureHelp(ae,G,K,ue);if(me){const Ne=this.d.add([me]);return{...C.SignatureHelp.from(me),id:Ne}}}g(F){let V;if(F.activeSignatureHelp){const J=C.SignatureHelp.to(F.activeSignatureHelp),K=this.d.get(F.activeSignatureHelp.id,0);K?(V=K,V.activeSignature=J.activeSignature,V.activeParameter=J.activeParameter):V=J}return{...F,activeSignatureHelp:V}}releaseSignatureHelp(F){this.d.delete(F)}}class _{constructor(F,V,J,K,ae){this.f=F,this.g=V,this.h=J,this.j=K,this.k=ae,this.d=new a.$N$b("InlayHints"),this.e=new Map}async provideInlayHints(F,V,J){const K=this.f.getDocument(F),ae=C.Range.to(V),G=await this.h.provideInlayHints(K,ae,J);if(!Array.isArray(G)||G.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${V}`);return}if(J.isCancellationRequested)return;const ue=this.d.add(G);this.e.set(ue,new o.$kb);const me={hints:[],cacheId:ue};for(let Ne=0;Ne<G.length;Ne++)this.l(G[Ne],ae)&&me.hints.push(this.m(G[Ne],[ue,Ne]));return this.j.trace(`[InlayHints] ${me.hints.length} inlay hints from '${this.k.identifier.value}' for ${V}`),me}async resolveInlayHint(F,V){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...F);if(!J)return;const K=await this.h.resolveInlayHint(J,V);if(K&&this.l(K))return this.m(K,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,V){return F.label.length===0||Array.isArray(F.label)&&F.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(V&&!V.contains(F.position))}m(F,V){const J=this.e.get(V[0]);if(!J)throw Error("DisposableStore is missing...");const K={label:"",cacheId:V,tooltip:C.MarkdownString.fromStrict(F.tooltip),position:C.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(C.TextEdit.from),kind:F.kind&&C.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?K.label=F.label:K.label=F.label.map(ae=>{const G={label:ae.value};return G.tooltip=C.MarkdownString.fromStrict(ae.tooltip),M.$PJ.isLocation(ae.location)&&(G.location=C.location.from(ae.location)),ae.command&&(G.command=this.g.toInternal(ae.command,J)),G}),K}}class pe{constructor(F,V){this.e=F,this.f=V,this.d=new a.$N$b("DocumentLink")}async provideLinks(F,V){const J=this.e.getDocument(F),K=await this.f.provideDocumentLinks(J,V);if(!(!Array.isArray(K)||K.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:K.filter(pe.g).map(C.DocumentLink.from)};{const ae=this.d.add(K),G={links:[],cacheId:ae};for(let ue=0;ue<K.length;ue++){if(!pe.g(K[ue]))continue;const me=C.DocumentLink.from(K[ue]);me.cacheId=[ae,ue],G.links.push(me)}return G}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,V){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...F);if(!J)return;const K=await this.f.resolveDocumentLink(J,V);if(!(!K||!pe.g(K)))return C.DocumentLink.from(K)}releaseLinks(F){this.d.delete(F)}}class Ie{constructor(F,V){this.d=F,this.e=V}async provideColors(F,V){const J=this.d.getDocument(F),K=await this.e.provideDocumentColors(J,V);return Array.isArray(K)?K.map(G=>({color:C.Color.from(G.color),range:C.Range.from(G.range)})):[]}async provideColorPresentations(F,V,J){const K=this.d.getDocument(F),ae=C.Range.to(V.range),G=C.Color.to(V.color),ue=await this.e.provideColorPresentations(G,{document:K,range:ae},J);if(Array.isArray(ue))return ue.map(C.ColorPresentation.from)}}class De{constructor(F,V){this.d=F,this.e=V}async provideFoldingRanges(F,V,J){const K=this.d.getDocument(F),ae=await this.e.provideFoldingRanges(K,V,J);if(Array.isArray(ae))return ae.map(C.FoldingRange.from)}}class ye{constructor(F,V,J){this.d=F,this.e=V,this.f=J}async provideSelectionRanges(F,V,J){const K=this.d.getDocument(F),ae=V.map(C.Position.to),G=await this.e.provideSelectionRanges(K,ae,J);if(!(0,A.$qf)(G))return[];if(G.length!==ae.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ue=[];for(let me=0;me<ae.length;me++){const Ne=[];ue.push(Ne);let Be=ae[me],Ye=G[me];for(;;){if(!Ye.range.contains(Be))throw new Error("INVALID selection range, must contain the previous range");if(Ne.push(C.SelectionRange.from(Ye)),!Ye.parent)break;Be=Ye.range,Ye=Ye.parent}}return ue}}class Se{constructor(F,V){this.f=F,this.g=V,this.d=new i.$IL(""),this.e=new Map}async prepareSession(F,V,J){const K=this.f.getDocument(F),ae=C.Position.to(V),G=await this.g.prepareCallHierarchy(K,ae,J);if(!G)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(G)?G.map(me=>this.h(ue,me)):[this.h(ue,G)]}async provideCallsTo(F,V,J){const K=this.j(F,V);if(!K)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyIncomingCalls(K,J);if(ae)return ae.map(G=>({from:this.h(F,G.from),fromRanges:G.fromRanges.map(ue=>C.Range.from(ue))}))}async provideCallsFrom(F,V,J){const K=this.j(F,V);if(!K)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyOutgoingCalls(K,J);if(ae)return ae.map(G=>({to:this.h(F,G.to),fromRanges:G.fromRanges.map(ue=>C.Range.from(ue))}))}releaseSession(F){this.e.delete(F)}h(F,V){const J=this.e.get(F),K=C.CallHierarchyItem.from(V,F,J.size.toString(36));return J.set(K._itemId,V),K}j(F,V){return this.e.get(F)?.get(V)}}class oe{constructor(F,V){this.f=F,this.g=V,this.d=new i.$IL(""),this.e=new Map}async prepareSession(F,V,J){const K=this.f.getDocument(F),ae=C.Position.to(V),G=await this.g.prepareTypeHierarchy(K,ae,J);if(!G)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(G)?G.map(me=>this.h(ue,me)):[this.h(ue,G)]}async provideSupertypes(F,V,J){const K=this.j(F,V);if(!K)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySupertypes(K,J);if(ae)return ae.map(G=>this.h(F,G))}async provideSubtypes(F,V,J){const K=this.j(F,V);if(!K)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySubtypes(K,J);if(ae)return ae.map(G=>this.h(F,G))}releaseSession(F){this.e.delete(F)}h(F,V){const J=this.e.get(F),K=C.TypeHierarchyItem.from(V,F,J.size.toString(36));return J.set(K._itemId,V),K}j(F,V){return this.e.get(F)?.get(V)}}class de{constructor(F,V,J,K,ae){this.d=F,this.e=V,this.f=J,this.g=K,this.h=ae}async provideDocumentOnDropEdits(F,V,J,K,ae){const G=this.e.getDocument(V),ue=C.Position.to(J),me=C.DataTransfer.toDataTransfer(K,async Be=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Be)).buffer),Ne=await this.f.provideDocumentDropEdits(G,ue,me,ae);if(Ne)return{id:Ne.id?this.h.identifier.value+"."+Ne.id:this.h.identifier.value,label:Ne.label??(0,h.localize)(1,null,this.h.displayName||this.h.name),priority:Ne.priority??0,insertText:typeof Ne.insertText=="string"?Ne.insertText:{snippet:Ne.insertText.value},additionalEdit:Ne.additionalEdit?C.WorkspaceEdit.from(Ne.additionalEdit,void 0):void 0}}}class ee{constructor(F,V){this.adapter=F,this.extension=V}}class ie{static{this.d=0}constructor(F,V,J,K,ae,G,ue,me){this.g=V,this.h=J,this.j=K,this.k=ae,this.l=G,this.m=ue,this.n=me,this.f=new Map,this.e=F.getProxy(g.$BJ.MainThreadLanguageFeatures)}o(F,V){return C.DocumentSelector.from(F,this.g,V)}p(F){return new M.$DJ(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return ie.d++}async s(F,V,J,K,ae,G=!1){const ue=this.f.get(F);if(!ue||!(ue.adapter instanceof V))return K;const me=Date.now();G||this.l.trace(`[${ue.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Ne=J(ue.adapter,ue.extension);return Promise.resolve(Ne).catch(Be=>{(0,S.$2)(Be)||(this.l.error(`[${ue.extension.identifier.value}] provider FAILED`),this.l.error(Be),this.n.onExtensionError(ue.extension.identifier,Be))}).finally(()=>{G||this.l.trace(`[${ue.extension.identifier.value}] provider DONE after ${Date.now()-me}ms`)}),y.CancellationToken.isCancellationToken(ae)?(0,I.$lg)(Ne,ae):Ne}t(F,V){const J=this.q();return this.f.set(J,new ee(F,V)),J}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,V,J,K){const ae=this.t(new n(this.h,J),F),G=K&&K.label||ie.u(F);return this.e.$registerDocumentSymbolProvider(ae,this.o(V,F),G),this.p(ae)}$provideDocumentSymbols(F,V,J){return this.s(F,n,K=>K.provideDocumentSymbols(w.URI.revive(V),J),void 0,J)}registerCodeLensProvider(F,V,J){const K=this.q(),ae=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(K,new ee(new s(this.h,this.j.converter,J),F)),this.e.$registerCodeLensSupport(K,this.o(V,F),ae);let G=this.p(K);if(ae!==void 0){const ue=J.onDidChangeCodeLenses(me=>this.e.$emitCodeLensEvent(ae));G=M.$DJ.from(G,ue)}return G}$provideCodeLenses(F,V,J){return this.s(F,s,K=>K.provideCodeLenses(w.URI.revive(V),J),void 0,J)}$resolveCodeLens(F,V,J){return this.s(F,s,K=>K.resolveCodeLens(V,J),void 0,void 0)}$releaseCodeLenses(F,V){this.s(F,s,J=>Promise.resolve(J.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(F,V,J){const K=this.t(new k(this.h,J),F);return this.e.$registerDefinitionSupport(K,this.o(V,F)),this.p(K)}$provideDefinition(F,V,J,K){return this.s(F,k,ae=>ae.provideDefinition(w.URI.revive(V),J,K),[],K)}registerDeclarationProvider(F,V,J){const K=this.t(new l(this.h,J),F);return this.e.$registerDeclarationSupport(K,this.o(V,F)),this.p(K)}$provideDeclaration(F,V,J,K){return this.s(F,l,ae=>ae.provideDeclaration(w.URI.revive(V),J,K),[],K)}registerImplementationProvider(F,V,J){const K=this.t(new f(this.h,J),F);return this.e.$registerImplementationSupport(K,this.o(V,F)),this.p(K)}$provideImplementation(F,V,J,K){return this.s(F,f,ae=>ae.provideImplementation(w.URI.revive(V),J,K),[],K)}registerTypeDefinitionProvider(F,V,J){const K=this.t(new v(this.h,J),F);return this.e.$registerTypeDefinitionSupport(K,this.o(V,F)),this.p(K)}$provideTypeDefinition(F,V,J,K){return this.s(F,v,ae=>ae.provideTypeDefinition(w.URI.revive(V),J,K),[],K)}registerHoverProvider(F,V,J,K){const ae=this.t(new u(this.h,J),F);return this.e.$registerHoverProvider(ae,this.o(V,F)),this.p(ae)}$provideHover(F,V,J,K){return this.s(F,u,ae=>ae.provideHover(w.URI.revive(V),J,K),void 0,K)}registerEvaluatableExpressionProvider(F,V,J,K){const ae=this.t(new d(this.h,J),F);return this.e.$registerEvaluatableExpressionProvider(ae,this.o(V,F)),this.p(ae)}$provideEvaluatableExpression(F,V,J,K){return this.s(F,d,ae=>ae.provideEvaluatableExpression(w.URI.revive(V),J,K),void 0,K)}registerInlineValuesProvider(F,V,J,K){const ae=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,G=this.t(new R(this.h,J),F);this.e.$registerInlineValuesProvider(G,this.o(V,F),ae);let ue=this.p(G);if(ae!==void 0){const me=J.onDidChangeInlineValues(Ne=>this.e.$emitInlineValuesEvent(ae));ue=M.$DJ.from(ue,me)}return ue}$provideInlineValues(F,V,J,K,ae){return this.s(F,R,G=>G.provideInlineValues(w.URI.revive(V),J,K,ae),void 0,ae)}registerDocumentHighlightProvider(F,V,J){const K=this.t(new W(this.h,J),F);return this.e.$registerDocumentHighlightProvider(K,this.o(V,F)),this.p(K)}$provideDocumentHighlights(F,V,J,K){return this.s(F,W,ae=>ae.provideDocumentHighlights(w.URI.revive(V),J,K),void 0,K)}registerLinkedEditingRangeProvider(F,V,J){const K=this.t(new B(this.h,J),F);return this.e.$registerLinkedEditingRangeProvider(K,this.o(V,F)),this.p(K)}$provideLinkedEditingRanges(F,V,J,K){return this.s(F,B,async ae=>{const G=await ae.provideLinkedEditingRanges(w.URI.revive(V),J,K);if(G)return{ranges:G.ranges,wordPattern:G.wordPattern?ie.w(G.wordPattern):void 0}},void 0,K)}registerReferenceProvider(F,V,J){const K=this.t(new q(this.h,J),F);return this.e.$registerReferenceSupport(K,this.o(V,F)),this.p(K)}$provideReferences(F,V,J,K,ae){return this.s(F,q,G=>G.provideReferences(w.URI.revive(V),J,K,ae),void 0,ae)}registerCodeActionProvider(F,V,J,K){const ae=new o.$kb,G=this.t(new U(this.h,this.j.converter,this.k,J,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(G,this.o(V,F),{providedKinds:K?.providedCodeActionKinds?.map(ue=>ue.value),documentation:K?.documentation?.map(ue=>({kind:ue.kind.value,command:this.j.converter.toInternal(ue.command,ae)}))},ie.u(F),!!J.resolveCodeAction),ae.add(this.p(G)),ae}$provideCodeActions(F,V,J,K,ae){return this.s(F,U,G=>G.provideCodeActions(w.URI.revive(V),J,K,ae),void 0,ae)}$resolveCodeAction(F,V,J){return this.s(F,U,K=>K.resolveCodeAction(V,J),{},void 0)}$releaseCodeActions(F,V){this.s(F,U,J=>Promise.resolve(J.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(F,V,J){const K=this.t(new O(this.h,J),F);return this.e.$registerDocumentFormattingSupport(K,this.o(V,F),F.identifier,F.displayName||F.name),this.p(K)}$provideDocumentFormattingEdits(F,V,J,K){return this.s(F,O,ae=>ae.provideDocumentFormattingEdits(w.URI.revive(V),J,K),void 0,K)}registerDocumentRangeFormattingEditProvider(F,V,J){const K=typeof J.provideDocumentRangesFormattingEdits=="function";K&&(0,r.$zF)(F,"formatMultipleRanges");const ae=this.t(new ce(this.h,J),F);return this.e.$registerRangeFormattingSupport(ae,this.o(V,F),F.identifier,F.displayName||F.name,K),this.p(ae)}$provideDocumentRangeFormattingEdits(F,V,J,K,ae){return this.s(F,ce,G=>G.provideDocumentRangeFormattingEdits(w.URI.revive(V),J,K,ae),void 0,ae)}$provideDocumentRangesFormattingEdits(F,V,J,K,ae){return this.s(F,ce,G=>G.provideDocumentRangesFormattingEdits(w.URI.revive(V),J,K,ae),void 0,ae)}registerOnTypeFormattingEditProvider(F,V,J,K){const ae=this.t(new X(this.h,J),F);return this.e.$registerOnTypeFormattingSupport(ae,this.o(V,F),K,F.identifier),this.p(ae)}$provideOnTypeFormattingEdits(F,V,J,K,ae,G){return this.s(F,X,ue=>ue.provideOnTypeFormattingEdits(w.URI.revive(V),J,K,ae,G),void 0,G)}registerWorkspaceSymbolProvider(F,V){const J=this.t(new be(V,this.l),F);return this.e.$registerNavigateTypeSupport(J,typeof V.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(F,V,J){return this.s(F,be,K=>K.provideWorkspaceSymbols(V,J),{symbols:[]},J)}$resolveWorkspaceSymbol(F,V,J){return this.s(F,be,K=>K.resolveWorkspaceSymbol(V,J),void 0,void 0)}$releaseWorkspaceSymbols(F,V){this.s(F,be,J=>J.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(F,V,J){const K=this.t(new Ee(this.h,J,this.l),F);return this.e.$registerRenameSupport(K,this.o(V,F),Ee.supportsResolving(J)),this.p(K)}$provideRenameEdits(F,V,J,K,ae){return this.s(F,Ee,G=>G.provideRenameEdits(w.URI.revive(V),J,K,ae),void 0,ae)}$resolveRenameLocation(F,V,J,K){return this.s(F,Ee,ae=>ae.resolveRenameLocation(w.URI.revive(V),J,K),void 0,K)}registerDocumentSemanticTokensProvider(F,V,J,K){const ae=this.t(new Z(this.h,J),F),G=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ae,this.o(V,F),K,G);let ue=this.p(ae);if(G){const me=J.onDidChangeSemanticTokens(Ne=>this.e.$emitDocumentSemanticTokensEvent(G));ue=M.$DJ.from(ue,me)}return ue}$provideDocumentSemanticTokens(F,V,J,K){return this.s(F,Z,ae=>ae.provideDocumentSemanticTokens(w.URI.revive(V),J,K),null,K)}$releaseDocumentSemanticTokens(F,V){this.s(F,Z,J=>J.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,V,J,K){const ae=this.t(new he(this.h,J),F);return this.e.$registerDocumentRangeSemanticTokensProvider(ae,this.o(V,F),K),this.p(ae)}$provideDocumentRangeSemanticTokens(F,V,J,K){return this.s(F,he,ae=>ae.provideDocumentRangeSemanticTokens(w.URI.revive(V),J,K),null,K)}registerCompletionItemProvider(F,V,J,K){const ae=this.t(new Ce(this.h,this.j.converter,J,this.m,F),F);return this.e.$registerCompletionsProvider(ae,this.o(V,F),K,Ce.supportsResolving(J),F.identifier),this.p(ae)}$provideCompletionItems(F,V,J,K,ae){return this.s(F,Ce,G=>G.provideCompletionItems(w.URI.revive(V),J,K,ae),void 0,ae)}$resolveCompletionItem(F,V,J){return this.s(F,Ce,K=>K.resolveCompletionItem(V,J),void 0,J)}$releaseCompletionItems(F,V){this.s(F,Ce,J=>J.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(F,V,J,K){const ae=new ne(F,this.h,J,this.j.converter),G=this.t(ae,F);return this.e.$registerInlineCompletionsSupport(G,this.o(V,F),ae.supportsHandleEvents,b.$Hl.toKey(F.identifier.value),K?.yieldTo?.map(ue=>b.$Hl.toKey(ue))||[]),this.p(G)}$provideInlineCompletions(F,V,J,K,ae){return this.s(F,H,G=>G.provideInlineCompletions(w.URI.revive(V),J,K,ae),void 0,ae)}$handleInlineCompletionDidShow(F,V,J,K){this.s(F,H,async ae=>{ae.handleDidShowCompletionItem(V,J,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,V,J,K){this.s(F,H,async ae=>{ae.handlePartialAccept(V,J,K)},void 0,void 0)}$freeInlineCompletionsList(F,V){this.s(F,H,async J=>{J.disposeCompletions(V)},void 0,void 0)}registerSignatureHelpProvider(F,V,J,K){const ae=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,G=this.t(new L(this.h,J),F);return this.e.$registerSignatureHelpProvider(G,this.o(V,F),ae),this.p(G)}$provideSignatureHelp(F,V,J,K,ae){return this.s(F,L,G=>G.provideSignatureHelp(w.URI.revive(V),J,K,ae),void 0,ae)}$releaseSignatureHelp(F,V){this.s(F,L,J=>J.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(F,V,J){const K=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,ae=this.t(new _(this.h,this.j.converter,J,this.l,F),F);this.e.$registerInlayHintsProvider(ae,this.o(V,F),typeof J.resolveInlayHint=="function",K,ie.u(F));let G=this.p(ae);if(K!==void 0){const ue=J.onDidChangeInlayHints(me=>this.e.$emitInlayHintsEvent(K));G=M.$DJ.from(G,ue)}return G}$provideInlayHints(F,V,J,K){return this.s(F,_,ae=>ae.provideInlayHints(w.URI.revive(V),J,K),void 0,K)}$resolveInlayHint(F,V,J){return this.s(F,_,K=>K.resolveInlayHint(V,J),void 0,J)}$releaseInlayHints(F,V){this.s(F,_,J=>J.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(F,V,J){const K=this.t(new pe(this.h,J),F);return this.e.$registerDocumentLinkProvider(K,this.o(V,F),typeof J.resolveDocumentLink=="function"),this.p(K)}$provideDocumentLinks(F,V,J){return this.s(F,pe,K=>K.provideLinks(w.URI.revive(V),J),void 0,J,V.scheme==="output")}$resolveDocumentLink(F,V,J){return this.s(F,pe,K=>K.resolveLink(V,J),void 0,void 0,!0)}$releaseDocumentLinks(F,V){this.s(F,pe,J=>J.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(F,V,J){const K=this.t(new Ie(this.h,J),F);return this.e.$registerDocumentColorProvider(K,this.o(V,F)),this.p(K)}$provideDocumentColors(F,V,J){return this.s(F,Ie,K=>K.provideColors(w.URI.revive(V),J),[],J)}$provideColorPresentations(F,V,J,K){return this.s(F,Ie,ae=>ae.provideColorPresentations(w.URI.revive(V),J,K),void 0,K)}registerFoldingRangeProvider(F,V,J){const K=this.q(),ae=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(K,new ee(new De(this.h,J),F)),this.e.$registerFoldingRangeProvider(K,this.o(V,F),F.identifier,ae);let G=this.p(K);if(ae!==void 0){const ue=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ae));G=M.$DJ.from(G,ue)}return G}$provideFoldingRanges(F,V,J,K){return this.s(F,De,ae=>ae.provideFoldingRanges(w.URI.revive(V),J,K),void 0,K)}registerSelectionRangeProvider(F,V,J){const K=this.t(new ye(this.h,J,this.l),F);return this.e.$registerSelectionRangeProvider(K,this.o(V,F)),this.p(K)}$provideSelectionRanges(F,V,J,K){return this.s(F,ye,ae=>ae.provideSelectionRanges(w.URI.revive(V),J,K),[],K)}registerCallHierarchyProvider(F,V,J){const K=this.t(new Se(this.h,J),F);return this.e.$registerCallHierarchyProvider(K,this.o(V,F)),this.p(K)}$prepareCallHierarchy(F,V,J,K){return this.s(F,Se,ae=>Promise.resolve(ae.prepareSession(w.URI.revive(V),J,K)),void 0,K)}$provideCallHierarchyIncomingCalls(F,V,J,K){return this.s(F,Se,ae=>ae.provideCallsTo(V,J,K),void 0,K)}$provideCallHierarchyOutgoingCalls(F,V,J,K){return this.s(F,Se,ae=>ae.provideCallsFrom(V,J,K),void 0,K)}$releaseCallHierarchy(F,V){this.s(F,Se,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(F,V,J){const K=this.t(new oe(this.h,J),F);return this.e.$registerTypeHierarchyProvider(K,this.o(V,F)),this.p(K)}$prepareTypeHierarchy(F,V,J,K){return this.s(F,oe,ae=>Promise.resolve(ae.prepareSession(w.URI.revive(V),J,K)),void 0,K)}$provideTypeHierarchySupertypes(F,V,J,K){return this.s(F,oe,ae=>ae.provideSupertypes(V,J,K),void 0,K)}$provideTypeHierarchySubtypes(F,V,J,K){return this.s(F,oe,ae=>ae.provideSubtypes(V,J,K),void 0,K)}$releaseTypeHierarchy(F,V){this.s(F,oe,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(F,V,J,K){const ae=this.q();return this.f.set(ae,new ee(new de(this.e,this.h,J,ae,F),F)),this.e.$registerDocumentOnDropEditProvider(ae,this.o(V,F),(0,r.$yF)(F,"dropMetadata")?K:void 0),this.p(ae)}$provideDocumentOnDropEdits(F,V,J,K,ae,G){return this.s(F,de,ue=>Promise.resolve(ue.provideDocumentOnDropEdits(V,w.URI.revive(J),K,ae,G)),void 0,void 0)}registerDocumentPasteEditProvider(F,V,J,K){const ae=this.q();return this.f.set(ae,new ee(new N(this.e,this.h,J,ae,F),F)),this.e.$registerPasteEditProvider(ae,this.o(V,F),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,copyMimeTypes:K.copyMimeTypes,pasteMimeTypes:K.pasteMimeTypes}),this.p(ae)}$prepareDocumentPaste(F,V,J,K,ae){return this.s(F,N,G=>G.prepareDocumentPaste(w.URI.revive(V),J,K,ae),void 0,ae)}$providePasteEdits(F,V,J,K,ae,G){return this.s(F,N,ue=>ue.providePasteEdits(V,w.URI.revive(J),K,ae,G),void 0,G)}static w(F){return{pattern:F.source,flags:(0,D.$zd)(F)}}static y(F){return{decreaseIndentPattern:ie.w(F.decreaseIndentPattern),increaseIndentPattern:ie.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?ie.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?ie.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:ie.w(F.beforeText),afterText:F.afterText?ie.w(F.afterText):void 0,previousLineText:F.previousLineText?ie.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(ie.z)}setLanguageConfiguration(F,V,J){const{wordPattern:K}=J;if(K&&(0,D.$xd)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this.h.setWordDefinitionFor(V,K):this.h.setWordDefinitionFor(V,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use."),J.autoClosingPairs&&(0,r.$zF)(F,"languageConfigurationAutoClosingPairs");const ae=this.q(),G={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?ie.w(J.wordPattern):void 0,indentationRules:J.indentationRules?ie.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?ie.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs};return this.e.$setLanguageConfiguration(ae,V,G),this.p(ae)}$setWordDefinitions(F){for(const V of F)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$W$b=ie}),define(Ae[235],Fe([1,0,4,8,7,29,16,6]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E_b=void 0;class D{constructor(A,E,c,y){this.c=E,this.d=c,this.e=y,this.b=[],this.f=0,this.g=new Set,this.a=A.getProxy(w.$BJ.MainThreadLanguages)}$acceptLanguageIds(A){this.b=A}async getLanguages(){return this.b.slice(0)}async changeLanguage(A,E){await this.a.$changeLanguage(A,E);const c=this.c.getDocumentData(A);if(!c)throw new Error(`document '${A.toString()}' NOT found`);return c.document}async tokenAtPosition(A,E){const c=A.version,y=T.Position.from(E),b=await this.a.$tokensAtPosition(A.uri,y),o={type:C.StandardTokenType.Other,range:A.getWordRangeAtPosition(E)??new C.$FJ(E.line,E.character,E.line,E.character)};if(!b)return o;const t={range:T.Range.to(b.range),type:T.TokenType.to(b.type)};return!t.range.contains(E)||c!==A.version?o:t}createLanguageStatusItem(A,E,c){const y=this.f++,b=this.a,o=this.g,t=`${A.identifier.value}/${E}`;if(o.has(t))throw new Error(`LanguageStatusItem with id '${E}' ALREADY exists`);o.add(t);const i={selector:c,id:E,name:A.displayName??A.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const m=new g.$kb,S=()=>{if(a?.dispose(),!o.has(t)){console.warn(`LanguageStatusItem (${E}) from ${A.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,P.$xg)(()=>{m.clear(),this.a.$setLanguageStatus(y,{id:t,name:i.name??A.displayName??A.name,source:A.displayName??A.name,selector:T.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===C.LanguageStatusSeverity.Error?M.default.Error:i.severity===C.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:i.command&&this.d.toInternal(i.command,m),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},I={dispose(){m.dispose(),a?.dispose(),b.$removeLanguageStatus(y),o.delete(t)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,S()},get selector(){return i.selector},set selector(r){i.selector=r,S()},get text(){return i.text},set text(r){i.text=r,S()},get detail(){return i.detail},set detail(r){i.detail=r,S()},get severity(){return i.severity},set severity(r){i.severity=r,S()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,S()},get command(){return i.command},set command(r){i.command=r,S()},get busy(){return i.busy},set busy(r){i.busy=r,S()}};return S(),I}}e.$E_b=D}),define(Ae[80],Fe([1,0,22,15,2,3,14,4,27,17]),function($e,e,w,T,C,M,P,g,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u_b=e.$t_b=void 0;let A=class{constructor(c,y,b){this.f=b,this.d=new Map,this.a=y.getProxy(g.$BJ.MainThreadLocalization),this.b=c.environment.appLanguage,this.c=this.b===w.$f}getMessage(c,y){const{message:b,args:o,comment:t}=y;if(this.c)return(0,T.$md)(b,o??{});let i=b;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const a=this.d.get(c)?.contents[i];return a||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,T.$md)(a??b,o??{})}getBundle(c){return this.d.get(c)?.contents}getBundleUri(c){return this.d.get(c)?.uri}async initializeLocalizedMessages(c){if(this.c||!c.l10n&&!c.isBuiltin||this.d.has(c.identifier.value))return;let y;const b=await this.g(c);if(!b){this.f.error(`No bundle location found for extension ${c.identifier.value}`);return}try{const o=await this.a.$fetchBundleContents(b),t=JSON.parse(o);y=c.isBuiltin?t.contents?.bundle:t}catch(o){this.f.error(`Failed to load translations for ${c.identifier.value} from ${b}: ${o.message}`);return}y&&this.d.set(c.identifier.value,{contents:y,uri:b})}async g(c){if(c.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(c.identifier.value,this.b);return C.URI.revive(y)}return c.l10n?C.URI.joinPath(c.extensionLocation,c.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$t_b=A,e.$t_b=A=Ve([qe(0,D.$TL),qe(1,p.$DL),qe(2,P.$Ri)],A),e.$u_b=(0,M.$ph)("IExtHostLocalizationService")}),define(Ae[236],Fe([1,0,14,4,27,17,2,69]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qac=void 0;let D=class extends w.$3i{constructor(E,c){super(c.logLevel,c.logsLocation,c.loggers.map(y=>(0,g.$Yg)(y))),this.n=E.getProxy(T.$BJ.MainThreadLogger)}$setLogLevel(E,c){c?this.setLogLevel(P.URI.revive(c),E):this.setLogLevel(E)}setVisibility(E,c){super.setVisibility(E,c),this.n.$setVisibility(E,c)}m(E,c,y){return new p(this.n,E,c,y)}};e.$Qac=D,e.$Qac=D=Ve([qe(0,M.$DL),qe(1,C.$TL)],D);class p extends w.$Xi{constructor(E,c,y,b){super(b?.logLevel==="always"),this.m=E,this.n=c,this.k=!1,this.l=[],this.setLevel(y),this.m.$createLogger(c,b).then(()=>{this.r(this.l),this.k=!0})}g(E,c){const y=[[E,c]];this.k?this.r(y):this.l.push(...y)}r(E){this.m.$log(this.n,E)}flush(){this.m.$flush(this.n)}}}),define(Ae[81],Fe([1,0,4,3,6,17,25]),function($e,e,w,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w_b=e.$v_b=void 0,e.$v_b=(0,T.$ph)("IExtHostManagedSockets");let g=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(w.$BJ.MainThreadManagedSockets)}setFactory(E,c){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new D(E,c),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const c=++this.b,y=await this.c.makeConnection(),b=new C.$kb;return this.d.set(c,new p(c,y,b)),b.add((0,C.$jb)(()=>this.d.delete(c))),b.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(c),b.dispose()})),b.add(y.onDidClose(o=>{this.a.$onDidManagedSocketClose(c,o?.stack??o?.message),b.dispose()})),b.add(y.onDidReceiveMessage(o=>this.a.$onDidManagedSocketHaveData(c,P.$Jb.wrap(o)))),c}$remoteSocketWrite(E,c){this.d.get(E)?.actual.send(c.buffer)}$remoteSocketEnd(E){const c=this.d.get(E);c&&(c.actual.end(),c.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$w_b=g,e.$w_b=g=Ve([qe(0,M.$DL)],g);class D{constructor(E,c){this.socketFactoryId=E,this.makeConnection=c}}class p extends C.$lb{constructor(E,c,y){super(),this.socketId=E,this.actual=c,this.B(y)}}}),define(Ae[237],Fe([1,0,4,14,26]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F_b=void 0;function M(g){return g&&g.title}let P=class{constructor(D,p){this.b=p,this.a=D.getProxy(w.$BJ.MainThreadMessageService)}showMessage(D,p,A,E,c){const y={source:{identifier:D.identifier,label:D.displayName||D.name}};let b;typeof E=="string"||M(E)?b=[E,...c]:(y.modal=E?.modal,y.useCustom=E?.useCustom,y.detail=E?.detail,b=c),y.useCustom&&(0,C.$zF)(D,"resolvers");const o=[];for(let t=0;t<b.length;t++){const i=b[t];if(typeof i=="string")o.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:a,isCloseAffordance:m}=i;o.push({title:a,isCloseAffordance:!!m,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(p,A,y,o).then(t=>{if(typeof t=="number")return b[t]})}};e.$F_b=P,e.$F_b=P=Ve([qe(1,T.$Ri)],P)}),define(Ae[238],Fe([1,0,151,25,5,6,28,15,12,2,38,55,4,32,8,7,46,205,103,11,24,13]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t,i,a,m,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(n=>n.apiEditor)}constructor(n,s,$,k,l){this.q=$,this.r=k,this.s=l,this.f=new Map,this.g=new P.$ni,this.h=new Map,this.j=new C.$8c({onListenerError:m.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$8c({onListenerError:m.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$8c({onListenerError:m.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$8c({onListenerError:m.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new E.$N$b("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=n.getProxy(c.$BJ.MainThreadNotebook),this.c=n.getProxy(c.$BJ.MainThreadNotebookDocuments),this.d=n.getProxy(c.$BJ.MainThreadNotebookEditors),this.i=s.converter,s.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===13){const v=f.notebookEditor?.notebookUri,u=f.cell.handle,R=this.g.get(v)?.getCell(u);if(R)return R.apiCell}if(f&&f.$mid===14){const v=f.uri,u=this.g.get(v);if(u)return u.apiNotebook}return f}}),r.A(s)}getEditorById(n){const s=this.h.get(n);if(!s)throw new Error(`unknown text editor: ${n}. known editors: ${[...this.h.keys()]} `);return s}getIdByEditor(n){for(const[s,$]of this.h)if($.apiEditor===n)return s}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(n,s){const $=this.g.get(n);if(!$&&!s)throw new Error(`NO notebook document for '${n}'`);return $}static t(n,s){if(!s)return;const $=s.filenamePattern.map(k=>b.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(s.filenamePattern&&!$){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:n.identifier,providerDisplayName:n.displayName||n.name,displayName:s.displayName,filenamePattern:$,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(n,s,$){const k=r.a++,l=typeof $.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(k,$),this.b.$registerNotebookCellStatusBarItemProvider(k,l,s);let f;return l!==void 0&&(f=$.onDidChangeCellStatusBarItems(v=>this.b.$emitCellStatusBarEvent(l))),new o.$DJ(()=>{this.f.delete(k),this.b.$unregisterNotebookCellStatusBarItemProvider(k,l),f?.dispose()})}async createNotebookDocument(n){const s=await this.c.$tryCreateNotebook({viewType:n.viewType,content:n.content&&b.NotebookData.from(n.content)});return p.URI.revive(s)}async openNotebookDocument(n){const s=this.g.get(n);if(s)return s.apiNotebook;const $=await this.c.$tryOpenNotebook(n),k=this.g.get(p.URI.revive($));return(0,D.$ue)(k?.apiNotebook)}async showNotebookDocument(n,s){p.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let $;typeof s=="object"?$={position:b.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(b.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:$={preserveFocus:!1};const k=await this.d.$tryShowNotebookDocument(n.uri,n.notebookType,$),l=k&&this.h.get(k)?.apiEditor;if(l)return l;throw k?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(n,s,$,k){const l=this.f.get(n),f=p.URI.revive(s),v=this.g.get(f);if(!v||!l)return;const u=v.getCellFromIndex($);if(!u)return;const d=await l.provideCellStatusBarItems(u.apiCell,k);if(!d)return;const R=new M.$kb,W=this.p.add([R]),q=(Array.isArray(d)?d:[d]).map(U=>b.NotebookStatusBarItem.from(U,this.i,R));return{cacheId:W,items:q}}$releaseNotebookCellStatusBarItems(n){this.p.delete(n)}registerNotebookSerializer(n,s,$,k,l){if((0,g.$kd)(s))throw new Error("viewType cannot be empty or just whitespace");const f=this.u++;return this.w.set(f,{viewType:s,serializer:$,options:k}),this.b.$registerNotebookSerializer(f,{id:n.identifier,location:n.extensionLocation},s,b.NotebookDocumentContentOptions.from(k),r.t(n,l)),(0,M.$jb)(()=>{this.b.$unregisterNotebookSerializer(f)})}async $dataToNotebook(n,s,$){const k=this.w.get(n);if(!k)throw new Error("NO serializer found");const l=await k.serializer.deserializeNotebook(s.buffer,$);return new t.$Yz(b.NotebookData.from(l))}async $notebookToData(n,s,$){const k=this.w.get(n);if(!k)throw new Error("NO serializer found");const l=await k.serializer.serializeNotebook(b.NotebookData.to(s.value),$);return T.$Jb.wrap(l)}async $saveNotebook(n,s,$,k,l){const f=p.URI.revive(s),v=this.w.get(n);if(!v)throw new Error("NO serializer found");const u=this.g.get(f);if(!u)throw new Error("Document NOT found");if(u.versionId!==$)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(f.scheme))throw new A.$ak((0,w.localize)(0,null,this.y(f)),6);await this.x(f,k);const d={metadata:(0,S.$Pm)(u.apiNotebook.metadata,U=>!(v.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of u.apiNotebook.getCells()){const N=new o.$3K(U.kind,U.document.getText(),U.document.languageId,U.mime,v.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);N.metadata=(0,S.$Pm)(U.metadata,O=>!(v.options?.transientCellMetadata??{})[O]),d.cells.push(N)}const R=await v.serializer.serializeNotebook(d,l);await this.s.value.writeFile(f,R);const W=this.s.getFileSystemProviderExtUri(f.scheme),B=await this.s.value.stat(f);return{name:W.basename(f),isFile:(B.type&A.FileType.File)!==0,isDirectory:(B.type&A.FileType.Directory)!==0,isSymbolicLink:(B.type&A.FileType.SymbolicLink)!==0,mtime:B.mtime,ctime:B.ctime,size:B.size,readonly:!!((B.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(f.scheme),locked:!!((B.permissions??0)&A.FilePermission.Locked),etag:A.$lk({mtime:B.mtime,size:B.size}),children:void 0}}async x(n,s){const $=await this.s.value.stat(n);if(typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==A.$kk&&typeof $.mtime=="number"&&typeof $.size=="number"&&s.mtime<$.mtime&&s.etag!==A.$lk({mtime:s.mtime,size:$.size}))throw new A.$ak((0,w.localize)(1,null),3,s)}y(n){return n.scheme===I.Schemas.file?n.fsPath:n.toString()}z(n,s,$){if(this.h.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const k=new a.$mac(s,this.d,n,$.visibleRanges.map(b.NotebookRange.to),$.selections.map(b.NotebookRange.to),typeof $.viewColumn=="number"?b.ViewColumn.to($.viewColumn):void 0);this.h.set(s,k)}$acceptDocumentAndEditorsDelta(n){if(n.value.removedDocuments)for(const $ of n.value.removedDocuments){const k=p.URI.revive($),l=this.g.get(k);l&&(l.dispose(),this.g.delete(k),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:l.apiNotebook.getCells().map(f=>f.document.uri)}),this.n.fire(l.apiNotebook));for(const f of this.h.values())f.notebookData.uri.toString()===k.toString()&&this.h.delete(f.id)}if(n.value.addedDocuments){const $=[];for(const k of n.value.addedDocuments){const l=p.URI.revive(k.uri);if(this.g.has(l))throw new Error(`adding EXISTING notebook ${l} `);const f=new i.$lac(this.c,this.q,this.r,l,k);$.push(...k.cells.map(v=>i.$kac.asModelAddData(f.apiNotebook,v))),this.g.get(l)?.dispose(),this.g.set(l,f),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:$}),this.m.fire(f.apiNotebook)}}if(n.value.addedEditors)for(const $ of n.value.addedEditors){if(this.h.has($.id))return;const k=p.URI.revive($.documentUri),l=this.g.get(k);l&&this.z(l,$.id,$)}const s=[];if(n.value.removedEditors)for(const $ of n.value.removedEditors){const k=this.h.get($);k&&(this.h.delete($),this.k?.id===k.id&&(this.k=void 0),s.push(k))}if(n.value.visibleEditors){this.l=n.value.visibleEditors.map(k=>this.h.get(k)).filter(k=>!!k);const $=new Set;this.l.forEach(k=>$.add(k.id));for(const k of this.h.values()){const l=$.has(k.id);k._acceptVisibility(l)}this.l=[...this.h.values()].map(k=>k).filter(k=>k.visible),this.o.fire(this.visibleNotebookEditors)}n.value.newActiveEditor===null?this.k=void 0:n.value.newActiveEditor&&(this.h.get(n.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${n.value.newActiveEditor}`),this.k=this.h.get(n.value.newActiveEditor)),n.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(n){const s=y.$2L.String.with("notebookType","A notebook type"),$=new y.$4L("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[s,new y.$2L("data","Bytes to convert to data",l=>l instanceof Uint8Array,l=>T.$Jb.wrap(l))],new y.$3L("Notebook Data",l=>b.NotebookData.to(l.value))),k=new y.$4L("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[s,new y.$2L("NotebookData","Notebook data to convert to bytes",l=>!0,l=>new t.$Yz(b.NotebookData.from(l)))],new y.$3L("Bytes",l=>l.buffer));n.registerApiCommand($),n.registerApiCommand(k)}}e.$nac=r}),define(Ae[239],Fe([1,0,18,16,20,5,6,28,2,21,14,55,4,32,8,7,76,198,26,46]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t,i,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=e.$Bac=void 0;let S=class{constructor(l,f,v,u,d){this.m=f,this.n=v,this.o=u,this.q=d,this.b=new g.$ni,this.c=new g.$ni,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new E.$N$b("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new M.$8c,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=l.getProxy(c.$BJ.MainThreadNotebookKernels);const R=new y.$4L("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new y.$2L("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const B=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:B}}else if(W&&"notebookEditor"in W){const B=this.n.getIdByEditor(W.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:B}}return W})],y.$3L.Void);this.o.registerApiCommand(R)}createNotebookController(l,f,v,u,d,R){for(const H of this.j.values())if(H.controller.id===f&&p.$Hl.equals(l.identifier,H.extensionId))throw new Error(`notebook controller with id '${f}' ALREADY exist`);const W=this.k++,B=this;this.q.trace(`NotebookController[${W}], CREATED by ${l.identifier.value}, ${f}`);const q=()=>console.warn(`NO execute handler from notebook controller '${X.id}' of extension: '${l.identifier}'`);let U=!1;const N=new P.$kb,O=new M.$8c,ce=new M.$8c,X={id:$(l.identifier,f),notebookType:v,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:u||l.identifier.value,preloads:R?R.map(b.NotebookRendererScript.from):[]};let be=d??q,Ee;this.a.$addKernel(W,X).catch(H=>{console.log(H),U=!0});let Re=0;const Z=()=>{if(U)return;const H=++Re;Promise.resolve().then(()=>{H===Re&&this.a.$updateKernel(W,X)})},he=new g.$ni,Ce={get id(){return f},get notebookType(){return X.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return X.label},set label(H){X.label=H??l.displayName??l.name,Z()},get detail(){return X.detail??""},set detail(H){X.detail=H,Z()},get description(){return X.description??""},set description(H){X.description=H,Z()},get supportedLanguages(){return X.supportedLanguages},set supportedLanguages(H){X.supportedLanguages=H,Z()},get supportsExecutionOrder(){return X.supportsExecutionOrder??!1},set supportsExecutionOrder(H){X.supportsExecutionOrder=H,Z()},get rendererScripts(){return X.preloads?X.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return be},set executeHandler(H){be=H??q},get interruptHandler(){return Ee},set interruptHandler(H){Ee=H,X.supportsInterrupt=!!H,Z()},createNotebookCellExecution(H){if(U)throw new Error("notebook controller is DISPOSED");if(!he.has(H.notebook.uri))throw B.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(he.keys()).map(ne=>ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${H.notebook.uri.toString()}`);return B._createNotebookCellExecution(H,$(l.identifier,this.id))},createNotebookExecution(H){if((0,a.$zF)(l,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!he.has(H.uri))throw B.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(he.keys()).map(ne=>ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${H.uri.toString()}`);return B._createNotebookExecution(H,$(l.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${W}], DISPOSED`),U=!0,this.j.delete(W),N.dispose(),O.dispose(),ce.dispose(),this.a.$removeKernel(W))},updateNotebookAffinity(H,ne){ne===o.NotebookControllerAffinity2.Hidden&&(0,a.$zF)(l,"notebookControllerAffinityHidden"),B.a.$updateNotebookPriority(W,H.uri,ne)},onDidReceiveMessage:ce.event,postMessage(H,ne){return(0,a.$zF)(l,"notebookMessaging"),B.a.$postMessage(W,ne&&B.n.getIdByEditor(ne),H)},asWebviewUri(H){return(0,a.$zF)(l,"notebookMessaging"),(0,t.$knb)(H,B.m.remote)}};return this.j.set(W,{extensionId:l.identifier,controller:Ce,onDidReceiveMessage:ce,onDidChangeSelection:O,associatedNotebooks:he}),Ce}getIdByController(l){for(const[f,v]of this.j)if(v.controller===l)return $(v.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,f){const v=this.f++,u=this;this.q.trace(`NotebookControllerDetectionTask[${v}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(v,f);const d={dispose:()=>{this.e.delete(v),u.a.$removeKernelDetectionTask(v)}};return this.e.set(v,d),d}registerKernelSourceActionProvider(l,f,v){const u=this.h++,d=typeof v.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,R=this;this.g.set(u,v),this.q.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(u,u,f);let W;return d!==void 0&&(W=v.onDidChangeNotebookKernelSourceActions(B=>this.a.$emitNotebookKernelSourceActionsChangeEvent(d))),{dispose:()=>{this.g.delete(u),R.a.$removeKernelSourceActionProvider(u,u),W?.dispose()}}}async $provideKernelSourceActions(l,f){const v=this.g.get(l);if(v){const u=new P.$kb;return this.i.add([u]),(await v.provideNotebookKernelSourceActions(f)??[]).map(R=>b.NotebookKernelSourceAction.from(R,this.o.converter,u))}return[]}$acceptNotebookAssociation(l,f,v){const u=this.j.get(l);if(u){const d=this.n.getNotebookDocument(D.URI.revive(f));v?u.associatedNotebooks.set(d.uri,!0):u.associatedNotebooks.delete(d.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,d.uri.toString(),v),u.onDidChangeSelection.fire({selected:v,notebook:d.apiNotebook})}}async $executeCells(l,f,v){const u=this.j.get(l);if(!u)return;const d=this.n.getNotebookDocument(D.URI.revive(f)),R=[];for(const W of v){const B=d.getCell(W);B&&R.push(B.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,d.uri.toString(),R.length),await u.controller.executeHandler.call(u.controller,R,d.apiNotebook,u.controller)}catch(W){this.q.error(`NotebookController[${l}] execute cells FAILED`,W),console.error(W)}}async $cancelCells(l,f,v){const u=this.j.get(l);if(!u)return;const d=this.n.getNotebookDocument(D.URI.revive(f));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,d.apiNotebook);else for(const R of v){const W=d.getCell(R);W&&this.b.get(W.uri)?.cancel()}if(u.controller.interruptHandler){const R=this.c.get(d.uri);v.length&&Array.isArray(R)&&R.length&&R.forEach(W=>W.dispose())}}$acceptKernelMessageFromRenderer(l,f,v){const u=this.j.get(l);if(!u)return;const d=this.n.getEditorById(f);u.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:v}))}$cellExecutionChanged(l,f,v){const d=this.n.getNotebookDocument(D.URI.revive(l)).getCell(f);if(d){const R=v?b.NotebookCellExecutionState.to(v):o.NotebookCellExecutionState.Idle;R!==void 0&&this.l.fire({cell:d.apiCell,state:R})}}_createNotebookCellExecution(l,f){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const d=new r(f,u,this.a);this.b.set(u.uri,d);const R=d.onDidChangeState(()=>{d.state===I.Resolved&&(d.dispose(),R.dispose(),this.b.delete(u.uri))});return d.asApiObject()}_createNotebookExecution(l,f){const v=this.n.getNotebookDocument(l.uri),u=l.getCells().find(W=>{const B=v.getCellFromApiCell(W);return B&&this.b.has(B.uri)});if(u)throw new Error(`duplicate cell execution for ${u.document.uri}`);if(this.c.has(v.uri))throw new Error(`duplicate notebook execution for ${v.uri}`);const d=new n(f,v,this.a),R=d.onDidChangeState(()=>{d.state===h.Resolved&&(d.dispose(),R.dispose(),this.c.delete(v.uri))});return this.c.set(v.uri,[d,R]),d.asApiObject()}};e.$Bac=S,e.$Bac=S=Ve([qe(4,A.$Ri)],S);var I;(function(k){k[k.Init=0]="Init",k[k.Started=1]="Started",k[k.Resolved=2]="Resolved"})(I||(I={}));class r extends P.$lb{static{this.a=0}get state(){return this.f}constructor(l,f,v){super(),this.j=f,this.k=v,this.b=r.a++,this.c=new M.$8c,this.onDidChangeState=this.c.event,this.f=I.Init,this.g=this.B(new C.$ed),this.h=new s(10,u=>this.m(u)),this.i=f.internalMetadata.executionOrder,this.k.$createExecution(this.b,l,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(l){await this.h.addItem(l)}async m(l){const f=Array.isArray(l)?l:[l];return this.k.$updateExecution(this.b,new m.$Yz(f))}n(){if(this.f===I.Init)throw new Error("Must call start before modifying cell output");if(this.f===I.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(l){let f=this.j;if(l&&(f=this.j.notebook.getCellFromApiCell(l)),!f)throw new Error("INVALID cell");return f.handle}s(l){return l.map(f=>{const v=o.$6K.ensureUniqueMimeTypes(f.items,!0);return v===f.items?b.NotebookCellOutput.from(f):b.NotebookCellOutput.from({items:v,id:f.id,metadata:f.metadata})})}async t(l,f,v){const u=this.r(f),d=this.s((0,w.$Jf)(l));return this.l({editType:i.CellExecutionUpdateType.Output,cellHandle:u,append:v,outputs:d})}async w(l,f,v){return l=o.$6K.ensureUniqueMimeTypes((0,w.$Jf)(l),!0),this.l({editType:i.CellExecutionUpdateType.OutputItems,items:l.map(b.NotebookCellOutputItem.from),outputId:f.id,append:v})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.j.apiCell},get executionOrder(){return l.i},set executionOrder(v){l.i=v,l.m([{editType:i.CellExecutionUpdateType.ExecutionState,executionOrder:l.i}])},start(v){if(l.f===I.Resolved||l.f===I.Started)throw new Error("Cannot call start again");l.f=I.Started,l.c.fire(),l.m({editType:i.CellExecutionUpdateType.ExecutionState,runStartTime:v})},end(v,u){if(l.f===I.Resolved)throw new Error("Cannot call resolve twice");l.f=I.Resolved,l.c.fire(),l.h.flush(),l.k.$completeExecution(l.b,new m.$Yz({runEndTime:u,lastRunSuccess:v}))},clearOutput(v){return l.n(),l.t([],v,!1)},appendOutput(v,u){return l.n(),l.t(v,u,!0)},replaceOutput(v,u){return l.n(),l.t(v,u,!1)},appendOutputItems(v,u){return l.n(),l.w(v,u,!0)},replaceOutputItems(v,u){return l.n(),l.w(v,u,!1)}})}}var h;(function(k){k[k.Init=0]="Init",k[k.Started=1]="Started",k[k.Resolved=2]="Resolved"})(h||(h={}));class n extends P.$lb{static{this.a=0}get state(){return this.f}constructor(l,f,v){super(),this.h=f,this.i=v,this.b=n.a++,this.c=new M.$8c,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new C.$ed),this.i.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===h.Resolved||this.f===h.Started)throw new Error("Cannot call start again");this.f=h.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===h.Resolved)throw new Error("Cannot call resolve twice");this.f=h.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}class s{constructor(l,f){this.e=l,this.f=f,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new T.$Pg,this.b=Date.now(),(0,T.$wg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const f=this.a;return this.a=[],this.f(f).finally(()=>l.complete())}}function $(k,l){return`${k.value}/${l}`}e.$Cac=$}),define(Ae[240],Fe([1,0,5,4,103]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=void 0;class M{constructor(g,D){this.c=D,this.a=new Map,this.b=g.getProxy(T.$BJ.MainThreadNotebookRenderers)}$postRendererMessage(g,D,p){const A=this.c.getEditorById(g);this.a.get(D)?.fire({editor:A.apiEditor,message:p})}createRendererMessaging(g,D){if(!g.contributes?.notebookRenderer?.some(A=>A.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(A,E,c)=>this.d(D).event(A,E,c),postMessage:(A,E)=>{C.$mac.apiEditorsToExtHost.has(A)&&([A,E]=[E,A]);const c=E&&C.$mac.apiEditorsToExtHost.get(E);return this.b.$postMessage(c?.id,D,A)}}}d(g){let D=this.a.get(g);return D||(D=new w.$8c({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete(g)}}),this.a.set(g,D),D)}}e.$Dac=M}),define(Ae[241],Fe([1,0,6,12,2,26,4]),function($e,e,w,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=void 0;class g{constructor(p){this.b=new Map,this.a=p.getProxy(P.$BJ.MainThreadProfileContentHandlers)}registrProfileContentHandler(p,A,E){if((0,M.$zF)(p,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,E),this.a.$registerProfileContentHandler(A,E.name,E.description,p.identifier.value),(0,w.$jb)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(p,A,E,c){const y=this.b.get(p);if(!y)throw new Error(`Unknown handler with id: ${p}`);return y.saveProfile(A,E,c)}async $readProfile(p,A,E){const c=this.b.get(p);if(!c)throw new Error(`Unknown handler with id: ${p}`);return c.readProfile((0,T.$je)(A)?A:C.URI.revive(A),E)}}e.$Hac=g}),define(Ae[242],Fe([1,0,2,4,16,8]),function($e,e,w,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iac=void 0;class P{static{this.a=0}constructor(D,p){this.d=p,this.c=new Map,this.b=D.getProxy(T.$BJ.MainThreadQuickDiff)}$provideOriginalResource(D,p,A){const E=w.URI.revive(p),c=this.c.get(D);return c?(0,C.$og)(()=>c.provideOriginalResource(E,A)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(D,p,A,E){const c=P.a++;return this.c.set(c,p),this.b.$registerQuickDiffProvider(c,M.DocumentSelector.from(D,this.d),A,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(c),this.c.delete(c)}}}}e.$Iac=P}),define(Ae[243],Fe([1,0,20,5,6,4,2,7,11,18,29,40,26,8]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_b=void 0;function b(o,t,i){const a=o.getProxy(M.$BJ.MainThreadQuickOpen);class m{constructor(l,f){this.e=new Map,this.f=0,this.a=l,this.b=f}showQuickPick(l,f,v,u=w.CancellationToken.None){this.c=void 0;const d=Promise.resolve(f),R=++this.f,W=a.$show(R,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},u),B={},q=W.then(()=>B);return Promise.race([q,d]).then(U=>{if(U===B)return;const N=(0,c.$yF)(l,"quickPickItemTooltip");return d.then(O=>{const ce=[];for(let X=0;X<O.length;X++){const be=O[X];if(typeof be=="string")ce.push({label:be,handle:X});else if(be.kind===g.QuickPickItemKind.Separator)ce.push({type:"separator",label:be.label});else{be.tooltip&&!N&&console.warn(`Extension '${l.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`);const Ee=be.iconPath?n(be.iconPath):void 0;ce.push({label:be.label,iconPath:Ee?.iconPath,iconClass:Ee?.iconClass,description:be.description,detail:be.detail,picked:be.picked,alwaysShow:be.alwaysShow,tooltip:N?y.MarkdownString.fromStrict(be.tooltip):void 0,handle:X})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=X=>{v.onDidSelectItem(O[X])}),a.$setItems(R,ce),W.then(X=>{if(typeof X=="number")return O[X];if(Array.isArray(X))return X.map(be=>O[be])})})}).then(void 0,U=>{if(!(0,D.$2)(U))return a.$setError(R,U),Promise.reject(U)})}$onItemSelected(l){this.c?.(l)}showInput(l,f=w.CancellationToken.None){return this.d=l?.validateInput,a.$input(l,typeof this.d=="function",f).then(void 0,v=>{if(!(0,D.$2)(v))return Promise.reject(v)})}async $validateInput(l){if(!this.d)return;const f=await this.d(l);if(!f||typeof f=="string")return f;let v;switch(f.severity){case g.InputBoxValidationSeverity.Info:v=A.default.Info;break;case g.InputBoxValidationSeverity.Warning:v=A.default.Warning;break;case g.InputBoxValidationSeverity.Error:v=A.default.Error;break;default:v=f.message?A.default.Error:A.default.Ignore;break}return{content:f.message,severity:v}}async showWorkspaceFolderPick(l,f=w.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!v)return;const u=await this.a.getWorkspaceFolders2();if(u)return u.find(d=>d.uri.toString()===v.uri.toString())}createQuickPick(l){const f=new s(l,()=>this.e.delete(f._id));return this.e.set(f._id,f),f}createInputBox(l){const f=new $(l,()=>this.e.delete(f._id));return this.e.set(f._id,f),f}$onDidChangeValue(l,f){this.e.get(l)?._fireDidChangeValue(f)}$onDidAccept(l){this.e.get(l)?._fireDidAccept()}$onDidChangeActive(l,f){const v=this.e.get(l);v instanceof s&&v._fireDidChangeActive(f)}$onDidChangeSelection(l,f){const v=this.e.get(l);v instanceof s&&v._fireDidChangeSelection(f)}$onDidTriggerButton(l,f){this.e.get(l)?._fireDidTriggerButton(f)}$onDidTriggerItemButton(l,f,v){const u=this.e.get(l);u instanceof s&&u._fireDidTriggerItemButton(f,v)}$onDidHide(l){this.e.get(l)?._fireDidHide()}}class S{static{this.a=1}constructor(l,f){this.x=l,this.y=f,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$8c,this.q=new T.$8c,this.r=new T.$8c,this.s=new T.$8c,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(l){this.b=l,this.z({title:l})}get step(){return this.c}set step(l){this.c=l,this.z({step:l})}get totalSteps(){return this.d}set totalSteps(l){this.d=l,this.z({totalSteps:l})}get enabled(){return this.g}set enabled(l){this.g=l,this.z({enabled:l})}get busy(){return this.j}set busy(l){this.j=l,this.z({busy:l})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(l){this.k=l,this.z({ignoreFocusOut:l})}get value(){return this.l}set value(l){this.l=l,this.z({value:l})}get placeholder(){return this.m}set placeholder(l){this.m=l,this.z({placeholder:l})}get buttons(){return this.n}set buttons(l){this.n=l.slice(),this.o.clear(),l.forEach((f,v)=>{const u=f===g.$YK.Back?-1:v;this.o.set(u,f)}),this.z({buttons:l.map((f,v)=>({...n(f.iconPath),tooltip:f.tooltip,handle:f===g.$YK.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(l){this.l=l,this.q.fire(l)}_fireDidTriggerButton(l){const f=this.o.get(l);f&&this.r.fire(f)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$gb)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),a.$dispose(this._id))}z(l){if(!this.v){for(const f of Object.keys(l)){const v=l[f];this.u[f]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){a.$createOrUpdate(this.u),this.u={id:this._id}}}function I(k){if(k instanceof g.$yK)return{id:k.id};const l=h(k),f=r(k);return{dark:typeof l=="string"?P.URI.file(l):l,light:typeof f=="string"?P.URI.file(f):f}}function r(k){return typeof k=="object"&&"light"in k?k.light:k}function h(k){return typeof k=="object"&&"dark"in k?k.dark:k}function n(k){const l=I(k);let f,v;return"id"in l?v=E.ThemeIcon.asClassName(l):f=l,{iconPath:f,iconClass:v}}class s extends S{constructor(l,f){super(l.identifier,f),this.O=l,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$8c,this.L=[],this.M=new T.$8c,this.N=new T.$8c,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(l){this.B=l.slice(),this.C.clear(),this.D.clear(),l.forEach((u,d)=>{this.C.set(d,u),this.D.set(u,d)});const f=(0,c.$yF)(this.O,"quickPickItemTooltip"),v=[];for(let u=0;u<l.length;u++){const d=l[u];if(d.kind===g.QuickPickItemKind.Separator)v.push({type:"separator",label:d.label});else{d.tooltip&&!f&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const R=d.iconPath?n(d.iconPath):void 0;v.push({handle:u,label:d.label,iconPath:R?.iconPath,iconClass:R?.iconClass,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,tooltip:f?y.MarkdownString.fromStrict(d.tooltip):void 0,buttons:d.buttons?.map((W,B)=>({...n(W.iconPath),tooltip:W.tooltip,handle:B}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(l){this.E=l,this.z({canSelectMany:l})}get matchOnDescription(){return this.F}set matchOnDescription(l){this.F=l,this.z({matchOnDescription:l})}get matchOnDetail(){return this.G}set matchOnDetail(l){this.G=l,this.z({matchOnDetail:l})}get sortByLabel(){return this.H}set sortByLabel(l){this.H=l,this.z({sortByLabel:l})}get keepScrollPosition(){return this.I}set keepScrollPosition(l){this.I=l,this.z({keepScrollPosition:l})}get activeItems(){return this.J}set activeItems(l){this.J=l.filter(f=>this.D.has(f)),this.z({activeItems:this.J.map(f=>this.D.get(f))})}get selectedItems(){return this.L}set selectedItems(l){this.L=l.filter(f=>this.D.has(f)),this.z({selectedItems:this.L.map(f=>this.D.get(f))})}_fireDidChangeActive(l){const f=(0,p.$mf)(l.map(v=>this.C.get(v)));this.J=f,this.K.fire(f)}_fireDidChangeSelection(l){const f=(0,p.$mf)(l.map(v=>this.C.get(v)));this.L=f,this.M.fire(f)}_fireDidTriggerItemButton(l,f){const v=this.C.get(l);if(!v||!v.buttons||!v.buttons.length)return;const u=v.buttons[f];u&&this.N.fire({button:u,item:v})}}class $ extends S{constructor(l,f){super(l.identifier,f),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(l){this.B=l,this.z({password:l})}get prompt(){return this.C}set prompt(l){this.C=l,this.z({prompt:l})}get valueSelection(){return this.D}set valueSelection(l){this.D=l,this.z({valueSelection:l})}get validationMessage(){return this.E}set validationMessage(l){this.E=l,l?typeof l=="string"?this.z({validationMessage:l,severity:A.default.Error}):this.z({validationMessage:l.message,severity:l.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new m(t,i)}e.$J_b=b}),define(Ae[244],Fe([1,0,2,5,65,6,16,4,18,131,14,21,40,8,26,13]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L_b=e.$K_b=void 0;function t(l){if(l)return typeof l.iconPath=="string"?w.URI.file(l.iconPath):w.URI.isUri(l.iconPath)||c.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function i(l,f){if(!l.iconPath&&!f.iconPath)return 0;if(l.iconPath){if(!f.iconPath)return 1}else return-1;const v=typeof l.iconPath=="string"?l.iconPath:w.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,u=typeof f.iconPath=="string"?f.iconPath:w.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,p.$9p)(v,u)}function a(l,f){let v=0;if(l.strikeThrough!==f.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==f.faded)return l.faded?1:-1;if(l.tooltip!==f.tooltip)return(l.tooltip||"").localeCompare(f.tooltip||"");if(v=i(l,f),v!==0)return v;if(l.light&&f.light)v=i(l.light,f.light);else{if(l.light)return 1;if(f.light)return-1}if(v!==0)return v;if(l.dark&&f.dark)v=i(l.dark,f.dark);else{if(l.dark)return 1;if(f.dark)return-1}return v}function m(l,f){if(l.command!==f.command)return l.command<f.command?-1:1;if(l.title!==f.title)return l.title<f.title?-1:1;if(l.tooltip!==f.tooltip){if(l.tooltip!==void 0&&f.tooltip!==void 0)return l.tooltip<f.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(l.arguments===f.arguments)return 0;if(l.arguments)if(f.arguments){if(l.arguments.length!==f.arguments.length)return l.arguments.length-f.arguments.length}else return 1;else return-1;for(let v=0;v<l.arguments.length;v++){const u=l.arguments[v],d=f.arguments[v];if(u!==d)return u<d?-1:1}return 0}function S(l,f){let v=(0,p.$9p)(l.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(v!==0)return v;if(l.command&&f.command)v=m(l.command,f.command);else{if(l.command)return 1;if(f.command)return-1}if(v!==0)return v;if(l.decorations&&f.decorations)v=a(l.decorations,f.decorations);else{if(l.decorations)return 1;if(f.decorations)return-1}return v}function I(l,f){for(let v=0;v<l.length;v++)if(l[v]!==f[v])return!1;return!0}function r(l,f){return l.command===f.command&&l.title===f.title&&l.tooltip===f.tooltip&&(l.arguments&&f.arguments?I(l.arguments,f.arguments):l.arguments===f.arguments)}function h(l,f){return(0,D.$bf)(l,f,r)}class n{#e;#t;get value(){return this.d}set value(f){f=f??"",this.#e.$setInputBoxValue(this.l,f),this.n(f)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(f){this.#e.$setInputBoxPlaceholder(this.l,f),this.f=f}get validateInput(){return(0,b.$zF)(this.k,"scmValidation"),this.g}set validateInput(f){if((0,b.$zF)(this.k,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=f,this.#e.$setValidationProviderIsEnabled(this.l,!!f)}get enabled(){return this.h}set enabled(f){f=!!f,this.h!==f&&(this.h=f,this.#e.$setInputBoxEnablement(this.l,f))}get visible(){return this.j}set visible(f){f=!!f,this.j!==f&&(this.j=f,this.#e.$setInputBoxVisibility(this.l,f))}get document(){return(0,b.$zF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(f,v,u,d,R){this.k=f,this.l=d,this.m=R,this.d="",this.e=new T.$8c,this.f="",this.h=!0,this.j=!0,this.#t=v,this.#e=u}showValidationMessage(f,v){(0,b.$zF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,f,v)}$onInputBoxValueChange(f){this.n(f)}n(f){this.d=f,this.e.fire(f)}}e.$K_b=n;class s{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(f){this.v=f,this.q.$updateGroupLabel(this.t,this.handle,f)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(f){this.p=f,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(f){this.f=[...f],this.k.fire()}constructor(f,v,u,d,R){this.q=f,this.s=v,this.t=u,this.u=d,this.v=R,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$8c,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$8c,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=s.d++}getResourceState(f){return this.g.get(f)}$executeResourceCommand(f,v){const u=this.h.get(f);return u?(0,P.$og)(()=>this.s.executeCommand(u.command,...u.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this.f].sort(S),u=(0,D.$if)(this.o,f,S).map(W=>{const B=W.toInsert.map(q=>{const U=this.e++;this.g.set(U,q);const N=q.resourceUri;let O;if(q.command)if(q.command.command==="vscode.open"||q.command.command==="vscode.diff"){const ne=new M.$kb;O=this.s.converter.toInternal(q.command,ne),this.j.set(U,ne)}else this.h.set(U,q.command);const ce=t(q.decorations),X=q.decorations&&t(q.decorations.light)||ce,be=q.decorations&&t(q.decorations.dark)||ce,Ee=[X,be],Re=q.decorations&&q.decorations.tooltip||"",Z=q.decorations&&!!q.decorations.strikeThrough,he=q.decorations&&!!q.decorations.faded,Ce=q.contextValue||"";return{rawResource:[U,N,Ee,Re,Z,he,Ce,O],handle:U}});return{start:W.start,deleteCount:W.deleteCount,toInsert:B}}),d=u.map(({start:W,deleteCount:B,toInsert:q})=>[W,B,q.map(U=>U.rawResource)]),R=u.reverse();for(const{start:W,deleteCount:B,toInsert:q}of R){const U=q.map(O=>O.handle),N=this.n.splice(W,B,...U);for(const O of N)this.g.delete(O),this.h.delete(O),this.j.get(O)?.dispose(),this.j.delete(O)}return this.o=f,d}dispose(){this.l=!0,this.m.fire()}}class ${static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(f){this.g!==f&&(this.g=f,this.#e.$updateSourceControl(this.t,{count:f}))}get quickDiffProvider(){return this.h}set quickDiffProvider(f){this.h=f;let v;(0,b.$yF)(this.u,"quickDiffProvider")&&(v=f?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!f,quickDiffLabel:v})}get commitTemplate(){return this.j}set commitTemplate(f){f!==this.j&&(this.j=f,this.#e.$updateSourceControl(this.t,{commitTemplate:f}))}get acceptInputCommand(){return this.l}set acceptInputCommand(f){this.k.value=new M.$kb,this.l=f;const v=this.v.converter.toInternal(f,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:v})}get actionButton(){return(0,b.$zF)(this.u,"scmActionButton"),this.n}set actionButton(f){(0,b.$zF)(this.u,"scmActionButton"),this.m.value=new M.$kb,this.n=f;const v=f!==void 0?{command:this.v.converter.toInternal(f.command,this.m.value),secondaryCommands:f.secondaryCommands?.map(u=>u.map(d=>this.v.converter.toInternal(d,this.m.value))),description:f.description,enabled:f.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:v??null})}get statusBarCommands(){return this.p}set statusBarCommands(f){if(this.p&&f&&h(this.p,f))return;this.o.value=new M.$kb,this.p=f;const v=(f||[]).map(u=>this.v.converter.toInternal(u,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:v})}get selected(){return this.q}constructor(f,v,u,d,R,W,B){this.u=f,this.v=d,this.w=R,this.x=W,this.y=B,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new M.$mb,this.l=void 0,this.m=new M.$mb,this.o=new M.$mb,this.p=void 0,this.q=!1,this.s=new T.$8c,this.onDidChangeSelection=this.s.event,this.t=$.d++,this.z=new Map,this.A=new Set,this.#e=u;const q=w.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${R}/scm${this.t}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new n(f,v,this.#e,this.t,q),this.#e.$registerSourceControl(this.t,R,W,B,q)}createResourceGroup(f,v){const u=new s(this.#e,this.v,this.t,f,v),d=T.Event.once(u.onDidDispose)(()=>this.z.delete(u));return this.z.set(u,d),this.eventuallyAddResourceGroups(),u}eventuallyAddResourceGroups(){const f=[],v=[];for(const[u,d]of this.z){d.dispose();const R=u.onDidUpdateResourceStates(()=>{this.A.add(u),this.eventuallyUpdateResourceStates()});T.Event.once(u.onDidDispose)(()=>{this.A.delete(u),R.dispose(),this.e.delete(u.handle),this.#e.$unregisterGroup(this.t,u.handle)}),f.push([u.handle,u.id,u.label,u.features]);const W=u._takeResourceStateSnapshot();W.length>0&&v.push([u.handle,W]),this.e.set(u.handle,u)}this.#e.$registerGroups(this.t,f,v),this.z.clear()}eventuallyUpdateResourceStates(){const f=[];this.A.forEach(v=>{const u=v._takeResourceStateSnapshot();u.length!==0&&f.push([v.handle,u])}),f.length>0&&this.#e.$spliceResourceStates(this.t,f),this.A.clear()}getResourceGroup(f){return this.e.get(f)}setSelectionState(f){this.q=f,this.s.fire(f)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(f=>f.dispose()),this.#e.$unregisterSourceControl(this.t)}}Ve([(0,C.$Ug)(100)],$.prototype,"eventuallyAddResourceGroups",null),Ve([(0,C.$Ug)(100)],$.prototype,"eventuallyUpdateResourceStates",null);let k=class En{static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(f,v,u,d){this.l=v,this.m=u,this.n=d,this.g=new Map,this.h=new E.$Jl,this.j=new T.$8c,this.e=f.getProxy(g.$BJ.MainThreadSCM),this.f=f.getProxy(g.$BJ.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const W=this.g.get(R.sourceControlHandle);if(!W)return R;const B=W.getResourceGroup(R.groupHandle);return B?B.getResourceState(R.handle):R}else if(R&&R.$mid===4){const W=this.g.get(R.sourceControlHandle);return W?W.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const W=this.g.get(R.handle);return W||R}return R}})}createSourceControl(f,v,u,d){this.n.trace("ExtHostSCM#createSourceControl",f.identifier.value,v,u,d),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const R=En.d++,W=new $(f,this.m,this.e,this.l,v,u,d);this.g.set(R,W);const B=this.h.get(f.identifier)||[];return B.push(W),this.h.set(f.identifier,B),W}getLastInputBox(f){this.n.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const v=this.h.get(f.identifier),u=v&&v[v.length-1];return u&&u.inputBox}$provideOriginalResource(f,v,u){const d=w.URI.revive(v);this.n.trace("ExtHostSCM#$provideOriginalResource",f,d.toString());const R=this.g.get(f);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.$og)(()=>R.quickDiffProvider.provideOriginalResource(d,u)).then(W=>W||null)}$onInputBoxValueChange(f,v){this.n.trace("ExtHostSCM#$onInputBoxValueChange",f);const u=this.g.get(f);return u&&u.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(f,v,u,d){this.n.trace("ExtHostSCM#$executeResourceCommand",f,v,u);const R=this.g.get(f);if(!R)return Promise.resolve(void 0);const W=R.getResourceGroup(v);return W?W.$executeResourceCommand(u,d):Promise.resolve(void 0)}$validateInput(f,v,u){this.n.trace("ExtHostSCM#$validateInput",f);const d=this.g.get(f);return!d||!d.inputBox.validateInput?Promise.resolve(void 0):(0,P.$og)(()=>d.inputBox.validateInput(v,u)).then(R=>{if(!R)return Promise.resolve(void 0);const W=y.MarkdownString.fromStrict(R.message);return W?Promise.resolve([W,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this.g.get(f)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=f,Promise.resolve(void 0)}};e.$L_b=k,e.$L_b=k=Ve([qe(3,A.$Ri)],k)}),define(Ae[82],Fe([1,0,4,5,3]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r_b=e.$q_b=void 0;class M{constructor(g){this.b=new T.$8c,this.onDidChangePassword=this.b.event,this.a=g.getProxy(w.$BJ.MainThreadSecretState)}async $onDidChangePassword(g){this.b.fire(g)}get(g,D){return this.a.$getPassword(g,D)}store(g,D,p){return this.a.$setPassword(g,D,p)}delete(g,D){return this.a.$deletePassword(g,D)}}e.$q_b=M,e.$r_b=(0,C.$ph)("IExtHostSecretState")}),define(Ae[245],Fe([1,0,4,7]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mac=void 0;class C{constructor(P){this.a=new Map,this.b=0,this.c=P.getProxy(w.$BJ.MainThreadSemanticSimilarity)}async $provideSimilarityScore(P,g,D,p){if(this.a.size===0)throw new Error("No semantic similarity providers registered");const A=this.a.get(P);if(!A)throw new Error("Semantic similarity provider not found");return await A.provideSimilarityScore(g,D,p)}registerSemanticSimilarityProvider(P,g){const D=this.b;return this.b++,this.a.set(D,g),this.c.$registerSemanticSimilarityProvider(D),new T.$DJ(()=>{this.c.$unregisterSemanticSimilarityProvider(D),this.a.delete(D)})}}e.$Mac=C}),define(Ae[246],Fe([1,0,4,8,2]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oac=void 0;class M{static{this.a=0}constructor(g,D){this.d=D,this.c=new Map,this.b=g.getProxy(w.$BJ.MainThreadShare)}async $provideShare(g,D,p){return await this.c.get(g)?.provideShare({selection:T.Range.to(D.selection),resourceUri:C.URI.revive(D.resourceUri)},p)??void 0}registerShareProvider(g,D){const p=M.a++;return this.c.set(p,D),this.b.$registerShareProvider(p,T.DocumentSelector.from(g,this.d),D.id,D.label,D.priority),{dispose:()=>{this.b.$unregisterShareProvider(p),this.c.delete(p)}}}}e.$Oac=M}),define(Ae[247],Fe([1,0,7,4,153,6,8,12]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N_b=e.$M_b=void 0;class D{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$zK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$zK("statusBarItem.warningForeground")]])}#e;#t;constructor(c,y,b,o,t,i=w.StatusBarAlignment.Left,a){if(this.i=!1,this.k="",this.q=new M.$kb,this.#e=c,this.#t=y,t&&o){this.c=(0,w.$cK)(o.identifier,t);const m=b.get(this.c);m&&(i=m.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,a=m.priority,this.j=!0,this.name=m.name,this.text=m.text,this.tooltip=m.tooltip,this.command=m.command,this.accessibilityInformation=m.accessibilityInformation)}else this.c=String(D.a++);this.e=o,this.f=t,this.g=i,this.h=this.u(a)}u(c){if((0,g.$ne)(c))return c===Number.POSITIVE_INFINITY?Number.MAX_VALUE:c===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:c}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(c){this.k=c,this.v()}set name(c){this.m=c,this.v()}set tooltip(c){this.l=c,this.v()}set color(c){this.n=c,this.v()}set backgroundColor(c){c&&!D.b.has(c.id)&&(c=void 0),this.o=c,this.v()}set command(c){this.r?.fromApi!==c&&(this.p&&this.q.add(this.p),this.p=new M.$kb,typeof c=="string"?this.r={fromApi:c,internal:this.#t.toInternal({title:"",command:c},this.p)}:c?this.r={fromApi:c,internal:this.#t.toInternal(c,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(c){this.t=c,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let c;this.e?this.f?c=`${this.e.identifier.value}.${this.f}`:c=this.e.identifier.value:c=this.f;let y;this.m?y=this.m:y=(0,C.localize)(0,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=D.b.get(this.o.id));const o=P.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,c,this.e?.identifier.value,y,this.k,o,this.r?.internal,b,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$M_b=D;class p{constructor(c){this.b=[],this.a=c.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(c){const y={message:c};return this.b.unshift(y),this.c(),new w.$DJ(()=>{const b=this.b.indexOf(y);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(c,y){this.e=new Map,this.a=c.getProxy(T.$BJ.MainThreadStatusBar),this.b=y,this.c=new p(this)}$acceptStaticEntries(c){for(const y of c)this.e.set(y.entryId,y)}createStatusBarEntry(c,y,b,o){return new D(this.a,this.b,this.e,c,y,b,o)}setStatusBarMessage(c,y){const b=this.c.setMessage(c);let o;return typeof y=="number"?o=setTimeout(()=>b.dispose(),y):typeof y<"u"&&y.then(()=>b.dispose(),()=>b.dispose()),new w.$DJ(()=>{b.dispose(),clearTimeout(o)})}}e.$N_b=A}),define(Ae[83],Fe([1,0,4,5,3]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f_b=e.$e_b=void 0;class M{constructor(g,D){this.c=D,this.b=new T.$8c,this.onDidChangeStorage=this.b.event,this.a=g.getProxy(w.$BJ.MainThreadStorage)}registerExtensionStorageKeysToSync(g,D){this.a.$registerExtensionStorageKeysToSync(g,D)}async initializeExtensionStorage(g,D,p){const A=await this.a.$initializeExtensionStorage(g,D);let E;return A&&(E=this.d(g,D,A)),E||p}setValue(g,D,p){return this.a.$setValue(g,D,p)}$acceptValue(g,D,p){const A=this.d(g,D,p);A&&this.b.fire({shared:g,key:D,value:A})}d(g,D,p){try{return JSON.parse(p)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${g}): ${A}`)}}}e.$e_b=M,e.$f_b=(0,C.$ph)("IExtHostStorage")}),define(Ae[84],Fe([1,0,3,27,14,62,2]),function($e,e,w,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l_b=e.$k_b=void 0,e.$k_b=(0,w.$ph)("IExtensionStoragePaths");let g=class{constructor(p,A,E){this.d=A,this.f=E,this.a=p.workspace??void 0,this.b=p.environment,this.whenReady=this.h().then(c=>this.c=c)}async g(p){return P.URI.joinPath(this.b.workspaceStorageHome,p)}async h(){if(!this.a)return Promise.resolve(void 0);const p=this.a.id,A=await this.g(p);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(P.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:P.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(p){if(this.c)return P.URI.joinPath(this.c,p.identifier.value)}globalValue(p){return P.URI.joinPath(this.b.globalStorageHome,p.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$l_b=g,e.$l_b=g=Ve([qe(0,T.$TL),qe(1,C.$Ri),qe(2,M.$j_b)],g)}),define(Ae[63],Fe([1,0,5,4,3,2,17,6,7,155,11,182,20,36,183,40,12,16,8,26]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t,i,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p_b=e.$o_b=e.$n_b=e.$m_b=void 0,e.$m_b=(0,C.$ph)("IExtHostTerminalService");class S{constructor(u,d,R,W){this.k=u,this._id=d,this.l=R,this.m=W,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(q=>this.f=q);const B=this;this.value={get name(){return B.m||""},get processId(){return B.b},get creationOptions(){return B.l},get exitStatus(){return B.h},get state(){return B.i},get selection(){return B.j},sendText(q,U=!0){B.o(),B.k.$sendText(B._id,q,U)},show(q){B.o(),B.k.$show(B._id,q)},hide(){B.o(),B.k.$hide(B._id)},dispose(){B.a||(B.a=!0,B.k.$dispose(B._id))},get dimensions(){if(!(B.d===void 0||B.g===void 0))return{columns:B.d,rows:B.g}}}}async create(u,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:u.name,shellPath:(0,t.$Be)(u.shellPath),shellArgs:(0,t.$Be)(u.shellArgs),cwd:(0,t.$Be)(u.cwd),env:(0,t.$Be)(u.env),icon:(0,t.$Be)(k(u.iconPath)),color:o.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,t.$Be)(u.message),strictEnv:(0,t.$Be)(u.strictEnv),hideFromUser:(0,t.$Be)(u.hideFromUser),isFeatureTerminal:(0,t.$Be)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,t.$Be)(d?.useShellEnvironment),location:d?.location||this.n(u.location,d?.resolvedExtHostIdentifier),isTransient:(0,t.$Be)(u.isTransient)})}async createExtensionTerminal(u,d,R,W){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:R,color:o.ThemeColor.isThemeColor(W)?W.id:void 0,location:this.n(u,d),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(u,d){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&d?{parentTerminal:d}:"viewColumn"in u?{viewColumn:a.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.m=u}setExitStatus(u,d){this.h=Object.freeze({code:u,reason:d})}setDimensions(u,d){return u===this.d&&d===this.g||u===0||d===0?!1:(this.d=u,this.g=d,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}setSelection(u){this.j=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(d=>{d!==u&&(this.b=Promise.resolve(u))})}}e.$n_b=S;class I{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new w.$8c,this.onProcessData=this.a.event,this.b=new w.$8c,this.d=new w.$8c,this.onDidChangeProperty=this.d.event,this.f=new w.$8c,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,d){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${d}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,d){this.g.setDimensions?.({columns:u,rows:d})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(d=>this.a.fire(d)),this.g.onDidClose?.((d=void 0)=>{this.f.fire(d===void 0?void 0:d)}),this.g.onDidOverrideDimensions?.(d=>{d&&this.d.fire({type:"overrideDimensions",value:{cols:d.columns,rows:d.rows}})}),this.g.onDidChangeName?.(d=>{this.d.fire({type:"title",value:d})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let r=1,h=class extends g.$lb{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}get onDidWriteTerminalData(){return this.H.event}constructor(u,d){super(),this.f=[],this.g=new Map,this.h={},this.i={},this.j={},this.k=new Map,this.s=new Set,this.u=new Map,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new w.$8c,this.onDidCloseTerminal=this.z.event,this.C=new w.$8c,this.onDidOpenTerminal=this.C.event,this.D=new w.$8c,this.onDidChangeActiveTerminal=this.D.event,this.F=new w.$8c,this.onDidChangeTerminalDimensions=this.F.event,this.G=new w.$8c,this.onDidChangeTerminalState=this.G.event,this.I=new w.$8c,this.onDidChangeShell=this.I.event,this.a=d.getProxy(T.$BJ.MainThreadTerminalService),this.n=new b.$bjb(this.a.$sendProcessData),this.H=new w.$8c({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(u),this.B({dispose:()=>{for(const[R,W]of this.g)W.shutdown(!0)}})}getDefaultShell(u){return(u?this.m:this.l)?.path||""}getDefaultShellArgs(u){return(u?this.m:this.l)?.args||[]}createExtensionTerminal(u,d){const R=new S(this.a,(0,y.$6e)(),u,u.name),W=new I(u.pty);return R.createExtensionTerminal(u.location,this.J(u,d).resolvedExtHostIdentifier,k(u.iconPath),l(u.color)).then(B=>{const q=this.L(B,W);this.h[B]=q}),this.f.push(R),R.value}J(u,d){if(d=d||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const R=u.location.parentTerminal;if(R){const W=this.f.find(B=>B.value===R);W&&(d.resolvedExtHostIdentifier=W._id)}}else u.location&&typeof u.location!="object"?d.location=u.location:d.location&&typeof d.location=="object"&&"splitActiveTerminal"in d.location&&(d.location={splitActiveTerminal:!0});return d}attachPtyToTerminal(u,d){if(!this.N(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const W=new I(d),B=this.L(u,W);this.h[u]=B}async $acceptActiveTerminalChanged(u){const d=this.b;if(u===null){this.b=void 0,d!==this.b&&this.D.fire(this.b);return}const R=this.N(u);R&&(this.b=R,d!==this.b&&this.D.fire(this.b.value))}async $acceptTerminalProcessData(u,d){const R=this.N(u);R&&this.H.fire({terminal:R.value,data:d})}async $acceptTerminalDimensions(u,d,R){const W=this.N(u);W&&W.setDimensions(d,R)&&this.F.fire({terminal:W.value,dimensions:W.value.dimensions})}async $acceptTerminalMaximumDimensions(u,d,R){this.g.get(u)?.resize(d,R)}async $acceptTerminalTitleChange(u,d){const R=this.N(u);R&&(R.name=d)}async $acceptTerminalClosed(u,d,R){const W=this.P(this.f,u);if(W!==null){const B=this.f.splice(W,1)[0];B.setExitStatus(d,R),this.z.fire(B.value)}}$acceptTerminalOpened(u,d,R,W){if(d){const U=this.P(this.f,d);if(U!==null){this.f[U]._id=u,this.C.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const B={name:W.name,shellPath:W.executable,shellArgs:W.args,cwd:typeof W.cwd=="string"?W.cwd:M.URI.revive(W.cwd),env:W.env,hideFromUser:W.hideFromUser},q=new S(this.a,u,B,R);this.f.push(q),this.C.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(u,d){this.N(u)?._setProcessId(d)}async $startExtensionTerminal(u,d){const R=this.N(u);if(!R)return{message:(0,p.localize)(0,null,u)};R.isOpen||await new Promise(B=>{const q=this.onDidOpenTerminal(async U=>{U===R.value&&(q.dispose(),B())})});const W=this.g.get(u);W?W.startSendingEvents(d):this.i[u]={initialDimensions:d}}L(u,d){const R=new g.$kb;R.add(d.onProcessReady(B=>this.a.$sendProcessReady(u,B.pid,B.cwd,B.windowsPty))),R.add(d.onDidChangeProperty(B=>this.a.$sendProcessProperty(u,B))),this.n.startBuffering(u,d.onProcessData),R.add(d.onProcessExit(B=>this.M(u,B))),this.g.set(u,d);const W=this.i[u];return W&&d instanceof I&&(d.startSendingEvents(W.initialDimensions),delete this.i[u]),R}$acceptProcessAckDataEvent(u,d){this.g.get(u)?.acknowledgeDataEvent(d)}$acceptProcessInput(u,d){this.g.get(u)?.input(d)}$acceptTerminalInteraction(u){const d=this.N(u);d?.setInteractedWith()&&this.G.fire(d.value)}$acceptTerminalSelection(u,d){this.N(u)?.setSelection(d)}$acceptProcessResize(u,d,R){try{this.g.get(u)?.resize(d,R)}catch(W){if(W.code!=="EPIPE"&&W.code!=="ERR_IPC_CHANNEL_CLOSED")throw W}}$acceptProcessShutdown(u,d){this.g.get(u)?.shutdown(d)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(d=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:d}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(d=>this.a.$sendProcessProperty(u,{type:"cwd",value:d}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.s.add(u),this.s.size===1&&this.a.$startLinkProvider(),new D.$DJ(()=>{this.s.delete(u),this.s.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,d,R){if(this.u.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this.u.set(d,R),this.a.$registerProfileProvider(d,u.identifier.value),new D.$DJ(()=>{this.u.delete(d),this.a.$unregisterProfileProvider(d)})}registerTerminalQuickFixProvider(u,d,R){if(this.v.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.v.set(u,R),this.a.$registerQuickFixProvider(u,d),new D.$DJ(()=>{this.v.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,d){const R=new c.$ed().token;if(R.isCancellationRequested)return;const W=this.v.get(u);if(!W)return;const B=await W.provideTerminalQuickFixes(d,R);if(B!==null)return B}async $createContributedProfileTerminal(u,d){const R=new c.$ed().token;let W=await this.u.get(u)?.provideTerminalProfile(R);if(!R.isCancellationRequested){if(W&&!("options"in W)&&(W={options:W}),!W||!("options"in W))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in W.options){this.createExtensionTerminal(W.options,d);return}this.createTerminalFromOptions(W.options,d)}}async $provideLinks(u,d){const R=this.N(u);if(!R)return[];this.w.delete(u),this.y.get(u)?.dispose(!0);const B=new c.$ed;this.y.set(u,B);const q=[],U={terminal:R.value,line:d},N=[];for(const X of this.s)N.push(i.Promises.withAsyncBody(async be=>{B.token.onCancellationRequested(()=>be({provider:X,links:[]}));const Ee=await X.provideTerminalLinks(U,B.token)||[];B.token.isCancellationRequested||be({provider:X,links:Ee})}));const O=await Promise.all(N);if(B.token.isCancellationRequested)return[];const ce=new Map;for(const X of O)X&&X.links.length>0&&q.push(...X.links.map(be=>{const Ee={id:r++,startIndex:be.startIndex,length:be.length,label:be.tooltip};return ce.set(Ee.id,{provider:X.provider,link:be}),Ee}));return this.w.set(u,ce),q}$activateLink(u,d){const R=this.w.get(u)?.get(d);R&&R.provider.handleTerminalLink(R.link)}M(u,d){this.n.stopBuffering(u),this.g.delete(u),delete this.i[u];const R=this.h[u];R&&(R.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,d)}N(u){return this.O(this.f,u)}O(u,d){const R=this.P(u,d);return R!==null?u[R]:null}P(u,d){const R=u.findIndex(W=>W._id===d);return R===-1?null:R}getEnvironmentVariableCollection(u){let d=this.k.get(u.identifier.value);return d||(d=new n(u),this.R(u.identifier.value,d)),d.getScopedEnvironmentVariableCollection(void 0)}Q(u,d){const R=(0,E.$Zq)(d.map),W=(0,E.$1q)(d.descriptionMap);this.a.$setEnvironmentVariableCollection(u,d.persistent,R.length===0?void 0:R,W)}$initEnvironmentVariableCollections(u){u.forEach(d=>{const R=d[0],W=new n(void 0,d[1]);this.R(R,W)})}$acceptDefaultProfile(u,d){const R=this.l;this.l=u,this.m=d,R?.path!==u.path&&this.I.fire(u.path)}R(u,d){this.k.set(u,d),d.onDidChangeCollection(()=>{this.Q(u,d)})}};e.$o_b=h,e.$o_b=h=Ve([qe(1,P.$DL)],h);class n{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u,d){this.f=u,this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new w.$8c,this.map=new Map(d)}getScopedEnvironmentVariableCollection(u){this.f&&u&&(0,m.$zF)(this.f,"envCollectionWorkspace");const d=this.i(u);let R=this.a.get(d);return R||(R=new s(this,u),this.a.set(d,R),R.onDidChangeCollection(()=>this.d.fire())),R}replace(u,d,R,W){this.f&&R&&(0,m.$zF)(this.f,"envCollectionOptions"),this.g(u,{value:d,type:D.EnvironmentVariableMutatorType.Replace,options:R??{},scope:W})}append(u,d,R,W){this.f&&R&&(0,m.$zF)(this.f,"envCollectionOptions"),this.g(u,{value:d,type:D.EnvironmentVariableMutatorType.Append,options:R??{},scope:W})}prepend(u,d,R,W){this.f&&R&&(0,m.$zF)(this.f,"envCollectionOptions"),this.g(u,{value:d,type:D.EnvironmentVariableMutatorType.Prepend,options:R??{},scope:W})}g(u,d){if(d.options&&d.options.applyAtProcessCreation===!1&&!d.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const R=this.h(u,d.scope),W=this.map.get(R);if(!W||W.value!==d.value||W.type!==d.type||W.options?.applyAtProcessCreation!==(d.options.applyAtProcessCreation??!0)||W.options?.applyAtShellIntegration!==(d.options.applyAtShellIntegration??!1)||W.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index){const B=this.h(u,d.scope),q={variable:u,...d,options:{applyAtProcessCreation:d.options.applyAtProcessCreation??!0,applyAtShellIntegration:d.options.applyAtShellIntegration??!1}};this.map.set(B,q),this.d.fire()}}get(u,d){const R=this.h(u,d),W=this.map.get(R);return W?f(W):void 0}h(u,d){const R=this.i(d);return R.length?`${u}:::${R}`:u}i(u){return this.j(u?.workspaceFolder)??""}j(u){return u?u.uri.toString():void 0}getVariableMap(u){const d=new Map;for(const[R,W]of this.map)this.i(W.scope)===this.i(u)&&d.set(W.variable,f(W));return d}delete(u,d){const R=this.h(u,d);this.map.delete(R),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[d,R]of this.map)R.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(d);this.k(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,d){const R=this.i(d),W=this.descriptionMap.get(R);if(!W||W.description!==u){let B;typeof u=="string"?B=u:B=u?.value.split(`

`)[0];const q={description:B,scope:d};this.descriptionMap.set(R,q),this.d.fire()}}getDescription(u){const d=this.i(u);return this.descriptionMap.get(d)?.description}k(u){const d=this.i(u);this.descriptionMap.delete(d)}}class s{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,d){this.b=u,this.d=d,this.a=new w.$8c}getScopedEnvironmentVariableCollection(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,d,R){this.b.replace(u,d,R,this.d)}append(u,d,R){this.b.append(u,d,R,this.d)}prepend(u,d,R){this.b.prepend(u,d,R,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,d){this.b.getVariableMap(this.d).forEach((R,W)=>u.call(d,W,R,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let $=class extends h{constructor(u){super(!1,u)}createTerminal(u,d,R){throw new A.$$}createTerminalFromOptions(u,d){throw new A.$$}};e.$p_b=$,e.$p_b=$=Ve([qe(0,P.$DL)],$);function k(v){if(!(!v||typeof v=="string"))return"id"in v?{id:v.id,color:v.color}:v}function l(v){return o.ThemeColor.isThemeColor(v)?v:void 0}function f(v){const u={...v};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(Ae[248],Fe([1,0,18,16,25,20,5,203,92,6,24,12,36,4,17,104,8,7,45,75,57]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t,i,a,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zac=e.$yac=e.$xac=e.$wac=void 0;let I=class{constructor(B,q,U){this.j=U,this.c=new P.$8c,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=B.getProxy(y.$BJ.MainThreadTesting),this.h=new u(this.f),this.g=new s(this.f),q.registerArgumentProcessor({processArgument:N=>{if(N?.$mid!==15)return N;const O=N,ce=O.tests[O.tests.length-1].item.extId;return this.d.get(a.$nI.root(ce))?.collection.tree.get(ce)?.actual??(0,o.$PL)(N)}}),q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await q.executeCommand("_testing.getExplorerSelection"),O=ce=>{const X=this.d.get(a.$nI.root(ce));if(X)return a.$nI.isRoot(ce)?X.controller:X.collection.tree.get(ce)?.actual};return{include:N?.include.map(O).filter(E.$re)||[],exclude:N?.exclude.map(O).filter(E.$re)||[]}})}createTestController(B,q,U,N){if(this.d.has(q))throw new Error(`Attempt to insert a duplicate controller with ID "${q}"`);const O=new p.$kb,ce=O.add(new o.$SL(q,U,this.j));ce.root.label=U;const X=new Map,be=this.f,Ee={items:ce.root.children,get label(){return U},set label(Z){U=Z,ce.root.label=Z,be.$updateController(q,{label:U})},get refreshHandler(){return N},set refreshHandler(Z){N=Z,be.$updateController(q,{canRefresh:!!Z})},get id(){return q},createRunProfile:(Z,he,Ce,H,ne,re)=>{let L=(0,D.$di)(Z);for(;X.has(L);)L++;return new d(this.f,X,q,L,Z,he,Ce,H,ne,re)},createTestItem(Z,he,Ce){return new o.$QL(q,Z,he,Ce)},createTestRun:(Z,he,Ce=!0)=>this.g.createTestRun(q,ce,Z,he,Ce),invalidateTestResults:Z=>{if(Z===void 0)this.f.$markTestRetired(void 0);else{const he=Z instanceof Array?Z:[Z];this.f.$markTestRetired(he.map(Ce=>a.$nI.fromExtHostTestItem(Ce,q).toString()))}},set resolveHandler(Z){ce.resolveHandler=Z},get resolveHandler(){return ce.resolveHandler},dispose:()=>{O.dispose()}};be.$registerTestController(q,U,!!N),O.add((0,p.$jb)(()=>be.$unregisterTestController(q)));const Re={controller:Ee,collection:ce,profiles:X};return this.d.set(q,Re),O.add((0,p.$jb)(()=>this.d.delete(q))),O.add(ce.onDidGenerateDiff(Z=>be.$publishDiff(q,Z.map(S.TestsDiffOp.serialize)))),Ee}createTestObserver(){return this.h.checkout()}async runTests(B,q=M.CancellationToken.None){const U=$(B);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.d.get(U.controllerId);if(!N)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:B.include?.map(O=>a.$nI.fromExtHostTestItem(O,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:R[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:B.exclude?.map(O=>O.id)},q)}$syncTests(){for(const{collection:B}of this.d.values())B.flushDiff();return Promise.resolve()}$provideFileCoverage(B,q,U){return(0,w.$Lf)(this.g.trackers,O=>O.id===B?O.getCoverage(q):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(B,q,U,N){return(0,w.$Lf)(this.g.trackers,ce=>ce.id===B?ce.getCoverage(q):void 0)?.resolveFileCoverage(U,N)??Promise.resolve([])}$configureRunProfile(B,q){this.d.get(B)?.profiles.get(q)?.configureHandler?.()}async $refreshTests(B,q){await this.d.get(B)?.controller.refreshHandler?.(q)}$publishTestResults(B){this.results=Object.freeze(B.map(q=>(0,A.$Im)(t.TestResults.to(q))).concat(this.results).sort((q,U)=>U.completedAt-q.completedAt).slice(0,32)),this.c.fire()}async $expandTest(B,q){const U=this.d.get(a.$nI.fromString(B).controllerId)?.collection;U&&(await U.expand(B,q<0?1/0:q),U.flushDiff())}$acceptDiff(B){this.h.applyDiff(B.map(S.TestsDiffOp.deserialize))}async $runControllerTests(B,q){return Promise.all(B.map(U=>this.k(U,!1,q)))}async $startContinuousRun(B,q){const U=new M.$ed(q),N=await Promise.all(B.map(O=>this.k(O,!0,U.token)));return!q.isCancellationRequested&&!N.some(O=>O.error)&&await new Promise(O=>q.onCancellationRequested(O)),U.dispose(!0),N}async k(B,q,U){const N=this.d.get(B.controllerId);if(!N)return{};const{collection:O,profiles:ce}=N,X=ce.get(B.profileId);if(!X)return{};const be=B.testIds.map(he=>O.tree.get(he)).filter(E.$re),Ee=B.excludeExtIds.map(he=>N.collection.tree.get(he)).filter(E.$re).filter(he=>be.some(Ce=>Ce.fullId.compare(he.fullId)===2));if(!be.length)return{};const Re=new i.$aL(be.some(he=>he.actual instanceof o.$RL)?void 0:be.map(he=>he.actual),Ee.map(he=>he.actual),X,q),Z=(0,S.$pI)(B)&&this.g.prepareForMainThreadTestRun(Re,k.fromInternal(B,N.collection),U);try{return await X.runHandler(Re,U),{}}catch(he){return{error:String(he)}}finally{Z&&(Z.hasRunningTasks&&!U.isCancellationRequested&&await P.Event.toPromise(Z.onEnd),Z.dispose())}}$cancelExtensionTestRun(B){B===void 0?this.g.cancelAllRuns():this.g.cancelRunById(B)}};e.$wac=I,e.$wac=I=Ve([qe(0,b.$DL)],I);const r=1e4;var h;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(h||(h={}));class n extends p.$lb{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(B,q,U){super(),this.k=B,this.l=q,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new P.$8c),this.onEnd=this.j.event,this.h=this.B(new M.$ed(U));const N=this.B(new T.$Gg(()=>this.m(),r));this.B(this.h.token.onCancellationRequested(()=>N.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(B){return this.f.get(B)?.coverage}createRun(B){const q=this.k.id,U=this.k.controllerId,N=(0,c.$6e)(),O=new l(this.l,q,N),ce=Re=>(Z,...he)=>{if(be){console.warn(`Setting the state of test "${Z.id}" is a no-op after the run ends.`);return}this.k.isIncluded(Z)&&(this.s(Z),Re(Z,...he))},X=(Re,Z)=>{const he=Z instanceof Array?Z.map(t.TestMessage.from):[t.TestMessage.from(Z)];if(Re.uri&&Re.range){const Ce={range:t.Range.from(Re.range),uri:Re.uri};for(const H of he)H.location=H.location||Ce}this.l.$appendTestMessagesInRun(q,N,a.$nI.fromExtHostTestItem(Re,U).toString(),he)};let be=!1;const Ee={isPersisted:this.k.isPersisted,token:this.h.token,name:B,get coverageProvider(){return O.coverageProvider},set coverageProvider(Re){O.coverageProvider=Re},enqueued:ce(Re=>{this.l.$updateTestStateInRun(q,N,a.$nI.fromExtHostTestItem(Re,U).toString(),1)}),skipped:ce(Re=>{this.l.$updateTestStateInRun(q,N,a.$nI.fromExtHostTestItem(Re,U).toString(),5)}),started:ce(Re=>{this.l.$updateTestStateInRun(q,N,a.$nI.fromExtHostTestItem(Re,U).toString(),2)}),errored:ce((Re,Z,he)=>{X(Re,Z),this.l.$updateTestStateInRun(q,N,a.$nI.fromExtHostTestItem(Re,U).toString(),6,he)}),failed:ce((Re,Z,he)=>{X(Re,Z),this.l.$updateTestStateInRun(q,N,a.$nI.fromExtHostTestItem(Re,U).toString(),4,he)}),passed:ce((Re,Z)=>{this.l.$updateTestStateInRun(q,N,a.$nI.fromExtHostTestItem(Re,this.k.controllerId).toString(),3,Z)}),appendOutput:(Re,Z,he)=>{be||(he&&(this.k.isIncluded(he)?this.s(he):he=void 0),this.l.$appendOutputToRun(q,N,C.$Jb.fromString(Re),Z&&t.location.from(Z),he&&a.$nI.fromExtHostTestItem(he,U).toString()))},end:()=>{be||(be=!0,this.l.$finishedTestRunTask(q,N),this.f.delete(N),this.f.size||this.p())}};return this.f.set(N,{run:Ee,coverage:O}),this.l.$startedTestRunTask(q,{id:N,name:B,running:!0}),Ee}m(){for(const{run:B}of this.f.values())B.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(B){if(!(B instanceof o.$QL))throw new m.$vL(B.id);if(this.g.has(a.$nI.fromExtHostTestItem(B,this.k.controllerId).toString()))return;const q=[],U=this.k.colllection.root;for(;;){const N=t.TestItem.from(B);if(q.unshift(N),this.g.has(N.extId)||(this.g.add(N.extId),B===U))break;B=B.parent||U}this.l.$addTestsToRun(this.k.controllerId,this.k.id,q)}}class s{get trackers(){return this.c.values()}constructor(B){this.d=B,this.c=new Map}prepareForMainThreadTestRun(B,q,U){return this.f(B,q,U)}cancelRunById(B){for(const q of this.c.values())if(q.id===B){q.cancel();return}}cancelAllRuns(){for(const B of this.c.values())B.cancel()}createTestRun(B,q,U,N,O){const ce=this.c.get(U);if(ce)return ce.createRun(N);const X=k.fromPublic(B,q,U,O),be=$(U);this.d.$startedExtensionTestRun({controllerId:B,continuous:!!U.continuous,profile:be&&{group:R[be.kind],id:be.profileId},exclude:U.exclude?.map(Re=>a.$nI.fromExtHostTestItem(Re,q.root.id).toString())??[],id:X.id,include:U.include?.map(Re=>a.$nI.fromExtHostTestItem(Re,q.root.id).toString())??[q.root.id],persist:O});const Ee=this.f(U,X);return Ee.onEnd(()=>{this.d.$finishedExtensionTestRun(X.id),Ee.dispose()}),Ee.createRun(N)}f(B,q,U){const N=new n(q,this.d,U);return this.c.set(B,N),N.onEnd(()=>this.c.delete(B)),N}}e.$xac=s;const $=W=>{if(W.profile){if(!(W.profile instanceof d))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class k{static fromPublic(B,q,U,N){return new k(B,(0,c.$6e)(),U.include?.map(O=>a.$nI.fromExtHostTestItem(O,B).toString())??[B],U.exclude?.map(O=>a.$nI.fromExtHostTestItem(O,B).toString())??[],N,q)}static fromInternal(B,q){return new k(B.controllerId,B.runId,B.testIds,B.excludeExtIds,!0,q)}constructor(B,q,U,N,O,ce){this.controllerId=B,this.id=q,this.isPersisted=O,this.colllection=ce,this.c=U.map(X=>X+"\0"),this.d=N.map(X=>X+"\0")}isIncluded(B){const q=a.$nI.fromExtHostTestItem(B,this.controllerId).toString()+"\0";for(const U of this.d)if(q===U||q.startsWith(U))return!1;for(const U of this.c)if(q===U||q.startsWith(U))return!0;return!1}}e.$yac=k;class l{set coverageProvider(B){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");B&&(this.c=B,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(B,q,U){this.f=B,this.g=q,this.h=U}async provideFileCoverage(B){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(B))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(q){throw this.d=void 0,q}}async resolveFileCoverage(B,q){const U=await this.d;let N=U?.[B];return!this.c||!U||!N?[]:(N.detailedCoverage||(N=U[B]=await this.c.resolveFileCoverage?.(N,q)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class f{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(B){this.h=B,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(B){this.c.add(B)}update(B){Object.assign(B.revived,t.TestItem.toPlain(B.item)),this.c.has(B)||this.d.add(B)}remove(B){if(this.c.has(B)){this.c.delete(B);return}this.d.delete(B);const q=a.$nI.parentId(B.item.extId);if(q&&this.g.has(q.toString())){this.g.add(B.item.extId);return}this.f.add(B)}getChangeEvent(){const{c:B,d:q,f:U}=this;return{get added(){return[...B].map(N=>N.revived)},get updated(){return[...q].map(N=>N.revived)},get removed(){return[...U].map(N=>N.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class v extends S.$uI{constructor(){super(...arguments),this.q=new P.$8c,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(B){return this.d.get(B)}getMirroredTestDataByReference(B){return this.d.get(B.id)}p(B,q){return{...B,revived:t.TestItem.toPlain(B.item),depth:q?q.depth+1:0,children:new Set}}o(){return new f(this.q)}}class u{constructor(B){this.d=B}checkout(){this.c||(this.c=this.f());const B=this.c;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(q=>q.revived)},dispose:(0,g.$cb)(()=>{--B.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(B){return this.c?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.c?.tests.apply(B)}f(){const B=new v;return this.d.$subscribeToDiffs(),{observers:0,tests:B}}}class d{#e;#t;get label(){return this.d}set label(B){B!==this.d&&(this.d=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:B}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(B){B!==this.g&&(this.g=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:B}))}get isDefault(){return this.f}set isDefault(B){B!==this.f&&(this.f=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:B?t.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this.c}set configureHandler(B){B!==this.c&&(this.c=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!B}))}constructor(B,q,U,N,O,ce,X,be=!1,Ee=void 0,Re=!1){this.controllerId=U,this.profileId=N,this.d=O,this.kind=ce,this.runHandler=X,this.f=be,this._tag=Ee,this.g=Re,this.#e=B,this.#t=q,q.set(N,this);const Z=R[ce];if(typeof Z!="number")throw new Error(`Unknown TestRunProfile.group ${ce}`);this.#e.$publishTestRunProfile({profileId:N,controllerId:U,tag:Ee?t.TestTag.namespace(this.controllerId,Ee.id):null,label:O,group:Z,isDefault:be,hasConfigurationHandler:!1,supportsContinuousRun:Re})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$zac=d;const R={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[249],Fe([1,0,18,11,5,4,105,8,7]),function($e,e,w,T,C,M,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O_b=void 0;class p{constructor(E,c){this.i=c,this.a=new C.$8c({onListenerError:T.$Z}),this.b=new C.$8c({onListenerError:T.$Z}),this.c=new C.$8c({onListenerError:T.$Z}),this.d=new C.$8c({onListenerError:T.$Z}),this.f=new C.$8c({onListenerError:T.$Z}),this.g=new C.$8c({onListenerError:T.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=E.getProxy(M.$BJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(E){const c=this.i.allEditors();return E?c:c.map(y=>y.value)}async showTextDocument(E,c,y){let b;typeof c=="number"?b={position:g.ViewColumn.from(c),preserveFocus:y}:typeof c=="object"?b={position:g.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selection:typeof c.selection=="object"?g.Range.from(c.selection):void 0,pinned:typeof c.preview=="boolean"?!c.preview:void 0}:b={preserveFocus:!1};const o=await this.h.$tryShowTextDocument(E.uri,b),t=o&&this.i.getEditor(o);if(t)return t.value;throw o?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}createTextEditorDecorationType(E,c){return new P.$KL(this.h,E,c).value}$acceptEditorPropertiesChanged(E,c){const y=this.i.getEditor(E);if(!y)throw new Error("unknown text editor");if(c.options&&y._acceptOptions(c.options),c.selections){const b=c.selections.selections.map(g.Selection.to);y._acceptSelections(b)}if(c.visibleRanges){const b=w.$mf(c.visibleRanges.map(g.Range.to));y._acceptVisibleRanges(b)}if(c.options&&this.b.fire({textEditor:y.value,options:{...c.options,lineNumbers:g.TextEditorLineNumbersStyle.to(c.options.lineNumbers)}}),c.selections){const b=D.TextEditorSelectionChangeKind.fromValue(c.selections.source),o=c.selections.selections.map(g.Selection.to);this.a.fire({textEditor:y.value,selections:o,kind:b})}if(c.visibleRanges){const b=w.$mf(c.visibleRanges.map(g.Range.to));this.c.fire({textEditor:y.value,visibleRanges:b})}}$acceptEditorPositionData(E){for(const c in E){const y=this.i.getEditor(c);if(!y)throw new Error("Unknown text editor");const b=g.ViewColumn.to(E[c]);y.value.viewColumn!==b&&(y._acceptViewColumn(b),this.d.fire({textEditor:y.value,viewColumn:b}))}}getDiffInformation(E){return Promise.resolve(this.h.$getDiffInformation(E))}}e.$O_b=p}),define(Ae[250],Fe([1,0,2,3,4,6,7,8,21,12]),function($e,e,w,T,C,M,P,g,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=e.$qac=void 0,e.$qac=(0,T.$ph)("IExtHostTimeline");class A{constructor(y,b){this.b=new Map,this.c=new Map,this.a=y.getProxy(C.$BJ.MainThreadTimeline),b.registerArgumentProcessor({processArgument:(o,t)=>{if(o&&o.$mid===12)if(this.b.get(o.source)&&D.$Hl.equals(t,this.b.get(o.source)?.extension)){const i=o.uri===void 0?void 0:w.URI.revive(o.uri);return this.c.get(o.source)?.get(E(i))?.get(o.handle)}else return;return o}})}async $getTimeline(y,b,o,t){return this.b.get(y)?.provider.provideTimeline(w.URI.revive(b),o,t)}registerTimelineProvider(y,b,o,t){const i=new M.$kb,a=this.d(b.id,t,i).bind(this);let m;b.onDidChange&&(m=b.onDidChange(I=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...I,id:b.id}),this));const S=this.c;return this.f({...b,scheme:y,onDidChange:void 0,async provideTimeline(I,r,h){r?.resetCache&&(i.clear(),S.get(b.id)?.clear());const n=await b.provideTimeline(I,r,h);if(n==null)return;const s=a(I,r);return{...n,source:b.id,items:n.items.map(s)}},dispose(){for(const I of S.values())I.get(b.id)?.clear();m?.dispose(),i.dispose()}},o)}d(y,b,o){return(t,i)=>{let a;if(i?.cacheResults){let m=this.c.get(y);m===void 0&&(m=new Map,this.c.set(y,m));const S=E(t);a=m.get(S),a===void 0&&(a=new Map,m.set(S,a))}return m=>{const{iconPath:S,...I}=m,r=`${y}|${m.id??m.timestamp}`;a?.set(r,m);let h,n,s;m.iconPath&&(S instanceof P.$yK?s={id:S.id,color:S.color}:w.URI.isUri(S)?(h=S,n=S):{light:h,dark:n}=S);let $;return P.$5J.isMarkdownString(I.tooltip)?$=g.MarkdownString.from(I.tooltip):(0,p.$je)(I.tooltip)?$=I.tooltip:P.$5J.isMarkdownString(I.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),$=g.MarkdownString.from(I.detail)):(0,p.$je)(I.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),$=I.detail),{...I,id:I.id??void 0,handle:r,source:y,command:m.command?b.toInternal(m.command,o):void 0,icon:h,iconDark:n,themeIcon:s,tooltip:$,accessibilityInformation:m.accessibilityInformation}}}}f(y,b){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:b}),(0,M.$jb)(()=>{for(const t of this.c.values())t.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$rac=A;function E(c){return c?.toString()}}),define(Ae[85],Fe([1,0,20,5,6,157,3,14,185,4,27,17,7]),function($e,e,w,T,C,M,P,g,D,p,A,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpb=e.$Wpb=e.TunnelDtoConverter=void 0;class y extends D.$Oz{}var b;(function(t){function i(m){return{remoteAddress:m.remoteAddress,localAddress:m.localAddress,public:!!m.public,privacy:m.privacy??(m.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:m.protocol}}t.fromApiTunnel=i;function a(m){return{remoteAddress:{host:m.tunnelRemoteHost,port:m.tunnelRemotePort},localAddress:m.localAddress,public:m.privacy!==D.TunnelPrivacyId.ConstantPrivate&&m.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:m.privacy,protocol:m.protocol}}t.fromServiceTunnel=a})(b||(e.TunnelDtoConverter=b={})),e.$Wpb=(0,P.$ph)("IExtHostTunnelService");let o=class extends C.$lb{constructor(i,a,m){super(),this.n=m,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$8c,this.onDidChangeTunnels=this.h.event,this.k=0,this.l=new Map,this.a=i.getProxy(p.$BJ.MainThreadTunnelService)}async openTunnel(i,a){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const m=await this.a.$openTunnel(a,i.displayName);if(m){const S=new y(m.remoteAddress,m.localAddress,()=>this.a.$closeTunnel(m.remoteAddress));return this.B(S),S}}async getTunnels(){return this.a.$getTunnels()}p(){return this.k++}registerPortsAttributesProvider(i,a){const m=this.p();return this.l.set(m,{selector:i,provider:a}),this.a.$registerPortsAttributesProvider(i,m),new c.$DJ(()=>{this.l.delete(m),this.a.$unregisterPortsAttributesProvider(m)})}async $providePortAttributes(i,a,m,S,I){const r=[];for(const n of i){const s=this.l.get(n);if(!s)return[];r.push(...await Promise.all(a.map(async $=>({providedAttributes:await s.provider.providePortAttributes($,m,S,I),port:$}))))}const h=r.filter(n=>!!n.providedAttributes);return h.length>0?h.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,a){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(S,I)=>await i.provideTunnel(S,I,new w.$ed().token)??void 0;const m=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,privacyOptions:a.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(m),Promise.resolve((0,C.$jb)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i){if(i){if(i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter()),i.tunnelFactory){this.b=i.tunnelFactory;let a=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const m=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:a}:void 0;this.a.$setTunnelProvider(m)}}else this.b=void 0;return(0,C.$jb)(()=>{this.b=void 0})}async $closeTunnel(i,a){if(this.g.has(i.host)){const m=this.g.get(i.host);m.has(i.port)&&(a&&m.get(i.port).disposeListener.dispose(),await m.get(i.port).tunnel.dispose(),m.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,a){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const m=this.b(i,a);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),m!==void 0){const S=await m;if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),S===void 0){this.n.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const I=this.B(S.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(S.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:S,disposeListener:I}),b.fromApiTunnel(S)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(i){const a=await Promise.all(i.map(S=>this.f(S.host,S.port,S.detail??""))),m=i.filter((S,I)=>a[I]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(S=>S.port).join(", ")} to ${m.map(S=>S.port).join(", ")}`),m}};e.$Xpb=o,e.$Xpb=o=Ve([qe(0,E.$DL),qe(1,A.$TL),qe(2,g.$Ri)],o)}),define(Ae[251],Fe([1,0,6,13,2,4]),function($e,e,w,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aac=void 0;class P{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(D){this.c=new Map,this.b=D.getProxy(M.$BJ.MainThreadUriOpeners)}registerExternalUriOpener(D,p,A,E){if(this.c.has(p))throw new Error(`Opener with id '${p}' already registered`);const c=E.schemes.find(y=>!P.a.has(y));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this.c.set(p,A),this.b.$registerUriOpener(p,E.schemes,D,E.label),(0,w.$jb)(()=>{this.c.delete(p),this.b.$unregisterUriOpener(p)})}async $canOpenUri(D,p,A){const E=this.c.get(D);if(!E)throw new Error(`Unknown opener with id: ${D}`);const c=C.URI.revive(p);return E.canOpenExternalUri(c,A)}async $openUri(D,p,A){const E=this.c.get(D);if(!E)throw new Error(`Unknown opener id: '${D}'`);return E.openExternalUri(C.URI.revive(p.resolvedUri),{sourceUri:C.URI.revive(p.sourceUri)},A)}}e.$Aac=P}),define(Ae[252],Fe([1,0,4,2,6,11,21]),function($e,e,w,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=void 0;class g{static{this.a=0}constructor(p){this.c=new P.$Il,this.d=new Map,this.b=p.getProxy(w.$BJ.MainThreadUrls)}registerUriHandler(p,A){const E=p.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const c=g.a++;return this.c.add(E),this.d.set(c,A),this.b.$registerUriHandler(c,E,p.displayName||p.name),(0,C.$jb)(()=>{this.c.delete(E),this.d.delete(c),this.b.$unregisterUriHandler(c)})}$handleExternalUri(p,A){const E=this.d.get(p);if(!E)return Promise.resolve(void 0);try{E.handleUri(T.URI.revive(A))}catch(c){(0,M.$Y)(c)}return Promise.resolve(void 0)}async createAppUri(p){return T.URI.revive(await this.b.$createAppUri(p))}}e.$Q_b=g}),define(Ae[64],Fe([1,0,5,13,24,2,169,192,76,4]),function($e,e,w,T,C,M,P,g,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V_b=e.$U_b=e.$T_b=e.$S_b=e.$R_b=void 0;class A{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(m,S,I,r,h,n,s){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.$8c,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$8c,this._onDidDispose=this.#h.event,this.#e=m,this.#t=S,this.#r=I,this.#l=r,this.#u=h,this.#n=n,this.#c=E(n),this.#d=c(n),this.#i=s}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return this.#a=!0,(0,D.$knb)(m,this.#l)}get cspSource(){const m=this.#n.extensionLocation;if(m.scheme===T.Schemas.https||m.scheme===T.Schemas.http){let S=m.toString();return S.endsWith("/")||(S+="/"),S+" "+D.$jnb}return D.$jnb}get html(){return this.a(),this.#s}set html(m){this.a(),this.#s!==m&&(this.#s=m,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(m)))}get options(){return this.a(),this.#r}set options(m){this.a(),C.$Lm(this.#r,m)||this.#t.$setOptions(this.#e,o(this.#n,this.#u,m)),this.#r=m}async postMessage(m){if(this.#o)return!1;const S=(0,g.$90)(m,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,S.message,...S.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(m){if(!this.#d)return m;const S=this.#n.extensionLocation?.scheme===T.Schemas.vscodeRemote,I=this.#n.extensionLocation.scheme===T.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return m.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,h,n,s,$,k)=>{const l=M.URI.from({scheme:s||"file",path:decodeURIComponent($)}),f=(0,D.$knb)(l,{isRemote:S,authority:I}).toString();return`${h}${f}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,h,n,s,$,k)=>{const l=M.URI.from({scheme:s||"file",path:decodeURIComponent($)}),f=(0,D.$knb)(l,{isRemote:S,authority:I}).toString();return`${h}${f}${k}`})}}e.$R_b=A;function E(a){try{const m=(0,P.$to)((0,P.$so)(a.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.$S_b=E;function c(a){try{const m=(0,P.$to)((0,P.$so)(a.engines.vscode));return m?m.majorBase<1||m.majorBase===1&&m.minorBase<60:!1}catch{return!1}}class y{constructor(m,S,I,r,h){this.c=S,this.d=I,this.e=r,this.f=h,this.b=new Map,this.a=m.getProxy(p.$BJ.MainThreadWebviews)}$onMessage(m,S,I){const r=this.g(m);if(r){const{message:h}=(0,g.$00)(S,I.value);r._onMessageEmitter.fire(h)}}$onMissingCsp(m,S){this.e.warn(`${S} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,S,I){const r=new A(m,this.a,t(S),this.c,this.d,I,this.f);return this.b.set(m,r),r._onDidDispose(()=>{this.b.delete(m)}),r}deleteWebview(m){this.b.delete(m)}g(m){return this.b.get(m)}}e.$T_b=y;function b(a){return{id:a.identifier,location:a.extensionLocation}}e.$U_b=b;function o(a,m,S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,enableForms:S.enableForms,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots||i(a,m)}}e.$V_b=o;function t(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(m=>M.URI.from(m))}}function i(a,m){return[...(m?.getWorkspaceFolders()||[]).map(S=>S.uri),a.extensionLocation]}}),define(Ae[253],Fe([1,0,20,92,6,13,23,2,8,64,55,4,7]),function($e,e,w,T,C,M,P,g,D,p,A,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=void 0;class y{constructor(h,n){this.document=h,this.b=n,this.a=1,this.c=new A.$N$b("custom documents")}addEdit(h){return this.c.add([h])}async undo(h,n){await this.f(h).undo(),n||this.disposeBackup()}async redo(h,n){await this.f(h).redo(),n||this.disposeBackup()}disposeEdits(h){for(const n of h)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const h=I(this.document.uri)+this.a++;return(0,P.$0f)(this.b,h)}updateBackup(h){this.d?.delete(),this.d=h}disposeBackup(){this.d?.delete(),this.d=void 0}f(h){const n=this.c.get(h,0);if(!n)throw new Error("No edit found");return n}}class b{constructor(){this.a=new Map}get(h,n){return this.a.get(this.b(h,n))}add(h,n,s){const $=this.b(h,n.uri);if(this.a.has($))throw new Error(`Document already exists for viewType:${h} resource:${n.uri}`);const k=new y(n,s);return this.a.set($,k),k}delete(h,n){const s=this.b(h,n.uri);this.a.delete(s)}b(h,n){return`${h}@@@${n}`}}var o;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(o||(o={}));class t{constructor(){this.a=new Map}addTextProvider(h,n,s){return this.b(0,h,n,s)}addCustomProvider(h,n,s){return this.b(1,h,n,s)}get(h){return this.a.get(h)}b(h,n,s,$){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:h,extension:s,provider:$}),new c.$DJ(()=>this.a.delete(n))}}class i{constructor(h,n,s,$,k){this.d=n,this.f=s,this.g=$,this.h=k,this.b=new t,this.c=new b,this.a=h.getProxy(E.$BJ.MainThreadCustomEditors)}registerCustomEditorProvider(h,n,s,$){const k=new C.$kb;return m(s)?(k.add(this.b.addTextProvider(n,h,s)),this.a.$registerTextEditorProvider((0,p.$U_b)(h),n,$.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,p.$S_b)(h))):(k.add(this.b.addCustomProvider(n,h,s)),a(s)&&k.add(s.onDidChangeCustomDocument(l=>{const f=this.i(n,l.document.uri);if(S(l)){const v=f.addEdit(l);this.a.$onDidEdit(l.document.uri,n,v,l.label)}else this.a.$onContentChange(l.document.uri,n)})),this.a.$registerCustomEditorProvider((0,p.$U_b)(h),n,$.webviewOptions||{},!!$.supportsMultipleEditorsPerDocument,(0,p.$S_b)(h))),c.$DJ.from(k,new c.$DJ(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(h,n,s,$,k){const l=this.b.get(n);if(!l)throw new Error(`No provider found for '${n}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${n}'`);const f=g.URI.revive(h),v=await l.provider.openCustomDocument(f,{backupId:s,untitledDocumentData:$?.buffer},k);let u;return a(l.provider)&&this.f&&(u=this.f.workspaceValue(l.extension)??this.f.globalValue(l.extension)),this.c.add(n,v,u),{editable:a(l.provider)}}async $disposeCustomDocument(h,n){const s=this.b.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const $=g.URI.revive(h),{document:k}=this.i(n,$);this.c.delete(n,k),k.dispose()}async $resolveCustomEditor(h,n,s,$,k,l){const f=this.b.get(s);if(!f)throw new Error(`No provider found for '${s}'`);const v=D.ViewColumn.to(k),u=this.g.createNewWebview(n,$.contentOptions,f.extension),d=this.h.createNewWebviewPanel(n,s,$.title,v,$.options,u,$.active),R=g.URI.revive(h);switch(f.type){case 1:{const{document:W}=this.i(s,R);return f.provider.resolveCustomEditor(W,d,l)}case 0:{const W=this.d.getDocument(R);return f.provider.resolveCustomTextEditor(W,d,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(h,n,s){this.i(n,h).disposeEdits(s)}async $onMoveCustomEditor(h,n,s){const $=this.b.get(s);if(!$)throw new Error(`No provider found for '${s}'`);if(!$.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const k=this.h.getWebviewPanel(h);if(!k)throw new Error("No webview found");const l=g.URI.revive(n),f=this.d.getDocument(l);await $.provider.moveCustomTextEditor(f,k,w.CancellationToken.None)}async $undo(h,n,s,$){return this.i(n,h).undo(s,$)}async $redo(h,n,s,$){return this.i(n,h).redo(s,$)}async $revert(h,n,s){const $=this.i(n,h);await this.j(n).revertCustomDocument($.document,s),$.disposeBackup()}async $onSave(h,n,s){const $=this.i(n,h);await this.j(n).saveCustomDocument($.document,s),$.disposeBackup()}async $onSaveAs(h,n,s,$){const k=this.i(n,h);return this.j(n).saveCustomDocumentAs(k.document,g.URI.revive(s),$)}async $backup(h,n,s){const $=this.i(n,h),l=await this.j(n).backupCustomDocument($.document,{destination:$.getNewBackupUri()},s);return $.updateBackup(l),l.id}i(h,n){const s=this.c.get(h,g.URI.revive(n));if(!s)throw new Error("No custom document found");return s}j(h){const s=this.b.get(h)?.provider;if(!s||!a(s))throw new Error("Custom document is not editable");return s}}e.$uac=i;function a(r){return!!r.onDidChangeCustomDocument}function m(r){return typeof r.resolveCustomTextEditor=="function"}function S(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function I(r){const h=r.scheme===M.Schemas.file||r.scheme===M.Schemas.untitled?r.fsPath:r.toString();return(0,T.$di)(h)+""}}),define(Ae[254],Fe([1,0,5,6,2,36,8,64,4,7]),function($e,e,w,T,C,M,P,g,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=void 0;class A extends T.$lb{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(b,o,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new w.$8c),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$8c),this.onDidChangeViewState=this.#h.event,this.#e=b,this.#t=o,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(b){this.c(),this.#n!==b&&(this.#n=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.c(),this.#s}set iconPath(b){this.c(),this.#s!==b&&(this.#s=b,this.#t.$setIconPath(this.#e,C.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(b){this.#c||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#a=b.active,this.#o=b.visible,this.#r=b.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(b,o){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:P.ViewColumn.from(b),preserveFocus:!!o})}c(){if(this.#c)throw new Error("Webview is disposed")}}class E{static c(){return(0,M.$6e)()}constructor(b,o,t){this.g=o,this.h=t,this.e=new Map,this.f=new Map,this.d=b.getProxy(D.$BJ.MainThreadWebviewPanels)}createWebviewPanel(b,o,t,i,a={}){const m=typeof i=="object"?i.viewColumn:i,S={viewColumn:P.ViewColumn.from(m),preserveFocus:typeof i=="object"&&!!i.preserveFocus},I=(0,g.$S_b)(b),r=E.c();this.d.$createWebviewPanel((0,g.$U_b)(b),r,o,{title:t,panelOptions:c(a),webviewOptions:(0,g.$V_b)(b,this.h,a),serializeBuffersForPostMessage:I},S);const h=this.g.createNewWebview(r,a,b);return this.createNewWebviewPanel(r,o,t,m,a,h,!0)}$onDidChangeWebviewPanelViewStates(b){const o=Object.keys(b);o.sort((t,i)=>{const a=b[t],m=b[i];return a.active?1:m.active?-1:+a.visible-+m.visible});for(const t of o){const i=this.getWebviewPanel(t);if(!i)continue;const a=b[t];i._updateViewState({active:a.active,visible:a.visible,viewColumn:P.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.e.delete(b),this.g.deleteWebview(b)}registerWebviewPanelSerializer(b,o,t){if(this.f.has(o))throw new Error(`Serializer for '${o}' already registered`);return this.f.set(o,{serializer:t,extension:b}),this.d.$registerSerializer(o,{serializeBuffersForPostMessage:(0,g.$S_b)(b)}),new p.$DJ(()=>{this.f.delete(o),this.d.$unregisterSerializer(o)})}async $deserializeWebviewPanel(b,o,t,i){const a=this.f.get(o);if(!a)throw new Error(`No serializer found for '${o}'`);const{serializer:m,extension:S}=a,I=this.g.createNewWebview(b,t.webviewOptions,S),r=this.createNewWebviewPanel(b,o,t.title,i,t.panelOptions,I,t.active);await m.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel(b,o,t,i,a,m,S){const I=new A(b,this.d,m,{viewType:o,title:t,viewColumn:i,panelOptions:a,active:S});return this.e.set(b,I),I}getWebviewPanel(b){return this.e.get(b)}}e.$tac=E;function c(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(Ae[255],Fe([1,0,5,6,64,8,4,7]),function($e,e,w,T,C,M,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sac=void 0;class D extends T.$lb{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(E,c,y,b,o,t){super(),this.#u=!1,this.#a=this.B(new w.$8c),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new w.$8c),this.onDidDispose=this.#c.event,this.#i=y,this.#s=b,this.#e=E,this.#t=c,this.#l=o,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(E){this.a(),this.#s!==E&&(this.#s=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#r}set description(E){this.a(),this.#r!==E&&(this.#r=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(E){E===this.#n||this.#u||(this.#n=E,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(E){this.a(),!(E?.value===this.#o?.value&&E?.tooltip===this.#o?.tooltip)&&(this.#o=M.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#u)throw new Error("Webview is disposed")}}class p{constructor(E,c){this.d=c,this.b=new Map,this.c=new Map,this.a=E.getProxy(P.$BJ.MainThreadWebviewViews)}registerWebviewViewProvider(E,c,y,b){if(this.b.has(c))throw new Error(`View provider for '${c}' already registered`);return this.b.set(c,{provider:y,extension:E}),this.a.$registerWebviewViewProvider((0,C.$U_b)(E),c,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$S_b)(E)}),new g.$DJ(()=>{this.b.delete(c),this.a.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(E,c,y,b,o){const t=this.b.get(c);if(!t)throw new Error(`No view provider found for '${c}'`);const{provider:i,extension:a}=t,m=this.d.createNewWebview(E,{},a),S=new D(E,this.a,c,y,m,!0);this.c.set(E,S),await i.resolveWebviewView(S,{state:b},o)}async $onDidChangeWebviewViewVisibility(E,c){this.e(E)._setVisible(c)}async $disposeWebviewView(E){const c=this.e(E);this.c.delete(E),c.dispose(),this.d.deleteWebview(E)}e(E){const c=this.c.get(E);if(!c)throw new Error("No webview found");return c}}e.$sac=p}),define(Ae[108],Fe([1,0,5,4,2,13,15,3,17,26]),function($e,e,w,T,C,M,P,g,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X_b=e.$W_b=void 0;let A=class Dn{static{this.a={focused:!0,active:!0}}getState(c){const y=this.d;return{get focused(){return y.focused},get active(){return(0,p.$zF)(c,"windowActivity"),y.active}}}constructor(c){this.c=new w.$8c,this.onDidChangeWindowState=this.c.event,this.d=Dn.a,this.b=c.getProxy(T.$BJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:y,isActive:b})=>{this.onDidChangeWindowProperty("focused",y),this.onDidChangeWindowProperty("active",b)})}$onDidChangeWindowFocus(c){this.onDidChangeWindowProperty("focused",c)}$onDidChangeWindowActive(c){this.onDidChangeWindowProperty("active",c)}onDidChangeWindowProperty(c,y){y!==this.d[c]&&(this.d={...this.d,[c]:y},this.c.fire(this.d))}openUri(c,y){let b;if(typeof c=="string"){b=c;try{c=C.URI.parse(c)}catch{return Promise.reject(`Invalid uri - '${c}'`)}}return(0,P.$kd)(c.scheme)?Promise.reject("Invalid scheme - cannot be empty"):c.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${c.scheme}'`):this.b.$openUri(c,b,y)}async asExternalUri(c,y){if((0,P.$kd)(c.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(c,y);return C.URI.from(b)}};e.$W_b=A,e.$W_b=A=Ve([qe(0,D.$DL)],A),e.$X_b=(0,g.$ph)("IExtHostWindow")}),define(Ae[256],Fe([1,0,223,27,17]),function($e,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=void 0;let M=class extends w.$Rac{constructor(g,D){super(g,D)}f(g,D,p){D.apply(console,p)}};e.$Xcc=M,e.$Xcc=M=Ve([qe(0,C.$DL),qe(1,T.$TL)],M)}),define(Ae[257],Fe([1,0,16,25,20,11,5,6,132,216,46]),function($e,e,w,T,C,M,P,g,D,p,A){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$A1b=e.ResponsiveState=e.RequestInitiator=e.$z1b=e.$y1b=void 0;function c(u,d){try{return JSON.stringify(u,d)}catch{return"null"}}const y="$$ref$$",b={[y]:-1};class o{constructor(d,R){this.jsonString=d,this.referencedBuffers=R}}function t(u,d=null,R=!1){const W=[];return{jsonString:(R?c:JSON.stringify)(u,(q,U)=>{if(typeof U>"u")return b;if(typeof U=="object"){if(U instanceof T.$Jb){const N=W.push(U)-1;return{[y]:N}}if(d)return d(q,U)}return U}),referencedBuffers:W}}e.$y1b=t;function i(u,d,R){return JSON.parse(u,(W,B)=>{if(B){const q=B[y];if(typeof q=="number")return d[q];if(R&&B.$mid===1)return R.transformIncoming(B)}return B})}e.$z1b=i;function a(u,d){return JSON.stringify(u,d)}function m(u){return u?(d,R)=>R&&R.$mid===1?u.transformOutgoing(R):R:null}var S;(function(u){u[u.LocalSide=0]="LocalSide",u[u.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));var I;(function(u){u[u.Responsive=0]="Responsive",u[u.Unresponsive=1]="Unresponsive"})(I||(e.ResponsiveState=I={}));const r=()=>{},h=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class s extends g.$lb{static{E=h}static{this.a=3*1e3}constructor(d,R=null,W=null){super(),this[E]=!0,this.b=this.B(new P.$8c),this.onDidChangeResponsiveState=this.b.event,this.c=d,this.f=R,this.g=W,this.h=m(this.g),this.j=!1,this.k=[],this.l=[];for(let B=0,q=A.$Vz.count;B<q;B++)this.k[B]=null,this.l[B]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new w.$Gg(()=>this.C(),1e3)),this.c.onMessage(B=>this.G(B))}dispose(){this.j=!0,Object.keys(this.s).forEach(d=>{this.s[d].resolveErr(M.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(d){this.u===0&&(this.v=Date.now()+s.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(d){this.v=Date.now()+s.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(d){this.t!==d&&(this.t=d,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(d){return this.g?(0,D.$qm)(d,this.g):d}getProxy(d){const{nid:R,sid:W}=d;return this.l[R]||(this.l[R]=this.F(R,W)),this.l[R]}F(d,R){const W={get:(B,q)=>(typeof q=="string"&&!B[q]&&q.charCodeAt(0)===36&&(B[q]=(...U)=>this.O(d,q,U)),q===n?R:B[q])};return new Proxy(Object.create(null),W)}set(d,R){return this.k[d.nid]=R,R}assertRegistered(d){for(let R=0,W=d.length;R<W;R++){const B=d[R];if(!this.k[B.nid])throw new Error(`Missing proxy instance ${B.sid}`)}}G(d){if(this.j)return;const R=d.byteLength,W=$.read(d,0),B=W.readUInt8(),q=W.readUInt32();switch(B){case 1:case 2:{let{rpcId:U,method:N,args:O}=l.deserializeRequestJSONArgs(W);this.g&&(O=(0,D.$qm)(O,this.g)),this.H(R,q,U,N,O,B===2);break}case 3:case 4:{let{rpcId:U,method:N,args:O}=l.deserializeRequestMixedArgs(W);this.g&&(O=(0,D.$qm)(O,this.g)),this.H(R,q,U,N,O,B===4);break}case 5:{this.f?.logIncoming(R,q,0,"ack"),this.z(q);break}case 6:{this.I(R,q);break}case 7:{this.J(R,q,void 0);break}case 9:{let U=l.deserializeReplyOKJSON(W);this.g&&(U=(0,D.$qm)(U,this.g)),this.J(R,q,U);break}case 10:{const U=l.deserializeReplyOKJSONWithBuffers(W,this.g);this.J(R,q,U);break}case 8:{const U=l.deserializeReplyOKVSBuffer(W);this.J(R,q,U);break}case 11:{let U=l.deserializeReplyErrError(W);this.g&&(U=(0,D.$qm)(U,this.g)),this.L(R,q,U);break}case 12:{this.L(R,q,void 0);break}default:console.error("received unexpected message"),console.error(d)}}H(d,R,W,B,q,U){this.f?.logIncoming(d,R,1,`receiveRequest ${(0,A.$Xz)(W)}.${B}(`,q);const N=String(R);let O,ce;if(U){const be=new C.$ed;q.push(be.token),O=this.M(W,B,q),ce=()=>be.cancel()}else O=this.M(W,B,q),ce=r;this.p[N]=ce;const X=l.serializeAcknowledged(R);this.f?.logOutgoing(X.byteLength,R,1,"ack"),this.c.send(X),O.then(be=>{delete this.p[N];const Ee=l.serializeReplyOK(R,be,this.h);this.f?.logOutgoing(Ee.byteLength,R,1,"reply:",be),this.c.send(Ee)},be=>{delete this.p[N];const Ee=l.serializeReplyErr(R,be);this.f?.logOutgoing(Ee.byteLength,R,1,"replyErr:",be),this.c.send(Ee)})}I(d,R){this.f?.logIncoming(d,R,1,"receiveCancel");const W=String(R);this.p[W]?.()}J(d,R,W){this.f?.logIncoming(d,R,0,"receiveReply:",W);const B=String(R);if(!this.s.hasOwnProperty(B))return;const q=this.s[B];delete this.s[B],q.resolveOk(W)}L(d,R,W){this.f?.logIncoming(d,R,0,"receiveReplyErr:",W);const B=String(R);if(!this.s.hasOwnProperty(B))return;const q=this.s[B];delete this.s[B];let U;W&&(W.$isError?(U=new Error,U.name=W.name,U.message=W.message,U.stack=W.stack):U=W),q.resolveErr(U)}M(d,R,W){try{return Promise.resolve(this.N(d,R,W))}catch(B){return Promise.reject(B)}}N(d,R,W){const B=this.k[d];if(!B)throw new Error("Unknown actor "+(0,A.$Xz)(d));const q=B[R];if(typeof q!="function")throw new Error("Unknown method "+R+" on actor "+(0,A.$Xz)(d));return q.apply(B,W)}O(d,R,W){if(this.j)return new p.$x1b;let B=null;if(W.length>0&&C.CancellationToken.isCancellationToken(W[W.length-1])&&(B=W.pop()),B&&B.isCancellationRequested)return Promise.reject(M.$4());const q=l.serializeRequestArguments(W,this.h),U=++this.m,N=String(U),O=new p.$w1b;B&&B.onCancellationRequested(()=>{const X=l.serializeCancel(U);this.f?.logOutgoing(X.byteLength,U,0,"cancel"),this.c.send(l.serializeCancel(U))}),this.s[N]=O,this.y(U);const ce=l.serializeRequest(U,d,R,q,!!B);return this.f?.logOutgoing(ce.byteLength,U,0,`request: ${(0,A.$Xz)(d)}.${R}(`,W),this.c.send(ce),O}}e.$A1b=s;class ${static alloc(d,R,W){const B=new $(T.$Jb.alloc(W+1+4),0);return B.writeUInt8(d),B.writeUInt32(R),B}static read(d,R){return new $(d,R)}get buffer(){return this.a}constructor(d,R){this.a=d,this.b=R}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(d){this.a.writeUInt8(d,this.b),this.b+=1}readUInt8(){const d=this.a.readUInt8(this.b);return this.b+=1,d}writeUInt32(d){this.a.writeUInt32BE(d,this.b),this.b+=4}readUInt32(){const d=this.a.readUInt32BE(this.b);return this.b+=4,d}static sizeShortString(d){return 1+d.byteLength}writeShortString(d){this.a.writeUInt8(d.byteLength,this.b),this.b+=1,this.a.set(d,this.b),this.b+=d.byteLength}readShortString(){const d=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+d).toString();return this.b+=d,W}static sizeLongString(d){return 4+d.byteLength}writeLongString(d){this.a.writeUInt32BE(d.byteLength,this.b),this.b+=4,this.a.set(d,this.b),this.b+=d.byteLength}readLongString(){const d=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+d).toString();return this.b+=d,W}writeBuffer(d){this.a.writeUInt32BE(d.byteLength,this.b),this.b+=4,this.a.set(d,this.b),this.b+=d.byteLength}static sizeVSBuffer(d){return 4+d.byteLength}writeVSBuffer(d){this.a.writeUInt32BE(d.byteLength,this.b),this.b+=4,this.a.set(d,this.b),this.b+=d.byteLength}readVSBuffer(){const d=this.a.readUInt32BE(this.b);this.b+=4;const R=this.a.slice(this.b,this.b+d);return this.b+=d,R}static sizeMixedArray(d){let R=0;R+=1;for(let W=0,B=d.length;W<B;W++){const q=d[W];switch(R+=1,q.type){case 1:R+=this.sizeLongString(q.value);break;case 2:R+=this.sizeVSBuffer(q.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(q.value);for(let U=0;U<q.buffers.length;++U)R+=this.sizeVSBuffer(q.buffers[U]);break;case 4:break}}return R}writeMixedArray(d){this.a.writeUInt8(d.length,this.b),this.b+=1;for(let R=0,W=d.length;R<W;R++){const B=d[R];switch(B.type){case 1:this.writeUInt8(1),this.writeLongString(B.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(B.value);break;case 3:this.writeUInt8(3),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let q=0;q<B.buffers.length;++q)this.writeBuffer(B.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const d=this.a.readUInt8(this.b);this.b+=1;const R=new Array(d);for(let W=0;W<d;W++)switch(this.readUInt8()){case 1:R[W]=this.readLongString();break;case 2:R[W]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),U=this.readLongString(),N=[];for(let O=0;O<q;++O)N.push(this.readVSBuffer());R[W]=new A.$Yz(i(U,N,null));break}case 4:R[W]=void 0;break}return R}}var k;(function(u){u[u.Simple=0]="Simple",u[u.Mixed=1]="Mixed"})(k||(k={}));class l{static a(d){for(let R=0,W=d.length;R<W;R++)if(d[R]instanceof T.$Jb||d[R]instanceof A.$Yz||typeof d[R]>"u")return!0;return!1}static serializeRequestArguments(d,R){if(this.a(d)){const W=[];for(let B=0,q=d.length;B<q;B++){const U=d[B];if(U instanceof T.$Jb)W[B]={type:2,value:U};else if(typeof U>"u")W[B]={type:4};else if(U instanceof A.$Yz){const{jsonString:N,referencedBuffers:O}=t(U.value,R);W[B]={type:3,value:T.$Jb.fromString(N),buffers:O}}else W[B]={type:1,value:T.$Jb.fromString(a(U,R))}}return{type:1,args:W}}return{type:0,args:a(d,R)}}static serializeRequest(d,R,W,B,q){switch(B.type){case 0:return this.b(d,R,W,B.args,q);case 1:return this.c(d,R,W,B.args,q)}}static b(d,R,W,B,q){const U=T.$Jb.fromString(W),N=T.$Jb.fromString(B);let O=0;O+=$.sizeUInt8(),O+=$.sizeShortString(U),O+=$.sizeLongString(N);const ce=$.alloc(q?2:1,d,O);return ce.writeUInt8(R),ce.writeShortString(U),ce.writeLongString(N),ce.buffer}static deserializeRequestJSONArgs(d){const R=d.readUInt8(),W=d.readShortString(),B=d.readLongString();return{rpcId:R,method:W,args:JSON.parse(B)}}static c(d,R,W,B,q){const U=T.$Jb.fromString(W);let N=0;N+=$.sizeUInt8(),N+=$.sizeShortString(U),N+=$.sizeMixedArray(B);const O=$.alloc(q?4:3,d,N);return O.writeUInt8(R),O.writeShortString(U),O.writeMixedArray(B),O.buffer}static deserializeRequestMixedArgs(d){const R=d.readUInt8(),W=d.readShortString(),B=d.readMixedArray(),q=new Array(B.length);for(let U=0,N=B.length;U<N;U++){const O=B[U];typeof O=="string"?q[U]=JSON.parse(O):q[U]=O}return{rpcId:R,method:W,args:q}}static serializeAcknowledged(d){return $.alloc(5,d,0).buffer}static serializeCancel(d){return $.alloc(6,d,0).buffer}static serializeReplyOK(d,R,W){if(typeof R>"u")return this.d(d);if(R instanceof T.$Jb)return this.e(d,R);if(R instanceof A.$Yz){const{jsonString:B,referencedBuffers:q}=t(R.value,W,!0);return this.g(d,B,q)}else return this.f(d,c(R,W))}static d(d){return $.alloc(7,d,0).buffer}static e(d,R){let W=0;W+=$.sizeVSBuffer(R);const B=$.alloc(8,d,W);return B.writeVSBuffer(R),B.buffer}static deserializeReplyOKVSBuffer(d){return d.readVSBuffer()}static f(d,R){const W=T.$Jb.fromString(R);let B=0;B+=$.sizeLongString(W);const q=$.alloc(9,d,B);return q.writeLongString(W),q.buffer}static g(d,R,W){const B=T.$Jb.fromString(R);let q=0;q+=$.sizeUInt32,q+=$.sizeLongString(B);for(const N of W)q+=$.sizeVSBuffer(N);const U=$.alloc(10,d,q);U.writeUInt32(W.length),U.writeLongString(B);for(const N of W)U.writeBuffer(N);return U.buffer}static deserializeReplyOKJSON(d){const R=d.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(d,R){const W=d.readUInt32(),B=d.readLongString(),q=[];for(let U=0;U<W;++U)q.push(d.readVSBuffer());return new A.$Yz(i(B,q,R))}static serializeReplyErr(d,R){const W=R?c(M.$1(R),null):void 0;if(typeof W!="string")return this.h(d);const B=T.$Jb.fromString(W);let q=0;q+=$.sizeLongString(B);const U=$.alloc(11,d,q);return U.writeLongString(B),U.buffer}static deserializeReplyErrError(d){const R=d.readLongString();return JSON.parse(R)}static h(d){return $.alloc(12,d,0).buffer}}var f;(function(u){u[u.RequestJSONArgs=1]="RequestJSONArgs",u[u.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",u[u.RequestMixedArgs=3]="RequestMixedArgs",u[u.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",u[u.Acknowledged=5]="Acknowledged",u[u.Cancel=6]="Cancel",u[u.ReplyOKEmpty=7]="ReplyOKEmpty",u[u.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",u[u.ReplyOKJSON=9]="ReplyOKJSON",u[u.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",u[u.ReplyErrError=11]="ReplyErrError",u[u.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var v;(function(u){u[u.String=1]="String",u[u.VSBuffer=2]="VSBuffer",u[u.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",u[u.Undefined=4]="Undefined"})(v||(v={}))}),define(Ae[258],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;const w=function(M){const P=g=>{globalThis.removeEventListener("message",P);const D=g.data;Object.defineProperties(globalThis,{postMessage:{value(p,A){D.postMessage(p,A)}},onmessage:{get(){return D.onmessage},set(p){D.onmessage=p}}}),D.addEventListener("message",p=>{globalThis.dispatchEvent(new MessageEvent("message",{data:p.data,ports:p.ports?[...p.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",P)}.toString();class T extends EventTarget{constructor(M,P,g){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${w})('${P}'))`,p=new Blob([D],{type:"application/javascript"}),A=URL.createObjectURL(p),E=new MessageChannel,c=A,y={type:"_newWorker",id:c,port:E.port2,url:A,options:g};M(y,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{M({type:"_terminateWorker",id:c}),URL.revokeObjectURL(A),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(b){E.port1.onmessage=b}},onmessageerror:{get(){return E.port1.onmessageerror},set(b){E.port1.onmessageerror=b}}}),E.port1.addEventListener("messageerror",b=>{const o=new MessageEvent("messageerror",{data:b.data});this.dispatchEvent(o)}),E.port1.addEventListener("message",b=>{const o=new MessageEvent("message",{data:b.data});this.dispatchEvent(o)}),E.port1.start()}}e.$Zcc=T}),define(Ae[259],Fe([1,0,5,30,31,3]),function($e,e,w,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QI=e.$PI=e.OutputChannelUpdateMode=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=void 0,e.$EI="text/x-code-output",e.$FI="output",e.$GI="Log",e.$HI="text/x-code-log-output",e.$II="log",e.$JI="log",e.$KI="workbench.panel.output",e.$LI=new C.$Oi("inOutput",!1),e.$MI=new C.$Oi("activeLogOutput",!1),e.$NI=new C.$Oi("outputView.scrollLock",!1),e.$OI=(0,M.$ph)("outputService");var P;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(P||(e.OutputChannelUpdateMode=P={})),e.$PI={OutputChannels:"workbench.contributions.outputChannels"};class g{constructor(){this.a=new Map,this.b=new w.$8c,this.onDidRegisterChannel=this.b.event,this.c=new w.$8c,this.onDidRemoveChannel=this.c.event}registerChannel(p){this.a.has(p.id)||(this.a.set(p.id,p),this.b.fire(p.id))}getChannels(){const p=[];return this.a.forEach(A=>p.push(A)),p}getChannel(p){return this.a.get(p)}removeChannel(p){this.a.delete(p),this.c.fire(p)}}T.$Tm.add(e.$PI.OutputChannels,new g),e.$QI=new C.$Oi("activeOutputChannel","")}),define(Ae[109],Fe([1,0,4,3,17,21,14,259,62,27,39,129,25,12,38,5,6]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H_b=e.$G_b=void 0;class i extends P.$Xi{get disposed(){return this.l}constructor(I,r,h,n,s){super(),this.id=I,this.name=r,this.m=h,this.n=n,this.extension=s,this.k=0,this.l=!1,this.visible=!1,this.setLevel(h.getLevel()),this.B(h.onDidChangeLogLevel($=>this.setLevel($)))}get logLevel(){return this.getLevel()}appendLine(I){this.append(I+`
`)}append(I){this.info(I)}clear(){const I=this.k;this.m.flush(),this.n.$update(this.id,g.OutputChannelUpdateMode.Clear,I)}replace(I){const r=this.k;this.info(I),this.n.$update(this.id,g.OutputChannelUpdateMode.Replace,r),this.visible&&this.m.flush()}show(I,r){this.m.flush(),this.n.$reveal(this.id,!!(typeof I=="boolean"?I:r))}hide(){this.n.$close(this.id)}g(I,r){this.k+=c.$Jb.fromString(r).byteLength,(0,P.log)(this.m,I,r),this.visible&&(this.m.flush(),this.n.$update(this.id,g.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class a extends i{appendLine(I){this.append(I)}}let m=class{constructor(I,r,h,n,s,$){this.i=r,this.j=h,this.k=n,this.l=s,this.m=$,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=I.getProxy(w.$BJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,E.$Sl)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(I){this.h=I;for(const[r,h]of this.g)h.visible=r===this.h}createOutputChannel(I,r,h){if(I=I.trim(),!I)throw new Error("illegal argument `name`. must not be falsy");const n=typeof r=="object"&&r.log,s=(0,y.$je)(r)?r:void 0;if((0,y.$je)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let $;const k=this.i.environment.extensionLogLevel?.find(([f])=>M.$Hl.equals(h.identifier,f))?.[1];k&&($=(0,P.$8i)(k));const l=n?this.o(I,$,h):this.n(I,s,h);return l.then(f=>{this.g.set(f.id,f),f.visible=f.id===this.h}),n?this.r(I,$??this.m.getLevel(),l):this.q(I,l)}async n(I,r,h){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,s=this.k.extUri.joinPath(n,`${this.f++}-${I.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),$=this.l.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),k=await this.a.$register(I,s,r,h.identifier.value);return new i(k,I,$,this.a,h)}async o(I,r,h){const n=await this.p(h),s=I.replace(/[\\/:\*\?"<>\|]/g,""),$=this.k.extUri.joinPath(n,`${s}.log`),k=`${h.identifier.value}.${s}`,l=this.l.createLogger($,{id:k,name:I,logLevel:r,extensionId:h.identifier.value});return new a(k,I,l,this.a,h)}p(I){let r=this.d.get(I.identifier.value);if(!r){const h=this.k.extUri.joinPath(this.i.logsLocation,I.identifier.value);this.d.set(I.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(h)}catch(n){if((0,b.$8j)(n)!==b.FileSystemProviderErrorCode.FileExists)throw n}return h})())}return r}q(I,r){let h=!1;const n=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return I},append(s){n(),r.then($=>$.append(s))},appendLine(s){n(),r.then($=>$.appendLine(s))},clear(){n(),r.then(s=>s.clear())},replace(s){n(),r.then($=>$.replace(s))},show(s,$){n(),r.then(k=>k.show(s,$))},hide(){n(),r.then(s=>s.hide())},dispose(){h=!0,r.then(s=>s.dispose())}}}r(I,r,h){const n=new t.$kb,s=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},$=n.add(new o.$8c);function k(l){r=l,$.fire(l)}return h.then(l=>{n.add(l),l.logLevel!==r&&k(l.logLevel),n.add(l.onDidChangeLogLevel(f=>k(f)))}),{...this.q(I,h),get logLevel(){return r},onDidChangeLogLevel:$.event,trace(l,...f){s(),h.then(v=>v.trace(l,...f))},debug(l,...f){s(),h.then(v=>v.debug(l,...f))},info(l,...f){s(),h.then(v=>v.info(l,...f))},warn(l,...f){s(),h.then(v=>v.warn(l,...f))},error(l,...f){s(),h.then(v=>v.error(l,...f))},dispose(){n.dispose()}}}};e.$G_b=m,e.$G_b=m=Ve([qe(0,C.$DL),qe(1,p.$TL),qe(2,D.$j_b),qe(3,A.$Q$b),qe(4,P.$Si),qe(5,P.$Ri)],m),e.$H_b=(0,T.$ph)("IExtHostOutputService")}),define(Ae[260],Fe([1,0,3,16]),function($e,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=void 0,e.$8l=(0,w.$ph)("remoteAgentService"),e.$9l=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let M=1/0;for(let g=0;g<this.maxSampleCount;g++){const D=await C.getRoundTripTime();if(D===void 0)return;M=Math.min(M,D/2),await(0,T.$wg)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let P;return this.initial.length<this.maxInitialCount?this.initial.push(M):P=this.initial.reduce((g,D)=>g+D,0)/this.initial.length,this.lastMeasurement={initial:P,current:M,average:this.average.reduce((g,D)=>g+D,0)/this.average.length,high:(()=>typeof P>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>P*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[261],Fe([1,0,42,13,19,22,23,2,3,187,54,209,260]),function($e,e,w,T,C,M,P,g,D,p,A,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eJ=e.$dJ=void 0,e.$dJ=(0,D.$ph)("pathService");let y=class kn{constructor(o,t,i,a){this.d=o,this.e=t,this.f=i,this.g=a,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const m=await this.e.getEnvironment();return this.c=m?.userHome??o})()}hasValidBasename(o,t,i){return typeof t=="string"||typeof t>"u"?this.a.then(a=>this.h(o,a,t)):this.h(o,t,i)}h(o,t,i){return o.scheme===T.Schemas.file||o.scheme===T.Schemas.vscodeRemote?(0,w.$Ie)(i??(0,P.$7f)(o),t===1):!0}get defaultUriScheme(){return kn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,t){if(o.remoteAuthority)return T.Schemas.vscodeRemote;const i=(0,p.$aJ)(t.getWorkspace());if(i)return i;const a=t.getWorkspace().folders[0];if(a)return a.uri.scheme;const m=t.getWorkspace().configuration;return m?m.scheme:T.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?C.$9b:C.$0b)}async fileURI(o){let t="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const a=o.indexOf("/",2);a===-1?(t=o.substring(2),o="/"):(t=o.substring(2,a),o=o.substring(a)||"/")}return g.URI.from({scheme:T.Schemas.file,authority:t,path:o,query:"",fragment:""})}};e.$eJ=y,e.$eJ=y=Ve([qe(1,c.$8l),qe(2,E.$RI),qe(3,A.$yh)],y)}),define(Ae[110],Fe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$TH=e.$SH=void 0;class w{constructor(P,g){this.line=P,this.character=g}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,g){return new w(0,0)}with(P){return new w(0,0)}}e.$SH=w;class T{constructor(P,g,D,p){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(P,g),this.end=new w(D,p)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new T(0,0,0,0)}with(P){return new T(0,0,0,0)}}e.$TH=T;var C;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ae[47],Fe([1,0,18,37,24,42,15,3,19,11,110,16]),function($e,e,w,T,C,M,P,g,D,p,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.SearchErrorCode=e.$8H=e.$7H=e.SearchSortOrder=e.ViewMode=e.$6H=e.$5H=e.$4H=e.$3H=e.SearchCompletionExitCode=e.$2H=e.$1H=e.$ZH=e.QueryType=e.SearchProviderType=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$UH="workbench.view.search",e.$VH="workbench.panel.search",e.$WH="workbench.view.search",e.$XH="search.exclude";const c="\u27EA ",y=" characters skipped \u27EB",b=(c.length+y.length+5)*2;e.$YH=(0,g.$ph)("searchService");var o;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text"})(o||(e.SearchProviderType=o={}));var t;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text"})(t||(e.QueryType=t={}));function i(Z){return!!Z.preview}e.$ZH=i;function a(Z){return!!Z.resource}e.$1H=a;function m(Z){return!!Z.message}e.$2H=m;var S;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(S||(e.SearchCompletionExitCode=S={}));class I{constructor(he){this.resource=he,this.results=[]}}e.$3H=I;class r{constructor(he,Ce,H,ne){this.ranges=Ce,this.webviewIndex=ne;const re=Array.isArray(Ce)?Ce:[Ce];if(H&&H.matchLines===1&&h(re)){he=(0,P.$ce)(he,H.matchLines);let L="",_=0,pe=0;const Ie=Math.floor(H.charsPerLine/5),De=[];for(const ye of re){const Se=Math.max(ye.startColumn-Ie,0),oe=ye.startColumn+H.charsPerLine;if(Se>pe+Ie+b){const de=c+(Se-pe)+y;L+=de+he.slice(Se,oe),_+=Se-(pe+de.length)}else L+=he.slice(pe,oe);De.push(new s(0,ye.startColumn-_,ye.endColumn-_)),pe=oe}this.preview={text:L,matches:Array.isArray(this.ranges)?De:De[0]}}else{const L=Array.isArray(Ce)?Ce[0].startLineNumber:Ce.startLineNumber;this.preview={text:he,matches:(0,w.$If)(Ce,_=>new n(_.startLineNumber-L,_.startColumn,_.endLineNumber-L,_.endColumn))}}}}e.$4H=r;function h(Z){const he=Z[0].startLineNumber;for(const Ce of Z)if(Ce.startLineNumber!==he||Ce.endLineNumber!==he)return!1;return!0}class n{constructor(he,Ce,H,ne){this.startLineNumber=he,this.startColumn=Ce,this.endLineNumber=H,this.endColumn=ne}}e.$5H=n;class s extends n{constructor(he,Ce,H){super(he,Ce,he,H)}}e.$6H=s;var $;(function(Z){Z.List="list",Z.Tree="tree"})($||(e.ViewMode=$={}));var k;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(k||(e.SearchSortOrder=k={}));function l(Z,he=!0){const Ce=Z&&Z.files&&Z.files.exclude,H=he&&Z&&Z.search&&Z.search.exclude;if(!Ce&&!H)return;if(!Ce||!H)return Ce||H;let ne=Object.create(null);return ne=C.$Km(ne,C.$Hm(Ce)),ne=C.$Km(ne,C.$Hm(H),!0),ne}e.$7H=l;function f(Z,he){return Z.excludePattern&&T.$dj(Z.excludePattern,he)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&T.$dj(Z.includePattern,he)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(Ce=>{const H=Ce.folder.fsPath;if(M.$Ke(he,H)){const ne=D.$cc(H,he);return!Ce.includePattern||!!T.$dj(Ce.includePattern,ne)}else return!1}):!1:!0}e.$8H=f;var v;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class u extends Error{constructor(he,Ce){super(he),this.code=Ce}}e.$9H=u;function d(Z){const he=Z.message;if((0,p.$2)(Z))return new u(he,v.canceled);try{const Ce=JSON.parse(he);return new u(Ce.message,Ce.code)}catch{return new u(he,v.other)}}e.$0H=d;function R(Z){const he={message:Z.message,code:Z.code};return new Error(JSON.stringify(he))}e.$$H=R;function W(Z){return Z.type==="error"?!0:Z.type==="success"}e.$_H=W;function B(Z){return Z.type==="success"}e.$aI=B;function q(Z){return!!Z.path}e.$bI=q;function U(Z,he){const Ce=Z.searchPath?Z.searchPath:Z.relativePath;return(0,P.$_d)(Ce,he)}e.$cI=U;class N{constructor(he){this.path=he,this.results=[]}addMatch(he){this.results.push(he)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$dI=N;function O(Z,he){const Ce={...Z||{},...he||{}};return Object.keys(Ce).filter(H=>{const ne=Ce[H];return typeof ne=="boolean"&&ne})}e.$eI=O;class ce{constructor(he,Ce){this.c=null,this.a={...he.excludePattern||{},...Ce.excludePattern||{}},this.b=T.$ej(this.a);let H=he.includePattern;Ce.includePattern&&(H?H={...H,...Ce.includePattern}:H=Ce.includePattern),H&&(this.c=T.$ej(H))}matchesExcludesSync(he,Ce,H){return!!(this.b&&this.b(he,Ce,H))}includedInQuerySync(he,Ce,H){return!(this.b&&this.b(he,Ce,H)||this.c&&!this.c(he,Ce,H))}includedInQuery(he,Ce,H){const ne=this.b(he,Ce,H),re=()=>this.c?!!this.c(he,Ce,H):!0;return(0,E.$ig)(ne)?ne.then(L=>L?!1:re()):re()}hasSiblingExcludeClauses(){return X(this.a)}}e.$fI=ce;function X(Z){for(const he in Z)if(typeof Z[he]!="boolean")return!0;return!1}function be(Z){if(!Z)return;let he;return Ce=>(he||(he=(Z()||Promise.resolve([])).then(H=>H?Re(H):{})),he.then(H=>!!H[Ce]))}e.$gI=be;function Ee(Z){if(!Z)return;let he;return Ce=>{if(!he){const H=Z();he=H?Re(H):{}}return!!he[Ce]}}e.$hI=Ee;function Re(Z){const he={};for(const Ce of Z)he[Ce]=!0;return he}}),define(Ae[33],Fe([1,0,18,16,20,5,6,48,13,117,23,15,12,2,158,3,14,175,54,39,27,17,8,7,56,47,4]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t,i,a,m,S,I,r,h,n,s,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4$b=e.$3$b=void 0;function k(B,q,U){return new A.$Yf(N=>u(N,U)).isEqual(B,q)}function l(B,q,U){return k(B.uri,q.uri,U)?0:(0,E.$Fd)(B.uri.toString(),q.uri.toString())}function f(B,q,U){return B.index!==q.index?B.index<q.index?-1:1:k(B.uri,q.uri,U)?(0,E.$Fd)(B.name,q.name):(0,E.$Fd)(B.uri.toString(),q.uri.toString())}function v(B,q,U,N){const O=B.slice(0).sort((X,be)=>U(X,be,N)),ce=q.slice(0).sort((X,be)=>U(X,be,N));return(0,w.$jf)(O,ce,(X,be)=>U(X,be,N))}function u(B,q){const U=q.getCapabilities(B.scheme);return!(U&&U&1024)}class d extends a.$Ih{static toExtHostWorkspace(q,U,N,O){if(!q)return{workspace:null,added:[],removed:[]};const{id:ce,name:X,folders:be,configuration:Ee,transient:Re,isUntitled:Z}=q,he=[],Ce=U;U?be.forEach((L,_)=>{const pe=y.URI.revive(L.uri),Ie=d.o(N||U,pe,O);Ie?(Ie.name=L.name,Ie.index=L.index,he.push(Ie)):he.push({uri:pe,name:L.name,index:_})}):he.push(...be.map(({uri:L,name:_,index:pe})=>({uri:y.URI.revive(L),name:_,index:pe}))),he.sort((L,_)=>L.index<_.index?-1:1);const H=new d(ce,X,he,!!Re,Ee?y.URI.revive(Ee):null,!!Z,L=>u(L,O)),{added:ne,removed:re}=v(Ce?Ce.workspaceFolders:[],H.workspaceFolders,l,O);return{workspace:H,added:ne,removed:re}}static o(q,U,N){for(let O=0;O<q.folders.length;O++){const ce=q.workspaceFolders[O];if(k(ce.uri,U,N))return ce}}constructor(q,U,N,O,ce,X,be){super(q,N.map(Ee=>new a.$Jh(Ee)),O,ce,be),this.t=U,this.u=X,this.q=[],this.s=g.$vh.forUris(be),N.forEach(Ee=>{this.q.push(Ee),this.s.set(Ee.uri,Ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,U){return U&&this.s.get(q)&&(q=(0,A.$9f)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let R=class{constructor(q,U,N,O,ce){this.c=new M.$8c,this.onDidChangeWorkspace=this.c.event,this.g=new M.$8c,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$0c,this.B=new Map,this.h=O,this.s=N,this.t=ce,this.j=new p.$vl,this.k=new T.$ug,this.o=q.getProxy($.$BJ.MainThreadWorkspace),this.q=q.getProxy($.$BJ.MainThreadMessageService);const X=U.workspace;this.l=X?new d(X.id,X.name,[],!!X.transient,X.configuration?y.URI.revive(X.configuration):null,!!X.isUntitled,be=>u(be,N)):void 0}$initializeWorkspace(q,U){this.v=U,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?y.URI.from({scheme:D.Schemas.untitled,path:(0,A.$7f)((0,A.$9f)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,U,N,...O){const ce=[];if(Array.isArray(O)&&O.forEach(Z=>{y.URI.isUri(Z.uri)&&!ce.some(he=>k(he.uri,Z.uri,this.s))&&ce.push({uri:Z.uri,name:Z.name||(0,A.$6f)(Z.uri)})}),this.n||[U,N].some(Z=>typeof Z!="number"||Z<0)||N===0&&ce.length===0)return!1;const X=this.x?this.x.workspaceFolders:[];if(U+N>X.length)return!1;const be=X.slice(0);be.splice(U,N,...ce.map(Z=>({uri:Z.uri,name:Z.name||(0,A.$6f)(Z.uri),index:void 0})));for(let Z=0;Z<be.length;Z++){const he=be[Z];if(be.some((Ce,H)=>H!==Z&&k(he.uri,Ce.uri,this.s)))return!1}be.forEach((Z,he)=>Z.index=he);const{added:Ee,removed:Re}=v(X,be,f,this.s);if(Ee.length===0&&Re.length===0)return!1;if(this.o){const Z=q.displayName||q.name;this.o.$updateWorkspaceFolders(Z,U,N,ce).then(void 0,he=>{this.n=void 0;const Ce={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(i.Severity.Error,(0,b.localize)(0,null,Z,he.toString()),Ce,[])})}return this.y(be),!0}getWorkspaceFolder(q,U){if(this.x)return this.x.getWorkspaceFolder(q,U)}async getWorkspaceFolder2(q,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,U)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,U){let N,O="";if(typeof q=="string"?(N=y.URI.file(q),O=q):typeof q<"u"&&(N=q,O=q.fsPath),!N)return O;const ce=this.getWorkspaceFolder(N,!0);if(!ce)return O;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let X=(0,A.$_f)(ce.uri,N);return U&&ce.name&&(X=`${ce.name}/${X}`),X}y(q){this.x&&(this.n=d.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:U,added:N,removed:O}=d.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:O}))}findFiles(q,U,N,O,ce=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let X;if(U===null?X=!1:U&&(typeof U=="string"?X=U:X=U.pattern),ce&&ce.isCancellationRequested)return Promise.resolve([]);const{includePattern:be,folder:Ee}=W(r.GlobPattern.from(q));return this.o.$startFileSearch((0,c.$Ce)(be),(0,c.$Ce)(Ee),(0,c.$Ce)(X),(0,c.$Ce)(N),ce).then(Re=>Array.isArray(Re)?Re.map(Z=>y.URI.revive(Z)):[])}async findTextInFiles(q,U,N,O,ce=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const X=this.j.getNext(),be=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:Ee,folder:Re}=W(r.GlobPattern.from(U.include)),Z=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,he={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:be,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:Ee,excludePattern:Z},Ce=!1;if(this.u[X]=H=>{if(Ce)return;const ne=y.URI.revive(H.resource);H.results.forEach(re=>{(0,s.$ZH)(re)?N({uri:ne,preview:{text:re.preview.text,matches:(0,w.$If)(re.preview.matches,L=>new h.$FJ(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn))},ranges:(0,w.$If)(re.ranges,L=>new h.$FJ(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn))}):N({uri:ne,text:re.text,lineNumber:re.lineNumber})})},ce.isCancellationRequested)return{};try{const H=await this.o.$startTextSearch(q,(0,c.$Ce)(Re),he,X,ce);return delete this.u[X],H||{}}catch(H){throw delete this.u[X],H}}$handleTextSearchResult(q,U){this.u[U]?.(q)}async save(q){const U=await this.o.$save(q,{saveAs:!1});return y.URI.revive(U)}async saveAs(q){const U=await this.o.$save(q,{saveAs:!0});return y.URI.revive(U)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,U){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,U);const N=this.t.transformOutgoingScheme(q),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,N),(0,P.$jb)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(q,U){this.h.info("Getting edit session identifier for workspaceFolder",q);const N=await this.resolveWorkspaceFolder(y.URI.revive(q));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const O=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!O),!O)return;const ce=await O.provideEditSessionIdentity(N,U);if(this.h.info("Provider returned edit session identifier: ",ce),!!ce)return ce}async $provideEditSessionIdentityMatch(q,U,N,O){this.h.info("Getting edit session identifier for workspaceFolder",q);const ce=await this.resolveWorkspaceFolder(y.URI.revive(q));if(!ce){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",ce);const X=this.w.get(ce.uri.scheme);if(this.h.info(`Provider for scheme ${ce.uri.scheme} is defined: `,!!X),!X)return;const be=await X.provideEditSessionIdentityMatch?.(U,N,O);if(this.h.info("Provider returned edit session identifier match result: ",be),!!be)return be}getOnWillCreateEditSessionIdentityEvent(q){return(U,N,O)=>{const ce=function(be){U.call(N,be)};return ce.extension=q,this.A.event(ce,void 0,O)}}async $onWillCreateEditSessionIdentity(q,U,N){const O=await this.resolveWorkspaceFolder(y.URI.revive(q));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},U,async(ce,X)=>{const be=Date.now();await Promise.resolve(ce),Date.now()-be>N&&this.h.warn("SLOW edit session create-participant",X.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(q,U){if(this.B.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.B.set(q,U);const N=this.t.transformOutgoingScheme(q),O=this.z++;return this.o.$registerCanonicalUriProvider(O,N),(0,P.$jb)(()=>{this.B.delete(q),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(q,U,N){const O=this.B.get(q.scheme);if(!O)return;const ce=await O.provideCanonicalUri?.(y.URI.revive(q),U,N);if(ce)return ce}async $provideCanonicalUri(q,U,N){return this.provideCanonicalUri(y.URI.revive(q),{targetScheme:U},N)}};e.$3$b=R,e.$3$b=R=Ve([qe(0,I.$DL),qe(1,S.$TL),qe(2,m.$Q$b),qe(3,t.$Ri),qe(4,n.$1$b)],R),e.$4$b=(0,o.$ph)("IExtHostWorkspace");function W(B){let q,U;return B&&(typeof B=="string"?q=B:(q=B.pattern,U=y.URI.revive(B.baseUri))),{includePattern:q,folder:U}}}),define(Ae[34],Fe([1,0,24,5,33,4,7,178,95,12,16,3,17,14,2]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7$b=e.$6$b=e.$5$b=void 0;function o(h,n){if(n){const s=n.split(".");let $=h;for(let k=0;$&&k<s.length;k++)$=$[s[k]];return $}}function t(h){return h instanceof b.URI}function i(h){return h&&h.uri instanceof b.URI&&h.languageId&&typeof h.languageId=="string"}function a(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function m(h){return h&&h.uri instanceof b.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function S(h){if(t(h))return{resource:h};if(i(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(a(h))return{overrideIdentifier:h.languageId};if(m(h))return{resource:h.uri};if(h===null)return{resource:null}}let I=class{constructor(n,s,$){this.a=n.getProxy(M.$BJ.MainThreadConfiguration),this.c=s,this.b=$,this.d=new A.$ug,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new r(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,s){this.getConfigProvider().then($=>$.$acceptConfigurationChanged(n,s))}};e.$5$b=I,e.$5$b=I=Ve([qe(0,c.$DL),qe(1,C.$4$b),qe(2,y.$Ri)],I);class r{constructor(n,s,$,k){this.a=new T.$8c,this.b=n,this.f=k,this.c=s,this.e=g.$fn.parse($),this.d=this.k($.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,s){const $={data:this.e.toData(),workspace:this.c.workspace};this.e=g.$fn.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(s,$))}getConfiguration(n,s,$){const k=S(s)||{},l=this.g(n?o(this.e.getValue(void 0,k,this.c.workspace),n):this.e.getValue(void 0,k,this.c.workspace));n&&this.h(n,k,$?.identifier);function f(u){if(u==null)return null;if(typeof u=="boolean")return u?2:5;switch(u){case P.ConfigurationTarget.Global:return 2;case P.ConfigurationTarget.Workspace:return 5;case P.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(u){return typeof o(l,u)<"u"},get:(u,d)=>{this.h(n?`${n}.${u}`:u,k,$?.identifier);let R=o(l,u);if(typeof R>"u")R=d;else{let W;const B=(q,U)=>{if((0,p.$le)(q)){let N;const O=()=>{W=W||(0,w.$Hm)(l),N=N||o(W,U)};return new Proxy(q,{get:(ce,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return O(),()=>N;if(W)return N=N||o(W,U),N[X];const be=ce[X];return typeof X=="string"?B(be,`${U}.${X}`):be},set:(ce,X,be)=>(O(),N&&(N[X]=be),!0),deleteProperty:(ce,X)=>(O(),N&&delete N[X],!0),defineProperty:(ce,X,be)=>(O(),N&&Object.defineProperty(N,X,be),!0)})}return Array.isArray(q)?(0,w.$Hm)(q):q};R=B(R,u)}return R},update:(u,d,R,W)=>{u=n?`${n}.${u}`:u;const B=f(R);return d!==void 0?this.b.$updateConfigurationOption(B,u,d,k,W):this.b.$removeConfigurationOption(B,u,k,W)},inspect:u=>{u=n?`${n}.${u}`:u;const d=this.e.inspect(u,k,this.c.workspace);if(d)return{key:u,defaultValue:(0,w.$Hm)(d.policy?.value??d.default?.value),globalValue:(0,w.$Hm)(d.user?.value??d.application?.value),workspaceValue:(0,w.$Hm)(d.workspace?.value),workspaceFolderValue:(0,w.$Hm)(d.workspaceFolder?.value),defaultLanguageValue:(0,w.$Hm)(d.default?.override),globalLanguageValue:(0,w.$Hm)(d.user?.override??d.application?.override),workspaceLanguageValue:(0,w.$Hm)(d.workspace?.override),workspaceFolderLanguageValue:(0,w.$Hm)(d.workspaceFolder?.override),languageIds:(0,w.$Hm)(d.overrideIdentifiers)}}};return typeof l=="object"&&(0,w.$Km)(v,l,!1),Object.freeze(v)}g(n){const s=$=>(0,p.$le)($)?new Proxy($,{get:(k,l)=>s(k[l]),set:(k,l,f)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(k,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(k,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:k=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):$;return s(n)}h(n,s,$){const k=D.$9m.test(n)?4:this.d.get(n),l=$?`[${$.value}] `:"";if(k===4){typeof s?.resource>"u"&&this.f.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(k===3){s?.resource&&this.f.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,s){const $=new g.$hn(n,s,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(k,l)=>$.affectsConfiguration(k,S(l))})}k(n){return n.reduce((s,$)=>(s.set($[0],$[1]),s),new Map)}}e.$6$b=r,e.$7$b=(0,E.$ph)("IExtHostConfiguration")}),define(Ae[111],Fe([1,0,2,16,5,4,7,33,60,34,20,63,17,27,3,13,22,14,79,215,11]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t,i,a,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5_b=e.$4_b=e.$3_b=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var I;(function(B){function q(N){if(N!=null)return N}B.from=q;function U(N){if(N!=null)return N}B.to=U})(I||(I={}));var r;(function(B){function q(N){if(N!=null)return N}B.from=q;function U(N){if(N!=null)return N}B.to=U})(r||(r={}));var h;(function(B){function q(N){if(N!=null)return N}B.from=q;function U(N){if(N!=null)return N}B.to=U})(h||(h={}));var n;(function(B){function q(O){if(O){const ce=O;return ce&&!!ce.process}else return!1}B.is=q;function U(O){if(O==null)return;const ce={process:O.process,args:O.args};return O.options&&(ce.options=h.from(O.options)),ce}B.from=U;function N(O){if(O!=null)return new P.$mK(O.process,O.args,O.options)}B.to=N})(n||(n={}));var s;(function(B){function q(N){if(N!=null)return N}B.from=q;function U(N){if(N!=null)return N}B.to=U})(s||(s={}));var $;(function(B){function q(O){if(O){const ce=O;return ce&&(!!ce.commandLine||!!ce.command)}else return!1}B.is=q;function U(O){if(O==null)return;const ce={};return O.commandLine!==void 0?ce.commandLine=O.commandLine:(ce.command=O.command,ce.args=O.args),O.options&&(ce.options=s.from(O.options)),ce}B.from=U;function N(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new P.$nK(O.commandLine,O.options):new P.$nK(O.command,O.args?O.args:[],O.options)}B.to=N})($||($={}));var k;(function(B){function q(O){if(O){const ce=O;return ce&&ce.customExecution==="customExecution"}else return!1}B.is=q;function U(O){return{customExecution:"customExecution"}}B.from=U;function N(O,ce){return ce.get(O)}B.to=N})(k||(e.CustomExecutionDTO=k={}));var l;(function(B){function q(U,N){let O;return U.scope!==void 0&&typeof U.scope!="number"?O=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===P.TaskScope.Workspace&&N&&N.workspaceFile?O=N.workspaceFile:O=m.$UF),{id:U._id,workspaceFolder:O}}B.from=q})(l||(e.TaskHandleDTO=l={}));var f;(function(B){function q(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}B.from=q})(f||(f={}));var v;(function(B){function q(O,ce){if(O==null)return[];const X=[];for(const be of O){const Ee=U(be,ce);Ee&&X.push(Ee)}return X}B.fromMany=q;function U(O,ce){if(O==null)return;let X;O.execution instanceof P.$mK?X=n.from(O.execution):O.execution instanceof P.$nK?X=$.from(O.execution):O.execution&&O.execution instanceof P.$oK&&(X=k.from(O.execution));const be=I.from(O.definition);let Ee;return O.scope?typeof O.scope=="number"?Ee=O.scope:Ee=O.scope.uri:Ee=P.TaskScope.Workspace,!be||!Ee?void 0:{_id:O._id,definition:be,name:O.name,source:{extensionId:ce.identifier.value,label:O.source,scope:Ee},execution:X,isBackground:O.isBackground,group:f.from(O.group),presentationOptions:r.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}B.from=U;async function N(O,ce,X){if(O==null)return;let be;n.is(O.execution)?be=n.to(O.execution):$.is(O.execution)?be=$.to(O.execution):k.is(O.execution)&&(be=k.to(O._id,X));const Ee=I.to(O.definition);let Re;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Re=O.source.scope:Re=await ce.resolveWorkspaceFolder(w.URI.revive(O.source.scope)):Re=P.TaskScope.Workspace),!Ee||!Re)return;const Z=new P.$pK(Ee,Re,O.name,O.source.label,be,O.problemMatchers);return O.isBackground!==void 0&&(Z.isBackground=O.isBackground),O.group!==void 0&&(Z.group=P.$lK.from(O.group._id),Z.group&&O.group.isDefault&&(Z.group=new P.$lK(Z.group.id,Z.group.label),O.group.isDefault===!0&&(Z.group.isDefault=O.group.isDefault))),O.presentationOptions&&(Z.presentationOptions=r.to(O.presentationOptions)),O._id&&(Z._id=O._id),O.detail&&(Z.detail=O.detail),Z}B.to=N})(v||(e.TaskDTO=v={}));var u;(function(B){function q(N){return N}B.from=q;function U(N){if(N)return Object.assign(Object.create(null),N)}B.to=U})(u||(u={}));class d{#e;constructor(q,U,N){this._id=U,this.a=N,this.#e=q}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}let R=class{constructor(q,U,N,O,ce,X,be,Ee){this.q=new C.$8c,this.r=new C.$8c,this.s=new C.$8c,this.t=new C.$8c,this.a=q.getProxy(M.$BJ.MainThreadTask),this.b=N,this.c=O,this.d=ce,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=be,this.g=Ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(q,U,N){if(!N)return new P.$DJ(()=>{});const O=this.w();return this.j.set(O,{type:U,provider:N,extension:q}),this.a.$registerTaskProvider(O,U),new P.$DJ(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(q,U){this.a.$registerTaskSystem(q,U)}fetchTasks(q){return this.a.$fetchTasks(u.from(q)).then(async U=>{const N=[];for(const O of U){const ce=await v.to(O,this.b,this.m);ce&&N.push(ce)}return N})}get taskExecutions(){const q=[];return this.k.forEach(U=>q.push(U)),q}terminateTask(q){if(!(q instanceof d))throw new Error("No valid task execution provided");return this.a.$terminateTask(q._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(q,U,N){const O=this.m.get(q.id);O&&(this.o.set(q.id,O),this.e.attachPtyToTerminal(U,await O.callback(N))),this.p=q.id,this.q.fire({execution:await this.y(q)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(q){const U=await this.y(q);this.l.delete(q.id),this.k.delete(q.id),this.A(q),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(q){const U=await this.y(q.id);this.s.fire({execution:U,processId:q.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(q){const U=await this.y(q.id);this.t.fire({execution:U,exitCode:q.exitCode})}$provideTasks(q,U){const N=this.j.get(q);if(!N)return Promise.reject(new Error("no handler found"));const O=[],ce=(0,T.$og)(()=>N.provider.provideTasks(A.CancellationToken.None)).then(X=>this.u(U,O,N,X));return new Promise(X=>{ce.then(be=>{Promise.all(O).then(()=>{X(be)})})})}async $resolveTask(q,U){const N=this.j.get(q);if(!N)return Promise.reject(new Error("no handler found"));if(U.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${N.type}].`);const O=await v.to(U,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const ce=await N.provider.resolveTask(O,A.CancellationToken.None);if(!ce)return;this.z(ce,N);const X=v.from(ce,N.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(ce.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return k.is(X.execution)&&await this.x(X,ce,!0),await this.v(X)}w(){return this.h++}async x(q,U,N){const O=await this.a.$createTaskId(q);!N&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,U.execution)),this.m.set(O,U.execution)}async y(q,U){if(typeof q=="string"){const ce=this.l.get(q);if(!ce)throw new S.$ab("Unexpected: The specified task is missing an execution");return ce}const N=this.l.get(q.id);if(N)return N;const O=new Promise((ce,X)=>{function be(Ee,Re,Z){Z?ce(new d(Ee,Re.id,Z)):X("Unexpected: Task does not exist.")}U?be(this,q,U):v.to(q.task,this.b,this.m).then(Ee=>be(this,q,Ee))});return this.l.set(q.id,O),O.then(ce=>(this.k.set(q.id,ce),ce),ce=>Promise.reject(ce))}z(q,U){q._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(q){this.o.get(q.id)&&this.o.delete(q.id),this.n.has(q.id)&&this.p!==q.id&&(this.m.delete(q.id),this.n.delete(q.id));const N=this.n.values();let O=N.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=N.next()}};e.$3_b=R,e.$3_b=R=Ve([qe(0,c.$DL),qe(1,y.$TL),qe(2,g.$4$b),qe(3,D.$OL),qe(4,p.$7$b),qe(5,E.$m_b),qe(6,i.$Ri),qe(7,a.$T$b)],R);let W=class extends R{constructor(q,U,N,O,ce,X,be,Ee){super(q,U,N,O,ce,X,be,Ee),this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(q,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const N=v.from(U,q);if(N===void 0)throw new Error("Task is not valid");if(k.is(N.execution))await this.x(N,U,!1);else throw new S.$$;const O=await this.y(await this.a.$getTaskExecution(N),U);return this.a.$executeTask(N).catch(ce=>{throw new Error(ce)}),O}u(q,U,N,O){const ce=[];if(O)for(const X of O){this.z(X,N),(!X.definition||!q[X.definition.type])&&this.f.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const be=v.from(X,N.extension);be&&k.is(be.execution)?(ce.push(be),U.push(this.x(be,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ce,extension:N.extension}}async v(q){if(k.is(q.execution))return q;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(q,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,U,N){}};e.$4_b=W,e.$4_b=W=Ve([qe(0,c.$DL),qe(1,y.$TL),qe(2,g.$4$b),qe(3,D.$OL),qe(4,p.$7$b),qe(5,E.$m_b),qe(6,i.$Ri),qe(7,a.$T$b)],W),e.$5_b=(0,b.$ph)("IExtHostTask")}),define(Ae[262],Fe([1,0,19,20,41,37,23,59,47]),function($e,e,w,T,C,M,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cac=void 0;class p{constructor(c,y,b){this.k=c,this.l=y,this.o=b,this.e=!1,this.f=0,this.g=!1,this.a=c.filePattern,this.b=c.includePattern&&M.$ej(c.includePattern),this.c=c.maxResults||void 0,this.d=c.exists,this.h=new Set,this.j=c.excludePattern&&M.$ej(c.excludePattern)}cancel(){this.g=!0,this.h.forEach(c=>c.cancel()),this.h=new Set}search(c){const y=this.k.folderQueries||[];return new Promise((b,o)=>{const t=i=>{this.f++,c(i)};if(this.g)return b({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const a=i.toString(),m=w.$ec(a);this.j&&this.j(a,m)||this.v(t,{base:i,basename:m})}),Promise.all(y.map(i=>this.p(i,t))).then(i=>{b({limitHit:this.e,stats:i[0]||void 0})},i=>{o(new Error((0,C.$ai)(i)))})})}async p(c,y){const b=new T.$ed,o=this.q(c),t=this.r(),i=new D.$fI(this.k,c),a=!i.hasSiblingExcludeClauses();let m;try{this.h.add(b),m=g.$4c.create();const S=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},o,b.token),I=m.elapsed(),r=g.$4c.create();return this.g&&!this.e||(S&&S.forEach(h=>{const n=w.$0b.relative(c.folder.path,h.path);if(a){const s=w.$ec(h.path);this.v(y,{base:c.folder,relativePath:n,basename:s});return}this.s(t,c.folder,n,y)}),this.g&&!this.e)?null:(this.u(t,i,y),{providerTime:I,postProcessTime:r.elapsed()})}finally{b.dispose(),this.h.delete(b)}}q(c){const y=(0,D.$eI)(this.k.includePattern,c.includePattern),b=(0,D.$eI)(this.k.excludePattern,c.excludePattern);return{folder:c.folder,excludes:b,includes:y,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}s({pathToEntries:c},y,b,o){if(b===this.a){const i=w.$ec(this.a);this.v(o,{base:y,relativePath:this.a,basename:i})}function t(i){const a=w.$ec(i),m=w.$dc(i);let S=c[m];S||(S=c[m]=[],t(m)),S.push({base:y,relativePath:i,basename:a})}t(b)}u({rootEntries:c,pathToEntries:y},b,o){const t=this,i=this.a;function a(m){const S=(0,D.$hI)(()=>m.map(I=>I.basename));for(let I=0,r=m.length;I<r;I++){const h=m[I],{relativePath:n,basename:s}=h;if(b.matchesExcludesSync(n,s,i!==s?S:void 0))continue;const $=y[n];if($)a($);else{if(n===i)continue;t.v(o,h)}if(t.e)break}}a(c)}v(c,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||c(y))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(c,y,b,o){const t=this.c(c.cacheKey),i=new p(c,y,t&&t.token);let a=0;const m=S=>{a+=S.length,b(S.map(I=>this.d(I)))};return this.e(i,A.a,m,o).then(S=>({limitHit:S.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:a,detailStats:S.stats}}))}clearCache(c){this.c(c)?.cancel()}c(c){if(c)return this.b.has(c)||this.b.set(c,new T.$ed),this.b.get(c)}d(c){return c.relativePath?{resource:P.$0f(c.base,c.relativePath)}:{resource:c.base}}e(c,y,b,o){o.onCancellationRequested(()=>{c.cancel()});const t=a=>{a&&(i.push(a),y>0&&i.length>=y&&(b(i),i=[]))};let i=[];return c.search(t).then(a=>(i.length&&b(i),a),a=>(i.length&&b(i),Promise.reject(a)))}}e.$cac=A}),define(Ae[263],Fe([1,0,18,99,37,89,28,13,19,23,15,12,2,277,167,43,14,54,102,261,47]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t,i,a,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gJ=e.$fJ=void 0;let I=class{constructor(u,d,R,W,B){this.a=u,this.b=d,this.c=R,this.d=W,this.e=B}text(u,d,R={}){u=this.f(u,R);const W=this.a.getValue(),B=d&&d.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(d?.map(i.$Kh),R),type:2,contentPattern:u,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:W.search.usePCRE2||B||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}f(u,d){const R=this.a.getValue();u.isRegExp&&(u.pattern=u.pattern.replace(/\r?\n/g,"\\n"));const W={...u,wordSeparators:R.editor.wordSeparators};return this.j(u,d)&&(W.isCaseSensitive=!0),this.k(u)&&(W.isMultiline=!0),d.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=d.notebookSearchConfig.includeMarkupInput),d.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=d.notebookSearchConfig.includeMarkupPreview),d.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=d.notebookSearchConfig.includeCodeInput),d.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=d.notebookSearchConfig.includeOutput),W}file(u,d={}){return{...this.h(u,d),type:1,filePattern:d.filePattern?d.filePattern.trim():d.filePattern,exists:d.exists,sortByScore:d.sortByScore,cacheKey:d.cacheKey}}g(u,d){return u?(u=Array.isArray(u)?u.map($):$(u),d?this.parseSearchPaths(u):{pattern:h(...Array.isArray(u)?u:[u])}):{}}h(u=[],d={}){const R=this.g(d.includePattern,d.expandPatterns),W=this.g(d.excludePattern,d.expandPatterns),B=u.length>1,q=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(O=>this.q(O,d,W)):u.map(O=>this.r(O,d,W,B))).filter(O=>!!O),U={_reason:d._reason,folderQueries:q,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:d.extraFileResources,excludePattern:W.pattern,includePattern:R.pattern,onlyOpenEditors:d.onlyOpenEditors,maxResults:d.maxResults};if(d.onlyOpenEditors){const O=w.$mf(w.$yf(this.c.groups.map(be=>be.editors.map(Ee=>Ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const ce=O.filter(be=>(0,S.$8H)(U,be.fsPath)),X=this.i(ce);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...U,...X}}const N=d.extraFileResources&&d.extraFileResources.filter(O=>(0,S.$8H)(U,O.fsPath));return U.extraFileResources=N&&N.length?N:void 0,U}i(u){const d=[],R=new P.$ni,W={};let B=!1;return u.forEach(q=>{if(q.scheme===g.Schemas.walkThrough)return;if((0,p.$bg)(q)){const N=this.b.getWorkspaceFolder(q)?.uri??q.with({path:D.$dc(q.fsPath)});let O=R.get(N);O||(B=!0,O={folder:N,includePattern:{}},d.push(O),R.set(N,O));const ce=D.$cc(N.fsPath,q.fsPath);(0,E.$ue)(O.includePattern)[ce.replace(/\\/g,"/")]=!0}else q.fsPath&&(B=!0,W[q.fsPath]=!0)}),{folderQueries:d,includePattern:W,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}j(u,d){if(d.isSmartCase){if(u.isRegExp){if(A.$ae(u.pattern,!0))return!0}else if(A.$ae(u.pattern))return!0}return!!u.isCaseSensitive}k(u){return u.isMultiline||u.isRegExp&&(0,y.$4B)(u.pattern)||u.pattern.indexOf(`
`)>=0?!0:!!u.isMultiline}parseSearchPaths(u){const d=X=>D.$_b(X)||/^\.\.?([\/\\]|$)/.test(X),W=(Array.isArray(u)?u:n(u)).map(X=>{const be=this.e.resolvedUserHome;return be?(0,M.$3z)(X,be.scheme===g.Schemas.file?be.fsPath:be.path):X}),B=T.$I(W,X=>d(X)?"searchPaths":"exprSegments"),q=(B.exprSegments||[]).map(X=>A.$td(X,"/")).map(X=>A.$td(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),s(X))),U={},N=this.m(B.searchPaths||[]);N&&N.length&&(U.searchPaths=N);const O=w.$yf(q),ce=h(...O);return ce&&(U.pattern=ce),U}l(u,d){return d.disregardExcludeSettings?void 0:(0,S.$7H)(u,!d.disregardSearchExcludeSettings)}m(u){if(!u||!u.length)return[];const d=u.flatMap(W=>{let{pathPortion:B,globPortion:q}=r(W);return q&&(q=k(q)),this.n(B).flatMap(N=>this.o(N,q))}),R=new Map;return d.forEach(W=>{const B=W.searchPath.toString(),q=R.get(B);q?W.pattern&&(q.pattern=q.pattern||{},q.pattern[W.pattern]=!0):R.set(B,{searchPath:W.searchPath,pattern:W.pattern?h(W.pattern):void 0})}),Array.from(R.values())}n(u){if(D.$_b(u)){const d=this.b.getWorkspace().folders;return d[0]&&d[0].uri.scheme!==g.Schemas.file?[{searchPath:d[0].uri.with({path:u})}]:[{searchPath:c.URI.file(D.$$b(u))}]}if(this.b.getWorkbenchState()===2){const d=this.b.getWorkspace().folders[0].uri;if(u=$(u),u.startsWith("../")||u===".."){const W=D.$0b.resolve(d.path,u);return[{searchPath:d.with({path:W})}]}const R=k(u);return[{searchPath:d,pattern:R}]}else{if(u==="./"||u===".\\")return[];{const d=u.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(B=>{const q=d.match(new RegExp(`^${A.$od(B.name)}(?:/(.*)|$)`));return q?{match:q,folder:B}:null}).filter(E.$re);if(W.length)return W.map(B=>{const q=B.match[1];return{searchPath:B.folder.uri,pattern:q&&k(q)}});{const B=u.match(/\.[\/\\](.+)[\/\\]?/),q=B?B[1]:u,U=b.localize(0,null,q);throw new Error(U)}}}}o(u,d){const R=u.pattern&&d?`${u.pattern}/${d}`:u.pattern||d,W=[{searchPath:u.searchPath,pattern:R}];return R&&!R.endsWith("**")&&W.push({searchPath:u.searchPath,pattern:R+"/**"}),W}q(u,d,R){const W=this.r((0,i.$Kh)(u.searchPath),d,R,!1);return W?{...W,includePattern:u.pattern}:null}r(u,d,R,W){let B;const q=c.URI.isUri(u)?u:u.uri;if(R.searchPaths){const X=R.searchPaths.filter(be=>(0,p.$3f)(be.searchPath,q))[0];if(X&&!X.pattern)return null;X&&(B=X.pattern)}const U=this.a.getValue({resource:q}),O={...this.l(U,d)||{},...B||{}},ce=c.URI.isUri(u)?(0,p.$7f)(u):u.name;return{folder:q,folderName:W?ce:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof d.disregardIgnoreFiles=="boolean"?d.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof d.disregardGlobalIgnoreFiles=="boolean"?d.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof d.disregardParentIgnoreFiles=="boolean"?d.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof d.ignoreSymlinks=="boolean"?d.ignoreSymlinks:!U.search.followSymlinks}}};e.$fJ=I,e.$fJ=I=Ve([qe(0,o.$Vh),qe(1,i.$yh),qe(2,a.$OC),qe(3,t.$Ri),qe(4,m.$dJ)],I);function r(v){const u=v.match(/[\*\{\}\(\)\[\]\?]/);if(u){const d=u.index,R=v.substr(0,d).match(/[/|\\][^/\\]*$/);if(R){let W=v.substr(0,R.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:v.substr((R.index||0)+1)}}}return{pathPortion:v}}function h(...v){return v.length?v.reduce((u,d)=>(u[d]=!0,u),Object.create(null)):void 0}function n(v){return C.$cj(v,",").map(u=>u.trim()).filter(u=>!!u.length)}function s(v){return[`**/${v}/**`,`**/${v}`].map(d=>d.replace(/\*\*\/\*\*/g,"**"))}function $(v){return v.replace(/\\/g,"/")}function k(v){return $(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(v){return v.replace(/([?*[\]])/g,"[$1]")}function f(v,u){v=w.$rf(v,W=>W.toString());const d=[],R=u.getWorkspace();return v&&v.forEach(W=>{let B;if(u.getWorkbenchState()===2)B=(0,p.$_f)(R.folders[0].uri,W),B&&B!=="."&&(B="./"+B);else{const q=u.getWorkspaceFolder(W);if(q){const U=q.name;if(R.folders.filter(O=>O.name===U).length===1){const O=(0,p.$_f)(q.uri,W);O===""?B=`./${q.name}`:B=`./${q.name}/${O}`}else B=W.fsPath}}B&&d.push(l(B))}),d}e.$gJ=f}),define(Ae[264],Fe([1,0,23,2,20,11,3,263,47,54]),function($e,e,w,T,C,M,P,g,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjb=e.$Vjb=void 0;const A=7e3;function E(o,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const a=[],m=[];for(const s of i)if(/^workspaceContains:/.test(s)){const $=s.substr(18);$.indexOf("*")>=0||$.indexOf("?")>=0||o.forceUsingSearch?m.push($):a.push($)}if(a.length===0&&m.length===0)return Promise.resolve(void 0);let S;const I=new Promise((s,$)=>{S=s}),r=s=>S({activationEvent:s}),h=Promise.all(a.map(s=>c(o,s,r))).then(()=>{}),n=y(o,t.identifier,m,r);return Promise.all([h,n]).then(()=>{S(void 0)}),I}e.$Vjb=E;async function c(o,t,i){for(const a of o.folders)if(await o.exists(w.$0f(T.URI.revive(a),t))){i(`workspaceContains:${t}`);return}}async function y(o,t,i,a){if(i.length===0)return Promise.resolve(void 0);const m=new C.$ed,S=o.checkExists(o.folders,i,m.token),I=setTimeout(async()=>{m.cancel(),o.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},A);let r=!1;try{r=await S}catch(h){M.$2(h)||M.$Y(h)}m.dispose(),clearTimeout(I),r&&a(`workspaceContains:${i.join(",")}`)}function b(o,t,i,a){const m=o.get(P.$oh),S=o.get(D.$YH),r=m.createInstance(g.$fJ).file(t.map(h=>(0,p.$Kh)(T.URI.revive(h))),{_reason:"checkExists",includePattern:i,exists:!0});return S.fileSearch(r,a).then(h=>!!h.limitHit,h=>M.$2(h)?!1:Promise.reject(h))}e.$Wjb=b}),define(Ae[35],Fe([1,0,148,19,86,23,16,6,48,2,14,4,34,210,83,33,26,106,11,21,25,189,7,96,3,27,84,17,72,85,63,5,264,82,191,13,80,59,22,81]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t,i,a,m,S,I,r,h,n,s,$,k,l,f,v,u,d,R,W,B,q,U,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B_b=e.$A_b=e.$z_b=e.$y_b=e.$x_b=void 0,e.$x_b=(0,n.$ph)("IHostUtils");let ce=class Sn extends g.$lb{constructor(H,ne,re,L,_,pe,Ie,De,ye,Se,oe,de){super(),this.R=de,this.a=this.B(new u.$8c),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=ne,this.g=re,this.f=Ie,this.j=L,this.k=_,this.l=pe,this.m=ye,this.p=Se,this.s=oe,this.t=this.g.getProxy(E.$BJ.MainThreadWorkspace),this.u=this.g.getProxy(E.$BJ.MainThreadTelemetry),this.v=this.g.getProxy(E.$BJ.MainThreadExtensionService),this.w=new P.$ug,this.y=new P.$ug,this.z=new P.$ug,this.C=new P.$ug,this.D=new he(this.f.activationEvents),this.G=new i.$s1b(this.D,this.f.allExtensions);const ee=new m.$Il(this.f.myExtensions);this.F=new i.$s1b(this.D,Re(this.G,ee)),this.H=new b.$e_b(this.g,this.l),this.I=new R.$q_b(this.g),this.J=De,this.h=H.createChild(new l.$nh([b.$f_b,this.H],[R.$r_b,this.I])),this.L=this.B(new y.$d_b(this.F,this.G,{onExtensionActivationError:(ie,le,F)=>{this.v.$onExtensionActivationError(ie,a.$1(le),F)},actualActivateExtension:async(ie,le)=>{if(i.$s1b.isHostExtension(ie,this.F,this.G))return await this.v.$activateExtension(ie,le),new y.$c_b;const F=this.F.getExtensionDescription(ie);return this.$(F,le)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(H){a.$Y(H)}}async S(){this.J.onWillDeactivateAll();let H=[];try{H=this.F.getAllExtensionDescriptions().map(_=>_.identifier).filter(_=>this.isActivated(_)).map(_=>this.Z(_))}catch{}await Promise.all(H)}terminate(H,ne=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${H}`),this.l.flush(),this.p.dispose(),this.L.dispose(),a.setUnexpectedErrorHandler(L=>{this.l.error(L)}),this.g.dispose();const re=this.S();Promise.race([(0,P.$wg)(5e3),re]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${ne}`):this.l.info(`Extension host exiting with code ${ne}`),this.l.flush(),this.l.dispose(),this.c.exit(ne)})}isActivated(H){return this.z.isOpen()?this.L.isActivated(H):!1}async getExtension(H){const ne=await this.v.$getExtension(H);return ne&&{...ne,identifier:new m.$Hl(ne.identifier.value),extensionLocation:p.URI.revive(ne.extensionLocation)}}U(H,ne){return this.L.activateByEvent(H,ne)}W(H,ne){return this.L.activateById(H,ne)}activateByIdWithErrors(H,ne){return this.W(H,ne).then(()=>{const re=this.L.getActivatedExtension(H);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(H=>this.F)}getExtensionExports(H){if(this.z.isOpen())return this.L.getActivatedExtension(H).exports;try{return this.L.getActivatedExtension(H).exports}catch{return null}}async X(H){if(H.scheme===B.Schemas.file&&this.c.fsRealpath){const ne=await this.c.fsRealpath(H.fsPath);return p.URI.file(ne)}return H}async getExtensionPathIndex(){return this.M||(this.M=this.Y(this.F.getAllExtensionDescriptions()).then(H=>new Z(H))),this.M}async Y(H){const ne=D.$vh.forUris(re=>M.$1f.ignorePathCasing(re));return await Promise.all(H.map(async re=>{if(this.qb(re)){const L=await this.X(re.extensionLocation);ne.set(L,re)}})),ne}Z(H){let ne=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(H))return ne;const re=this.L.getActivatedExtension(H);if(!re)return ne;try{typeof re.module.deactivate=="function"&&(ne=Promise.resolve(re.module.deactivate()).then(void 0,L=>(this.l.error(L),Promise.resolve(void 0))))}catch(L){this.l.error(`An error occurred when deactivating the extension '${H.value}':`),this.l.error(L)}try{(0,g.$gb)(re.subscriptions)}catch(L){this.l.error(`An error occurred when deactivating the subscriptions for extension '${H.value}':`),this.l.error(L)}return ne}async $(H,ne){return this.f.remote.isRemote?this.v.$onWillActivateExtension(H.identifier):await this.v.$onWillActivateExtension(H.identifier),this.bb(H,ne).then(re=>{const L=re.activationTimes;return this.v.$onDidActivateExtension(H.identifier,L.codeLoadingTime,L.activateCallTime,L.activateResolvedTime,ne),this.ab(H,ne,"success",L),re},re=>{throw this.ab(H,ne,"failure"),re})}ab(H,ne,re,L){const _=be(H,ne);this.u.$publicLog2("extensionActivationTimes",{..._,...L||{},outcome:re})}bb(H,ne){const re=be(H,ne);this.u.$publicLog2("activatePlugin",re);const L=this.qb(H);if(!L)return Promise.resolve(new y.$b_b(y.$$$b.NONE));this.l.info(`ExtensionService#_doActivateExtension ${H.identifier.value}, startup: ${ne.startup}, activationEvent: '${ne.activationEvent}'${H.identifier.value!==ne.extensionId.value?`, root cause: ${ne.extensionId.value}`:""}`),this.l.flush();const _=new y.$_$b(ne.startup);return Promise.all([this.rb(H,(0,M.$0f)(H.extensionLocation,L),_),this.cb(H)]).then(pe=>(C.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),Sn.db(this.l,H.identifier,pe[0],pe[1],_))).then(pe=>(C.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),pe))}cb(H){const ne=new I.$h_b(H,this.H),re=new I.$g_b(H.identifier.value,!1,this.H),L=new W.$s_b(H,this.I),_=H.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,pe=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([ne.whenReady,re.whenReady,this.J.whenReady]).then(()=>{const Ie=this;let De,ye;const Se=(0,t.$yF)(H,"ipc")?this.f.messagePorts?.get(m.$Hl.toKey(H.identifier)):void 0;return Object.freeze({globalState:ne,workspaceState:re,secrets:L,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(oe){return T.$ac(H.extensionLocation.fsPath,oe)},get storagePath(){return Ie.J.workspaceValue(H)?.fsPath},get globalStoragePath(){return Ie.J.globalValue(H).fsPath},get logPath(){return T.$ac(Ie.f.logsLocation.fsPath,H.identifier.value)},get logUri(){return p.URI.joinPath(Ie.f.logsLocation,H.identifier.value)},get storageUri(){return Ie.J.workspaceValue(H)},get globalStorageUri(){return Ie.J.globalValue(H)},get extensionMode(){return _},get extension(){return De===void 0&&(De=new Ee(Ie,H.identifier,H,pe,!1)),De},get extensionRuntime(){return(0,t.$zF)(H,"extensionRuntime"),Ie.extensionRuntime},get environmentVariableCollection(){return Ie.p.getEnvironmentVariableCollection(H)},get messagePassingProtocol(){if(!ye){if(!Se)return;const oe=u.Event.buffer(u.Event.fromDOMEventEmitter(Se,"message",de=>de.data));Se.start(),ye={onDidReceiveMessage:oe,postMessage:Se.postMessage.bind(Se)}}return ye}})})}static db(H,ne,re,L,_){return re=re||{activate:void 0,deactivate:void 0},this.eb(H,ne,re,L,_).then(pe=>new y.$a_b(!1,null,_.build(),re,pe,L.subscriptions))}static eb(H,ne,re,L,_){if(typeof re.activate=="function")try{_.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${ne.value}`);const pe=typeof global=="object"?global:self,Ie=re.activate.apply(pe,[L]);return _.activateCallStop(),_.activateResolveStart(),Promise.resolve(Ie).then(De=>(_.activateResolveStop(),De))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(re)}fb(H,ne){this.W(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:ne}).then(void 0,re=>{this.l.error(re)})}gb(H,ne=0){const L=Date.now();(0,N.$A)(()=>{for(let _=ne;_<H.length;_+=1){const pe=H[_];for(const Ie of pe.activationEvents??[])if(Ie==="onStartupFinished")if(Date.now()-L>50){this.gb(H,_);break}else this.fb(pe,Ie)}})}hb(){this.v.$setPerformanceMarks(C.getMarks()),this.k.getConfigProvider().then(H=>{const ne=H.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),re=this.F.getAllExtensionDescriptions();if(ne)this.gb(re);else for(const L of re)if(L.activationEvents)for(const _ of L.activationEvents)_==="onStartupFinished"&&this.fb(L,_)})}ib(){const H=this.U("*",!0).then(void 0,pe=>{this.l.error(pe)});this.B(this.j.onDidChangeWorkspace(pe=>this.jb(pe.added)));const ne=this.j.workspace?this.j.workspace.folders:[],re=this.jb(ne),L=this.lb(),_=Promise.all([L,H,re]).then(()=>{});return Promise.race([_,(0,P.$wg)(1e4)]).then(()=>{this.hb()}),_}jb(H){return H.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(ne=>this.kb(H,ne))).then(()=>{})}async kb(H,ne){if(this.isActivated(ne.identifier))return;const re=!this.f.remote.isRemote&&!!this.f.remote.authority,L={logService:this.l,folders:H.map(pe=>pe.uri),forceUsingSearch:re||!this.c.fsExists,exists:pe=>this.c.fsExists(pe.fsPath),checkExists:(pe,Ie,De)=>this.t.$checkExists(pe,Ie,De)},_=await(0,d.$Vjb)(L,ne);if(_)return this.W(ne.identifier,{startup:!0,extensionId:ne.identifier,activationEvent:_.activationEvent}).then(void 0,pe=>this.l.error(pe))}async lb(){if(this.f.remote.authority)return this.U(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(H){throw console.error(H),H}}async mb(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:ne}=this.f.environment;if(!H||!ne)throw new Error(w.localize(0,null));const re=await this.rb(null,ne,new y.$_$b(!1));if(!re||typeof re.run!="function")throw new Error(w.localize(1,null,ne.toString()));return new Promise((L,_)=>{const pe=(ye,Se)=>{ye?_(ye):L(typeof Se=="number"&&Se>0?1:0)},Ie=(0,M.$Xf)(ne),De=re.run(Ie,pe);De&&De.then&&De.then(()=>{L(0)}).catch(ye=>{_(ye instanceof Error&&ye.stack?ye.stack:String(ye))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,P.$wg)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(H,ne){return this.N[H]=ne,(0,g.$jb)(()=>{delete this.N[H]})}async getRemoteExecServer(H){const{resolver:ne}=await this.ob(H);return ne?.resolveExecServer?.(H,{resolveAttempt:0})}async ob(H){const ne=H.indexOf("+");if(ne===-1)throw new r.$JJ("Not an authority that can be resolved!",h.RemoteAuthorityResolverErrorCode.InvalidAuthority);const re=H.substr(0,ne);return await this.w.wait(),await this.U(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this.N[re]}}async $resolveAuthority(H,ne){const re=U.$4c.create(!1),L=()=>`[resolveAuthority(${(0,h.$Ak)(H)},${ne})][${re.elapsed()}ms] `,_=J=>this.l.info(`${L()}${J}`),pe=J=>this.l.warn(`${L()}${J}`),Ie=(J,K=void 0)=>this.l.error(`${L()}${J}`,K),De=J=>{if(J instanceof r.$JJ)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},ye=async J=>{_(`activating resolver for ${J}...`);const{resolver:K,authorityPrefix:ae}=await this.ob(J);if(!K)throw Ie(`no resolver for ${ae}`),new r.$JJ(`No remote extension installed to resolve ${ae}.`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:ae,remoteAuthority:J}},Se=H.split(/@|%40/g).reverse();_(`activating remote resolvers ${Se.join(" -> ")}`);let oe;try{oe=await Promise.all(Se.map(ye)).catch(async J=>{if(!(J instanceof r.$JJ)||J._code!==h.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return pe(`resolving nested authorities failed: ${J.message}`),[await ye(H)]})}catch(J){return De(J)}const de=new P.$Fg;de.cancelAndSet(()=>_("waiting..."),1e3);let ee,ie;for(const[J,{authorityPrefix:K,resolver:ae,remoteAuthority:G}]of oe.entries())try{if(J===oe.length-1)_("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${K}`),ee=await ae.resolve(G,{resolveAttempt:ne,execServer:ie}),C.mark(`code/extHost/didResolveAuthorityOK/${K}`),_("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(ae));else{if(_(`invoking resolveExecServer() for ${G}`),C.mark(`code/extHost/willResolveExecServer/${K}`),ie=await ae.resolveExecServer?.(G,{resolveAttempt:ne,execServer:ie}),!ie)throw new r.$JJ(`Exec server was not available for ${G}`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(ue){return C.mark(`code/extHost/didResolveAuthorityError/${K}`),Ie("returned an error",ue),de.dispose(),De(ue)}de.dispose();const le={environmentTunnels:ee.environmentTunnels,features:ee.tunnelFeatures},F={extensionHostEnv:ee.extensionHostEnv,isTrusted:ee.isTrusted,authenticationSession:ee.authenticationSessionForInitializingExtensions?{id:ee.authenticationSessionForInitializingExtensions.id,providerId:ee.authenticationSessionForInitializingExtensions.providerId}:void 0};_(`returned ${r.$IJ.isManagedResolvedAuthority(ee)?"managed authority":`${ee.host}:${ee.port}`}`);let V;if(r.$IJ.isManagedResolvedAuthority(ee)){const J=ne;this.R.setFactory(J,ee.makeConnection),V={authority:H,connectTo:new h.$xk(J),connectionToken:ee.connectionToken}}else V={authority:H,connectTo:new h.$yk(ee.host,ee.port),connectionToken:ee.connectionToken};return{type:"ok",value:{authority:V,options:F,tunnelInformation:le}}}async $getCanonicalURI(H,ne){this.l.info(`$getCanonicalURI invoked for authority (${(0,h.$Ak)(H)})`);const{resolver:re}=await this.ob(H);if(!re)return null;const L=p.URI.revive(ne);if(typeof re.getCanonicalURI>"u")return L;const _=await(0,P.$og)(()=>re.getCanonicalURI(L));return _||L}$startExtensionHost(H){H.toAdd.forEach(L=>L.extensionLocation=p.URI.revive(L.extensionLocation));const{globalRegistry:ne,myExtensions:re}=X(this.D,this.G,this.F,H);return this.G.set(ne.getAllExtensionDescriptions()),this.F.set(re),this.nb()}$activateByEvent(H,ne){return ne===1?this.w.wait().then(re=>this.U(H,!1)):this.z.wait().then(re=>this.U(H,!1))}async $activate(H,ne){return await this.z.wait(),this.F.getExtensionDescription(H)?(await this.W(H,ne),!0):!1}async $deltaExtensions(H){H.toAdd.forEach(pe=>pe.extensionLocation=p.URI.revive(pe.extensionLocation));const{globalRegistry:ne,myExtensions:re}=X(this.D,this.G,this.F,H),L=await this.Y(re);return(await this.getExtensionPathIndex()).setSearchTree(L),this.G.set(ne.getAllExtensionDescriptions()),this.F.set(re),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){const ne=S.$Jb.alloc(H),re=Math.random()%256;for(let L=0;L<H;L++)ne.writeUInt8(re,L);return ne}async $updateRemoteConnectionData(H){this.Q=H,this.a.fire()}};e.$y_b=ce,e.$y_b=ce=Ve([qe(0,n.$oh),qe(1,e.$x_b),qe(2,k.$DL),qe(3,o.$4$b),qe(4,c.$7$b),qe(5,A.$Ri),qe(6,s.$TL),qe(7,$.$k_b),qe(8,f.$Wpb),qe(9,v.$m_b),qe(10,q.$u_b),qe(11,O.$v_b)],ce);function X(Ce,H,ne,re){Ce.addActivationEvents(re.addActivationEvents);const L=new i.$s1b(Ce,H.getAllExtensionDescriptions());L.deltaExtensions(re.toAdd,re.toRemove);const _=new m.$Il(ne.getAllExtensionDescriptions().map(Ie=>Ie.identifier));for(const Ie of re.myToRemove)_.delete(Ie);for(const Ie of re.myToAdd)_.add(Ie);const pe=Re(L,_);return{globalRegistry:L,myExtensions:pe}}function be(Ce,H){return{id:Ce.identifier.value,name:Ce.name,extensionVersion:Ce.version,publisherDisplayName:Ce.publisher,activationEvents:Ce.activationEvents?Ce.activationEvents.join(","):null,isBuiltin:Ce.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}e.$z_b=(0,n.$ph)("IExtHostExtensionService");class Ee{#e;#t;#i;constructor(H,ne,re,L,_){this.#e=H,this.#t=ne,this.#i=re.identifier,this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=T.$$b((0,M.$Xf)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=L,this.isFromDifferentExtensionHost=_}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$A_b=Ee;function Re(Ce,H){return Ce.getAllExtensionDescriptions().filter(ne=>H.has(ne.identifier))}class Z{constructor(H){this.a=H}setSearchTree(H){this.a=H}findSubstr(H){return this.a.findSubstr(H)}forEach(H){return this.a.forEach(H)}}e.$B_b=Z;class he{constructor(H){this.a=new m.$Jl,this.addActivationEvents(H)}readActivationEvents(H){return this.a.get(H.identifier)}addActivationEvents(H){for(const ne of Object.keys(H))this.a.set(ne,H[ne])}}}),define(Ae[265],Fe([1,0,86,2,4,34,26,21,17,27,3,35,52,14,15]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=void 0;let o=class{constructor(I,r,h,n,s,$,k){this.c=I,this.d=r,this.e=h,this.f=n,this.g=s,this.h=$,this.i=k,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const I=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const r=await this.g.getExtensionPathIndex();this.register(new i(this.c,r,this.d,I,this.i)),this.register(this.e.createInstance(a,r)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(m,r,this.h.environment.appUriScheme))}register(I){if("nodeModuleName"in I)if(Array.isArray(I.nodeModuleName))for(const r of I.nodeModuleName)this.a.set(r,I);else this.a.set(I.nodeModuleName,I);typeof I.alternativeModuleName=="function"&&this.b.push(r=>I.alternativeModuleName(r))}};e.$Tac=o,e.$Tac=o=Ve([qe(2,A.$oh),qe(3,M.$7$b),qe(4,E.$z_b),qe(5,p.$TL),qe(6,y.$Ri)],o);let t=class gn{static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(I){if(I.environment.appRoot&&gn.a.size){const r=(0,b.$od)(this.c(I.environment.appRoot.fsPath)),h="[a-z0-9_.-]",n=`@${h}+\\/${h}+|${h}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${r}/${s}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(I){if(!this.b)return;const r=this.b.exec(this.c(I));if(!r)return;const[,h,n,s]=r,$=gn.a.get(n);if($!==void 0)return console.warn(`${n} as been renamed to ${$}, please update your imports`),h+$+s}c(I){return I.replace(/\\/g,"/")}};t=Ve([qe(0,p.$TL)],t);class i{constructor(I,r,h,n,s){this.c=I,this.d=r,this.e=h,this.f=n,this.g=s,this.nodeModuleName="vscode",this.a=new g.$Jl}load(I,r){const h=this.d.findSubstr(r);if(h){let n=this.a.get(h.identifier);return n||(n=this.c(h,this.e,this.f),this.a.set(h.identifier,n)),n}if(!this.b){let n="";this.d.forEach((s,$)=>n+=`	${$} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${n}`),this.b=this.c(P.$tF,this.e,this.f)}return this.b}}let a=class{constructor(I,r,h){this.d=I,this.nodeModuleName="keytar",this.a=r.getProxy(C.$BJ.MainThreadTelemetry);const{environment:n}=h,s=r.getProxy(C.$BJ.MainThreadKeytar);if(n.appRoot){let $=n.appRoot.fsPath;c.$7b==="win32"&&($=$.replace(/\\/g,"/")),$[$.length-1]==="/"&&($=$.substr(0,$.length-1)),this.b=new Set,this.b.add(`${$}/node_modules.asar/keytar`),this.b.add(`${$}/node_modules/keytar`)}this.c={getPassword:($,k)=>s.$getPassword($,k),setPassword:($,k,l)=>s.$setPassword($,k,l),deletePassword:($,k)=>s.$deletePassword($,k),findPassword:$=>s.$findPassword($),findCredentials($){return s.$findCredentials($)}}}load(I,r){const h=this.d.findSubstr(r);return this.a.$publicLog2("shimming.keytar",{extension:h?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(I){const r=I.length;if(r<=7||!this.b)return;const h=r-7;if((I.charAt(h)==="/"||I.charAt(h)==="\\")&&I.endsWith("keytar")&&(I=I.replace(/\\/g,"/"),this.b.has(I)))return"keytar"}};a=Ve([qe(1,D.$DL),qe(2,p.$TL)],a);let m=class{constructor(I,r,h){this.e=I,this.f=r,this.nodeModuleName=["open","opn"],this.d=h.getProxy(C.$BJ.MainThreadTelemetry);const n=h.getProxy(C.$BJ.MainThreadWindow);this.c=(s,$)=>{const k=T.URI.parse(s);return $?this.g(s,$):k.scheme==="http"||k.scheme==="https"?n.$openUri(k,s,{allowTunneling:!0}):k.scheme==="mailto"||k.scheme===this.f?n.$openUri(k,s,{}):this.g(s,$)}}load(I,r,h){const n=this.e.findSubstr(r);return n&&(this.a=n.identifier.value,this.h()),this.b=h(I),this.c}g(I,r){return this.i(),this.b(I,r)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};m=Ve([qe(2,D.$DL)],m)}),define(Ae[112],Fe([1,0,66,6,19,52,3,60,61,35,7,33,201,34]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9_b=e.$8_b=void 0,e.$8_b=(0,P.$ph)("IExtHostVariableResolverProvider");class b extends c.$EM{constructor(i,a,m,S,I,r,h){function n(){if(m){const s=m.activeEditor();if(s)return s.document.uri;const $=S.tabGroups.all.find(k=>k.isActive)?.activeTab;if($!==void 0){if($.input instanceof A.$lL||$.input instanceof A.$qL)return $.input.modified;if($.input instanceof A.$kL||$.input instanceof A.$pL||$.input instanceof A.$nL)return $.input.uri}}}super({getFolderUri:s=>{const $=r.folders.filter(k=>k.name===s);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(s,$)=>I.getConfiguration(void 0,s).get($),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=n();if(s)return C.$$b(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(a){const s=n();if(s){const $=a.getWorkspaceFolder(s);if($)return C.$$b($.uri.fsPath)}}},getSelectedText:()=>{if(m){const s=m.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(m){const s=m.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>i.getExtension(s)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(M.env))}}let o=class extends T.$lb{constructor(i,a,m,S,I){super(),this.b=i,this.c=a,this.g=m,this.h=S,this.i=I,this.a=new w.$T(async()=>{const r=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async s=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new b(this.b,this.c,this.g,this.i,r,n,this.j())})}getResolver(){return this.a.value}j(){}};e.$9_b=o,e.$9_b=o=Ve([qe(0,p.$z_b),qe(1,E.$4$b),qe(2,g.$OL),qe(3,y.$7$b),qe(4,D.$6_b)],o)}),define(Ae[113],Fe([1,0,16,5,12,2,3,4,61,35,17,7,33,194,196,34,112]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bac=e.$aac=e.$__b=e.$$_b=e.$0_b=void 0,e.$0_b=(0,P.$ph)("IExtHostDebugService");let i=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(n,s,$,k,l,f){this.E=s,this.F=$,this.G=k,this.H=l,this.I=f,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$8c,this.n=new T.$8c,this.o=new T.$8c,this.u=new T.$8c,this.k=n.getProxy(g.$BJ.MainThreadDebugService),this.y=new T.$8c,this.A=new T.$8c,this.v=new m(this.k),this.w=new Map,this.F.getExtensionRegistry().then(v=>{v.onDidChange(u=>{this.J(v)}),this.J(v)})}asDebugSourceUri(n,s){const $=n;if(typeof $.sourceReference=="number"&&$.sourceReference>0){let k=`debug:${encodeURIComponent($.path||"")}`,l="?";return s&&(k+=`${l}session=${encodeURIComponent(s.id)}`,l="&"),k+=`${l}ref=${$.sourceReference}`,M.URI.parse(k)}else{if($.path)return M.URI.file($.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(n){const s=[];for(const $ of n.getAllExtensionDescriptions())if($.contributes){const k=$.contributes.debuggers;if(k&&k.length>0)for(const l of k)(0,b.$9E)(l)&&s.push(l.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const n=[];return this.w.forEach(s=>n.push(s)),n}addBreakpoints(n){const s=n.filter(l=>{const f=l.id;return this.w.has(f)?!1:(this.w.set(f,l),!0)});this.U(s,[],[]);const $=[],k=new Map;for(const l of s)if(l instanceof E.$DK){let f=k.get(l.location.uri.toString());f||(f={type:"sourceMulti",uri:l.location.uri,lines:[]},k.set(l.location.uri.toString(),f),$.push(f)),f.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof E.$EK&&$.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this.k.$registerBreakpoints($)}removeBreakpoints(n){const s=n.filter(f=>this.w.delete(f.id));this.U([],s,[]);const $=s.filter(f=>f instanceof E.$DK).map(f=>f.id),k=s.filter(f=>f instanceof E.$EK).map(f=>f.id),l=s.filter(f=>f instanceof E.$FK).map(f=>f.id);return this.k.$unregisterBreakpoints($,k,l)}startDebugging(n,s,$){return this.k.$startDebugging(n?n.uri:void 0,s,{parentSessionID:$.parentSession?$.parentSession.id:void 0,lifecycleManagedByParent:$.lifecycleManagedByParent,repl:$.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:$.noDebug,compact:$.compact,suppressSaveBeforeStart:$.suppressSaveBeforeStart,suppressDebugStatusbar:$.suppressDebugStatusbar??$.debugUI?.simple,suppressDebugToolbar:$.suppressDebugToolbar??$.debugUI?.simple,suppressDebugView:$.suppressDebugView??$.debugUI?.simple})}stopDebugging(n){return this.k.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,s,$){if(!s)return new E.$DJ(()=>{});const k=this.d++;return this.f.push({type:n,handle:k,provider:s}),this.k.$registerDebugConfigurationProvider(n,$,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,k),new E.$DJ(()=>{this.f=this.f.filter(l=>l.provider!==s),this.k.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(n,s,$){if(!$)return new E.$DJ(()=>{});if(!this.Q(n,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:s,handle:k,factory:$}),this.k.$registerDebugAdapterDescriptorFactory(s,k),new E.$DJ(()=>{this.h=this.h.filter(l=>l.factory!==$),this.k.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(n,s){if(!s)return new E.$DJ(()=>{});const $=this.i++;return this.j.push({type:n,handle:$,factory:s}),new E.$DJ(()=>{this.j=this.j.filter(k=>k.factory!==s)})}async $runInTerminal(n,s){return Promise.resolve(void 0)}async $substituteVariables(n,s){let $;const k=await this.W(n);return k&&($={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync($,s)}K(n,s){if(n.type==="implementation")return new I(n.implementation)}L(){}async $startDASession(n,s){const $=this,k=await this.V(s);return this.S(this.N(k.type),k).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const f=this.M(l),v=this.K(f,k);if(!v)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const u=v;return this.B.set(n,u),this.R(k).then(d=>(d&&this.C.set(n,d),u.onMessage(async R=>{if(R.type==="request"&&R.command==="handshake"){const W=R,B={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const q=await this.D.sign(W.arguments.value);B.body={signature:q},u.sendResponse(B)}else throw new Error("no signer")}catch(q){B.success=!1,B.message=q.message,u.sendResponse(B)}}else d&&d.onDidSendMessage&&d.onDidSendMessage(R),R=(0,b.$bF)(R,!0),$.k.$acceptDAMessage(n,R)}),u.onError(R=>{d&&d.onError&&d.onError(R),this.k.$acceptDAError(n,R.name,R.message,R.stack)}),u.onExit(R=>{d&&d.onExit&&d.onExit((0,C.$Be)(R),void 0),this.k.$acceptDAExit(n,(0,C.$Be)(R),void 0)}),d&&d.onWillStartSession&&d.onWillStartSession(),u.startSession()))})}$sendDAMessage(n,s){s=(0,b.$aF)(s,!1);const $=this.C.get(n);$&&$.onWillReceiveMessage&&$.onWillReceiveMessage(s),this.B.get(n)?.sendMessage(s)}$stopDASession(n){const s=this.C.get(n);this.C.delete(n),s&&s.onWillStopSession&&s.onWillStopSession();const $=this.B.get(n);return this.B.delete(n),$?$.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const s=[],$=[],k=[];if(n.added)for(const l of n.added){const f=l.id;if(f&&!this.w.has(f)){let v;if(l.type==="function")v=new E.$EK(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")v=new E.$FK(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const u=M.URI.revive(l.uri);v=new E.$DK(new E.$PJ(u,new E.$EJ(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,E.$BK)(v,f),this.w.set(f,v),s.push(v)}}if(n.removed)for(const l of n.removed){const f=this.w.get(l);f&&(this.w.delete(l),$.push(f))}if(n.changed){for(const l of n.changed)if(l.id){const f=this.w.get(l.id);if(f){if(f instanceof E.$EK&&l.type==="function"){const v=f;v.enabled=l.enabled,v.condition=l.condition,v.hitCondition=l.hitCondition,v.logMessage=l.logMessage,v.functionName=l.functionName}else if(f instanceof E.$DK&&l.type==="source"){const v=f;v.enabled=l.enabled,v.condition=l.condition,v.hitCondition=l.hitCondition,v.logMessage=l.logMessage,v.location=new E.$PJ(M.URI.revive(l.uri),new E.$EJ(l.line,l.character))}k.push(f)}}}this.U(s,$,k)}async $acceptStackFrameFocus(n){let s;const $=n.sessionId?await this.V(n.sessionId):void 0;if(!$)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?s=new E.$LK($,n.threadId):s=new E.$KK($,n.threadId,n.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(n,s,$){return(0,w.$og)(async()=>{const k=this.P(n);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.W(s);return k.provideDebugConfigurations(l,$)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(n,s,$,k){return(0,w.$og)(async()=>{const l=this.P(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const f=await this.W(s);return l.resolveDebugConfiguration(f,$,k)})}$resolveDebugConfigurationWithSubstitutedVariables(n,s,$,k){return(0,w.$og)(async()=>{const l=this.P(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const f=await this.W(s);return l.resolveDebugConfigurationWithSubstitutedVariables(f,$,k)})}async $provideDebugAdapter(n,s){const $=this.O(n);if(!$)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.V(s);return this.S($,k).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.M(l)})}async $acceptDebugSessionStarted(n){const s=await this.V(n);this.m.fire(s)}async $acceptDebugSessionTerminated(n){const s=await this.V(n);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(n){this.q=n?await this.V(n):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(n,s){(await this.V(n))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(n,s){const k={session:await this.V(n),event:s.event,body:s.body};this.u.fire(k)}M(n){if(n instanceof E.$GK)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof E.$HK)return{type:"server",port:n.port,host:n.host};if(n instanceof E.$IK)return{type:"pipeServer",path:n.path};if(n instanceof E.$JK)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}N(n){const s=this.h.filter($=>$.type===n);if(s.length>0)return s[0].factory}O(n){const s=this.h.filter($=>$.handle===n);if(s.length>0)return s[0].factory}P(n){const s=this.f.filter($=>$.handle===n);if(s.length>0)return s[0].provider}Q(n,s){if(n.contributes){const $=n.contributes.debuggers;if($&&$.length>0){for(const k of $)if(k.label&&k.type&&k.type===s)return!0}}return!1}R(n){const $=n.configuration.type,k=this.j.filter(l=>l.type===$||l.type==="*").map(l=>(0,w.$og)(()=>l.factory.createDebugAdapterTracker(n)).then(f=>f,f=>null));return Promise.race([Promise.all(k).then(l=>{const f=l.filter(v=>!!v);if(f.length>0)return new S(f)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async S(n,s){const $=s.configuration.debugServer;if(typeof $=="number")return Promise.resolve(new E.$HK($));if(n){const l=await this.F.getExtensionRegistry();return(0,w.$og)(()=>n.createDebugAdapterDescriptor(s,this.T(s,l))).then(f=>{if(f)return f})}const k=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,k))}T(n,s){}U(n,s,$){(n.length>0||s.length>0||$.length>0)&&this.y.fire(Object.freeze({added:n,removed:s,changed:$}))}async V(n){if(n)if(typeof n=="string"){const s=this.l.get(n);if(s)return s}else{let s=this.l.get(n.id);if(!s){const $=await this.W(n.folderUri),k=n.parent?this.l.get(n.parent):void 0;s=new a(this.k,n.id,n.type,n.name,$,n.configuration,k),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(n){if(n){const s=M.URI.revive(n);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$$_b=i,e.$$_b=i=Ve([qe(0,A.$DL),qe(1,c.$4$b),qe(2,p.$z_b),qe(3,o.$7$b),qe(4,D.$6_b),qe(5,t.$8_b)],i);class a{constructor(n,s,$,k,l,f,v){this.d=n,this.f=s,this.g=$,this.h=k,this.i=l,this.j=f,this.k=v}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(n){this.h=n,this.d.$setDebugSessionName(this.f,n)}get parentSession(){return this.k}_acceptNameChanged(n){this.h=n}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(n,s){return this.d.$customDebugAdapterRequest(this.f,n,s)}getDebugProtocolBreakpoint(n){return this.d.$getDebugProtocolBreakpoint(this.f,n.id)}}e.$__b=a;class m{constructor(n){this.value=Object.freeze({append(s){n.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$aac=m;class S{constructor(n){this.d=n}onWillStartSession(){this.d.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(n):void 0)}onWillStopSession(){this.d.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.d.forEach(s=>s.onError?s.onError(n):void 0)}onExit(n,s){this.d.forEach($=>$.onExit?$.onExit(n,s):void 0)}}class I extends y.$C${constructor(n){super(),this.h=n,n.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.h.handleMessage(n)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let r=class extends i{constructor(n,s,$,k,l,f){super(n,s,$,k,l,f)}};e.$bac=r,e.$bac=r=Ve([qe(0,A.$DL),qe(1,c.$4$b),qe(2,p.$z_b),qe(3,o.$7$b),qe(4,D.$6_b),qe(5,t.$8_b)],r)}),define(Ae[266],Fe([1,0,11,86,2,4,257,14,71,72,27,172,17,56,35,58]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=e.$Uac=void 0;class t{static async installEarlyHandler(m){Error.stackTraceLimit=100;const S=m.get(g.$Ri),r=m.get(c.$DL).getProxy(M.$BJ.MainThreadErrors);w.setUnexpectedErrorHandler(h=>{S.error(h);const n=w.$1(h);r.$onUnexpectedError(n)})}static async installFullHandler(m){const S=m.get(g.$Ri),I=m.get(c.$DL),r=m.get(b.$z_b),h=m.get(o.$XL),n=I.getProxy(M.$BJ.MainThreadExtensionService),s=I.getProxy(M.$BJ.MainThreadErrors),$=await r.getExtensionPathIndex(),k=new WeakMap;function l(u,d){if(k.has(u))return k.get(u).stack;let R="",W,B;for(const U of d)R+=`
	at ${U.toString()}`,B=U.getFileName(),!W&&B&&(W=$.findSubstr(C.URI.file(B)));const q=`${u.name||"Error"}: ${u.message||""}${R}`;return k.set(u,{extensionIdentifier:W?.identifier,stack:q}),q}const f=Symbol("prepareStackTrace wrapped");let v=l;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(u){if(u===l||u[f]){v=u;return}v=function(d,R){return l(d,R),u.call(Error,d,R)},Object.assign(v,{[f]:!0})}}),w.setUnexpectedErrorHandler(u=>{S.error(u);const d=w.$1(u),R=k.get(u);if(!R?.extensionIdentifier){s.$onUnexpectedError(d);return}n.$onExtensionRuntimeError(R.extensionIdentifier,d);const W=h.onExtensionError(R.extensionIdentifier,u);S.trace("forwarded error to extension?",W,R)})}}e.$Uac=t;class i{constructor(m,S,I,r,h){this.a=I,this.b=new P.$A1b(m,null,r),S=i.e(S,this.b);const n=new p.$nh(...(0,D.$ar)());n.set(A.$TL,{_serviceBrand:void 0,...S,messagePorts:h}),n.set(c.$DL,new c.$EL(this.b)),n.set(y.$1$b,new y.$2$b(r)),n.set(b.$x_b,I);const s=new E.$Up(n,!0);s.invokeFunction(t.installEarlyHandler),this.d=s.invokeFunction($=>$.get(g.$Ri)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",S),this.c=s.invokeFunction($=>$.get(b.$z_b)),this.c.initialize(),s.invokeFunction(t.installFullHandler)}async asBrowserUri(m){const S=this.b.getProxy(M.$BJ.MainThreadExtensionService);return C.URI.revive(await S.$asBrowserUri(m))}terminate(m){this.c.terminate(m)}static e(m,S){m.allExtensions.forEach(r=>{r.extensionLocation=C.URI.revive(S.transformIncomingURIs(r.extensionLocation))}),m.environment.appRoot=C.URI.revive(S.transformIncomingURIs(m.environment.appRoot));const I=m.environment.extensionDevelopmentLocationURI;return I&&(m.environment.extensionDevelopmentLocationURI=I.map(r=>C.URI.revive(S.transformIncomingURIs(r)))),m.environment.extensionTestsLocationURI=C.URI.revive(S.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=C.URI.revive(S.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=C.URI.revive(S.transformIncomingURIs(m.environment.workspaceStorageHome)),m.environment.extensionTelemetryLogResource=C.URI.revive(S.transformIncomingURIs(m.environment.extensionTelemetryLogResource)),m.nlsBaseUrl=C.URI.revive(S.transformIncomingURIs(m.nlsBaseUrl)),m.logsLocation=C.URI.revive(S.transformIncomingURIs(m.logsLocation)),m.workspace=S.transformIncomingURIs(m.workspace),m}}e.$Vac=i}),define(Ae[267],Fe([1,0,18,16,20,41,13,19,23,2,47]),function($e,e,w,T,C,M,P,g,D,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gac=e.$fac=e.$eac=e.$dac=void 0;class E{constructor(a,m,S,I){this.d=a,this.e=m,this.f=S,this.g=I,this.a=null,this.b=!1,this.c=0}search(a,m){const S=this.d.folderQueries||[],I=new C.$ed;return m.onCancellationRequested(()=>I.cancel()),new Promise((r,h)=>{this.a=new y(a);let n=!1;const s=($,k)=>{if(!n&&!this.b){const l=this.h($);o($)&&typeof this.d.maxResults=="number"&&this.c+l>this.d.maxResults&&(this.b=!0,n=!0,I.cancel(),$=this.j($,this.d.maxResults-this.c));const f=this.h($);this.c+=f,(f>0||!o($))&&this.a.add($,k)}};Promise.all(S.map(($,k)=>this.k($,l=>s(l,k),I.token))).then($=>{I.dispose(),this.a.flush();const k=$.some(l=>!!l&&!!l.limitHit);r({limitHit:this.b||k,messages:(0,w.$yf)($.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.g}})},$=>{I.dispose();const k=(0,M.$ai)($);h(new Error(k))})})}h(a){return o(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}j(a,m){const S=Array.isArray(a.ranges)?a.ranges:[a.ranges],I=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:S.slice(0,m),preview:{matches:I.slice(0,m),text:a.preview.text},uri:a.uri}}async k(a,m,S){const I=new A.$fI(this.d,a),r=[],h={report:$=>{if(!this.l($))return;const k=a.folder.scheme===P.Schemas.file?(0,A.$gI)(()=>this.f.readdir(D.$9f($.uri))):void 0,l=D.$_f(a.folder,$.uri);if(l){const f=I.includedInQuery(l,g.$ec(l),k);(0,T.$ig)(f)?r.push(f.then(v=>{v&&m($)})):f&&m($)}}},n=this.n(a),s=await this.e.provideTextSearchResults(c(this.d.contentPattern),n,h,S);return r.length&&await Promise.all(r),s}l(a){if(o(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(a){const m=(0,A.$eI)(this.d.includePattern,a.includePattern),S=(0,A.$eI)(this.d.excludePattern,a.excludePattern),I={folder:p.URI.from(a.folder),excludes:S,includes:m,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.f.toCanonicalName(a.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return I.usePCRE2=this.d.usePCRE2,I}}e.$dac=E;function c(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class y{constructor(a){this.e=a,this.b=-1,this.d=null,this.a=new t(512,m=>this.g(m))}add(a,m){this.d&&(this.b!==m||!D.$3f(this.c,a.uri))&&(this.f(),this.d=null),this.d||(this.b=m,this.d={resource:a.uri,results:[]}),this.d.results.push(b(a))}f(){const a=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,a)}flush(){this.f(),this.a.flush()}g(a){this.e(a)}}e.$eac=y;function b(i){return o(i)?{preview:{matches:(0,w.$If)(i.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:i.preview.text},ranges:(0,w.$If)(i.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function o(i){return!!i.preview}e.$fac=o;class t{static{this.a=4e3}static{this.b=50}constructor(a,m){this.g=a,this.h=m,this.c=0,this.d=[],this.e=0}addItem(a,m){a&&this.j(a,m)}addItems(a,m){a&&this.k(a,m)}j(a,m){this.d.push(a),this.e+=m,this.l()}k(a,m){this.d=this.d.concat(a),this.e+=m,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$gac=t}),define(Ae[114],Fe([1,0,6,4,3,262,17,56,14,2,267]),function($e,e,w,T,C,M,P,g,D,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jac=e.$iac=e.$hac=void 0,e.$hac=(0,C.$ph)("IExtHostSearch");let E=class{constructor(o,t,i){this.k=o,this.l=t,this.n=i,this.c=this.k.getProxy(T.$BJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$cac}o(o){return this.l.transformOutgoingScheme(o)}registerTextSearchProvider(o,t){if(this.g.has(o))throw new Error(`a text search provider for the scheme '${o}' is already registered`);this.g.add(o);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(o)),(0,w.$jb)(()=>{this.g.delete(o),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(o,t){if(this.i.has(o))throw new Error(`a file search provider for the scheme '${o}' is already registered`);this.i.add(o);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(o)),(0,w.$jb)(()=>{this.i.delete(o),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(o,t,i,a){const m=c(i),S=this.h.get(o);if(S)return this.j.fileSearch(m,S,I=>{this.c.$handleFileMatch(o,t,I.map(r=>r.resource))},a);throw new Error("unknown provider: "+o)}$clearCache(o){return this.j.clearCache(o),Promise.resolve(void 0)}$provideTextSearchResults(o,t,i,a){const m=this.e.get(o);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${o}`);const S=c(i);return this.q(S,m).search(r=>this.c.$handleTextMatch(o,t,r),a)}$enableExtensionHostSearch(){}q(o,t){return new A.$dac(o,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$iac=E,e.$iac=E=Ve([qe(0,P.$DL),qe(1,g.$1$b),qe(2,D.$Ri)],E);function c(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(y),extraFileResources:b.extraFileResources&&b.extraFileResources.map(o=>p.URI.revive(o))}}e.$jac=c;function y(b){return{...b,folder:p.URI.revive(b.folder)}}}),define(Ae[268],Fe([1,0,20,11,5,29,2,135,278,124,133,38,4,78,221,220,32,222,34,224,225,226,204,227,60,35,228,229,234,235,237,109,208,243,244,247,83,63,249,211,8,7,53,252,64,108,33,21,199,233,51,107,111,113,114,14,56,17,27,238,197,85,79,217,250,84,62,255,253,254,218,39,248,251,82,61,58,239,110,240,13,94,207,190,231,6,26,195,80,186,241,242,219,230,206,245,232,81,246]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t,i,a,m,S,I,r,h,n,s,$,k,l,f,v,u,d,R,W,B,q,U,N,O,ce,X,be,Ee,Re,Z,he,Ce,H,ne,re,L,_,pe,Ie,De,ye,Se,oe,de,ee,ie,le,F,V,J,K,ae,G,ue,me,Ne,Be,Ye,Ke,Xe,Ge,ct,xe,tt,Oe,nt,x,Y,ge,je,Me,Ze,et,gt,wt,Nt,Jt,Wt,yt,At,Ft,zt,Ut){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=void 0;function Lt(st){const ht=st.get(oe.$TL),jt=st.get(Ne.$Q$b),Tt=st.get(K.$j_b),Dt=st.get(s.$z_b),ot=st.get(he.$4$b),Pt=st.get(Ge.$XL),Mt=st.get(a.$7$b),Pe=st.get(ye.$1$b),we=st.get(Se.$DL),ve=st.get(q.$f_b),Q=st.get(J.$k_b),Le=st.get(De.$Si),Ue=st.get(De.$Ri),He=st.get(ie.$Wpb),We=st.get(le.$T$b),_e=st.get(Z.$X_b),bt=st.get(Ke.$r_b),kt=st.get(Xe.$6_b),St=st.get(zt.$v_b);we.set(c.$CJ.ExtHostFileSystemInfo,jt),we.set(c.$CJ.ExtHostLogLevelServiceShape,Le),we.set(c.$CJ.ExtHostWorkspace,ot),we.set(c.$CJ.ExtHostConfiguration,Mt),we.set(c.$CJ.ExtHostExtensionService,Dt),we.set(c.$CJ.ExtHostStorage,ve),we.set(c.$CJ.ExtHostTunnelService,He),we.set(c.$CJ.ExtHostWindow,_e),we.set(c.$CJ.ExtHostSecretState,bt),we.set(c.$CJ.ExtHostTelemetry,Pt),we.set(c.$CJ.ExtHostEditorTabs,kt),we.set(c.$CJ.ExtHostManagedSockets,St);const pt=we.set(c.$CJ.ExtHostDecorations,st.get(L.$2_b)),mt=we.set(c.$CJ.ExtHostDocumentsAndEditors,st.get(n.$OL)),lt=we.set(c.$CJ.ExtHostCommands,st.get(t.$ZL)),$t=we.set(c.$CJ.ExtHostTerminalService,st.get(U.$m_b)),ft=we.set(c.$CJ.ExtHostDebugService,st.get(pe.$0_b)),Yt=we.set(c.$CJ.ExtHostSearch,st.get(Ie.$hac)),Bt=we.set(c.$CJ.ExtHostTask,st.get(_.$5_b)),Xi=we.set(c.$CJ.ExtHostOutputService,st.get(u.$H_b)),hi=we.set(c.$CJ.ExtHostLocalization,st.get(et.$u_b)),di=we.set(c.$CJ.ExtHostUrls,new Ee.$Q_b(we)),It=we.set(c.$CJ.ExtHostDocuments,new h.$O$b(we,mt)),yi=we.set(c.$CJ.ExtHostDocumentContentProviders,new I.$9$b(we,mt,Ue)),Kt=we.set(c.$CJ.ExtHostDocumentSaveParticipant,new r.$0$b(Ue,It,we.getProxy(c.$BJ.MainThreadBulkEdits))),Et=we.set(c.$CJ.ExtHostNotebook,new de.$nac(we,lt,mt,It,Tt)),Ei=we.set(c.$CJ.ExtHostNotebookDocuments,new Y.$Fac(Et)),fi=we.set(c.$CJ.ExtHostNotebookEditors,new x.$Eac(Ue,Et)),ai=we.set(c.$CJ.ExtHostNotebookKernels,new ct.$Bac(we,ht,Et,lt,Ue)),_i=we.set(c.$CJ.ExtHostNotebookRenderers,new tt.$Dac(we,Et)),ni=we.set(c.$CJ.ExtHostNotebookDocumentSaveParticipant,new yt.$Lac(Ue,Et,we.getProxy(c.$BJ.MainThreadBulkEdits))),Rt=we.set(c.$CJ.ExtHostEditors,new N.$O_b(we,mt)),gi=we.set(c.$CJ.ExtHostTreeViews,new O.$P_b(we.getProxy(c.$BJ.MainThreadTreeViews),lt,Ue)),Di=we.set(c.$CJ.ExtHostEditorInsets,new H.$Y_b(we.getProxy(c.$BJ.MainThreadEditorInsets),Rt,ht.remote)),ri=we.set(c.$CJ.ExtHostDiagnostics,new m.$S$b(we,Ue,jt,mt)),si=we.set(c.$CJ.ExtHostLanguages,new f.$E_b(we,It,lt.converter,Pe)),at=we.set(c.$CJ.ExtHostLanguageFeatures,new l.$W$b(we,Pe,It,lt,ri,Ue,We,Pt)),ki=we.set(c.$CJ.ExtHostFileSystem,new $.$C_b(we,at)),Ht=we.set(c.$CJ.ExtHostFileSystemEventService,new k.$D_b(we,Ue,mt)),xt=we.set(c.$CJ.ExtHostQuickOpen,(0,R.$J_b)(we,ot,lt)),mi=we.set(c.$CJ.ExtHostSCM,new W.$L_b(we,lt,It,Ue)),Ni=we.set(c.$CJ.ExtHostQuickDiff,new Nt.$Iac(we,Pe)),Si=we.set(c.$CJ.ExtHostShare,new Ut.$Oac(we,Pe)),Ii=we.set(c.$CJ.ExtHostComments,(0,i.$Z$b)(we,lt,It)),$i=we.set(c.$CJ.ExtHostProgress,new d.$I_b(we.getProxy(c.$BJ.MainThreadProgress))),Ci=we.set(c.$CJ.ExtHosLabelService,new ne.$Z_b(we)),Pi=we.set(c.$CJ.ExtHostTheming,new ee.$oac(we)),ei=we.set(c.$CJ.ExtHostAuthentication,new F.$pac(we)),Ri=we.set(c.$CJ.ExtHostTimeline,new V.$rac(we,lt)),pi=we.set(c.$CJ.ExtHostWebviews,new Re.$T_b(we,ht.remote,ot,Ue,We)),bi=we.set(c.$CJ.ExtHostWebviewPanels,new ue.$tac(we,pi,ot)),Ui=we.set(c.$CJ.ExtHostCustomEditors,new G.$uac(we,It,Q,pi,bi)),ji=we.set(c.$CJ.ExtHostWebviewViews,new ae.$sac(we,pi)),oi=we.set(c.$CJ.ExtHostTesting,new Be.$wac(we,lt,mt)),xi=we.set(c.$CJ.ExtHostUriOpeners,new Ye.$Aac(we)),en=we.set(c.$CJ.ExtHostProfileContentHandlers,new wt.$Hac(we));we.set(c.$CJ.ExtHostInteractive,new ge.$Gac(we,Et,mt,lt,Ue));const Ai=we.set(c.$CJ.ExtHostInlineChat,new Wt.$Kac(we,lt,It,Ue)),Xt=we.set(c.$CJ.ExtHostChat,new Jt.$Jac(we,Ue)),tn=we.set(c.$CJ.ExtHostSemanticSimilarity,new At.$Mac(we)),nn=we.set(c.$CJ.ExtHostIssueReporter,new Ft.$Nac(we)),Fi=we.set(c.$CJ.ExtHostStatusBar,new B.$N_b(we,lt.converter)),Li=Object.values(c.$CJ);we.assertRegistered(Li);const Bi=new me.$vac(we,mt),Wi=new o.$Y$b(we),vi=new v.$F_b(we,Ue),qi=new S.$8$b(we);return b.$X$b.register(lt),function(ze,Gt,Zt){const dt=function(){let te=!ze.isUnderDevelopment;function fe(){te||(Ue.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(it){if(Array.isArray(it))it.forEach(Te);else if(typeof it=="string")fe();else{const vt=it;typeof vt.scheme>"u"&&fe(),typeof vt.exclusive=="boolean"&&(0,Me.$zF)(ze,"documentFiltersExclusive")}return it}}(),rn={getSession(te,fe,Te){return ei.getSession(ze,te,fe,Te)},getSessions(te,fe){return(0,Me.$zF)(ze,"authGetSessions"),ei.getSessions(ze,te,fe)},async hasSession(te,fe){return(0,Me.$zF)(ze,"authSession"),!!await ei.getSession(ze,te,fe,{silent:!0})},get onDidChangeSessions(){return ei.onDidChangeSessions},registerAuthenticationProvider(te,fe,Te,it){return ei.registerAuthenticationProvider(te,fe,Te,it)}},qt={registerCommand(te,fe,Te){return lt.registerCommand(!0,te,fe,Te,void 0,ze)},registerTextEditorCommand(te,fe,Te){return lt.registerCommand(!0,te,(...it)=>{const vt=Rt.getActiveTextEditor();if(!vt){Ue.warn("Cannot execute "+te+" because there is no active text editor.");return}return vt.edit(Ct=>{fe.apply(Te,[vt,Ct,...it])}).then(Ct=>{Ct||Ue.warn("Edits from command "+te+" were not applied.")},Ct=>{Ue.warn("An error occurred while running command "+te,Ct)})},void 0,void 0,ze)},registerDiffInformationCommand:(te,fe,Te)=>((0,Me.$zF)(ze,"diffCommand"),lt.registerCommand(!0,te,async(...it)=>{const vt=mt.activeEditor(!0);if(!vt){Ue.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ct=await Rt.getDiffInformation(vt.id);fe.apply(Te,[Ct,...it])},void 0,void 0,ze)),executeCommand(te,...fe){return lt.executeCommand(te,...fe)},getCommands(te=!1){return lt.getCommands(te)}},ci={get machineId(){return ht.telemetryInfo.machineId},get sessionId(){return ht.telemetryInfo.sessionId},get language(){return ht.environment.appLanguage},get appName(){return ht.environment.appName},get appRoot(){return ht.environment.appRoot?.fsPath??""},get appHost(){return ht.environment.appHost},get uriScheme(){return ht.environment.appUriScheme},get clipboard(){return Wi.value},get shell(){return $t.getDefaultShell(!1)},get onDidChangeShell(){return(0,Me.$zF)(ze,"envShellEvent"),$t.onDidChangeShell},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Pt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Me.$zF)(ze,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Me.$zF)(ze,"telemetry"),Pt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ge.$WL)(ht.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,fe){return Ge.$VL.validateSender(te),Pt.instantiateLogger(ze,te,fe)},openExternal(te,fe){return _e.openUri(te,{allowTunneling:!!ht.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ht.environment.appUriScheme)return di.createAppUri(te);try{return await _e.asExternalUri(te,{allowTunneling:!!ht.remote.authority})}catch(fe){if((0,nt.$_Y)(te,Oe.Schemas.http)||(0,nt.$_Y)(te,Oe.Schemas.https))return te;throw fe}},get remoteName(){return(0,re.$Ck)(ht.remote.authority)},get remoteAuthority(){return(0,Me.$zF)(ze,"resolvers"),ht.remote.authority},get uiKind(){return ht.uiKind},get logLevel(){return Ue.getLevel()},get onDidChangeLogLevel(){return Ue.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Me.$zF)(ze,"handleIssueUri"),nn.registerIssueUriRequestHandler(ze,te)},get appQuality(){return(0,Me.$zF)(ze,"resolvers"),ht.quality},get appCommit(){return(0,Me.$zF)(ze,"resolvers"),ht.commit}};ht.environment.extensionTestsLocationURI||Object.freeze(ci);const Vi={createTestController(te,fe,Te){return oi.createTestController(ze,te,fe,Te)},createTestObserver(){return(0,Me.$zF)(ze,"testObserver"),oi.createTestObserver()},runTests(te){return(0,Me.$zF)(ze,"testObserver"),oi.runTests(te)},get onDidChangeTestResults(){return(0,Me.$zF)(ze,"testObserver"),oi.onResultsChanged},get testResults(){return(0,Me.$zF)(ze,"testObserver"),oi.results}},ui=ht.remote.isRemote?X.ExtensionKind.Workspace:X.ExtensionKind.UI,Ji={getExtension(te,fe){(0,Me.$yF)(ze,"extensionsAny")||(fe=!1);const Te=Gt.mine.getExtensionDescription(te);if(Te)return new s.$A_b(Dt,ze.identifier,Te,ui,!1);if(fe){const it=Gt.all.getExtensionDescription(te);if(it)return new s.$A_b(Dt,ze.identifier,it,ui,!0)}},get all(){const te=[];for(const fe of Gt.mine.getAllExtensionDescriptions())te.push(new s.$A_b(Dt,ze.identifier,fe,ui,!1));return te},get allAcrossExtensionHosts(){(0,Me.$zF)(ze,"extensionsAny");const te=new Ce.$Il(Gt.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),fe=[];for(const Te of Gt.all.getAllExtensionDescriptions()){const it=!te.has(Te.identifier);fe.push(new s.$A_b(Dt,ze.identifier,Te,ui,it))}return fe},get onDidChange(){return(0,Me.$yF)(ze,"extensionsAny")?C.Event.any(Gt.mine.onDidChange,Gt.all.onDidChange):Gt.mine.onDidChange}},Ki={createDiagnosticCollection(te){return ri.createDiagnosticCollection(ze.identifier,te)},get onDidChangeDiagnostics(){return ri.onDidChangeDiagnostics},getDiagnostics:te=>ri.getDiagnostics(te),getLanguages(){return si.getLanguages()},setTextDocumentLanguage(te,fe){return si.changeLanguage(te.uri,fe)},match(te,fe){const Te=It.getDocumentData(fe.uri)?.notebook;return(0,A.$YE)(ce.LanguageSelector.from(te),fe.uri,fe.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(te,fe,Te){return at.registerCodeActionProvider(ze,dt(te),fe,Te)},registerDocumentPasteEditProvider(te,fe,Te){return(0,Me.$zF)(ze,"documentPaste"),at.registerDocumentPasteEditProvider(ze,dt(te),fe,Te)},registerCodeLensProvider(te,fe){return at.registerCodeLensProvider(ze,dt(te),fe)},registerDefinitionProvider(te,fe){return at.registerDefinitionProvider(ze,dt(te),fe)},registerDeclarationProvider(te,fe){return at.registerDeclarationProvider(ze,dt(te),fe)},registerImplementationProvider(te,fe){return at.registerImplementationProvider(ze,dt(te),fe)},registerTypeDefinitionProvider(te,fe){return at.registerTypeDefinitionProvider(ze,dt(te),fe)},registerHoverProvider(te,fe){return at.registerHoverProvider(ze,dt(te),fe,ze.identifier)},registerEvaluatableExpressionProvider(te,fe){return at.registerEvaluatableExpressionProvider(ze,dt(te),fe,ze.identifier)},registerInlineValuesProvider(te,fe){return at.registerInlineValuesProvider(ze,dt(te),fe,ze.identifier)},registerDocumentHighlightProvider(te,fe){return at.registerDocumentHighlightProvider(ze,dt(te),fe)},registerLinkedEditingRangeProvider(te,fe){return at.registerLinkedEditingRangeProvider(ze,dt(te),fe)},registerReferenceProvider(te,fe){return at.registerReferenceProvider(ze,dt(te),fe)},registerRenameProvider(te,fe){return at.registerRenameProvider(ze,dt(te),fe)},registerDocumentSymbolProvider(te,fe,Te){return at.registerDocumentSymbolProvider(ze,dt(te),fe,Te)},registerWorkspaceSymbolProvider(te){return at.registerWorkspaceSymbolProvider(ze,te)},registerDocumentFormattingEditProvider(te,fe){return at.registerDocumentFormattingEditProvider(ze,dt(te),fe)},registerDocumentRangeFormattingEditProvider(te,fe){return at.registerDocumentRangeFormattingEditProvider(ze,dt(te),fe)},registerOnTypeFormattingEditProvider(te,fe,Te,...it){return at.registerOnTypeFormattingEditProvider(ze,dt(te),fe,[Te].concat(it))},registerDocumentSemanticTokensProvider(te,fe,Te){return at.registerDocumentSemanticTokensProvider(ze,dt(te),fe,Te)},registerDocumentRangeSemanticTokensProvider(te,fe,Te){return at.registerDocumentRangeSemanticTokensProvider(ze,dt(te),fe,Te)},registerSignatureHelpProvider(te,fe,Te,...it){return typeof Te=="object"?at.registerSignatureHelpProvider(ze,dt(te),fe,Te):at.registerSignatureHelpProvider(ze,dt(te),fe,typeof Te>"u"?[]:[Te,...it])},registerCompletionItemProvider(te,fe,...Te){return at.registerCompletionItemProvider(ze,dt(te),fe,Te)},registerInlineCompletionItemProvider(te,fe,Te){return fe.handleDidShowCompletionItem&&(0,Me.$zF)(ze,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Me.$zF)(ze,"inlineCompletionsAdditions"),Te&&(0,Me.$zF)(ze,"inlineCompletionsAdditions"),at.registerInlineCompletionsProvider(ze,dt(te),fe,Te)},registerDocumentLinkProvider(te,fe){return at.registerDocumentLinkProvider(ze,dt(te),fe)},registerColorProvider(te,fe){return at.registerColorProvider(ze,dt(te),fe)},registerFoldingRangeProvider(te,fe){return at.registerFoldingRangeProvider(ze,dt(te),fe)},registerSelectionRangeProvider(te,fe){return at.registerSelectionRangeProvider(ze,te,fe)},registerCallHierarchyProvider(te,fe){return at.registerCallHierarchyProvider(ze,te,fe)},registerTypeHierarchyProvider(te,fe){return at.registerTypeHierarchyProvider(ze,te,fe)},setLanguageConfiguration:(te,fe)=>at.setLanguageConfiguration(ze,te,fe),getTokenInformationAtPosition(te,fe){return(0,Me.$zF)(ze,"tokenInformation"),si.tokenAtPosition(te,fe)},registerInlayHintsProvider(te,fe){return at.registerInlayHintsProvider(ze,te,fe)},createLanguageStatusItem(te,fe){return si.createLanguageStatusItem(ze,te,fe)},registerDocumentDropEditProvider(te,fe,Te){return at.registerDocumentOnDropEditProvider(ze,te,fe,(0,Me.$yF)(ze,"dropMetadata")?Te:void 0)}},sn={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return $t.activeTerminal},get terminals(){return $t.terminals},async showTextDocument(te,fe,Te){const it=await(P.URI.isUri(te)?Promise.resolve(Ti.openTextDocument(te)):Promise.resolve(te));return Rt.showTextDocument(it,fe,Te)},createTextEditorDecorationType(te){return Rt.createTextEditorDecorationType(ze,te)},onDidChangeActiveTextEditor(te,fe,Te){return Rt.onDidChangeActiveTextEditor(te,fe,Te)},onDidChangeVisibleTextEditors(te,fe,Te){return Rt.onDidChangeVisibleTextEditors(te,fe,Te)},onDidChangeTextEditorSelection(te,fe,Te){return Rt.onDidChangeTextEditorSelection(te,fe,Te)},onDidChangeTextEditorOptions(te,fe,Te){return Rt.onDidChangeTextEditorOptions(te,fe,Te)},onDidChangeTextEditorVisibleRanges(te,fe,Te){return Rt.onDidChangeTextEditorVisibleRanges(te,fe,Te)},onDidChangeTextEditorViewColumn(te,fe,Te){return Rt.onDidChangeTextEditorViewColumn(te,fe,Te)},onDidCloseTerminal(te,fe,Te){return $t.onDidCloseTerminal(te,fe,Te)},onDidOpenTerminal(te,fe,Te){return $t.onDidOpenTerminal(te,fe,Te)},onDidChangeActiveTerminal(te,fe,Te){return $t.onDidChangeActiveTerminal(te,fe,Te)},onDidChangeTerminalDimensions(te,fe,Te){return(0,Me.$zF)(ze,"terminalDimensions"),$t.onDidChangeTerminalDimensions(te,fe,Te)},onDidChangeTerminalState(te,fe,Te){return $t.onDidChangeTerminalState(te,fe,Te)},onDidWriteTerminalData(te,fe,Te){return(0,Me.$zF)(ze,"terminalDataWriteEvent"),$t.onDidWriteTerminalData(te,fe,Te)},get state(){return _e.getState(ze)},onDidChangeWindowState(te,fe,Te){return _e.onDidChangeWindowState(te,fe,Te)},showInformationMessage(te,...fe){return vi.showMessage(ze,M.default.Info,te,fe[0],fe.slice(1))},showWarningMessage(te,...fe){return vi.showMessage(ze,M.default.Warning,te,fe[0],fe.slice(1))},showErrorMessage(te,...fe){return vi.showMessage(ze,M.default.Error,te,fe[0],fe.slice(1))},showQuickPick(te,fe,Te){return xt.showQuickPick(ze,te,fe,Te)},showWorkspaceFolderPick(te){return xt.showWorkspaceFolderPick(te)},showInputBox(te,fe){return xt.showInput(te,fe)},showOpenDialog(te){return qi.showOpenDialog(ze,te)},showSaveDialog(te){return qi.showSaveDialog(te)},createStatusBarItem(te,fe,Te){let it,vt,Ct;return typeof te=="string"?(it=te,vt=fe,Ct=Te):(vt=te,Ct=fe),Fi.createStatusBarEntry(ze,it,vt,Ct)},setStatusBarMessage(te,fe){return Fi.setStatusBarMessage(te,fe)},withScmProgress(te){return We.report("window.withScmProgress",ze,"Use 'withProgress' instead."),$i.withProgress(ze,{location:X.ProgressLocation.SourceControl},(fe,Te)=>te({report(it){}}))},withProgress(te,fe){return $i.withProgress(ze,te,fe)},createOutputChannel(te,fe){return Xi.createOutputChannel(te,fe,ze)},createWebviewPanel(te,fe,Te,it){return bi.createWebviewPanel(ze,te,fe,Te,it)},createWebviewTextEditorInset(te,fe,Te,it){return(0,Me.$zF)(ze,"editorInsets"),Di.createWebviewEditorInset(te,fe,Te,it,ze)},createTerminal(te,fe,Te){return typeof te=="object"?"pty"in te?$t.createExtensionTerminal(te):$t.createTerminalFromOptions(te):$t.createTerminal(te,fe,Te)},registerTerminalLinkProvider(te){return $t.registerLinkProvider(te)},registerTerminalProfileProvider(te,fe){return $t.registerProfileProvider(ze,te,fe)},registerTerminalQuickFixProvider(te,fe){return(0,Me.$zF)(ze,"terminalQuickFixProvider"),$t.registerTerminalQuickFixProvider(te,ze.identifier.value,fe)},registerTreeDataProvider(te,fe){return gi.registerTreeDataProvider(te,fe,ze)},createTreeView(te,fe){return gi.createTreeView(te,fe,ze)},registerWebviewPanelSerializer:(te,fe)=>bi.registerWebviewPanelSerializer(ze,te,fe),registerCustomEditorProvider:(te,fe,Te={})=>Ui.registerCustomEditorProvider(ze,te,fe,Te),registerFileDecorationProvider(te){return pt.registerFileDecorationProvider(te,ze)},registerUriHandler(te){return di.registerUriHandler(ze,te)},createQuickPick(){return xt.createQuickPick(ze)},createInputBox(){return xt.createInputBox(ze)},get activeColorTheme(){return Pi.activeColorTheme},onDidChangeActiveColorTheme(te,fe,Te){return Pi.onDidChangeActiveColorTheme(te,fe,Te)},registerWebviewViewProvider(te,fe,Te){return ji.registerWebviewViewProvider(ze,te,fe,Te?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,fe,Te){return Et.onDidChangeActiveNotebookEditor(te,fe,Te)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,fe,Te){return fi.onDidChangeNotebookEditorSelection(te,fe,Te)},onDidChangeNotebookEditorVisibleRanges(te,fe,Te){return fi.onDidChangeNotebookEditorVisibleRanges(te,fe,Te)},showNotebookDocument(te,fe){return Et.showNotebookDocument(te,fe)},registerExternalUriOpener(te,fe,Te){return(0,Me.$zF)(ze,"externalUriOpener"),xi.registerExternalUriOpener(ze.identifier,te,fe,Te)},registerProfileContentHandler(te,fe){return(0,Me.$zF)(ze,"profileContentHandlers"),en.registrProfileContentHandler(ze,te,fe)},registerQuickDiffProvider(te,fe,Te,it){return(0,Me.$zF)(ze,"quickDiffProvider"),Ni.registerQuickDiffProvider(dt(te),fe,Te,it)},get tabGroups(){return kt.tabGroups},registerShareProvider(te,fe){return(0,Me.$zF)(ze,"shareProvider"),Si.registerShareProvider(dt(te),fe)}},Ti={get rootPath(){return We.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(te){throw T.$7()},getWorkspaceFolder(te){return ot.getWorkspaceFolder(te)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(te){throw T.$7()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(te){throw T.$7()},updateWorkspaceFolders:(te,fe,...Te)=>ot.updateWorkspaceFolders(ze,te,fe||0,...Te),onDidChangeWorkspaceFolders:function(te,fe,Te){return ot.onDidChangeWorkspace(te,fe,Te)},asRelativePath:(te,fe)=>ot.getRelativePath(te,fe),findFiles:(te,fe,Te,it)=>ot.findFiles(te,fe,Te,ze.identifier,it),findTextInFiles:(te,fe,Te,it)=>{(0,Me.$zF)(ze,"findTextInFiles");let vt,Ct;return typeof fe=="object"?(vt=fe,Ct=Te):(vt={},Ct=fe,it=Te),ot.findTextInFiles(te,vt||{},Ct,ze.identifier,it)},save:te=>((0,Me.$zF)(ze,"saveEditor"),ot.save(te)),saveAs:te=>((0,Me.$zF)(ze,"saveEditor"),ot.saveAs(te)),saveAll:te=>ot.saveAll(te),applyEdit(te,fe){return Bi.applyWorkspaceEdit(te,ze,fe)},createFileSystemWatcher:(te,fe,Te,it)=>Ht.createFileSystemWatcher(ot,ze,te,fe,Te,it),get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw T.$7()},openTextDocument(te){let fe;const Te=te;if(typeof te=="string")fe=Promise.resolve(P.URI.file(te));else if(P.URI.isUri(te))fe=Promise.resolve(te);else if(!Te||typeof Te=="object")fe=It.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(it=>It.ensureDocumentData(it).then(vt=>vt.document))},onDidOpenTextDocument:(te,fe,Te)=>It.onDidAddDocument(te,fe,Te),onDidCloseTextDocument:(te,fe,Te)=>It.onDidRemoveDocument(te,fe,Te),onDidChangeTextDocument:(te,fe,Te)=>It.onDidChangeDocument(te,fe,Te),onDidSaveTextDocument:(te,fe,Te)=>It.onDidSaveDocument(te,fe,Te),onWillSaveTextDocument:(te,fe,Te)=>Kt.getOnWillSaveTextDocumentEvent(ze)(te,fe,Te),get notebookDocuments(){return Et.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,fe){let Te;if(P.URI.isUri(te))Te=te,await Et.openNotebookDocument(te);else if(typeof te=="string")Te=P.URI.revive(await Et.createNotebookDocument({viewType:te,content:fe}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(te,fe,Te){return Ei.onDidSaveNotebookDocument(te,fe,Te)},onDidChangeNotebookDocument(te,fe,Te){return Ei.onDidChangeNotebookDocument(te,fe,Te)},onWillSaveNotebookDocument(te,fe,Te){return ni.getOnWillSaveNotebookDocumentEvent(ze)(te,fe,Te)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(te,fe,Te,it){return Et.registerNotebookSerializer(ze,te,fe,Te,(0,Me.$yF)(ze,"notebookLiveShare")?it:void 0)},onDidChangeConfiguration:(te,fe,Te)=>Zt.onDidChangeConfiguration(te,fe,Te),getConfiguration(te,fe){return fe=arguments.length===1?void 0:fe,Zt.getConfiguration(te,fe,ze)},registerTextDocumentContentProvider(te,fe){return yi.registerTextDocumentContentProvider(te,fe)},registerTaskProvider:(te,fe)=>(We.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Bt.registerTaskProvider(ze,te,fe)),registerFileSystemProvider(te,fe,Te){return(0,je.$ib)(ki.registerFileSystemProvider(ze,te,fe,Te),Tt.addFileSystemProvider(te,fe,Te))},get fs(){return Tt.value},registerFileSearchProvider:(te,fe)=>((0,Me.$zF)(ze,"fileSearchProvider"),Yt.registerFileSearchProvider(te,fe)),registerTextSearchProvider:(te,fe)=>((0,Me.$zF)(ze,"textSearchProvider"),Yt.registerTextSearchProvider(te,fe)),registerRemoteAuthorityResolver:(te,fe)=>((0,Me.$zF)(ze,"resolvers"),Dt.registerRemoteAuthorityResolver(te,fe)),registerResourceLabelFormatter:te=>((0,Me.$zF)(ze,"resolvers"),Ci.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Me.$zF)(ze,"resolvers"),Dt.getRemoteExecServer(te)),onDidCreateFiles:(te,fe,Te)=>Ht.onDidCreateFile(te,fe,Te),onDidDeleteFiles:(te,fe,Te)=>Ht.onDidDeleteFile(te,fe,Te),onDidRenameFiles:(te,fe,Te)=>Ht.onDidRenameFile(te,fe,Te),onWillCreateFiles:(te,fe,Te)=>Ht.getOnWillCreateFileEvent(ze)(te,fe,Te),onWillDeleteFiles:(te,fe,Te)=>Ht.getOnWillDeleteFileEvent(ze)(te,fe,Te),onWillRenameFiles:(te,fe,Te)=>Ht.getOnWillRenameFileEvent(ze)(te,fe,Te),openTunnel:te=>((0,Me.$zF)(ze,"tunnels"),He.openTunnel(ze,te).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Me.$zF)(ze,"tunnels"),He.getTunnels()},onDidChangeTunnels:(te,fe,Te)=>((0,Me.$zF)(ze,"tunnels"),He.onDidChangeTunnels(te,fe,Te)),registerPortAttributesProvider:(te,fe)=>((0,Me.$zF)(ze,"portsAttributes"),He.registerPortsAttributesProvider(te,fe)),registerTunnelProvider:(te,fe)=>((0,Me.$zF)(ze,"tunnelFactory"),He.registerTunnelProvider(te,fe)),registerTimelineProvider:(te,fe)=>((0,Me.$zF)(ze,"timeline"),Ri.registerTimelineProvider(te,fe,ze.identifier,lt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:te=>((0,Me.$zF)(ze,"workspaceTrust"),ot.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,fe,Te)=>ot.onDidGrantWorkspaceTrust(te,fe,Te),registerEditSessionIdentityProvider:(te,fe)=>((0,Me.$zF)(ze,"editSessionIdentityProvider"),ot.registerEditSessionIdentityProvider(te,fe)),onWillCreateEditSessionIdentity:(te,fe,Te)=>((0,Me.$zF)(ze,"editSessionIdentityProvider"),ot.getOnWillCreateEditSessionIdentityEvent(ze)(te,fe,Te)),registerCanonicalUriProvider:(te,fe)=>((0,Me.$zF)(ze,"canonicalUriProvider"),ot.registerCanonicalUriProvider(te,fe)),getCanonicalUri:(te,fe,Te)=>((0,Me.$zF)(ze,"canonicalUriProvider"),ot.provideCanonicalUri(te,fe,Te))},Hi={get inputBox(){return We.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),mi.getLastInputBox(ze)},createSourceControl(te,fe,Te){return mi.createSourceControl(ze,te,fe,Te)}},on={createCommentController(te,fe){return Ii.createCommentController(ze,te,fe)}},an={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},get stackFrameFocus(){return ft.stackFrameFocus},onDidStartDebugSession(te,fe,Te){return ft.onDidStartDebugSession(te,fe,Te)},onDidTerminateDebugSession(te,fe,Te){return ft.onDidTerminateDebugSession(te,fe,Te)},onDidChangeActiveDebugSession(te,fe,Te){return ft.onDidChangeActiveDebugSession(te,fe,Te)},onDidReceiveDebugSessionCustomEvent(te,fe,Te){return ft.onDidReceiveDebugSessionCustomEvent(te,fe,Te)},onDidChangeBreakpoints(te,fe,Te){return ft.onDidChangeBreakpoints(te,fe,Te)},onDidChangeStackFrameFocus(te,fe,Te){return(0,Me.$zF)(ze,"debugFocus"),ft.onDidChangeStackFrameFocus(te,fe,Te)},registerDebugConfigurationProvider(te,fe,Te){return ft.registerDebugConfigurationProvider(te,fe,Te||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,fe){return ft.registerDebugAdapterDescriptorFactory(ze,te,fe)},registerDebugAdapterTrackerFactory(te,fe){return ft.registerDebugAdapterTrackerFactory(te,fe)},startDebugging(te,fe,Te){return!Te||typeof Te=="object"&&"configuration"in Te?ft.startDebugging(te,fe,{parentSession:Te}):ft.startDebugging(te,fe,Te||{})},stopDebugging(te){return ft.stopDebugging(te)},addBreakpoints(te){return ft.addBreakpoints(te)},removeBreakpoints(te){return ft.removeBreakpoints(te)},asDebugSourceUri(te,fe){return ft.asDebugSourceUri(te,fe)}},zi={registerTaskProvider:(te,fe)=>Bt.registerTaskProvider(ze,te,fe),fetchTasks:te=>Bt.fetchTasks(te),executeTask:te=>Bt.executeTask(ze,te),get taskExecutions(){return Bt.taskExecutions},onDidStartTask:(te,fe,Te)=>Bt.onDidStartTask(te,fe,Te),onDidEndTask:(te,fe,Te)=>Bt.onDidEndTask(te,fe,Te),onDidStartTaskProcess:(te,fe,Te)=>Bt.onDidStartTaskProcess(te,fe,Te),onDidEndTaskProcess:(te,fe,Te)=>Bt.onDidEndTaskProcess(te,fe,Te)},Gi={createNotebookController(te,fe,Te,it,vt){return ai.createNotebookController(ze,te,fe,Te,it,(0,Me.$yF)(ze,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(te,fe)=>Et.registerNotebookCellStatusBarItemProvider(ze,te,fe),createRendererMessaging(te){return _i.createRendererMessaging(ze,te)},createNotebookControllerDetectionTask(te){return(0,Me.$zF)(ze,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(ze,te)},registerKernelSourceActionProvider(te,fe){return(0,Me.$zF)(ze,"notebookKernelSource"),ai.registerKernelSourceActionProvider(ze,te,fe)},onDidChangeNotebookCellExecutionState(te,fe,Te){return(0,Me.$zF)(ze,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(te,fe,Te)}},Zi={t(...te){if(typeof te[0]=="string"){const fe=te.shift(),Te=!te||typeof te[0]!="object"?te:te[0];return hi.getMessage(ze.identifier.value,{message:fe,args:Te})}return hi.getMessage(ze.identifier.value,te[0])},get bundle(){return hi.getBundle(ze.identifier.value)},get uri(){return hi.getBundleUri(ze.identifier.value)}},Qi={_version:1,registerInteractiveEditorSessionProvider(te){return(0,Me.$zF)(ze,"interactive"),Ai.registerProvider(ze,te)},registerInteractiveSessionProvider(te,fe){return(0,Me.$zF)(ze,"interactive"),Xt.registerChatProvider(ze,te,fe)},addInteractiveRequest(te){return(0,Me.$zF)(ze,"interactive"),Xt.addChatRequest(te)},sendInteractiveRequestToProvider(te,fe){return(0,Me.$zF)(ze,"interactive"),Xt.sendInteractiveRequestToProvider(te,fe)},get onDidPerformUserAction(){return(0,Me.$zF)(ze,"interactiveUserActions"),Xt.onDidPerformUserAction},transferChatSession(te,fe){return(0,Me.$zF)(ze,"interactive"),Xt.transferChatSession(te,fe)}},cn={registerSlashCommandProvider(te,fe){return(0,Me.$zF)(ze,"interactiveSlashCommands"),Xt.registerSlashCommandProvider(ze,te,fe)}},un={registerSemanticSimilarityProvider(te){return(0,Me.$zF)(ze,"semanticSimilarity"),tn.registerSemanticSimilarityProvider(ze,te)}};return{version:ht.version,ai:un,authentication:rn,commands:qt,comments:on,debug:an,env:ci,extensions:Ji,interactive:Qi,interactiveSlashCommands:cn,l10n:Zi,languages:Ki,notebooks:Gi,scm:Hi,tasks:zi,tests:Vi,window:sn,workspace:Ti,Breakpoint:X.$CK,TerminalOutputAnchor:X.TerminalOutputAnchor,CallHierarchyIncomingCall:X.$2J,CallHierarchyItem:X.$1J,CallHierarchyOutgoingCall:X.$3J,CancellationError:T.$3,CancellationTokenSource:w.$ed,CandidatePortSource:c.CandidatePortSource,CodeAction:X.$WJ,CodeActionKind:X.$XJ,CodeActionTriggerKind:X.CodeActionTriggerKind,CodeLens:X.$4J,Color:X.$eK,ColorInformation:X.$fK,ColorPresentation:X.$gK,ColorThemeKind:X.ColorThemeKind,CommentMode:X.CommentMode,CommentState:X.CommentState,CommentThreadCollapsibleState:X.CommentThreadCollapsibleState,CommentThreadState:X.CommentThreadState,CompletionItem:X.$$J,CompletionItemKind:X.CompletionItemKind,CompletionItemTag:X.CompletionItemTag,CompletionList:X.$_J,CompletionTriggerKind:X.CompletionTriggerKind,ConfigurationTarget:X.ConfigurationTarget,CustomExecution:X.$oK,DebugAdapterExecutable:X.$GK,DebugAdapterInlineImplementation:X.$JK,DebugAdapterNamedPipeServer:X.$IK,DebugAdapterServer:X.$HK,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:X.DebugConsoleMode,DecorationRangeBehavior:X.DecorationRangeBehavior,Diagnostic:X.$RJ,DiagnosticRelatedInformation:X.$QJ,DiagnosticSeverity:X.DiagnosticSeverity,DiagnosticTag:X.DiagnosticTag,Disposable:X.$DJ,DocumentHighlight:X.$TJ,DocumentHighlightKind:X.DocumentHighlightKind,DocumentLink:X.$dK,DocumentSymbol:X.$VJ,EndOfLine:X.EndOfLine,EnvironmentVariableMutatorType:X.EnvironmentVariableMutatorType,EvaluatableExpression:X.$MK,InlineValueText:X.$NK,InlineValueVariableLookup:X.$OK,InlineValueEvaluatableExpression:X.$PK,InlineCompletionTriggerKind:X.InlineCompletionTriggerKind,EventEmitter:C.$8c,ExtensionKind:X.ExtensionKind,ExtensionMode:X.ExtensionMode,ExternalUriOpenerPriority:X.ExternalUriOpenerPriority,FileChangeType:X.FileChangeType,FileDecoration:X.$ZK,FileDecoration2:X.$ZK,FileSystemError:X.$RK,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:X.$SK,FoldingRangeKind:X.FoldingRangeKind,FunctionBreakpoint:X.$EK,InlineCompletionItem:X.$aK,InlineCompletionList:X.$bK,Hover:X.$SJ,IndentAction:p.IndentAction,Location:X.$PJ,MarkdownString:X.$5J,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:X.$6J,PortAutoForwardAction:X.PortAutoForwardAction,Position:X.$EJ,ProcessExecution:X.$mK,ProgressLocation:X.ProgressLocation,QuickInputButtons:X.$YK,Range:X.$FJ,RelativePattern:X.$AK,Selection:X.$GJ,SelectionRange:X.$ZJ,SemanticTokens:X.$VK,SemanticTokensBuilder:X.$UK,SemanticTokensEdit:X.$WK,SemanticTokensEdits:X.$XK,SemanticTokensLegend:X.$TK,ShellExecution:X.$nK,ShellQuoting:X.ShellQuoting,SignatureHelp:X.$8J,SignatureHelpTriggerKind:X.SignatureHelpTriggerKind,SignatureInformation:X.$7J,SnippetString:X.$OJ,SourceBreakpoint:X.$DK,StandardTokenType:X.StandardTokenType,StatusBarAlignment:X.StatusBarAlignment,SymbolInformation:X.$UJ,SymbolKind:X.SymbolKind,SymbolTag:X.SymbolTag,Task:X.$pK,TaskGroup:X.$lK,TaskPanelKind:X.TaskPanelKind,TaskRevealKind:X.TaskRevealKind,TaskScope:X.TaskScope,TerminalLink:X.$hK,TerminalQuickFixCommand:X.$jK,TerminalQuickFixOpener:X.$iK,TerminalLocation:X.TerminalLocation,TerminalProfile:X.$kK,TerminalExitReason:X.TerminalExitReason,TerminalQuickFixType:X.TerminalQuickFixType,TextDocumentSaveReason:X.TextDocumentSaveReason,TextEdit:X.$KJ,SnippetTextEdit:X.$MJ,TextEditorCursorStyle:g.TextEditorCursorStyle,TextEditorLineNumbersStyle:X.TextEditorLineNumbersStyle,TextEditorRevealType:X.TextEditorRevealType,TextEditorSelectionChangeKind:X.TextEditorSelectionChangeKind,TextDocumentChangeReason:X.TextDocumentChangeReason,ThemeColor:X.$zK,ThemeIcon:X.$yK,TreeItem:X.$qK,TreeItemCheckboxState:X.TreeItemCheckboxState,TreeItemCollapsibleState:X.TreeItemCollapsibleState,TypeHierarchyItem:X.$jL,UIKind:y.UIKind,Uri:P.URI,ViewColumn:X.ViewColumn,WorkspaceEdit:X.$NJ,DocumentDropEdit:X.$wK,DocumentPasteEdit:X.$xK,InlayHint:X.$0J,InlayHintLabelPart:X.$9J,InlayHintKind:X.InlayHintKind,RemoteAuthorityResolverError:X.$JJ,ResolvedAuthority:X.$HJ,ManagedResolvedAuthority:X.$IJ,SourceControlInputBoxValidationType:X.SourceControlInputBoxValidationType,ExtensionRuntime:X.ExtensionRuntime,TimelineItem:X.$0K,NotebookRange:X.$2K,NotebookCellKind:X.NotebookCellKind,NotebookCellExecutionState:X.NotebookCellExecutionState,NotebookCellData:X.$3K,NotebookData:X.$4K,NotebookRendererScript:X.$8K,NotebookCellStatusBarAlignment:X.NotebookCellStatusBarAlignment,NotebookEditorRevealType:X.NotebookEditorRevealType,NotebookCellOutput:X.$6K,NotebookCellOutputItem:X.$5K,NotebookCellStatusBarItem:X.$7K,NotebookControllerAffinity:X.NotebookControllerAffinity,NotebookControllerAffinity2:X.NotebookControllerAffinity2,NotebookEdit:X.$LJ,NotebookKernelSourceAction:X.$9K,PortAttributes:X.$_K,LinkedEditingRanges:X.$$K,TestResultState:X.TestResultState,TestRunRequest:X.$aL,TestRunRequest2:X.$bL,TestMessage:X.$cL,TestTag:X.$dL,TestRunProfileKind:X.TestRunProfileKind,TextSearchCompleteMessageType:xe.TextSearchCompleteMessageType,DataTransfer:X.$vK,DataTransferItem:X.$rK,CoveredCount:X.$eL,FileCoverage:X.$fL,StatementCoverage:X.$gL,BranchCoverage:X.$hL,FunctionCoverage:X.$iL,WorkspaceTrustState:X.WorkspaceTrustState,LanguageStatusSeverity:X.LanguageStatusSeverity,QuickPickItemKind:X.QuickPickItemKind,InputBoxValidationSeverity:X.InputBoxValidationSeverity,TabInputText:X.$kL,TabInputTextDiff:X.$lL,TabInputTextMerge:X.$mL,TabInputCustom:X.$nL,TabInputNotebook:X.$pL,TabInputNotebookDiff:X.$qL,TabInputWebview:X.$oL,TabInputTerminal:X.$rL,TabInputInteractiveWindow:X.$sL,TelemetryTrustedValue:be.$2n,LogLevel:De.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:X.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:X.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:X.InteractiveEditorResponseFeedbackKind,StackFrameFocus:X.$KK,ThreadFocus:X.$LK,NotebookCodeActionKind:X.$YJ}}}e.$Pac=Lt}),define(Ae[269],Fe([1,0,71,109,33,107,34,32,60,63,111,113,114,83,85,79,108,62,39,82,58,61,236,14,112,80,81]),function($e,e,w,T,C,M,P,g,D,p,A,E,c,y,b,o,t,i,a,m,S,I,r,h,n,s,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$_q)(s.$u_b,s.$t_b,1),(0,w.$_q)(h.$Si,r.$Qac,1),(0,w.$_q)(o.$T$b,o.$U$b,1),(0,w.$_q)(g.$ZL,g.$YL,0),(0,w.$_q)(P.$7$b,P.$5$b,0),(0,w.$_q)(i.$j_b,i.$i_b,0),(0,w.$_q)(E.$0_b,E.$bac,0),(0,w.$_q)(M.$2_b,M.$1_b,0),(0,w.$_q)(D.$OL,D.$NL,0),(0,w.$_q)($.$v_b,$.$w_b,0),(0,w.$_q)(a.$Q$b,a.$P$b,0),(0,w.$_q)(T.$H_b,T.$G_b,1),(0,w.$_q)(c.$hac,c.$iac,0),(0,w.$_q)(y.$f_b,y.$e_b,0),(0,w.$_q)(A.$5_b,A.$4_b,0),(0,w.$_q)(p.$m_b,p.$p_b,0),(0,w.$_q)(b.$Wpb,b.$Xpb,0),(0,w.$_q)(t.$X_b,t.$W_b,0),(0,w.$_q)(C.$4$b,C.$3$b,0),(0,w.$_q)(m.$r_b,m.$q_b,0),(0,w.$_q)(S.$XL,S.$UL,0),(0,w.$_q)(I.$6_b,I.$7_b,0),(0,w.$_q)(n.$8_b,n.$9_b,0)}),define(Ae[270],Fe([1,0,268,35,2,265,7,16,256]),function($e,e,w,T,C,M,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;class p extends M.$Tac{j(){}getModule(y,b){for(const o of this.b){const t=o(y);if(t){y=t;break}}if(this.a.has(y))return this.a.get(y).load(y,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends T.$y_b{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Webworker}async pb(){this.h.createInstance(D.$Xcc);const y=this.h.invokeFunction(w.$Pac);this.r=this.h.createInstance(p,y,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.vb()}qb(y){return y.browser}async rb(y,b,o){b=b.with({path:E(b.path,".js")});const t=y?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=C.URI.revive(await this.v.$asBrowserUri(b)),a=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),a.status!==200)throw new Error(a.statusText);const m=await a.text(),S=`${b.toString(!0)}#vscode-extension`,I=`${m}
//# sourceURL=${S}`;let r;try{r=new Function("module","exports","require",I)}catch($){throw console.error(t?`Loading code for extension ${t} failed: ${$.message}`:`Loading code failed: ${$.message}`),console.error(`${b.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}y&&await this.s.initializeLocalizedMessages(y);const h={},n={exports:h},s=$=>{const k=this.r.getModule($,b);if(k===void 0)throw new Error(`Cannot load module '${$}'`);return k};try{return o.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(n,h,s),n.exports!==h?n.exports:h}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}}async $setRemoteEnvironment(y){}async vb(y=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+y;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,g.$wg)(10)}}e.$Ycc=A;function E(c,y){return c.endsWith(y)?c:c+y}}),define(Ae[271],Fe([1,0,70,71,14,35,188,84,270]),function($e,e,w,T,C,M,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$_q)(C.$Ri,new w.$mh(P.$Sac,[!0],!0)),(0,T.$_q)(M.$z_b,D.$Ycc,0),(0,T.$_q)(g.$k_b,g.$l_b,0)}),define(Ae[279],Fe([1,0,25,5,78,266,258,19,86,13,2,269,271]),function($e,e,w,T,C,M,P,g,D,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function y(r){return/^(file|vscode-remote):/i.test(r)}const b=fetch.bind(self);function o(r){self.fetch=async function(h,n){return h instanceof Request||y(String(h))&&(h=(await r(A.URI.parse(String(h)))).toString(!0)),b(h,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(h,n,s,$,k){(async()=>(y(n.toString())&&(n=(await r(A.URI.parse(n.toString()))).toString(!0)),super.open(h,n,s??!0,$,k)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(h,n){if(/^file:/i.test(h.toString()))h=p.$4e.uriToBrowserUri(A.URI.parse(h.toString())).toString(!0);else if(/^vscode-remote:/i.test(h.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const $=`(${function(v){function u(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const d=fetch.bind(self);self.fetch=function(W,B){return W instanceof Request?d(W,B):d(u(W),B)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,B,q,U,N){return super.open(W,u(B),q??!0,U,N)}};const R=importScripts.bind(self);self.importScripts=(...W)=>{R(...W.map(u))},R(v)}.toString()}('${h}'))`;n=n||{},n.name=n.name||g.$ec(h.toString());const k=new Blob([$],{type:"application/javascript"}),l=URL.createObjectURL(k);return new r(l,n)}}else self.Worker=class extends P.$Zcc{constructor(r,h){super(c,r,{name:g.$ec(r.toString()),...h})}};const t=new class{constructor(){this.pid=void 0}exit(r){E()}};class i{constructor(){const h=new MessageChannel,n=new T.$8c;let s=!1;c(h.port2,[h.port2]),h.port1.onmessage=$=>{const{data:k}=$;if(!(k instanceof ArrayBuffer)){console.warn("UNKNOWN data received",k);return}const l=w.$Jb.wrap(new Uint8Array(k,0,k.byteLength));if((0,C.$Ql)(l,2)){s=!0,m("received terminate message from renderer");return}n.fire(l)},this.protocol={onMessage:n.event,send:$=>{if(!s){const k=$.buffer.buffer.slice($.buffer.byteOffset,$.buffer.byteOffset+$.buffer.byteLength);h.port1.postMessage(k,[k])}}}}}function a(r){return new Promise(h=>{const n=r.onMessage(s=>{n.dispose();const $=JSON.parse(s.toString());r.send((0,C.$Pl)(0)),h({protocol:r,initData:$})});r.send((0,C.$Pl)(1))})}let m=r=>E();function S(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function I(){D.mark("code/extHost/willConnectToRenderer");const r=new i;return{onmessage(h){S(h)&&a(r.protocol).then(n=>{D.mark("code/extHost/didWaitForInitData");const s=new M.$Vac(n.protocol,n.initData,t,null,h.data);o($=>s.asBrowserUri($)),m=$=>s.terminate($)})}}}e.create=I})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/93d3731736cc6fefbd63810d5fb2d57bedc84ca0/core/vs/workbench/api/worker/extensionHostWorker.js.map
