/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],W=function(z){for(var e=[],T=0,E=z.length;T<E;T++)e[T]=q[z[T]];return e};define(q[21],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class T{static get(){const v=new Map,O=new Map,r=new Map,u=new Map;function t(l,n){l.has(n.detail)||l.set(n.detail,-n.timestamp)}function a(l,n){const i=l.get(n.detail);i&&(i>=0||l.set(n.detail,i+n.timestamp))}let c=[];typeof z=="function"&&typeof z.getStats=="function"&&(c=z.getStats().slice(0).sort((l,n)=>l.timestamp-n.timestamp));for(const l of c)switch(l.type){case 10:t(v,l);break;case 11:case 12:a(v,l);break;case 21:t(O,l);break;case 22:a(O,l);break;case 33:t(r,l);break;case 34:a(r,l);break;case 31:t(u,l);break;case 32:a(u,l);break}let o=0;r.forEach(l=>o+=l);function f(l){const n=[];return l.forEach((i,s)=>n.push([s,i])),n}return{amdLoad:f(v),amdInvoke:f(O),nodeRequire:f(r),nodeEval:f(u),nodeRequireTotal:o}}static toMarkdownTable(v,O){let r="";const u=[];return v.forEach((t,a)=>{u[a]=t.length}),O.forEach(t=>{t.forEach((a,c)=>{typeof a>"u"&&(a=t[c]="-");const o=a.toString().length;u[c]=Math.max(o,u[c])})}),v.forEach((t,a)=>{r+=`| ${t+" ".repeat(u[a]-t.toString().length)} `}),r+=`|
`,v.forEach((t,a)=>{r+=`| ${"-".repeat(u[a])} `}),r+=`|
`,O.forEach(t=>{t.forEach((a,c)=>{typeof a<"u"&&(r+=`| ${a+" ".repeat(u[c]-a.toString().length)} `)}),r+=`|
`}),r}}e.$S=T}),define(q[4],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mc=e.$Lc=e.$Kc=void 0;let T;function E(i){T=i}e.$Kc=E;function v(){return T}e.$Lc=v;class O{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([u(l("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[u(" "),a(c(s.oldValue,70),{color:"red",strikeThrough:!0}),u(" "),a(c(s.newValue,60),{color:"green"})]:[u(" (unchanged)")]:[u(" "),a(c(s.newValue,60),{color:"green"}),u(" (initial)")]}handleObservableChanged(s,$){console.log(...this.b([t("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.c($)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map($=>$.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const $=s.handleChange;this.d.set(s,new Set),s.handleChange=(S,P)=>(this.d.get(s).add(S),$.apply(s,[S,P]))}handleDerivedRecomputed(s,$){const S=this.d.get(s);console.log(...this.b([t("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.c($),this.formatChanges(S),{data:[{fn:s._computeFn}]}])),S.clear()}handleFromEventObservableTriggered(s,$){console.log(...this.b([t("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.c($),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const $=s.handleChange;this.d.set(s,new Set),s.handleChange=(S,P)=>(this.d.get(s).add(S),$.apply(s,[S,P]))}handleAutorunTriggered(s){const $=this.d.get(s);console.log(...this.b([t("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges($),{data:[{fn:s._runFn}]}])),$.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let $=s.getDebugName();$===void 0&&($=""),console.log(...this.b([t("transaction"),a($,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Mc=O;function r(i){const s=new Array,$=[];let S="";function P(k){if("length"in k)for(const d of k)d&&P(d);else"text"in k?(S+=`%c${k.text}`,s.push(k.style),k.data&&$.push(...k.data)):"data"in k&&$.push(...k.data)}P(i);const M=[S,...s];return M.push(...$),M}function u(i){return a(i,{color:"black"})}function t(i){return a(n(`${i}: `,10),{color:"black",bold:!0})}function a(i,s={color:"black"}){function $(P){return Object.entries(P).reduce((M,[k,d])=>`${M}${k}:${d};`,"")}const S={color:s.color};return s.strikeThrough&&(S["text-decoration"]="line-through"),s.bold&&(S["font-weight"]="bold"),{text:i,style:$(S)}}function c(i,s){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=s?`"${i}"`:`"${i.substr(0,s-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?o(i,s):f(i,s);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function o(i,s){let $="[ ",S=!0;for(const P of i){if(S||($+=", "),$.length-5>s){$+="...";break}S=!1,$+=`${c(P,s-$.length)}`}return $+=" ]",$}function f(i,s){let $="{ ",S=!0;for(const[P,M]of Object.entries(i)){if(S||($+=", "),$.length-5>s){$+="...";break}S=!1,$+=`${P}: ${c(M,s-$.length)}`}return $+=" }",$}function l(i,s){let $="";for(let S=1;S<=s;S++)$+=i;return $}function n(i,s){for(;i.length<s;)i+=" ";return i}}),define(q[5],W([0,1,4]),function(z,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=void 0;let E;function v(i){E=i}e.$Sc=v;class O{get TChange(){return null}reportChanges(){this.get()}read(s){return s?s.readObservable(this):this.get()}map(s){return E($=>s(this.read($),$),()=>{const $=c(s);if($!==void 0)return $;const P=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(s.toString());return P?`${this.debugName}.${P[2]}`:`${this.debugName} (mapped)`})}}e.$Tc=O;class r extends O{constructor(){super(...arguments),this.c=new Set}addObserver(s){const $=this.c.size;this.c.add(s),$===0&&this.f()}removeObserver(s){this.c.delete(s)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Uc=r;function u(i,s){const $=new a(i,s);try{i($)}finally{$.finish()}}e.$Vc=u;function t(i,s,$){i?s(i):u(s,$)}e.$Wc=t;class a{constructor(s,$){this._fn=s,this.b=$,this.a=[],(0,T.$Lc)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():c(this._fn)}updateObserver(s,$){this.a.push({observer:s,observable:$}),s.beginUpdate($)}finish(){const s=this.a;this.a=null;for(const{observer:$,observable:S}of s)$.endUpdate(S);(0,T.$Lc)()?.handleEndTransaction()}}e.$Xc=a;function c(i){const s=i.toString(),S=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(s);return(S?S[1]:void 0)?.trim()}e.$Yc=c;function o(i,s){return new f(i,s)}e.$Zc=o;class f extends r{constructor(s,$){super(),this.debugName=s,this.a=$}get(){return this.a}set(s,$,S){if(this.a===s)return;let P;$||($=P=new a(()=>{},()=>`Setting ${this.debugName}`));try{const M=this.a;this.b(s),(0,T.$Lc)()?.handleObservableChanged(this,{oldValue:M,newValue:s,change:S,didChange:!0,hadValue:!0});for(const k of this.c)$.updateObserver(k,this),k.handleChange(this,S)}finally{P&&P.finish()}}toString(){return`${this.debugName}: ${this.a}`}b(s){this.a=s}}e.$1c=f;function l(i,s){return new n(i,s)}e.$2c=l;class n extends f{b(s){this.a!==s&&(this.a&&this.a.dispose(),this.a=s)}dispose(){this.a?.dispose()}}e.$3c=n}),define(q[9],W([0,1,42,2,5,4]),function(z,e,T,E,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=void 0;function r(n,i){return new f(n.debugName,i,void 0,void 0)}e.$rc=r;function u(n){return new f(void 0,n,void 0,void 0)}e.$sc=u;function t(n,i){return new f(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.$tc=t;function a(n,i){const s=new E.$kb,$=t({debugName:n.debugName??(()=>(0,v.$Yc)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(S,P)=>{s.clear(),i(S,P,s)});return(0,E.$jb)(()=>{$.dispose(),s.dispose()})}e.$uc=a;function c(n){const i=new E.$kb,s=r({debugName:()=>(0,v.$Yc)(n)||"(anonymous)"},$=>{i.clear(),n($,i)});return(0,E.$jb)(()=>{s.dispose(),i.dispose()})}e.$vc=c;var o;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(o||(o={}));class f{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const s=this.h();if(s!==void 0)return s}const i=(0,v.$Yc)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,s,$,S){this.h=i,this._runFn=s,this.i=$,this.j=S,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,O.$Lc)()?.handleAutorunCreated(this),this.k()}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear()}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;try{if(!this.c){(0,O.$Lc)()?.handleAutorunTriggered(this);const s=this.g;this.g=this.i?.(),this._runFn(this,s)}}finally{(0,O.$Lc)()?.handleAutorunFinished(this);for(const s of this.f)s.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,T.$pc)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,s){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:s,didChange:S=>S===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const s=i.get();return this.e.add(i),this.f.delete(i),s}}e.$wc=f,function(n){n.Observer=f}(u||(e.$sc=u={}));function l(n,i){let s;return r({debugName:()=>(0,v.$Yc)(i)},$=>{const S=n.read($),P=s;s=S,i({lastValue:P,newValue:S})})}e.$xc=l}),define(q[10],W([0,1,6,2,5,4]),function(z,e,T,E,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=void 0;const r=(l,n)=>l===n;function u(l,n){return new f(n,l,void 0,void 0,void 0,r)}e.$Nc=u;function t(l,n){return new f(l.debugName,n,void 0,void 0,void 0,l.equalityComparer??r)}e.$Oc=t;function a(l,n,i){return new f(l,i,n.createEmptyChangeSummary,n.handleChange,void 0,r)}e.$Pc=a;function c(l,n){const i=new E.$kb;return new f(l,s=>(i.clear(),n(s,i)),void 0,void 0,()=>i.dispose(),r)}e.$Qc=c,(0,v.$Sc)(u);var o;(function(l){l[l.initial=0]="initial",l[l.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",l[l.stale=2]="stale",l[l.upToDate=3]="upToDate"})(o||(o={}));class f extends v.$Uc{get debugName(){return this.m?typeof this.m=="function"?this.m():this.m:(0,v.$Yc)(this._computeFn)||"(anonymous)"}constructor(n,i,s,$,S=void 0,P){super(),this.m=n,this._computeFn=i,this.n=s,this.p=$,this.q=S,this.s=P,this.e=0,this.h=void 0,this.i=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.n?.(),(0,O.$Lc)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.j)n.removeObserver(this);this.j.clear(),this.q?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.n?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.j)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.u()}while(this.e!==3);return this.h}}u(){if(this.e===3)return;const n=this.k;this.k=this.j,this.j=n;const i=this.e!==0,s=this.h;this.e=3;const $=this.l;this.l=this.n?.();try{this.h=this._computeFn(this,$)}finally{for(const P of this.k)P.removeObserver(this);this.k.clear()}const S=i&&!this.s(s,this.h);if((0,O.$Lc)()?.handleDerivedRecomputed(this,{oldValue:s,newValue:this.h,change:void 0,didChange:S,hadValue:i}),S)for(const P of this.c)P.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.i++;const i=this.i===1;if(this.e===3&&(this.e=1,!i))for(const s of this.c)s.handlePossibleChange(this);if(i)for(const s of this.c)s.beginUpdate(this)}endUpdate(n){if(this.i--,this.i===0){const i=[...this.c];for(const s of i)s.endUpdate(this)}if(this.i<0)throw new T.$bb}handlePossibleChange(n){if(this.e===3&&this.j.has(n)&&!this.k.has(n)){this.e=1;for(const i of this.c)i.handlePossibleChange(this)}}handleChange(n,i){if(this.j.has(n)&&!this.k.has(n)){const s=this.p?this.p({changedObservable:n,change:i,didChange:S=>S===n},this.l):!0,$=this.e===3;if(s&&(this.e===1||$)&&(this.e=2,$))for(const S of this.c)S.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.j.add(n),this.k.delete(n),i}addObserver(n){const i=!this.c.has(n)&&this.i>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.c.has(n)&&this.i>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.$Rc=f}),define(q[22],W([0,1,2,9,5,10,4]),function(z,e,T,E,v,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=void 0;function u(m){return new t(m)}e.$yc=u;class t extends v.$Tc{constructor(w){super(),this.a=w}get debugName(){return this.toString()}get(){return this.a}addObserver(w){}removeObserver(w){}toString(){return`Const: ${this.a}`}}function a(m){const w=(0,v.$Zc)("promiseValue",{});return m.then(N=>{w.set({value:N},void 0)}),w}e.$zc=a;function c(m,w){return new Promise(N=>{let F=!1,g=!1;const C=(0,E.$sc)(U=>{const B=m.read(U);w(B)&&(F?C.dispose():g=!0,N(B))});F=!0,g&&C.dispose()})}e.$Ac=c;function o(m,w){return new f(m,w)}e.$Bc=o;class f extends v.$Uc{constructor(w,N){super(),this.h=w,this._getValue=N,this.b=!1,this.k=F=>{const g=this._getValue(F),C=!this.b||this.a!==g;(0,r.$Lc)()?.handleFromEventObservableTriggered(this,{oldValue:this.a,newValue:g,change:void 0,didChange:C,hadValue:this.b}),C&&(this.a=g,this.b&&(0,v.$Vc)(U=>{for(const B of this.c)U.updateObserver(B,this),B.handleChange(this,void 0)},()=>{const U=this.i();return"Event fired"+(U?`: ${U}`:"")}),this.b=!0)}}i(){return(0,v.$Yc)(this._getValue)}get debugName(){const w=this.i();return"From Event"+(w?`: ${w}`:"")}f(){this.e=this.h(this.k)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.k(void 0),this.a):this._getValue(void 0)}}e.$Cc=f,function(m){m.Observer=f}(o||(e.$Bc=o={}));function l(m,w){return new n(m,w)}e.$Dc=l;class n extends v.$Uc{constructor(w,N){super(),this.debugName=w,this.b=N,this.h=()=>{(0,v.$Vc)(F=>{for(const g of this.c)F.updateObserver(g,this),g.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function i(m){return new s(m)}e.$Ec=i;class s extends v.$Uc{constructor(w){super(),this.debugName=w}trigger(w,N){if(!w){(0,v.$Vc)(F=>{this.trigger(F,N)},()=>`Trigger signal ${this.debugName}`);return}for(const F of this.c)w.updateObserver(F,this),F.handleChange(this,N)}get(){}}function $(m,w,N){const F=(0,v.$Zc)("debounced",void 0);let g;return N.add((0,E.$sc)(C=>{const U=m.read(C);g&&clearTimeout(g),g=setTimeout(()=>{(0,v.$Vc)(B=>{F.set(U,B)})},w)})),F}e.$Fc=$;function S(m,w,N){const F=(0,v.$Zc)("triggeredRecently",!1);let g;return N.add(m(()=>{F.set(!0,void 0),g&&clearTimeout(g),g=setTimeout(()=>{F.set(!1,void 0)},w)})),F}e.$Gc=S;function P(m,w){const N=new M(w??!1);return m.addObserver(N),w&&m.reportChanges(),(0,T.$jb)(()=>{m.removeObserver(N)})}e.$Hc=P;class M{constructor(w){this.b=w,this.a=0}beginUpdate(w){this.a++}endUpdate(w){this.a--,this.a===0&&this.b&&w.reportChanges()}handlePossibleChange(w){}handleChange(w,N){}}function k(m,w){let N;return(0,O.$Nc)(g=>(N=w(g,N),N),m)}e.$Ic=k;function d(m,w){let N;const F=(0,v.$Zc)("derivedObservableWithWritableCache.counter",0),g=(0,O.$Nc)(C=>(F.read(C),N=w(C,N),N),m);return Object.assign(g,{clearCache:C=>{N=void 0,F.set(F.get()+1,C)}})}e.$Jc=d}),define(q[11],W([0,1,5,10,9,22,4]),function(z,e,T,E,v,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.keepAlive=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return T.$Zc}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return T.$2c}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return T.$Vc}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return T.$Wc}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return E.$Nc}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return E.$Oc}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return E.$Pc}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return E.$Qc}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$sc}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$xc}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$tc}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$vc}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return v.$rc}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return v.$uc}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return O.$yc}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return O.$Fc}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return O.$Ic}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return O.$Jc}}),Object.defineProperty(e,"keepAlive",{enumerable:!0,get:function(){return O.$Hc}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return O.$Bc}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return O.$zc}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return O.$Ec}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return O.$Dc}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return O.$Ac}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return O.$Gc}}),!1&&(0,r.$Kc)(new r.$Mc)}),define(q[23],W([0,1,6,2]),function(z,e,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=void 0;function v(M){const k=M;return k?typeof k.read=="function":!1}e.$ub=v;function O(M){const k=M;return k?[k.on,k.pause,k.resume,k.destroy].every(d=>typeof d=="function"):!1}e.$vb=O;function r(M){const k=M;return k?O(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.$wb=r;function u(M,k){return new t(M,k)}e.$xb=u;class t{constructor(k,d){this.e=k,this.f=d,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(d=>this.d.push(d))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(d=>d(k))}h(k){this.c.error.length===0?(0,T.$Y)(k):this.c.error.slice(0).forEach(d=>d(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,d){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(d),this.resume();break;case"end":this.c.end.push(d),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(d),this.a.flowing&&this.k();break}}removeListener(k,d){if(this.a.destroyed)return;let m;switch(k){case"data":m=this.c.data;break;case"end":m=this.c.end;break;case"error":m=this.c.error;break}if(m){const w=m.indexOf(d);w>=0&&m.splice(w,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const d=[...this.d];this.d.length=0,d.forEach(m=>m())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(M,k){const d=[];let m;for(;(m=M.read())!==null;)d.push(m);return k(d)}e.$yb=a;function c(M,k,d){const m=[];let w;for(;(w=M.read())!==null&&m.length<d;)m.push(w);return w===null&&m.length>0?k(m):{read:()=>{if(m.length>0)return m.shift();if(typeof w<"u"){const N=w;return w=void 0,N}return M.read()}}}e.$zb=c;function o(M,k){return new Promise((d,m)=>{const w=[];f(M,{onData:N=>{k&&w.push(N)},onError:N=>{k?m(N):d(void 0)},onEnd:()=>{d(k?k(w):void 0)}})})}e.$Ab=o;function f(M,k){let d=!1;return M.on("error",m=>{d||k.onError(m)}),M.on("end",()=>{d||k.onEnd()}),M.on("data",m=>{d||k.onData(m)}),(0,E.$jb)(()=>d=!0)}e.$Bb=f;function l(M,k){return new Promise((d,m)=>{const w=new E.$kb,N=[],F=U=>{if(N.push(U),N.length>k)return w.dispose(),M.pause(),d({stream:M,buffer:N,ended:!1})},g=U=>m(U),C=()=>d({stream:M,buffer:N,ended:!0});w.add((0,E.$jb)(()=>M.removeListener("error",g))),M.on("error",g),w.add((0,E.$jb)(()=>M.removeListener("end",C))),M.on("end",C),w.add((0,E.$jb)(()=>M.removeListener("data",F))),M.on("data",F)})}e.$Cb=l;function n(M,k){const d=u(k);return d.end(M),d}e.$Db=n;function i(){const M=u(()=>{throw new Error("not supported")});return M.end(),M}e.$Eb=i;function s(M){let k=!1;return{read:()=>k?null:(k=!0,M)}}e.$Fb=s;function $(M,k,d){const m=u(d);return f(M,{onData:w=>m.write(k.data(w)),onError:w=>m.error(k.error?k.error(w):w),onEnd:()=>m.end()}),m}e.$Gb=$;function S(M,k,d){let m=!1;return{read:()=>{const w=k.read();return m?w:(m=!0,w!==null?d([M,w]):M)}}}e.$Hb=S;function P(M,k,d){let m=!1;const w=u(d);return f(k,{onData:N=>m?w.write(N):(m=!0,w.write(d([M,N]))),onError:N=>w.error(N),onEnd:()=>{m||(m=!0,w.write(M)),w.end()}}),w}e.$Ib=P}),define(q[12],W([0,1,43,23]),function(z,e,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=void 0;const v=typeof Buffer<"u",O=new T.$T(()=>new Uint8Array(256));let r,u;class t{static alloc(b){return v?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return v&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,R){return!(R?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from(b)):(r||(r=new TextEncoder),new t(r.encode(b)))}static fromByteArray(b){const R=t.alloc(b.length);for(let G=0,V=b.length;G<V;G++)R.buffer[G]=b[G];return R}static concat(b,R){if(typeof R>"u"){R=0;for(let p=0,_=b.length;p<_;p++)R+=b[p].byteLength}const G=t.alloc(R);let V=0;for(let p=0,_=b.length;p<_;p++){const K=b[p];G.set(K,V),V+=K.byteLength}return G}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return v?this.buffer.toString():(u||(u=new TextDecoder),u.decode(this.buffer))}slice(b,R){return new t(this.buffer.subarray(b,R))}set(b,R){if(b instanceof t)this.buffer.set(b.buffer,R);else if(b instanceof Uint8Array)this.buffer.set(b,R);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),R);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return f(this.buffer,b)}writeUInt32BE(b,R){l(this.buffer,b,R)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,R){i(this.buffer,b,R)}readUInt8(b){return s(this.buffer,b)}writeUInt8(b,R){$(this.buffer,b,R)}indexOf(b,R=0){return a(this.buffer,b instanceof t?b.buffer:b,R)}}e.$Jb=t;function a(I,b,R=0){const G=b.byteLength,V=I.byteLength;if(G===0)return 0;if(G===1)return I.indexOf(b[0]);if(G>V-R)return-1;const p=O.value;p.fill(b.length);for(let J=0;J<b.length;J++)p[b[J]]=b.length-J-1;let _=R+b.length-1,K=_,Z=-1;for(;_<V;)if(I[_]===b[K]){if(K===0){Z=_;break}_--,K--}else _+=Math.max(b.length-K,p[I[_]]),K=b.length-1;return Z}e.$Kb=a;function c(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0}e.$Lb=c;function o(I,b,R){I[R+0]=b&255,b=b>>>8,I[R+1]=b&255}e.$Mb=o;function f(I,b){return I[b]*2**24+I[b+1]*2**16+I[b+2]*2**8+I[b+3]}e.$Nb=f;function l(I,b,R){I[R+3]=b,b=b>>>8,I[R+2]=b,b=b>>>8,I[R+1]=b,b=b>>>8,I[R]=b}e.$Ob=l;function n(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0|I[b+2]<<16>>>0|I[b+3]<<24>>>0}e.$Pb=n;function i(I,b,R){I[R+0]=b&255,b=b>>>8,I[R+1]=b&255,b=b>>>8,I[R+2]=b&255,b=b>>>8,I[R+3]=b&255}e.$Qb=i;function s(I,b){return I[b]}e.$Rb=s;function $(I,b,R){I[R]=b}e.$Sb=$;function S(I){return E.$yb(I,b=>t.concat(b))}e.$Tb=S;function P(I){return E.$Fb(I)}e.$Ub=P;function M(I){return E.$Ab(I,b=>t.concat(b))}e.$Vb=M;async function k(I){return I.ended?t.concat(I.buffer):t.concat([...I.buffer,await M(I.stream)])}e.$Wb=k;function d(I){return E.$Db(I,b=>t.concat(b))}e.$Xb=d;function m(I){return E.$Gb(I,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.$Yb=m;function w(I){return E.$xb(b=>t.concat(b),I)}e.$Zb=w;function N(I,b){return E.$Hb(I,b,R=>t.concat(R))}e.$1b=N;function F(I,b){return E.$Ib(I,b,R=>t.concat(R))}e.$2b=F;function g(I){let b=0,R=0,G=0;const V=new Uint8Array(Math.floor(I.length/4*3)),p=K=>{switch(R){case 3:V[G++]=b|K,R=0;break;case 2:V[G++]=b|K>>>2,b=K<<6,R=3;break;case 1:V[G++]=b|K>>>4,b=K<<4,R=2;break;default:b=K<<2,R=1}};for(let K=0;K<I.length;K++){const Z=I.charCodeAt(K);if(Z>=65&&Z<=90)p(Z-65);else if(Z>=97&&Z<=122)p(Z-97+26);else if(Z>=48&&Z<=57)p(Z-48+52);else if(Z===43||Z===45)p(62);else if(Z===47||Z===95)p(63);else{if(Z===61)break;throw new SyntaxError(`Unexpected base64 character ${I[K]}`)}}const _=G;for(;R>0;)p(0);return t.wrap(V).slice(0,_)}e.$3b=g;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function B({buffer:I},b=!0,R=!1){const G=R?U:C;let V="";const p=I.byteLength%3;let _=0;for(;_<I.byteLength-p;_+=3){const K=I[_+0],Z=I[_+1],J=I[_+2];V+=G[K>>>2],V+=G[(K<<4|Z>>>4)&63],V+=G[(Z<<2|J>>>6)&63],V+=G[J&63]}if(p===1){const K=I[_+0];V+=G[K>>>2],V+=G[K<<4&63],b&&(V+="==")}else if(p===2){const K=I[_+0],Z=I[_+1];V+=G[K>>>2],V+=G[(K<<4|Z>>>4)&63],V+=G[Z<<2&63],b&&(V+="=")}return V}e.$4b=B}),define(q[24],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0,e.$5c=Symbol("MicrotaskDelay")}),define(q[13],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=e.StringEOL=void 0;var T;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(T||(e.StringEOL=T={}));function E(v){let O=0,r=0,u=0,t=0;for(let a=0,c=v.length;a<c;a++){const o=v.charCodeAt(a);o===13?(O===0&&(r=a),O++,a+1<c&&v.charCodeAt(a+1)===10?(t|=2,a++):t|=3,u=a+1):o===10&&(t|=1,O===0&&(r=a),O++,u=a+1)}return O===0&&(r=v.length),[O,r,v.length-u,t]}e.$fs=E}),define(q[14],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var T;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(T||(e.LanguageId=T={}));var E;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(E||(e.FontStyle=E={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var O;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(O||(e.StandardTokenType=O={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class u{static getLanguageId(a){return(a&255)>>>0}static getTokenType(a){return(a&768)>>>8}static containsBalancedBrackets(a){return(a&1024)!==0}static getFontStyle(a){return(a&30720)>>>11}static getForeground(a){return(a&16744448)>>>15}static getBackground(a){return(a&4278190080)>>>24}static getClassNameFromMetadata(a){let o="mtk"+this.getForeground(a);const f=this.getFontStyle(a);return f&1&&(o+=" mtki"),f&2&&(o+=" mtkb"),f&4&&(o+=" mtku"),f&8&&(o+=" mtks"),o}static getInlineStyleFromMetadata(a,c){const o=this.getForeground(a),f=this.getFontStyle(a);let l=`color: ${c[o]};`;f&1&&(l+="font-style: italic;"),f&2&&(l+="font-weight: bold;");let n="";return f&4&&(n+=" underline"),f&8&&(n+=" line-through"),n&&(l+=`text-decoration:${n};`),l}static getPresentationFromMetadata(a){const c=this.getForeground(a),o=this.getFontStyle(a);return{foreground:c,italic:!!(o&1),bold:!!(o&2),underline:!!(o&4),strikethrough:!!(o&8)}}}e.$ds=u}),define(q[25],W([0,1,26]),function(z,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hC=void 0;class E{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,u){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=u}replace(r,u,t){if(r>=this.a.length)return;if(u===0){this.insert(r,t);return}else if(t===0){this.delete(r,u);return}const a=this.a.slice(0,r),c=this.a.slice(r+u),o=v(t,this.b);this.a=a.concat(o,c)}delete(r,u){u===0||r>=this.a.length||this.a.splice(r,u)}insert(r,u){if(u===0||r>=this.a.length)return;const t=[];for(let a=0;a<u;a++)t[a]=this.b;this.a=(0,T.$Df)(this.a,r,t)}}e.$hC=E;function v(O,r){const u=[];for(let t=0;t<O;t++)u[t]=r;return u}}),define(q[7],W([0,1,14]),function(z,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=void 0;class E{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(r,u){const t=E.defaultTokenMetadata,a=new Uint32Array(2);return a[0]=r.length,a[1]=t,new E(a,r,u)}constructor(r,u,t){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=u,this.d=t}equals(r){return r instanceof E?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,u,t){if(this.c!==r.c||this.b!==r.b)return!1;const a=u<<1,c=a+(t<<1);for(let o=a;o<c;o++)if(this.a[o]!==r.a[o])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const u=this.a[(r<<1)+1],t=T.$ds.getLanguageId(u);return this.d.decodeLanguageId(t)}getStandardTokenType(r){const u=this.a[(r<<1)+1];return T.$ds.getTokenType(u)}getForeground(r){const u=this.a[(r<<1)+1];return T.$ds.getForeground(u)}getClassName(r){const u=this.a[(r<<1)+1];return T.$ds.getClassNameFromMetadata(u)}getInlineStyle(r,u){const t=this.a[(r<<1)+1];return T.$ds.getInlineStyleFromMetadata(t,u)}getPresentation(r){const u=this.a[(r<<1)+1];return T.$ds.getPresentationFromMetadata(u)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return E.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,u,t){return new v(this,r,u,t)}static convertToEndOffset(r,u){const a=(r.length>>>1)-1;for(let c=0;c<a;c++)r[c<<1]=r[c+1<<1];r[a<<1]=u}static findIndexInTokensArray(r,u){if(r.length<=2)return 0;let t=0,a=(r.length>>>1)-1;for(;t<a;){const c=t+Math.floor((a-t)/2),o=r[c<<1];if(o===u)return c+1;o<u?t=c+1:o>u&&(a=c)}return t}withInserted(r){if(r.length===0)return this;let u=0,t=0,a="";const c=new Array;let o=0;for(;;){const f=u<this.b?this.a[u<<1]:-1,l=t<r.length?r[t]:null;if(f!==-1&&(l===null||f<=l.offset)){a+=this.c.substring(o,f);const n=this.a[(u<<1)+1];c.push(a.length,n),u++,o=f}else if(l){if(l.offset>o){a+=this.c.substring(o,l.offset);const n=this.a[(u<<1)+1];c.push(a.length,n),o=l.offset}a+=l.text,c.push(a.length,l.tokenMetadata),t++}else break}return new E(new Uint32Array(c),a,this.d)}}e.$gs=E;class v{constructor(r,u,t,a){this.a=r,this.b=u,this.c=t,this.d=a,this.e=r.findTokenIndexAtOffset(u),this.f=0;for(let c=this.e,o=r.getCount();c<o&&!(r.getStartOffset(c)>=t);c++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof v?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const u=this.a.getEndOffset(this.e+r);return Math.min(this.c,u)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,u){return this.a.getInlineStyle(this.e+r,u)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(q[27],W([0,1,7]),function(z,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=void 0,e.$hs=new Uint32Array(0).buffer;class E{static deleteBeginning(r,u){return r===null||r===e.$hs?r:E.delete(r,0,u)}static deleteEnding(r,u){if(r===null||r===e.$hs)return r;const t=v(r),a=t[t.length-2];return E.delete(r,u,a)}static delete(r,u,t){if(r===null||r===e.$hs||u===t)return r;const a=v(r),c=a.length>>>1;if(u===0&&a[a.length-2]===t)return e.$hs;const o=T.$gs.findIndexInTokensArray(a,u),f=o>0?a[o-1<<1]:0,l=a[o<<1];if(t<l){const S=t-u;for(let P=o;P<c;P++)a[P<<1]-=S;return r}let n,i;f!==u?(a[o<<1]=u,n=o+1<<1,i=u):(n=o<<1,i=f);const s=t-u;for(let S=o+1;S<c;S++){const P=a[S<<1]-s;P>i&&(a[n++]=P,a[n++]=a[(S<<1)+1],i=P)}if(n===a.length)return r;const $=new Uint32Array(n);return $.set(a.subarray(0,n),0),$.buffer}static append(r,u){if(u===e.$hs)return r;if(r===e.$hs)return u;if(r===null)return r;if(u===null)return null;const t=v(r),a=v(u),c=a.length>>>1,o=new Uint32Array(t.length+a.length);o.set(t,0);let f=t.length;const l=t[t.length-2];for(let n=0;n<c;n++)o[f++]=a[n<<1]+l,o[f++]=a[(n<<1)+1];return o.buffer}static insert(r,u,t){if(r===null||r===e.$hs)return r;const a=v(r),c=a.length>>>1;let o=T.$gs.findIndexInTokensArray(a,u);o>0&&a[o-1<<1]===u&&o--;for(let f=o;f<c;f++)a[f<<1]+=t;return r}}e.$is=E;function v(O){return O instanceof Uint32Array?O:new Uint32Array(O)}e.$js=v}),define(q[28],W([0,1,26,12,44,13,27,15]),function(z,e,T,E,v,O,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0;class t{static deserialize(c,o,f){const l=new Uint32Array(c.buffer),n=(0,E.$Nb)(c,o);o+=4;const i=(0,E.$Nb)(c,o);o+=4;const s=[];for(let $=0;$<i;$++){const S=(0,E.$Nb)(c,o);o+=4,s.push(l.subarray(o/4,o/4+S/4)),o+=S}return f.push(new t(n,s)),o}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(c,o){this.a=c,this.b=o}getLineRange(){return new u.$Pr(this.a,this.a+this.b.length)}getLineTokens(c){return this.b[c-this.a]}appendLineTokens(c){this.b.push(c)}serializeSize(){let c=0;c+=4,c+=4;for(let o=0;o<this.b.length;o++){const f=this.b[o];if(!(f instanceof Uint32Array))throw new Error("Not supported!");c+=4,c+=f.byteLength}return c}serialize(c,o){(0,E.$Ob)(c,this.a,o),o+=4,(0,E.$Ob)(c,this.b.length,o),o+=4;for(let f=0;f<this.b.length;f++){const l=this.b[f];if(!(l instanceof Uint32Array))throw new Error("Not supported!");(0,E.$Ob)(c,l.byteLength,o),o+=4,c.set(new Uint8Array(l.buffer),o),o+=l.byteLength}return o}applyEdit(c,o){const[f,l]=(0,O.$fs)(o);this.c(c),this.d(new v.$Nr(c.startLineNumber,c.startColumn),f,l)}c(c){if(c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn)return;const o=c.startLineNumber-this.a,f=c.endLineNumber-this.a;if(f<0){const l=f-o;this.a-=l;return}if(!(o>=this.b.length)){if(o<0&&f>=this.b.length){this.a=0,this.b=[];return}if(o===f){this.b[o]=r.$is.delete(this.b[o],c.startColumn-1,c.endColumn-1);return}if(o>=0)if(this.b[o]=r.$is.deleteEnding(this.b[o],c.startColumn-1),f<this.b.length){const l=r.$is.deleteBeginning(this.b[f],c.endColumn-1);this.b[o]=r.$is.append(this.b[o],l),this.b.splice(o+1,f-o)}else this.b[o]=r.$is.append(this.b[o],null),this.b=this.b.slice(0,o+1);else{const l=-o;this.a-=l,this.b[f]=r.$is.deleteBeginning(this.b[f],c.endColumn-1),this.b=this.b.slice(f)}}}d(c,o,f){if(o===0&&f===0)return;const l=c.lineNumber-this.a;if(l<0){this.a+=o;return}if(!(l>=this.b.length)){if(o===0){this.b[l]=r.$is.insert(this.b[l],c.column-1,f);return}this.b[l]=r.$is.deleteEnding(this.b[l],c.column-1),this.b[l]=r.$is.insert(this.b[l],c.column-1,f),this.e(c.lineNumber,o)}}e(c,o){if(o===0)return;const f=[];for(let l=0;l<o;l++)f[l]=null;this.b=T.$Df(this.b,c,f)}}e.$ks=t}),define(q[16],W([0,1,12,28]),function(z,e,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iC=void 0;class v{static deserialize(r){let u=0;const t=(0,T.$Nb)(r,u);u+=4;const a=[];for(let c=0;c<t;c++)u=E.$ks.deserialize(r,u,a);return a}constructor(){this.a=[]}add(r,u){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(u);return}}this.a.push(new E.$ks(r,[u]))}finalize(){return this.a}serialize(){const r=this.b(),u=new Uint8Array(r);return this.c(u),u}b(){let r=0;r+=4;for(let u=0;u<this.a.length;u++)r+=this.a[u].serializeSize();return r}c(r){let u=0;(0,T.$Ob)(r,this.a.length,u),u+=4;for(let t=0;t<this.a.length;t++)u=this.a[t].serialize(r,u)}}e.$iC=v}),define(q[29],W([0,1,30,3,31,45]),function(z,e,T,E,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=void 0;function r(g){return g===47||g===92}e.$De=r;function u(g){return g.replace(/[\\/]/g,T.$0b.sep)}e.$Ee=u;function t(g){return g.indexOf("/")===-1&&(g=u(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}e.$Fe=t;function a(g,C=T.$0b.sep){if(!g)return"";const U=g.length,B=g.charCodeAt(0);if(r(B)){if(r(g.charCodeAt(1))&&!r(g.charCodeAt(2))){let b=3;const R=b;for(;b<U&&!r(g.charCodeAt(b));b++);if(R!==b&&!r(g.charCodeAt(b+1))){for(b+=1;b<U;b++)if(r(g.charCodeAt(b)))return g.slice(0,b+1).replace(/[\\/]/g,C)}}return C}else if($(B)&&g.charCodeAt(1)===58)return r(g.charCodeAt(2))?g.slice(0,2)+C:g.slice(0,2);let I=g.indexOf("://");if(I!==-1){for(I+=3;I<U;I++)if(r(g.charCodeAt(I)))return g.slice(0,I+1)}return""}e.$Ge=a;function c(g){if(!E.$i||!g||g.length<5)return!1;let C=g.charCodeAt(0);if(C!==92||(C=g.charCodeAt(1),C!==92))return!1;let U=2;const B=U;for(;U<g.length&&(C=g.charCodeAt(U),C!==92);U++);return!(B===U||(C=g.charCodeAt(U+1),isNaN(C)||C===92))}e.$He=c;const o=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(g,C=E.$i){const U=C?o:f;return!(!g||g.length===0||/^\s+$/.test(g)||(U.lastIndex=0,U.test(g))||C&&l.test(g)||g==="."||g===".."||C&&g[g.length-1]==="."||C&&g.length!==g.trim().length||g.length>255)}e.$Ie=n;function i(g,C,U){const B=g===C;return!U||B?B:!g||!C?!1:(0,v.$Md)(g,C)}e.$Je=i;function s(g,C,U,B=T.sep){if(g===C)return!0;if(!g||!C||C.length>g.length)return!1;if(U){if(!(0,v.$Nd)(g,C))return!1;if(C.length===g.length)return!0;let b=C.length;return C.charAt(C.length-1)===B&&b--,g.charAt(b)===B}return C.charAt(C.length-1)!==B&&(C+=B),g.indexOf(C)===0}e.$Ke=s;function $(g){return g>=65&&g<=90||g>=97&&g<=122}e.$Le=$;function S(g,C){return E.$i&&g.endsWith(":")&&(g+=T.sep),(0,T.$_b)(g)||(g=(0,T.$ac)(C,g)),g=(0,T.$$b)(g),E.$i?(g=(0,v.$td)(g,T.sep),g.endsWith(":")&&(g+=T.sep)):(g=(0,v.$td)(g,T.sep),g||(g=T.sep)),g}e.$Me=S;function P(g){const C=(0,T.$$b)(g);return E.$i?g.length>3?!1:M(C)&&(g.length===2||C.charCodeAt(2)===92):C===T.$0b.sep}e.$Ne=P;function M(g,C=E.$i){return C?$(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}e.$Oe=M;function k(g,C=E.$i){return M(g,C)?g[0]:void 0}e.$Pe=k;function d(g,C,U){return C.length>g.length?-1:g===C?0:(U&&(g=g.toLowerCase(),C=C.toLowerCase()),g.indexOf(C))}e.$Qe=d;function m(g){const C=g.split(":");let U,B,I;for(const b of C){const R=Number(b);(0,O.$ne)(R)?B===void 0?B=R:I===void 0&&(I=R):U=U?[U,b].join(":"):b}if(!U)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:U,line:B!==void 0?B:void 0,column:I!==void 0?I:B!==void 0?1:void 0}}e.$Re=m;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",N="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function F(g,C,U=8){let B="";for(let b=0;b<U;b++){let R;b===0&&E.$i&&!C&&(U===3||U===4)?R=N:R=w,B+=R.charAt(Math.floor(Math.random()*R.length))}let I;return C?I=`${C}-${B}`:I=B,g?(0,T.$ac)(g,I):I}e.$Se=F}),define(q[17],W([0,1,6,3,8]),function(z,e,T,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.Schemas=void 0;var O;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.$We="vscode-tkn",e.$Xe="tkn";class r{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c){this.f=`${c}/${O.vscodeRemoteResource}`}set(c,o,f){this.a[c]=o,this.b[c]=f}setConnectionToken(c,o){this.c[c]=o}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(s){return T.$Y(s),c}const o=c.authority;let f=this.a[o];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const l=this.b[o],n=this.c[o];let i=`path=${encodeURIComponent(c.path)}`;return typeof n=="string"&&(i+=`&${e.$Xe}=${encodeURIComponent(n)}`),v.URI.from({scheme:E.$o?this.d:O.vscodeRemoteResource,authority:`${f}:${l}`,path:this.f,query:i})}}e.$Ye=new r,e.$Ze="vs/../../extensions",e.$1e="vs/../../node_modules",e.$2e="vs/../../node_modules.asar",e.$3e="vs/../../node_modules.asar.unpacked";class u{static{this.a="vscode-app"}asBrowserUri(c){const o=this.b(c,z);return this.uriToBrowserUri(o)}uriToBrowserUri(c){return c.scheme===O.vscodeRemote?e.$Ye.rewrite(c):c.scheme===O.file&&(E.$m||E.$p&&E.$g.origin===`${O.vscodeFileResource}://${u.a}`)?c.with({scheme:O.vscodeFileResource,authority:c.authority||u.a,query:null,fragment:null}):c}asFileUri(c){const o=this.b(c,z);return this.uriToFileUri(o)}uriToFileUri(c){return c.scheme===O.vscodeFileResource?c.with({scheme:O.file,authority:c.authority!==u.a?c.authority:null,query:null,fragment:null}):c}b(c,o){return v.URI.isUri(c)?c:v.URI.parse(o.toUrl(c))}}e.$4e=new u;var t;(function(a){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(c.get("3"));const o="vscode-coi";function f(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:v.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const s=i?.get(o);if(s)return c.get(s)}a.getHeadersFromQuery=f;function l(n,i,s){if(!globalThis.crossOriginIsolated)return;const $=i&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(o,$):n[o]=$}a.addSearchParam=l})(t||(e.COI=t={}))}),define(q[32],W([0,1,21,17,3,8]),function(z,e,T,E,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WC=void 0;class r{constructor(f,l,n){this.id=f,this.dependencies=l,this.callback=n}}class u{static{this.INSTANCE=new u}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(f,l,n)=>{typeof f!="string"&&(n=l,l=f,f=null),(typeof l!="object"||!Array.isArray(l))&&(n=l,l=null),this.c.push(new r(f,l,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){if(f.startsWith(window.location.origin)||f.startsWith("vscode-file://vscode-app"))return f;throw new Error(`[trusted_script_src] Invalid script url: ${f}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){return f}})))}async load(f){this.g();const l=await(this.a?this.i(f):this.b?this.h(f):this.j(f));if(!l)throw new Error(`Did not receive a define call from script ${f}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${f}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(f){return new Promise((l,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const s=()=>{i.removeEventListener("load",$),i.removeEventListener("error",S)},$=P=>{s(),l(this.c.pop())},S=P=>{s(),n(P)};i.addEventListener("load",$),i.addEventListener("error",S),this.f&&(f=this.f.createScriptURL(f)),i.setAttribute("src",f),document.getElementsByTagName("head")[0].appendChild(i)})}i(f){return new Promise((l,n)=>{try{this.f&&(f=this.f.createScriptURL(f)),importScripts(f),l(this.c.pop())}catch(i){n(i)}})}async j(f){try{const l=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,s=O.URI.parse(f).fsPath,$=l.readFileSync(s).toString(),S=i.wrap($.replace(/^#!.*/,""));return new n.Script(S).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const t=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function c(o,f,l){if(T.$R){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[o]&&(o=a[o]);const n=`${o}/${f}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const P=`${l&&!v.$o?E.$2e:E.$1e}/${n}`;i=E.$4e.asBrowserUri(P).toString(!0)}const s=u.INSTANCE.load(i);return t.set(n,s),s}else return await new Promise((n,i)=>{z([o],n,i)})}e.$WC=c}),define(q[18],W([0,1,29,17,30,3,31,8]),function(z,e,T,E,v,O,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.DataUri=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=void 0;function t(l){return(0,u.$Ve)(l,!0)}e.$Xf=t;class a{constructor(n){this.a=n}compare(n,i,s=!1){return n===i?0:(0,r.$Fd)(this.getComparisonKey(n,s),this.getComparisonKey(i,s))}isEqual(n,i,s=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,s)===this.getComparisonKey(i,s)}getComparisonKey(n,i=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,i,s=!1){if(n.scheme===i.scheme){if(n.scheme===E.Schemas.file)return T.$Ke(t(n),t(i),this.a(n))&&n.query===i.query&&(s||n.fragment===i.fragment);if((0,e.$cg)(n.authority,i.authority))return T.$Ke(n.path,i.path,this.a(n),"/")&&n.query===i.query&&(s||n.fragment===i.fragment)}return!1}joinPath(n,...i){return u.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.$7f)(n)||n.authority}basename(n){return v.$0b.basename(n.path)}extname(n){return v.$0b.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===E.Schemas.file?i=u.URI.file(v.$dc(t(n))).path:(i=v.$0b.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===E.Schemas.file?i=u.URI.file(v.$$b(t(n))).path:i=v.$0b.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.$cg)(n.authority,i.authority))return;if(n.scheme===E.Schemas.file){const S=v.$cc(t(n),t(i));return O.$i?T.$Ee(S):S}let s=n.path||"/";const $=i.path||"/";if(this.a(n)){let S=0;for(const P=Math.min(s.length,$.length);S<P&&!(s.charCodeAt(S)!==$.charCodeAt(S)&&s.charAt(S).toLowerCase()!==$.charAt(S).toLowerCase());S++);s=$.substr(0,S)+s.substr(S)}return v.$0b.relative(s,$)}resolvePath(n,i){if(n.scheme===E.Schemas.file){const s=u.URI.file(v.$bc(t(n),i));return n.with({authority:s.authority,path:s.path})}return i=T.$Fe(i),n.with({path:v.$0b.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,r.$Md)(n,i)}hasTrailingPathSeparator(n,i=v.sep){if(n.scheme===E.Schemas.file){const s=t(n);return s.length>T.$Ge(s).length&&s[s.length-1]===i}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=v.sep){return(0,e.$dg)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=v.sep){let s=!1;if(n.scheme===E.Schemas.file){const $=t(n);s=$!==void 0&&$.length===T.$Ge($).length&&$[$.length-1]===i}else{i="/";const $=n.path;s=$.length===1&&$.charCodeAt($.length-1)===47}return!s&&!(0,e.$dg)(n,i)?n.with({path:n.path+"/"}):n}}e.$Yf=a,e.$Zf=new a(()=>!1),e.$1f=new a(l=>l.scheme===E.Schemas.file?!O.$k:!0),e.$2f=new a(l=>!0),e.$3f=e.$Zf.isEqual.bind(e.$Zf),e.$4f=e.$Zf.isEqualOrParent.bind(e.$Zf),e.$5f=e.$Zf.getComparisonKey.bind(e.$Zf),e.$6f=e.$Zf.basenameOrAuthority.bind(e.$Zf),e.$7f=e.$Zf.basename.bind(e.$Zf),e.$8f=e.$Zf.extname.bind(e.$Zf),e.$9f=e.$Zf.dirname.bind(e.$Zf),e.$0f=e.$Zf.joinPath.bind(e.$Zf),e.$$f=e.$Zf.normalizePath.bind(e.$Zf),e.$_f=e.$Zf.relativePath.bind(e.$Zf),e.$ag=e.$Zf.resolvePath.bind(e.$Zf),e.$bg=e.$Zf.isAbsolutePath.bind(e.$Zf),e.$cg=e.$Zf.isEqualAuthority.bind(e.$Zf),e.$dg=e.$Zf.hasTrailingPathSeparator.bind(e.$Zf),e.$eg=e.$Zf.removeTrailingPathSeparator.bind(e.$Zf),e.$fg=e.$Zf.addTrailingPathSeparator.bind(e.$Zf);function c(l,n){const i=[];for(let s=0;s<l.length;s++){const $=n(l[s]);l.some((S,P)=>P===s?!1:(0,e.$4f)($,n(S)))||i.push(l[s])}return i}e.$gg=c;var o;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function n(i){const s=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(P=>{const[M,k]=P.split(":");M&&k&&s.set(M,k)});const S=i.path.substring(0,i.path.indexOf(";"));return S&&s.set(l.META_DATA_MIME,S),s}l.parseMetaData=n})(o||(e.DataUri=o={}));function f(l,n,i){if(n){let s=l.path;return s&&s[0]!==v.$0b.sep&&(s=v.$0b.sep+s),l.with({scheme:i,authority:n,path:s})}return l.with({scheme:i})}e.$hg=f}),define(q[19],W([0,1,46,6,33,2,18,3,24]),function(z,e,T,E,v,O,r,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.$Rg=e.$Qg=e.Promises=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function a(L){return!!L&&typeof L.then=="function"}e.$ig=a;function c(L){const h=new T.$ed,y=L(h.token),A=new Promise((j,D)=>{const H=h.token.onCancellationRequested(()=>{H.dispose(),h.dispose(),D(new E.$3)});Promise.resolve(y).then(X=>{H.dispose(),h.dispose(),j(X)},X=>{H.dispose(),h.dispose(),D(X)})});return new class{cancel(){h.cancel()}then(j,D){return A.then(j,D)}catch(j){return this.then(void 0,j)}finally(j){return A.finally(j)}}}e.$jg=c;function o(L,h,y){return new Promise((A,j)=>{const D=h.onCancellationRequested(()=>{D.dispose(),A(y)});L.then(A,j).finally(()=>D.dispose())})}e.$kg=o;function f(L,h){return new Promise((y,A)=>{const j=h.onCancellationRequested(()=>{j.dispose(),A(new E.$3)});L.then(y,A).finally(()=>j.dispose())})}e.$lg=f;async function l(L){let h=-1;const y=L.map((A,j)=>A.then(D=>(h=j,D)));try{return await Promise.race(y)}finally{L.forEach((A,j)=>{j!==h&&A.cancel()})}}e.$mg=l;function n(L,h,y){let A;const j=setTimeout(()=>{A?.(void 0),y?.()},h);return Promise.race([L.finally(()=>clearTimeout(j)),new Promise(D=>A=D)])}e.$ng=n;function i(L){return new Promise((h,y)=>{const A=L();a(A)?A.then(h,y):h(A)})}e.$og=i;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(h){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=h,!this.b){const y=()=>{if(this.b=null,this.f)return;const A=this.queue(this.d);return this.d=null,A};this.b=new Promise(A=>{this.a.then(y,y).then(A)})}return new Promise((y,A)=>{this.b.then(y,A)})}return this.a=h(),new Promise((y,A)=>{this.a.then(j=>{this.a=null,y(j)},j=>{this.a=null,A(j)})})}dispose(){this.f=!0}}e.$pg=s;class ${constructor(){this.a=Promise.resolve(null)}queue(h){return this.a=this.a.then(()=>h(),()=>h())}}e.$qg=$;class S{constructor(){this.a=new Map}queue(h,y){const j=(this.a.get(h)??Promise.resolve()).catch(()=>{}).then(y).finally(()=>{this.a.get(h)===j&&this.a.delete(h)});return this.a.set(h,j),j}}e.$rg=S;const P=(L,h)=>{let y=!0;const A=setTimeout(()=>{y=!1,h()},L);return{isTriggered:()=>y,dispose:()=>{clearTimeout(A),y=!1}}},M=L=>{let h=!0;return queueMicrotask(()=>{h&&(h=!1,L())}),{isTriggered:()=>h,dispose:()=>{h=!1}}};class k{constructor(h){this.defaultDelay=h,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(h,y=this.defaultDelay){this.g=h,this.h(),this.b||(this.b=new Promise((j,D)=>{this.d=j,this.f=D}).then(()=>{if(this.b=null,this.d=null,this.g){const j=this.g;return this.g=null,j()}}));const A=()=>{this.a=null,this.d?.(null)};return this.a=y===t.$5c?M(A):P(y,A),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new E.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$sg=k;class d{constructor(h){this.a=new k(h),this.b=new s}trigger(h,y){return this.a.trigger(()=>this.b.queue(h),y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$tg=d;class m{constructor(){this.a=!1,this.b=new Promise((h,y)=>{this.d=h})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ug=m;class w extends m{constructor(h){super(),this.f=setTimeout(()=>this.open(),h)}open(){clearTimeout(this.f),super.open()}}e.$vg=w;function N(L,h){return h?new Promise((y,A)=>{const j=setTimeout(()=>{D.dispose(),y()},L),D=h.onCancellationRequested(()=>{clearTimeout(j),D.dispose(),A(new E.$3)})}):c(y=>N(L,y))}e.$wg=N;function F(L,h=0){const y=setTimeout(L,h);return(0,O.$jb)(()=>clearTimeout(y))}e.$xg=F;function g(L){const h=[];let y=0;const A=L.length;function j(){return y<A?L[y++]():null}function D(H){H!=null&&h.push(H);const X=j();return X?X.then(D):Promise.resolve(h)}return Promise.resolve(null).then(D)}e.$yg=g;function C(L,h=A=>!!A,y=null){let A=0;const j=L.length,D=()=>{if(A>=j)return Promise.resolve(y);const H=L[A++];return Promise.resolve(H()).then(Q=>h(Q)?Promise.resolve(Q):D())};return D()}e.$zg=C;function U(L,h=A=>!!A,y=null){if(L.length===0)return Promise.resolve(y);let A=L.length;const j=()=>{A=-1;for(const D of L)D.cancel?.()};return new Promise((D,H)=>{for(const X of L)X.then(Q=>{--A>=0&&h(Q)?(j(),D(Q)):A===0&&D(y)}).catch(Q=>{--A>=0&&(j(),H(Q))})})}e.$Ag=U;class B{constructor(h){this.a=0,this.d=h,this.f=[],this.b=0,this.g=new v.$8c}get onDrained(){return this.g.event}get size(){return this.a}queue(h){return this.a++,new Promise((y,A)=>{this.f.push({factory:h,c:y,e:A}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const h=this.f.shift();this.b++;const y=h.factory();y.then(h.c,h.e),y.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Bg=B;class I extends B{constructor(){super(1)}}e.$Cg=I;class b{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const h=new ee;return this.b.add(h),h.p}d(){for(const[,h]of this.a)if(h.size>0)return!1;return!0}queueFor(h,y=r.$Zf){const A=y.getComparisonKey(h);let j=this.a.get(A);return j||(j=new I,v.Event.once(j.onDrained)(()=>{j?.dispose(),this.a.delete(A),this.f()}),this.a.set(A,j)),j}f(){this.d()&&this.g()}g(){for(const h of this.b)h.complete();this.b.clear()}dispose(){for(const[,h]of this.a)h.dispose();this.a.clear(),this.g()}}e.$Dg=b;class R{constructor(h,y){this.a=-1,typeof h=="function"&&typeof y=="number"&&this.setIfNotSet(h,y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(h,y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,h()},y)}setIfNotSet(h,y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,h()},y))}}e.$Eg=R;class G{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(h,y){this.cancel(),this.a=setInterval(()=>{h()},y)}}e.$Fg=G;class V{constructor(h,y){this.b=-1,this.a=h,this.d=y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(h=this.d){this.cancel(),this.b=setTimeout(this.f,h)}get delay(){return this.d}set delay(h){this.d=h}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Gg=V;class p{constructor(h,y){y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${y}ms is not a multiple of 1000ms.`),this.a=h,this.b=y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(h=this.b){h%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(h/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Hg=p;class _ extends V{constructor(h,y){super(h,y),this.j=[]}work(h){this.j.push(h),this.isScheduled()||this.schedule()}h(){const h=this.j;this.j=[],this.a?.(h)}dispose(){this.j=[],super.dispose()}}e.$Ig=_;class K extends O.$lb{constructor(h,y){super(),this.g=h,this.h=y,this.a=[],this.b=this.B(new O.$mb),this.f=!1}get pending(){return this.a.length}work(h){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+h.length>this.g.maxBufferedWork)return!1}else if(this.pending+h.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const y of h)this.a.push(y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Jg=K,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Kg=L=>{(0,u.$A)(()=>{if(h)return;const y=Date.now()+15;L(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,y-Date.now())}}))});let h=!1;return{dispose(){h||(h=!0)}}}:e.$Kg=(L,h)=>{const y=requestIdleCallback(L,typeof h=="number"?{timeout:h}:void 0);let A=!1;return{dispose(){A||(A=!0,cancelIdleCallback(y))}}}}();class Z{constructor(h){this.d=!1,this.a=()=>{try{this.f=h()}catch(y){this.g=y}finally{this.d=!0}},this.b=(0,e.$Kg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Lg=Z;async function J(L,h,y){let A;for(let j=0;j<y;j++)try{return await L()}catch(D){A=D,await N(h)}throw A}e.$Mg=J;class se{hasPending(h){return this.a?typeof h=="number"?this.a.taskId===h:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(h,y,A){return this.a={taskId:h,cancel:()=>A?.(),promise:y},y.then(()=>this.d(h),()=>this.d(h)),y}d(h){this.a&&h===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const h=this.b;this.b=void 0,h.run().then(h.promiseResolve,h.promiseReject)}}setNext(h){if(this.b)this.b.run=h;else{let y,A;const j=new Promise((D,H)=>{y=D,A=H});this.b={run:h,promise:j,promiseResolve:y,promiseReject:A}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ng=se;class re{constructor(h,y=()=>Date.now()){this.d=h,this.f=y,this.a=0,this.b=0}increment(){const h=this.f();return h-this.a>this.d&&(this.a=h,this.b=0),this.b++,this.b}}e.$Og=re;var x;(function(L){L[L.Resolved=0]="Resolved",L[L.Rejected=1]="Rejected"})(x||(x={}));class ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((h,y)=>{this.a=h,this.b=y})}complete(h){return new Promise(y=>{this.a(h),this.d={outcome:0,value:h},y()})}error(h){return new Promise(y=>{this.b(h),this.d={outcome:1,value:h},y()})}cancel(){return this.error(new E.$3)}}e.$Pg=ee;var te;(function(L){async function h(A){let j;const D=await Promise.all(A.map(H=>H.then(X=>X,X=>{j||(j=X)})));if(typeof j<"u")throw j;return D}L.settled=h;function y(A){return new Promise(async(j,D)=>{try{await A(j,D)}catch(H){D(H)}})}L.withAsyncBody=y})(te||(e.Promises=te={}));var ne;(function(L){L[L.Initial=0]="Initial",L[L.DoneOK=1]="DoneOK",L[L.DoneError=2]="DoneError"})(ne||(ne={}));class Y{static fromArray(h){return new Y(y=>{y.emitMany(h)})}static fromPromise(h){return new Y(async y=>{y.emitMany(await h)})}static fromPromises(h){return new Y(async y=>{await Promise.all(h.map(async A=>y.emitOne(await A)))})}static merge(h){return new Y(async y=>{await Promise.all(h.map(async A=>{for await(const j of A)y.emitOne(j)}))})}static{this.EMPTY=Y.fromArray([])}constructor(h){this.a=0,this.b=[],this.d=null,this.f=new v.$8c,queueMicrotask(async()=>{const y={emitOne:A=>this.g(A),emitMany:A=>this.h(A),reject:A=>this.k(A)};try{await Promise.resolve(h(y)),this.j()}catch(A){this.k(A)}finally{y.emitOne=void 0,y.emitMany=void 0,y.reject=void 0}})}[Symbol.asyncIterator](){let h=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(h<this.b.length)return{done:!1,value:this.b[h++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(h,y){return new Y(async A=>{for await(const j of h)A.emitOne(y(j))})}map(h){return Y.map(this,h)}static filter(h,y){return new Y(async A=>{for await(const j of h)y(j)&&A.emitOne(j)})}filter(h){return Y.filter(this,h)}static coalesce(h){return Y.filter(h,y=>!!y)}coalesce(){return Y.coalesce(this)}static async toPromise(h){const y=[];for await(const A of h)y.push(A);return y}toPromise(){return Y.toPromise(this)}g(h){this.a===0&&(this.b.push(h),this.f.fire())}h(h){this.a===0&&(this.b=this.b.concat(h),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(h){this.a===0&&(this.a=2,this.d=h,this.f.fire())}}e.$Qg=Y;class ie extends Y{constructor(h,y){super(y),this.l=h}cancel(){this.l.cancel()}}e.$Rg=ie;function ae(L){const h=new T.$ed,y=L(h.token);return new ie(h,async A=>{const j=h.token.onCancellationRequested(()=>{j.dispose(),h.dispose(),A.reject(new E.$3)});try{for await(const D of y){if(h.token.isCancellationRequested)return;A.emitOne(D)}j.dispose(),h.dispose()}catch(D){j.dispose(),h.dispose(),A.reject(D)}})}e.$Sg=ae}),define(q[20],W([0,1,34]),function(z,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gC=e.$fC=e.$eC=void 0,e.$eC=new class{clone(){return this}equals(O){return this===O}};function E(O,r){return new T.$ns([new T.$ms(0,"",O)],r)}e.$fC=E;function v(O,r){const u=new Uint32Array(2);return u[0]=0,u[1]=(O<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new T.$os(u,r===null?e.$eC:r)}e.$gC=v}),define(q[35],W([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(z,e,T,E,v,O,r,u,t,a,c,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oC=e.$nC=e.$mC=e.$lC=e.$kC=e.$jC=void 0;var l;(function(k){k[k.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(l||(l={}));class n{constructor(d,m){this.tokenizationSupport=m,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(d)}getStartState(d){return this.store.getStartState(d,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$jC=n;class i extends n{constructor(d,m,w,N){super(d,m),this._textModel=w,this._languageIdCodec=N}updateTokensUntilLine(d,m){const w=this._textModel.getLanguageId();for(;;){const N=this.getFirstInvalidLine();if(!N||N.lineNumber>m)break;const F=this._textModel.getLineContent(N.lineNumber),g=P(this._languageIdCodec,w,this.tokenizationSupport,F,!0,N.startState);d.add(N.lineNumber,g.tokens),this.store.setEndState(N.lineNumber,g.endState)}}getTokenTypeIfInsertingCharacter(d,m){const w=this.getStartState(d.lineNumber);if(!w)return 0;const N=this._textModel.getLanguageId(),F=this._textModel.getLineContent(d.lineNumber),g=F.substring(0,d.column-1)+m+F.substring(d.column-1),C=P(this._languageIdCodec,N,this.tokenizationSupport,g,!0,w),U=new f.$gs(C.tokens,g,this._languageIdCodec);if(U.getCount()===0)return 0;const B=U.findTokenIndexAtOffset(d.column-1);return U.getStandardTokenType(B)}tokenizeLineWithEdit(d,m,w){const N=d.lineNumber,F=d.column,g=this.getStartState(N);if(!g)return null;const C=this._textModel.getLineContent(N),U=C.substring(0,F-1)+w+C.substring(F-1+m),B=this._textModel.getLanguageIdAtPosition(N,0),I=P(this._languageIdCodec,B,this.tokenizationSupport,U,!0,g);return new f.$gs(I.tokens,U,this._languageIdCodec)}isCheapToTokenize(d){const m=this.store.getFirstInvalidEndStateLineNumberOrMax();return d<m||d===m&&this._textModel.getLineLength(d)<2048}tokenizeHeuristically(d,m,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(d,w),{heuristicTokens:!1};let N=this.b(m);const F=this._textModel.getLanguageId();for(let g=m;g<=w;g++){const C=this._textModel.getLineContent(g),U=P(this._languageIdCodec,F,this.tokenizationSupport,C,!0,N);d.add(g,U.tokens),N=U.endState}return{heuristicTokens:!0}}b(d){let m=this._textModel.getLineFirstNonWhitespaceColumn(d);const w=[];let N=null;for(let C=d-1;m>1&&C>=1;C--){const U=this._textModel.getLineFirstNonWhitespaceColumn(C);if(U!==0&&U<m&&(w.push(this._textModel.getLineContent(C)),m=U,N=this.getStartState(C),N))break}N||(N=this.tokenizationSupport.getInitialState()),w.reverse();const F=this._textModel.getLanguageId();let g=N;for(const C of w)g=P(this._languageIdCodec,F,this.tokenizationSupport,C,!1,g).endState;return g}}e.$kC=i;class s{constructor(d){this.d=d,this.a=new $,this.b=new S,this.b.addRange(new t.$dC(1,d+1))}getEndState(d){return this.a.getEndState(d)}setEndState(d,m){if(!m)throw new E.$bb("Cannot set null/undefined state");this.b.delete(d);const w=this.a.setEndState(d,m);return w&&d<this.d&&this.b.addRange(new t.$dC(d+1,d+2)),w}acceptChange(d,m){this.d+=m-d.length,this.a.acceptChange(d,m),this.b.addRangeAndResize(new t.$dC(d.startLineNumber,d.endLineNumberExclusive),m)}acceptChanges(d){for(const m of d){const[w]=(0,r.$fs)(m.text);this.acceptChange(new u.$Pr(m.range.startLineNumber,m.range.endLineNumber+1),w+1)}}invalidateEndStateRange(d){this.b.addRange(new t.$dC(d.startLineNumber,d.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(d,m){return d===1?m:this.getEndState(d-1)}getFirstInvalidLine(d){const m=this.getFirstInvalidEndStateLineNumber();if(m===null)return null;const w=this.getStartState(m,d);if(!w)throw new E.$bb("Start state must be defined");return{lineNumber:m,startState:w}}}e.$lC=s;class ${constructor(){this.a=new c.$hC(null)}getEndState(d){return this.a.get(d)}setEndState(d,m){const w=this.a.get(d);return w&&w.equals(m)?!1:(this.a.set(d,m),!0)}acceptChange(d,m){let w=d.length;m>0&&w>0&&(w--,m--),this.a.replace(d.startLineNumber,w,m)}acceptChanges(d){for(const m of d){const[w]=(0,r.$fs)(m.text);this.acceptChange(new u.$Pr(m.range.startLineNumber,m.range.endLineNumber+1),w+1)}}}e.$mC=$;class S{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const d=this.a[0];return d.start+1===d.endExclusive?this.a.shift():this.a[0]=new t.$dC(d.start+1,d.endExclusive),d.start}delete(d){const m=this.a.findIndex(w=>w.contains(d));if(m!==-1){const w=this.a[m];w.start===d?w.endExclusive===d+1?this.a.splice(m,1):this.a[m]=new t.$dC(d+1,w.endExclusive):w.endExclusive===d+1?this.a[m]=new t.$dC(w.start,d):this.a.splice(m,1,new t.$dC(w.start,d),new t.$dC(d+1,w.endExclusive))}}addRange(d){t.$dC.addRange(d,this.a)}addRangeAndResize(d,m){let w=0;for(;!(w>=this.a.length||d.start<=this.a[w].endExclusive);)w++;let N=w;for(;!(N>=this.a.length||d.endExclusive<this.a[N].start);)N++;const F=m-d.length;for(let g=N;g<this.a.length;g++)this.a[g]=this.a[g].delta(F);if(w===N){const g=new t.$dC(d.start,d.start+m);g.isEmpty||this.a.splice(w,0,g)}else{const g=Math.min(d.start,this.a[w].start),C=Math.max(d.endExclusive,this.a[N-1].endExclusive),U=new t.$dC(g,C+F);U.isEmpty?this.a.splice(w,N-w):this.a.splice(w,N-w,U)}}toString(){return this.a.map(d=>d.toString()).join(" + ")}}e.$nC=S;function P(k,d,m,w,N,F){let g=null;if(m)try{g=m.tokenizeEncoded(w,N,F.clone())}catch(C){(0,E.$Y)(C)}return g||(g=(0,a.$gC)(k.encodeLanguageId(d),F)),f.$gs.convertToEndOffset(g.tokens,w.length),g}class M{constructor(d,m){this.b=d,this.d=m,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,T.$Kg)(d=>{this.f=!1,this.h(d)}))}h(d){const m=Date.now()+d.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<m?(0,v.$A)(w):this.g())};w()}j(){const d=this.b._textModel.getLineCount(),m=new o.$iC,w=O.$4c.create(!1);do if(w.elapsed()>1||this.l(m)>=d)break;while(this.k());this.d.setTokens(m.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(d){const m=this.b?.getFirstInvalidLine();return m?(this.b.updateTokensUntilLine(d,m.lineNumber),m.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(d,m){this.b.store.invalidateEndStateRange(new u.$Pr(d,m))}}e.$oC=M}),define(q[37],W([0,1,33,2,36,14,34]),function(z,e,T,E,v,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_yb=void 0;class u extends E.$lb{constructor(a,c,o,f,l,n,i){super(),this.c=a,this.f=c,this.g=o,this.h=f,this.j=l,this.k=n,this.l=i,this.a=[],this.b=this.B(new T.$8c),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(a,c,o){throw new Error("Not supported!")}createBackgroundTokenizer(a,c){if(this.h)return this.h(a,c)}tokenizeEncoded(a,c,o){const f=Math.random()*1e4<1,l=this.l||f,n=l?new v.$4c(!0):void 0,i=this.c.tokenizeLine2(a,o,500);if(l){const $=n.elapsed();(f||$>32)&&this.k($,a.length,f)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${a.substring(0,100)}`),new r.$os(i.tokens,o);if(this.g){const $=this.a,S=i.tokens;for(let P=0,M=S.length>>>1;P<M;P++){const k=S[(P<<1)+1],d=O.$ds.getLanguageId(k);$[d]||($[d]=!0,this.b.fire(d))}}let s;return o.equals(i.ruleStack)?s=o:s=i.ruleStack,new r.$os(i.tokens,s)}}e.$_yb=u}),define(q[38],W([0,1,20,2,11]),function(z,e,T,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$azb=void 0;class O extends E.$lb{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(u,t,a){super(),this.a=u,this.b=t,this.c=a,this.B((0,v.keepAlive)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(u,t,a){throw new Error("Not supported!")}tokenizeEncoded(u,t,a){return u.length>=this.c.get()?(0,T.$gC)(this.a,a):this.b.tokenizeEncoded(u,t,a)}createBackgroundTokenizer(u,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(u,t)}}e.$azb=O}),define(q[39],W([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(z,e,T,E,v,O,r,u,t,a,c,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fzb=void 0;class l extends u.$wu{constructor(s,$,S,P,M,k,d,m){super(s,$,S,P),this.s=M,this.t=k,this.u=d,this.a=null,this.b=!1,this.c=(0,v.observableValue)("_maxTokenizationLineLength",-1),this.q=new E.$Gg(()=>this.w(),10),this.c.set(m,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,$){this.t=s,this.u=$,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,$){this.a&&(this.a.store.invalidateEndStateRange(new r.$Pr(s,$)),this.q.schedule())}async v(){this.a=null;const s=this.t,$=this.u,S=await this.s.getOrCreateGrammar(s,$);if(!(this.b||s!==this.t||$!==this.u||!S)){if(S.grammar){const P=new f.$azb(this.u,new o.$_yb(S.grammar,S.initialState,!1,void 0,()=>!1,(M,k,d)=>{this.s.reportTokenizationTime(M,s,S.sourceExtensionId,k,d)},!1),this.c);this.a=new t.$jC(this.f.length,P)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:$}=await(0,T.$WC)("vscode-textmate","release/main.js");this.m=$}const s=new Date().getTime();for(;;){let $=0;const S=new a.$iC,P=new n;for(;;){const d=this.a.getFirstInvalidLine();if(d===null||$>200)break;$++;const m=this.f[d.lineNumber-1],w=this.a.tokenizationSupport.tokenizeEncoded(m,!0,d.startState);if(this.a.store.setEndState(d.lineNumber,w.endState)){const F=this.m(d.startState,w.endState);P.setState(d.lineNumber,F)}else P.setState(d.lineNumber,null);if(c.$gs.convertToEndOffset(w.tokens,m.length),S.add(d.lineNumber,w.tokens),new Date().getTime()-s>20)break}if($===0)break;const M=P.getStateDeltas();if(this.s.setTokensAndStates(this.h,S.serialize(),M),new Date().getTime()-s>20){(0,O.$A)(()=>this.w());return}}}}e.$fzb=l;class n{constructor(){this.a=-1,this.b=[]}setState(s,$){s===this.a+1?this.b[this.b.length-1].stateDeltas.push($):this.b.push({startLineNumber:s,stateDeltas:[$]}),this.a=s}getStateDeltas(){return this.b}}}),define(q[40],W([0,1,18]),function(z,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$czb=void 0;class E{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(O){if(this.a[O.scopeName]){const r=this.a[O.scopeName];T.$3f(r.location,O.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${O.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${O.location.toString()}`)}this.a[O.scopeName]=O}getGrammarDefinition(O){return this.a[O]||null}}e.$czb=E}),define(q[41],W([0,1,2,40]),function(z,e,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ezb=e.$dzb=void 0,e.$dzb="No TM Grammar registered for this language.";class v extends T.$lb{constructor(r,u,t,a){super(),this.a=r,this.b=t.INITIAL,this.c=new E.$czb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:a,loadGrammar:async c=>{const o=this.c.getGrammarDefinition(c);if(!o)return this.a.logTrace(`No grammar found for scope ${c}`),null;const f=o.location;try{const l=await this.a.readFile(f);return t.parseRawGrammar(l,f.path)}catch(l){return this.a.logError(`Unable to load and parse grammar for scope ${c} from ${f}`,l),null}},getInjections:c=>{const o=c.split(".");let f=[];for(let l=1;l<=o.length;l++){const n=o.slice(0,l).join(".");f=[...f,...this.f[n]||[]]}return f}}));for(const c of u){if(this.c.register(c),c.injectTo){for(const o of c.injectTo){let f=this.f[o];f||(this.f[o]=f=[]),f.push(c.scopeName)}if(c.embeddedLanguages)for(const o of c.injectTo){let f=this.g[o];f||(this.g[o]=f=[]),f.push(c.embeddedLanguages)}}c.language&&this.h.set(c.language,c.scopeName)}}has(r){return this.h.has(r)}setTheme(r,u){this.j.setTheme(r,u)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,u){const t=this.h.get(r);if(typeof t!="string")throw new Error(e.$dzb);const a=this.c.getGrammarDefinition(t);if(!a)throw new Error(e.$dzb);const c=a.embeddedLanguages;if(this.g[t]){const l=this.g[t];for(const n of l)for(const i of Object.keys(n))c[i]=n[i]}const o=Object.keys(c).length>0;let f;try{f=await this.j.loadGrammarWithConfiguration(t,u,{embeddedLanguages:c,tokenTypes:a.tokenTypes,balancedBracketSelectors:a.balancedBracketSelectors,unbalancedBracketSelectors:a.unbalancedBracketSelectors})}catch(l){throw l.message&&l.message.startsWith("No grammar provided for")?new Error(e.$dzb):l}return{languageId:r,grammar:f,initialState:this.b,containsEmbeddedLanguages:o,sourceExtensionId:a.sourceExtensionId}}}e.$ezb=v}),define(q[49],W([0,1,8,41,39]),function(z,e,T,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function O(u,t){return new r(u,t)}e.create=O;class r{constructor(t,a){this.f=a,this.b=new Map,this.c=[],this.a=t.host;const c=a.grammarDefinitions.map(o=>({location:T.URI.revive(o.location),language:o.language,scopeName:o.scopeName,embeddedLanguages:o.embeddedLanguages,tokenTypes:o.tokenTypes,injectTo:o.injectTo,balancedBracketSelectors:o.balancedBracketSelectors,unbalancedBracketSelectors:o.unbalancedBracketSelectors,sourceExtensionId:o.sourceExtensionId}));this.d=this.g(c)}async g(t){const a=this.f.textmateMainUri,c=await new Promise((i,s)=>{z([a],i,s)}),o=await new Promise((i,s)=>{z([this.f.onigurumaMainUri],i,s)}),l=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await o.loadWASM(l);const n=Promise.resolve({createOnigScanner:i=>o.createOnigScanner(i),createOnigString:i=>o.createOnigString(i)});return new E.$ezb({logTrace:i=>{},logError:(i,s)=>console.error(i,s),readFile:i=>this.a.readFile(i)},t,c,n)}acceptNewModel(t){const a=T.URI.revive(t.uri),c=this;this.b.set(t.controllerId,new v.$fzb(a,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(o,f){const l=await c.d;return l?(c.c[f]||(c.c[f]=l.createGrammar(o,f)),c.c[f]):Promise.resolve(null)},setTokensAndStates(o,f,l){c.a.setTokensAndStates(t.controllerId,o,f,l)},reportTokenizationTime(o,f,l,n,i){c.a.reportTokenizationTime(o,f,l,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,a){this.b.get(t).onEvents(a)}retokenize(t,a,c){this.b.get(t).retokenize(a,c)}acceptModelLanguageChanged(t,a,c){this.b.get(t).onLanguageId(a,c)}acceptRemovedModel(t){const a=this.b.get(t);a&&(a.dispose(),this.b.delete(t))}async acceptTheme(t,a){(await this.d)?.setTheme(t,a)}acceptMaxTokenizationLineLength(t,a){this.b.get(t).acceptMaxTokenizationLineLength(a)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/93d3731736cc6fefbd63810d5fb2d57bedc84ca0/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
